cross[a_,b_] := { a[[2]]b[[3]]-a[[3]]b[[2]],-b[[3]]a[[1]]+b[[1]]a[[3]],a[[1]]b[[2]]-a[[2]]b[[1]]};
(*Extracts the ith answer from ans*) 
	AA[ans_,i_] := ans[[1,i,2]];
(*Unit vectors*)
	i = {1,0,0};
	j = {0,1,0};
	k = {0,0,1};

(*Position, velocity and acceleration.*)
     Pos[a_] := a[px] i + a[py] j + a[pz] k;
     Vel[a_] := a[vx] i + a[vy] j + a[vz] k;
     Acc[a_] := a[ax] i + a[ay] j + a[az] k;

(*Determine a vector given radius and angle (in radians) from +i.*)
     RTheta[r_,radians_] := r (Cos[radians] i + Sin[radians] j);

(*Angular velocities and accelerations.*)
     AngVel[a_] := a[omx] i + a[omy] j + a[omz] k
     AngAcc[a_] := a[alx] i + a[aly] j + a[alz] k
     SimpAngVel[a_] := a[omz] k;
     SimpAngAcc[a_] := a[alz] k;

(*General kinematic equations between two points on a rigid body.*)
     RigidVel[left_,right_,body_] := Vel[left] == Vel[right] +cross[AngVel[body],Pos[left]-Pos[right]];
     RigidAcc[left_,right_,body_] := Acc[left] == Acc[right] +cross[AngAcc[body],Pos[left]-Pos[right]] +cross[AngVel[body],cross[AngVel[body],Pos[left]-Pos[right]]];

     Combine[list1_,list2_] := Table[{list1[[i]],list2[[i]]},{i,1,Length[list1]}];

     mag[a_] := Sqrt[a . a]