(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     33939,        743]
NotebookOptionsPosition[     32587,        691]
NotebookOutlinePosition[     33143,        713]
CellTagsIndexPosition[     33100,        710]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
<<\"C:\\\\Users\\\\nathanael\\\\Documents\\\\Barhorst \
Work\\\\Old\\\\Notebooks\\\\insidematerial\\\\genkin.h\"\
\>", "Input",
 CellChangeTimes->{{3.5181718571316*^9, 3.5181718848596*^9}}],

Cell["\<\

vaydoteqn = vay'[t] == -Tax/(m r) - L^2 Tax/(inertia r);

thetaddoteqn = thetadot'[t] == (Tax L)/(inertia r);

fx[t] = m (2 vay[t] thetadot[t] + L thetadot[t]^2);

xdoteqn = x'[t] == - (vay[t]+ L thetadot[t]) Sin[theta[t]];

ydoteqn = y'[t] == (vay[t] + L thetadot[t]) Cos[theta[t]];

thetaeqn = theta'[t] == thetadot[t];
\
\>", "Input"],

Cell[CellGroupData[{

Cell["\<\

dsolution = DSolve[{

\tvaydoteqn,vay[0]==vaynot,

\tthetaddoteqn,thetadot[0]==thetadotnot,

\tthetaeqn,theta[0]==thetanot

},{vay[t],thetadot[t],theta[t]},t][[1]]
\
\>", "Input",
 CellChangeTimes->{{3.5181719309806004`*^9, 3.5181719366496*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"vay", "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "inertia"}], " ", "t", " ", "Tax"}], "-", 
      RowBox[{
       SuperscriptBox["L", "2"], " ", "m", " ", "t", " ", "Tax"}], "+", 
      RowBox[{"inertia", " ", "m", " ", "r", " ", "vaynot"}]}], 
     RowBox[{"inertia", " ", "m", " ", "r"}]]}], ",", 
   RowBox[{
    RowBox[{"theta", "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"L", " ", 
       SuperscriptBox["t", "2"], " ", "Tax"}], "+", 
      RowBox[{"2", " ", "inertia", " ", "r", " ", "t", " ", "thetadotnot"}], 
      "+", 
      RowBox[{"2", " ", "inertia", " ", "r", " ", "thetanot"}]}], 
     RowBox[{"2", " ", "inertia", " ", "r"}]]}], ",", 
   RowBox[{
    RowBox[{"thetadot", "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"L", " ", "t", " ", "Tax"}], "+", 
      RowBox[{"inertia", " ", "r", " ", "thetadotnot"}]}], 
     RowBox[{"inertia", " ", "r"}]]}]}], "}"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181718910136003`*^9, 3.5181723470126*^9}]
}, Open  ]],

Cell["\<\

inertia = 1/12 m L^2;

Tax = torque m r;
\
\>", "Input"],

Cell["\<\

thetanot = 0;

thetadotnot = 0;

vaynot = 0;

torque = 1;

L = 1;
\
\>", "Input"],

Cell[CellGroupData[{

Cell["\<\

ndsol = NDSolve[{

\txdoteqn/.dsolution,x[0]==0,

\tydoteqn/.dsolution,y[0]==0

},{x[t],y[t]},{t,0,1}]
\
\>", "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "1.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"y", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "1.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}]}], "}"}], "}"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181718911496*^9, 3.5181723501966*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Plot[x[t]/.ndsol[[1]],{t,0,1}]
\
\>", "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3k8VO8XxyXZkjYUkcqSLbQg5H7Knq1sJSSyJGQn2ixF9oQiFNnKEpKt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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {0., 0.16666666324071736`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181718912176*^9, 3.5181723519936*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Plot[y[t]/.ndsol[[1]],{t,0,2}]
\
\>", "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3k41N8XFiq7khQpa1JJvmVLOLIL2felSCkqeyoVCS22FoRI2ZKdmcGM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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 2}, {-0.10210579988709984`, 7.41272989716348}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181718913076*^9, 3.5181723535436*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"temp", "[", "z", "]"}], "=", 
  RowBox[{
   RowBox[{"theta", "[", "t", "]"}], "/.", "dsolution"}]}]], "Input",
 CellChangeTimes->{{3.5181723753255997`*^9, 3.5181724830066*^9}}],

Cell[BoxData[
 RowBox[{"6", " ", 
  SuperscriptBox["t", "2"]}]], "Output",
 CellChangeTimes->{{3.5181723931576*^9, 3.5181724259296*^9}, {
  3.5181724562876*^9, 3.5181724834936*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Plot[((temp[z])/ 2 Pi),{t,0,2}]
\
\>", "Input",
 CellChangeTimes->{{3.5181720088756*^9, 3.5181720144496*^9}, {
  3.5181720538016*^9, 3.5181720562595997`*^9}, {3.5181720894706*^9, 
  3.5181722715936003`*^9}, {3.5181723082026*^9, 3.5181723153876*^9}, {
  3.5181723982186003`*^9, 3.5181724747525997`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVzGk8lXkDh3GiqESkmbEnHC06KVsJv383IWmxJSnJWkpZ2iSVxtFmqyQi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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 2}, {0., 37.69911030433828}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{
  3.5181718918966*^9, {3.5181719875706*^9, 3.5181720156076*^9}, 
   3.5181720571376*^9, {3.5181720956356*^9, 3.5181722724776*^9}, 
   3.5181723162306004`*^9, 3.5181723559216003`*^9, {3.5181724025446*^9, 
   3.5181724847995996`*^9}}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 199, 4, 31, "Input"],
Cell[759, 26, 348, 14, 235, "Input"],
Cell[CellGroupData[{
Cell[1132, 44, 256, 13, 201, "Input"],
Cell[1391, 59, 1148, 31, 51, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[2554, 93, 67, 6, 99, "Input"],
Cell[2624, 101, 92, 12, 201, "Input"],
Cell[CellGroupData[{
Cell[2741, 117, 129, 10, 167, "Input"],
Cell[2873, 129, 864, 29, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[3774, 163, 57, 4, 65, "Input"],
Cell[3834, 169, 11181, 190, 240, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[15052, 364, 57, 4, 65, "Input"],
Cell[15112, 370, 12717, 215, 245, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[27866, 590, 211, 5, 31, "Input"],
Cell[28080, 597, 181, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28298, 606, 313, 8, 65, "Input"],
Cell[28614, 616, 3957, 72, 245, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
