(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     57571,       1138]
NotebookOptionsPosition[     56357,       1092]
NotebookOutlinePosition[     56917,       1114]
CellTagsIndexPosition[     56874,       1111]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
<<\"C:\\\\Users\\\\nathanael\\\\Documents\\\\Barhorst \
Work\\\\New\\\\Notebooks\\\\math\\\\Next\\\\genkin.h\"\
\>", "Input",
 CellChangeTimes->{{3.5181733976526003`*^9, 3.5181734090436*^9}},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vaydoteqn", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"vay", "'"}], "[", "t", "]"}], " ", "==", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "Tax"}], "/", 
      RowBox[{"(", 
       RowBox[{"m", " ", "r"}], ")"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{"L", "^", "2"}], " ", 
      RowBox[{"Tax", "/", 
       RowBox[{"(", 
        RowBox[{"inertia", " ", "r"}], ")"}]}]}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"thetaddoteqn", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"thetadot", "'"}], "[", "t", "]"}], " ", "==", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"Tax", " ", "L"}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"inertia", " ", "r"}], ")"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"fx", "[", "t", "]"}], " ", "=", " ", 
   RowBox[{"m", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"vay", "[", "t", "]"}], " ", 
       RowBox[{"thetadot", "[", "t", "]"}]}], " ", "+", " ", 
      RowBox[{"L", " ", 
       RowBox[{
        RowBox[{"thetadot", "[", "t", "]"}], "^", "2"}]}]}], ")"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"xdoteqn", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "'"}], "[", "t", "]"}], " ", "==", " ", 
    RowBox[{
     RowBox[{"-", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"vay", "[", "t", "]"}], "+", " ", 
        RowBox[{"L", " ", 
         RowBox[{"thetadot", "[", "t", "]"}]}]}], ")"}]}], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"theta", "[", "t", "]"}], "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ydoteqn", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"y", "'"}], "[", "t", "]"}], " ", "==", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"vay", "[", "t", "]"}], " ", "+", " ", 
       RowBox[{"L", " ", 
        RowBox[{"thetadot", "[", "t", "]"}]}]}], ")"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"theta", "[", "t", "]"}], "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"thetaeqn", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"theta", "'"}], "[", "t", "]"}], " ", "==", " ", 
    RowBox[{"thetadot", "[", "t", "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181734195806*^9, 3.5181734195816*^9}},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inertia", " ", "=", " ", 
   RowBox[{
    RowBox[{"1", "/", "12"}], " ", "m", " ", 
    RowBox[{"L", "^", "2"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Tax", " ", "=", " ", 
   RowBox[{"torque", " ", "m", " ", "r"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181734355696*^9, 3.5181734355706*^9}},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"thetanot", " ", "=", " ", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"thetadotnot", " ", "=", " ", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"vaynot", " ", "=", " ", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"torque", " ", "=", " ", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"L", " ", "=", " ", "1"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181734380146*^9, 3.5181734380165997`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dsolution", " ", "=", " ", 
  RowBox[{
   RowBox[{"DSolve", "[", 
    RowBox[{
     RowBox[{"{", "\n", "\t", 
      RowBox[{"vaydoteqn", ",", 
       RowBox[{
        RowBox[{"vay", "[", "0", "]"}], "==", "vaynot"}], ",", "\n", "\t", 
       "thetaddoteqn", ",", 
       RowBox[{
        RowBox[{"thetadot", "[", "0", "]"}], "==", "thetadotnot"}], ",", "\n",
        "\t", "thetaeqn", ",", 
       RowBox[{
        RowBox[{"theta", "[", "0", "]"}], "==", "thetanot"}]}], "\n", "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vay", "[", "t", "]"}], ",", 
       RowBox[{"thetadot", "[", "t", "]"}], ",", 
       RowBox[{"theta", "[", "t", "]"}]}], "}"}], ",", "t"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5181734256516*^9, 3.5181734312136*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"vay", "[", "t", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "13"}], " ", "t"}]}], ",", 
   RowBox[{
    RowBox[{"theta", "[", "t", "]"}], "\[Rule]", 
    RowBox[{"6", " ", 
     SuperscriptBox["t", "2"]}]}], ",", 
   RowBox[{
    RowBox[{"thetadot", "[", "t", "]"}], "\[Rule]", 
    RowBox[{"12", " ", "t"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.5181734564486*^9, 3.5181735576196003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ndsol", " ", "=", " ", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", "\n", "\t", 
     RowBox[{
      RowBox[{"xdoteqn", "/.", "dsolution"}], ",", 
      RowBox[{
       RowBox[{"x", "[", "0", "]"}], "==", "0"}], ",", "\n", "\t", 
      RowBox[{"ydoteqn", "/.", "dsolution"}], ",", 
      RowBox[{
       RowBox[{"y", "[", "0", "]"}], "==", "0"}]}], "\n", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], ",", 
      RowBox[{"y", "[", "t", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5181734397716*^9, 3.5181734397726*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"y", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.5181735504016*^9, 3.5181735634916*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "t", "]"}], "/.", 
    RowBox[{"ndsol", "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181734436576*^9, 3.5181734436596003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUmXk41F8bxlV+WdqFJBUtQkiytDC3UBEpouwkKRIRFZWdEqKs2bImVJZs
2ZkZikKEslWyZxm7YYz3+/41132d7znnOc+5zznP5xohC3uda6tZWFiOsLKw
/P/37LWhb5XD10gsLJWkzfx3T7Cq8N/+tV0Veqziv+TuaiseeRUV+2G7LpRW
pDkrFaMV+wT2ed4TNoXH+ttm17lqFTW+tufGbbdESvAJ2yKxX4r7Anemruy2
xtYB3h2yquOKjLNXI68I2+H34QCL5Fq64ojPd8qVCAfIJLbtdf24lnTZcr7s
xXYn6PDU/XpSz0WiqPAXkmPv4hU/lDXLBUhSexWzZ3a7QH8h0mtb2z5S7Grz
9P3JD2DY/k9jYY0kib3XK+mSsBt4j16N379OllT8u/krWdcD1/+Eij3xUyDd
vmB51jjCE7Sg+qqfs8ok4crZmpl2L/Dxx/36HqtO6j70WCVouw/ypkq9E8S0
SWGv+Cr3G/mibz5bIDj4EunspgyF8lg/xMZmHJdbNiaxuJ/4eKnnMWxp38fr
jlmQCsa/yE7s9oeORfvqyy5WJFtT09zHV56CkWxsAMWbpD0NE5KCyQHIN5Sm
VynfJv1Q9Mws6guEVv28FZfoHdKzd1wi2sLPUJfMnA3Rvks6tTMlZfh6MDar
qeullbqQ3GqiN1fphsDR68nUnphHJAO3v1pBsyGQXB1hpcLmSZKREw8yiHiO
kYGXjtYB3qRN4071++VfwGbifNwaQz/SSGoZx1T7C+TuKBrYcsefRDVZq1Z+
PxQVN5u1wtoCSQk85/2ebg/DZ/tGm1PKIaQHXyMpl4rDEFHyrMyV9IJ0yff3
6r1G4dA4Mesifz2MdFhR9OTEUjhK5vjJn79EkNbPOriXxEaAa+9WiS/2L0mD
b4vLHitGQrOyu5B0IZZUbbmGcbEnEjcbXK8K2b0i3f8edn9090tk7op4tuNw
MuliYHdBUeVLcJ1P4JEVSCVJqgrP+lyJhuTRuvXhB9JIHAy7I9qrY5AWfzE0
yDSd1Peh0GFncgyWTWP9r5AzSRU3WbKHVWIh7ZIysfnSe1L0XvXx/L5YJM3l
954LyCZph3bYaAnHw9dB4HdiyAeSuMbedP7aeBhLv3LMls0nsa+xHRy4/gp+
vO/YPkwWkMw+MnMqdBMQ6Fl+/nBhMUmTZ++3/akJMN/W7etCKSUddzhDC5hN
wOJlkgIHrZzEIxoiqR+RCK9AafKflirSat+8c+UDiXhlrLDvxg4yifb7h+0+
+SSMJ+bfmXGikOqjhDJp7UnozFRdv+pKLalo5lTdJZFkaHnyXhme+UR6fcFm
uPR+MuQd2XpvxdWRPNk/HPDfngLSRe/93yQbSGJnnj/JvZ2CL1G68alCTaRm
X/vhztoUdHw2ag0+9o20b414puTdVKTXho3sCGshfTnJuV7/ayquukt0hrd/
Jzl7DNl67nsNtvPsArfE2kg1yymS35tfQ9Ds3TYVlp8kewXv4GXRNNjtCJl5
6tNB4ntwhSbsmYYwc6s6G/4ukvXCzlyXQ28woq8eNf7wF2n9dITs7sB0KPbL
Ct4N/0vKP+wcofY3HUPqWaHTKX0k09sX5x2OZ+DCSBbvjYp+UtbYpo+UoQyw
nvNVsOYdIumLj28fRyZOXQiaeHxxmMRy84vrtshMFHPWV9fEjpB0hp4o2Jx6
iyMHtEY+6Y6RloSvx4XGvsXeuhqtXZRxUsq1U8zS6bfgaRmjGwnSSLO9qyo3
Jb2D8Grbtns5k6SobleVfOZ7nDp/7Vma2CzppIBBSo9eFv5wND0UEJgjjRjK
/8f+Lgv3rp76EcEzT9o16nL1nUQ27O5vzNYRopMc1w1vVTbIBunuyZcTRxZJ
NWL6lDafbIxEKn5WO79EsreW28/SlY3i+vPtAwnLJMqT1NYwthxoC57a87id
SeJ7w+0neiQHjRv/nP66jgWVA1MDOk9zkF7P3nTDcBW4LLPepB7NRdERxwfn
ZFhh5b3L4LhlLi4p7/Jbs8CKkqQgjsbgXOI8lW1XqPoPln9u2iwM5OJB5PHO
JEs25JuKiGuEf4BmSF+12hQnON0iu35VfsDXub7NPP3rYBq3Nshp9ANUB18N
oGc91nb1jcWp5MF5+o3I7r6N0DdIzKJN5qHzRssur4QtmOjU5Uziz4f4a9dv
U2Jc8DNlv3ZRJR8Z4RORgUVc+HDVnr8gLB+Gzm4Bdt1bsdFO0feBfAFG4ltO
6JznRSqN9kvcvADT3wNKHGZ4oXAn5XjPkwL4P/dPFYzbBpv762hKHQUIePL8
rxmdD1Svn4ZrHxXicOtdubqeHTD+Lyi/MLUQE6+ZcvWJAph6rLTZuqEQKbdO
b6q+sROCQWnU+t1FWH7K6vp59W48jHSWel5dhMWbtRw3ZYQg/XbLWgH2YvjS
fg80sO7HZ0mq+VepYsBureoV//0wz7lf4mZQjIC7U48sNgsjqODX7T8Zxaj6
J/GyYf8BDFW+63x9rgSZnsLlu+xF4a5yRU7/bgke/I04ssgmBt4a7uccr0ow
F7rpoVeyGFTqH5y2pZVA34ibs7j3IOJb1XMOh5aipUu14I2XJGT1l9f9LSnF
wvpvZg2HD+FLR7ZVWF8pkjwM+/78PQT6r20C87JluNd2yNPljRR0R/r9Sn+U
gbWgILjpgDTWrXgan9lVAaR6sR+9I4so68um4qcrICmoajf1Rxb7voubb7Gr
wKV1vg8u68iBlN5+tbOsAt8yX/+RPiqPj+kR+YWSlXC4flHqDd8xjF0cLdVo
qMSSQerdy1KKkOFoVyT1VqJv61ktSokiXMuryqXmKkHZOyMkpE4Cm2hkJc+u
KtDLXbhKrQEh5knKr1tV4ONY2OXyRwl6byLr72yohqBg7t/PtiqINfHStBKq
xg1901u8ZBX0ct36qi9bDeVpL05PflXYP1JuVDSpRkuR2qXiL6rw1xlrZntX
jTYjLZ7VOI0yhnJHjCYZN6geihtM1MGaK2H0zJwMDQO6tEWNOs5e5+vycCKD
kyYfxZA6i/ZvY93XYskoXyh6vo5TA5Ovo/4cGiWDN+f4ta56TezXHh8iB1Bw
kvv3w8tqF8Dvfub49UQKdJXe8ssHXcDmdwkBnIUUsGY21k40X8Ai+0VJ7V4K
6BJK56fNtdFUWXin5ygV437k9U6PdeAq5clc6KeixbGQq29FF/amHedjl6gQ
XM2eIHxRD5aBRxKxpQZrPuY6m6bp4fxQv4qfQg0sSXzJ+TqXsC/hrP/W0Bo4
bjiUKp9/GQ2buLkllWohOjpAks80BFnx1rVverWQaOAUzNtohKKbNQVON4l2
o+Ax1TtGSK69b1ASUYt+3tK5dBjjvnt3vNpYLVQfZJkX9ptgz8Rr0avRn0AO
vNx4Js8c9xqOIWrmM5Rdjp0qyLTERsn8/s/sdWjLiJ5mGSXqtiCpwCWBOhTu
Dm3/JX4N3zQP/DQ9VYcNR+nRJtnXcLCe+87+iDrMUR2Cbpdb4VftxOtc+XoI
lK2+WDB/A3cP3DzXp1EPOkfGpcyT1lj/eGCax7wegg5n3ZQDrXHsdLeSy5N6
tH/f8clwrw1CKXUd+FkPq1++4poGN3GmKnXjV9cvEL4Vb0vvu4UeQaF85rMv
6E2Uvf7gmB2cPGKNpJK/YITTqPLdMzskIvRNaP0X3KycFThwwh5LZR7KhgJf
kdTgX6usdRtZxUZ3B8u+IrzhjervSgdsy9vSs2pVIyh5zPsG404wDlzS7eNt
hJHMuD2XqDOSLPvra8QbscIlZa1q6Qxxno8fA/QboWGsXsXT5Qzlu+bhPNmN
cDLd8Mrt213IxV5+HXaoCexxyzdoLfdxxfS1yZueJhjO77gTduIRfM7uePly
uAnCh4N7ovwe4bVcyPenM02wyiWniTY/wuhGV41bnN+Q9Ke2csrGDXcrzh2T
lvsGU60ETplkdwQKznKXBhHtJhRWt22eKOhV+dKo0Ayx7Nc+E53eaFPznAw6
04zl7S4xUxw+mHtfzqup04wDpXvfKR/1gfyDY1c+XW8GrUGuvy7cB0VbD81V
vmjGRZlPqd66vvioyi+YO9SMjCg/vbbffih9TbsTFtaCsCeGs+NyT9G1XvKl
zqsWxKdZkATsiTrW8Wb55owWWNJfm75KewpFDLAHVbQg9BbjxJvtAShv74zz
HWnB8b0+676sCkQFe23tXaXv8FpjNhPVG4Rqm7gdBqPfwcnj08g+E4IPwzdv
ms59h/ZXQY/7W58j5cbxkqssrejRVdm25chz+Fq1G9pxt2LNU0+zMsfnULPY
Eu2t0AqJiKJ9/808R6OBL9/7wFYUOZ34d535Al1qt3jWSLTBZ1982u4j4fha
e+Iau3wbrtteEOm8HI7y05z5G062YUDLy6n6YTheqabp8um1wVvFlcJdGw4L
pT+hEo/a8NX/QkSdSQSG5PW49L+24bubSnxQaCRmhRU3vbvVjq0Hfi0yBKNB
6lWufXq/HZkspdVjWtHwi1Nzv+HdDr9gCQr3o2jwcutO7H3Zji7thsr/OqIh
t+pmYzSlHamca0qdI2JwvzMq+MmOH/A12PUifnscGMEzmyw//4DW1tysT/sS
sJqeuXnH/g4s7nyevS89GTu+Kk/jUAceZvEUC1CTCW762Wp5rAM9YYXOEn+S
cU2dLeb9uQ7c7mBnRBF14qeXFvuV73bAur59S1RACoKPbz9uXduBer7OzzJO
qRB46He10LoTfAEVEh2X0yC3Yl5w8X0X7u285Ol6PRNffGQaasR+YaVkhVYq
lYvdIf/o6eO/0ar0OpCRVoh/8796WqV68fviXYr/6jIUXA+uPivXiymHevas
7WXwaCe9rjjRC8q93W+bpMrAWxh3K/10Lypak+zYzcqI82TEeGjcCzY+iQen
SsoQPdO2fd+TXryzH7RtdiyH2uRXXcdfvSjw0XLm6K5AykhJ3cZnf3Gp/mLK
pHoV7CLP77UJ/Qub2O7ew7pVkFf9+4Aa9Rd2P1532ZhWoS6OU+Jh8l/46ugn
1zhWYfKCQfBw0V84RHYN7ImpAqlw7iLl71/EvgkLNRipwk/vw90ux/og8EPq
IK9XNZKkqLKtpD5cSF88g4Bq2HbrP5NS7cPM2CZe07BqsMh7YFCrD2VvZiwe
vq6G8EhDoq5lHxprgjiO1VXD6YKt1aHgPhzjefA1dhMZG3emTfT19aF8K9PX
9DkZSpe8u/8O9+HJN6Nz/lFkOAab1feO9yGti2b15hUZbav40n4v9OEy3Rrk
d2TEDzwx7Vrfj9tCRzWtP5MhmW3ztUWmH5oB5auvMckwHz5d0nysHxTv3db1
rBS82LM3/RupH9calnr2raNgLqzTp1GN6C9cmJ69jYJyF02FeuN+dNyTDBaV
ouCcimRmtU8/fLS/HAs2pcDtIefLKv9+9Jp0qO20pCA7f8Cv8lk/Msdei8ZZ
U8At8sqiPKofNVfXb3F0ohD3xWb+4rf9SLy7X93OnwLbtsknOd/7UdzCE/Iq
m4L4TQ13s3/2I2wze9LJfAqa1DIss3r6YbTVT/f7RwpkSiyU3g31I6rlx4X6
agoYr1rm3zD6obSzKn65hYJA63yrhH0DSP/UqXV1moIRpXdP1okNIPfNywrd
eQrO8KVm3D00QNzbl0uklyhYXRs2rnl8AFaht2Y+rKbCZZ/TXfr5AWgsqM5+
2kxF29LNKEu9AYS77FYR4KZCpuVqcaPhAGj2ibZG26igeV5kpl4bQL8vy0rs
TirxTkn76TwYwMnu0XYxUSooBWJvyjwG4BZE+dhxkIo9z/bUifgNYPT0hiZn
SSq6Fbg2roQM4NarS6dvHaHiODenlE3EAJ4k+z/8LEtF1L9VOq0xAxhwfRG6
magrdKMnwzNfD+D+raebzRSoyHUYLuR9O4D8sUxNKxIVm9T//PTMGYDqOnZe
fSUq6uabduqXDsB26DtjUYUKkUbira8awMYN92mZp6jwe115RbJ2AFtfFu88
c4aKk3rZqazNA7D+fvHbibNUxIu/qbVvH4B31XfpcA0qGGsShju6BhD5ccHr
hyYVhp2R6073DhA+Gsj+T4uKotxgiZzBAVy1IGcKnKeC9+nj8wJjA5jvKbDY
eYGKO1fcHR5PDUCBOUBh06ai6ei90Kn5AewWdq3qJLTkZvt8k+UBBJdGnHmp
Q0XgoFX7p9WDcDlw9bTSRSpGyk3pR9gHUf/lv3dNhFaLuLTj1YZB3OFKtTmr
S0XqLS1Fzq2DMDW9bveO0KtPnTZz5huEK++dNDqhzQVInr93DqIgYZz1kB4V
5dOyyRp7B7FiwXL3HKEF6iWoBSKDUCY3DOsS2jVp/6CQ5CBuHfA4f4rQ7S47
OYKODMJ+9njELkLLaPMcXDg6CNnQ/e9+E+O/ENlw7ippEO+srLwDCE1bYbVv
UBkEpXUv+25Ca7UzQo6pD+LGaR+xGCL+t+9nclO0BvF41/ufK8R6OfxGv2/S
HcRmSi3rOUJbmfTNuRoMYiJ2PtqLyA9FpotvwHQQWgf3BSQQ+dyz/vtxbctB
PBR1pb4m8u3xt9641HoQbDfFSOHEfvQUk90O2A+C+aJg+OY5Kk68KEl44TQI
Z9WEUjFi/+aUMvtuuA9CuOlFhrk6FaUp/2Lu+QyibvhG7BThBy928Yt+/oPI
MQlJsD9Nxcamt1XJoYM4xuZQLEb46fuRsfu5UYPQ5XUpu3GSiuhICamquEG8
lr797jmoEDZ7H9+TNojuU58lU05QMVo9rjf2dhAKvK7vgo4R/hU+tIGRQ+Tn
deH0FXkqSONZD7aXEvkvuZtTJ03FpUc5+rpNg4iO0B2NESH258/kpqutg+jX
LEns2E9Fr6p0rUPHIJRER1rW7KXCbv0H2eC+QfCwkfx5iPPoF5PHVbcwiPT9
BjKyxHnWXJn5/GN5EKRyttaa9VRwXZX1HFw9BOYD7XxlDsLvYgUTrBuG4DtH
30dfRUX+x8IvEBqC1vd7OuZTFLjuXPDWEh5Cj9cPT5VxCpQ8j54wOTiEZGej
b5tHKPii9jHdVXYIFwrXVVn/oaCvvdgvX30IPyLHnbgbKcg4saRI0RpCtu5x
ebU6Cm6/OjHbfHEItU6HFq9RifvMqvQqzWQIMnYGjmYlxP05V6Z00HEIudK+
ZeqvKegwYM4fuzcEwbkZ3q8JFCSUkbLUHg6h/US49vEYCsR9K3Za+Q3hflWA
YXMwBarcVYsJ0UOoqil+u3CPAidpSh4veQgDkctXBFUpsJIRTHj+aQhfVB8I
vlegQF/uYcD6hiH8x/d71R5ZCk4cl7FY/XMI+8Vmj5XuJ+5L5ZRN4+ND4Kiz
ai/+j4JgbR8bKv8w8u3Dn/ytJMPj4m89JcFhFG88Mve9kHiv9BROluwfhvWa
9Z/fvifjksHMthypYdSHrmvaRHCYwBVLauzpYdR0eJWnOJORcVtV0MlxGE46
pvPc+8iIdUxYN3FvGOmV408ct5MR5MSYs340jBgB0dOFG8m4fT/vq9mTYRSq
yDvPLVRD3mPfA434YUz8WGQ596UalGDWtj11w3B3fst23a4av95TAr4JjWA4
cPzmn4QqNI2xjkofGEHLJa61fqFVqBQ/pRkmPoI9bXkbefyqkJBBXX9ZfgSq
b9OI+rsKFq9rgro0R4g6Q10j60gVBuI+BQ/eG0GIlb3KmapKjAV+CV3+OgKZ
nNbckJgKLNl8jxF1/Yf8jkaziOslOHiSjWlVMgqB4rmdm97nIjsj88CPylFM
uTU5nn6cCxnuC9rqNaM4kPz8r7t5LhQGo1IOfiP02k4sceVCK0hMgzYwCuxa
Nbvnfg4cf56LcuEaw5NW7e73Ktn46BAmHWg9BvdkJkmoNhOkzqPGy3Zj6H0p
miPzMBPVqt2+dk5j2HbBqsH+cCbqtgn/vOA+Bvu/2eFXYjPQVVbozhM+BuWO
HeIXndLBwtn5Jb5yDIv3SL8cJNJwJknoes62cXAaSvuQvyRBJmqjcI3AOOqf
ltT4BiVB8NlSX4fQODQelI8+1UrCokurBav4OO7GeSdf+ZaId9r+ppeVxiE6
p8Y07EjA1lWTess3xuHabz4bPxMHlvlubi67cYxV/GWYu8dhdLSuRfjOOE4f
HPlawxmHmh8p2hcejSO8aP85372xcMnWP5f8fBwNVqw3V5tE45dZpap68Tgs
BgwQMRmBL3rv1phWjOPN7UhWx8cRKNKIrnakjMNmbt+Hjbsi8ELeSSm2YRw1
CuZTz8+F49QmEYWJ3nEc/JDOOpUfiszy4CPh6yZwvZul5c27EETlPZxK3zyB
9rwTetYXQuCTYZ1TzjMBOtev9g1DwTCNUDk0tHsCHQdZMyoePMMWu3mxEzIT
uGi6b6ttUQBRN5vt+WM8gfL5DzIV/n6wuCB1qevKBBglu6JdJ3yh5b3qabvV
BESEUlo2X/aF8HDy5NfbE4jjvLvy86APvucNVRb7TGDteECqzKgnKgc/zuT7
T8B4bxppxxVPZPIHiOQ8m0Cp9dH+6XYPeHlIhKRFTeDolnDfdZHukNJ0NAt7
O4GoSzxSw2EPIOCuEhqcMwES+42RG/GuYMvlrn1aMIF3Bl1mc5ku6NlWKOlZ
OQHmS1XN8y33EPh3afnWd+L7zw2dTy864T7v18PWPyeQmzW8m9PtDq6qx1+z
7JlA8gejisq3jjiepfTVcGgCEs1mv4d4HTDk6ht7hjGBg5q0VbaKthi5dPBG
IgsNen+qbFbabGBO27p69xoaIs/2MbVcrKGxt1+Wn52Gz7MRUco/rFBZ+rUx
kpOG1P6+8Lmwa5C7VGDNs4GGBdaVd36Gltjj/zhuMxcNroe27jJisUDUntvy
z7hpiBqqu5X12xwbS/W/rdtGwxGjsOCVUDPQx0X/YxOgYZO9LLe1vRGadL/Y
Lu+nwT2q5k0Miy5Oj+etfSBCAxpv/UfR0UHp47iEBTEadIOey1gWXkBasd33
6UM05GQ9bY68rQEB3ct2DtI0nPBILLVKV8OLMbBPyNDQ9TWeI5XtNNwEtyiM
HKMhyNRNfVzmJGY+0luvK9BwW0A2y4CdBJuLvfb9JBr4dVVpPlPH8Hu0juPq
SRqcxynn/UTkoOf3Ifm3ChHPPe1a3wxp1O2OVTQ9TUP0OHvipUlJKH30ae9U
o6F6gvZZUVgUBTq3HAw0aLjLEcLYPLMX4qN669rP0bA6UU5fqWAXinQ1K55e
oOHoRvZHk9t4oVKmfId0kYYC6QXk1W5Aw/5jB6b0aBivefotUHY1DJ8d6kzV
p4FGMmRwzE2RBub2BxsY0fBbe1/Gm69dJEczAZUNpjR4cNbVvLXKJTFrueYr
zWlgyRvfHnImg+QvxZHpdJXQT2kvMfSDxP1yxVTEioYLRxVjea5MkhJWzXF1
3SDieWMniP2rIG4zWhN8kwbWR6HHyh6uR1Fzr6uKHQ3Nh13ytIx5oHrip+T8
bRoidBaYJ8Z2ojG5sTfjDuGH1QfO0Bf2wnB9TYTpXRreOFjWe+aLYsCp9CyX
C+EHLaUj4rxScOzOZVIf0OCkzWH07f0RLJ9Kz3VxoyGs8cdBcoo8nrx/ZSXh
SUOfgasT98IJcG+L4P/jTay/smuVra4SEtwDG8L8aOgYkdIN6VSG+JCXl5o/
DU8cX0V5PD8FlY/2I1nPaDD8aBE+4q+BBiGr+KvPCb+xewvc+6IFw6fGOtvC
iO9tMl4u7tKGo5F6sdtLGoZXN7fNtumCQDY76Vgakh7O2Z9ouwR/cbk9A/E0
NKlUvFo/po+E5T1Pz6XQoHyO44XlFROIW20nrUqjIUXSN3um3AyFDZum8tKJ
fHe4zW3iv4KGVwwDgSwaXjsphcblXsXyyTbRfx9pKP9F7+dysMaTjC/d8aU0
/CNF7t7OtAH3VvJznQpif10EfX9F2EK8L4v+kULDKhnlja//2cPQz//zk0Ya
6jVt9GdD7mBg3P2RQjPhN8PJ21f8nOBw+e5h2ncaxtiKf772dMYTkasvL3fQ
4PbRir3Y/x4K6hSshftpuB/HoUb+9QBbN9HYKYs0FJ4zcrdo8kJz2dPH6ss0
nDGM+EG75Y0XtvvXNq7QsKttv9nCBh9w1Rmu6WCdhM3QHi47PV9w+VKXJzZO
ovTTz99Nq55g81L01I69k1iUTTrY3hCEpnRZh8T9kwgxrn8vE/oMIfpNE8Ii
k8hnXRgaMwjGpoL/xg5LTCK7Kfah7L0QbHS4PXhGfhJrVQr70re/wPrBU113
NCahTNW8ejs8HF/CfxvSz01C+nkA2zRHBAJVH/x0uzAJqS3xR4PdI7AuKbvN
X28Sb4J69m60iwSnyY5vr8wmIbJTSnvp8kuwt9Co9Xcm8ajKruOEaRxYK2Ky
9sYS4zPMDkxtTUaHgqrar3hifcfoOtctk5FVPPo7OnESq7sjxs3yk2FYoMjF
lUbEf7X0U6t+CnLe/XJiyZ3EZ7WBfempqTCN3Xu8u3YSmzSbeiL03qDIJZMS
MT0Jo4/sG5+seY+bMiU/OTSmcHBu85vm7fmobGp9W3RuCtfXfTg0cjYfPLdo
7tcvTOHM7zxujof5qEjdL0zVm8LQp7y/+j352LotxNHDfAqk8OxN+5ILUEK3
XDfvPIXVlwUlvMWLsK5io2JfwhSKre6ZLMqVwNxIdHNo8hR4v72QWLAqQf68
yt+Tr6dw1lk5oDOiBGZSLv6vMqfQfPlJhNZcCT4k/m01LJiCx3KLW+2HUhj5
FNl9q5+CamDEgS0i5chUt0gon5vC29E4U7l7lZARFyKBPgXJ7D9uWwMqUb7x
d2fF0hS+mAXsaouvRFOLybYqlml0D2M3Z00lZkwMnpE5pxFmWMgrtLUKJMcL
Dz/tmsZPdl6x92lVqNXdxK8uNA3WruL32R+rcEG+ofDz3mls3rD834t6oh5k
aEzXiUwjx8vYb2K8Co/9zth8lZ5GHJeDKqdMNZqiSfrNp6exTq1S8lphNQwe
Lc/qqE9D83Jjxr7aavSalYa2aEyjvNwjv7StGjP7jjd+vzANk21x806z1die
JXu63XAaz+89yluSIsOCLC7TZTeNcBTmb0wg41/qv2/GDtMwdlnKEXtHhtOT
DPvuO9Po4V/03F5MxuNzIpk996fxrGm9nl0LGW/b9+754zWN+NctDf/WUDD7
j3/zQMQ0ml7LaYwbURAWN1gb+3IaS+rPBoetKDhyPs/9Yuw01iYbXs9woMAh
99xEZeI0Fk5u/Xzfj4Kx+x4NMW+nsbH6wg7ldxQEip3z08maxkRS9E+jAgoO
dm0nceRO41BT14h8BQXW+PDubuE02DvXlcs2UdD/30CgdjWxH0pXJDBBgU9h
rio7dRq2W4v9LeYo2GvtziivncaPT8/enFqm4MoXPlvxr9PgN7gxqc5JBYtb
/96/jUQ8TqNxNgTfvTqU2/myeRrMNou1Z3mp6H6hocH2YxqDiZaHVIWoeKjK
t6a8YxqL+zZ5mQpTsWOur9ipexov94zkyR2kojgtx/Hg72l0Hvjv+ZdDVBgY
uIn19hJ+qLL/tVuGigVOjd6o/mlkPjpmLXWUisjSbdHnh6aJ+8dhfpng29bd
ORxlY9PYsmJ7qlGZCqdvj6ru0KYhRtWKbD5FxVbvsy5i09N4Yde95YUawb8y
2w7/mZ2GxRMRtw0aVGgP/B2KXCD89AqpqgSv0yKzE7SWpuF/SOSCPMH3weqP
9P9jTmNPy3PNfoL/JZfUN5eyzCBU4sUjLR0qvr7l/eS4ZgZ/7qnUO16kwtb0
r7vo2hlw/avYqaNLxbrN2fK/2WcgXilkMkrojKqHExHrZnBEytvhpB4V6nfU
085tnMEhJ6ayNqGH9vGasW6ZwT7qu487CP24rZe3ZOsM+IwzyxKI/sJPshoc
eGew2XGL/G9iPuqxh34i24n5lBY3dBDxWP5TI/3aQfRfcRd7pk3FmjieufBd
M9AYKnViEOtJ0up9pyk0gyCZ+u/7tKg4yZJ1bc2+GUwIUKXZNKn4nfNgZ7Hw
DO53UO4mq1PhflWt9bboDA6+7ntCP03FLh6eoAPixPwfSdocqlSU1fxR7ZGc
QdLlD0XNSlQY33/PCDs8A1b1gI96ilQsiT7I05Ah2p3dTV4coyK684ztavkZ
GIWVv38iS8WxIO59H48R8RvfKzx6mIofpD+d9gozSPf+4ZkkTsU92rtQYcxg
dfVmvpoDVORfPLMmTHUGXqZVTcd3UvFEo8hX4MwMJJV+zo9vI+ZXEWVPVZ/B
y/wFbisuKlYfWbehQGsGuyftdeLWEn4RexhM0p7BqKe+twkLFW/2jG2pvUjs
3wmb+t90CrS4Gnl/6M8gs1KsWmqUAiFOpZfmRjOQuWTjudxHwcyqnB3DJjPQ
zJi5H9RNQczkC8FFixlkPOPD/FcKhpouiQncmkFcHEvObCYFJZ9q36bYE/2b
tvH9SqLgWeXRQxKOM5DXXM4LfEmBTDa/DOneDFwP+ArLEufbM7hH0dxzBvkx
NawVxhTwa1lpp4TP4DFHSmo7UZyMnWpvEY8i+qud0+SdIqNSUe1SfvQMwd3P
mnb0k2ElIWZU82oG3+7Yuz+sI+PD+nHLofQZyIrUtMa8IEOz3vm+ePkMjNem
mATxkbGbPLCYV0nsT/oNZwN2MqaKLz9SJM9ADrsSafPVeJlxzEvr0wz0Hh+x
8CTuywH/5YDbzTPYIMzVJ/e8Gu5qvq/yBmbQ2d5ifnq5Cs2mN4ylhmdwsy9o
g/ZIFfY5a2x/+28GqSz9/pLtVahL3BKaTCP85HHc5Gp2FbiX4vxeLM6APfDo
y3LzKrx5V3Dr9sZZcK73uBbzkXg/uIZOiMvNguOkzYsj8eUQ6j77I9l3FvxP
fvpyahbhafWJLL0ns9j4J8w5iKsIU2nifmwBs3CzDWOZ/VGIaseNMjdDZmF6
7fyt+9cKYcneHCwdM4uzI1B1e1SAN0cMzlRlz6I4dWf7YkYeJJ9eL+jpnMV/
/NnrK9lyEGGvHxTSMwvhZEN2gYZsrOiqWyr/mYW/Y8GD0LBsNO0+yPV6YBbW
enrtnULZcMgfv3VrchZNnGWBbA/fI++3837G2jlYNSZ9dGFk4Li8T9h26Tm8
3ZCRdkIvBW0W2+XiZObApxRx1GYuGXeevW8XlJ9D0ds5d9GoZLzt/8EvojCH
Dp/Ko9e6k7ArTCJR7vQc4h8f9dtln4jVk23vLhrOIVOGb/Dn1TjEC9iebzee
Q9s1FvWW4licUFs1aWg2h7O9lCTlrbFwenVQxsJyDpas8/WRn6IxcM6j+Lbd
HPZU5XVlnopCfYZobZDXHLJM33OTg0Jxo638xhbfOZiVm4TZMV+AdbUuZ/jj
OTxPld3QffsFSAZu52ID55B6dvEkj9FzZLO1tGREzGFu30OFgafPoHnkhrPk
yzl8T39165Z/EIZNl3lzY+bwS6TOpzogEHsKDhh+TJjDl8ecp2djniLM8uHv
2ow5RHXxHNf75wepkC1eGu/mcEBDq2ovhx++lrze25g1hxvhx2nLYr5Yu/Wb
VVveHIQO/Sc84+qN+1X7x/rK5yAdgG2Vmh7gHit+dqNqDt/+3mU+3uaOHL4L
UqPkOehkcrYLxj/CiL3rnelPc5BlnTWRpbrCeFcjfVXLHHreHOiRe+iMjdsd
80ta51DF9iF/eL8TqrbyODj/mIOUW1fbrg5HCHMYDQ11z6FaICtc0+I2fqxh
Jif9nkP3lN7aWls7PGUmmBn/nYP3++8fHMVsMTE90NY4NAcFZg61dOA6ksb9
X/j/m0Nn/+i5yP5r0B0W11IZn4OEXdnbK4tXUdTjSC2YnoPts6pbPFbmsPnJ
43l7bg4iPw9wnHM1wc7vRQpi9DmYZplTx3QN4fWZ+SGOOQfBWo5S9RBdyFAS
7S+vmsfq8EIz3UltDJarHtzCOo+xg8OfFphaiP44OFC3dh42eyqWm53PQjPv
aZIPxzxsYyRr/c6cBvO9hClp/TzeCTk/u+qkjOz0pu0LG+eh4p3g4kBXhEXK
ndacLfNw37R0N7NKHjyveJ/f5Cb6uxx5y6UsjU8vP2ru3zaP8ZwBV5k5MbiG
GbP/2j6PD2bFOus79kA8eIUcJTAPnYKtP83N+dDjn+Sus3seSgIzF5/3rUOI
z6kT6/fM4/bhHqpxJp2k4j40R903j0q9iqCjOV2kOZeAXPcD82BZ2HLvM2sY
6Y2TpN0xsXl43Hz6WfDmd5Kh/TfRafF5NP06+d4/ZJa0wcap/+2heRTFGq98
7GBHpeW2RCvpeTiOn+y9cZUXjmbFxoKy81AOPBfxOlkI+wxN+Drk5xFex/qQ
PUgUbbos30OPz+Ph2XvtkvcO48n55OBzivNQi99cxt0nhxNnT2uwKc3jN9ut
TwYbFDGuOry2SnkeTuOfyhzoJ5GAwGrXU0T8Plm9Z+pOQef4ITcZNSJeGJ7d
RVcHq2zzsfGz81DlPTb611cLBYecZ9POEflm6fmlUqQNazG+nCsX5jHwQNT0
obEuGnabirTqzWPZgcTmftgQHvyr+p7pE+v9e0/0qIUJjvCkvFIzItabGjTY
YW6OKM4R3lLzeYhMV6jbrbXE2f+Cmp2vzuPekx+6xxnXsLxy6Nkhq3lIu+94
eZnjBixmnf9LvjkPS24O8lVrW3DT+KqM7ebx5Zykk3SpHWpHSh7yOhDzRXie
2xB6G+K/V834351HyrzcMZfddzBbF9R723Meu5kvpO2r7qNrXesNhvc8wEO9
cFjcFdWaAhOP/Yh41pPpnxMeIKQhYyk+YB7R8fX9FmluEGuu5f4aPg9zm4ee
OWFe2Lx1U4x+1DwaDvj5rdz2xvzFS0J90fOwX5/eulXHB5TWPomlV/NQ6DP5
eHePH0x/rjojmkH4k+3RDZclf6jyq3/Ne0vk74h6yLnlpzhoFHJRKWseYqXO
TQVrArHQtcv8ch7hJ5etq6R2PcOL3ydcfMvnsVj974Wf6nPUDDpn/mmeh9Eb
H8eSbRF4K1J2+FbrPEbL1rwKL4lAqDVr0UL7POazomZcr0TC/N8LyqbueVCu
ab3X+xCFxfGsbsXBeazK+qveZBeDQ3PDm6KX5iG3pkdfPCEBUaymTjr7FlCi
1qAquTUNzKvbZL8JL6A+cbu/n1saLMlNs+dFF0BZ/+mN10gapLxU7p2TXMDo
SAmHIeUNPq2IuKodXcBsia2YpHsG5hen3UmaCxDfH5/usfE9Lk36B4g5LSDc
a/vdoLJclF5Q0Uy/uwBdP9qQ2GIu9mQz1ou4LEDxjG7VH7kPGLezf7bfbQGv
yu1XQrM/wHdU97ngkwUs5xcca03JQ97g7kje2AXoxXRm8wYXYGtPftJqygK4
oq7NxBoX49n6R48KaxZQq8hJzogrBucJVX3bzws4msf/KKCnGKujmje0NSzA
+YDAzRKzEkxpT9xP/7mAqwWjR4LMStFEFTl/YWIBO6hfuYp1yqE5MyH639QC
AoSVtcnB5fi0p5C1eGYBjbu7v939Uo4K91PFexcX0Mu9N7ZZtQLvj1nsn2el
Y+Bi9IcAvkoEvotZiuOnYygtKbd9sRLsXRZtOjvpWLyb9pOftwo+nGI5bIJ0
5Ki8aNl9uAoPrhdZOeynQ2ON/EsbqyrYCLV+U5WiY2rldmfv1yqohW988+8U
Hb3Zz+euBleDQm71SlCjQ1rw5hnF19VQmoo10dOg4+Al8lJNaTXkzx/cWnGB
jhGpdw6DQ9XE+6Hm9sKIjp4IMSoUyfjvkafuMQc6TnoW/HRpJSNvcpRecYcO
LY+0knKivrO00n91+i4xPufX+zmzZFDOHxq5+ICOtL9l1XHcBM/t6Xa386Xj
OZ+ltpsWUV9Gqu2ffUxH99n+xV1EPdm3Lq/uwVM66lLULt+wpkB19imPfzAd
e/KWNkx7UcD66Whm8ksiHx6Mwp85FOQppFwQi6XDR+q+Yk4pBZY5m+ay4+n4
03RFSaKWAkr0gFJ5Mh0fPlGSN3dS4LRJZ0D1NR3HvH/O3SXq5X0+ZQH1b4h4
G/YXuo9R4H0rrO3HOzrOq+r+d49JgXTvygOzbDpuXGrssiTq895LN4UGcon5
FNSypzdQoaykbDtdSEeKzrWeqR1UTOW92+JaTEesdZKXxR6CZ0S3F7KU0fFo
z6YCBxGi3t9KW7WxmsjnmXST//+/n/vYKC2MQsfFGPsdBgQ/WjBqNHfU0vHS
NHKpV4EKLgfpqcTPdBjEDydznqSiuj8uUuQLHae/OX1rJPjG0ZBDMauBjpLW
t5elCX7c0+jUK/uNjoYP3ZzSBD82q/x+XNpCR8SdixUNBD96FWlIqLTRIbrT
UJ2d4EVpicLmzz/oiClSfNRD8Fhv4p77FzrpYNU6e0ib4LcXvM92tnfT4dJf
f8Sc4DvlAHq1yW86Nj/eaLaO4L+pFcsbfb3Eeo6b+uoQOsmpacPNfmJ/2Nke
yBJaZ/jEh8lBOlzputx5RP9Vpmn690fouMMdtr+BGD+7mYvJHKUjLnaNvzfB
h+Zn3JJ9J+j41rbr+Hcivs2lw2rrp+igmWahkuDBSim98RczdKgoeiScIXjw
dmpl6PZ5Ora5Gl+1IXhQkF/8WAKdjoKdm4JFCB5sehbZI8ygw1bqqpgXwd8e
a9b4vGPS4VW8V+EeiQqp+3aiMqsWcYqyo57tOMGXoz8bitcsgqnH23OE4L+Q
K6ecTq5dxOK9ngdLBP8rtWVv/8S+CG9pZJoSR4J2VqBCa90i/gatuWOyj4qE
iseWrRsWsZwt2DFP8B9LumlWL9ci3ohxrmXZTEXNaLvdK55FFB0PjKployJQ
SlvSmG8RN3xMjvKvULCtSOVd606inX2i/grBd11LpbYEwcG0P0vvci8FSZAT
P793EZmo4vvZToFkrUjmJ5FFXMhpu+tVRfAfZ5KN78FFvLfpTMvIp6BYa4eY
suQi4ZvDJPN0Ck61bUgvObKI269Yxp2CKTDun3r9nrSIDrbrdTqXKNgjamt1
8+QiSkpO8UyfJnjRtn+/iOoips/ub9onT8GdmfaURPVF8Mm7fSHxUvB0TVlS
mO4ivuzadN24kYwLZ+QstC8v4siI3nxkKRm8AVlCGw0XIbSz8K91OhlJXEkJ
j80WUdx/bd13TzI+Cj2Od7VZxBb5KqkfEmS4XWMxlb+1iK47BxS6t5Ghmu6y
c8Z+ES63e/ncV5HRJGUbe8t5EUmHPD1jW6oxBO1oc49FWOW1sOrfqQav6Y6I
0xGLyOezZS1JrEJXYpjempeLWP/XZHqVXxWS+jfwVMYsgsL4s2rOugoSt1jC
jiUuQtmtNXBEqgqqD/ufi79dxBo3F4pISSUco7OCuKoX0WNySkPcpwKFjOjH
1ZRFjGhfmign7m+GqZ+nYy2x3xlCFztYK/B4r4lz85dFaPDtNizwLkfsW06T
F+2L0Mo/dv3CwzJQy6+Jc40tYtZW54iXUQn4/u6o38K3BB+tSJe1gwUwOcVG
reJfwvv5LppxfAGS0qbKHXYu4e0vR6k4vQKI237O/bZnCZ+dSBxD5HycnL0b
/VxiCfcOJ35gTciDDVuz9RaVJXxUfB5x1iAXZQefsG+xW0J5MeupU42ZkPu+
7euL20s4qNral6iVieyHac+57ywhv5hh+6IhA0lfa/j57hPjeZKeqzal44n9
fxK7vZawMrrptVdnGnQ+eGlLRCzh6KZd5HW8Kag34uLNilqC5IbGsT2JyVBl
TeqQilnCfn5SsJBEMuT1qq7KJCxhC/s+7eEzSRCYX3E+kUHMV/M+8JB/AgaP
P4pWL1+CgqPtx6JH0TD/u96svnIJyqFr+e3yX6IjIHbvOfIS9nxSFQ6YiMKX
rpK3Fz4tofM2KU7wZiRy3RbLLzcv4XRokkOBRxgOHnjq/fM70f8/WZuUL6FI
adyuZtS+BKsxfwXsCEWk4LFvpl1E+3XK6+jK53hYfe/vtYEldI3S5fwMnmHW
hu3N4NAS6vnVfvTtDILd1khb639LiNFR2sg/FIArlgWztjRi/UfYMk8/88fp
tbNsTotL4GI9Hn98ry8q3/t8mWUsYcPZCs7ebT44dpn7+b2VJazldZ76wuUN
8TdH+B+wMlDH9nrNqx2e2HLWUdxrIwPs7zeVCc26IqFq07rjWxhwm7EzihRy
gdSxd8OTWxk4Oxi0Ns/kHrREhl5f2c7ApU/PMs/+54TuV76+2wUY2NmQmjx5
2xG22/ZaftvFgLKDPyl+9DaerjUVOrmPGM+1Z5osYovtbksrC8IM1LjsaNbw
tMab2aiebFEGFjdelXqxaIWjt+TKbogzwBmi3U0Os0RtX0uM4CEGfPW80zZc
sMAlYwfXH4cZ0M4PM4kVN8dAy0aDEBkGWNepxh7TMwYrWZ2X5TgDR47yfBba
pofQ44MzhQoMnGaWz97p1saeXJ8WezDgWTv6UKbxHHJE9+QeUGbgkJOGvv9N
NSglVoT8UmUgINUu+HSIChr5TOwjzzDAZOjdiHpAgmnI4rnzZxlYUsnInhmS
wzhblDjbOQYKrnrvsLCWwiN32XUV5xnIOMfz8uTSfqyfbx6+q0PMp5waR37J
j1i7258k9RjIOnTKLWzfOhwc2JA2cJkBpaeuRcaB06Rik0zfeEMGWOTG8i5+
rSKpt6pZXjIhtMeA/qvIatIPzQHljeaE5rB6su3nNOk6xVuoxoKB7Iw7v12s
1mHuhBCL2zUGjr4nV/2s54fvh/Ie2RsM/DidThcVFAb3QeOyMRsGxB6Zfzrq
I4WUJHpM6i0Goo1OFNtvkscR/khXk9sMCPMHfqzNIaH6uYwBzx0G4r6WXkrL
V4EOR7P8V2cG7K6Ekzji1fDHw57X9z4DbLJ/H2/m0sLthfWzCg8YmJPbQ//N
roMV+4yWmUeEFuDSdNXSw7PBM7lvPRh4+CjYNOOnPnaa9YdYejPwe2TY/XSG
Md62edkL+DFQ9qBoZQvBYye0BLW+P2Ggmf84b2CQBeqoZeKBAQx0xAgdfNht
ieG8heGlEAZuW1eN3+izxn3xiE8fQhmwOfN59HiMLdhTjqTdjGBgh0TbYwkn
ewiH2ll2xjDgv63x5aYaR+RzrlcJjWdgXsDD9/41J6h6pQtpJDIgonBwpZTn
Liwc+nqKXzMgqqiY7v7GBZNDnmWO6Qw8irlu+u3pA3iY744Ve8uARYDY29RH
j/DqvKFBdA4DPwM9gkh1HuiSaGpxKSX80n1BVUHZF6/+bXm0poLIR/J0UZqZ
HyzSLwoHVTGwKlNl47z3Ywzva7+fUMPAixlp1fV//DG3o2dnbRMD6/Nkh0P/
PUPxz921F1oYUCiqOqWzOwSPIq/c7mgl4vPeqcv7JQSsW/urxzoIP+xwdJQ7
9AJbOEevc/cz4PVlQxXvjnB8r5XYEj9InOdLWu8/docjyte++MAIA1Nb4s2N
kyOwa9X0+hMTxH1QJGvxSD4K4gv0nCt0BoYZjfQjXjE4PcDGeL9hGV7d5q9q
NRPBkaKeenTzMgIsaH2z5ER8uRKgVc21jKZL7b8uKyThYvfGxNZty3Dp2qOf
KJUM8+88pxlCy5jznV7zQTgVD6r3hqjLLSOSu2hgUiUd2fHY12e6jH31FtTJ
dTmYdp1mu3JlGcs/6xwTL+ZA7nLav+6ry7guni3lF5ODkk2bPrTfWMZJYxXe
3oO5qPHoOVnvuIyBC6Efnmh9QKfFI7Ncv2Wc3WGUlhCVj7UHSqI93i9D1LdM
9aRIMdTX2LstZy9jWrZLgOd2MQJ/7bFw/bAMq2rz9zmFxdgS9VTUqWgZJt9T
beVPl0CAw7DoejWxPtN2Gq95KaT/LbRqtS1D18ikT9qnHCZZclt2MpdRVZuR
bHuiCgWGCxubWJjQzx3l2G9UhY1ri9d7r2HCwWRk1t21CpXGiuzD7Ex0Gj5g
5S2qwh5O1ZW8rUw8KErxDJashmv+f8vXeZmou+UcI6JRjRbz2kX+7UzckT/g
q3e9Gj6FZ+c8djGRt/PXytX4agxYao9pijLxzU016gAbGaTNW/+tHGSiuXRk
k7QgGZEl34dyJZkY5h+KJx8lQ41Lv49Phgnfiv1lzjfIyKgw7ewjMRFdz39+
pIqM1TcFf0aeZGI7OcR8dTsZRry9bWdVmQiXC/oT/o+M9beuNWerM6GXWH5K
bCsFdvy2nx/qMpE06yc4YERBDVWi9tBlJowU8uQLbSnY7TBB6TVgYnxXbj/9
IQVNtY6VamZE/Is1+xtjKBC5I1O+dIWJjk8dcWYZFHjumit5b8lEfLWjp0kR
wUPOLoXcNkyc1rKTjm8m6j/BE/m1tkz8sHG4+KuHgr/1jFxXeyYsPsk/fjpC
gcK98mwJRybkxZ/Px89SELbH4/1vJybSjc417GChYuzrybeh95jgE1CQZeGk
4rTLmozTrkx8l5a4pLGVivlGv9S37kwwQvRvcRH19YUHaslmXkxMTZi1Bh6k
4o0wZyKXLxNtWav23pQm+KK5Pp76mMjXzmO0twRPGT4Kir3/lAlBn1Xt2kS9
nytyPvpgEBO6hy85GKhQse775qieYCaEHKQNyGeosHRvDn/+gomJ4OciwQQ/
lYqFhaqGM3Ggw86llOAP7ja95/ORTMjEUvvPErx0y3NbcEY0E+57nrMdJ3im
RvxnoEkc4a+PX+77E7yz60f0080JhF/e3Wk5SvDQXW/jJ+QkJrL9D3w4Q+hG
yV1+d1OZyAp2GMonvhfp+OUt+obwX9U9T29iPA/fRM+uDCa6rSjB2cR8G+6x
nb3yjgmvgLM7bM9TEX3jFtdAFhMuqyIWYwgeEjZs6bDJZeKD0OAJJYKHPmgc
S57IY2LXKbcx/VMEvyi+uulUyEQmJWbngBIVXyT/k6F/ZEKT7t4xeIIKA8Gb
jEelhD9O3JQ2laNiYMs3yuoKJrz7446oSxG8uUY+6HEVE0wt/dE3olSszMTq
racwIfWnw+YRwbuBA6t3Pa9hQtmltbGGnwq+HzcGeD4zcfWjipsvFxWpnxve
R9czEfdhZfAjB8GfJTL3djcwsdr1r5sl4QeNeBZ20RYmwj48XdpJ8M+PYKum
d61M/Dq7mirxh+B7zy9R0j+YiJnj8M5vpcDNMkpUoZv4vuVwimQZBZyXmJOV
v5hYEln7TzCbgsgzlsWneplY19k8FphEQbaYlMb5QSY4NDsnW3wpUBSI2Pp9
mIn/FJP5su9SULeB0ak/SvhtRsmC/TrhZ1qtrcUkkZ+3qkFSBA/xFpo9c15i
QvGnSZAzk4zkN9RLi8tMLCZReNSJ8ygVfXC3O8sKHvMF735FnFf1R/NZT/5b
wQfNP7Ot78l4qBL8LWbTCn6VegsFXCaDQ3b2pSDXCsyXpz8GKZERIWxkkcq9
godNtet2iJKRxXFg+v32FXy1fqbSsVCN3sZy7uq9K+CJmdrOGVoN+6p93aeF
V1D9uGm91/1qMHKfptaLrIBDnv38M5Nq8ERckmuVWAHvooyGtfD/AoIBff7C
P0hc7lfoN/8/YNpU5k+zwT+t6B2bDkz/P7PCbuogu8A/iJ2FYN5O/z8d79pG
upbAP2RS7SWuUf8/Li1anutxwD8cvLywTVf/PzK6SlofJ8A/io9bxoxi/z+Y
llNKGhq/P2g2mfEKef8/V3/vVnuSvD8ihBRIB6b/P/LQlveoK7c//jh8Ddeo
/z+k8gor79K2P9nt49Kmq/8/0+GlgxN6tj+QV7NdRrH/P8dqxnwOyLU//ypS
c4W8/z/+XWQreGO0P9zRj54D0/8//hKDtnKdsT+4hvdj09X/P7wNcQl1RbE/
lDtfKaPY/z9mnA8Vt+2wP0ulLrRC3v8/xCyEvhI/sD+6eM3Jgen/P115dXCm
y60/li01j1Hs/z/zVmld/CCtP3HinFQh7/8/NPlRBjN3rD8oTGzfwPT/P3+V
uvJxJqs/BAHUpJD3/z/sFJfpkX+qP+C1O2pg+v8/hmMhA8LZqT+8aqMvMP3/
P/7DBxkONak/lx8L9f///z8+efgEgpGoPzN6bdI=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 2}, {0., 0.16666661659612642`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181734770566*^9, 3.5181735656535997`*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"y", "[", "t", "]"}], "/.", 
    RowBox[{"ndsol", "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181734464286003`*^9, 3.5181734464306*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVmnk4VO8XwC1lKVKiIpUtScg3QgunsmSPbCWEJGlFIiVbpFASQmSXfZm5
V5byypJCoizZl5R9G4ZhjPnd31/znOe+9+znnfN5ZsQc7py/ysbCwsK7gYXl
/596V8daq8avqrOwVNlnsM583KAhfHdASBN+Dvmq5quEViomxSaQhcygVGJT
4L7K7MoREUl/TylbYCmNHJN+/7FS/3snKVHIETgFBF8kX/5WKRm2J4O57zr4
/ebf2fHtV+Wa3pU39lK3oR8Tyenx7K2ceNJWax/jCvb7s3znrP9UWjouf4oU
uget8hqbF86OV9ZqCH+oSbgPlfcHPKlrs5UKEmpFi/segOPXV8P0TwuVCWx2
2fvTHkJwRALt0fByJddwQKqF1GOQnppmMG6sVZYP/vxeY+YHmdNnHkA+C7pr
7KhnHeMPtrwyE0wLdtR3+KlGuNAT2FSxJZXlDDeKStpVtf9SEHAsho6dCuRB
enw5JysTgkFIqEKUdZkPlcw0HZ3d9wxqXu8ks1RsRzdtbUlP7Z+DK1d5WXKV
IBJvnpUXTQuFQ+5Hy/wGdqIX+fzSJlIvoFbmQyrLdRGktSc9ffzaS+hD+WHJ
v/aix1/it342iwCZT4JKVbmiSElZNvxizCvwM3Kk+JpLoGTBc8HPhaKgoElz
9fGpg+jh9ze1FuVR8G5xIq25WwZZBA2ySVyKBtbv7VDpL4t4qK6+FQkxYMBr
quhDPYy82qK8pvbFgeCIOLtauSIyDesrKa2KA/mbVX4jZUpIXlOK+sQ+Huab
Q+d70FE0Qv7guiftLSheXwwv71dBJq+7XYyk3kFrG56q7HwSyepLZAvXv4OQ
CN4bNvFqiIv95ui/a0mQ+mJVuO2nOrpctl6MzJKh8duWsAu5p5DgwQj5CzEp
4Lze+UzAXAP5c5EPPBNKhxZJ93WOU7pI5uyrENLddGA35aP0iuihn0F3xnvq
06HDNMHEmaGHJNllc+XvZwBtxx2dpG8G6AsjXb7tZyacwW/1aJ81RjwLMUf3
hWVDnEBHs+JVM4T/5xGj8ycbrvpF7tCdN0O2d02XXY/nwO1tT0ZVfc1R4TRf
We1YDvSfVBTISrZA58dCTrpo5UHgQI1C7coFFNvnrYGvF4DTK7GC2Q226LTI
xfR+80LY67Prfm6BLZqwUtnIlV8I0QvI/bTVZbR36sGVfLki4Gu+vOpzyQ7d
ua68n6W3CKK/T0uZ19gjfsfCrAxVEgC3zWZ35IguXEwpnJvHIOT+h9mz12+g
2R6zTanCODTsEt8q0XYDBdtyXTXVwGHbsy/GTXATka/cES6JwsGi7a/AM6Fb
aMtttaCHKiXgJpzYmdNxG9UFdFlx+HyA7VoLl2tPuKIjeds4RLjKQSry1dXS
gx7om3yd3XeFcrj6JLOVecMD2RV7VTy+WA7olm5pfoEHCi8ZuDuUUw6KM7sH
Th69j8aq8nsyDSvgfql394Gznuhdu27xf68/wtZi19yDjx+gzUx/67N7EZh4
jghlqD5GsdctbWW1CXnbxO59wY+RZJus3bbbCGxdxaNXfz1G6tmdV3o+ITD4
mfC5/a4vKsuOwT/IV8H6u7GxcEs/NG069VG/uQrSaSzpM+/8kXnWm0Z33mrY
b/wpj2LyBO03mRmrCa0Fsw3x4yZnnyNh37PHr6XUwt2jpnstHj9HW/OTQzd9
qIWd+qq6r/DnaJXLVN5kuBZ0TFO08iRDUUvVB/d+1TrwFM8/6r4xDHkr+K/T
/tbBw9z83yqt4aiZT0BA/lQ9KD3i2R/5NQJ5Nh+D2MVvsOza6rXaEYW2yON/
v3E1QDmUvPy2FIXSwxXC6CINUF/ZCQU7olGrwYEuW60GsJGMglKLaHSoUcB9
f0wDXA2Qevq9MxoN1M9mklQa4eKBGHFKXww6+zljy3fvJhhTfLK3aiUW7cS2
9bOy/gDLS1lxe28mopJhjaYfJ3+Ccnc1S95KGqp2Sdx9caoNWlictyoGZyOq
lBpf/q1O+PisSlG0vACpD5+pf+7VCRnvpDsVWgpQcKKOr3NgJ7A7Od4//q8A
7RAwm5WI6wQfNqagKn8hUma98SO+thMG5C90/b5eiLx6Yl+G7P4NL0TylL9u
LkJrLxf5HL/9Bq7SB4/H8SKkqb9af7rtN6TQ6fdsqopQGAeL376B3yBZkxnY
2FCE9vhsnute/A11Xx3eRA8UIXUX8RYT0S54ITx7cYCrGPlqGkeAZxfIHZO1
VLEqRmwruVt37+8G9qJmFuflYrT7+5kFONwNDbI775qxkJBSSle747FuoN35
4nKMm4Su6nK+LTDsBt3HMmVTwiT0Nc5h/5n73bBF9nPZkhoJvTwudPx6fTf4
WUydDQkgIZFHwVc+XO8B2du8gmIbyeio8R7tXvceCPhx4hydh4yMJDFp1sc9
cMS+FTUKkJFv09C0XmQPKKuzLhlJktGwiJpXf3kPSNL3vO49Q0bZnxbCNvL0
QodDggf7YzJSZtqVmBb0wvnTW6lLk2RkYFgVoFXaC5v2Wzw3oZDRlbf7zqlU
9wJH1F6rZBoZRaj0jwp39MLNyipr4Y0YGr9zSWiY0QsXZ3k7ffZgKGHQ/NFd
wz6gC4z/ndfHEEke13Gw7IPe3AdyT00w9PWRgKCZfR8EeZF9+CwxRN31K1/F
ow/abfImafYYMjIxHlhP6IMfbJ7/ZD0xxFqtdyZ8qg9uc4cnciVhaNfWnC2+
S33Q5uf5oC4NQ/K23D13Wfqhhxktcy8LQ1ar9e5mAv3wLdwDZRZjCDuilbH7
ZD+ERG19a1uDoQa/dFde7X7ok1HmzKrH0GAzuzrzXD+U6e0rHG7EEO+N6o7h
K/1weSni6qE2DDmlAVdOaD80Z2mYcY1g6NH8u7a30f3wRbkzqGsUQ69hPTk8
qR+Wpjovvp3EUFXPx2Ou5H4wTfFImKNgSEjg+A3Vnn641e7uPsCCIwWHOBWZ
v4Q/xtVJihtwpF1EYxeZ7YfnkQfaPTlx5GbwIYHJNgAJx0O3tPDiqOmJUvMX
mQGw/cKV9kkIR8f5GtleHR2Am2/JaU0iOMqKs1e5dGoA+k/niX/dh6PAghfJ
s+YDwMUZd+zJfhzNqe5vL7MbALaFTcma0jiyrangfnJjAKzrJMXmZQh9v8fc
dvkPgFbBnMAWBUKfg+/74dABEJFNv/D4CI52TAv25sUMQFnS0IVuJRzNs2po
nc4bgN/KDAXzY4S+sK4Hmz8MQOrn3i73E4S/O+4WtH8egJqtukM+aoS+Q4k7
XToHIL6hId/0NKGvRNFAaXgA4hKGNPZp4OjJqQa/9akBeMwa0t2uiaOiHPo9
XdZBCD8fnMuug6PRWe2XBRyDwMwYKPHWxdHeo5HZ23kGYdyq0bFXD0ehSLq/
b8cgFH+w1rtsiKPqDfdoZ0QG4fcXdlM/IxzRdBF/ltggcHCcSg49h6PDLzfJ
8R4YhAHpSGF/Yxw5tZmfdZMdBK4/3jl2JjhKFEqx7/xvECTHvFVlzuOozXbq
4UmVQeic5M/vI+TN6SoxKScH4UtKzZy3KY7OjAcUcZwZhKhPvFOsZjh6IN/c
cOPsIPyluD51I+Qid6G/LQaDYEu9m9tEyKOljsyj5wch1Sv01FZzIp71QqG3
loNgrnDmsBohm2vQFVlsBkGkRdDOlJDDQrSNrjoMgugFz4rzhFz9/ZVzw7VB
0I8KlD5ByCv8fQGHbw3CBfW2CB5CVrggnRjlNgjX3WQHvhD2nBLdP6x4DkKS
wbn164ScOFzZauszCMLjzN9Uwv+2A5umagIGYe0Kq5ULIW++Zc5xMGQQnLp2
3Kwn4j1DShZ9ET4IXlfZV3kI+cHy5PGFyEEwk3w+c5zIV9FJFfMLsYS+I7eV
TIh8jvoH3PmUOAhTOW4l54h8763//kw8bRAmcqwuKxP1MOcRSn+aNQhHjcaF
NhL1CjNxrJzKH4SZoqGWCn0c1cQU/jYhD4LKLMcdK6K+qz2rlJLSQVDYLzIw
SPSDs9OrA/41g/BhTHwwXQtHSbm9p/99HYTggnjtYaKfOuYOWOs3D8Lz3i0y
nGdwpPmwMkKwaxCKhmj8nOo4eljFnevdPwg75henh4h+JW00rxv4MwiKXStz
aUQ/74uYXMmeGQShdBnhPqLfK+19s0kLg/BuV5GBHzEPtorbL1bQBsG96kg0
LzEvCR3HS5vYhiBPRVbiHzFPu/Y8vz+7Ywim876eCyfm8cPMHina7iGIUm02
9CXm1aKquJ1FbAgsaox+WxHzHH2lS4n/0BDcFR252MyPI/4c6QUlGIJaFkv/
DOJ+KH74MVVNcwgEww+ZDxP3h7Gh8Xlt3SFgz/+swcXA0Ms5z2JL0yFgzJur
8lExxKNSf8f72hDIxwrOcxL31cbaq1Po5RDUvc5WiP2EofTolbdfo4Yglbec
w64UQ5rXwvVb44ZAXFNIYCsZQwGb8JzhtCEw/m/0rTRxn64bb7i+sXQIxARK
W4+9whCtL/Wv3uAQnDOf9W2xxdCbQuVo079D0L5TTEPwAoaU/Rs0rSeGIE2S
cus0cd97SFLSbi0OAarY8eucBoYoLqcdIriGIUl5ol5DCkOTywP97QrDMLb9
E/IdJaOSay+r9ZSHQV2GQySwn4z8OtUz0YlhSA09/du5nYx2fEi8la09DLS2
2+o91WR05v6ltUfWw/CZ87ODVQIZxS92CEmGDANfQfH2D7pkdNUxmBEbPgx3
8d1vutXJSKHt6BDv62Fo+bL584AiGX0hR2UtJw5DNc/Ewos9ZDTvdl6lkTwM
E7qvtfxmSUhn/ruZ28Aw8Ocf25UTTkLb7X1UR0eGgTSXF//Xj4T6W2RFrCeG
4aCphSvbPRK6VxT6R4s6DD8ffOAYvEhCSXd03YQ2/4Fnbu9Py0iS0NJ07csq
5T+w2djLc4lUjNInKhq2vPgD5lV9CQ5lRej2m3MSLq//gAD/06Jt2UVIRfPP
w7rYP6D3MEEuLbYINSRuknuU9gdGKt3db3kWoXnjiy/HS/9ArXJ+XJIisa98
WDKt/fMHdr+SsaUbFKKuwP/6HhwbAQ1G+o/3U3koVaHuaLv6CBwsTZ4trc1D
N/suvFDQHIG7IMf/KiEPsaj4wajRCJieEP0ao5+HpCaaU8wcR8AqJaBzNTMX
3TO+6XT45QhYvmtnVzPNQVv2vJ8dGRmB1YOenKUB79Epi8C+P+MjcLVRapuA
5Xvk9vJy4/DMCAweSyo6c+g96mDd9X6QNgKxZ6U1dv3KRO/+hdj28vwFnmz9
kizRTCRf5PL9l9JfiBfUOBxITkeGGvK51U/+wvVdpfMhZSko7DrulCz5D66P
VnU7ZMagpVO5I86+o+Bloduze8wX7h2pxXbUjEEDj9wn5fhUcFISTX71dQyi
7vhnH+1MhQvKj0J5msdg7bqYHr9AGpw4ruTA1jUGV62mkX14GrCdSeebmRkD
kbfmElqP0+GlyROXOuFxEDm2dc77Qibk3NUUvec2DhvCjOXdxrMhwS1586zn
ONSMbM0uF82B8HtrS9d9xuFjycrub5Y5cNcL+345ZBxci4PGlepyQMVP8qH+
u3E4cttwr2JiLtS+3NAh3jAOXWazo6Kn82GgoDa0VWwCuAyFOD8fLIKW6Q1T
Rw5MQJAP1+13p4qgSlbLIEp2AqR1jc+bWRZBck4dj6UKIS+nHdR5UgQOmV/C
ew0m4Lzt1mPaBLf9S/z6ctRzAqZz29+de1IMHb1cczo+E8CXmeQVGlsM9bt1
jXMCJsD6ldfF+LxiyIr7tvVW+ATkJnh0Hm4rBpfohleU1AngOOxqoSBGgumw
pteM7xMgutl6/0kSCfobeRZtf01A/LsSDb8aEjRvMjSr+j0Bu7yYUpFtJCgI
+S4Q+GcCbp6PYO5ZIsHdJ83RXCsT4Lwicu67MhnsarYsXV+fAPq2C5P3tclg
wnbOopF9EiR2T/ycNCfDEb8fO15smQQXs7Nnle+RYfFhy5vtkpPQ8MFst1YB
GUbKt9LuHZyE1mzc+dRHMrSvGF/okJ+EFeWOpxsayFDi2bor7tgkhIXOMv+O
kMHL/Wfc3nOTIO1ydTfHLgzoLm1vD3pPwo7l9YrH7hiYKdu8kvedhPCxf5xH
fTDIY/0XrPhkEkaHtAM/BGNgG7vsqvZiEube1EmLxmHwuU5YxyR1EmKrRbZ5
V2Ag/CpNzeL9JESlS1SE1mDgZi2reClvEn7umW671oiB5ILa3qslk/Df8veQ
x90YPBW1X/RqmAQ9IQcOsSUMBifHx31+TIIVq/pG/zUMVD+4DQS0TcIesRX2
HDYcJgyfNIT1T8LT5Y1GFltw0BDirXr1ZxK2SrVB13YcEkai8ZixSdj+yPux
pBAOhg/fJydTJsHwhc7h7RI4ZGorxGQsT4Jz9dTZkgM4rG8rC81Zm4QaXodV
UVkcLPtO+xeyToFx3j8hUwUcirIa7mMcU8DWXfrAQAkH7numN8s2T8HXnzum
eVRxcIBe+8qtUxD9U/1s1AkctndMG3wVnoJNnX/Xlk7jcDPl/pnv+4jnpkPr
rZo41N5kqvyUnIIntKdK7mdx2KMaItd5cArsyje5devicJ99m0Sv/BTEe3HF
cBrg8KM5bteQ4hQ02bz3XzXEQTpefMs/1Sl4FcW7g3wOB7+rueyTalPgd9Ze
6T8THLoUlFZmz0yBcsrXT/fO43Bk7ePM4tkp0G+6/trHFIfn9VojKwZTcHHB
JUbfDIc/kc1d6yZTsHqK8r6fkE/aWv5gt5yC+oH92crmOEQfHKzlsp4Cq9VD
D4l9DGYWnct57afAsEKGqUTI2lXzhfxOU3DMUGdHD/F+Uqh3xs4bU1DWnZOi
Rcg0C/a3InenwOmFV8A9wr6xeFiEmMcUdEd2xl0j/MueFgiW8p6CAv6Zr3sJ
/9nKEh8e8p0CH9XhuTgivktPpFwVnkwRfNtN+U3Ej50rdDr6bAruiK4V9ujj
wLNb1fr4C8JfldvcqUT+rv6rMoHXU+CbZDF4iMhvZbHuWc3YKVAM6BF8QOR/
h8/Pk7qJU/Bwk0ToM6I+d3QuHTFKnYK8j9FiNuo4fN0+csD0/RSE35qvXTiO
g9jAzT0X8qZg1KvPyVAFB+8cKr9N8RS4Gm1Yua6Iw6HTnOtOFUT+duRhkzJE
v+TkHvhdNQUq37MLJvbjoCRgbKL7ZQom/GMSUkSJ/I7Gph9qnYLgiIObVQRx
qDJWa07oIPIL2tcE+XDQKh9a5u2dgvsx6rdzuXAwCpfRn/s3BVdGCxTXVzH4
udR8z35qCvYqJ34vX8DA0s793c/5KVjuMP0mP4WBneLHeWyNyG8pR+LJXmL+
ugxjH/BPg0oqHZ8uxWDpDOXzxM5pSKOn2l4pxOBhXszkpT3T8OwAf9fLDAye
+A6oq0tPgxf7MT3eVxjE7Hf9y6Y+DfbC+1G8IzHfLwX57mlMA6Xgr2v9BQyS
aGWqf3WmId/mv325BhhkNbKF1ZtOw6fGh35vFDEoc406EnZ9GppULzI3rJNB
vUfVmnF7Gs5OzxyYmCVDtWZf0O170yB0SvFB8BAZGnZKdRn7EucDuvJGasjQ
++mDr2A08bwlYFUliAwsm3qa3lVNwxbRY791V0nwxN13ie/LNEQ+vXwva5QE
3H0Sov6N03DoZOArRNy//EU33a90TIM8avuxs4AEkhbrQtJT08AM3zfibkOC
s6li14p3zsCZB/s6lgqKQSl2i9QXkRmAcR3n+3HFIPqCPtItNgP1FHdyWWAx
rD5od9ggOwOpLF3HwiyLId/kma3lqRm4qS/l4rRWBNtZ580ZzjNgU8HpLnyi
CAYuV2nqls/AokynUcfufGgyz2e3RTPQpxASFD6cB6X68dVutTOAnYyM687K
g0iVe6cSmmfAb8uFFFWlPNDikz45OzwD3crH9gto50Ju5UvF6M2zEKZUtvub
RTZ47rksPmQ9C7tY3MdGFDLAwVjBotd+Fj7e/VIxN5UORoGszzudZoEbb/LN
zUoHqfG0+e93Z4HUcqRYYV86tGFjVeVPZiFHQocRzpUGCgZul6PyZsFR0+L5
ue/JMOYdlHB2bRa0j2iQhPViQXbKfHOn4RycU9uo4szvBqVmBui58Rw4Vblc
ski/DRqfzrirm85Bs6HHBjfx62D14nBPxoU54Cn3OBVx1BqeKXDn3rsyB3l6
x+rY2I3Rv3sf9fgfzMFw8sMeXNYbJTPEnxumz0FEcbuk89tXSNZJSJ31PfG8
5r8KA/1I9KGZj4Jlz4G4alH02mokak5auyhSOAfvLbbzFF+MQozTHQcny+Zg
6tTv8W0Cb5BV8LNvIT/mwNMrtLb7QQLazjfHVbs6B8q+vCcsH6Shn5+eP9Vl
zIHttlH3q3VpKPLmfo4fzDnY+KP62OFt6Yi/wYq9e8M8FCh1C8y9J+SgOsbs
lnmo/1MfwfozA22lx1N2S8zDIMlv9/GdWYhnVKvXXX8eouuCu1ut81BT9KDV
iuE80P0+zlQn5qEwzYddj43nwUrwzVet/jy0ObWo45n5PByy1W2m2+SjTTa7
W5Muz4NmENdBjgsFiOvXXF2j+zz48uQdrhQuQl/9QzVN7s+D8uYr27xVilCI
glRNh9c8cC9fXl00LUKcLy5VDfnMQ0LZ+9j9YUWIQ/dL+fLTeeAf+cXusFKE
NqC3hRIJ83Ar7otv/Zdi1H1SU2fg3TxYf+wMUBkqRoXlU4PxKfPgpXPOyZhe
jKxK1Pj538/DorIWm7c8CRXnD9xjIc1D2GjZh/gIEgo+FML7EZsH76tJlpBF
QtbZCpmeH4j4O4rynyIS4srw75z5OA8eiR4LLNMkZJsgcbyvfh4CeC4eeKJB
RkrCTT9jG+bBwO1uudIFMuKOvXfD7Ps85A/NzgfeJCPsdV1C409C35hmHf01
GW0OvcYs65uHkSay+imCjwa5tsZ6DM5DHdezs+2zBD8Flyr892cetH88uLeB
FUMOAdwOWWPzIL/vg9xhcQyVPsitjVkg4qsarH5/GUMvlk1tzi/NA/vZn6+Y
tzB0xWONyrsyD3bv5l2mH2Joi6vhgaD1efg2XC3/LAZDIzNUdIqVAo72K/zK
aRgqv/nuwho7BWi/nBbvF2LoqvPsM3duCnz4e6uY9AVDx/+9ET/MQwEBufHy
vFYMbXU8VTGxhQI2tmZbjvVi6OPlV1P2AhQ4bfRjN+cchiL7jgXt2UmBnHu6
wjorGLp2aXhPlxAFXpmFTAqxEXxsqXjOeB8FArcefHmb4OWxtp7RzeIUsDKj
ZswRPP3p/BO/ekkKGIhd2sUmhqPIFlmhwAMUOJX7MiT1AI6cjdqL1WUoICr1
NbZVDkfqTT56q7IUaKk7NvlCEUfb9aT+4IcpoFQpJN6tSuivb37oeoQCRzUS
B0hqOKrU8hSQO0qBipCVul1ncBRVsy9/TIXQZ6bpuVkbR9dPf9VKP04BJx/n
d891Cf3obv9lNcJfiSb2GAMcCagJee4+RQHW6rF7cudwNFH+ma/zDHG+TQUZ
m+CoStUlK1KLAic6jhQxz+MopoT/tJEOBTg1TAWPm+HohlJFF7c+BUxj+D8y
CbmqpT2v1JACrY26G43NcSR4a873mjEFbmE9zocJ2YV7s+kOUwrwm6+UJBLn
UcZ+qTpzCuSSfqF4U8KfM6dW3C9QQOLnW1Mpwt71fqsm8UsUuFoacOaUMRGv
t0dSqw0FrF3KrMcMifzsjHDzs6PAwtRdt736RD7JOVqHrxD11eo2HT5L5P9c
3a7+q4R+T6lWRU2iXlMDk2HOFEh7FlzOfwpH10JWK0/coIDb0H9Dj0/g6KOk
YOTELcI/DqaclzKOtn0+fDXuLgXkHom/W1fAUcWK4+ZlD6Kf7G8MkCRxtDXG
tz/DiwKxplvzBvfg6OqR+GKzhxTofLvp9dsdOOK78cOS5EeB80rrmaUcOHLk
nJCxD6QAC6fnD+F1DJWlbVjnC6bAjJIm9yYq0e+9x9JvhVLg9vvu9y+HiPnw
MvMUeUH4d1uCS6oTQ7yCd/QaIygQH43u6jZh6ANxOUvHUECZe95EBcfQZrRF
bSSZAnntZfqF/hiyu3Rw6+s0or7ewmoF7hjClzX+nM4k+mPRhHT8KoYuKzx4
lpRLAfU68z9r2hgip/xptyqhgOslCZ9DGzHEpb6exV1GgSj5/Jy3C2Rk073r
UWkFBfxfyP+MHyIjzu1G4js+U0DRWLpB+yMZXXpSeru1kQLul1weWhH3RZHo
r9N+zRQ4d1sl5qwlGW38NC1wuJWwd/qOQt1pMiqkileEdVAgsfiFrbsgGbFf
C+fUGSLya5trlvmBhHJ1HZIrlyhQs2Z8+uNoMVKSFVOHFQqUu2yVq/5ejCq3
DPYgOgXm/zjb3SQXo5ZfNjs/sywAD39yT4FPMVq0ufiiZtMCpGfbMZd4i5G6
m/Gjr3sXQL3/x/TaniJUb8YnrCu2AHcs3nYvrBUiY5XmD98kFmDO6Hme5qdC
5LCmv9AgvQDl3QaRMycK0dPgsy7fjyzAN/0tf33+K0At8eoXfmovwG43tflH
67noog+Del53AUZ8A5n2eC4avvzx9S/9BVhyvE4rvJGLFiWP/2gzXgA2S9KH
0I4cJFR4VLvTagEO6YY0Xs3IRg41skq9txdg/mu6ao30e0SdFN76L2YBrO1j
OR+1pKCoxNH6hLgFQNaPf6TcSUGK5zBf04QF2CfM5264JQW5kgxnq1IWYLjO
Pgr0ktG0l1/z27wFwBI1HZMfJKK/G/+FmVQvgKTE0y6zPW9Q+75i7k/TC9Bx
aGlytDMQ4aZn2aM0FyEl9kao3NFXEKJfGiRydhFEqzS2HF5/BdYaB7kydBfB
rh7THPoSCWyKm3lLjBYhdFZlg5ZlFBjx/9jx+8IiuPMkmwW7v4GxFgsZkVuL
INOKd7ZEJ4KwkZNJevQiPLLxCNYqSodprc5fsrGLIP1n+cmZzRlQpaZjgccv
gkUQe1XT1QxwkpO59CVpER4a2oz6CmUCmWfGcSx7EcYU8nvFHr4Hg0YPL9nK
RXjqYHz70v4c8NUJSsL+LQKUf7OU4CiEn7bO1grji5B1fER+q2EhSHroC+VN
EvGlBjH1XxdCQ8q212lzi6AoR7Vv21IEAvTE4MjVRVCTcL4wGFUEWfklt+5u
ocL8LdrhmRfEvlkTJzO1lQrLn78a3M4rBsPuR6PXtlOhRehP5tNvxUDh0LC/
vIsKlcI/sgLYSHDS7oeZkTgVDlz7yPS/Q4IW/rETsspU2DU9qrCsRAbxg420
96pUKDHgnMrRJ4MHFOASJ6ggP9mbPGlPBuGb9w7vPkWFnGvle7aFk8GxjkVi
kx4V3DTu3f7dR4aSnj8DQQZUMPzJ5BmcIwM35UsC6zkqmFRUSt5hx6Bgb/iO
FVMq0Gj/RYodwIDmKbRpzIYKPwpv7f/qjIHei7UvV+yoEJew3WjNE4PE9IHA
AQcqCL5LiyIHY3CmNYPRcY0Kxif7DLNTMYgaDSk/70IF8lMs+x/BK6OMG57N
N6nAq9VKTf+IQZjMkfk6Vyp0uCn/l9qGQf8pwYLT96gw1qe3aXAAg/8saS6f
7lPBKri6MmECg47AyhHsIRVcT4mfe7WOwcH4lBSFx1Rwl+Tz/MqJw6OiJ7Z5
flRgaPhs89lK8F+f3u+0IOL97n9HbQh+e159otA8hArbjzUI75XGgfJeNpgz
lAobhv/GaBzGwSp8j01ZOBV+0QgEPIpDtdsWpRsRVBBN6Q8pP4GDzAXmpj2v
qfBivX7XZoI/X6vNDTVHU6FKie1epRYOa+JDpX6xVDC/9vpAG8Gzjlw/Xx55
S4XpMv8qfYJ/m6arnUYSqeAtvNQkaYzD0V9ktZhkKlAfS67ZEjz9rjRdQCeN
CnVh3vtWCd7meBc9uZJBhT9KbdxLBI/fDgyuzs2igr4z74vzBL93OnvG2eQS
/bWTzZePkE8ZOd/lK6DCsNKLQlnifJbixbOfi6jAURROySb0bxXS2+tOpoKN
d6/wU8L+g/XjVMkS4vwTC3oN4d/wn0NNHaVEfFWdTnZ6OOh9E0kLqaDC5b0n
Fay1cSAV8HofryT65+VlmQ9E/MJR68ZTVVQw3bBX2vUkDgEPZg+8q6HCjdum
a8+UcZi0HVw/94UKpU2dD1gVcDDTbG1n/UYFi50NAZ1E/j8erM4jNxL2xnYc
4hHDQZKPHHi1mQpPrDwiknbhELaYZrWzlQp2TxNaXhF8vdgV9d+3X1TQe6bB
/WcjDjYoiOthBxUcvcUuvKZjIP/8Wkl/DxU6I20Lt/0l+PfOhfCIfir4zhxa
GPiNAdNM1/HMEJHvFJ5a3iYMWvYd4s/8R4UVr5HAkCIMVDeKjFuOE++36Ba0
p2CQPMFTxT1Fhf3j73oDIjFwxWdu3ZqnApdQBmK4YtAdP6C5b5Go17nUP412
RP/7texuXaJC9I1CdroRBvz6pG9Ka1QI0rv+z+cgBtigx/41jiVoun2DLtZJ
BpEvTmv53Euw/81yLftnMgTlWv66zLME3VHuo7o5ZLC4f8y/ZtsSpHHl/t3w
kAzLmxm9z0WWYLU4JuO0IBns5qfJJ/ctgUY7n+d5gqe/dvQ/nxFbgl2bZAsb
+0kQm1Klev7AEgSVB5xczSDBcZUnUUJHCPu4iKy1HAk6HISUE5WWYCjCeugf
HwncXxR0iqoswebPk+mU+WLI+/tbWPrkElxyPIG9xIphb5RcirL2Eqgf/5Qw
p1gMbPMd+aZWS7C9R4pJ2V0E70Runuu0XoKfrtNsNdOFcEKHdd7q8hI8ctST
KE8thHtJh5QcHJegv8PeicFdCP8M/crv3l6Cnrr73zma86Ex52B9eMAS1D8V
2tEqlwvOHZXO24KWiH0qt0K2Iwc2sJltin66BFcTphs+++SA+sXHhglhhL2h
7wXJDdlQxPnrV07MEjhpt2jfupQFUY6PButzlkApVC5N51IGWO/9scL6awlO
6wUF/GhMhC1CbnhF+xI8m91csWs4AT5vF3T1+L0EG9cCC4yX34IU96Wxsb4l
UN2kdDtnbzzMLvzr+DG2BEbyHGNt9jEQ8G2dnLhO1Gud81uQfzhk3ZO/fUxm
GZxNre8vVxkgqzutBxdkl4l79JFPxEFbxOty72/e4WX46BaUV77ihNwul1uL
Hl0GtfLp4SF7d3RCT1uf89QymCc6qitH+aPmfbbS7ebLMJMm1SSXGoGoDeHD
d/2XAVgW8sJHk1Dv5nbntcBlOBfSYB7kkIyqDURmnwYvg2nc4mBzSzKKaM6h
vwtdBgb/fw2LuSlI5me9wPfoZaBsqnl3wDoN2Xaxnj2Ys0x8X3N/3p2SiTSF
db9jectwUSwgY4TjPTp0KcL0VOEyiPzT72K5+R7RevfaWWLL8OXbpXv7lbJQ
5OCJB0GVyzA3fc4NVWSjL6MeuUM/l6Hua2nwpYw8lCf96b9b7cuwcDCSt3E9
D72+vqGU1rkMliotvy5a5iO7ychavr5luHbNy/vrxgK0OlPYpza6DA8fjf94
ZVmIBg8vX/k2vgxtR3Y9SMsuRPV31SfMppZhn6Yd+8fVQhRFaVq6Mb8MS0k0
c7pBETq8NM4XT1+GKN4NruL/itAOlf9i9q8vg8zrBwKim4vRmqeXSDELDdZe
KAjFHC5GDSscB79upMEmo0+Vf+8XI0eGxJklPhq85f/XPLVejGI32N47L0mD
m1tk8gIXSGj9ys6jrVI0aLPhihveQkaONS3UcwdpwHphyinvIBkpBGh4GsrT
gFmS5/TIhoy+MqW9dVRpcCjPSn3uExnJXx4+Xn+cBvcuVeWEtJFRVOVbupYa
De47iC8ETpCRnc8WH40zNJgGfbZkAQwtry74qhvQoIqkHnjBHkPWVvmnPhnR
oCcuWpXihqHqMifWkyY0OHf967uxQIKHvboCjlkQ+p795zxG8O1iZ6RG6QUa
GFcmnZojYchKxWCDyiUafE27iJl8xpDUUmWQkh0NQha4L+wleDbM3Eub7EAD
icrKTSFjGKJg/3EeuUoDzeeBsTqLGLogMFlfdI0G/z4yIy4zMVTpnh5y2IUG
XBXdgU3cOJL8ZaNbcJMGmeMVLC+34+j5kZ2b5O7QoDJf702mCI7mXrU05LrS
wOimfCf/fhxZzD8LlblHA5PnW4x/yRI8ZaxhkH2fBvU3I1+NEjwrXrTGI/2A
Brle9ofOHcdRCF/J98yHNKDzS+RzEzw2c/vOi/2PaYAnP87coYUjs2bpc+l+
NGgP3v3eg+DXcrlhPolAGljJpKhLEfwnGv62JSWIBjBXsnaA4MOgKbNXoiE0
CFDb4OpN8OOE/pbzSc9pYKn47dAegjeNc+v594bTYPSGwjDx/YpKNvn/SnhJ
AzXPaz7//z+DiMvxqN2RRD+wqE+MEOcDvi2YxUfRYD8WKFhP8OmYdL6g0BvC
/5NcUzSCj41CnDrexNGgX+utlTfBz9jovjc7Emhw/CGPkT7B18Jnuyyj3xHL
R8gh8g0dHPllRu4SSCHqt+vr/R4NHP3baNAVmUaD9Y7ioHh1HBlc3Ri/LZMG
FXdKm7II3ifVVlpFZNGA7UWuKscRHO2S9NrNl0sD/T6rEpIMjh4H/tcbnk+D
rdwxRwrEcTQyPJHAU0SD7x9l42lCONI7k24TSqLBStpM16utOCpKsdm7CadB
2tzGvw8IHn1k15LEWU7462mkqjKHoWH0zC74Iw2mdujs5R3BkM4+DbGNiAbz
Lw5PHiH4c3s/nspWSwPJ3/887lQQ/cnj4/PhCw1Ug048OZGLoU0nNC/c/Eac
94S+Y/EYYov9ydvRTMyn+Be2Hx4Yevwlbux5Kw3izFnjnBwwtLpoVwNtNPCq
tuY9YkT0p8msV3YXDaLhr4STBIZu+5WY2vbSYG9Dw8sfPBiaKPCR3z5Ag12y
px7eppLR0GaekUcjNPB95MhhXEtGLXXS54xnaTAiNP6n/AIZGSzOHtxIocHA
p+BbYyeI+RX/sKF8kZi3R3u8z+8lI+SrVS6xSgNbk0P5A4MkVHDMYf/yhhVo
9X7oumxNQmH5b+mJwiuQQFIY4DhSjLh6HTrO71mBF09XjT25i9GTTTLFnKIr
UPWYrVh5sAg9vFbq5Lp/BSwi+NH70CLkItbeqqlAPJdwNVvACpFO9JasSa0V
oIi0Ue+T8lBtTXtAss4KzLyT35BmkIdOURJszPVXoMWX607K31ykcu7QdmS8
Av/SAzgkBXKRFLfO48hLKxCdksH9/ko22ujjb3bMdQUabvr5q7ZkIGx+agW5
r4DoZJ+9lX0GcnS6kKR9fwWol1xtCufTUe25wxOmD1cg61CtMuvWdPREvM/3
dtAK8JdVxeZopKINX1Vz0+JWYH3qu9cOwUTEtn2OdUv1ClSiqGf3fzxHpKeX
3kfVroB1xDPxrqYQgo+/GOyuX4EwdbcqsW/BqPpv4hvpphUIMU4zKqgMQAGl
+nIaHSvEvkihvAQPxGr7/oLXxArI3dBJjGh3ApZs28Jh/lXQvLYn4PLu1/Bl
qvN2kuAqPHlo2ar2XxSEKZjIW+9ahVK6CZ+ldjTsLNXIb9+zCmv8Ij1ct9+A
fL107lfpVUBOfPp8pLdg/ZeSWaC+CrGK7BunWVIJvrrpdOP0KnCcW/v+IyAV
xm7+3S+tuQoqG8lSM+xp4L7YmZ6iuwrVV/Oe1bGnw3P2T6lRZqsQ/npBVGUl
A8rEnr7zdlmFxZqcU5tLsuHxVRZblVur8KVDhP+fdA5oZj/Ys3iHeL4cvJQU
nwMtCjcTbnmsgtqS/91471wYA5N4O79VqBHhs+OXzYeCwIaLewJXYSNLXLFh
dD7cq9cQ6g5ahQiNrFo1Rj4wjZRjTUNXIbvhTNuBbwWww3Z3jHbMKpz1ng7X
ky6C3pQoc/a4VbDQ7Vp3tyyC1L+8glVvV8FL+kfGn6AikLvFEnUsZRX+JC20
hA0Wgeajv69k84j4lSuNvoUVw6YqW5PxglUY007dPYoXQwv7762Zxaswz4Pi
jvUXw6XQhpf7PqyCj1PZqLssCdziC8P5q1fBhfHjMhsiwYe1+KfVtavgwDXd
OzlIgjXbYH+3+lXAQuz+Y2Mjw1MJG4+fTavwSyq2rOA0GZqCdO4E/FgFrT9s
8aftyMA/pnj9yE9C//ltuas+ZEjI22QT2bkKN4KdSn+XkGFoy5LFme5V6B03
tV9tJYOU65AxpXcVCjYoR52YIkPR0VLN88OrwJ0U/HPHXgyob9LU2f6ugnLA
y3sFRzE4vvpClTS6CmKnHQPsDDCoq7wqyz+9Co/Ktu/jI/h2k5iJVPXsKvhn
IgPuUAyMA0+KulFWIbSjS0LoHbH/n90u8HOZqK8TfbPHZwz25azzBqyuQuLq
r4rKVgwceSY4jzBWoVD103mhIQxmWqror9jo0JesUrK2hoGiYh719EY6bHOQ
Hg7kxsEr+s3sPCcd5kJeP9wliEPlcsB4yiY61D2w/122Dwd2q9t/THjp0Bzr
bXTtIA46Hy/2sW6lg5levaLoERxe7NXqLOanQzLlcP+fYzj88lNotRekA4Wa
kFZ8Coddf3Y3bttFh6jSpa4QgudstDjrPgvTofHd/k5nfRxS31MqXfcQ/vHw
zxufw2GUu79UTJQOW6+l+5wi+FH25jdSqzgd0nk2dCkTfOnajOX576fD58my
IkWCP0sUkjP/k6aD2BPuif///rwWGZo8JEMH3k8nbpwizp+m3o9/JUeHJp84
YWNCX7ClQ9RpBTpk5t/ov0rYayozfDF/hA5DivQEf8KfbSLHQlKO0qF+OeJk
GuGvxWPJABNVIr5Bj7QGIp63g3yPWE/QgdxO+bBMxDt4hu5RrEYHnUpjOxki
H/sz/t2xP0WH9/6/AxyIfLlw/ry+TYMOOzl/bUwm8ll4/dOVz1p0MO016x8W
IPiyMcvGVYcOdO8DDoeIehyXj7IU06eDxJtiXm+iXr4RviathoS+3642P2Yw
qKW46Psb08Fi9N/3Q4NEv5hbaP1nSoc1l5c9L1swiBKSO/bqAh3i7npU3S3A
oOvhLsXTl+igcKYoYuYtBnv72eXmbYj6SwvNeYRgkJXaLWpyhQ6rP+4Ypdli
ML3hizCrEx1kVC9p6+lgcORasUCxMx0kv6X1rClg8OlQCNe223RQ6uGeDGGS
Qblt5/fIu3RwUemIlhsl+v/R+1cC7oS9atGjrM1kSP3+RXiXFxGvU1KrahwZ
Qu5slNsXQIcwuv5GNikysO6Knk9+QsgD/J3KnGTwrpIsEX9Kh8jlo+9SRklw
a5smSIXRQXtJrV0kkwTnyQEmcjF0uBnsiH8XIkHjJf4dhbFEfUrUdH4tFoPm
htRuhbd0gGeP/uz6UQwq5p+vKCXTwX5iPOq6fzGILDM9TuTQ4dGtipfafUUw
etwnXreSDtf23JXz/VcAdn94LjdW0UF+1Yt9OqgAukMTJAxriP7h62nklSyA
pt6KPOOvdCh9e/bJfet8ID1erbT8SYfsu+wcepW58Kja88/Vf3RwDr8fl6Cb
Bdv03GQDtqyBSxYucO9dMiR/5tt8fNsaZIum8D3blgwKx/LH57evQbVaxJ0n
nElgJD2WaS+0BruvW/h4NybAcw5bsdOSaxCTKsmrfjoWNtTo7mA5vgbnaRsO
Og6Fw9IJMZbHVwn9DZ9Wzw3dRUHkyv6jzmtQIHWwMZLkgQQOWX+adlmDZmuO
GvlAb6Qo/Mbb5u4aeDfOWpZvDUB3aTzUkw/XgK7xiJKeEYrGMdo4PWINMoVr
SnadfYN65Vp+Pfi4BlP79MVOJ6WjpMltPuxoDTgc/xx6tDcDOWSbSoV/XoPD
LWhDY0IGGpfs9Er+sgYq+049C4vJREu7+/fUt6zBrWfr99d8stC2TVPXBP6u
gcOt6c5HO/NQW73ctneja6DLt6fqRFAeig26U35gYg3iBr9TSfN5aC/rAs+J
2TVQ3laWg3/JR7K0lWL7lTVQKxoYemhXiLT/ca4V8DIgi5K3cPZAMeJO181Q
3cqAd2Wx2qXni1GTfahRNT8DstPpvjY+xci0b0tK+04GXHQK5FBvKUZ2bYLa
a2IMqOEX37j7JglJRlrOBkkywMXDSH4pgoRGz8XF8h1gwCMZg/VFjIRuN4pM
issyoOpcZKf5Kgk9rJaI0FVmQKOJxeb73mSk7nf12C9VBqzJJT1RiyUjNvX3
w9YnGBDylbptN05GIWUyR++eYgDtXduvbVPE/ud5s3/lDAPktwx9OsCBIb6j
BU8DtRiwP5X9gOE+DMUU/dcdo8eA+5ubRxGxf1687R4oasiAFzfSLTddxZCI
LC6bc44BEw/+y7b1xlDae1XfT2YMKAhWJoumYsjpqrf0WUsG5Cy/MgjDMCQj
8bG15SIDpNdcnjHqMFT0DiRHbIl40q0Lp/5iaMF7gdPengGY/nkucYK/lC3f
T/ZdYUCDuALuwIojL8VLP6ycGPC7cXdJPi+OKvj4yJ3ODPg0dnwzG7HPr09W
x5jdYEDilVzMVgJHp77e9269xYBf33ybqgneCkyXsTW6y4CZ6fo2uaM4+uLX
f7rRjQHG7Oeck07iiMsmcr+OBwPs1AbFdhL8oX9Mm7vOkwFPf2gnRBF88kJw
deq0NwNkpw3ddhJ81TKf31L5iAHkb1XqSQRfbW+2x074EudjXRIOETxkkSMY
W+rPAJ7wHVIfCV6KDf728OgTIh/dL+////e/Hgefy6RgBnzDUqTHiOd74T+N
w88Y0Gy0szOAeN9u91+pvFAGiPVWiIgSPJW2HLvp4AsGnBD1iUKE/X+/DGYy
IhhQG1S40Z7gP+kilp/irxnga1actEETRzfCMDwpmgH9EJaco4ajAmfnOJFY
Blyg62qbKhN8qiniExfPgOvHF5vX5XCkKNZityORAY+LorzyJXF0nxGo+TqJ
AVu3HfW/LIyj0i4V6a2pDEjgG5AS5MMRHZ/cHJ7OgLDLCe+b2XCkHpk0y/2e
AdbY/dNhVAz53Tb9FZxN5OOz5xGjUQxxHKiI9ytgQO5PAf7Begzpst95zChi
gNxznsdFJQSPD4g7eJMZMLrd/FFwOoa2xT4/eK+UAUO/pXK1fTBkdk+dd76c
ASq3NNOPOBP9aUyZu/WJAa/IkWUHzhP9yG1Veq2aATZcE98UCD66/Jc3YaSW
AdQ7T8O1N2Eo9fNnX/t6Bnw+8XjdeY6MDngfPHupiQHHSckPOsvI6Mgkrd2o
gwFWIvcP3ztNRh71eWWNvxmw2+h8IbcYGZWm2SXq9DDA6DlbIsYkITXrr45n
BhngUSkxaFxOQjrf3ywcnWCAgrVu13dJEnqerd9JmmLAEenMt8cYxeh7ELP8
8CyRfxU7rvq2YnRe/VrAwUUGFFYoMA38i5FNofK2PevE/ND7bY62FKESK9qW
FpZ10Dzx2+5vYhHawlHOE8i+DlutwtNSXIpQlbUa1zjXOuwp/9Woy1qExDdp
MrHt6+B8vqta92wB+udoMm1wcB3u3aNpCj7OQepbt08yD60D/cyV6AJGNnpT
0TZGkl+H5QP1ctUPs5EO/4WRXUrrxH7tE+LunoVykG3PiPo6lJV/zEQmmei2
8M1vj8zWoXbzzGphSwr6UidXf9hynZjfE4IOJ1LQPtfZ2uGL6xDqM5LFlZGM
WurdqnQur8PitJ/o+4l36IjHgw8CLuvQVJi8OUcwHi3/CM7I812Htzf0Od6L
RyC/oBT/3px1aJs03Lzw1hV4PTn17PPXoeBwH+/grfsQ73yL/1/hOrhUhDRu
hodA1j+WNoutQyzlfcHWOwHwb1trLRtah/w4eb6DG8JA/x0L18Ff63Dy/bc6
HY838PulU0t++zpcv5glaZgUC47+TbFHfq8DzXrpi8TXOHjsGHvwZN86kB8r
bOLekQBFMgr650bXgVOmh+5jnAw7Plx+4UFfB2zPSx02cjqkZdVZrDLW4XXk
bCj1eAYoxB/a58vCBLcioeDOzxmg67NcGLKRCZ9oDsm6TZnwSONl61s+Jvzd
KZ6151cWDP+oFKiWYELoO9ELt1Lz4M5nyT5tKSZQ9v7LownmwxrpeUajNBOe
V5VQ2UPyQTDGQrldjgm1NL5g/2sFoGM9YzmmwoQmkUFdnLsI8sf2vN1iwITf
ikbb2wieCUkMsus3Is77x3SfrSwGx/PT+wtMmLBqtrQ/cobYRz5+LDK0ZMKz
1d6ot/okoN2VvL/HignVIR8um3qR4Nf+sBPT1kzQnjlm+CuNBM9fXvoS5sAE
tjXTjn3LJHDSrAm1vsqE2L6LSf/2kuHMioyJrDMTIppW+q9rkWHFYbWn8RYT
zmuNiMS/IEPbToeUt3eZ4MOVqHO6mNjXmr453XBnQrt+k1bcTzI4K8fNb3rA
hBMGtyyMt2GgOcnyofshE7ZfOZ+bI0/wRrLzo5zHTNg1dmhvnh4GHdyqnHpP
mOA09Uou4TEGpMqkJqGnTPDS4CYFx2Dwwp0zcvwZE8xK9SS35mOg1dch8uwl
E9ZyWFOX2zEQjVQfvhDJhIMG9tEmYxisaWe+l45mwpcNwY/OrGDwm857i/aG
CV1+V0W/ceGAFXkc+RrPhE17DJ1GduAQcbVv+U0iE9iVnyu+lsDhhrDWp2vJ
TLgu7XKrTR4H7R95ASppTJgwPr6SqYqD+BMBHc5MJhzh0fnIfRqHddVHvJ1Z
TBgtGXxLP4tD1/Sfn5m5TCjMN/F5+P//j6bqx94vYIKK4ZhWiAlhz5Jso13M
hOgInEWM4IubPLsldmBMUBwYcdAi+EPnc8DY3xIm3LbhNKESzyXvT+TjZUy4
oVRQqGCKA1PmvHvQRyYYhbtcWSb4o3ugTNUcMeHYq+/GugR/lESJrUtWM8Hw
urO1lBYOkbrPahZrmVCg3uTyQg2H2+tzIbX1TPA//tzOXwkHPfIFo6gGJowF
KYozCd7Y71y13fE7Ezb/2Z/HuRcHlj3SXYotTDigVpjydisOva0v37H/YsKp
197TFaw4lAYvX/nVTvhfd9/7+jzBDycuH0z7zYROUqRixgAGd+e+zLj1MGHD
yU/sd5sw0M+Qx870MyH+1N/2hg8YSFnFPOAfIuJLXokqScGAjW9dffgPk7gv
xw8pPceg3Ov7N/9xJghEG8aPWWAQI3f0pckUE3QrFFbETmDgOpxgJjZLxL+h
9xVlDwbSBjcHqhaZEBVGV7IfIMMG1rb0iGUmqG7PEmOvJMMgfsLFbpUJLPrh
PJpvyfDRJe2wAoOYT8v6f/s9yfBm32Yqk8kEX2u3lBwTMvwPPteRmw==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 2}, {-0.08333321662740939, 0.08333322293399573}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181735067106*^9, 3.5181735672536*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"theta", "[", "t", "]"}], "/.", "dsolution"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"2", "Pi"}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181734488775997`*^9, 3.5181734488796*^9}, {
  3.5181735116236*^9, 3.5181735311116*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVk2k41AsDxbOEm2YsabGFGiKSupTInP+NUiKvpVC2st28ZbnaKIlmkL3S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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 2}, {0., 3.8197184782986073`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{{3.5181735043596*^9, 3.5181735289426003`*^9}, 
   3.5181735692546*^9},
 AspectRatioFixed->True]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 226, 5, 31, "Input"],
Cell[786, 27, 2287, 73, 132, "Input"],
Cell[3076, 102, 359, 10, 52, "Input"],
Cell[3438, 114, 441, 12, 112, "Input"],
Cell[CellGroupData[{
Cell[3904, 130, 857, 23, 112, "Input"],
Cell[4764, 155, 465, 14, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5266, 174, 701, 19, 92, "Input"],
Cell[5970, 195, 845, 28, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6852, 228, 345, 10, 31, "Input"],
Cell[7200, 240, 22580, 377, 240, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[29817, 622, 345, 10, 31, "Input"],
Cell[30165, 634, 21877, 365, 225, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[52079, 1004, 442, 13, 31, "Input"],
Cell[52524, 1019, 3817, 70, 243, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

