(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     86245,       2015]
NotebookOptionsPosition[     84039,       1939]
NotebookOutlinePosition[     84599,       1961]
CellTagsIndexPosition[     84556,       1958]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"<<", 
  "\"\<C:\\\\Users\\\\nathanael\\\\Documents\\\\Barhorst \
Work\\\\New\\\\Notebooks\\\\math\\\\Next\\\\genkin.h\>\""}]], "Input",
 CellChangeTimes->{{3.5181736103606*^9, 3.5181736185576*^9}},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cx", " ", "=", " ", "i"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"cy", " ", "=", " ", "j"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"cz", " ", "=", " ", "k"}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{"The", " ", 
    RowBox[{"positions", "."}]}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Pos", "[", "a", "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"l", " ", "cy"}], " ", "-", " ", 
    RowBox[{"w", " ", "cx"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Pos", "[", "b", "]"}], " ", "=", "  ", 
   RowBox[{
    RowBox[{"l", " ", "cy"}], " ", "+", " ", 
    RowBox[{"w", " ", "cx"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Pos", "[", "c", "]"}], " ", "=", "  ", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "l"}], " ", "cy"}], " ", "+", " ", 
    RowBox[{"w", " ", "cx"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Pos", "[", "d", "]"}], " ", "=", "  ", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "l"}], " ", "cy"}], " ", "-", " ", 
    RowBox[{"w", " ", "cx"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Pos", "[", "g", "]"}], " ", "=", " ", 
   RowBox[{"0", " ", "cx"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181736207896*^9, 3.5181736207916*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"What", " ", "we", " ", 
    RowBox[{"know", "."}]}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"AngVel", "[", "car", "]"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"theta", "'"}], "[", "t", "]"}], " ", "k"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"AngAcc", "[", "car", "]"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"theta", "''"}], "[", "t", "]"}], " ", "k"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"Vel", "[", "a", "]"}], " ", "=", "  ", 
     RowBox[{
      RowBox[{"va", "[", "t", "]"}], " ", "cy"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"Acc", "[", "a", "]"}], " ", "=", "  ", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"va", "'"}], "[", "t", "]"}], " ", "cy"}], " ", "-", " ", 
      RowBox[{"2", " ", 
       RowBox[{"va", "[", "t", "]"}], " ", 
       RowBox[{
        RowBox[{"theta", "'"}], "[", "t", "]"}], " ", "cx"}]}]}], ";"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
    "The", " ", "acceleration", " ", "of", " ", "a", " ", "was", " ", 
     "derived", " ", "in", " ", "a", "\n", "previous", " ", "example"}], 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5181736220076*^9, 3.5181736220095997`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"The", " ", "Kinematic", " ", 
    RowBox[{"Equations", "."}]}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"veleqnag", " ", "=", " ", 
     RowBox[{"RigidVel", "[", 
      RowBox[{"a", ",", "g", ",", "car"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"veleqnbg", " ", "=", " ", 
     RowBox[{"RigidVel", "[", 
      RowBox[{"b", ",", "g", ",", "car"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"veleqncg", " ", "=", " ", 
     RowBox[{"RigidVel", "[", 
      RowBox[{"c", ",", "g", ",", "car"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"veleqndg", " ", "=", " ", 
     RowBox[{"RigidVel", "[", 
      RowBox[{"d", ",", "g", ",", "car"}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
    "A", " ", "list", " ", "of", " ", "what", " ", "we", " ", "want", " ", 
     "to", " ", "find"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"vsolutions", " ", "=", " ", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Vel", "[", "b", "]"}], ",", 
        RowBox[{"Vel", "[", "c", "]"}], ",", 
        RowBox[{"Vel", "[", "d", "]"}], ",", 
        RowBox[{"Vel", "[", "g", "]"}]}], "}"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"velans", " ", "=", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "veleqnag", ",", "veleqnbg", ",", "veleqncg", ",", "veleqndg"}], 
        "}"}], ",", "vsolutions"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"NumberOfVelAns", " ", "=", " ", 
     RowBox[{"Length", "[", "velans", "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5181736236366*^9, 3.5181736236386003`*^9}, 
   3.5181736743806*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"The", " ", 
    RowBox[{"accelerations", "."}]}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"acceqnag", " ", "=", " ", 
     RowBox[{"RigidAcc", "[", 
      RowBox[{"a", ",", "g", ",", "car"}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
    "We", " ", "really", " ", "only", " ", "need", " ", "the", " ", 
     "acceleration", " ", "of", " ", "g"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"solutions", " ", "=", " ", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{"Acc", "[", "g", "]"}], "}"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"accans", " ", "=", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", "acceqnag", "}"}], ",", "solutions"}], "]"}]}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{"NumberOfAccAns", " ", "=", " ", 
     RowBox[{"Length", "[", "accans", "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5181736287886*^9, 3.5181736287916*^9}, 
   3.5181736768416*^9},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mass", " ", "=", " ", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"inertia", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "12"}], " ", "mass", " ", 
     RowBox[{"l", "^", "2"}]}], " ", "+", " ", 
    RowBox[{"2", " ", "mass"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l", " ", "=", " ", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"w", " ", "=", " ", "1"}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{"Now", " ", "we", " ", "say", " ", "there", " ", 
    RowBox[{"isn", "'"}], "t", " ", "a", " ", "force", " ", "in", " ", "the", 
    " ", "y", " ", "direction", "\n", "of", " ", "the", " ", "front", " ", 
    "wheels", " ", 
    RowBox[{"(", 
     RowBox[{"no", " ", "brake", " ", "applied"}], ")"}], " ", "but", " ", 
    "the", " ", "\n", "following", " ", "allows", " ", "that", " ", "to", " ",
     "be", " ", "changed", " ", "easily"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"famax", " ", "=", " ", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"fay", " ", "=", " ", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"va", "[", "t", "]"}], ">", "0"}], ",", 
      RowBox[{"-", "famax"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"va", "[", "t", "]"}], "<", "0"}], ",", "famax", ",", "0"}], 
       "]"}]}], "]"}]}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
   "Coefficient", " ", "of", " ", "friction", " ", "times", " ", "the", " ", 
    "normal", " ", "for", " ", "the", " ", "\n", "rear", " ", "wheels"}], 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"muN", " ", "=", " ", ".1"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181736312696*^9, 3.5181736312716*^9}},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kinematics", " ", "=", " ", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"velans", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"accans", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Fa", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"fax", " ", "cx"}], " ", "+", " ", 
      RowBox[{"fay", " ", "cy"}]}], ")"}], "/.", "kinematics"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Fb", " ", "=", " ", "Fa"}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
   "The", " ", "next", " ", "two", " ", "statements", " ", "say", " ", "that",
     " ", "friction", " ", "opposes", "\n", "the", " ", "slip"}], 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"Fc", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", " ", "muN"}], " ", 
      RowBox[{
       RowBox[{"Vel", "[", "c", "]"}], "/", 
       RowBox[{"mag", "[", 
        RowBox[{"Vel", "[", "c", "]"}], "]"}]}]}], ")"}], "/.", 
    "kinematics"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Fd", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", " ", "muN"}], " ", 
      RowBox[{
       RowBox[{"Vel", "[", "d", "]"}], "/", 
       RowBox[{"mag", "[", 
        RowBox[{"Vel", "[", "d", "]"}], "]"}]}]}], ")"}], "/.", 
    "kinematics"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"theacc", " ", "=", " ", 
    RowBox[{
     RowBox[{"Acc", "[", "g", "]"}], "/.", "kinematics"}]}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{"The", " ", "force", " ", "and", " ", "moment", " ", "equations"}],
    "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"feqn", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
      "Fa", " ", "+", " ", "Fb", " ", "+", " ", "Fc", " ", "+", " ", "Fd"}], 
      " ", "==", " ", 
      RowBox[{"mass", " ", "theacc"}]}], ")"}], "/.", "kinematics"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"momeqn", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"cross", "[", 
          RowBox[{
           RowBox[{"Pos", "[", "a", "]"}], ",", "Fa"}], "]"}], " ", "+", " ", 
         
         RowBox[{"cross", "[", 
          RowBox[{
           RowBox[{"Pos", "[", "b", "]"}], ",", "Fb"}], "]"}], " ", "+", " ", 
         "\n", "\t", 
         RowBox[{"cross", "[", 
          RowBox[{
           RowBox[{"Pos", "[", "c", "]"}], ",", "Fc"}], "]"}], " ", "+", " ", 
         
         RowBox[{"cross", "[", 
          RowBox[{
           RowBox[{"Pos", "[", "d", "]"}], ",", "Fd"}], "]"}]}], " ", ")"}], 
       "[", 
       RowBox[{"[", "3", "]"}], "]"}], " ", "==", " ", "\n", "\t", 
      RowBox[{"inertia", " ", 
       RowBox[{
        RowBox[{"theta", "''"}], "[", "t", "]"}]}]}], ")"}], "/.", 
    "kinematics"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181736323996*^9, 3.5181736324016*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "The", " ", "three", " ", "force", " ", "and", " ", "moment", " ", 
    "equations", " ", "contain", "\n", "three", " ", "unknowns", " ", "theta",
     " ", "double", " ", "dot"}], ",", " ", 
   RowBox[{
   "va", " ", "dot", " ", "and", " ", "fax", "\n", "solve", " ", "for", " ", 
    "these", " ", "unknowns"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.5181736350266*^9, 3.5181736350285997`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"thesolutions", " ", "=", " ", 
   RowBox[{"NSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"feqn", ",", "momeqn"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"theta", "''"}], "[", "t", "]"}], ",", 
       RowBox[{
        RowBox[{"va", "'"}], "[", "t", "]"}], ",", "fax"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5181736363206*^9, 3.5181736363226*^9}, 
   3.5181736963076*^9},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "thesolutions", "]"}]], "Input",
 CellChangeTimes->{{3.5181736377656*^9, 3.5181736377676*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["theta", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
     RowBox[{"0.`", "\[VeryThinSpace]", "+", 
      RowBox[{"0.3157894736842105`", " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["theta", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
       RowBox[{
        SuperscriptBox["theta", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["0.02526315789473684`", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"va", "[", "t", "]"}], "2"], "+", 
             RowBox[{"16.`", " ", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["theta", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], "-", 
         FractionBox["0.02842105263157895`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"4.`", " ", 
             RowBox[{"va", "[", "t", "]"}], " ", 
             RowBox[{
              SuperscriptBox["theta", "\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"20.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], 
        ")"}]}], "+", 
      RowBox[{
       RowBox[{"va", "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"0.631578947368421`", " ", 
          RowBox[{
           SuperscriptBox["theta", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         FractionBox["0.0015789473684210517`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"16.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]], "-", 
         FractionBox["0.0015789473684210541`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"4.`", " ", 
             RowBox[{"va", "[", "t", "]"}], " ", 
             RowBox[{
              SuperscriptBox["theta", "\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"20.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], 
        ")"}]}]}]}], ",", 
    RowBox[{
     RowBox[{
      SuperscriptBox["va", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
     RowBox[{"0.`", "\[VeryThinSpace]", "-", 
      RowBox[{"2.3157894736842106`", " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["theta", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
       RowBox[{"va", "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "0.631578947368421`"}], " ", 
          RowBox[{
           SuperscriptBox["theta", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         FractionBox["0.011578947368421053`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"16.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]], "-", 
         FractionBox["0.008421052631578947`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"4.`", " ", 
             RowBox[{"va", "[", "t", "]"}], " ", 
             RowBox[{
              SuperscriptBox["theta", "\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"20.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], 
        ")"}]}], "+", 
      RowBox[{
       RowBox[{
        SuperscriptBox["theta", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["0.02526315789473684`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"16.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]], "+", 
         FractionBox["0.008421052631578945`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"4.`", " ", 
             RowBox[{"va", "[", "t", "]"}], " ", 
             RowBox[{
              SuperscriptBox["theta", "\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"20.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], 
        ")"}]}]}]}], ",", 
    RowBox[{"fax", "\[Rule]", 
     RowBox[{"0.`", "\[VeryThinSpace]", "-", 
      RowBox[{"1.8421052631578945`", " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["theta", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
       RowBox[{
        SuperscriptBox["theta", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["0.052631578947368425`", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"va", "[", "t", "]"}], "2"], "+", 
             RowBox[{"16.`", " ", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["theta", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], "-", 
         FractionBox["0.08421052631578946`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"4.`", " ", 
             RowBox[{"va", "[", "t", "]"}], " ", 
             RowBox[{
              SuperscriptBox["theta", "\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"20.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], 
        ")"}]}], "+", 
      RowBox[{
       RowBox[{"va", "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3.6842105263157894`"}], " ", 
          RowBox[{
           SuperscriptBox["theta", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         FractionBox["0.015789473684210534`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"16.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]], "-", 
         FractionBox["0.015789473684210523`", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"va", "[", "t", "]"}], "2"], "+", 
            RowBox[{"4.`", " ", 
             RowBox[{"va", "[", "t", "]"}], " ", 
             RowBox[{
              SuperscriptBox["theta", "\[Prime]",
               MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"20.`", " ", 
             SuperscriptBox[
              RowBox[{
               SuperscriptBox["theta", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "2"]}]}]]]}], 
        ")"}]}]}]}]}], "}"}], "}"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181736991015997`*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Initial", " ", "conditions"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"vanot", " ", "=", " ", "10"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"thetanot", " ", "=", " ", 
     RowBox[{"5", " ", "Degree"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"thetadotnot", " ", "=", " ", "1"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5181736408616*^9, 3.5181736408636*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"numsol", " ", "=", " ", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", "\n", "\t", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"va", "'"}], "[", "t", "]"}], " ", "==", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"va", "'"}], "[", "t", "]"}], "/.", 
         RowBox[{"thesolutions", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}], ",", "\n", "\t", 
      RowBox[{
       RowBox[{
        RowBox[{"thetadot", "'"}], "[", "t", "]"}], " ", "==", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"theta", "''"}], "[", "t", "]"}], "/.", 
         RowBox[{"thesolutions", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}], ",", "\n", "\t", 
      RowBox[{
       RowBox[{
        RowBox[{"theta", "'"}], "[", "t", "]"}], " ", "==", " ", 
       RowBox[{"thetadot", "[", "t", "]"}]}], ",", "\n", "\t", 
      RowBox[{
       RowBox[{"va", "[", "0", "]"}], " ", "==", " ", "vanot"}], ",", "\n", 
      "\t", 
      RowBox[{
       RowBox[{"theta", "[", "0", "]"}], " ", "==", " ", "thetanot"}], ",", 
      "\n", "\t", 
      RowBox[{
       RowBox[{"thetadot", "[", "0", "]"}], " ", "==", " ", "thetadotnot"}]}],
      "\n", "\t", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"va", "[", "t", "]"}], ",", 
      RowBox[{"theta", "[", "t", "]"}], ",", 
      RowBox[{"thetadot", "[", "t", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "5"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5181736424396*^9, 3.5181736424416*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"va", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"theta", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"thetadot", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}]}], "}"}], "}"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181737051286*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"theta", "[", "t", "]"}], "/.", "numsol"}], ")"}], 
    RowBox[{"180", "/", "Pi"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "5"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"theta", "[", "t", "]"}], "/.", "numsol"}], ")"}], 
    RowBox[{"180", "/", "Pi"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5181736453946*^9, 3.5181736453966*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwd1nk01F8UAPCZwVhmMLZQsoeQUJRU71KppERZ8qOYr6TsSVFKhSxRSChF
SiVCJZEkpIgoopC02SL7vuX3vvPX93zO+Z5377v3vneeAtvL8iCNQqF8o1Io
5LfS7sOyycBO9Ajm7ijWOILlyrTKkuBOVNczGitX5wjZrrqLNYY7kZj1OYkV
c47A/rr3Fdf7LrSpL8BKZbcTCCT/9PBp6UInaGsdp/Y6wRM7T5nvXV3ojO8I
V9k+J+BqDQsoonajndyF9vqEE6Q3F63yWdONJnd0bMzzc4KuJvmM9tvdaFiK
msF9zQkuXc22NnvUjajyvpbbbjqBvtU6nqKX3eiZoGh6cJoThDXuYV9t7kY5
D4dO/XzgBGqfLsiYCfUgfZfuAsMiJzjy8W/M84AetI57ev5EixOIxgQg1bAe
dGaR/8EN35ygyJw+EB/fg1ipCq6zP5yA8UFuh3duD+oN8Qtw6nGCh7WWPKqd
PaipU8Lpy4QTDFQXBsTv/oP+iz+z8bgoG3zehLC9VHsRy1J/adtmNsh2mNAn
VvUiMQOrkze2sqGGxp8ZCL3osxXzo40pG5ZB9HDEvl6UW2sd+cqcDS1FV8+m
X+xFBxY6N+y1Y4PRo3spLYO9yIE173/dkw0iyVWtmwr7UJPrKd2mK2woeR55
prqiDxmd0PPnSWCDW7OZokV9H2o/pF2uk8SGNxL1h/f39iE9p0NBZ26wISCm
Zcpf5i+qL1nu8iedDT9DexflnP2LXESLljDy2fDYm7lHans/8nJ+K5HdwIb3
18UCsq37kVqrw+2YRjZ0VSxONXbuRyorNvl7f2bDYunlfe5B/Yi/XEF2WSsb
Qsq2BJfl96OL7qHKxE82WIsG5R1RHEBcWVlb1g6ywXv9hZaFlQPo5IfGqt9D
bIh0iV6I3zCAMrsZ9KgRNrwqSt7xynYAHbn2+F3DOBvUiMLfYpcH0PatDirr
5tgwkzcs9nJ2AGkb0K758REg3j5lYMk/iHrFPR4N8hOgxUdx7F40iOZb7nS4
MAgg7IUeiugOoq8HC56bCRHwnltjs4vrIDJ2N3kyIUZAipXzMeGmQfTnN+tZ
lSwBaafcerVthpCbRTKK0CVAu5R/KsxhCNF37Em7uYqAUu4Mnu/EEDKIDmA+
Wk3Aj+gO+WjvIeSn3ib4QZ8A2VsONn8ihpBxfZvSxDoCrleYV6QVD6E6hnlK
nzEBcYKrU0QVh9FqgWfVkRYEKFo2ZB1WG0Y27f1/XCwJeJzg/bxUaxjRbOtP
Gu0h4KNcdqOn4TD6suTO3PBeAoR0VRg1e4eRDEOwFmwJiLSW8g8OG0Ytqf08
SfsJOJ86ZzH2dxhZSGgIoyME7NYu9NEYHUbtt0+K9WHLlvnGsqeHkcPAp+6r
bgQU/er9+JFnBD3excXf407AyLIW82zZEbRFds75jBcB7If5O112jyC7kz7g
d4wAo+ee25vzRtCi4VWrr53G+ZiqHxYuGkE5EkF0pTMEtLV2hpuUjiDNYu/O
LGz/Ofuqp+9H0AZbnY9FQQQ8Qju2xnaOoK27oiJqzxEg/1Z1i6nkKBIeKv1X
GUoA5dMPKD45irQzU+KWRBMQ8qck7eS5UbQQEu12BZufcpNmED6KaOtvHBC4
RIDoin0V+VdHUYZndeo49rKw+q25j0aRv75xblkMAaaG5btud42i/gPa53Ti
CaizuJXr2D+KIuwtGpOx97ieYcmNjaIn+0vsea4SYH91XUMydQxlLbYQ+4zt
OfjE6qrMGLKhqYNnIgFX7tyxD7ccQ9rSWt9PXidAqujcS5N9Y0jn4KReC/aN
jwdkeRzHUO4qgxb9ZALuzS/5cc4D/y9gKDCEXWgTT5wKH0NWSTUGdjdxvRih
RzxLxpC3SGmf0C0CVI65+O9VH0e2cZZraXcJWLHu+55U7XHUWut1eSv2aort
yl79caS9+5RbFLZx1PauoE3jaP38RL74PQL2p2vuzbIfR3cMWx7K3ScgoXFk
Je3yOKr55tgo94AAHr2g7tzRcXT73+C5uocEMGcny2emx5Hx9yBuejauZ5l3
yhbKBFI6H6u8AVt+J9vqK3MCNa7sR5nY6w9ueU1XmUALou4TQTkEHLvKSHWw
nUBhps+mpR8R0DGeaM14OYHm6h6WM/MIuG20yvfb6wnUe/zB3/XYB6LrLudW
T6BEN90id+xWZZ53e5onUDBPg3ENdv2eo4Y3RieQ+ZoE2ZCnBJQ8NpNfoT6J
zm26dKUzn4DA+e71C9qT6G/Sv62sZwQYbA/eV79mEoWM+mSuw37643mc35ZJ
FKfdfOoSdqawKk+J4ySqEP/hpFtAQKIHtXdX4iQ6qMhf4VZIwN7nN+gKKZPI
S+9lWiy2KM9apdH0SUQxadcvwL50w9M+8ckkktlyOoL6HM9jzde677WT6AOl
qj0O23v5szxv7ikklWxXklGE563zyOk4nyn05KB+U3oxASanlR5u9p9CPhIr
WeXYxhJtrRNnptBnFRXx79jrtuxc+1/UFPq+94W/1EsC1O+uHFW6P4VE1fVK
w7EZB8dc89um0JX8pWkHSvD91XF6b/PWaaS+ql7jzysCqgL1gyN3TaOIHvom
SikBFeKDj9dbTSPDnA4tSezizY7Caexp9ONZTehm7IfpxtWHT08jrU85a29i
RzvzwuyTaVTXTZ0wKSNgV0eMhqzsDNLlkmg/XY7jaXQ02ivPoM3Mw78uYe/w
XXMmWX0GDfN3VqVib6O1f5RaM4NmdNQ2lGEby2scF9s9g77a366ivSZAz/5N
Kd/5GURV8rl2FlumcdpqtHMGjTSnubtW4Ptxyc4Fnb8z6PhAgsRxbGniVob3
yAza15p8Lxh70YjJbP+/GfQFQs+lYLNY8bd6JGfR+LV7cp+wucy0+r5tn0UN
9A8Ka98Q0PuafbYqexa9sIjbOIItF9t85NLTWSSqWKT4D3vv/l1We1/Mom0+
lkP8b/F8TRmo/6iaRSt2RW1TwI5bIdI4+XsWBUlIjezCNkx8paq6eA5Fpy02
u4cddUTmQ+iFObTYV1TJpJKAsjVxz3dEz6GGwmPnzbEnuPnSReLn0LSPzEdb
bMfUUf+baXOIL+WZvhv26sZqxfziOVRu47v6Mva3DQHHO0bmUJ7KDLMRW0vk
89JNB+aRMv9afssqArqiu85fPTiPJvLmB2yxbwpMdne7zSN+IrrqADaTW+pJ
lP882lNgb+OB3Tuxz+Rz7DzSvj7VGYZ9t+2b5+GKeRRtzWopwpbJ6Hx1efk/
1P8tN13qHQGNyhPKv1b+Q7nG9eqy2BfT6JGr9f+hu1rL7ythz1xX3dti/A+d
zHp1Xgu7Ofpwj6L9P8RKt6/chH3Ft5/17NI/1N1LveqOLYDGndpG/yE3+Q1P
C7D9jdT4ns38Q4ahkkHF2F2b/su5TF1AV5xKoAy7fFvZjLHwArpmV5BRjX3S
MvrKA/UFpGWMBL9h9x1c9ua40wLijRhYQ6kmwM7V1m236wJqN3x1ghu76shF
EXWvBRTN8s7lw073Gnb4FriAMrdk0UWw7QNeTmxKWkBthlLWCtjvo6zURD4s
oEJkHgrY6y6H1/U2LSD37Kbtm7EzYl8cq2hbQGcoCrzbsEMSFMpO9OL8wpG7
ObbsxwnNQRoFEk5r/nLA/txS/sZKlgJtLbPhAdhb++0mFa0oUDQdLvkQO0U8
+FOQLQWElypRcrHHDLNy2/6jwOj6Lb8fY9+KnD2UwKaAx5ud1wqwZ1RvNPN7
U6DO+uabcuyH7G/PhyIpEPz7kGozNqv5QGBJKQU+yeqYL2C7LITZLqnA6yeY
JlNr8HlXebTav5ICBW/Ef3NhH/aj9OvUUSBztPkgH3a5aJrD3a8UyLs9tFYE
+9jOXxujJigwLdK+RBG7udyZaqdJhSahND4j7CGj1sWnV1JhZ5BEkTE2b5n5
6lu6VJC+GOu6GVv/1bpDXWupYM33tHgrdvwLVu3RLVRg3NEw3oVt/rQ46eJ+
KhjdW/HWDvvtXXHtlzFUKPyd3uiD3a4cuf3HFSrYtR3X9sUev7PA5kqkgkFZ
V8QxbOXbvVe336SCAs8jvRPY51NKZ5seUKHdzdonEHtjonvlQDkVBlzYgRew
88Mr9suPU0FyqH0uCTvDtEYqbIoKUvkuGtexrzMbGvpnqRBD5NokY5+N+W7y
gkaD7KgrD25imyXNaFmzaKB9RnLVbexf97UXLmrQgGtP7I9M7KbDa56PaNFg
RwR/fxZ2lcZG3326NDDsOT/5EDs7d0e3igENvqyMoOdi+xe4fCgzocHtvXsF
87CFKm+kTjrR4BxFq6wImxpxZ9/+gzR45nI29wX2mGmm2BtXGvA6CN4oxm6p
KwiL86LB4fbfXiXY6Z8bvFacpgHd9xutHHtdFx8QSTRgfG1srsJ24fH7UVdH
g5E7Y3ZN2Ivl3n2ZrafBxRWmAp+x69Yu/aDWRAPNhUOFpPXd37w8/5UGuV3c
Is3Y9E8Syfo9NPj14l9eK/bdW8+sUqhcEKFWXf4du8NwqtpjNRfYpUmK/sFO
sjIrv76GC+Y2eaSQNvO69bxyHRfccnu3vBf76e1tGQpGXFDCvLGhDzuE/1po
004uONzbsq+f7O8XA9hwiAvS8nRdhrGJo6fymde5IMSovmWKzE+3PX/5TS5Y
XjS8dRpbYASemdzigtObLPNJP/KhF5y9xwWRd5ujZ7DnvGMLx55wQeMxWf05
7ASv+y/aarig5uFD5wXsd+6fyh7Oc8FfkXBjnvf4vaapX/6Owg2dx0WTSXv/
TSrv4uIG51jaKOlF7vtfywtwQ/uwZBodm+32pyJ+ETdIZq+a4MWeO7xQGbiS
Gzy8REIFsFce0qgzc+KGGyePrBfGbj8s55XtzA0K4SkRpKPcxVhCrtyQMQSf
Sf/xmbX44MkNms2NHizsO4E1TRaB3GCkapUggi0Z5/bNOpEbDCeTasWwF4qz
/jrWcsOIoW6bJHbOq9Toso/cIP9bXloK2778ipZiIzesK7xhRfp55Snv363c
UC+Iakn7NuwYO9jDDV8tNhdIY3d3980e4eKB5kTKiSXYH0Q1GX4GPPBj/Hmm
LPZGD48/yet5YH3VzS+kcypzKssRD/SX6HLLYV8K1AlhmfDAdfGj9qTNuvTn
syx5gAv28stjVz83GvzlxgOplySsFLDfONp82p3CA8qVXIVK2KtfJD0+kcYD
8a3UNtLpEq2XU9J5YG1H6QLpkGp7s7+ZPFDiFGyijG28mv0mrIAHpBuV60mX
8noUlHzkgUSm9tdl2C9yzidrctFB+9ySN6rYdDOrxYl0Ony96thB2uKP6jWq
AB0+qh3hUiP3r1Sb8JlFh+rS90Ba7Jpk3FlZOnzKaysk7Rb8MLzRgA7mdkEp
y7GfyQfxog10oB9CRaSpJRYXHgAdbHyqm0gnTk0En9lKhxT6JqY69msPoyA1
Kzqc6q06TnqJ7We/QG86uO88bayB7TKeMdblSwd/2SX/kX4cd8rX4gQdXJmR
vqS31sr7qJyhw9u3bXdI+xq7uX+8SAf2DkeaJnaNJoVQvk8H6UDVAtKnqOq7
33+jw1aDWqoWdtdmRrPKTzrcV2sUJ707/O+Bcx102B9YoEpaWTjXS7+PDqk+
4jtJv5dZffnWFB2OB6xMIC27dmPdMTFeCGArK67ELve0NFu6nRdS6bGK2tia
T1Y1njDjhcx3N3RIJ4yL2zeY80Lwzigg7Rb4xS3MmhdYvpL7SYtH2l8cJnjh
rV5HImmXuy7Vb87wwr/rYXQdbIG2k9s8n/LC40SzetL6Jx4IXi7gBdlElzbS
TqLNDblFvEBd5tFNunCbnsNwKS8k+8A8aZf8QZ9jtbxgcIxLTRe77JJz8sku
Xmg3lzpJ2t9o18AFKT4ofe8ssoqct7bAvPtL+MBZb/di0h9OZPlXyfLBXWFN
JdIqOXxcAsv44F1g/mrSnxa/lozW4YP2UREb0lpja4yumPJBrirvNdKd9xTi
UwP5wMUgVnQ19t+Qn9NcZ/lA9YTVYtIj7LQDrsF8ELKIoUiaIqegoRPJB5um
TXVIL06ULy9P5IM/FvLmpHeHyQ11PuGD7o164aSLDy010/zDB5HK2UOkX2/5
9jjmLx+wTWsnSFcr3ZQcH+QDu6afc6S/fJf5/XKCD6QDevj0yPg2MifNufnh
d5SnPGm1bUsyjsrxg5HG0Z2k49WkuZ9b8cObH62ppO33q9z/bcsP3MMO6aSV
41eZCtnzQwO1JYP004WdMQSbH9z2Fzwm3fj5vIyQFz9Uxi96TVos9O9qIpwf
CoPcOkjH/Xx1UPAFP4zd/aCgj20nWcu3toQfst09lpFW3NmaxS7jB/U67uWk
nxSODRdU8oNQlLw26YbLy8+wG3E+soIbSYtsvJJQ0M8PGQOvbUnHXHepdJIX
gDu/RiJInzh+3jdQSQBqpKujSO+3TJFLVBGAFM8bl0lrCnw+8V5TAM5E6V4l
/S5gi9oaAwH44LLsFmnaPuUIpqUAxNM080n7Sf4yLQgWAM2NQ19J24/OT9Rf
EICeXQbtpDd/kL7zN0IAEg6d+UFaNMxiViFGAFTq5jpI50yUZkXdEIDCDTX9
pHuaUpnsfLy+WP4/Tj3iHeqY3QLQF9a3dA22TJ7AErdeAZAu7ZUj/b2+4NC7
fgFo1e9SIO0sLEq9MCYAzjP1y0h7Rr5dtUBlwL3Y0ytInz+78tqwDAOMytTX
k37gTnX+bMkAQzWGDWn3izmPVlszYPtgii1prcz/5uP2MWBz5Uo70k+68xPM
HRlgWrHNgXQx+8i7Kg8GzJyyJUh/tP2k9SKcAWqXRjxJT22+O51awoDpXJ0Q
0oEvUoMryhjg4v1fKGmK7nXBPxUM6FcOvkCaV+6ygm4NA+wC3oeTXjTtv73i
CwP0DLZGk16VbXatZ4gBfE4/rnL2JzG2VkeJCYRY0V3SIxcHyq1UmCBg8OAe
aT/aH7OTy5kg/CLhPif+4DfH1yuZ8K3d/QHpi+8qw63WM8FmiCebdMbp5OYA
KyYwYvvzSP/uNPYvD2PCi1N3S0kbp9bdVr/IBD03vzLSt2ztauMuMWFDw6Zy
0vtrfBSJq0y4It72mnTro1vvue4wIfbdzFvSDaf+yW8pYcIvxdH3pHX0Indk
lzFh3Y+sWtIxAxLHJd4w4edGoo70LqcVNZ01TLj1p/YD6WoTe78LLUy4tOZK
A+lykaJ3lWNMcKz+/oW0Qs2WsZVTTDArCm4mfTakXjZplgkpPiotpDdO9vi6
0gRhArm2ki5qk5TlZwmCYsq3Nk5/7/sdNdUQhDS/2J+kb2/QWVLrJAilYSt6
OfF2CQTPOgvi9909jn8d+N273FUQxpfL9pFWOn+16IKnIFzzZ/wlnf52eh+c
EgTG1rZ+0nfNy5Py4gXh6lebYU69nfYsul4pCEKnSidJVx3VPFNVLQhZixSm
SPcE83RN1ArCd95zHKvdK8jf0ygIUUMbpznz27vESvCnIOym5s2QzvTtuHJ2
RhAuSp2eJ50d6idyaIUQCCel0taS9+96h/Oh2kLAOtHHsebY5tE7q4TApF6f
i3QmW7zph4EQtM/UcJyB8pLsTIQgyHCIm3T69JDcrgNCELFWgZf0dQ93Lb1Y
IfhkocEg3aq8N3VPvBCI7nLlWLrNkHU0UQg+/kznOMmUMZJzUwhsPskwSV9V
zcxXyxSCbZO8gqRjfnavl3ktBFnjNUKkw6yIHVzjQrAuUkiU9G3zNvuDU0Kw
uW8Tx8XbrTwrZ4Wgutuf45ENW2Mv0oThU/5Pju1VNL6IsYTBryBHjLTu5Ahb
WUMYGO36EqTbk86f3OIkDGIK3FKkp+NmL953FgYpdS2OxaOP3eR3FYbSXzYc
bz/nUlrrKQznDmZy/PSwKd06UBgOl++QJh25TjTOJVEYHNLOLiat15b2IKxW
GGSKn8mQZmm5TuV+FAbD4iaO/wZpbW3+JAxHQsc4Tld60aHWKgybjuks5cR3
a5Sr7hKGRbUZHM8Ecu2gU1jw62m0LOkWhn7ZNmkWLMnUlefk4zAn7CPDghhe
Z45jcsv3X5NjQdrTeI637TGf+7OMBUv5xjguvO665qIuC9R4sxQ4/VmenF27
gwWXD80pkjYvGblhYM6CJxaqSqTpe0yj7lqyoCjJgmO/wOkjp/exwNcknWPL
DzZqKw6xIOOAsTJppp/4najzLMg8Rywj/ZrfPW4qlAW7toVyfDLl9TnnCBb8
uHyP4z+VRx3Xx7BA+GE3x28X1y/9e5MFIWxnFdJBpdFJO56zYGZ6mypp69nR
mPvFLCD0CY419e0iuEpZsFHkNMfNWSonX7xlgfb9XI51E1/9p9HIgr3HWWqk
uzyGZRmDLGA9LeP4yu+Xwq/HWXDkUy/HsC+ScmqOBcavRZdz5n2z0q9efhFI
1T/A8c4lVnerlUWgWK+P40AoZglriMDtcH510g8PKgXu0RGBAroqxwKPhi3b
NojAl+QDHFduvkQZsBaBzNpKjlUu2385TojAcOUkxyEt6jkLXiIQbLRMg7SR
Z+V/IhEiwBAI4JhZ0fo0I0EE1t6/zXGz9IAgpIvA2/p3HHu/ES/1fCUCquEi
mqTXL1GTpteKQKi3Lsd8PoZHb7aKgGOqBcepMmzl9+Mi0B10kWO4MFqqKSwK
CnzFHP8aDHGIVhMFGa9ujoP3LZrpNxIFkx1CK0grv76fsOs/UWCu0uH4lUPO
qZXHROG7/G6O7aaeOrKiRcH3pxvH43EvtgzfFQXuWyEcx6woV28oEYXCnOsc
n4r5PV87JgodLeUcu4xy179TFwO3pb85dm6Y9V/uIAZ3Kmc4Zj8ekY+4LAbj
75hanPUamNEVlWJw4a0MxyWjKtMLC2KwyWk5x/8DT1GBIw==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 135.},
  PlotRange->{{0, 5}, {134.34797858493903`, 158.3818579490854}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181737072816*^9},
 AspectRatioFixed->True,
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVzHk41Akcx3FXq6KRMdRMDWYWhZJ1ldJ+v6GIKJOSdY3fIKlE2Y59ajV2
Bs042rJSTM5Om2MdWxsRuhFhKfcYcv/YTTb71OzsH5/n/bz++bCIY5xQFSUl
JQ/F/q9b6Ghr7di+b/fEnPZUUqKhmhMjqp9uAwezwrJUqTS0zs7IKqM7wy7z
UNvlRjR0b+r8TUL3hu5U/cztrjT0CZmvvkQPAc0i0xrWzzTs3ZDglEyPgXl9
vkW+kS7m6O6OF9EF8IbuNzrB0UP+4rI1F+hpkPCkrfpa00o84JtbPDNbAAyL
PMu/H+ujhpzv76JfDM0no4eqktlo7DU9Wi8uB5EoZaaAZoKnmu0h48MDWCZZ
6mt5xAxXlGv3KSvXgHR6wPikygaslDo1vnaoA90rquZBu62wLkKyyneyAV54
MYvMImxxzmSr1r2jz0D8grQyubEJVT4VLl9l/BIWRVo1tyQ4oJ2cW7m3qBGC
xnZQ9jshNgpsmp+avQbi8U6X9hBHNLg48enOdAucoxlOHpI548R8f1+H5Rt4
zs1YWUS4YMH4w5eUlDbIfRIdOLPVDSnMW6RM1g5Qj1HV5h6YdKgiLMfoTwjw
dK8ZXtiNH7FQFh7bCfmipRUaF7wwxqqhXK++C8IvU27FLXCwv6hB3Mp6B5yA
MkGW0Bv/jWjPNP2hGyovX3tlK9+H5tvUv4Q97AFr5oOU8xwfdMljHSxd0Qfh
2jpMjdIDeIoZxB7074eMPV0i+bAvrpvcp9HpMQCCx4TWTyp+qKM1s7hhYQAa
3et8ldn+qFaTWfx11iD8YiDuO8oIwMM2D98ucZfCXyrfGMdRA7FwJ5Hz6KMU
wqJMjv04G4hzE4zlI+lDsNGkooRWEoQVe11U05xlkBRXQ56142KsqzC7fEQG
1F+/Yg/Gc5HV69aVLxyGV0JifraZi5s3CtLoViOQ9ixb3VIvGP31X39SbhuB
9GW5a+9ygnHuZbI0iv8eCkWm4Y4pwZihFhjDMRqF2KHtB1/VBqNOX0WeSsMo
VLoxfv9nKhgXneN720ePQb+DgB3PIFDpTmCxlDoOZlMRlzyQwOPXipOpdePg
J1FxPhtKYLV54mLtyAk4s0JKFccTqO12fF0cZRKCY+s+p+cR2LO+pe1M1SR4
Wn6XsvURgSXXwUgWOAXSm0MOZR0EBhTbaTO/TIFLR4df6TiB54W5/J6702C4
X2x/VE7gvVFmJmUXCWvssjvVtXmYKBFy+zxJsNbK7eUoHMKZMi7yImHdO4sn
EoVXV1WVePiQUN9iaG9N5aEo1e9pEkFCuWZthb8OD8Ptrs4uPUNCl+GC5l1d
HrIFNFf1myQ0C5rEFgweftl0dlnnbRJ6zRq6v1f47dTQm5uFJETqdVKqFb7o
Uxawo5QEzuFYffdVPJSbcU4IqxT/z+nDoat52NOael21jYQkuxP0dH0e3o+f
57V1kCDmJ+Z0K5y2Jcg0v4uEuadRGiwDHrrfsCh37CNh2/T7pEKF/zjd9II/
RsLewyVQY8jD9PW2qV6TJGzeIRlRZfEwWprlzSJJUD55P9pV4bW7jvTXfiCB
4N+yaVVYTbm94OI8CVetLx3RZfNwoGJLBHeBhLH3XYm+CldF5G+w/ExCzpKE
CxKFrxhozMnlJGiq3Y4cVPg/Z6M7uQ==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {0., 153.09001858535373`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181737072936*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "x", " ", "dot", " ", "y", " ", "dot", " ", "are", " ", "related", " ", 
     "to", " ", "va"}], ",", " ", 
    RowBox[{"compute", " ", "them"}]}], "*)"}], "\n", 
  RowBox[{"numxysol", " ", "=", " ", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", "\n", "\t", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"x", "'"}], "[", "t", "]"}], " ", "==", " ", 
        RowBox[{"xdot", "[", "t", "]"}]}], ",", "\n", "\t", 
       RowBox[{
        RowBox[{
         RowBox[{"y", "'"}], "[", "t", "]"}], " ", "==", " ", 
        RowBox[{"ydot", "[", "t", "]"}]}], ",", "\n", "\t", 
       RowBox[{
        RowBox[{
         RowBox[{"xdot", "'"}], "[", "t", "]"}], " ", "==", " ", 
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"numsol", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}], " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"numsol", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], "]"}]}], 
          ")"}]}]}], ",", "\n", "\t", 
       RowBox[{
        RowBox[{
         RowBox[{"ydot", "'"}], "[", "t", "]"}], " ", "==", " ", 
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"numsol", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}], " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"numsol", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], "]"}]}], 
          ")"}]}]}], ",", "\n", "\t", 
       RowBox[{
        RowBox[{"y", "[", "0", "]"}], " ", "==", " ", "0"}], ",", "\n", "\t", 
       
       RowBox[{
        RowBox[{"x", "[", "0", "]"}], " ", "==", " ", "0"}], ",", "\n", "\t", 
       
       RowBox[{
        RowBox[{"xdot", "[", "0", "]"}], " ", "==", " ", "0"}], ",", "\n", 
       "\t", 
       RowBox[{
        RowBox[{"ydot", "[", "0", "]"}], " ", "==", " ", "0"}]}], "\n", "\t", 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "[", "t", "]"}], ",", 
       RowBox[{"xdot", "[", "t", "]"}], ",", 
       RowBox[{"y", "[", "t", "]"}], ",", 
       RowBox[{"ydot", "[", "t", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "5"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5181736487265997`*^9, 3.5181736487286*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Solve", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Equal]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"velax", "-", 
               RowBox[{"lc", " ", "thetadot", " ", 
                RowBox[{"Sin", "[", "theta", "]"}]}]}], ",", 
              RowBox[{"velay", "+", 
               RowBox[{"lc", " ", "thetadot", " ", 
                RowBox[{"Cos", "[", "theta", "]"}]}]}], ",", "0"}], "}"}]}], 
           ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"velax", ",", "velay", ",", "0"}], "}"}], "\[Equal]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"velpx", "-", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["lc", "2"], " ", "thetadot", " ", 
                 RowBox[{"Cos", "[", "theta", "]"}], " ", 
                 RowBox[{"Sin", "[", "theta", "]"}]}], 
                RowBox[{"lr", " ", 
                 SqrtBox[
                  RowBox[{"1", "-", 
                   FractionBox[
                    RowBox[{
                    SuperscriptBox["lc", "2"], " ", 
                    SuperscriptBox[
                    RowBox[{"Sin", "[", "theta", "]"}], "2"]}], 
                    SuperscriptBox["lr", "2"]]}]]}]]}], ",", 
              RowBox[{"velpy", "-", 
               RowBox[{"lc", " ", "thetadot", " ", 
                RowBox[{"Cos", "[", "theta", "]"}]}]}], ",", "0"}], "}"}]}], 
           ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"velpx", ",", "velpy", ",", "0"}], "}"}], "\[Equal]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"lc", " ", "thetadot", " ", 
               RowBox[{"Sin", "[", "theta", "]"}], " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 FractionBox[
                  RowBox[{"lc", " ", 
                   RowBox[{"Cos", "[", "theta", "]"}]}], 
                  RowBox[{"lr", " ", 
                   SqrtBox[
                    RowBox[{"1", "-", 
                    FractionBox[
                    RowBox[{
                    SuperscriptBox["lc", "2"], " ", 
                    SuperscriptBox[
                    RowBox[{"Sin", "[", "theta", "]"}], "2"]}], 
                    SuperscriptBox["lr", "2"]]}]]}]]}], ")"}]}], ",", "0", 
              ",", "0"}], "}"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"velax", ",", "velay", ",", "velpx", ",", "velpy", ",", 
           RowBox[{"lc", " ", "thetadot", " ", 
            RowBox[{"Sin", "[", "theta", "]"}], " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"lc", " ", 
                RowBox[{"Cos", "[", "theta", "]"}]}], 
               RowBox[{"lr", " ", 
                SqrtBox[
                 RowBox[{"1", "-", 
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["lc", "2"], " ", 
                    SuperscriptBox[
                    RowBox[{"Sin", "[", "theta", "]"}], "2"]}], 
                   SuperscriptBox["lr", "2"]]}]]}]]}], ")"}]}], ",", 
           FractionBox[
            RowBox[{"lc", " ", "thetadot", " ", 
             RowBox[{"Cos", "[", "theta", "]"}]}], 
            RowBox[{"lr", " ", 
             SqrtBox[
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["lc", "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"Sin", "[", "theta", "]"}], "2"]}], 
                SuperscriptBox["lr", "2"]]}]]}]]}], "}"}]}], "]"}], 
       "\[LeftDoubleBracket]", 
       RowBox[{"1", ",", "5", ",", "2"}], "\[RightDoubleBracket]"}], "[", "t",
       "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"y", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"ydot", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "5.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5181737203926*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tend", " ", "=", " ", "5"}], ";"}]], "Input",
 CellChangeTimes->{{3.5181736503876*^9, 3.5181736503886003`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x", "[", "t", "]"}], "/.", "numxysol"}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181736515336*^9, 3.5181736515355997`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVzHk8lIkfwHEetrUq1yKsIzk6CBW66FsraR2VK2ztRImS3JvE0rRGkqOY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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {-2.345510642719765, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5181737233166*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"y", "[", "t", "]"}], "/.", "numxysol"}], ")"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181736524365997`*^9, 3.5181736524386*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV13c81f8XB3DSkETEV5SVkSSpRItTIUJDJDsiKSWroZSRUSINqaTsWTIi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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {-0.15940730504363262`, 0.6519850509596072}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5181737249556*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"theta", "[", "t", "]"}], "/.", "numsol"}], ")"}], 
    RowBox[{"180", "/", "Pi"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181736531506*^9, 3.5181736531526003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVzHk41Akcx3FXq6KRMdRMDWYWhZJ1ldJ+v6GIKJOSdY3fIKlE2Y59ajV2
Bs042rJSTM5Om2MdWxsRuhFhKfcYcv/YTTb71OzsH5/n/bz++bCIY5xQFSUl
JQ/F/q9b6Ghr7di+b/fEnPZUUqKhmhMjqp9uAwezwrJUqTS0zs7IKqM7wy7z
UNvlRjR0b+r8TUL3hu5U/cztrjT0CZmvvkQPAc0i0xrWzzTs3ZDglEyPgXl9
vkW+kS7m6O6OF9EF8IbuNzrB0UP+4rI1F+hpkPCkrfpa00o84JtbPDNbAAyL
PMu/H+ujhpzv76JfDM0no4eqktlo7DU9Wi8uB5EoZaaAZoKnmu0h48MDWCZZ
6mt5xAxXlGv3KSvXgHR6wPikygaslDo1vnaoA90rquZBu62wLkKyyneyAV54
MYvMImxxzmSr1r2jz0D8grQyubEJVT4VLl9l/BIWRVo1tyQ4oJ2cW7m3qBGC
xnZQ9jshNgpsmp+avQbi8U6X9hBHNLg48enOdAucoxlOHpI548R8f1+H5Rt4
zs1YWUS4YMH4w5eUlDbIfRIdOLPVDSnMW6RM1g5Qj1HV5h6YdKgiLMfoTwjw
dK8ZXtiNH7FQFh7bCfmipRUaF7wwxqqhXK++C8IvU27FLXCwv6hB3Mp6B5yA
MkGW0Bv/jWjPNP2hGyovX3tlK9+H5tvUv4Q97AFr5oOU8xwfdMljHSxd0Qfh
2jpMjdIDeIoZxB7074eMPV0i+bAvrpvcp9HpMQCCx4TWTyp+qKM1s7hhYQAa
3et8ldn+qFaTWfx11iD8YiDuO8oIwMM2D98ucZfCXyrfGMdRA7FwJ5Hz6KMU
wqJMjv04G4hzE4zlI+lDsNGkooRWEoQVe11U05xlkBRXQ56142KsqzC7fEQG
1F+/Yg/Gc5HV69aVLxyGV0JifraZi5s3CtLoViOQ9ixb3VIvGP31X39SbhuB
9GW5a+9ygnHuZbI0iv8eCkWm4Y4pwZihFhjDMRqF2KHtB1/VBqNOX0WeSsMo
VLoxfv9nKhgXneN720ePQb+DgB3PIFDpTmCxlDoOZlMRlzyQwOPXipOpdePg
J1FxPhtKYLV54mLtyAk4s0JKFccTqO12fF0cZRKCY+s+p+cR2LO+pe1M1SR4
Wn6XsvURgSXXwUgWOAXSm0MOZR0EBhTbaTO/TIFLR4df6TiB54W5/J6702C4
X2x/VE7gvVFmJmUXCWvssjvVtXmYKBFy+zxJsNbK7eUoHMKZMi7yImHdO4sn
EoVXV1WVePiQUN9iaG9N5aEo1e9pEkFCuWZthb8OD8Ptrs4uPUNCl+GC5l1d
HrIFNFf1myQ0C5rEFgweftl0dlnnbRJ6zRq6v1f47dTQm5uFJETqdVKqFb7o
Uxawo5QEzuFYffdVPJSbcU4IqxT/z+nDoat52NOael21jYQkuxP0dH0e3o+f
57V1kCDmJ+Z0K5y2Jcg0v4uEuadRGiwDHrrfsCh37CNh2/T7pEKF/zjd9II/
RsLewyVQY8jD9PW2qV6TJGzeIRlRZfEwWprlzSJJUD55P9pV4bW7jvTXfiCB
4N+yaVVYTbm94OI8CVetLx3RZfNwoGJLBHeBhLH3XYm+CldF5G+w/ExCzpKE
CxKFrxhozMnlJGiq3Y4cVPg/Z6M7uQ==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {0., 153.09001858535373`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5181737263556004`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"va", "[", "t", "]"}], "/.", "numsol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181736537296*^9, 3.5181736537316*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1nk4lc8XAHCiEiWRst77cqNIJVv5FeeKLFlCJLKlUrIUEb6RJbtCpZIl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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {-8.284650446918192, 9.999999823551459}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5181737279835997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"thetadot", "[", "t", "]"}], "/.", "numsol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181736542866*^9, 3.5181736542886*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1nlcTG0bB/BKaF/mHEsUSkgbUtGi6yYUpbRRtKkUaSE92iVPqzCeJGmT
FrTQokKboiztambOTNNe2lRTtEjbe94/zud8vv/MzPldv+s+I+3gaXqRh4uL
q5e8/n8/eXH4e9WIhY4xGMlycU0Cr+6mq90SqvC55KCPBd8k7H8an/RG4ijc
ofyofi02CQaNRGGyhDlsyhmwd5eehLNOcxUxEk4Q9evC7026k9C5J0L3noQ3
+ImmZh2MmITUdcbhdyRCYa992eEoyhSE8L3ZFSURC0mBlYxWtV9gafUsb3Iq
A24zL1T4jE6D4EqItd6WPDjv++ZFc/Uc7DCZGP4UXQS65/1Ffdl/wadJA+Kn
34OEI09uWtwybCgS7+Lm/gA/XKJTltW4UUmfbkOz9kdIm8a7M/xWoY+uyZut
xmoAEle76HWvRjM7D4m+cv8CczQlAYY2H+KZzxHbvKMOBAS8rBUHBZD6in2J
2esGyN53MivIVRg1hKo2fZZvhvr4iq5GQhRtffBzPmuiBQwt1l4WVBBHP+e6
u+h7W0FFr+SBywEKKnGhfjyp3gqR3qjgmRYF3SJ0nn/QaoVBj8wGJlDQ+rfJ
7lnHW+GS4s4fh/Qp6MiN84uB1q0geUNUrd+SghKmGRKyka0Q/GxQ7LEfBelP
NZp7dbdCYvboh6h3FIRdCDo4NNAKj9S/C1uXU1BXi6Kk9Wgr8Dlr9spXUZB3
fnT/sZlW+OZYKVD5hYKeep7wkhBsg7pv+WtLGRQ0O15DrVJvA6N3tmmrpyko
Y7SsTuR+GxhYNhi0KWDI47HxdteHbcCfuvBr6x4MHTjaH1Ab3wbx7zOYl1Qw
VJcsoBSY3gZfQ1LNOAcxNHXaijryrg1e6fYXNx3DkM7bWbOa/jaI8ymPp9li
iPXvvk4/DRpsHK75OnwPQ2l7a9XoOjTIe5uR9/YBhtw6Le/vPUqD0I+hgbcf
YojrwC0YMqKBR4lSpeATDO0cbXpm7kQDbuPAhLF0DHmfdnPeQ6UB8aw95Mc7
DIlIveAMDNBAbfBDfXo3htCZfzv7R2iwZmoo+1MvhryodvV9EzQ48srnfXc/
hhjcG1/0/KGBsfGKjdAwhlIGI207hOiwJozx6MAkhpTzXRvbVOlwPep0IG0F
Q/Yjx8taNeigG+7xpIQbRzEy27O+69CBZRTQFLsKR7Ox7NBmfTr8OtHnf2wt
jir9DLXrrenwZ517iY8Ijk7pKud8DKXDUoNrxBZJHN0MFHhSHUUHocI7IdVS
OMovHgyvuk+HYxkawfZbcYTLPXWojKfD9tMKITEyOOoQEttUmkuH3Ttyb3+W
w5EbYyqygEYHvuq4OHdVHKWINt3IZ9FhUP21UYsajlr0s53yuuhQoMGZVz6A
I9UyB/RqmA4+f9g7ejRwtPi0be7lIh2apuQqxAFHdy8XO6fKMoBlJWFRoI+j
UfQqUlCeAdW/UlR/nsCR3sbM7Bt7GFAvtlp3mwGOeL7EThhqMqBxdt1IwCkc
+cl635g3ZoCmbNWReRMcMRauxDtZMODH0w8hQmbk97c5ljafY0BW6fjwJnMc
TYaYLWdeZECS+rDS7jM4cu5WCTcNYMBUlXyk4Dkc1ZTIv6y4xYBVvpZLc6Rl
7svUyYUzoKw743H3eRx1alNEVh4wQO3YTs1UGxyZJ0w9ynnOAP7V6YpD9jgq
vDbydn0uA5Y7k6tyL+BI9EQvK6SAAQ2eLTfcHXBUN9ciZVnOALEjl/V7HHF0
2CI/k7eVAZWnn92IdibzVHz5xZNggDK/FSbvQua1KnWkvYMBj4SzWz6RfldI
VSoYYsARDvXV8CUcrb8TYSw5zgC+L/aN1y/j6PqF4GsRv8j8uo+I/CWtLOZZ
bLPEAJFvhb/nXMm8h5yJrzwEbIsNjPe8QuZdaTu/n48A2UfNtn2kM92NDglg
BKwoRZ1+70bmfey43T8bCbCoUgiUcseRvaROSI8UAQlBzd8CSUvWK9WWyBEw
5R5Tr+iBI/+0HUPSygSEJI4HB5Em/KT47+0nP2+4+sw30qom6xT+HCQgy0zp
tJgn2Wc54VOOOgRI3Dd1MyU9ucLr2aRLwO/8uBwqaSNi8YHGCQIUY6giX0nn
vp4uzDAioGkr7dECaf7wMZqoOQE9eguH5a+S87QZmPW3IsDtTyJmTrpGtWPj
oC0BAVtPCfqRlhGiaZo4EYDnZO5+QvpWf711+WUCdKO0PYtId5V+urnLkwCR
ly876khrxZSlxngTEDxzy6uDdPzlNx+X/AhIsbPeN0J6FuUMXAom4B/ad4kp
0uUZPxN9QgnoHYrcMk36Np+iWXgUASZs6/FfpPXd3AQe3Sdg3+Wv4eOkRVpy
q9MfEjBhcPxnP2na/nHfwngCpg+ZbGaQTnistLc6mYC8eccNNaTtF9yHmtMI
uKsx3/2K9E671yldLwiYeRv9z0PSYx8nLMZzCbDaE8f0Jl24c4/wYgEBj82/
85uS9r3jWSPwloD5RiSgQFpnIi9AopyAapeX7Stknrymkypy1eS8NtcHtJCu
K947qv6ZgJqBKxNJpM8EFViat5D9SdpvsJu0ZO+UqCOdAObNHvURcr59R1W+
XGsn4IzthrkM0h5Cb9SoAwQMLSj/Ef3//K/+HkseIeA5b5zmB7I/f9v2Z+RO
ENBakmnuSjo8sYhS94eAdYshWBHZP8OV6W/MJfJ5Du0vNSVNcVQLGeJhQoC1
ufY42dcU+RIOrzATSh7kMdaRLn7/tgGkmeBx1uCmGtl/f6k//xrtZMLJXq7N
b8h9QSEHtWwUmOB5uzNBkXSD/vssfzUmzJTf1cfI/RogSsOLTzBh2fREQJ4T
jrK1Fg7VGDFByKHitBDpq0+1ZlrNmNCMzlEukvu76FzuOGnDhP4rVFsBcr/x
2Qqk4MWE2pgUbVk7HLVbLc9p+DCBXvA91t4WR6kVOnn6gUx4NbO+P548PxTD
Pkg5hzMh4Q6/yxJ5vhzFq/+mJjAB+29sb5wljrxVaorWf2JCtGYkNx95vjmr
bkv97ysTyu6PBE4Y48hSPTBaqIkJUV8qzFuMyL5qqjrwsJjww1hPOtyQ3N8j
GaITE0zwnqI6l+rhiGoS6lq7iQW3hWI99A6R/TfrsUDbWPBS2DZ9QAtHXhba
h8t2sGBne6VFkCY5b6vpDQV7WeBWVKL9jDzPJS841SYdZ0F/ZJLFm31kPleP
bvP2YkFtxO4anh04SvJKFeT4sEDk0rtxy+04uue9OHs5iAVFDzJLs6XJ/HyL
Gu0iWWCZIKR/eAuODtySDTBIYcGy3uZ/NDeQ+0rlZcjUscAkos/Tjg9H3a9r
or9Lt8N2z7uz4UMYahnnHVPZ1Q6lUv8O2//AUJXiMcNYxXaw+rnmrzr5fk3N
rhU6e6AdfLy2RxBdGHJ4/vleh2E7PNqQ92SUjqHB5K/UIZ92KP+zdtv5Txga
v9vwcKmxHYJVbEf9EjG04EpL3O3PhqHFmGCrwxgyV7f5TzmYDZ9yLDrDdTCU
yz0Yvj+UDYqnUsIKtDBkGz937dB9NhSzUNWyGoaqazfpm6SxYeJxwS4/eQxF
bLsw7VvHBuUx882TFAxhjHHDr5s6wM09Pni+l4IUDq9ddi7rANtfhxwp5P8t
vTRpl4INXRAUFnP8fIA48pGyk+m17oa6zDPeeT5iSHHMQpA41QM2KzLhomwR
hIlO8tX87QGTwkLqmhghxPshMW97Ui98Ox/xOf2GALqiWsbiN+gDtdrkuiTE
h3JOOKRWzvbBhwI+l9Q9a9DMz01ig3H90KWs+SvClhcVm+mtij06AKf2XYHE
CB4UrB/2tGhwAJ7KuNxHk1xIuvMkMz3sB7Qu+gsTS8ugeSA0VkJlEAZuJTe7
Sy2C9Zbmee62QZjxE1/z8OU8zNTd67saMgSXbdN5/DXnIJ7X1ttUdhjija7f
Ld49A1hXcRpPzTCUVz+uDzr9G1YHhZhrXBsB4cbruSVBU8CVZZvXRxkFI1ru
F/kBDngl5N2jfBwFlemwZIX2MahQiOQT9/gJEXzN2td2jYL4SS/F2yJjwLE7
ZXK+awg6lFra/MrH4KaTiPjdlB+QnwKyA7bjoMU/tW+8pB9s8tTFpZbH4QLv
1HaHVX1wK+xZSEf2BHDdSFpafaYHXg1LJYoYcmBsA23CjNYJkclh9l1GHNgc
remt8bUTnEzHd7w24cBCVt/C9vJOkCwvzz91lgM8q67z82V0wh3q+c93HThg
Wj/VK+jdCZfUn0wJ+HHAd8k8h2tdJ8iE4vprn3NgmQh8Sz3XAcsHA4WJlxzw
sAy9KG7cAazx/tbnORyQo1i0PtbtgAdn39gcL+CAmEdaT6FiB6zIm14PK+eA
ztUtCdIrbOj4Tk1Z1cYB1CfX2p3Bhnfhc45tdA64UhTCc5+wIVbLbnc6kwOe
Hgfag8jeGmQqFx3p4kD+YOU5ZV82lPo2fgsZ4UDIrdKIzwZsiFNSo5qMcYD7
Hax5h9hwrS/JXJrDgaxYz3Wv1dggZ+jWXTXNgbX+W7tebGUDLzct48Ec+fue
fXmYg7Ohp1jL1f4vB/qyXFvf8LOh3DV9z94lDrxIl4yvWm6Hx1sFZ1ZWOBCd
PNX3/Xc7/A9f6b9c
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {0., 5.110306241136613}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5181737297226*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"theta", "[", "t", "]"}], "/.", "numsol"}], ")"}], 
    RowBox[{"180", "/", "Pi"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181736547966003`*^9, 3.5181736547986*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwd1nk01F8UAPCZwVhmMLZQsoeQUJRU71KppERZ8qOYr6TsSVFKhSxRSChF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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 135.},
  PlotRange->{{0, 5}, {134.34797858493903`, 158.3818579490854}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5181737311466*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 246, 5, 31, "Input"],
Cell[806, 27, 1269, 42, 192, "Input"],
Cell[2078, 71, 1324, 40, 152, "Input"],
Cell[3405, 113, 1716, 48, 192, "Input"],
Cell[5124, 163, 1019, 30, 132, "Input"],
Cell[6146, 195, 1719, 47, 252, "Input"],
Cell[7868, 244, 3001, 96, 272, "Input"],
Cell[10872, 342, 480, 11, 72, "Input"],
Cell[11355, 355, 507, 16, 31, "Input"],
Cell[CellGroupData[{
Cell[11887, 375, 159, 3, 31, "Input"],
Cell[12049, 380, 8701, 235, 347, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[20765, 618, 451, 13, 92, "Input"],
Cell[CellGroupData[{
Cell[21241, 635, 1625, 45, 172, "Input"],
Cell[22869, 682, 1234, 42, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[24140, 729, 631, 20, 52, "Input"],
Cell[24774, 751, 12493, 213, 236, 9319, 158, "CachedBoxData", "BoxData", \
"Output",
 Evaluatable->False],
Cell[37270, 966, 2112, 42, 242, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[39419, 1013, 2497, 70, 232, "Input"],
Cell[41919, 1085, 5388, 148, 328, "Output"]
}, Open  ]],
Cell[47322, 1236, 171, 4, 31, "Input"],
Cell[CellGroupData[{
Cell[47518, 1244, 318, 9, 31, "Input"],
Cell[47839, 1255, 3643, 66, 230, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51519, 1326, 318, 9, 31, "Input"],
Cell[51840, 1337, 8086, 138, 232, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59963, 1480, 370, 11, 31, "Input"],
Cell[60336, 1493, 2070, 40, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62443, 1538, 287, 8, 31, "Input"],
Cell[62733, 1548, 6151, 107, 235, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68921, 1660, 293, 8, 31, "Input"],
Cell[69217, 1670, 5037, 89, 248, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74291, 1764, 370, 11, 31, "Input"],
Cell[74664, 1777, 9359, 159, 236, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

