(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     10240,        298]
NotebookOptionsPosition[      9287,        261]
NotebookOutlinePosition[      9847,        283]
CellTagsIndexPosition[      9804,        280]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "The", " ", "following", " ", "is", " ", "used", " ", "to", " ", "solve", 
   " ", "1", " ", "nonlinear", " ", 
   RowBox[{"equation", ".", "  ", "\n", "You"}], " ", "call", " ", "it", " ", 
   "as", " ", 
   RowBox[{"follows", ":", "\n", 
    RowBox[{"Solve1NonLinear", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"eqn1", "==", "something"}], "}"}], ",", 
      "NameOfIndependentVariable", ",", " ", "\n", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
        "Initial", " ", "value", " ", "of", " ", "Independent", " ", 
         "variable"}], ",", " ", 
        RowBox[{"Final", " ", "value", " ", "of", " ", 
         RowBox[{"indep", ".", " ", "var", "."}]}], " ", ",", " ", "\n", 
        RowBox[{"increment", " ", "of", " ", 
         RowBox[{"indep", ".", " ", "variable"}]}]}], "}"}], ",", " ", 
      RowBox[{"{", "VariableToFind", "}"}], ",", 
      RowBox[{"{", "GuessAtVariable", "}"}]}], "]"}]}]}], "*)"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5181745634806004`*^9, 3.5181745773566*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve1NonLinear", "[", 
   RowBox[{
   "eqns_", ",", "iVar_", ",", "iVarStuff_", ",", "dVars_", ",", 
    "dVarInits_"}], "]"}], ":=", "\n", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "iStart", ",", "iFinish", ",", "iInc", ",", "iVarTable", ",", "npts", 
      ",", "sol", ",", "solTable"}], "}"}], ",", "\n", 
    RowBox[{
     RowBox[{"SetAttributes", "[", 
      RowBox[{"Solve1NonLinear", ",", "HoldAll"}], "]"}], ";", "\n", 
     RowBox[{"iStart", "=", 
      RowBox[{"iVarStuff", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
     RowBox[{"iFinish", "=", 
      RowBox[{"iVarStuff", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ";", "\n", 
     RowBox[{"iInc", "=", 
      RowBox[{"iVarStuff", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", 
     RowBox[{"iVarTable", "=", 
      RowBox[{"Table", "[", 
       RowBox[{"i", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "iStart", ",", "iFinish", ",", "iInc"}], "}"}]}], 
       "]"}]}], ";", "\n", 
     RowBox[{"npts", "=", 
      RowBox[{"Length", "[", "iVarTable", "]"}]}], ";", "\n", 
     RowBox[{"sol", "=", "dVarInits"}], ";", "\n", 
     RowBox[{"solTable", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", "\n", "\t", 
           RowBox[{"sol", "=", 
            RowBox[{"dVars", "/.", "\n", "\t", 
             RowBox[{"FindRoot", "[", 
              RowBox[{
               RowBox[{"Evaluate", "[", 
                RowBox[{"eqns", "/.", 
                 RowBox[{"iVar", "->", 
                  RowBox[{"iVarTable", "[", 
                   RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}], ",", "\n", "\t", 
               RowBox[{"Evaluate", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"dVars", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"sol", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}]}], 
              "]"}]}]}], "}"}], ",", "\n", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "npts"}], "}"}]}], "]"}], ",", "1"}], 
       "]"}]}], ";", "\n", 
     RowBox[{"{", 
      RowBox[{"Interpolation", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"iVarTable", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"solTable", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "npts"}], "}"}]}], "]"}], "]"}], 
      "}"}]}]}], " ", "]"}]}]], "Input",
 CellChangeTimes->{{3.5181745634846*^9, 3.5181745634866*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 StyleBox[
  RowBox[{"(*", 
   RowBox[{"New", " ", "stuff", " ", "goes", " ", "here"}], "*)"}],
  FontFamily->"Times",
  FontWeight->"Plain"]], "Input",
 CellChangeTimes->{{3.5181745634886*^9, 3.5181745634906*^9}},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"beta", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"60", " ", "Degree"}], ")"}], "//", "N"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"equation", " ", ":=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "x"}], " ", "+", " ", 
      RowBox[{"L", " ", 
       RowBox[{"Cos", "[", "theta", "]"}]}], " ", "-", " ", 
      RowBox[{"L", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "theta", "]"}], "/", 
        RowBox[{"Tan", "[", "beta", "]"}]}]}]}], " ", "==", " ", "0"}], 
    "}"}]}], "\n", 
  RowBox[{"(*", 
   RowBox[{"If", " ", "x", " ", "is", " ", "actually", " ", 
    RowBox[{"x", "/", "L"}], " ", "then", " ", "L", " ", "factors", " ", 
    "out"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"L", " ", "=", " ", "1"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181745634926*^9, 3.5181745634946003`*^9}, {
  3.5181746411446*^9, 3.5181746457406*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", "thetheta", "}"}], " ", "=", " ", 
  RowBox[{"Solve1NonLinear", "[", 
   RowBox[{"equation", ",", "x", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", ".01"}], "}"}], ",", 
    RowBox[{"{", "theta", "}"}], ",", 
    RowBox[{"{", "beta", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5181745634955997`*^9, 3.5181745634976*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  TagBox[
   RowBox[{"InterpolatingFunction", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0.`", ",", "1.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], "]"}],
   False,
   Editable->False], "}"}]], "Output",
 CellChangeTimes->{3.5181745822716*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"thetheta", "[", "0", "]"}], "}"}]], "Input",
 CellChangeTimes->{{3.5181745634986*^9, 3.5181745635006*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", "1.0471975511965976`", "}"}]], "Output",
 CellChangeTimes->{3.5181745852005997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"thetheta", "[", "x", "]"}], "}"}], "/", "Degree"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181745635025997`*^9, 3.5181745635036*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVy3080wkcwPF5qMRFHspNrYVW5CHlIRLfryhjW51NpQu5PORIIa/UyXWT
9SRRL6/SUB57UuaxK4RwKkflKUKzJDYbv3WXlsKu++Pzev/1Md5/mB2qSiKR
WN/7X+9QcUeDZKdruj9XoVSyUN3dKHqIbAeKM1LGojkW2t7IzK4gewA/hpNr
NMNCRntveQ7ZF/700Pey/8LC3SGKx5fJIUDbrsePkLPw7boz7qnkODj1w0LH
HhELc5fsOH2enAxuVuWcu09YyNWoWHOOnAE+JdVnOadY6LcnTyD/WAjm/LE6
6gwTtZRcf88VAhjruBfZnshEms+kuCmlEh4nKab7VJgY/8IJMj89gswCp0DH
BAYaVuoKVVTqIetaN/+XWW98MOze9nJzI8Q79CfWx3ljY0TOsj2yZhi0Lt3F
nPTCqdUuOvejnoJmaZnJpWgvVJ0uXryM1goDVwalPWN0dFAGPeCUtAHP2vBS
ywE6tiXbvWhZ+xKmVpd9aJd4IjVdOn1n8hX8pGUtuhrkiVLFkLDHphNKHD3j
1UXbsHC8plX7Yhc8G3O5PcfZhtqUW8TISDfYUSyfvHq+FS/8WhWWu+o1uD4Y
VXOjb8XPWDwSfrIX9AbUjkqqPTBuQ3Pl0qY+WBl46aKZgwcOlTSndBj3wy56
CmdXkTt+i+jOMv9tAPzATGq41B0t3BbMhdUMwpkmzq2YtC3omW98oMxQCBqz
O2bcZ9wwnrLP5J3/EJQ7CwxuxbihpWynVi9LBDOWHo5pYkR9HblG81cRSNQf
HglhI6rXZwlMs99B8hGy3vVzgJF2NW8WMoYh+OBEL4fjisVe+3PrPg9D3kq5
yTyqC05JjRaPXnkProdr1su+OWMVx1Mtw2ME+vmXl5BrN+FJOu9G5egIeP94
gRKQ6oTGb737Cngf4BkF9uwLcsRNG5MzyBtGYSLwL6d7BhvRf8XLaZWuUTCQ
H0xa0G+PU62pw9HcMVhO236z+3c7zFQPjGOvEoOFoi0k1M4W9YVV+arNYrDu
VfMzGF+P8xK5vk4xEjh+SMRUPWGDpDuBgmG9cTgctXZvxWZrjOULUvUax+FR
gumxbFsLfGxxVkP3kBQySr/KFpmaoa53rGWStgzsw1LF+etpOGj1qut4rQzm
qqnmjFFjLL0Oq0YCJ6CatPpvURQFAwQOupS5CZhP7WaF/7sU/+DlcQfvToLm
msJEoYsO3hdTsrSZBAxYubDNx0h4NocXJNxOwGBsMp1XRMIQ9gStxIcAWiPD
vjOYhMtra0tZuwl4q5eTktighPNpe1su7Ceg0I4R/LR0FsIdrn3UPE4AOyGb
yEyZBpNkA/qCmwS4jJ+2DzX/CHOOJxb13ibApqOqxDJfDm8m3nfeLCYg0sV0
stNIDum7KwK2lRHAnVdadtRwEpRr2Ud4tQT8XPDN6J9eCQx2pF1X6yKgYn7d
iAnzHTw8rQju6iGgPFozKdZJBBnO+8wL+gioL0qVfGEKgVFkXblFSIBvfCY5
UfkGqo+1P+dKCJifENouDeiAK1b2aT4yAp7Rcjd7h7+AmOFsX2Pi+6+/rOWG
fiuYMQ8ONXwiYKPelJ887Amoq3QXpisICLfNSu2iVIOoyjki6CsBdVcTW3mR
ZVAbUbDOZpaA1+lL+NKoPLhK1ZpSKgk4VtZEFc40uP4HZOlUXQ==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {0., 59.99999898735507}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181745839426003`*^9},
 AspectRatioFixed->True]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 1105, 26, 112, "Input",
 Evaluatable->False],
Cell[1665, 48, 2850, 75, 312, "Input"],
Cell[4518, 125, 253, 7, 30, "Input"],
Cell[4774, 134, 948, 27, 92, "Input"],
Cell[CellGroupData[{
Cell[5747, 165, 403, 10, 31, "Input"],
Cell[6153, 177, 299, 10, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6489, 192, 171, 4, 31, "Input"],
Cell[6663, 198, 112, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6812, 205, 322, 9, 31, "Input"],
Cell[7137, 216, 2134, 42, 246, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

