(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     71901,       1366]
NotebookOptionsPosition[     70696,       1320]
NotebookOutlinePosition[     71256,       1342]
CellTagsIndexPosition[     71213,       1339]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "The", " ", "following", " ", "is", " ", "used", " ", "to", " ", "solve", 
   " ", "2", " ", "nonlinear", " ", 
   RowBox[{"equations", ".", "  ", "You"}], " ", "call", " ", "it", " ", "as",
    " ", 
   RowBox[{"follows", ":", "\n", 
    RowBox[{"Solve2NonLinear", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"eqn1", "==", "something"}], ",", " ", 
        RowBox[{"eqn2", "==", "other"}]}], "}"}], ",", 
      "NameOfIndependentVariable", ",", " ", "\n", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
        "Initial", " ", "value", " ", "of", " ", "Independent", " ", 
         "variable"}], ",", " ", 
        RowBox[{"Final", " ", "value", " ", "of", " ", 
         RowBox[{"indep", ".", " ", "var", "."}]}], " ", ",", " ", 
        RowBox[{"increment", " ", "of", " ", 
         RowBox[{"indep", ".", " ", "variable"}]}]}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"FirstVariableToFind", ",", "SecondVariableToFind"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"GuessAtFirstVariable", ",", "GuessAtSecondVariable"}], 
       "}"}]}], "]"}]}]}], "*)"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5181746730566*^9, 3.5181746981376*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Solve2NonLinear", "[", 
    RowBox[{
    "eqns_", ",", "iVar_", ",", "iVarStuff_", ",", "dVars_", ",", 
     "dVarInits_"}], "]"}], ":=", "\n", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "iStart", ",", "iFinish", ",", "iInc", ",", "iVarTable", ",", "npts", 
       ",", "sol", ",", "solTable"}], "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"SetAttributes", "[", 
       RowBox[{"Solve2NonLinear", ",", "HoldAll"}], "]"}], ";", "\n", 
      RowBox[{"iStart", "=", 
       RowBox[{"iVarStuff", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"iFinish", "=", 
       RowBox[{"iVarStuff", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"iInc", "=", 
       RowBox[{"iVarStuff", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], ";", "\n", 
      RowBox[{"iVarTable", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"i", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "iStart", ",", "iFinish", ",", "iInc"}], "}"}]}], 
        "]"}]}], ";", "\n", 
      RowBox[{"npts", "=", 
       RowBox[{"Length", "[", "iVarTable", "]"}]}], ";", "\n", 
      RowBox[{"sol", "=", "dVarInits"}], ";", "\n", 
      RowBox[{"solTable", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", "\n", "\t", 
            RowBox[{"sol", "=", 
             RowBox[{"dVars", "/.", "\n", "\t", 
              RowBox[{"FindRoot", "[", 
               RowBox[{
                RowBox[{"Evaluate", "[", 
                 RowBox[{"eqns", "/.", 
                  RowBox[{"iVar", "->", 
                   RowBox[{"iVarTable", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}], ",", "\n", 
                "\t", 
                RowBox[{"Evaluate", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"dVars", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"sol", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"dVars", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"sol", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], 
               "]"}]}]}], "}"}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "npts"}], "}"}]}], "]"}], ",", "1"}], 
        "]"}]}], ";", "\n", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Interpolation", "[", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"iVarTable", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"solTable", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "npts"}], "}"}]}], "]"}], "]"}], ",", 
        "\n", " ", 
        RowBox[{"Interpolation", "[", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"iVarTable", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"solTable", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "npts"}], "}"}]}], "]"}], "]"}]}], 
       "}"}]}]}], " ", "]"}]}], "\n"}]], "Input",
 CellChangeTimes->{{3.5181746736566*^9, 3.5181746736586*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"eqs", ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"l", " ", 
       RowBox[{"Cos", "[", "th", "]"}]}], "+", " ", 
      RowBox[{"2", " ", "l", " ", 
       RowBox[{"Cos", "[", "gam", "]"}]}]}], "==", 
     RowBox[{
      RowBox[{"1.5", " ", "l"}], " ", "+", " ", 
      RowBox[{"2", " ", "l", " ", 
       RowBox[{"Cos", "[", "bet", "]"}]}]}]}], ",", "\n", "\t\t\t\t", 
    RowBox[{
     RowBox[{
      RowBox[{"l", " ", 
       RowBox[{"Sin", "[", "th", "]"}]}], " ", "+", " ", 
      RowBox[{"2", " ", "l", " ", 
       RowBox[{"Sin", "[", "gam", "]"}]}], " ", "-", " ", 
      RowBox[{"2", " ", "l", " ", 
       RowBox[{"Sin", "[", "bet", "]"}]}]}], " ", "==", " ", "0"}]}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.5181746750486*^9, 3.5181746750506*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"l", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"gamma", ",", "beta"}], "}"}], "=", 
  RowBox[{"Solve2NonLinear", "[", 
   RowBox[{"eqs", ",", "th", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"4", " ", "Pi"}], ",", 
      RowBox[{"10", " ", "Degree"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"gam", ",", "bet"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{".1", ",", ".5"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5181746768936*^9, 3.5181746768956003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Table", "::", "itflrw"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Warning: In evaluating \[NoBreak]\\!\\(Floor[\\(\\(1 + \
\\(2\\\\ \[Pi]\\)\\/\\(5\\\\ \[Degree]\\)\\)\\)]\\)\[NoBreak] to find the \
number of iterations to use for \[NoBreak]\\!\\(Table\\)\[NoBreak], \
$MaxExtraPrecision = \[NoBreak]\\!\\(50.`\\)\[NoBreak] was encountered. An \
upper estimate will be used for the number of iterations. \\!\\(\\*ButtonBox[\
\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/itflrw\\\", ButtonNote -> \
\\\"Table::itflrw\\\"]\\)\"\>"}]], "Message", "MSG",
 Evaluatable->False,
 CellChangeTimes->{3.5181747041656*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"InterpolatingFunction", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0.`", ",", "12.566370614359172`"}], "}"}], "}"}], 
      ",", "\<\"<>\"\>"}], "]"}],
    False,
    Editable->False], ",", 
   TagBox[
    RowBox[{"InterpolatingFunction", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0.`", ",", "12.566370614359172`"}], "}"}], "}"}], 
      ",", "\<\"<>\"\>"}], "]"}],
    False,
    Editable->False]}], "}"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181747042066*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell["", "Input",
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"gamma", "[", "th", "]"}], ",", 
     RowBox[{"beta", "[", "th", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "0", ",", 
     RowBox[{"720", " ", "Degree"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181746806306*^9, 3.5181746806326*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwdmXk8VP/3x4dUKkQY+9hiRgsJpSznkBCSPdlClpKESvZStiRJ8UGhFS0U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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwV2Xk81M8bAHB2Pxspx9p1LnLtLlLpokvzpEOlnCFJSulwhUTKUcpRjhzl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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.5},
  PlotRange->
   NCache[{{0, 720 Degree}, {0.5053275277200432, 2.636264804402363}}, {{
     0, 12.566370614359172`}, {0.5053275277200432, 2.636264804402363}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181747133856*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"gamma", "[", "th", "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "0", ",", 
     RowBox[{"720", " ", "Degree"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181746831966*^9, 3.5181746831986*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwdmXk8VP/3x4dUKkQY+9hiRgsJpSznkBCSPdlClpKESvZStiRJ8UGhFS0U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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.6000000000000001},
  PlotRange->
   NCache[{{0, 720 Degree}, {0.5053275277200432, 2.0472306631485684`}}, {{
     0, 12.566370614359172`}, {0.5053275277200432, 2.0472306631485684`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181747149365997`*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"beta", "[", "th", "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "0", ",", 
     RowBox[{"720", " ", "Degree"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181746849656*^9, 3.5181746849676*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV2Xk81M8bAHB2Pxspx9p1LnLtLlLpokvzpEOlnCFJSulwhUTKUcpRjhzl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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 1.2000000000000002`},
  PlotRange->
   NCache[{{0, 720 Degree}, {1.0943621623204542`, 2.636264804402363}}, {{
     0, 12.566370614359172`}, {1.0943621623204542`, 2.636264804402363}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181747165536003`*^9},
 AspectRatioFixed->True]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 1281, 32, 92, "Input",
 Evaluatable->False],
Cell[1841, 54, 3818, 99, 352, "Input"],
Cell[5662, 155, 844, 24, 52, "Input"],
Cell[CellGroupData[{
Cell[6531, 183, 576, 17, 52, "Input"],
Cell[7110, 202, 763, 15, 41, "Message",
 Evaluatable->False],
Cell[7876, 219, 639, 23, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[8530, 245, 42, 1, 31, "Input"],
Cell[CellGroupData[{
Cell[8597, 250, 380, 11, 31, "Input"],
Cell[8980, 263, 30236, 504, 244, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[39253, 772, 319, 9, 31, "Input"],
Cell[39575, 783, 15366, 259, 235, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[54978, 1047, 318, 9, 31, "Input"],
Cell[55299, 1058, 15381, 259, 232, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

