(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     19225,        531]
NotebookOptionsPosition[     17551,        466]
NotebookOutlinePosition[     18111,        488]
CellTagsIndexPosition[     18068,        485]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Viscous table", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "x_", "]"}], ":=", 
  RowBox[{"v0", " ", "-", " ", 
   RowBox[{
    RowBox[{"c", "/", "mp"}], " ", "x"}]}]}]], "Input",
 CellChangeTimes->{{3.5181738425116*^9, 3.5181738425136003`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.5181738439955997`*^9, 3.5181738439976*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"v0", "-", 
  FractionBox[
   RowBox[{"0.2`", " ", "x"}], "mp"]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181738638886003`*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"3", " ", "-", " ", 
    RowBox[{".5", " ", "x"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181738451605997`*^9, 3.5181738451626*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl1H081AccB/DD8ZMSxzkljOKUHlSrjay+37RqWcf15KRm51mlOw8jD5HY
UXKeTtsueTil7hYxXtWyFbfEtaJaNilOrkyo4ZBnt99e++P7+r7er8/r8/3z
a+vP3xukTaFQWOT8tye+5BWy+clbfuIoxjUaAtMCHZY/ZvpCRqKhyGqOwOZ/
3hwVMnngf2nvGtcZAodqtmWGMZPAdLAjMGaCwBTGiOVhZhZEpw0/fTdE4MMm
9559zCJwvmFR3t5NIL8k5oEn8zrUmRzn1twjUJ6Z+QuLeReam2kPgtMJ1NWL
JPqOPoYn/IZbUiqBu075CW54tcH8t7Kr+Rl6eCsuqLPsqRKCpCtKe0z0sN3n
mFPkiddQlm9SS8vVRdpOYbAce8Gas+ZZr7kuGrcGVX96aACSttfME+dTcZlN
mEzgPwgzCX+4V5pS0bnz+MOtecNQfcZOyC/QQflU8u7WghFgy7veGSzWwdA6
heJuyhgwnzSz2MXaKA64amHGHQcLB6/bUw7auNq7+8Nc0CSMyXa6JV/RQuWI
ZwvumgZ9nbBHlau1UN21eC3jwCxQz0xG1f5IwZxr8SEcjgYsD9gyHR0pyDTS
Z8UWUPDF0Hh1eqAGboYnX8sq1kL37FP7I7hz0GovIvbkaeOqF2ET14/Pgl3q
s+VfiXWw4+SqttLgGXBhd20oLqBiU6XNQ27gNHSGC7YIM3VxWXa8PDJqCqpd
Dhrez9VDj8Yr6k28SWB4NbVLBQT2y5yZnPgJABUl97dv9FFupeFtPjcOYkao
ITN2Hob0fa9uT/8AKUVH0jceNcAkv+9ifz8/BoUtPzRmhc/HgHUhLhHZo5DI
Ew1ZRS7A1NwwI5VwBAb8li866G+IZkVtvVcK1XButp+qDF6I0dpm07biYah9
t3NwoY8R7jD92Xi4bAj+sndWbbIzRmnoRyfo/EEIXRHgJCozRq5PlFvNkfcg
9zqUsNWahjOX80ym0gbgY+9+GV1Cww3FXt4VCX0QlrqjbfMSE2Sre0r1Rb1w
Jlh/Sktkgq+ClOYTNT1wx8pP0083xQVnE7T3l7+G23NpOo5Zpmip+2aY09QN
LTXb+oU0Oub4qSpyorrgvk1wY2YeHZ9PtjwSH3sJ3946IOk2MMNX2/aOqaVt
cHhph+8hoRnavLeeZ3/+GUzfdFqykmAgO4fK8hA+hpM6fY/OJzEQFfx1lxgK
YNi5+NlTzBETXz7fN10HJ3heowZx5mizbn20RFkFlp8EKpgJ5pj8WdwIs6AK
6mcjLrolmiPli/qIck4VGAiFn8efJvM7Fzt4kkooutaQ33eW9KI/Wy4IKqDx
7fqNigukW7bXqFkyoAcYxQh+JfuuDidLlSVw29HKXXLXHOv33Iit4JSAr9rR
+k49mT9N6w+XFIP09I7G0QbSq+o6LgoKwbUkkRHYTN5TOclHWWLw7xy46aYk
c09axmVlDhBlkxm+r0hP+uhFS7KhPIz4Ol5Fer9ookQghA/TS4nqv0kbUDsn
WGchw8KHYztIOqanTKpMBidVyMrNw6RLXdfKBInQKovWeI+Q9i6na3nEgbVL
7tWccdINws4qZTjcoxQnlE+SHp1JpXkcgVBFuadimjRXuVuu5MKCnNplb2ZJ
l5xaqVKy4f+/RZpCKWLzw7f8C8g/Mog=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 6}, {0., 2.99999993877551}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181738649646*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"t", "=", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"v", "[", "x", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "chi"}], "}"}]}], "]"}], " ", "/.", 
   RowBox[{"chi", "->", "x"}]}]}]], "Input",
 CellChangeTimes->{{3.5181738473786*^9, 3.5181738473806*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{"mp", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"5.`", " ", 
       RowBox[{"Log", "[", 
        RowBox[{"mp", " ", "v0"}], "]"}]}], "-", 
      RowBox[{"5.`", " ", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"mp", " ", "v0"}], "-", 
         RowBox[{"0.2`", " ", "x"}]}], "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", 
      FractionBox[
       RowBox[{"mp", " ", "v0"}], "x"], "]"}], "\[GreaterEqual]", "0.2`"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", 
      FractionBox[
       RowBox[{"mp", " ", "v0"}], "x"], "]"}], "\[LessEqual]", "0"}], "||", 
    RowBox[{
     FractionBox[
      RowBox[{"mp", " ", "v0"}], "x"], "\[NotElement]", "Reals"}]}]}], 
  "]"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181738785146*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "t", "]"}]], "Input",
 CellChangeTimes->{{3.5181738485206003`*^9, 3.5181738485226*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   RowBox[{"mp", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"5.`", " ", 
       RowBox[{"Log", "[", 
        RowBox[{"mp", " ", "v0"}], "]"}]}], "-", 
      RowBox[{"5.`", " ", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"mp", " ", "v0"}], "-", 
         RowBox[{"0.2`", " ", "x"}]}], "]"}]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", 
      FractionBox[
       RowBox[{"mp", " ", "v0"}], "x"], "]"}], "\[GreaterEqual]", "0.2`"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", 
      FractionBox[
       RowBox[{"mp", " ", "v0"}], "x"], "]"}], "\[LessEqual]", "0"}], "||", 
    RowBox[{
     FractionBox[
      RowBox[{"mp", " ", "v0"}], "x"], "\[NotElement]", "Reals"}]}]}], 
  "]"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181738786026*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", " ", 
  RowBox[{
   RowBox[{"2", " ", 
    RowBox[{"Log", "[", 
     RowBox[{"3", "/", 
      RowBox[{"(", 
       RowBox[{"3", " ", "-", " ", 
        RowBox[{".5", " ", "x"}]}], ")"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "5.9"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181738505546*^9, 3.5181738505566*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVUHk4lvkCtZMln295X+uHRsSMpsiS6vsdoybJcrNUhuxRJEIqsmZrUVGR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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 5.9}, {0., 8.18868671628239}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{{3.5181738786336*^9, 3.5181738842216*^9}},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Dry Table", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"v2", "[", "x_", "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{"v0", " ", "-", " ", 
    RowBox[{"2", " ", "mu", " ", "g", " ", "x"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5181738538406*^9, 3.5181738538426*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"9", "-", 
     RowBox[{"2", " ", "x"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4.5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181738550746*^9, 3.5181738550766*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVkXk8FHgfx8c4xrXMr9zS5CiVfbJKaMn3y0PtltVujs0mlQeFnEl6dUhG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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 4.5}, {0., 2.999999969387755}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181739249726*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"t2", "=", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"v2", "[", "x", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "chi"}], "}"}]}], "]"}], "/.", 
   RowBox[{"chi", "->", "x"}]}]}]], "Input",
 CellChangeTimes->{{3.5181738568436003`*^9, 3.5181738568456*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"0.03105590062111801`", " ", 
      SqrtBox["v0"]}], "-", 
     RowBox[{"0.03105590062111801`", " ", 
      SqrtBox[
       RowBox[{"v0", "-", 
        RowBox[{"64.4`", " ", "mu", " ", "x"}]}]]}]}], "mu"], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", 
      FractionBox["v0", 
       RowBox[{"mu", " ", "x"}]], "]"}], "\[GreaterEqual]", "64.4`"}], "||", 
    RowBox[{
     RowBox[{"Re", "[", 
      FractionBox["v0", 
       RowBox[{"mu", " ", "x"}]], "]"}], "\[LessEqual]", "0"}], "||", 
    RowBox[{
     FractionBox["v0", 
      RowBox[{"mu", " ", "x"}]], "\[NotElement]", "Reals"}]}]}], 
  "]"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181739498746*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sqrt", "[", "9", "]"}], " ", "-", " ", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"9", "-", 
      RowBox[{"2", " ", "x"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4.5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5181738585706*^9, 3.5181738585726*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVUnk81fkaPud3FjvnW0j2NnvRjKuDxvvqpuaOUmPnUm6JTI2lhjETIUs6
xpIwGGVtm8Q0SEPZGlHIek1Cjixjd+zHluv+8Xye9/N5/nme5312nPGxPkfR
aLRvN/F/nvfbMyG8F2i2eWad9HEzc49ROaV02x5o6nuLPDTNYHuRLmcswwNo
/MfXn2tawfyrz7xaMwKAlmUleKN1CvpPPpWrzYgCWlD2ne263vBOTjhekZEC
tIkv+a36V8FGqPBXecY9oGnnlDsYx8FNr4fHyjKeQmjm5Ja4Y3cgPCK5dl9C
HdAOl4QOVhTC92piu0XDWkE9cE7NpbgUvlKS9Dio8hdUlWrk5AZUwhHRHUd1
P+8Fg3clpulrL+H4wqjkTd9+8A0MsnxLqwfJ0421XhGDUBWo87Xh+UZQVCAw
eONvwLhk3jn3Fuho2P3kzL/HIGvkyX88/dtgV2D1pQqvSRCcHlqEsg6Ij0+R
l9kpAO7t9tjovk4o5q23y0TPQOhhgys9tC7YRWkbh0jOQQLHCqMcu2FksTxd
EDAPHHbpWHd8Lyx5bs1r2ViAqp/fGBdv9EEBLSM2LGwJhJfGjV8a9UO5/E+X
DUeFYEAVnlN0/QhbHiLd3mcF6qdTp52zB6DymUvMD92rkAT+i1Mdg1B6+IsX
Eh7rINmuwevVHAZ7oVWz9+gnQHWidPfHv+Gu7OCUlzYNfRWHzro+HwGLceqN
zSQNU930HZ6qjUFCqF2uWR4d1/hrGqt+41DwsGripgOFgkP1hjJ/TsAsR5qn
rMhA7uDH1hCTKeg3it/zoJmBQluF4dTMaVhIn5W9kMTEwiSXe6+TBdCb6P1d
ih0LS17qvWO5zoDPv1TbasTY6FA5onhdaRY0zX4L12hio/MBa3729CzwZvw/
jwkXQa7xnl8Pls9BFdfWxtFIFJ/YHXeMjZ4H5QrZOhehKCZ23Jhy9F7Y7FfM
+MxjMYybaftl1XIRTkT0fbrjJ47rZgYNdIsl0KgdrenRkkD5IAnZMiMhtKRJ
Ll3rkcAC8b3p5/cuQ1Y+CXHLlETretYze4sVULr6FQvspDCkPzx3zmEVymPP
9dkqSuP3IiesshPXQH9/mnZ7tzRK8W5EWfSsg9Ut2iXrBBk0+c3j0EWNDXi9
fc91pg4HrR4pR/3Xjobmr8/aukVykJd2drlTlY65NQVOgg8cdNa2Oay3Tkdm
0QVRfz4HH/D0jbh0Cj1ytUqX+zf1q7uGjrAo1InIkWUMcfDKgeqEi1IU/m6R
0iw3zsHLt9WrulQorKoPtjBd4mDN6/omBAp73x7bHyVD8MtgqWHfCArNKsX4
4oTgbhVY40dTmFX4Ki5+C8GOLR8LbWMpdE/AiVQ5gibjBluPplA48bXh/UdK
BPPUFBsdH1C40qGk0qpJsPbEbAa3icJt3WOiykiw1VNSmru5g8XP8v6IMidY
JdDf0a3KwE6e6zczhwiu/5CVdW0XA5NMWhpeWRD0dHiwrU+PgZz0kjg/S4LD
9BnnZmCguFOobJ09QQ8jr4o0DwaudcqpX/qWoJTUNmPLZwzs3tfc0uNN8ENp
tV36CwaWRUWHHfUlONhSpyCoYWCg0epH5csEczUClwqbGLiQzL9bF0iw2nea
ihhg4JTtI12VCIIBHrryP3OY2N+GB+rTCT7f/SrmvB8TM7Qs5V0zCO4gjUM/
BTLR8ardwsxtgpkavNbKECa2aH9TpJS96f9Ph0brOCZWhN7S97lPUHR8QJ+b
z8T0fcOa8sUEs8/LXvccZ6J9hID9qITgolxb+MM5JpL3K0NQSrCta6sKtcbE
6EiZPK8ygvlhdM0VSRYG9HDVX1QRZGs/1lYxYKENL0bBvYngRZt6U5UgFkrz
k5eEbzf/9129kXkUC9/8I6sztoVg3cy4V3wCCw/1FyeVthNMDU7SK7rLQgPu
B47Ee4Jp0id73NpYOBE7Mp3ZvZn3CvlR9QML7w/MvjXsJciPTNBTHWOharxI
7Ck+wb4B4/RFio2SwwZivw8T3J9zXLmYy8Z6U9ORIyMEX1gbm2ofZWP4TYu6
7lGCcC14XMmejSsHnSNZk5v9jkXeKvJn49NEd/f0KYKjfKf+oCg2+o14/1Nf
QDBR+gs36VQ2jtwKpzvNEewxlzsrXcHGvNFY/uQ8QZ3+Cw5dbWw8DamV1xYJ
uu5EHYNRNiom59zZJiTY8P4P6gpdBDvH8oPzlwkWMNbKnJRFMBFLXcxXCb68
WubVZSKCVinVpp1rBCmRyXL2aREUn2hQvPCJ4M4NrQN6cSJYa965vLFB0PKd
ipXahgj+D6CXBCM=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 4.5}, {0., 2.9995714285715045`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181740378436003`*^9},
 AspectRatioFixed->True]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 75, 2, 29, "Text",
 Evaluatable->False],
Cell[635, 24, 254, 7, 31, "Input"],
Cell[CellGroupData[{
Cell[914, 35, 145, 3, 31, "Input"],
Cell[1062, 40, 190, 6, 49, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[1289, 51, 290, 8, 31, "Input"],
Cell[1582, 61, 2109, 42, 245, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[3728, 108, 377, 11, 31, "Input"],
Cell[4108, 121, 898, 29, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[5043, 155, 152, 3, 31, "Input"],
Cell[5198, 160, 898, 29, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[6133, 194, 410, 12, 31, "Input"],
Cell[6546, 208, 3077, 58, 247, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[9638, 269, 71, 2, 29, "Text",
 Evaluatable->False],
Cell[9712, 273, 279, 7, 31, "Input"],
Cell[CellGroupData[{
Cell[10016, 284, 311, 9, 31, "Input"],
Cell[10330, 295, 2779, 53, 244, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[13146, 353, 378, 11, 31, "Input"],
Cell[13527, 366, 814, 26, 51, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[14378, 397, 381, 11, 31, "Input"],
Cell[14762, 410, 2773, 53, 244, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

