(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     66588,       1472]
NotebookOptionsPosition[     64820,       1407]
NotebookOutlinePosition[     65380,       1429]
CellTagsIndexPosition[     65337,       1426]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["The following input defines some constants.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"L", " ", "=", " ", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DD", " ", "=", " ", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"g", " ", "=", " ", "9.81"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"thetadot", " ", "=", " ", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"thetanot", " ", "=", " ", 
   RowBox[{
    RowBox[{"-", "30"}], " ", 
    RowBox[{"Pi", "/", "180"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"thetaend", " ", "=", " ", 
   RowBox[{"180", " ", 
    RowBox[{"Pi", "/", "180"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5181740548836*^9, 3.5181740548845997`*^9}},
 AspectRatioFixed->True],

Cell["The following the the equation for Theta versus time.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"theta", "[", "t_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"thetadot", " ", "t"}], " ", "+", " ", "thetanot"}]}]], "Input",
 CellChangeTimes->{{3.5181740579136*^9, 3.5181740579156*^9}},
 AspectRatioFixed->True],

Cell["\<\
The following is time given Theta.\
\>", "Text",
 Evaluatable->False,
 CellChangeTimes->{{3.5181740825746*^9, 3.5181740861556*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tt", "[", "theta_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"theta", "-", "thetanot"}], ")"}], "/", "thetadot"}]}], "\n", 
 RowBox[{
  RowBox[{"tend", " ", "=", " ", 
   RowBox[{"tt", "[", "thetaend", "]"}]}], ";"}], "\n", 
 RowBox[{"tend", "//", "N"}]}], "Input",
 CellChangeTimes->{{3.5181740594196*^9, 3.5181740594216003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData["0.3665191429188092`"], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181740805696*^9, 3.5181741296926003`*^9, 
  3.5181744104356003`*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell["\<\
The following two equations are from the equations of motion.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"gamma", "[", 
   RowBox[{"beta_", ",", "t_"}], "]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"Pi", " ", "/", "2"}], " ", "+", " ", 
   RowBox[{"theta", "[", "t", "]"}], " ", "-", " ", "beta"}]}], "\n", 
 RowBox[{
  RowBox[{"foverm", "[", 
   RowBox[{"beta_", ",", "betadot_", ",", "t_"}], "]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"thetadot", "^", "2"}], " ", "DD", " ", 
    RowBox[{"Cos", "[", "beta", "]"}]}], " ", "+", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"betadot", "-", "thetadot"}], ")"}], "^", "2"}], " ", "L"}], 
   " ", "+", " ", 
   RowBox[{"g", " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"gamma", "[", 
      RowBox[{"beta", ",", "t"}], "]"}], "]"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.5181740618596*^9, 3.5181740618616*^9}, {
  3.5181741160036*^9, 3.5181741211586*^9}, {3.5181743444226*^9, 
  3.5181743812386*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "beta"}], "+", 
  FractionBox["\[Pi]", "3"], "+", 
  RowBox[{"10", " ", "t"}]}]], "Output",
 CellChangeTimes->{{3.5181743491566*^9, 3.5181743747796*^9}, 
   3.5181744133496*^9}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "10"}], "+", "betadot"}], ")"}], "2"], "+", 
  RowBox[{"200", " ", 
   RowBox[{"Cos", "[", "beta", "]"}]}], "+", 
  RowBox[{"9.81`", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"beta", "+", 
     FractionBox["\[Pi]", "6"], "-", 
     RowBox[{"10", " ", "t"}]}], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.5181743491566*^9, 3.5181743747796*^9}, 
   3.5181744133536*^9}]
}, Open  ]],

Cell["The following is integrating the equation for Beta.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"u", "'"}], "[", "t", "]"}], "==", 
       RowBox[{
        RowBox[{"g", " ", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{"gamma", "[", 
            RowBox[{
             RowBox[{"beta", "[", "t", "]"}], ",", "t"}], "]"}], "]"}], "/", 
          "L"}]}], " ", "-", " ", 
        RowBox[{
         RowBox[{"thetadot", "^", "2"}], " ", 
         RowBox[{"DD", "/", "L"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"beta", "[", "t", "]"}], "]"}]}]}]}], ",", 
      "\[IndentingNewLine]", "\t", 
      RowBox[{
       RowBox[{
        RowBox[{"beta", "'"}], "[", "t", "]"}], " ", "==", " ", 
       RowBox[{"u", "[", "t", "]"}]}], ",", "\n", "\t\t", 
      RowBox[{
       RowBox[{"beta", "[", "0", "]"}], "==", 
       RowBox[{"-", "thetanot"}]}], ",", "\[IndentingNewLine]", "\t", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], "==", 
       RowBox[{"-", "thetadot"}]}]}], "}"}], ",", "\n", "\t\t", 
    RowBox[{"{", 
     RowBox[{"beta", ",", "u"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "tend"}], "}"}], ",", 
    RowBox[{"MaxSteps", "->", "1000"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5181740641696*^9, 3.5181740641716003`*^9}, {
   3.5181741811626*^9, 3.5181741931776*^9}, 3.5181744244876003`*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"beta", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "0.3665191429188092`"}], "}"}], "}"}], 
        ",", "\<\"<>\"\>"}], "]"}],
      False,
      Editable->False]}], ",", 
    RowBox[{"u", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "0.3665191429188092`"}], "}"}], "}"}], 
        ",", "\<\"<>\"\>"}], "]"}],
      False,
      Editable->False]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5181744248076*^9}]
}, Open  ]],

Cell["\<\
The first plot is theta versus time.
The second is beta versus time
Third is beta versus theta.
Last is F/m versus theta.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"theta", "[", "t", "]"}], " ", 
    RowBox[{"180", "/", "Pi"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"foverm", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"beta", "[", "t", "]"}], "/.", "sol"}], "]"}], ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], "/.", "sol"}], "]"}], ",", "t"}], "]"}], 
   ",", "\n", "\t", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"180", "/", "Pi"}], " ", 
      RowBox[{"beta", "[", 
       RowBox[{"tt", "[", 
        RowBox[{"thet", " ", 
         RowBox[{"Pi", "/", "180"}]}], "]"}], "]"}]}], "/.", "sol"}], "]"}], 
   ",", "\n", "\t", 
   RowBox[{"{", 
    RowBox[{"thet", ",", 
     RowBox[{"thetanot", " ", 
      RowBox[{"180", "/", "Pi"}]}], ",", 
     RowBox[{"thetaend", " ", 
      RowBox[{"180", "/", "Pi"}]}]}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"foverm", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"beta", "[", 
        RowBox[{"tt", "[", 
         RowBox[{"thet", " ", 
          RowBox[{"Pi", "/", "180"}]}], "]"}], "]"}], "/.", "sol"}], "]"}], 
     ",", "\n", "\t", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"u", "[", 
        RowBox[{"tt", "[", 
         RowBox[{"thet", " ", 
          RowBox[{"Pi", "/", "180"}]}], "]"}], "]"}], "/.", "sol"}], "]"}], 
     ",", 
     RowBox[{"tt", "[", 
      RowBox[{"thet", " ", 
       RowBox[{"Pi", "/", "180"}]}], "]"}]}], "]"}], ",", "\n", "\t", 
   RowBox[{"{", 
    RowBox[{"thet", ",", 
     RowBox[{"thetanot", " ", 
      RowBox[{"180", "/", "Pi"}]}], ",", 
     RowBox[{"thetaend", " ", 
      RowBox[{"180", "/", "Pi"}]}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5181740657626*^9, 3.5181740657656*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVznk4lAkcwHFUOtb9sMgVKxk6SJZpmn6/JemikiNpHoaZt1FKtBrEot2y
rUT7lNgI2UWUGsdkJfMicjSTmfDK0ehAxyaxNaLMtn98n8+/X8vQSB+umoqK
itfX/lc/KWWKpoMbdyqNapVKJmkVOhK4MdYMflwibD35jkmaXmAaz/FXQY7B
np4FciZpfOPV9BCfCaP26ZPfNDDJ7L9FL8V8L/hpr+oqowQmSYnKhlv4LCgX
vCp0mN5AKtwKBhv5h2Expy6NPcEgU+df7hfxE6GpLSi4eZhOVk2/l8yrOQdB
so+e93jOZO596b6sh1kQVqF158IGR1I8fHfaxeIKPFF7fLFymx3Zxy5f1KBe
BG40D1fhQUvS24Thb1lXDNqv/OSCTXpkHt3yaU99GWRpFQzrM6pFz+d2qUqv
V8AlDXrLop26aKgeKji9UgCyEpV+uXwZ2olak73sqkBja7WEbKchmoon1qnX
gNDKJUBVyxGlO2LLRX1CeErztltt5YySm5L5U7JaGJ3QqDfLoKNE2Dq3ubwO
4ke8m5m3mMiYCL/kXl4P/+7I3aRj8AN+90UQ/7ywAcrsV+ekerrjQspLuZtB
gm1hiq2hrwdWbsnOPE1vhIyPtoaL0j0x+KxTdKdNEzQ9O4+6BVvRLdy66MWK
ZpBXeLefkG/H5zcPxO20vgdJSaXuEfreeKptNr9DuwWiptgJdbq7kBU/YrBU
uxWWXso5HblmN7rMWQzGfWkFG/W1FQ7rfVDy5rqn/dh9OKbIllTDHsyNzlAT
vGiD6r5rV8KDfPFQZ5Omp7Qd9p8yOWvH8cOjd7fzBNIOUFi60Ex/9kcn4xW8
w+JO6EZLUVduACo276ml1z4APfuI6PNFe3FSsyegXyiGbQvYPSfJQBwvLvFM
+1MCI2VCv+SOfVh67cFgevpDEMn6JfgwCB9cLQpZ69EF516XKhxf78eWwMWz
y+90QbOYYq6ZZGHgkPHdeQwpjBfccmLpBON4u09JeKUURBYxRZ2aIRj6Zh0n
doUMbBziaB2ZIRj1uHFLVLEMzrj6LHxqzsYUB77fpOkjyCsemEosYuNKX+oM
K+8RVGisd3VyCkXh9eHMKJNueFKlnN5KhiIe0SM1z3dDAxnTNuoehtzP499e
0OmBP1rId5dlYZg2NXXxamoP0Bzql1MBHMy0uDoW+LkHqAHzvmP9HHQwmg2Z
je+FlCT/Z7Y8LkrjEtSWv++FwV83zob9w8VdOTaF66Z6gX551aHKcS5Kartg
04deyLphOqDynosdCuvEsE+94CWbqcv7wMXmGLGiUJWCBpPb8dQcF2uizN+a
61GQX7FmZpsugTnhJGXkREFY97JPjt8TaHTm4HFbZwoaR7XDk10JzCrVN3B1
ocDs01yfZD2Bv4/xfAIYFDwyG6o9BASmcXXFF90p8DiQE/vXFgIT2aFNer4U
2MzoThsFEfg5WYNt5U/BLxqqvAMsAuMLhErHvRTIzSeommACj8uXMHfvpyDb
XXLbh0NgJKvqdgaHgsXpv/HPHiZwPIHln09QQOTHjfVHEhiRu/BDBe/rn4AX
QIsmkDcQtFYSQUF872aX1uMEjs4skA4doaD3pXOJfhyBnKW3It8epcBx1tow
7ASBz+j7tL5EU5CuqZ8qSCSQHTj/hkYMBW8s5imUSQT+B80fWBc=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{0, Rational[7, 60] Pi}, {-29.999995714285713`, 
     179.99999571428575`}}, {{0, 0.3665191429188092}, {-29.999995714285713`, 
     179.99999571428575`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181741026456003`*^9, 3.5181744307466*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV2Hk41N8XB3BJqBCSsgshe1GSdG5S2UJICCWz2VJKtFjCSNmSLbLvSZaU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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 200.},
  PlotRange->
   NCache[{{0, Rational[7, 60] Pi}, {159.2583683241105, 
     688.3231347157935}}, {{0, 0.3665191429188092}, {159.2583683241105, 
     688.3231347157935}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181741026456003`*^9, 3.5181744307995996`*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwd1nk8VOv/AHBLlptkiRIhS0VkyVoMH2Y5xwyzWStutpkUReSKRGlBiLIU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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-30, 180}, {-48.452952558499334`, 41.595703308089966`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181741026456003`*^9, 3.5181744308016*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV2Hk8VF8bAHDZkl3Z933NvpbwiErIbuyM5t6ZKUsiStkZaZHSYgkpS6Jk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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 200.},
  PlotRange->{{-30, 180}, {159.25836832411048`, 688.3231347157935}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181741026456003`*^9, 3.5181744308686*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell["\<\
The following produces a column of numbers which will be imported to a \
spreadsheet for 
plotting.  First column is theta in degrees, second is F/m third is beta in \
degrees.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", "\n", "  ", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"180", "/", "Pi"}], " ", 
        RowBox[{"theta", "[", 
         RowBox[{"tt", "[", 
          RowBox[{"thet", " ", 
           RowBox[{"Pi", "/", "180"}]}], "]"}], "]"}]}], "//", "N"}], ",", 
      "\n", "  ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"foverm", "[", 
          RowBox[{
           RowBox[{"Evaluate", "[", 
            RowBox[{
             RowBox[{"beta", "[", 
              RowBox[{"tt", "[", 
               RowBox[{"thet", " ", 
                RowBox[{"Pi", "/", "180"}]}], "]"}], "]"}], "/.", "sol"}], 
            "]"}], ",", "\n", "    ", 
           RowBox[{"Evaluate", "[", 
            RowBox[{
             RowBox[{"u", "[", 
              RowBox[{"tt", "[", 
               RowBox[{"thet", " ", 
                RowBox[{"Pi", "/", "180"}]}], "]"}], "]"}], "/.", "sol"}], 
            "]"}], ",", 
           RowBox[{"tt", "[", 
            RowBox[{"thet", " ", 
             RowBox[{"Pi", "/", "180"}]}], "]"}]}], "]"}], "//", "N"}], ")"}],
        "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "\n", "  ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Evaluate", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"180", "/", "Pi"}], " ", 
            RowBox[{"beta", "[", 
             RowBox[{"tt", "[", 
              RowBox[{"thet", " ", 
               RowBox[{"Pi", "/", "180"}]}], "]"}], "]"}]}], "/.", "sol"}], 
          "]"}], "//", "N"}], ")"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "\n", "    ", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"thet", ",", 
      RowBox[{"thetanot", " ", 
       RowBox[{"180", "/", "Pi"}]}], ",", 
      RowBox[{"thetaend", " ", 
       RowBox[{"180", "/", "Pi"}]}]}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5181740699365997`*^9, 3.5181740699386*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "30.`"}], "581.7007899680132`", "30.`"},
     {
      RowBox[{"-", "29.`"}], "589.8051238592426`", "28.99179803816434`"},
     {
      RowBox[{"-", "28.`"}], "597.6820465252849`", "27.967586498891787`"},
     {
      RowBox[{"-", "27.`"}], "605.3165855558556`", "26.927964028668782`"},
     {
      RowBox[{"-", "26.`"}], "612.6940696242887`", "25.873542593836998`"},
     {
      RowBox[{"-", "25.`"}], "619.800171333755`", "24.80494648839476`"},
     {
      RowBox[{"-", "24.`"}], "626.6209550540739`", "23.722811858162466`"},
     {
      RowBox[{"-", "23.`"}], "633.1429242682609`", "22.62778585948663`"},
     {
      RowBox[{"-", "22.`"}], "639.3531173006473`", "21.520529541693115`"},
     {
      RowBox[{"-", "21.`"}], "645.2390030004511`", "20.401709389234078`"},
     {
      RowBox[{"-", "20.`"}], "650.7887739383964`", "19.272006953758336`"},
     {
      RowBox[{"-", "19.`"}], "655.9911583993803`", "18.132109310830565`"},
     {
      RowBox[{"-", "18.`"}], "660.8355953066911`", "16.982714083513436`"},
     {
      RowBox[{"-", "17.`"}], "665.312214338236`", "15.82452647263536`"},
     {
      RowBox[{"-", "16.`"}], "669.4119415227069`", "14.658259760794072`"},
     {
      RowBox[{"-", "15.`"}], "673.1264387382124`", "13.48463285815233`"},
     {
      RowBox[{"-", "14.`"}], "676.4482541902998`", "12.304371919510128`"},
     {
      RowBox[{"-", "13.`"}], "679.3707186430229`", "11.118207214571278`"},
     {
      RowBox[{"-", "12.`"}], "681.8881137943386`", "9.926874557380003`"},
     {
      RowBox[{"-", "11.`"}], "683.9955592001252`", "8.731112744825342`"},
     {
      RowBox[{"-", "10.`"}], "685.6891469622433`", "7.5316641049706385`"},
     {
      RowBox[{"-", "9.`"}], "686.9658710910616`", "6.329272834352874`"},
     {
      RowBox[{"-", "8.`"}], "687.8236699045473`", "5.124684753887708`"},
     {
      RowBox[{"-", "7.`"}], "688.2614559978321`", "3.91864613964627`"},
     {
      RowBox[{"-", "6.`"}], "688.2791802720894`", "2.711902908695703`"},
     {
      RowBox[{"-", "5.`"}], "687.8775035657327`", "1.5052008241064017`"},
     {
      RowBox[{"-", "4.`"}], "687.0582957837382`", "0.2992825579636682`"},
     {
      RowBox[{"-", "3.`"}], "685.8242775085453`", 
      RowBox[{"-", "0.905111455750194`"}]},
     {
      RowBox[{"-", "2.`"}], "684.1789387487237`", 
      RowBox[{"-", "2.107242338812151`"}]},
     {
      RowBox[{"-", "1.`"}], "682.1269543181334`", 
      RowBox[{"-", "3.3063788486039702`"}]},
     {"0.`", "679.6736820453733`", 
      RowBox[{"-", "4.501791918782306`"}]},
     {"1.`", "676.8253223888196`", 
      RowBox[{"-", "5.692757556132149`"}]},
     {"2.`", "673.5890999606524`", 
      RowBox[{"-", "6.8785623974905805`"}]},
     {"3.`", "669.9728042063774`", 
      RowBox[{"-", "8.05849478071645`"}]},
     {"4.`", "665.9850934244032`", 
      RowBox[{"-", "9.231853467180427`"}]},
     {"5.`", "661.6354186772597`", 
      RowBox[{"-", "10.39794815191648`"}]},
     {"6.`", "656.9337199785621`", 
      RowBox[{"-", "11.556090784414257`"}]},
     {"7.`", "651.890751145205`", 
      RowBox[{"-", "12.705609632100447`"}]},
     {"8.`", "646.5178183973328`", 
      RowBox[{"-", "13.8458417921273`"}]},
     {"9.`", "640.8266671085372`", 
      RowBox[{"-", "14.976129264849263`"}]},
     {"10.`", "634.8297099730968`", 
      RowBox[{"-", "16.09583475247015`"}]},
     {"11.`", "628.5397107231934`", 
      RowBox[{"-", "17.204326547856674`"}]},
     {"12.`", "621.9698196355656`", 
      RowBox[{"-", "18.300983139890693`"}]},
     {"13.`", "615.1336438059272`", 
      RowBox[{"-", "19.38520448370632`"}]},
     {"14.`", "608.0449977128842`", 
      RowBox[{"-", "20.456393858137993`"}]},
     {"15.`", "600.717993269573`", 
      RowBox[{"-", "21.51397145685783`"}]},
     {"16.`", "593.1669850201692`", 
      RowBox[{"-", "22.557376080446506`"}]},
     {"17.`", "585.40643008696`", 
      RowBox[{"-", "23.586049761932067`"}]},
     {"18.`", "577.4509523817757`", 
      RowBox[{"-", "24.59945765710285`"}]},
     {"19.`", "569.3152418186523`", 
      RowBox[{"-", "25.59707837538976`"}]},
     {"20.`", "561.0140024055651`", 
      RowBox[{"-", "26.578394376614902`"}]},
     {"21.`", "552.5619499640596`", 
      RowBox[{"-", "27.542918213960316`"}]},
     {"22.`", "543.9737404853972`", 
      RowBox[{"-", "28.490174900499948`"}]},
     {"23.`", "535.2639489097708`", 
      RowBox[{"-", "29.419689921612097`"}]},
     {"24.`", "526.4470374347212`", 
      RowBox[{"-", "30.33100980215777`"}]},
     {"25.`", "517.537281219673`", 
      RowBox[{"-", "31.223710294183956`"}]},
     {"26.`", "508.5487959795085`", 
      RowBox[{"-", "32.09736930615663`"}]},
     {"27.`", "499.49551438455353`", 
      RowBox[{"-", "32.95157044830232`"}]},
     {"28.`", "490.391070951291`", 
      RowBox[{"-", "33.78592940716967`"}]},
     {"29.`", "481.2488467651877`", 
      RowBox[{"-", "34.60007229553177`"}]},
     {"30.`", "472.081986979952`", 
      RowBox[{"-", "35.39362931281737`"}]},
     {"31.`", "462.90326526387577`", 
      RowBox[{"-", "36.166258062795784`"}]},
     {"32.`", "453.72514659953896`", 
      RowBox[{"-", "36.917627325174784`"}]},
     {"33.`", "444.559815159087`", 
      RowBox[{"-", "37.6474103784721`"}]},
     {"34.`", "435.4190206123086`", 
      RowBox[{"-", "38.355307449755294`"}]},
     {"35.`", "426.31417205997695`", 
      RowBox[{"-", "39.04102881992285`"}]},
     {"36.`", "417.2563668701834`", 
      RowBox[{"-", "39.70428953015532`"}]},
     {"37.`", "408.25623131782413`", 
      RowBox[{"-", "40.34483074093481`"}]},
     {"38.`", "399.32403517622`", 
      RowBox[{"-", "40.96240255038864`"}]},
     {"39.`", "390.46971645546654`", 
      RowBox[{"-", "41.55676006964158`"}]},
     {"40.`", "381.7027250675265`", 
      RowBox[{"-", "42.12768355755578`"}]},
     {"41.`", "373.03215120909624`", 
      RowBox[{"-", "42.67496114776213`"}]},
     {"42.`", "364.4667435360673`", 
      RowBox[{"-", "43.19838619632115`"}]},
     {"43.`", "356.01476353592335`", 
      RowBox[{"-", "43.69777607793199`"}]},
     {"44.`", "347.6841186487144`", 
      RowBox[{"-", "44.17295506550969`"}]},
     {"45.`", "339.482372900712`", 
      RowBox[{"-", "44.623752853569435`"}]},
     {"46.`", "331.4166171505714`", 
      RowBox[{"-", "45.05002200197838`"}]},
     {"47.`", "323.49359975872477`", 
      RowBox[{"-", "45.45162109262972`"}]},
     {"48.`", "315.71972991735805`", 
      RowBox[{"-", "45.82841431416385`"}]},
     {"49.`", "308.1009669415914`", 
      RowBox[{"-", "46.18028758213348`"}]},
     {"50.`", "300.64294225191685`", 
      RowBox[{"-", "46.50713206815707`"}]},
     {"51.`", "293.35096594511776`", 
      RowBox[{"-", "46.80884315146623`"}]},
     {"52.`", "286.2299096432274`", 
      RowBox[{"-", "47.08533973633058`"}]},
     {"53.`", "279.28431736889405`", 
      RowBox[{"-", "47.33654797200108`"}]},
     {"54.`", "272.5184486425708`", 
      RowBox[{"-", "47.562394180680855`"}]},
     {"55.`", "265.9362047620134`", 
      RowBox[{"-", "47.76281772223128`"}]},
     {"56.`", "259.54109641329944`", 
      RowBox[{"-", "47.93777984243847`"}]},
     {"57.`", "253.3363508329697`", 
      RowBox[{"-", "48.08724387858289`"}]},
     {"58.`", "247.32491536625503`", 
      RowBox[{"-", "48.21117423542951`"}]},
     {"59.`", "241.5093820729961`", 
      RowBox[{"-", "48.30955389085222`"}]},
     {"60.`", "235.89201520459685`", 
      RowBox[{"-", "48.38238157546996`"}]},
     {"61.`", "230.47481075149798`", 
      RowBox[{"-", "48.42965651863548`"}]},
     {"62.`", "225.25948543221122`", 
      RowBox[{"-", "48.45138121377093`"}]},
     {"63.`", "220.247421053482`", 
      RowBox[{"-", "48.4475806477911`"}]},
     {"64.`", "215.43971380912936`", 
      RowBox[{"-", "48.418289284868`"}]},
     {"65.`", "210.83719764325164`", 
      RowBox[{"-", "48.3635416254445`"}]},
     {"66.`", "206.4404257793412`", 
      RowBox[{"-", "48.28337959113864`"}]},
     {"67.`", "202.24964523722338`", 
      RowBox[{"-", "48.177868430004175`"}]},
     {"68.`", "198.2648365344025`", 
      RowBox[{"-", "48.04707796099818`"}]},
     {"69.`", "194.4857198304155`", 
      RowBox[{"-", "47.8910782394392`"}]},
     {"70.`", "190.9117351133999`", 
      RowBox[{"-", "47.70995282850749`"}]},
     {"71.`", "187.54203913126096`", 
      RowBox[{"-", "47.50380583944665`"}]},
     {"72.`", "184.37552781166576`", 
      RowBox[{"-", "47.27274310551626`"}]},
     {"73.`", "181.41083680655657`", 
      RowBox[{"-", "47.01687180627563`"}]},
     {"74.`", "178.64632399513744`", 
      RowBox[{"-", "46.73631921423061`"}]},
     {"75.`", "176.08007631143326`", 
      RowBox[{"-", "46.43122803160913`"}]},
     {"76.`", "173.70992190314217`", 
      RowBox[{"-", "46.10174135459323`"}]},
     {"77.`", "171.53342858998332`", 
      RowBox[{"-", "45.74800644430036`"}]},
     {"78.`", "169.5478879228036`", 
      RowBox[{"-", "45.370195845404396`"}]},
     {"79.`", "167.75032770075734`", 
      RowBox[{"-", "44.96849158126559`"}]},
     {"80.`", "166.13752091863626`", 
      RowBox[{"-", "44.54307579819236`"}]},
     {"81.`", "164.70597747790453`", 
      RowBox[{"-", "44.09414381587503`"}]},
     {"82.`", "163.45194170017015`", 
      RowBox[{"-", "43.621908013352574`"}]},
     {"83.`", "162.37140224600307`", 
      RowBox[{"-", "43.12658838964164`"}]},
     {"84.`", "161.46009135872`", 
      RowBox[{"-", "42.608416418320566`"}]},
     {"85.`", "160.71348709567712`", 
      RowBox[{"-", "42.06763562194946`"}]},
     {"86.`", "160.1268190376301`", 
      RowBox[{"-", "41.50449964164263`"}]},
     {"87.`", "159.69506835799726`", 
      RowBox[{"-", "40.91927570722584`"}]},
     {"88.`", "159.41297722611995`", 
      RowBox[{"-", "40.31224092960509`"}]},
     {"89.`", "159.27504988964006`", 
      RowBox[{"-", "39.68368592224036`"}]},
     {"90.`", "159.2755620485105`", 
      RowBox[{"-", "39.033912546847134`"}]},
     {"91.`", "159.40856731997218`", 
      RowBox[{"-", "38.36323474477683`"}]},
     {"92.`", "159.66790349601604`", 
      RowBox[{"-", "37.67197975794792`"}]},
     {"93.`", "160.04721308483795`", 
      RowBox[{"-", "36.96048166252862`"}]},
     {"94.`", "160.53992590552346`", 
      RowBox[{"-", "36.22909715006215`"}]},
     {"95.`", "161.13928782833787`", 
      RowBox[{"-", "35.47819585190063`"}]},
     {"96.`", "161.8383961845224`", 
      RowBox[{"-", "34.708147418274564`"}]},
     {"97.`", "162.63019394823758`", 
      RowBox[{"-", "33.919332733987034`"}]},
     {"98.`", "163.5074459644109`", 
      RowBox[{"-", "33.11216443683417`"}]},
     {"99.`", "164.4628043327869`", 
      RowBox[{"-", "32.287060734378514`"}]},
     {"100.`", "165.48883488048247`", 
      RowBox[{"-", "31.444439998348273`"}]},
     {"101.`", "166.57800553455132`", 
      RowBox[{"-", "30.584736510174004`"}]},
     {"102.`", "167.72268131319657`", 
      RowBox[{"-", "29.708413522372627`"}]},
     {"103.`", "168.91519477206768`", 
      RowBox[{"-", "28.815937361799918`"}]},
     {"104.`", "170.14786900239042`", 
      RowBox[{"-", "27.907774980813382`"}]},
     {"105.`", "171.41300377045528`", 
      RowBox[{"-", "26.98441357175338`"}]},
     {"106.`", "172.70289405271433`", 
      RowBox[{"-", "26.0463644601868`"}]},
     {"107.`", "174.00989416736263`", 
      RowBox[{"-", "25.094140382844433`"}]},
     {"108.`", "175.32643644715404`", 
      RowBox[{"-", "24.128256216442562`"}]},
     {"109.`", "176.64502275016994`", 
      RowBox[{"-", "23.14925061059762`"}]},
     {"110.`", "177.9582688647275`", 
      RowBox[{"-", "22.15767561662149`"}]},
     {"111.`", "179.2589459140015`", 
      RowBox[{"-", "21.154083877338984`"}]},
     {"112.`", "180.53998610778888`", 
      RowBox[{"-", "20.139043004077024`"}]},
     {"113.`", "181.79451117010154`", 
      RowBox[{"-", "19.11313646289401`"}]},
     {"114.`", "183.0158719320933`", 
      RowBox[{"-", "18.076948710038067`"}]},
     {"115.`", "184.19766259451453`", 
      RowBox[{"-", "17.031075360255603`"}]},
     {"116.`", "185.3337467431034`", 
      RowBox[{"-", "15.976127794506443`"}]},
     {"117.`", "186.41828853786905`", 
      RowBox[{"-", "14.912718643662318`"}]},
     {"118.`", "187.44577135480094`", 
      RowBox[{"-", "13.841468279427477`"}]},
     {"119.`", "188.41102479157047`", 
      RowBox[{"-", "12.763011564015493`"}]},
     {"120.`", "189.30924431372603`", 
      RowBox[{"-", "11.67798493471749`"}]},
     {"121.`", "190.13600976670412`", 
      RowBox[{"-", "10.587029688306341`"}]},
     {"122.`", "190.88731529717967`", 
      RowBox[{"-", "9.490799162998389`"}]},
     {"123.`", "191.55957659953893`", 
      RowBox[{"-", "8.38994846892962`"}]},
     {"124.`", "192.14964482443565`", 
      RowBox[{"-", "7.285135418705869`"}]},
     {"125.`", "192.6548389425892`", 
      RowBox[{"-", "6.177026513251898`"}]},
     {"126.`", "193.07294228527263`", 
      RowBox[{"-", "5.066289844625849`"}]},
     {"127.`", "193.40220829046737`", 
      RowBox[{"-", "3.9535947737054333`"}]},
     {"128.`", "193.64139237557913`", 
      RowBox[{"-", "2.8396154681268304`"}]},
     {"129.`", "193.78974126750796`", 
      RowBox[{"-", "1.7250269176753004`"}]},
     {"130.`", "193.8469885681181`", 
      RowBox[{"-", "0.6105045419850222`"}]},
     {"131.`", "193.8133818977889`", "0.5032753046639373`"},
     {"132.`", "193.68966866773562`", "1.6156370069498347`"},
     {"133.`", "193.47708153165007`", "2.725904953050197`"},
     {"134.`", "193.17735666962287`", "3.833405972159838`"},
     {"135.`", "192.7927182944705`", "4.9374700735471`"},
     {"136.`", "192.3258562139787`", "6.037427499737134`"},
     {"137.`", "191.77993251442126`", "7.132613462409085`"},
     {"138.`", "191.1585648749708`", "8.222369597817696`"},
     {"139.`", "190.46580008112215`", "9.306037908348381`"},
     {"140.`", "189.70610853154713`", "10.382966437322004`"},
     {"141.`", "188.88436506601036`", "11.452515007122175`"},
     {"142.`", "188.00582165287162`", "12.514044626989188`"},
     {"143.`", "187.07609226442247`", "13.566918843521208`"},
     {"144.`", "186.10112798565618`", "14.610518259940667`"},
     {"145.`", "185.08719066332816`", "15.644230309196407`"},
     {"146.`", "184.04083643966277`", "16.66744266779811`"},
     {"147.`", "182.96888482591535`", "17.679555407811943`"},
     {"148.`", "181.878382637356`", "18.67998672748921`"},
     {"149.`", "180.77659529442838`", "19.668156242885836`"},
     {"150.`", "179.67098132807882`", "20.64348860654733`"},
     {"151.`", "178.56914025703284`", "21.605430964715346`"},
     {"152.`", "177.47880814555157`", "22.553436474851406`"},
     {"153.`", "176.407836182398`", "23.486963367941865`"},
     {"154.`", "175.3641351344867`", "24.40549203073296`"},
     {"155.`", "174.35567712057028`", "25.308508880228008`"},
     {"156.`", "173.3904711750944`", "26.19550735764966`"},
     {"157.`", "172.47650700403588`", "27.06600419166287`"},
     {"158.`", "171.6217668416202`", "27.919520949710357`"},
     {"159.`", "170.83419546115064`", "28.7555884732392`"},
     {"160.`", "170.1216486764615`", "29.57376111387942`"},
     {"161.`", "169.49191254100717`", "30.37359698382013`"},
     {"162.`", "168.95266807681736`", "31.154665817996367`"},
     {"163.`", "168.51144878448468`", "31.916560204078657`"},
     {"164.`", "168.17566366656072`", "32.65887563170813`"},
     {"165.`", "167.95255805718352`", "33.38122155225807`"},
     {"166.`", "167.84918262643475`", "34.083228911165655`"},
     {"167.`", "167.87241684925652`", "34.76453096639352`"},
     {"168.`", "168.0289280169531`", "35.42477711811523`"},
     {"169.`", "168.32515228602963`", "36.06363637272196`"},
     {"170.`", "168.76731596614601`", "36.680779759472166`"},
     {"171.`", "169.36139489648843`", "37.27589637395379`"},
     {"172.`", "170.11310648710855`", "37.84869269094134`"},
     {"173.`", "171.0279272835857`", "38.398877221200316`"},
     {"174.`", "172.11105441024418`", "38.92617813184439`"},
     {"175.`", "173.36740659505332`", "39.43033857834462`"},
     {"176.`", "174.80163673379184`", "39.91110457548876`"},
     {"177.`", "176.41809784906673`", "40.36824244737034`"},
     {"178.`", "178.22085458323232`", "40.80152809354906`"},
     {"179.`", "180.21367631554395`", "41.21074807502151`"},
     {"180.`", "182.4000245025288`", "41.595704905632466`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5181744347426*^9},
 AspectRatioFixed->True]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 105, 2, 29, "Text",
 Evaluatable->False],
Cell[665, 24, 628, 19, 132, "Input"],
Cell[1296, 45, 115, 2, 29, "Text",
 Evaluatable->False],
Cell[1414, 49, 251, 6, 31, "Input"],
Cell[1668, 57, 166, 5, 29, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1859, 66, 415, 11, 72, "Input"],
Cell[2277, 79, 183, 4, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[2475, 86, 131, 4, 29, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[2631, 94, 935, 26, 52, "Input"],
Cell[3569, 122, 216, 6, 45, "Output"],
Cell[3788, 130, 457, 14, 45, "Output"]
}, Open  ]],
Cell[4260, 147, 113, 2, 29, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[4398, 153, 1454, 40, 112, "Input"],
Cell[5855, 195, 718, 24, 30, "Output"]
}, Open  ]],
Cell[6588, 222, 191, 7, 83, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[6804, 233, 2114, 66, 172, "Input"],
Cell[8921, 301, 2287, 45, 231, "Output",
 Evaluatable->False],
Cell[11211, 348, 14371, 244, 237, "Output",
 Evaluatable->False],
Cell[25585, 594, 5830, 102, 238, "Output",
 Evaluatable->False],
Cell[31418, 698, 14175, 239, 244, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[45608, 940, 246, 7, 47, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[45879, 951, 2023, 58, 132, "Input"],
Cell[47905, 1011, 16899, 393, 3191, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

