(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    111354,       2003]
NotebookOptionsPosition[    110142,       1956]
NotebookOutlinePosition[    110698,       1978]
CellTagsIndexPosition[    110655,       1975]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

This File Solves Two Billiard Balls Impacting.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell["\<\

e1 = rest == -(vaxf - vbxf)/(vaxi - vbxi);

e2 = 0 == vaxf + vbxf - vaxi - vbxi;



e3 = rest == -(vayf - vbyf)/(vayi - vbyi);

e4 = 0 == vayf + vbyf - vayi - vbyi;



ic = {vbxi->0,vaxi->vi Cos[theta],rest->.99};

ic2 = {vbyi->0,vayi->vi Sin[theta]};
\
\>", "Input",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

ans = Simplify[Solve[{e1,e2},{vaxf,vbxf}]]

ans2 = Simplify[Solve[{e1,e2,e3,e4},

\t{vaxf,vbxf,vayf,vbyf}]]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vaxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"vaxi", "-", 
        RowBox[{"rest", " ", "vaxi"}], "+", "vbxi", "+", 
        RowBox[{"rest", " ", "vbxi"}]}], ")"}]}]}], ",", 
    RowBox[{"vbxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"vaxi", "+", 
        RowBox[{"rest", " ", "vaxi"}], "+", "vbxi", "-", 
        RowBox[{"rest", " ", "vbxi"}]}], ")"}]}]}]}], "}"}], "}"}]], "Output",\

 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181781765336*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vaxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"vaxi", "-", 
        RowBox[{"rest", " ", "vaxi"}], "+", "vbxi", "+", 
        RowBox[{"rest", " ", "vbxi"}]}], ")"}]}]}], ",", 
    RowBox[{"vbxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"vaxi", "+", 
        RowBox[{"rest", " ", "vaxi"}], "+", "vbxi", "-", 
        RowBox[{"rest", " ", "vbxi"}]}], ")"}]}]}], ",", 
    RowBox[{"vayf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"vayi", "-", 
        RowBox[{"rest", " ", "vayi"}], "+", "vbyi", "+", 
        RowBox[{"rest", " ", "vbyi"}]}], ")"}]}]}], ",", 
    RowBox[{"vbyf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"vayi", "+", 
        RowBox[{"rest", " ", "vayi"}], "+", "vbyi", "-", 
        RowBox[{"rest", " ", "vbyi"}]}], ")"}]}]}]}], "}"}], "}"}]], "Output",\

 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181781765495996`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

ans//.ic

(ans2//.ic2)//.ic
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vaxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"0.010000000000000009`", " ", "vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}]}], ")"}]}]}], ",", 
    RowBox[{"vbxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"1.99`", " ", "vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}]}], ")"}]}]}]}], "}"}], 
  "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181781793406*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vaxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"0.010000000000000009`", " ", "vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}]}], ")"}]}]}], ",", 
    RowBox[{"vbxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"1.99`", " ", "vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}]}], ")"}]}]}], ",", 
    RowBox[{"vayf", "\[Rule]", 
     RowBox[{"0.0050000000000000044`", " ", "vi", " ", 
      RowBox[{"Sin", "[", "theta", "]"}]}]}], ",", 
    RowBox[{"vbyf", "\[Rule]", 
     RowBox[{"0.995`", " ", "vi", " ", 
      RowBox[{"Sin", "[", "theta", "]"}]}]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181781793526*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

ic3 = {vbxi->0,vaxi->vi Cos[theta]};

a = ans//.ic3
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vaxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}], "-", 
        RowBox[{"rest", " ", "vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}]}], ")"}]}]}], ",", 
    RowBox[{"vbxf", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}], "+", 
        RowBox[{"rest", " ", "vi", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}]}], ")"}]}]}]}], "}"}], 
  "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181781829456*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Plot3D[((vaxf/.a)/.{vi->1})[[1]],

\t{theta,0,80 Degree},{rest,0,1},

\tAxesLabel->{\"Theta\",\"  Coef.Rest.\",

\t\t\"Vaxf    \"}]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1nHc8V/0b/42olKaG0lBoS0ta3qKEdhFCGQ0NJUoZSWSmMkopMpJEQvjY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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwtmXfgltMbxt/3Ofe3QpsyEkIayN6jgQaaCiHJpohs7WlkpIwmkST6pYHs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         "]], Polygon3DBox[CompressedData["
1:eJwtmmXAHbUWRe8k0xYtLVL84fZwd7eHu3txd/fiXhyKFnenuLu7u7u7v7XY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         "]], Polygon3DBox[CompressedData["
1:eJwt13fc1WMfB/Bzd04Ube2Q9kAltGigJRrSsJoaRruorCKVzEgLIYXqaUfD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         "]]}]}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwt0skrRlEYwOFr/HxmWUmRnRRbKbZSrJQUO9mwoKxYW7Am/AFiLbE0zxvJ
PA9JMkVmSTy3LH73OXVut/d0bkFTe21bTBAE3XpXuH7WpQZigyCTw8znOEs4
xwpusIZnbOQjn9RqnRoXBF3MZS+LOMQyjrKKk6znIg94zU9t6VX3mjLQNqe5
wxnucpZ74Szc5zwPuMBDLvKISzzmMk+4wlOu8oxrPGefuW/4pQu96UEd5tpk
MxdYxwlWcoSlHGQhe5jDTiYzqpbwHL7dwBNWc53l4VlYzDHmcc/7V/xQhl50
p2wzpjOLaeEeU5nGFKYwmVFGGWESExhhHBPDu2UCfxWvn3BP3zJC0O9x+/8f
/AEKW0i6
       "]]}, {
      Line3DBox[{661, 981, 458, 660, 1096, 883, 662, 1097, 884, 663, 1098, 
       885, 664, 1099, 886, 665, 1100, 887, 666, 1101, 888, 667, 465, 668, 
       1102, 889, 669, 1103, 890, 670, 1104, 891, 671, 1105, 892, 672, 1106, 
       893, 673, 1302, 982, 894, 983}], 
      Line3DBox[{675, 987, 1193, 674, 472, 676, 1107, 895, 677, 1108, 896, 
       678, 1109, 897, 679, 1110, 898, 680, 1111, 899, 681, 988, 1194, 682, 
       989, 1195, 683, 1112, 900, 684, 1113, 901, 685, 1114, 902, 686, 1115, 
       903, 687, 1116, 904, 688}], 
      Line3DBox[{690, 990, 1196, 689, 991, 1197, 691, 992, 1198, 692, 1117, 
       905, 693, 1118, 906, 694, 1119, 907, 695, 1120, 908, 696, 993, 1199, 
       697, 994, 1200, 698, 995, 1201, 699, 1121, 909, 700, 1122, 910, 701, 
       1123, 911, 702, 1124, 912, 703}], 
      Line3DBox[{705, 996, 1202, 704, 997, 1203, 706, 998, 1204, 707, 999, 
       1205, 708, 1125, 913, 709, 1126, 914, 710, 1127, 915, 711, 1000, 1206, 
       712, 1001, 1207, 713, 1002, 1208, 714, 1003, 1209, 715, 1128, 916, 716,
        1129, 917, 717, 1130, 918, 718}], 
      Line3DBox[{720, 1004, 1210, 719, 1005, 1211, 721, 1006, 1212, 722, 1007,
        1213, 723, 1008, 1214, 724, 1131, 919, 725, 1132, 920, 726, 1009, 
       1215, 727, 1010, 1216, 728, 1011, 1217, 729, 1012, 1218, 730, 1013, 
       1219, 731, 1133, 921, 732, 1134, 922, 733}], 
      Line3DBox[{735, 1014, 1220, 734, 1015, 1221, 736, 1016, 1222, 737, 1017,
        1223, 738, 1018, 1224, 739, 1019, 1225, 740, 1135, 923, 741, 1020, 
       1226, 742, 1021, 1227, 743, 1022, 1228, 744, 1023, 1229, 745, 1024, 
       1230, 746, 1025, 1231, 747, 1136, 924, 748}], 
      Line3DBox[{752, 1137, 925, 750, 1138, 926, 754, 1139, 927, 756, 1140, 
       928, 758, 1141, 929, 760, 1142, 930, 762, 1143, 931, 764, 1144, 932, 
       766, 1145, 933, 768, 1146, 934, 770, 1147, 935, 772, 1148, 936, 774, 
       1149, 937, 776, 1150, 938, 778}], 
      Line3DBox[{777, 1245, 1039, 775, 1244, 1038, 773, 1243, 1037, 771, 1242,
        1036, 769, 1241, 1035, 767, 1240, 1034, 765, 1239, 1033, 763, 1238, 
       1032, 761, 1237, 1031, 759, 1236, 1030, 757, 1235, 1029, 755, 1234, 
       1028, 753, 1233, 1027, 749, 1232, 1026, 751}], 
      Line3DBox[{780, 1040, 1246, 779, 1151, 939, 781, 1152, 940, 782, 1153, 
       941, 783, 1154, 942, 784, 1155, 943, 785, 1156, 944, 786, 1041, 1247, 
       787, 1157, 945, 788, 1158, 946, 789, 1159, 947, 790, 1160, 948, 791, 
       1161, 949, 792, 1162, 950, 793}], 
      Line3DBox[{795, 1042, 1248, 794, 1043, 1249, 796, 1163, 951, 797, 1164, 
       952, 798, 1165, 953, 799, 1166, 954, 800, 1167, 955, 801, 1044, 1250, 
       802, 1045, 1251, 803, 1168, 956, 804, 1169, 957, 805, 1170, 958, 806, 
       1171, 959, 807, 1172, 960, 808}], 
      Line3DBox[{810, 1046, 1252, 809, 1047, 1253, 811, 1048, 1254, 812, 1173,
        961, 813, 1174, 962, 814, 1175, 963, 815, 1176, 964, 816, 1049, 1255, 
       817, 1050, 1256, 818, 1051, 1257, 819, 1177, 965, 820, 1178, 966, 821, 
       1179, 967, 822, 1180, 968, 823}], 
      Line3DBox[{825, 1052, 1258, 824, 1053, 1259, 826, 1054, 1260, 827, 1055,
        1261, 828, 1181, 969, 829, 1182, 970, 830, 1183, 971, 831, 1056, 1262,
        832, 1057, 1263, 833, 1058, 1264, 834, 1059, 1265, 835, 1184, 972, 
       836, 1185, 973, 837, 1186, 974, 838}], 
      Line3DBox[{840, 1060, 1266, 839, 1061, 1267, 841, 1062, 1268, 842, 1063,
        1269, 843, 1064, 1270, 844, 1187, 975, 845, 1188, 976, 846, 1065, 
       1271, 847, 1066, 1272, 848, 1067, 1273, 849, 1068, 1274, 850, 1069, 
       1275, 851, 1189, 977, 852, 1190, 978, 853}], 
      Line3DBox[{855, 1070, 1276, 854, 1071, 1277, 856, 1072, 1278, 857, 1073,
        1279, 858, 1074, 1280, 859, 1075, 1281, 860, 1191, 979, 861, 1076, 
       1282, 862, 1077, 1283, 863, 1078, 1284, 864, 1079, 1285, 865, 1080, 
       1286, 866, 1081, 1287, 867, 1192, 980, 868}], 
      Line3DBox[{882, 986, 1301, 1095, 881, 1300, 1093, 880, 1299, 1092, 879, 
       1298, 1091, 878, 1297, 1090, 877, 1296, 1089, 876, 1295, 1088, 875, 
       1294, 1087, 874, 1293, 1086, 873, 1292, 1085, 872, 1291, 1084, 871, 
       1290, 1083, 870, 1289, 1082, 869, 1094, 1288, 984, 985}]}, {
      Line3DBox[{251, 459, 1096, 252, 472, 278, 1197, 486, 292, 1203, 500, 
       306, 1211, 514, 320, 1221, 528, 334, 1233, 542, 1138, 348, 556, 1151, 
       362, 1249, 570, 376, 1253, 584, 390, 1259, 598, 404, 1267, 612, 418, 
       1277, 626, 432, 1289, 640, 446}], 
      Line3DBox[{253, 460, 1097, 254, 473, 1107, 279, 1198, 487, 293, 1204, 
       501, 307, 1212, 515, 321, 1222, 529, 335, 1234, 543, 1139, 349, 557, 
       1152, 363, 571, 1163, 377, 1254, 585, 391, 1260, 599, 405, 1268, 613, 
       419, 1278, 627, 433, 1290, 641, 447}], 
      Line3DBox[{255, 461, 1098, 256, 474, 1108, 280, 488, 1117, 294, 1205, 
       502, 308, 1213, 516, 322, 1223, 530, 336, 1235, 544, 1140, 350, 558, 
       1153, 364, 572, 1164, 378, 586, 1173, 392, 1261, 600, 406, 1269, 614, 
       420, 1279, 628, 434, 1291, 642, 448}], 
      Line3DBox[{257, 462, 1099, 258, 475, 1109, 281, 489, 1118, 295, 503, 
       1125, 309, 1214, 517, 323, 1224, 531, 337, 1236, 545, 1141, 351, 559, 
       1154, 365, 573, 1165, 379, 587, 1174, 393, 601, 1181, 407, 1270, 615, 
       421, 1280, 629, 435, 1292, 643, 449}], 
      Line3DBox[{259, 463, 1100, 260, 476, 1110, 282, 490, 1119, 296, 504, 
       1126, 310, 518, 1131, 324, 1225, 532, 338, 1237, 546, 1142, 352, 560, 
       1155, 366, 574, 1166, 380, 588, 1175, 394, 602, 1182, 408, 616, 1187, 
       422, 1281, 630, 436, 1293, 644, 450}], 
      Line3DBox[{261, 464, 1101, 262, 477, 1111, 283, 491, 1120, 297, 505, 
       1127, 311, 519, 1132, 325, 533, 1135, 339, 1238, 547, 1143, 353, 561, 
       1156, 367, 575, 1167, 381, 589, 1176, 395, 603, 1183, 409, 617, 1188, 
       423, 631, 1191, 437, 1294, 645, 451}], 
      Line3DBox[{8, 667, 23, 681, 38, 696, 53, 711, 68, 726, 83, 741, 98, 763,
        764, 113, 786, 128, 801, 143, 816, 158, 831, 173, 846, 188, 861, 203, 
       875, 218}], 
      Line3DBox[{263, 465, 264, 1194, 478, 284, 1199, 492, 298, 1206, 506, 
       312, 1215, 520, 326, 1226, 534, 340, 1239, 548, 1144, 354, 1247, 562, 
       368, 1250, 576, 382, 1255, 590, 396, 1262, 604, 410, 1271, 618, 424, 
       1282, 632, 438, 1295, 646, 452}], 
      Line3DBox[{265, 466, 1102, 266, 1195, 479, 285, 1200, 493, 299, 1207, 
       507, 313, 1216, 521, 327, 1227, 535, 341, 1240, 549, 1145, 355, 563, 
       1157, 369, 1251, 577, 383, 1256, 591, 397, 1263, 605, 411, 1272, 619, 
       425, 1283, 633, 439, 1296, 647, 453}], 
      Line3DBox[{267, 467, 1103, 268, 480, 1112, 286, 1201, 494, 300, 1208, 
       508, 314, 1217, 522, 328, 1228, 536, 342, 1241, 550, 1146, 356, 564, 
       1158, 370, 578, 1168, 384, 1257, 592, 398, 1264, 606, 412, 1273, 620, 
       426, 1284, 634, 440, 1297, 648, 454}], 
      Line3DBox[{269, 468, 1104, 270, 481, 1113, 287, 495, 1121, 301, 1209, 
       509, 315, 1218, 523, 329, 1229, 537, 343, 1242, 551, 1147, 357, 565, 
       1159, 371, 579, 1169, 385, 593, 1177, 399, 1265, 607, 413, 1274, 621, 
       427, 1285, 635, 441, 1298, 649, 455}], 
      Line3DBox[{271, 469, 1105, 272, 482, 1114, 288, 496, 1122, 302, 510, 
       1128, 316, 1219, 524, 330, 1230, 538, 344, 1243, 552, 1148, 358, 566, 
       1160, 372, 580, 1170, 386, 594, 1178, 400, 608, 1184, 414, 1275, 622, 
       428, 1286, 636, 442, 1299, 650, 456}], 
      Line3DBox[{273, 470, 1106, 274, 483, 1115, 289, 497, 1123, 303, 511, 
       1129, 317, 525, 1133, 331, 1231, 539, 345, 1244, 553, 1149, 359, 567, 
       1161, 373, 581, 1171, 387, 595, 1179, 401, 609, 1185, 415, 623, 1189, 
       429, 1287, 637, 443, 1300, 651, 457}], 
      Line3DBox[{275, 653, 1302, 654, 276, 484, 1116, 290, 498, 1124, 304, 
       512, 1130, 318, 526, 1134, 332, 540, 1136, 346, 1245, 554, 1150, 360, 
       568, 1162, 374, 582, 1172, 388, 596, 1180, 402, 610, 1186, 416, 624, 
       1190, 430, 638, 1192, 444, 1301, 656, 657, 658}], 
      Line3DBox[{445, 639, 655, 1288, 431, 625, 1276, 417, 611, 1266, 403, 
       597, 1258, 389, 583, 1252, 375, 569, 1248, 361, 555, 1246, 347, 1137, 
       541, 1232, 333, 527, 1220, 319, 513, 1210, 305, 499, 1202, 291, 485, 
       1196, 277, 471, 1193, 250, 458, 652, 659}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJx8u3k0Vf/7/t8oNEdIJUVlqqhIwiUlIUMKaZChSBkaiZApKVEoZCizzPM8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    "]],
  Axes->True,
  AxesLabel->{
    FormBox["\"Theta\"", TraditionalForm], 
    FormBox["\"  Coef.Rest.\"", TraditionalForm], 
    FormBox["\"Vaxf    \"", TraditionalForm]},
  BoxRatios->{1, 1, 0.4},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->
   NCache[{{0, 80 Degree}, {0, 1}, {0., 0.4999999642857118}}, {{
     0, 1.3962634015954636`}, {0, 1}, {0., 0.4999999642857118}}],
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181781852776003`*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 151, 7, 191, "Title",
 Evaluatable->False],
Cell[711, 29, 300, 19, 303, "Input"],
Cell[CellGroupData[{
Cell[1036, 52, 156, 9, 133, "Input"],
Cell[1195, 63, 654, 21, 47, "Output",
 Evaluatable->False],
Cell[1852, 86, 1150, 35, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[3039, 126, 76, 7, 99, "Input"],
Cell[3118, 135, 693, 21, 47, "Output",
 Evaluatable->False],
Cell[3814, 158, 954, 26, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[4805, 189, 217, 12, 99, "Input"],
Cell[5025, 203, 773, 25, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[5835, 233, 180, 11, 167, "Input"],
Cell[6018, 246, 104108, 1707, 261, 81462, 1333, "CachedBoxData", "BoxData", \
"Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

