(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      5436,        267]
NotebookOptionsPosition[      4112,        216]
NotebookOutlinePosition[      4668,        238]
CellTagsIndexPosition[      4625,        235]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

This file solves the three 

simultaneous equations for the 

Two Blocks in the Elevator.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell[CellGroupData[{

Cell["\<\

e1 := F + f + T == mt xddot

e2 := N - mt g == mt a

e3 := T - mb g == mb yddot

ans = Simplify[Solve[{e1,e2,e3},{f,T,N}]]
\
\>", "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181782082785997`*^9, 3.5181782084856*^9}, {
  3.5181782398666*^9, 3.5181782601085997`*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"f", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "F"}], "-", 
      RowBox[{"g", " ", "mb"}], "+", 
      RowBox[{"mt", " ", "xddot"}], "-", 
      RowBox[{"mb", " ", "yddot"}]}]}], ",", 
    RowBox[{"T", "\[Rule]", 
     RowBox[{"mb", " ", 
      RowBox[{"(", 
       RowBox[{"g", "+", "yddot"}], ")"}]}]}], ",", 
    RowBox[{"N", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", "g"}], ")"}], " ", "mt"}]}]}], "}"}], 
  "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{{3.5181782003676*^9, 3.5181782110446*^9}, {
  3.5181782418845997`*^9, 3.5181782618466*^9}}]
}, Open  ]],

Cell["\<\

Now for the no slip conditions.
\
\>", "Text",
 Evaluatable->False],

Cell["\<\

xddot = 0;

yddot = a - xddot;
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell["\<\

Now for the parameters of the problem.  Note the last three lines give results.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell["\<\

g = 9.81;

mt = 2;

mb = 0.5;

muk = 0.65;

mus = 0.7;

tmax = 9;

F = 1;

a = 6;

ans

fsmax = (mus N)/.ans

fkmax = (muk N)/.ans
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"f", "\[Rule]", 
     RowBox[{"-", "8.905000000000001`"}]}], ",", 
    RowBox[{"T", "\[Rule]", "7.905`"}], ",", 
    RowBox[{"N", "\[Rule]", "31.62`"}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181782669266*^9}],

Cell[BoxData[
 RowBox[{"{", "22.134`", "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181782669365997`*^9}],

Cell[BoxData[
 RowBox[{"{", "20.553`", "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181782669386*^9}],

Cell["\<\

This is the second option.  Just change the parameters that have changed and

execute.
\
\>", "Text",
 Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

F = 13;

ans

mus N/.ans

muk N/.ans
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"f", "\[Rule]", 
     RowBox[{"-", "20.905`"}]}], ",", 
    RowBox[{"T", "\[Rule]", "7.905`"}], ",", 
    RowBox[{"N", "\[Rule]", "31.62`"}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181782693456*^9}],

Cell[BoxData[
 RowBox[{"{", "22.134`", "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181782693536*^9}],

Cell[BoxData[
 RowBox[{"{", "20.553`", "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181782693566*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 194, 11, 407, "Title",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[776, 35, 403, 18, 167, "Input"],
Cell[1182, 55, 685, 22, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[1882, 80, 78, 5, 65, "Text",
 Evaluatable->False],
Cell[1963, 87, 196, 12, 99, "Input"],
Cell[2162, 101, 126, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[2313, 110, 296, 30, 405, "Input"],
Cell[2612, 142, 331, 10, 30, "Output",
 Evaluatable->False],
Cell[2946, 154, 143, 4, 30, "Output",
 Evaluatable->False],
Cell[3092, 160, 139, 4, 30, "Output",
 Evaluatable->False],
Cell[3234, 166, 133, 7, 101, "Text",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[3404, 178, 85, 11, 167, "Input"],
Cell[3492, 191, 320, 10, 30, "Output",
 Evaluatable->False],
Cell[3815, 203, 139, 4, 30, "Output",
 Evaluatable->False],
Cell[3957, 209, 139, 4, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

