(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     56659,       1348]
NotebookOptionsPosition[     54442,       1264]
NotebookOutlinePosition[     54998,       1286]
CellTagsIndexPosition[     54955,       1283]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

This File Determines If A Ball Bounces Over a Fence.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell["\<\

Solve for the time period from release to impact.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"e1", " ", "=", " ", 
     RowBox[{
      RowBox[{"m", " ", "g", " ", "yo"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"1", "/", "2"}], " ", "m", " ", 
       RowBox[{"vi", "^", "2"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{"ans", " ", "=", " ", 
    RowBox[{"Solve", "[", 
     RowBox[{"e1", ",", "vi"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778339046*^9, 3.5181778339066*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"vi", "\[Rule]", 
     RowBox[{
      RowBox[{"-", 
       SqrtBox["2"]}], " ", 
      SqrtBox["g"], " ", 
      SqrtBox["yo"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"vi", "\[Rule]", 
     RowBox[{
      SqrtBox["2"], " ", 
      SqrtBox["g"], " ", 
      SqrtBox["yo"]}]}], "}"}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778671436*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"ansvi", " ", "=", " ", 
    RowBox[{"ans", "[", 
     RowBox[{"[", "2", "]"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778354236*^9, 3.5181778354256*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"vi", "\[Rule]", 
   RowBox[{
    SqrtBox["2"], " ", 
    SqrtBox["g"], " ", 
    SqrtBox["yo"]}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778688986*^9}]
}, Open  ]],

Cell["\<\

Now for the impact itself.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"nx", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"ny", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"i", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "theta", "]"}]}], " ", "ny"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "nx"}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"j", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "theta", "]"}], " ", "nx"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "ny"}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"vinx", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", " ", "vi"}], " ", 
        RowBox[{"j", " ", ".", " ", "nx"}]}], ")"}], "/.", "ansvi"}]}], ";"}],
    "\n", "\n", 
   RowBox[{
    RowBox[{"viny", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", " ", "vi"}], " ", 
        RowBox[{"j", " ", ".", " ", "ny"}]}], ")"}], "/.", "ansvi"}]}], ";"}],
    "\n", "\n", 
   RowBox[{
    RowBox[{"vfny", " ", "=", " ", "viny"}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"e2", " ", "=", " ", 
     RowBox[{"rest", " ", "==", " ", 
      RowBox[{
       RowBox[{"-", " ", 
        RowBox[{"(", 
         RowBox[{"vfnx", " ", "-", " ", "0"}], ")"}]}], "/", 
       RowBox[{"(", 
        RowBox[{"vinx", " ", "-", " ", "0"}], ")"}]}]}]}], ";"}], "\n", "\n", 
   
   RowBox[{"ans", " ", "=", " ", 
    RowBox[{"Solve", "[", 
     RowBox[{"e2", ",", "vfnx"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778377676*^9, 3.5181778377706003`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"vfnx", "\[Rule]", 
    RowBox[{
     SqrtBox["2"], " ", 
     SqrtBox["g"], " ", "rest", " ", 
     SqrtBox["yo"], " ", 
     RowBox[{"Cos", "[", "theta", "]"}]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778708576*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"vf", " ", "=", " ", 
    RowBox[{
     RowBox[{"vfny", " ", "ny"}], " ", "+", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"vfnx", "/.", "ans"}], ")"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], " ", "nx"}]}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778396486*^9, 3.5181778396506*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SqrtBox["2"], " ", 
    SqrtBox["g"], " ", "rest", " ", 
    SqrtBox["yo"], " ", 
    RowBox[{"Cos", "[", "theta", "]"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     SqrtBox["2"]}], " ", 
    SqrtBox["g"], " ", 
    SqrtBox["yo"], " ", 
    RowBox[{"Sin", "[", "theta", "]"}]}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778725866003`*^9}]
}, Open  ]],

Cell["\<\

Now for the flight after the impact.
\
\>", "Text",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"nx", " ", "=."}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"ny", " ", "=."}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"i", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"j", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"nx", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "theta", "]"}], " ", "j"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "i"}]}]}], ";"}], "\n", "\n", 
   
   RowBox[{
    RowBox[{"ny", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "theta", "]"}]}], " ", "i"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "j"}]}]}], ";"}], "\n", "\n", 
   
   RowBox[{
    RowBox[{"vfij", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"vf", "[", 
        RowBox[{"[", "1", "]"}], "]"}], " ", "nx"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"vf", "[", 
        RowBox[{"[", "2", "]"}], "]"}], " ", "ny"}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"vfi", " ", "=", " ", 
     RowBox[{"vfij", " ", ".", " ", "i"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"vfj", " ", "=", " ", 
     RowBox[{"vfij", " ", ".", " ", "j"}]}], ";"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778416326*^9, 3.5181778416345997`*^9}}],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{"vfi", " ", "t"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"y", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"L", " ", 
       RowBox[{"Tan", "[", "theta", "]"}]}], " ", "+", " ", 
      RowBox[{"vfj", " ", "t"}], " ", "-", " ", 
      RowBox[{
       RowBox[{"1", "/", "2"}], " ", "g", " ", 
       RowBox[{"t", "^", "2"}]}]}]}], ";"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778425206003`*^9, 3.5181778425226*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"ans", " ", "=", " ", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"L", " ", "==", " ", 
        RowBox[{"x", "[", "t", "]"}]}], ",", "t"}], "]"}]}], ";"}], "\n", 
   "\n", 
   RowBox[{"clearance", " ", "=", " ", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"t", "/.", "ans"}], ")"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}], " ", "-", " ", "H"}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778435516*^9, 3.5181778435536003`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"L", " ", "rest", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "rest"}], ")"}], " ", "yo", " ", 
    RowBox[{"Cot", "[", "theta", "]"}]}], "-", 
   RowBox[{
    SuperscriptBox["L", "2"], " ", 
    SuperscriptBox[
     RowBox[{"Csc", "[", 
      RowBox[{"2", " ", "theta"}], "]"}], "2"]}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", "rest"}], ")"}], " ", "yo", " ", 
    RowBox[{"Sec", "[", "theta", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"H", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "rest"}], ")"}], " ", 
       RowBox[{"Cos", "[", "theta", "]"}]}], "-", 
      RowBox[{"L", " ", "rest", " ", 
       RowBox[{"Sin", "[", "theta", "]"}]}]}], ")"}]}]}], 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "+", "rest"}], ")"}], "2"], " ", "yo"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778796136*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"param", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"H", "->", "1"}], ",", 
       RowBox[{"L", "->", "2"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}], ",", "\n", "\n", "\t", 
       RowBox[{"g", "->", "9.81"}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"clearance", "/.", "param"}], ")"}], "//", "N"}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778493746*^9, 3.5181778493766003`*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData["0.44916482433446353`"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778812446003`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"g", " ", "=", " ", "9.81"}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"tend", " ", "=", " ", ".5"}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"a", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778541226*^9, 3.5181778541246*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nk4lN0bB3DLkCgpFemlFIpQqV9J6h4le0mWUqTIVl5bKWRLUgqh7EuL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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0.6},
  ImageSize->{891., Automatic},
  PlotRange->{{0., 2.5768476381035805`}, {0.5773502691896258, 
   0.9386002404249476}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778830016003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "3"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"b", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778561566*^9, 3.5181778561586*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw113k4lF0UAPD3nSFDydImRKSdspQonNuiEiFKUipKpY0UiURIn12EQpKk
ZElaSFlCyJbQhsqayjJetNhmvuOP5p95fs88c8/dz7kKtg5mdiyKoiRoipr4
/veZoxGmf/dcGxRmJ0lczzYBKvhTQoHHP+8DvqiB14eL/+wAOy7FVAoG/LMn
WBoIXd0T88+h8HIBp2cg959vwpxVd3OKRv/5AfDSrUr63NvhoYetSKBfITQP
T16tFtgB5uszIq2Cy+HpWIPeeq9OKPBTzetdWQvl2cN29Ue+wfOxbY7Bbg2Q
/0eqxW1PF6Sky/qtc/kIAwYffpWt+g6eDg+aLcqawd0uvDFe9gdUfRrhKni3
wH6XjZP3DP2AbdcHFOedb4OSZ4XaCU9+whYb49/1CR1gdorzxPNCN7wo5bmJ
3foGX+j5vk1qPWDSy7FYFf0dXjTsNOQ09oCl7Nm3U3N+Qkjx2Ky+y73w8bs2
z/FxD9xVH2CUFPugOm9/pXdTH8RUpx75r7APBlIcz5Lz/TBZzPTEfHMu5K5v
avV1ZWC67v6QwXouPG89K6sQMAAN0oYRXkv74VxN/gNv/0FwmjprbczBfjhV
sGqaTvwQWGb/DJsS3w/DYZ9vdaf/grhe6zt/3/aD3kMV//2pv2GNwO4nR3j9
kPfuAVHJ/wOf7lzJ1V7CwN/NzaYF+X8hYqpznLAJAyVxK4M25Q6Dep2uoIED
AxVDhdELK0eA+tVU/yeYgUOV21QU34xAmIx+m00IA3RiW5Fs/QgIXDPJqkRr
mgj0STSNQEL45uj4UAZup2zaMPYTHVJxZu0VBtz31vTXiozCi1tTL7hfZWBp
eZOB25ZROLgi+nVhDAPBsb9Hq16Pgsvk+xvCkhnQWl3eL1szCq7Tb2wdQHd+
vN55vG4UBGqNRLffZUBvpu6bKU2jkLG3LXPmPQZ6w3wSjXpGYW9j53/XUhgw
9BM3qJo6BoqGxudD0hgQObUkqtJ8DNZJ3nFcn8WA/8a9qhWfx+CT5tHQty8Y
yL7WPC7YNgYNjQn18nkMfPtpVbn22xicz1399gR6XejOQ8/6xuC98rW/nHwG
Rj+Yxt3jj8HTz8N/1hQwcMJ+PeeywjhIOVo+u/qSAdOgRS3r7cbBeaf3RolS
Bi58SU73tB8H9VNzsy3Qaarz3Z+fGIf4UoXWWLTwO4WZGi7j4KVkbDO/jIGi
OTJGipfH4WTaVsmV5QxoPBDNoVLGoa+nS3NTBQOz6gZC83rGwVfVP0CzhgGv
6nqnzP5xSNKrneGA/lH+eMftIWxfLOXAXXRugYuM/9g4zB0R2zTrDQP700eS
t0/hwR4mS3kInfIfK797KQ8yj2w9nfiWAR2Q7Jl9jAe1bg29tQ0M3Fk9WDPF
gQfLOswr6XcMiGk2POQ78eCQuN0xdXSrctTZTjce2D3UGQxHX5KWZj8M4EHM
jJcK294z8OaXgvTm+zxoOSQ38vIDAzZpaptdfvCgTXnpNedGBpoczAPye3ng
3+QLiegdGs5VkwZ40Nd+M74GbZCbYxo9woN+Wtp3QRMDauWwK2cyH5qd5Hrq
0KyOrUdHVPhgvOiIqtxnBs7fdUhbp86HBqcP5hvRv49e6QvQ5MPMWZzlJ9E/
mQYnGeDDu+PpU/LQdfzd7jqmfFi9lWO38wvuX5mjQRec+BDXyvO/8JWBOV8D
a0pd+MAr81mciI5OTBcXc+fDXE6F1yt04GLm6k0fPsRExlhMbmHg9CrXG4VX
+eDSaXgzAr3B3C+Dlc2HcktuUlQr7ueAxFq/UT68D9a+eKidget/Fizy4/PB
wnmXhSd6Yda7giKaIj1ql3qi0c1yVrOKBCliu4TaU47e+Ne2tFCUIgekfDct
6GBAOvWMUv4cilR8LzZ9jz7TqlmbJ0+RQoVbmt3oN7OG3fMUKFKzPOAzH+3r
61H/Yj5FVCs9Ty7qZIBr7ef9XIUiIvy/cS7oIvFrLTm6FFHaPU9Z6BuOf5NV
UA5Q5EpnnqIU2tVDVitnLUWm6x9sXIRW+ZkQmq2P/fNpCDJARxWn6D3dShGp
8XW8y2hm+NjPJyYUIao641FoQ9VlUU+2UeSC1tq8O2jqRlbv4x0UWVd+0qsI
fczledwja4p0dOycNox+leax+dE+ipQWPpCe1MXA3HYYyrLB8Z2a1i6JbjAp
Mcyyo8iYGe/pUjQsrh7JPEGRAEnbY1bo6/tCkzMdKLIoWsrdDj0Uuc0s8xRF
Pvc3GjqiU1jvUx44UyRkno/qJbRk8xfLDA+KCPvZTEpDLzv+p/+2J0UEvmsx
j9FbxsT8r1+kSFty2M089EXZtc98L1Fk/ZqXG2vQcWm7trldxv6Kx8B7dI6O
0w8Hf4osWT84+hnN3XN79u5gikTlLyjoQYv0Pn9oGkqRBCG6dBC9wKPBYOMV
7H/67rAR9N4bgm5qkRhfPNxB6DsD51TkJBdGUySi6oSvKDoyT/O+7HX8/dvr
PdPQVZ8PNwrdwP8vZ1vKobtOeDmNx2P7+1rc5qHZvGsigwkUie7RtVmEXi1X
sfpLEkWU57i5qqEtMtrq6pMn5tsyZSXaSW/06Ot7FNnwMvuGNjplr3Ls4zRc
n4+/awm6pG+Dxv0Migj1vxfbgG65YF15MxP308FVkpvQY1NdDkRmUaR/hdRH
A/SsmyGjAY8pkm17zsYIrbH8boTXU4rs77XKMEabFBQsdcmhyM+GF/mm6KMm
H4uP5VLEYvbNcDO039f+3TYvKJKUSy/Zjk50EB6yyKdIXU6H7w50Pl8hyKgQ
+zdt820LdGPoaqV1RRR5X7n00k70b3nzF6tKKHK/JXSJJVoi89h2lVKMb3Ym
YsIqxLdHsZwiv+d+KpiwQW2cr1QFRRyM8h9M+OD+J7JTqyhS3jDvwIQ9+6sf
s2tw/nOFGyfaj/X6ZjT8hiKKYw7TJ5wtzu/oe0sRhVgLyYn+1CXM8uiopwgr
Oq9+ov99qqozGt9RpJibZGmOFnm5Of3NB4ocuTPl1jb0gm02+q8+4X2QPZRm
gl7beu5zbhNFti+0Pr8VvedUuHPmZ4rEDeqLGaJd6VTR5K+4frIP7Dajr14p
vhPbivOTeM1TH/1AoVn3SjtF8i+xrNehKx4OvfPrxP3/qmdcD/1trejJ810U
0bPdabsGLWerF3+4G9c/K91ZA609YKFp3UuRGLvrSsvRO7wdasy4FKl1Foxe
gg5KTODpDuL5SNtbOhd9V/1ZlMYvjFdv6CODLi56u2zxH4qc3/mMPRM90sba
N30U23OeYSIyEe/D8+QV43hevoyHstHrK8/0bedTpOjMff8xPA+Bj755RLJp
wlE2vduLfnD35qsngjTJNjKo7ETXx1qKvheiycnYSfcmzpuMb0XczCk0+VVU
HViFJq4+HZpTaVIS+yG8GH3guI7yTnGaxCTeMctFp27PeB49nSb7V4eMJaN1
5oc3Ss2hyZbwK8Pn0ftmGypqy9PEsulF6Sm0r6jA0V0KNHEwSzM6hK765Tx8
fT5Nsio+eBuj95TukpJZRpPY9v3XZNAehxUs5gBNvj1dc+Qe3m+3djfe0F1L
k9MtKS+vTdx3JhGd1utxfFrN9f+hRbUEneM3YfxTwYpH0Dc4PyLkTWmiPEXR
fh46PyXzrYINjrd9WmwQ3t9tN+xnrztAE7feEi9X9KRwRRtbO5oEz18tfxBt
4na1P9GeJlXyp/xWo79ucRVTcqLJfR0JXjvmB6oHti7woUnbLOnwxeiiFffl
FS/RJLzdMlUS7eMxfWDOZZq0SET6jWI+EhL7ETUjEOcjStCnCi2qHt4iEEGT
p3plEcfQs107Trcn0mSJaPX0+DY8j4XGG78m0aSI1bbVBx0n/EyqKZkmf62G
Nh9By8cG59XdpwnRkLikhp6frylUlEUTPZ+lM15i/lQT8I9JKKIJk9B2tQHz
66DR4PG4Epo4Flb3PkE/jrSGa6U0CV33lBON1lqo3hFaQZPkk56+lmi9LU0q
nnU02XBoIOIj5u8tYSovrdtoollvJVmN+f+AbF2XNItFhm+vDL7cjPfB62b7
tQIsEnIh4rs1+o9zV/fhSSxiXCcxqoEOfDPGfSzCIts6HfS/Yj3yyHvhX+Np
LLL32UMHdbTAj/McHyUWiZptJF35iYGkJwsXd29kEa/cprJXWB+dsFVPlTBg
Ec/czUIRaC0xXRUtQxa5p/F+fB+66oiZ2iUTFrlwxUx8GOurIRkPbXlLFlEf
ra1YiN7gXWdgbs8iOX4dkWfrGWg39jj6PJBFyIVDvi1Y3xmaap/NC2YRvSVC
t+6hs7b98ikIZREV1zkXHNEXt5+4URzBIp+G75/jY70ob2VdWxnLIsevGrhI
o3fb6Wo2p2L8BZGXNlTh+XIfp8crWWRrvt3YEaxPi+55XNebwiZxL3q2DGI9
/JMdFq45lU3ueRf2pqGn7UsMXCbOJj12F80PoQ/OKPOQm84mc30rDn/EelrI
W9yWJ8MmWvJuj55hvW20+/aS/KX4e63xB8fnDLwTff1c15BNPsrWmD58ivWt
0/QvOgFs0mujNNkd63tp9TK/fUFswr6VPl8ObcScW+4dwiaKxrv/FqYykO7w
1assnE3ODcwrFUSfOn5/nlksmwQdOMoOwvfCiB2xP5zGJgZdlQKB+N6YvOv4
0JUaNhF3blU0T8D1hxKRLkkB8j3FompyBNZT6q/bT4cLkJNNCwLXnmUgZFFX
UpqsIFGa5n342Xasf0Ji3fcnCeL0R+tbLcP8J3OH91txEtk++cBI2CTMF6ll
9tppk4ixn4et5Id+2GcLF/cqC5EGN8omKbkf/P23ZvBShIhs062W7af74U3W
meIt6hwy8rWgdO+qfjjNZnzPPeSQR9Mkw8p+c+FH99WjDx9xiH1Pt278EBf2
NWiZ/njCIfz9aaZnBrhgeMdLZlcuh1TPaU2S6+OC0ibxLK1iDununM053smF
hoDlX/80cIh2ZvmzH/j+XCF5UtvlL4cIq8hUOGZyIXVEQj5jhENeXyyfviKD
CwrtTwS+jWE8pz0lv1O5IPp4/M0OWpgYLNQyc7vLhc4dwYdWigiT4K/5i9zi
uRB5PS1iSEaYzAsQfrkniAuTvU3PKcsJk664uVYzA7hw8ejQ3oNzhUmgoZzl
m8tcOLFGZ0mDkjBxPl/tDT5c0P9cWfhIRZhUK4+GS7nh+/iVQ3L3cmESIbfJ
vPosF9QypgXNUxcm2mnnXC86c0HOc/fOCE1hsjA2nOly5MLVw3ydSi1h4jDm
qh9zkgsiprcV2WuESfSwPs/wOBe8tDZx1ugKk5vhwzLj9lz4Pbe71wmEyeWy
iPj0w1z4HzwUj3A=
     "]]}},
  Axes->True,
  AxesOrigin->{0, 0.6},
  ImageSize->{898., Automatic},
  PlotRange->{{0., 3.1559809291248895`}, {0.5773502691896258, 
   1.11922526302993}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778904546003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".5"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"c", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778578816*^9, 3.5181778578856*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nc4lX0YB/ATKXtkJBnplZBCoozcx0iJlJJRySiU1yZKKWR7QyiUJCGj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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{642., Automatic},
  PlotRange->{{0., 2.034353398502827}, {-0.25738823672622857`, 
   0.6086002545996008}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181778982246*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"45", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"d", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778593736*^9, 3.5181778593756*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxV0Asw1VkcB/Dr1V8UUqotbTRuanBVq9KD3wkRFbKKzWN3SB65pUtR45Zk
U/JcKuuRQlJ5FaUrOm5e5S3uQ1mPy0Xc6+8ZFdq7M2tn9syc+c1n5nd+8/se
Tbczdh7SFArFVXL/qf8/o0Bl+03vHjgMZ9UWyyd/J/+1C8wfMUzY/p/p4IcW
7/KeXzATnowHFNXOLjgKwnL8Gee/LDgV2OeUFM+Ok0Cz0G0K4N6Fd6c77syO
kbCzYSArryoNRqKbs8MlfuCrr7Ps/T2IMtNxSBkloTgo60NYQTpQf38sxCMk
dMQm7PKlZ8ELp+Z35NDC/Fxwd2XljQsk7926oga88kA9puS+u8RUWWuthKE8
6GPpyLT1kLDBQueIWJwP9+dclhV2kxDbz+DYfC2AZiNpJ59OEqJ89fSlpQpB
9r5lRlk7CeFB6YKTSsWAx1uJ6SYSgmMjLbdsxhBewdV4XkLCYP5QRokHhue6
oYlLJbZrOjBvlo5BUGEW58EiQS08tD1naTkYBCsvWvGSBFGVcTT7WjmwV7ya
9XlOQpJp8fRQEBsChT4/ShWQMG2cXWvkUgEOcno/NWaSULA9wq+XWgPDxnvS
hyNJyJ/v3UmLa4RDPyR12TuSkMOjtrGsW8E+z2/v45Uk4KTqS+tUeNBZpPbc
smUEso+MMOc1P8KVEoN3FswROPa5e3eXRheYOg+/6dYcAYGJxrkQeg/UxdzZ
/aBSDFfDlk83MXrBmB5d135MDGF7jMbxUSFMht7Yoj8oAi/vQ/X6+gPAvrJL
WyFABIbL0mw7t3wC0/d8kiEeBk/aJms9lWGwk57Z3+I5DCFVk1Mlq8QwF+8o
t7VxCJitWcFv1ST/wDARXaINAf2JhfGroFF4kVpzJj3uE6g8dol/enEM3r8l
d3zoHAT3XiVq0Klx4O57tK9DfxCetPcouvpNAM2JdD7hPQAeN7UFV/0mQX7H
8uSE1H5oCpSfuvDrFHRsuWh7licEmqaiS4zbZ/ALbCntm+4DI7lHUufspyH0
yVO3rz/2QVkm61bSvhnQ3PstP8OkF7ZJiS51mXwBQbnvLcpBATgmsjInt30F
w0g6cJx6gCHKXr955zfQKW7ybrbphu/fFCJSd8xCt5X6upjLnbDHXH6rQGsO
qkdlntICOoB+WFvPXHseQhPuHASdD2Ad0+NxcfV3qP159NjwDA9szQmLQGkK
UjV+keH+hgMBGXly7FAKKnFlMW5YtQKZmiFgfKUgmvD8hglRM/Sf3+xjECyF
ytfLF/fdqgcD8ayy65QUGlS9mWkaUQN72DdytX2lUTl/ebX6hTdQ5v9wiiKW
RvIrG0w25LPgdoWqs4mHDIpdk/hojpsLw2NK9PgBGRSSu2ntOk44zDArz4V5
yiKNXo6V3JJ07PKwJuWvTlk02n/8inZQETbKdzpt/pscGhXucmPGl+MAeyPX
Ve1yiKJcZdOcVo1POPD3X7dZhLqNBQ3OOfW40VCWL9+8CIWxVP098ltwXDHz
+pgFgVSkNqt6drXhy89SJ+StCDSZN7ikWtyG6bllrhqHCLSa+tFo42wbtsqY
M7CxJZC6j6PJ0GoOlo1h9uQ4EkjDoYgTYsfB508yd3t5E0i2bIw6WMXBx9WY
os4IAp14GeqblsvFliqpDp8jCWRwOlmPWsrFOxXL3iyNIZCZqF8rp5aLV0jN
Je6NJ5DWvpUvyga4uEEUvD8pmUD8w1w3UpOHoTL47tEcAulOfBRG3uZhGk5Z
TM+T7KurqbDxAQ+vLSkNCCsg0AztzxPlhTw8kz9rVVhEoMqbmqUzzTz8NDl4
WqWMQI7Z8VOBinx873aK2yYsyaN1pm7NGj6OjittALYkjxeT93oTH58Kn804
XUWgvgPb/lAw5+NfQtWVr9UQKFPIR8/s+diCufdi6juJrZ5Rndz5eEeQs7Co
TtIf+BrJMfhYyz/Ytr5Bkp8+F1cQwsd/A14o+K4=
     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0., 2.9754873550395065`}, {-0.38285459763365837`, 1.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779028936*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", 
     RowBox[{"FrameLabel", "->", 
      RowBox[{"{", 
       RowBox[{"\"\<x\>\"", ",", "\"\<y\>\""}], "}"}]}], ",", 
     RowBox[{"Frame", "->", "True"}]}], "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181778617426*^9, 3.5181778617446003`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nk4lN0bB3DLkCgpFemlFIpQqV9J6h4le0mWUqTIVl5bKWRLUgqh7EuL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      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw113k4lF0UAPD3nSFDydImRKSdspQonNuiEiFKUipKpY0UiURIn12EQpKk
ZElaSFlCyJbQhsqayjJetNhmvuOP5p95fs88c8/dz7kKtg5mdiyKoiRoipr4
/veZoxGmf/dcGxRmJ0lczzYBKvhTQoHHP+8DvqiB14eL/+wAOy7FVAoG/LMn
WBoIXd0T88+h8HIBp2cg959vwpxVd3OKRv/5AfDSrUr63NvhoYetSKBfITQP
T16tFtgB5uszIq2Cy+HpWIPeeq9OKPBTzetdWQvl2cN29Ue+wfOxbY7Bbg2Q
/0eqxW1PF6Sky/qtc/kIAwYffpWt+g6eDg+aLcqawd0uvDFe9gdUfRrhKni3
wH6XjZP3DP2AbdcHFOedb4OSZ4XaCU9+whYb49/1CR1gdorzxPNCN7wo5bmJ
3foGX+j5vk1qPWDSy7FYFf0dXjTsNOQ09oCl7Nm3U3N+Qkjx2Ky+y73w8bs2
z/FxD9xVH2CUFPugOm9/pXdTH8RUpx75r7APBlIcz5Lz/TBZzPTEfHMu5K5v
avV1ZWC67v6QwXouPG89K6sQMAAN0oYRXkv74VxN/gNv/0FwmjprbczBfjhV
sGqaTvwQWGb/DJsS3w/DYZ9vdaf/grhe6zt/3/aD3kMV//2pv2GNwO4nR3j9
kPfuAVHJ/wOf7lzJ1V7CwN/NzaYF+X8hYqpznLAJAyVxK4M25Q6Dep2uoIED
AxVDhdELK0eA+tVU/yeYgUOV21QU34xAmIx+m00IA3RiW5Fs/QgIXDPJqkRr
mgj0STSNQEL45uj4UAZup2zaMPYTHVJxZu0VBtz31vTXiozCi1tTL7hfZWBp
eZOB25ZROLgi+nVhDAPBsb9Hq16Pgsvk+xvCkhnQWl3eL1szCq7Tb2wdQHd+
vN55vG4UBGqNRLffZUBvpu6bKU2jkLG3LXPmPQZ6w3wSjXpGYW9j53/XUhgw
9BM3qJo6BoqGxudD0hgQObUkqtJ8DNZJ3nFcn8WA/8a9qhWfx+CT5tHQty8Y
yL7WPC7YNgYNjQn18nkMfPtpVbn22xicz1399gR6XejOQ8/6xuC98rW/nHwG
Rj+Yxt3jj8HTz8N/1hQwcMJ+PeeywjhIOVo+u/qSAdOgRS3r7cbBeaf3RolS
Bi58SU73tB8H9VNzsy3Qaarz3Z+fGIf4UoXWWLTwO4WZGi7j4KVkbDO/jIGi
OTJGipfH4WTaVsmV5QxoPBDNoVLGoa+nS3NTBQOz6gZC83rGwVfVP0CzhgGv
6nqnzP5xSNKrneGA/lH+eMftIWxfLOXAXXRugYuM/9g4zB0R2zTrDQP700eS
t0/hwR4mS3kInfIfK797KQ8yj2w9nfiWAR2Q7Jl9jAe1bg29tQ0M3Fk9WDPF
gQfLOswr6XcMiGk2POQ78eCQuN0xdXSrctTZTjce2D3UGQxHX5KWZj8M4EHM
jJcK294z8OaXgvTm+zxoOSQ38vIDAzZpaptdfvCgTXnpNedGBpoczAPye3ng
3+QLiegdGs5VkwZ40Nd+M74GbZCbYxo9woN+Wtp3QRMDauWwK2cyH5qd5Hrq
0KyOrUdHVPhgvOiIqtxnBs7fdUhbp86HBqcP5hvRv49e6QvQ5MPMWZzlJ9E/
mQYnGeDDu+PpU/LQdfzd7jqmfFi9lWO38wvuX5mjQRec+BDXyvO/8JWBOV8D
a0pd+MAr81mciI5OTBcXc+fDXE6F1yt04GLm6k0fPsRExlhMbmHg9CrXG4VX
+eDSaXgzAr3B3C+Dlc2HcktuUlQr7ueAxFq/UT68D9a+eKidget/Fizy4/PB
wnmXhSd6Yda7giKaIj1ql3qi0c1yVrOKBCliu4TaU47e+Ne2tFCUIgekfDct
6GBAOvWMUv4cilR8LzZ9jz7TqlmbJ0+RQoVbmt3oN7OG3fMUKFKzPOAzH+3r
61H/Yj5FVCs9Ty7qZIBr7ef9XIUiIvy/cS7oIvFrLTm6FFHaPU9Z6BuOf5NV
UA5Q5EpnnqIU2tVDVitnLUWm6x9sXIRW+ZkQmq2P/fNpCDJARxWn6D3dShGp
8XW8y2hm+NjPJyYUIao641FoQ9VlUU+2UeSC1tq8O2jqRlbv4x0UWVd+0qsI
fczledwja4p0dOycNox+leax+dE+ipQWPpCe1MXA3HYYyrLB8Z2a1i6JbjAp
Mcyyo8iYGe/pUjQsrh7JPEGRAEnbY1bo6/tCkzMdKLIoWsrdDj0Uuc0s8xRF
Pvc3GjqiU1jvUx44UyRkno/qJbRk8xfLDA+KCPvZTEpDLzv+p/+2J0UEvmsx
j9FbxsT8r1+kSFty2M089EXZtc98L1Fk/ZqXG2vQcWm7trldxv6Kx8B7dI6O
0w8Hf4osWT84+hnN3XN79u5gikTlLyjoQYv0Pn9oGkqRBCG6dBC9wKPBYOMV
7H/67rAR9N4bgm5qkRhfPNxB6DsD51TkJBdGUySi6oSvKDoyT/O+7HX8/dvr
PdPQVZ8PNwrdwP8vZ1vKobtOeDmNx2P7+1rc5qHZvGsigwkUie7RtVmEXi1X
sfpLEkWU57i5qqEtMtrq6pMn5tsyZSXaSW/06Ot7FNnwMvuGNjplr3Ls4zRc
n4+/awm6pG+Dxv0Migj1vxfbgG65YF15MxP308FVkpvQY1NdDkRmUaR/hdRH
A/SsmyGjAY8pkm17zsYIrbH8boTXU4rs77XKMEabFBQsdcmhyM+GF/mm6KMm
H4uP5VLEYvbNcDO039f+3TYvKJKUSy/Zjk50EB6yyKdIXU6H7w50Pl8hyKgQ
+zdt820LdGPoaqV1RRR5X7n00k70b3nzF6tKKHK/JXSJJVoi89h2lVKMb3Ym
YsIqxLdHsZwiv+d+KpiwQW2cr1QFRRyM8h9M+OD+J7JTqyhS3jDvwIQ9+6sf
s2tw/nOFGyfaj/X6ZjT8hiKKYw7TJ5wtzu/oe0sRhVgLyYn+1CXM8uiopwgr
Oq9+ov99qqozGt9RpJibZGmOFnm5Of3NB4ocuTPl1jb0gm02+q8+4X2QPZRm
gl7beu5zbhNFti+0Pr8VvedUuHPmZ4rEDeqLGaJd6VTR5K+4frIP7Dajr14p
vhPbivOTeM1TH/1AoVn3SjtF8i+xrNehKx4OvfPrxP3/qmdcD/1trejJ810U
0bPdabsGLWerF3+4G9c/K91ZA609YKFp3UuRGLvrSsvRO7wdasy4FKl1Foxe
gg5KTODpDuL5SNtbOhd9V/1ZlMYvjFdv6CODLi56u2zxH4qc3/mMPRM90sba
N30U23OeYSIyEe/D8+QV43hevoyHstHrK8/0bedTpOjMff8xPA+Bj755RLJp
wlE2vduLfnD35qsngjTJNjKo7ETXx1qKvheiycnYSfcmzpuMb0XczCk0+VVU
HViFJq4+HZpTaVIS+yG8GH3guI7yTnGaxCTeMctFp27PeB49nSb7V4eMJaN1
5oc3Ss2hyZbwK8Pn0ftmGypqy9PEsulF6Sm0r6jA0V0KNHEwSzM6hK765Tx8
fT5Nsio+eBuj95TukpJZRpPY9v3XZNAehxUs5gBNvj1dc+Qe3m+3djfe0F1L
k9MtKS+vTdx3JhGd1utxfFrN9f+hRbUEneM3YfxTwYpH0Dc4PyLkTWmiPEXR
fh46PyXzrYINjrd9WmwQ3t9tN+xnrztAE7feEi9X9KRwRRtbO5oEz18tfxBt
4na1P9GeJlXyp/xWo79ucRVTcqLJfR0JXjvmB6oHti7woUnbLOnwxeiiFffl
FS/RJLzdMlUS7eMxfWDOZZq0SET6jWI+EhL7ETUjEOcjStCnCi2qHt4iEEGT
p3plEcfQs107Trcn0mSJaPX0+DY8j4XGG78m0aSI1bbVBx0n/EyqKZkmf62G
Nh9By8cG59XdpwnRkLikhp6frylUlEUTPZ+lM15i/lQT8I9JKKIJk9B2tQHz
66DR4PG4Epo4Flb3PkE/jrSGa6U0CV33lBON1lqo3hFaQZPkk56+lmi9LU0q
nnU02XBoIOIj5u8tYSovrdtoollvJVmN+f+AbF2XNItFhm+vDL7cjPfB62b7
tQIsEnIh4rs1+o9zV/fhSSxiXCcxqoEOfDPGfSzCIts6HfS/Yj3yyHvhX+Np
LLL32UMHdbTAj/McHyUWiZptJF35iYGkJwsXd29kEa/cprJXWB+dsFVPlTBg
Ec/czUIRaC0xXRUtQxa5p/F+fB+66oiZ2iUTFrlwxUx8GOurIRkPbXlLFlEf
ra1YiN7gXWdgbs8iOX4dkWfrGWg39jj6PJBFyIVDvi1Y3xmaap/NC2YRvSVC
t+6hs7b98ikIZREV1zkXHNEXt5+4URzBIp+G75/jY70ob2VdWxnLIsevGrhI
o3fb6Wo2p2L8BZGXNlTh+XIfp8crWWRrvt3YEaxPi+55XNebwiZxL3q2DGI9
/JMdFq45lU3ueRf2pqGn7UsMXCbOJj12F80PoQ/OKPOQm84mc30rDn/EelrI
W9yWJ8MmWvJuj55hvW20+/aS/KX4e63xB8fnDLwTff1c15BNPsrWmD58ivWt
0/QvOgFs0mujNNkd63tp9TK/fUFswr6VPl8ObcScW+4dwiaKxrv/FqYykO7w
1assnE3ODcwrFUSfOn5/nlksmwQdOMoOwvfCiB2xP5zGJgZdlQKB+N6YvOv4
0JUaNhF3blU0T8D1hxKRLkkB8j3FompyBNZT6q/bT4cLkJNNCwLXnmUgZFFX
UpqsIFGa5n342Xasf0Ji3fcnCeL0R+tbLcP8J3OH91txEtk++cBI2CTMF6ll
9tppk4ixn4et5Id+2GcLF/cqC5EGN8omKbkf/P23ZvBShIhs062W7af74U3W
meIt6hwy8rWgdO+qfjjNZnzPPeSQR9Mkw8p+c+FH99WjDx9xiH1Pt278EBf2
NWiZ/njCIfz9aaZnBrhgeMdLZlcuh1TPaU2S6+OC0ibxLK1iDununM053smF
hoDlX/80cIh2ZvmzH/j+XCF5UtvlL4cIq8hUOGZyIXVEQj5jhENeXyyfviKD
CwrtTwS+jWE8pz0lv1O5IPp4/M0OWpgYLNQyc7vLhc4dwYdWigiT4K/5i9zi
uRB5PS1iSEaYzAsQfrkniAuTvU3PKcsJk664uVYzA7hw8ejQ3oNzhUmgoZzl
m8tcOLFGZ0mDkjBxPl/tDT5c0P9cWfhIRZhUK4+GS7nh+/iVQ3L3cmESIbfJ
vPosF9QypgXNUxcm2mnnXC86c0HOc/fOCE1hsjA2nOly5MLVw3ydSi1h4jDm
qh9zkgsiprcV2WuESfSwPs/wOBe8tDZx1ugKk5vhwzLj9lz4Pbe71wmEyeWy
iPj0w1z4HzwUj3A=
      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nc4lX0YB/ATKXtkJBnplZBCoozcx0iJlJJRySiU1yZKKWR7QyiUJCGj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      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxV0Asw1VkcB/Dr1V8UUqotbTRuanBVq9KD3wkRFbKKzWN3SB65pUtR45Zk
U/JcKuuRQlJ5FaUrOm5e5S3uQ1mPy0Xc6+8ZFdq7M2tn9syc+c1n5nd+8/se
Tbczdh7SFArFVXL/qf8/o0Bl+03vHjgMZ9UWyyd/J/+1C8wfMUzY/p/p4IcW
7/KeXzATnowHFNXOLjgKwnL8Gee/LDgV2OeUFM+Ok0Cz0G0K4N6Fd6c77syO
kbCzYSArryoNRqKbs8MlfuCrr7Ps/T2IMtNxSBkloTgo60NYQTpQf38sxCMk
dMQm7PKlZ8ELp+Z35NDC/Fxwd2XljQsk7926oga88kA9puS+u8RUWWuthKE8
6GPpyLT1kLDBQueIWJwP9+dclhV2kxDbz+DYfC2AZiNpJ59OEqJ89fSlpQpB
9r5lRlk7CeFB6YKTSsWAx1uJ6SYSgmMjLbdsxhBewdV4XkLCYP5QRokHhue6
oYlLJbZrOjBvlo5BUGEW58EiQS08tD1naTkYBCsvWvGSBFGVcTT7WjmwV7ya
9XlOQpJp8fRQEBsChT4/ShWQMG2cXWvkUgEOcno/NWaSULA9wq+XWgPDxnvS
hyNJyJ/v3UmLa4RDPyR12TuSkMOjtrGsW8E+z2/v45Uk4KTqS+tUeNBZpPbc
smUEso+MMOc1P8KVEoN3FswROPa5e3eXRheYOg+/6dYcAYGJxrkQeg/UxdzZ
/aBSDFfDlk83MXrBmB5d135MDGF7jMbxUSFMht7Yoj8oAi/vQ/X6+gPAvrJL
WyFABIbL0mw7t3wC0/d8kiEeBk/aJms9lWGwk57Z3+I5DCFVk1Mlq8QwF+8o
t7VxCJitWcFv1ST/wDARXaINAf2JhfGroFF4kVpzJj3uE6g8dol/enEM3r8l
d3zoHAT3XiVq0Klx4O57tK9DfxCetPcouvpNAM2JdD7hPQAeN7UFV/0mQX7H
8uSE1H5oCpSfuvDrFHRsuWh7licEmqaiS4zbZ/ALbCntm+4DI7lHUufspyH0
yVO3rz/2QVkm61bSvhnQ3PstP8OkF7ZJiS51mXwBQbnvLcpBATgmsjInt30F
w0g6cJx6gCHKXr955zfQKW7ybrbphu/fFCJSd8xCt5X6upjLnbDHXH6rQGsO
qkdlntICOoB+WFvPXHseQhPuHASdD2Ad0+NxcfV3qP159NjwDA9szQmLQGkK
UjV+keH+hgMBGXly7FAKKnFlMW5YtQKZmiFgfKUgmvD8hglRM/Sf3+xjECyF
ytfLF/fdqgcD8ayy65QUGlS9mWkaUQN72DdytX2lUTl/ebX6hTdQ5v9wiiKW
RvIrG0w25LPgdoWqs4mHDIpdk/hojpsLw2NK9PgBGRSSu2ntOk44zDArz4V5
yiKNXo6V3JJ07PKwJuWvTlk02n/8inZQETbKdzpt/pscGhXucmPGl+MAeyPX
Ve1yiKJcZdOcVo1POPD3X7dZhLqNBQ3OOfW40VCWL9+8CIWxVP098ltwXDHz
+pgFgVSkNqt6drXhy89SJ+StCDSZN7ikWtyG6bllrhqHCLSa+tFo42wbtsqY
M7CxJZC6j6PJ0GoOlo1h9uQ4EkjDoYgTYsfB508yd3t5E0i2bIw6WMXBx9WY
os4IAp14GeqblsvFliqpDp8jCWRwOlmPWsrFOxXL3iyNIZCZqF8rp5aLV0jN
Je6NJ5DWvpUvyga4uEEUvD8pmUD8w1w3UpOHoTL47tEcAulOfBRG3uZhGk5Z
TM+T7KurqbDxAQ+vLSkNCCsg0AztzxPlhTw8kz9rVVhEoMqbmqUzzTz8NDl4
WqWMQI7Z8VOBinx873aK2yYsyaN1pm7NGj6OjittALYkjxeT93oTH58Kn804
XUWgvgPb/lAw5+NfQtWVr9UQKFPIR8/s+diCufdi6juJrZ5Rndz5eEeQs7Co
TtIf+BrJMfhYyz/Ytr5Bkp8+F1cQwsd/A14o+K4=
      "]]}}},
  Axes->True,
  AxesOrigin->{0, 0.6},
  Frame->True,
  FrameLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox["\"y\"", TraditionalForm]},
  ImageSize->{1064., Automatic},
  PlotRange->{{0., 2.5768476381035805`}, {0.5773502691896258, 
   0.9386002404249476}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779050326*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 157, 7, 191, "Title",
 Evaluatable->False],
Cell[717, 29, 96, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[838, 38, 487, 14, 112, "Input"],
Cell[1328, 54, 461, 18, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[1826, 77, 244, 7, 72, "Input"],
Cell[2073, 86, 240, 9, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[2328, 98, 73, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[2426, 107, 1866, 58, 392, "Input"],
Cell[4295, 167, 330, 11, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[4662, 183, 398, 12, 72, "Input"],
Cell[5063, 197, 440, 16, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[5518, 216, 83, 5, 65, "Text",
 Evaluatable->False],
Cell[5604, 223, 1537, 48, 392, "Input"],
Cell[7144, 273, 615, 18, 112, "Input"],
Cell[CellGroupData[{
Cell[7784, 295, 639, 20, 112, "Input"],
Cell[8426, 317, 956, 30, 52, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[9407, 351, 769, 24, 152, "Input"],
Cell[10179, 377, 134, 3, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10362, 386, 1354, 42, 272, "Input"],
Cell[11719, 430, 5756, 103, 145, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[17512, 538, 1205, 38, 192, "Input"],
Cell[18720, 578, 5827, 104, 176, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[24584, 687, 1205, 38, 192, "Input"],
Cell[25792, 727, 5771, 103, 285, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[31600, 835, 1205, 38, 192, "Input"],
Cell[32808, 875, 2382, 46, 182, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[35227, 926, 390, 10, 72, "Input"],
Cell[35620, 938, 18806, 323, 193, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

