(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     57602,       1361]
NotebookOptionsPosition[     55343,       1276]
NotebookOutlinePosition[     55899,       1298]
CellTagsIndexPosition[     55856,       1295]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

This File Determines If A Ball 

Bounces Over a Fence.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell["\<\

Solve for the time period from release to impact.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"e1", " ", "=", " ", 
     RowBox[{
      RowBox[{"m", " ", "g", " ", "yo"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"1", "/", "2"}], " ", "m", " ", 
       RowBox[{"vi", "^", "2"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{"ans", " ", "=", " ", 
    RowBox[{"Solve", "[", 
     RowBox[{"e1", ",", "vi"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779284066*^9, 3.5181779284086*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Solve", "::", "ratnz"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Solve was unable to solve the system with inexact \
coefficients. The answer was obtained by solving a corresponding exact system \
and numericizing the result. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Solve\\\", ButtonNote -> \
\\\"Solve::ratnz\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5181779535246*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"vi", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "4.42944691807002`"}], " ", 
      SqrtBox["yo"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"vi", "\[Rule]", 
     RowBox[{"4.42944691807002`", " ", 
      SqrtBox["yo"]}]}], "}"}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779535276003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"ansvi", " ", "=", " ", 
    RowBox[{"ans", "[", 
     RowBox[{"[", "2", "]"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779297686*^9, 3.5181779297706003`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"vi", "\[Rule]", 
   RowBox[{"4.42944691807002`", " ", 
    SqrtBox["yo"]}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779591296*^9}]
}, Open  ]],

Cell["\<\

Now for the impact itself.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"nx", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"ny", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"i", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "theta", "]"}]}], " ", "ny"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "nx"}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"j", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "theta", "]"}], " ", "nx"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "ny"}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"vinx", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", " ", "vi"}], " ", 
        RowBox[{"j", " ", ".", " ", "nx"}]}], ")"}], "/.", "ansvi"}]}], ";"}],
    "\n", "\n", 
   RowBox[{
    RowBox[{"viny", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", " ", "vi"}], " ", 
        RowBox[{"j", " ", ".", " ", "ny"}]}], ")"}], "/.", "ansvi"}]}], ";"}],
    "\n", "\n", 
   RowBox[{
    RowBox[{"vfny", " ", "=", " ", "viny"}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"e2", " ", "=", " ", 
     RowBox[{"rest", " ", "==", " ", 
      RowBox[{
       RowBox[{"-", " ", 
        RowBox[{"(", 
         RowBox[{"vfnx", " ", "-", " ", "0"}], ")"}]}], "/", 
       RowBox[{"(", 
        RowBox[{"vinx", " ", "-", " ", "0"}], ")"}]}]}]}], ";"}], "\n", "\n", 
   
   RowBox[{"ans", " ", "=", " ", 
    RowBox[{"Solve", "[", 
     RowBox[{"e2", ",", "vfnx"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779314606*^9, 3.5181779314625998`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"vfnx", "\[Rule]", 
    RowBox[{"4.42944691807002`", " ", "rest", " ", 
     SqrtBox["yo"], " ", 
     RowBox[{"Cos", "[", "theta", "]"}]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779607816*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"vf", " ", "=", " ", 
    RowBox[{
     RowBox[{"vfny", " ", "ny"}], " ", "+", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"vfnx", "/.", "ans"}], ")"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], " ", "nx"}]}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779327246*^9, 3.5181779327265997`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"0.`", "\[VeryThinSpace]", "+", 
    RowBox[{"4.42944691807002`", " ", "rest", " ", 
     SqrtBox["yo"], " ", 
     RowBox[{"Cos", "[", "theta", "]"}]}]}], ",", 
   RowBox[{"0.`", "\[VeryThinSpace]", "-", 
    RowBox[{"4.42944691807002`", " ", 
     SqrtBox["yo"], " ", 
     RowBox[{"Sin", "[", "theta", "]"}]}]}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779623386*^9}]
}, Open  ]],

Cell["\<\

Now for the flight after the impact.
\
\>", "Text",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"nx", " ", "=."}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"ny", " ", "=."}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"i", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"j", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"nx", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "theta", "]"}], " ", "j"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "i"}]}]}], ";"}], "\n", "\n", 
   
   RowBox[{
    RowBox[{"ny", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "theta", "]"}]}], " ", "i"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"Sin", "[", "theta", "]"}], " ", "j"}]}]}], ";"}], "\n", "\n", 
   
   RowBox[{
    RowBox[{"vfij", " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"vf", "[", 
        RowBox[{"[", "1", "]"}], "]"}], " ", "nx"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"vf", "[", 
        RowBox[{"[", "2", "]"}], "]"}], " ", "ny"}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"vfi", " ", "=", " ", 
     RowBox[{"vfij", " ", ".", " ", "i"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"vfj", " ", "=", " ", 
     RowBox[{"vfij", " ", ".", " ", "j"}]}], ";"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779341736*^9, 3.5181779341756*^9}}],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{"vfi", " ", "t"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"y", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"L", " ", 
       RowBox[{"Tan", "[", "theta", "]"}]}], " ", "+", " ", 
      RowBox[{"vfj", " ", "t"}], " ", "-", " ", 
      RowBox[{
       RowBox[{"1", "/", "2"}], " ", "g", " ", 
       RowBox[{"t", "^", "2"}]}]}]}], ";"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779349896*^9, 3.5181779349916*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"ans", " ", "=", " ", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"L", " ", "==", " ", 
        RowBox[{"x", "[", "t", "]"}]}], ",", "t"}], "]"}]}], ";"}], "\n", 
   "\n", 
   RowBox[{"clearance", " ", "=", " ", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"t", "/.", "ans"}], ")"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}], " ", "-", " ", "H"}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779371436*^9, 3.5181779371456003`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "H"}], "-", 
  FractionBox[
   RowBox[{"4.905`", " ", 
    SuperscriptBox["L", "2"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"0.`", "\[VeryThinSpace]", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"4.42944691807002`", "\[VeryThinSpace]", "+", 
         RowBox[{"4.42944691807002`", " ", "rest"}]}], ")"}], " ", 
       SqrtBox["yo"], " ", 
       RowBox[{"Cos", "[", "theta", "]"}], " ", 
       RowBox[{"Sin", "[", "theta", "]"}]}]}], ")"}], "2"]], "+", 
  FractionBox[
   RowBox[{"0.`", "\[VeryThinSpace]", "+", 
    RowBox[{"4.42944691807002`", " ", "L", " ", "rest", " ", 
     SqrtBox["yo"], " ", 
     SuperscriptBox[
      RowBox[{"Cos", "[", "theta", "]"}], "2"]}], "-", 
    RowBox[{"4.42944691807002`", " ", "L", " ", 
     SqrtBox["yo"], " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "theta", "]"}], "2"]}]}], 
   RowBox[{"0.`", "\[VeryThinSpace]", "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"4.42944691807002`", "\[VeryThinSpace]", "+", 
       RowBox[{"4.42944691807002`", " ", "rest"}]}], ")"}], " ", 
     SqrtBox["yo"], " ", 
     RowBox[{"Cos", "[", "theta", "]"}], " ", 
     RowBox[{"Sin", "[", "theta", "]"}]}]}]], "+", 
  RowBox[{"L", " ", 
   RowBox[{"Tan", "[", "theta", "]"}]}]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779673696003`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"param", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"H", "->", "1"}], ",", 
       RowBox[{"L", "->", "2"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}], ",", "\n", "\n", "\t", 
       RowBox[{"g", "->", "9.81"}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"clearance", "/.", "param"}], ")"}], "//", "N"}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779398346*^9, 3.5181779398375998`*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData["0.44916482433446414`"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779692576*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"g", " ", "=", " ", "9.81"}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"tend", " ", "=", " ", ".5"}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"a", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779415456*^9, 3.5181779415486*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nk8lNsfB/DByFZaqKRLFIpIlt+NUt/RYktJllKJyFLJIG4SkVBkSyFZ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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0.6},
  ImageSize->{921., Automatic},
  PlotRange->{{0., 2.57684763810358}, {0.5773502691896258, 
   0.9386002404249478}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779711826*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "3"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"b", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779436046*^9, 3.5181779436076*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw112k4lF0YB/BnZshMJUubEJFWlFSi6D4qIWuURBSlUsryRiIRUkRERZGk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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0.6},
  ImageSize->{935., Automatic},
  PlotRange->{{0., 3.1559809291248886`}, {0.5773502691896258, 
   1.1192252630299298`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779754835997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".5"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"30", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"c", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779450685997`*^9, 3.5181779450706*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nc8VW8cB/CbKHsnyUiDSFFGGfW9JKWkVFYiZJTsRClCdr/sMpIkK0rD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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  ImageSize->{631., Automatic},
  PlotRange->{{0., 2.034353398502826}, {-0.2573882367262288, 
   0.6086002545996008}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779791766*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"paramxy", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"L", "->", "1"}], ",", 
       RowBox[{"rest", "->", ".9"}], ",", 
       RowBox[{"yo", "->", "2"}], ",", 
       RowBox[{"theta", "->", 
        RowBox[{"45", " ", "Degree"}]}]}], "}"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yy", "[", "t_", "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"y", "[", "t", "]"}], "/.", "paramxy"}]}], ";"}], "\n", "\n", 
   RowBox[{"d", " ", "=", " ", 
    RowBox[{"ParametricPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "t", "]"}], ",", 
        RowBox[{"yy", "[", "t", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "tend"}], "}"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779463845997`*^9, 3.5181779463866*^9}},
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxVzw0w1HkYB/Al21+UJKorFcaGkaVOL/Ly/FBEhTrF5eUaUchKmyJjS3Lp
ReSoHOmFXhQWpbSy/WwlKrLK2lXOy7LI7vojIqHbmzk3c7+ZZ37zmXmeZ56v
fsDBHUHKFArFX1H//P9/A0DjRYxu6NkGh3RmqWb9IP+1H0xtX5++5j8zIALN
sgqZmjYL8ociS99MTPsCJBQcZh79Nu1s4B3RUD80RALdeWV9ZNM1eB3ecmVi
kIR1dT132FXXoT+Zn5eo8O0wc9N572/AhY2mXlcHSCiLvvMxoTgHaL/fl+B+
EloupluFMe7AYx/+a7Jven8hBPpz2ENixXxA24WeYDboppTf3KswTcXNML2P
DV0c0xmNHSQYOJtul8uL4Oak37yH7SRc7GYK3MeLgW+r7BPaSsKFMDNzZaWH
oHLTJZfbTEJidI54n0YZ4KEPxGg9CbEXk1wsTDAkvmjSe1ROQm9RX255EIZH
K+Mz5ii8o37z1MYcDOIXG1ODOCToJMY3F8ypBMvYuTO1n5Agq7JL5p2uBJ72
04nQRyRkOpaN9kXzIEoSukypmIRRu7w3tn4vwItq9vO7WyQUrzkX0UmrBqmd
dY40iYSiqc519NR3sPWnzDZPbxIKhLRGjtsH2MmOsLm/gASc+er4Uk0htJXq
PHJp6Ie87f2sKf1PcLLc8rUzqx92fW3f0KbXBo6+0uft+v0gdtA7EsfogLcp
VzbcfimHUwnzR+uZnQCM5LfNu+SQYG07hHdKYDj+rIV5rwyCQ7bWmpv3AO+k
lZFapAzWz7vu0WrxGRzfi0imXAr76cZuZppS2KE8tqlhvxTiqoZHyhfKYSrN
m7rqXR+wPtyJrdEhQc50kB2n9wEj39nuafQAlGVXH8xJ/Qya9/3SSmIG4X0N
ufZjay/s7dSgRR8YAqH9PfsW817Ib+5Q94/4AnQf0jcwpAeCzhuJT0UMg9ra
+Vnp2d1QH6U6cuy3EWixiPE4JJQAXV/dLyXgKxyKaqjoGu0CW+o9pSOeo3Aq
vyRgfFkXcG9xLmXaj4GBzfeiXIdOWK0kO97m8A26KsMuUbaIwTuDc2t49ThY
JTFA4NMBTFnecpN132FlWX0I370dfnxXO5e9dgLErrpLU060grWT6iqx4STU
DMwooUe2AGObkZmT0RScTr+yBUw/gltKR1DMoh9Q+8vALumYEDycCOcoZQrS
tnucu/e5ACJz2VRePAVV+HOYZ10/AJmdK2aOU5CF5KjBFxkfuo+ahFrGKqGX
y1XLui7VgqV8Yq7/iBKSaZ2/5XiuGqx5ZwuNwpRRjWj+K91jz4F7+O4IRa6M
NBfUORgUceDyCy1fh6AZqHhxxr3JpkKQDmow0npmIArbeMlSQSKMsV4eSdiv
giidAlfq7Bzsd7f66l+tKqi9e/dJo+hSbFvkE+60h4p6JVYBrLRKHOlp67+w
mYrGNKrc+ddf4UAv0aYz7jORyE5c51tQi9+tVxGp8meiOI7W4aCiBpxaxjoz
6Eyg2UomWvvbGvGJB9lfVF0JNMDunf1K3ogZhVx/va0E0qZ9sl0x0Yhdcyct
3T0ItCjU26FvkQCrpLA6CrwJpOtVKojbIcBH97E2BIcQiMIdpPVWCfBuHZas
9RyB9jyJD7te2IRdNLO9viYRyCI8y4xW0YTXqXOfz0khEJJ1Gxa8acLaSpMZ
NmkE0rNf8Jjb04TrZLGbMrMIJNrWFEDqCzG8jL22s4BAxl8+SZIuCzEdX53F
YCvuXamvtuK2EC8pr4hMKCbQMP3PwMqHQjxWNOH6sJRAlef1K8b4QlySFTuq
ySWQZ17aSJS6CN+4fDXAGCvyGB58u3ixCCenVtQBT5EnmCV8ZizCBxIncsOr
CNS+efUfak4i/Gu87tzT1QS6IRGhB54i7Myyicl+rbDrA5rPXhFeG+0rKX2r
6I96hqhMETY8HOtRW6fIz5hMLY4T4b8BF7/44w==
     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0., 2.9754873550395065`}, {-0.38285459763365814`, 1.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779824456*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", 
     RowBox[{"FrameLabel", "->", 
      RowBox[{"{", 
       RowBox[{"\"\<x\>\"", ",", "\"\<y\>\""}], "}"}]}], ",", 
     RowBox[{"Frame", "->", "True"}]}], "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181779482346*^9, 3.5181779482366*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nk8lNsfB/DByFZaqKRLFIpIlt+NUt/RYktJllKJyFLJIG4SkVBkSyFZ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      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw112k4lF0YB/BnZshMJUubEJFWlFSi6D4qIWuURBSlUsryRiIRUkRERZGk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      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw11nc8VW8cB/CbKHsnyUiDSFFGGfW9JKWkVFYiZJTsRClCdr/sMpIkK0rD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      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxVzw0w1HkYB/Al21+UJKorFcaGkaVOL/Ly/FBEhTrF5eUaUchKmyJjS3Lp
ReSoHOmFXhQWpbSy/WwlKrLK2lXOy7LI7vojIqHbmzk3c7+ZZ37zmXmeZ56v
fsDBHUHKFArFX1H//P9/A0DjRYxu6NkGh3RmqWb9IP+1H0xtX5++5j8zIALN
sgqZmjYL8ociS99MTPsCJBQcZh79Nu1s4B3RUD80RALdeWV9ZNM1eB3ecmVi
kIR1dT132FXXoT+Zn5eo8O0wc9N572/AhY2mXlcHSCiLvvMxoTgHaL/fl+B+
EloupluFMe7AYx/+a7Jven8hBPpz2ENixXxA24WeYDboppTf3KswTcXNML2P
DV0c0xmNHSQYOJtul8uL4Oak37yH7SRc7GYK3MeLgW+r7BPaSsKFMDNzZaWH
oHLTJZfbTEJidI54n0YZ4KEPxGg9CbEXk1wsTDAkvmjSe1ROQm9RX255EIZH
K+Mz5ii8o37z1MYcDOIXG1ODOCToJMY3F8ypBMvYuTO1n5Agq7JL5p2uBJ72
04nQRyRkOpaN9kXzIEoSukypmIRRu7w3tn4vwItq9vO7WyQUrzkX0UmrBqmd
dY40iYSiqc519NR3sPWnzDZPbxIKhLRGjtsH2MmOsLm/gASc+er4Uk0htJXq
PHJp6Ie87f2sKf1PcLLc8rUzqx92fW3f0KbXBo6+0uft+v0gdtA7EsfogLcp
VzbcfimHUwnzR+uZnQCM5LfNu+SQYG07hHdKYDj+rIV5rwyCQ7bWmpv3AO+k
lZFapAzWz7vu0WrxGRzfi0imXAr76cZuZppS2KE8tqlhvxTiqoZHyhfKYSrN
m7rqXR+wPtyJrdEhQc50kB2n9wEj39nuafQAlGVXH8xJ/Qya9/3SSmIG4X0N
ufZjay/s7dSgRR8YAqH9PfsW817Ib+5Q94/4AnQf0jcwpAeCzhuJT0UMg9ra
+Vnp2d1QH6U6cuy3EWixiPE4JJQAXV/dLyXgKxyKaqjoGu0CW+o9pSOeo3Aq
vyRgfFkXcG9xLmXaj4GBzfeiXIdOWK0kO97m8A26KsMuUbaIwTuDc2t49ThY
JTFA4NMBTFnecpN132FlWX0I370dfnxXO5e9dgLErrpLU060grWT6iqx4STU
DMwooUe2AGObkZmT0RScTr+yBUw/gltKR1DMoh9Q+8vALumYEDycCOcoZQrS
tnucu/e5ACJz2VRePAVV+HOYZ10/AJmdK2aOU5CF5KjBFxkfuo+ahFrGKqGX
y1XLui7VgqV8Yq7/iBKSaZ2/5XiuGqx5ZwuNwpRRjWj+K91jz4F7+O4IRa6M
NBfUORgUceDyCy1fh6AZqHhxxr3JpkKQDmow0npmIArbeMlSQSKMsV4eSdiv
giidAlfq7Bzsd7f66l+tKqi9e/dJo+hSbFvkE+60h4p6JVYBrLRKHOlp67+w
mYrGNKrc+ddf4UAv0aYz7jORyE5c51tQi9+tVxGp8meiOI7W4aCiBpxaxjoz
6Eyg2UomWvvbGvGJB9lfVF0JNMDunf1K3ogZhVx/va0E0qZ9sl0x0Yhdcyct
3T0ItCjU26FvkQCrpLA6CrwJpOtVKojbIcBH97E2BIcQiMIdpPVWCfBuHZas
9RyB9jyJD7te2IRdNLO9viYRyCI8y4xW0YTXqXOfz0khEJJ1Gxa8acLaSpMZ
NmkE0rNf8Jjb04TrZLGbMrMIJNrWFEDqCzG8jL22s4BAxl8+SZIuCzEdX53F
YCvuXamvtuK2EC8pr4hMKCbQMP3PwMqHQjxWNOH6sJRAlef1K8b4QlySFTuq
ySWQZ17aSJS6CN+4fDXAGCvyGB58u3ixCCenVtQBT5EnmCV8ZizCBxIncsOr
CNS+efUfak4i/Gu87tzT1QS6IRGhB54i7Myyicl+rbDrA5rPXhFeG+0rKX2r
6I96hqhMETY8HOtRW6fIz5hMLY4T4b8BF7/44w==
      "]]}}},
  Axes->True,
  AxesOrigin->{0, 0.6},
  Frame->True,
  FrameLabel->{
    FormBox["\"x\"", TraditionalForm], 
    FormBox["\"y\"", TraditionalForm]},
  ImageSize->{926., Automatic},
  PlotRange->{{0., 2.57684763810358}, {0.5773502691896258, 
   0.9386002404249478}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181779840516*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 159, 9, 299, "Title",
 Evaluatable->False],
Cell[719, 31, 96, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[840, 40, 487, 14, 112, "Input"],
Cell[1330, 56, 521, 11, 21, "Message"],
Cell[1854, 69, 412, 14, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[2303, 88, 248, 7, 72, "Input"],
Cell[2554, 97, 218, 7, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[2787, 107, 73, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[2885, 116, 1866, 58, 392, "Input"],
Cell[4754, 176, 306, 9, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[5097, 190, 402, 12, 72, "Input"],
Cell[5502, 204, 469, 13, 37, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[5986, 220, 83, 5, 65, "Text",
 Evaluatable->False],
Cell[6072, 227, 1533, 48, 392, "Input"],
Cell[7608, 277, 611, 18, 112, "Input"],
Cell[CellGroupData[{
Cell[8244, 299, 639, 20, 112, "Input"],
Cell[8886, 321, 1383, 38, 62, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[10294, 363, 769, 24, 152, "Input"],
Cell[11066, 389, 130, 3, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11245, 398, 1354, 42, 272, "Input"],
Cell[12602, 442, 5753, 103, 149, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[18392, 550, 1205, 38, 192, "Input"],
Cell[19600, 590, 5838, 104, 182, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[25475, 699, 1209, 38, 192, "Input"],
Cell[26687, 739, 5769, 103, 280, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[32493, 847, 1209, 38, 192, "Input"],
Cell[33705, 887, 2382, 46, 182, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[36124, 938, 386, 10, 72, "Input"],
Cell[36513, 950, 18814, 323, 173, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

