(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16543,        546]
NotebookOptionsPosition[     14339,        464]
NotebookOutlinePosition[     14895,        486]
CellTagsIndexPosition[     14852,        483]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

This file derives the coefficient of restitution equations.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"edax", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "fd"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "uax"}], " ", "-", " ", 
       RowBox[{"ma", " ", "vaxi"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"eday", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "nd"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "uay"}], " ", "-", " ", 
       RowBox[{"ma", " ", "vayi"}]}]}]}], ";"}], "\n", "\n", "\n", "\n", 
   RowBox[{
    RowBox[{"edbx", " ", "=", " ", 
     RowBox[{"fd", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "ubx"}], " ", "-", " ", 
       RowBox[{"mb", " ", "vbxi"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"edby", " ", "=", " ", 
     RowBox[{"nd", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "uby"}], " ", "-", " ", 
       RowBox[{"mb", " ", "vbyi"}]}]}]}], ";"}], "\n", "\n", "\n", "\n", 
   RowBox[{
    RowBox[{"erax", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "fr"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "vaxf"}], " ", "-", " ", 
       RowBox[{"ma", " ", "uax"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"eray", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "nr"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "vayf"}], " ", "-", " ", 
       RowBox[{"ma", " ", "uay"}]}]}]}], ";"}], "\n", "\n", "\n", "\n", 
   RowBox[{
    RowBox[{"erbx", " ", "=", " ", 
     RowBox[{"fr", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "vbxf"}], " ", "-", " ", 
       RowBox[{"mb", " ", "ubx"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"erby", " ", "=", " ", 
     RowBox[{"nr", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "vbyf"}], " ", "-", " ", 
       RowBox[{"mb", " ", "uby"}]}]}]}], ";"}], "\n", "\n", "\n"}]}]], "Input",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560609974003`*^9, 3.5195560609974003`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", 
    RowBox[{"{", 
     RowBox[{
     "edax", ",", "erax", ",", "eday", ",", "eray", ",", "edbx", ",", "erbx", 
      ",", "edby", ",", "erby"}], "}"}], "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560629318*^9, 3.5195560629318*^9}}],

Cell[BoxData["\<\"\\\\{-\\\\text{fd}=\\\\text{ma} \\\\text{uax}-\\\\text{ma} \
\\\\text{vaxi},-\\\\text{fr}=\\\\text{ma} \\\\text{vaxf}-\\\\text{ma} \
\\\\text{uax},-\\\\text{nd}=\\\\text{ma} \\\\text{uay}-\\\\text{ma} \
\\\\text{vayi},-\\\\text{nr}=\\\\text{ma} \\\\text{vayf}-\\\\text{ma} \
\\\\text{uay},\\\\text{fd}=\\\\text{mb} \\\\text{ubx}-\\\\text{mb} \
\\\\text{vbxi},\\\\text{fr}=\\\\text{mb} \\\\text{vbxf}-\\\\text{mb} \
\\\\text{ubx},\\\\text{nd}=\\\\text{mb} \\\\text{uby}-\\\\text{mb} \
\\\\text{vbyi},\\\\text{nr}=\\\\text{mb} \\\\text{vbyf}-\\\\text{mb} \
\\\\text{uby}\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560661766*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"a", " ", "=", " ", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"edax", ",", "erax", ",", "eday", ",", "eray"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"fd", ",", "fr", ",", "nd", ",", "nr"}], "}"}]}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ubx", "->", "uax"}], ",", 
       RowBox[{"uby", "->", "uay"}]}], "}"}]}]}], "\n", "\n", 
   RowBox[{"b", " ", "=", " ", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"edbx", ",", "erbx", ",", "edby", ",", "erby"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"fd", ",", "fr", ",", "nd", ",", "nr"}], "}"}]}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ubx", "->", "uax"}], ",", 
       RowBox[{"uby", "->", "uay"}]}], "}"}]}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560718705997`*^9, 3.5195560718862*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"fd", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "ma"}], " ", "uax"}], "+", 
      RowBox[{"ma", " ", "vaxi"}]}]}], ",", 
    RowBox[{"fr", "\[Rule]", 
     RowBox[{
      RowBox[{"ma", " ", "uax"}], "-", 
      RowBox[{"ma", " ", "vaxf"}]}]}], ",", 
    RowBox[{"nd", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "ma"}], " ", "uay"}], "+", 
      RowBox[{"ma", " ", "vayi"}]}]}], ",", 
    RowBox[{"nr", "\[Rule]", 
     RowBox[{
      RowBox[{"ma", " ", "uay"}], "-", 
      RowBox[{"ma", " ", "vayf"}]}]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560733993998`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"fd", "\[Rule]", 
     RowBox[{
      RowBox[{"mb", " ", "uax"}], "-", 
      RowBox[{"mb", " ", "vbxi"}]}]}], ",", 
    RowBox[{"fr", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "mb"}], " ", "uax"}], "+", 
      RowBox[{"mb", " ", "vbxf"}]}]}], ",", 
    RowBox[{"nd", "\[Rule]", 
     RowBox[{
      RowBox[{"mb", " ", "uay"}], "-", 
      RowBox[{"mb", " ", "vbyi"}]}]}], ",", 
    RowBox[{"nr", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "mb"}], " ", "uay"}], "+", 
      RowBox[{"mb", " ", "vbyf"}]}]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560733993998`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", "a", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "b", "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560777206*^9, 3.5195560777206*^9}}],

Cell[BoxData["\<\"\\\\{\\\\{\\\\text{fd}\\\\to \\\\text{ma} \\\\text{vaxi}-\\\
\\text{ma} \\\\text{uax},\\\\text{fr}\\\\to \\\\text{ma} \
\\\\text{uax}-\\\\text{ma} \\\\text{vaxf},\\\\text{nd}\\\\to \\\\text{ma} \
\\\\text{vayi}-\\\\text{ma} \\\\text{uay},\\\\text{nr}\\\\to \\\\text{ma} \
\\\\text{uay}-\\\\text{ma} \\\\text{vayf}\\\\}\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556084257*^9}],

Cell[BoxData["\<\"\\\\{\\\\{\\\\text{fd}\\\\to \\\\text{mb} \
\\\\text{uax}-\\\\text{mb} \\\\text{vbxi},\\\\text{fr}\\\\to \\\\text{mb} \
\\\\text{vbxf}-\\\\text{mb} \\\\text{uax},\\\\text{nd}\\\\to \\\\text{mb} \
\\\\text{uay}-\\\\text{mb} \\\\text{vbyi},\\\\text{nr}\\\\to \\\\text{mb} \
\\\\text{vbyf}-\\\\text{mb} \\\\text{uay}\\\\}\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560842882*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"restax", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"fr", "/", "fd"}], ")"}], "//.", "a"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"restbx", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"fr", "/", "fd"}], ")"}], "//.", "b"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"restay", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nr", "/", "nd"}], ")"}], "//.", "a"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"restby", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nr", "/", "nd"}], ")"}], "//.", "b"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560890306*^9, 3.5195560890306*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uax"}], "+", "vaxf"}], 
  RowBox[{"uax", "-", "vaxi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556090185*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uax"}], "+", "vbxf"}], 
  RowBox[{"uax", "-", "vbxi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556090185*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uay"}], "+", "vayf"}], 
  RowBox[{"uay", "-", "vayi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560902005997`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uay"}], "+", "vbyf"}], 
  RowBox[{"uay", "-", "vbyi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560902005997`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", "restax", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "restbx", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "restay", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "restby", "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560939758*^9, 3.5195560939758*^9}}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vaxf}-\\\\text{uax}}{\\\\text{uax}-\\\\\
text{vaxi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953642*^9}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vbxf}-\\\\text{uax}}{\\\\text{uax}-\\\\\
text{vbxi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953798*^9}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vayf}-\\\\text{uay}}{\\\\text{uay}-\\\\\
text{vayi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953798*^9}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vbyf}-\\\\text{uay}}{\\\\text{uay}-\\\\\
text{vbyi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953954*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"eans", " ", "=", " ", 
    RowBox[{"Simplify", "[", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"e", "==", "restax"}], ",", 
         RowBox[{"e", "==", "restbx"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"e", ",", "uax"}], "}"}]}], "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"eyans", " ", "=", " ", 
    RowBox[{"Simplify", "[", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ey", "==", "restay"}], ",", 
         RowBox[{"ey", "==", "restby"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ey", ",", "uay"}], "}"}]}], "]"}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.519556098531*^9, 3.519556098531*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"e", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "vaxf"}], "+", "vbxf"}], 
      RowBox[{"vaxi", "-", "vbxi"}]]}], ",", 
    RowBox[{"uax", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "vaxi"}], " ", "vbxf"}], "+", 
       RowBox[{"vaxf", " ", "vbxi"}]}], 
      RowBox[{"vaxf", "-", "vaxi", "-", "vbxf", "+", "vbxi"}]]}]}], "}"}], 
  "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195561005278*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ey", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "vayf"}], "+", "vbyf"}], 
      RowBox[{"vayi", "-", "vbyi"}]]}], ",", 
    RowBox[{"uay", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "vayi"}], " ", "vbyf"}], "+", 
       RowBox[{"vayf", " ", "vbyi"}]}], 
      RowBox[{"vayf", "-", "vayi", "-", "vbyf", "+", "vbyi"}]]}]}], "}"}], 
  "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556100559*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", "eans", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "eyans", "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195561033982*^9, 3.5195561033982*^9}}],

Cell[BoxData["\<\"\\\\left\\\\{\\\\left\\\\{e\\\\to \
\\\\frac{\\\\text{vbxf}-\\\\text{vaxf}}{\\\\text{vaxi}-\\\\text{vbxi}},\\\\\
text{uax}\\\\to \\\\frac{\\\\text{vaxf} \\\\text{vbxi}-\\\\text{vaxi} \
\\\\text{vbxf}}{\\\\text{vaxf}-\\\\text{vaxi}-\\\\text{vbxf}+\\\\text{vbxi}}\\\
\\right\\\\}\\\\right\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195561049114*^9}],

Cell[BoxData["\<\"\\\\left\\\\{\\\\left\\\\{\\\\text{ey}\\\\to \
\\\\frac{\\\\text{vbyf}-\\\\text{vayf}}{\\\\text{vayi}-\\\\text{vbyi}},\\\\\
text{uay}\\\\to \\\\frac{\\\\text{vayf} \\\\text{vbyi}-\\\\text{vayi} \
\\\\text{vbyf}}{\\\\text{vayf}-\\\\text{vayi}-\\\\text{vbyf}+\\\\text{vbyi}}\\\
\\right\\\\}\\\\right\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556104927*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"<<", "tex.h"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195561164709997`*^9, 3.5195561164709997`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Get", "::", "noopen"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot open \[NoBreak]\\!\\(\\\"tex.h\\\"\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/noopen\\\", \
ButtonNote -> \\\"Get::noopen\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5195561184522*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.5195561184522*^9}]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 164, 7, 191, "Title",
 Evaluatable->False],
Cell[724, 29, 1973, 57, 512, "Input"],
Cell[CellGroupData[{
Cell[2722, 90, 329, 9, 72, "Input"],
Cell[3054, 101, 691, 11, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[3782, 117, 991, 28, 112, "Input"],
Cell[4776, 147, 726, 24, 30, "Output",
 Evaluatable->False],
Cell[5505, 173, 726, 24, 30, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[6256, 201, 231, 6, 112, "Input"],
Cell[6490, 209, 440, 7, 30, "Output",
 Evaluatable->False],
Cell[6933, 218, 441, 7, 50, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7423, 231, 1083, 32, 192, "Input"],
Cell[8509, 265, 205, 7, 47, "Output",
 Evaluatable->False],
Cell[8717, 274, 205, 7, 47, "Output",
 Evaluatable->False],
Cell[8925, 283, 210, 7, 49, "Output",
 Evaluatable->False],
Cell[9138, 292, 210, 7, 49, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[9373, 303, 351, 8, 192, "Input"],
Cell[9727, 313, 188, 4, 30, "Output",
 Evaluatable->False],
Cell[9918, 319, 188, 4, 30, "Output",
 Evaluatable->False],
Cell[10109, 325, 188, 4, 30, "Output",
 Evaluatable->False],
Cell[10300, 331, 188, 4, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10537, 341, 819, 25, 112, "Input"],
Cell[11359, 368, 562, 19, 47, "Output",
 Evaluatable->False],
Cell[11924, 389, 562, 19, 49, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[12511, 412, 238, 6, 112, "Input"],
Cell[12752, 420, 409, 7, 30, "Output",
 Evaluatable->False],
Cell[13164, 429, 419, 7, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[13620, 441, 180, 5, 72, "Input"],
Cell[13803, 448, 431, 9, 21, "Message"],
Cell[14237, 459, 74, 1, 30, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

