(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     28355,       1044]
NotebookOptionsPosition[     24087,        887]
NotebookOutlinePosition[     24643,        909]
CellTagsIndexPosition[     24600,        906]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

This file derives the coefficient of restitution equations.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"edax", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "fd"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "uax"}], " ", "-", " ", 
       RowBox[{"ma", " ", "vaxi"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"eday", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "nd"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "uay"}], " ", "-", " ", 
       RowBox[{"ma", " ", "vayi"}]}]}]}], ";"}], "\n", "\n", "\n", "\n", 
   RowBox[{
    RowBox[{"edbx", " ", "=", " ", 
     RowBox[{"fd", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "ubx"}], " ", "-", " ", 
       RowBox[{"mb", " ", "vbxi"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"edby", " ", "=", " ", 
     RowBox[{"nd", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "uby"}], " ", "-", " ", 
       RowBox[{"mb", " ", "vbyi"}]}]}]}], ";"}], "\n", "\n", "\n", "\n", 
   RowBox[{
    RowBox[{"erax", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "fr"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "vaxf"}], " ", "-", " ", 
       RowBox[{"ma", " ", "uax"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"eray", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", "nr"}], " ", "==", " ", 
      RowBox[{
       RowBox[{"ma", " ", "vayf"}], " ", "-", " ", 
       RowBox[{"ma", " ", "uay"}]}]}]}], ";"}], "\n", "\n", "\n", "\n", 
   RowBox[{
    RowBox[{"erbx", " ", "=", " ", 
     RowBox[{"fr", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "vbxf"}], " ", "-", " ", 
       RowBox[{"mb", " ", "ubx"}]}]}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{"erby", " ", "=", " ", 
     RowBox[{"nr", " ", "==", " ", 
      RowBox[{
       RowBox[{"mb", " ", "vbyf"}], " ", "-", " ", 
       RowBox[{"mb", " ", "uby"}]}]}]}], ";"}], "\n", "\n", "\n"}]}]], "Input",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560609974003`*^9, 3.5195560609974003`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", 
    RowBox[{"{", 
     RowBox[{
     "edax", ",", "erax", ",", "eday", ",", "eray", ",", "edbx", ",", "erbx", 
      ",", "edby", ",", "erby"}], "}"}], "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560629318*^9, 3.5195560629318*^9}}],

Cell[BoxData["\<\"\\\\{-\\\\text{fd}=\\\\text{ma} \\\\text{uax}-\\\\text{ma} \
\\\\text{vaxi},-\\\\text{fr}=\\\\text{ma} \\\\text{vaxf}-\\\\text{ma} \
\\\\text{uax},-\\\\text{nd}=\\\\text{ma} \\\\text{uay}-\\\\text{ma} \
\\\\text{vayi},-\\\\text{nr}=\\\\text{ma} \\\\text{vayf}-\\\\text{ma} \
\\\\text{uay},\\\\text{fd}=\\\\text{mb} \\\\text{ubx}-\\\\text{mb} \
\\\\text{vbxi},\\\\text{fr}=\\\\text{mb} \\\\text{vbxf}-\\\\text{mb} \
\\\\text{ubx},\\\\text{nd}=\\\\text{mb} \\\\text{uby}-\\\\text{mb} \
\\\\text{vbyi},\\\\text{nr}=\\\\text{mb} \\\\text{vbyf}-\\\\text{mb} \
\\\\text{uby}\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560661766*^9, 3.5195562424666*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"a", " ", "=", " ", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"edax", ",", "erax", ",", "eday", ",", "eray"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"fd", ",", "fr", ",", "nd", ",", "nr"}], "}"}]}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ubx", "->", "uax"}], ",", 
       RowBox[{"uby", "->", "uay"}]}], "}"}]}]}], "\n", "\n", 
   RowBox[{"b", " ", "=", " ", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"edbx", ",", "erbx", ",", "edby", ",", "erby"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"fd", ",", "fr", ",", "nd", ",", "nr"}], "}"}]}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ubx", "->", "uax"}], ",", 
       RowBox[{"uby", "->", "uay"}]}], "}"}]}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560718705997`*^9, 3.5195560718862*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"fd", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "ma"}], " ", "uax"}], "+", 
      RowBox[{"ma", " ", "vaxi"}]}]}], ",", 
    RowBox[{"fr", "\[Rule]", 
     RowBox[{
      RowBox[{"ma", " ", "uax"}], "-", 
      RowBox[{"ma", " ", "vaxf"}]}]}], ",", 
    RowBox[{"nd", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "ma"}], " ", "uay"}], "+", 
      RowBox[{"ma", " ", "vayi"}]}]}], ",", 
    RowBox[{"nr", "\[Rule]", 
     RowBox[{
      RowBox[{"ma", " ", "uay"}], "-", 
      RowBox[{"ma", " ", "vayf"}]}]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560733993998`*^9, 3.5195562424821997`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"fd", "\[Rule]", 
     RowBox[{
      RowBox[{"mb", " ", "uax"}], "-", 
      RowBox[{"mb", " ", "vbxi"}]}]}], ",", 
    RowBox[{"fr", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "mb"}], " ", "uax"}], "+", 
      RowBox[{"mb", " ", "vbxf"}]}]}], ",", 
    RowBox[{"nd", "\[Rule]", 
     RowBox[{
      RowBox[{"mb", " ", "uay"}], "-", 
      RowBox[{"mb", " ", "vbyi"}]}]}], ",", 
    RowBox[{"nr", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "mb"}], " ", "uay"}], "+", 
      RowBox[{"mb", " ", "vbyf"}]}]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560733993998`*^9, 3.5195562424821997`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", "a", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "b", "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560777206*^9, 3.5195560777206*^9}}],

Cell[BoxData["\<\"\\\\{\\\\{\\\\text{fd}\\\\to \\\\text{ma} \\\\text{vaxi}-\\\
\\text{ma} \\\\text{uax},\\\\text{fr}\\\\to \\\\text{ma} \
\\\\text{uax}-\\\\text{ma} \\\\text{vaxf},\\\\text{nd}\\\\to \\\\text{ma} \
\\\\text{vayi}-\\\\text{ma} \\\\text{uay},\\\\text{nr}\\\\to \\\\text{ma} \
\\\\text{uay}-\\\\text{ma} \\\\text{vayf}\\\\}\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556084257*^9, 3.5195562425134*^9}],

Cell[BoxData["\<\"\\\\{\\\\{\\\\text{fd}\\\\to \\\\text{mb} \
\\\\text{uax}-\\\\text{mb} \\\\text{vbxi},\\\\text{fr}\\\\to \\\\text{mb} \
\\\\text{vbxf}-\\\\text{mb} \\\\text{uax},\\\\text{nd}\\\\to \\\\text{mb} \
\\\\text{uay}-\\\\text{mb} \\\\text{vbyi},\\\\text{nr}\\\\to \\\\text{mb} \
\\\\text{vbyf}-\\\\text{mb} \\\\text{uay}\\\\}\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556084257*^9, 3.5195562425446*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"restax", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"fr", "/", "fd"}], ")"}], "//.", "a"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"restbx", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"fr", "/", "fd"}], ")"}], "//.", "b"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"restay", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nr", "/", "nd"}], ")"}], "//.", "a"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"restby", " ", "=", " ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nr", "/", "nd"}], ")"}], "//.", "b"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560890306*^9, 3.5195560890306*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uax"}], "+", "vaxf"}], 
  RowBox[{"uax", "-", "vaxi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556090185*^9, 3.5195562425601997`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uax"}], "+", "vbxf"}], 
  RowBox[{"uax", "-", "vbxi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556090185*^9, 3.5195562425601997`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uay"}], "+", "vayf"}], 
  RowBox[{"uay", "-", "vayi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556090185*^9, 3.5195562425601997`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "uay"}], "+", "vbyf"}], 
  RowBox[{"uay", "-", "vbyi"}]]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556090185*^9, 3.5195562425601997`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", "restax", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "restbx", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "restay", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "restby", "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195560939758*^9, 3.5195560939758*^9}}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vaxf}-\\\\text{uax}}{\\\\text{uax}-\\\\\
text{vaxi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953642*^9, 3.5195562425914*^9}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vbxf}-\\\\text{uax}}{\\\\text{uax}-\\\\\
text{vbxi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953642*^9, 3.5195562425914*^9}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vayf}-\\\\text{uay}}{\\\\text{uay}-\\\\\
text{vayi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953642*^9, 3.5195562426070004`*^9}],

Cell[BoxData["\<\"\\\\frac{\\\\text{vbyf}-\\\\text{uay}}{\\\\text{uay}-\\\\\
text{vbyi}}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195560953642*^9, 3.5195562426070004`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"eans", " ", "=", " ", 
    RowBox[{"Simplify", "[", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"e", "==", "restax"}], ",", 
         RowBox[{"e", "==", "restbx"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"e", ",", "uax"}], "}"}]}], "]"}], "]"}]}], "\n", "\n", 
   RowBox[{"eyans", " ", "=", " ", 
    RowBox[{"Simplify", "[", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ey", "==", "restay"}], ",", 
         RowBox[{"ey", "==", "restby"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ey", ",", "uay"}], "}"}]}], "]"}], "]"}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.519556098531*^9, 3.519556098531*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"e", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "vaxf"}], "+", "vbxf"}], 
      RowBox[{"vaxi", "-", "vbxi"}]]}], ",", 
    RowBox[{"uax", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "vaxi"}], " ", "vbxf"}], "+", 
       RowBox[{"vaxf", " ", "vbxi"}]}], 
      RowBox[{"vaxf", "-", "vaxi", "-", "vbxf", "+", "vbxi"}]]}]}], "}"}], 
  "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195561005278*^9, 3.5195562426382*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ey", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "vayf"}], "+", "vbyf"}], 
      RowBox[{"vayi", "-", "vbyi"}]]}], ",", 
    RowBox[{"uay", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "vayi"}], " ", "vbyf"}], "+", 
       RowBox[{"vayf", " ", "vbyi"}]}], 
      RowBox[{"vayf", "-", "vayi", "-", "vbyf", "+", "vbyi"}]]}]}], "}"}], 
  "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195561005278*^9, 3.5195562426538*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mytex", "[", "eans", "]"}], "\n", "\n", 
   RowBox[{"mytex", "[", "eyans", "]"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195561033982*^9, 3.5195561033982*^9}}],

Cell[BoxData["\<\"\\\\left\\\\{\\\\left\\\\{e\\\\to \
\\\\frac{\\\\text{vbxf}-\\\\text{vaxf}}{\\\\text{vaxi}-\\\\text{vbxi}},\\\\\
text{uax}\\\\to \\\\frac{\\\\text{vaxf} \\\\text{vbxi}-\\\\text{vaxi} \
\\\\text{vbxf}}{\\\\text{vaxf}-\\\\text{vaxi}-\\\\text{vbxf}+\\\\text{vbxi}}\\\
\\right\\\\}\\\\right\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195561049114*^9, 3.5195562426694*^9}],

Cell[BoxData["\<\"\\\\left\\\\{\\\\left\\\\{\\\\text{ey}\\\\to \
\\\\frac{\\\\text{vbyf}-\\\\text{vayf}}{\\\\text{vayi}-\\\\text{vbyi}},\\\\\
text{uay}\\\\to \\\\frac{\\\\text{vayf} \\\\text{vbyi}-\\\\text{vayi} \
\\\\text{vbyf}}{\\\\text{vayf}-\\\\text{vayi}-\\\\text{vbyf}+\\\\text{vbyi}}\\\
\\right\\\\}\\\\right\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195561049114*^9, 3.519556242685*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"<<", "tex.h"}], "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5195561164709997`*^9, 3.5195561164709997`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Get", "::", "noopen"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot open \[NoBreak]\\!\\(\\\"tex.h\\\"\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/noopen\\\", \
ButtonNote -> \\\"Get::noopen\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5195561184522*^9, 3.5195562427005997`*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.5195561184522*^9, 3.5195562427005997`*^9}]
}, Open  ]]
}, Open  ]],

Cell["\<\

This file derives the energy loss from an impact.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell[CellGroupData[{

Cell["\<\

<<tex.h
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Get", "::", "noopen"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Cannot open \[NoBreak]\\!\\(\\\"tex.h\\\"\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/noopen\\\", \
ButtonNote -> \\\"Get::noopen\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5195562427318*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.5195562427318*^9}]
}, Open  ]],

Cell["\<\

keai = 1/2 ma (vaxi^2 + vayi^2);

kebi = 1/2 mb (vbxi^2 + vbyi^2);

keaf = 1/2 ma (vaxf^2 + vayf^2);

kebf = 1/2 mb (vbxf^2 + vbyf^2);

tei = keai + kebi;

tef = keaf + kebf;

echange = tef - tei;
\
\>", "Input",
 PageWidth->Infinity],

Cell["\<\

lmx = ma vaxi + mb vbxi == ma vaxf + mb vbxf;

lmy = ma vayi + mb vbyi == ma vayf + mb vbyf;

restx = rest == - (vaxf - vbxf)/(vaxi - vbxi);

resty = rest == - (vayf - vbyf)/(vayi - vbyi);
\
\>", "Input",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

ansfspecial = Simplify[Solve[

\t{lmx,restx},{vaxf,vbxf}]]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vaxf", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"ma", " ", "vaxi"}], "+", 
       RowBox[{"mb", " ", 
        RowBox[{"(", 
         RowBox[{"vbxi", "+", 
          RowBox[{"rest", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "vaxi"}], "+", "vbxi"}], ")"}]}]}], ")"}]}]}], 
      RowBox[{"ma", "+", "mb"}]]}], ",", 
    RowBox[{"vbxf", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"mb", " ", "vbxi"}], "+", 
       RowBox[{"ma", " ", 
        RowBox[{"(", 
         RowBox[{"vaxi", "+", 
          RowBox[{"rest", " ", "vaxi"}], "-", 
          RowBox[{"rest", " ", "vbxi"}]}], ")"}]}]}], 
      RowBox[{"ma", "+", "mb"}]]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556242763*^9}]
}, Open  ]],

Cell["\<\

yspecial = {vayf->vayi,vbyf->vbyi};
\
\>", "Input",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

teansspecial = Simplify[(echange/.ansfspecial)/.yspecial]
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 RowBox[{"{", 
  FractionBox[
   RowBox[{"ma", " ", "mb", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["rest", "2"]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"vaxi", "-", "vbxi"}], ")"}], "2"]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"ma", "+", "mb"}], ")"}]}]], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556242841*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

mytex[teansspecial]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData["\<\"\\\\left\\\\{\\\\frac{\\\\text{ma} \\\\text{mb} \\\\left(\\\
\\text{rest}^2-1\\\\right) (\\\\text{vaxi}-\\\\text{vbxi})^2}{2 \
(\\\\text{ma}+\\\\text{mb})}\\\\right\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562431842003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

ansf = 

\tSimplify[Solve[{lmx,restx,lmy,resty},

\t\t{vaxf,vbxf,vayf,vbyf}]]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"vaxf", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"ma", " ", "vaxi"}], "+", 
       RowBox[{"mb", " ", 
        RowBox[{"(", 
         RowBox[{"vbxi", "+", 
          RowBox[{"rest", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "vaxi"}], "+", "vbxi"}], ")"}]}]}], ")"}]}]}], 
      RowBox[{"ma", "+", "mb"}]]}], ",", 
    RowBox[{"vbxf", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"mb", " ", "vbxi"}], "+", 
       RowBox[{"ma", " ", 
        RowBox[{"(", 
         RowBox[{"vaxi", "+", 
          RowBox[{"rest", " ", "vaxi"}], "-", 
          RowBox[{"rest", " ", "vbxi"}]}], ")"}]}]}], 
      RowBox[{"ma", "+", "mb"}]]}], ",", 
    RowBox[{"vayf", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"ma", " ", "vayi"}], "+", 
       RowBox[{"mb", " ", 
        RowBox[{"(", 
         RowBox[{"vbyi", "+", 
          RowBox[{"rest", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "vayi"}], "+", "vbyi"}], ")"}]}]}], ")"}]}]}], 
      RowBox[{"ma", "+", "mb"}]]}], ",", 
    RowBox[{"vbyf", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"mb", " ", "vbyi"}], "+", 
       RowBox[{"ma", " ", 
        RowBox[{"(", 
         RowBox[{"vayi", "+", 
          RowBox[{"rest", " ", "vayi"}], "-", 
          RowBox[{"rest", " ", "vbyi"}]}], ")"}]}]}], 
      RowBox[{"ma", "+", "mb"}]]}]}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562432466*^9}],

Cell[CellGroupData[{

Cell["\<\

teans = Simplify[echange/.ansf]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  FractionBox[
   RowBox[{"ma", " ", "mb", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["rest", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["vaxi", "2"], "+", 
      SuperscriptBox["vayi", "2"], "-", 
      RowBox[{"2", " ", "vaxi", " ", "vbxi"}], "+", 
      SuperscriptBox["vbxi", "2"], "-", 
      RowBox[{"2", " ", "vayi", " ", "vbyi"}], "+", 
      SuperscriptBox["vbyi", "2"]}], ")"}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"ma", "+", "mb"}], ")"}]}]], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562432778*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

mytex[teans]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData["\<\"\\\\left\\\\{\\\\frac{\\\\text{ma} \\\\text{mb} \\\\left(\\\
\\text{rest}^2-1\\\\right) \\\\left(\\\\text{vaxi}^2-2 \\\\text{vaxi} \
\\\\text{vbxi}+\\\\text{vayi}^2-2 \\\\text{vayi} \
\\\\text{vbyi}+\\\\text{vbxi}^2+\\\\text{vbyi}^2\\\\right)}{2 \
(\\\\text{ma}+\\\\text{mb})}\\\\right\\\\}\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562433246*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

fact = teans[[1,6]]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["vaxi", "2"], "+", 
  SuperscriptBox["vayi", "2"], "-", 
  RowBox[{"2", " ", "vaxi", " ", "vbxi"}], "+", 
  SuperscriptBox["vbxi", "2"], "-", 
  RowBox[{"2", " ", "vayi", " ", "vbyi"}], "+", 
  SuperscriptBox["vbyi", "2"]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562433402*^9}],

Cell[CellGroupData[{

Cell["\<\

Simplify[fact]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["vaxi", "2"], "+", 
  SuperscriptBox["vayi", "2"], "-", 
  RowBox[{"2", " ", "vaxi", " ", "vbxi"}], "+", 
  SuperscriptBox["vbxi", "2"], "-", 
  RowBox[{"2", " ", "vayi", " ", "vbyi"}], "+", 
  SuperscriptBox["vbyi", "2"]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562433714*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

factalso = (vaxi - vbxi)^2 + (vayi - vbyi)^2
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"vaxi", "-", "vbxi"}], ")"}], "2"], "+", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"vayi", "-", "vbyi"}], ")"}], "2"]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556243387*^9}],

Cell[CellGroupData[{

Cell["\<\

mytex[factalso]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData["\<\"(\\\\text{vaxi}-\\\\text{vbxi})^2+(\\\\text{vayi}-\\\\text{\
vbyi})^2\"\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562434182*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Expand [factalso]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["vaxi", "2"], "+", 
  SuperscriptBox["vayi", "2"], "-", 
  RowBox[{"2", " ", "vaxi", " ", "vbxi"}], "+", 
  SuperscriptBox["vbxi", "2"], "-", 
  RowBox[{"2", " ", "vayi", " ", "vbyi"}], "+", 
  SuperscriptBox["vbyi", "2"]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.519556243465*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Simplify[fact - factalso]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData["0"], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562434806004`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Factor[fact]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["vaxi", "2"], "+", 
  SuperscriptBox["vayi", "2"], "-", 
  RowBox[{"2", " ", "vaxi", " ", "vbxi"}], "+", 
  SuperscriptBox["vbxi", "2"], "-", 
  RowBox[{"2", " ", "vayi", " ", "vbyi"}], "+", 
  SuperscriptBox["vbyi", "2"]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5195562435118*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 164, 7, 191, "Title",
 Evaluatable->False],
Cell[724, 29, 1973, 57, 512, "Input"],
Cell[CellGroupData[{
Cell[2722, 90, 329, 9, 72, "Input"],
Cell[3054, 101, 711, 11, 69, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[3802, 117, 991, 28, 112, "Input"],
Cell[4796, 147, 750, 24, 30, "Output",
 Evaluatable->False],
Cell[5549, 173, 750, 24, 30, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[6324, 201, 231, 6, 112, "Input"],
Cell[6558, 209, 460, 7, 30, "Output",
 Evaluatable->False],
Cell[7021, 218, 460, 7, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7530, 231, 1083, 32, 192, "Input"],
Cell[8616, 265, 229, 7, 47, "Output",
 Evaluatable->False],
Cell[8848, 274, 229, 7, 47, "Output",
 Evaluatable->False],
Cell[9080, 283, 229, 7, 49, "Output",
 Evaluatable->False],
Cell[9312, 292, 229, 7, 49, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[9566, 303, 351, 8, 192, "Input"],
Cell[9920, 313, 208, 4, 30, "Output",
 Evaluatable->False],
Cell[10131, 319, 208, 4, 30, "Output",
 Evaluatable->False],
Cell[10342, 325, 212, 4, 30, "Output",
 Evaluatable->False],
Cell[10557, 331, 212, 4, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10818, 341, 819, 25, 112, "Input"],
Cell[11640, 368, 582, 19, 47, "Output",
 Evaluatable->False],
Cell[12225, 389, 583, 19, 49, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[12833, 412, 238, 6, 112, "Input"],
Cell[13074, 420, 429, 7, 30, "Output",
 Evaluatable->False],
Cell[13506, 429, 439, 7, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[13982, 441, 180, 5, 72, "Input"],
Cell[14165, 448, 455, 9, 21, "Message"],
Cell[14623, 459, 98, 1, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[14748, 464, 154, 7, 191, "Title",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[14927, 475, 56, 5, 65, "Input"],
Cell[14986, 482, 431, 9, 21, "Message"],
Cell[15420, 493, 74, 1, 30, "Output"]
}, Open  ]],
Cell[15509, 497, 245, 17, 269, "Input"],
Cell[15757, 516, 237, 11, 167, "Input"],
Cell[CellGroupData[{
Cell[16019, 531, 107, 7, 99, "Input"],
Cell[16129, 540, 871, 28, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[17015, 571, 84, 5, 65, "Input"],
Cell[CellGroupData[{
Cell[17124, 580, 223, 10, 65, "Input"],
Cell[17350, 592, 465, 16, 53, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[17852, 613, 68, 5, 65, "Input"],
Cell[17923, 620, 291, 5, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[18251, 630, 126, 9, 133, "Input"],
Cell[18380, 641, 1584, 50, 47, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[19989, 695, 80, 5, 65, "Input"],
Cell[20072, 702, 682, 21, 53, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[20803, 729, 61, 5, 65, "Input"],
Cell[20867, 736, 408, 7, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[21312, 748, 68, 5, 65, "Input"],
Cell[21383, 755, 359, 10, 30, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[21767, 769, 63, 5, 65, "Input"],
Cell[21833, 776, 359, 10, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[22229, 791, 93, 5, 65, "Input"],
Cell[22325, 798, 290, 10, 30, "Output",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[22640, 812, 64, 5, 65, "Input"],
Cell[22707, 819, 187, 4, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[22931, 828, 66, 5, 65, "Input"],
Cell[23000, 835, 358, 10, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23419, 852, 74, 5, 65, "Input"],
Cell[23496, 859, 115, 3, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[23648, 867, 61, 5, 65, "Input"],
Cell[23712, 874, 359, 10, 30, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

