(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     10197,        350]
NotebookOptionsPosition[      8648,        290]
NotebookOutlinePosition[      9204,        312]
CellTagsIndexPosition[      9161,        309]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Quit", "Input",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\
n = (mb + mc ) g;
eqnc = F[t] - f[t] == mc yd'[t];
eqnb = -F[t] == mb (yd'[t] - xd'[t]);\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell["F[t_] = fnot Sin[omega t];", "Input",
 PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
sticksol = ({f[t],xd[t]}/.DSolve[{eqnc,eqnb,xd[tnot]==xdnot}/.yd'[t]->0,
    {f[t],xd[t]},t])[[1]]\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"fnot", " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"omega", " ", "t"}], "]"}]}], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"mb", " ", "omega", " ", "xdnot"}], "-", 
     RowBox[{"fnot", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "t"}], "]"}]}], "+", 
     RowBox[{"fnot", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "tnot"}], "]"}]}]}], 
    RowBox[{"mb", " ", "omega"}]]}], "}"}]], "Output",
 CellChangeTimes->{3.5181784601656*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
slippossol = \
({yd[t],xd[t]}/.DSolve[{eqnc,eqnb,xd[tnot]==xdnot,yd[tnot]==ydnot}/.f[t]->mu n,
    {yd[t],xd[t]},t])[[1]]
slipnegsol = \
({yd[t],xd[t]}/.DSolve[{eqnc,eqnb,xd[tnot]==xdnot,yd[tnot]==ydnot}/.f[t]->-mu \
n,
    {yd[t],xd[t]},t])[[1]]\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "g"}], " ", "mb", " ", "mu", " ", "omega", " ", "t"}], "-", 
     RowBox[{"g", " ", "mc", " ", "mu", " ", "omega", " ", "t"}], "+", 
     RowBox[{"g", " ", "mb", " ", "mu", " ", "omega", " ", "tnot"}], "+", 
     RowBox[{"g", " ", "mc", " ", "mu", " ", "omega", " ", "tnot"}], "+", 
     RowBox[{"mc", " ", "omega", " ", "ydnot"}], "-", 
     RowBox[{"fnot", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "t"}], "]"}]}], "+", 
     RowBox[{"fnot", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "tnot"}], "]"}]}]}], 
    RowBox[{"mc", " ", "omega"}]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "g"}], " ", 
      SuperscriptBox["mb", "2"], " ", "mu", " ", "omega", " ", "t"}], "-", 
     RowBox[{"g", " ", "mb", " ", "mc", " ", "mu", " ", "omega", " ", "t"}], 
     "+", 
     RowBox[{"g", " ", 
      SuperscriptBox["mb", "2"], " ", "mu", " ", "omega", " ", "tnot"}], "+", 
     
     RowBox[{
     "g", " ", "mb", " ", "mc", " ", "mu", " ", "omega", " ", "tnot"}], "+", 
     RowBox[{"mb", " ", "mc", " ", "omega", " ", "xdnot"}], "-", 
     RowBox[{"fnot", " ", "mb", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "t"}], "]"}]}], "-", 
     RowBox[{"fnot", " ", "mc", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "t"}], "]"}]}], "+", 
     RowBox[{"fnot", " ", "mb", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "tnot"}], "]"}]}], "+", 
     RowBox[{"fnot", " ", "mc", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "tnot"}], "]"}]}]}], 
    RowBox[{"mb", " ", "mc", " ", "omega"}]]}], "}"}]], "Output",
 CellChangeTimes->{3.5181784625486*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"g", " ", "mb", " ", "mu", " ", "omega", " ", "t"}], "+", 
     RowBox[{"g", " ", "mc", " ", "mu", " ", "omega", " ", "t"}], "-", 
     RowBox[{"g", " ", "mb", " ", "mu", " ", "omega", " ", "tnot"}], "-", 
     RowBox[{"g", " ", "mc", " ", "mu", " ", "omega", " ", "tnot"}], "+", 
     RowBox[{"mc", " ", "omega", " ", "ydnot"}], "-", 
     RowBox[{"fnot", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "t"}], "]"}]}], "+", 
     RowBox[{"fnot", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "tnot"}], "]"}]}]}], 
    RowBox[{"mc", " ", "omega"}]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"g", " ", 
      SuperscriptBox["mb", "2"], " ", "mu", " ", "omega", " ", "t"}], "+", 
     RowBox[{"g", " ", "mb", " ", "mc", " ", "mu", " ", "omega", " ", "t"}], 
     "-", 
     RowBox[{"g", " ", 
      SuperscriptBox["mb", "2"], " ", "mu", " ", "omega", " ", "tnot"}], "-", 
     
     RowBox[{
     "g", " ", "mb", " ", "mc", " ", "mu", " ", "omega", " ", "tnot"}], "+", 
     RowBox[{"mb", " ", "mc", " ", "omega", " ", "xdnot"}], "-", 
     RowBox[{"fnot", " ", "mb", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "t"}], "]"}]}], "-", 
     RowBox[{"fnot", " ", "mc", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "t"}], "]"}]}], "+", 
     RowBox[{"fnot", " ", "mb", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "tnot"}], "]"}]}], "+", 
     RowBox[{"fnot", " ", "mc", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"omega", " ", "tnot"}], "]"}]}]}], 
    RowBox[{"mb", " ", "mc", " ", "omega"}]]}], "}"}]], "Output",
 CellChangeTimes->{3.5181784626186*^9}]
}, Open  ]],

Cell["\<\
itsticks[fo_,om_,xdo_,massb_,to_] := \
sticksol/.{fnot->fo,omega->om,xdnot->xdo,mb->massb,tnot->to}[[1]]\
\>", "Input",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell["itsticks[1,2,3,1,5]", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Sin", "[", 
    RowBox[{"omega", " ", "t"}], "]"}], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"mb", " ", "omega", " ", "xdnot"}], "-", 
     RowBox[{"Cos", "[", 
      RowBox[{"omega", " ", "t"}], "]"}], "+", 
     RowBox[{"Cos", "[", 
      RowBox[{"omega", " ", "tnot"}], "]"}]}], 
    RowBox[{"mb", " ", "omega"}]]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181784692326*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["sticksol/.{fnot->1,omega->2,xdnot->0,mb->1,tnot->10}", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Sin", "[", 
    RowBox[{"2", " ", "t"}], "]"}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Cos", "[", "20", "]"}], "-", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "t"}], "]"}]}], ")"}]}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{{3.5181784777455997`*^9, 3.5181784906456003`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["%[[1]]", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"Sin", "[", 
  RowBox[{"2", " ", "t"}], "]"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{{3.5181784792436*^9, 3.5181784915626*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NSolve[%==1/2,t]", "Input",
 PageWidth->Infinity,
 CellChangeTimes->{3.5181784875856*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NSolve", "::", "ifun"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Inverse functions are being used by \[NoBreak]\\!\\(NSolve\
\\)\[NoBreak], so some solutions may not be found; use Reduce for complete \
solution information. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NSolve\\\", ButtonNote -> \\\"NSolve::ifun\\\"]\\)\
\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5181784925866003`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"t", "\[Rule]", "0.26179938779914946`"}], "}"}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{{3.5181784807125998`*^9, 3.5181784925875998`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["?NSolve", "Input",
 PageWidth->Infinity],

Cell[OutputFormData["\<\
No Input Form Generated
\
\>", "\<\
NSolve[eqns, vars] attempts to solve numerically an equation or set of
   equations for the variables vars.  Any variable in eqns but not
   vars is regarded as a parameter.  NSolve[eqns] treats all variables
   encountered as vars above.  NSolve[eqns, vars, prec] attempts to
   solve numerically the equations for vars using prec digits
   precision.
\
\>"], "Output",
 PageWidth->Infinity,
 Evaluatable->False]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 43, 1, 31, "Input"],
Cell[CellGroupData[{
Cell[625, 25, 252, 10, 65, "Input"],
Cell[880, 37, 65, 1, 31, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[982, 43, 145, 4, 48, "Input"],
Cell[1130, 49, 527, 16, 49, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1694, 70, 410, 14, 82, "Input"],
Cell[2107, 86, 1770, 44, 117, "Output"],
Cell[3880, 132, 1726, 42, 91, "Output"]
}, Open  ]],
Cell[5621, 177, 151, 4, 31, "Input"],
Cell[CellGroupData[{
Cell[5797, 185, 58, 1, 31, "Input"],
Cell[5858, 188, 479, 15, 49, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[6374, 208, 91, 1, 31, "Input"],
Cell[6468, 211, 437, 14, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[6942, 230, 45, 1, 31, "Input"],
Cell[6990, 233, 185, 5, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[7212, 243, 95, 2, 31, "Input"],
Cell[7310, 247, 524, 11, 21, "Message"],
Cell[7837, 260, 235, 6, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[8109, 271, 46, 1, 31, "Input"],
Cell[8158, 274, 474, 13, 85, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

