(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13689,        447]
NotebookOptionsPosition[     13025,        419]
NotebookOutlinePosition[     13581,        441]
CellTagsIndexPosition[     13538,        438]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

Integrating the Power of a Train.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell["\<\

The following shows the integral of a difficult function.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"time", " ", "=", " ", 
    RowBox[{"me", " ", 
     RowBox[{"Integrate", "[", 
      RowBox[{
       RowBox[{"nu", "/", 
        RowBox[{"(", 
         RowBox[{"power", "-", 
          RowBox[{"c", " ", 
           RowBox[{"nu", "^", "3"}]}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"nu", ",", "vo", ",", "v"}], "}"}]}], "]"}]}]}], 
   "\n"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.5181793486476*^9, 3.5181793486496*^9}}],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"me", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        SqrtBox["3"], " ", 
        RowBox[{"ArcTan", "[", 
         FractionBox[
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["c", 
              RowBox[{"1", "/", "3"}]], " ", "v"}], 
            SuperscriptBox["power", 
             RowBox[{"1", "/", "3"}]]]}], 
          SqrtBox["3"]], "]"}]}], "+", 
       RowBox[{"2", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"ArcTan", "[", 
         FractionBox[
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["c", 
              RowBox[{"1", "/", "3"}]], " ", "vo"}], 
            SuperscriptBox["power", 
             RowBox[{"1", "/", "3"}]]]}], 
          SqrtBox["3"]], "]"}]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"Log", "[", 
         RowBox[{
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], "-", 
          RowBox[{
           SuperscriptBox["c", 
            RowBox[{"1", "/", "3"}]], " ", "v"}]}], "]"}]}], "+", 
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["power", 
          RowBox[{"2", "/", "3"}]], "+", 
         RowBox[{
          SuperscriptBox["c", 
           RowBox[{"1", "/", "3"}]], " ", 
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], " ", "v"}], "+", 
         RowBox[{
          SuperscriptBox["c", 
           RowBox[{"2", "/", "3"}]], " ", 
          SuperscriptBox["v", "2"]}]}], "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"Log", "[", 
         RowBox[{
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], "-", 
          RowBox[{
           SuperscriptBox["c", 
            RowBox[{"1", "/", "3"}]], " ", "vo"}]}], "]"}]}], "-", 
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["power", 
          RowBox[{"2", "/", "3"}]], "+", 
         RowBox[{
          SuperscriptBox["c", 
           RowBox[{"1", "/", "3"}]], " ", 
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], " ", "vo"}], "+", 
         RowBox[{
          SuperscriptBox["c", 
           RowBox[{"2", "/", "3"}]], " ", 
          SuperscriptBox["vo", "2"]}]}], "]"}]}], ")"}]}], 
    RowBox[{"6", " ", 
     SuperscriptBox["c", 
      RowBox[{"2", "/", "3"}]], " ", 
     SuperscriptBox["power", 
      RowBox[{"1", "/", "3"}]]}]], ",", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"Im", "[", "vo", "]"}], "2"]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"Re", "[", "v", "]"}], "2"]}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{
           RowBox[{"Im", "[", "v", "]"}], " ", 
           RowBox[{"Im", "[", "vo", "]"}]}]}], ")"}], " ", 
        RowBox[{"Re", "[", "v", "]"}], " ", 
        RowBox[{"Re", "[", "vo", "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"Im", "[", "v", "]"}], "2"]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"Re", "[", "vo", "]"}], "2"]}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Re", "[", "v", "]"}], "-", 
         RowBox[{"Re", "[", "vo", "]"}]}], ")"}], "2"]], "\[LessEqual]", 
     "0"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{
           FractionBox[
            SuperscriptBox["power", 
             RowBox[{"1", "/", "3"}]], 
            SuperscriptBox["c", 
             RowBox[{"1", "/", "3"}]]], "-", "vo"}], 
          RowBox[{"v", "-", "vo"}]], "\[Element]", "Reals"}], "&&", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Re", "[", 
            FractionBox[
             RowBox[{
              FractionBox[
               SuperscriptBox["power", 
                RowBox[{"1", "/", "3"}]], 
               SuperscriptBox["c", 
                RowBox[{"1", "/", "3"}]]], "-", "vo"}], 
             RowBox[{"v", "-", "vo"}]], "]"}], "\[GreaterEqual]", "1"}], "||", 
          RowBox[{
           RowBox[{"Re", "[", 
            FractionBox[
             RowBox[{
              FractionBox[
               SuperscriptBox["power", 
                RowBox[{"1", "/", "3"}]], 
               SuperscriptBox["c", 
                RowBox[{"1", "/", "3"}]]], "-", "vo"}], 
             RowBox[{"v", "-", "vo"}]], "]"}], "\[LessEqual]", "0"}]}], 
         ")"}]}], ")"}], "||", 
      RowBox[{
       FractionBox[
        RowBox[{
         FractionBox[
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], 
          SuperscriptBox["c", 
           RowBox[{"1", "/", "3"}]]], "-", "vo"}], 
        RowBox[{"v", "-", "vo"}]], "\[NotElement]", "Reals"}]}], ")"}], "&&", 
    
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"Im", "[", 
         FractionBox[
          RowBox[{
           FractionBox[
            SuperscriptBox["power", 
             RowBox[{"1", "/", "3"}]], 
            SuperscriptBox["c", 
             RowBox[{"1", "/", "3"}]]], "+", 
           RowBox[{"2", " ", "vo"}]}], 
          RowBox[{
           RowBox[{"2", " ", "v"}], "-", 
           RowBox[{"2", " ", "vo"}]}]], "]"}]}], "\[NotEqual]", 
       RowBox[{
        SqrtBox["3"], " ", 
        RowBox[{"Re", "[", 
         FractionBox[
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], 
          RowBox[{
           SuperscriptBox["c", 
            RowBox[{"1", "/", "3"}]], " ", 
           RowBox[{"(", 
            RowBox[{"v", "-", "vo"}], ")"}]}]], "]"}]}]}], "||", 
      RowBox[{
       RowBox[{
        RowBox[{
         SqrtBox["3"], " ", 
         RowBox[{"Im", "[", 
          FractionBox[
           SuperscriptBox["power", 
            RowBox[{"1", "/", "3"}]], 
           RowBox[{
            SuperscriptBox["c", 
             RowBox[{"1", "/", "3"}]], " ", 
            RowBox[{"(", 
             RowBox[{"v", "-", "vo"}], ")"}]}]], "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Re", "[", 
          FractionBox[
           RowBox[{
            FractionBox[
             SuperscriptBox["power", 
              RowBox[{"1", "/", "3"}]], 
             SuperscriptBox["c", 
              RowBox[{"1", "/", "3"}]]], "+", 
            RowBox[{"2", " ", "vo"}]}], 
           RowBox[{
            RowBox[{"2", " ", "v"}], "-", 
            RowBox[{"2", " ", "vo"}]}]], "]"}]}]}], "\[GreaterEqual]", "0"}], 
      "||", 
      RowBox[{
       RowBox[{"2", "+", 
        RowBox[{
         SqrtBox["3"], " ", 
         RowBox[{"Im", "[", 
          FractionBox[
           SuperscriptBox["power", 
            RowBox[{"1", "/", "3"}]], 
           RowBox[{
            SuperscriptBox["c", 
             RowBox[{"1", "/", "3"}]], " ", 
            RowBox[{"(", 
             RowBox[{"v", "-", "vo"}], ")"}]}]], "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Re", "[", 
          FractionBox[
           RowBox[{
            FractionBox[
             SuperscriptBox["power", 
              RowBox[{"1", "/", "3"}]], 
             SuperscriptBox["c", 
              RowBox[{"1", "/", "3"}]]], "+", 
            RowBox[{"2", " ", "vo"}]}], 
           RowBox[{
            RowBox[{"2", " ", "v"}], "-", 
            RowBox[{"2", " ", "vo"}]}]], "]"}]}]}], "\[LessEqual]", "0"}]}], 
     ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Im", "[", 
          FractionBox[
           RowBox[{
            FractionBox[
             SuperscriptBox["power", 
              RowBox[{"1", "/", "3"}]], 
             SuperscriptBox["c", 
              RowBox[{"1", "/", "3"}]]], "+", 
            RowBox[{"2", " ", "vo"}]}], 
           RowBox[{
            RowBox[{"2", " ", "v"}], "-", 
            RowBox[{"2", " ", "vo"}]}]], "]"}]}], "+", 
        RowBox[{
         SqrtBox["3"], " ", 
         RowBox[{"Re", "[", 
          FractionBox[
           SuperscriptBox["power", 
            RowBox[{"1", "/", "3"}]], 
           RowBox[{
            SuperscriptBox["c", 
             RowBox[{"1", "/", "3"}]], " ", 
            RowBox[{"(", 
             RowBox[{"v", "-", "vo"}], ")"}]}]], "]"}]}]}], "\[NotEqual]", 
       "0"}], "||", 
      RowBox[{
       RowBox[{
        SqrtBox["3"], " ", 
        RowBox[{"Im", "[", 
         FractionBox[
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], 
          RowBox[{
           SuperscriptBox["c", 
            RowBox[{"1", "/", "3"}]], " ", 
           RowBox[{"(", 
            RowBox[{"v", "-", "vo"}], ")"}]}]], "]"}]}], "\[GreaterEqual]", 
       RowBox[{"2", "+", 
        RowBox[{"2", " ", 
         RowBox[{"Re", "[", 
          FractionBox[
           RowBox[{
            FractionBox[
             SuperscriptBox["power", 
              RowBox[{"1", "/", "3"}]], 
             SuperscriptBox["c", 
              RowBox[{"1", "/", "3"}]]], "+", 
            RowBox[{"2", " ", "vo"}]}], 
           RowBox[{
            RowBox[{"2", " ", "v"}], "-", 
            RowBox[{"2", " ", "vo"}]}]], "]"}]}]}]}], "||", 
      RowBox[{
       RowBox[{
        SqrtBox["3"], " ", 
        RowBox[{"Im", "[", 
         FractionBox[
          SuperscriptBox["power", 
           RowBox[{"1", "/", "3"}]], 
          RowBox[{
           SuperscriptBox["c", 
            RowBox[{"1", "/", "3"}]], " ", 
           RowBox[{"(", 
            RowBox[{"v", "-", "vo"}], ")"}]}]], "]"}]}], "\[LessEqual]", 
       RowBox[{"2", " ", 
        RowBox[{"Re", "[", 
         FractionBox[
          RowBox[{
           FractionBox[
            SuperscriptBox["power", 
             RowBox[{"1", "/", "3"}]], 
            SuperscriptBox["c", 
             RowBox[{"1", "/", "3"}]]], "+", 
           RowBox[{"2", " ", "vo"}]}], 
          RowBox[{
           RowBox[{"2", " ", "v"}], "-", 
           RowBox[{"2", " ", "vo"}]}]], "]"}]}]}]}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Im", "[", "v", "]"}], "\[Equal]", 
       RowBox[{"Im", "[", "vo", "]"}]}], "||", 
      RowBox[{
       RowBox[{
        RowBox[{"Im", "[", "vo", "]"}], " ", 
        RowBox[{"Re", "[", "v", "]"}]}], "\[Equal]", 
       RowBox[{
        RowBox[{"Im", "[", "v", "]"}], " ", 
        RowBox[{"Re", "[", "vo", "]"}]}]}], "||", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Im", "[", "v", "]"}], ">", 
         RowBox[{"Im", "[", "vo", "]"}]}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"Im", "[", "vo", "]"}], " ", 
          RowBox[{"Re", "[", "v", "]"}]}], "<", 
         RowBox[{
          RowBox[{"Im", "[", "v", "]"}], " ", 
          RowBox[{"Re", "[", "vo", "]"}]}]}]}], ")"}], "||", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Im", "[", "v", "]"}], "<", 
         RowBox[{"Im", "[", "vo", "]"}]}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"Im", "[", "vo", "]"}], " ", 
          RowBox[{"Re", "[", "v", "]"}]}], ">", 
         RowBox[{
          RowBox[{"Im", "[", "v", "]"}], " ", 
          RowBox[{"Re", "[", "vo", "]"}]}]}]}], ")"}]}], ")"}]}]}], 
  "]"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5181800155095997`*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 138, 7, 191, "Title",
 Evaluatable->False],
Cell[698, 29, 104, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[827, 38, 506, 16, 72, "Input"],
Cell[1336, 56, 11673, 360, 103, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

