(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     37869,       5837]*)
(*NotebookOutlinePosition[     38724,       5869]*)
(*  CellTagsIndexPosition[     38680,       5865]*)
(*WindowFrame->Normal*)



Notebook[{


Cell[TextData["\nQuit\n"], "Input",
  PageWidth->Infinity],

Cell[TextData["\n<<highorde.h\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nxx[t_] := -l1 Cos[theta[t]] - \n\n\td Cos[theta[t]+alpha[t]]\n\nyy[t_] := \
-l1 Sin[theta[t]] - \n\n\td Sin[theta[t]+alpha[t]]\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\ne1 := l1 Tension[t] Sin[alpha[t]] - \n\n\tm2 g l2 Cos[theta[t]] == \n\n\t\
m2 l2^2 theta''[t]\n\ne2 := Tension[t] Sin[theta[t]+alpha[t]] - \n\n\tm1 g + \
n1 == m1 yy''[t]\n\ne3 := Tension[t] Cos[theta[t]+alpha[t]] == \n\n\tm1 \
xx''[t]\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nm1 =.;l1 =.;m2 =.;l2 =.;g =.;d =.;n1 =.;\n\nderivs = Solve[{e1,e2,e3},\n\n\
\t{Tension[t],alpha''[t],theta''[t]}];\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nm1 = 1;l1 = 10;\n\nm2 = 500;l2 = 1;\n\ng = 9.81;\n\nd = 5;\n\nn1 = 0;\n\n\
thetanot = 45 Degree;\n\nthetamin = -45 Degree;\n\nthetadotnot = 0 Degree;\n\n\
alphanot = 90 Degree - thetanot;\n\nalphadotnot = - thetadotnot;\n"], "Input",\

  PageWidth->Infinity],

Cell[TextData[
"\nMaxTime = 1;\n\neqns = {theta[0]==thetanot,alpha[0]==alphanot,\n\n\t\
theta'[0]==thetadotnot,alpha'[0]==alphadotnot,\n\n\ttheta''[t] == \
(theta''[t]/.derivs)[[1]],\n\n\talpha''[t] == (alpha''[t]/.derivs)[[1]]};\n\n\
firsteqns = SecondToFirstOrder[eqns,{theta,alpha},t];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[TextData[
"\nsol = NDSolve[firsteqns,\n\n\t{theta[t],alpha[t],thetadot[t],alphadot[t]},\
\n\n\t{t,0,MaxTime}];\n\nendtime = (theta[t]/.sol)[[1,0]][[1,2]];\n"], "Input",\

  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[CellGroupData[{Cell[TextData["\nPlot[(theta[t]/.sol)/Degree,{t,0,endtime}];\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.435491 0.00372951 [

[(0.2)] .21429 .43549 0 2 Msboxa

[(0.4)] .40476 .43549 0 2 Msboxa

[(0.6)] .59524 .43549 0 2 Msboxa

[(0.8)] .78571 .43549 0 2 Msboxa

[(1)] .97619 .43549 0 2 Msboxa

[(-100)] .01131 .06254 1 0 Msboxa

[(-75)] .01131 .15578 1 0 Msboxa

[(-50)] .01131 .24902 1 0 Msboxa

[(-25)] .01131 .34225 1 0 Msboxa

[(25)] .01131 .52873 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .43549 m

.21429 .44174 L

s

P

[(0.2)] .21429 .43549 0 2 Mshowa

p

.002 w

.40476 .43549 m

.40476 .44174 L

s

P

[(0.4)] .40476 .43549 0 2 Mshowa

p

.002 w

.59524 .43549 m

.59524 .44174 L

s

P

[(0.6)] .59524 .43549 0 2 Mshowa

p

.002 w

.78571 .43549 m

.78571 .44174 L

s

P

[(0.8)] .78571 .43549 0 2 Mshowa

p

.002 w

.97619 .43549 m

.97619 .44174 L

s

P

[(1)] .97619 .43549 0 2 Mshowa

p

.001 w

.0619 .43549 m

.0619 .43924 L

s

P

p

.001 w

.1 .43549 m

.1 .43924 L

s

P

p

.001 w

.1381 .43549 m

.1381 .43924 L

s

P

p

.001 w

.17619 .43549 m

.17619 .43924 L

s

P

p

.001 w

.25238 .43549 m

.25238 .43924 L

s

P

p

.001 w

.29048 .43549 m

.29048 .43924 L

s

P

p

.001 w

.32857 .43549 m

.32857 .43924 L

s

P

p

.001 w

.36667 .43549 m

.36667 .43924 L

s

P

p

.001 w

.44286 .43549 m

.44286 .43924 L

s

P

p

.001 w

.48095 .43549 m

.48095 .43924 L

s

P

p

.001 w

.51905 .43549 m

.51905 .43924 L

s

P

p

.001 w

.55714 .43549 m

.55714 .43924 L

s

P

p

.001 w

.63333 .43549 m

.63333 .43924 L

s

P

p

.001 w

.67143 .43549 m

.67143 .43924 L

s

P

p

.001 w

.70952 .43549 m

.70952 .43924 L

s

P

p

.001 w

.74762 .43549 m

.74762 .43924 L

s

P

p

.001 w

.82381 .43549 m

.82381 .43924 L

s

P

p

.001 w

.8619 .43549 m

.8619 .43924 L

s

P

p

.001 w

.9 .43549 m

.9 .43924 L

s

P

p

.001 w

.9381 .43549 m

.9381 .43924 L

s

P

p

.002 w

0 .43549 m

1 .43549 L

s

P

p

.002 w

.02381 .06254 m

.03006 .06254 L

s

P

[(-100)] .01131 .06254 1 0 Mshowa

p

.002 w

.02381 .15578 m

.03006 .15578 L

s

P

[(-75)] .01131 .15578 1 0 Mshowa

p

.002 w

.02381 .24902 m

.03006 .24902 L

s

P

[(-50)] .01131 .24902 1 0 Mshowa

p

.002 w

.02381 .34225 m

.03006 .34225 L

s

P

[(-25)] .01131 .34225 1 0 Mshowa

p

.002 w

.02381 .52873 m

.03006 .52873 L

s

P

[(25)] .01131 .52873 1 0 Mshowa

p

.001 w

.02381 .08119 m

.02756 .08119 L

s

P

p

.001 w

.02381 .09983 m

.02756 .09983 L

s

P

p

.001 w

.02381 .11848 m

.02756 .11848 L

s

P

p

.001 w

.02381 .13713 m

.02756 .13713 L

s

P

p

.001 w

.02381 .17442 m

.02756 .17442 L

s

P

p

.001 w

.02381 .19307 m

.02756 .19307 L

s

P

p

.001 w

.02381 .21172 m

.02756 .21172 L

s

P

p

.001 w

.02381 .23037 m

.02756 .23037 L

s

P

p

.001 w

.02381 .26766 m

.02756 .26766 L

s

P

p

.001 w

.02381 .28631 m

.02756 .28631 L

s

P

p

.001 w

.02381 .30496 m

.02756 .30496 L

s

P

p

.001 w

.02381 .32361 m

.02756 .32361 L

s

P

p

.001 w

.02381 .3609 m

.02756 .3609 L

s

P

p

.001 w

.02381 .37955 m

.02756 .37955 L

s

P

p

.001 w

.02381 .3982 m

.02756 .3982 L

s

P

p

.001 w

.02381 .41684 m

.02756 .41684 L

s

P

p

.001 w

.02381 .45414 m

.02756 .45414 L

s

P

p

.001 w

.02381 .47279 m

.02756 .47279 L

s

P

p

.001 w

.02381 .49143 m

.02756 .49143 L

s

P

p

.001 w

.02381 .51008 m

.02756 .51008 L

s

P

p

.001 w

.02381 .54738 m

.02756 .54738 L

s

P

p

.001 w

.02381 .56602 m

.02756 .56602 L

s

P

p

.001 w

.02381 .58467 m

.02756 .58467 L

s

P

p

.001 w

.02381 .60332 m

.02756 .60332 L

s

P

p

.001 w

.02381 .04389 m

.02756 .04389 L

s

P

p

.001 w

.02381 .02524 m

.02756 .02524 L

s

P

p

.001 w

.02381 .0066 m

.02756 .0066 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .60332 m

.02505 .60332 L

.02629 .60331 L

.02753 .60331 L

.02877 .6033 L

.03001 .60329 L

.03125 .60328 L

.03373 .60325 L

.03621 .60321 L

.03869 .60316 L

.04365 .60303 L

.04861 .60287 L

.05357 .60267 L

.06349 .60217 L

.07341 .60153 L

.08333 .60074 L

.10317 .59873 L

.12302 .59615 L

.14286 .59299 L

.18254 .58495 L

.22222 .57459 L

.2619 .56188 L

.30159 .54676 L

.34127 .52915 L

.38095 .50891 L

.42063 .48586 L

.46032 .45984 L

.5 .43071 L

.53968 .39844 L

.57937 .36317 L

.61905 .32534 L

.65873 .28571 L

.69841 .24546 L

.7381 .20611 L

.77778 .16931 L

.81746 .13629 L

.85714 .10695 L

.89683 .07893 L

.93651 .04875 L

.97619 .01472 L

s

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData["\nPlot[(thetadot[t]/.sol)/Degree,{t,0,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.603319 0.00226869 [

[(0.2)] .21429 .60332 0 2 Msboxa

[(0.4)] .40476 .60332 0 2 Msboxa

[(0.6)] .59524 .60332 0 2 Msboxa

[(0.8)] .78571 .60332 0 2 Msboxa

[(1)] .97619 .60332 0 2 Msboxa

[(-250)] .01131 .03615 1 0 Msboxa

[(-200)] .01131 .14958 1 0 Msboxa

[(-150)] .01131 .26302 1 0 Msboxa

[(-100)] .01131 .37645 1 0 Msboxa

[(-50)] .01131 .48988 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .60332 m

.21429 .60957 L

s

P

[(0.2)] .21429 .60332 0 2 Mshowa

p

.002 w

.40476 .60332 m

.40476 .60957 L

s

P

[(0.4)] .40476 .60332 0 2 Mshowa

p

.002 w

.59524 .60332 m

.59524 .60957 L

s

P

[(0.6)] .59524 .60332 0 2 Mshowa

p

.002 w

.78571 .60332 m

.78571 .60957 L

s

P

[(0.8)] .78571 .60332 0 2 Mshowa

p

.002 w

.97619 .60332 m

.97619 .60957 L

s

P

[(1)] .97619 .60332 0 2 Mshowa

p

.001 w

.0619 .60332 m

.0619 .60707 L

s

P

p

.001 w

.1 .60332 m

.1 .60707 L

s

P

p

.001 w

.1381 .60332 m

.1381 .60707 L

s

P

p

.001 w

.17619 .60332 m

.17619 .60707 L

s

P

p

.001 w

.25238 .60332 m

.25238 .60707 L

s

P

p

.001 w

.29048 .60332 m

.29048 .60707 L

s

P

p

.001 w

.32857 .60332 m

.32857 .60707 L

s

P

p

.001 w

.36667 .60332 m

.36667 .60707 L

s

P

p

.001 w

.44286 .60332 m

.44286 .60707 L

s

P

p

.001 w

.48095 .60332 m

.48095 .60707 L

s

P

p

.001 w

.51905 .60332 m

.51905 .60707 L

s

P

p

.001 w

.55714 .60332 m

.55714 .60707 L

s

P

p

.001 w

.63333 .60332 m

.63333 .60707 L

s

P

p

.001 w

.67143 .60332 m

.67143 .60707 L

s

P

p

.001 w

.70952 .60332 m

.70952 .60707 L

s

P

p

.001 w

.74762 .60332 m

.74762 .60707 L

s

P

p

.001 w

.82381 .60332 m

.82381 .60707 L

s

P

p

.001 w

.8619 .60332 m

.8619 .60707 L

s

P

p

.001 w

.9 .60332 m

.9 .60707 L

s

P

p

.001 w

.9381 .60332 m

.9381 .60707 L

s

P

p

.002 w

0 .60332 m

1 .60332 L

s

P

p

.002 w

.02381 .03615 m

.03006 .03615 L

s

P

[(-250)] .01131 .03615 1 0 Mshowa

p

.002 w

.02381 .14958 m

.03006 .14958 L

s

P

[(-200)] .01131 .14958 1 0 Mshowa

p

.002 w

.02381 .26302 m

.03006 .26302 L

s

P

[(-150)] .01131 .26302 1 0 Mshowa

p

.002 w

.02381 .37645 m

.03006 .37645 L

s

P

[(-100)] .01131 .37645 1 0 Mshowa

p

.002 w

.02381 .48988 m

.03006 .48988 L

s

P

[(-50)] .01131 .48988 1 0 Mshowa

p

.001 w

.02381 .05883 m

.02756 .05883 L

s

P

p

.001 w

.02381 .08152 m

.02756 .08152 L

s

P

p

.001 w

.02381 .10421 m

.02756 .10421 L

s

P

p

.001 w

.02381 .12689 m

.02756 .12689 L

s

P

p

.001 w

.02381 .17227 m

.02756 .17227 L

s

P

p

.001 w

.02381 .19496 m

.02756 .19496 L

s

P

p

.001 w

.02381 .21764 m

.02756 .21764 L

s

P

p

.001 w

.02381 .24033 m

.02756 .24033 L

s

P

p

.001 w

.02381 .2857 m

.02756 .2857 L

s

P

p

.001 w

.02381 .30839 m

.02756 .30839 L

s

P

p

.001 w

.02381 .33108 m

.02756 .33108 L

s

P

p

.001 w

.02381 .35376 m

.02756 .35376 L

s

P

p

.001 w

.02381 .39914 m

.02756 .39914 L

s

P

p

.001 w

.02381 .42182 m

.02756 .42182 L

s

P

p

.001 w

.02381 .44451 m

.02756 .44451 L

s

P

p

.001 w

.02381 .4672 m

.02756 .4672 L

s

P

p

.001 w

.02381 .51257 m

.02756 .51257 L

s

P

p

.001 w

.02381 .53526 m

.02756 .53526 L

s

P

p

.001 w

.02381 .55795 m

.02756 .55795 L

s

P

p

.001 w

.02381 .58063 m

.02756 .58063 L

s

P

p

.001 w

.02381 .01346 m

.02756 .01346 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .60332 m

.06349 .56984 L

.10317 .53633 L

.14286 .50275 L

.18254 .46902 L

.22222 .43499 L

.2619 .40037 L

.30159 .36469 L

.34127 .32735 L

.38095 .28777 L

.42063 .24559 L

.46032 .20099 L

.5 .15497 L

.53968 .10963 L

.57937 .06827 L

.59921 .05047 L

.61905 .03548 L

.62897 .02926 L

.63889 .02403 L

.64881 .01986 L

.65377 .01822 L

.65873 .01687 L

.66121 .01632 L

.66369 .01584 L

.66617 .01545 L

.66865 .01514 L

.66989 .01502 L

.67113 .01491 L

.67237 .01483 L

.67361 .01477 L

.67485 .01473 L

.67609 .01472 L

.67733 .01472 L

.67857 .01475 L

.67981 .0148 L

.68105 .01487 L

.68229 .01496 L

.68353 .01508 L

.68601 .01538 L

.68849 .01577 L

.69345 .01683 L

.69841 .01827 L

.70833 .02229 L

.71825 .02786 L

.7381 .04362 L

.75794 .06521 L

.77778 .09168 L

.81746 .15092 L

.82738 .16457 L

.8373 .17659 L

Mistroke

.84226 .18178 L

.84722 .18632 L

.85218 .19014 L

.85714 .19317 L

.85962 .19437 L

.8621 .19535 L

.86458 .19611 L

.86582 .19641 L

.86706 .19665 L

.8683 .19684 L

.86954 .19696 L

.87078 .19703 L

.87202 .19705 L

.87326 .197 L

.8745 .1969 L

.87574 .19674 L

.87698 .19652 L

.87822 .19625 L

.87946 .19592 L

.88194 .1951 L

.8869 .1928 L

.89187 .18967 L

.89683 .18576 L

.91667 .16385 L

.93651 .13571 L

.97619 .07831 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData["\nPlot[(alpha[t]/.sol)/Degree,{t,0,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.232702 0.00329595 [

[(0.2)] .21429 .2327 0 2 Msboxa

[(0.4)] .40476 .2327 0 2 Msboxa

[(0.6)] .59524 .2327 0 2 Msboxa

[(0.8)] .78571 .2327 0 2 Msboxa

[(1)] .97619 .2327 0 2 Msboxa

[(-50)] .01131 .0679 1 0 Msboxa

[(-25)] .01131 .1503 1 0 Msboxa

[(25)] .01131 .3151 1 0 Msboxa

[(50)] .01131 .3975 1 0 Msboxa

[(75)] .01131 .4799 1 0 Msboxa

[(100)] .01131 .5623 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .2327 m

.21429 .23895 L

s

P

[(0.2)] .21429 .2327 0 2 Mshowa

p

.002 w

.40476 .2327 m

.40476 .23895 L

s

P

[(0.4)] .40476 .2327 0 2 Mshowa

p

.002 w

.59524 .2327 m

.59524 .23895 L

s

P

[(0.6)] .59524 .2327 0 2 Mshowa

p

.002 w

.78571 .2327 m

.78571 .23895 L

s

P

[(0.8)] .78571 .2327 0 2 Mshowa

p

.002 w

.97619 .2327 m

.97619 .23895 L

s

P

[(1)] .97619 .2327 0 2 Mshowa

p

.001 w

.0619 .2327 m

.0619 .23645 L

s

P

p

.001 w

.1 .2327 m

.1 .23645 L

s

P

p

.001 w

.1381 .2327 m

.1381 .23645 L

s

P

p

.001 w

.17619 .2327 m

.17619 .23645 L

s

P

p

.001 w

.25238 .2327 m

.25238 .23645 L

s

P

p

.001 w

.29048 .2327 m

.29048 .23645 L

s

P

p

.001 w

.32857 .2327 m

.32857 .23645 L

s

P

p

.001 w

.36667 .2327 m

.36667 .23645 L

s

P

p

.001 w

.44286 .2327 m

.44286 .23645 L

s

P

p

.001 w

.48095 .2327 m

.48095 .23645 L

s

P

p

.001 w

.51905 .2327 m

.51905 .23645 L

s

P

p

.001 w

.55714 .2327 m

.55714 .23645 L

s

P

p

.001 w

.63333 .2327 m

.63333 .23645 L

s

P

p

.001 w

.67143 .2327 m

.67143 .23645 L

s

P

p

.001 w

.70952 .2327 m

.70952 .23645 L

s

P

p

.001 w

.74762 .2327 m

.74762 .23645 L

s

P

p

.001 w

.82381 .2327 m

.82381 .23645 L

s

P

p

.001 w

.8619 .2327 m

.8619 .23645 L

s

P

p

.001 w

.9 .2327 m

.9 .23645 L

s

P

p

.001 w

.9381 .2327 m

.9381 .23645 L

s

P

p

.002 w

0 .2327 m

1 .2327 L

s

P

p

.002 w

.02381 .0679 m

.03006 .0679 L

s

P

[(-50)] .01131 .0679 1 0 Mshowa

p

.002 w

.02381 .1503 m

.03006 .1503 L

s

P

[(-25)] .01131 .1503 1 0 Mshowa

p

.002 w

.02381 .3151 m

.03006 .3151 L

s

P

[(25)] .01131 .3151 1 0 Mshowa

p

.002 w

.02381 .3975 m

.03006 .3975 L

s

P

[(50)] .01131 .3975 1 0 Mshowa

p

.002 w

.02381 .4799 m

.03006 .4799 L

s

P

[(75)] .01131 .4799 1 0 Mshowa

p

.002 w

.02381 .5623 m

.03006 .5623 L

s

P

[(100)] .01131 .5623 1 0 Mshowa

p

.001 w

.02381 .08438 m

.02756 .08438 L

s

P

p

.001 w

.02381 .10086 m

.02756 .10086 L

s

P

p

.001 w

.02381 .11734 m

.02756 .11734 L

s

P

p

.001 w

.02381 .13382 m

.02756 .13382 L

s

P

p

.001 w

.02381 .16678 m

.02756 .16678 L

s

P

p

.001 w

.02381 .18326 m

.02756 .18326 L

s

P

p

.001 w

.02381 .19974 m

.02756 .19974 L

s

P

p

.001 w

.02381 .21622 m

.02756 .21622 L

s

P

p

.001 w

.02381 .24918 m

.02756 .24918 L

s

P

p

.001 w

.02381 .26566 m

.02756 .26566 L

s

P

p

.001 w

.02381 .28214 m

.02756 .28214 L

s

P

p

.001 w

.02381 .29862 m

.02756 .29862 L

s

P

p

.001 w

.02381 .33158 m

.02756 .33158 L

s

P

p

.001 w

.02381 .34806 m

.02756 .34806 L

s

P

p

.001 w

.02381 .36454 m

.02756 .36454 L

s

P

p

.001 w

.02381 .38102 m

.02756 .38102 L

s

P

p

.001 w

.02381 .41398 m

.02756 .41398 L

s

P

p

.001 w

.02381 .43046 m

.02756 .43046 L

s

P

p

.001 w

.02381 .44694 m

.02756 .44694 L

s

P

p

.001 w

.02381 .46342 m

.02756 .46342 L

s

P

p

.001 w

.02381 .49638 m

.02756 .49638 L

s

P

p

.001 w

.02381 .51286 m

.02756 .51286 L

s

P

p

.001 w

.02381 .52934 m

.02756 .52934 L

s

P

p

.001 w

.02381 .54582 m

.02756 .54582 L

s

P

p

.001 w

.02381 .05142 m

.02756 .05142 L

s

P

p

.001 w

.02381 .03494 m

.02756 .03494 L

s

P

p

.001 w

.02381 .01847 m

.02756 .01847 L

s

P

p

.001 w

.02381 .00199 m

.02756 .00199 L

s

P

p

.001 w

.02381 .57878 m

.02756 .57878 L

s

P

p

.001 w

.02381 .59526 m

.02756 .59526 L

s

P

p

.001 w

.02381 .61174 m

.02756 .61174 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .38102 m

.02505 .38102 L

.02629 .38103 L

.02753 .38104 L

.02877 .38106 L

.03001 .38108 L

.03125 .38111 L

.03373 .38117 L

.03621 .38126 L

.03869 .38136 L

.04365 .38163 L

.04861 .38197 L

.05357 .38239 L

.06349 .38346 L

.07341 .38483 L

.08333 .38649 L

.10317 .39071 L

.14286 .40254 L

.18254 .41859 L

.22222 .43827 L

.2619 .46086 L

.30159 .48542 L

.34127 .51085 L

.38095 .53589 L

.42063 .55913 L

.46032 .579 L

.48016 .58718 L

.5 .5939 L

.50992 .59666 L

.51984 .59897 L

.52976 .60082 L

.53968 .60217 L

.54464 .60266 L

.54712 .60285 L

.5496 .60302 L

.55208 .60314 L

.55332 .60319 L

.55456 .60324 L

.5558 .60327 L

.55704 .6033 L

.55828 .60331 L

.55952 .60332 L

.56076 .60332 L

.562 .60331 L

.56324 .60329 L

.56448 .60326 L

.56572 .60322 L

.56696 .60318 L

.56944 .60306 L

.57192 .6029 L

Mistroke

.5744 .60271 L

.57937 .60221 L

.58433 .60156 L

.58929 .60076 L

.59921 .59867 L

.60913 .59592 L

.61905 .59251 L

.63889 .58356 L

.65873 .57166 L

.69841 .53843 L

.7381 .49171 L

.77778 .43055 L

.81746 .35452 L

.85714 .26581 L

.89683 .17275 L

.93651 .08692 L

.97619 .01472 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData["\nPlot[(alphadot[t]/.sol)/Degree,{t,0,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.477379 0.00067787 [

[(0.2)] .21429 .47738 0 2 Msboxa

[(0.4)] .40476 .47738 0 2 Msboxa

[(0.6)] .59524 .47738 0 2 Msboxa

[(0.8)] .78571 .47738 0 2 Msboxa

[(1)] .97619 .47738 0 2 Msboxa

[(-600)] .01131 .07066 1 0 Msboxa

[(-400)] .01131 .20623 1 0 Msboxa

[(-200)] .01131 .3418 1 0 Msboxa

[(200)] .01131 .61295 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .47738 m

.21429 .48363 L

s

P

[(0.2)] .21429 .47738 0 2 Mshowa

p

.002 w

.40476 .47738 m

.40476 .48363 L

s

P

[(0.4)] .40476 .47738 0 2 Mshowa

p

.002 w

.59524 .47738 m

.59524 .48363 L

s

P

[(0.6)] .59524 .47738 0 2 Mshowa

p

.002 w

.78571 .47738 m

.78571 .48363 L

s

P

[(0.8)] .78571 .47738 0 2 Mshowa

p

.002 w

.97619 .47738 m

.97619 .48363 L

s

P

[(1)] .97619 .47738 0 2 Mshowa

p

.001 w

.0619 .47738 m

.0619 .48113 L

s

P

p

.001 w

.1 .47738 m

.1 .48113 L

s

P

p

.001 w

.1381 .47738 m

.1381 .48113 L

s

P

p

.001 w

.17619 .47738 m

.17619 .48113 L

s

P

p

.001 w

.25238 .47738 m

.25238 .48113 L

s

P

p

.001 w

.29048 .47738 m

.29048 .48113 L

s

P

p

.001 w

.32857 .47738 m

.32857 .48113 L

s

P

p

.001 w

.36667 .47738 m

.36667 .48113 L

s

P

p

.001 w

.44286 .47738 m

.44286 .48113 L

s

P

p

.001 w

.48095 .47738 m

.48095 .48113 L

s

P

p

.001 w

.51905 .47738 m

.51905 .48113 L

s

P

p

.001 w

.55714 .47738 m

.55714 .48113 L

s

P

p

.001 w

.63333 .47738 m

.63333 .48113 L

s

P

p

.001 w

.67143 .47738 m

.67143 .48113 L

s

P

p

.001 w

.70952 .47738 m

.70952 .48113 L

s

P

p

.001 w

.74762 .47738 m

.74762 .48113 L

s

P

p

.001 w

.82381 .47738 m

.82381 .48113 L

s

P

p

.001 w

.8619 .47738 m

.8619 .48113 L

s

P

p

.001 w

.9 .47738 m

.9 .48113 L

s

P

p

.001 w

.9381 .47738 m

.9381 .48113 L

s

P

p

.002 w

0 .47738 m

1 .47738 L

s

P

p

.002 w

.02381 .07066 m

.03006 .07066 L

s

P

[(-600)] .01131 .07066 1 0 Mshowa

p

.002 w

.02381 .20623 m

.03006 .20623 L

s

P

[(-400)] .01131 .20623 1 0 Mshowa

p

.002 w

.02381 .3418 m

.03006 .3418 L

s

P

[(-200)] .01131 .3418 1 0 Mshowa

p

.002 w

.02381 .61295 m

.03006 .61295 L

s

P

[(200)] .01131 .61295 1 0 Mshowa

p

.001 w

.02381 .09777 m

.02756 .09777 L

s

P

p

.001 w

.02381 .12489 m

.02756 .12489 L

s

P

p

.001 w

.02381 .152 m

.02756 .152 L

s

P

p

.001 w

.02381 .17912 m

.02756 .17912 L

s

P

p

.001 w

.02381 .23335 m

.02756 .23335 L

s

P

p

.001 w

.02381 .26046 m

.02756 .26046 L

s

P

p

.001 w

.02381 .28758 m

.02756 .28758 L

s

P

p

.001 w

.02381 .31469 m

.02756 .31469 L

s

P

p

.001 w

.02381 .36892 m

.02756 .36892 L

s

P

p

.001 w

.02381 .39603 m

.02756 .39603 L

s

P

p

.001 w

.02381 .42315 m

.02756 .42315 L

s

P

p

.001 w

.02381 .45026 m

.02756 .45026 L

s

P

p

.001 w

.02381 .50449 m

.02756 .50449 L

s

P

p

.001 w

.02381 .53161 m

.02756 .53161 L

s

P

p

.001 w

.02381 .55872 m

.02756 .55872 L

s

P

p

.001 w

.02381 .58584 m

.02756 .58584 L

s

P

p

.001 w

.02381 .04354 m

.02756 .04354 L

s

P

p

.001 w

.02381 .01643 m

.02756 .01643 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .47738 m

.06349 .50141 L

.10317 .52473 L

.14286 .54657 L

.18254 .5661 L

.22222 .5824 L

.24206 .58906 L

.2619 .59457 L

.27183 .59687 L

.28175 .59883 L

.29167 .60046 L

.30159 .60174 L

.30655 .60224 L

.31151 .60264 L

.31399 .60281 L

.31647 .60296 L

.31895 .60308 L

.32143 .60317 L

.32267 .60321 L

.32391 .60325 L

.32515 .60327 L

.32639 .60329 L

.32763 .60331 L

.32887 .60332 L

.33011 .60332 L

.33135 .60331 L

.33259 .6033 L

.33383 .60329 L

.33631 .60323 L

.33755 .6032 L

.33879 .60316 L

.34127 .60305 L

.34623 .60277 L

.35119 .60237 L

.36111 .60127 L

.37103 .59973 L

.38095 .59774 L

.40079 .59237 L

.42063 .58509 L

.46032 .56457 L

.5 .53591 L

.53968 .49917 L

.57937 .45472 L

.61905 .40307 L

.65873 .34489 L

.69841 .28092 L

.7381 .21182 L

.77778 .13862 L

.79762 .10178 L

.81746 .06698 L

Mistroke

.82738 .05138 L

.8373 .03775 L

.84226 .03189 L

.84722 .02676 L

.85218 .02246 L

.85714 .01905 L

.85962 .0177 L

.8621 .0166 L

.86334 .01614 L

.86458 .01574 L

.86582 .01541 L

.86706 .01514 L

.8683 .01494 L

.86954 .0148 L

.87078 .01473 L

.87202 .01472 L

.87326 .01477 L

.8745 .01489 L

.87574 .01507 L

.87698 .01532 L

.87822 .01563 L

.87946 .01601 L

.88194 .01694 L

.8869 .01956 L

.89187 .02311 L

.89683 .02754 L

.91667 .05246 L

.93651 .08499 L

.97619 .15755 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[((theta[t]+alpha[t])/.sol)/Degree,{t,0,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 -0.573333 0.010455 [

[(0.2)] .21429 .05396 0 2 Msboxa

[(0.4)] .40476 .05396 0 2 Msboxa

[(0.6)] .59524 .05396 0 2 Msboxa

[(0.8)] .78571 .05396 0 2 Msboxa

[(1)] .97619 .05396 0 2 Msboxa

[(70)] .01131 .15851 1 0 Msboxa

[(80)] .01131 .26306 1 0 Msboxa

[(90)] .01131 .36761 1 0 Msboxa

[(100)] .01131 .47216 1 0 Msboxa

[(110)] .01131 .57671 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .05396 m

.21429 .06021 L

s

P

[(0.2)] .21429 .05396 0 2 Mshowa

p

.002 w

.40476 .05396 m

.40476 .06021 L

s

P

[(0.4)] .40476 .05396 0 2 Mshowa

p

.002 w

.59524 .05396 m

.59524 .06021 L

s

P

[(0.6)] .59524 .05396 0 2 Mshowa

p

.002 w

.78571 .05396 m

.78571 .06021 L

s

P

[(0.8)] .78571 .05396 0 2 Mshowa

p

.002 w

.97619 .05396 m

.97619 .06021 L

s

P

[(1)] .97619 .05396 0 2 Mshowa

p

.001 w

.0619 .05396 m

.0619 .05771 L

s

P

p

.001 w

.1 .05396 m

.1 .05771 L

s

P

p

.001 w

.1381 .05396 m

.1381 .05771 L

s

P

p

.001 w

.17619 .05396 m

.17619 .05771 L

s

P

p

.001 w

.25238 .05396 m

.25238 .05771 L

s

P

p

.001 w

.29048 .05396 m

.29048 .05771 L

s

P

p

.001 w

.32857 .05396 m

.32857 .05771 L

s

P

p

.001 w

.36667 .05396 m

.36667 .05771 L

s

P

p

.001 w

.44286 .05396 m

.44286 .05771 L

s

P

p

.001 w

.48095 .05396 m

.48095 .05771 L

s

P

p

.001 w

.51905 .05396 m

.51905 .05771 L

s

P

p

.001 w

.55714 .05396 m

.55714 .05771 L

s

P

p

.001 w

.63333 .05396 m

.63333 .05771 L

s

P

p

.001 w

.67143 .05396 m

.67143 .05771 L

s

P

p

.001 w

.70952 .05396 m

.70952 .05771 L

s

P

p

.001 w

.74762 .05396 m

.74762 .05771 L

s

P

p

.001 w

.82381 .05396 m

.82381 .05771 L

s

P

p

.001 w

.8619 .05396 m

.8619 .05771 L

s

P

p

.001 w

.9 .05396 m

.9 .05771 L

s

P

p

.001 w

.9381 .05396 m

.9381 .05771 L

s

P

p

.002 w

0 .05396 m

1 .05396 L

s

P

p

.002 w

.02381 .15851 m

.03006 .15851 L

s

P

[(70)] .01131 .15851 1 0 Mshowa

p

.002 w

.02381 .26306 m

.03006 .26306 L

s

P

[(80)] .01131 .26306 1 0 Mshowa

p

.002 w

.02381 .36761 m

.03006 .36761 L

s

P

[(90)] .01131 .36761 1 0 Mshowa

p

.002 w

.02381 .47216 m

.03006 .47216 L

s

P

[(100)] .01131 .47216 1 0 Mshowa

p

.002 w

.02381 .57671 m

.03006 .57671 L

s

P

[(110)] .01131 .57671 1 0 Mshowa

p

.001 w

.02381 .07487 m

.02756 .07487 L

s

P

p

.001 w

.02381 .09578 m

.02756 .09578 L

s

P

p

.001 w

.02381 .11669 m

.02756 .11669 L

s

P

p

.001 w

.02381 .1376 m

.02756 .1376 L

s

P

p

.001 w

.02381 .17942 m

.02756 .17942 L

s

P

p

.001 w

.02381 .20033 m

.02756 .20033 L

s

P

p

.001 w

.02381 .22124 m

.02756 .22124 L

s

P

p

.001 w

.02381 .24215 m

.02756 .24215 L

s

P

p

.001 w

.02381 .28397 m

.02756 .28397 L

s

P

p

.001 w

.02381 .30488 m

.02756 .30488 L

s

P

p

.001 w

.02381 .32579 m

.02756 .32579 L

s

P

p

.001 w

.02381 .3467 m

.02756 .3467 L

s

P

p

.001 w

.02381 .38852 m

.02756 .38852 L

s

P

p

.001 w

.02381 .40943 m

.02756 .40943 L

s

P

p

.001 w

.02381 .43034 m

.02756 .43034 L

s

P

p

.001 w

.02381 .45125 m

.02756 .45125 L

s

P

p

.001 w

.02381 .49307 m

.02756 .49307 L

s

P

p

.001 w

.02381 .51398 m

.02756 .51398 L

s

P

p

.001 w

.02381 .53489 m

.02756 .53489 L

s

P

p

.001 w

.02381 .5558 m

.02756 .5558 L

s

P

p

.001 w

.02381 .03305 m

.02756 .03305 L

s

P

p

.001 w

.02381 .01214 m

.02756 .01214 L

s

P

p

.001 w

.02381 .59762 m

.02756 .59762 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .36761 m

.02505 .36762 L

.02629 .36763 L

.02753 .36765 L

.02877 .36768 L

.03001 .36772 L

.03125 .36777 L

.03373 .3679 L

.03621 .36806 L

.03869 .36825 L

.04365 .36875 L

.04861 .36939 L

.05357 .37016 L

.06349 .37214 L

.08333 .37774 L

.10317 .38548 L

.14286 .40695 L

.18254 .43529 L

.22222 .46869 L

.2619 .5047 L

.30159 .54024 L

.34127 .57154 L

.36111 .58425 L

.38095 .59422 L

.39087 .59797 L

.39583 .5995 L

.40079 .60079 L

.40575 .60183 L

.40823 .60225 L

.41071 .6026 L

.41319 .60289 L

.41567 .6031 L

.41691 .60318 L

.41815 .60324 L

.41939 .60329 L

.42063 .60331 L

.42188 .60332 L

.42312 .60331 L

.42436 .60328 L

.4256 .60323 L

.42684 .60316 L

.42808 .60307 L

.43056 .60284 L

.43304 .60252 L

.43552 .60213 L

.44048 .60109 L

.44544 .59971 L

.4504 .59798 L

.46032 .59343 L

.47024 .58734 L

Mistroke

.48016 .57964 L

.5 .55903 L

.51984 .53095 L

.53968 .49478 L

.57937 .39604 L

.61905 .25919 L

.65873 .08197 L

Mfstroke

.67364 0 m

.65873 .08197 L

s

s

s

s

s

s

s

s

s

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[\n\n((((Tension[t]/.derivs)/.{alpha'[t]->alphadot[t],\n\n\
theta'[t]->thetadot[t]})/.sol)),{t,0,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.0147151 0.000483036 [

[(0.2)] .21429 .01472 0 2 Msboxa

[(0.4)] .40476 .01472 0 2 Msboxa

[(0.6)] .59524 .01472 0 2 Msboxa

[(0.8)] .78571 .01472 0 2 Msboxa

[(1)] .97619 .01472 0 2 Msboxa

[(200)] .01131 .11132 1 0 Msboxa

[(400)] .01131 .20793 1 0 Msboxa

[(600)] .01131 .30454 1 0 Msboxa

[(800)] .01131 .40114 1 0 Msboxa

[(1000)] .01131 .49775 1 0 Msboxa

[(1200)] .01131 .59436 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .01472 m

.21429 .02097 L

s

P

[(0.2)] .21429 .01472 0 2 Mshowa

p

.002 w

.40476 .01472 m

.40476 .02097 L

s

P

[(0.4)] .40476 .01472 0 2 Mshowa

p

.002 w

.59524 .01472 m

.59524 .02097 L

s

P

[(0.6)] .59524 .01472 0 2 Mshowa

p

.002 w

.78571 .01472 m

.78571 .02097 L

s

P

[(0.8)] .78571 .01472 0 2 Mshowa

p

.002 w

.97619 .01472 m

.97619 .02097 L

s

P

[(1)] .97619 .01472 0 2 Mshowa

p

.001 w

.0619 .01472 m

.0619 .01847 L

s

P

p

.001 w

.1 .01472 m

.1 .01847 L

s

P

p

.001 w

.1381 .01472 m

.1381 .01847 L

s

P

p

.001 w

.17619 .01472 m

.17619 .01847 L

s

P

p

.001 w

.25238 .01472 m

.25238 .01847 L

s

P

p

.001 w

.29048 .01472 m

.29048 .01847 L

s

P

p

.001 w

.32857 .01472 m

.32857 .01847 L

s

P

p

.001 w

.36667 .01472 m

.36667 .01847 L

s

P

p

.001 w

.44286 .01472 m

.44286 .01847 L

s

P

p

.001 w

.48095 .01472 m

.48095 .01847 L

s

P

p

.001 w

.51905 .01472 m

.51905 .01847 L

s

P

p

.001 w

.55714 .01472 m

.55714 .01847 L

s

P

p

.001 w

.63333 .01472 m

.63333 .01847 L

s

P

p

.001 w

.67143 .01472 m

.67143 .01847 L

s

P

p

.001 w

.70952 .01472 m

.70952 .01847 L

s

P

p

.001 w

.74762 .01472 m

.74762 .01847 L

s

P

p

.001 w

.82381 .01472 m

.82381 .01847 L

s

P

p

.001 w

.8619 .01472 m

.8619 .01847 L

s

P

p

.001 w

.9 .01472 m

.9 .01847 L

s

P

p

.001 w

.9381 .01472 m

.9381 .01847 L

s

P

p

.002 w

0 .01472 m

1 .01472 L

s

P

p

.002 w

.02381 .11132 m

.03006 .11132 L

s

P

[(200)] .01131 .11132 1 0 Mshowa

p

.002 w

.02381 .20793 m

.03006 .20793 L

s

P

[(400)] .01131 .20793 1 0 Mshowa

p

.002 w

.02381 .30454 m

.03006 .30454 L

s

P

[(600)] .01131 .30454 1 0 Mshowa

p

.002 w

.02381 .40114 m

.03006 .40114 L

s

P

[(800)] .01131 .40114 1 0 Mshowa

p

.002 w

.02381 .49775 m

.03006 .49775 L

s

P

[(1000)] .01131 .49775 1 0 Mshowa

p

.002 w

.02381 .59436 m

.03006 .59436 L

s

P

[(1200)] .01131 .59436 1 0 Mshowa

p

.001 w

.02381 .03404 m

.02756 .03404 L

s

P

p

.001 w

.02381 .05336 m

.02756 .05336 L

s

P

p

.001 w

.02381 .07268 m

.02756 .07268 L

s

P

p

.001 w

.02381 .092 m

.02756 .092 L

s

P

p

.001 w

.02381 .13064 m

.02756 .13064 L

s

P

p

.001 w

.02381 .14997 m

.02756 .14997 L

s

P

p

.001 w

.02381 .16929 m

.02756 .16929 L

s

P

p

.001 w

.02381 .18861 m

.02756 .18861 L

s

P

p

.001 w

.02381 .22725 m

.02756 .22725 L

s

P

p

.001 w

.02381 .24657 m

.02756 .24657 L

s

P

p

.001 w

.02381 .26589 m

.02756 .26589 L

s

P

p

.001 w

.02381 .28522 m

.02756 .28522 L

s

P

p

.001 w

.02381 .32386 m

.02756 .32386 L

s

P

p

.001 w

.02381 .34318 m

.02756 .34318 L

s

P

p

.001 w

.02381 .3625 m

.02756 .3625 L

s

P

p

.001 w

.02381 .38182 m

.02756 .38182 L

s

P

p

.001 w

.02381 .42047 m

.02756 .42047 L

s

P

p

.001 w

.02381 .43979 m

.02756 .43979 L

s

P

p

.001 w

.02381 .45911 m

.02756 .45911 L

s

P

p

.001 w

.02381 .47843 m

.02756 .47843 L

s

P

p

.001 w

.02381 .51707 m

.02756 .51707 L

s

P

p

.001 w

.02381 .53639 m

.02756 .53639 L

s

P

p

.001 w

.02381 .55572 m

.02756 .55572 L

s

P

p

.001 w

.02381 .57504 m

.02756 .57504 L

s

P

p

.001 w

.02381 .61368 m

.02756 .61368 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .04056 m

.02505 .04056 L

.02629 .04057 L

.02753 .04057 L

.02877 .04057 L

.03001 .04058 L

.03125 .04059 L

.03373 .04061 L

.03621 .04064 L

.03869 .04068 L

.04365 .04077 L

.05357 .04103 L

.06349 .04138 L

.08333 .04238 L

.10317 .04371 L

.14286 .04718 L

.18254 .0512 L

.22222 .05501 L

.24206 .0566 L

.2619 .05786 L

.27183 .05835 L

.27679 .05855 L

.28175 .05872 L

.28671 .05886 L

.29167 .05897 L

.29415 .05902 L

.29663 .05906 L

.29911 .05909 L

.30159 .05911 L

.30283 .05912 L

.30407 .05912 L

.30531 .05913 L

.30655 .05913 L

.30779 .05913 L

.30903 .05913 L

.31027 .05912 L

.31151 .05912 L

.31275 .05911 L

.31399 .0591 L

.31647 .05907 L

.31895 .05904 L

.32143 .05899 L

.32639 .05888 L

.33135 .05874 L

.34127 .05836 L

.35119 .05785 L

.36111 .05722 L

.38095 .05563 L

.42063 .05165 L

.44048 .04966 L

Mistroke

.4504 .04879 L

.46032 .04807 L

.46528 .04779 L

.47024 .04756 L

.47272 .04747 L

.4752 .0474 L

.47644 .04737 L

.47768 .04734 L

.47892 .04732 L

.48016 .0473 L

.4814 .04729 L

.48264 .04729 L

.48388 .04729 L

.48512 .04729 L

.48636 .0473 L

.4876 .04732 L

.49008 .04737 L

.49132 .0474 L

.49256 .04744 L

.49504 .04754 L

.5 .04781 L

.50496 .0482 L

.50992 .04871 L

.51984 .05013 L

.52976 .05214 L

.53968 .0548 L

.5496 .05819 L

.55952 .06237 L

.57937 .07334 L

.59921 .08809 L

.61905 .10691 L

.65873 .15694 L

.69841 .22226 L

.7381 .3009 L

.77778 .3943 L

.81746 .50423 L

.82738 .53184 L

.8373 .5573 L

.84722 .5788 L

.85218 .58746 L

.85714 .59441 L

.85962 .59719 L

.8621 .59946 L

.86334 .60041 L

.86458 .60123 L

.86582 .60191 L

.86706 .60246 L

.8683 .60288 L

.86954 .60316 L

.87078 .60331 L

Mistroke

.87202 .60332 L

.87326 .60319 L

.8745 .60293 L

.87574 .60254 L

.87698 .60201 L

.87822 .60134 L

.87946 .60055 L

.88194 .59857 L

.8869 .59311 L

.89187 .5858 L

.89683 .57684 L

.91667 .52928 L

.93651 .4735 L

.97619 .36805 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\ntimeoffall = FindRoot[(theta[t]/.sol)[[1]]== thetamin,{t,0.4}]\n"], "Input",\

  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[OutputFormData["\<\

{t -> 0.6853363209889384}




\
\>", "\<\

{t -> 0.685336}
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]]
},
FrontEndVersion->"NeXT 3.0",
ScreenRectangle->{{0, 1085}, {0, 864}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{520, 600},
WindowMargins->{{Automatic, 128}, {Automatic, 114}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]



(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1711, 51, 58, 1, 70, "Input"],
Cell[1772, 54, 66, 1, 70, "Input"],
Cell[1841, 57, 181, 3, 70, "Input"],
Cell[2025, 62, 290, 5, 70, "Input"],
Cell[2318, 69, 169, 3, 70, "Input"],
Cell[2490, 74, 276, 5, 70, "Input"],
Cell[2769, 81, 447, 10, 70, "Input"],
Cell[3219, 93, 320, 9, 70, "Input"],

Cell[CellGroupData[{
Cell[3562, 104, 97, 1, 70, "Input"],
Cell[3662, 107, 4973, 903, 70, 4825, 898, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8667, 1012, 222, 6, 70, "Input"],
Cell[8892, 1020, 5296, 905, 70, 5148, 900, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14220, 1927, 219, 6, 70, "Input"],
Cell[14442, 1935, 5702, 1023, 70, 5554, 1018, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20176, 2960, 222, 6, 70, "Input"],
Cell[20401, 2968, 5068, 859, 70, 4920, 854, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[25501, 3829, 231, 7, 70, "Input"],
Cell[25735, 3838, 5119, 913, 70, 4971, 908, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30886, 4753, 288, 8, 70, "Input"],
Cell[31177, 4763, 6257, 1047, 70, 6109, 1042, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37466, 5812, 241, 8, 70, "Input"],
Cell[37710, 5822, 147, 14, 70, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)
