(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     81019,      12058]*)
(*NotebookOutlinePosition[     81873,      12090]*)
(*  CellTagsIndexPosition[     81829,      12086]*)
(*WindowFrame->Normal*)



Notebook[{


Cell[TextData["\nQuit\n"], "Input",
  PageWidth->Infinity],

Cell[TextData["\n<<highorde.h\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nxx[t_] := -l1 Cos[theta[t]] - \n\n\td Cos[theta[t]+alpha[t]]\n\nyy[t_] := \
-l1 Sin[theta[t]] - \n\n\td Sin[theta[t]+alpha[t]]\n\nydrag[t_] := -h\n\n\
alphadrag[t_] := ArcSin[(h-l1 Sin[theta[t]])/d] -\n\n\t theta[t]\n\n\
alphadrag[t_] := Pi - ArcSin[(h-l1 Sin[theta[t]])/d] -\n\n\t theta[t]\n\n\
xdrag[t_] := -l1 Cos[theta[t]] - \n\n\td Cos[theta[t]+alphadrag[t]]\n"], 
  "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nnde1 := l1 Tension[t] Sin[alpha[t]] - \n\n\tm2 g l2 Cos[theta[t]] == \n\n\t\
m2 l2^2 theta''[t]\n\nnde2 := Tension[t] Sin[theta[t]+alpha[t]] - \n\n\tm1 g \
== m1 yy''[t]\n\nnde3 := Tension[t] Cos[theta[t]+alpha[t]] == \n\n\tm1 \
xx''[t]\n\nde1 := l1 Tension[t] Sin[alphadrag[t]] - \n\n\tm2 g l2 \
Cos[theta[t]] == \n\n\tm2 l2^2 theta''[t]\n\nde2 := Tension[t] \
Sin[theta[t]+alphadrag[t]] - \n\n\tm1 g + n1 == 0\n\nde3 := Tension[t] \
Cos[theta[t]+alphadrag[t]] == \n\n\tm1 xdrag''[t]\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nm1 =.;l1 =.;m2 =.;l2 =.;g =.;d =.;h=.;\n\nderivsnd = \
Solve[{nde1,nde2,nde3},\n\n\t{Tension[t],alpha''[t],theta''[t]}];\n\n\
derivsdrag = Solve[{de1,de2,de3},\n\n\t{Tension[t],theta''[t],n1}];\n"], 
  "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nm1 = 1; l1 = 10;\n\nm2 = 500; l2 = 1;\n\ng = 9.81;\n\nd = 5;\n\nthetanot = \
45 Degree;\n\nthetamin = -45 Degree;\n\nthetadotnot = 0 Degree;\n\nh = l1 \
Sin[thetanot];\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nDragMaxTime = 1;\n\ndrageqns = {theta[0]==thetanot,\n\n   \
theta'[0]==thetadotnot,\n\n   theta''[t] == (theta''[t]/.derivsdrag)[[1]]};\n\
\nfirstdrageqns = \n\n   SecondToFirstOrder[drageqns,theta,t];\n"], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{Cell[TextData[
"\ndragsol = (NDSolve[firstdrageqns,\n\n\t{theta[t],thetadot[t]},\n\n\t\
{t,0,DragMaxTime}])/.thetadot->theta';\n\nenddraginttime = \
(theta[t]/.dragsol)[[1,0]][[1,2]];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[TextData[
"\nnormal[time_] := Module[{dragsolattime},\n\n   dragsolattime = \
(dragsol/.t->time)[[1]];\n\n   \
((((n1/.derivsdrag)/.t->time)//N)/.dragsolattime)\n\n      [[1]]\n\n   ]\n"], 
  "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[CellGroupData[{Cell[TextData[
"\nnval = Interpolation[Table[{t,normal[t]},\n\n   \
{t,0,enddraginttime,.02}]];\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

Can't Format Cell




\
\>", "\<\

InterpolatingFunction::dmwarn: 

   Warning: Input value lies outside domain of the interpolating function.
\
\>"], "Message",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

Can't Format Cell




\
\>", "\<\

InterpolatingFunction::dmwarn: 

   Warning: Input value lies outside domain of the interpolating function.
\
\>"], "Message",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]],

Cell[CellGroupData[{Cell[TextData["\nnplot = Plot[nval[t],{t,0,enddraginttime}];\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.60142 0.000193566 [

[(0.2)] .21429 .60142 0 2 Msboxa

[(0.4)] .40476 .60142 0 2 Msboxa

[(0.6)] .59524 .60142 0 2 Msboxa

[(0.8)] .78571 .60142 0 2 Msboxa

[(1)] .97619 .60142 0 2 Msboxa

[(-3000)] .01131 .02072 1 0 Msboxa

[(-2500)] .01131 .1175 1 0 Msboxa

[(-2000)] .01131 .21429 1 0 Msboxa

[(-1500)] .01131 .31107 1 0 Msboxa

[(-1000)] .01131 .40785 1 0 Msboxa

[(-500)] .01131 .50464 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .60142 m

.21429 .60767 L

s

P

[(0.2)] .21429 .60142 0 2 Mshowa

p

.002 w

.40476 .60142 m

.40476 .60767 L

s

P

[(0.4)] .40476 .60142 0 2 Mshowa

p

.002 w

.59524 .60142 m

.59524 .60767 L

s

P

[(0.6)] .59524 .60142 0 2 Mshowa

p

.002 w

.78571 .60142 m

.78571 .60767 L

s

P

[(0.8)] .78571 .60142 0 2 Mshowa

p

.002 w

.97619 .60142 m

.97619 .60767 L

s

P

[(1)] .97619 .60142 0 2 Mshowa

p

.001 w

.0619 .60142 m

.0619 .60517 L

s

P

p

.001 w

.1 .60142 m

.1 .60517 L

s

P

p

.001 w

.1381 .60142 m

.1381 .60517 L

s

P

p

.001 w

.17619 .60142 m

.17619 .60517 L

s

P

p

.001 w

.25238 .60142 m

.25238 .60517 L

s

P

p

.001 w

.29048 .60142 m

.29048 .60517 L

s

P

p

.001 w

.32857 .60142 m

.32857 .60517 L

s

P

p

.001 w

.36667 .60142 m

.36667 .60517 L

s

P

p

.001 w

.44286 .60142 m

.44286 .60517 L

s

P

p

.001 w

.48095 .60142 m

.48095 .60517 L

s

P

p

.001 w

.51905 .60142 m

.51905 .60517 L

s

P

p

.001 w

.55714 .60142 m

.55714 .60517 L

s

P

p

.001 w

.63333 .60142 m

.63333 .60517 L

s

P

p

.001 w

.67143 .60142 m

.67143 .60517 L

s

P

p

.001 w

.70952 .60142 m

.70952 .60517 L

s

P

p

.001 w

.74762 .60142 m

.74762 .60517 L

s

P

p

.001 w

.82381 .60142 m

.82381 .60517 L

s

P

p

.001 w

.8619 .60142 m

.8619 .60517 L

s

P

p

.001 w

.9 .60142 m

.9 .60517 L

s

P

p

.001 w

.9381 .60142 m

.9381 .60517 L

s

P

p

.002 w

0 .60142 m

1 .60142 L

s

P

p

.002 w

.02381 .02072 m

.03006 .02072 L

s

P

[(-3000)] .01131 .02072 1 0 Mshowa

p

.002 w

.02381 .1175 m

.03006 .1175 L

s

P

[(-2500)] .01131 .1175 1 0 Mshowa

p

.002 w

.02381 .21429 m

.03006 .21429 L

s

P

[(-2000)] .01131 .21429 1 0 Mshowa

p

.002 w

.02381 .31107 m

.03006 .31107 L

s

P

[(-1500)] .01131 .31107 1 0 Mshowa

p

.002 w

.02381 .40785 m

.03006 .40785 L

s

P

[(-1000)] .01131 .40785 1 0 Mshowa

p

.002 w

.02381 .50464 m

.03006 .50464 L

s

P

[(-500)] .01131 .50464 1 0 Mshowa

p

.001 w

.02381 .04008 m

.02756 .04008 L

s

P

p

.001 w

.02381 .05943 m

.02756 .05943 L

s

P

p

.001 w

.02381 .07879 m

.02756 .07879 L

s

P

p

.001 w

.02381 .09815 m

.02756 .09815 L

s

P

p

.001 w

.02381 .13686 m

.02756 .13686 L

s

P

p

.001 w

.02381 .15622 m

.02756 .15622 L

s

P

p

.001 w

.02381 .17557 m

.02756 .17557 L

s

P

p

.001 w

.02381 .19493 m

.02756 .19493 L

s

P

p

.001 w

.02381 .23364 m

.02756 .23364 L

s

P

p

.001 w

.02381 .253 m

.02756 .253 L

s

P

p

.001 w

.02381 .27236 m

.02756 .27236 L

s

P

p

.001 w

.02381 .29171 m

.02756 .29171 L

s

P

p

.001 w

.02381 .33043 m

.02756 .33043 L

s

P

p

.001 w

.02381 .34978 m

.02756 .34978 L

s

P

p

.001 w

.02381 .36914 m

.02756 .36914 L

s

P

p

.001 w

.02381 .3885 m

.02756 .3885 L

s

P

p

.001 w

.02381 .42721 m

.02756 .42721 L

s

P

p

.001 w

.02381 .44657 m

.02756 .44657 L

s

P

p

.001 w

.02381 .46592 m

.02756 .46592 L

s

P

p

.001 w

.02381 .48528 m

.02756 .48528 L

s

P

p

.001 w

.02381 .52399 m

.02756 .52399 L

s

P

p

.001 w

.02381 .54335 m

.02756 .54335 L

s

P

p

.001 w

.02381 .56271 m

.02756 .56271 L

s

P

p

.001 w

.02381 .58206 m

.02756 .58206 L

s

P

p

.001 w

.02381 .00136 m

.02756 .00136 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .60332 m

.02505 .60332 L

.02629 .60332 L

.02753 .60332 L

.02877 .60332 L

.03001 .60332 L

.03125 .60332 L

.03373 .60331 L

.03621 .60331 L

.03869 .60331 L

.04365 .6033 L

.04861 .60329 L

.05357 .60328 L

.06349 .60325 L

.07341 .60321 L

.08333 .60316 L

.10317 .60303 L

.12302 .60286 L

.14286 .60262 L

.1627 .60231 L

.18254 .6019 L

.20238 .60134 L

.22222 .6006 L

.23214 .60012 L

.24206 .59956 L

.2619 .59808 L

.27183 .5971 L

.28175 .59592 L

.30159 .59262 L

.31151 .5903 L

.32143 .58735 L

.33135 .58351 L

.34127 .57845 L

.35119 .57164 L

.36111 .56221 L

.36607 .55589 L

.37103 .54904 L

.37599 .54042 L

.38095 .52934 L

.38591 .51532 L

.39087 .50054 L

.39583 .48014 L

.40079 .45222 L

.40575 .41518 L

.41071 .36783 L

.41567 .30648 L

.42063 .2286 L

.42188 .20624 L

.42312 .18266 L

.4256 .11106 L

Mistroke

Mfstroke

.4289 0 m

.4256 .11106 L

s

s

s

s

s

s

s

s

s

s

s

s

.46513 0 m

.47024 .11717 L

s

.47024 .11717 m

.4752 .22408 L

.48016 .32055 L

.48264 .35557 L

.48512 .38299 L

.49008 .42698 L

.49504 .45901 L

.5 .48201 L

.50496 .50335 L

.50992 .51964 L

.51488 .53193 L

.51984 .54149 L

.5248 .55037 L

.52976 .5575 L

.53968 .56801 L

.5496 .5759 L

.55952 .58152 L

.56944 .58585 L

.57937 .5891 L

.58929 .59167 L

.59921 .59367 L

.61905 .59658 L

.62897 .59764 L

.63889 .59851 L

.65873 .59984 L

.67857 .60078 L

.69841 .60146 L

.71825 .60197 L

.7381 .60235 L

.75794 .60264 L

.77778 .60285 L

.79762 .60301 L

.81746 .60313 L

.82738 .60317 L

.8373 .6032 L

.84226 .60321 L

.84722 .60322 L

.85218 .60323 L

.85714 .60324 L

.85962 .60324 L

.8621 .60324 L

.86334 .60324 L

.86458 .60324 L

.86582 .60324 L

.86706 .60324 L

.8683 .60324 L

.86954 .60324 L

.87078 .60324 L

.87202 .60324 L

.87326 .60324 L

Mistroke

.8745 .60324 L

.87698 .60324 L

.87946 .60324 L

.88194 .60324 L

.8869 .60323 L

.89187 .60322 L

.89683 .60321 L

.90675 .60318 L

.91667 .60314 L

.93651 .60303 L

.95635 .60288 L

.97619 .60267 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nthplot = Plot[(theta[t]/.dragsol)/Degree,\n\n   {t,0,enddraginttime}];\n"],
   "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 -0.198198 0.0178115 [

[(0.2)] .21429 .06897 0 2 Msboxa

[(0.4)] .40476 .06897 0 2 Msboxa

[(0.6)] .59524 .06897 0 2 Msboxa

[(0.8)] .78571 .06897 0 2 Msboxa

[(1)] .97619 .06897 0 2 Msboxa

[(20)] .01131 .15803 1 0 Msboxa

[(25)] .01131 .24709 1 0 Msboxa

[(30)] .01131 .33615 1 0 Msboxa

[(35)] .01131 .4252 1 0 Msboxa

[(40)] .01131 .51426 1 0 Msboxa

[(45)] .01131 .60332 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .06897 m

.21429 .07522 L

s

P

[(0.2)] .21429 .06897 0 2 Mshowa

p

.002 w

.40476 .06897 m

.40476 .07522 L

s

P

[(0.4)] .40476 .06897 0 2 Mshowa

p

.002 w

.59524 .06897 m

.59524 .07522 L

s

P

[(0.6)] .59524 .06897 0 2 Mshowa

p

.002 w

.78571 .06897 m

.78571 .07522 L

s

P

[(0.8)] .78571 .06897 0 2 Mshowa

p

.002 w

.97619 .06897 m

.97619 .07522 L

s

P

[(1)] .97619 .06897 0 2 Mshowa

p

.001 w

.0619 .06897 m

.0619 .07272 L

s

P

p

.001 w

.1 .06897 m

.1 .07272 L

s

P

p

.001 w

.1381 .06897 m

.1381 .07272 L

s

P

p

.001 w

.17619 .06897 m

.17619 .07272 L

s

P

p

.001 w

.25238 .06897 m

.25238 .07272 L

s

P

p

.001 w

.29048 .06897 m

.29048 .07272 L

s

P

p

.001 w

.32857 .06897 m

.32857 .07272 L

s

P

p

.001 w

.36667 .06897 m

.36667 .07272 L

s

P

p

.001 w

.44286 .06897 m

.44286 .07272 L

s

P

p

.001 w

.48095 .06897 m

.48095 .07272 L

s

P

p

.001 w

.51905 .06897 m

.51905 .07272 L

s

P

p

.001 w

.55714 .06897 m

.55714 .07272 L

s

P

p

.001 w

.63333 .06897 m

.63333 .07272 L

s

P

p

.001 w

.67143 .06897 m

.67143 .07272 L

s

P

p

.001 w

.70952 .06897 m

.70952 .07272 L

s

P

p

.001 w

.74762 .06897 m

.74762 .07272 L

s

P

p

.001 w

.82381 .06897 m

.82381 .07272 L

s

P

p

.001 w

.8619 .06897 m

.8619 .07272 L

s

P

p

.001 w

.9 .06897 m

.9 .07272 L

s

P

p

.001 w

.9381 .06897 m

.9381 .07272 L

s

P

p

.002 w

0 .06897 m

1 .06897 L

s

P

p

.002 w

.02381 .15803 m

.03006 .15803 L

s

P

[(20)] .01131 .15803 1 0 Mshowa

p

.002 w

.02381 .24709 m

.03006 .24709 L

s

P

[(25)] .01131 .24709 1 0 Mshowa

p

.002 w

.02381 .33615 m

.03006 .33615 L

s

P

[(30)] .01131 .33615 1 0 Mshowa

p

.002 w

.02381 .4252 m

.03006 .4252 L

s

P

[(35)] .01131 .4252 1 0 Mshowa

p

.002 w

.02381 .51426 m

.03006 .51426 L

s

P

[(40)] .01131 .51426 1 0 Mshowa

p

.002 w

.02381 .60332 m

.03006 .60332 L

s

P

[(45)] .01131 .60332 1 0 Mshowa

p

.001 w

.02381 .08679 m

.02756 .08679 L

s

P

p

.001 w

.02381 .1046 m

.02756 .1046 L

s

P

p

.001 w

.02381 .12241 m

.02756 .12241 L

s

P

p

.001 w

.02381 .14022 m

.02756 .14022 L

s

P

p

.001 w

.02381 .17584 m

.02756 .17584 L

s

P

p

.001 w

.02381 .19365 m

.02756 .19365 L

s

P

p

.001 w

.02381 .21147 m

.02756 .21147 L

s

P

p

.001 w

.02381 .22928 m

.02756 .22928 L

s

P

p

.001 w

.02381 .2649 m

.02756 .2649 L

s

P

p

.001 w

.02381 .28271 m

.02756 .28271 L

s

P

p

.001 w

.02381 .30052 m

.02756 .30052 L

s

P

p

.001 w

.02381 .31834 m

.02756 .31834 L

s

P

p

.001 w

.02381 .35396 m

.02756 .35396 L

s

P

p

.001 w

.02381 .37177 m

.02756 .37177 L

s

P

p

.001 w

.02381 .38958 m

.02756 .38958 L

s

P

p

.001 w

.02381 .40739 m

.02756 .40739 L

s

P

p

.001 w

.02381 .44302 m

.02756 .44302 L

s

P

p

.001 w

.02381 .46083 m

.02756 .46083 L

s

P

p

.001 w

.02381 .47864 m

.02756 .47864 L

s

P

p

.001 w

.02381 .49645 m

.02756 .49645 L

s

P

p

.001 w

.02381 .53207 m

.02756 .53207 L

s

P

p

.001 w

.02381 .54988 m

.02756 .54988 L

s

P

p

.001 w

.02381 .5677 m

.02756 .5677 L

s

P

p

.001 w

.02381 .58551 m

.02756 .58551 L

s

P

p

.001 w

.02381 .05116 m

.02756 .05116 L

s

P

p

.001 w

.02381 .03335 m

.02756 .03335 L

s

P

p

.001 w

.02381 .01554 m

.02756 .01554 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .60332 m

.02505 .60331 L

.02629 .6033 L

.02753 .60327 L

.02877 .60323 L

.03001 .60318 L

.03125 .60312 L

.03373 .60297 L

.03621 .60277 L

.03869 .60253 L

.04365 .60192 L

.04861 .60114 L

.05357 .60017 L

.06349 .59773 L

.07341 .59458 L

.08333 .59073 L

.10317 .5809 L

.12302 .56824 L

.14286 .5527 L

.18254 .5129 L

.22222 .46124 L

.2619 .39751 L

.30159 .32174 L

.34127 .23461 L

.38095 .13887 L

.40079 .09049 L

.42063 .04634 L

.4256 .03697 L

.43056 .02875 L

.43552 .02206 L

.438 .01941 L

.44048 .0173 L

.44172 .01647 L

.44296 .01579 L

.4442 .01527 L

.44544 .01492 L

.44668 .01473 L

.44792 .01472 L

.44916 .01487 L

.4504 .0152 L

.45164 .01569 L

.45288 .01634 L

.45536 .01809 L

.45784 .02041 L

.46032 .02325 L

.47024 .03867 L

.48016 .0585 L

.5 .10435 L

.53968 .2008 L

.57937 .2909 L

Mistroke

.61905 .37023 L

.65873 .43764 L

.69841 .49293 L

.7381 .53625 L

.75794 .55349 L

.77778 .56784 L

.79762 .57932 L

.81746 .58794 L

.82738 .5912 L

.8373 .59374 L

.84226 .59475 L

.84722 .59558 L

.85218 .59624 L

.85714 .59672 L

.85962 .5969 L

.8621 .59703 L

.86334 .59708 L

.86458 .59711 L

.86582 .59714 L

.86706 .59716 L

.8683 .59716 L

.86954 .59716 L

.87078 .59714 L

.87202 .59711 L

.87326 .59707 L

.8745 .59702 L

.87698 .59689 L

.87946 .59672 L

.88194 .5965 L

.8869 .59592 L

.89187 .59518 L

.89683 .59425 L

.90675 .59188 L

.91667 .5888 L

.93651 .58051 L

.95635 .56938 L

.97619 .55538 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData["\nShow[{thplot,nplot}];\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.573414 0.000664557 [

[(0.2)] .21429 .57341 0 2 Msboxa

[(0.4)] .40476 .57341 0 2 Msboxa

[(0.6)] .59524 .57341 0 2 Msboxa

[(0.8)] .78571 .57341 0 2 Msboxa

[(1)] .97619 .57341 0 2 Msboxa

[(-800)] .01131 .04177 1 0 Msboxa

[(-600)] .01131 .17468 1 0 Msboxa

[(-400)] .01131 .30759 1 0 Msboxa

[(-200)] .01131 .4405 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .57341 m

.21429 .57966 L

s

P

[(0.2)] .21429 .57341 0 2 Mshowa

p

.002 w

.40476 .57341 m

.40476 .57966 L

s

P

[(0.4)] .40476 .57341 0 2 Mshowa

p

.002 w

.59524 .57341 m

.59524 .57966 L

s

P

[(0.6)] .59524 .57341 0 2 Mshowa

p

.002 w

.78571 .57341 m

.78571 .57966 L

s

P

[(0.8)] .78571 .57341 0 2 Mshowa

p

.002 w

.97619 .57341 m

.97619 .57966 L

s

P

[(1)] .97619 .57341 0 2 Mshowa

p

.001 w

.0619 .57341 m

.0619 .57716 L

s

P

p

.001 w

.1 .57341 m

.1 .57716 L

s

P

p

.001 w

.1381 .57341 m

.1381 .57716 L

s

P

p

.001 w

.17619 .57341 m

.17619 .57716 L

s

P

p

.001 w

.25238 .57341 m

.25238 .57716 L

s

P

p

.001 w

.29048 .57341 m

.29048 .57716 L

s

P

p

.001 w

.32857 .57341 m

.32857 .57716 L

s

P

p

.001 w

.36667 .57341 m

.36667 .57716 L

s

P

p

.001 w

.44286 .57341 m

.44286 .57716 L

s

P

p

.001 w

.48095 .57341 m

.48095 .57716 L

s

P

p

.001 w

.51905 .57341 m

.51905 .57716 L

s

P

p

.001 w

.55714 .57341 m

.55714 .57716 L

s

P

p

.001 w

.63333 .57341 m

.63333 .57716 L

s

P

p

.001 w

.67143 .57341 m

.67143 .57716 L

s

P

p

.001 w

.70952 .57341 m

.70952 .57716 L

s

P

p

.001 w

.74762 .57341 m

.74762 .57716 L

s

P

p

.001 w

.82381 .57341 m

.82381 .57716 L

s

P

p

.001 w

.8619 .57341 m

.8619 .57716 L

s

P

p

.001 w

.9 .57341 m

.9 .57716 L

s

P

p

.001 w

.9381 .57341 m

.9381 .57716 L

s

P

p

.002 w

0 .57341 m

1 .57341 L

s

P

p

.002 w

.02381 .04177 m

.03006 .04177 L

s

P

[(-800)] .01131 .04177 1 0 Mshowa

p

.002 w

.02381 .17468 m

.03006 .17468 L

s

P

[(-600)] .01131 .17468 1 0 Mshowa

p

.002 w

.02381 .30759 m

.03006 .30759 L

s

P

[(-400)] .01131 .30759 1 0 Mshowa

p

.002 w

.02381 .4405 m

.03006 .4405 L

s

P

[(-200)] .01131 .4405 1 0 Mshowa

p

.001 w

.02381 .06835 m

.02756 .06835 L

s

P

p

.001 w

.02381 .09493 m

.02756 .09493 L

s

P

p

.001 w

.02381 .12151 m

.02756 .12151 L

s

P

p

.001 w

.02381 .1481 m

.02756 .1481 L

s

P

p

.001 w

.02381 .20126 m

.02756 .20126 L

s

P

p

.001 w

.02381 .22784 m

.02756 .22784 L

s

P

p

.001 w

.02381 .25443 m

.02756 .25443 L

s

P

p

.001 w

.02381 .28101 m

.02756 .28101 L

s

P

p

.001 w

.02381 .33417 m

.02756 .33417 L

s

P

p

.001 w

.02381 .36076 m

.02756 .36076 L

s

P

p

.001 w

.02381 .38734 m

.02756 .38734 L

s

P

p

.001 w

.02381 .41392 m

.02756 .41392 L

s

P

p

.001 w

.02381 .46708 m

.02756 .46708 L

s

P

p

.001 w

.02381 .49367 m

.02756 .49367 L

s

P

p

.001 w

.02381 .52025 m

.02756 .52025 L

s

P

p

.001 w

.02381 .54683 m

.02756 .54683 L

s

P

p

.001 w

.02381 .01519 m

.02756 .01519 L

s

P

p

.001 w

.02381 .6 m

.02756 .6 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

p

.004 w

.02381 .60332 m

.02505 .60332 L

.02629 .60332 L

.02753 .60332 L

.02877 .60332 L

.03001 .60331 L

.03125 .60331 L

.03373 .60331 L

.03621 .6033 L

.03869 .60329 L

.04365 .60327 L

.04861 .60324 L

.05357 .6032 L

.06349 .60311 L

.07341 .60299 L

.08333 .60285 L

.10317 .60248 L

.12302 .60201 L

.14286 .60143 L

.18254 .59995 L

.22222 .59802 L

.2619 .59564 L

.30159 .59281 L

.34127 .58956 L

.38095 .58599 L

.40079 .58418 L

.42063 .58254 L

.4256 .58219 L

.43056 .58188 L

.43552 .58163 L

.438 .58153 L

.44048 .58145 L

.44172 .58142 L

.44296 .5814 L

.4442 .58138 L

.44544 .58137 L

.44668 .58136 L

.44792 .58136 L

.44916 .58136 L

.4504 .58138 L

.45164 .58139 L

.45288 .58142 L

.45536 .58148 L

.45784 .58157 L

.46032 .58168 L

.47024 .58225 L

.48016 .58299 L

.5 .5847 L

.53968 .5883 L

.57937 .59166 L

Mistroke

.61905 .59462 L

.65873 .59714 L

.69841 .5992 L

.7381 .60082 L

.75794 .60146 L

.77778 .602 L

.79762 .60242 L

.81746 .60275 L

.82738 .60287 L

.8373 .60296 L

.84226 .603 L

.84722 .60303 L

.85218 .60305 L

.85714 .60307 L

.85962 .60308 L

.8621 .60308 L

.86334 .60309 L

.86458 .60309 L

.86582 .60309 L

.86706 .60309 L

.8683 .60309 L

.86954 .60309 L

.87078 .60309 L

.87202 .60309 L

.87326 .60309 L

.8745 .60308 L

.87698 .60308 L

.87946 .60307 L

.88194 .60306 L

.8869 .60304 L

.89187 .60302 L

.89683 .60298 L

.90675 .60289 L

.91667 .60278 L

.93651 .60247 L

.95635 .60205 L

.97619 .60153 L

Mfstroke

P

P

p

p

.004 w

.02381 .57993 m

.02505 .57993 L

.02629 .57993 L

.02753 .57993 L

.02877 .57993 L

.03001 .57993 L

.03125 .57992 L

.03373 .57992 L

.03621 .57991 L

.03869 .5799 L

.04365 .57988 L

.04861 .57984 L

.05357 .5798 L

.06349 .5797 L

.07341 .57957 L

.08333 .5794 L

.10317 .57896 L

.12302 .57835 L

.14286 .57754 L

.1627 .57646 L

.18254 .57505 L

.20238 .57315 L

.22222 .57059 L

.23214 .56895 L

.24206 .56703 L

.2619 .56196 L

.27183 .55859 L

.28175 .55452 L

.30159 .54319 L

.31151 .53522 L

.32143 .52512 L

.33135 .51191 L

.34127 .49456 L

.35119 .47116 L

.36111 .4388 L

.36607 .41712 L

.37103 .39358 L

.37599 .36399 L

.38095 .32593 L

.38591 .27782 L

.39087 .22706 L

.39583 .15704 L

.40079 .06119 L

s

.40318 0 m

.40079 .06119 L

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

s

.49123 0 m

.49504 .08448 L

s

.49504 .08448 m

.5 .16346 L

.50496 .23672 L

.50992 .29266 L

.51488 .33482 L

.51984 .36767 L

.5248 .39815 L

.52976 .42264 L

.53968 .45871 L

.5496 .4858 L

.55952 .5051 L

.56944 .51995 L

.57937 .53113 L

.58929 .53993 L

.59921 .54681 L

.61905 .55679 L

.62897 .56042 L

.63889 .56342 L

.65873 .56798 L

.67857 .57121 L

.69841 .57356 L

.71825 .5753 L

.7381 .57661 L

.75794 .57759 L

.77778 .57834 L

.79762 .57889 L

.81746 .57928 L

.82738 .57942 L

.8373 .57953 L

.84226 .57958 L

.84722 .57961 L

.85218 .57964 L

.85714 .57966 L

.85962 .57967 L

.8621 .57967 L

.86334 .57967 L

.86458 .57968 L

.86582 .57968 L

.86706 .57968 L

.8683 .57968 L

.86954 .57968 L

.87078 .57968 L

.87202 .57968 L

.87326 .57967 L

.8745 .57967 L

.87698 .57967 L

.87946 .57966 L

.88194 .57965 L

.8869 .57963 L

.89187 .57959 L

Mistroke

.89683 .57955 L

.90675 .57945 L

.91667 .57932 L

.93651 .57894 L

.95635 .57841 L

.97619 .57769 L

Mfstroke

P

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[(theta'[t]/.dragsol)/Degree,{t,0,enddraginttime}];\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 1.23344 0.309844 0.0022402 [

[(0.2)] .2705 .30984 0 2 Msboxa

[(0.4)] .51718 .30984 0 2 Msboxa

[(0.6)] .76387 .30984 0 2 Msboxa

[(-100)] .01131 .08582 1 0 Msboxa

[(-50)] .01131 .19783 1 0 Msboxa

[(50)] .01131 .42185 1 0 Msboxa

[(100)] .01131 .53386 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.2705 .30984 m

.2705 .31609 L

s

P

[(0.2)] .2705 .30984 0 2 Mshowa

p

.002 w

.51718 .30984 m

.51718 .31609 L

s

P

[(0.4)] .51718 .30984 0 2 Mshowa

p

.002 w

.76387 .30984 m

.76387 .31609 L

s

P

[(0.6)] .76387 .30984 0 2 Mshowa

p

.001 w

.07315 .30984 m

.07315 .31359 L

s

P

p

.001 w

.12248 .30984 m

.12248 .31359 L

s

P

p

.001 w

.17182 .30984 m

.17182 .31359 L

s

P

p

.001 w

.22116 .30984 m

.22116 .31359 L

s

P

p

.001 w

.31983 .30984 m

.31983 .31359 L

s

P

p

.001 w

.36917 .30984 m

.36917 .31359 L

s

P

p

.001 w

.41851 .30984 m

.41851 .31359 L

s

P

p

.001 w

.46785 .30984 m

.46785 .31359 L

s

P

p

.001 w

.56652 .30984 m

.56652 .31359 L

s

P

p

.001 w

.61586 .30984 m

.61586 .31359 L

s

P

p

.001 w

.6652 .30984 m

.6652 .31359 L

s

P

p

.001 w

.71453 .30984 m

.71453 .31359 L

s

P

p

.001 w

.81321 .30984 m

.81321 .31359 L

s

P

p

.001 w

.86255 .30984 m

.86255 .31359 L

s

P

p

.001 w

.91188 .30984 m

.91188 .31359 L

s

P

p

.001 w

.96122 .30984 m

.96122 .31359 L

s

P

p

.002 w

0 .30984 m

1 .30984 L

s

P

p

.002 w

.02381 .08582 m

.03006 .08582 L

s

P

[(-100)] .01131 .08582 1 0 Mshowa

p

.002 w

.02381 .19783 m

.03006 .19783 L

s

P

[(-50)] .01131 .19783 1 0 Mshowa

p

.002 w

.02381 .42185 m

.03006 .42185 L

s

P

[(50)] .01131 .42185 1 0 Mshowa

p

.002 w

.02381 .53386 m

.03006 .53386 L

s

P

[(100)] .01131 .53386 1 0 Mshowa

p

.001 w

.02381 .10823 m

.02756 .10823 L

s

P

p

.001 w

.02381 .13063 m

.02756 .13063 L

s

P

p

.001 w

.02381 .15303 m

.02756 .15303 L

s

P

p

.001 w

.02381 .17543 m

.02756 .17543 L

s

P

p

.001 w

.02381 .22024 m

.02756 .22024 L

s

P

p

.001 w

.02381 .24264 m

.02756 .24264 L

s

P

p

.001 w

.02381 .26504 m

.02756 .26504 L

s

P

p

.001 w

.02381 .28744 m

.02756 .28744 L

s

P

p

.001 w

.02381 .33225 m

.02756 .33225 L

s

P

p

.001 w

.02381 .35465 m

.02756 .35465 L

s

P

p

.001 w

.02381 .37705 m

.02756 .37705 L

s

P

p

.001 w

.02381 .39945 m

.02756 .39945 L

s

P

p

.001 w

.02381 .44426 m

.02756 .44426 L

s

P

p

.001 w

.02381 .46666 m

.02756 .46666 L

s

P

p

.001 w

.02381 .48906 m

.02756 .48906 L

s

P

p

.001 w

.02381 .51146 m

.02756 .51146 L

s

P

p

.001 w

.02381 .06342 m

.02756 .06342 L

s

P

p

.001 w

.02381 .04102 m

.02756 .04102 L

s

P

p

.001 w

.02381 .01862 m

.02756 .01862 L

s

P

p

.001 w

.02381 .55627 m

.02756 .55627 L

s

P

p

.001 w

.02381 .57867 m

.02756 .57867 L

s

P

p

.001 w

.02381 .60107 m

.02756 .60107 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .30984 m

.0752 .27607 L

.1266 .24198 L

.17799 .20733 L

.22938 .17193 L

.28078 .13577 L

.33217 .0992 L

.38356 .06335 L

.40926 .04655 L

.43496 .03148 L

.4478 .02505 L

.45423 .02224 L

.46065 .01976 L

.46708 .01767 L

.47029 .0168 L

.4735 .01607 L

.47671 .01547 L

.47832 .01523 L

.47992 .01504 L

.48153 .01489 L

.48314 .01478 L

.48474 .01472 L

.48635 .01472 L

.48795 .01476 L

.48956 .01487 L

.49117 .01503 L

.49277 .01526 L

.49438 .01555 L

.49598 .01591 L

.4992 .01687 L

.50241 .01816 L

.50562 .01982 L

.51205 .02446 L

.51526 .02756 L

.51847 .03126 L

.52489 .04086 L

.53132 .05408 L

.53774 .07205 L

.54417 .09619 L

.55059 .12822 L

.55701 .16983 L

.56344 .222 L

.57629 .34926 L

.58914 .4583 L

.59556 .49756 L

.60198 .52765 L

.60841 .55028 L

.61483 .5671 L

.62126 .57946 L

.62768 .5884 L

Mistroke

.63089 .59184 L

.6341 .5947 L

.64053 .59895 L

.64374 .60045 L

.64695 .6016 L

.64856 .60205 L

.65016 .60243 L

.65177 .60273 L

.65338 .60297 L

.65498 .60314 L

.65659 .60326 L

.65819 .60332 L

.6598 .60332 L

.66141 .60327 L

.66301 .60317 L

.66623 .60284 L

.66783 .60261 L

.66944 .60234 L

.67265 .60169 L

.67907 .59998 L

.69192 .59525 L

.71762 .58229 L

.74331 .56658 L

.79471 .53154 L

.8461 .49499 L

.89749 .45856 L

.94889 .42279 L

Mfstroke

1 .38796 m

.94889 .42279 L

s

s

s

s

s

s

s

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]]}, Open]]}, Open]],

Cell[CellGroupData[{Cell[TextData["\nliftoff = FindRoot[nval[t] == 0,{t,0.2}]\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

{t -> 0.1849866548238114}




\
\>", "\<\

{t -> 0.184987}
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]],

Cell[CellGroupData[{Cell[TextData["\nthliftoff = (dragsol/.liftoff)[[1]]\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

{theta[0.1849866548238114] -> 0.6759842876441738, 

  Derivative[1][theta][0.1849866548238114] -> -1.197731367599528}




\
\>", "\<\

{theta[0.184987] -> 0.675984, theta'[0.184987] -> -1.19773}
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]]}, Open]],

Cell[TextData[
"\nPlot[alphadrag[tau]/Degree/.theta[tau]->th Degree,\n\n   {th,45,25}];\n"], 
  "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{Cell[TextData[
"\nalphaliftoff = ({alpha[t/.liftoff] -> alphadrag[t/.liftoff],\n\n   \
alpha'[t/.liftoff] -> (alphadrag'[t]/.liftoff)}/.\n\n   thliftoff)//N\n"], 
  "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

{alpha[0.1849866548238114] -> 2.301996741323125, 

  Derivative[1][alpha][0.1849866548238114] -> -0.6962419007637849}




\
\>", "\<\

{alpha[0.184987] -> 2.302, alpha'[0.184987] -> -0.696242}
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]],

Cell[TextData[
"\nMaxTime = 5;\n\neqns = {theta[t/.liftoff]==(0.675984),\n\n        \
alpha[t/.liftoff]==(2.302),\n\n\ttheta'[t/.liftoff]==(-1.19773),\n\n        \
alpha'[t/.liftoff]==(-.696242),\n\n\ttheta''[t] == \
(theta''[t]/.derivsnd)[[1]],\n\n\talpha''[t] == (alpha''[t]/.derivsnd)[[1]]};\
\n\nfirsteqns = SecondToFirstOrder[eqns,{theta,alpha},t];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[TextData[
"\nsol = NDSolve[firsteqns,\n\n\t{theta[t],alpha[t],thetadot[t],alphadot[t]},\
\n\n\t{t,t/.liftoff,MaxTime}];\n\nendtime = (theta[t]/.sol)[[1,0]][[1,2]];\n\
"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[CellGroupData[{Cell[TextData[
"\nthplot =\n\nPlot[(theta[t]/.sol)/Degree,{t,t/.liftoff,endtime}];\n"], 
  "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.190476 0.509476 0.00225107 [

[(1)] .21429 .50948 0 2 Msboxa

[(2)] .40476 .50948 0 2 Msboxa

[(3)] .59524 .50948 0 2 Msboxa

[(4)] .78571 .50948 0 2 Msboxa

[(5)] .97619 .50948 0 2 Msboxa

[(-200)] .01131 .05926 1 0 Msboxa

[(-150)] .01131 .17181 1 0 Msboxa

[(-100)] .01131 .28437 1 0 Msboxa

[(-50)] .01131 .39692 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .50948 m

.21429 .51573 L

s

P

[(1)] .21429 .50948 0 2 Mshowa

p

.002 w

.40476 .50948 m

.40476 .51573 L

s

P

[(2)] .40476 .50948 0 2 Mshowa

p

.002 w

.59524 .50948 m

.59524 .51573 L

s

P

[(3)] .59524 .50948 0 2 Mshowa

p

.002 w

.78571 .50948 m

.78571 .51573 L

s

P

[(4)] .78571 .50948 0 2 Mshowa

p

.002 w

.97619 .50948 m

.97619 .51573 L

s

P

[(5)] .97619 .50948 0 2 Mshowa

p

.001 w

.0619 .50948 m

.0619 .51323 L

s

P

p

.001 w

.1 .50948 m

.1 .51323 L

s

P

p

.001 w

.1381 .50948 m

.1381 .51323 L

s

P

p

.001 w

.17619 .50948 m

.17619 .51323 L

s

P

p

.001 w

.25238 .50948 m

.25238 .51323 L

s

P

p

.001 w

.29048 .50948 m

.29048 .51323 L

s

P

p

.001 w

.32857 .50948 m

.32857 .51323 L

s

P

p

.001 w

.36667 .50948 m

.36667 .51323 L

s

P

p

.001 w

.44286 .50948 m

.44286 .51323 L

s

P

p

.001 w

.48095 .50948 m

.48095 .51323 L

s

P

p

.001 w

.51905 .50948 m

.51905 .51323 L

s

P

p

.001 w

.55714 .50948 m

.55714 .51323 L

s

P

p

.001 w

.63333 .50948 m

.63333 .51323 L

s

P

p

.001 w

.67143 .50948 m

.67143 .51323 L

s

P

p

.001 w

.70952 .50948 m

.70952 .51323 L

s

P

p

.001 w

.74762 .50948 m

.74762 .51323 L

s

P

p

.001 w

.82381 .50948 m

.82381 .51323 L

s

P

p

.001 w

.8619 .50948 m

.8619 .51323 L

s

P

p

.001 w

.9 .50948 m

.9 .51323 L

s

P

p

.001 w

.9381 .50948 m

.9381 .51323 L

s

P

p

.002 w

0 .50948 m

1 .50948 L

s

P

p

.002 w

.02381 .05926 m

.03006 .05926 L

s

P

[(-200)] .01131 .05926 1 0 Mshowa

p

.002 w

.02381 .17181 m

.03006 .17181 L

s

P

[(-150)] .01131 .17181 1 0 Mshowa

p

.002 w

.02381 .28437 m

.03006 .28437 L

s

P

[(-100)] .01131 .28437 1 0 Mshowa

p

.002 w

.02381 .39692 m

.03006 .39692 L

s

P

[(-50)] .01131 .39692 1 0 Mshowa

p

.001 w

.02381 .08177 m

.02756 .08177 L

s

P

p

.001 w

.02381 .10428 m

.02756 .10428 L

s

P

p

.001 w

.02381 .12679 m

.02756 .12679 L

s

P

p

.001 w

.02381 .1493 m

.02756 .1493 L

s

P

p

.001 w

.02381 .19433 m

.02756 .19433 L

s

P

p

.001 w

.02381 .21684 m

.02756 .21684 L

s

P

p

.001 w

.02381 .23935 m

.02756 .23935 L

s

P

p

.001 w

.02381 .26186 m

.02756 .26186 L

s

P

p

.001 w

.02381 .30688 m

.02756 .30688 L

s

P

p

.001 w

.02381 .32939 m

.02756 .32939 L

s

P

p

.001 w

.02381 .3519 m

.02756 .3519 L

s

P

p

.001 w

.02381 .37441 m

.02756 .37441 L

s

P

p

.001 w

.02381 .41943 m

.02756 .41943 L

s

P

p

.001 w

.02381 .44194 m

.02756 .44194 L

s

P

p

.001 w

.02381 .46445 m

.02756 .46445 L

s

P

p

.001 w

.02381 .48697 m

.02756 .48697 L

s

P

p

.001 w

.02381 .53199 m

.02756 .53199 L

s

P

p

.001 w

.02381 .5545 m

.02756 .5545 L

s

P

p

.001 w

.02381 .57701 m

.02756 .57701 L

s

P

p

.001 w

.02381 .59952 m

.02756 .59952 L

s

P

p

.001 w

.02381 .03675 m

.02756 .03675 L

s

P

p

.001 w

.02381 .01424 m

.02756 .01424 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.05905 .59666 m

.0686 .58781 L

.07815 .57672 L

.09726 .54782 L

.13547 .46868 L

.17369 .3798 L

.2119 .26491 L

.23101 .20354 L

.25012 .14827 L

.26922 .10341 L

.27878 .08539 L

.28833 .07023 L

.29789 .05768 L

.30744 .04737 L

.31699 .03889 L

.32655 .03187 L

.3361 .02605 L

.34565 .02133 L

.35043 .01939 L

.35521 .01774 L

.35998 .01642 L

.36237 .01588 L

.36476 .01545 L

.36595 .01526 L

.36715 .0151 L

.36834 .01497 L

.36954 .01487 L

.37073 .01479 L

.37193 .01474 L

.37312 .01472 L

.37431 .01472 L

.37551 .01476 L

.3767 .01483 L

.3779 .01492 L

.37909 .01505 L

.38148 .01541 L

.38387 .01591 L

.38626 .01654 L

.38864 .01732 L

.39342 .01932 L

.3982 .02195 L

.40297 .02521 L

.41253 .0337 L

.42208 .04484 L

.44119 .07507 L

.4603 .11564 L

.4794 .16602 L

.51762 .2984 L

.55583 .42804 L

.57494 .48378 L

Mistroke

.59405 .52933 L

.6036 .54789 L

.61315 .56363 L

.62271 .57663 L

.63226 .58695 L

.63704 .59113 L

.64181 .59467 L

.64659 .59758 L

.65137 .59988 L

.65376 .6008 L

.65614 .60158 L

.65853 .60221 L

.66092 .60269 L

.66212 .60288 L

.66331 .60304 L

.6645 .60316 L

.6657 .60324 L

.66689 .6033 L

.66809 .60332 L

.66928 .60331 L

.67048 .60326 L

.67167 .60319 L

.67286 .60308 L

.67525 .60277 L

.67764 .60234 L

.68003 .6018 L

.68481 .60037 L

.68958 .59853 L

.69914 .59367 L

.70869 .58742 L

.7278 .57108 L

.7469 .54935 L

.76601 .52044 L

.78512 .48189 L

.82333 .37486 L

.86155 .25441 L

.89976 .15789 L

.91887 .11656 L

.93798 .0794 L

.97619 .02541 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[(thetadot[t]/.sol)/Degree,{t,t/.liftoff,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.190476 0.287847 0.000988061 [

[(1)] .21429 .28785 0 2 Msboxa

[(2)] .40476 .28785 0 2 Msboxa

[(3)] .59524 .28785 0 2 Msboxa

[(4)] .78571 .28785 0 2 Msboxa

[(5)] .97619 .28785 0 2 Msboxa

[(-200)] .01131 .09024 1 0 Msboxa

[(-100)] .01131 .18904 1 0 Msboxa

[(100)] .01131 .38665 1 0 Msboxa

[(200)] .01131 .48546 1 0 Msboxa

[(300)] .01131 .58427 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .28785 m

.21429 .2941 L

s

P

[(1)] .21429 .28785 0 2 Mshowa

p

.002 w

.40476 .28785 m

.40476 .2941 L

s

P

[(2)] .40476 .28785 0 2 Mshowa

p

.002 w

.59524 .28785 m

.59524 .2941 L

s

P

[(3)] .59524 .28785 0 2 Mshowa

p

.002 w

.78571 .28785 m

.78571 .2941 L

s

P

[(4)] .78571 .28785 0 2 Mshowa

p

.002 w

.97619 .28785 m

.97619 .2941 L

s

P

[(5)] .97619 .28785 0 2 Mshowa

p

.001 w

.0619 .28785 m

.0619 .2916 L

s

P

p

.001 w

.1 .28785 m

.1 .2916 L

s

P

p

.001 w

.1381 .28785 m

.1381 .2916 L

s

P

p

.001 w

.17619 .28785 m

.17619 .2916 L

s

P

p

.001 w

.25238 .28785 m

.25238 .2916 L

s

P

p

.001 w

.29048 .28785 m

.29048 .2916 L

s

P

p

.001 w

.32857 .28785 m

.32857 .2916 L

s

P

p

.001 w

.36667 .28785 m

.36667 .2916 L

s

P

p

.001 w

.44286 .28785 m

.44286 .2916 L

s

P

p

.001 w

.48095 .28785 m

.48095 .2916 L

s

P

p

.001 w

.51905 .28785 m

.51905 .2916 L

s

P

p

.001 w

.55714 .28785 m

.55714 .2916 L

s

P

p

.001 w

.63333 .28785 m

.63333 .2916 L

s

P

p

.001 w

.67143 .28785 m

.67143 .2916 L

s

P

p

.001 w

.70952 .28785 m

.70952 .2916 L

s

P

p

.001 w

.74762 .28785 m

.74762 .2916 L

s

P

p

.001 w

.82381 .28785 m

.82381 .2916 L

s

P

p

.001 w

.8619 .28785 m

.8619 .2916 L

s

P

p

.001 w

.9 .28785 m

.9 .2916 L

s

P

p

.001 w

.9381 .28785 m

.9381 .2916 L

s

P

p

.002 w

0 .28785 m

1 .28785 L

s

P

p

.002 w

.02381 .09024 m

.03006 .09024 L

s

P

[(-200)] .01131 .09024 1 0 Mshowa

p

.002 w

.02381 .18904 m

.03006 .18904 L

s

P

[(-100)] .01131 .18904 1 0 Mshowa

p

.002 w

.02381 .38665 m

.03006 .38665 L

s

P

[(100)] .01131 .38665 1 0 Mshowa

p

.002 w

.02381 .48546 m

.03006 .48546 L

s

P

[(200)] .01131 .48546 1 0 Mshowa

p

.002 w

.02381 .58427 m

.03006 .58427 L

s

P

[(300)] .01131 .58427 1 0 Mshowa

p

.001 w

.02381 .11 m

.02756 .11 L

s

P

p

.001 w

.02381 .12976 m

.02756 .12976 L

s

P

p

.001 w

.02381 .14952 m

.02756 .14952 L

s

P

p

.001 w

.02381 .16928 m

.02756 .16928 L

s

P

p

.001 w

.02381 .2088 m

.02756 .2088 L

s

P

p

.001 w

.02381 .22856 m

.02756 .22856 L

s

P

p

.001 w

.02381 .24832 m

.02756 .24832 L

s

P

p

.001 w

.02381 .26809 m

.02756 .26809 L

s

P

p

.001 w

.02381 .30761 m

.02756 .30761 L

s

P

p

.001 w

.02381 .32737 m

.02756 .32737 L

s

P

p

.001 w

.02381 .34713 m

.02756 .34713 L

s

P

p

.001 w

.02381 .36689 m

.02756 .36689 L

s

P

p

.001 w

.02381 .40641 m

.02756 .40641 L

s

P

p

.001 w

.02381 .42618 m

.02756 .42618 L

s

P

p

.001 w

.02381 .44594 m

.02756 .44594 L

s

P

p

.001 w

.02381 .4657 m

.02756 .4657 L

s

P

p

.001 w

.02381 .50522 m

.02756 .50522 L

s

P

p

.001 w

.02381 .52498 m

.02756 .52498 L

s

P

p

.001 w

.02381 .54474 m

.02756 .54474 L

s

P

p

.001 w

.02381 .5645 m

.02756 .5645 L

s

P

p

.001 w

.02381 .07047 m

.02756 .07047 L

s

P

p

.001 w

.02381 .05071 m

.02756 .05071 L

s

P

p

.001 w

.02381 .03095 m

.02756 .03095 L

s

P

p

.001 w

.02381 .01119 m

.02756 .01119 L

s

P

p

.001 w

.02381 .60403 m

.02756 .60403 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.05905 .22004 m

.07815 .1809 L

.09726 .14244 L

.10681 .1255 L

.11159 .11814 L

.11637 .11177 L

.12114 .10653 L

.12592 .10253 L

.12831 .10101 L

.1307 .09981 L

.13189 .09933 L

.13309 .09892 L

.13428 .09859 L

.13547 .09832 L

.13667 .09811 L

.13786 .09797 L

.13906 .09788 L

.14025 .09783 L

.14144 .09782 L

.14264 .09785 L

.14503 .09795 L

.14622 .09802 L

.14742 .09807 L

.14861 .09809 L

.1498 .09809 L

.151 .09803 L

.15219 .09791 L

.15339 .09772 L

.15458 .09744 L

.15578 .09705 L

.15697 .09655 L

.15816 .09591 L

.15936 .09514 L

.16175 .09314 L

.16413 .09051 L

.16891 .0833 L

.17369 .07388 L

.18324 .05196 L

.18802 .04141 L

.1928 .03217 L

.19757 .02471 L

.20235 .01927 L

.20474 .01735 L

.20593 .01658 L

.20713 .01595 L

.20832 .01545 L

.20951 .01508 L

.21071 .01483 L

.2119 .01472 L

.2131 .01472 L

Mistroke

.21429 .01485 L

.21549 .01511 L

.21668 .01548 L

.21907 .01657 L

.22146 .01812 L

.22384 .02012 L

.22623 .02253 L

.23101 .0286 L

.24056 .04522 L

.25012 .0667 L

.26922 .11725 L

.28833 .16705 L

.29789 .1884 L

.30744 .20622 L

.32655 .23195 L

.34565 .25134 L

.35521 .26176 L

.36476 .27418 L

.38387 .30756 L

.40297 .35062 L

.44119 .44311 L

.4794 .52996 L

.48896 .55562 L

.49373 .57067 L

.49851 .58605 L

.5009 .59289 L

.50329 .59837 L

.50448 .60042 L

.50568 .60194 L

.50687 .6029 L

.50806 .60332 L

.50926 .60321 L

.51045 .60264 L

.51165 .60167 L

.51284 .60037 L

.51523 .5971 L

.51762 .59339 L

.53672 .5714 L

.5415 .56734 L

.54628 .56265 L

.55583 .54995 L

.56539 .5324 L

.57494 .51103 L

.59405 .46264 L

.63226 .36667 L

.65137 .32276 L

.67048 .2836 L

.70869 .22738 L

.7278 .20528 L

.7469 .17885 L

Mistroke

.76601 .14185 L

.78512 .09571 L

.79467 .07232 L

.80423 .05104 L

.809 .04178 L

.81378 .03374 L

.81856 .02712 L

.82333 .02208 L

.82572 .02019 L

.82692 .01942 L

.82811 .01875 L

.8293 .0182 L

.8305 .01776 L

.83169 .01743 L

.83289 .01722 L

.83408 .01713 L

.83527 .01715 L

.83647 .01729 L

.83766 .01754 L

.83886 .01791 L

.84005 .01839 L

.84244 .0197 L

.84483 .02145 L

.84722 .02365 L

.85199 .02926 L

.86155 .04452 L

.8711 .06254 L

.88065 .07927 L

.88543 .0861 L

.89021 .09172 L

.89976 .10005 L

.90932 .10684 L

.91887 .11465 L

.92842 .12481 L

.93798 .13759 L

.97619 .20444 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nalphaplot = \n\nPlot[(alpha[t]/.sol)/Degree,{t,t/.liftoff,endtime}];\n"], 
  "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.190476 0.523568 0.000604654 [

[(1)] .21429 .52357 0 2 Msboxa

[(2)] .40476 .52357 0 2 Msboxa

[(3)] .59524 .52357 0 2 Msboxa

[(4)] .78571 .52357 0 2 Msboxa

[(5)] .97619 .52357 0 2 Msboxa

[(-800)] .01131 .03984 1 0 Msboxa

[(-600)] .01131 .16078 1 0 Msboxa

[(-400)] .01131 .28171 1 0 Msboxa

[(-200)] .01131 .40264 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .52357 m

.21429 .52982 L

s

P

[(1)] .21429 .52357 0 2 Mshowa

p

.002 w

.40476 .52357 m

.40476 .52982 L

s

P

[(2)] .40476 .52357 0 2 Mshowa

p

.002 w

.59524 .52357 m

.59524 .52982 L

s

P

[(3)] .59524 .52357 0 2 Mshowa

p

.002 w

.78571 .52357 m

.78571 .52982 L

s

P

[(4)] .78571 .52357 0 2 Mshowa

p

.002 w

.97619 .52357 m

.97619 .52982 L

s

P

[(5)] .97619 .52357 0 2 Mshowa

p

.001 w

.0619 .52357 m

.0619 .52732 L

s

P

p

.001 w

.1 .52357 m

.1 .52732 L

s

P

p

.001 w

.1381 .52357 m

.1381 .52732 L

s

P

p

.001 w

.17619 .52357 m

.17619 .52732 L

s

P

p

.001 w

.25238 .52357 m

.25238 .52732 L

s

P

p

.001 w

.29048 .52357 m

.29048 .52732 L

s

P

p

.001 w

.32857 .52357 m

.32857 .52732 L

s

P

p

.001 w

.36667 .52357 m

.36667 .52732 L

s

P

p

.001 w

.44286 .52357 m

.44286 .52732 L

s

P

p

.001 w

.48095 .52357 m

.48095 .52732 L

s

P

p

.001 w

.51905 .52357 m

.51905 .52732 L

s

P

p

.001 w

.55714 .52357 m

.55714 .52732 L

s

P

p

.001 w

.63333 .52357 m

.63333 .52732 L

s

P

p

.001 w

.67143 .52357 m

.67143 .52732 L

s

P

p

.001 w

.70952 .52357 m

.70952 .52732 L

s

P

p

.001 w

.74762 .52357 m

.74762 .52732 L

s

P

p

.001 w

.82381 .52357 m

.82381 .52732 L

s

P

p

.001 w

.8619 .52357 m

.8619 .52732 L

s

P

p

.001 w

.9 .52357 m

.9 .52732 L

s

P

p

.001 w

.9381 .52357 m

.9381 .52732 L

s

P

p

.002 w

0 .52357 m

1 .52357 L

s

P

p

.002 w

.02381 .03984 m

.03006 .03984 L

s

P

[(-800)] .01131 .03984 1 0 Mshowa

p

.002 w

.02381 .16078 m

.03006 .16078 L

s

P

[(-600)] .01131 .16078 1 0 Mshowa

p

.002 w

.02381 .28171 m

.03006 .28171 L

s

P

[(-400)] .01131 .28171 1 0 Mshowa

p

.002 w

.02381 .40264 m

.03006 .40264 L

s

P

[(-200)] .01131 .40264 1 0 Mshowa

p

.001 w

.02381 .06403 m

.02756 .06403 L

s

P

p

.001 w

.02381 .08822 m

.02756 .08822 L

s

P

p

.001 w

.02381 .1124 m

.02756 .1124 L

s

P

p

.001 w

.02381 .13659 m

.02756 .13659 L

s

P

p

.001 w

.02381 .18496 m

.02756 .18496 L

s

P

p

.001 w

.02381 .20915 m

.02756 .20915 L

s

P

p

.001 w

.02381 .23333 m

.02756 .23333 L

s

P

p

.001 w

.02381 .25752 m

.02756 .25752 L

s

P

p

.001 w

.02381 .30589 m

.02756 .30589 L

s

P

p

.001 w

.02381 .33008 m

.02756 .33008 L

s

P

p

.001 w

.02381 .35426 m

.02756 .35426 L

s

P

p

.001 w

.02381 .37845 m

.02756 .37845 L

s

P

p

.001 w

.02381 .42682 m

.02756 .42682 L

s

P

p

.001 w

.02381 .45101 m

.02756 .45101 L

s

P

p

.001 w

.02381 .4752 m

.02756 .4752 L

s

P

p

.001 w

.02381 .49938 m

.02756 .49938 L

s

P

p

.001 w

.02381 .01566 m

.02756 .01566 L

s

P

p

.001 w

.02381 .54775 m

.02756 .54775 L

s

P

p

.001 w

.02381 .57194 m

.02756 .57194 L

s

P

p

.001 w

.02381 .59613 m

.02756 .59613 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.05905 .60332 m

.06382 .60264 L

.0686 .60182 L

.07815 .59967 L

.08771 .59675 L

.09726 .59293 L

.10681 .58804 L

.11637 .5819 L

.13547 .56524 L

.15458 .54248 L

.17369 .51805 L

.17847 .51294 L

.18324 .50853 L

.18802 .50491 L

.1928 .50212 L

.19518 .50104 L

.19757 .50016 L

.19877 .4998 L

.19996 .49949 L

.20115 .49923 L

.20235 .49902 L

.20354 .49885 L

.20474 .49874 L

.20593 .49867 L

.20713 .49865 L

.20832 .49867 L

.20951 .49874 L

.21071 .49884 L

.2119 .49899 L

.21429 .49941 L

.21668 .49997 L

.22146 .50147 L

.23101 .50556 L

.24056 .51015 L

.25012 .5141 L

.25251 .51488 L

.25489 .51555 L

.25728 .51611 L

.25848 .51634 L

.25967 .51654 L

.26086 .51671 L

.26206 .51684 L

.26325 .51694 L

.26445 .51701 L

.26564 .51705 L

.26684 .51705 L

.26803 .51701 L

.26922 .51694 L

.27042 .51683 L

.27161 .51669 L

Mistroke

.274 .51631 L

.27639 .51578 L

.27878 .51512 L

.28355 .5134 L

.28833 .51117 L

.29789 .50535 L

.30744 .49805 L

.32655 .48072 L

.36476 .44323 L

.38387 .42587 L

.40297 .41124 L

.42208 .39965 L

.44119 .38957 L

.45074 .38412 L

.4603 .3776 L

.46985 .36924 L

.4794 .35809 L

.48896 .34301 L

.49851 .32292 L

.51762 .27495 L

.52717 .25586 L

.53672 .24157 L

.5415 .23602 L

.54628 .2314 L

.55583 .22446 L

.56061 .22191 L

.56539 .21983 L

.57494 .21669 L

.58449 .21437 L

.59405 .21239 L

.6036 .21036 L

.61315 .20802 L

.63226 .20164 L

.64181 .19735 L

.65137 .19226 L

.67048 .17981 L

.70869 .14903 L

.7278 .13263 L

.7469 .117 L

.75646 .1101 L

.76601 .10429 L

.77079 .10191 L

.77556 .09993 L

.78034 .09838 L

.78273 .09777 L

.78512 .09727 L

.78751 .09689 L

.7887 .09674 L

.7899 .09661 L

.79109 .09652 L

Mistroke

.79228 .09645 L

.79348 .09641 L

.79467 .09639 L

.79587 .0964 L

.79706 .09643 L

.79825 .09649 L

.79945 .09657 L

.80184 .0968 L

.80423 .09711 L

.809 .09793 L

.81378 .09895 L

.82333 .10118 L

.82811 .10215 L

.8305 .10255 L

.83289 .10287 L

.83408 .103 L

.83527 .10311 L

.83647 .10319 L

.83766 .10324 L

.83886 .10327 L

.84005 .10326 L

.84125 .10323 L

.84244 .10317 L

.84363 .10307 L

.84483 .10294 L

.84722 .10257 L

.84961 .10206 L

.85199 .1014 L

.85677 .09962 L

.86155 .09723 L

.8711 .09069 L

.88065 .08224 L

.89976 .06302 L

.91887 .04562 L

.93798 .03209 L

.95708 .02206 L

.97619 .01472 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[CellGroupData[{Cell[TextData["\nShow[thplot,alphaplot]\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.190476 0.523568 0.000604654 [

[(1)] .21429 .52357 0 2 Msboxa

[(2)] .40476 .52357 0 2 Msboxa

[(3)] .59524 .52357 0 2 Msboxa

[(4)] .78571 .52357 0 2 Msboxa

[(5)] .97619 .52357 0 2 Msboxa

[(-800)] .01131 .03984 1 0 Msboxa

[(-600)] .01131 .16078 1 0 Msboxa

[(-400)] .01131 .28171 1 0 Msboxa

[(-200)] .01131 .40264 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .52357 m

.21429 .52982 L

s

P

[(1)] .21429 .52357 0 2 Mshowa

p

.002 w

.40476 .52357 m

.40476 .52982 L

s

P

[(2)] .40476 .52357 0 2 Mshowa

p

.002 w

.59524 .52357 m

.59524 .52982 L

s

P

[(3)] .59524 .52357 0 2 Mshowa

p

.002 w

.78571 .52357 m

.78571 .52982 L

s

P

[(4)] .78571 .52357 0 2 Mshowa

p

.002 w

.97619 .52357 m

.97619 .52982 L

s

P

[(5)] .97619 .52357 0 2 Mshowa

p

.001 w

.0619 .52357 m

.0619 .52732 L

s

P

p

.001 w

.1 .52357 m

.1 .52732 L

s

P

p

.001 w

.1381 .52357 m

.1381 .52732 L

s

P

p

.001 w

.17619 .52357 m

.17619 .52732 L

s

P

p

.001 w

.25238 .52357 m

.25238 .52732 L

s

P

p

.001 w

.29048 .52357 m

.29048 .52732 L

s

P

p

.001 w

.32857 .52357 m

.32857 .52732 L

s

P

p

.001 w

.36667 .52357 m

.36667 .52732 L

s

P

p

.001 w

.44286 .52357 m

.44286 .52732 L

s

P

p

.001 w

.48095 .52357 m

.48095 .52732 L

s

P

p

.001 w

.51905 .52357 m

.51905 .52732 L

s

P

p

.001 w

.55714 .52357 m

.55714 .52732 L

s

P

p

.001 w

.63333 .52357 m

.63333 .52732 L

s

P

p

.001 w

.67143 .52357 m

.67143 .52732 L

s

P

p

.001 w

.70952 .52357 m

.70952 .52732 L

s

P

p

.001 w

.74762 .52357 m

.74762 .52732 L

s

P

p

.001 w

.82381 .52357 m

.82381 .52732 L

s

P

p

.001 w

.8619 .52357 m

.8619 .52732 L

s

P

p

.001 w

.9 .52357 m

.9 .52732 L

s

P

p

.001 w

.9381 .52357 m

.9381 .52732 L

s

P

p

.002 w

0 .52357 m

1 .52357 L

s

P

p

.002 w

.02381 .03984 m

.03006 .03984 L

s

P

[(-800)] .01131 .03984 1 0 Mshowa

p

.002 w

.02381 .16078 m

.03006 .16078 L

s

P

[(-600)] .01131 .16078 1 0 Mshowa

p

.002 w

.02381 .28171 m

.03006 .28171 L

s

P

[(-400)] .01131 .28171 1 0 Mshowa

p

.002 w

.02381 .40264 m

.03006 .40264 L

s

P

[(-200)] .01131 .40264 1 0 Mshowa

p

.001 w

.02381 .06403 m

.02756 .06403 L

s

P

p

.001 w

.02381 .08822 m

.02756 .08822 L

s

P

p

.001 w

.02381 .1124 m

.02756 .1124 L

s

P

p

.001 w

.02381 .13659 m

.02756 .13659 L

s

P

p

.001 w

.02381 .18496 m

.02756 .18496 L

s

P

p

.001 w

.02381 .20915 m

.02756 .20915 L

s

P

p

.001 w

.02381 .23333 m

.02756 .23333 L

s

P

p

.001 w

.02381 .25752 m

.02756 .25752 L

s

P

p

.001 w

.02381 .30589 m

.02756 .30589 L

s

P

p

.001 w

.02381 .33008 m

.02756 .33008 L

s

P

p

.001 w

.02381 .35426 m

.02756 .35426 L

s

P

p

.001 w

.02381 .37845 m

.02756 .37845 L

s

P

p

.001 w

.02381 .42682 m

.02756 .42682 L

s

P

p

.001 w

.02381 .45101 m

.02756 .45101 L

s

P

p

.001 w

.02381 .4752 m

.02756 .4752 L

s

P

p

.001 w

.02381 .49938 m

.02756 .49938 L

s

P

p

.001 w

.02381 .01566 m

.02756 .01566 L

s

P

p

.001 w

.02381 .54775 m

.02756 .54775 L

s

P

p

.001 w

.02381 .57194 m

.02756 .57194 L

s

P

p

.001 w

.02381 .59613 m

.02756 .59613 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

p

.004 w

.05905 .54699 m

.0686 .54461 L

.07815 .54163 L

.09726 .53387 L

.13547 .51261 L

.17369 .48874 L

.2119 .45788 L

.23101 .44139 L

.25012 .42655 L

.26922 .4145 L

.27878 .40966 L

.28833 .40558 L

.29789 .40221 L

.30744 .39944 L

.31699 .39716 L

.32655 .39528 L

.3361 .39372 L

.34565 .39245 L

.35043 .39193 L

.35521 .39148 L

.35998 .39113 L

.36237 .39099 L

.36476 .39087 L

.36595 .39082 L

.36715 .39078 L

.36834 .39074 L

.36954 .39071 L

.37073 .39069 L

.37193 .39068 L

.37312 .39067 L

.37431 .39067 L

.37551 .39068 L

.3767 .3907 L

.3779 .39073 L

.37909 .39076 L

.38148 .39086 L

.38387 .39099 L

.38626 .39116 L

.38864 .39137 L

.39342 .39191 L

.3982 .39261 L

.40297 .39349 L

.41253 .39577 L

.42208 .39876 L

.44119 .40688 L

.4603 .41778 L

.4794 .43131 L

.51762 .46687 L

.55583 .50169 L

.57494 .51667 L

Mistroke

.59405 .5289 L

.6036 .53389 L

.61315 .53812 L

.62271 .54161 L

.63226 .54438 L

.63704 .5455 L

.64181 .54645 L

.64659 .54723 L

.65137 .54785 L

.65376 .5481 L

.65614 .54831 L

.65853 .54848 L

.66092 .54861 L

.66212 .54866 L

.66331 .5487 L

.6645 .54873 L

.6657 .54876 L

.66689 .54877 L

.66809 .54878 L

.66928 .54877 L

.67048 .54876 L

.67167 .54874 L

.67286 .54871 L

.67525 .54863 L

.67764 .54851 L

.68003 .54837 L

.68481 .54798 L

.68958 .54749 L

.69914 .54618 L

.70869 .5445 L

.7278 .54012 L

.7469 .53428 L

.76601 .52651 L

.78512 .51616 L

.82333 .48741 L

.86155 .45506 L

.89976 .42913 L

.91887 .41803 L

.93798 .40805 L

.97619 .39354 L

Mfstroke

P

P

p

p

.004 w

.05905 .60332 m

.06382 .60264 L

.0686 .60182 L

.07815 .59967 L

.08771 .59675 L

.09726 .59293 L

.10681 .58804 L

.11637 .5819 L

.13547 .56524 L

.15458 .54248 L

.17369 .51805 L

.17847 .51294 L

.18324 .50853 L

.18802 .50491 L

.1928 .50212 L

.19518 .50104 L

.19757 .50016 L

.19877 .4998 L

.19996 .49949 L

.20115 .49923 L

.20235 .49902 L

.20354 .49885 L

.20474 .49874 L

.20593 .49867 L

.20713 .49865 L

.20832 .49867 L

.20951 .49874 L

.21071 .49884 L

.2119 .49899 L

.21429 .49941 L

.21668 .49997 L

.22146 .50147 L

.23101 .50556 L

.24056 .51015 L

.25012 .5141 L

.25251 .51488 L

.25489 .51555 L

.25728 .51611 L

.25848 .51634 L

.25967 .51654 L

.26086 .51671 L

.26206 .51684 L

.26325 .51694 L

.26445 .51701 L

.26564 .51705 L

.26684 .51705 L

.26803 .51701 L

.26922 .51694 L

.27042 .51683 L

.27161 .51669 L

Mistroke

.274 .51631 L

.27639 .51578 L

.27878 .51512 L

.28355 .5134 L

.28833 .51117 L

.29789 .50535 L

.30744 .49805 L

.32655 .48072 L

.36476 .44323 L

.38387 .42587 L

.40297 .41124 L

.42208 .39965 L

.44119 .38957 L

.45074 .38412 L

.4603 .3776 L

.46985 .36924 L

.4794 .35809 L

.48896 .34301 L

.49851 .32292 L

.51762 .27495 L

.52717 .25586 L

.53672 .24157 L

.5415 .23602 L

.54628 .2314 L

.55583 .22446 L

.56061 .22191 L

.56539 .21983 L

.57494 .21669 L

.58449 .21437 L

.59405 .21239 L

.6036 .21036 L

.61315 .20802 L

.63226 .20164 L

.64181 .19735 L

.65137 .19226 L

.67048 .17981 L

.70869 .14903 L

.7278 .13263 L

.7469 .117 L

.75646 .1101 L

.76601 .10429 L

.77079 .10191 L

.77556 .09993 L

.78034 .09838 L

.78273 .09777 L

.78512 .09727 L

.78751 .09689 L

.7887 .09674 L

.7899 .09661 L

.79109 .09652 L

Mistroke

.79228 .09645 L

.79348 .09641 L

.79467 .09639 L

.79587 .0964 L

.79706 .09643 L

.79825 .09649 L

.79945 .09657 L

.80184 .0968 L

.80423 .09711 L

.809 .09793 L

.81378 .09895 L

.82333 .10118 L

.82811 .10215 L

.8305 .10255 L

.83289 .10287 L

.83408 .103 L

.83527 .10311 L

.83647 .10319 L

.83766 .10324 L

.83886 .10327 L

.84005 .10326 L

.84125 .10323 L

.84244 .10317 L

.84363 .10307 L

.84483 .10294 L

.84722 .10257 L

.84961 .10206 L

.85199 .1014 L

.85677 .09962 L

.86155 .09723 L

.8711 .09069 L

.88065 .08224 L

.89976 .06302 L

.91887 .04562 L

.93798 .03209 L

.95708 .02206 L

.97619 .01472 L

Mfstroke

P

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[OutputFormData["\<\

No Input Form was saved for this expression.




\
\>", "\<\

-Graphics-
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nrelease = FindRoot[(alpha[t]/.sol)[[1]] == 0,{t,.5}]\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

Can't Format Cell




\
\>", "\<\

General::spell1: 

   Possible spelling error: new symbol name \"release\"

     is similar to existing symbol \"Release\".
\
\>"], "Message",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

{t -> 0.7625223207998645}




\
\>", "\<\

{t -> 0.762522}
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]],

Cell[CellGroupData[{Cell[TextData["\n((theta[t]/.sol)/.release)[[1]]/Degree//N\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

-52.45328892725125




\
\>", "\<\

-52.4533
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[(alphadot[t]/.sol)/Degree,{t,t/.liftoff,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.190476 0.511464 0.000601043 [

[(1)] .21429 .51146 0 2 Msboxa

[(2)] .40476 .51146 0 2 Msboxa

[(3)] .59524 .51146 0 2 Msboxa

[(4)] .78571 .51146 0 2 Msboxa

[(5)] .97619 .51146 0 2 Msboxa

[(-800)] .01131 .03063 1 0 Msboxa

[(-600)] .01131 .15084 1 0 Msboxa

[(-400)] .01131 .27105 1 0 Msboxa

[(-200)] .01131 .39126 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .51146 m

.21429 .51771 L

s

P

[(1)] .21429 .51146 0 2 Mshowa

p

.002 w

.40476 .51146 m

.40476 .51771 L

s

P

[(2)] .40476 .51146 0 2 Mshowa

p

.002 w

.59524 .51146 m

.59524 .51771 L

s

P

[(3)] .59524 .51146 0 2 Mshowa

p

.002 w

.78571 .51146 m

.78571 .51771 L

s

P

[(4)] .78571 .51146 0 2 Mshowa

p

.002 w

.97619 .51146 m

.97619 .51771 L

s

P

[(5)] .97619 .51146 0 2 Mshowa

p

.001 w

.0619 .51146 m

.0619 .51521 L

s

P

p

.001 w

.1 .51146 m

.1 .51521 L

s

P

p

.001 w

.1381 .51146 m

.1381 .51521 L

s

P

p

.001 w

.17619 .51146 m

.17619 .51521 L

s

P

p

.001 w

.25238 .51146 m

.25238 .51521 L

s

P

p

.001 w

.29048 .51146 m

.29048 .51521 L

s

P

p

.001 w

.32857 .51146 m

.32857 .51521 L

s

P

p

.001 w

.36667 .51146 m

.36667 .51521 L

s

P

p

.001 w

.44286 .51146 m

.44286 .51521 L

s

P

p

.001 w

.48095 .51146 m

.48095 .51521 L

s

P

p

.001 w

.51905 .51146 m

.51905 .51521 L

s

P

p

.001 w

.55714 .51146 m

.55714 .51521 L

s

P

p

.001 w

.63333 .51146 m

.63333 .51521 L

s

P

p

.001 w

.67143 .51146 m

.67143 .51521 L

s

P

p

.001 w

.70952 .51146 m

.70952 .51521 L

s

P

p

.001 w

.74762 .51146 m

.74762 .51521 L

s

P

p

.001 w

.82381 .51146 m

.82381 .51521 L

s

P

p

.001 w

.8619 .51146 m

.8619 .51521 L

s

P

p

.001 w

.9 .51146 m

.9 .51521 L

s

P

p

.001 w

.9381 .51146 m

.9381 .51521 L

s

P

p

.002 w

0 .51146 m

1 .51146 L

s

P

p

.002 w

.02381 .03063 m

.03006 .03063 L

s

P

[(-800)] .01131 .03063 1 0 Mshowa

p

.002 w

.02381 .15084 m

.03006 .15084 L

s

P

[(-600)] .01131 .15084 1 0 Mshowa

p

.002 w

.02381 .27105 m

.03006 .27105 L

s

P

[(-400)] .01131 .27105 1 0 Mshowa

p

.002 w

.02381 .39126 m

.03006 .39126 L

s

P

[(-200)] .01131 .39126 1 0 Mshowa

p

.001 w

.02381 .05467 m

.02756 .05467 L

s

P

p

.001 w

.02381 .07871 m

.02756 .07871 L

s

P

p

.001 w

.02381 .10275 m

.02756 .10275 L

s

P

p

.001 w

.02381 .1268 m

.02756 .1268 L

s

P

p

.001 w

.02381 .17488 m

.02756 .17488 L

s

P

p

.001 w

.02381 .19892 m

.02756 .19892 L

s

P

p

.001 w

.02381 .22296 m

.02756 .22296 L

s

P

p

.001 w

.02381 .247 m

.02756 .247 L

s

P

p

.001 w

.02381 .29509 m

.02756 .29509 L

s

P

p

.001 w

.02381 .31913 m

.02756 .31913 L

s

P

p

.001 w

.02381 .34317 m

.02756 .34317 L

s

P

p

.001 w

.02381 .36721 m

.02756 .36721 L

s

P

p

.001 w

.02381 .4153 m

.02756 .4153 L

s

P

p

.001 w

.02381 .43934 m

.02756 .43934 L

s

P

p

.001 w

.02381 .46338 m

.02756 .46338 L

s

P

p

.001 w

.02381 .48742 m

.02756 .48742 L

s

P

p

.001 w

.02381 .00659 m

.02756 .00659 L

s

P

p

.001 w

.02381 .53551 m

.02756 .53551 L

s

P

p

.001 w

.02381 .55955 m

.02756 .55955 L

s

P

p

.001 w

.02381 .58359 m

.02756 .58359 L

s

P

p

.001 w

.02381 .60763 m

.02756 .60763 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.05905 .48749 m

.07815 .4617 L

.09726 .42568 L

.11637 .37638 L

.13547 .31495 L

.14025 .29916 L

.14503 .28437 L

.14742 .2777 L

.1498 .27176 L

.15219 .26677 L

.15458 .26297 L

.15578 .26159 L

.15697 .26059 L

.15816 .26001 L

.15936 .25987 L

.16055 .2602 L

.16175 .26101 L

.16294 .26232 L

.16413 .26413 L

.16533 .26646 L

.16652 .2693 L

.16891 .27647 L

.17369 .29634 L

.18324 .35206 L

.1928 .41731 L

.20235 .48184 L

.2119 .53826 L

.21668 .56134 L

.22146 .57995 L

.22384 .58736 L

.22623 .59342 L

.22743 .59592 L

.22862 .59807 L

.22982 .59985 L

.23101 .60127 L

.2322 .60232 L

.2334 .603 L

.23459 .60332 L

.23579 .60327 L

.23698 .60287 L

.23818 .60211 L

.23937 .60101 L

.24056 .59957 L

.24295 .59571 L

.24534 .59062 L

.25012 .57719 L

.25967 .54068 L

.26922 .49751 L

.27878 .45371 L

.28833 .41352 L

Mistroke

.29789 .38001 L

.30744 .35499 L

.31222 .34576 L

.31699 .33853 L

.32177 .33308 L

.32655 .32913 L

.32893 .32764 L

.33132 .32643 L

.33371 .32547 L

.3361 .32474 L

.33729 .32445 L

.33849 .32422 L

.33968 .32403 L

.34088 .3239 L

.34207 .3238 L

.34326 .32375 L

.34446 .32375 L

.34565 .32378 L

.34685 .32386 L

.34804 .32398 L

.34924 .32415 L

.35043 .32435 L

.35282 .32489 L

.35521 .32561 L

.35998 .32761 L

.36476 .33042 L

.36954 .33415 L

.37431 .33884 L

.38387 .3511 L

.40297 .38254 L

.41253 .39726 L

.4173 .40332 L

.41969 .4059 L

.42208 .40814 L

.42447 .41 L

.42686 .41145 L

.42805 .41201 L

.42925 .41245 L

.43044 .41278 L

.43164 .41298 L

.43283 .41305 L

.43402 .41298 L

.43522 .41278 L

.43641 .41244 L

.43761 .41194 L

.4388 .41129 L

.44119 .40951 L

.44358 .40706 L

.44597 .40388 L

.45074 .39516 L

Mistroke

.45552 .38298 L

.4603 .36693 L

.46507 .34658 L

.46985 .32151 L

.4794 .25546 L

.48896 .16574 L

.49373 .11322 L

.49851 .06167 L

.5009 .04003 L

.50209 .03118 L

.50329 .02403 L

.50448 .01879 L

.50568 .01566 L

.50687 .01472 L

.50806 .01596 L

.50926 .01931 L

.51045 .0246 L

.51284 .04005 L

.51762 .08347 L

.52717 .18238 L

.53672 .27181 L

.54628 .34503 L

.55583 .39981 L

.56061 .42041 L

.56539 .43689 L

.57016 .44968 L

.57494 .45923 L

.57733 .46292 L

.57972 .46595 L

.5821 .46838 L

.58449 .47024 L

.58569 .47097 L

.58688 .47157 L

.58808 .47205 L

.58927 .47242 L

.59046 .47267 L

.59166 .47281 L

.59285 .47285 L

.59405 .47279 L

.59524 .47262 L

.59643 .47237 L

.59882 .47159 L

.60002 .47107 L

.60121 .47047 L

.6036 .46903 L

.60838 .4653 L

.61315 .46056 L

.63226 .43424 L

.65137 .40262 L

.67048 .37492 L

Mistroke

.68003 .36479 L

.68481 .36076 L

.68958 .35739 L

.69436 .35461 L

.69914 .35239 L

.70391 .35067 L

.7063 .34999 L

.70869 .34944 L

.70988 .34921 L

.71108 .34901 L

.71227 .34884 L

.71347 .34871 L

.71466 .3486 L

.71585 .34854 L

.71705 .34851 L

.71824 .34852 L

.71944 .34857 L

.72063 .34866 L

.72183 .34879 L

.72302 .34897 L

.72421 .3492 L

.72541 .34947 L

.7278 .35018 L

.73019 .35113 L

.73257 .35233 L

.73735 .35562 L

.74213 .36026 L

.7469 .36648 L

.75168 .37446 L

.75646 .38431 L

.76601 .40964 L

.78512 .47651 L

.79467 .51089 L

.79945 .52608 L

.80423 .53892 L

.80661 .54423 L

.809 .54867 L

.81139 .55216 L

.81259 .55352 L

.81378 .55463 L

.81497 .55546 L

.81617 .55602 L

.81736 .55629 L

.81856 .55629 L

.81975 .55599 L

.82094 .5554 L

.82214 .55452 L

.82333 .55335 L

.82453 .55188 L

.82572 .55013 L

Mistroke

.82811 .54578 L

.83289 .5338 L

.83766 .51787 L

.84244 .49861 L

.86155 .40453 L

.86632 .38145 L

.8711 .36065 L

.87588 .34323 L

.88065 .33008 L

.88304 .32528 L

.88424 .32335 L

.88543 .32171 L

.88663 .32039 L

.88782 .31935 L

.88901 .31861 L

.89021 .31815 L

.8914 .31796 L

.8926 .31803 L

.89379 .31835 L

.89498 .31889 L

.89618 .31966 L

.89737 .32063 L

.89976 .32313 L

.90454 .32992 L

.90932 .33841 L

.91887 .35782 L

.93798 .39605 L

.95708 .42666 L

.97619 .44963 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[((theta[t]+alpha[t])/.sol)/Degree,{t,t/.liftoff,endtime}];\n"], 
  "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.190476 0.521483 0.000479622 [

[(1)] .21429 .52148 0 2 Msboxa

[(2)] .40476 .52148 0 2 Msboxa

[(3)] .59524 .52148 0 2 Msboxa

[(4)] .78571 .52148 0 2 Msboxa

[(5)] .97619 .52148 0 2 Msboxa

[(-1000)] .01131 .04186 1 0 Msboxa

[(-800)] .01131 .13779 1 0 Msboxa

[(-600)] .01131 .23371 1 0 Msboxa

[(-400)] .01131 .32963 1 0 Msboxa

[(-200)] .01131 .42556 1 0 Msboxa

[(200)] .01131 .61741 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .52148 m

.21429 .52773 L

s

P

[(1)] .21429 .52148 0 2 Mshowa

p

.002 w

.40476 .52148 m

.40476 .52773 L

s

P

[(2)] .40476 .52148 0 2 Mshowa

p

.002 w

.59524 .52148 m

.59524 .52773 L

s

P

[(3)] .59524 .52148 0 2 Mshowa

p

.002 w

.78571 .52148 m

.78571 .52773 L

s

P

[(4)] .78571 .52148 0 2 Mshowa

p

.002 w

.97619 .52148 m

.97619 .52773 L

s

P

[(5)] .97619 .52148 0 2 Mshowa

p

.001 w

.0619 .52148 m

.0619 .52523 L

s

P

p

.001 w

.1 .52148 m

.1 .52523 L

s

P

p

.001 w

.1381 .52148 m

.1381 .52523 L

s

P

p

.001 w

.17619 .52148 m

.17619 .52523 L

s

P

p

.001 w

.25238 .52148 m

.25238 .52523 L

s

P

p

.001 w

.29048 .52148 m

.29048 .52523 L

s

P

p

.001 w

.32857 .52148 m

.32857 .52523 L

s

P

p

.001 w

.36667 .52148 m

.36667 .52523 L

s

P

p

.001 w

.44286 .52148 m

.44286 .52523 L

s

P

p

.001 w

.48095 .52148 m

.48095 .52523 L

s

P

p

.001 w

.51905 .52148 m

.51905 .52523 L

s

P

p

.001 w

.55714 .52148 m

.55714 .52523 L

s

P

p

.001 w

.63333 .52148 m

.63333 .52523 L

s

P

p

.001 w

.67143 .52148 m

.67143 .52523 L

s

P

p

.001 w

.70952 .52148 m

.70952 .52523 L

s

P

p

.001 w

.74762 .52148 m

.74762 .52523 L

s

P

p

.001 w

.82381 .52148 m

.82381 .52523 L

s

P

p

.001 w

.8619 .52148 m

.8619 .52523 L

s

P

p

.001 w

.9 .52148 m

.9 .52523 L

s

P

p

.001 w

.9381 .52148 m

.9381 .52523 L

s

P

p

.002 w

0 .52148 m

1 .52148 L

s

P

p

.002 w

.02381 .04186 m

.03006 .04186 L

s

P

[(-1000)] .01131 .04186 1 0 Mshowa

p

.002 w

.02381 .13779 m

.03006 .13779 L

s

P

[(-800)] .01131 .13779 1 0 Mshowa

p

.002 w

.02381 .23371 m

.03006 .23371 L

s

P

[(-600)] .01131 .23371 1 0 Mshowa

p

.002 w

.02381 .32963 m

.03006 .32963 L

s

P

[(-400)] .01131 .32963 1 0 Mshowa

p

.002 w

.02381 .42556 m

.03006 .42556 L

s

P

[(-200)] .01131 .42556 1 0 Mshowa

p

.002 w

.02381 .61741 m

.03006 .61741 L

s

P

[(200)] .01131 .61741 1 0 Mshowa

p

.001 w

.02381 .06105 m

.02756 .06105 L

s

P

p

.001 w

.02381 .08023 m

.02756 .08023 L

s

P

p

.001 w

.02381 .09942 m

.02756 .09942 L

s

P

p

.001 w

.02381 .1186 m

.02756 .1186 L

s

P

p

.001 w

.02381 .15697 m

.02756 .15697 L

s

P

p

.001 w

.02381 .17615 m

.02756 .17615 L

s

P

p

.001 w

.02381 .19534 m

.02756 .19534 L

s

P

p

.001 w

.02381 .21452 m

.02756 .21452 L

s

P

p

.001 w

.02381 .25289 m

.02756 .25289 L

s

P

p

.001 w

.02381 .27208 m

.02756 .27208 L

s

P

p

.001 w

.02381 .29126 m

.02756 .29126 L

s

P

p

.001 w

.02381 .31045 m

.02756 .31045 L

s

P

p

.001 w

.02381 .34882 m

.02756 .34882 L

s

P

p

.001 w

.02381 .368 m

.02756 .368 L

s

P

p

.001 w

.02381 .38719 m

.02756 .38719 L

s

P

p

.001 w

.02381 .40637 m

.02756 .40637 L

s

P

p

.001 w

.02381 .44474 m

.02756 .44474 L

s

P

p

.001 w

.02381 .46393 m

.02756 .46393 L

s

P

p

.001 w

.02381 .48311 m

.02756 .48311 L

s

P

p

.001 w

.02381 .5023 m

.02756 .5023 L

s

P

p

.001 w

.02381 .54067 m

.02756 .54067 L

s

P

p

.001 w

.02381 .55985 m

.02756 .55985 L

s

P

p

.001 w

.02381 .57904 m

.02756 .57904 L

s

P

p

.001 w

.02381 .59822 m

.02756 .59822 L

s

P

p

.001 w

.02381 .02268 m

.02756 .02268 L

s

P

p

.001 w

.02381 .00349 m

.02756 .00349 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.05905 .60332 m

.0686 .60024 L

.07815 .59617 L

.08771 .59102 L

.09726 .58467 L

.11637 .56805 L

.13547 .54585 L

.15458 .51854 L

.17369 .48948 L

.18324 .47645 L

.1928 .46537 L

.20235 .45651 L

.20713 .45293 L

.2119 .44988 L

.22146 .44523 L

.22623 .44348 L

.23101 .44202 L

.24056 .43953 L

.25012 .43701 L

.25967 .43386 L

.26922 .42971 L

.28833 .41806 L

.32655 .38573 L

.34565 .36859 L

.36476 .35249 L

.37431 .34525 L

.38387 .33883 L

.39342 .33343 L

.40297 .3292 L

.40775 .32754 L

.41253 .32616 L

.4173 .32505 L

.42208 .32419 L

.42447 .32385 L

.42686 .32356 L

.42925 .32332 L

.43164 .32312 L

.43402 .32295 L

.43641 .32283 L

.44119 .32264 L

.44597 .32251 L

.44835 .32244 L

.45074 .32237 L

.45313 .32227 L

.45552 .32215 L

.45791 .322 L

.4603 .32179 L

.46268 .32153 L

.46507 .32119 L

.46746 .32078 L

Mistroke

.46985 .32027 L

.47463 .31892 L

.4794 .31704 L

.48418 .31453 L

.48896 .31128 L

.49851 .30223 L

.50806 .29045 L

.51762 .2793 L

.52239 .27491 L

.52717 .27143 L

.52956 .27002 L

.53195 .26884 L

.53434 .26787 L

.53672 .2671 L

.53792 .26678 L

.53911 .26652 L

.54031 .2663 L

.5415 .26612 L

.5427 .26599 L

.54389 .2659 L

.54508 .26585 L

.54628 .26583 L

.54747 .26585 L

.54867 .26591 L

.54986 .266 L

.55106 .26612 L

.55344 .26644 L

.55583 .26687 L

.56061 .268 L

.56539 .26938 L

.57494 .27259 L

.59405 .27888 L

.59882 .28015 L

.6036 .28123 L

.60838 .28209 L

.61077 .28244 L

.61315 .28273 L

.61554 .28295 L

.61674 .28304 L

.61793 .28311 L

.61912 .28317 L

.62032 .2832 L

.62151 .28322 L

.62271 .28323 L

.6239 .28322 L

.6251 .28319 L

.62629 .28314 L

.62748 .28307 L

.62987 .28289 L

.63226 .28263 L

Mistroke

.63465 .2823 L

.63704 .2819 L

.64181 .28087 L

.64659 .27955 L

.65137 .27794 L

.67048 .26879 L

.68958 .25607 L

.70869 .241 L

.7469 .20748 L

.78512 .17746 L

.80423 .16685 L

.82333 .15775 L

.83289 .15255 L

.84244 .14621 L

.86155 .12896 L

.89976 .08125 L

.91887 .05865 L

.93798 .04 L

.95708 .02547 L

.97619 .01472 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[\n\n((((Tension[t]/.derivs)/.{alpha'[t]->alphadot[t],\n\n\
theta'[t]->thetadot[t]})/.sol)),{t,0,endtime}];\n"], "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.952381 0.0147151 0.000483036 [

[(0.2)] .21429 .01472 0 2 Msboxa

[(0.4)] .40476 .01472 0 2 Msboxa

[(0.6)] .59524 .01472 0 2 Msboxa

[(0.8)] .78571 .01472 0 2 Msboxa

[(1)] .97619 .01472 0 2 Msboxa

[(200)] .01131 .11132 1 0 Msboxa

[(400)] .01131 .20793 1 0 Msboxa

[(600)] .01131 .30454 1 0 Msboxa

[(800)] .01131 .40114 1 0 Msboxa

[(1000)] .01131 .49775 1 0 Msboxa

[(1200)] .01131 .59436 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.21429 .01472 m

.21429 .02097 L

s

P

[(0.2)] .21429 .01472 0 2 Mshowa

p

.002 w

.40476 .01472 m

.40476 .02097 L

s

P

[(0.4)] .40476 .01472 0 2 Mshowa

p

.002 w

.59524 .01472 m

.59524 .02097 L

s

P

[(0.6)] .59524 .01472 0 2 Mshowa

p

.002 w

.78571 .01472 m

.78571 .02097 L

s

P

[(0.8)] .78571 .01472 0 2 Mshowa

p

.002 w

.97619 .01472 m

.97619 .02097 L

s

P

[(1)] .97619 .01472 0 2 Mshowa

p

.001 w

.0619 .01472 m

.0619 .01847 L

s

P

p

.001 w

.1 .01472 m

.1 .01847 L

s

P

p

.001 w

.1381 .01472 m

.1381 .01847 L

s

P

p

.001 w

.17619 .01472 m

.17619 .01847 L

s

P

p

.001 w

.25238 .01472 m

.25238 .01847 L

s

P

p

.001 w

.29048 .01472 m

.29048 .01847 L

s

P

p

.001 w

.32857 .01472 m

.32857 .01847 L

s

P

p

.001 w

.36667 .01472 m

.36667 .01847 L

s

P

p

.001 w

.44286 .01472 m

.44286 .01847 L

s

P

p

.001 w

.48095 .01472 m

.48095 .01847 L

s

P

p

.001 w

.51905 .01472 m

.51905 .01847 L

s

P

p

.001 w

.55714 .01472 m

.55714 .01847 L

s

P

p

.001 w

.63333 .01472 m

.63333 .01847 L

s

P

p

.001 w

.67143 .01472 m

.67143 .01847 L

s

P

p

.001 w

.70952 .01472 m

.70952 .01847 L

s

P

p

.001 w

.74762 .01472 m

.74762 .01847 L

s

P

p

.001 w

.82381 .01472 m

.82381 .01847 L

s

P

p

.001 w

.8619 .01472 m

.8619 .01847 L

s

P

p

.001 w

.9 .01472 m

.9 .01847 L

s

P

p

.001 w

.9381 .01472 m

.9381 .01847 L

s

P

p

.002 w

0 .01472 m

1 .01472 L

s

P

p

.002 w

.02381 .11132 m

.03006 .11132 L

s

P

[(200)] .01131 .11132 1 0 Mshowa

p

.002 w

.02381 .20793 m

.03006 .20793 L

s

P

[(400)] .01131 .20793 1 0 Mshowa

p

.002 w

.02381 .30454 m

.03006 .30454 L

s

P

[(600)] .01131 .30454 1 0 Mshowa

p

.002 w

.02381 .40114 m

.03006 .40114 L

s

P

[(800)] .01131 .40114 1 0 Mshowa

p

.002 w

.02381 .49775 m

.03006 .49775 L

s

P

[(1000)] .01131 .49775 1 0 Mshowa

p

.002 w

.02381 .59436 m

.03006 .59436 L

s

P

[(1200)] .01131 .59436 1 0 Mshowa

p

.001 w

.02381 .03404 m

.02756 .03404 L

s

P

p

.001 w

.02381 .05336 m

.02756 .05336 L

s

P

p

.001 w

.02381 .07268 m

.02756 .07268 L

s

P

p

.001 w

.02381 .092 m

.02756 .092 L

s

P

p

.001 w

.02381 .13064 m

.02756 .13064 L

s

P

p

.001 w

.02381 .14997 m

.02756 .14997 L

s

P

p

.001 w

.02381 .16929 m

.02756 .16929 L

s

P

p

.001 w

.02381 .18861 m

.02756 .18861 L

s

P

p

.001 w

.02381 .22725 m

.02756 .22725 L

s

P

p

.001 w

.02381 .24657 m

.02756 .24657 L

s

P

p

.001 w

.02381 .26589 m

.02756 .26589 L

s

P

p

.001 w

.02381 .28522 m

.02756 .28522 L

s

P

p

.001 w

.02381 .32386 m

.02756 .32386 L

s

P

p

.001 w

.02381 .34318 m

.02756 .34318 L

s

P

p

.001 w

.02381 .3625 m

.02756 .3625 L

s

P

p

.001 w

.02381 .38182 m

.02756 .38182 L

s

P

p

.001 w

.02381 .42047 m

.02756 .42047 L

s

P

p

.001 w

.02381 .43979 m

.02756 .43979 L

s

P

p

.001 w

.02381 .45911 m

.02756 .45911 L

s

P

p

.001 w

.02381 .47843 m

.02756 .47843 L

s

P

p

.001 w

.02381 .51707 m

.02756 .51707 L

s

P

p

.001 w

.02381 .53639 m

.02756 .53639 L

s

P

p

.001 w

.02381 .55572 m

.02756 .55572 L

s

P

p

.001 w

.02381 .57504 m

.02756 .57504 L

s

P

p

.001 w

.02381 .61368 m

.02756 .61368 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .04056 m

.02505 .04056 L

.02629 .04057 L

.02753 .04057 L

.02877 .04057 L

.03001 .04058 L

.03125 .04059 L

.03373 .04061 L

.03621 .04064 L

.03869 .04068 L

.04365 .04077 L

.05357 .04103 L

.06349 .04138 L

.08333 .04238 L

.10317 .04371 L

.14286 .04718 L

.18254 .0512 L

.22222 .05501 L

.24206 .0566 L

.2619 .05786 L

.27183 .05835 L

.27679 .05855 L

.28175 .05872 L

.28671 .05886 L

.29167 .05897 L

.29415 .05902 L

.29663 .05906 L

.29911 .05909 L

.30159 .05911 L

.30283 .05912 L

.30407 .05912 L

.30531 .05913 L

.30655 .05913 L

.30779 .05913 L

.30903 .05913 L

.31027 .05912 L

.31151 .05912 L

.31275 .05911 L

.31399 .0591 L

.31647 .05907 L

.31895 .05904 L

.32143 .05899 L

.32639 .05888 L

.33135 .05874 L

.34127 .05836 L

.35119 .05785 L

.36111 .05722 L

.38095 .05563 L

.42063 .05165 L

.44048 .04966 L

Mistroke

.4504 .04879 L

.46032 .04807 L

.46528 .04779 L

.47024 .04756 L

.47272 .04747 L

.4752 .0474 L

.47644 .04737 L

.47768 .04734 L

.47892 .04732 L

.48016 .0473 L

.4814 .04729 L

.48264 .04729 L

.48388 .04729 L

.48512 .04729 L

.48636 .0473 L

.4876 .04732 L

.49008 .04737 L

.49132 .0474 L

.49256 .04744 L

.49504 .04754 L

.5 .04781 L

.50496 .0482 L

.50992 .04871 L

.51984 .05013 L

.52976 .05214 L

.53968 .0548 L

.5496 .05819 L

.55952 .06237 L

.57937 .07334 L

.59921 .08809 L

.61905 .10691 L

.65873 .15694 L

.69841 .22226 L

.7381 .3009 L

.77778 .3943 L

.81746 .50423 L

.82738 .53184 L

.8373 .5573 L

.84722 .5788 L

.85218 .58746 L

.85714 .59441 L

.85962 .59719 L

.8621 .59946 L

.86334 .60041 L

.86458 .60123 L

.86582 .60191 L

.86706 .60246 L

.8683 .60288 L

.86954 .60316 L

.87078 .60331 L

Mistroke

.87202 .60332 L

.87326 .60319 L

.8745 .60293 L

.87574 .60254 L

.87698 .60201 L

.87822 .60134 L

.87946 .60055 L

.88194 .59857 L

.8869 .59311 L

.89187 .5858 L

.89683 .57684 L

.91667 .52928 L

.93651 .4735 L

.97619 .36805 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{299, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\ntimeoffall = FindRoot[(theta[t]/.sol)[[1]]== thetamin,{t,0.4}]\n"], "Input",\

  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[OutputFormData["\<\

{t -> 0.6853363209889384}






\
\>", "\<\

{t -> 0.685336}
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]]
},
FrontEndVersion->"NeXT 3.0",
ScreenRectangle->{{0, 1085}, {0, 864}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{520, 600},
WindowMargins->{{Automatic, 172}, {68, Automatic}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]



(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1711, 51, 58, 1, 70, "Input"],
Cell[1772, 54, 66, 1, 70, "Input"],
Cell[1841, 57, 421, 7, 70, "Input"],
Cell[2265, 66, 539, 8, 70, "Input"],
Cell[2807, 76, 251, 5, 70, "Input"],
Cell[3061, 83, 222, 4, 70, "Input"],
Cell[3286, 89, 256, 4, 70, "Input"],

Cell[CellGroupData[{
Cell[3565, 95, 342, 9, 70, "Input"],
Cell[3910, 106, 350, 10, 70, "Input"],

Cell[CellGroupData[{
Cell[4283, 118, 132, 3, 70, "Input"],
Cell[4418, 123, 232, 16, 70, "Message"],
Cell[4653, 141, 232, 16, 70, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4917, 159, 97, 1, 70, "Input"],
Cell[5017, 162, 6345, 1079, 70, 6197, 1074, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11394, 1243, 128, 3, 70, "Input"],
Cell[11525, 1248, 5870, 1015, 70, 5722, 1010, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[17427, 2265, 75, 1, 70, "Input"],
Cell[17505, 2268, 7039, 1153, 70, 6891, 1148, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[24576, 3423, 110, 2, 70, "Input"],
Cell[24689, 3427, 4869, 841, 70, 4721, 836, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[29608, 4270, 94, 1, 70, "Input"],
Cell[29705, 4273, 147, 14, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29884, 4289, 89, 1, 70, "Input"],
Cell[29976, 4292, 283, 16, 70, "Output"]
}, Open  ]],
Cell[30280, 4310, 127, 3, 70, "Input"],

Cell[CellGroupData[{
Cell[30430, 4315, 196, 4, 70, "Input"],
Cell[30629, 4321, 281, 16, 70, "Output"]
}, Open  ]],
Cell[30922, 4339, 512, 11, 70, "Input"],
Cell[31437, 4352, 329, 9, 70, "Input"],

Cell[CellGroupData[{
Cell[31789, 4363, 122, 3, 70, "Input"],
Cell[31914, 4368, 5442, 929, 70, 5294, 924, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37388, 5299, 232, 7, 70, "Input"],
Cell[37623, 5308, 6464, 1075, 70, 6316, 1070, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[44119, 6385, 248, 8, 70, "Input"],
Cell[44370, 6395, 6144, 1001, 70, 5996, 996, "GraphicsData", 
"PostScript", "Graphics"],

Cell[CellGroupData[{
Cell[50537, 7398, 76, 1, 70, "Input"],
Cell[50616, 7401, 7700, 1199, 70, 7552, 1194, "GraphicsData", 
"PostScript", "Graphics"],
Cell[58319, 8602, 161, 14, 70, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[58521, 8618, 107, 2, 70, "Input"],
Cell[58631, 8622, 248, 18, 70, "Message"],
Cell[58882, 8642, 147, 14, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[59061, 8658, 95, 1, 70, "Input"],
Cell[59159, 8661, 133, 14, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[59324, 8677, 232, 7, 70, "Input"],
Cell[59559, 8686, 7766, 1201, 70, 7618, 1196, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[67357, 9889, 243, 8, 70, "Input"],
Cell[67603, 9899, 6399, 1071, 70, 6251, 1066, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[74034, 10972, 288, 8, 70, "Input"],
Cell[74325, 10982, 6257, 1047, 70, 6109, 1042, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[80614, 12031, 241, 8, 70, "Input"],
Cell[80858, 12041, 149, 16, 70, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)
