(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     27568,        594]
NotebookOptionsPosition[     26634,        558]
NotebookOutlinePosition[     27190,        580]
CellTagsIndexPosition[     27147,        577]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

An Incremental Motion Device.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell["\<\

Dd = 2 L Cos[45 Degree];L=1;
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell["\<\

thetadot = -300 * 360 Degree / 60;
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell["\<\

function := Block[{beta,h,betadot,vrel,betaddot},

    theta = theta//N;

    beta = If[theta>45Degree,45 Degree,

\tIf[theta<-45 Degree, -45 Degree,

\tArcTan[Dd/L - Cos[theta],Sin[theta]]]]//N;

    h = If[beta==0,0,L Sin[theta]/Sin[beta]]//N;

    betadot = If[theta>45Degree,0,

\tIf[theta<-45 Degree, 0 ,

            L thetadot(Cos[theta]Cos[beta]-

            Sin[theta]Sin[beta])/h]]//N;

    vrel = betadot h Sin[beta] + 

         thetadot L Sin[theta]/Cos[beta]//N;

    betaddot = If[theta>45Degree,0,

\tIf[theta<-45 Degree, 0 , 

         1/h(-thetadot L (Sin[theta]Cos[beta]+

         Cos[theta]Sin[beta])-2betadot vrel)]]//N;

    {beta/Degree,betadot 60/(360 Degree),

         betaddot 60/(360 Degree)}];
\
\>", "Input",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"function", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"theta", ",", 
     RowBox[{
      RowBox[{"-", "60"}], " ", "\[Degree]"}], ",", 
     RowBox[{"60", " ", "\[Degree]"}]}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF2Hk0Vs0fAHBCqWSXPVEiSxHZmXl47k2RJFSihLRZizZLsmQvCS1K2hfi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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{(-60) Degree, 60 Degree}, {-45., 45.}}, {{-1.0471975511965976`, 
    1.0471975511965976`}, {-45., 45.}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.518437225476*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"function", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"theta", ",", 
     RowBox[{
      RowBox[{"-", "60"}], " ", "\[Degree]"}], ",", 
     RowBox[{"60", " ", "\[Degree]"}]}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1],
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF2Hk0VV/YB3BjIhlCkpnSQBmbUNuUoZAh85AkJZnKWDLee0xl6OdKMpPM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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{(-60) Degree, 60 Degree}, {-724.2638814667828, 
     0.}}, {{-1.0471975511965976`, 1.0471975511965976`}, {-724.2638814667828, 
    0.}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184372268332*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"function", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"theta", ",", 
     RowBox[{
      RowBox[{"-", "60"}], " ", "\[Degree]"}], ",", 
     RowBox[{"60", " ", "\[Degree]"}]}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1],
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF2Xk0VV+8AHBDKUVUIiRjIkIpSbJ3lBQpKpmKVCoZKw2SFEKGJEOTIZnn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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{(-60) Degree, 60 Degree}, {-37289.55821764965, 
     37289.57379110126}}, {{-1.0471975511965976`, 
    1.0471975511965976`}, {-37289.55821764965, 37289.57379110126}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184372281436*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 134, 7, 191, "Title",
 Evaluatable->False],
Cell[694, 29, 194, 10, 65, "Input"],
Cell[891, 41, 200, 10, 65, "Input"],
Cell[1094, 53, 773, 39, 643, "Input"],
Cell[CellGroupData[{
Cell[1892, 96, 347, 10, 31, "Input"],
Cell[2242, 108, 7356, 127, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9635, 240, 464, 15, 31, "Input"],
Cell[10102, 257, 6157, 108, 239, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16296, 370, 464, 15, 31, "Input"],
Cell[16763, 387, 9855, 168, 238, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

