(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     22739,        654]
NotebookOptionsPosition[     20814,        583]
NotebookOutlinePosition[     21370,        605]
CellTagsIndexPosition[     21327,        602]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\

A Sliding Ladder.
\
\>", "Title",
 Evaluatable->False,
 CellHorizontalScrolling->False,
 TextAlignment->Center],

Cell["\<\

This is the nonlinear equation to solve.
\
\>", "Text",
 Evaluatable->False],

Cell["\<\

eq := (x^2-L^2/Tan[beta]^2)-2 x L u + 

          L^2(1+1/Tan[beta]^2)u^2==0
\
\>", "Input",
 PageWidth->Infinity],

Cell["\<\

Ordinarily you cannot find an analytical solution but this equation is merely \
quadratic.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell["\<\

uis = Simplify[Solve[eq,u]]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"x", "-", 
        RowBox[{"x", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", "beta"}], "]"}]}], "-", 
        RowBox[{
         SqrtBox["2"], " ", 
         SqrtBox[
          RowBox[{
           SuperscriptBox[
            RowBox[{"Cos", "[", "beta", "]"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"2", "-", 
             SuperscriptBox["x", "2"], "+", 
             RowBox[{
              SuperscriptBox["x", "2"], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", " ", "beta"}], "]"}]}]}], ")"}]}]]}]}], ")"}]}]}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"x", "-", 
        RowBox[{"x", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", "beta"}], "]"}]}], "+", 
        RowBox[{
         SqrtBox["2"], " ", 
         SqrtBox[
          RowBox[{
           SuperscriptBox[
            RowBox[{"Cos", "[", "beta", "]"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"2", "-", 
             SuperscriptBox["x", "2"], "+", 
             RowBox[{
              SuperscriptBox["x", "2"], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", " ", "beta"}], "]"}]}]}], ")"}]}]]}]}], ")"}]}]}],
     "}"}]}], "}"}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.518437247666*^9}]
}, Open  ]],

Cell["\<\

Notice that there are two answers, we need to find out which one is correct.
\
\>", "Text",
 Evaluatable->False],

Cell["\<\

par := {L->1,beta->60 Degree}
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell["\<\

Plot the first solution using some specific parameters.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"uis", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}], "/.", 
     "\[InvisibleSpace]", "par"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1Ps3lHkAx3GkVSkRyiTakUpSqZQt1cfibK1LjkvRSVJRSBdyVnZFU26F
pW22bC4JsYghVJh8HUll3QcjZp5HY3IfjzaSLmbbH97n9R+82cfPOfsoKSgo
OHzrf219htpqhg/sOcFLYuRymihbLz9Ps8zAdzfWtPhCk613k1NLWTYIVZGq
//KRJnZNwodpLFcEBz6+MzpBEzfv6ad/sLyxx5Ia7HhDE/GmGOsEVjCuHTTy
zXhGkwxtx+jrrEjY7QpR0I2hCWde6dprLC5sNyTEpy+iifuhe7yJd9noD/s4
bqJMEVU5x2OvPg+9xTLL5vlistppfOhZXBky9V0iPmuISEjzDiRPVqBQlHgr
QqmXLCvToBQVCRzDB9szlHrII4l1Y8uuWtzgVOTcHukmtf5puofG6qD2p/AR
1SEkU2t2Ly488wINYS8r7Fu6iNJMgbru6gZIk8V2A8WdZLvc65FLUSPkMhfV
4cwO0hhp1lxv3IKFE/nZNbcFZGXS6EzeeCsaMnVyNS+0k9Fpmuo0bQcEN484
HW0j2SNVDWq/C2B9v18SvLmVqOnlMlJpB+Zuyqg3WdhM4v3KT2YYdkHt/TET
u+5/yAfLAqlvhBAJATLN1LOvSPCWurKlz7oRrXwsxtLoBaGL6uLa2D0Imzl0
luTXkc/+HSnrfu3FwwuaZkZbasn6H1VmT1aJ4JbmeLOhipC9mexTJcsorM8p
XGN6r5KE6B01eONBI84910m3tZyYjB1QFTr0wcuT94C7oIRoLp6YV/epD2Ou
53flpeUSZZLCW5X6BpYfit0mQ1PIabOq1/PtJOhTtZVP2ISQgp+PZ1R/kEDd
1G9RkF8ipkaXqw/c6kd812BOrVImyl32zuHaSBEfPnowZ10hIvZF3S0bkKLS
IvN7z55SsMW23VlRb5E/YdMyq12BneaRXNaWAWgFlJQaCqvhod8yoygYADev
0cDPsBZTDQmS85xBMNYn7XoNniNZ2TPY2XAI1WwmMmzmBTSp8kyluiH03gnx
rm5swNxLHNcdgcNIibZatm2kCQp5njzJkhGUSz758M+1IugOL2FJ7QhiKlUS
8zTa8XR97DyNs6PQmRYXOJYJoGEbZHJFbQz6KqOP31t1QrShVRDKH0N61ncT
A1+6UJwOQ6mnDMba/Q+SsrpxhLddQ29WBq1/C3IC7HtwOeoeR5Q/jic1mg4Z
a0QoHNJLUbNn4NUY5eHIiBGbFuVF7WdwaoF5h++0GN7OstVFTgymZOGxV+Vi
rODzix3cGPiydubzF1O4nni4Pv44g3eXz4zsNqXgu/2vdwtCGRRZtbMvBVIw
iNTap5LDoGrOnpeTkxRmfwhbJPybweulrQnmXym8lvW35xQwcB87XPjbXBpJ
bqVHfiphcFrkOauylIbc2PlCFJ/Bivn7lTeb0xC1JabPETCIo9ZGPw+l8SR6
+oSgk0Fg/Fsf/Ss0uBZH12V1M5jdsbX44nUadvc3lllRDFJbOmM3p9CovNj0
ijPMQFt33LeMT+PWhm2JTmMMztULq3Se0wiUpLqyGQb6amuvhDfRMLIPoGsm
GTwICj+zn6KhrNiRnTTNoJvTzH0yQKOv3MLf6xODVTpaZoYMDb5/1ibTrwz6
N4bY35imcXul6pRczqDVk01/+xf+A4s+kNM=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {-0.4999999846938776, 0.4999999693877557}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184372530948*^9}]
}, Open  ]],

Cell["\<\

Now plot the second solution.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"uis", "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}], "/.", 
     "\[InvisibleSpace]", "par"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1Ak8VFscB/ARRYu1UsQTISrxtGn9FULyKlJaSAl5kkraJFKUSDxPEi3a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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.5},
  PlotRange->{{0, 1}, {0.5000000153061224, 0.9999999999999994}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184372549044*^9}]
}, Open  ]],

Cell["\<\

Choose the second solution since cos(theta) ought to be positive.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell["\<\

costheta = uis[[2,1,2]]
\
\>", "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{"x", "-", 
    RowBox[{"x", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", "beta"}], "]"}]}], "+", 
    RowBox[{
     SqrtBox["2"], " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"Cos", "[", "beta", "]"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         SuperscriptBox["x", "2"], "+", 
         RowBox[{
          SuperscriptBox["x", "2"], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"2", " ", "beta"}], "]"}]}]}], ")"}]}]]}]}], 
   ")"}]}]], "Output",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{3.5184372574004*^9}]
}, Open  ]],

Cell["\<\

Plot this versus x/L for beta=60 and L=1.
\
\>", "Text",
 Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"ArcCos", "[", 
     RowBox[{
      RowBox[{"costheta", "/.", "\[InvisibleSpace]", 
       RowBox[{"x", "\[Rule]", 
        RowBox[{"X", " ", "L"}]}]}], "/.", "\[InvisibleSpace]", "par"}], 
     "]"}], "\[Degree]"], ",", 
   RowBox[{"{", 
    RowBox[{"X", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVjnk01AkcwIeZtuTlyPWGRYp1lFKOSHy/jFwz02FE3o4jEVFtIyW7aVYh
HaLWVos0SVQqlWM3JiTZl+ceQsuYGAwz/NhoUpht//i8z3+f9zEJ/8kvUplE
IjG/8b99IyUddeN7XbPZyXKFgokUmv6xQaodVJJk9FVLTLS9fTOvjOoBvwf4
8/QXmEhv6Xl+i+oP94XaPvafmRgYIX95jRoBgg7tnJhpJg5sOk/LoMbDd+2q
jt0iJvJ0dqVdpKbAfvpz1sNXTExeUWZ+gZoNZ2Or0lnnmLgv6E7p9EwhWA+N
1BgvMFBVkcz2MioFjaKHsS1JDDTbMyV5fakc2Oc/zfcqMTCh1Qluzr6A2STb
EMdf6KhXrilUUqqFmvTWnP2Lvlg5RGtu214P+RrNSbXxvlgfc8sgSNYA5v25
AYwpH5z7wUX98ZG/IVg3b+3VYz6oPF+iYWDWBNzqWmn3mDc6KMIqWU+aIUhP
ntUY5Y3NKXatjVZt4JyQOdIy7oXGWdL5B1PtwDxDEd0I80KpfFDYbdMJ9XXU
BIrIEwsnqpvUrgiAc23l/SWWJ6oZFhNicRfkN8rr2t/uwMuHKg7yTN9BtPcD
spv3DvyEJeJobg+kTTWdGK/ywPgtDeW6r3tBV7DzioWDBw4+abjUYfIeKP5s
VsA9Gn6N6cq1/PkfOCTQlOrp0nC92/Klg9X9UORoXczJdEevApOoZ3pC0LH3
WqAtuGGCYejaD+xBiKM81i7muOEG2V7VHqYIyHJLx0wJopb69IqGLyKIPHjt
eIQfIqU2t3Rd3gdoLZ7UzL8AGGtX3adCH4KcjIV3LJYrlviE82o+DcHwxyiT
ZcYuOCfV1xi9Pgyxq7fayL46YwXLi5ztIYYy7jYtKn8bcr1Tb5ePiuEN91/9
4AwnNBnw7b2bOgKHR3gBoWGOuG1rSjZ1yyhkxSk7PNLeimyjtnklwShcdnA/
s/y9Pc41ZQwdSx4DM+kjXtcZO7xJCYn3M5UAtcwsJNLOFrWEFQXKDRLoV9m3
W3tiMy5LSvZ34oyDl6cWTfm0DZIehJQOrZ4ALYYzrWz7RozLKc1YXT8B7gon
dp7teny5Pn2F5lEpcFJ3ta1aZ4GavnEbzqrJQMUhrLZgsxn2W7cLEvkyuPBW
mUwfNcGn+WAqDpkEj1HzUNERQwwuddA0XJoEktpGXtRHXfw19U5y/8MpULic
sh9wUcfHEsNcNQYBOk5iS/MxEqbfSg0T7iTA8GUg59w9Ekb4TZo92UOABE5W
th8g4fd8/lNmIAEnBj7qnK5TwMXMHxsvhxPwdTzb7M3TRYh2+GNmZSIBs8XW
tlcvzcPaFG3v5UXf+ux1/uGWM7DkeHpVz30C2njP660KpqFvcrizqISATrKC
0qk/DVmBZcGezwjoy5VbJ+p9+7TyO57KJ0DFYFfbYs849Hdk5pMFBFzn7p9x
ZXyAv9LkBwTdBHCnX8synUSQ7RxqebeXgM/qRov2TCHQ720sdxcSQB/OkvEV
fVB1quVt8jgBY4nTdhYhHXDd2j5zj4wAIdeghh/dCpyhPH8TggBxp1WHinYT
WDAOD9bNEvBnySDDPeoVUJS6CrPkBKwx9UsKNKoCUYVzTNgXAl6QVcji2GfA
j7m7yWaRAJpEHLT76B24Yaw6p1AQULjm5G915DrX/wCnB1IQ
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {0., 59.9999989873551}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.518437259132*^9}]
}, Open  ]],

Cell["\<\

Now define the speed of point a.
\
\>", "Text",
 Evaluatable->False],

Cell["\<\

xpar={xdot->1,xddot->0};
\
\>", "Input",
 PageWidth->Infinity,
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell["\<\

theta := ArcCos[costheta];

td := -xdot/L (Cos[theta]Tan[beta-theta]+Sin[theta]);

tdd:= (-xddot Sin[theta]-(xddot Cos[theta] + 

             L td^2)Tan[beta-theta])/L;
\
\>", "Input",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"N", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"td", "/.", "\[InvisibleSpace]", 
        RowBox[{"x", "\[Rule]", 
         RowBox[{"X", " ", "L"}]}]}], "/.", "\[InvisibleSpace]", "par"}], "/.",
       "\[InvisibleSpace]", "xpar"}], "]"}], "\[Degree]"], ",", 
   RowBox[{"{", 
    RowBox[{"X", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1Gk41PsXAHCpUGSrbpcIWUpp0r2UhENaZrHPMFMyyBZtSFeUxDVde5Qm
5Ea2LHcaWVKkvtXETbZQiAaTZP/Vv+ja/18vznOez4tzXpzznKNx/KyDl7iY
mFgOjqVM9Rp6i4YdzTS/BiraNpPRCktl/14lA3BU3ayx5N8zUzPKlA6Abx7J
eskDKloRwTo2YBibyl0yrbGj9G8lBrxqcp1fsla8at6i2hHwCI6KsMOeo3rc
ctdhQ0KMhKY99khUu8Cd6w4z0oP9S2Z6/qy5ruQJmRKaTx2wBZbKlS8zvCEn
sqaSjq2vaVryQ80XfGMrmhjYGeJuhdo5J+GarvRyJ2wpUWS2k84Z+HLqKYOJ
XdXX2viS4Q9Xjje/ZGH723lSj3ED4I6Smd1R7I87/7JMUAqCe3KGz12wUzJ/
RdrO52HPuZo8V2yqXJHJ04w/4G5/zj137IcTDYaEWgggw7jl3tin2OzSv9xD
YYAS73ICe3MTQVLPuQjo1Wi7H3YiT3Grvc5l+Mqu3eiPfVA1N3fYJxzCyi1G
A7Ev16bLP2dcgZ2ijZ3nsQ126yUc4UbAF8vxVZews9bbXo1VigLz95JNMdgX
G28JnKqiQCY9LDoB24nTJ67pzIE4e7pbMrbMZEB4dcZVyDFXO5GGfaE95cKY
Wgw0DJp2FmHT4z8+fIRigCT5KIyPTTqgMxnlHgvrOTfMy5f2WVYZoJoTB3e8
zm56im1/44OfjU4imN1Axm3YejTNQuW6RPjsT3vTuTTv5ae+DPpcAwPPvSFC
bNfHCw+eMZJgazjsGMFer5tEYnGTwTxwdlK8hYwipMq2xCilwLUHp1cbY287
nBxd6p8CBs/FFfdjt3LODnfXpcBIv44JFVtruV4x6Y+bcOab6n9HsWvnc0nt
rVyQGWiVvYwt851rqBafBqYRVZX12BW7znPJn9LAmRY01I7N9qf/DDBOhxYn
wb5ebP643GPBUDoY7tWl/sB2GIo28TuYAfrP1kmovyWj1I+hlhULd6Bvfmwm
DNtC5Uiu0DETCixojrHYI0f3rJTiZcKLQnIrF3vTWIgHb0cWkJw1DUqwz/ru
1hbryQJmi++tAWxFT35BnlE23Jdo7KG3khHryF3+12+5EEl/72PVRkZEN2N1
tnIeeLYdmHXGvsqW8qJb5sFi+tQ/J7HLPM4qP0zJA+tSnZNx2LJnTDkX9+RD
gHqDQwP2q8iuoxJh9+C7yetmejsZ/faPgoSKVBHMbK3mhLwjo9ekV26N+tgz
/4nisd0eXKi+fKQIypSus7OwEx72+vcXFcGzm10lddhDiNedb10M20zfPd/w
nozuvKM82HXjHzDdb8GtwZZejDh2eBMfNu6ykFPvxPPyZbL1DvFBq1bs1W5s
rXY9N4UzfIgVrUq1xjYr7PDoruFDefDczYvYjwu5FZWkEjAQhH3rxB6njz2h
NZWAYVD9lrQuMnIsuPXm3JpSUKanpe7sxvftEmnlrVEKQZvOT1OwRYqnG1mG
pZA9VxXsiX02bH+zqUsptDjGNKRhxziMt0rySuH3cNuOlT1kVDO3/8NtqzIo
6g8L/IStbT8x9DKuHA6JX60rF5KRcvhhY5+75bArPtbrHbY8LytudWU5zM4w
daawZ6ToJHtROaQQdHmjXjJqQZXnhEYVoBMwz6nBDtWPWPjvcwUEB12dbuoj
oya5detI5pWQGEJZI/OJjIKb9kLqj8fwIEvbiviC90eq+Pxaqgq2X6YMrh8i
o9wE/fhZlSq4Ercp0wT7rdWWLvbBKgjrFp2Kxd7+Zt05bW4VyOksD9kyTEa9
dUR+6Z5qeJqs6ugzQkaHn+fJNoY+gXhO99aFMTLaUK4gXLbsGXzg/5ob/T/8
r0SWDc0mL4CpvkvbSIyCXvj9vfHImACS04kVY3IUNKljKsc7XQfF5vNyOeoU
JD5dLL9Rux4KjhSEKhpS0O5Ft4f0+w0Qc7DxhBuVghqiDJpqtzWDtTnI+7pT
kFrS6HThRAvQZG5miC5R0OjPXuE7/VbgjTEaJ1IpKHekul42sQ0c41W+yVdR
kKzqPWJgoB1eWU8+uvCRguJ9K7yztN6DMDkkTW8ZFU2ZFw+cCO8A9lRR9NQ2
Kgr6TVD+y8tOYErXV84xqKj3viDurcYHYAQx0TyHimb92m/rhnZD6D7erebH
VLTdQnLBu7oHktekdxeOU9HhbA2fBxuEEHb1DfO7Lg0Fq7pu7j/WC/m1311t
vGlIb8xRusO6D76fUbSIz6OhtXJfpQQzfbDAzcldRdDQime3+ZoZ/eDJ+cUr
1sgKnTSo7lpFE4FW+Q4vsUQrVEw5nvV0SgRlR3mrLIes0OSosvwg9xMUX39R
krXfGlXQDy9POTAAUT3NOnPF1iiczMksHxyArqZm48H1NkjjI7Uzh/MZRuqn
J6M4Nsh4T1SK0m+DYCch43xQyhYd29Q8vaxtEPJrLjZQ4m3RZH2CyD/iCwSG
FR9tWWuHUlewgxy0hsDqjU/tv8ft0FphRba4YAjCb5mJSVbaoZVhEYy9AcNg
YyGwX7/RHokVsvkixRF4Je6oXh9hjwLT+QmKL0ZAfEPFZeGcParZHi2lcGYU
2Ml10ff+dEAK1EC9SNkx2LeOIaMqT0c9O1raQp6MweNqRd3sajoquQNaA+xx
+N+5e1LcAAZy4e9WUF0Yh7K4gnE5U0d0hXM3oqdoAjy2mNX/NHFCa4Ilqe68
Cfhcf0NlhYUTSj9xWnGQPwGdfZKzigedUBltbw5RPgHZwze9jayd0KDCW4H4
swn4a4O6RbaLE6LdEZPSbZuA7YFjTj8uO6FfKl0Tz8/i+lHpk3kvnRBvSPW2
rBUB1pH9oQOOTBT9N8dNaEMAtc1MfK8zE3k6jGvftycAKbnxkt2YSOXJkxJr
JgFdow//tD3JRLHXnGvjjxPQwvpdMH+FiU7sTvu2OoQAmSlXW10eE22OWkeW
zCfAVCL93IAUCy0YXVrTUUDA4OqnJv/KslDX+KfW/GIC/+cZUck6Fkpilrkc
eoD7u9b1Jamz0OI2h3OcJwRMGz4/Gm/EQj1vr91Z3kZAdYeWcbAvCz26+tOj
7R0BQqrLXPFZFkrZ56qb00mAxfXCVYPnWYiWRyrfLyQgPal1s18kC1VdaHwd
MUyAtEu3WtltFuLuMLxmP0ZApkHt6rXZLBQgymBoEATc5X65dKGAhbZanepF
Pwgw05lZz6hgoRXL2nOTfhJQ3H/Pqr6ahfoq9vm5zRDQmbZy26EXLPTEL2en
/jwBe4S/Pqz7l4VuqUlPLi4S4GZ7esammYX+D0qQLtw=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, -100.},
  PlotRange->{{0, 1}, {-99.2391954486352, -49.61960058796128}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184372648571997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"N", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"tdd", "/.", "\[InvisibleSpace]", 
        RowBox[{"x", "\[Rule]", 
         RowBox[{"X", " ", "L"}]}]}], "/.", "\[InvisibleSpace]", "par"}], "/.",
       "\[InvisibleSpace]", "xpar"}], "]"}], "\[Degree]"], ",", 
   RowBox[{"{", 
    RowBox[{"X", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->DirectedInfinity[1],
 FontFamily->"Courier New",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->GrayLevel[0],
 Background->GrayLevel[1]],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVxXs00wscAHB5rhQtrztSZ5pcSaQsLXxTCqW6i5J5jZkhJa5u5ZFHSyhO
OdWklEpXJJR55WbfWHZ0kylFD0Ty+v02PdFVuvf+8Tkfekj0Tr6qiopK4H/+
fwt/pANHdzn/cZW5YSyhpFF9o/GBPtpq8O1/ox/DPSFZdSXvUhXNFc4dyrrg
zBVJtrZ13S2geYM4o0jXglss8QmdvJ9LCwXHqXs0M26tpMfmxMZsWhys66O8
ZnFlkkKDHelZNCHUBzjbiLldklRKlUUm7SzwbqzpKAoZluzxvVrx4WMRZGaK
TeIFUxLtn6n+bosqwPPtqZ6TVqpozlaONJ8Ug8ApXSOJSsFDT9ZC3pd6oPMr
jxRm6qCRmNo7a5YEDniyL0R5L8CagY2P2x2bIFoYKNIWG2BTZIGJLymFLYb7
n7sa0PDrUifd2/tk0JpQLI/ZvhBVv92ab2L+CLykllXT7xYj8ye3xqv8MUSa
W5VGl9LxsXD1k5Zl7cDsaDM1EizBxaeJbyVKOXTOxMB9X3MkJvt6n9s+hVpx
Kmo6WmDRWMMjnZxnIHsgms7xs0Qd0+LxwcFO+GQQ2yjKsMJTEdVhhYwXED5W
qRVRbI0T628Nhid3gbyk/pwTxRbj7KRiw+ZuMCvtlvxgrsS+cunJDvorKNpk
6vjjtB1OR3ZetIx/DbnSruHxqVVo5aI1E9bwBlbepQYT/vbodo0uuGPUC8ns
PZ1HJpl4yDTIrN+/Dzrq6xIvnHbA5eQu7a5tb8Ftk8N1iSML9XQ/UKT/vIUn
0NpuZ+OI6pKLFUsu9cNy7ZXZtgxn3Lu64eXsrQMAV4VtlWvW4y2PkMLGiQHQ
EFpUs2Nc8CthPH/o/Ds4QeU1lVVswGovN7WzroPwzoEVvcTSFZPdj18RDw1C
s9aa8GVlm5Des6X7+vH3sHt47adJTzdkrRGepdkNAZ99OUjs4oH+i9q/zXo2
BDJCsrndYyt+fZQ9cCB1GHTmcjanP9iGeeqBcTsZIzBoP6+aa/0b6vVWX1OV
jsAxzS8uwgI2aiSleq+NGYUCvRk/P74XqpQEVgwsGIM9NrbFxjt2YWx+RfaC
pjHwmleu7l7ng/etMijU/QS0OlwbTj7GQWanUVvuAQIKE033vsnhYGVi8Rn9
3wmYW8aOWJ/PwWttLca/HCYg6kbtx0V3OJgRrWG9OI2A0pD5k8w+Du6sSmNb
nyfgMeuo/ktHPxxmJeV7NBJQk7Qiijbjh9QtscvTdEiQZR01d88PwMIHutos
KgkUq6HBgZsBaLv29uhHPRJcQoiOjNoA3P7ryJ/BNBJYTgb8ic4AzNIMpLsw
SFD7nvrQd34gqjd7GKqwSFiaNeLlmRmIE+voKkf5JPgk+iesEwbhG2v5syN/
kdDaELa+TM7FKwQ1SU1CgvCSSONHNxdDSryWZj8gIfrRnXXe/VwcZXQdLmwh
Qbz7vqHhJy5OmPSayuQkTHfRdozoBSN1DinQf09CDrGT3rYnGDcPaX0vn6cA
UYG9Q9twMFZeBsZgoALUTCogbiEPP8d/1goOVoCTunhl1FIeMn2KiR6eAqQv
u32jbHnYoKtb1RWuABmZG3vclYctKb0uf8cqoNSB88xkHw9fhyQF3U1XQMK9
TGW/hIeaFg35KeUKOJOZk20SFYoeatFHf1Qq4KFuWJv1oVA81WcWEl+lgOa0
96c90kKRmpdlGVengOm6V/KCvFBcOJtTJ2hSgM54Svy9h6FoR0w93/5CATdt
TN4+ofMxoIJJNZ1RAIPhuqGhn481nCkduYoSLnI9ZGbjfNTRvDf3mJoSjHVn
B4i+8xH9nSijFCVIenxVbxqFodkc159iPSWUuxbaRmwPw6FQtsLTUgkf3Isj
EhrDcL9xVGuitxIi3I1aw0sE2PLQWmbjowRpysEzojoBLo4Zlw74KiElnzb6
XCZAuSwW3YOUMOnWdyV1SIB2B4/U6kcqob/F/qaIEY6T7ek3ypKV4JxQKXp6
PRzVKFErNPOUYOsCtFxWBP4LCcfwjA==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 1}, {-201.8303343043749, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184372664172*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 122, 7, 191, "Title",
 Evaluatable->False],
Cell[682, 29, 87, 5, 65, "Text",
 Evaluatable->False],
Cell[772, 36, 125, 7, 99, "Input"],
Cell[900, 45, 137, 6, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1062, 55, 76, 5, 65, "Input"],
Cell[1141, 62, 1577, 51, 59, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[2733, 116, 123, 5, 65, "Text",
 Evaluatable->False],
Cell[2859, 123, 195, 10, 65, "Input"],
Cell[3057, 135, 102, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[3184, 144, 365, 10, 31, "Input"],
Cell[3552, 156, 2086, 40, 228, "Output"]
}, Open  ]],
Cell[5653, 199, 76, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[5754, 208, 365, 10, 31, "Input"],
Cell[6122, 220, 3356, 61, 245, "Output"]
}, Open  ]],
Cell[9493, 284, 112, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[9630, 293, 72, 5, 65, "Input"],
Cell[9705, 300, 686, 24, 59, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[10406, 327, 88, 5, 65, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[10519, 336, 412, 12, 43, "Input"],
Cell[10934, 350, 2078, 40, 246, "Output"]
}, Open  ]],
Cell[13027, 393, 79, 5, 65, "Text",
 Evaluatable->False],
Cell[13109, 400, 190, 10, 65, "Input"],
Cell[13302, 412, 218, 11, 167, "Input"],
Cell[CellGroupData[{
Cell[13545, 427, 457, 13, 43, "Input"],
Cell[14005, 442, 3747, 67, 241, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17789, 514, 575, 18, 43, "Input"],
Cell[18367, 534, 2431, 46, 228, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

