(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     23528,       3326]*)
(*NotebookOutlinePosition[     24381,       3358]*)
(*  CellTagsIndexPosition[     24337,       3354]*)
(*WindowFrame->Normal*)



Notebook[{


Cell[TextData["\nThe Shape of an Odd Body\n"], "Title",
  Evaluatable->False,
  CellHorizontalScrolling->False,
  TextAlignment->Center],

Cell[TextData[
"\nThe following is a program that solves nonlinear equations.  It was \
written by the authors and is not very sophisticated.\n"], "Text",
  Evaluatable->False],

Cell[TextData["\n<<bisect.h;\n"], "Input",
  PageWidth->Infinity],

Cell[TextData["\nEnter some specific parameters.\n"], "Text",
  Evaluatable->False],

Cell[TextData[
"\nl1 = 2;\n\nl2 = 3;\n\nl3 = 1;\n\nl4 = 4;\n\nalpha = 100 Degree;\n"], 
  "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nHere are the x and y components of the equations being solved.\n"], "Text",\

  Evaluatable->False],

Cell[TextData[
"\nxeq[beta_,gamma_] := l1 Cos[alpha] - l2 + l3 Cos[beta] +\n\n               \
      l4 Cos[beta+gamma-Pi]\n\nyeq[beta_,gamma_] := -l1 Sin[alpha] + l3 \
Sin[beta] + \n\n                     l4 Sin[beta + gamma - Pi]\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nHere is the one combination equation we attempt to solve.\n"], "Text",
  Evaluatable->False],

Cell[CellGroupData[{Cell[TextData[
"\neq[bpg_]  := (l1 Sin[alpha] + l4 Sin[bpg Degree])^2 +\n\n      (l2 - l1 \
Cos[alpha] + l4 Cos[bpg Degree])^2-l3^2\n"], "Input",
  PageWidth->Infinity],

Cell[TextData[
"\nPlot the function so we can see what it looks like.\n"], "Text",
  Evaluatable->False],

Cell[CellGroupData[{Cell[TextData["\nPlot[eq[bpg],{bpg,0,360}];\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.0238095 0.0026455 0.0240593 0.00947214 [

[(50)] .15608 .02406 0 2 Msboxa

[(100)] .28836 .02406 0 2 Msboxa

[(150)] .42063 .02406 0 2 Msboxa

[(200)] .55291 .02406 0 2 Msboxa

[(250)] .68519 .02406 0 2 Msboxa

[(300)] .81746 .02406 0 2 Msboxa

[(350)] .94974 .02406 0 2 Msboxa

[(10)] .01131 .11878 1 0 Msboxa

[(20)] .01131 .2135 1 0 Msboxa

[(30)] .01131 .30822 1 0 Msboxa

[(40)] .01131 .40294 1 0 Msboxa

[(50)] .01131 .49767 1 0 Msboxa

[(60)] .01131 .59239 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.15608 .02406 m

.15608 .03031 L

s

P

[(50)] .15608 .02406 0 2 Mshowa

p

.002 w

.28836 .02406 m

.28836 .03031 L

s

P

[(100)] .28836 .02406 0 2 Mshowa

p

.002 w

.42063 .02406 m

.42063 .03031 L

s

P

[(150)] .42063 .02406 0 2 Mshowa

p

.002 w

.55291 .02406 m

.55291 .03031 L

s

P

[(200)] .55291 .02406 0 2 Mshowa

p

.002 w

.68519 .02406 m

.68519 .03031 L

s

P

[(250)] .68519 .02406 0 2 Mshowa

p

.002 w

.81746 .02406 m

.81746 .03031 L

s

P

[(300)] .81746 .02406 0 2 Mshowa

p

.002 w

.94974 .02406 m

.94974 .03031 L

s

P

[(350)] .94974 .02406 0 2 Mshowa

p

.001 w

.05026 .02406 m

.05026 .02781 L

s

P

p

.001 w

.07672 .02406 m

.07672 .02781 L

s

P

p

.001 w

.10317 .02406 m

.10317 .02781 L

s

P

p

.001 w

.12963 .02406 m

.12963 .02781 L

s

P

p

.001 w

.18254 .02406 m

.18254 .02781 L

s

P

p

.001 w

.20899 .02406 m

.20899 .02781 L

s

P

p

.001 w

.23545 .02406 m

.23545 .02781 L

s

P

p

.001 w

.2619 .02406 m

.2619 .02781 L

s

P

p

.001 w

.31481 .02406 m

.31481 .02781 L

s

P

p

.001 w

.34127 .02406 m

.34127 .02781 L

s

P

p

.001 w

.36772 .02406 m

.36772 .02781 L

s

P

p

.001 w

.39418 .02406 m

.39418 .02781 L

s

P

p

.001 w

.44709 .02406 m

.44709 .02781 L

s

P

p

.001 w

.47354 .02406 m

.47354 .02781 L

s

P

p

.001 w

.5 .02406 m

.5 .02781 L

s

P

p

.001 w

.52646 .02406 m

.52646 .02781 L

s

P

p

.001 w

.57937 .02406 m

.57937 .02781 L

s

P

p

.001 w

.60582 .02406 m

.60582 .02781 L

s

P

p

.001 w

.63228 .02406 m

.63228 .02781 L

s

P

p

.001 w

.65873 .02406 m

.65873 .02781 L

s

P

p

.001 w

.71164 .02406 m

.71164 .02781 L

s

P

p

.001 w

.7381 .02406 m

.7381 .02781 L

s

P

p

.001 w

.76455 .02406 m

.76455 .02781 L

s

P

p

.001 w

.79101 .02406 m

.79101 .02781 L

s

P

p

.001 w

.84392 .02406 m

.84392 .02781 L

s

P

p

.001 w

.87037 .02406 m

.87037 .02781 L

s

P

p

.001 w

.89683 .02406 m

.89683 .02781 L

s

P

p

.001 w

.92328 .02406 m

.92328 .02781 L

s

P

p

.001 w

.97619 .02406 m

.97619 .02781 L

s

P

p

.002 w

0 .02406 m

1 .02406 L

s

P

p

.002 w

.02381 .11878 m

.03006 .11878 L

s

P

[(10)] .01131 .11878 1 0 Mshowa

p

.002 w

.02381 .2135 m

.03006 .2135 L

s

P

[(20)] .01131 .2135 1 0 Mshowa

p

.002 w

.02381 .30822 m

.03006 .30822 L

s

P

[(30)] .01131 .30822 1 0 Mshowa

p

.002 w

.02381 .40294 m

.03006 .40294 L

s

P

[(40)] .01131 .40294 1 0 Mshowa

p

.002 w

.02381 .49767 m

.03006 .49767 L

s

P

[(50)] .01131 .49767 1 0 Mshowa

p

.002 w

.02381 .59239 m

.03006 .59239 L

s

P

[(60)] .01131 .59239 1 0 Mshowa

p

.001 w

.02381 .043 m

.02756 .043 L

s

P

p

.001 w

.02381 .06195 m

.02756 .06195 L

s

P

p

.001 w

.02381 .08089 m

.02756 .08089 L

s

P

p

.001 w

.02381 .09984 m

.02756 .09984 L

s

P

p

.001 w

.02381 .13772 m

.02756 .13772 L

s

P

p

.001 w

.02381 .15667 m

.02756 .15667 L

s

P

p

.001 w

.02381 .17561 m

.02756 .17561 L

s

P

p

.001 w

.02381 .19456 m

.02756 .19456 L

s

P

p

.001 w

.02381 .23245 m

.02756 .23245 L

s

P

p

.001 w

.02381 .25139 m

.02756 .25139 L

s

P

p

.001 w

.02381 .27033 m

.02756 .27033 L

s

P

p

.001 w

.02381 .28928 m

.02756 .28928 L

s

P

p

.001 w

.02381 .32717 m

.02756 .32717 L

s

P

p

.001 w

.02381 .34611 m

.02756 .34611 L

s

P

p

.001 w

.02381 .36506 m

.02756 .36506 L

s

P

p

.001 w

.02381 .384 m

.02756 .384 L

s

P

p

.001 w

.02381 .42189 m

.02756 .42189 L

s

P

p

.001 w

.02381 .44083 m

.02756 .44083 L

s

P

p

.001 w

.02381 .45978 m

.02756 .45978 L

s

P

p

.001 w

.02381 .47872 m

.02756 .47872 L

s

P

p

.001 w

.02381 .51661 m

.02756 .51661 L

s

P

p

.001 w

.02381 .53555 m

.02756 .53555 L

s

P

p

.001 w

.02381 .5545 m

.02756 .5545 L

s

P

p

.001 w

.02381 .57344 m

.02756 .57344 L

s

P

p

.001 w

.02381 .00512 m

.02756 .00512 L

s

P

p

.001 w

.02381 .61133 m

.02756 .61133 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .56267 m

.04365 .57998 L

.05357 .58691 L

.06349 .59265 L

.07341 .59718 L

.07837 .59898 L

.08333 .60047 L

.08829 .60165 L

.09077 .60213 L

.09325 .60252 L

.09573 .60284 L

.09697 .60296 L

.09821 .60307 L

.09945 .60316 L

.10069 .60323 L

.10193 .60328 L

.10317 .60331 L

.10441 .60332 L

.10565 .60331 L

.10689 .60328 L

.10813 .60323 L

.10938 .60316 L

.11062 .60307 L

.1131 .60284 L

.11558 .60252 L

.11806 .60213 L

.12302 .60111 L

.12798 .59977 L

.13294 .59813 L

.14286 .59391 L

.15278 .58847 L

.1627 .58184 L

.18254 .5651 L

.22222 .51883 L

.2619 .45827 L

.30159 .38753 L

.34127 .31145 L

.38095 .2352 L

.42063 .16398 L

.46032 .10264 L

.48016 .07702 L

.5 .05537 L

.51984 .03806 L

.52976 .03112 L

.53968 .02538 L

.5496 .02085 L

.55456 .01905 L

.55952 .01756 L

.56448 .01638 L

.56696 .01591 L

Mistroke

.56944 .01551 L

.57192 .0152 L

.57316 .01507 L

.5744 .01496 L

.57564 .01487 L

.57688 .0148 L

.57813 .01475 L

.57937 .01473 L

.58061 .01472 L

.58185 .01472 L

.58309 .01475 L

.58433 .0148 L

.58557 .01487 L

.58681 .01496 L

.58929 .0152 L

.59177 .01551 L

.59425 .0159 L

.59921 .01693 L

.60417 .01826 L

.60913 .01991 L

.61905 .02412 L

.62897 .02956 L

.63889 .0362 L

.65873 .05294 L

.69841 .0992 L

.7381 .15977 L

.77778 .2305 L

.81746 .30659 L

.85714 .38284 L

.89683 .45406 L

.93651 .51539 L

.97619 .56267 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]}, Open]]}, Open]],

Cell[TextData[
"\nZoom in on the areas that look like they are zero. We did some trial and \
error when \"homing\" in on the limits.\n"], "Text",
  Evaluatable->False],

Cell[CellGroupData[{Cell[TextData[
"\nPlot[eq[bpg],{bpg,150,210}];\n\nPlot[eq[bpg],{bpg,210,250}];\n\n\n"], 
  "Input",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

-2.35714 0.015873 0.0515262 0.0373552 [

[(160)] .18254 .05153 0 2 Msboxa

[(170)] .34127 .05153 0 2 Msboxa

[(180)] .5 .05153 0 2 Msboxa

[(190)] .65873 .05153 0 2 Msboxa

[(200)] .81746 .05153 0 2 Msboxa

[(210)] .97619 .05153 0 2 Msboxa

[(2.5)] .01131 .14491 1 0 Msboxa

[(5)] .01131 .2383 1 0 Msboxa

[(7.5)] .01131 .33169 1 0 Msboxa

[(10)] .01131 .42508 1 0 Msboxa

[(12.5)] .01131 .51847 1 0 Msboxa

[(15)] .01131 .61185 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.18254 .05153 m

.18254 .05778 L

s

P

[(160)] .18254 .05153 0 2 Mshowa

p

.002 w

.34127 .05153 m

.34127 .05778 L

s

P

[(170)] .34127 .05153 0 2 Mshowa

p

.002 w

.5 .05153 m

.5 .05778 L

s

P

[(180)] .5 .05153 0 2 Mshowa

p

.002 w

.65873 .05153 m

.65873 .05778 L

s

P

[(190)] .65873 .05153 0 2 Mshowa

p

.002 w

.81746 .05153 m

.81746 .05778 L

s

P

[(200)] .81746 .05153 0 2 Mshowa

p

.002 w

.97619 .05153 m

.97619 .05778 L

s

P

[(210)] .97619 .05153 0 2 Mshowa

p

.001 w

.05556 .05153 m

.05556 .05528 L

s

P

p

.001 w

.0873 .05153 m

.0873 .05528 L

s

P

p

.001 w

.11905 .05153 m

.11905 .05528 L

s

P

p

.001 w

.15079 .05153 m

.15079 .05528 L

s

P

p

.001 w

.21429 .05153 m

.21429 .05528 L

s

P

p

.001 w

.24603 .05153 m

.24603 .05528 L

s

P

p

.001 w

.27778 .05153 m

.27778 .05528 L

s

P

p

.001 w

.30952 .05153 m

.30952 .05528 L

s

P

p

.001 w

.37302 .05153 m

.37302 .05528 L

s

P

p

.001 w

.40476 .05153 m

.40476 .05528 L

s

P

p

.001 w

.43651 .05153 m

.43651 .05528 L

s

P

p

.001 w

.46825 .05153 m

.46825 .05528 L

s

P

p

.001 w

.53175 .05153 m

.53175 .05528 L

s

P

p

.001 w

.56349 .05153 m

.56349 .05528 L

s

P

p

.001 w

.59524 .05153 m

.59524 .05528 L

s

P

p

.001 w

.62698 .05153 m

.62698 .05528 L

s

P

p

.001 w

.69048 .05153 m

.69048 .05528 L

s

P

p

.001 w

.72222 .05153 m

.72222 .05528 L

s

P

p

.001 w

.75397 .05153 m

.75397 .05528 L

s

P

p

.001 w

.78571 .05153 m

.78571 .05528 L

s

P

p

.001 w

.84921 .05153 m

.84921 .05528 L

s

P

p

.001 w

.88095 .05153 m

.88095 .05528 L

s

P

p

.001 w

.9127 .05153 m

.9127 .05528 L

s

P

p

.001 w

.94444 .05153 m

.94444 .05528 L

s

P

p

.002 w

0 .05153 m

1 .05153 L

s

P

p

.002 w

.02381 .14491 m

.03006 .14491 L

s

P

[(2.5)] .01131 .14491 1 0 Mshowa

p

.002 w

.02381 .2383 m

.03006 .2383 L

s

P

[(5)] .01131 .2383 1 0 Mshowa

p

.002 w

.02381 .33169 m

.03006 .33169 L

s

P

[(7.5)] .01131 .33169 1 0 Mshowa

p

.002 w

.02381 .42508 m

.03006 .42508 L

s

P

[(10)] .01131 .42508 1 0 Mshowa

p

.002 w

.02381 .51847 m

.03006 .51847 L

s

P

[(12.5)] .01131 .51847 1 0 Mshowa

p

.002 w

.02381 .61185 m

.03006 .61185 L

s

P

[(15)] .01131 .61185 1 0 Mshowa

p

.001 w

.02381 .0702 m

.02756 .0702 L

s

P

p

.001 w

.02381 .08888 m

.02756 .08888 L

s

P

p

.001 w

.02381 .10756 m

.02756 .10756 L

s

P

p

.001 w

.02381 .12624 m

.02756 .12624 L

s

P

p

.001 w

.02381 .16359 m

.02756 .16359 L

s

P

p

.001 w

.02381 .18227 m

.02756 .18227 L

s

P

p

.001 w

.02381 .20095 m

.02756 .20095 L

s

P

p

.001 w

.02381 .21962 m

.02756 .21962 L

s

P

p

.001 w

.02381 .25698 m

.02756 .25698 L

s

P

p

.001 w

.02381 .27566 m

.02756 .27566 L

s

P

p

.001 w

.02381 .29434 m

.02756 .29434 L

s

P

p

.001 w

.02381 .31301 m

.02756 .31301 L

s

P

p

.001 w

.02381 .35037 m

.02756 .35037 L

s

P

p

.001 w

.02381 .36905 m

.02756 .36905 L

s

P

p

.001 w

.02381 .38772 m

.02756 .38772 L

s

P

p

.001 w

.02381 .4064 m

.02756 .4064 L

s

P

p

.001 w

.02381 .44376 m

.02756 .44376 L

s

P

p

.001 w

.02381 .46243 m

.02756 .46243 L

s

P

p

.001 w

.02381 .48111 m

.02756 .48111 L

s

P

p

.001 w

.02381 .49979 m

.02756 .49979 L

s

P

p

.001 w

.02381 .53714 m

.02756 .53714 L

s

P

p

.001 w

.02381 .55582 m

.02756 .55582 L

s

P

p

.001 w

.02381 .5745 m

.02756 .5745 L

s

P

p

.001 w

.02381 .59318 m

.02756 .59318 L

s

P

p

.001 w

.02381 .03285 m

.02756 .03285 L

s

P

p

.001 w

.02381 .01417 m

.02756 .01417 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .60332 m

.06349 .55981 L

.10317 .51748 L

.14286 .47639 L

.18254 .43664 L

.22222 .39829 L

.2619 .36143 L

.30159 .32611 L

.34127 .29241 L

.38095 .26039 L

.42063 .23011 L

.46032 .20163 L

.5 .175 L

.53968 .15028 L

.57937 .12751 L

.61905 .10673 L

.65873 .08799 L

.69841 .07131 L

.7381 .05674 L

.77778 .0443 L

.81746 .03401 L

.85714 .0259 L

.87698 .02266 L

.89683 .01997 L

.91667 .01783 L

.92659 .01696 L

.93651 .01624 L

.94643 .01565 L

.95139 .01541 L

.95635 .0152 L

.96131 .01503 L

.96627 .01489 L

.96875 .01483 L

.97123 .01478 L

.97619 .01472 L

s

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

-4.97619 0.0238095 0.0964414 0.0828452 [

[(220)] .2619 .09644 0 2 Msboxa

[(230)] .5 .09644 0 2 Msboxa

[(240)] .7381 .09644 0 2 Msboxa

[(250)] .97619 .09644 0 2 Msboxa

[(-1)] .01131 .0136 1 0 Msboxa

[(1)] .01131 .17929 1 0 Msboxa

[(2)] .01131 .26213 1 0 Msboxa

[(3)] .01131 .34498 1 0 Msboxa

[(4)] .01131 .42782 1 0 Msboxa

[(5)] .01131 .51067 1 0 Msboxa

[(6)] .01131 .59351 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.2619 .09644 m

.2619 .10269 L

s

P

[(220)] .2619 .09644 0 2 Mshowa

p

.002 w

.5 .09644 m

.5 .10269 L

s

P

[(230)] .5 .09644 0 2 Mshowa

p

.002 w

.7381 .09644 m

.7381 .10269 L

s

P

[(240)] .7381 .09644 0 2 Mshowa

p

.002 w

.97619 .09644 m

.97619 .10269 L

s

P

[(250)] .97619 .09644 0 2 Mshowa

p

.001 w

.07143 .09644 m

.07143 .10019 L

s

P

p

.001 w

.11905 .09644 m

.11905 .10019 L

s

P

p

.001 w

.16667 .09644 m

.16667 .10019 L

s

P

p

.001 w

.21429 .09644 m

.21429 .10019 L

s

P

p

.001 w

.30952 .09644 m

.30952 .10019 L

s

P

p

.001 w

.35714 .09644 m

.35714 .10019 L

s

P

p

.001 w

.40476 .09644 m

.40476 .10019 L

s

P

p

.001 w

.45238 .09644 m

.45238 .10019 L

s

P

p

.001 w

.54762 .09644 m

.54762 .10019 L

s

P

p

.001 w

.59524 .09644 m

.59524 .10019 L

s

P

p

.001 w

.64286 .09644 m

.64286 .10019 L

s

P

p

.001 w

.69048 .09644 m

.69048 .10019 L

s

P

p

.001 w

.78571 .09644 m

.78571 .10019 L

s

P

p

.001 w

.83333 .09644 m

.83333 .10019 L

s

P

p

.001 w

.88095 .09644 m

.88095 .10019 L

s

P

p

.001 w

.92857 .09644 m

.92857 .10019 L

s

P

p

.002 w

0 .09644 m

1 .09644 L

s

P

p

.002 w

.02381 .0136 m

.03006 .0136 L

s

P

[(-1)] .01131 .0136 1 0 Mshowa

p

.002 w

.02381 .17929 m

.03006 .17929 L

s

P

[(1)] .01131 .17929 1 0 Mshowa

p

.002 w

.02381 .26213 m

.03006 .26213 L

s

P

[(2)] .01131 .26213 1 0 Mshowa

p

.002 w

.02381 .34498 m

.03006 .34498 L

s

P

[(3)] .01131 .34498 1 0 Mshowa

p

.002 w

.02381 .42782 m

.03006 .42782 L

s

P

[(4)] .01131 .42782 1 0 Mshowa

p

.002 w

.02381 .51067 m

.03006 .51067 L

s

P

[(5)] .01131 .51067 1 0 Mshowa

p

.002 w

.02381 .59351 m

.03006 .59351 L

s

P

[(6)] .01131 .59351 1 0 Mshowa

p

.001 w

.02381 .03017 m

.02756 .03017 L

s

P

p

.001 w

.02381 .04673 m

.02756 .04673 L

s

P

p

.001 w

.02381 .0633 m

.02756 .0633 L

s

P

p

.001 w

.02381 .07987 m

.02756 .07987 L

s

P

p

.001 w

.02381 .11301 m

.02756 .11301 L

s

P

p

.001 w

.02381 .12958 m

.02756 .12958 L

s

P

p

.001 w

.02381 .14615 m

.02756 .14615 L

s

P

p

.001 w

.02381 .16272 m

.02756 .16272 L

s

P

p

.001 w

.02381 .19586 m

.02756 .19586 L

s

P

p

.001 w

.02381 .21242 m

.02756 .21242 L

s

P

p

.001 w

.02381 .22899 m

.02756 .22899 L

s

P

p

.001 w

.02381 .24556 m

.02756 .24556 L

s

P

p

.001 w

.02381 .2787 m

.02756 .2787 L

s

P

p

.001 w

.02381 .29527 m

.02756 .29527 L

s

P

p

.001 w

.02381 .31184 m

.02756 .31184 L

s

P

p

.001 w

.02381 .32841 m

.02756 .32841 L

s

P

p

.001 w

.02381 .36155 m

.02756 .36155 L

s

P

p

.001 w

.02381 .37811 m

.02756 .37811 L

s

P

p

.001 w

.02381 .39468 m

.02756 .39468 L

s

P

p

.001 w

.02381 .41125 m

.02756 .41125 L

s

P

p

.001 w

.02381 .44439 m

.02756 .44439 L

s

P

p

.001 w

.02381 .46096 m

.02756 .46096 L

s

P

p

.001 w

.02381 .47753 m

.02756 .47753 L

s

P

p

.001 w

.02381 .4941 m

.02756 .4941 L

s

P

p

.001 w

.02381 .52724 m

.02756 .52724 L

s

P

p

.001 w

.02381 .54381 m

.02756 .54381 L

s

P

p

.001 w

.02381 .56037 m

.02756 .56037 L

s

P

p

.001 w

.02381 .57694 m

.02756 .57694 L

s

P

p

.001 w

.02381 .61008 m

.02756 .61008 L

s

P

p

.002 w

.02381 0 m

.02381 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .0148 m

.02629 .01477 L

.02877 .01474 L

.03001 .01473 L

.03125 .01473 L

.03249 .01472 L

.03373 .01472 L

.03497 .01472 L

.03621 .01472 L

.03745 .01472 L

.03869 .01472 L

.03993 .01473 L

.04117 .01474 L

.04365 .01477 L

.04613 .0148 L

.04861 .01484 L

.05357 .01495 L

.05853 .0151 L

.06349 .01527 L

.07341 .01573 L

.08333 .01633 L

.10317 .01792 L

.12302 .02006 L

.14286 .02274 L

.18254 .02974 L

.22222 .0389 L

.2619 .05021 L

.30159 .06368 L

.34127 .07928 L

.38095 .097 L

.42063 .11684 L

.46032 .13876 L

.5 .16276 L

.53968 .18881 L

.57937 .21689 L

.61905 .24697 L

.65873 .27904 L

.69841 .31306 L

.7381 .34901 L

.77778 .38685 L

.81746 .42656 L

.85714 .4681 L

.89683 .51142 L

.93651 .55651 L

.97619 .60332 L

s

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[TextData["\nNow look for the two solutions.\n"], "Text",
  Evaluatable->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nbpgfirst = Bisect[150,210,1/1000,eq[bpg],bpg]\n\nbpgsecond = \
Bisect[210,250,1/1000,eq[bpg],bpg]\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

195.9970092773438




\
\>", "\<\

195.997
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

224.9505615234375




\
\>", "\<\

224.951
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]],

Cell[TextData[
"\nThese equations give us beta when we know beta + gamma.\n"], "Text",
  Evaluatable->False],

Cell[TextData[
"\nsinb[bpg_] := (l1 Sin[alpha] - \n\n              l4 Sin[bpg Degree - \
Pi])/l3\n\ncosb[bpg_] := (-l1 Cos[alpha] + l2 - \n\n              l4 Cos[bpg \
Degree - Pi])/l3\n"], "Input",
  PageWidth->Infinity],

Cell[TextData["\nSolve for the two values of beta.\n"], "Text",
  Evaluatable->False],

Cell[CellGroupData[{Cell[TextData[
"\nbetafirst = ArcTan[cosb[bpgfirst],\n\n                   \
sinb[bpgfirst]]/Degree//N\n\nbetasecond = ArcTan[cosb[bpgsecond],\n\n         \
          sinb[bpgsecond]]/Degree//N\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

119.8556667946434




\
\>", "\<\

119.856
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

-58.90812838879405




\
\>", "\<\

-58.9081
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[TextData["\nSolve for the two values of gamma.\n"], "Text",
  Evaluatable->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\ngammafirst = bpgfirst - betafirst\n\ngammasecond = bpgsecond - betasecond\n\
"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

76.14134248270037




\
\>", "\<\

76.1413
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

283.8586899122316




\
\>", "\<\

283.859
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[TextData[
"\nCheck these answers to make sure they are good solutions to the original \
equations. All of these quantities should be zero.\n"], "Text",
  Evaluatable->False]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"\nxeq[betafirst Degree, gammafirst Degree]//N\n\nyeq[betafirst Degree, \
gammafirst Degree]//N\n\nxeq[betasecond Degree, gammasecond Degree]//N\n\n\
yeq[betasecond Degree, gammasecond Degree]//N\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

-(8.84621170049726*10^-6)




\
\>", "\<\

           -6

-8.84621 10
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

0.00001541161654006196




\
\>", "\<\

0.0000154116
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

-0.00001788783197609334




\
\>", "\<\

-0.0000178878
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False],

Cell[OutputFormData["\<\

0.00002966251154035149




\
\>", "\<\

0.0000296625
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]}, Open]]}, Open]]
},
FrontEndVersion->"NeXT 3.0",
ScreenRectangle->{{0, 1085}, {0, 864}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{520, 600},
WindowMargins->{{Automatic, 40}, {Automatic, 14}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]



(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1711, 51, 136, 3, 70, "Title"],
Cell[1850, 56, 176, 3, 70, "Text"],
Cell[2029, 61, 65, 1, 70, "Input"],
Cell[2097, 64, 83, 1, 70, "Text"],
Cell[2183, 67, 121, 3, 70, "Input"],
Cell[2307, 72, 117, 3, 70, "Text"],
Cell[2427, 77, 268, 4, 70, "Input"],
Cell[2698, 83, 110, 2, 70, "Text"],

Cell[CellGroupData[{
Cell[2831, 87, 168, 3, 70, "Input"],
Cell[3002, 92, 104, 2, 70, "Text"],

Cell[CellGroupData[{
Cell[3129, 96, 80, 1, 70, "Input"],
Cell[3212, 99, 6452, 1133, 70, 6304, 1128, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],
Cell[9685, 1234, 167, 3, 70, "Text"],

Cell[CellGroupData[{
Cell[9875, 1239, 244, 8, 70, "Input"],
Cell[10122, 1249, 5272, 961, 70, 5124, 956, "GraphicsData", 
"PostScript", "Graphics"],
Cell[15397, 2212, 5043, 905, 70, 4895, 900, "GraphicsData", 
"PostScript", "Graphics"],
Cell[20443, 3119, 83, 1, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20558, 3122, 152, 3, 70, "Input"],
Cell[20713, 3127, 131, 14, 70, "Output"],
Cell[20847, 3143, 131, 14, 70, "Output"]
}, Open  ]],
Cell[20990, 3159, 108, 2, 70, "Text"],
Cell[21101, 3163, 221, 4, 70, "Input"],
Cell[21325, 3169, 85, 1, 70, "Text"],

Cell[CellGroupData[{
Cell[21433, 3172, 230, 4, 70, "Input"],
Cell[21666, 3178, 131, 14, 70, "Output"],
Cell[21800, 3194, 133, 14, 70, "Output"],
Cell[21936, 3210, 86, 1, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22054, 3213, 130, 3, 70, "Input"],
Cell[22187, 3218, 131, 14, 70, "Output"],
Cell[22321, 3234, 131, 14, 70, "Output"],
Cell[22455, 3250, 178, 3, 70, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22665, 3255, 247, 4, 70, "Input"],
Cell[22915, 3261, 158, 16, 70, "Output"],
Cell[23076, 3279, 141, 14, 70, "Output"],
Cell[23220, 3295, 143, 14, 70, "Output"],
Cell[23366, 3311, 141, 14, 70, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)
