(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     18737,       1963]*)
(*NotebookOutlinePosition[     19590,       1993]*)
(*  CellTagsIndexPosition[     19546,       1989]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData["\nTracking An Airplane.\n"], "Title",
  Evaluatable->False,
  CellHorizontalScrolling->False,
  TextAlignment->Center],

Cell[CellGroupData[{

Cell[TextData[
"\ntheta[d_] := ArcTan[d,h]\n\nl[d_] := Sqrt[h^2+d^2]\n\nldot[d_] := -v \
Cos[theta[d]]\n\nthetadot[d_] := v Sin[theta[d]]/l[d]\n\nthetaddot[d_] := -2 \
thetadot[d] ldot[d] / l[d]\n\ntorque[d_] := -iner thetaddot[d]\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

Can't Format Cell




\
\>", "\<\

General::spell1: 

   Possible spelling error: new symbol name \"thetaddot\"

     is similar to existing symbol \"thetadot\".
\
\>"], "Message",
  PageWidth->Infinity,
  Evaluatable->False]
}, Open  ]],

Cell[TextData[
"\nh = 1000;(*Meters*)\n\nv = 70; (*Meters/second*)\n\niner = 1000;(*Kg \
Meters^2*)\n"], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[TextData["\nPlot[torque[d],{d,-2000,2000}];\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.5 0.000238095 0.309017 0.092471 [

[(-2000)] .02381 .30902 0 2 Msboxa

[(-1000)] .2619 .30902 0 2 Msboxa

[(1000)] .7381 .30902 0 2 Msboxa

[(2000)] .97619 .30902 0 2 Msboxa

[(-3)] .4875 .0316 1 0 Msboxa

[(-2)] .4875 .12407 1 0 Msboxa

[(-1)] .4875 .21655 1 0 Msboxa

[(1)] .4875 .40149 1 0 Msboxa

[(2)] .4875 .49396 1 0 Msboxa

[(3)] .4875 .58643 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.02381 .30902 m

.02381 .31527 L

s

P

[(-2000)] .02381 .30902 0 2 Mshowa

p

.002 w

.2619 .30902 m

.2619 .31527 L

s

P

[(-1000)] .2619 .30902 0 2 Mshowa

p

.002 w

.7381 .30902 m

.7381 .31527 L

s

P

[(1000)] .7381 .30902 0 2 Mshowa

p

.002 w

.97619 .30902 m

.97619 .31527 L

s

P

[(2000)] .97619 .30902 0 2 Mshowa

p

.001 w

.07143 .30902 m

.07143 .31277 L

s

P

p

.001 w

.11905 .30902 m

.11905 .31277 L

s

P

p

.001 w

.16667 .30902 m

.16667 .31277 L

s

P

p

.001 w

.21429 .30902 m

.21429 .31277 L

s

P

p

.001 w

.30952 .30902 m

.30952 .31277 L

s

P

p

.001 w

.35714 .30902 m

.35714 .31277 L

s

P

p

.001 w

.40476 .30902 m

.40476 .31277 L

s

P

p

.001 w

.45238 .30902 m

.45238 .31277 L

s

P

p

.001 w

.54762 .30902 m

.54762 .31277 L

s

P

p

.001 w

.59524 .30902 m

.59524 .31277 L

s

P

p

.001 w

.64286 .30902 m

.64286 .31277 L

s

P

p

.001 w

.69048 .30902 m

.69048 .31277 L

s

P

p

.001 w

.78571 .30902 m

.78571 .31277 L

s

P

p

.001 w

.83333 .30902 m

.83333 .31277 L

s

P

p

.001 w

.88095 .30902 m

.88095 .31277 L

s

P

p

.001 w

.92857 .30902 m

.92857 .31277 L

s

P

p

.002 w

0 .30902 m

1 .30902 L

s

P

p

.002 w

.5 .0316 m

.50625 .0316 L

s

P

[(-3)] .4875 .0316 1 0 Mshowa

p

.002 w

.5 .12407 m

.50625 .12407 L

s

P

[(-2)] .4875 .12407 1 0 Mshowa

p

.002 w

.5 .21655 m

.50625 .21655 L

s

P

[(-1)] .4875 .21655 1 0 Mshowa

p

.002 w

.5 .40149 m

.50625 .40149 L

s

P

[(1)] .4875 .40149 1 0 Mshowa

p

.002 w

.5 .49396 m

.50625 .49396 L

s

P

[(2)] .4875 .49396 1 0 Mshowa

p

.002 w

.5 .58643 m

.50625 .58643 L

s

P

[(3)] .4875 .58643 1 0 Mshowa

p

.001 w

.5 .0501 m

.50375 .0501 L

s

P

p

.001 w

.5 .06859 m

.50375 .06859 L

s

P

p

.001 w

.5 .08709 m

.50375 .08709 L

s

P

p

.001 w

.5 .10558 m

.50375 .10558 L

s

P

p

.001 w

.5 .14257 m

.50375 .14257 L

s

P

p

.001 w

.5 .16106 m

.50375 .16106 L

s

P

p

.001 w

.5 .17956 m

.50375 .17956 L

s

P

p

.001 w

.5 .19805 m

.50375 .19805 L

s

P

p

.001 w

.5 .23504 m

.50375 .23504 L

s

P

p

.001 w

.5 .25353 m

.50375 .25353 L

s

P

p

.001 w

.5 .27203 m

.50375 .27203 L

s

P

p

.001 w

.5 .29052 m

.50375 .29052 L

s

P

p

.001 w

.5 .32751 m

.50375 .32751 L

s

P

p

.001 w

.5 .34601 m

.50375 .34601 L

s

P

p

.001 w

.5 .3645 m

.50375 .3645 L

s

P

p

.001 w

.5 .38299 m

.50375 .38299 L

s

P

p

.001 w

.5 .41998 m

.50375 .41998 L

s

P

p

.001 w

.5 .43848 m

.50375 .43848 L

s

P

p

.001 w

.5 .45697 m

.50375 .45697 L

s

P

p

.001 w

.5 .47546 m

.50375 .47546 L

s

P

p

.001 w

.5 .51245 m

.50375 .51245 L

s

P

p

.001 w

.5 .53095 m

.50375 .53095 L

s

P

p

.001 w

.5 .54944 m

.50375 .54944 L

s

P

p

.001 w

.5 .56794 m

.50375 .56794 L

s

P

p

.001 w

.5 .01311 m

.50375 .01311 L

s

P

p

.001 w

.5 .60492 m

.50375 .60492 L

s

P

p

.002 w

.5 0 m

.5 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .38151 m

.06349 .39637 L

.10317 .41485 L

.14286 .43771 L

.18254 .46561 L

.22222 .49866 L

.2619 .53557 L

.30159 .57204 L

.32143 .58741 L

.33135 .59365 L

.33631 .59629 L

.34127 .59858 L

.34623 .60046 L

.34871 .60124 L

.35119 .6019 L

.35367 .60244 L

.35491 .60267 L

.35615 .60286 L

.35739 .60302 L

.35863 .60314 L

.35987 .60324 L

.36111 .6033 L

.36235 .60332 L

.36359 .60331 L

.36483 .60326 L

.36607 .60317 L

.36855 .60288 L

.36979 .60268 L

.37103 .60244 L

.37351 .60184 L

.37599 .60107 L

.38095 .59901 L

.38591 .59622 L

.39087 .59267 L

.40079 .58316 L

.41071 .57022 L

.42063 .5537 L

.44048 .5097 L

.46032 .452 L

.5 .30902 L

.53968 .16603 L

.55952 .10833 L

.57937 .06434 L

.58929 .04781 L

.59921 .03488 L

.60417 .0297 L

.60913 .02536 L

.61409 .02181 L

.61905 .01903 L

.62401 .01697 L

Mistroke

.62649 .0162 L

.62897 .01559 L

.63021 .01535 L

.63145 .01515 L

.63269 .01499 L

.63393 .01486 L

.63517 .01478 L

.63641 .01473 L

.63765 .01472 L

.63889 .01474 L

.64013 .0148 L

.64137 .01489 L

.64385 .01518 L

.64509 .01537 L

.64633 .01559 L

.64881 .01614 L

.65377 .01758 L

.65873 .01946 L

.66865 .02439 L

.67857 .03063 L

.69841 .04599 L

.7381 .08246 L

.77778 .11937 L

.81746 .15242 L

.85714 .18032 L

.89683 .20319 L

.93651 .22166 L

.97619 .23652 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0000^@800@400ooo;Ol00?oo;Ol00?oo;Ol0
09Oo00<l09;o002Go`03?02Bo`00Uol00c`0T_l009Oo00<l09;o002Go`03300Qo`P0JOl009Oo00<l
01oo00<000Oo00<006Ko002Ao`033007o1go00<l00[o00<<06Co002@o`03?008?a_o00<<00ko00<<
06;o002Co`Po6_l00c`04Ol00``0H?l008[o00<000Do00@o00G06Ol00c`04ol00``0Gol009?o23lH
o`03300Fo`03?01Mo`00T?l00c`023lHo`03?00Go`03301Lo`00TOl00``01o`Go`03?00Jo`03?01J
o`00Uol00c`05ol00c`07?l00c`0FOl009Oo00<<01Ko00<<01ko00<l05So002Go`03?00Fo`03?00O
o`03?01Go`00Uol00c`05Ol00c`08Ol00c`0E_l009Oo00<l01Go00<l02;o00<<05Go002Go`03?00D
o`03?00Uo`03?01Co`00Uol00c`05?l00c`09_l00c`0D_l009Oo00<<01?o00<l02So00<l057o002G
o`03?00Co`03?00Yo`03?01@o`00Uol00c`04_l00c`0:ol00c`0Col009Oo00<l01;o00<l02co00<l
04ko002Go`03?00Ao`03?00^o`03?01=o`00Uol00``04Ol00c`0;ol00c`0C?l009Oo00<l013o00<l
037o00<l04_o002Go`03?00@o`03?00bo`03?01:o`00Uol00c`03ol00c`0=?l00c`0BOl009Oo00<l
00oo00<l03Go00<l04So002Go`03300?o`03?00fo`033017o`00Uol00c`03_l00c`0>Ol00c`0AOl0
09Oo00<l00ko00<l03[o00<l04Co002@o`030008?`co00<l03co00<l04?o002@o`04?`07o0co00<l
03go00<l04;o002Ao`03?007o0co00<l03ko00<l047o002:o`050<07o0G02ol00c`0@?l00c`0@?l0
09?o23l;o`03?011o`03300oo`00T?l00c`023l;o`03?013o`03?00mo`00TOl00``01o`:o`03?015
o`03?00lo`00Uol00c`02ol00c`0A_l00c`0>ol009Oo00<<00_o00<l04Oo00<l03[o002Go`03?00:
o`03?019o`03300io`00Uol00c`02_l00c`0Bol00c`0=ol009Oo00<l00[o00<l04co00<l03Ko002G
o`03?009o`03?01>o`03?00eo`00Uol00``02Ol00c`0Col00``0=?l009Oo00<l00Wo00<l057o00<l
03;o002Go`03?008o`03?01Co`03300ao`00Uol00c`02?l00c`0EOl00c`0;ol009Oo00<l00So00<l
05Ko00<<02ko002Go`03?007o`03?01Io`03?00/o`00Uol00``01ol00c`0F_l00``0:ol009Oo00<l
00Oo00<l05co00<l02Wo002Go`03?007o`03?01Mo`03300Xo`00Uol00c`01_l00c`0H?l00``09_l0
09Oo00<l00Ko00<l06;o00<<02Co002Go`033006o`03?01To`03?00Ro`00Uol00c`01_l00c`0IOl0
0``08Ol009Oo00<l00Go00<l06So00<<01oo002@o`030008?`03o005cfWo00<<01go002Bo`03?006
l`03o005cf_o00<001_o002Bo`04?`05`0OlKol00``06?l008[o00D0`0Ol1Ll7o77o00<<01Ko002B
o`03?006l`OlLol00``05?l0093o00@300Ol1oaeo`03000Bo`00T_l00c`01_<6lgWo00<000oo002G
o`03?007o7co00<<00co002Go`033007o7ko00<<00[o002Go`03?006lhco002Go`03?006lhco002G
o`03?006lhco002Go`03?006lhco002Go`D?T?l009Oo23n=o`00Uol8?hgo002Go`PoSOl009Oo00@l
097o002Go`04302Ao`00Uol013`0TOl000Ko00<000Do00<l00K`1_0^o`030005?`03?006l0K`=Ol0
0c00=ol00`001Cl00c`01_06l2ko00<000Do00<l00K`1O0000Ko00<l00Kl00@l00Gc00@l037o1cl0
13`01O<013`0=_l00c00>Ol7?`04?005l`04?00_o`03?006o004?005l`04?00000Oo00<l00Gc00@l
00Gc00@l037o1cl013`01O<013`0=_l00c00>Ol7?`04?005l`04?00`o`03?005l`04?005l`04?000
00050<0:o004?005l`04?00Yo`050<0:o004?005l`04?00fo`03<00io`Lo00@l00Gc00@l037o1cl0
13`01O<013`00009o`04?005l`04?005l`03?00_o`Lo00@l00Gc00@l03Ko00<<03Wo1cl013`01O<0
13`0<_l013`01O<013`01O<100001_l013`01O<013`01O<013`0;ol00`001_`013`01O<013`0=_l0
0``0=ol00`001_`013`01O<013`0;ol013`01O<013`01O<013`00007o`043`06l0K`1_0`o`03?006
l0K`1_0eo`03300io`03?006l0K`1_0_o`043`06l0K`1O0009Oo00<l09;o002Go`03?02Bo`001ooo
028000Co00003Ol00c`02ol00c`02ol00c`02ol00c`02_l00c`02ol00c`02ol00c`02ol00c`02_l0
0c`02ol00c`02ol00c`02ol00c`02_l00c`02ol00c`02ol00c`02ol00c`02_l00c`02ol00c`02ol0
0c`02ol00c`02_l00c`02Ol000go00<l04;o00<l047o00<<04?o00<l047o00<l00Wo002Fo`03302C
o`00U_l00``0Tol009Ko00<009?o002Eo`03<02Do`00UOl00c00U?l009Go00<`09Co002Do`04?02D
o`00U?l013`0U?l009Co1cbAo`00U?l013`0U?l009?o23nAo`00Tol8?i7o002Co`PoTOl009;o00<l
00K`TOl009;o00<l00KcTOl009;o00<l00KcTOl009;o00<l00KcTOl0097o00<l00OlTOl000go00<<
087o00@o00K`TOl000oo00<007oo00<l00OlTOl001;o00<007co00<l00OlTOl001Go00<<07So00<0
00PoTOl001Oo00<007Ko00@c00OlTOl001[o00<<07?o00@c00OlTOl001co00<<073o00Llo0G0TOl0
01ko00<<06ko00Dl`0OlTOl0023o00<006co00D0`0OlTOl002?o00<<06Wo00Dl`0OlTOl002Co00<0
06Oo00<l00Ko00<l09;o000Wo`03?01To`03?006o`03302Bo`00:?l00``0Hol00c`01_l00c`0T_l0
02[o00<<063o00<l00Oo00<l09;o000/o`03?01No`03?007o`03?02Bo`00;Ol00``0GOl00c`01ol0
0c`0T_l002oo00<<05_o00<l00Oo00<<09;o000ao`03?01Ho`03?008o`03?02Bo`00<_l00``0Eol0
0c`02?l00c`0T_l003Co00<l05Go00<l00So00<l09;o000eo`03301Co`03?009o`03?02Bo`00=ol0
0c`0DOl00c`02Ol00c`0T_l003So00<l053o00<l00Wo00<<09;o000io`03301?o`03?009o`03?02B
o`00>ol00c`0C?l00c`02_l00c`0T_l003co00<l04_o00<l00[o00<l09;o000mo`033019o`03?00;
o`03?02Bo`00?ol00c`0Aol00c`02ol00``0T_l0043o00<l04Ko00<l00_o00<l09;o0011o`03?014
o`03?00<o`03?02Bo`00@_l00c`0@ol00c`01Ol00`0023nAo`00@ol00``0@_l00c`01Ol013l01obA
o`00AOl00c`0?ol00c`01ol01Co01L2Ao`00A_l00c`0?_l00c`02?l00c`01_>Ao`00Aol00c`0?Ol0
0c`02Ol8?i7o0018o`03?00ko`03?007o`03?008?i7o0019o`03?00jo`03?008o`033007o97o001:
o`03?00io`03?00>o`03?02Bo`00Bol00c`0=ol00c`03ol00``0T_l004co00<l03Ko00<l00oo00<l
09;o001=o`03?00do`03?00@o`03?02Bo`00C_l00``0<ol00c`04?l00c`0T_l0053o00<l033o00<l
017o00<l09;o001Ao`03?00_o`03?00Ao`03302Bo`00D_l00c`0;_l00c`04Ol00c`0T_l005?o00<l
02co00<l01;o00<l09;o001Do`03?00[o`03?00Bo`03?02Bo`00EOl00c`0:Ol00c`04ol00c`0T_l0
05Ko00<l02So00<l01?o00<<09;o001Go`03?00Vo`03?00Do`03?02Bo`00F?l00c`09Ol00c`05?l0
0c`0T_l005Wo00<l02?o00<l01Go00<l09;o001Jo`03300Ro`03?00Eo`03?02Bo`00G?l00c`07ol0
0c`05_l00c`0T_l005go00<l01go00<l01Oo00<<09;o001No`03?00Lo`03?00Go`03?02Bo`00Gol0
0c`06_l00c`06?l00c`0T_l0063o00<l01So00<l01?o00<<00OlTOl0067o00<<01Ko00<l01?o00<l
00PoTOl006?o00<l01?o00<l01Oo1Cl00``0TOl006Co00<<017o00<l01Ko00<<00OlTOl006Ko00<l
00ko00<l01Wo23nAo`00Iol00``02ol00``06?l00c`023nAo`00JOl00`001ol00`006ol00``01obA
o`00K?l702Co00<<09;o002Go`03?02Bo`00Uol00c`0T_l009Oo00<l09;o002Go`03?02Bo`00ool]
o`00ool]o`00ool]o`00\
\>"],
  ImageRangeCache->{{{0, 299}, {184, 0}} -> {-2203.041748, -3.427797, 
  14.549449, 0.037462}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["\nPlot[thetadot[d],{d,-2000,2000}];\n"], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\

%!

%%Creator: Mathematica

%%AspectRatio: .61803 

MathPictureStart

%% Graphics

/Courier findfont 10  scalefont  setfont

% Scaling calculations

0.5 0.000238095 -0.132436 10.5108 [

[(-2000)] .02381 .07778 0 2 Msboxa

[(-1000)] .2619 .07778 0 2 Msboxa

[(1000)] .7381 .07778 0 2 Msboxa

[(2000)] .97619 .07778 0 2 Msboxa

[(0.03)] .4875 .18289 1 0 Msboxa

[(0.04)] .4875 .288 1 0 Msboxa

[(0.05)] .4875 .3931 1 0 Msboxa

[(0.06)] .4875 .49821 1 0 Msboxa

[(0.07)] .4875 .60332 1 0 Msboxa

[ -0.001 -0.001 0 0 ]

[ 1.001 .61903 0 0 ]

] MathScale

% Start of Graphics

1 setlinecap

1 setlinejoin

newpath

[ ] 0 setdash

0 g

p

p

.002 w

.02381 .07778 m

.02381 .08403 L

s

P

[(-2000)] .02381 .07778 0 2 Mshowa

p

.002 w

.2619 .07778 m

.2619 .08403 L

s

P

[(-1000)] .2619 .07778 0 2 Mshowa

p

.002 w

.7381 .07778 m

.7381 .08403 L

s

P

[(1000)] .7381 .07778 0 2 Mshowa

p

.002 w

.97619 .07778 m

.97619 .08403 L

s

P

[(2000)] .97619 .07778 0 2 Mshowa

p

.001 w

.07143 .07778 m

.07143 .08153 L

s

P

p

.001 w

.11905 .07778 m

.11905 .08153 L

s

P

p

.001 w

.16667 .07778 m

.16667 .08153 L

s

P

p

.001 w

.21429 .07778 m

.21429 .08153 L

s

P

p

.001 w

.30952 .07778 m

.30952 .08153 L

s

P

p

.001 w

.35714 .07778 m

.35714 .08153 L

s

P

p

.001 w

.40476 .07778 m

.40476 .08153 L

s

P

p

.001 w

.45238 .07778 m

.45238 .08153 L

s

P

p

.001 w

.54762 .07778 m

.54762 .08153 L

s

P

p

.001 w

.59524 .07778 m

.59524 .08153 L

s

P

p

.001 w

.64286 .07778 m

.64286 .08153 L

s

P

p

.001 w

.69048 .07778 m

.69048 .08153 L

s

P

p

.001 w

.78571 .07778 m

.78571 .08153 L

s

P

p

.001 w

.83333 .07778 m

.83333 .08153 L

s

P

p

.001 w

.88095 .07778 m

.88095 .08153 L

s

P

p

.001 w

.92857 .07778 m

.92857 .08153 L

s

P

p

.002 w

0 .07778 m

1 .07778 L

s

P

p

.002 w

.5 .18289 m

.50625 .18289 L

s

P

[(0.03)] .4875 .18289 1 0 Mshowa

p

.002 w

.5 .288 m

.50625 .288 L

s

P

[(0.04)] .4875 .288 1 0 Mshowa

p

.002 w

.5 .3931 m

.50625 .3931 L

s

P

[(0.05)] .4875 .3931 1 0 Mshowa

p

.002 w

.5 .49821 m

.50625 .49821 L

s

P

[(0.06)] .4875 .49821 1 0 Mshowa

p

.002 w

.5 .60332 m

.50625 .60332 L

s

P

[(0.07)] .4875 .60332 1 0 Mshowa

p

.001 w

.5 .0988 m

.50375 .0988 L

s

P

p

.001 w

.5 .11982 m

.50375 .11982 L

s

P

p

.001 w

.5 .14084 m

.50375 .14084 L

s

P

p

.001 w

.5 .16187 m

.50375 .16187 L

s

P

p

.001 w

.5 .20391 m

.50375 .20391 L

s

P

p

.001 w

.5 .22493 m

.50375 .22493 L

s

P

p

.001 w

.5 .24595 m

.50375 .24595 L

s

P

p

.001 w

.5 .26697 m

.50375 .26697 L

s

P

p

.001 w

.5 .30902 m

.50375 .30902 L

s

P

p

.001 w

.5 .33004 m

.50375 .33004 L

s

P

p

.001 w

.5 .35106 m

.50375 .35106 L

s

P

p

.001 w

.5 .37208 m

.50375 .37208 L

s

P

p

.001 w

.5 .41412 m

.50375 .41412 L

s

P

p

.001 w

.5 .43515 m

.50375 .43515 L

s

P

p

.001 w

.5 .45617 m

.50375 .45617 L

s

P

p

.001 w

.5 .47719 m

.50375 .47719 L

s

P

p

.001 w

.5 .51923 m

.50375 .51923 L

s

P

p

.001 w

.5 .54025 m

.50375 .54025 L

s

P

p

.001 w

.5 .56128 m

.50375 .56128 L

s

P

p

.001 w

.5 .5823 m

.50375 .5823 L

s

P

p

.001 w

.5 .05676 m

.50375 .05676 L

s

P

p

.001 w

.5 .03574 m

.50375 .03574 L

s

P

p

.001 w

.5 .01472 m

.50375 .01472 L

s

P

p

.002 w

.5 0 m

.5 .61803 L

s

P

P

0 0 m

1 0 L

1 .61803 L

0 .61803 L

closepath

clip

newpath

p

p

.004 w

.02381 .01472 m

.06349 .03627 L

.10317 .06232 L

.14286 .09395 L

.18254 .13244 L

.22222 .17918 L

.2619 .23544 L

.30159 .30178 L

.34127 .37693 L

.38095 .45617 L

.42063 .52974 L

.44048 .56004 L

.4504 .57271 L

.46032 .58343 L

.47024 .592 L

.4752 .59542 L

.48016 .59824 L

.48512 .60046 L

.4876 .60133 L

.49008 .60204 L

.49256 .6026 L

.4938 .60282 L

.49504 .603 L

.49628 .60314 L

.49752 .60324 L

.49876 .6033 L

.5 .60332 L

.50124 .6033 L

.50248 .60324 L

.50372 .60314 L

.50496 .603 L

.5062 .60282 L

.50744 .6026 L

.50992 .60204 L

.5124 .60133 L

.51488 .60046 L

.51984 .59824 L

.52976 .592 L

.53968 .58343 L

.55952 .56004 L

.57937 .52974 L

.61905 .45617 L

.65873 .37693 L

.69841 .30178 L

.7381 .23544 L

.77778 .17918 L

.81746 .13244 L

.85714 .09395 L

.89683 .06232 L

.93651 .03627 L

Mistroke

.97619 .01472 L

Mfstroke

P

P

% End of Graphics

MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageSize->{300, 185},
  ImageMargins->{{100, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]
}, Open  ]],

Cell[TextData["\n<<bisect.h\n"], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[TextData["\neqn[d_] := Simplify[torque'[d]]\n"], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[TextData["\ndatmax = Bisect[250,750,1/100,eqn[d],d]\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

577.3544311523438




\
\>", "\<\

577.354
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["\ntorque[datmax]\n"], "Input",
  PageWidth->Infinity],

Cell[OutputFormData["\<\

-3.182643358783771




\
\>", "\<\

-3.18264
\
\>"], "Output",
  PageWidth->Infinity,
  Evaluatable->False]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"NeXT 3.0",
ScreenRectangle->{{0, 1085}, {0, 864}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{520, 600},
WindowMargins->{{215, Automatic}, {Automatic, 114}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1709, 49, 133, 3, 174, "Title"],

Cell[CellGroupData[{
Cell[1867, 56, 267, 4, 168, "Input"],
Cell[2137, 62, 251, 18, 44, "Message"]
}, Open  ]],
Cell[2403, 83, 136, 3, 96, "Input"],

Cell[CellGroupData[{
Cell[2564, 90, 85, 1, 48, "Input"],
Cell[2652, 93, 10718, 991, 193, 5084, 916, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13407, 1089, 87, 1, 70, "Input"],
Cell[13497, 1092, 4530, 815, 70, 4382, 810, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],
Cell[18042, 1910, 64, 1, 70, "Input"],

Cell[CellGroupData[{
Cell[18131, 1915, 85, 1, 70, "Input"],

Cell[CellGroupData[{
Cell[18241, 1920, 93, 1, 70, "Input"],
Cell[18337, 1923, 131, 14, 70, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18505, 1942, 68, 1, 70, "Input"],
Cell[18576, 1945, 133, 14, 70, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

