(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     64935,       1259]
NotebookOptionsPosition[     62423,       1169]
NotebookOutlinePosition[     62766,       1184]
CellTagsIndexPosition[     62723,       1181]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Instant center example from chapter 8.8", "Subsection",
 CellChangeTimes->{{3.502608882058894*^9, 3.502608916549876*^9}}],

Cell[GraphicsData["PDF", "\<\
9E14ARda;S<:9LCUl^G[Yo>Pd<C62S@P<21_HVX:?3`P;daUKVMdJ20e830PDR0_
AVU/M6Eb82m6K65dIDAUHfmTIB0n?PYcM79UHFd:N06MF4f?53L@_ON_L6jcR]K[
:WlOmP8296j8TG:07<80fD@;4FbDoi=oVUNffnk^jETPL=RF?ik;EJmNUNN;NZFn
:8?ocU]UCE9O?jQOe6OeASWe:hKOZi^W3jBN_/KgjjMHBfGe=BTRYcPkMOZTDUAT
k?BYC=f[e`1mDcL_e[/h;`lA2fDa?^[ZL/KY0D<?9nFM=Y5<W=RF;l9JWcDk5i9R
JgE<dF:S0;8Pn3YT<EVFbMQMQl5XQH5m7iLG60K5LR3@LDcVU1TW4[LCPm5<S<Wk
fN9@;;0d`M;X_AESk]@NR7R2e<_UZIAaA_B:<V_3G]cW<N1Bb1?925ViL=CFDCAN
/KJI<Xk_8dh7ThcU_VmlW=@l>OGUi`3mV?UPME;GYQeX>lARK>XPOFoo>0dC7`OY
IXikWPYG47eF9OY2A3203Bac>L=9AVOlPd?Hh4H4aU3:>/3Wll14:F[hJ[4[1Ffl
8Eb;SM<nFFb2He;IQJ/DU3j0VaP/Y[I[>^7HLXA/Zm2;POW`NMM/XIcEX15I6g16
>gbBD;N1kKe>X:@1@DJj;C9VTF7R6?S0V`V91[X9/GQ=;8]LH<:UJaZ2@Xa=mo;7
iT;NmTL6/GmJ9MgbF?Pf59`WAgP084IMhblhVmCaTkYiS[^3e/N?j_3?UC[n>Cdk
5QTId[12L0g1BDiUI5O0ABX@DZ01oBI0j]Ua4Sfj03A<8NBi/LCM8]^1e:gj8BRK
]?G>PF_]LP?:=R3hZ/BXjN4;j>7_3d/c6G]1eN5j2^:dYVd_`6j/Ibj;X49/BC/O
QLY1Td?<kQ6i2X6_?Y^]CSi9k>kVgB31B/?J]PU1YlXA/X8MPZZK8A>RFf9<WkUN
C=g=nhAABlm7dRU1O]Q[4ebF4d;BA9k1Yc[VH0g6@7E?RX9VWo41=DkAP6]6na1b
A4gYjhdfi49<>B3;P9bMPMQ2=]QKCRHXPXYVP^aICIhR4YJ<QQ84Zk9f8C3^DdFS
b83aZ0S<fU=`L2aU279T:V<T_/6]4i8_>G2>_?HIYD[606JQ/jPO>T1Y<0I7R;1/
45O>YXe?9=h`>4:90:nmB`i1AG`I[Y=kPnk>4_8EFK^m1Jb8//E4MLd@=6>/[fK/
86j3Pk:;VR@aTABE?9LDADE0EJjIQI;G<X^/kcaNAKR2b2FN7:L52<?YIbSokV:`
e52h^ATb4UBdH][C2ZChVVPKR5faZ4Q3;=k]6h<<X;C<`T;;FBi_J]i>2i9Kb1ab
L>@]08:@@Ob=mBE_5n]IZT`/9ia;HcEbZ0O_6XUdEg;UGHoEd05RZ^Y:^a0FFA6@
1]lCO>N_YZ:[JjMOP/3m7P_mdWL<6JNH_m^<:^m[<a[6>HnoHLNBaRc5?3H:CQ0H
HePMDL?g/P:j=FN5YV3Sl6mSa`ZilTV/Jm::5WV[jP]f@1];1oe8H71n2neLkmH>
/CjSJnS/N?`:kgI3:aV0O_6a^0`_o=DM/0j]b>i<lam`JG0nkAX5KML>N^S@M4UW
11LabP<j9RTC60XA:P8e3JQhTYEm4<:4aRfP2Z9:X853VF2D0]TJX1EmkdT5e74[
EIDAFP2RC:6M;/]@TLY>=9i]8iBn[ST1Xj`ZCB4ZQ9cSHXhF9LNR:IIDZJJ2;e;9
I9lj3BPT]=M@4A@b?3o:;8Bm7^bX;Jl=VgS1R8D6=c187[P1Hia]VYRT8IF:aBT9
RjG35NgRj3E7Y2FKY9=L_o@3>eR[H[Ea^K0H=c>A>@Nlg70AlPUiDhIQ?UYM62I_
T`C7XVgLg^5NGL<@Pok=C]RMD5C[@n/2k:IVLD;=@VUYfK5G:]0<]NclZO=bVI2R
cQL0ZW82X:GG3`6P43/;A@D5EbE[>/b]i3Y;;mS1Y;<=O^2<FW2kVaDGL2`:7B8c
>];AKQMkc]Y]?0h9M=oeK2lYcK>SYiD2Am>jTDE4bIO4Qj?[6odA`B_ULeJ[obnm
2`Uej1^L?jl7XjoYf_E67MhND231?UJ7Wo^G_T:jHRCDZNWPiSEXPn[R=7nl_K[2
Sac7UfM=2J5jG>CJ]]3OkY;e8PCJD;Bfd9;c3VVOKQ^TDAC`2PX[Y:EccQcB1d21
jXOnTNLA603WCHN_:4mecO_ihjKimN62bbA4_G3]IOMPLGTdW_Ul1K3K1X;;dlgc
KkF1:iaQ29aEgiicUXlf2do6]hOM82jaM^^P@c2]M?ec<7/83[CY<1HdGl;2W=Zm
9iG`i;8elKLLNg^echd;B?:3PiGb<I_e;FVmP4?hnB@6U9cR=3Qo1?67k24D??b4
QXia?;:KD]lZ`^ljfNoSF@o;n_]RD5o/[M86QeLT2<:YlUN9KQLAn6=VknOihn7_
=]DIgZOZC17m/_WdHMjdFJ8>ONK[<Q]No@NeLTiW2VE^I7=dLVEQK@YUKVA_HVX:
=B0`86mRJPXa=cLf2VE^I6mRJPXb830PKf9Z2S`l82mDNG1U82m@HFMU82m@HG9U
KW@P<b0`858P;e9ULfmeLV=ULb0f830PDR0_@fm^M6E^M7<P=20`858P;deUI6UQ
@Vmh85/`830P=3Dc83<`>5d:;d=bKg12KgPPFc8^=SDf>3Tb838^=SDf>3Tb83@d
=bhf>3Hb83<`=Bhe=38eGB0_@VaUIFA2KgPPFc0P<20d=C<P<c0hGB0_E79YKD9_
N0YK<20`83@e<b0c<3QM82m1LWA2KgPPFc0P<20d=C<P<c0hGB0n?PYUKVA_HVX:
=R0`86mRJPXl?20_D79_He=UM21K82m@A4HP;eAUN7@PGB0_@fm/Kg9CL65SIB0l
?20_@g<a83LP<21B82m3Lc8P>20`858P?ShP;dEhM4MCM65dI@Xl?20_Ag<a834f
830PDR0_Ag<b834g830PDR0n?R0_AVm^M20l?20_AS4^<20i830PDR0_ASD^<20a
<b0`858P;dHf;S4P<CDP<21B2Rm6<bh`834a830PDR0_AS@^<20a<R0`858P;dHb
;S0P<C0P<21B83hn83hn2VE^I6mRJPXa=R0`86mRJPXl?20_E7U`IB0_AGQdAe=d
HGAU82m1@E1<>T5186IQK7=U83hn2VE^I6mRJPXa=b0`86mRJPXl?20_E7U`IB0_
AGQdAe=dHGAU82m1@E1<>T5187AbMFDP?Sh:IFiTKf9Z2S4h830PKf9Z2S`l82m<
IFiWM6PP<CTP<21B82m>834P;d5/M6EbKV5dIB0_A6EfJF=UAg9QNB0_AVU/M6Eb
82m6K65dIDAUHfmTIB0n?PYcM79UHFd:N065DTm8554Lo/df4XB8@HEhR7L:2IDY
[:bPfWIeFIE]FiGBXQQWgkZS/c?CVmTeaI<4GJ8lM@nRHgC/d:6KUj;0[4_G8:TP
23aej?_=k>XXQ6mi>mokoOengg]4KIfVkc/Y@EAc@iD[YJM^CTf;PalYAAgDCURV
5OSYHW6</N^iT[nkemIWd]Rbg/NeM__f?KFEIF0QjRff]a3j8I5V01nIWbQUP;?0
7IJ_f3h1?5P>[1[`8j833iZi<=?AW7BU/RfADnJR:2Z_HS]9[__i^LJnRkF9PoiL
SfKFS[fcjZ[AC=BdmdBQ_0n^A1W?GeCfK3DDY`gSW4Q36RWb[]GO:dc74I4[44X6
DSET^ImZCYeeh7DH^efjTn?hmQ2U?/UPZ8VejK:I7HEm07HZbn`@l0GXlK9R3nN1
Nf7oFe73Tl0WHCmTQgWF[Aof5jiCh7^4?CGPcQB^aO7JRQmN;@53me@SJ8acCLCC
ecUcY8S_<M@IV?M6>JH;<GNFZQ<gP3]Q7eVZIPZaGO^^jRG^N`9gdn<kdI/i2ebP
74Ub/AGI5=0l2EPDOH^`B@hl?/hNEN1gZ9S07;V9g<dXmakE4A]WXe:1EWZ=ElI?
hkWaaOQUK1S?P7j/M]MkO?oYhaEeekHn??V=N]`i[[fM6eEQEW5U2mgoac:4SmTW
>JK1dj5IF6_HM^@?V/a</0`Xa7l5?YOjTQ=Eg=G^kKQ54/a@?Ra/9KY;E6hYe>Xm
PdZ/72_H07I`T/@/FQbhDf^j>GQgf29jKOU=Ek;[Q_kjmW[kf_8NKLZX:BPCcK=4
IYBaFj?TgGSKoFJA4Ilh>[kW_HYJbOi9AA0oQCUJ:_8DEOAFD=K4KfL>OQ^fOU`o
YNOe@Odl2Cf]Wm6_j:<A_PadBLo2Le4OXdW`/6TQhQ:PRX<ce4iDHhd3hRWal[AK
I97m3d0IoFH:IFiTLgAbIF5]2VE^I6mRJPXa>B0`86mRJPXg<3@:IFiTKf9Z2SLP
<21_HVX:Fb0_BD=3@V5cIF@P<CPP<21B85d:IFiTKf9Z2S8`830PKf9Z2S`l82m<
IFiWM6PP<S4P<21B82m>83<P;d5/M6EbKV5dIB0_A6EfJF=UDTM282m6JFadIG8P
;dI/HGAUA6ESKfAU83hn2W=dLVEQK@Yh0HEDcf/C@ACn=VjYd288FV/>/WR@8TUI
ZfQ5e3Km4F9[3=/O]TF@I3=9eVhfjnhV]JF8i>;A:]i5kJ47oh0NN_1T;dZ5FTDX
gZ/XHZ4G;O7=KTbfYN[0cWkcgSO_OFmfg`0=L]8dmH04i0g7DZ8AJFal@V[lR02>
XPU1=2EEfna>90I1Pg?iNnOHNPn1FeK3No]g/WN]V]:fVPN4oD3PAi[I:[3_5g4:
FA82R3cOXBW7M0SOhmSbk8liCWUh`KD?:cg4FB9l@3D]cWm=^5?=9M=0PdPhU?Ea
DSjLeh^Dead7JFiVa/P@_Dn@Y[_<kZ]RXIa>mPj@_IgdOTjcgSk28L8;6JdoA[R=
W_F<eCoRHN6Ti/B6?A`H=OChH1Fg6ZWh=L8DGa1=9j9DLMT^3O6H[_eFlTZ2L90h
bVAQP7=JB4oGC6kh^XL5OBKG4joRMeIAhGV?4fONe=g_AMX2[c0>7@`J39X=B50@
A@AQV;1@@8Hl6S4d/W8o8j/66i=k<WDTJ[]dHTBa@G/fg3fgDJCM??hX8W6D@kD8
T_a1oRZ_bDoUNOW;G;3HE_ND[I^J^_;P>lGUVKTJ7]OCb>=cCEilUMAfTeM7UZai
N[bJk1Xok5NG<NJ2=Ho4Lk3klBeOULbG:H`DaN=ElnY;Q7EJ<COOWfao>cgR;/l^
]MIc[HV;=eJKUfOmJTSkkZZlTnIEnDmNmO7lIlg4Hn8Y<BIfR^LQRIO5;_6Bf4^[
2n9PKLL8WIF6:M9]TOXTeF1PV[ce;edoFgRmAWl<mE6D6LcBE8WgOl8ZI3BM^@i_
nXoKao`Gi?N:iilX0Rm/h<RI^VeCLNl@XFFUKW>^0QNodGg`]Vi[Xghho0AH?:/F
[E8eWb2l0AafQgXNj2VHdiJFcCUBQbbOTk[YbV9Bc53K@e9BebGGID/F/iUEH^Uf
f9WC7FhLXCU2mlBWBVFCnZoa4K3m/5;inJaBfGi>6]J1UoY_`;cmA@YUKVAcM79U
HFd:IFiTKf9Z2S8a830PKf9Z2SLc=`YUKVA_HVX:>20`86mRJPYK82m9@d=2HG=U
I20b<20`858PG@YUKVA_HVX:<b0`86mRJPXl?20_E7U`IB0_D65WIG<P;deUI6UQ
@Vmh85/`830P=S4b83Li<UdP;d=_MFid834P;d]YI7<PFb0b830PDR1M83hn2VE^
I6mRJPXb<R0`86mRJPXl?20_E7U`IB0_@f5dHFa_Ib0_D65WIG<P<b0`858P?Sh:
IFiTKf9Z2S8c830PKf9Z2S`l82m<IFiWM6PP<S@P<21B82m<IFiWM6Pa83Hb=3PP
;dIYK7AULR0_AVaQM6E4IF=_I6DP?Sh:LgAbIF5]2WP1cEP=M1AEU[k_EGEG1m99
QhC@98BZY/T?nN7?4488BHMd9i0@K21P=b:T2H60AQ2Hb8n`6C70MYCChh0h>^S8
c[X21R/=be@FdJbjhZP`j^bbLc`3<VLb/ahDWITScXlT]EmE=`7Vk7ZL/g?VK;en
kkikkoO^^nnnWgYMVcMnZhDBZH<4lSBgQCJ@nHcl6>C=i_K=BXbgmA5I_:/g[6V;
lDTRTGAQcGeKElOhM8f8=KFfQ5K5N;X>F]8:@HaWaJ3SFm/fKhWa8gl>VWSOn^Jh
?Ud5Kf/;KHWgChIN^CoDeQ;3>cfPNA_FKmXLiidV_k4USVL1n1?g1Ih`0iF42XQ0
NlQ:OF@SCPhT?i0OBaM8Q=K44GFf_1UMTEanSJGHS8IdN:7Q3]5[ob:N7CQloHAm
K/8?dC[Q1]jPEQX48_4G0hL73]/bH3cKK7:S43BZ:M2X77UZ`L_lnbbAbTWV1j;n
6K;6mg/:@2?FR<@?cNfNbk/gMWOa@a/?MO5^^K^<7i8?UO5^YM_?3bV7o5cSTA=U
aO98SGM5JnDdSHM1DSGnmb0S=;hG94GSNd0L6]l=TZcaCY0TSCl2H]Oh;Y14SCl<
<UcSg`HIY_4>T0B=oaf8CN<k@BB=k`2aJ_`Q48_6]h>86]l68VQl:`RLf@;2=?hP
26VlgI<<bQ3b1<HAI9^W:Xg?H_OC1[:cMFIi]eT^<//d/gBHYGQbPggm1W_E<?HC
JPGj[5TfVfFZ9jWEoWV[_KoEO[KEoVn]mUMH:cD0U6FF5TmJPoeLPee]/8LKk>D=
mZT=m_`6`mC_Z0jXO[=dVNEHcjPjniMem_nX/kmOInn^/cOGfH_[k=UeMXgmYbNU
dgjadgjTdikCJGMgf[<j8Cen<[TnVA9>/n=D3f?_AOf5l/_/ME8`BYWmJe@i;EN=
IWeD9Q[l:g7JBk;9Wj9ZUPgiBmAXdV>DJc=`CE7o=5USbj?nFB3;X_jU84^So^DP
`JQo9KZhRoaVTlJXdRmGYK25Y9PVilNkJ:0^KYRJ1gX<M4iDGX?FgVSeB[TZPEEA
]@V_@<m;X1iS>5iUIb?SIU;R7RI1InS]9nEcl]DbSBf9bUMP9c/ZojYA4eUDoRQG
hlLl`nE;^Ogb^ok_b^oh=@kaJhd@AnEGLm7TU7aLOTIn`@16iGld957iD0cfODFc
0Oe437dPccBi?dmSCifB7llm9nld^XCe7C2`;NnLO7nefGMKS:c9@f]XEnOebb_U
Kl/;LlgfMbXVJ5jSfOOL/W=bKIkIM`eLH:MTWg9>WVddSLXNK34hEAWSY/O<U/Bh
>fCCfY@^dmZTf4R:<<A2N8^f1G0cfi</SiLgbZkZ=O9R>D5>R9aV^dRR2=_YVB55
WYDR7E9TTaBiEhZ/Tb9;Y<PL:E8ZABI:TG5BI:bDIQ]QLmRBK8VfHCJKcFXCKAck
8TgC;g_bSC<YcNX`R1EW:2?A[3^hDDN1TSRcLJZ[L_8`fOQNi=g8Sb0oS=b1_1?i
8NA]b5^@fi73n^DCA^]N7^H?WCB=m_:7n;JhL1_O7Jo]iU_R]BflgJaQ4il`nPB=
eQ5YC>mDfF>ZMFm0IB[KUjTBbZ0c?KfmdUTiXR9UAXggObRJC66C]n3Vhob;6ma/
RaZ[mfmm5L_d<hANIZnJILlYBCh_bBm:9[9n4@0A4a0a0A46@>Bl58T3W5WZ4oF;
0^[A[:0jeJSXFL5jMN8RIEVPUeObFCi_;jl`B33@BiMhYFnQ8JM;gR1PBddHC^e:
`:S<882aXb@K<;Qde8@eaf0:[c1POX<0aQlTaH@Yo44CeVo0NSJFnK`mIBP04Lo@
AQ>bDCac2jC[MTRG2NV:@c9=:kVi/5:=8QSX6IL;@4o^>=?2n9_ZaYQjHT`mdEA?
_jW>RjU[HnYJZ6n;oOnAJIWmUaS`[Edd>idZ:id5SW8fBDYD[NkIZ^Cngfa/RSoX
0[LBg0P/YIAQFDbY@Q]U4>TO8^?nX_mfL:TnJ2VVX/6SnRn4<MQL?hQW43`^>T[k
jCGJ@S]@OiPdbZ=lZ/6=h@FlI8;Dcc`d6I_bJM`Pm]>Gi:AJ^YMMAQo7l8hj3e`f
nNPPYD>nR][A?XNZPOeWg5jVdmfdUG[Xag@1]P]Y8BfV=gRgoP5=XBOY?OHSDM0S
/3BABZR=7Z5mnX]DA;=PZH=f<cOKY5nUNi3Jh=Mgj33m^oh1aRGA<=?7LR0GX:LN
U/36<Po[a7DT2GNKK?S[Adm;d>8TMWB]_Q6]DZVH?5A5LbP0_kOCXo@D?7^M?VC;
nFJQFoOZIoBO81kSdCh7G/c0Jo=>fTRKdL=1>TFmm4NfQ2OYhoGWm5km[?hi/9`/
U4Dbf/c2>c80CmO@?]SE<>:OdHM8oOA[U/QV/R[VIig/BGJFoICkQ29QSa0E7AII
o`>=@FAb4O5lN3fMI/;_IKB2@^Si<OXQML?7:o@ULk;a[9QifG<lRdoPZoUjoPKo
G1C4;[5O_f9j`S4C4R8i3IiGd3bTaHSKPaB6Aa7j;^K^2GSf0^j0kf1V?Z:[m4Nj
cRa<HSJFabK1nUchmc=fRBOaM>kV/oU7@X5@8J`GgaOk;Kk1OH>od`=jD7m0?hgA
Gd9Oa/R=>=e=bn7a:Xbm7K>m4g=WY5e8NnUINYj>H8FmA:nPikO@mgWjP2jRodoX
DoQ`UKjP?n2N?00_4YT3JB@KPiC=RQ2e2/bZWbePkF`Wjf2kf2=/7g`la4jbdna]
A;:F1oPmO0OObeoVko>OlYocSoVWo?M2PY0U^13S7h^ehU;aAD^BIHEU^jG3lY:e
I>2;`NV3M`d^7f`O?:M;NY:N[kO[>oAWM0fcnQ/cTSI:YU7TaX`DH5KWdG`T?eKJ
?KBBVVTegH^ifH9X7T@lWlH8Sm2;V:LOHBfmSM6mSeVoB;o6b7i?Gm403N:2;B;>
Xk6NlmUDS:PF8fYTReV0;F?;f@ZfV[Fb1mPf]QeSk4;Jakj3DCk7GV8mk7EfQGg1
_^C4;CbAYg255f9VJ_URY13F@A_Oc_O`aoT1oQAoUSo?ohV[o2Ao1m7hS0l:`hDT
8E^HS^@CiPWcQI3`P;1?n0OQNN6Hl:k`WW1E^2h<20=R/CQ3_5?L;^hGGa<oA?Z=
9LDbbE9ZFFaIIKWGL[lUK3UPjKI4;AL]GeU;[3RDY8GB`m9NjJ3DCLo@Vo@mk;AK
Wc<dlUKfJn]?dg5nS__X<Wf22>cRYMPkDg3Wm8];j@fL?V?hWoPCk6f/[7YZaWDb
7FLM]mAC5[9C>8QmCOX_TJlRGaVLSG<@^/4cnPEQ;?YMYen`M60>`mSa8k0Sc]77
HP:KSo=SQE2<mK/:9l]TLoOUNjI>VCaYHU5Q@Oj4_=bLk?7^LBi57Y/e9S=S]7=D
n/Rde14YS^@TNn;`H@TfbFXA1Ea22gg^VRI5cFUBaAcgW3U51^l>@A2jAM2T:Q3E
g8iA5J=M2:[KT1hPEolIdQ=3NXJ@c:6DDgUAXN9c:nXi[e_13GY10?G7_>jPXUhe
j`eVGL`a6C/HU`/]59nceJ^X[4WaZCG][F5OTkNXT?G>j_k/Tf55QMBKTSj[NkQQ
FJGZd8iF9hR1l:TIKZm?7Ne67CXQfaMJYOXG17cNC9L[F5BX/^YVmdZEl<I:;XPg
=bf[D[EZ[HIYIJf:0E2GdU?H5giDLm3:YX;4ENiEXFD1E@S1Q4m=:E17^KgZZ6gm
cY_/SI[_dKSbEe2Z?;/Ve1:^DCe=G@Rj`CHIG>QAL?G6jegUWD5Lg3YQF37L=Eb?
3J;5kC<TCN/D=L4mfmdJG]N4V6N4EEZheAG=b?3djWRinIA`Hl3]DR/cgL6@Mda?
6XDGKSdafZ><_UeCE=S[g3WCQI3e5UDEEAUdY/^i<dKoJeM<oT6O@IdkgkP<F[m`
:6[<L<@m5j=@UFH53PCL64ZYDKBDD[Ri5<754f@8`UXeXKXYk2S3K:VFK8MK2Eo3
QKC9OOGCfbFQ^<BJkKQ6Q]:Hk:45Xk;@SKYJD:3Vif?><Cl]V2JhEV4:YQDE]Z^I
kPd>ALe4Z<R?>8J2II<@MiO;V;8^cD<[`JPM2`8aGZ6EVE7bC2X8Z[c9d?CMd8aL
K6PjKVR6VSNi/AY?6_Ml6ZWJLXInbHkdE5m[VL[B_dKMH^[aCJ6`GZ<4Oj27hFI^
G=PelVKehP^5/69iTDIg6<]m[AOS1e=L246n2kEYQDX=hUj3J0NE/1:N^bZ/e2R]
F=1R]TVQJ0T79f7XR`9[DCH6G:XWV3UDK@T6bf2Wa;239X27Pk2`;Vh1e1A=6P1X
NV4m9SW77eP@D3^lVJ[76lBTHP_e8Jamf3g1852U@ik2hae[WG6OIl3WdWcXbf9F
L7?_P8UP>6cHG6B/cki`>3=/K?XH[c7jLh4W;]38P1Qk@F<MO[@5LK/b3H7KiGK1
[J0GGLg4o[Va@?7Ui^/S?6_8KkB/P;Ncc0QGoYDRk?TV4JkjAQ6N?NCYKA6^Q/nc
S@QkogHAm]dFhIZ_Sg3]T=m`LPjl[CDS??N_5>6jKa;QnVlDhGU3W]hFh@Kh?<n8
l?boGHC__2G2A>8_mJ/Lihc`6=kca/L1hm31Ad_lFm105KX[;S75onl;HbS6Dh:T
4SO^?EHgo_/I]ooIWPAAlY75j^?h=YW_BAD46VJEO8a6fkSP/hS1Q<5NMQoQ;nHG
i@?Ule4f39ACIKUS02b::I?M:JjDG>ADJhWfEIVUm4m_JL9Ked^=7QWUjeN4E^5a
VT3[?EEKQ6n9Ni>NC3X`oXDTZd/DGJ;;9LXlJdaFUS`R<M6NJ1MMlYP/bIYZ7Ci1
BWFWeC/U21=iF/hLGY1FT3oYgCLM5mX_>U=6c9PaLB9EGQ^X[4`I<FZ6I74D>?ZH
8IhQfA`IDbJcN`PG<<KMhg9cYQGcg8W<?LhZCJ]PUJ`TOIBAYYN<V5H<GLTM@V7i
h;F1ZLTF8B=am>CZhEVYHo^/[RA7HTiZHZ9[cOVUAOQWh;mScn3a`ELWS9YNcC`=
AeIbWV7=il?4g6W7Sj`mkfiSQAGbGN=MnLK7:?fgb2dDo`I_1>:FAd1M`;mT8cXS
h^_8J]a9jaKG=RaZ;6QLfmJbZFS^i]1mJi/1nVnKHBE62VE^I7=dLVEQK@YUKVA_
HVX:<S@P<21_HVX:<cLi=0YUKVA_HVX:<SDP<21_HVX:?3`P;eAiL6DP;dI_KWA4
IG=SLVU`M6mb82m1Lf=UKW@P=cD`82m3HG18IFUWJ7@P=SHg82m4IG=SIFid82db
=C0P;dI/HFMc83Tf2Rm6Kfid@T9_N21K;C8i=R0]=34c834f=S4P<C8`=EdP;dI_
KWA>HFeU82m:EDM=De@[E6U]IG<]BGAQK6US82m9M65/JF=1KVM/I@X]=b0_DgAU
KEHP<20_CF5hEfUTM6PP<CHa<20_F4QUJFMXM20e<30P;dI_KWA6JFaU<R0b<b0`
858P?Sh:IFiTKf9Z2S8f830PKf9Z2U/P<SD`830P<20`830P<20`830P<20`830P
<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830:
<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P
<20`830P<20`830P<20`830P<20`830P<0X`830P<20`830P<20`830P<20`830P
<20`830P=3@d85d:IFiTKf9Z2STP<21_HVX:?3`P;eAiL6DP;dI_KW@P;e=eHWAi
L6DP;eAbMFEDNG1U82m2HG=UAVm^M20_BUE7CE=D:eAYKFEc;DUdHFaYHb0_AVm^
M4AULf=bJG1dKg8:<SDP<21B82mGJFAdJ7<P<SHP<21B82m6JG9cM4=XHG8P<c8P
;daQLgA3J65b834a>20_AFiSKfAYKVLP;deQHe9_KF5^AFiSKfAYKVL:?Sh:IFiT
Kf9Z2S8g830PKf9Z2S`l82m<IFiWM6PP<SPP<21B82m<IFiWM6Pa834a<C@h82m6
JFadIG8P;dI/HGAUA6ESKfAU83hn2W=dLVEQK@Yh0KdjNG`DAKYEODcgg3ggWIW9
I:kL1i>3A=:4G422PB0TB201PPV288HX21PD42:`8Q0R/0XNb:D<0F40lK48Rjjk
gWPP^^/CGMIW5WLO^Z^BVOMeChPT_kOkl`mofogkZ^Z[jZkjj[_ZZnY^FkRX6BUA
1b9AcIBV1K>AN0Dk428D<nLe;HSS>S_TIfJf]kWR>1e0R9`kNl4Mln8h^aTQVN>>
^H_kgmNK4M9ogM;L=2_NSZi3W]/25G4L3h<lZFENfgeaG7/4lYJilfOf]n_n17S^
_:Kkn/M7U`1ggMDd[aUb^89C8DUJ<?nN=Q55@@[b^PD;Vo^OagE0gi/8@jdEcDMB
M2MR484h^1/@HZk878R2EZ4M[UVYlTgCeDGO8Pd[h]>[ObGV_gFom?hoVjokiA_I
kj52N^=i8IL4Xd6451SJNnDK1e[4mb2aAU1]BPB=1RP6206TY8`dX`jl6cd:/1>0
A:gh4K@HH2g0h`3D@6T_H<Oa8cdDbio0Ri4ESn7UU7>Rg^8dbnC>Mb9HL^@9idOV
cdmR2dS_<fcYDB;YB1WNRIm4/i0C?h^lN0VZA06lkG1`[[<AV_JR1@0M0:BHH[bg
9b7KnC9>AEh:`c/nU43QXlhoIjDi_lR:4;S7NLHOXB3kC@9P_=Yif_64lklLMcQO
1]POKmXGQ2N>>_LjiSXg9DC`]QkWHhh8QWLfa[=53WSeZ7=N/</i:d]/[nZ:4?]k
W0G@?XVG>g?cgLj@hk8c`amQ<N1YSRYWL]HOW4W`8ScVPTjm_<IYMfab3XNV14NI
OcS0BK`?KdO9N7^?Mhcc11AQ^XM71o>k8_Sn`iF1;6l4;n5c:`=M`DZo=eSUm0K;
oGhXCgZEFLWLcXaT/YTD9/3h63MSHoB/U^EH5J]PIBc;<Q5lX:OH:CV9mj=RH<_n
`jb4YB?h1JRTC^;WaL[WSk4DBk28eDMRO`;UaDPO`O^?L4892TLUHTTB`LlOSULm
cc]1Ac6Ra0J>4<Z@@8X8c19X30[SmA49FVE/;cHGJdMX2/Y;oeGB:;KLB5?nmFG6
SW3Gf=Zjl3i7OCQK:<@LmCLN=mlXo<^lKA4d=INTY8bM/?Q`nh8i/l^J?FF=W[9V
P<K`8nd]iW3739O[d9`5@X<[C?XJIla/4O:Vi_02Cg=YN8jWe7FXGGa_B?=/XKWM
DgX8cBjKF7MX=]mLf]?>]iMiVT[[3llXFMP`J:be0f<];?UoaRXA>U/XS3E3O6o8
F0e2l`aQ[0IQ[0IQ[1Wl374/HO9U[KDUmkB1M[[:F/Nj`X7Jl>SaDn[2[ZKjdPSN
3IFURa1m6W7d:ABP>i2EbT1>Q68O0E`Dl^Q]/BoYlhR;cX_mSB`4XAhGP8PF5j7C
J3gJSPhR2MX3i@2JQ[[AJgP>f?IDM0BmSa=@>_QN2TE@5OXmS/GNA[?A<o1l6cZ3
]Z13B07_c4<6J=f0_K4UP?=@WX5FaYi2BBPO[DJWD07d^P7ea_K63T?[17@KfXOf
`o^_H`maR=;5GXQMAR`J3gf^Q9JgHeFaPdR;DU49ZX7JUNQUk2D_aUZ@6AD2MC_@
TfPGnPgj6Sn8SlAJH^fa]f:OPJZJTAgE`[d<7l6OT@NYeK4M/JmRDN1402G3Z8eX
4gXJnSl8mfU`[FGhC]b6=n4]14llB1bQE]6VJ1o`8HPZh:h4[k`6>70LWDEoAmoS
ZhBIi<PflU`/5?]O94MSHIK2C9YA>m`?`kd1iW@BBg0V7XE[l3:l6Fo1ka;9a6e4
7G4_LAoa9CV>W4X^9]nUkZ5jj7Ed]d@NoCIf<WHnMP6IT0?MSQJRiC2k<nP]M0gm
P4WXbhjm^12Gh6U`Mn3]a76l2alWJ_1Yo1Ja3olAOhj_hQl9VU0@1R:5J2<f4O^9
<l@KI2^iQGbLo2?i;CF29^QMm1LB;o=aM4IdKOB=F67//mPo`LFbb0fB:D7Sd7CD
1;=MP8JQ1f0Fcl=m4:Af5Ye3[hWgimR>N]4oP@/8Jk4EIn=Z^<OQFo5/g8ZO`2OP
OUVTiC/214582@eQ8^a4;C63V4Md41N83]969Y=Sb2WT@KQO9MlWObAoY6Q:AaVX
2VXdFTO=XkK1_I_J@oE@Km85m0Qj73f9kZ3Gd^_8VOCKm?^BiI8=TQk9ELTgh1J[
V?W<>Y3>Jj2c_`5Mo^VRL19@Whg^@S=a:Ij1^T0J^g0CjPC]VXGG0;lFX42/PEa>
EQ2IX0d_Xo]1FkNQIFP]>AG]RWe8kT<OP:K<QBhkd7=D2G;@Fd4j3j9<d:;nV`lV
1`=nWcO9TnQfPL^gfj`F/lUXd>^d6TjYT<^T;2>Q:I;0:;G<DmkX2_/J`iC?DeVI
9^2N9ZQX^ZVR4DcI5BhOo4cH9KcG14f3W^CQbMU3W^CSCo83Cf;>EHB:dU9MIAiG
n0nU7UL4CaUO1nGeYIijEkQG;5N;iDO5/Q;:KSNlh2Xc]iBj`[SAEAH^KfoY;6//
CD_5agUPQb`]EG0L?98;7HOAZ:IUh63A:>69/[3EDeXF]WRP36fT]jaYE[QVO5eI
ZLg][XLjZ9Y@1f>TYKJ6PDkdR6:FImHS4Ak=J1A:CE?[`VACOIQX5?[BY8A=W]:`
JLTGiYo@6jFbMCLeQPU_NE=cIgVHKg`4V2^PS@;F]0j`/KD^j9IHEElGaZ_jRA1X
W0>D2^C6e`A_haaGF>XYlKAdcVT4iZ89MCeFgRXjgc2ZZN^al1HABD/mKUiNj8KI
7dlKVCIBb0_Mi^Gao<l?aN_O>BgTi^EWo`Cif0T33<021cbSPLj`JjHhR0N8cANB
iWcD>C<On0AG?HIY]P8mXl84j0cY3M?NdDgQS]XKI;BDaXU[W5?J8kEHaDFXY1jN
KncTQX>Th7W>hn[l5UK[ATo_eh=[V_Y[95k^Fb@d2X8Nd9D`K[YAKQLFBbo<^/G/
JA7Tfbk:572?^NbV2/05ePPdQoF`P=OD^L>^NZR0J39eK0A9JnX>HKbQ?X9SZb:X
e74LHUAbnSAXCQED[KDDaPLT;ADZT]e@BTmeUL?8iH:^^3YMWJ=WMK[:GBfPC9AG
c:6Q^K<n0cQHF`Ml@Q=QA;kN=U1/[ZlO3_eT2?g0:o1hIcgd<:No1lS5ZX`nN2Pc
5AICdUMC=kh^g55Z2o>UmB05D=oC=GGQdj2imOG`E=H0YD3a/UIc?lgI@7=F<[CW
a7^1f:D3^ZS_k1Cj[:gc^<>W>c]]WH:maO48AT<[n?j:218N4EPN`Adel2iT7[M=
U87Kh`JbjPFN3P>E_Z5A4;?oN`kW3]0=KnH1]KTRQo=o8@hGo1`>3omI72hLX7@@
Qh^0iT:1`kOlicPlHQ27RolmQoT1^X78TD0];g:hi1ORl:RO`n7BWlGQ/P5:1g6h
76P^4cQLlIoSL>DP3Xonma`N<d0g43TFZ1dSL[SZ5n9`mLoQl;ROaN5K1bPMa>4J
X?UFPL?Sog<LWS28`kGoW/<C1nP68Vl3JRN:79kd2g5hl/oQL=g?hW3m0:F3>3`5
J:hG>7ck08MiFaSMk8LkQ[QMm8/kiZTg/A`R9EZ;BXP2f3S_@a/0BZT3J2[P1hDj
jQid5R0;H1Q02D0e`=SnlVS89`2d`fJl4?9lP4Yl7Zf4G812j6l]]0WmVf2X6fM4
2]Ri26MD;]RC`9Imd4E0]0l3RgDd?0L7C00/[<Dbf<TXh7a69KKmLXTJc[4d/8OC
mGNY7nSJP8aRf@Ck=D]okC3HNBb5B?c_/;_8aE<9UYQ4O4EfT;nSU]9JnY:TG?8Z
<hb9/ZW/6RVBU/]l/WIhTh2m2j;NPSd_2O<YSYmW/AT@M02`G0BQ]`047<[TY@RR
012DVD_XQ<R1BBTWX1LJCD[9c<[A^3EnP19Z@nCjOm>WOQPEXJYoQ;<Ah>J6j3BR
RKj0m6P4;mE[Y3ZSbFBEW/@kP8Mj_8=GlJR3Z^8/1^<og7<WV2=<mZZDU77GZW^]
WeQkgn/MEmILnRDZ;/k:a0@SdG0VXljCS_dn_bo4iNGZR6VocZPHWkeYlF?U`GbS
_:7`97dQn^JS7dLoRgkjcNKXEiNGcmflIo:]>?3WCMP[dU<:m9R07Qg:iAF/1^T<
@0mEYMH99<4a890TIBej`coLaOO38HY0bG^mWma4QdjKUj_Qo3hb9`6K4[21HbAT
aI?Yi@8EfdKj<X?C2Tm4Yn7L3AmP=gIo/aTK_k^WNMVe^j<OG]TBoEBT0LhgZOVD
0O@WSkNCBfS2aLZGb6A:X4BbQ9:jB=TBI54DCc2WS>>^EEl[jR^je/n7>9:EZ@^i
=L1ePe_SdDc5AoKS8m6ZoOSX7W`/>WY?M0`n:Xic40C@PBj2S7fl3RNC<QY6`;>@
QJ9W^FLfajOGMj?[gZc<_1b3in3KKen4P`m1MW0ALd@MBN5=33KQ[K2a9PRkUR@A
@LZ4<bkBTV5n3aDG5AOA3jNW;>?>hPJLPcghWNiXN[NP2D8oIj6O2oAS877?8AI7
L0j_X2Q6@C5M=99EB;Wf/nJc5oX:@<cGoR3<K@C>bh69WGeUVfo3JO:kCUgmkQo^
8[lCJLZ:ODAIjFdX2igUWJ<E]FW=`IUYRh:;dRAM?SbFCI6IDoA:l_//ODP96cL?
[mN4^0NDbRaK:8UV@UU:LiNoE1>14eNe;3mm?^4<^UJ@OR:W8U^Ph[gNJkgL]kf@
X^;NhUi]@LJe_RniGZiGXbg005VIXaKc^AVI5QnBdSj7=m4W@F@0DBBK:@]P^lLI
@5J_>H0Yc0C0U219L=/2f>:318j8De8`05LTU5J/F84JL0=5Q7:<9V=>MViXV<nC
:6522CPW>bn><A;6<b`_eid=^f<XPk;YT@LK_gQ94BPo]^70Rk^dGYgMIf`N^K2k
nDRISnkQkl:6SknYB2fonh7XgooYajIG7bVn^o^ncNdH?dTB[_a7kfbk[fC9cPF_
_W9liH@LQo=@aanRDE7<h4D@UD7_094ZdE@nDD[8F2G8nVF]A<8@4T`c;9bY<39R
TIbnBRXHRXaPdh^hBlTNT4E`gF5JGJ4B>OP]Z>]U@I:P]IX2TF_0^09@3VXIMdh=
MZbAHXdkQ7<dX6`Jh]UX2;oA]hih]?_MMn4hIVgO_E4JC`^C6ji?ogGd:H4fS4YR
UbPkg@7nnBBODZUMhb@:5>FjbKXkM=A`EZ5TT4:VEZTFJGDj[D[]d^XHY3?9C24P
;96g:Qm@ZAcJhFZ:2[W>>i@J9]lj7nFk4R_LLHUofg/FQ=eKg0OB_Wc]QZ@;hS@3
bBP^NY2m6H@O<3^aU?2A2G0`1/OZ;][>1;3D30UfDP4T/D72FT0I1763];TR@Mb2
[1_0lmdTIkl>[9O<cL_=bJH<N/:MV>C_dbkS9nkLMZbSHEG6SWW4UKhWKlU>ZfTm
QkDoAW/?A_nG`o>f5BKlOVWG<iFlU2AOR2kdjMcAEej?o^kLkh5?1:Z>ODaij2N@
3OWAG[kPGR/f/EkFKjVc[4H?hcEBYX:E^Og^T4ZU9llc8A_]3h6]18TE2OVJnBHI
DBA;bS85:`8RHoX:UXjML=nB33<HA;lm20HQ<4PdPf5NWmfU=R89kG>Y4`;HIdP:
8;/>BX9=H8YdL^h0mQ[m0NC@@R;HQ:3n:CQ^0885[<0=l<W6J?20?oLT4Sna`i>8
=5bNeZg]=`^3gYQ3EYcZhC`SEfk]THfH=VW>4Jb8o/m[dD/SUn6Z5N^Gkfhkn>Aj
nXW_EmjF>BGjUnSefm<2Gein9OX^cX9S=_T9?>^7Cok[`K_>Km^n1XiQ@7ASAGg_
@6YDbnOBLP^A;an^:52>DMi6C:9V4<LHfE;U4NDi9DU8/E8e7:TYZH9@`RNTnBXf
GgY0YJWPA3J1`oQ2D71@NM1hD1_LT9GIP0dBF:h4nmGZL_?L8BZSk8^jbFV>m?>U
EmI^_Gj5k_SeZ>RAdbNgcKb4]n6^_cko8WcB0Sgo07cK3UPGC70:mcYO<@U?UTiA
en]VhFKYWNYFgKeNjFS^OT^kIj7g7_oB[:GIJb`?^akf[dUOTmE]DEJ`fJaGAGRc
iB6=9YD>9M2VD:ZBb8L=lNYSZ_cPo0`fg`KU5oGi6L<ZL^;Z;cZlWoaMKmaTnfDL
BTjg^kA6DVU<d`N@8TDE`38]2f[^P8Ab4P5/B3L5T38I4/I>1c3YPVC0dhUN;RkS
VnAh/d`A[>?3`0CR3Ph<14c1TiP4MGW4<j/k7WZ`[F_fVVOg[E[am9HMdANCKkeb
hHf_BWdemCWCXeONS_iajA:BGcFeI_GZ:Ld;n`XOG_g8Xi/NG?0d/C>UYV?WUam]
G5fKTAH<cMYi:_[mialnL3a;/97A/@lY3J`OPXg/im<]M0XM<5I:j^PFNZeUSKGK
:ReW6KOO7i;9c>h@Ae<QfgVcTR6:V8@/n0Yd6bmGXZ1]AE:nlXJQR6]6Gl6b^;F8
_VB`XCQm5Z]LQdV]Uo0UZ/5:G1Z`4]82;/@W1mBS0T=ajR31EW0OGPEHRfPX@W:3
QcS^?G@Z38HB6ZK=LNV<47^0ho25d4gLaAakIekIRZ>nXT>cgocKGjoPPW];KWdX
N_jMRdCfXBO_GkUmcAHlID]1`PMhm?AZC;cn2Pi4_mcnUnSg[dMO^;@KnmJ7WmQn
J?>jI`EmW01nEcQQE/>gPb;d2InOW8UUW=bV/?]c:[UFjAb>:F2e2RUYbfJBY0i>
hBQ<8M:3QLL:RL;/I:nFHfSFkTldfB>hToNH74k6kdRG4hj@_8PY:[;[VF3bWRC[
25_@?TK]ckOL<^8U_1D>eXoS;]@ONUg[7LMmEgfikbah7[0`F9?1EF/;=5YC@@=H
GGY_NZn`;V]<LIlDb<dc929/lN9L]A^I4fa^I7CY8@a;A7V46eTM9SLf^24A_O>P
QCP9O7=NkReHQMF`cTT<65bc^2@;AS`2eVC@C@ehXF`H@Y01Q:129ZQ_WPj[5XjK
G]oUK/VN=b>[5QlIHE0l]6AmXE^fQok7djOJ5iVlRPA=LZZ_8MTXcG]SjIIC9kIf
_STUMOC^S@JkA:FdImb1ik:Yi[BY]EG9]KoMGUWIgKOEWTRBZaBB4PmO>NO5=E^N
dN7;P_jfacjU_?@If24TX0ElnVkV>O/7MS:AEBL@=48V1leXI0T>^Ec_Ijd^JcZG
SX=8Hg6j7WJOJQ2IFUCMMoVb`5DaaP66JPXdLNjI]DJ9c2SAnk1F1XV1<OV`CY[P
0fJ1haKF<5f>AV25ER=H:G30h4TJD3eHg=X?5SkCn>[ggeeL<S6kH3LaNn?6mOLO
meFLXLodoDoen6Q_m5Xd6RkdE:mMM^GU_IlNOG_[]4?R^PEOELRgZ77`=Mn6W^<c
W[?PK_<NMYnI7<=Z]^]9DRmaF1VU@bng<CJKRO=[<HA/6Z]3iSMIk?2YVCW/G[R/
Gf=PITGEh<D44ha[31@hR6eQlAj6;:aGHI3iT4[7`B`eJXja04HSdXda@I5bXm:7
e5Y8Y6J93l8hRO_6TRDXBg`aCa43=f@d`DK4T`RZ4]N:W;QULRR78Mkog7B@FkSl
`9S<=Hl]N<Qb<>6KTnolP;G_fJUah@mV?[AWg/iMUmKNNn4Lc_TB?PT=Yd6^nK6;
I2o8E@kOBnkU/o=D5J[9Z^NX_CKJbnX9]H=3[<?1j6B4`bBWdgGYG52S]C[UOZ/U
`OV`Nf79cM<70@_ajlfb]I[]DQW2f2b7^MTQ@AK2Qf@fePLC5:D;/m8:jQf?@`g8
I3C15/<C4ZJ518OcgF>kU^gJ_FC=G]aIVgW;ldlE7iQo>?[3eDoam2/O_?Kj:fom
S/PKUS2FL?``H/_<>Ycf`eMh<_R@b]Q5bPXna0iO=;eH`BoNbSi^OLi9dRY2CN/=
:ZgJX>LE_9h=F_5HnE7b??h]NMkf8O^Am7gWQih[YR/NnGW=NBdaUJGMBNY]ATMB
PHAQS6j7WI4iS78_/mGnW?dHf03U=JZmM]XRDc0JUEo]l==FOe8jhkMHO?kgg;_S
bPnj;j[nNge2P2N/fj0M3@=j0R^h6>^;fU:>?1A=`RM0C5<BYdo3JCTMYnLXRL:K
J4_b@CCZl>44QmC4n93LX?91V>2a^Z6:QX@ePehY>DSR[Sb^?^3=Te>BEn2k6m3M
3A3h08n=1WLlh/l31A921S7d@CUH38TT32J>_9nOZnF^GjDOgKYnHZKn47=[eXC5
8bNl6_d:VolK>nF1<Ll_gD=S3eEaifgSihiij^Uc3KTEQA_CJn`LK<@TV<0UDMnR
lPL?Mf;QAa_@]ID@01GfkoecNC_c1@D1THBDBHD=:2J230V68]gWWQ7GZZ;Z/ge5
Ifo/a8^:Zl6J`1=hQ01niC6hZ>@OgjM?aF=@j9_/1GUK`9ZWlEW79>LU12GABocj
MTTK@n/EQ=k<PIM24[=LIVF/EZ@8BZefW6h>FY351T^5i?1?0oN;:fk;AJ3A`YI2
24j4_I<^ag33<G/d`h@84_RW`PJ=1joLGkF_iG9=jS57iW8n>2HocGH4?dMUM4nK
l>CTYo[64do?:9ZU=9J4kVk]Na>81Cd]Q7fU6gb@@SaKNIC?jFJk^<N=ce9kf=gL
GV>4OIGmP?Y2mANmHSP[LIPIQD<[]c0FRh7`ZjdfZMmP/D9/9@E?e:mYh/[eTaLB
EBXEVBROG2L5[M0@?/bHX4@[XBCC:g`8Li2`AW0lY0XBHNdG4l7Q96U3hPa5Kj>5
h1PFOQ@BWLfOEVEFWGRfZn]Yn>7PN_@OWdB_HnfO9FeH_K][f^K[?O/_TaNSGh?[
kH^nP5>^``;7db3^]J08Se4E/8kLb__lY4nIAeI@U8[U29ED8eGhFD546QU[eF71
eb2;EQO1IB2Ji@>[b3Q>>9VY;SkKMeJ`Y?P6FEPTA;4HC@K1?dY076_g6ijiTcHk
>1^gi[4SE<Kag>d4nC9975cHebgX8lBmi55Z;?`]TH7CnEoUBk_Y;^gSnVi3Mk8T
T>Ceik[;gAE95Oi9BI?m/i?^l2eF;5H^E[EkfY;J_6fng@UkDWDTV22MAZG[T=EP
<mW=QSAmNT0]KfEmgU`_hDeDbZPDWOVgMXN>XAcYfe;T6HaDaA4<bW1WF9eVXmU_
6Q7`<Oj0=D_Um7<ST3oMTYWE<n0gNZoe5@RNXjn0Pi8`gH8<8O0@0goH?OK2_/QD
L;LXiBZLA_P<GZ_?[G:jTAAn@l9T:/@eM3:D75ZX/nW=K^aB9kZA>e6UI?db=oIi
YC:LA[WQgc=84SAf=kHH8A7MQkS`R4UL8@CE0:D@K20N5P[:TB6h336J=QVIn8h:
]<ETM0ZQXd4?S/GWaeMIKnVNFMfgn>oieMZAKAlOoo^MXhQm]6o4hk=Kb`;SkSeC
d_[AYeO?<oPH[YVB>GWbkFE9h74CTdN_j7iY`iBFFk8[a_7UbAJM8b>eK?>_g_YX
9o4mj98YMYF@dU?0LRJlZ4bGWEK16DlakjF<1BIBXY9Y[>1Gh?@PR0`ZPiYdTPAi
gFRaF:nkknQO]O/J2/iV2<hgkV@bH2mEgEODboEM5Sf=L5004aV8_G`QF9MbmQcM
_mmWb58Vj9fSo<^WK=a8ChUNf=AGUZnCHf:3U5ea1g5^TnS_1:n7H/g`_lWoMeVQ
4]@7;5lUW[_ZhI@eO/8Za2=fE8[:D;WhEd/Eo54So;Lb2DdF>l9`BX_5TPC>K=74
fY6SAYFUE3K?KFm^JigI12gaE^6A1@1;0MH120N=1`1N0Q2lY^2F_`Jh3RlX0>`0
Z@1505D0D`7V0R`5F0N`0n00`4/0_`Nh1?0e`?EHo`EmXH4bAZhQ>?cO>JPMoWDL
Q:L<`M>7h1U3L=QH3GXoI`P>Id^3fT=3l=`QN=h@?7l83Ul21_DWL?[VnLhHP/lL
P/lJPX]jLA>oFXNdgcD4Wcl4GcP4_fL8gRKPo`MILWgY2VE^I7=dLVEQK@YUKVA_
HVX:<SPP<21_HVX:=c<d>0YUKVA_HVX:<STP<21_HVX:?3`P;eAiL6DP;dI_KWA4
IG=SLVU`M6mb82m1Lf=UKW@P=cL`82m3HG18IFUWJ7@P=c4g82m4IG=SIFid82db
<c0P;dI/HFMc83<b2Rm6Kfid@T9_N21K;CTe<B0]=3Pa834d=3DP<C4b<UdP;dI_
KWA>HFeU82mDDd53@dD[B6E/MVEdJF=Q82m9M65/JF=1KVM/IB0`2RmCM6E]ER0`
82m=HGQGJFAdJ20a=C0`82mHB6EYIfQd83Hc=b0_AVm^M4IYK6Db838g830PDR0n
?PYUKVA_HVX:<c0P<21_HVX:Fb0b=cPP<20`830P<20`830P<20c<c<P<c<c830P
=CPd830P<20b=cPP<SLh830P=CDf830P=CDf83De=R0e=CHP=CDf83De=PXe=CHP
=CDf830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P
<20`830P<20`830P<20`830P<20`2S0P<20`830P<20`83De=R0e=CHP=C0`83De
=R0e=CHP<20`830P<S8b830P<20`830P=CDf83De=R0`830P<c<c83D`<20b=cP:
G@YUKVA_HVX:<C<P<21_HVX:?3`P;eAiL6DP;dI_KW@P;e=eHWAiL6DP;eAbMFED
NG1U82m2HG=UAVm^M20_E5=1@d=5:dQUK7IUM6USHB0_AVm^M4AULf=bJG1dKg8:
<STP<21B82mGJFAdJ7<P<c0P<21B82m6JG9cM4=XHG8P<c8P;daQLgA3J65b834a
=R0_AFiSKfAYKVLP;deQHe9_KF5^AFiSKfAYKVL:?Sh:IFiTKf9Z2S<a830PKf9Z
2S`l82m<IFiWM6PP<c8P<21B82m<IFiWM6Pa83Hc>CHP;dIYK7AULR0_AVaQM6E4
IF=_I6DP?Sh:LgAbIF5]2WP1_ET=M5CE]MkWg;Tc4lPT4`QQ@/SL>`ci8LT@`HB4
T919<Y>@Q>0@0Yf9o6@8PH1646WTAgRY6:0CIDeK5J_57m[j48gNS3ajXj8lmOUK
;=[FenDC]J^achFR]T_]SbKgOOO>4:3[?IMM[j_gIYmmm]kOfFNOOLjiLnk=]ZgO
kZ9TjR>1_9dmhBeTG5=6`:IemVjChk;e597XFkmU@dmLCS4AFMkLL>f>mG4i`d[4
kno^2Zn;bo@En;a^:>8b:`6OfMfcKG]LW_8f^?GJcId9NhJ^=_N4]bOj9md^GaO^
jM8=A8iOXLSO/_V6KHI8SZ?PAE^fMRG`;8QheUl^Ya0aX3S]9c>M8R]ZM]`183n`
_4TVF7Dk[_j^5f9[DR/oIfTH1ZhS[H[1Wgg2m>;XTJlN]cDVo@B]TbkPMFjV<F2B
Oc]jI?B8MAZLiaQ=;QALYOY2UBY1L`^OhSmRbEA94[lS5YP_ZOafKb5he1bel<>=
PhelL>_P03nlmO007i@6:oQQjG057i@70ob`O3S0EAim_:94VZ;bPER3U:kb2=QT
UGlGK9;:3h2UZG`oV5gUnl1BEMh?UZ;bFl1/:]l;UZcbVl4VZ_`kH1=DgPNFY?9o
0K>ZO0nHANFk`L`Z_`U<E?T^<9?:Mh89:]l1QV2fPc6Eg`Q6:^oeYX8caRR9LBCI
jZe9ieG/>]Y2=[K9::lfbVE6VFjDMZ<d7MmRfkc5ES>1oH:jPGkA:3^=L[8gYM_f
BKM]Y=_fH[O]?kY]Ck=^JP4XfbQ5KgZ;kGB;CFVaAEY/UBff^BffPQKMeAnY2JPA
Xg@IYM<k]LWfAI?]edffei]/PdffcRIKBI<]YlVV/_odY_GKc_KK7^ZgiOKKg?ff
k7iX7cfNfYa:BDnbAjTIc/k40TGBDn`iTS5:ROekC7iBZ/UTYjS2Y<]?9oP`BHIl
P^YH3_B?DI_17jHlZhk[R0E:9IF]SPFZ`5K60^ePkK70J[1@;;0FGGb;0TJC]YPl
8]FT/EJB3IM;4Ufdd03GGBd6OaQlDDcJP=JnF=eJZBJ9eE2M0En8WUO0?5d?_<K6
YRCLY2DRC85=]m^>BjNUlaDZFa6Cc/5?CTaj_dde/ISdKYk:7oI>U=k96i5n7_R1
m6Y0iE0of`IeC7XV3de>B8m:mdY7MF1<nZV^RDV7hk0ObJXEj3_Sj3_b3INgij_/
kQ?Bmo=>Bg_d;^5m=ac/c3l]GEMWm=dCIa_bdA[FmOTSdU[Y>e9[W]7n:]T0;Fhc
nVj/>2dei1]meb<4MT;bbjNUF[eYC?9RRb6Xj[QD5WLk;biM:AWNiP`HgX[S8o5P
R4F85Vd;4FJ>=eFJ:FfEG7DKY>EBTY@DOI;]9@]5fAk_O4_d?T^dca:m`A:maQ;M
I8V^/4@GFJ;UU^Q/BgB69NZdY5/WFNgF56^bMH;EJSEKCEJ>OI6^J^mi2oAWD[[I
[S<cWZ6<C4KMc_Dj2YC4VIECDhf3AlS:3h3fPFh1g@cZ0nd1g@CJ2MX>jPE5]?LN
ee/?l`RojKSQM9SOa7LVU3_i_TA]7mnNZ6gW_DH=VoQa_Do`F1>Ab[AnQMfVV0l4
5JJ`PeT:X@`i<S9jZagETaJVcJogoBm5Qj7/l1EN_1aoMh>;KE5ScH4Mcf2IOXcD
Bn`IXa`jHI5N/dR?F0aTlc80XPHPJP2R383XJiIX0^38E^i/GQIDSVF7U;UjAL/>
=B^cUlT[Pl>lVUOiOL=lXLi2`F5jQeOkFgDm_N<;0MI^`?3D[PJ<:W@663]6TPi3
B<L<F6LL9_>5>RbP<l3hSB@K<9WOJ<16M=S@ePZoKjP21B2VTkCEP6`eWK`4<W0i
I<2032@PFHJG_3ahZD<A2Pk=b0=P:6n6hF7VAG=Kg3`kKYi]V</^V_?SiXJh^@7V
bg;ooaBjJ_lN1oj=bfXcZ;[JDFR_I<FFI<G/[UD/k_o;a`f92egPE88CPEQ>dlCU
=5WXXFU4fU^P3d1o66_Ga/@BlX`Mdgh[C<OV^Sm1H;QLM8a^YfMY>ne6oFIB:Il:
Z1hWXJ?hT@WA2??B5MRDmn04LC]m@@iZX6_HNnSSHOa6_@IL3_WY46E0_hijdCjG
jX3m=iaNb^QZfT53m3:m2Mm5e4[;jGTnZ;e1LnP^>/=nIQ:d:3c=YWWD@kO@@NdA
lU0E??GA?^IV=fSWJAG^7/Ce?CY2_m;N`;P/=<68/A;8YNQYR2Da9o>bOQa7DW2f
bD6l0OBd0Rf>HdLgJ5_AJS:ET9MZJ1454OL^^YG^AVC?dE]/=MlV36XnkJCf2nAS
9][W8X[in=VlR[KB=_A`R4k@<?f5[N0YfTc]0FeHNe7k15Q>8VFCQ3IEn8d<8]8=
M11nEHch=o@FkQ7j?D]V2eP=2k1nMQMkTOfBn`F?/5n8VNbRY?fIYR<cNLQh0J8^
X`F8NbF]XC1j_Xen@X>8lAam`Aa/9R]Q?_H0cnJcn7ZnVCo??c49YP7CR7K>R8AS
9Rc8I2TRGdR;LBm7gVjT22::dPl`MgLR/Z<h0kj:VGVGc]=Oj2/V<P^c/WaF3>n=
R>lgk1fN`S>hVmObMhE2HJ6`fOBjJDCdSadLnj<Fe4;JmMZC6?dkj4/O^IjWZfTe
8Uj7/OMR]_MPk_Ak;nh3M1lmB0mQQCe6Cj?WUm3gJo@6WDGo7m97R>4lODIoaSUi
554T<c_^:F`jkQcV@MHFHUH3K2W[IG]H7m_;KV474N=QMY`mbEi19Q]hT:oR^oT1
oQAoWOnB_ldoh1oa?`U9@[KP@XiO=SFHfTf?R2WR6W6Gf2LnIYhgn]UHfMRgaUJ?
mHjMeRaJRUJPmFZk]G/e5K?jZI59:jGBE79SAPXaZh]Y2Nh0E]XZFT^M]9j^`Ma/
AcH?8IogH8@?dB>HYimQ;Kf2dKf>FCm;_lO8oTAOdRR=hH1]@Yhc/Ih;f5b<Z04S
JV?;FI2]I:_I6[JNMK?[fDjf2f<L`7f@O@nSO80maXKHLn`Lnham`HV;?9VWLITG
HFHJn7;LHJb37[j;knOOigO`^oUmo47n[ecQaoV[b<K7O4bH::@8>D8IK[n`F5PR
Q8G[QH?2ShD7QHN5W`]WQ??2El:X<6XZ<LdgGFGJIK[Mm:cY;MbORVUR/EP^;QOG
RMN8ehTAl@iaD8b9IlD_cO?<N2QIFRdgF`iH3UT6jEijPGj8WGKYMI:VG2YnKOdN
NYBOiWijSci41_KbL^bM>CQc1Tc]m3bN?]?iGoVMk1F/[6KZa74b0llj;SIC=/PQ
7<:n9^egX?>PLf>eN0k2=WIBNe=`X]m=fY]R7nH`PQdo2C_R=7ePBV9;l?aH8iAP
oJk3TnD:HoLEN>O>^J9h]ZNX/61FOUi^cTcg39L/>K>WIdg;M4c=V98nNE:J?CG5
USaa@Y;EHQI=0PjQAGigOHN/i7HXYUcgXTDNGGJ7X@QOX^Q@I:SZ;lLX/]h^3==U
B2n@jol6jHdS_N=8IYL[ZM9C9?_M/W;JiiIaPUhJA?dfWc/T:nN=NX]A=nDJPPf2
bhDF/]oAkI<EeR7kUO[NkXRo`nLYH/=EPamo><5CA<=Y6EF34gG?2]F5MgLk`7B4
GiWVm_VEC3OZ/0Tio_0j9K0dj?MU^E`QCi72jS[MJaG2;eIZHJ:ihEVae2WV>[RF
=bXH00g8@dFW8[NZMU[KDIRlc[d^_3:X266hl2]YQLYD]dnI^W?4LE6lD??OVS2n
3j?2Ln[3GI5jaM/aP:C[HXL^QFn5e:co_2^l?hB3FclLbgZhN^Sa@GBioKZVHi>/
9;U[gMfACAg8nKB8@ZdkG;5Ydkc36WkLo7:T;NQf:MEIkU3H=gdXWB:]>ak?m<ZI
Ue/lAL>>?@]LB=V`YlICXo<5;/NN>?o__G7m6jMdk]Sco7_PcJgSFF=j8>i6S4:A
>fD447AS:>EjdEE>TLib91MGR2496iFT^Xj8_@:cYHPiM[LLnA`7dPkgnHl^eh@C
6W>>oG?BSOYTSblHQHD_e9G2@ZFP07>>nNW2=26dQHJRe5?DZfBi]mQU9@^YXP3b
60iE52?_;YLnI@>ZUmI2D?ZF1^>bC6^cH^@];P`Y_4>gW;YPVK9L]oAM/8`gkg1S
=AkGcoTdAK7VS_nUfS<Vnk/[59Ka=NH^`hi_2TG=:RD5PT<<9g?m`:jB;g/HGbR4
=J/m:UfY;oN=?X`O@TTA50D^e4Z;i7[T_AkI3/TA>M:h;R;GbmeHd:HLPl?@5@TE
HnS;PQ]A]PEMRSND=Ek]2XDZh6NNkPM=08n4h65C`P>hXBXN1JR/Z1VCW1/8;PdZ
OKh/aN/;HE:aQDhQ[JN`Nd8QX<[78dG4^cLj4S7?AlcU1K1Ga;gPi=h75j58A?Ni
C5nOYb:A[8RnjN>bb^Q_5Mj4@RDMX^l5UOD5d1K<kL[B5FjGfhF`@Sid]@3kil82
aINK[lm`eGSLJ;T@dEHI6Jkn1fGHnddbG?>=<U`k7^UU6Ji3c;EjQWgo_0ck;l]`
oMMW^64lKPBi2=4f61U^o0MU^>VKI;Si6fEhlGRTUfFh1C4_eS>li9nGhJ/^bC2A
jGOJNG4oEN=ALn5KIc;N598Q^lHen4k;0]1`oAaQM^=MBSm=egZCC1HoRFHoakNn
0^mT@J09IX^ODJJE2gkA54XJ6fKG4UkI?Z/L[Eb2/VFdTZX[kJ<@DLbi`YgVB//3
CCK?Dkn/4<_onY8Z_?AE>KY2gmGJAf:KX58[:m>oTSj1/9I@=KPCafZM5n>PDUeH
T`F36FmHI[bIV?6^I<KkVAW_=fJLA/dhMI]Y7nQ>d8>P4j0G@;IE=B;m6YGg@GbE
B_?]:]W?6=jLl>J4=bNl>N7=2Fm>N7?2Va?NW?3VQ3LW_3WQcGW1Va?NW?06eflQ
^7<P25Uhj>IC9VPFJ3jX4A@2K@C]07dGm4?@@j1Qd</PfjXWl5:hQ8[C9/f?AkOP
39i0aBXE8m:f]o4NiH7@F_`4cL1kCCDn8ln0`@Y@:KS_c1EcV=V2Nh[ib[UUloBk
=;M/gYDI^/k@Ydo=^3:^;lW;cB/cCHhKLR7TU[XC:;LQ6RXMbm]Gn_bNM[ioURaU
UND/hXjYSD7><c9Ml]AYQKVn5KEE/`:Idn/cFK:93oQFMWcknUWY4bJJ75UBcTc?
g:[jdS:GgII/CA<?goEO`T1bDm>VmiFCmUA7BN?m:i@UCKamEWUIKDeCHj1fUXL_
JK[^dj<eldXclP9SilhndehjWo=6]jM`cYa2Sm/m:H??L9EVBDk9FgEFDEcjac7]
3j0^B_a?@5m8Ueb`<bi^k^WJ48JFhLb[olCZ7nYaCVi_ZPff]ABfKNcY^/7C^2el
kLI>V?h7o3aQPPYUKVAcM79UHFd:IFiTKf9Z2S<b830PKf9Z2S<i=cP:IFiTKf9Z
2S<c830PKf9Z2S`l82mDNG1U82m6KfidA6EcHg9YL7A_LR0_@G=SIFid83Le<20_
@f5`B6EYIfQd83Hf=b0_A6EcHfE^M20]<SD`82m6K65WLb0f>0X_AVm^M492KgPP
Fbdb>CHP;C@a<b0a=SHa834b<3EM82m6KfidCV5]IB0_FTY2F5A=:eAYKFEc;DUd
HFaYHb0_BGAQK6US@FiWK6D:;CLP;e=dIFeF830P;deQN5MYI7AX834f<C0P;eQ8
IFUWJ7@P=C0`82m6KfidAVU/IC8P<c4P<21B83hn2VE^I6mRJPXc=20`86mRJPYK
83Hi<B1M2VE^I6mRJPXc=B0`86mRJPXl?20_C6E^IgAX83<f830PDR0_AVU/M6Eb
82m6K65dIDAUHfmTIB0n?PYcM79UHFd:N05MT4eZa30<QOLnQIKCaF1We/I@YPaT
dAnJmP2>[@A38a_7FNCfUMed2Ug8h:OgRBO9JooDDbPPgg9d0aJH0_V<Jmbb@aQa
3RBj2oSPb_5[VU]/4Y;QHEl;;Se=4K@F0?:MTKGT7Dj??XkhD;GGk347V^7dNAfJ
<V`YON62E409Hl3Sa>>NKGZa2h9/j;Wgg0mU?c?eioSH4`8WHZ;kRNBRacEIQmWB
S48[IOC]IPBBomLjP74jW9O>j5Y:lE_m_if:eQG_TMbF<jMYMfQ1Jh10N3mERZT>
J?D=KX1`4`YUKVAcM79UHFd:IFiTKf9Z2S<f830PKf9Z2S8b<`YUKVA_HVX:<CDP
<21_HVX:?3`P;eAiL6DP;dI_KW@P;e=eHWAiL6DP;eAbMFEDNG1U82m2HG=UAVm^
M20_FTY2F5A=:eAYKFEc;DUdHFaYHb0_AVm^M4AULf=bJG1dKg8:<c<P<21B82mG
JFAdJ7<P<c@P<21B82m6JG9cM4=XHG8P<c<P;daQLgA3J65b83<c82mDKeE^JF=_
I6DP<cDP<21B83hn2VE^I6mRJPXc=b0`86mRJPXl?20_C6E^IgAX83<h830PDR0_
C6E^IgAX<B0f>34b82m6JFadIG8P;dI/HGAUA6ESKfAU83hn2W=dLVEQK@Yh0KeI
2gQCEKINncabTRJWBMZdCM=7TZK_Y4dO]:E@fU>J5=YBJ4_1ARcdZFfaU9LEQ4;a
0JF0X2PRX/8<_U5>bn>VP<XEe1W1>h`cS5a651GAZoJ>cT0MQBJccTU1lO>kWmom
kWO?k]U[[lONJneo[g?fc^WBaGNePPIjP@JQ^K=a8LRGoQ/T]LgMBbd1GQT=`<CN
__2>cP2_:@1PnnjhLoW]0CkT=P3^HU][Hd^0Qf]8Lm]@4>39>:CaKIe;U`Eho@VT
SS^kV/Od8BkTSIf=blKl``O8FaHdM[H6k4eB_oR5GD^FS_42d_4;5kN>fI<j0<Ga
VoUP089FJUP42]P6:Z10QfDRA_Z5hSP`Z9GdN9f>g=/iCe]`QNRE<_oKBG=Tn/IQ
=]_GL6d[_b?8P@;EMG^9:/278_i=Gh=_;gOTQTK^QiGJ2iUf;bCI1JgZ3kE4Fd^:
CZN@Yf^9D<bCZfRN8MLF^MK9=I2[PYZ0QFcQb1H5nJIh1RG5n3N:a_XH9DD[4Sn8
f7ZMD^9jkL?F?VaAl3@UgE9[=@EhBe@9Vk6m6M^m58]D2AadXJ@;9EdXjD890o>@
Zd8?li2SH@IbT]LI<YN1G15b6C;WA6m>i9`bIjJDPd@Y72JOTDYBLe1[OV=A/?TX
ZB2Ed0AVTSVhMXKi=O8/F80WVnGjGR7H`WmXhLmIn<dFO[F5Ohe/P2YDgbWGA0R^
h/mFlBEEO54E?j6:?d8V@S:ZJL6@c;nJc7^CnNNBnIG9O7LbWiJ<_@NP7=G?bODS
PZFLojjLoedi_kfLOj2L_jNL_kfL]iKcCM5lO3@O5LekbJY3fXNeFkBP`^J1;Oc3
Fe1fIGnVdec/9OlhV6ff>g;=G[9n/=J1i;k1fYO<aF5T3J@`16OD2bT8P9V/19M<
Ui<<VBhS6K;nkT5W2WIK<USh5995PhDG4HkiT2h[>`Jc;j9do63]G7>aRVB?SIT5
;ZDdI]YPhEIDY`hjgSDGjdTBY9<45<M3]Zbf@KHlB]`HE@cF9Z8iN`03mJMh2ATd
noZl53UT_^Z/<HnTNaVDG4Wg:Y5lW>:UGQXdWgLR4B;<OgG>=OmWHKWi18i`_?JR
nGGWWNK33[W32jjSTQMhWVB@7H;Jo8acZgV?Lkgi=hFbNUNf?=jfFYTlVX;2@nKe
><bBM2nI?FQNW2eiD9_WhhPMSPYc<hYg25Yc^R???==ia5c]G6bN4O1DiY97W>Xl
;4o[7`9O76<^M/JH9aFnJikX`YT<V_>UkX?VL@7WFNWbm38;YiW]>3gVT3Ve=]<L
Qbj9T6JNM@LgSi_5iG4iG0JGb2E`/E`<Ie26:7G:H:E66JAD:QE:AXUiZcAhoAL4
^oAR<2Qd4U4`D/g8KAdn7@BO8JT6RRPYC2d_lClPTTgQgDG6XY12OGjYjaNZ1UWH
h;;odQDSKZ^HFBNn6><A/jB6?lIC8NK<]=aF=d@n9iniGD?TTT@lb5_9inhJFFie
NCc62W5JEIfGG7:gNe7AgRP:T_8B2TBQ4@dZa=Wb>9228]L@e4X4aj5b8DDJ1e<f
EcIK7c1chRQXiY:8I7HAW;:ITkXXVkd[V@gdYKQM0bUHX@VK3WfbBAnK;YTPh878
<k2[Jl295EX5RBA3SS/SB9@7RY47b/i6Td:/?7D3FMUX<92M9J^M?jXM0GE=@5dS
ZnOlZ4h?Z7L5e;]@oD/@ofmT[I=oGJomLiiH/m?MJW<gf=b]N3N86k[KS69_TlDb
/>H9BF4AjLB6Y^HfRCJfRToHFUgR6Y_;<S17k_LcmDi9?LOV6X2Mk]ZjPIe2Zf]`
SS37KL<5gKmfdb;gCKkFgo2eJ=<_n=XT3KI8l[EFk_LcGfi9_EKbiIIl^BEOJhFe
/RmYm^kfVI>Go<:em:jkiRiI<QOHYD2a5A23]i5n3481o9oR?HcgUkk9N090WNmE
oeoXF7aV3TPgiB/ZP4B8QQkHS_]93g`8>A21ko5?BB7b1n0dO0CCh5HhPLoFBf@:
m<=db8M><PWRbG^@2fih2Uk37/^Q2fe;hB6`HZo3oSM@UP/_PAM6L1n>PDU@Qj=/
Q<Om9f0GO05Go;_mGd8f?80FIobOP1=jDD^12A9`c0iHB=:XYOieD8Sn]/=Qn924
n`/Q3<I10KSP3VR3CUP0mj?^ECP3ki=XW4dJI:2OD[P5=/1FN0a4N8^Hb@[b9:?b
]oTkH3I6d87m7/KIW8K?hE^R9jnC]ogAoP=n?oZf`GRH;>]g`Y>`6ghSc@CNaW8A
Q/U<LP]]XlOiNGnFob[JJa4e0B[P=^cA2B]a9]_QCCR9iB?dVTabbBbbT?BBO_8f
=IT>ICQf^_mNS5:9N4o2<P?SGh:AKX574L?WhFD/an5?R;b:f:QRZYNjC>]YPJUV
^of[oO_l[oWoP2_2@S3RGh5U6Rb5IM07jg4n3l<QN0?>hUYm0j>48cXBPC4L8>O9
EaA@NRX5Ag^7kZ;kjGd<<3^Ilf`Q^lkg[>nRo`koXojCoWoRk2TlKbCPb^MQ6Hln
RZ0JIX87FQ3[nG9n?0kkH0264;/cL0k>`bShB2c><hm<9[NBNlQ_b@UbRWa7DIB>
<Z??56XMmCBFHm@YjPa]XV?XI3ZCWT]_XinVWfNf/Rg/8_HAMT3a5MOWJoJen;Ym
:ge7oAGnaoakoLL`6R]68jgYE2S3fEI3;JkPkG2?S7FoU4/HcghhR>D@AWD4S/8Y
S>eS^8`iM`eaD<Th6169399?2TPQaUU2G:@<ScdcB2f^cbfTSSBB3]93EY7kbDh/
Ci;M>8l3F8K84G:BW2K_HkU8_/Kb7LEB76FTK5@R9E0EF6k1dTPeDfeD>mE9KL;b
;;F?>T1iJJ0;jE:j4H]87j??d>oC7m7O<bIV:K>2nGOV57>>^LSlWAUQMF`6>h^M
[C0ZlQGMRSf:oMalkVG^70`RaZoPW7ij=L=bJQ_e0jbRY^1cmS_LlmjQY^9:m93m
I0lRm@c/a>MS79k5?l3<520CBa2FNa73E2`P92DVa=_R[1IcK4adU2WB614NIPP=
dN^d`Ka67JABLPZFXO6Hi73KBQ//HV:3b2CJYTi=TgQK8`XJOb9X42dX:[gIA[A8
oAYAMI>UP9JgolaB25P:=bb9cU801FT>Rm]V4MmefBaNLV]e7KHg^F`NRcP/]b_U
mQJicF?KJ/D>5[NacFDABH?5;IIf]oFk6eaY3S8T87Y1J@i<3TA3;@d/@TUS3fh7
D29I^4FCcNDF8fgHAQfMh6i/4J^Zjmb^::_ETnH@BDVc[DT4ffAAJao[;_G3egI2
CAgjCW>dhlh^`PI=RjeUPeN0YPJYeGQKWDPgNTBZ@O:Q]h/A=YLHLLmWaQoIjbgg
aYlXABZQ];6e_e@D6SHPj1;K876=6i6[T7IITG[0DbNB1c0h:@Pim/0/0Q]K@T>7
AECI9]_JnS/J47>XZA/d2BIi1a6QZVh`DXRDVCC7T77EA2^2<YAFW5H/dHUFhjX0
oObnP?bmHa8e[SYa0FU5c@eLR>CKEXIQRYIVfHT=Had_EJgSXKmi?<:7UhOP;=]5
EDU3_fh2[XO89^Q/U_h[n;>X`CKlmLfBaS698T5g1BBU]9`g<T;4acB@7OPKcE7Q
1EEEg@0Q3gZTlihGG353^<_@lnJVNB5IBXMf5oI69/F1PU@[]U8MUU:<^UAJ=d^o
YKn/YMmBJVW31FLBI8Z:eWj?4jLc/jhMjmXjZbQhXVhdFcfN2CR>GAX7^j1i_`M7
j1PK0JT/LXjRTL=A8Fg]EGGEMF:_:dXDG1j415?/F5FMN0bcbn=1:icSF:A8NmZ=
Hc6WHlaYZJQg1TK1<fP_3^7YkiO6W5UW/h[7n_^SnZEW8/1k2OaL88`9_22IB:WR
9KeEf1N9cAXU2FaFVaG3l[S@E@JVeoGUaEo2oc?2FCORaYkI66fFS?2hob>4Lgh=
`[Vo2^6l6i7NQ?1hS3U?@SSoo`oQ2Cm1V7dK[1BnVjPGHBkN^MSn07oGO8[g9;`m
N1O;kO_`W23m^/7O=gQYl2=6:E8;a8i9I;5LDGPf^7iQEkaH]>J@1SjAB5m30UN@
C7;aM;H:ml/Ag0LoXIKBLOAKm=oa3635SXoQ>I76_RD7:5;6:_3WXQ0=35M6@a3;
U=4dIE8Y^382TD[EEmKB6Z?M?_eb@NEX`GCMB46UK[@0RPY62gBG/L[<b=IKmDUh
FmU^kmDOf8XO3W[Y_ei;`1P8c?E]YK[H=]23FhSFl0c=:cFQ3:?QJCdO6QXAHF9N
DDkEAhJ4NXUj_oFnP:?:dL_CgJf^Be1D59:OCo@QnDSPmk[OIfJ4Q>KVABPhQEhG
4A;19BIAn[VWNel9gNeNWUim`KARlc0mUg2kVjbmbooTfnfkmX;_k5K[a;dT1Wof
bo7THSaC<1h3U0/F5DFd>Tj1OkAJbfTE>[dR=1aS<TaE_j:=30^GHjZL;Dnnl_;X
cC55i8=>3PWZPN8`92hY=bmG[d^RT_;28d;de9CY5C?^_fERj8hYZbIDomWdE=lO
BK=_Y7]Eim@HjeggW2G=a7b8T:gF^T7OOo_f8UHOn;lP[n?IDPf9@RRKZUKc68/b
UH[Dl<N]bah<Q74mR/[Qc0`V<FMLKWHFK_0:6hVMG>9dCRk><4YT/]=I8/ogD`0j
PId;hM0UA7HKeQZXA4>^PM:<=RT_a=7O=g4GK8H;n<eU`F1XT`6o`@QjGT=CS3:<
EG8J8oZWJ2o9>:SAl94AaZ=T6ES9<j@Na_814f4<U8:RT8SlbR_3elPE^cdc0aKE
@gRHgQ0N4FK=:B@inW69]SP5Ui>@CCFAVXFSYiJG6i==<n=9UhKe/:Z[dbYCVNQH
ANj]m5<IFC6jJ3`D4NViX4nb;A05GV5J@PQnU5Y0fT?Y5VZKMT@kHV1H[L8@YTd`
<7JU0G>J62>3e4@MA==PXXfAnTRS>XR`2X=ROS0KI]QS4/0JYJ7km4LSSn1WQaQl
=;V1V6SWZH^jTL_3D6BJM<YX`W`^6]KSE0999kFTANIHWNW=c8bBiD8dXe<VL7a@
3ZR2=6YFBnL@UDJA@aPMEV2g4k^^@5MP]jlQR43mXS`UbI6V;VE78I6GRR;F;<aQ
fSZ9;22:GEg[IcW]mZbo[GoQSioheY:C3M<cCEgG?XhP:dW;2hlldI:gF7EYoiTM
NgbWOB_B?A[OO`Gbf>?oU^iV>o0geJ=2@EWT78kRh/?SDkQl[X;[h3ZDbkTEbQLR
ghYGAeR=aPRP7BA>aa/SZ50=MBE5R>>]aeA4YG:6hW>gA=16/Ljn55hg?iJM_b^A
9;j:;j]<o8jG2`i:=I2IhCae6D6Zonc?2=>`Q4nn/gjBjG`?0ZHK_HiF_XBEbHS?
:>I7OFihMUI^c[PTNMUajSm70@49UdjVH8fCToP_1h/fm^GEWnN=>VZGmj7j1KGY
>NKTLi/OOljME=<`XM=ga_OeRVI[`R^;GnfJGkfND:H9feId;Zifg<I]?oClP/KZ
m?bD_?KM[oTn;4/eI@@`:_IoBJmVEh<3oT=8FQ]5LYB6<?bFU1;16^8<HFZ=BQ]Q
dVVeBd:RXTaAf69H?4Z@;24f@KDW:XXbAI[f265F_HjQAQ9hMWkLXEeQHQPE9VE?
>Wk6h@KBdnC/ZIOBIkRX`7C2=5Z0h?@hSEo[QS638_;G1JOKfAkMVj3?AdFn?Y^4
i>]UY10W8nICHW@l[KAHcMIHJhbEDG29bVPfQm3aF2V/ZQ`B7LGHZ1`0C2_<;K/m
MLdJ<PJ^;P71CDA/ld;US>:2RLdZXAXABa1HFebBS>ak@eU;m_ZnO_cnL;FBXZUc
i6F;;EXgWHT?loG<fS>]YgIZ^No=Ki/:F^aYokKVi2>4GUa4ZiAZUW`H7Q/lY6;g
ADNVeT`IJ3k_>a]Z[XY=Tk2UH9;o=;f?KLIOZWHH4ZX^6Bm5GS5NRFA:XfO7g1ee
MoBjZ7GA>gCKXQj=OU5g>>FMU7>jLbW1jLY8Xc4bfD8CVUE79QRUQS9Qa[aP4U`F
K5C^/[=6W^d3?M5k:NGn=7EO/QMACW=PoPeSoR7:AL<QnMg>N^<`HX^0bQQ;Nh>d
=B2JLHVY2QfOZ<JW<aD[CX/`JY:2Lb0XAHV0j[123:EkcAZXacc=cI=BTl9gDiPQ
?=^4^?gh:TMEW_ANAi1caXETDbD?1C6:SN^JURmji=PgRc]G7nml=ZS=_K:RHkG>
E]hbc_kRfl=3e:AYYZ0ebJL9<cS`l3oYA=o^/m]mKjehd9dDUVb<bYcBnWf]JGbH
i]_WcQ1304OhUYU2VnBm>?fP8U?;4Li;=8:Nc/Co1n0VC>4>_=5J>KH3hnh;c^7:
dGYlna=l]DXg<nGZ21=dMHCdK=a8W]bhDAiGFRG`]l;HofYTm/M:SDdJmaT=k//6
o>8B3TKldV51:H4@_:E;PBdXMILDEiOHJm/kFiNTeGAe=Rkh5lg4];X:IFiTLgAb
IF5]2VE^I6mRJPXc>20`86mRJPXd=cTg2VE^I6mRJPXc>B0`86mRJPXl?20_E7U`
IB0_AVm^M4AULf=bJG1dKg8P;d5cHfE^M20g=C0P;d=QL4QUJFMXM20f=SLP;dAU
Lf=UKW@P;C8e<20_AVaQIg<P<c8:;dI_KWA2@Vmh85/]<S0c82dd<SPP<CL`<20a
<SLbGB0_AVm^M4iQKFDP;dI5@d5A@b]DJFeULbeBKfeQKR0_BGAQK6US@FiWK6D:
<20_DgAUKEHP<20_CF5hEfUTM6PP<CLb<B0_F4QUJFMXM20e<30P;dI_KWA6JFaU
<R0c=b0`858P?Sh:IFiTKf9Z2S@`830PKf9Z2U/P<SD`830P<20`830P<20`830P
<c<c83<c<b0`830P<20`838e<20`830P=C0`83D`<20e<30P<20e<30P<20`830P
=C0`830:<20`83Df=21M2VE^I6mRJPXa<B0`86mRJPXl?20_E7U`IB0_AVm^M20_
DgERM7U`IB0_E79eIEAiL6DP;d9QLfE6Kfid82m6AD=1DD<[E6U]IG<]DVm]HFhP
;dI_KWA4IG=SLVU`M6mb2S<i830PDR0_EfUTM6Qc83@`830PDR0_AVUbLgA3J65b
83<b82m<HG=d@fQQLR0f<B0_AFiSKfAYKVLP;deQHe9_KF5^AFiSKfAYKVL:?Sh:
IFiTKf9Z2S@a830PKf9Z2S`l82m<IFiWM6PP=38P<21B82m<IFiWM6Pa83Hb=3@P
;dIYK7AULR0_AVaQM6E4IF=_I6DP?Sh:LgAbIF5]2WP1gCQYM5AEV]nmkkeJT[bT
:U]E:/^[BZE2UTZZT/Y2<2@_D1E90RB485DRD9D@CH8QQ626Z65A@@SBdRjhXF8g
;RgJ_1B1[X0;XmSf]3Q]>d?[d8gBHeb>TS?]=>2dT:[igZ^8h_7dlLbI<cnVkWWg
FnomU__M^_NmmN]^jH@hf0`<R1fmPKFPo?Ao@_1ean1jLiCFI02`FCN^_JTgB/ME
0g3KKkYij<HXWOPIdWUMWH5EDAX^8jcX@TJD9VD8LkYjefn8d_XC28dgmgE<ba?O
AcZn=k1QfSk8m/e[0[fMDGfSR31WKMo0nVUJQm2iMUgW]3ka0ZQN_iZ>1b2XYH9n
O?J05RSX/5d3X?i<mCZ`:9GUn7/WkHGNU@WE5hQNXm0oWke<PJlMiEaQonGknDMS
k<S@OZ<_@aF4TLFo4OJ7Ge0O^b9AaV6W2T59H@QV58X9f]neTH@fD_]>?WVbSHQe
?;V4jTjU=b^mC^V1G19S2IS9KSGI[B9oZF^V/Xoo@AW/Se?IFhU4@4;/EJ[1mCZ8
f474:3a9iDO6=U70AhHJ^1OaNa7OC3V46U137g;jT=>7W3kT/;0BZAJd/18Y1YZA
TZdf:i@CZEZTW0[U@6/>Y1`:9E1=T6S4XnAS/X2d7Th@G^^?5ehRCF@1]8=0BX;K
VXEGb3=P1YkLZoAgR?5VoP<cOm[<gf_V=iWiElQ>J47acDY?a?PFo_dFOVh;Gm_2
cf[QSi5[80o5S9RLaknLahObn6Ocn=_cn<4l_RP?Ahm28hZOEOX7A7<SoeDSoi]6
o^56OV/SOf/SOf<SKfWTfc?hW0`n?H<?THe74^i;f9d0FTC7M_?gkDKNQD<U3Z4^
A?ijf2DDfR^44=TAK;<S^3?HMT2XBb5K89lU6=5Vb<L42>AfL2]`R3PE^84h5OTo
11gi>6`PF?<4P_iPc@BVHcDD:l:NX6/2^C>3KB^4>ReaCLmI2Vj=?6MA/>In51L4
kFl;MGXb0hZ93MTih5;4EW0Y/fA?@eF`;AOE^C5d=98O8R@XQ;N7:3TRG7:d2QN;
@bab;QB7=0SnW1nR1h;26@L2dB3ldK52n;NJA^44c_1jfhC`Z^=VhJQM6O0;md^b
5GR>><VSHZc`]>=nHKmSQo2c6TFlcjG<]jM=0@oV8o>8/0>W6BP>TN^2`SZGK25F
F8dcm]RKQ0iT?bXV2<GfBV6ahiR`b;5>J8iJJW0[<lic75G2nZ_8efD:MHi<HGK=
fl8eKX`T:5C9`h=2FMAhJK4BGTW=O:4@`f>?20E]9D8fVRARTK3T9_E:mA9eYKYL
kECWZVgZ;7FV>UVCZ=5YhSEaVQR=AZ?B/1Z/Fdeb:79F;9Co699En1M2@<G:?J_P
>]`M1?N@g0<U6XZU5B:A[A;IUCYHJja=[=5GeK]oX?<[C;nkl8MnVM:NY/ENjOU<
We@Z8i5<Gi=D_]QlPgNLO4Xnm[S7bBLbl25]8ImjFQFnaNgc6I^TnBgN4?W4dae2
@GM04VGQ9lR@a00Z=4WG:O=0?[;Lhm0V0ib7ET2n?0nFK8FR]R>Zi/1ID<d]0eU]
0Qb:VX=>:6Y_bfZSfo<mk]5lk525:hK]R/Yf[UQF`HA7?GORD?NX0c_DRY68Do7K
6B<Y4fDZ4kULZ5:3WLlkF^Y2QE5GZB9fO2^fAlF]DG6[8Ukf[KPh:]hG5Nm3l@nU
n7o2jicchdHMF_KHU[fNCZ_7KoEdh^>GMPif6JG=kFKcj9K7I85IHW;mkAeM<Pad
BXmI>mgB5Z_K?;Y<6OLmlEiI_<cZ7XFmWSK_j5jadaeL9RkcF7513fgKeNnib]J>
:kKjMof0[EgbI?fb[Fg:^>oIl/SRKK8]Sfc;8m_J9ViCK<WANkXGcaWhPMojFfiI
<C2`0[Se@;TVb<C7b3`4B@2ASo2Ia>Ocl1`llE4FOSWb1bH;mlbHo=1`KCGT@PH<
`l=hWPc31e0>1_`OohSD83d6kl27<1n^Qa>h]`j@Jf445T8Em9;IT4?NQ@[``1?`
2XhHPSkD[HNOPPE77HflQ[`:>00Q^8SWL2K<1Ro>LPll4ST1nn0c^11i:_8i^60[
JYb:o3/hl4Ic3niU4mQ`cQiHBh[Xn/SMD8?f7XJSl059SMA02YA1=KSQ9^R2GUP3
Mj7/ICP5ka6lkd0A>=5>?Bb5WG0o?0@Bo9X8i3Kb>:^=M4Ejh3[dX0O7gHOA_0>O
`YM4CehUKdHb8V>A2=Zf`TbHXlSg`^?`5?a<SPCNa3H1Tf@aFLYHVK887bV=G4;m
1<bJ24e`0hkXQM/aTXOQ3GP;fhMX=HmDT2ET;MU<A/RKM0jCa:ZiQI4kd4/=iW/f
]VKdO`0mg@d?HPjOPaNa_@koPYWG4R^]Xi_YNDK?R>`RKS2b:G8`lT[TMkPR7<AS
oY^`cHOe/06f``j<ichh0Zo1nkQFOh4YXRHjHT0Oa/PIlPD5ZZOi>=]_VCiVQ3W8
0[^G?L?EL7N7W`U?A6j:?1Qi:o9O63g5nhH=EkhBfdbdD@^;H37hH1GVN[EB7ho0
@AR5LLcM:CP=If0:`R@;hj`TLlSei5KbLg:2W2AODDYeE42KnOA^nRBfho@T?LFH
V4`VSbUQES1kV2NIimSk^EEL?oL0=j[j@[dmg15N5Ah<gain:M8DNBSb@^@hNV=1
Kn@eW@L=6>dRJ<<E_15^EG8m8]LBnW<83V<kPUhMPiOP9?[fIcR?=GLIlj1ElV34
C3Q95JTV=NSWG>8V3GS]JBI]^3i;RIL4B0lI9Q_9GF@_]/O9DaS76;IaLXblAMhQ
kf6K8>N`ODDiZZI6JZFiE:A=f9IR2m0>fTFkJBoMQNdINY2>dA03C0eCc`B`BLaa
iQCc7_<QlcOFa:iWKf?oTCg9WVHWf?mT;g8jc/T]hJiC6EEEZT7EO]DQmF[eRn[C
4<@Loa9Sn^j_0hKX7_XeK:CGhSkk3Iii_jGcL2F6bB6b7c?e=>c5oE66Mo4oHFF:
D88]1]/MV<<2K23>b;GUF;<]IR4[<b?MU6HdY:HT9bGZM@WaO5a/S5JSEW4/PmLT
^lMJkcM;^Gj9cKG>VeLTdmH0<P;OHOPU<k;Z[mJAc?:h08Z^dQAAllK_JHYACO6:
9]6IZj6jb6kfF<gBffj[>DB^GnA5O9OKjS=;T`Zn@<5g:cR?^<F20l`NHiOK;16o
fB?E3gJ=N?c^8S/I5c5k<DEf;0k<AZ`l/@Ac0l=h7<1LFL<SVJa^SiAVAAaUS<dC
F2Fe;?9jg>TFRjo8;Y6i7MIf2JacY8C2jN7b>?cK][EjdGJA_A]?MPUfaZfb[]XI
4Z7M;f>16k`B4o19e2oKd1M:1Z]K<]cj/O5KlQ_<LlmgQ1:ee@LjAnXUdKlCTbjC
OYT:g8=DTgc:BWB[cb^A[NRLk8CRNcB:j<5VloNH9JeeS[E[Y<N?>HMFKm0TVY@C
A88FKc1=C5>88_^hLN<e5Tc:N55MDId<[k4H=dKQYgM6nNlNUj5ahhVc29]J[nB5
b;J]3NRVI>i@S5SAeiUbecTCASYVH_[`ib<HIKNTWN/OdLg2mI0hVliZ7[V0[dEn
jnBiZcV1JHk:Y[/0/U1NcR/E8N4fSEH7_Z?IVd:PKO6>4_8CWgcO2h4kLaa?6FKU
RZ8@i<WUd>g6dDSTfi5AH46/`6j^Ajo[iGDcSiQ76UJ=V>_=GKSP[4f1:>PLlCT`
W<GNK^cK_1I9m:EO@C]m_UThCj4l3`i1mA4Oc]0c?@=2QNFH@RFk_DTnfU^lRkcB
IWNj9;YmV18//N<]G^ThEYO?QeXHhkBW28NkSM<n5j??A@DXMdAW`C_XIYc2=c8R
ckWHJkE8adM6dTOT?A6U@`Bnca2W6B6@ENAB2I7=;CPFPMFB;S>/5Z/5gO:idI@C
bn^KiLDghKnOhM8[O^=85gYKZVBhk7lY`nDo9/<E?b[3UELl_B[3<m7WBSW3EOmg
6IkeW@acKh85gf<n`/N7S`6O>/J5maKiC@KOIO0GQal/cR4/`JlQ<XORfHmZobmo
g7AD5O00bBGKJ1Um03TDcgoP7/8k:h=gPKUSU3A`:Wae5C>0ECL`4<>a3@a3CEZE
^X50VTKkQJFneEQH^?1lmH:YjXFjRmD;M5?ED5/mEJdkSef9djFgj6OPHn46@iNn
iYZn?QaRoWSIQ[H8O0C0f;PET0YmH]YPl[ITVY]LTDcSY]XeIk>I_kF[ceZCcn;g
QcG1Y?ITo1hQj_ThQ[:J54jSSS<J32K:Q8ScL5`LWfH`_T@fP8DlCIK3]3oXb49?
Yo/Cm:HfdE2eh<;TIG:Q/;342Og;8CE5WiaZB;6Dei1bOEV^=E^U;[NiJ3]YGC]e
LZSAV6MJW4?jhSPOYkddOd41Vi6UZ[RNNL9IVZW;`0/20EoTBfJ@jl4km8=RMD?J
<SEEijCVi:^[e4gZ7WF?ITQmVnHGJKo>RCEHS4H3<7JB[N>=1YXDAboTRmVliKRF
J;F>Y2Cl728VY7>>kOVlKWDF]gYO;/UmVLY5b9<:/5?]J8WCLO;lQ>kRlXooMA9Z
9f/WmHUES^FcCFN6CaY=^RTm1TN@EHE@Ic;nDhTCLk2l8]EEFU5N=T<9K@I6:@NY
EZTAMIGR3@CAE?TV0YK/g?:b2]LO3]ON/kebnAWNZ:?k@SmM_ZJ]^5c8>gg_8lmj
I[CjIoF6ChG?gMIQ/OebgL]mZaO]8=@dJlm]_N/FfFm@?gcT^CF1ALEEnIGMCkdB
oZ2Q`>BDRh_Rf`P`Kn;jD^1QZbQ/H0S7ZeP]IGPPI22AiaW2@ac3aP1QE?P]JcgF
G1aij70<`lG4aHA8UZR5oEXWNiJUK8QDo<Z/4UGkE8cZ68g1=h4hC4e2_>>TW9Wc
bj^W9Z2f5X_^@[FnB/V7W9:kR`_IHMdKP7R2W1L]/BBim:hDZmjZ]iCC9N4Dl/FL
UKoooI=CamWMDhg<GIM_gaXn@9I/ENZc;_8i/hWK17KhIg76]WAB[TU>`FlOn@H^
>C/i9CI>Vf0`jA8B1Q;CddgYR;4L7WfTE<bbJONWYe=CVVVoV6;AjeQjdLIcZk>?
k4^ADVS:<Oc8DXbO7MBSaDGCkR_[FVdjHIZZAUN77LIc^TULDd?EgO75QI`B@IDL
Smi54Z_dbT[S>Q_W3XVi6CV<aV`A;5VFC0^[D^MZ<[Qb`^APYk9XbdU6>V^Ui@25
^^Y2PZnc1E^fT>WRd=V`97:a82ZC;:DEU@Ie?;5Ji:X`I14/36_f3:DbgQd_7GPQ
O>jA^e9S=IBQYlV;IV^6KR6KTa8NG[9ooW3K_<K`6enfEjlZ;?[EU[LN8<bjFTJ[
RNG81jUIlN=JkV16FT7[]J<MIl;_9`T]FDGAfUS:6>PCF1^aF2D3HiFJn39=R9`G
Hi?;::CQe]JGL@Y]:8]=<jImK;Wc9lZfGS0i=CVmZfFda8TY:<3MC0`fB6;d=/9[
4D]@8iH:bCJBb68G5a=_0id:>oV5G/i2hIK42VDKZ303iEVh9G2_b5/UINV1XJ7W
WalJ>[2Z_kUUkMZFiWifC:4?33GgAeU:KL]A@:@C>QGTnid:6LWh_fH08mbY20TT
CYlb:/BPNF7Cg2GN`[K^g/j1X]Jng/2Jo`IF]Ohm2VE^I7=dLVEQK@YUKVA_HVX:
=38P<21_HVX:=34g=@YUKVA_HVX:=3<P<21_HVX:?3`P;eAiL6DP;dI_KWA4IG=S
LVU`M6mb82m1Lf=UKW@P=cD`82m3HG18IFUWJ7@P=SHg82m4IG=SIFid82db=C0P
;dI/HFMc83<b2Rm6Kfid@T9_N21K;C8`<b0]=38h834g<30P<C8g<UdP;dI_KWA>
HFeU82m?CT]3EEP[E6U]IG<]DVm]HFhP;dUdHFaYHd5^IfaU2S0P;e=dIFeF830P
;deQN5MYI7AX834g<S4P;eQ8IFUWJ7@P=C0`82m6KfidAVU/IC8P=34P<21B83hn
2VE^I6mRJPXd=20`86mRJPYK83D`<20`83D`<20e<30P=C0`830P<20`830P<20`
830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`2S0P<20`
830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`
830P<20`830P<20`830P<20`830:<20`830P<20`830P<20`830P<20`830P<20`
830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<20`830P<0X`
830P<20`830P<20d<30PG@YUKVA_HVX:<C8P<21_HVX:?3`P;eAiL6DP;dI_KW@P
;e=eHWAiL6DP;eAbMFEDNG1U82m2HG=UAVm^M20_Cdi;@eEH:eAYKFEc;E9_KF5^
82m6KfidA6EcHg9YL7A_LPXd<b0`858P;eMYI7AXLb0d=20`858P;dIYLW=d@fQQ
LR0d>B0_C65cM4=XHG8P<CHa82m5KV=_I6U^Ib0_CF5SDVm]HFi5KV=_I6U^I`Xn
?PYUKVA_HVX:=3DP<21_HVX:?3`P;daUKVMdJ20d=R0`858P;daUKVMdJ34P=CD`
=20_AVU/M6Eb82m6K65dIDAUHfmTIB0n?PYcM79UHFd:N06m>0]d4fFjgcnCIm]Y
4fQYjF/V34TOBIZd:HE2B:M]DVT3DTZ1A5h9YM22]Kc/1EL@G448L6EU@DELL=Oe
LMEU6RXW?5@FfGF?h5V>mk;^IE5gkeKMXoKLO@1jQFK^mdl:RXMcSnNNNnklVOmk
?ok_ofOnOk9^cOfMT06KP@FYXbNj2]C;O051HDOO>R556`X1=<G;ERg_BM4IGP3]
m^GgKURFX/eG05RYZc>j=4G33H@eGLQ8dJ@JhOR^WWG[DkCi;<:<Ng/kA^CV;i0f
m4CGSlB7bdP;mdEk>U?j>@/@SUoE^gKM24gmUJiJdcVRCd80^[M^Yc<126Za/1Yd
/1n<`809fa@0oEmdKh46YEB>ehFa[o@/c_9N9FJ3B_m/jW`EWSVQmB@S=oIb1m8L
b33Ne:M@1dUTLKm:AY:_j4oNTZQff;49Z;@WX<@^IAUofdjbfTWMQC9bZ9e8mAbi
S^Y^]AODgZCf@:i;j@@4/TM?m^S8Gn]W<SC7ofAHk4lc=5^I:20SmRIS`74M@N`8
HP`LH^Q=/HLH`9]20cb6n6>8KfJd20fPQekTm2:W5cVmb=70HZAJ<L9RY5RHRAB=
>U>Ug4SE8NEF:AM6Lb7UDRVN<LB9@CY1?RHcB=][FObIeIWl:A8T<f09l:@b_VdV
o`Ii7PCPb6=Zok2D:G0O2]`UPG]<h1hB^3O8CVQ5lKeZCjC<E^kg[EaS:eOGbTe^
iDjB:E2:HUK:;^EN;nDBYM`;YMb3YEaO:NL/AN]nJ47a2f[oHdUXhKi/hGkC`SgI
`Ve]hAiXhIJeL9HFKTTQ=kj@:bST4VCC/Jc7/oITPA7APCgLhg^@MoEXYH^_Ci1o
_>KQkHhJ?T5fa=/M27hHKgnI[llQFj1<@g14Vj4<2l2C1l6_`Pg4[L;ea:g:obW^
:T>c]G7OCa2/S_/6/A`[XD8E[XQk1Y4k:MjnR:lg4/n8cb[`6jQ?Imbg5lGULLNk
O;fIU405/B9k?7QD/@PNeL^h4JR;]m]@GC^0RBYU2D;RO79kPR77n>^^=_iJAD:3
W:/E2@>2?iDUV9OSo0L^158^o`OG8_kOOBglFOC`E_/PojK[G_j4@cEhbGn:AX4G
RI/LT=;iWk_fl/niM_0omJWR`akEgoif5N`[@nHaOPNjFE^A87?So1X?SI3>[dB?
:aa1_P?I1j@/_/8aTIo]>/W?LZgQIjHR=O]ESm=L9mAQoD?RjX_hNULA?mGg;So5
Sb>9lkGD?<iGYh9GEJS3ZoA=indh?<da_[bmTQn78HWTi>L/eboFcm5?e4o@^oDf
_EEO[2oBIa]66Db6C4>68LeP<>P<6P>^Fd=f@_VSI:L_QVbMR@:MQ_HJ5COQdd7`
6J8m<<C0h=9:46F[C7J?jJ_;Za_U<mLfnNo@AEAVa6nodeDTk`o>3/WoDQBFZbRR
58F3lXCI`X;@LO8YnCSP?dhnXB2<]8El6VQCnAIo>9`GU:NgQQ;TTd1g0PGMDEVR
`Tn@8D]AE0S:LeDoD8H/og5XY`3m<3E@A_gPTZeAeGJTe5cX1MGl552e@G2YJRiV
D5EkUj[eKbl;n?_;/4<EK@E/EeFfJb^X2QHlUKTKCOgm;^a@:ddVKSE_MiZ/>RYB
7GTlZ>;3;QcZ[o:P@[nWBQFk_Q4kD^:fU;Q=5LooAUbA4Qm>R@nSn4hUo]o`>Q^n
WmGAnDm_>ASX50<A<M29MdCNfMNE9fmN8PSmFijV0T5VKI4U7EdDAS_UYlE>_ka5
m0_mleFkkhP?D_5ldMl?1`?]XOj3DZLo?UnJ7a1a@Xm^fkdjL5^/7KMR[MimQeRk
ZK?E==HfeNhk/@9D_8g62]1H0AY[VkA=SDE77nRNgK3f3]NjnnmO]7K]8]2^0dHK
Q2:llmPWH3B0lVNlQo3n;=V09`2D9EmGO/LFhc<c@6lVFNL56aC2AWPBmi>=l25<
P5alSonIn90NP0_`4Db7Nn0/?U/_Tk/P1WM3;OB@ZC2N_0Le482O`1]X/@5jDKL9
OP@F]3ZQW45N3K`<2KR6ng0AC8D@N]T5CbUWhC3l1JhZcbZOP@NfX/I5iCo0QBNJ
GOP/ih<EOJj0ELC9[5<N1Ao6Na9>`8MTS>:37:P6;oQQ>GA13m`7Sj3/MKP8ki=2
78dCg1RW2NK1C]P;Ch0<_bHln@5iAV=D^Y@E<1LcF85fSn=X;/2Wl3MR9VnB]iE2
ID1A<;H8Tj11UAn4In1In2TM2Kb=KA26b6`bSaGIJXECZYC[Z9n5EI<P20_@XPLN
a94l2Kn2LmPn`ZRUY8K<8J_8IQ8SKc<=k6R=GW^glS1VJL1jClDf4o=ORiW^PGeH
`aOQEFa_`KmRiHe4I>ZIcL`Ee/a:VUWJ?^DQiHSbQ_9KW14]I6;mPmRV`cYH3m]Q
1hkWLCP6In3g>5MoQF6R9bJBRcT<T0o8i```IZH<_Kg3m[8amXP6=0Le7fQmfTNC
cbL7UNG:?^FLlQF>W/7cQQEWOR:fBARS3VK1K0S3DZceBWEm?0E7X1n>Hnd^`RGh
08HQBHYaW1=90kV7?41nA/jBlnA;QV5<38labiQ7VD?HCS?WVH]/?U_4U[:Ek29f
?g^8OE6cEk]D^e[kHffokW?mmVA7LVVb;oUPlY@BE9i@GU5>HcHFc8K>jCAXa]7>
PWJL`FG`P5[[65e;V<mAN0gK<LcZ99b2liSKWn0:[[TKF0NSFXLl[8BKe18_lF6N
SLA?V_7H<i>dhoc<8b4B9B_8A[:9?48>HW^6?8_S6<1fW9`TilP5lSjf@O85]RlI
;J=WlQRA/C4B4l@f3e^DjF2jV6jVQmV=kGWV23?095QPOF`C6lDV/jOIRnckk4O/
OfWb=N/d?m3lDW=NLdTcZ?VkiY[FY7E[ifSWj_9d]KXngG>jXoZEnUOeUb2>=Oh5
S^WKE`M/H?HcGl<ViRilcWj3Nmhkc3BLRHgT:7T>:oEc>8S?AcFNaBoSbYBP4U/J
]XNaQ^GH@2ZaFLN;hb`2GeaDF90o=RmgC4kfj55VDeHVUi6NISCXMEX=RlLTAd1/
RPRb;B9[K>:dJDi:Re5TA;o5R<P2/YY^ei45JQM5dFfJ4VX^nhjVU=:DKVTBTn05
[m<Q14A1O]L_2PUbcj`@h[_mHUR@QeAlQX[_DG4>LH/53HA0GYMOT4U42<Q=OEfa
@<C_M93S4UH_cNW0aH7EB:N>IFR<K/C]01ZYAT3>5od1NJb8><YHJb2jE6jM5@[h
2bbF/=<QTlH>LHT<HX>LIAlaYgKhf[JfQC2fdm6=>k/<>c>FRT]g9RAH4Z5HM458
IZ=QVHW@66JkW2_jiM`7?/kkQ[b91GImBbPceZIXIja9UR8k/NRDS50Z^P^Y8=eU
IFI[>2BC[IPLCD;=?CF:e<IVSJ`@I:?H87K5ETB`i]0FR^M;nNX>8T=[:3iF6Z/B
C/Oa_4eC;5RDhlijIcf5DbaiVe;`danVn>nMYS1_dmTo8PbfgJX;XK75ITaC5S[D
82;V>XUfWI<PeS49bhMGV>0X^fESHbAVVXcc8F^]9U68GLG?XXPhm<G]W>P8AfLe
G@DZY==iJdG8n9RVEPMnXcV22C2fQ_X9nNL`?NlU`5md77LIM_4RI`9:jG;XmZ<e
4VD>I9AK42]g24fHMA>M=b4Va9ZGaX@VX@/WG6=E8@XjHf4G3VMfZ1_kmY15U/85
]m3>L7Pbn[5C?fR2j[4`NUPahP6QbW8=Xi;34JAKNf]XETSNk2n@9GlHBh9;k7A[
B3j=Zb/LARdLhdRV23MfihgTG84i>l]AkTYi`C?XIW@AS/FXcmTQdB:OS/D:H_BI
B=490]mUB2><150E^U@BI7<[fR8@;@FD8EY42jHEmV<X=bj_Vm>;Gl;oLhF[K^F=
UQk<]TZ]L?GoDHDWO9l:egb_2TnlUNU]5Ij4>DnT5Jkmoj_`i6mEF?/fF=SM4<A_
6CfnXVkn[i61Oe;PWb0@aKdhmEf3olWP3W/HJ@^NgYk0la^;5Xd336WFj_0cCRX4
SKjIQCB]YYUUVGbSC]m<H:c1n;VUZBg?K[okRWO6/?M^dcG_3=>`5nZl`ekC5N`Z
gAjcaEb2]dGKUkSn]CKhmF/9mPlg[1RMQJ3b=gH7>`3Yn=J/9aWB//m/eff<_ZA9
afB81m8>e;jDmU;jRm`Yhc_6Ljick/_6bni;UElHQmaIl`b>b_;L@SjK1dmF5/UZ
[ZZXZJedI:F1;]^@kK7Z:g`ej@KOe?AjOGe]RBWMEEl^EFhXLiDO:FO:4`a8JHei
9@GnL@dJ_hBO;_f=3JkcEhJ^30nJ[RgdOV8NEC_/7GA1GMd@KNIA^KG8jW<]c1/j
SdP]`JkBgKQ1V^:[4d/cLXVN/G8fWFfDSFAZK:3gJHXQIga^<Hc97Fdc5I>BDSH3
K8A0IYJfcU0<iY;/HP9f^lU[l]X9g_Q;GE_`PXETmD:Rdn]b/W?7N:YZ9XbOF6>M
D5eR4lMA7^jTNYdhcSJQ^/ICQO^Z>JDe<@L]T5fB0Q<84e`Kg><]LCM/B<:?5Y3A
fN=FNRXZdZ`iADkgZbnL2EP=G5U^/EF`CY[/WlY>[iWO=WLCfLRDfb[2ZnOK2e]Z
EdJmbnL/:fg<;g1Ue1XVSN6VS6mjJU?PTFC_i34UV@GE9F=]XJT=@/f6Q@`No?6@
07YUR7dM_`gbl7bgFbZoVT5d6N@0Ad@3^ICC2XETSjRcj_6]X<]9Il7RBmLGM9SC
RofI2HJAdTZ/9CYGm^TLTX?_f_hB6lk8@RnMTB5@i`4;Ok?hL7GX1[VZCT5NXI1Q
4S::KJC@Q1g?FFbT::_01UQOH[N?U7?d11oaH:eZ9V;A/8902fR^]XVPEQRALKXL
/gk=<CfCGkePoMh;bKmOk_fM<9THHmFk7]fdnjk]VZo6iD/jgO0Q]cgheJoo;OUN
b:6aC:jl7WFn]foOl;c699>Z0Ne1jHBAobMElY^>AMB?gagdFAa5odg0BhLH]<bi
JlK/MW]kMdoWFVMKKdod__l6Lh^2X@YUKVAcM79UHFd:IFiTKf9Z2S@f830PKf9Z
2S<g<c<:IFiTKf9Z2S@g830PKf9Z2S`l82mDNG1U82m6KfidA6EcHg9YL7A_LR0_
@G=SIFid83Le<20_@f5`B6EYIfQd83Hf=b0_A6EcHfE^M20]<SD`82m6K65WLb0c
<PX_AVm^M492KgPPFbdb<3<P;C@b>20a=c0`834b=c9M82m6KfidCV5]IB0_BUE7
CE=D:eAYKFEc;E9_KF5^82m9M65/JF=1KVM/I@X`82mCM6E]ER0`82m=HGQGJFAd
J20a=c8a82mHB6EYIfQd83D`<20_AVm^M4IYK6Db83@e830PDR0n?PYUKVA_HVX:
=3PP<21_HVX:Fb0d=3@P=C0`85d:IFiTKf9Z2S4`830PKf9Z2S`l82mDNG1U82m6
Kfid82mCMF9dNG1U82mDLWEUE7U`IB0_@V5cIDI_KW@P;dYEAdeCE2]DJFeULbeB
KfeQKR0_AVm^M4AULf=bJG1dKg8:=3LP<21B82mGJFAdJ7<P=3PP<21B82m6JG9c
M4=XHG8P>CLP;daQLgA3J65b83Th82m5KV=_I6U^Ib0_CF5SDVm]HFi5KV=_I6U^
I`Xn?PYUKVA_HVX:=3TP<21_HVX::4eQHb1?Db1H834`;SH^=B1AMF5bM7XPD4A6
@fm^M6EhM2T:IFiTKf9Z2SD`830PKf9Z2RQ4>S8`<C0a<S8i<C0e=34cFS0`9c0`
9bT:IFiTKf9Z2S4P<21_HVX:?3`P;e1bKfAeHfEb83@i830PDR0_@g9UHGAYKfi4
HGAU83D`830PDR0_CFmTA65dIB0e<20`858P?Sh:IFiTKf9Z2WQbIFH:<20e<@X`
<30`<30`<30`83He=C<e86HP2S0`<30`<cHd>C0P<30`<30PKR0:<30`<30`<CPi
<R0`<30`<21^80X`<30`<30d<CTd830`<30`86hP2S0`<30`<30`<S8P<30`<30P
KR0:<30`<30`<CPg<R0`<30`<21^80X`<30`<30b<C4b830`<30`86hP2S0`<30`
<3<b=S8P<30`<30PKR0:<30`<30`=34e>20`<30`<21^80X`<30`<30h=SDi830`
<30`86hP2S0`<30`<cHb<S0P<30`<30PKR0:<30`<30b=STi>B0`<30`<21^80X`
<30`<3<a>C@d830`<30`86hP2S0`<30`<CHg=S4P<30`<30PKR0:<30`<30`<30`
<20`<30`<21^80X`<30`<38a=CTg830`<30`86hP2S0`<30`<38c<SLP<30`<30P
KR0:<30`<30`<S<h<B0`<30`<21^80X`<30`<30b=3<d830`<30`86hP2S0`<30`
<3<b=38P<30`<30PKR0:<30`<30`<c8i>20`<30`<21^80X`<30`<30d<C<h830`
<30`86hP2S0`<30`<3@b=cLP<30`<30PKR0:<30`<30`=3<b=b0`<30`<21^80X`
<30`<30h<S4a830`<30`86hP2S0`<30`<3Pb<c8P<30`<30PKR0:<30`<30`>3@f
<B0`<30`<21^80X`<30`<30h>3<f830`<30`86hP2S0`<30`<CHb=cDP<30`<30P
KR0:<30`<30a=S8i=R0`<30`<21^80X`<30`<34f=C8a830`<30`86hP2S0`<30`
<CHi<cHP<30`<30PKR0:<30`<30b<C0`=20`<30`<21^80X`<30`<38a<38e830`
<30`86hP2S0`<30`<S4b=C@P<30`<30PKR0:<30`<30b<C8g>20`<30`<21^80X`
<30`<38a=CLg830`<30`86hP2S0`<30`<S4g=S@P<30`<30PKR0:<30`<30b=SHe
<B0`<30`<21^80X`<30`<38f=SLb830`<30`86hP2S0`<30`<SHh>CTP<30`<30P
KR0:<30`<30b=c4g=B0`<30`<21^80X`<30`<3<a=3@`830`<30`86hP2S0`<30`
<c4d=S4P<30`<30PKR0:<30`<30c<CHh>20`<30`<21^80X`<30`<3<b<C8a830`
<30`86hP2S0`<30`<cDi=3@P<30`<30PKR0:<30`<30c=CTf=B0`<30`<21^80X`
<30`<3<f<CTb830`<30`86hP2S0`<30`<cHc>CHP<30`<30PKR0:<30`<30c=S@d
>20`<30`<21^80YdLV5YK6Eb2S`l82mCJGYU83Da82mBKfmd838b830PDR0_BFiV
Kb0a830PDR0_BD@PFb0l=cQVHcIQIS9TISPcICLb>FAS=3TdHVIQ<C0a<V8h=V<n
2S`g>6IS=V5V<VAV>3=U=c8iI6<d>CARIV4a<34bHSPfHchPGB0n?PYcM65bM7Qb
IFH:<cHe=SD:9BE5CdH:\>"], "Graphics",
 ImageSize->{445.029296875, 302.8856201171875},
 ImageMargins->0,
 ImageRegion->{{0., 1.}, {0., 1.}}],

Cell["horizontal side next to b", "Text",
 CellChangeTimes->{{3.502607498911418*^9, 3.502607526782071*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{"x", "/.", 
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"2", "^", "2"}], "==", 
       RowBox[{
        RowBox[{"1", "^", "2"}], " ", "+", " ", 
        RowBox[{"x", "^", "2"}], " ", "-", " ", 
        RowBox[{"2", "x", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"3", " ", 
           RowBox[{"Pi", "/", "4"}]}], "]"}]}]}]}], ",", "x"}], "]"}]}], "//",
    "N"}]}]], "Input",
 CellChangeTimes->{{3.5025947270164013`*^9, 3.502594749682109*^9}, {
   3.502594785923277*^9, 3.502594808035969*^9}, {3.502594891672188*^9, 
   3.5025948960952263`*^9}, {3.502594987529544*^9, 3.502594989553697*^9}, 
   3.502595201736123*^9, {3.502595240233547*^9, 3.502595241048255*^9}, {
   3.502595552554435*^9, 3.502595554056975*^9}, {3.5026062460281143`*^9, 
   3.502606247267789*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "2.5779354745735183`"}], ",", "1.163721912200423`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5025948095396223`*^9, 3.502594897589967*^9, 
  3.50259499095571*^9, 3.502595203574183*^9, 3.5025952421277246`*^9, 
  3.5025955549138393`*^9, 3.502606251026944*^9, 3.518437690494*^9}]
}, Open  ]],

Cell["hypotenuse of lower triangle", "Text",
 CellChangeTimes->{{3.502607538049518*^9, 3.5026075931745243`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol2", "=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{"2", 
    RowBox[{
     RowBox[{"sol", "[", 
      RowBox[{"[", "2", "]"}], "]"}], "^", "2"}]}], " ", "]"}]}]], "Input",
 CellChangeTimes->{{3.50259529665486*^9, 3.502595311297929*^9}, {
  3.502595558393873*^9, 3.5025955746492043`*^9}, {3.5025960294787617`*^9, 
  3.5025960315574636`*^9}, {3.502606269180275*^9, 3.502606278756309*^9}}],

Cell[BoxData["1.6457513110645903`"], "Output",
 CellChangeTimes->{3.502606279705061*^9, 3.5184376914611998`*^9}]
}, Open  ]],

Cell["r from a to c", "Text",
 CellChangeTimes->{{3.5026074784720507`*^9, 3.5026074879171553`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"r", "=", 
  RowBox[{"sol2", "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.502595464135889*^9, 3.5025954751983624`*^9}, {
  3.502596048039382*^9, 3.502596048765767*^9}}],

Cell[BoxData["2.6457513110645903`"], "Output",
 CellChangeTimes->{3.502595477957337*^9, 3.502596050204427*^9, 
  3.502606284082295*^9, 3.5184376934112*^9}]
}, Open  ]],

Cell["body ab omega", "Text",
 CellChangeTimes->{{3.502607601419035*^9, 3.50260761043185*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"omega", " ", "=", " ", 
  RowBox[{"3", "/", "r"}]}]], "Input",
 CellChangeTimes->{{3.50259548266848*^9, 3.502595489150498*^9}}],

Cell[BoxData["1.1338934190276817`"], "Output",
 CellChangeTimes->{3.502595490024229*^9, 3.502596063791201*^9, 
  3.502606286052888*^9, 3.51843769416*^9}]
}, Open  ]],

Cell["velocity of b", "Text",
 CellChangeTimes->{{3.502607650884534*^9, 3.502607661049309*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vb", "=", " ", 
  RowBox[{"omega", " ", 
   RowBox[{"sol", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.502596308609795*^9, 3.502596314749086*^9}, {
  3.502607668049386*^9, 3.50260767453813*^9}}],

Cell[BoxData["1.3195366178223693`"], "Output",
 CellChangeTimes->{3.502607675336063*^9, 3.5184376957824*^9}]
}, Open  ]],

Cell["acceleration of a", "Text",
 CellChangeTimes->{{3.502607420168288*^9, 3.502607434722579*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Aa", "=", 
  RowBox[{
   RowBox[{"3", "^", "2"}], "/", "1"}]}]], "Input",
 CellChangeTimes->{{3.502607010337902*^9, 3.502607022536351*^9}}],

Cell[BoxData["9"], "Output",
 CellChangeTimes->{3.50260702387475*^9, 3.51843769767*^9}]
}, Open  ]],

Cell["vector triple product along ab", "Text",
 CellChangeTimes->{{3.502607438300137*^9, 3.5026074576234617`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wxwxr", "=", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"omega", "^", "2"}]}], " ", 
   RowBox[{"(", "2", ")"}]}]}]], "Input",
 CellChangeTimes->{{3.502601249937996*^9, 3.502601267467366*^9}, {
  3.5026070538502207`*^9, 3.502607054745068*^9}}],

Cell[BoxData[
 RowBox[{"-", "2.5714285714285716`"}]], "Output",
 CellChangeTimes->{3.502601268889204*^9, 3.502606295027419*^9, 
  3.502607055811541*^9, 3.518437698684*^9}]
}, Open  ]],

Cell["angle by a", "Text",
 CellChangeTimes->{{3.502607405929986*^9, 3.50260741420982*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"adoti", "=", 
  RowBox[{"Cos", "[", 
   RowBox[{"Pi", "/", "4"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.502606013824992*^9, 3.5026060535412493`*^9}}],

Cell[BoxData[
 FractionBox["1", 
  SqrtBox["2"]]], "Output",
 CellChangeTimes->{3.502606176927977*^9, 3.5184376999788*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"adotj", "=", 
  RowBox[{"-", 
   RowBox[{"Sin", "[", 
    RowBox[{"Pi", "/", "4"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.502606178732163*^9, 3.502606190097814*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["1", 
   SqrtBox["2"]]}]], "Output",
 CellChangeTimes->{3.502606191700542*^9, 3.51843770196*^9}]
}, Open  ]],

Cell["angle by b", "Text",
 CellChangeTimes->{{3.502607389217329*^9, 3.5026073960666523`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol\[Beta]", "=", 
  RowBox[{
   RowBox[{"\[Beta]", "/.", 
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"1", "^", "2"}], "\[Equal]", 
       RowBox[{
        RowBox[{"2", "^", "2"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"sol", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "^", "2"}], " ", "-", " ", 
        RowBox[{"2", 
         RowBox[{"(", "2", ")"}], 
         RowBox[{"sol", "[", 
          RowBox[{"[", "2", "]"}], "]"}], " ", 
         RowBox[{"Cos", "[", "\[Beta]", "]"}]}]}]}], ",", "\[Beta]"}], 
     "]"}]}], "//", "N"}]}]], "Input",
 CellChangeTimes->{{3.5025947270164013`*^9, 3.502594749682109*^9}, {
   3.502594785923277*^9, 3.502594808035969*^9}, {3.502594891672188*^9, 
   3.5025948960952263`*^9}, {3.502594987529544*^9, 3.502594989553697*^9}, 
   3.502595201736123*^9, {3.502595240233547*^9, 3.502595241048255*^9}, {
   3.502595552554435*^9, 3.502595554056975*^9}, {3.502606215132365*^9, 
   3.502606215706326*^9}, {3.50260630874907*^9, 3.502606413936632*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Solve", "::", "ifun"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Inverse functions are being used by \
\[NoBreak]\\!\\(Solve\\)\[NoBreak], so some solutions may not be found; use \
Reduce for complete solution information. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Solve/ifun\\\", ButtonNote -> \
\\\"Solve::ifun\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5184377032704*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.3613671239067072`"}], ",", "0.3613671239067072`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.502606374410695*^9, 3.502606414833993*^9}, 
   3.5184377032704*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cdoti", " ", "=", " ", 
  RowBox[{"Cos", "[", 
   RowBox[{"sol", 
    StyleBox["[",
     FontWeight->"Plain"], 
    StyleBox[
     RowBox[{"[", "2", "]"}],
     FontWeight->"Plain"], 
    StyleBox["]",
     FontWeight->"Plain"]}], 
   StyleBox["]",
    FontWeight->"Plain"]}]}]], "Input",
 CellChangeTimes->{{3.502606443154663*^9, 3.502606467792968*^9}}],

Cell[BoxData["0.39592451066021034`"], "Output",
 CellChangeTimes->{3.502606482578556*^9, 3.5184377068584003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cdotj", " ", "=", " ", 
  RowBox[{"-", 
   RowBox[{"Sin", "[", 
    RowBox[{"sol", 
     StyleBox["[",
      FontWeight->"Plain"], 
     StyleBox[
      RowBox[{"[", "2", "]"}],
      FontWeight->"Plain"], 
     StyleBox["]",
      FontWeight->"Plain"]}], 
    StyleBox["]",
     FontWeight->"Plain"]}]}]}]], "Input",
 CellChangeTimes->{{3.5026064845831823`*^9, 3.502606498697747*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.918283061946845`"}]], "Output",
 CellChangeTimes->{3.502606503551051*^9, 3.5184377082156*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bdoti", " ", "=", " ", 
  RowBox[{"Sin", "[", 
   RowBox[{"sol", 
    StyleBox["[",
     FontWeight->"Plain"], 
    StyleBox[
     RowBox[{"[", "2", "]"}],
     FontWeight->"Plain"], 
    StyleBox["]",
     FontWeight->"Plain"]}], 
   StyleBox["]",
    FontWeight->"Plain"]}]}]], "Input",
 CellChangeTimes->{{3.502608062870099*^9, 3.50260806818819*^9}, {
  3.502608117050605*^9, 3.502608130752018*^9}}],

Cell[BoxData["0.918283061946845`"], "Output",
 CellChangeTimes->{3.5026081479970903`*^9, 3.5184377090424*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bdotj", "=", 
  RowBox[{"Cos", "[", 
   RowBox[{"sol", 
    StyleBox["[",
     FontWeight->"Plain"], 
    StyleBox[
     RowBox[{"[", "2", "]"}],
     FontWeight->"Plain"], 
    StyleBox["]",
     FontWeight->"Plain"]}], 
   StyleBox["]",
    FontWeight->"Plain"]}]}]], "Input",
 CellChangeTimes->{{3.502608152625548*^9, 3.502608160608081*^9}}],

Cell[BoxData["0.39592451066021034`"], "Output",
 CellChangeTimes->{3.502608252777329*^9, 3.5184377101968*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"alpha", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"omega", "^", "2"}], " ", 
      RowBox[{"(", "2", ")"}], " ", "bdoti"}], " ", "-", " ", 
     RowBox[{"Aa", " ", "adotj"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", "2", ")"}], " ", "bdotj"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.502608295692129*^9, 3.502608348292489*^9}}],

Cell[BoxData["11.018843362688571`"], "Output",
 CellChangeTimes->{3.502608349852404*^9, 3.5184377111015997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ab", " ", "=", " ", 
  RowBox[{
   RowBox[{"Aa", " ", "adoti"}], " ", "+", " ", 
   RowBox[{"alpha", " ", 
    RowBox[{"(", "2", ")"}], " ", "bdoti"}], " ", "-", " ", 
   RowBox[{
    RowBox[{"omega", "^", "2"}], " ", 
    RowBox[{"(", "2", ")"}], "cdoti"}]}]}]], "Input",
 CellChangeTimes->{{3.502608356086828*^9, 3.502608398429793*^9}}],

Cell[BoxData["25.582703876243045`"], "Output",
 CellChangeTimes->{3.5026084438543463`*^9, 3.518437712802*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 127, 1, 36, "Subsection"],
Cell[709, 25, 51259, 790, 311, "Graphics"],
Cell[51971, 817, 107, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[52103, 822, 861, 21, 31, "Input"],
Cell[52967, 845, 334, 7, 30, "Output"]
}, Open  ]],
Cell[53316, 855, 112, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[53453, 860, 407, 9, 31, "Input"],
Cell[53863, 871, 112, 1, 30, "Output"]
}, Open  ]],
Cell[53990, 875, 99, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[54114, 880, 192, 4, 31, "Input"],
Cell[54309, 886, 155, 2, 30, "Output"]
}, Open  ]],
Cell[54479, 891, 94, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[54598, 896, 151, 3, 31, "Input"],
Cell[54752, 901, 153, 2, 30, "Output"]
}, Open  ]],
Cell[54920, 906, 95, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[55040, 911, 252, 6, 31, "Input"],
Cell[55295, 919, 108, 1, 30, "Output"]
}, Open  ]],
Cell[55418, 923, 99, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[55542, 928, 163, 4, 31, "Input"],
Cell[55708, 934, 87, 1, 30, "Output"]
}, Open  ]],
Cell[55810, 938, 114, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[55949, 943, 265, 7, 31, "Input"],
Cell[56217, 952, 171, 3, 30, "Output"]
}, Open  ]],
Cell[56403, 958, 91, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[56519, 963, 176, 4, 31, "Input"],
Cell[56698, 969, 122, 3, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56857, 977, 194, 5, 31, "Input"],
Cell[57054, 984, 139, 4, 50, "Output"]
}, Open  ]],
Cell[57208, 991, 94, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[57327, 996, 1044, 24, 31, "Input"],
Cell[58374, 1022, 529, 11, 21, "Message"],
Cell[58906, 1035, 221, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59164, 1046, 378, 13, 31, "Input"],
Cell[59545, 1061, 113, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59695, 1067, 409, 14, 31, "Input"],
Cell[60107, 1083, 124, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60268, 1090, 426, 14, 31, "Input"],
Cell[60697, 1106, 109, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60843, 1112, 368, 13, 31, "Input"],
Cell[61214, 1127, 109, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61360, 1133, 409, 12, 31, "Input"],
Cell[61772, 1147, 112, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61921, 1153, 362, 9, 31, "Input"],
Cell[62286, 1164, 109, 1, 30, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
