(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     72708,       2331]
NotebookOptionsPosition[     70761,       2265]
NotebookOutlinePosition[     71121,       2281]
CellTagsIndexPosition[     71078,       2278]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Example Animation", "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Input the definitions for the vector operations", "Subsubsection"],

Cell["\<\
Input the vector definition with the command that follows.  The path will \
depend on where  the definitions reside on the local system.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Get", "[", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<vectors3.m\>\""}], 
   "]"}], "]"}]], "Input",
 CellChangeTimes->{
  3.5184384636324*^9, {3.5195563111762*^9, 3.5195563111762*^9}, {
   3.5362636775314207`*^9, 3.536263701826948*^9}, {3.536263749502494*^9, 
   3.536263776944263*^9}, {3.536263821970294*^9, 3.5362638617769003`*^9}, {
   3.5362639175516*^9, 3.536263950578731*^9}, {3.536264179236363*^9, 
   3.53626418453414*^9}, {3.536264220068849*^9, 3.536264240290702*^9}, {
   3.536264328926669*^9, 3.536264333760079*^9}},
 AspectRatioFixed->True],

Cell[BoxData["\<\"These Engineering Vector algorithms are copyright Alan A. \
Barhorst\"\>"], "Print",
 CellChangeTimes->{3.536264335122077*^9, 3.536264367469923*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["System to Anmimate", "Subsubsection"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 0.855705
200 dict begin
MathPictureStart
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 1 [
[ 37 103 0 0 ]
[ 335 358 0 0 ]
] MathScale
% Start of Graphics
%!PS-Adobe-2.0 EPSF-2.0
%%Title: 
%%Creator: Tailor
%%CreationDate: Wed Oct 29 23:09:19 1997
%%For: alan
%%DocumentFonts: (atend)
%%Pages: 0 0
%%BoundingBox: 37 103 335 358
%%NXNextStepVersion: 3.0
%%EndComments

%%BeginProcSet: /usr/lib/NextStep/printPackage.ps 3.0
%!
% NeXT Printing Package
% Version: 3.1
% Copyright: 1988, NeXT, Inc.

/__NXdef{1 index where{pop pop pop}{def}ifelse}bind def
/__NXbdef{1 index where{pop pop pop}{bind def}ifelse}bind def
/UserObjects 10 array __NXdef
/defineuserobject{
\texch dup 1 add dup UserObjects length gt{
\t\tarray dup 0 UserObjects putinterval
\t\t/UserObjects exch def
\t}{pop}ifelse UserObjects exch 3 -1 roll put
}__NXbdef
/undefineuserobject{UserObjects exch null put}__NXbdef
/execuserobject{UserObjects exch get exec}__NXbdef
/__NXRectPath{4 2 roll moveto 1 index 0 rlineto
0 exch rlineto neg 0 rlineto closepath}__NXbdef
/__NXProcessRectArgs{
\t1 index type /arraytype eq{
\t\texch 0 4 2 index length 1 sub{
\t\t\tdup 3 add 1 exch{1 index exch get exch}for
\t\t\t5 1 roll 5 index exec
\t\t}for pop pop
\t}{exec}ifelse
}__NXbdef
/rectfill{gsave newpath {__NXRectPath fill} __NXProcessRectArgs \
grestore}__NXbdef
/rectclip{newpath {__NXRectPath} __NXProcessRectArgs clip newpath}__NXbdef
/rectstroke{
\tgsave newpath dup type /arraytype eq{dup length 6 eq}{false}ifelse{
\t\t{gsave __NXRectPath null concat stroke grestore}
\t\tdup length array cvx copy dup 2 4 -1 roll put __NXProcessRectArgs
\t}{{__NXRectPath stroke} __NXProcessRectArgs}ifelse grestore
}__NXbdef
/_NXLevel2 systemdict /languagelevel known {languagelevel 2 ge}{false}ifelse \
__NXdef
/xyshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index 2 mul 1 add get add exch
\t\t3 index\t3 index 2 mul get add exch moveto pop
\t}for pop pop
}__NXbdef
/xshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\texch 3 index 3 index get add exch moveto pop
\t}for pop pop
}__NXbdef
/yshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index get add moveto pop
\t}for pop pop
}__NXbdef
/arct{arcto pop pop pop pop}__NXbdef
/setbbox{pop pop pop pop}__NXbdef
/ucache{}__NXbdef
/ucachestatus{mark 0 0 0 0 0}__NXbdef
/setucacheparams{cleartomark}__NXbdef
/uappend{systemdict begin cvx exec end}__NXbdef
/ueofill{gsave newpath uappend eofill grestore}__NXbdef
/ufill{gsave newpath uappend fill grestore}__NXbdef
/ustroke{
\tgsave newpath dup length 6 eq
\t{exch uappend concat}{uappend}ifelse
\tstroke grestore
}__NXbdef
/__NXustrokepathMatrix dup where {pop pop}{matrix def}ifelse
/ustrokepath{
\tnewpath dup length 6 eq{
\t\texch uappend __NXustrokepathMatrix currentmatrix exch concat
\t\tstrokepath setmatrix
\t}{uappend strokepath}ifelse
} __NXbdef
/upath{
\t[exch {/ucache cvx}if pathbbox /setbbox cvx
\t {/moveto cvx}{/lineto cvx}{/curveto cvx}{/closepath cvx}pathforall]cvx
} __NXbdef
/setstrokeadjust{pop}__NXbdef
/currentstrokeadjust{false}__NXbdef
/selectfont{exch findfont exch
dup type /arraytype eq {makefont}{scalefont}ifelse setfont}__NXbdef
/_NXCombineArrays{
\tcounttomark dup 2 add index dup length 3 -1 roll {
\t\t2 index length sub dup 4 1 roll 1 index exch 4 -1 roll putinterval exch
\t}repeat pop pop pop
}__NXbdef
/flushgraphics{}def
/setwindowtype{pop pop}def
/currentwindowtype{pop 0}def
/setalpha{pop}def
/currentalpha{1.0}def
/hidecursor{}def
/obscurecursor{}def
/revealcursor{}def
/setcursor{4 {pop}repeat}bind def
/showcursor{}def
/NextStepEncoding where not{
/NextStepEncoding StandardEncoding 256 array copy def
0 [129/Agrave/Aacute/Acircumflex/Atilde/Adieresis/Aring/Ccedilla/Egrave
/Eacute/Ecircumflex/Edieresis/Igrave/Iacute/Icircumflex/Idieresis
/Eth/Ntilde/Ograve/Oacute/Ocircumflex/Otilde/Odieresis/Ugrave/Uacute
/Ucircumflex/Udieresis/Yacute/Thorn/mu/multiply/divide/copyright
176/registered 181/brokenbar 190/logicalnot 192/onesuperior 201/twosuperior
204/threesuperior 209/plusminus/onequarter/onehalf/threequarters/agrave
/aacute/acircumflex/atilde/adieresis/aring/ccedilla/egrave/eacute
/ecircumflex/edieresis/igrave 226/iacute 228/icircumflex/idieresis/eth
/ntilde 236/ograve/oacute/ocircumflex/otilde/odieresis 242/ugrave/uacute
/ucircumflex 246/udieresis/yacute 252/thorn/ydieresis]
{dup type /nametype eq
 {NextStepEncoding 2 index 2 index put pop 1 add}{exch pop}ifelse
}forall pop
/NextStepEncoding NextStepEncoding readonly def
/_NXfstr 128 string dup 0 (_NX) putinterval def
/_NXfindfont /findfont load def
/findfont{
 % Because we can never let NextStepEncoding get into
 % SharedFontDirectory, we cannot reencode a font to NextStepEncoding
 % if we are in shared mode.  So if currentshared is true,
 % we call the normal findfont and return that
 /currentshared where {pop currentshared} {false} ifelse
 {_NXfindfont}
 {dup _NXfstr 3 125 getinterval cvs length 3 add _NXfstr 0 3 -1 roll
  getinterval cvn exch FontDirectory 2 index known 
  {pop FontDirectory exch get}
  {_NXfindfont dup /Encoding get StandardEncoding eq
   {\tdup length dict exch
\t{1 index /FID ne {2 index 3 1 roll put}{pop pop}ifelse}forall
\t dup /Encoding NextStepEncoding put definefont
\t}{exch pop} ifelse
   }ifelse
 }ifelse
}bind def
}{pop}ifelse
/_NXImageString {/__NXImageString where{pop}{/__NXImageString 4000 string \
__NXdef}ifelse __NXImageString}__NXbdef
/_NXDoImageOp{
\t3 dict begin /parr 5 array def 1 index{dup}{1}ifelse /chans exch def
\tchans 2 add 2 roll parr 0 chans getinterval astore pop
\t5 index 4 index mul 2 index{1 sub 8 idiv 1 add mul}{mul 1 sub 8 idiv 1 \
add}ifelse
\t4 index mul /totbytes exch def pop exch pop
\tgsave matrix invertmatrix concat 0.5 setgray 0 0 4 2 roll rectfill grestore
\t{0 1 chans 1 sub{parr exch get exec length totbytes exch sub /totbytes exch \
def}for totbytes 0 le{exit}if}loop end
}__NXbdef
/alphaimage{1 add _NXDoImageOp}def
_NXLevel2{ 
\t/NXCalibratedRGBColorSpace where{pop}{
\t\t/NXCalibratedRGBColorSpace
\t\t{mark /NXCalibratedRGB /ColorSpace findresource exch pop}stopped
\t\t{cleartomark /NXCalibratedRGB[/CIEBasedABC 2 dict dup begin 
\t\t/MatrixLMN[.4124 .2126 .0193 .3576 .7152 .1192 .1805 .0722 .9505]def
\t\t/WhitePoint[.9505 1 1.089] def end] /ColorSpace defineresource}if \
def}ifelse
\t/nxsetrgbcolor{NXCalibratedRGBColorSpace setcolorspace setcolor}__NXbdef
\t/nxsetgray{dup dup nxsetrgbcolor}__NXbdef
\t/_NXCalibratedImage{exch{array astore dup length true}{false}ifelse
\t\t8 -1 roll{NXCalibratedRGBColorSpace setcolorspace}if
\t\t8 dict dup 9 1 roll begin /ImageType 1 def /MultipleDataSources exch def
\t\tcurrentcolorspace 0 get /Indexed eq{pop /Decode[0 2 6 index exp 1 \
sub]def}
\t\t{2 mul dup array /Decode exch def 1 sub 0 1 3 -1 roll{Decode exch dup 2 \
mod put}for}ifelse
\t\t/DataSource exch def /ImageMatrix exch def 
\t\t/BitsPerComponent exch def /Height exch def /Width exch def end \
image}__NXbdef
} {
\t/setcmykcolor{
\t\t1.0 exch sub dup dup 6 -1 roll sub dup 0 lt{pop 0}if 5 1 roll
\t\t4 -1 roll sub dup 0 lt{pop 0}if 3 1 roll exch sub dup 0 lt{pop 0}if \
setrgbcolor}__NXbdef
\t/currentcmykcolor{currentrgbcolor 3{1.0 exch sub 3 1 roll}repeat 0}__NXbdef
\t/colorimage{2 copy 3 ne or{_NXDoImageOp}{4 index dup 8 ne exch 4 ne \
and{_NXDoImageOp}{
\t\tpop pop save 6 1 roll 12 dict begin/Proc exch def/Res 0 string def
\t\t/Alloc{2 index length mul 2 add dup 2 index load length gt{1.2 mul round \
cvi string def}{pop pop}ifelse}def
\t\t1 index 8 eq{/Unpack{.34 Alloc}def}{
\t\t\t/Wid 4 index 3 mul def exch pop 8 exch/Str1 0 string def/Lim Wid def
\t\t\t/Unpack{.67 Alloc/Str1 2 Alloc 0 exch Lim exch
\t\t\t\t{dup -4 bitshift 17 mul Str1 exch 4 index exch put 15 and 17 mul Str1 \
exch 3 index 1 add exch put
\t\t\t\t2 sub dup 0 le{0 lt Wid exch{exch 1 sub exch}if}if exch 2 add exch
\t\t\t\t}forall/Lim exch def Str1 exch 0 exch getinterval
\t\t\t}def
\t\t}ifelse
\t\t/Ops[{.3 mul add 1}{.59 mul add 2}{.11 mul add round cvi Res exch 2 index \
exch put 1 add 0.0 0}]def/Val 0.0 def/Phase 0 def
\t\t{0 Val Phase Proc/Res Unpack{exch Ops exch get exec}forall/Phase exch \
def/Val exch def Res exch 0 exch getinterval}
\t\timage end restore}ifelse}ifelse
\t}__NXbdef
\t/nxsetrgbcolor{setrgbcolor}__NXbdef /nxsetgray{setgray}__NXbdef
\t/setpattern{pop .5 setgray}__NXbdef
\t/_NXCalibratedImage{dup 1 eq {pop pop image}{colorimage}ifelse pop}__NXbdef
} ifelse
/_NXSetCMYKOrRGB where{pop}{
\tmark{systemdict /currentwindow get exec}stopped
\t{{pop pop pop setcmykcolor}}{{nxsetrgbcolor pop pop pop pop}}ifelse \
/_NXSetCMYKOrRGB exch def cleartomark
}ifelse
%%EndProcSet

%%BeginResource: procset (Tailor 2.0)
/TailorDict 10 dict def TailorDict begin
/TailorGroupBegin {pop} def /TailorGroupEnd {} def
/TailorBlockBegin {pop pop pop} def /TailorBlockEnd {} def
/TailorSetUniformStroke {pop} def
/setoverprint where {pop} {/setoverprint {pop} def} ifelse
end
%%EndResource

gsave
 /__NXbasematrix matrix currentmatrix def
grestore
%%EndProlog
%%BeginSetup
TailorDict begin
%%EndSetup
0 0 335 358 rectclip
0 0 335 358 rectclip
gsave
0 setgray
1 setlinewidth
(* Group Created by User *) TailorGroupBegin
[1 0 0 1 0 0] matrix invertmatrix concat
[0.634399 -0.767227 0.767227 0.634399 -334.250427 593.32782] concat
gsave
newpath
systemdict
begin
470.496002 143.572006 697.495972 160.572006 setbbox
470.496002 152.072006 moveto
470.496002 156.766006 474.302002 160.572006 478.996002 160.572006 curveto
688.995972 160.572006 lineto
693.690979 160.572006 697.495972 156.766006 697.495972 152.072006 curveto
697.495972 147.376999 693.690979 143.572006 688.995972 143.572006 curveto
478.996002 143.572006 lineto
474.302002 143.572006 470.496002 147.376999 470.496002 152.072006 curveto
closepath
end
stroke
grestore
[0.634399 -0.767227 0.767227 0.634399 -334.250427 593.32782] matrix \
invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
153.285995 29.7143 207.266998 66.214302 setbbox
207.266998 64.865196 moveto
206.729996 45.245201 194.809006 29.7143 180.285995 29.7143 curveto
165.382004 29.7143 153.285995 46.066299 153.285995 66.214302 curveto
end
stroke
grestore
gsave
newpath
systemdict
begin
124.286003 66.714302 233.285995 66.714302 setbbox
124.286003 66.714302 moveto
233.285995 66.714302 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
156.285995 67.714203 165.285995 84.714203 setbbox
165.285995 84.714203 moveto
156.285995 67.714203 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
165.285995 66.714302 174.285995 83.714302 setbbox
174.285995 83.714302 moveto
165.285995 66.714302 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
174.285995 66.714302 183.285995 83.714302 setbbox
183.285995 83.714302 moveto
174.285995 66.714302 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
184.285995 66.714302 193.285995 83.714302 setbbox
193.285995 83.714302 moveto
184.285995 66.714302 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
193.285995 66.714302 202.285995 83.714302 setbbox
202.285995 83.714302 moveto
193.285995 66.714302 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
202.285995 68.714203 211.285995 85.714203 setbbox
211.285995 85.714203 moveto
202.285995 68.714203 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[1.4222 0 0 1.4222 -166.975494 -17.160133] concat
gsave
newpath
systemdict
begin
241.550003 157.785004 246.449997 162.684998 setbbox
246.449997 160.235001 moveto
246.449997 158.882996 245.352005 157.785004 244 157.785004 curveto
242.647995 157.785004 241.550003 158.882996 241.550003 160.235001 curveto
241.550003 161.587997 242.647995 162.684998 244 162.684998 curveto
245.352005 162.684998 246.449997 161.587997 246.449997 160.235001 curveto
closepath
end
fill
grestore
[1.4222 0 0 1.4222 -166.975494 -17.160133] matrix invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
179.537994 44.557098 186.537994 51.557098 setbbox
186.537994 48.057098 moveto
186.537994 46.125099 184.970001 44.557098 183.037994 44.557098 curveto
181.106003 44.557098 179.537994 46.125099 179.537994 48.057098 curveto
179.537994 49.989101 181.106003 51.557098 183.037994 51.557098 curveto
184.970001 51.557098 186.537994 49.989101 186.537994 48.057098 curveto
closepath
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[-0.695381 -0.712423 0.712423 -0.695381 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
-163.451004 141.227005 -156.451004 145.227005 setbbox
-162.451004 143.227005 moveto
-163.451004 145.227005 lineto
-156.451004 143.227005 lineto
-163.451004 141.227005 lineto
closepath
end
fill
grestore
[-0.695381 -0.712423 0.712423 -0.695381 -2.180612 162.883255] matrix \
invertmatrix concat
[0.30004 0.94925 -0.94925 0.30004 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
109.480003 -209.804993 116.480003 -205.804001 setbbox
110.480003 -207.804001 moveto
109.480003 -205.804001 lineto
116.480003 -207.804001 lineto
109.480003 -209.804993 lineto
closepath
end
fill
grestore
[0.30004 0.94925 -0.94925 0.30004 -2.180612 162.883255] matrix invertmatrix \
concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
215.966995 16.208401 231.438995 42.714298 setbbox
215.966995 16.208401 moveto
222.904007 23.189699 228.240997 32.333099 231.438995 42.714298 curveto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[-0.638721 0.763633 0.763633 0.638721 690.918396 162.883255] concat
gsave
newpath
systemdict
begin
549.583008 -365.5 556.583008 -361.5 setbbox
550.583008 -363.5 moveto
549.583008 -361.5 lineto
556.583008 -363.5 lineto
549.583008 -365.5 lineto
closepath
end
fill
grestore
[-0.638721 0.763633 0.763633 0.638721 690.918396 162.883255] matrix \
invertmatrix concat
[-0.99554 0 0 0.99554 690.918396 162.883255] concat
gsave
newpath
systemdict
begin
580.713989 127.713997 632.06897 189.112 setbbox
580.713989 127.713997 moveto
632.06897 189.112 lineto
end
stroke
grestore
[-0.99554 0 0 0.99554 690.918396 162.883255] matrix invertmatrix concat
[0.765481 0.636504 -0.636504 0.765481 701.705811 149.98111] concat
gsave
newpath
systemdict
begin
-242.949997 316.022003 -235.949997 320.022003 setbbox
-241.949997 318.022003 moveto
-242.949997 320.022003 lineto
-235.949997 318.022003 lineto
-242.949997 316.022003 lineto
closepath
end
fill
grestore
[0.765481 0.636504 -0.636504 0.765481 701.705811 149.98111] matrix \
invertmatrix concat
[-4.35163e-08 0.99554 -0.99554 -4.35163e-08 701.705811 149.98111] concat
gsave
newpath
systemdict
begin
14.7142 389.368011 89.838097 479.713989 setbbox
14.7142 479.713989 moveto
89.838097 389.368011 lineto
end
stroke
grestore
[-4.35163e-08 0.99554 -0.99554 -4.35163e-08 701.705811 149.98111] matrix \
invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
310.300995 46.714199 317.300995 50.714199 setbbox
311.300995 48.714199 moveto
310.300995 50.714199 lineto
317.300995 48.714199 lineto
310.300995 46.714199 lineto
closepath
end
fill
grestore
gsave
newpath
systemdict
begin
190.285995 48.714298 311.300995 48.714298 setbbox
190.285995 48.714298 moveto
311.300995 48.714298 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[-4.35163e-08 0.99554 -0.99554 -4.35163e-08 801.339478 430.245514] concat
gsave
newpath
systemdict
begin
-95.269997 621.713989 -88.269997 625.713989 setbbox
-94.269997 623.713989 moveto
-95.269997 625.713989 lineto
-88.269997 623.713989 lineto
-95.269997 621.713989 lineto
closepath
end
fill
grestore
gsave
newpath
systemdict
begin
-215.285995 623.713989 -94.269997 623.713989 setbbox
-215.285995 623.713989 moveto
-94.269997 623.713989 lineto
end
stroke
grestore
[-4.35163e-08 0.99554 -0.99554 -4.35163e-08 801.339478 430.245514] matrix \
invertmatrix concat
[0.99554 0 0 0.99554 -183.084763 52.093914] concat
/Times-BoldItalic findfont 1 scalefont [14 0 0 14 0 0] makefont
39
exch
defineuserobject
39 execuserobject setfont
229 288 moveto
(b) show
/Times-BoldItalic findfont 1 scalefont [12 0 0 12 0 0] makefont
40
exch
defineuserobject
40 execuserobject setfont
236 283.200012 moveto
(1 ) show
[0.99554 0 0 0.99554 -183.084763 52.093914] matrix invertmatrix concat
[0.99554 0 0 0.99554 92.680138 -47.460098] concat
39 execuserobject setfont
229 288 moveto
(b) show
40 execuserobject setfont
236 283.200012 moveto
(2 ) show
[0.99554 0 0 0.99554 92.680138 -47.460098] matrix invertmatrix concat
[0.99554 0 0 0.99554 -86.51709 193.460571] concat
39 execuserobject setfont
132 154.399994 moveto
(^ ) show
[0.99554 0 0 0.99554 -86.51709 193.460571] matrix invertmatrix concat
[0.99554 0 0 0.99554 190.242798 92.910995] concat
132 154.399994 moveto
(^ ) show
[0.99554 0 0 0.99554 190.242798 92.910995] matrix invertmatrix concat
[0.99554 0 0 0.99554 154.403625 -52.437798] concat
169 258 moveto
(i ) show
[0.99554 0 0 0.99554 154.403625 -52.437798] matrix invertmatrix concat
[0.99554 0 0 0.99554 70.778259 52.093914] concat
122 278 moveto
(j ) show
[0.99554 0 0 0.99554 70.778259 52.093914] matrix invertmatrix concat
[0.99554 0 0 0.99554 117.568642 26.209854] concat
75 309 moveto
(^ ) show
[0.99554 0 0 0.99554 117.568642 26.209854] matrix invertmatrix concat
[0.99554 0 0 0.99554 247.984116 -98.232666] concat
75 309 moveto
(^ ) show
[0.99554 0 0 0.99554 247.984116 -98.232666] matrix invertmatrix concat
[0.99554 0 0 0.99554 -9.86049 -446.671722] concat
/Times-Italic findfont 1 scalefont [18 0 0 18 0 0] makefont
41
exch
defineuserobject
41 execuserobject setfont
175 665 moveto
(o ) show
[0.99554 0 0 0.99554 -9.86049 -446.671722] matrix invertmatrix concat
[1.4222 0 0 1.4222 -166.975494 -17.160133] concat
gsave
newpath
systemdict
begin
221.397003 178.632004 228.602997 185.839005 setbbox
228.602997 182.235001 moveto
228.602997 180.246002 226.988998 178.632004 225 178.632004 curveto
223.011002 178.632004 221.397003 180.246002 221.397003 182.235001 curveto
221.397003 184.225006 223.011002 185.839005 225 185.839005 curveto
226.988998 185.839005 228.602997 184.225006 228.602997 182.235001 curveto
closepath
end
fill
grestore
[1.4222 0 0 1.4222 -166.975494 -17.160133] matrix invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
150.748001 74.337898 161.042999 84.633499 setbbox
161.042999 79.485703 moveto
161.042999 76.644096 158.737 74.337898 155.895004 74.337898 curveto
153.054001 74.337898 150.748001 76.644096 150.748001 79.485703 curveto
150.748001 82.327301 153.054001 84.633499 155.895004 84.633499 curveto
158.737 84.633499 161.042999 82.327301 161.042999 79.485703 curveto
closepath
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[0.99554 0 0 0.99554 -50.677635 -215.706451] concat
174 462 moveto
(cm ) show
[0.99554 0 0 0.99554 -50.677635 -215.706451] matrix invertmatrix concat
[0.99554 0 0 0.99554 -0.900633 -97.237106] concat
39 execuserobject setfont
229 288 moveto
(q) show
40 execuserobject setfont
236 283.200012 moveto
(1 ) show
[0.99554 0 0 0.99554 -0.900633 -97.237106] matrix invertmatrix concat
[0.99554 0 0 0.99554 28.965588 -38.500256] concat
39 execuserobject setfont
229 288 moveto
(q) show
40 execuserobject setfont
236 283.200012 moveto
(2 ) show
[0.99554 0 0 0.99554 28.965588 -38.500256] matrix invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
199.285995 -51.285801 246.285995 -28.285801 setbbox
199.285995 -28.285801 moveto
199.285995 -51.285801 lineto
246.285995 -51.285801 lineto
246.285995 -28.285801 lineto
closepath
end
stroke
grestore
gsave
newpath
systemdict
begin
200.285995 -28.2857 222.285995 -0.285772 setbbox
222.285995 -0.285772 moveto
200.285995 -28.2857 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
223.285995 -28.285801 246.285995 -1.28579 setbbox
223.285995 -1.28579 moveto
246.285995 -28.285801 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[0.99554 0 0 0.99554 -115.388031 -177.87587] concat
39 execuserobject setfont
229 288 moveto
(c) show
40 execuserobject setfont
235.216003 283.200012 moveto
(1 ) show
[0.99554 0 0 0.99554 -115.388031 -177.87587] matrix invertmatrix concat
[0.99554 0 0 0.99554 -18.820356 -36.509228] concat
39 execuserobject setfont
132 154.399994 moveto
(^ ) show
[0.99554 0 0 0.99554 -18.820356 -36.509228] matrix invertmatrix concat
[0.99554 0 0 0.99554 -24.793592 -17.593895] concat
229 288 moveto
(c) show
40 execuserobject setfont
235.216003 283.200012 moveto
(2 ) show
[0.99554 0 0 0.99554 -24.793592 -17.593895] matrix invertmatrix concat
[0.99554 0 0 0.99554 72.769341 122.777199] concat
39 execuserobject setfont
132 154.399994 moveto
(^ ) show
[0.99554 0 0 0.99554 72.769341 122.777199] matrix invertmatrix concat
[-0.995482 -0.010796 -0.010796 0.995482 690.918396 162.883255] concat
gsave
newpath
systemdict
begin
561.322021 -36.124699 568.322021 -32.124699 setbbox
562.322021 -34.124699 moveto
561.322021 -32.124699 lineto
568.322021 -34.124699 lineto
561.322021 -36.124699 lineto
closepath
end
fill
grestore
[-0.995482 -0.010796 -0.010796 0.995482 690.918396 162.883255] matrix \
invertmatrix concat
[-0.99554 0 0 0.99554 690.918396 162.883255] concat
gsave
newpath
systemdict
begin
475.713989 -40.220699 561.919006 -39.285801 setbbox
475.713989 -39.285801 moveto
561.919006 -40.220699 lineto
end
stroke
grestore
[-0.99554 0 0 0.99554 690.918396 162.883255] matrix invertmatrix concat
[1.4222 0 0 1.4222 -166.975494 -17.160133] concat
gsave
newpath
systemdict
begin
267.897003 95.632004 275.102997 102.838997 setbbox
275.102997 99.235497 moveto
275.102997 97.2463 273.489014 95.632004 271.5 95.632004 curveto
269.510986 95.632004 267.897003 97.2463 267.897003 99.235497 curveto
267.897003 101.224998 269.510986 102.838997 271.5 102.838997 curveto
273.489014 102.838997 275.102997 101.224998 275.102997 99.235497 curveto
closepath
end
fill
grestore
[1.4222 0 0 1.4222 -166.975494 -17.160133] matrix invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
217.175995 -44.233501 227.472 -33.937901 setbbox
227.472 -39.085701 moveto
227.472 -41.927399 225.166 -44.233501 222.324005 -44.233501 curveto
219.481995 -44.233501 217.175995 -41.927399 217.175995 -39.085701 curveto
217.175995 -36.244099 219.481995 -33.937901 222.324005 -33.937901 curveto
225.166 -33.937901 227.472 -36.244099 227.472 -39.085701 curveto
closepath
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[0.99554 0 0 0.99554 49.871929 -353.090881] concat
41 execuserobject setfont
174 462 moveto
(cm ) show
[0.99554 0 0 0.99554 49.871929 -353.090881] matrix invertmatrix concat
[0.01259 0.995461 0.995461 -0.01259 690.918396 162.883255] concat
gsave
newpath
systemdict
begin
93.724701 -476.230011 100.724998 -472.230011 setbbox
94.7248 -474.230011 moveto
93.7248 -472.230011 lineto
100.724998 -474.230011 lineto
93.724701 -476.230011 lineto
closepath
end
fill
grestore
[0.01259 0.995461 0.995461 -0.01259 690.918396 162.883255] matrix \
invertmatrix concat
[-0.99554 0 0 0.99554 690.918396 162.883255] concat
gsave
newpath
systemdict
begin
472.993988 -35.2859 474.713989 100.714996 setbbox
474.713989 -35.2859 moveto
472.993988 100.714996 lineto
end
stroke
grestore
[-0.99554 0 0 0.99554 690.918396 162.883255] matrix invertmatrix concat
[0.79665 -0.597034 0.597034 0.79665 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
195.403 224.716995 202.403 228.716995 setbbox
196.403 226.716995 moveto
195.403 228.716995 lineto
202.403 226.716995 lineto
195.403 224.716995 lineto
closepath
end
fill
grestore
[0.79665 -0.597034 0.597034 0.79665 -2.180612 162.883255] matrix invertmatrix \
concat
[-0.994037 -0.0547 0.0547 -0.994037 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
-234.563995 -71.792099 -227.563995 -67.792099 setbbox
-233.563995 -69.792099 moveto
-234.563995 -67.792099 lineto
-227.563995 -69.792099 lineto
-234.563995 -71.792099 lineto
closepath
end
fill
grestore
[-0.994037 -0.0547 0.0547 -0.994037 -2.180612 162.883255] matrix invertmatrix \
concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
229.376007 63.638699 293.128998 82.714401 setbbox
293.128998 63.638699 moveto
276.972992 75.963699 256.598999 82.714401 235.559006 82.714401 curveto
233.496002 82.714401 231.434006 82.649498 229.376007 82.519699 curveto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[1.4222 0 0 1.4222 -166.975494 -17.160133] concat
gsave
newpath
systemdict
begin
267.549988 122.785004 272.450012 127.684998 setbbox
272.450012 125.235001 moveto
272.450012 123.883003 271.35199 122.785004 270 122.785004 curveto
268.64801 122.785004 267.549988 123.883003 267.549988 125.235001 curveto
267.549988 126.587997 268.64801 127.684998 270 127.684998 curveto
271.35199 127.684998 272.450012 126.587997 272.450012 125.235001 curveto
closepath
end
fill
grestore
[1.4222 0 0 1.4222 -166.975494 -17.160133] matrix invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
216.681 -5.44289 223.681 1.55714 setbbox
223.681 -1.94288 moveto
223.681 -3.8749 222.113007 -5.44289 220.181 -5.44289 curveto
218.248993 -5.44289 216.681 -3.8749 216.681 -1.94288 curveto
216.681 -0.010853 218.248993 1.55714 220.181 1.55714 curveto
222.113007 1.55714 223.681 -0.010853 223.681 -1.94288 curveto
closepath
end
stroke
grestore
gsave
newpath
systemdict
begin
134.285995 10.7142 178.285995 44.714199 setbbox
178.285995 44.714199 moveto
134.285995 10.7142 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
187.285995 -28.285801 219.285995 -3.28582 setbbox
219.285995 -3.28582 moveto
187.285995 -28.285801 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
124.286003 56.714199 153.285995 77.714203 setbbox
153.285995 77.714203 moveto
124.286003 56.714199 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
41.285702 125.713997 88.285698 162.714005 setbbox
88.285698 162.714005 moveto
41.285702 125.713997 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[-0.637329 0.764795 -0.764795 -0.637329 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
-86.529297 -146.973999 -79.529297 -142.973999 setbbox
-85.529297 -144.973999 moveto
-86.529297 -142.973999 lineto
-79.529297 -144.973999 lineto
-86.529297 -146.973999 lineto
closepath
end
fill
grestore
[-0.637329 0.764795 -0.764795 -0.637329 -2.180612 162.883255] matrix \
invertmatrix concat
[0.637329 -0.764795 0.764795 0.637329 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
135.011002 142.973999 142.011002 146.973999 setbbox
136.011002 144.973999 moveto
135.011002 146.973999 lineto
142.011002 144.973999 lineto
135.011002 142.973999 lineto
closepath
end
fill
grestore
[0.637329 -0.764795 0.764795 0.637329 -2.180612 162.883255] matrix \
invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
166.126999 -11.6764 198.445007 27.1049 setbbox
166.126999 27.1049 moveto
198.445007 -11.6764 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[-0.639747 0.762774 -0.762774 -0.639747 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
-45.119099 -146.598007 -38.119099 -142.598007 setbbox
-44.119099 -144.598007 moveto
-45.119099 -142.598007 lineto
-38.119099 -144.598007 lineto
-45.119099 -146.598007 lineto
closepath
end
fill
grestore
[-0.639747 0.762774 -0.762774 -0.639747 -2.180612 162.883255] matrix \
invertmatrix concat
[0.639747 -0.762774 0.762774 0.639747 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
71.578903 142.598007 78.578903 146.598007 setbbox
72.578903 144.598007 moveto
71.578903 146.598007 lineto
78.578903 144.598007 lineto
71.578903 142.598007 lineto
closepath
end
fill
grestore
[0.639747 -0.762774 0.762774 0.639747 -2.180612 162.883255] matrix \
invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
139.141006 37.311298 157.429993 59.117001 setbbox
139.141006 59.117001 moveto
157.429993 37.311298 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[-0.636664 0.76535 -0.76535 -0.636664 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
62.869301 -125.530998 69.869301 -121.530998 setbbox
63.869301 -123.530998 moveto
62.869301 -121.530998 lineto
69.869301 -123.530998 lineto
62.869301 -125.530998 lineto
closepath
end
fill
grestore
[-0.636664 0.76535 -0.76535 -0.636664 -2.180612 162.883255] matrix \
invertmatrix concat
[0.636662 -0.76535 0.76535 0.636662 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
70.116898 121.530998 77.116997 125.530998 setbbox
71.116898 123.530998 moveto
70.116898 125.530998 lineto
77.116997 123.530998 lineto
70.116898 121.530998 lineto
closepath
end
fill
grestore
[0.636662 -0.76535 0.76535 0.636662 -2.180612 162.883255] matrix invertmatrix \
concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
54.122799 24.326799 140.449005 128.102005 setbbox
54.122799 128.102005 moveto
140.449005 24.326799 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[0.99554 0 0 0.99554 -159.191788 -46.464626] concat
39 execuserobject setfont
229 288 moveto
(l) show
40 execuserobject setfont
232.891998 283.200012 moveto
(2 ) show
[0.99554 0 0 0.99554 -159.191788 -46.464626] matrix invertmatrix concat
[0.99554 0 0 0.99554 -98.463562 -83.299561] concat
39 execuserobject setfont
229 288 moveto
(d) show
40 execuserobject setfont
236 283.200012 moveto
(1 ) show
[0.99554 0 0 0.99554 -98.463562 -83.299561] matrix invertmatrix concat
[0.99554 0 0 0.99554 -61.628586 -123.12117] concat
39 execuserobject setfont
229 288 moveto
(l) show
40 execuserobject setfont
232.891998 283.200012 moveto
(1 ) show
[0.99554 0 0 0.99554 -61.628586 -123.12117] matrix invertmatrix concat
[0.99554 0 0 0.99554 45.889755 -147.014114] concat
39 execuserobject setfont
229 288 moveto
(d) show
40 execuserobject setfont
236 283.200012 moveto
(2 ) show
[0.99554 0 0 0.99554 45.889755 -147.014114] matrix invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
228.285995 -1.28579 282.286011 -1.28579 setbbox
228.285995 -1.28579 moveto
282.286011 -1.28579 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
230.285995 -39.285801 283.286011 -38.285702 setbbox
230.285995 -39.285801 moveto
283.286011 -38.285702 lineto
end
stroke
grestore
[0.99554 0 0 0.99554 -2.180612 162.883255] matrix invertmatrix concat
[0 0.99554 -0.99554 0 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
-8.28582 -272.286011 -1.28579 -268.286011 setbbox
-7.28581 -270.286011 moveto
-8.28582 -268.286011 lineto
-1.28579 -270.286011 lineto
-8.28582 -272.286011 lineto
closepath
end
fill
grestore
[0 0.99554 -0.99554 0 -2.180612 162.883255] matrix invertmatrix concat
[1.18717e-08 -0.99554 0.99554 1.18717e-08 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
31.285801 268.286011 38.285801 272.286011 setbbox
32.285801 270.286011 moveto
31.285801 272.286011 lineto
38.285801 270.286011 lineto
31.285801 268.286011 lineto
closepath
end
fill
grestore
[1.18717e-08 -0.99554 0.99554 1.18717e-08 -2.180612 162.883255] matrix \
invertmatrix concat
[0.99554 0 0 0.99554 -2.180612 162.883255] concat
gsave
newpath
systemdict
begin
270.286011 -32.285801 270.286011 -7.28581 setbbox
270.286011 -7.28581 moveto
270.286011 -32.285801 lineto
end
stroke
grestore
TailorGroupEnd
grestore
gsave
[1 0 0 -1 0 358] concat
grestore
%%Trailer
end
showpage
%%DocumentFonts: Times-Italic
%%+ Times-BoldItalic

%End of Graphics
MathPictureEnd
end
\
\>"], "Graphics",
 ImageSize->{298, 255},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell["\<\
Define fixed relationships between the frames of reference.   Note: these are \
different for different base orientations of the
 frames. \
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"B", ",", "b", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"C", ",", "c", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"n", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"N", ",", "n", ",", "a"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5184392415875998`*^9, 3.5184392460959997`*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "Ignore", " ", "the", " ", "errors", " ", "this", " ", "generates"}], ",", 
   " ", 
   RowBox[{"it", " ", "has", " ", "no", " ", 
    RowBox[{"effect", "."}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.5184395558747997`*^9, 3.5184395666856003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "Dot", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "3", "]"}]}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "3", "]"}]}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "3", "]"}]}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Protect", "[", "Dot", "]"}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "Cross", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"b", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"b", "[", "1", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"n", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"n", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"n", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"n", "[", "1", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"c", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"c", "[", "1", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"n", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"n", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"n", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"n", "[", "1", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"c", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"c", "[", "1", "]"}]}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"b", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"b", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "Cross", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5184391985004*^9, 3.5184392041632*^9}, {
  3.5195563197406*^9, 3.5195563197406*^9}},
 AspectRatioFixed->True],

Cell["Define the variable relationships between the frames.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"transform", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "//.", "\n", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"c", "[", "1", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", "\n", " ", 
     RowBox[{
      RowBox[{"c", "[", "2", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", "\n", " ", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Cos", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}]}], " ", "i"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "j"}]}]}], ",", " ", "\n",
      " ", 
     RowBox[{
      RowBox[{"b", "[", "2", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "j"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "i"}]}]}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.518439274722*^9, 3.518439274722*^9}},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Animation", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
For this animation we will draw two circles center at each end of the bar and \

two lines tangent to the circles to repesent the bar.  The we draw the lines \
connecting the box to the bar then we draw the box.  We then animate \
according to letting q1 and q2 be functions of time.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"thick", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"l1", " ", "+", " ", "l2"}], ")"}], "/", "10"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5184388277664003`*^9, 3.5184388405896*^9}, {
   3.5184388780296*^9, 3.518438892678*^9}, 3.5184391292208*^9},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{"(*", " ", 
   RowBox[{"circle", " ", "centers"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"xc0", "[", "t_", "]"}], "=", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{"l2", " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}], "//", 
     "distributeScalars"}]}], "\n", 
   RowBox[{
    RowBox[{"yc0", "[", "t_", "]"}], "=", 
    RowBox[{"transform", "[", 
     RowBox[{"l2", " ", 
      RowBox[{
       RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"xc1", "[", "t_", "]"}], "=", 
    RowBox[{"transform", "[", 
     RowBox[{
      RowBox[{"-", "l1"}], " ", 
      RowBox[{
       RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"yc1", "[", "t_", "]"}], "=", 
    RowBox[{"transform", "[", 
     RowBox[{
      RowBox[{"-", "l1"}], " ", 
      RowBox[{
       RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5184388277664003`*^9, 3.5184388405896*^9}, {
  3.5184388780296*^9, 3.518438892678*^9}, {3.5184391292208*^9, 
  3.5184391790472*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "l2"}], " ", 
  RowBox[{"Cos", "[", 
   RowBox[{"q1", "[", "t", "]"}], "]"}]}]], "Output",
 CellChangeTimes->{{3.5184391677060003`*^9, 3.518439179328*^9}, 
   3.5184392963592*^9, 3.5184396222528*^9, 3.519556325731*^9, 
   3.536264367706421*^9}],

Cell[BoxData[
 RowBox[{"l2", " ", 
  RowBox[{"Sin", "[", 
   RowBox[{"q1", "[", "t", "]"}], "]"}]}]], "Output",
 CellChangeTimes->{{3.5184391677060003`*^9, 3.518439179328*^9}, 
   3.5184392963592*^9, 3.5184396222528*^9, 3.519556325731*^9, 
   3.5362643677083282`*^9}],

Cell[BoxData[
 RowBox[{"l1", " ", 
  RowBox[{"Cos", "[", 
   RowBox[{"q1", "[", "t", "]"}], "]"}]}]], "Output",
 CellChangeTimes->{{3.5184391677060003`*^9, 3.518439179328*^9}, 
   3.5184392963592*^9, 3.5184396222528*^9, 3.519556325731*^9, 
   3.5362643677096977`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "l1"}], " ", 
  RowBox[{"Sin", "[", 
   RowBox[{"q1", "[", "t", "]"}], "]"}]}]], "Output",
 CellChangeTimes->{{3.5184391677060003`*^9, 3.518439179328*^9}, 
   3.5184392963592*^9, 3.5184396222528*^9, 3.519556325731*^9, 
   3.5362643677110786`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"lower", " ", "line", " ", "points"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xl0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"l2", " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yl0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"l2", " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xl1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yl1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5184388277664003`*^9, 3.5184388405896*^9}, {
  3.5184388780296*^9, 3.518438892678*^9}, {3.5184391292208*^9, 
  3.5184391380192003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"upper", " ", "line", " ", "points"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xu0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"l2", " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yu0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"l2", " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xu1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yu1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"1", "/", "2"}], " ", "thick", " ", 
           RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5184388277664003`*^9, 3.5184388405896*^9}, {
  3.5184388780296*^9, 3.518438892678*^9}, {3.5184391292208*^9, 
  3.5184391408896*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Coordinates", " ", "for", " ", "connecting", " ", "members", " ", "and", 
    " ", "Box"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xblo", "[", "t_", "]"}], "=", 
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"-", "l1"}], " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yblo", "[", "t_", "]"}], "=", 
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"-", "l1"}], " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}]}], ";"}], "\n", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb2", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb2", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb3", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb3", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb4", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb4", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{"transform", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], " ", 
           RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
          RowBox[{"d2", " ", 
           RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxL", "/", "2"}], " ", 
           RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
          RowBox[{
           RowBox[{"boxH", "/", "2"}], " ", 
           RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//", 
      "distributeScalars"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5184388277664003`*^9, 3.5184388405896*^9}, {
  3.5184388780296*^9, 3.518438892678*^9}, {3.5184391292208*^9, 
  3.5184391408896*^9}},
 AspectRatioFixed->True],

Cell["Set the constants.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"l1", "=", "5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l2", "=", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"d1", "=", "2.5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"d2", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"boxH", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"boxL", "=", "3"}], ";"}]}], "Input"],

Cell["Do the animation with the angles prescribed as follows.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"q1", "[", "t_", "]"}], ":=", 
  RowBox[{".5", " ", "t"}]}], "\n", 
 RowBox[{
  RowBox[{"q2", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{"-", "1"}], " ", "t"}]}]}], "Input"],

Cell["Set the final time.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tf", "=", 
   RowBox[{"4", "Pi"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.518439614094*^9, 3.5184396533124*^9}}],

Cell["Finally animate.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Animate", "[", 
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Circle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xc0", "[", "t", "]"}], ",", 
             RowBox[{"yc0", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"thick", "/", "2"}]}], "]"}], ",", " ", "\n", "\t\t", 
         RowBox[{"Circle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xc1", "[", "t", "]"}], ",", 
             RowBox[{"yc1", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"thick", "/", "2"}]}], "]"}], ",", "  ", "\n", "\t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xl0", "[", "t", "]"}], ",", 
              RowBox[{"yl0", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
            "\t\t\t  ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xl1", "[", "t", "]"}], ",", 
              RowBox[{"yl1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
         " ", "\n", "\t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xu0", "[", "t", "]"}], ",", 
              RowBox[{"yu0", "[", "t", "]"}]}], "}"}], ",", "\n", "\t\t\t  ", 
            
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xu1", "[", "t", "]"}], ",", 
              RowBox[{"yu1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\n", "\n", "\t    ", 
         RowBox[{"(*", " ", 
          RowBox[{"draw", " ", "the", " ", "box", " ", "support"}], " ", 
          "*)"}], "\n", "\t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xblo", "[", "t", "]"}], ",", 
              RowBox[{"yblo", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
            "\t\t\t  ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb1", "[", "t", "]"}], ",", 
              RowBox[{"yb1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
         " ", "\n", "\t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xblo", "[", "t", "]"}], ",", 
              RowBox[{"yblo", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
            "\t\t\t  ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb4", "[", "t", "]"}], ",", 
              RowBox[{"yb4", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
         "\n", "\n", "\t\t", 
         RowBox[{"(*", " ", 
          RowBox[{"draw", " ", "the", " ", "box"}], " ", "*)"}], "\n", "\t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb1", "[", "t", "]"}], ",", 
              RowBox[{"yb1", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
            "\t\t\t  ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb2", "[", "t", "]"}], ",", 
              RowBox[{"yb2", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
         " ", "\n", "\t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb2", "[", "t", "]"}], ",", 
              RowBox[{"yb2", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
            "\t\t\t  ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb3", "[", "t", "]"}], ",", 
              RowBox[{"yb3", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
         " ", "\n", "\t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb3", "[", "t", "]"}], ",", 
              RowBox[{"yb3", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
            "\t\t\t  ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb4", "[", "t", "]"}], ",", 
              RowBox[{"yb4", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
         " ", "\n", " \t\t", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb4", "[", "t", "]"}], ",", 
              RowBox[{"yb4", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
            "\t\t\t  ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xb1", "[", "t", "]"}], ",", 
              RowBox[{"yb1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}]}], " ", 
        "\n", "\t   ", "}"}], "]"}], ",", "\n", "    ", 
      RowBox[{"Axes", "->", "True"}], ",", 
      RowBox[{"PlotRange", "->", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], "-", "l2"}], ",", 
           RowBox[{"l1", "+", "l2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], "-", "l2"}], ",", 
           RowBox[{"l1", "+", "l2"}]}], "}"}]}], "}"}]}], ",", "\n", "    ", 
      RowBox[{"AspectRatio", "->", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.5184386129244003`*^9, 3.5184386218632*^9}, {
  3.5184393239868*^9, 3.5184394562748003`*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`t$$ = 2.346623888182927, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`t$$], 0, 4 Pi}}, Typeset`size$$ = {
    360., {177., 181.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`t$115$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`t$$ = 0}, 
      "ControllerVariables" :> {
        Hold[$CellContext`t$$, $CellContext`t$115$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Show[
        Graphics[{
          Circle[{
            $CellContext`xc0[$CellContext`t$$], 
            $CellContext`yc0[$CellContext`t$$]}, $CellContext`thick/2], 
          Circle[{
            $CellContext`xc1[$CellContext`t$$], 
            $CellContext`yc1[$CellContext`t$$]}, $CellContext`thick/2], 
          Line[{{
             $CellContext`xl0[$CellContext`t$$], 
             $CellContext`yl0[$CellContext`t$$]}, {
             $CellContext`xl1[$CellContext`t$$], 
             $CellContext`yl1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xu0[$CellContext`t$$], 
             $CellContext`yu0[$CellContext`t$$]}, {
             $CellContext`xu1[$CellContext`t$$], 
             $CellContext`yu1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xblo[$CellContext`t$$], 
             $CellContext`yblo[$CellContext`t$$]}, {
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xblo[$CellContext`t$$], 
             $CellContext`yblo[$CellContext`t$$]}, {
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}, {
             $CellContext`xb2[$CellContext`t$$], 
             $CellContext`yb2[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb2[$CellContext`t$$], 
             $CellContext`yb2[$CellContext`t$$]}, {
             $CellContext`xb3[$CellContext`t$$], 
             $CellContext`yb3[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb3[$CellContext`t$$], 
             $CellContext`yb3[$CellContext`t$$]}, {
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}, {
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}}]}], Axes -> True, 
        PlotRange -> {{-$CellContext`l1 - $CellContext`l2, $CellContext`l1 + \
$CellContext`l2}, {-$CellContext`l1 - $CellContext`l2, $CellContext`l1 + \
$CellContext`l2}}, AspectRatio -> 1], 
      "Specifications" :> {{$CellContext`t$$, 0, 4 Pi, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}}, 
      "Options" :> {
       ControlType -> Animator, AppearanceElements -> None, DefaultBaseStyle -> 
        "Animate", DefaultLabelStyle -> "AnimateLabel", SynchronousUpdating -> 
        True, ShrinkingDelay -> 10.}, "DefaultOptions" :> {}],
     ImageSizeCache->{403., {213., 218.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Animate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.5184394634664*^9, {3.5184396283992*^9, 3.5184396557616*^9}, 
   3.519556336495*^9, 3.5362643679483023`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1350, 633},
WindowMargins->{{Automatic, 413}, {Automatic, 116}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 82, 2, 67, "Section",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[686, 28, 72, 0, 24, "Subsubsection"],
Cell[761, 30, 206, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[992, 39, 632, 13, 27, "Input"],
Cell[1627, 54, 166, 2, 20, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1842, 62, 43, 0, 24, "Subsubsection"],
Cell[1888, 64, 36481, 1239, 263, 32027, 1163, "GraphicsData", "PostScript", \
"Graphics"],
Cell[38372, 1305, 208, 6, 41, "Text",
 Evaluatable->False],
Cell[38583, 1313, 490, 13, 58, "Input"],
Cell[39076, 1328, 307, 8, 27, "Input"],
Cell[39386, 1338, 4867, 156, 598, "Input"],
Cell[44256, 1496, 69, 0, 26, "Text"],
Cell[44328, 1498, 1713, 51, 88, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46078, 1554, 80, 2, 24, "Subsubsection",
 Evaluatable->False],
Cell[46161, 1558, 353, 8, 41, "Text",
 Evaluatable->False],
Cell[46517, 1568, 318, 9, 27, "Input"],
Cell[CellGroupData[{
Cell[46860, 1581, 1176, 36, 103, "Input"],
Cell[48039, 1619, 283, 7, 27, "Output"],
Cell[48325, 1628, 267, 6, 27, "Output"],
Cell[48595, 1636, 267, 6, 27, "Output"],
Cell[48865, 1644, 285, 7, 27, "Output"]
}, Open  ]],
Cell[49165, 1654, 2207, 66, 88, "Input"],
Cell[51375, 1722, 2203, 66, 88, "Input"],
Cell[53581, 1790, 6345, 187, 253, "Input"],
Cell[59929, 1979, 34, 0, 26, "Text"],
Cell[59966, 1981, 337, 12, 103, "Input"],
Cell[60306, 1995, 71, 0, 26, "Text"],
Cell[60380, 1997, 212, 7, 43, "Input"],
Cell[60595, 2006, 35, 0, 26, "Text"],
Cell[60633, 2008, 149, 4, 27, "Input"],
Cell[60785, 2014, 32, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[60842, 2018, 5678, 151, 448, "Input"],
Cell[66523, 2171, 4198, 89, 448, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
