(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    837406,      15624]
NotebookOptionsPosition[    825715,      15244]
NotebookOutlinePosition[    826086,      15260]
CellTagsIndexPosition[    826043,      15257]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Introduction to Mathematica", "Title"],

Cell["In this notebook we explore basic Mathematica", "Text"],

Cell[CellGroupData[{

Cell["Mathematica Basics", "Subtitle"],

Cell["\<\
Mathematica is a very poweful tool for analyis of engineering systems.  Its \
notebook interface provides a convenient means to arrange the analysis at \
hand.  Mathematica provides many mechanisms for interacting with other \
analysis packages, but is really a self contained environment.   In this \
notebook we hope to present some of the tool's usefulness to undergraduate \
mechanical engineers.\
\>", "Text"],

Cell["\<\
The first thing we describe are open and closed cells.  A cell is closed when \
the blue bars on the right look as follow:\
\>", "Text"],

Cell[CellGroupData[{

Cell["A closed cell", "Subsubtitle"],

Cell["\<\
A closed cell.  You can close it by double clicking the blue middle bracket.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["An open cell", "Subsubtitle"],

Cell["\<\
A cell can be opened or closed by double-clicking the bracket at various \
levels.  The bracket nearest the text is not collapsable.  Brackets outside \
of these are collapsable.

As a test, double-click the second bracket to the right.  Then double-click \
it back open.

Now double-click the 3rd bracket to the right, then the outer-most bracket.  \
Be sure to open them back up.\
\>", "Text"],

Cell["As you can see there can be many levels of cell nesting.", "Text"],

Cell["\<\
Mathematica is also happy to work with symbols in the text, as I am writing, \
or in evaluation cells described below.  If I wanted to cuss in GREEK I might \
say \[Pi]\[Alpha]\[Beta]\[Eta]\[Zeta]\[Mu]\[Xi]!!!\
\>", "Text"],

Cell["\<\
I can also draw pictures an include them right along with everything else.\
\>", "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 0.459677
200 dict begin
MathPictureStart
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 248 114 0 0 ]
] MathScale
% Start of Graphics
%!PS-Adobe-2.0 EPSF-2.0
%%Title: 
%%Creator: Tailor
%%CreationDate: Wed Jan 26 11:47:48 2000
%%For: alan
%%DocumentFonts: (atend)
%%Pages: 0 0
%%BoundingBox: 0 0 248 114
%%NXNextStepVersion: 3.0
%%EndComments

%%BeginProcSet: /usr/lib/NextStep/printPackage.ps 3.0
%!
% NeXT Printing Package
% Version: 3.1
% Copyright: 1988, NeXT, Inc.

/__NXdef{1 index where{pop pop pop}{def}ifelse}bind def
/__NXbdef{1 index where{pop pop pop}{bind def}ifelse}bind def
/UserObjects 10 array __NXdef
/defineuserobject{
\texch dup 1 add dup UserObjects length gt{
\t\tarray dup 0 UserObjects putinterval
\t\t/UserObjects exch def
\t}{pop}ifelse UserObjects exch 3 -1 roll put
}__NXbdef
/undefineuserobject{UserObjects exch null put}__NXbdef
/execuserobject{UserObjects exch get exec}__NXbdef
/__NXRectPath{4 2 roll moveto 1 index 0 rlineto
0 exch rlineto neg 0 rlineto closepath}__NXbdef
/__NXProcessRectArgs{
\t1 index type /arraytype eq{
\t\texch 0 4 2 index length 1 sub{
\t\t\tdup 3 add 1 exch{1 index exch get exch}for
\t\t\t5 1 roll 5 index exec
\t\t}for pop pop
\t}{exec}ifelse
}__NXbdef
/rectfill{gsave newpath {__NXRectPath fill} __NXProcessRectArgs \
grestore}__NXbdef
/rectclip{newpath {__NXRectPath} __NXProcessRectArgs clip newpath}__NXbdef
/rectstroke{
\tgsave newpath dup type /arraytype eq{dup length 6 eq}{false}ifelse{
\t\t{gsave __NXRectPath null concat stroke grestore}
\t\tdup length array cvx copy dup 2 4 -1 roll put __NXProcessRectArgs
\t}{{__NXRectPath stroke} __NXProcessRectArgs}ifelse grestore
}__NXbdef
/_NXLevel2 systemdict /languagelevel known {languagelevel 2 ge}{false}ifelse \
__NXdef
/xyshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index 2 mul 1 add get add exch
\t\t3 index\t3 index 2 mul get add exch moveto pop
\t}for pop pop
}__NXbdef
/xshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\texch 3 index 3 index get add exch moveto pop
\t}for pop pop
}__NXbdef
/yshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index get add moveto pop
\t}for pop pop
}__NXbdef
/arct{arcto pop pop pop pop}__NXbdef
/setbbox{pop pop pop pop}__NXbdef
/ucache{}__NXbdef
/ucachestatus{mark 0 0 0 0 0}__NXbdef
/setucacheparams{cleartomark}__NXbdef
/uappend{systemdict begin cvx exec end}__NXbdef
/ueofill{gsave newpath uappend eofill grestore}__NXbdef
/ufill{gsave newpath uappend fill grestore}__NXbdef
/ustroke{
\tgsave newpath dup length 6 eq
\t{exch uappend concat}{uappend}ifelse
\tstroke grestore
}__NXbdef
/__NXustrokepathMatrix dup where {pop pop}{matrix def}ifelse
/ustrokepath{
\tnewpath dup length 6 eq{
\t\texch uappend __NXustrokepathMatrix currentmatrix exch concat
\t\tstrokepath setmatrix
\t}{uappend strokepath}ifelse
} __NXbdef
/upath{
\t[exch {/ucache cvx}if pathbbox /setbbox cvx
\t {/moveto cvx}{/lineto cvx}{/curveto cvx}{/closepath cvx}pathforall]cvx
} __NXbdef
/setstrokeadjust{pop}__NXbdef
/currentstrokeadjust{false}__NXbdef
/selectfont{exch findfont exch
dup type /arraytype eq {makefont}{scalefont}ifelse setfont}__NXbdef
/_NXCombineArrays{
\tcounttomark dup 2 add index dup length 3 -1 roll {
\t\t2 index length sub dup 4 1 roll 1 index exch 4 -1 roll putinterval exch
\t}repeat pop pop pop
}__NXbdef
/flushgraphics{}def
/setwindowtype{pop pop}def
/currentwindowtype{pop 0}def
/setalpha{pop}def
/currentalpha{1.0}def
/hidecursor{}def
/obscurecursor{}def
/revealcursor{}def
/setcursor{4 {pop}repeat}bind def
/showcursor{}def
/NextStepEncoding where not{
/NextStepEncoding StandardEncoding 256 array copy def
0 [129/Agrave/Aacute/Acircumflex/Atilde/Adieresis/Aring/Ccedilla/Egrave
/Eacute/Ecircumflex/Edieresis/Igrave/Iacute/Icircumflex/Idieresis
/Eth/Ntilde/Ograve/Oacute/Ocircumflex/Otilde/Odieresis/Ugrave/Uacute
/Ucircumflex/Udieresis/Yacute/Thorn/mu/multiply/divide/copyright
176/registered 181/brokenbar 190/logicalnot 192/onesuperior 201/twosuperior
204/threesuperior 209/plusminus/onequarter/onehalf/threequarters/agrave
/aacute/acircumflex/atilde/adieresis/aring/ccedilla/egrave/eacute
/ecircumflex/edieresis/igrave 226/iacute 228/icircumflex/idieresis/eth
/ntilde 236/ograve/oacute/ocircumflex/otilde/odieresis 242/ugrave/uacute
/ucircumflex 246/udieresis/yacute 252/thorn/ydieresis]
{dup type /nametype eq
 {NextStepEncoding 2 index 2 index put pop 1 add}{exch pop}ifelse
}forall pop
/NextStepEncoding NextStepEncoding readonly def
/_NXfstr 128 string dup 0 (_NX) putinterval def
/_NXfindfont /findfont load def
/findfont{
 % Because we can never let NextStepEncoding get into
 % SharedFontDirectory, we cannot reencode a font to NextStepEncoding
 % if we are in shared mode.  So if currentshared is true,
 % we call the normal findfont and return that
 /currentshared where {pop currentshared} {false} ifelse
 {_NXfindfont}
 {dup _NXfstr 3 125 getinterval cvs length 3 add _NXfstr 0 3 -1 roll
  getinterval cvn exch FontDirectory 2 index known 
  {pop FontDirectory exch get}
  {_NXfindfont dup /Encoding get StandardEncoding eq
   {\tdup length dict exch
\t{1 index /FID ne {2 index 3 1 roll put}{pop pop}ifelse}forall
\t dup /Encoding NextStepEncoding put definefont
\t}{exch pop} ifelse
   }ifelse
 }ifelse
}bind def
}{pop}ifelse
/_NXImageString {/__NXImageString where{pop}{/__NXImageString 4000 string \
__NXdef}ifelse __NXImageString}__NXbdef
/_NXDoImageOp{
\t3 dict begin /parr 5 array def 1 index{dup}{1}ifelse /chans exch def
\tchans 2 add 2 roll parr 0 chans getinterval astore pop
\t5 index 4 index mul 2 index{1 sub 8 idiv 1 add mul}{mul 1 sub 8 idiv 1 \
add}ifelse
\t4 index mul /totbytes exch def pop exch pop
\tgsave matrix invertmatrix concat 0.5 setgray 0 0 4 2 roll rectfill grestore
\t{0 1 chans 1 sub{parr exch get exec length totbytes exch sub /totbytes exch \
def}for totbytes 0 le{exit}if}loop end
}__NXbdef
/alphaimage{1 add _NXDoImageOp}def
_NXLevel2{ 
\t/NXCalibratedRGBColorSpace where{pop}{
\t\t/NXCalibratedRGBColorSpace
\t\t{mark /NXCalibratedRGB /ColorSpace findresource exch pop}stopped
\t\t{cleartomark /NXCalibratedRGB[/CIEBasedABC 2 dict dup begin 
\t\t/MatrixLMN[.4124 .2126 .0193 .3576 .7152 .1192 .1805 .0722 .9505]def
\t\t/WhitePoint[.9505 1 1.089] def end] /ColorSpace defineresource}if \
def}ifelse
\t/nxsetrgbcolor{NXCalibratedRGBColorSpace setcolorspace setcolor}__NXbdef
\t/nxsetgray{dup dup nxsetrgbcolor}__NXbdef
\t/_NXCalibratedImage{exch{array astore dup length true}{false}ifelse
\t\t8 -1 roll{NXCalibratedRGBColorSpace setcolorspace}if
\t\t8 dict dup 9 1 roll begin /ImageType 1 def /MultipleDataSources exch def
\t\tcurrentcolorspace 0 get /Indexed eq{pop /Decode[0 2 6 index exp 1 \
sub]def}
\t\t{2 mul dup array /Decode exch def 1 sub 0 1 3 -1 roll{Decode exch dup 2 \
mod put}for}ifelse
\t\t/DataSource exch def /ImageMatrix exch def 
\t\t/BitsPerComponent exch def /Height exch def /Width exch def end \
image}__NXbdef
} {
\t/setcmykcolor{
\t\t1.0 exch sub dup dup 6 -1 roll sub dup 0 lt{pop 0}if 5 1 roll
\t\t4 -1 roll sub dup 0 lt{pop 0}if 3 1 roll exch sub dup 0 lt{pop 0}if \
setrgbcolor}__NXbdef
\t/currentcmykcolor{currentrgbcolor 3{1.0 exch sub 3 1 roll}repeat 0}__NXbdef
\t/colorimage{2 copy 3 ne or{_NXDoImageOp}{4 index dup 8 ne exch 4 ne \
and{_NXDoImageOp}{
\t\tpop pop save 6 1 roll 12 dict begin/Proc exch def/Res 0 string def
\t\t/Alloc{2 index length mul 2 add dup 2 index load length gt{1.2 mul round \
cvi string def}{pop pop}ifelse}def
\t\t1 index 8 eq{/Unpack{.34 Alloc}def}{
\t\t\t/Wid 4 index 3 mul def exch pop 8 exch/Str1 0 string def/Lim Wid def
\t\t\t/Unpack{.67 Alloc/Str1 2 Alloc 0 exch Lim exch
\t\t\t\t{dup -4 bitshift 17 mul Str1 exch 4 index exch put 15 and 17 mul Str1 \
exch 3 index 1 add exch put
\t\t\t\t2 sub dup 0 le{0 lt Wid exch{exch 1 sub exch}if}if exch 2 add exch
\t\t\t\t}forall/Lim exch def Str1 exch 0 exch getinterval
\t\t\t}def
\t\t}ifelse
\t\t/Ops[{.3 mul add 1}{.59 mul add 2}{.11 mul add round cvi Res exch 2 index \
exch put 1 add 0.0 0}]def/Val 0.0 def/Phase 0 def
\t\t{0 Val Phase Proc/Res Unpack{exch Ops exch get exec}forall/Phase exch \
def/Val exch def Res exch 0 exch getinterval}
\t\timage end restore}ifelse}ifelse
\t}__NXbdef
\t/nxsetrgbcolor{setrgbcolor}__NXbdef /nxsetgray{setgray}__NXbdef
\t/setpattern{pop .5 setgray}__NXbdef
\t/_NXCalibratedImage{dup 1 eq {pop pop image}{colorimage}ifelse pop}__NXbdef
} ifelse
/_NXSetCMYKOrRGB where{pop}{
\tmark{systemdict /currentwindow get exec}stopped
\t{{pop pop pop setcmykcolor}}{{nxsetrgbcolor pop pop pop pop}}ifelse \
/_NXSetCMYKOrRGB exch def cleartomark
}ifelse
%%EndProcSet

%%BeginResource: procset (Tailor 2.0)
/TailorDict 10 dict def TailorDict begin
/TailorGroupBegin {pop} def /TailorGroupEnd {} def
/TailorBlockBegin {pop pop pop} def /TailorBlockEnd {} def
/TailorSetUniformStroke {pop} def
/setoverprint where {pop} {/setoverprint {pop} def} ifelse
end
%%EndResource

gsave
 /__NXbasematrix matrix currentmatrix def
grestore
%%EndProlog
%%BeginSetup
TailorDict begin
%%EndSetup
0 0 248 114 rectclip
0 0 248 114 rectclip
gsave
0 setgray
1 setlinewidth
[1 0 0 1 0 0] matrix invertmatrix concat
[0.999978 0 0 -0.999978 9.074997 64.260986] concat
0.15 setlinewidth
gsave
newpath
systemdict
begin
6.79493e-06 -1.19209e-06 58.001301 58.001301 setbbox
58.001301 29.000601 moveto
58.001301 45.008999 45.008999 58.001301 29.000601 58.001301 curveto
12.9923 58.001301 6.79493e-06 45.008999 6.79493e-06 29.000601 curveto
6.79493e-06 12.9923 12.9923 -1.19209e-06 29.000601 -1.19209e-06 curveto
45.008999 -1.19209e-06 58.001301 12.9923 58.001301 29.000601 curveto
end
stroke
grestore
[0.999978 0 0 -0.999978 9.074997 64.260986] matrix invertmatrix concat
[0.999978 0 0 -0.999978 136.074997 64.260986] concat
gsave
newpath
systemdict
begin
0 -1.19209e-06 58.001301 58.001301 setbbox
58.001301 29.000601 moveto
58.001301 45.008999 45.008999 58.001301 29.000601 58.001301 curveto
12.9923 58.001301 0 45.008999 0 29.000601 curveto
0 12.9923 12.9923 -1.19209e-06 29.000601 -1.19209e-06 curveto
45.008999 -1.19209e-06 58.001301 12.9923 58.001301 29.000601 curveto
end
stroke
grestore
[0.999978 0 0 -0.999978 136.074997 64.260986] matrix invertmatrix concat
[1 0 0 -1 0.074997 76.260986] concat
gsave
newpath
systemdict
begin
0 0 246 12 setbbox
0 0 moveto
246 0 lineto
246 12 lineto
0 12 lineto
closepath
end
stroke
grestore
[1 0 0 -1 0.074997 76.260986] matrix invertmatrix concat
[1 0 0 -1 31.074997 43.260986] concat
gsave
newpath
systemdict
begin
0 0 13 13 setbbox
0 0 moveto
13 0 lineto
13 13 lineto
0 13 lineto
closepath
end
stroke
grestore
[1 0 0 -1 31.074997 43.260986] matrix invertmatrix concat
[1 0 0 -1 158.074997 42.260986] concat
gsave
newpath
systemdict
begin
0 0 13 13 setbbox
0 0 moveto
13 0 lineto
13 13 lineto
0 13 lineto
closepath
end
stroke
grestore
[1 0 0 -1 158.074997 42.260986] matrix invertmatrix concat
[8 0 0 -8 34.074997 40.260986] concat
gsave
newpath
systemdict
begin
0 0 1 1 setbbox
1 0.5 moveto
1 0.775999 0.775999 1 0.5 1 curveto
0.224001 1 0 0.775999 0 0.5 curveto
0 0.224001 0.224001 0 0.5 0 curveto
0.775999 0 1 0.224001 1 0.5 curveto
end
fill
grestore
[8 0 0 -8 34.074997 40.260986] matrix invertmatrix concat
[1 0 0 -1 34.074997 40.260986] concat
gsave
newpath
systemdict
begin
0 0 8 8 setbbox
8 4 moveto
8 6.20799 6.20799 8 4 8 curveto
1.79201 8 0 6.20799 0 4 curveto
0 1.79201 1.79201 0 4 0 curveto
6.20799 0 8 1.79201 8 4 curveto
end
stroke
grestore
[1 0 0 -1 34.074997 40.260986] matrix invertmatrix concat
[8 0 0 -8 161.074997 39.260986] concat
gsave
newpath
systemdict
begin
0 0 1 1 setbbox
1 0.5 moveto
1 0.775999 0.776001 1 0.5 1 curveto
0.223999 1 0 0.775999 0 0.5 curveto
0 0.224001 0.223999 0 0.5 0 curveto
0.776001 0 1 0.224001 1 0.5 curveto
end
fill
grestore
[8 0 0 -8 161.074997 39.260986] matrix invertmatrix concat
[1 0 0 -1 161.074997 39.260986] concat
gsave
newpath
systemdict
begin
0 0 8 8 setbbox
8 4 moveto
8 6.20799 6.20801 8 4 8 curveto
1.79199 8 0 6.20799 0 4 curveto
0 1.79201 1.79199 0 4 0 curveto
6.20801 0 8 1.79201 8 4 curveto
end
stroke
grestore
[1 0 0 -1 161.074997 39.260986] matrix invertmatrix concat
[1 0 0 1 28.074997 22.260986] concat
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
[1 0 0 1 28.074997 22.260986] matrix invertmatrix concat
[1 0 0 1 32.074997 21.260986] concat
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
[1 0 0 1 32.074997 21.260986] matrix invertmatrix concat
[1 0 0 1 36.074997 21.260986] concat
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
[1 0 0 1 36.074997 21.260986] matrix invertmatrix concat
[1 0 0 1 40.074997 22.260986] concat
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
[1 0 0 1 40.074997 22.260986] matrix invertmatrix concat
[1 0 0 1 156.074997 20.260986] concat
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
[1 0 0 1 156.074997 20.260986] matrix invertmatrix concat
[1 0 0 1 160.074997 20.260986] concat
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
[1 0 0 1 160.074997 20.260986] matrix invertmatrix concat
[1 0 0 1 165.074997 20.260986] concat
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 4 8 setbbox
0 0 moveto
4 8 lineto
end
stroke
grestore
[1 0 0 1 165.074997 20.260986] matrix invertmatrix concat
[1 0 0 1 128.074997 78.260986] concat
gsave
newpath
systemdict
begin
0 0 0 29 setbbox
0 0 moveto
0 29 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
0 0 0 29 setbbox
0 0 moveto
0 29 lineto
end
stroke
grestore
[1 0 0 1 128.074997 78.260986] matrix invertmatrix concat
[1 0 0 1 100.074997 98.260986] concat
gsave
newpath
systemdict
begin
0 0 28 0 setbbox
0 0 moveto
28 0 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
18 -3 28 3 setbbox
28 0 moveto
18 3 lineto
21 0 lineto
18 -3 lineto
closepath
end
stroke
grestore
gsave
newpath
systemdict
begin
18 -3 28 3 setbbox
28 0 moveto
18 3 lineto
21 0 lineto
18 -3 lineto
closepath
end
fill
grestore
gsave
newpath
systemdict
begin
0 0 28 0 setbbox
0 0 moveto
28 0 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
18 -3 28 3 setbbox
28 0 moveto
18 3 lineto
21 0 lineto
18 -3 lineto
closepath
end
stroke
grestore
gsave
newpath
systemdict
begin
18 -3 28 3 setbbox
28 0 moveto
18 3 lineto
21 0 lineto
18 -3 lineto
closepath
end
fill
grestore
[1 0 0 1 100.074997 98.260986] matrix invertmatrix concat
[1 0 0 -1 109.074997 103.760986] concat
/Helvetica findfont 1 scalefont [12 0 0 -12 0 0] makefont
23
exch
defineuserobject
23 execuserobject setfont
0 0 moveto
(x) show
[1 0 0 -1 109.074997 103.760986] matrix invertmatrix concat
[0.925926 0 0 1 100.815994 83.260986] concat
gsave
newpath
systemdict
begin
1.46937e-06 0 1.46937e-06 29 setbbox
1.46937e-06 0 moveto
1.46937e-06 29 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
1.46937e-06 0 1.46937e-06 29 setbbox
1.46937e-06 0 moveto
1.46937e-06 29 lineto
end
stroke
grestore
[0.925926 0 0 1 100.815994 83.260986] matrix invertmatrix concat
[0.925926 0 0 1 93.40799 101.260986] concat
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
[0.925926 0 0 1 93.40799 101.260986] matrix invertmatrix concat
[0.925926 0 0 1 93.40799 96.260986] concat
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
[0.925926 0 0 1 93.40799 96.260986] matrix invertmatrix concat
[0.925926 0 0 1 93.40799 91.260986] concat
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
[0.925926 0 0 1 93.40799 91.260986] matrix invertmatrix concat
[0.925926 0 0 1 93.40799 86.260986] concat
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
[0.925926 0 0 1 93.40799 86.260986] matrix invertmatrix concat
[0.925926 0 0 1 93.40799 81.260986] concat
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
gsave
newpath
systemdict
begin
-4.06901e-07 0 8 7 setbbox
-4.06901e-07 0 moveto
8 7 lineto
end
stroke
grestore
[0.925926 0 0 1 93.40799 81.260986] matrix invertmatrix concat
[1 0 0 1 208.074997 0.260986] concat
gsave
newpath
systemdict
begin
0 0 0 56 setbbox
0 0 moveto
0 56 lineto
end
stroke
grestore
[1 0 0 1 208.074997 0.260986] matrix invertmatrix concat
[0 -1 1 0 208.074997 0.260986] concat
gsave
newpath
systemdict
begin
-10 -3 0 3 setbbox
0 0 moveto
-10 3 lineto
-7 0 lineto
-10 -3 lineto
closepath
end
stroke
grestore
gsave
newpath
systemdict
begin
-10 -3 0 3 setbbox
0 0 moveto
-10 3 lineto
-7 0 lineto
-10 -3 lineto
closepath
end
fill
grestore
[0 -1 1 0 208.074997 0.260986] matrix invertmatrix concat
[1 0 0 -1 215.074997 11.260986] concat
0 0 moveto
(g) show
[1 0 0 -1 215.074997 11.260986] matrix invertmatrix concat
[1 0 0 1 16.074997 14.260986] concat
gsave
newpath
systemdict
begin
0 22 42.870998 44 setbbox
0 22 moveto
0 34.144001 9.856 44 22 44 curveto
31.4695 44 39.876499 37.940498 42.870998 28.957001 curveto
end
stroke
grestore
[1 0 0 1 16.074997 14.260986] matrix invertmatrix concat
[0.316228 -0.948683 0.948683 0.316228 16.074997 14.260986] concat
gsave
newpath
systemdict
begin
-23.914 46.827999 -13.914 52.828098 setbbox
-13.914 49.828098 moveto
-23.914 52.828098 lineto
-20.914 49.828098 lineto
-23.914 46.827999 lineto
closepath
end
stroke
grestore
gsave
newpath
systemdict
begin
-23.914 46.827999 -13.914 52.828098 setbbox
-13.914 49.828098 moveto
-23.914 52.828098 lineto
-20.914 49.828098 lineto
-23.914 46.827999 lineto
closepath
end
fill
grestore
[0.316228 -0.948683 0.948683 0.316228 16.074997 14.260986] matrix \
invertmatrix concat
[1 0 0 1 143.074997 13.260986] concat
gsave
newpath
systemdict
begin
2.09399 21.084101 44 44 setbbox
2.09399 31.3675 moveto
5.72263 39.0784 13.478 44 22 44 curveto
34.144001 44 44 34.144001 44 22 curveto
44 21.694599 43.993698 21.389299 43.9809 21.084101 curveto
end
stroke
grestore
[1 0 0 1 143.074997 13.260986] matrix invertmatrix concat
[-0.425797 -0.904819 0.904819 -0.425797 143.074997 13.260986] concat
gsave
newpath
systemdict
begin
-39.273602 -14.4616 -29.2736 -8.46155 setbbox
-29.2736 -11.4615 moveto
-39.273499 -8.46155 lineto
-36.273499 -11.4616 lineto
-39.273602 -14.4616 lineto
closepath
end
stroke
grestore
gsave
newpath
systemdict
begin
-39.273602 -14.4616 -29.2736 -8.46155 setbbox
-29.2736 -11.4615 moveto
-39.273499 -8.46155 lineto
-36.273499 -11.4616 lineto
-39.273602 -14.4616 lineto
closepath
end
fill
grestore
grestore
gsave
[1 0 0 -1 0 114] concat
grestore
%%Trailer
end
showpage
%%DocumentFonts: Helvetica

%End of Graphics
MathPictureEnd
end
\
\>"], "Graphics",
 ImageSize->{248, 114},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzVWFtPU0EQ3p5L77TltIAUkIoCxttvICKtN7yGGEMAKxLhgWgAw6uJiT77
x/TH+CBv65w9M3v2zDlb2uCDPmy+ndmZb2b37G5nu94/2d877J8c7PY7vaP+
x/2D3eNO98MRqNycEOIM2lFR5HJC/pSOWJZCcPwhPbGUgQuyKE6hLUofmhBz
gEVoh4jzMq/0bemKANp7xFnQ5xUKMS2FK6QUkxDrndFvQxMeGAhfCh+00J2B
NgX6GbTbMfpTkZWQwoHYkQ64gSvqzyJuMZni58N4bujfBq8WSB1om4hk5SOq
uKKJ0gLiKyZPxl7GDMaBbwnaBqLNKtIuI75gcjPTq4Ha64jPmdzMnEcdpRuI
T5kcZK4Red1EfMJkmkG4A2rYv4W4zmTTdgz7dxAfIY7pmXqomUBsZHg3tHUb
NQ+tPPQF6gZPNWXt6h7ZP4j9LJmZjBXs01o42sthXr3UHHimtQze+oBMe/E6
WzK1MJ6TadfKOxmvn+Ytp6zTma7FO9WSqYXRkmnrQrxBRqYTjLGVYmwNZrRk
2mS8gaydw1TTudxj7GXGWTX8S2yM264y2YHb3huBL8ve4PTCWRdSs7YwWqx5
jsVh+SzWdj5aeXckXvpud5lFCe9POm20TpUMVo9FJN/WuTlXLQyD2EdZk7/O
r75yPrXGQ/Izb1v+Lvx6+UNEKGv75JjpT5y2czcMP//2/IZYs3BXmH/W3TA8
d037D8eXtieu2yPwLMJa5pk/re01Jps8fO5XoYoknq4ec0LbkTjIrqfHXNAn
ObJ+IWnsCtx5aQ4P9FE/n8FRZRzzUDFTTlRZuKDrMDuzpuDfIuSgfUt1k6Mq
8SSHWTHxu2jOOEuP9emaYzPJYiD2GVg9B74Cnfh1nUle1+vEY1Z+dcbT1n5U
dz7DfBx1Gi/JuNYPDJ6G5okr92h2QtfRjtonVHUMYikgtoxozzVLWBMH0Piv
6KJRwxfQhu6ul4gl0I3BWlV0hNg30Jm5YBPzb+gT7avdQTtgwvBtgn0Fx8vQ
fw2tDjwNwBWjgglj07fbRLyMuKJqMgfeSY56Z4UINyqseTRO2GfyqnrTOcp3
D7GrXic+7HhfHCDeB10HMNydx4iwT8RvkQsffYrrl8z9c1KU3xm0zzjjTwP6
9NrsGLptfVZj3Y7e6RFOG2NvzBee1vajk5DQbSVYkvbbesxJ6P/HyOOwbwsD
oo/DPeNZMghkWZwmos8pOY4YGPVmMqqvb6bsqMn74uJzLzKrSkZWg2zeYmYl
tK0ZY7vqTnH0nRvq6P+XIui/GXIB/b8aujyL+8UY+8764WkRuT/BQdMd\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Some Quick Keyboard Shortcuts", "Subtitle",
 CellChangeTimes->{{3.5184414708431997`*^9, 3.5184414758196*^9}}],

Cell[TextData[{
 "To type special characters, such as greek letters and symbols, ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " uses the [esc] key. \[OpenCurlyDoubleQuote]\[AliasDelimiter]\
\[CloseCurlyDoubleQuote]\nGreek characters can by put in via the math \
palette, or by typing [esc] <the letter you wish to write> [esc]\nFor \
example:\n\[Beta] is [esc]b[esc]\n\[Alpha] is [esc]a[esc]\n\nYou can also do \
upper case letters.\n\[CapitalGamma] is [esc]G[esc] \n\[CapitalLambda] is \
[esc]L[esc]\n\nOther special symbols can by expressed in the same method. \n\
One example is the cross product \[Cross], [esc]cross[esc]\n\n",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " also allows you to add subscripts, superscripts, overscripts and such with \
quick keyboard shortcuts.\n",
 Cell[BoxData[
  FormBox[
   RowBox[{"Ctrl", "+", 
    RowBox[{"2", " ", "is", " ", "Square", " ", "Root", "                                                     ", 
     SqrtBox["A"]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{"Ctrl", "+"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "4 is underscript                                        ",
 Cell[BoxData[
  FormBox[
   UnderscriptBox["A", "B"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "\nCtrl+6 is superscript (or raise to the power)   A",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["", "B"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "\nCtrl+7 is overscript                                           ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["A", "B"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "\nCtrl+- or Ctrl+_ is subscript                             ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["A", "B"], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.5184414901716003`*^9, 3.5184415329468*^9}, {
  3.5184487262004004`*^9, 3.5184493279976*^9}, {3.5184493587608*^9, 
  3.5184493741892*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mathematica Operations", "Subtitle"],

Cell["\<\
Mathematica can operate on symbols and numerical data with ease.  In fact \
Mathematica can provide exact values for expressions or numerical values.  I \
can work with and exact expression:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", "=", "\[Pi]"}]], "Input",
 InitializationCell->False],

Cell[BoxData["\[Pi]"], "Output",
 CellChangeTimes->{3.5184408986507998`*^9, 3.5184409309428*^9}]
}, Open  ]],

Cell["\<\
Or I can work with a numerical approximation.\
\>", "Text",
 CellChangeTimes->{{3.5184413949024*^9, 3.5184413961348*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"y", "=", 
  RowBox[{"N", "[", "\[Pi]", "]"}]}]], "Input",
 CellChangeTimes->{{3.5184491860355997`*^9, 3.5184491871400003`*^9}}],

Cell[BoxData["3.141592653589793`"], "Output",
 CellChangeTimes->{3.5184408999611998`*^9, 3.5184409309896*^9}]
}, Open  ]],

Cell["\<\
Any function that requires on argument can be post-fixed to an operand.  For \
example the N[] function just used can also  be used like:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"z", "=", 
  RowBox[{"\[Pi]", "//", "N"}]}]], "Input"],

Cell[BoxData["3.141592653589793`"], "Output",
 CellChangeTimes->{3.5184409011312*^9, 3.5184409329708*^9}]
}, Open  ]],

Cell["\<\
When I use N[\[Pi]] I am using N[] in its pre-fix form.  

Any function that takes two arguments can be used in pre-fix notation or \
in-fix notation.  For example\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "=", 
  RowBox[{"Times", "[", 
   RowBox[{"c", ",", "b"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"b", " ", "c"}]], "Output",
 CellChangeTimes->{3.5184409032216*^9, 3.5184409339379997`*^9}]
}, Open  ]],

Cell["or", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "=", 
  RowBox[{"c", "~", "Times", "~", "b"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"b", " ", "c"}]], "Output",
 CellChangeTimes->{3.5184409049063997`*^9, 3.5184409357476*^9}]
}, Open  ]],

Cell["or just using the built in Times symbol (a space) ", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "=", " ", 
  RowBox[{"b", " ", "c"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"b", " ", "c"}]], "Output",
 CellChangeTimes->{3.5184409064664*^9, 3.5184409366991997`*^9}]
}, Open  ]],

Cell["or", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "=", 
  RowBox[{"b", "*", "c"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"b", " ", "c"}]], "Output",
 CellChangeTimes->{3.5184409076052*^9, 3.5184409382124*^9}]
}, Open  ]],

Cell["Division uses the Times operator as can be seen here:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{"aa", "/", "bb"}], "]"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Times", "[", 
    RowBox[{"aa", ",", 
     RowBox[{"Power", "[", 
      RowBox[{"bb", ",", 
       RowBox[{"-", "1"}]}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.518440908744*^9, 3.5184409388364*^9}]
}, Open  ]],

Cell["\<\
Various other operands are defined in a similar fashion, like Cross[], Dot[], \
etc.  They also have operator symbols like Times[] and division.  \
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functions Etc.", "Subtitle"],

Cell["\<\
Now we can talk about functions in Mathematica.  Assignment of a quantity to \
a symbol is done as shown above:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", "=", "\[Pi]"}]], "Input"],

Cell[BoxData["\[Pi]"], "Output",
 CellChangeTimes->{{3.5184409120512*^9, 3.5184409401935997`*^9}}]
}, Open  ]],

Cell["\<\
assigns the value of Pi to x.  However I might want to create a function of \
x.  I do this as follows:\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"x", "^", "2"}], " ", "+", " ", 
   RowBox[{"3", "x"}], " ", "+", " ", "2"}]}]], "Input"],

Cell["\<\
In this case x is internal to the function is not the value of Pi above.  \
However if I evaluate f[x] I will get f[\[Pi]].\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "x", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"2", "+", 
  RowBox[{"3", " ", "\[Pi]"}], "+", 
  SuperscriptBox["\[Pi]", "2"]}]], "Output",
 CellChangeTimes->{{3.5184409145004*^9, 3.5184409419407997`*^9}}]
}, Open  ]],

Cell["\<\
because Pi was assigned to x above.  I could also use anything in the \
argument list for f[].  For example\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "jane", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"2", "+", 
  RowBox[{"3", " ", "jane"}], "+", 
  SuperscriptBox["jane", "2"]}]], "Output",
 CellChangeTimes->{{3.5184409158264*^9, 3.5184409436412*^9}}]
}, Open  ]],

Cell["or", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "3", "]"}]], "Input"],

Cell[BoxData["20"], "Output",
 CellChangeTimes->{{3.5184409174488*^9, 3.5184409443276*^9}}]
}, Open  ]],

Cell["I can create a function of many variables as:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"x", " ", "y"}], " ", "+", " ", 
   RowBox[{"2", " ", "x"}], " ", "+", " ", 
   RowBox[{"3", " ", "y"}]}]}]], "Input"],

Cell["and", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"x", ",", "y"}], "]"}]], "Input"],

Cell[BoxData["25.577567669038324`"], "Output",
 CellChangeTimes->{3.5184409469172*^9}]
}, Open  ]],

Cell["because y was a numerical value above", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"x", ",", "3"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"9", "+", 
  RowBox[{"5", " ", "\[Pi]"}]}]], "Output",
 CellChangeTimes->{3.5184409481028*^9}]
}, Open  ]],

Cell["because exact values were used as the arguments.  Finally:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"l", ",", "m"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "l"}], "+", 
  RowBox[{"3", " ", "m"}], "+", 
  RowBox[{"l", " ", "m"}]}]], "Output",
 CellChangeTimes->{3.5184409496004*^9}]
}, Open  ]],

Cell["Now I am going to clear the values assigned to a,x,y,z:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "=."}], ";", 
  RowBox[{"x", "=."}], ";", 
  RowBox[{"y", "=."}], ";", 
  RowBox[{"z", "=."}], ";"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simple Manipulation", "Subtitle"],

Cell["\<\
Mathematica is simple to work with.  In this section we demonstrate some of \
the stuff we can do with the tool.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Plotting", "Subsubtitle"],

Cell["First we plot simple functions", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot1", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Sin", "[", "x", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{"2", " ", "Pi"}]}], "}"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwlmXk4lN/7x61ZUmaeISRF+0pKaaH7VEKRUqJFSFpIEhGSSiUk2SvZUpb4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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{0, 2 Pi}, {-0.9999998592131705, 0.9999998782112116}}, {{
     0, 6.283185307179586}, {-0.9999998592131705, 0.9999998782112116}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184409551696*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot2", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Cos", "[", "x", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{"2", " ", "Pi"}]}], "}"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw12Xk41N37B3C7GVsIM8gSKUnqydJCnTvtKtFCWVr0WJIUlXqkRdlKiz2p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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{0, 2 Pi}, {-0.9999998830731719, 0.9999999999999918}}, {{
     0, 6.283185307179586}, {-0.9999998830731719, 0.9999999999999918}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.518440957026*^9}]
}, Open  ]],

Cell["We can also put the two plots together.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"plot1", ",", "plot2"}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwlmXk4lN/7x61ZUmaeISRF+0pKaaH7VEKRUqJFSFpIEhGSSiUk2SvZUpb4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      "]]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw12Xk41N37B3C7GVsIM8gSKUnqydJCnTvtKtFCWVr0WJIUlXqkRdlKiz2p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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{0, 2 Pi}, {-0.9999998592131705, 0.9999998782112116}}, {{
     0, 6.283185307179586}, {-0.9999998592131705, 0.9999998782112116}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184409595064*^9}]
}, Open  ]],

Cell["We can also plot complicated functions", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot3", "=", 
  RowBox[{"Plot3D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", "x", "]"}], " ", 
     RowBox[{"Sin", "[", "y", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{"2", " ", "Pi"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", "0", ",", 
      RowBox[{"2", " ", "Pi"}]}], "}"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx1nXm8jtUWx0+UsYgy3AylVAoZksr0HpKh24AuKWOuhJspIZJMuTqh0tHV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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxFnHn8F9P3x2fmzvImlFSUSikiUraKREWylYRIJIXsWbJTicpSiOxrhexb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         "]], Polygon3DBox[CompressedData["
1:eJxFnAn4DtX7xmfemTnzjciSJEvI0kpSkj0U7QghyVZp1V5a0WJpU0mlXZui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         "]], Polygon3DBox[CompressedData["
1:eJwt1nnwVlMcx/H7e279nkqlzUgTaZNGSpEs2UY0ZEl7KZHJYEghyRayJFSi
lUpooxIttKNSKmpMWlBCpeIXyaTsr6/7/PF5nvN5n88599x7z3Jr97qrXZ9c
kiRDqDQN9ZMDdpdKki60JJ8kk7B71Q1Kk+QO7ANsIV2h3Jl6FyXJgzLTqI9c
X6wffSizmmYpL6ZVcqtlZtFDcg9jj9AKme+Lk2QqVs813sd28XtpFnYqtgzb
x/fQtip2Al+D5mn7KTXCT6ee6p71Xx+r6D4OyYyij/m1tEr5H6qjbrNcNyqv
TVWsGs2VWUztlG+gPsY8WGaia58tt127q/FJMV66ANuJdcCm8WOoCbYNuxQb
y79FrbBdWDdsJv+CPlP+B74HLXXNiVhpbB//tXt+E6srO1z5CnWD9THH/zt4
XqYMfYOVYG9Sf+UB2P30kczblFNOaau6PTJF+rtef5cq18Bu9H8S9hx2eeG9
xPv5kbYrz8U3aL9eX7uwzdhsbD22DhuL3Yk9gN2KLceW0U3Ke0plcynm1P54
J8pF/ovxOfHOlevlsolXhM3GNtDZfAtao2qL/9pYObkDMkNjHvEb6Xx1LWmD
3A7/n2FN/TejW7CR/sdQKW33arfFGKfLnEjF2H7sUVrJL/UMnvGu7+a/k5uJ
bde2rty/MZfpE6xz6WydlOcr0Lv5bB7FfPo71gutwf7Cuujn4sJ8jXn7Oj4n
njNtwXZj47GhfLU0W4PtjKMPnWYslfW1EG/OvxjPVHmH6/ym7hj+GfxcmR30
K1YWq0pHlL+Va4WPj7Z0kfJOOqyukszf2H7lzdgptAB7GmuhvJ0OqstjRXRA
+SusKb3HD6NuxvKFazQw5gu0+5d+ktsqs1rdhXwiV4Jti2eHXYT9RfuwL2Ld
Y+fzR2kP9jlWk+Zr92esf2xTPHu58/jbqQFWEXsfmyrXHzsLqx5rCGvBP493
Vd5kfKcYRsuY31gnbCNWCzsn1hXWHduKNcZu9j5GYD3SbP3GOu6Xz/a22OM6
uUbruDb2bOwRcqvkTlfXV38n0BCsOM32yxkxF7HJfIM028vWYa2wz/gSbdtj
l/Fn0DisFk3Elsk1xSbwdWkKtgJr4rrVtasfc9lYtsUeSbcZwwF8I9463i19
gjXj/6CefC/6J54RrYj75XfTR3KNsN+oK38mTVE+jebJfe66Z7puTf03xN6N
OSdzJW3iD8W+JteGr0pPYEma7QtTta2GPckXpdn5EOdEv9gnXfe4WDP4NP0f
H+sG262/a/DJMpXoTvXf57I9dJC2lbF+2A9YG+wpbHrcn7Z7sbXqLuFrxJpW
zqfZ3hh7ZAWspfI38c5j/cdaK86eeTz7IbGv8Y/L3qG/7nxbWmRsVfDBMjvj
HJSfIjM65kfh3uJ+Yz8cgz3E5wr3Oy7eW3H2DuNdjtTfRr6eXAXjOMgfwjtj
Y7FHC2OOORRn71uxF8Xap/uwydgMbGvMU7oLG4+Nwx7jyxTu91Wsuj6f5nfR
Pdh0bKTcjWl2lsWZ1p8/mcryJcZSoq6Ddi9jzytXp+FyHbGVcXZ5LgNjf485
HfuNPjsqr81lZ2mcqYepPbaIymFd4r3J/h57k7aNaJC+XsJ6pdkZGmfp7XKj
sFvS7LyMd94XOzaf7V2xhzWkh7X9He8gt0buGLmucabK/Sz3JdZMbrDcQbyt
3FIMSjrxk+XGp9m3xazCepuAvcCfSGOxgfwrNIKvSWPiPJSbhL3E16ZJ8R3D
N475q/+jLjCCNrhumXy2L8f+XIcGYq9io9PsOye+dxbpryzeXPkr7evJPcAX
57M9OPbiWjQA+0X2Wu0WpP8vr6RjPCv8klLZM41nWyW+I+hFgZMLe8n8eH6x
R6TZvI/5PwCbIjcfuyrmFvYT9itdxy/PZedcnHcNY+7zh13jKVqrr/L57ByK
86glNizmBdZT269z2f301rYi3jvN7q154V2+Ft8m2GVp9j0R3xVvYPP4Nmn2
3RHfH921PcI3pSVxhvL/ARVWZ1w=
         "]]}]}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0stKlGEYB/BnUrMmra7AwQGXtqhtbew0OTMgwyzEESKDSBe6CcwbKLsA
7QIqN65CBUlEZMYQEcXRTuYhwdbtWvd7Cb6P3/95+Z73xNc9MlEZz0TEG2//
hYiUH7BHqLZFXFfXmONT3uAY73CKJU6zxsH2iGd6x+RRvjc+Jc9zmgt8y0+c
4waXeMAG/16MOLZuSe++usAjdV+Lb9R3+YX3+JX3+S3tl9/5kD+YM9+Q3sO0
dxaM/5Qf8Sidk8cs8oQlnrLMX9xrjfht3bLes9THc/Uf8zbVZ6yzyUXW+YHL
nOVHvuaA+6jqfSlX+M74qDyT9sdXLHKSt/mcvXzCLr5wH7esW9R7LZ2PN9W7
vKreYSe32cEtXuEms/zMy8yb77F8SR5mw9ue9k1LxDp9Emt09Filq4gVeiJr
MJ/5/3/8A4cwRA4=
       "]]}, {
      Line3DBox[{1364, 1852, 1853, 1641, 846, 1640, 1588, 1876, 2129, 1520, 
       1365, 2001, 1521, 1366, 2002, 1522, 1367, 1970, 2003, 1523, 1642, 1958,
        2004, 1644, 1524, 1643, 2079, 1589, 1646, 1849, 1525, 1645, 1854, 
       1855, 1648, 1931, 2069, 1647, 1590, 1878, 2130, 1526, 1368, 2005, 1527,
        1369, 2006, 1528, 1370, 1971, 2007, 1529, 1649, 1959, 2008, 1651, 
       1530, 1650, 2080, 1591, 1653, 1850, 1531, 1652}], 
      Line3DBox[{1371, 1592, 1932, 2070, 1877, 1593, 855, 1372, 1903, 1904, 
       2141, 1532, 1373, 1972, 2009, 1533, 1785, 1973, 2010, 1786, 1534, 1654,
        2081, 1594, 1787, 1535, 1656, 2082, 1595, 1788, 1536, 1374, 1596, 
       1933, 2071, 1879, 1597, 1934, 2072, 1375, 1907, 1908, 2143, 1537, 1376,
        1659, 2011, 1538, 1789, 1974, 2012, 1790, 1539, 1660, 2084, 1598, 
       1791, 1540, 1662, 2085, 1599, 1792, 1541, 1377}], 
      Line3DBox[{1379, 1935, 2035, 1378, 1905, 1936, 2142, 1906, 1665, 1794, 
       862, 1793, 1975, 2013, 1796, 1542, 1668, 2087, 1655, 1798, 1543, 1670, 
       2088, 1657, 1800, 1544, 1380, 2083, 1658, 1545, 1381, 1937, 2036, 1382,
        1909, 1938, 2144, 1910, 1675, 1803, 1939, 2091, 1802, 1676, 1805, 
       1546, 1679, 2092, 1661, 1807, 1547, 1682, 2093, 1663, 1809, 1548, 1383,
        2086, 1664, 1549, 1384}], 
      Line3DBox[{1386, 1940, 2037, 1385, 1687, 1688, 2096, 1387, 1666, 1795, 
       1667, 2097, 1388, 1076, 1797, 1669, 1389, 2089, 1671, 1799, 1672, 1390,
        2090, 1673, 1801, 1674, 1391, 2014, 1550, 1392, 1941, 2038, 1393, 
       1694, 1695, 2098, 1394, 1677, 1804, 1678, 2099, 1395, 1680, 1806, 1681,
        1396, 2094, 1683, 1808, 1684, 1397, 2095, 1685, 1810, 1686, 1398, 
       2015, 1551, 1399}], 
      Line3DBox[{1401, 1702, 1703, 2100, 1400, 1689, 1811, 1690, 2101, 1402, 
       1691, 1812, 2039, 1976, 1403, 1977, 2122, 1813, 1692, 1404, 1099, 1814,
        1693, 1919, 1405, 1924, 2133, 1889, 1923, 1890, 1406, 2016, 1552, 
       1407, 1707, 1708, 2102, 1408, 1696, 1815, 1697, 2103, 1409, 1698, 1816,
        2040, 1978, 1410, 1699, 1817, 1700, 1411, 1979, 2123, 1818, 1701, 
       1920, 1412, 1926, 2135, 1892, 1925, 1893, 1413, 2017, 1553, 1414}], 
      Line3DBox[{1416, 1600, 1704, 1601, 2104, 1415, 1602, 1705, 971, 1417, 
       1706, 1819, 2041, 1980, 1418, 1982, 2042, 1714, 1419, 1997, 2134, 1891,
        685, 1420, 972, 1603, 1421, 2073, 1604, 1605, 1422, 1606, 1709, 1607, 
       2105, 1423, 1608, 1710, 977, 1424, 1711, 1820, 2043, 1981, 1425, 1718, 
       2044, 1719, 1426, 1998, 2136, 1894, 689, 1427, 978, 1609, 1428, 2074, 
       1610, 1611, 1429}], 
      Line3DBox[{106, 380, 766, 107, 767, 108, 768, 109, 769, 110, 770, 111, 
       771, 112, 1130, 384, 113, 386, 772, 114, 773, 115, 774, 116, 775, 117, 
       776, 118, 777, 119, 1134, 389, 120}], 
      Line3DBox[{1443, 1881, 1882, 1720, 991, 1442, 1615, 1871, 2126, 1963, 
       1441, 2052, 1945, 1440, 2051, 1944, 1439, 1984, 2050, 1722, 1438, 1962,
        2049, 1717, 1614, 1437, 987, 1716, 1859, 1858, 1436, 1856, 1857, 1715,
        986, 1435, 1613, 1870, 2125, 1961, 1434, 2048, 1943, 1433, 2047, 1942,
        1432, 1983, 2046, 1721, 1431, 1960, 2045, 1713, 1612, 1430, 982, 1712,
        1902, 1901, 1880}], 
      Line3DBox[{1444, 1883, 1884, 1724, 898, 1723, 1616, 1885, 2131, 1554, 
       1445, 2018, 1555, 1446, 2019, 1556, 1447, 1985, 2020, 1557, 1725, 1964,
        2021, 1727, 1558, 1726, 995, 1729, 1851, 1559, 1728, 1860, 1861, 1731,
        902, 1730, 1617, 1887, 2132, 1560, 1448, 2022, 1561, 1449, 2023, 1562,
        1450, 1986, 2024, 1563, 1732, 1965, 2025, 1734, 1564, 1733, 999, 1735,
        1873, 1565, 1872}], 
      Line3DBox[{1451, 1618, 1946, 2075, 1886, 1619, 907, 1452, 1911, 1912, 
       2145, 1566, 1453, 1987, 2026, 1567, 1821, 1988, 2027, 1822, 1568, 1736,
        1003, 1823, 1569, 1737, 2106, 1620, 1824, 1570, 1454, 1621, 1947, 
       2076, 1888, 1622, 910, 1455, 1915, 1916, 2147, 1571, 1456, 1740, 2028, 
       1572, 1825, 1989, 2029, 1826, 1573, 1741, 1009, 1827, 1574, 1742, 2108,
        1623, 1828, 1575, 1457}], 
      Line3DBox[{1459, 1948, 2053, 1458, 1913, 1949, 2146, 1914, 1745, 1830, 
       914, 1829, 1990, 2030, 1831, 1576, 1746, 1155, 1832, 1577, 1747, 2110, 
       1738, 1833, 1578, 1460, 2107, 1739, 1579, 1461, 1950, 2054, 1462, 1917,
        1951, 2148, 1918, 1748, 1835, 917, 1834, 1749, 1836, 1580, 1750, 1165,
        1837, 1581, 1751, 2112, 1743, 1838, 1582, 1463, 2109, 1744, 1583, 
       1464}], Line3DBox[{1466, 1952, 2055, 1465, 435, 2114, 1467, 421, 1193, 
       437}], Line3DBox[{1475, 1585, 2032, 1474, 434, 2113, 1473, 433, 1205, 
       446, 431, 444, 1203, 429, 1472, 2115, 442, 1471, 2056, 1953, 1470, 
       1584, 2031, 1469, 426, 2111, 1468, 425, 1196, 439, 423, 1176, 423}], 
      Line3DBox[{1477, 1763, 1764, 2116, 1476, 1752, 1839, 1753, 2117, 1478, 
       1754, 1840, 1195, 1479, 1991, 2124, 1841, 1755, 1480, 1199, 1842, 1756,
        1921, 1481, 1928, 2137, 1895, 1927, 1896, 1482, 2033, 1586, 1483, 
       1768, 1769, 2118, 1484, 1757, 1843, 1758, 2119, 1485, 1759, 1844, 1204,
        1486, 1760, 1845, 1761, 1487, 1206, 1846, 1762, 1922, 1488, 1930, 
       2139, 1898, 1929, 1899, 1489, 2034, 1587, 1490}], 
      Line3DBox[{1492, 1624, 1765, 1625, 2120, 1491, 1626, 1766, 1013, 1493, 
       1767, 1847, 2057, 1992, 1494, 1994, 2058, 1775, 1495, 1999, 2138, 1897,
        693, 1496, 1014, 1627, 1497, 2077, 1628, 1629, 1498, 1630, 1770, 1631,
        2121, 1499, 1632, 1771, 1019, 1500, 1772, 1848, 2059, 1993, 1501, 
       1779, 2060, 1780, 1502, 2000, 2140, 1900, 697, 1503, 1020, 1633, 1504, 
       2078, 1634, 1635, 1505}], 
      Line3DBox[{1519, 1868, 1869, 1781, 1033, 1518, 1639, 1875, 2128, 1969, 
       1517, 2068, 1957, 1516, 2067, 1956, 1515, 1996, 2066, 1784, 1514, 1968,
        2065, 1778, 1638, 1513, 1029, 1777, 1867, 1866, 1512, 1864, 1865, 
       1776, 1028, 1511, 1637, 1874, 2127, 1967, 1510, 2064, 1955, 1509, 2063,
        1954, 1508, 1995, 2062, 1783, 1507, 1966, 2061, 1774, 1636, 1506, 
       1024, 1773, 1863, 1862, 1782}]}, {
      Line3DBox[{699, 950, 847, 2129, 700, 959, 855, 721, 1345, 1346, 2142, 
       861, 729, 1091, 2096, 867, 737, 1092, 2101, 1109, 875, 745, 971, 1120, 
       883, 757, 2045, 983, 1256, 889, 767, 992, 899, 2131, 779, 1001, 907, 
       789, 1351, 1352, 2146, 913, 797, 1191, 2114, 919, 805, 1192, 2117, 
       1209, 927, 813, 1013, 1220, 935, 825, 2061, 1025, 1280, 941, 835}], 
      Line3DBox[{701, 848, 2001, 702, 1344, 856, 2141, 722, 1071, 1242, 862, 
       730, 1074, 2097, 1093, 868, 738, 2039, 1095, 1110, 876, 746, 2041, 
       1112, 1253, 884, 758, 2046, 1128, 890, 768, 900, 2018, 780, 1350, 908, 
       2145, 790, 1171, 1266, 914, 798, 1174, 1193, 920, 806, 1195, 1210, 928,
        814, 2057, 1212, 1277, 936, 826, 2062, 1228, 942, 836}], 
      Line3DBox[{703, 849, 2002, 704, 1049, 1050, 2009, 723, 1072, 1243, 1073,
        2013, 1244, 1076, 1094, 1077, 1250, 2122, 1097, 1111, 1098, 747, 2042,
        1121, 1254, 1122, 759, 2047, 891, 769, 901, 2019, 781, 1149, 1150, 
       2026, 791, 1172, 1267, 1173, 2030, 1268, 1176, 1194, 1177, 1274, 2124, 
       1197, 1211, 1198, 815, 2058, 1221, 1278, 1222, 827, 2063, 943, 837}], 
      Line3DBox[{705, 1036, 1037, 2003, 706, 1051, 1234, 1052, 2010, 1235, 
       1054, 1075, 2087, 1055, 1245, 1079, 2089, 1096, 1080, 1251, 1099, 1113,
        1100, 1327, 2134, 1324, 1325, 760, 2048, 892, 770, 1136, 1137, 2020, 
       782, 1151, 1258, 1152, 2027, 1259, 1154, 1175, 1155, 1269, 1179, 1196, 
       1180, 1275, 1199, 1213, 1200, 1337, 2138, 1334, 1335, 828, 2064, 944, 
       838}], Line3DBox[{707, 951, 1038, 952, 2004, 1040, 960, 1053, 2081, 
       961, 1236, 1057, 1078, 2088, 1058, 1246, 1081, 2090, 1082, 1356, 683, 
       2133, 1326, 1323, 748, 972, 1357, 973, 1304, 2125, 984, 985, 771, 993, 
       1138, 994, 2021, 1140, 1002, 1153, 1003, 1260, 1157, 1178, 2110, 1158, 
       1270, 1181, 2111, 1182, 1360, 691, 2137, 1336, 1333, 816, 1014, 1361, 
       1015, 1308, 2127, 1026, 1027, 839}], 
      Line3DBox[{708, 1312, 1313, 1039, 2079, 953, 1041, 962, 1056, 2082, 963,
        1237, 1059, 2083, 1060, 731, 869, 2014, 739, 877, 2016, 749, 974, 
       2073, 1303, 975, 1123, 986, 1129, 1290, 1289, 1130, 1295, 1296, 1139, 
       995, 1141, 1004, 1156, 2106, 1005, 1261, 1159, 2107, 1160, 799, 921, 
       2031, 807, 929, 2033, 817, 1016, 2077, 1307, 1017, 1223, 1028, 1229, 
       1322, 1321, 1311}], 
      Line3DBox[{8, 298, 1645, 23, 1374, 38, 1381, 53, 1392, 68, 1407, 83, 
       1422, 98, 1436, 383, 113, 396, 1728, 128, 1454, 143, 1461, 158, 1470, 
       173, 1483, 188, 1498, 203, 1512, 480, 218}], 
      Line3DBox[{710, 954, 851, 2130, 711, 965, 2072, 858, 725, 1348, 1349, 
       2144, 864, 733, 1101, 2098, 871, 741, 1102, 2103, 1115, 879, 751, 977, 
       1125, 886, 762, 2049, 988, 1257, 894, 773, 996, 903, 2132, 784, 1007, 
       910, 793, 1354, 1355, 2148, 916, 801, 1201, 2115, 923, 809, 1202, 2119,
        1215, 931, 819, 1019, 1225, 938, 830, 2065, 1030, 1281, 946, 841}], 
      Line3DBox[{712, 852, 2005, 713, 1347, 859, 2143, 726, 1083, 1247, 2091, 
       865, 734, 1084, 2099, 1103, 872, 742, 2040, 1104, 1116, 880, 752, 2043,
        1117, 1255, 887, 763, 2050, 1132, 895, 774, 904, 2022, 785, 1353, 911,
        2147, 794, 1183, 1271, 917, 802, 1184, 1203, 924, 810, 1204, 1216, 
       932, 820, 2059, 1217, 1279, 939, 831, 2066, 1231, 947, 842}], 
      Line3DBox[{714, 853, 2006, 715, 316, 2011, 727, 332, 1805, 501, 1806, 
       335, 510, 1817, 351, 753, 2044, 377, 764, 2051, 896, 775, 905, 2023, 
       786, 412, 2028, 795, 428, 1836, 533, 431, 542, 1845, 447, 821, 2060, 
       473, 832, 2067, 948, 843}], 
      Line3DBox[{716, 1043, 1044, 2007, 717, 1061, 1238, 1062, 2012, 1239, 
       1064, 1085, 2092, 1065, 1248, 1087, 2094, 1105, 1088, 1252, 2123, 1106,
        1118, 1107, 1332, 2136, 1329, 1330, 765, 2052, 897, 776, 1143, 1144, 
       2024, 787, 1161, 1262, 1162, 2029, 1263, 1164, 1185, 1165, 1272, 1187, 
       1205, 1188, 1276, 1206, 1218, 1207, 1342, 2140, 1339, 1340, 833, 2068, 
       949, 844}], 
      Line3DBox[{718, 955, 1045, 956, 2008, 1047, 966, 1063, 2084, 967, 1240, 
       1067, 1086, 2093, 1068, 1249, 1089, 2095, 1090, 1358, 687, 2135, 1331, 
       1328, 754, 978, 1359, 979, 1306, 2126, 989, 990, 777, 997, 1145, 998, 
       2025, 1147, 1008, 1163, 1009, 1264, 1167, 1186, 2112, 1168, 1273, 1189,
        2113, 1190, 1362, 695, 2139, 1341, 1338, 822, 1020, 1363, 1021, 1310, 
       2128, 1031, 1032, 845}], 
      Line3DBox[{719, 1287, 1288, 1046, 2080, 957, 1048, 968, 1066, 2085, 969,
        1241, 1069, 2086, 1070, 735, 873, 2015, 743, 881, 2017, 755, 980, 
       2074, 1305, 981, 1126, 991, 1133, 1292, 1291, 1134, 1299, 1300, 1146, 
       999, 1148, 1010, 1166, 2108, 1011, 1265, 1169, 2109, 1170, 803, 925, 
       2032, 811, 933, 2034, 823, 1022, 2078, 1309, 1023, 1226, 1033, 1232, 
       1302, 1301, 1233}], 
      Line3DBox[{834, 940, 1284, 1227, 1024, 824, 934, 1219, 2120, 1012, 812, 
       926, 2116, 1208, 804, 918, 2055, 796, 912, 2053, 788, 906, 2075, 1319, 
       1000, 778, 898, 1135, 1294, 1293, 766, 888, 1282, 1127, 982, 756, 882, 
       1119, 2104, 970, 744, 874, 2100, 1108, 736, 866, 2037, 728, 860, 2035, 
       720, 854, 2070, 1317, 958, 698, 846, 1035, 1286, 1285, 1034}], 
      Line3DBox[{840, 945, 1343, 1230, 1029, 829, 937, 1224, 2121, 1018, 818, 
       930, 2118, 1214, 808, 922, 2056, 800, 915, 2054, 792, 909, 2076, 1320, 
       1006, 783, 902, 1142, 1298, 1297, 772, 893, 1283, 1131, 987, 761, 885, 
       1124, 2105, 976, 750, 878, 2102, 1114, 740, 870, 2038, 732, 863, 2036, 
       724, 857, 2071, 1318, 964, 709, 850, 2069, 1042, 1316, 1315, 
       1314}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJx1fXVc1cvzPpjYLTbY3YqFrN15Rb12oGIXCnZjN4piX6/d3Z7FBFtBUSxE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    "]],
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->
   NCache[{{0, 2 Pi}, {0, 2 Pi}, {-0.9999999999999496, 
     0.9999999999999496}}, {{0, 6.283185307179586}, {
     0, 6.283185307179586}, {-0.9999999999999496, 0.9999999999999496}}],
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184409625952*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell["\<\
We can even animate graphics. The Animate function acts like a for loop, \
plotting whatever you put inside of it to the values you assign it.
Animate[ <<Stuff you want to animate goes here, for a plot, use Plot[], for \
most other things, use Show[Graphics[]]>>,<<The range of values to plot goes \
here, in the form {variable name, minumum value, maximum value}>>]\
\>", "Text",
 CellChangeTimes->{{3.5184411225576*^9, 3.5184412295892*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Animate", "[", 
  RowBox[{
   RowBox[{"Plot3D", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Sin", "[", "t", "]"}], " ", 
      RowBox[{"Sin", "[", "x", "]"}], " ", 
      RowBox[{"Sin", "[", "y", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"2", " ", "Pi"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "0", ",", 
       RowBox[{"2", " ", "Pi"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", 
     RowBox[{"2", "Pi"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5184409839516*^9, 3.5184411010764*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`t$$ = 1.4697621203077973`, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`t$$], 0, 2 Pi}}, Typeset`size$$ = {
    360., {142., 146.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`t$4752$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`t$$ = 0}, 
      "ControllerVariables" :> {
        Hold[$CellContext`t$$, $CellContext`t$4752$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      Plot3D[Sin[$CellContext`t$$] Sin[$CellContext`x] 
        Sin[$CellContext`y], {$CellContext`x, 0, 2 Pi}, {$CellContext`y, 0, 2 
         Pi}, PlotRange -> {-1, 1}], 
      "Specifications" :> {{$CellContext`t$$, 0, 2 Pi, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}}, 
      "Options" :> {
       ControlType -> Animator, AppearanceElements -> None, DefaultBaseStyle -> 
        "Animate", DefaultLabelStyle -> "AnimateLabel", SynchronousUpdating -> 
        True, ShrinkingDelay -> 10.}, "DefaultOptions" :> {}],
     ImageSizeCache->{409., {180., 185.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Animate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{{3.5184409694592*^9, 3.5184411017939997`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simple Algebra", "Subsubtitle"],

Cell["Here we do some algebra.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"poly", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"a", " ", "x"}], "+", " ", "b"}], ")"}], " ", 
   RowBox[{"(", " ", 
    RowBox[{
     RowBox[{"c", " ", 
      RowBox[{"x", "^", "2"}]}], " ", "+", "d"}], ")"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"b", "+", 
    RowBox[{"a", " ", "x"}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"d", "+", 
    RowBox[{"c", " ", 
     SuperscriptBox["x", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184412354704*^9}]
}, Open  ]],

Cell["Now expand the product:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", "poly", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"b", " ", "d"}], "+", 
  RowBox[{"a", " ", "d", " ", "x"}], "+", 
  RowBox[{"b", " ", "c", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"a", " ", "c", " ", 
   SuperscriptBox["x", "3"]}]}]], "Output",
 CellChangeTimes->{3.5184412364376*^9}]
}, Open  ]],

Cell["\<\
Put it back into simplest factors.  The % means to use the last output.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Factor", "[", "%", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"b", "+", 
    RowBox[{"a", " ", "x"}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"d", "+", 
    RowBox[{"c", " ", 
     SuperscriptBox["x", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184412376232*^9}]
}, Open  ]],

Cell["A new polynomial:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"poly", "=", 
  RowBox[{
   RowBox[{"3", " ", 
    RowBox[{"x", "^", "3"}]}], " ", "+", " ", 
   RowBox[{"2", " ", 
    RowBox[{"x", "^", "2"}]}], " ", "+", " ", 
   RowBox[{"3", " ", "x"}], " ", "+", " ", "4"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"4", "+", 
  RowBox[{"3", " ", "x"}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"3", " ", 
   SuperscriptBox["x", "3"]}]}]], "Output",
 CellChangeTimes->{{3.5184412388244*^9, 3.5184412402128*^9}}]
}, Open  ]],

Cell["Its real factors:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Factor", "[", "poly", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "+", "x"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"4", "-", "x", "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["x", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184412416012*^9}]
}, Open  ]],

Cell["It only real root.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindRoot", "[", 
  RowBox[{"poly", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", "\[Rule]", 
   RowBox[{"-", "1.0000000000000007`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5184412660776*^9}]
}, Open  ]],

Cell["All of the roots.  The == is the equation equality.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"poly", "==", "0"}], ",", "x"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         SqrtBox["47"]}]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         SqrtBox["47"]}]}], ")"}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5184412672788*^9}]
}, Open  ]],

Cell["A plot to see the real root.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"poly", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtlmk01Xsfxc0HccJBGcqsqCshKnp+X0PSoMzTQUKUiFREusVFCLnINVSS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-3, 3}, {-67.99999118367386, 111.99998824489842`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184412686516*^9}]
}, Open  ]],

Cell["The numerical solution to the roots:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NSolve", "[", 
  RowBox[{
   RowBox[{"poly", "==", "0"}], ",", "x"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"-", "1.`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"0.1666666666666667`", "\[VeryThinSpace]", "-", 
      RowBox[{"1.1426091000668408`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"0.1666666666666667`", "\[VeryThinSpace]", "+", 
      RowBox[{"1.1426091000668408`", " ", "\[ImaginaryI]"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5184412715064*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simple Calculus", "Subsubtitle"],

Cell["Here we show some calculus functions", "Text"],

Cell["Differentiation is easy, here is poly again:", "Text"],

Cell[CellGroupData[{

Cell[BoxData["poly"], "Input"],

Cell[BoxData[
 RowBox[{"4", "+", 
  RowBox[{"3", " ", "x"}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"3", " ", 
   SuperscriptBox["x", "3"]}]}]], "Output",
 CellChangeTimes->{3.5184412770288*^9}]
}, Open  ]],

Cell["It's derivative with respect to x:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{"poly", ",", "x"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"3", "+", 
  RowBox[{"4", " ", "x"}], "+", 
  RowBox[{"9", " ", 
   SuperscriptBox["x", "2"]}]}]], "Output",
 CellChangeTimes->{3.5184412788227997`*^9}]
}, Open  ]],

Cell["Its total derivative:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dt", "[", "poly", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   RowBox[{"Dt", "[", "x", "]"}]}], "+", 
  RowBox[{"4", " ", "x", " ", 
   RowBox[{"Dt", "[", "x", "]"}]}], "+", 
  RowBox[{"9", " ", 
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"Dt", "[", "x", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184412811472*^9}]
}, Open  ]],

Cell["It total time derivative", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dt", "[", 
  RowBox[{"poly", ",", "t"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   RowBox[{"Dt", "[", 
    RowBox[{"x", ",", "t"}], "]"}]}], "+", 
  RowBox[{"4", " ", "x", " ", 
   RowBox[{"Dt", "[", 
    RowBox[{"x", ",", "t"}], "]"}]}], "+", 
  RowBox[{"9", " ", 
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"Dt", "[", 
    RowBox[{"x", ",", "t"}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184412838772*^9}]
}, Open  ]],

Cell["\<\
We do not know x=x[t] so it the dervivatives with respect to t are left \
unevaluated.\
\>", "Text"],

Cell["\<\
I can also use the symbols for calculus operations.  Let g[x_]:=poly\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", "x_", "]"}], ":=", "poly"}]], "Input"],

Cell["It's derivative with respect to x:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[PartialD]", "x"], " ", 
  RowBox[{"g", "[", "x", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"3", "+", 
  RowBox[{"4", " ", "x"}], "+", 
  RowBox[{"9", " ", 
   SuperscriptBox["x", "2"]}]}]], "Output",
 CellChangeTimes->{3.5184413013024*^9}]
}, Open  ]],

Cell["Now lets integrate:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], "=", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{"g", "[", "x", "]"}], ",", "x"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"4", " ", "x"}], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox["x", "2"]}], "2"], "+", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["x", "3"]}], "3"], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox["x", "4"]}], "4"]}]], "Output",
 CellChangeTimes->{3.5184413030495996`*^9}]
}, Open  ]],

Cell["Here is the integral at a point", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "3", "]"}]], "Input"],

Cell[BoxData[
 FractionBox["417", "4"]], "Output",
 CellChangeTimes->{3.5184413052648*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtmHk81N/3x2fmjUFooYUiS4rRoiiVD3MRkn1J1kgqWaJSWZKlKJIkKcvH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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-3, 3}, {-2.416663409532368, 104.24998628571502`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413069652*^9}]
}, Open  ]],

Cell["Or", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], "=", 
  RowBox[{"\[Integral]", 
   RowBox[{
    RowBox[{"g", "[", "x", "]"}], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"4", " ", "x"}], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox["x", "2"]}], "2"], "+", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["x", "3"]}], "3"], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox["x", "4"]}], "4"]}]], "Output",
 CellChangeTimes->{3.5184413146872*^9}]
}, Open  ]],

Cell["again at a point", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "3", "]"}]], "Input"],

Cell[BoxData[
 FractionBox["417", "4"]], "Output",
 CellChangeTimes->{3.5184413166684*^9}]
}, Open  ]],

Cell["Definite integrals are written as:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{"g", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData["60"], "Output",
 CellChangeTimes->{3.518441318322*^9}]
}, Open  ]],

Cell["Or", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox["\[Integral]", 
   RowBox[{"-", "3"}], "3"], 
  RowBox[{
   RowBox[{"g", "[", "x", "]"}], 
   RowBox[{"\[DifferentialD]", "x"}]}]}]], "Input"],

Cell[BoxData["60"], "Output",
 CellChangeTimes->{3.518441321988*^9}]
}, Open  ]],

Cell["\<\
Mathematica knows how to integrate very complicated functions.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"\[Integral]", 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{"Tan", "[", "x", "]"}], "x", " ", 
     RowBox[{"y", "^", "2"}], 
     RowBox[{"\[DifferentialD]", "x"}], 
     RowBox[{"\[DifferentialD]", "y"}]}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "6"], " ", "\[ImaginaryI]", " ", 
  SuperscriptBox["y", "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"x", " ", 
     RowBox[{"(", 
      RowBox[{"x", "+", 
       RowBox[{"2", " ", "\[ImaginaryI]", " ", 
        RowBox[{"Log", "[", 
         RowBox[{"1", "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", "x"}]]}], "]"}]}]}], 
      ")"}]}], "+", 
    RowBox[{"PolyLog", "[", 
     RowBox[{"2", ",", 
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", "x"}]]}]}], "]"}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.5184413246868*^9}]
}, Open  ]],

Cell["Here is waht the real part looks like:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"Re", "[", "sol", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJysvXeYj0f3Py5ESwiiJEp0ISKR6ESMaNGCIMoTLXrvLXqUICS66IIoqxMt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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJw1nHnAVdP3xu98z7333PcUhZJZkcwl9I0ihJBUZJYKJUUZMyRjVGQeSoOx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         "]], 
        Polygon3DBox[CompressedData["
1:eJwtnAncVdMaxs/0nbP32fucY8hQ5iFkvKJJIZpMqQgZomigUWSoSOYhQ7lm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         "]], Polygon3DBox[CompressedData["
1:eJwt13u4llMaBvC32tXeu2/vTykqyWkUMQdM5JBkZwapqFSESEkqlQ6EShrG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         "]], 
        Polygon3DBox[{{3850, 2478, 2871, 1620, 1619, 3687}, {3545, 1686, 1647,
          2637, 2766, 3546}, {3689, 1865, 1864, 2872, 2481, 3851}, {3353, 
         2546, 2451, 1150, 1109, 3609}, {3698, 1696, 1779, 1097, 2336, 
         4078}, {3086, 2137, 2341, 3841, 2970, 2971}, {4028, 2329, 1094, 1711,
          1744, 3699}, {2987, 2986, 3875, 2779, 2780, 3876}, {3784, 2104, 
         1986, 1985, 2307, 3191}}]}]}, 
     {GrayLevel[0.82], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxFmH2Q1VUZx3/3d3/37t6X315wGtaEhV00QVghsmZqKUKagK1VZMlpEAUt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         "]], 
        Polygon3DBox[CompressedData["
1:eJwtl1mQFEUQhntnpnt2emd68AhQYZH1AhEBb10UcT04hBfUMDgERFh9EMQz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         "]], Polygon3DBox[CompressedData["
1:eJwlk0tIlFEYhr+c//9tZnJGI7AaLzNlOdVUVtCmi2TlOBBlNyILSxcSYSok
NNIERQMugha2yIoW4iJKl5VmLTKoRYvKGim7OxlYaRloUBH2HL7Fy3/e97zf
5XznP6Haxl0NGSKyAdggkCUSR/BnivhAk0+kGO0he9UYUpZIGG7NEslHm4d2
Bi0Nf+MW2UZsLlo9WjM8iPc2vj1oT9BC8G70InxptGngh48S/3eGyGdHZAQc
pq7LK7KAmBfw52AxvNcjctMlMgWfBEvQRog/QL7reFeQL4CWR3wl6+NoQ+TN
o+5cYrvxnUM/it5IXAfIQYuQqxCchUeI/4NnlaN9dqHVk2+dV/eNrw/ej6cE
tJJL8D1j3cleGd8HaCfQtsLLHV1H0Q+h2/BP5NmPtgytCS0BD5O/An4ePpvZ
V8LLwTj+MTBg5uPW85lz3sA3gb4DXs3Z1jCXuKO9mzMs5cyDeOrgxTPpyU/f
oIUcDehF6HM4RwHeHNZXLL2/1+xvQd9k6VxNzbvEveW7HX4VPYC/0Kt3bO56
vq177+AuMwO0CFoV2npHvSamA3032nt8Xvq7aGlt08MdagT5LoJfs3Q+abfe
k7mvbPQo2hD8I9jLutNSv4lbSL6n8IOmN87bT74Cvo/gyx2959PwRs6WgF8C
L5nbOL5S4i1m7gINzDGJfgTfFzyj4B6xK8nfat6Do/c9Ta218Gzih+nHQ0w7
+gD/8hj5UqxXo5WAXDxf0f8RUwr2cZff4D0giS+Tug6o8WkdUy/k0f8kh9go
+Qapm3L0TbSzdx89yX4zfCdnzDd3idbD3iSw0b8Td4F8x+BBzt5L621Z+r7M
O4uxb5MjTh8f3Ho3IVv/D/OfdPl0LmY+Mbjt17dQQ2wtCJP3B9plk5O5nYS/
wuf365w3e/V9m3d+Cx5Gn8LzC2Sat0ndU8SWMY/f9FeFnoBH8caIaaGfCuq0
mbkTO8H+T5BB7GNiN5I/zf4wqKO+Ra3/ZYeSRw==
         "]], 
        Polygon3DBox[{{3385, 1638, 1478, 2078, 2602, 3384}}]}]}, 
     {GrayLevel[0.82], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwtl3twltURxt98l7z5vi9folw6tcQggXLRBiJErKPWqQO0iqXgTIVinE7T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         "]], Polygon3DBox[CompressedData["
1:eJw1l3+wVVUVx/c975577jn33vOUBw6TCZgkiAEveAhM4G9MMI2YSQpB89kE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         "]], Polygon3DBox[CompressedData["
1:eJwt0l1MjmEcBvA7vW/1Vt6Yj0MtkoUItZxgw8yWhK3EifV20NiS2dSYPhhT
piHWSb5OJGw+ZnNgM1/DQWNTJgcObBw4cG4jH79nj4Nrz31dz/X/uP/3vyTT
vmP/tBBCJSQhMT2Ep77bUiG8hyR+ryiEu7khzGboTYTwuTCEibwQ6rJDOJYT
QhoqC0LIzg9hge8uvnd8pWIfiC2ltdA+0JbQCmEsK4Q2vJg+Kx3CgFqH8VZo
krdDrmtqrHTulH+Kr0KeEtjk/JKvS+M/xW2HK/q7DOto43ifc6NzGW87bz/e
Qe/17YES/27iv1Jxnlq+g3zH8VVq7IYj6lar36Pf+2Ie8nyEr+ZzQW8vzKHe
/wN6nRSXdtea6G7yldP+0ubQxnlb5OuVr5b/PE8+DKlXJN9M+VL4BnMox5vE
n1bvLL6M/ghvEFsFGdoXdafEroVcNYbUSKk3xNeajOcYzbNM7LhzM+25Ggvx
eeIb8EP0kzzXxRbTh71HhtboXzFPBW0S3xu9pdil+Fvewehd9HYV2vgS+Dl1
9/B18vfJOZqK59vN0wWP4UxufK8RnsW8A/gUXw/tNa2eNr8g7inqrQnv9y9L
/pAfn98k4t2KdizyRjFjtFP+/RF3Q85mfAu9mzaKv0vFO3HJeRhWiDuRjvcl
2ps1BfE9+mCENoM3JX51Or5LdKcMPkjP0UcyPz5PJOKdjnZ7J2z0Ns8S8W5G
O7rPGy0302/e/iJ8l6+Rvp7vDl8V3yL8Vm7c6ytaHe32/3lFczsa3ce+1Iif
a/Z5alfDJ/4fYjfLuTUZz/C3Xp/w/AOtRHOV
         "]], 
        Polygon3DBox[{{3390, 2606, 2865, 1947, 1946, 3391}, {3691, 1629, 1630,
          2873, 2555, 3860}}]}]}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwVzj1OAnEQQPExRinwK6GwMUELO+INvIExKqIigoiKLshCKEy8wR7AZG1s
bWy0MCGh1RN4IX4UL+/Nzmzy3+kMT9KFiDjG82LEvHe5IpJixIZ5ydzXZV3Q
qd7T3dWIonlfJ3pdH+jMvsE5v6Gnv/iFp5xxye2vzvXAv5vmDz3SW/pHj/X2
/E7/rUR8elNm/jcfcbUQcYoaznCOyVrEBddxiQbefbviJlq4Rhs3yO06fIs7
3OPQu7r8gEckmLrrcR9PGCDFECO82n8vR8wA6ewkwg==
       "]], 
      Line3DBox[{676, 2, 2276, 298, 1906, 1907, 1908, 1909, 1910, 3703, 1911, 
       1912, 1913, 1914, 3774, 1915, 1916, 1917, 1918, 1919, 1920, 3711, 1921,
        1922, 1923, 1924, 2919, 1925, 1926, 1927, 1928, 1929, 3727, 1930, 
       1931, 1932, 1933, 1934, 3729, 1710}], Line3DBox[{302, 3, 806, 1422}], 
      Line3DBox[{1969, 4, 2278, 302}], 
      Line3DBox[{1970, 5, 1714, 1715, 1716, 1717, 3723, 1718, 1719, 1720, 
       2905, 1721, 1722, 3744, 1723, 1724, 1725, 1726, 1727, 1728, 3712, 1729,
        2897, 1730, 1731, 1732, 1733, 1734, 1735, 1736, 3746, 1737, 1738, 
       1739, 1740, 1741, 1742, 2907, 1743, 3747, 1744, 1711}], 
      Line3DBox[{1971, 6, 307, 1970}], Line3DBox[{1972, 7, 310, 681, 1971}], 
      Line3DBox[{449, 8, 2287, 312, 1972}], Line3DBox[{450, 9, 2413, 449}], 
      Line3DBox[{316, 10, 862, 2414, 450}], Line3DBox[{1464, 11, 2291, 316}], 
      Line3DBox[{1978, 12, 1057, 2854, 1746, 1747, 1748, 1749, 1750, 3704, 
       1751, 1752, 2908, 1753, 1754, 1755, 1756, 3749, 1757, 1758, 1759, 1760,
        1761, 1762, 3750, 1763, 2889, 1764, 1765, 1766, 1767, 1768, 1769, 
       3751, 1770, 1771, 1772, 1773, 1774, 1775, 2895, 1776, 1777, 3728, 1778,
        1707}], Line3DBox[{1979, 13, 451, 1978}], 
      Line3DBox[{1980, 14, 813, 1425}], 
      Line3DBox[{892, 15, 815, 1844, 1845, 1846, 1847, 1848, 3763, 1849, 1850,
        1851, 1852, 3736, 1853, 1854, 1855, 1856, 1857, 1858, 3739, 1859, 
       1860, 1861, 1862, 2893, 1863, 1864, 1865, 1866, 1867, 3766, 1868, 1869,
        1870, 1871, 1872, 1873, 3731, 1712}], 
      Line3DBox[{740, 30, 3184, 321, 892}], Line3DBox[{745, 45, 3406, 740}], 
      Line3DBox[{2939, 60, 3411, 745}], Line3DBox[{2950, 75, 750, 2939}], 
      Line3DBox[{2965, 90, 754, 2950}], Line3DBox[{2990, 105, 2965}], 
      Line3DBox[{3002, 120, 2991, 2990}], Line3DBox[{3011, 135, 3002}], 
      Line3DBox[{760, 150, 3011}], Line3DBox[{3027, 165, 3423, 760}], 
      Line3DBox[{3037, 180, 765, 3027}], Line3DBox[{3051, 195, 770, 3037}], 
      Line3DBox[{2094, 212, 1008, 1442}], 
      Line3DBox[{906, 213, 429, 2095, 214, 2857, 1780, 1781, 1782, 1783, 3709,
        1784, 1785, 1786, 1787, 2911, 1788, 1789, 1790, 3754, 1791, 1792, 
       1793, 1794, 1795, 1796, 3755, 1797, 2892, 1798, 1799, 1800, 1801, 1802,
        1803, 1804, 3714, 1805, 1806, 1807, 1808, 1809, 2896, 1810, 1811, 
       3724, 1708}], 
      Line3DBox[{1482, 215, 2399, 431, 216, 2790, 1011, 432, 217, 2443, 483, 
       2096, 218, 436, 2097, 219, 438, 2709, 909, 220, 440, 2098, 221, 1813, 
       1814, 1815, 1816, 3726, 1817, 1818, 2891, 1819, 1820, 1821, 3759, 1822,
        1823, 1824, 1825, 1826, 1827, 3715, 1828, 2901, 1829, 1830, 1831, 
       1832, 1833, 1834, 1835, 1836, 3734, 1837, 1838, 1839, 1840, 1841, 2916,
        1842, 3706, 1706}], 
      Line3DBox[{2099, 222, 2407, 442, 223, 2795, 1019, 1443}], 
      Line3DBox[{911, 224, 2409, 445, 1936, 1937, 1938, 1939, 1940, 3710, 
       1941, 1942, 1943, 1944, 3779, 1945, 1946, 1947, 1948, 1949, 1950, 3716,
        1951, 1952, 1953, 1954, 2920, 1955, 1956, 1957, 1958, 3720, 1959, 
       1960, 1961, 1962, 1963, 1964, 3725, 1709}], 
      Line3DBox[{3065, 210, 803, 3051}], 
      Line3DBox[{912, 225, 857, 444, 3065}], Line3DBox[{1524, 320, 1980}], 
      Line3DBox[{1558, 426, 2094}], Line3DBox[{676, 1241}], 
      Line3DBox[{1244, 685, 1979}], 
      Line3DBox[{886, 1673, 1617, 1494, 1521, 1495, 3773, 1520, 1498, 1648, 
       1499, 3705, 1526, 1666, 1466, 1583, 1504, 1562, 3775, 1668, 1669, 1486,
        1468, 2899, 1586, 1620, 1619, 1593, 1563, 3776, 1595, 1615, 1594, 
       1700, 1601, 3777, 1935}], Line3DBox[{906, 1258}], 
      Line3DBox[{911, 1259}], 
      Line3DBox[{912, 1677, 1642, 1641, 1561, 1519, 3778, 1481, 1492, 1654, 
       1514, 3708, 1553, 1639, 1552, 1591, 1509, 1551, 3780, 1637, 1676, 1636,
        1546, 2900, 1590, 1613, 1544, 1579, 3781, 1545, 1612, 1631, 1611, 
       1475, 1577, 3782, 1965}], 
      Line3DBox[{1534, 1657, 1533, 1587, 1621, 1588, 3713, 1538, 1661, 1537, 
       1690, 1487, 1472, 2902, 1602, 3707, 1697, 1745}], 
      Line3DBox[{1603, 1705, 3772, 1905}], 
      Line3DBox[{1647, 1507, 1650, 1672, 1651, 3738, 1548, 2912, 1570, 1614, 
       1569, 1662, 1691, 1663, 1542, 3756, 1649, 1674, 1675, 1607, 1474, 2913,
        1576, 1704, 3757, 1812}], 
      Line3DBox[{1554, 1511, 1652, 1510, 3769, 1547, 1638, 1478, 1581, 1580, 
       1567, 3770, 1633, 1634, 1632, 1476, 2918, 1489, 1609, 1540, 1608, 3730,
        1541, 1606, 1627, 1605, 1699, 1603}], 
      Line3DBox[{2890, 1682, 1692, 1480, 1693, 3753, 1681, 1688, 1493, 1482}],
       Line3DBox[{1640, 1516, 1559, 1515, 3721, 1554}], 
      Line3DBox[{1618, 1497, 1525, 1484, 3717, 1465, 1503, 1644, 1645, 3764, 
       1531, 1656, 1530, 1585, 1506, 1535, 3765, 1660, 1689, 1659, 1536, 2917,
        1589, 1626, 1625, 1596, 1539, 3719, 1575, 1598, 1488, 1473, 1600, 
       1703, 3767, 1874}], 
      Line3DBox[{1684, 1502, 1643, 1680, 3740, 1485, 1467, 1505, 1470, 1667, 
       1646, 3737, 1529, 2909, 1568, 1574, 1471, 1622, 1624, 1623, 3733, 1565,
        1670, 1564, 1671, 1597, 1698, 2910, 1599, 1702, 3752, 1696, 1779}], 
      Line3DBox[{1543, 1635, 1477, 1490, 1616, 1578, 1566, 3761, 1628, 1629, 
       1630, 1610, 1701, 2903, 1604, 3762, 1843}], 
      Line3DBox[{1500, 1527, 3718, 1501, 1528, 1584, 1469, 1655, 1532, 3745, 
       1573, 2906, 1658, 1534}], 
      Line3DBox[{1582, 1555, 3722, 1513, 1479, 1491, 1549, 1665, 1550, 3760, 
       1508, 2915, 1664, 1543}], Line3DBox[{1572, 1463, 1523, 2898, 1500}], 
      Line3DBox[{1592, 1556, 2914, 1557, 1582}], 
      Line3DBox[{1647, 1686, 3742, 1687, 1653, 1512, 2890}], 
      Line3DBox[{1695, 1679, 1678, 3748, 1683, 1685, 2904, 1684}], 
      Line3DBox[{1496, 1462, 1969}], 
      Line3DBox[{1496, 1522, 1571, 3743, 1572}], 
      Line3DBox[{1464, 1694, 1695}], Line3DBox[{1518, 1483, 2099}], 
      Line3DBox[{1518, 1560, 1517, 3758, 1592}], Line3DBox[{1524, 1618}], 
      Line3DBox[{1558, 1640}]}, {}, {Line3DBox[{2921, 3673, 3773}], 
      Line3DBox[{2923, 774, 3705}], 
      Line3DBox[{2926, 3429, 3119, 3193, 3483, 3775}], 
      Line3DBox[{2939, 3432, 3133, 3205, 3132, 3980, 3851, 3689, 3684, 3211, 
       3766}], Line3DBox[{2950, 3435, 3141, 3212, 3140, 3322, 4021, 2949, 
       3342, 3605, 3731}], 
      Line3DBox[{2952, 3142, 3213, 3324, 3323, 4035, 2951, 3345, 3346, 3663}],
       Line3DBox[{2965, 3145, 3217, 3144, 3981, 2964, 3350, 3351, 3628}], 
      Line3DBox[{2968, 3554, 3900, 3084, 3555, 3607, 3622}], 
      Line3DBox[{2990, 3221, 3286, 3220, 3996, 2989, 3462, 3491, 3463, 3630}],
       Line3DBox[{2992, 3222, 3223, 3807, 3997, 3464, 3465, 3484, 3466, 
       3624}], Line3DBox[{3002, 3107, 3572, 3509, 4052, 3510, 3106, 3511, 
       3670}], Line3DBox[{3003, 3146, 3225, 3809, 3982, 3292, 3352, 3608, 
       3665}], Line3DBox[{3011, 3114, 3231, 3148, 3325, 4000, 3230, 3311, 
       3310, 3648}], 
      Line3DBox[{3012, 3436, 3149, 3232, 3312, 3983, 3849, 3294, 3354, 3610, 
       3732}], Line3DBox[{3027, 3439, 3163, 3243, 3162, 3987, 3853, 3379, 
       3686, 3253, 3781}], Line3DBox[{3037, 3441, 3172, 3254, 3171, 3780}], 
      Line3DBox[{3051, 3445, 3446, 3708}], Line3DBox[{3065, 3675, 3778}], 
      Line3DBox[{3184, 3077, 3763}], Line3DBox[{3269, 3674, 3768}], 
      Line3DBox[{3406, 741, 3736}], 
      Line3DBox[{3411, 3413, 3412, 3204, 3123, 3739}], 
      Line3DBox[{3423, 3425, 3424, 3242, 3152, 3326, 4002, 3241, 3318, 3317, 
       3782}], Line3DBox[{3430, 3530, 3124, 3194, 3125, 4020, 3850, 3687, 
       3683, 3282, 3776}], 
      Line3DBox[{3433, 3532, 3134, 3206, 3135, 3320, 4011, 3376, 3343, 3606, 
       3777}], Line3DBox[{3437, 3538, 3153, 3233, 3154, 4022, 3852, 3378, 
       3685, 3244, 3771}], Line3DBox[{3440, 3539, 3164, 3245, 3165, 3735}], 
      Line3DBox[{3442, 3543, 3544, 3741}], 
      Line3DBox[{3623, 3910, 3884, 3559, 3094, 3909, 3876, 2987, 3093, 3908, 
       2985, 3092, 3907, 2983, 3091, 3906, 2981, 3090, 3905, 2979, 2142, 3904,
        2977, 3089, 3903, 2975, 3088, 3902, 2973, 3087, 3901, 2971, 3086, 
       4075, 3589, 3219, 3458, 3085, 4074, 3671}], 
      Line3DBox[{3625, 3468, 3485, 4042, 3864, 3467, 3105, 3224, 3919, 3843, 
       3001, 3104, 3918, 3000, 3103, 3917, 2999, 3102, 3916, 2998, 2153, 2997,
        3960, 3808, 3915, 2996, 3101, 3914, 2995, 3100, 3913, 2994, 3099, 
       3598, 3912, 3881, 2993, 3098, 4070, 3571, 3506, 3507, 3097, 4013, 3508,
        3669}], 
      Line3DBox[{3627, 3348, 4029, 3347, 2953, 3143, 3214, 3944, 3831, 2954, 
       3840, 4012, 3284, 3216, 2955, 3795, 3945, 2956, 2129, 2957, 3899, 3796,
        3946, 2958, 3797, 3947, 2959, 3798, 3948, 2960, 3799, 3949, 2961, 
       3867, 4051, 3504, 3577, 3576, 2962, 3535, 3536, 4061, 3416, 3490, 3505,
        3489, 2963, 2539, 3349, 3664}], 
      Line3DBox[{3629, 3460, 3488, 3459, 2969, 3218, 3285, 3951, 3841, 2970, 
       3800, 3952, 2972, 3801, 3953, 2974, 3802, 3954, 2976, 2141, 3955, 2978,
        3803, 3956, 2980, 3804, 3957, 2982, 3805, 3958, 2984, 3806, 3959, 
       2986, 3875, 4073, 3586, 3558, 2988, 3877, 4068, 3569, 3560, 3668}], 
      Line3DBox[{3647, 3308, 3998, 3309, 3226, 3469, 3147, 3417, 4053, 3513, 
       3514, 3512, 3868, 3920, 3537, 3108, 3004, 3882, 3921, 3599, 3109, 3005,
        3922, 3110, 3006, 3923, 3810, 3961, 3007, 3811, 3962, 3008, 2162, 
       3009, 3924, 3111, 3010, 3844, 3925, 3228, 3112, 3227, 3832, 3926, 3229,
        3113, 3293, 4017, 3353, 3609, 3666}], 
      Line3DBox[{3667, 3557, 3568, 3556, 2966, 3874, 3950, 3585, 3553, 2967}],
       Line3DBox[{3672, 3095, 3461, 3842, 3911, 3590, 3096, 2991}], 
      Line3DBox[{3706, 3611, 4030, 3859, 3240, 3316, 3315, 3561, 3151, 4043, 
       3471, 3237, 3117, 3238, 3930, 3834, 3236, 2170, 3235, 3017, 3965, 3814,
        3016, 3964, 3813, 3015, 3963, 3812, 3929, 3014, 3116, 3928, 3013, 
       3115, 3591, 3516, 4054, 3517, 3519, 3518, 3421, 3927, 3833, 3418, 3515,
        3984, 3869, 3419, 3150, 3470, 3234, 3314, 3999, 3313, 3757}], 
      Line3DBox[{3712, 3301, 3196, 3825, 3893, 3198, 3302, 3303, 3197, 3991, 
       3121, 3279, 3081, 3278, 4010, 3200, 3082, 2927, 3894, 3786, 3935, 2928,
        3787, 3936, 2929, 3528, 3788, 4058, 3529, 3122, 3500, 4071, 3573, 
       3574, 3407, 3826, 3895, 3409, 3502, 3503, 3408, 3737}], 
      Line3DBox[{3715, 3329, 3036, 3169, 3252, 4023, 3837, 3328, 3035, 3836, 
       3971, 3251, 3168, 3034, 4004, 3257, 3256, 3033, 3970, 3818, 3032, 3969,
        3817, 3932, 3031, 3523, 3602, 3522, 4056, 3883, 3030, 3579, 3167, 
       3541, 2253, 3542, 3029, 3166, 3426, 4062, 3835, 3540, 3028, 3738}], 
      Line3DBox[{3723, 3297, 3068, 3180, 3821, 3886, 3182, 3479, 3069, 3564, 
       3865, 4045, 3480, 3449, 3584, 3070, 3273, 2286, 3783, 3988, 2922, 3183,
        3887, 3071, 3565, 3596, 3597, 3495, 3873, 4048, 3072, 3549, 3450, 
       3451, 3290, 4049, 3497, 3073, 3496, 3697, 3748}], 
      Line3DBox[{3726, 3335, 3334, 3061, 3839, 3978, 3265, 3398, 3397, 3060, 
       3493, 4047, 3866, 3476, 3588, 3587, 3059, 3848, 3977, 3272, 3058, 4007,
        3271, 3976, 3847, 3057, 3270, 3562, 3563, 4066, 3878, 3056, 3395, 
       3396, 3295, 3872, 4018, 3547, 3055, 3580, 3581, 3753}], 
      Line3DBox[{3733, 3131, 3291, 3130, 3979, 3431, 2938, 3129, 3410, 4059, 
       3827, 3531, 2937, 3575, 4072, 3499, 3501, 3498, 2936, 3939, 3791, 2935,
        3938, 3790, 2934, 3937, 3789, 3896, 2933, 3210, 3209, 3995, 2932, 
       3202, 3280, 3201, 3992, 2931, 3128, 3199, 2217, 3319, 2930, 3456, 4041,
        3127, 3551, 3126, 3746}], 
      Line3DBox[{3734, 3161, 3472, 3160, 3986, 3327, 3026, 3159, 3239, 2247, 
       3025, 4003, 3250, 3249, 3024, 4014, 3248, 3247, 3023, 3967, 3816, 3022,
        3966, 3815, 3931, 3021, 3601, 3600, 4076, 3020, 3521, 3592, 3520, 
       4055, 3593, 3019, 3578, 3158, 3422, 3157, 3985, 3438, 3018, 4039, 3156,
        3420, 3155, 3756}], 
      Line3DBox[{3740, 919, 3405, 3892, 3824, 3402, 918, 4050, 3403, 3118, 
       3526, 3080, 3891, 3494, 2925, 3934, 3785, 2924, 3989, 3784, 3191, 4009,
        3276, 3079, 3189, 4008, 3275, 3078, 3190, 3890, 3823, 3187, 502, 3188,
        3889, 3822, 3744}], 
      Line3DBox[{3742, 3545, 3546, 4063, 3427, 3173, 3041, 3443, 3444, 4040, 
       3428, 3583, 3582, 3042, 2826, 3595, 3594, 3525, 3043, 3933, 3819, 3973,
        3044, 3262, 3263, 4015, 3045, 3264, 3974, 3846, 3046, 3174, 3258, 
       3975, 3838, 3047, 3330, 3331, 4024, 3259, 3175, 3759}], 
      Line3DBox[{3747, 3699, 4028, 3344, 3377, 3321, 3136, 3552, 4065, 3828, 
       3457, 2940, 3829, 3994, 3208, 3137, 2941, 2332, 3215, 2942, 3897, 3083,
        2943, 3898, 3792, 3940, 2944, 3793, 3941, 2945, 3794, 3942, 2946, 
       3533, 3943, 3871, 2947, 3534, 3830, 4060, 3414, 3138, 2948, 3434, 2228,
        3415, 3139, 3486, 3487, 3858, 4078, 3698, 3752}]}, {
      Line3DBox[{1970, 2197, 2281, 2198, 3886, 2283, 2203, 2300, 2204, 3890, 
       2304, 2211, 2313, 3991, 2212, 2424, 2317, 3992, 2323, 2318, 2001, 2332,
        2430, 2333, 2011, 3945, 2128, 2021, 3953, 2139, 3902, 2033, 2149, 
       3913, 2045, 2832, 2833, 3921, 2834, 2835, 2735, 2737, 4054, 2736, 2823,
        2824, 2738, 4055, 2740, 2739, 2764, 2765, 2253, 2636, 2254, 2638, 
       2646, 4040, 2262, 2639, 2263, 2453, 4018, 2768, 2269, 2767, 2270, 
       2399}], Line3DBox[{1971, 2580, 2701, 2581, 2411, 2682, 2796, 2681, 
       4045, 2648, 2302, 2418, 4008, 2303, 1984, 2315, 2423, 4010, 2316, 1993,
        2325, 3995, 2427, 2326, 2002, 2120, 3897, 2012, 2129, 2022, 3954, 
       2140, 3903, 2034, 2150, 3914, 2046, 2158, 3922, 2056, 2165, 3928, 2064,
        2836, 4076, 2837, 2838, 2839, 2840, 4056, 2742, 2741, 2825, 2826, 
       2827, 2747, 2746, 2787, 4066, 2788, 2789, 2442, 2674, 2698, 2673, 
       2790}], Line3DBox[{1972, 2284, 2412, 2286, 1973, 2305, 2419, 4009, 
       2307, 1985, 2108, 3894, 1994, 2113, 3896, 2003, 2121, 3898, 2013, 2130,
        3899, 2023, 2141, 3904, 2035, 2151, 3915, 2047, 2159, 3923, 2057, 
       2166, 3929, 2065, 2171, 3931, 2073, 2177, 3932, 2081, 2184, 3933, 2089,
        3976, 2400, 2791, 2402, 2443}], 
      Line3DBox[{2096, 2191, 4007, 2401, 2090, 2185, 3973, 2082, 2178, 3969, 
       2074, 2172, 3966, 2066, 2167, 3963, 2058, 2160, 3961, 2048, 2152, 3960,
        2036, 2142, 3955, 2024, 2131, 3946, 2014, 2122, 3940, 2004, 2114, 
       3937, 1995, 2109, 3935, 1986, 2104, 3989, 2306, 1974, 2101, 3988, 2285,
        2287}], 
      Line3DBox[{2097, 2192, 2444, 2403, 3977, 2091, 2186, 2439, 4015, 2388, 
       2083, 2179, 3970, 2075, 2173, 3967, 2067, 2168, 3964, 2059, 2161, 3962,
        2049, 2153, 2037, 3905, 2143, 3956, 2025, 2132, 3947, 2015, 2123, 
       3941, 2005, 2115, 3938, 1996, 2110, 3936, 1987, 2105, 3934, 1975, 3887,
        2102, 2797, 2288, 2413}], 
      Line3DBox[{2098, 2193, 2405, 2271, 3978, 2093, 2188, 2391, 2264, 3975, 
       2085, 2181, 2381, 2255, 3971, 2077, 2175, 2371, 4003, 2370, 2069, 2170,
        2359, 2358, 2061, 3924, 2163, 2051, 3917, 2155, 2039, 3907, 2145, 
       3958, 2027, 2134, 3949, 2017, 2125, 2756, 2755, 3943, 2007, 2117, 2752,
        4072, 2719, 2814, 1998, 2813, 4071, 2812, 2620, 2213, 1989, 2718, 
       4050, 2717, 2616, 2205, 1977, 2716, 4049, 2715, 2714, 2199, 2811, 
       2291}], Line3DBox[{2414, 2582, 2798, 2289, 2290, 2769, 2770, 4048, 
       1976, 2810, 2711, 2748, 2106, 3891, 1988, 2750, 2751, 4058, 2111, 1997,
        3939, 2116, 2006, 3942, 2124, 2016, 3948, 2133, 2026, 3957, 2144, 
       3906, 2038, 2154, 3916, 2050, 2162, 2060, 3965, 2169, 2068, 2369, 4014,
        2433, 2174, 2076, 2379, 4004, 2380, 2180, 2084, 3974, 2389, 2390, 
       2187, 2092, 4047, 2708, 2818, 2404, 2792, 2611, 2793, 2612, 2709}], 
      Line3DBox[{2890, 2261, 2880, 2260, 4063, 2766, 2637, 2252, 2644, 2251, 
       4062, 2763, 2635, 2246, 2632, 3985, 2245, 2643, 2630, 3927, 2239, 2629,
        2238, 2762, 2761, 3920, 2728, 2730, 2727, 2831, 2830, 3912, 2829, 
       2828, 2032, 3901, 2138, 3952, 2020, 2335, 2340, 2334, 4012, 2431, 2225,
        2331, 2224, 3994, 2324, 2218, 2322, 2217, 2479, 2314, 3893, 2210, 
       2312, 2209, 2474, 2301, 3889, 2202, 2859, 2201, 2905}], 
      Line3DBox[{2891, 2266, 2392, 2265, 4024, 2515, 2383, 2257, 2382, 2256, 
       4023, 2511, 2374, 2248, 2372, 2247, 2362, 3930, 2241, 2360, 2240, 2353,
        3925, 2351, 2350, 2052, 3918, 2156, 2040, 3908, 2146, 3959, 2028, 
       2721, 2720, 4051, 2722, 2227, 2757, 2226, 4060, 2758, 2624, 2220, 2753,
        2219, 4059, 2754, 2622, 3895, 2215, 2621, 2214, 2640, 2619, 3892, 
       2207, 2617, 2206, 2904}], 
      Line3DBox[{2893, 2480, 2872, 2481, 3980, 2327, 2483, 2534, 2482, 2328, 
       2486, 4021, 2487, 2447, 2489, 2488, 2337, 2233, 3981, 2449, 2493, 2492,
        2432, 2343, 3996, 2661, 2344, 3911, 2820, 2821, 2822, 2726, 4052, 
       2725, 2807, 2808, 2809, 2355, 2497, 4000, 2547, 2496, 2356, 2500, 2597,
        2501, 2365, 2503, 4002, 2553, 2502, 2366, 2507, 2599, 2508, 3987, 
       2376, 2510, 2870, 2509, 2900}], 
      Line3DBox[{2894, 2858, 2869, 2464, 2367, 4022, 2505, 2598, 2504, 2062, 
       2164, 2463, 3983, 2452, 2499, 2498, 2053, 2157, 3982, 2450, 2495, 2494,
        2042, 2147, 3997, 2662, 2345, 2029, 3900, 2135, 2778, 2777, 3950, 
       2018, 2126, 2816, 2338, 2491, 2595, 4035, 2490, 2008, 2118, 2572, 2462,
        2429, 2485, 4011, 2594, 2484, 1999, 2112, 2571, 2459, 2426, 4020, 
       2478, 2871, 2477, 2899}], 
      Line3DBox[{2897, 2881, 2458, 1992, 2656, 2774, 2216, 4041, 2321, 2460, 
       2657, 2461, 2000, 2658, 2776, 4065, 2223, 2330, 2119, 2010, 3944, 2230,
        2339, 2127, 2019, 3951, 2341, 2137, 4075, 2031, 2723, 2148, 4070, 
       2044, 2815, 2234, 2729, 2731, 4053, 2732, 2055, 2237, 2628, 3984, 2733,
        2734, 2063, 2244, 4039, 2631, 2633, 2634, 2072, 2912}], 
      Line3DBox[{2901, 2884, 2512, 2375, 2668, 2785, 2250, 2373, 3986, 2249, 
       2667, 2506, 2364, 2666, 2784, 2243, 4043, 2361, 2242, 2354, 3926, 2236,
        2352, 2235, 2348, 3919, 2347, 2346, 2041, 3909, 2780, 2779, 4073, 
       2817, 2232, 2759, 2231, 4061, 2760, 2627, 2229, 2626, 2228, 2642, 2625,
        2222, 2623, 3979, 2221, 2641, 2446, 2909}], 
      Line3DBox[{2907, 609, 4028, 2329, 514, 2009, 4029, 613, 2448, 516, 895, 
       3488, 830, 2660, 2136, 4074, 2030, 1069, 2724, 930, 4013, 2043, 619, 
       2349, 3998, 518, 2054, 625, 2357, 3999, 521, 2913}], 
      Line3DBox[{2910, 2535, 2704, 2536, 4078, 2336, 2538, 2659, 2537, 2844, 
       2539, 2705, 2540, 2342, 2542, 2541, 2802, 4068, 2782, 2783, 2781, 2841,
        3910, 2853, 2842, 2663, 2665, 2664, 4042, 2691, 2543, 2544, 2451, 
       2546, 4017, 2545, 2845, 2548, 2596, 2549, 2363, 4030, 2551, 2552, 2550,
        2916}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJzsvXlYz9/WP1wiRBGFQlTIUAopQ1kpTcpUKJQyNGcqQpIkQ0pSmkiJBqGi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    "]],
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->{{-2, 2}, {-2, 2}, {-0.6900603560544143, 0.6907290867244488}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413342651997`*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell["The imaginary part looks like this:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"Im", "[", "sol", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJy1fXm4j1X3vjI0SQMNr4TkTWRoIpXakQohDZpEMkZUVEqDehuURlMDGt4S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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxFnAf8VtMfx5/n3ue5S0Y2DRWlZFVmdkRJUsgoQslqqIwyG6JCS1RGiUJE
ZKU0rPpHtmTv9ReyE8n/8+5zvP6vV6fv557n3HPPveec7z6/+mf17dQnKpVK
M6qlUizaXbSR6BOVUulm/TBB5bZyqbRLVirVFO0kula/zxM+WLS+6GsqNwv/
o7JQuL3oPepnpGgqWkd93Kr6Ebq+XXSyynXCLVU/VXiF8AmhfstAabe9yvEq
k1S2UHk2M/49LZUeSUqlB4VHif5X9cvoX/QH0eUqg9TnONHnVEr0o2ctEU3p
J9TnKh1VXgj1NybGN4hOEP1PqB+e+Z5rRIeqnKIuT9UYXg7Pqhn6ezY8izp+
24bvorJU5bySMX3WYKwqM8v+5tNF71W5vORvPj3gv0TXqdQXXiv6p8qPwkeF
+l9Lpn+HNr0C5vcXc7XVt/9TdLn63KfiOeus8rrKLWq/WvTr8P0f0e8NRH/X
PS1D/f4qI1V+DuN8Xt/lG+GbRP8oe0yrVf8bc6KyufAk9bOF6A/q52A9d5rq
P9Z1Sfgf4aaCY0L9ASr9Mr9vX9FeKkv0+1x927GZxzk683p4I6wNnsmza5f8
PdYG3DqM4Qf6F11T/n/dmjC2ZfoW32hcv4iOTjyPbUWfU/lMbcYlHuP6MM4p
uh4g3EP0YY0j07h3FE0j40P4bro+Rm1OE62qrqLSUvW1dP2X6CzRO3R/G/aH
nv2Snl3VdcuiVEoi30P7xqI7q9wt3DfyM+j/Vt1zGWtB3/Uh9bVO+MHM4+Sb
/i5yr/q7S3R70d6qK6vsyV7UPc1E/656L2wWec3/qXY1hd/R7+NEN1cpVN9B
3/1YtX9K/V/MnlP9caK3qf3+qv9D/czL3P6p8D3yME6eGYXnbkR/Km2FZ2au
3zbQOLS5X9dt1XdX0Yaqa6QyWfVXlo1PLrvwW0P2V+b9dL5ornFcr7bbalwN
mBOVeoFv1I7MW/hefLeharNI91zLOk3dlnsm6PplzcUW+r2e5uIk3buD6uuW
/Xv90KZu5PpRJdN6AV9WNua+Z9T/9pH7H6jrWpGfVz88awfVXSG6U3hH5pn5
blR2XcNQ3yTUswa20jveyjM1vpkqj9CfaFP9vqvKfbp+Uc89VX2cKfqK3qWR
fj9L73KVft8ltKE/+t257LqmoX5ZZrx/5vXOevqtZL63ZWQedYrK2yrTVX+9
6C8q3wj31Ni2E71P3/hs4W3h98INU/OQ10Svibw34Vdd1WYj1oLanCAsUpqs
/84S3lp4WsX90/fXJe+RQ0UPVz9nqs1W7EW1mS48gHUo3K1qPnOr8BnCWyJb
hD/QvacLd9O9tVK3WSJ6otroX+k2+FPu9Xyo6i9WZQvhZ1Rfzr0f2V/nVf0u
c1R/kXBz4cXCXYQL9pzwJcJ7CT8rfDtyUqWWrjurXlNRukP19Vj3uriRNaZ6
PbI0VfWnCufIXeFThNWsdLfwNLXdGLkoeou+yaYqG6vcqTYXqs2vavOm8IvC
h4i+obJM+GBwYn4M3/898Z7eSHR39bebyhz9dp1+6yT6vvp5Xfg/wgeJvq2y
XLiV6EqVl/n+okN1X1f100zlFV0vUv2+otP1Ig8Lf6mX+FbP2FW/NxbdQdfH
qb6jfq+vl6qo7g69eyf18wzjUblLdZvxXqKXqt0Vav+96B3qt7fwTxrbVOG+
wr8ITxHuI/yz8I7q/zDhI1LL0glBnt6i/m8SHa9ytdofrjavqv1Vwq2EXxFu
pPG0E26ve7fKzZPbCUe5edaj+v0Ctd9J9Y+h/ySWXci781W/o/Cjqu8l3FD4
ceFlwg8IN+RbqtwvvJPoYpU7hLeDVwU+AI+aBy9WfU3R+1R3L+Muef/OZM1o
PA+o7v7IPP1+tbsK+Sl6Q+AP7OUHdH01fJe1oDJLuJHoEyqjhTcWnalyJXJH
41wkfDs8U7Su3mdH9VEnsZxHDzi9bF1sddAHRgS536rsvbmK+VL9JqLfqWTw
SXhd0CXQedC9OrFWM+tfF+tdFgQ+trXor5nvnSK6UNe3qX4b0fZ6p2OQnWXT
dsgJ4fuqXhvrNf7BqXn+mtQ6IfrgQN4nN2+cofo091pfrv5fFZ6r+gdU/5b6
mS/couq9M0+4OXqp2rzK3leb7YUXM7/CrwsvRQ4KT1V/U+Cnuh4tupdKCz37
bt3fn/FobJ+ofRPhXVPr0RcJr61Y34Af7Kj6HqrfWfjJwDMbC88Vfox5RWaK
PhrkWiH6uMqNwjVEh2metkJ+o4dwrfpEdBtdb636mqKz2assE9FRGuN2qt+2
bF3rQIrweZHn88uSeQ58e7rGcKLqT1C5pGQ9CzmK7j086GzoGOiuW0XWl/tF
1h/QFd7XO97J87XHzwv6OXr6lao/W3031vUCZLfaL0RX0rdozx4VnhrWA+ti
tO7P1U9D4V0zv+8o0bGqf0RjfUj9jReeIzxbeEzQD9ETf1A5Xf0nqh+nNuer
nzNUN0H46ar1h2a6ro2OJzpE9ecKn8o4hbuja2Ret9/Dn0T3Ul+fqM+eos1V
3hfuLrqnykrhM0X3UHlbuJvoYPUzQ/deqHs7q5wlvJve/2Pho9QGZn9F4Xp+
v0zXPfX7VsIrVQ5Qm3dFRzA2jXmEfv9Q162ZA9FdpIDvW7E+ukhtRqvNJ/qW
tVW/t+p7qL6/2p5dtj76dsV2WCXortShqx6XWT/ChtpW7SeGPfs3Y9L1OvQB
+CL9IPPKni905bvC95km+rTo0RTVH5v6WYNVf2HksaDbzQw6HrresqCroLMM
UZvzy75GX2O9nRB4SefAT9JgP7K2r1ab84I+WC/oY+hdXTLTEzLblyeWbWMe
k9ge3TSxLtkw6JPDRD8uW541F24WZNvqwPvggfurbr/IuH/FOlBv0YmBR52s
fudnls3nij5cWEe/T/O1U2Y5gjw5RfUPwpeFzxB+jj0t3E34WeHHhLsKzxV+
RPhU4YeEHxQ+Tfgp4TnCZwo/D18XPr+wzH5auLvwUuEnhc8V/iaxLO4p/DI8
TvicwjJ7PntReLnwU8IdM39v5vqCwjrEAtVfLvwjMkH4IuEPVP+c8ADh94Wf
Fb5Y+EPh54VPEr4LmSd8ifBHwi8I9y6sTywS7iv8jvAzwgOFPxFeInyVcGs9
qy1rRvg74a9U36ew/rFYeJDwp8JLhS8T/gwZi34hPEH4rtz6xhPo1qKtVT9C
9ZOFh7AHtTdOF75P9VOYR3gLPF/tTxNtrLKEORXdRr/9LNxFeBeVF4VPze33
YG1dL3qP+hkm3F14f/3WQeuik+hdhe2lbqo/O7NO0lP0gcJ25rXC54Q1w9p5
XaWF+n9TdPfCPpfh6mc34ZPh7/CezHJwY+Eeqn9J9XOFj1H9saH/zqqfhpxX
fXtdd1D9E9jRql+h+oXowsLPIFuETxaehb4CHxPuzR4TPkh4sPBNwnsLX4oO
IXxBZt/P86JdVP+k6h/ObduiJ6Mvt9P7nVuyzwR7EdsQm/Gcsulp6DD6bYjw
RaKv6d491eYV0bdV9hV+S7RHZB7YXO1eq1r+Hih6duTfkLndRc9Cl8VWyN0e
3tlS/X6k9vuJvocuK9xG9Hz0qKDDrAp6zOFBrxkZ6h/SPXeKXis6S+Ua9IrE
84XP5qLU37sKvwp6DvwSnw/yCv63ouLfk9Dm2Mi+IGztDTZlsCuxnZGbc0Wb
ZNZfVqX2DyFf0WOfL1tH5pv+mVneHivamDkoWXdqoHefpH42ZY9H1uHw2eBT
Oahsv8q5ka+R++gP8HlsYcY+MYx/fOQ1iX3RMNinyMozgr2AfXpm5Gt0TmyT
TSLL+8fhHRrPxxp/jch8D3u/q667Il/0+2OZdTr06p6im0Zeo/BJ9Ls5ovep
r6uQm+ikiW3NHTR3vYLugA6xj9rNQNcVvSmzz3Fv0SVV63h7VK0XoGdiN7NG
2F/YJPeoz8tFe4mOrFjvHSW6NLNd/r3of7CFy7aF0RfQwxuIvsVYVSZhk2bu
b+fE+ga6/F7I0rAf2ZfMIfOFz3Bq2I/sS/QfvnsH9OLEvoEXRZ9VGar6ixP7
7fDl4bvjPvw1+BKxZ7BrzkFnSy1/3s3td+lftu8Fn0rfsv0q11T9/T9Ft1S/
/ZhD0SdULuJ7ij6q0oe9GZ6L37B+ybyL9dsl2FY3h3dB7wOzH25UmzORtaKX
J7YJZulZT2ZeG/CftsG3VuA/i/wuHcLeYw9i4/8SMPezF0epfFWyj4r2rPVR
YZ/ie2TPjggYfx4+Pnx6rUIbdNo5et4FwqeIzkltqyJTztKYnoQPqe4c/TZc
eCG+3sw68irRV8rWD9E5To28z/E3nRdkJTITm3VzlfOxg7BdRV8W3TOz7sL6
RC9Fd94js6+cfYZfequgkxwTdPY6Zesqm8NzWF+i32XW23fPrPOy7rZANpQ9
Bvyfx2em+EUX654rhHsn1ovwSeGbQufBj4ZPCV/R4LJ9Ps+gSwn3Qz8WvaTs
tcJ84rdiXS7Sb4N4b9GXytbD8aOhW20dxnxSZt9q68xzgY+V61Myr9+j0Mcz
2wf4FJH578MX0V1S+y7QE9Aj3kXXrFq3mhhsvxq51znrnfgDPnH84X9XbA9e
k9hnTD3yCfmAnHitZF7JHkQ3y9XPWNVn6C2RfZ1F4JNjgk10XOQ2HVR+yrym
XkhtM9EGXro61PP76CCPkFPILvwj+EZe0sJ8TOWGsDb5HodpnJn6eqbkPc46
RH/4V49A9+yUWI71COOfWPGz6AN/OHoL+st++LnU/wJdNxV+Qngsc5j623wn
2i81n/hW77s28/r8VnWDIvN6+Pzm4Tsgm5EbyA/s/RsCn28U+D98H38RdlW3
yD7JVzXWycjuxLwPHrgi97rtEnkf7Rb64V7sMe6Hx36c+765hf2fp4c+8ZFy
L75W7LnTIuv/2PfIuIFB5rIn8Sl8pH6ehp+pnzsi+92wsVsE3YBvPTiyjYF9
gc2LHtAqzDtyEZ8ObbuH9q+pv+3hDxW/363hW72g+oHCS0UXqHSO/OzNgj0+
NsjVkyPvc/bLKZF/mx+5r40D3+L5hyR+167hfZlb7IwTVD9Yz35PczqgYvsV
PrAlvjvVzVC5VNfV1Pdt2Jvq44PYfJ99jx3UXvWfM5aK5UpW/b+vOkn9veEV
W1b/72s/XG1nxpaRRwnPii2P09RzCK9A9jdgzxW+B1vqWHxjelZeMU/piF+1
YvsqT72Wiaf0gWGrfgX9C9ep2NY6LPY6Zg1vH9tWxjb+Qn1uUvH+OEtz/Y9+
G6/101v079gy+WvmvOKYzQfC62OP6xvhbSr+rjeLpir9VMYn1h+bJeZL6Or/
6uzsg6NVHwfZinxcpH6ejz1vjXX/C7H1yHUV7zVidQcIL1T9Pcyfxrkgtu3P
b/Cm69TPUnTb2PL1eLWfH1vXfC933PJ+bEG1eTV2LPM54WWx9/7BsXkK/OT6
xL7x/2reLkms/zYR7ah+ZmP/i9avmsfD63EyE79CDpZTx5eQ9YwD/ny48B4a
z226t7euH678P37YNdjs2GULKtYpWGMt+K68I3IyK21wcN+p8Uep9T50jBcr
1kfQSzpoTNOYV2zSxHpglnj+58VeAzeGPYte1Uv0gsjjqJE5jjdDdJvcflAc
5LMi+0a5/kR9jUd+YpMIH6b62Ynjb/hbeGe+WavI+sb94V58hfUS87mvgj2C
H+DVzHwD2wRdYTs996HIfkV8ibur7XnY9JHrF5eCXzzwf3gL8U7072fD+n9H
962u2iePbx6ZclCQO9g++BlWZPY37qPf+xfmB9QTe30/c2zz5dQxGnxBzCv0
yIDfy/yOtMFPxG8fZJZLyKclfLvc3+Qj1W+cOSZzamJf5t6R98bMyP5ofNGP
BZl1qdpsHmIl76nuzsj+UHyh2Cn49LFV3krs/5xXcfycWDt6Y43Ev48R/SKz
LXi6+tkkt78e27at6NGR1xA6AL5g9uGG+GGof1z3n8SyFr0ucjvshzVVx6ze
TizrL1L9b3rOp5l9V9cEeYuvh7l6IPG8Ead4I/M78q7bJbYFPmOcKtNUX7dq
fZG1wNrg+7UJ6+qdzPPLPG+R2T/6hp6/JWs1clyJ9+R90T2mRa5vo+trw3sR
G04Sv8dH6IRqNyNyPGJ6ZMw7P5jYR71n4rgevjD4L/M7LLwXa5a1iw2DfcJ+
IiaDj21IWM9DQhswcTnic6xL/Gr0Ce8gRkGsgm+B3xf/L993ZGSfMroycgmM
Do2cHBRkHHx/WFhvvB/vuS7MKXPG/sdPh5xanzkWyftgbzbPbB8vySwDegU+
gI/2ysiy6urQnnHGue3jAal/vyK0+VD185Cdhcc4MowT/fnyyDr0X9h7avNI
YRsMnZdr4u3E3f/U9U6x+SO88cJQv4GvRfZ9o9ei46AzIRvRLVl7zDfxxyfx
CxQeH+NckljOXBzacE09vpPGoR/4UTW3H/7X1DkQfEv4A8/k2fhwkW34KOET
NXPvxRVq+5T6ulj4z4r1+ksj6/aMi+ei9/6hvi6JbJuz99Fl0WNbB33+58z8
GL6MjOG9eX/kwVFBt/9FlIQh8gyQDT1CP/CQmplzUu7NbMNh+2HH4ZPuH77b
V5nnhHesGb5nVLYPvs+/fYbvzjc/Ud9xsvbivXrXCYl55/7oJLFlEvLovcT7
ifyKQ9TvfsKf5R4/Y2dON8+cv/CU+iuX7eOGR/RR3T7wM/IFhI8SflN4oHBr
dNKK/WDoUeSoDFL9kex31e+c2RY8Tc8cUHVccrnqT069d1dqDN+qzYtlxzL6
qs2+qn9BbT7NPc591HaU6nsIf6v6kcLdkfXExPF/Ca8SbpPYx4RNPS7MKWvq
wqr7WaI21wqfyTcWXpPYL/qb6JHY+aovJ85TYm7wTfULa4rvP1z3nqE2X+re
G4R7Cn9HDIv9pHbTE/tA8YWSg8Few269OjU/go8MLazL/htLbBb0LvxpxyXW
x+FJDYJOic/n7dx+wWEhDsP8Lwi6IDwA3QSfD/ojemCXxHIPHadWYhsE386V
iWXlP4nXB+sEnx72VdfAn17OvK6JD6Jr/BWegd+dmOxmVeeEIANHoENljiFM
Cb78sarfVHQ31U+EL6bOGdsoyLqzU3//aerjM7XpJfy56B6R45Lo00VuHRK7
jVgK/gT8CvjRh8DbqrazsDuwP8iBOJT1gAxPPF/spyvVrqPq39X3GSJ8Avyv
4lgBcfldqo4h3Clcu+qYw0PIvqrlAHPRNOhA8B5yS4gnPIWsqdrX/qHwcaK3
J95nZ6CjVD2el/SsnxPbx/hdyXNiD26fBXke+D+0CPKubuZ1WCdzrJw4bLOq
4xILhPcW/SExT0LeYZ9uiMmUHUN4RW2OqDou8Y7w0VXHJVbynKpjLLOFm1Qd
N/hAuEPVcmNDLpHKF7nl+7jUcZKF7MGq4/LU16nan7O1nn+T5r1F5ryq+cID
c+c+XkRMITNfIa/p8qrjX8TcHsgsM9G1iOORf7UwxAHRE9AXtoYXlRz7uyez
HEZnw4/1Vcm+LHyBrE/46aTEdtJVokPV54n0X3F8EF0OnW6Y6jsLf1xxTGmq
cC3Ro1PztM9z+2nI1UO3/qrqPJwvRb9WqSH8QMV+Wnx1+B7JeyQO2E60gcpB
qt5B9Aq171By/tjszPyDvDhyXdaHNldlzgdtpecvTj13xJXQV8nfmy56eGTd
FT39lsS2zhWityaWvV1F+1WdZ7qsYj0JfQk9EBuE9fUmOqTKRpIHR6tubdXf
mXvXqm7P2P6sI8nbEH5TeBXtkT+a019Ud05sHn2I6q8X/jqzbd0o2Ndl3dsi
tq8Ne27HYNNhg14e2w7FDt4nti2M7XhQsB+x5w4NNt0Xok1i20fY6PvHttNb
ZtbZ8DEnqt83th13D3pIbN/c76LNYtvyi0Xbx7Y1W2nMI4W/1L2HESsSHibc
Hh07doz7CGRY7DzdI1V/ZOxYGHbzXsF2xjeBjwI7t43a942d+3Wo2u8aO7Z1
hHDL2PGv+tj9sfNB2xIfjS0D2gtPis3n39Tcfhfbzl4l+q3KIuHdc/uxyAHo
prqvYseTX1H7r2P7rKn7MtQ3yz1vxO73y+2PfBpbJvi7sPvwDawL/gHsQXzm
Q0T3zR2nIF6xKvK4GXNXeDQ+CHxUop+rzGdviH4fO+7dU/Ts2LYOeb/kL/Ft
ifuzXpDt2FHswZ+07s5V2xWR/UDthH+OnRNwnuhvsX3M54v+ofIqOk/s5/Gs
N9DHY/voaftraP9O5Lln3s/Qc9fgE2DvCI8WroiOET089ntWUudxbCLaSO96
XWzbmByBm2LrVsfonvGxcx72V/2E2DJlTdAP0RPrqu7m2HG8vol9R/iQ8NOM
i53DgH6O3o0/6fMg78hJ4B703M/UtntiGw4/ATFZ5p88AZ6HPriy4nWDXo8P
Y0BiOYn/iTWEvbJ71bF+nkfuBn4x7JBzE/tu/o03wnOYQ+b0rdx5u1erfbfE
dhu+EOIXfHu+4ZCwTkYmtnWfKdlfi66A7n1A1d8LPRTfBv5tdBRyRshbZm7J
+7ggsV8O/1wt9mnF7RZnzgslP5T1wTqBhz+quscixyzJPcK+q6vxPqy6RyJf
19b1HOFauXOSFpeM9wjyETn5R2K9nly/lnrmmbHz76fjd4ltBxyXmlc3zL2+
moY1NhdbMHKu5L5BjiPP6+Vuz32NhBdGvvcAlY70mTnuiG92M+ytyL5ObMAF
ok9Hzv87Kdhy5Lzgt4LHw9sbhHuIe/6d+FnrEuc5zgv9rNRzGsSO5Xws2jB2
vIoc9tNi57HDJxoHXvFr0HXReZkTdHV8n/sV1unH5bZNhwb7lJwlbCNilcRu
jw66MTmFhwmPzx0/f0n4MNGdCufVEfs+vmr5jNzE3sEOwiYiNj4F/Ud0DXZe
xf73AbqnS8V+eOxcbFXs3xpBB8XmIr6An/pHbCuVNvjZctu5IyLv8dUV768a
qXMV0EPQR8ak1kvJFRmbWo9FlxmQmZcPL6yvErshh2qyrocn9k0h9/GNkRM/
rbBcIo+9TuH8QvIERqvPMSXnqFwjPLjknBb0qE/VT8PC8VrituhM6Ev4D4iv
wk9uYI5y74VrkBHYrIXzJquqm4rPK7H/5G7hPoljCjWCjwhf0SW5c40G5ZaV
6NLk+r0XWbYh1/aO7b/Gd/1RZBmG/KofWybBS/Db4IMjz2o/1berOC9hB+HW
FfOXQeFZ6BKnV60rcZYBe22FxvaP6LVq+7L6GVhxfHidcA/VP67xd4wsi/n+
xyIHVd9OpWbsXKJ6seUlPO+bzDEF9A1k3LvCfXLryUPRLXL7fvENc96F2DUx
7CuoD8++AVs1tv8dvtU8tk8ffz45KuQz9Mjsf2NsjPG1yPwCXlEntgyAHxPj
IBdwvuhbogdWLPO4jzjZ3OA3w3dA7sreqfMYb9Bzhqe2X8hfQmdDv11XdV7J
8ei36usotTlCeILatEltX98sfG/VcTziem1T29e3qL5SOJeXvJRPKtZvP8RH
VzHfwrbtlNoOmpQ7XwJ/FP4V+D8+J3IQOqfWmW9X3fcV27aD1eak1H3ekTtf
Gb41ER9M6jHfmjuPnGdNEd6qcB42+TbnpbbTp6NfpLbfZwj3Tm2z35M71o/v
6TLRvqmfix/jHOGzhO8WPlO4m/DU3DlN/Xgv5Edqe/zO3Dk+7LtIdETimAMy
i31MPIEclstT30su1pMa5+1V51RvJHxT1blS6L3oBv1T5y1wHorcpBNT24+3
sQdT21DkjN1YdZ4vuejkED2o+p2hqW03cmnJryUHg5w0fJj36PsvF21aOC+Z
nKX9qo7F/xcfgurXV20nEk/qH3wBMwrrvJxlwO7+N9a9XebzK6PINUttw5Lb
Ni31eMhn65w4nn1y4jypp1W/l+iYwt+LfAnyqmeWnC9HDhQ8bZOqbTdslhj/
SuH8ePLHyCNjjr7RXDQNNvWXajMxNZ8nfw87CNuH8zxnJZZF5Fzcq35uqzom
26RwLjj5V1NS54dj+xITQQ6TlzEptb1GfuDk1DY7+X57pc4Zvl64RepzeaOE
1+fOQSd3a2jqPOG17L/UucR/sL5S58x/xtpMnUv/OWsw9TmCL1J/W2xYbNkL
U/sPv2FtpI6t/CVaO/XZiqWiC1OfESAfb1HqMwLk49VNfY5jmWid1Oc1/pPa
h4IvZR17NPgTftL7LkgtW8kD7B/01f/iy02dw/yT6M2p8+pjja1l6hz+D0QP
SJ3b/2FqmxDbkPMVt6TOga8gc1Lnuq8X/aFivZizBuT/40Mjx3hg6tz4H/hO
qXO2v0bnTJ3X/aVor9TnTb4SvSp13vXPqX1e+L5+Eb0+dR7736ITwvxG6r91
8Fd8nzj+iI3IObPZqdcnuZGDUuf2rxb9seKzD8vVpnHq8wVvMv+pzyO8kdrW
QCciz6Vp4L3kkj+UOqeC/UjcanbkOMDIzOciOR95WerzAj+mlgfIBXRe4onY
oOQi7VvYvzk29xmNrdXP3aKPpPaTkMPZKPU5iNdT57s3EX4LnVn3vSfcXnR+
6jMp5IjOS33GhDxS8umXlpxHOiz1OYU/ReulzkUnJ51ceeL5y0Xrpz5n9KJo
s9TndN5JnfeF74rzTnemzu3foEsEvsT+ap76bM67onumPr+zUrRB6lj/S6nP
p+DnwL9xZOpzMR+xn1Kf3fgndS4kMus1zU9c+DwJbTLhsVXvr3Lhc0SsyVx4
XNV7LSnMQ8mRK4THV73vUuEx6BSMt3AcCJ65OvcZIfI/d0h9Johv0qDwOQHW
846FzwYwNs4dvI6fQ3SLwudkWEvkkG6je+/SmA/U9d7CY9Rms+BLZ69hg7+u
+e0Ff07tp7oxd04o7Z+r2GeOLwufVn+VY/AbqM3Bqf3Y6NVR4XNQ5Iu+VbGv
6V2NaRPVT6x6Tx2U2sfOutq88Dkf9t2Whc/5sCY3FZ5UNf/ZWPiWqvddDeGb
q96P6InYAeSvbV34DAa8onHh8y3sffx600rWgf/IfVaN9flr7jNjrNvfc58r
Y3+RX0WeFWdh/sp97ot18nBqnyR5yOtyn/9h7X2X+wwb/PCn3OfBWEs/5j7T
xVr9IfcZMPjh97nPnsEPf859Fo61/Vvuc2vs610Ln1EhX/fpwjFI4tVrcp+R
Izd428JnS+A5OxQ+BwJfrV/43Aj8p1Hh8zbwn50Ln7GBf25T+OwcvKtu4bMi
8PbtC5+xQV7UKnxeCDmyS9iP8JYmqdfStbnzZDjjxpr7O/dZKfbXjfgiVT9I
tHbhM0vsaw7KcXYOvo0dgj1CbtWs1H5mcs6Jj5PH82bi3GxsEGwRciTw5xMD
J+6Dz4bzx8S5iJER5+sW/NL4p8n7xU9MHJ08UnJHOyTOFxpectxpTmFdkzNE
7D9yvojV/ZXYbsUOJR+POCfnQvF7YE/cF/xIDdhPuXUW/Hzk0+Hf4EwGZ4W7
BL8l/kvyMHsGnYQ8c/j2hph7bj0HfYcc5l/wB7C/0XUTx4yYe3QN1gL+Tfyc
nP0lTk2c/vPE+f7kIqBTcb4YH/vH6CeJ/at8T87tkg/xfuJ8Cc6aYbNxDofz
OJxZIBeCvIqvE58zJX9rFXZ04twsnkVclvgs5244a7xzaE88nbyr1YllCTKF
HGpiOsRZiLeckVquweuQR+RMzSqcP0mOF3El4kbkE+GjxyeAH2G96MGFYxvY
C9iF+F/JeTyksB8c2+HQwr5v7IVjg65L/KV54XgbulO7wKvR4dsHPoxe3THw
FvTwZoVjgehXLQrH1bBr9hd+J3E88YTAo9DtDywcg8FXcEDhNUSMZp/CsUP4
7R6Fz32xd/ARYZORj7xX4Xgh/LZT4HXYEccHnokdcUyQI9gF5A2TPzwt+D93
RO8RPapw7BC9nbjSTfpuG+XONSUftXZifxo2Ljn4bQrHFLGDTkqc94ltcmTh
uCP2zhGF44jYU20LxwKxj/AFMScLC8dROJfM+aq7M8cU8F2gc8wO6+cw/fZB
4rgDObeXBn8d56fwx3M+q1Xhs+j1VXd44Rgk9hdnQfCFoTtxFoD8GvJvyDcm
RkCsgJwTzuVhkxPT5+wSZ5jIM8TvQv4jfq3HI+8xbI67w17ANuJboWsRqybG
wnkrzr7gm0NHZezkYWBvfl5xHH1t4pwT8mBWCj9U2EfAeeeZwkXq3Ev2MXnb
2Jj8HQZi9MTqiVESxyGeg3+PfbOgsM/tqcjfAZ/e3PAs1h25I8jTyYlzgHju
g4X9UJxrxtbF5iVH8X8ngqIP
         "]], Polygon3DBox[CompressedData["
1:eJwtmwXUXEXShmfmmyszuEtgcdfguri7e5BAsCS4Lk5wl134cQnuLO7u7u7u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         "]], Polygon3DBox[CompressedData["
1:eJwt2Hm8ldMex/Fd+5zdOVvJNYRkKCpDEg2Gbi4yZ8hQJFepuFwaTBVpUgqN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         "]], 
        Polygon3DBox[{{2122, 779, 717, 1158, 1157, 2425}, {2144, 1642, 1556, 
         760, 727, 2352}, {1906, 1905, 2538, 1802, 1803, 2539}, {2424, 1134, 
         1139, 986, 754, 2071}, {2017, 1423, 1719, 2524, 1887, 1888}}]}]}, 
     {GrayLevel[0.82], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxFlMlrFFEQxl93T0/3jJCZgCgIbiBIIBlFBEGDGBlCbsqoiXE56EVBMJcE
t5iAiHPL0YP6BwSMiRpX9KCoGEEjKOYS9GByyQZZRgS9+PuoBx6K+up1Vb16
VV/15tNdlfOhc+4MEiEvMs41oldi5/rATwPn+tFXU+eegXvRq5Hf+Ewmzo1y
tgLepBzEbEO/xP9PbHmUr4bPAFLAvkzsI/AldDVvMdWcc7POfGbQq/i2gL6I
3kF8J4U94VsJfAT8ELwTfAL8HLwdfBT8GPzA36V8KfFz5L/FPc18f4NU+dZC
3aeI6efePD4b8d2SWN2qvwAuInvAY5xtzdmdqmeMHO+RIexGvh0G3wd/RFeQ
YfAF/A6B24mbJscNzn6iFwPDgc6o6SS1Xc/ZHbrrb2x9bsOhDV1MrbdXUosb
9LHlwO6pAzcongGeQ3fjV89ZkloNI/iMJ5ZPvdE89Ja3ofUyh88Gzj4n9h71
XPGtgb1pPXg2tnvuZayfM95ftWvmIxmrrcW/ccDPQLMe9O9VD3Zz7wF60kOO
OmSJs4nE8ivnviy9oCcV7Gs544nqaEUvx+a/H59yanXpXXuxxd2p2OY65cxW
Dr3jJrVNx1aXfJRHscOen+JwOWuzPsvZWvQupNlzeymwvMpZ4N4SupTYG+ec
1S1c8/Y47/sUWd9fh8YJzSmbWg161xriezPGsQVqmOd8PjZujnp+HoyMZ0Oe
8+Ke5taJfI9sB7+iv0S2f+2R2cLqrXb3dt5moxnVsI/z/UdkO6z9Fdfu4NOd
sR3qQh/j+2RkO6+ai8Suo853oXFdnNC+qGbx9kNouydudWB/i2yv1atlZ3vd
RHyTn7W4sOi5or6Uw/8c1n6L55qNZqS97RMPsHvQv2LLqbeI53cD49IrcjRk
zNa8630/O6hlIrJ/zT8+bqWb
         "]], Polygon3DBox[CompressedData["
1:eJwtlMtLlGEUxs98F79vDHSCKAi6QRsjDSIISqJiEKFNDGXZBaJNRJAb7WZq
hOR/0KL6DyqN7EqbWlS0yC4LKYSInE06E+kUQm36PZ13cZjnPec97znnOc83
G072Vc5GZrYPS7Byk1l3wWwz+E9qdrPZrJH6uSs3m8nMlsDt2HbwDeLzxNco
l/hdHpkDf8fm8Gf4ZsG3ebMfvJf3uwp+f5H4at6ogr9hTcQHimYd4EHeGQaf
wbaCH5HTBj4cm32KvZ+H+GZ5Q/2rRhX8ldhR7AmxneZ3D2EPwkwXqHEfvB68
DPyBWA82GXyvwPuxO5yXcx7Ivfc2ethB/WvMW6dOPeRrPt2r4BsldoXcTmyM
nAVsnLy1xBfCvLe48zf13rrJPRZ7zzo/5f4oNWrmNVRrN3yV8bcEPmup16uH
O2O8vy3x3H5+x8hfJPZbMfJ/pT5XI/jUo3gSX+p9I/yXzGs2c36X+e7msWLu
Myr/eOhHPatX8TsEvpw7/sIMvdS+mDvX0+K96JoR7/JdAqf4X7Cw8YLPNZj7
brdwpwSeov5EiElPzxLX2lLQY43c55HvRDNoRs3VCPmtmb81RN5KcJF6byLX
inS9Ct+JxGcoZc6nZhcH1/H3BS4V170eZpiKvafzvH8A/D52/d7Dl4FfRo6l
68+cj2CPw0yaQbNoj/pWRhKPzXDnXOL6lfb34NvFnRHqncbfKR/9XS16vBp2
N525lqSpdnBv7DVVSzy+Bv+IXB/S8MHYNa4dSvcd5Kwz10grvU3Gzul/Lgu+
X/Gk/wFpVfvTXPpu9V8gXlVLMwwnzrnOp4LelKNc7WsFsbex71wciEPpUbXV
w0TinIgbaS7PvYZqacYWzhVyN3GvHDTzkfPPyPetb/Yf+vKfGQ==
         "]], 
        Polygon3DBox[{{2434, 1362, 1174, 16, 2054}, {1998, 29, 976, 851, 
         2167}, {2165, 847, 966, 17, 2164}, {2439, 1383, 1212, 46, 2063}, {
         2436, 1373, 1199, 31, 2058}, {1999, 30, 1198, 1515, 2056}, {2006, 45,
          1211, 1523, 2062}, {2169, 981, 775, 326, 2170}, {1807, 1148, 1147, 
         46, 1212}, {2011, 60, 1224, 1531, 2068}, {2168, 237, 750, 708, 
         2343}, {2171, 243, 752, 712, 2345}, {2172, 989, 777, 328, 2173}, {
         1224, 60, 1129, 1128, 1808}}]}]}, 
     {GrayLevel[0.82], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxNk81vjFEUxu/b93MmBAuiFlIJC9Ui2k7LtDOD0BARipWIpEGttEU1BOEv
ELSKdjaatKxpLVhpu/aZUF8xmCb6V/idPG/C4uQ5995z7nnOc89d193bda7G
OdeD+VjVc66MtWIdkXM/2GsHG0LnnuKviJ1bJOFo4NxvYg5zthncFCkvx1kb
+A07jr0i5w97a4lfYD2WKK8MHiGnGb8JLBLzyFO9F9SaBOvA+kh1rX4951+w
adZP4DEFdnDPUKKzUfa2h6ppfOZCxTaCI8R8JeYeuAYutdgv1qvAlVgFP0/O
W+L3En/VV5zFLGLjWDHFElbA9hFTF4i39W59t1iNrHjnE+lhZ++5t5So32Ii
f4a96Vhal9Pczoxz13zpM4pdwT/LXjv+M+InY/UywH5PRpqeocYHJy4vffEx
TT6ZthnpaHquh9Mb1s1gPxwLxDTgj2TVs/XelOq2kdwNkbQzDS3OONhbW1/H
Imlgs5FPfds7AIcLcPjMeg+1BvEfEN8SqT+rnfPE2zjPh9q3893EvWNvNhbP
OfznsXSw93kItiXi1ppolozzDDG5jGoOs9dPzTBQ/8vBZYHm8XWoO3eAj2P1
ZfOw1ebO09lp7gkC6Taevn3FKXcLfmOkWj/RvBfcT2wf9T56mvHrvnq7n2gO
p2LxM56mk73Nyf/m/BQ5qzm/5Iur8bSZO+EpZxf3zII7k3/zZ1pPxPpf1q9p
ZNxNH6v73ZPm9r7G2f6I6Wx6d4LbInGzv3Keugl1541zVmc2n1X66wqkSy33
3w7092/S8y38wYzewmZqmLwF4g8Fqj1G3ITTG1XYPxjo39qMV9O/cDetOQSW
atSX6WwzUEj/ouVd9JVrXC774rMUf0mg/3yHWt34N9L3srvsfw4EepM+8C8F
Ipx4
         "]], Polygon3DBox[CompressedData["
1:eJwtk8lvT1EUx+9779f3ey0ihqKJjYSFUkRbrc4IjWGhqqumkUgMIdHW1EhE
2FiKVCdaG4tiTVmw0nZtiISa0gZN+CPE55vvW5zcc+4Z7/l+74aTvccuxCGE
w0gBGS0LYWsawgv0J8UQZpDWKIQWZF/GPfYHfDXYbdjT2CfQfyET2CPIN/Qd
kfMrKFqehNCD/RN5gH+BcxfyEv8U8oZ6O+k5Ru9J7GfYldgjZfYr9wcyRu7N
0hDOUXOSmMGie6hXVerZB/A/x3eXmFvozeRsxz/D3VNiG0qs6+4telPqt7Uh
zeiPiZnGvw27idxN3FVG3scs8dXU/IxdQv1T6ONF+xU3TP9+pAa9lrs95C/V
UhPPqL20U6Musn+uxPGaaZawd9Q7gywrOHaU/CH0OfSMcwCpTr17YXCAvMvU
XlLwfF+5/weYC7F1zXUN/+qC689jn6X+moIxGKd+L/YR7C/CpNRv2Kg9BL/t
Dr5DyCf8VzjXcXe+YP8r+q/I8RrkrgK9irsp7M2R93WJ/mUFx6hHH3aS56um
dvM79mzakTAUlsKnJTMnOlNzQFwQJzqwuyNzRTsWng35LhvxdaXmpLgp7i3G
5k9PzhP10T6Ef13mWTXzRNHvF5a6q8/8Ls0uDO6h16bm7sdg/PS2i4n9imvM
zJ2OnL+aRzgJL/2f18SuTTzfo5wj4kI9shf9Yea/dJy67eBRzhkn7inM+nIs
tD/h0JqZD535/9mS+j915zOI3/PB/bQX8ed98C6Us5waqxLHf4+MuWqL40OZ
e/9hf4v5n9Xsf2PPqJo3sLuocTqPWY9+PfFfV5/b6AcTv7U1Nvb9ieurz0rs
q4l7a27Nr/3pD+5mb8OZeaPdCu/7mbE8St5+9vMfvcmTTQ==
         "]], 
        Polygon3DBox[{{2111, 1586, 1337, 195, 2112}, {2103, 166, 1312, 1572, 
         2104}, {2202, 197, 1044, 890, 2203}, {2198, 182, 1035, 885, 2199}, {
         2197, 347, 787, 738, 2358}, {2201, 887, 1042, 194, 2200}, {1312, 166,
          1130, 1124, 1467}, {2109, 181, 1325, 1580, 2110}, {1975, 310, 1589, 
         1588, 2512}, {2355, 1028, 766, 298, 2196}, {2107, 1578, 1324, 180, 
         2108}, {2205, 893, 1052, 209, 2204}, {1809, 1169, 1168, 180, 
         1324}}]}]}, {}, {}}, {
     {GrayLevel[0], 
      Line3DBox[{496, 1, 424, 228, 1818, 16, 1828, 31, 1838, 46, 2421, 1146, 
       2430, 1147, 1148, 1814, 1149, 1150, 1151, 1142}], 
      Line3DBox[{497, 2, 1598, 321, 496}], Line3DBox[{394, 3, 425, 962}], 
      Line3DBox[{1177, 4, 1510, 230, 394}], Line3DBox[{1179, 5, 1177}], 
      Line3DBox[{1181, 6, 1179}], Line3DBox[{1183, 7, 1181}], 
      Line3DBox[{1187, 8, 1184, 1183}], Line3DBox[{1189, 9, 1187}], 
      Line3DBox[{1191, 10, 1189}], Line3DBox[{1193, 11, 1191}], 
      Line3DBox[{1195, 12, 1193}], Line3DBox[{1196, 13, 491, 323, 1195}], 
      Line3DBox[{1197, 14, 580, 1066}], Line3DBox[{500, 15, 433, 234, 1197}], 
      Line3DBox[{1837, 30, 2057, 235, 500}], Line3DBox[{1847, 45, 1837}], 
      Line3DBox[{1119, 61, 2082, 257, 76, 2273, 590, 265, 528, 91, 2088, 270, 
       1885, 106, 274, 1909, 121, 602, 279, 2243, 541, 136, 285, 1929, 151, 
       1160, 2428, 1161, 1162, 1812, 1163, 1164, 1165, 1145}], 
      Line3DBox[{1857, 60, 1847}], 
      Line3DBox[{1869, 75, 1153, 2427, 1154, 1155, 1811, 1156, 1157, 1158, 
       1144}], Line3DBox[{1883, 90, 262, 1869}], 
      Line3DBox[{1908, 105, 455, 268, 532, 1883}], 
      Line3DBox[{339, 120, 2089, 271, 1908}], 
      Line3DBox[{412, 135, 2128, 339}], 
      Line3DBox[{290, 150, 605, 2095, 282, 412}], 
      Line3DBox[{1938, 166, 1948, 181, 1961, 196, 2114, 312, 566, 211, 485, 
       311, 1351, 212, 614, 1109}], Line3DBox[{1123, 165, 2102, 290}], 
      Line3DBox[{1959, 180, 2423, 1167, 2433, 1168, 1169, 1817, 1170, 1171, 
       1172, 1143}], Line3DBox[{1974, 195, 1959}], 
      Line3DBox[{570, 213, 615, 314, 1352, 214, 1353, 215, 1354, 216, 1355, 
       217, 1356, 1357, 218, 1358, 219, 1359, 220, 1360, 221, 1361, 222, 1594,
        317, 574, 223, 1685, 489, 1055}], 
      Line3DBox[{575, 224, 1597, 320, 576, 225, 490, 319, 1988, 210, 1974}], 
      Line3DBox[{831, 397, 1196}], Line3DBox[{497, 896}], 
      Line3DBox[{570, 901}], Line3DBox[{575, 902}], 
      Line3DBox[{1130, 1124, 1816, 1131, 1136, 1141, 1166}], 
      Line3DBox[{1129, 1128, 1815, 1120, 1135, 1140, 1159}], 
      Line3DBox[{1134, 1139, 1152}], Line3DBox[{1138, 1137, 1173}], 
      Line3DBox[{1119, 2426, 1126, 1127, 1810, 1118, 1134}], 
      Line3DBox[{1123, 2429, 1125, 1132, 1813, 1133, 1138}], 
      Line3DBox[{2431, 1121, 1857}], Line3DBox[{2432, 1122, 1938}], 
      Line3DBox[{2431, 1129}], Line3DBox[{2432, 1130}]}, {}, {
      Line3DBox[{1869, 2086, 2085, 2702, 1868, 2175, 2350, 2412}], 
      Line3DBox[{1883, 2149, 2150, 2124, 2183, 2182, 2731, 1882, 2178, 2179, 
       2369}], Line3DBox[{1885, 2087, 2566, 2015, 2229, 2359, 2364}], 
      Line3DBox[{1908, 2151, 2235, 2152, 2126, 2298, 1734, 1907, 2307, 2308, 
       2371}], Line3DBox[{1909, 2208, 2210, 2209, 2127, 2237, 2238, 2472, 
       2736, 2236, 2360, 2366}], 
      Line3DBox[{1929, 2093, 2478, 2704, 2097, 2193, 2353, 2414}], 
      Line3DBox[{2082, 2079, 2080, 2701, 1858, 2174, 2347, 2396}], 
      Line3DBox[{2088, 2206, 2292, 2207, 2125, 2230, 2231, 2735, 2523, 1884, 
       2294, 2296, 2295, 2417}], 
      Line3DBox[{2089, 2027, 2338, 2319, 2320, 2744, 2527, 2297, 2026, 2419}],
       Line3DBox[{2095, 2191, 2192, 2190, 2131, 2091, 2718, 2133, 2189, 2188, 
       2400}], Line3DBox[{2102, 2049, 2096, 2707, 2101, 2195, 2194, 2402}], 
      Line3DBox[{2128, 2038, 2242, 2153, 2129, 2300, 2301, 2299, 2737, 2239, 
       2037, 2241, 2240, 2409}], 
      Line3DBox[{2243, 2154, 2187, 2090, 2130, 2184, 2281, 2185, 2732, 2092, 
       2186, 2282, 2351, 2399}], 
      Line3DBox[{2273, 2180, 2181, 2123, 2081, 2717, 1870, 2176, 2177, 2398}],
       Line3DBox[{2363, 2166, 2730, 2522, 2267, 1997, 2266, 2212, 2547, 2505, 
       1827, 1996, 2546, 1826, 1995, 2545, 1825, 1994, 2544, 1824, 1369, 1823,
        2605, 2435, 2543, 1822, 1993, 2542, 1821, 1992, 2541, 1820, 1991, 
       2540, 1819, 1990, 2733, 2211, 2288, 2287, 2289, 1989, 2693, 2163, 
       2410}], Line3DBox[{2365, 2577, 2539, 1906, 2025, 2576, 1904, 2024, 
       2575, 1902, 2023, 2574, 1900, 2022, 2573, 1898, 2021, 2572, 1896, 2640,
        2466, 2571, 1894, 2020, 2570, 1892, 2019, 2569, 1890, 2018, 2568, 
       1888, 2017, 2567, 2274, 2275, 2016, 2751, 2418}], 
      Line3DBox[{2367, 2279, 2280, 2742, 2526, 2278, 2036, 2309, 2585, 2525, 
       1919, 2035, 2584, 1918, 2034, 2583, 1917, 2033, 2582, 1916, 2647, 2474,
        1915, 2646, 2473, 2581, 1914, 2032, 2580, 1913, 2031, 2579, 1912, 
       2030, 2578, 1911, 2029, 2743, 2315, 2314, 1910, 2028, 2727, 2387}], 
      Line3DBox[{2368, 2143, 2722, 2142, 1871, 2233, 2234, 2232, 2626, 2337, 
       2336, 1872, 2341, 2342, 2750, 2340, 2335, 1873, 2455, 2627, 1874, 2456,
        2628, 1875, 2565, 2457, 2629, 1876, 2458, 2630, 1877, 2459, 2631, 
       1878, 2460, 2632, 1879, 2461, 2633, 1880, 2519, 2740, 2272, 2317, 2318,
        2316, 1881, 2521, 2703, 2162, 2413}], 
      Line3DBox[{2370, 2277, 2741, 2276, 1886, 2312, 2313, 2293, 2634, 2524, 
       1887, 2462, 2635, 1889, 2463, 2636, 1891, 2464, 2637, 1893, 2465, 2638,
        2639, 1895, 2467, 2641, 1897, 2468, 2642, 1899, 2469, 2643, 1901, 
       2470, 2644, 1903, 2471, 2645, 1905, 2538, 2729, 2389}], 
      Line3DBox[{2372, 2147, 2726, 2146, 1962, 2255, 2256, 2254, 2665, 2511, 
       1963, 2492, 2666, 1964, 2493, 2667, 1965, 1491, 1966, 2604, 2494, 2668,
        1967, 2495, 2669, 1968, 2496, 2670, 1969, 2497, 2671, 1970, 2534, 
       2672, 2330, 1971, 2331, 2332, 2749, 2257, 2259, 2258, 1972, 1655, 2148,
        2361, 2386}], 
      Line3DBox[{2374, 2157, 2728, 2156, 1976, 2261, 2262, 2260, 2674, 2513, 
       1977, 2498, 2675, 1978, 2499, 2676, 1979, 2500, 2677, 1980, 2501, 2678,
        2679, 1981, 2502, 2680, 1982, 2503, 2681, 1983, 2504, 2682, 1984, 
       2535, 2683, 2333, 1985, 2334, 2739, 2536, 2263, 2265, 2264, 1986, 2520,
        2713, 2158, 2416}], 
      Line3DBox[{2376, 2686, 2121, 2140, 2218, 2217, 2072, 2216, 2073, 2698, 
       1848, 2445, 2612, 1849, 2560, 2012, 1850, 2561, 2013, 1851, 2562, 2446,
        2613, 1852, 2447, 2614, 1853, 2448, 2615, 1854, 2449, 2616, 1855, 
       2530, 2617, 2323, 1856, 2324, 2699, 2074, 2220, 2075, 2305, 2221, 2222,
        2515, 2076, 2720, 2382}], 
      Line3DBox[{2377, 2122, 2425, 2422, 2700, 2077, 2078, 2427}], 
      Line3DBox[{2378, 2690, 344, 293, 2708, 1939, 2598, 2050, 1940, 2599, 
       2051, 1941, 2600, 2052, 1942, 2601, 2483, 2654, 1943, 2484, 2655, 1944,
        2485, 2656, 1945, 2486, 2657, 1946, 2748, 682, 683, 1766, 294, 652, 
       295, 2724, 2384}], Line3DBox[{2379, 345, 1615, 296, 2429}], 
      Line3DBox[{1069, 2134, 2684, 2135, 2117, 2290, 2060, 2213, 2734, 2000, 
       1829, 2548, 2001, 1830, 2549, 2002, 1831, 2550, 2003, 1832, 2551, 2437,
        2606, 1833, 2438, 2607, 1834, 1381, 1835, 2552, 2004, 1836, 2528, 
       2553, 2005, 2321, 2506, 2554, 2214, 2268, 2303, 2269, 2061, 1626, 2344,
        2392}], 
      Line3DBox[{2380, 2136, 2685, 2137, 2119, 2291, 2065, 2215, 2440, 2696, 
       1839, 2555, 2007, 1840, 2556, 2008, 1841, 2557, 2009, 1842, 2558, 2441,
        2608, 1843, 2442, 2609, 1844, 2443, 2610, 1845, 2444, 2611, 1846, 
       2529, 2559, 2010, 2322, 2745, 2066, 2219, 2270, 2304, 2271, 2067, 2514,
        2719, 2346, 2394}], 
      Line3DBox[{2381, 2138, 2689, 2139, 2132, 2302, 2098, 2246, 2479, 2706, 
       1930, 2593, 2045, 1931, 2594, 2046, 1932, 2595, 2047, 1933, 2596, 2480,
        2651, 1934, 2481, 2652, 1935, 2482, 2653, 1936, 1466, 1937, 2532, 
       2597, 2048, 2327, 2747, 2099, 2247, 2285, 2310, 2286, 2100, 2517, 2723,
        2354, 2403}], 
      Line3DBox[{2383, 2349, 2687, 2516, 2228, 2227, 2306, 2084, 2226, 2746, 
       2508, 2326, 1867, 2325, 2625, 2531, 1866, 2624, 2454, 1865, 2623, 2453,
        1864, 2622, 2452, 1863, 2621, 2451, 2564, 1862, 2014, 2563, 1861, 
       2620, 2450, 1860, 2339, 2619, 2537, 1859, 2507, 2618, 2223, 2083, 2224,
        2225, 2141, 2721, 2348, 2397}], 
      Line3DBox[{2385, 2357, 2691, 2518, 2253, 2252, 2311, 2106, 2251, 1575, 
       2329, 1957, 2328, 2664, 2533, 1956, 2663, 2491, 1955, 2662, 2490, 1954,
        2661, 2489, 1953, 2660, 2488, 2603, 1952, 2053, 2602, 1951, 1480, 
       1950, 2659, 2487, 1949, 2510, 2658, 2248, 2105, 2249, 2250, 2145, 2725,
        2356, 2406}], 
      Line3DBox[{2388, 2160, 2688, 2161, 2159, 2155, 2244, 2738, 2039, 1920, 
       2586, 2040, 1921, 2587, 2041, 1922, 2588, 2042, 1923, 2589, 2475, 2648,
        1924, 2476, 2649, 1925, 2477, 2650, 1926, 2590, 2043, 1927, 2591, 
       2044, 1928, 2509, 2592, 2245, 2283, 2284, 2094, 2705, 2144, 2352, 
       2401}], Line3DBox[{2395, 2071, 2424, 2420, 2697, 2070, 2069, 2426}], 
      Line3DBox[{2404, 292, 1566, 291, 2428}]}, {
      Line3DBox[{1177, 1364, 2540, 1178, 1375, 2548, 1202, 1385, 2555, 1215, 
       2612, 1395, 1228, 2619, 1787, 1788, 1789, 1790, 2750, 1780, 1783, 1781,
        1252, 2635, 1424, 2568, 1265, 1437, 2578, 1278, 1448, 2586, 1290, 
       1459, 2593, 1302, 1469, 2598, 1315, 2659, 1479, 1328, 2666, 1489, 1341,
        2675, 1499, 1353}], 
      Line3DBox[{1179, 1365, 2541, 1180, 1376, 2549, 1203, 1386, 2556, 1216, 
       1396, 2560, 1229, 2620, 1405, 1241, 2627, 1413, 1253, 2636, 1425, 2569,
        1266, 1438, 2579, 1279, 1449, 2587, 1291, 1460, 2594, 1303, 1470, 
       2599, 1316, 1480, 1329, 2667, 1490, 1342, 2676, 1500, 1354}], 
      Line3DBox[{1181, 1366, 2542, 1182, 1377, 2550, 1204, 1387, 2557, 1217, 
       1397, 2561, 1230, 1406, 2563, 1242, 2628, 1414, 1254, 2637, 1426, 2570,
        1267, 1439, 2580, 1280, 1450, 2588, 1292, 1461, 2595, 1304, 1471, 
       2600, 1317, 1481, 2602, 1330, 1491, 1343, 2677, 1501, 1355}], 
      Line3DBox[{1183, 1367, 2543, 1185, 1378, 2551, 1205, 1388, 2558, 1218, 
       1398, 2562, 1231, 1407, 2564, 1243, 1415, 2565, 1255, 2638, 1427, 2571,
        1268, 1440, 2581, 1281, 1451, 2589, 1293, 1462, 2596, 1305, 1472, 
       2601, 1318, 1482, 2603, 1331, 1492, 2604, 1344, 2678, 1502, 1356}], 
      Line3DBox[{1187, 1369, 1188, 2607, 1380, 1207, 2609, 1390, 1220, 2614, 
       1400, 1233, 2622, 1409, 1245, 2630, 1417, 1257, 2641, 1429, 2572, 1270,
        2647, 1442, 1283, 2649, 1453, 1295, 2652, 1464, 1307, 2655, 1474, 
       1320, 2661, 1484, 1333, 2669, 1494, 1346, 2680, 1504, 1358}], 
      Line3DBox[{1189, 1370, 2544, 1190, 1381, 1208, 2610, 1391, 1221, 2615, 
       1401, 1234, 2623, 1410, 1246, 2631, 1418, 1258, 2642, 1430, 2573, 1271,
        1443, 2582, 1284, 2650, 1454, 1296, 2653, 1465, 1308, 2656, 1475, 
       1321, 2662, 1485, 1334, 2670, 1495, 1347, 2681, 1505, 1359}], 
      Line3DBox[{1191, 1371, 2545, 1192, 1382, 2552, 1209, 2611, 1392, 1222, 
       2616, 1402, 1235, 2624, 1411, 1247, 2632, 1419, 1259, 2643, 1431, 2574,
        1272, 1444, 2583, 1285, 1455, 2590, 1297, 1466, 1309, 2657, 1476, 
       1322, 2663, 1486, 1335, 2671, 1496, 1348, 2682, 1506, 1360}], 
      Line3DBox[{1193, 1372, 2546, 1194, 1744, 1745, 2553, 1210, 1748, 1749, 
       2559, 1223, 2617, 1752, 1753, 1236, 2625, 1756, 1757, 1248, 2633, 1420,
        1260, 2644, 1432, 2575, 1273, 1445, 2584, 1286, 1456, 2591, 1298, 
       1760, 1761, 2597, 1310, 1764, 2748, 1765, 1323, 2664, 1768, 1769, 1336,
        2672, 1772, 1773, 1349, 2683, 1776, 1777, 1361}], 
      Line3DBox[{1195, 1511, 1512, 2547, 1687, 1747, 1519, 1746, 1520, 2554, 
       1689, 1751, 1527, 1750, 2745, 1528, 1691, 1755, 1534, 2699, 1754, 1535,
        1693, 1759, 2746, 1542, 1758, 1543, 1717, 2740, 1663, 1664, 1261, 
       2645, 1433, 2576, 1274, 1721, 1722, 2585, 1739, 1554, 1555, 2592, 1701,
        1763, 1561, 1762, 2747, 1562, 1703, 1767, 1568, 1766, 1569, 1705, 
       1771, 1575, 1770, 1576, 1707, 1775, 2749, 1583, 1774, 1584, 1709, 2739,
        1779, 1591, 1778, 1592, 1594}], Line3DBox[CompressedData["
1:eJwV0MkrxGEYwPF3mLFGKTcnbo6O/g03O2NfB2MrWxJZDrKGhCKhyZ6Lffln
HB2d+Mzh0/ftfZ731zSl8URVfySEkCQVDWEiK4RtJvmOhbCiNyxzkRfCn06x
wzQ/dmr0lmpCdgi1ukcdv+aH3jU431FPxE6j7tOUfsORnbje00yGnRY9oJUZ
8xxt54E2Mu2sul90XmKWa64oMDs3y9N8ipwLNcqj+TNP6W+5f9EOOimmmzX3
r9pFzJsePaWXEo7N+/WNPrLsJPSMAco4sTOk7wySbSeZ/h8ZZs68XEf5YIQc
O2OaYpwK1vlM/yZyzXe9m3e+ZIFKNvligy3+ARJOOnk=
       "]], 
      Line3DBox[{570, 415, 1620, 414, 2728, 1339, 479, 1618, 387, 2726, 1326, 
       362, 1616, 2725, 384, 1313, 361, 2690, 1614, 381, 1300, 360, 2689, 
       1613, 378, 1288, 421, 2688, 1671, 423, 1276, 2727, 1435, 1804, 1263, 
       2751, 1422, 1720, 593, 2741, 1250, 359, 1610, 373, 2722, 1239, 357, 
       1607, 2721, 370, 1226, 356, 2686, 1605, 367, 1213, 355, 2685, 1603, 
       364, 1200, 354, 2684, 1601, 399, 1175, 2693, 426, 1599, 392, 425}], 
      Line3DBox[{1352, 1498, 1590, 2674, 1340, 1488, 1582, 2665, 1327, 1478, 
       1574, 2658, 1314, 1468, 2708, 1567, 1301, 1458, 2706, 1560, 1289, 2738,
        1447, 1668, 1277, 2743, 1436, 1740, 1264, 2567, 1423, 1719, 2634, 
       1251, 1785, 1784, 1782, 1547, 2626, 1786, 1240, 1404, 1541, 2618, 1227,
        1394, 2698, 1533, 1214, 1384, 2696, 1526, 1201, 2734, 1374, 1518, 
       1176, 2733, 1363, 1509, 1510}], 
      Line3DBox[{1357, 1503, 2679, 1345, 1493, 2668, 1332, 1483, 2660, 1319, 
       1473, 2654, 1306, 1463, 2651, 1294, 1452, 2648, 1282, 1441, 2646, 1269,
        1428, 2640, 2639, 1256, 1416, 2629, 1244, 1408, 2621, 1232, 1399, 
       2613, 1219, 1389, 2608, 1206, 1379, 2606, 1186, 1368, 2605, 1184}], 
      Line3DBox[{1810, 2697, 1532, 1393, 1225, 1538, 2701, 1539, 1403, 1238, 
       1540, 2717, 1622, 1624, 1412, 1249, 2735, 1696, 1697, 1695, 1421, 2566,
        1262, 1549, 1698, 1699, 2736, 1434, 1275, 1666, 1667, 1552, 1680, 
       2732, 1446, 1287, 1553, 1559, 2704, 1457, 1299, 1565, 1566, 1812}], 
      Line3DBox[{1811, 2700, 1606, 1537, 1237, 1545, 2702, 1608, 1546, 1609, 
       1678, 2731, 1679, 1548, 1677, 1676, 1611, 1734, 1735, 1733, 1743, 1742,
        2744, 1741, 1550, 1700, 1737, 2737, 1736, 1738, 1657, 1658, 1623, 
       2718, 1551, 1612, 1557, 1564, 2707, 1558, 1311, 1571, 1615, 
       1813}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJzkfXlATV33f3PImFKmKKlU0qzpnm2qlFJCikqZMoXMiaSUEI1Cg5mikqlJ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    "]],
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->{{-2, 2}, {-2, 2}, {-1.598574695701248, 1.598574695701248}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413422056*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simple Differential Equations", "Subsubtitle"],

Cell["Mathematica is good at differential equations too!", "Text"],

Cell["Lets look at a linear  equation.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq", "=", 
  RowBox[{
   RowBox[{"m", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "'"}], "'"}], "[", "t", "]"}]}], " ", "+", " ", 
   RowBox[{"c", " ", 
    RowBox[{
     RowBox[{"x", "'"}], "[", "t", "]"}]}], " ", "+", " ", 
   RowBox[{"k", " ", 
    RowBox[{"x", "[", "t", "]"}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k", " ", 
   RowBox[{"x", "[", "t", "]"}]}], "+", 
  RowBox[{"c", " ", 
   RowBox[{
    SuperscriptBox["x", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"m", " ", 
   RowBox[{
    SuperscriptBox["x", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184413461368*^9}]
}, Open  ]],

Cell["Here is its general solution:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqSol", "=", 
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"eq", "==", "0"}], ",", 
    RowBox[{"x", "[", "t", "]"}], ",", "t"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "[", "t", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "c"}], "-", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["c", "2"], "-", 
             RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
        RowBox[{"2", " ", "m"}]]], " ", 
      RowBox[{"C", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "c"}], "+", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["c", "2"], "-", 
             RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
        RowBox[{"2", " ", "m"}]]], " ", 
      RowBox[{"C", "[", "2", "]"}]}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5184413484768*^9}]
}, Open  ]],

Cell["Here it is with initial conditions:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqSol", "=", 
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"eq", "==", "0"}], ",", 
      RowBox[{
       RowBox[{"x", "[", "0", "]"}], "==", "Xo"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"x", "'"}], "[", "0", "]"}], "==", "Vo"}]}], "}"}], ",", 
    RowBox[{"x", "[", "t", "]"}], ",", "t"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "[", "t", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "c"}], "-", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["c", "2"], "-", 
              RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
         RowBox[{"2", " ", "m"}]]], " ", "m", " ", "Vo"}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "c"}], "+", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["c", "2"], "-", 
              RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
         RowBox[{"2", " ", "m"}]]], " ", "m", " ", "Vo"}], "-", 
      RowBox[{"c", " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "c"}], "-", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["c", "2"], "-", 
              RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
         RowBox[{"2", " ", "m"}]]], " ", "Xo"}], "+", 
      RowBox[{"c", " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "c"}], "+", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["c", "2"], "-", 
              RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
         RowBox[{"2", " ", "m"}]]], " ", "Xo"}], "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "c"}], "-", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["c", "2"], "-", 
              RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
         RowBox[{"2", " ", "m"}]]], " ", 
       SqrtBox[
        RowBox[{
         SuperscriptBox["c", "2"], "-", 
         RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Xo"}], "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "c"}], "+", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["c", "2"], "-", 
              RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
         RowBox[{"2", " ", "m"}]]], " ", 
       SqrtBox[
        RowBox[{
         SuperscriptBox["c", "2"], "-", 
         RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Xo"}]}], 
     RowBox[{"2", " ", 
      SqrtBox[
       RowBox[{
        SuperscriptBox["c", "2"], "-", 
        RowBox[{"4", " ", "k", " ", "m"}]}]]}]]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5184413504268*^9}]
}, Open  ]],

Cell["Here we define a function using the solution for later use:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"x", "[", "t_", "]"}], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "t", "]"}], "/.", "eqSol"}], "//", "First"}]}]], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], " ", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "c"}], "-", 
         SqrtBox[
          RowBox[{
           SuperscriptBox["c", "2"], "-", 
           RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
      RowBox[{"2", " ", "m"}]]], " ", "m", " ", "Vo"}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "c"}], "+", 
         SqrtBox[
          RowBox[{
           SuperscriptBox["c", "2"], "-", 
           RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
      RowBox[{"2", " ", "m"}]]], " ", "m", " ", "Vo"}], "-", 
   RowBox[{"c", " ", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "c"}], "-", 
         SqrtBox[
          RowBox[{
           SuperscriptBox["c", "2"], "-", 
           RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
      RowBox[{"2", " ", "m"}]]], " ", "Xo"}], "+", 
   RowBox[{"c", " ", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "c"}], "+", 
         SqrtBox[
          RowBox[{
           SuperscriptBox["c", "2"], "-", 
           RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
      RowBox[{"2", " ", "m"}]]], " ", "Xo"}], "+", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "c"}], "-", 
         SqrtBox[
          RowBox[{
           SuperscriptBox["c", "2"], "-", 
           RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
      RowBox[{"2", " ", "m"}]]], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox["c", "2"], "-", 
      RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Xo"}], "+", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "c"}], "+", 
         SqrtBox[
          RowBox[{
           SuperscriptBox["c", "2"], "-", 
           RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
      RowBox[{"2", " ", "m"}]]], " ", 
    SqrtBox[
     RowBox[{
      SuperscriptBox["c", "2"], "-", 
      RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Xo"}]}], 
  RowBox[{"2", " ", 
   SqrtBox[
    RowBox[{
     SuperscriptBox["c", "2"], "-", 
     RowBox[{"4", " ", "k", " ", "m"}]}]]}]]], "Output",
 CellChangeTimes->{3.5184413521428003`*^9}]
}, Open  ]],

Cell["Now we plot:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"m", "=", "1"}], ";", 
  RowBox[{"c", "=", ".5"}], ";", 
  RowBox[{"k", "=", "5"}], ";", 
  RowBox[{"Xo", "=", "2"}], ";", 
  RowBox[{"Vo", "=", "0"}], ";"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "t", "]"}], "/.", "eqSol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]}], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3c81f8Xx+09rnWti8uVJCUlpfr2PkJD0kKUkMyUKAppS2UlWamQUZKs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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-1.4045094185337055`, 1.9999999999997917`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413552004004`*^9}]
}, Open  ]],

Cell["Here is the velocity", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "'"}], "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3c81d8ftve+1hUXl2xCaaicdypZSYqWVCKrJClC45sKmUVZRRkthVS2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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-3.7952222068568298`, 2.6652187596849357`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413574156*^9}]
}, Open  ]],

Cell["Clear x[t]", "Text",
 CellChangeTimes->{{3.5184413603171997`*^9, 3.5184413614091997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"x", "[", "t_", "]"}], "=."}]], "Input"],

Cell["Now use numerical solution tools:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqDsol", "=", 
  RowBox[{
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eq", "==", "0"}], ",", 
       RowBox[{
        RowBox[{"x", "[", "0", "]"}], "==", "Xo"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "'"}], "[", "0", "]"}], "==", "Vo"}]}], "}"}], ",", 
     RowBox[{"x", "[", "t", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}], "//", 
   "First"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"x", "[", "t", "]"}], "\[Rule]", 
   RowBox[{
    TagBox[
     RowBox[{"InterpolatingFunction", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
      "]"}],
     False,
     Editable->False], "[", "t", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5184413651844*^9}]
}, Open  ]],

Cell["\<\
The interpolating function is almost as useful as a real function.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "t", "]"}], "/.", "eqDsol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3c8le8btvc4xLEODqeslLRpPLdKA4lEKikiZKQiI20NM8n6qpBokZ0y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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-1.4045094560444353`, 1.9999999999997515`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413664012003`*^9}]
}, Open  ]],

Cell["\<\
Define the velocity in terms of a numerical derivative of the interpolating \
function:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", "t_", "]"}], "=", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "t", "]"}], "/.", "eqDsol"}], ",", "t"}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"InterpolatingFunction", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], "]"}],
   
   False,
   Editable->False], "[", "t", "]"}]], "Output",
 CellChangeTimes->{3.5184413680392*^9}]
}, Open  ]],

Cell["Here is the plot:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"v", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3k81F8XtmcvRhgxGGWnkKLknlJCUok2UhGhUmkTKj9KiFJUslYIWaPN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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-3.7952221076949044`, 2.665218759906878}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.518441368866*^9}]
}, Open  ]],

Cell["Next we use state-space form:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"m", "=."}], ";", 
  RowBox[{"c", "=."}], ";", 
  RowBox[{"k", "=."}], ";", 
  RowBox[{"Xo", "=."}], ";", 
  RowBox[{"Vo", "=."}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"eq1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"x1", "'"}], "[", "t", "]"}], "==", 
   RowBox[{"x2", "[", "t", "]"}]}]}], "\n", 
 RowBox[{"\t", 
  RowBox[{"eq2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"x2", "'"}], "[", "t", "]"}], "==", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "/", "m"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"c", " ", 
        RowBox[{"x2", "[", "t", "]"}]}], " ", "+", " ", 
       RowBox[{"k", " ", 
        RowBox[{"x1", "[", "t", "]"}]}]}], ")"}]}]}]}]}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["x1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
  RowBox[{"x2", "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.51844137183*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["x2", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"k", " ", 
      RowBox[{"x1", "[", "t", "]"}]}], "+", 
     RowBox[{"c", " ", 
      RowBox[{"x2", "[", "t", "]"}]}]}], "m"]}]}]], "Output",
 CellChangeTimes->{3.51844137183*^9}]
}, Open  ]],

Cell["Complete closed form solution", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol2", "=", 
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"eq1", ",", "eq2", ",", 
      RowBox[{
       RowBox[{"x1", "[", "0", "]"}], "==", "Xo"}], ",", 
      RowBox[{
       RowBox[{"x2", "[", "0", "]"}], "==", "Vo"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "[", "t", "]"}], ",", 
      RowBox[{"x2", "[", "t", "]"}]}], "}"}], ",", "t"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x1", "[", "t", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "-", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "m", " ", "Vo"}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "+", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "m", " ", "Vo"}], "-", 
       RowBox[{"c", " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "-", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "Xo"}], "+", 
       RowBox[{"c", " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "+", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "Xo"}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "-", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", 
        SqrtBox[
         RowBox[{
          SuperscriptBox["c", "2"], "-", 
          RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Xo"}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "+", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", 
        SqrtBox[
         RowBox[{
          SuperscriptBox["c", "2"], "-", 
          RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Xo"}]}], 
      RowBox[{"2", " ", 
       SqrtBox[
        RowBox[{
         SuperscriptBox["c", "2"], "-", 
         RowBox[{"4", " ", "k", " ", "m"}]}]]}]]}], ",", 
    RowBox[{
     RowBox[{"x2", "[", "t", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"c", " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "-", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "Vo"}], "-", 
       RowBox[{"c", " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "+", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "Vo"}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "-", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", 
        SqrtBox[
         RowBox[{
          SuperscriptBox["c", "2"], "-", 
          RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Vo"}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "+", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", 
        SqrtBox[
         RowBox[{
          SuperscriptBox["c", "2"], "-", 
          RowBox[{"4", " ", "k", " ", "m"}]}]], " ", "Vo"}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "-", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "k", " ", "Xo"}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "c"}], "+", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["c", "2"], "-", 
               RowBox[{"4", " ", "k", " ", "m"}]}]]}], ")"}], " ", "t"}], 
          RowBox[{"2", " ", "m"}]]], " ", "k", " ", "Xo"}]}], 
      RowBox[{"2", " ", 
       SqrtBox[
        RowBox[{
         SuperscriptBox["c", "2"], "-", 
         RowBox[{"4", " ", "k", " ", "m"}]}]]}]]}]}], "}"}], "}"}]], "Output",\

 CellChangeTimes->{3.5184413736864*^9}]
}, Open  ]],

Cell["Here are the plots of displacement and velocity.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"m", "=", "1"}], ";", 
  RowBox[{"c", "=", ".5"}], ";", 
  RowBox[{"k", "=", "5"}], ";", 
  RowBox[{"Xo", "=", "2"}], ";", 
  RowBox[{"Vo", "=", "0"}], ";"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x1", "[", "t", "]"}], "/.", "sol2"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]}], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3c81f8Xx+09rnWti8uVJCUlpfr2PkJD0kKUkMyUKAppS2UlWamQUZKs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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-1.4045094185337055`, 1.9999999999997917`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413762292*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x2", "[", "t", "]"}], "/.", "sol2"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3c81d8ftve+1hUXl2xCaaicdypZSYqWVCKrJClC45sKmUVZRRkthVS2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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-3.7952222068568298`, 2.6652187596849357`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413788032*^9}]
}, Open  ]],

Cell["Here is the numerical version of the result.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol3", "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"eq1", ",", "eq2", ",", 
      RowBox[{
       RowBox[{"x1", "[", "0", "]"}], "==", "Xo"}], ",", 
      RowBox[{
       RowBox[{"x2", "[", "0", "]"}], "==", "Vo"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "[", "t", "]"}], ",", 
      RowBox[{"x2", "[", "t", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x1", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"x2", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.51844138041*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x1", "[", "t", "]"}], "/.", "sol3"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3c81d8bz95c4loXl1uRFE3ROI9KQ9IQUVL5WhERZURJSlYhKxUySpKd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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-1.4045091636475568`, 1.9999999999991753`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413817516003`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x2", "[", "t", "]"}], "/.", "sol3"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3k81F8bHftOjG3EYJSdQkqR+0TJEqFoIUUSKkmbIvlFlJCKkkSJqGxp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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-3.7952212610737135`, 2.6652182189036444`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184413835612*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 44, 0, 83, "Title"],
Cell[626, 24, 61, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[712, 28, 38, 0, 49, "Subtitle"],
Cell[753, 30, 424, 7, 47, "Text"],
Cell[1180, 39, 146, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[1351, 46, 36, 0, 28, "Subsubtitle"],
Cell[1390, 48, 100, 2, 29, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1527, 55, 35, 0, 28, "Subsubtitle"],
Cell[1565, 57, 405, 10, 101, "Text"],
Cell[1973, 69, 72, 0, 29, "Text"],
Cell[2048, 71, 233, 4, 29, "Text"],
Cell[2284, 77, 98, 2, 29, "Text"],
Cell[2385, 81, 21458, 947, 122, 19973, 920, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23892, 1034, 115, 1, 49, "Subtitle"],
Cell[24010, 1037, 2002, 49, 371, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26049, 1091, 42, 0, 49, "Subtitle"],
Cell[26094, 1093, 214, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[26333, 1101, 81, 2, 31, "Input",
 InitializationCell->False],
Cell[26417, 1105, 96, 1, 30, "Output"]
}, Open  ]],
Cell[26528, 1109, 131, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[26684, 1116, 151, 3, 31, "Input"],
Cell[26838, 1121, 109, 1, 30, "Output"]
}, Open  ]],
Cell[26962, 1125, 161, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[27148, 1132, 77, 2, 31, "Input"],
Cell[27228, 1136, 105, 1, 30, "Output"]
}, Open  ]],
Cell[27348, 1140, 187, 5, 65, "Text"],
Cell[CellGroupData[{
Cell[27560, 1149, 105, 3, 31, "Input"],
Cell[27668, 1154, 114, 2, 30, "Output"]
}, Open  ]],
Cell[27797, 1159, 18, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[27840, 1163, 86, 2, 31, "Input"],
Cell[27929, 1167, 114, 2, 30, "Output"]
}, Open  ]],
Cell[28058, 1172, 66, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[28149, 1176, 77, 2, 31, "Input"],
Cell[28229, 1180, 114, 2, 30, "Output"]
}, Open  ]],
Cell[28358, 1185, 18, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[28401, 1189, 72, 2, 31, "Input"],
Cell[28476, 1193, 110, 2, 30, "Output"]
}, Open  ]],
Cell[28601, 1198, 69, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[28695, 1202, 86, 2, 31, "Input"],
Cell[28784, 1206, 353, 12, 44, "Output"]
}, Open  ]],
Cell[29152, 1221, 170, 3, 29, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29359, 1229, 34, 0, 49, "Subtitle"],
Cell[29396, 1231, 135, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[29556, 1238, 53, 1, 31, "Input"],
Cell[29612, 1241, 98, 1, 30, "Output"]
}, Open  ]],
Cell[29725, 1245, 127, 3, 29, "Text"],
Cell[29855, 1250, 175, 5, 31, "Input"],
Cell[30033, 1257, 147, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[30205, 1264, 54, 1, 31, "Input"],
Cell[30262, 1267, 181, 4, 30, "Output"]
}, Open  ]],
Cell[30458, 1274, 131, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[30614, 1281, 57, 1, 31, "Input"],
Cell[30674, 1284, 175, 4, 30, "Output"]
}, Open  ]],
Cell[30864, 1291, 18, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[30907, 1295, 54, 1, 31, "Input"],
Cell[30964, 1298, 91, 1, 30, "Output"]
}, Open  ]],
Cell[31070, 1302, 61, 0, 29, "Text"],
Cell[31134, 1304, 234, 7, 31, "Input"],
Cell[31371, 1313, 19, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[31415, 1317, 77, 2, 31, "Input"],
Cell[31495, 1321, 86, 1, 30, "Output"]
}, Open  ]],
Cell[31596, 1325, 53, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[31674, 1329, 77, 2, 31, "Input"],
Cell[31754, 1333, 117, 3, 30, "Output"]
}, Open  ]],
Cell[31886, 1339, 74, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[31985, 1343, 77, 2, 31, "Input"],
Cell[32065, 1347, 169, 5, 30, "Output"]
}, Open  ]],
Cell[32249, 1355, 71, 0, 29, "Text"],
Cell[32323, 1357, 150, 5, 31, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32510, 1367, 39, 0, 49, "Subtitle"],
Cell[32552, 1369, 136, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[32713, 1376, 31, 0, 28, "Subsubtitle"],
Cell[32747, 1378, 46, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[32818, 1382, 229, 7, 31, "Input"],
Cell[33050, 1391, 9386, 160, 231, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42473, 1556, 229, 7, 31, "Input"],
Cell[42705, 1565, 8584, 147, 231, "Output"]
}, Open  ]],
Cell[51304, 1715, 55, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[51384, 1719, 88, 2, 31, "Input"],
Cell[51475, 1723, 17559, 295, 231, "Output"]
}, Open  ]],
Cell[69049, 2021, 54, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[69128, 2025, 389, 12, 31, "Input"],
Cell[69520, 2039, 181353, 2956, 303, 91064, 1474, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[250888, 4998, 452, 7, 47, "Text"],
Cell[CellGroupData[{
Cell[251365, 5009, 746, 22, 31, "Input"],
Cell[252114, 5033, 2006, 40, 382, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[254169, 5079, 37, 0, 28, "Subsubtitle"],
Cell[254209, 5081, 40, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[254274, 5085, 267, 9, 31, "Input"],
Cell[254544, 5096, 261, 9, 33, "Output"]
}, Open  ]],
Cell[254820, 5108, 39, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[254884, 5112, 62, 1, 31, "Input"],
Cell[254949, 5115, 282, 8, 30, "Output"]
}, Open  ]],
Cell[255246, 5126, 95, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[255366, 5132, 59, 1, 31, "Input"],
Cell[255428, 5135, 261, 9, 33, "Output"]
}, Open  ]],
Cell[255704, 5147, 33, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[255762, 5151, 247, 7, 31, "Input"],
Cell[256012, 5160, 251, 7, 30, "Output"]
}, Open  ]],
Cell[256278, 5170, 33, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[256336, 5174, 62, 1, 31, "Input"],
Cell[256401, 5177, 246, 8, 33, "Output"]
}, Open  ]],
Cell[256662, 5188, 34, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[256721, 5192, 146, 4, 31, "Input"],
Cell[256870, 5198, 156, 4, 30, "Output"]
}, Open  ]],
Cell[257041, 5205, 67, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[257133, 5209, 109, 3, 31, "Input"],
Cell[257245, 5214, 643, 22, 47, "Output"]
}, Open  ]],
Cell[257903, 5239, 44, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[257972, 5243, 163, 5, 31, "Input"],
Cell[258138, 5250, 4230, 75, 238, "Output"]
}, Open  ]],
Cell[262383, 5328, 52, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[262460, 5332, 110, 3, 31, "Input"],
Cell[262573, 5337, 556, 15, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[263178, 5358, 38, 0, 28, "Subsubtitle"],
Cell[263219, 5360, 52, 0, 29, "Text"],
Cell[263274, 5362, 60, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[263359, 5366, 30, 0, 31, "Input"],
Cell[263392, 5368, 229, 7, 30, "Output"]
}, Open  ]],
Cell[263636, 5378, 50, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[263711, 5382, 80, 2, 31, "Input"],
Cell[263794, 5386, 175, 5, 30, "Output"]
}, Open  ]],
Cell[263984, 5394, 37, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[264046, 5398, 58, 1, 31, "Input"],
Cell[264107, 5401, 304, 9, 30, "Output"]
}, Open  ]],
Cell[264426, 5413, 40, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[264491, 5417, 81, 2, 31, "Input"],
Cell[264575, 5421, 379, 12, 30, "Output"]
}, Open  ]],
Cell[264969, 5436, 110, 3, 29, "Text"],
Cell[265082, 5441, 92, 2, 29, "Text"],
Cell[265177, 5445, 82, 2, 31, "Input"],
Cell[265262, 5449, 50, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[265337, 5453, 109, 3, 31, "Input"],
Cell[265449, 5458, 171, 5, 30, "Output"]
}, Open  ]],
Cell[265635, 5466, 35, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[265695, 5470, 168, 5, 31, "Input"],
Cell[265866, 5477, 350, 12, 50, "Output"]
}, Open  ]],
Cell[266231, 5492, 47, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[266303, 5496, 54, 1, 31, "Input"],
Cell[266360, 5499, 90, 2, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[266487, 5506, 189, 6, 31, "Input"],
Cell[266679, 5514, 6678, 115, 244, "Output"]
}, Open  ]],
Cell[273372, 5632, 18, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[273415, 5636, 190, 6, 43, "Input"],
Cell[273608, 5644, 346, 12, 50, "Output"]
}, Open  ]],
Cell[273969, 5659, 32, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[274026, 5663, 54, 1, 31, "Input"],
Cell[274083, 5666, 90, 2, 47, "Output"]
}, Open  ]],
Cell[274188, 5671, 50, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[274263, 5675, 194, 6, 31, "Input"],
Cell[274460, 5683, 68, 1, 30, "Output"]
}, Open  ]],
Cell[274543, 5687, 18, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[274586, 5691, 186, 6, 44, "Input"],
Cell[274775, 5699, 68, 1, 30, "Output"]
}, Open  ]],
Cell[274858, 5703, 86, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[274969, 5709, 279, 8, 43, "Input"],
Cell[275251, 5719, 697, 21, 47, "Output"]
}, Open  ]],
Cell[275963, 5743, 54, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[276042, 5747, 284, 9, 31, "Input"],
Cell[276329, 5758, 249882, 4078, 309, 175522, 2857, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[526226, 9839, 51, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[526302, 9843, 284, 9, 31, "Input"],
Cell[526589, 9854, 104961, 1705, 316, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[631599, 11565, 52, 0, 28, "Subsubtitle"],
Cell[631654, 11567, 66, 0, 29, "Text"],
Cell[631723, 11569, 48, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[631796, 11573, 329, 11, 31, "Input"],
Cell[632128, 11586, 390, 12, 30, "Output"]
}, Open  ]],
Cell[632533, 11601, 45, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[632603, 11605, 177, 5, 31, "Input"],
Cell[632783, 11612, 1008, 32, 63, "Output"]
}, Open  ]],
Cell[633806, 11647, 51, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[633882, 11651, 388, 12, 31, "Input"],
Cell[634273, 11665, 3054, 93, 87, "Output"]
}, Open  ]],
Cell[637342, 11761, 75, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[637442, 11765, 165, 5, 31, "Input"],
Cell[637610, 11772, 2689, 89, 87, "Output"]
}, Open  ]],
Cell[640314, 11864, 28, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[640367, 11868, 387, 12, 52, "Input"],
Cell[640757, 11882, 21715, 362, 230, "Output"]
}, Open  ]],
Cell[662487, 12247, 36, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[662548, 12251, 189, 6, 31, "Input"],
Cell[662740, 12259, 21162, 353, 233, "Output"]
}, Open  ]],
Cell[683917, 12615, 96, 1, 29, "Text"],
Cell[684016, 12618, 74, 2, 31, "Input"],
Cell[684093, 12622, 49, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[684167, 12626, 497, 16, 31, "Input"],
Cell[684667, 12644, 410, 14, 30, "Output"]
}, Open  ]],
Cell[685092, 12661, 90, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[685207, 12667, 200, 6, 31, "Input"],
Cell[685410, 12675, 21711, 362, 230, "Output"]
}, Open  ]],
Cell[707136, 13040, 111, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[707272, 13047, 196, 7, 31, "Input"],
Cell[707471, 13056, 309, 11, 30, "Output"]
}, Open  ]],
Cell[707795, 13070, 33, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[707853, 13074, 169, 5, 31, "Input"],
Cell[708025, 13081, 21155, 353, 233, "Output"]
}, Open  ]],
Cell[729195, 13437, 45, 0, 29, "Text"],
Cell[729243, 13439, 181, 6, 31, "Input"],
Cell[CellGroupData[{
Cell[729449, 13449, 545, 19, 52, "Input"],
Cell[729997, 13470, 214, 6, 30, "Output"],
Cell[730214, 13478, 368, 12, 47, "Output"]
}, Open  ]],
Cell[730597, 13493, 45, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[730667, 13497, 437, 13, 31, "Input"],
Cell[731107, 13512, 6179, 184, 174, "Output"]
}, Open  ]],
Cell[737301, 13699, 64, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[737390, 13703, 387, 12, 52, "Input"],
Cell[737780, 13717, 21711, 362, 230, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[759528, 14084, 199, 6, 31, "Input"],
Cell[759730, 14092, 21162, 353, 233, "Output"]
}, Open  ]],
Cell[780907, 14448, 60, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[780992, 14452, 500, 15, 31, "Input"],
Cell[781495, 14469, 825, 28, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[782357, 14502, 199, 6, 31, "Input"],
Cell[782559, 14510, 21699, 362, 230, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[804295, 14877, 199, 6, 31, "Input"],
Cell[804497, 14885, 21166, 353, 233, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

