(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    184375,       4071]
NotebookOptionsPosition[    178285,       3850]
NotebookOutlinePosition[    178902,       3874]
CellTagsIndexPosition[    178859,       3871]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
Run commands by typing <command> Enter or the Enter key on the keypad.

Double click the \"arrowed\" brace on the right to open up a cell.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["Input the vector definition with the command that follows.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Get", "[", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<vectors3.m\>\""}], 
   "]"}], "]"}]], "Input",
 CellChangeTimes->{
  3.5184494348887997`*^9, {3.518449508318*^9, 3.5184495083336*^9}, 
   3.53626474805453*^9},
 AspectRatioFixed->True],

Cell[BoxData["\<\"These Engineering Vector algorithms are copyright Alan A. \
Barhorst\"\>"], "Print",
 CellChangeTimes->{
  3.5184494392567997`*^9, {3.5184495117032003`*^9, 3.5184495192692003`*^9}, 
   3.536264763215639*^9}]
}, Open  ]],

Cell["Define Unit Vectors.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"B", ",", "b", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"C", ",", "c", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"n", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"N", ",", "n", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"bb", "[", 
   RowBox[{"a_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"unitDyad", "[", 
   RowBox[{
    RowBox[{"b", "[", "a", "]"}], ",", 
    RowBox[{"b", "[", "c", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"cc", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"unitDyad", "[", 
   RowBox[{
    RowBox[{"c", "[", "a", "]"}], ",", 
    RowBox[{"c", "[", "b", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.518449442642*^9, 3.518449442642*^9}},
 AspectRatioFixed->True],

Cell["Define Fixed Identities.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "Dot", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"b", "[", "3", "]"}]}], ":=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"c", "[", "3", "]"}]}], ":=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], ".", 
    RowBox[{"c", "[", "3", "]"}]}], ":=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "1", "]"}], ".", 
    RowBox[{"c", "[", "3", "]"}]}], ":=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], ".", 
    RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], ".", 
    RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "Dot", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "Cross", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"b", "[", "3", "]"}]}], " ", ":=", " ", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"b", "[", "1", "]"}]}], ":=", 
   RowBox[{"b", "[", "2", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"b", "[", "2", "]"}]}], ":=", 
   RowBox[{"-", 
    RowBox[{"b", "[", "1", "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"c", "[", "1", "]"}]}], ":=", 
   RowBox[{"c", "[", "2", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"c", "[", "2", "]"}]}], ":=", 
   RowBox[{"-", 
    RowBox[{"c", "[", "1", "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"c", "[", "1", "]"}]}], ":=", 
   RowBox[{"c", "[", "2", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"c", "[", "1", "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
   RowBox[{"b", "[", "2", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "3", "]"}], "\[Cross]", 
    RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"b", "[", "1", "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "Cross", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5184494454656*^9, 3.5184494454656*^9}, {
  3.5184495450092*^9, 3.5184496027855997`*^9}},
 AspectRatioFixed->True],

Cell["Calculate Angular Velocity.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NwB", "=", 
  RowBox[{
   RowBox[{"omega", "[", 
    RowBox[{"N", ",", "B"}], "]"}], "=", 
   RowBox[{
    RowBox[{"u1", "[", "t", "]"}], " ", 
    RowBox[{"b", "[", "3", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5184494506136*^9, 3.5184494506136*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"u1", "[", "t", "]"}], " ", 
  SubscriptBox[
   OverscriptBox["b", "^"], "3"]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.51844960745*^9, 3.536264763381928*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NwC", "=", 
  RowBox[{
   RowBox[{"omega", "[", 
    RowBox[{"N", ",", "C"}], "]"}], "=", 
   RowBox[{"NwB", " ", "+", " ", 
    RowBox[{
     RowBox[{"u2", "[", "t", "]"}], " ", 
     RowBox[{"c", "[", "3", "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.5184494554496*^9, 3.5184494554496*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"u1", "[", "t", "]"}], " ", 
   SubscriptBox[
    OverscriptBox["b", "^"], "3"]}], "+", 
  RowBox[{
   RowBox[{"u2", "[", "t", "]"}], " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184496095872*^9, 3.536264763447747*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Position vectors for Special Points.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OrS1", "=", 
  RowBox[{"0", " ", 
   RowBox[{"b", "[", "1", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494564792*^9, 3.5184494564792*^9}},
 AspectRatioFixed->True],

Cell[BoxData["0"], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184496110536003`*^9, 3.536264763482766*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OrS2", "=", 
  RowBox[{"l1", " ", 
   RowBox[{"b", "[", "1", "]"}], " "}]}]], "Input",
 CellChangeTimes->{{3.5184494578676*^9, 3.5184494578676*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"l1", " ", 
  SubscriptBox[
   OverscriptBox["b", "^"], "1"]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184496159519997`*^9, 3.536264763514949*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Make constants that.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"l1", ",", "l2"}], "}"}], ",", "Constant"}], "]"}]], "Input",
 CellChangeTimes->{{3.5184496244852*^9, 3.5184496244852*^9}},
 AspectRatioFixed->True],

Cell["Calculate velocities of special points.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NvS1", " ", "=", " ", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", "OrS1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5184494586164*^9, 3.5184494586164*^9}},
 AspectRatioFixed->True],

Cell[BoxData["0"], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497708132*^9, 3.536264763563838*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NvS2", " ", "=", " ", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", "OrS2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.518449459256*^9, 3.518449459256*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"l1", " ", 
  RowBox[{"u1", "[", "t", "]"}], " ", 
  SubscriptBox[
   OverscriptBox["b", "^"], "2"]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497715776*^9, 3.536264763598864*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Calculate Acceleration of CGs.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Nacg1", "=", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", 
    RowBox[{"DvDt", "[", 
     RowBox[{"N", ",", 
      RowBox[{"l1", " ", 
       RowBox[{"b", "[", "1", "]"}]}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5184494618143997`*^9, 3.5184494618143997`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"l1", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox[
       RowBox[{"u1", "[", "t", "]"}], "2"]}], " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "1"]}], "+", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], " ", 
     RowBox[{
      SuperscriptBox["u1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.518449772888*^9, 3.5362647636319942`*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Nacg2", "=", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", 
    RowBox[{"DvDt", "[", 
     RowBox[{"N", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"l1", " ", 
         RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
        RowBox[{"l2", " ", 
         RowBox[{"c", "[", "1", "]"}]}]}], ")"}]}], "]"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.5184494622980003`*^9, 3.5184494623136*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"l1", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox[
        RowBox[{"u1", "[", "t", "]"}], "2"]}], " ", 
      SubscriptBox[
       OverscriptBox["b", "^"], "1"]}], "+", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], " ", 
      RowBox[{
       SuperscriptBox["u1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{"l2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"u1", "[", "t", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"u1", "[", "t", "]"}]}], " ", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], "-", 
        RowBox[{
         RowBox[{"u2", "[", "t", "]"}], " ", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"u2", "[", "t", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"u1", "[", "t", "]"}]}], " ", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], "-", 
        RowBox[{
         RowBox[{"u2", "[", "t", "]"}], " ", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], ")"}]}], "+", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], " ", 
      RowBox[{
       SuperscriptBox["u1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], " ", 
      RowBox[{
       SuperscriptBox["u2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497735432*^9, 3.536264763666506*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Angular accelerations.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NaB", "=", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", "NwB"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5184494630624*^9, 3.5184494630624*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["b", "^"], "3"], " ", 
  RowBox[{
   SuperscriptBox["u1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497748224*^9, 3.53626476369971*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NaC", "=", 
  RowBox[{"DvDt", "[", 
   RowBox[{"N", ",", "NwC"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5184494637332*^9, 3.5184494637332*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox[
    OverscriptBox["b", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{
   SubscriptBox[
    OverscriptBox["c", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497754463997`*^9, 3.536264763732821*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Forces and torques.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"F1", " ", "=", " ", 
  RowBox[{
   RowBox[{"-", "m1"}], " ", "g", " ", 
   RowBox[{"n", "[", "2", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.518449465262*^9, 3.518449465262*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "g"}], " ", "m1", " ", 
  SubscriptBox[
   OverscriptBox["n", "^"], "2"]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497768816*^9, 3.5362647637662373`*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"F2", " ", "=", " ", 
  RowBox[{
   RowBox[{"-", "m2"}], " ", "g", " ", 
   RowBox[{"n", "[", "2", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494657455997`*^9, 3.5184494657455997`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "g"}], " ", "m2", " ", 
  SubscriptBox[
   OverscriptBox["n", "^"], "2"]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.518449777568*^9, 3.5362647637990837`*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T1", "=", " ", 
  RowBox[{"l1", " ", 
   RowBox[{
    RowBox[{"b", "[", "1", "]"}], "\[Cross]", " ", "F1"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494662604*^9, 3.518449466276*^9}, {
  3.5184497812028*^9, 3.518449784666*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "g"}], " ", "l1", " ", "m1", " ", 
  RowBox[{
   SubscriptBox[
    OverscriptBox["b", "^"], "1"], "\[Cross]", 
   SubscriptBox[
    OverscriptBox["n", "^"], "2"]}]}]], "Output",
 CellChangeTimes->{3.51844979309*^9, 3.536264763833301*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"T2", " ", "=", " ", 
  RowBox[{"l2", " ", 
   RowBox[{
    RowBox[{"c", "[", "1", "]"}], "\[Cross]", " ", "F2"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494668064003`*^9, 3.5184494668064003`*^9}, {
  3.5184497873336*^9, 3.5184497904224*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "g"}], " ", "l2", " ", "m2", " ", 
  RowBox[{
   SubscriptBox[
    OverscriptBox["c", "^"], "1"], "\[Cross]", 
   SubscriptBox[
    OverscriptBox["n", "^"], "2"]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497914052*^9, 3.536264763866302*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Inetia forc from d'Alembert's principle.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"I1", " ", "=", " ", 
  RowBox[{"m1", " ", "Nacg1"}]}]], "Input",
 CellChangeTimes->{{3.5184494678984003`*^9, 3.5184494678984003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"l1", " ", "m1", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox[
       RowBox[{"u1", "[", "t", "]"}], "2"]}], " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "1"]}], "+", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], " ", 
     RowBox[{
      SuperscriptBox["u1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184497995172*^9, 3.536264763900681*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"I2", " ", "=", " ", 
  RowBox[{"m2", " ", "Nacg2"}]}]], "Input",
 CellChangeTimes->{{3.5184494719388*^9, 3.5184494719388*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"m2", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"l1", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox[
          RowBox[{"u1", "[", "t", "]"}], "2"]}], " ", 
        SubscriptBox[
         OverscriptBox["b", "^"], "1"]}], "+", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], " ", 
        RowBox[{
         SuperscriptBox["u1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
    RowBox[{"l2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"u1", "[", "t", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"u1", "[", "t", "]"}]}], " ", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], "-", 
          RowBox[{
           RowBox[{"u2", "[", "t", "]"}], " ", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}]}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"u2", "[", "t", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"u1", "[", "t", "]"}]}], " ", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], "-", 
          RowBox[{
           RowBox[{"u2", "[", "t", "]"}], " ", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}]}], ")"}]}], "+", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "2"], " ", 
        RowBox[{
         SuperscriptBox["u1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "2"], " ", 
        RowBox[{
         SuperscriptBox["u2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184498003596*^9, 3.536264763935296*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Inertia Dyadics.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ivv1", "=", 
  RowBox[{"m1", " ", 
   RowBox[{"l1", "^", "2"}], " ", 
   RowBox[{"bb", "[", 
    RowBox[{"3", ",", "3"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.518449474778*^9, 3.518449474778*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["l1", "2"], " ", "m1", " ", 
  RowBox[{"(", 
   InterpretationBox[
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "3"], "\[InvisibleSpace]", 
     SubscriptBox[
      OverscriptBox["b", "^"], "3"]}],
    SequenceForm[
     $CellContext`unitVector[$CellContext`B, $CellContext`b, 3], 
     $CellContext`unitVector[$CellContext`B, $CellContext`b, 3]],
    Editable->False], ")"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184515966684*^9, 3.536264763968383*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ivv2", " ", "=", " ", 
  RowBox[{"m2", " ", 
   RowBox[{"l2", "^", "2"}], " ", 
   RowBox[{"cc", "[", 
    RowBox[{"3", ",", "3"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494757139997`*^9, 3.5184494757139997`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["l2", "2"], " ", "m2", " ", 
  RowBox[{"(", 
   InterpretationBox[
    RowBox[{
     SubscriptBox[
      OverscriptBox["c", "^"], "3"], "\[InvisibleSpace]", 
     SubscriptBox[
      OverscriptBox["c", "^"], "3"]}],
    SequenceForm[
     $CellContext`unitVector[C, $CellContext`c, 3], 
     $CellContext`unitVector[C, $CellContext`c, 3]],
    Editable->False], ")"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184515974796*^9, 3.536264764001335*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Rotational Inertia torque.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"J1", " ", "=", " ", 
  RowBox[{
   RowBox[{"Ivv1", " ", ".", " ", "NaB"}], " ", "+", " ", 
   RowBox[{
    RowBox[{"NwB", "\[Cross]", " ", "Ivv1"}], " ", ".", " ", 
    "NwB"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494765252*^9, 3.5184494765252*^9}, {
  3.5184516048584003`*^9, 3.5184516081812*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["l1", "2"], " ", "m1", " ", 
  SubscriptBox[
   OverscriptBox["b", "^"], "3"], " ", 
  RowBox[{
   SuperscriptBox["u1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184516091172*^9, 3.536264764034218*^9}]
}, Open  ]],

Cell["Ditto for body 2.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NaS2", " ", "=", " ", 
  RowBox[{"Nacg1", "//", "distributeScalars"}]}]], "Input",
 CellChangeTimes->{{3.5184494775704*^9, 3.518449477586*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "l1"}], " ", 
   SuperscriptBox[
    RowBox[{"u1", "[", "t", "]"}], "2"], " ", 
   SubscriptBox[
    OverscriptBox["b", "^"], "1"]}], "+", 
  RowBox[{"l1", " ", 
   SubscriptBox[
    OverscriptBox["b", "^"], "2"], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516111140003`*^9, 3.53626476406736*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"J2", " ", "=", " ", 
  RowBox[{
   RowBox[{"l2", " ", "m2", " ", 
    RowBox[{
     RowBox[{"c", "[", "1", "]"}], " ", "\[Cross]", " ", "NaS2"}]}], " ", "+",
    " ", 
   RowBox[{"Ivv2", " ", ".", " ", "NaC"}], " ", "+", " ", 
   RowBox[{
    RowBox[{"NwC", "\[Cross]", " ", "Ivv2"}], " ", ".", " ", 
    "NwC"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494805968*^9, 3.5184494805968*^9}, {3.518451614*^9, 
  3.5184516215816*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "l1"}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "1"], "\[Cross]", 
       SubscriptBox[
        OverscriptBox["b", "^"], "1"]}], " ", 
      SuperscriptBox[
       RowBox[{"u1", "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"l1", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "1"], "\[Cross]", 
       SubscriptBox[
        OverscriptBox["b", "^"], "2"]}], " ", 
      RowBox[{
       SuperscriptBox["u1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516229076*^9, 3.5362647641025743`*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Equations of motion.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NvS1", ",", 
        RowBox[{"u1", "[", "t", "]"}]}], "]"}], " ", ".", " ", 
      RowBox[{"(", 
       RowBox[{"F1", " ", "-", " ", "I1"}], ")"}]}], " ", "+", " ", 
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NvS2", ",", 
        RowBox[{"u1", "[", "t", "]"}]}], "]"}], ".", "\n", 
      RowBox[{"(", 
       RowBox[{"F2", " ", "-", " ", "I2"}], ")"}]}], " ", "+", " ", 
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NwB", ",", 
        RowBox[{"u1", "[", "t", "]"}]}], "]"}], ".", 
      RowBox[{"(", 
       RowBox[{"T1", " ", "-", " ", "J1"}], ")"}]}], " ", "+", " ", 
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NwC", ",", 
        RowBox[{"u1", "[", "t", "]"}]}], "]"}], ".", "\n", 
      RowBox[{"(", 
       RowBox[{"T2", " ", "-", " ", "J2"}], ")"}]}]}], "//", 
    "distributeScalars"}], "//", "loosenDots"}]}]], "Input",
 CellChangeTimes->{{3.5184494813612003`*^9, 3.5184494813612003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "l1", " ", "m1", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["n", "^"], "2"]}]}], "-", 
  RowBox[{"g", " ", "l1", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["n", "^"], "2"]}]}], "-", 
  RowBox[{"g", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["n", "^"], "2"]}]}], "+", 
  RowBox[{"2", " ", "l1", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{"u1", "[", "t", "]"}], " ", 
   RowBox[{"u2", "[", "t", "]"}]}], "+", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   SuperscriptBox[
    RowBox[{"u2", "[", "t", "]"}], "2"]}], "-", 
  RowBox[{
   SuperscriptBox["l1", "2"], " ", "m1", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l1", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516259184*^9, 3.536264764136297*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Transform vectors.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"transForm", "[", "x_", "]"}], ":=", 
  RowBox[{"x", " ", "//.", 
   RowBox[{"{", "\n", 
    RowBox[{
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], " ", "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"n", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"n", "[", "2", "]"}]}]}]}], ",", "\n", 
     RowBox[{
      RowBox[{"b", "[", "2", "]"}], " ", "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}]}], " ", 
        RowBox[{"n", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"n", "[", "2", "]"}]}]}]}], ",", "\n", 
     RowBox[{
      RowBox[{"c", "[", "1", "]"}], " ", "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", "\n", 
     RowBox[{
      RowBox[{"c", "[", "2", "]"}], " ", "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494829056*^9, 3.5184494829056*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom1", "=", 
  RowBox[{"eom1", "//", "transForm"}]}]], "Input",
 CellChangeTimes->{{3.5184494857292*^9, 3.5184494857292*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "l1", " ", "m1", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
  RowBox[{"g", " ", "l1", " ", "m2", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
  RowBox[{"g", " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{"2", " ", "l1", " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   RowBox[{"u1", "[", "t", "]"}], " ", 
   RowBox[{"u2", "[", "t", "]"}]}], "+", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u2", "[", "t", "]"}], "2"]}], "-", 
  RowBox[{
   SuperscriptBox["l1", "2"], " ", "m1", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l1", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"2", " ", "l1", " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"]}]}], ")"}], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"]}]}], ")"}], " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516327824*^9, 3.536264764202484*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NvS1", ",", 
        RowBox[{"u2", "[", "t", "]"}]}], "]"}], " ", ".", " ", 
      RowBox[{"(", 
       RowBox[{"F1", " ", "-", " ", "I1"}], ")"}]}], " ", "+", " ", 
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NvS2", ",", 
        RowBox[{"u2", "[", "t", "]"}]}], "]"}], ".", "\n", 
      RowBox[{"(", 
       RowBox[{"F2", " ", "-", " ", "I2"}], ")"}]}], " ", "+", " ", 
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NwB", ",", 
        RowBox[{"u2", "[", "t", "]"}]}], "]"}], ".", 
      RowBox[{"(", 
       RowBox[{"T1", " ", "-", " ", "J1"}], ")"}]}], " ", "+", " ", 
     RowBox[{
      RowBox[{"Pvel", "[", 
       RowBox[{"NwC", ",", 
        RowBox[{"u2", "[", "t", "]"}]}], "]"}], ".", "\n", 
      RowBox[{"(", 
       RowBox[{"T2", " ", "-", " ", "J2"}], ")"}]}]}], "//", 
    "distributeScalars"}], "//", "loosenDots"}]}]], "Input",
 CellChangeTimes->{{3.5184494863844*^9, 3.5184494863844*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["n", "^"], "2"]}]}], "+", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"u1", "[", "t", "]"}], "2"]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516345608*^9, 3.53626476423612*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["eom2=eom2//transForm", "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox[
        RowBox[{"Cos", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], "2"]}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "-", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u1", "[", "t", "]"}], "2"]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l1", " ", "l2", " ", "m2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"]}]}], ")"}], " ", 
   RowBox[{
    SuperscriptBox["u1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l2", "2"], " ", "m2", " ", 
   RowBox[{
    SuperscriptBox["u2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516364172*^9, 3.5362647642683163`*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Kinematic differential equations.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom3", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"q1", "'"}], "[", "t", "]"}], " ", "-", " ", 
   RowBox[{"u1", "[", "t", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494881472*^9, 3.5184494944184*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"u1", "[", "t", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["q1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516380708*^9, 3.536264764367104*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom4", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"q2", "'"}], "[", "t", "]"}], " ", "-", " ", 
   RowBox[{"u2", "[", "t", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5184494908616*^9, 3.5184494908616*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"u2", "[", "t", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["q2", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516393032*^9, 3.536264764384667*^9},
 LineSpacing->{1, 0},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Solve.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tfinal", "=", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l1", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l2", "=", ".75"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"m1", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"m2", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"g", "=", "9.81"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"NDSolve", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"eom1", "==", "0"}], ",", 
        RowBox[{"eom2", "==", "0"}], ",", 
        RowBox[{"eom3", "==", "0"}], ",", 
        RowBox[{"eom4", "==", "0"}], ",", "\n", 
        RowBox[{
         RowBox[{"u1", "[", "0", "]"}], "==", "0"}], ",", 
        RowBox[{
         RowBox[{"u2", "[", "0", "]"}], "==", "0"}], ",", 
        RowBox[{
         RowBox[{"q1", "[", "0", "]"}], "==", " ", 
         RowBox[{
          RowBox[{"-", "Pi"}], "/", "18"}]}], ",", 
        RowBox[{
         RowBox[{"q2", "[", "0", "]"}], "==", "0"}]}], "}"}], "]"}], ",", 
     "\n", 
     RowBox[{"{", 
      RowBox[{"q1", ",", "q2", ",", "u1", ",", "u2"}], "}"}], ",", "\n", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "tfinal"}], "}"}], ",", 
     RowBox[{"MaxSteps", "->", "5000"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5184494975072002`*^9, 3.5184494975072002`*^9}, {
  3.5184516463388*^9, 3.5184516520796003`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"q1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tfinal"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"q2", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tfinal"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"u1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tfinal"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"u2", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tfinal"}], "}"}]}], "]"}], "\n"}], "Input",
 CellChangeTimes->{{3.5184494995196*^9, 3.5184494995196*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVmnk4lN8bxm0zrxBj3xlDKUkp0aLeR0UlZElK8i0pWyRSitK+WUJR9ohs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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-2.9654814748058054`, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516543416*^9, 3.536264764483766*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUlnc41u8Xx+1sD4/REEIiEioN6twaWkRWS/JFSUqKNNBAJSFkr8jIlpEQ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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-0.5591084476404895, 0.5619126538762954}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516543416*^9, 3.5362647644909697`*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUWHc81d8b/9z1+djjXtyrlJVRhNAQdR5KthBRoaKSRNpEU6lkJVIpLS3J
KDJS94RKikjfsiJb2ZI9fvf31309r+dzzrPf7+dcZa99TjvpBEFokQTx/99b
J7zIJTsurVbapB8iFIHflFQr2boq+aIBTbtTZa7J/Nn3b8KUlIJRSjiz1981
nX8LRymylC6i9IEDhi0b3/D3rjrsP6p4HZUpS5LKLhX86snd8QOKT1C18aKu
MbtGPlXfotGrmI8WHanvf6nVx6/Brw/3dOWjm5t/aqTK9/NTH14r7s4qQDoz
exxuMQb49gfst/5ZU4hIvWKr6IEB/lXhgqudPnzkbUjcv/lhiM++WUof/FGE
en5dk9/uM8K/W3Z7f7fiR3SUsZ5Tsn6aP3wtZ1FT5EfUtXmM7Hw7zV/n86n1
6/hHJKW+KUzLYIbfwxh1KaguQwd4LzSn2bP8FavsV148/xl9XFXUfNKbwJUZ
U3SN/i/o8VzyPkzTMBsJe4rrVCLnltzSt4vp2Fg9fuX5HZWI+8jz9y0POo4e
fvL3WFUl6jwUz9nyio4NL/+30+tpFXLtTnRKDGDgk2Xa1ku2VqOay2EehVlM
/DgrV/1pQjU6UaaVeuc7E3+9ZsZQ+1yNKtp3sF9OMPECH7dCntE3dNXmzmY/
YGF7+9Zrcfu+oV3HggdJLxY+ujTgsNjDb2jrbYXZsjMsXMY4q0Nw/kOSqtEK
JW9ZePiPhOgxq/+QXA9N7F8TC8/7er3z78n/0HjuAo110ywceCfjTmfPf2iD
Zt1zWEpiuVX17C/vv6PuSL0PHjdIDAt29VtOf0evJDiZG7NI7Cs6+KnI4Ad6
e9LddusHEhfWkude3vmB5pS7KCUOkLgDX96u9+MHGvEuliliUFjyscLqVPEa
NDKVrjcsS2GvI/qjt47VIJNru2R3LqdwpMfram5WDdpk/vXI7XUUzllrmXm5
swbNXTKrUeNM4Uat6kjR+bXo2oGZTjEvCgtxPH3POdci9aqPh40DKKw/0WU+
G1GLLK6ZRG0PpvCW5oMqwW9r0fFXMV2hYRQ+WzozMzRai6Jy/MwuRVI4PeNi
/V6dOpRcIOcSEU/hP+w/kdbb65Cb49VakSQKaxyxXq0ZX4ckVhdyku5QeEdt
aj/rQx0y3p9jaPSAwndMRO+2jtehrzSngNbHFG647ef0Vrse9QzvY1x7SmF5
xmfG7a31SOji1BqXZxTeuEs7JzSuHr0ckT8ln07huI+Ruza/q0dbH6SKtgr0
Fdq93BVj9egWtXhrZhqFRWPtPspqNaCLlBDrVCqFLf8+O/bXowHlBT4/7/BI
EM9GCe2q2AZ0n7k+VOk+hXF+wM/04gb0b0t3Tt8tCk8rfImOHGlATrX/zS1I
pPDKU7qwZ+FPZFa5N+F0LIWPtMYMWrj/RJYq2ZprL1D4+bqBe2oxP9G92OsL
aScp3P/EwZlR9BOtb5ceyz1EYW3xLFbz8E/E3rOMsduXwrsDpXPfaDSiwJDv
XGkPCqdU7999c3MjYuIKtRfrKdy87Kv8sahG9ObENzV7Uwpvno4LXfq3ER2t
zC4OVKbw1W1/F3PUmxD9qV7GuCSFq4s3NA24NaHM9VE2J6ZJbBshY5b2pgmt
SjqadOo/El/oPfT34mATOnT47QsaJrHX4z1fDdi/UESCaOu5JyS+LfopTNr8
F/psUi9zL5jEq1eFuJ/y/IWu1Y8kwDYSNwRoLe0/+gs5mBzg9JuTmPf1Usfn
1F9IqOFHX6QEiS9fs7W6INWMvOh5I14JLKxXNqU8urAZbf4RO8Y+zMIVk2kT
O9c0o1wTlSq6MwuLbBVPW3OkGVnWax98J8nCYWoVErP1zag9Lj+++yQTq7ie
6PT/14z6ymKWpG9mYnxBBzdItKBC+aJj1FImnuqO3l9g2oLMnS7ycrsY+PDz
9d8OP2pBzokOVLEdA/ugqus9B1qRy/XCqfz5dEzcGymov9SKamJtrT9M0vA1
pkJDWUorStisfS6xloZLP+6a/+R7K/JcfXGwNpGGt2lHomv9rSjEZEVbUBAN
j0VnbTsv1Ia6dO8rGW6mYU3nqXs7V7ahQ7mr321UpmH8UrnEeUMbakqIcvpN
0rCbvEX7mr1tiH6wOba3l8ADIXtJg3NtSMWl8fbR7wS+0HhZQyW5DY3HCOAB
E1jJNNdSOrcNvWZ/aPRJI3De/QZforIN7VfpWzh4ncAOJP1Sf1cbWrz6ebL5
RQJ37dZIa6S1I1238d6Dxwh86pNtefmcdpQsdtnvgj+BeToH+goN2tEqbmdy
tBeBM2MTJdNs2xGZfOlHzCZCMA+Fekk721Hv7Sc5V5wI/MulxTHiRDvSo/X6
3rEjcFAedTA4sR05Kb3anW9NYKm5i+N3Z7YjzZZO22YrAj857pTj+rEdmQY9
SePaENjs19Hv61rakYX28aHN9gSuM7s1unSyHYnMtbN5tIHABx4U8dRkOlCM
0d33I5sJLCLUZSSzuANVBbSuM9tB4Ht7xLcw1nUgvYeX/p7cR+CV5fqhQ54d
KD/gwPIHoQT+qut2q/loB8p0fzn/wSUC74k7/qYytgPJvze9sf8mgen/7jXx
n3SgqV4/o8l0At9wLSUyijpQwMqsPr1iApcpcNZEDXegs/ZTe90GCOx1csWO
UPFOlC1+x0lVmIYnmj3O+al3okWZ0/PsVGlY69HjD1ZunahXPnbZ7i00XCJc
0bVifyfK/Gf7fXEwDbvv/SusGdGJXoXkWU8K+iVyyWpbsrATZfzXbuxcQ8M9
r6orixS7kLp7mdTl7XR8dv74YNaKLnTm0rF9C8/RscLp+Zy7jl1ob8yeS3Of
0LHtOl+Xk2FdSCJkXfTrQTp+VjlTa9zZhfIcWFo9YQwc0L6wNTv9N7IIMb1X
fIuJf3nWCr39+BsFTCn0vX3LxBtqLuiUt/1GW1b8eyHazsQrPnUGt8/5g8ps
Tts5LWThp2sTbw8u/YOK19pnGVmz8Pw3695NO/xBObE79pvuYWFG1gMpufN/
kNlcqijmEQsfWeSyTOXeH8Tb1v7lfQkLd91nuuu8/oM+BS5aP/tLMM9XvR+t
+/sHBV0cz3aXE/CbFKfcSaIbWV3cbnZUl8QvLhYNeS7sRjGht7afsCDxtVDl
1Ue3dqMi796YNYdILDJS6R12rBulNv72mLxA4uP7Tl2MSehGPclvV1+5SeKB
Lt2MpMxuAd+kcIUzBHjl1fTt0adu1FQ267NFgF/f6qMnXnR0Iw0qovRCJYkt
XFYrYVoP0kglXGObSFxQ0Wv+WaEHyVO8M/t7SaxtecuvZnkPivj9/ofWBImT
39pebnPqQWL1QwF8FoWljadeDvj3oFMzqWe1pQT8kP20YepCD3K6ION3UJ7C
I4u30IVTelBZHuN3vAB/fR+JaMrye1C7xdOey5oC/lIqsFOu60E2MVb+fjoU
tr/he3Dxvx6Uvs4/W8WAwm858teNpHrRr0cPl+Uvo7BhVOkbc61e9PX2nL16
RhR+SAa1Oa7rRWlNsbSIlQL+O6Uh4rm9FwUdki3/IJAjx7/r7gntRRap1x92
C76fORDuciSxF8nGS5wdFfD//p6lIWee96ImNaETvYYUbtvZfie6vBfNGs2m
f9ET8GdT/PsbXb3oX+xSuKNF4VK3tT0PGX0oqzb74HY1Cht//Sv9Yn4fMi24
ESU7X8DvNveX8436UMrc4R9vBPuG0jsnj0/OfWib9pfUrWIC/l1ND/uxrw9J
EYVbJ2gUZuVlPW6N6EOTrDHHyyMk/pMqNTyJ+9ClP5r+rxtI7L4Ayws19KG/
/O0urhUk/nJrH5IZ7UO7yQOjI29InB1bEaG9uB/NG2+pdrhFYg2RE5krLPvR
uuvlryUvkfhG2OLva737kfgDq1c/j5L45JFIZY/r/ehNOmhm2pN4qN/Ywje7
H+lUv1LOX0HiHb7dew9/6Ud4p7pFnTKJ1XTUGt7TB9CcKz+pgEEB/yif1Wha
MYDoVzOzeOEsXGpyWfeE+QB6sOaJuZwfC4e7JS+f5zSA2tTez7qtZ2F6bJ7F
Fr8BFOSoUp8ty8ITMz0+P24NoFdLretHrjNx3pyJfUdSB1DHhU9b7IOZ+Mgy
Kkg2dwB9Wv3fzJgrEw/5K1/YUDmA1rNyS+05TNzd4PL4C30QVX65GqF7hoFT
x7wyAyQH0Xf/J8QGdwbeLROYJ64wiDqVBnxrljJwm01Eqc3SQRRWldUo1UnH
DQVvuj74DCKh0HH6fjM6/nxNYyH+PIgUBzYwyhsJHJFtuGRr7SDKcdYhRTMF
eF9pajTTPoiu2Tc1l58icAnlbmUyO4gUQvvbu5UIXHgk1jdvyRDSvXRR6Gbu
DP+Z8/iTzKtDaG1nwr5XoZP8aKlPi+5u+4s2m3suXRA7zM9fPi/HPuAvcoh8
llvCGea3ee5DUyF/kZp4T9Do1b9842ccZ9fEvyh/0QU/jZtD/C4r9+PiFX+R
70hkrf69Af6asN4vwcbDaJ2LUPFC09/8sX+Sh53k/qETy4boV/5W8b3qnfmM
zyNo0SXRrPr8TiSS1Oy/v3YEJceV76TndaHnmwMUmjpG0PMjXycqc34jRt35
4ALaKDKTPLbKXoAbKTUFBvuXj6I8WZGlynf6Ucd/So8b742iIxZ5KPz5XxSd
8GyjbeYoGkpU22CxeBgtc1nJKng9irJ2cnbdfTSMzn/b4JVQM4qWvTmqKZ70
D2lWhyvYSoyhBbZbxI1CR9Geyp7Y/OAxRK2skdNSnUTs2GCkcX4MjdrkWwgl
TKKC9WRffPwYagg8lqROTiHRL4o2gRljKLIBFkh0TKG0cieWRvsY+p3f6VWf
NCPYc/KC4x3G0cXA5/tmegi4GmGuSfccR8ujXlecmU+D1dZfv+/zG0f9n2bD
j6ynQczHbgOb8HGUV3rf604GDfRK5/fRCsfR6AWh6Ge76bD/3VmvfRoTaPmA
yeH1rxgwv20dOWIwgVDXtbUtTQz4RBdODYUJ9EzIJOwrgwlqEDV4cdMEqv7n
3V5sxYTagoRTKZcmkFzTxOjLciaE17ou0Lo2gQJcgoTovUwwGJMvzUqZQAVX
6XNuirIgammyJP/1BNLpinZ8uY4FppkPk2v7J5CK6dN1G7JZ0Fex22zb1ARq
jpHd2lHOgqTeRR0dQpNow5XJqoIOFvxblLF4WHkSOb+3IpTlSLhntb/qmM4k
+rOx2iVDm4T1uw0O04wnkWJc9IogMxKePMgtlHCeRI9vtFc89yNhY0nwtoRt
k+jTZTuO8kkSGK3GTAX/STRx04lRfJkEDyVsszB8Ej0ZfDl0I5sEEXSmPyNu
EnFcrY6Ul5CQ67H2yrLbk0hyNiZV+xsJ0kmldWvyJtGhNfMU9gyQ8CY/4kRZ
ySQ6mWn2be00CX41tiqOVZPI6Lq3vrkwBbxRifc/fk6ixp3fj/jKUPBOtsrX
888kMl9n1pIxn4IDhlfE20cm0YEta3LkNClQ3OCS5ceYQn+FYclNPQo+7+e6
DElOoXWG1g9Wr6AgOLZ2LEhhCr0/Ur9jajUF6hlJN2c1p1CFv39x9VoKqss9
IHzplADPBtjFVhSc6lFsEzObQlRwYm6pHQWLRVvOX7GfQlebuYatDhTULUzR
mrNlCiVG3xST3kDBectdX+74TKE6U4d3Ds4UGPpoHtQ4NIU4aY3NdwRy87k/
cumnptDKT0EEIZCjU9IKDKOmkPi3stm9ThQYFwd4vro+hRRF1d53rKegq1mP
bvZwChE5P4z22lKQQPx9UPp8Cv1ssjadsqDATDHHaj1/CjlZhXQlmFHQv+po
73+fplAnXyt+hQkFN92NLrvXTCEXQ+ecVkMKrEImDVvbppDu4u7Cq9oUjFx/
XeM7OIV2ff9s4KhKwf28k6ED01NoM2+PLEeeAocfpkpHRaZRO3XreIM4BdP/
GCXTctPoVz668IxGQarMe5+zqtMoP95pT/gwCa4GF0RF9aZR6GX1Xp8OErIC
xTbwrKbRU2ZwmeUHEj7f4AQ/2ziNHA4qcCsF/dJRMue22Y5ppHXs3KGVd0mY
I7+we+/JaSQhHqtZfIQEwzV60vSoaVRnPra6c6ugX/2XL0+8MY2Ecs7LTFqQ
cPatedjbnGlkt+9aJ0OWhORu2ycbi6cRJ2f2Hn2CBXmyzl+6K6eR8/fsOlYj
C3p9vebK9UyjFUbbPAzvs2Aj++SLPSozyAF2nuWosiDQJLx2VncG7Ujv38Ch
sSBiV9Rs/KoZtHxoqeG2RibwC5Js+G4ziGYbaMNOZIKmd14rJ2YGLc67GBhA
Z8LEi0HO68kZpCPVqZ9cSQeZxjEjJ+FZdGDe9ALDp3TQESK2dcrNIpN5P/dZ
htPB210iTVp/Fnmb+fzesJoOJ8Jlvz5Es2j/uzL3U3PpcC1TYczYbhYtLbxk
mjBOg89MrbW7dgvOqx0PbM+jQYeO/p7Jw7No1HdkrusNGhCbjGJjw2aR4+vU
B/OO02BOGLxUuzyLCjjuzzdsp8HSZxYNBcmzaP0IKmZb0AT1tac7pM0imxdn
ag7q0GAPbaNme/4s0jH4bRXDpcFZLQ/7Yx9mUcRkpkMInQbJLjsOSf43i/4F
O+Ta9ROQd9LvRkrLLDL46HJ5TiMB1U8OYKMBgf8LNVz+VhDQVx3cUTE9izK3
7pf8/ZYA5kkgn7MIWLNlNEc4lwBpmbXXQ8UIWBpWV7UtnYD5Tyy0LTgEvNhT
bzD+iACt1TZ86TkEHKv32117n4AV1fZODUoEKOYPW5D3CDDf7dT+UIMAmQDF
RWEC2WnaJWi/DgFSl8JK7R8QsDVuk6jJUgJS5kz37UolYK+GRzJpItDfSvn1
PouA4MJtS6rMCBDXIId3viIg3HFHSZIVARuI8JGVHwiI7/Bx3eUg8PvbzcNG
/xFwN8Tvj54rARO+V92d2gnQw8Jj5z0E8qmxu0tGCMDMx6wmbwKuxVUZfRQS
5NdqHWfZHgJmk09mCs2jwa+oNqWoQAI6S51MmvRpEPj1jE7bEQLehXPlVlrT
YFZO2cT4OAFsk3TM8qbB/Dserr8vCvKRuNr89jUapLdN7oBYAtZLjBea5dBg
1cIbBxKvCvy3/+3OqKaB+/PvUeaCPB2aUH0RJk2HGyXrS+4WEnDZcEBH9hod
Fgn3VY0VEWAxY8de8YoO+XaRTes/EnCWV+T5sZEONd9LJ6YFcZp5l+a3qTNA
7rfpks2COlPFpxub8hgQJ26YzFahwU/hV3j6GxNUnL4+9dUU9IUNryh1hAlZ
VwPzsaCPdGrd7r7nsqBS8dm3AGMaOH0d2qvqxoJtO2xa3pnSwGO2293xKAv6
H//uV7CkwZstLxQ/JrBAQl9d9JMzDYZD5F4fqWRB8pESnsoWGvg01N5P7mHB
4lde6sGCPnabqyY3TJFgu/a2qUYADe47PPwnZUJCxEZeUNh5GsTvVbsZc12A
J0kvz9VF0UDc8tiem+kCfmtyvrIkngbBChoyOUUklO6+nN50hwZvg+cxaV0k
uD3TLVz2iAaXYuspvXESOgfLP0Y9o0FmuaWct4CPyBCRduMCGoRp/nxSqU7B
Vf7joThMA420Y6uEBfiqxrQg/ryngUKErq8ZUJBt2S5uWk6D4pFrP0NsKFgb
FTb3mqBO+/MPbMpxoeBblfLC/loalN0TE+r3pMBbDi9b90uQH7LSfKEPBUOb
Pdfe6qDB1HOPfTsCKDhze8pxuIcG0/J0xt1DAnzWy9uv9Vcw17qvaj8EUzD/
7cHLXgKcWLly5O7kcQp6HHWzrs8K5KOOuqtOU1DQ8qeykkUHX1bMyagwCi4c
fDhAidFhuZRmYe9ZCjYyvaQQW4BDcj5SW89RsCBhnt4RHh28Xu9JaxHoh9Rq
1z+bT4c56+Z0BgvO45fx+9oW0EEypFNTXXB/tIVDzFwtOij7rq3rEth3rxHN
cFpCBz3TCb9igX+LfD9UXFxOh4zea7tzBf6PjZ/pw6voYLi/2/O9IL73Easl
xtbQ4Yp0489BQfzxcycW61rToejgy1DjbRR4peXY7XKgQ8hq+6YUVwr0Vu33
v7WRDimSR1N17SmYKdeO+uZOB9Vz9LCfawT879mVJupNB9bXVolMAf/f6L//
2cyXDrfkVk88FvDf7lNbe4L30WF8ddPAR0UKlknPFcs6TIeWYPtkGTYFX/Xj
bBTP0CH7p/jnxQJ+u1Ns57fxAh0iAm7cnW0lIcBZ+FJUNB2Oz5p9p1UL9p8j
p8omb9Dhdy9z8pag30zzA6xqXtBh7+/tat7uJEhYL/KVLKCDeficv+3mJDTU
tV9Yh+mwNJzSf6hDQtCUe2n2Zzo8ldA73D7NgkxkY3G5nQ4ly+uXRF5hwYlK
0qe0mw71WZ3PNQTzY7u9KHx2kA7RVwrixTezoOuM0Xv/GToE7rspzZ/HAqX3
GubWXAY0JZyidd1kQt/G1h2n5zFgUvn7UVYIEwo7k8/mqTKgMbn07zE3JrgJ
y5Wo6zFAKw7NOyzNhFhb5hqGFQPSTiyPrQthAFH9CwqPMWAjo3ORuiEdzv5+
c/fYaQY8XOkTM8ykgzBxi250gQG6B88Uq/5HA/biTSU5CQwQkuQmZx6kgdr5
KouMTAbEV+T/rH1CgLVxkf29DgaUK7PLvCem0ZX7990vODFhh8+zxhXPRpD6
oV1BzotYsGNZUqDHjnq0eGXThtt6LKiqipo5cboWGRJuun+WseD5b9tRn+Qf
yCzSquPkGhZM0d/VpvyoRp4p2s5P3QU4Qv/Tfy22FF39NqRLj2GBTYnDrPyX
h3zW0pOdGX9ZUFZ/cF/c+V98scnRoolxFsjLfblpGtTMZ78NTDYnSLgSZLOh
aHcLX8nOy6VejITzbSyhRVZtfJOd5sWkOgno+IPD2lQX/1CC6G0PNxJyDFJq
dA7189v+JW4UfU3ChX2XH4j8G+HfMzU4+LOYhD971r4dDBjlb42qiMkoE+y9
yraeVl2j/LoFrI8bagR78YTICf3aMX7VhgPGN/+SkNjQcWjNiwn+myxbpcWL
BHtsoH1MldkMP3S602RWsOc+89YI+545wzeyCttUtVywNyaetOyYN8vP/pUf
d9hcMHcSVWyxf7P8VEkN1hvBHA3qHUv0+ETgRH/aH/tECuZErfrEdaRj5/yb
pHIyBdvnTP39d4KO2awVqn9TKDg+XZOrmUbH0TcD3BOfC3DilNvC00wGPvup
vqKpXHD/qnLPnDQGNuMe7c76JtiDDwmv6v/GwLNebKGz9RSkLPHd7jvFwMcm
LE01f1PwcqTLUdaKiQMXvnwRyBSC7khFIbFaJtY57FhpJioEvad/nBeaFLzn
cU+PDFsIHFJCfA0UWHiXm6p6vqIQSN8zTBN1Z+EFKW/MLqkLgcLR5++zj7Fw
S/+mrR6LheDtVEta2DUW9jgfe41mLATxhy/bRFSx8JxqrZxqUyF4dmt54ese
Fq6Z/6HqgaUQbK3J9ZSgSOz8clrEeqMQhHm/2z+zgsRs+nUNBQ8hGFSJO3Hd
gcRf7AzX9nkLgUjIwJClD4mt2/ccj9svBDbWKUP1l0m87rhq2togIZiSUJPa
9oDEZrINdSMnhEAlPsNxLJfEq5/FCz85JwQv7U+cv/eRxCvN7VZsiRSC8KzB
QPc6Ei/7yfIRvyIE2xy3fFD9Q2L9w28S+NeFoENOau3IGIkXPdD9q/pISMCP
S+JfcCisvqpL+fszIbAeNiu/rkhhlf/uOFzIFgLTpJMTpxdReL7/ppMrXwnB
58qYT76GFJ7DYqf3vBWCpuG5A/arKCx3q6whuVQIJo4t4+qaU5i9NEzU8YsQ
nCzf0EfZUlii3Hgl47sQ1IwsMPrhSGHRncO7cxoE8bg+xTc2UlhoOi3Rp1UI
jth32TlspjAzYed7+T8Ce07VT/65U5hYPP/fpwEhGNsdfeeCJ4WnSr6rnhgV
Ao3XosuprRQec49x0psR3H+2//w+gX542OJ0C1MYLv77+YwvOD8QSWTGiwpD
7tqQ4n+bKNyzIL9xHVsY9vuf7ZQU2O8q3C8+zhOGI517E8QE/rU5LzJ5qigM
dV8XXfhjTeFfPS17PNSF4bDp1pDHayjccDbpuuRiYVA0f7rI3JjCNQrOpW8N
hOHe8NEN/CUU/pYtNnpwpTCMIKwhp0HhStt3auqmwkBK+u20mkvhz23HnWss
hMH6m06VmwSFS0OXhUXYC8NKepHuWoLCJTL9WSYuwrB48JK56CCJcdqjX31b
hCF92sE6/ReJC9duk7zrJXicMooDdb6QOK+Bt3qDrzCEKBkIRxWSOPtQ1V5W
oDA4Hxry/vSYxGkpZmW+x4XhR8PMWM9xEj82mRybe1YYwtZOT3zbReKUby80
KiKEYU+5rONDexLfZKqd078mDP7MG83suSSO2kHB5HNhWHvu8I7///8cMcUP
eJYvDGpj6YqrLrBweHzQra1YGHayDZ/N+LDwiZLfE8XlwqAdufhu4wIWDljw
OSeySxjuSP0KVUtgYvu2WK3580XgiJDoG40tDPxZq+2b+wIRiL//+vWOpQxs
c3D5iaRFIrBV+xHzpiQDW9IbK3nLRWBkjd8z0xI6NlPSOsJxEAGXXe3VEXp0
jH1OKDptFIGb8TlmOWJ0jDKqSmPdRcAqQ2NOyG8aNlkdNFfCVwR8jj6a1X9A
w0vd32GhMyJg/nDj2W8aNJx9n7fH4oIILJNIuOMqSsP63X6c8GgRaDDLU9Ie
IHCmPr+wJF4EzmsKi+z+TmCdY+xdjCQRiN0QZKn0hsBpb3dKmt0VgZoIoRjf
RwTWEs7PO/VIBO4km550jSNwqoOYF/+ZCLQJxxpPnSCw5rWtojMvRGDi7oG7
vv4Eftj0PNukQASMpjcezvAgsJoG6RmCRUBTylS8YT2BUwI2UQXvReDkn7IF
02sIrPIyLXPsswj8t/KY/7yVBL4zPbtpebUIMPg3bqzTJ7Ci+QbGkVoRgMqP
E6e0CZwc+TAtu0ngT/XmM1WaBFb4Nu7yt10EXvZ0XzHRIPCNuXazS3pEwLTn
84ISgSzvfedx4JAIVOwZsfJZROBrqX8dM8ZEgAmDyQt0CSw3tG6yd0YE6oyb
wkeXEjje6EaKNksUZpxeBteuJjDndK+dn6goLGqvkC22InBcKYw+kRaF3gfT
NU82ElhKKv5OF1cUPIv3bjuzk8DRrp1WGvNF4dqLJA10hMDit1f+3blAFFRi
NJ2qLhA4siPqZsoiUbB60/BM8xaBRXSazVv1RGHaWi3Q4AWBLxw27FdeLgpv
6o/LN5URmHx9/tq2VaLQ/0M0ldtGYIatTvdPK1GQH16f1zCHhs9cOR2v4CAK
Tycyv65aQcNE/bdVWzaKgtOy4YT/NtLwlG9IbI2XKKx4ONtql0jDI+dLl1aH
iMLyJd0hjSp0/KfY61TpM1FQVhEOn+fIwIqXa/ZEZ4uCUZTYHf4xBnb2tHdx
fiUKt1QffYAUBn4zZrToV6koGBfRV0aPMHDcYulvo62icNlmwxXbq0z8YSL8
zes/omC5Ne7Hj0Imnvow9ThsUJC/0xLeuS1MvMur67jkrCjMp2duRNosbJzI
19CYIwZaU8bjxjksHLhjKbtXSQwc1MMcFv3Hwg+XPJ16riEGv1pMTs0dZmGp
z1erVi8Vgx8Wv3u7dUhsfl2skGkiBhM46BDfmsTHdp15WGYmBvc6foSf2Eni
NiIgZKODGPh3FhPpiSSWr2jdqeAqBlcuN1txM0hsn7TJocVDDJQOXw/zeEfi
sN1fVj7eIQb3PU5tPyHgn7yl5moBfmKwq06y6GgfiXvpryQND4hBuvEwz5Im
4JdKvYnxIDGoqZZQ6WNTOHKPwpdz4WLw7rNbc64+hd8uj8u3iRIDYY+ygTqg
8AhTKEU6Xgwsy/ZWV9lRWOvr8egfN8TA47Ri+00Bnm+7/Tfo1l0xuG11L89k
B4UT9vp6ez8Wg9OXoTvLn8JlRk12CzPEIJ8Vd3T6MIVnSZcV/TliMMfsxDml
4xQ2/FamklMo0OenWyiEUdj3LoiHFIuBa3eZ0dB5CicHvByFMjFYNlr67/4l
Clcba7eQVWJwKOHPfINoAX8J3/v8+YcYEBcORd+NofCq79zcuEYxSLp6R29Q
IB+4H3XXrV0MJhnrxlUF8uNARuT8HjG4/t6eZhJF4Z+rgo+0DYmBRZLdXuMI
AX+K9m9LHReD+WZnvBeEU9iyZodNICEOp/QT1cdPUfj4g7qlyyhxeLJ0wcSr
YxR+fsBBaUpcHLZM26rvO0jhTvRepEhGHGJ2hU/L+FFYQdzk3/m54kAOhlVn
bKewY11Wk52KOBzf4jdt6krh8EcaZZyFAv035apyGwq/OnQru1ZXHIZ5x+67
IAF/mnJu314mDo6/ND/WC/hNTfLixZ2rxKG5L/+ylyqFNzfMHNRaKw5l3uKW
PYJ9IubJIc9Ba3E44/B2WQhDwGdH/ljmOorDUf2iu9JDJNaR/j5vzVZx6Llh
+cPjM4k7ojrOJOwUB52Pa9YH55P4lshoZ6efONiwtH4UC/YfMSbveWSQOHw7
sYPXG0LiklOa3KYT4nDYe5fVF0G/hkyvCF1yThysg2YOdwr468/IpnXfL4vD
swfakXg+ie8d3PNU85o4eJoxqs6ySLxp4JhUSLI4xF0/XXaum4VLfyfVKT4V
h6dCEafXCubpQcPPAN8ScaAOBu9qRSzsvqmv+lWZOJjMyH15pcTCMt9nVkhU
iYPq1o+rGgkWPvNFkfHipzhcm3lEE+Iz8bai7YlTI4J8vX9spGTAxAqP2/kx
CyWgMDWgkpii428LRha06EoAq+N4+4avdHzpLhlhuEwC+ucGhEo+puOJGxrO
tWYSYFE9bPBRsE/XRPl2qbhLQFefY/75ZBq+crBX6mW0BOzKe+vhrCjAQ/Rv
e8NfCUg4+uvIsrvj/CBTTaGXExLgUWwVv1tznN+xZkt6DE0SNmiccB1PH+MX
Wb6dMJOUhLNlkinrC0b5x5yirjxZJAkdtz6oBJf943fvVHt3ZLtA/75GNOW/
Qf7nSBdN6S+SIL/xbtpb/1a+Re/mURUXKRi13UY9VqlHyTJh1SfdpADr7ntk
qvkTDRs/zWjYIgWOodaLri5uQnciJn2ueklBxlxKITWpGU1o3KwRDpSCXc2r
bRbfb0dpXj/zByKk4JipmcnxB71IqmZr6BssBTGv0APthyNo1+x5t7klUmA/
Z8HXJUqjqFA90zDogxR0TCz8k3d9FPkeJnqXVEjBgd3j48sujaEi9l2PB/VS
UFKRsH+9zwQ6ZNeyOnJECt4bnN5yamYalR0Smft7XAq+6Z3nVvrPIKWb+qPm
01Lw97RXzKqGGVT+50zGLEMaxBzcfm58OYvUL6gqHZSWhrinb8q8MwioKdpB
26wtDXP0m5ceWEWHAdO6Ocd1pSHdvUJ/sy8dqLfrDe/oS8MuiTi1F/F0WMZf
6dOxQhp6iOjX6b/pEP9KqvyAuTT8/vvf9qhIwbt4ZXhHgqU0mCgs6Xj9ggHF
+ZOzeTbSML9gqtSujgFDuR36s47S8MxHNTBMjQnrswuvXfIU6BnWjlLZTNhl
oP88fbs0BOfbdTC/M+HE80efqnZIw4Qw957VKBPSMuNmuH7ScH9xYnThchaI
PNu9I+WoNOAIXRVeJgtUtBuPfzgmDUMzRt89PrPA6OmGxD/HpaG9+9HCjk4W
7H6yukzvrDQccLu0Ik+BhPcPZPRexwryc2BDieFxEhoXRFj9uiINvSdLVnld
IeHf/VkvRqI0GDY88Xn3mIQF9/4kWN2Shkf+hVbqVSSYKG/L2HtHGt6zX71S
aiNhw53/SmPuS8PO3ZO21iMknEnGk/89kQajlQaqC3gU3Ji3THY8TRq2uIF0
lQYFWTef6ihkSoNbf6Xvw2UUlM5VtkQvpKHUyDDo3loKft24ut3rpTT4rSg4
X+xIwZi8WMi5fGkI0rnYSnlSIHn9dPzjQmnoz4ir9velQJ03+uwTXxru5Rne
+XuQgtWJez/0FUmDfsvtuMTjgneqXMsv6ffSYPyeOewaToF/guuE4UdpAJsq
MQH+w1mZco7bZ2loULZYpJFAwc0rZotDvkjDfzrF9/WTKMhm561L/ioNVYHq
VRvuUPDp8uJtb/+Thu5kR5GLgndxi9T94LYaabBzd3hS+YiCiRjeFapBGroW
r1qwMJUCtmR02qImaUhbeG8q9ikFC6MZ7+1apCFip3A2mUYBiAc3BbZLg14r
/nRBoHeL7Bu70iUNWxMZDbKC8/tEd7Bzu6Uhivk9I01wf3hErVZdnzRYLRnh
2grsJwuvN58elAb1BSrtQ7cpyLlQ4qn0TxpusA16bt+g4LH1J975MWngrA8f
eHNFUA+xr197J6Uh8Gu+38tLFERV1EQ6z0pDXeW2E+fOUHAqtmndKzobJuo/
WGkFUXDQqYNQIdmw6I3D2kd7Kdgl01twQZgNp9QlD4xvpWDT97+H+sXYkOEU
1arsRIHttQmdjVJsCD267InSGgrQZtrvQg4bTuxUZo/oU6CvIHRflcuGTFC2
va9MAfeOLHdwHhusHboeREySIOKlUOWqzIZ71wbufOggYUpV9dKbBWxgbyxZ
3lpJQssjvdlLWmy4z3l+vuguCf/5Ls8f0mGDyYlFhyMvkFCqtfrgJn02+L2I
DDYLIOFZhk2nuhEb5mSrvzm/jISg3F1f3q5jQ2rK3DVzXrHAL9j/oqY1G2aO
73Tvvs4CT+NDa2Ls2JD/fU9d41EWrOGfznV3ZsMZk9JM1yUskPhw8/bodjYU
vmve8iOJCbSL9zd57mRDlPR3E8ZhJgxbp3Le7WaDwp8RKt+OCbUVuefj9rHB
xV95BTXDgJTvX/ctPs6G5E+d95E7AxKv1S6MP8WGc2qeFqUGDIjY/Kt1IowN
emZZyaGiDNjX2OtaGsGGeXtWRJe+osPKDiHwvsYGt3zwLFGhw+LHkhMfkwTn
76d+ODxDA6U9ctl6t9nw8sd2PfV6GrD6VDVnHrCh5ZbMoeFEGoxlLGrZ8YQN
XrPY3DqIBn/2L7n5KY0Ny0VnSyQ206Dy32qp6y/YMHc0mG6vQoPiXPOy2Zds
uGS5e+OUEA1eBtue3VXAhms5JldODhLw2HjD6vLXbFi78MGBvnoCkqY3jRm8
ZUN8iqSGZykB0fxtz2+UsOFo9XbdlpcEnDrts5dWygae5yN25CMCDq4JUN/9
iQ23YIeH3w0CdrEO/6qoYIOu3Rm3qBgC5ih+/DFZxQYGT3Uk5DwBFSvmfdH8
jw1Xfp6MP3iagDNO+9+71LAhaUOnWfBxApbtfff6TD0byosWyMeGEPDnnHxO
RiMbqkYy1fIFcvJt/7SGZjYc+3Hm8F/B9075b+8Ltwv8myMnb3KGALJaNmlZ
l6Bf1jwxi75AQEGPb5x3NxtKN/a+a4klIIB8czG2jw1bMr2sliQRoKLEPv16
kA3blJf3BQji+W60K+jPsKC/aANFMTkERGwo2McdE8wDO+3juXcErPaX8Fk7
KeiX/plPpj8IGAr38tw/wwbt/HGhF38IeHDnpUsyjQPk6z33P8wS4FYgYveJ
yYG5898l7ZWjgdg3z7VjFAdeFab+jdKhwSGKMnCS4ECfRDd3yIsGmspbFp2U
5sB/T+/5C5+kQcPKDOU0GQ48229wcd1NGqwNcJUi53LgQiRX90etoB/OP6UM
5nPAdRNFmx6nQdrd2ZmtyhxQjD68uXcOHWT+e9Sbr8GBCu+5dtWedGgzHivz
N+SAbIrsW7seOlxzsS26sZwD9u8ZD7dJMcB23538Dys58OBtSfMVQwZk37N8
rGzKAVpqxw6p4ww4K3z93H92HNCrapY7IcaEFaq9oXRHDsSabMxJ1WVCj4np
IV1nDsg/kz56yIkJzoG/vS5u5oDmAzXXtKtMWPDDCFb5cODA1bnbfXgsqBmI
Wr5nDwfmm1Z2Gwr4MVKkRSfRnwPxLa5ZVi4sGF4VMW/wIAcO2u8/sDCGBY9d
G2XmH+WAKnv3zY5UFrjv1xezOcaBba7zwyvesaAkpW4i5RQHft62mBEaZ0HQ
G52hqjAO7P5Gs3GUJkG75szvmXAOTATHn8/UJCFeVKvGLYoDUwtxRIozCZZq
J7+ci+VARPvpdH1fAX6trn7//AoHzKX9k8pCSfA+EJIjdkOQDwt9PQkBfi3T
b8xZeEuQ75HnEzuyBPg3BC/X3eEI/KRefcAk/My6/9L7PgeMJi38ln4hIXM/
mXvqIQd+/RKxedZAQtgS39xbTzgQotJzW+c3CRsHP+UWpHFA+U+AUP4wCQuz
dPJ+ZPxfNttrOyvwJ/By3vBzDjg/JHO7hCj4ojecJ/2SAyeLd0pFS1Nwb2Bj
vk4+BzaaOneayFNwJDM/36aQA7YLZTL+KVJgFahQsJvPgWB7mZk8NQoU9E4W
nCvigP8GoazziygY6G8uuPeOA3Hl02leOhQUZ6x9xS/lgI1daKP1Egqu7nv0
quETBzwWmvqZGlDgqytSOF7BgfR38XEWhhSY9O8tlPvKgXEZZrynQJbK+FJo
8B8Hllv3lJwXfN8aoP/aoYYDrILaOyWC+17qJLz2r+fA5S9/HsrpUhDRN/o6
opEDlpaXNp3UosAjffObR80cmK3JdSEE+4dewOs3JW2CeSjYsjZJwD8MHSV+
cycHlugEVjjOpeB77xn+zB8OBOQefqAmQ8GTZ+38uX2C+LJ2XeSJURDqb4lX
DHKAU7jBWJtBwfrFT7HLMAe67JyPe42ToNIr/vbAKAdaGa28130kfNxb/TZt
mgNqD0oudXwn4ab2sqKPhAxojNZM5n0kIbDnWlEHQwbcntmPvnxFgtxez2Il
ERnoHpIvNrlFwm+tt8WrxGXAFyctKo0kobBbtWSzlAyo7RC3Cg8hwcvvd0m8
nAy8JfaX3t1IwlIt23dZ8jIAK25n0teQINSd/q5CQQa06efcb+mQkLHn0Hsh
VRnIzbUbDWcI+sF39kOorgzcuyR+aEsKC74s9Cq9ri8DMbeWlxZEsODe75LS
l0tlYKnXqoTtgSyw8o34OGAsA7+fbnKNNGLB1d2yn3ZYysDlo5U554qZ4KsZ
9Om0jQwEalAchxQmmHTVfUq2l4EXQ6mH951lQovPnc81zjLgOEPTyDZjgq6P
VoXtdhnozVgVHp7LgEZfxX3PdsjAgeKH42KxDIjcy5GS2C2w9757Qb0PA37v
n3T8EiADHfYcAzdZBtwP/fSfY6gMhLwyVp2zmw7cOL+fGxNl4Eut0h+yn4D3
8VtP5N6QgdCYbDWT1wQcStygyEuWgQQjpXetEQRU3TTeXpsiA56RY7pXFxBw
6ZFo+5bnMjBx/96vvPszaLbwac+2ckF97KwOosWTKJ1/O+ptpQwsUf439bVg
ArkXXdFR+SbIZ3GtyTOLCZT/ISSwtU4GhrjnGu22jqODX22Gd3bJQFno8KG2
8FHU2dk9uYchC5zFr9TXFv5FX9jaooeNZCFdPL/IragTrfb3/51kIgt0ujzF
+NaB0j+kfyhCshCl/2n9jvZ2FB265KzUOllYUXvmkDvVhmw7lk0/dZIFVY/b
VnGWv1BZvml/i58srFRYwNYJr0LvtrlWOyQLvte+yrZw+Mg3fHUt6+hdWRj9
9/zVRdlyfopsXUxyiizcrNQONPWv5J8tc7ftSZWFrJE7JnlLvvHNDL3enc+V
BaqLcY+eV8/HlH/um0pZEHt6Xct9czv/VfqZJG2GHMzZFVHwWHyIT9q6zEkk
5aDUmz/mfmmI7/hb4zpNRA4+lRo0Pxf6y+9ULb/6XUoOcrTXFujRh/mc69y4
U/PloIQ4YdfT/4/vF5Z24ZuRHBhK/Gt8kzXOf6l0kkKr5GC1SmKBisYEn/bG
MfwJyEF0wXpOVdIEP3FsJOyEhRyMcK39h89M8ov9TU9qusiBYmL+7QcW0/y5
bt8PhwbKQWdn8PwoJwLv+vd4uOOgHPBebpDhhhM4Ky7koONROTg+J/QaJ5/A
FuVK+9VPyMF4m+cf13k0fNDMb2/lJTlwUNxUnd9Iw2+aVnWvjJGD2rMLc8PE
6Vj4uNSeB3EC/4s0Tjw2puPbuTk+x64L9MpBp0cT6PiTNuG94JEcMEpqnm81
Y2C5sq/N0aly8K/z54NsPwbe7vNg2/gzOdAvLTFeH8/Ao3etPSuy5aC/POyG
TSsDq3ITNgUVycFNI4+KeUFMHJDtU9PyTg4K6LKP3JOYON9xpavdRznIutVs
WPGaiddHNjmrVMrB99C3AUCwcAhtkcPnn3LgP3AkUiWEhTvWitaoN8vBup7K
h4aJLOxwoWfr6TZBfGYrM/Y9Z+EFkhn7lnXLgUjwE0m3DhaOdoodje2Tg3M3
MzRpsyw8lrD/ZPegHKQ+l8kqkyPxZwXDmDtjctBgYLz35RoSL9smy52cFNRj
00vrb24kvnN/JNllVg7ee37tE/Yn8eFF+ekiJBc0hZc8fxFH4l/+N5btFObC
jmKvHaopJLbOCnnDF+NC+2w/cS+bxPNXrK44xOHCXe772aKvJL4QorjxixwX
8sd127f9IvHQG6Jx4RwuKCn9ymf2ktid3rLz7DwuZGf5QtoYiT+YF/c2KnEh
70rUahcGhfUvphw2WsAFdU/xY9NiFL75+dz0FQ0u0E515N2TpTAp5XOubxEX
XA7aVZrNo3DgBktxKx0uvFdrTa5XpXDd1YUJ95dwYeiLA8NvIYXX1onMmzHk
gr5qQGPfYgqnz+tJcVvBBccfavo7l1BYfnu59gtjLkw2yct8NqDw2ZT0bHEk
sC8ieUN5KYX7OmNMdptxwd1mXY23QHbT2l9SZM4F1fsrFS4bUrgowMl2nhUX
7q2O6HqkT2Ht5wbfjtpyIazgOX6oS+Gr/2Tcv67nCt47SzQjtShMGI20am/g
wuVDpdkb1SnsF/rD7/xGruD9Wb2XpUTh7/y8v82buCD87MDpRB6FgXEjxMSD
C/G19apiUhROXRfCSNzGBbV/LTFeJIVlItwvDXpzgTpTcvbGJIlPlK/i2Ppw
4aPpddnsfhJ3SSkmPdwjOE+7vzGjhcROzoQqLYALwVs1d0V+I/HrxObULfu5
0PJ3L2n7jsSa9UX6Lw9x4ZF9S3C/oL5x81MKpIK4YL5pLhl0n8S7Huwqe3eC
C3NvfPJefZzElV0WTkpnuLB31Wmp07tJvFJ7Yd2xc1yQe6ZXleVEYskX3b91
I7lwZfrQp9+qJD428nl/RAwXDpab7hsXIXGbUfp4WxwXhm9b6lCDLJyHA4Vv
XOdCbQgluaSAhVWYTpeHb3JBlOr/u+kWC0daGMivv8MF6Gt7dP0kC2+v+KfJ
fMSFt5etbUNMWVik4ZhlQDYX3mw96lrxiomXHX0iHpPLhQxzuyExwTxuZ9d8
zSjgQqdl3af3wUycZ7nUYxBzYctYw/y6pUy8K6d//6FyLmxQvzvQ/ISB4xzm
L0+oFNg/bFO0KZyBX3fbTuVUc+GDVmB9nhcDy6ikho/WckHMQeRw4FwGfhu9
I+lYBxf8W7P/FETTcc/CK9uSfnMhyeGv67a9dMx791atsIcLNXyGxxlrOg6Y
nJ85PcSFB4Ozx2KF6PjGVbvD80e4IPm83ftRFw2/WxK6Eo0L+kc2eG/sRxpW
2F1bcmqWC+GySWp60TRsyRCKuEvnQV0osZl9QICHycvWF7F4sLfji888VxpO
Ntop0yrEA3aW2uNdq2i47NuVWoYYD9z/jGXS1Wh4ZF9R8gJJHpDiFYdYEjSs
LDrobc7mwVjwgrwzYwS2fai4cJcsD4jAtKrINgIHmdr3hfN4UC5t5b70K4FT
GkJfPJrLg9uNXxdEvSXwl6NPg0rn80BCYYXQ/ecEnmDXrfqtzAPv5e+9zj0g
sHq6EENEjQeDufGRcIPAjlbLSxdp8sBV3/hhUyyBQ9t2Rtlo8cBAi93hd5HA
j0/GO+3V4YHO7VSZ3jACV88p5kYt4cFJesfv3acIPJMz2PDMkAe+4s1xrScI
vMhR6V7Fch606jBlt54ksEuPvU//Sh6EXxqoqz9N4FPnj2tLrRbYi1yk7ibg
lzSVtEE9Ux6sHruRVBlJ4B+v6146ruXBLU+3UpRAYPom4dADFjwoLXj4JPk2
gXWGl5teseZB2fQ+y7anBN4cs4vMtuPBU1W9tWQBgc8tSvj0zYEHPkVX/cY+
EjjzXXHsvw08EK32HEurJ3DDtiEXOVceTPSv8JPtJ7DQlNLc5Zt50BZ32kyZ
ScMGiet/uXrwYE1Qohd/Dg1HlKftue7NA7nmScZuWxp+ubtet2CXIB+azAM2
PjTczBD5V+fLg/3JnioHw2h4xUqfkwqBPHB8uSxtJZ+G2x8qx98OFdiLHk+1
NRP049nmccYpHnw9tnm6x4eOh7zubt0dxoNKiW1PVwn6lVBU1loSIainso33
uQY6npOoVFSUyIPnM2JT7aEMrHz4l4ZGEg/W7hifXfWAgTU33Im6lMwDa46u
ZFg5Ay+VVNrk/IAHH6+IzDszj4kdzisOtD/nwbJ9ixfa5DOx684mF+uXPKDt
OXNsspGJPdfcfpWezwNJf0uWOJOF/Wbnnz+KeSB95mSzoi0LH/jZ2FNfzIOK
D996hPaxcNCrZCf4wINLUTxF1cssHH50/nzhCh7IOCO54q8sHOXSGOZfxQOP
r/biy4dYON4g+XfVNx6sSDC2y5Mi8d3+eTk36nkwT6T05HtrEj8u/zlntpEH
nDWlhMUuEqc/vXXKu4UHVukVqa9OkbjQZ56t9m8ePNC6o7bvOYmLzX9mxfbw
wCLZq/bBRxKXqd7i/uvnwXXdnRg3CfCQ5nF8019B/vse/SocJvGPJoXW1yM8
cHPM7UsUonDj6wZLlQkeVPHu1KyfS+G2pJvp4dOC+l2dGG/RpvCQq8Kx9Ux5
eN9aOu+qLYXHlzY0vaDkQTRy68XszQL+kLlpzhOVh7r6Ys5THwEfDm15Gioh
D7bJdUHBByksXjlXullaHqzO+vxSPCHgh/T6I+ay8hDxPaw8+TyF50QmNTzh
yYOjZcT7kRgKK+/ZYiahIA8bdmbFaiZSWNNy7uMDivJwZF/yyqW3KKyrXi/+
Q0UeVGfdaubdo/AyZtJBY3WBvSVX0lofUNikZXPt7YXyYP+wcMmFxxReg+cg
5mJ5CE2z6xBLpbB1cl3Kbj15eK3N9z0okB1Cb4iUG8jDVYv0sNdPKOy6eXPg
kuXycIJ/ZabnEYU9V8z5nrBSHsZ12woYgvt3ytUZT6ySBwN+7QvGXQrvHb5+
19NUHlr9TnT0JVH4wNdNVPFaech5pOLxIYHCwZny/hqW8qBVUbokJprCp6Jr
v16ykYdnR7edtAyncPje6ysG7OVBenm4z79QCkdZb0p2dpKH9uIP7GsHKByv
Kc/Md5GHrsfdT/QF+XX3VH/U6iYPnbdsO+5tofCCeANrCXd5+Dzz6qneegpn
z9rFenvJQ0zc3cangv0hdOkWg+id8qCYIV55c4Fg//Db/T1vtzwcqwpf/1yG
wt++n1GQ2Cfwz1Kzz3GIxDfFYvkrDshDXMD2U02C/tlhdsvL+7A89AecD7/2
mcTDz3If54XIg6GOAf+KgH8553oMvS/IAz3qwvBPCxLXFYz/iLokDy5pb/9X
wZXHQ/V+4Rlm7rWWVPpiZsydK0lStEjJnGRLipQ1spRCUiGylBYplFDJkkiU
PSVLxLypFCJJC6mUXfalbOV3f3+ez33fc877POec5/7x3mv/Ww1DqcNYYEmk
LCgZrE03XIwhDTvimeQNWeh3zPNO/M5E5mssd5TckYXSeE7b+sNMJOe2f/hn
mizEGb6X1Kf67eftY9ckM2ThmuyaG/GqVP+JRTQ758mCSolDOesXA8X8ELhI
lsmCoGdFS7kDA9kuqRPZUCEL1hHlW9Q3MRBvR0u28zNZ+HzmasnUYgZ6VDI+
UvyKOv/DB43R1cKo8ery085NsoCNOAjJLhdGC3SuxRYPyMLx5MScE7V09Nk7
RevnsCzQArk0fhIdpWTmtkqMy0IF8ZFxzpOOVi9+zXOeloXg/onU4Pl0ZNY/
myeBy8F0yeZfd7fTUFTCwVdOXDmo7qzvGbX/K/DzPecdRMrBzZyPk84Ts4J9
5rcVbirJwcoc301LL88KVMU++r1RlYPzyW/UCotnBNX++sqaWnLwZrhSPRqf
FgjZKIZJmMuBbBqZcDbyt+DEkp/GxeflQOVU/upLeYMC2+v29RLdcqCj9Y0l
xE4SsArE5A/3yQGXr+8ULneY//1d8aHqATmY5PqYC0bu8A/Ml6aHjsuBg7TF
5usbnvA9w6vWzNHlwcgs0Yvf8oZ/7syq+BGWPIinH/TSv/uNn+lBP/DRXB5E
3FysbRyH+B4ReflrLeXhWO+1ZPlVw3y1rL1/Y2zkwZAx71N17jD/UXdhrKmj
PNA0vn3fkzXCf+rsXv36iDxcCl7AKkwe4zdYv1cruyQP+XLH7sb7/eFP6qVP
JVfIw95DyVf3Fv7jB5Uln3/xTB7mXN6WrJSf49M0EiR7X8jDs5N6Y6pn5vi4
wlVCo1YezKI8n9STNJCZOrntxSd56N4mfL65kwZrck3ie4blYesju89scyEo
Ig1JyXEq/x9LNTadEoKNCVty1f/IwwG9wK2v7guB7sX1zwL+ykOqd98r3owQ
mDlxeyXEWKBvPembnSAMnovHN6iTLBh6YT9uVMaA0YjBSgslFlz1r8ywb2XA
CaFek4DlLDCUpctXzjIgaOir4/NVLBhxe3fYexMTIqpfXbLQZkGiUKHOtnwm
zINK6QA+C+47biBza5kQU/T01m1dFgSexCN2dzEh4e7D/G4jFvwazLZ2ksUg
41TiZ38LFhS9F5sw98VAdfyG821rFuQHtnXfisAg3z2qv3IvC+r1tGRZKRgU
W12gSTizQEzezKOgCoON9cHhq11Y0BsktOD1/++N6gUssnBlgZ5OHV28D4Mq
9aPKtz1ZIHnk9ONFYjgYZ7g9qjzOgvNzF39++g+HOs4B7W4fFig2VKlWKuFg
dmNflfhJFnSxM8vercGhSdzGbHUgC54tSypmAA7W53a37DnNgkvfgo1stuPQ
OrnjgP9ZFvX+tvNqnQUOjkeNBpNCWLDF8maOgwMO7Z26JysvsmDOreiZpCsO
usn1qSoRFH4ee1u9juGQYm1bFxPJgr1lKw+98sNhbkHXn+loFqjb7RUSPY3D
vtrjvP03WNCUk+Sw7jwO5SF/TWrjWDA2fE7D+CIOLJ0wvzW3WLDZI15NPxyH
wD+LUhOTWfAjKkZE8TIOLfkpb4TvsuBgxoLbHZSt5a765/A9an3Gt64Qyo4j
S4imTBYE3epsEYrA4U/rVhPtXBa4zDw+bncJB8vYt75p+SxYfG2w/GoIDoWm
e+9IPGZBgNGsamIwDotEu2t9illglINrn/LHwbvS63drKQs0TDe6rvXCoTHw
H1e/gkXp1wd1gRsO6uvCt+c+YwH314szLEccogYX+y5+Se1HnPvbKfyG7t9J
OfWaBQfSRGa2b8Nhp9PK2s5aFkjJZDSytHHIlXsyseMtC25HoHvlK3GQaNLj
FjWygN0g+1KNg0ONgd2J0GYWpN15silkBoPltJ7kwVYWVCdaVLr1YHDpiXeN
ZRsLOpKzzvCaMDBQjVBY1s2Cs6nSKTIZGKR3yhhf7aP864lnWkZhwEhO9fkz
wIKN2s/We/thULmgtPrVOAt4OK9wly4GRK3++KpJFqzP1OxmKWFwJuQdJ26G
BVuPhup8FMFA50+Pt6sQG/Ze5M4up/qhtHUJR1SKDSblLt+U9ZggG3vX6PhC
NoQIKgZVuUw4abrKu1mGWu9WM+s4w4D1lQavM9lsuKF8ZO7SAwY8un/Cy3gF
G049LD24V4oBC5zoSY/U2LDPd72DXbcwHJO78kpOgw1BdpcfMCuEQe1KGuvX
BjbsonOTU9yFIcvrfVWEARsalzYm2z4XAlFVh5GxbWzQDgvdMB0vBK6dffJ2
O9gwF81wnj4mBErWQsdV97BhQc/BtjCuEKRuVpevc2KDyoXCd1gYHSp3ip2f
OcAGdv3Lqwtc6fDTob1vuSsb7DO3DG4wogN57kZpqCcbZGVur9SRoIPeNU9e
4XE2aK0MCd8+TKN4Ngxv92FDu6qcetMHGqRVTdlAIBuWWRmlPEinwYtPjc88
T7MhPPCwumoUDTp6spcnnWUDzfrbVr8gGjCmQ6JrQ9ggGCtoS3WngaL4vqmp
i2z4ZfBeS2BLAz2WppNyBBv4L+oOfzGh4q2UqraMZENx2OuVjC00CNHpXX0h
mg12uV6kviYN0k0r4wqus+HagY+K91fRoMoxkfbzJhs8uEpf1VVo0HXcx1Uq
kQ08QxmxPiUaYOd3NOjcZsP8fbL/GpfSQOm60oYjd9gg89teb4B6bpA+l5yY
xgZbu8PpmtT+g0Wf8Zr71PnrLp7Jo/yHvnp4dDKLDZX1KnImVPx7n8M/KeWx
4ZXA7LUIlV9V736+xUMK39WXL7VQ+XdNa98//5gNDwb2dBRS58MkZOY/KmaD
fn/+3GXq/MvYQ75tpWxQUrw6YEbhY6T2+tu8CjastaeHDV+lgSv/jsHmZ2zY
7VvVakPhm+G0WybhFRsGbyV+/P/3Xa+9VE+/rmGD/JnqjaFDNOg5z+z6XceG
TYWjfYbidFC+V1y4u4kN691e/qszoENmn7yF5A82+Ik4HNerpUPNzPjTTR1s
+NHg15A8SIc+iXpF9242TEb0OeVLC4HKqjPjVQNssMRvTsTYCUGWd8e1M9Ns
GJgv8qtjXAhqQspn8v6yITIsWPGovDD03Yjd/5XGgdY2XT5NVxhWlBit2Yhz
YMr71o/+SGHImc1pHFvIgTizVFFpJQa8kQzdyFvCgXnz66qGjRnQz3FINZPj
gGlKaprFUQaoblnglcvlwJdE+ZYzRQzIvXBiwaGVHOAKsu4s28yEfm37cxdW
c6B03CHayY5J6ZHe2N01HAiJ2xP8OYAJWc6LPrRpceAYY26ncyET+mRn9ee0
OaBsEbva7R0Tlr9rL2IDBx6ffpdyvZ8JGfyCOFsDDrQzN70x4GLQ8ztB1H8b
BzasFfv1YgMGy/LOBdw04YBKTAXdygyDeyxzuyZzDpx5K7ErKwiDrvdadaMW
HKifkrA/GI3B0ghCZ4ENB/5O1z9YkY5B2tSwwk4HDgjfHVKtrcagI/9zlIcz
BzqWRmeltmBAuiJ6hAsHaBInv52i9NBZIcMr05UDGTV2GnZTGKR+vNr+6jAH
BvFM2c04Dj+u+O3p8uTA/u0pRtxFOHD1HV4yvDjgvanlDZNL6duswXryBAcy
V9wuG1DBIblA7f6WkxwYDRRz/LwWh2/uMv85BnKgt+GZSdVmHDi8f5dOn+ZA
VeNL2RJ9HOybO6dunaXw4567mGeCw62oOveyEA7oJzPis8wpPTUs/NJ8kQON
P05a5VrhID93y2QynAPXDdrfF+/FwbYopFwmkgMF+vU2tftwSDjiobYumgOV
AumdvZSetCjuSd59nQNbP8UtXuiMg2zrJimvmxwQ7fVWMqZs62vk2agEDoz0
RHCinCj9MxYfzUviwL2StpQuSq8/0cec61Ko+Avjd5na4yDzpOX9r7scyP22
q7fWhtLDY5V6Yvc54J8Qs3ofpVc3lmUVKmdxINuUPYybUe8L36KVDHM5cLGh
bqyG0q9Fsf43XfI5kPfy9KJMXRx273ASCSngwL5Op5VpG3GIYWzzTy3iQE1k
tmyFOqWXZav70BMO3DALLp5chsMC7//2fn/KgbffDndZsCm9/NGtzXrOgUur
zL2DmTg0xL3N3VjFgUArzSumkxjMNyvm2FRzgPGyOXsbxXdkRSgt9i0HtMa1
rZ/XYlB/wvP440YOuFy8cdmgDAPJlZY/Gz9Q9e41LDWTicHlxKUv5rdyIL5C
Yd1cCAZvzCXXqX3nwAR5xdb8OAbiYhPpJj85cFlH4/tXOwzCT764GNbDAZkv
i0bS1DG4aLF/u/AEB6ybRiJ4jUxINW21c5nkQMrOoXr1IiY83Wbh+WqGA3xl
4ZUH45kwutkwOkJIAca+m1wzsGeCndKKTwulFCC/0NKN+4UBfty0nhMLFaDv
v7jpmBIGxMixpz/JKEDaykSPTTcY8GrefPYttgJMfFUPXG/CAI0/o86KKxRA
7oTOkoUPhWHHyGGfUDUF6BB/tsTrkjC4/uq40KOuAM1JT4b+cxCGpO8fM3I2
KMDsG+VHhmLCIPK6dHCtgQIU7suNOWotBN/izgXoOymAfXCSFnykwVTMTMT9
Awqg55QzaHGXBouu+CSJuirA9ufNxt+P0mDb2YOozlMB7B7rBdngNHjsZoxZ
BimArK/do4uO//jhG6VjDt5UgMGYexOBzdP8da13Mi/WKYD/PU3lNSZjfCk1
18kHDQqwStNqWdanUX5/sJrh5/cKoOIXTL5zHuWnkWUdyi0KsO6/yZ2bT47w
Fx1uUqjpUgBMrcz6K3+IPx0kvB2jccFoR3ZTbk03v1l8/TMjWS6cXyD8otjp
HT9ueWJu3XYuRN2pKTS90ykYHzNIP7+DC8VjvASNe10C04rRW1qmXLDvfbn/
TVa3ANttfDndnAv1eUn+UgW9ghNBU+6nbLjwrq0b1xIMCMzfWimvPMQF6axv
wrJto4K8eGFuuysXNurqqb3cNyYQPfBgSbw7F1xS3pYt/DomQJMYzvTkwpPq
mTchn8cFq3hFna0+XLj3+u/B5TW/BRInFt29fI4LK3b458Vdmxa48lGCbggX
kn0SznSIzgiei3rETF7gwnWXqjnf4BlBwO3nZw+EcWF7h1qpheusoPeVl6N2
FBfcTyYlaa/+J6iSe8fuT+ICzc/exLaahnidQYtTk7mABaYoK/yloVMPlCWt
73ChMSeBs2s1Ha3VOzP7PI0LyoLR5UPX6Sj1yKovidlc4O+9qF1qKYSC0ZW4
7U+40OOddbTziTDq+4quT5VyQenjMnL7T2FkOTMWdf8p9//36OonRBlIdb1t
mDDiwuozk2ekrBjoc7ZSQFkVFx6Rrwvkehhoa7WNr9trLqhb2m86JMZEeV2X
vZbUcOF+X2Zy1womukCMuXvXcUHgpux/woOJNG4K9q5o4kJHyPDW+HYmSno8
atX8gQt6mw1X6M4xkUjj0j0XP3EhsdHUSVIOQ98lLpu0t3ChVZR2S2gHhoxV
BEbRrVyoWU5GKbtgqMhwVI//jQtD8rQC1yAMXT5nvTnxBxfirGr3rMrA0J/k
CK1t7VyoSD765OFTDDmXV6z708GFrlX2SwwaMKQ1qai2u4fiT0/L9dY4htIW
W6vQ+7iQ3jusZsvEkdSaCKUHv7jAyHS/QSzGUdeREY74EBcum8k3vVDH0a4I
RfknwxQfY199b+ng6GmG1ZJDo1xqHi3bccIYR8pV4QsXj1P+T8Rt3mGBo2vt
5fOfT3DBS7xyFc8BR/9oI+LH/3Ah8FKc5OghHLlzFEUUprjwMKuxtvQojj5s
smLUTXPBQPO1U4AvjsAmnBY4y4X+ZnqtWhCOsn3LZ5X/cWFO7uXij2dwJHN9
ePLjHBcK133e4xmCo3MPyYkQOgFhSxTTJkJxNFBvOaIhTMDaZlG++yUcWfeH
DbQxCDibbXuohrJfiJb3RmIEHHmz4Mgiyl61bLhTW4SAEhav3oDan6BH/uwT
JYD723OB43kcMZ0tv8WJEyCiSn+/LxhHx4LDWgwkCTgatm9wSwCOWm89/Tg+
jwD4nmgs4oMjw9KhxlQpAprn7+vP98DRo0+8t2bSBMzuGlux6QCOOBMWtf8W
EtDjLnvsni2OwqTDXuUsJiD7tanhqCmOxlc9fW67hAAzWlEWRw9HDjuGBCKy
BHywOJW2QhNHNe68p0VyBAizktxkl+No3SWLkgMsAsjsydc9sjhKSb/0WJpD
gJ7FpQcJojgSf16WjxQI2LB44eLVkxjybRvM8SQI6D4dcjOrE0M75C3SaxQJ
SHM387Aqx1Bchxraq0RA/oipv2QmhjpyRb70LyOg7ezmXx+uYSgInkrNX0GA
/7q6J5kHMZTjQgbtVqfw9ChaUEnH0KTa39gODQJcNOtGPLuYSG/y48MTawlY
JzPQY1rDRF/Cw7tvahKwMT4hq+oqE4nlj5i3biag8GKTwx5pJrL0rz1yhE/A
XHirifsIA6Xqpl/6BwRobL9QN/6WgbQ+WFdw9QiIvN8SGx3BQK7TguUuxgSs
ce1L1PknjF7pRdIGLQn4eEjnufI3ISQ9z1U+2JqAkWVqJYOlQmjfpy3rpWwJ
6CDK2rhxQui328RhDXtqv7/vAvk9Qkh3zdvQ5/sIuHEUMMk1QihyNuPOHkcC
pEPKjlVICyGlq3affPcTEFB3wbawiY68rNeP4i5U/r4t5UuL6aiCkJKMP0hA
3dNI7ewEOrJ4/Fy3zI0APx2oNnKho5RTSfYmhwkIMtTqDDOho34Dv5NfPaj6
vZVjoL6OjkKaVfLmjlL431g19FeMjhpSGdVRxwk4oO/wXX+Shlge39oJbwIE
g1+YG7tpyHVdyb9HPgQovEPlPZ9oqOBftKyeLwFvTediHWpo6N+rw2s/+BHw
KwZUsipoyDha3/SgP1U/Ud0L3j+moVhbBfc/AQTY7DR48jOHhn6SUyGXgghg
DZgfabtHQ2oDjcmypwmwtO3kvUuloYCinNKsYAIyZS7dLEmhoarg0A+bzhIw
OOrGjaNs6W2Ow2/OEdB/7lT1UWr9PumN4vtCCDh512nzZspf1peFSkMXCPBi
jDTNZtPQ77QBOHORgKimx+kZBTS0xfPV3gVhlH9m7Rmtchqa/txr8CKcAM9H
r+ceUvrweKuEht9lqh6XOSwy+UxDR/LU2CqRBOzUWCM12UNDSrK7RL5eJSCi
Ta7r7gwNtZ33HrsaTeV/54KnthQdxQ/e+KZ7jQDnyVnFHCU6knjR8jgjlgA+
GetdZE1HVWp/k/fGEXCl+pMD14eOguMVIuYlEPCvf1MDLZqORj0POPkkEXBK
+EFIWT0dfZYdlIQ0Av6b3J/AtRJCMSFSU6PpBNycyZTYESiEtg9pdKTfJ2C0
XHPnfylCqOKFX6l4NgG6mlnnyF9CKO0o/dCnhwS8PlxF2IYIo2MvFyFPAQE+
K/MSrPIZSGW1ZjbxjADkvbzy03sGak+wiW2qJKBPhfm44DcDWR677bGxigDr
gY3rdmxkIqkvyGrgFQHjlSUNY7ZMVK3frptSTQCuVLDpdQATacsry2J1BJSS
v7w/FDPR7wvGjCf1BEjd5Zv8bWKiB8MeQ4cbCLDzFQf1ESbiVT18+e49AYui
rjalKmGodXVTfsgHaj727RI08TF0I/F3ouYnAkKfO++escKQyPFNXkktBFxs
1upddAFDlV/s7c1aCUieXBpJS8BQoMEZI+FvBFQWYh3vcjG09mHqmqLvVH2o
RPqHIgwNyr/kuP0gwKnR5K98I4YyQrtFWe0EPJ64Vh71E0NOI6IT9R3UPBu6
Z9E+giE5O9W2s11U/EaZ69I0HDVV7axd20OAh/FAE1sSR5Hqx4u6ewmga16+
yqDmo+Gta3cSfhEQH5gQWUXiiIYXXd4xQID+i7GJ/StxVHr8sx9tiIBiOZeZ
1nU48m6ddi4YJqBXPF1DYzOOVA3ZOw+OUvV7Ld/ywFZKLx/ytWTHqfn0YXSL
jxGOklnOim8mKL5//ZTdb4KjjWtWqDn/IUAr4MMGcWq+N20b15ycpOIphoc9
McORp2P5lshpAnJOWpoc3YUjEb/Q7YqzFL8Rxi9WUnbqFVOL0r8ELO/O2f2b
2q+d9p+D2RwBX1+GBtbswNHH0h+uXTQeXGdKVmRTenzsXZZXkBAP6JnmdxIN
cCTW4x0kzeCBTaxHTeIWHKX90w7NYPLge0TNr9xNONJZjEXp4DzIcXld/H4t
jj6veBvfJELZ81D7PAoPL924u+5iPChYmLneSRFHEjZOuTQJHjTkhQe9kcPR
vaMqxbGSPDhfteusuRSl36FjSHU+D1Y9fy49wcBRy62nNZVSPEhuKmYWUfrj
U3ChyVqaB6J6gatu/qL4bVvSE7KYB5Jv54Ke1WNI90/biNwSHsTHbDWZJ6Dq
TTJrJv8/HlTlGN4/l4ehBZu053+V54H9wBOz3nBKf3YxZb3ZPOhindL97och
A9d6nqgCDzKLTzEZBzAUcMNx/ToeD+Q8Otf90MLQz6EQ+yvKPDgw48hntTJR
ELbzEKnCg9s3PJtKK5lIhr3k+JMVPPA5sd4/NoOJjI0zQzrVePArVm1O3IuJ
HqXVZW9ex4Nh5HSBmGUgk7LYwvfreRD50pLd0spAXe8cBG4beHCQ4fDv61MG
kpsbabyxiQf/lSwYrg9goPM2MtMDW3iQ9/ji/rBBYcQ59l04ZCsPqv/k6DRU
C6OS0AxJOX0ecOVi/I6nCaP+go2EgRHlb+FqRq2VMNozz8Ho9k4esDVv3FpU
LIQUn9+P3bmXwrd52KTPho7qVSfTWu14sOE/M6NnqnR0MtaowH0fD6Z27twj
P0dDtW69b0OdeOB5uEvemZrPXlIrRAWHeBDr2mU4XTUnENjnBa7y4YFr7Nrf
S9JmBbaTjx2lrvDgh9eLxZrtE4KolZUqjRU8mLlqcGu721dBxoa9oucQxc+3
pTZZLl8Egq3j3eqVPHjUVzJa4tQsGLRRSo9+yYOfh25tpdt8EGwPDVfY9YYH
fKVfzcNhNQLsu/mihmYqfn5/gJzufX5gVPvfunEehKebxzy4+YMfkxjUeuo3
D0Z6DFXj437ys+4tLls5yQP9FdJ79eLb+Z+fGp68MsMDcYWPh97Ed/LX92aP
mgiRsF2t84rMzV7+8Baf7tr5JPy825bwtGKYf3CM8a5ahQQt3+ctUs6T/H1Z
evV2qiQobTuiptgwybd0CqkdWkmCpJR/Z/bmKb7BW+GqxeokhC57qslcMs1X
yhYqc9Ikwd/BiGZdOcPvdKalT20lwabgacmyP//4rbKQelmfBLXJ6w1rbOf4
TQ3ByQqGJHztwURcns7xX+jMxesbk/BvW3PAAv7///v0LzLajIRH+MvWLTM0
ONA4c3K5PQnnb7ds3rtXCOzCNvk+3UdCQY/G3V8hQrAHAr1NHUmIznse2psr
BHp500dO7CdB7PrWq0v/CYFi+JTzMzcSMkNP3T94UxhYW7Qc9xwmIUBc45nK
U2FYNHnSvtuDhJmOU4kmbcLAODhpJXmMBFV5M5lUJQa0b/ljYuNLwom0lESn
bAa0TK437vcjYfGYZUlbDQMaH/gaBvuTkGFboPWglwGV7N9b0oNIGDur67dm
KRNKm9bxN5wmwUFaUNa5hQmPIk5o1waTIJQq7Ndmz4TUqfH1I+dIiIi47ZJx
jQkJ+WvXhoSQ0LG6k+eVy4SYQz7qS0Ip/+ktbqeqmHDuw9iKzWEkvLR7GbHr
NxOcH45yw66S4Nu8JKXCBAOPc7tnjaNJuGnyJv22MwYndj/+JHGNhKqDLVuC
/TC4NHEiMiqWhGT7d5OatzGIqfroZh5Hwh2fBy1i+Rgk3tTUX5RAguOOj4Pv
EQZ5WlMzN5NIWNJ3QEXnOwYlYrafbJJJ2G0uQWvpx+DZl9JH8ndICJ5q8XSa
wqAmRz7yayoJbmq9de8YODSdCnJLTiPhudY8L+X5OHzd+VXP6R7FZ29SofN/
OHQp6HDJDBLWpJymn+biMDx8e6Yjk4R3vgoCv2U4TD2b+3gvmwTz0CGrHStx
ELrm+Mg1l8onK3f9rDoOEgeeXVF5QEJhSfbo2XU4LF7Hc+vPJyHEYbdWqyYO
HOy8Xt4jEuhr5peIaOGg/Kld4dhjEsJ9W+WZlK2eoTejXkQCh/tG5S21fqN/
+sexYhJiX7qLu1D+9IyxR4VPSKhuiv79//vrO+UPXfErI+F6mdzSAVUcrPpf
uWqVkzA63f/hixIOjuXKejMVJOwUXZZ/VQEH98gwhXJEgrfI21x8CQ4+Dn3T
pytJcBktqNGVxOHU6u0f4QUJJmNqVFHgEErPeShURcKBlUeOzk1gENUoceXF
KxJ2tR26fqYHg4S7R1xDq0lY9epm0PNmDO761G81qiXBUmZe6utqDHL0VymI
1ZFglum+KLoEgyKZqOnaehJS5Oh97HsYoO7hD1caSDBt2X/qWAwG1SW7Hpo2
knDXbko14hQGrbYLXd9/IOFPw0kb0gyDrhU+W298IuEp/Tf7viYGQ7NNHKtm
qt/u1VnSOBgIJcd+aGklIb1h9Lp+NxOWtctu/dlOwvKs3JBqDyasfhzASeuk
+s9D61zKdiZsvPBlyqWbwvPI8S8XljPBZFlSfm8fCUkBE9X3fjLA6zCXMzJC
1U+1xuqc7QwI0j479WiMBPaLwiVWigy4IPmzyWeCwmMg8OzZWWGIe3A3YnKS
hKyBrPV3soUh9QzjUOk01a9ihfGCc8KQvctFN2iW4nfPnhsPbIThMa+KrfOP
hAsGgpBLq4WhYkxpam6OhHLPt7+ccWH4Hz+E34Q=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-2.9600095756457803`, 2.9589971604697825`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516543416*^9, 3.536264764496242*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUV3k8ld8TxrUv172WSyVZWiSRUoTMlBZKUhSVJAmpLK2KIi1KhL6UhChS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-4.38801273831517, 4.390167653160539}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184516543416*^9, 3.536264764522533*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell["Animation.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 StyleBox[
  RowBox[{
   RowBox[{
    RowBox[{"Xn", "[", 
     RowBox[{"x_", ",", "t_"}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"x", "<=", "l1"}], ",", 
      RowBox[{"x", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"First", "[", 
         RowBox[{"Evaluate", "[", 
          RowBox[{
           RowBox[{"q1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
         "]"}], "]"}]}], ",", "\n", 
      RowBox[{
       RowBox[{"l1", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"First", "[", 
          RowBox[{"Evaluate", "[", 
           RowBox[{
            RowBox[{"q1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
          "]"}], "]"}]}], " ", "+", "\n", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", " ", "-", " ", "l1"}], ")"}], 
        RowBox[{"Cos", "[", 
         RowBox[{
          RowBox[{"First", "[", 
           RowBox[{"Evaluate", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
           "]"}], " ", "+", "\n", "\t\t\t", 
          RowBox[{"First", "[", 
           RowBox[{"Evaluate", "[", 
            RowBox[{
             RowBox[{"q2", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
           "]"}]}], "]"}]}]}]}], " ", "]"}]}], "\n"}],
  FontWeight->"Bold"], "\n", 
 StyleBox[
  RowBox[{
   RowBox[{"Yn", "[", 
    RowBox[{"x_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"x", "<=", "l1"}], ",", 
     RowBox[{"x", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"First", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"q1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
        "]"}], "]"}]}], ",", "\n", 
     RowBox[{
      RowBox[{"l1", " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"First", "[", 
         RowBox[{"Evaluate", "[", 
          RowBox[{
           RowBox[{"q1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
         "]"}], "]"}]}], " ", "+", "\n", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", " ", "-", " ", "l1"}], ")"}], " ", 
       RowBox[{"Sin", "[", 
        RowBox[{
         RowBox[{"First", "[", 
          RowBox[{"Evaluate", "[", 
           RowBox[{
            RowBox[{"q1", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
          "]"}], " ", "+", "\n", "\t\t\t", 
         RowBox[{"First", "[", 
          RowBox[{"Evaluate", "[", 
           RowBox[{
            RowBox[{"q2", "[", "t", "]"}], " ", "/.", " ", "sol"}], "]"}], 
          "]"}]}], "]"}]}]}]}], " ", "]"}]}],
  FontWeight->"Bold"]}], "Input",
 CellChangeTimes->{{3.518449501142*^9, 3.518449501142*^9}, 
   3.536264778226336*^9},
 AspectRatioFixed->True,
 FontFamily->"Courier",
 FontWeight->"Plain",
 FontSlant->"Plain",
 FontTracking->"Plain",
 FontVariations->{"Outline"->False,
 "Shadow"->False,
 "Underline"->False}],

Cell["\<\
Click on the middle bracket on the right hand side of the output picture \
shown below,
then type <command> y, or double click the figure.
\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tf", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Animate", "[", 
  RowBox[{
   RowBox[{"ParametricPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Xn", "[", 
        RowBox[{"x", ",", "t"}], "]"}], ",", 
       RowBox[{"Yn", "[", 
        RowBox[{"x", ",", "t"}], "]"}]}], "}"}], ",", "\n", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"(", 
        RowBox[{"l1", " ", "+", " ", "l2"}], ")"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"l1", " ", "+", " ", "l2"}], ")"}]}], ",", 
          RowBox[{"(", 
           RowBox[{"l1", " ", "+", " ", "l2"}], ")"}]}], "}"}], ",", "\n", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"l1", " ", "+", " ", "l2"}], ")"}]}], ",", 
          RowBox[{"(", 
           RowBox[{"l1", " ", "+", " ", "l2"}], ")"}]}], "}"}]}], "}"}]}], 
     ",", 
     RowBox[{"AspectRatio", "->", "1"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], "\n"}], "Input",
 CellChangeTimes->{{3.518449426652*^9, 3.518449426652*^9}, {
  3.5184516671804*^9, 3.5184516831236*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`t$$ = 2.7790932655334473`, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`t$$], 0, 5}}, Typeset`size$$ = {360., {178., 182.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`t$307$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`t$$ = 0}, 
      "ControllerVariables" :> {
        Hold[$CellContext`t$$, $CellContext`t$307$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> ParametricPlot[{
         $CellContext`Xn[$CellContext`x, $CellContext`t$$], 
         $CellContext`Yn[$CellContext`x, $CellContext`t$$]}, {$CellContext`x, 
         0, $CellContext`l1 + $CellContext`l2}, 
        PlotRange -> {{-($CellContext`l1 + $CellContext`l2), $CellContext`l1 + \
$CellContext`l2}, {-($CellContext`l1 + $CellContext`l2), $CellContext`l1 + \
$CellContext`l2}}, AspectRatio -> 1], 
      "Specifications" :> {{$CellContext`t$$, 0, 5, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}}, 
      "Options" :> {
       ControlType -> Animator, AppearanceElements -> None, DefaultBaseStyle -> 
        "Animate", DefaultLabelStyle -> "AnimateLabel", SynchronousUpdating -> 
        True, ShrinkingDelay -> 10.}, "DefaultOptions" :> {}],
     ImageSizeCache->{403., {214., 219.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Animate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.5184516838255997`*^9, 3.536264764786207*^9}]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, 128}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"NeXTAutomaticEncoding",
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 208, 6, 56, "Text",
 Evaluatable->False],
Cell[768, 28, 120, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[913, 34, 317, 9, 27, "Input"],
Cell[1233, 45, 225, 4, 20, "Print"]
}, Open  ]],
Cell[1473, 52, 82, 2, 26, "Text",
 Evaluatable->False],
Cell[1558, 56, 921, 28, 88, "Input"],
Cell[2482, 86, 86, 2, 26, "Text",
 Evaluatable->False],
Cell[2571, 90, 3723, 128, 388, "Input"],
Cell[6297, 220, 89, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[6411, 226, 304, 9, 27, "Input"],
Cell[6718, 237, 253, 8, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[7008, 250, 343, 10, 27, "Input"],
Cell[7354, 262, 382, 13, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[7751, 278, 98, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[7874, 284, 191, 5, 27, "Input"],
Cell[8068, 291, 162, 4, 27, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[8267, 300, 197, 5, 27, "Input"],
Cell[8467, 307, 231, 7, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[8713, 317, 82, 2, 26, "Text",
 Evaluatable->False],
Cell[8798, 321, 234, 6, 27, "Input"],
Cell[9035, 329, 101, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[9161, 335, 207, 5, 27, "Input"],
Cell[9371, 342, 136, 3, 27, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[9544, 350, 205, 5, 27, "Input"],
Cell[9752, 357, 266, 8, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[10033, 368, 92, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[10150, 374, 323, 9, 27, "Input"],
Cell[10476, 385, 565, 19, 34, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[11078, 409, 455, 14, 27, "Input"],
Cell[11536, 425, 1838, 61, 34, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[13389, 489, 84, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[13498, 495, 195, 5, 27, "Input"],
Cell[13696, 502, 315, 10, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[14048, 517, 195, 5, 27, "Input"],
Cell[14246, 524, 512, 17, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[14773, 544, 81, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[14879, 550, 227, 6, 27, "Input"],
Cell[15109, 558, 257, 8, 29, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[15403, 571, 237, 6, 27, "Input"],
Cell[15643, 579, 256, 8, 29, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[15936, 592, 276, 7, 27, "Input"],
Cell[16215, 601, 276, 8, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16528, 614, 291, 7, 27, "Input"],
Cell[16822, 623, 346, 11, 29, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[17183, 637, 102, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[17310, 643, 183, 4, 27, "Input"],
Cell[17496, 649, 575, 19, 34, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[18108, 673, 175, 4, 27, "Input"],
Cell[18286, 679, 2002, 64, 34, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[20303, 746, 78, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[20406, 752, 251, 7, 27, "Input"],
Cell[20660, 761, 578, 17, 34, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[21275, 783, 271, 7, 27, "Input"],
Cell[21549, 792, 552, 17, 33, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[22116, 812, 88, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[22229, 818, 351, 9, 27, "Input"],
Cell[22583, 829, 294, 8, 31, "Output"]
}, Open  ]],
Cell[22892, 840, 79, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[22996, 846, 192, 4, 27, "Input"],
Cell[23191, 852, 515, 17, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[23743, 874, 479, 13, 27, "Input"],
Cell[24225, 889, 1250, 40, 34, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[25490, 932, 82, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[25597, 938, 1097, 31, 58, "Input"],
Cell[26697, 971, 2733, 87, 47, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[29445, 1061, 80, 2, 26, "Text",
 Evaluatable->False],
Cell[29528, 1065, 1845, 53, 88, "Input"],
Cell[CellGroupData[{
Cell[31398, 1122, 174, 4, 27, "Input"],
Cell[31575, 1128, 3821, 115, 60, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[35433, 1248, 1089, 31, 58, "Input"],
Cell[36525, 1281, 1212, 39, 31, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[37774, 1325, 62, 1, 27, "Input"],
Cell[37839, 1328, 2107, 65, 49, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[39961, 1396, 95, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[40081, 1402, 252, 7, 27, "Input"],
Cell[40336, 1411, 318, 10, 27, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[40691, 1426, 252, 7, 27, "Input"],
Cell[40946, 1435, 318, 10, 27, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[41279, 1448, 68, 2, 26, "Text",
 Evaluatable->False],
Cell[41350, 1452, 1434, 42, 163, "Input"],
Cell[CellGroupData[{
Cell[42809, 1498, 1047, 30, 88, "Input"],
Cell[43859, 1530, 21660, 362, 233, "Output",
 Evaluatable->False],
Cell[65522, 1894, 37476, 621, 229, "Output",
 Evaluatable->False],
Cell[103001, 2517, 33210, 551, 239, "Output",
 Evaluatable->False],
Cell[136214, 3070, 35259, 585, 234, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[171488, 3658, 72, 2, 26, "Text",
 Evaluatable->False],
Cell[171563, 3662, 2872, 87, 148, "Input"],
Cell[174438, 3751, 209, 7, 56, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[174672, 3762, 1367, 40, 88, "Input"],
Cell[176042, 3804, 2227, 43, 450, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
