(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      9311,        274]
NotebookOptionsPosition[      8838,        252]
NotebookOutlinePosition[      9181,        267]
CellTagsIndexPosition[      9138,        264]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"c", "=", ".3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"m", "=", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Vx0", "=", "100"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Vy0", "=", "100"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Vz0", "=", "100"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"x0", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"y0", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"z0", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"g", "=", "9.8"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fx", "=", 
   RowBox[{
    RowBox[{"-", "c"}], " ", 
    RowBox[{"Sign", "[", 
     RowBox[{
      SuperscriptBox["x", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["x", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fy", "=", 
   RowBox[{
    RowBox[{"-", "c"}], " ", 
    RowBox[{"Sign", "[", 
     RowBox[{
      SuperscriptBox["y", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["y", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fz", "=", 
   RowBox[{
    RowBox[{"-", "c"}], " ", 
    RowBox[{"Sign", "[", 
     RowBox[{
      SuperscriptBox["z", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["z", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ";"}], "\n", 
 RowBox[{"sol", "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox["x", "\[DoublePrime]",
         MultilineFunction->None], "[", "t", "]"}], "==", 
       FractionBox["fx", "m"]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["y", "\[DoublePrime]",
         MultilineFunction->None], "[", "t", "]"}], "==", 
       FractionBox["fy", "m"]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["z", "\[DoublePrime]",
         MultilineFunction->None], "[", "t", "]"}], "==", 
       RowBox[{
        FractionBox["fz", "m"], "-", "g"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["x", "\[Prime]",
         MultilineFunction->None], "[", "0", "]"}], "==", "Vx0"}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["y", "\[Prime]",
         MultilineFunction->None], "[", "0", "]"}], "==", "Vy0"}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["z", "\[Prime]",
         MultilineFunction->None], "[", "0", "]"}], "==", "Vz0"}], ",", 
      RowBox[{
       RowBox[{"x", "[", "0", "]"}], "==", "x0"}], ",", 
      RowBox[{
       RowBox[{"y", "[", "0", "]"}], "==", "y0"}], ",", 
      RowBox[{
       RowBox[{"z", "[", "0", "]"}], "==", "z0"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "[", "t", "]"}], ",", 
      RowBox[{"y", "[", "t", "]"}], ",", 
      RowBox[{"z", "[", "t", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"y", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}], ",", 
    RowBox[{
     RowBox[{"z", "[", "t", "]"}], "\[Rule]", 
     RowBox[{
      TagBox[
       RowBox[{"InterpolatingFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
        "]"}],
       False,
       Editable->False], "[", "t", "]"}]}]}], "}"}], "}"}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184522452136*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot3D", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "[", "t", "]"}], ",", 
       RowBox[{"y", "[", "t", "]"}], ",", 
       RowBox[{"z", "[", "t", "]"}]}], "}"}], "/.", "sol"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 Graphics3DBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], Line3DBox[CompressedData["
1:eJw91nk4VfsawPEdpd0xlQYOIaVStFEI5Xgz721V1qJMu+5pTihESYPrXBmy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     "]]}},
  Axes->True,
  PlotRange->{{0., 114.46623911258466`}, {0., 
   114.46623911258466`}, {-53.686182174774444`, 57.55907324114485}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 Evaluatable->False,
 CellChangeTimes->{3.5184522479592*^9},
 AspectRatioFixed->True]
}, Open  ]]
},
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 3159, 101, 287, "Input"],
Cell[3741, 125, 1225, 42, 30, "Output",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[5003, 172, 403, 12, 31, "Input"],
Cell[5409, 186, 3413, 63, 397, "Output",
 Evaluatable->False]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

