(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    225666,       6113]
NotebookOptionsPosition[    220147,       5924]
NotebookOutlinePosition[    220763,       5948]
CellTagsIndexPosition[    220720,       5945]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Trebuchet 1", "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Input the definitions for the vector operations", "Subsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
Input the vector definition with the command that follows.  The path will 
depend on where  the definitions reside on the local system.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Get", "[", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<vectors3.m\>\""}], 
   "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5184522694560003`*^9, 3.5184522728255997`*^9}, 
   3.536264921059216*^9},
 AspectRatioFixed->True],

Cell[BoxData["\<\"These Engineering Vector algorithms are copyright Alan A. \
Barhorst\"\>"], "Print",
 CellChangeTimes->{3.5184523330104*^9, 3.5184529847868*^9, 
  3.536264930559658*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Define the symbols used for Unit Vectors and Unit Dyads", "Subsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
Define Unit Vectors and Unit Dyads for however many frames we need for the 
system. For this example we will use three frames of reference, with the \
frame
 N being the Newtonian frame.  \
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"B", ",", "b", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"C", ",", "c", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"n", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"N", ",", "n", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"bb", "[", 
   RowBox[{"a_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"unitDyad", "[", 
   RowBox[{
    RowBox[{"b", "[", "a", "]"}], ",", 
    RowBox[{"b", "[", "c", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"cc", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"unitDyad", "[", 
   RowBox[{
    RowBox[{"c", "[", "a", "]"}], ",", 
    RowBox[{"c", "[", "b", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5184522741672*^9, 3.5184522741672*^9}},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[" Modeling the Beam and Rock Crate", "Subsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["System Extent, Choosing Coordinates, and Define the System", \
"Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 0.385281
MathPictureStart
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 462 178 0 0 ]
] MathScale
% Start of Graphics
%!PS-Adobe-2.0 EPSF-2.0
%%Title: 
%%Creator: AppsoftDraw
%%CreationDate: Thu Apr 10 10:35:50 1997
%%For: alan
%%DocumentFonts: (atend)
%%Pages: 0 0
%%BoundingBox: 0 0 462 178
%%NXNextStepVersion: 3.0
%%EndComments

%%BeginProcSet: /usr/lib/NextStep/printPackage.ps 3.0
%!
% NeXT Printing Package
% Version: 3.1
% Copyright: 1988, NeXT, Inc.

/__NXdef{1 index where{pop pop pop}{def}ifelse}bind def
/__NXbdef{1 index where{pop pop pop}{bind def}ifelse}bind def
/UserObjects 10 array __NXdef
/defineuserobject{
\texch dup 1 add dup UserObjects length gt{
\t\tarray dup 0 UserObjects putinterval
\t\t/UserObjects exch def
\t}{pop}ifelse UserObjects exch 3 -1 roll put
}__NXbdef
/undefineuserobject{UserObjects exch null put}__NXbdef
/execuserobject{UserObjects exch get exec}__NXbdef
/__NXRectPath{4 2 roll moveto 1 index 0 rlineto
0 exch rlineto neg 0 rlineto closepath}__NXbdef
/__NXProcessRectArgs{
\t1 index type /arraytype eq{
\t\texch 0 4 2 index length 1 sub{
\t\t\tdup 3 add 1 exch{1 index exch get exch}for
\t\t\t5 1 roll 5 index exec
\t\t}for pop pop
\t}{exec}ifelse
}__NXbdef
/rectfill{gsave newpath {__NXRectPath fill} __NXProcessRectArgs \
grestore}__NXbdef
/rectclip{newpath {__NXRectPath} __NXProcessRectArgs clip newpath}__NXbdef
/rectstroke{
\tgsave newpath dup type /arraytype eq{dup length 6 eq}{false}ifelse{
\t\t{gsave __NXRectPath null concat stroke grestore}
\t\tdup length array cvx copy dup 2 4 -1 roll put __NXProcessRectArgs
\t}{{__NXRectPath stroke} __NXProcessRectArgs}ifelse grestore
}__NXbdef
/_NXLevel2 systemdict /languagelevel known {languagelevel 2 ge}{false}ifelse \
__NXdef
/xyshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index 2 mul 1 add get add exch
\t\t3 index\t3 index 2 mul get add exch moveto pop
\t}for pop pop
}__NXbdef
/xshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\texch 3 index 3 index get add exch moveto pop
\t}for pop pop
}__NXbdef
/yshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index get add moveto pop
\t}for pop pop
}__NXbdef
/arct{arcto pop pop pop pop}__NXbdef
/setbbox{pop pop pop pop}__NXbdef
/ucache{}__NXbdef
/ucachestatus{mark 0 0 0 0 0}__NXbdef
/setucacheparams{cleartomark}__NXbdef
/uappend{systemdict begin cvx exec end}__NXbdef
/ueofill{gsave newpath uappend eofill grestore}__NXbdef
/ufill{gsave newpath uappend fill grestore}__NXbdef
/ustroke{
\tgsave newpath dup length 6 eq
\t{exch uappend concat}{uappend}ifelse
\tstroke grestore
}__NXbdef
/__NXustrokepathMatrix dup where {pop pop}{matrix def}ifelse
/ustrokepath{
\tnewpath dup length 6 eq{
\t\texch uappend __NXustrokepathMatrix currentmatrix exch concat
\t\tstrokepath setmatrix
\t}{uappend strokepath}ifelse
} __NXbdef
/upath{
\t[exch {/ucache cvx}if pathbbox /setbbox cvx
\t {/moveto cvx}{/lineto cvx}{/curveto cvx}{/closepath cvx}pathforall]cvx
} __NXbdef
/setstrokeadjust{pop}__NXbdef
/currentstrokeadjust{false}__NXbdef
/selectfont{exch findfont exch
dup type /arraytype eq {makefont}{scalefont}ifelse setfont}__NXbdef
/_NXCombineArrays{
\tcounttomark dup 2 add index dup length 3 -1 roll {
\t\t2 index length sub dup 4 1 roll 1 index exch 4 -1 roll putinterval exch
\t}repeat pop pop pop
}__NXbdef
/flushgraphics{}def
/setwindowtype{pop pop}def
/currentwindowtype{pop 0}def
/setalpha{pop}def
/currentalpha{1.0}def
/hidecursor{}def
/obscurecursor{}def
/revealcursor{}def
/setcursor{4 {pop}repeat}bind def
/showcursor{}def
/NextStepEncoding where not{
/NextStepEncoding StandardEncoding 256 array copy def
0 [129/Agrave/Aacute/Acircumflex/Atilde/Adieresis/Aring/Ccedilla/Egrave
/Eacute/Ecircumflex/Edieresis/Igrave/Iacute/Icircumflex/Idieresis
/Eth/Ntilde/Ograve/Oacute/Ocircumflex/Otilde/Odieresis/Ugrave/Uacute
/Ucircumflex/Udieresis/Yacute/Thorn/mu/multiply/divide/copyright
176/registered 181/brokenbar 190/logicalnot 192/onesuperior 201/twosuperior
204/threesuperior 209/plusminus/onequarter/onehalf/threequarters/agrave
/aacute/acircumflex/atilde/adieresis/aring/ccedilla/egrave/eacute
/ecircumflex/edieresis/igrave 226/iacute 228/icircumflex/idieresis/eth
/ntilde 236/ograve/oacute/ocircumflex/otilde/odieresis 242/ugrave/uacute
/ucircumflex 246/udieresis/yacute 252/thorn/ydieresis]
{dup type /nametype eq
 {NextStepEncoding 2 index 2 index put pop 1 add}{exch pop}ifelse
}forall pop
/NextStepEncoding NextStepEncoding readonly def
/_NXfstr 128 string dup 0 (_NX) putinterval def
/_NXfindfont /findfont load def
/findfont{
 % Because we can never let NextStepEncoding get into
 % SharedFontDirectory, we cannot reencode a font to NextStepEncoding
 % if we are in shared mode.  So if currentshared is true,
 % we call the normal findfont and return that
 /currentshared where {pop currentshared} {false} ifelse
 {_NXfindfont}
 {dup _NXfstr 3 125 getinterval cvs length 3 add _NXfstr 0 3 -1 roll
  getinterval cvn exch FontDirectory 2 index known 
  {pop FontDirectory exch get}
  {_NXfindfont dup /Encoding get StandardEncoding eq
   {\tdup length dict exch
\t{1 index /FID ne {2 index 3 1 roll put}{pop pop}ifelse}forall
\t dup /Encoding NextStepEncoding put definefont
\t}{exch pop} ifelse
   }ifelse
 }ifelse
}bind def
}{pop}ifelse
/_NXImageString {/__NXImageString where{pop}{/__NXImageString 4000 string \
__NXdef}ifelse __NXImageString}__NXbdef
/_NXDoImageOp{
\t3 dict begin /parr 5 array def 1 index{dup}{1}ifelse /chans exch def
\tchans 2 add 2 roll parr 0 chans getinterval astore pop
\t5 index 4 index mul 2 index{1 sub 8 idiv 1 add mul}{mul 1 sub 8 idiv 1 \
add}ifelse
\t4 index mul /totbytes exch def pop exch pop
\tgsave matrix invertmatrix concat 0.5 setgray 0 0 4 2 roll rectfill grestore
\t{0 1 chans 1 sub{parr exch get exec length totbytes exch sub /totbytes exch \
def}for totbytes 0 le{exit}if}loop end
}__NXbdef
/alphaimage{1 add _NXDoImageOp}def
_NXLevel2{ 
\t/NXCalibratedRGBColorSpace where{pop}{
\t\t/NXCalibratedRGBColorSpace
\t\t{mark /NXCalibratedRGB /ColorSpace findresource exch pop}stopped
\t\t{cleartomark /NXCalibratedRGB[/CIEBasedABC 2 dict dup begin 
\t\t/MatrixLMN[.4124 .2126 .0193 .3576 .7152 .1192 .1805 .0722 .9505]def
\t\t/WhitePoint[.9505 1 1.089] def end] /ColorSpace defineresource}if \
def}ifelse
\t/nxsetrgbcolor{NXCalibratedRGBColorSpace setcolorspace setcolor}__NXbdef
\t/nxsetgray{dup dup nxsetrgbcolor}__NXbdef
\t/_NXCalibratedImage{exch{array astore dup length true}{false}ifelse
\t\t8 -1 roll{NXCalibratedRGBColorSpace setcolorspace}if
\t\t8 dict dup 9 1 roll begin /ImageType 1 def /MultipleDataSources exch def
\t\tcurrentcolorspace 0 get /Indexed eq{pop /Decode[0 2 6 index exp 1 \
sub]def}
\t\t{2 mul dup array /Decode exch def 1 sub 0 1 3 -1 roll{Decode exch dup 2 \
mod put}for}ifelse
\t\t/DataSource exch def /ImageMatrix exch def 
\t\t/BitsPerComponent exch def /Height exch def /Width exch def end \
image}__NXbdef
} {
\t/setcmykcolor{
\t\t1.0 exch sub dup dup 6 -1 roll sub dup 0 lt{pop 0}if 5 1 roll
\t\t4 -1 roll sub dup 0 lt{pop 0}if 3 1 roll exch sub dup 0 lt{pop 0}if \
setrgbcolor}__NXbdef
\t/currentcmykcolor{currentrgbcolor 3{1.0 exch sub 3 1 roll}repeat 0}__NXbdef
\t/colorimage{2 copy 3 ne or{_NXDoImageOp}{4 index dup 8 ne exch 4 ne \
and{_NXDoImageOp}{
\t\tpop pop save 6 1 roll 12 dict begin/Proc exch def/Res 0 string def
\t\t/Alloc{2 index length mul 2 add dup 2 index load length gt{1.2 mul round \
cvi string def}{pop pop}ifelse}def
\t\t1 index 8 eq{/Unpack{.34 Alloc}def}{
\t\t\t/Wid 4 index 3 mul def exch pop 8 exch/Str1 0 string def/Lim Wid def
\t\t\t/Unpack{.67 Alloc/Str1 2 Alloc 0 exch Lim exch
\t\t\t\t{dup -4 bitshift 17 mul Str1 exch 4 index exch put 15 and 17 mul Str1 \
exch 3 index 1 add exch put
\t\t\t\t2 sub dup 0 le{0 lt Wid exch{exch 1 sub exch}if}if exch 2 add exch
\t\t\t\t}forall/Lim exch def Str1 exch 0 exch getinterval
\t\t\t}def
\t\t}ifelse
\t\t/Ops[{.3 mul add 1}{.59 mul add 2}{.11 mul add round cvi Res exch 2 index \
exch put 1 add 0.0 0}]def/Val 0.0 def/Phase 0 def
\t\t{0 Val Phase Proc/Res Unpack{exch Ops exch get exec}forall/Phase exch \
def/Val exch def Res exch 0 exch getinterval}
\t\timage end restore}ifelse}ifelse
\t}__NXbdef
\t/nxsetrgbcolor{setrgbcolor}__NXbdef /nxsetgray{setgray}__NXbdef
\t/setpattern{pop .5 setgray}__NXbdef
\t/_NXCalibratedImage{dup 1 eq {pop pop image}{colorimage}ifelse pop}__NXbdef
} ifelse
/_NXSetCMYKOrRGB where{pop}{
\tmark{systemdict /currentwindow get exec}stopped
\t{{pop pop pop setcmykcolor}}{{nxsetrgbcolor pop pop pop pop}}ifelse \
/_NXSetCMYKOrRGB exch def cleartomark
}ifelse
%%EndProcSet

_NXLevel2{/_NXsethsb where{pop}{/_NXsethsb /sethsbcolor load def}ifelse \
/sethsbcolor{_NXsethsb currentrgbcolor nxsetrgbcolor}def \
/setrgbcolor{nxsetrgbcolor}bind def /setgray{nxsetgray}bind def
}if
gsave
 /__NXbasematrix matrix currentmatrix def
grestore
%%EndProlog
%%BeginSetup
/TopDrawDict 250 dict def
TopDrawDict begin /prt_stack {
    (***Top of Stack\\012) print pstack (---Bottom of Stack\\012) print flush
} def /prt_top {
    (top item of stack) == dup == flush
} def /prtmat matrix def /prt_ctm {
    (current transformation matrix: ) print prtmat currentmatrix == flush
} def /tmmat matrix def /obmat matrix def /strmat matrix def /pgmat matrix \
def /idmat matrix def /sc1mt matrix def /sc2mt matrix def /sc3mt matrix def \
/sc4mt matrix def /sc5mt matrix def /sc6mt matrix def /sc7mt matrix def \
/inmat matrix def /ctmmt matrix def /octmmt matrix def /clpmt matrix def \
/weglet_mat matrix def /crlinw 1 def crlinw setlinewidth /crlinjn 0 def \
crlinjn setlinejoin /crlincp 0 def crlincp setlinecap /crmtrlmt \
currentmiterlimit def /crstrpat 0 def /crfilpat 0 def /crflat currentflat def \
/dftflat currentflat def /strinclr false def /crlingry 0 def /crlinred 0 def \
/crlingrn 0 def /crlinblu 0 def /crlinalph 1 def /filinclr false def \
/crfilgry 0 def /crfilred 0 def /crfilgrn 0 def /crfilblu 0 def /crfilalph 1 \
def /crfilstyl 0 def /txtdraw true def /txtinclr false def /txtwpat false def \
/txtwittrans false def /crtxtgry 0 def /crtxtred 0 def /crtxtgrn 0 def \
/crtxtblu 0 def /crtxtalph 1 def /crtxtpat 0 def /txlndraw true def \
/txlninclr false def /txlnwpat false def /txlnwittrans false def /crtxlngry 0 \
def /crtxlnred 0 def /crtxlngrn 0 def /crtxlnblu 0 def /crtxlnalph 1 def \
/crtxlnpat 0 def /hilittxt false def /strdsh [2 2] def /dshpatoff 0 def \
/usedash false def /filwpat false def /strwpat false def /filwittrans false \
def /strwittrans false def /crfrtarw false def /crendarw false def /rsave 0 \
def /esave 0 def /sslsave 0 def /lsave 0 def /clpsave 0 def /pathsave 0 def \
/tpatstr 10 string def /ptdist {
    sub dup mul 3 1 roll sub dup mul add sqrt
} bind def /dodrawctm {
    octmmt currentmatrix pop idmat obmat concatmatrix ctmmt currentmatrix \
sc1mt concatmatrix setmatrix
} bind def /undrawctm {
    obmat inmat invertmatrix ctmmt currentmatrix sc1mt concatmatrix setmatrix
} bind def /undrawmat {
    obmat aload pop 7 -1 roll astore
} bind def /unpagectm {
    octmmt setmatrix
} bind def /unpagemat {
    pgmat aload pop 7 -1 roll astore
} bind def /drtan {
    gsave 1 setalpha 0 setlinewidth 0.333333 setgray moveto lineto stroke \
grestore
} bind def /drdgrdln {
    gsave 1 setalpha 0 setlinewidth [1 2] 0 setdash setgray moveto lineto \
stroke grestore
} bind def /drgrdln {
    gsave 1 setalpha 0 setlinewidth setgray moveto lineto stroke grestore
} bind def end
TopDrawDict begin /rpath {
    newpath moveto dup 0 exch rlineto exch 0 rlineto 0 exch neg rlineto \
closepath
} bind def /rfpath {
    /rad3 exch def /hh3 exch def /ww3 exch def /yy1 exch def /xx1 exch def \
/xx2 xx1 ww3 add def /yy2 yy1 hh3 add def newpath xx1 yy1 rad3 hh3 0 gt {
        add
    } {
        sub
    } ifelse moveto xx1 yy1 xx2 yy1 rad3 arcto 4 {
        pop
    } repeat xx2 yy1 xx2 yy2 rad3 arcto 4 {
        pop
    } repeat xx2 yy2 xx1 yy2 rad3 arcto 4 {
        pop
    } repeat xx1 yy2 xx1 yy1 rad3 arcto 4 {
        pop
    } repeat closepath
} bind def /rfill {
    gsave dodrawctm crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse filwpat {
        4 2 roll rpath crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        rectfill pop
    } ifelse grestore
} bind def /rstroke {
    gsave dodrawctm crlinalph setalpha crlinw setlinewidth crlincp setlinecap \
crlinjn setlinejoin crmtrlmt setmiterlimit usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse 4 2 roll rpath unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /rffill {
    gsave dodrawctm crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse rfpath filwpat {
        crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /rfstroke {
    gsave dodrawctm crlinalph setalpha crlinw setlinewidth crlincp setlinecap \
crlinjn setlinejoin crmtrlmt setmiterlimit usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse rfpath unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /mkrpath {
    dodrawctm rpath unpagectm
} bind def end
TopDrawDict begin /p1x 0 def /p1y 0 def /p2x 0 def /p2y 0 def /ssl {
    gsave dodrawctm crfrtarw crendarw or {
        /p1y 1 index def /p1x 2 index def /p2y 1 index 4 index add def /p2x 2 \
index 5 index add def newpath moveto rlineto
    } {
        newpath moveto rlineto
    } ifelse crlinalph setalpha crlinw setlinewidth crlincp setlinecap \
usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse crfrtarw {
        2 copy currentlinewidth exch p2x p2y p1x p1y arow
    } if crendarw {
        2 copy currentlinewidth exch p1x p1y p2x p2y arow
    } if unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def end
TopDrawDict begin /arwlen 6 def /arw 4 def /arow {
    gsave newpath moveto lineto unpagectm concat {
        
    } {
        
    } {
        
    } {
        
    } pathforall newpath 4 2 roll 2 copy moveto 4 2 roll exch 4 -1 roll exch \
sub 3 1 roll sub exch atan rotate dup 1 lt {
        pop 1 1 scale
    } {
        dup scale
    } ifelse -1 2 rlineto 7 -2 rlineto -7 -2 rlineto closepath crlinalph \
setalpha strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse strwpat {
        crstrpat findfont exch strwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /arwpath {
    sc7mt currentmatrix pop gsave newpath moveto lineto unpagectm dup concat \
{
        
    } {
        
    } {
        
    } {
        
    } pathforall grestore unpagectm 5 -1 roll concat 4 2 roll 2 copy moveto 4 \
2 roll exch 4 -1 roll exch sub 3 1 roll sub exch atan rotate dup 1 lt {
        pop 1 1 scale
    } {
        dup scale
    } ifelse -1 2 rlineto 7 -2 rlineto -7 -2 rlineto closepath sc7mt \
setmatrix
} bind def end
TopDrawDict begin /estroke {
    gsave dodrawctm translate scale newpath dup dup 0 360 arc closepath \
crlinalph setalpha crlinw setlinewidth usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /efill {
    gsave dodrawctm translate scale newpath dup dup 0 360 arc closepath \
unpagectm crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse filwpat {
        crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /apstroke {
    gsave dodrawctm /chord exch def /pie exch def /radius exch def /yscale \
exch def /xscale exch def /yy exch def /xx exch def /angle2 exch def /angle1 \
exch def xx yy translate xscale yscale scale newpath pie {
        radius dup moveto
    } if radius dup dup angle1 angle2 arc pie chord or {
        closepath
    } if crlinalph setalpha pie not chord not and {
        crfrtarw {
            2 copy crlinw exch gsave newpath angle1 1 add cos radius mul \
radius add angle1 1 add sin radius mul radius add moveto angle1 cos radius \
mul radius add angle1 sin radius mul radius add lineto unpagectm {
                
            } {
                
            } {
                
            } {
                
            } pathforall arow grestore
        } if crendarw {
            2 copy crlinw exch gsave newpath angle2 1 sub cos radius mul \
radius add angle2 1 sub sin radius mul radius add moveto angle2 cos radius \
mul radius add angle2 sin radius mul radius add lineto unpagectm {
                
            } {
                
            } {
                
            } {
                
            } pathforall arow grestore
        } if
    } if crlincp setlinecap crlinalph setalpha crlinw setlinewidth usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /apfill {
    gsave dodrawctm /chord exch def /pie exch def /radius exch def /yscale \
exch def /xscale exch def /yy exch def /xx exch def xx yy translate xscale \
yscale scale newpath pie {
        radius dup moveto
    } if radius dup dup 5 -2 roll arc pie chord or {
        closepath
    } if 1 xscale div 1 yscale div scale crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse filwpat {
        crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /mkepath {
    dodrawctm /chord exch def /pie exch def /radius exch def /yscale exch def \
/xscale exch def /yy exch def /xx exch def /angle2 exch def /angle1 exch def \
/closed exch def xx yy translate xscale yscale scale newpath pie {
        radius dup moveto
    } if radius dup dup angle1 angle2 arc closed pie or chord or {
        closepath
    } if unpagectm
} bind def end
TopDrawDict begin /dotx {
    gsave txtdraw {
        concat selectfont txtinclr {
            crtxtred crtxtgrn crtxtblu setrgbcolor
        } {
            crtxtgry setgray
        } ifelse crtxtalph setalpha moveto xyshow
    } {
        pop pop pop pop pop pop pop
    } ifelse grestore
} bind def /txtlin {
    gsave txlndraw {
        concat txlninclr {
            crtxlnred crtxlngrn crtxlnblu setrgbcolor
        } {
            crtxlngry setgray
        } ifelse crtxlnalph setalpha setlinewidth 0 setlinecap newpath moveto \
0 rlineto stroke
    } {
        pop pop pop pop pop
    } ifelse grestore
} bind def end
%%EndSetup
0 0 462 178 rectclip
-144 -85.235443 translate
144 85.235443 461.71759 177.496185 rectclip
gsave
TopDrawDict begin
/invpats true def
/crlincp 0 def
/crlinjn 0 def
/crmtrlmt 10 def
/crlinw 0 def
/crlinalph 1 def
/crlinred 0 def /crlingrn 0 def /crlinblu 0 def /strinclr true def
/crfilalph 1 def
/crfilred 0 def /crfilgrn 0 def /crfilblu 0 def /filinclr true def
/filwpat false def
TopDrawDict /piddict known TopDrawDict /ipiddict known or {
    1 getpat /crfilpat exch def
} if
/filwittrans false def
/strwpat false def
TopDrawDict /piddict known TopDrawDict /ipiddict known or {
    1 getpat /crstrpat exch def
} if
/strwittrans false def
/usedash false def
/strdsh [2 2] def /dshpatoff 0 def
/crendarw false def
/crfrtarw false def
/txtdraw false def
/crtxtalph 1 def
/crtxtred 0 def /crtxtgrn 0 def /crtxtblu 0 def /txtinclr true def
/txtwpat false def
/txtwittrans false def
/txlndraw false def
/crtxlnalph 1 def
/crtxlnred 0 def /crtxlngrn 0 def /crtxlnblu 0 def /txlninclr true def
/txlnwpat false def
/txlnwittrans false def
/crlinw 1 def
0.446069 -0.539465 0.539465 0.446069 -117.616791 429.256836 sc4mt astore \
0.446069 -0.539465 0.539465 0.446069 -117.616791 429.256836 sc5mt astore 179 \
579 227 -17 8.5 0.446069 -0.539465 0.539465 0.446069 -213.316788 85.356827 \
sc6mt astore rfstroke
/esave save def 0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 \
115.873192 126.595428 sc6mt astore 2.118194 180 154 610 1 -1.351852 27 false \
false 0.7 0 0 0.7 115.373199 -228.504547 sc5mt astore apstroke esave restore
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore 109 0 125 574 0.7 0 0 0.7 115.373199 -228.504547 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore -9 -17 166 592 0.7 0 0 0.7 115.373199 -228.504547 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore -9 -17 175 591 0.7 0 0 0.7 115.373199 -228.504547 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore -9 -17 184 591 0.7 0 0 0.7 115.373199 -228.504547 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore -9 -17 194 591 0.7 0 0 0.7 115.373199 -228.504547 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore -9 -17 203 591 0.7 0 0 0.7 115.373199 -228.504547 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore -9 -17 212 593 0.7 0 0 0.7 115.373199 -228.504547 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.475929 0 0 0.47593 188.545044 -37.571251 sc5mt astore efill
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 0.475929 0 0 0.47593 \
188.545044 -37.571251 sc5mt astore estroke
/crendarw true def
/crfrtarw true def
/esave save def 0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 \
115.873192 126.595428 sc6mt astore 308.8797 338.968628 227 236 1.067485 1 \
81.5 false false 0.407236 0 0 0.542578 116.939148 0.096664 sc5mt astore \
apstroke esave restore
/crfrtarw false def
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore -0.7 0 0 0.7 603.216064 \
126.595428 sc5mt astore -51.354561 61.397736 122.204041 498.999969 0.7 0 0 \
0.7 111.173203 -133.304535 sc6mt astore ssl
-3.05979e-08 0.7 -0.7 -3.05979e-08 610.801208 117.523438 sc4mt astore \
-3.05979e-08 0.7 -0.7 -3.05979e-08 610.801208 117.523438 sc5mt astore \
90.346512 75.123932 234.040024 373.039948 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore 121.015747 0 191 556 0.7 0 0 0.7 115.373199 \
-228.504547 sc6mt astore ssl
-3.05979e-08 0.7 -0.7 -3.05979e-08 680.857178 314.587433 sc4mt astore \
-3.05979e-08 0.7 -0.7 -3.05979e-08 680.857178 314.587433 sc5mt astore \
121.015747 0 209 538 -3.05979e-08 0.7 -0.7 -3.05979e-08 620.857178 17.587433 \
sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(b) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
-11.32679 48.695435] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.7 \
0 0 0.7 -11.32679 48.695435] dotx
/txtdraw true def
/txlndraw true def
(b) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
182.573196 -21.304558] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.7 \
0 0 0.7 182.573196 -21.304558] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.7 0 0 0.7 56.573212 148.095428] dotx
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.7 0 0 0.7 251.173187 77.395432] dotx
/txtdraw true def
/txlndraw true def
(i ) [3.891998 0 0 0] 169 258 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 \
0 0 0.7 225.973206 -24.80455] dotx
(j ) [3.891998 0 0 0] 122 278 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 \
0 0 0.7 167.173203 48.695435] dotx
(^ ) [7.980003 0 0 0] 75 309 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 \
0 0.7 200.073196 30.495453] dotx
(^ ) [7.980003 0 0 0] 75 309 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 \
0 0.7 291.773193 -57.004547] dotx
/crendarw false def
0.446069 -0.539465 0.539465 0.446069 -117.616791 429.256836 sc4mt astore \
0.446069 -0.539465 0.539465 0.446069 -117.616791 429.256836 sc5mt astore 179 \
579 227 -17 8.5 0.446069 -0.539465 0.539465 0.446069 -3.316795 77.65683 sc6mt \
astore rfstroke
/crendarw true def
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore -0.944946 -103.000244 286 225 0.7 0 0 0.7 233.673187 \
91.395432 sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore 76.016205 -0.926849 139 306 0.7 0 0 0.7 297.373199 \
-62.604561 sc6mt astore ssl
-3.05979e-08 0.7 -0.7 -3.05979e-08 680.857178 314.587433 sc4mt astore \
-3.05979e-08 0.7 -0.7 -3.05979e-08 680.857178 314.587433 sc5mt astore 0.11058 \
70.575714 227 225 0.7 0 0 0.7 296.673187 -61.204559 sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(mg ) [12.996002 0 9 0 0 0] 302 113 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] \
[0.7 0 0 0.7 225.973206 118.695435] dotx
(Rx ) [10.998001 0 7.992004 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 342.173187 -38.804558] dotx
(Ry ) [10.998001 0 7.992004 0 0 0] 201 225 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 316.973206 -24.804558] dotx
(o ) [9 0 0 0] 175 665 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] [0.7 0 0 0.7 \
110.473198 -302.004547] dotx
/crendarw false def
0.7 0 0 0.7 115.873192 126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.7 0 0 0.7 144.073196 -108.804558 sc5mt astore efill
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 0.7 0 0 0.7 144.073196 \
-108.804558 sc5mt astore estroke
(cm ) [7.992004 0 12.996002 0 0 0] 174 462 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 81.773193 -139.604553] dotx
/txtdraw true def
/txlndraw true def
(q) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
116.773201 -56.304558] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.7 \
0 0 0.7 116.773201 -56.304558] dotx
/txtdraw true def
/txlndraw true def
(q) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
137.773209 -15.004555] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.7 \
0 0 0.7 137.773209 -15.004555] dotx
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 206 343 47 -23 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore rstroke
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore -22 -28 229 371 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 23 -27 230 370 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(c) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
36.273247 -113.004562] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 235.216003 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.7 0 0 0.7 36.273247 -113.004562] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.7 0 0 0.7 104.173248 -13.604568] dotx
/txtdraw true def
/txlndraw true def
(c) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
99.973206 -0.304558] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 235.216003 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.7 0 0 0.7 99.973206 -0.304558] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.7 0 0 0.7 168.573196 98.395432] dotx
/crendarw true def
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore -0.7 0 0 0.7 603.216064 \
126.595428 sc5mt astore -86.204391 -0.934906 227.204041 331.999969 0.7 0 0 \
0.7 111.173203 -133.304535 sc6mt astore ssl
/crendarw false def
0.7 0 0 0.7 115.873192 126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.7 0 0 0.7 190.273193 -192.104553 sc5mt astore efill
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 0.7 0 0 0.7 190.273193 \
-192.104553 sc5mt astore estroke
/txtdraw true def
/txlndraw true def
(cm ) [7.992004 0 12.996002 0 0 0] 174 462 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 152.473206 -236.204559] dotx
/crendarw true def
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore -0.7 0 0 0.7 603.216064 \
126.595428 sc5mt astore 1.720078 136.000519 228.204041 335.999969 0.7 0 0 0.7 \
111.173203 -133.304535 sc6mt astore ssl
/crfrtarw true def
/esave save def 0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 \
115.873199 126.595459 sc6mt astore 50.162003 93.944878 406 302 1 1.083333 54 \
false false 1.164947 0 0 0.983265 -255.11145 -227.492462 sc5mt astore \
apstroke esave restore
/crendarw false def
/crfrtarw false def
0.7 0 0 0.7 115.873192 126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.475929 0 0 0.47593 215.14505 -72.571251 sc5mt astore efill
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc6mt astore 5.147812 1.000001 -1 111 421 0.475929 0 0 0.47593 \
215.14505 -72.571251 sc5mt astore estroke
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore -44 -34 185 416 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore -32 -25 226 368 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore -29 -21 160 449 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore -47 -37 95 534 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
/crendarw true def
/crfrtarw true def
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 32.31778 -38.781311 172.84111 398.390656 0.7 0 0 0.7 \
111.173203 -133.304535 sc6mt astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 18.288666 -21.805725 145.855667 430.402863 0.7 0 0 \
0.7 111.173203 -133.304535 sc6mt astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 86.325836 -103.774658 60.837086 499.387329 0.7 0 0 \
0.7 111.173203 -133.304535 sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(l) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
5.473206 -20.604561] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 232.891998 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.7 0 0 0.7 5.473206 -20.604561] dotx
/txtdraw true def
/txlndraw true def
(d) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
48.173203 -46.504555] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.7 \
0 0 0.7 48.173203 -46.504555] dotx
/txtdraw true def
/txlndraw true def
(l) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
74.073204 -74.504562] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 232.891998 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.7 0 0 0.7 74.073204 -74.504562] dotx
/txtdraw true def
/txlndraw true def
(d) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.7 0 0 0.7 \
149.673203 -91.304558] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.7 \
0 0 0.7 149.673203 -91.304558] dotx
/crendarw false def
/crfrtarw false def
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 54 0 235 370 0.7 0 0 0.7 111.173203 -133.304535 sc6mt \
astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 53 1 237 332 0.7 0 0 0.7 111.173203 -133.304535 sc6mt \
astore ssl
/crendarw true def
/crfrtarw true def
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 0 -25 277 364 0.7 0 0 0.7 111.173203 -133.304535 \
sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(Px ) [10.998001 0 7.992004 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 404.473206 -71.004562] dotx
(Py ) [10.998001 0 7.992004 0 0 0] 201 225 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 343.573181 -14.304558] dotx
/crfrtarw false def
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore -0.7 0 0 0.7 814.484497 \
126.595428 sc5mt astore 76.016205 -0.926849 139 306 -0.7 0 0 0.7 636.884521 \
-95.504562 sc6mt astore ssl
-3.05979e-08 0.7 -0.7 -3.05979e-08 680.857178 314.587433 sc4mt astore \
-9.17939e-08 -0.7 -0.7 9.17939e-08 680.857178 423.406464 sc5mt astore 0.11058 \
70.575714 227 225 0.7 -6.11959e-08 -6.11959e-08 -0.7 321.873199 331.898499 \
sc6mt astore ssl
/crendarw false def
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 651 479 47 -23 0.7 0 0 0.7 114.673203 -164.804535 \
sc6mt astore rstroke
( ) [0 0] 653.5 462.105988 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] [0.7 0 0 0.7 \
114.673203 -164.804535] dotx
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore -22 -28 674 507 0.7 0 0 0.7 114.673203 -164.804535 \
sc6mt astore ssl
0.7 0 0 0.7 115.873199 126.595459 sc4mt astore 0.7 0 0 0.7 115.873199 \
126.595459 sc5mt astore 23 -27 675 506 0.7 0 0 0.7 114.673203 -164.804535 \
sc6mt astore ssl
(Px ) [10.998001 0 7.992004 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 467.473206 -1.704559] dotx
(Py ) [10.998001 0 7.992004 0 0 0] 201 225 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.7 0 0 0.7 430.373169 52.195435] dotx
/crendarw true def
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 299.273193 \
126.595428 sc5mt astore 76.016205 -0.926849 139 306 0.7 0 0 0.7 431.073181 \
-24.104553 sc6mt astore ssl
-3.05979e-08 0.7 -0.7 -3.05979e-08 680.857178 314.587433 sc4mt astore \
-3.05979e-08 0.7 -0.7 -3.05979e-08 680.857178 535.787476 sc5mt astore 0.11058 \
70.575714 227 225 0.7 0 0 0.7 427.573181 30.495468 sc6mt astore ssl
0.7 0 0 0.7 115.873192 126.595428 sc4mt astore 0.7 0 0 0.7 115.873192 \
126.595428 sc5mt astore 0 -57.999969 673 467.999969 0.7 0 0 0.7 114.673203 \
-164.804535 sc6mt astore ssl
(mg ) [12.996002 0 9 0 0 0] 302 113 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] \
[0.7 0 0 0.7 379.273193 50.795441] dotx
end
grestore
%%Trailer
%%DocumentFonts: Times-BoldItalic
%%+ Times-Italic
%%BoundingBox: 0.000000 0.000000 461.717590 177.496185

%End of Graphics
MathPictureEnd
\
\>"], "Graphics",
 Evaluatable->False,
 AspectRatioFixed->True,
 ImageSize->{462, 178},
 ImageMargins->{{0, Inherited}, {Inherited, Inherited}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],
 ImageRangeCache->{{{0, 461}, {177, 0}} -> {0, 1, 1, 1}}],

Cell["\<\
Let's write the equations of motion for this system and solve the equations 
and animate the results.  This is a single degree of freedom system with the 
coordinate and freebody diagram as shown.  We will use angular momentum to 
derive the equations of motion.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
Define fixed relationships between the frames of reference.   Note: these are \
different for different base orientations of the
 frames. \
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "Dot", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "3", "]"}]}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "3", "]"}]}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "3", "]"}]}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Protect", "[", "Dot", "]"}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "Cross", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"b", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"b", "[", "1", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"n", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"n", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"n", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"n", "[", "1", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"c", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"c", "[", "1", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"n", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"n", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"n", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"n", "[", "1", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"c", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"c", "[", "1", "]"}]}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"b", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"b", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "Cross", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5184522770220003`*^9, 3.5184522770220003`*^9}},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
FMR\[Dash]Angular Momentum and Linear Momentum\
\>", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
The force vector on the rocker arm B and Rock Crate C are given by:\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Fb", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "mb"}], " ", "g", " ", "j"}], " ", "+", " ", 
   RowBox[{"Rx", " ", "i"}], " ", "+", " ", 
   RowBox[{"Ry", " ", "j"}], " ", "-", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Px", " ", 
      RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
     RowBox[{"Py", " ", 
      RowBox[{"c", "[", "2", "]"}]}]}], ")"}]}]}], "\n", 
 RowBox[{"Fc", " ", "=", " ", 
  RowBox[{
   RowBox[{"Px", " ", 
    RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
   RowBox[{"Py", " ", 
    RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
   RowBox[{"mc", " ", "g", " ", "j"}]}]}]}], "Input",
 CellChangeTimes->{{3.518452280142*^9, 3.5184522801576*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "Px"}], " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "1"]}], "-", 
  RowBox[{"Py", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "2"]}], "+", 
  RowBox[{"Rx", " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "-", 
  RowBox[{"g", " ", "mb", " ", 
   OverscriptBox["\<\"j\"\>", "^"]}], "+", 
  RowBox[{"Ry", " ", 
   OverscriptBox["\<\"j\"\>", "^"]}]}]], "Output",
 CellChangeTimes->{3.5184523405608*^9, 3.5184529893264*^9, 
  3.536264930721746*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Px", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "1"]}], "+", 
  RowBox[{"Py", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "2"]}], "-", 
  RowBox[{"g", " ", "mc", " ", 
   OverscriptBox["\<\"j\"\>", "^"]}]}]], "Output",
 CellChangeTimes->{3.5184523405608*^9, 3.5184529893264*^9, 
  3.536264930724407*^9}]
}, Open  ]],

Cell["\<\
The moments about the CG for both A and C are, including viscous friction at \
the pins. \
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Mb", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "dB"}], " ", 
     RowBox[{
      RowBox[{"q1", "'"}], "[", "t", "]"}], " ", 
     RowBox[{"b", "[", "3", "]"}]}], " ", "+", " ", 
    RowBox[{"dC", " ", 
     RowBox[{
      RowBox[{"q2", "'"}], "[", "t", "]"}], " ", 
     RowBox[{"c", "[", "3", "]"}]}], " ", "-", " ", 
    RowBox[{"d1", " ", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], " ", "\[Cross]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Rx", " ", "i"}], " ", "+", " ", 
        RowBox[{"Ry", " ", "j"}]}], ")"}]}]}], " ", "-", " ", "\n", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"d1", " ", "+", " ", "l1"}], ")"}], " ", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], " ", "\[Cross]", " ", 
      RowBox[{"-", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Px", " ", 
          RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
         RowBox[{"Py", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}]}]}]}]}], "//", 
   "distributeScalars"}]}], "\n", 
 RowBox[{"Mc", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "dC"}], " ", 
    RowBox[{
     RowBox[{"q2", "'"}], "[", "t", "]"}], " ", 
    RowBox[{"c", "[", "3", "]"}]}], " ", "+", " ", 
   RowBox[{"d2", " ", 
    RowBox[{
     RowBox[{"c", "[", "2", "]"}], " ", "\[Cross]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Px", " ", 
        RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{"Py", " ", 
        RowBox[{"c", "[", "2", "]"}]}]}], ")"}]}]}]}]}]}], "Input",
 CellChangeTimes->{{3.518452281234*^9, 3.5184522812496*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"d1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"l1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"d1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "+", 
  RowBox[{"l1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"d1", " ", "Rx", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
  RowBox[{"d1", " ", "Ry", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"dB", " ", 
   SubscriptBox[
    OverscriptBox["b", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"dC", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523415436*^9, 3.5184529920252*^9, 
  3.536264930758955*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d2"}], " ", "Px", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"]}], "-", 
  RowBox[{"dC", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523415436*^9, 3.5184529920252*^9, 
  3.536264930763225*^9}]
}, Open  ]],

Cell["\<\
The full inertia Dyadics about the CG for each body are given by:\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ibo", " ", "=", " ", 
   RowBox[{
    RowBox[{"B11", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"1", ",", "1"}], "]"}]}], " ", "+", " ", 
    RowBox[{"B12", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"1", ",", "2"}], "]"}]}], " ", "+", " ", 
    RowBox[{"B13", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"1", ",", "3"}], "]"}]}], " ", "+", "\n", "\t ", 
    RowBox[{"B21", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"2", ",", "1"}], "]"}]}], " ", "+", " ", 
    RowBox[{"B22", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"2", ",", "2"}], "]"}]}], " ", "+", " ", 
    RowBox[{"B23", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"2", ",", "3"}], "]"}]}], " ", "+", "  ", "\n", "\t ", 
    RowBox[{"B31", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"3", ",", "1"}], "]"}]}], " ", "+", " ", 
    RowBox[{"B32", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"3", ",", "2"}], "]"}]}], " ", "+", " ", 
    RowBox[{"B33", " ", 
     RowBox[{"bb", "[", 
      RowBox[{"3", ",", "3"}], "]"}]}]}]}], "\n", "\t "}], "\n", 
 RowBox[{"Ico", " ", "=", " ", 
  RowBox[{
   RowBox[{"C11", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"1", ",", "1"}], "]"}]}], " ", "+", " ", 
   RowBox[{"C12", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"1", ",", "2"}], "]"}]}], " ", "+", " ", 
   RowBox[{"C13", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"1", ",", "3"}], "]"}]}], " ", "+", "\n", "\t ", 
   RowBox[{"C21", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"2", ",", "1"}], "]"}]}], " ", "+", " ", 
   RowBox[{"C22", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"2", ",", "2"}], "]"}]}], " ", "+", " ", 
   RowBox[{"C23", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"2", ",", "3"}], "]"}]}], " ", "+", "  ", "\n", "\t ", 
   RowBox[{"C31", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"3", ",", "1"}], "]"}]}], " ", "+", " ", 
   RowBox[{"C32", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"3", ",", "2"}], "]"}]}], " ", "+", " ", 
   RowBox[{"C33", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"3", ",", "3"}], "]"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.518452284198*^9, 3.518452284198*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"B11", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B12", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B13", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B21", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B22", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B23", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B31", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B32", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B33", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3]],
     Editable->False], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184523430724*^9, 3.5184529934136*^9, 
  3.536264930812274*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"C11", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 1], 
      $CellContext`unitVector[C, $CellContext`c, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C12", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 1], 
      $CellContext`unitVector[C, $CellContext`c, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C13", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 1], 
      $CellContext`unitVector[C, $CellContext`c, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C21", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 2], 
      $CellContext`unitVector[C, $CellContext`c, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C22", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 2], 
      $CellContext`unitVector[C, $CellContext`c, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C23", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 2], 
      $CellContext`unitVector[C, $CellContext`c, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C31", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 3], 
      $CellContext`unitVector[C, $CellContext`c, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C32", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 3], 
      $CellContext`unitVector[C, $CellContext`c, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C33", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 3], 
      $CellContext`unitVector[C, $CellContext`c, 3]],
     Editable->False], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184523430724*^9, 3.5184529934136*^9, 
  3.536264930815535*^9}]
}, Open  ]],

Cell["Making the I's constants.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "B11", ",", "B12", ",", "B13", ",", "B21", ",", "B22", ",", "B23", ",", 
     "B31", ",", "B32", ",", "B33", ",", "\n", "C11", ",", "C12", ",", "C13", 
     ",", "C21", ",", "C22", ",", "C23", ",", "C31", ",", "C32", ",", "C33", 
     ",", "d1", ",", "d2", ",", "l1"}], "}"}], ",", "\n", "Constant"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5184522868032*^9, 3.5184522868032*^9}},
 AspectRatioFixed->True],

Cell["The angular velocities of frame B and C are:", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"NwB", " ", "=", " ", 
  RowBox[{
   RowBox[{"omega", "[", 
    RowBox[{"N", ",", "B"}], "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"q1", "'"}], "[", "t", "]"}], " ", 
    RowBox[{"b", "[", "3", "]"}]}]}]}], "\n", 
 RowBox[{"NwC", " ", "=", " ", 
  RowBox[{
   RowBox[{"omega", "[", 
    RowBox[{"N", ",", "C"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"q1", "'"}], "[", "t", "]"}], " ", "+", " ", 
      RowBox[{
       RowBox[{"q2", "'"}], "[", "t", "]"}]}], ")"}], " ", 
    RowBox[{"c", "[", "3", "]"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.5184522879264*^9, 3.5184522879264*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["b", "^"], "3"], " ", 
  RowBox[{
   SuperscriptBox["q1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184523454904003`*^9, 3.5184529963308*^9, 
  3.536264930889533*^9}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["c", "^"], "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "+", 
    RowBox[{
     SuperscriptBox["q2", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184523454904003`*^9, 3.5184529963308*^9, 
  3.536264930891419*^9}]
}, Open  ]],

Cell["The angular momentum is given by Ho = Io . NwB (C).", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Hbo", "=", 
  RowBox[{"Ibo", " ", ".", " ", "NwB"}]}], "\n", 
 RowBox[{"Hco", "=", 
  RowBox[{"Ico", " ", ".", " ", "NwC"}]}]}], "Input",
 CellChangeTimes->{{3.5184522899700003`*^9, 3.5184522899700003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"B13", " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "1"]}], "+", 
    RowBox[{"B23", " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "2"]}], "+", 
    RowBox[{"B33", " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "3"]}]}], ")"}], " ", 
  RowBox[{
   SuperscriptBox["q1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184523468632*^9, 3.5184529979063997`*^9, 
  3.536264930925067*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"C13", " ", 
     SubscriptBox[
      OverscriptBox["c", "^"], "1"]}], "+", 
    RowBox[{"C23", " ", 
     SubscriptBox[
      OverscriptBox["c", "^"], "2"]}], "+", 
    RowBox[{"C33", " ", 
     SubscriptBox[
      OverscriptBox["c", "^"], "3"]}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "+", 
    RowBox[{
     SuperscriptBox["q2", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184523468632*^9, 3.5184529979063997`*^9, 
  3.5362649309268713`*^9}]
}, Open  ]],

Cell["\<\
The equation of motion can be derived from Mo - DvDt[N,Ho]==0 and F- ma==0 \
for each body; we will drop the == 0 until we get to the solution.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Mb", " ", "-", " ", 
      RowBox[{"DvDt", "[", 
       RowBox[{"N", ",", "Hbo"}], "]"}]}], ")"}], ".", 
    RowBox[{"b", "[", "3", "]"}]}], "//", "distributeScalars"}]}]], "Input",
 CellChangeTimes->{{3.5184522924348*^9, 3.5184522924348*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"d1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"l1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"d1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "+", 
  RowBox[{"l1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"d1", " ", "Rx", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
  RowBox[{"d1", " ", "Ry", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"dB", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"B33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523475964003`*^9, 3.5184529991856003`*^9, 
  3.5362649309580927`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Mc", " ", "-", " ", 
      RowBox[{"DvDt", "[", 
       RowBox[{"N", ",", "Hco"}], "]"}]}], ")"}], ".", 
    RowBox[{"c", "[", "3", "]"}]}], "//", "distributeScalars"}]}]], "Input",
 CellChangeTimes->{{3.5184522935424*^9, 3.5184522935424*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d2"}], " ", "Px"}], "-", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523483452*^9, 3.5184530005896*^9, 
  3.536264931138579*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq3", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fb", " ", "-", " ", 
      RowBox[{"mb", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{"d1", " ", 
            RowBox[{"b", "[", "1", "]"}]}]}], "]"}]}], "]"}]}]}], ")"}], ".", 
    "i"}], "//", "distributeScalars"}]}]], "Input",
 CellChangeTimes->{{3.5184522947748003`*^9, 3.5184522947748003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"Rx", "-", 
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "1"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "+", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523530875998`*^9, 3.5184530016816*^9, 
  3.536264931173408*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq4", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fb", " ", "-", " ", 
      RowBox[{"mb", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{"d1", " ", 
            RowBox[{"b", "[", "1", "]"}]}]}], "]"}]}], "]"}]}]}], ")"}], ".", 
    "j"}], "//", "distributeScalars"}]}]], "Input",
 CellChangeTimes->{{3.5184522956015997`*^9, 3.5184522956015997`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mb"}], "+", "Ry", "-", 
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "1"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523538208*^9, 3.5184530039904003`*^9, 
  3.53626493120833*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq5", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fc", " ", "-", " ", 
      RowBox[{"mc", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "l1"}], " ", 
             RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
            RowBox[{"d2", " ", 
             RowBox[{"c", "[", "2", "]"}]}]}]}], "]"}]}], "]"}]}]}], ")"}], 
    ".", 
    RowBox[{"b", "[", "1", "]"}]}], "//", "distributeScalars"}]}]], "Input",
 CellChangeTimes->{{3.5184522961788*^9, 3.5184522961944*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"g", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"l1", " ", "mc", " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "+", 
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523546008*^9, 3.5184530046924*^9, 
  3.5362649312419786`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq6", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fc", " ", "-", " ", 
      RowBox[{"mc", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "l1"}], " ", 
             RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
            RowBox[{"d2", " ", 
             RowBox[{"c", "[", "2", "]"}]}]}]}], "]"}]}], "]"}]}]}], ")"}], 
    ".", 
    RowBox[{"b", "[", "2", "]"}]}], "//", "distributeScalars"}]}]], "Input",
 CellChangeTimes->{{3.5184522971616*^9, 3.5184522971772003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"g", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "+", 
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], "+", 
  RowBox[{"l1", " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184523552872*^9, 3.518453006034*^9, 
  3.536264931296501*^9}]
}, Open  ]],

Cell["\<\
Now solve for the reaction forces at the pins and eliminate them for the two \
angular momentum equation (eq1,eq2). The results are the raw equations of \
motion\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solR", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eq3", "==", "0"}], ",", 
       RowBox[{"eq4", "==", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Rx", ",", "Ry"}], "}"}]}], "]"}], "//", "First"}]}]], "Input",
 CellChangeTimes->{{3.5184522988932*^9, 3.5184522988932*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Rx", "\[Rule]", 
    RowBox[{
     RowBox[{"Px", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "1"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}]}], "+", 
     RowBox[{"Py", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "2"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
   RowBox[{"Ry", "\[Rule]", 
    RowBox[{
     RowBox[{"g", " ", "mb"}], "+", 
     RowBox[{"Px", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "1"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
     RowBox[{"Py", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "2"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.518452356972*^9, {3.5184529597019997`*^9, 3.5184529613868*^9}, 
   3.5184530073132*^9, 3.5362649313253403`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solP", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eq5", "==", "0"}], ",", 
       RowBox[{"eq6", "==", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Px", ",", "Py"}], "}"}]}], "]"}], "//", "First"}]}]], "Input",
 CellChangeTimes->{{3.5184522997980003`*^9, 3.5184522998136*^9}, {
  3.51845236719*^9, 3.5184523748184*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Px", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"g", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         OverscriptBox["\<\"j\"\>", "^"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}], "-", 
       RowBox[{"g", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
       RowBox[{"l1", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
       RowBox[{"l1", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SuperscriptBox["q1", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "-", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SuperscriptBox["q1", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "+", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SuperscriptBox["q1", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "-", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SuperscriptBox["q2", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "+", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SuperscriptBox["q2", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]}], 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], "-", 
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}]}]]}]}], ",", 
   RowBox[{"Py", "\[Rule]", 
    RowBox[{"-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "-", 
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}]}]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g"}], " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          OverscriptBox["\<\"j\"\>", "^"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "+", 
        RowBox[{"g", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
        RowBox[{"l1", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"2", " ", "d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], " ", 
         RowBox[{
          SuperscriptBox["q2", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "+", 
        RowBox[{"2", " ", "d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], " ", 
         RowBox[{
          SuperscriptBox["q2", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "-", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"l1", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5184523576272*^9, 3.518452376082*^9}, 
   3.5184529624164*^9, 3.5184530093724003`*^9, 3.536264931363826*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom1", "=", 
  RowBox[{
   RowBox[{"eq1", "/.", "solR"}], "/.", "solP"}]}]], "Input",
 CellChangeTimes->{{3.5184523018728*^9, 3.5184523018728*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "dB"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"B33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}]}], "-", 
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}]}]}]], 
   RowBox[{"d1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "2"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g"}], " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}]}], "+", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}]}], "-", 
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}]}]}]], 
   RowBox[{"l1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "2"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g"}], " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}]}], "+", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "-", 
  FractionBox[
   RowBox[{"d1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "1"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}]}], "-", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}]}], "-", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}]}]}]], "-", 
  FractionBox[
   RowBox[{"l1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "1"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}]}], "-", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}]}], "-", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}]}]}]], "-", 
  RowBox[{"d1", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "d1"}], " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "-", 
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}]}]}]], 
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "2"], ".", 
        OverscriptBox["\<\"i\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g"}], " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}]}], "+", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "1"], ".", 
        OverscriptBox["\<\"i\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}]}], "-", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], "-", 
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}]}]]}], ")"}]}], "-", 
  RowBox[{"d1", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g", " ", "mb"}], "-", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "-", 
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}]}]}]], 
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g"}], " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}]}], "+", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}]}], "-", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], "-", 
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5184523604976*^9, 3.5184523798416*^9}, 
   3.5184525327216*^9, 3.5184525643584003`*^9, {3.518452698012*^9, 
   3.5184527173248*^9}, 3.518452783344*^9, 3.5184529149924*^9, 
   3.5184529647096*^9, 3.5184530151443996`*^9, 3.536264931416362*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom2", "=", 
  RowBox[{
   RowBox[{"eq2", "/.", "solR"}], "/.", "solP"}]}]], "Input",
 CellChangeTimes->{{3.5184523029024*^9, 3.5184523029024*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "dC"}], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  FractionBox[
   RowBox[{"d2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}]}], "-", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}]}], "-", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}]}]}]]}]], "Output",
 CellChangeTimes->{
  3.518452381698*^9, 3.518452534734*^9, {3.5184529531968*^9, 
   3.5184529664412003`*^9}, 3.5184530178744*^9, 3.536264931460204*^9}]
}, Open  ]],

Cell["\<\
The last thing we need to do is transform the unresolved Dot product and \
simplify the results.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"transform", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "//.", "\n", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"c", "[", "1", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", "\n", " ", 
     RowBox[{
      RowBox[{"c", "[", "2", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", "\n", " ", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Cos", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}]}], " ", "i"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "j"}]}]}], ",", " ", "\n",
      " ", 
     RowBox[{
      RowBox[{"b", "[", "2", "]"}], "->", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "j"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "i"}]}]}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.5184523043375998`*^9, 3.5184523043375998`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom1", "=", 
  RowBox[{
   RowBox[{"eom1", "//", "transform"}], "//", "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.518452304946*^9, 3.518452304946*^9}, {
  3.5184524956716003`*^9, 3.5184525896148*^9}, {3.5184526843775997`*^9, 
  3.5184527144700003`*^9}, {3.5184527587584*^9, 3.5184529303115997`*^9}, {
  3.518452973898*^9, 3.5184529761132*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d1"}], " ", "g", " ", "mb", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
  RowBox[{"g", " ", "l1", " ", "mc", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q2", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{"dB", "-", 
     RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
  RowBox[{"B33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["d1", "2"], " ", "mb", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["l1", "2"], " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{
  3.5184528593004*^9, {3.5184529067712*^9, 3.518452930998*^9}, 
   3.518452969374*^9, 3.5184530236619997`*^9, 3.5362649317760878`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom2", "=", 
  RowBox[{
   RowBox[{"eom2", "//", "transform"}], "//", "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.5184523058664*^9, 3.5184523058664*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d2"}], " ", "g", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{
     RowBox[{"q1", "[", "t", "]"}], "+", 
     RowBox[{"q2", "[", "t", "]"}]}], "]"}]}], "-", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["d2", "2"], " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["d2", "2"], " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184524821464*^9, 3.5184530270472*^9, 
  3.536264931975239*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solve and Interpret", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["Define the constants.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"l1", "=", "5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l2", "=", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"d1", "=", "2.5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mb", "=", "100"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"B33", "=", 
    RowBox[{"mb", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"l1", " ", "+", " ", "l2"}], ")"}], "^", "2"}], "/", 
      "12"}]}]}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"Slender", " ", "Rod"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"dB", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"d2", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mc", "=", "400"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"boxH", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"boxL", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"C33", "=", 
    RowBox[{"mc", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"boxL", "^", "2"}], " ", "+", " ", 
        RowBox[{"boxH", "^", "2"}]}], ")"}], "/", "12"}]}]}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"Box", " ", "full", " ", "of", " ", "Rocks"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"dC", "=", ".4"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"g", "=", "9.81"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5184523079412003`*^9, 3.5184523079412003`*^9}},
 AspectRatioFixed->True],

Cell["Initial conditions and final time.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"W1o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Q1o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"W2o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Q2o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"tf", "=", "10"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5184523095480003`*^9, 3.5184523095480003`*^9}, {
  3.5184532049256*^9, 3.5184532056744003`*^9}, {3.5184532406496*^9, 
  3.5184532411331997`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"eom1", "==", "0"}], ",", 
      RowBox[{"eom2", "==", "0"}], ",", "\n", 
      RowBox[{
       RowBox[{
        RowBox[{"q1", "'"}], "[", "0", "]"}], "==", "W1o"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"q2", "'"}], "[", "0", "]"}], "==", "W2o"}], ",", 
      RowBox[{
       RowBox[{"q1", "[", "0", "]"}], "==", "Q1o"}], ",", 
      RowBox[{
       RowBox[{"q2", "[", "0", "]"}], "==", "Q2o"}]}], "}"}], ",", "\n", 
    RowBox[{"{", 
     RowBox[{"q1", ",", "q2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "tf"}], "}"}], ",", 
    RowBox[{"MaxSteps", "->", "5000"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.518452310796*^9, 3.518452310796*^9}, 
   3.518452404552*^9, {3.5184524445816*^9, 3.5184524650176*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"q1", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}], ",", 
    RowBox[{"q2", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.5184523902468*^9, 3.518452405488*^9}, {
   3.5184524453772*^9, 3.518452460634*^9}, 3.5184530343168*^9, 
   3.518453212398*^9, 3.5184532428024*^9, 3.536264932082383*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"q1", "[", "t", "]"}], "/.", "sol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"q2", "[", "t", "]"}], "/.", "sol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5184523120439997`*^9, 3.5184523120596*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3k8lG8Xxq1jl3XsM8wkhZRSUXJOSkmKFFqESISEfkURhaiQpbKnlFba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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {0., 3.0180269667946034`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184523961280003`*^9, 3.5184530381387997`*^9, 
  3.5184532131624002`*^9, 3.5362649321510468`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUmXk4lF8bx5kZ24x9ZyxTQknKEio5p0URFYpKEhKyq5QoEaVI5EdU9qWQ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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-3.8008268062723918`, 0.16022082041266705`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184523961280003`*^9, 3.5184530381387997`*^9, 
  3.5184532131624002`*^9, 3.536264932157838*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Animation", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
For this animation we will draw two circles center at each end of the bar and \

two lines tangent to the circles to repesent the bar and animate according \
the
 time solution above.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{"tg", "=."}], "\n", 
 RowBox[{
  RowBox[{"thick", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"l1", " ", "+", " ", "l2"}], ")"}], "/", "10"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5184523152888002`*^9, 3.5184523153044*^9}, 
   3.5184530472492*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"circle", " ", "centers"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xc0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{"l2", " ", 
         RowBox[{
          RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}], "//.", "sol"}], "//",
       "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yc0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{"l2", " ", 
         RowBox[{
          RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}], "//.", "sol"}], "//",
       "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xc1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"-", "l1"}], " ", 
         RowBox[{
          RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}], "//.", "sol"}], "//",
       "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yc1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"-", "l1"}], " ", 
         RowBox[{
          RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}], "//.", "sol"}], "//",
       "First"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5184523152888002`*^9, 3.5184523153044*^9}, {
  3.5184530472492*^9, 3.5184530783556004`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"lower", " ", "line", " ", "points"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xl0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"l2", " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yl0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"l2", " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xl1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yl1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5184523152888002`*^9, 3.5184523153044*^9}, {
  3.5184530472492*^9, 3.5184530857812*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"upper", " ", "line", " ", "points"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xu0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"l2", " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yu0", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"l2", " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xu1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yu1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"1", "/", "2"}], " ", "thick", " ", 
            RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.5184523152888002`*^9, 3.5184523153044*^9}, {
  3.5184530472492*^9, 3.5184530560944*^9}, {3.5184530906796*^9, 
  3.5184530938152*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Coordinates", " ", "for", " ", "connecting", " ", "members", " ", "and", 
    " ", "Box"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"xblo", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"-", "l1"}], " ", 
         RowBox[{
          RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}], "//.", "sol"}], "//",
       "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yblo", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"-", "l1"}], " ", 
         RowBox[{
          RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}], "//.", "sol"}], "//",
       "First"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb1", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb2", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb2", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb3", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb3", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "-", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"xb4", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"yb4", "[", "t_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"transform", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "l1"}], " ", 
            RowBox[{"b", "[", "1", "]"}]}], " ", "-", 
           RowBox[{"d2", " ", 
            RowBox[{"c", "[", "2", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxL", "/", "2"}], " ", 
            RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
           RowBox[{
            RowBox[{"boxH", "/", "2"}], " ", 
            RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.",
        "sol"}], "//", "First"}]}], ";"}], "\n"}]}]], "Input",
 CellChangeTimes->{{3.5184523152888002`*^9, 3.5184523153044*^9}, {
  3.5184530472492*^9, 3.518453062428*^9}, {3.5184530962332*^9, 
  3.5184531019428*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Animate", "[", " ", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"Graphics", "[", "\n", "        ", 
      RowBox[{"(*", " ", 
       RowBox[{"draw", " ", "the", " ", "rocker", " ", "arm"}], " ", "*)"}], 
      "\n", "       ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Circle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"xc0", "[", "t", "]"}], ",", 
            RowBox[{"yc0", "[", "t", "]"}]}], "}"}], ",", 
          RowBox[{"thick", "/", "2"}]}], "]"}], ",", " ", "\n", "\t\t", 
        RowBox[{"Circle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"xc1", "[", "t", "]"}], ",", 
            RowBox[{"yc1", "[", "t", "]"}]}], "}"}], ",", 
          RowBox[{"thick", "/", "2"}]}], "]"}], ",", "  ", "\n", "\t\t", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xl0", "[", "t", "]"}], ",", 
             RowBox[{"yl0", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
           "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xl1", "[", "t", "]"}], ",", 
             RowBox[{"yl1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        " ", "\n", "\t\t", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xu0", "[", "t", "]"}], ",", 
             RowBox[{"yu0", "[", "t", "]"}]}], "}"}], ",", "\n", "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xu1", "[", "t", "]"}], ",", 
             RowBox[{"yu1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        "\n", "\t    ", 
        RowBox[{"(*", " ", 
         RowBox[{"draw", " ", "the", " ", "box", " ", "support"}], " ", 
         "*)"}], "\n", "\t\t", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xblo", "[", "t", "]"}], ",", 
             RowBox[{"yblo", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
           "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb1", "[", "t", "]"}], ",", 
             RowBox[{"yb1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        " ", "\n", "\t\t", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xblo", "[", "t", "]"}], ",", 
             RowBox[{"yblo", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
           "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb4", "[", "t", "]"}], ",", 
             RowBox[{"yb4", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        "\n", "\t\t", 
        RowBox[{"(*", " ", 
         RowBox[{"draw", " ", "the", " ", "box"}], " ", "*)"}], "\n", "\t\t", 
        
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb1", "[", "t", "]"}], ",", 
             RowBox[{"yb1", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
           "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb2", "[", "t", "]"}], ",", 
             RowBox[{"yb2", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        " ", "\n", "\t\t", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb2", "[", "t", "]"}], ",", 
             RowBox[{"yb2", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
           "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb3", "[", "t", "]"}], ",", 
             RowBox[{"yb3", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        " ", "\n", "\t\t", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb3", "[", "t", "]"}], ",", 
             RowBox[{"yb3", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
           "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb4", "[", "t", "]"}], ",", 
             RowBox[{"yb4", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        " ", "\n", " \t\t", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb4", "[", "t", "]"}], ",", 
             RowBox[{"yb4", "[", "t", "]"}]}], "}"}], ",", "  ", "\n", 
           "\t\t\t  ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb1", "[", "t", "]"}], ",", 
             RowBox[{"yb1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}]}], " ", 
       "\n", "\t   ", "}"}], "\n", "\t ", "]"}], ",", "\n", "    ", 
     RowBox[{"Axes", "->", "True"}], ",", 
     RowBox[{"PlotRange", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], "-", "l2"}], ",", 
          RowBox[{"l1", "+", "l2"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], "-", "l2"}], ",", 
          RowBox[{"l1", "+", "l2"}]}], "}"}]}], "}"}]}], ",", "\n", "    ", 
     RowBox[{"AspectRatio", "->", "1"}]}], "]"}], "\n", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5184523152888002`*^9, 3.5184523153044*^9}, {
  3.5184530472492*^9, 3.5184530606963997`*^9}, {3.5184531060612*^9, 
  3.5184531229091997`*^9}, {3.5184531544212*^9, 3.5184531774052*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`t$$ = 3.9241600036621094`, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`t$$], 0, 10}}, Typeset`size$$ = {360., {177., 181.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`t$422$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`t$$ = 0}, 
      "ControllerVariables" :> {
        Hold[$CellContext`t$$, $CellContext`t$422$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Show[
        Graphics[{
          Circle[{
            $CellContext`xc0[$CellContext`t$$], 
            $CellContext`yc0[$CellContext`t$$]}, $CellContext`thick/2], 
          Circle[{
            $CellContext`xc1[$CellContext`t$$], 
            $CellContext`yc1[$CellContext`t$$]}, $CellContext`thick/2], 
          Line[{{
             $CellContext`xl0[$CellContext`t$$], 
             $CellContext`yl0[$CellContext`t$$]}, {
             $CellContext`xl1[$CellContext`t$$], 
             $CellContext`yl1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xu0[$CellContext`t$$], 
             $CellContext`yu0[$CellContext`t$$]}, {
             $CellContext`xu1[$CellContext`t$$], 
             $CellContext`yu1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xblo[$CellContext`t$$], 
             $CellContext`yblo[$CellContext`t$$]}, {
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xblo[$CellContext`t$$], 
             $CellContext`yblo[$CellContext`t$$]}, {
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}, {
             $CellContext`xb2[$CellContext`t$$], 
             $CellContext`yb2[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb2[$CellContext`t$$], 
             $CellContext`yb2[$CellContext`t$$]}, {
             $CellContext`xb3[$CellContext`t$$], 
             $CellContext`yb3[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb3[$CellContext`t$$], 
             $CellContext`yb3[$CellContext`t$$]}, {
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}, {
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}}]}], Axes -> True, 
        PlotRange -> {{-$CellContext`l1 - $CellContext`l2, $CellContext`l1 + \
$CellContext`l2}, {-$CellContext`l1 - $CellContext`l2, $CellContext`l1 + \
$CellContext`l2}}, AspectRatio -> 1], 
      "Specifications" :> {{$CellContext`t$$, 0, 10, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}}, 
      "Options" :> {
       ControlType -> Animator, AppearanceElements -> None, DefaultBaseStyle -> 
        "Animate", DefaultLabelStyle -> "AnimateLabel", SynchronousUpdating -> 
        True, ShrinkingDelay -> 10.}, "DefaultOptions" :> {}],
     ImageSizeCache->{403., {213., 218.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Animate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.5184531831168003`*^9, {3.5184532186535997`*^9, 3.5184532463904*^9}, 
   3.536264932326112*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"NeXTAutomaticEncoding",
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 76, 2, 67, "Section",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[680, 28, 115, 2, 34, "Subsection",
 Evaluatable->False],
Cell[798, 32, 205, 5, 41, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1028, 41, 300, 8, 27, "Input"],
Cell[1331, 51, 187, 3, 20, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1567, 60, 123, 2, 34, "Subsection",
 Evaluatable->False],
Cell[1693, 64, 258, 7, 56, "Text",
 Evaluatable->False],
Cell[1954, 73, 923, 28, 88, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2914, 106, 101, 2, 34, "Subsection",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[3040, 112, 131, 3, 24, "Subsubsection",
 Evaluatable->False],
Cell[3174, 117, 41302, 1013, 186, 36569, 932, "GraphicsData", "PostScript", \
"Graphics",
 Evaluatable->False],
Cell[44479, 1132, 332, 7, 71, "Text",
 Evaluatable->False],
Cell[44814, 1141, 208, 6, 41, "Text",
 Evaluatable->False],
Cell[45025, 1149, 4830, 155, 598, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49892, 1309, 125, 4, 24, "Subsubsection",
 Evaluatable->False],
Cell[50020, 1315, 137, 4, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[50182, 1323, 735, 21, 43, "Input"],
Cell[50920, 1346, 506, 16, 31, "Output"],
Cell[51429, 1364, 355, 11, 31, "Output"]
}, Open  ]],
Cell[51799, 1378, 159, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[51983, 1387, 1655, 50, 58, "Input"],
Cell[53641, 1439, 1507, 49, 31, "Output"],
Cell[55151, 1490, 412, 13, 29, "Output"]
}, Open  ]],
Cell[55578, 1506, 135, 4, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[55738, 1514, 2131, 61, 118, "Input"],
Cell[57872, 1577, 3787, 111, 34, "Output"],
Cell[61662, 1690, 3553, 111, 33, "Output"]
}, Open  ]],
Cell[65230, 1804, 87, 2, 26, "Text",
 Evaluatable->False],
Cell[65320, 1808, 499, 11, 58, "Input"],
Cell[65822, 1821, 106, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[65953, 1827, 690, 22, 43, "Input"],
Cell[66646, 1851, 275, 8, 31, "Output"],
Cell[66924, 1861, 424, 13, 29, "Output"]
}, Open  ]],
Cell[67363, 1877, 113, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[67501, 1883, 257, 6, 43, "Input"],
Cell[67761, 1891, 523, 17, 34, "Output"],
Cell[68287, 1910, 674, 22, 33, "Output"]
}, Open  ]],
Cell[68976, 1935, 213, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[69214, 1944, 359, 10, 27, "Input"],
Cell[69576, 1956, 1495, 49, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71108, 2010, 359, 10, 27, "Input"],
Cell[71470, 2022, 568, 17, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72075, 2044, 510, 15, 27, "Input"],
Cell[72588, 2061, 958, 30, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73583, 2096, 510, 15, 27, "Input"],
Cell[74096, 2113, 1010, 32, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75143, 2150, 678, 20, 27, "Input"],
Cell[75824, 2172, 1769, 58, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77630, 2235, 682, 20, 27, "Input"],
Cell[78315, 2257, 1746, 57, 31, "Output"]
}, Open  ]],
Cell[80076, 2317, 231, 6, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[80332, 2327, 395, 12, 27, "Input"],
Cell[80730, 2341, 2136, 64, 34, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82903, 2410, 442, 13, 27, "Input"],
Cell[83348, 2425, 9830, 290, 126, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93215, 2720, 196, 5, 27, "Input"],
Cell[93414, 2727, 41468, 1240, 493, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134919, 3972, 196, 5, 27, "Input"],
Cell[135118, 3979, 4484, 139, 74, "Output"]
}, Open  ]],
Cell[139617, 4121, 166, 5, 26, "Text",
 Evaluatable->False],
Cell[139786, 4128, 1723, 51, 88, "Input"],
Cell[CellGroupData[{
Cell[141534, 4183, 396, 8, 27, "Input"],
Cell[141933, 4193, 2414, 67, 49, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144384, 4265, 206, 5, 27, "Input"],
Cell[144593, 4272, 1528, 44, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[146170, 4322, 90, 2, 24, "Subsubsection",
 Evaluatable->False],
Cell[146263, 4326, 83, 2, 26, "Text",
 Evaluatable->False],
Cell[146349, 4330, 1322, 46, 208, "Input"],
Cell[147674, 4378, 96, 2, 26, "Text",
 Evaluatable->False],
Cell[147773, 4382, 476, 14, 88, "Input"],
Cell[CellGroupData[{
Cell[148274, 4400, 899, 25, 58, "Input"],
Cell[149176, 4427, 836, 26, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[150049, 4458, 473, 14, 43, "Input"],
Cell[150525, 4474, 20674, 345, 242, "Output"],
Cell[171202, 4821, 25408, 422, 234, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[196659, 5249, 80, 2, 24, "Subsubsection",
 Evaluatable->False],
Cell[196742, 5253, 253, 8, 56, "Text",
 Evaluatable->False],
Cell[196998, 5263, 309, 10, 43, "Input"],
Cell[197310, 5275, 1492, 49, 88, "Input"],
Cell[198805, 5326, 2277, 69, 88, "Input"],
Cell[201085, 5397, 2322, 70, 88, "Input"],
Cell[203410, 5469, 6779, 200, 253, "Input"],
Cell[CellGroupData[{
Cell[210214, 5673, 5695, 154, 418, "Input"],
Cell[215912, 5829, 4183, 89, 448, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
