(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    408334,      10229]
NotebookOptionsPosition[    400325,       9962]
NotebookOutlinePosition[    400941,       9986]
CellTagsIndexPosition[    400898,       9983]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Trebuchet 2", "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Input the definitions for the vector operations", "Subsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
Input the vector definition with the command that follows.  The path will 
depend on where  the definitions reside on the local system.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Get", "[", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<vectors3.m\>\""}], 
   "]"}], "]"}]], "Input",
 CellChangeTimes->{3.5184534883192*^9, 3.5362649738459473`*^9},
 AspectRatioFixed->True],

Cell[BoxData["\<\"These Engineering Vector algorithms are copyright Alan A. \
Barhorst\"\>"], "Print",
 CellChangeTimes->{3.5184534900196*^9, 3.5184536764863997`*^9, 
  3.536264978877132*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[" Modeling the Trebuchet", "Subsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["System Extent, Choosing Coordinates, and Define the System", \
"Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 0.395669
MathPictureStart
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 508 201 0 0 ]
] MathScale
% Start of Graphics
%!PS-Adobe-2.0 EPSF-2.0
%%Title: 
%%Creator: AppsoftDraw
%%CreationDate: Mon Apr 21 15:10:25 1997
%%For: alan
%%DocumentFonts: (atend)
%%Pages: 0 0
%%BoundingBox: 0 0 508 201
%%NXNextStepVersion: 3.0
%%EndComments

%%BeginProcSet: /usr/lib/NextStep/printPackage.ps 3.0
%!
% NeXT Printing Package
% Version: 3.1
% Copyright: 1988, NeXT, Inc.

/__NXdef{1 index where{pop pop pop}{def}ifelse}bind def
/__NXbdef{1 index where{pop pop pop}{bind def}ifelse}bind def
/UserObjects 10 array __NXdef
/defineuserobject{
\texch dup 1 add dup UserObjects length gt{
\t\tarray dup 0 UserObjects putinterval
\t\t/UserObjects exch def
\t}{pop}ifelse UserObjects exch 3 -1 roll put
}__NXbdef
/undefineuserobject{UserObjects exch null put}__NXbdef
/execuserobject{UserObjects exch get exec}__NXbdef
/__NXRectPath{4 2 roll moveto 1 index 0 rlineto
0 exch rlineto neg 0 rlineto closepath}__NXbdef
/__NXProcessRectArgs{
\t1 index type /arraytype eq{
\t\texch 0 4 2 index length 1 sub{
\t\t\tdup 3 add 1 exch{1 index exch get exch}for
\t\t\t5 1 roll 5 index exec
\t\t}for pop pop
\t}{exec}ifelse
}__NXbdef
/rectfill{gsave newpath {__NXRectPath fill} __NXProcessRectArgs \
grestore}__NXbdef
/rectclip{newpath {__NXRectPath} __NXProcessRectArgs clip newpath}__NXbdef
/rectstroke{
\tgsave newpath dup type /arraytype eq{dup length 6 eq}{false}ifelse{
\t\t{gsave __NXRectPath null concat stroke grestore}
\t\tdup length array cvx copy dup 2 4 -1 roll put __NXProcessRectArgs
\t}{{__NXRectPath stroke} __NXProcessRectArgs}ifelse grestore
}__NXbdef
/_NXLevel2 systemdict /languagelevel known {languagelevel 2 ge}{false}ifelse \
__NXdef
/xyshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index 2 mul 1 add get add exch
\t\t3 index\t3 index 2 mul get add exch moveto pop
\t}for pop pop
}__NXbdef
/xshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\texch 3 index 3 index get add exch moveto pop
\t}for pop pop
}__NXbdef
/yshow{
\t0 1 3 index length 1 sub{
\t\tcurrentpoint 4 index 3 index 1 getinterval show
\t\t3 index 3 index get add moveto pop
\t}for pop pop
}__NXbdef
/arct{arcto pop pop pop pop}__NXbdef
/setbbox{pop pop pop pop}__NXbdef
/ucache{}__NXbdef
/ucachestatus{mark 0 0 0 0 0}__NXbdef
/setucacheparams{cleartomark}__NXbdef
/uappend{systemdict begin cvx exec end}__NXbdef
/ueofill{gsave newpath uappend eofill grestore}__NXbdef
/ufill{gsave newpath uappend fill grestore}__NXbdef
/ustroke{
\tgsave newpath dup length 6 eq
\t{exch uappend concat}{uappend}ifelse
\tstroke grestore
}__NXbdef
/__NXustrokepathMatrix dup where {pop pop}{matrix def}ifelse
/ustrokepath{
\tnewpath dup length 6 eq{
\t\texch uappend __NXustrokepathMatrix currentmatrix exch concat
\t\tstrokepath setmatrix
\t}{uappend strokepath}ifelse
} __NXbdef
/upath{
\t[exch {/ucache cvx}if pathbbox /setbbox cvx
\t {/moveto cvx}{/lineto cvx}{/curveto cvx}{/closepath cvx}pathforall]cvx
} __NXbdef
/setstrokeadjust{pop}__NXbdef
/currentstrokeadjust{false}__NXbdef
/selectfont{exch findfont exch
dup type /arraytype eq {makefont}{scalefont}ifelse setfont}__NXbdef
/_NXCombineArrays{
\tcounttomark dup 2 add index dup length 3 -1 roll {
\t\t2 index length sub dup 4 1 roll 1 index exch 4 -1 roll putinterval exch
\t}repeat pop pop pop
}__NXbdef
/flushgraphics{}def
/setwindowtype{pop pop}def
/currentwindowtype{pop 0}def
/setalpha{pop}def
/currentalpha{1.0}def
/hidecursor{}def
/obscurecursor{}def
/revealcursor{}def
/setcursor{4 {pop}repeat}bind def
/showcursor{}def
/NextStepEncoding where not{
/NextStepEncoding StandardEncoding 256 array copy def
0 [129/Agrave/Aacute/Acircumflex/Atilde/Adieresis/Aring/Ccedilla/Egrave
/Eacute/Ecircumflex/Edieresis/Igrave/Iacute/Icircumflex/Idieresis
/Eth/Ntilde/Ograve/Oacute/Ocircumflex/Otilde/Odieresis/Ugrave/Uacute
/Ucircumflex/Udieresis/Yacute/Thorn/mu/multiply/divide/copyright
176/registered 181/brokenbar 190/logicalnot 192/onesuperior 201/twosuperior
204/threesuperior 209/plusminus/onequarter/onehalf/threequarters/agrave
/aacute/acircumflex/atilde/adieresis/aring/ccedilla/egrave/eacute
/ecircumflex/edieresis/igrave 226/iacute 228/icircumflex/idieresis/eth
/ntilde 236/ograve/oacute/ocircumflex/otilde/odieresis 242/ugrave/uacute
/ucircumflex 246/udieresis/yacute 252/thorn/ydieresis]
{dup type /nametype eq
 {NextStepEncoding 2 index 2 index put pop 1 add}{exch pop}ifelse
}forall pop
/NextStepEncoding NextStepEncoding readonly def
/_NXfstr 128 string dup 0 (_NX) putinterval def
/_NXfindfont /findfont load def
/findfont{
 % Because we can never let NextStepEncoding get into
 % SharedFontDirectory, we cannot reencode a font to NextStepEncoding
 % if we are in shared mode.  So if currentshared is true,
 % we call the normal findfont and return that
 /currentshared where {pop currentshared} {false} ifelse
 {_NXfindfont}
 {dup _NXfstr 3 125 getinterval cvs length 3 add _NXfstr 0 3 -1 roll
  getinterval cvn exch FontDirectory 2 index known 
  {pop FontDirectory exch get}
  {_NXfindfont dup /Encoding get StandardEncoding eq
   {\tdup length dict exch
\t{1 index /FID ne {2 index 3 1 roll put}{pop pop}ifelse}forall
\t dup /Encoding NextStepEncoding put definefont
\t}{exch pop} ifelse
   }ifelse
 }ifelse
}bind def
}{pop}ifelse
/_NXImageString {/__NXImageString where{pop}{/__NXImageString 4000 string \
__NXdef}ifelse __NXImageString}__NXbdef
/_NXDoImageOp{
\t3 dict begin /parr 5 array def 1 index{dup}{1}ifelse /chans exch def
\tchans 2 add 2 roll parr 0 chans getinterval astore pop
\t5 index 4 index mul 2 index{1 sub 8 idiv 1 add mul}{mul 1 sub 8 idiv 1 \
add}ifelse
\t4 index mul /totbytes exch def pop exch pop
\tgsave matrix invertmatrix concat 0.5 setgray 0 0 4 2 roll rectfill grestore
\t{0 1 chans 1 sub{parr exch get exec length totbytes exch sub /totbytes exch \
def}for totbytes 0 le{exit}if}loop end
}__NXbdef
/alphaimage{1 add _NXDoImageOp}def
_NXLevel2{ 
\t/NXCalibratedRGBColorSpace where{pop}{
\t\t/NXCalibratedRGBColorSpace
\t\t{mark /NXCalibratedRGB /ColorSpace findresource exch pop}stopped
\t\t{cleartomark /NXCalibratedRGB[/CIEBasedABC 2 dict dup begin 
\t\t/MatrixLMN[.4124 .2126 .0193 .3576 .7152 .1192 .1805 .0722 .9505]def
\t\t/WhitePoint[.9505 1 1.089] def end] /ColorSpace defineresource}if \
def}ifelse
\t/nxsetrgbcolor{NXCalibratedRGBColorSpace setcolorspace setcolor}__NXbdef
\t/nxsetgray{dup dup nxsetrgbcolor}__NXbdef
\t/_NXCalibratedImage{exch{array astore dup length true}{false}ifelse
\t\t8 -1 roll{NXCalibratedRGBColorSpace setcolorspace}if
\t\t8 dict dup 9 1 roll begin /ImageType 1 def /MultipleDataSources exch def
\t\tcurrentcolorspace 0 get /Indexed eq{pop /Decode[0 2 6 index exp 1 \
sub]def}
\t\t{2 mul dup array /Decode exch def 1 sub 0 1 3 -1 roll{Decode exch dup 2 \
mod put}for}ifelse
\t\t/DataSource exch def /ImageMatrix exch def 
\t\t/BitsPerComponent exch def /Height exch def /Width exch def end \
image}__NXbdef
} {
\t/setcmykcolor{
\t\t1.0 exch sub dup dup 6 -1 roll sub dup 0 lt{pop 0}if 5 1 roll
\t\t4 -1 roll sub dup 0 lt{pop 0}if 3 1 roll exch sub dup 0 lt{pop 0}if \
setrgbcolor}__NXbdef
\t/currentcmykcolor{currentrgbcolor 3{1.0 exch sub 3 1 roll}repeat 0}__NXbdef
\t/colorimage{2 copy 3 ne or{_NXDoImageOp}{4 index dup 8 ne exch 4 ne \
and{_NXDoImageOp}{
\t\tpop pop save 6 1 roll 12 dict begin/Proc exch def/Res 0 string def
\t\t/Alloc{2 index length mul 2 add dup 2 index load length gt{1.2 mul round \
cvi string def}{pop pop}ifelse}def
\t\t1 index 8 eq{/Unpack{.34 Alloc}def}{
\t\t\t/Wid 4 index 3 mul def exch pop 8 exch/Str1 0 string def/Lim Wid def
\t\t\t/Unpack{.67 Alloc/Str1 2 Alloc 0 exch Lim exch
\t\t\t\t{dup -4 bitshift 17 mul Str1 exch 4 index exch put 15 and 17 mul Str1 \
exch 3 index 1 add exch put
\t\t\t\t2 sub dup 0 le{0 lt Wid exch{exch 1 sub exch}if}if exch 2 add exch
\t\t\t\t}forall/Lim exch def Str1 exch 0 exch getinterval
\t\t\t}def
\t\t}ifelse
\t\t/Ops[{.3 mul add 1}{.59 mul add 2}{.11 mul add round cvi Res exch 2 index \
exch put 1 add 0.0 0}]def/Val 0.0 def/Phase 0 def
\t\t{0 Val Phase Proc/Res Unpack{exch Ops exch get exec}forall/Phase exch \
def/Val exch def Res exch 0 exch getinterval}
\t\timage end restore}ifelse}ifelse
\t}__NXbdef
\t/nxsetrgbcolor{setrgbcolor}__NXbdef /nxsetgray{setgray}__NXbdef
\t/setpattern{pop .5 setgray}__NXbdef
\t/_NXCalibratedImage{dup 1 eq {pop pop image}{colorimage}ifelse pop}__NXbdef
} ifelse
/_NXSetCMYKOrRGB where{pop}{
\tmark{systemdict /currentwindow get exec}stopped
\t{{pop pop pop setcmykcolor}}{{nxsetrgbcolor pop pop pop pop}}ifelse \
/_NXSetCMYKOrRGB exch def cleartomark
}ifelse
%%EndProcSet

_NXLevel2{/_NXsethsb where{pop}{/_NXsethsb /sethsbcolor load def}ifelse \
/sethsbcolor{_NXsethsb currentrgbcolor nxsetrgbcolor}def \
/setrgbcolor{nxsetrgbcolor}bind def /setgray{nxsetgray}bind def
}if
gsave
 /__NXbasematrix matrix currentmatrix def
grestore
%%EndProlog
%%BeginSetup
/TopDrawDict 250 dict def
TopDrawDict begin /prt_stack {
    (***Top of Stack\\012) print pstack (---Bottom of Stack\\012) print flush
} def /prt_top {
    (top item of stack) == dup == flush
} def /prtmat matrix def /prt_ctm {
    (current transformation matrix: ) print prtmat currentmatrix == flush
} def /tmmat matrix def /obmat matrix def /strmat matrix def /pgmat matrix \
def /idmat matrix def /sc1mt matrix def /sc2mt matrix def /sc3mt matrix def \
/sc4mt matrix def /sc5mt matrix def /sc6mt matrix def /sc7mt matrix def \
/inmat matrix def /ctmmt matrix def /octmmt matrix def /clpmt matrix def \
/weglet_mat matrix def /crlinw 1 def crlinw setlinewidth /crlinjn 0 def \
crlinjn setlinejoin /crlincp 0 def crlincp setlinecap /crmtrlmt \
currentmiterlimit def /crstrpat 0 def /crfilpat 0 def /crflat currentflat def \
/dftflat currentflat def /strinclr false def /crlingry 0 def /crlinred 0 def \
/crlingrn 0 def /crlinblu 0 def /crlinalph 1 def /filinclr false def \
/crfilgry 0 def /crfilred 0 def /crfilgrn 0 def /crfilblu 0 def /crfilalph 1 \
def /crfilstyl 0 def /txtdraw true def /txtinclr false def /txtwpat false def \
/txtwittrans false def /crtxtgry 0 def /crtxtred 0 def /crtxtgrn 0 def \
/crtxtblu 0 def /crtxtalph 1 def /crtxtpat 0 def /txlndraw true def \
/txlninclr false def /txlnwpat false def /txlnwittrans false def /crtxlngry 0 \
def /crtxlnred 0 def /crtxlngrn 0 def /crtxlnblu 0 def /crtxlnalph 1 def \
/crtxlnpat 0 def /hilittxt false def /strdsh [2 2] def /dshpatoff 0 def \
/usedash false def /filwpat false def /strwpat false def /filwittrans false \
def /strwittrans false def /crfrtarw false def /crendarw false def /rsave 0 \
def /esave 0 def /sslsave 0 def /lsave 0 def /clpsave 0 def /pathsave 0 def \
/tpatstr 10 string def /ptdist {
    sub dup mul 3 1 roll sub dup mul add sqrt
} bind def /dodrawctm {
    octmmt currentmatrix pop idmat obmat concatmatrix ctmmt currentmatrix \
sc1mt concatmatrix setmatrix
} bind def /undrawctm {
    obmat inmat invertmatrix ctmmt currentmatrix sc1mt concatmatrix setmatrix
} bind def /undrawmat {
    obmat aload pop 7 -1 roll astore
} bind def /unpagectm {
    octmmt setmatrix
} bind def /unpagemat {
    pgmat aload pop 7 -1 roll astore
} bind def /drtan {
    gsave 1 setalpha 0 setlinewidth 0.333333 setgray moveto lineto stroke \
grestore
} bind def /drdgrdln {
    gsave 1 setalpha 0 setlinewidth [1 2] 0 setdash setgray moveto lineto \
stroke grestore
} bind def /drgrdln {
    gsave 1 setalpha 0 setlinewidth setgray moveto lineto stroke grestore
} bind def end
TopDrawDict begin /rpath {
    newpath moveto dup 0 exch rlineto exch 0 rlineto 0 exch neg rlineto \
closepath
} bind def /rfpath {
    /rad3 exch def /hh3 exch def /ww3 exch def /yy1 exch def /xx1 exch def \
/xx2 xx1 ww3 add def /yy2 yy1 hh3 add def newpath xx1 yy1 rad3 hh3 0 gt {
        add
    } {
        sub
    } ifelse moveto xx1 yy1 xx2 yy1 rad3 arcto 4 {
        pop
    } repeat xx2 yy1 xx2 yy2 rad3 arcto 4 {
        pop
    } repeat xx2 yy2 xx1 yy2 rad3 arcto 4 {
        pop
    } repeat xx1 yy2 xx1 yy1 rad3 arcto 4 {
        pop
    } repeat closepath
} bind def /rfill {
    gsave dodrawctm crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse filwpat {
        4 2 roll rpath crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        rectfill pop
    } ifelse grestore
} bind def /rstroke {
    gsave dodrawctm crlinalph setalpha crlinw setlinewidth crlincp setlinecap \
crlinjn setlinejoin crmtrlmt setmiterlimit usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse 4 2 roll rpath unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /rffill {
    gsave dodrawctm crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse rfpath filwpat {
        crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /rfstroke {
    gsave dodrawctm crlinalph setalpha crlinw setlinewidth crlincp setlinecap \
crlinjn setlinejoin crmtrlmt setmiterlimit usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse rfpath unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /mkrpath {
    dodrawctm rpath unpagectm
} bind def end
TopDrawDict begin /p1x 0 def /p1y 0 def /p2x 0 def /p2y 0 def /ssl {
    gsave dodrawctm crfrtarw crendarw or {
        /p1y 1 index def /p1x 2 index def /p2y 1 index 4 index add def /p2x 2 \
index 5 index add def newpath moveto rlineto
    } {
        newpath moveto rlineto
    } ifelse crlinalph setalpha crlinw setlinewidth crlincp setlinecap \
usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse crfrtarw {
        2 copy currentlinewidth exch p2x p2y p1x p1y arow
    } if crendarw {
        2 copy currentlinewidth exch p1x p1y p2x p2y arow
    } if unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def end
TopDrawDict begin /arwlen 6 def /arw 4 def /arow {
    gsave newpath moveto lineto unpagectm concat {
        
    } {
        
    } {
        
    } {
        
    } pathforall newpath 4 2 roll 2 copy moveto 4 2 roll exch 4 -1 roll exch \
sub 3 1 roll sub exch atan rotate dup 1 lt {
        pop 1 1 scale
    } {
        dup scale
    } ifelse -1 2 rlineto 7 -2 rlineto -7 -2 rlineto closepath crlinalph \
setalpha strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse strwpat {
        crstrpat findfont exch strwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /arwpath {
    sc7mt currentmatrix pop gsave newpath moveto lineto unpagectm dup concat \
{
        
    } {
        
    } {
        
    } {
        
    } pathforall grestore unpagectm 5 -1 roll concat 4 2 roll 2 copy moveto 4 \
2 roll exch 4 -1 roll exch sub 3 1 roll sub exch atan rotate dup 1 lt {
        pop 1 1 scale
    } {
        dup scale
    } ifelse -1 2 rlineto 7 -2 rlineto -7 -2 rlineto closepath sc7mt \
setmatrix
} bind def end
TopDrawDict begin /estroke {
    gsave dodrawctm translate scale newpath dup dup 0 360 arc closepath \
crlinalph setalpha crlinw setlinewidth usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /efill {
    gsave dodrawctm translate scale newpath dup dup 0 360 arc closepath \
unpagectm crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse filwpat {
        crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /apstroke {
    gsave dodrawctm /chord exch def /pie exch def /radius exch def /yscale \
exch def /xscale exch def /yy exch def /xx exch def /angle2 exch def /angle1 \
exch def xx yy translate xscale yscale scale newpath pie {
        radius dup moveto
    } if radius dup dup angle1 angle2 arc pie chord or {
        closepath
    } if crlinalph setalpha pie not chord not and {
        crfrtarw {
            2 copy crlinw exch gsave newpath angle1 1 add cos radius mul \
radius add angle1 1 add sin radius mul radius add moveto angle1 cos radius \
mul radius add angle1 sin radius mul radius add lineto unpagectm {
                
            } {
                
            } {
                
            } {
                
            } pathforall arow grestore
        } if crendarw {
            2 copy crlinw exch gsave newpath angle2 1 sub cos radius mul \
radius add angle2 1 sub sin radius mul radius add moveto angle2 cos radius \
mul radius add angle2 sin radius mul radius add lineto unpagectm {
                
            } {
                
            } {
                
            } {
                
            } pathforall arow grestore
        } if
    } if crlincp setlinecap crlinalph setalpha crlinw setlinewidth usedash {
        strdsh dshpatoff setdash
    } if strinclr {
        crlinred crlingrn crlinblu setrgbcolor
    } {
        crlingry setgray
    } ifelse unpagectm concat strwpat {
        crstrpat findfont exch strwittrans {
            trpatstrk
        } {
            oppatstrk
        } ifelse
    } {
        stroke pop
    } ifelse grestore
} bind def /apfill {
    gsave dodrawctm /chord exch def /pie exch def /radius exch def /yscale \
exch def /xscale exch def /yy exch def /xx exch def xx yy translate xscale \
yscale scale newpath pie {
        radius dup moveto
    } if radius dup dup 5 -2 roll arc pie chord or {
        closepath
    } if 1 xscale div 1 yscale div scale crfilalph setalpha filinclr {
        crfilred crfilgrn crfilblu setrgbcolor
    } {
        crfilgry setgray
    } ifelse filwpat {
        crfilpat findfont exch filwittrans {
            trpatfil
        } {
            oppatfil
        } ifelse
    } {
        fill pop
    } ifelse grestore
} bind def /mkepath {
    dodrawctm /chord exch def /pie exch def /radius exch def /yscale exch def \
/xscale exch def /yy exch def /xx exch def /angle2 exch def /angle1 exch def \
/closed exch def xx yy translate xscale yscale scale newpath pie {
        radius dup moveto
    } if radius dup dup angle1 angle2 arc closed pie or chord or {
        closepath
    } if unpagectm
} bind def end
TopDrawDict begin /dotx {
    gsave txtdraw {
        concat selectfont txtinclr {
            crtxtred crtxtgrn crtxtblu setrgbcolor
        } {
            crtxtgry setgray
        } ifelse crtxtalph setalpha moveto xyshow
    } {
        pop pop pop pop pop pop pop
    } ifelse grestore
} bind def /txtlin {
    gsave txlndraw {
        concat txlninclr {
            crtxlnred crtxlngrn crtxlnblu setrgbcolor
        } {
            crtxlngry setgray
        } ifelse crtxlnalph setalpha setlinewidth 0 setlinecap newpath moveto \
0 rlineto stroke
    } {
        pop pop pop pop pop
    } ifelse grestore
} bind def end
%%EndSetup
0 0 508 202 rectclip
-136.427536 -63.621582 translate
136.427536 63.621582 507.484436 200.824463 rectclip
gsave
TopDrawDict begin
/invpats true def
/crlincp 0 def
/crlinjn 0 def
/crmtrlmt 10 def
/crlinw 1 def
/crlinalph 1 def
/crlinred 0 def /crlingrn 0 def /crlinblu 0 def /strinclr true def
/crfilalph 1 def
/crfilred 0 def /crfilgrn 0 def /crfilblu 0 def /filinclr true def
/filwpat false def
TopDrawDict /piddict known TopDrawDict /ipiddict known or {
    1 getpat /crfilpat exch def
} if
/filwittrans false def
/strwpat false def
TopDrawDict /piddict known TopDrawDict /ipiddict known or {
    1 getpat /crstrpat exch def
} if
/strwittrans false def
/usedash false def
/strdsh [2 2] def /dshpatoff 0 def
/crendarw false def
/crfrtarw false def
/txtdraw false def
/crtxtalph 1 def
/crtxtred 0 def /crtxtgrn 0 def /crtxtblu 0 def /txtinclr true def
/txtwpat false def
/txtwittrans false def
/txlndraw false def
/crtxlnalph 1 def
/crtxlnred 0 def /crtxlngrn 0 def /crtxlnblu 0 def /txlninclr true def
/txlnwpat false def
/txlnwittrans false def
0.477931 -0.577998 0.577998 0.477931 -155.874847 431.401611 sc4mt astore \
0.477931 -0.577998 0.577998 0.477931 -155.874847 431.401611 sc5mt astore 179 \
579 227 -17 8.5 0.477931 -0.577998 0.577998 0.477931 -233.624847 64.651611 \
sc6mt astore rfstroke
/esave save def 0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 \
94.292992 107.121552 sc6mt astore 2.118194 180 154 610 1 -1.351852 27 false \
false 0.75 0 0 0.75 118.542992 -271.628448 sc5mt astore apstroke esave \
restore
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore 109 0 125 574 0.75 0 0 0.75 118.542992 -271.628448 \
sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -9 -17 166 592 0.75 0 0 0.75 118.542992 -271.628448 \
sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -9 -17 175 591 0.75 0 0 0.75 118.542992 -271.628448 \
sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -9 -17 184 591 0.75 0 0 0.75 118.542992 -271.628448 \
sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -9 -17 194 591 0.75 0 0 0.75 118.542992 -271.628448 \
sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -9 -17 203 591 0.75 0 0 0.75 118.542992 -271.628448 \
sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -9 -17 212 593 0.75 0 0 0.75 118.542992 -271.628448 \
sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.509924 0 0 0.509925 196.941406 -67.057045 sc5mt astore efill
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 0.509924 0 0 0.509925 \
196.941406 -67.057045 sc5mt astore estroke
/crendarw true def
/crfrtarw true def
/esave save def 0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 \
94.292992 107.121552 sc6mt astore 308.8797 338.968628 227 236 1.067485 1 81.5 \
false false 0.436324 0 0 0.581333 120.220795 -26.698563 sc5mt astore apstroke \
esave restore
/crfrtarw false def
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore -0.75 0 0 0.75 616.446045 \
107.121552 sc5mt astore -58.403805 71.356964 113.204041 499.999969 0.75 0 0 \
0.75 120.792999 -170.378418 sc6mt astore ssl
-3.27835e-08 0.75 -0.75 -3.27835e-08 624.572998 97.401558 sc4mt astore \
-3.27835e-08 0.75 -0.75 -3.27835e-08 624.572998 97.401558 sc5mt astore \
90.346512 75.123932 234.040024 373.039948 0.75 0 0 0.75 114.042999 \
-169.628418 sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore 121.015747 0 191 556 0.75 0 0 0.75 118.542992 \
-271.628448 sc6mt astore ssl
-3.27835e-08 0.75 -0.75 -3.27835e-08 699.632935 308.541565 sc4mt astore \
-3.27835e-08 0.75 -0.75 -3.27835e-08 699.632935 308.541565 sc5mt astore \
121.015747 0 209 538 -3.27835e-08 0.75 -0.75 -3.27835e-08 660.132935 \
-7.958435 sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(b) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
0.792999 35.121552] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.75 \
0 0 0.75 0.792999 35.121552] dotx
/txtdraw true def
/txlndraw true def
(b) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
190.542999 -49.628448] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.75 \
0 0 0.75 190.542999 -49.628448] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.75 0 0 0.75 73.542999 141.621552] dotx
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.75 0 0 0.75 264.042999 56.121552] dotx
/txtdraw true def
/txlndraw true def
(i ) [3.891998 0 0 0] 169 258 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 \
0 0 0.75 237.042999 -53.378448] dotx
(j ) [3.891998 0 0 0] 122 278 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 \
0 0 0.75 174.042999 25.371552] dotx
(^ ) [7.980003 0 0 0] 75 309 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 \
0 0 0.75 209.292999 5.871552] dotx
(^ ) [7.980003 0 0 0] 75 309 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 \
0 0 0.75 307.542999 -87.878448] dotx
/crendarw false def
0.477931 -0.577998 0.577998 0.477931 -155.874847 431.401611 sc4mt astore \
0.477931 -0.577998 0.577998 0.477931 -155.874847 431.401611 sc5mt astore 179 \
579 227 -17 8.5 0.477931 -0.577998 0.577998 0.477931 7.125153 78.151619 sc6mt \
astore rfstroke
/crendarw true def
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -0.944946 -103.000275 286 225 0.75 0 0 0.75 \
260.292999 93.621559 sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore 76.016205 -0.926849 139 306 0.75 0 0 0.75 329.292999 \
-72.128441 sc6mt astore ssl
-3.27835e-08 0.75 -0.75 -3.27835e-08 699.632935 308.541565 sc4mt astore \
-3.27835e-08 0.75 -0.75 -3.27835e-08 699.632935 308.541565 sc5mt astore \
0.11058 70.575714 227 225 0.75 0 0 0.75 328.542999 -70.628441 sc6mt astore \
ssl
/txtdraw true def
/txlndraw true def
(mg ) [12.996002 0 9 0 0 0] 302 113 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] \
[0.75 0 0 0.75 252.042999 122.121559] dotx
(Rx ) [10.998001 0 7.992004 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 376.542999 -45.878441] dotx
(Ry ) [10.998001 0 7.992004 0 0 0] 201 225 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 350.292999 -31.628441] dotx
(o ) [9 0 0 0] 175 665 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] [0.75 0 0 0.75 \
113.292992 -350.378448] dotx
/crendarw false def
0.75 0 0 0.75 94.292992 107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.75 0 0 0.75 149.292999 -143.378448 sc5mt astore efill
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 0.75 0 0 0.75 149.292999 \
-143.378448 sc5mt astore estroke
(cm ) [7.992004 0 12.996002 0 0 0] 174 462 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 82.542992 -176.378448] dotx
/txtdraw true def
/txlndraw true def
(q) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
120.042999 -87.128441] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.75 \
0 0 0.75 120.042999 -87.128441] dotx
/txtdraw true def
/txlndraw true def
(q) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
142.542999 -42.878441] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.75 \
0 0 0.75 142.542999 -42.878441] dotx
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 206 343 47 -23 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore rstroke
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore -22 -28 229 371 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 23 -27 230 370 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(c) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
33.793045 -147.878448] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 235.216003 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.75 0 0 0.75 33.793045 -147.878448] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.75 0 0 0.75 106.543045 -41.378448] dotx
/txtdraw true def
/txlndraw true def
(c) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
102.042999 -27.128448] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 235.216003 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.75 0 0 0.75 102.042999 -27.128448] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.75 0 0 0.75 175.542999 78.621552] dotx
/crendarw true def
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore -0.75 0 0 0.75 616.446045 \
107.121552 sc5mt astore -86.204391 -0.934906 227.204041 331.999969 0.75 0 0 \
0.75 114.042999 -169.628418 sc6mt astore ssl
/crendarw false def
0.75 0 0 0.75 94.292992 107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.75 0 0 0.75 198.792999 -232.628448 sc5mt astore efill
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 0.75 0 0 0.75 198.792999 \
-232.628448 sc5mt astore estroke
/txtdraw true def
/txlndraw true def
(cm ) [7.992004 0 12.996002 0 0 0] 174 462 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 158.292999 -279.878448] dotx
/crendarw true def
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore -0.75 0 0 0.75 616.446045 \
107.121552 sc5mt astore 1.720078 136.000519 228.204041 335.999969 0.75 0 0 \
0.75 114.042999 -169.628418 sc6mt astore ssl
/crfrtarw true def
/esave save def 0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 \
94.292999 107.121582 sc6mt astore 50.162003 93.944878 406 302 1 1.083333 54 \
false false 1.248157 0 0 1.053498 -278.404846 -270.544067 sc5mt astore \
apstroke esave restore
/crendarw false def
/crfrtarw false def
0.75 0 0 0.75 94.292992 107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.509924 0 0 0.509925 225.441406 -104.557045 sc5mt astore efill
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 0.509924 0 0 0.509925 \
225.441406 -104.557045 sc5mt astore estroke
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore -44 -34 185 416 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore -32 -25 226 368 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore -29 -21 160 449 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore -47 -37 95 534 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
/crendarw true def
/crfrtarw true def
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 32.31781 -38.781372 172.841095 398.390686 0.75 0 0 \
0.75 114.042999 -169.628418 sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 18.288666 -21.805725 145.855667 430.402863 0.75 0 0 \
0.75 114.042999 -169.628418 sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 86.325836 -103.774658 60.837086 499.387329 0.75 0 0 \
0.75 114.042999 -169.628418 sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(l) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
20.292999 -46.628441] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 232.891998 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.75 0 0 0.75 20.292999 -46.628441] dotx
/txtdraw true def
/txlndraw true def
(d) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
46.542999 -76.628441] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.75 \
0 0 0.75 46.542999 -76.628441] dotx
/txtdraw true def
/txlndraw true def
(l) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
74.292999 -106.628441] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 232.891998 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.75 0 0 0.75 74.292999 -106.628441] dotx
/txtdraw true def
/txlndraw true def
(d) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
155.292999 -124.628441] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.75 \
0 0 0.75 155.292999 -124.628441] dotx
/crendarw false def
/crfrtarw false def
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 54 0 235 370 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 53 1 237 332 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
/crendarw true def
/crfrtarw true def
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 0 -25 277 364 0.75 0 0 0.75 114.042999 -169.628418 \
sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(Px ) [10.998001 0 7.992004 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 444.042999 -81.128441] dotx
(Py ) [10.998001 0 7.992004 0 0 0] 201 225 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 378.792999 -20.378441] dotx
/crfrtarw false def
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore -0.75 0 0 0.75 842.805176 \
107.121552 sc5mt astore 76.016235 -0.926849 139 306 -0.75 0 0 0.75 693.055176 \
-107.378448 sc6mt astore ssl
-3.27835e-08 0.75 -0.75 -3.27835e-08 699.632935 308.541565 sc4mt astore \
-9.83506e-08 -0.75 -0.75 9.83506e-08 699.632935 425.133362 sc5mt astore \
0.11058 70.575714 227 225 0.75 -6.5567e-08 -6.5567e-08 -0.75 355.542999 \
350.553406 sc6mt astore ssl
/crendarw false def
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 651 479 47 -23 0.75 0 0 0.75 117.792999 -203.378418 \
sc6mt astore rstroke
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore -22 -28 674 507 0.75 0 0 0.75 117.792999 -203.378418 \
sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore 23 -27 675 506 0.75 0 0 0.75 117.792999 -203.378418 \
sc6mt astore ssl
(Px ) [10.998001 0 7.992004 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 495.792999 -28.628448] dotx
(Py ) [10.998001 0 7.992004 0 0 0] 201 225 /Times-Italic [ 18 1 mul 0 0 18 0 \
0 ] [0.75 0 0 0.75 456.042999 29.121552] dotx
/crendarw true def
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 290.792999 \
107.121552 sc5mt astore 76.016235 -0.926849 139 306 0.75 0 0 0.75 456.792999 \
-52.628448 sc6mt astore ssl
-3.27835e-08 0.75 -0.75 -3.27835e-08 699.632935 308.541565 sc4mt astore \
-3.27835e-08 0.75 -0.75 -3.27835e-08 699.632935 545.541565 sc5mt astore \
0.11058 70.575714 227 225 0.75 0 0 0.75 453.042938 5.871582 sc6mt astore ssl
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore 0 -57.999969 673 467.999969 0.75 0 0 0.75 117.792999 \
-203.378418 sc6mt astore ssl
(mg ) [12.996002 0 9 0 0 0] 302 113 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] \
[0.75 0 0 0.75 401.292999 27.621552] dotx
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -21.403625 -44.590851 342 286.999969 0.75 0 0 0.75 \
170.292999 29.871582 sc6mt astore ssl
(S ) [9 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] [0.75 0 0 0.75 \
315.792999 -6.878441] dotx
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore 18.09787 32.748566 378 231.999969 0.75 0 0 0.75 \
132.792999 -78.878418 sc6mt astore ssl
(S ) [9 0 0 0] 131 277 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] [0.75 0 0 0.75 \
336.042999 -95.378441] dotx
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -0.857178 -36.001678 379 231.999969 0.75 0 0 0.75 \
132.792999 -78.878418 sc6mt astore ssl
(mg ) [12.996002 0 9 0 0 0] 302 113 /Times-Italic [ 18 1 mul 0 0 18 0 0 ] \
[0.75 0 0 0.75 195.792999 -13.628441] dotx
/crendarw false def
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc5mt astore -42 -132 86 534 0.75 0 0 0.75 120.792999 -170.378418 \
sc6mt astore ssl
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc6mt astore 13.200378 1 -1 33 398 0.75 0 0 0.75 116.292999 \
-166.628418 sc5mt astore estroke
/crendarw true def
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -15.167437 -47.286713 43 397 0.75 0 0 0.75 120.792999 \
-170.378418 sc6mt astore ssl
/txtdraw true def
/txlndraw true def
(t) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
-23.206955 -131.378448] dotx
/txtdraw true def
/txlndraw true def
(1 ) [6 0 0 0] 232.891998 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.75 0 0 0.75 -23.206955 -131.378448] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.75 0 0 0.75 49.543045 -24.878448] dotx
/txtdraw true def
/txlndraw true def
(l) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
-5.206978 -58.628441] dotx
/txtdraw true def
/txlndraw true def
(3 ) [6 0 0 0] 232.891998 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.75 0 0 0.75 -5.206978 -58.628441] dotx
/txtdraw true def
/txlndraw true def
(t) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
-35.206955 -72.128441] dotx
/txtdraw true def
/txlndraw true def
(2 ) [6 0 0 0] 232.891998 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 \
] [0.75 0 0 0.75 -35.206955 -72.128441] dotx
/txtdraw true def
/txlndraw true def
(^ ) [7.979996 0 0 0] 132 154.399994 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 \
] [0.75 0 0 0.75 37.543045 34.371559] dotx
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc5mt astore -21.373503 7.916107 53 432 0.75 0 0 0.75 120.792999 \
-170.378418 sc6mt astore ssl
/crfrtarw true def
/esave save def 0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 \
94.292999 107.121582 sc6mt astore 295.674774 38.678638 88 535 -1.018868 1 \
26.5 false false 0.75 0 0 0.75 136.542999 -189.878418 sc5mt astore apstroke \
esave restore
/txtdraw true def
/txlndraw true def
(q) [0 0] 229 288 /Times-BoldItalic [ 14 1 mul 0 0 14 0 0 ] [0.75 0 0 0.75 \
-24.707001 11.871552] dotx
/txtdraw true def
/txlndraw true def
(3 ) [6 0 0 0] 236 283.200012 /Times-BoldItalic [ 12 1 mul 0 0 12 0 0 ] [0.75 \
0 0 0.75 -24.707001 11.871552] dotx
/crendarw false def
/crfrtarw false def
0.75 0 0 0.75 94.292999 107.121582 sc4mt astore 0.75 0 0 0.75 94.292999 \
107.121582 sc6mt astore 13.200378 1 -1 33 398 0.75 0 0 0.75 381.792999 \
-194.378418 sc5mt astore estroke
0.75 0 0 0.75 94.292992 107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 \
0.509924 0 0 0.509925 125.691406 18.442963 sc5mt astore efill
0.75 0 0 0.75 94.292992 107.121552 sc4mt astore 0.75 0 0 0.75 94.292992 \
107.121552 sc6mt astore 5.147812 1.000001 -1 111 421 0.509924 0 0 0.509925 \
125.691406 18.442963 sc5mt astore estroke
end
grestore
%%Trailer
%%DocumentFonts: Times-BoldItalic
%%+ Times-Italic
%%BoundingBox: 0.000000 0.000000 507.484436 200.824463

%End of Graphics
MathPictureEnd
\
\>"], "Graphics",
 Evaluatable->False,
 AspectRatioFixed->True,
 ImageSize->{508, 201},
 ImageMargins->{{0, Inherited}, {Inherited, Inherited}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],
 ImageRangeCache->{{{0, 507}, {200, 0}} -> {0, 1, 1, 1}}],

Cell["\<\
This is the Trebuchet with the projectile sling being modeled with a rigid \
massless rod.  The model also does not incorporate the dragging of the \
projectile along the ground, thus the model has three degrees of freedom.  As \
far as the \"true\" Trebuchet is concerned, this model is only accurate when \
the tension in the sling (massless rod) is positive.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
Define Unit Vectors and Unit Dyads for however many frames we need for the 
system. For this example we will use three frames of reference, with the \
frame
 T being along the sling as shown.  \
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"B", ",", "b", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"C", ",", "c", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"t", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"T", ",", "t", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"bb", "[", 
   RowBox[{"a_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"unitDyad", "[", 
   RowBox[{
    RowBox[{"b", "[", "a", "]"}], ",", 
    RowBox[{"b", "[", "c", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"cc", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"unitDyad", "[", 
   RowBox[{
    RowBox[{"c", "[", "a", "]"}], ",", 
    RowBox[{"c", "[", "b", "]"}]}], "]"}]}]}], "Input",
 AspectRatioFixed->True],

Cell["\<\
Define fixed relationships between the frames of reference.   Note: these are \
different for different base orientations of the
 frames. \
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "Dot", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "3", "]"}]}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "3", "]"}]}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"t", "[", "3", "]"}]}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"t", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], ".", 
   RowBox[{"t", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "3", "]"}]}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"t", "[", "3", "]"}]}], ":=", "1"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"t", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], ".", 
   RowBox[{"t", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "3", "]"}]}], ":=", 
  RowBox[{"-", "1"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], ".", 
   RowBox[{"n", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], ".", 
   RowBox[{"b", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], ".", 
   RowBox[{"c", "[", "2", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], ".", 
   RowBox[{"t", "[", "1", "]"}]}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "3", "]"}], ".", 
    RowBox[{"t", "[", "2", "]"}]}], ":=", "0"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Protect", "[", "Dot", "]"}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "Cross", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"b", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"b", "[", "1", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"n", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"n", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"n", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"n", "[", "1", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"c", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"c", "[", "1", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"n", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"n", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"n", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"n", "[", "1", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"t", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"t", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"t", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"t", "[", "1", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"t", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"n", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"n", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"t", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"n", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"n", "[", "1", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"c", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"c", "[", "1", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"t", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"t", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"t", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"b", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"t", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"t", "[", "1", "]"}]}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"b", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"b", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"t", "[", "3", "]"}]}], " ", ":=", " ", "0"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"t", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"t", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"t", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"t", "[", "1", "]"}]}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"b", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"b", "[", "2", "]"}]}], " ", ":=", " ", 
  RowBox[{"-", 
   RowBox[{"b", "[", "2", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "[", "3", "]"}], " ", "\[Cross]", " ", 
   RowBox[{"c", "[", "1", "]"}]}], " ", ":=", " ", 
  RowBox[{"c", "[", "2", "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"t", "[", "3", "]"}], " ", "\[Cross]", " ", 
    RowBox[{"c", "[", "2", "]"}]}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"c", "[", "1", "]"}]}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "Cross", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5184534956356*^9, 3.5184534970084*^9}, {
   3.5184535285516*^9, 3.5184535371316*^9}, 3.51845357401*^9},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
FMR\[Dash]Angular Momentum and Linear Momentum\
\>", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
The force vector on the rocker arm B, Rock Crate C and Porjectile H are given \
by:\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Fb", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "mb"}], " ", "g", " ", "j"}], "+", 
   RowBox[{"Rx", " ", "i"}], "+", 
   RowBox[{"Ry", " ", "j"}], "-", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Px", " ", 
      RowBox[{"c", "[", "1", "]"}]}], "+", 
     RowBox[{"Py", " ", 
      RowBox[{"c", "[", "2", "]"}]}]}], ")"}], "+", 
   RowBox[{"S", " ", 
    RowBox[{"t", "[", "1", "]"}]}]}]}], "\n", 
 RowBox[{"Fc", "=", 
  RowBox[{
   RowBox[{"Px", " ", 
    RowBox[{"c", "[", "1", "]"}]}], "+", 
   RowBox[{"Py", " ", 
    RowBox[{"c", "[", "2", "]"}]}], "-", 
   RowBox[{"mc", " ", "g", " ", "j"}]}]}], "\n", 
 RowBox[{"Fh", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "mh"}], " ", "g", " ", "j"}], "-", 
   RowBox[{"S", " ", 
    RowBox[{"t", "[", "1", "]"}]}]}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "Px"}], " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "1"]}], "-", 
  RowBox[{"Py", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "2"]}], "+", 
  RowBox[{"Rx", " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "-", 
  RowBox[{"g", " ", "mb", " ", 
   OverscriptBox["\<\"j\"\>", "^"]}], "+", 
  RowBox[{"Ry", " ", 
   OverscriptBox["\<\"j\"\>", "^"]}], "+", 
  RowBox[{"S", " ", 
   SubscriptBox[
    OverscriptBox["t", "^"], "1"]}]}]], "Output",
 CellChangeTimes->{3.5184535775512*^9, 3.51845368321*^9, 3.536264979034584*^9}
  ],

Cell[BoxData[
 RowBox[{
  RowBox[{"Px", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "1"]}], "+", 
  RowBox[{"Py", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "2"]}], "-", 
  RowBox[{"g", " ", "mc", " ", 
   OverscriptBox["\<\"j\"\>", "^"]}]}]], "Output",
 CellChangeTimes->{3.5184535775512*^9, 3.51845368321*^9, 3.536264979036734*^9}
  ],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mh", " ", 
   OverscriptBox["\<\"j\"\>", "^"]}], "-", 
  RowBox[{"S", " ", 
   SubscriptBox[
    OverscriptBox["t", "^"], "1"]}]}]], "Output",
 CellChangeTimes->{3.5184535775512*^9, 3.51845368321*^9, 3.536264979038247*^9}
  ]
}, Open  ]],

Cell["\<\
The moments about the CG for both B and C are, including viscous friction \
(dB,dC) at the pins. \
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Mb", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "dB"}], " ", 
     RowBox[{
      RowBox[{"q1", "'"}], "[", "t", "]"}], " ", 
     RowBox[{"b", "[", "3", "]"}]}], " ", "+", " ", 
    RowBox[{"dC", " ", 
     RowBox[{
      RowBox[{"q2", "'"}], "[", "t", "]"}], " ", 
     RowBox[{"c", "[", "3", "]"}]}], " ", "-", " ", 
    RowBox[{"d1", " ", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], " ", "\[Cross]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Rx", " ", "i"}], " ", "+", " ", 
        RowBox[{"Ry", " ", "j"}]}], ")"}]}]}], " ", "-", " ", "\n", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"d1", " ", "+", " ", "l1"}], ")"}], " ", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], " ", "\[Cross]", " ", 
      RowBox[{"-", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Px", " ", 
          RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
         RowBox[{"Py", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}]}]}]}], " ", "+", " ", "\n", 
    
    RowBox[{"l2", " ", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], " ", "\[Cross]", " ", "S"}], " ", 
     RowBox[{"t", "[", "1", "]"}]}]}], "//", "distributeScalars"}]}], "\n", 
 RowBox[{"Mc", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "dC"}], " ", 
    RowBox[{
     RowBox[{"q2", "'"}], "[", "t", "]"}], " ", 
    RowBox[{"c", "[", "3", "]"}]}], " ", "+", " ", 
   RowBox[{"d2", " ", 
    RowBox[{
     RowBox[{"c", "[", "2", "]"}], " ", "\[Cross]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Px", " ", 
        RowBox[{"c", "[", "1", "]"}]}], " ", "+", " ", 
       RowBox[{"Py", " ", 
        RowBox[{"c", "[", "2", "]"}]}]}], ")"}]}]}]}]}]}], "Input",
 CellChangeTimes->{
  3.5184535302363997`*^9, {3.5184535818724003`*^9, 3.5184535818724003`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"d1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"l1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"d1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "+", 
  RowBox[{"l1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"d1", " ", "Rx", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
  RowBox[{"d1", " ", "Ry", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
  RowBox[{"l2", " ", "S", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], "\[Cross]", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}]}], "-", 
  RowBox[{"dB", " ", 
   SubscriptBox[
    OverscriptBox["b", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"dC", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.51845358298*^9, 3.5184536854876003`*^9, 
  3.536264979103446*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d2"}], " ", "Px", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"]}], "-", 
  RowBox[{"dC", " ", 
   SubscriptBox[
    OverscriptBox["c", "^"], "3"], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.51845358298*^9, 3.5184536854876003`*^9, 
  3.536264979106032*^9}]
}, Open  ]],

Cell["\<\
The full inertia Dyadics about the CG for each body (the projectile is model \
as a point mass) are given by:\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Ibo", "=", 
  RowBox[{
   RowBox[{"B11", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"1", ",", "1"}], "]"}]}], "+", 
   RowBox[{"B12", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"1", ",", "2"}], "]"}]}], "+", 
   RowBox[{"B13", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"1", ",", "3"}], "]"}]}], "+", 
   RowBox[{"B21", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"2", ",", "1"}], "]"}]}], "+", 
   RowBox[{"B22", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"2", ",", "2"}], "]"}]}], "+", 
   RowBox[{"B23", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"2", ",", "3"}], "]"}]}], "+", 
   RowBox[{"B31", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"3", ",", "1"}], "]"}]}], "+", 
   RowBox[{"B32", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"3", ",", "2"}], "]"}]}], "+", 
   RowBox[{"B33", " ", 
    RowBox[{"bb", "[", 
     RowBox[{"3", ",", "3"}], "]"}]}]}]}], "\n", 
 RowBox[{"Ico", "=", 
  RowBox[{
   RowBox[{"C11", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"1", ",", "1"}], "]"}]}], "+", 
   RowBox[{"C12", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"1", ",", "2"}], "]"}]}], "+", 
   RowBox[{"C13", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"1", ",", "3"}], "]"}]}], "+", 
   RowBox[{"C21", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"2", ",", "1"}], "]"}]}], "+", 
   RowBox[{"C22", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"2", ",", "2"}], "]"}]}], "+", 
   RowBox[{"C23", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"2", ",", "3"}], "]"}]}], "+", 
   RowBox[{"C31", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"3", ",", "1"}], "]"}]}], "+", 
   RowBox[{"C32", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"3", ",", "2"}], "]"}]}], "+", 
   RowBox[{"C33", " ", 
    RowBox[{"cc", "[", 
     RowBox[{"3", ",", "3"}], "]"}]}]}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"B11", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B12", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B13", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B21", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B22", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B23", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B31", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B32", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"B33", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["b", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3], 
      $CellContext`unitVector[$CellContext`B, $CellContext`b, 3]],
     Editable->False], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184535873012*^9, 3.5184536899491997`*^9, 
  3.536264979140499*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"C11", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 1], 
      $CellContext`unitVector[C, $CellContext`c, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C12", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 1], 
      $CellContext`unitVector[C, $CellContext`c, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C13", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "1"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 1], 
      $CellContext`unitVector[C, $CellContext`c, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C21", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 2], 
      $CellContext`unitVector[C, $CellContext`c, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C22", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 2], 
      $CellContext`unitVector[C, $CellContext`c, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C23", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "2"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 2], 
      $CellContext`unitVector[C, $CellContext`c, 3]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C31", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 3], 
      $CellContext`unitVector[C, $CellContext`c, 1]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C32", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 3], 
      $CellContext`unitVector[C, $CellContext`c, 2]],
     Editable->False], ")"}]}], "+", 
  RowBox[{"C33", " ", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{
      SubscriptBox[
       OverscriptBox["c", "^"], "3"], "\[InvisibleSpace]", 
      SubscriptBox[
       OverscriptBox["c", "^"], "3"]}],
     SequenceForm[
      $CellContext`unitVector[C, $CellContext`c, 3], 
      $CellContext`unitVector[C, $CellContext`c, 3]],
     Editable->False], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184535873012*^9, 3.5184536899491997`*^9, 
  3.5362649791433773`*^9}]
}, Open  ]],

Cell["Making the I's constants.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "B11", ",", "B12", ",", "B13", ",", "B21", ",", "B22", ",", "B23", ",", 
     "B31", ",", "B32", ",", "B33", ",", "C11", ",", "C12", ",", "C13", ",", 
     "C21", ",", "C22", ",", "C23", ",", "C31", ",", "C32", ",", "C33", ",", 
     "d1", ",", "d2", ",", "l1", ",", "l2", ",", "l3"}], "}"}], ",", 
   "Constant"}], "]"}]], "Input",
 AspectRatioFixed->True],

Cell["The angular velocities of frame B, C, and T are:", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"NwB", "=", 
  RowBox[{
   RowBox[{"omega", "[", 
    RowBox[{"N", ",", "B"}], "]"}], "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], " ", 
    RowBox[{"b", "[", "3", "]"}]}]}]}], "\n", 
 RowBox[{"NwC", "=", 
  RowBox[{
   RowBox[{"omega", "[", 
    RowBox[{"N", ",", "C"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "+", 
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ")"}], " ", 
    RowBox[{"c", "[", "3", "]"}]}]}]}], "\n", 
 RowBox[{"NwT", "=", 
  RowBox[{
   RowBox[{"omega", "[", 
    RowBox[{"N", ",", "T"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "+", 
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ")"}], " ", 
    RowBox[{"t", "[", "3", "]"}]}]}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["b", "^"], "3"], " ", 
  RowBox[{
   SuperscriptBox["q1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184535892200003`*^9, 3.5184536932564*^9, 
  3.53626497918648*^9}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["c", "^"], "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "+", 
    RowBox[{
     SuperscriptBox["q2", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184535892200003`*^9, 3.5184536932564*^9, 
  3.53626497918834*^9}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["t", "^"], "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "+", 
    RowBox[{
     SuperscriptBox["q3", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184535892200003`*^9, 3.5184536932564*^9, 
  3.536264979189806*^9}]
}, Open  ]],

Cell["The angular momentum is given by Ho = Io . NwB (C).", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Hbo", "=", 
  RowBox[{"Ibo", ".", "NwB"}]}], "\n", 
 RowBox[{"Hco", "=", 
  RowBox[{"Ico", ".", "NwC"}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"B13", " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "1"]}], "+", 
    RowBox[{"B23", " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "2"]}], "+", 
    RowBox[{"B33", " ", 
     SubscriptBox[
      OverscriptBox["b", "^"], "3"]}]}], ")"}], " ", 
  RowBox[{
   SuperscriptBox["q1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184535918876*^9, 3.518453695222*^9, 
  3.5362649792206783`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"C13", " ", 
     SubscriptBox[
      OverscriptBox["c", "^"], "1"]}], "+", 
    RowBox[{"C23", " ", 
     SubscriptBox[
      OverscriptBox["c", "^"], "2"]}], "+", 
    RowBox[{"C33", " ", 
     SubscriptBox[
      OverscriptBox["c", "^"], "3"]}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "+", 
    RowBox[{
     SuperscriptBox["q2", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184535918876*^9, 3.518453695222*^9, 
  3.536264979222618*^9}]
}, Open  ]],

Cell["\<\
The equation of motion can be derived from Mo - DvDt[N,Ho]==0 and F- ma==0 \
for each body; we will drop the == 0 until we get to the solution.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq1", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Mb", "-", 
      RowBox[{"DvDt", "[", 
       RowBox[{"N", ",", "Hbo"}], "]"}]}], ")"}], ".", 
    RowBox[{"b", "[", "3", "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"d1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"l1", " ", "Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"d1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "+", 
  RowBox[{"l1", " ", "Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"d1", " ", "Rx", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
  RowBox[{"d1", " ", "Ry", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
  RowBox[{"l2", " ", "S", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}]}], "-", 
  RowBox[{"dB", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"B33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184535951168003`*^9, 3.5184536969068003`*^9, 
  3.536264979254135*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq2", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Mc", "-", 
      RowBox[{"DvDt", "[", 
       RowBox[{"N", ",", "Hco"}], "]"}]}], ")"}], ".", 
    RowBox[{"c", "[", "3", "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d2"}], " ", "Px"}], "-", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{{3.518453593744*^9, 3.5184535963803997`*^9}, 
   3.5184536979519997`*^9, 3.536264979407556*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq3", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fb", "-", 
      RowBox[{"mb", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{"d1", " ", 
            RowBox[{"b", "[", "1", "]"}]}]}], "]"}]}], "]"}]}]}], ")"}], ".", 
    "i"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"Rx", "-", 
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "1"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}]}], "+", 
  RowBox[{"S", " ", 
   RowBox[{
    OverscriptBox["\<\"i\"\>", "^"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}]}], "+", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184535974412003`*^9, 3.518453699512*^9, 
  3.53626497943718*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq4", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fb", "-", 
      RowBox[{"mb", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{"d1", " ", 
            RowBox[{"b", "[", "1", "]"}]}]}], "]"}]}], "]"}]}]}], ")"}], ".", 
    "j"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mb"}], "+", "Ry", "-", 
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "1"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["c", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
  RowBox[{"S", " ", 
   RowBox[{
    OverscriptBox["\<\"j\"\>", "^"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}]}], "+", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"d1", " ", "mb", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184535987984*^9, 3.5184537004323997`*^9, 
  3.536264979471089*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq5", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fc", "-", 
      RowBox[{"mc", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "l1"}], " ", 
             RowBox[{"b", "[", "1", "]"}]}], "-", 
            RowBox[{"d2", " ", 
             RowBox[{"c", "[", "2", "]"}]}]}]}], "]"}]}], "]"}]}]}], ")"}], 
    ".", 
    RowBox[{"b", "[", "1", "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"g", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"l1", " ", "mc", " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "+", 
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184535996408*^9, 3.5184537011188*^9, 
  3.5362649795392323`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq6", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fc", "-", 
      RowBox[{"mc", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "l1"}], " ", 
             RowBox[{"b", "[", "1", "]"}]}], "-", 
            RowBox[{"d2", " ", 
             RowBox[{"c", "[", "2", "]"}]}]}]}], "]"}]}], "]"}]}]}], ")"}], 
    ".", 
    RowBox[{"b", "[", "2", "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Px", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}]}], "+", 
  RowBox[{"Py", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}]}], "-", 
  RowBox[{"g", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "+", 
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], "+", 
  RowBox[{"l1", " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"d2", " ", "mc", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["c", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.518453600686*^9, 3.5184537021952*^9, 3.53626497960565*^9}
  ]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq7", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fh", "-", 
      RowBox[{"mh", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{
            RowBox[{"l2", " ", 
             RowBox[{"b", "[", "1", "]"}]}], "+", 
            RowBox[{"l3", " ", 
             RowBox[{"t", "[", "1", "]"}]}]}]}], "]"}]}], "]"}]}]}], ")"}], 
    ".", 
    RowBox[{"t", "[", "1", "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "S"}], "-", 
  RowBox[{"g", " ", "mh", " ", 
   RowBox[{
    OverscriptBox["\<\"j\"\>", "^"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}]}], "+", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"l3", " ", "mh", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "+", 
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], "-", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184536016532*^9, 3.5184537029440002`*^9, 
  3.536264979671483*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq8", "=", 
  RowBox[{"distributeScalars", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Fh", "-", 
      RowBox[{"mh", " ", 
       RowBox[{"DvDt", "[", 
        RowBox[{"N", ",", 
         RowBox[{"DvDt", "[", 
          RowBox[{"N", ",", 
           RowBox[{
            RowBox[{"l2", " ", 
             RowBox[{"b", "[", "1", "]"}]}], "+", 
            RowBox[{"l3", " ", 
             RowBox[{"t", "[", "1", "]"}]}]}]}], "]"}]}], "]"}]}]}], ")"}], 
    ".", 
    RowBox[{"t", "[", "2", "]"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mh", " ", 
   RowBox[{
    OverscriptBox["\<\"j\"\>", "^"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "2"]}]}], "+", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "2"]}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"l3", " ", "mh", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "2"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l3", " ", "mh", " ", 
   RowBox[{
    SuperscriptBox["q3", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.51845360287*^9, 3.5184537036616*^9, 3.536264979771407*^9}
  ]
}, Open  ]],

Cell["\<\
Now solve for the reaction forces at the pins and eliminate them for the two \
angular momentum equation (eq1,eq2).   Also need to eliminate the sling \
tension S.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solR", "=", 
  RowBox[{"First", "[", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eq3", "==", "0"}], ",", 
       RowBox[{"eq4", "==", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Rx", ",", "Ry"}], "}"}]}], "]"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Rx", "\[Rule]", 
    RowBox[{
     RowBox[{"Px", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "1"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}]}], "+", 
     RowBox[{"Py", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "2"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}]}], "-", 
     RowBox[{"S", " ", 
      RowBox[{
       OverscriptBox["\<\"i\"\>", "^"], ".", 
       SubscriptBox[
        OverscriptBox["t", "^"], "1"]}]}], "-", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
   RowBox[{"Ry", "\[Rule]", 
    RowBox[{
     RowBox[{"g", " ", "mb"}], "+", 
     RowBox[{"Px", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "1"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
     RowBox[{"Py", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["c", "^"], "2"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
     RowBox[{"S", " ", 
      RowBox[{
       OverscriptBox["\<\"j\"\>", "^"], ".", 
       SubscriptBox[
        OverscriptBox["t", "^"], "1"]}]}], "-", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.51845360404*^9, 3.5184537053152*^9, 
  3.5362649799073963`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solP", "=", 
  RowBox[{"First", "[", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eq5", "==", "0"}], ",", 
       RowBox[{"eq6", "==", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Px", ",", "Py"}], "}"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5184536552860003`*^9, 3.5184536610892*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Px", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"g", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         OverscriptBox["\<\"j\"\>", "^"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}], "-", 
       RowBox[{"g", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
       RowBox[{"l1", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
       RowBox[{"l1", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SuperscriptBox["q1", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "-", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SuperscriptBox["q1", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "+", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SuperscriptBox["q1", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "-", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SuperscriptBox["q2", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "+", 
       RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SuperscriptBox["q2", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]}], 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], "-", 
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}]}]]}]}], ",", 
   RowBox[{"Py", "\[Rule]", 
    RowBox[{"-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "-", 
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}]}]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g"}], " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          OverscriptBox["\<\"j\"\>", "^"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "+", 
        RowBox[{"g", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
        RowBox[{"l1", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"2", " ", "d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], " ", 
         RowBox[{
          SuperscriptBox["q2", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "+", 
        RowBox[{"2", " ", "d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], " ", 
         RowBox[{
          SuperscriptBox["q2", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "-", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"d2", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"l1", " ", "mc", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.518453605756*^9, 3.5184536616976*^9}, 
   3.5184537062511997`*^9, 3.536264980131798*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solS", "=", 
  RowBox[{"First", "[", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"eq7", "==", "0"}], ",", "S"}], "]"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"S", "\[Rule]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "g"}], " ", "mh", " ", 
     RowBox[{
      OverscriptBox["\<\"j\"\>", "^"], ".", 
      SubscriptBox[
       OverscriptBox["t", "^"], "1"]}]}], "+", 
    RowBox[{"l3", " ", "mh", " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"l2", " ", "mh", " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["t", "^"], "1"]}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", "l3", " ", "mh", " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], " ", 
     RowBox[{
      SuperscriptBox["q3", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"l3", " ", "mh", " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
    RowBox[{"l2", " ", "mh", " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["t", "^"], "1"]}], " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.518453608876*^9, 3.5184537076708*^9, 
  3.536264980211224*^9}]
}, Open  ]],

Cell["\<\
Now write down the equations of motion with the known reaction forces \
eliminated with the results shown above.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"eq1", "/.", "solR"}], "/.", "solP"}], "/.", "solS"}]}]], "Input",\

 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "dB"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"B33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}]}], "-", 
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}]}]}]], 
   RowBox[{"d1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "2"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g"}], " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}]}], "+", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}]}], "-", 
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "1"]}], " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["c", "^"], "2"]}]}]}]], 
   RowBox[{"l1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "2"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "g"}], " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}]}], "+", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"2", " ", "d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "+", 
  RowBox[{"l2", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "1"]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "g"}], " ", "mh", " ", 
      RowBox[{
       OverscriptBox["\<\"j\"\>", "^"], ".", 
       SubscriptBox[
        OverscriptBox["t", "^"], "1"]}]}], "+", 
     RowBox[{"l3", " ", "mh", " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"l2", " ", "mh", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       SubscriptBox[
        OverscriptBox["t", "^"], "1"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"2", " ", "l3", " ", "mh", " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], " ", 
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"l3", " ", "mh", " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q3", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
     RowBox[{"l2", " ", "mh", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       SubscriptBox[
        OverscriptBox["t", "^"], "1"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"d1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "1"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}]}], "-", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}]}], "-", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}]}]}]], "-", 
  FractionBox[
   RowBox[{"l1", " ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["b", "^"], "2"], ".", 
     SubscriptBox[
      OverscriptBox["c", "^"], "1"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}]}], "-", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}]}], "-", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}]}]}]], "-", 
  RowBox[{"d1", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"i\"\>", "^"]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "d1"}], " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"i\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "-", 
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}]}]}]], 
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "2"], ".", 
        OverscriptBox["\<\"i\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g"}], " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}]}], "+", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "-", 
     RowBox[{
      RowBox[{
       OverscriptBox["\<\"i\"\>", "^"], ".", 
       SubscriptBox[
        OverscriptBox["t", "^"], "1"]}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g"}], " ", "mh", " ", 
         RowBox[{
          OverscriptBox["\<\"j\"\>", "^"], ".", 
          SubscriptBox[
           OverscriptBox["t", "^"], "1"]}]}], "+", 
        RowBox[{"l3", " ", "mh", " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"l2", " ", "mh", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["t", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"2", " ", "l3", " ", "mh", " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], " ", 
         RowBox[{
          SuperscriptBox["q3", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "+", 
        RowBox[{"l3", " ", "mh", " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"l2", " ", "mh", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["t", "^"], "1"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "1"], ".", 
        OverscriptBox["\<\"i\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}]}], "-", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], "-", 
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}]}]]}], ")"}]}], "-", 
  RowBox[{"d1", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    OverscriptBox["\<\"j\"\>", "^"]}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"g", " ", "mb"}], "-", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "1"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["q1", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
     RowBox[{"d1", " ", "mb", " ", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["b", "^"], "2"], ".", 
       OverscriptBox["\<\"j\"\>", "^"]}], " ", 
      RowBox[{
       SuperscriptBox["q1", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}]}], "-", 
        RowBox[{
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "1"]}], " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["c", "^"], "2"]}]}]}]], 
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "g"}], " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}]}], "+", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"2", " ", "d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], "-", 
     RowBox[{
      RowBox[{
       OverscriptBox["\<\"j\"\>", "^"], ".", 
       SubscriptBox[
        OverscriptBox["t", "^"], "1"]}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "g"}], " ", "mh", " ", 
         RowBox[{
          OverscriptBox["\<\"j\"\>", "^"], ".", 
          SubscriptBox[
           OverscriptBox["t", "^"], "1"]}]}], "+", 
        RowBox[{"l3", " ", "mh", " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"l2", " ", "mh", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "1"], ".", 
          SubscriptBox[
           OverscriptBox["t", "^"], "1"]}], " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
        RowBox[{"2", " ", "l3", " ", "mh", " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}], " ", 
         RowBox[{
          SuperscriptBox["q3", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], "+", 
        RowBox[{"l3", " ", "mh", " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
        RowBox[{"l2", " ", "mh", " ", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["b", "^"], "2"], ".", 
          SubscriptBox[
           OverscriptBox["t", "^"], "1"]}], " ", 
         RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         OverscriptBox["c", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}]}], "-", 
         RowBox[{"g", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          SuperscriptBox[
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
         RowBox[{"l1", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
         RowBox[{"d2", " ", "mc", " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "1"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "1"]}], " ", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["b", "^"], "2"], ".", 
           SubscriptBox[
            OverscriptBox["c", "^"], "2"]}], " ", 
          RowBox[{
           SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}]}], "-", 
       RowBox[{
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "1"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "1"]}], " ", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["b", "^"], "2"], ".", 
         SubscriptBox[
          OverscriptBox["c", "^"], "2"]}]}]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184536105608*^9, 3.5184537092776003`*^9, 
  3.536264980262233*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom2", "=", 
  RowBox[{
   RowBox[{"eq2", "/.", "solR"}], "/.", "solP"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "dC"}], " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  FractionBox[
   RowBox[{"d2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}]}], "-", 
      RowBox[{"g", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        OverscriptBox["\<\"j\"\>", "^"]}]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l1", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q1", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "mc", " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "1"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "1"]}], " ", 
       RowBox[{
        SubscriptBox[
         OverscriptBox["b", "^"], "2"], ".", 
        SubscriptBox[
         OverscriptBox["c", "^"], "2"]}], " ", 
       RowBox[{
        SuperscriptBox["q2", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}]}], "-", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "1"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "1"]}], " ", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["b", "^"], "2"], ".", 
      SubscriptBox[
       OverscriptBox["c", "^"], "2"]}]}]}]]}]], "Output",
 CellChangeTimes->{3.5184536122924*^9, 3.518453710822*^9, 
  3.536264980312374*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom3", "=", "eq8"}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mh", " ", 
   RowBox[{
    OverscriptBox["\<\"j\"\>", "^"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "2"]}]}], "+", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "1"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "2"]}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"l3", " ", "mh", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["b", "^"], "2"], ".", 
    SubscriptBox[
     OverscriptBox["t", "^"], "2"]}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"l3", " ", "mh", " ", 
   RowBox[{
    SuperscriptBox["q3", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184536138992*^9, 3.5184537119296*^9, 
  3.536264980393963*^9}]
}, Open  ]],

Cell["\<\
The last thing we need to do is transform the unresolved Dot product and \
simplify the results.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"transform", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "//.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"t", "[", "1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"t", "[", "2", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"q3", "[", "t", "]"}], "]"}]}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], "+", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", "1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", "2", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}], " ", 
        RowBox[{"b", "[", "1", "]"}]}], "+", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"b", "[", "2", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Cos", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}]}], " ", "i"}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "j"}]}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", "2", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "j"}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"q1", "[", "t", "]"}], "]"}], " ", "i"}]}]}]}], 
    "}"}]}]}]], "Input",
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom1", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"transform", "[", "eom1", "]"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "d1", " ", "g", " ", "mb", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
    RowBox[{"2", " ", "g", " ", "l1", " ", "mc", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
    RowBox[{"d1", " ", "g", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
    RowBox[{"g", " ", "l2", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
    RowBox[{"d1", " ", "g", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"q1", "[", "t", "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
    RowBox[{"g", " ", "l2", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"q1", "[", "t", "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"d1", "+", "l2"}], ")"}], " ", "mh", " ", 
        RowBox[{"(", 
         RowBox[{"l3", "+", 
          RowBox[{"l2", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", "dC", " ", 
     RowBox[{
      SuperscriptBox["q2", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", "d1", " ", "l3", " ", "mh", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", "l2", " ", "l3", " ", "mh", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{
     RowBox[{
      SuperscriptBox["q1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "dB"}], "+", 
       RowBox[{"4", " ", "d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{
         SuperscriptBox["q2", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{"d1", "+", "l2"}], ")"}], " ", "l3", " ", "mh", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
        RowBox[{
         SuperscriptBox["q3", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", "B33", " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["d1", "2"], " ", "mb", " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["l1", "2"], " ", "mc", " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{"d1", " ", "l2", " ", "mh", " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{
     SuperscriptBox["l2", "2"], " ", "mh", " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"d1", " ", "l2", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", 
       RowBox[{"q3", "[", "t", "]"}]}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["l2", "2"], " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", 
       RowBox[{"q3", "[", "t", "]"}]}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["q2", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184536184231997`*^9, 3.5184537170464*^9, 
  3.536264981849856*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom2", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"transform", "[", "eom2", "]"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d2"}], " ", "g", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{
     RowBox[{"q1", "[", "t", "]"}], "+", 
     RowBox[{"q2", "[", "t", "]"}]}], "]"}]}], "-", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"dC", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["d2", "2"], " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["d2", "2"], " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["q2", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184537184816*^9, 3.536264981983507*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eom3", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"transform", "[", "eom3", "]"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "mh"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"g", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"q1", "[", "t", "]"}], "+", 
       RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
    RowBox[{"l2", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"l3", "+", 
       RowBox[{"l2", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
     RowBox[{
      SuperscriptBox["q1", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"l3", " ", 
     RowBox[{
      SuperscriptBox["q3", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184537196672*^9, 3.536264982050955*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solve and Interpret", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
Before we proceed with the numerical solution, we will generate a function \
for the tension in the sling so that we can keep the model within its realm \
of validity.  From the force equations above we have:\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Stemp", "=", 
  RowBox[{"transform", "[", 
   RowBox[{"S", "/.", "solS"}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{"l3", " ", "mh", " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", "l3", " ", "mh", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}], " ", 
   RowBox[{
    SuperscriptBox["q3", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"l3", " ", "mh", " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q3", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184537263283997`*^9, 3.5362649820765743`*^9}]
}, Open  ]],

Cell["\<\
The variables and their first derivatives can be found via the numerical \
solution, the acceleration term needed in the tension above can be found from \
the EOMs above and the numerical solution to the equations of motion\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"algSol", "=", 
  RowBox[{"First", "[", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eom1", "==", "0"}], ",", 
       RowBox[{"eom2", "==", "0"}], ",", 
       RowBox[{"eom3", "==", "0"}]}], "}"}], ",", 
     RowBox[{
      SuperscriptBox["q1", "\[DoublePrime]",
       MultilineFunction->None], "[", "t", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["q2", "\[DoublePrime]",
         MultilineFunction->None], "[", "t", "]"}], ",", 
       RowBox[{
        SuperscriptBox["q3", "\[DoublePrime]",
         MultilineFunction->None], "[", "t", "]"}]}], "}"}]}], "]"}], 
   "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["q1", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
   RowBox[{"-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "d2"}], " ", "g", " ", "mc", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"q2", "[", "t", "]"}]}], "]"}]}], "-", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dC", " ", 
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "C33"}], "-", 
          RowBox[{
           SuperscriptBox["d2", "2"], " ", "mc"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "d1"}], " ", "g", " ", "mb", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{"g", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{
           FractionBox["1", "2"], " ", "d1", " ", "g", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{
           FractionBox["1", "2"], " ", "g", " ", "l2", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", "d1", " ", "g", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", "g", " ", "l2", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{"d1", "+", "l2"}], ")"}], " ", "mh", " ", 
              RowBox[{"(", 
               RowBox[{"l3", "+", 
                RowBox[{"l2", " ", 
                 RowBox[{"Cos", "[", 
                  RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"dC", " ", 
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"d1", " ", "l3", " ", "mh", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"l2", " ", "l3", " ", "mh", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", "dB"}], "+", 
             RowBox[{"4", " ", "d2", " ", "l1", " ", "mc", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
              RowBox[{
               SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{"d1", "+", "l2"}], ")"}], " ", "l3", " ", "mh", " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
              RowBox[{
               SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
         ")"}]}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "C33"}], "-", 
          RowBox[{
           SuperscriptBox["d2", "2"], " ", "mc"}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "C33"}], "-", 
          RowBox[{
           SuperscriptBox["d2", "2"], " ", "mc"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "B33"}], "-", 
          RowBox[{
           SuperscriptBox["d1", "2"], " ", "mb"}], "-", 
          RowBox[{
           SuperscriptBox["l1", "2"], " ", "mc"}], "-", 
          FractionBox[
           RowBox[{"d1", " ", "l2", " ", "mh"}], "2"], "-", 
          FractionBox[
           RowBox[{
            SuperscriptBox["l2", "2"], " ", "mh"}], "2"], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", "d1", " ", "l2", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", 
             RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           SuperscriptBox["l2", "2"], " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", 
             RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}]}], ")"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5184537281692*^9, 3.536264982233923*^9}]
}, Open  ]],

Cell["\<\
So the tension can now be written without the acceleration as:\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Stemp", "=", 
  RowBox[{"Stemp", "/.", "algSol"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{"l3", " ", "mh", " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q1", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", "l3", " ", "mh", " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}], " ", 
   RowBox[{
    SuperscriptBox["q3", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"l3", " ", "mh", " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["q3", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"l2", " ", "mh", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"Cos", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Sin", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "d2"}], " ", "g", " ", "mc", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"q2", "[", "t", "]"}]}], "]"}]}], "-", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dC", " ", 
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "C33"}], "-", 
          RowBox[{
           SuperscriptBox["d2", "2"], " ", "mc"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "d1"}], " ", "g", " ", "mb", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{"g", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{
           FractionBox["1", "2"], " ", "d1", " ", "g", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{
           FractionBox["1", "2"], " ", "g", " ", "l2", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", "d1", " ", "g", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", "g", " ", "l2", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{"d1", "+", "l2"}], ")"}], " ", "mh", " ", 
              RowBox[{"(", 
               RowBox[{"l3", "+", 
                RowBox[{"l2", " ", 
                 RowBox[{"Cos", "[", 
                  RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"dC", " ", 
           RowBox[{
            SuperscriptBox["q2", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"d1", " ", "l3", " ", "mh", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"l2", " ", "l3", " ", "mh", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{
            SuperscriptBox["q1", "\[Prime]",
             MultilineFunction->None], "[", "t", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", "dB"}], "+", 
             RowBox[{"4", " ", "d2", " ", "l1", " ", "mc", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
              RowBox[{
               SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{"d1", "+", "l2"}], ")"}], " ", "l3", " ", "mh", " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
              RowBox[{
               SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
         ")"}]}]}], ")"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"d2", " ", "l1", " ", "mc", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "C33"}], "-", 
        RowBox[{
         SuperscriptBox["d2", "2"], " ", "mc"}], "+", 
        RowBox[{"d2", " ", "l1", " ", "mc", " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "C33"}], "-", 
        RowBox[{
         SuperscriptBox["d2", "2"], " ", "mc"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "B33"}], "-", 
        RowBox[{
         SuperscriptBox["d1", "2"], " ", "mb"}], "-", 
        RowBox[{
         SuperscriptBox["l1", "2"], " ", "mc"}], "-", 
        FractionBox[
         RowBox[{"d1", " ", "l2", " ", "mh"}], "2"], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["l2", "2"], " ", "mh"}], "2"], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", "d1", " ", "l2", " ", "mh", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", 
           RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["l2", "2"], " ", "mh", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", 
           RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
        RowBox[{"d2", " ", "l1", " ", "mc", " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.518453731414*^9, 3.536264982272331*^9}]
}, Open  ]],

Cell["\<\
We also will need to observe the projectiles velocity vector as it swings.  \
We want to maximize the velocity at release.  Here are the x and y components.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vhxTemp", "=", 
  RowBox[{"transform", "[", 
   RowBox[{
    RowBox[{"DvDt", "[", 
     RowBox[{"N", ",", 
      RowBox[{
       RowBox[{"l2", " ", 
        RowBox[{"b", "[", "1", "]"}]}], "+", 
       RowBox[{"l3", " ", 
        RowBox[{"t", "[", "1", "]"}]}]}]}], "]"}], ".", "i"}], 
   "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"l2", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"l3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["q1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "+", 
     RowBox[{
      SuperscriptBox["q3", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184537330364*^9, 3.536264982299172*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vhyTemp", "=", 
  RowBox[{"transform", "[", 
   RowBox[{
    RowBox[{"DvDt", "[", 
     RowBox[{"N", ",", 
      RowBox[{
       RowBox[{"l2", " ", 
        RowBox[{"b", "[", "1", "]"}]}], "+", 
       RowBox[{"l3", " ", 
        RowBox[{"t", "[", "1", "]"}]}]}]}], "]"}], ".", "j"}], 
   "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"l2", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"l3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["q1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "+", 
     RowBox[{
      SuperscriptBox["q3", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184537339256*^9, 3.5362649823499403`*^9}]
}, Open  ]],

Cell["\<\
As one more step to make the evaluation of the tension easier and to avoid \
numerical differentiation of a numerical solution we will generate first \
order equations of motion by rasing the number of variables to six.  This way \
the angular velocites and angles will be output from NDSolve instead of just \
angles.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"eom1", "=", 
  RowBox[{"eom1", "//.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w1", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w2", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w3", "[", "t", "]"}]}]}], "}"}]}]}], "\n", 
 RowBox[{"eom2", "=", 
  RowBox[{"eom2", "//.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w1", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w2", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w3", "[", "t", "]"}]}]}], "}"}]}]}], "\n", 
 RowBox[{"eom3", "=", 
  RowBox[{"eom3", "//.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[DoublePrime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{
       SuperscriptBox["w3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w1", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w2", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w3", "[", "t", "]"}]}]}], "}"}]}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "d1", " ", "g", " ", "mb", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
    RowBox[{"2", " ", "g", " ", "l1", " ", "mc", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
    RowBox[{"d1", " ", "g", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
    RowBox[{"g", " ", "l2", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
    RowBox[{"d1", " ", "g", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"q1", "[", "t", "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
    RowBox[{"g", " ", "l2", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"q1", "[", "t", "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"d1", "+", "l2"}], ")"}], " ", "mh", " ", 
        RowBox[{"(", 
         RowBox[{"l3", "+", 
          RowBox[{"l2", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{"w1", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", "dC", " ", 
     RowBox[{"w2", "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{"w2", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", "d1", " ", "l3", " ", "mh", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{"w3", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"2", " ", "l2", " ", "l3", " ", "mh", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{"w3", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{
     RowBox[{"w1", "[", "t", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "dB"}], "+", 
       RowBox[{"4", " ", "d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"w2", "[", "t", "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{"d1", "+", "l2"}], ")"}], " ", "l3", " ", "mh", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"w3", "[", "t", "]"}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", "B33", " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["d1", "2"], " ", "mb", " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["l1", "2"], " ", "mc", " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{"d1", " ", "l2", " ", "mh", " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "-", 
    RowBox[{
     SuperscriptBox["l2", "2"], " ", "mh", " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"d1", " ", "l2", " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", 
       RowBox[{"q3", "[", "t", "]"}]}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["l2", "2"], " ", "mh", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"2", " ", 
       RowBox[{"q3", "[", "t", "]"}]}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["w2", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184537357195997`*^9, 3.536264982379553*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "d2"}], " ", "g", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{
     RowBox[{"q1", "[", "t", "]"}], "+", 
     RowBox[{"q2", "[", "t", "]"}]}], "]"}]}], "-", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{"w1", "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"dC", " ", 
   RowBox[{"w2", "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["w1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["d2", "2"], " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["w1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"d2", " ", "l1", " ", "mc", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
   RowBox[{
    SuperscriptBox["w1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"C33", " ", 
   RowBox[{
    SuperscriptBox["w2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["d2", "2"], " ", "mc", " ", 
   RowBox[{
    SuperscriptBox["w2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184537357195997`*^9, 3.536264982382874*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "mh"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"g", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{
       RowBox[{"q1", "[", "t", "]"}], "+", 
       RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
    RowBox[{"l2", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{"w1", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"l3", "+", 
       RowBox[{"l2", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
     RowBox[{
      SuperscriptBox["w1", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"l3", " ", 
     RowBox[{
      SuperscriptBox["w3", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5184537357195997`*^9, 3.5362649823849373`*^9}]
}, Open  ]],

Cell["\<\
The three extra eoms are simple the kinematic differntial equations.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"eom4", "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox["q1", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}], "-", 
   RowBox[{"w1", "[", "t", "]"}]}]}], "\n", 
 RowBox[{"eom5", "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox["q2", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}], "-", 
   RowBox[{"w2", "[", "t", "]"}]}]}], "\n", 
 RowBox[{"eom6", "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox["q3", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}], "-", 
   RowBox[{"w3", "[", "t", "]"}]}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"w1", "[", "t", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["q1", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184537387771997`*^9, 3.536264982483554*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"w2", "[", "t", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["q2", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184537387771997`*^9, 3.536264982485684*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"w3", "[", "t", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["q3", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}]}]], "Output",
 CellChangeTimes->{3.5184537387771997`*^9, 3.536264982487289*^9}]
}, Open  ]],

Cell["Making tension and velocity ready to take the results too.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tension", "[", "t_", "]"}], "=", 
  RowBox[{"Stemp", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w1", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w2", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w3", "[", "t", "]"}]}]}], "}"}]}]}], "\n", 
 RowBox[{
  RowBox[{"vhx", "[", "t_", "]"}], "=", 
  RowBox[{"vhxTemp", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w1", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w2", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w3", "[", "t", "]"}]}]}], "}"}]}]}], "\n", 
 RowBox[{
  RowBox[{"vhy", "[", "t_", "]"}], "=", 
  RowBox[{"vhyTemp", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["q1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w1", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q2", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w2", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       SuperscriptBox["q3", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
      RowBox[{"w3", "[", "t", "]"}]}]}], "}"}]}]}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "g"}], " ", "mh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}]}], "+", 
  RowBox[{"l3", " ", "mh", " ", 
   SuperscriptBox[
    RowBox[{"w1", "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"l2", " ", "mh", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        RowBox[{"q1", "[", "t", "]"}], "]"}], "2"]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"w1", "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", "l3", " ", "mh", " ", 
   RowBox[{"w1", "[", "t", "]"}], " ", 
   RowBox[{"w3", "[", "t", "]"}]}], "+", 
  RowBox[{"l3", " ", "mh", " ", 
   SuperscriptBox[
    RowBox[{"w3", "[", "t", "]"}], "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"l2", " ", "mh", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"Cos", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Sin", "[", 
          RowBox[{"q1", "[", "t", "]"}], "]"}], "2"], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d2", " ", "l1", " ", "mc", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "d2"}], " ", "g", " ", "mc", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"q2", "[", "t", "]"}]}], "]"}]}], "-", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{"w1", "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dC", " ", 
           RowBox[{"w2", "[", "t", "]"}]}]}], ")"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "C33"}], "-", 
          RowBox[{
           SuperscriptBox["d2", "2"], " ", "mc"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "d1"}], " ", "g", " ", "mb", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{"g", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{
           FractionBox["1", "2"], " ", "d1", " ", "g", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{
           FractionBox["1", "2"], " ", "g", " ", "l2", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", "d1", " ", "g", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", "g", " ", "l2", " ", "mh", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"q1", "[", "t", "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"q3", "[", "t", "]"}]}]}], "]"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "d2", " ", "l1", " ", "mc", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "[", "t", "]"}], "]"}]}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{"d1", "+", "l2"}], ")"}], " ", "mh", " ", 
              RowBox[{"(", 
               RowBox[{"l3", "+", 
                RowBox[{"l2", " ", 
                 RowBox[{"Cos", "[", 
                  RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"w1", "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"dC", " ", 
           RowBox[{"w2", "[", "t", "]"}]}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{"w2", "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"d1", " ", "l3", " ", "mh", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{"w3", "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"l2", " ", "l3", " ", "mh", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{"w3", "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{"w1", "[", "t", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", "dB"}], "+", 
             RowBox[{"4", " ", "d2", " ", "l1", " ", "mc", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
              RowBox[{"w2", "[", "t", "]"}]}], "+", 
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{"d1", "+", "l2"}], ")"}], " ", "l3", " ", "mh", " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
              RowBox[{"w3", "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}]}], 
      ")"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"d2", " ", "l1", " ", "mc", " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q2", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "C33"}], "-", 
        RowBox[{
         SuperscriptBox["d2", "2"], " ", "mc"}], "+", 
        RowBox[{"d2", " ", "l1", " ", "mc", " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "C33"}], "-", 
        RowBox[{
         SuperscriptBox["d2", "2"], " ", "mc"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "B33"}], "-", 
        RowBox[{
         SuperscriptBox["d1", "2"], " ", "mb"}], "-", 
        RowBox[{
         SuperscriptBox["l1", "2"], " ", "mc"}], "-", 
        FractionBox[
         RowBox[{"d1", " ", "l2", " ", "mh"}], "2"], "-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["l2", "2"], " ", "mh"}], "2"], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", "d1", " ", "l2", " ", "mh", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", 
           RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["l2", "2"], " ", "mh", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", 
           RowBox[{"q3", "[", "t", "]"}]}], "]"}]}], "+", 
        RowBox[{"d2", " ", "l1", " ", "mc", " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"q2", "[", "t", "]"}], "]"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184537406804*^9, 3.536264982618761*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"l2", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
   RowBox[{"w1", "[", "t", "]"}]}], "+", 
  RowBox[{"l3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"w1", "[", "t", "]"}], "+", 
     RowBox[{"w3", "[", "t", "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184537406804*^9, 3.536264982623989*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"l2", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
   RowBox[{"w1", "[", "t", "]"}]}], "+", 
  RowBox[{"l3", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q1", "[", "t", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"q3", "[", "t", "]"}], "]"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"w1", "[", "t", "]"}], "+", 
     RowBox[{"w3", "[", "t", "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5184537406804*^9, 3.536264982625474*^9}]
}, Open  ]],

Cell["Define the constants.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"l1", "=", "5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l2", "=", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"d1", "=", "2.5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mb", "=", "100"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"B33", "=", 
   RowBox[{
    FractionBox["1", "12"], " ", "mb", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"l1", "+", "l2"}], ")"}], "2"]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"dB", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"d2", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mc", "=", "1300"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"boxH", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"boxL", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"C33", "=", 
   RowBox[{
    FractionBox["1", "12"], " ", "mc", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["boxL", "2"], "+", 
      SuperscriptBox["boxH", "2"]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"dC", "=", ".4"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l3", "=", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mh", "=", "100"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"g", "=", "9.81"}], ";"}]}], "Input",
 AspectRatioFixed->True],

Cell["Initial conditions and final time.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"W1o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Q1o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"W2o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Q2o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"W3o", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Q3o", "=", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", "\[Pi]"}], "4"]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"tf", "=", "10"}], ";"}]}], "Input",
 AspectRatioFixed->True],

Cell["Numerical solution to the equations of motion.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"eom1", "==", "0"}], ",", 
      RowBox[{"eom2", "==", "0"}], ",", 
      RowBox[{"eom3", "==", "0"}], ",", 
      RowBox[{"eom4", "==", "0"}], ",", 
      RowBox[{"eom5", "==", "0"}], ",", 
      RowBox[{"eom6", "==", "0"}], ",", 
      RowBox[{
       RowBox[{"w1", "[", "0", "]"}], "==", "W1o"}], ",", 
      RowBox[{
       RowBox[{"w2", "[", "0", "]"}], "==", "W2o"}], ",", 
      RowBox[{
       RowBox[{"w3", "[", "0", "]"}], "==", "W3o"}], ",", 
      RowBox[{
       RowBox[{"q1", "[", "0", "]"}], "==", "Q1o"}], ",", 
      RowBox[{
       RowBox[{"q2", "[", "0", "]"}], "==", "Q2o"}], ",", 
      RowBox[{
       RowBox[{"q3", "[", "0", "]"}], "==", "Q3o"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"q1", ",", "q2", ",", "q3", ",", "w1", ",", "w2", ",", "w3"}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "tf"}], "}"}], ",", 
    RowBox[{"MaxSteps", "\[Rule]", "5000"}]}], "]"}]}]], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"q1", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}], ",", 
    RowBox[{"q2", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}], ",", 
    RowBox[{"q3", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}], ",", 
    RowBox[{"w1", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}], ",", 
    RowBox[{"w2", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}], ",", 
    RowBox[{"w3", "\[Rule]", 
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "10.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
       "]"}],
      False,
      Editable->False]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5184537466552*^9, 3.536264982881692*^9}]
}, Open  ]],

Cell["Plot the coordinates for each degree of freedom.", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"q1", "[", "t", "]"}], "/.", "sol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"q2", "[", "t", "]"}], "/.", "sol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"q3", "[", "t", "]"}], "/.", "sol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"tension", "[", "t", "]"}], "/.", "sol"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"vhx", "[", "t", "]"}], "/.", "sol"}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"vhy", "[", "t", "]"}], "/.", "sol"}], ")"}], "2"]}]], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"ArcTan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"vhx", "[", "t", "]"}], "/.", "sol"}], ",", 
     RowBox[{
      RowBox[{"vhy", "[", "t", "]"}], "/.", "sol"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}]}], "Input",
 AspectRatioFixed->True],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUl3k8lG8Xxmex72NfxwxCiGjV4hyKslQSpX5SKVGktBelpEiJFkuIspSS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {0., 2.41521313994194}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184537495724*^9, 3.536264983034563*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUl3c81d8fx++9XOsS1x4XN4SQSlIk511GGe2M5KuoUCLSskoayiZSdptS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-3.509366144414826, 0.44022341150772465`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184537495724*^9, 3.536264983040719*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV13c81P8fAHB39t53xhk5IURKhcbnRSEjDfQtyUookUQipSKSLatlV1Kk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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-2.3561944901923195`, 5.890728531130236}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184537495724*^9, 3.536264983045484*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUV3c81e8Xt/e495pXMpJIMoqMyuegKYQvUklIRDJKIpKQVdY1r713XHvG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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-4295.204063940263, 8948.803341774947}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184537495724*^9, 3.5362649837053757`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUmHk8lG8Xxu1kN/Z9sg1jMMY2pJ6rVFK0KEslZUnKEioVKlGUbImIKIUk
0apSyRrZUqSSIlSW+GWXJe/z/uXz/czMfZ/lOuc+x1L3g/Z7uTg4ON7ycHD8
/2/mSXc+Q88LK0y+rrNok6peUd1KtXWi7ifWpQRefO5zg1h8XRZJpR4nrj6U
irri84DILI9T5aWeJ87NyvyX6VNJ+C4/4jeteoUIvvVbfcrnPdE65538R/U2
IaB570eIXw/B/6WHNqz6jBDhaevLOzRGZNdfCxxSfUPEzj+VaInlQlHx+S++
+h2EfTlN0qFVEoOUwdj1bh3EzepL6xLmJUELXr9CO7mDeOJ6hfVFUwrXLYWy
e/92EIVr9PluH5NC0ptYrx01X4ilVZVdaqrSCO5NGLV2+UrEb1i2ofKgDK4J
NURKrOkmuCxlrx5cKo99xLsrv4N6iWHh5k6hjyrguDFV+uVCLyGnOvFzgFcV
aTxKnfU5vcSM5CqO38aqqHvjpXK7vZfwaQsRcL2kCu1t8zf2WvQR+9+3FHLp
UNHvTSv8xvmDuLa/nsdtiIoDSSfKWhJ/EvUKWq0Z4WrgmrzR9er2T2J5ziLv
i3Q1pDvVcRRX/iSkZ9s7Jh+poV5J0ipu4idh3sl56smAGnRv5dfaOP8iWp7V
OYZsU8fv560tlar9xP1mmwJLAw34/9DpfVQ0QChV3essnNNEt+tngYo3A0Sc
Y12/lJIWtn46p9/UN0DcvSoXlWupBXbDr+M/FAaJnje8OStPaoH7fq64TPQg
oXtLJcyPm4a0sKUrju4eIi4vTsbUS2ujQlL+irn4MDGjG2RutZMO47i6sjW6
w0Qn/XYjz2k68viO9W1ZO0zYHxMOGcmjI/Zvu8GBsGGCk7vortk4HY5dya/T
+4eJd8sqP0bH6WKwQHxirnyE2DO6w1amjgHBpWdoXew/xPK4Ywtpaw1QZ3nR
4OSaP4QvU+d2kI8BopyzzJTt/xDfY9/bMhINwJX41Hqnzx/CJERxzuCzAWb/
/d73MfMPkV/XKRppzMRQp0P+W65RovLtDWnBMiYKZtzv+YuNEg3ZNi3BzUx4
SwU8FVEaJeSW/yXufWOib0NM3QaTUWKbFo9m+D8mOkvL+mv3jRJz8fqaTssM
kd7e8Mfr8CiRxy2377eNIZzHPs3wnh4lbo6oZCx3NkSbzrjA6vRRouhrgqrI
YUM0ptF0yhtHibKGL2tM8w0R88jYcPfnUeJZo+2T8EeGWNey0vzfj1GCvVXw
RFi5Iar5XWwsF0eJjXvaJc5+NESE+v4tX4TGiB38RpOJPYYAEbw9RG6MsFrF
FLUdNsSL4MT9Tw3HCKPPLq1vOVkIScoMdFoxRmy/FV6aJsQCu6jg+NT6McLt
ZKC5hDQLj35Unzf2HCMOOT72laSxcHfb39v3Lo8RNLn+7kBrFnwD+B5sujlG
7Gy1aG/cyAI9VrJ0pHiMmLY81f7NgYW8Kr16xpsxIp0dEavnwYJnl8X7hg9j
hLxs8ia//SyozVl3HOgZI6IeqVMPHGQhi+U+mD83RmQWrc/MDmHBZePBMWuB
ccIgqKK06xQLCgfCZn9KjRMXw9srv59h4XL2ZUFN/XEifmznfXY8C9te3qRU
W4wTl+M4tC4msUD5fE/Bw3qc+OB88/qjyyzEizfQs/eME2WdKfkeWSw8M1N+
vNF/nNgcWVxveYOFPteDxHzoOCFR1zrSlcuCeFTFm9vnxwnb0vqlm26zsOyu
5Dan1HHitMTmfbGFLHi17f3GkztOLHqte3ilmIWkuSfeDx6ME1pW2p3HHrDQ
b+NyQqR5nGjhWTX68AkLUoFF/M+/jBOuO6uYkqUsEGkcSd4D40RYaQrvhhcs
HHhlryQzPU5YlCcPupSR/v3MyavimSDa6vPY68tZqBCZZgZSJoi9/LOrpSpZ
+G1s81yFOkHY99TZvKhiQc4lY02j3gQxl9u9x6qGBavI4bfHl00QQRP22QWv
WfAvIHbQbCaI42V6/OO1LKS/u9jX5jhBhKVLBSq/YaFmptc/wnOCCH3S9Zxe
z8IfVdO/BkEThGSdX4FiAwtK1uciv56aIN5pivz8Q7K1f4fIhbgJ4uIradk7
jSwEpTDS2BkTxPeT1U3rm8h8vjip9jN/giipnjzTQvKb3pbCSyUTRF/8yieW
zSxMCKqbrayeIAbckt4kkExlHakYeTdBnFh5Raye5A3bazdc7ZogOCZHvw6R
HBwu324zPEHs8isNniT5xi2fPdOzE8TgMxHBXyQ3Nb8czBGYJGQ+N70pJ3lm
UuyIvcwk0fBmQ18EyerK7ouL6pNEypkLAXokb1z96Pxdw0lC40zm6XLSvhAf
PqmdxCSRPKKoZ0lybpJzloDdJMHqajl1nfSv5VmBdsmOSeLEZ/ljw6T/893z
Dzy8J4mf/mXS6iTTBDYtlwieJFSj/9u+koyfvUF2bVnkJGGcsGTZOjK+Jx3H
t/henCSGkkMLzOpYuH1iTaf8tUlCusjhqhiZj7acVK/awkniP4d57hYyfxyN
A38Ol04SnPNvG49Vs6A7vixUrW6S6Gtp6VlC5ttRIZ635cMkEVOz3ziygqxP
b5aC7ugk0a4TytYn9fMp4UzOp3+ThJwHtXw3qS+eJ+36UcJThPqNlazjpP52
8IZafadNEUWnXKI9SliIYjQ1xZtMEfFln9caP2Lh/lZVZ0urKYKQMy/4fZ8F
gRtVvqmuU4TK8FktqbssGL2Rnl7tO0XkFLzUiSxgwfXPvtNjx6eIJ4escz/f
YuHxCuHLdilTxL/Mkcn/15f7l22vuBuniA+n38p8TWFBMOO7X+DnKeLCfYXH
qWS9Ptjhr9T1c4qo8k5rtUhggbsj+ngp5zTBvSDfY3GOhZxPpUaBZtOERAPB
pXmcBds0655vq6cJxpa4nVpHSD05tSXa2k8TFk9KqRKBLKz5ODxM85smSvec
u3XTm4WfH6j5325ME86lO/dUOpL9IOWuo+29aeINS+WVlD0Lpg4WvKUvpwmr
14J29nYsRLdtdU/5NE3MT/dQEq1Y0G6NUrIVnSFMFja3qRiQ9dryO/HZ8Rki
Paag/gMX2W8SjxO06BmikXZnJ9eCIUo38Y0kJ88QTd1ZL1SnDSH0VnVDQPEM
Yakrl6Q/ZIjCJnte2o8ZYnHWTDv/vSFG6p8eT978l/g8m8rldc0QgTVn3A/S
Zgnmg3/njrEModK3lm/KaJY48TquekjXEA1cSwrCMEtYi/Kq79A0hCbiRs9v
nyWMpwuiteUM8bk0JTznwixh5TurH7fAxMp7eVmf/5sldmulWYfVMiGRUddh
9XSO2GG81MnHmYmyZzEn66vniE8Rpy32bmHC55Ot2pZ3c0Sh77OTruuZqJF+
t991cI5YeaWxa7MlE8cTP88cU5onAqW7GauoTHw/OyhTFD5PfCE+ymS9M8D9
AOGtcjYLxLfeDw37OA3QmC55/K7jArF6aY7N+gl9/KxWuLbKc4Gw1Pr6eesv
fSjI6wz5nlog+DSzZLub9HGmYk1kxeMFwlgupm78qj6yhmxvO1YtEFO/3J21
LurjqfS2t0MtC8SuheTus2f1MbzfXVHm9wLx8cZ8apO/Phwppx4eUPtHBPgi
NtpKHwGWUZ8XDf4R85w+F+nm+ojxiltMXv6PWF14Yfu8vj5elWZseOX8j2gS
qu3WVdSHtsfTXsmEf4SzfMaNkkk9zD4clXw594/YPv2CMHmoB6lvM+b2SxaJ
EE+WTd4dPegLcOz5JbNIVB0sCEKOHjxcRAslWItE5taOm8Mpemjk0V3t5b1I
FJS6DciH6uGnPuvA3JFFIsKknVZ5WA8c280TEyMXicu1Mvbx/nowuWvdWZq1
SFg0OF5McNdDloPnYbEPi8T2d+I2arZ6eHrKJz2nZ5H4d/UK0b5WD623g8rN
/ywSN0KfxuSv1APPKfA94OXAwaert+Wa6YHdutG+k8qBgLDeB7819LDG2/5H
Ho0DFy6nG4VT9WC/4HAsUJ8Dr+7sustQ0oMvbVcWnyUHWFNr+Zsl9ZAd6jPI
dOLA9QtPrZby6IFZvmQmehcH+gXSBm9z6KGcJ5+3y4MD0Y2a5qsXGOiO66PG
BXCgbb+bWOEUAyrXdzkNnOcAPflLn+UgA0V9c55I5MAdn9c81r8YWK6THpR6
mQP1d/7F7e5jwOVBe9yam+T5tSv8Sr8xkF69qTr7BQekh+1/i7QxQF8y8m6m
kgNHBcNaTr9j4JldbNemNxyY+kA7y/mWgU/tdbMLHzggMKq5Rr2eAZmBlYY7
/uPAk00/RvvLGUgSMc6iqHEiaNej7xvuMaBm//7Ofm1O+FGcvu8pYuD+5YBn
5fqckFZM33eykIEW1btt/ss4kdTjHPM+nwFRlpZQwzZOFAlfp3VmM5AVXC2n
tpMTrv4OW1jXGdB77q513I0TAVXWyxOzGLBdfW0lzZ8TWWcFl3pkMBDjKHcs
MpoTcXrKfz1SGFDIKDnbEceJ3L+23NOXGLjdte2SYTInWsc8Ey8mMVDnfbGo
6zonLD6uM/+awABfqOCPZaWcKCnxcHkbw8DlV/ljSeWc0P34l+faeQY0eaw5
Bl9zwugJxS/4HAOr4yIV01o5Ueza+sIyioGIa/NbJn5zgmd35WmdCAY2M58G
6o5zwvu77a/lp8l8VRy66P6XExde6ezbEc5Aac9gSwsvF0y7lWmFJxk4dyjv
D78wF4yXOtz8foIBRx53cYLChTxe/geqJI9pft50V4ULa6itYiWhDJSXJB/s
0+DCm9iBfFGS4603JyjqcsHyiOq+gBAy35+Eiu0NuSDX/Cboy3Eyv/trm8+b
ceHk9NHJTSTP/I0YKV/OBY7iIfnmYwy8jlkhOmPFBeHrIsKOJCcrzuoZrOeC
z70Tf38dZcC98LGd12YuvHwuKnmGZObyQL9MRy4ojVMu0En+18SIa3PhQnzT
fPKXYAYaXfsLhTy4kDbptDeV5PT/bjau2s+FmIOVhq4ke4fv/n38IBfeTf1g
Mkk2lVAUvn+EC7Ez/ukiJPPcaNftD+XCUNHsrakjDLxnJW1QjeBCtg5f6hDJ
16vsfBzPcSEzPjrvN8n+25ZciIvnwqbwQJlZki1/VBdUJ3Oh+cBdmhR5nmBw
eP1cOhcKuWWUlpH8ic9ykJXNhXNzgaYHSc5LnV5y4BYXlnH6ld4j+bD2Q53s
u1xY0dU1vEjyymf+Np8ekvnptVLcRforup6+X6yUC32aF+PrSO7s+HFubTkX
NstfS15Fxq/AJzv/xGsuJMpRQxtIPjbvUveokQsGmpmJHmT818bJ9Q+954LM
u0ANITJfUipt/OqfuXBauTaqkuR7xAbriz+4cCH3MZ97GAMnW/j21Q1xYdbp
64f1pB5s3SqjFke50BW++G41qR+FsRN5pjNciIap4+ZTDPRHmL/2+8cFZaVd
ZX6k3kokJ3/k8HCDwSm6L5PU45mce7ydgtxwG8m820Xqlfqatma9LDfuPr2Y
nnmWgRHHXs/Tyty4fHNMVCGagRe/ss48VedG8MTDJwWk/p2XyFRrMbnRcPDj
BsFYBrTS3/XuMuXGRVqxUEccAxP0OO4US25c/9Cc/4qsr0RbHituG270XN9o
0UzWo+vXV+4Wm7iR4WSgMEPWK8M/NCLQgRtl9mb55mlkfSaMVXS5cePhpSdF
vJkMcLR240UINwJ2+T5tvkXaP1CWHXKaG9Nllzl57zCwhCOTy/wcN0QCpDt2
kv2Gore9+nEKN5xmZvv9HjOQamWmefgqNxwnlh+nP2NAaYd0FOsmN5ITVe0E
X5L1Hf3OuvgeN/Lm1mea1pD5yyzO93vCDZNrhxPPvGFA/1HcEkYZN0aV8u/N
NDHA/m7TkN/ADbmCFl/HjwysX1a58cZPbnT4D32bH2Kgecv14j3D3PjOOGN9
cZSBrd4nxVUnuKF2bO/MlmmyPlMs3mdw8kCbY6/jTm49+P/3wCFFiQc8YuqM
HGU9jPFeLNmqzgPP/xoH75Hvy1Glg7IUOg+cYhJW/NHVQ7iN7ud4Mx7YftxS
t2SZHi7dvOlyzp4HS7pLrr7cqQe50tMv127nwTbe3SaHPfVwtWW3Cu8eHhzr
Klnp4aeHvAXF7tN+PIi4ejNk+BT5/jkle4Se40H8udPmlbf0YOkfVG2ewIMh
Td4B2wd6qDizWXMmhQdfXlpulHqph/r7wr8O3+TBvs/an3a06qFT6OwB/zKS
XXZavuHSxx41jwZGDQ8O5r7ftkJMHz/YKxlDDTygfFz2/A85D4zsXRje95kH
enh4SshUH5zlRwLdJnjgLVS2kc9PH1qHvY5to/PiRJTvlfk+fehZdG29xuSF
c5uKSMm4Pow5nA0GTXnxdMRkIJ7LAKtibX6esuJFepZR6yWqAVxzGNvuuPDi
CDwEE3cZ4HLbmAFXAi9kzDkVX380QGa6j5BdCi/ceV+rPPxpgJw9fT9TM3ix
Ildm2/FJAzz4/SFTL58XrXWnV1guYaKZ55nQ9gpeWB/lz6zRYOJDveGvm7W8
6AueO7hWl4nOxILKkSZeaMWc8bhiyMSg0tXjZzp44fJ41/dby5kY7ZFyeNvN
i8ZrAykuVkzM5McxFX6Rv7/dWvVhHRO8Jqd+FY+Tn3/NDxXYyoTw3HTl7F9e
dCa9e/DciQlKRUDWGg4+PBcpfqPlwoR89MDxRD4+nFHp6Vm7hwmqnbvDF2E+
jK07ayfvyQRN8gtTS5IPn7OqgjP2MaH/eatwoDwfLrzmFW84wCR13fjruSof
LmWn9uX6MWG5d00VnxYfEvZw89MDmLDSLcvawuCDa93TSocgJtaPmoZcZfFB
mDc7nnaYiS1Pih1+sflwmc0yyTrChPMJbUMWwYePP9LvPg1mYrdVtvCJNXx4
rPhqVfBRJryWKPTXbuAD95oy/3aS/d4mVVHs+bBF/TznZ5IPpwhd2+XMB5HQ
v39PkBy680xIvisfeH6FFtaQ50UsXXAY9+TD9WsP0++R953/dcRwhQ8fdix8
SSNIexLvjgifDyQ5+FbuIdLe1EP7+luP8sFcalZ4I+lPlnl3lcpJPgx/DEQL
6W/uovO1/Wf4YJzye3aOjEdhzbuQRzF8+LdOSqaVjNfDC+sdFxPJ85g/85zI
eJZuqTJcn8qH3/vO/bpAxrtC1lIkJZMP37xHTILIfNR9fdTfdZMPVu2qSiLk
/P/2pl41vYAPXxu+Gu8m89m+P+/akXt8ePqm28pnIxN9k6mOQi/5YHb5evIL
Ug83Vhod+lrFh60SfNtiSL3sjmtOKK7nw8lX8lWSZkx0aPC+2fqJD6uDK2T3
6zDxbmvQsqvjfPArszc/L0TuG/dtqXp0frisvaVx46IBUv04Bzem8qNxYdlJ
/6P62PbsKt/SLH40bDlbtMJLHxRetvp4Dj/CKRQvhoM+4q/6u6Q+4McrTju/
fUbkvtDwpbmriR9fQ9KWnB3VQ4BOycMAHgGk98xtwBFyPj+ypWWVkABCTxyX
Oualh6Hy37+lKAJQp+2p/+KkBy9nda1nqgIIvycbTSP7067oxDTOZQII5m0T
eU/2u/U/DpxIChRA5HdhPVeyv689oV64+pgAzEoEus9dZGCVdGfH1EkBHPv2
k7eTfI8s1tixd8YKoGCqI3DWn5xncg3G1W8JIPVR+3FRKwaE9k54P+4UgIjj
3CWrMV0ILBSm7usVgEvbpVWN/brgSdn7Wn5QADbCwo+Odulivrpd/eS0APKj
PnibNOnit8azb2spS6CricmVBbpo7Dux7ZP1EhTqOG7afEAXdWGmkTEblyC8
ROhUh7suqqX+u2/psASKATYDp3fq4sXqPWLZ7kvAiNNh0ux0UZizqn7/iSV4
WL1Tr8pQF/mWczOKZ5Zg2UJIrb6uLnLaHtKaY5agPPia1WMNXVzl0TzLSluC
1qaiZgk5XcR58mPuwRIIjdz5zsmhi5j5V/53ny3BYe8ki+WzdEQlH8vcXb4E
Ccc7fS9O0HGyemC2qmkJirUUAiIH6PDXaHwc278ELXcPPYpuo2NjX6Kuioog
VtZL9/YU0dGo29fmoiGIs8sSRToL6NhwyOxkBl0QxQK8gv15dKzj+tYiZyaI
N8sfj5hdo2MVVTdYcrMgxDzFnj9MpKN830lVe0dBuGhPVBNxdBDF7+oSXQTh
t7w57et5OixXHFMU3S+Ih13PaBsj6TBxqSkXiBDEjl/0+4vBdDy6KXfA+pwg
nFTOfJQ5TAdryEcyKl4QCaFj31cE0qEfQvHizhCEytU1yyp86NBO2y3076Eg
MoQ+0WPd6MjrevDIslQQGmoLV2m76dCk8bmGlguCnjGr1epCh1pJ4b2ZRkH0
Dytp7nCmQ6ntr8P4D0GssKlkaW6mI13RbtHwtyBOBd9pXrGRDnmP6/kBY4Lg
ZdnV7rOlQ2Zs7dzwP0HwOe88+msdHcnm6TkMXiHslWVxrbCmQ/L0sJ2PkBDe
T8Ym3lxDh7h48vV+WSH4ZxzfkbGKjninXzY0FSEIHKr11ltJh8g1i/G9GkLQ
EV67tJmgQ1D/+5pephAO5UguW7acjnNHjP9baiaEVacVA/gt6eB7GZ22Z7kQ
RGpeTH23oIPbVn/oq40QOnevTa9g0xFx6XSy0mYhbJxSiXltRgfHl7blOx2F
wHfhTuBnU1IPatq/rrgIwZN7xmLWhI75/aGJn9yFsE5701ttkkPuN5vL7hfC
W31T2b3GdPydWdrrcFAImVu9Z4uM6DiGI7HJR4TwIqh1Nx/JU9F1Jq2hQni2
aUzfh0XH4beKXRIRQuBRPLnlqyEd4zIHz20+JwS14qJ7LiQHuVYaJsQLYVG1
wXiAScefXOkvTclCuH1AsyaCZP9h7zPCGUKQgsw6HZKHjV/obcgm7f09c6PT
gA7fMLGP528J4ZXJ8tKrJA9WuYfX3SX9e/z60H6SVS9+OhD/SAg7LiSRQzUd
21w3Omx7LoST9CKmJsnndasJhUohjESOf5EjuWzGnN5dJ4Tj/de7FUgerymW
ynsrhOCorfK6JGtf0lz0aRcC48c7VxuSd+3JGDD8KgRajl/0EZKT9CTapnuF
MDk3d7CY5NrZqLKXg0JI6MqenCJ5vnY+P3JUCFm3s8c3kP4YpgRdspkRQgzN
0aqIZC/3/hNii0JQ5dF/oUzGJ8PA1fsDrzB+XL5llE5yy3yrfYawMHiU7U6o
k/Hlq7dZ7iYpDMLt/oFnJC9LfUWjKQij+JNvw04yHwGeJpRhqjA804f9BMn8
5RnemX9AE4aBvJpWDcnijZffrTARBk33iK4rqYc1V4Rf8FgKo3D1FyVLUi8h
XhF59auE0SwU6qtJ6qmPwz/UcbMwVs+NOsiTepNv7t2r5CSMsoDO0+rLyP6R
sX1zzy5hnGrSZrJJfT41WaPp70PaW+aiEb6CjtgDSm/PRgljerDG6YwVHRVm
Sc82xAlj7MLhDZ2rSf3wCORIJAtjs3nvgOVaOvZcGz+WmS0Mj92hMrI2dBi3
1as9fiGMJHNPX9omOr4uPx7cNyaMSw3ZJ46T9awv0a5stVsEyy1fu+Udp+Nn
3M+IlL0iaGaIqriG0pEpOP3rl48ICliRB6VO0CHMI/cg9pgITGPb7oSGk/qZ
2r62/aII6sP7UxjRdOR2fvXfXy2C88ZhvZ2X6HDZPtL6vF4Emd2bH+9KoUOq
/R9b9J0Igk5V63y+TNbbW1Xuh19FgNMlwa+ukPZXuqXOT4ng5n711LVkf1TK
//EqQUcUz+8s6BG36WjTmNLoMRDFWEjbvBfZXy9k88UYm4qiZJt9QcwdOmbT
ads+rxKFd+xe19q7dHyK29+v5iKKx5IbRmgP6EgUDLE74i6K8w0JCcRDOqyj
Yx7UeotCPnX8q/MjOkrC74T5HhFF3c39O1JK6Lh0aFi8JF4Uqzaod7k+p2P9
n4UjAimiYJ7T/nDnBR1cfqJfdmSIYldnYwx/GR3PBlRwN1sUxW0BgYdfkXry
MshdvCWKexZ7FybKyXroJQTti0Qh4PKz5kIlHV27Nx/MeSSK5PmPBcuqST1s
DzS3qRBFXF5v/Xgtqdf201kZtaLoS9ZYx11Px0v7JO6RJvL3vw4rWjT+v1/c
8EabKNqXXVx7tZkOhu3DpqQOUcwfXMbQf0fqr66K9aNbFM0e/MkTrWR9rGlL
Nfslig9PhYom2sl+SUy6dY6LosBjr/HTr2R/WqktUDIrCqx30+78TurBamdR
AqcYNA00/u7+SfaDtfHb9guI4cWR+UDbIToq11XMrhITQ7hnpsidP3QwN0xc
V5IRg9k+oYdnp+jIsqNZTymJwaVVNvjnPFkf9nGXbtPF8LTCS9RLSBf928rN
Iw3F0FNHXL4qqQtHp/EuF7YYEjWZJ88pkfPAdq0oU0IMg/r0ClMtXbBctjPE
14qBb92GqUdMXVx3jX0/YCuGovCs3RKWuhB1e3WsaqsYNj3Uat2xThdDezVr
gt3E4LB9/5FRD13s8Hb22ewtBo13SsO7DpHzx4ELEvSDYhAyWTE6GakLU7+y
J9zBYhDJvFnyJoWcJw6O7voaJoaASaWzA/m6oARp8DyJJO1v6U3e+1IX4Yed
ChJjxBC8h3PIrlUXLsdfTlmliSFH5N+lbG4G6kP/XFW+JoaWmtyzdBVyvz2p
bjWdK4aUhuT0HRYMSEWeTyh4KAb3LTad3UcZiDj7wuRMqRiOuWn2bbjCwJ/o
/77sqhDDqc7T26JfMNAY66At8VYMvkdDpc4K6MEi4Vzz4Acx8n34etrWUA/5
F58fru4Ug/6TIMsRcl89c3lpxdFBMaSHUO/dLdGDSssU4z8ucWj+WdE2Gq4P
hy3iHC584jh9u7Pw8BN9xL7Xaa1bIo7cmTftu/7Tx2yby/Eb4uKYPnskaMzd
AO2fK2scVMQh/HZ3YSOdCZGdnWmVS8Xxtnh27rcNE6s7J30MNMVxKSC7x3w/
Ew++aVOWMMQB2d4k8Xwm4nvjXV+Yi0Mhv3v9Ow1DWA/vmFZzIO9Pber5I8pC
llRk6ylncURO0Kev6rAwsexOcedOcSRZ/5Wqs2Lheszcvsvu4tgZMnsiNZiF
WdrVT0sCxLHIOH1Nt52FzZuqH3kdEsf64rrxT79ZyAv+nVgVLI7BoTvcYtxG
2FpjaXPihDiKGhzfqukbodD967M/MeK4d1tyeNMpI3DF8F62ixeHc/QF4fwk
Izjf1wsquCgOllfMpbxcI/BynKR7poljIeL999x6I7hmqmR8zBVHon9ZgriE
McQ/7Q4rKxeHH4/PPqskY3gtRjsrVotDKVVB50y2MV5o3TM+ViuOzJfWLWn3
jLH/CMewYbM4Uq09c1c3G6OSkr0r94s4Puk+k27hN8Fhu54VsVPiyPPKWF1y
2ASfKj05dzAkcO3rsjJrC1P8WdmhcMJAAjzHsy8KrzEFf8Um4+ssCZTWFn55
sckUpq8s9v1kSyB+z7lPXZ6mSH4u3hS0RgLp+7ICDeJNsenRi7QLrhIQ+aX7
4XenKbyMWA+K3CQQcUuL6vXTFCcf3Gp45ymBXIen+vX/maLwXtI/WR8J0Gq/
6thzmUHwrrdnzlEJRManzbpqmeF1rhTzZaIE7rE/DW49YIZvGjE23ZckEMZp
1usbZIbJm4vu3KkSWKUe3O0fYgaNG4MpNpkS4M6Y2acXY4aIrPK5D7clEGcW
ufZivhnSlU2l/xZK4OSS7KGRYjPcv3pHX+meBI5Lv04xfmKG7vTLbu4lEhj3
3OR1tMYMK1J9a0cqJbB2LWOgvdsMjjI93RKvJXDXZfB6wC8z+KU4zRq/kcBM
QghtdNgMVy+t0gt9K4GiNupw7qwZZhPkLvF3SiCJZhn5icIGRSy+kN4lAe9H
S5VuyrGhE8/92q5HAgMWFi/tVdhwjh2ZudQvgZTvx97t1mHj8blqV+qkBHZ3
VYlor2Ajf32DXPSMBBYjA0qPW7GRLvz+/fCcBAZ9rvXfWsdGeGLX2udcFNA7
gtip9mwcsv/JocZHwYPYD0WOTmx4SQ2XnltCAXfojOt/O9mwTZvVdxSn4Lp2
SkK+JxvEDs6BF5IUWLsWt772ZoOlJHBTXZaCHreK+8982ZC9Li07qkxBwIe/
D2QPsyHorvTOaSkFqhaHmk4dZWNeXf1CmQYFJ3w3MUpC2Oi5xVy8oEtBnulP
dlQ4Gx/2mz0b06cgk2fXC8VINup0VxzazqKAYn1K9OhZNkqHV+uVm1BQEk9p
S4lm427xhl9a5hT423UlHjnPxvVA++w4SwpuKAY6S15gI8lo+84JgoIpbX74
xrJxdnK39E4rCjbc3BBwIo6NY0+83laspWCF+I5aq3g2fI77nddeT4HHzT+d
z0l2XXbYKsGOgj97DTx6SN68ELIwuZkCDSdBuUckW706/cRlGwVd+x099Ug2
PX0usMqJggy1+3fWk+drWyXo0ndS8IUn6JgAeb8i7+Ufia4UjHVttfOIYUO0
9uq1aTcKCrleZDudY4Pz/M3trnspcD4aI9RD+juxvkCyxpuCKDmHZYsRbPwU
vt+k60sBm3+Yt/AUG5+bn0QnHaQgdSbR90coG42JZSv/BlHw8s2fW/lkvMvs
a+Z2B1NQsz+WOR7Exn2pxsevj1OQq7C9rtKPjZz29wf1TpD5dZONlCbzmZr2
WSc5nEL2lWPNA25sxOzo7p2NpKB9cd/xFaQewpR+ZbpFU2DIkf6cso2Ng9+G
nepiKLB9u8rMy5YN9+sTEgbxFDhsEOI1X83GNve5hpSLpJ4eRBVdWMaGxU8B
eKRR4DjDIfZYmw29fLHZNxkUeH80ZSSQ+qYekHnEvEbBz1TXof8k2eAdUdf+
l0vBIVrb380LZmiZXCF+5SEFcwIpmn/rzVD1ZE39YgkFuskFN31fmqHkuO0Z
r1IKfG96ukeT9ZuxsH3GqIK0zzKDpy7JDF68R7qbmylwSj04KeFoBgXVNx/n
3lHANNFy87I2QzNb+a32BwqGZSvEk9lmMPWteRnxhbTPp2hZnIIZ+FqlM0z7
KQhOy804+NUUuddLHLI4JTGauHFok7spnEsF7Rp4JLEo6ntSZqsphNtcV8/w
S8LY+krmf1amOMzPb2QvKonAzrrzPZqmWO3vJM6nKAkHHhqda8gEfctm6v2M
JeFUMFcbGGqCNAfbynQzSdgtWe6l7W8C24PXn9VaSGLs/LJqPjcTPLqxLn/p
SknwPy8NsrQ2wZklV85+sJPEiV1b4y9Jm0DjozmW75PE9F8Dj8Vnxvj0J87s
wAFJPFxSFLS62Bixgj36qX6S0Gr3CLufY4yJ5THKo4ckYaYsoc2VaIzqnI7Z
nHBJ8Owa1TvkbQyPoNDHwumSsPKNdjCgGsOU9e2xTqYkXMsC0odkjSE4hpK1
1yWRsa3CpFbMGPcC+Z6E50miNb/VqWPRCPMBF59OPJBE/Iixu9t3I1w+eOt5
Z4Mkyt7Khh6/bYT9BoIv/jZLwud3UcvgDSNY/uf7Qua9JP7Yu3QEXTVCrz/r
5eZPkrh6ofRbdYIRmP4vy6r7JOFLWXrb7agR3vi2VhQuSEKs8a68wHojXGWY
Vr7hkMJ23ytCuauNEPA7rfIntxToGimOmwkjyPi6VlEFpbBxswxni7ER3H0G
qpNlpBC0eF3ai0rau3+xNsxACksP9i8/85cFg326zbZuUkjrkf1w6h4L3/ar
HrzrKYWFWOHN+XdYiPWVFBf1loJQt2z5uzwWBgLntrz1l4LCBddazUwWboY1
fNgSJoXFgYNDr8+zIJvk89UxVQpbDsS2pLqzsPjizu89TVJ459QYxhJnoejV
tbiKFinctMj+1CDIgkvlJX21NinkHZ7b7cLLwrPa0IDeDtKeps6V7rOGOPR+
w8TefikceLpqYb7XEL9+Dc0d4JbGQvppHvvHhnhLYQgdMZfG0l0pa2Y2GWKF
n99AhqU0ZC7uG35qY4ii2qLaSkIaPsvk6QFWhogPMzwjvlYava3zpytNDWH7
03Thjr00PMacW6aVDFH/bOV/PT7SkLB1t733i4maPU6tm7OkseGq0uTHYCae
F0VkMLhlsHGIV+omlwH4bB0UUvlkoPH2Vaz9qD62DNCucArKoGKuKvRvlz5+
qTddbheXgc5L6w79l/qQvCKbFK4ig5NjrEDiqD58IgvPtZnLoI42e9x0UA+K
zu1HwgJkwH2n9lhwEwNek/kTPw/JYMagIPv6cwbuJ4Ue2nJUBvQHfQENtxmw
bqIGap2UgfCEyXqNKAYOrfLxbbkgg7Rgv6ahFQw0MDg8NG7J4ObB27OK93UR
yknf3PhVBufbFfYkppP7yWqhT1rfZVByc+31pvN0bD73e/fpPhnc4bawliX3
WQ2x4oOmQzIQH+JLfedER6OSccL1GdI+oyyp/6TpUGGvaD4sKQv9XJrNyhQd
nAtVdXwrI4vckQ+rws/qYKyM45uOgiyyBHrnW4/ooHZN1fA3qizMz95e9cJR
BwFb14nY6Msi846I8g15HVT629sq28jiWTwrcXuONhgPjNqO2sriUMUVXpPL
2rg8KeXyfpMs9pbsiiJ3SPiEffSJdpTFn7MP38b4akMqxuXCqIcs9mkUe/SZ
auNk03JJ232ySK5+2/1RRxv94qoZeQfI83puhowpaeNl6veCnYGy6Cxn11/n
1oZXrld9zUlZxB9b/3j+PQ0t/db21AhZUK3+LV9dS4MFQ6cj5KwsYsyH+Z8/
p0Hs4dCAQawsnrgv9Fnk0vC0PGBJ+hVZiF7pvXQzhAY1HvuLE1dlMTJSPHcm
gIZYayP5TddlIedkPZflRYNb86Q2zy3SHsFs/YitNAh2hqzzfyQLp3WUo7pM
GkyP3hZJeCKLRy0u7RHa5Pcpn94Xl8qCFljTLrWUvG+dya7RcllMVM+5D1No
6Ov1UKNUy2L1hpBoU2HSvlNJv1i1svjwjGv7K14avB7/F3i4ibRfUtc25a8W
kjarmKW0yOKWVKrEj3EtvByynX/cSt4fcrHh+IgW+qNCK9rbZSHFo9awbUAL
UmoFUdOfZXHJo3fP0T4tEC8/bZD7Kos9re5fe7q0cMCZX8K8WxZL5zcVpH3R
QkW8Z0bIT1msyWn2GWjVwm+dS3syBmSRmGgQFt2iBbmaCs0Xv2VhErGUEtyk
Bas9fwY7/5OFroPT05J6LfjPqdxbGJPFY03ZmfV1Wki/bHdEZUoW9Y0a241f
a6HGMMyC+CsLEZWTboertfCnsWBx97wstka75QlXaUHJ+3N1+KIs1EUkRv5V
aGEdt0BMNpccbuUk8NiRfCjLdFMlrxy4D659OFOuhSzzvVK9AnIQWvqznJv8
vL7t0mduYTlkxlqPHiR56mBlloaYHES2beAlKrWwVGjUYw1FDlItT0uDyPts
81R1vKTl8C/0W4NwjRaOrdw4EiUnB9VYJT6xWi3kdIY9vKUoB6+PWodD32jh
7dE7x+pU5BAytE5rW6MWZikdyweWyiGmTFk7460WtIoEuAU15cBf4xFuT8Zv
i41ZHV1bDicdW5hhH7UQ1rc3boOuHKKCekwUOrWQfyrZ3ldfDnFTj6L0v2uh
VaFKNs5QDtTBk1LPf2rh3+PRzrvGcvit6Nhf8VsL9C3UG81mckjaGee0hsy/
w++N+/6zkINEvuML61kthEefYIivkMPXKfP9DZw0FKoVjjJXyuGZ7pf890to
+Piyo2TLajkMtb16uZvUn/6E2cpL6+Xgkn/IWkqThh0JXnyP7OQQT/sjBwMa
ztJTGto2k+eL9ZTNmtPQuWfMQcZJDiVJa4e0ttAgME9VNNshByfXvWczd9Fg
lLqp22mXHAJcGxXvHqAhpqnwwBUPMn7iz/uuR9FQ4v3FoNRLDmrZ78RiUmj4
zi042bFfDmvkdnjKkPXItth3SilADn7DnvvVX9PwI29p8rUwObgVX1nhLK6N
32e+/+UOl0OZutELTy1tjLln7/aOlEPP+7qa9cu1waG6VNcwhsy3+n2p+37a
4FvoTkyJI/2vXO7CjtaGyJfrU38T5dAWbGN0K1sbCqnUyspUMp6RMXY2n7Wx
9Eg3jZYhh4neC7aRU9rQ3no97kIWmV+l+nMPpHRgIkbdvi1XDrf9XnQtbNXB
5mjVPz8eyIFP+K/ctW86cNrb5bC+RA6OWZJ7O7jpcLW69rzomRxyb+XuUqPT
4bOoEn20XA7tQvJvu8l+HXVURWVJMxmfs/OeK7V0EefwLdLvnRwY20KNRbbp
Itkoa+Bdmxzo38XGf0foIvs/5cfpX+Tg/XCU3durixf7lG0ZA2Q93NszveUB
A1Vrvt5P/C2HkeN35w70M1Cvnik7+Z8cVk0k7z2kqoePXUq9L6fkcKzSv1Y3
UQ9jTkohm3jkIajK4Z4boo+/Jp1dD/nloXLpwOenJfrgkLq6Rk5IHsFruV8Z
jutDpEVR4ruEPFyeupR3+xpAe51ifpAqyTUbki8ZMGGg9UXko5o8Rm+PHl5u
x4QpT8ahZVryEKpVmA46wIRVuQLBoyePY6/Ts3hvMrE+qyPHmylP7n8qZapl
TGwOSxdsMpLHvgy3ROITE65shfYUC3k8v2y7dULAEHtlOpbNLpfH1ff9Zmaq
hvCduJLtulIeNbWrt3caGSLo/Xb+qtXyUDYR1Xi61hDH78n70dbJ44xA/sss
J0OEx39+f2GDPPrFeLI8vQwR5XuF/WejPEo2PlHpCjJE3PrtWdvs5TGz6Z7S
jzBDJGvL8zxzkIfJa5+yTWcM4eKqdavXWR48O/X4K88ZQiPZaL2oizxOyVkM
PYoxxO83GGbvlseFkZ3OEiQ/WrRL9HCXx6fQu/eqogwRZrLTKH6vPJiaggkv
wg2x2se7/am3PI6+KxUZPWoI4ewjx3t95PFauyB/h68h2tojlEQPysMsI5J/
ZpchrgonvmIHyUP4x7OcRltDeK7KdPc4Ig9a3PXibrYhGMcKeOOPyUOv+V/4
SjVDTNx9kv80VB5Z60arOJYY4kVv9Ybek/L4WX5yv/EwE2fk34+IRMij8cGa
c1PNTEie/W3scY7k9Z+Ssy4w0VH692PcBZLv5HTVejFx4w9f6NN4eegLr9bk
BRMsl6UVIinyYI0e87nTYQB7I0e7p9nyqMs96mt5UB9J31/tFXkuj5CU9phc
B13skG0SYJfJ41D1qtFff+hQs+u4414hD91YjZHDsXQ8eDox+qRWHjlzYSt4
a3TwPkHnpHubPMZ+xAU5EdpIrzFdGveRzO+2LJu93TS4z1lVP+kg/d/qs+9y
BA1jXq6CIt/lsdvjyqOr5HskseLS5SfD8ri///Ma9wOa+HTounnPH3mc8+oN
qJHWxPXbdzuFJ+SRcU/0dlKlBpjSdWrus/Lg9NR/foSqgc2/54uE+RWgovPg
XfCwGhLTvWrdqApIUW/SWddAxdHgiENh6go4kq9kuTueClf7LNVULQXw37sZ
+dyeCoZg+9FGhgI2K33VOlCmijfH12ibmStgufFURJSICu45uLVtsVRA8udp
qtktZaQZngj3JRTwlb+5x8RKGV4Djz5lr1FAh9oOl8XTSuDarnFe2F4BLIvF
tX/kFTFgDBOagwL2hQyWEDUKaBF3+b7SWQFRlk9Gs4MUcK3ukvlRVwVwiw/n
RbTKw5LNPfj9gAIitx82GC+Ug7qU6uV5PwXUbByTl/WWg+Afi1WygQoYTOd2
lyXfsU+3gtJtjyrgTSqV/1KOLI7I9qx/EqkA/1d71r1+KgOX8YWpd1EKmDQ7
66cYIYPVb+Vv/j6vgB9vOscV7GRAid4ytzSR5I2Lgxz90vjr7nfL8pICxssS
kr88kUb3ivNbnS4roHT+3ft156VRNFV+J/aqAsTaaYeqmNJIed/pdOuaAiQG
PTfX8EkjrGiGu/KGAg6Gc4at+iaFDV5Ml+l8kpV0U1MvSqH/wzVh98cK8HV2
jRJZIoW3958/DXuqgBWHEgtsBiVREvfRM/W5ArZmhiS2NkrizBqxl40VCjAh
t67SFHLvW6q7/1e1Aj7+1LgiFCYJ+4W10lx1Cgju7zqS7CGJpY9P+pk1k/mx
eTRvYioJgYvp8vbvyPO5Fm9ZLSX3RN+SGt82Ui9fhs8HiUji47r3gdEfFci9
9rrCy1kKyjRGlG90KEBqROSv8gAFuRyC9S++KiBhhU9VwicKYjs1gz92K6Dn
IFNC5A0FO5J3NQv/UkC2+ptTUncpUHooqOgzqAAzOQpfwjUKut492fdmWAHC
1IVB+iUKWZ+ej2ij5HnM41HfoynwFKNwRk0oYE+wsUHhCQq09F/Z9U0rwOFM
Dc4cpmDA1jd91ZwCDK9IWHv4UlDoI//r+j8FTJ8qH1y1lwL/mNdGi5yKcPc0
+ay0mwLm7UPhu3gV8Sv5bM3gdgrGa6lNzwUUkTMS6pvnQEHJzyZ5BWFFnEhb
9tTGnoJjvKFex8QU0fJOoKR5EwUWGtoP2ymK2HfJ5KTBRgoWVn1YNJZRxOuo
G8ZedhSUu0XYXiJ1nQZLIT+SI8INrowqKcI7fbfrCvL7q691/thEVYTBxPD9
NvI8/rLzrCJ1RZiX11+hk/fVd5qeEqYpQty74pkFaU/sXG/DAboiaHf/vF50
pmCjwkW5N3qKsAx/lXl4FwUS5iv20gwVEX9/1+pkdwranIbunzVWhOkyj7bt
3hRcDk7712umiP17BUPK/SlwTlmzYdUyRZya6jpcdYQCxUdjqddXKOL0wDJt
1///H2vU1nDXGkWEPY3ltomnwF189sTzdYr4kNN1JjGVAg2DW/Xytoq42sEO
cM2m4LYvp2e7vSKW3a1xPlFCge+FonvGjopInZlOel1BgX7BzoWk7YpQe+R4
NaqJgge/Hl/etEcRi19Djrj8pOCF+4E3dX6KOMlfcGpRSRInT8vK0ALJ+wrb
tmXpSmLl9Wr3s4cVUdC9LeiKhSRef1WZXxmqiGNU829p2yXR4tyq//ycIpSW
eAQHZkgi6Wh4qHws6c/KLZZ5hZJwuKxXdzRBER1bCg6rlUmiozXazfiyIrbr
HWb2f5dE30bL5Ls3FXHzS1uLP0MKM6tz/14rU0Sfs0nmmwYphD2/FlldQeb3
g6cgrUsKHKx0kYFqRTz2s+MsGJMCv2rCUlaDIi6J8UNJQRoyf4/ZVH9UhHLx
iP/lA9Iwumt7pf+PIrgtjO0UJWTgLz3BNlRXwok3675EHJRF749VxyqjlWAe
JXJMYLsCbiw3VGxyU8Y1rUi3A7FUVG4UjJzzVIZS8YJKxBUqenb3Dup4K0O9
I3BjVh4V6hEppVH+yvCQx86+cipyXv/djlBlCE2vcbs9SUXupsq0h8nKMC3L
NdTbsxT5bltl0muVUbBjtQ2vhRrqghgn6+qVYXbjX0OftRr6I3l/TjUpY+LV
eosmBzVo5z15vLVNGZnaKa+fBarh9qCig8h3ZYQem4kRKFBDwaG+S+GzynCq
ng94rKSOu2ePSOzTU4HVp9dnQ4U18NtyV8RZpgqK7HpfP1PUAGNi9fhNIxVk
8Tk+ENTVQIG71IducxU47Wu0/GmjgXziYdqOtSqoFb3xIfGcBnL+/lHduFsF
eo9lApYKaqLv3qdEX3cVdN/b+6VSQRPq3uWcF/aq4PJM6tuTupq40Z7QW+uj
AjeeHXnr7DRx7aH+rZXHSHsOd7cYJ2ki3c9X3+SiCoI5EoomlmqhQ2Pbta3J
Kti//2R7lLEW5DuXiQelqiB8quPCcmstpK0XGivKVMFktsRyRT8tpNAKHmsX
qKBvkhFcUKqFxO+/LJWqVMAZu6nkGbk/RDt4bOCeVMEWC2WJnjpt3NjU6bJ3
RgUca7/Ro3q18cLGwb92jrQn3yM28B85/y+3vniBSxVXNNLXqpnowEVL96Ok
uCquPrT24MvTAWt6zF1DVxUHt29ZVnSZDrtRn8NR+qpo+1xsbFFCh/dQ39l+
Q1U07Gn0V2qnI7OrPb+QrYqWA5c0f8noQqCudMR4rSocFN3UC6/q4ltaRMga
N1UsrlOsu/yMgb9JcxdueapiqDP1xvdvDEjFHc5c4q2Kc7yvauJ49GBz2qu8
yV8V/nYrvght0cOj/ev5HMNUcX7l4Gz+iB5iLChJXqmqKCsOUUizNIBJZ/bt
6CZVlAfIJ42JG0Jc33umuEUVNavq18zTyPnylL71p1ZVmPBHhNEJQ+SoP+/T
7lCFMmWAGPUzhJRPm2r9T1WY7akLEG0yxGwY9wY+DirqS6o/nElkoT/XKyid
k6yLs9V6DrdZaG9+c0WfmwrhKx4eJpUsPKAm9jvyUTGb1rROeYKFA9VKUbeE
qcj+OmJp62yEz0KmFevkqfCTlMlvUjXGa+Mr/Z0KVNz6Hl3nwzbGo13zYoFK
VKxXfnZ3aLMxEosrXa+oUhF214Pr9GljrNu6aX5Akwqh0rqg2G5jmIY9UD9J
o2LslkJS9bQxNHKlN1B0qHi/6KH5QtQEHNNfrlgwyDmqsmysfZkJnqZ7m11g
URH8oP8xO8kEeVUNrqrGVAxVXxIfzDNB8m/9qIcmVFTzb1I2fW6CgBWTbV/Y
VBBGBmZxPSZw3ec8f9CCig0xnHsSJ01gm/hcnceS9NfszjIVAVNo95wOYhBU
NHxp/deoawoZoR9XykHFm5ywsV+WpuAxXlexbRUV9pJ3eCLsTNF9VlT8xBoq
RLLNinX9TJGmk3G3aQMVFbLbr5vlmWJifG1upB0VrB93Nls8MsWmsrGr5puo
iIzfF5ddYQq+retjc8k5MeO6hNmtDlO4K09F7txGxaqbhLbtT1OU/coOlXCk
wrKo6or7qCmOhP09cGI7Ga/itTHTvGZoWZvrbrSTCv/XG3VPi5mBIbFlx4AL
FZBM258kZ4a+3Hwbhz1U8HDN+3rpmAEB21YKuVPx3ObdcjNDM2RYcJhXeFCx
Wv1Uxh22GezfOmnr7aOC+ok//epaMxRd4ab2elNxO+YJj7adGZZ4FsteOUAF
pzIz4vBWM5TP8PHz+lMh+7rnP9/dZjBQK/nReZiKJMrGh5eOmEH4iNTN2Agq
Jmx7FzZfM4M3UZ6+6gwV3JWTdsk5Zqha4ps0c5aKKhG32e+3zRCSVXXa8zwV
zkdH72U/MsNAbdAey0QqbuQXjlfVm+G1wjvl35lUfFz4vGvnXzOo/QiTvnGN
ioPSHCHbFs1wolhbxDmbihq5oRdbeNkwXh0+X5VDxRWG4GN7CTZu+Bl8ybhD
8sMJUSsdNk6Vx6VteEbFWd5fyyOc2Bj8Wp78t5QKu87QvN8ubDjOjSfeekEF
RxWTsdqdDYbpjvPc5DtxN2NXz2NfNj7d0Qp5/pqKdxKeXWfD2bB6sz14fx0V
Ujk/yyzOslH0MzZItp6KzW+qUtrOs3F26fiBQ03U/89Z/x4mscFKfbVTt42K
vwJOAqI32ch8NOb0+QMV+ZHqOe15bAi819wW/ZGM50iXxKkCNrqEY217O6jY
ZNuT73efjfX0V+sudlIxJbJP8OEjNkqsx1YT36j4Hln4sv0JG7ERzsszvlOx
7X8VV3s8llkXJTKk8qaLZOI9z3nDILnlfVRmliilEim5lEEJFUkuFX0kKUTU
ZEoX3UyKeJMaFYXESCjXksqXVIxcyj3Vd74/1++c3zl7r7P3WmdzV5TzC3kM
pcWbLW8Twvns0cXBRTw8C+/PH3onRMKllF6lhzyqm/sM098LMdVpguzhRzzM
hkX6Dh+FCJBQn1flPC5Pd9KR7hTi5t9/CQSPeQiM4zVz/hViS4PieOETHu/9
+tQVe4S4L/Xv5Oc1POzjRWp3eoXoHiuwjXzGoyBjvYr3ZyEO4aO5XB0P7bK4
qdP7hSjQklbaWs/jeFuh0kPmu8avc4cyG3h8l+pT3DkkxFIDW6MnjTy2qovk
NUZY/3XYKVQ28WhYuF62alSIPhOTpxnPecA5TipsTIiPddNfeb3gkRlSOKb9
XYhgOd/Ycc08ZvzRO9z4Q4io36wWRTAcdYMOREsTRO3J2tLC8Kdqxz4jGYJe
h1dhs17ycOqK/dQqS9Cm4tpnxnCpQmFHohzB165k64UMz9PqbV8kT+CvnqSg
wXCqFX3bqUBw4ie+tJ2dN97T8fVJRQITcc34JIYDImKbl04i2ONWtFmd4ZYz
BY39kwmOl/hHJbN4re/21F4UEPx5rUi6k+WT28TV2CkT7C/WidFmWH1gXeX3
qQQ5/mfyV7H8Y5Vjy7OmE+xd/WalC+Onf17BQxcVgofH5IZtGX+/r+p5IK9K
cMiuxV+P8ft4K1dwexaLL2inz5daHufTD+cpqxNYl33rxlMeig/vSYo0CCZU
hspUVPMIae3O8icEFsXr/jKv4rFKbV36YxHB4I2VBT0VPE6+0y9y1SRI/NS6
e9U/PN5dl3/ZpUVQJGiWPVvGIxwFAiVdwvRKMnsaq68sLxruYEjw8wa1f4Pu
8Zgg6VvTYk6gPafL5Tir73KrRKluR5aPell8ZAwP5ck+ahFO7P7B8Z+WR/Nw
a7IwFbgwLHNuaEYUj0HfgW1GGwkeuEy0KdzHQ/PohqaQTQQxhgUai4N5RL/Q
yf6xg2DXfqehlV48LPzLXafEEpDPZ7q6lvEYfd6xtDSOYaWDR2dY88iznGgU
eoRgE36W/LaEnadqL//qKHsv5ZRdCRY8JpY252WkEGjGJxdKLeBRpv8tzfUk
gcBzyQoBz/TklEb85FSCvMEp5TNNeXz23+wRdJbg6TDpFRgxvVDtnoTLBOK2
cotopj/HogUjn9MJ9Mu7zlto8VjRY/Qu/QqL961Pcq+Ix/3S0LuKmQSS0X/C
NIQ8ds9LTb+fRSBtcfrK2dk8DFMLknZms/pdHl2hoMb6c4e0d9MNgnmDdF/G
dMZXM10Td5PVl8oKzxfKPFSWLDU3v0Ww3XVue78Sj7hZ8VMv5ROcOhWf9VGB
1eejaUX+D1g+3y7o5oyJoWMgziTFBNM8Qx4Imd62pTqn1JcQtDZmxYQOiOEY
cG77gjKCrCPKp2s/ibFITVtVrorApbNurdErMQYP2sjeqSaIqIq4X/RcjJze
7T3bnhJMyS/SNqxn+l1249GzOoIdNTOn/s30XX7nwsCzzQQJ8wWyDrfFKHm5
caNdC6v34Pw3XRIxwpZGLpN5TSAFgybvTDG61R6p+/6XwFY6wF76vBj1ZbaV
Jh9Zv4TYWz86JEbaz56iJwMEtTOTZxbai7HAWFffc4jg4KyLk4dt2P7l/eLh
YYLTN9mUacXuD41ZIRpjfPV+/nuWqRgBz64Fho/j0NIQmCKvyvwz5kuRnhL7
t0en5X9gfv22J3pjgjYHGd11l3/YmSJcztab6nDwWR7g12LN/g+zVXbe0eXg
rn/CJvNXU9jYXI1u1+cwI9HBXqhnitzLVZnm8zkkFRnP8ZczxQHnGaOfLDhU
NA/0VuTPh+jhlRRbVw5KPh1tudPno1pv+HLLBg61P4WXb1Gcj90py25udeOw
2En2F2Xp+aj07aiJ8eCQEaN+fnWXCQIFugoPvDl0bb9zfUuJCR5szA6bF8RB
a/+3M4p+JnAZznMXJHBMB/2c9QqMIes5fse5RA5Ohxbva5QYI7ty3T69JA5m
FzxehaYbQzpt8NSy4+w+vxdTzicaI2MJXxd5isOlWUfWRrsbY+DYvSV96Rw6
XEd94sYZI2luiU7tfQ6pok0q7b8aIYN3VYgq4pA477vEzNAIDyz7PxiWcLh4
LmdTJDVCt7NmevIjDpHa/w1v+8kIK2LiNOyfcPjeXBExVmMIuTdrpj19wWHB
G3s9542GCEtq+1bVzyFW4ZZC5TYDbPki+6xCh6Lpn4+v71zRg9s1q+oNehRR
jZ5De2P04OgRXdkzl8I7xU5e5KWHpTUyZdMNKSzrhX0GnB40M8fd8xBTKHlI
Elae1kW7p1T6iCWFzR4y4h6ng821X3f/spHiw4GYt2u8tLEhdmFIgRuF+qSZ
e9dbamMtwnatdqf4Yvf4WCDRhlX2qF/wJopDPw6fHHilBVHciGexL4tn5qH4
XU5aaLMYWukcQmHuuqkvaR2bp4ZNbbpCKXbI7fHQM9VEbU6IdcQeigMKFzTl
VTRRMnvQIj2cxSuZ0xj/gs1rI/2mfVEUVV9rxgSec+B547Mw9ijFun0OndsO
iLA9ymHMJpnC5JAtVm0RIdghr2nicYo8qeU+uWxePDwQnJiUQrFLY//Vqcoi
ZJuNfP3zLIV+f4N06FWK/AkuTc5pbL3TbrAwiaL45d1ctQtsvc68NXU3Rf2+
cN+0y4zvAJsCNRuKkeIfjX9lUkhKvK3XsncZd9w91+c6yz91fJFXK4eJm4sT
dHIYX10PFyhXcVCXO2CVnUuxZfPs3Qsy2Lzc1KYRkMfiU266kpfCwTDD6qvh
bYoBHc36soMcrGzkcm/dofD3ylLI9uJgq+adEHqPQpqTexfhyGF9V7mPWSFF
xcoD7m1sHt+aGKtRWEQR7H8i21GPQ9DvnaP/KaGQSldq9dDgsM9gRSNKGb/9
HU4DyqwPaycmlJZTGOqvfXb1K0HqJT+fmAoK3QKDj6W9BJeCqi2XVVIU7rwe
tOE9we0ZSaOV1RSHdY48/1LLfO9Db0PCU4q3s+LbuyoIKvLtb6yupZhXh861
TEdbXKb61DVQvHOMzd/EdPq9bpDliSaKnnhPB5lrBD1j9errX/y/XpqTZS4R
jEtLaWhuYXydbI5SYb6jGDAkOfOaQnX8yzGaxHTZwumIWyuFu67KzSjmY1pt
qpZv21i9ZqmVa0cSGOTtVb/cTnGBqJn5hhEsOPhyxOsDRUu3rWp3CIGl46IG
rQ6W320XLi+QYKXWWUlHJ8XzcUe5fH8Cx+Fv8ZldFDraYYODWwl+r3Dz9uum
+GNSY4qfN0HgNqF6Xx/FKsWwu4PuBOGL9o/kfqEIPNx9S8aN6eykt/VBA+w9
t53bae7K/gmvF0tMhyhEfyLkAvP1kzmX4oeHKZqPdW+fy3z/YqSs991RimO+
hVPeOBBk2nstDh9j/TBZammePfNVrmz2r98ptu6NUMhcTXD/i+bIjx8UbnmB
u4tXEfwPW/oEDQ==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {0., 24.856373284460442`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184537495724*^9, 3.536264983861277*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwUV3c81e8Xv8a9197rmtdoiKyvrMpzSiqjkiKVVJJZdpmVVBSSZEUZRUQh
IzPPNUJGFNlCtkRmVvnd31+f1/v1ec457zOf80hbu5heZiQQCFbMBML/v89v
WpNUbUJ1hzp1JM9OkqGmjWp8iuqA3DedDlrQ8WZtxR0q1Qcd4Zg+fIyOuSLf
57J1BaIs/q/GQMfPaQ+liNQHSI/YeE6BjhVnbcI37R6hCpHs6zx03M+V+G+j
MxJx3heNmZ0gg9wrVo219WjUsLCnrJ6Or+y9dvWP1FO0g993NIGO89sHUxf1
nqFQUTcBBzpeczLum7NLQuvi3w+p0HEyQ9+DP/op6Mly6K25cTIcaH68Zbnz
BZqt4S17Q8cTcYcqFx1SkZtP8upFOg6z+Wu5sJ6G/rNP0+Gl47Z1+6jfUq/R
9SfGVefGyHC9TlJl9l0m0ipQZ1kfJYPok/bGX3pvEJtJ+dFIOrbeAUw/7XJQ
WWNfd/YIGRjXfVsW/XPRbOequDodtw+aSSzqv0OPBxLP5Q+TwfsNe8l8Zx5K
+W+uPekHGQwjx0jzyfko50MQKycdi3tXnpxzKEAM5auankNkoOl5/Z5dL0Qu
mqM3VQbJQO79se2XVAkKqP/z9EI/GbpoH65NT5SgqjNlt5/3kSHzVVz1z3el
KMm950x7LxmOuh89P6VXjgh89/qVe8gQw1oaM26HUfVjvZXnHWQo8DJ09xCh
oTaVgwcyv5Hh2ZQmZcGfhvaljF/LbSeDcyuf3bx+JQqb/nk38ysZ+J7VM851
ViFhZ3cls89kWOd6/9p1TzUa1zsXoNJMhpHbL01+J1ejk5GGmcQmMry3u5k4
61CDCDptN55/IsOZ/9R1ZtY/Ij0lhdnAGjKkNCS5/ZT6hGR/FuvIlpBhMa5w
x0DYJ8TeqNPmU0SGg3aNw19XP6Hn88HkT4VkmGb6Y1ba1oDq3RvVj+eRQWvv
UZ0HwU2o9Lr2bpYsMrTmbDBum21B/lempjkT6HwRqxWnUiuyJX95NB1Hht1b
o3SCbVrR75f9T6pjyBC++HrB90srurmj5+2ZSDKoP/522TrrCxJi2pOu+IAM
txoUDVXPtyF3+cW2s9fIkPGuaGtWdBvSufvbocKdDF/j9jNtaWpDKPuxMMWV
Xr92FuUi2u0oPMok7b0jGRqY7ioR+L8hh7Od04/Pk0Foby9fS20H8p2Wu1Vz
iAzZOQ96ryj1IC9bW4vfvGSY4psKM7zYg64L2c/f5yLDtuuGutujetCU/sgm
hZ1e33vYU4ZXe9DjxVnLLcxkiPwUZnvmYy+SN/bzH1wiwfXhR3OHLPvRFa3z
FsOdJEhib7zDqz+IrJJjS2ajSaC7188ywGoQ3dvLzxD6mAR9zgq7Zr0G0Z2P
PIsSD0kg8jV0rClzEAnUnKzYcZcEj+OMDe7zDKHnUYYiA24kuLPlM9dm7xB6
8pD/2xsjEtihL0+n3YeR0zf/tNcrRCC8WC7tDR1Gc6yfWA4vECGOWbyvIXUY
8SjvDe3/RYT6T7aSrzuGkUpQcOuvH0TYfnLjxWWdEXT0vELEiyYiTNhve/Od
YRSJFOo0mycSwTHyRkVrxBjqmNfMLNUhAuPSiwH8egyNfrzyRFmdCPGn6gk5
VWPo2q3p2vidRGgQ59d7uDiGwr2Nlk9QiaCQnlFnYDGOSjdjv5sQiTBd1tZa
JTWB1MpZX7g2M4PzqPxwQfYkOpTL9UDFnBkGrbpZKj9Nokj3M/jDEWY40XVf
qXlkEjluXJBH+syg1TjuMyo6ha5ZMWdLqjMD07s0HqHgKbS8kCF1nJcZ4vyl
db3O/0RR6/9lhH5igkp+ylNtnl8oOz25qEeVCdQf1lfoK/xCU1cafrJvZ4JX
JO+R4wd/oegHj0+pSzJB2GqHsqM//fyV8AwnNiYwH4iqjZ/4hTYGn7f7/WCE
qUyexXXaDHIQGv1h95gR2KTvbhvQ+o3qs+NSw38xQP2ex8o39X+j2MWAbYIj
DBBkkagpYfobiWWMNaX0MABjRPGhs06/0SSnsGprHQOs/Zu263z+GxFbOQWj
XzDAzz6zjBbGOfSEa9HN5gwDZK5Y5zpzzyG1oeCYl8cZwF7AtZhTfA4dm/wv
fvEwA4wYhdQb7ZpDsaLB21o0GaCvtGKizm4OPdhLTfARYoCmuG3ytKY59CdN
YmJ7FwFCCtRVz3fPoSZr08utrQQ43LpP+9/oHCoa4FeK/ESAGrKlwZ7NOTTq
8MjpchkByq9HOBSrziODyjwX42QC+EY+dzulO48CvAIq6p8SQCs702fZcB7N
S35zO/+EAAWjNQ/UbebRIeKh3p4gArw9ufo6N2YeOT4S0Sa4EOCKKynv2Mt5
lMt3he2gAwF2hPGXzuTMI4dK0saLSwR4Vb2zQfHTPAo9Sh1NsiBAopr1VMb6
PDrumwxP9AgQztO4I+XCAtoWMXO0TJwAJZoShUedF9A35jTpD8IEGLFyQRt+
C+h1vfTxJj4C7H7Lf/JU7AKa7n9O4mYlwISB5Q3OzwtIN++CPmV6E+nd+dXi
s3sR+by9QvR4sYlWlrivmQotIY3kVelI3k0kK2G9uSm7hMTSX3P7s2yiowcK
HrxVXUIBYZdu2mz+Q2mRFoksR5bQVvmY86q//iFT5ZS6ijtLiF/vWG5l/T/0
1l5NVGFuCdV/4U9nCfiHrHtPYqamZXR7v3Czz/xfxJYwdNWtexmpD6ktikz9
RXlnnMUHxpZRxH4Olpqhv4ipJ9inlOEPUn188S768heldpX+56b5B1VUVrN0
5P5FY9+oGd9f/EGbJ3vVsftf5Ng6HVHis4KMuWSflzL8RXwRPmhb8AoKULJg
FFzfQKXHSDNRUSuoibVZzntxA7G3SBm55qygqptjX06Ob6A3zabEbaMrqLZ0
jNGweQPNNBT7RJmsopNDZra/4zZQTIj+dkarVcSyUu2rG7mBdA2/drg4raL/
GgZv3QjdQI8+/fzPKGgVia94fPl4YwOp1EvO0O9SZCI/26V7cQN1BWc9c/lE
x7wfXrWf3kABh7SM+jtWUbVJhMVh0w3UWns8o3huFR1V0C6v2L+B3D7etXbZ
toaWJZJPx0tvIMmRg6Tl/9ZQ+UGRs06UDdTIyJrpD2voWHqcGzvvBtoCD+ce
nF5DZoTYWzmb66i7NDogNXQNHTAqmNbvWUdB3afkFOLW0OWT2l5HW9fRfyuU
+nepa0iRWe4Nf+06ergrkRt/WEPKR+v9G3PX0b7cV4nds2uodkpDoChwHc18
tt9/YWMN5aX8U3W6vo4Sfu0YG2NZRzavQqHJYR0t7cjZuSi9jm65xTWHH1tH
r9OKyrlOrqMU9oTRX0LryLzG50L0hXUk25jiNkReR0zDu5nFr66jZCpPs9fK
GjpHpRnJB62jv62mzQ+61hBvQn2PXjH9f13i9K6oNVRREnKzoWYdvdx/wVw1
cA05dRnLHP+yjnoPe401uayhj4JfHKym1tGYcFLjqMEa8onoXvEW30BBfLKe
b1dX0dC9KaHsgA20YM3Ic/XwKgpPfVOq/nADyXbu4W1SWUW7q52typ5uICIt
4WefyCqKJiyk1edtoCXvlDqxiRVk4LeuPjyygYIddN4cvLOC3rlynBAx+IvU
qsoEdLL/oKZ4fp+35n/Rds2ZY+cj/qCxGtGk/TZ/kWnLqpCp+x8kSpH/eeXW
X3TfppH1za4/6G6l/p3Kwr8o5rlCXWDpMjLnu5XvKPMPOX5aMdyOl9Ba/hz/
h/V/6OINt8a/NQtI4PuKtinrJnqFzHQ/pC0gJRbChXGhTfRA0OTy46AFdMmS
6w2v2iZi9tnS4H94ATUxKxywtd9Eg923o282z6NEMxtP7m+bSJu38PRa3xxK
8XOaUjlFAB2zczZtgr+RCo11JfgcARjbGLq+rswiGnMGcYA+lwx4ze9D7Swa
fDhCfehKgKeOFx4PXpxFksnnTk0+IEDpva8qqs9mUHzNsZqUcgLkepcy/RT/
hSI51RP5ZBjgc15HzjnjKRSYtHF8cZoBvm0RGe/SH0UmKsVuCgsM8KDM4hmH
9CiSrPR4bL3KAB42BaMXNkZQ6Y+p1lYiI9xTcnltnz+C5rd0H3sryQiP3xCt
h2VGkPWbwiO2JoywHvOrZIk0jPaVOBt05TNCYPBQAufAICK0DUK5LxNoht0k
7zTvRncnK1J8bzPBmkTEVx7ObsRKeM6ofZ8J1i/f/z1U3YX4dp6uKYxmglnz
ZrODql1oS/CXQzm5TPCZ+LZ2lq0TGe6uOvpijH6PRlsqPytuR09evrS8b8oM
RQ1Nu8d+tiCR0tsfDp5mhkUncnmISQt61npekniBGVZ3iEh9LfiMXv0VG7x9
lRluzr8wNfRvRsWnoi753WeGO/o/zcnkRtTHfs/RuYIun3d962fOWrTV09b7
5A4iiFpudN7nKkY7dQZOJKkQoQbu81iNvUfqBAvlKQ0iKDvo5ojiQrQ/zGDs
lh4RAnLkl4s98pFVquLJLEsifLwujYq636KY9nllxkdE2Fws27l1IQ49j3di
PxJNhPxgfv6vn6JQ6oWRsdgEIhz9JmK2+SYC5U1/e74zgwj3uyrnyJq30Wfm
EvbTlURYab3cpGXih781qI6/rCNCZ+uv95ac93BfRGbVTDMROJk7Tf8cDcNT
4s987vYQIadyKwOPajQm7ro1nkPfy/JCZsYeyqdgjvU/VWurRJgJLHRky3+B
+SpdE/UJJNCOPOh3RDUVU49Ym/VykOCRVbrYXvZ0vI2/V2UrP31vfCIyc9M2
Ayt1n+Bwo5DgVqPNt4LC13jPZf1q0lYSWG9mXzut/AbrKVQkHlckgeTI04Lg
02+x4ZyG7zM1ElxtkT4t55WNLW5sV1VDJAjIYs9SO5iLz+ulcNzQJ8HxXiGP
tcpcbMsqOlFH3zMbRG7W2Wi+w57R7EnnLEjQ4z7ju5M7D/udveubYUWCS/3K
8XFueThQ+q/Zgg0JVPt8KnBzHn4wfk1V14kET0+ZlebK5uOItzMcD+h7rGJz
GsHPIx/HethNtHnR/X2v56v6IR8nag9WS94kwfNvpU8mCAU4bdMiyYG+B+dQ
ti0U6RbgNx+/+BaEkKDlVkhE8fUCnB9qaL4ZQYJ9/mf+EF8X4NLj1aqGsSTI
Y9Cz/PCtAFcK7+GMfk7nr24e93ejANf3F0wMvCTBqtSvy+OShbjl5c6aHZkk
+OftG/xsdyHucHiVdC2XBCd99c/AiULcryzlR3tPAld+B/E/lwvxyFKsOfsH
EixsagmNeRTiF/v+8+ivJoGBZsmj2huF+PzDz49yGkhQ9MBD2S6wEIt3O7y5
/YUEiXX1i6u3C3GPHPHTiS4SGJ1NcnznX4jjXJNHtwyQwFTRTovmXojNy3cz
roySQCi51fe0TSEWYOmUbJgmQTuvnF/O8UL85YT77mcLJAjsTDixpFOIw5M4
LZzXSCA+7/zRklqIjX9meAIDGWKfvHMSZizEbJoHHvOxkOGQHF+u+SDd/8CB
tyP0d03Izi5Ww7ICHPTZt+G9IBlWT5qEST8pwHqiQuP3xennFyWl2e0LcMU7
Y+rOHWSw+tdy4BNrAfb/O75nU4WOVRymFjvysbbBndNfNOnvzIyxsqGUfFww
WBJ5TZ8MnYTSiUTVfJzJvY1YcYH+TvPSudK0Jw/HXmWYOhpLBl8zIctayVx8
suQZSTqRDNesj8oF5+ZgPqKW7EIqGTZ25KWOy+Tg8GfOlrH0dybTwucnAaRs
fLex9/MA/Z0rTxnIUGrOwq7y7/NdmVng5RHHiIMe6Vjp2vHW/ewsAJplR/dM
v8I/adPTAnws0G61wnLJ9hW2tZDdWiLFArw6hO2BVmn4XHBEHMNuFvBkaTKI
Of8SG4463oh0YwFDV6OzU5ZJ+OAN2TcHvFlAUSuuQ+tuIt4v2NezfJMFggI+
VTHkPMc6+ke0zoaxQFbUvI8M9zO8I015QTadBTjPhQobrMXhrXsnpDvessDj
0j8HJHTjsMy3ZJP7BSwwzN5eFn0vFosS+bKnK1ngthmrqr9UDGa/vGhf2McC
5dJuSrq3nmCWv29i7YZZgGuO1ctiMBIzR1+upUzR+T1OlxbXj8QbNR2yN/+w
QHhLaFM85TGeliv5fpCPFc6qOefc73uIJ8rdOFdFWMFISMHsT1cYHjm5Y0+W
FCt84RxuiOsLxX13E55y72SF+KRK73OrD3DTyI2TXYdY4U9Eb9mh+0G43l/j
TshRVgiRdJtK/XAP1wjMvttjxgpPDv3awrR2F5cfuMCdYs0Keoeyu9OD7+Di
PhHdEw6soJqp1DLQFYgLPL9cIbqywvWZV083VALxm9T9DQ43WOGBt+CupqUA
nLFnfUXsLiuocM5tc7cOwKnt+ds+h7AC/+nWnbVZt/Az5i331OJYgVzod1/w
xQ0c96w/fySRFbb+SdS48s4fR6nH/IhJYwWmy/Ix2z/74Yc2ZFjPo/NVEBx9
oeyLQzaw89sSVpDRLzlo4OmDg6K8n5+nsUK1lYiMfK03DlRUbeKtY4V7up6F
2lu88c2aybXqZlZo1pb95/bYC/tavpC/3s4KjNckafVsXvj64hmL7b2skEry
KVJ/fB27h/EH9wzR+RL3l2fLXcfOck2FYROsEH3fR0n14zXsWH53RHeWFbSE
da3fu1/Dtif38s8tsYL0/vDnWjuvYevppX0vN1jhrdt/UnmLntjqbrarGRMb
PGvkm5T45InPiNslkdnYIEn4X5BPpic2L5D6XMLDBvbWPZTqOE9saty14STM
BuUzV/tXnnjioyMRCpKSbHCToViJ8swTNymMtFvKsQHth+CnYzme2MhD82bC
Djao7sv7RGv2xA2lIdt6VNjg1/bh/5z/eOLDjN9bRTTZIK7eweOM4jVca6Dq
e2ovG/Sdu7fj/pVrWP/xXdkYPTaQJxE11oqu4ZquzqZ2AzZ4LnbqXT7Xdbyf
qnCd34QNcP3jtSLX65hmd1PK1JwNDjsJLLF9v45Rzpf6CEs2kOYux3nmXrhi
Wc69xZoN2IhNme97vPAeXW8xLgc24J1Ouyjp6I1L7zXWGLuwQdP29zNzzD5Y
q1nSOfQaG8jS5LB2lg/eZfmRxhLIBs7udj8MRP1wwUsRx0P32cAlaSZpy7Af
VvvpxB8UzgZ7ZAz+Syzyx0q+fLZMCWzg8GrrUPydm/hN5WXu/SlsMC7pUK/j
dwsrsJYUB6SzQcfUbOQpFIC3x51n/5fPBpmyNxxfn7yNXw3kFewpZYNPWy9H
HZ+4jbdsI1n50djg3fLHSGJgIJZ5/yZ3pYkNnlR9zy2uu4PF21fNFkbZYPSc
YpfH8yAcL3ZkU3WaDc6unjqZYh2MKZeSM1zn2YC0OblTXek+Fpo/uP7rHxvY
qHJp07oeYB6eqOQJYXZovXcon/nGQxx+atxgmyQ7fOKcGvl1PRxzJuksXJZj
h4mMEmKh1yPMpjSkP6zCDjcr2ut46yIwk7HSz34DdrDrnLypz/IEBz65HSVu
wg6HorOYClOeYEJv+96z5uwQlln2e1A3Cm84+EV0WbPDC+PbRvF3o/FycP2u
Nj92MB+hXu6mzy/PFrEB3kB2OKklW+H6Jw4vCLncN7nPDt2/nRi2FDzFv9ME
e5uj2CFyODFHVCcBT1VbB9S/ZQeWXovCBp9ELPW4yzG8gB0CNTxXo+yS8Emr
o2Yny9gh/bs6z8WdybhiRXvHYD07jCV05TdtT8GRO3nb/wyzg7xid3r7vpe4
bi2o4sMUO3zrPsPu2/ISb9RtZNyZYweKbuEpxQup2NZ64gb3JjtIyh8dmApJ
w7tj8bZtohxQouH19DA5A7va7OL7ReUAv0SFzcbsDPxKNWsjbxsHKH89a914
+jXmaYr5oruLA3LbuqP8SjPxCMHZz9yEAzb5TlyxzXiLwxzFW+4FccDBXctK
izJ5uFIzssToIQeQQ7daPovJw8vMLKm8URzgZRD4JJojH19IWvB+nkK3l6PE
mbGZj9XbG2QKyzmgjjb+PobpPXZIAU6/ag6IrfSM4wp9jxOd3/+BBg6YubZT
U0uwCLOwvmhq6uQAxgTl1A7VYty/1+f6yDwHVNWa+DQ/LMV87LMXMlc5QPrd
fVkrxTJ8uMvGyJXACbd2bvUU/FyG89xNqBucnPAh/J2QttgHHJS+rYFfnhNU
fZiM1L9jrMTbIaF3nhNC8qoEP7BX47GHY4HRlzlh7tjO3Wpu1fg525/xcSdO
6Nf6zPWoqxpzMIvkhXlzgsit0gPb3tbgqeXTBzsec0K9f1HcgnMtfuHhmLU9
7v/2psNqR2rx6d++PH6JdH0u5rkdlnW4fjKhRyqLE+x4Xby/n6jHaX39zg41
nBDZVxA8bdWALU/PtJU1cMJPhR1R5IkGLNDxT4vrCyekbezsqvNoxIEtUkz5
/ZxQa+Vv7/6kCV+ouhi7scwJF063PJdY+ozFM0bxI3ku0Hoj0Xto+1fcLrcs
90OZCzptXF+13/uKQ1NIIeoaXOBLlM6C0a94LX7bye79XGCgzZM+9LoNdz10
mJCx5ALHXYFf7hh9wxFsvkeuWXOB6ZDaKf2Sb/hQcEhenT0XvFhvUdaT78Dv
A7L8r1zjgqMJW/W28XTiJx6/eN6Hc4HJNv8/pPUubPj77zWWaC4oyrjnJuXf
jRmvcvWeSeAC2w8fwoY2u7GrrXLaZjoX5I1bej/n7sVHT7tpG1RyQQUfWS3h
eD9mQ0sX+xa4gHpKU/ixxhD23red5f0aF3S9EGUPih3CY3pnsx8xcEM0307V
p2tDuOpw5dp+bm54Efrr8O66H9jX9OGT1zu4gTJWbaPtN4InTtK076hyw54M
T7XpXyPY/NTCgKUWN8wvnf0zYz2K1SxPK/Ic5AYvo1DVnyfG8M/LWz5ev8gN
taulTknHJ/AZewsnE3tuOG/uNl/cMYHrHUN5d7hwQ1OBWyrJahKnusyd6/fn
huv2pk9YPaawpc+HZb04brgZHEXKLJjGTWFm23lbuIHTKHsFKn5jnUf3P099
44ZHlRvhthxzOONxmWdNHzeMttU1Rp+Zw3djpCu9priB+jyyJXF5Dku2LivO
MvLAtrSxFPEdC9jsOA/BksQDgySjjNPXFnDYV/m2elYeGC37NlOAF/Bau6XP
Cx4eKLzy0NDi+CLu6K76aCbJA2PxfKrJl5cw59m+uCppHih9GxgknL6ED/Qt
OSlv4QEx5vcz62NLOO/7dj5WRR7oOuWKey4u48nz+0evKfPAvIfGxapny5g6
dLb4hxoP1Jwv95v7tozDh8OtyrV54FF2krao3h/80SZDVX4vDwwsdKjye/3B
G6OVzDHAAyfYHQVMX//BjhOLmS6HeECkeotbIcsKPvTrzB8ZMx7IvqPhPpu/
ghMF7rTdsuCBF25bp9R7VvDi7qycvrM8EHCp0EVocwUnh6zbxVjzwJub9fcG
Dqzi5XeyBxYu80DO0cWywcur+Ei3EdXEgQcK7nFT3t1bxWvbnnWxuvLAnenq
JwuVq9jkWE2BrQcPJLcwJ9z6vopfXZ+OqL7OA7WHb3tyra3iEx/3GNy4wQP7
/trz2Cqt4TfW/SW/Q3hAeZZxSO/hGmYMIcYcCeeBPpMzVsov17DFu53umY95
4GM9N6tX8RomEm7usInjAffwwDE0tIatnksmdKbR87dVqeOF4jouqDnopf6a
B9r+Kyda6a5jtmnnE4/f8MBKRnVawbF1XKSD2Y3yeeCxSIW/sds65uk6719B
4wG5V2EfKnLXse1msIVYDQ/U567+m8XruHxrrrp3HQ+Y3dY3HP28jh2uEX6p
fuYBr3ZNaYXpdVzFl3IurZcH7EKdzt+W28CeR37ohi3zAJdQ18ms8A3cVWXD
cEaRF0L3acx/OPkX/97XI3pDmReYWLJIK+f/YnLlMfVkNV44PWt/UNHpL9bA
OnZjWrww+0/ixd3bf3FUGU+zuz4vLByRrt14+xcfKyiPC7XihXLRvc+1Sf9w
bZqAyocIXni9b2pfYsE//F0uxGDwCS+Yv4vpcMH/8NLLTWumWF6w56IJo4Z/
WO7FVLTBc15w8tUo6hj4hwMTaevfXtP13bSP+cm2iXVjr9TNVPHCK/nh2YoL
m7jwfo0VdYkX7tqMpriRCLQMw0aR4BVeMB3TOnueg0CL5/j69dc6L5QGtL05
wUegBUQMHCxj5AP22qOHTkgSaMZxa0rmPHzQOjEr0aRBoKEzDJPl/Hyw4vQq
mW0vgaYmzvJSVpgP5uSypi30CDThZEHhOQk+6NbcS1AwIdB+pKtshirwweWF
4cAORwLtm4NmybwSHygPb+2udiPQ6hV0PU6r8UFR1vc9rd4E2tsco/Gt2nxw
6vmOu8eCCTTvItuWyoN8MB6hu6zyikBz8rn6YLshH/izFzBbZRNoVrs99R4d
4YPbogoR+D2BpodvF1me5APXhrhFhXoCjavuWdKfi3ywo/ZWw79fBBrDg5en
rS7zgdF3lyzZFQJt0TCT/6M9H7wTJTdFMTLQuj8XBUe68MEHZ88MWxEGWmrH
V5edN/hgoNRZlfMwAy02rls+KoAPAt5tZeo+yUALOTM4vHaHD1QPvShktGag
uXz/dao+hA96pVGB5w0Gms4YC1yK4wPhUkLWeDEDbWcG99qnBD7Q75ivKq5n
oFEdhQpUkvjggm/oylQXA404I7v9XxofIHYVN5c1Blrrki7P03w+0Nzbrde+
j5FmS7w2+PkzHXsf3DgyyEgTlfrUuf6FD5ICU9M2Fhhpn7UkWrZ/4wPnY7Of
f5CZaBpXPn4I7OWDZZ77GsYqTDRSm2CCxgQf9DkLNBy/w0RLS35vlsjAD6rb
a2pVVZhpI7tXGq6q88Od1qPq/HFEWpyZcVW8Jj+81L75si6bSDN2SS6p0+EH
wYqrd/0+EmkFLw5nSO/jBw6JQx/754m0u6xP7307wg/VPidkPI+QaHKd2rDX
jh9qtq2E7mMg07p+P9R0dOQHB9vQrofCZFoY2w+l2Kv80PWAqvV5J5m2uDdE
Ys6Dru9jIsifIdNqUnvWUgP4QT+gpXx3Hpl2yd2vkCOeH9qSig74nmehaah9
L5R/TuerwxDn6MlCY5uH9weT+eFRnWamwQMWWq4bqSjgFR2rqTG35bHQ7qg6
FD1/zQ9RFi8a/etYaOZzjUWlb/hB3srvpEAfC03+nVJxZw4/uLcfufz0Nwtt
w/Vx8WIeP7BxJH5kJ7LSWlQWi3nf84P588m9ThRW2ovf5iVKJfzgyj/PjYTo
79rckhKjcn74cSuaSGJkBQNX8VJ7zA+WtqI3Bn+xgLjKrdJ7VfxwwW57+udu
Fvg9O1T64iM/yEV55rd+ZIEYl/SyvkZ6PCxPb+dNZAEHZbby1c/88MV7ZfxY
CAvsmb1SLvSVHyIIM1ovr7PAsLPaB5Mufoh/fE7t/jEWUHH+UFEzwg/EdPPC
Y4ws8OlKW+Wbv/R8xQrcXXAiwzNFjapPBAEYjSGfCTtNBtfpuKoxJgEoNKnt
332IDEJXrKqpbAKw8+zg6QEZMlg7TdZECQnAy+TEGZ1eEmw4bNb5KwtAhFVl
j4UJCZTtFD4bXxSAsK/TVwqNifDdQcrlrY0A8AiyWW3uJkLYFX4eLnsBGOL3
z7FVIMKk2/rxFmcBuC1ISHvIRoSX/o3fjvsLwOFIOW7dBmYQjnTqN48VgKR9
+w6qHGOG2qjzN4viBWDluGLySWAGz9gTUiKJApCvcaA1RpUZvjzbfbE7VQBY
o78XeQowQ2g6++jZPLq+ANXkmF4m2CzPmr7QLADsgl9Jri5MkI2THla2CkBJ
76dqV2smsKx6oiTTTvf35xDvIzMmKKnzcx3uEYA3lV0acnuYwOOr0eLlCQH4
0eqjk8PGBOPjP9cdmQShxGXXbZ23jNDCp8h+TVsQZK5f644gM4Lu1auTCXsE
4djpqHO0fwyQXZddV4UEwaxVQIm8zADh/qp3eQ4KQu/tSwd7RhjAeEzjb5ap
IHwxqtn3pJoBGkr2zf5wEoTVtrgIjXsMoCNwp5nVRRBEgFm/+QYDZDrXZKm4
C8Km8087n+sM8ED2kP1Nb0GY/NLozWvPAIcfGg9R7gnCEysrnb3GDPDxwqk2
k0RBcDdE1+nzDNTL4t55pQhC2TFyzQE+BkgV7HmUmCoIL2ar3TU4GOBug6Xx
dKYgqJckupwgMMB+deuPwUWCIGHYZe06SQAa+WpRRasgGDc17xPFBFCxzo4e
bROE8xPDKVKlBEgun/Xg6BQExvKHVzUKCXDLzV3lTL8gqPV7fonNIoBur9fr
pUlBoFZx5m59SoCy7MAERSYhMGJnrzrnRQCSsZloLEkIlmuMj1I8CHB8cttT
BjYhcMpacxp3JsC4bHNMB48QJIQK/S61JQD/U+HIAEkhqLMSOLTnFAGsNKZ4
fkoLwZfjveEPThDgdVv5I7MtQqAqfjh94hgBEJf1wx2KQqB0znq99zABnO68
ud+uTdd/7qd89G4CvKfeIqO9QhDyIHneWYsADBXHg14DHUeKkM7sIkDsyvKd
m4eEYPh9zvdLygSovrrv1nYzIQgKdFLXlyMAF7vAv0gLIRhjFlHNkCbA6Ywx
/79nhWB94OR/4lIEmP0R6vvVWgg2Foh7NEUJIGbRcc3fVQiUm3yUtXkJYLuU
sTjmIQQMCee2yXET4F2kn8dxLyHofcUqR+UkwKFmqtvWm0JATLmy34iVAJGO
C7MRt4VAZL+Hmy+ZAP3kWuf1u0JgbPoDlxIJ4LHf6UprKJ2vr/53Z0YCVAzs
/anzSAjuZcVU/SAQgPUGj2NapBD8LrQbavm3iZKKCu18nwoBC6Xuk/HqJpo6
eX9s5JkQHA5JicLLm2jX/JnLx5KF4MrXW65mi5uoUZFwSS6d7n/W0tTU7CYS
avg6FJ4pBH/7w75N/dpEF+3SLqy+FQKK2yEHrulN9IbZe+DSOyE4otD41Wxq
E/1JMbT6XCAEEdlq+ysnNtF+JNGvVSwEv/CBSZPxTfSwb/bsyzIhkO/2WGce
20RdPlU9nFgIuvL73/aPbCJZ4ejT3lVCkFlpqNk7vImcC+y6fnwUgoCIna1/
f2yikuM6p458EoIpkRd5+nTMPMvRUdQkBC+XrojmD22iY2EDJ2VaheDQ3a36
B+k4Xj6vLaxNCOL9pz02BzfRaO1d0z8dQrBAujD1nY5VbE59udhD9/dg3q8R
OvZj2GHS1C8EH6Uyanjp8mMH2Lu2DgnBrRDRb5fo2OT+9PnbI0LAna3R30vH
pY3N473j9HoUMZPzpfOR485x0fhJt/9l94IunX+4acSfiBkhUIkXi9pB928l
2u3WzzkhSIrNNN07uomsu03JB5eEIH9I4oYXPR5N4uqPkleEwOew86Vuerw0
LggKr68LgZ5ou/mlyU2U/HI50WyTLs9e91rw5yZiG+/cmssoDNGaqzm/6fm4
tqMkm40kDMvDxysWZzbR4NV4jcuswlBMntghM7eJDN/5VWAOYSA83jD2WdhE
klq6nz35hUFJ0FLg1comuu8nZd4iJAzXZcyd/dc30XwF4bu8qDA0Rx8av0Gv
pzr96l/fqcIgmkfuuE2vP7UHqde05YShtyHgzAFmAjxruvf3yTZhsOG/ryBB
IoDricOcBkrCoLstwZOPjQA9MfLRL1WFIeeXylFlDgIc6GGT+KcuDENa5zQv
cRGAcrFZMX+3MEx682zy8BOgytnUWMJAGA6JSHx/IEEAxbz/2r2MhYG6/1OW
DZUAMUsCll+PCYPxWQVRC1l6//t3OgWbC4PWVrsXD+QJIBBiGTp3SRhOxcv3
imsS4GbzXn5jO3p8bpPlq3QIMMEjlfDKURg0K16m3dYlwIfYocyzbsKQ7lD2
89hBev+m2TZ8vCkML4/mtyrR51HrxCFTaqAwPPD/UZ55lgA6ivI9vveEIabx
vMH+CwTgzv85qRwmDP5XxX/VOBCgmObKGv+ULl+3tVb8JgHY+nwPOxcIQ1zz
+YJdbwig4fWa81GRMLw5fWWIO48AF/m6vuaU0uP/XaWXqZguf3jXuTmaMMhs
+eqkXUPnUzjr5tksDKv3JBT7+glQGW6T4DsmDBleVbmMQgwwLf/kQsKkMAht
GVT2l2AAkY+VW8qnheGHJq8L9xYGcF6XzP07LwyXy890BKozgLh9d03ApjDU
GKgdjD/JAN77js4EiYiAdtr7Voen9Pukzz8/XUwE/hX9XHJ+wQAtXlne9ZIi
4LRxUSI0iwG2ZrMwsW0RgcPRw0fIFQzQJlot/FBVBM6up7uQ6Peh0qLmvieG
IlCRMujb/B8jjL6SjkryFwHHjaQD2wYYYfru0CpTgAg0aRQxyv9khHnrlPP2
d0RAWSHkvdofRiBISSuohoiAyM/bRme4mUA0llpVFSsCkeJe6d8RE5gES/0e
zRMB//f+Wm3JTHDq8oCZ4XsRyDnB4Nrzhgms9JLKsktEQOH7pcddxUzgtCkZ
7EUTAZmjNt8KWpkgyEtSkvWzCFy6FhPZsMkE5XYSxoqTIvAgYujGgTPMUK3f
/y5imh4PXb8lqcvM0CD7XHhpVgRe1MlX9LkwQ+eA+PCHZRFol+5zXLzLDPOn
xH2PMVMgbmL7iPNbZljd1TeQT6ZAjc32ue1FzEAQeKYvwk6BDus+6yIaM3C2
ivEO8VJgVnECG7Yxw/bDYhnuUhT43RLzUnSZGZS39nJ2ylCAfORk86F/zKDB
nOCxeysF3tu5Ze4mEUGPJoqYd1JAfp7I5yZIBMPEnlR7FQpYv9ELzxEngol/
PFvzfxT4VyiQmS1LBCst0Y5oHQr8NZ8qnFQhwmWhnt1reymgpLXgK6tJhCuL
T1Os9lGAecHlCWUvEXxyKVe3Habbr/hmq3WYCAHh3V9DjSigXcwRceEIEYKu
PNX6fZQCopTOn3qmRIjaTmEuMaOAAyubpO5ZIlhabU0ftqD7016zwXeeSN+L
/zPksqTAtgv1ndnWRJj+BL+0zlPgCNcoH78tEQo2j0RcsqbAV7sSg30ORPDf
dfa/8MsUOJN81Gb3FSIccLLvKLanQEGLTTiTCxHaOwLFuVwo0DPHPEX2JMIz
jgis5U6BKP/9GQbXiWCz/7n1pWsUsDvB4m/jTYTFt0UZxX50f4JE36r5E6F8
uMZo+CYFLofFcP66QYS7lK8znIEUuD/QdCP8FhH4702rX7pPgea45LzoQCL0
lK52PgylAMlTR5bpLhFe/Cb5FYdTYNxJasH2HhHULKUrOaMpIDGlvEm9T4S1
x0o2WnEU4Kpc/HjzARGq6naTLyXQ4/dlbG4ohAim/5kfKU6hwPI/93e1D4kg
6nDp949UCli0/uA+9ogIPxJdn3BmUEB6tf/aVAQRMttvaGhlUYBisLKSEEkE
d7bQbutsCnBuPoi0jSKCDsT5P3xHgR2Z0zJHYojAeD1NqriAArbLR4+ZxhEh
cghf5iyjQGzOr+9Vz4hwRriZRauCArwUc47/koggc6Qny7qSnn8Bd/fGFCJM
BY4ffVhDgZu5zTrhqUTIK16cK6qjwNjc3lM30ongO8MQ/aOBAi0qA0XxmUTY
L8etxfmZAr7xaxITb4nw9ZH8Tet2CmTRsj5SCokQ/1FD+mEnBQba7ykwlBDB
el2vpqiHns/GgTHJD0SYt7Vi4xyiwMZQbB9jLRFKnzm91RyhQEWm5qvGBiIE
fvU2sR6n95eS3mRLCxF4dZ/EFP2iwAGvAfNHPUTo8kjW/vGbAqOccQnGg0RI
fv22j2ORAgG9Xx4bjBFBRbBexnqNAoRj/LqkBSKsGH77GPaXzjd3W27dKhFo
AT/siwiikOliebiJQAKT6Y1sDrIoTPO3/E7hJoGIDJupJpsomB5us/MUJsHg
KeGli5yiYGkQ9SVMigSu1aq7i/hFwe3XuaHHKiSIiLetu0gVBRvtGsV1MxJ4
XQ/08JcVhb99V051nSeBlWmiVOxWUTjB9GTPhgMJFNk6vJoU6faZz2+n3CLB
Jx/97ZraolCb/nR/1hsS5JpdbD++RxQufHh8taqYBHGqNwKuIFGwOmsxS/1I
AtvJgq4UfVH4RzqmlP+dBIyn5R5wmIrCfQL3AzlBMkyqw65tZqIQ8Mna3lmW
DK08lkP7LEQB7SqN2FAlQ1L9E20vK1HYT7jPOnyMDHu0mKaGHEWhSayphxZO
hmvCPwyL7ojC60/JATXCLGC58Hf5S5AoZEyY6HfJs8CBFsrL6Qf0/8MRj8T3
sABf8PF16QhROBLVRlW+yAKr1lfT9zwRhdBA0aBVDxYY1H1w4lSMKMyrMj6f
DmKB7GVaVtgzUfimTzt14C0LRH/tO5WeJAonZ9pTU2ks4J+9wlT1QhSYfpAn
5NpZwCZEILcvTRRMmKpaq8ZZwMhWxfJPhihEXnrK6b/OAmr7jVn43tDjGyen
d5SbFUQl7QsUc0QhRCo3EVNZaQxrdy4cyhMF80ClwioOVtrEtyQO60JROP77
rUDBCgut5V1ZsX+xKATP31CKGWGhvX/YaRNbJgo/Rll8nVpZaHf1uT80VYqC
xJ23t1bTWWjShTevan6m208rezpuzkI7E3XuM8e4KBw+zukl9p5ME89nE3Oa
EoUdxQ3diclk2sCXIrtPv0SBEGQjrBtKptlw8zEELYqCr+2v290XyDTnkNr/
NhnEwMjd4QiNk0wLDFB+OicuBroZ5W2dLiTagaS+0WNUMci+VXZ6w5JEI1c8
UMuWFQMhI4sz5oYkWtj6cKPjDjGYjwh69XYLiRZzPe7fsKYYhGhvM1r5TqS9
vsJg02EqBldvN4ypWBJpV0Kzc9XNxYDRqCO2w5hIU8o8+zfytBgMvPiPo2Av
kZY3Xhhz7IIYDKfR3ghQibRya8dP9VfFID7FNOj8ODOt1aJNqey+GJhGK5jG
3mKmRXoF+FHCxGDdgeOAtwczzSxmZ73XIzEQ/ySiFmzHTOtpC76oHiMGqjai
cwomzLSRo3ui3r4Ug0ueCnJ+ssy0lQNpq0kVYnB+wOy/gC9MNP+ypDs1lWIQ
jv9uBtUz0Qhq8ZyTNfT/r+RIWZiJRpZ6JK3WKAannEyOHM5mogmtehvUdIqB
m8rkXG0YE+2/t8ZPJ36LQV/Cfo4TR5lozoKLWqqy4pBy0j59YYCRNh86U2W2
VRwEm2n+Ed2MtGuMk8a+8uJw5xwnRaeNkeY/23+hWlkcxBKmWPNqGWmhn+ru
m+0Rh7ZN8W75bEZaxo2ELh8zcRCgPjEfu8lIGx7d710VLA6EgBcvYQsjbX/S
5xc7QsXh+8y5NlMpRlqyxZnmyHBxyNV6VWtHYaRZNbrJXIoWh/d94VlxnIy0
ntzkJqaX4mBcbveQc5mB9tXvH1W/QhwermTlbNYy0Kp4Sz/VLYqDy/KLYB47
Bpp0o/6i8gqd7+WUq1MXGGgBd79Ixq2Lg3e+6N6KMww03T8THvaMEmBy/X6K
6VEGWmmfsCQrjwTwDHbObNvFQMtLv+ZuqCABo58a2Y8zMNBe7FUVa74oASvX
qElckQRa1VG2O+s2EnBm9+J+tVAC7cf54Sl5ewkwE7/qZHiXQJMNjC4NcpaA
y4pyCaeuE2iptaunwU8CZiTf/Bg8TaClHauKy4+SgOAQdqUQSQKt9kIC4Ues
BPzO4TvwQ4hAG3PztOdJkACXg2GgyE2gbY3aqnU1RQI6dLvjd2xu4lddIZ1b
syVg1z6/LGe8iTMunhCKr5OAb88DmVV1NnG9u+LN+gYJiDhZxby6fRNP3CGO
LTdLgBvr+L8k4U28/VVR4Yl2CYiduFL2YPEffj0lZsY5JAFljn3ONW/+4UyP
kScBaxIQbSAT+EzoH3577xqv3U5JuHMqr0/98wae3nMu8J6KJNjo5ra2FG9g
xcUDCy//kwSLxzd1D7zcwJnWAt8GtSWh0sKBrcRrA2eg/LgzByVhStdJr0Vy
A6eu/pY6el4S8jLD1+Ivr+P4q1eUdj2WBNLKovjtb6u4R+5k0okoSYhx3eGv
WraKKX27edxjJaHivJtMWfIqjjNkn89+Lgl6xOzOM06rOHpbZuH2TEmgHOV3
a/23giOGxveIV0vCmMlkYaXkCg42u2TEtCQJk2t+zPkHlvGLY32Wl1fo5026
Cxxll3G5gZlz3boklOZkqxMYl/H83kOPQxmlQLOkkreuYglbblXo5OeRAvan
D8u+aSxhtT/z1nIKUvD7T4f3Q+lF/D0u0Ff/ohQc6LhYmjc2h1cj10PTbaTA
JWFBNrhqDgs89HzOai8FId+FeUwT57DBbVtas7MUvHY5LN1iNocLHAxJ5v5S
MJAQOxBQ8xuH6PBF2sbSz3s/WtyrN4t39aW8Dm6WAiPTSr3ominMo2S/ktMq
BcLcp64mBE7h6VtKh7rapGB67nF6C0zhVNmyke09UrBLL/BE04dJLODULtUw
JgVfbcwKL5ZO4DV/JiMSgQpXbOwFfWhjeCLN1j2egQpSTxLGcgPHcMfnT0+V
mKggLnl7/ZD+GM6jRkyYk6jQZ+/G+LJxFDvWiAelc1Dh+Oj2oZv9I7ibXaPy
MIUKOtbxI2TRYVyr/nSiT5QKbZ9ZVMxHfuCCcxvcbuJU4D2sy3Ay5weOyKmy
eipFhcv327V9Dv3Ah08c25jcQoXVJr9j224PYQ3/PNmb26gwftmvPPf4EJZL
EzTik6fC8lWxp9KyQ5jwp/epjiIVFi6/GeyoH8TF8faaoWpUeFxRM36BOohf
VTdaSalT4eDd83mTcwM4alopKH8XFXz2f601SxvArrpL7b1aVIjdPeiowj+A
rewsNlx0qMD+2vJpcfN3bBxRJsu8hwqhfzp4i0O+4+0/brsrIiocaRt7eIjj
OxZiH31KAypoe5t9mmrtx8zqhytP7qeCrn3U6o64fjx4j4vnhj4VEvtT/RKU
+vHnbDdN3kNUkBv7Edj+tw+Xd7ZbpR2mgmdQ7Zbylj4cJ5/wttmICjQB5nOx
fn14ceFg2p0jVBAoN+G6btqHj1XMP9M+RoXaw+P3XBT7cOb9xKhZEyoErvuK
+7H2YdIJw7A0Uyro/bY9HzbZi60llu+cPUkFD7u/2tFNvbhiPMWP15wKLByp
NXfyerFo3hGPulNUuOTb43EgoRdf8191vHGaCnvJP6VoQb249WCa9X9nqbDW
GbXa79mLFXmPn5m0pMKMsCkh8HIvvt+7cTzJim6fffpRuEUvHknLMDC7QIVd
tdk2w0d6Mbie3MduTYUG7Zk8K/1enKBD0K68RIXn286+7dPtxcvMb1S8LlPh
j0/nnKZOLzZtObV9px0Vrj59am+o2YuznzJRh+2pYOB2lmN6Vy9mtckRfupI
BUt42b1IxzZKZ7mPXaHC7XdX83bTz9NWSGSiMxVM21Uvxmr3YvHqvH+lLlSI
HMl1/76nF3s/tFp2daPrt/DPHIde3H6KbWarBxU+HhrkDKHzU5Z5P9rnSYXN
eLzjuWEvDpm+2B95nQqP6t0PrR7rxWPvOb8d9qbC/Uue3l5mvXj/7ZKmfz5U
KO13nZo704sTjS7XFPhRoTo1oFXvQi9eE+Qtd7xBhWE5fZoBPV5mg+X51FtU
EIyMvzXk0ItzM+2zOgKocO7JTqepq72Y45rAy7BAKmid+i2p79aL7REtfv9d
KoTr7mJu9+jF1axXIlfu0eWTHnD6XevFku3CIdnBVPAuDdOSut6LfROrb9s8
oIKLRf5QOv1/h72Lj2goFeZkf7r/pcur/Sfm1hpGhZ+qYZiVrj/8b619UDgV
cp89/1h8pRdP1rlf2BNB79/b743+2PbiA5GSFvOP6fmRkejNP9+Lky0bjmU8
oUL6zC3P7+a9eGPr9UNW0VS46XR2p71xL7aYk0YCsVQIFrCp0KPHt6CsWaMh
jgoDGav5Nmq9mDvIRykgngo3hig7aTK92NFky1aNZ/T6uqXKb8zbi2tFv0hM
P6dCvYf5k82/PVhm1F/wRRIVtu7n+fh1ogffyNnOaZFChbHru1MrvvTgLp92
Zq6X9H7xjlL/UNyD1Q8EbFSn0vOvGMH/6XkPjuBSXPR5RQXJftJof0AP/tnV
+VM5gwrvmwo+/rnYg19cVe5NyKJC4Xy+sLJkD/6n2fv1+Ft6fzY28h5e7can
GYMbyDlUUP115cS5r92YJ/Z7iUcevT+S82R8bnbjKxdD3skXUKFbYY/hrePd
uF5B4/VAIb2/diT6Bch041u0h3FGJVQgTWb/51XRhaf6aVGrpVQYlFKcdAzp
wubrCxHp5XR9t/qSXU92YUWNMw+YaPR6a9aoKP7RibuytvqW1dL1XT806jnR
gfU+nb7uUE8FTmNugkpaB84eC3MXbqDPg3qhdK4LHfie9IKjRzO9nt+KvNrX
+g2rxeKzCu1UOAP9ii3x7fh5wfyp7m9UKNt25Ofy4XbM8nXLyeBO+vyNtqw/
vdSGBzjCjId7qPDvcJBD/+E2HBZosTdhiAoJSfKmu3q/4LGrc5Lss/T50h7L
vHa+GR8PlRMr+U2fn3a96rlBTbg845Sw3TwVNHxvBx3IbMRPhj9wVy/R4z2n
eEJm4hOG0yEEvw06P/YMXxdUi+MPyP6YYpWG7/9ELQpqyvERMbO0BjlpcGAn
n/oWHY/iRpRoZ7dKQ1u2n7FiUQoaecvSO71NGmQrRxvXd7xC/lDOw60gDb4b
Dj5123PQm8uy/idUpcGfBT2sLi9GbLlzpn17pSHrR2CTdftHVHcgnDBjLg3u
XWPJp7rbER+XvdgtC7o+X1NlOf9vyKpznwbPGWm4sYVWD1IdaNlhyUntnDR0
jPTbmth2oq2PLDuvX5KG2ayvO3j/dKO73TuyN12koWrzmpakxADa51x3lvcB
XX/cqpFZ6gha65o8WBMiDWFaqj4v10ZQgR6HmleYNFD1kkfjTEbRVspxlv5H
0qDbG7tiuz6KOGp6CjJipGEl87wcr/E46qLMcEKqNBjEZwwMfptEkXd5VufT
pIFhi77vU7kpZDSrNpKWLg3xo0XpRe5TqKLGq5Q9SxoGR4y+CXP+RKkuDHad
76ThxG4NiqDONHL9KEBzxtLAsifs5ZT7DNqhopklXSkNqX5Dx2vfz6Dh+NMx
7VXS8MYDhEZXZ5C5a+IVnVppcNp7On3ixizaI7adQmqWBtuRhb/+ur8Ri9tu
9+c90lBH2ChMV5hDVb3nzpn0ScNjiRO1qYfmkN/BgMNM36VBs/+gkv6lOTQj
9lHSYUga5Ktl4t2fzqH22qON6hPScNOrKimKYR4liVvLNS1JQ5NMpUtZ5TzS
+U9ByfoP3d/VzfC2jnnUbrCoubIiDZeYWJLTf84jFq8gI7kNaTjiNGMYLLCA
XL9kuvszysBO0T286NICgqAFmiK3DOgsX2G0W1pAPc/KG6p4ZMDgs5tULmkR
eebfa7fgk4FdNFvvGuFFlDEoPHFXUAb2BF0sMdVeRLy793D3i8kAbej7mJTv
Ivoxe/fcw+0yINhY7GO0sIj8SUftZHfIwJnzjazFDEtISELYrURBBvLUbjn+
415Choav744qycB6KQefuOISykttztq7SwbW/vJMvbNeQndOC6392icDx58d
Ll/7tITkqtNjjp6VgVMfCg9sD/pfheYeFnMaR/ExpplpVdjkcdku3ncrGpVW
xUreb5roGbnLKpUuLhU2MtlW2akQSpmUsbnVw4Q1mZRWu0rU2jbPMCq1af2y
1lCiFV1m5jfXnf3z/HPO5zzn36MmyrlaKRWFgNV6iGtfpCbpktBbyTEILkzJ
Dx86pyaKpIEnuXEInl/K7vqhWk1SJ/Gs7+1AkO8a5mpNqcm9aHmGtxBBtyfy
5XtrSKS2NnZSAQIvVfXZgXYNYcVbpVwsRCCre7hxAqUhckX4wbliBLWqwT6v
Pg0ZV6YuDS1GYBZJYg/qNORayMKnWaUW3uA1lXysJWOn6kM+VSDoiSmtV6Vp
idiz2aOjEYHvIq7LRUSTaws3W+fcR1AkaArr8qLJveDRfp9mBLmuu8ElgCYf
Itwqin5H0Fu8nTm6niYrcvOc1z6y7PdvyV1pLk3Yf6+b0taDwG3+nu8bP9LE
8d37YdFzBIMtJYuyTDTxHTvc7t2LQFUzJoy10ZGECXWFJ18iwHl3QDRbR+4v
mGm9uh/BxCj3UUG8jmSIVcbHowhsT4G+ldKRU+cyqYNqy15f8AKVgzpy/YpD
vacWwbQt82+YDDryrGF5eoEewa08+6uvHfXEf0A2HMbE8H5G2Z4XcXryMUjY
r5iIwa/RrnnLiJ5wV9q2ZEzGULVlfvcxtoE4b7oi5dljcLSzaxqcbiCrvn0W
lz8Vg8RH/l1SkIHIzi6mBI4Y3NPS28OLDWT7CKv9oQeGYf/EEAbfSGKu85VR
czEExXaEKyOMZGPcYcWQJ4ZnbQFTX6YYybIn41scfDCc8Bc/6ThvJG4yZn3c
Agw5djOPfq4zkjfxjAo6GMP1rMpJb5tNhJoOl06EYPBKnpaQ0msinW2iMufl
Fn+Rn88KrYk8WGIuDRFg2ClctZLlbSbSGabCojUY7pe/pc6Um8nWDn36nGgM
qyJfvjgiYEDU8YD9DTEYjGp/kEYyYANk7Fsdi6Hk3OaskWQG8OW63WkJGGj/
wBLXEwz4Mo+Ob0rC8GFcYDvVxgBVkCYsYj+Gta13y8oSxkF89bDL8ZMY7ky7
zbOuZMKunPUGQZGFN8/GKuUBE9LW13bbFGPYW85UGigmHBtLKxRLMHAXnB/I
tRsP8q9p/ZkLlrynN/fa7RsPdJP5zysyDIzAXlM0YQGzOLYm8YZFH9CyNJtY
YLO1qcCjytL/9LrXR1NZ4MQ+xJfXYFjcmTGUU8ECvoBd8/OvGKTly5wPfGYF
4g6bggd/YKDq/pkR89gKzl7enZj7EMOu/vKl7a+t4LJQGRyqwCCq4mWyDVZw
e6pYp1Di///poZVz2EBF2ic+7cIwEDrPoTybDX08YfDpbgy8vg2veiVsGDJ0
On3Tg2FDtShCIWMDs0zS9ReFQW3/vl7eyQZ31fTgVyoMo5yrir2IA/NqDzhJ
31j6d7XEsP04sOjIc3pbP4Y162YnBi3nQJj7hZsD7zA4JSc4/JTMgdSdLk6f
PmGoUJ9cEXCDA5mLs+maEQyBXwU2mBo4cMT2VadwzOIvjZ6c9IgDP1Zdztdq
Mfi+Gdzo944Dl7JYO+7oMNj+0utYquWAbO22pZkGDD0eYalX2VyoRS2OS0wY
mHX5krgpXGgccaPNZgxn6N8+ts7iwn8pp5rE
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 10}, {-3.1409904859064612`, 3.135862469267913}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184537495724*^9, 3.536264983999473*^9}]
}, Open  ]],

Cell["\<\
Notice for this set of parameters and initial conditions the model is no \
longer valid after the first time axis crossing in the last graph which is \
for tension.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Animation", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["\<\
For this animation we will draw: two circles center at each end of the bar and 
two lines tangent to the circles to repesent the bar, lines to represent the \
box of rocks, and lines and a circle to represent the sling and payload.  We \
then animate according to the time solution above.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{"tg", "=."}], "\n", 
 RowBox[{
  RowBox[{"thick", "=", 
   FractionBox[
    RowBox[{"l1", "+", "l2"}], "10"]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xc0", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{"l2", " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}], "//.", "sol"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yc0", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{"l2", " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}], "//.", "sol"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xc1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"-", "l1"}], " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}], "//.", "sol"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yc1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"-", "l1"}], " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}], "//.", "sol"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xl0", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"l2", " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yl0", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"l2", " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xl1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yl1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xu0", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"l2", " ", 
          RowBox[{"b", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yu0", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"l2", " ", 
          RowBox[{"b", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xu1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yu1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "thick", " ", 
          RowBox[{"b", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xblo", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"-", "l1"}], " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "i"}]}], "]"}], "//.", "sol"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yblo", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"-", "l1"}], " ", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ".", "j"}]}], "]"}], "//.", "sol"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xb1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yb1", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xb2", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yb2", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xb3", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yb3", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xb4", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yb4", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "l1"}], " ", 
          RowBox[{"b", "[", "1", "]"}]}], "-", 
         RowBox[{"d2", " ", 
          RowBox[{"c", "[", "2", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxL", " ", 
          RowBox[{"c", "[", "1", "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], " ", "boxH", " ", 
          RowBox[{"c", "[", "2", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"xh", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"l2", " ", 
          RowBox[{"b", "[", "1", "]"}]}], "+", 
         RowBox[{"l3", " ", 
          RowBox[{"t", "[", "1", "]"}]}]}], ")"}], ".", "i"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"yh", "[", "t_", "]"}], "=", 
   RowBox[{"First", "[", 
    RowBox[{
     RowBox[{"transform", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"l2", " ", 
          RowBox[{"b", "[", "1", "]"}]}], "+", 
         RowBox[{"l3", " ", 
          RowBox[{"t", "[", "1", "]"}]}]}], ")"}], ".", "j"}], "]"}], "//.", 
     "sol"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.518453759494*^9, 3.5184538686628*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Animate", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"Graphics", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Circle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"xc0", "[", "t", "]"}], ",", 
            RowBox[{"yc0", "[", "t", "]"}]}], "}"}], ",", 
          FractionBox["thick", "2"]}], "]"}], ",", 
        RowBox[{"Circle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"xc1", "[", "t", "]"}], ",", 
            RowBox[{"yc1", "[", "t", "]"}]}], "}"}], ",", 
          FractionBox["thick", "2"]}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xl0", "[", "t", "]"}], ",", 
             RowBox[{"yl0", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xl1", "[", "t", "]"}], ",", 
             RowBox[{"yl1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xu0", "[", "t", "]"}], ",", 
             RowBox[{"yu0", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xu1", "[", "t", "]"}], ",", 
             RowBox[{"yu1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xblo", "[", "t", "]"}], ",", 
             RowBox[{"yblo", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb1", "[", "t", "]"}], ",", 
             RowBox[{"yb1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xblo", "[", "t", "]"}], ",", 
             RowBox[{"yblo", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb4", "[", "t", "]"}], ",", 
             RowBox[{"yb4", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb1", "[", "t", "]"}], ",", 
             RowBox[{"yb1", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb2", "[", "t", "]"}], ",", 
             RowBox[{"yb2", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb2", "[", "t", "]"}], ",", 
             RowBox[{"yb2", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb3", "[", "t", "]"}], ",", 
             RowBox[{"yb3", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb3", "[", "t", "]"}], ",", 
             RowBox[{"yb3", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb4", "[", "t", "]"}], ",", 
             RowBox[{"yb4", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb4", "[", "t", "]"}], ",", 
             RowBox[{"yb4", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xb1", "[", "t", "]"}], ",", 
             RowBox[{"yb1", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xc0", "[", "t", "]"}], ",", 
             RowBox[{"yc0", "[", "t", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xh", "[", "t", "]"}], ",", 
             RowBox[{"yh", "[", "t", "]"}]}], "}"}]}], "}"}], "]"}], ",", 
        RowBox[{"Circle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"xh", "[", "t", "]"}], ",", 
            RowBox[{"yh", "[", "t", "]"}]}], "}"}], ",", "thick"}], "]"}]}], 
       "}"}], "]"}], ",", 
     RowBox[{"Axes", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], "-", "l2", "-", "l3", "-", 
           RowBox[{"2", " ", "thick"}]}], ",", 
          RowBox[{"l1", "+", "l2", "+", "l3", "+", 
           RowBox[{"2", " ", "thick"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "l1"}], "-", "l2", "-", "l3", "-", 
           RowBox[{"2", " ", "thick"}]}], ",", 
          RowBox[{"l1", "+", "l2", "+", "l3", "+", 
           RowBox[{"2", " ", "thick"}]}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "tf"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.518453759494*^9, 3.5184538686628*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`t$$ = 0.5403709411621094, Typeset`show$$ = 
    True, Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`t$$], 0, 10}}, Typeset`size$$ = {360., {178., 182.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`t$858$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`t$$ = 0}, 
      "ControllerVariables" :> {
        Hold[$CellContext`t$$, $CellContext`t$858$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Show[
        Graphics[{
          Circle[{
            $CellContext`xc0[$CellContext`t$$], 
            $CellContext`yc0[$CellContext`t$$]}, $CellContext`thick/2], 
          Circle[{
            $CellContext`xc1[$CellContext`t$$], 
            $CellContext`yc1[$CellContext`t$$]}, $CellContext`thick/2], 
          Line[{{
             $CellContext`xl0[$CellContext`t$$], 
             $CellContext`yl0[$CellContext`t$$]}, {
             $CellContext`xl1[$CellContext`t$$], 
             $CellContext`yl1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xu0[$CellContext`t$$], 
             $CellContext`yu0[$CellContext`t$$]}, {
             $CellContext`xu1[$CellContext`t$$], 
             $CellContext`yu1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xblo[$CellContext`t$$], 
             $CellContext`yblo[$CellContext`t$$]}, {
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xblo[$CellContext`t$$], 
             $CellContext`yblo[$CellContext`t$$]}, {
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}, {
             $CellContext`xb2[$CellContext`t$$], 
             $CellContext`yb2[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb2[$CellContext`t$$], 
             $CellContext`yb2[$CellContext`t$$]}, {
             $CellContext`xb3[$CellContext`t$$], 
             $CellContext`yb3[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb3[$CellContext`t$$], 
             $CellContext`yb3[$CellContext`t$$]}, {
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xb4[$CellContext`t$$], 
             $CellContext`yb4[$CellContext`t$$]}, {
             $CellContext`xb1[$CellContext`t$$], 
             $CellContext`yb1[$CellContext`t$$]}}], 
          Line[{{
             $CellContext`xc0[$CellContext`t$$], 
             $CellContext`yc0[$CellContext`t$$]}, {
             $CellContext`xh[$CellContext`t$$], 
             $CellContext`yh[$CellContext`t$$]}}], 
          Circle[{
            $CellContext`xh[$CellContext`t$$], 
            $CellContext`yh[$CellContext`t$$]}, $CellContext`thick]}], Axes -> 
        True, PlotRange -> {{-$CellContext`l1 - $CellContext`l2 - \
$CellContext`l3 - 
           2 $CellContext`thick, $CellContext`l1 + $CellContext`l2 + \
$CellContext`l3 + 
           2 $CellContext`thick}, {-$CellContext`l1 - $CellContext`l2 - \
$CellContext`l3 - 
           2 $CellContext`thick, $CellContext`l1 + $CellContext`l2 + \
$CellContext`l3 + 2 $CellContext`thick}}, AspectRatio -> 1], 
      "Specifications" :> {{$CellContext`t$$, 0, 10, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}}, 
      "Options" :> {
       ControlType -> Animator, AppearanceElements -> None, DefaultBaseStyle -> 
        "Animate", DefaultLabelStyle -> "AnimateLabel", SynchronousUpdating -> 
        True, ShrinkingDelay -> 10.}, "DefaultOptions" :> {}],
     ImageSizeCache->{403., {214., 219.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Animate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.5184538751368*^9, 3.536264984132114*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"NeXTAutomaticEncoding",
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 76, 2, 67, "Section",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[680, 28, 115, 2, 34, "Subsection",
 Evaluatable->False],
Cell[798, 32, 205, 5, 41, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1028, 41, 268, 7, 27, "Input"],
Cell[1299, 50, 191, 3, 20, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1539, 59, 91, 2, 34, "Subsection",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1655, 65, 131, 3, 24, "Subsubsection",
 Evaluatable->False],
Cell[1789, 70, 46829, 1118, 209, 40742, 1015, "GraphicsData", "PostScript", \
"Graphics",
 Evaluatable->False],
Cell[48621, 1190, 431, 8, 41, "Text",
 Evaluatable->False],
Cell[49055, 1200, 263, 7, 56, "Text",
 Evaluatable->False],
Cell[49321, 1209, 861, 27, 88, "Input"],
Cell[50185, 1238, 208, 6, 41, "Text",
 Evaluatable->False],
Cell[50396, 1246, 9324, 300, 1123, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59757, 1551, 125, 4, 24, "Subsubsection",
 Evaluatable->False],
Cell[59885, 1557, 153, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[60063, 1566, 834, 28, 58, "Input"],
Cell[60900, 1596, 585, 19, 31, "Output"],
Cell[61488, 1617, 353, 11, 31, "Output"],
Cell[61844, 1630, 289, 9, 31, "Output"]
}, Open  ]],
Cell[62148, 1642, 167, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[62340, 1651, 1860, 55, 73, "Input"],
Cell[64203, 1708, 1684, 55, 31, "Output"],
Cell[65890, 1765, 414, 13, 29, "Output"]
}, Open  ]],
Cell[66319, 1781, 179, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[66523, 1790, 1793, 59, 43, "Input"],
Cell[68319, 1851, 3791, 111, 34, "Output"],
Cell[72113, 1964, 3559, 111, 33, "Output"]
}, Open  ]],
Cell[75687, 2078, 87, 2, 26, "Text",
 Evaluatable->False],
Cell[75777, 2082, 448, 10, 27, "Input"],
Cell[76228, 2094, 110, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[76363, 2100, 1159, 38, 58, "Input"],
Cell[77525, 2140, 274, 8, 31, "Output"],
Cell[77802, 2150, 423, 13, 29, "Output"],
Cell[78228, 2165, 424, 13, 30, "Output"]
}, Open  ]],
Cell[78667, 2181, 113, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[78805, 2187, 167, 5, 43, "Input"],
Cell[78975, 2194, 520, 17, 34, "Output"],
Cell[79498, 2213, 667, 22, 33, "Output"]
}, Open  ]],
Cell[80180, 2238, 213, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[80418, 2247, 291, 9, 27, "Input"],
Cell[80712, 2258, 1661, 55, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82410, 2318, 291, 9, 27, "Input"],
Cell[82704, 2329, 598, 17, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83339, 2351, 434, 14, 27, "Input"],
Cell[83776, 2367, 1096, 35, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84909, 2407, 434, 14, 27, "Input"],
Cell[85346, 2423, 1151, 37, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86534, 2465, 600, 19, 27, "Input"],
Cell[87137, 2486, 1769, 58, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88943, 2549, 600, 19, 27, "Input"],
Cell[89546, 2570, 1745, 57, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91328, 2632, 571, 18, 27, "Input"],
Cell[91902, 2652, 1203, 38, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93142, 2695, 571, 18, 27, "Input"],
Cell[93716, 2715, 1155, 36, 31, "Output"]
}, Open  ]],
Cell[94886, 2754, 233, 6, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[95144, 2764, 337, 11, 27, "Input"],
Cell[95484, 2777, 2395, 73, 34, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97916, 2855, 403, 12, 27, "Input"],
Cell[98322, 2869, 9810, 290, 126, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108169, 3164, 196, 6, 27, "Input"],
Cell[108368, 3172, 1584, 47, 34, "Output"]
}, Open  ]],
Cell[109967, 3222, 182, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[110174, 3231, 165, 6, 27, "Input"],
Cell[110342, 3239, 46499, 1386, 559, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[156878, 4630, 134, 4, 27, "Input"],
Cell[157015, 4636, 4415, 138, 74, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[161467, 4779, 79, 2, 27, "Input"],
Cell[161549, 4783, 1157, 36, 31, "Output"]
}, Open  ]],
Cell[162721, 4822, 166, 5, 26, "Text",
 Evaluatable->False],
Cell[162890, 4829, 2327, 72, 43, "Input"],
Cell[CellGroupData[{
Cell[165242, 4905, 152, 4, 27, "Input"],
Cell[165397, 4911, 5574, 148, 103, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[171008, 5064, 152, 4, 27, "Input"],
Cell[171163, 5070, 1505, 43, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172705, 5118, 152, 4, 27, "Input"],
Cell[172860, 5124, 1002, 30, 33, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[173911, 5160, 90, 2, 24, "Subsubsection",
 Evaluatable->False],
Cell[174004, 5164, 278, 6, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[174307, 5174, 142, 4, 27, "Input"],
Cell[174452, 5180, 2315, 70, 53, "Output"]
}, Open  ]],
Cell[176782, 5253, 293, 6, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[177100, 5263, 722, 22, 27, "Input"],
Cell[177825, 5287, 7309, 185, 192, "Output"]
}, Open  ]],
Cell[185149, 5475, 132, 4, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[185306, 5483, 111, 3, 27, "Input"],
Cell[185420, 5488, 9219, 246, 213, "Output"]
}, Open  ]],
Cell[194654, 5737, 226, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[194905, 5746, 356, 12, 27, "Input"],
Cell[195264, 5760, 955, 29, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[196256, 5794, 356, 12, 27, "Input"],
Cell[196615, 5808, 957, 29, 27, "Output"]
}, Open  ]],
Cell[197587, 5840, 388, 8, 41, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[198000, 5852, 4183, 121, 58, "Input"],
Cell[202186, 5975, 4923, 131, 103, "Output"],
Cell[207112, 6108, 1341, 39, 30, "Output"],
Cell[208456, 6149, 923, 28, 33, "Output"]
}, Open  ]],
Cell[209394, 6180, 138, 4, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[209557, 6188, 589, 19, 58, "Input"],
Cell[210149, 6209, 254, 7, 27, "Output"],
Cell[210406, 6218, 254, 7, 27, "Output"],
Cell[210663, 6227, 254, 7, 27, "Output"]
}, Open  ]],
Cell[210932, 6237, 120, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[211077, 6243, 2007, 61, 58, "Input"],
Cell[213087, 6306, 8084, 216, 211, "Output"],
Cell[221174, 6524, 758, 23, 27, "Output"],
Cell[221935, 6549, 758, 23, 27, "Output"]
}, Open  ]],
Cell[222708, 6575, 83, 2, 26, "Text",
 Evaluatable->False],
Cell[222794, 6579, 1155, 42, 280, "Input"],
Cell[223952, 6623, 96, 2, 26, "Text",
 Evaluatable->False],
Cell[224051, 6627, 486, 18, 139, "Input"],
Cell[224540, 6647, 108, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[224673, 6653, 1081, 30, 43, "Input"],
Cell[225757, 6685, 1843, 64, 43, "Output"]
}, Open  ]],
Cell[227615, 6752, 110, 2, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[227750, 6758, 1489, 49, 120, "Input"],
Cell[229242, 6809, 23517, 391, 242, "Output"],
Cell[252762, 7202, 27197, 451, 234, "Output"],
Cell[279962, 7655, 15127, 254, 238, "Output"],
Cell[295092, 7911, 32930, 545, 224, "Output"],
Cell[328025, 8458, 25619, 426, 246, "Output"],
Cell[353647, 8886, 23825, 396, 234, "Output"]
}, Open  ]],
Cell[377487, 9285, 234, 6, 26, "Text",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[377758, 9296, 80, 2, 24, "Subsubsection",
 Evaluatable->False],
Cell[377841, 9300, 358, 7, 41, "Text",
 Evaluatable->False],
Cell[378202, 9309, 11885, 391, 761, "Input"],
Cell[CellGroupData[{
Cell[390112, 9704, 5471, 150, 156, "Input"],
Cell[395586, 9856, 4687, 100, 450, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
