(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   4883423,     100213]*)
(*NotebookOutlinePosition[   4884321,     100243]*)
(*  CellTagsIndexPosition[   4884277,     100239]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Trebuchet 3", "Title",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Input the definitions for the vector operations", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Input the vector definition with the command that follows.  The \
path will depend on where  the definitions reside on the local system.\
\>", \
"Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(<< "\</Volumes/Users/alan/Book/Rev2004/dynmath/math3/vectors3\>"\)], \
"Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \("These Engineering Vector algorithms are copyright Alan A. \
Barhorst"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[" Modeling the Trebuchet", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["System Extent, Choosing Coordinates, and Define the System", \
"Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PICT", "\<\
000000000A<1M@0A0_l<0?on0000B00004P0000000014`5e0000000N00402P00
00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
00400000000000000000040000000000000000000000@00000014`5e00030000
00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
M6lPLfEU87AXJG<PL6USM7EbIBh0003o\>"], "Graphics",
  ImageSize->{373, 275},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell["\<\
This is the full Trebuchet model with the extra bar on the bucket \
end.  The model will switch for the given motion regimes, dragging, machine \
motion, and free flight.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Define Unit Vectors and Unit Dyads for however many frames we need \
for the system. For this example we will use five frames of reference as \
shown.  \
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[{
    \(a[x_] := unitVector[A, a, x]\), "\[IndentingNewLine]", 
    \(b[x_] := unitVector[B, b, x]\), "\n", 
    \(c[x_] := unitVector[C, c, x]\), "\n", 
    \(d[x_] := unitVector[D, d, x]\), "\n", 
    \(n[x_] := unitVector[N, n, x]\), "\n", 
    \(aa[x_, y_] := unitDyad[a[x], a[y]]\), "\n", 
    \(bb[x_, y_] := unitDyad[b[x], b[y]]\), "\n", 
    \(cc[x_, y_] := unitDyad[c[x], c[y]]\), "\[IndentingNewLine]", 
    \(dd[x_, y_] := unitDyad[d[x], d[y]]\)}], "Input",
  AspectRatioFixed->True],

Cell["\<\
Define fixed relationships between the frames of reference.   Note: \
these are different for different base orientations of the frames. \
\>", \
"Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[{
    \(\(\(Unprotect[Dot];\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(a[3] . n[1] := 0\), "\n", 
    \(a[3] . n[2] := 0\), "\n", 
    \(\(\(a[3] . n[3] := \(-1\)\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(a[3] . b[1] := 0\), "\n", 
    \(a[3] . b[2] := 0\), "\n", 
    \(\(\(a[3] . b[3] := 1\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(a[3] . c[1] := 0\), "\n", 
    \(a[3] . c[2] := 0\), "\n", 
    \(\(\(a[3] . c[3] := 1\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(a[3] . d[1] := 0\), "\n", 
    \(a[3] . d[2] := 0\), "\n", 
    \(\(\(a[3] . d[3] := 1\)\(\[IndentingNewLine]\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(b[3] . n[1] := 0\), "\n", 
    \(b[3] . n[2] := 0\), "\n", 
    \(\(\(b[3] . n[3] := \(-1\)\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(b[3] . a[1] := 0\), "\n", 
    \(\(\(b[3] . a[2] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(b[3] . c[1] := 0\), "\n", 
    \(b[3] . c[2] := 0\), "\n", 
    \(\(\(b[3] . c[3] := 1\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(b[3] . d[1] := 0\), "\n", 
    \(b[3] . d[2] := 0\), "\n", 
    \(\(\(b[3] . d[3] := 1\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(c[3] . n[1] := 0\), "\n", 
    \(c[3] . n[2] := 0\), "\n", 
    \(\(\(c[3] . n[3] := \(-1\)\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(c[3] . a[1] := 0\), "\n", 
    \(\(\(c[3] . a[2] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(c[3] . b[1] := 0\), "\n", 
    \(\(\(c[3] . b[2] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(c[3] . d[1] := 0\), "\n", 
    \(c[3] . d[2] := 0\), "\n", 
    \(\(\(c[3] . d[3] := 1\)\(\[IndentingNewLine]\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(d[3] . n[1] := 0\), "\n", 
    \(d[3] . n[2] := 0\), "\n", 
    \(\(\(d[3] . n[3] := \(-1\)\)\(\n\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(n[3] . a[1] := 0\), "\n", 
    \(\(\(n[3] . a[2] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(n[3] . b[1] := 0\), "\n", 
    \(\(\(n[3] . b[2] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(n[3] . c[1] := 0\), "\n", 
    \(\(\(n[3] . c[2] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(n[3] . d[1] := 0\), "\n", 
    \(\(\(n[3] . d[2] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(\(Protect[Dot];\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(\(Unprotect[Cross];\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(a[3]\[Cross]b[1] := b[2]\), "\n", 
    \(\(\(a[3]\[Cross]b[2] := \(-b[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(a[3]\[Cross]c[1] := c[2]\), "\n", 
    \(\(\(a[3]\[Cross]c[2] := \(-c[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(a[3]\[Cross]d[1] := d[2]\), "\n", 
    \(\(\(a[3]\[Cross]d[2] := \(-d[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(a[3]\[Cross]n[1] := \(-n[2]\)\), "\n", 
    \(\(\(a[3]\[Cross]n[2] := 
      n[1]\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(b[3]\[Cross]a[1] := a[2]\), "\n", 
    \(\(\(b[3]\[Cross]a[2] := \(-a[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(b[3]\[Cross]c[1] := c[2]\), "\n", 
    \(\(\(b[3]\[Cross]c[2] := \(-c[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(b[3]\[Cross]d[1] := d[2]\), "\n", 
    \(\(\(b[3]\[Cross]d[2] := \(-d[1]\)\)\(\n\)
    \)\), "\n", 
    \(b[3]\[Cross]n[1] := \(-n[2]\)\), "\n", 
    \(\(\(b[3]\[Cross]n[2] := 
      n[1]\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(c[3]\[Cross]a[1] := a[2]\), "\n", 
    \(\(\(c[3]\[Cross]a[2] := \(-a[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(c[3]\[Cross]b[1] := b[2]\), "\n", 
    \(\(\(c[3]\[Cross]b[2] := \(-b[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(c[3]\[Cross]d[1] := d[2]\), "\n", 
    \(\(\(c[3]\[Cross]d[2] := \(-d[1]\)\)\(\n\)
    \)\), "\n", 
    \(c[3]\[Cross]n[1] := \(-n[2]\)\), "\n", 
    \(\(\(c[3]\[Cross]n[2] := 
      n[1]\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(d[3]\[Cross]a[1] := a[2]\), "\n", 
    \(\(\(d[3]\[Cross]a[2] := \(-a[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(d[3]\[Cross]b[1] := b[2]\), "\n", 
    \(\(\(d[3]\[Cross]b[2] := \(-b[1]\)\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(d[3]\[Cross]c[1] := c[2]\), "\n", 
    \(\(\(d[3]\[Cross]c[2] := \(-c[1]\)\)\(\n\)
    \)\), "\n", 
    \(d[3]\[Cross]n[1] := \(-n[2]\)\), "\n", 
    \(\(\(d[3]\[Cross]n[2] := 
      n[1]\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(n[3]\[Cross]a[1] := \(-a[2]\)\), "\n", 
    \(n[3]\[Cross]a[2] := a[1]\), "\n", 
    \(\(\(n[3]\[Cross]a[3] := 0\)\(\n\)
    \)\), "\n", 
    \(n[3]\[Cross]b[1] := \(-b[2]\)\), "\n", 
    \(n[3]\[Cross]b[2] := b[1]\), "\n", 
    \(\(\(n[3]\[Cross]b[3] := 0\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(n[3]\[Cross]c[1] := \(-c[2]\)\), "\n", 
    \(n[3]\[Cross]c[2] := c[1]\), "\n", 
    \(\(\(n[3]\[Cross]c[3] := 0\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(n[3]\[Cross]d[1] := \(-d[2]\)\), "\n", 
    \(n[3]\[Cross]d[2] := d[1]\), "\n", 
    \(\(\(n[3]\[Cross]d[3] := 0\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(\(Protect[Cross];\)\)}], "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["FMR: Angular Momentum and Linear Momentum", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PICT", "\<\
000000000@T1JP0A0_l<0?on0000B00004P0000000012@5Z0000000N00402P00
00012@5Z038000000@T1JP0OP0200800PP000<]X00000@000000000000000000
00400000000000000000040000000000000000000000@00000012@5Z00030000
00X02P0000012@5Z0000OWAYIVH0000000000000001QL71/000000001001JP49
04P0001800000<ZL004:E4U6AR0XC5YG:@00000000000000000000000000000H
ool0000<LgAbL00001h0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
bIb0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
oGo0H71H?2FamHN1_g5@=nHg2ho8I79I?:GAoIN1_W=IMoIG?Io@J7AJ>SHenIW=
HW5IcCHYnjCHK7IK?JKF6Ib4jj1__NKKOKoPL7QGkC@IlLN3IYlkaml?WLoXM7YE
[S_P2MO>MGVM?^Mg_Mo`CWM@80NF6?KdN7eN_fNggA3>`?bP9nH^1?kD_]i_mo?J
17jn;<?hPCCWnel2^JOl2_S0L6Wlek5`Rel3@2c[<@30cg`e3L>@j[ch]>OIlWh0
010:O42@VO/D7TKa8Sn=8b36;aN66IH4PJ4QDU:GIZA/1@006HIV6bN21AA1B1Wd
dk5WhOD5BNO9k5:CQ;Rl<8/3<=`f4>A1<4BAA>7_49oWg9Il_o3deCG=TfYnn<Wc
:Oh10@14d7nO44WbNQoWbKiTUNBP00200h3b@Q54JEH?0`6A;T4A`TQh89HUjIIg
84N/S_[3<bc@O3mWbNIL5@E09PD0YiW^M1_7>L3bPVDiEV9>iiWhN[>`C2LgEiG]
OEnTSh^JOcCd603VWk1<3>JO9`TZ?PaP<101WM9h@Q67@70<3YoWROPA0^3Y[6nM
AhX4oLiCjNlWdhOSoGLCi;4f?Xl3`PAhUTFYF0Z3@G7/iYjC92ImWjOTTEgH64X0
oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm7i18I4oX4o859000@0m
7dmY8oghmWXog^iQR80H/eX[7:k7T0005f<`VbjVbh@`30Ln84l84k7dnW6jgFnG
`oIQ0WdmGnngXaEd_0T30H[5LX@B3P@YeD^gcF:Hoge0WfngcM85F95NkiOKmOl1
PL5Pl9QL=QlARLERlISLMSh;;j^oi@1PAMkbniPn70g6`3PL17flg8`Ef^1>;R@k
iVZDZVR/A1l/EZ]Zhod8T4HHCBIlYNGnmW^mh4n7biVn40406<d6Jli?N/dn9=VY
PoNU`<QfnigNmgo1hO5ho9iO=ioAOiO9]n0060k_F7_G7dnEV]e`EbhEX4kD2?@i
4HBQDW`TPl3B=`9YDNQj7Pn9<56CIRVJIIn98ObGZjV1iT0>XhP>X0>1440i3f?Y
d7DNR[9PTQk[VP[[;dm<IaY6/KA_74Lae7LNAjlJB7hc2/0<0X0:dgkOYTj1o`:O
ij``OAo:`OZiWjNbh7/PAk7RNAd32=0_56EYF0`3`F74LAf7nOYgUREI>Sl@i97R
^iaVfI`oS^=@@QB6Qi9=2c]BTbTGaU7e3dAA=5DGAU6dMAm88LUm9Wn0[UWh[e0W
X^<<^Y9QkYR[=A;dUilWLMifVl00300HQW6J<@e3hMii;bMXl3P<8e3dA9a7NOYi
W>K9AT^@i04BBahX6_E>7k33fDSJ=YFWJUZf]Jm/Fc94<Wn0BE<XO<<AH[/PCFOI
oBFYUBY>^Al>8OihUPEA<4BAHnW8MAd2h=0n9LTl/WhMaGUXG164VC9<T/AiUVDH
LobHPK[AOL/TFeRf;haS>=HgSV>XQKU_00TU`b0TUce4Tal>=IBm;^hM37fMXf3<
:SQWDCaB5480T2dMl/^e9ZiI<OIkY8O[[7gUZBgHcEaHmYnXJSZFYjYZ[8FhO^@b
Q@=0fLgin[_CdZ/dOEWI6mQo9WN1l7dNS[IDh1liC36TBARFSY=2j/D7=L;d;Zg0
L3`G1l9`^[JlOH0^F[4;Kf_DI;/[Z[^8OJV<e@9k<e:UU7nNNC;O_<V7Z^/];QC6
C@/O:j^8Z<eg6OCfJm3FnL=f_KM_g7Lmdl[YI<m`0JKefD9NOC=7fN^fg<[9hCnj
dSWlfim>6[T;i6_21aNNbC7kJ2mMSMV_^agOao9l_cO?m2;[e::i000P0[SDC[D2
[ZCOH^In9=TVC84NQk9;;V?i5kBAmSlID?ikA=7=3jBF?=D0mTX^<I<QLPl1EX?Y
Pa1V3D6dK410P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCOcmPChOcoO@00X5Nd3OT2O
D2T<IOlIN/2SlIOKhOkgNclTdQTkoRdEO[hUd]V[kUT4OCmO[aS<^OkkOldO;nOE
=OU2RMAZECZUEZeG[5I[EK[UM[eO/5Q/ES/UU/eW]5Y]E[]URR/WOD/0040cgT4R
TlgPShO;hN<e`4IVL2OLbOSjY5@OckO;gO3kRciY4/O[nNTG^57RdFPLVXCkd3i]
^SdVUdfWe6YeF[eV]ef_e[nfD<d4nfL2TdcOU?aFhgf0P]2hFEOddVo7Z_2Pe=TO
1Z5PhFbTe7d7B_<2OX0082O5?`3jVFLPVLlF1PWCPfilFilN4k7_mV`nGcnWend:
n<=lW_Vd=o;k`10<1@6/KY9dXb8<:OQlZJm;>8bOAlY:VcWX>ckM[ROS9_:Zij`l
Q;Q`Z[cJW_4[JXB0<DX6f[M/?1/2AQ6<IAW6Sd]noCn?fQSoa[7/OAo0Alb4PKV>
/TSM^DTDGX95Z4aJiTV`/oR[B<Y<<BFPL3^C2/ZXC0lF^U580b9;4PC=<ldCC=De
cI=/gBg3R3]ZClj6i>b@=fPKQB4YKI7]?j9A2Y3nZ_?Sd]^Om3;1?SYAK3bD]aA0
0DW;bMA?=m<DcCE=diC]?DnZ=6cbk2QBZ;ECPcE8?EF;MFTiEiaeRQ=;`XO[J][9
:^EY49na:^bED0ZkXd@c[I7OHi6FC@io8j0YjFNPI7FTLEZE1Je[faK=]FgKSCdE
:bJBHgM_VeLY=G>:MdP_MH=gJ;]gU=N9bgW@:QBRZMLf:m22g^[4ZelK^0PCPH^H
;OE9P0PMgRk<AeHMGe^hSRF9hYR^;Fc?j?b?3C@8<hEne8O/k6hBfBRL9`V0X2P9
1=U^5UCV5HW6OZJ?SOJZFNbj1ElNNNc1HRZEg4B2hF0NS29Y5OH618QjJ0nWS=Z=
JH_ZVZf_7B5i]6j6JaZf_JnZ[VJiD^P9?A4^e8b5K6Q]Q:kL8nh0a^@B164`b36<
aIUTFYd7>MB]][V1DSI`Um;3GSY7Sa@5lH1G71Sb64LL1EVijNNdK1c?=C=[Z4jd
h6^BWcOAm8[W?_Djm2?8fAn;hYJ16@I9UTNB192>90V0P289QOgXdmnFgPWGhKYN
;/]kV;i>S07PX^FnPOWX;8^bc8i]aG2;7/hAaP5hAQ0_O1XCa=[:_aM;lod;HOZV
XaA5Q/5e:RW_jgZb<hE1e[:^?e7L3YGbLi>;QU8/gK4nV0b?GCVh>@jXk1XChV8I
XGXOhlaj3h68<<H`R8=0mPh1J3`;H@1aQ4;^4PjHC?E8<465@1XF18QL>B612CV<
I8I0DlKI3YRgQd167SgU9_L5i459jBd3_6I^@IT41hUA;:VQQ:JEDVTI@dH/X9iX
K7HOHj:0LB7n;;QY0<iS>G?6bAI5f;LC8d7fI/LP]iKbSV4MHMPNZOcR4c<g19d1
0e7S;Si1XA0?Y00>T43N@T8PhRhT@hXN8f960<TLl^A`31@BCNPT<PXl9<9hG2oi
Nco43S:U03VDCbf404U<0RE0EYE:?TZJ8Q2D3M]CSC;>FQ3WF4j7XT8NjnGi8C@d
XTai=GoXj9bCYj[dFc?5NZ;2IPMiW1_VP7RJ@NYZ2KV/M:ET[bV^HU[=de<Jc[a]
<hX=@KmbC3fA<Q=/a`31A6WLCQVQ^aPCc4=?F3P?G9cg0i?/0DoEVP?X1205/laP
:hJ73LlCoaoc>3_?/3P[j812XU:P1329kQoX`bX2TS1/?EAJRfQB:f>cNY9;A7Di
H/8BIX?lIHbQWR]5H;4I8b1VSU78>TNPlak7BP:W/d2_aoYJNTL`YZlabRQZ@6:Y
@OZVDLUJmDE5DATeCTeD:T]EcG6NPDjVLQkRSS?6N</L0h1_3A6T=8J`eje3H6iF
TKHm1kX;ULNRKS8EJ<o7l?:_@V:nB20MAAQ4o@1<80KHD75QaJf9UJ[UKjO0`f?1
iI6/Hh3Y2?/]95Q3KQ:T36=If`@fK@9jX>/^FEF;C>U7jWmWDiGF2o5l<40P0`32
H4^9`JXe1/RC4T9L0H0P3df7>L/OAAYbA9/V9>i5S``RD^II<Q<b:A3k2;M=c3dc
RVk[[JNkAGdMCRZmEdXh`QQ2nWj00@0PA0R/5J:lCHW1@><0R;lH@bBJAC^cMV_0
M[m0B_i3hkB:F4=?0?OiiL?08_P2m2HM;46@_96:`PMV4B33A`X/fRV3R1^FZ@:4
5F7I<3`QU=]heflBFX>`T9B0oJXRV0:0@0hi1aSV?=;l@8P12diHdAY5lhc23Fal
8W8625cRJ7ATESaWjAe1V<@R;hogPRfKH=2j:bhThUb/EVHTMk_Uh8d>4L8gHF02
@HG4TQ0QK2i5l>DM0ki=_GY2H@d4=YC04C4`P5VMgNP_2_W/=fOF5Q;d12h908M2
@/0=OiOBO;YQ55SXe5ZO3J/id<`PQTZP[FJ=[5LP]fL[jMHUBLKhga^/86><HI<`
R@bo9Z?FG9?CZVb6L<hIPN@lQeZD5hEf^I5@XZ6mJMidj[BJ8673HV`TU?ddm/T[
=FRTZTZlLeS@n1<[W2H4d:9KaJ2c5/;8F`]cVW68cVmF/DCOW/0o^LHNjEA;Q<o5
ToY;2Ac:>8?b?VYbF8B9Z102P5Ac3Z7G10ji_J:03;XL@iR9c:RAhD6GQQWTA6Nc
K/[RC57kRi5b;NB8jae3]?=5HYH^AL2k3V78>XI>C2ci@naeRmj5?jQaL9jeN;A3
m3WcE:Yc5Lh<hWc/R9Vb<ea?j?HOHmB@/jhh?`N0?PQ1;122H6hB@Q1?0>0410j1
f3[=4ZGLYamPaB=]^E6j?3>hlZ2NjnYP2@iT^8XV:@oa^3M721L408[EV47Z?<Xi
8b@PS122@000P34aWE^4O0nQV3:6F2`5`:b@_[@FNmSYRbI659]4OWWUb0?n1@>2
@F3@N4@V2_V6?f7@J7?f5@EnAF8`Un_]n?mo?m?alLSPM_Ym_enA:C_mI[9JW4h7
<h6hh[mN<9m_QoBIo_]m?f>ab5`b1_jR@J6?V1_ZU@=mdfRCmoaF=`QJeEWEN1e:
/aF9ef_En`F6aF>bFFcFNdFVeF^fFNB_ZPE61A^T?fh?>1>Ig>Q/002QI^^:9?Mo
X@mX1h_MigFCa:>_]l_R<g22cZPBB>AfRe2Oe22cV1IAk@9mc_BG:iCQo_R>G1kA
_B^ih_D00T5_B1DR1GIo?1f_mk_PR48RP010;B`:OcioceK;5ITPV4WB`n=j2U`i
n?j=?oVFg`N7aN?bNGcNOdNVbAN2dfB`n:E::dogNb2Nj2IeoYM;9T60J1iBU<E0
f3P>8eSH=aUVHIal7/O;88fZK7>BS[<>HOQmZPYD><XPkl84NTA:HYZ37a4j37[5
A1aHXJRX;3SeAU6LJA[6dKa`gJWYBNjh=PPAgW/MR178H9MUB4`EQlN;A]<NYgWN
i;F7lO:U/jaana>eRQWnNIi7ZLYc7DoBh[RcclXTdcE]>i<9;Vi/;8hd[BWlN[<7
n4PFQNHAWVZNkUaldJ<U=@QJ5`Fim9bo2>WhNilT6@913/>hkdBkjh`Vkc]?Q7=>
dmCm@E3DCdZNYlB9hYJ9Zd^J:aR_9b7:E1C5>:h[2b0H20<BQ:T^Nj=9nNAiWZ;h
^S0NYiW]:QnVJIIW103XAVNIaYb[5ijWX`R9W]KMG7oKLVX?3QPg7Dl]86==d86R
=^e7M]gGON5hXPcJiYm7/f^JWI_3@<HWT0@Y<Wb^Qi^[4[P>EMAo7_Jj>9=EZU9e
JAXQN60J7]GdbC<Q3@CDbRDCNZKH<Ndl7[TWao2^;h`Sj@i7BfkdO7[>B67[21lI
/gJVh4TPHijFnOi>XM<Z0bdcgUXnTJCYFU_JYZ8XSEL?_MYe>ALOa`j`Cf]2k[Q6
TFAQb74LJP5HEYGP:0`4248`S`@=`Y2V:Ye7@MJhY@WX/R/;Qg7JNBO^2^568ZNo
2E=ERYX8Io5>>0AGLLYi7LR079SmbZ4Tgc1cLdPci:iYW?m1d?AC;MBO@Pi9h7ZM
aA4l@H3LV98W32JI[WTe2<Wa3;TZbc2LWhOCM<nOiS6:I1<TdCcVHcS;?b`dk_NP
X2OXfiWW9BQb>WjMIhWR1P:PdH1RVBOYl]6Od]dCO<eEAI:MR88`QRZ:`[7/NVI<
e2CMDI>STcCXcXh0@1P50<RKQR3YJA0@LXhdh62<PL6B20VH93WPXDUVhoRCW^C8
V8MHkQgSa:PgLS8mQm3P6l>4>XL`k50FZm=3A2FXXR7X6F6ST`00;Q`]lY9BPF@m
073mM0JB1YJLd>I@PYWBUfEC0B9TCHW7T<J@APBE634K;P?dLi0Qh/27n?U=<ETA
5C>B>^<PQA1R44V94B0L@gQ^86:6>0XQ@RT0f1X3Xh1`SUC8IaQ11c@<LCBK]Q3d
b37;9:`/gIDaFRa5`040P2ACRU58QTNbC1gaF=8I4NQS``QU34000801j[KK/Aa;
IVUF9bCNjB9l[IGB_GJZFFA1QiBe6U;L?4^@fBk57;dN4_hMXN?c7f?[P2YToBZM
N@Cd1;RE4`;HFP]gY;e?^`Hi/Bg72^0[=/0lgI]PEPe;=4:8P3CULH5:M4_ah5B4
9>f1</9hCaWTDHVi1379^9dkTO0jR>3fMbC]k:fC77N7V?LNPF:43jI^;TFh]QGR
]5H;:R@WJ:?07h5l;`HAhSbQ8WBHSc4d<=VG7fE1Z6=5AR^I@SAfR13D6^=`4e<@
[QG2V8lB`SaRS<6::dEHZQ01n3j2l68;P^QQ30>PN0kYSaN=FjJPK8B/ViV9?>ZU
EJ[5YGH@8HmF`heM3KElEmHBSeI:RO=5lebB9ENTDAn`mI27=:LJ4O26Xa3o3664
<UBH]ecC8OHPHb;00Y/406`Tg@3P=/@>jaAmTMTE:><fb5Q9@^C11IELH`A:fIR6
RNFCoj[fO]0^ik:<D:/V=M?dZ<ocEe@NPBPIPdAUR1]T/LN`:0C0W6V=4J0C[N>4
7^6`=HKPaQR3;7^SmDj@/LSmBA;RITj4TX=B92aeB>R=SD6PV8:`HP_2J4/9PPPn
Qo5JhhW0o3M>1=@d<P@mH4YY<YIjd=lKiCa7WODG]miMQ/3EO^bj76Xen=9=HQCn
677K=8AEVYZRMUL?d;4EP/02P30<>`MA_c7WK9o>Z1`S0@hMQ`0^6di@305a8=_4
aARQ48?L4c5UTXK><3eS5kPlHTgca]SMC[fIkB3>lW4OcPBN<OUDD1W@fA]SF0CT
UB0Q01P104;PF`]``iC2iUD;ba@X1?2T/6]ec<_B5bn`W;iWWOU8>hnAni9BN5<8
4Wm=JGJn;hFZKXg@mb7YYRi84O]k48?@=1Pc76PM1An[>eHR13[fWJLlOV/lkc@a
;_Z?<EVThPQid/<KC11[oJ;;Jla<TakS_BZHOX?hOQ0QJ2f5d4H90C08eMQn6d?`
1`f0I[DE6]hT]?dDhRcHn1/JoaLi=aV902cO[2:lR<hBX578<Nj/VPmXKANc7bJN
A3CTi9naLd^X9USmHFJlW[mGkT4BdQVE193__;^ALgCfG]ZHk=<?X`QMYC3g7/?;
>^KGWf]_@JQK;nRDc7NZ`Ej9=ajHd_Q]7QEE[>b5:8A60a2H4CFJRNj2PiaBLIbV
65bXOQZLOE>E^lf:M2L9;1^eC6GR<dUOl`SHG;`0P3f9Zh168/@cU_f6XPM_W>J;
QTeXCd@L=Q^j9cIbN/XKLd0ad^f@PAfM?JR]mZ>Q^5mEa^lb@;c:E?:>FM]lQ0c8
dNak2`h=OSm4oEo^ZEVk3UMIc6^ZTM2S2>o>lJ`Nj@cEYK7FHA;KR2>Seg`SaA:n
223dF2K^Oek3_<eFCSoOOE_8FPfCP8ciA2Y8LfEcdOPi?>2Blm3@<^6aanS8CXhc
;AUea;;E7o]g:JC]4>j?Z3:6H^4MH^UDTXZOM0FmiRlhh6OPHcJRDN<Pjn<RT_b9
CiCF1`ZW6oln`gAXKBP/9m?jgY^AOIlSm^ZinTdoOANE0i=7/e_?mU2lao]B>4Y<
mOi3E5[S9UY1fbTGHcDOQcI@3^1DCBSf7P8h`/7V646H6Z3Z444T565>5PA4gjk>
=2DH`2MfBZmTUFe07jF4M/ni0dUL`08>lVMf:j6_14jJm0nD4X/D7LFnJP8Zn`84
g:8/JZ>Dl/dh;BmHoXfhNVMj=8X6Hd9B_65P0W22`f0U28bB0BVb?Ln:LR4L3W2J
XX4j752RJ/PBJR1m2/092`f8/@0J/06@J/ihdNmU1Xm?0g3:AT82P3oPD3PT5Pd7
Q49PKnPD<O/>QcoQTBPKmPDFQclPKkOKlNclOCmOKiSD<TKjOdJRSmSCjTT6NkhO
4CVT9V/DW3oOLGUDZOdgOkhPCjOTFOm6Ne2OSdRCXKKGI8Y6Y1ICFM@=1hIHC1HT
CNcgO<hV/aT<<UDkOlnPCiXTmQ/:^5a^Ec^Ue^eg_5i_Ek_Um_eo^4LS[lUD4WlC
WDLJN;@F=<^?EFAN>CR[mUV4Pf7PdbXF1SVJ`6IS56Qm7RMZW4RT/GOkiV>V`Sl@
21@HH38KJFiGVk1nm5No@W1?O3Dg5NG7PKjiFLc<oiCjPfkGP6jP=jbkk0BkCGkV
FO_<^3glFQlWUlgWm7YmG[mLgR4;]lgTlBXckVE<me_/GjTf2ckn?dPklYb]2F84
OR69nPak8HO2E94PAl8/OIi[BLAD5:B@jT2Aii84Nd694Uck8dQjDW/NQj_fUAkX
e2Bd[FVK;9dPAk`BmTLAc7DMai7Zo<>`k_=0RD584`ARB@@4U3A9QGBLhl?;FO9l
^lPKH^NPc_BZP[HbVO<QX<f;1=2OcAX^mlH?f]kG@TO3X8I=P[CT7XO20LYc7@Jd
m<N<X0Cl=e0<5;c1=RQ;`89@Z2/??`017Ab1U5B8?DVMe:XfclRZ2VD/aW7e?DoD
5@e574d=@`dRE@XImWdNK;;@WAlZ5Ebf:>]ikWZXBJbln2M<8X3<`0/Dg`<]<4/@
PIj@K1jd>POijWJHYKTd5hF0`0@6Pl<0g4<?Xo447HL1R88S1n8HT22NIiWN>XiS
T8@MQl9PU2JLQe7DcY=52DhURJ:h5PB2QM5`HZ?Z30mAhAQ>5HG7TP//f<Q/4k1M
SORXiH_RMd`ZXKUB6ke4`586ADc:c<8;@VC898FB;e<[jC>dbSa:X2c7dWJ;7NMY
g1T60HR=Whi3V>XjS/?1MJ>D6TP7YM3/ZXbd]SU=;Wg8KHd?BH?1e[C3/h@^_1W/
4@@IC</@RVF8IIQVeKG]Vfc9V<e=HQ]S7nUbV:3@ZJ9HUb:90S2gYLeNB`A<lRf?
AEPYXWLb`E`b:`nXIklFn/S7NX9/54CQ23>>a3WJSC6TD0Lo5RFiFU/GIJ3D<Pb5
TE9F7dNYjQ84PA2b;@]6>IQWR49@Y@HOi=TbDP60D2Ye7TOYkh?]gViK0?3e[jFW
Yc^;lnSie?Hn`S15Kk`do0>Oa6AlSWbfPUMi>SSVWmU32c1SSWfK^[UC3Z;2_=Uf
GNVmkBX@@lC8Ua<080<0L8D1aR`98VJDXXoAeS/7H=j2AYSE7?8PBTUKE4P87IF@
]C;HPa@Q2S2<Q8HHC19Q@fEZ226d_IQM2n64<Bj50=934ViAS456FJIdeY9Rc8X;
B>XeXeA@RF3l6P?@S1eT262<8J@;`E0/7Z?/N9@`HPL1@8L>XP17RC4P9HCXUAMR
a5P:@CXX0L152F8@BXVQ>2P529<BPV1bS_7`l]=<<Xm4h9D?I:Q58<53@RW0nPfQ
ZSI6h=/K`da/SE6NM`NhmV3VH@NSLRYQ6K4SKTJAEcLR24M9BgmGYR6dBT<8nN3c
dCo?[ODZli;7BOVC7R:BFPIYK1jU`=^G@m9N46C6femd[gi]C86dd_S3VWS`VD;>
IPM9W1GVP0jJ@[iZ43OBCP]4fBG`e9nIPVKMDJAiAP?d/8oahA0PF@e<cnWZ:l8H
4L8`B@b1S3<g5UB47Y@[V4@VE4NioCoX1@4`4=d0[<8TVmPa[B5W@7b>@]8eQC2J
446`?`T1a7@6X=LL`<0EP_9A5@MhkPFPF10=lI8dfKSc7h?DM`gQ_RP4V9P>HPQ1
S]@RC/V8o5FSoTU>:PCcCCdgTf@d/0nJK<67l?XJ0bQXP3040L>`O`l244L8/0X1
0:5?Ln@aIYABL=UQZDLVCHi:TYP/J2X=?RhV7O^HFH:RVdVa79G<CmMGF1T4AGVG
@fb3CGOHYbMZ?F?:MD@bUYH0bkcGUn@ABXkQCf?D06hBETc^3G5]IL3=VAWfKWhZ
h`QBYbYE;LO@WK=Z55^8LF6LRARQYONTo]bK;eP4D7V?8NX=@J0g4484@TTAlf;8
^U>?2VXN=>V/U>WmbKUG;^HZLe9o7:?]8XIdM[6jTTj7@FTKPXQ:R23K5b8@oaTS
=6/101H3aj8fEZ6L:@E0RPc1R>4LXhQUSA6R7h=`MQN2_5X000X01GS25h>dMhn@
_1M3F>LN0mJN_h^J``RKReU]bYFA`McT:TSO6b><1h3P:3^7`>dMXn1h0_1J48?X
N1954W2JF1IIUGB[Tg9RCb_4C>B7hPiYiPS>G08@b=1J821SMb88?8`IlT2LbD>?
9UaT^=B@>[i];l5?]RUBMh`Cie6BY>OShe]b213Yc4:7<RC0d2Fc@>K=DZeGQ`cL
>O>4`Zo5_]GKlWD2fZ9Y9KJ`Rk=Qk3`7T?TN8aAWS:58I4GP_aQSR74lPN=`lnEQ
LA80R`iQbSX1>2H58XaA2UUBAbd<:/fC4`OZGDfYgWD4CDbi6J3BeT=7e98OPkA/
S35F2@3020B0f249<EP`0QQ72M0@18]AJRoAP?@L@h0DPJ0Z0008004P<0P?C1A[
An1_3f6l001U60;5Z;@HTiC>_He@Z0RJE6C6HOf?fW[6d:e94f9XDhC@X1GBX>hD
`ZA?030:1VUe_fKW>7fJXOaK9CX1:>IJK^=9lV29^ZI^LZYFBOD`HQ;eVaWR:hiT
P<hW^@:7b]G0U>D>5TR8hb39d;V@62DIUAZHfNI2HiX6_V`WNL3XieH2_^H2iCG7
T?@N=YJ68UD:Fk?=KQlS360;T001002E4n9XJhfa^2A4R9MYH2abSURG9nXM/baa
n6`=LK@4`90E5cf/d3bUKZ6DgU4`_:]cmek]gLm20d1f4W;>FY;bakhG7d>`XjjR
1MO7XFQ^PnQkTF7TQEENC1`Td7ZM0SAHAmSU7R>/Nid6n5X7]1[_32EBZZV:A92]
AZ3Q82/6448:`J0M0R0<1BOQMS86b?0WVDGm7j;8o]3n@Rh92?dRJC9cf@<[<A2X
Hgc@nO?3Em4F7diI9GO[g9nd;8LVF<ig@QG<5AVLi6oAnH1Oc>3Cd=H@gjnK1[VX
:m:12LilWUmaDlE`n84o/F@hXQ;oj2E2@Sj3UQC1B1CP5=YQ_QbQaY/T45EQoPlP
lQ0Vd[0T1<j>9;6W_1FV=9>YlQg`?>N>9_`?A`A`B@BRK74Vi9dUT7^25RMR?1oQ
j:K1mXP9c=GRL1h3:<8TS3A]@4dR;8YY=2a2c4S9;@C5@TC9/^`5F2M1e1iQh1bP
005P<1d3>QmQf0cPYYhP]0e1dW7UH8<7I>2R;3BRG9;3nUG/_4C2f2bXFYm>i3Y6
:Pg_fQO@j7I4E4Y9bWd4YZf>C<Z<_:oR4@oTMa134X=34560kA4PlA5QLA6XE71Z
fYna2V@3Ha92hWc^89e3m?6211hQaQ_1[02P3P8QK1N1U42SlR>UW47=c?_T0?P2
3YO^D@lR4[5a;@SALAL`AYf;W2S5C;E]g=g292MY=1iRV2RQfR>XZZ56HZ^2QZER
RQjR78M29;@T51l75RSRTaY6j7ZaM4LX;RQ<k6KTHRSQc1I1H1?P@PM0U?M211i1
a10Pe0]0C0LPSQ`XL2eTE8O1oSa7o;Y_>REWl<_53SC_^2I@k69Pab5V;Pi>=4_3
_A7^9ZgRi:fS3ZcWXYT<Z@A5?<^R>6SQM0kbABAP1BBYR^hR2B92l6@9[YBa9?kV
EAQ`;2EagRSQ^QOQK1B01040?1aZK90R;1n?A<m@D=EYg2gQk5L?T[27f6a9B/[T
]@:A_bYbZ;U=fS4@E2e272QA/6jYb99>2Y`8NZNVkYbWl491n7UaO2dSa[[VjX;U
D?nRC;Wa_BZ^lYA:62`RU2eSX1nQf0b0a0YQ31>1CTX]J1W0?P5P00o17Q;ZSR:1
^QXQX0;P:0=1U1VQZ45?[RC5VRc<l_/22WcQc<h1CQD1D0fcD3QPmQXCF71aKRo<
_?_?UA;^6@fTNV=1HcLa5Pl?WPn3LQYB;SU;3W]/7?j@@ROWcZfRK>6cRWcYD:dX
JbQ;Y2d:K1n1ZQAQ<100F0JPXQh;XZN`QT31nbiBRVJBRWhS=bD:mYK0c=61a9S?
bBkCiCiZOb[T0[AY;;B/mTJ2cV3YbXlBcBH_NXn2;SBUR3mb/>`aFcj2o8;<j4g@
kZ61k19Q5Q401=XPW0/0[P^7F0601P21;Q717WP=b[T2>0]P]0_Qh1i_6?;4S2F_
56I3FSGaYQn/e1c>L1>ZkZlQ4891_CI/OcT67^C7]BV?QcJb/CVBX<M^:]B1o/A1
fQDdYCD0fQ6d[1Zd/?_71P0d^8m`E7:;YZ4cZQZQBZ90307PF1fUV`TT3?nR`7P>
61oQgQi7P8n9A:_=cA:dS4RDTQo9V1IP<E0_dcGDm/ZBX[0a9B<CUWf^:V8^:e3d
]DPd5d6E:8H?P8J@DY/5Nba@G7VBP]GWed3e<6G47d2@_2L^mE:WlT8TYVbRd5I;
E9?S_Z6D42SVKAmQmQ]Q[1/0hPhPkTFDG9/72C>1nQe1d1dQ2:J?f[9Q9:iZ7D2Y
b>O71b:8H?[2@dme5CS_U_[XE/V1aZjQ?_f^J8j>^S_BHC@[233S1BBP1:09^DHX
;aUQ`Q_1[QR4o0;QE1J1[QjVkR=2CP^0^0]9U1g3UPfPg0h4o0217Q81:DlDGQoA
SDje8R5;5Va58QA0?f</h1cR3@kCQbXW1f@eXFA;2/LbD2hU3ecR5;52>BEEEFGX
K6WaOd2Y0;F43DfE<R<e=c?bj7YAbFJYaADBSVGe9fH8Ie=USUVRR@bZ_9`b`W25
DAoeGRSQm^YQ=1J1JQLRd;A`L1jQ[1[Q/Q3Q314^?1>1=1=Qj?7aVa2`o>D/YFRb
>2ifhdn6Ab=`9S;B?9GC@FB^^QbQ6FoeNPhQAg1YIDWAJdV/WQnD^00Z0E;VB44Q
l99F848QJ1K1Q4o080TPV0XPfG>PXPV0V1iU;4bX8881fQh[K1m0JPL0N2E1h/63
D9<UO^;@a6WcG^>150@GMGBT_1`GO56A6QLE5b:<_?iT_6A[5bE6=?a/PZNS3CKF
SGX/8FI7X6KUGZdb/6KTC5DfOAn?Ra=4J2JaDTd=EYAGY7WSlYbbnR92BbQ;?TB/
L=fST[JXUcaP`f02_UJ;a1V1X0i0k0kPgPh0i1DDY6a4ZT4f74f233W_i[0BWRo`
A<PG4`@Dn2j3_1ZH<<S11b6S8QE6a7cDTFk>3TYa9<_<]Xmd`<l^DAR63_RBIQe1
g1eQeQh8Q7^7I2M6oR9QO1PQS1=Q?1Ab^[AQl@mSm@ef9e5W1bAPNHUR1^eQLP8H
X@80ldmBYB:VDhZG322Va6]0MB6ZeVbE^Gcha:P<MWVEK293>WoAOSA[ASDVWb<d
574:dcR`EGIhaRk/HHL2DG``M/k_CaV9`bmaE1l1J1F@301000bcfG>QNXVQh4DQ
212Q3PC0CPCV9TcbQ4A3DY;4CAla8bXh94MFie5//9ES>7b1TCNg0V9bW7^FFh`c
dH9RibEHCXm8M2RDh7d;FEGY>:3SXB^Tgbne?^3QngO1c1315Q7`Tho<MB3HeDT7
f2A7fRB;5[5T_7L0]0Vi]F;U60HI_;SaJDShg_m>:SHPUicgM0@B8;20YIfP/IgZ
f_lX=fmbC[RhkikU@_PF]R5g96kheA^U>YF5GbefP3FCX;W5NHffO>5bjil2j_kS
i=f@ae?XkQn1iBQ@lWUQo1j1n1DQG1D0gPjPePhPdPb1[1V1U4a4?VK2E1c^M073
NP5UoPPPPPOQMQLgQD1Z^HQSmUEhZRhhSUB5<i@R1QQJSA4Pk10jU1PjV8EFG2h<
ZE[E[A221iJe;6HQmR`1iY^RL;@aV8NE@SU1nQj1iQlW;9`9=;OQe1`Qb1=Q=Q@Q
gdF1eJhQj=e2QSg/8UOII=9USieia^BQn83PQHUPN3]09561VK4cdRIdQ4]H/chR
1Idi:PCYD/c0Ok;hT>9fBCGj7K>iA2gimR6VkV=aE;I8L8M;E5GcnWZR8hieC7Zi
Uj3;HaHK?Fi3m7eUHiUfOR;=7QkQA1C1CPbPa0d12Q012D/1YbQ993_SFUThc[Y8
<D31a1b1`P;P;]WTo070605P3Z[c00aQJQIQJ1fQeQg6o3mT_9BYTK>H8CKIBfm1
oV=1IKi`hPoKk1TklEe2>A93>7cY[S>JWRiA<IGWiSZ038m@M4844:_2<4Z6KKV1
nEHaZDGZN48T8QdQ^Q^0903P4PQPQ0SPH0J0MjjYl@0BiTd[OY_joW1UKUL_b3WQ
:LHU656K308lKLITo3[06PWlN6WKf9kcae^?kU6K[0;R1Q5lT0DLUFEFE8E33cOQ
ElXhW:mdKkJl[K?Vn^5:NZNWo4RkC[FfZ5Jcl5CWZEBcc4[Hc5JaNKJL[aG7o5R3
41mQb1aQ_Q>Q>1@PcPc0f10Q1121^<R2:KLR@9/WU3l@0]efZCaWnSLQXLK07]X^
Wd;P20101k]06P1P0Z/>dPS0R0SPh0g0hlHQ:;;QKCg4Q`n?]:1VAG3`IT@9J1BG
0Q3mI>I1/YDRheZFma9?U9T>EcGU5ToL491/FFZ4BgfE=;CAb2?27bQ2QQjQkaUR
UBna/TGb``0dHTR86aE<l^R5JZLQT1UQWkiQI1SQRQS1`1^QaY8T:;K4U100ClU0
2?c=X00BB]XM84oK]P71aQa1bT]hETQ`eR1gV211JN2k304N4;7QCP;N65k1e9<<
JGi261dQd1eP<P<0=PePf0g1Z93QK1KQLP9P9P8cC1C@CeD4/lfnEFSYO<nCcR:l
cfRUPjX>5>jkmKh=?g4CSGWa3lLEfG5lLMjMjToNPLIm:01;olL=XWAmjNPnWNUN
RNWP0nQmkNYnZEf;3U6EfNPnRnQI4LLBAa2JS1QEfBUhEdUnd21>M1d<d1;<g0h>
/18nefE>EfB5?HA>Ej[8IHk7/7nYk>`j9Sj2C2O4cBchccaQjj;4G6jQjQSQN1O0
001P6191=1A1]1^1/Q5Q4Q402P0P7QdQb3l2L<M1]1_1^UaPP0304D;mkmiP20VP
U0X<n]HaYS=Ca>8`aR60L0KPMM90201P3LKABF/1_l<Q[Q[1Y>bQYL;2M1dQc1fK
^P7;7QFkEb^^J1:1_ej2Dj1VXDI5W1k5Q]8nEoaob4LcG]Aed4CFRmL<_T_U<`k:
mQ4oi7`0dQ;okDX71iARiWc/Z20?F19j21230240>50V60R72^87>9:R:<B;>n<?
n=?f>?b?AanaYoain:bC@P0B9lB]oBfEB^ABeoB9^cE9CLgCUAC]eCfAB1mD6AD>
=abR?n@DNUD^VDfUc:Se2Rb6=BRWEN/EV]E^^EfOc=l?bT?j@fAoc>EB=mDR`_mh
_Im>]K:]FPd1Pa]=id_R=?UoGbT8HoXim?Fcf9lf:a?ml?j??mm/AT/8FRdD`h40
400@70/8[K@A^IdIn?^A]]_]aE:iF^9c>Em_ao>Ab^L30D4@P1KX3Kd60X5P;=0P
2001`Qm?MgFMm20>R@cVLh__C?FnBjG?Ak?6=F^n_VoI1j?Ui_fIfRG_J_N_fNgg
NohO7iO?jOGkOOlOV^B2YES`7bmii@4Nl294J43Sa1:LSLE<6WY1jTZ8jSC@TjSi
9TojOXhd1K<`U06A0<DA6=4QkA<XjB9RU/7WXYRP^lOi6aTU1`aZZ:G8dK<M4=7P
dAlElP8`MlE7m2LDZNUZB@RoCe_k8T=:XOj[BI:TZZDOJIW//CH_>aJZ:</aoaJO
ia7>LaW/d1QPUhJbT7nOCZ;FO:@WhO1j9W;aoW^]K5]<OYmB;;b>47@SMP0c@014
48B7k;Lo]6DiEU@>hmS`JQZVZ@i44@?Xo40;H^2lgCQ080H10:U06PF1PHQP5QB5
6CakW]8Io^fN1f0X2P?5bGISc2llmcM01o_:fBR7dOSeCNY3C:3;388dm4[FYJ][
F_K5/feKM^:VoZBFnajR994eUZ75jA?o4QS3mMXhGNFEhg:TDU8hVDUbQM5Y9UOU
ngmOZSgdOiPh80V30EQ1IhE8jV``l2[_o9b=2gRP3h/G><9FO1WHh?F?GN>6<5c0
Qka^ab?Z=96CY8fDLFj[/UbG:NGiX[MX7X/ETbjSDlfW<I^5/F1;H@4AfWJSCC7l
OAk9VOM0;:/l:CXVM0FHafNJ@OAng:IiW6B207PEDP^Rh<:d4RBI85`GQL[5NdL5
XFYKP80X3PD186=d1X60N56o6LIQU[8O9k7ZkUV<HJaZVSP`66lKYe>`aIm@0SS0
I:aV7[9AeVCnOk`@YHUYi[dWBm=doDMCKRB@VYU`IMSDDG5?D25af`fmaT1OMgf:
UY9PCnBBSfBMTaKkANGGTT1iJ17[e]aiIhbV@bSF=BGTRB1ekBD2GkXnNnGW`bQQ
al`WijQglTGcZ_m?EISU<Y8AeGifQ;Dgf>TN/CMjCe7lK@YQ?251T3L:@lc09m7V
J=2Q6am3hO:P1bI8C`[@N<NQAXnaj3Y7@>41`3@8:V0>70>8LaH[a=72L_Y@@N0m
1nKXg@1`309@J:TWkCVT@gJ/?LKhgQ]6J08=PJ`geSXh7hXe4`kAk3h7ZFQc`o1l
S]84H0Y3KQnSh=<N=o3lh]AKRi5f;dGbA?HMVC9PC6QgAW5[6U7`J44Qh6O6lYQ@
2Q5>B<k<Xiof64PSe7^?TO7R;kGhm@[a86=4bHI7lY173o_Q5h6bAa2SST82m9=5
ioGNU:NRm8kY@El5>G^o1nKkdX/cS0]^51KBeYO8f]9o98S_3S529X@h0@3PM7`F
DNiXc6TJ7TB/N0lAeWM;>?lLhjQgYm8d?ETZag:B6;8//aYSP:0C0/@P0Phab3V?
<Bi?ie1FR^5LKX080P20c1T3DBPTa;2OWHE0/cPdk5WF8F/OHm`A0K0l5L:8F1j5
lR/ePB0RQ5356J<n1L613Qo3d4H9hDC3>OFC<<]1RgAbUX]ANS56J=5<T^B1QQ8T
F<J4kB<==9A1DW6_BTZkjbWB49F``TTR9GAc?WAlXRoXlTMMWCI=lW2>;U8X:P>=
@a2E5D`=DJUB@5e;H<0@3ECfC?Z>XOmNM=f0;8Ym=]OTO8_bR95:BSJEXD;@93:Z
53D4g4J7V=`K8d00P30N:TE@^WlaE>B?LOXG0`1QJLNDOXldA1NE>0TAXSa>6996
WPV9?fT=>7Z>PM8hbLQ/50:4D/g2X3m=X>D1;22D1n3n7nHJ/alS2]<7Ne43FBYQ
JL?TNRSKESj7R>TLh90>PPQR10?0O11Q6204LHh`QR3`7Y0UJ:bQX38669LD0Xai
WM:XUTNjLfGEQ^]MNk5fGCWm77MdVhTY71/X48XL]iDU[eBS9dY]jZXeFXZl5Oml
Eo/2TAEhZLLGh3X_d9ZoUhA9goAd=UTdk1?XP0H0715CAih;H5C`Xml;fb9BRE[1
c;kk?a9CMY:YiRaY^^RoUJ4ZGmB/7n;XG8_9[1:2@54>XL`n1:2D5:3@jcZ3aa/>
DN8lQe3^7T?<6H=0RGCCNJJ2Rd4g5T7`?LNHGP_QGPM0TdMJ1iSe7T1h3h7bD2O5
0:28]J5YgM766H<PHad6_;>EA;0oD095CNGa;0kLN3Y7BT>FnAiF6VRD6h=0IQ^C
IXNH^1f79QhJd9XG@bE;hG/Ii7JCJ<5jJ<<PW6VRA;e<<6WYLAVV@ejK4aYdLnWd
X>[dQYA]m5GfdmCPQJ@18WVWmdDD=QR=A`R?eYN4DN]abJiBOZ_AHo0Rjo9@BPP`
4:ARM`SZo@nSD387TQYlLi8Ube=91P/NI_@3;[dO9[I=jjceY/ER6A;nC5_6Cn/X
NPkQh3j7J?3=CV2b9oL?0HO8kaRS96@9dC`[Ql5[PM:fHIh;ESm3^7H>FL1cG@[:
B5Y`o@ll=0;`lT`[60jCT0Ol;hG`^Xj6^E=;1SV[eY:<?^22M5X]:;>?@NXn@X1?
2U<Y>o9HYb]7^F:R^fnKLgi`EU2MjZ^G^ZU?E0]kV9JX6EdD@oAm=Q[5Kd/N7CGR
lmFk8Ij?@nOUGYc5DV1A=F/^TABTJhRn`>h3J:_/WCAhME:WNYTR;jVk1kL4?^5l
7PBPibD?/b4bD0Kkd>3_UGb4Jb0Kh4U4PTXD/iaVREIiiFN87jWi=mRVNBY7fFdN
]55Y8DC^?hN8hAa3J428D@dc6Y^OIcHPY6mQR2X5>:8kY;DhLd;@]<K7/nO/A9K7
964Uk@QmNB;REMRal[2Lm5EFg<kYVSF8<0HPba82C4`dPO8n1hV>JB]7jg=NjWa8
280oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5HBoX`nXe6h=68loX76hlo98ni=2Gk:
I8o9<ngc;f;<C[<cO=Ec=g]>H=:IhoH]?hO?8m@9i;HO:ibmX<bJHOJLMZP/jTkZ
Y0iK78M:j`odcG@1G`KH@5Hjn009IjXkYg:J1KKMKh<W[UH`44[/e;aI@QN`?ODo
Oh77Z=0Z7L<=Qh??WnnX4ngi0/OQ85RWnnlJnGo:H`olSSl/olaTWno/HoWVgVld
TdVT`lGXn7NlW^ml/o90n<IXli93LKCA0Wa9Wc;I1RgfoMVmikK8;?8_69GPH`X^
XSN]0gkTN:oGdo7/llcTYNmGJkgH@R:C4/UTi;7_0]cW9m[gcTLAmoanOenoioOl
oj5/:PkXX:[J>X`WRE`DTQL@JVL7SZHT99NnZBY>bJE98Q:]8e0T08LXZFY<XC=/
8SkRX8Y:F^LPD:675hjAR>DIV36[TYK3bN7a7J3:g2R@XdP`<B6/h21[8jb[/2Bj
3M9Z1`Y7l?bTQ/>?S2P?b`/X1bf14^[X2T`>TSj1ZC:Lc9@n36/jPK8/Xk;5/Ng:
O<nf[6YfO9cW8KH9PT1HW2J:0CQD5ai7/fSh9lnb@@X>`jSPk9kXhT537^T3:C50
dC7m2U<WnNM?X<IUA3KDTh<baAmWlUS`eD`QlWdO;GWZbb@>PTQm<LgBMc?GUNem
GmPF2]bE`50DaAa2c?Wni9EFJVXgS_J9YfVN5ZXN`J2A?<MQ>a39nAHQB?G0ZbC@
4Y9NGA9Xg:L?/968Pd?FkBl@>HdLBg/Oa7gd^PUgjPH0h1JIYQ3PRbW=Pj3FaKUP
3mQX3HN1V8[;Qh343Rd3Wli>5c?E4e=4cS8I1T3?Wa>c]edi^C7dO1k_0T38]Zc5
LWnNaleZbAXVPIQ2T8@4g]eBb@7g7JU8@UMade81m>Lfm8]dLibW<;`/2/NAg7Fh
[8b2Oc:=cTYn/]YIlFncnH>dbam_O[V=kI]^gKO^2S`dP^Sg[L1eK`jQA3?_Q3kl
_1ZF;NnUC5N:4A952NDkH2?8g2W3<[2ioW[bQDL/=7<4IcEA6I=ViX9Y5lG9IG?7
i2U]M72RN;:9GFm6/Z1WAf@8mX<gKG1Hfh/?::29JL7Ob:/ZjB:K?Rma`L<GWgCl
<Ei]MIOT9njhc6^CF`V>_2bkB]7A:17ZOAjKAjeH=]A=L6JIIV4nCa@a4OYl>7X[
:Hdi]jX<NWl8<NYjKDd3PZj9L5l;@FQVSA6T/YFYmRO6T<hHaKiTAk=2>dHAFQYG
U?;Pa1V3D6cm^Q6k1l_hWfn1W:j9Te0gUi<99<i0U1VT4?f8LkV3@k8J5b4l6B70
THM>o70h9KB:24ZMLQ38WS_2330R@@U;H0gj3o7U4n3hgDa@L?`gEi@:8/5UH004
5DGFU4KFa4f:Q@3RaUPXO22AVDD:e</Vn1bLCP6I?Rf]EQUW:3c<lHmmiY6K=S<Z
]TbIUAl3n:T;4@XQA0`BDfM1X1677^OL8dTn3Fg^<X>fAl@8QA32/Th?`NHm5C`A
=0@=n1lVH6jIG79kT<Xab]UM:nEb0Q]Bc4E;D=<]a@biH>>JEQ1BAb@TT@Ab27Ua
;NF8lQH<ER3Bc6dJ/CC]Pc2DVT>VJRCbG_7FfK/ndTE/c8KFj4Q;_8I8kI:@9f4_
YT>;<A0]SXoUJ?BI2b:<ccf?ccM0@M]KG2G?KWV?Th<8`10108FD<E1HPBnLR/YG
3Y9H4?I^J:MdJ5C@;T2mUXARc6=5JnO5GCcS9]2=Y7i=jZC:TYEXH]B[fC<SD6Z<
l;hH@^7293:FH9bdg;eW980gBgj>`CYh:/E8ZQ;R=4FITOHmC7VQEHS]Kll2O3i:
DMbSm3JZEEZ/^6I4AWT_jLY3j6@cj`B74:iP=3UQD:O?19>SR_9`?9V?6^I369QT
TZmG5i;aA/R;[e2=IXZZdCZ8S?>O<l6DDZT1?J<]7YfBE/6@bLi2Y/F8XQ@RNKdW
4SlI;0`OIh1nbP7nomCa?YbVQ7/CjU:M85ZePFZ]CM>eHAa>lN4OAbS8Sd?ZLDDX
Y1CP=0D10080012W5@:XfQ]S9Zi9lb]VaVHmD7Z^P6GeR[WCf=eDjaRUk14k^ble
3doZCV37jgPM51@a>b7@P93eP6<ACO[CLbPdaW3>3D6P<hmcLA[<ThY[KH9o@/^O
Oo046jK>D7ZV9<Y1F56@FBC4HXNl71[`PPdG0il:46W9OiGd_d5>QS0^ENn6TNY1
W@JC4A11hhW6URT?6:lF2]aMRLN;B/<4C/5>aX<meF6B/U9Ek<kk[hl8EHn5YU5]
ghWY?BOYgL4?_7TITNPdASRk365h:ak1>2A4l:H0P3@>3G70>l?hQa8P[1T3XKXi
1f6O7^o;7CkcA`E7L>TL8J`c1P3X6d>@J0bQ/468PAP]1MRo7V?HO@h1_ST0L0/2
=_`23H6h=f2IXV]8J>@?fiN0KoUK>92lkV9L28a3XibW<`Ei8jAgPUd4<34[e`X>
L<^[aaJa9KPLPSn;?CJda[WGEEH`Vc87PAM0_0ik33c/E5h`ha48e@j=H5P2AEfE
>lY1ImTX4_8<SDH:<`i5@3]Q;3BfW@hcXMA36dJW/_>S=S^>Vj;5f=8GT9`jmLRV
1XAHDk53cXcO<H?^D0nQh1U2l5@0@1P1RI54:L2`7PH1Q3@7XCXY1F0A0/1TMXl7
`/_E[J[1AXbU3k7R5<9XBQ4R347:<B8SQ:PR1>2/J@fM86C<N0H0P1kOP2N]IIGC
BjBajT6?Zif^iG;PA3@aIN_R2`j4R:OYA0hVbmV5GCCT?R[hU[NDVJ0cN/>U8Idk
X7GN_7nMhE]0F<70K33V`d?`a^e89V0c@W96g4;`E_REH3XMD59[A2[XVZ2KRiFO
]aMdf;f47jWF/Wo?j:f:WaI?NfilOk^b2ElQUTF?TMl[_AiiVf^3n7aPDOTX1j3/
1:1h2PCPWQ76n>LM9G`;1`3/8`I`da[P`1X34k1SkS6hXZBLd`mAg3S0^1<20`aO
32Sn5d;@HA32;4OJDaIRR@0D0T1GV/45LLh>:OGWMA]cMOZY=QL1;GE;ef2PnKQ1
STa=eX@</Z0U/K;848KnEOMYc5dkhKkgnOm7k:gCHPH<40248UJ[BQ8RB:b]YSPU
;Ij^3a3EIiAJXN0Ed2BFh=;]1cP]IiCna<C0Rm@oRSb6;bka`WkN41a<BjPk37i0
Xhjo0O:nc=hc8O0LHK0J@0h[j6PKhFXG8G0000H3`MS68@PA0@hA`B0@KBaFK@PK
hL0N3kA4YXHdK68d`?0>H>X<H<0<hA/8H281`2PK8K`L:LXb9UPOP6H686P0D7RD
jBbN:d@UPcl1[oJ33CI533[XS_B7T00<3DIbIbR59i90@WQRQ<PWBmZDQ7H[HFTA
8@TAJJbYD?d><B4B8Rd0PPaDP=XMlC1C[40P[I9O1d8SbAjKIGie1i95INXUJ6PM
PD/EH<<EZFXAB7Qd;3PSDC/3AXc]X]ja2aK[JRT4jRXRd4T344cb[MS83c2nakIK
8bbZ0DHC@BX=0;h;0c8N8;X;X;8C0C`F@NPaP3h404PA`AH@@LhKhJPM@LPL83H3
P5`LPL`U`d:R8NhM<JHDHD8DP8@8098L`L0M2Z@chd:d0T3VX0X0H0aja[9G1TBY
hk<=lBB3A0ACYa2LTC@S2]0;TR`MLS4@bLYgYbD1H/Y7`Uk`[8HWRIQMB]4?L14Q
/UDUK4;``i8=DV38I`XTSob[HPZLTU9GT0T0RLTE8BLWlB`BDX@L/XPikcQ7PPY2
SE330`@Td1H^2>RN@`8WcNDHT5hbY[8Rk8l>0PTH<@YCBjRSc7a^RRRchhI7h]Q/
09TNhH8G0FHd0NP483X38KHLXLPLXMXNX382`4h?9J0aHL`N@MHK8=X=`?`O<GI8
8OHM@O`N@L@5P585h[h1H8@7P8PC`CHD8N8fHN@SA/L/YBaE;WaWjYY/3g2@<=D[
TUQH<?Id/DS`QbDAXWSD0GlfYdKYbLP^R7b^DVSE@UHM/h4JX;XL<hSITeLhli1^
TgXbS20=INB6B6CE4CKYhOT3Y:B6@Jlk;n@@`>4kXC/klh0M[^DD@Q@SIb4Dc8Q4
hQlj`Q/Z9jaDln3aRRZc;9ATC93aS8`Q4[cE9=``Z84/A>bUCk8kZ`R<`OD?Y/0b
YV@aRZ0c2E9VS6:chb0MXGPFXD@1`2830=P>H@XA@A0CIT@O8M0<X;890HXHPI@N
39XH`H@IP3P383hF8FhFhd8ciWkj0aIjZNYA1CIVHd/eDi9Gl>KbJ5bicE0SLEHD
XB]9IS3X@U8^QL3nYNkl9bDelBcHm8=;<eKCAbAIk`I0D?LFdoTW8R4ejm3Z41SY
c58J@@5=Z4JCPER9k9[DS[ak51<nd]:ThhXabDhObdXOB?50:jY>9kYTCB:WQgRg
h04HbmZBk8ka=0</L[Kc0kLZPfY/8c0kU1a[iT@g8S@=cP0JHK8IhNXT07X7H:8O
c0YbHL`3h2P00G0FhGXN;9XL`LHMAZP;8HaD@NXU@a[WB<dPcc1=YTDQU;DUHHEI
;/dC/?H^PX9KdlHQPAeJI_C[C4LfkJ5HmKA]l10WU>0KmL32dY1dBH92TC/AiHlS
XSC^df=>ToSHh>=N<kX>3_[_8Q4BU>XaYBe6YK[kRQkk8O1UaUaVXfm7L=EPQolG
`PEAEAToUAdmk71>S7TG/nBa<n518OHaQ/0aQl3=a]HhhNhM0MX<0:X:j>`F8G@F
HBhB`Db?iIHMhM`LPK2g8E8@hA8BHDHD0D`M0L`M8chNRHRbMHCBDe50=85KKGHS
cF8LDEX<8]8Q<4SneNcXXmhQdl`TQ2UI8HCD1NCFSmMY5/234gIi<S0MLWhBKLBc
kDm:ZKbM<ceLHQS2iciI3JPUk_/BcHX?8YPI<ekYPfLR3ECX0aCWd65@@c]?CbZ1
`MhK@JXIHJ`KHK`I`J`K`JXJXKIF5?`bbLXNldiIHg1Ehn`SMQRa/Z8XBZMR455U
d/MRUAmRe?8aHc4j/a4Q1SY/0e8JUD0=0F8FXFPAXBHB9XAF;OY=9=RhhahT0N@O
1VZN9=QG1EDdU7LQ=H/4=/<B0]:J2:9L3m]K8PCFeJ`d3Jc4IgSF`LMl/hEkb]e^
MM]j]mQQKmemL2Q<CK@5mnTl=^=^4Vd4Z]E<Pi;5`EY1iMT2l[jQ;[TiDlU`BRC=
bDJN9EL/Zb`URD0O`MhJ@IHH2h00P@@A@B@A8A8Ah0X0P1@KPL0Lhd=cUUdQ3a5d
KMZmeQmiRPj>UeIX4nBNjO9]2=Y=m1=fC0XUejHN@NHNiFLa1Cb>8g:D5deSAjA/
PPDcYUUS8k1G9j4ZEXPl<e=m/i5=X@3K`S0^Q3cYZI1L4?JHTRQD0PXY<hB:>:f=
9gB8TDhTTkhCY_0M@PcK@6N>/C0Mi:[[KCUZiAE:HiN>:6dBdAH@PK6@]m5<HiLQ
i3]=2]lQXaB@Hc=ZZYAV2=YNbBa]@MXLHKXIh000`1@N@aibPOX5`5X6H?8?X@PN
0iDOeOhPC_9[V5D5;J>5/nf5lZTGMeUQF5JRa>64adQBa/IE/[:N0O1B5@`gKWb1
P[A]9/5X4nZWF9:N;8eHV:^=Co9a`Ui0@DfKHB6KZ;MM3114M8]K/gc]Y2S/e_ML
nJfMI:K`DY8UkEZ4Yd9M@6>N/24VF0dXblb4Z70<PmHBelXLJmI0[^S`mkS[^Aj?
EZ/SI>Q>XcKW52@O@M@D@CPA`9h:`;@N0akY@Eh[h0cA`LZdHh1>JQldefFF;b5d
cLdmjPii^G5BUjRM]CAVk6hk8]QBb2Hhm`RTQYKBadb@9XQ>fVmU`d>7hNbW8T2i
EXIGFJUXfMS[i3b/0IkFQcP/[FRGHJf[<Xa3LG5oKE@SdEhG^/DjNYn/Y3j8Acm;
fL9IE_85^]`i<D>M`PUbXJY_`@h=V_0D6_DXPL]ni/Icm<AYDR@SDm27nPn12chc
fQHZ`a^QbQhP@Y@O0Lh;@:P8P58686H0X283H[h0k58K0chMhmjY5UaV^Vdd0O^U
4GNFMdn5aU<n3MMHNJER:ZK8kjnV]?MhkLa3XN`hnB4/f1ijHgMSIFHNmC<DBiBW
NfN:M@]Hf/c09K@Y8/X8NjU>CmP[mYYM`/Z4K]T=cXQ3cFPSdeZ]@Q>KXB2IU]>i
nm@XSECE59HB^_TH@PA1h4^n]ZI0@J>o8?VoL2PEnofjeo9dKn3J<360/oTi5`NH
5``b5a2TY[`N@M@KH0h0H00Mc@JLYOX:H:h:`;SkERD[6:A]HUIf665RIYSLccCc
5BVUlo4ZcLng:bMOIXL/8fHNIXAA8aa`J1J=ikVQCBck;JbBl[<=NGW8MXnMRk8T
;SU`ZZBO>YV1UR[LUB:aUBHbXfbNJX8E@/X5W;P]8/XFg<1h8[mZM:>[XRN<DXj@
HS0<O=VlNmO=hodYYXI7LBagQ4AbAMA8h6[_[/aIm6M6PUo=7>0o^:;8`iT/AEhN
PG]U87`7X70N^XhN^HX?`?X@@5P5@5YUR]8n:Cj?aTAY`b:LhhhOUZ/dIjRRQWmQ
@ooEFV6ej2ha:`_EPQ41[Wo8n/Xb>4YIC68NhL0AX?@=8>h<P;HHHGHG82CR@D`E
XFXHEad7P28HPIPJ`d:1F1QjSSXN8IhIHHh:H:H;H>h?8@H<P<h=P@hAPAj0XK6W
JN86`6`6P0RP8382h2eA@1ONX^P9gO5oe<n0mo8UIK28]l=l1VaNhSK]5[o@OQ23
ZT`T`DWQXFGQn<17No`EiIo?@4WRmYn[`bUO7Q<G>6Nei>PTRLXOJ0H;0C0C0B`g
@KXKPKi?P2hA0@`@kSUP8MH=h=H=0[h0@B0B@CV8G3h080@0VhbcaF0O0N8k:c9m
miOFGS_@HhXNecXPC68OXM0IXFHDP2@[h@X?0>1_`@X3`5068>P@8B87@8P;8FPG
PIeD]UccU08O39XOXNHMhM0L72P00JPJNd0T04W/89@:0;HMLc^4]c^KHD`0n3h1
Y;ZPH05AB;K0S2@@GbDhaO29/CYd>@j]hUJ/WY_cY<cY@Di1iInlbIQ<C/g?F>=k
o0Oc`Rg9?F5e@a^3P@YQh0P:X:X:H<8<0<H0`0X10A8A0AYihNhNPN8M1oIJXN8N
H5`607@cm`Pg?aX0IXA[RL_TL5XYGegeWeQX@Uakjc`O0A0>H>033b@OXMP5H583
@0h2@2R]82H306XKHKhO0NQ>J?iE4ZUP@JB0X30P0E3KkNkcMSZM8000>JcNN3iO
koOLARKoOTANcgOHA20C0L:Sh00X30ABTcjU3lUCFUQHUdAOlXOD`VTAUDgOSkWD
eVTgO4oWR?XC@XTjR/lY59YE;YU=Ye?Z5AZECZUEZeG[5I[E:Vkn[eOWUPR;m/Qe
/``]3^]D`Ne]/EK^5a^Ec^KnR=fOmhY3mRUmRDDO;iNmSOel`]ga4AO3nOKdOKiO
38I;;DJVE/ENSh_koQ@0^dEOChNkb_^5O/G_>9^V[eV]ef_f6a[VXOMfNfWNh`4@
]H:`G3aL[E0h2030HJjJSLL`?2XeN3fOl@Okfa[o_TBRknNLBNCeMca38G3BYDZR
9_W<Y[>k``Kg^ci^fXnEl9ge0/PQ@70X6GWmV2S9PM/19L;2e7L/QnYTVD4:E02T
ZnI/8Te2L6=U2d;`a3<=@f^D:^//Rf;K3bS:<>lC1_51cADWRI@i5dG[R_4I:Djj
:WfWij;lOZ_>ba;hWdRIn^TO1[VZJQ3T@AAlX^NSg8ZO2n<jOAn<6Ob8B/_:I_Rf
[Dbk64_c1<<a:f_2MbbV9`7HLIY0:0h>7@MQoV6GYM1l6H>[bLa?4fBPKR8<QEUd
KjSWlOAlWY7:b7dNQhX]A9hRV9`T4fCYE7@MYo7h_TM^RS2;YVRc57`NaFUHE060
D182040H2EL`;h:lV1keXWPgE^JML`lV2OWa5ZJejBMQ0CHQ]F<=mT9QGLafII]W
FN[B_[Nolc8U4SJeTV]UWoGZc3[50KWCLD7FQL/`AW;bN>_6Z:9@NbEBVUCoWd`c
[7fRj270KQ/56D9@7VNQk7VNLU[le3>[6RRLbZdlP9b^bmG=RF9hXe^8AU89d5ZE
Y?2L:`eabOi0Sn?a>TR@;[7@>`gS>0`81BL[]WZO3/bdRej;bRIo7/KQZ6>nk>PH
;0]SHHQRV?<Z8W^_U@=A7Qb76Kh3080X0XD4F/:EF5YFbOi8JnDF`a2j2JV=/`_K
@0fe<j0FfPI]jIFWR^ikY^/=kTZ=NekJQmeoKROSY`8IL6MW2k]`kFGAR=]HCNc7
lJ_>^YQQkDWDLaaPX206288@PQB5@F7TNIkiadU@bj`9kW/N]6f/b4^bgaO4MWfV
:/?1=5WR^anWZWCYH;QJl/eN1jXQYVV>RDAB4nD1?U:;0ZRfj9j7<L9]RB90UWPN
9jW8Ka_5VEaH8D1I_W>NFWAla9joH2P90WZ`03?nL4EPWUb@lF_m39oQAol4J003
X108P8IdcX^841<PDId>43B_[KM[162CLfl5@9^Qh[iGF^]hO/F</PMX@0_Q4>n4
T4hC5?G@DiML7QnU7LVBY1S45=<i8TIX`YN8IWb<DAEaL=dQ5iQJ?UN:?HCa5R<Q
a42E5k93JDgeQBlRl:KE0PT_:Y1G2V4T9HBK1AW3=6W3DJ`daV0;0F14KHfa`Sd7
L>`IPaaSPo244lMJSF8`]9DVDOS41oPk1b3XhP0F`RR:D>B@P0I3;40B1BA@496B
6038P0/T@1bC<jfX0`A9<3bTdh4>PdY?07U19<0HbIBA7:f@480oh50h91H=1hA2
HE2hI3HM3hQ4HU4hY5HBoX`o8e2Gk7CQ7a[8GO8h`oXjoH6nYE5XLniM1Wa<H=9I
?0i;=Xa0hdo9I?Im17m0Z33Y@oj;AhK@j77J=::3BX5?7oDZU1i=CGoD9]?jiGJm
Gk1;9_DHg2igHKA1J7DZMAWfogg?;SDJ2o;[0W_NJbm7nnGLERPCGRkgPnZ2jWRm
gk=7`eFJbdjUTbRDLTUV]ellGPmZ=DiAD[Ro7e;jPIS8I@7ZF7ZiC:h59de/AM/m
B0`?]`5^@1^mh0Ml1>0N>4m^8IN<f>A0cobmh5NLjNQ9i[[jI0YLniDn^WJNigNm
go1hO55Y;ei;9Nc0hnL1SkG=khOjJmeng0oYeJKAHKIo7GjdQZT<k0B5Z6PJRZ^Y
jQ:S1J/YVjR/@;1/9?k2T:`/R:lW^Q9j`i2j_:G1B17dPAl=NZAlX551oW`oBgWj
_Qn7XDA=4^:HY2ZA984/Ia[Vh`ck:=4J>WbU1l;Hjc5`HYBLY<Oan7jAI54JgH17
7:baXJi1/25;SN0=;kN=h<4aSK<Xmc>LDdX<I/f0G=cN1C><<X6O<jX<oRP9c3dm
ci?/oCnQci893Qj`<o3/S[A8KDFMU6_=?Dl`RRU1C`nbGB`jm:8e;53?e@5?Xi4<
4`TZCoZg0D3Z14=@EIEZ^@c>KZAJUmG8Hoj[ZIDYo`dOjnAG9RD7]@Ym<hXacWJM
ZgZV[JC7bNQl7[0/Ce8[KADlXbQW^V9I5RFP2P60b1eS5JIETB]cPcM8UGF1Ef]i
MX55MNDjaDPjMgXPKKP>g`0P;Oe5Q/NV1=JOBHa:P[/^_F^5hIQ^78GQB2^9HYod
4PM4SZ5^=96Mma;d/:BcaB]0]L^3[eYQmFE<[EM@V[ED`W2E9ICVU@@c@F8X9W>J
eE9=?::ZTEX5@^QEf_AlA6OIn]6OLE7cDJS;IIBZZU4JLjUDMVWbNj]6XJI[164@
BXHD6bPm/hRkBIneV9]X7KNh025[^J;dPnZ12__<`]gN0QklN?08CRNNL9`_3?6k
M>8AO22SSaf=1K@U;=2ZZ:lDPn39dSG<a5T]>YaVO3_7UL57jWVO:2]/9IQ2?DmC
dGH@]WJQ8a@G;hNX]U7kZJM@H]bhAEID1A6OAlXdcj17]h_CmNcjgWbOGS]O9D3L
g4b=7^NdD:2O1k^dSZBUCl@BO87gc63m4l3cmH6oJ@?gX=NSkWkaVSEhOiBob1Wm
gl0[N0@P03Z0BSAf<4Djb=f<2H5@;8<i8PY>cb/XD`Bh?T5@D@G7G1Uci?dl8IB`
BLI48AH@S732DJd9gi<XPHQMdRbgC;HE@c9jL<RX@_F_2^71?Gj_c>g0Q`QEgO[;
A2DagIeRY3cJDdn8A@g^XoQLjMYT<FPXR@FJ9IDEdjXJBBE1BC1PKaO5_667a0P9
aUO82@TkW29Tk6?6d1lKcN09STKT0CoH00@KV;ETAIHLamSlcA;1fBB_eLV@`mK0
3X3Y:nk<PRm0/b?2O94H/T`/BE1o9MW;mHe>5@2PADBZb6:NQJjL^A@GM>[NXPf6
[Yhob]8/C]^inH5<c:E3IehoTG4XF2?LOKA5O3bB8DY9kFak>YLXBQiIf459>R6T
ihYeR/XS@6/8O2258:MH/@9:`hfcPN7Q=n@YI4H/38A10S0lid?]0K7A=`2flQGT
^3m_H013ce?@ijEdnIm9lP@WPjlHclYh3Y@<651ET3]9jkI9k1DD>V7dQ`2;nab3
R76PeAXlQ:2E4bTmdY?92>7Tj@X[BYR5bRU13FDd<gE8PQTZMelndoaLEGB>U[db
V9=U0PId11QJRd5^1l408RhTVL[BZ6JZVHXF@:D/YaLhK5H=0PUGb_V3X5QNBHld
WbYXZUdC`Vkg1k8JBJ?aYC^j_UIV@lJ]29:b3d:T/lO;CF[99QQ41kPmbkBRVH[:
L8oeh;l4mH43UPf34U6GHLC5RD/7W88DiZaKbkdeYL@AU]TZHFG/`[HS19gKT23M
IlT8=Ai3`HkDB?U@gX5fE4c0XiRak5l7Z?<9P@`O0@GJ>4L0kDE7J:VDlX;fK8EJ
YXPiWeVB9@g:]LIQUC2VX^ALP:[e:HG4VA:?e4[CC@>d=0GHOL]j7=::25D;0G0n
1o48J>S[1iY=<RE4:k]BDmbeE_<dPJAXRXBIcId]E>BNd/R:?@L0eaY2n6/>4L@a
aXSF6l=TK8oUXBl7hRZZaL5N89M=PjXmRb<?m0SQdPLT@WR<a4C1L]SB<``@dGh^
4aBD3_<hHX^2Yb=eU9h`LNCdHQFE^ES^iDPdk:bC`6o8@:`DPX7H>ZAAeU;T25J:
hF0dAY3DZ74e1ZcQk3m7^XDdADfT3_7B1P1h407PA0l>@MHoAiGG>/Z=P[B[gg3M
2ji0N?<jAm;G;Znk`VP5I^TFlZEel]3jNmQQ@`o6T51=7Dd[=IAnSS7<>X0@2@7S
U7D>hX2;V[CBR5F[7DP58@8Ic;4l;ZIY3kA:?`L@LPe1A000X1XWaGRl4R8/AH1c
MRW5N:mXUM<mVM7Z?N]aL2=?5anE>?Q_3UQo>^=3IP6=WCX7VWMCIHdAio7V>0Ih
iAY3;`B>LIHeafSQ7:>aKAQRDC:<j?R^<aAo;e^cO3>^lHLb<H4[jFB:DjQi3^7H
78=`K3^h1ETOh<@I0d1b3X7U7:FU7NORo6nGQbSO6nK/1HJ0gQoAE;b8Ej:Fi`^C
LGNG8IIX?O0kjVDBdB3gfSU]YMg7:edN2kTcPo]XSnV:G0@`T1:Ph244U0[BTEXS
gE^YFTeILIlPBNMB5nZU52<h?`K`RQ11[2b6T>`lB1Sf7f>8Jhd`00200<PJ`e;^
E[EdF/QNmB1P8kHVTLCX4aQPfCAnbQ7MfCA7n>@JP;P=0A1D3T9@XQKS:345h;@5
`604hT>UPiVhQ7FNj?91/;mhLRl]0W^T>hE4V3F6T=51@H<gJD386H=DZE;f=Q5k
>Ra^MS66;/G1A[ZSk448@A`7@AP_B8GdU3d4m<:RgL;Sm;o;o5IhPRG<ZUC^UV<J
A4EeCASlb^aDXI;aim?:EMOB`nah9?bb@83h;0I2Z5J;9hLd2Qa8__;bJ/W3l>JZ
:YoHIL>/3i702P3h3QDRf69ha1hOHNP:X;H;H>P?h@0ZZ[1j3bJI0U0NXNaY2O1T
ahACXjhLT2b<X2KJ1`IFC]0XckhNHM05P3@2PGPIXKPN10`N8D`BXAIL02hM0_QG
QkCDP[;m[U3hd71`ibjARnXV9PZ/@OX>@>0>85T8XN8N@NP4h505@0@0H0XH8H@H
Qj3CA4`OHNhH8GXG@@@?P?:j`NAnPN`@H@`AX8h9X;1IC[BUXoRUJ[BoKT47<>1Q
PXZ^J6;]19::jE0YXN0MPM0K@K8J@KXK`K0IkISR@LhZk4/=0[;:hOQShG@HXH`3
@3h4@NPa8O`N94I3AJHOhMhNHN2jBi2iJJjLC3Ad8o/>HOXN`M`MXK`Jh1`0P0@L
`N13[[8OLE@4@4@50?@?XAA7l>hO3[15I9;CZF0o0TjAPTh=DIBch=aCXVZiQP[_
@JX2h1`28J8K`LAnhOXMPLXJ`I`08183`H8J0MXNRb2G@N[bBja8RQkT/><MiVZ1
baYl0S:?R]JQcM@>`>P>X5`5X6040484I:P80888HXJ:9E0ChC`C@706P60=0<P<
0@8@0?P1P1h2PKPLHMJ_46hNhO9H/HkSZoSbKhTN4Ta?l>JJ18k]2mkD[SHYiI@O
0=H=0<81@180PDhE0E@A0@hAP0S[hESlQGPNQ9XW8SX^A5`;A<H>h?0?S69X@NPU
B;Aeb/Qf4I0o3YDD`l0k0NkBbj`DXB`CH8P7H80NC2;5hP@MXN@MhLP0h1030H`I
0KikYEIPikY8d13?QJB?RF9;0M4_j>hL4`@VLZXO0cQY@BH@hB0908X9QGQ4[;@M
4KXI`000838KBQ1NXYKC;=8NS2DTld1Qb`XS3^PjhE8DhD`DHD8D0ChCXC`A@A0A
87<fI<8080H1H1P1d@PJ19iW`V9HYYDA/ELb@LXL:migTYj^98cMXj`hP_SSbhTT
/d<jI2PXYPjihc[>DUa4DLdk<01i8?X?P?0<LlRYHOHMHK@J@0`gHH0JPK@MI5::
HO<H8NPLHM0L@282h2hJPJ0K@cY5CDh/iV1`[J0PcDA?II@_RGX:88H:0CPBPD:j
hN8O`M@P@L`BHAh@H101`4`MIS/YiYKmPa9J958O3ARO`Ub?J/R5A4PV:NX@k^9R
b6cJXOH5H485@DXDHEQHY5T`hLPGhE`D@001h50KkJ9L[28^1J2f9IBJD[DjU:0l
A?4[9d1@C8P500;RP181DF00HgPfY:T9X0X8h909142SP^b_JkXOdGa7hZ@NZe91
CX1PXO1Gbh<TDj;>M:=?HkQ12^HZjeBJ1XZ8I1h_cMXMi/84XF`F`GRYK5hLh;P:
@90>PAhB`L`P@NKS8Z960Mh]hO@B8C8C87`7P8XSJQY4XO@4Q/@K0JHJkb/>@S/_
hM1@ANQa<DHlJk[kPN@MXLm;`18L0K`MI4/SPN8E@E8BP1X1P0XJ@K0Me>190K8J
0I8282`38I@JHK2XJ]HP]FXo43JbQhho2KhN1]h1`KeLh/kXjGXMJg00H081`KUH
;Q@OhcPN`L`5X4P3X=0>hAU3jgXZI3SH1h:]R^U?UPaQhX;8hMHD0C`Ch8DPR>@1
8gT9];`giO`EcG8d9e8chcmSMOlTAg::TYl2JbHQ2T=PmU0[QG1ZeTHPQ4[VbEBT
I4HO<b@K`JJ>@28LPLlL`SKVPOhNXLX5H3`2X<`@8A5BiGMT8^1@XO[k[5HX86X6
H7R`8DRQXJ@KHJU;800J8I@Ij60PXTinYW55PPjF8kJcQB2=@WH@5]P<E]cn0Q<7
Pl8OHN@MHL0:@9h8`101P2H<SR`<h<H;h:89P8`?H?P?`MbH1gAK9S/E8:@:`;XM
QGbTPRR3ho0Aec0:5c@VYYHZHN8GhFXFH0P1`4HN2mA4/]P<8;X;@7X8`9<SH_XP
@LXKPJX:09:N@0X08GY]K@MEmU=gi?[;;VHei18IUh`9Mi00Hh4bYOY;k<820`TC
kiQZ:G4gZVT>m@DkMTT=]0bXmh5kmbZGBh9PlcCVMhJe@k0X[VHM@E@D@BX787H8
iPl1cVH_PMPL82@180@G8IXJLn5Wjm@XEUhN]=hk@HhHHIX3H303k6hO0>P?X>`2
C<@G8F@F][jP<NbLE^9Bif/28WJK<_A;0I>4Ib5i09J0PPaRN412jb3:hOCji4Q>
TCC2iGZS`PSJXN8JhI`Hh=P>@?YnjUU9jD8o4H[=0N@N@469:`hIM9@GHEXD@3P2
P28000P2`>0>`A@=jAjN07HDPDhEQXQYa[HM0KhJ`X`NHF`H`H8;`SiDYIF8El6>
<j/NU=QTXIF>h3N?:NH;2Ahd<:K>lNUTe@E9^@Ji=EmTn>@P3oPD3PT5Pd7Q49QD
;QT=Qd?R4:Od2O[mOlCO42S<2OcfOkmSdFOTCPKlNk]OkhLY<8@fB2CD4KTTJC2>
AX>0h:M[gNdKR/FOcmN[iO3iPCgSTTOKo=9Q=AZ>1`4X^581080Ej[E3nOU;P[n/
43/51R/6O=WPck]D6OU]T]^PCj^Ch^Ql^`J_2S_D3NMm/EQP]]OUbODA`d;TSlO[
lO53OkjS=;RckNU;RMNSKdNccakfE:IC:[FJmN]ROklNdNVN7QkaecPf4GRcmS;i
eDOXdY^;oOLCN]0SnkgDY@bCAC:K;DN>Eh<GeW?j7AjGCjWEjgGk7IQF2PMZ[d4`
T3`QhlP7l`0m2FBjGTSee>:O^[PdFi]N`^lRT7TWbi_dkk]@10<1@70T2`:TRbX`
PCLX^S;J>2/:e:<SYlWFKP5Z^Kaa7JSIm[JEQE5B0P0P@Lib7DRIl[JN@h3F<Kd0
0A9:4ZNR1000@4123hD3R<XgTfB9<PF1`9041@400Zho3j?2f_^RC08_:;^^l]J1
2I;1EBdPbaYnJ/_Q3<8XC6LTbX6N/d;H^3CcG0b9>4TJS7dNInAZnQn88XJRXhPI
lWj=`_S8M9h<JPAmWdfKP>NWjO^hPC19nkbi/G1c2c`dj192Y5;/:X:C8neAm5VF
YH5@FIE@MBkV_i=eFeMEmHESFB6;XO2a[7FZ28V`K;7nIAT6B183b@m1R66HcW<G
?SWFHX;ID=J3neeIKn?XoeIfaK=]FgE/4Chg;_WlbENfHgQc72KH`RX9H4_@=8f3
P;PaSB80R2:@Q2TBMQgDjdikWNNQf6nNQgW;OIdQP7hR7NPA9TdD@6PD285000h8
P@1]QPI6kd:^6@IQJRS`/3=JabXbQjAZY9o5YUX3INJ>HX<e9k3]V`7I`F>M;OEB
o_iG>Efba;l]bS=;e/bRUWdbEU<NOiM5NGX20019dWDMb_99TKXDLPU9;TQ9nd>i
ak^IL2?W^NkL]nX5>W`HAQ60GQP5nMIj@i=SId_EU^Kk_fol1Ebc`HQ9l7/Y5MjF
iae7@M8:0T2Kd04LIa7:ieWFKJU[FRnUZLmL_=_a`?Am9d^o?gC7DfI1=[WgB[ND
/O>e7/nb;7_Bb9l`SZ;/hOik6<IATTVD9DWQJ;=Wb?8h3WRH6Z^0LHIO8`50</5E
9nPO/D=:b3dR]@:O00Wa87]9kV7ll`Q2;GeWMm/n[@SBjNdl6`J31OhETO9j@Me<
o<D?`d[_S9?G>4Ei?2hTf5M;Jg`ik9R_UPEZMhoA5ckWnJ:WQ/AgAl3762;l0H0`
0Pn2444>0MPi7f7fXYdd:hF@]QLAX/ilX8_L:hL1GQ7gLV?::;LFX^3W3f7XhQci
ng@^MFViV92dWA@_RI4f9a4GD>XLndiga_475;7/W8nhmR<3b:6YLaA72:]U8n?X
JHe1[224B8lY0oaj:k8:I0NhY1ARO0P0iib<3d0;Sh;J?c?R4]ML6mhOHQY309T@
1:AC:Aj1cTL1^B0/99?_7c0i:D371T9PT]b8aZdl8N8nFi/I_884N=i19Bji6/WD
<8eelYK3N[>7Z?@`/1Sa9hSN?hNA6SW54QbAB<10S=3c8W4J9laiTC9>/HUASWBa
WLLB[e/D1dn6@G95:K2bhU5OR6f4o<bXW^HRB@BHbO8Y4>QE><QkVeWCWVk>hX4a
U[bTBi=fLInicTIMg1TfI_G;Sn7X?TO@l5>A6:jhPOHfa/SJ5::PEPl3:S[7ThXg
Q8iRZ6;0?Z3X_P2P3JVSMihG:AC=?R[MJYIGkSi5mB/1E;DH0aYP2BV@FJJ3/7J`
aAhnT9Wa:jk9Fb2bi3F6Z=4K@fAZSJ6g@XK8fAiS[7C:L[`miOZaV:Thh8nj16F@
I4DSPnR9a]:G:TU;oY]6/OVcalSJI<eC:DOTO0nQjTCU<I`O`mbg5UVVK:IRbAm:
O>K>2`5PK1F3/8]f:Ili_eL[o4NK2WC5ZkZVORMZDQoXZD`f8O[Bk;A4YdJEeQGY
Ecf?Z]214HIZ;UD^AHg9ASj:M/L]5U@mX<4c]14VH=KGEEkU0XZfYcYoBPMDXl`H
i1a3Q0[LL88@PR0X1B2/XYlB45WZTE`PH^k[08^`EH0;;`3=KT8@`MUhI409O5An
?@Ikd376@<ZOe0Tl3l:<jj<]D5XS764;ZShP13245?Od584@7QV2V5FGHoacXY=<
O>S9gTfh9WMPhQ9ZiccIFN]9KcUe]hD9W?<bbRX6CN/;R74F8lBHU`SHLP]R[5CL
R@?jaaHBA[UM5=8TBShLFBa/f9CZhe3F[a]J;3Q5bU`YDa>L[a5R=VA=gRk2YGX^
4YEDeZdRO2;END`YLg=9LKbf]lP]J=RIPV?;DF=[I0fP6?;TH9[YhRi4o69Vnk02
01Ic5IWE[^I2iBF6oW^A@4[b`ONPNRkR<05P<0LTT0P;@G0`/ZDH`MUL2ShZRQhJ
hdaWP?9`>/N;3844W1`2<3`H@iR57?;`dkBgbX8N/G7<N45EeU`ORKFF/mJJee][
Lj6/L@H[CN@G8kZg<fm8o[lO8nh/k6R8AN<<28<bWbmKWF6=if4Ra[>M_MUH[I@R
YQg32iFQaD_NHm?1ZVV5N@HHTbl6=VXM?V^>g6FR4BKBQQ^U4Ub1RXg`S2lNK4WT
6cf=l3W0DH05h8S3><O05PGhD3<6P=0U1>2N5L;0G:jZk?XI`O]152TC4084@XE@
]1M>nWDU8h1K2S4X1/5X@A`AHWLNk9kZNH4cRTOBMf^]LLiiec_WW?ISlhNkHVKi
R;471M3UBRkfI]Fo;2H0a:4l>VB=cU6//6;IX@anX[ZQ/TlDjg5?@fN=/`W=c2AG
LLF3hZf:i/;2iKBO]5VdOhbKWM[`9NbAFEYKI<T5kfAoN^N4WQTl5`@0/TQHKlTH
<KaEf^1l5?@4gb0Wo93HlX@IYI`1n^8f;<8P@lCN6LJF1l4X<AF2e64?4ma7o?3g
6d:lC`S0?Pa2>>SIhmoD[;7XVS^^F^Jf7j1ckh7`OQO3n8P3gn:NQF;a?S:aUIEY
]S:k;fS6EBIMnJHK;7SCIb9l]ke_VcZCoWfTo1R8l`JaO<b51@^?GGHVlCmGe1;W
S<K?FHOHhA@NTiX7e:lQ4UY;5JY;4^4XXm3d3b0l19`41G`5?63d0<@712@81d`9
>n^kYVXY5>S532SkTJQjQc1g1`1]P002P;QYQaZOSIQf1oQkQ^0`0X0PPRPZPe<3
]/=U7>ZBZf^W=G?_/I?S_R`O@O`P@P_R`N^U8U9bX9/F^U5W:l>`[9SCR;4d??3l
?Z7D_N5[8<81Rf?^=C>]WD?c^^R<>J9_`_Wn]W_b6W<V9a;J[X3;32[X8h@J>Y^S
5XSk/SSo49?;<lR`?n;j<DR:_oWi=jS11ca207a3:TQ]PNA5@20017a77i^gWl32
7iRB1i3U]GSLQkQl9MQmQd1K1D1>PA0G0Q1e/ZQm[?:K1[1R6:001NQV1^Qg2SYE
RnQiT?;h2i<>R`AK8T@M/9?W@Q7BR0R0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF
;AN<AV=A^>Af?An??j1B9obAo_f1?ZCbYnBZE?fE?Im?]mbN1CEn_aocZM_nJ_mj
bR2cVCcYnb:D?jDCbD?V1?NKb>1bBACbOcEmcYmbJQENUe:M?Yl?mmE1nf>S_na_
jF@:M?Il_fhbZeBFebNDF>jcjCb:LEnnCfBcmm?ioCbb?ZjA1ihf3CBO`Aki>1Wc
;73<?K=57>IPh7k@0kA4gB;oC@InJWD?fRBF1_f]_UlcnC?9`5<RSQ69QB?6Y?Me
=eY2<7Pi>Y9;?F1?2X_m1810j@VbBShN1?W5BJZ@:QM^Ye:@N7aN?bNGcNOdNWeN
_fNggNohAS_CJj_ikFBaf=nF=CZ]D7TO9i86OQkZLWRM:L_JC;k1RdZBU2OYd_CU
<2`bY98ZbX]Jec17fYJJYhYBJW`o:c;@/:XZ^Oi`6jLIeWBM427NT[kY52dE9j]:
OZBkS`<2^SZY<b3G]HZL;8:e;4BC0KE>^f@;BPJdY874Ql=I:jca8CL]QG;XFBnC
/`/P`bf>bPAk=BTal_^f2]WnNd2TfAY10@0002H:X/3N?Q12R:@V34;8Z6hIQZ7n
Yd9^^XiSV:Ha@DO>1kY8NAk7ZnK_>k7d>@Fn=>dmCm@E3DEAe9D]CE;:Z1b6P/bB
=CR9^dkRVWXTiiYlNQf7<N0R249YbWDLQl7dNS[;8kQm]TO:m:P`C^<<U/2;lTZD
7XO9`V`KYh=W2RhY:TAjYTkJLWm=c`9dOakg>[Yo=UJJJ[4/RiY8`]b`hWAkWHN1
;4HAJC`BODT]K1l6A`NTc@i7[0XcE/TBJPS857R8THWQR2BC<V:X6Fn=R3SX=hnd
0o7KTJIYXU:U9>W5T7bNl[YfU2aGBNb/>i0Ug[L]BVfLO`e3@=9_j0OSF@`PAl=U
F<>DcQ5=e?Y^WJOZ6XjUZNZJZQeTX6aC5eLnFCh@O2/9NMig7<KH@0j4Q`W2MN0F
IVRNWi0:oFIBbb:C8j^iP`JP7`D9;4hJY_70iS0i=NNC9lXjm@lNkU@lWYj7hObm
JC@jEg9U9mWZNJN7VVTe:Lk0fRj;Yg7LMSJ=NTYiZQ4217SbD:;eHAkYXO:N;SbB
;iLTLS[`XB3QahAFn9EG489[22nBPQ/nJ;oWbP2`[R`;52VXVBod?IRm<EU[j9mX
eK>nOCkWf]Ze7hOK6WV9`V2K:/<=Ig63jHnSio[ZgloeoOnOkocofY6/:fHMgS3g
37PO^@/];UT6;67n?@nhlac0^1<1TEh[QHS:6J=8;HF`/RN4b9TDI_05P40F>hN0
h`mR23`1T4@<Ae82@Ro8UY=g95S7fE0^8Y1;RL72>`MZ<eVXf9^/PYAJajR;487T
>0IP^2n5R:T3`6@=RI5B;HEh`AZP3061TIHb1[Si:i0lMaI78YWC>MIc0n1j1F24
44Gh`QS;<6></I@F`ZQC487@>PNPg1`3b80A0ba^3T=l?mISAFRU>7j/aEi5gU/E
7[9<JLUF?PK8<l/PKbeDZ/<=9dOhl9A2:4F8d2@6P>0m244DEXZ1E5T:P?hNB91f
8Q:ZkD_197D]9A2?lI8aaT2@4L8mEAZCZ^iD^N1YB2h4`0VM<nJ4dIYCCVXiU1<1
S8V^FDCFIY2H5^AMdVM4HnQR2c5B1X2011kSf7TETO`H@`1S0H0T1hY1<RU0h1<2
`I@c1F52:TCP2P;PX756E1:2bQ3j5V;@EP@POPh2X448H6P6PB182l60A@[QG2<4
T:0lAgCP9hG@N`oAk3[5f;4DH34k243/6/@`PA0PF1>3L@@UAHPl1n60FX/QUcI9
D?UFPlQg?HFH?J=A:QkSa2^4<80^XhSM7D>i>`01[3>6G8PNX:@>PO2X5`<`fQf3
fT>?26ZKdcSa=TGXa16TUZbB`@<;ULa3eeB8l20Y2Db9HB:@DcEB6RTX5>:`Eh>`
LPl1F2D4HUA7R17/?@Li?88B:KPMLTjJ32[77l>dM0k0NPk1h9TBhV1hfU>lkFc;
25<@889=fJ][kHFa]UK>fQ6UW/9CNIZCKAiUZJPDdAY9U1iSb3R5d;0T0oQgMF?@
NHkP;0I103T7HAal^`0J0<0@O@k1T6V=@I@:0KQ:L8/`WSSG8Sk?^FXNXl1e5Z7f
:4B@UAZ3O70>``cR2M6Y9V?YlB]Qo3a4>7l>040300:0>`60:PD030H1TM1m`=0M
2<=/KILV0AXCFhTWkRbnSkEX?@Mh5`4036L=8JHc1ZSG0WR/Wa/QfS/`:08I8da]
82:1IHVibY6ToX>k^_Y1:n5b=UGl2>AKBSaTVD77kFR39GEF@A[EKgObja`C<Ohb
1QS32`548h70;P=3B6/=0hQa3XPLCFe4>YM^99lCQCCQb/U^B^QJeKn<kFecaWW?
FNlnC@:5G4Q3:7jb?8@l0eciT74[2X407hbAI2/:0>HL8fQX000<14MR]1FRZ5R0
l0V1QgSP4:7h>`PA9RWc=:6o9Dj4TR:P/<]@nQA2A4Z=XLXi/K>8N0CnY0n;fSj7
N2/4H81E2R50?PMhj04P100<@H@`A[SJ7CAD7A<UE3h7/>TL[Jlhjl<RBXO`m1ZS
7641l2P43=3b7F>dM@90A0S529`C`D@V1@Wh6X_B]87cL@6FjL8n7dj48OGV^11Q
0L7[V5`QVC9?5:bFHXe33QkXT@>cR10mQ`3I6N7P>hL`9PB0Z4l90EAN2j6;S`Vi
gVhT[;`hfm:72/_Y9:d:1KmKNWOJGWgWG>nNLmilNdV1HWK995OdDFH/QJg37Z<h
IXd=1cNAjB@_Be2e:B7/6P:HEQoSO6m0lL0Y1<2:2@5P<lIAoQN326DD@TenW01V
243XN172S68>HOn=S44i;T?D[:]79`?7^:XB`Va^3W7@>]XN[Qh:F;U6POHk1eSR
6f0`0h5bH3o64;dH8=@FPRT@=hDXVa8Pk2264F`_n^So7V<THX^@50E1R>dW@m2m
5DE/?dMXN0jQ^345h;A>ifSd7D5h;8FA=2J50>HMQU>kV:cLSI2;NcVY08g`@X4T
`BOI6Um^_nCO4Z_H[meg[TdB9<:HK==5U7KTS;@OMXb11lo74d2L5H;0C0[1N:4D
X[5:Xn;@7V;HURH/J6J:h2cTAhLZc/]Lio0I0J?Fh48J:@:@O/JHd<EH]l?S0FEH
cn]K0Lj0FV7RAN0V=450565>5b5l640H0F0L4n4j4l=L^0>dH69/bX=LMJQd2ZXj
7b_XD>7D2P261`5/666R7B9Z0b0j0l7J746d7n7@70120L0N383Z4:7B84@X:XiT
L`;8;H?^=V7j7R7V;dO4PFef7d@2MF5L5@5:2l2f3L>/3Z3T3`524b4L9f723V3<
2Z0>0H10c:;l7P6^6T6@4H4d5ZM@cHO/^J7@6d0<0<047B7B7>;87V7:6hRfZZ00
0>2Z2j3@5h6<6JMBghF6ML9k02TDd48/Hbgl7h5a5N1_5RbNC8C6MlNFbT]fV^[^
HHGFIBiB9^;@?dIPMd9PG8ZP66XT2J0Z0X123n3h467N7H7:9P7NO<Z@J4HZUdCB
o70jc^]I0m7172?6>X@N>m0W1ZiP9l:dPLeFlJCLN0^0Ujd2H6IA7[0_7<eHFVJ@
B:B:R8JF:B;XG:J@VH?Y0i7`jNJI8?0P]P9<KR6j6F6B0^0F0F@XT>5Z5V5/6j6X
6Z98@B[H9/=Q5m5Dd>9X:<LT7f4/4R4V6l6Z6/D>klb/PHiRiH9Jo8/bmZ844B4>
4@5<585:2@2<2:A8Y;937j<2ajbJFVKg7/B>:X9`EX;><4:/7b4^4R4N4n4n5B1n
222L5j5f68H@7g:2226B6@6J:8766j782J2>2LCF7j6d6`725J5P5^093j7B7D7H
Td:A7T:D:D@C0/8/P:Jd2M<<C24j8g5H8>H`MlI[6fDg2f;>CPPK7DW2J47n6d6b
6l2d2b2h0N0J0HfH003^3^3[6c<M75=E=FE8>XEU;j@JES8k7D;h;X;JFA2k7@hZ
<4h57Z9A7k0@>o8>:S;ni`cnAhO_80Jl]DcO8:jS6o8D@^:TPG8F]O0Tf`7VjhCZ
002h3B3Na/=L_hoB;fKM90A0Vi<4n/6e?F5=?J[^U0H2ancV@/:>443j3n6`6V6Z
dT763L3H3Jia=g=g0FTNo0HB:5=f7d7j0n0`0f584n524R4H4L6h6d6fC83]=:5`
5b5fLK0V6R6N6d0H0D0W;R72^H7c;:6L1f1d1njE0<Tl:H[PVbTPGJ8:6iA`0YAd
B^U08`JdP:n/FBn/H[Ajh;5J6OB@2eBD0UBH2]BL3?BP=40L7EBXOF<NN?5a=IBe
Bf?9=LH@/b`^jN:8/b@Q>8;8A7>S6l[e6o0^Oa=m7fHC7lX@9C5o>Hic>LNoC^d3
>K>Xcf:jiH@l5j5X5^00040:3N3`3f<VAh@c9U1[=o1Y7PMlHZ6CDZ[^86<V7^09
Df8H7X7T7V2^2T2XZ47/3>34398^5YDc7Rh];mCF8=@=C`hZ7:6l721f1X1^oP2V
2L2P/N7Z6mF06gA`WL=L[>9@6P6N6Z4/4Z4f4X4V4b5T5R5^FDOTcNKa@>]`8ZhH
Fl9<3MFl3SG08ln]B0QX[KB<9fHLbTBB7UGHDN501?GP0oGT4UGX7AG]<JWN3232
3oGhBXo;BiH1H2?J?VCLcS=i>VFT9]=f9l;m0d?E8=>Q>U7n>K<5CD8E>Z8IHZ]Z
I@Z4iI7l564h4n06C/686F6S8n=L:9IDo11XH/CB<=<8hP8ADf08JdbN86Lf7X0n
U@3^3T3X0/0X0[9d4@<N=BMc@70`iaCIEPHBhZ504b4h6B686<7@767:0:060877
Jf>Y6bGR9l;XG4Uj=J>g5I0iC`8cDbB^[n0_KK4T7CB:8n<PTd847YK]FfbB8Bnf
6T3AKj0AKn2YL25mL6b2Jh85?F6dT_K/geG@kbnoH5LQLRHG0A7m9==YC/B5C=7a
7YDSJI8AHL8NVBd;M7Cb8MCC@8PAIJ]W92_@5H58526T7275LHPP1Z10163d4B4L
k=LLFVM`>K0B@G5WDVMlBZB^ZZ8BBFA/=WHDb/94BZH^G<h]MA@30`cZKb_@;@:T
FBjTJ>J:7^g09g?>R87aO0d4O_<GGa<E=B7nBf4f2OOPB_Bb8/BBBCI^HKG<Mn86
[n53Oj1]On0aP2[Z4>I67JB_DbhR<@FB<P1[PJ5YPOPCD_LUPWPYM3DU:T:;HI<[
7<g1O2cX:TADLa>1LmM>[e>@DdcoHF8?7PAld5AYCg1SHRc]HPJC7X]Y927d7Z3j
3Z3P666Z6ZTBA81VZj59FUMh:V;njT/XLZ=QObTcA]Od8:05RWNhMl[c0hF@<;<`
R:G:iYJACe>KH?C_8>DcRK@3FZ;h9=PAQ:VgL=<I<J8lNF1WSV5WS[N7H`8Y?SDT
GIRQL@3WSn0[T22;T65[T:<PB[O^NARP8B5CTJ2?TNNGTCP[TWTX8I@5QAJD>XIE
1]CVLaQ5ME6oRoES:<^1@?QD97>3CMCoEOK;>WU4?YQ2VEUAS0VVSF7R2`2P2F1J
1L1Q@b3f2L2<263D3430;PPH@B:<JF@BV^>fH_R/[iEPFNHMNAO`[b`^`^>fU18j
H?>68G1UJB8>f`DTMlC6?07N^7G<P5Gl7`H[Ff8[<F8UG`6=WV11WZ8=KR8ZB_WL
85B]2`TWSZ5V29X4b:0SG03R7=XA5bVlhO@DanU1I/9XaF0V`X6gXGHeT[XaLQLZ
>K7U:E5m;2@P=K9`VEDP;aCdiENWN/EUF:h]U=Ta7]QSL`coESUJAe>RXCC=Ca96
]TI@Y<;/CNWG34Q@7JG0?^G>9[8l8@AaN3TE5dBL;RanEMIXbU=@R8;?O29J<RH2
HICB8IVoUX8GFgJjF;9V;jF:>Z<AWf8E?VENn/8`2[[P4S[UX/8`P;KD=HU47P3c
[f0k[j1e[n59/2bUN=?UZRo6P:C9P@8G[f3b3O/L8=/EXc/UPZ>fA`<A789^MK0V
H<;E2haeLc90F4cH:ZP7LX?0J<G:>[<HbWXi08Ad9Y?:hLcRA/Dc3A/^Gl7fB]U8
Uk]QCX;LCL:A932j;I91K2IZOeGa[LHJ<:lJl^7`>DIIZCEJPH_CTdBK]_H/8X03
^gOC<MZkH_QUZmQUM1_7JGK?_?FaM:8/NGKX;EGoLKKN0K_UP:ELbUTCWQ6h9B<D
=<5n2E_mAd0X3C`4NJ6cTT?HB^71`B0Q`GFgWa/W`OBi/[Xh=@ET7Z7hF8;h@VY<
?f545L5D>`eF7_/iK?=Q?2@l;Ca099Z;[:]c6_QI7C?Y]lK0O9:D94CGVC909@7V
PQ0T<2Ai:;[B787:6j6`6`6]O?G@H07j@Y@EATHAX^JTHZ5ibW8V0GGGGHJcO:Gl
/^9F<9/`G8@BiN>nV>:>WFG?W1^e^iOHHc^oUIJG_1LocACKQ:MECa_AKA[ZaoOE
_b883ecm/L3NnlegB`=C`<MnM<7L4OdD13dH1CdL5;dQdAd<?KFfFCTN2?TJ5C_K
`QdiH2^0nRAEAUNNOBEX7Qa4AL2428226^71X[BlK_G@<Bi]RL<V@Xcn6Ye`B6VI
RgH>=P7/S:g3]mPb9/_hZ2D>KN:A]QHKcZ9<f@7N7:4LGhLZ9Kc2CP7R@/hP@cS`
E:bUDcP;^f020?g5KfP8O/cR7T;NL:LBh0O@>_C9;jA1^`JD8eg1^k898@8_cYge
_;cSHWc]_B8iOVEM/AVT7hT^6EhAPR[QdgZO_hn:2b0OhRNX2ah@6DJcITVa_`?A
OV5Uhj1YhoG9bQdki6imXfAcHBcMY<7j>Hg27/7@7V1D0h1B74726iNOfVeLZ35=
f`;o_><dgdcn4[j46/6Z6a1_V<=HLfWJ:O]b9:=l7fAV?f:9@l<5WH9jCL;d>a@D
LV953@hQ]Z7dL87X34M87V7H=lB]Y<[@;8MdCL:2T@=QffJX61kXZZRh064/4X4Z
LC<0;Ojj7hMUj_C@i`A/<>@l]CHE:AgYcDo1^m_35GgigggkcY_Cc_i4EQW8N>EL
bN55lj2=lo5c<GL:85P:4am<1Sm@Bn1IdD4N7ImMh^I:<ST?_NE2P:FB0ima`9`M
i9mhiiCT88MW>NDfg07D7f7L761D141Z5`5Q286B5h3D362R4R4P4WI25L0:0H0i
;D7X3l484T161>1T7H7NC@d=6]<0>JQbLK<@7R7U`a:D7h/N;a829j7^7>4@3f3D
3D3880HF0_f86`f9E8WEDeF<b`>008`6>egZognnWloH/n7hohhogjo8k88/og/o
WdkRjEBVaEh`Hlof/cfTDbPAcZMSPJ3DMSdP4Ldfhgga5Wm9JABJEBjICJMCjNoZ
UBY4o51E`IF@1FaL<1Jb6@aX/ngo6I78gfngboGjnKLmj?II9992ogg6Xdo;9LZQ
OH/0L1D[SB<5OZ=Ql=9KSRlARLAS;iS/UTlUK<]6ZCJKfoaoWE?Wl]E95VY:e]<I
M@4mDBmH`mLn]QY8]KWcD<5XLY^JQ^7o]47_c?`Mi^^9aN=anAbNEbnIcNMcn;Aj
WPi=5WY5WkLI7IJ:ng8aUXYPD2`nn=ZogThcJG2@4PP4dPUeB5A0<RlJCfW5:]0H
4PlNcJWd/Qm7`Nj;7dT1lU`FQH1h70J2R9hW0Q2PD1B5XR2>9PURD9YmWRN2@@nS
S]WdM1OUHC86P@0@jSZ?I0Z04h@1JB@o4:9`PR@G9PVXMl3/6Sj?^b^;<@nT1i2>
7XN5lF9L7bMYk0<[IYVPHl3Pl48G2N:`c7:NAk>^Oc]^Q<ZBW[=2B]h:lf060P20
00800X2`9S@<HcW0Ka`[fljn<G8ak7fNYn7lfZA`A?kV<00;2ZCAbo<Pac8DUBK7
/K<dcDPaBY6UC`<e0T[H7dbbZWSDiBEB6mEX<3HmeNLeHY:ZZUDQDMA^6Y=JDbZ3
J9:fQbF22]Qc@N]LeiI5TfEIMVFKIeU>daZD;:Nd3XjO[=Wk11l76>X]RH@a7510
b;7ZM8EPN00S@bLTOP00@;SP?i:62IQ_1`7hVc0b:<[]0an`<OakW^NIgWfOAk4n
Ca@V^K1^7fXjjY<RYn7dlijWbXYn7<Bi13G:H07XNQm1N5`N0H0X:7nN9k162`>V
ZKij7FSZd7hNB>W/^2hB:Oin7^MYn7XLhC0^31`VRK9XV8IX>0R2Z;7/LYcW2[H6
6/KigA2Oj:imIkR]TY3N:[DH:P^2P10?>Di:f0h8PP2`TRJ9AR6BHMB<>OIkFZRm
]WeWn_8_82@>Xhm6DfXbY/=BU<:KaS8/EC?7lWBo8>LgS=3Kc@nLiDCH6kd0hm43
7B2?daIMAHmAZ[eRA<=eOGJnYUO:H9_K4mg5AmUgONMkggOfHSG2dSb?7D`_M4X`
^e/[8Nid2X7PH5^H9UJjM9ZVH2R]WbNQk5FFIO001@=WFXXn4:BQ1T>BBA]ai2bk
nO2:[<TA=TnD1`76Ljf>`Rf:TP7d?DS1Pan3^1F1/1H^AIRU7P?0MaF`834Aj>LJ
`fP:080D/Hm15Qg3aG<>PLJQDQUC@8F@O`lA[3<5l1<lHm1e3b7k1d405P:RR549
h8`C0V1Z3L7TN1AC[]LOlHXc2Sc2>=N:MAhDACS6<H?4Ea1B1TS;6@0D0h0R]Ya0
20T[H1DhP00N141Rk`3Pl1h48G@]AJSf7Z?0XiMg196OjiI`aPG564S^GebQ]W:U
;N6Lf?LPHT6j<4f4gRa@7B9F2>@DdSGC170U94?4Ta_bE:JEEHiBUB^a90FafQB6
`^o=^o`R`^YC0/U@l2EDZiFB]UL?`c1Phi=T;f]Z4[N3YA3;hPEA9fBm5cSNF=`Q
MS/Bb;8?DN8IPY1?72>DLQAAo2M4X8d<hF0XSo7^?D<@H0aR=4^9i[X9`CP_4<8@
@hhA^SJ8b?PZCN9H4SSNDL^0oa7RG4b>8L`ii>XR@BFDfZoBSSL6h>92P351SM5n
;/EH8PC0o7fAdD@V1;Q<263XG0_APU57n<lIXeP:0>JP?TSYAdb?27D7`>PG`^QQ
31B8R`mai1N2P4dB`W1CSU7RFFG;G9iBPOPXZH4a:Q5URFnlT]3al9RTjTAmZW9L
Ue7b?M14/G:aoHRa4;hH@_03ZhE^;2k`4080<1L2h5@;0G0b2P4h:PgQ]3M7>F`n
5/DSV;9ThSQhl^9So:j_TCHk^]7h9F`@8k2;30Z3ja0[K5<3G8cjCUMUT=QT=:AC
DMiASm1;ITI=Vc;fD/k4EGMOKAFS]9J@kC435Bo7m2J4dC3I]o96P0][OjSUZZ8h
4Xm6Z=<A]^G@S@n1m1P2P50LPiA_[K2T4h9@`QLRd8^?L4@6P<3S7F>dMHm1kP?0
L14?PMPk<nKiAZMaLD06mJRDLNYAaj85P0B2gB1cNSi]F?lE@/1N1D2b5`R`iPoQ
l3@9/CX];bQa3F6/24G1dS[7@G/IHbAY2M4^:6K1/c7Y@7<=@1LGQa3W70]LL8fA
[9`:f041`DP/QY60<0Hc>RgG`;RPQJILjhE2;fGYLPnaj5[;g>/SM@4AFf:B?Nl[
?Amc/Z0YEb9fB@3SbI5V/820;IA0mU<L^EBVZSRRg]_UBcUehN756d^HBV:g=PVX
]SH@4iY/b2DKfKK65@]3:^cjT<hVDc0D`B6N@/Ik9;VmodW<kiRd5X?@RVBA:98^
NM88o1lSb8l?/EXZ1F2b5/;<L@jQd3J6j>B>iV1m<RZEKRla<BiA;Ojo`l`UQ3R8
cJ=XSY/7^<n=Z?Djjf1jTL?>?4NBHRbJ<8l?<A@QQ12U56:888A0T7W7XF@NBQbU
I590^@Nd/5og]ZJB<Ma8QgUeUQLl_>AWU3m4X9<C8Va<RV2:48:8aaR3;Il`4N`?
`QQ26B<hI3?QeS/78=N78EadS^7n>NO0^1IRgJ/>LN0nakedSTGHXjRMNa3;>DSR
1DjG7IOT?KP1S<GVJ94H<aQMEni7T7S<R`LnD:<1kb/Bg;E@0I6gc6aVFUOU^</Y
2b1aL_:e[cXGWfPBBf:5J3WXPn>S:c94??YAB//LmFEVARf;BTli>954gPkN/BA0
T>_[VMI@5Yc=JkWgHnbMU<=XM/C?Vl3o7X>hMHh08P90T:`D`[QLRn5^0[^8Ta:R
QGkL1LU6S4EDCjHODe_R;Sk74JK00V2>Uk;8]YWgTLUCHaQCiK@T13R26T<XI0jE
PQ/3R7A_UjMA/FYfFflhoQjLH7`gbZT/52M/hNG?b<9RT9Q7Z>d4880BRR52:h@H
PQ93J6/>0S`m0mQc3L;DG``AjmP7j>`K@cAQMb0n<`JPiajS/7N=<I0bPL[i7D]F
e7J:05eNDFCb1Qf8SidnF<O>dbiJ_eO@lT17AkTLB:DOn2^STQbb_K]:YHOXIl0j
;88L1@TXCl1Z``d`JbY`YBCkX2^j>c;kYc/bdD2R>ig@Y83D440hIhgJbT2YIcXb
^@]QB2D8hS[cSbCP:/68A/6K>2ajbT3D70_`P820?n1@>2@F3@N4@V5@^6@f7@n8
@Qo?mn_Ml?R:@9n_f1>aY=1QPd71inA>1?=L;IC]1Y=mmaam`:9_Yj_=jAVLA>H_
nMbJ2ab=_mk_Uo_an/mX/jH_f;_Io_jU_en?ElE2N?bNDmo?im>mc^@]U0V?n;VT
aV=E[5HcNb@:Mdn=Aao_Yn_jf?In?alBFb?N=?Z1?Ih_Qhd^NA>/Gc0DEn?1`]mY
3/M3ek?EoUHZV9kCMd^9c]FF?VYA>HDin_]U/iZY=;Z9;Y5=[5E[EhiIiDB/C;M@
>H_^/C2gG61?ZML5lbEk_ZU_=n_[LaV]g3YBJS?mllj5abCM_Mmb31S`3caA_V_Y
m;3dN0<<Sf?_gNn4nJjD68``0oN]cj1oWjogo?o040`4lR1[bXb=_TPIl`FAT6S3
1kb?hP/5Z90D;890b1`8RCX`^gSg@TPT=WnIDBQG4iiABPdA`m5/GAO64HaU6LJA
ZQ;B:fgkQ7nN9e7>KP0001HbS8>9jWZM:17XXIoWVYcL^LXRC;T^B1=bg;m@dYj>
>Zld^:FmkC/1:T[=doBHW^NPBPb30n3P>090H1Q3@J_bfZ4gjmXX^CU7h^ikW^ZS
4Y<OJ<7dN2o7fN[C^/`2/7VNio7VUjCU2CY8V3C9`W2M80P01Y_VnM9m/FWbjZi?
JL]dOLk>da2g<B^B9Y=2Zg]bWKV^7B2f9PNi[VJIIY6fKYW6fKiX6VKAWVLJQY6T
K4DW`Nbl=ljJ2[baLb7lkC]>jgJ1@X:Ma1ALT2[bPIIgB2]edbH:1X^S21GQ6[kP
34;m`k6emGg6L4XANJ177P@:H8Mn3@n]l=@@len8A2V5:T_<@_Q6;la34Kb1KSAM
HhPd<[S:^6i5TNBI;TfCXBdmF;MOb:7lZYmWXHiO5b1@204>PlShYc3eFmcN<1KM
_[[UbL8T]bP>TNQlDRP^V7d0X1P<X[M@CE1n7b^ai::V=/FfN2;`Zim29NO/:^MV
:=Cd_R:9SUjRIRYRRbh[:Q9`NQlWXMB=B`VM7EQKMZffSL:XgY//EBODYFjjCmg0
h<bZ;<J<:hg=YY^OQhVXI9PP00@4SX@Q7UBEYJ5:DQEH83AK5/GSX^lRccA0W2iK
MKWJ8eKj5HOJjlUigmePZFWQhm0f9Gc3ejg^VGTIAifCA72SbMhPhYN/B_/@E1LF
NNPcggZPd@nG5_^:dWa9o@;_eNYhZBnKk_hOSnGinNl^N9fOIo7hYM77VDHWQ<91
0><DIXecSWBE8]iaZFWL4<8VTLNYgSU=4>TT40AL1m3h:8D4X8nBo:i7fg1o;T1k
VnHBG>39KSO<l<FgDNcQB>3i7/KL`YQcT]D9fXhZ3Fao5h7hLANA64[VkQnkHUl@
6T]DOfheFCiT3]lLNgEE9NR:5>LZR8WPk1d3K6P001@4ac5nR0d8]@]ah3`7/clj
j7C_6TLPkI;L3HV/^?bQ5O9lV?T4A:<X2LOADAoG`Cj?;bCl?_O6oBA2<gb/DCf?
dHLSeb0XAFOAldQfB7iB202BK4CWX_A6bejR:Ai0=U8>ZDdS90bFTC:^ET[IG47>
l?POBMS;@m5B:4Chjac3V7`ADgh;0CP[4>84A1^Dk4kG?1V>3^6Q=2>b[>:1L8fT
2P/]I^Lee65FVLhb8STDM=eO`_P[C^BW[E>`HHS<@bM/lGS2<jD@h5V;J2]nL<Li
W:hW8e@jcT6fU5==5Hk2NcL3/529D@hCP/1Q7HA`E`/QMRl5f<1J`nBZcBPDSQ]Y
cDLTJOdLf3BZX5WoGP=BTP5jC2PY@@b?:57a?_@<n1iPoWfB_YXbH5==aOdiG=3m
QREUc_aNE8Imj=F;E5?T6bY0PJUB3I1CFYeCjX?`VVZLVl?@l1_3P<XHXab/3kSB
?D3`60?S15f<9]`lSc3fJ2MhZDi2PE_Y2K^I1<W4DFWd00080RO:49QG1KM68T/Q
E_?eKBI77CF9a>4PkA2M[aWKHNN1nYiEk86d6NKSHL^@BZ[BOT72<=bR^EYA`k`U
101/183P8@OQ?2d0@104AbST7EFfRSS2IT_EXNJS1ABX?R>ZX@jd=d0ai?T=Zh`7
;T2F^DNAP4/5lSX^P8BjC421P3^]8`B5fIC3Z^KE6kb5cb2B_45ZlTZ5`8;TAD5;
;iTGX6_<@dI]l@<gc8<beJK?;_gi_eO]2ilT5YfMT?D:PDPZPj1Z3LA@P`l1A2L4
D<XI`haXWdSR9[ng1]4C91bKRISQU?B`KV9Ye9ZEi[fL1^]PVQen``QE2Y14/YC`
iQQJeP;4A0Fbn5b2>Y];EWdAA<LB8g5IEARN^b]D2]8am44RY`ah3U6n0/0@01f6
E7LC4?POQ4@NbB]HNZBe24UWQG>JlMCO@IBTkXoj1V<4KH4><m@SLhFE?UCdPQlU
=SQGZ5k?AnD:BI865S@4VAbJ3_iXDoanAfJ90gX_@Hi7XgXOYNYl=@dG7icE9AQ1
0`KJK5MYe4:P4kJ6e5Z?DQ2VE:A:iA@V9iQh3Y6l?4MPi1jU4@ZKF5nFYYhRaUQZ
T<d2fUFab]hTeN00A^J5I613TGJE`Wk5:`mQdb6oZk?YKZeIdKE9VkUDaY3Oa^`d
MjL/iLJCP/d]HYJ>[8f=8W;eUh]1F2Z1f3D6XjahS]GR?AWUPdmSgADMb2J]b9S`
DP>DM6DhBfD>TGDdlWCo8S@<R4M?4@ClC3YaEkc?jO7?3=a/0W7@TlOT`T49G8k[
03Z@6aMi5mBl[8F5_UfL16_UUDbGBA1NITAhODDQUgB12Jil53X6VN<l/j9dFYa_
WT=^J2E4SLn2IW7WPKV3A@4YkM8bD6gjfSY5nf0G?4c8MQZNb34TkVb3MZbBYR9a
^_^4VjZk]?4462/9SC;AQQ>fh6]7RIFj]e^lGM^IjegICA4n]K;86X=0J`nQl3of
lWS36c72D;^5KNX>e5d7n/PK0:0EP`B^Ab3AKm;@o@mZ1R4XDDPbmEbNVI1m6P@m
P0_f@;?JLUm]MJnoA_MB=?8<_g`9OP7TO:o;V^;]:80Z;N_W=NelS4nM9W>o5hCn
knYmET`_QOS30D0/1ZY:0<_BNf`jmUb9Sb7/?N==_NeZW>DACM5OHhW@jfDo5_V3
5bMf6T7_V_^cG[?fM^?dkDh@a2Ij/2;PQ6/^]/J<9nfd/fJ6fdFnVJPX[ZV/VPW`
;T<BC:7j7Z7/7H4X4V4H06]L2<2B2J78bLL8[Jj^D28X:Z7`7ZEHZZC<9d8V686>
6L4`4f547JD@[ZEXbe0F@2NVdPA4TX7M2>1g2B2o2FcT>LYn88iL2fTb0A2XTbTb
352`S`N>oln/_dA2Hd1J5c34dW2hI<n:T2@l_NC2TX?b7S3L4c3P1Q3T153Xdj5M
2K2k3c3dI:7B7@7JDl06Tb6X6V6NkJJH7P>6D0E>;V[n[TDLQn8hoK1DWd9j/:=8
;lJ`8boJl`:2Vfcm0T9fb<kF`hPF[PkRgdh@_Fk10NoU0ZIC0JW4kJEDa:XhLS06
Ag0I0>WhC^FT;b7^fTLX<<D:=87d7H7:6f4Z4P4D4f4^4X3`3/3^;P5:5:5J4d4h
5<0l141FF<7@c2:`8/GRE>hH?jiT:f^J_/FV2A7D2I7HOJ86Hh5dCT0Hhj08Tc7T
6;7`YHn?3f^lA24i7n2O82Sbn6I?3>YRTl8fZHlb6P6Pi>0S8NN/2TMH5/YfNdjQ
777i8c8d@/8V5n5l620<0=7ZB24Z4V4/J:C^>8gFKLG166SVJ:DHaj/R/:KDJi4d
=jaD8dcm4jKZK55HohR`f?0P`VfNkdg1:<c@R`>Q5G5TVV9o:LhB[lk>f[5fK@SB
WhJ4HH[ZJ`2h2Z2J7VUd605d5^5:524l5L5H5J4n5058l`2F2T2d/L>6ENV^SS4V
@586TXTHA2GPG42V2;<07W<486Sf1e<<0;<@Tc<@0:GZ2]<LU4nC8f_bTHU4H80X
nRUG8<_H@^A3<4Ol56572B1f0m=83c=<^g7M8>9nda<U=K=L8FA25?=TGZTb1O=/
6D6@6>Xh`g2:BZIJg1:>IB@TXjY08;4nkn/A>3:B/?02?o3:HZPE>I=Pc@=8ahi/
<HKH=lkS9@_FVV6/6N6T423b3^7h7T7P1N1<127>706`2R2H2<7L7N7B3D3P3L2n
lB</7o?c?bm4GT:S>8>6]dGbSbH^n4I2I1;hiD8:2i@H1W@M=<3bSj0W3]7D2@Tb
i:23@b3g@f11@j6k@nS/_FTHGPi_=NAZ?NnF3KAD3kAI8Zi]@72OAL89AAAS=DQ@
QJclMj;e@D/G8CAZ>]29@n6kAD3J^@0h2?B@;D5R^K89A=BMBN@0mb843ABXi:Tb
0UB`;>366mBhiBGSA^nT@5@;@>8?AcBPAXO6A2_L?M8D8P8V6n6d6l0DJT4L4846
0@B25V5D523P3B2n302n2`2l362j2J2`2b707N7T;I?b7VE:LRXn8VdB7H3aDZTN
66U48Bih9hh`n<:QDj@Y3F7k300EE:7?E>864GED0MEHTb4CEN865kET05EX^<6d
HP?NmJS[=IC>I6Y86Y=80m2>7M3@8F@X?Tm78`8A@<BZGPTb?bm<8:_^?NTH?9CF
7fGB5W@b22N2hZ3X6_G0UEBKEkG9G:8B?NGP0OGE2/B32X0A920<2_GT_R6JIK8/
@mC68IC=G<GeE5F:miFIH3H2;Pgh9^=>7l7[4@:V:N7X7ReJZj7T9O?b7J<0V>/P
<2jiA_B@2?EX041mHoEn^Y@2QJYfmJPP8<GK7X3;IFA66MILU80JTc8H6P8<59I/
1=Ia3L7S39F[EiGhO9;eFXOb:fgT1[FcGoFHTgI5DlUD?N?bi;JGDfA3E>7>41J]
B<?41hSn5ABJ?cAYFEIoK3C>e1FR89IL6LmT0GGIKF01GQGL25KP5CKTAOGb8GGg
K53CDj_ZcYI>^69j_>bBQj;VJfK<=8@ZC/C/GRWTP>Ph9O>/86@N33E:0EHjN247
L^cJA7K:YgA32KFg345cC6ckGIA3Kj7n_82d^b4PPQCJI0_OK`?nhM2N@YBEKP25
BUAkC9<RYSA2UDA3K_=kF/;b5mN82GN<N3BeIWLkMiImMQNMNMDgM@G[Hj0CN[<G
B`0T0kNdhV1>3[NmAU>LGcG6VXoeNOC@GbYJnCOEOGO@;VB>KJQkIf]19DYnaH84
<6YT[ZPj7^hGBl@<1YP1GD0NTcNZ0C<GKB21PB4APFN65X6[POM=3`85LVE26oJF
86N2TcDf?T4_Pj3EPnOKJM7gO<n@n>PP_V0cPZ?9G/QDK:BZTIQ55E@=J4;O<GQH
7nH<7N4EQf17Qk@L1VO@4V7YR6A^:fmJj5=kQ9RE8cQ_F^^P7AGPG[IQ3X147;R]
G^85PR@3KZ8EN1RF8SOCBmG`LRo=HbEBEbEbbd:TJ8oB/Da0jJFVlXn5R`7n1oS]
KGHkLW=XB3<F0?SmKGN47iB5I`1=O67oRXG[BK7`6;31E3Kd8AMKRn8LnBmJ3UT]
Fl8<NYEgC9R@Yg8DTIC<6=U5<L2]KBcd2lSf^8cX?cM`T3FAQ7TUURn[@BUTcX?9
B8TcM/4gUgQ@6]UmTk<iO5NJ89RmUT8BNYQ^?OKIVGVIGHbR037Z0:0@0605<HB3
97960I954201VX0:04060?V_W6Ll?_W;W>hjbSGI7YKGGMVI<GWMVMHkEX8=R67Y
<F87UJYSFgN1<lG@GB2MX3R;DoJ7>OV=FGV6A3Ul6/?DS?4@I0ScQQDjO;Q^^KRO
LVY^1BA>1FiQIdT38EQ_V0RMAoMOX?Y<d=Q^_^?cE]Hk@ZGP4oYQB=IW=CQ:E=V6
87V;Y>8PTncY>LG0>;;ZHDTJD0Y0el9<>EJ6/6:hAbA73]GQ<GP;Qj164MZYD_Wm
A]GoTgNiG06_38876V5:5I[5O085@QDZ3`UBidhcA;Yd8:_N^K@[=056TIXSTN@a
AnA2_^6W[gBX3AP4Tb65/3RK2OT2Tf_OTg[K/B?jd^B[7;X<A/_OY285GMPB208=
3/Y<0^SfO:^JO6IJ_O8EM600cGC9UO/O/Dd>SNfDfPki>;5Ng8J=M1HjTcJ/41XF
IB8fdnD1CBGb2c]mAH3kXoAoT3UY3T1P5_^AM=S3]@?[TRe18V1k^SQGYkX@/f:f
A7Qb55^d1_^iNd0j4?_1RNTb?9]1Ao^I_>AXN=2OJo[8NL?cQ^@X__U>TSUD?>?@
0]_`Yb5o/@<2FWT<YgE5OCHjTg_9[]TS_ACLLRc5>k]JW/AG`JGQJY@j11N<2FUf
S3Z8_>=4L929Y4@<_m29DV?EET5kKfQK8De1M]2SBHjKXWAlOM]?]@YF@F^JU5B<
Sg39`:;NA66aajhf3<dF0g7H2H5Ob:H@?cGPTg`?`AbHAKMgC0JL8_bFGibO_iDh
;NcW^X7oD__`0/5aboPT88GQE4nG`9EiN1W]]aTibKYm:9575M0ZM^MXklhcXMRd
8J?TO;_E77]=bn5`i:4md2YE5lD0i>TcWeB1`g/KY_bK_ObdmJZD423OdVU1`kRb
B>5GdcFgbj3odkPN6[S5AeC=_Qd]cIe<AODgNFOWaecgM`IJScM=K?EH0Mb:5NHQ
]=c2HAQ_K:Tc/HHAR?e?KY>RaNX_cTkC>Xn?QcdV3NnL69/T:5`b8EK:SbFL6UXc
2F2n4OfeU46=M03mfn1Mg3f`dKSYabTYbWY?MUK1WbFWR/7;LVGPA7PZ45gY<]M]
[1eDOJScN1K;Y;f3go^J;cV@BmdHI7gm39CE/9J3X;ZiP45=hNO;dA_;aQ2KC=YD
Z4T5_=h08K0U>T/@/FSRVM>@>gAPOgDj?c8RTc=5K?b/86PQaeV?28@YPF4@i?g2
1L29ic][db5GC2@hOeY9[]^I/7hY=FBZ2SjA7n4h?@5Q`[N`3?jP6cjTT2mJGQTG
E4?O<FNTL<D1Zihgjn@2NYBKf1bXOO^V9YOOANH]LfHL@GBh6mQ@4akUiMkC>`O7
ROdj3oSXTbIK_04>cJ8=Dgk1>WS>`fkE1m:3cUi7io/<?LOD2kLWKCB=][l08GfO
e28EA8Ac2fA3]=bOhfA7bOeD__IVTc^h1^Y@50mKJBYRTHG[IF3:8=Hj@<^fi;LS
h?l7mcdB87kHTK[HHJ^IAhcChD8[fR87kN0onB^T49GojfK<@Fc_7U@H2iU0B2GQ
Pn3DTcRN8Cc_me>_l:PGl?5]lBoSnn?eDgc^@X1coGKBG[<GGQIQS/1n4;oY3/6i
o^@X^JSc`ncX80o84oh91Gg1gm2H;1Gk3HG18BoX4o7_5HO5ha6He6hi7Hm7i18I
568>nhW6XJoHS5g5;G];h=1i79IBQI/1I`EYdn9h09lgZ04J41:9;G58jABJEBjI
CJMCjQDJUDi0VZ]@6m:HI3XQ5gmGJnogiGHOHK2ogg17e1;Bogjok=J7eKhbn[]1
K]JhQ2XO:Je3kcOgnj<89l<MlA<KK2kc1BeS`ATB=ThW?P0BlaUS?Vh:nLm:jYXM
5XhcIkQI8Fo[OM:oHK7IH93]UZhG[gc1=_H]ALHaLGgLlEX;M3I?18V>^AUP7bl]
?P5cP80`<2^YUP3ena5l51Ihn8;`^5G[iHX7Y?=ioA7O3a_;6iYG8G9LEl[fo/K/
OP6_d1`:11d70KP40H2PJ1`8>L>44[H/CK_]1KD>neJeWlOKG=fQSH]=32g=>gT=
=>m<@a54LBA:R8]a@34E0i5P^aLD4H6lKi_[BOQmWj]In;N/Il[6Nd7WjfcL8:NR
_WRPQj;HQb57`NkGXf`CRWnnk6;^/[aX^M<]1c;PgBlnR5YBkZ:W^0dc0I=0HcDb
`3cJ1LgWS><`;a:dBc/m;N=H]47[PeImP>W`3020H0040U2d?@X0Yl081>NW`6D7
@00DC0KWd8004D>0820>158dY@P10B105/]Ae7e>icW060P3>KE@0DGFEIDaF030
:12O09AMG061;WE@iMK8:RK]]`cb][X^28ba>mWfQJ:WBU:SQ>jCi>Th1`40:1U^
9l0]ID01057LN1f[599nWV^4SWlNbE@XgLLb>OQj=c9:a;RNal7T[il=NUBl;I9T
N88Nin`K1l?fUQ^7HNd=Z_6JN:4iR`/h`2`;P^4`E1><@a30Di>50MQaW@O2g^lO
ihWbNl@;d]J6WV[igX8NJE7`QBnHH_<Y<lg=V@oX3aHII6PWOY8JjF=>Vj1:S>/l
ah]</1n[EP00ZJeWk?<5Hn8K0S=Ua0/<m=baMiA`^Bd7lNJdWR]<=H1/Im=^gjg=
nOEn;@N>4[JNTRa0QZGgbOil7c6j_Y<_TM7nNil7dgQn@XE9EUABebDlb8Dlh?ho
42J1WVXNYi7c]CCY:R;1>4`AHMLC_HJSX>`mYf^6bRmZ9bXLibW81]3dBWeP0<1h
K1n8?CIU7ilWLOilW@EAB4/8XTRDF9L5l:H[R`>Xh3DOIcVd5P?P/AY=558ioW[U
MUlS`cGad]im7TI1QUj:h[2h>`nT:;Pe1[3j8PA8eQZSJ7ljI43]X5<=8220?n1@
>2@F3@N4@V5@^4_B7?j8@=ma=naF8?imAUU/eU9Q;9L[4`Z1<614D2dCV8eV=@ZM
A^Ye^mo_Yo_ej`9oAIk?bK@9m?Ik_NNC><_RS@J;`Ihd^1aUmDIl@InE>:_f1eF[
aFUD/Qed[En;`ijA=m`=NfL7fT0F^f0jg<VhE=nDV6GFkGNlGVmG^3EIofFL_mo@
:oH?1gn1?b1_bK_aiCFXeImEIl`9k_]mH?:hO2e5o?B1?J1?Rb_O:go1__5@9ma3
7_ikhB8_=k?g3a:9h^:_Z9/ES/@006f00i7<i]gTAMnJem?VihFL@N/@Rj?lOML5
MVb@IlmgZgc`N7aN?bNGcNCZg:YE>2CTT3lM0GQP/10X:9iC:C1cAkcMm]0OQd7T
Ma_0`3H@1<5PKU4E1D1^6PESb<`]TB?`l3:>Y07LPAl[:a3n]4VYj7baioZ<MYbP
F]IYVLIak;:2PBQJ:8_S@Lad`ffkcag7TNam7lPB34bSX:k[C[l`34/8OiUVRHi3
TN@@V2P9X7PP2PE1<6@e3<>AFUDF1f9PeRN=Re348:mD>>j/RW5E=hbCRPbX<FmS
F=c>kFXRW4mWn^@Wd09M1;8RiQd<7]4;H0M5dH0]72UB1eDTQ<SB5Be;XF_bJ<@`
k3>R`E?86O1kWTM31=ZO3V]RXK5=/VIo@lZbLYfOahW^NbI7jNRUW:Ja[6TKI^7H
XIk7`NJiWRJaZVLJMVVhKic@m7AnZPjIoWHMYfPV2P:1n80P7JMag=/fm2>P`9l]
9Jb3:M8e[:Z4Mh[Hkm<G[Nekg`_M[>E>b2:LO[<56CI;0L103>21X0081igf<oIm
WRN2o/lMQYVNGjePBGaR6TE9GUN0JeWFKAX46?@jTBCQD7K?T><6_eb9VOIl7JLI
Y6<2:eWoM9e7JNP00D3ARV/L/?>gO>TJCYFU[^X9kZ[NR3ZNf9o7`JQX6JJYZ72J
IZVnJQ[fHJaTV/KA/WLN9k6JJ1ZTHAQ92B8XWP^28<1:4HB3J=XdUPF9EWBMAb8V
dioW]`en=FPQRlF0o6dP:CZdZQIjlXYZ<ZbOZi;T;O>>^7`fM02oA5SdPVm<hJel
l@OEPoe[T6kXj2JMYWJ;i931ET`DUMe9ON7g<akEWg6ZbDNcV/U=2[ANNZb`lW2J
7hMA@4dABeP:Ja/79EYmWjNi4T@AHRR89A`7:M9l;YM;@<3c9mWcCIoWGnGMLcg7
kMhP^X[9>Tel8Y142g0>090=>Xo7n<k>jkF1D2h6?o8^KLZ[/BT^I6n=LJC1F3]0
0X1P49IE=<k;:Le?`ja9R?464d9hFGV3o2@4d:0E@Z1?;n?@3P5P9S?76>`MIEcA
Zc7f>PLHiG:3a<4?@OPiaZ0g0n18EPWA@@X2h54<HMacV::RCE?/3H]AKRhN8YbX
RS>a=HCDN@bQR/H000`?HPA7R^5P:dChX1<050<0XGH_QQSe<VhTZ`oCJSB6J=4@
`Q11Q52<41:`2PFP]1FLH>H_Y8?bQf@Ef8AI;5/2C9TM4Vh2UTJPWeJdHS25E8Zj
d3h4iD;R7LTHB/[@6B_;H9>FA0i82n03;LK4^H3aMUhoUV1Q3EXNSi:<V[VAn6C7
j?TW9UAnTd8ZJA?a4S4Z`84?0O3`C3^G7Z>@LPfaT/Q008dAXTcETd7l9/CHYA[S
F76JMF<bCF:gA:m`eC_3mW>OHHX`;n5@@?L`W=8T24S?n84jP04XYNd9XD_F;jJB
YWO9bCHN@4P60:;F0L;`H@d3cE_6<iI<cA3n7V243`5AN2n6@>LMXn@6PB0/>LLX
i1`3E6N141H21<R/5Q9<VZ74C3^7^2/4`:Qg3]7BH8NK>adQO2>3/E8VQ?`j7fa8
Oj6dC4nVY@^[EFgJBk8@G9Xk51b3M6T0D1H5aeA4W/?lGP^aPSX7G=HP@mF03n:6
LjW[m605C7`<B_`Q;00j/5:P2H<K31e/@;Ba@l;6;=6V1:b1K05fC5=IFQY1g38Q
88FA=DoAUfO;H72dACRb8]6MI=5AJaVF[8^DhF5[`BFa;9IaO]G7JXj9lHZ4DdC2
5U9hme9IZbN7n78?0M8e``QS3J>a3Hkad3e3D6@=Hj1g3/<lD>gS=1ARE4D`8C01
hj3]HR?L`HJ`g1m7XK6MeVeAccS6YeCl_jl/_<DJX^IdEG5n;oK=ibjdn3n6=P6e
02L238`=KAa=WKKH;`H@TZ^2R4<0VL?/70<PI5[04:@DXZGgV6:/?aEJ^1cSR0hj
8eZC1Y3J1d3h8XlQhSd74=TJTh1I305lJ1gI=1h3W7`6@;`J3@Te7K4PIK>@0<90
:5<:@GaJ326eFYQXn[M>m`KUG:aie[5b_lH@d@nac2U4n8l8PC0[9V5N:dG@_QL3
0Q4J^:lc31Fn`nCEn11k>U>61WT?VN`RIm0AWn`@>PCJ3cn0P]P3M4F61R<7AQ5i
@TC`Q?dPKWQIjEdRE20H12f>c<B_d;^Wa7JQb^k@cRWdCAFVHZg>Q=GV/k:SRO88
oa_S45h:<78>`SSi:/<dI8ed7PkA6?bMaP=M9n7`7H<hGg2S/101/2X]AK2j7B>l
OHNQ02FO@c]9Cg7R4cC^^UgRi3EV6PlY^n1W89ic;]9lfhT]gJ8HBF/B>lh2iKe7
_NQ;TR25bdLEXPIQbYQU3062Fh0AK2g5c^4WaSeMC5MeGPdhn9m667a7XNlZbISe
=Q6HHhTA32B2l5H=X[aE2jEB>dM0iQZQH2D4TNhiagSS6b>7<h^3jPO6`></I[1o
4g[c_SX7@B3WE:[Ei?bMV:111j2l40:0H132L5l0h10:SU6m3/`NKR13bL_=AP3b
CXZMRbog;Hlnc2Dk@1G]@1^f:<;IXEAP;>i2gkY0iZ95e^0D7=g]c1eC/dF;Fe58
`T?21Zl=d9O>YGlLBA=ZVW/cMF8O=5^<ci0Q_Qm3T5XB8T1>k53b7T@OVa;4AbTo
LZ`iA^3M4b8`@IPQd<24H4T8hDQG2c6L;8G@g>O;BlJ?[73<al5SOMF^Hk^Jee[_
QOVnRoK>km_d@=d`CBf>=0>4cjdoo4OIj5ZDA`RA4Z;02=clF`WMSnY3i>h<Hdd9
k:enH`Hka_SO6V6Ji9/1oR23h9HK@eeC>56P6T680J0>0L7<6n7L7F7>7V6H6D6Z
1j1l2L7RZB:4N2Z^inne0^g^X@86GL`N7^7H7<6`0D0>006`72^:<Z3n3h4F^0Lb
hT7l>l]hFX:R7`ed_8Mdh0nND8k67n;4:Z3k1nUN0HX<h:X<052=2>]A2>Lh2f7?
2Jbdgl7nMN0m2Vgn8P:Z/b861;2e2>MR/^6U2n1]32=`NM0`An]`9V]d=>ShcTfd
YjDjSl7n7^72140b0@6b6b76Nh7n0h0l1D6/6X6nYj:NE0L:NH5X5L5/6:5f5d9Z
7>7<6j6H0J0B0Z0D0L1B727H7nil<b:JWR7c0XGljj_RDn_Pgn_`ININ8BPTCj;8
M40^db;H0Q5T>h>m1g3;5^Uj[/7j5D5@5B;HL6[b<jFXhH>RV2oDCf<2o<If7<ST
4B685l6:685n6R0V0N1<XnEB7X<67`6L6P6d4T4V5:4N4L4h5J5F5`9nIf7^Dg4h
R^nO5a7PZdPRC`:8cZ]j7d5f5^5V1H1F1>=>=>7V7R;VLBA2N<?hil^4o;3R=D76
7>7@=hNLTl8ZMRX<;H1?8^D@1j2i8fl<3E2F2W9023940k98nXh:db8B7U9D`80B
U92PL/7d2?9T;H86;4/j539`Tb2C7RD/WfIQ6<]i62`nWdVBn2cR76WF0n0X0/7/
Sd4n565H0J0L106Z6V7<7R7L9^8`<71/7j3`3Z4=3PCl=07j7V3<303>QL2jfY3R
IJYj7^hU7FJZ9h=_:h7/<g59;c5<n>]a0d8:;4dH6322/T/W225]<?9i<B`F;P6C
9X9ZV>Mo9DlRjn_Q8B]i;ZETY27@5P584X1X1L1`3X3T4>0>0<0/o47<h0Ym3J^`
V2IO7H8VC=7O<E=XMZMR:P>Z/bB<8^3230363n4044N<[a3RlH887V>jII6=6Dfk
5@7n6H6R6X181B1I1XNL]JL^Cb]R186E>j`N:VB</_0fPB8@;9>j6D_h_/LC8^1>
6g?L86k<ZBU67k9`52Hn5N8B;T43?f41?j86LXim=Z?2M^R`Dng6Qh_VDfY2:R8b
5F505Hdd0B2n2j2l5052560Z0/1@2>2@2do8<4bT7l7P44483l06020X5Z5T6:9/
ZBo<5T5J5R4n4n5;7n9`<T:S:0VE<_;f9m1XW/n<Ae5:]`PNCjgd862[BBh;9H;H
DL0:2cBP?FLC@5BXlB@i>bE0Wd<0]l_ZBC1^Mg@>Qi6D7b7=3R7BN8[/L;AcB^=h
[V<D9fCl;l=Fjn7gAM7]B[C`JE;m4dLZ</:24X4Z4^00060D2@2F2P7478728c50
IN8VAb=0@lC<ER:9CP7f606>6N4f4n5D<?9DA:?K1fMRbb:V/^JS2`8F>Z2eEF3e
EJ;d>Z;48^`/1T5GE[CgCb;ZPnC?49B75:A<7d7VZ?3P=J2h2X3B7D7:7^7VG4=H
7J7P<^`nR_3e4e:h_^@j:^>FY27n7T7P7V?g7F7R/L4N4N4Z3P3^3n?`5Pif@l=Y
4hj?CVO^<0EU=W5:bg?5Cl7^P2d:1OGh;Hdbd:7CH39QEaH8B1=DoF891J<J>L:3
;iHL;j=69ZR8EdVXE6Cl=B=6f4EJ^4jbJ<:/n6VY>LWiH;I8Da1e;ZCk;T=>7Zg6
EUGMBVE`7@704O>0544T4d3`3J3fo85>5D4n4j584d0Z0h1D6T6^7DRbdRGg5/TX
8Y2P:MG_7Z>[@087H27C5L`<6@;UE@88gdF]8c902VP;B?I:8E@8EM48n8e<N8hJ
7/7V6f6P6/Y^0fg0[bP<<>VQ46inE67`7PcL:/7TV^W:VPC/7V7F7B6d34362j[`
3H3X3l6L6^78cNIL]hONDfJ<oELbObDnX@P>;UEF2eBM9T2>:L;H2EM@kn2oMGE_
K;ML;b<>@lO@[/ZbPm:71JO/g>_a?:9lE>HVo8<2==Ff<^ee4h`TSjMjoJDfIR[a
3?MONN?2/jgI2Z[/CDilR^eF:N=F:49VE6302/2XF^7B6H5b5d5D505B5R5P5V4h
504J;:7/2J2V3BAOH_HC2PbgE8a1HJObCj/jMSJm9N8:/D5X;H5;P>8=E68ZB<3G
PJ;Hj=NP;[I5;ZMkHa:2[ZaMDZA`h@67><V2]n[g487bC<8`847V:]7F9VN0<Ba>
FX9V7B4f4X426H6J666[?L1D1V1l7F=0A2[XCAL9M[MjflCA39;e?bLd7hkf7=BM
MF2nF/GV8P35RV;H6mR]PSRaMPoDKCAf<`7f9^_U0ZVMKCR0n>CAL`Mh_Z<ZN<Ca
IJ9`<RN27Z=5PFmlEK4ha?NMRcSd;/>ZL@:UHS3SCV`nVJ]l846/6R6Z403/3Z;n
7/1:0Z0V[6742MTX[B6n3:3NCR3D3mOZ__5FXRG93>GF?f8b8QCV?E5@EPVJ=C5@
>PMd=EUES^6X6T6R1AU/2^2`2i704^[l685V5R5T3n3j3l1_V;BB2Z7N/IMR?IEm
HQ@:OaVK<EB7;f>PV4=`ClQ2<X>GP/a1T:N6C_49M`L::/QGKdF>8;QL7h7F5N5@
4/1V1X1H3;PL0:0P6d72HK=GV/[dWQR9S@Wf?Je<_nnJ8PDT7Dnl4BGH8cBM=f8P
4AXMDnJP:@k3KGB2WhUoVSSfg_MRoD;VWL7dJOCCHc1IS9MUS=Hm2]GPOZION:VP
g2<JZBEH8R<`9b@lm;ScXcY`?:E2XoK/<PW<7n6hEl0CA>483h3bdd005^fP3:3<
3<2/2j2/2`322hc62X7XW=XaA_Mc58n=UMR;Bn<@?HVdbWILO/[`9Xm:A2E67Z7X
4@4N4^343@3V1/1X1^2Dcj3lln5TKjMd=F=><bPlo:_Ta><`<4L8_U9mNC/E7SB5
KFV8G?/MI7;fPQLd_XMf?K[:VCU<]oH?C3Zb_US2G^h:k^;YC2]h<EA/]kCS[j>S
7IYjnCYbb_VKX_VMX[/G][X1S=]dVUI2e=KAEmY_]S^4?1X^f:_^EKHJjo46EP<`
V`Xn<L:=]B=?PYI76CGWZg;iK?[0Nf:93R9X<[Lb_^R_^n9iC/E5T1@:oJH0=cHk
1NoD[cU;5eR8J=YZ<GP[^e62bY^6G]B:Wlga]71g_lmiXi0[N`lPXnjb>RR_CFVS
]Q_g`O`Q`RXDWfg>:6DeXn7VHTlPEPVF=U<O=GIF<W^YVWLdO]S3`FnA;bWZjn;o
LaHo`:gnSjBB7P7R7[IFMnV:JZfbIT]lVLV=1iNh<<>FQ2Q3_B8UUIZeWA]_`UbH
85`13?_m]=V]]BeG`AAi]MGQ5==WbKbibkblB2<d7aXZFYalcRcRP<mf<8@k><7J
k=Lga7;dWgGT_W4jfl<<E2g@9cc^Mg/:FX9g@o1OVlWdS6jnVH`WHg0feK]IXV<@
O[NAEfES1a]a0]bo_gbNk]/^=dV;bXjo<Y:3ZnlEMgd[e7e9e:;f`jh0eQ`lOJ7^
OGLfESE;H?L9/S3OHNWg_7[1//W[EiDLMkCVeOcoGLlO1]c5;N<DLCCZR:;:`kfF
<]dI1X[ZC@ShNP<bgEe[e=d[d_OjCgBW]E8W_NjlBCBW]XWi^3fag?gAdZ:6<>GB
<aU;gFSjET=Ea`HVV^:T<UBm^c^aB6;m[D8R8S8CefV6]i4iI2PlJXN<7/7UVIH>
=J<0eDo87hA3NG`JeNWa/A;JCAbZSg:3c^E3AkgCYcfeE3^YHCM]<]a<McNM]]X3
i3iMiObIgHISI6::[/=K`A^^=B8W_mgIY]Lie/VUS5I5</Pmh7Ho7BENIPSj7J6f
6V685J5X5eW?_V<>R<EZMlZadgfM:2;:7`7@7V4X4@4T7R@j/eH>EMa9kCR?iQI;
i7NY]bgoGUH?B1[1^[^_kIkakc_fEMC38PS5^/N6>GQ3id_kd6>Y57kYS>QjEOZe
^?`n<WS`L:?nQ2PP:]jl5f5T53LN46A:ECP[`e69WjU7YN=2Un7b787R2B1b287J
7T7[Q>__cRk3UMkE]gke@5kL_nj7]i]ol?VPUlm=m_n5n7MOmZ`RBGl1a9/WdW/F
Wf=h7haa;^mmeZ__^n<6Y3L`=SRn;ocF<P;oHV7X7P:/ZXC<bT<gYP8Y8GNB>J8b
=>UFm;jfR_Vh_RWZ=CNJk3cfgAj1ognD80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY
2`15gm6H=6Gm18jogloHbo8?7Gdngjnh57hm1Wk0YO8I1;h[=I]=ia>Ie>ii?Im?
j1@J5@j9AIc7jA:hE=9SCI1BZODII;YQ1:ID7nnX4lgNlG6GbnGCDJCNCbHFfbfG
6BRHAS@JRhdfN`bbFBN>bBAfVhg4bfTbaf=QHeF6]C/Jc6PTPVFblGfJ3dNChPS`
SD6M@C5ddWElmINmGbocZM3PIBjF=>F4:SdXZeV_E>Ve:9@X77DiGBX58YAF<1XS
4NT`Z3`JGR/DgfnGe7e6XeFEBZGBXE2hOSlQ4lWU8n7c8X4ngi6ZUD:Chj=ioAjO
E4P3kHi2XjoWcXI2o9OgWdn7^nG^n7dUjE:RQbW9TmL3@?144`E1L6@K1d7XTlZR
@TPJJ@2nj198OjJ:bUicU<Di9Sd>hnWnTQ=4`DYn9DCi@4d80Q1U4ad60HAJ000@
6WTPA_WBLa0Sn=aoWXJa23^<`fSjBA`:d?A64H1`:P6JaWUVFiG5:30=R8Mal7nB
Y@5R<0`RfOikW@EA=TV0H60fK1a7^IYQVH1h0P0LY`VjIaY6R0030`@a44ZNAb6b
1J;W8LYbVnLigP@1@:7a;a]VfLX1P61IJUZGKb_0lCbe0lT8E7DUA_J0;gXBVAo9
DT9lEJPMFA<O<0WTnR6:VkmM@gD]NemGmPF3HEQf8lmLeiI2]EhVT=@i;aoWDIYW
Ub0LL3<<8hVZJ1aEhLQaVh0`3P0MIdV`F1HU>0H50THaWVhBQA56J1Z6:T1/5LCi
33D?A8WBPA54bC`kSf=DN6hK1U0B1PKW>MYoTLBaDRd;HZaVEi@TX6PN2LNj>WZL
ii182P97DMIaWBNIh0R3PG7RN217`MXL121iJUbFaU6bK`2PB2VG9B[@<0`4Af7H
NR?_14bHe4le@f;YnX8VRh08BO^[7m5IoWfN/EW_3Al`dOeWW`N[UfOHmTJFZEFZ
e0^XkO^6hkU^NjKZQT;8k0<0`c_UT7nNb17LU9e6FHaP0j2h?PP0hA6hJf7Kn;P^
RJ@O:S`>hm<R>P/Rj;@b3T?^mWjKQB4X?0aSX@Uo7nAQ9U2b8i8jKY/VdI040B6;
^7nKQ]WG>`05FDa91j7XH4lDiI7g09gWl60;PfLAeW8LAl7V1`@1DLQ`7HOigWJ<
HPQ^FaOUab0F1T7Xh3N?XoSlAHfSJ>m9JEY]A>lkgjk]oEPXiZJ4_:>B?PNPgA/3
@6l=XJkNR13j7V>TKPeaVS<6V=TLXkAl:O86/XOL62@=/9Vo^448HA@SQ8[m2QAC
_@KJd[]_ZcBJ>07j>dD@WQ73O6d=8[8o`BPJ1`;/F@baj3_7><TI8_02020N;hGH
bQaSJ6V]D00WaERe=2C0L8[a@273V80Acg1oRV5B;P:hEPY427<=/Khd04P91F?E
7HeAW3K1F2P3hbQV2lHJ>4Ni0d=3^7l28104AaS]7@blOh2@<0MSLUhNXl`[Ph1V
<4I0`673n1l4@9h_1MS96N<hKPm6STJ8dM`OYg8E7SO^di]49IF7XOjAMokbQl`2
509TAlD1[SJ7>QLN`ja6R93f3l8`CQ[3OSlQ9Iibb?TdET?m;cKYFcAVU=>JTeCh
84:`@DY<ZVV5E@fAf599RZXJFJ@=`2d1A2O4F0mL8U14RI2N48;`nI33n7/f@MP8
`@Pf7T>h[Hn0M0a1I8DMa:Qm3b7>=<:`BPN070H1dF0^QXQA2Z5`0X1`0Rk5n:h@
8P`nP50:1lE0XaPRh5R;H12e@1P68_50102aW3>6`8l?@Q`6P0089LC0VQ8RK4eC
P0hUA9RD60;DEh22;QX3B64L@iQbTG0B0P0h5Dk0>ZP90B0V59@L:C:VKkC9EcF[
4CX0EIFZ]G7j?TL0fAWa@468TBj0Ik3Y5H:HB`da]SS7XQU2DiiUCN7l/ZLkNjaf
5/=HNa3o9/82VdDZKQiY_ENQBEDSkHB1[?7FePMHo1jSh7T>Td<EIWSi7VB0iI91
makQbgm/XociSo7ZB2dXnak=IQE>@nA7H;`;RZBX?`N0l3J6Z<dThlkD2h5j<0Ah
Sa;f[:d?dTT;RV7jT=>LO0^1IRc4/9@CXnS@g@FP>XNPGP_1VNDE4iAhBUFB/OHV
ma4e;P3:/BBl21AmRL4b90CHVA<070@1PMXkd=3d3F6/;`m2E3f9S=]_lhUV43@2
/m3Ukl:HE`/DDP:0?n1@>2@F3@N4@V5@^6@f7@n8A1n`Ao@::aB9_ml@9m?n;aV@
AJ9_jAaJ1B1naFD_n<_^FBEoAF;bNCc6B?bFAd@QX>UXZ5AIZiH:MC:TW4dY]m_>
BF@:L?b9e23Bin_V1A]o?HjVlfPH1PYBZ=H:mF[PeVTjFAKDf??mm?VI@b@fb8gF
kGNlGVm@Nig>mAO0@G0AV:BJfhNI`80H^FDn[?f>_QibalVhgVmi?Em2LA39L;AQ
>9d>@oXQ0cR?AV>`>[?Yk_n[Biok:Lk2EG_LKWMK_NKgOKoPL7QL?RLGSLOTLWUG
nKE1k_1jZQ@ZI7XU8:]BZaj_9l_bGC6?G73`FG?]k_Uk>n??Qn_Mj/AP/M7Xe<9Y
<:=_=abdfghg3<2Q2nYXiL2@:QD1;X_<0<Be<6/4ol8<>0;67lZR>WfNbF7/LI_V
hA974TfA;4LBhYRJ:YC5PFYIV2HBIWfUcD8ZNRg8fRJh7lNJh84fD6@=7lPB38DQ
b98/SB?94TbDl:E7lO9j@bW1kWU3:i_4OJL8^ZB27k;;I7a9c9`Zb41XW;/87g2k
E`0_Tb`79LhCRQ2B@L`[4<=;3`7o2H08m2b=<VOYk5HE1BUhH1TWhRYdW6L0:0N1
h3PL3aeaXO9mWZPAjBLO/cdbf21ZTOJBaU>ECE?E5DeEEMFEKEb;CdR:?cL]Yk<e
1K37bOCD86O/d`bOd;W`OQlDcD[_=W=L8ea0=J<9EmX>E>Tj@O>m[87?RB:/OR>/
POAi7J?`lSc:2gC<O1h30;P/2H:HbWZTZ>WlN9odDYZ=WnN1l8fO;G^m=;HBcJ>1
h9P^3H?Q64b0Vbk9TO;FfjOkg7]JJW8VOJ:]@O:DbaGSgAXfLo9N]Zg_4RYl7^OQ
lW`kjg>jlN5HA=SQY3JMWfF`b3Ci7RFD`Mif4`B15PN1@55/G9PEhOal5lGAK4NB
aB=NSAmDo:>1@cD2CZY;2XicV>`K3/Fak9/^bi/OMM86RimE6NQkbaWUjX4NakW_
7bB7mOnEX<kfC9=JTOK=EnI^5VZAi_Jd0HNZb1080@0]CH;Gc8eakWVN3D7O:Qn7
]<E<9aO2CVTIaU4XAi7S^>`lTjDQE7XfE>YOfAkgU`OKmag?MMggSRbkHQnFhV[3
=@N9jW]:VDcah=>`@T4HLJPQmNWaRKNKg]FFIIR6nM=fK8I`_VciGei>nS^ECmSM
H`ZUkILJMWh2b:h[<J?8l3fJ1[VffR<^jl2YG/@1P50>0T1Fa4]C:[XOCK6<U>KT
hED;`GPZkN4FaKcXR3<<P<W5kB4G^;>NlhQl3Gb2>?LRVMfCj7f;1KHS0Sd2bZVX
=T90B0SQW3=6B>8L0h@CPV1FlXcBIVN@YKG1^8dAhTA9RDP@T2CBF@MLDcPQ;gH;
:dRFTA^cDej`BN2gf;Z?8G5GGg15GR_GI:`9Vhb<aQ8^AOBHBMlR3BB?T8_0Y^Q9
1k:G=VA<EH[1C0`1N2P<`H`dP@0L1TJ0da[Zl96MlR[68BAGTU9>BTUI:A=RO9V:
<Vg]Y]R[9m14UTPSfU918PKdh5Za;U6MRCMXe4LNV@Iji3YB=I=W2j>JJAl:f=Hb
a0J=1o=gHbaTOXmDdScF2?lNPlVic=:K2XPB^SaBRVY=FJdefaa>9G9b:DD6IaD;
m=Q0/4h@45U@_]dDZ8=6`UlH5_a0dH<HES;=jD/CbAQ8E5TPKMU?UH7d[JNA/g>X
lPZA<NjneMZjAg4i`DhZ7D?XQA594gY^dETf@FL54XV@C9RJQGdn2YX`U<N@OA9B
fYY<9?6MI39DDZ9/[62Dm:>]KKhaD]m7W[TC7Z?=NaKE>ZUCc@fSE@jRE5Z<KV21
_jTe7B2YdfECdH=C7j>LLhiA<eG6gETPc:d/B@HbEBX588a>RRc>R3<ZR[ZG8^;4
F@]1ZE_NVV1I1PEnYEKnh4]dZ7Y`]<?@VYUOk0F1/51hhEBk1W99Jl4mQEJXTW5N
F@aH01NfCPU:QTS;b:/[9:?LNc;JAa_SA6@PdZ894GKZID=hLAU396HHPT4i5IdX
/^`9>i5f>f6/?KVgE^h[a@PbOn4DX4gYfXX]NgQ4GVWX7^_@]a7;58l2B4T8h_kZ
C`Y:WM<iKFD4UZh@VbdJ7VgOU^KAkJ/eO;L7h>i^TcDH[4:_7EbQiGKB@=M6>XEa
klGi_dkNgbeC1X>RYOjRe^;mdH^NFhk`maM]>224<7`C@WQ:06H/H0^QM2W50:>j
@BPdQZ3H0T1@31QS06<4/8XC0Y;];>6aSi5a?2Q5@5H;8H0]1H2b7d?PN1<Hk9F:
DDX[@/QH2l5T:PEQ2R34490B8TaR376F3P6h>QT336:=`J8d`Y1:2>9XCXT0KPn1
/0T0`5a^3E?f?`NPfQZ362`5`;XH@bQ`3L6/?PQQ22?6n>4KSXKRH5cmWo@6PM1:
m;N?DL8f1/PA0H0`N;ECA3T0`0d1hb1KRk6Z<@I01S5R8QZ:XF@/0E0S1<<TGP`E
iSf0f1<28jQcSP76>LL`003PJ7I<`LhhQa04<F;lH0`=GS`0@0P3`k1dSl7F>0LP
235jE5h>DM@kPD0R1B<DFh]Qo3V6b5<8@=PKPo1n>0N8n0c1]3Z7X>8LQoSb7>3X
4@5QK2k5l>`Z`:`D113d7DA;6h^/]7f_RnnPn0L1h5`>JYEK>2G4H8h?jhdK3d7j
?P:HA`TS75T;LOhlAk0T0b1/KhjAb;n7P>LM0caO322`4T9P50508ZX=/J`fQ/P3
0>28Mdc9JPS161TLPiAbSE6^><0X0P>Si<V?`c@5`8P>7T?0NK9@SQ12@<XG@^69
3S2V405h_ASS>7FADB>G101gg@?4LP?@?PD6:<`J5c0RQ22j:XDP^cE_W<>AWOo1
>lMikeg]g2Ub/3m529HC6=0]:KHNB`:0A0S3<5^;`OhkQiPL0V1@L`l1eXf4j9@B
XE`S1:7/>LM@6MEJe7<JP4@60H1m3X8ddXRP/1U2h?FWK8@HPT1l7`>`SPlR04<6
P=PJHmTJ7f4H8HBAO2h;F?XM0EPR0e5N;PG]c192K4l7o/@oafSQ5P9<A81P5P>4
Z:DF@6`<0aDHJk?QD80MloIngmgkfI6=Fh:lD`YfR0:71ahZP:P?PQ5j5B5L7n7N
7V140h0h767J7@7NBN0d0R0T6>5`5f7N767:0J0>0:5j665^7J7R7L2/2@2n625Z
6F60]F7P7nJbV:DZ2D1l2X645h6V646F6P7VKC1@@bMZ2B2<2H6B6868=P7D2N1l
1T626@6H^H4`52583j3^3XHT7J4l4:3h4R4^4^686P6d7J7FPLLJF<88E6IPoQ35
37393:B4=^Ij7T7V2B282800ed1l2820fD00322T2Z4J3l420:<F3Jk47D7V7L:f
3N0P02082/2F2J0Z0N0H2@2D1j7<7<74`V0T0<020Z00@V0>0D024:4:42L`7^@V
0P04000T080:0C4b004F4B4D6RkD0F0D0N2j2^2^6Y0d0h0N082V2/2d5T5n6>1P
1b1f1<1:127h7:6j382N2C5F000:0H<F0P1X1R247JIBU/<JK]333=6m6o7172@D
8h@Z7Z7^AXQLDj787D7<:X7`7TVH7`8jEf[b8fO@<P7XAX7VF=7`GXAb5Z5X5O5L
4dCXF87Z7J7D6n34342l5T5T5`4X4T5:Ll9X7@7>762n3638Hd?HI6c@=VV@_F8d
84Wh7X746l3:A<kl7Z=@9`3n3l4H6b767@Lb=FTJC[759c9e9g9dBdTbC<8VNV9`
:ZC8QC:0Uf7Z<N<N9NAbDbQBLJ7V3fg^0@0D0^4h4l5F5n5d5X3H3:2d/N5F3D3J
3T0H0J0j56545P5/5P5P3D3<345X5b5hMP?6MThN9H:`^K1@PL7n6^6F6D0D<F3h
3h3dgP644H4D4Z34383PDnJV/JVBFY9i<W<Y<ZoJSZ<Q:6I6Djkl=_7C:39]7/=R
RfX58lA/V@7f7X^X6BM@4b4j4^4Xcd6TAh8^5n626J4H4H4/4n4d4d706n6fNDLJ
KJ<<El?K:LGZ8VGa:FEl706/6X504n4f4@4B4B5n5j6<G/JV7RBfARDc<U<]?3?5
?6cl]];hTn]nIQ?<VL8boFBnQN;H_nI3?W>:VhVJK`R4=HKU<fZN<:G/G`Pa?O?1
?9@8BF8200d1000300000@5Z00010@0300000@4900010P0300000`00bSh10`03
00000@0500011P0300000@0200014@0400002@00bT@15@0300000@0300015P04
00000@0001h15`0400002@00bVP16P0500000@00bX`16`0500000@00bY@17003
00000@010001:00300000@020000000000P02008000020001Sl001R=000fU`00
D3/006Y]00290`00XM800;ea0006=`004Th001h:000IY0006S8001jF000Hc`00
6il000`[00[lP0009a002_b0000W40070:h0NP0700400@0300<0100000d0300@
0FX1JP5Z0FX0:01h07l@DGEYHf]DJFeUZR1QKV@PH@00:02406PGE4U6AR0XC5YG
:B1TIF=_KG1bIG=cKg80:02@05POHG9U86iUIFAUI21dKb1cIFDPM6QYLb1`JF=d
MG9U;P000?l\>"], "Graphics",
  ImageSize->{362, 265},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell["\<\
The force vector on the rocker arm B, arm C, rock crate D and \
Porjectile A are given by (Fad is the air drag on the projecile):\
\>", "Text",\

  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Fad\  = \ \(-\ 
          Cd\)\ Aa\ \((\(x'\)[t]^2\ Sign[\(x'\)[t]]\ n[
                1]\  + \ \(y'\)[t]^2\ Sign[\(y'\)[t]]\ n[
                2])\)\ \), "\[IndentingNewLine]", 
    \(Fa = \(-\((ma + mh)\)\)\ g\ n[2] - \[Mu]\ Na\ Sign[\(x'\)[t]] 
          n[1]\  + \ Na\ n[2]\  - S\ a[1]\  + \ Fad\ \), "\n", 
    \(Fb = \(-mb\)\ g\ n[2] + B1\ n[1] + B2\ n[2] - C1\ c[1] + C2\ c[2] + 
        S\ a[1]\), "\n", 
    \(Fc = 
      C1\ c[1] - C2\ c[2] - mc\ g\ n[2]\  - D1\ d[1]\  + \ D2\ d[2]\), "\n", 
    \(Fd = D1\ d[1]\  - \ D2\ d[2] - md\ g\ n[2]\)}], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(-Aa\), " ", "Cd", " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \(\(n\&^\)\_1\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \(\(n\&^\)\_2\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
        ")"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(\(-S\)\ \(a\&^\)\_1\), "-", 
      RowBox[{"Na", " ", "\[Mu]", " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], 
        " ", \(\(n\&^\)\_1\)}], "+", \(g\ \((\(-ma\) - mh)\)\ \(n\&^\)\_2\), 
      "+", \(Na\ \(n\&^\)\_2\), "-", 
      RowBox[{"Aa", " ", "Cd", " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              RowBox[{"Sign", "[", 
                RowBox[{
                  SuperscriptBox["x", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "]"}], 
              " ", \(\(n\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["x", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
              RowBox[{"Sign", "[", 
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "]"}], 
              " ", \(\(n\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
          ")"}]}]}]], "Output"],

Cell[BoxData[
    \(S\ \(a\&^\)\_1 - C1\ \(c\&^\)\_1 + C2\ \(c\&^\)\_2 + B1\ \(n\&^\)\_1 + 
      B2\ \(n\&^\)\_2 - g\ mb\ \(n\&^\)\_2\)], "Output"],

Cell[BoxData[
    \(C1\ \(c\&^\)\_1 - C2\ \(c\&^\)\_2 - D1\ \(d\&^\)\_1 + D2\ \(d\&^\)\_2 - 
      g\ mc\ \(n\&^\)\_2\)], "Output"],

Cell[BoxData[
    \(D1\ \(d\&^\)\_1 - D2\ \(d\&^\)\_2 - g\ md\ \(n\&^\)\_2\)], "Output"]
}, Open  ]],

Cell["\<\
The moments about the CG for both B, C, and D are, including \
viscous friction (dB, dC, dD) at the pins. \
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Mb = \(-dB\)\ \(q2'\)[t]\ b[3] + dC\ \(q3'\)[t]\ c[3] + 
          d1\ b[1]\[Cross]\((B1\ n[1]\  + \ B2\ n[2])\) - \((l1\  - \ 
                d1)\)\ b[1]\[Cross]\((\(-\ C1\)\ c[1] + C2\ c[2])\) + 
          l2\ b[1]\[Cross]S\ a[1] // distributeScalars\), "\n", 
    \(Mc = \(\(\(-dC\)\ \(q3'\)[t]\ c[3] + \ dD\ \(q4'\)[t]\ d[3] + 
          d2\ c[2]\[Cross]\((C1\ c[1] - C2\ c[2])\)\  - \ \((l4\  - \ d2)\) 
            c[2]\ \[Cross]\((\(-D1\)\ d[1]\  + \ 
                  D2\ d[2])\)\)\(//\)\(distributeScalars\)\(\ \)\)\), "\
\[IndentingNewLine]", 
    \(Md = \(-dD\)\ \(q4'\)[t]\ d[3] - 
        d3\ d[2]\[Cross]\((D1\ d[1]\  - \ D2\ d[2])\)\)}], "Input"],

Cell[BoxData[
    RowBox[{\(l2\ S\ \(b\&^\)\_1\[Cross]\(a\&^\)\_1\), 
      "-", \(C1\ d1\ \(b\&^\)\_1\[Cross]\(c\&^\)\_1\), 
      "+", \(C1\ l1\ \(b\&^\)\_1\[Cross]\(c\&^\)\_1\), 
      "+", \(C2\ d1\ \(b\&^\)\_1\[Cross]\(c\&^\)\_2\), 
      "-", \(C2\ l1\ \(b\&^\)\_1\[Cross]\(c\&^\)\_2\), 
      "+", \(B1\ d1\ \(b\&^\)\_1\[Cross]\(n\&^\)\_1\), 
      "+", \(B2\ d1\ \(b\&^\)\_1\[Cross]\(n\&^\)\_2\), "-", 
      RowBox[{"dB", " ", \(\(b\&^\)\_3\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dC", " ", \(\(c\&^\)\_3\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(\(-D1\)\ d2\ \(c\&^\)\_2\[Cross]\(d\&^\)\_1\), 
      "+", \(D1\ l4\ \(c\&^\)\_2\[Cross]\(d\&^\)\_1\), 
      "+", \(d2\ D2\ \(c\&^\)\_2\[Cross]\(d\&^\)\_2\), 
      "-", \(D2\ l4\ \(c\&^\)\_2\[Cross]\(d\&^\)\_2\), 
      "-", \(C1\ d2\ \(c\&^\)\_3\), "-", 
      RowBox[{"dC", " ", \(\(c\&^\)\_3\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dD", " ", \(\(d\&^\)\_3\), " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(D1\ d3\ \(d\&^\)\_3\), "-", 
      RowBox[{"dD", " ", \(\(d\&^\)\_3\), " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[TextData[
"The full inertia Dyadics about the CG for each body (the projectile is model \
as a point mass) are given by:"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Ibg = 
      B11\ bb[1, 1] + B12\ bb[1, 2] + B13\ bb[1, 3] + B21\ bb[2, 1] + 
        B22\ bb[2, 2] + B23\ bb[2, 3] + B31\ bb[3, 1] + B32\ bb[3, 2] + 
        B33\ bb[3, 3]\), "\n", 
    \(Icg = 
      C11\ cc[1, 1] + C12\ cc[1, 2] + C13\ cc[1, 3] + C21\ cc[2, 1] + 
        C22\ cc[2, 2] + C23\ cc[2, 3] + C31\ cc[3, 1] + C32\ cc[3, 2] + 
        C33\ cc[3, 3]\), "\[IndentingNewLine]", 
    \(Idg = 
      D11\ dd[1, 1] + D12\ dd[1, 2] + D13\ dd[1, 3] + D21\ dd[2, 1] + 
        D22\ dd[2, 2] + D23\ dd[2, 3] + D31\ dd[3, 1] + D32\ dd[3, 2] + 
        D33\ dd[3, 3]\), "\n", 
    \(\)}], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
      RowBox[{"B11", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_1\[InvisibleSpace]\(b\&^\)\_1\),
            SequenceForm[ 
              unitVector[ B, b, 1], 
              unitVector[ B, b, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B12", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_1\[InvisibleSpace]\(b\&^\)\_2\),
            SequenceForm[ 
              unitVector[ B, b, 1], 
              unitVector[ B, b, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B13", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_1\[InvisibleSpace]\(b\&^\)\_3\),
            SequenceForm[ 
              unitVector[ B, b, 1], 
              unitVector[ B, b, 3]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B21", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_2\[InvisibleSpace]\(b\&^\)\_1\),
            SequenceForm[ 
              unitVector[ B, b, 2], 
              unitVector[ B, b, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B22", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_2\[InvisibleSpace]\(b\&^\)\_2\),
            SequenceForm[ 
              unitVector[ B, b, 2], 
              unitVector[ B, b, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B23", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_2\[InvisibleSpace]\(b\&^\)\_3\),
            SequenceForm[ 
              unitVector[ B, b, 2], 
              unitVector[ B, b, 3]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B31", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_3\[InvisibleSpace]\(b\&^\)\_1\),
            SequenceForm[ 
              unitVector[ B, b, 3], 
              unitVector[ B, b, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B32", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_3\[InvisibleSpace]\(b\&^\)\_2\),
            SequenceForm[ 
              unitVector[ B, b, 3], 
              unitVector[ B, b, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"B33", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(b\&^\)\_3\[InvisibleSpace]\(b\&^\)\_3\),
            SequenceForm[ 
              unitVector[ B, b, 3], 
              unitVector[ B, b, 3]],
            Editable->False], ")"}]}]}]], "Output"],

Cell[BoxData[
    RowBox[{
      RowBox[{"C11", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_1\[InvisibleSpace]\(c\&^\)\_1\),
            SequenceForm[ 
              unitVector[ C, c, 1], 
              unitVector[ C, c, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C12", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_1\[InvisibleSpace]\(c\&^\)\_2\),
            SequenceForm[ 
              unitVector[ C, c, 1], 
              unitVector[ C, c, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C13", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_1\[InvisibleSpace]\(c\&^\)\_3\),
            SequenceForm[ 
              unitVector[ C, c, 1], 
              unitVector[ C, c, 3]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C21", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_2\[InvisibleSpace]\(c\&^\)\_1\),
            SequenceForm[ 
              unitVector[ C, c, 2], 
              unitVector[ C, c, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C22", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_2\[InvisibleSpace]\(c\&^\)\_2\),
            SequenceForm[ 
              unitVector[ C, c, 2], 
              unitVector[ C, c, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C23", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_2\[InvisibleSpace]\(c\&^\)\_3\),
            SequenceForm[ 
              unitVector[ C, c, 2], 
              unitVector[ C, c, 3]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C31", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_3\[InvisibleSpace]\(c\&^\)\_1\),
            SequenceForm[ 
              unitVector[ C, c, 3], 
              unitVector[ C, c, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C32", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_3\[InvisibleSpace]\(c\&^\)\_2\),
            SequenceForm[ 
              unitVector[ C, c, 3], 
              unitVector[ C, c, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"C33", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(c\&^\)\_3\[InvisibleSpace]\(c\&^\)\_3\),
            SequenceForm[ 
              unitVector[ C, c, 3], 
              unitVector[ C, c, 3]],
            Editable->False], ")"}]}]}]], "Output"],

Cell[BoxData[
    RowBox[{
      RowBox[{"D11", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_1\[InvisibleSpace]\(d\&^\)\_1\),
            SequenceForm[ 
              unitVector[ D, d, 1], 
              unitVector[ D, d, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D12", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_1\[InvisibleSpace]\(d\&^\)\_2\),
            SequenceForm[ 
              unitVector[ D, d, 1], 
              unitVector[ D, d, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D13", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_1\[InvisibleSpace]\(d\&^\)\_3\),
            SequenceForm[ 
              unitVector[ D, d, 1], 
              unitVector[ D, d, 3]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D21", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_2\[InvisibleSpace]\(d\&^\)\_1\),
            SequenceForm[ 
              unitVector[ D, d, 2], 
              unitVector[ D, d, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D22", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_2\[InvisibleSpace]\(d\&^\)\_2\),
            SequenceForm[ 
              unitVector[ D, d, 2], 
              unitVector[ D, d, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D23", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_2\[InvisibleSpace]\(d\&^\)\_3\),
            SequenceForm[ 
              unitVector[ D, d, 2], 
              unitVector[ D, d, 3]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D31", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_3\[InvisibleSpace]\(d\&^\)\_1\),
            SequenceForm[ 
              unitVector[ D, d, 3], 
              unitVector[ D, d, 1]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D32", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_3\[InvisibleSpace]\(d\&^\)\_2\),
            SequenceForm[ 
              unitVector[ D, d, 3], 
              unitVector[ D, d, 2]],
            Editable->False], ")"}]}], "+", 
      RowBox[{"D33", " ", 
        RowBox[{"(", 
          InterpretationBox[\(\(d\&^\)\_3\[InvisibleSpace]\(d\&^\)\_3\),
            SequenceForm[ 
              unitVector[ D, d, 3], 
              unitVector[ D, d, 3]],
            Editable->False], ")"}]}]}]], "Output"]
}, Open  ]],

Cell[TextData["Making the I's constants."], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(SetAttributes[{B11, B12, B13, B21, B22, B23, B31, B32, B33, C11, C12, 
        C13, C21, C22, C23, C31, C32, C33, D11, D12, D13, D21, D22, D23, D31, 
        D32, D33, d1, d2, d3, l1, l2, l3, l4}, Constant]\)], "Input",
  AspectRatioFixed->True],

Cell[TextData["The angular velocities of frame B, C, and T are:"], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{"NwA", "=", 
      RowBox[{\(omega[N, A]\), "=", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
          " ", \(a[3]\)}]}]}], "\n", 
    RowBox[{"NwB", "=", 
      RowBox[{\(omega[N, B]\), "=", 
        RowBox[{
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], 
          " ", \(b[3]\)}]}]}], "\n", 
    RowBox[{"NwC", "=", 
      RowBox[{\(omega[N, C]\), "=", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
          " ", \(c[3]\)}]}]}], "\n", 
    RowBox[{"NwD", "=", 
      RowBox[{\(omega[N, D]\), "=", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{\(\(q1'\)[t]\), "+", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
          " ", \(d[3]\)}]}]}]}], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(\(a\&^\)\_3\), " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "+", 
          RowBox[{
            SuperscriptBox["q4", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(\(b\&^\)\_3\), " ", 
      RowBox[{
        SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(\(c\&^\)\_3\), " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "+", 
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\(\(d\&^\)\_3\), " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "+", 
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "+", 
          RowBox[{
            SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell["The angular momentum is given by Hg = Ig . NwB (C).", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Hbg = Ibg . NwB\), "\n", 
    \(Hcg = Icg . NwC\), "\[IndentingNewLine]", 
    \(Hdg = Idg . NwD\)}], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\((B13\ \(b\&^\)\_1 + B23\ \(b\&^\)\_2 + B33\ \(b\&^\)\_3)\), " ",
       
      RowBox[{
        SuperscriptBox["q1", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\((C13\ \(c\&^\)\_1 + C23\ \(c\&^\)\_2 + C33\ \(c\&^\)\_3)\), " ",
       
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "+", 
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output"],

Cell[BoxData[
    RowBox[{\((D13\ \(d\&^\)\_1 + D23\ \(d\&^\)\_2 + D33\ \(d\&^\)\_3)\), " ",
       
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "+", 
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "+", 
          RowBox[{
            SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell["\<\
The equation of motion can be derived from Mo - DvDt[N,Ho]==0 and \
F- ma==0 for each body; we will drop the == 0 until we get to the solution.

First we generate the rotational equations for the equations of motion\
\>", \
"Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq1 = distributeScalars[\((Mb - DvDt[N, Hbg])\) . b[3]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(l2\ S\ \(a\&^\)\_1 . \(b\&^\)\_2\), 
      "-", \(C1\ d1\ \(b\&^\)\_2 . \(c\&^\)\_1\), 
      "+", \(C1\ l1\ \(b\&^\)\_2 . \(c\&^\)\_1\), 
      "+", \(C2\ d1\ \(b\&^\)\_2 . \(c\&^\)\_2\), 
      "-", \(C2\ l1\ \(b\&^\)\_2 . \(c\&^\)\_2\), 
      "+", \(B1\ d1\ \(b\&^\)\_2 . \(n\&^\)\_1\), 
      "+", \(B2\ d1\ \(b\&^\)\_2 . \(n\&^\)\_2\), "-", 
      RowBox[{"dB", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"B33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq2 = distributeScalars[\((Mc - DvDt[N, Hcg])\) . c[3]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(\(-C1\)\ d2\), "+", \(D1\ d2\ \(c\&^\)\_1 . \(d\&^\)\_1\), 
      "-", \(D1\ l4\ \(c\&^\)\_1 . \(d\&^\)\_1\), 
      "-", \(d2\ D2\ \(c\&^\)\_1 . \(d\&^\)\_2\), 
      "+", \(D2\ l4\ \(c\&^\)\_1 . \(d\&^\)\_2\), "-", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq3 = distributeScalars[\((Md - DvDt[N, Hdg])\) . d[3]]\)], "Input"],

Cell[BoxData[
    RowBox[{\(D1\ d3\), "-", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell["\<\
Next we generate the translational equations to solve for the \
reactions and normal force.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq4 = 
      distributeScalars[\((Fa - \((ma + mh)\)\ DvDt[N, 
                  DvDt[N, x[t]\ n[1] + y[t]\ n[2]]])\) . a[1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(-S\), "-", \(g\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
      "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
      "+", \(Na\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
      RowBox[{"Na", " ", "\[Mu]", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["y", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["y", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq5 = 
      distributeScalars[\((Fa - \((ma\  + \ mh)\)\ DvDt[N, 
                  DvDt[N, x[t]\ n[1] + y[t]\ n[2]]])\) . a[2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
      "-", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
      "+", \(Na\ \(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
      RowBox[{"Na", " ", "\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["y", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["y", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq6 = 
      distributeScalars[\((Fb - mb\ DvDt[N, DvDt[N, \(-\ d1\)\ b[1]]])\) . 
          n[1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
    "B1", "+", \(S\ \(a\&^\)\_1 . \(n\&^\)\_1\), 
      "-", \(C1\ \(c\&^\)\_1 . \(n\&^\)\_1\), 
      "+", \(C2\ \(c\&^\)\_2 . \(n\&^\)\_1\), "-", 
      RowBox[{"d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_1\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq7 = 
      distributeScalars[\((Fb - mb\ DvDt[N, DvDt[N, \(-\ d1\)\ b[1]]])\) . 
          n[2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
    "B2", "-", \(g\ mb\), "+", \(S\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
      "-", \(C1\ \(c\&^\)\_1 . \(n\&^\)\_2\), 
      "+", \(C2\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
      RowBox[{"d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_2\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq8 = 
      distributeScalars[\((Fc - 
              mc\ DvDt[N, DvDt[N, \(-l1\)\ b[1] - d2\ c[2]]])\) . 
          c[1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
    "C1", "-", \(D1\ \(c\&^\)\_1 . \(d\&^\)\_1\), 
      "+", \(D2\ \(c\&^\)\_1 . \(d\&^\)\_2\), 
      "-", \(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "-", 
      RowBox[{"l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq9 = 
      distributeScalars[\((Fc - 
              mc\ DvDt[N, DvDt[N, \(-l1\)\ b[1] - d2\ c[2]]])\) . 
          c[2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(-C2\), "-", \(D1\ \(c\&^\)\_2 . \(d\&^\)\_1\), 
      "+", \(D2\ \(c\&^\)\_2 . \(d\&^\)\_2\), 
      "-", \(g\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
      RowBox[{"l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"d2", " ", "mc", " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{"l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq10 = 
      distributeScalars[\((Fd - 
              md\ DvDt[N, 
                  DvDt[N, \(-l1\)\ b[1] - l4\ c[2]\  - d3\ d[2]]])\) . 
          d[1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{"D1", "-", \(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "-", 
      RowBox[{"l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{"d3", " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eq11 = 
      distributeScalars[\((Fd - 
              md\ DvDt[N, 
                  DvDt[N, \(-l1\)\ b[1] - l4\ c[2]\  - d3\ d[2]]])\) . 
          d[2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(-D2\), "-", \(g\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
      RowBox[{"l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{"d3", " ", "md", " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "+", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{"l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell["\<\
Now solve for the reaction forces at the pins and eliminate them \
for the three angular momentum equation (eq1,eq2,eq3).   Also need to \
eliminate the sling tension S and normal force Na.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(solS = First[Solve[eq4 == 0, S]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"S", "\[Rule]", 
        RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
          "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
          "+", \(Na\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
          RowBox[{
          "Na", " ", "\[Mu]", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solN = First[Solve[eq5 == 0, Na]]\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solN\)\" is similar to \
existing symbol \"\!\(solS\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"Na", "\[Rule]", 
        RowBox[{
          FractionBox["1", 
            RowBox[{\(\(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
              RowBox[{"\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}]}]}]], 
          RowBox[{"(", 
            
            RowBox[{\(g\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
              "+", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "+", 
              RowBox[{
              "Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell["When moving after lifting off the floor the normal is zero.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(solNs = {Na \[Rule] 0}\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solNs\)\" is similar to \
existing symbol \"\!\(solN\)\"."\)], "Message"],

Cell[BoxData[
    \({Na \[Rule] 0}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solB = First[Solve[{eq6 == 0, eq7 == 0}, {B1, B2}]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solB\)\" is similar to \
existing symbols \!\({solN, solS}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"B1", "\[Rule]", 
          
          RowBox[{\(\(-S\)\ \(a\&^\)\_1 . \(n\&^\)\_1\), 
            "+", \(C1\ \(c\&^\)\_1 . \(n\&^\)\_1\), 
            "-", \(C2\ \(c\&^\)\_2 . \(n\&^\)\_1\), "+", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
        RowBox[{"B2", "\[Rule]", 
          
          RowBox[{\(g\ mb\), "-", \(S\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
            "+", \(C1\ \(c\&^\)\_1 . \(n\&^\)\_2\), 
            "-", \(C2\ \(c\&^\)\_2 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solC = First[Solve[{eq8 == 0, eq9 == 0}, {C1, C2}]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solC\)\" is similar to \
existing symbols \!\({solB, solN, solS}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"C1", "\[Rule]", 
          
          RowBox[{\(D1\ \(c\&^\)\_1 . \(d\&^\)\_1\), 
            "-", \(D2\ \(c\&^\)\_1 . \(d\&^\)\_2\), 
            "+", \(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
        RowBox[{"C2", "\[Rule]", 
          
          RowBox[{\(\(-D1\)\ \(c\&^\)\_2 . \(d\&^\)\_1\), 
            "+", \(D2\ \(c\&^\)\_2 . \(d\&^\)\_2\), 
            "-", \(g\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"d2", " ", "mc", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solD = First[Solve[{eq10 == 0, eq11 == 0}, {D1, D2}]]\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solD\)\" is similar to \
existing symbols \!\({solB, solC, solN, solS}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"D1", "\[Rule]", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
        RowBox[{"D2", "\[Rule]", 
          RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "-", 
            RowBox[{"d3", " ", "md", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}]}], 
      "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Extra Equations: Kinematic Constraints", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Now we look at the constraints to incorporate them for the entire \
motion.\
\>", "Text"],

Cell[GraphicsData["PICT", "\<\
000000000A<1M@0A0_l<0?on0000B00004P0000000014`5e0000000N00402P00
00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
00400000000000000000040000000000000000000000@00000014`5e00030000
00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
M6lPLfEU87AXJG<PL6USM7EbIBh0003o\>"], "Graphics",
  ImageSize->{373, 275},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(vloop1\  = \ 
      H\ n[2]\  + \ l2\ b[1]\  + \ l3\ a[1]\  - \ y[t]\ n[2]\  - \ 
        x[t]\ n[1]\)], "Input"],

Cell[BoxData[
    \(l3\ \(a\&^\)\_1 + l2\ \(b\&^\)\_1 + 
      H\ \(n\&^\)\_2 - \(n\&^\)\_1\ x[t] - \(n\&^\)\_2\ y[t]\)], "Output"]
}, Open  ]],

Cell["Transformations that remain.", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(transform[x_] := 
      x //. {d[1] \[Rule] Cos[q3[t]]\ c[1] + Sin[q3[t]]\ c[2], 
          d[2] \[Rule] \(-Sin[q3[t]]\)\ c[1] + Cos[q3[t]]\ c[2], 
          c[1] \[Rule] Cos[q2[t]]\ b[1] + Sin[q2[t]]\ b[2], 
          c[2] \[Rule] \(-Sin[q2[t]]\)\ b[1] + Cos[q2[t]]\ b[2], 
          a[1] \[Rule] Cos[q4[t]]\ b[1] + Sin[q4[t]]\ b[2], 
          a[2] \[Rule] \(-Sin[q4[t]]\)\ b[1] + Cos[q4[t]]\ b[2], 
          b[1] \[Rule] \(-Cos[q1[t]]\)\ n[1] + Sin[q1[t]]\ n[2], 
          b[2] \[Rule] Sin[q1[t]]\ n[1] + Cos[q1[t]]\ n[2]}\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(Xpos = vloop1 . n[1] // transform\)], "Input"],

Cell[BoxData[
    \(\(-l2\)\ Cos[q1[t]] + 
      l3\ \((\(-Cos[q1[t]]\)\ Cos[q4[t]] + Sin[q1[t]]\ Sin[q4[t]])\) - 
      x[t]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Ypos\  = \ vloop1 . n[2] // transform\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Ypos\)\" is similar to \
existing symbol \"\!\(Xpos\)\"."\)], "Message"],

Cell[BoxData[
    \(H + l2\ Sin[q1[t]] + 
      l3\ \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\) - 
      y[t]\)], "Output"]
}, Open  ]],

Cell["\<\
Here are the constrained variables while dragging.  Notice that \
y[t] will be a constant during dragging.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(solq4x = 
      Solve[{Xpos \[Equal] 0, Ypos \[Equal] 0}, {q4[t], x[t]}] // 
        Simplify\)], "Input"],

Cell[BoxData[
    \(Solve::"ifun" \(\(:\)\(\ \)\) 
      "Inverse functions are being used by \!\(Solve\), so some solutions may \
not be found."\)], "Message"],

Cell[BoxData[
    \({{x[t] \[Rule] \(-l2\)\ Cos[q1[t]] - 
            1\/2\ \@\(\(-2\)\ \((2\ H\^2 + l2\^2 - 2\ l3\^2 - l2\^2\ Cos[2\ \
q1[t]] + 4\ H\ l2\ Sin[q1[t]])\) + 8\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 4\ \
y[t]\^2\), 
        q4[t] \[Rule] \(-ArcCos[\(1\/l3\)\((\(-H\)\ Sin[q1[t]] - 
                  l2\ Sin[q1[t]]\^2 + 
                  Sin[q1[t]]\ y[
                      t] + \(Cos[q1[t]]\ \@\(\(-2\)\ H\^2 - l2\^2 + 2\ l3\^2 \
+ l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 4\ \((H + l2\ Sin[q1[t]])\)\ \
y[t] - 2\ y[t]\^2\)\)\/\@2)\)]\)}, {x[t] \[Rule] \(-l2\)\ Cos[q1[t]] - 
            1\/2\ \@\(\(-2\)\ \((2\ H\^2 + l2\^2 - 2\ l3\^2 - l2\^2\ Cos[2\ \
q1[t]] + 4\ H\ l2\ Sin[q1[t]])\) + 8\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 4\ \
y[t]\^2\), 
        q4[t] \[Rule] 
          ArcCos[\(1\/l3\)\((\(-H\)\ Sin[q1[t]] - l2\ Sin[q1[t]]\^2 + 
                Sin[q1[t]]\ y[
                    t] + \(Cos[q1[t]]\ \@\(\(-2\)\ H\^2 - l2\^2 + 2\ l3\^2 + \
l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 4\ \((H + l2\ Sin[q1[t]])\)\ \
y[t] - 2\ y[t]\^2\)\)\/\@2)\)]}, {x[
            t] \[Rule] \(-l2\)\ Cos[
                q1[t]] + \@\(\(-H\^2\) - l2\^2\/2 + l3\^2 + 1\/2\ l2\^2\ \
Cos[2\ q1[t]] - 2\ H\ l2\ Sin[q1[t]] + 2\ \((H + l2\ Sin[q1[t]])\)\ y[t] - \
y[t]\^2\), 
        q4[t] \[Rule] \(-ArcCos[\(-\(\(1\/l3\)\((H\ Sin[q1[t]] + 
                    l2\ Sin[q1[t]]\^2 - 
                    Sin[q1[t]]\ y[
                        t] + \(Cos[q1[t]]\ \@\(\(-2\)\ H\^2 - l2\^2 + 2\ \
l3\^2 + l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 4\ \((H + l2\ \
Sin[q1[t]])\)\ y[t] - 2\ y[t]\^2\)\)\/\@2)\)\)\)]\)}, {x[
            t] \[Rule] \(-l2\)\ Cos[
                q1[t]] + \@\(\(-H\^2\) - l2\^2\/2 + l3\^2 + 1\/2\ l2\^2\ \
Cos[2\ q1[t]] - 2\ H\ l2\ Sin[q1[t]] + 2\ \((H + l2\ Sin[q1[t]])\)\ y[t] - \
y[t]\^2\), 
        q4[t] \[Rule] 
          ArcCos[\(-\(\(1\/l3\)\((H\ Sin[q1[t]] + l2\ Sin[q1[t]]\^2 - 
                  Sin[q1[t]]\ y[
                      t] + \(Cos[q1[t]]\ \@\(\(-2\)\ H\^2 - l2\^2 + 2\ l3\^2 \
+ l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 4\ \((H + l2\ Sin[q1[t]])\)\ \
y[t] - 2\ y[t]\^2\)\)\/\@2)\)\)\)]}}\)], "Output"]
}, Open  ]],

Cell["\<\
Next we generate the velocity loop for use as a kinematic \
differential equation\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Xvel = D[Xpos, t]\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Xvel\)\" is similar to \
existing symbols \!\({Pvel, vel}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\(Cos[q4[t]]\), " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q4[t]]\), " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{
        SuperscriptBox["x", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Yvel = D[Ypos, t]\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Yvel\)\" is similar to \
existing symbols \!\({Pvel, vel, Xvel}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\(Cos[q1[t]]\), " ", \(Cos[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(Sin[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Cos[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(Sin[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{
        SuperscriptBox["y", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solDq4x = 
      Solve[{Xvel \[Equal] 0, Yvel \[Equal] 0}, {\(q4'\)[t], \(x'\)[t]}] // 
        Simplify\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solDq4x\)\" is similar \
to existing symbol \"\!\(solq4x\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{
            RowBox[{
              SuperscriptBox["x", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
            RowBox[{
              
              RowBox[{\(-l2\), " ", \(Sec[q1[t] + q4[t]]\), 
                " ", \(Sin[q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{\(Tan[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
          RowBox[{
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
            FractionBox[
              RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
                RowBox[{"(", 
                  RowBox[{
                    
                    RowBox[{\(-\((l2\ Cos[q1[t]] + 
                            l3\ Cos[q1[t] + q4[t]])\)\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], 
              "l3"]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Xacc = D[Xvel, t]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\(Cos[q1[t]]\), " ", \(Cos[q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{\(Sin[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", \(Cos[q1[t]]\), " ", \(Cos[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"2", " ", \(Sin[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Cos[q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{\(Sin[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{\(Cos[q4[t]]\), " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q4[t]]\), " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{
        SuperscriptBox["x", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Yacc = D[Yvel, t]\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Yacc\)\" is similar to \
existing symbol \"\!\(Xacc\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-l2\), " ", \(Sin[q1[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\(-Cos[q4[t]]\), " ", \(Sin[q1[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", \(Cos[q4[t]]\), " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"2", " ", \(Cos[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(Cos[q4[t]]\), " ", \(Sin[q1[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Cos[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(Sin[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t]]\), " ", \(Cos[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(Sin[q1[t]]\), " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{
        SuperscriptBox["y", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solDDq4x = \(Solve[{Xacc \[Equal] 0, 
              Yacc \[Equal] 0}, {\(q4''\)[t], \(x''\)[t]}] // Simplify\) // 
        First\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solDDq4x\)\" is similar \
to existing symbol \"\!\(solDq4x\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{
            SuperscriptBox["x", "\[Prime]\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
          RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"2", " ", "l3", " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{"l2", " ", \(Sin[q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{\(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], 
              ")"}]}]}], ",", 
        RowBox[{
          RowBox[{
            SuperscriptBox["q4", "\[Prime]\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
          RowBox[{\(1\/l3\), 
            RowBox[{"(", 
              RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
                RowBox[{"(", 
                  RowBox[{
                    
                    RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), 
                      " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "+", 
                    RowBox[{
                    "2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q4", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], 
              ")"}]}]}]}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
Now we re-solve the generic vector loop equation for machine \
motion, q4[t] is now not constrained, but we have excess coordinates \
x[t],y[t].\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(solxy = \(Solve[{Xpos \[Equal] 0, Ypos \[Equal] 0}, {x[t], y[t]}] // 
          Simplify\) // First\)], "Input"],

Cell[BoxData[
    \({x[t] \[Rule] \(-l2\)\ Cos[q1[t]] - l3\ Cos[q1[t] + q4[t]], 
      y[t] \[Rule] H + l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]]}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solDxy = \(Solve[{Xvel \[Equal] 0, 
              Yvel \[Equal] 0}, {\(x'\)[t], \(y'\)[t]}] // Simplify\) // 
        First\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solDxy\)\" is similar \
to existing symbol \"\!\(solxy\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
          RowBox[{
            RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
        RowBox[{
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
          RowBox[{
            RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}]}], 
      "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(solDDxy = \(Solve[{Xacc \[Equal] 0, 
              Yacc \[Equal] 0}, {\(x''\)[t], \(y''\)[t]}] // Simplify\) // 
        First\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(solDDxy\)\" is similar \
to existing symbol \"\!\(solDxy\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{
            SuperscriptBox["x", "\[Prime]\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
          RowBox[{
            RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
        RowBox[{
          RowBox[{
            SuperscriptBox["y", "\[Prime]\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
          RowBox[{
            RowBox[{\(-\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\)\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}]}]}], 
      "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Generating the sets of equations of motion", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Now write down the equations of motion with the known reaction \
forces eliminated with the results shown above.  There are three cases, \
dragging, swinging, free.  In the dragging motion\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Generating the dragging sets of equations of motion", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom1d = \(\(\(\(eq1 /. solB\) /. solC\) /. solD\) /. solS\) /. 
        solN\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dB\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"B33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"l1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"d2", " ", "mc", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "-", 
      RowBox[{"l1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"d2", " ", "mc", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"l2", " ", \(\(a\&^\)\_1 . \(b\&^\)\_2\), " ", 
        RowBox[{"(", 
          
          RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
            "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  SuperscriptBox["x", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["x", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
              FractionBox["1", 
                RowBox[{\(\(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{"\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], 
                      "]"}]}]}]], 
              RowBox[{"(", 
                RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                  RowBox[{"(", 
                    
                    RowBox[{\(g\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
                      "+", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "+", 
                      RowBox[{
                      "Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), 
                        " ", 
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            SuperscriptBox["x", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "]"}], " ", 
                        SuperscriptBox[
                          RowBox[{
                            SuperscriptBox["x", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "2"]}], "+", 
                      RowBox[{
                      "Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), 
                        " ", 
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            SuperscriptBox["y", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "]"}], " ", 
                        SuperscriptBox[
                          RowBox[{
                            SuperscriptBox["y", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "2"]}], "+", 
                      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                        RowBox[{
                          SuperscriptBox["x", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                        RowBox[{
                          SuperscriptBox["x", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}]}], 
                    ")"}]}], ")"}]}], "-", 
            RowBox[{
              FractionBox["1", 
                RowBox[{\(\(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{"\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], 
                      "]"}]}]}]], 
              RowBox[{"(", 
                RowBox[{"\[Mu]", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "]"}], " ",
                   
                  RowBox[{"(", 
                    
                    RowBox[{\(g\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
                      "+", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "+", 
                      RowBox[{
                      "Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), 
                        " ", 
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            SuperscriptBox["x", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "]"}], " ", 
                        SuperscriptBox[
                          RowBox[{
                            SuperscriptBox["x", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "2"]}], "+", 
                      RowBox[{
                      "Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), 
                        " ", 
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            SuperscriptBox["y", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "]"}], " ", 
                        SuperscriptBox[
                          RowBox[{
                            SuperscriptBox["y", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "2"]}], "+", 
                      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                        RowBox[{
                          SuperscriptBox["x", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                        RowBox[{
                          SuperscriptBox["x", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}]}], 
                    ")"}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"d2", " ", "mc", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                
                RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
                  "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                    FractionBox["1", 
                      RowBox[{\(\(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        RowBox[{
                        "\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                          RowBox[{"Sign", "[", 
                            RowBox[{
                              SuperscriptBox["x", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "]"}]}]}]], 
                    RowBox[{"(", 
                      RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(g\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
                            "+", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], ")"}]}], "-", 
                  RowBox[{
                    FractionBox["1", 
                      RowBox[{\(\(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        RowBox[{
                        "\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                          RowBox[{"Sign", "[", 
                            RowBox[{
                              SuperscriptBox["x", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "]"}]}]}]], 
                    RowBox[{"(", 
                      RowBox[{
                      "\[Mu]", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            SuperscriptBox["x", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "]"}], " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(g\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
                            "+", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], ")"}]}]}], ")"}]}]}], 
          ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mb\), "+", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"d2", " ", "mc", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                
                RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
                  "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                    FractionBox["1", 
                      RowBox[{\(\(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        RowBox[{
                        "\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                          RowBox[{"Sign", "[", 
                            RowBox[{
                              SuperscriptBox["x", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "]"}]}]}]], 
                    RowBox[{"(", 
                      RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(g\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
                            "+", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], ")"}]}], "-", 
                  RowBox[{
                    FractionBox["1", 
                      RowBox[{\(\(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        RowBox[{
                        "\[Mu]", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                          RowBox[{"Sign", "[", 
                            RowBox[{
                              SuperscriptBox["x", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "]"}]}]}]], 
                    RowBox[{"(", 
                      RowBox[{
                      "\[Mu]", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            SuperscriptBox["x", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "]"}], " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(g\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
                            "+", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["x", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "Aa", " ", "Cd", 
                              " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "]"}], " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["y", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], ")"}]}]}], ")"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom2d = \(\(\(eq2 /. solC\) /. solD\) /. solS\) /. solN\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dC\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "-", 
            RowBox[{"d3", " ", "md", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+",
       
      RowBox[{"l4", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "-", 
            RowBox[{"d3", " ", "md", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+",
       
      RowBox[{"d2", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"l4", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"d2", " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom3d = \(\(\(eq3 /. solC\) /. solD\) /. solS\) /. solN\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dD\), " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom1d = Simplify[transform[eom1d]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{\(d1\ g\ mb\ Cos[q4[t]]\), "+", \(g\ l1\ mc\ Cos[q4[t]]\), 
          "+", \(g\ l1\ md\ Cos[q4[t]]\), 
          "+", \(d1\ g\ mb\ Cos[2\ q1[t] + q4[t]]\), 
          "+", \(g\ l1\ mc\ Cos[2\ q1[t] + q4[t]]\), 
          "+", \(g\ l1\ md\ Cos[2\ q1[t] + q4[t]]\), "+", 
          RowBox[{
          "2", " ", "l1", 
            " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                d3\ md\ Cos[q2[t] + q3[t]])\), " ", \(Cos[q1[t] + q4[t]]\), 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"2", " ", "dB", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "d2", " ", "l1", " ", "mc", " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "l1", " ", "l4", " ", "md", " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "d2", " ", "l1", " ", "mc", " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "l1", " ", "l4", " ", "md", " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"2", " ", "dC", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l1", " ", "md", 
            " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l1", " ", "md", 
            " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"4", " ", "l1", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                
                RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                      d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"d3", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
          "-", 
          RowBox[{"2", " ", "B33", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "2", " ", \(d1\^2\), " ", "mb", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "2", " ", \(l1\^2\), " ", "mc", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "2", " ", \(l1\^2\), " ", "md", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] - q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] - q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] + q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] + q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] - q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] - q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] + q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] + q2[t] + q4[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "d3", " ", "l1", " ", "md", 
            " ", \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"2", " ", "d1", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"2", " ", "l2", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"2", " ", "d1", " ", "mh", " ", \(Sin[q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"2", " ", "l2", " ", "mh", " ", \(Sin[q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            RowBox[{"(", 
              
              RowBox[{\(\(-2\)\ d1\ g\ ma\ \[Mu]\ Sin[q4[t]]\), 
                "+", \(2\ g\ l2\ ma\ \[Mu]\ Sin[q4[t]]\), 
                "-", \(d1\ g\ mb\ \[Mu]\ Sin[q4[t]]\), 
                "-", \(g\ l1\ mc\ \[Mu]\ Sin[q4[t]]\), 
                "-", \(g\ l1\ md\ \[Mu]\ Sin[q4[t]]\), 
                "-", \(2\ d1\ g\ mh\ \[Mu]\ Sin[q4[t]]\), 
                "+", \(2\ g\ l2\ mh\ \[Mu]\ Sin[q4[t]]\), 
                "-", \(d1\ g\ mb\ \[Mu]\ Sin[2\ q1[t] + q4[t]]\), 
                "-", \(g\ l1\ mc\ \[Mu]\ Sin[2\ q1[t] + q4[t]]\), 
                "-", \(g\ l1\ md\ \[Mu]\ Sin[2\ q1[t] + q4[t]]\), "-", 
                RowBox[{
                "2", " ", "l1", " ", "\[Mu]", 
                  " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                      d3\ md\ Cos[q2[t] + q3[t]])\), 
                  " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{
                "2", " ", "l1", " ", "\[Mu]", 
                  " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                      d3\ md\ Cos[q2[t] + q3[t]])\), 
                  " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{
                "2", " ", "dC", " ", "\[Mu]", " ", \(Sin[q1[t] + q4[t]]\), 
                  " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{
                "4", " ", "l1", " ", "\[Mu]", " ", \(Sin[q1[t] + q4[t]]\), 
                  " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      
                      RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                            d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                        RowBox[{
                          SuperscriptBox["q2", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{
                      "d3", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), " ", 
                        RowBox[{
                          SuperscriptBox["q3", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}]}], 
                    ")"}]}], "+", 
                RowBox[{"2", " ", "\[Mu]", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{"(", 
                    RowBox[{"dB", "-", 
                      RowBox[{
                      "2", " ", "d3", " ", "l1", " ", "md", 
                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                        RowBox[{
                          SuperscriptBox["q3", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}]}], 
                    ")"}]}], "-", 
                RowBox[{
                "2", " ", "Aa", " ", "Cd", " ", "d1", " ", \(Sin[q4[t]]\), 
                  " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{
                "2", " ", "Aa", " ", "Cd", " ", "l2", " ", \(Sin[q4[t]]\), 
                  " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{
                "2", " ", "Aa", " ", "Cd", " ", "d1", " ", "\[Mu]", " ", 
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "]"}], 
                  " ", \(Sin[q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{
                "2", " ", "Aa", " ", "Cd", " ", "l2", " ", "\[Mu]", " ", 
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "]"}], 
                  " ", \(Sin[q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{
                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "2", " ", "B33", " ", "\[Mu]", " ", \(Sin[q1[t] + q4[t]]\), 
                  " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "2", " ", \(d1\^2\), " ", "mb", " ", "\[Mu]", 
                  " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "2", " ", \(l1\^2\), " ", "mc", " ", "\[Mu]", 
                  " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "2", " ", \(l1\^2\), " ", "md", " ", "\[Mu]", 
                  " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                  " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "2", " ", "d1", " ", "ma", " ", "\[Mu]", " ", \(Sin[q4[t]]\), 
                  " ", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "2", " ", "l2", " ", "ma", " ", "\[Mu]", " ", \(Sin[q4[t]]\), 
                  " ", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{
                "2", " ", "d1", " ", "mh", " ", "\[Mu]", " ", \(Sin[q4[t]]\), 
                  " ", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "2", " ", "l2", " ", "mh", " ", "\[Mu]", " ", \(Sin[q4[t]]\), 
                  " ", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], 
              ")"}]}]}], ")"}], "/", 
      RowBox[{"(", 
        RowBox[{"2", " ", 
          RowBox[{"(", 
            RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
              RowBox[{"\[Mu]", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], 
                " ", \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom2d = Simplify[transform[eom2d]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), 
      "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
      RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - 
            d3\ l4\ md\ Sin[q3[t]])\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "+", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], "+", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(d2\^2\), " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(l4\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(d2\^2\), " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(l4\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom3d = Simplify[transform[eom3d]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
      RowBox[{
      "d3", " ", "md", " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), 
        " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom4d\  = \ \((\(q4''\)[t] /. solDDq4x)\) - \(q4''\)[t]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(1\/l3\), 
        RowBox[{"(", 
          RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                  SuperscriptBox["y", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom5d = \ \((\(x''\)[t] /. solDDq4x)\)\  - \ \(x''\)[t]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "l3", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"l2", " ", \(Sin[q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom6d\  = \ \(y''\)[t]\)], "Input"],

Cell[BoxData[
    RowBox[{
      SuperscriptBox["y", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Generating the swinging sets of equations of motion", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom1s = \(\(\(\(eq1 /. solB\) /. solC\) /. solD\) /. solS\) /. 
        solNs\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom1s\)\" is similar to \
existing symbol \"\!\(eom1d\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dB\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"B33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"l1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"d2", " ", "mc", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "-", 
      RowBox[{"l1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"d2", " ", "mc", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"l2", " ", \(\(a\&^\)\_1 . \(b\&^\)\_2\), " ", 
        RowBox[{"(", 
          
          RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
            "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  SuperscriptBox["x", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["x", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+",
       
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"d2", " ", "mc", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                
                RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
                  "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mb\), "+", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"d2", " ", "mc", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                
                RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), 
                  "-", \(g\ mh\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["y", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["x", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"mh", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom2s = \(\(\(eq2 /. solC\) /. solD\) /. solS\) /. solNs\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom2s\)\" is similar to \
existing symbol \"\!\(eom2d\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dC\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "-", 
            RowBox[{"d3", " ", "md", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+",
       
      RowBox[{"l4", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "-", 
            RowBox[{"d3", " ", "md", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+",
       
      RowBox[{"d2", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"l4", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"d2", " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom3s = \(\(\(eq3 /. solC\) /. solD\) /. solS\) /. solNs\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom3s\)\" is similar to \
existing symbol \"\!\(eom3d\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dD\), " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom4s\  = \ eq5 /. solNs\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom4s\)\" is similar to \
existing symbol \"\!\(eom4d\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), 
      "-", \(g\ mh\ \(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["y", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"mh", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{
          SuperscriptBox["y", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom1s = Simplify[transform[eom1s]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(1\/2\), " ", 
      RowBox[{"(", 
        RowBox[{\(d1\ g\ ma\ Cos[q1[t]]\), "-", \(g\ l2\ ma\ Cos[q1[t]]\), 
          "+", \(2\ d1\ g\ mb\ Cos[q1[t]]\), 
          "+", \(2\ g\ l1\ mc\ Cos[q1[t]]\), 
          "+", \(2\ g\ l1\ md\ Cos[q1[t]]\), "+", \(d1\ g\ mh\ Cos[q1[t]]\), 
          "-", \(g\ l2\ mh\ Cos[q1[t]]\), 
          "-", \(d1\ g\ ma\ Cos[q1[t] + 2\ q4[t]]\), 
          "+", \(g\ l2\ ma\ Cos[q1[t] + 2\ q4[t]]\), 
          "-", \(d1\ g\ mh\ Cos[q1[t] + 2\ q4[t]]\), 
          "+", \(g\ l2\ mh\ Cos[q1[t] + 2\ q4[t]]\), "+", 
          RowBox[{
          "2", " ", "l1", 
            " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "2", " ", "l1", 
            " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"2", " ", "dC", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l1", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"4", " ", "l1", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                
                RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                      d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"d3", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
          "-", 
          RowBox[{"2", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{"dB", "-", 
                RowBox[{
                "2", " ", "d3", " ", "l1", " ", "md", 
                  " ", \(Cos[q2[t] + q3[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
          "+", 
          RowBox[{"Aa", " ", "Cd", " ", "d1", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \(Sin[q1[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", "l2", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \(Sin[q1[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", "d1", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", "l2", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(Cos[q1[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(Cos[q1[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{
          "Aa", " ", "Cd", " ", "d1", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "Aa", " ", "Cd", " ", "l2", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"2", " ", "B33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"2", " ", \(d1\^2\), " ", "mb", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"2", " ", \(l1\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"2", " ", \(l1\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d1", " ", "ma", " ", \(Sin[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"l2", " ", "ma", " ", \(Sin[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d1", " ", "mh", " ", \(Sin[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"l2", " ", "mh", " ", \(Sin[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d1", " ", "ma", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l2", " ", "ma", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d1", " ", "mh", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l2", " ", "mh", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["x", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d1", " ", "ma", " ", \(Cos[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"l2", " ", "ma", " ", \(Cos[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d1", " ", "mh", " ", \(Cos[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"l2", " ", "mh", " ", \(Cos[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d1", " ", "ma", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l2", " ", "ma", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d1", " ", "mh", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l2", " ", "mh", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom2s = Simplify[transform[eom2s]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), 
      "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
      RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - 
            d3\ l4\ md\ Sin[q3[t]])\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "+", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], "+", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(d2\^2\), " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(l4\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(d2\^2\), " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(l4\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom3s = Simplify[transform[eom3s]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
      RowBox[{
      "d3", " ", "md", " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), 
        " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom4s = Simplify[transform[eom4s]]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-Aa\), " ", "Cd", " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], 
        " ", \(Sin[q1[t] + q4[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(Cos[q1[t] + q4[t]]\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{\((ma + mh)\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{"(", 
                RowBox[{"g", "+", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom5s = \ \((\(x''\)[t] /. solDDxy)\) - \(x''\)[t]\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom5s\)\" is similar to \
existing symbol \"\!\(eom5d\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q4", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{
        SuperscriptBox["x", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom6s\  = \ \((\(y''\)[t] /. solDDxy)\) - \(y''\)[t]\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom6s\)\" is similar to \
existing symbol \"\!\(eom6d\)\"."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\)\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q4", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{
        SuperscriptBox["y", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "t", "]"}]}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Generating the free flying sets of equations of motion", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom1f = \(\(\(\(\(\(\(\(eq1 /. solB\) /. solC\) /. solD\) /. solS\) /. 
                solNs\) //. solDDxy\) //. solDxy\) //. solxy\) /. 
        mh \[Rule] 0\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom1f\)\" is similar to \
existing symbols \!\({eom1d, eom1s}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dB\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"B33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"l1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"d2", " ", "mc", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "-", 
      RowBox[{"l1", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"d2", " ", "mc", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"l2", " ", \(\(a\&^\)\_1 . \(b\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  
                  RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                    
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
              " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    
                    RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), 
                      " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}], "2"]}], "-", 
            RowBox[{
            "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"Sign", "[", 
                RowBox[{
                  
                  RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                    
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
              " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    
                    RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), 
                      " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}], "2"]}], "-", 
            RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{
                  
                  RowBox[{\(-\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\)\), 
                    " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "-", 
            RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{
                  
                  RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                    
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}]}
                                ], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"d2", " ", "mc", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        
                        RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\),
                           " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      "]"}], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\((l2\ Cos[q1[t]] + 
                                l3\ Cos[q1[t] + q4[t]])\), " ", 
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         ")"}], "2"]}], "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        
                        RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\),
                           " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      "]"}], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\((l2\ Sin[q1[t]] + 
                                l3\ Sin[q1[t] + q4[t]])\), " ", 
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         ")"}], "2"]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        
                        RowBox[{\(-\((l2\ Sin[q1[t]] + 
                                l3\ Sin[q1[t] + q4[t]])\)\), " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], " ", 
                          
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        
                        RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\),
                           " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], " ", 
                          
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"d1", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mb\), "+", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_1 . \(n\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "d1", " ", "mb", " ", \(\(b\&^\)\_2 . \(n\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d2", " ", "mc", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(c\&^\)\_2 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ mc\ \(c\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"d2", " ", "mc", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                        
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "-", 
                        RowBox[{"d3", " ", "md", " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{\(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          SuperscriptBox[
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "+", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}], "2"]}], "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{
                        "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                        "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), 
                          " ", 
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"d3", " ", "md", " ", 
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}], "-", 
            RowBox[{\(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_1 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        
                        RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\),
                           " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      "]"}], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\((l2\ Cos[q1[t]] + 
                                l3\ Cos[q1[t] + q4[t]])\), " ", 
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         ")"}], "2"]}], "-", 
                  RowBox[{
                  "Aa", " ", "Cd", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        
                        RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\),
                           " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      "]"}], " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\((l2\ Sin[q1[t]] + 
                                l3\ Sin[q1[t] + q4[t]])\), " ", 
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         ")"}], "2"]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_2\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        
                        RowBox[{\(-\((l2\ Sin[q1[t]] + 
                                l3\ Sin[q1[t] + q4[t]])\)\), " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "-", 
                        RowBox[{
                        "2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], " ", 
                          
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "-", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}], "-", 
                  RowBox[{"ma", " ", \(\(a\&^\)\_1 . \(n\&^\)\_1\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        
                        RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\),
                           " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{
                        "2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], " ", 
                          
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                          SuperscriptBox[
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}], 
                            "2"]}], "+", 
                        RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                          RowBox[{
                            SuperscriptBox["q4", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}]}], 
                      ")"}]}]}], ")"}]}]}], ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom2f = \(\(\(\(\(\(\(eq2 /. solC\) /. solD\) /. solS\) /. solNs\) //. 
              solDDxy\) //. solDxy\) //. solxy\) /. mh \[Rule] 0\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom2f\)\" is similar to \
existing symbols \!\({eom2d, eom2s}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dC\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d2", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "-", 
            RowBox[{"d3", " ", "md", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+",
       
      RowBox[{"l4", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "-", 
            RowBox[{"d3", " ", "md", " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+",
       
      RowBox[{"d2", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"l4", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"d2", " ", 
        RowBox[{"(", 
          RowBox[{\(g\ mc\ \(c\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_1 . \(c\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "mc", " ", \(\(b\&^\)\_2 . \(c\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d2", " ", "mc", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
              RowBox[{"(", 
                RowBox[{\(\(-g\)\ md\ \(d\&^\)\_2 . \(n\&^\)\_2\), "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "-", 
                  RowBox[{"d3", " ", "md", " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q3", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_2\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}], "+", 
            RowBox[{\(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{"(", 
                RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    SuperscriptBox[
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], "+", 
                          
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}], "2"]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "-", 
                  RowBox[{
                  "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"d3", " ", "md", " ", 
                    RowBox[{
                      SuperscriptBox["q3", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], 
                ")"}]}]}], ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom3f = \(\(\(\(\(\(\(eq3 /. solC\) /. solD\) /. solS\) /. solNs\) //. 
              solDDxy\) //. solDxy\) //. solxy\) /. mh \[Rule] 0\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom3f\)\" is similar to \
existing symbols \!\({eom3d, eom3s}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-dD\), " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", 
        RowBox[{"(", 
          RowBox[{\(g\ md\ \(d\&^\)\_1 . \(n\&^\)\_2\), "+", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_1 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_2 . \(d\&^\)\_1\), " ", 
              SuperscriptBox[
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "+", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}], 
                "2"]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{
            "l1", " ", "md", " ", \(\(b\&^\)\_2 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "l4", " ", "md", " ", \(\(c\&^\)\_1 . \(d\&^\)\_1\), " ", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"d3", " ", "md", " ", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom4f\  = \ \(\(\(\(eq5 /. solNs\) //. solDDxy\) //. solDxy\) //. 
          solxy\) /. mh \[Rule] 0\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom4f\)\" is similar to \
existing symbols \!\({eom4d, eom4s}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{\(\(-g\)\ ma\ \(a\&^\)\_2 . \(n\&^\)\_2\), "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
          "2"]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
          "2"]}], "-", 
      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_2\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\(-\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\)\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"ma", " ", \(\(a\&^\)\_2 . \(n\&^\)\_1\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom5f\  = \ 
      eq4 /. {S \[Rule] 0, Na \[Rule] 0, ma \[Rule] 0, 
          a[1] \[Rule] n[1]}\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom5f\)\" is similar to \
existing symbols \!\({eom5d, eom5s}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-Aa\), " ", "Cd", " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"mh", " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom6f\  = \ 
      eq5 /. {S \[Rule] 0, Na \[Rule] 0, ma \[Rule] 0, 
          a[2] \[Rule] n[2]}\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(eom6f\)\" is similar to \
existing symbols \!\({eom6d, eom6s}\)."\)], "Message"],

Cell[BoxData[
    RowBox[{\(\(-g\)\ mh\), "-", 
      RowBox[{"Aa", " ", "Cd", " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"mh", " ", 
        RowBox[{
          SuperscriptBox["y", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom1f = Simplify[transform[eom1f]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(1\/8\), " ", 
      RowBox[{"(", 
        RowBox[{\(4\ d1\ g\ ma\ Cos[q1[t]]\), 
          "-", \(4\ g\ l2\ ma\ Cos[q1[t]]\), 
          "+", \(8\ d1\ g\ mb\ Cos[q1[t]]\), 
          "+", \(8\ g\ l1\ mc\ Cos[q1[t]]\), 
          "+", \(8\ g\ l1\ md\ Cos[q1[t]]\), 
          "-", \(4\ d1\ g\ ma\ Cos[q1[t] + 2\ q4[t]]\), 
          "+", \(4\ g\ l2\ ma\ Cos[q1[t] + 2\ q4[t]]\), "+", 
          RowBox[{"4", " ", 
            RowBox[{"(", 
              
              RowBox[{\(2\ d2\ l1\ mc\ Cos[q2[t]]\), 
                "+", \(2\ l1\ l4\ md\ Cos[q2[t]]\), 
                "+", \(2\ d3\ l1\ md\ Cos[q2[t] + q3[t]]\), 
                "-", \(2\ d1\ l3\ ma\ Sin[q4[t]]\), 
                "+", \(2\ l2\ l3\ ma\ Sin[q4[t]]\), 
                "-", \(d1\ l2\ ma\ Sin[2\ q4[t]]\), 
                "+", \(l2\^2\ ma\ Sin[2\ q4[t]]\), "+", 
                RowBox[{
                "2", " ", "Aa", " ", "Cd", " ", \((d1 - l2)\), 
                  " ", \(\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\)\^2\), 
                  " ", 
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      
                      RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), 
                        " ", 
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                        RowBox[{
                          SuperscriptBox["q4", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}]}], 
                    "]"}], " ", \(Sin[q4[t]]\), " ", \(Sin[q1[t] + q4[t]]\)}],
                 "-", 
                RowBox[{
                "2", " ", "Aa", " ", "Cd", " ", \((d1 - l2)\), 
                  " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{"Sign", "[", 
                    RowBox[{
                      
                      RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), 
                        " ", 
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                        RowBox[{
                          SuperscriptBox["q4", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}]}], 
                    "]"}], " ", \(Sin[q4[t]]\), 
                  " ", \(\((l2\ Sin[q1[t]] + 
                          l3\ Sin[q1[t] + q4[t]])\)\^2\)}]}], ")"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "8", " ", "l1", 
            " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"8", " ", "dC", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "d3", " ", "l1", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"8", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{"dB", "-", 
                RowBox[{
                "2", " ", "d3", " ", "l1", " ", "md", 
                  " ", \(Cos[q2[t] + q3[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
          "+", 
          RowBox[{
          "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", \(Cos[q1[t]]\), 
            " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{
          "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", \(Cos[q1[t]]\), 
            " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{
          "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), 
            " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), 
            " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), 
            " ", \(Cos[3\ q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{
          "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), 
            " ", \(Cos[3\ q1[t] + 2\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{
          "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), 
            " ", \(Cos[3\ q1[t] + 4\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), 
            " ", \(Cos[3\ q1[t] + 4\ q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[q1[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[q1[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{
          "8", " ", "d1", " ", "l3", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "8", " ", "l2", " ", "l3", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[3\ q1[t] + 2\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[3\ q1[t] + 2\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[3\ q1[t] + 4\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[3\ q1[t] + 4\ q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"2", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                "8", " ", "l1", 
                  " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                      d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "8", " ", "d3", " ", "l1", " ", "md", 
                  " ", \(Cos[q2[t] + q3[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{
                "2", " ", \((d1 - l2)\), " ", "l3", " ", \(Sin[q4[t]]\), " ", 
                  
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                      "2", " ", "Aa", " ", "Cd", 
                        " ", \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), 
                        " ", 
                        RowBox[{"Sign", "[", 
                          RowBox[{
                            
                            RowBox[{\((l2\ Cos[q1[t]] + 
                                  l3\ Cos[q1[t] + q4[t]])\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], "]"}], 
                        " ", \(Sin[2\ \((q1[t] + q4[t])\)]\)}], "-", 
                      RowBox[{"2", " ", 
                        RowBox[{"(", 
                          RowBox[{\(2\ ma\), "+", 
                            RowBox[{"Aa", " ", "Cd", " ", 
                              RowBox[{"Sign", "[", 
                                RowBox[{
                                  
                                  RowBox[{\((l2\ Sin[q1[t]] + 
                                        l3\ Sin[q1[t] + q4[t]])\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                  "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}]}], "]"}], 
                              " ", \((l2\ Sin[q1[t]] + 
                                  l3\ Sin[q1[t] + q4[t]])\), 
                              " ", \(Sin[2\ \((q1[t] + q4[t])\)]\)}]}], 
                          ")"}]}]}], ")"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
          "-", 
          RowBox[{"8", " ", "B33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"4", " ", "d1", " ", "l2", " ", "ma", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"4", " ", \(l2\^2\), " ", "ma", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"8", " ", \(d1\^2\), " ", "mb", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"8", " ", \(l1\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"8", " ", \(l1\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "4", " ", "d1", " ", "l2", " ", "ma", " ", \(Cos[2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "4", " ", \(l2\^2\), " ", "ma", " ", \(Cos[2\ q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "8", " ", "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), 
            " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom2f = Simplify[transform[eom2f]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), 
      "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
      RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - 
            d3\ l4\ md\ Sin[q3[t]])\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"dC", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q3", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "+", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], "+", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(d2\^2\), " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(l4\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"C33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(d2\^2\), " ", "mc", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{\(l4\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom3f = Simplify[transform[eom3f]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
      RowBox[{
      "d3", " ", "md", " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), 
        " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["q2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"dD", " ", 
        RowBox[{
          SuperscriptBox["q4", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q1", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
        RowBox[{
          SuperscriptBox["q2", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "-", 
      RowBox[{"D33", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{\(d3\^2\), " ", "md", " ", 
        RowBox[{
          SuperscriptBox["q3", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom4f = Simplify[transform[eom4f]]\)], "Input"],

Cell[BoxData[
    RowBox[{\(\(-g\)\ ma\ Cos[q1[t] + q4[t]]\), "-", 
      RowBox[{"Aa", " ", "Cd", " ", \(Cos[q1[t] + q4[t]]\), " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
          "2"]}], "-", 
      RowBox[{"Aa", " ", "Cd", " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
        " ", \(Sin[q1[t] + q4[t]]\), " ", 
        SuperscriptBox[
          RowBox[{"(", 
            RowBox[{
              RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
          "2"]}], "+", 
      RowBox[{"ma", " ", \(Cos[q1[t] + q4[t]]\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
            RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "-", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-",
       
      RowBox[{"ma", " ", \(Sin[q1[t] + q4[t]]\), " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom5f = \ Simplify[transform[eom5f]]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-Aa\), " ", "Cd", " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["x", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"mh", " ", 
        RowBox[{
          SuperscriptBox["x", "\[Prime]\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(eom6f = \ Simplify[transform[eom6f]]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(-Aa\), " ", "Cd", " ", 
        RowBox[{"Sign", "[", 
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["y", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
      RowBox[{"mh", " ", 
        RowBox[{"(", 
          RowBox[{"g", "+", 
            RowBox[{
              SuperscriptBox["y", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], 
          ")"}]}]}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Finding switching conditions for motion regimes", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
Create a normal force function that does not depend on the \
accelerations, only the speeds and positions.  First we find the angular \
accelerations from the equations of motion.  y''[t]->0 during the dragging \
motion, \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(solAcc = \(Solve[{eom1d \[Equal] 0, eom2d \[Equal] 0, 
              eom3d \[Equal] 0}, {\(q1''\)[t], \(q2''\)[t], \(q3''\)[t]}] //. 
          solDDq4x\) //. \(y''\)[t] \[Rule] 0\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{
            RowBox[{
              SuperscriptBox["q1", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
            RowBox[{
              RowBox[{"-", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
                      RowBox[{
                      "d3", " ", "md", 
                        " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), 
                        " ", 
                        SuperscriptBox[
                          RowBox[{
                            SuperscriptBox["q1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "2"]}], "+", 
                      RowBox[{
                      "2", " ", "d3", " ", "l4", " ", "md", 
                        " ", \(Sin[q3[t]]\), " ", 
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], " ", 
                        RowBox[{
                          SuperscriptBox["q2", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], "+", 
                      
                      RowBox[{
                      "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
                        SuperscriptBox[
                          RowBox[{
                            SuperscriptBox["q2", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}], 
                          "2"]}], "-", 
                      RowBox[{"dD", " ", 
                        RowBox[{
                          SuperscriptBox["q4", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}]}], 
                    ")"}], "/", \((\(-D33\) + d3\^2\ md + 
                      d3\ l4\ md\ Cos[q3[t]] - 
                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\)}]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            RowBox[{"(", 
                              RowBox[{
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                  
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                      "-", 
                                      
                                      FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              
                              RowBox[{\(-\((\(-C33\) - d2\^2\ mc - 
                                      l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                                      d2\ l1\ mc\ Sin[q2[t]] + 
                                      l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                                RowBox[{"(", 
                                  
                                  RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                    RowBox[{
                                    "d3", " ", "md", 
                                      " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  
                                  RowBox[{\(\(-d2\)\ g\ mc\ Sin[
                                        q1[t] + q2[t]]\), 
                                    "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), 
                                    "-", 
                                    
                                    RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] - d3\ l4\ md\ Sin[q3[t]])\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dC", " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                        
                        RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                    d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                      "-", 
                                      
                                      FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], " ", 
                                RowBox[{"(", 
                                  RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                    RowBox[{
                                    "d3", " ", "md", 
                                      " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    FractionBox[\(d1\ g\ mb\ Cos[q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[\(g\ l1\ mc\ Cos[q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[\(g\ l1\ md\ Cos[q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d1\ g\ mb\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(g\ l1\ mc\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(g\ l1\ md\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "ma", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l2", " ", "ma", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "mb", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "mc", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "md", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "mh", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l2", " ", "mh", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "mb", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "mc", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "md", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "dB", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "dC", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{"dC", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "-", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                    FractionBox[
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{"dB", "-", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "d1", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "l2", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "d1", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "l2", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "-", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}]}], 
                      ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                  
                  RowBox[{\((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        
                        RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                    d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                              RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      
                                      FractionBox[\(B33\ Cos[q1[t] + q4[t]]\),
                                         
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                    "-", 
                                    
                                    FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}], "-", 
                        
                        RowBox[{\((\(-\((\(-D33\) + 
                                      d3\^2\ md)\)\)\ \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) - 
                              d3\ l4\ md\ Cos[
                                  q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      
                                      FractionBox[\(B33\ Cos[q1[t] + q4[t]]\),
                                         
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                    "-", 
                                    
                                    FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}]}], 
                      ")"}]}], ")"}]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  
                  RowBox[{\((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])\),
                     " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"(", 
                            RowBox[{
                              
                              RowBox[{\(-\((\(-C33\) - d2\^2\ mc - 
                                      l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                                      d2\ l1\ mc\ Sin[q2[t]] + 
                                      l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                                RowBox[{"(", 
                                  
                                  RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                    RowBox[{
                                    "d3", " ", "md", 
                                      " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  
                                  RowBox[{\(\(-d2\)\ g\ mc\ Sin[
                                        q1[t] + q2[t]]\), 
                                    "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), 
                                    "-", 
                                    
                                    RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] - d3\ l4\ md\ Sin[q3[t]])\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dC", " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}]}], ")"}], 
                          "/", \((\(-\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                    d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\)}], 
                        "-", 
                        RowBox[{
                          RowBox[{"(", 
                            
                            RowBox[{\((\(-\((\(-D33\) + 
                                        d3\^2\ md)\)\)\ \((\(-C33\) - 
                                        d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\) - 
                                  d3\ l4\ md\ Cos[
                                      q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                              " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{
                                    RowBox[{"-", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                        " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], 
                                        ")"}]}], "-", 
                                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]]}], "-", 
                                        
                                        FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        
                                        FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "+", 
                                        FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "+", 
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "+", 
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], 
                                        ")"}]}]}], ")"}]}], " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        
                                        RowBox[{\(-\((\(-C33\) - d2\^2\ mc - 
                                        l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                                        RowBox[{"(", 
                                        
                                        RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                                        
                                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                        " ", 
                                        RowBox[{"(", 
                                        
                                        RowBox[{\(\(-d2\)\ g\ mc\ Sin[
                                        q1[t] + q2[t]]\), 
                                        "-", \(g\ l4\ md\ Sin[
                                        q1[t] + q2[t]]\), "-", 
                                        
                                        RowBox[{\((l1\ \((d2\ mc + 
                                        l4\ md)\)\ Cos[q2[t]] - 
                                        d3\ l4\ md\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{"dC", " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                        RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                                  
                                  RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                        d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[
                                        q2[t]])\) + \((\(-C33\) - d2\^2\ mc - 
                                        l4\^2\ md - 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\ \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                                    " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]]}], "-", 
                                        
                                        FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        
                                        FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        
                                        FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "+", 
                                        FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "+", 
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "+", 
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]], "-", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], 
                                        ")"}]}], " ", 
                                        RowBox[{"(", 
                                        
                                        RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                                        
                                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                        " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        FractionBox[\(d1\ g\ mb\ Cos[q4[t]]\),
                                         
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(g\ l1\ mc\ Cos[q4[t]]\),
                                         
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(g\ l1\ md\ Cos[q4[t]]\),
                                         
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d1\ g\ mb\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(g\ l1\ mc\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(g\ l1\ md\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "ma", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "g", " ", "l2", " ", "ma", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "mh", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "g", " ", "l2", " ", "mh", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", \((\((d2\ mc + 
                                        l4\ md)\)\ Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "dB", " ", \(Cos[q1[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q1[t] - q2[t] - q3[t] + 
                                        q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q1[t] + q2[t] + q3[t] + 
                                        q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "dC", " ", \(Cos[q1[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{"dC", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q1[t] - q2[t] - q3[t] + 
                                        q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q1[t] + q2[t] + q3[t] + 
                                        q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q1[t] - q2[t] - q3[t] + 
                                        q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q1[t] + q2[t] + q3[t] + 
                                        q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] - q2[t] - q3[t] + 
                                        q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q2[t] + q3[t] + 
                                        q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[q2[t] + 
                                        q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", \(Cos[
                                        q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[q2[t] + 
                                        q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", \(Cos[
                                        q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}], "+", 
                                        FractionBox[
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{"dB", "-", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "d1", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "l2", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "d1", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "l2", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}], ")"}], 
                          "/", 
                          RowBox[{"(", 
                            
                            RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                        d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[
                                        q2[t]])\) + \((\(-C33\) - d2\^2\ mc - 
                                        l4\^2\ md - 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\ \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                              " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  
                                  RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                        d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[
                                        q2[t]])\) + \((\(-C33\) - d2\^2\ mc - 
                                        l4\^2\ md - 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\ \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                                    " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        
                                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                        " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], "+",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], 
                                        ")"}]}], "-", 
                                        
                                        RowBox[{\((\(-D33\) + d3\^2\ md)\), 
                                        " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]]}], "-", 
                                        
                                        FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], 
                                        ")"}]}]}], ")"}]}], "-", 
                                  
                                  RowBox[{\((\(-\((\(-D33\) + 
                                        d3\^2\ md)\)\)\ \((\(-C33\) - 
                                        d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\) - 
                                        d3\ l4\ md\ Cos[
                                        q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                                    " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        
                                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                        " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{"d2", " ", "l1", " ", "mc", 
                                        " ", "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], 
                                        ")"}]}], "-", 
                                        
                                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}]]}], "-", 
                                        
                                        FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[
                                        q1[t] + q4[t]]\)}]}], ")"}]}]]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}], 
                            ")"}]}]}], ")"}]}], ")"}], 
                "/", \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\)}]}]}], ",", 
          RowBox[{
            RowBox[{
              SuperscriptBox["q2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
            RowBox[{
              RowBox[{"-", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      
                      RowBox[{\(-\((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                              d3\ l4\ md\ Cos[q3[t]] + 
                              d2\ l1\ mc\ Sin[q2[t]] + 
                              l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), 
                            "+", 
                            RowBox[{
                            "d3", " ", "md", 
                              " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                  l4\ Sin[q3[t]])\), " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "-", 
                            RowBox[{"dD", " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], "+", 
                      
                      RowBox[{\((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), 
                            "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
                            
                            RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[
                                      q2[t]] - d3\ l4\ md\ Sin[q3[t]])\), " ",
                               
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "-", 
                            RowBox[{"dC", " ", 
                              RowBox[{
                                SuperscriptBox["q3", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{
                                SuperscriptBox["q3", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "+", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{"dD", " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}]}], ")"}], 
                  "/", \((\(-\((\(-D33\) + d3\^2\ md + 
                              d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                            d2\ l1\ mc\ Sin[q2[t]] + 
                            l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - 
                            d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                            d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\)}]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{\((\(-\((\(-D33\) + d3\^2\ md)\)\)\ \((\(-C33\) - 
                              d2\^2\ mc - l4\^2\ md - 
                              d3\ l4\ md\ Cos[q3[t]] + 
                              d2\ l1\ mc\ Sin[q2[t]] + 
                              l1\ l4\ md\ Sin[q2[t]])\) - 
                        d3\ l4\ md\ Cos[
                            q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                              d3\ l4\ md\ Cos[q3[t]] - 
                              d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{
                          RowBox[{"-", 
                            RowBox[{"(", 
                              RowBox[{
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                  
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                      "-", 
                                      
                                      FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}], " ", 
                          RowBox[{"(", 
                            RowBox[{
                              
                              RowBox[{\(-\((\(-C33\) - d2\^2\ mc - 
                                      l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                                      d2\ l1\ mc\ Sin[q2[t]] + 
                                      l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                                RowBox[{"(", 
                                  
                                  RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                    RowBox[{
                                    "d3", " ", "md", 
                                      " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  
                                  RowBox[{\(\(-d2\)\ g\ mc\ Sin[
                                        q1[t] + q2[t]]\), 
                                    "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), 
                                    "-", 
                                    
                                    RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] - d3\ l4\ md\ Sin[q3[t]])\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dC", " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                        
                        RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                    d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                      "-", 
                                      
                                      FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], " ", 
                                RowBox[{"(", 
                                  
                                  RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                    RowBox[{
                                    "d3", " ", "md", 
                                      " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                    "d3", " ", "l4", " ", "md", 
                                      " ", \(Sin[q3[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                    RowBox[{"dD", " ", 
                                      RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    FractionBox[\(d1\ g\ mb\ Cos[q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[\(g\ l1\ mc\ Cos[q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[\(g\ l1\ md\ Cos[q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d1\ g\ mb\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(g\ l1\ mc\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(g\ l1\ md\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "ma", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l2", " ", "ma", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "mb", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "mc", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "md", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "mh", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l2", " ", "mh", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d1", " ", "g", " ", "mb", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "mc", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "g", " ", "l1", " ", "md", " ", "\[Mu]",
                                         " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "dB", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "dC", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{"dC", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "-", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                    FractionBox[
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{"dB", "-", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "d1", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "l2", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "d1", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "Aa", " ", "Cd", " ", "l2", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "-", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}]}], 
                      ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                  
                  RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                              d2\^2\ mc - l4\^2\ md - 
                              d3\ l4\ md\ Cos[q3[t]] + 
                              d2\ l1\ mc\ Sin[q2[t]] + 
                              l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                              d2\^2\ mc - l4\^2\ md - 
                              d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                              d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                              d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                    RowBox[{"(", 
                      RowBox[{
                        
                        RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                    d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                              RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      
                                      FractionBox[\(B33\ Cos[q1[t] + q4[t]]\),
                                         
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                    "-", 
                                    
                                    FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}], "-", 
                        
                        RowBox[{\((\(-\((\(-D33\) + 
                                      d3\^2\ md)\)\)\ \((\(-C33\) - 
                                    d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) - 
                              d3\ l4\ md\ Cos[
                                  q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                              
                              RowBox[{\((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      
                                      FractionBox[\(B33\ Cos[q1[t] + q4[t]]\),
                                         
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                    "-", 
                                    
                                    FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    FractionBox[
                                      RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                     
                                    FractionBox[
                                      
                                      RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                     
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                    
                                    FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}]}], 
                      ")"}]}], ")"}]}]}]}], ",", 
          RowBox[{
            RowBox[{
              SuperscriptBox["q3", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
            RowBox[{"-", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        RowBox[{"(", 
                          RowBox[{
                            
                            RowBox[{\((\(-D33\) + d3\^2\ md + 
                                  d3\ l4\ md\ Cos[q3[t]] - 
                                  d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    FractionBox[
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                  FractionBox[
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  FractionBox[
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  
                                  FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  
                                  FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  
                                  FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                            
                            RowBox[{\((\(-D33\) + d3\^2\ md + 
                                  d3\ l4\ md\ Cos[q3[t]])\), " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                  "-", 
                                  
                                  FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  
                                  FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  
                                  FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  FractionBox[
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  FractionBox[
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  FractionBox[
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{"B33", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                   
                                  FractionBox[
                                    
                                    RowBox[{\(d1\^2\), " ", "mb", " ", 
                                      "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                   
                                  FractionBox[
                                    
                                    RowBox[{\(l1\^2\), " ", "mc", " ", 
                                      "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                   
                                  FractionBox[
                                    
                                    RowBox[{\(l1\^2\), " ", "md", " ", 
                                      "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  
                                  FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  
                                  FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  
                                  FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\(-\((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                  d3\ l4\ md\ Cos[q3[t]] + 
                                  d2\ l1\ mc\ Sin[q2[t]] + 
                                  l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                            RowBox[{"(", 
                              
                              RowBox[{\(d3\ g\ md\ Sin[
                                    q1[t] + q2[t] + q3[t]]\), "+", 
                                RowBox[{
                                "d3", " ", "md", 
                                  " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                      l4\ Sin[q3[t]])\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}], "+", 
                          
                          RowBox[{\((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              
                              RowBox[{\(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), 
                                "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
                                
                                RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] - d3\ l4\ md\ Sin[q3[t]])\), 
                                  " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dC", " ", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    
                    RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                  d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            RowBox[{"-", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                  "-", 
                                  
                                  FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  
                                  FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  
                                  FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  FractionBox[
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  FractionBox[
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  FractionBox[
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  FractionBox[
                                    RowBox[{"B33", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                   
                                  FractionBox[
                                    
                                    RowBox[{\(d1\^2\), " ", "mb", " ", 
                                      "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                   
                                  FractionBox[
                                    
                                    RowBox[{\(l1\^2\), " ", "mc", " ", 
                                      "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                   
                                  FractionBox[
                                    
                                    RowBox[{\(l1\^2\), " ", "md", " ", 
                                      "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}], 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                   
                                  
                                  FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  
                                  FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                  
                                  FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                  
                                  FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], " ", 
                            RowBox[{"(", 
                              
                              RowBox[{\(d3\ g\ md\ Sin[
                                    q1[t] + q2[t] + q3[t]]\), "+", 
                                RowBox[{
                                "d3", " ", "md", 
                                  " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                      l4\ Sin[q3[t]])\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", 
                                  " ", \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}], "+", 
                          
                          RowBox[{\((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                FractionBox[\(d1\ g\ mb\ Cos[q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[\(g\ l1\ mc\ Cos[q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[\(g\ l1\ md\ Cos[q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d1\ g\ mb\ Cos[
                                      2\ q1[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(g\ l1\ mc\ Cos[
                                      2\ q1[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(g\ l1\ md\ Cos[
                                      2\ q1[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d1", " ", "g", " ", "ma", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "g", " ", "l2", " ", "ma", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d1", " ", "g", " ", "mb", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "g", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "g", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d1", " ", "g", " ", "mh", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "g", " ", "l2", " ", "mh", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d1", " ", "g", " ", "mb", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "g", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "g", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "l1", 
                                    " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), 
                                    " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "\[Mu]", 
                                    " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "dB", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", 
                                    " ", \(Cos[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", 
                                    " ", \(Cos[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "\[Mu]", 
                                    " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "dC", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{"dC", " ", "\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", 
                                    " ", \(Cos[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], " ", 
                                    RowBox[{
                                      SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", 
                                    " ", \(Cos[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], " ", 
                                    RowBox[{
                                      SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", 
                                    " ", \(Cos[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", 
                                    " ", \(Cos[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "2", " ", "l1", 
                                      " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "2", " ", "l1", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}], "+", 
                                FractionBox[
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], " ", 
                                    RowBox[{"(", 
                                      RowBox[{"dB", "-", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{"Aa", " ", "Cd", " ", "d1", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                    " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{"Aa", " ", "Cd", " ", "l2", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                    " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "Aa", " ", "Cd", " ", "d1", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                    " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "Aa", " ", "Cd", " ", "l2", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                    " ", 
                                    SuperscriptBox[
                                      RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "ma", 
                                      " ", \(Sec[q1[t] + q4[t]]\), 
                                      " ", \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l2", " ", "ma", 
                                      " ", \(Sec[q1[t] + q4[t]]\), 
                                      " ", \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "mh", 
                                      " ", \(Sec[q1[t] + q4[t]]\), 
                                      " ", \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l2", " ", "mh", 
                                      " ", \(Sec[q1[t] + q4[t]]\), 
                                      " ", \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}], 
                "/", 
                RowBox[{"(", 
                  RowBox[{
                    
                    RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                  d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  FractionBox[
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]]}], ")"}]}], "-", 
                          RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                "-", 
                                
                                FractionBox[\(d1\^2\ mb\ Cos[q1[t] + q4[t]]\),
                                   
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                
                                FractionBox[\(l1\^2\ mc\ Cos[q1[t] + q4[t]]\),
                                   
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                
                                FractionBox[\(l1\^2\ md\ Cos[q1[t] + q4[t]]\),
                                   
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{"B33", " ", "\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  
                                  RowBox[{\(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  
                                  RowBox[{\(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  
                                  RowBox[{\(l1\^2\), " ", "md", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                
                                FractionBox[\(d2\ l1\ mc\ Sin[
                                      q1[t] - q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(l1\ l4\ md\ Sin[
                                      q1[t] - q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d2\ l1\ mc\ Sin[
                                      q1[t] + q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(l1\ l4\ md\ Sin[
                                      q1[t] + q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]]}], ")"}]}]}], ")"}]}], "-", 
                    
                    RowBox[{\((\(-\((\(-D33\) + d3\^2\ md)\)\)\ \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) - 
                          d3\ l4\ md\ Cos[
                              q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  FractionBox[
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(d2\ l1\ mc\ Sin[
                                      q1[t] - q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(l1\ l4\ md\ Sin[
                                      q1[t] - q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d2\ l1\ mc\ Sin[
                                      q1[t] + q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(l1\ l4\ md\ Sin[
                                      q1[t] + q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]]}], ")"}]}], "-", 
                          
                          RowBox[{\((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                "-", 
                                
                                FractionBox[\(d1\^2\ mb\ Cos[q1[t] + q4[t]]\),
                                   
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                
                                FractionBox[\(l1\^2\ mc\ Cos[q1[t] + q4[t]]\),
                                   
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                
                                FractionBox[\(l1\^2\ md\ Cos[q1[t] + q4[t]]\),
                                   
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{
                                  "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                    " ", \(Cos[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                FractionBox[
                                  RowBox[{"B33", " ", "\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  
                                  RowBox[{\(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  
                                  RowBox[{\(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                                FractionBox[
                                  
                                  RowBox[{\(l1\^2\), " ", "md", " ", "\[Mu]", 
                                    " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}], 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                                
                                FractionBox[\(d2\ l1\ mc\ Sin[
                                      q1[t] - q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(l1\ l4\ md\ Sin[
                                      q1[t] - q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d2\ l1\ mc\ Sin[
                                      q1[t] + q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(l1\ l4\ md\ Sin[
                                      q1[t] + q2[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "-", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]], "+", 
                                
                                FractionBox[\(d3\ l1\ md\ Sin[
                                      q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]]}], ")"}]}]}], ")"}]}]}], 
                  ")"}]}]}]}]}], "}"}], "}"}]], "Output"]
}, Closed]],

Cell["\<\
Now create the normal force function with a dummy place holder for \
q1''[t].\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Nahold = \((\((Na //. solN)\) //. solDDq4x)\) //. {\(y''\)[t] \[Rule] 
              0, \(q1''\)[t] \[Rule] q1DD[t]} // transform\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{\(g\ ma\ \((Cos[q1[t]]\ Cos[q4[t]] - 
                Sin[q1[t]]\ Sin[q4[t]])\)\), 
          "+", \(g\ mh\ \((Cos[q1[t]]\ Cos[q4[t]] - 
                Sin[q1[t]]\ Sin[q4[t]])\)\), "+", 
          RowBox[{
          "ma", " ", \(Sec[q1[t] + q4[t]]\), 
            " ", \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\), " ", 
            RowBox[{"(", 
              RowBox[{\(\(-l2\)\ q1DD[t]\ Sin[q4[t]]\), "+", 
                RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"2", " ", "l3", " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
              ")"}]}], "+", 
          RowBox[{
          "mh", " ", \(Sec[q1[t] + q4[t]]\), 
            " ", \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\), " ", 
            RowBox[{"(", 
              RowBox[{\(\(-l2\)\ q1DD[t]\ Sin[q4[t]]\), "+", 
                RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"2", " ", "l3", " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
              ")"}]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"Aa", " ", "Cd", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \((Cos[q1[t]]\ Cos[q4[t]] - Sin[q1[t]]\ Sin[q4[t]])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}], 
      "/", 
      RowBox[{"(", 
        RowBox[{\(Cos[q1[t]]\ Cos[q4[t]]\), "-", \(Sin[q1[t]]\ Sin[q4[t]]\), 
          "-", 
          RowBox[{"\[Mu]", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], 
            " ", \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\)}]}], 
        ")"}]}]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Na[t_] = Nahold;\)\)], "Input"],

Cell["\<\
Create the dummy place holder function for use when called upon in \
the simulation.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(q1DD[t_] = \(q1''\)[t] /. solAcc // First\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"-", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
              RowBox[{
              "d3", " ", "md", 
                " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"dD", " ", 
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
          "/", \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
              d3\ l1\ md\ Sin[q2[t] + q3[t]])\)}]}], "+", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  RowBox[{"-", 
                    RowBox[{"(", 
                      RowBox[{
                        
                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                              d3\ l4\ md\ Cos[q3[t]] - 
                              d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", 
                                FractionBox[
                                  RowBox[{
                                  "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                    " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                    
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                  RowBox[{"2", " ", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                      ")"}]}]]}], "-", 
                              FractionBox[
                                RowBox[{
                                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              FractionBox[
                                RowBox[{
                                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\),
                                   " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\),
                                   " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              
                              FractionBox[\(d2\ l1\ mc\ Sin[
                                    q1[t] - q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              
                              FractionBox[\(l1\ l4\ md\ Sin[
                                    q1[t] - q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(d2\ l1\ mc\ Sin[
                                    q1[t] + q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(l1\ l4\ md\ Sin[
                                    q1[t] + q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              
                              FractionBox[\(d3\ l1\ md\ Sin[
                                    q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(d3\ l1\ md\ Sin[
                                    q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]]}], ")"}]}], "-", 
                        
                        RowBox[{\((\(-D33\) + d3\^2\ md + 
                              d3\ l4\ md\ Cos[q3[t]])\), " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", 
                                FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], "-",
                               
                              FractionBox[\(d1\^2\ mb\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              FractionBox[\(l1\^2\ mc\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              FractionBox[\(l1\^2\ md\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              FractionBox[
                                RowBox[{
                                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              FractionBox[
                                RowBox[{
                                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              FractionBox[
                                RowBox[{
                                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\),
                                   " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\),
                                   " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{"B33", " ", "\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                              FractionBox[
                                
                                RowBox[{\(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                  " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                              FractionBox[
                                
                                RowBox[{\(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                  " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                              FractionBox[
                                
                                RowBox[{\(l1\^2\), " ", "md", " ", "\[Mu]", 
                                  " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              
                              FractionBox[\(d2\ l1\ mc\ Sin[
                                    q1[t] - q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              
                              FractionBox[\(l1\ l4\ md\ Sin[
                                    q1[t] - q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(d2\ l1\ mc\ Sin[
                                    q1[t] + q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(l1\ l4\ md\ Sin[
                                    q1[t] + q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              
                              FractionBox[\(d3\ l1\ md\ Sin[
                                    q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(d3\ l1\ md\ Sin[
                                    q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]]}], ")"}]}]}], ")"}]}], " ", 
                  RowBox[{"(", 
                    RowBox[{
                      
                      RowBox[{\(-\((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                              d3\ l4\ md\ Cos[q3[t]] + 
                              d2\ l1\ mc\ Sin[q2[t]] + 
                              l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), 
                            "+", 
                            RowBox[{
                            "d3", " ", "md", 
                              " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                  l4\ Sin[q3[t]])\), " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "-", 
                            RowBox[{"dD", " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], "+", 
                      
                      RowBox[{\((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), 
                            "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
                            
                            RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[
                                      q2[t]] - d3\ l4\ md\ Sin[q3[t]])\), " ",
                               
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "-", 
                            RowBox[{"dC", " ", 
                              RowBox[{
                                SuperscriptBox["q3", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{
                                SuperscriptBox["q3", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "+", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{"dD", " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                
                RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                              d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                            d2\ l1\ mc\ Sin[q2[t]] + 
                            l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - 
                            d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                            d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                  RowBox[{"(", 
                    RowBox[{
                      RowBox[{
                        RowBox[{"-", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", 
                                FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], "-",
                               
                              FractionBox[\(d1\^2\ mb\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              FractionBox[\(l1\^2\ mc\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              FractionBox[\(l1\^2\ md\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              FractionBox[
                                RowBox[{
                                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              FractionBox[
                                RowBox[{
                                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              FractionBox[
                                RowBox[{
                                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\),
                                   " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{
                                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\),
                                   " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              FractionBox[
                                RowBox[{"B33", " ", "\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                              FractionBox[
                                
                                RowBox[{\(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                  " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                              FractionBox[
                                
                                RowBox[{\(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                  " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                              FractionBox[
                                
                                RowBox[{\(l1\^2\), " ", "md", " ", "\[Mu]", 
                                  " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}], 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                              
                              FractionBox[\(d2\ l1\ mc\ Sin[
                                    q1[t] - q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              
                              FractionBox[\(l1\ l4\ md\ Sin[
                                    q1[t] - q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(d2\ l1\ mc\ Sin[
                                    q1[t] + q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(l1\ l4\ md\ Sin[
                                    q1[t] + q2[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "-", 
                              
                              FractionBox[\(d3\ l1\ md\ Sin[
                                    q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]], "+", 
                              
                              FractionBox[\(d3\ l1\ md\ Sin[
                                    q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]]}], ")"}]}], " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), 
                            "+", 
                            RowBox[{
                            "d3", " ", "md", 
                              " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                  l4\ Sin[q3[t]])\), " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "-", 
                            RowBox[{"dD", " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], "+", 
                      
                      RowBox[{\((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                        RowBox[{"(", 
                          RowBox[{
                            FractionBox[\(d1\ g\ mb\ Cos[q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[\(g\ l1\ mc\ Cos[q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[\(g\ l1\ md\ Cos[q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d1\ g\ mb\ Cos[2\ q1[t] + q4[t]]\), 
                              
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(g\ l1\ mc\ Cos[2\ q1[t] + q4[t]]\), 
                              
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(g\ l1\ md\ Cos[2\ q1[t] + q4[t]]\), 
                              
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d1", " ", "g", " ", "ma", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "g", " ", "l2", " ", "ma", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d1", " ", "g", " ", "mb", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "g", " ", "l1", " ", "mc", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "g", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d1", " ", "g", " ", "mh", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "g", " ", "l2", " ", "mh", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d1", " ", "g", " ", "mb", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "g", " ", "l1", " ", "mc", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "g", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                    d3\ md\ Cos[q2[t] + q3[t]])\), 
                                " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "\[Mu]", 
                                " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                    d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q1[t] + q4[t]]\),
                                 " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "dB", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d2", " ", "l1", " ", "mc", 
                                " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", 
                                " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d2", " ", "l1", " ", "mc", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", 
                                " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", 
                                " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "\[Mu]", 
                                " ", \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                    d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q1[t] + q4[t]]\),
                                 " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "dC", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{"dC", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q1[t] + q4[t]]\),
                                 " ", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", 
                                " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 " ", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", 
                                " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 " ", 
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", 
                                " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", 
                                " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{
                                "2", " ", "l1", " ", \(Cos[q1[t] + q4[t]]\), 
                                  " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      
                                      RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{
                                      "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                              RowBox[{"(", 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                            "-", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{"2", " ", "l1", " ", "\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      
                                      RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{
                                      "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                              RowBox[{"(", 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                            "+", 
                            FractionBox[
                              RowBox[{"\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q1[t] + q4[t]]\),
                                 " ", 
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 " ", 
                                RowBox[{"(", 
                                  RowBox[{"dB", "-", 
                                    RowBox[{
                                    "2", " ", "d3", " ", "l1", " ", "md", 
                                      " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "Aa", " ", "Cd", " ", "d1", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["y", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["y", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "Aa", " ", "Cd", " ", "l2", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["y", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], " ", \(Sin[q4[t]]\), " ", 
                                SuperscriptBox[
                                  RowBox[{
                                    SuperscriptBox["y", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "2"]}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{
                                "d1", " ", "ma", " ", \(Sec[q1[t] + q4[t]]\), 
                                  " ", \(Sin[q4[t]]\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      
                                      RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                                        
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                      RowBox[{
                                      "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                              RowBox[{"(", 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                            "+", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{
                                "l2", " ", "ma", " ", \(Sec[q1[t] + q4[t]]\), 
                                  " ", \(Sin[q4[t]]\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      
                                      RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                                        
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                      RowBox[{
                                      "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                              RowBox[{"(", 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                            "-", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{
                                "d1", " ", "mh", " ", \(Sec[q1[t] + q4[t]]\), 
                                  " ", \(Sin[q4[t]]\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      
                                      RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                                        
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                      RowBox[{
                                      "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                              RowBox[{"(", 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                            "+", 
                            RowBox[{
                              RowBox[{"(", 
                                RowBox[{
                                "l2", " ", "mh", " ", \(Sec[q1[t] + q4[t]]\), 
                                  " ", \(Sin[q4[t]]\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      
                                      RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                                        
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                      RowBox[{
                                      "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                              RowBox[{"(", 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
          ")"}], "/", 
        RowBox[{"(", 
          
          RowBox[{\((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
            RowBox[{"(", 
              RowBox[{
                
                RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                              d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                            d2\ l1\ mc\ Sin[q2[t]] + 
                            l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - 
                            d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                            d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                  RowBox[{"(", 
                    RowBox[{
                      
                      RowBox[{\((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              FractionBox[
                                RowBox[{
                                "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\),
                                   " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]]}], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] - q2[t] - q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] + q2[t] + q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]]}], ")"}]}], "-", 
                      RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], "-", 
                            FractionBox[\(d1\^2\ mb\ Cos[q1[t] + q4[t]]\), 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[\(l1\^2\ mc\ Cos[q1[t] + q4[t]]\), 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[\(l1\^2\ md\ Cos[q1[t] + q4[t]]\), 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{"B33", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              
                              RowBox[{\(d1\^2\), " ", "mb", " ", "\[Mu]", " ",
                                 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              
                              RowBox[{\(l1\^2\), " ", "mc", " ", "\[Mu]", " ",
                                 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              
                              RowBox[{\(l1\^2\), " ", "md", " ", "\[Mu]", " ",
                                 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            
                            FractionBox[\(d2\ l1\ mc\ Sin[
                                  q1[t] - q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(l1\ l4\ md\ Sin[
                                  q1[t] - q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d2\ l1\ mc\ Sin[
                                  q1[t] + q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(l1\ l4\ md\ Sin[
                                  q1[t] + q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] - q2[t] - q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] + q2[t] + q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]]}], ")"}]}]}], ")"}]}], "-", 
                
                RowBox[{\((\(-\((\(-D33\) + d3\^2\ md)\)\)\ \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                            d2\ l1\ mc\ Sin[q2[t]] + 
                            l1\ l4\ md\ Sin[q2[t]])\) - 
                      d3\ l4\ md\ Cos[
                          q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                  RowBox[{"(", 
                    RowBox[{
                      
                      RowBox[{\((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              FractionBox[
                                RowBox[{
                                "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                  " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}]}], 
                                RowBox[{"2", " ", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                    ")"}]}]]}], "-", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(d2\ l1\ mc\ Sin[
                                  q1[t] - q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(l1\ l4\ md\ Sin[
                                  q1[t] - q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d2\ l1\ mc\ Sin[
                                  q1[t] + q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(l1\ l4\ md\ Sin[
                                  q1[t] + q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] - q2[t] - q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] + q2[t] + q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]]}], ")"}]}], "-", 
                      
                      RowBox[{\((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]])\), " ", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{"-", 
                              FractionBox[\(B33\ Cos[q1[t] + q4[t]]\), 
                                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                  RowBox[{"\[Mu]", " ", 
                                    RowBox[{"Sign", "[", 
                                      RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                    " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], "-", 
                            FractionBox[\(d1\^2\ mb\ Cos[q1[t] + q4[t]]\), 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[\(l1\^2\ mc\ Cos[q1[t] + q4[t]]\), 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[\(l1\^2\ md\ Cos[q1[t] + q4[t]]\), 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{
                              "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                " ", \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}]}], 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            FractionBox[
                              RowBox[{"B33", " ", "\[Mu]", " ", 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              
                              RowBox[{\(d1\^2\), " ", "mb", " ", "\[Mu]", " ",
                                 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              
                              RowBox[{\(l1\^2\), " ", "mc", " ", "\[Mu]", " ",
                                 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+", 
                            FractionBox[
                              
                              RowBox[{\(l1\^2\), " ", "md", " ", "\[Mu]", " ",
                                 
                                RowBox[{"Sign", "[", 
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "]"}], 
                                " ", \(Sin[q1[t] + q4[t]]\)}], 
                              RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                RowBox[{"\[Mu]", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "]"}], 
                                  " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-", 
                            
                            FractionBox[\(d2\ l1\ mc\ Sin[
                                  q1[t] - q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(l1\ l4\ md\ Sin[
                                  q1[t] - q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d2\ l1\ mc\ Sin[
                                  q1[t] + q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(l1\ l4\ md\ Sin[
                                  q1[t] + q2[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "-", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] - q2[t] - q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]], "+", 
                            
                            FractionBox[\(d3\ l1\ md\ Sin[
                                  q1[t] + q2[t] + q3[t] + q4[t]]\), 
                              RowBox[{"2", " ", 
                                RowBox[{"(", 
                                  RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                      " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                  ")"}]}]]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
          ")"}]}], "+", 
      RowBox[{
        RowBox[{"(", 
          RowBox[{\((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{
                      
                      RowBox[{\(-\((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                              d3\ l4\ md\ Cos[q3[t]] + 
                              d2\ l1\ mc\ Sin[q2[t]] + 
                              l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), 
                            "+", 
                            RowBox[{
                            "d3", " ", "md", 
                              " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                  l4\ Sin[q3[t]])\), " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "-", 
                            RowBox[{"dD", " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}], "+", 
                      
                      RowBox[{\((\(-D33\) + d3\^2\ md + 
                            d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), 
                            "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
                            
                            RowBox[{\((l1\ \((d2\ mc + l4\ md)\)\ Cos[
                                      q2[t]] - d3\ l4\ md\ Sin[q3[t]])\), " ",
                               
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "-", 
                            RowBox[{"dC", " ", 
                              RowBox[{
                                SuperscriptBox["q3", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{
                                SuperscriptBox["q3", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                            "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                              " ", 
                              SuperscriptBox[
                                RowBox[{
                                  SuperscriptBox["q3", "\[Prime]",
                                    MultilineFunction->None], "[", "t", "]"}],
                                 "2"]}], "+", 
                            RowBox[{
                            "2", " ", "d3", " ", "l4", " ", "md", 
                              " ", \(Sin[q3[t]]\), " ", 
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}], 
                              " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], "+", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{"dD", " ", 
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "t", 
                                "]"}]}]}], ")"}]}]}], ")"}], 
                  "/", \((\(-\((\(-D33\) + d3\^2\ md + 
                              d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                            d2\ l1\ mc\ Sin[q2[t]] + 
                            l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                            d2\^2\ mc - l4\^2\ md - 
                            d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                            d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                            d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\)}], "-", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{\((\(-\((\(-D33\) + d3\^2\ md)\)\)\ \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) - 
                          d3\ l4\ md\ Cos[
                              q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            RowBox[{"-", 
                              RowBox[{"(", 
                                RowBox[{
                                  
                                  RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                    " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                                  
                                  RowBox[{\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", 
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                        "-", 
                                        
                                        FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}], " ", 
                            RowBox[{"(", 
                              RowBox[{
                                
                                RowBox[{\(-\((\(-C33\) - d2\^2\ mc - 
                                        l4\^2\ md - d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                                  RowBox[{"(", 
                                    
                                    RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                      RowBox[{
                                      "d3", " ", "md", 
                                        " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{
                                      "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{
                                      "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                      RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                  
                                  RowBox[{"(", 
                                    
                                    RowBox[{\(\(-d2\)\ g\ mc\ Sin[
                                        q1[t] + q2[t]]\), 
                                      "-", \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), 
                                      "-", 
                                      
                                      RowBox[{\((l1\ \((d2\ mc + 
                                        l4\ md)\)\ Cos[q2[t]] - 
                                        d3\ l4\ md\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{
                                      "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                      RowBox[{"dC", " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{
                                      "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{
                                      "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{
                                      "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                      RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                          
                          RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                      d2\^2\ mc - l4\^2\ md - 
                                      d3\ l4\ md\ Cos[q3[t]] + 
                                      d2\ l1\ mc\ Sin[q2[t]] + 
                                      l1\ l4\ md\ Sin[
                                        q2[t]])\) + \((\(-C33\) - d2\^2\ mc - 
                                      l4\^2\ md - 
                                      d3\ l4\ md\ Cos[
                                        q3[t]])\)\ \((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                            " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                        "-", 
                                        FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                         
                                        FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                         
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                        
                                        FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], " ", 
                                  RowBox[{"(", 
                                    
                                    RowBox[{\(d3\ g\ md\ Sin[
                                        q1[t] + q2[t] + q3[t]]\), "+", 
                                      RowBox[{
                                      "d3", " ", "md", 
                                        " ", \((l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                      RowBox[{
                                      "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{
                                      "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                      RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                  
                                  RowBox[{"(", 
                                    RowBox[{
                                      FractionBox[\(d1\ g\ mb\ Cos[q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[\(g\ l1\ mc\ Cos[q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[\(g\ l1\ md\ Cos[q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d1\ g\ mb\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(g\ l1\ mc\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(g\ l1\ md\ Cos[
                                        2\ q1[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "ma", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "g", " ", "l2", " ", "ma", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "mh", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "g", " ", "l2", " ", "mh", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d1", " ", "g", " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "g", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[2\ q1[t] + q4[t]]\)}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "dB", " ", \(Cos[q1[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "\[Mu]", 
                                        " ", \((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "dC", " ", \(Cos[q1[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{"dC", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", 
                                        " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "-", 
                                      RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((\((d2\ mc + l4\ md)\)\ Cos[
                                        q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                      FractionBox[
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{"dB", "-", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "d1", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "l2", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "d1", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "l2", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                      RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "ma", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "-", 
                                      RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}], "+", 
                                      RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "mh", 
                                        " ", \(Sec[q1[t] + q4[t]]\), 
                                        " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", 
                                        "\[Prime]\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}]}], 
                        ")"}]}], ")"}], "/", 
                  RowBox[{"(", 
                    
                    RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                  d3\ l4\ md\ Cos[q3[t]])\)\)\ \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) + \((\(-C33\) - 
                                d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]])\)\ \((\(-D33\) + 
                                d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          
                          RowBox[{\((\(-\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[
                                        q3[t]])\)\)\ \((\(-C33\) - 
                                      d2\^2\ mc - l4\^2\ md - 
                                      d3\ l4\ md\ Cos[q3[t]] + 
                                      d2\ l1\ mc\ Sin[q2[t]] + 
                                      l1\ l4\ md\ Sin[
                                        q2[t]])\) + \((\(-C33\) - d2\^2\ mc - 
                                      l4\^2\ md - 
                                      d3\ l4\ md\ Cos[
                                        q3[t]])\)\ \((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                            " ", 
                            RowBox[{"(", 
                              RowBox[{
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                  
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                                RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                      "-", 
                                      
                                      FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}], "-", 
                          
                          RowBox[{\((\(-\((\(-D33\) + 
                                        d3\^2\ md)\)\)\ \((\(-C33\) - 
                                      d2\^2\ mc - l4\^2\ md - 
                                      d3\ l4\ md\ Cos[q3[t]] + 
                                      d2\ l1\ mc\ Sin[q2[t]] + 
                                      l1\ l4\ md\ Sin[q2[t]])\) - 
                                d3\ l4\ md\ Cos[
                                    q3[t]]\ \((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                            " ", 
                            RowBox[{"(", 
                              RowBox[{
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]] - 
                                      d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                                  
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}], "-", 
                                
                                RowBox[{\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{"-", 
                                        
                                        FractionBox[\(B33\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]]}], 
                                      "-", 
                                      
                                      FractionBox[\(d1\^2\ mb\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ mc\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(l1\^2\ md\ Cos[
                                        q1[t] + q4[t]]\), 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", 
                                        " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      FractionBox[
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(d1\^2\), " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "+",
                                       
                                      FractionBox[
                                        
                                        RowBox[{\(l1\^2\), " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}], 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}]], "-",
                                       
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] - q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d2\ l1\ mc\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(l1\ l4\ md\ Sin[
                                        q1[t] + q2[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "-", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]], "+", 
                                      
                                      FractionBox[\(d3\ l1\ md\ Sin[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], 
                                        " ", \(Sin[q1[t] + q4[t]]\)}]}], 
                                        ")"}]}]]}], ")"}]}]}], ")"}]}]}], 
                        ")"}]}], ")"}]}]}], ")"}]}], ")"}], 
        "/", \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
            d3\ l1\ md\ Sin[q2[t] + q3[t]])\)}]}]], "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solve and Interpret", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[{
  StyleBox["********NOTE********",
    FontColor->RGBColor[1, 0, 0]],
  "\nWhen running this simulation make changes in this section and execute \
this section as many times as needed to get the results. The steps above need \
only be executed during the first pass through the notebook. "
}], "Text"],

Cell[TextData[{
  "Define the constants.  ",
  StyleBox["Use consistent units",
    FontSlant->"Italic",
    FontVariations->{"Underline"->True}],
  StyleBox[".",
    FontSlant->"Italic",
    FontVariations->{"Underline"->True}]
}], "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PICT", "\<\
000000000A<1M@0A0_l<0?on0000B00004P0000000014`5e0000000N00402P00
00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
00400000000000000000040000000000000000000000@00000014`5e00030000
00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
M6lPLfEU87AXJG<PL6USM7EbIBh0003o\>"], "Graphics",
  ImageSize->{373, 275},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*Body\ A\ and\ the\ horse*) \)\(\[IndentingNewLine]\)\(\(l3 = 
        15;\)\n
    \(ma = 1;\)\ \  (*mass\ of\ sling\ and\ rope*) \[IndentingNewLine]
    \(mh = 100;\)\ \  (*mass\ of\ horse*) \n
    \(rH = 0.5\ ;\)\  (*"\<radius of horse\>"*) \[IndentingNewLine]
    \(Cd = 0.0;\)\  (*coefficient\ of\ drag*) \[IndentingNewLine]
    \(Aa = \[Pi]\ rH^2;\)\  (*cross - 
        sectional\ area*) \[IndentingNewLine]\[IndentingNewLine] (*Body\ B\
*) \[IndentingNewLine]
    \(l1 = 5;\)\n
    \(l2 = 10;\)\n
    \(d1 = 2.5;\)\n
    \(mb = 100;\)\n
    \(B33 = 1\/12\ mb\ \((l1 + l2)\)\^2;\)\n
    \(dB = 
        1.0;\)\ \  (*joint\ friction*) \[IndentingNewLine]\[IndentingNewLine] \
(*Body\ C*) \[IndentingNewLine]
    \(l4 = 2.55;\)\n
    \(d2 = l4/2;\)\n
    \(mc = 20;\)\n
    \(C33 = 1\/12\ mc\ l4\^2;\)\n
    \(dC = 
        500.0;\)\ \  (*joint\ friction*) \[IndentingNewLine]\
\[IndentingNewLine] (*Body\ D*) \[IndentingNewLine]
    \(d3 = 0.5;\)\n
    \(md = 500;\)\n
    \(boxH = 2;\)\ \  (*rock\ box\ height*) \n
    \(boxL = 3;\)\ \  (*rock\ box\ length*) \n
    \(D33 = 1\/12\ md\ \((boxL\^2 + boxH\^2)\);\)\n
    \(dD = 
        500.0;\)\  (*joint\ friction*) \[IndentingNewLine]\[IndentingNewLine] \
(*Height, \ friction\ coefficient, \ and\ gravity*) \[IndentingNewLine]
    \(H = l1 + l4 + d3\  + \ boxH;\)\[IndentingNewLine]
    \(\[Mu] = 0.5;\)\n
    \(g = 9.81;\)\)\)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(boxL\)\" is similar to \
existing symbol \"\!\(boxH\)\"."\)], "Message"]
}, Open  ]],

Cell["\<\
Clear the integration variables. It may complain if not initialized \
first time through, just ignore complaint.     \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(q1[t_] =. ;\)\), "\[IndentingNewLine]", 
    \(\(q2[t_] =. ;\)\), "\[IndentingNewLine]", 
    \(\(q3[t_] =. ;\)\), "\[IndentingNewLine]", 
    \(\(q4[t_] =. ;\)\), "\[IndentingNewLine]", 
    \(\(x[t_] =. ;\)\), "\[IndentingNewLine]", 
    \(\(y[t_] =. ;\)\), "\[IndentingNewLine]", 
    \(\(t =. ;\)\)}], "Input"],

Cell[BoxData[
    \(Unset::"norep" \(\(:\)\(\ \)\) 
      "Assignment on \!\(q1\) for \!\(q1[t_]\) not found."\)], "Message"],

Cell[BoxData[
    \(Unset::"norep" \(\(:\)\(\ \)\) 
      "Assignment on \!\(q2\) for \!\(q2[t_]\) not found."\)], "Message"],

Cell[BoxData[
    \(Unset::"norep" \(\(:\)\(\ \)\) 
      "Assignment on \!\(q3\) for \!\(q3[t_]\) not found."\)], "Message"],

Cell[BoxData[
    \(Unset::"norep" \(\(:\)\(\ \)\) 
      "Assignment on \!\(q4\) for \!\(q4[t_]\) not found."\)], "Message"],

Cell[BoxData[
    \(Unset::"norep" \(\(:\)\(\ \)\) 
      "Assignment on \!\(x\) for \!\(x[t_]\) not found."\)], "Message"],

Cell[BoxData[
    \(Unset::"norep" \(\(:\)\(\ \)\) 
      "Assignment on \!\(y\) for \!\(y[t_]\) not found."\)], "Message"]
}, Open  ]],

Cell["\<\
Initial conditions and release angle.  These can be adjusted per \
the given situation.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(W1o = 0;\)\n
    \(\(Q1o = \(-40\)\ \[Pi]/180;\)\(\n\)
    \)\[IndentingNewLine]
    \(W2o = 0;\)\n
    \(\(Q2o = 30\ \[Pi]/180;\)\(\n\)
    \)\[IndentingNewLine]
    \(W3o = 0;\)\n
    \(\(Q3o = 10\ \[Pi]/180;\)\(\[IndentingNewLine]\)
    \)\[IndentingNewLine]
    \(Vyo = 0;\)\n
    \(Yo = rH;\)\ \ \[IndentingNewLine]\n
    W4o = \(\(\(\(q4'\)[t] //. solDq4x[\([1]\)]\) //. 
          solq4x[\([3]\)]\)\(//.\)\({q1[t] \[Rule] Q1o, 
          y[t] \[Rule] Yo, \(q1'\)[t] \[Rule] W1o, \(y'\)[t] \[Rule] 
            Vyo}\)\(\ \ \)\( (*must\ satisfy\ the\ constraint*) \)\)\n
    \(\(Q4o = \(q4[t] //. solq4x[\([3]\)]\) //. {q1[t] \[Rule] Q1o, 
          y[t] \[Rule] 
            Yo}\)\(\ \ \)\( (*must\ satisfy\ the\ constraint*) \)\(\
\[IndentingNewLine]\)
    \)\[IndentingNewLine]
    Vxo = \(\(\(\(x'\)[t] //. solDq4x[\([1]\)]\) /. 
          solq4x[\([4]\)]\)\(//.\)\({q1[t] \[Rule] Q1o, 
          y[t] \[Rule] Yo, \(q1'\)[t] \[Rule] W1o, \(y'\)[t] \[Rule] 
            Vyo}\)\(\ \ \)\( (*must\ satisfy\ the\ constraint*) \)\)\n
    \(\(Xo = \(x[t] //. solq4x[\([3]\)]\) //. {q1[t] \[Rule] Q1o, 
          y[t] \[Rule] 
            Yo}\)\(\ \ \)\( (*must\ satisfy\ the\ constraint*) \)\(\n\)
    \)\[IndentingNewLine]
    \(q4R = \(-10\)\ \[Pi]/
            180;\)\)\(\ \ \)\( (*Release\ angle\ of\ the\ string . \ \ This\ \
is\ adjustable\ for\ optimal\ \(\(performance\)\(.\)\)*) \)\)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(0\)], "Output"],

Cell[BoxData[
    \(\(-2.233786397790948`\)\)], "Output"],

Cell[BoxData[
    \(0\)], "Output"],

Cell[BoxData[
    \(7.0110361462255595`\)], "Output"]
}, Open  ]],

Cell["\<\
Numerical solution to the equations of motion.  This switches \
regimes based on the normal force then the string angle relative to the arm \
for release.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[{
    RowBox[{\(tf = 1.0;\), 
      " ", \( (*estimate\ the\ final\ time, \ 
        the\ integrator\ stops\ when\ the\ horse\ hits\ ground*) \)}], "\
\[IndentingNewLine]", 
    RowBox[{\(nIntPnts = 50000\ tf;\), 
      " ", \( (*number\ of\ entry\ points\ for\ integrator*) \)}], "\
\[IndentingNewLine]", 
    RowBox[{\(tip1 = tf/nIntPnts;\), 
      " ", \( (*time\ divisions\ for\ integrator\ stepping*) \)}], "\n", 
    RowBox[{\(ti = 0.0;\), " ", \( (*initial\ time*) \)}], "\n", 
    RowBox[{\(dt = tip1/2;\), 
      " ", \( (*outer\ loop\ time\ division*) \)}], "\n", 
    RowBox[{\(dts = dt/5;\), 
      " ", \( (*small\ time\ division\ for\ table*) \)}], \
"\[IndentingNewLine]", 
    RowBox[{\(\(pntdiv = 
          5;\)\(\ \)\( (*number\ of\ points\ at\ each\ integration\ step*) \)\
\), "\n"}], "\n", 
    RowBox[{\(flag = 0;\), \( (*first\ pass\ flag, \ 
        used\ to\ initiate\ table\ of\ data, \ 
        do\ not\ change*) \)}], "\[IndentingNewLine]", 
    RowBox[{\(flagNa = 0;\), 
      " ", \( (*flag\ for\ using\ constrained\ equations, \ 
        do\ not\ change*) \)}], "\n", 
    RowBox[{\(flagQr\  = \ 
          0;\), \( (*flag\ for\ using\ swinging\ equations, \ 
        do\ not\ change*) \)}], "\n", 
    RowBox[{\(dbFlag\  = \ 0;\), 
      " ", \( (*print\ debugging\ messages\ when\ dbFlag = 1, \ 
        none\ otherwise*) \), "\[IndentingNewLine]", 
      "\[IndentingNewLine]", \( (*main\ loop, \ 
        ends\ at\ tf\ or\ when\ the\ horse\ hits\ the\ ground \((y[t] = 
              0)\)*) \)}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"While", "[", 
        RowBox[{\(ti \[LessEqual] tf && \ Yo \[GreaterEqual] 0\), ",", "\n", 
          "\[IndentingNewLine]", "       ", 
          
          RowBox[{\(If[flag \[Equal] 0, NaHold = \((ma + mh)\)\ g, 
              NaHold = First[Na[ti] /. sol]]\), ";", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            "     ", \( (*next\ we\ set\ which\ eom\ to\ use, \ 
              depends\ on\ the\ motion\ \(regime : \ dragging\), \ 
              swinging, \ free*) \), "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            "      ", \(If[
              NaHold > 0\  && \ 
                flagNa \[Equal] 
                  0, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ If[dbFlag \[Equal] 
                  1, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ Print["\<Na[\>", ti, "\<]=\>", 
                  NaHold]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ Print["\<q1[\>", ti, "\<]=\>", 
                  q1h[ti]]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ Print["\<q4[\>", ti, "\<]=\>", 
                  q4h[ti]]]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ sol = \ NDSolve[{eom1d == 0, eom2d == 0, eom3d == 0, eom4d == 0, 
                    eom5d == 0, 
                    eom6d == 0, \(q1'\)[0] == W1o, \(q2'\)[0] == 
                      W2o, \(q3'\)[0] == W3o, \(q4'\)[0] == 
                      W4o, \(x'\)[0] \[Equal] Vxo, \(y'\)[0] \[Equal] Vyo, 
                    q1[0] == Q1o, q2[0] == Q2o, q3[0] == Q3o, q4[0] == Q4o, 
                    x[0] \[Equal] Xo, y[0] \[Equal] Yo}, {q1, q2, q3, q4, x, 
                    y}, {t, ti, 
                    tip1}], \[IndentingNewLine]\ \ \  (*else\
*) \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ If[
                q4h[ti] \[LessEqual] q4R\  && \ 
                  flagQr \[Equal] 
                    0, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ If[dbFlag \[Equal] 
                    1, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ Print["\<q1[\>", ti, "\<]=\>", 
                    q1h[ti]]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ Print["\<q4[\>", ti, "\<]=\>", 
                    q4h[ti]]]; \ \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ flagNa = 
                  1; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ sol = NDSolve[{eom1s == 0, eom2s == 0, eom3s == 0, eom4s == 0, 
                      eom5s == 0, 
                      eom6s == 0, \(q1'\)[0] == W1o, \(q2'\)[0] == 
                        W2o, \(q3'\)[0] == W3o, \(q4'\)[0] == 
                        W4o, \(x'\)[0] \[Equal] Vxo, \(y'\)[0] \[Equal] Vyo, 
                      q1[0] == Q1o, q2[0] == Q2o, q3[0] == Q3o, q4[0] == Q4o, 
                      x[0] \[Equal] Xo, y[0] \[Equal] Yo}, {q1, q2, q3, q4, 
                      x, y}, {t, ti, 
                      tip1}], \[IndentingNewLine]\ \ \ \ \ \  (*else\
*) \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ If[dbFlag \[Equal] 1, \ 
                  Print["\<t=\>", 
                    ti]]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ flagQr \
= 1; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ sol = 
                  NDSolve[{eom1f == 0, eom2f == 0, eom3f == 0, eom4f == 0, 
                      eom5f == 0, 
                      eom6f == 0, \(q1'\)[0] == W1o, \(q2'\)[0] == 
                        W2o, \(q3'\)[0] == W3o, \(q4'\)[0] == 
                        W4o, \(x'\)[0] \[Equal] Vxo, \(y'\)[0] \[Equal] Vyo, 
                      q1[0] == Q1o, q2[0] == Q2o, q3[0] == Q3o, q4[0] == Q4o, 
                      x[0] \[Equal] Xo, y[0] \[Equal] Yo}, {q1, q2, q3, q4, 
                      x, y}, {t, ti, tip1}]]]\), ";", "\n", "\t", "\n", 
            "\t", \(q1h[t_] = First[q1[t] /. sol]\), ";", 
            " ", \( (*build\ solutions\ for\ this\ time\ step*) \), "\n", 
            "           ", \(q2h[t_] = First[q2[t] /. sol]\), ";", "\n", 
            "\t", \(q3h[t_] = First[q3[t] /. sol]\), ";", "\n", 
            "\t", \(q4h[t_] = First[q4[t] /. sol]\), ";", "\n", 
            "\t", \(q5h[t_] = First[q6[t] /. sol]\), ";", "\n", 
            "\t", \(q7h[t_] = First[q7[t] /. sol]\), ";", "\n", 
            "\t", \(xh[t_] = First[x[t] /. sol]\), ";", "\n", 
            "\t", \(yh[t_] = First[y[t] /. sol]\), ";", "\[IndentingNewLine]",
             "\[IndentingNewLine]", \( (*\ 
              re - assign\ temp\ variables\ for\ use\ in\ normal\ force\ \
calculation*) \), "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "        ", \(q1[t_] = q1h[t]\), ";", "\n", 
            "           ", \(q2[t_] = q2h[t]\), ";", "\n", 
            "           ", \(q3[t_] = q3h[t]\), ";", "\n", 
            "           ", \(q4[t_] = q4h[t]\), ";", "\n", 
            "           ", \(x[t_] = xh[t]\), ";", "\n", 
            "           ", \(y[t_] = yh[t]\), ";", "\[IndentingNewLine]", 
            "\n", \(If[
              flag == 0, \[IndentingNewLine]\t (*first\ pass\
*) \[IndentingNewLine]\n\t\tq1tab = 
                Table[{t, q1[t]}, {t, ti, 
                    tip1, \(tip1 - ti\)\/pntdiv}]; \n\t\tq2tab = 
                Table[{t, q2[t]}, {t, ti, 
                    tip1, \(tip1 - ti\)\/pntdiv}]; \n\t\tq3tab = 
                Table[{t, q3[t]}, {t, ti, 
                    tip1, \(tip1 - ti\)\/pntdiv}]; \n\t\tq4tab = 
                Table[{t, q4[t]}, {t, ti, 
                    tip1, \(tip1 - ti\)\/pntdiv}]; \n\t\txtab = 
                Table[{t, x[t]}, {t, ti, 
                    tip1, \(tip1 - ti\)\/pntdiv}]; \n\t\tytab = 
                Table[{t, y[t]}, {t, ti, 
                    tip1, \(tip1 - ti\)\/pntdiv}]; \n\t\tflag = 
                1;, \n (*else*) \[IndentingNewLine]\t\n\t\tq1tab = 
                Join[q1tab, 
                  Table[{t, q1[t]}, {t, ti + dts, 
                      tip1, \(tip1 - ti\)\/pntdiv}]]; \n\t\tq2tab = 
                Join[q2tab, 
                  Table[{t, q2[t]}, {t, ti + dts, 
                      tip1, \(tip1 - ti\)\/pntdiv}]]; \n\t\tq3tab = 
                Join[q3tab, 
                  Table[{t, q3[t]}, {t, ti + dts, 
                      tip1, \(tip1 - ti\)\/pntdiv}]]; \n\t\tq4tab = 
                Join[q4tab, 
                  Table[{t, q4[t]}, {t, ti + dts, 
                      tip1, \(tip1 - ti\)\/pntdiv}]]; \n\t\txtab = 
                Join[xtab, 
                  Table[{t, x[t]}, {t, ti + dts, 
                      tip1, \(tip1 - ti\)\/pntdiv}]]; \n\t\tytab = 
                Join[ytab, 
                  Table[{t, y[t]}, {t, ti + dts, 
                      tip1, \(tip1 - ti\)\/pntdiv}]];]\), ";", 
            "\[IndentingNewLine]", "\t\t", 
            "\n", \( (*new\ initial\ data\ for\ next\ integration\ step*) \), 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "      ", \(Q1o = q1[tip1]\), ";", " ", "\n", 
            "         ", \(Q2o = q2[tip1]\), ";", "\n", 
            "         ", \(Q3o = q3[tip1]\), ";", "\n", 
            "         ", \(Q4o = q4[tip1]\), ";", "\n", 
            "         ", \(Xo = x[tip1]\), ";", "\n", 
            "         ", \(Yo = y[tip1]\), ";", "\n", "         ", 
            RowBox[{"W1o", "=", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", "\n", 
            "         ", 
            RowBox[{"W2o", "=", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", "\n", 
            "         ", 
            RowBox[{"W3o", "=", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            "\[IndentingNewLine]", "      ", 
            RowBox[{"W4o", "=", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", "\n", 
            "         ", 
            RowBox[{"Vxo", "=", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", "\n", 
            "         ", 
            RowBox[{"Vyo", "=", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            "\[IndentingNewLine]", "\n", 
            "    ", \( (*reset\ the\ variables\ for\ integration\ over\ the\ \
next\ time\ step*) \), "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "          ", \(q1[t_] =. \), ";", "\[IndentingNewLine]", 
            "          ", \(q2[t_] =. \), ";", "\[IndentingNewLine]", 
            "          ", \(q3[t_] =. \), ";", "\[IndentingNewLine]", 
            "          ", \(q4[t_] =. \), ";", "\[IndentingNewLine]", 
            "          ", \(x[t_] =. \), ";", "\[IndentingNewLine]", 
            "          ", \(y[t_] =. \), ";", "\[IndentingNewLine]", 
            "          ", \(t =. \), ";", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            "     ", \( (*increment\ the\ time\ counters, \ 
              step\ smaller\ near\ release*) \), "\[IndentingNewLine]", 
            "\t", \(If[
              Abs[Abs[q4h[ti]] - \ Abs[q4R]] > 
                0.5, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ If[
                dbFlag \[Equal] 1, 
                Print["\<diff=\>", 
                  Abs[q4h[ti]] - 
                    Abs[q4R]]]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \
ti = tip1; \n\t\ \ \ \ \ \ \ \ tip1 = 
                tip1 + dt;, \[IndentingNewLine] (*else*) \[IndentingNewLine]\ \
\ \ \ \ \ \ \ \ \ \ \ \ ti = 
                tip1; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ If[
                dbFlag \[Equal] 1, 
                Print["\<near release, diff=\>", 
                  Abs[q4h[ti]] - 
                    Abs[q4R]]]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \
tip1 = tip1 + dt/100]\)}]}], "]"}], "\n", 
      "\n", \( (*build\ the\ final\ solutions\ as\ functions\ for\ plotting\ \
etc, \ also\ record\ time\ of\ final\ step*) \)}], "\n", \(q1final[
          t_] := \(Interpolation[q1tab, InterpolationOrder \[Rule] 3]\)[
          t];\), "\n", \(q2final[
          t_] := \(Interpolation[q2tab, InterpolationOrder \[Rule] 3]\)[
          t];\), "\n", \(q3final[
          t_] := \(Interpolation[q3tab, InterpolationOrder \[Rule] 3]\)[
          t];\), "\n", \(q4final[
          t_] := \(Interpolation[q4tab, InterpolationOrder \[Rule] 3]\)[
          t];\), "\n", \(xfinal[
          t_] := \(Interpolation[xtab, InterpolationOrder \[Rule] 3]\)[
          t];\), "\n", \(yfinal[
          t_] := \(Interpolation[ytab, InterpolationOrder \[Rule] 3]\)[
          t];\), "\[IndentingNewLine]", \(tf = ti;\)}], "Input",
  AspectRatioFixed->True],

Cell["Plot the coordinates for each degree of freedom.", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PICT", "\<\
000000000A<1M@0A0_l<0?on0000B00004P0000000014`5e0000000N00402P00
00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
00400000000000000000040000000000000000000000@00000014`5e00030000
00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
M6lPLfEU87AXJG<PL6USM7EbIBh0003o\>"], "Graphics",
  ImageSize->{373, 275},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q1final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 92.3888 0.156966 0.20376 [
[.20859 .14447 -15 -9 ]
[.20859 .14447 15 0 ]
[.39336 .14447 -15 -9 ]
[.39336 .14447 15 0 ]
[.57814 .14447 -15 -9 ]
[.57814 .14447 15 0 ]
[.76292 .14447 -15 -9 ]
[.76292 .14447 15 0 ]
[.9477 .14447 -12 -9 ]
[.9477 .14447 12 0 ]
[.01131 .05509 -24 -4.5 ]
[.01131 .05509 0 4.5 ]
[.01131 .25885 -18 -4.5 ]
[.01131 .25885 0 4.5 ]
[.01131 .36073 -6 -4.5 ]
[.01131 .36073 0 4.5 ]
[.01131 .46261 -18 -4.5 ]
[.01131 .46261 0 4.5 ]
[.01131 .56449 -6 -4.5 ]
[.01131 .56449 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20859 .15697 m
.20859 .16322 L
s
[(0.002)] .20859 .14447 0 1 Mshowa
.39336 .15697 m
.39336 .16322 L
s
[(0.004)] .39336 .14447 0 1 Mshowa
.57814 .15697 m
.57814 .16322 L
s
[(0.006)] .57814 .14447 0 1 Mshowa
.76292 .15697 m
.76292 .16322 L
s
[(0.008)] .76292 .14447 0 1 Mshowa
.9477 .15697 m
.9477 .16322 L
s
[(0.01)] .9477 .14447 0 1 Mshowa
.125 Mabswid
.07 .15697 m
.07 .16072 L
s
.1162 .15697 m
.1162 .16072 L
s
.16239 .15697 m
.16239 .16072 L
s
.25478 .15697 m
.25478 .16072 L
s
.30098 .15697 m
.30098 .16072 L
s
.34717 .15697 m
.34717 .16072 L
s
.43956 .15697 m
.43956 .16072 L
s
.48575 .15697 m
.48575 .16072 L
s
.53195 .15697 m
.53195 .16072 L
s
.62434 .15697 m
.62434 .16072 L
s
.67053 .15697 m
.67053 .16072 L
s
.71673 .15697 m
.71673 .16072 L
s
.80911 .15697 m
.80911 .16072 L
s
.85531 .15697 m
.85531 .16072 L
s
.9015 .15697 m
.9015 .16072 L
s
.99389 .15697 m
.99389 .16072 L
s
.25 Mabswid
0 .15697 m
1 .15697 L
s
.02381 .05509 m
.03006 .05509 L
s
[(-0.5)] .01131 .05509 1 0 Mshowa
.02381 .25885 m
.03006 .25885 L
s
[(0.5)] .01131 .25885 1 0 Mshowa
.02381 .36073 m
.03006 .36073 L
s
[(1)] .01131 .36073 1 0 Mshowa
.02381 .46261 m
.03006 .46261 L
s
[(1.5)] .01131 .46261 1 0 Mshowa
.02381 .56449 m
.03006 .56449 L
s
[(2)] .01131 .56449 1 0 Mshowa
.125 Mabswid
.02381 .07546 m
.02756 .07546 L
s
.02381 .09584 m
.02756 .09584 L
s
.02381 .11621 m
.02756 .11621 L
s
.02381 .13659 m
.02756 .13659 L
s
.02381 .17734 m
.02756 .17734 L
s
.02381 .19772 m
.02756 .19772 L
s
.02381 .21809 m
.02756 .21809 L
s
.02381 .23847 m
.02756 .23847 L
s
.02381 .27922 m
.02756 .27922 L
s
.02381 .2996 m
.02756 .2996 L
s
.02381 .31997 m
.02756 .31997 L
s
.02381 .34035 m
.02756 .34035 L
s
.02381 .3811 m
.02756 .3811 L
s
.02381 .40148 m
.02756 .40148 L
s
.02381 .42185 m
.02756 .42185 L
s
.02381 .44223 m
.02756 .44223 L
s
.02381 .48298 m
.02756 .48298 L
s
.02381 .50336 m
.02756 .50336 L
s
.02381 .52373 m
.02756 .52373 L
s
.02381 .54411 m
.02756 .54411 L
s
.02381 .03471 m
.02756 .03471 L
s
.02381 .01433 m
.02756 .01433 L
s
.02381 .58486 m
.02756 .58486 L
s
.02381 .60524 m
.02756 .60524 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .01472 m
.02499 .01472 L
.02605 .01472 L
.02729 .01472 L
.02846 .01472 L
.02954 .01472 L
.03053 .01472 L
.03163 .01472 L
.03279 .01472 L
.03395 .01472 L
.0352 .01472 L
.03628 .01472 L
.03746 .01472 L
.03818 .01472 L
.03884 .01472 L
.04016 .01472 L
.04135 .01472 L
.04262 .01472 L
.04519 .01472 L
.04589 .01472 L
.04664 .01472 L
.04797 .01472 L
.04923 .01472 L
.04992 .01472 L
.05058 .01472 L
.05185 .01472 L
.05302 .01472 L
.05406 .01472 L
.05517 .01472 L
.05639 .01472 L
.05751 .01472 L
.05864 .01472 L
.05986 .01472 L
.06055 .01472 L
.06119 .01472 L
.06244 .01473 L
.06373 .01473 L
.0649 .01473 L
.06555 .01473 L
.06625 .01473 L
.06752 .01473 L
.07225 .01474 L
.07783 .01476 L
.08048 .01476 L
.08178 .01477 L
.08297 .01477 L
.08538 .01478 L
.08797 .01479 L
.09347 .01482 L
.09885 .01486 L
Mistroke
.10458 .01491 L
.11445 .01502 L
.1236 .01516 L
.13449 .01539 L
.14434 .01567 L
.16363 .01645 L
.17448 .01702 L
.18446 .01768 L
.20332 .0194 L
.224 .02191 L
.24355 .02515 L
.26448 .02987 L
.28576 .03606 L
.30589 .04365 L
.34427 .06295 L
.36408 .07668 L
.3851 .09311 L
.42291 .13085 L
.46316 .18153 L
.5019 .24401 L
.52198 .28753 L
.53207 .31533 L
.54309 .35316 L
.56274 .40834 L
.58371 .45091 L
.60366 .4869 L
.61416 .50401 L
.62526 .51941 L
.63005 .52514 L
.63519 .52946 L
.63814 .53179 L
.64083 .53337 L
.64357 .53466 L
.64477 .53525 L
.64546 .53533 L
.6461 .53556 L
.6472 .53577 L
.64839 .536 L
.64965 .53611 L
.65082 .53612 L
.65201 .53606 L
.65332 .53588 L
.65398 .53575 L
.65468 .53568 L
.65595 .53518 L
.65716 .53485 L
.65847 .53433 L
.66084 .53302 L
.66529 .52955 L
.67017 .52471 L
Mistroke
.67474 .51831 L
.67975 .50916 L
.68514 .49653 L
.68645 .49089 L
.68718 .48913 L
.68784 .48775 L
.68862 .48424 L
.68936 .48049 L
.69004 .47709 L
.69078 .48231 L
.69142 .54798 L
.69213 .55458 L
.69283 .56004 L
.69357 .56537 L
.69426 .56961 L
.69489 .57032 L
.69613 .57745 L
.69742 .58062 L
.6986 .58347 L
.69988 .58731 L
.70061 .5882 L
.70129 .58884 L
.70253 .59087 L
.70366 .59179 L
.70487 .59227 L
.70618 .59257 L
.70746 .59243 L
.70867 .5921 L
.70975 .59136 L
.71092 .58992 L
.7122 .58878 L
.71339 .58724 L
.71463 .58392 L
.71529 .58337 L
.71599 .58173 L
.71727 .57715 L
.71847 .57262 L
.71956 .56857 L
.72074 .47684 L
.72184 .45179 L
.72301 .45151 L
.72412 .45151 L
.72512 .45166 L
.72642 .45212 L
.72707 .45237 L
.72779 .45296 L
.73025 .45528 L
.73312 .45904 L
.73579 .46313 L
.7371 .46507 L
Mistroke
.73832 .46688 L
.7396 .48153 L
.74028 .48943 L
.741 .48763 L
.74582 .47594 L
.75085 .45899 L
.75365 .45075 L
.75631 .44501 L
.75879 .44104 L
.75947 .43982 L
.76019 .43883 L
.76149 .43806 L
.76277 .4373 L
.76398 .43692 L
.76506 .43691 L
.76623 .43705 L
.76739 .43756 L
.76847 .4383 L
.76976 .43899 L
.77093 .43978 L
.77216 .44134 L
.77333 .4423 L
.7759 .44503 L
.78016 .44823 L
.78133 .44921 L
.78257 .44975 L
.78363 .45005 L
.7848 .45024 L
.78602 .45021 L
.78715 .44997 L
.78839 .44961 L
.78908 .44907 L
.78972 .44844 L
.79092 .44756 L
.7922 .44645 L
.79287 .44541 L
.7936 .4441 L
.79489 .44265 L
.79607 .43992 L
.79735 .43741 L
.79965 .43279 L
.80414 .42231 L
.80681 .41623 L
.80754 .41446 L
.80823 .4129 L
.80901 .41202 L
.80973 .41149 L
.81037 .41042 L
.81105 .40953 L
.8118 .40911 L
Mistroke
.81248 .40891 L
.8137 .40849 L
.81439 .40851 L
.81504 .40868 L
.81633 .40949 L
.81755 .41102 L
.81866 .41238 L
.81984 .41402 L
.82113 .41806 L
.82231 .42076 L
.82359 .42374 L
.82431 .42673 L
.82499 .43019 L
.82607 .43396 L
.82721 .438 L
.82845 .44618 L
.8296 .45261 L
.83395 .4848 L
.83633 .50858 L
.83895 .53689 L
.8413 .55491 L
.8435 .56954 L
.84415 .5732 L
.84486 .57498 L
.84614 .58339 L
.84739 .58721 L
.84855 .59093 L
.85118 .5985 L
.85182 .60035 L
.85251 .60156 L
.85327 .6021 L
.85398 .60272 L
.85516 .60328 L
.85645 .60291 L
.8571 .6022 L
.8578 .60184 L
.85906 .59865 L
.86031 .59616 L
.8615 .59264 L
.86257 .58716 L
.86372 .5804 L
.87416 .49844 L
.87913 .44765 L
.88157 .42544 L
.88379 .4091 L
.88614 .39589 L
.88745 .39019 L
.88867 .38426 L
.88999 .38124 L
.89068 .37851 L
Mistroke
.89142 .37617 L
.89213 .37508 L
.8928 .37418 L
.89404 .37144 L
.89536 .36997 L
.89608 .36915 L
.89676 .36884 L
.89795 .36832 L
.89926 .36829 L
.89999 .36853 L
.90068 .36902 L
.90198 .36974 L
.90271 .37074 L
.90338 .37196 L
.90412 .37268 L
.9049 .3736 L
.90604 .37665 L
.90728 .37956 L
.90979 .38788 L
.911 .39198 L
.91214 .39599 L
.91316 .40057 L
.91427 .4084 L
.9155 .41836 L
.91681 .42619 L
.91748 .43599 L
.91821 .44781 L
.91951 .46115 L
.92081 .48151 L
.92205 .49429 L
.92317 .50229 L
.92438 .51107 L
.92893 .53579 L
.93016 .54254 L
.93147 .54569 L
.9327 .54894 L
.93382 .55213 L
.93497 .55371 L
.93621 .55463 L
.93731 .55504 L
.93846 .55437 L
.9395 .55305 L
.94046 .55108 L
.94151 .54835 L
.94266 .54482 L
.94375 .53909 L
.94491 .52815 L
.94698 .50785 L
.94815 .49527 L
.94941 .47321 L
Mistroke
.95168 .44069 L
.95396 .41535 L
.95509 .4004 L
.95613 .3919 L
.95708 .38559 L
.95808 .38098 L
.9592 .37817 L
.96021 .37717 L
.96121 .37799 L
.96227 .38192 L
.96317 .38645 L
.96416 .39477 L
.96523 .40837 L
.96637 .4232 L
.96745 .44137 L
.96844 .46875 L
.97034 .52595 L
.97135 .54809 L
.97242 .57209 L
.97335 .58765 L
.97438 .60063 L
.97531 .60332 L
.97619 .6033 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`006oooool00ol0003oooooooooo`3oooooo`?ooooo000Kooooo`03o`000?oooooooooo0?oo
oooo0oooool001_ooooo00?o0000ooooooooool0ooooool3ooooo`006oooool00ol0003ooooooooo
o`3oooooo`?ooooo000Kooooob_o0000f_ooool001_ooooo00?o0000ooooooooool0:?ooool9o`00
0=7ooooo000Kooooo`03o`000?oooooooooo037ooooo1Ol0003<ooooo`006oooool00ol0003ooooo
ooooo`0fooooo`Go0000aoooool001_ooooo00?o0000ooooooooool0>oooool6o`000<7ooooo000K
ooooo`;o0000@_ooool4o`000;gooooo000Kooooo`03o`000?oooooooooo04Gooooo0ol0002joooo
o`006oooool00ol0003oooooooooo`18ooooo`;o0000^?ooool000Sooooo0_l00004ooooo`03o`00
0?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo04[ooooo0_l0002fooooo`001ooo
ool01?l0003oooooooooool00007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`1<ooooo`03o`000?oooooooooo0;?ooooo0005o`0000;ooooo00Co0000oooooooooooo
00002oooool00ol0003oooooooooo`02ooooo`;o0000C_ooool2o`000;?ooooo0007ooooo`04o`00
0?ooooooooooo`0000_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`1?ooooo`;o
0000/Oooool000Oooooo00Co0000oooooooooooo00001oooool4o`0000Gooooo00?o0000oooooooo
ool0DOooool00ol0003oooooooooo`2^ooooo`001oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0D_ooool2o`000:kooooo0008ooooo`;o0000
2?ooool5o`0000Cooooo00?o0000ooooooooool0E?ooool2o`000:cooooo000Kooooo`03o`000?oo
oooooooo05Kooooo00?o0000ooooooooool0ZOooool001_ooooo0_l0001Hooooo`;o0000ZOooool0
01_ooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`2Vooooo`006oooool00ol0003o
ooooooooo`1Jooooo`03o`000?oooooooooo0:Gooooo000Kooooo`03o`000?oooooooooo05_ooooo
00?o0000ooooooooool0Y?ooool001_ooooo00?o0000ooooooooool0G?ooool00ol0003ooooooooo
o`2Sooooo`006oooool2o`0005kooooo00?o0000ooooooooool0X_ooool001_ooooo00?o0000oooo
ooooool0G_ooool00ol0003oooooooooo`2Qooooo`006oooool00ol0003oooooooooo`1Oooooo`03
o`000?oooooooooo0:3ooooo000Kooooo`03o`000?oooooooooo063ooooo00?o0000ooooooooool0
Woooool001_ooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`2Nooooo`006oooool0
0ol0003oooooooooo`0Qooooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2
o`0000;ooooo1Ol0000Fooooo`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00000_ooool0
1?l0003oooooo`000?l00004ooooo`?o00005_ooool2o`0000Cooooo00?o0000ooooooooool00ooo
ool2o`0000Cooooo0_l00003ooooo`?o00005oooool2o`0000Cooooo00?o0000ooooooooool00ooo
ool2o`0000Cooooo0_l00003ooooo`?o00006oooool2o`0000Cooooo00?o0000ooooooooool00ooo
ool2o`0000?ooooo0ol00005ooooo`006oooool2o`00027ooooo00Co0000oooooooooooo00002?oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00005Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00001?ooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000So
oooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o
0000ooooooooool04oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;o
oooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01Oooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Cooooo
000Kooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo00002?ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool05Oooool01?l0
003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo0_l000000ooooooo0000oooo
o`05o`0001Gooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06
o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Cooooo`04o`000?oooooo
ooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`00
00?ooooo00?o0000ooooooooool05oooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000?ooooo00?o0000ooooooooool01?ooool001_ooooo00?o0000ooooooooool08?ooool0
1?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00001?ooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooo
oooooooo00000_ooool01_l0003oooooo`000?l0003oooooo`0000;ooooo00?o0000ooooooooool0
5?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooo
oooooooo0000ooooo`04o`0001Kooooo00Co0000oooooooooooo00002?ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0000;ooooo0ol0000Jooooo`04o`000?ooooooooooo`00
00Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`04ooooo`006oooool00ol0
003oooooooooo`0Pooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool04oooool01?l0003o
ooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooo`00000Fooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo
00000_ooool01_l0003oooooooooool0003oooooo`0001Wooooo00Co0000oooooooooooo00002?oo
ool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0
003oooooooooo`0Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`04ooooo`006oooool00ol0003oooooooooo`0Pooooo`04o`000?oooooo
ooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`00
00?ooooo00?o0000ooooooooool04oooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool00_l00002ooooo`;o00005_ooool01?l0003ooooooooo
ool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0Fooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool05oooool01?l0003o
ooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo0_l00006ooooo`006oooool2o`00
02;ooooo0_l0000:ooooo`;o00001?ooool2o`0000?ooooo0ol0000Gooooo`;o00002_ooool2o`00
00Cooooo0_l000000ooooooo0000ooooo`02ooooo`03o`000?oooooooooo01Gooooo0_l0000:oooo
o`;o00001?ooool2o`0000Cooooo0_l0000Gooooo`;o00002_ooool2o`0000Cooooo0_l00003oooo
o`?o00006oooool2o`0000[ooooo0_l00004ooooo`03o`000?oooooooooo00Cooooo000Kooooo`03
o`000?oooooooooo06Sooooo00?o0000ooooooooool0Uoooool001_ooooo00?o0000ooooooooool0
JOooool00ol0003oooooooooo`2Fooooo`006oooool00ol0003oooooooooo`1Zooooo`03o`000?oo
oooooooo09Gooooo000Kooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0U?ooool0
01_ooooo00?o0000ooooooooool0K?ooool00ol0003oooooooooo`2Cooooo`005?ooooooo`0000go
0000000Kooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooo000000[ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`09ooooo`7o00000Oooool1ooooo`006oooool00ol0003oooooooooo`1^ooooo`03o`000?oo
oooooooo097ooooo000Kooooo`03o`000?oooooooooo06oooooo00?o0000ooooooooool0T?ooool0
01_ooooo00?o0000ooooooooool0L?ooool00ol0003oooooooooo`2?ooooo`006oooool2o`0007;o
oooo00?o0000ooooooooool0S_ooool001_ooooo00?o0000ooooooooool0L_ooool00ol0003ooooo
ooooo`2=ooooo`006oooool00ol0003oooooooooo`1booooo`03o`000?oooooooooo08gooooo000K
ooooo`03o`000?oooooooooo07?ooooo00?o0000ooooooooool0S?ooool001_ooooo00?o0000oooo
ooooool0Loooool00ol0003oooooooooo`2<ooooo`006oooool2o`0007Gooooo00?o0000oooooooo
ool0Roooool001_ooooo00?o0000ooooooooool0MOooool00ol0003oooooooooo`2:ooooo`006ooo
ool00ol0003oooooooooo`1eooooo`03o`000?oooooooooo08[ooooo000Kooooo`03o`000?oooooo
oooo07Kooooo00?o0000ooooooooool0ROooool001_ooooo00?o0000ooooooooool0M_ooool00ol0
003oooooooooo`29ooooo`006oooool00ol0003oooooooooo`1gooooo`03o`000?oooooooooo08So
oooo000Kooooo`;o0000NOooool00ol0003oooooooooo`27ooooo`006oooool00ol0003ooooooooo
o`1hooooo`03o`000?oooooooooo08Oooooo000Kooooo`03o`000?oooooooooo07Wooooo00?o0000
ooooooooool0Q_ooool001_ooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`26oooo
o`006oooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo08Gooooo000Kooooo`;o0000
O?ooool00ol0003oooooooooo`24ooooo`006oooool00ol0003oooooooooo`1kooooo`03o`000?oo
oooooooo08Cooooo000Kooooo`03o`000?oooooooooo07cooooo00?o0000ooooooooool0Poooool0
00Sooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo
07cooooo00?o0000ooooooooool0Poooool000Oooooo00Co0000oooooooooooo00001oooool01Ol0
003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0OOooool00ol0003oooooooooo`22
ooooo`001oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0OOooool00ol0003oooooooooo`22ooooo`001oooool01?l0003oooooooooool0000;
ooooo`03o`000?oooooooooo00;ooooo0_l0001oooooo`03o`000?oooooooooo087ooooo0007oooo
o`04o`000?ooooooooooo`0000Oooooo1?l00005ooooo`03o`000?oooooooooo07kooooo00?o0000
ooooooooool0POooool000Oooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo07oooooo00?o0000ooooooooool0P?ooool000Sooooo0_l00008oooo
o`Go00001?ooool00ol0003oooooooooo`1oooooo`03o`000?oooooooooo083ooooo000Kooooo`03
o`000?oooooooooo07oooooo00?o0000ooooooooool0P?ooool001_ooooo0_l00021ooooo`03o`00
0?oooooooooo07oooooo000Kooooo`03o`000?oooooooooo083ooooo00?o0000ooooooooool0Oooo
ool001_ooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`1nooooo`006oooool00ol0
003oooooooooo`21ooooo`03o`000?oooooooooo07kooooo000Kooooo`03o`000?oooooooooo08;o
oooo00?o0000ooooooooool0OOooool001_ooooo00?o0000ooooooooool0P_ooool00ol0003ooooo
ooooo`1mooooo`006oooool2o`0008?ooooo00?o0000ooooooooool0OOooool001_ooooo00?o0000
ooooooooool0Poooool00ol0003oooooooooo`1looooo`006oooool00ol0003oooooooooo`23oooo
o`03o`000?oooooooooo07cooooo000Kooooo`03o`000?oooooooooo08?ooooo00?o0000oooooooo
ool0O?ooool001_ooooo00?o0000ooooooooool0Q?ooool00ol0003oooooooooo`1kooooo`006ooo
ool2o`0008Gooooo00?o0000ooooooooool0Noooool001_ooooo00?o0000ooooooooool0Q?ooool0
0ol0003oooooooooo`1kooooo`006oooool00ol0003oooooooooo`25ooooo`03o`000?oooooooooo
07[ooooo000Kooooo`03o`000?oooooooooo08Gooooo00?o0000ooooooooool0N_ooool001_ooooo
00?o0000ooooooooool0QOooool00ol0003oooooooooo`1jooooo`006oooool2o`0008Oooooo00?o
0000ooooooooool0NOooool001_ooooo00?o0000ooooooooool0Q_ooool00ol0003oooooooooo`1i
ooooo`006oooool00ol0003oooooooooo`26ooooo`03o`000?oooooooooo07Wooooo000Cooooo`?o
00001Oooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo07Sooooo000Dooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`1hooooo`005?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0N?oo
ool001Cooooo00?o0000ooooooooool01?ooool2o`0008Wooooo00?o0000ooooooooool0Moooool0
01Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`28ooooo`03o`000?oooooooooo
07Oooooo000Cooooo`;o00001_ooool00ol0003oooooooooo`28ooooo`03o`000?oooooooooo05[o
oooo0ol0000Jooooo`005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo08Wooooo
00?o0000ooooooooool0F?ooool01?l0003oooooooooool0000Jooooo`006oooool00ol0003ooooo
ooooo`29ooooo`03o`000?oooooooooo05Sooooo00Go0000ooooooooooooooooo`00000=ooooo`03
o`000?oooooooooo00Wooooo000Kooooo`;o0000R_ooool00ol0003oooooooooo`1Gooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool02_ooool2o`0000_ooooo000Kooooo`03o`000?oo
oooooooo08[ooooo00?o0000ooooooooool0E_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00[ooooo0_l0000;ooooo`006oooool00ol0003oooooooooo`2:ooooo`03o`000?oooooo
oooo05Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
000000[ooooo000Kooooo`03o`000?oooooooooo08[ooooo00?o0000ooooooooool0E_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooool000002_ooool001_o
oooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool02Oooool00ol0003oooooo`00000:ooooo`006oooool00ol0003ooooo
ooooo`2;ooooo`03o`000?oooooooooo05Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooo000000[ooooo000Kooooo`;o0000S?ooool00ol0003ooooooooo
o`1Dooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02Oooool00ol0003oooooo`00
000:ooooo`006oooool00ol0003oooooooooo`2<ooooo`03o`000?oooooooooo043ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooool000002_ooool001_ooooo00?o0000ooooooooool0S?ooool00ol0003oooooooooo`0ooooo
o`?o00004Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00Co0000oooo
oooooooo00002_ooool001_ooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`0moooo
o`03o`000?oooooooooo00;o00004?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Oooooo00Co0000oooooooooooo00002_ooool001_ooooo00?o0000ooooooooool0SOooool00ol0
003oooooooooo`0mooooo`05o`000?ooooooooooooooool000004?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Oooooo00Go0000ooooooooooooooooo`000009ooooo`006oooool2
o`0008oooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`05o`000?oooooo
ooooooooool000002Oooool001_ooooo00?o0000ooooooooool0S_ooool00ol0003oooooooooo`0k
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Oooooo00Go0000ooooooooooooooooo`000009ooooo`006oooool0
0ol0003oooooooooo`2?ooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool0
1Ol0003ooooooooooooooooo000000Wooooo000Kooooo`03o`000?oooooooooo08oooooo00?o0000
ooooooooool0>Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`06ooooo`05o`000?ooooooooooooooool000002Ooo
ool001_ooooo00?o0000ooooooooool0T?ooool00ol0003oooooooooo`0^ooooo`?o00001oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`06ooooo`05o`000?ooooooooooooooool000002Oooool001_ooooo0_l0002A
ooooo`03o`000?oooooooooo02gooooo0_l000000ooooooo0000o`000005ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Kooooo00Go0000ooooooooooooooooo`000009ooooo`006oooool00ol0003oooooooooo`2A
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool00_ooool01?l0003ooooooooooooo
ool2o`0000Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Kooooo00Go0000ooooooooooooooooo`000009ooooo`006oooool00ol0003ooooooooo
o`2Aooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool00oooool4o`0000Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00Go
0000ooooooooooooooooo`000009ooooo`001oooool3o`0000Cooooo00?o0000ooooooooool00_oo
ool3o`0000Gooooo00?o0000ooooooooool0T_ooool00ol0003oooooooooo`0Rooooo`;o00001_oo
ool00ol0003oooooooooo`05ooooo`;o00002_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01_ooool01Ol0003ooooooooooooooooo000000Wooooo
0008ooooo`03o`000?oooooooooo00Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo09;ooooo00?o0000ooooooooool08_ooool00ol0003oooooo`000005ooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Kooooo00Go0000ooooooooooooooooo`000009ooooo`002?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0Toooool00ol0003ooooo
ooooo`0Qooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Oooooo0008ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool00_ooool2o`0009Cooooo00?o0000ooooooooool08Oooool01?l0003ooooo
ooooool00003ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`07ooooo`002?ooool00ol0003oooooooooo`07ooooo`Co00001Oooool00ol0003ooooo
ooooo`2Dooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool0000Dooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01oooool000Oooooo
0_l00009ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0UOooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000005_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00Oooooo0008ooooo`03o`000?oooooooooo00Oooooo1Ol0
0004ooooo`03o`000?oooooooooo09Gooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooo000001Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`07ooooo`006oooool00ol0003oooooooooo`2Fooooo`03o`000?oooooooooo01Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000001Kooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`07ooooo`006oooool2o`0009Oooooo00?o0000oooo
ooooool05Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ool000005_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Oooooo000Kooooo`03
o`000?oooooooooo09Oooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00;ooooo0_l0000Gooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01oooool001_ooooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`0Cooooo`;o0000
1oooool00ol0003oooooooooo`02ooooo`;o00005oooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00Oooooo000Kooooo`03o`000?oooooooooo09Sooooo00?o0000ooooooooool04_oo
ool2o`0000Oooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00Oooooo000Kooooo`03o`000?oooooooooo09Wooooo00?o0000ooooooooool04Oooool2
o`0000Oooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00Oooooo000Kooooo`03o`000?oooooooooo09Wooooo00?o0000ooooooooool04Oooool2o`00
00Oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Kooooo000Kooooo`;o0000Voooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo000000Oo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Ko
oooo000Kooooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool03_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`06ooooo`006oooool00ol0003oooooooooo`2Kooooo`03o`000?oooooooooo00gooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01_ooool001_ooooo00?o0000ooooooooool0W?ooool00ol0003ooooo
ooooo`0;ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool001_ooooo00?o0000ooooooooool0
WOooool00ol0003oooooooooo`0:ooooo`05o`000?ooooooooooooooool000001oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool001_ooooo
0_l0002Nooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`06ooooo`006oooool00ol0003oooooooooo`2Nooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`006oooool00ol0003oooooooooo`2O
ooooo`;o00001_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool07Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00gooooo00Go0000
ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Kooooo000Kooooo`03o`000?oooooo
oooo0:7ooooo1_l00007ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00gooooo00Go0000ooooooooooooooooo`00
0006ooooo`03o`000?oooooooooo00Kooooo000Kooooo`03o`000?oooooooooo0:kooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool03Oooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool01_oo
ool001_ooooo00?o0000ooooooooool0[_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0>ooooo`05o`000?oooooo
ooooooooool000001_ooool00ol0003oooooooooo`06ooooo`006oooool2o`000:oooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Kooooo000K
ooooo`03o`000?oooooooooo0:kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03oooool00ol0003oooooo`000007
ooooo`03o`000?oooooooooo00Kooooo000Booooo`Go00001?ooool00ol0003oooooooooo`2_oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00oooooo0_l00008ooooo`03o`000?oooooooooo00Kooooo000Cooooo`04
o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0[oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo00Kooooo000Dooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0[oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00Kooooo000Eooooo`03o`00
0?oooooooooo00?ooooo0_l0002`ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
1_ooool001;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0:oooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`06ooooo`004_ooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool0[oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo00Kooooo000Cooooo`?o00001Oooool00ol0003oooooooooo`2`ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool01_ooool001_ooooo00?o0000ooooooooool0/?ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00Kooooo000Kooooo`;o0000/Oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo023ooooo00Go0000ooooooooooooooooo`00000L
ooooo`03o`000?oooooooooo00Kooooo000Kooooo`03o`000?oooooooooo0;7ooooo00Co0000oooo
oooooooo00008oooool01Ol0003ooooooooooooooooo000001cooooo00?o0000ooooooooool01_oo
ool001_ooooo00?o0000ooooooooool0/Oooool4o`0002?ooooo00Go0000ooooooooooooooooo`00
000Looooo`03o`000?oooooooooo00Kooooo000Kooooo`03o`000?oooooooooo0=Sooooo00Co0000
oooooooooooo00007Oooool00ol0003oooooooooo`06ooooo`006oooool00ol0003oooooooooo`3I
ooooo`03o`000?oooooo000001kooooo00?o0000ooooooooool01Oooool001_ooooo00?o0000oooo
ooooool0fOooool3o`0001kooooo00?o0000ooooooooool01Oooool001_ooooo0_l0003oooooo`Co
oooo000Kooooo`03o`000?oooooooooo0?oooooo0oooool001_ooooo00?o0000ooooooooool0oooo
ool3ooooo`006oooool00ol0003oooooooooo`3oooooo`?ooooo003oooooob7ooooo003oooooob7o
oooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.00111191, -0.886008, \
4.06902*^-5, 0.0184497}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q2final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 92.3888 0.352022 0.0332502 [
[.20859 .33952 -15 -9 ]
[.20859 .33952 15 0 ]
[.39336 .33952 -15 -9 ]
[.39336 .33952 15 0 ]
[.57814 .33952 -15 -9 ]
[.57814 .33952 15 0 ]
[.76292 .33952 -15 -9 ]
[.76292 .33952 15 0 ]
[.9477 .33952 -12 -9 ]
[.9477 .33952 12 0 ]
[.01131 .01952 -18 -4.5 ]
[.01131 .01952 0 4.5 ]
[.01131 .10265 -24 -4.5 ]
[.01131 .10265 0 4.5 ]
[.01131 .18577 -12 -4.5 ]
[.01131 .18577 0 4.5 ]
[.01131 .2689 -24 -4.5 ]
[.01131 .2689 0 4.5 ]
[.01131 .43515 -18 -4.5 ]
[.01131 .43515 0 4.5 ]
[.01131 .51827 -6 -4.5 ]
[.01131 .51827 0 4.5 ]
[.01131 .6014 -18 -4.5 ]
[.01131 .6014 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20859 .35202 m
.20859 .35827 L
s
[(0.002)] .20859 .33952 0 1 Mshowa
.39336 .35202 m
.39336 .35827 L
s
[(0.004)] .39336 .33952 0 1 Mshowa
.57814 .35202 m
.57814 .35827 L
s
[(0.006)] .57814 .33952 0 1 Mshowa
.76292 .35202 m
.76292 .35827 L
s
[(0.008)] .76292 .33952 0 1 Mshowa
.9477 .35202 m
.9477 .35827 L
s
[(0.01)] .9477 .33952 0 1 Mshowa
.125 Mabswid
.07 .35202 m
.07 .35577 L
s
.1162 .35202 m
.1162 .35577 L
s
.16239 .35202 m
.16239 .35577 L
s
.25478 .35202 m
.25478 .35577 L
s
.30098 .35202 m
.30098 .35577 L
s
.34717 .35202 m
.34717 .35577 L
s
.43956 .35202 m
.43956 .35577 L
s
.48575 .35202 m
.48575 .35577 L
s
.53195 .35202 m
.53195 .35577 L
s
.62434 .35202 m
.62434 .35577 L
s
.67053 .35202 m
.67053 .35577 L
s
.71673 .35202 m
.71673 .35577 L
s
.80911 .35202 m
.80911 .35577 L
s
.85531 .35202 m
.85531 .35577 L
s
.9015 .35202 m
.9015 .35577 L
s
.99389 .35202 m
.99389 .35577 L
s
.25 Mabswid
0 .35202 m
1 .35202 L
s
.02381 .01952 m
.03006 .01952 L
s
[(-10)] .01131 .01952 1 0 Mshowa
.02381 .10265 m
.03006 .10265 L
s
[(-7.5)] .01131 .10265 1 0 Mshowa
.02381 .18577 m
.03006 .18577 L
s
[(-5)] .01131 .18577 1 0 Mshowa
.02381 .2689 m
.03006 .2689 L
s
[(-2.5)] .01131 .2689 1 0 Mshowa
.02381 .43515 m
.03006 .43515 L
s
[(2.5)] .01131 .43515 1 0 Mshowa
.02381 .51827 m
.03006 .51827 L
s
[(5)] .01131 .51827 1 0 Mshowa
.02381 .6014 m
.03006 .6014 L
s
[(7.5)] .01131 .6014 1 0 Mshowa
.125 Mabswid
.02381 .03615 m
.02756 .03615 L
s
.02381 .05277 m
.02756 .05277 L
s
.02381 .0694 m
.02756 .0694 L
s
.02381 .08602 m
.02756 .08602 L
s
.02381 .11927 m
.02756 .11927 L
s
.02381 .1359 m
.02756 .1359 L
s
.02381 .15252 m
.02756 .15252 L
s
.02381 .16915 m
.02756 .16915 L
s
.02381 .2024 m
.02756 .2024 L
s
.02381 .21902 m
.02756 .21902 L
s
.02381 .23565 m
.02756 .23565 L
s
.02381 .25227 m
.02756 .25227 L
s
.02381 .28552 m
.02756 .28552 L
s
.02381 .30215 m
.02756 .30215 L
s
.02381 .31877 m
.02756 .31877 L
s
.02381 .3354 m
.02756 .3354 L
s
.02381 .36865 m
.02756 .36865 L
s
.02381 .38527 m
.02756 .38527 L
s
.02381 .4019 m
.02756 .4019 L
s
.02381 .41852 m
.02756 .41852 L
s
.02381 .45177 m
.02756 .45177 L
s
.02381 .4684 m
.02756 .4684 L
s
.02381 .48502 m
.02756 .48502 L
s
.02381 .50165 m
.02756 .50165 L
s
.02381 .5349 m
.02756 .5349 L
s
.02381 .55152 m
.02756 .55152 L
s
.02381 .56815 m
.02756 .56815 L
s
.02381 .58477 m
.02756 .58477 L
s
.02381 .0029 m
.02756 .0029 L
s
.02381 .61802 m
.02756 .61802 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .36943 m
.02499 .36943 L
.02605 .36943 L
.02729 .36943 L
.02846 .36943 L
.02954 .36943 L
.03053 .36943 L
.03163 .36943 L
.03279 .36943 L
.03395 .36943 L
.0352 .36943 L
.03628 .36943 L
.03746 .36943 L
.03818 .36943 L
.03884 .36943 L
.04016 .36943 L
.04135 .36943 L
.04262 .36943 L
.04519 .36943 L
.04589 .36943 L
.04664 .36943 L
.04797 .36943 L
.04923 .36943 L
.04992 .36943 L
.05058 .36943 L
.05185 .36943 L
.05302 .36943 L
.05406 .36943 L
.05517 .36943 L
.05639 .36943 L
.05751 .36943 L
.05864 .36943 L
.05986 .36943 L
.06055 .36943 L
.06119 .36943 L
.06244 .36943 L
.06373 .36943 L
.0649 .36943 L
.06555 .36943 L
.06625 .36943 L
.06752 .36943 L
.07225 .36943 L
.07783 .36943 L
.08048 .36944 L
.08178 .36944 L
.08297 .36944 L
.08538 .36944 L
.08797 .36944 L
.09347 .36944 L
.09885 .36944 L
Mistroke
.10458 .36945 L
.11445 .36945 L
.1236 .36947 L
.13449 .36948 L
.14434 .3695 L
.16363 .36956 L
.17448 .3696 L
.18446 .36965 L
.20332 .36977 L
.224 .36993 L
.26448 .37037 L
.28315 .3706 L
.30344 .37083 L
.3088 .37088 L
.3145 .37093 L
.31704 .37095 L
.31977 .37097 L
.32472 .37099 L
.32598 .371 L
.32715 .371 L
.32838 .371 L
.32972 .37101 L
.33088 .37101 L
.33193 .37101 L
.33315 .37101 L
.33429 .37101 L
.33558 .37101 L
.33622 .37101 L
.33693 .37101 L
.33819 .37101 L
.33936 .37101 L
.34007 .371 L
.34075 .371 L
.34201 .371 L
.34485 .37098 L
.34599 .37098 L
.34721 .37097 L
.34837 .37095 L
.34943 .37094 L
.35184 .37092 L
.35449 .37089 L
.35707 .37085 L
.35948 .3708 L
.36218 .37074 L
.36351 .37072 L
.36473 .3707 L
.36582 .37066 L
.36697 .37063 L
.36939 .37057 L
.37363 .37043 L
Mistroke
.3786 .37025 L
.38315 .37005 L
.39257 .36947 L
.4027 .3687 L
.41208 .36776 L
.421 .36671 L
.4306 .3652 L
.44082 .3633 L
.45921 .35874 L
.46951 .35551 L
.48064 .35128 L
.49026 .34702 L
.50082 .3411 L
.51045 .33507 L
.52077 .32669 L
.53167 .31508 L
.54184 .3001 L
.55202 .28558 L
.55778 .27968 L
.5631 .27564 L
.56813 .27219 L
.57286 .26976 L
.57778 .26775 L
.58322 .26575 L
.58832 .26426 L
.59306 .26309 L
.59801 .26219 L
.60342 .26136 L
.61237 .26037 L
.62193 .25953 L
.63218 .25873 L
.63499 .25854 L
.63796 .25839 L
.63919 .25833 L
.6405 .25829 L
.64125 .25827 L
.64194 .25827 L
.64263 .25826 L
.64329 .25826 L
.64456 .25827 L
.64572 .2583 L
.64696 .25834 L
.64765 .25839 L
.6483 .25841 L
.64946 .25853 L
.65069 .25862 L
.65176 .25872 L
.65294 .25889 L
.65429 .25912 L
.65556 .25929 L
Mistroke
.65627 .25948 L
.65704 .25968 L
.65773 .25988 L
.65838 .25993 L
.65955 .26037 L
.66084 .26071 L
.66218 .26115 L
.66345 .26171 L
.6684 .2639 L
.67121 .26557 L
.67382 .26757 L
.67859 .27168 L
.68126 .27479 L
.68368 .27847 L
.68591 .28133 L
.68703 .28315 L
.68826 .28649 L
.68891 .2869 L
.6896 .28851 L
.69084 .30964 L
.69209 .42085 L
.69322 .42532 L
.70221 .45111 L
.71223 .47673 L
.71467 .48229 L
.7173 .48734 L
.71803 .48815 L
.7188 .48975 L
.71946 .49192 L
.72018 .51616 L
.72085 .58147 L
.72158 .59406 L
.72289 .59342 L
.7242 .59304 L
.7254 .59266 L
.72769 .59171 L
.73017 .59095 L
.73281 .59033 L
.7339 .59005 L
.73508 .58986 L
.73619 .58977 L
.7372 .5897 L
.73839 .58968 L
.73968 .59994 L
.74091 .60309 L
.74204 .60323 L
.74329 .60332 L
.74445 .60327 L
.74572 .60313 L
.74635 .60292 L
Mistroke
.74705 .60278 L
.74823 .60225 L
.7495 .60181 L
.75069 .60113 L
.75178 .60023 L
.76059 .59338 L
.76546 .58957 L
.76803 .58782 L
.77075 .58616 L
.77189 .58562 L
.77312 .58483 L
.77383 .58469 L
.77447 .58447 L
.77574 .58396 L
.77682 .5836 L
.77799 .58338 L
.77914 .58321 L
.78036 .58299 L
.78099 .58294 L
.78168 .58285 L
.7829 .58278 L
.78359 .58274 L
.78432 .58271 L
.78502 .58271 L
.78565 .5827 L
.78688 .58271 L
.78758 .58271 L
.78822 .58272 L
.7894 .58272 L
.79065 .58271 L
.79175 .58269 L
.79294 .58264 L
.79406 .58255 L
.79509 .5824 L
.79748 .58192 L
.79868 .5816 L
.8 .58092 L
.80269 .57935 L
.80334 .5792 L
.80402 .57869 L
.80524 .57762 L
.80665 .57626 L
.80818 .57439 L
.81085 .5713 L
.81613 .56387 L
.82096 .55468 L
.82546 .54534 L
.82801 .53862 L
.83037 .53066 L
.83556 .51121 L
Mistroke
.8381 .49665 L
.8405 .48568 L
.84514 .47037 L
.84936 .46004 L
.8588 .43778 L
.87718 .40388 L
.88762 .38258 L
.89736 .36636 L
.90698 .34627 L
.90976 .33935 L
.91238 .33257 L
.91474 .32394 L
.91538 .32018 L
.91607 .31879 L
.9173 .31046 L
.91965 .29721 L
.92093 .28498 L
.92212 .27994 L
.92342 .27494 L
.92483 .26801 L
.92732 .25902 L
.93302 .242 L
.93837 .22803 L
.94856 .19626 L
.95357 .17944 L
.95819 .16315 L
.96238 .14327 L
.96453 .1307 L
.96571 .12435 L
.96683 .11552 L
.96803 .09441 L
.96913 .07853 L
.97016 .06716 L
.97129 .05752 L
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`006oooool00ol0003oooooooooo`3oooooo`?ooooo000Kooooo`;o0000ooooool4ooooo`00
3Oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0?oooooo0oooool000kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0?oooooo
0oooool000Kooooo1Ol00003ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`3jooooo`03o`000?oooooooooo00Gooooo000>ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000?_ooooo00?o0000ooooooooool0
1Oooool000kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooooooo0?[ooooo00?o0000ooooooooool01Oooool000gooooo0_l00004ooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool0n_ooool00ol0003oooooooooo`05ooooo`003_oo
ool00ol0003oooooooooo`03ooooo`;o00001Oooool00ol0003oooooooooo`3jooooo`03o`000?oo
oooooooo00Gooooo000Kooooo`;o0000noooool00ol0003oooooooooo`05ooooo`006oooool00ol0
003oooooooooo`3iooooo`03o`000?oooooooooo00Kooooo000Kooooo`03o`000?oooooooooo0?Wo
oooo00?o0000ooooooooool01_ooool001_ooooo00?o0000ooooooooool0nOooool00ol0003ooooo
ooooo`06ooooo`006oooool00ol0003oooooooooo`3iooooo`03o`000?oooooooooo00Kooooo000K
ooooo`;o0000n_ooool00ol0003oooooooooo`06ooooo`006oooool00ol0003oooooooooo`3ioooo
o`03o`000?oooooooooo00Kooooo000Kooooo`03o`000?oooooooooo0?Wooooo00?o0000oooooooo
ool01_ooool001_ooooo00?o0000ooooooooool0nOooool00ol0003oooooooooo`06ooooo`006ooo
ool2o`000?[ooooo00?o0000ooooooooool01_ooool001_ooooo00?o0000ooooooooool0nOooool0
0ol0003oooooooooo`06ooooo`006oooool00ol0003oooooooooo`3hooooo`03o`000?oooooooooo
00Oooooo000Kooooo`03o`000?oooooooooo0?Sooooo00?o0000ooooooooool01oooool001_ooooo
00?o0000ooooooooool0n?ooool00ol0003oooooooooo`07ooooo`006oooool2o`000?Wooooo00?o
0000ooooooooool01oooool001_ooooo00?o0000ooooooooool0n?ooool00ol0003oooooooooo`07
ooooo`002?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo0ol00005oooo
o`03o`000?oooooooooo0?Sooooo00?o0000ooooooooool01oooool000Sooooo00?o0000oooooooo
ool01oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0n?ooool00ol0
003oooooooooo`07ooooo`001Ol00004ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool00_ooool2o`000?Wooooo00?o0000ooooooooool01oooool000Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?Sooooo00?o0000ooooooooool0
1oooool000[ooooo00?o0000ooooooooool01Oooool4o`0000Gooooo00?o0000ooooooooool0n?oo
ool00ol0003oooooooooo`07ooooo`001_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`3hooooo`03o`000?oooooooooo00Oooooo0006
ooooo`Go00001oooool5o`0000Cooooo00?o0000ooooooooool0n?ooool00ol0003oooooooooo`07
ooooo`006oooool2o`000?Wooooo00?o0000ooooooooool01oooool001_ooooo00?o0000oooooooo
ool0moooool00ol0003oooooooooo`08ooooo`006oooool00ol0003oooooooooo`3gooooo`03o`00
0?oooooooooo00Sooooo000Kooooo`03o`000?oooooooooo0?Oooooo00?o0000ooooooooool02?oo
ool001_ooooo0_l0003hooooo`03o`000?oooooooooo00Sooooo000Kooooo`03o`000?oooooooooo
0?Kooooo00?o0000ooooooooool02Oooool001_ooooo00?o0000ooooooooool0m_ooool00ol0003o
ooooooooo`09ooooo`006oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo00Wooooo
000Kooooo`;o0000moooool00ol0003oooooooooo`09ooooo`006oooool00ol0003oooooooooo`3e
ooooo`03o`000?oooooooooo00[ooooo000Kooooo`03o`000?oooooooooo0?Gooooo00?o0000oooo
ooooool02_ooool001_ooooo00?o0000ooooooooool0mOooool00ol0003oooooooooo`0:ooooo`00
6oooool00ol0003oooooooooo`3eooooo`03o`000?oooooooooo00[ooooo000Kooooo`;o0000m_oo
ool00ol0003oooooooooo`0:ooooo`006oooool00ol0003oooooooooo`3dooooo`03o`000?oooooo
oooo00_ooooo000Cooooo`?o00001Oooool00ol0003oooooooooo`3dooooo`03o`000?oooooooooo
00_ooooo000Booooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3doooo
o`03o`000?oooooooooo00_ooooo000<ooooo`Go00001Oooool00ol0003oooooooooo`02ooooo`;o
0000mOooool00ol0003oooooooooo`0;ooooo`005_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo0?Cooooo00?o0000ooooooooool02oooool001;ooooo1?l00005ooooo`03o`000?oo
oooooooo0??ooooo00?o0000ooooooooool03?ooool001;ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`3cooooo`03o`000?oooooooooo00cooooo000Booooo`Go00001?ooool00ol0
003oooooooooo`3cooooo`03o`000?oooooooooo00cooooo000Kooooo`;o0000loooool00ol0003o
ooooooooo`0=ooooo`006oooool00ol0003oooooooooo`3booooo`03o`000?oooooooooo00gooooo
000Kooooo`03o`000?oooooooooo0?;ooooo00?o0000ooooooooool03Oooool001_ooooo00?o0000
ooooooooool0lOooool00ol0003oooooooooo`0>ooooo`006oooool2o`000?;ooooo00?o0000oooo
ooooool03_ooool001_ooooo00?o0000ooooooooool0lOooool00ol0003oooooooooo`0>ooooo`00
6oooool00ol0003oooooooooo`3`ooooo`03o`000?oooooooooo00oooooo000Kooooo`03o`000?oo
oooooooo0?3ooooo00?o0000ooooooooool03oooool001_ooooo0_l0003aooooo`03o`000?oooooo
oooo00oooooo000Kooooo`03o`000?oooooooooo0>oooooo00?o0000ooooooooool04?ooool001_o
oooo00?o0000ooooooooool0koooool00ol0003oooooooooo`0@ooooo`006oooool00ol0003ooooo
ooooo`3_ooooo`03o`000?oooooooooo013ooooo000Kooooo`03o`000?oooooooooo0>kooooo00?o
0000ooooooooool04Oooool001_ooooo0_l0003_ooooo`03o`000?oooooooooo017ooooo000Koooo
o`03o`000?oooooooooo0:7ooooo0_l0001;ooooo`03o`000?oooooooooo017ooooo0006ooooo`Go
00000oooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`2Goooooa7o
0000AOooool00ol0003oooooooooo`0Booooo`001oooool01?l0003oooooooooool00007ooooo`05
o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`2Aooooo`Ko00004Oooool2o`00
04?ooooo00?o0000ooooooooool04_ooool000Go00000oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00;ooooo0_l0002Aooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool0@?ooool00ol0003oooooooooo`0Booooo`002Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0SOooool3o`0001_ooooo00?o0000ooooooooool0
?oooool00ol0003oooooooooo`0Booooo`001_ooool01Ol0003ooooooooooooooooo000000Oooooo
1?l00005ooooo`03o`000?oooooooooo08cooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0mooooo`03o`000?oooooooooo01?ooooo0006ooooo`05o`000?ooooooooooooooool00000
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo08_ooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`0mooooo`03o`000?oooooooooo01?ooooo0007ooooo`?o00002?oo
ool5o`0000Cooooo00?o0000ooooooooool0R_ooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo03cooooo00?o0000ooooooooool04oooool001_ooooo0_l0002:ooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`0Dooooo`006oooool00ol0
003oooooooooo`29ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0>_ooool00ol0
003oooooooooo`0Dooooo`006oooool00ol0003oooooooooo`28ooooo`03o`000?oooooooooo02?o
oooo00?o0000ooooooooool0>_ooool00ol0003oooooooooo`0Dooooo`006oooool00ol0003ooooo
ooooo`28ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0>_ooool00ol0003ooooo
ooooo`0Dooooo`006oooool2o`0008Sooooo00?o0000ooooooooool09?ooool00ol0003ooooooooo
o`0jooooo`03o`000?oooooooooo01Cooooo000Kooooo`03o`000?oooooooooo08Oooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`0jooooo`03o`000?oooooooooo01Cooooo000Koooo
o`03o`000?oooooooooo027ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l00004oooo
o`;o00000_ooool5o`0001Kooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l00004oooo
o`;o00001?ooool3o`0001Kooooo0_l000001Ooooooo0000oooooooooooo000000Gooooo0_l00004
ooooo`;o00000oooool3o`00017ooooo00?o0000ooooooooool00oooool2o`0000Cooooo00?o0000
ooooooooool00oooool2o`0000Cooooo0_l00003ooooo`?o00006oooool3o`0000?ooooo00?o0000
ooooooooool00oooool2o`0000?ooooo0ol00005ooooo`006oooool00ol0003oooooooooo`0Poooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool00002ooooo`04o`000?ooooooooooo`0001Gooooo00Co0000oooooooooooo00002?ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool05?oo
ool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooo
oooo0000ooooool00003ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo
0000ooooool00003ooooo`03o`000?oooooooooo01Oooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Cooooo000Kooooo`03o`000?oooooo
oooo023ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000?ooooo00?o0000ooooooooool05Oooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooooooo0000ooooo`05o`0001Gooooo00Co
0000ooooool0003o00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`00
0?oooooo00000oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oo
oooo00000oooool00ol0003oooooooooo`0Gooooo`04o`000?oooooo0000o`0000Sooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`04ooooo`006oooool2o`00027ooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Co
oooo00?o0000ooooooooool05?ooool01?l0003oooooooooool00008ooooo`04o`000?oooooooooo
o`0000;ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo01Cooooo
0_l000000ooooooo0000ooooo`07ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooo
oooo0000ooooo`04o`00017ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00008
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool3o`0001[ooooo
00Co0000ooooool0003o00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo
00Cooooo000Kooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo00002?ooool01?l0
003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003ooooo
ooooo`0Cooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooo000001Kooooo00Co0000oooooooooooo00002?oo
ool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00005?ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool05oooool01?l0003o
ooooo`000?l00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01?ooool0
01_ooooo00?o0000ooooooooool08?ooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01?o
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000?ooooo0_l0000Dooooo`?o00000_ooool00ol0003oooooooooo`06ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002
ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Gooooo`04o`00
0?oooooo0000o`0000Sooooo00Co0000oooooooooooo00000_ooool2o`0000Kooooo000Kooooo`03
o`000?oooooooooo027ooooo0_l0000:ooooo`;o00001?ooool2o`0000?ooooo0ol0000Gooooo`;o
00002_ooool2o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo017ooooo00Co0000oooooooo
oooooooo0_l0000:ooooo`;o00001?ooool2o`0000Cooooo0_l0000Aooooo`03o`000?oooooooooo
00?ooooo0_l0000:ooooo`;o00001?ooool2o`0000?ooooo0ol0000Kooooo`;o00002_ooool2o`00
00Cooooo00?o0000ooooooooool01?ooool001_ooooo0_l0001oooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0Fooooo`006oooool00ol0003ooooo
ooooo`1mooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0=oooool00ol0003ooooo
ooooo`0Gooooo`006oooool00ol0003oooooooooo`1kooooo`;o0000<Oooool00ol0003ooooooooo
o`0gooooo`03o`000?oooooooooo01Oooooo000Kooooo`03o`000?oooooooooo07Sooooo0ol0000c
ooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool05oooool001Coooooool0000=o`00
00006oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`04ooooo`?o00000oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`;o
00002oooool00ol0003oooooooooo`09ooooo`7o00000Oooool1ooooo`006oooool00ol0003ooooo
ooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool03Oooool3o`0001kooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0<ooooo`006oooool00ol0003ooooooooo
o`1[ooooo`Co0000?oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo01Wooooo000K
ooooo`03o`000?oooooooooo06Gooooo1_l00013ooooo`03o`000?oooooooooo03Cooooo00?o0000
ooooooooool06_ooool001_oooooJ?l0001:ooooo`03o`000?oooooooooo03?ooooo00?o0000oooo
ooooool06_ooool001_ooooo00?o0000ooooooooool0[oooool00ol0003oooooooooo`0booooo`03
o`000?oooooooooo01_ooooo000Kooooo`03o`000?oooooooooo0:oooooo00?o0000ooooooooool0
<_ooool00ol0003oooooooooo`0Kooooo`006oooool00ol0003oooooooooo`2_ooooo`03o`000?oo
oooooooo03;ooooo00?o0000ooooooooool06oooool001_ooooo0_l0002`ooooo`03o`000?oooooo
oooo037ooooo00?o0000ooooooooool07?ooool001_ooooo00?o0000ooooooooool0[oooool00ol0
003oooooooooo`0aooooo`03o`000?oooooooooo01cooooo000Kooooo`03o`000?oooooooooo0:oo
oooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0Mooooo`006oooool00ol0003ooooo
ooooo`2_ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool07_ooool001_ooooo00?o
0000ooooooooool0[oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo000K
ooooo`;o0000/?ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01oooooo000Koooo
o`03o`000?oooooooooo0:oooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Ooooo
o`006oooool00ol0003oooooooooo`2_ooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool08?ooool001_ooooo00?o0000ooooooooool0[oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo023ooooo000Kooooo`;o0000/?ooool00ol0003oooooooooo`0/ooooo`03o`000?oo
oooooooo027ooooo000Kooooo`03o`000?oooooooooo0:oooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0Rooooo`001_ooool5o`0000?ooooo00?o0000ooooooooool00_ooool3o`00
00Gooooo00?o0000ooooooooool0[oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02;ooooo0007ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo0:oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0S
ooooo`002?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0[oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02?ooooo0009ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool2o`000;7ooooo00?o0000oooooooo
ool0:?ooool00ol0003oooooooooo`0Tooooo`001_ooool01Ol0003ooooooooooooooooo000000Oo
oooo1?l00005ooooo`03o`000?oooooooooo0;3ooooo00?o0000ooooooooool0:?ooool00ol0003o
ooooooooo`0Tooooo`001_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`2`ooooo`03o`000?oooooooooo02Oooooo00?o0000oooooooo
ool09Oooool000Oooooo0ol00008ooooo`Go00001?ooool00ol0003oooooooooo`2aooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool09Oooool001_ooooo0_l0002booooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool09_ooool001_ooooo00?o0000ooooooooool0/Oooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo02Kooooo000Kooooo`03o`000?oooooooooo
0;;ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0Wooooo`006oooool00ol0003o
ooooooooo`2booooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool09oooool001_ooooo
0_l0002dooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0:?ooool001_ooooo00?o
0000ooooooooool0/oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02Sooooo000K
ooooo`03o`000?oooooooooo0;?ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0X
ooooo`006oooool00ol0003oooooooooo`2dooooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool0:?ooool001_ooooo00?o0000ooooooooool0]Oooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo02Wooooo000Kooooo`;o0000]_ooool00ol0003oooooooooo`0Nooooo`03o`00
0?oooooooooo02Wooooo000Kooooo`03o`000?oooooooooo0;Gooooo0_l0000Oooooo`03o`000?oo
oooooooo02Wooooo000Kooooo`03o`000?oooooooooo0;Kooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`0Zooooo`006oooool00ol0003oooooooooo`2fooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool0:_ooool001_ooooo0_l0002gooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool0:_ooool001_ooooo00?o0000ooooooooool0]_ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo02[ooooo000Cooooo`?o00001Oooool00ol0003ooooooooo
o`2fooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0:_ooool001;ooooo00Go0000
ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0;Kooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0Zooooo`005_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo0;Kooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Zooooo`005_ooool00ol0
003oooooooooo`02ooooo`;o0000]oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
02_ooooo000Booooo`Co00001Oooool00ol0003oooooooooo`2fooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool0:oooool001;ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`2fooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0:oooool001;ooooo1Ol0
0004ooooo`03o`000?oooooooooo0;Kooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`0/ooooo`006oooool2o`000;Oooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`0/
ooooo`006oooool00ol0003oooooooooo`2fooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool0;?ooool001_ooooo00?o0000ooooooooool0]_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo02cooooo000Kooooo`03o`000?oooooooooo0;Kooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`0]ooooo`006oooool2o`000;Oooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`0]ooooo`006oooool00ol0003oooooooooo`2fooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool0;_ooool001_ooooo00?o0000ooooooooool0]_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo02kooooo000Kooooo`03o`000?oooooooooo0;Ko
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0_ooooo`006oooool00ol0003ooooo
ooooo`2fooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0;oooool001_ooooo0_l0
002gooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0<?ooool001_ooooo00?o0000
ooooooooool0]_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo037ooooo000Koooo
o`03o`000?oooooooooo0;Kooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0boooo
o`006oooool00ol0003oooooooooo`2fooooo`03o`000?oooooooooo01;ooooo0_l0000eooooo`00
6oooool2o`000;Oooooo00?o0000ooooooooool02oooool8o`0003Kooooo000Kooooo`03o`000?oo
oooooooo0;Kooooo00?o0000ooooooooool02_ooool2o`0003gooooo0008ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0]_ooool6
o`0000Kooooo00?o0000ooooooooool0?Oooool000Sooooo00?o0000ooooooooool01oooool01Ol0
003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0]_ooool2o`0000?ooooo00?o0000
ooooooooool00_ooool2o`00043ooooo0009ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`2kooooo`03o`000?oooooooooo00;o0000@_ooool000Wo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`;o0000_Oooool3o`0004?o
oooo000:ooooo`03o`000?oooooooooo00Gooooo1?l00005ooooo`03o`000?oooooooooo0?oooooo
0oooool000Kooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0ooooool3ooooo`001_ooool5o`0000Oooooo1Ol00004ooooo`03o`000?oo
oooooooo0?oooooo0oooool001_ooooo0_l0003oooooo`Cooooo003oooooob7ooooo003oooooob7o
oooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.00111191, -11.2915, \
4.06902*^-5, 0.113061}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q3final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 92.3888 0.0160372 0.0092545 [
[.20859 .00354 -15 -9 ]
[.20859 .00354 15 0 ]
[.39336 .00354 -15 -9 ]
[.39336 .00354 15 0 ]
[.57814 .00354 -15 -9 ]
[.57814 .00354 15 0 ]
[.76292 .00354 -15 -9 ]
[.76292 .00354 15 0 ]
[.9477 .00354 -12 -9 ]
[.9477 .00354 12 0 ]
[.01131 .10858 -12 -4.5 ]
[.01131 .10858 0 4.5 ]
[.01131 .20113 -12 -4.5 ]
[.01131 .20113 0 4.5 ]
[.01131 .29367 -12 -4.5 ]
[.01131 .29367 0 4.5 ]
[.01131 .38622 -12 -4.5 ]
[.01131 .38622 0 4.5 ]
[.01131 .47876 -12 -4.5 ]
[.01131 .47876 0 4.5 ]
[.01131 .57131 -12 -4.5 ]
[.01131 .57131 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20859 .01604 m
.20859 .02229 L
s
[(0.002)] .20859 .00354 0 1 Mshowa
.39336 .01604 m
.39336 .02229 L
s
[(0.004)] .39336 .00354 0 1 Mshowa
.57814 .01604 m
.57814 .02229 L
s
[(0.006)] .57814 .00354 0 1 Mshowa
.76292 .01604 m
.76292 .02229 L
s
[(0.008)] .76292 .00354 0 1 Mshowa
.9477 .01604 m
.9477 .02229 L
s
[(0.01)] .9477 .00354 0 1 Mshowa
.125 Mabswid
.07 .01604 m
.07 .01979 L
s
.1162 .01604 m
.1162 .01979 L
s
.16239 .01604 m
.16239 .01979 L
s
.25478 .01604 m
.25478 .01979 L
s
.30098 .01604 m
.30098 .01979 L
s
.34717 .01604 m
.34717 .01979 L
s
.43956 .01604 m
.43956 .01979 L
s
.48575 .01604 m
.48575 .01979 L
s
.53195 .01604 m
.53195 .01979 L
s
.62434 .01604 m
.62434 .01979 L
s
.67053 .01604 m
.67053 .01979 L
s
.71673 .01604 m
.71673 .01979 L
s
.80911 .01604 m
.80911 .01979 L
s
.85531 .01604 m
.85531 .01979 L
s
.9015 .01604 m
.9015 .01979 L
s
.99389 .01604 m
.99389 .01979 L
s
.25 Mabswid
0 .01604 m
1 .01604 L
s
.02381 .10858 m
.03006 .10858 L
s
[(10)] .01131 .10858 1 0 Mshowa
.02381 .20113 m
.03006 .20113 L
s
[(20)] .01131 .20113 1 0 Mshowa
.02381 .29367 m
.03006 .29367 L
s
[(30)] .01131 .29367 1 0 Mshowa
.02381 .38622 m
.03006 .38622 L
s
[(40)] .01131 .38622 1 0 Mshowa
.02381 .47876 m
.03006 .47876 L
s
[(50)] .01131 .47876 1 0 Mshowa
.02381 .57131 m
.03006 .57131 L
s
[(60)] .01131 .57131 1 0 Mshowa
.125 Mabswid
.02381 .03455 m
.02756 .03455 L
s
.02381 .05306 m
.02756 .05306 L
s
.02381 .07156 m
.02756 .07156 L
s
.02381 .09007 m
.02756 .09007 L
s
.02381 .12709 m
.02756 .12709 L
s
.02381 .1456 m
.02756 .1456 L
s
.02381 .16411 m
.02756 .16411 L
s
.02381 .18262 m
.02756 .18262 L
s
.02381 .21964 m
.02756 .21964 L
s
.02381 .23815 m
.02756 .23815 L
s
.02381 .25665 m
.02756 .25665 L
s
.02381 .27516 m
.02756 .27516 L
s
.02381 .31218 m
.02756 .31218 L
s
.02381 .33069 m
.02756 .33069 L
s
.02381 .3492 m
.02756 .3492 L
s
.02381 .36771 m
.02756 .36771 L
s
.02381 .40473 m
.02756 .40473 L
s
.02381 .42324 m
.02756 .42324 L
s
.02381 .44174 m
.02756 .44174 L
s
.02381 .46025 m
.02756 .46025 L
s
.02381 .49727 m
.02756 .49727 L
s
.02381 .51578 m
.02756 .51578 L
s
.02381 .53429 m
.02756 .53429 L
s
.02381 .5528 m
.02756 .5528 L
s
.02381 .58982 m
.02756 .58982 L
s
.02381 .60833 m
.02756 .60833 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .01765 m
.02499 .01765 L
.02605 .01765 L
.02729 .01765 L
.02846 .01765 L
.02954 .01765 L
.03053 .01765 L
.03163 .01765 L
.03279 .01765 L
.03395 .01765 L
.0352 .01765 L
.03628 .01765 L
.03746 .01765 L
.03818 .01765 L
.03884 .01765 L
.04016 .01765 L
.04135 .01765 L
.04262 .01765 L
.04519 .01765 L
.04589 .01765 L
.04664 .01765 L
.04797 .01765 L
.04923 .01765 L
.04992 .01765 L
.05058 .01765 L
.05185 .01765 L
.05302 .01765 L
.05406 .01765 L
.05517 .01765 L
.05639 .01765 L
.05751 .01765 L
.05864 .01765 L
.05986 .01765 L
.06055 .01765 L
.06119 .01765 L
.06244 .01765 L
.06373 .01765 L
.0649 .01765 L
.06555 .01765 L
.06625 .01765 L
.06752 .01765 L
.07225 .01765 L
.07783 .01765 L
.08048 .01765 L
.08178 .01765 L
.08297 .01765 L
.08538 .01765 L
.08797 .01765 L
.09347 .01765 L
.09885 .01764 L
Mistroke
.10458 .01764 L
.11445 .01764 L
.1236 .01763 L
.13449 .01762 L
.14434 .0176 L
.16363 .01756 L
.17448 .01753 L
.18446 .0175 L
.20332 .01741 L
.224 .01729 L
.24355 .01714 L
.26448 .01693 L
.30589 .01637 L
.34579 .01569 L
.38417 .01504 L
.39439 .0149 L
.40398 .0148 L
.4088 .01476 L
.41127 .01474 L
.41258 .01474 L
.41332 .01474 L
.41398 .01473 L
.41473 .01473 L
.41543 .01473 L
.41608 .01472 L
.41678 .01472 L
.41753 .01472 L
.41832 .01472 L
.419 .01472 L
.41973 .01472 L
.42103 .01472 L
.42224 .01472 L
.42298 .01472 L
.42369 .01472 L
.425 .01472 L
.42614 .01472 L
.42736 .01472 L
.42852 .01473 L
.42958 .01473 L
.43075 .01474 L
.432 .01475 L
.43271 .01475 L
.43337 .01476 L
.43464 .01477 L
.43587 .01478 L
.43721 .01479 L
.43963 .01482 L
.44489 .01489 L
.44954 .01497 L
.45446 .0151 L
Mistroke
.4633 .01535 L
.47272 .01572 L
.48285 .01625 L
.49241 .01692 L
.50115 .01762 L
.51101 .01871 L
.52015 .02002 L
.52264 .02038 L
.52532 .02086 L
.53019 .02204 L
.5358 .02371 L
.54088 .02555 L
.58191 .04456 L
.62141 .0589 L
.65941 .07532 L
.66943 .07893 L
.67437 .08063 L
.67893 .08184 L
.68417 .08289 L
.68694 .08334 L
.68763 .08346 L
.68835 .08357 L
.68915 .08366 L
.68988 .08369 L
.69104 .09137 L
.69232 .10239 L
.69351 .10289 L
.69462 .10333 L
.69594 .10401 L
.69715 .10483 L
.69985 .10655 L
.70918 .11381 L
.71428 .11842 L
.71677 .1213 L
.71786 .12225 L
.71905 .12361 L
.72033 .14725 L
.72154 .18618 L
.72221 .18711 L
.72292 .18798 L
.72421 .18892 L
.72988 .19415 L
.73257 .19666 L
.73511 .19908 L
.73622 .19986 L
.73739 .20069 L
.73867 .20215 L
.73985 .22394 L
.74108 .22494 L
.74241 .2262 L
Mistroke
.74483 .22874 L
.74936 .23425 L
.75954 .2468 L
.7779 .26579 L
.79733 .28383 L
.81875 .31004 L
.85809 .37134 L
.89836 .42864 L
.90733 .4362 L
.91225 .44045 L
.91467 .44349 L
.91573 .44466 L
.91689 .446 L
.91818 .44921 L
.91888 .45001 L
.91953 .45117 L
.92239 .4565 L
.92738 .46434 L
.93712 .47569 L
.94208 .48261 L
.94327 .48432 L
.94453 .48577 L
.9456 .48772 L
.94679 .49108 L
.94938 .49774 L
.95221 .5077 L
.95715 .52402 L
.97619 .60332 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00=oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00002oooo
o`Go00005oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00004oooo
o`?o00006?ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003oooo
o`?o00006?ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003oooo
o`?o00007?ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol00008oooo
o`00=_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Fooooo`04o`000?ooooooooooo`0000So
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo
oooo01Kooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`00
0?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Dooooo`04o`000?oooooooooo
o`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000?o
oooo00?o0000ooooooooool06?ooool01?l0003oooooooooool00008ooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooooooool01oooool003Kooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
5_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooo
oooooooo0000ooooo`05o`0001Oooooo00Co0000oooooooooooo00002?ooool01?l0003ooooooooo
ool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Doooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooooooool06?ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01oooool003Kooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool05Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`00
00;ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo01Kooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`05o`000?ooooooooooo`00
0?ooool01?l0000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`?o00006oooool01?l0003oooooooooool00008ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01oooool003Kooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo0000
0oooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000001Sooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oo
oooo00006_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko
0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01Sooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Oooooo000foooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooooooool05?ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool2o`0001Sooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool05oooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01So
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`;o00002Oooool0
03Oooooo0_l0000:ooooo`;o00001?ooool2o`0000?ooooo0ol0000Hooooo`;o00002_ooool2o`00
00Cooooo0_l00005ooooo`03o`000?oooooooooo01Oooooo0_l0000:ooooo`;o00001?ooool2o`00
00Cooooo0_l0000Hooooo`;o00002_ooool2o`0000Cooooo0_l00003ooooo`?o00007?ooool2o`00
00[ooooo0_l00004ooooo`03o`000?oooooooooo00Oooooo000Aooooo`03o`000?oooooooooo0?oo
oooo3Oooool0017ooooo00?o0000ooooooooool0ooooool=ooooo`004Oooool00ol0003ooooooooo
o`3oooooo`gooooo000Aooooo`03o`000?oooooooooo0?oooooo3Oooool000_oooooool0000Co`00
00?ooooo000Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00oooool7o`0000co
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool00oooool0017ooooo00?o0000ooooooooool0<?ooool00ol0003ooooo
ooooo`0_ooooo`03o`000?oooooooooo02?ooooo0ol0000:ooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0?ooooo`004Oooool00ol0003ooooooooo
o`2;ooooo`;o0000Ooooool0017ooooo00?o0000ooooooooool0SOooool2o`0007gooooo000Aoooo
o`;o0000T?ooool3o`0007[ooooo000Aooooo`03o`000?oooooooooo09;ooooo0_l0001hooooo`00
4Oooool00ol0003oooooooooo`2Dooooo`;o0000M_ooool0017ooooo00?o0000ooooooooool0U_oo
ool2o`0007Cooooo000Aooooo`03o`000?oooooooooo09Sooooo0ol0001aooooo`004Oooool2o`00
09cooooo0ol0001^ooooo`004Oooool00ol0003oooooooooo`2Nooooo`?o0000Joooool0017ooooo
00?o0000ooooooooool0XOooool2o`0006Wooooo000Aooooo`03o`000?oooooooooo0:?ooooo0ol0
001Vooooo`004Oooool00ol0003oooooooooo`2Vooooo`;o0000I?ooool0017ooooo0_l0002Yoooo
o`?o0000HOooool0017ooooo00?o0000ooooooooool0Zoooool3o`0005kooooo000Aooooo`03o`00
0?oooooooooo0:kooooo00?o0000ooooooooool0Foooool0017ooooo00?o0000ooooooooool0[ooo
ool5o`0005Sooooo000Aooooo`03o`000?oooooooooo0;?ooooo00?o0000ooooooooool0E_ooool0
017ooooo0_l0002eooooo`03o`000?oooooooooo05Gooooo000Aooooo`03o`000?oooooooooo0;Co
oooo00?o0000ooooooooool0EOooool0017ooooo00?o0000ooooooooool0]?ooool00ol0003ooooo
ooooo`1Eooooo`000oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0;Cooooo00?o
0000ooooooooool0EOooool000Cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo0;Cooooo0_l0001Fooooo`001?ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000Cooooo0ol0002fooooo`;o0000E?ooool000Cooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;Sooooo00?o
0000ooooooooool0DOooool000Cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo0;Wooooo00?o0000ooooooooool0D?ooool000?ooooo0_l00004
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool00ol0003ooooooooo
o`1?ooooo`001?ooool00ol0003oooooooooo`03ooooo`;o00001Oooool00ol0003oooooooooo`2k
ooooo`03o`000?oooooooooo04kooooo000Aooooo`;o0000_?ooool00ol0003oooooooooo`1>oooo
o`004Oooool00ol0003oooooooooo`2kooooo`03o`000?oooooooooo04kooooo000Aooooo`03o`00
0?oooooooooo0;_ooooo00?o0000ooooooooool0C_ooool0017ooooo00?o0000ooooooooool0_?oo
ool00ol0003oooooooooo`1=ooooo`004Oooool00ol0003oooooooooo`2looooo`03o`000?oooooo
oooo04gooooo000Aooooo`;o0000_Oooool00ol0003oooooooooo`1=ooooo`004Oooool00ol0003o
ooooooooo`2looooo`03o`000?oooooooooo04gooooo000Aooooo`03o`000?oooooooooo0;cooooo
00?o0000ooooooooool0COooool0017ooooo00?o0000ooooooooool0_?ooool00ol0003ooooooooo
o`1=ooooo`004Oooool00ol0003oooooooooo`2looooo`03o`000?oooooooooo04gooooo000Aoooo
o`;o0000_Oooool00ol0003oooooooooo`1=ooooo`004Oooool00ol0003oooooooooo`2looooo`03
o`000?oooooooooo04gooooo000Aooooo`03o`000?oooooooooo0;cooooo00?o0000ooooooooool0
COooool0017ooooo00?o0000ooooooooool0_?ooool00ol0003oooooooooo`1=ooooo`004Oooool0
0ol0003oooooooooo`2looooo`03o`000?oooooooooo04gooooo000Aooooo`03o`000?oooooooooo
0;cooooo00?o0000ooooooooool0COooool0017ooooo0_l0002mooooo`03o`000?oooooooooo04go
oooo000Aooooo`03o`000?oooooooooo0;cooooo0_l0001>ooooo`000_ooool5o`0000?ooooo0_l0
0005ooooo`03o`000?oooooooooo0;gooooo00?o0000ooooooooool0C?ooool000?ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;kooooo
0_l0001<ooooo`001?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool0`?ooool00ol0003oooooooooo`19ooooo`001Oooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooooooool00_ooool3o`000<7ooooo00?o0000ooooooooool0
B?ooool000;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Co
oooo00?o0000ooooooooool0`Oooool00ol0003oooooooooo`18ooooo`000_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`31oooo
o`03o`000?oooooooooo04Sooooo0003ooooo`?o00001?ooool2o`0000Gooooo00?o0000oooooooo
ool0`Oooool00ol0003oooooooooo`18ooooo`004Oooool00ol0003oooooooooo`31ooooo`03o`00
0?oooooooooo04Sooooo000Aooooo`;o0000`_ooool00ol0003oooooooooo`18ooooo`004Oooool0
0ol0003oooooooooo`31ooooo`;o0000BOooool0017ooooo00?o0000ooooooooool0`_ooool00ol0
003oooooooooo`17ooooo`004Oooool00ol0003oooooooooo`33ooooo`03o`000?oooooooooo04Ko
oooo000Aooooo`03o`000?oooooooooo0<Cooooo00?o0000ooooooooool0AOooool0017ooooo0_l0
0035ooooo`03o`000?oooooooooo04Gooooo000Aooooo`03o`000?oooooooooo0<Gooooo00?o0000
ooooooooool0A?ooool0017ooooo00?o0000ooooooooool0a_ooool00ol0003oooooooooo`13oooo
o`004Oooool00ol0003oooooooooo`37ooooo`03o`000?oooooooooo04;ooooo000Aooooo`03o`00
0?oooooooooo0<Sooooo00?o0000ooooooooool0@Oooool0017ooooo0_l0003:ooooo`03o`000?oo
oooooooo043ooooo000Aooooo`03o`000?oooooooooo0<[ooooo00?o0000ooooooooool0?oooool0
017ooooo00?o0000ooooooooool0boooool2o`0003oooooo000Aooooo`03o`000?oooooooooo0<go
oooo00?o0000ooooooooool0??ooool0017ooooo00?o0000ooooooooool0c_ooool00ol0003ooooo
ooooo`0kooooo`004Oooool2o`000=3ooooo00?o0000ooooooooool0>_ooool0017ooooo00?o0000
ooooooooool0d?ooool00ol0003oooooooooo`0iooooo`000oooool3o`0000Cooooo0_l00005oooo
o`03o`000?oooooooooo0=7ooooo00?o0000ooooooooool0>?ooool000;ooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0dOooool0
0ol0003oooooooooo`0hooooo`001_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0d_ooool00ol0003oooooooooo`0gooooo`001?ooool2o`00
00?ooooo00Co0000oooooooooooo00001?ooool3o`000=?ooooo00?o0000ooooooooool0=_ooool0
00Kooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo0=Cooooo00?o0000ooooooooool0=Oooool000;ooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0eOooool00ol0003ooooooooo
o`0dooooo`000oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0=Kooooo00?o0000
ooooooooool0<oooool0017ooooo00?o0000ooooooooool0eoooool00ol0003oooooooooo`0boooo
o`004Oooool2o`000=Sooooo00?o0000ooooooooool0<_ooool0017ooooo00?o0000ooooooooool0
f?ooool00ol0003oooooooooo`0aooooo`004Oooool00ol0003oooooooooo`3Hooooo`03o`000?oo
oooooooo037ooooo000Aooooo`03o`000?oooooooooo0=Wooooo00?o0000ooooooooool0<?ooool0
017ooooo00?o0000ooooooooool0f_ooool00ol0003oooooooooo`0_ooooo`004Oooool2o`000=_o
oooo00?o0000ooooooooool0;oooool0017ooooo00?o0000ooooooooool0foooool00ol0003ooooo
ooooo`0^ooooo`004Oooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo02kooooo000A
ooooo`03o`000?oooooooooo0=cooooo00?o0000ooooooooool0;Oooool0017ooooo00?o0000oooo
ooooool0gOooool00ol0003oooooooooo`0/ooooo`004Oooool2o`000=kooooo00?o0000oooooooo
ool0;?ooool0017ooooo00?o0000ooooooooool0g_ooool00ol0003oooooooooo`0[ooooo`004Ooo
ool00ol0003oooooooooo`3Nooooo`03o`000?oooooooooo02_ooooo000Aooooo`03o`000?oooooo
oooo0=oooooo00?o0000ooooooooool0:_ooool0017ooooo00?o0000ooooooooool0h?ooool00ol0
003oooooooooo`0Yooooo`004Oooool2o`000>7ooooo00?o0000ooooooooool0:Oooool0017ooooo
00?o0000ooooooooool0hOooool00ol0003oooooooooo`0Xooooo`004Oooool00ol0003ooooooooo
o`3Qooooo`03o`000?oooooooooo02Sooooo0004ooooo`?o00000oooool2o`0000Gooooo00?o0000
ooooooooool0h_ooool00ol0003oooooooooo`0Wooooo`001Oooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3Sooooo`03o`000?oooooo
oooo02Kooooo0002ooooo`Go00000_ooool01?l0003oooooooooool00004ooooo`?o0000hoooool0
0ol0003oooooooooo`0Vooooo`000_ooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool0i?ooool00ol0003oooooooooo`0Uooooo`000oooool0
0ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0iOoo
ool00ol0003oooooooooo`0Tooooo`001?ooool2o`0000?ooooo00Co0000oooooooooooo00001?oo
ool00ol0003oooooooooo`3Uooooo`03o`000?oooooooooo02Cooooo0005ooooo`03o`000?oooooo
oooo00;ooooo0_l00005ooooo`03o`000?oooooooooo0>Kooooo00?o0000ooooooooool08oooool0
017ooooo0_l0003Xooooo`03o`000?oooooooooo02;ooooo000Aooooo`03o`000?oooooooooo0>So
oooo00?o0000ooooooooool08Oooool0017ooooo00?o0000ooooooooool0j?ooool00ol0003ooooo
ooooo`0Qooooo`004Oooool00ol0003oooooooooo`3Yooooo`03o`000?oooooooooo023ooooo000A
ooooo`03o`000?oooooooooo0>[ooooo00?o0000ooooooooool07oooool0017ooooo0_l0003[oooo
o`03o`000?oooooooooo01oooooo000Aooooo`03o`000?oooooooooo0>_ooooo00?o0000oooooooo
ool07_ooool0017ooooo00?o0000ooooooooool0k?ooool2o`0001kooooo000Aooooo`03o`000?oo
oooooooo0>kooooo00?o0000ooooooooool06oooool0017ooooo00?o0000ooooooooool0koooool0
0ol0003oooooooooo`0Jooooo`004Oooool2o`000?7ooooo00?o0000ooooooooool06Oooool0017o
oooo00?o0000ooooooooool0lOooool00ol0003oooooooooo`0Hooooo`004Oooool00ol0003ooooo
ooooo`3booooo`03o`000?oooooooooo01Oooooo000Aooooo`03o`000?oooooooooo0?;ooooo00?o
0000ooooooooool05oooool0017ooooo00?o0000ooooooooool0loooool00ol0003oooooooooo`0F
ooooo`004Oooool2o`000?Cooooo00?o0000ooooooooool05_ooool0017ooooo00?o0000oooooooo
ool0m?ooool00ol0003oooooooooo`0Eooooo`004Oooool00ol0003oooooooooo`3dooooo`03o`00
0?oooooooooo01Gooooo0003ooooo`?o00001?ooool2o`0000Gooooo00?o0000ooooooooool0mOoo
ool00ol0003oooooooooo`0Dooooo`000_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001?ooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo01?ooooo
0006ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00_ooool3o`000?Oooooo
00?o0000ooooooooool04_ooool000Kooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo0?Sooooo00?o0000ooooooooool04Oooool000;ooooo1?l0
0003ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0nOooool00ol0003ooooo
ooooo`0@ooooo`000_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool0nOooool00ol0003oooooooooo`0@ooooo`000_ooool5o`0000?ooooo0_l0
0005ooooo`03o`000?oooooooooo0?[ooooo00?o0000ooooooooool03oooool0017ooooo0_l0003k
ooooo`03o`000?oooooooooo00oooooo000Aooooo`03o`000?oooooooooo0?[ooooo00?o0000oooo
ooooool03oooool0017ooooo00?o0000ooooooooool0n_ooool00ol0003oooooooooo`0?ooooo`00
4Oooool00ol0003oooooooooo`3kooooo`03o`000?oooooooooo00kooooo000Aooooo`03o`000?oo
oooooooo0?_ooooo00?o0000ooooooooool03_ooool0017ooooo00?o0000ooooooooool0noooool0
0ol0003oooooooooo`0>ooooo`004Oooool2o`000?gooooo00?o0000ooooooooool03Oooool0017o
oooo00?o0000ooooooooool0o?ooool00ol0003oooooooooo`0=ooooo`004Oooool00ol0003ooooo
ooooo`3looooo`03o`000?oooooooooo00gooooo000Aooooo`03o`000?oooooooooo0?cooooo00?o
0000ooooooooool03Oooool0017ooooo00?o0000ooooooooool0o?ooool00ol0003oooooooooo`0=
ooooo`004Oooool2o`000?kooooo00?o0000ooooooooool03?ooool0017ooooo00?o0000oooooooo
ool0oOooool00ol0003oooooooooo`0<ooooo`004Oooool00ol0003oooooooooo`3mooooo`03o`00
0?oooooooooo00cooooo000Aooooo`03o`000?oooooooooo0?kooooo00?o0000ooooooooool02ooo
ool0017ooooo00?o0000ooooooooool0o_ooool00ol0003oooooooooo`0;ooooo`004Oooool2o`00
0?oooooo00?o0000ooooooooool02oooool0017ooooo00?o0000ooooooooool0o_ooool00ol0003o
ooooooooo`0;ooooo`000oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0?oooooo
00?o0000ooooooooool02_ooool000;ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooooooool0ooooool00ol0003oooooooooo`0:ooooo`00
0_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool00ol0
003oooooooooo`3oooooo`03o`000?oooooooooo00[ooooo0002ooooo`Co00000oooool01?l0003o
ooooooooool00004ooooo`?o0000ooooool1ooooo`03o`000?oooooooooo00Wooooo0002ooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3ooooo
o`7ooooo00?o0000ooooooooool02Oooool000?ooooo00?o0000ooooooooool00oooool01?l0003o
ooooooooool00004ooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0003oooooooooo`09oooo
o`001?ooool2o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0003o
ooooooooo`09ooooo`004Oooool00ol0003oooooooooo`3oooooo`;ooooo00?o0000ooooooooool0
2?ooool0017ooooo0_l0003oooooo`?ooooo00?o0000ooooooooool02?ooool0017ooooo00?o0000
ooooooooool0ooooool2ooooo`03o`000?oooooooooo00Sooooo000Aooooo`03o`000?oooooooooo
0?oooooo0oooool00ol0003oooooooooo`07ooooo`004Oooool00ol0003oooooooooo`3oooooo`?o
oooo00?o0000ooooooooool01oooool0017ooooo00?o0000ooooooooool0ooooool=ooooo`004Ooo
ool2o`000?oooooo3_ooool0017ooooo00?o0000ooooooooool0ooooool=ooooo`004Oooool00ol0
003oooooooooo`3oooooo`gooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.000705566, -4.90917, \
3.96052*^-5, 0.395383}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q4final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 92.3888 0.297897 0.11433 [
[.20859 .2854 -15 -9 ]
[.20859 .2854 15 0 ]
[.39336 .2854 -15 -9 ]
[.39336 .2854 15 0 ]
[.57814 .2854 -15 -9 ]
[.57814 .2854 15 0 ]
[.76292 .2854 -15 -9 ]
[.76292 .2854 15 0 ]
[.9477 .2854 -12 -9 ]
[.9477 .2854 12 0 ]
[.01131 .06924 -12 -4.5 ]
[.01131 .06924 0 4.5 ]
[.01131 .18357 -12 -4.5 ]
[.01131 .18357 0 4.5 ]
[.01131 .41223 -6 -4.5 ]
[.01131 .41223 0 4.5 ]
[.01131 .52656 -6 -4.5 ]
[.01131 .52656 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20859 .2979 m
.20859 .30415 L
s
[(0.002)] .20859 .2854 0 1 Mshowa
.39336 .2979 m
.39336 .30415 L
s
[(0.004)] .39336 .2854 0 1 Mshowa
.57814 .2979 m
.57814 .30415 L
s
[(0.006)] .57814 .2854 0 1 Mshowa
.76292 .2979 m
.76292 .30415 L
s
[(0.008)] .76292 .2854 0 1 Mshowa
.9477 .2979 m
.9477 .30415 L
s
[(0.01)] .9477 .2854 0 1 Mshowa
.125 Mabswid
.07 .2979 m
.07 .30165 L
s
.1162 .2979 m
.1162 .30165 L
s
.16239 .2979 m
.16239 .30165 L
s
.25478 .2979 m
.25478 .30165 L
s
.30098 .2979 m
.30098 .30165 L
s
.34717 .2979 m
.34717 .30165 L
s
.43956 .2979 m
.43956 .30165 L
s
.48575 .2979 m
.48575 .30165 L
s
.53195 .2979 m
.53195 .30165 L
s
.62434 .2979 m
.62434 .30165 L
s
.67053 .2979 m
.67053 .30165 L
s
.71673 .2979 m
.71673 .30165 L
s
.80911 .2979 m
.80911 .30165 L
s
.85531 .2979 m
.85531 .30165 L
s
.9015 .2979 m
.9015 .30165 L
s
.99389 .2979 m
.99389 .30165 L
s
.25 Mabswid
0 .2979 m
1 .2979 L
s
.02381 .06924 m
.03006 .06924 L
s
[(-2)] .01131 .06924 1 0 Mshowa
.02381 .18357 m
.03006 .18357 L
s
[(-1)] .01131 .18357 1 0 Mshowa
.02381 .41223 m
.03006 .41223 L
s
[(1)] .01131 .41223 1 0 Mshowa
.02381 .52656 m
.03006 .52656 L
s
[(2)] .01131 .52656 1 0 Mshowa
.125 Mabswid
.02381 .0921 m
.02756 .0921 L
s
.02381 .11497 m
.02756 .11497 L
s
.02381 .13783 m
.02756 .13783 L
s
.02381 .1607 m
.02756 .1607 L
s
.02381 .20643 m
.02756 .20643 L
s
.02381 .2293 m
.02756 .2293 L
s
.02381 .25217 m
.02756 .25217 L
s
.02381 .27503 m
.02756 .27503 L
s
.02381 .32076 m
.02756 .32076 L
s
.02381 .34363 m
.02756 .34363 L
s
.02381 .3665 m
.02756 .3665 L
s
.02381 .38936 m
.02756 .38936 L
s
.02381 .43509 m
.02756 .43509 L
s
.02381 .45796 m
.02756 .45796 L
s
.02381 .48083 m
.02756 .48083 L
s
.02381 .50369 m
.02756 .50369 L
s
.02381 .04637 m
.02756 .04637 L
s
.02381 .0235 m
.02756 .0235 L
s
.02381 .00064 m
.02756 .00064 L
s
.02381 .54942 m
.02756 .54942 L
s
.02381 .57229 m
.02756 .57229 L
s
.02381 .59516 m
.02756 .59516 L
s
.02381 .61802 m
.02756 .61802 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .04251 m
.02499 .04251 L
.02605 .04251 L
.02729 .04251 L
.02846 .04251 L
.02954 .04251 L
.03053 .04251 L
.03163 .04251 L
.03279 .04251 L
.03395 .04251 L
.0352 .04251 L
.03628 .04251 L
.03746 .04251 L
.03818 .04251 L
.03884 .04251 L
.04016 .04251 L
.04135 .04251 L
.04262 .04251 L
.04519 .04251 L
.04589 .04251 L
.04664 .04251 L
.04797 .04251 L
.04923 .04251 L
.04992 .04251 L
.05058 .04251 L
.05185 .04251 L
.05302 .04251 L
.05406 .04251 L
.05517 .04251 L
.05639 .04251 L
.05751 .04251 L
.05864 .04251 L
.05986 .04251 L
.06055 .04251 L
.06119 .04251 L
.06244 .0425 L
.06373 .0425 L
.0649 .0425 L
.06555 .0425 L
.06625 .0425 L
.06752 .0425 L
.07225 .0425 L
.07783 .0425 L
.08048 .04249 L
.08178 .04249 L
.08297 .04249 L
.08538 .04249 L
.08797 .04249 L
.09347 .04248 L
.09885 .04247 L
Mistroke
.10458 .04246 L
.11445 .04243 L
.1236 .04239 L
.13449 .04233 L
.14434 .04225 L
.16363 .04205 L
.17448 .04189 L
.18446 .04172 L
.20332 .04127 L
.224 .04061 L
.24355 .03978 L
.26448 .0386 L
.30589 .03531 L
.34579 .03088 L
.38417 .02565 L
.40359 .02279 L
.425 .01985 L
.43477 .01871 L
.4453 .01754 L
.45523 .01672 L
.46432 .01613 L
.46908 .01588 L
.47169 .01578 L
.47297 .01571 L
.47415 .01567 L
.47645 .0156 L
.47894 .01554 L
.48103 .01549 L
.48219 .01546 L
.48328 .01544 L
.48458 .01543 L
.48576 .01541 L
.48687 .0154 L
.48808 .01539 L
.48876 .01539 L
.48941 .01539 L
.49008 .01539 L
.49082 .01538 L
.49204 .01538 L
.49335 .01539 L
.49464 .01539 L
.49537 .01539 L
.49605 .0154 L
.4989 .01543 L
.504 .01549 L
.50904 .01559 L
.51169 .01563 L
.51239 .01564 L
.51314 .01565 L
.51384 .01567 L
Mistroke
.5145 .01568 L
.51579 .0157 L
.51696 .01571 L
.51764 .01572 L
.51836 .01573 L
.51967 .01574 L
.52084 .01575 L
.52194 .01576 L
.52325 .01575 L
.52443 .01575 L
.52551 .01574 L
.52669 .01572 L
.52785 .0157 L
.52908 .01566 L
.53024 .01561 L
.53129 .01556 L
.53336 .01545 L
.53459 .01538 L
.53573 .01526 L
.53832 .01507 L
.53951 .01492 L
.54077 .01484 L
.54193 .01478 L
.54301 .01473 L
.54408 .01472 L
.54523 .01475 L
.5465 .01481 L
.54765 .01498 L
.54888 .01522 L
.54953 .01534 L
.55022 .01542 L
.55148 .01589 L
.55265 .01621 L
.55372 .01654 L
.55487 .01689 L
.55596 .01744 L
.55695 .01793 L
.56169 .02038 L
.5823 .03392 L
.60133 .0501 L
.62208 .07118 L
.6418 .09717 L
.66279 .13598 L
.67312 .1605 L
.67854 .17623 L
.68426 .19521 L
.68669 .20568 L
.68733 .20954 L
.68802 .21097 L
.68928 .21841 L
Mistroke
.69006 .22261 L
.69077 .22229 L
.69143 .21129 L
.69213 .20998 L
.69339 .20252 L
.69411 .20106 L
.69479 .19954 L
.69593 .19622 L
.69717 .19326 L
.69835 .19194 L
.69944 .19094 L
.70071 .1898 L
.70141 .18968 L
.70206 .1895 L
.70329 .18953 L
.70445 .19001 L
.70561 .19055 L
.70685 .19125 L
.70803 .19277 L
.7091 .19427 L
.71175 .19827 L
.71292 .2005 L
.71421 .20249 L
.71544 .20658 L
.71674 .21015 L
.71816 .21545 L
.71882 .2169 L
.7195 .22108 L
.72076 .34631 L
.72191 .37759 L
.72316 .37852 L
.72386 .37912 L
.72452 .37923 L
.72567 .37993 L
.72692 .3802 L
.72811 .38033 L
.7292 .38031 L
.73018 .38014 L
.73126 .37977 L
.73238 .37938 L
.73345 .37892 L
.73469 .37822 L
.73582 .37716 L
.73715 .37634 L
.73838 .37537 L
.73944 .37594 L
.74058 .37934 L
.74299 .38557 L
.75329 .419 L
.75612 .42696 L
Mistroke
.75766 .43146 L
.7591 .43452 L
.76164 .43861 L
.76443 .44255 L
.76705 .44546 L
.76834 .44667 L
.76953 .44763 L
.77061 .44823 L
.77176 .44879 L
.77417 .45035 L
.77962 .45381 L
.78077 .45454 L
.782 .45536 L
.78271 .45621 L
.78335 .45715 L
.78461 .45818 L
.78574 .45945 L
.78696 .46178 L
.78812 .46321 L
.78919 .4647 L
.794 .47366 L
.80411 .49961 L
.80871 .51122 L
.80986 .51412 L
.81095 .51701 L
.81193 .51899 L
.813 .52066 L
.81516 .52366 L
.81626 .52527 L
.81748 .52736 L
.81872 .52837 L
.82003 .5296 L
.82126 .53069 L
.8224 .53123 L
.82363 .53169 L
.82474 .53205 L
.82598 .53212 L
.82666 .53201 L
.8273 .53197 L
.82859 .53125 L
.82978 .53059 L
.83109 .5293 L
.83175 .52854 L
.83247 .52702 L
.83365 .52513 L
.83477 .52174 L
.83606 .51614 L
.83724 .5126 L
.84171 .49844 L
.843 .49612 L
Mistroke
.84422 .49264 L
.84489 .4922 L
.84562 .49087 L
.84688 .48862 L
.8481 .48705 L
.84938 .48617 L
.85059 .48518 L
.85168 .48475 L
.85298 .48472 L
.85369 .48493 L
.85436 .48532 L
.85558 .48607 L
.85687 .48714 L
.85754 .48825 L
.85828 .48975 L
.85959 .49152 L
.86033 .49357 L
.86112 .4959 L
.86256 .50001 L
.87206 .53905 L
.87728 .56001 L
.87985 .56929 L
.88097 .57329 L
.88221 .57769 L
.88291 .5791 L
.88357 .57996 L
.88427 .58209 L
.88501 .58401 L
.88583 .58575 L
.8866 .58672 L
.88805 .58891 L
.8908 .59278 L
.89214 .59447 L
.89335 .59588 L
.89459 .59676 L
.89575 .59782 L
.8983 .5997 L
.90088 .60134 L
.90159 .60178 L
.90234 .60205 L
.90371 .6025 L
.90501 .60286 L
.90624 .60317 L
.90734 .60328 L
.90854 .60332 L
.90982 .60318 L
.91053 .60311 L
.91119 .60297 L
.91235 .60257 L
.91364 .60166 L
Mistroke
.91481 .6009 L
.91593 .59991 L
.91693 .59835 L
.91803 .59526 L
.92046 .58852 L
.92166 .58486 L
.92276 .58162 L
.92406 .57964 L
.92547 .57671 L
.92666 .57489 L
.92792 .57356 L
.93077 .57004 L
.93148 .56917 L
.93216 .56834 L
.93343 .56763 L
.93461 .56679 L
.93571 .56623 L
.93688 .56604 L
.93815 .56602 L
.93935 .56644 L
.94067 .56703 L
.94133 .5678 L
.94204 .56842 L
.94334 .57009 L
.94434 .57168 L
.94525 .57361 L
.94729 .57862 L
.94921 .58515 L
.95005 .58829 L
.95098 .59101 L
.95198 .59332 L
.95304 .59579 L
.95419 .59824 L
.95528 .59933 L
.9563 .60006 L
.95723 .60041 L
.95831 .60035 L
.95934 .59986 L
.9604 .59861 L
.96136 .59698 L
.96247 .59386 L
.96352 .59101 L
.96538 .58397 L
.96643 .57919 L
.9674 .57284 L
.97619 .49181 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`003oooool2o`000?oooooo4?ooool000oooooo00?o0000ooooooooool0
ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooo
oooo0?oooooo3oooool000oooooo00?o0000ooooooooool0NOoooolHo`0007gooooo000?ooooo`03
o`000?oooooooooo06kooooo2ol0000Gooooo`?o0000Noooool000oooooo00?o0000ooooooooool0
I?ooool:o`0002Gooooo0_l0001iooooo`003oooool2o`00063ooooo1Ol0000aooooo`03o`000?oo
oooooooo07Kooooo000?ooooo`03o`000?oooooooooo05[ooooo1Ol0000gooooo`03o`000?oooooo
oooo07Gooooo000?ooooo`03o`000?oooooooooo057ooooo2Ol0000mooooo`03o`000?oooooooooo
07Cooooo000?ooooo`03o`000?oooooooooo04Kooooo2ol00017ooooo`;o0000M?ooool000oooooo
00?o0000ooooooooool0<_oooolDo`0005Cooooo00?o0000ooooooooool0LOooool000oooooo=Ol0
001Yooooo`;o0000LOooool000oooooo0_l0002Nooooo`03o`000?oooooooooo06kooooo000?oooo
o`03o`000?oooooooooo09kooooo00?o0000ooooooooool0KOooool000oooooo00?o0000oooooooo
ool0W_ooool00ol0003oooooooooo`1]ooooo`003oooool00ol0003oooooooooo`2Oooooo`03o`00
0?oooooooooo06cooooo0006ooooo`Go00001?ooool00ol0003oooooooooo`2Pooooo`03o`000?oo
oooooooo06_ooooo0007ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0XOoo
ool00ol0003oooooooooo`1Zooooo`001Ol00003ooooo`03o`000?oooooooooo00Cooooo0ol0002R
ooooo`03o`000?oooooooooo06Wooooo0009ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0Xoooool00ol0003oooooooooo`1Xooooo`001_ooool01Ol0003ooooooooooooooooo0000
00Cooooo00?o0000ooooooooool0Xoooool00ol0003oooooooooo`1Xooooo`001_ooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`1Woooo
o`001oooool3o`0000Gooooo00?o0000ooooooooool0YOooool00ol0003oooooooooo`1Vooooo`00
3oooool00ol0003oooooooooo`2Vooooo`03o`000?oooooooooo06Gooooo000?ooooo`03o`000?oo
oooooooo0:Oooooo00?o0000ooooooooool0I?ooool000oooooo0_l0002Yooooo`03o`000?oooooo
oooo06?ooooo000?ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool0H_ooool000oo
oooo00?o0000ooooooooool0ZOooool00ol0003oooooooooo`1Rooooo`003oooool00ol0003ooooo
ooooo`2Zooooo`03o`000?oooooooooo067ooooo000?ooooo`03o`000?oooooooooo0:[ooooo00?o
0000ooooooooool0HOooool000oooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`1P
ooooo`003oooool2o`000:cooooo00?o0000ooooooooool0H?ooool000oooooo00?o0000oooooooo
ool0[?ooool00ol0003oooooooooo`1Oooooo`003oooool00ol0003oooooooooo`2]ooooo`03o`00
0?oooooooooo05kooooo000?ooooo`03o`000?oooooooooo0:gooooo00?o0000ooooooooool0G_oo
ool000oooooo00?o0000ooooooooool0[_ooool00ol0003oooooooooo`1Mooooo`003oooool00ol0
003oooooooooo`2^ooooo`03o`000?oooooooooo05gooooo000?ooooo`;o0000/?ooool00ol0003o
ooooooooo`1Looooo`003oooool00ol0003oooooooooo`2_ooooo`03o`000?oooooooooo05cooooo
000?ooooo`03o`000?oooooooooo0;3ooooo00?o0000ooooooooool0Foooool000oooooo00?o0000
ooooooooool0/?ooool00ol0003oooooooooo`1Kooooo`003oooool00ol0003oooooooooo`2aoooo
o`03o`000?oooooooooo05[ooooo000?ooooo`03o`000?oooooooooo0;7ooooo00?o0000oooooooo
ool0F_ooool000oooooo00?o0000ooooooooool0/Oooool00ol0003oooooooooo`1Jooooo`003ooo
ool2o`000;?ooooo00?o0000ooooooooool0FOooool000oooooo00?o0000ooooooooool0/_ooool0
0ol0003oooooooooo`1Iooooo`003oooool00ol0003oooooooooo`2booooo`03o`000?oooooooooo
05Wooooo000?ooooo`03o`000?oooooooooo0;?ooooo00?o0000ooooooooool0F?ooool000Oooooo
0ol00005ooooo`03o`000?oooooooooo0;?ooooo00?o0000ooooooooool0F?ooool000Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`2cooooo`03o`000?oooooooooo05Sooooo0005
o`0000?ooooo00?o0000ooooooooool01?ooool3o`000;Cooooo00?o0000ooooooooool0Eoooool0
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2dooooo`03o`000?oooooooooo
05Oooooo0008ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0]?ooool00ol0003o
ooooooooo`02ooooo`?o0000D_ooool000Oooooo0_l00006ooooo`03o`000?oooooooooo0;Gooooo
00Co0000oooooooooooo00000_ooool2o`00057ooooo0008ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0]Oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo04oo
oooo000?ooooo`03o`000?oooooooooo0;Gooooo00Co0000ooooool0003o00001?ooool00ol0003o
ooooooooo`1>ooooo`003oooool2o`000;Kooooo00?o0000ooooool000001Oooool00ol0003ooooo
ooooo`1>ooooo`003oooool00ol0003oooooooooo`2fooooo`;o00001Oooool00ol0003ooooooooo
o`1>ooooo`003oooool00ol0003oooooooooo`2fooooo`;o00001_ooool00ol0003oooooooooo`1=
ooooo`003oooool00ol0003oooooooooo`2fooooo`;o00001_ooool00ol0003oooooooooo`1=oooo
o`003oooool00ol0003oooooooooo`2fooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0COooool000oooooo00?o0000ooooooooool0]_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo04gooooo000?ooooo`03o`000?oooooooooo0;kooooo00?o0000ooooooooool0COoo
ool000oooooo0_l0002oooooo`03o`000?oooooooooo04gooooo000?ooooo`03o`000?oooooooooo
0;kooooo00?o0000ooooooooool0COooool000oooooo00?o0000ooooooooool0__ooool00ol0003o
ooooooooo`1=ooooo`003oooool00ol0003oooooooooo`2nooooo`03o`000?oooooooooo04gooooo
000?ooooo`03o`000?oooooooooo0;kooooo00?o0000ooooooooool0COooool000oooooo00?o0000
ooooooooool0__ooool00ol0003oooooooooo`1=ooooo`003oooool2o`000;oooooo00?o0000oooo
ooooool0COooool000oooooo00?o0000ooooooooool08oooool2o`0000Cooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00002ooooo`Go00006Oooool2o`0000Cooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00004ooooo`?o00006?ooool2o`0000Cooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00003ooooo`?o00006_ooool2o`0000Cooooo00?o0000oooooooo
ool00oooool2o`0000Cooooo0_l00003ooooo`?o00007?ooool2o`0000Cooooo00?o0000oooooooo
ool00oooool2o`0000?ooooo0ol00006ooooo`003oooool00ol0003oooooooooo`0Rooooo`04o`00
0?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0001Sooooo00Co0000oooooooooooo00002?ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool05_ooool01?l0
003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000
ooooool00003ooooo`03o`000?oooooooooo01Kooooo0_l000000ooooooo0000ooooo`07ooooo`04
o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oo
oooooooo01Sooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00003ooooo`03
o`000?oooooooooo00Gooooo000?ooooo`03o`000?oooooooooo02;ooooo00Co0000oooooooooooo
00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool06?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo
00Go0000oooooooooooo0000ooooo`05o`0001Oooooo00Co0000oooooooooooo00002?ooool01?l0
003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003ooooo
ooooo`0Fooooo`;o000000?oooooo`000?ooool01oooool01?l0003oooooooooool00002ooooo`06
o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Hooooo`04o`000?oooooo
ooooo`0000Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`05ooooo`003ooo
ool00ol0003oooooooooo`0Rooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo01Oooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo
00000_ooool00ol0003oooooooooo`0Fooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooo
oooooooo00000_ooool01Ol0003oooooooooool0003ooooo00Co00006Oooool2o`000003ooooool0
003ooooo00Oooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`?o
00006oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool01Oooool000oooooo00?o0000ooooooooool08_ooool01?l0003oooooooooool00008
ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03
o`000?oooooooooo01Kooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooool000006?ooool01?l0003ooooooooo
ool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool0000L
ooooo`;o000000?oooooo`000?ooool01oooool01?l0003oooooooooool00002ooooo`06o`000?oo
ooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Hooooo`04o`000?ooooooooooo`00
00Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`05ooooo`003oooool00ol0
003oooooooooo`0Rooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool05_ooool01?l0003o
ooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000ooo
ool2o`0001Sooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06Oooool2o`000003ooooool0003ooooo
00Oooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000?ooooo
00?o0000ooooooooool06?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`00
00;ooooo0_l00007ooooo`003oooool2o`0002Cooooo0_l0000:ooooo`;o00001?ooool2o`0000?o
oooo0ol0000Jooooo`;o00002_ooool2o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo01Oo
oooo0_l0000:ooooo`;o00001?ooool2o`0000Cooooo0_l0000Jooooo`;o00002_ooool2o`0000Co
oooo0_l00003ooooo`?o00007?ooool2o`0000[ooooo0_l00004ooooo`03o`000?oooooooooo00Go
oooo000?ooooo`03o`000?oooooooooo0;kooooo00?o0000ooooooooool0COooool000oooooo00?o
0000ooooooooool0__ooool00ol0003oooooooooo`1=ooooo`003oooool00ol0003oooooooooo`2o
ooooo`03o`000?oooooooooo04cooooo000?ooooo`03o`000?oooooooooo0;oooooo00?o0000oooo
ooooool0C?ooool000oooooo00?o0000ooooooooool0_oooool00ol0003oooooooooo`1<ooooo`00
2?ooooooo`0001Wo0000000?ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`;o00002oooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo0Ol00001ooooo`7ooooo000?ooooo`03o`000?oooooooooo033ooooo00?o0000
ooooooooool0<Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo00gooooo000?oooo
o`03o`000?oooooooooo0;oooooo00?o0000ooooooooool0C?ooool000oooooo00?o0000oooooooo
ool0_oooool00ol0003oooooooooo`1<ooooo`003oooool00ol0003oooooooooo`2oooooo`03o`00
0?oooooooooo04cooooo000?ooooo`;o0000`?ooool00ol0003oooooooooo`1<ooooo`003oooool0
0ol0003oooooooooo`2oooooo`03o`000?oooooooooo04cooooo000?ooooo`03o`000?oooooooooo
0;oooooo00?o0000ooooooooool0C?ooool000oooooo00?o0000ooooooooool0_oooool00ol0003o
ooooooooo`1<ooooo`003oooool00ol0003oooooooooo`2oooooo`03o`000?oooooooooo04cooooo
000?ooooo`03o`000?oooooooooo0;oooooo00?o0000ooooooooool0C?ooool000oooooo00?o0000
ooooooooool0_oooool00ol0003oooooooooo`1<ooooo`003oooool2o`000<3ooooo00?o0000oooo
ooooool0C?ooool000oooooo00?o0000ooooooooool0_oooool00ol0003oooooooooo`1<ooooo`00
3oooool00ol0003oooooooooo`2oooooo`03o`000?oooooooooo04cooooo000?ooooo`03o`000?oo
oooooooo0;oooooo00?o0000ooooooooool0C?ooool000oooooo00?o0000ooooooooool0_oooool0
0ol0003oooooooooo`1<ooooo`003oooool00ol0003oooooooooo`2oooooo`03o`000?oooooooooo
04cooooo000?ooooo`;o0000`?ooool00ol0003oooooooooo`1<ooooo`003oooool00ol0003ooooo
ooooo`2oooooo`03o`000?oooooooooo04cooooo000?ooooo`03o`000?oooooooooo0;oooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`17ooooo`003oooool00ol0003oooooooooo`2o
ooooo`03o`000?oooooooooo00?o0000BOooool000oooooo00?o0000ooooooooool0`?ooool3o`00
0003ooooool0003ooooo04Sooooo000?ooooo`03o`000?oooooooooo0<Gooooo00?o0000oooooooo
ool0A_ooool000oooooo0_l00036ooooo`03o`000?oooooooooo04Kooooo000?ooooo`03o`000?oo
oooooooo0<Gooooo00?o0000ooooooooool0A_ooool000oooooo00?o0000ooooooooool0a_ooool0
0ol0003oooooooooo`15ooooo`003oooool00ol0003oooooooooo`36ooooo`03o`000?oooooooooo
04Gooooo0007ooooo`?o00001Oooool00ol0003oooooooooo`36ooooo`03o`000?oooooooooo04Go
oooo0008ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0aoooool00ol0003ooooo
ooooo`14ooooo`002?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0<Oooooo00?o
0000ooooooooool0A?ooool000Sooooo00?o0000ooooooooool01?ooool3o`000<Oooooo00?o0000
ooooooooool0A?ooool000Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`38oooo
o`03o`000?oooooooooo04?ooooo0007ooooo`;o00001_ooool00ol0003oooooooooo`38ooooo`03
o`000?oooooooooo04?ooooo0008ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
b?ooool00ol0003oooooooooo`13ooooo`003oooool00ol0003oooooooooo`39ooooo`03o`000?oo
oooooooo04;ooooo000?ooooo`03o`000?oooooooooo0<Wooooo00?o0000ooooooooool0@_ooool0
00oooooo0_l0003:ooooo`03o`000?oooooooooo04;ooooo000?ooooo`03o`000?oooooooooo0<[o
oooo00?o0000ooooooooool0@Oooool000oooooo00?o0000ooooooooool0boooool00ol0003ooooo
ooooo`10ooooo`003oooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo03oooooo000?
ooooo`03o`000?oooooooooo0<cooooo0ol0000oooooo`003oooool00ol0003oooooooooo`3?oooo
o`03o`000?oooooooooo03cooooo000?ooooo`;o0000dOooool00ol0003oooooooooo`0kooooo`00
3oooool00ol0003oooooooooo`3Aooooo`03o`000?oooooooooo03[ooooo000?ooooo`03o`000?oo
oooooooo0=7ooooo0_l0000kooooo`003oooool00ol0003oooooooooo`3Booooo`03o`000?oooooo
oooo03Wooooo000?ooooo`03o`000?oooooooooo0=?ooooo00?o0000ooooooooool0>?ooool000oo
oooo00?o0000ooooooooool0doooool00ol0003oooooooooo`0hooooo`003oooool00ol0003ooooo
ooooo`3Cooooo`03o`000?oooooooooo03Sooooo000?ooooo`;o0000eOooool00ol0003ooooooooo
o`0gooooo`003oooool00ol0003oooooooooo`3Dooooo`03o`000?oooooooooo00cooooo0_l0000Y
ooooo`003oooool00ol0003oooooooooo`3Eooooo`03o`000?oooooooooo00[ooooo00Co0000oooo
oooooooo0000:?ooool000oooooo00?o0000ooooooooool0eOooool00ol0003oooooooooo`09oooo
o`;o00000_ooool2o`0001oooooo00?o0000ooooooooool01Oooool000oooooo00?o0000oooooooo
ool0eOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`05ooooo`003oooool00ol0003oooooooooo`3Fooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00Gooooo000?ooooo`;o0000eoooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`05ooooo`003oooool0
0ol0003oooooooooo`3Gooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Gooooo000?ooooo`03o`000?oooooooooo
0=Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool01_ooool000oooooo00?o0000ooooooooool0f?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`06ooooo`001_ooool5o`0000Cooooo00?o0000ooooooooool0f?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`06ooooo`001oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0=Sooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool01_ooool000Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`3Iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo00Kooooo0009ooooo`03o`000?oooooooooo00?ooooo0ol0003J
ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0Jooooo`03o`000?oo
oooooooo00Kooooo0006ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`3Kooooo`?o00002_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00Kooooo0006
ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3Yooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool01oooool000Oooooo0ol00005ooooo`03o`000?oooooo
oooo0>Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`003oooool00ol0
003oooooooooo`3Yooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool000oo
oooo00?o0000ooooooooool0jOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oo
oooo000?ooooo`;o0000j_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo
000?ooooo`03o`000?oooooooooo0>[ooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`07ooooo`003oooool00ol0003oooooooooo`3Zooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool01oooool000oooooo00?o0000ooooooooool0j_ooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo00Sooooo000?ooooo`03o`000?oooooooooo0>[ooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`08ooooo`003oooool00ol0003oooooooooo`3[ooooo`03o`00
0?oooooooooo00_ooooo1?l00006ooooo`03o`000?oooooooooo00Sooooo000?ooooo`;o0000k?oo
ool00ol0003oooooooooo`0;ooooo`05o`000?ooooooooooooooool000001Oooool00ol0003ooooo
ooooo`08ooooo`003oooool00ol0003oooooooooo`3[ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo000?
ooooo`03o`000?oooooooooo0>cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02?ooool000oooooo00?o0000oooo
ooooool0k?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`08ooooo`003oooool00ol0003oooooooooo`3]ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00Sooooo000?ooooo`03o`000?oooooooooo0>gooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000_ooooo000?ooooo`03o`00
0?oooooooooo0>kooooo0_l00006ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo
00002oooool000oooooo0_l0003`ooooo`;o00001Oooool00ol0003oooooooooo`06ooooo`;o0000
00?oooooo`000?ooool02_ooool000oooooo00?o0000ooooooooool0l?ooool2o`0000;ooooo0_l0
000:ooooo`;o00003?ooool000oooooo00?o0000ooooooooool0lOooool4o`0001Wooooo000?oooo
o`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`00
3oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`;o0000ooooool@ooooo`00oooooolQ
ooooo`00oooooolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.000602321, -2.68478, \
3.89146*^-5, 0.0314464}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[xfinal[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 92.3888 0.119805 0.00822914 [
[.20859 .10731 -15 -9 ]
[.20859 .10731 15 0 ]
[.39336 .10731 -15 -9 ]
[.39336 .10731 15 0 ]
[.57814 .10731 -15 -9 ]
[.57814 .10731 15 0 ]
[.76292 .10731 -15 -9 ]
[.76292 .10731 15 0 ]
[.9477 .10731 -12 -9 ]
[.9477 .10731 12 0 ]
[.01131 .03751 -18 -4.5 ]
[.01131 .03751 0 4.5 ]
[.01131 .2021 -12 -4.5 ]
[.01131 .2021 0 4.5 ]
[.01131 .28439 -12 -4.5 ]
[.01131 .28439 0 4.5 ]
[.01131 .36668 -12 -4.5 ]
[.01131 .36668 0 4.5 ]
[.01131 .44897 -12 -4.5 ]
[.01131 .44897 0 4.5 ]
[.01131 .53126 -12 -4.5 ]
[.01131 .53126 0 4.5 ]
[.01131 .61355 -12 -4.5 ]
[.01131 .61355 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20859 .11981 m
.20859 .12606 L
s
[(0.002)] .20859 .10731 0 1 Mshowa
.39336 .11981 m
.39336 .12606 L
s
[(0.004)] .39336 .10731 0 1 Mshowa
.57814 .11981 m
.57814 .12606 L
s
[(0.006)] .57814 .10731 0 1 Mshowa
.76292 .11981 m
.76292 .12606 L
s
[(0.008)] .76292 .10731 0 1 Mshowa
.9477 .11981 m
.9477 .12606 L
s
[(0.01)] .9477 .10731 0 1 Mshowa
.125 Mabswid
.07 .11981 m
.07 .12356 L
s
.1162 .11981 m
.1162 .12356 L
s
.16239 .11981 m
.16239 .12356 L
s
.25478 .11981 m
.25478 .12356 L
s
.30098 .11981 m
.30098 .12356 L
s
.34717 .11981 m
.34717 .12356 L
s
.43956 .11981 m
.43956 .12356 L
s
.48575 .11981 m
.48575 .12356 L
s
.53195 .11981 m
.53195 .12356 L
s
.62434 .11981 m
.62434 .12356 L
s
.67053 .11981 m
.67053 .12356 L
s
.71673 .11981 m
.71673 .12356 L
s
.80911 .11981 m
.80911 .12356 L
s
.85531 .11981 m
.85531 .12356 L
s
.9015 .11981 m
.9015 .12356 L
s
.99389 .11981 m
.99389 .12356 L
s
.25 Mabswid
0 .11981 m
1 .11981 L
s
.02381 .03751 m
.03006 .03751 L
s
[(-10)] .01131 .03751 1 0 Mshowa
.02381 .2021 m
.03006 .2021 L
s
[(10)] .01131 .2021 1 0 Mshowa
.02381 .28439 m
.03006 .28439 L
s
[(20)] .01131 .28439 1 0 Mshowa
.02381 .36668 m
.03006 .36668 L
s
[(30)] .01131 .36668 1 0 Mshowa
.02381 .44897 m
.03006 .44897 L
s
[(40)] .01131 .44897 1 0 Mshowa
.02381 .53126 m
.03006 .53126 L
s
[(50)] .01131 .53126 1 0 Mshowa
.02381 .61355 m
.03006 .61355 L
s
[(60)] .01131 .61355 1 0 Mshowa
.125 Mabswid
.02381 .05397 m
.02756 .05397 L
s
.02381 .07043 m
.02756 .07043 L
s
.02381 .08689 m
.02756 .08689 L
s
.02381 .10335 m
.02756 .10335 L
s
.02381 .13626 m
.02756 .13626 L
s
.02381 .15272 m
.02756 .15272 L
s
.02381 .16918 m
.02756 .16918 L
s
.02381 .18564 m
.02756 .18564 L
s
.02381 .21856 m
.02756 .21856 L
s
.02381 .23501 m
.02756 .23501 L
s
.02381 .25147 m
.02756 .25147 L
s
.02381 .26793 m
.02756 .26793 L
s
.02381 .30085 m
.02756 .30085 L
s
.02381 .3173 m
.02756 .3173 L
s
.02381 .33376 m
.02756 .33376 L
s
.02381 .35022 m
.02756 .35022 L
s
.02381 .38314 m
.02756 .38314 L
s
.02381 .3996 m
.02756 .3996 L
s
.02381 .41605 m
.02756 .41605 L
s
.02381 .43251 m
.02756 .43251 L
s
.02381 .46543 m
.02756 .46543 L
s
.02381 .48189 m
.02756 .48189 L
s
.02381 .49835 m
.02756 .49835 L
s
.02381 .5148 m
.02756 .5148 L
s
.02381 .54772 m
.02756 .54772 L
s
.02381 .56418 m
.02756 .56418 L
s
.02381 .58064 m
.02756 .58064 L
s
.02381 .5971 m
.02756 .5971 L
s
.02381 .02106 m
.02756 .02106 L
s
.02381 .0046 m
.02756 .0046 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .1775 m
.02499 .1775 L
.02605 .1775 L
.02729 .1775 L
.02846 .1775 L
.02954 .1775 L
.03053 .1775 L
.03163 .1775 L
.03279 .1775 L
.03395 .1775 L
.0352 .1775 L
.03628 .1775 L
.03746 .1775 L
.03818 .1775 L
.03884 .1775 L
.04016 .1775 L
.04135 .1775 L
.04262 .1775 L
.04519 .1775 L
.04589 .1775 L
.04664 .1775 L
.04797 .1775 L
.04923 .1775 L
.04992 .1775 L
.05058 .1775 L
.05185 .1775 L
.05302 .1775 L
.05406 .1775 L
.05517 .1775 L
.05639 .1775 L
.05751 .1775 L
.05864 .1775 L
.05986 .1775 L
.06055 .1775 L
.06119 .1775 L
.06244 .1775 L
.06373 .1775 L
.0649 .1775 L
.06555 .1775 L
.06625 .1775 L
.06752 .17749 L
.07225 .17749 L
.07783 .17749 L
.08048 .17748 L
.08178 .17748 L
.08297 .17748 L
.08538 .17748 L
.08797 .17747 L
.09347 .17746 L
.09885 .17745 L
Mistroke
.10458 .17744 L
.11445 .1774 L
.1236 .17736 L
.13449 .17728 L
.14434 .17719 L
.16363 .17694 L
.17448 .17675 L
.18446 .17654 L
.20332 .17598 L
.224 .17517 L
.24355 .17413 L
.26448 .17261 L
.28576 .17064 L
.30589 .16824 L
.34427 .16221 L
.36408 .15796 L
.3851 .1529 L
.42291 .14116 L
.44392 .13314 L
.46316 .12428 L
.5019 .10107 L
.52086 .08629 L
.54158 .06729 L
.56287 .04661 L
.58219 .02952 L
.59186 .02312 L
.59694 .02012 L
.60232 .01774 L
.60702 .01624 L
.60831 .016 L
.60904 .01578 L
.6097 .01561 L
.61098 .01541 L
.61219 .01524 L
.61328 .01505 L
.6143 .01492 L
.61537 .01483 L
.61655 .01477 L
.61773 .01473 L
.61901 .01472 L
.6202 .01473 L
.62129 .01477 L
.62256 .01488 L
.62377 .015 L
.62486 .01511 L
.62602 .01524 L
.62728 .01553 L
.62845 .01571 L
.6297 .0159 L
.63041 .0161 L
Mistroke
.63108 .01632 L
.64019 .01914 L
.66088 .02818 L
.67127 .03354 L
.68114 .03922 L
.68543 .04172 L
.68779 .04278 L
.68894 .04342 L
.69001 .0441 L
.69127 .08182 L
.69193 .09482 L
.69264 .09583 L
.69502 .09827 L
.69967 .10342 L
.70916 .11408 L
.71438 .11955 L
.71695 .12232 L
.71808 .1237 L
.71933 .12545 L
.72048 .18105 L
.72156 .23063 L
.7227 .23201 L
.72392 .23378 L
.72892 .23903 L
.73315 .24434 L
.73426 .2454 L
.73547 .24645 L
.73661 .24805 L
.73766 .24952 L
.73893 .25074 L
.73957 .27008 L
.74027 .28497 L
.74149 .28647 L
.74263 .2882 L
.74725 .29359 L
.75772 .3056 L
.77882 .33123 L
.81767 .37992 L
.85897 .43458 L
.89875 .48978 L
.93701 .54471 L
.97619 .60332 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`000?oooooo
oooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0WOooool5o`0006Kooooo000Eooooo`03
o`000?oooooooooo09[ooooo1?l00003ooooo`Co0000Hoooool001Gooooo0_l0002Iooooo`;o0000
2oooool2o`00067ooooo000Eooooo`03o`000?oooooooooo09Kooooo0_l0000?ooooo`?o0000G_oo
ool000Oooooo0ol00004ooooo`;o00001Oooool00ol0003oooooooooo`2Eooooo`03o`000?oooooo
oooo01;ooooo0ol0001Kooooo`002?ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Cooooo00?o0000ooooooooool0U?ooool00ol0003oooooooooo`0Fooooo`;o0000FOooool0
00Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool0Toooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo05Kooooo0008oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool3o`0009;ooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`1Eooooo`002?ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0TOooool00ol0003oooooooooo`0M
ooooo`;o0000EOooool000Oooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool0T?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo05?ooooo0008oooo
o`03o`000?oooooooooo00?ooooo0_l00005ooooo`03o`000?oooooooooo08oooooo00?o0000oooo
ooooool08?ooool00ol0003oooooooooo`1Cooooo`005Oooool2o`0008oooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`1Cooooo`005Oooool00ol0003oooooooooo`2=ooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool0Doooool001Gooooo00?o0000ooooooooool0S?oo
ool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo05?ooooo000Eooooo`03o`000?oooooo
oooo08_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1Booooo`005Oooool2o`00
08[ooooo0_l0000Xooooo`03o`000?oooooooooo05;ooooo000Eooooo`03o`000?oooooooooo08So
oooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`1Booooo`005Oooool00ol0003ooooo
ooooo`27ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0D_ooool001Gooooo00?o
0000ooooooooool08_ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l0
0002ooooo`Go00005oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l0
0004ooooo`?o00005oooool3o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l0
0003ooooo`?o00004_ooool00ol0003oooooooooo`03ooooo`;o00001?ooool00ol0003ooooooooo
o`03ooooo`;o00001?ooool2o`0000?ooooo0ol0000Kooooo`;o00001?ooool00ol0003ooooooooo
o`03ooooo`;o00000oooool3o`0000Kooooo000Eooooo`03o`000?oooooooooo027ooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00005_ooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0Eooooo`;o0000
0_ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooo
oooo0000ooooool00003ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo
0000ooooool00003ooooo`03o`000?oooooooooo01Oooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Gooooo000Eooooo`;o00008_ooool0
1?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000oooool00ol0003oooooooooo`0Fooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooo
oooooooo00000_ooool01Ol0003oooooooooool0003ooooo00Go00005?ooool2o`000005ooooool0
003oooooooooool000002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`00
0?oooooo00000oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oo
oooo00000oooool00ol0003oooooooooo`0Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`05ooooo`005Oooool00ol0003oooooooooo`0Q
ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo01Gooooo00Co0000oooooooooooo00002?ooool01?l0
003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003ooooo
ooooo`0Booooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`06ooooo`04
o`000?ooooooooooo`0000;ooooo00Go0000oooooooooooo0000ooooo`04o`0001;ooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00000_ooool3o`0001[ooooo00Co0000oooooooooooo00002?ooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo00Gooooo000Eooooo`03o`000?oooooooooo
027ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?oo
ooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`00
00Sooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooo000001?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00008ooooo`04o`00
0?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool0000Eooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`00
0?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Gooooo`04o`000?oooooooooo
o`0000Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`05ooooo`005Oooool0
0ol0003oooooooooo`0Qooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo0000
0_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool05?ooool01?l0
003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
0oooool2o`0001;ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00008ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0C
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`06ooooo`04o`000?oo
ooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo
01Oooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`;o00001ooo
ool001Gooooo0_l0000Sooooo`;o00002_ooool2o`0000Cooooo0_l00003ooooo`?o00006?ooool2
o`0000[ooooo0_l00004ooooo`;o00001Oooool00ol0003oooooooooo`0>ooooo`;o00001oooool2
o`0000[ooooo0_l00004ooooo`;o00001?ooool2o`0001Cooooo00Co0000oooooooooooooooo0_l0
000:ooooo`;o00001?ooool2o`0000?ooooo0ol0000Kooooo`;o00002_ooool2o`0000Cooooo00?o
0000ooooooooool01Oooool001Gooooo00?o0000ooooooooool0O?ooool2o`0003Oooooo00?o0000
ooooooooool0D?ooool001Gooooo00?o0000ooooooooool0N_ooool2o`0003[ooooo00?o0000oooo
ooooool0Coooool001Gooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`0kooooo`03
o`000?oooooooooo04kooooo000Eooooo`03o`000?oooooooooo07Oooooo0_l0000oooooo`03o`00
0?oooooooooo04gooooo000>oooooooo00004ol0000001Gooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool2
o`0000Kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`;o00002oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo0Ol00001ooooo`7ooooo000Eoooo
o`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0=oooo
o`;o00008Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0;oooool00ol0003oooooooooo`0=ooooo`005Oooool00ol0003oooooooooo`1`ooooo`03
o`000?oooooooooo04Oooooo00?o0000ooooooooool0Boooool001Gooooo0_l0001_ooooo`;o0000
B_ooool00ol0003oooooooooo`1;ooooo`005Oooool00ol0003oooooooooo`1[ooooo`?o0000C?oo
ool00ol0003oooooooooo`1;ooooo`005Oooool00ol0003oooooooooo`1Wooooo`Co0000Coooool0
0ol0003oooooooooo`1;ooooo`005Oooool00ol0003oooooooooo`1Tooooo`?o0000Doooool00ol0
003oooooooooo`1;ooooo`005Oooool00ol0003oooooooooo`1Qooooo`?o0000E_ooool00ol0003o
ooooooooo`1;ooooo`005Oooool2o`0005gooooo1Ol0001Iooooo`03o`000?oooooooooo04_ooooo
000Eooooo`03o`000?oooooooooo05Oooooo1Ol0001Nooooo`03o`000?oooooooooo04_ooooo000E
ooooo`03o`000?oooooooooo05;ooooo1Ol0001Sooooo`03o`000?oooooooooo04_ooooo000Eoooo
o`03o`000?oooooooooo04gooooo1Ol0001Xooooo`03o`000?oooooooooo04_ooooo000Eooooo`;o
0000B?ooool6o`0006gooooo00?o0000ooooooooool0Boooool001Gooooo00?o0000ooooooooool0
??ooool;o`0007?ooooo00?o0000ooooooooool0Boooool001Gooooo00?o0000ooooooooool08Ooo
oolKo`0007kooooo00?o0000ooooooooool0Boooool001Gooooo9?l0002Iooooo`03o`000?oooooo
oooo04_ooooo000Eooooo`03o`000?oooooooooo0;[ooooo00?o0000ooooooooool0Boooool001Go
oooo0_l0002kooooo`03o`000?oooooooooo04_ooooo000Eooooo`03o`000?oooooooooo0;[ooooo
00?o0000ooooooooool0Boooool000Oooooo0ol00004ooooo`;o00001Oooool00ol0003ooooooooo
o`2jooooo`03o`000?oooooooooo04_ooooo0008ooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00001?ooool00ol0003oooooooooo`2jooooo`03o`000?oooooooooo04_ooooo0008
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool3o`000;[ooooo00?o
0000ooooooooool0Boooool000Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo0;[ooooo00?o0000ooooooooool0Boooool000Sooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;_ooooo00?o
0000ooooooooool0B_ooool000Oooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool0^oooool00ol0003oooooooooo`1:ooooo`002?ooool00ol0003oooooooooo`03
ooooo`;o00001Oooool00ol0003oooooooooo`2kooooo`03o`000?oooooooooo04[ooooo000Eoooo
o`;o0000_?ooool00ol0003oooooooooo`1:ooooo`005Oooool00ol0003oooooooooo`2kooooo`03
o`000?oooooooooo04[ooooo000Eooooo`03o`000?oooooooooo0;_ooooo00?o0000ooooooooool0
B_ooool001Gooooo00?o0000ooooooooool0^oooool00ol0003oooooooooo`1:ooooo`005Oooool2
o`000;cooooo0_l0001;ooooo`005Oooool00ol0003oooooooooo`2mooooo`03o`000?oooooooooo
04Sooooo000Eooooo`03o`000?oooooooooo0;gooooo00?o0000ooooooooool0B?ooool001Gooooo
00?o0000ooooooooool0__ooool2o`0004Sooooo000Eooooo`03o`000?oooooooooo0;oooooo00?o
0000ooooooooool0A_ooool001Gooooo0_l00030ooooo`03o`000?oooooooooo04Kooooo000Eoooo
o`03o`000?oooooooooo0;oooooo00?o0000ooooooooool0A_ooool001Gooooo00?o0000oooooooo
ool0_oooool00ol0003oooooooooo`16ooooo`005Oooool00ol0003oooooooooo`30ooooo`03o`00
0?oooooooooo04Gooooo000Eooooo`;o0000`Oooool00ol0003oooooooooo`15ooooo`005Oooool0
0ol0003oooooooooo`30ooooo`03o`000?oooooooooo04Gooooo0006ooooo`Go00000oooool2o`00
00Gooooo00?o0000ooooooooool0`?ooool00ol0003oooooooooo`15ooooo`001oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0`?ooool0
0ol0003oooooooooo`15ooooo`002?ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Cooooo00?o0000ooooooooool0`?ooool00ol0003oooooooooo`15ooooo`002Oooool01Ol0
003ooooooooooooooooo000000;ooooo00?o0000ooooooooool00_ooool3o`000<3ooooo00?o0000
ooooooooool0AOooool000Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool0`?ooool2o`0004Kooooo0006ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0<;ooooo
00?o0000ooooooooool0@oooool000Oooooo0ol00004ooooo`;o00001Oooool00ol0003ooooooooo
o`33ooooo`03o`000?oooooooooo04;ooooo000Eooooo`;o0000aOooool00ol0003oooooooooo`11
ooooo`005Oooool00ol0003oooooooooo`35ooooo`03o`000?oooooooooo043ooooo000Eooooo`03
o`000?oooooooooo0<Gooooo00?o0000ooooooooool0@?ooool001Gooooo00?o0000ooooooooool0
a_ooool00ol0003oooooooooo`0oooooo`005Oooool00ol0003oooooooooo`37ooooo`03o`000?oo
oooooooo03kooooo000Eooooo`;o0000bOooool00ol0003oooooooooo`0mooooo`005Oooool00ol0
003oooooooooo`38ooooo`03o`000?oooooooooo03gooooo000Eooooo`03o`000?oooooooooo0<Wo
oooo00?o0000ooooooooool0??ooool001Gooooo00?o0000ooooooooool0b_ooool00ol0003ooooo
ooooo`0kooooo`005Oooool2o`000<_ooooo00?o0000ooooooooool0>oooool001Gooooo00?o0000
ooooooooool0boooool00ol0003oooooooooo`0jooooo`005Oooool00ol0003oooooooooo`3<oooo
o`03o`000?oooooooooo03Wooooo000Eooooo`03o`000?oooooooooo0<gooooo00?o0000oooooooo
ool0>?ooool001Gooooo00?o0000ooooooooool0c_ooool00ol0003oooooooooo`0gooooo`005Ooo
ool2o`000<oooooo00?o0000ooooooooool0=oooool001Gooooo00?o0000ooooooooool0coooool0
0ol0003oooooooooo`0fooooo`001oooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo
0=3ooooo00?o0000ooooooooool0=Oooool000Kooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0dOooool00ol0003oooooooooo`0d
ooooo`002_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00;ooooo0ol0003A
ooooo`03o`000?oooooooooo03Cooooo0008ooooo`;o00000oooool01?l0003oooooooooool00004
ooooo`03o`000?oooooooooo0=;ooooo00?o0000ooooooooool0<oooool000[ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0=?ooooo00?o0000
ooooooooool0<_ooool000Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool0e?ooool00ol0003oooooooooo`0aooooo`001oooool3
o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0=Gooooo00?o0000ooooooooool0<?ooool0
01Gooooo0_l0003Fooooo`03o`000?oooooooooo033ooooo000Eooooo`03o`000?oooooooooo0=Ko
oooo00?o0000ooooooooool0;oooool001Gooooo00?o0000ooooooooool0eoooool00ol0003ooooo
ooooo`0^ooooo`005Oooool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo02gooooo000E
ooooo`;o0000fOooool00ol0003oooooooooo`0]ooooo`005Oooool00ol0003oooooooooo`3Ioooo
o`03o`000?oooooooooo02cooooo000Eooooo`03o`000?oooooooooo0=[ooooo00?o0000oooooooo
ool0:oooool001Gooooo00?o0000ooooooooool0foooool00ol0003oooooooooo`0Zooooo`005Ooo
ool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo02[ooooo000Eooooo`;o0000gOooool0
0ol0003oooooooooo`0Yooooo`005Oooool00ol0003oooooooooo`3Mooooo`03o`000?oooooooooo
02Sooooo000Eooooo`03o`000?oooooooooo0=gooooo00?o0000ooooooooool0:?ooool001Gooooo
00?o0000ooooooooool0g_ooool00ol0003oooooooooo`0Wooooo`005Oooool2o`000>3ooooo00?o
0000ooooooooool09_ooool001Gooooo00?o0000ooooooooool0h?ooool00ol0003oooooooooo`0U
ooooo`002?ooool3o`0000?ooooo0_l00005ooooo`03o`000?oooooooooo0>3ooooo00?o0000oooo
ooooool09Oooool000Wooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool0hOooool00ol0003oooooooooo`0Tooooo`001_ooool5o`0000;o
oooo00Co0000oooooooooooo00001?ooool3o`000>;ooooo00?o0000ooooooooool08oooool000Ko
oooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00004ooooo`03o`000?oooooo
oooo0>?ooooo00?o0000ooooooooool08_ooool000Oooooo00?o0000ooooool000000oooool01?l0
003oooooooooool00004ooooo`03o`000?oooooooooo0>?ooooo00?o0000ooooooooool08_ooool0
00Sooooo0_l00003ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0i?ooool0
0ol0003oooooooooo`0Qooooo`002Oooool00ol0003oooooooooo`02ooooo`;o00001Oooool00ol0
003oooooooooo`3Uooooo`03o`000?oooooooooo023ooooo000Eooooo`;o0000ioooool00ol0003o
ooooooooo`0Oooooo`005Oooool00ol0003oooooooooo`3Vooooo`03o`000?oooooooooo01oooooo
000Eooooo`03o`000?oooooooooo0>Oooooo00?o0000ooooooooool07_ooool001Gooooo00?o0000
ooooooooool0j?ooool00ol0003oooooooooo`0Mooooo`005Oooool2o`000>Wooooo00?o0000oooo
ooooool07Oooool001Gooooo00?o0000ooooooooool0jOooool00ol0003oooooooooo`0Looooo`00
5Oooool00ol0003oooooooooo`3Zooooo`03o`000?oooooooooo01_ooooo000Eooooo`03o`000?oo
oooooooo0>_ooooo00?o0000ooooooooool06_ooool001Gooooo00?o0000ooooooooool0joooool0
0ol0003oooooooooo`0Jooooo`005Oooool2o`000>gooooo00?o0000ooooooooool06Oooool001Go
oooo00?o0000ooooooooool0kOooool00ol0003oooooooooo`0Hooooo`005Oooool00ol0003ooooo
ooooo`3]ooooo`03o`000?oooooooooo01Sooooo000Eooooo`03o`000?oooooooooo0>kooooo00?o
0000ooooooooool05oooool001Gooooo0_l0003`ooooo`03o`000?oooooooooo01Kooooo000Eoooo
o`03o`000?oooooooooo0>oooooo00?o0000ooooooooool05_ooool000Oooooo0ol00004ooooo`;o
00001Oooool00ol0003oooooooooo`3`ooooo`03o`000?oooooooooo01Gooooo0006ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo
0?7ooooo00?o0000ooooooooool05?ooool000[ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo0?7ooooo00?o0000ooooooooool05?ooool000[o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`02ooooo`?o0000l_ooool00ol0
003oooooooooo`0Cooooo`001_ooool4o`0000?ooooo00Co0000oooooooooooo00001?ooool00ol0
003oooooooooo`3cooooo`03o`000?oooooooooo01;ooooo0006ooooo`03o`000?oooooooooo00Co
oooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3cooooo`03o`000?oooooooooo
01;ooooo0006ooooo`Go00000oooool2o`0000Gooooo00?o0000ooooooooool0m?ooool00ol0003o
ooooooooo`0Aooooo`005Oooool2o`000?Kooooo00?o0000ooooooooool04?ooool001Gooooo00?o
0000ooooooooool0mOooool00ol0003oooooooooo`0@ooooo`005Oooool00ol0003oooooooooo`3f
ooooo`03o`000?oooooooooo00oooooo000Eooooo`03o`000?oooooooooo0?Oooooo00?o0000oooo
ooooool03_ooool001Gooooo00?o0000ooooooooool0n?ooool00ol0003oooooooooo`0=ooooo`00
5Oooool2o`000?Wooooo00?o0000ooooooooool03Oooool001Gooooo00?o0000ooooooooool0nOoo
ool00ol0003oooooooooo`0<ooooo`005Oooool00ol0003oooooooooo`3jooooo`03o`000?oooooo
oooo00_ooooo000Eooooo`03o`000?oooooooooo0?_ooooo00?o0000ooooooooool02_ooool001Go
oooo0_l0003looooo`03o`000?oooooooooo00[ooooo000Eooooo`03o`000?oooooooooo0?cooooo
00?o0000ooooooooool02Oooool001Gooooo00?o0000ooooooooool0oOooool00ol0003ooooooooo
o`08ooooo`005Oooool00ol0003oooooooooo`3mooooo`03o`000?oooooooooo00Sooooo000Eoooo
o`03o`000?oooooooooo0?kooooo00?o0000ooooooooool01oooool001Gooooo0_l0003oooooo`7o
oooo00?o0000ooooooooool01_ooool001Gooooo00?o0000ooooooooool0ooooool1ooooo`03o`00
0?oooooooooo00Gooooo0007ooooo`?o00001?ooool2o`0000Gooooo00?o0000ooooooooool0oooo
ool9ooooo`001_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`3oooooo`Wooooo0006ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00004ooooo`?o0000ooooool9ooooo`001_ooool4o`0000?ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3oooooo`Wooooo0006ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo0000ooooool@ooooo`001oooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooo`000?oooooo4?ooool000Sooooo0_l00004ooooo`;o0000
oooooolAooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.000851432, -15.7883, \
3.97826*^-5, 0.44664}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[yfinal[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 92.3888 0.0179949 0.0147161 [
[.20859 .00549 -15 -9 ]
[.20859 .00549 15 0 ]
[.39336 .00549 -15 -9 ]
[.39336 .00549 15 0 ]
[.57814 .00549 -15 -9 ]
[.57814 .00549 15 0 ]
[.76292 .00549 -15 -9 ]
[.76292 .00549 15 0 ]
[.9477 .00549 -12 -9 ]
[.9477 .00549 12 0 ]
[.01131 .16516 -12 -4.5 ]
[.01131 .16516 0 4.5 ]
[.01131 .31232 -12 -4.5 ]
[.01131 .31232 0 4.5 ]
[.01131 .45948 -12 -4.5 ]
[.01131 .45948 0 4.5 ]
[.01131 .60664 -12 -4.5 ]
[.01131 .60664 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20859 .01799 m
.20859 .02424 L
s
[(0.002)] .20859 .00549 0 1 Mshowa
.39336 .01799 m
.39336 .02424 L
s
[(0.004)] .39336 .00549 0 1 Mshowa
.57814 .01799 m
.57814 .02424 L
s
[(0.006)] .57814 .00549 0 1 Mshowa
.76292 .01799 m
.76292 .02424 L
s
[(0.008)] .76292 .00549 0 1 Mshowa
.9477 .01799 m
.9477 .02424 L
s
[(0.01)] .9477 .00549 0 1 Mshowa
.125 Mabswid
.07 .01799 m
.07 .02174 L
s
.1162 .01799 m
.1162 .02174 L
s
.16239 .01799 m
.16239 .02174 L
s
.25478 .01799 m
.25478 .02174 L
s
.30098 .01799 m
.30098 .02174 L
s
.34717 .01799 m
.34717 .02174 L
s
.43956 .01799 m
.43956 .02174 L
s
.48575 .01799 m
.48575 .02174 L
s
.53195 .01799 m
.53195 .02174 L
s
.62434 .01799 m
.62434 .02174 L
s
.67053 .01799 m
.67053 .02174 L
s
.71673 .01799 m
.71673 .02174 L
s
.80911 .01799 m
.80911 .02174 L
s
.85531 .01799 m
.85531 .02174 L
s
.9015 .01799 m
.9015 .02174 L
s
.99389 .01799 m
.99389 .02174 L
s
.25 Mabswid
0 .01799 m
1 .01799 L
s
.02381 .16516 m
.03006 .16516 L
s
[(10)] .01131 .16516 1 0 Mshowa
.02381 .31232 m
.03006 .31232 L
s
[(20)] .01131 .31232 1 0 Mshowa
.02381 .45948 m
.03006 .45948 L
s
[(30)] .01131 .45948 1 0 Mshowa
.02381 .60664 m
.03006 .60664 L
s
[(40)] .01131 .60664 1 0 Mshowa
.125 Mabswid
.02381 .04743 m
.02756 .04743 L
s
.02381 .07686 m
.02756 .07686 L
s
.02381 .10629 m
.02756 .10629 L
s
.02381 .13572 m
.02756 .13572 L
s
.02381 .19459 m
.02756 .19459 L
s
.02381 .22402 m
.02756 .22402 L
s
.02381 .25345 m
.02756 .25345 L
s
.02381 .28288 m
.02756 .28288 L
s
.02381 .34175 m
.02756 .34175 L
s
.02381 .37118 m
.02756 .37118 L
s
.02381 .40061 m
.02756 .40061 L
s
.02381 .43004 m
.02756 .43004 L
s
.02381 .48891 m
.02756 .48891 L
s
.02381 .51834 m
.02756 .51834 L
s
.02381 .54777 m
.02756 .54777 L
s
.02381 .57721 m
.02756 .57721 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .02535 m
.06244 .02535 L
.10458 .02535 L
.14415 .02535 L
.18221 .02535 L
.22272 .02535 L
.26171 .02535 L
.30316 .02535 L
.34309 .02535 L
.3815 .02535 L
.40095 .02535 L
.41127 .02535 L
.42237 .02535 L
.42781 .02535 L
.43298 .02535 L
.43522 .02535 L
.43762 .02535 L
.43833 .02535 L
.43899 .02535 L
.44024 .02535 L
.44142 .02535 L
.44268 .02535 L
.44387 .02535 L
.44498 .02535 L
.4462 .02536 L
.4475 .02536 L
.44816 .02536 L
.44887 .02536 L
.45017 .02537 L
.45143 .02537 L
.4526 .02538 L
.45369 .02539 L
.45488 .02539 L
.45599 .0254 L
.45702 .02542 L
.45925 .02545 L
.46172 .02549 L
.46299 .02552 L
.4642 .02555 L
.46528 .02557 L
.46646 .02562 L
.46773 .02566 L
.46892 .0257 L
.47016 .02577 L
.47081 .02578 L
.47152 .02582 L
.474 .02597 L
.47508 .02603 L
.47627 .02609 L
.47743 .02619 L
Mistroke
.47851 .02629 L
.48064 .02646 L
.48335 .02674 L
.4859 .02707 L
.49067 .02776 L
.4958 .02868 L
.49847 .02929 L
.50134 .03006 L
.50627 .03183 L
.51087 .03372 L
.51588 .03609 L
.52132 .03965 L
.52699 .04422 L
.53235 .05014 L
.5424 .06523 L
.56182 .09823 L
.58323 .14373 L
.60352 .20101 L
.62255 .26349 L
.66129 .39387 L
.67081 .42559 L
.68097 .45819 L
.68398 .46704 L
.68682 .47591 L
.68806 .48015 L
.68937 .48492 L
.69005 .48748 L
.6908 .49471 L
.69212 .55659 L
.69282 .55738 L
.69347 .55823 L
.69471 .55907 L
.69748 .56156 L
.70248 .56608 L
.70726 .57017 L
.71234 .5738 L
.71668 .57727 L
.71787 .57793 L
.71915 .57912 L
.72037 .58922 L
.72148 .60332 L
.72268 .60309 L
.72397 .60275 L
.72518 .60254 L
.72628 .60232 L
.73155 .60085 L
.73416 .6 L
.73488 .59975 L
.73554 .59967 L
.73624 .59938 L
Mistroke
.737 .59906 L
.73829 .59872 L
.73902 .59839 L
.73968 .58641 L
.74095 .58232 L
.74216 .58169 L
.7434 .58064 L
.74475 .57972 L
.74719 .57775 L
.75175 .57426 L
.76198 .5653 L
.78037 .54627 L
.79993 .52084 L
.82139 .48745 L
.8609 .40674 L
.90134 .2983 L
.94027 .16344 L
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00=oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00002oooo
o`Go00005oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00004oooo
o`?o00006?ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003oooo
o`?o00006?ooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003oooo
o`?o00006oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol00009oooo
o`00=_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Fooooo`04o`000?ooooooooooo`0000So
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo
oooo01Kooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`00
0?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Dooooo`04o`000?oooooooooo
o`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000?o
oooo00?o0000ooooooooool05oooool01?l0003oooooooooool00008ooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooooooool02?ooool003Kooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
5_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooo
oooooooo0000ooooo`05o`0001Oooooo00Co0000oooooooooooo00002?ooool01?l0003ooooooooo
ool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Doooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooooooool05oooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool02?ooool003Kooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool05Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`00
00;ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo01Kooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`05o`000?ooooooooooo`00
0?ooool01?l0000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`?o00006_ooool01?l0003oooooooooool00008ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool02?ooool003Kooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo0000
0oooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000001Sooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oo
oooo00006_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko
0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01Oooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Sooooo000foooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooooooool05?ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool2o`0001Sooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool05oooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01Oo
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`;o00002_ooool0
01;ooooo00?o0000ooooooooool08_ooool2o`0000[ooooo0_l00004ooooo`;o00000oooool3o`00
01Sooooo0_l0000:ooooo`;o00001?ooool2o`0000Gooooo00?o0000ooooooooool05oooool2o`00
00[ooooo0_l00004ooooo`;o00001?ooool2o`0001Sooooo0_l0000:ooooo`;o00001?ooool2o`00
00?ooooo0ol0000Kooooo`;o00002_ooool2o`0000Cooooo00?o0000ooooooooool02?ooool001;o
oooo00?o0000ooooooooool0ooooool<ooooo`004_ooool00ol0003oooooooooo`3oooooo`cooooo
000Booooo`03o`000?oooooooooo0?oooooo3?ooool001;ooooo00?o0000ooooooooool0ooooool1
ooooo`03o`000?oooooooooo00Sooooo000<oooooooo00004Ol00004ooooo`004_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00?ooooo000Booooogoo00006?ooool00ol0003ooooo
ooooo`0_ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`09ooooo`004_ooool00ol0003oooooooooo`1looooo`Co0000Ooooool00ol0003ooooooooo
o`09ooooo`004_ooool00ol0003oooooooooo`20ooooo`?o0000O?ooool00ol0003oooooooooo`09
ooooo`004_ooool00ol0003oooooooooo`23ooooo`03o`000?oooooooooo07Wooooo00?o0000oooo
ooooool02Oooool001;ooooo00?o0000ooooooooool0Q?ooool2o`0007Sooooo00?o0000oooooooo
ool02_ooool001;ooooo00?o0000ooooooooool0Q_ooool00ol0003oooooooooo`1eooooo`03o`00
0?oooooooooo00[ooooo000Booooo`;o0000Qoooool00ol0003oooooooooo`1eooooo`03o`000?oo
oooooooo00[ooooo000Booooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0M?ooool0
0ol0003oooooooooo`0:ooooo`004_ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo
07?ooooo00?o0000ooooooooool02oooool001;ooooo00?o0000ooooooooool0R?ooool00ol0003o
ooooooooo`1booooo`03o`000?oooooooooo00_ooooo000Booooo`03o`000?oooooooooo08Wooooo
00?o0000ooooooooool0LOooool00ol0003oooooooooo`0;ooooo`004_ooool00ol0003ooooooooo
o`2:ooooo`03o`000?oooooooooo073ooooo00?o0000ooooooooool02oooool001;ooooo00?o0000
ooooooooool0R_ooool00ol0003oooooooooo`1_ooooo`03o`000?oooooooooo00cooooo000Boooo
o`03o`000?oooooooooo08_ooooo00?o0000ooooooooool0K_ooool00ol0003oooooooooo`0<oooo
o`004_ooool2o`0008cooooo00?o0000ooooooooool0K_ooool00ol0003oooooooooo`0<ooooo`00
4_ooool00ol0003oooooooooo`2<ooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool0
3?ooool001;ooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`1[ooooo`03o`000?oo
oooooooo00gooooo000Booooo`03o`000?oooooooooo08gooooo00?o0000ooooooooool0Joooool0
0ol0003oooooooooo`0=ooooo`004_ooool00ol0003oooooooooo`2>ooooo`03o`000?oooooooooo
06[ooooo00?o0000ooooooooool03Oooool001;ooooo00?o0000ooooooooool0S_ooool00ol0003o
ooooooooo`1Zooooo`03o`000?oooooooooo00gooooo000Booooo`03o`000?oooooooooo08oooooo
00?o0000ooooooooool0JOooool00ol0003oooooooooo`0=ooooo`004_ooool00ol0003ooooooooo
o`2?ooooo`03o`000?oooooooooo06Sooooo00?o0000ooooooooool03_ooool001;ooooo0_l0002A
ooooo`03o`000?oooooooooo06Oooooo00?o0000ooooooooool03_ooool001;ooooo00?o0000oooo
ooooool0T?ooool00ol0003oooooooooo`1Wooooo`03o`000?oooooooooo00kooooo000Booooo`03
o`000?oooooooooo097ooooo00?o0000ooooooooool0I_ooool00ol0003oooooooooo`0>ooooo`00
4_ooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool0
3oooool001;ooooo00?o0000ooooooooool0T_ooool00ol0003oooooooooo`1Tooooo`03o`000?oo
oooooooo00oooooo000Booooo`03o`000?oooooooooo09;ooooo00?o0000ooooooooool0I?ooool0
0ol0003oooooooooo`0?ooooo`004_ooool00ol0003oooooooooo`2Cooooo`03o`000?oooooooooo
06?ooooo00?o0000ooooooooool03oooool001;ooooo00?o0000ooooooooool0Toooool00ol0003o
ooooooooo`1Rooooo`03o`000?oooooooooo013ooooo000Booooo`;o0000UOooool00ol0003ooooo
ooooo`1Qooooo`03o`000?oooooooooo013ooooo000Booooo`03o`000?oooooooooo09Cooooo00?o
0000ooooooooool0HOooool00ol0003oooooooooo`0@ooooo`004_ooool00ol0003oooooooooo`2E
ooooo`03o`000?oooooooooo063ooooo00?o0000ooooooooool04?ooool001;ooooo00?o0000oooo
ooooool0UOooool00ol0003oooooooooo`1Oooooo`03o`000?oooooooooo017ooooo000Booooo`03
o`000?oooooooooo09Kooooo00?o0000ooooooooool0G_ooool00ol0003oooooooooo`0Aooooo`00
1?ooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo09Kooooo00?o0000ooooooooool0
G_ooool00ol0003oooooooooo`0Aooooo`001Oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool0U_ooool00ol0003oooooooooo`1Nooooo`03o`00
0?oooooooooo017ooooo0005ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo05cooooo00?o0000ooooooooool0
4_ooool000Gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`?o0000
Uoooool00ol0003oooooooooo`1Looooo`03o`000?oooooooooo01;ooooo0005ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`2Gooooo`03o`00
0?oooooooooo05cooooo00?o0000ooooooooool04_ooool000Cooooo0_l00004ooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool0V?ooool00ol0003oooooooooo`1Kooooo`03o`00
0?oooooooooo01;ooooo0005ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`03o`000?oo
oooooooo09Sooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`0Cooooo`004_ooool0
0ol0003oooooooooo`2Iooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool04oooool0
01;ooooo00?o0000ooooooooool0VOooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo
01?ooooo000Booooo`03o`000?oooooooooo09Wooooo00?o0000ooooooooool0F?ooool00ol0003o
ooooooooo`0Dooooo`004_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo05Oooooo
00?o0000ooooooooool05?ooool001;ooooo0_l0002Kooooo`03o`000?oooooooooo05Oooooo00?o
0000ooooooooool05?ooool001;ooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`1G
ooooo`03o`000?oooooooooo01Cooooo000Booooo`03o`000?oooooooooo09_ooooo00?o0000oooo
ooooool0EOooool00ol0003oooooooooo`0Eooooo`004_ooool00ol0003oooooooooo`2Kooooo`03
o`000?oooooooooo05Gooooo00?o0000ooooooooool05Oooool001;ooooo00?o0000ooooooooool0
Voooool00ol0003oooooooooo`1Eooooo`03o`000?oooooooooo01Gooooo000Booooo`03o`000?oo
oooooooo09cooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Eooooo`004_ooool0
0ol0003oooooooooo`2Looooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool05_ooool0
01;ooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`1Cooooo`03o`000?oooooooooo
01Kooooo000Booooo`;o0000W_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01Ko
oooo000Booooo`03o`000?oooooooooo09gooooo00?o0000ooooooooool0DOooool00ol0003ooooo
ooooo`0Gooooo`004_ooool00ol0003oooooooooo`2Mooooo`03o`000?oooooooooo057ooooo00?o
0000ooooooooool05oooool001;ooooo00?o0000ooooooooool0W_ooool00ol0003oooooooooo`1@
ooooo`03o`000?oooooooooo01Oooooo000Booooo`03o`000?oooooooooo09kooooo00?o0000oooo
ooooool0D?ooool00ol0003oooooooooo`0Gooooo`004_ooool00ol0003oooooooooo`2Nooooo`03
o`000?oooooooooo04oooooo00?o0000ooooooooool06?ooool001;ooooo00?o0000ooooooooool0
W_ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo01Sooooo000Booooo`03o`000?oo
oooooooo09oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Hooooo`004_ooool2
o`000:3ooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`0Iooooo`004_ooool00ol0
003oooooooooo`2Oooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool06Oooool001;o
oooo00?o0000ooooooooool0X?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo01Wo
oooo000Booooo`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool0C?ooool00ol0003ooooo
ooooo`0Iooooo`004_ooool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo04_ooooo00?o
0000ooooooooool06_ooool001;ooooo00?o0000ooooooooool0X?ooool00ol0003oooooooooo`1;
ooooo`03o`000?oooooooooo01[ooooo000Booooo`03o`000?oooooooooo0:7ooooo00?o0000oooo
ooooool0B_ooool00ol0003oooooooooo`0Jooooo`004_ooool00ol0003oooooooooo`2Qooooo`03
o`000?oooooooooo04[ooooo00?o0000ooooooooool06_ooool001;ooooo0_l0002Rooooo`03o`00
0?oooooooooo04Wooooo00?o0000ooooooooool06oooool001;ooooo00?o0000ooooooooool0X_oo
ool00ol0003oooooooooo`18ooooo`03o`000?oooooooooo01_ooooo000Booooo`03o`000?oooooo
oooo0:;ooooo00?o0000ooooooooool0B?ooool00ol0003oooooooooo`0Kooooo`004_ooool00ol0
003oooooooooo`2Rooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool07?ooool001;o
oooo00?o0000ooooooooool0X_ooool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo01co
oooo0003ooooo`Go00000oooool2o`0000Gooooo00?o0000ooooooooool0Xoooool00ol0003ooooo
ooooo`16ooooo`03o`000?oooooooooo01cooooo0004ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`2Sooooo`03o`000?oooooooooo04Go
oooo00?o0000ooooooooool07Oooool000Gooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo0:?ooooo00?o0000ooooooooool0AOooool00ol0003o
ooooooooo`0Mooooo`001_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooooooo
ool00_ooool3o`000:Cooooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`0Mooooo`00
0oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool00ol0
003oooooooooo`2Tooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool07_ooool000?o
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool0Y?ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo01kooooo0004oooo
o`?o00001?ooool2o`0000Gooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`13oooo
o`03o`000?oooooooooo01kooooo000Booooo`03o`000?oooooooooo0:Gooooo00?o0000oooooooo
ool0@Oooool00ol0003oooooooooo`0Oooooo`004_ooool00ol0003oooooooooo`2Uooooo`03o`00
0?oooooooooo047ooooo00?o0000ooooooooool07oooool001;ooooo00?o0000ooooooooool0YOoo
ool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo01oooooo000Booooo`03o`000?oooooo
oooo0:Kooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0Pooooo`004_ooool2o`00
0:Oooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0Pooooo`004_ooool00ol0003o
ooooooooo`2Vooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool08Oooool001;ooooo
00?o0000ooooooooool0Y_ooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo027ooooo
000Booooo`03o`000?oooooooooo0:Oooooo00?o0000ooooooooool0?Oooool00ol0003ooooooooo
o`0Qooooo`004_ooool00ol0003oooooooooo`2Wooooo`03o`000?oooooooooo03cooooo00?o0000
ooooooooool08_ooool001;ooooo00?o0000ooooooooool0Yoooool00ol0003oooooooooo`0loooo
o`03o`000?oooooooooo02;ooooo000Booooo`03o`000?oooooooooo0:Sooooo00?o0000oooooooo
ool0>oooool00ol0003oooooooooo`0Rooooo`004_ooool00ol0003oooooooooo`2Xooooo`03o`00
0?oooooooooo03[ooooo00?o0000ooooooooool08oooool001;ooooo0_l0002Yooooo`03o`000?oo
oooooooo03[ooooo00?o0000ooooooooool08oooool001;ooooo00?o0000ooooooooool0Z?ooool0
0ol0003oooooooooo`0iooooo`03o`000?oooooooooo02Cooooo000Booooo`03o`000?oooooooooo
0:Wooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0Tooooo`004_ooool00ol0003o
ooooooooo`2Yooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool09?ooool001;ooooo
00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02Gooooo
000Booooo`03o`000?oooooooooo0:[ooooo00?o0000ooooooooool0=_ooool00ol0003ooooooooo
o`0Uooooo`004_ooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo03Kooooo00?o0000
ooooooooool09Oooool001;ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`0eoooo
o`03o`000?oooooooooo02Kooooo000Booooo`;o0000[?ooool00ol0003oooooooooo`0dooooo`03
o`000?oooooooooo02Kooooo000Booooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool0
=?ooool00ol0003oooooooooo`0Vooooo`004_ooool00ol0003oooooooooo`2[ooooo`03o`000?oo
oooooooo03?ooooo00?o0000ooooooooool09oooool001;ooooo00?o0000ooooooooool0[?ooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo02Oooooo000Booooo`03o`000?oooooooooo
0:cooooo00?o0000ooooooooool0<Oooool00ol0003oooooooooo`0Xooooo`004_ooool00ol0003o
ooooooooo`2/ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0:?ooool001;ooooo
00?o0000ooooooooool0[Oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02Wooooo
000Booooo`03o`000?oooooooooo0:gooooo00?o0000ooooooooool0;oooool00ol0003ooooooooo
o`0Yooooo`004_ooool2o`000:kooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Z
ooooo`004_ooool00ol0003oooooooooo`2^ooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool0:_ooool001;ooooo00?o0000ooooooooool0[_ooool00ol0003oooooooooo`0/ooooo`03
o`000?oooooooooo02_ooooo000Booooo`03o`000?oooooooooo0:kooooo00?o0000ooooooooool0
;?ooool00ol0003oooooooooo`0[ooooo`004_ooool00ol0003oooooooooo`2_ooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool0;?ooool000Cooooo0ol00004ooooo`;o00001Oooool0
0ol0003oooooooooo`2_ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0;?ooool0
00?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool0[oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02gooooo0007
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`2`ooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0;Oooool000Gooooo0_l00003
ooooo`04o`000?ooooooooooo`0000Cooooo0ol0002`ooooo`03o`000?oooooooooo02Oooooo00?o
0000ooooooooool0;_ooool000Oooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo0;3ooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0^ooooo`000oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`2`ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
;oooool000Cooooo0ol00004ooooo`;o00001Oooool00ol0003oooooooooo`2`ooooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool0;oooool001;ooooo00?o0000ooooooooool0/Oooool0
0ol0003oooooooooo`0Tooooo`03o`000?oooooooooo033ooooo000Booooo`03o`000?oooooooooo
0;7ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0`ooooo`004_ooool00ol0003o
ooooooooo`2booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0<Oooool001;ooooo
00?o0000ooooooooool0/_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo037ooooo
000Booooo`;o0000/oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo03;ooooo000B
ooooo`03o`000?oooooooooo0;;ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0b
ooooo`004_ooool00ol0003oooooooooo`2booooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool0<oooool001;ooooo00?o0000ooooooooool0/_ooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo03Cooooo000Booooo`03o`000?oooooooooo0;;ooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0dooooo`004_ooool00ol0003oooooooooo`2booooo`03o`000?oo
oooooooo01kooooo00?o0000ooooooooool0=Oooool001;ooooo00?o0000ooooooooool0/_ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo03Kooooo000Booooo`03o`000?oooooooooo
0;;ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0fooooo`004_ooool2o`000;?o
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0gooooo`004_ooool00ol0003ooooo
ooooo`2booooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0>?ooool001;ooooo00?o
0000ooooooooool0/_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo03Sooooo000B
ooooo`03o`000?oooooooooo0;?ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0i
ooooo`004_ooool00ol0003oooooooooo`2cooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool0>_ooool001;ooooo00?o0000ooooooooool0/oooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo03_ooooo000Booooo`03o`000?oooooooooo0;?ooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0kooooo`004_ooool00ol0003oooooooooo`2cooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool0??ooool001;ooooo0_l0002dooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0?Oooool001;ooooo00?o0000ooooooooool0/oooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo03kooooo000Booooo`03o`000?oooooooooo0;?o
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0oooooo`004_ooool00ol0003ooooo
ooooo`2cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0@?ooool001;ooooo00?o
0000ooooooooool0]?ooool2o`00017ooooo00?o0000ooooooooool0@Oooool001;ooooo00?o0000
ooooooooool0]_ooool00ol0003oooooooooo`0<ooooo`;o0000A?ooool001;ooooo00?o0000oooo
ooooool0]oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo04Cooooo000Booooo`03
o`000?oooooooooo0;Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`15ooooo`00
4_ooool2o`000;[ooooo0_l00007ooooo`03o`000?oooooooooo04Kooooo000Booooo`03o`000?oo
oooooooo0;[ooooo00?o0000ooooooooool00oooool2o`0004Wooooo000Booooo`03o`000?oooooo
oooo0;[ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`18ooooo`004_ooool00ol0
003oooooooooo`2jooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0B?ooool001;o
oooo00?o0000ooooooooool0^_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04So
oooo0005ooooo`?o00000oooool2o`0000Gooooo00?o0000ooooooooool0^_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo04Wooooo0006ooooo`05o`000?ooooooooooooooool00000
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0;_ooooo00?o0000ooooool00000
0_l0001;ooooo`000oooool5o`0000;ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooo
ooooo`2kooooo`;o0000C_ooool000?ooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00004ooooo`?o0000ooooool<ooooo`001?ooool00ol0003oooooo`000003ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooooooool0ooooool<ooooo`001Oooool2o`0000?ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3oooooo`cooooo0006ooooo`03o`00
0?oooooooooo00;ooooo0_l00005ooooo`03o`000?oooooooooo0?oooooo3?ooool00?oooooo8Ooo
ool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.000736513, -3.09944, \
3.98122*^-5, 0.249944}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ParametricPlot[{xfinal[t], yfinal[t]}, {t, 0, tf}, 
      PlotRange \[Rule] All]\)], "Input"],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[BoxData[
    \(InterpolatingFunction::"dmval" \(\(:\)\(\ \)\) 
      "Input value \!\({0.010308399570483132`}\) lies outside the range of \
data in the interpolating function. Extrapolation will be used."\)], "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.274842 0.0196571 0.0179948 0.014716 [
[.07827 .00549 -9 -9 ]
[.07827 .00549 9 0 ]
[.47141 .00549 -6 -9 ]
[.47141 .00549 6 0 ]
[.66798 .00549 -6 -9 ]
[.66798 .00549 6 0 ]
[.86455 .00549 -6 -9 ]
[.86455 .00549 6 0 ]
[.26234 .16515 -12 -4.5 ]
[.26234 .16515 0 4.5 ]
[.26234 .31232 -12 -4.5 ]
[.26234 .31232 0 4.5 ]
[.26234 .45948 -12 -4.5 ]
[.26234 .45948 0 4.5 ]
[.26234 .60664 -12 -4.5 ]
[.26234 .60664 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.07827 .01799 m
.07827 .02424 L
s
[(-10)] .07827 .00549 0 1 Mshowa
.47141 .01799 m
.47141 .02424 L
s
[(10)] .47141 .00549 0 1 Mshowa
.66798 .01799 m
.66798 .02424 L
s
[(20)] .66798 .00549 0 1 Mshowa
.86455 .01799 m
.86455 .02424 L
s
[(30)] .86455 .00549 0 1 Mshowa
.125 Mabswid
.11759 .01799 m
.11759 .02174 L
s
.1569 .01799 m
.1569 .02174 L
s
.19621 .01799 m
.19621 .02174 L
s
.23553 .01799 m
.23553 .02174 L
s
.31416 .01799 m
.31416 .02174 L
s
.35347 .01799 m
.35347 .02174 L
s
.39278 .01799 m
.39278 .02174 L
s
.4321 .01799 m
.4321 .02174 L
s
.51073 .01799 m
.51073 .02174 L
s
.55004 .01799 m
.55004 .02174 L
s
.58936 .01799 m
.58936 .02174 L
s
.62867 .01799 m
.62867 .02174 L
s
.7073 .01799 m
.7073 .02174 L
s
.74661 .01799 m
.74661 .02174 L
s
.78593 .01799 m
.78593 .02174 L
s
.82524 .01799 m
.82524 .02174 L
s
.03896 .01799 m
.03896 .02174 L
s
.90387 .01799 m
.90387 .02174 L
s
.94318 .01799 m
.94318 .02174 L
s
.9825 .01799 m
.9825 .02174 L
s
.25 Mabswid
0 .01799 m
1 .01799 L
s
.27484 .16515 m
.28109 .16515 L
s
[(10)] .26234 .16515 1 0 Mshowa
.27484 .31232 m
.28109 .31232 L
s
[(20)] .26234 .31232 1 0 Mshowa
.27484 .45948 m
.28109 .45948 L
s
[(30)] .26234 .45948 1 0 Mshowa
.27484 .60664 m
.28109 .60664 L
s
[(40)] .26234 .60664 1 0 Mshowa
.125 Mabswid
.27484 .04743 m
.27859 .04743 L
s
.27484 .07686 m
.27859 .07686 L
s
.27484 .10629 m
.27859 .10629 L
s
.27484 .13572 m
.27859 .13572 L
s
.27484 .19459 m
.27859 .19459 L
s
.27484 .22402 m
.27859 .22402 L
s
.27484 .25345 m
.27859 .25345 L
s
.27484 .28288 m
.27859 .28288 L
s
.27484 .34175 m
.27859 .34175 L
s
.27484 .37118 m
.27859 .37118 L
s
.27484 .40061 m
.27859 .40061 L
s
.27484 .43004 m
.27859 .43004 L
s
.27484 .48891 m
.27859 .48891 L
s
.27484 .51834 m
.27859 .51834 L
s
.27484 .54777 m
.27859 .54777 L
s
.27484 .5772 m
.27859 .5772 L
s
.25 Mabswid
.27484 0 m
.27484 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.41266 .02535 m
.41265 .02535 L
.41251 .02535 L
.41192 .02535 L
.41046 .02535 L
.40719 .02535 L
.40152 .02535 L
.39141 .02535 L
.37653 .02535 L
.35592 .02535 L
.34278 .02535 L
.33517 .02535 L
.32619 .02535 L
.32141 .02535 L
.31714 .02535 L
.31472 .02535 L
.31279 .02535 L
.31211 .02535 L
.31121 .02535 L
.31033 .02535 L
.30894 .02535 L
.3076 .02535 L
.30669 .02535 L
.30562 .02535 L
.30389 .02536 L
.30292 .02536 L
.30126 .02536 L
.30002 .02537 L
.29905 .02537 L
.29724 .02538 L
.29503 .02539 L
.29194 .02542 L
.28983 .02545 L
.28721 .02549 L
.28106 .02563 L
.27826 .02571 L
.27499 .02583 L
.26827 .02614 L
.26255 .02649 L
.25499 .02708 L
.24794 .02778 L
.2393 .02885 L
.23009 .03029 L
.22206 .03182 L
.21192 .03416 L
.19387 .03965 L
.18401 .0435 L
.17191 .04926 L
.14941 .06365 L
.10235 .09806 L
Mistroke
.07942 .11812 L
.068 .13038 L
.05751 .14373 L
.04856 .15746 L
.04024 .17332 L
.03464 .18691 L
.03018 .20099 L
.0282 .20907 L
.02688 .21556 L
.02547 .22449 L
.02474 .23087 L
.02426 .2366 L
.0242 .23769 L
.02408 .23961 L
.02387 .24531 L
.02381 .2489 L
.02381 .25196 L
.02386 .25529 L
.02406 .26074 L
.02426 .26447 L
.02451 .26793 L
.02497 .27313 L
.02583 .28064 L
.02829 .29642 L
.03213 .31479 L
.03696 .33367 L
.06017 .40365 L
.07242 .43451 L
.07986 .45229 L
.08605 .46702 L
.08953 .47555 L
.09203 .48191 L
.09318 .48491 L
.10742 .49538 L
.21517 .55652 L
.21756 .55737 L
.22133 .55871 L
.22477 .55991 L
.23199 .56238 L
.24409 .56636 L
.26883 .57389 L
.27594 .57591 L
.28337 .57794 L
.28474 .57831 L
.28584 .5786 L
.28834 .57926 L
.35187 .58535 L
.50816 .60031 L
.53957 .60332 L
.54373 .60301 L
Mistroke
.54961 .60254 L
.55665 .60191 L
.56978 .60057 L
.57641 .59981 L
.58249 .59906 L
.58504 .59873 L
.5876 .59839 L
.66939 .58295 L
.67193 .58233 L
.72918 .56605 L
.7907 .54371 L
.91319 .48429 L
Mfstroke
.91319 .48429 m
1 .42769 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`006_ooool3o`0000Cooooo0_l0001Oooooo`?o00001?ooool2o`0002cooooo1Ol00003oooo
o`;o0000;?ooool3o`0000Cooooo0_l0000Zooooo`006oooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0005oooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000/
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000:_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo0000:Oooool001?ooooo1Ol00003ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000Goooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0002gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
000^ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool09oooool001_ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool0001Oooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo0000;_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0:_ooool2o`0000?ooooo00Co0000oooooooooooo0000:Oooool001_ooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool0001Oooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo0000:oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
0000;_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo02Oooooo000Jooooo`;o
00001?ooool01?l0003oooooooooool0001Nooooo`;o00001?ooool01?l0003oooooooooool0000[
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Zooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Yooooo`006oooool00ol0003o
ooooooooo`03ooooo`;o0000;oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo00?o
oooo0_l0000]ooooo`?o00001?ooool2o`0002cooooo0ol00004ooooo`;o0000:_ooool005;ooooo
00?o0000ooooooooool0boooool005;ooooo00?o0000ooooooooool0boooool005;ooooo00?o0000
ooooooooool0boooool005;ooooo00?o0000ooooooooool0boooool000Ooooooool0000Bo`0000So
oooo000Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00_ooooo000Looooo`03o`000?oooooooooo02cooooo;_l0
000>ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0<_ooool00ol0003ooooooooo
o`0[ooooo`00AOooool6o`0000Oooooo00?o0000ooooooooool0boooool0043ooooo1Ol0000=oooo
o`03o`000?oooooooooo0<_ooooo000mooooo`?o00004_ooool00ol0003oooooooooo`3;ooooo`00
>oooool2o`0001Gooooo00?o0000ooooooooool0boooool003Sooooo0ol0000Gooooo`03o`000?oo
oooooooo0<_ooooo000eooooo`?o00006_ooool2o`000<cooooo000dooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool0boooool003;ooooo0_l0000Nooooo`03o`000?oooooooooo0<_o
oooo000aooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0boooool002oooooo0_l0
000Qooooo`03o`000?oooooooooo0<_ooooo000^ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool0boooool002gooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3;oooo
o`00:oooool2o`0002Gooooo00?o0000ooooooooool0boooool002[ooooo00?o0000ooooooooool0
9Oooool2o`000<cooooo000Yooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0booo
ool002Sooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`3;ooooo`009_ooool2o`00
02[ooooo00?o0000ooooooooool0boooool002Gooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`3;ooooo`009?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo0<_ooooo
000Rooooo`;o0000;_ooool00ol0003oooooooooo`3;ooooo`008Oooool00ol0003oooooooooo`0^
ooooo`03o`000?oooooooooo0<_ooooo000Pooooo`03o`000?oooooooooo02oooooo0_l0003<oooo
o`007oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooooooo0<_ooooo000Nooooo`03o`00
0?oooooooooo037ooooo00?o0000ooooooooool0boooool001gooooo00?o0000ooooooooool0<_oo
ool00ol0003oooooooooo`3;ooooo`007Oooool00ol0003oooooooooo`0booooo`03o`000?oooooo
oooo0<_ooooo000Looooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0boooool001_o
oooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`3;ooooo`006_ooool00ol0003ooooo
ooooo`0eooooo`03o`000?oooooooooo0<_ooooo000Iooooo`03o`000?oooooooooo03Kooooo0_l0
003<ooooo`006?ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo0<_ooooo000Goooo
o`03o`000?oooooooooo03Sooooo00?o0000ooooooooool0boooool001Oooooo00?o0000oooooooo
ool0>?ooool00ol0003oooooooooo`3;ooooo`005_ooool00ol0003oooooooooo`0iooooo`03o`00
0?oooooooooo0<_ooooo000Eooooo`03o`000?oooooooooo02_ooooo0ol00004ooooo`;o00001_oo
ool00ol0003oooooooooo`3;ooooo`005?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`3;ooooo`005?ooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Ooo
ool00ol0003oooooooooo`3;ooooo`004oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00001Oooool2o`000<cooooo000Cooooo`03o`000?oooooo
oooo02kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00005ooooo`03o`000?oo
oooooooo0<_ooooo000Booooo`03o`000?oooooooooo02kooooo0_l00004ooooo`04o`000?oooooo
ooooo`0000Gooooo00?o0000ooooooooool0boooool001;ooooo00?o0000ooooooooool0;oooool0
0ol0003oooooooooo`03ooooo`;o00001_ooool00ol0003oooooooooo`3;ooooo`004Oooool00ol0
003oooooooooo`0nooooo`03o`000?oooooooooo0<_ooooo000Aooooo`03o`000?oooooooooo03ko
oooo00?o0000ooooooooool0boooool0013ooooo00?o0000ooooooooool0?oooool00ol0003ooooo
ooooo`3;ooooo`004?ooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo0<_ooooo000@
ooooo`03o`000?oooooooooo03oooooo0_l0003<ooooo`003oooool00ol0003oooooooooo`10oooo
o`03o`000?oooooooooo0<_ooooo000?ooooo`03o`000?oooooooooo043ooooo00?o0000oooooooo
ool0boooool000oooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`3;ooooo`003ooo
ool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo0<_ooooo000?ooooo`03o`000?oooooo
oooo043ooooo00?o0000ooooooooool0boooool000kooooo00?o0000ooooooooool0@Oooool00ol0
003oooooooooo`3;ooooo`003_ooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo0<_o
oooo000>ooooo`03o`000?oooooooooo047ooooo0_l0003<ooooo`003_ooool00ol0003ooooooooo
o`11ooooo`03o`000?oooooooooo0<_ooooo000>ooooo`03o`000?oooooooooo047ooooo00?o0000
ooooooooool0boooool000kooooo00?o0000ooooooooool0@Oooool00ol0003oooooooooo`3;oooo
o`003_ooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo0<_ooooo000>ooooo`03o`00
0?oooooooooo047ooooo00?o0000ooooooooool0boooool000kooooo00?o0000ooooooooool0@Ooo
ool00ol0003oooooooooo`3;ooooo`003_ooool00ol0003oooooooooo`11ooooo`03o`000?oooooo
oooo0<_ooooo000>ooooo`03o`000?oooooooooo047ooooo0_l0003<ooooo`003_ooool00ol0003o
ooooooooo`11ooooo`03o`000?oooooooooo0<_ooooo000>ooooo`03o`000?oooooooooo047ooooo
00?o0000ooooooooool0boooool000kooooo00?o0000ooooooooool0@Oooool00ol0003ooooooooo
o`3;ooooo`003_ooool00ol0003oooooooooo`11ooooo`03o`000?oooooooooo0<_ooooo000>oooo
o`03o`000?oooooooooo047ooooo00?o0000ooooooooool0boooool000kooooo00?o0000oooooooo
ool0@Oooool00ol0003oooooooooo`3;ooooo`003_ooool00ol0003oooooooooo`11ooooo`03o`00
0?oooooooooo0<_ooooo000>ooooo`03o`000?oooooooooo047ooooo0_l0003<ooooo`003_ooool0
0ol0003oooooooooo`11ooooo`03o`000?oooooooooo0<_ooooo000?ooooo`03o`000?oooooooooo
043ooooo00?o0000ooooooooool0boooool000oooooo00?o0000ooooooooool0@?ooool00ol0003o
ooooooooo`3;ooooo`003oooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo0<_ooooo
000?ooooo`03o`000?oooooooooo033ooooo1Ol00003ooooo`;o00001_ooool00ol0003ooooooooo
o`3;ooooo`003oooool00ol0003oooooooooo`0aooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00001Oooool00ol0003oooooooooo`3;ooooo`004?ooool00ol0003ooooooooo
o`0aooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool00ol0003ooooo
ooooo`3;ooooo`004?ooool00ol0003oooooooooo`0booooo`05o`000?ooooooooooooooool00000
0_ooool00ol0003oooooooooo`03ooooo`;o0000c?ooool0013ooooo00?o0000ooooooooool0;ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001Oooool00ol0003o
ooooooooo`3;ooooo`004?ooool00ol0003oooooooooo`0_ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo0<_ooooo000@ooooo`03
o`000?oooooooooo033ooooo0ol00004ooooo`;o00001_ooool00ol0003oooooooooo`3;ooooo`00
4Oooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo0<_ooooo000Aooooo`03o`000?oo
oooooooo03kooooo00?o0000ooooooooool0boooool0017ooooo00?o0000ooooooooool0?_ooool0
0ol0003oooooooooo`3;ooooo`004Oooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo
0<_ooooo000Aooooo`03o`000?oooooooooo03kooooo0_l0003<ooooo`004_ooool00ol0003ooooo
ooooo`0mooooo`03o`000?oooooooooo0<_ooooo000Booooo`03o`000?oooooooooo03gooooo00?o
0000ooooooooool0boooool001;ooooo00?o0000ooooooooool0?Oooool00ol0003oooooooooo`3;
ooooo`004oooool00ol0003oooooooooo`0looooo`03o`000?oooooooooo0<_ooooo000Cooooo`03
o`000?oooooooooo03cooooo00?o0000ooooooooool0boooool001?ooooo00?o0000ooooooooool0
??ooool00ol0003oooooooooo`3;ooooo`005?ooool00ol0003oooooooooo`0kooooo`03o`000?oo
oooooooo0<_ooooo000Dooooo`03o`000?oooooooooo03_ooooo0_l0003<ooooo`005?ooool00ol0
003oooooooooo`0kooooo`03o`000?oooooooooo0<_ooooo000Eooooo`03o`000?oooooooooo03[o
oooo00?o0000ooooooooool0boooool001Gooooo00?o0000ooooooooool0>_ooool00ol0003ooooo
ooooo`3;ooooo`005Oooool00ol0003oooooooooo`0jooooo`03o`000?oooooooooo0<_ooooo000F
ooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0boooool001Kooooo00?o0000oooo
ooooool0>Oooool00ol0003oooooooooo`3;ooooo`005_ooool00ol0003oooooooooo`0iooooo`03
o`000?oooooooooo0<_ooooo000Gooooo`03o`000?oooooooooo03Sooooo0_l0003<ooooo`005ooo
ool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo0<_ooooo000Gooooo`03o`000?oooooo
oooo03Sooooo00?o0000ooooooooool0boooool001Sooooo00?o0000ooooooooool0=oooool00ol0
003oooooooooo`3;ooooo`006?ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo0<_o
oooo000Iooooo`03o`000?oooooooooo03Kooooo00?o0000ooooooooool0boooool001Wooooo00?o
0000ooooooooool0=_ooool00ol0003oooooooooo`3;ooooo`006_ooool00ol0003oooooooooo`0e
ooooo`03o`000?oooooooooo0<7ooooo0_l00008ooooo`006_ooool00ol0003oooooooooo`0eoooo
o`;o0000`Oooool00ol0003oooooooooo`08ooooo`006oooool00ol0003oooooooooo`0dooooo`03
o`000?oooooooooo0;kooooo0_l0000;ooooo`006oooool00ol0003oooooooooo`0dooooo`03o`00
0?oooooooooo0;gooooo00?o0000ooooooooool02oooool001cooooo00?o0000ooooooooool0<ooo
ool00ol0003oooooooooo`2kooooo`;o00003_ooool001cooooo00?o0000ooooooooool0<oooool0
0ol0003oooooooooo`2jooooo`03o`000?oooooooooo00kooooo000Looooo`03o`000?oooooooooo
02Cooooo0ol00004ooooo`;o00001_ooool00ol0003oooooooooo`2hooooo`;o00004Oooool001go
oooo00?o0000ooooooooool08_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001Oooool00ol0003oooooooooo`2gooooo`03o`000?oooooooooo017ooooo000Moooo
o`03o`000?oooooooooo02Kooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo0;Gooooo0_l0000Dooooo`007Oooool00ol0003oooooooooo`0Toooo
o`;o00000oooool01?l0003oooooooooool00005ooooo`;o0000]Oooool00ol0003oooooooooo`0D
ooooo`007_ooool00ol0003oooooooooo`0Uooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`2booooo`;o00005oooool001kooooo00?o0000oooo
ooooool08Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001Ooo
ool00ol0003oooooooooo`2aooooo`03o`000?oooooooooo01Oooooo000Nooooo`03o`000?oooooo
oooo02;ooooo0ol00004ooooo`;o00001_ooool00ol0003oooooooooo`2_ooooo`;o00006_ooool0
01oooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`2^ooooo`03o`000?oooooooooo
01[ooooo000Oooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool0[?ooool2o`0001go
oooo000Pooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0Zoooool00ol0003ooooo
ooooo`0Mooooo`008?ooool2o`00033ooooo00?o0000ooooooooool0ZOooool2o`00023ooooo000R
ooooo`03o`000?oooooooooo02gooooo0_l0002Xooooo`;o00008_ooool002?ooooo00?o0000oooo
ooooool0;?ooool00ol0003oooooooooo`2Uooooo`;o00009?ooool002Cooooo0_l0000/ooooo`03
o`000?oooooooooo0:?ooooo0_l0000Vooooo`009_ooool2o`0002[ooooo00?o0000ooooooooool0
XOooool2o`0002Sooooo000Xooooo`;o0000:?ooool00ol0003oooooooooo`2Oooooo`;o0000:_oo
ool002[ooooo0_l0000Vooooo`03o`000?oooooooooo09gooooo0_l0000/ooooo`00;?ooool00ol0
003oooooooooo`0Sooooo`03o`000?oooooooooo09_ooooo0_l0000^ooooo`00;Oooool2o`0002?o
oooo00?o0000ooooooooool0V?ooool3o`00033ooooo000_ooooo`;o00008Oooool2o`0009Oooooo
0_l0000cooooo`00<Oooool2o`0001oooooo00?o0000ooooooooool0U?ooool2o`0003Gooooo000c
ooooo`;o00007Oooool00ol0003oooooooooo`2Booooo`;o0000=oooool003Gooooo0_l0000Koooo
o`03o`000?oooooooooo093ooooo0_l0000iooooo`00=oooool2o`0001Wooooo00?o0000oooooooo
ool0S_ooool2o`0003_ooooo000iooooo`;o00005oooool00ol0003oooooooooo`2<ooooo`;o0000
?Oooool003_ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`2:ooooo`;o0000?ooo
ool003cooooo0_l0000Dooooo`03o`000?oooooooooo08Sooooo0_l00011ooooo`00?_ooool2o`00
01;ooooo0_l00026ooooo`?o0000@oooool0043ooooo0_l0000@ooooo`03o`000?oooooooooo08;o
oooo0ol00016ooooo`00@_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo07oooooo
0ol00019ooooo`00@_ooool4o`0000cooooo00?o0000ooooooooool0O?ooool3o`0004cooooo0016
ooooo`?o00002Oooool00ol0003oooooooooo`1iooooo`?o0000Coooool004Wooooo0ol00006oooo
o`03o`000?oooooooooo07Kooooo0ol0001Booooo`00C?ooool3o`0000?ooooo00?o0000oooooooo
ool0L_ooool4o`0005Gooooo001?ooooo`Co0000LOooool3o`0005Wooooo001Booooo`Co0000J_oo
ool4o`0005cooooo001Booooo`03o`000?oooooooooo00[o0000Goooool2o`00063ooooo001Boooo
o`03o`000?oooooooooo00[ooooo3_l0001=ooooo`Co0000H_ooool005;ooooo00?o0000oooooooo
ool06?ooool;o`0003gooooo1Ol0001Vooooo`00D_ooool00ol0003oooooooooo`0Sooooo`[o0000
;Oooool6o`0006_ooooo0014ooooo`?o00000oooool2o`0000Kooooo00?o0000ooooooooool0;Ooo
ool;o`0001gooooo1Ol0001aooooo`00AOooool01Ol0003ooooooooooooooooo000000;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0hooooo`[o00002Oooool:o`0007Kooooo0012
ooooo`Go00000_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo04;ooooo2Ol0
0020ooooo`00@_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Gooooo
0_l0003<ooooo`00@oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Gooooo
00?o0000ooooooooool0boooool004Cooooo0_l00003ooooo`04o`000?ooooooooooo`0000Gooooo
00?o0000ooooooooool0boooool004Gooooo00?o0000ooooooooool00_ooool2o`0000Kooooo00?o
0000ooooooooool0boooool00?oooooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-15.3972, -3.09946, \
0.187118, 0.249946}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Animation", "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
For this animation we will draw: two circles center at each end of \
the bar and 
two lines tangent to the circles to repesent the bar, lines to represent the \
box of rocks, and lines and a circle to represent the sling and payload.  We \
then animate according to the time solution above.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[GraphicsData["PICT", "\<\
000000000A<1M@0A0_l<0?on0000B00004P0000000014`5e0000000N00402P00
00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
00400000000000000000040000000000000000000000@00000014`5e00030000
00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
M6lPLfEU87AXJG<PL6USM7EbIBh0003o\>"], "Graphics",
  ImageSize->{373, 275},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \ \ \ \ \ \ \ \)\(\(q1[t_] = q1final[t];\)\n
    \ \ \ \ \ \ \ \(q2[t_] = q2final[t];\)\n
    \ \ \ \ \ \ \ \ \ \ \ \(q3[t_] = q3final[t];\)\n
    \ \ \ \ \ \ \ \ \ \ \ \(q4[t_] = q4final[t];\)\n
    \ \ \ \ \ \ \ \ \ \ \ \(x[t_] = xfinal[t];\)\n
    \ \ \ \ \ \ \ \ \ \ \ \(y[t_] = 
        yfinal[t];\)\[IndentingNewLine]\[IndentingNewLine]\[IndentingNewLine]
    tg =. \n
    \(thick = \(l1 + l2\)\/10;\)\n (*locations\ for\ horse\ cradle\ and\ \
circle\ end\ caps\ of\ beams\ to\ be\ drawn*) \[IndentingNewLine]
    \(xa0 = 
        transform[\((H\ n[2]\  + \ l2\ b[1]\  + \ l3\ a[1])\) . n[1]];\)\n
    \(ya0 = 
        transform[\((H\ n[2]\  + \ l2\ b[1]\  + \ l3\ a[1])\) . n[2]];\)\n
    \(xb0 = transform[\((H\ n[2]\  + \ l2\ b[1])\) . n[1]];\)\n
    \(yb0 = transform[\((H\ n[2]\  + \ l2\ b[1])\) . n[2]];\)\n
    \(xc0 = transform[\((H\ n[2] - l1\ b[1])\) . n[1]];\)\n
    \(yc0 = transform[\((H\ n[2] - l1\ b[1])\) . n[2]];\)\n
    \(xd0 = transform[\((H\ n[2] - l1\ b[1]\  - \ l4\ c[2])\) . n[1]];\)\n
    \(yd0 = 
        transform[\((H\ n[2] - l1\ b[1]\  - \ l4\ c[2])\) . 
            n[2]];\)\[IndentingNewLine]\n (*end\ points\ for\ lines\ to\ be\ \
drawn\ to\ tangents\ of\ end\ caps, \ 
      beam\ B*) \[IndentingNewLine]\[IndentingNewLine]
    \(xbl0 = 
        transform[\((H\ n[2]\  + \ l2\ b[1] - 1\/2\ thick\ b[2])\) . 
            n[1]];\)\n
    \(ybl0 = 
        transform[\((H\ n[2]\  + \ l2\ b[1] - 1\/2\ thick\ b[2])\) . 
            n[2]];\)\n
    \(xbl1 = 
        transform[\((H\ n[2]\  - \ l1\ b[1] - 1\/2\ thick\ b[2])\) . 
            n[1]];\)\n
    \(ybl1 = 
        transform[\((H\ n[2]\  - \ l1\ b[1] - 1\/2\ thick\ b[2])\) . 
            n[2]];\)\n
    \(xbu0 = 
        transform[\((H\ n[2]\  + \ l2\ b[1] + 1\/2\ thick\ b[2])\) . 
            n[1]];\)\n
    \(ybu0 = 
        transform[\((H\ n[2]\  + \ l2\ b[1] + 1\/2\ thick\ b[2])\) . 
            n[2]];\)\n
    \(xbu1 = 
        transform[\((H\ n[2]\  - \ l1\ b[1] + 1\/2\ thick\ b[2])\) . 
            n[1]];\)\n
    \(ybu1 = 
        transform[\((H\ n[2]\  - \ l1\ b[1] + 1\/2\ thick\ b[2])\) . 
            n[
              2]];\)\[IndentingNewLine]\n (*end\ points\ for\ lines\ to\ be\ \
drawn\ to\ tangents\ of\ end\ caps, \ 
      beam\ C*) \[IndentingNewLine]\[IndentingNewLine]
    \(xcl0 = 
        transform[\((H\ n[2]\  - l1\ b[1] - 1\/2\ thick\ c[1])\) . n[1]];\)\n
    \(ycl0 = 
        transform[\((H\ n[2]\  - l1\ b[1] - 1\/2\ thick\ c[1])\) . n[2]];\)\n
    \(xcl1 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - 
                1\/2\ thick\ c[1])\) . n[1]];\)\n
    \(ycl1 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - 
                1\/2\ thick\ c[1])\) . n[2]];\)\n
    \(xcu0 = 
        transform[\((H\ n[2]\  - l1\ b[1] + 1\/2\ thick\ c[1])\) . n[1]];\)\n
    \(ycu0 = 
        transform[\((H\ n[2]\  - l1\ b[1] + 1\/2\ thick\ c[1])\) . n[2]];\)\n
    \(xcu1 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  + 
                1\/2\ thick\ c[1])\) . n[1]];\)\n
    \(ycu1 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  + 
                1\/2\ thick\ c[1])\) . 
            n[2]];\)\n\[IndentingNewLine] (*now\ the\ rock\ crate\ corners\ \
are\ located*) \n\[IndentingNewLine]
    \(xd1 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  - 
                1\/2\ boxL\ d[1] + 1\/2\ boxH\ d[2])\) . n[1]];\)\n
    \(yd1 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  - 
                1\/2\ boxL\ d[1] + 1\/2\ boxH\ d[2])\) . n[2]];\)\n
    \(xd2 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  - 
                1\/2\ boxL\ d[1] - 1\/2\ boxH\ d[2])\) . n[1]];\)\n
    \(yd2 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  - 
                1\/2\ boxL\ d[1] - 1\/2\ boxH\ d[2])\) . n[2]];\)\n
    \(xd3 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  + 
                1\/2\ boxL\ d[1] - 1\/2\ boxH\ d[2])\) . n[1]];\)\n
    \(yd3 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  + 
                1\/2\ boxL\ d[1] - 1\/2\ boxH\ d[2])\) . n[2]];\)\n
    \(xd4 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  + 
                1\/2\ boxL\ d[1] + 1\/2\ boxH\ d[2])\) . n[1]];\)\n
    \(yd4 = 
        transform[\((H\ n[2]\ \  - l1\ b[1]\  - \ l4\ c[2]\  - \ d3\ d[2]\  + 
                1\/2\ boxL\ d[1] + 1\/2\ boxH\ d[2])\) . 
            n[2]];\)\n\[IndentingNewLine] (*location\ of\ horse\
*) \[IndentingNewLine]\[IndentingNewLine]
    \(xH = x[t];\)\n
    \(yH = 
        y[t];\)\n\[IndentingNewLine] (*draw\ the\ shapes\ and\ lines\ as\ \
animation*) \[IndentingNewLine]\[IndentingNewLine]
    For[tg = 0, tg \[LessEqual] tf, tg += tf/100, 
      Show[Graphics[{Circle[{xb0 /. t \[Rule] tg, yb0 /. t \[Rule] tg}, 
              thick\/2], 
            Circle[{xc0 /. t \[Rule] tg, yc0 /. t \[Rule] tg}, thick\/2], 
            Circle[{xd0 /. t \[Rule] tg, yd0 /. t \[Rule] tg}, 
              thick\/2], \[IndentingNewLine]Line[{{xbl0 /. t \[Rule] tg, 
                  ybl0 /. t \[Rule] tg}, {xbl1 /. t \[Rule] tg, 
                  ybl1 /. t \[Rule] tg}}], 
            Line[{{xbu0 /. t \[Rule] tg, 
                  ybu0 /. t \[Rule] tg}, {xbu1 /. t \[Rule] tg, 
                  ybu1 /. t \[Rule] tg}}], 
            Line[{{xcl0 /. t \[Rule] tg, 
                  ycl0 /. t \[Rule] tg}, {xcl1 /. t \[Rule] tg, 
                  ycl1 /. t \[Rule] tg}}], 
            Line[{{xcu0 /. t \[Rule] tg, 
                  ycu0 /. t \[Rule] tg}, {xcu1 /. t \[Rule] tg, 
                  ycu1 /. t \[Rule] tg}}], 
            Line[{{xd1 /. t \[Rule] tg, 
                  yd1 /. t \[Rule] tg}, {xd2 /. t \[Rule] tg, 
                  yd2 /. t \[Rule] tg}}], 
            Line[{{xd3 /. t \[Rule] tg, 
                  yd3 /. t \[Rule] tg}, {xd4 /. t \[Rule] tg, 
                  yd4 /. t \[Rule] tg}}], 
            Line[{{xb0 /. t \[Rule] tg, 
                  yb0 /. t \[Rule] tg}, {xa0 /. t \[Rule] tg, 
                  ya0 /. t \[Rule] tg}}], \[IndentingNewLine]Line[{{xd1 /. 
                    t \[Rule] tg, yd1 /. t \[Rule] tg}, {xd4 /. t \[Rule] tg, 
                  yd4 /. t \[Rule] tg}}], \[IndentingNewLine]Line[{{xd2 /. 
                    t \[Rule] tg, yd2 /. t \[Rule] tg}, {xd3 /. t \[Rule] tg, 
                  yd3 /. t \[Rule] tg}}], \[IndentingNewLine]Line[{{xd1 /. 
                    t \[Rule] tg, yd1 /. t \[Rule] tg}, {xd0 /. t \[Rule] tg, 
                  yd0 /. t \[Rule] tg}}], \[IndentingNewLine]Line[{{xd4 /. 
                    t \[Rule] tg, yd4 /. t \[Rule] tg}, {xd0 /. t \[Rule] tg, 
                  yd0 /. t \[Rule] tg}}], \[IndentingNewLine]Circle[{xa0 /. 
                  t \[Rule] tg, ya0 /. t \[Rule] tg}, 
              1.125\ rH], \[IndentingNewLine]Circle[{xH /. t \[Rule] tg, 
                yH /. t \[Rule] tg}, \ 
              rH], \[IndentingNewLine]Line[{{0, H}, {H, 
                  0}}], \[IndentingNewLine]Line[{{0, H}, {\(-H\), 
                  0}}]\[IndentingNewLine]}], Axes \[Rule] True, 
        PlotRange \[Rule] {{\(-\((H + l1 + l2 + l3 + 2\ rH)\)\), 
              2 \((H + l1 + l2 + l3 + 2\ rH)\)}, {0, 
              1.5 \((H + l1 + l2 + l3 + 2\ rH)\)}}, 
        AspectRatio \[Rule] Automatic]]\)\)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .10771 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .10771 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .10771 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .10771 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02942 .00609 0 365.73 arc
s
newpath
.36444 .1077 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08625 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02942 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27112 .02942 .00609 0 365.73 arc
s
newpath
.36444 .1077 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03409 m
.36052 .11237 L
s
.37044 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08625 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27112 .02942 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27112 .02943 .00609 0 365.73 arc
s
newpath
.36444 .1077 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27503 .02476 m
.36836 .10303 L
s
.2672 .03409 m
.36053 .11236 L
s
.37044 .10875 m
.37403 .08836 L
s
.35844 .10664 m
.36203 .08625 L
s
.38021 .09136 m
.38021 .07512 L
s
.35585 .07513 m
.35585 .09137 L
s
.27112 .02943 m
.39025 .00406 L
s
.38021 .09136 m
.35585 .09137 L
s
.38021 .07512 m
.35585 .07513 L
s
.38021 .09136 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39025 .00406 .00457 0 365.73 arc
s
newpath
.39025 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27111 .02944 .00609 0 365.73 arc
s
newpath
.36445 .10769 .00609 0 365.73 arc
s
newpath
.36803 .0873 .00609 0 365.73 arc
s
.27502 .02477 m
.36836 .10302 L
s
.26719 .03411 m
.36053 .11236 L
s
.37045 .10875 m
.37403 .08835 L
s
.35845 .10664 m
.36203 .08624 L
s
.38021 .09136 m
.38021 .07512 L
s
.35585 .07512 m
.35585 .09136 L
s
.27111 .02944 m
.39023 .00406 L
s
.38021 .09136 m
.35585 .09136 L
s
.38021 .07512 m
.35585 .07512 L
s
.38021 .09136 m
.36803 .0873 L
s
.35585 .09136 m
.36803 .0873 L
s
newpath
.39023 .00406 .00457 0 365.73 arc
s
newpath
.39023 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27109 .02946 .00609 0 365.73 arc
s
newpath
.36446 .10768 .00609 0 365.73 arc
s
newpath
.36803 .08729 .00609 0 365.73 arc
s
.275 .02479 m
.36837 .10301 L
s
.26718 .03413 m
.36054 .11235 L
s
.37045 .10873 m
.37403 .08834 L
s
.35846 .10663 m
.36203 .08624 L
s
.38021 .09134 m
.38021 .0751 L
s
.35585 .07511 m
.35585 .09135 L
s
.27109 .02946 m
.39021 .00406 L
s
.38021 .09134 m
.35585 .09135 L
s
.38021 .0751 m
.35585 .07511 L
s
.38021 .09134 m
.36803 .08729 L
s
.35585 .09135 m
.36803 .08729 L
s
newpath
.39021 .00406 .00457 0 365.73 arc
s
newpath
.39021 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00W?ooool6o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo1Ol0000I
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0
003oooooooooo`02o`000003ooooool0003ooooo00;o00006Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009cooooo
0_l000000ooooooo0000o`000004ooooo`?o00005_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooCOooool009kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`3oooooodoooooo002Pooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000004oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:7o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00X_ooool00ol0003oooooooooo`05ooooo`04o`00
0?oooooo0000o`00013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Sooooo`;o00001_ooool01?l0003oooooooooool0000?ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Vooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003Oooool3o`0000ko
oooo00?o0000ooooooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKo
oooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0000:ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00ZOooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00:[ooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002]ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o0000
1?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0000
1_ooool00ol0003oooooooooo`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;7ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Oooool3o`0000Co
oooo0ol00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`03o`0000?ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooooooo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003ooooo
ooooooooool5o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooo
oom?ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
0008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool01Ol0003ooooo
oooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`00
0?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o000000Coooooo`000?l0003o0000
1?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo00?o0000ooooool000002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool2o`0000?ooooo0_l0
00000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`05o`000?ooooooooooooooool000002Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000;ooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;ko
oooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0000?ooooo0_l0003ooooo
oeCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`;o
0000oooooomDooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`09ooooo`;o00001_oo
ool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00004
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol0000;ooooo`;o00000_ooool2o`00
0?ooooooEOooool00;kooooo00?o0000ooooooooool03Oooool2o`000?ooooooEoooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27107 .02949 .00609 0 365.73 arc
s
newpath
.36447 .10767 .00609 0 365.73 arc
s
newpath
.36803 .08727 .00609 0 365.73 arc
s
.27498 .02482 m
.36838 .103 L
s
.26716 .03416 m
.36056 .11234 L
s
.37047 .10872 m
.37403 .08832 L
s
.35847 .10662 m
.36203 .08622 L
s
.38021 .09133 m
.3802 .07509 L
s
.35584 .07509 m
.35585 .09133 L
s
.27107 .02949 m
.39019 .00406 L
s
.38021 .09133 m
.35585 .09133 L
s
.3802 .07509 m
.35584 .07509 L
s
.38021 .09133 m
.36803 .08727 L
s
.35585 .09133 m
.36803 .08727 L
s
newpath
.39019 .00406 .00457 0 365.73 arc
s
newpath
.39019 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00WOooool5o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Looooo`04o`000?ooooooooooooooo`Go00006Ooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool009_ooooo00?o0000
ooooooooool00_l000000ooooooo0000ooooo`02o`0001Wooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`3ooooood_ooooo002Kooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_l0000Hooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Looooo`;o
000000?oooooo`000?l000001?ooool3o`0001Kooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`3oooooodgooooo002Nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool00000
5Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009oooooo00?o
0000ooooooooool01Oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0oooooom?ooooo`00X?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
000001?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Qoooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooool000004_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo0?ooooooDOooool00:;ooooo00?o0000ooooooooool01Oooool01?l0003o
ooooo`000?l0000@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBoooo
o`00Xoooool2o`0000Kooooo00Co0000oooooooooooo00003oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo0?ooooooDoooool00:Gooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooomDoooo
o`00Y_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000gooooo0ol0000>oooo
o`03o`000?oooooooooo0?ooooooEOooool00:Oooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomFoooo
o`00Z?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;o00002_ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00:Wooooo00?o0000ooooooooool0
1?ooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`3ooooooeSooooo002Zooooo`;o00001Oooool01Ol0003ooooooooooooooooo000000So
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002/ooooo`03o`00
0?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0oooooomJooooo`00[Oooool00ol0003oooooooooo`03ooooo`05o`00
0?ooooooooooooooool000001_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?oo
ooooFoooool00:kooooo00?o0000ooooooooool00oooool01?l0003oooooooooooooool2o`0000Co
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002_ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooooooool3o`0000Ko
oooo00?o0000ooooooooool0oooooomMooooo`00/?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooooeko
oooo002aooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomOooooo`00/oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Cooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0oooooomQooooo`00]Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
ooooo`?o000000?oooooo`000?ooool01_ooool>o`000?ooooooCoooool00:gooooo0ol00004oooo
o`?o00001?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00ol00003ooooo`07o`000?oooooo0000ooooool0003oooooo`00
0007ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooooooo
0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooooooool5o`000003ooooool0003ooooo00Cooooo00Co0000oooooooo
oooooooo1Ol00004ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000Kooooo0_l00003
ooooo`05o`000?ooooooooooooooool000001?ooool01Ol0003ooooooooooooooooo00000?oooooo
Coooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool00000
2?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooo
ooooooooo`00003oooooodoooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`;o
00002Oooool00ol0003oooooo`000002ooooo`03o`000?oooooo000000Co00000oooool00ol0003o
ooooooooo`3oooooodgooooo002nooooo`;o00002Oooool2o`000004ooooool0003o0000o`0000Co
oooo0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`03o`000?oooooo000000Wooooo
3_l0003oooooodoooooo002nooooo`04o`000?ooooooooooo`0000Wooooo0_l00003ooooo`;o0000
00?oooooo`000?ooool0oooooomBooooo`00__ooool01Ol0003ooooooooooooooooo000000Wooooo
0_l00005ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo0ol00002ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3ooooooe7ooooo002n
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool01?ooool2
o`0000Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002noooo
o`03o`000?oooooooooo00Kooooo00Co0000oooooooooooooooo0ol00003ooooo`;o0000oooooomD
ooooo`00__ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;o00001?ooool2o`00
0?ooooooE?ooool00;kooooo00?o0000ooooooooool02?ooool00ol0003oooooo`000006ooooo`03
o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool02Oooool2o`0000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`0:ooooo`;o00001?oo
ool00ol0003oooooooooo`3ooooooe?ooooo002nooooo`?o00002oooool2o`0000;ooooo0_l0003o
oooooeGooooo002nooooo`03o`000?oooooooooo00gooooo0_l0003ooooooeOooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Go
oooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:go
oooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`00
00Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go
0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00
[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27103 .02953 .00609 0 365.73 arc
s
newpath
.36448 .10765 .00609 0 365.73 arc
s
newpath
.36802 .08725 .00609 0 365.73 arc
s
.27494 .02485 m
.36839 .10298 L
s
.26713 .0342 m
.36058 .11232 L
s
.37048 .10869 m
.37402 .08829 L
s
.35848 .10661 m
.36202 .08621 L
s
.38021 .0913 m
.3802 .07506 L
s
.35584 .07507 m
.35585 .09131 L
s
.27103 .02953 m
.39014 .00406 L
s
.38021 .0913 m
.35585 .09131 L
s
.3802 .07506 m
.35584 .07507 L
s
.38021 .0913 m
.36802 .08725 L
s
.35585 .09131 m
.36802 .08725 L
s
newpath
.39014 .00406 .00457 0 365.73 arc
s
newpath
.39014 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00WOooool5o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Looooo`04o`000?ooooooooooooooo`Go00006Ooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool009_ooooo00?o0000
ooooooooool00_l000000ooooooo0000ooooo`02o`0001Wooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`3ooooood_ooooo002Kooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_l0000Hooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Looooo`;o
000000?oooooo`000?l000001?ooool3o`0001Kooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`3oooooodgooooo002Nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool00000
5Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009oooooo00?o
0000ooooooooool01Oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0oooooom?ooooo`00X?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
000001?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Qoooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooool000004_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo0?ooooooDOooool00:;ooooo00?o0000ooooooooool01Oooool01?l0003o
ooooo`000?l0000@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBoooo
o`00Xoooool2o`0000Kooooo00Co0000oooooooooooo00003oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo0?ooooooDoooool00:Gooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooomDoooo
o`00Y_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000gooooo0ol0000>oooo
o`03o`000?oooooooooo0?ooooooEOooool00:Oooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomFoooo
o`00Z?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;o00002_ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00:Wooooo00?o0000ooooooooool0
1?ooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`3ooooooeSooooo002Zooooo`;o00001Oooool01Ol0003ooooooooooooooooo000000So
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002/ooooo`03o`00
0?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0oooooomJooooo`00[Oooool00ol0003oooooooooo`03ooooo`05o`00
0?ooooooooooooooool000001_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?oo
ooooFoooool00:kooooo00?o0000ooooooooool00oooool01?l0003oooooooooooooool2o`0000Co
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002_ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooooooool3o`0000Ko
oooo00?o0000ooooooooool0oooooomMooooo`00/?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooooeko
oooo002aooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomOooooo`00/oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Cooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0oooooomQooooo`00]Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
ooooo`?o000000?oooooo`000?ooool01_ooool>o`000?ooooooCoooool00:gooooo0ol00004oooo
o`?o00001?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00ol00003ooooo`07o`000?oooooo0000ooooool0003oooooo`00
0007ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooooooo
0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooooooool5o`000003ooooool0003ooooo00Cooooo00Co0000oooooooo
oooooooo1Ol00004ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000Kooooo0_l00003
ooooo`05o`000?ooooooooooooooool000001?ooool01Ol0003ooooooooooooooooo00000?oooooo
Coooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool00000
2?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooo
ooooooooo`00003oooooodoooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`;o
00002Oooool00ol0003oooooo`000002ooooo`03o`000?oooooo000000Co00000oooool00ol0003o
ooooooooo`3oooooodgooooo002nooooo`;o00002Oooool2o`000004ooooool0003o0000o`0000Co
oooo0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`03o`000?oooooo000000Wooooo
3_l0003oooooodoooooo002nooooo`04o`000?ooooooooooo`0000Wooooo0_l00003ooooo`;o0000
00?oooooo`000?ooool0oooooomBooooo`00__ooool01Ol0003ooooooooooooooooo000000Wooooo
0_l00005ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo0ol00002ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3ooooooe7ooooo002n
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool01?ooool2
o`0000Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002noooo
o`03o`000?oooooooooo00Kooooo00Co0000oooooooooooooooo0ol00003ooooo`;o0000oooooomD
ooooo`00__ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;o00001?ooool2o`00
0?ooooooE?ooool00;kooooo00?o0000ooooooooool02?ooool00ol0003oooooo`000006ooooo`03
o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool02Oooool2o`0000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`0:ooooo`?o00000ooo
ool00ol0003oooooooooo`3ooooooe?ooooo002nooooo`?o00002oooool00ol0003oooooo`000003
o`000?ooooooEOooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go
0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?oo
ooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27099 .02958 .00609 0 365.73 arc
s
newpath
.36451 .10762 .00609 0 365.73 arc
s
newpath
.36802 .08722 .00609 0 365.73 arc
s
.27489 .0249 m
.36841 .10295 L
s
.26709 .03426 m
.3606 .1123 L
s
.37051 .10866 m
.37402 .08825 L
s
.3585 .10659 m
.36202 .08618 L
s
.3802 .09127 m
.38019 .07503 L
s
.35583 .07505 m
.35584 .09129 L
s
.27099 .02958 m
.39009 .00406 L
s
.3802 .09127 m
.35584 .09129 L
s
.38019 .07503 m
.35583 .07505 L
s
.3802 .09127 m
.36802 .08722 L
s
.35584 .09129 m
.36802 .08722 L
s
newpath
.39009 .00406 .00457 0 365.73 arc
s
newpath
.39009 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00WOooool5o`0000Sooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool00ol0003oooooooooo`02ooooo`;o00000_ooool5o`0001Cooooo00?o0000ooooooooool06_oo
ool00ol0003oooooooooo`3oooooodWooooo002Looooo`04o`000?ooooooooooooooo`Go00006Ooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool009_ooooo00?o0000
ooooooooool00_l000000ooooooo0000ooooo`02o`0001Wooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`3ooooood_ooooo002Kooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00_l0000Hooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Looooo`;o
000000?oooooo`000?l000001?ooool3o`0001Kooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`3oooooodgooooo002Nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool00000
5Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009oooooo00?o
0000ooooooooool01Oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0oooooom?ooooo`00X?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
000001?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Qoooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooool000004_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo0?ooooooDOooool00:;ooooo00?o0000ooooooooool01Oooool01?l0003o
ooooo`000?l0000@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBoooo
o`00Xoooool2o`0000Kooooo00Co0000oooooooooooo00003oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo0?ooooooDoooool00:Gooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000>ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooomDoooo
o`00Y_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000gooooo0ol0000>oooo
o`03o`000?oooooooooo0?ooooooEOooool00:Oooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomFoooo
o`00Z?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;o00002_ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00:Wooooo00?o0000ooooooooool0
1?ooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`3ooooooeSooooo002Zooooo`;o00001Oooool01Ol0003ooooooooooooooooo000000So
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002/ooooo`03o`00
0?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool0oooooomJooooo`00[Oooool00ol0003oooooooooo`03ooooo`05o`00
0?ooooooooooooooool000001_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?oo
ooooFoooool00:kooooo00?o0000ooooooooool00oooool01?l0003oooooooooooooool2o`0000Co
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002_ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooooooool3o`0000Ko
oooo00?o0000ooooooooool0oooooomMooooo`00/?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooooeko
oooo002aooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000Kooooo
00?o0000ooooooooool0oooooomOooooo`00/oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Cooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0oooooomQooooo`00]Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
ooooo`?o000000?oooooo`000?ooool01_ooool>o`000?ooooooCoooool00:gooooo0ol00004oooo
o`?o00001?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00ol00003ooooo`07o`000?oooooo0000ooooool0003oooooo`00
0007ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooooooo
0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooooooool5o`000003ooooool0003ooooo00Cooooo00Co0000oooooooo
oooooooo1Ol00004ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000Kooooo0_l00003
ooooo`05o`000?ooooooooooooooool000001?ooool01Ol0003ooooooooooooooooo00000?oooooo
Coooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool00000
2?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooo
ooooooooo`00003oooooodoooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`;o
00002Oooool00ol0003oooooo`000002ooooo`03o`000?oooooo000000Co00000oooool00ol0003o
ooooooooo`3oooooodgooooo002nooooo`;o00002Oooool2o`000004ooooool0003o0000o`0000Co
oooo0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`03o`000?oooooo000000Wooooo
3_l0003oooooodoooooo002nooooo`04o`000?ooooooooooo`0000Wooooo0_l00003ooooo`;o0000
00?oooooo`000?ooool0oooooomBooooo`00__ooool01Ol0003ooooooooooooooooo000000Wooooo
0_l00005ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo0ol00002ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3ooooooe7ooooo002n
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool01?ooool2
o`0000Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002noooo
o`03o`000?oooooooooo00Kooooo00Co0000oooooooooooooooo0ol00003ooooo`;o0000oooooomD
ooooo`00__ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;o00001?ooool2o`00
0?ooooooE?ooool00;kooooo00?o0000ooooooooool02?ooool00ol0003oooooo`000006ooooo`03
o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool02Oooool2o`0000Kooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`0:ooooo`?o00000ooo
ool00ol0003oooooooooo`3ooooooe?ooooo002nooooo`?o00002oooool00ol0003oooooo`000003
o`000?ooooooEOooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go
0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?oo
ooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27093 .02965 .00609 0 365.73 arc
s
newpath
.36453 .10759 .00609 0 365.73 arc
s
newpath
.36802 .08718 .00609 0 365.73 arc
s
.27483 .02497 m
.36843 .10291 L
s
.26704 .03433 m
.36064 .11227 L
s
.37054 .10861 m
.37402 .0882 L
s
.35853 .10656 m
.36201 .08615 L
s
.3802 .09122 m
.38018 .07498 L
s
.35582 .07501 m
.35584 .09125 L
s
.27093 .02965 m
.39002 .00406 L
s
.3802 .09122 m
.35584 .09125 L
s
.38018 .07498 m
.35582 .07501 L
s
.3802 .09122 m
.36802 .08718 L
s
.35584 .09125 m
.36802 .08718 L
s
newpath
.39002 .00406 .00457 0 365.73 arc
s
newpath
.39002 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`?o0000oooooom9ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo1?l0
00000ooooooo0000ooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Dooooo`Oo000000?ooooo
o`000?ooool01_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool5o`0000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003ooooooooo
ooooool5o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Nooooo`Go00007_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1Ol000000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00WOooool4o`0000Wooooo
1Ol0000?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool01?l0003oooooooooooooool2o`0000?ooooo1Ol0000Dooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool0oooooom9ooooo`00W?ooool01?l0003oooooooooooooool5o`0001Wooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Kooooo`03o`000?oo
oooooooo00;o000000Coooooo`000?oooooo00006_ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool01?l0003ooooooooo
ool0000Iooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Looooo`;o000000?o
ooooo`000?l000001?ooool2o`0001Oooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`3oooooodgooooo002Nooooo`03o`000?oooooooooo00Gooooo0_l0000Fooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Woooool00ol0003oooooooooo`05oooo
o`;o00005Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool00:3o
oooo00?o0000ooooooooool01Oooool2o`0001Cooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`3ooooooe3ooooo002Qooooo`03o`000?oooooooooo00Gooooo0_l0000Cooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0oooooomAooooo`00X_ooool2o`0000Kooooo0ol0
000Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBooooo`00Y?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooo0000013ooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`3ooooooe?ooooo002Uooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ool000003oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00:Ko
oooo00?o0000ooooooooool01?ooool00ol0003oooooo`00000>ooooo`?o00003_ooool00ol0003o
ooooooooo`3ooooooeGooooo002Wooooo`03o`000?oooooooooo00Cooooo00Co0000ooooool0003o
00003?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:Sooooo
0_l00005ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`3ooooooeOooooo002Zooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo
00002_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00:_ooooo
00?o0000ooooooooool00oooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0oooooomIooooo`00[?ooool00ol0003oooooooooo`03ooooo`04o`00
0?ooooooooooo`0000Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[o
oooo002]ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_l00006ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool0oooooomKooooo`00[_ooool2o`0000Cooooo00Go
0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
oooooomLooooo`00/?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
1?ooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00/Oooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooG_ooool00;;ooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ooooool2o`000003ooooool0003ooooo00Gooooo00?o0000ooooooooool0oooooomOooooo`00/ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo0_l00005ooooo`03o`000?oo
oooooooo0?ooooooH?ooool00;Cooooo0_l00003ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`3oooooof7ooooo002fooooo`05o`000?oooooooooo
ooooool000000oooool2o`0000;ooooo00?o0000ooooooooool01Oooool>o`000?ooooooCoooool0
0:gooooo0ol00004ooooo`;o000000?oooooo`000?ooool00_ooool01Ol0003oooooooooool0003o
oooo00;o00002?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool0
0:kooooo00?o0000ooooooooool00_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00Co
0000ooooool0003ooooo0ol00007ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
oooooom=ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooooooo0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooooooool5o`000003ooooool0003ooooo
00Cooooo00Co0000oooooooooooooooo1Ol00004ooooo`03o`000?oooooooooo0?ooooooCOooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`;o000000?ooooo
o`000?ooool01Oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001?oo
ool01Ol0003ooooooooooooooooo00000?ooooooCoooool00:gooooo0_l00004ooooo`04o`000?oo
ooooooooo`0000Kooooo0_l00007ooooo`;o00000_ooool01?l0003oooooooooool00005ooooo`05
o`000?ooooooooooooooool00000oooooom?ooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o
00002?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool0
00001?l00003ooooo`03o`000?oooooooooo0?ooooooCOooool00;kooooo0_l00009ooooo`;o0000
00Coooooo`000?l0003o00001?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo
00?o0000ooooool000002Oooool>o`000?ooooooCoooool00;kooooo00?o0000ooooooooool00_l0
0008ooooo`;o00000oooool2o`000003ooooool0003ooooo0?ooooooD_ooool00;kooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`06ooooo`;o00001Oooool00ol0003oooooooooo`3o
oooooe7ooooo002nooooo`?o00000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo0000
00Cooooo00?o0000ooooooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3ooooo
oe;ooooo002nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool00ol0003o
ooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool0
1_ooool2o`0000;ooooo0ol00003ooooo`;o0000oooooomDooooo`00__ooool00ol0003ooooooooo
o`08ooooo`04o`000?oooooo0000o`0000Cooooo0_l0003ooooooeCooooo002nooooo`03o`000?oo
oooooooo00Wooooo0_l00006ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooD_ooool0
0;kooooo00?o0000ooooooooool02oooool2o`0000?ooooo00?o0000ooooooooool0oooooomCoooo
o`00__ooool3o`0000cooooo1Ol0003ooooooeGooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o
0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co
0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?oo
ooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000ooo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o
0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0
003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27086 .02973 .00609 0 365.73 arc
s
newpath
.36457 .10755 .00609 0 365.73 arc
s
newpath
.36801 .08713 .00609 0 365.73 arc
s
.27475 .02505 m
.36846 .10286 L
s
.26697 .03442 m
.36068 .11223 L
s
.37057 .10856 m
.37402 .08814 L
s
.35856 .10653 m
.36201 .08611 L
s
.3802 .09117 m
.38017 .07493 L
s
.35581 .07497 m
.35584 .09121 L
s
.27086 .02973 m
.38993 .00406 L
s
.3802 .09117 m
.35584 .09121 L
s
.38017 .07493 m
.35581 .07497 L
s
.3802 .09117 m
.36801 .08713 L
s
.35584 .09121 m
.36801 .08713 L
s
newpath
.38993 .00406 .00457 0 365.73 arc
s
newpath
.38993 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`;o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03ooooo`Co0000
00?oooooo`000?ooool01_ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool05?ooool7o`000003ooooool0
003ooooo00Kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00oooooo1Ol00007ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00[ooooo1Ol0000Cooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`Co00005oooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo
oooo1Ol0000Jooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool0
7_ooool5o`0001kooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003ooooooooo
o`0Hooooo`Go000000?oooooo`000?ooool07oooool00ol0003oooooooooo`3oooooodGooooo002N
ooooo`03o`000?oooooooooo01;ooooo1Ol00006ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0=ooooo`Co00002oooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool009gooooo1?l00009ooooo`Go
00003oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool009cooooo
00Co0000oooooooooooooooo0_l00003ooooo`Go00005?ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo0?ooooooBOooool009cooooo00Co0000oooooooooooooooo1Ol0000Iooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0003ooooo
ooooo`02o`000004ooooool0003oooooo`0001[ooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`3ooooood_ooooo002Kooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo
00006Oooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00W?ooool2o`000003oooo
ool0003o000000Cooooo0_l0000Gooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
oooooom=ooooo`00W_ooool00ol0003oooooooooo`05ooooo`;o00005_ooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009oooooo00?o0000ooooooooool01Oooool2
o`0001Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3oooooodoooooo002Poooo
o`03o`000?oooooooooo00Gooooo0_l0000Dooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0oooooom@ooooo`00XOooool00ol0003oooooooooo`05ooooo`;o00004oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo0?ooooooDOooool00:;ooooo0_l00006ooooo`?o0000
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool00:Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooo`00000@ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
000000oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002Voooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooool000003_ooool3o`0000kooooo00?o0000oooo
ooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`000?oooooo0000o`00
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKooooo002Xooooo`;o
00001Oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool0oooooomGooooo`00Z_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`00
00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeSooooo002[ooooo`03
o`000?oooooooooo00?ooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o0000ooooooooool00oooool01?l0003o
ooooooooool00008ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJoooo
o`00[Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o00001_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo0?ooooooFoooool00:kooooo0_l00004ooooo`05o`00
0?ooooooooooooooool000001Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oo
ooooG?ooool00;3ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Co
oooo0ol00006ooooo`03o`000?oooooooooo0?ooooooGOooool00;7ooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3ooooooekooooo002booooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
oooo0_l000000ooooooo0000ooooo`05ooooo`03o`000?oooooooooo0?ooooooGoooool00;?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`;o00001Oooool00ol0003ooooo
ooooo`3oooooof3ooooo002dooooo`;o00000oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0oooooomQooooo`00]_ooool01Ol0003ooooooooooooo
oooo000000?ooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo3_l0003oooooodoooooo002]
ooooo`?o00001?ooool2o`000003ooooool0003ooooo00;ooooo00Go0000oooooooooooo0000oooo
o`02o`0000Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`04o`00
0?oooooo0000ooooo`?o00001oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?oo
ooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooooooo`?o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooooooo1Ol000000ooooooo0000ooooo`04
ooooo`04o`000?ooooooooooooooo`Go00001?ooool00ol0003oooooooooo`3oooooodgooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000003ooooool0
003ooooo00Gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00Go0000ooooooooooooooooo`00003oooooodoooooo002]ooooo`;o00001?ooool01?l0003ooooo
ooooool00006ooooo`;o00001oooool2o`0000;ooooo00Co0000oooooooooooo00001Oooool01Ol0
003ooooooooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`00
00Sooooo00?o0000ooooooooool01oooool00ol0003oooooo`000002ooooo`03o`000?oooooo0000
00Co00000oooool00ol0003oooooooooo`3oooooodgooooo002nooooo`;o00002Oooool2o`000004
ooooool0003o0000o`0000Cooooo0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`03
o`000?oooooo000000Wooooo3_l0003oooooodoooooo002nooooo`03o`000?oooooooooo00;o0000
2?ooool2o`0000?ooooo0_l000000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool01_ooool2o`0000Gooooo00?o0000ooooooooool0oooo
oomAooooo`00__ooool3o`0000?ooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000004
ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomB
ooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002nooooo`03o`000?oooooooooo00Ko
oooo0_l00002ooooo`?o00000oooool2o`000?ooooooE?ooool00;kooooo00?o0000ooooooooool0
2?ooool01?l0003oooooo`000?l00004ooooo`;o0000oooooomDooooo`00__ooool00ol0003ooooo
ooooo`09ooooo`;o00001_ooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooe;ooooo002n
ooooo`03o`000?oooooooooo00_ooooo0_l00003ooooo`03o`000?oooooooooo0?ooooooDoooool0
0;kooooo0ol0000<ooooo`Go0000oooooomEooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`00
0?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000
oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27076 .02985 .00609 0 365.73 arc
s
newpath
.36462 .10749 .00609 0 365.73 arc
s
newpath
.368 .08706 .00609 0 365.73 arc
s
.27465 .02516 m
.3685 .10279 L
s
.26688 .03454 m
.36074 .11218 L
s
.37063 .10848 m
.37401 .08805 L
s
.35861 .10649 m
.362 .08606 L
s
.38019 .09109 m
.38016 .07485 L
s
.3558 .0749 m
.35583 .09114 L
s
.27076 .02985 m
.3898 .00406 L
s
.38019 .09109 m
.35583 .09114 L
s
.38016 .07485 m
.3558 .0749 L
s
.38019 .09109 m
.368 .08706 L
s
.35583 .09114 m
.368 .08706 L
s
newpath
.3898 .00406 .00457 0 365.73 arc
s
newpath
.3898 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`;o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03ooooo`Co0000
00?oooooo`000?ooool01_ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool05?ooool7o`000003ooooool0
003ooooo00Kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00oooooo1Ol00007ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00[ooooo1Ol0000Cooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`Co00005oooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo
oooo1Ol0000Jooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool0
7_ooool5o`0001kooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003ooooooooo
o`0Hooooo`Go000000?oooooo`000?ooool07oooool00ol0003oooooooooo`3oooooodGooooo002N
ooooo`03o`000?oooooooooo01;ooooo1Ol00006ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0=ooooo`Co00002oooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool009gooooo1?l00009ooooo`Go
00003oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool009cooooo
00Co0000oooooooooooooooo0_l00003ooooo`Go00005?ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo0?ooooooBOooool009cooooo00Co0000oooooooooooooooo1Ol0000Iooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0003ooooo
ooooo`02o`000004ooooool0003oooooo`0001[ooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`3ooooood_ooooo002Kooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo
00006Oooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00W?ooool2o`000003oooo
ool0003o000000Cooooo0_l0000Gooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
oooooom=ooooo`00W_ooool00ol0003oooooooooo`05ooooo`;o00005_ooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009oooooo00?o0000ooooooooool01Oooool2
o`0001Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3oooooodoooooo002Poooo
o`03o`000?oooooooooo00Gooooo0_l0000Dooooo`03o`000?oooooooooo01?ooooo00?o0000oooo
ooooool0oooooom@ooooo`00XOooool00ol0003oooooooooo`05ooooo`;o00004oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo0?ooooooDOooool00:;ooooo0_l00006ooooo`?o0000
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool00:Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooo`00000@ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool0oooooomCooooo`00YOooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
000000oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002Voooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooool000003_ooool3o`0000kooooo00?o0000oooo
ooooool0oooooomEooooo`00Yoooool00ol0003oooooooooo`04ooooo`04o`000?oooooo0000o`00
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKooooo002Xooooo`;o
00001Oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool0oooooomGooooo`00Z_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`00
00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeSooooo002[ooooo`03
o`000?oooooooooo00?ooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo0?ooooooFOooool00:cooooo00?o0000ooooooooool00oooool01?l0003o
ooooooooool00008ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJoooo
o`00[Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o00001_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo0?ooooooFoooool00:kooooo0_l00004ooooo`05o`00
0?ooooooooooooooool000001Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oo
ooooG?ooool00;3ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Co
oooo0ol00006ooooo`03o`000?oooooooooo0?ooooooGOooool00;7ooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3ooooooekooooo002booooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
oooo0_l000000ooooooo0000ooooo`05ooooo`03o`000?oooooooooo0?ooooooGoooool00;?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`;o00001Oooool00ol0003ooooo
ooooo`3oooooof3ooooo002dooooo`;o00000oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0oooooomQooooo`00]_ooool01Ol0003ooooooooooooo
oooo000000?ooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo3_l0003oooooodoooooo002]
ooooo`?o00001?ooool2o`000003ooooool0003ooooo00;ooooo00Go0000oooooooooooo0000oooo
o`02o`0000Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`04o`00
0?oooooo0000ooooo`?o00001oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?oo
ooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooooooo`?o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooooooo1Ol000000ooooooo0000ooooo`04
ooooo`04o`000?ooooooooooooooo`Go00001?ooool00ol0003oooooooooo`3oooooodgooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000003ooooool0
003ooooo00Gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo
00Go0000ooooooooooooooooo`00003oooooodoooooo002]ooooo`;o00001?ooool01?l0003ooooo
ooooool00006ooooo`;o00001oooool2o`0000;ooooo00Co0000oooooooooooo00001Oooool01Ol0
003ooooooooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00oooool2o`00
00Sooooo00?o0000ooooooooool01oooool00ol0003oooooo`000002ooooo`03o`000?oooooo0000
00Co00000oooool00ol0003oooooooooo`3oooooodgooooo002nooooo`;o00002Oooool2o`000004
ooooool0003o0000o`0000Cooooo0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`03
o`000?oooooo000000Wooooo3_l0003oooooodoooooo002nooooo`03o`000?oooooooooo00;o0000
2?ooool2o`0000?ooooo0_l000000ooooooo0000ooooo`3ooooooe;ooooo002nooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool01_ooool2o`0000Gooooo00?o0000ooooooooool0oooo
oomAooooo`00__ooool3o`0000?ooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000004
ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomB
ooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002nooooo`03o`000?oooooooooo00Ko
oooo0_l00002ooooo`?o00000oooool2o`000?ooooooE?ooool00;kooooo00?o0000ooooooooool0
2?ooool01?l0003oooooo`000?l00004ooooo`;o0000oooooomDooooo`00__ooool00ol0003ooooo
ooooo`09ooooo`;o00001_ooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooe;ooooo002n
ooooo`03o`000?oooooooooo00_ooooo0_l00003ooooo`03o`000?oooooooooo0?ooooooDoooool0
0;kooooo0ol0000<ooooo`Go0000oooooomEooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`00
0?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000
oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27065 .02998 .00609 0 365.73 arc
s
newpath
.36467 .10742 .00609 0 365.73 arc
s
newpath
.368 .08698 .00609 0 365.73 arc
s
.27452 .02528 m
.36855 .10272 L
s
.26678 .03469 m
.3608 .11212 L
s
.37068 .1084 m
.37401 .08796 L
s
.35866 .10644 m
.36198 .086 L
s
.38019 .09101 m
.38014 .07477 L
s
.35578 .07483 m
.35583 .09108 L
s
.27065 .02998 m
.38966 .00406 L
s
.38019 .09101 m
.35583 .09108 L
s
.38014 .07477 m
.35578 .07483 L
s
.38019 .09101 m
.368 .08698 L
s
.35583 .09108 m
.368 .08698 L
s
newpath
.38966 .00406 .00457 0 365.73 arc
s
newpath
.38966 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`;o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03ooooo`Co0000
00?oooooo`000?ooool01_ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool05?ooool6o`000003ooooool0
003o000000Oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00oooooo1Ol00006ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00[ooooo1Ol0000Cooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`Co00005oooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo
oooo1Ol0000Jooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool0
7_ooool5o`0001kooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003ooooooooo
o`0Hooooo`Go000000?oooooo`000?ooool07oooool00ol0003oooooooooo`3oooooodGooooo002N
ooooo`03o`000?oooooooooo01;ooooo1Ol00006ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0=ooooo`Co00002oooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool009gooooo1?l00009ooooo`Go
00003oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool009cooooo
00Co0000oooooooooooooooo0_l00003ooooo`Go00005?ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo0?ooooooBOooool009cooooo00Co0000oooooooooooooooo1Ol0000Iooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool00ol0003ooooo
ooooo`02o`000004ooooool0003oooooo`0001[ooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`3ooooood_ooooo002Kooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo
00006Oooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00W?ooool2o`000003oooo
ool0003o000000Cooooo0_l0000Gooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0
oooooom=ooooo`00W?ooool3o`0000Oooooo0_l0000Fooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool0oooooom>ooooo`00W_ooool00ol0003oooooooooo`06ooooo`;o00005Oooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool009oooooo00?o0000oooo
ooooool01_ooool2o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooo
oe3ooooo002Pooooo`03o`000?oooooooooo00Kooooo0_l0000Cooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00XOooool2o`0000Oooooo0ol0000Aooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool0oooooomBooooo`00Xoooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooo0000013ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`3ooooooe?ooooo002Tooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000003oooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00:Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooo`00000>ooooo`?o00003_ooool00ol0003oooooooooo`3ooooo
oeGooooo002Vooooo`03o`000?oooooooooo00Gooooo00Co0000ooooool0003o00003?ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:Oooooo0_l00006ooooo`04
o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooo
oeOooooo002Yooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00:[ooooo00?o0000oooooooo
ool01?ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0oooooomIooooo`00Zoooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002/ooooo`;o
00001Oooool00ol0003oooooooooo`02o`0000Kooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`3ooooooe_ooooo002^ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooooooo
ooooo`000005ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00
[oooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooooooool000001?ooool3o`0000Ko
oooo00?o0000ooooooooool0oooooomMooooo`00/?ooool00ol0003oooooooooo`03ooooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oo
ooooG_ooool00;7ooooo00?o0000ooooooooool00oooool01?l0003oooooooooooooool2o`000003
ooooool0003ooooo00Gooooo00?o0000ooooooooool0oooooomOooooo`00/_ooool2o`0000Cooooo
00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00]?oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo3_l0003oooooodoooooo002]
ooooo`?o00001?ooool3o`0000Cooooo00Go0000oooooooooooo0000ooooo`02o`0000Sooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00ol00003ooooo`04o`000?oooooo0000ooooo`?o00001ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooooooo`?o0000
0oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`03o`00
0?oooooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool01?ooool01?l0003o
ooooooooooooool2o`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooo
odgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0
003oooooooooool00006ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0004ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00[Oooool2o`0000Cooooo00Co
0000oooooooooooo00001Oooool00ol0003oooooo`000007ooooo`;o00000_ooool01?l0003ooooo
ooooool00005ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00[_ooool00ol0003o
ooooooooo`03ooooo`;o00001oooool2o`0000Wooooo00?o0000ooooool000000_ooool00ol0003o
ooooo`000004o`0000?ooooo00?o0000ooooooooool0oooooom=ooooo`00__ooool2o`0000Wooooo
0_l000001?oooooo0000o`000?l00004ooooo`?o000000?oooooo`000?ooool0oooooom>ooooo`00
__ooool00ol0003oooooo`000009ooooo`ko0000oooooom?ooooo`00__ooool01?l0003ooooooooo
ool00009ooooo`;o00000oooool2o`000003ooooool0003ooooo0?ooooooD_ooool00;kooooo00Co
0000oooooooooooooooo0_l00008ooooo`;o00001Oooool00ol0003oooooooooo`3ooooooe7ooooo
002nooooo`?o00000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000Cooooo00?o
0000ooooooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3ooooooe;ooooo002n
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool00ol0003oooooo`000002
o`000003ooooool0003ooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool01_ooool01ol0
003ooooooooooooooooo0000ooooool000000oooool2o`000?ooooooE?ooool00;kooooo00?o0000
ooooooooool01oooool2o`000003ooooool0003o000000Cooooo0_l0003ooooooeCooooo002noooo
o`03o`000?oooooooooo00Wooooo0_l00006ooooo`03o`000?oooooooooo0?ooooooD_ooool00;ko
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oo
ooooD_ooool00;kooooo00?o0000ooooooooool02oooool3o`000003ooooool0003o00000?oooooo
EOooool00;kooooo0ol0000<ooooo`03o`000?oooooo00000?ooooooEoooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^oooo
o`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`00
00?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000oooo
ool000000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003o
ooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo
0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooo
oooo00001oooool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000oooooooo
ool00oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:ko
oooo0_l00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27052 .03015 .00609 0 365.73 arc
s
newpath
.36474 .10734 .00609 0 365.73 arc
s
newpath
.36799 .08689 .00609 0 365.73 arc
s
.27438 .02544 m
.3686 .10263 L
s
.26666 .03486 m
.36088 .11205 L
s
.37075 .10829 m
.374 .08784 L
s
.35873 .10638 m
.36197 .08593 L
s
.38018 .0909 m
.38012 .07466 L
s
.35576 .07475 m
.35582 .09099 L
s
.27052 .03015 m
.3895 .00406 L
s
.38018 .0909 m
.35582 .09099 L
s
.38012 .07466 m
.35576 .07475 L
s
.38018 .0909 m
.36799 .08689 L
s
.35582 .09099 m
.36799 .08689 L
s
newpath
.3895 .00406 .00457 0 365.73 arc
s
newpath
.3895 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`;o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03ooooo`?o0000
0_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Cooooo`Go000000?o
ooooo`000?ooool00_l00007ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_oo
ool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?oo
ool009Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0>ooooo`Go00001oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`0:ooooo`Co00005?ooool00ol0003oooooooooo`3ooooo
od7ooooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01Oooool5o`0001Oo
oooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo00Go00006oooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`000?oo
oooooooo01gooooo1Ol0000Oooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000
ooooooooool06?ooool4o`0000;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3o
ooooodGooooo002Nooooo`03o`000?oooooooooo01;ooooo1Ol00006ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0<ooooo`Go
00002oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool009gooooo
1?l00009ooooo`Co00004?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?oooooo
B?ooool009cooooo00Co0000oooooooooooooooo0_l00003ooooo`Go00005?ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo0?ooooooBOooool009cooooo00Co0000oooooooooooooooo
1Ol0000Iooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Vooo
ool00ol0003oooooooooo`02o`000004ooooool0003oooooo`0001[ooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`3ooooood_ooooo002Kooooo`03o`000?oooooooooo00?ooooo00Co
0000oooooooooooo00006Oooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00W?oo
ool2o`000003ooooool0003o000000Cooooo0_l0000Gooooo`03o`000?oooooooooo01Kooooo00?o
0000ooooooooool0oooooom=ooooo`00W?ooool3o`0000Oooooo0_l0000Fooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00W_ooool00ol0003oooooooooo`06oooo
o`;o00005Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool009oo
oooo00?o0000ooooooooool01_ooool2o`0001Cooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`3ooooooe3ooooo002Pooooo`03o`000?oooooooooo00Kooooo0_l0000Cooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0oooooomAooooo`00XOooool2o`0000Oooooo0ol0
000Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBooooo`00Xoooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo0000013ooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`3ooooooe?ooooo002Tooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000003oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00:Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000>ooooo`?o00003_ooool00ol0003o
ooooooooo`3ooooooeGooooo002Vooooo`03o`000?oooooooooo00Gooooo00Co0000ooooool0003o
00003?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:Oooooo
0_l00006ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`3ooooooeOooooo002Yooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00002_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00:[ooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0oooooomIooooo`00Zoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[o
oooo002/ooooo`;o00001Oooool00ol0003oooooooooo`02o`0000Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`3ooooooe_ooooo002^ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
oooooomLooooo`00[oooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooooooool00000
1?ooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00/?ooool00ol0003ooooooooo
o`03ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooG_ooool00;7ooooo00?o0000ooooooooool00oooool01?l0003ooooooooo
ooooool2o`000003ooooool0003ooooo00Gooooo00?o0000ooooooooool0oooooomOooooo`00/_oo
ool2o`0000Cooooo00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooo
oomPooooo`00]?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo3_l0003o
ooooodoooooo002]ooooo`?o00001?ooool3o`0000Cooooo00Go0000oooooooooooo0000ooooo`02
o`0000Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00ol00003ooooo`04o`000?oooooo0000
ooooo`?o00001oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooooooo`?o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0_l0
0005ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool0
1?ooool01?l0003oooooooooooooool2o`0000;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001?ooool01?l0003oooooooooool00006ooooo`03o`000?oooooooooo00;ooooo00Go0000oooo
ooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00[Oooool2
o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`000007ooooo`;o00000_oo
ool01?l0003oooooooooool00005ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00
[_ooool00ol0003oooooooooo`03ooooo`;o00001oooool2o`0000Wooooo00?o0000ooooool00000
0_ooool00ol0003oooooo`000004o`0000?ooooo00?o0000ooooooooool0oooooom=ooooo`00__oo
ool2o`0000Wooooo0_l000001?oooooo0000o`000?l00004ooooo`?o000000?oooooo`000?ooool0
oooooom>ooooo`00__ooool00ol0003oooooo`000009ooooo`ko0000oooooom?ooooo`00__ooool0
1?l0003oooooooooool00009ooooo`03o`000?oooooo000000;ooooo0_l000000ooooooo0000oooo
o`3ooooooe;ooooo002nooooo`04o`000?ooooooooooooooo`;o00002?ooool2o`0000Gooooo00?o
0000ooooooooool0oooooomAooooo`00__ooool3o`0000?ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002nooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool00_ooool2o`0000?ooooo0_l0003ooooooeCo
oooo002nooooo`03o`000?oooooooooo00Oooooo0_l00002ooooo`03o`000?oooooooooo00;ooooo
0_l0003ooooooeCooooo002nooooo`03o`000?oooooooooo00Wooooo0ol00005ooooo`03o`000?oo
oooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool02oooool3o`00
0003ooooool0003o00000?ooooooEOooool00;kooooo0ol0000<ooooo`03o`000?oooooo00000?oo
ooooEoooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go0000oooo
oomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo
0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000
oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`00
0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5
o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?oooooo
I?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002`
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?oo
ool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool4
o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo00?o0000
ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27034 .03037 .00609 0 365.73 arc
s
newpath
.36483 .10723 .00609 0 365.73 arc
s
newpath
.36797 .08676 .00609 0 365.73 arc
s
.27418 .02564 m
.36867 .1025 L
s
.2665 .03509 m
.36099 .11195 L
s
.37085 .10815 m
.37399 .08769 L
s
.35881 .1063 m
.36195 .08584 L
s
.38017 .09076 m
.3801 .07452 L
s
.35574 .07464 m
.35581 .09088 L
s
.27034 .03037 m
.38927 .00406 L
s
.38017 .09076 m
.35581 .09088 L
s
.3801 .07452 m
.35574 .07464 L
s
.38017 .09076 m
.36797 .08676 L
s
.35581 .09088 m
.36797 .08676 L
s
newpath
.38927 .00406 .00457 0 365.73 arc
s
newpath
.38927 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`;o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03ooooo`?o0000
00?oooooo`000?l000001oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool5o`000003ooooool0
003ooooo00;o00001oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o
0000ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002H
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03_ooool5o`0000Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool02_ooool4o`0001Cooooo00?o0000ooooooooool0oooooom1oooo
o`00V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Gooooo1Ol0000Gooooo`03
o`000?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool00ol0003ooooo
ooooo`05o`0001_ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Mooooo`Go00007oooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Sooooo1?l00002ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooom5
ooooo`00W_ooool00ol0003oooooooooo`0Booooo`Go00001_ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool03?ooool5o`0000_o
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo002Mooooo`Co0000
2Oooool4o`00013ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`3oooooodSooooo
002Looooo`04o`000?ooooooooooooooo`;o00000oooool5o`0001Cooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`3oooooodWooooo002Looooo`04o`000?ooooooooooooooo`Go0000
6Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool009_ooooo00?o
0000ooooooooool00_l000001?oooooo0000ooooool0000Jooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool0oooooom;ooooo`00Voooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0001Wooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009_ooooo0ol0
0002ooooo`03o`000?oooooooooo00;ooooo0_l0000Gooooo`03o`000?oooooooooo01Kooooo00?o
0000ooooooooool0oooooom=ooooo`00W?ooool5o`0000Gooooo0_l0000Fooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00W_ooool00ol0003oooooooooo`06oooo
o`;o00005Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool009oo
oooo00?o0000ooooooooool01_ooool2o`0001Cooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`3ooooooe3ooooo002Pooooo`03o`000?oooooooooo00Kooooo0_l0000Cooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool0oooooomAooooo`00XOooool2o`0000Oooooo0ol0
000Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBooooo`00Xoooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooo0000013ooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`3ooooooe?ooooo002Tooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ool000003oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00:Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000>ooooo`?o00003_ooool00ol0003o
ooooooooo`3ooooooeGooooo002Vooooo`03o`000?oooooooooo00Gooooo00Co0000ooooool0003o
00003?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:Oooooo
0_l00006ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`3ooooooeOooooo002Yooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00002_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00:[ooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool0oooooomIooooo`00Zoooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[o
oooo002/ooooo`;o00001Oooool00ol0003oooooooooo`02o`0000Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`3ooooooe_ooooo002^ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
oooooomLooooo`00[oooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooooooool00000
1?ooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00/?ooool00ol0003ooooooooo
o`03ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooG_ooool00;7ooooo00?o0000ooooooooool00oooool01?l0003ooooooooo
ooooool2o`000003ooooool0003ooooo00Gooooo00?o0000ooooooooool0oooooomOooooo`00/_oo
ool2o`0000Cooooo00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooo
oomPooooo`00]?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo3_l0003o
ooooodoooooo002]ooooo`?o00001?ooool3o`0000Cooooo00Go0000oooooooooooo0000ooooo`02
o`0000Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00ol00003ooooo`04o`000?oooooo0000
ooooo`?o00001oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooooooo`?o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0ol0
0004ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooooooo`Go000000?oooooo`000?ooool0
1?ooool01?l0003oooooooooooooool2o`0000?ooooo00Go0000ooooooooooooooooo`00003ooooo
odoooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0
003oooooooooool00006ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0004ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00[Oooool2o`0000Cooooo00Co
0000oooooooooooo00001Oooool00ol0003oooooo`000007ooooo`;o00000_ooool01?l0003ooooo
ooooool00005ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00[_ooool00ol0003o
ooooooooo`03ooooo`;o00001oooool2o`0000Wooooo00?o0000ooooool000000_ooool00ol0003o
ooooo`000004o`0000?ooooo00?o0000ooooooooool0oooooom=ooooo`00__ooool2o`0000Wooooo
0_l000001?oooooo0000o`000?l00004ooooo`?o000000?oooooo`000?ooool0oooooom>ooooo`00
__ooool00ol0003oooooo`000009ooooo`ko0000oooooom?ooooo`00__ooool01?l0003ooooooooo
ool00009ooooo`03o`000?oooooo000000;ooooo0_l000000ooooooo0000ooooo`3ooooooe;ooooo
002nooooo`04o`000?ooooooooooooooo`;o00002?ooool2o`0000Gooooo00?o0000ooooooooool0
oooooomAooooo`00__ooool3o`0000?ooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
0004ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooo
oomBooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002nooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool00_ooool2o`0000?ooooo0_l0003ooooooeCooooo002nooooo`03
o`000?oooooooooo00Oooooo0_l00002ooooo`;o00000oooool2o`000?ooooooE?ooool00;kooooo
00?o0000ooooooooool02Oooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo0?oooooo
D_ooool00;kooooo00?o0000ooooooooool02_ooool2o`0000Gooooo00?o0000ooooooooool0oooo
oomBooooo`00__ooool00ol0003oooooooooo`0;ooooo`?o000000?oooooo`000?l00000oooooomE
ooooo`00__ooool3o`0000cooooo00?o0000ooooool00000oooooomGooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooooooo
o`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003ooooo
o`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oo
oooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003ooooooooo
ool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003ooooooooo
o`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27015 .0306 .00609 0 365.73 arc
s
newpath
.36493 .10711 .00609 0 365.73 arc
s
newpath
.36796 .08663 .00609 0 365.73 arc
s
.27397 .02587 m
.36875 .10237 L
s
.26632 .03534 m
.3611 .11185 L
s
.37095 .108 m
.37398 .08752 L
s
.3589 .10622 m
.36194 .08573 L
s
.38016 .09061 m
.38007 .07437 L
s
.35571 .07452 m
.3558 .09076 L
s
.27015 .0306 m
.38902 .00406 L
s
.38016 .09061 m
.3558 .09076 L
s
.38007 .07437 m
.35571 .07452 L
s
.38016 .09061 m
.36796 .08663 L
s
.3558 .09076 m
.36796 .08663 L
s
newpath
.38902 .00406 .00457 0 365.73 arc
s
newpath
.38902 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Kooooo`;o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03ooooo`?o0000
00?oooooo`000?l000001oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool7o`000003ooooool0
003o000000Oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00kooooo1Ol00007ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00[ooooo1?l0000Dooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`05ooooo`Go00005oooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
1Ol0000Kooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool07Ooo
ool5o`0001oooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0H
ooooo`Co00000_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00cooooo1Ol0000;ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00WOooool4o`0000Wooooo
1?l0000@ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?oo
ool01?l0003oooooooooooooool2o`0000?ooooo1Ol0000Dooooo`03o`000?oooooooooo01[ooooo
00?o0000ooooooooool0oooooom9ooooo`00W?ooool01?l0003oooooooooooooool5o`0001Wooooo
00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Kooooo`03o`000?oo
oooooooo00;o000000Coooooo`000?oooooo00006_ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo0?ooooooBoooool009_ooooo00?o0000ooooooooool00oooool01?l0003ooooooooo
ool0000Iooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Kooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool2o`0001Oooooo00?o0000ooooooooool05_oo
ool00ol0003oooooooooo`3oooooodgooooo002Kooooo`?o000000?oooooo`000?l000001Oooool2
o`0001Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`3oooooodkooooo002Noooo
o`03o`000?oooooooooo00Kooooo0_l0000Eooooo`03o`000?oooooooooo01Cooooo00?o0000oooo
ooooool0oooooom?ooooo`00Woooool00ol0003oooooooooo`06ooooo`;o00005?ooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00:3ooooo00?o0000ooooooooool0
1_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo
002Qooooo`;o00001oooool3o`00017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`3ooooooe;ooooo002Sooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000004?ooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool00:Cooooo00?o0000oooo
ooooool01Oooool00ol0003oooooo`00000?ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0oooooomDooooo`00YOooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000ko
oooo0ol0000>ooooo`03o`000?oooooooooo0?ooooooEOooool00:Kooooo00?o0000ooooooooool0
1Oooool01?l0003oooooo`000?l0000<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool0oooooomFooooo`00Yoooool2o`0000Kooooo00Co0000oooooooooooo00002oooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00:Wooooo00?o0000ooooooooool0
1?ooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0oooooomHooooo`00Z_ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Wo
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002[ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00002?ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo0?ooooooF_ooool00:cooooo0_l00005ooooo`03o`000?oooooooooo00;o0000
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooFoooool00:kooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`3ooooooecooooo002_ooooo`03o`000?oooooooooo00?ooooo00Go
0000ooooooooooooooooo`000004ooooo`?o00001_ooool00ol0003oooooooooo`3ooooooegooooo
002`ooooo`03o`000?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00/Oooool00ol0003ooooooooo
o`03ooooo`04o`000?ooooooooooooooo`;o000000?oooooo`000?ooool01Oooool00ol0003ooooo
ooooo`3ooooooeoooooo002booooo`;o00001?ooool00ol0003oooooooooo`02ooooo`;o00001Ooo
ool00ol0003oooooooooo`3oooooof3ooooo002dooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooHOooool0
0;Gooooo00?o0000ooooooooool00_ooool01?l0003oooooooooooooool2o`0000;ooooo00?o0000
ooooooooool01Oooool>o`000?ooooooCoooool00:gooooo0ol00004ooooo`?o00001?ooool01Ol0
003oooooooooool0003ooooo00;o00002?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03o`00
00?ooooo00Co0000ooooool0003ooooo0ol00007ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool0oooooom=ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooooooo0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool00oooool3o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooooooo
1Ol000000ooooooo0000ooooo`04ooooo`04o`000?ooooooooooooooo`;o00000oooool01Ol0003o
oooooooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00004ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000Cooooo00Go0000ooooooooooooooooo`00003oooooodoooooo
002]ooooo`;o00001?ooool01?l0003oooooooooool00005ooooo`03o`000?oooooo000000Oooooo
0_l00002ooooo`05o`000?ooooooooooo`000?ooool00ol000000ooooooo0000ooooo`02ooooo`03
o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo
0_l00009ooooo`03o`000?oooooo000000;ooooo0_l00003ooooo`?o00000_ooool00ol0003ooooo
ooooo`3oooooodgooooo002nooooo`;o00002Oooool6o`0000Cooooo00?o0000ooooool000000_l0
003oooooodoooooo002nooooo`03o`000?oooooo000000Wooooo3_l0003oooooodoooooo002noooo
o`04o`000?ooooooooooo`0000Wooooo00?o0000ooooool000000_ooool2o`000003ooooool0003o
oooo0?ooooooD_ooool00;kooooo00Co0000oooooooooooooooo0_l00008ooooo`;o00001Oooool0
0ol0003oooooooooo`3ooooooe7ooooo002nooooo`?o00000oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooo000000Cooooo00?o0000ooooooooool0oooooomAooooo`00__ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool00oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooDoooool00;kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`02ooooo`;o00000oooool2o`000?oooooo
E?ooool00;kooooo00?o0000ooooooooool01oooool2o`0000;ooooo0_l00003ooooo`;o0000oooo
oomDooooo`00__ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000000Gooooo00?o0000
ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`0:ooooo`;o00001Oooool00ol0
003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00_ooooo0ol000000ooooooo
0000o`00003ooooooeGooooo002nooooo`?o00003?ooool00ol0003oooooo`00003ooooooeOooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0
003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?oo
ool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0
003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]
ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/oooo
o`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003oooo
o`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26992 .03088 .00609 0 365.73 arc
s
newpath
.36504 .10697 .00609 0 365.73 arc
s
newpath
.36794 .08647 .00609 0 365.73 arc
s
.27373 .02613 m
.36884 .10221 L
s
.26612 .03564 m
.36123 .11173 L
s
.37107 .10782 m
.37397 .08732 L
s
.35901 .10611 m
.36191 .08561 L
s
.38015 .09044 m
.38003 .0742 L
s
.35567 .07438 m
.35579 .09062 L
s
.26992 .03088 m
.38874 .00406 L
s
.38015 .09044 m
.35579 .09062 L
s
.38003 .0742 m
.35567 .07438 L
s
.38015 .09044 m
.36794 .08647 L
s
.35579 .09062 m
.36794 .08647 L
s
newpath
.38874 .00406 .00457 0 365.73 arc
s
newpath
.38874 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Jooooo`?o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00?ooooo0_l00002ooooo`03o`000?oooooooooo00Oooooo0_l0000Dooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooool000004_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool00ooo
ool3o`000003ooooool0003ooooo00Oooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01?ooooo1ol00000
0ooooooo0000o`000007ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool0
0ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool0
09Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0?ooooo`Co00001oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`0;ooooo`Co00004oooool00ol0003oooooooooo`3ooooood7o
oooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool5o`0001Kooooo
00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo00;ooooo1?l0000Jooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000
ooooooooool07oooool5o`0001gooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0
003oooooooooo`0Jooooo`Go00008?ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03
o`000?oooooooooo01Gooooo1?l00004ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0@ooooo`Co00002?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool009gooooo0_l000000ooooooo0000oooo
o`0;ooooo`Go00003?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?oo
ool009_ooooo0_l00002ooooo`?o00001oooool4o`00017ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Kooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ool000000_ooool4o`0001Gooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooo
od[ooooo002Jooooo`03o`000?oooooooooo00?ooooo1Ol0000Iooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool0oooooom;ooooo`00V_ooool01?l0003oooooooooooooool2o`000005
ooooool0003oooooooooool000006Oooool3o`0001Oooooo00?o0000ooooooooool0oooooom<oooo
o`00Voooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o00005oooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool009_ooooo0ol000000ooooooo
0000o`000005ooooo`;o00005_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?oo
ooooC_ooool009gooooo0_l00008ooooo`;o00005Oooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo0?ooooooCoooool009oooooo00?o0000ooooooooool01_ooool2o`0001Cooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Pooooo`03o`000?oooooo
oooo00Kooooo0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooooomA
ooooo`00XOooool2o`0000Oooooo0ol0000Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool0oooooomBooooo`00Xoooool00ol0003oooooooooo`05ooooo`03o`000?oooooo0000013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3ooooooe?ooooo002Tooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooool000003oooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo0?ooooooE?ooool00:Gooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00
000>ooooo`?o00003_ooool00ol0003oooooooooo`3ooooooeGooooo002Vooooo`;o00001_ooool0
1?l0003oooooo`000?l0000<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooo
oomFooooo`00Z?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000_ooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo002Yooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo0?ooooooF?ooool00:[ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0009ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooomIooooo`00Zoooool2
o`0000Gooooo00Co0000oooooooooooo00002?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo0?ooooooF_ooool00:gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02
o`0000Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooe_ooooo002^oooo
o`03o`000?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00[oooool00ol0003oooooooooo`03oooo
o`05o`000?ooooooooooooooool000001?ooool3o`0000Kooooo00?o0000ooooooooool0oooooomM
ooooo`00/?ooool2o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00/_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooooooo`;o000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`3o
oooooeoooooo002cooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool2o`00
00Gooooo00?o0000ooooooooool0oooooomPooooo`00]?ooool2o`0000?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooHOooool00;Kooooo
00Go0000ooooooooooooooooo`000003ooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`ko
0000oooooom?ooooo`00[Oooool3o`0000Cooooo0_l000000ooooooo0000ooooo`02ooooo`05o`00
0?ooooooooooo`000?ooool00_l00008ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool0oooooom=ooooo`00[_ooool00ol0003oooooooooo`02ooooo`06o`000?ooooooooooo`000?oo
oooo00000oooool01?l0003oooooo`000?ooool3o`0000Oooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool2o`0000;ooooo0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool00oooool3o`0000Cooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol00000
0ooooooo0000ooooo`04ooooo`04o`000?ooooooooooooooo`;o00000oooool01Ol0003ooooooooo
oooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00005ooooo`03o`000?oooooo000000Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000Cooooo00Go0000ooooooooooooooooo`00003oooooodoooooo002]ooooo`;o
00001?ooool01?l0003oooooooooool00006ooooo`;o00001oooool2o`0000;ooooo00Go0000oooo
oooooooo0000ooooo`05o`0000?ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0
003oooooooooo`03ooooo`;o00002?ooool2o`0000Sooooo00?o0000ooooool000000_ooool2o`00
00Cooooo0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`03o`000?oooooo000000So
oooo1_l00002ooooo`Oo0000oooooom?ooooo`00__ooool01?l0003oooooooooool00008ooooo`[o
0000oooooomCooooo`00__ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooool0
00000_ooool01?l0003oooooooooool0003ooooooe?ooooo002nooooo`03o`000?oooooooooo00;o
oooo0_l00007ooooo`;o00001Oooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`?o0000
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0
oooooomAooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000002o`000003ooooool0
003ooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool01oooool2o`0000;ooooo0_l00003
ooooo`;o0000oooooomDooooo`00__ooool00ol0003oooooooooo`09ooooo`04o`000?oooooo0000
o`0000?ooooo0_l0003ooooooeCooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00005oooo
o`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool0
2oooool3o`000003ooooool0003o00000?ooooooEOooool00;kooooo0ol0000>ooooo`03o`000?oo
oooooooo0?ooooooEOooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05oooo
o`Go0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007
ooooo`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]
ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`00
00?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooo
ooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5
o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`00
0?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:co
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26964 .03125 .00609 0 365.73 arc
s
newpath
.36518 .10679 .00609 0 365.73 arc
s
newpath
.36792 .08626 .00609 0 365.73 arc
s
.27341 .02647 m
.36896 .10201 L
s
.26586 .03602 m
.36141 .11157 L
s
.37122 .10759 m
.37396 .08707 L
s
.35915 .10598 m
.36189 .08546 L
s
.38014 .09021 m
.37999 .07397 L
s
.35563 .0742 m
.35578 .09044 L
s
.26964 .03125 m
.38837 .00406 L
s
.38014 .09021 m
.35578 .09044 L
s
.37999 .07397 m
.35563 .0742 L
s
.38014 .09021 m
.36792 .08626 L
s
.35578 .09044 m
.36792 .08626 L
s
newpath
.38837 .00406 .00457 0 365.73 arc
s
newpath
.38837 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Jooooo`?o0000oooooom:ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_l00009ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo0ol0
00000ooooooo0000ooooo`07ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Cooooo`Oo000000?ooooo
o`000?l000001oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03oooool4o`0000Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`00
0?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`02ooooo`Co00006_ooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`000?oooooo
oooo01oooooo1Ol0000Mooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000oooo
ooooool06_ooool5o`00023ooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003o
ooooooooo`0Dooooo`Go00001?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0?oo
ooooA_ooool009oooooo00?o0000ooooooooool03oooool4o`0000Wooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo00Wooooo1Ol0
000=ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00Voooool7
o`0000Kooooo1?l0000Booooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0oooooom9
ooooo`00Voooool00ol0003oooooooooo`02ooooo`?o000000?oooooo`000?l000000_l0000Foooo
o`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00V_ooool00ol0003o
ooooooooo`02ooooo`Go00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?oo
ooooBoooool009[ooooo00?o0000ooooooooool00_l00002ooooo`04o`000?oooooo0000o`0001Wo
oooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009[ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`02o`0001Sooooo00?o0000ooooooooool05_ooool00ol0003ooooo
ooooo`3oooooodgooooo002Kooooo`;o00000_ooool2o`0000Gooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009gooooo0_l00008
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3o
ooooodoooooo002Nooooo`03o`000?oooooooooo00Oooooo0_l0000Dooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0oooooom@ooooo`00Woooool00ol0003oooooooooo`07ooooo`;o
00004oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooDOooool00:3ooooo
0_l00008ooooo`;o00004_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?oooooo
D_ooool00:;ooooo00?o0000ooooooooool01_ooool2o`00017ooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`3ooooooe?ooooo002Sooooo`03o`000?oooooooooo00Kooooo0ol0000?
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooomDooooo`00Y?ooool2o`00
00Oooooo00?o0000ooooool000003_ooool3o`0000kooooo00?o0000ooooooooool0oooooomEoooo
o`00Y_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`3ooooooeKooooo002Wooooo`03o`000?oooooooooo00Gooooo
00Co0000ooooool0003o00002oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?oo
ooooEoooool00:Sooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0000:ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00ZOooool2o`0000Kooooo
00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?oo
ooooFOooool00:_ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00008ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJooooo`00[?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00;o00001_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0?ooooooFoooool00:gooooo0_l00005ooooo`05o`000?ooooooooooooooool00000
1Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:oooooo00?o
0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Cooooo0ol00006ooooo`03o`00
0?oooooooooo0?ooooooGOooool00;3ooooo00?o0000ooooooooool00oooool01?l0003ooooooooo
ooooool2o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooekooooo
002aooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00
0006ooooo`03o`000?oooooooooo0?ooooooGoooool00;;ooooo0_l00004ooooo`03o`000?oooooo
oooo00;ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Cooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0oooooomQooooo`00]Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooooooo
o`?o000000?oooooo`000?ooool01_ooool>o`000?ooooooCoooool00:gooooo0ol00004ooooo`Co
00000oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;o
oooo00Ko0000oooooooooooo0000ooooool00003ooooo`07o`000?oooooo0000ooooool0003ooooo
o`000007ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooom=ooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
oooo0ol00003ooooo`;o00001Oooool00ol0003oooooooooo`03ooooo`?o00001?ooool00ol0003o
ooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00000oooool01?l0003oooooooooooooool5o`0000;ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooooooool2o`0000?ooooo00Go0000ooooooooooooooooo`00003oooooodoooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000003ooooool0
003ooooo00Kooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`00003oooooodoooooo002]ooooo`;o00001?ooool01?l0003ooooo
ooooool00006ooooo`;o00002?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo0000
00Co00000oooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03o`000?oooooooooo00?o
oooo0_l00008ooooo`03o`000?oooooooooo00Oooooo0ol000001?oooooo0000o`000?l00004oooo
o`?o000000?oooooo`000?ooool0oooooom>ooooo`00__ooool3o`0000Wooooo3_l0003oooooodoo
oooo002nooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooool000000_ooool4o`000?oo
ooooDoooool00;kooooo00Go0000ooooooooooooooooo`000009ooooo`;o00001Oooool00ol0003o
ooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
1oooool2o`0000Cooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000?ooooo0_l0
0006ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooomAooooo`00__oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00Oo0000oooooooooooooooo
o`000?oooooo00000?ooooooE?ooool00;kooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooo000000Co0000oooooomDooooo`00__ooool00ol0003ooooooooo
o`07ooooo`;o00000_ooool2o`0000?ooooo0_l0003ooooooeCooooo002nooooo`03o`000?oooooo
oooo00Wooooo00Co0000ooooool0003o00000oooool2o`000?ooooooE?ooool00;kooooo00?o0000
ooooooooool02_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomBoooo
o`00__ooool00ol0003oooooooooo`0<ooooo`;o000000?oooooo`000?l00000oooooomEooooo`00
__ooool3o`0000kooooo00?o0000ooooooooool0oooooomEooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:go
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003
ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool0
1?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2
o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_
ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007
ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26933 .03164 .00609 0 365.73 arc
s
newpath
.36534 .10659 .00609 0 365.73 arc
s
newpath
.3679 .08604 .00609 0 365.73 arc
s
.27307 .02684 m
.36908 .10179 L
s
.26558 .03644 m
.36159 .11139 L
s
.37138 .10735 m
.37395 .0868 L
s
.35929 .10584 m
.36186 .08529 L
s
.38013 .08997 m
.37995 .07373 L
s
.35559 .074 m
.35577 .09024 L
s
.26933 .03164 m
.38796 .00406 L
s
.38013 .08997 m
.35577 .09024 L
s
.37995 .07373 m
.35559 .074 L
s
.38013 .08997 m
.3679 .08604 L
s
.35577 .09024 m
.3679 .08604 L
s
newpath
.38796 .00406 .00457 0 365.73 arc
s
newpath
.38796 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Jooooo`;o0000oooooom;ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00002_ooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`02ooooo`Co0000
00?oooooo`000?ooool01oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool7o`000003ooooool0
003ooooo00Oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00oooooo1?l00007ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00[ooooo1Ol0000Cooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`Co00005oooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
0_ooool4o`0001[ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Oooooo`Go00007Oooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01[ooooo1Ol0000Pooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000oooo
ooooool05?ooool5o`0000Cooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3ooooo
odKooooo002Oooooo`03o`000?oooooooooo00oooooo1?l00009ooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`09ooooo`Go0000
3Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool009cooooo1_l0
0006ooooo`Co00004_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo0?ooooooBOoo
ool009_ooooo00?o0000ooooooooool00_ooool3o`000003ooooool0003o000000;o00005_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool009_ooooo00Co0000oooo
oooooooooooo1Ol0000Jooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom;
ooooo`00V_ooool00ol0003oooooooooo`02o`000004ooooool0003oooooooooo`;o00006Oooool3
o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00V_ooool00ol0003oooooooooo`03oooo
o`04o`000?ooooooooooooooo`;o00006?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooo
oooo0?ooooooCOooool009_ooooo0_l000000ooooooo0000o`000006ooooo`03o`000?oooooooooo
01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`3oooooodkooooo002Mooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03
o`000?oooooooooo0?ooooooCoooool009kooooo00?o0000ooooooooool01oooool2o`0001Cooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Oooooo`03o`000?oo
oooooooo00Oooooo0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooo
oomAooooo`00X?ooool2o`0000Sooooo0_l0000Booooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool0oooooomBooooo`00X_ooool00ol0003oooooooooo`06ooooo`;o00004Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool00:?ooooo00?o0000oooooooo
ool01_ooool3o`0000oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Tooooo`;o00001oooool00ol0003oooooo`00000>ooooo`?o00003_ooool00ol0003ooooo
ooooo`3ooooooeGooooo002Vooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000003Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:Oooooo00?o0000
ooooooooool01Oooool01?l0003oooooo`000?l0000;ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool0oooooomGooooo`00Z?ooool00ol0003oooooooooo`05ooooo`04o`000?oooooo
ooooo`0000[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeSooooo002Y
ooooo`;o00001_ooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool0oooooomIooooo`00Zoooool00ol0003oooooooooo`04ooooo`04o`000?oooooo
ooooo`0000Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002/
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l00006ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0oooooomKooooo`00[Oooool2o`0000Gooooo00Go0000oooo
ooooooooooooo`000005ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomL
ooooo`00[oooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooooooool000001?ooool3
o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00/?ooool00ol0003oooooooooo`03oooo
o`04o`000?ooooooooooooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooG_ooool00;7ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooo000000Kooooo00?o0000ooooooooool0oooooomOooooo`00/_ooool2o`0000Co
oooo00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00
]?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`3oooooof7ooooo002eooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooooooo0ol000000ooooooo0000ooooo`06ooooo`ko0000oooooom?ooooo`00[Ooo
ool3o`0000Cooooo1?l00003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o
0000ooooooooool00_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00Oo0000ooooool0
003oooooo`000?oooooo000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3o
ooooodgooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooooooool3o`0000?ooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo0ol0
0004ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooooooo`Go00000_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooooooo`;o00000oooool01Ol0003ooooooooooooooooo0000
0?ooooooCoooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004oooo
o`;o000000?oooooo`000?ooool01_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo00000?ooooooCoooool00:gooooo0_l00004
ooooo`04o`000?ooooooooooo`0000Kooooo0_l00008ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooool000001?l00003ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o
0000ooooooooool00oooool2o`0000Sooooo00?o0000ooooooooool01oooool3o`000004ooooool0
003o0000o`0000Cooooo0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`?o00002Ooo
ool>o`000?ooooooCoooool00;kooooo00Co0000oooooooooooo00002Oooool00ol0003oooooo`00
0002ooooo`04o`000?ooooooooooo`000?ooooooDoooool00;kooooo00Go0000oooooooooooooooo
o`000009ooooo`;o00001Oooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool01oooool2o`0000Cooooo00?o0000ooooooooool0oooo
oomAooooo`00__ooool3o`0000?ooooo0_l00006ooooo`04o`000?ooooooooooo`0000?ooooo00?o
0000ooooooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00?ooooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooE?ooool00;kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`02ooooo`Oo0000oooooomDooooo`00__ooool0
0ol0003oooooooooo`07ooooo`;o00000_ooool2o`0000?ooooo0_l0003ooooooeCooooo002noooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooool000001?ooool2o`000?ooooooE?ooool00;ko
oooo00?o0000ooooooooool02_ooool2o`0000Gooooo00?o0000ooooooooool0oooooomBooooo`00
__ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
oooooomBooooo`00__ooool00ol0003oooooooooo`0<ooooo`;o000000?oooooo`000?l00000oooo
oomEooooo`00__ooool3o`0000kooooo00?o0000ooooooooool0oooooomEooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:ko
oooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo
00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003o
ooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26898 .03209 .00609 0 365.73 arc
s
newpath
.36551 .10637 .00609 0 365.73 arc
s
newpath
.36788 .0858 .00609 0 365.73 arc
s
.27269 .02726 m
.36923 .10154 L
s
.26526 .03692 m
.3618 .11119 L
s
.37156 .10706 m
.37393 .08649 L
s
.35946 .10567 m
.36183 .0851 L
s
.38011 .08969 m
.37989 .07345 L
s
.35553 .07378 m
.35575 .09002 L
s
.26898 .03209 m
.38751 .00406 L
s
.38011 .08969 m
.35575 .09002 L
s
.37989 .07345 m
.35553 .07378 L
s
.38011 .08969 m
.36788 .0858 L
s
.35575 .09002 m
.36788 .0858 L
s
newpath
.38751 .00406 .00457 0 365.73 arc
s
newpath
.38751 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Jooooo`;o0000oooooom;ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00002_ooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`02ooooo`?o0000
0_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Booooo`Go000000?o
ooooo`000?ooool00_l00008ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_oo
ool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?oo
ool009Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0>ooooo`Co00001oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`0:ooooo`Co00005?ooool00ol0003oooooooooo`3ooooo
od7ooooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01Oooool5o`0001Oo
oooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`04o`00
0?ooooooooooooooo`Co00006oooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`00
0?oooooooooo01oooooo1?l0000Nooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o
0000ooooooooool06Oooool6o`00023ooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool0
0ol0003oooooooooo`0Dooooo`Co00001Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo0?ooooooA_ooool009oooooo00?o0000ooooooooool03oooool4o`0000Wooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo00Wo
oooo1Ol0000=ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00
W?ooool3o`0000;ooooo00?o0000ooooooooool01?ooool4o`0001;ooooo00?o0000ooooooooool0
6_ooool00ol0003oooooooooo`3oooooodWooooo002Kooooo`04o`000?ooooooooooooooo`;o0000
00?oooooo`000?ooool01?l0000Fooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
oooooom:ooooo`00Voooool01?l0003oooooooooooooool5o`0001[ooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`3ooooood_ooooo002Jooooo`03o`000?oooooooooo00;o000000Ko
ooooo`000?oooooo0000ooooool0000Iooooo`?o00005oooool00ol0003oooooooooo`3oooooodco
oooo002Jooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ol0000Hooooo`03o`00
0?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00Voooool2o`000003ooooool0
003o000000Gooooo0_l0000Gooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooo
oom>ooooo`00Voooool3o`0000Sooooo0_l0000Fooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool0oooooom?ooooo`00WOooool00ol0003oooooooooo`07ooooo`;o00005Oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool009kooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool0oooooomAooooo`00Woooool2o`0000Wooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool00:7ooooo00?o0000ooooooooool01ooo
ool2o`00017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3ooooooe?ooooo002R
ooooo`03o`000?oooooooooo00Oooooo0_l0000@ooooo`03o`000?oooooooooo00oooooo00?o0000
ooooooooool0oooooomDooooo`00Xoooool2o`0000Sooooo0_l0000?ooooo`?o00003_ooool00ol0
003oooooooooo`3ooooooeGooooo002Uooooo`03o`000?oooooooooo00Kooooo0_l0000>ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomFooooo`00Y_ooool00ol0003ooooo
ooooo`06ooooo`?o00003?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?oooooo
Eoooool00:Oooooo0_l00007ooooo`03o`000?oooooo000000_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`3ooooooeSooooo002Yooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooool000002_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool0
0:[ooooo00?o0000ooooooooool01Oooool01?l0003oooooo`000?l00008ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0oooooomJooooo`00Zoooool00ol0003oooooooooo`05oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3o
oooooe_ooooo002/ooooo`;o00001_ooool01?l0003oooooooooool00006ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00[_ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00;o00001?ooool3o`0000Kooooo00?o0000ooooooooool0oooooomMoooo
o`00[oooool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooG_ooool00;3ooooo0_l00005ooooo`05
o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
0?ooooooGoooool00;;ooooo00?o0000ooooooooool00oooool01?l0003oooooooooooooool3o`00
00Gooooo00?o0000ooooooooool0oooooomPooooo`00/oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3oooooof7o
oooo002dooooo`;o00001?ooool01?l0003oooooooooooooool2o`0000;ooooo00?o0000oooooooo
ool01Oooool=o`000?ooooooD?ooool00:gooooo0ol00004ooooo`?o00001?ooool01Ol0003ooooo
ooooool0003ooooo00;o00002?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?oo
ooooC_ooool00:kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02o`0000Cooooo
00Oo0000ooooool0003oooooo`000?oooooo000000Oooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooo
oooo0000ooooo`02o`0000?ooooo0ol00003ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00_ooool4o`0000?ooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooooooo1Ol00000
0ooooooo0000o`000004ooooo`05o`000?ooooooooooooooool000001?ooool01?l0003ooooooooo
ool0003ooooooe3ooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool01?l0003oooooooooool00007ooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00[Oooool2o`00
00Cooooo00Co0000oooooooooooo00001Oooool3o`0000Sooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooo`000004o`0000?ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool0
0ol0003oooooooooo`03ooooo`;o00002?ooool00ol0003oooooooooo`07ooooo`04o`000?oooooo
0000ooooo`?o00001?ooool3o`000003ooooool0003ooooo0?ooooooC_ooool00;kooooo0_l00009
ooooo`oo0000oooooom?ooooo`00__ooool01?l0003oooooo`000?l00009ooooo`03o`000?oooooo
000000;ooooo00Co0000oooooooooooo0000oooooomCooooo`00__ooool01Ol0003ooooooooooooo
oooo000000Wooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`07ooooo`;o00001?ooool00ol0003oooooooooo`3o
oooooe7ooooo002nooooo`?o00000oooool00ol0003oooooooooo`05ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`04oooo
o`;o00001Oooool01ol0003ooooooooooooooooo0000ooooool00000oooooomDooooo`00__ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo1ol0003ooooooeCooooo002noooo
o`03o`000?oooooooooo00Oooooo00Co0000oooooooooooooooo0_l00003ooooo`;o0000oooooomD
ooooo`00__ooool00ol0003oooooooooo`08ooooo`;o000000?oooooo`000?ooool00oooool2o`00
0?ooooooE?ooool00;kooooo00?o0000ooooooooool02_ooool2o`0000Gooooo00?o0000oooooooo
ool0oooooomBooooo`00__ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`0<ooooo`;o000000?o
ooooo`000?l00000oooooomEooooo`00__ooool3o`0000kooooo00?o0000ooooooooool0oooooomE
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go0000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomToooo
o`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co0000
0oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26856 .03264 .00609 0 365.73 arc
s
newpath
.36572 .10609 .00609 0 365.73 arc
s
newpath
.36785 .0855 .00609 0 365.73 arc
s
.27223 .02778 m
.36939 .10124 L
s
.26489 .03749 m
.36205 .11095 L
s
.37178 .10672 m
.37391 .08612 L
s
.35966 .10547 m
.36179 .08487 L
s
.3801 .08936 m
.37983 .07312 L
s
.35547 .07352 m
.35574 .08976 L
s
.26856 .03264 m
.38696 .00406 L
s
.3801 .08936 m
.35574 .08976 L
s
.37983 .07312 m
.35547 .07352 L
s
.3801 .08936 m
.36785 .0855 L
s
.35574 .08976 m
.36785 .0855 L
s
newpath
.38696 .00406 .00457 0 365.73 arc
s
newpath
.38696 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Jooooo`;o0000oooooom;ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00002_ooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`02ooooo`?o0000
00?oooooo`000?l000002?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04_ooool7o`000003ooooool0
003o000000Sooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00kooooo1?l00007ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00[ooooo1?l0000Dooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`05ooooo`Go00005oooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo
oooo1?l0000Kooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool0
7oooool4o`0001kooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003ooooooooo
o`0Iooooo`Ko00008?ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooo
oooo01Cooooo1?l00005ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooom6
ooooo`00Woooool00ol0003oooooooooo`0?ooooo`Co00002Oooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool02Oooool5o`0000go
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`3oooooodSooooo002Looooo`?o0000
0_ooool00ol0003oooooooooo`04ooooo`Co00004_ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo0?ooooooBOooool009_ooooo00Co0000oooooooooooooooo0_l000000ooooooo0000
ooooo`04o`0001Kooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo
002Kooooo`04o`000?ooooooooooooooo`Go00006_ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo0?ooooooBoooool009[ooooo00?o0000ooooooooool00_l000001_oooooo0000oooo
ool0003oooooo`0001Wooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009[ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`03o`0001Sooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`3oooooodgooooo002Kooooo`05o`000?ooooooooooooooool00000
1Oooool2o`0001Oooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`3oooooodkooooo
002Kooooo`;o000000?oooooo`000?l000001_ooool2o`0001Kooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`3oooooodoooooo002Mooooo`03o`000?oooooooooo00Oooooo0_l0000E
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom@ooooo`00W_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`3ooooooe7ooooo002Oooooo`;o00002Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBooooo`00XOooool00ol0003ooooo
ooooo`07ooooo`;o00004Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?oooooo
Doooool00:;ooooo00?o0000ooooooooool01oooool2o`00013ooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`3ooooooeCooooo002Sooooo`;o00002?ooool2o`0000oooooo0ol0000>
ooooo`03o`000?oooooooooo0?ooooooEOooool00:Gooooo00?o0000ooooooooool01_ooool2o`00
00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKooooo002Vooooo`03
o`000?oooooooooo00Kooooo0ol0000<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0oooooomGooooo`00Yoooool2o`0000Oooooo00?o0000ooooool000002oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00:Wooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooo
oomIooooo`00Z_ooool00ol0003oooooooooo`05ooooo`04o`000?oooooo0000o`0000Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002[ooooo`03o`000?oooooo
oooo00Gooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo0?ooooooFoooool00:cooooo0_l00006ooooo`04o`000?ooooooooooo`0000Kooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002^ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool00_l00004ooooo`?o00001_ooool00ol0003oooooooooo`3o
oooooegooooo002_ooooo`03o`000?oooooooooo00Cooooo00Go0000ooooooooooooooooo`000003
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00/?ooool2o`00
00Gooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0oooooomOooooo`00/_ooool00ol0003oooooooooo`03ooooo`04o`000?oooooooooo
ooooo`?o00001Oooool00ol0003oooooooooo`3oooooof3ooooo002cooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00[ooooo1ol0003ooooooe3ooooo002dooooo`;o00001?ooool01?l0003oooooooooooooool2o`00
00;ooooo00?o0000ooooooooool01Oooool6o`0000Kooooo00?o0000ooooooooool0oooooom>oooo
o`00[Oooool3o`0000Cooooo0ol00004ooooo`05o`000?ooooooooooo`000?ooool00_l00008oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;o00001?ooool01ol0003oooooo`000?oooooo0000
ooooool000001oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooC_ooool0
0:kooooo00?o0000ooooooooool00_ooool01Ol0003oooooooooool0003ooooo00;o00000oooool3
o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`Co00000oooool0
0ol0003oooooooooo`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000oooool01?l0003oooooooooooooool5o`000003ooooool0003o000000Cooooo00Go
0000ooooooooooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00
[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooo
oooo00001oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo00000?ooooooCoooool00:gooooo0_l00004ooooo`04o`000?oooooo
ooooo`0000Gooooo0ol00008ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooool00000
1?l00003ooooo`03o`000?oooooooooo0?ooooooCOooool00:kooooo00?o0000ooooooooool00ooo
ool2o`0000Sooooo00?o0000ooooooooool01oooool01?l0003oooooo`000?ooool3o`0000Cooooo
0ol000000ooooooo0000ooooo`3oooooodkooooo002nooooo`;o00002Oooool?o`000?ooooooCooo
ool00;kooooo00Co0000ooooool0003o00002Oooool00ol0003oooooo`000002ooooo`04o`000?oo
ooooooooo`000?ooooooDoooool00;kooooo00Go0000ooooooooooooooooo`000009ooooo`;o0000
1Oooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool01oooool2o`0000Cooooo00?o0000ooooooooool0oooooomAooooo`00__ooool3
o`0000?ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool01?ooool2o`0000Gooooo00?o0000
ooooool000000_l000000ooooooo0000ooooo`3ooooooe?ooooo002nooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool00_ooool2o`0000?ooooo0_l0003ooooooeCooooo002nooooo`03
o`000?oooooooooo00Oooooo00Co0000oooooooooooooooo0_l00004ooooo`03o`000?oooooooooo
0?ooooooD_ooool00;kooooo00?o0000ooooooooool02?ooool2o`000003ooooool0003ooooo00Co
oooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`0:ooooo`;o0000
1Oooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00_ooooo0_l0
0004ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool03?ooool2
o`000003ooooool0003o00000?ooooooEOooool00;kooooo0ol0000>ooooo`03o`000?oooooooooo
0?ooooooEOooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go0000
oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:go
oooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go
0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?ooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooooooo
o`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?oo
ooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo
002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?oooooo
I?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26809 .03327 .00609 0 365.73 arc
s
newpath
.36596 .10578 .00609 0 365.73 arc
s
newpath
.36782 .08516 .00609 0 365.73 arc
s
.27171 .02837 m
.36958 .10088 L
s
.26446 .03816 m
.36233 .11067 L
s
.37202 .10633 m
.37389 .0857 L
s
.35989 .10523 m
.36175 .08461 L
s
.38008 .08898 m
.37976 .07274 L
s
.3554 .07321 m
.35572 .08945 L
s
.26809 .03327 m
.38634 .00406 L
s
.38008 .08898 m
.35572 .08945 L
s
.37976 .07274 m
.3554 .07321 L
s
.38008 .08898 m
.36782 .08516 L
s
.35572 .08945 m
.36782 .08516 L
s
newpath
.38634 .00406 .00457 0 365.73 arc
s
newpath
.38634 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Iooooo`?o0000oooooom;ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_l0000:ooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`04o`000?ooooooooooooooo`Co0000
00?oooooo`000?ooool02?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04oooool6o`000003ooooool0
003ooooo00Sooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00oooooo1?l00006ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00_ooooo1?l0000Cooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`Co00005_ooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
0oooool4o`0001Wooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Oooooo`Ko00007?ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01_ooooo1Ol0000Oooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000oooo
ooooool05_ooool4o`0000?ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3ooooo
odKooooo002Oooooo`03o`000?oooooooooo017ooooo1?l00007ooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`0<ooooo`Co0000
2oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o
0000ooooooooool01oooool4o`0000oooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`3oooooodWooooo002Jooooo`Ko00000_ooool00ol0003oooooooooo`02ooooo`Co00004oooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool009[ooooo00?o0000oooo
ooooool00_ooool2o`0000;ooooo1?l0000Gooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool0oooooom;ooooo`00VOooool00ol0003oooooooooo`03ooooo`Co000000?oooooo`000?oo
ool06?ooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00VOooool01?l0003ooooo
ooooooooool2o`000003ooooool0003ooooo00;o000000?oooooo`000?ooool05oooool00ol0003o
ooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool009Wooooo00?o0000ooooooooool0
1?ooool01ol0003ooooooooooooooooo0000ooooool000005oooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo0?ooooooC_ooool009[ooooo0ol000000ooooooo0000o`000005ooooo`03
o`000?oooooo000001Kooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3oooooodoo
oooo002Mooooo`03o`000?oooooooooo00Kooooo0ol0000Eooooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool0oooooom@ooooo`00W_ooool00ol0003oooooooooo`07ooooo`;o00005?oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooDOooool009oooooo0_l00008
ooooo`;o00004oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool0
0:7ooooo00?o0000ooooooooool01_ooool2o`0001;ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`3ooooooe?ooooo002Rooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00:?ooooo
0_l00008ooooo`03o`000?oooooooooo00kooooo0ol0000>ooooo`03o`000?oooooooooo0?oooooo
EOooool00:Gooooo00?o0000ooooooooool01_ooool2o`0000kooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`3ooooooeKooooo002Vooooo`03o`000?oooooooooo00Kooooo0_l0000=
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00Yoooool2o`00
00Oooooo0_l0000<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHoooo
o`00ZOooool00ol0003oooooooooo`05ooooo`?o00002_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo0?ooooooFOooool00:[ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
o`000009ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJooooo`00Zooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`3ooooooe_ooooo002/ooooo`;o00001_ooool01?l0003oooooo`000?l0
0006ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00[_ooool0
0ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Gooooo0ol00006ooooo`03o`000?oo
oooooooo0?ooooooGOooool00:oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02
o`0000?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooekooooo002`oooo
o`;o00001Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`3ooooooeoooooo002booooo`03o`000?oooooooooo00?ooooo00Oo0000oooo
ooooooooooooo`000?oooooo000000Gooooo00?o0000ooooooooool0oooooomPooooo`00/oooool0
0ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o00001?ooool00ol0003ooooooooo
o`0:ooooo`Oo0000oooooom@ooooo`00]?ooool2o`0000Cooooo00Co0000oooooooooooooooo0_l0
0002ooooo`03o`000?oooooooooo00Gooooo1_l00006ooooo`03o`000?oooooooooo0?ooooooC_oo
ool00:gooooo0ol00004ooooo`?o00001?ooool01Ol0003oooooooooool0003ooooo00;o00002?oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooC_ooool00:kooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02o`0000Cooooo00Co0000ooooool0003ooooo0ol0
0007ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`05o`000?ooooooooooo`000?ooool00_l00003ooooo`?o00000ooo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooooooo`Go00000oooool00ol0003ooooo
ooooo`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooooooool5o`000003ooooool0003ooooo00Cooooo00Go0000oooooooo
ooooooooo`000004ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001_oo
ool2o`0000?ooooo00Co0000oooooooooooo00001Oooool01Ol0003ooooooooooooooooo00000?oo
ooooCoooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo0ol00008ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooool000001?l00003ooooo`03o`000?oooooooooo
0?ooooooCOooool00:kooooo00?o0000ooooooooool00oooool2o`0000Sooooo00?o0000oooooooo
ool01oooool01?l0003oooooo`000?ooool3o`0000Cooooo0ol000000ooooooo0000ooooo`3ooooo
odkooooo002nooooo`;o00002Oooool?o`000?ooooooCoooool00;kooooo00Co0000ooooool0003o
00002Oooool00ol0003oooooo`000002ooooo`04o`000?ooooooooooo`000?ooooooDoooool00;ko
oooo00Go0000ooooooooooooooooo`000009ooooo`;o00001Oooool00ol0003oooooooooo`3ooooo
oe7ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01_ooool3o`0000Co
oooo00?o0000ooooooooool0oooooomAooooo`00__ooool3o`0000?ooooo00?o0000ooooooooool0
1Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo
00?o0000ooooooooool01?ooool2o`0000Gooooo00?o0000ooooool000001?l0003ooooooeCooooo
002nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00_ooool2o`0000?ooooo0_l0
003ooooooeCooooo002nooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooooooo0_l0
0004ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool02?ooool2
o`000003ooooool0003ooooo00Cooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0
003oooooooooo`0:ooooo`;o00001Oooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03
o`000?oooooooooo00_ooooo0_l00003ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo
00?o0000ooooooooool03?ooool2o`000003ooooool0003o00000?ooooooEOooool00;kooooo0ol0
000>ooooo`03o`000?oooooooooo0?ooooooEOooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0
003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0
003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oo
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooo
oooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0
003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26758 .03395 .00609 0 365.73 arc
s
newpath
.36621 .10543 .00609 0 365.73 arc
s
newpath
.36779 .08479 .00609 0 365.73 arc
s
.27116 .02902 m
.36978 .1005 L
s
.26401 .03889 m
.36263 .11037 L
s
.37228 .1059 m
.37386 .08525 L
s
.36014 .10497 m
.36172 .08432 L
s
.38006 .08857 m
.37969 .07233 L
s
.35533 .07289 m
.3557 .08913 L
s
.26758 .03395 m
.38566 .00406 L
s
.38006 .08857 m
.3557 .08913 L
s
.37969 .07233 m
.35533 .07289 L
s
.38006 .08857 m
.36779 .08479 L
s
.3557 .08913 m
.36779 .08479 L
s
newpath
.38566 .00406 .00457 0 365.73 arc
s
newpath
.38566 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Iooooo`;o0000oooooom<ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00002oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool01?l0003oooooooooooooool3o`0000;o
oooo00?o0000ooooooooool01oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04_ooool4o`000003oooo
ool0003ooooo00;o00002Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo
00?o0000ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo
002Hooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03_ooool4o`0000Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool02_ooool4o`0001Cooooo00?o0000ooooooooool0oooooom1
ooooo`00V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Goooo
o`03o`000?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool00ol0003o
ooooooooo`02ooooo`Co00006_ooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`00
0?oooooooooo01oooooo1Ol0000Mooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o
0000ooooooooool06_ooool5o`00023ooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool0
0ol0003oooooooooo`0Eooooo`Co00001?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo0?ooooooA_ooool009oooooo00?o0000ooooooooool04?ooool4o`0000Sooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo00_o
oooo1?l0000<ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00
XOooool00ol0003oooooooooo`06ooooo`Co00004?ooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo0?ooooooBOooool009cooooo0ol00003ooooo`04o`000?ooooooooooooooo`Co0000
5?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool009[ooooo0_l0
0002ooooo`;o00000_ooool4o`0001Sooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`3ooooood_ooooo002Jooooo`04o`000?ooooooooooooooo`Co00000_ooool00ol0003ooooooooo
o`0Gooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Iooooo`03o`000?oooooo
oooo00;o000000Coooooo`000?oooooo00000oooool00ol0003oooooooooo`0Fooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00VOooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;o00000_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00V_ooool2o`0000;ooooo0_l00004oooo
o`04o`000?ooooooooooo`0001Kooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3o
ooooodoooooo002Jooooo`Co00001oooool2o`000003ooooool0003ooooo01Cooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Looooo`03o`000?oooooooooo00So
oooo00?o0000ooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?oo
ooooDOooool009gooooo0_l00009ooooo`03o`000?oooooo000001?ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`3ooooooe;ooooo002Oooooo`03o`000?oooooooooo00Oooooo0ol0
000Booooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0oooooomCooooo`00X?ooool0
0ol0003oooooooooo`08ooooo`;o00004Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo0?ooooooE?ooool00:7ooooo0_l00009ooooo`;o00004?ooool3o`0000kooooo00?o0000oooo
ooooool0oooooomEooooo`00Xoooool00ol0003oooooooooo`07ooooo`;o00003oooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:Cooooo0_l00009ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo
002Vooooo`03o`000?oooooooooo00Oooooo0_l0000<ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool0oooooomHooooo`00Yoooool00ol0003oooooooooo`07ooooo`;o00002oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:Sooooo0_l00008oooo
o`;o00002_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooF_ooool00:[o
oooo00?o0000ooooooooool01_ooool3o`0000Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`3ooooooe_ooooo002[ooooo`;o00001oooool00ol0003oooooo`000007ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00[Oooool00ol0003ooooooooo
o`05ooooo`04o`000?oooooo0000o`0000Gooooo0ol00006ooooo`03o`000?oooooooooo0?oooooo
GOooool00:kooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00[oooool2o`0000Kooooo00Co
0000oooooooooooo00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo
Goooool00;7ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02o`000003ooooool0
003ooooo00Cooooo00?o0000ooooooooool0oooooomPooooo`00/_ooool2o`0000Gooooo00Co0000
oooooooooooooooo0_l00004ooooo`03o`000?oooooooooo00Cooooo3Ol0003ooooooe3ooooo002d
ooooo`03o`000?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3oooooodkooooo002]
ooooo`?o00001?ooool2o`0000Gooooo00?o0000ooooooooool01?l00008ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00;o00001?ooool01?l0003oooooo`000?ooool2o`0000Sooooo00?o0000
ooooooooool00_ooool4o`0000?ooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0
003oooooooooo`02ooooo`06o`000?ooooooooooo`000?oooooo00001?ooool3o`0000;ooooo0_l0
0006ooooo`05o`000?ooooooooooooooool000001?ooool01?l0003oooooooooool0003ooooooe3o
oooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool2o`0000?o
oooo1Ol000000ooooooo0000ooooo`04ooooo`05o`000?ooooooooooooooool000001?ooool01Ol0
003ooooooooooooooooo00000?ooooooCoooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00005ooooo`05o`000?ooooooooooooooool00000oooooom?ooooo`00
[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`000007ooooo`;o
00000_ooool01Ol0003oooooooooool0003ooooo00Ko00000_ooool00ol0003oooooooooo`3ooooo
odgooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`;o00002Oooool01?l0003o
ooooo`000?ooool3o`0000;ooooo1ol0003oooooodoooooo002nooooo`;o00002Oooool;o`000?oo
ooooDoooool00;kooooo00Co0000ooooool0003o00002?ooool2o`000005ooooool0003ooooooooo
ool000000_ooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`05o`000?oooooooooooooo
ool000002Oooool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Kooooo0ol00004ooooo`03o`000?oooooooooo0?oo
ooooDOooool00;kooooo0ol00003ooooo`;o00001_ooool01?l0003oooooooooool00003ooooo`03
o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?o000000?oooooo`000?ooool0oooooomBooooo`00__oo
ool00ol0003oooooooooo`06ooooo`;o00000oooool3o`0000;ooooo0ol0003ooooooe?ooooo002n
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_l00004ooooo`;o0000oooooomC
ooooo`00__ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000000Kooooo00?o0000oooo
ooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`0:ooooo`;o00001_ooool00ol0003o
ooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00cooooo0_l00002ooooo`;o0000
oooooomDooooo`00__ooool00ol0003oooooooooo`0=ooooo`?o0000oooooomFooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go
0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?oo
ooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26702 .03474 .00609 0 365.73 arc
s
newpath
.36649 .10504 .00609 0 365.73 arc
s
newpath
.36775 .08437 .00609 0 365.73 arc
s
.27054 .02977 m
.37 .10007 L
s
.26351 .03971 m
.36297 .11001 L
s
.37257 .10541 m
.37383 .08474 L
s
.36041 .10467 m
.36167 .084 L
s
.38004 .08811 m
.3796 .07187 L
s
.35525 .07252 m
.35569 .08876 L
s
.26702 .03474 m
.3849 .00406 L
s
.38004 .08811 m
.35569 .08876 L
s
.3796 .07187 m
.35525 .07252 L
s
.38004 .08811 m
.36775 .08437 L
s
.35569 .08876 m
.36775 .08437 L
s
newpath
.3849 .00406 .00457 0 365.73 arc
s
newpath
.3849 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Iooooo`;o0000oooooom<ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00002oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool01?l0003oooooooooooooool3o`000003
ooooool0003ooooo00Wooooo00?o0000ooooool000005?ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01;ooooo1_l000000ooooooo0000
o`000009ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003ooooo
ooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`0>ooooo`Co00001_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`0;ooooo`?o00005?ooool00ol0003oooooooooo`3ooooood7ooooo002Joooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool4o`0001Kooooo00?o0000oooo
ooooool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00?o
oooo1?l0000Iooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool0
7oooool6o`0001cooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003ooooooooo
o`0Looooo`Co00007oooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooo
oooo01Sooooo0ol00002ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooom6
ooooo`00Woooool00ol0003oooooooooo`0Cooooo`Co00001Oooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool03_ooool4o`0000Wo
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`00
0?oooooooooo00Wooooo1?l0000=ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0
oooooom9ooooo`00Voooool2o`0000Gooooo00?o0000ooooooooool01?ooool4o`00017ooooo00?o
0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Jooooo`03o`000?oooooo
oooo00?o00000oooool00ol0003oooooooooo`03o`0001Gooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`3ooooood_ooooo002Jooooo`08o`000?ooooooooooooooool0003oooooo`00
0?ooool4o`0001Sooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool009Wooooo00?o
0000ooooooooool00_ooool5o`0000;ooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo0?ooooooCOooool009Wooooo00?o0000ooooooooool00_l00000
0ooooooo0000ooooo`02ooooo`04o`000?ooooooooooo`0001Oooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`3oooooodkooooo002Jooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool0000Fooooo`03o`000?oooooooooo01Cooooo00?o
0000ooooooooool0oooooom?ooooo`00V_ooool2o`000003ooooool0003o000000Kooooo0_l00000
0ooooooo0000ooooo`0Dooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom@
ooooo`00W?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000001Cooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo002Mooooo`;o00002Oooool3o`0001?o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002Oooooo`03o`00
0?oooooooooo00Sooooo0_l0000Booooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0
oooooomCooooo`00X?ooool00ol0003oooooooooo`08ooooo`;o00004Oooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00:7ooooo0_l00009ooooo`;o00004?ooool3
o`0000kooooo00?o0000ooooooooool0oooooomEooooo`00Xoooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooo
oeKooooo002Tooooo`;o00002Oooool2o`0000gooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`3ooooooeOooooo002Vooooo`03o`000?oooooooooo00Oooooo0_l0000<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00Yoooool00ol0003ooooooooo
o`07ooooo`?o00002_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOoo
ool00:Sooooo0_l00008ooooo`03o`000?oooooo000000Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`3ooooooe[ooooo002Zooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ool000002?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooFoooool00:_o
oooo0_l00007ooooo`04o`000?oooooo0000o`0000Kooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`3ooooooecooooo002]ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooo
oooo00001Oooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00[_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00;o00000oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooG_ooool00:oooooo0_l00006ooooo`05o`000?ooooooooooooooool0
00000_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooGoooool00;7ooooo
00?o0000ooooooooool01?ooool01ol0003ooooooooooooooooo0000ooooool000001Oooool00ol0
003oooooooooo`3oooooof3ooooo002booooo`;o00001Oooool01?l0003oooooooooooooool2o`00
00Cooooo00?o0000ooooooooool01?ooool=o`000?ooooooD?ooool00;Cooooo00?o0000oooooooo
ool00oooool01?l0003oooooooooooooool2o`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooC_ooool00:gooooo0ol00004ooooo`;o
00001Oooool01Ol0003oooooooooool0003ooooo00;o00002?ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo0?ooooooC_ooool00:kooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02o`0000Cooooo00Oo0000ooooool0003oooooo`000?oooooo000000Oooooo00?o0000
ooooooooool00_ooool4o`0000?ooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0
003oooooooooo`02ooooo`06o`000?ooooooooooo`000?oooooo00001?ooool3o`0000?ooooo0_l0
0005ooooo`05o`000?ooooooooooooooool000001?ooool01?l0003oooooooooool0003ooooooe3o
oooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool2o`0000?o
oooo1Ol00002ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000004oooo
o`05o`000?ooooooooooooooool00000oooooom?ooooo`00[_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooool000001?l00003ooooo`03o`000?oooooooooo0?oooooo
COooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool00000
2?ooool2o`000004ooooool0003oooooooooo`;o00001?ooool3o`000003ooooool0003ooooo0?oo
ooooC_ooool00:kooooo00?o0000ooooooooool00oooool2o`0000Oooooo0_l0000:ooooo`Oo0000
00?oooooo`000?l000001Ol0003oooooodoooooo002nooooo`;o00002_ooool:o`000?ooooooDooo
ool00;kooooo00Co0000ooooool0003o00002_ooool2o`0000Gooooo00?o0000ooooooooool0oooo
oomAooooo`00__ooool01Ol0003ooooooooooooooooo000000[ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool01_ooool01?l0003oooooo`000?l00003ooooo`03o`000?oooooooooo0?ooooooDOoo
ool00;kooooo0ol00003ooooo`;o00001_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o
0000ooooooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00ol000000ooooooo0000ooooo`3ooooooe;ooooo002noooo
o`03o`000?oooooooooo00Kooooo0_l00003ooooo`?o00000oooool2o`000?ooooooDoooool00;ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`02o`0000Cooooo0_l0003ooooooe?o
oooo002nooooo`03o`000?oooooooooo00Wooooo00?o0000ooooool000001_ooool00ol0003ooooo
ooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00[ooooo0_l00006ooooo`03o`000?oo
oooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool03?ooool2o`0000;ooooo0_l0003o
oooooeCooooo002nooooo`03o`000?oooooooooo00gooooo0ol0003ooooooeKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0
003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo
1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo
0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooo
oooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000
oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooo
oomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool0
0ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26634 .03572 .00609 0 365.73 arc
s
newpath
.36683 .10455 .00609 0 365.73 arc
s
newpath
.36771 .08387 .00609 0 365.73 arc
s
.26978 .03069 m
.37027 .09953 L
s
.2629 .04074 m
.36339 .10958 L
s
.37291 .10481 m
.3738 .08413 L
s
.36074 .10429 m
.36163 .08361 L
s
.38001 .08754 m
.3795 .07131 L
s
.35515 .07208 m
.35567 .08831 L
s
.26634 .03572 m
.38396 .00406 L
s
.38001 .08754 m
.35567 .08831 L
s
.3795 .07131 m
.35515 .07208 L
s
.38001 .08754 m
.36771 .08387 L
s
.35567 .08831 m
.36771 .08387 L
s
newpath
.38396 .00406 .00457 0 365.73 arc
s
newpath
.38396 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Hooooo`;o0000oooooom=ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`05o`00
0?ooooooooooooooool000000_ooool00ol0003oooooooooo`0:ooooo`;o00005?ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Co0000
00?oooooo`000?ooool02Oooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04_ooool6o`000003ooooool0
003ooooo00Wooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00kooooo1?l00006ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00_ooooo0ol0000Dooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`Co00005_ooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
0oooool4o`0001Wooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Oooooo`Ko00007?ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01cooooo1?l0000Oooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000oooo
ooooool06?ooool3o`0000;ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3ooooo
odKooooo002Oooooo`03o`000?oooooooooo01?ooooo1?l00005ooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`0>ooooo`Co0000
2Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o
0000ooooooooool02Oooool4o`0000gooooo00?o0000ooooooooool06_ooool00ol0003ooooooooo
o`3oooooodWooooo002Rooooo`03o`000?oooooooooo00Cooooo1?l0000Aooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Voooool4o`0000Cooooo00?o0000oooo
ooooool00ol0000Eooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom;oooo
o`00V_ooool01?l0003oooooooooooooool2o`0000;ooooo1?l0000Hooooo`?o00005oooool00ol0
003oooooooooo`3oooooodcooooo002Jooooo`04o`000?ooooooooooooooo`Co00000oooool00ol0
003oooooooooo`0Fooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=oooo
o`00VOooool00ol0003oooooooooo`02o`000005ooooool0003oooooooooool000000oooool00ol0
003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>oooo
o`00VOooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooooom?oooo
o`00VOooool3o`000003ooooool0003o000000Kooooo00Co0000oooooooooooo00005Oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool009[ooooo0ol00009ooooo`04
o`000?ooooooooooo`0001Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3ooooo
oe7ooooo002Looooo`03o`000?oooooooooo00Sooooo0_l000000ooooooo0000ooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBooooo`00WOooool2o`0000[ooooo
00?o0000ooooool000004_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?oooooo
Doooool009oooooo00?o0000ooooooooool02?ooool3o`00017ooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`3ooooooeCooooo002Pooooo`;o00002_ooool2o`00013ooooo0ol0000>
ooooo`03o`000?oooooooooo0?ooooooEOooool00:;ooooo00?o0000ooooooooool02?ooool2o`00
00oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKooooo002Sooooo`;o
00002_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0oooooomGooooo`00YOooool00ol0003oooooooooo`08ooooo`;o00003?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00:Kooooo0_l00009ooooo`;o00002ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:Sooooo00?o0000
ooooooooool01oooool2o`0000[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3o
oooooe[ooooo002Yooooo`;o00002?ooool3o`0000Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`3ooooooe_ooooo002[ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooool0
00001oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:cooooo
0_l00007ooooo`04o`000?oooooo0000o`0000Gooooo0ol00006ooooo`03o`000?oooooooooo0?oo
ooooGOooool00:kooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00004ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00[oooool2o`0000Kooooo
00?o0000ooooooooool00_l00002ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
oooooomOooooo`00/Oooool00ol0003oooooooooo`04ooooo`07o`000?ooooooooooooooool0003o
ooooo`000005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;;ooooo0_l00005ooooo`04o`00
0?ooooooooooooooo`;o00001?ooool00ol0003oooooooooo`04ooooo`go0000oooooom@ooooo`00
]?ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooom>ooooo`00
[Oooool3o`0000Cooooo0_l00005ooooo`05o`000?ooooooooooo`000?ooool00_l00008ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;o00001?ooool01?l0003oooooo`000?ooool3o`0000Oo
oooo00?o0000ooooooooool00_ooool4o`0000?ooooo00?o0000ooooooooool0oooooom>ooooo`00
[_ooool00ol0003oooooooooo`02ooooo`06o`000?ooooooooooo`000?oooooo00001?ooool3o`00
00?ooooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooooooo000000Cooooo00Co0000
oooooooooooo0000oooooom@ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000;ooooo0_l00003ooooo`Go000000?oooooo`000?l000001?ooool01Ol0003ooooooooo
oooooooo000000Cooooo00Go0000ooooooooooooooooo`00003oooooodoooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0003oooooooooool00007oooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooo`000004o`0000?ooooo00?o0000
ooooooooool0oooooom=ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool3
o`0000Sooooo0_l000000ooooooo0000ooooo`03o`0000Cooooo0ol000000ooooooo0000ooooo`3o
ooooodkooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00008ooooo`03o`000?oooooooooo
00Sooooo3ol0003oooooodoooooo002nooooo`?o00002Oooool2o`000005ooooool0003ooooooooo
ool000000_ooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`04o`000?ooooooooooo`00
00[ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00Co0000oooooooo
oooooooo0_l00009ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomAoooo
o`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Kooooo0ol00003ooooo`03
o`000?oooooooooo0?ooooooDOooool00;kooooo0ol00004ooooo`;o00001_ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`03ooooo`Go000000?oooooo`000?ooool0oooooomBooooo`00__oo
ool00ol0003oooooooooo`07ooooo`;o00000oooool2o`0000?ooooo0_l0003ooooooe?ooooo002n
ooooo`03o`000?oooooooooo00Wooooo00Co0000oooooooooooo00001?ooool2o`000?ooooooDooo
ool00;kooooo00?o0000ooooooooool02_ooool3o`0000Gooooo00?o0000ooooooooool0oooooomA
ooooo`00__ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`0<ooooo`?o000000?oooooo`000?l0
0000oooooomDooooo`00__ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?oooooo
E?ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooo
oooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05
o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?oooooooooo
o`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000oooo
ooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26567 .03672 .00609 0 365.73 arc
s
newpath
.36717 .10405 .00609 0 365.73 arc
s
newpath
.36767 .08335 .00609 0 365.73 arc
s
.26903 .03165 m
.37053 .09898 L
s
.2623 .0418 m
.3638 .10913 L
s
.37326 .1042 m
.37376 .0835 L
s
.36108 .1039 m
.36158 .0832 L
s
.37999 .08696 m
.3794 .07073 L
s
.35506 .07162 m
.35565 .08785 L
s
.26567 .03672 m
.38301 .00406 L
s
.37999 .08696 m
.35565 .08785 L
s
.3794 .07073 m
.35506 .07162 L
s
.37999 .08696 m
.36767 .08335 L
s
.35565 .08785 m
.36767 .08335 L
s
newpath
.38301 .00406 .00457 0 365.73 arc
s
newpath
.38301 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Hooooo`;o0000oooooom=ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`05o`00
0?ooooooooooooooool000000_ooool00ol0003oooooooooo`0:ooooo`;o00005?ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o0000
00?oooooo`000?ooool02_ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool04_ooool5o`000003ooooool0
003o000000[ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00kooooo1?l00005ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00[ooooo1?l0000Dooooo`03o`000?oooooooooo0?oooooo@Oooool009[o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`?o00005oooool00ol0003o
ooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
0oooool4o`0001Wooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooooooo
o`0Oooooo`Ko00007?ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01gooooo1?l0000Nooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000oooo
ooooool06?ooool4o`000003ooooool0003ooooo01kooooo00?o0000ooooooooool0oooooom6oooo
o`00Woooool00ol0003oooooooooo`0Dooooo`?o00001Oooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool03oooool4o`0000Sooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oo
oooooooo00_ooooo0ol0000<ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0oooo
oom9ooooo`00X_ooool00ol0003oooooooooo`06ooooo`Co00003oooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo0?ooooooB_ooool009_ooooo0_l00006ooooo`03o`000?oooooooooo
00;ooooo0ol0000Cooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom;oooo
o`00VOooool2o`0000;ooooo0_l00005ooooo`Co00005_ooool3o`0001Oooooo00?o0000oooooooo
ool0oooooom<ooooo`00VOooool00ol0003oooooooooo`02ooooo`Ko000000?oooooo`000?ooool0
5oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool009Sooooo00?o
0000ooooooooool00_ooool5o`0000Cooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009Sooooo00?o0000ooooooooool00_l00000
0ooooooo0000ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool009Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`;o00000oooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom@ooooo`00VOooool3o`000003
ooooool0003o000000Kooooo00Go0000ooooooooooooooooo`00000Dooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool0oooooomAooooo`00Voooool2o`0000Wooooo0_l00002ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;o
oooo002Mooooo`;o00002Oooool01?l0003oooooooooool0000Booooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00Woooool00ol0003oooooooooo`07ooooo`;o0000
00?oooooo`000?ooool04?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?oooooo
E?ooool00:3ooooo0_l00009ooooo`03o`000?oooooo0000013ooooo0ol0000>ooooo`03o`000?oo
oooooooo0?ooooooEOooool00:;ooooo00?o0000ooooooooool01oooool3o`0000oooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKooooo002Sooooo`;o00002Oooool2o`00
00kooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo002Uooooo`03
o`000?oooooooooo00Oooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool0oooooomHooooo`00Y_ooool2o`0000Wooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00:Sooooo00?o0000ooooooooool01ooo
ool2o`0000[ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002Y
ooooo`;o00002?ooool2o`0000Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3o
oooooe_ooooo002[ooooo`03o`000?oooooooooo00Kooooo0ol00007ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0oooooomLooooo`00[?ooool2o`0000Oooooo00Co0000ooooool0
003o00001Oooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00[_ooool00ol0003o
ooooooooo`05ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3ooooooekooooo002_ooooo`;o00001_ooool00ol0003oooooooooo`02o`0000;o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeoooooo002aooooo`03o`00
0?oooooooooo00Cooooo00Oo0000ooooooooooooooooo`000?oooooo000000Gooooo00?o0000oooo
ooooool02Oooool7o`000?ooooooD?ooool00;;ooooo0_l00005ooooo`04o`000?oooooooooooooo
o`;o00001?ooool00ol0003oooooooooo`04ooooo`Ko00001_ooool00ol0003oooooooooo`3ooooo
odkooooo002dooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooooooo0_l00002oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooo
odkooooo002]ooooo`?o00001?ooool2o`0000Gooooo00Go0000oooooooooooo0000ooooo`02o`00
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3oooooodkooooo002^ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_l00004ooooo`07o`000?oooooo0000oooo
ool0003oooooo`000007ooooo`04o`000?ooooooooooooooo`Go00000oooool00ol0003ooooooooo
o`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;ooooo00Ko0000oooooooooooo0000oooo
ool00004ooooo`?o00000oooool2o`0000Gooooo00Go0000ooooooooooooooooo`000004ooooo`05
o`000?ooooooooooooooool00000oooooom?ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0000;ooooo0_l00003ooooo`Go00000_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Gooooo00Go0000ooooooooooooooooo`00003oooooodoooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0003ooooooooo
ool00007ooooo`;o00000_ooool01Ol0003oooooooooool0003ooooo00Go00000oooool00ol0003o
ooooooooo`3oooooodgooooo002]ooooo`;o00001?ooool01?l0003oooooooooool00005ooooo`?o
00002Oooool01?l0003oooooo`000?ooool3o`0000Cooooo0ol000000ooooooo0000ooooo`3ooooo
odkooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00008ooooo`03o`000?oooooooooo00So
oooo3ol0003oooooodoooooo002nooooo`?o00002_ooool00ol0003oooooo`000002ooooo`04o`00
0?ooooooooooo`000?ooooooDoooool00;kooooo00Co0000oooooooooooo00002_ooool2o`0000Go
oooo00?o0000ooooooooool0oooooomAooooo`00__ooool01?l0003oooooooooooooool2o`0000Wo
oooo0_l00004ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`06ooooo`04o`000?oooooo0000o`0000;ooooo00?o0000oooooooo
ool0oooooomAooooo`00__ooool3o`0000Cooooo0_l00006ooooo`03o`000?oooooo000000;o0000
00?oooooo`000?ooool0oooooomBooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00?ooooo0_l00003ooooo`;o0000oooooomCooooo`00__ooool00ol0003oooooooooo`07
ooooo`;o00000oooool2o`0000?ooooo0_l0003ooooooe?ooooo002nooooo`03o`000?oooooooooo
00Wooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`3ooooooe7ooooo002noooo
o`03o`000?oooooooooo00[ooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooDOooool00;ko
oooo00?o0000ooooooooool03?ooool2o`0000?ooooo00?o0000ooooooooool0oooooomBooooo`00
__ooool00ol0003oooooooooo`0=ooooo`;o000000?oooooo`000?l00000oooooomDooooo`00__oo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool00002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`000?oo
ooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool0
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCo
oooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26493 .03785 .00609 0 365.73 arc
s
newpath
.36754 .10349 .00609 0 365.73 arc
s
newpath
.36763 .08278 .00609 0 365.73 arc
s
.26821 .03272 m
.37082 .09836 L
s
.26165 .04298 m
.36425 .10862 L
s
.37363 .10352 m
.37372 .08281 L
s
.36144 .10346 m
.36154 .08275 L
s
.37997 .08633 m
.37929 .0701 L
s
.35495 .07112 m
.35563 .08734 L
s
.26493 .03785 m
.38195 .00406 L
s
.37997 .08633 m
.35563 .08734 L
s
.37929 .0701 m
.35495 .07112 L
s
.37997 .08633 m
.36763 .08278 L
s
.35563 .08734 m
.36763 .08278 L
s
newpath
.38195 .00406 .00457 0 365.73 arc
s
newpath
.38195 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Gooooo`;o0000oooooom>ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool02oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`000003o`000003oooo
ool0003ooooo00[ooooo00?o0000ooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01;ooooo1?l000000ooooooo0000o`00
000;ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`0>ooooo`Co00001?ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`0:ooooo`Co00005?ooool00ol0003oooooooooo`3ooooood7ooooo002Jooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool3o`0001Oooooo00?o0000oooooooo
ool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00?ooooo
1?l0000Iooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool07ooo
ool6o`0001cooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0M
ooooo`Co00007_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo
01Sooooo1?l000000ooooooo0000ooooo`0Nooooo`03o`000?oooooooooo0?ooooooA_ooool009oo
oooo00?o0000ooooooooool05?ooool3o`0000Gooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo00oooooo1?l00008ooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00XOooool00ol0003ooooooooo
o`0;ooooo`?o00003?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo0?ooooooBOoo
ool00:;ooooo00?o0000ooooooooool01_ooool4o`0000oooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo00;ooooo0ol0000Coooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom;ooooo`00V_ooool3o`0000Oo
oooo1?l0000Fooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Iooooo`04o`00
0?ooooooooooooooo`;o000000?oooooo`000?l000000_l000000ooooooo0000ooooo`0Gooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00VOooool01?l0003ooooo
ooooooooool3o`0000Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo0?ooooooC_ooool009Sooooo00?o0000ooooooooool00_l000000ooooooo0000
ooooo`02o`0000Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo0?ooooooCoooool009Sooooo00?o0000ooooooooool00oooool01Ol0003ooooooooo
oooooooo000000Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo0?ooooooD?ooool009Wooooo0_l000000ooooooo0000o`000005ooooo`;o00001?oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooo
oomAooooo`00VOooool3o`0000Wooooo0_l00003ooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002Kooooo`03o`000?oooooooooo
00Wooooo00Go0000ooooooooooooooooo`00000Booooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool0oooooomCooooo`00W?ooool2o`0000[ooooo0_l00002ooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002Nooooo`03
o`000?oooooooooo00Wooooo00Co0000oooooooooooo00004?ooool3o`0000kooooo00?o0000oooo
ooooool0oooooomEooooo`00Woooool2o`0000[ooooo0_l000000ooooooo0000ooooo`0>ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomFooooo`00XOooool2o`0000[ooooo
00?o0000ooooool000003_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?oooooo
Eoooool00:?ooooo00?o0000ooooooooool02?ooool3o`0000gooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`3ooooooeSooooo002Tooooo`;o00002_ooool2o`0000cooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002Vooooo`03o`000?oooooooooo
00Sooooo0_l0000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJoooo
o`00Yoooool2o`0000[ooooo0_l00009ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool0oooooomKooooo`00ZOooool00ol0003oooooooooo`08ooooo`;o00002?ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:[ooooo0_l00009ooooo`?o00001_oo
ool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00[?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3o
oooooekooooo002]ooooo`;o00002?ooool01?l0003oooooo`000?l00003ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0oooooomOooooo`00[oooool2o`0000Oooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo3Ol0003o
oooooe3ooooo002aooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00ol00004oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooo
odkooooo002booooo`;o00001_ooool01?l0003oooooooooooooool2o`0000;ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooC_ooool00:go
oooo0ol00004ooooo`;o00001Oooool01Ol0003oooooooooool0003ooooo00;o00002?ooool00ol0
003oooooooooo`02ooooo`Co00000oooool00ol0003oooooooooo`3oooooodkooooo002^ooooo`03
o`000?oooooooooo00;ooooo00Co0000ooooool0003o00001Oooool01?l0003oooooo`000?ooool3
o`0000Oooooo00Go0000ooooooooooooooooo`000004ooooo`04o`000?ooooooooooo`000?oooooo
D?ooool00:kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02o`0000Gooooo0ol0
0003ooooo`03o`000?oooooooooo00Cooooo00Go0000ooooooooooooooooo`000004ooooo`05o`00
0?ooooooooooooooool00000oooooom?ooooo`00[_ooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooo`000?ooool00_l00004ooooo`Go000000?oooooo`000?l000001?ooool01Ol0003o
ooooooooool0003ooooo00Go00000oooool00ol0003oooooooooo`3oooooodgooooo002^ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool2o`0000;ooooo00?o0000oooo
ooooool01Oooool01Ol0003ooooooooooooooooo000000;ooooo0_l00004ooooo`?o000000?ooooo
o`000?ooool0oooooom>ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool0
0ol0003oooooo`000008ooooo`;o000000?oooooo`000?l000000ol00002ooooo`Oo0000oooooom?
ooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001oooool2o`0000[ooooo2ol0003ooooo
oe?ooooo002nooooo`;o00002_ooool2o`000005ooooool0003oooooooooool000000_ooool00ol0
003oooooooooo`3ooooooe7ooooo002nooooo`04o`000?oooooo0000o`0000[ooooo0_l00005oooo
o`03o`000?oooooooooo0?ooooooDOooool00;kooooo00Go0000ooooooooooooooooo`00000:oooo
o`;o00001?ooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00;o
oooo0_l00008ooooo`04o`000?oooooo0000o`0000;ooooo00?o0000ooooooooool0oooooomAoooo
o`00__ooool3o`0000Cooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000002o`000003
ooooool0003ooooo0?ooooooD_ooool00;kooooo00?o0000ooooooooool01Oooool2o`0000Gooooo
0_l00003ooooo`;o0000oooooomCooooo`00__ooool00ol0003oooooooooo`07ooooo`;o00000ooo
ool2o`0000?ooooo0_l0003ooooooe?ooooo002nooooo`03o`000?oooooooooo00Wooooo00Co0000
oooooooooooo00001Oooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooo
oooo00[ooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000oooo
ooooool03?ooool3o`000003ooooool0003o00000?ooooooE?ooool00;kooooo00?o0000oooooooo
ool03Oooool00ol0003oooooo`00003ooooooeKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooo
oooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05
o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?oooooooooo
o`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000oooo
ooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26404 .03927 .00609 0 365.73 arc
s
newpath
.36798 .10277 .00609 0 365.73 arc
s
newpath
.36759 .08207 .00609 0 365.73 arc
s
.26722 .03408 m
.37116 .09758 L
s
.26086 .04447 m
.3648 .10797 L
s
.37407 .10266 m
.37367 .08196 L
s
.36189 .10289 m
.3615 .08219 L
s
.37995 .08554 m
.37916 .06932 L
s
.35483 .07049 m
.35562 .08672 L
s
.26404 .03927 m
.38064 .00406 L
s
.37995 .08554 m
.35562 .08672 L
s
.37916 .06932 m
.35483 .07049 L
s
.37995 .08554 m
.36759 .08207 L
s
.35562 .08672 m
.36759 .08207 L
s
newpath
.38064 .00406 .00457 0 365.73 arc
s
newpath
.38064 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Fooooo`?o0000oooooom>ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooo000000;ooooo0_l0000=ooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o000000?oooooo`000?ooool02ooo
ool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool05?oo
ool001Kooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool04Oooool5o`000003ooooool0003o000000_ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo00kooooo0ol00005ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00[o
oooo1?l0000Dooooo`03o`000?oooooooooo0?oooooo@Oooool009[ooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`07ooooo`?o00005oooool00ol0003oooooooooo`3ooooood;ooooo
002Kooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool00oooool4o`0001Wooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`Ko00007?ooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo0ol0000Noooo
o`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000ooooooooool06Oooool5o`0001oo
oooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0Eooooo`?o0000
1?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o
0000ooooooooool04?ooool4o`0000Oooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo00cooooo0ol0000;ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003oooooooooo`08oooo
o`?o00003_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool00:?o
oooo00?o0000ooooooooool00oooool4o`00017ooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`3ooooood_ooooo002Tooooo`03o`000?oooooo000000;o00005Oooool3o`0001Oooooo
00?o0000ooooooooool0oooooom<ooooo`00V_ooool4o`0000Cooooo1?l0000Hooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00V?ooool2o`0000?ooooo1Ol00004
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`3o
ooooodkooooo002Hooooo`04o`000?ooooooooooooooo`Go00001_ooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooooom?ooooo`00Uoooool00ol0
003oooooooooo`02o`0000;ooooo00?o0000ooooooooool00_l00005ooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Gooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7o
oooo002Hooooo`;o00000_ooool2o`0000Kooooo0_l00004ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002Iooooo`?o00002_oo
ool2o`0000?ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo0?ooooooDoooool009_ooooo00?o0000ooooooooool02_ooool01Ol0003ooooooooooooo
oooo0000017ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002L
ooooo`;o00002oooool2o`0000;ooooo00?o0000ooooooooool03_ooool3o`0000kooooo00?o0000
ooooooooool0oooooomEooooo`00W_ooool2o`0000_ooooo0_l000000ooooooo0000ooooo`0>oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomFooooo`00X?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooo000000kooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`3ooooooeOooooo002Qooooo`;o00002oooool3o`0000gooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`3ooooooeSooooo002Sooooo`;o00002oooool2o`0000cooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002Uooooo`03o`000?oooooo
oooo00Wooooo0_l0000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJ
ooooo`00Y_ooool2o`0000_ooooo0_l00009ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0oooooomKooooo`00Z?ooool2o`0000[ooooo0_l00008ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0oooooomLooooo`00Z_ooool00ol0003oooooooooo`08ooooo`?o0000
1_ooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00Zoooool2o`0000Wooooo00Co
0000ooooool0003o00001?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
G_ooool00:gooooo00?o0000ooooooooool01oooool01?l0003oooooooooool00003ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool02?ooool7o`000?ooooooD?ooool00:kooooo0_l0
0008ooooo`03o`000?oooooooooo00;o000000?oooooo`000?ooool01?ooool00ol0003ooooooooo
o`02ooooo`Oo00001_ooool00ol0003oooooooooo`3oooooodkooooo002`ooooo`;o00001oooool0
1?l0003oooooooooooooool2o`0000Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo0?ooooooC_ooool00;;ooooo00?o0000ooooooooool01Oooool0
1?l0003oooooooooooooool2o`0000;ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo0?ooooooC_ooool00:gooooo0ol00003ooooo`?o00001Oooool0
1Ol0003oooooooooool0003ooooo00;o00001oooool00ol0003oooooooooo`03ooooo`Co00000ooo
ool00ol0003oooooooooo`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000
ooooool0003o00001Oooool01ol0003oooooo`000?oooooo0000ooooool000001_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00003ooooo
odoooooo002^ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_l00005ooooo`?o
00000oooool2o`0000Gooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?oooooooooo
ooooool00000oooooom?ooooo`00[_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
o`000?ooool00_l00004ooooo`Go00000_ooool2o`0000?ooooo00Go0000oooooooooooo0000oooo
o`05o`0000?ooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000?ooooo0_l00002ooooo`03o`000?oooooooooo00Kooooo00Co
0000oooooooooooo00000_ooool2o`0000Cooooo0ol000000ooooooo0000ooooo`3oooooodkooooo
002]ooooo`;o00001?ooool01?l0003oooooooooool00005ooooo`03o`000?oooooo000000Wooooo
2?l000000ooooooo0000o`000005o`000?ooooooCoooool00:kooooo00?o0000ooooooooool00ooo
ool2o`0000Oooooo0_l0000;ooooo`Oo00000_ooool00ol0003oooooooooo`3ooooooe7ooooo002n
ooooo`;o00003?ooool2o`0000Gooooo00?o0000ooooooooool0oooooomAooooo`00__ooool01?l0
003oooooo`000?l0000;ooooo`;o00001?ooool00ol0003oooooooooo`3ooooooe7ooooo002noooo
o`04o`000?ooooooooooooooo`;o00002Oooool01?l0003oooooo`000?l00002ooooo`03o`000?oo
oooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`06
ooooo`07o`000?ooooooooooooooool0003oooooo`00003ooooooe?ooooo002nooooo`?o00001?oo
ool2o`0000Kooooo1ol0003ooooooe?ooooo002nooooo`03o`000?oooooooooo00Kooooo0_l00004
ooooo`;o00001?ooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo
00Sooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo0?ooooooDOooool0
0;kooooo00?o0000ooooooooool02Oooool2o`000003ooooool0003ooooo00Cooooo00?o0000oooo
ooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`0;ooooo`;o00001Oooool00ol0003o
ooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00gooooo0_l00002ooooo`;o0000
oooooomCooooo`00__ooool00ol0003oooooooooo`0>ooooo`?o0000oooooomEooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooooooo
o`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003ooooo
o`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oo
oooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003ooooooooo
ool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003ooooooooo
o`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_oo
ool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26318 .04071 .00609 0 365.73 arc
s
newpath
.36841 .10206 .00609 0 365.73 arc
s
newpath
.36754 .08137 .00609 0 365.73 arc
s
.26625 .03545 m
.37148 .0968 L
s
.26012 .04597 m
.36534 .10732 L
s
.37449 .1018 m
.37363 .08112 L
s
.36232 .10231 m
.36146 .08162 L
s
.37993 .08476 m
.37904 .06854 L
s
.35472 .06987 m
.3556 .08609 L
s
.26318 .04071 m
.37934 .00406 L
s
.37993 .08476 m
.3556 .08609 L
s
.37904 .06854 m
.35472 .06987 L
s
.37993 .08476 m
.36754 .08137 L
s
.3556 .08609 m
.36754 .08137 L
s
newpath
.37934 .00406 .00457 0 365.73 arc
s
newpath
.37934 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Fooooo`;o0000oooooom?ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooo000000;ooooo00?o0000ooooooooool03?ooool2o`0001Cooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool4o`000003ooooool0003o000000cooooo00?o
0000ooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000F
ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0T
ooooo`03o`000?oooooooooo013ooooo1Ol000000ooooooo0000o`00000<ooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o0000ooooooooool08oooool00ol0
003oooooooooo`0=ooooo`?o00001Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
0?oooooo@?ooool009Wooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0:ooooo`?o
00005Oooool00ol0003oooooooooo`3ooooood7ooooo002Jooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool01oooool3o`0001Oooooo00?o0000ooooooooool0oooooom2ooooo`00Vooo
ool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00Cooooo0ol0000Iooooo`03o`000?oo
oooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool07oooool7o`0001_ooooo00?o0000
ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0Nooooo`?o00007_ooool00ol0
003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01[ooooo1?l0000Oooooo`03
o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool05_ooool3o`0000?ooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oo
oooooooo01;ooooo0ol00006ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooo
oom8ooooo`00XOooool00ol0003oooooooooo`0>ooooo`?o00002Oooool00ol0003oooooooooo`0J
ooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool02_ooool3o`00
00cooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03
o`000?oooooooooo00Gooooo1?l0000?ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool0oooooom;ooooo`00Y?ooool01?l0003oooooooooooooool3o`0001?ooooo0ol0000Gooooo`03
o`000?oooooooooo0?ooooooC?ooool00:Gooooo0ol0000Fooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool0oooooom=ooooo`00V?ooool6o`0000Cooooo0ol000000ooooooo0000oooo
o`0Fooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00V?ooool0
1_l0003ooooooooooooooooo0000ooooo`Co00001Oooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo01Cooooo00?o0000ooooooooool0oooooom?ooooo`00Uoooool00ol0003ooooooooo
o`02ooooo`?o000000?oooooo`000?ooool01_ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0oooooom@ooooo`00Uoooool00ol0003oooooooooo`02
o`000003ooooool0003ooooo00;ooooo0_l00006ooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo002Gooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool2o`0000Gooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool009Sooooo0_l000000ooooooo
0000o`000008ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool009[ooooo0_l0000:ooooo`;o0000
1?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
oooooomDooooo`00W?ooool00ol0003oooooooooo`09ooooo`;o00000oooool00ol0003ooooooooo
o`0>ooooo`?o00003_ooool00ol0003oooooooooo`3ooooooeGooooo002Mooooo`;o00002oooool0
1Ol0003ooooooooooooooooo000000oooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`3ooooooeKooooo002Oooooo`;o00002_ooool2o`0000;ooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00:7ooooo00?o0000oooo
ooooool02Oooool2o`000003ooooool0003ooooo00cooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`3ooooooeSooooo002Rooooo`;o00002oooool00ol0003oooooo`00000<ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooomIooooo`00Y?ooool2o`0000[ooooo
0ol0000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJooooo`00Y_oo
ool2o`0000[ooooo0_l0000:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooo
oomKooooo`00Z?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002Yooooo`;o00002_ooool2o`00
00Oooooo0ol00006ooooo`03o`000?oooooooooo0?ooooooGOooool00:_ooooo0_l00009ooooo`?o
00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooG_ooool00:gooooo
00?o0000ooooooooool01oooool01?l0003oooooo`000?l00003ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool02?ooool7o`000?ooooooD?ooool00:kooooo0_l00008ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`Oo
00001_ooool00ol0003oooooooooo`3oooooodkooooo002`ooooo`;o00001oooool00ol0003ooooo
ooooo`03o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo0?ooooooC_ooool00;;ooooo0_l00006ooooo`04o`000?ooooooooooooooo`;o0000
0_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
oooooom>ooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`05o`000?ooooooooooo`000?ooool0
0_l00007ooooo`03o`000?oooooooooo00;ooooo1?l00004ooooo`03o`000?oooooooooo0?oooooo
C_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooo`000?l00005ooooo`04o`00
0?oooooo0000ooooo`?o00001_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooooooo`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00ol00004ooooo`?o00000oooool2o`0000Gooooo00Co0000oooooooo
oooo00001?ooool01Ol0003ooooooooooooooooo00000?ooooooD?ooool00:kooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00002ooooo`;o00000oooool5o`0000;ooooo00?o0000
ooooooooool00_ooool01Ol0003oooooooooool0003ooooo00Go00000_ooool00ol0003ooooooooo
o`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?oo
ool01?l0003oooooooooool00007ooooo`;o00000_ooool00ol0003oooooo`000002o`000003oooo
ool0003o000000Go0000oooooom@ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo0000
1Oooool3o`0000Wooooo2?l000001?oooooo0000o`000?l0003ooooooe?ooooo002^ooooo`03o`00
0?oooooooooo00?ooooo0_l00008ooooo`;o00002_ooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`000?ooooooDoooool00;kooooo00?o0000ooooool000002_ooool3o`0000Go
oooo00?o0000ooooooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`02o`0000[ooooo
0_l00004ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool00_oo
ool2o`0000Sooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3ooooooe3ooooo002n
ooooo`03o`000?oooooooooo00Cooooo0_l00006ooooo`03o`000?oooooooooo00?o000000?ooooo
o`000?ooool0oooooomAooooo`00__ooool3o`0000Kooooo00?o0000ooooooooool00oooool3o`00
00;ooooo0ol0003ooooooe;ooooo002nooooo`03o`000?oooooooooo00Oooooo0_l00003ooooo`;o
00001?ooool2o`000?ooooooD_ooool00;kooooo00?o0000ooooooooool02Oooool2o`000003oooo
ool0003ooooo00Gooooo00?o0000ooooooooool0oooooom@ooooo`00__ooool00ol0003ooooooooo
o`0;ooooo`;o00001_ooool00ol0003oooooooooo`3ooooooe3ooooo002nooooo`03o`000?oooooo
oooo00cooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000oooo
ooooool03Oooool2o`0000;ooooo0_l0003ooooooe?ooooo002nooooo`03o`000?oooooooooo00oo
oooo0_l0003ooooooeGooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`00
0?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]
ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5
o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003o
ooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003ooooo
ofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26228 .04231 .00609 0 365.73 arc
s
newpath
.36886 .10126 .00609 0 365.73 arc
s
newpath
.3675 .0806 .00609 0 365.73 arc
s
.26522 .03698 m
.37181 .09593 L
s
.25933 .04763 m
.36591 .10659 L
s
.37494 .10086 m
.37358 .0802 L
s
.36278 .10166 m
.36143 .081 L
s
.37991 .0839 m
.37891 .06769 L
s
.35459 .06919 m
.3556 .0854 L
s
.26228 .04231 m
.37792 .00406 L
s
.37991 .0839 m
.3556 .0854 L
s
.37891 .06769 m
.35459 .06919 L
s
.37991 .0839 m
.3675 .0806 L
s
.3556 .0854 m
.3675 .0806 L
s
newpath
.37792 .00406 .00457 0 365.73 arc
s
newpath
.37792 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Eooooo`;o0000oooooom@ooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`;o0000
0_ooool00ol0003oooooooooo`0=ooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`?o00000_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooo000001Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool0
0ol0003oooooooooo`1Aooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool09?ooool0
0ol0003oooooooooo`0@ooooo`Co000000?oooooo`000?l000003Oooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`1A
ooooo`03o`000?oooooooooo01Cooooo002Hooooo`03o`000?oooooooooo02?ooooo00?o0000oooo
ooooool03Oooool3o`0000Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooo
od3ooooo002Iooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02_ooool3o`0001Go
oooo00?o0000ooooooooool0oooooom1ooooo`00V_ooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo00Oooooo0ol0000Gooooo`03o`000?oooooooooo0?oooooo@_ooool009_ooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`04ooooo`?o00006Oooool00ol0003ooooooooo
o`3ooooood?ooooo002Looooo`03o`000?oooooooooo01oooooo0ol000001?oooooo0000o`000?l0
000Kooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool07_ooool4
o`0001gooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003oooooooooo`0Koooo
o`?o00007oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo01Oo
oooo0ol00002ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00
X?ooool00ol0003oooooooooo`0Cooooo`?o00001Oooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool03oooool3o`0000Sooooo00?o
0000ooooooooool06_ooool00ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooo
oooo00_ooooo0ol0000;ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:
ooooo`00Xoooool00ol0003oooooooooo`07ooooo`?o00003_ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?ooooooBoooool00:Cooooo00?o0000ooooooooool00oooool3o`00017o
oooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o0000ooooool00000
0_l0000Dooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00VOoo
ool3o`0000Sooooo0ol0000Gooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooo
oom>ooooo`00Uoooool2o`0000;ooooo0_l00004ooooo`?o00000oooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooooom?ooooo`00Uoooool00ol0
003oooooooooo`02ooooo`Go00001oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0oooooom@ooooo`00U_ooool00ol0003oooooooooo`02ooooo`?o
000000?oooooo`000?l000002?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00U_ooool01Ol0003ooooooooooooooooo000000;o
oooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002Gooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool2o`0000Oooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool009Oooooo0ol000000ooooooo0000
o`000007ooooo`;o00001_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool0oooooomDooooo`00VOooool3o`0000[ooooo0_l00005ooooo`03o`000?oo
oooooooo00kooooo0ol0000>ooooo`03o`000?oooooooooo0?ooooooEOooool009cooooo00?o0000
ooooooooool02Oooool2o`0000Cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo0?ooooooE_ooool009gooooo0_l0000;ooooo`;o00000oooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomGoooo
o`00Woooool2o`0000_ooooo00Go0000ooooooooooooooooo`00000=ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool0oooooomHooooo`00XOooool2o`0000[ooooo0_l00002ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWo
oooo002Sooooo`;o00002_ooool2o`000003ooooool0003ooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe[ooooo002Uooooo`03o`000?oooooooooo00Wooooo0ol0
000:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooomKooooo`00Y_ooool2
o`0000_ooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomL
ooooo`00Z?ooool2o`0000_ooooo0_l00007ooooo`?o00001_ooool00ol0003oooooooooo`3ooooo
oegooooo002Zooooo`;o00002_ooool2o`0000Kooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3ooooooekooooo002/ooooo`03o`000?oooooooooo00Sooooo0ol00004ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooooooo3_l0003ooooooe3ooooo002]ooooo`;o0000
2Oooool01?l0003oooooo`000?l00002ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooC_ooool00:oooooo
0_l00008ooooo`03o`000?oooooooooo00?o00001?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0oooooom>ooooo`00/Oooool2o`0000Oooooo00Co
0000oooooooooooooooo0_l00002ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
0oooool3o`0000Cooooo00?o0000ooooooooool0oooooom>ooooo`00[Oooool3o`0000?ooooo0ol0
0005ooooo`05o`000?ooooooooooo`000?ooool00_l00007ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0?ooooooC_ooool00:kooooo
00?o0000ooooooooool00_ooool01?l0003oooooo`000?l00005ooooo`07o`000?oooooo0000oooo
ool0003oooooo`000007ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo00000?ooooooD?ooool00:kooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02o`0000Gooooo0ol00003ooooo`;o00001Oooool01Ol0003oooooooooool0003ooooo00Go0000
0_ooool00ol0003oooooooooo`3oooooodkooooo002^ooooo`03o`000?oooooooooo00;ooooo00Go
0000oooooooooooo0000ooooo`02o`0000Cooooo1Ol00002ooooo`;o00000oooool00ol0003ooooo
ooooo`02o`0000Cooooo1?l0003ooooooe3ooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00000oooool2o`0000;ooooo00?o0000ooooooooool01_ooool2o`000003oooo
ool0003o000000_o0000oooooom@ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo0000
1Oooool00ol0003oooooo`00000:ooooo`_o0000oooooomCooooo`00[_ooool00ol0003ooooooooo
o`03ooooo`;o00001oooool2o`0000cooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooDOoo
ool00;kooooo0ol0000<ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomA
ooooo`00__ooool00ol0003oooooooooo`02o`0000[ooooo0ol00004ooooo`03o`000?oooooooooo
0?ooooooD?ooool00;kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`08ooooo`04
o`000?oooooo0000o`0000;ooooo00?o0000ooooooooool0oooooom@ooooo`00__ooool00ol0003o
ooooooooo`03ooooo`;o00002?ooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?oo
ooooDOooool00;kooooo0ol00005ooooo`;o00001_ooool2o`0000?ooooo0_l0003ooooooe;ooooo
002nooooo`03o`000?oooooooooo00Oooooo0_l00004ooooo`;o00000oooool2o`000?ooooooD_oo
ool00;kooooo00?o0000ooooooooool02Oooool2o`0000;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`3ooooooe3ooooo002nooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ool000001Oooool00ol0003oooooooooo`3ooooooe3ooooo002nooooo`03o`000?oooooooooo00co
oooo1?l000000ooooooo0000o`00003ooooooe?ooooo002nooooo`03o`000?oooooooooo00kooooo
00?o0000ooooool00000oooooomEooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003ooooooooo
ool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`00
0?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000ooo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]
ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?oo
ooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oo
oooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26123 .04427 .00609 0 365.73 arc
s
newpath
.36939 .10028 .00609 0 365.73 arc
s
newpath
.36746 .07966 .00609 0 365.73 arc
s
.26403 .03886 m
.37219 .09487 L
s
.25843 .04968 m
.36659 .10569 L
s
.37545 .09971 m
.37352 .07909 L
s
.36332 .10084 m
.3614 .08023 L
s
.37989 .08286 m
.37876 .06666 L
s
.35446 .06836 m
.35559 .08456 L
s
.26123 .04427 m
.3762 .00406 L
s
.37989 .08286 m
.35559 .08456 L
s
.37876 .06666 m
.35446 .06836 L
s
.37989 .08286 m
.36746 .07966 L
s
.35559 .08456 m
.36746 .07966 L
s
newpath
.3762 .00406 .00457 0 365.73 arc
s
newpath
.3762 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Dooooo`;o0000oooooomAooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`04o`00
0?ooooooooooo`00013ooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool05?ooool001Kooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooool000004_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo017ooooo1?l000000ooooooo0000ooooo`0=ooooo`03o`000?oooooo000001Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool09?ooool00ol0003ooooooooo
o`0@ooooo`Co000000?oooooo`000?ooool03Oooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo05;ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oo
oooooooo01Cooooo002Hooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03Oooool3
o`0000Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooood3ooooo002Ioooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02_ooool3o`0001Gooooo00?o0000oooo
ooooool0oooooom1ooooo`00V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oo
oooo0ol0000Gooooo`03o`000?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`04ooooo`?o00006Oooool00ol0003oooooooooo`3ooooood?ooooo
002Looooo`03o`000?oooooooooo01oooooo0ol000001?oooooo0000o`000?l0000Kooooo`03o`00
0?oooooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool07_ooool01?l0003oooooo`00
0?l0000Mooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000ooooooooool07?oo
ool3o`0001kooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0H
ooooo`?o000000?oooooo`000?ooool07Oooool00ol0003oooooooooo`3oooooodOooooo002Poooo
o`03o`000?oooooooooo01Cooooo0ol00004ooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0@ooooo`?o00001oooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool0
3?ooool3o`0000[ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo
002Sooooo`03o`000?oooooooooo00Sooooo0ol0000=ooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`05ooooo`;o00004?ooool3
o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool01?l0003oooooooooooooool3
o`0001;ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`3oooooodgooooo002Voooo
o`?o00005Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool009So
oooo0ol00008ooooo`?o000000?oooooo`000?ooool05Oooool00ol0003oooooooooo`0Dooooo`03
o`000?oooooooooo0?ooooooCoooool009Oooooo00?o0000ooooooooool00_l00004ooooo`?o0000
1Oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
oooooom@ooooo`00Uoooool01?l0003oooooooooooooool5o`0000Wooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooDOooool009Kooooo00Co
0000oooooooooooooooo0ol000000ooooooo0000o`00000:ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002Fooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooooooo0_l00009ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3ooooooe?ooooo002Gooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool2o`0000Sooooo00?o0000ooooooooool0
3oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool009Oooooo1Ol0
0008ooooo`;o00001oooool00ol0003oooooooooo`0>ooooo`?o00003_ooool00ol0003ooooooooo
o`3ooooooeGooooo002Iooooo`?o00002_ooool2o`0000Kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool009cooooo0_l0000:oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo0?ooooooEoooool009kooooo0_l00009ooooo`;o00001Oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00
X?ooool2o`0000Wooooo0_l00004ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`3ooooooeWooooo002Rooooo`;o00002Oooool2o`0000?ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooF_oo
ool00:Cooooo0_l00009ooooo`;o00000_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0oooooomKooooo`00Y_ooool00ol0003oooooooooo`08oooo
o`;o000000?oooooo`000?ooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
0?ooooooG?ooool00:Oooooo0_l0000:ooooo`?o00002?ooool3o`0000Kooooo00?o0000oooooooo
ool0oooooomMooooo`00ZOooool2o`0000[ooooo0_l00007ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01oooool7o`000?ooooooD?ooool00:_ooooo0_l0000:ooooo`;o00001Ooo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooooooo`Oo00001_ooool00ol0003ooooo
ooooo`3oooooodkooooo002]ooooo`;o00002Oooool3o`0000?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooo
oom>ooooo`00[oooool2o`0000Sooooo00Ko0000ooooool0003o0000ooooool00004ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodkooooo
002aooooo`;o00001oooool00ol0003oooooooooo`02o`0000?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`02ooooo`Co00001?ooool00ol0003oooooooooo`3oooooodkooooo002]
ooooo`?o00000oooool3o`0000Gooooo00?o0000ooooooooool01?l00007ooooo`03o`000?oooooo
oooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0?ooooooC_oo
ool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooo`000?l00005ooooo`04o`000?oo
oooo0000ooooo`?o00001oooool01?l0003oooooooooool00004ooooo`05o`000?oooooooooooooo
ool00000oooooom@ooooo`00[_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?o
00001?ooool3o`0000?ooooo0_l00005ooooo`05o`000?ooooooooooo`000?ooool01Ol00002oooo
o`03o`000?oooooooooo0?ooooooC_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00002ooooo`;o00000oooool5o`0000;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooo`000002o`0000Cooooo1?l0003ooooooe3ooooo002^ooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00001?ooool2o`000003ooooool0003ooooo00Kooooo0_l00002oooo
o`go0000oooooom@ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001_ooool2o`00
00Wooooo0_l00003ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomA
ooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00002?ooool3o`0000Wooooo0_l000000ooo
oooo0000ooooo`04ooooo`03o`000?oooooooooo0?ooooooDOooool00;kooooo00?o0000oooooooo
ool00_l00009ooooo`;o00001Oooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool02?ooool2o`0000Cooooo00?o0000ooooooooool0
oooooom@ooooo`00__ooool00ol0003oooooooooo`03ooooo`;o00002?ooool00ol0003oooooo`00
0002o`000003ooooool0003ooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool01Oooool2
o`0000Kooooo0_l00002ooooo`?o0000oooooomBooooo`00__ooool3o`0000Oooooo0_l00004oooo
o`;o00000oooool2o`000?ooooooD_ooool00;kooooo00?o0000ooooooooool02Oooool2o`0000;o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe3ooooo002nooooo`03o`00
0?oooooooooo00_ooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooD?ooool00;kooooo00?o
0000ooooooooool03Oooool2o`0000Cooooo00?o0000ooooooooool0oooooom@ooooo`00__ooool0
0ol0003oooooooooo`0>ooooo`;o000000?oooooo`000?l00000oooooomCooooo`00__ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oo
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0003ooooo
ofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003o
ooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomT
ooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomToooo
o`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co
00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003o
ooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26022 .04629 .00609 0 365.73 arc
s
newpath
.36989 .09927 .00609 0 365.73 arc
s
newpath
.36742 .07871 .00609 0 365.73 arc
s
.26286 .0408 m
.37254 .09378 L
s
.25757 .05177 m
.36724 .10475 L
s
.37594 .09854 m
.37347 .07798 L
s
.36385 .09999 m
.36137 .07944 L
s
.37988 .08181 m
.37861 .06562 L
s
.35433 .06752 m
.3556 .08371 L
s
.26022 .04629 m
.37446 .00406 L
s
.37988 .08181 m
.3556 .08371 L
s
.37861 .06562 m
.35433 .06752 L
s
.37988 .08181 m
.36742 .07871 L
s
.3556 .08371 m
.36742 .07871 L
s
newpath
.37446 .00406 .00457 0 365.73 arc
s
newpath
.37446 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Cooooo`;o0000oooooomBooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`;o0000
00?oooooo`000?ooool04?ooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04?ooool4o`000003ooooool0003ooooo00kooooo00?o0000ooooool000005?oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo057ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo00oooooo1?l000000ooooooo0000ooooo`0>ooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool0D_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool05?ooool009Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0<oooo
o`?o00001?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?oooooo@?ooool009Wo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0:ooooo`;o00005_ooool00ol0003o
ooooooooo`3ooooood7ooooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
1oooool3o`0001Oooooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo00Cooooo0ol0000Iooooo`03o`000?oooooooooo0?oooooo@ooo
ool009cooooo00?o0000ooooooooool07oooool3o`0000;ooooo0_l0000Kooooo`03o`000?oooooo
oooo0?ooooooA?ooool009gooooo00?o0000ooooooooool07_ooool00ol0003oooooo`000002o`00
01cooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003oooooooooo`0Looooo`?o
00007_ooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo01Wooooo
0_l000000ooooooo0000ooooo`0Mooooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o
0000ooooooooool05Oooool3o`0000?ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo017ooooo0ol00006ooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003oooooooooo`0=oooo
o`?o00002Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool00:?o
oooo00?o0000ooooooooool02_ooool2o`0000cooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`3ooooood_ooooo002Tooooo`03o`000?oooooooooo00Kooooo0ol0000>ooooo`?o0000
5oooool00ol0003oooooooooo`3oooooodcooooo002Uooooo`03o`000?oooooooooo00;ooooo0ol0
000Aooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00Y_ooool0
1?l0003oooooo`000?l0000Dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooo
oom>ooooo`00YOooool3o`0001Kooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3o
ooooodoooooo002Hooooo`;o00002?ooool3o`0000?ooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool009Kooooo0_l00002ooooo`;o
00001?ooool2o`0000Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo0?ooooooDOooool009Kooooo00?o0000ooooooooool00_ooool5o`0000[ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?oooooo
D_ooool009Gooooo00?o0000ooooooooool00_ooool3o`000003ooooool0003o000000_ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDooo
ool009Gooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooooooo`;o0000
2_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
oooooomDooooo`00U_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo0ol0
0008ooooo`03o`000?oooooooooo00kooooo0ol0000>ooooo`03o`000?oooooooooo0?ooooooEOoo
ool009Kooooo0ol000000ooooooo0000o`000009ooooo`;o00001oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomFooooo`00V?ooool3o`00
00cooooo0_l00006ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`3ooooooeOooooo002Kooooo`;o00003?ooool2o`0000Gooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool009gooooo
0_l0000<ooooo`;o00001?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool0oooooomIooooo`00Woooool2o`0000cooooo0_l00003ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002Q
ooooo`;o00003?ooool2o`0000;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo0?ooooooFoooool00:?ooooo0_l0000<ooooo`;o000000?oooooo`00
0?ooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:Go
oooo0_l0000<ooooo`?o00002?ooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00
Yoooool2o`0000cooooo0ol00006ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1oooool7o`000?ooooooD?ooool00:Wooooo0_l0000<ooooo`?o00001?ooool00ol0003ooooooooo
o`04ooooo`04o`000?ooooooooooooooo`Oo00001_ooool00ol0003oooooooooo`3oooooodkooooo
002[ooooo`;o00002oooool01?l0003oooooo`000?l00002ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?oooooo
C_ooool00:gooooo0_l0000:ooooo`03o`000?oooooooooo00?o00001?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo0ol00004ooooo`03o`000?oooooooooo0?ooooooC_oo
ool00:oooooo0_l00009ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo0?ooooooC_ooool00:gooooo0ol000001?oooooo0000o`000?ooool2o`0000Gooooo
00Go0000oooooooooooo0000ooooo`02o`0000Oooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0003o
ooooooooo`02ooooo`Co00001Oooool01_l0003oooooo`000?oooooo0000ooooo`;o00001_ooool0
1Ol0003oooooooooool0003ooooo00Go00000_ooool00ol0003oooooooooo`3oooooodkooooo002^
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_l00005ooooo`?o00001?ooool2
o`0000Cooooo00?o0000ooooooooool00_l00004ooooo`Co0000oooooom@ooooo`00[_ooool00ol0
003oooooooooo`02ooooo`05o`000?ooooooooooo`000?ooool00_l00004ooooo`Go00000oooool2
o`0000;ooooo1Ol000000ooooooo0000o`000005o`000?ooooooD?ooool00:kooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00003ooooo`;o00000_ooool00ol0003oooooooooo`07
ooooo`So000000Coooooo`000?l0003o0000oooooomCooooo`00[Oooool2o`0000Cooooo00Co0000
oooooooooooo00001Oooool3o`0000cooooo0ol00002ooooo`04o`000?ooooooooooo`000?oooooo
Doooool00:kooooo00?o0000ooooooooool00oooool2o`0000Sooooo0_l0000=ooooo`;o00001?oo
ool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`04o`000?oooooo0000o`0000_ooooo00Co
0000ooooool0003o00000oooool00ol0003oooooooooo`3ooooooe3ooooo002nooooo`04o`000?oo
ooooooooooooo`;o00002_ooool00ol0003oooooooooo`02o`000003ooooool0003ooooo0?oooooo
DOooool00;kooooo00?o0000ooooooooool00oooool2o`0000Sooooo00?o0000ooooooooool01?l0
003ooooooe;ooooo002nooooo`03o`000?oooooooooo00Gooooo0_l00006ooooo`?o00000oooool0
0ol0003oooooooooo`3ooooooe3ooooo002nooooo`?o00001oooool2o`0000Cooooo0_l00004oooo
o`03o`000?oooooooooo0?ooooooD?ooool00;kooooo00?o0000ooooooooool02Oooool2o`0000;o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe3ooooo002nooooo`03o`00
0?oooooooooo00_ooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooD?ooool00;kooooo00?o
0000ooooooooool03Oooool3o`000003ooooool0003o00000?ooooooDoooool00;kooooo00?o0000
ooooooooool03oooool2o`000?ooooooEOooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooo
oooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05
o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?oooooooooo
o`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000oooo
ooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25919 .0485 .00609 0 365.73 arc
s
newpath
.37041 .09816 .00609 0 365.73 arc
s
newpath
.36739 .07768 .00609 0 365.73 arc
s
.26167 .04293 m
.37289 .0926 L
s
.25671 .05406 m
.36792 .10372 L
s
.37643 .09728 m
.37341 .07679 L
s
.36438 .09905 m
.36136 .07857 L
s
.37987 .08067 m
.37847 .06449 L
s
.3542 .0666 m
.35561 .08278 L
s
.25919 .0485 m
.3726 .00406 L
s
.37987 .08067 m
.35561 .08278 L
s
.37847 .06449 m
.3542 .0666 L
s
.37987 .08067 m
.36739 .07768 L
s
.35561 .08278 m
.36739 .07768 L
s
newpath
.3726 .00406 .00457 0 365.73 arc
s
newpath
.3726 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Booooo`?o0000oooooomBooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooo000000;o00004Oooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool03oooool4o`000003ooooool0003ooooo00oooooo00?o0000ooooool000005?oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo057ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo00kooooo1?l000000ooooooo0000ooooo`0?ooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool0D_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool05?ooool009Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`0<oooo
o`;o00001?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo0?oooooo@?ooool009Wo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`09ooooo`?o00005_ooool00ol0003o
ooooooooo`3ooooood7ooooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
1_ooool3o`0001Sooooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo00Cooooo0_l0000Jooooo`03o`000?oooooooooo0?oooooo@ooo
ool009cooooo00?o0000ooooooooool07oooool3o`000004ooooool0003o0000o`0001_ooooo00?o
0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0Nooooo`04o`000?oooooo
0000o`0001gooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003oooooooooo`0L
ooooo`?o00007_ooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo
01Wooooo0_l000000ooooooo0000ooooo`0Mooooo`03o`000?oooooooooo0?ooooooAoooool00:3o
oooo00?o0000ooooooooool05Oooool3o`0000?ooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo017ooooo0ol00006ooooo`03o`00
0?oooooooooo01[ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003ooooooooo
o`0>ooooo`;o00002Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_oo
ool00:?ooooo00?o0000ooooooooool02_ooool3o`0000_ooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`000?oooooooooo00Oooooo0_l0000>oooo
o`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Uooooo`03o`000?oooooooooo00?o
oooo0ol0000@ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00
Y_ooool00ol0003oooooooooo`02o`0001?ooooo00?o0000ooooooooool05Oooool00ol0003ooooo
ooooo`3oooooodkooooo002Vooooo`?o00005Oooool00ol0003oooooooooo`0Dooooo`03o`000?oo
oooooooo0?ooooooCoooool00:Cooooo0_l00002ooooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Qooooo`?o00001Oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooooomAoooo
o`00U_ooool5o`0000?ooooo0ol00009ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002Fooooo`04o`000?ooooooooooooooo`Co
00003Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool0oooooomCooooo`00UOooool01?l0003oooooooooooooool3o`000004ooooool0003o0000o`00
00cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
0?ooooooE?ooool009Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`02oooo
o`;o00002oooool00ol0003oooooooooo`0>ooooo`?o00003_ooool00ol0003oooooooooo`3ooooo
oeGooooo002Eooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool2o`0000[o
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?oo
ooooE_ooool009Kooooo0_l000000ooooooo0000o`000009ooooo`;o00002Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00Uooo
ool2o`0000gooooo0ol00007ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`3ooooooeSooooo002Iooooo`;o00003_ooool2o`0000Kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool0
09_ooooo0ol0000=ooooo`;o00001Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool0oooooomJooooo`00W_ooool2o`0000gooooo0_l00004ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooe_o
oooo002Pooooo`;o00003Oooool2o`0000?ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00:;ooooo0ol0000<ooooo`?o000000?o
ooooo`000?ooool01oooool3o`0000Kooooo00?o0000ooooooooool01_ooool7o`000?ooooooD?oo
ool00:Gooooo0_l0000=ooooo`?o00001oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Oo00001_ooool00ol0003oooooooooo`3oooooodkooooo002Wooooo`;o00003Oooool2o`00
00Kooooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooooooo000000cooooo00?o0000
ooooooooool0oooooom>ooooo`00ZOooool2o`0000gooooo0_l00004ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo
0?ooooooC_ooool00:_ooooo0ol0000;ooooo`Co000000?oooooo`000?ooool00oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00;ooooo1?l00004ooooo`03o`000?oooooooooo0?oo
ooooC_ooool00:kooooo0_l0000:ooooo`03o`000?oooooooooo00;o00000oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`03
o`000?oooooooooo0?ooooooC_ooool00:gooooo1Ol00002ooooo`;o00001Oooool00ol0003ooooo
ooooo`04o`0000Sooooo00Co0000oooooooooooo00001?ooool2o`0000;ooooo00?o0000oooooooo
ool0oooooom>ooooo`00[_ooool01?l0003oooooooooooooool3o`000003ooooool0003ooooo00Co
oooo00Co0000ooooool0003ooooo0ol00007ooooo`05o`000?ooooooooooo`000?ooool01Ol00002
ooooo`03o`000?oooooooooo0?ooooooC_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooo`000?l00006ooooo`?o00000oooool3o`0000Cooooo00?o0000ooooool000000_l00000
0ooooooo0000o`000005o`000?ooooooD?ooool00:kooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`03o`0000Gooooo1Ol00003ooooo`;o00000_ooool6o`000004ooooool0003o0000
o`000?ooooooDoooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002
ooooo`;o00000oooool00ol0003oooooooooo`07ooooo`;o00000oooool01?l0003oooooooooool0
0003ooooo`03o`000?oooooooooo0?ooooooD?ooool00:gooooo0_l00004ooooo`04o`000?oooooo
ooooo`0000Cooooo1?l0000;ooooo`;o000000?oooooo`000?ooool01Oooool00ol0003ooooooooo
o`3ooooooe3ooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00008ooooo`;o00003?ooool2
o`0000Kooooo00?o0000ooooooooool0oooooom@ooooo`00__ooool01?l0003oooooo`000?l0000<
ooooo`?o00000oooool00ol0003oooooooooo`3ooooooe3ooooo002nooooo`04o`000?oooooooooo
ooooo`;o00002_ooool00ol0003oooooooooo`04o`000?ooooooD_ooool00;kooooo00?o0000oooo
ooooool00oooool3o`0000Oooooo0ol00002ooooo`?o0000oooooomAooooo`00__ooool00ol0003o
ooooooooo`06ooooo`;o00001Oooool2o`0000Cooooo0_l0003ooooooe7ooooo002nooooo`?o0000
2?ooool2o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooodoooooo
002nooooo`03o`000?oooooooooo00[ooooo1?l00006ooooo`03o`000?oooooooooo0?ooooooCooo
ool00;kooooo00?o0000ooooooooool03Oooool2o`0000Cooooo00?o0000ooooooooool0oooooom@
ooooo`00__ooool00ol0003oooooooooo`0>ooooo`;o00000_ooool2o`000?ooooooD_ooool00;ko
oooo00?o0000ooooooooool04?ooool2o`000?ooooooE?ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo
00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo
00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol0
0003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo
1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2581 .05105 .00609 0 365.73 arc
s
newpath
.37095 .09688 .00609 0 365.73 arc
s
newpath
.36736 .07649 .00609 0 365.73 arc
s
.26039 .04541 m
.37324 .09124 L
s
.25581 .0567 m
.36866 .10253 L
s
.37695 .09583 m
.37336 .07544 L
s
.36495 .09794 m
.36136 .07755 L
s
.37987 .07936 m
.37831 .06319 L
s
.35406 .06554 m
.35563 .08171 L
s
.2581 .05105 m
.37047 .00406 L
s
.37987 .07936 m
.35563 .08171 L
s
.37831 .06319 m
.35406 .06554 L
s
.37987 .07936 m
.36736 .07649 L
s
.35563 .08171 m
.36736 .07649 L
s
newpath
.37047 .00406 .00457 0 365.73 arc
s
newpath
.37047 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003Aooooo`;o0000oooooomDooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0?ooooo`04o`00
0?ooooooooooo`0001?ooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool05?ooool001Kooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooool000004_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00kooooo00?o0000ooooool000000ol0000Aooooo`03o`000?oooooo000001Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool09?ooool00ol0003ooooooooo
o`0=ooooo`Co000000?oooooo`000?ooool04?ooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo05;ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oo
oooooooo01Cooooo002Hooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool02oooool2
o`0000Cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooood3ooooo002Ioooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02?ooool3o`0001Oooooo00?o0000oooo
ooooool0oooooom1ooooo`00V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Ko
oooo0_l0000Iooooo`03o`000?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`03ooooo`?o00006_ooool00ol0003oooooooooo`3ooooood?ooooo
002Looooo`03o`000?oooooooooo01oooooo0ol000000ooooooo0000o`00000Looooo`03o`000?oo
oooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool07_ooool01?l0003oooooo`000?l0
000Mooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000ooooooooool07?ooool3
o`0001kooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0Ioooo
o`;o000000?oooooo`000?ooool07Oooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03
o`000?oooooooooo01Gooooo0ol00003ooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0Booooo`;o00001_ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool03_oo
ool3o`0000Sooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002S
ooooo`03o`000?oooooooooo00_ooooo0_l0000;ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`07ooooo`?o00003Oooool3o`00
01Oooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`04ooooo`;o
00004?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool00:Kooooo
00?o0000ooooooooool00ol0000Booooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
oooooom>ooooo`00Yoooool2o`0001Gooooo00?o0000ooooooooool05?ooool00ol0003ooooooooo
o`3oooooodoooooo002Uooooo`;o000000?oooooo`000?ooool05?ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo0?ooooooD?ooool00:;ooooo0ol00004ooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo002Pooooo`;o
00002?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool0oooooomBooooo`00Uoooool4o`0000;ooooo0ol0000;ooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`3ooooooe?ooooo002Eooooo`;o00000ooo
ool4o`0000kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo0?ooooooE?ooool009Gooooo00?o0000ooooooooool00ol00003ooooo`;o00003Oooool0
0ol0003oooooooooo`0>ooooo`?o00003_ooool00ol0003oooooooooo`3ooooooeGooooo002Doooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool2o`0000cooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool0
09Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`?o00002_ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomGoooo
o`00UOooool2o`0000;ooooo0_l0000:ooooo`;o00002Oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00U_ooool3o`0000kooooo
0ol00007ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`3ooooooeWooooo002Hooooo`?o00003oooool2o`0000Kooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooF_ooool009_ooooo0_l0000?
ooooo`?o00001?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0oooooomKooooo`00WOooool3o`0000oooooo0_l00003ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`Co0000oooooom@oooo
o`00X?ooool2o`0000oooooo0_l00002ooooo`03o`000?oooooooooo00Kooooo0ol00006ooooo`03
o`000?oooooooooo00;ooooo1ol00003ooooo`03o`000?oooooooooo0?ooooooC_ooool00:;ooooo
0ol0000>ooooo`Co00001oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?o0000
2_ooool00ol0003oooooooooo`3oooooodkooooo002Uooooo`;o00003oooool2o`0000Kooooo00?o
0000ooooooooool01?ooool01Ol0003ooooooooooooooooo000000cooooo00?o0000ooooooooool0
oooooom>ooooo`00Yoooool2o`0000oooooo0ol00003ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`?o00001?ooool00ol0003ooooooooo
o`3oooooodkooooo002Yooooo`?o00003Oooool01_l0003oooooo`000?l0003oooooo`0000Cooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`3oooooodkooooo002/ooooo`;o00003?ooool00ol0003ooooo
ooooo`02o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`3oooooodkooooo002]ooooo`Co0000
0oooool2o`0000Gooooo00?o0000ooooooooool01?l00008ooooo`05o`000?ooooooooooo`000?oo
ool01Ol00002ooooo`03o`000?oooooooooo0?ooooooC_ooool00:kooooo00?o0000ooooooooool0
0ol00002ooooo`03o`000?oooooooooo00?ooooo00Ko0000ooooool0003oooooo`000?ooool2o`00
00Kooooo00?o0000ooooooooool00_l00004ooooo`Co0000oooooom@ooooo`00[_ooool00ol0003o
ooooooooo`02ooooo`Co00001_ooool3o`0000Cooooo0ol00003ooooo`go0000oooooom@ooooo`00
[_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o00001_ooool5o`0000Cooooo
0_l000000ooooooo0000o`000005o`0000?ooooo00?o0000ooooooooool0oooooom@ooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooo`000?ooool00ol00003ooooo`03o`00
0?oooooooooo00Sooooo0ol00002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
oooooom@ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001?ooool2o`000003oooo
ool0003ooooo00cooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooD?ooool00:kooooo00?o
0000ooooooooool00oooool2o`0000Oooooo0ol0000>ooooo`;o00001?ooool00ol0003ooooooooo
o`3ooooooe3ooooo002nooooo`04o`000?oooooo0000o`0000cooooo00?o0000ooooool000000_l0
00000ooooooo0000ooooo`3ooooooe7ooooo002nooooo`04o`000?ooooooooooooooo`;o00002_oo
ool00ol0003oooooo`000003o`000003ooooool0003ooooo0?ooooooD?ooool00;kooooo00?o0000
ooooooooool00oooool3o`0000Sooooo0_l00003ooooo`;o0000oooooomAooooo`00__ooool00ol0
003oooooooooo`06ooooo`;o00001_ooool00ol0003oooooooooo`02ooooo`;o0000oooooomAoooo
o`00__ooool3o`0000Sooooo0ol00003ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0oooooom?ooooo`00__ooool00ol0003oooooooooo`0;ooooo`;o000000?oooooo`000?ooool0
1?ooool00ol0003oooooooooo`3oooooodoooooo002nooooo`03o`000?oooooooooo00gooooo1?l0
00000ooooooo0000o`00003ooooooe;ooooo002nooooo`03o`000?oooooooooo013ooooo0_l0003o
oooooeCooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?o
oooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o
00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oo
oooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool0
1?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25702 .05386 .00609 0 365.73 arc
s
newpath
.37149 .09548 .00609 0 365.73 arc
s
newpath
.36734 .07519 .00609 0 365.73 arc
s
.2591 .04814 m
.37357 .08976 L
s
.25494 .05959 m
.36941 .1012 L
s
.37746 .09426 m
.3733 .07397 L
s
.36552 .0967 m
.36137 .07642 L
s
.37988 .07793 m
.37815 .06179 L
s
.35393 .06438 m
.35566 .08053 L
s
.25702 .05386 m
.36817 .00406 L
s
.37988 .07793 m
.35566 .08053 L
s
.37815 .06179 m
.35393 .06438 L
s
.37988 .07793 m
.36734 .07519 L
s
.35566 .08053 m
.36734 .07519 L
s
newpath
.36817 .00406 .00457 0 365.73 arc
s
newpath
.36817 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003@ooooo`;o0000oooooomEooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00;o00004oooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool03Oooool3o`000003ooooool0003o000001;ooooo00?o0000ooooool000005?oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooo
oooo057ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooo
oooo00cooooo0ol000000ooooooo0000o`00000Booooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool0D_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool05?ooool009Sooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`09oooo
o`?o00000oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?oooooo@?ooool009Wo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o00006Oooool00ol0003o
ooooooooo`3ooooood7ooooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
1Oooool2o`0001[ooooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo00;ooooo0ol0000Kooooo`03o`000?oooooooooo0?oooooo@ooo
ool009cooooo00?o0000ooooooooool07oooool5o`0001gooooo00?o0000ooooooooool0oooooom4
ooooo`00WOooool00ol0003oooooooooo`0Nooooo`?o00007_ooool00ol0003oooooooooo`3ooooo
odGooooo002Nooooo`03o`000?oooooooooo01cooooo0_l0000Oooooo`03o`000?oooooooooo0?oo
ooooA_ooool009oooooo00?o0000ooooooooool06?ooool3o`000003ooooool0003ooooo01gooooo
00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`0Eooooo`;o00001?oo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000
ooooooooool04_ooool2o`0000Kooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`3o
ooooodWooooo002Rooooo`03o`000?oooooooooo00kooooo0ol00008ooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003oooooooooo`0;ooooo`;o
00002oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?ooooooBoooool00:Cooooo
00?o0000ooooooooool02?ooool2o`0000gooooo0ol0000Gooooo`03o`000?oooooooooo0?oooooo
C?ooool00:Gooooo00?o0000ooooooooool01Oooool2o`0000oooooo00?o0000ooooooooool05_oo
ool00ol0003oooooooooo`3oooooodgooooo002Vooooo`04o`000?ooooooooooooooo`?o00004Ooo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo0ol0000D
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooooom?ooooo`00Y_ooool3o`00
01Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooooe3ooooo002Tooooo`;o
00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool0oooooomAooooo`00XOooool3o`0000Kooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool009oooooo0_l0000:ooooo`03o`000?oo
oooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3ooooooe?ooooo002F
ooooo`?o00001?ooool2o`0000gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo0?ooooooE?ooool009Gooooo00?o0000ooooooooool01Ol0000@oooo
o`03o`000?oooooooooo00kooooo0ol0000>ooooo`03o`000?oooooooooo0?ooooooEOooool009Go
oooo00?o0000ooooooooool01Ol0000Aooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`3ooooooeKooooo002Dooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool00ol0000?ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`3ooooooeOooooo002Dooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00oooool3o`0000gooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool009Gooooo00Go0000oooooooooooooooo
o`000009ooooo`?o00002oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool0oooooomIooooo`00UOooool5o`0000cooooo0_l0000:ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002G
ooooo`Co00003Oooool3o`0000Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo0?ooooooFoooool009_ooooo0ol0000=ooooo`?o00001_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool7o`00
0?ooooooD?ooool009kooooo0_l0000>ooooo`?o00001?ooool00ol0003oooooooooo`06ooooo`?o
00001_ooool00ol0003oooooo`000006o`0000Kooooo00?o0000ooooooooool0oooooom>ooooo`00
X?ooool3o`0000kooooo0ol00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo0?ooooooC_ooool00:?ooooo
0ol0000>ooooo`Co00001_ooool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooooooool0
00001Oooool2o`0000Gooooo00?o0000ooooooooool0oooooom>ooooo`00Y_ooool2o`0000oooooo
0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0oooooom>ooooo`00
Z?ooool3o`0000kooooo0ol00002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`3oooooodkooooo002[ooooo`?o00003?ooool00ol0003oooooo`000002o`0000?ooooo
00?o0000ooooooooool01Oooool01?l0003oooooooooool00004ooooo`;o00000_ooool00ol0003o
ooooooooo`3oooooodkooooo002]ooooo`?o00001?ooool2o`0000Gooooo00?o0000ooooooooool0
1?l00008ooooo`05o`000?ooooooooooo`000?ooool01Ol00002ooooo`03o`000?oooooooooo0?oo
ooooC_ooool00:kooooo00?o0000ooooool000000ol00002ooooo`03o`000?oooooooooo00?ooooo
00Ko0000ooooool0003oooooo`000?ooool3o`0000Gooooo00?o0000ooooool000000_l000000ooo
oooo0000o`000005o`000?ooooooD?ooool00:kooooo00?o0000ooooooooool00_ooool4o`0000Ko
oooo0ol00005ooooo`;o00000oooool6o`000005ooooool0003o0000ooooool00000oooooomBoooo
o`00[_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?o00001Oooool5o`0000Co
oooo0ol00003ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooom@oooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo0_l00003oooo
o`03o`000?oooooooooo00Wooooo0ol000000ooooooo0000ooooo`04ooooo`03o`000?oooooooooo
0?ooooooD?ooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo1?l0000>oooo
o`?o00001?ooool00ol0003oooooooooo`3ooooooe3ooooo002^ooooo`03o`000?oooooooooo00?o
oooo0_l00008ooooo`?o00003Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?oo
ooooDOooool00;kooooo00?o0000ooooooooool00_l0000;ooooo`03o`000?oooooooooo00Go0000
oooooomAooooo`00__ooool00ol0003oooooooooo`02ooooo`?o00002?ooool00ol0003oooooo`00
0004ooooo`03o`000?oooooooooo0?ooooooCoooool00;kooooo00?o0000ooooooooool01Oooool3
o`0000Kooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooCoooool00;kooooo00?o0000oooo
ooooool02?ooool2o`0000Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooo
odoooooo002nooooo`?o00002_ooool3o`000003ooooool0003ooooo00Cooooo00?o0000oooooooo
ool0oooooom?ooooo`00__ooool00ol0003oooooooooo`0=ooooo`Co000000?oooooo`000?l00000
oooooomBooooo`00__ooool00ol0003oooooooooo`0@ooooo`;o0000oooooomDooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003ooooo
ooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03
o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co0000
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25602 .05679 .00609 0 365.73 arc
s
newpath
.37199 .09402 .00609 0 365.73 arc
s
newpath
.36732 .07384 .00609 0 365.73 arc
s
.25788 .05099 m
.37385 .08822 L
s
.25416 .06259 m
.37013 .09982 L
s
.37792 .09264 m
.37326 .07247 L
s
.36606 .09539 m
.36139 .07522 L
s
.37989 .07646 m
.378 .06033 L
s
.35381 .06317 m
.3557 .0793 L
s
.25602 .05679 m
.36582 .00406 L
s
.37989 .07646 m
.3557 .0793 L
s
.378 .06033 m
.35381 .06317 L
s
.37989 .07646 m
.36732 .07384 L
s
.3557 .0793 m
.36732 .07384 L
s
newpath
.36582 .00406 .00457 0 365.73 arc
s
newpath
.36582 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003?ooooo`;o0000oooooomFooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0=ooooo`06o`00
0?ooooooooooo`000?oooooo00004oooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool03?ooool3o`000004ooooool0003o0000o`0001;ooooo00?o0000oooo
ool000005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03
o`000?oooooooooo057ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03
o`000?oooooooooo00_ooooo0ol000000ooooooo0000o`00000Cooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057o
oooo00?o0000ooooooooool05?ooool009Sooooo00?o0000ooooooooool08oooool00ol0003ooooo
ooooo`09ooooo`;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?oooooo
@?ooool009Wooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o00006Ooo
ool00ol0003oooooooooo`3ooooood7ooooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool01?ooool3o`0001[ooooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo00;ooooo0_l0000Looooo`03o`000?oooooooooo
0?oooooo@oooool009cooooo00?o0000ooooooooool07oooool5o`0001gooooo00?o0000oooooooo
ool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0Nooooo`?o00007_ooool00ol0003ooooo
ooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01cooooo0_l0000Oooooo`03o`000?oo
oooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool06Oooool2o`000003ooooool0003o
oooo01gooooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`0Foooo
o`;o00000oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool00:7o
oooo00?o0000ooooooooool04oooool2o`0000Gooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo013ooooo0_l00007ooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003ooooooooo
o`0<ooooo`?o00002Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?ooooooBooo
ool00:Cooooo00?o0000ooooooooool02Oooool2o`0000cooooo0ol0000Gooooo`03o`000?oooooo
oooo0?ooooooC?ooool00:Gooooo00?o0000ooooooooool01_ooool2o`0000kooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo00?o
oooo0_l0000@ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00
Yoooool00ol0003oooooooooo`02o`0001;ooooo00?o0000ooooooooool05?ooool00ol0003ooooo
ooooo`3oooooodoooooo002Xooooo`;o00005?ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo0?ooooooD?ooool00:Kooooo0_l000000ooooooo0000ooooo`0Cooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool0oooooomAooooo`00Y?ooool2o`0000Cooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool00:;o
oooo0_l00007ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`3ooooooe?ooooo002Oooooo`?o00002_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool0oooooomDooooo`00WOooool2o`0000kooooo00?o
0000ooooooooool03_ooool3o`0000kooooo00?o0000ooooooooool0oooooomEooooo`00U_ooool4
o`000003ooooool0003o0000017ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo0?ooooooE_ooool009Cooooo0_l00003ooooo`Co00004_ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomGoooo
o`00U?ooool00ol0003oooooooooo`03o`0000?ooooo0ol0000@ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeSooooo002Cooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01?ooool3o`0000kooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool009?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`?o00003?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJooooo`00U?oo
ool2o`0000;ooooo0_l0000<ooooo`?o00002_ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool00oooool7o`000?ooooooDOooool009Gooooo0ol0000A
ooooo`Co00001oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo1ol00006
ooooo`03o`000?oooooooooo0?ooooooCoooool009Sooooo0ol0000Booooo`?o00001Oooool00ol0
003oooooooooo`06ooooo`?o00001_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo
0?ooooooCoooool009_ooooo0ol0000Booooo`?o00000oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`3ooooo
odoooooo002Nooooo`?o00004_ooool3o`000003ooooool0003ooooo00Gooooo00?o0000oooooooo
ool01?ooool01Ol0003ooooooooooooooooo000000Cooooo1?l00003ooooo`03o`000?oooooooooo
0?ooooooCoooool00:7ooooo0ol0000Booooo`?o00001Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool0oooooom>ooooo`00Y?ooool3o`0001;ooooo0ol00002ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00004oooo
o`;o00000_ooool00ol0003oooooooooo`3oooooodkooooo002Wooooo`Co00003oooool00ol0003o
ooooo`000002o`0000?ooooo00?o0000ooooooooool01Oooool01Ol0003oooooooooool0003ooooo
00Go00000_ooool00ol0003oooooooooo`3oooooodkooooo002[ooooo`Go00001?ooool2o`0000Go
oooo00?o0000ooooooooool01Ol00007ooooo`03o`000?oooooooooo00;o00001?ooool4o`000?oo
ooooD?ooool00:kooooo0ol00002ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000ooooool0
003oooooo`000002ooooo`?o00001?ooool:o`000?ooooooDoooool00:kooooo00?o0000oooooooo
ool00ol00002ooooo`03o`000?oooooooooo00Cooooo0ol00006ooooo`?o000000?oooooo`000?l0
00000_l00002ooooo`05o`000?ooooooooooooooool00000oooooomBooooo`00[_ooool00ol0003o
ooooooooo`02ooooo`Co00001oooool5o`0000Kooooo0ol00002ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0oooooom@ooooo`00[_ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00Co00001?ooool00ol0003oooooooooo`0;ooooo`?o00001Oooool00ol0003ooooo
ooooo`3ooooooe3ooooo002]ooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`?o0000
00?oooooo`000?ooool03_ooool4o`0000;ooooo00?o0000ooooooooool0oooooom@ooooo`00[_oo
ool00ol0003oooooooooo`03ooooo`;o00001oooool4o`0000gooooo00Co0000oooooooooooooooo
0ol0003ooooooe;ooooo002nooooo`03o`000?oooooooooo00?o00002_ooool01?l0003oooooo`00
0?l00003ooooo`03o`000?oooooooooo0?ooooooCoooool00;kooooo00?o0000ooooooooool00ooo
ool3o`0000Sooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooCoooool00;kooooo00?o0000
ooooooooool01_ooool3o`0000Gooooo00?o0000ooooooooool00oooool2o`000?ooooooD?ooool0
0;kooooo00?o0000ooooooooool02Oooool3o`0000;ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`3oooooodkooooo002nooooo`?o00003?ooool5o`0000?ooooo00?o0000oooooooo
ool0oooooom?ooooo`00__ooool00ol0003oooooooooo`0?ooooo`Ko0000oooooomAooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003o
ooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003o
ooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooo
oooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003o
ooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?oo
ooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25501 .06017 .00609 0 365.73 arc
s
newpath
.37249 .09233 .00609 0 365.73 arc
s
newpath
.36732 .07228 .00609 0 365.73 arc
s
.25662 .05429 m
.3741 .08645 L
s
.25341 .06604 m
.37088 .0982 L
s
.37839 .09081 m
.37322 .07076 L
s
.3666 .09385 m
.36142 .0738 L
s
.37992 .07475 m
.37784 .05864 L
s
.35368 .06176 m
.35576 .07786 L
s
.25501 .06017 m
.36312 .00406 L
s
.37992 .07475 m
.35576 .07786 L
s
.37784 .05864 m
.35368 .06176 L
s
.37992 .07475 m
.36732 .07228 L
s
.35576 .07786 m
.36732 .07228 L
s
newpath
.36312 .00406 .00457 0 365.73 arc
s
newpath
.36313 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003=ooooo`?o0000oooooomGooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00;o00000_ooool00ol0003oooooooooo`0Aooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0:ooooo`Co000000Goooooo`000?oooooooooo
o`00000Booooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool09?ooool00ol0003oooooooooo`0:ooooo`?o000000?oooooo`000?ooool05?oo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool0DOoo
ool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool02?ooool2o`0000?ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool01_ooool2o`0001[ooooo00?o0000ooooooooool0oooooom1ooooo`00V_ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Cooooo0_l0000Kooooo`03o`000?oooooooooo0?oo
oooo@_ooool009_ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`02ooooo`;o0000
7?ooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`000?oooooooooo01oooooo1Ol0
000Mooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool07_ooool0
0ol0003oooooo`00000Nooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000oooo
ooooool07Oooool2o`0001kooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003o
ooooooooo`0Jooooo`?o00007_ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`00
0?oooooooooo01Oooooo0_l00002ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
oooooom8ooooo`00XOooool00ol0003oooooooooo`0Dooooo`;o00001?ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool04Oooool2
o`0000Kooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Soooo
o`03o`000?oooooooooo00kooooo0_l00008ooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0;ooooo`;o00002_ooool3o`0001Oo
oooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`08ooooo`;o0000
3?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool00:Kooooo00?o
0000ooooooooool01Oooool2o`0000kooooo00?o0000ooooooooool05Oooool00ol0003ooooooooo
o`3oooooodkooooo002Wooooo`03o`000?oooooooooo00;ooooo0_l0000@ooooo`03o`000?oooooo
oooo01Cooooo00?o0000ooooooooool0oooooom?ooooo`00Z?ooool01?l0003oooooo`000?l0000B
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom@ooooo`00Z?ooool2o`00
01Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo002Vooooo`;o
00000_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool0oooooomBooooo`00Y?ooool2o`0000Gooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool00:?ooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooo
oomDooooo`00XOooool2o`0000[ooooo00?o0000ooooooooool03_ooool3o`0000kooooo00?o0000
ooooooooool0oooooomEooooo`00Woooool2o`0000gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool009gooooo0_l0000@ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOo
oooo002Dooooo`Ko000000?oooooo`000?l000004oooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00U?ooool01?l0003ooooooooo
ooooool6o`0001?ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo0?ooooooFOooool009?ooooo00Co0000oooooooooooooooo0_l00005ooooo`?o0000
4Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
1Oooool4o`000?ooooooDOooool009?ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`Co00003_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool01_l00003ooooo`03o`000?oooooooooo0?ooooooCoooool009?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`09ooooo`Co00002oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo1?l00009ooooo`03o`000?oooooooooo0?ooooooCooo
ool009Cooooo0_l000000ooooooo0000o`00000@ooooo`Co00002?ooool00ol0003oooooooooo`06
ooooo`?o00001_ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo0?ooooooCoooool0
09Gooooo0ol0000Eooooo`?o00001_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00Co0000oooooooooooo00001Oooool3o`0000?ooooo00?o0000ooooooooool0oooooom?
ooooo`00V?ooool4o`0001Cooooo1?l00003ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool01Ol0003ooooooooooooooooo000000Cooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo0?ooooooC_ooool009cooooo1?l0000Dooooo`Go00001Oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooooooool2o`0000;ooooo00?o0000ooooooooool0oooooom>ooooo`00X?ooool3
o`0001Gooooo1?l00002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool0
1Ol0003oooooooooool0003ooooo00Go00000_ooool00ol0003oooooooooo`3oooooodkooooo002S
ooooo`Co00004oooool00ol0003oooooo`000002o`0000?ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`02o`0000Cooooo1?l0003ooooooe3ooooo002Wooooo`Co00000_ooool3o`00
00Cooooo0_l00005ooooo`03o`000?oooooooooo00Go00001oooool9o`000003ooooool0003ooooo
0?ooooooDOooool00:_ooooo1?l00004ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000oooo
ool0003oooooo`000002ooooo`Co00000oooool4o`0000;ooooo00Go0000ooooooooooooooooo`00
003ooooooe;ooooo002^ooooo`Ko00000_ooool00ol0003oooooooooo`04ooooo`?o00001oooool4
o`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe3ooooo002^oooo
o`03o`000?oooooooooo00;ooooo1?l00007ooooo`Go00002?ooool4o`0000Kooooo00?o0000oooo
ooooool0oooooom?ooooo`00[_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Co
00001?ooool00ol0003oooooooooo`0=ooooo`Co00000oooool00ol0003oooooooooo`3oooooodoo
oooo002]ooooo`;o00001?ooool01?l0003oooooooooool00003ooooo`Go00004?ooool00ol0003o
ooooooooo`04o`000?ooooooDOooool00:kooooo00?o0000ooooooooool00oooool2o`0000Sooooo
1?l0000=ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0oooooom?ooooo`00__oo
ool01?l0003oooooooooooooool4o`0000Wooooo0_l00004ooooo`;o0000oooooom@ooooo`00__oo
ool00ol0003oooooooooo`05ooooo`?o00001_ooool2o`0000Gooooo00?o0000ooooooooool0oooo
oom>ooooo`00__ooool00ol0003oooooooooo`08ooooo`Co00000_ooool2o`0000Gooooo00?o0000
ooooooooool0oooooom>ooooo`00__ooool00ol0003oooooooooo`0<ooooo`Co00001?ooool00ol0
003oooooooooo`3oooooodoooooo002nooooo`?o00003oooool3o`000003ooooool0003o00000?oo
ooooDOooool00;kooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03
o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04
o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003o
ooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03
o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo
0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go0000
0oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go
0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25412 .06377 .00609 0 365.73 arc
s
newpath
.37294 .09053 .00609 0 365.73 arc
s
newpath
.36733 .0706 .00609 0 365.73 arc
s
.25545 .05782 m
.37428 .08459 L
s
.25278 .06971 m
.3716 .09647 L
s
.3788 .08888 m
.37319 .06895 L
s
.36708 .09218 m
.36147 .07225 L
s
.37996 .07292 m
.37769 .05684 L
s
.35357 .06023 m
.35583 .07631 L
s
.25412 .06377 m
.36028 .00406 L
s
.37996 .07292 m
.35583 .07631 L
s
.37769 .05684 m
.35357 .06023 L
s
.37996 .07292 m
.36733 .0706 L
s
.35583 .07631 m
.36733 .0706 L
s
newpath
.36028 .00406 .00457 0 365.73 arc
s
newpath
.36028 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003<ooooo`;o0000oooooomIooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0:ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool02Oooool3o`000003ooooool0003o000000?ooooo
00?o0000ooooooooool04?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool02?ooool3o`000003ooooool0
003o000001Kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Oooooo00Go0000ooooooooooooooooo`00
000Gooooo`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`05ooooo`;o00006oooool00ol0003oooooooooo`3ooooood7ooooo002Joooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool00oooool2o`0001cooooo00?o0000oooo
ooooool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`04o`000?oooooooooooooo
o`;o00007Oooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`000?oooooooooo01oo
oooo1?l0000Nooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool0
7_ooool2o`0001oooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003ooooooooo
o`0Looooo`;o00007oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooo
oooo01Wooooo0_l000000ooooooo0000ooooo`0Mooooo`03o`000?oooooooooo0?ooooooAoooool0
0:3ooooo00?o0000ooooooooool05_ooool2o`0000?ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo
00?o0000ooooooooool04Oooool2o`0000Kooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo00kooooo0_l00008ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0;
ooooo`;o00002_ooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0
003oooooooooo`08ooooo`;o00003?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
0?ooooooCOooool00:Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0003ooooo
ooooo`03ooooo`;o00003oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?oooooo
Coooool00:Sooooo00?o0000ooooooooool00_l0000Aooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool0oooooom@ooooo`00ZOooool2o`0001?ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`3ooooooe7ooooo002Xooooo`03o`000?oooooo000001?ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002Vooooo`;o00000oooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0oooooomCooooo`00
Y?ooool2o`0000Kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo0?ooooooE?ooool00:;ooooo0_l00009ooooo`03o`000?oooooooooo00kooooo0ol0
000>ooooo`03o`000?oooooooooo0?ooooooEOooool00:7ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomF
ooooo`00Woooool2o`0000kooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo0?ooooooEoooool009gooooo0_l0000Aooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeSooooo002Eooooo`;o0000
1?ooool2o`0001Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Cooooo1?l0003ooooooe7ooooo002Cooooo`;o000000?oooooo`000?l000000ol0
000Gooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooo`00
0005o`0000?ooooo00?o0000ooooooooool0oooooom?ooooo`00Toooool00ol0003oooooooooo`02
ooooo`Ko00005Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo0ol00009
ooooo`03o`000?oooooooooo0?ooooooCoooool009;ooooo00Co0000oooooooooooooooo0ol00005
ooooo`Go00004Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo0_l0000<
ooooo`03o`000?oooooooooo0?ooooooC_ooool009;ooooo00Co0000oooooooooooo00000_ooool2
o`0000Wooooo1Ol0000=ooooo`03o`000?oooooooooo00Kooooo0ol00006ooooo`03o`000?oooooo
000000Gooooo0ol00004ooooo`03o`000?oooooooooo0?ooooooC_ooool009?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0<ooooo`Co00002_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00001?ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool0oooooom>ooooo`00Toooool2o`0000;ooooo0_l0000C
ooooo`Go00001_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00Go0000
ooooooooooooooooo`000004ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003ooooo
ooooo`3oooooodkooooo002Eooooo`?o00006Oooool5o`0000;ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooooooo0000
ooooo`06o`0000;ooooo00?o0000ooooooooool0oooooom=ooooo`00V?ooool5o`0001Wooooo1Ol0
0003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`02o`0000Cooooo1Ol0003oooooodoooooo002Mooooo`Co00006Oooool6o`0000;ooooo00?o0000
ooooooooool01Oooool;o`000?ooooooD_ooool00:7ooooo1?l00008ooooo`?o00001?ooool2o`00
00Gooooo00Go0000oooooooooooo0000ooooo`04o`0000Kooooo1?l00002ooooo`05o`000?oooooo
ooooooooool00000oooooomBooooo`00YOooool5o`0000Cooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00005ooooo`05o`000?oooooo0000ooooool000000oooool5o`0000Gooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe3ooooo002Zooooo`Go00001?oo
ool01?l0003oooooooooool00006ooooo`?o00002Oooool6o`0000Kooooo00?o0000ooooooooool0
oooooom?ooooo`00[_ooool4o`000005ooooool0003oooooooooool000001oooool5o`0000_ooooo
1Ol00002ooooo`03o`000?oooooooooo0?ooooooCoooool00:kooooo00Co0000oooooooooooooooo
1Ol00007ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool01?l0003ooooooe7ooooo
002]ooooo`;o00001?ooool00ol0003oooooooooo`05o`0000?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooCoooool00:kooooo00?o0000
ooooooooool00oooool2o`0000Gooooo1?l0000@ooooo`03o`000?oooooo000000?ooooo0_l0003o
oooooe3ooooo002nooooo`Ko00003?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
0?ooooooC_ooool00;kooooo00?o0000ooooooooool00oooool4o`0000Sooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`3oooooodkooooo002nooooo`03o`000?oooooooooo00Oooooo
1?l00005ooooo`05o`000?ooooooooooooooool00000oooooomAooooo`00__ooool00ol0003ooooo
ooooo`0;ooooo`Oo000000?oooooo`000?l00000oooooomAooooo`00__ooool3o`00013ooooo0ol0
003ooooooe?ooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool00002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Ooo
ool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo0000
1oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol0
0003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oooooo
ooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo
1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooo
oomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0
003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/
ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25337 .06748 .00609 0 365.73 arc
s
newpath
.37332 .08867 .00609 0 365.73 arc
s
newpath
.36735 .06884 .00609 0 365.73 arc
s
.25443 .06148 m
.37437 .08267 L
s
.25231 .07348 m
.37226 .09467 L
s
.37915 .08692 m
.37318 .06709 L
s
.36748 .09043 m
.36152 .0706 L
s
.38 .07102 m
.37756 .05497 L
s
.35347 .05863 m
.35592 .07469 L
s
.25337 .06748 m
.35736 .00406 L
s
.38 .07102 m
.35592 .07469 L
s
.37756 .05497 m
.35347 .05863 L
s
.38 .07102 m
.36735 .06884 L
s
.35592 .07469 m
.36735 .06884 L
s
newpath
.35736 .00406 .00457 0 365.73 arc
s
newpath
.35736 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003:ooooo`?o0000oooooomJooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00;o00001Oooool00ol0003oooooooooo`0Aooooo`;o00005?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`Co000000?oooooo`000?ooool01?oo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooo000001Cooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`1Aooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`08ooooo`;o000000?ooooo
o`000?ooool05oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool01_ooool2o`0000;ooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool01?ooool2o`0001cooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo023ooooo00Co
0000oooooooooooooooo0_l0000Mooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o
0000ooooooooool07oooool4o`0001kooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool0
0ol0003oooooooooo`0Nooooo`;o00007oooool00ol0003oooooooooo`3oooooodGooooo002Noooo
o`03o`000?oooooooooo01cooooo0_l0000Oooooo`03o`000?oooooooooo0?ooooooA_ooool009oo
oooo00?o0000ooooooooool06Oooool2o`000003ooooool0003ooooo01gooooo00?o0000oooooooo
ool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`0Gooooo`05o`000?ooooooooooooooool0
00007Oooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo01Cooooo
0_l00004ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0oooooom9ooooo`00X_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo00oooooo0_l00007
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0
003oooooooooo`0<ooooo`;o00002Oooool3o`0001Oooooo00?o0000ooooooooool0oooooom<oooo
o`00YOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo00Oooooo
0_l0000<ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Yooo
ool00ol0003oooooooooo`04ooooo`;o00003_ooool00ol0003oooooooooo`0Dooooo`03o`000?oo
oooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom@ooooo`00ZOooool01?l0
003oooooo`000?l0000Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooooomA
ooooo`00ZOooool2o`0001?ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooo
oe;ooooo002Xooooo`04o`000?ooooooooooo`0001;ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`3ooooooe?ooooo002Vooooo`;o00001?ooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooomDooooo`00YOooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00kooooo0ol0000>ooooo`03o`000?oooooooooo0?oooooo
EOooool00:?ooooo0_l00009ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`3ooooooeKooooo002Qooooo`;o00003?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00X?ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`03ooooo`Co0000oooooomAooooo`00W_ooool2o`00017ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`0:ooooo`Oo00000oooool00ol0003oooooooooo`3oooooodoo
oooo002Looooo`;o00005?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo
0ol00009ooooo`03o`000?oooooooooo0?ooooooCoooool009Cooooo1_l000000ooooooo0000oooo
o`0Fooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo0?ooooooC_ooool009?ooooo00Co0000oooooooooooo00000_oo
ool6o`0001Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`;o00001Ooo
ool3o`0000Cooooo00?o0000ooooooooool0oooooom>ooooo`00Toooool01?l0003ooooooooooooo
ool2o`0000Kooooo1_l0000@ooooo`03o`000?oooooooooo00Kooooo0ol00006ooooo`03o`000?oo
oooo000000Cooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0?oooooo
C_ooool009;ooooo00Co0000oooooooooooooooo0_l0000=ooooo`Ko00002oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00001?ooool01?l0003o
ooooooooooooool2o`0000;ooooo00?o0000ooooooooool0oooooom>ooooo`00T_ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo013ooooo1Ol00007ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
o`000?ooool01_l00002ooooo`03o`000?oooooooooo0?ooooooCOooool009?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0Eooooo`Ko00000_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02o`00
00Cooooo1Ol0003oooooodoooooo002Cooooo`;o000000?oooooo`000?l000007_ooool6o`0000;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`_o0000oooooomBooooo`00
U?ooool4o`0002;ooooo00?o0000ooooool000001?l000000ooooooo0000ooooo`06ooooo`Co0000
0_ooool01Ol0003ooooooooooooooooo00000?ooooooD_ooool009Sooooo1_l0000?ooooo`?o0000
1?ooool2o`0000Gooooo00Co0000oooooooooooo00000_ooool6o`0000Oooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`3ooooooe3ooooo002Nooooo`Go00002oooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000ooooool0003oooooo`000006oooo
o`Ko000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`3oooooodoooooo002Sooooo`Ko
00001Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Kooooo0ol0000=oooo
o`Go00000oooool00ol0003oooooooooo`3oooooodoooooo002Yooooo`Ko00001?ooool01?l0003o
ooooooooool00007ooooo`Go00003?ooool00ol0003oooooooooo`04o`000?ooooooDOooool00:ko
oooo1ol000000ooooooo0000ooooo`06ooooo`03o`000?oooooooooo00kooooo00?o0000ooooool0
00000oooool00ol0003oooooooooo`3oooooodoooooo002]ooooo`;o00001?ooool00ol0003ooooo
o`000004o`0000Cooooo00?o0000ooooooooool03_ooool00ol0003oooooo`000003ooooo`;o0000
oooooom@ooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001?ooool6o`00013ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`3oooooodkooooo002nooooo`03o`000?oooooo
000000Go00002_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooC_ooool0
0;kooooo00?o0000ooooooooool01Oooool5o`0000Kooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3oooooodkooooo002nooooo`03o`000?oooooooooo00[ooooo2?l000000ooooooo
0000o`00003ooooooe7ooooo002nooooo`03o`000?oooooooooo013ooooo0ol0003ooooooe?ooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5
o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oo
oooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?oo
ooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool0
1Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003ooooooooo
ool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oo
oooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooo
oomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25275 .07161 .00609 0 365.73 arc
s
newpath
.37363 .08661 .00609 0 365.73 arc
s
newpath
.36739 .06686 .00609 0 365.73 arc
s
.2535 .06557 m
.37438 .08056 L
s
.252 .07765 m
.37288 .09265 L
s
.37943 .08477 m
.37319 .06503 L
s
.36782 .08844 m
.36158 .0687 L
s
.38006 .06889 m
.37742 .05286 L
s
.35339 .05683 m
.35603 .07285 L
s
.25275 .07161 m
.3541 .00406 L
s
.38006 .06889 m
.35603 .07285 L
s
.37742 .05286 m
.35339 .05683 L
s
.38006 .06889 m
.36739 .06686 L
s
.35603 .07285 m
.36739 .06686 L
s
newpath
.3541 .00406 .00457 0 365.73 arc
s
newpath
.3541 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo0039ooooo`;o0000oooooomLooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool01_ooool3o`000003ooooool0003ooooo00Kooooo
00?o0000ooooooooool04?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool01_ooool2o`000003ooooool0
003o000001Wooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00Cooooo0_l00002ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3ooooo
od7ooooo002Jooooo`03o`000?oooooooooo027ooooo00Co0000oooooooooooooooo0_l0000Noooo
o`03o`000?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003o
ooooooooool0000Oooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000oooooooo
ool07oooool3o`0001oooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooom5ooooo`00W_oo
ool00ol0003oooooooooo`0Kooooo`?o00007oooool00ol0003oooooooooo`3oooooodKooooo002O
ooooo`03o`000?oooooooooo01Wooooo00Co0000oooooooooooo00007_ooool00ol0003ooooooooo
o`3oooooodOooooo002Pooooo`03o`000?oooooooooo01Kooooo0_l00003ooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`3ooooo
odWooooo002Rooooo`03o`000?oooooooooo017ooooo0_l00006ooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo
002Tooooo`03o`000?oooooooooo00cooooo0_l00009ooooo`?o00005oooool00ol0003ooooooooo
o`3oooooodcooooo002Uooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool00:Kooooo00?o0000oooo
ooooool01oooool2o`0000cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`3ooooo
odkooooo002Wooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
oooooom@ooooo`00ZOooool00ol0003oooooooooo`02o`00013ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`;o00004_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo0?ooooooD_ooool00:Wooooo0ol0000Booooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0oooooomCooooo`00Z?ooool01Ol0003ooooooooooooooooo0000
017ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002Vooooo`;o
00001Oooool00ol0003oooooooooo`0>ooooo`?o00003_ooool00ol0003oooooooooo`3ooooooeGo
oooo002Uooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:?ooooo0_l0000:ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`Co0000oooo
oomAooooo`00X_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02oooool6o`0000?ooooo00?o0000ooooooooool0oooooom?ooooo`00X?ooool2o`00
00oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`?o00002Oooool00ol0
003oooooooooo`3oooooodoooooo002Oooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`08ooooo`;o00002oooool00ol0003oooooooooo`3oooooodko
oooo002Mooooo`;o00005?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool00oooool3o`0000Cooooo00?o0000ooooooooool0oooooom>ooooo`00W?oo
ool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool2o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0?oooooo
C_ooool009[ooooo0_l0000Iooooo`03o`000?oooooooooo00Kooooo0ol00006ooooo`03o`000?oo
oooo000000Cooooo00Co0000oooooooooooooooo0_l00002ooooo`03o`000?oooooooooo0?oooooo
C_ooool009?ooooo2?l0000Kooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooool000001Ol00002ooooo`03o`00
0?oooooooooo0?ooooooCOooool009?ooooo00Co0000oooooooooooooooo0_l00002ooooo`Wo0000
4oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02o`0000Cooooo1Ol0003oooooodoooooo002Booooo`04o`000?oo
ooooooooooooo`;o00003?ooool9o`0000_ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo2ol0003ooooooe;ooooo002Aooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`0Booooo`Wo00000oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool4o`0000;ooooo
00Go0000ooooooooooooooooo`00003ooooooe;ooooo002Aooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool06oooool9o`0000?ooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo0?ooooooD?ooool009;ooooo0ol000000ooooooo0000o`00
000Eooooo`?o00001?ooool2o`0000Gooooo00?o0000ooooooooool02_l00006ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0oooooom?ooooo`00U?ooool5o`0001Gooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00005ooooo`05o`000?oooooo0000ooooool00000
1oooool9o`0000Cooooo00?o0000ooooooooool0oooooom?ooooo`00VOooool8o`0000gooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00006ooooo`?o00003oooool00ol0003ooooo
o`000004o`000?ooooooDOooool00:7ooooo2?l00005ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001oooool5o`0000cooooo00?o0000ooooool000001?ooool00ol0003ooooo
ooooo`3oooooodkooooo002Yooooo`So00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3oooooodkooooo
002]ooooo`;o00000_ooool7o`0000Kooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo0?ooooooC_ooool00:kooooo00?o0000ooooooooool00oooool2
o`0000;ooooo2?l0000@ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooom>
ooooo`00__ooool00ol0003oooooo`000007o`0000Wooooo00Go0000ooooooooooooooooo`00003o
oooooe7ooooo002nooooo`03o`000?oooooooooo00Oooooo2?l000001?oooooo0000o`000?ooool2
o`000?ooooooDOooool00;kooooo00?o0000ooooooooool03oooool4o`000?ooooooDoooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00
/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?oo
ooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo
00?o0000ooooool000000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l0
0003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co
0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o
0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25232 .07613 .00609 0 365.73 arc
s
newpath
.37384 .08435 .00609 0 365.73 arc
s
newpath
.36744 .06466 .00609 0 365.73 arc
s
.25273 .07005 m
.37425 .07827 L
s
.25191 .0822 m
.37343 .09042 L
s
.37963 .08247 m
.37323 .06277 L
s
.36805 .08623 m
.36165 .06654 L
s
.38014 .06652 m
.3773 .05053 L
s
.35331 .0548 m
.35616 .07079 L
s
.25232 .07613 m
.35051 .00406 L
s
.38014 .06652 m
.35616 .07079 L
s
.3773 .05053 m
.35331 .0548 L
s
.38014 .06652 m
.36744 .06466 L
s
.35616 .07079 m
.36744 .06466 L
s
newpath
.35051 .00406 .00457 0 365.73 arc
s
newpath
.35051 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo0037ooooo`;o0000oooooomNooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`05ooooo`04o`00
0?ooooooooooo`0000Wooooo00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool01?ooool3o`000003ooooool0003o000000Sooooo
00?o0000ooooooooool04?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool01?ooool2o`000003ooooool0
003o000001_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00007?oo
ool00ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;ooooo00Co0000
oooooooooooooooo0_l0000Oooooo`03o`000?oooooooooo0?oooooo@Oooool009[ooooo00?o0000
ooooooooool08Oooool01?l0003oooooooooool0000Pooooo`03o`000?oooooooooo0?oooooo@_oo
ool009_ooooo00?o0000ooooooooool08?ooool3o`00023ooooo00?o0000ooooooooool0oooooom3
ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool00ol0003oooooooooo`3ooooo
odCooooo002Mooooo`03o`000?oooooooooo01gooooo0_l0000Pooooo`03o`000?oooooooooo0?oo
ooooAOooool009kooooo00?o0000ooooooooool06_ooool2o`000003ooooool0003ooooo01kooooo
00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0Hooooo`05o`000?oo
ooooooooooooool000007_ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool04oooool2o`0000Gooooo00?o0000
ooooooooool06_ooool00ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
0?ooooooB_ooool00:?ooooo00?o0000ooooooooool03_ooool2o`0000Sooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool02?ooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00YOoo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool05_oo
ool00ol0003oooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo00Oooooo0_l0000<
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo00;ooooo0_l0000?ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom@ooooo`00ZOooool01?l0003ooooo
ooooool0000Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooooomAooooo`00
Z_ooool2o`0001;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo
002Yooooo`?o00004_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDooo
ool00:Sooooo00Go0000ooooooooooooooooo`00000Aooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool0oooooomDooooo`00Yoooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00kooooo0ol0000>ooooo`03o`000?oooooooooo0?ooooooEOooool00:Gooooo0_l00007oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool01?l0003oooooooooooooool4
o`000?ooooooDOooool00:Cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00_ooooo1_l00003ooooo`03o`000?oooooooooo0?ooooooCoooool00:;o
oooo0_l0000<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02?ooool4o`0000So
oooo00?o0000ooooooooool0oooooom?ooooo`00XOooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003oooooo`00000:ooooo`03o`00
0?oooooooooo0?ooooooC_ooool00:3ooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo0_l00004ooooo`?o00001?ooool00ol0003ooooooooo
o`3oooooodkooooo002Nooooo`;o00004oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool0oooooom>ooooo`00WOooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool2o`0000Cooooo00Co0000oooooooooooooooo0_l0
0002ooooo`03o`000?oooooooooo0?ooooooC_ooool009cooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`06ooooo`?o00001_ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooo000000Go00000_ooool00ol0003oooooooooo`3oooooodgooooo002Jooooo`;o00006_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00Go0000ooooooooooooooooo`00
0002ooooo`;o00001?ooool5o`000?ooooooCoooool009Wooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool;
o`000?ooooooD_ooool009Cooooo2_l0000Jooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`03ooooo`Co00000_ooool01Ol0003ooooooooooooooooo
00000?ooooooD_ooool009;ooooo0_l00002ooooo`;o00001_ooool@o`0000_ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`3ooooooe3ooooo002Booooo`06o`000?ooooooooooo`00
0?oooooo00005_ooool?o`000003ooooool0003ooooo00;ooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooCoooool0097ooooo00Co0000oooo
oooooooo00000oooool00ol0003oooooooooo`0Booooo`?o00001?ooool2o`0000Gooooo00?o0000
ooooool000003ol000000ooooooo0000ooooo`05ooooo`03o`000?oooooooooo0?ooooooCoooool0
097ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00001Oooool01Ol0003oooooo`000?oooooo000000cooooo2Ol0
003ooooooe7ooooo002Booooo`;o00000_ooool2o`0001Kooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00006ooooo`?o00003oooool01?l0003oooooo`000?l00003ooooo`03o`00
0?oooooooooo0?ooooooC_ooool009Cooooo2Ol0000Aooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001oooool5o`0000cooooo00?o0000ooooool000001?ooool00ol0003ooooo
ooooo`3oooooodkooooo002Moooooa3o000000?oooooo`000?ooool00oooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`3oooooodkooooo002]ooooo`oo00000_ooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0003oooooooooo`03
ooooo`;o00001_ooool@o`0000Gooooo0_l00003ooooo`03o`000?oooooooooo0?ooooooC_ooool0
0;kooooo00?o0000ooooooooool02oooool;o`000?ooooooD?ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2
o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003
ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo
000000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^
ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?oooooooooo
o`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo
00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^oooo
o`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25214 .08063 .00609 0 365.73 arc
s
newpath
.37393 .0821 .00609 0 365.73 arc
s
newpath
.36751 .06241 .00609 0 365.73 arc
s
.25221 .07454 m
.374 .07601 L
s
.25206 .08672 m
.37386 .08819 L
s
.37972 .08021 m
.3733 .06052 L
s
.36814 .08399 m
.36172 .0643 L
s
.38023 .06412 m
.37719 .04817 L
s
.35326 .05273 m
.3563 .06868 L
s
.25214 .08063 m
.34686 .00406 L
s
.38023 .06412 m
.3563 .06868 L
s
.37719 .04817 m
.35326 .05273 L
s
.38023 .06412 m
.36751 .06241 L
s
.3563 .06868 m
.36751 .06241 L
s
newpath
.34686 .00406 .00457 0 365.73 arc
s
newpath
.34686 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo0035ooooo`;o0000oooooomPooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03ooooo`04o`00
0?ooooooooooo`0000_ooooo00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool00_ooool3o`000003ooooool0003o000000[ooooo
00?o0000ooooooooool04?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool00_ooool2o`000003ooooool0
003o000001gooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000ooooooooool08_ooool0
1?l0003oooooooooool0000Qooooo`03o`000?oooooooooo0?oooooo@Oooool009[ooooo00?o0000
ooooooooool08Oooool3o`00027ooooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0oooooom3oooo
o`00W?ooool00ol0003oooooooooo`0Nooooo`Co00007oooool00ol0003oooooooooo`3oooooodCo
oooo002Mooooo`03o`000?oooooooooo01cooooo00?o0000ooooool000008?ooool00ol0003ooooo
ooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01Wooooo0_l00002ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3o
ooooodOooooo002Pooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool0oooooom9ooooo`00X_ooool00ol0003oooooooooo`0@ooooo`;o00001oooool00ol0003ooooo
ooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooo
oom;ooooo`00Y?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Sooooo0ol0000G
ooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=oooo
o`00Y_ooool00ol0003oooooooooo`07ooooo`;o00003?ooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooooom?ooooo`00Z?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`3ooooooe3ooooo002Yooooo`03o`000?oooooooooo00;o00004?ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo0_l0000Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBooooo`00Z_ooool2o`0001;o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3ooooooe?ooooo002Yooooo`04o`00
0?ooooooooooo`00017ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCo
oooo002Wooooo`;o00001?ooool00ol0003oooooooooo`0>ooooo`?o00003_ooool00ol0003ooooo
ooooo`04o`000?ooooooDOooool00:Kooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00_ooooo1_l00003ooooo`03o`000?oooooooooo0?ooooooCooo
ool00:Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00Sooooo0ol000000ooooooo0000ooooo`06ooooo`03o`000?oooooooooo0?ooooooCoooool0
0:Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00Sooooo00Co0000oooooooooooo00002Oooool00ol0003oooooooooo`3oooooodkooooo002Roooo
o`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ool000000oooool3o`0000Cooooo00?o0000ooooooooool0oooooom>ooooo`00XOooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool2o`0000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0?ooooooC_ooool00:3o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooooooool2o`0000;ooooo00?o0000oooo
ooooool0oooooom>ooooo`00Woooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooo`000002ooooo`03o`000?oooooo000000Go
00000_ooool00ol0003oooooooooo`3oooooodgooooo002Mooooo`;o00005_ooool00ol0003ooooo
ooooo`06ooooo`?o00001_ooool01?l0003oooooooooool00002ooooo`;o00001?ooool5o`000?oo
ooooCoooool009cooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Gooooo00Co0000oooooooooooooooo2ol0003ooooooe;ooooo002Kooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00;ooooo1?l00002ooooo`05o`000?ooooooooooooooool00000oooooomBooooo`00
V_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
oooooom@ooooo`00V?ooool2o`0001oooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`3oooooodoooooo002Dooooob7o00001Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooCooo
ool009;ooooo0_l00002ooooo`;o00005Oooool3o`0000Cooooo8_l0003ooooooe7ooooo002Boooo
o`06o`000?ooooooooooo`000?oooooo00005_ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000Gooooo00Go0000ooooool0003oooooo`00000>ooooo`04o`000?oooooo0000o`00
00?ooooo00?o0000ooooooooool0oooooom>ooooo`00TOooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo01Cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00006
ooooo`?o00003oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooC_ooool0
097ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00001oooool5o`0000gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`3oooooodgooooo002Booooo`;o00000oooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooom=ooooo`00U?ooool4o`00
01Gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool04?ooool2
o`0000;ooooo0_l0003ooooooe3ooooo002Doooood7o0000oooooomBooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:ko
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo
00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?oooooooooo
o`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^oooo
o`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003o
oooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007
ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo
00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomToooo
o`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25222 .08545 .00609 0 365.73 arc
s
newpath
.37389 .07969 .00609 0 365.73 arc
s
newpath
.3676 .05996 .00609 0 365.73 arc
s
.25193 .07937 m
.3736 .0736 L
s
.25251 .09153 m
.37418 .08577 L
s
.37969 .07784 m
.3734 .05811 L
s
.36809 .08154 m
.3618 .06181 L
s
.38034 .06151 m
.37711 .0456 L
s
.35324 .05045 m
.35647 .06636 L
s
.25222 .08545 m
.34285 .00407 L
s
.38034 .06151 m
.35647 .06636 L
s
.37711 .0456 m
.35324 .05045 L
s
.38034 .06151 m
.3676 .05996 L
s
.35647 .06636 m
.3676 .05996 L
s
newpath
.34285 .00407 .00457 0 365.73 arc
s
newpath
.34285 .00407 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo0033ooooo`;o0000oooooomRooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Aooooo`;o00005?ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`03o`000003ooooool0003o000000cooooo
00?o0000ooooooooool04?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo02Cooooo00?o0000ooooooooool00_l000000ooooooo0000o`00
000Oooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o0000
ooooooooool08oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo01kooooo00?o0000
ooooooooool0oooooom0ooooo`00VOooool00ol0003oooooooooo`0Rooooo`;o00008oooool00ol0
003oooooooooo`3ooooood7ooooo002Jooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo01oooooo
0_l0000Rooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooo`000002o`0001oooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool0
0ol0003oooooooooo`0Kooooo`04o`000?ooooooooooo`00023ooooo00?o0000ooooooooool0oooo
oom5ooooo`00W_ooool00ol0003oooooooooo`0Hooooo`;o00000oooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool05_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7oooo
o`00X?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo0?oooooo
BOooool00:;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3o
oooood_ooooo002Tooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02?ooool3o`00
01Oooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`3oooooodgo
oooo002Vooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o0000ooooooooool01Ooo
ool2o`0000gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3oooooodoooooo002X
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00Go0000ooooooooooooooooo`00000@
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0
003oooooo`00000Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomBoooo
o`00Zoooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooool0
00000_l0003ooooooe7ooooo002Zooooo`03o`000?oooooo0000017ooooo00?o0000ooooooooool0
3_ooool4o`0000;ooooo00?o0000ooooooooool0oooooom?ooooo`00ZOooool01Ol0003ooooooooo
oooooooo0000013ooooo0ol0000:ooooo`Go00001Oooool00ol0003oooooooooo`3oooooodoooooo
002Xooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`08ooooo`;o00000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooC_oo
ool00:Kooooo0_l00007ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02?ooool0
1_l0003ooooooooooooooooo0000ooooo`?o00001?ooool00ol0003oooooooooo`3oooooodkooooo
002Uooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`08ooooo`06o`000?ooooooooooo`000?oooooo00000oooool01Ol0003ooooooooooooooooo0000
0?ooooooD?ooool00:Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`000?ooooooD?ooool00:?ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0_l00002ooooo`03o`000?oooooooooo00?o
oooo00Go0000ooooooooooooooooo`00003oooooodoooooo002Rooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o00000_ooool00ol0003o
ooooo`000008o`000?ooooooCoooool00:7ooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool000000_ooool2o`000003oooo
ool0003o000000?o0000oooooomBooooo`00X?ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo00Kooooo0ol00006ooooo`03o`000?oooooooooo00Ko000000Goooooo`000?l0003ooooo
o`00003ooooooe;ooooo002Oooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooooooo`;o000000Goooooo`000?oooooo
ooooo`000003ooooo`03o`000?oooooooooo0?ooooooD?ooool009kooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooD?ooool009cooooo0_l0
000Jooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooom?ooooo`00Voooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooom?
ooooo`00V_ooool00ol0003oooooooooo`0Mooooo`05o`000?ooooooooooooooool000000oooool0
0ol0003oooooooooo`04ooooo`go0000oooooomAooooo`00VOooool00ol0003oooooooooo`0Aoooo
o`?o00001?oooolEo`0000Kooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3ooooo
odkooooo002Hooooo`03o`000?oooooooooo00Cooooo5Ol00002ooooo`03o`000?oooooooooo00?o
oooo00Go0000ooooool0003oooooo`00000>ooooo`;o00001Oooool00ol0003oooooooooo`3ooooo
odkooooo002Booooo`go00003oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Kooooo0ol0000@ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooom=oooo
o`00T_ooool01?l0003oooooooooooooool2o`0001Kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00007ooooo`Go00003Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?ooooooCOooool0097ooooo00Oo0000ooooooooooooooooo`000?oooooo000001Kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo013ooooo
0_l00002ooooo`;o0000oooooom@ooooo`00TOooool01?l0003oooooooooool00003ooooo`03o`00
0?oooooooooo01;ooooo0_l00004ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool02Oooool;o`000?ooooooD_ooool0097ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo00?ooooo5_l0003ooooooegooooo002Booooo`;o00000_oo
ool2o`0000Sooooo5Ol00009ooooo`03o`000?oooooooooo0?ooooooI_ooool009Cooooo3?l0000N
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00
[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?oo
ool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000ooo
ool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003ooooooooo
o`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25266 .09085 .00609 0 365.73 arc
s
newpath
.37367 .07699 .00609 0 365.73 arc
s
newpath
.36772 .05715 .00609 0 365.73 arc
s
.25197 .0848 m
.37298 .07094 L
s
.25335 .0969 m
.37436 .08304 L
s
.3795 .07524 m
.37356 .05541 L
s
.36784 .07874 m
.36189 .0589 L
s
.38049 .05854 m
.37704 .04267 L
s
.35324 .04783 m
.35668 .0637 L
s
.25266 .09085 m
.33821 .00414 L
s
.38049 .05854 m
.35668 .0637 L
s
.37704 .04267 m
.35324 .04783 L
s
.38049 .05854 m
.36772 .05715 L
s
.35668 .0637 m
.36772 .05715 L
s
newpath
.33821 .00414 .00457 0 365.73 arc
s
newpath
.33821 .00414 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo0030ooooo`?o0000oooooomTooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04_ooool3o`0000;ooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_oo
ool2o`000004ooooool0003oooooo`0000oooooo00?o0000ooooooooool04?ooool00ol0003ooooo
o`00000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool05?ooool001Kooooo00?o
0000ooooooooool0DOooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Cooooo1_l0
000Qooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o0000
ooooooooool08oooool01?l0003oooooo`000?l0000Rooooo`03o`000?oooooooooo0?oooooo@?oo
ool009Wooooo00?o0000ooooooooool08_ooool2o`0002?ooooo00?o0000ooooooooool0oooooom1
ooooo`00V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Oooooo`;o00008_ooool00ol0003o
ooooooooo`3ooooood?ooooo002Looooo`03o`000?oooooooooo01gooooo00?o0000ooooool00000
0_l0000Oooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool06ooo
ool01?l0003oooooooooool0000Pooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o
0000ooooooooool06Oooool01Ol0003ooooooooooooooooo000001oooooo00?o0000ooooooooool0
oooooom6ooooo`00Woooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?ooooooBoooool00:Cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`07ooooo`?o00005oooool00ol0003ooooooooo
o`3oooooodcooooo002Uooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool00:Kooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool0
1Ol0003ooooooooooooooooo000000oooooo00?o0000ooooooooool04Oooool4o`000?ooooooDOoo
ool00:_ooooo00?o0000ooooool000004?ooool00ol0003oooooooooo`0;ooooo`Ko00000oooool0
0ol0003oooooooooo`3oooooodoooooo002/ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool02?ooool3o`0000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooo
odoooooo002[ooooo`03o`000?oooooo0000013ooooo0ol00008ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooodkooooo002Zooooo`05o`00
0?ooooooooooooooool000003oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;o
oooo1Ol00003ooooo`03o`000?oooooooooo0?ooooooC_ooool00:Wooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Sooooo00Co0000oooooooooooo
oooo0_l00004ooooo`04o`000?ooooooooooo`000?ooooooD?ooool00:Sooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Sooooo00Ko0000oooooooo
oooo0000ooooool00004ooooo`04o`000?ooooooooooo`000?ooooooD?ooool00:Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo0_l00000
0ooooooo0000ooooo`06o`0000;ooooo00?o0000ooooooooool0oooooom=ooooo`00Y_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`02o`0000Cooooo00?o0000ooooool000000_l0003oooooodoooooo002Uooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o
000000?oooooo`000?l000001ol0003ooooooe;ooooo002Tooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000Ko0000
0oooool00ol0003oooooooooo`3ooooooe3ooooo002Sooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool01_ooool3o`0000Kooooo00?o0000ooooooooool00_l00002ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool0oooooom@ooooo`00X_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooom?ooooo`00XOooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooom?oooo
o`00X?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`08ooooo`Oo0000oooooomAooooo`00Woooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooooooool9o`000003ooooool0003ooooo00;ooooo0_l0003ooooooe3ooooo002Nooooo`03o`00
0?oooooooooo01Wooooo00Co0000oooooooooooooooo2Ol00008ooooo`03o`000?oooooo000000Co
oooo00?o0000ooooooooool0oooooom>ooooo`00WOooool00ol0003oooooooooo`0=ooooo`?o0000
1?ooool2o`000003ooooool0003o000000Ko00000_ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0oooooom>ooooo`00W?ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooo000000Ko00001Oooool01Ol0003oooooo`000?oooooo000000oooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooodkooooo002Kooooo`03o`000?oo
oooooooo00[ooooo2?l00003ooooo`04o`000?ooooooooooo`0000Kooooo0ol0000Aooooo`05o`00
0?ooooooooooooooool00000oooooomAooooo`00V_ooool00ol0003oooooooooo`03ooooo`So0000
1_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0000>ooooo`;o
000000?oooooo`000?l00000oooooomAooooo`00U?ooool2o`0000;ooooo2?l0000>ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`0?ooooo`Go
0000oooooomBooooo`00Toooool6o`0001Cooooo0_l00004ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool01_ooool9o`000?ooooooEoooool009;ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00?ooooo0_l00008ooooo`Wo0000
oooooomPooooo`00TOooool00ol0003oooooooooo`02ooooo`;o00007Oooool:o`000?ooooooJ?oo
ool0097ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo017ooooo2Ol0
0009ooooo`03o`000?oooooooooo0?ooooooI_ooool009;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`08ooooo`Wo00004_ooool00ol0003oooooooooo`3oooooofKooooo002Boooo
o`?o000000?oooooo`000?l000000_ooool9o`0001_ooooo00?o0000ooooooooool0oooooomVoooo
o`00UOooool5o`0002Cooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?o
oooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o
00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oo
oooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool0
1?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25344 .0961 .00609 0 365.73 arc
s
newpath
.37328 .07436 .00609 0 365.73 arc
s
newpath
.36787 .05438 .00609 0 365.73 arc
s
.25235 .09011 m
.3722 .06837 L
s
.25452 .10209 m
.37437 .08035 L
s
.37916 .07277 m
.37374 .05278 L
s
.3674 .07596 m
.36199 .05597 L
s
.38064 .05561 m
.37702 .03978 L
s
.35327 .04523 m
.3569 .06106 L
s
.25344 .0961 m
.33351 .00432 L
s
.38064 .05561 m
.3569 .06106 L
s
.37702 .03978 m
.35327 .04523 L
s
.38064 .05561 m
.36787 .05438 L
s
.3569 .06106 m
.36787 .05438 L
s
newpath
.33351 .00432 .00457 0 365.73 arc
s
newpath
.33351 .00432 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo002nooooo`;o0000oooooomWooooo`004_ooooooo`000?oo00002Ol0000=ooooo`00
5_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool2o`0001?ooooo00?o0000ooooooooool04Oooool2o`000003ooooool0003ooooo017ooooo
00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo013ooooo00?o
0000ooooool000000_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo000F
ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0S
ooooo`Go00008oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05;ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo01Cooooo002Hoooo
o`03o`000?oooooooooo02;ooooo1?l0000Sooooo`03o`000?oooooooooo0?oooooo@?ooool009Wo
oooo00?o0000ooooooooool08?ooool00ol0003oooooo`00000Tooooo`03o`000?oooooooooo0?oo
oooo@Oooool009[ooooo00?o0000ooooooooool07_ooool01?l0003oooooooooool0000Sooooo`03
o`000?oooooooooo0?oooooo@_ooool009_ooooo00?o0000ooooooooool07?ooool01Ol0003ooooo
oooooooooooo000002;ooooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003ooooo
ooooo`0Jooooo`03o`000?oooooooooo00;ooooo0ol0000Oooooo`03o`000?oooooooooo0?oooooo
A?ooool009gooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo01kooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3o
ooooodKooooo002Oooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Iooooo`03o`000?oo
oooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo0ol0000Gooooo`03o`000?oooooooooo
0?ooooooC?ooool00:Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00Y_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool05Oooool00ol0003ooooo
ooooo`3oooooodkooooo002Wooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo01;ooooo0ol0003o
oooooe7ooooo002Yooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0>ooooo`Go000000?oooooo`000?ooool0oooooom@ooooo`00Z_ooool01?l0003o
ooooooooool0000@ooooo`03o`000?oooooooooo00[ooooo1?l00003ooooo`04o`000?oooooooooo
o`000?ooooooDOooool00:_ooooo0_l0000Aooooo`03o`000?oooooooooo00Sooooo0_l00006oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooom>ooooo`00Zoooool2o`00017o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0oooooom>ooooo`00Z_ooool01?l0003oooooooooool0000@ooooo`?o
00002?ooool00ol0003oooooooooo`02ooooo`Go00000oooool00ol0003oooooooooo`3oooooodko
oooo002Yooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`09ooooo`05o`000?ooooooooooooooool000001?ooool01?l0003oooooooooool0003ooooo
oe3ooooo002Yooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`09ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000ooooooooooooooooo`00003o
ooooodoooooo002Xooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`09ooooo`05o`000?oooooo0000o`000?ooool02Ol0003oooooodoooooo002Woooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09oooo
o`;o000000?oooooo`000?l000000_ooool4o`000?ooooooD_ooool00:Kooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo2Ol000000ooooooo
0000ooooo`3ooooooe7ooooo002Uooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000;o00000_ooool01Ol0003ooooo
oooooooooooo00000?ooooooD_ooool00:Cooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo0?ooooooD?ooool00:?ooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`06ooooo`?o00001_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0oooooom?ooooo`00Xoooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooom?ooooo`00X_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`07ooooo`Oo0000oooooomAooooo`00XOooool00ol0003oooooooooo`0Dooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`Ko
000000?oooooo`000?ooool00_ooool2o`000?ooooooD?ooool00:3ooooo00?o0000ooooooooool0
5_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo1ol00005ooooo`03o`00
0?oooooo000000?ooooo0_l0003ooooooe3ooooo002Oooooo`03o`000?oooooooooo01Sooooo00Co
0000oooooooooooooooo1_l0000<ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
oooooom>ooooo`00W_ooool00ol0003oooooooooo`0<ooooo`?o00001?ooool2o`0000?ooooo1_l0
0002ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`3oooooodkooooo002Mooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool00_ooool6
o`0000?ooooo00Go0000ooooool0003oooooo`00000@ooooo`;o000000?oooooo`000?l00000oooo
oomAooooo`00W?ooool00ol0003oooooooooo`0>ooooo`Oo00000_ooool00ol0003oooooooooo`04
ooooo`?o00004Oooool4o`000?ooooooD_ooool009cooooo00?o0000ooooooooool02Oooool5o`00
0003ooooool0003ooooo00?ooooo00Co0000oooooooooooo00001oooool5o`0000Wooooo1Ol0003o
oooooeKooooo002Kooooo`03o`000?oooooooooo00Cooooo1_l00006ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`05ooooo`Ko0000oooooomK
ooooo`00V_ooool00ol0003oooooo`000005o`0000_ooooo0_l00004ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooool000001Ol0003oooooof7ooooo002Gooooo`Go00004_ooool00ol0
003oooooooooo`03ooooo`;o00001Oooool5o`000?ooooooIoooool009Cooooo0ol000000ooooooo
0000ooooo`0Kooooo`Ko00000oooool00ol0003oooooooooo`3oooooofKooooo002Cooooo`05o`00
0?ooooooooooooooool000005oooool6o`0000Wooooo00?o0000ooooooooool0oooooomVooooo`00
Toooool00ol0003oooooooooo`02o`0001;ooooo1Ol0000?ooooo`03o`000?oooooooooo0?oooooo
I_ooool009;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`09ooooo`Ko0000
5?ooool00ol0003oooooooooo`3oooooofKooooo002Booooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool6o`0001[ooooo0ol0003oooooofKooooo002Cooooo`06o`000?oooooo
ooooooooool0003ooooo1Ol0000Pooooo`03o`000?oooooooooo0?ooooooI_ooool009?ooooo0_l0
00001?oooooo0000o`000?l0000Uooooo`03o`000?oooooooooo0?ooooooI_ooool009Gooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool00002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`00
0?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]
ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5
o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003o
ooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003ooooo
ofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25463 .10159 .00609 0 365.73 arc
s
newpath
.37269 .07162 .00609 0 365.73 arc
s
newpath
.36804 .05144 .00609 0 365.73 arc
s
.25313 .09569 m
.37119 .06571 L
s
.25613 .10749 m
.37418 .07752 L
s
.37862 .07025 m
.37398 .05007 L
s
.36675 .07298 m
.36211 .0528 L
s
.38083 .05253 m
.37702 .03674 L
s
.35334 .04245 m
.35715 .05824 L
s
.25463 .10159 m
.3284 .00467 L
s
.38083 .05253 m
.35715 .05824 L
s
.37702 .03674 m
.35334 .04245 L
s
.38083 .05253 m
.36804 .05144 L
s
.35715 .05824 m
.36804 .05144 L
s
newpath
.3284 .00467 .00457 0 365.73 arc
s
newpath
.3284 .00467 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool00_l0000Dooooo`03o`00
0?oooooooooo017ooooo0_l0000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
5?ooool001Kooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooool000004_ooool00ol0003oooooooooo`0=ooooo`;o000000Co
ooooo`000?oooooo00005?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo000001Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool07oooool4o`000003ooooool0
003ooooo02Gooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool0
0ol0003oooooooooo`0Oooooo`Go00009Oooool00ol0003oooooooooo`3ooooood3ooooo002Ioooo
o`03o`000?oooooooooo01kooooo00Go0000ooooooooooooooooo`00000Tooooo`03o`000?oooooo
oooo0?oooooo@Oooool009[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool08?ooool00ol0003o
ooooooooo`3ooooood?ooooo002Looooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0
0oooool3o`0001oooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`3oooooodGooooo002Nooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000oooo
ooooool05?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Jooooo`03o`00
0?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02Oooool3o`0001Oooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo01;ooooo0ol0
003ooooooe7ooooo002Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0>ooooo`Co000000?oooooo`000?l00000oooooomAooooo`00ZOooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool02_ooool4o`00
00Cooooo00?o0000ooooool00000oooooomAooooo`00Z_ooool01?l0003oooooooooool0000@oooo
o`03o`000?oooooooooo00Sooooo0_l00007ooooo`05o`000?ooooooooooooooool00000oooooom@
ooooo`00Zoooool2o`00017ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04oooo
o`?o00000oooool00ol0003oooooooooo`3oooooodkooooo002/ooooo`03o`000?oooooooooo00oo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`02ooooo`?o00000_ooool01?l0003o
ooooooooool0003ooooooe3ooooo002[ooooo`03o`000?oooooo0000013ooooo0ol00009ooooo`04
o`000?ooooooooooooooo`;o00000oooool01?l0003oooooooooool0003ooooooe3ooooo002Zoooo
o`05o`000?ooooooooooooooool000003oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00So00000_ooool00ol0003oooooooooo`3oooooodgooooo002Yooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00;o00001?ooool00ol0003oooooo`000002o`000?ooooooCoooool00:Wooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooool0
00000ol000000ooooooo0000o`000002o`000?ooooooD_ooool00:Sooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo1ol00002ooooo`03o`00
0?oooooooooo0?ooooooD?ooool00:Oooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo0ol000000ooooooo0000ooooo`04ooooo`03o`000?oo
oooooooo0?ooooooD?ooool00:Kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Kooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooCoooool00:Gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`06ooooo`?o00001_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooom?ooooo`00Y?ooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`06ooooo`Oo0000oooooomAooooo`00Xoooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`Co000000?o
ooooo`000?ooool00_ooool2o`000?ooooooD?ooool00:?ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooooooo1?l0
0004ooooo`03o`000?oooooooooo00;ooooo0_l0003ooooooe3ooooo002Rooooo`03o`000?oooooo
oooo01Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`Go00002?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooC_ooool00:7ooooo00?o0000oooo
ooooool05_ooool01_l0003ooooooooooooooooo0000ooooo`Co00003?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo0?ooooooC_ooool00:3ooooo00?o0000ooooooooool02_ooool3
o`0000Cooooo0_l00005ooooo`Go000000?oooooo`000?ooool03Oooool3o`000003ooooool0003o
00000?ooooooDOooool009oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooo`000?ooool01Ol000001?oooooo0000ooooool0000Aooooo`?o0000oooo
oomBooooo`00Woooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo1Ol00005
ooooo`?o00003_ooool4o`000?ooooooEOooool009kooooo00?o0000ooooooooool03Oooool6o`00
00;ooooo00?o0000ooooooooool01Oooool5o`0000Oooooo1?l0003ooooooeWooooo002Mooooo`03
o`000?oooooooooo00_ooooo1?l00004ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool01Oooool4o`000?ooooooGOooool009cooooo00?o0000ooooooooool02?ooool4o`0000;o
oooo0_l00004ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01Ol0003ooooo
of7ooooo002Looooo`03o`000?oooooooooo00Cooooo1?l00007ooooo`03o`000?oooooooooo00?o
oooo0_l00007ooooo`Co0000oooooomVooooo`00Voooool01?l0003oooooooooooooool4o`0001Ko
oooo1?l000000ooooooo0000ooooo`3oooooofOooooo002Jooooo`Go00005_ooool4o`0000Gooooo
00?o0000ooooooooool0oooooomVooooo`00Uoooool4o`0001Kooooo1?l00009ooooo`03o`000?oo
oooooooo0?ooooooI_ooool009Gooooo0ol000000ooooooo0000ooooo`0Booooo`Co00003Oooool0
0ol0003oooooooooo`3oooooofKooooo002Dooooo`05o`000?ooooooooooooooool000004?ooool4
o`00017ooooo0ol0003oooooofKooooo002Cooooo`04o`000?ooooooooooooooo`;o00002oooool5
o`0001Gooooo00?o0000ooooooooool0oooooomVooooo`00T_ooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooooooool01?ooool4o`0001[ooooo00?o0000ooooooooool0oooooomV
ooooo`00T_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co00007_ooool00ol0
003oooooooooo`3oooooofKooooo002Cooooo`?o000000?oooooo`000?l000000ol0000Rooooo`03
o`000?oooooooooo0?ooooooI_ooool009Kooooo0_l0000Vooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`00
0?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000
oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25648 .10781 .00609 0 365.73 arc
s
newpath
.37176 .06851 .00609 0 365.73 arc
s
newpath
.36827 .0481 .00609 0 365.73 arc
s
.25451 .10205 m
.3698 .06274 L
s
.25844 .11358 m
.37373 .07427 L
s
.37776 .06748 m
.37427 .04707 L
s
.36576 .06953 m
.36227 .04912 L
s
.38108 .04903 m
.37708 .03329 L
s
.35347 .03929 m
.35747 .05503 L
s
.25648 .10781 m
.32237 .00537 L
s
.38108 .04903 m
.35747 .05503 L
s
.37708 .03329 m
.35347 .03929 L
s
.38108 .04903 m
.36827 .0481 L
s
.35747 .05503 m
.36827 .0481 L
s
newpath
.32237 .00537 .00457 0 365.73 arc
s
newpath
.32237 .00537 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00_l00002ooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oo
oooooooo00[ooooo0_l000001?oooooo0000o`000?l00002ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04?ooool00ol0003oooooo`00000Dooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo01cooooo0_l000001?oooooo0000ooooool00002ooooo`03o`00
0?oooooooooo02Cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`00
0?oooooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?oo
ool00ol0003oooooooooo`0Looooo`Co00000oooool00ol0003oooooooooo`0Sooooo`03o`000?oo
oooooooo0?oooooo@?ooool009Wooooo00?o0000ooooooooool06oooool00ol0003oooooo`000004
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00V_ooool00ol0
003oooooooooo`0Jooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`06ooooo`?o00007oooool00ol0003ooooo
ooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000
ooooooooool04oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool0oooooom6ooooo`00Woooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0oooooom9ooooo`00X_oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?ooooooBoooool0
0:Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`?o00005oooool00ol0
003oooooooooo`3oooooodcooooo002Uooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02oooool00ol0003oooooooooo`0Booooo`?o000000?oooooo`000?ooool0oooooom>ooooo`00
Y_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3_ooool4o`0000;ooooo0_l0003ooooooe3ooooo002Wooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0:ooooo`Co00001_ooool00ol0003ooooooooo
o`3oooooodoooooo002Xooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`08ooooo`;o00002Oooool00ol0003oooooo`00003ooooooe3ooooo002Yoooo
o`05o`000?ooooooooooooooool000004?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Cooooo1?l00002ooooo`03o`000?oooooooooo0?ooooooC_ooool00:[ooooo00?o0000oooo
ool000004Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo0_l00002oooo
o`;o00000_ooool00ol0003oooooooooo`3oooooodkooooo002[ooooo`;o00004Oooool00ol0003o
ooooooooo`09ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooo`000002oooo
o`03o`000?oooooooooo0?ooooooC_ooool00:_ooooo0_l0000Aooooo`03o`000?oooooooooo00Wo
oooo00Co0000oooooooooooo00000_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooooooool0oooooom=ooooo`00Zoooool00ol0003oooooo`00000@ooooo`?o00002Oooool01Ol0
003oooooooooool0003ooooo00Wo0000oooooom?ooooo`00Z_ooool01Ol0003ooooooooooooooooo
000000oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02o`0000;ooooo1?l0003o
oooooe;ooooo002Yooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0:ooooo`Ko000000Coooooo`000?l0003o0000oooooomBooooo`00ZOooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool3o`00
00;ooooo0_l00002ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Sooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooo
oooo00001Oooool00ol0003oooooooooo`3ooooooe3ooooo002Wooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`05o`000?oooooooooooooo
ool000001_ooool00ol0003oooooooooo`3oooooodoooooo002Wooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooodoooooo002Vooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooool000001Ol0003ooooooe7ooooo002Uooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool01_ooool3o`0000Kooooo00?o0000ooooooooool00ooo
ool5o`0000?ooooo00?o0000ooooooooool0oooooom?ooooo`00YOooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool01?l0003ooooooooooooo
ool3o`0000;ooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooCoooool00:Cooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooool000000_l00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooom?
ooooo`00Y?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool00oooool3o`0000Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooo
odoooooo002Sooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`03o`0000cooooo0_l000000ooooooo0000o`00003ooooooe;ooooo002Rooooo`03o`00
0?oooooooooo01Gooooo00Co0000oooooooooooooooo0ol000000ooooooo0000ooooo`0>ooooo`;o
0000oooooomCooooo`00X_ooool00ol0003oooooooooo`08ooooo`?o00001?ooool2o`0000Gooooo
1?l00002ooooo`03o`000?oooooooooo00_ooooo0ol0003ooooooeGooooo002Qooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool00_ooool01Ol0003oooooooooool0003ooooo00?o0000
00Koooooo`000?oooooo0000ooooool0000;ooooo`?o0000oooooomHooooo`00X?ooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000000_l00005ooooo`?o
00002Oooool3o`000?ooooooFoooool00:3ooooo00?o0000ooooooooool02oooool01?l0003ooooo
ooooooooool3o`000003ooooool0003ooooo00Kooooo1Ol00003ooooo`?o0000oooooomNooooo`00
Woooool00ol0003oooooooooo`0<ooooo`Co000000Goooooo`000?ooooooooooo`000007ooooo`03
o`000?oooooooooo00;ooooo0ol0003oooooof7ooooo002Nooooo`03o`000?oooooooooo00_ooooo
0ol00004ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooool000000_l0003oooooofCo
oooo002Nooooo`03o`000?oooooooooo00Sooooo0ol00002ooooo`03o`000?oooooooooo00?ooooo
0_l00007ooooo`?o0000oooooomWooooo`00WOooool00ol0003oooooooooo`06ooooo`?o00004Ooo
ool3o`000003ooooool0003ooooo0?ooooooIoooool009cooooo00?o0000ooooooooool01?ooool3
o`00017ooooo0ol00004ooooo`03o`000?oooooooooo0?ooooooI_ooool009cooooo00Co0000oooo
oooooooooooo0ol0000Aooooo`?o00001oooool00ol0003oooooooooo`3oooooofKooooo002Koooo
o`03o`000?oooooo000000;o00004Oooool3o`0000[ooooo00?o0000ooooooooool0oooooomVoooo
o`00V_ooool3o`00017ooooo0ol0000=ooooo`?o0000oooooomVooooo`00Uoooool4o`00013ooooo
0ol0000@ooooo`03o`000?oooooooooo0?ooooooI_ooool009Kooooo1?l0000>ooooo`?o00004ooo
ool00ol0003oooooooooo`3oooooofKooooo002Dooooo`;o00000oooool00ol0003oooooooooo`09
ooooo`?o00005_ooool00ol0003oooooooooo`3oooooofKooooo002Dooooo`04o`000?oooooooooo
ooooo`;o00002?ooool3o`0001Wooooo00?o0000ooooooooool0oooooomVooooo`00Toooool01Ol0
003ooooooooooooooooo000000;ooooo00?o0000ooooooooool00_ooool3o`0001cooooo00?o0000
ooooooooool0oooooomVooooo`00Toooool00ol0003oooooooooo`04ooooo`03o`000?oooooo0000
00;o00007oooool00ol0003oooooooooo`3oooooofKooooo002Dooooo`03o`000?oooooooooo00;o
oooo0ol0000Rooooo`03o`000?oooooooooo0?ooooooI_ooool009Cooooo0_l00002ooooo`;o0000
9?ooool3o`000?ooooooI_ooool009Kooooo0_l0000Vooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000
oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_oooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000
ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003o
ooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25887 .114 .00609 0 365.73 arc
s
newpath
.37056 .06541 .00609 0 365.73 arc
s
newpath
.36853 .04481 .00609 0 365.73 arc
s
.25644 .10841 m
.36814 .05983 L
s
.2613 .11958 m
.37299 .071 L
s
.37663 .06482 m
.37459 .04421 L
s
.3645 .06601 m
.36247 .0454 L
s
.38135 .04559 m
.37717 .0299 L
s
.35363 .03617 m
.35781 .05187 L
s
.25887 .114 m
.31614 .0065 L
s
.38135 .04559 m
.35781 .05187 L
s
.37717 .0299 m
.35363 .03617 L
s
.38135 .04559 m
.36853 .04481 L
s
.35781 .05187 m
.36853 .04481 L
s
newpath
.31614 .0065 .00457 0 365.73 arc
s
newpath
.31614 .0065 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo00Sooooo1?l00006ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo00Sooooo00Co
0000oooooooooooo00001_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo013ooooo
00?o0000ooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`0Iooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0Tooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o0000
ooooooooool06?ooool6o`0000Gooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`3o
oooood3ooooo002Iooooo`03o`000?oooooooooo01Sooooo1?l00006ooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool0oooooom1ooooo`00V_ooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3ooooood;o
oooo002Kooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`0Pooooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool05?oo
ool00ol0003oooooooooo`08ooooo`?o00007oooool00ol0003oooooooooo`3oooooodCooooo002M
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooom6oooo
o`00Woooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?oooooo
B?ooool00:7ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3o
oooood[ooooo002Sooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0Booooo`?o00000oooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool3o`0000kooooo1?l00002ooooo`04
o`000?ooooooooooo`000?ooooooC_ooool00:Gooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo00[ooooo1?l00006ooooo`03o`000?oooooo00000?oo
ooooCoooool00:Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00Sooooo0_l0000;ooooo`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool2o`000?ooooooD?ooool00:Sooooo00Go0000ooooooooooooooooo`00
000Aooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool4o`000004ooooool0
003oooooo`000?ooooooD?ooool00:Wooooo00Co0000oooooooooooo00004Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000002ooooo`03
o`000?oooooooooo0?ooooooC_ooool00:[ooooo0_l0000Booooo`03o`000?oooooooooo00Wooooo
00Go0000ooooooooooooooooo`000003ooooo`?o00000_ooool00ol0003oooooooooo`3oooooodgo
oooo002[ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool02Oooool01?l0003ooooo
ooooool00002ooooo`So0000oooooom?ooooo`00Z_ooool00ol0003oooooo`00000Aooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool02?l0003ooooooe;ooooo002Zooooo`04o`000?oo
ooooooooo`00013ooooo0ol0000:ooooo`Ko000000Coooooo`000?l0003o0000oooooomBooooo`00
ZOooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
2_ooool4o`0000;ooooo00Co0000oooooooooooo0000oooooomBooooo`00ZOooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool2o`0000Gooooo
00?o0000ooooooooool0oooooom@ooooo`00Z?ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02oooool00ol0003oooooo`000006ooooo`03o`000?oo
oooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00001_ooool00ol0003ooooooooo
o`3oooooodoooooo002Wooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`09ooooo`05o`000?ooooooooooooooool000000_ooool3o`000003ooooool0
003ooooo0?ooooooD?ooool00:Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool3o`0000?ooooo0_l0003o
oooooe7ooooo002Vooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo0ol00004ooooo`;o0000oooooomAoooo
o`00Y_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Kooooo0ol00006ooooo`03
o`000?oooooooooo00?o000000?oooooo`000?l000001Oooool00ol0003oooooooooo`3oooooodoo
oooo002Uooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`05ooooo`04o`000?oooooo0000o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0?oo
ooooCoooool00:Gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo0ol00007ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
oooooom@ooooo`00Y?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool3o`0000Wooooo1_l0003ooooooe;ooooo002Tooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03o`0000cooooo0ol0003o
oooooeCooooo002Sooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooooooo0ol00000
0ooooooo0000ooooo`09ooooo`?o0000oooooomGooooo`00Xoooool00ol0003oooooooooo`07oooo
o`?o00001?ooool2o`0000Gooooo00Co0000ooooool0003o00000_ooool00ol0003oooooooooo`07
ooooo`;o0000oooooomJooooo`00X_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00000oooool3o`000004ooooool0003oooooo`0000Sooooo0_l0
003ooooooecooooo002Rooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool0
1Ol0003oooooooooool0003ooooo00;o00000oooool3o`0000Oooooo0_l0003ooooooekooooo002Q
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
o`0000Kooooo1Ol000001?oooooo0000o`000?l0003oooooof3ooooo002Qooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool00_ooool4o`0000Oooooo00Co0000oooooooooooooooo0_l0
003oooooof?ooooo002Pooooo`03o`000?oooooooooo00[ooooo0_l00002ooooo`?o00000_ooool0
0ol0003oooooooooo`05ooooo`04o`000?oooooo0000o`000?ooooooIOooool00:3ooooo00?o0000
ooooooooool02oooool3o`0000?ooooo0_l00008ooooo`;o0000oooooomWooooo`00Woooool00ol0
003oooooooooo`0;ooooo`;o00003Oooool3o`000?ooooooJ?ooool009kooooo00?o0000oooooooo
ool02Oooool3o`0000cooooo0ol00002ooooo`03o`000?oooooooooo0?ooooooI_ooool009kooooo
00?o0000ooooooooool01oooool2o`0000gooooo0_l00005ooooo`03o`000?oooooooooo0?oooooo
I_ooool009gooooo00?o0000ooooooooool01_ooool2o`0000gooooo0_l00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool009gooooo00?o0000ooooooooool01?ooool2o`0000gooooo0_l00009
ooooo`?o0000oooooomVooooo`00W?ooool00ol0003oooooooooo`02ooooo`?o00003?ooool3o`00
00_ooooo00?o0000ooooooooool0oooooomVooooo`00W?ooool00ol0003oooooooooo`02o`0000go
oooo0_l0000>ooooo`03o`000?oooooooooo0?ooooooI_ooool009_ooooo00Co0000ooooool0003o
00003Oooool2o`00013ooooo00?o0000ooooooooool0oooooomVooooo`00V_ooool3o`0000gooooo
0_l0000Booooo`03o`000?oooooooooo0?ooooooI_ooool009Oooooo1?l0000<ooooo`?o00005?oo
ool00ol0003oooooooooo`3oooooofKooooo002Fooooo`;o000000?oooooo`000?l000002_ooool2
o`0001Oooooo00?o0000ooooooooool0oooooomVooooo`00U_ooool00ol0003oooooooooo`02o`00
00Sooooo0_l0000Iooooo`03o`000?oooooooooo0?ooooooI_ooool009Gooooo00Co0000oooooooo
oooooooo0_l00006ooooo`;o00006oooool3o`000?ooooooI_ooool009Gooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooooooool2o`0001gooooo00?o0000ooooooooool0oooooomV
ooooo`00UOooool00ol0003oooooooooo`03ooooo`Co00007oooool00ol0003oooooooooo`3ooooo
ofKooooo002Eooooo`?o000000Coooooo`000?l0003o00008_ooool00ol0003oooooooooo`3ooooo
ofKooooo002Hooooo`;o00009?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:go
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003
ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool0
1?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2
o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_
ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007
ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.262 .1204 .00609 0 365.73 arc
s
newpath
.369 .06221 .00609 0 365.73 arc
s
newpath
.36883 .0415 .00609 0 365.73 arc
s
.25909 .11505 m
.36609 .05686 L
s
.26491 .12575 m
.37191 .06756 L
s
.37509 .06216 m
.37492 .04145 L
s
.36291 .06226 m
.36274 .04155 L
s
.38166 .04213 m
.37728 .02649 L
s
.35382 .03306 m
.3582 .0487 L
s
.262 .1204 m
.30947 .00823 L
s
.38166 .04213 m
.3582 .0487 L
s
.37728 .02649 m
.35382 .03306 L
s
.38166 .04213 m
.36883 .0415 L
s
.3582 .0487 m
.36883 .0415 L
s
newpath
.30947 .00823 .00457 0 365.73 arc
s
newpath
.30947 .00823 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo00Gooooo0ol0000:ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool2o`0001Cooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Dooooo`005_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo00Cooooo1Ol0
0009ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04?ooool00ol0003oooooo`00
000Dooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo01Kooooo0_l00002
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`1A
ooooo`03o`000?oooooooooo01Cooooo002Hooooo`03o`000?oooooooooo01Gooooo00Go0000oooo
ool0003oooooo`000009ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0
ooooo`00VOooool00ol0003oooooooooo`0Dooooo`Go00002Oooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo0?oooooo@Oooool009[ooooo00?o0000ooooooooool05?ooool4o`0000Wo
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3ooooood;ooooo002Kooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0;ooooo`?o00007oooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo0?ooooooAOooool009kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo01?ooooo0_l0
0005ooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo013ooooo0ol000000ooooooo0000ooooo`03
ooooo`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo0ol00004ooooo`05o`000?oooooooooo
ooooool00000oooooom=ooooo`00Y?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00kooooo0ol0000:ooooo`?o00002?ooool00ol0003oooooo`00003oooooodkooooo002Uooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`08ooooo`;o
00002oooool2o`000?ooooooCoooool00:Kooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool3o`0000?ooooo
00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`06o`000?oo
ooooooooooooool0003ooooo0_l0003ooooooe3ooooo002Xooooo`04o`000?ooooooooooo`0001;o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooooooo
o`;o00000_ooool00ol0003oooooooooo`3oooooodgooooo002Yooooo`03o`000?oooooo000001;o
oooo00?o0000ooooooooool02Oooool01_l0003ooooooooooooooooo0000ooooo`So0000oooooom?
ooooo`00Z_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Wooooo00Co0000oooo
oooooooooooo0_l00002ooooo`Co0000oooooomAooooo`00Z_ooool2o`0001;ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`08o`000?ooooooD_ooool00:[ooooo00?o0000ooooool0
00004Oooool00ol0003oooooooooo`0:ooooo`Oo00000_ooool00ol0003oooooooooo`3ooooooe3o
oooo002Yooooo`05o`000?ooooooooooooooool000004?ooool3o`0000[ooooo0_l000000ooooooo
0000o`000004ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`3ooooooe3ooooo002Xooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`;o00001Oooool00ol0003ooooooooo
o`3ooooooe3ooooo002Xooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0oooooom@
ooooo`00Yoooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`05o`000003ooooool0003ooooo0?ooooooDOooool00:Oo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooool000000ol00003ooooo`;o0000oooooomBooooo`00Yoooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool3o`0000;ooooo
00?o0000ooooooooool00_ooool2o`000?ooooooD_ooool00:Kooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo0_l00004ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool0oooooom@ooooo`00Y_ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Kooooo0ol00006ooooo`;o00001Oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Gooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo0_l00008ooooo`;o000000?oooooo`00
0?l00000oooooomCooooo`00YOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00_ooool3o`0000_ooooo0_l0003ooooooeCooooo002Tooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02o`000003oooo
ool0003ooooo00Wooooo0_l0003ooooooeKooooo002Tooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool00_ooool3o`0000;ooooo00?o0000ooooooooool01oooool2o`000?ooooooF?oo
ool00:Cooooo00?o0000ooooooooool04oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`3ooooooeSooooo002Sooooo`03o`000?oooooo
oooo00Oooooo0ol00004ooooo`;o00001Oooool4o`0000;ooooo00?o0000ooooooooool01_ooool2
o`000?ooooooFoooool00:?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000?ooooo0ol000001?oooooo0000ooooool00007ooooo`;o0000oooo
oomMooooo`00X_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00Go0000
oooooooooooo0000ooooo`02o`0000?ooooo0ol00006ooooo`;o0000oooooomOooooo`00X_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_l00006
ooooo`Go000000?oooooo`000?l00000oooooomQooooo`00XOooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00;ooooo1?l00007ooooo`04o`000?ooooooooooooooo`;o0000oooooomS
ooooo`00XOooool00ol0003oooooooooo`09ooooo`;o00001?ooool01?l0003oooooooooool00007
ooooo`04o`000?ooooooooooo`000?ooooooIOooool00:7ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`02o`000003ooooool0003o000000Sooooo0ol0003oooooofKooooo002Poooo
o`03o`000?oooooooooo00cooooo0_l0000<ooooo`;o0000oooooomXooooo`00X?ooool00ol0003o
ooooooooo`0:ooooo`;o00003?ooool2o`000003ooooool0003ooooo0?ooooooIoooool009oooooo
00?o0000ooooooooool02Oooool2o`0000cooooo0_l00003ooooo`03o`000?oooooooooo0?oooooo
I_ooool009oooooo00?o0000ooooooooool01oooool2o`0000cooooo0_l00005ooooo`03o`000?oo
oooooooo0?ooooooI_ooool009kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00Gooooo0ol0003oooooofKooooo002Nooooo`03o`000?oooooooooo
00Gooooo0_l0000<ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002Nooooo`03
o`000?oooooooooo00?ooooo0_l0000<ooooo`;o00002_ooool00ol0003oooooooooo`3oooooofKo
oooo002Mooooo`03o`000?oooooooooo00;ooooo0_l0000<ooooo`;o00003?ooool00ol0003ooooo
ooooo`3oooooofKooooo002Mooooo`03o`000?oooooooooo00;o00003?ooool2o`0000kooooo00?o
0000ooooooooool0oooooomVooooo`00W?ooool01?l0003oooooo`000?l0000<ooooo`;o00004?oo
ool00ol0003oooooooooo`3oooooofKooooo002Looooo`;o00003Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo0?ooooooI_ooool009_ooooo0_l0000<ooooo`;o00004oooool00ol0
003oooooooooo`3oooooofKooooo002Iooooo`?o00002oooool2o`0001Gooooo0ol0003oooooofKo
oooo002Hooooo`Co00002Oooool2o`0001Oooooo00?o0000ooooooooool0oooooomVooooo`00Uooo
ool2o`000004ooooool0003oooooo`0000Kooooo0_l0000Iooooo`03o`000?oooooooooo0?oooooo
I_ooool009Oooooo00Ko0000oooooooooooo0000ooooool00004ooooo`;o00006oooool00ol0003o
ooooooooo`3oooooofKooooo002Fooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooo
oooo00007Oooool00ol0003oooooooooo`3oooooofKooooo002Fooooo`03o`000?oooooooooo00Co
oooo0ol0000Nooooo`03o`000?oooooooooo0?ooooooI_ooool009Oooooo0_l00002ooooo`?o0000
8?ooool00ol0003oooooooooo`3oooooofKooooo002Iooooo`?o00008_ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5
o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oo
oooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?oo
ooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool0
1Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003ooooooooo
ool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oo
oooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooo
oomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26648 .1277 .00609 0 365.73 arc
s
newpath
.36676 .05856 .00609 0 365.73 arc
s
newpath
.3692 .038 .00609 0 365.73 arc
s
.26302 .12268 m
.3633 .05355 L
s
.26993 .13271 m
.37022 .06358 L
s
.37281 .05928 m
.37525 .03872 L
s
.36071 .05785 m
.36315 .03728 L
s
.38203 .0384 m
.37738 .02284 L
s
.35404 .02982 m
.35869 .04538 L
s
.26648 .1277 m
.30172 .0111 L
s
.38203 .0384 m
.35869 .04538 L
s
.37738 .02284 m
.35404 .02982 L
s
.38203 .0384 m
.3692 .038 L
s
.35869 .04538 m
.3692 .038 L
s
newpath
.30172 .0111 .00457 0 365.73 arc
s
newpath
.30172 .01111 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Cooooo`?o00003_ooool00ol0003oooooooooo`0T
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`1A
ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o0000oooo
ooooool04Oooool2o`0000;ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo0?oooooo@?ooool009Wooooo00?o0000ooooooooool04?ooool01Ol0003o
ooooo`000?oooooo000000gooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3ooooo
od7ooooo002Jooooo`03o`000?oooooooooo00oooooo00Go0000ooooool0003oooooo`00000=oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003o
ooooooooo`0>ooooo`Go00003Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo0?oo
oooo@oooool009cooooo00?o0000ooooooooool03_ooool2o`0000oooooo0ol0000Oooooo`03o`00
0?oooooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`0Cooooo`;o00001oooool00ol0003oooooooooo`3ooooo
odOooooo002Pooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0@ooooo`?o000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`3oooooodSo
oooo002Qooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03oooool00ol0003ooooo
ooooo`0=ooooo`?o00001Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?oooooo
BOooool00:;ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00[ooooo0ol00008ooooo`05o`000?ooooooooooooooool00000oooooom<ooooo`00Xooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool02?oo
ool2o`0000_ooooo00Co0000oooooooooooo0000oooooom=ooooo`00Y?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo013ooooo0ol00008ooooo`03o`000?oooooooooo00Cooooo0ol0
0004ooooo`;o0000oooooom>ooooo`00YOooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`3oooooodgooooo002Vooooo`05o`000?oooooo
ooooooooool000004oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00Go
0000ooooooooooooooooo`000002ooooo`;o0000oooooom?ooooo`00Yoooool01?l0003ooooooooo
ool0000Cooooo`03o`000?oooooooooo00Wooooo00Ko0000ooooooooooooooooo`000?ooool9o`00
0?ooooooC_ooool00:Sooooo00?o0000ooooool000004oooool00ol0003oooooooooo`09ooooo`04
o`000?ooooooooooooooo`;o00000oooool3o`000?ooooooDOooool00:Wooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00So0000oooooomBooooo`00
ZOooool2o`0001?ooooo00?o0000ooooooooool02_ooool5o`000003ooooool0003o000000;o0000
oooooomBooooo`00ZOooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo00[ooooo0_l0
00001Ooooooo0000oooooooooooo000000;ooooo00?o0000ooooooooool0oooooom@ooooo`00ZOoo
ool01?l0003oooooooooool0000Aooooo`03o`000?oooooooooo00gooooo00?o0000ooooool00000
0oooool00ol0003oooooooooo`3ooooooe3ooooo002Xooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool03_ooool3o`0000cooooo00?o0000ooooool000001?ooool00ol0003ooooooooo
o`3ooooooe3ooooo002Xooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0<ooooo`;o00001?ooool00ol0003oooooooooo`3ooooooe7ooooo002Xoooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<oooo
o`Go000000?oooooo`000?ooool0oooooomBooooo`00Yoooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00_ooooo00?o0000ooooooooool02oooool3o`0000?ooooo0_l0003ooooooe?o
oooo002Wooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`09ooooo`;o000000?oooooo`000?l000000oooool2o`000?ooooooDoooool00:Oooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0_l0
0002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomAooooo`00Y_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool3
o`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe7ooooo002Voooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooo000000Cooooo0ol000000ooooooo0000o`00003ooooooeCooooo002Vooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool01_ooool3o`0000Cooooo00?o0000ooooool0
00002?ooool2o`000?ooooooEOooool00:Kooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00;ooooo0_l000000ooooooo0000ooooo`07ooooo`03o`00
0?oooooooooo0?ooooooEOooool00:Gooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`;o0000
oooooomHooooo`00YOooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00?ooooo00Co
0000ooooool0003o00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
F?ooool00:Gooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`;o00000ooo
ool00ol0003oooooooooo`04ooooo`;o0000oooooomKooooo`00Y?ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo00;o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?ooooooFoooool00:Cooooo00?o0000ooooooooool01_ooool3o`0000Cooooo0_l00005oooo
o`;o000000Goooooo`000?ooooooooooo`000006ooooo`03o`000?oooooooooo0?ooooooG?ooool0
0:Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000?ooooo0ol000001?oooooo0000ooooool00005ooooo`;o0000oooooomOooooo`00Y?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooooooool3o`0000Gooooo00?o0000ooooooooool0oooooomOooooo`00Xooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo00Ko0000oooooooooooo0000
ooooool00005ooooo`Oo0000oooooomRooooo`00Xoooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_l00006ooooo`05o`000?ooooooooooooooool0
0000oooooomTooooo`00Xoooool00ol0003oooooooooo`07ooooo`;o00001?ooool01?l0003ooooo
o`000?l00007ooooo`04o`000?oooooo0000o`000?ooooooIOooool00:;ooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`02ooooo`?o00002?ooool2o`000?ooooooIoooool00:;ooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`08ooooo`;o0000oooooomXooooo`00X_oo
ool00ol0003oooooooooo`0;ooooo`;o00002_ooool00ol0003oooooo`00003oooooofSooooo002Q
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02?ooool2o`0000;ooooo00?o0000
ooooooooool0oooooomVooooo`00XOooool00ol0003oooooooooo`09ooooo`;o00002_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooI_ooool00:7ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`;o00001Oooool3o`000?ooooooI_ooool00:7ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00X?ooool00ol0003oooooooooo`06ooooo`;o00002_oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooI_ooool00:3ooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`08ooooo`;o00002Oooool00ol0003oooooooooo`3o
ooooofKooooo002Pooooo`03o`000?oooooooooo00?ooooo0_l0000:ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool0oooooomVooooo`00Woooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Sooooo0_l0000<ooooo`03o`000?oooooooooo0?ooooooI_ooool009oooooo
00Co0000oooooooooooooooo0_l0000:ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0oooooomVooooo`00Woooool01?l0003oooooooooool0000:ooooo`;o00003oooool00ol0003o
ooooooooo`3oooooofKooooo002Oooooo`?o00002_ooool00ol0003oooooooooo`0?ooooo`?o0000
oooooomVooooo`00W_ooool2o`0000[ooooo0_l0000Booooo`03o`000?oooooooooo0?ooooooI_oo
ool009kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo0?ooooooI_ooool009cooooo0ol00008ooooo`;o00005Oooool00ol0003oooooooooo`3ooooo
ofKooooo002Kooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`3oooooofKooooo002Jooooo`Co00001oooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo0?ooooooI_ooool009[ooooo00?o0000ooooooooool00_l00004ooooo`;o00006Ooo
ool00ol0003oooooooooo`3oooooofKooooo002Iooooo`06o`000?ooooooooooo`000?oooooo0000
0oooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooI_ooool009Wooooo00Co
0000oooooooooooo00000_ooool3o`0001cooooo00?o0000ooooooooool0oooooomVooooo`00VOoo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01cooooo0ol0003oooooofKooooo002I
ooooo`?o000000?oooooo`000?l000007oooool00ol0003oooooooooo`3oooooofKooooo002Loooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go0000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomToooo
o`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co0000
0oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27256 .13546 .00609 0 365.73 arc
s
newpath
.36372 .05468 .00609 0 365.73 arc
s
newpath
.36956 .03482 .00609 0 365.73 arc
s
.26852 .1309 m
.35968 .05012 L
s
.2766 .14002 m
.36776 .05924 L
s
.36956 .0564 m
.3754 .03653 L
s
.35788 .05296 m
.36372 .0331 L
s
.3824 .03484 m
.3773 .01943 L
s
.35417 .02708 m
.35927 .0425 L
s
.27256 .13546 m
.29348 .01547 L
s
.3824 .03484 m
.35927 .0425 L
s
.3773 .01943 m
.35417 .02708 L
s
.3824 .03484 m
.36956 .03482 L
s
.35927 .0425 m
.36956 .03482 L
s
newpath
.29348 .01547 .00457 0 365.73 arc
s
newpath
.29348 .01547 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0=ooooo`?o00004_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0?oo
oooo@Oooool009[ooooo00?o0000ooooooooool02oooool5o`00017ooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`3ooooood;ooooo002Kooooo`03o`000?oooooooooo00Wooooo0_l0
0002ooooo`;o00004Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo0?oooooo@ooo
ool009cooooo00?o0000ooooooooool02?ooool2o`000004ooooool0003oooooo`00017ooooo0ol0
000Oooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000ooooooooool02?ooool4
o`0001;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Noooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Coooo
o`;o00002?ooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`?o000000?oooooo`000?oo
ool01_ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0=ooooo`?o00001Oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00[ooooo0ol00008ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02?ooool2o`0000Gooooo0ol00003
ooooo`05o`000?ooooooooooooooool00000oooooom<ooooo`00Xoooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooo`00003oooooodgooooo002T
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04_ooool3o`0000Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o0000oooooom>
ooooo`00YOooool01?l0003oooooooooool0000Eooooo`03o`000?oooooooooo00Wooooo00Go0000
ooooooooooooooooo`000005ooooo`04o`000?ooooooooooo`000?ooooooCoooool00:Kooooo00?o
0000ooooool000005Oooool00ol0003oooooooooo`09ooooo`06o`000?ooooooooooooooool0003o
oooo2Ol0003oooooodkooooo002Wooooo`;o00005Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00;o00001?ooool3o`000?ooooooD?ooool00:Sooooo00?o0000ooooooooool04ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooo000000Oo0000oooooomBooooo`00Z?ooool2
o`0001Cooooo00?o0000ooooooooool02_ooool00ol0003oooooo`000004o`000003ooooool0003o
00000?ooooooD_ooool00:Sooooo00?o0000ooooool000004oooool00ol0003oooooooooo`0;oooo
o`;o00001?ooool2o`000?ooooooDoooool00:Oooooo00Go0000ooooooooooooooooo`00000Boooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00003ooooo
oe?ooooo002Wooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`0;ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3ooooo
oe7ooooo002Wooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool3o`0000_o
oooo1Ol000000ooooooo0000ooooo`3ooooooe?ooooo002Wooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0:ooooo`;o000000Coooooo`000?oooooo
oooo0_l0003ooooooeCooooo002Wooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`09ooooo`Co00000oooool2o`000?ooooooE?ooool00:Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Sooooo00Co
0000ooooool0003o00001?ooool00ol0003oooooooooo`3ooooooe?ooooo002Vooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`07ooooo`04o`000?oo
ooooooooo`0000Gooooo00?o0000ooooooooool0oooooomCooooo`00Y_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01_ooool01Ol0003ooooooooo
ool0003ooooo00;o000000?oooooo`000?l00000oooooomFooooo`00Y_ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01Oooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooooooo0?ooooooE_ooool00:Kooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`3ooooooeOooooo002Vooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool01_ooool3o`0000;ooooo0_l00002ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0oooooomHooooo`00YOooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00Gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool0oooooomIooooo`00YOooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0?ooooooF_ooool00:Gooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3o
oooooe_ooooo002Uooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00_ooool2o`00
00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooecooooo002Uooooo`03
o`000?oooooooooo01;ooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?oooooooooo
ooooo`;o0000oooooomOooooo`00YOooool00ol0003oooooooooo`05ooooo`?o00001?ooool2o`00
00Gooooo00Co0000ooooool0003o00000_ooool01Ol0003ooooooooooooooooo00000?ooooooHOoo
ool00:Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000Cooooo0_l000001?oooooo0000ooooool00003ooooo`03o`000?oooooooooo0?oooooo
H?ooool00:Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000?ooooo00?o0000ooooooooool00ol00003ooooo`03o`000?oooooooooo0?oooooo
HOooool00:Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool00_ooool5o`000?ooooooI?ooool00:Cooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`06o`000?ooooooooooo`000?oooooo
00001Oooool01?l0003oooooooooool0003oooooofGooooo002Tooooo`03o`000?oooooooooo00Ko
oooo0_l00004ooooo`03o`000?oooooooooo00;o00001_ooool00ol0003oooooo`00003oooooofKo
oooo002Tooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00oooool3o`0000Oooooo
0_l0003oooooofOooooo002Sooooo`03o`000?oooooooooo00kooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`06
ooooo`?o0000oooooomXooooo`00Xoooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Kooooo00Co0000oooooooooooo0000oooooomXooooo`00Xoooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00Kooooo00Go0000ooooooooooooooooo`00003oooooofSooooo002Soooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02oooo
o`?o0000oooooomVooooo`00X_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo002Rooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:;ooooo00?o0000ooooooooool01oooool2o`0000Sooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002Rooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`;o00002Oooool00ol0003oooooooooo`3oooooofKooooo002Rooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:7ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool0oooooomVooooo`00XOooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02oooool3o`000?ooooooI_oo
ool00:7ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0oooooomVooooo`00XOooool00ol0003oooooooooo`02o`00
00Sooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3oooooofKooooo002Qooooo`03
o`000?oooooo000000Wooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`3oooooofKo
oooo002Qooooo`;o00002Oooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:3ooooo0_l00009ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0oooo
oomVooooo`00X?ooool00ol0003oooooooooo`06ooooo`;o00004oooool00ol0003oooooooooo`3o
ooooofKooooo002Oooooo`;o00001oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
0?ooooooI_ooool009kooooo00?o0000ooooool000001_ooool00ol0003oooooooooo`0Dooooo`03
o`000?oooooooooo0?ooooooI_ooool009gooooo1?l00005ooooo`03o`000?oooooooooo01Gooooo
0ol0003oooooofKooooo002Mooooo`05o`000?oooooo0000ooooool000000oooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo0?ooooooI_ooool009cooooo00Ko0000oooooooooooo0000
ooooool00002ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0oooooomVooooo`00
W?ooool01?l0003oooooooooool00002ooooo`;o00006_ooool00ol0003oooooooooo`3oooooofKo
oooo002Looooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06Oooool00ol0003ooooo
ooooo`3oooooofKooooo002Mooooo`;o000000?oooooo`000?l000007?ooool00ol0003ooooooooo
o`3oooooofKooooo002Oooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go
0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?oo
ooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.28094 .14365 .00609 0 365.73 arc
s
newpath
.35953 .05059 .00609 0 365.73 arc
s
newpath
.36973 .03257 .00609 0 365.73 arc
s
.27629 .13972 m
.35488 .04666 L
s
.28559 .14758 m
.36418 .05452 L
s
.36483 .05359 m
.37503 .03557 L
s
.35423 .04759 m
.36443 .02957 L
s
.38254 .03172 m
.37639 .01668 L
s
.35384 .0259 m
.35999 .04094 L
s
.28094 .14365 m
.285 .02191 L
s
.38254 .03172 m
.35999 .04094 L
s
.37639 .01668 m
.35384 .0259 L
s
.38254 .03172 m
.36973 .03257 L
s
.35999 .04094 m
.36973 .03257 L
s
newpath
.285 .02191 .00457 0 365.73 arc
s
newpath
.285 .02191 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00004oooool2
o`0000[ooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`04oooo
o`Co00005_ooool00ol0003oooooooooo`0@ooooo`?o000000?oooooo`000?ooool02?ooool00ol0
003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooo
oooo00005_ooool00ol0003oooooooooo`0>ooooo`;o00001Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooA_ooool009oooooo00So0000ooooooooooooooooo`000?oooooo
0000ooooo`;o00005Oooool00ol0003oooooooooo`0<ooooo`;o00001oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool01_l0000E
ooooo`03o`000?oooooooooo00Wooooo0ol00009ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0oooooom8ooooo`00XOooool00ol0003oooooooooo`04o`0001Kooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`04ooooo`Co00000oooool01Ol0003ooooooooooooooooo
00000?ooooooBoooool00:;ooooo00Co0000oooooooooooo00006?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooool000006?ooool0
0ol0003oooooooooo`09ooooo`04o`000?ooooooooooooooo`;o00001?ooool01_l0003ooooooooo
ool0003oooooo`000?ooooooCOooool00:Cooooo0_l0000Hooooo`?o00002Oooool01Ol0003ooooo
oooooooooooo000000;ooooo2?l0003oooooodkooooo002Uooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02o`000003ooooool0003ooooo00;ooooo
1?l0003oooooodoooooo002Uooooo`;o00005oooool00ol0003oooooooooo`0:ooooo`05o`000?oo
oooo0000ooooool000000_ooool3o`000003ooooool0003ooooo0?ooooooCoooool00:Gooooo00?o
0000ooooool000005_ooool00ol0003oooooooooo`0:ooooo`;o000000?oooooo`000?l000001_l0
003ooooooe7ooooo002Uooooo`04o`000?ooooooooooo`0001Gooooo00?o0000ooooooooool02_oo
ool00ol0003oooooo`000002o`000003ooooool0003ooooo00;o0000oooooomBooooo`00YOooool0
1Ol0003ooooooooooooooooo000001Cooooo00?o0000ooooooooool02_ooool2o`0000Kooooo00?o
0000ooooooooool0oooooomAooooo`00YOooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooD_ooool00:Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00Wooooo1?l00003ooooo`03o`000?oooooooooo0?ooooooDoooool00:Go
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00So
oooo0_l00003ooooo`04o`000?oooooo0000o`000?ooooooEOooool00:Gooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0>ooooo`?o00002?ooool2o`0000?ooooo0ol0003ooooooeKo
oooo002Uooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00;ooooo0ol0003ooooooeKooooo002Uooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`07ooooo`;o00000ooo
ool00ol0003oooooo`00003ooooooeOooooo002Tooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Go0000oooooomH
ooooo`00Y?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`02ooooo`;o000000?oooooo`000?ooool0oooooomGoooo
o`00Y?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`000?ooooooFOooool00:Co
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0003ooooooe[ooooo002Tooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`05
o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3ooooooeWooooo002Tooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool01_ooool3o`0000;ooooo00Go0000oooooooo
ooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooF_ooool00:Cooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool000000oooool01?l0
003oooooooooool0003ooooooegooooo002Tooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool00003ooooo`05o`000?ooooooooooooooool00000oooo
oomMooooo`00Y?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooool000000oooool01Ol0003ooooooooooooooooo00000?ooooooG_ooool00:Cooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`02ooooo`;o00000oooool01Ol0003ooooooooooooo
oooo00000?ooooooGoooool00:Cooooo00?o0000ooooooooool04oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00003oooooof3ooooo002Tooooo`03o`000?oo
oooooooo00Kooooo0ol00004ooooo`;o00001Oooool01?l0003oooooooooool00002ooooo`05o`00
0?ooooooooooooooool00000oooooomQooooo`00Y?ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool3o`000003ooooool0003ooooo00;o
oooo00?o0000ooooooooool0oooooomPooooo`00Y?ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool4o`0000Cooooo00?o0000oooooooo
ool0oooooomPooooo`00Y?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`06o`000?ooooooHoooool00:Cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:Co
oooo00?o0000ooooooooool01_ooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`000?ooooooIOooool00:Cooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`03ooooo`;o00000_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooo00000?ooooooI_ooool00:Cooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`03ooooo`;o0000oooooomWooooo`00Y?ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo00Cooooo0_l0003oooooofOooooo002Tooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002Tooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool01Oooool2o`000?ooooooJ?ooool00:Cooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000;o0000oooooomVoooo
o`00Y?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooo
oooo0000oooooomXooooo`00Y?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Co
oooo00Go0000ooooooooooooooooo`00003oooooofSooooo002Tooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo00000?ooooooJ?ooool00:Co
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0oooooomVooooo`00Y?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo
002Tooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Cooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomV
ooooo`00Y?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01_ooool3o`000?ooooooI_ooool00:?ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooooomVooooo`00
Xoooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`3oooooofKooooo002Sooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0oooooomVooooo`00Xoooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooo
ofKooooo002Sooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooI_ooool00:?ooooo00Go0000oooooooooooo
ooooo`000008ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomVooooo`00
Xoooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`3oooooofKooooo002Sooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool03Oooool3o`000?ooooooI_ooool00:?ooooo00?o0000ooooool000001oooool00ol0003ooooo
ooooo`0>ooooo`03o`000?oooooooooo0?ooooooI_ooool00:?ooooo0_l00007ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool0oooooomVooooo`00Xoooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0oooooomVooooo`00X_ooool4o`00
00Gooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3oooooofKooooo002Qooooo`03
o`000?oooooo000000;ooooo00Go0000ooooooooooooooooo`00000Cooooo`03o`000?oooooooooo
0?ooooooI_ooool00:7ooooo00?o0000ooooool000000_ooool01?l0003oooooooooool0000Doooo
o`03o`000?oooooooooo0?ooooooI_ooool00:3ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooo`00000Eooooo`03o`000?oooooooooo0?ooooooI_ooool00:3ooooo00?o0000oooooooo
ool00oooool2o`0001Kooooo0ol0003oooooofKooooo002Qooooo`;o000000Coooooo`000?l0003o
00005oooool00ol0003oooooooooo`3oooooofKooooo002Sooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002oooo
o`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003oooo
o`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`00
00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_oooo
o`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:go
oooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Co
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29196 .15148 .00609 0 365.73 arc
s
newpath
.35402 .04667 .00609 0 365.73 arc
s
newpath
.36887 .03224 .00609 0 365.73 arc
s
.28672 .14838 m
.34878 .04357 L
s
.2972 .15458 m
.35926 .04978 L
s
.35827 .05104 m
.37311 .03661 L
s
.34978 .04231 m
.36462 .02787 L
s
.38122 .02873 m
.37206 .01531 L
s
.35194 .02904 m
.3611 .04246 L
s
.29196 .15148 m
.27589 .03074 L
s
.38122 .02873 m
.3611 .04246 L
s
.37206 .01531 m
.35194 .02904 L
s
.38122 .02873 m
.36887 .03224 L
s
.3611 .04246 m
.36887 .03224 L
s
newpath
.27589 .03074 .00457 0 365.73 arc
s
newpath
.2759 .03074 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00004?ooool2
o`0000gooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00oooooo00?o0000ooooool000003?ooool00ol0003oooooooooo`3ooooo
odGooooo002Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool03Oooool2o`0000?o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo0?ooooooB?ooool00:3ooooo0_l0000Looooo`03o`000?oooooo
oooo00Wooooo0_l00004ooooo`?o00000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo0?ooooooBOooool009oooooo00Co0000oooooooooooo00006oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000002ooooo`;o00000_oo
ool00ol0003oooooooooo`3ooooood[ooooo002Nooooo`;o00000_ooool2o`0001[ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`03ooooo`;o00000oooool3o`0000?ooooo00?o0000
ooooooooool0oooooom;ooooo`00W_ooool2o`000003ooooool0003ooooo00;o00006Oooool3o`00
00Oooooo00?o0000ooooooooool00_ooool2o`0000;ooooo0_l000000ooooooo0000ooooo`02oooo
o`03o`000?oooooooooo0?ooooooC?ooool009oooooo1?l00002ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool02?ooool01_l0003oooooooooool0003oooooo`0000;ooooo00Co0000
ooooool0003o00000_ooool00ol0003oooooooooo`3oooooodgooooo002Qooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`09ooooo`;o00000_ooool6
o`0000;ooooo00?o0000ooooooooool0oooooom>ooooo`00XOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo01Cooooo00?o0000ooooooooool02Oooool2o`0000?ooooo1Ol000000ooo
oooo0000ooooo`3ooooooe3ooooo002Qooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000?ooooo00?o0000ooooool0
00000_ooool00ol0003oooooooooo`3ooooooe3ooooo002Rooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`06ooooo`Co000000Koooooo`000?oooooo
0000ooooool00002ooooo`03o`000?oooooooooo0?ooooooDOooool00:;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Gooooo0_l00003ooooo`05
o`000?oooooo0000ooooool000000_ooool00ol0003oooooooooo`3ooooooe;ooooo002Rooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3ooooo
oe?ooooo002Rooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`04ooooo`;o00001Oooool2o`0000;ooooo00?o0000ooooooooool0oooooomDooooo`00
X_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00kooooo0ol00004ooooo`;o0000
1Oooool01?l0003oooooooooool0003ooooooeOooooo002Rooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o0000
00Koooooo`000?l0003o0000ooooool0003ooooooeSooooo002Rooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?o
oooo00Go0000ooooool0003oooooo`00003ooooooeWooooo002Rooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Go
oooo0_l0003ooooooe[ooooo002Sooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
2_ooool01Ol0003ooooooooooooooooo000000Oooooo0_l0003ooooooe_ooooo002Sooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000Ko
oooo0_l0003ooooooecooooo002Sooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
2?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooFoooool00:?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000Oooooo
00?o0000ooooooooool0oooooomLooooo`00Xoooool00ol0003oooooooooo`0?ooooo`03o`000?oo
oooooooo00Kooooo0ol00006ooooo`;o0000oooooomNooooo`00Xoooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00Gooooo0_l00006ooooo`;o0000oooooomOooooo`00Xoooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00Cooooo0_l00005ooooo`;o0000oooooomPoooo
o`00Y?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooo`00003oooooof3ooooo002Tooooo`03o`000?oooooooooo01;ooooo
00Co0000oooooooooooooooo0_l00004ooooo`03o`000?oooooo00000?ooooooHOooool00:Cooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`02o`0000?ooooo00Co0000oooooooooooo
0000oooooomQooooo`00Y?ooool00ol0003oooooooooo`06ooooo`?o00001?ooool2o`0000Gooooo
0_l000001Ooooooo0000oooooooooooo000000;ooooo00?o0000ooooooooool0oooooomPooooo`00
Y?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001Oooool01Ol0003oooooo`000?oooooo000000?ooooo00?o0000ooooooooool0oooooomPoooo
o`00Y?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00001?ooool00ol0003oooooo`000002o`0000?ooooo00?o0000ooooooooool0oooooomQoooo
o`00Y?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00000oooool01?l0003oooooooooooooool5o`000?ooooooI?ooool00:Cooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:Gooooo00?o0000
ooooooooool01Oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`000?ooooooIOooool00:Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`03ooooo`;o00000oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`000?ooooooIOooool00:Gooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooo00000?ooooooI_ooool00:Gooooo00?o0000ooooooooool03oooool0
0ol0003oooooooooo`04ooooo`;o0000oooooomWooooo`00YOooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00Cooooo0_l0003oooooofOooooo002Uooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002Uooooo`03o`00
0?oooooooooo00kooooo00?o0000ooooooooool01Oooool3o`000?ooooooI_ooool00:Gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`05ooooo`;o0000oooooomXooooo`00Y_ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Gooooo0_l0003oooooofSooooo002Voooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00003ooooo
ofSooooo002Vooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01Oooool01?l0003o
ooooooooool0003oooooofSooooo002Vooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool01Oooool01?l0003oooooooooool0003oooooofSooooo002Vooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool01Oooool01Ol0003ooooooooooooooooo00000?ooooooJ?ooool00:Ko
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`05ooooo`05o`000?oooooooooooooo
ool00000oooooomXooooo`00Y_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool00_ooool3o`000?ooooooI_ooool00:Kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
oooooomVooooo`00Yoooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo002Wooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomVooooo`00Yoooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002Wooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Oooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0oooooomVooooo`00Yoooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3oooooofKooooo002Xoooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`07ooooo`?o0000oooooomV
ooooo`00Z?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0oooooomVooooo`00Z?ooool00ol0003oooooo`000008ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool0oooooomVooooo`00Z?ooool00ol0003oooooo`000007ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomVooooo`00Z?ooool2o`0000Sooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`3oooooofKooooo002Xooooo`;o00001ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Sooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:Oooooo0_l00007ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomVoooo
o`00Yoooool4o`0000Cooooo00?o0000ooooooooool03?ooool3o`000?ooooooI_ooool00:Kooooo
0_l000001?oooooo0000ooooool00003ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0oooooomVooooo`00Yoooool01Ol0003oooooo`000?oooooo000000;ooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`3oooooofKooooo002Vooooo`04o`000?ooooooooooo`0000;o
oooo0_l0000@ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Kooooo00?o0000ooooooooool0
0oooool2o`00013ooooo00?o0000ooooooooool0oooooomVooooo`00Yoooool2o`000004ooooool0
003o0000o`00017ooooo00?o0000ooooooooool0oooooomVooooo`00ZOooool00ol0003ooooooooo
o`05o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`00
0?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000
oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.30169 .15639 .00609 0 365.73 arc
s
newpath
.34916 .04422 .00609 0 365.73 arc
s
newpath
.36654 .03296 .00609 0 365.73 arc
s
.29608 .15402 m
.34355 .04184 L
s
.3073 .15876 m
.35476 .04659 L
s
.35247 .04933 m
.36985 .03808 L
s
.34585 .0391 m
.36323 .02785 L
s
.37689 .02537 m
.36364 .01599 L
s
.34956 .03586 m
.36281 .04525 L
s
.30169 .15639 m
.26643 .0398 L
s
.37689 .02537 m
.36281 .04525 L
s
.36364 .01599 m
.34956 .03586 L
s
.37689 .02537 m
.36654 .03296 L
s
.36281 .04525 m
.36654 .03296 L
s
newpath
.26643 .0398 .00457 0 365.73 arc
s
newpath
.26643 .0398 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00003Oooool2
o`00013ooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00gooooo00?o0000ooooool000003_ooool00ol0003oooooooooo`3ooooo
odGooooo002Nooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool03?ooool01?l0003o
ooooooooooooool2o`0000_ooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`06ooooo`;o00001Oooool00ol0003ooooooooo
o`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`05o`000004ooooool0003oooooo`0000Cooooo00?o0000ooooooooool0oooo
oom:ooooo`00Xoooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool00_l00004ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0oooooom;
ooooo`00Y?ooool00ol0003oooooooooo`0Gooooo`?o00002?ooool4o`0000Cooooo0ol00004oooo
o`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`07ooooo`;o00000_ooool01Ol0003ooooooooooooooooo000000;ooooo00Go0000oooo
ooooooooooooo`00003oooooodoooooo002Jooooo`Co00002?ooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo00Kooooo0_l00003ooooo`06o`000?ooooooooooooooool0003ooooo0_l0
0002ooooo`03o`000?oooooooooo0?ooooooC_ooool009[ooooo00?o0000ooooooooool00_l00008
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool01Oooool4o`0000?ooooo1_l00002
ooooo`03o`000?oooooooooo0?ooooooCoooool009Wooooo0_l000001?oooooo0000ooooool00009
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol00003
ooooo`;o00000oooool00ol0003oooooooooo`3ooooooe3ooooo002Iooooo`;o000000Coooooo`00
0?oooooo00002_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`05o`0000;ooooo00?o0000ooooooooool0oooooomA
ooooo`00V_ooool4o`0000cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02oooo
o`;o00001Oooool00ol0003oooooo`000003o`0000;ooooo00?o0000ooooooooool0oooooomBoooo
o`00W?ooool2o`0000gooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00Cooooo0_l00002ooooo`04o`000?ooooooooooo`000?ooooooEOooool009go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;o
oooo0_l00004ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomDooooo`00
WOooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo0ol000000ooooooo0000
ooooo`02o`0000;ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooEOooool009kooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`05o`000?ooooooooooooooool00000
0oooool3o`0000Gooooo00?o0000ooooooooool0oooooomFooooo`00W_ooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00cooooo00Go0000ooooooooooooooooo`000005ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0oooooomGooooo`00W_ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo00_ooooo00Co0000oooooooooooo00001_ooool01Ol0003ooooo
oooooooooooo00000?ooooooF_ooool009oooooo00?o0000ooooooooool03oooool00ol0003ooooo
ooooo`0:ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000ooooooooooooooooo`00003ooooo
oe_ooooo002Oooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooo`000006ooooo`04o`000?ooooooooooo`000?ooooooG?ooool009oooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Gooooo00Co0000oooooooo
oooo0000oooooomMooooo`00Woooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oo
oooo0_l00006ooooo`03o`000?oooooo00000?ooooooG_ooool00:3ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`06ooooo`?o00001?ooool00ol0003oooooo`00003ooooooeoooooo
002Pooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool01Oooool2o`0000Gooooo0_l0
003oooooof3ooooo002Pooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooGoooool00:7ooooo00?o0000oooo
ooooool05?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0oooooomPooooo`00XOooool00ol0003oooooooooo`0Eooooo`04o`000?oooooooooooooo
o`;o00001?ooool2o`000?ooooooH_ooool00:7ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`02o`0000?ooooo0_l0003oooooof?ooooo002Qooooo`03o`000?oooooooooo00Wooooo
0ol00004ooooo`;o00001Oooool2o`000007ooooool0003oooooooooool0003oooooo`00003ooooo
of?ooooo002Rooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00005ooooo`05o`000?oooooo0000ooooool000000_ooool00ol0003oooooooooo`3o
ooooof7ooooo002Rooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00005ooooo`Co00000_ooool00ol0003oooooooooo`3oooooof;ooooo002Roooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004
ooooo`03o`000?oooooooooo00Go0000oooooomTooooo`00Xoooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooHoooool00:?ooooo00?o0000ooooooooool01oooool2
o`0000Cooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo000000;ooooo
00?o0000ooooooooool0oooooomSooooo`00Xoooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00?ooooo0_l00004ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooo
ooooo`3oooooof?ooooo002Tooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooo`00003oooooofKooooo002Tooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooo`00003oooooofKooooo002Tooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool00:Cooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`03ooooo`;o0000oooooomWooooo`00YOooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo00?ooooo0ol0003oooooofKooooo002Uooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooofKooooo002U
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3o
ooooofKooooo002Vooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01?ooool2o`00
0?ooooooJ?ooool00:Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`;o
0000oooooomXooooo`00Y_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooool00000oooooomXooooo`00Y_ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooool00000oooooomXooooo`00Yoooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool00000oooooomXooooo`00Yoooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00ol0003ooooo
ofKooooo002Wooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool0003oooooofSooooo002Xooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool01?ooool01Ol0003ooooooooooooooooo00000?ooooooJ?ooool00:Sooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooooooool00000oooooomXoooo
o`00Z?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`3oooooofKooooo002Yooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00ZOooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3o
ooooofKooooo002Yooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooI_ooool00:[ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo0ol0003oooooofKo
oooo002Zooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo0?ooooooI_ooool00:[ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooo
oomVooooo`00Zoooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`3oooooofKooooo002[ooooo`05o`000?ooooooooooooooool000001_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:_ooooo00Co0000
oooooooooooo00001_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:_ooooo00Co0000oooooooooooo00001_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo0_l00007ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool2o`0000Kooooo00?o0000ooooooooool01oooool3o`00
0?ooooooI_ooool00:cooooo0_l00006ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool3o`0000Cooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`;o000000?oooooo`000?ooool00_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo0?ooooooI_ooool00:_ooooo0ol00002ooooo`03o`000?oooooo
000000_ooooo00?o0000ooooooooool0oooooomVooooo`00Zoooool02?l0003oooooooooool0003o
ooooo`000?oooooo00002oooool00ol0003oooooooooo`3oooooofKooooo002[ooooo`So000000?o
ooooo`000?l000002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`;o00000_ooool2
o`000005ooooool0003oooooooooool000001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000
oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Ooo
ool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4
o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool0
1?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool0
0ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.30952 .15924 .00609 0 365.73 arc
s
newpath
.34524 .04279 .00609 0 365.73 arc
s
newpath
.36366 .03334 .00609 0 365.73 arc
s
.3037 .15745 m
.33942 .04101 L
s
.31535 .16103 m
.35106 .04458 L
s
.34802 .04821 m
.36644 .03875 L
s
.34246 .03737 m
.36088 .02792 L
s
.37063 .02255 m
.3549 .0185 L
s
.34883 .04209 m
.36455 .04614 L
s
.30952 .15924 m
.25763 .04904 L
s
.37063 .02255 m
.36455 .04614 L
s
.3549 .0185 m
.34883 .04209 L
s
.37063 .02255 m
.36366 .03334 L
s
.36455 .04614 m
.36366 .03334 L
s
newpath
.25763 .04904 .00457 0 365.73 arc
s
newpath
.25763 .04904 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool02Oooool3o`0001;ooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01?l0000=ooooo`03
o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Gooooo0_l0000:ooooo`03o`000?oooooooooo0?oooooo
Aoooool00:3ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3oooooodSooooo002Q
ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`05
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool01oooool01?l0003oooooooooooooool6o`0000Sooooo00?o0000
ooooooooool0oooooom:ooooo`00Xoooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooool000000_l00003ooooo`;o00001oooool00ol0003oooooooooo`3ooooo
od_ooooo002Tooooo`03o`000?oooooooooo01Oooooo0ol00007ooooo`;o000000?oooooo`000?oo
ool00_ooool3o`0000Kooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo00Gooooo0_l00003ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooodgooooo002Vooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool00oooool2o`000003ooooool0003ooooo00;ooooo
00Go0000oooooooooooo0000ooooo`02o`0000Cooooo00?o0000ooooooooool0oooooom>ooooo`00
Yoooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooooooo`Ko00001?ooool5o`0000Co
oooo00?o0000ooooooooool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0Cooooo`05o`00
0?ooooooooooooooool000000oooool2o`0000Kooooo0ol00003ooooo`03o`000?oooooooooo0?oo
ooooD?ooool00:Wooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`02o`0000?ooooo
0ol00004ooooo`Co00000_ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool00_l00005ooooo`Ko000000Goooooo`000?oooooooooo
o`00003ooooooeCooooo002Fooooo`Co00004Oooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;o00001Oooool3o`0000?ooooo0_l000000ooooooo0000ooooo`3ooooooeCooooo002F
ooooo`04o`000?ooooooooooo`0001;ooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`03o`0000;ooooo0ol00007ooooo`03o`000?oooooooooo0?ooooooE?ooool009Gooooo00Co0000
ooooool0003ooooo0_l0000Booooo`03o`000?oooooooooo00kooooo1?l00002ooooo`?o000000?o
ooooo`000?ooool01Oooool00ol0003oooooooooo`3ooooooeGooooo002Eooooo`Ko00004oooool0
0ol0003oooooooooo`0=ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`3ooooooeKooooo002Eooooo`Go00005Oooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooo000000Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3o
oooooeOooooo002Hooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool02oooool00ol0
003oooooo`000006ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomHoooo
o`00VOooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00[ooooo00?o0000ooooool0
00001Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooFOooool009Wooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`09ooooo`;o00001_ooool01Ol0003ooooo
oooooooooooo00000?ooooooG?ooool009[ooooo00?o0000ooooooooool05_ooool00ol0003ooooo
ooooo`08ooooo`;o00001_ooool01?l0003oooooooooool0003ooooooegooooo002Jooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool01oooool2o`0000Gooooo00Co0000oooooooooooo
0000oooooomNooooo`00Voooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo
0ol00004ooooo`03o`000?oooooo00000?ooooooGoooool009_ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo0_l0003oooooof3ooooo002L
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03
ooooo`;o0000oooooomQooooo`00W?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
00;ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool009cooooo00?o0000oooooooo
ool06_ooool01?l0003oooooooooooooool2o`0000Cooooo0_l0003oooooof;ooooo002Mooooo`03
o`000?oooooooooo01[ooooo00?o0000ooooooooool00_l00003ooooo`;o0000oooooomSooooo`00
WOooool00ol0003oooooooooo`0=ooooo`?o00001?ooool2o`0000Gooooo0_l000001ooooooo0000
oooooooooooo0000ooooool00000oooooomSooooo`00W_ooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool01Ol0003oooooo`000?oooooo
000000;ooooo00?o0000ooooooooool0oooooomQooooo`00W_ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool4o`0000;ooooo00?o0000
ooooooooool0oooooomRooooo`00Woooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`000004o`000?ooooooI?ooool0
09oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002P
ooooo`03o`000?oooooooooo00[ooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00Co
0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002Pooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool00oooool2o`0000Gooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`3oooooof?ooooo002Qooooo`03o`000?oooooooooo01Kooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00:7ooooo00?o
0000ooooooooool05_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
oooooomSooooo`00X_ooool00ol0003oooooooooo`0Eooooo`07o`000?ooooooooooooooool0003o
ooooo`00003oooooofKooooo002Rooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0
0_ooool00ol0003oooooo`00003oooooofKooooo002Sooooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool00_ooool3o`000?ooooooI_ooool00:?ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00Y?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo00?ooooo0_l0003oooooofOooooo002Tooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool00oooool2o`000?ooooooIoooool00:Gooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Gooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:Gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:Kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`;o0000oooooomXooooo`00Y_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Co
oooo1?l0003oooooofKooooo002Wooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
1?ooool2o`000?ooooooJ?ooool00:Oooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooo00000?ooooooJ?ooool00:Sooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooo00000?ooooooJ?ooool00:Sooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo00000?ooooooJ?ooool00:Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`00
0?ooooooJ?ooool00:Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`04
o`000?ooooooooooo`000?ooooooJ?ooool00:[ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`04ooooo`04o`000?ooooooooooo`000?ooooooJ?ooool00:[ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`000?ooooooJ?ooool00:_o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`04o`000?oooooooooooooo
o`?o0000oooooomVooooo`00Zoooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Co
oooo00Go0000ooooooooooooooooo`00003oooooofSooooo002/ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooooooo00000?ooooooJ?ooool00:co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00Go0000ooooooooooooooooo`00
0005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool0
1?l0003oooooooooool00006ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool01?l0003oooooooooool00006ooooo`03o`000?oooooooooo00?ooooo0ol0
003oooooofKooooo002_ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`3oooooofKooooo002_ooooo`;o00001_ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo1?l00002ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[oooool3o`0000;ooooo00?o
0000ooooool000001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Ko00000_ooool3
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01Ol0003oooooo`000?l0003o
oooo00;o000000?oooooo`000?l000001oooool00ol0003oooooooooo`3oooooofKooooo002^oooo
o`;o00000oooool01?l0003oooooo`000?l00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:oooooo0ol000001Ooooooo0000o`000?oooooo000000Oooooo1Ol0003oooooofCooooo002/oooo
o`06o`000?ooooooooooooooool0003ooooo0_l00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?oo
ool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0
003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]
ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/oooo
o`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003oooo
o`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.317 .16115 .00609 0 365.73 arc
s
newpath
.3415 .04184 .00609 0 365.73 arc
s
newpath
.36036 .03329 .00609 0 365.73 arc
s
.31103 .15992 m
.33554 .04061 L
s
.32296 .16237 m
.34747 .04306 L
s
.34401 .04738 m
.36288 .03884 L
s
.33899 .03629 m
.35785 .02774 L
s
.36296 .02072 m
.34683 .02263 L
s
.3497 .04682 m
.36583 .04491 L
s
.317 .16115 m
.24927 .05991 L
s
.36296 .02072 m
.36583 .04491 L
s
.34683 .02263 m
.3497 .04682 L
s
.36296 .02072 m
.36036 .03329 L
s
.36583 .04491 m
.36036 .03329 L
s
newpath
.24927 .05991 .00457 0 365.73 arc
s
newpath
.24927 .05991 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool02Oooool5o`0000oooooo00?o0000ooooooooool0oooooom6ooooo`00
Woooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Cooooo1Ol00004ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo0_l0000<ooooo`03o`000?oooooo
oooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00;ooooo1Ol0000;ooooo`03o`000?oooooooooo0?ooooooB_ooool00:?o
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`05ooooo`Go00000_ooool3o`0000Wo
oooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0Gooooo`?o0000
1?ooool2o`0000;ooooo00Go0000oooooooooooo0000ooooo`02o`0000Sooooo00?o0000oooooooo
ool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0Fooooo`04o`000?ooooooooooooooo`?o
000000Goooooo`000?ooooooooooo`000002ooooo`03o`000?oooooooooo00;o00001_ooool00ol0
003oooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool01?l000001Ooooooo0000oooooooooooo000000;ooooo00?o0000ooooooooool00_l00005oooo
o`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o0000ooooooooool05?ooool01?l0003o
ooooooooool00003ooooo`;o00000oooool2o`000004ooooool0003o0000o`0000Gooooo00?o0000
ooooooooool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo0000
00Cooooo0_l00005ooooo`Co00001?ooool00ol0003oooooooooo`3ooooooe3ooooo002Yooooo`03
o`000?oooooooooo01;ooooo0ol00005ooooo`04o`000?ooooooooooooooo`?o000000?oooooo`00
0?l000000oooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo017o
oooo0ol00005ooooo`Co00001?ooool2o`0000;ooooo00?o0000ooooooooool0oooooomBooooo`00
Zoooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo000000;o00000_ooool3o`0000?ooooo
1Ol000000ooooooo0000ooooo`3ooooooeCooooo002/ooooo`03o`000?oooooooooo00oooooo0_l0
0003ooooo`So00001Oooool00ol0003oooooooooo`3ooooooeCooooo002]ooooo`03o`000?oooooo
oooo00kooooo0ol00004ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomE
ooooo`00[_ooool00ol0003oooooooooo`0=ooooo`;o00001Oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool03?ooool2o`0000Go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooeOooooo002Booooo`?o0000
6oooool00ol0003oooooooooo`0;ooooo`;o00001Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo0?ooooooF?ooool0097ooooo1Ol0000Kooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFOoo
ool0093ooooo0_l00002ooooo`;o00007?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe[ooooo002@oooo
o`;o000000Coooooo`000?oooooo00007Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooe_ooooo002Aoooo
o`Co00007oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo00Go0000oooo
ooooooooooooo`00003ooooooekooooo002Cooooo`;o00008?ooool00ol0003oooooooooo`06oooo
o`?o00000oooool01?l0003oooooooooool0003ooooooeoooooo002Eooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool01?ooool2o`0000Gooooo00?o0000ooooool00000oooooomPoooo
o`00UOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`03
o`000?oooooo00000?ooooooHOooool009Kooooo00?o0000ooooooooool07oooool00ol0003ooooo
ooooo`02ooooo`;o00001?ooool2o`000?ooooooH_ooool009Oooooo00?o0000ooooooooool07ooo
ool01?l0003oooooooooooooool2o`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00Uooo
ool00ol0003oooooooooo`0Pooooo`05o`000?oooooo0000ooooool000000oooool2o`000?oooooo
Hoooool009Sooooo00?o0000ooooooooool04_ooool3o`0000Cooooo0_l00005ooooo`;o000000Oo
ooooo`000?ooooooooooo`000?oooooo00000?ooooooHoooool009Wooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo00Oo0000ooooool0
003oooooo`000?oooooo00000?ooooooI?ooool009Wooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo1?l00002ooooo`03o`000?oooooo
oooo0?ooooooH_ooool009[ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool000001?l0003oooooofCooooo002Koooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004
ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooomRooooo`00Voooool0
0ol0003oooooooooo`0?ooooo`;o00001?ooool01?l0003oooooooooool00004ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00W?ooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0oooooomSooooo`00WOooool00ol0003oooooooooo`0Kooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00WOooool00ol0003ooooooooo
o`0Kooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00W_oo
ool00ol0003oooooooooo`0Iooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooo
ooooo`3oooooof?ooooo002Oooooo`03o`000?oooooooooo01Sooooo00Oo0000oooooooooooooooo
o`000?oooooo00000?ooooooI_ooool009oooooo00?o0000ooooooooool06?ooool01?l0003ooooo
ooooooooool3o`000?ooooooI_ooool00:3ooooo00?o0000ooooooooool05oooool01ol0003ooooo
oooooooooooo0000ooooool00000oooooomVooooo`00XOooool00ol0003oooooooooo`0Eooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooool00000oooooomVooooo`00XOooool00ol0003ooooo
ooooo`0Eooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool00000oooooomVooooo`00X_oo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00;ooooo0_l0003oooooofOooooo002S
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool0
0:?ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWoooo
o`00Y?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo0_l0003oooooofOo
oooo002Uooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool00oooool3o`000?oooooo
I_ooool00:Kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:Kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Oooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Sooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Sooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:Wooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`;o0000oooo
oomXooooo`00Z_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00?ooooo0_l0003o
ooooofSooooo002Zooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00oooool2o`00
0?ooooooJ?ooool00:_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`Co
0000oooooomVooooo`00[?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooool00000oooooomXooooo`00[?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooool00000oooooomXooooo`00[Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000oooooomXooooo`00[_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool00000oooooomXoooo
o`00[_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool0
0000oooooomXooooo`00[oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00Co0000oooooooooooo0000oooooomXooooo`00/?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo0000oooooomXooooo`00/?ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ol0003oooooofKooooo
002aooooo`04o`000?ooooooooooo`0000Kooooo00Co0000oooooooooooo0000oooooomXooooo`00
/_ooool00ol0003oooooo`000006ooooo`04o`000?ooooooooooo`000?ooooooJ?ooool00;;ooooo
00?o0000ooooool000001Oooool01Ol0003ooooooooooooooooo00000?ooooooJ?ooool00;?ooooo
0_l00005ooooo`05o`000?ooooooooooooooool00000oooooomXooooo`00]?ooool4o`0000;ooooo
00Go0000ooooooooooooooooo`00003oooooofSooooo002/ooooo`Go00000_ooool3o`0000;ooooo
00?o0000ooooool000000oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?oo
ooooooooo`0000;ooooo1?l000001?oooooo0000ooooool00003ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool5o`000?ooooooI?ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`Ko00001Oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o
00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?o
oooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool0
00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:ko
oooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool0
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0_l00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32464 .16234 .00609 0 365.73 arc
s
newpath
.33768 .04124 .00609 0 365.73 arc
s
newpath
.35663 .0329 .00609 0 365.73 arc
s
.31859 .16169 m
.33162 .04059 L
s
.3307 .16299 m
.34373 .04189 L
s
.34013 .04681 m
.35908 .03848 L
s
.33523 .03567 m
.35418 .02733 L
s
.35422 .02029 m
.34005 .02824 L
s
.35197 .04948 m
.36613 .04154 L
s
.32464 .16234 m
.24157 .07327 L
s
.35422 .02029 m
.36613 .04154 L
s
.34005 .02824 m
.35197 .04948 L
s
.35422 .02029 m
.35663 .0329 L
s
.36613 .04154 m
.35663 .0329 L
s
newpath
.24157 .07327 .00457 0 365.73 arc
s
newpath
.24157 .07327 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool01oooool2o`0001Cooooo00?o0000ooooooooool0oooooom6ooooo`00
Woooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Gooooo0_l000000ooooooo0000
ooooo`0Booooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooooooo`;o00004Oooool00ol0003ooooo
ooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool00_oo
ool2o`0000Cooooo0ol0000?ooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo00?o0000
ooooooooool06Oooool01Ol0003ooooooooooooooooo000000Gooooo1Ol0000=ooooo`03o`000?oo
oooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool06?ooool01Ol0003ooooooooooooo
oooo000000;ooooo1?l000001Ooooooo0000o`000?oooooo000000_ooooo00?o0000ooooooooool0
oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0Gooooo`?o00000_ooool2o`0000;ooooo00Go
0000oooooooooooo0000ooooo`02o`0000[ooooo00?o0000ooooooooool0oooooom<ooooo`00YOoo
ool00ol0003oooooooooo`0Fooooo`03o`000?oooooo000000?o00000oooool00ol0003ooooooooo
o`02o`000003ooooool0003o000000Sooooo00?o0000ooooooooool0oooooom=ooooo`00Y_ooool0
0ol0003oooooooooo`0Eooooo`Go000000?oooooo`000?ooool00_ooool01?l0003ooooooooooooo
ool3o`0000Oooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0D
ooooo`;o00000oooool2o`0000?ooooo0_l00002ooooo`?o00001_ooool00ol0003oooooooooo`3o
ooooodoooooo002Xooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00_ooool00ol0
003oooooo`000004ooooo`?o000000?oooooo`000?ooool01?ooool00ol0003oooooooooo`3ooooo
oe3ooooo002Yooooo`03o`000?oooooooooo017ooooo0_l00005ooooo`04o`000?oooooo0000oooo
o`?o00000oooool2o`0000?ooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003o
ooooooooo`0@ooooo`;o00001Oooool01?l0003oooooo`000?l00004ooooo`;o00001?ooool00ol0
003oooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo00oooooo1?l000000ooooooo
0000o`000002o`000003ooooool0003ooooo00;ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00kooooo0_l00002ooooo`;o0000
00Koooooo`000?ooooooooooo`000?ooool2o`0000Gooooo00?o0000ooooooooool0oooooomDoooo
o`00[Oooool00ol0003oooooooooo`0=ooooo`Co00000oooool01Ol0003ooooooooooooooooo0000
00Kooooo00?o0000ooooooooool0oooooomEooooo`00[_ooool00ol0003oooooooooo`0<ooooo`;o
00001?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo
00?o0000ooooooooool02_ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0oooooomGooooo`00/?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooo000000Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3ooooooeSooooo002a
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooFOooool00;;ooooo00?o0000ooooooooool01oooool00ol0
003oooooo`000004ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomJoooo
o`00/oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`3ooooooe_ooooo002dooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooool000001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?oooooo
G?ooool00;Gooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000002o`0000;ooooo00Go
0000ooooooooooooooooo`00003ooooooeoooooo002fooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooool000001?ooool01?l0003oooooooooool0003oooooof3ooooo002>ooooo`?o00009_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo0000
oooooomQooooo`00SOooool00ol0003oooooooooo`02o`0002Kooooo00Oo0000oooooooooooooooo
o`000?oooooo000000?ooooo00?o0000ooooool00000oooooomRooooo`00S?ooool2o`0000;ooooo
0_l0000Wooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooooooo0_l0003oooooof?o
oooo002<ooooo`;o000000Coooooo`000?oooooo0000:?ooool2o`0000;ooooo00Go0000oooooooo
ooooooooo`00003oooooofCooooo002=ooooo`Go00006oooool3o`0000Cooooo0_l00005ooooo`04
o`000?ooooooooooo`0000;ooooo0_l0003oooooofCooooo002?ooooo`;o00007Oooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo0_l000001_oooooo0000ooooool0003o
ooooo`000?ooooooI?ooool0097ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooool000000_l00002ooooo`03o`000?oo
oooooooo0?ooooooH_ooool009;ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol0003oooooofCooooo002C
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0004ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooomRooooo`00U?oo
ool00ol0003oooooooooo`0Fooooo`;o00001?ooool01?l0003oooooooooool00004ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00UOooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool0oooooomSooooo`00U_ooool00ol0003oooooooooo`0Rooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00Uoooool00ol0003ooooo
ooooo`0Qooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00
V?ooool00ol0003oooooooooo`0Oooooo`05o`000?ooooooooooooooool000000_ooool00ol0003o
ooooooooo`3oooooof?ooooo002Iooooo`03o`000?oooooooooo01kooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool009[ooooo00?o0000ooooooooool0
7Oooool01?l0003oooooooooooooool4o`000?ooooooIOooool009_ooooo00?o0000ooooooooool0
7?ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0oooooomSooooo`00
W?ooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooooooool000000_ooool00ol0003o
ooooooooo`3oooooof?ooooo002Mooooo`03o`000?oooooooooo01[ooooo00Oo0000oooooooooooo
ooooo`000?oooooo00000?ooooooI_ooool009gooooo00?o0000ooooooooool06_ooool01ol0003o
oooooooooooooooo0000ooooool00000oooooomVooooo`00W_ooool00ol0003oooooooooo`0Ioooo
o`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002Oooooo`03o`000?oooooo
oooo01Sooooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00:3ooooo00?o
0000ooooooooool05oooool01ol0003ooooooooooooooooo0000ooooool00000oooooomVooooo`00
XOooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00;ooooo0ol0003oooooofKooooo
002Rooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00
003oooooofKooooo002Sooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooo`00003oooooofKooooo002Tooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooo`00003oooooofKooooo002Uooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool00:Kooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00Yoooool00ol0003ooooooooo
o`0?ooooo`03o`000?oooooooooo00;ooooo0_l0003oooooofOooooo002Xooooo`03o`000?oooooo
oooo00kooooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool00:Wooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00Z_ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo0ol0003oooooofKooooo002[ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool00oooool2o`000?ooooooIoooool00:cooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`;o0000oooooomWooooo`00[?ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo0_l0003oooooofOooooo002]oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooo
ofKooooo002^ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo002aooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool00oooool3o`000?ooooooI_ooool00;;ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooI_ooool00;?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;Cooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;Gooooo00?o0000ooooool000001_ooool00ol0003oooooooooo`3oooooofKooooo
002fooooo`;o00001Oooool2o`000?ooooooJ?ooool00:cooooo1Ol00003ooooo`;o000000?ooooo
o`000?l000000ol000000ooooooo0000o`00003oooooofSooooo002]ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool00ol00003ooooo`?o0000oooooomXooooo`00[_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;o000000Coooooo`000?oooooooooo0ol0003o
ooooofSooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool2o`0000;ooooo00?o0000
ooooooooool01_l0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool0
1_l0003oooooooooool0003oooooo`0000Cooooo0_l0003oooooofSooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01Ol0003oooooooooool0003ooooo00;o000000Goooooo`000?l0
003oooooo`00003oooooofSooooo002]ooooo`?o00001?ooool2o`0000Cooooo00Go0000oooooooo
ooooooooo`00003oooooofSooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o
00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?o
oooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool0
00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:ko
oooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo
00001oooool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool0
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0_l00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.33145 .16279 .00609 0 365.73 arc
s
newpath
.33427 .04102 .00609 0 365.73 arc
s
newpath
.35308 .03235 .00609 0 365.73 arc
s
.32536 .16265 m
.32819 .04088 L
s
.33754 .16293 m
.34036 .04116 L
s
.33682 .04655 m
.35563 .03788 L
s
.33172 .03549 m
.35053 .02682 L
s
.34625 .02148 m
.33594 .03403 L
s
.35476 .04949 m
.36507 .03694 L
s
.33145 .16279 m
.2359 .08725 L
s
.34625 .02148 m
.36507 .03694 L
s
.33594 .03403 m
.35476 .04949 L
s
.34625 .02148 m
.35308 .03235 L
s
.36507 .03694 m
.35308 .03235 L
s
newpath
.2359 .08725 .00457 0 365.73 arc
s
newpath
.2359 .08725 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool01?ooool2o`0001Kooooo00?o0000ooooooooool0
oooooom7ooooo`00X?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooool000005?ooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooo
oooo01[ooooo00?o0000ooooooooool00oooool00ol0003oooooo`000004o`00013ooooo00?o0000
ooooooooool0oooooom9ooooo`00X_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
00;ooooo0ol000001_oooooo0000ooooool0003oooooo`0000kooooo00?o0000ooooooooool0oooo
oom:ooooo`00Xoooool00ol0003oooooooooo`0Hooooo`04o`000?ooooooooooooooo`;o00000_oo
ool01?l0003oooooo`000?ooool2o`0000gooooo00?o0000ooooooooool0oooooom;ooooo`00Y?oo
ool00ol0003oooooooooo`0Gooooo`Co00000oooool01?l0003oooooooooooooool2o`000003oooo
ool0003ooooo00[ooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003ooooooooo
o`0Fooooo`Co00000oooool00ol0003oooooooooo`03ooooo`?o00002Oooool00ol0003ooooooooo
o`3oooooodgooooo002Vooooo`03o`000?oooooooooo01Cooooo1?l000000ooooooo0000ooooo`02
ooooo`;o00000oooool01?l0003oooooo`000?l00007ooooo`03o`000?oooooooooo0?ooooooC_oo
ool00:Oooooo00?o0000ooooooooool04oooool2o`0000;ooooo00?o0000ooooool000001?ooool4
o`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooodoooooo002Xoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooool000000_ooool01?l0003oooooooooool00002
ooooo`?o00001?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooD?ooool0
0:Wooooo00?o0000ooooooooool04?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo
00;o00001_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooDOooool00:[o
oooo00?o0000ooooooooool03oooool00ol0003oooooo`000003ooooo`?o000000?oooooo`000?oo
ool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooD_ooool00:_ooooo
00?o0000ooooooooool03_ooool3o`000004ooooool0003o0000o`0000Cooooo00Go0000oooooooo
ooooooooo`000005ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo00Cooooo00?o0000ooooool0
00001Oooool00ol0003oooooooooo`3ooooooeCooooo002]ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooool000000_l000000ooooooo0000ooooo`05ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0oooooomEooooo`00[_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooo000000?ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooeKooooo002_
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo0?ooooooEoooool00;3ooooo00?o0000ooooooooool02Oooool00ol0
003oooooo`000003ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomHoooo
o`00/Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000?ooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`3ooooooeWooooo002booooo`03o`000?oooooooooo00Oooooo
00?o0000ooooool000000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
F_ooool00;?ooooo00?o0000ooooooooool01_ooool00ol0003oooooo`000003ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0oooooomKooooo`00]?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3o
oooooecooooo002eooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool000000_l000000ooo
oooo0000ooooo`03ooooo`03o`000?oooooooooo0?ooooooGOooool00;Kooooo00?o0000oooooooo
ool00oooool00ol0003oooooo`000003ooooo`05o`000?ooooooooooooooool00000oooooomPoooo
o`00]oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooo
oooo0000oooooomQooooo`00^?ooool01ol0003ooooooooooooooooo0000ooooool000000oooool0
0ol0003oooooo`00003oooooof;ooooo002iooooo`06o`000?ooooooooooo`000?oooooo00000ooo
ool2o`000?ooooooHoooool00;[ooooo0_l00002ooooo`05o`000?ooooooooooooooool00000oooo
oomTooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`04o`000?ooooooooooo`0000;ooooo0_l0
003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?oo
ool2o`000006ooooool0003oooooo`000?oooooo0000oooooomTooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooool000000_l00002ooooo`03
o`000?oooooooooo0?ooooooH_ooool008_ooooo0ol0000Pooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05o`000?ooooooI?ooool008[ooooo
1Ol0000Oooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0003o
ooooooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool008[ooooo0_l00002ooooo`03
o`000?oooooooooo01cooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooo
oooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002:ooooo`03o`000?oooooo0000
00;o00007oooool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool00003
ooooo`03o`000?oooooooooo0?ooooooH_ooool008[ooooo0_l000000ooooooo0000o`00000/oooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooomRooooo`00S?ooool01?l0
003oooooooooool0000[ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooo
oomRooooo`00T?ooool00ol0003oooooooooo`0Xooooo`04o`000?ooooooooooo`0000?ooooo00?o
0000ooooooooool0oooooomRooooo`00TOooool2o`0002Sooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`3oooooof;ooooo002Cooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool00ol000000ooooooo0000ooooo`3oooooof?ooooo002Dooooo`03o`000?oooooooooo
02Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002Eoooo
o`03o`000?oooooooooo02?ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3o
ooooof;ooooo002Fooooo`;o00008oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo0?ooooooHoooool009Sooooo00?o0000ooooooooool08?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo0?ooooooHoooool009Wooooo00?o0000ooooooooool07oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool009[ooooo00?o0000oooo
ooooool07_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool0
09_ooooo0_l0000Nooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomS
ooooo`00WOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Co0000oooooomUoooo
o`00W_ooool00ol0003oooooooooo`0Jooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0oooooomSooooo`00Woooool00ol0003oooooooooo`0Iooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool0oooooomSooooo`00X?ooool2o`0001Wooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002Rooooo`03o`000?oooooooooo01Ko
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002Sooooo`03
o`000?oooooooooo01Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3ooooo
of?ooooo002Tooooo`;o00005Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
0?ooooooHoooool00:Kooooo00?o0000ooooooooool04_ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo0?ooooooHoooool00:Oooooo00?o0000ooooooooool04Oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00:Sooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`04o`000?ooooooIOooool00:Wooooo0_l0000@ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00Zoooool00ol0003ooooo
ooooo`0<ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?o
oooo002/ooooo`03o`000?oooooooooo00_ooooo00Go0000ooooooooooooooooo`000002ooooo`03
o`000?oooooooooo0?ooooooHoooool00:gooooo00?o0000ooooooooool02_ooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool0oooooomSooooo`00[_ooool2o`0000[ooooo
00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;3ooooo
00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooooooo
ool0oooooomSooooo`00/Oooool00ol0003oooooooooo`06ooooo`05o`000?ooooooooooooooool0
00000_ooool00ol0003oooooooooo`3oooooof?ooooo002booooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo1?l0003oooooofGooooo002cooooo`;o00001Oooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool0oooooomSooooo`00]Oooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?o
oooo002fooooo`05o`000?ooooooooooooooool000000oooool01?l0003oooooooooool0003ooooo
ofGooooo002gooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo0000oooooomU
ooooo`00^?ooool3o`0000?ooooo00Co0000oooooooooooo0000oooooomUooooo`00[?ooool5o`00
00?ooooo0_l00004ooooo`03o`000?oooooooooo00?o000000?oooooo`000?ooool0oooooomToooo
o`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo0ol00000
0ooooooo0000ooooo`02o`000?ooooooIOooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00003ooooo`?o000000?oooooo`000?ooool00_l0003oooooofGooooo002_oooo
o`05o`000?ooooooooooooooool000000_ooool01Ol0003ooooooooooooooooo000000;ooooo1_l0
003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00003ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?o
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00004oooo
o`;o000000Coooooo`000?l0003o0000oooooomVooooo`00[Oooool3o`0000Cooooo0_l00007oooo
o`;o0000oooooomXooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?o
oooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o
00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oo
oooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool0
1?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3379 .16268 .00609 0 365.73 arc
s
newpath
.33105 .04107 .00609 0 365.73 arc
s
newpath
.34953 .03174 .00609 0 365.73 arc
s
.33182 .16302 m
.32497 .04141 L
s
.34398 .16234 m
.33713 .04073 L
s
.33379 .04651 m
.35228 .03718 L
s
.3283 .03563 m
.34679 .0263 L
s
.33909 .02428 m
.33431 .0398 L
s
.35759 .04696 m
.36237 .03144 L
s
.3379 .16268 m
.23195 .10261 L
s
.33909 .02428 m
.36237 .03144 L
s
.33431 .0398 m
.35759 .04696 L
s
.33909 .02428 m
.34953 .03174 L
s
.36237 .03144 m
.34953 .03174 L
s
newpath
.23195 .10261 .00457 0 365.73 arc
s
newpath
.23195 .10261 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool00ol0000Hooooo`03o`000?oo
oooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool06_ooool01Ol0003oooooooooool0
003ooooo00Ko00004_ooool00ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool01Ol000001?oooooo0000o`000?l0000@ooooo`03o`000?oo
oooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool06?ooool01?l0003oooooo`000?l0
0003ooooo`;o00000_ooool4o`0000cooooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool0
0ol0003oooooooooo`0Gooooo`?o00000oooool00ol0003oooooooooo`07o`0000[ooooo00?o0000
ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0Eooooo`;o000000?oooooo`00
0?ooool00_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000
ooooooooool0oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0Booooo`Ko00000oooool3o`00
0003ooooool0003o000000?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3ooooo
odkooooo002Wooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00ol00006ooooo`;o
00000oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo
00?o0000ooooooooool03oooool01?l0003oooooooooooooool4o`0000?ooooo0_l00005ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooom@ooooo`00ZOooool00ol0003ooooo
ooooo`0>ooooo`08o`000?ooooooooooooooool0003oooooo`000?ooool3o`0000Oooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo
00gooooo00Wo0000ooooooooooooooooo`000?oooooo0000ooooool000000_ooool3o`0000Cooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oo
oooooooo00cooooo0ol000000ooooooo0000o`000002o`0000Kooooo1?l00005ooooo`03o`000?oo
oooooooo0?ooooooDoooool00:cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`04
o`0000[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooeCooooo002]oooo
o`03o`000?oooooooooo00[ooooo00Co0000oooooooooooooooo0ol0000>ooooo`03o`000?oooooo
oooo0?ooooooEOooool00:kooooo00?o0000ooooooooool02Oooool01ol0003ooooooooooooooooo
0000ooooool000003Oooool00ol0003oooooooooo`3ooooooeKooooo002_ooooo`03o`000?oooooo
oooo00Sooooo00Oo0000ooooooooooooooooo`000?oooooo000000cooooo00?o0000ooooooooool0
oooooomGooooo`00/?ooool00ol0003oooooooooo`07ooooo`07o`000?ooooooooooooooool0003o
ooooo`00000;ooooo`03o`000?oooooooooo0?ooooooF?ooool00;7ooooo00?o0000ooooooooool0
1_ooool01ol0003ooooooooooooooooo0000ooooool000002_ooool00ol0003oooooooooo`3ooooo
oeWooooo002booooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooF_ooool00;?ooooo00?o0000oooooooo
ool01Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomKooooo`00]?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooecooooo002eooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool01?l00005ooooo`03o`000?oooooooooo0?oo
ooooGOooool00;Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomNooooo`00]oooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3ooooo
oeoooooo002hooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`3oooooof3ooooo002iooooo`03o`000?oooooo000000;ooooo00Ko0000oooo
oooooooo0000ooooool0003oooooof?ooooo002jooooo`;o00000_ooool00ol0003oooooooooo`02
o`000?ooooooI?ooool00:gooooo0ol00004ooooo`;o00001Oooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo0?ooooooHoooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`;o000000?oooooo`000?ooool00_l0003oooooofGooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooo`000002
o`000003ooooool0003ooooo0?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`03o`000?oooooooooo00Go0000oooooomTooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`3oooooof?ooooo002]ooooo`;o00001?ooool01?l0003oooooooooool0
0004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00[_oo
ool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo0?ooooooHoooool00;cooooo00?o0000ooooool000000oooool00ol0003ooooooooo
o`3oooooof;ooooo002looooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0oooooomR
ooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool00;co
oooo00?o0000ooooool000000oooool00ol0003oooooooooo`3oooooof;ooooo0029ooooo`?o0000
<?ooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooHoooool008Sooooo1Ol0
000_ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0oooooomRooooo`00R?ooool0
0ol0003oooooooooo`02o`0002oooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3o
ooooof;ooooo0028ooooo`03o`000?oooooo000000;o0000;oooool00ol0003oooooo`000003oooo
o`03o`000?oooooooooo0?ooooooH_ooool008Sooooo0_l000001?oooooo0000o`000?l0000^oooo
o`03o`000?oooooo000000?ooooo00?o0000ooooooooool0oooooomRooooo`00R_ooool01Ol0003o
oooooooooooooooo000002gooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3ooooo
of;ooooo002?ooooo`;o0000:oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo0?oo
ooooH_ooool0097ooooo0_l0000Yooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0
oooooomRooooo`00Toooool2o`0002Oooooo00?o0000ooooool000000_l000000ooooooo0000oooo
o`3oooooof?ooooo002Eooooo`;o00009Oooool00ol0003oooooo`000003ooooo`03o`000?oooooo
oooo0?ooooooH_ooool009Oooooo00?o0000ooooooooool08_ooool00ol0003oooooo`000003oooo
o`03o`000?oooooooooo0?ooooooH_ooool009Sooooo0_l0000Sooooo`;o00001?ooool00ol0003o
ooooooooo`3oooooof7ooooo002Jooooo`;o00008Oooool2o`0000Cooooo00?o0000ooooooooool0
oooooomQooooo`00W?ooool2o`0001oooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOoo
ool009kooooo00?o0000ooooooooool07?ooool2o`0000Cooooo00?o0000ooooooooool0oooooomQ
ooooo`00Woooool2o`0001cooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOooool00:7o
oooo0_l0000Jooooo`;o00001?ooool00ol0003oooooooooo`3oooooof7ooooo002Sooooo`;o0000
6?ooool4o`0000;ooooo00?o0000ooooooooool0oooooomQooooo`00YOooool2o`0001Kooooo0_l0
0004ooooo`03o`000?oooooooooo0?ooooooHOooool00:Oooooo00?o0000ooooooooool04oooool2
o`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00Z?ooool2o`0001?ooooo0_l00004oooo
o`03o`000?oooooooooo0?ooooooHOooool00:[ooooo0_l0000Aooooo`;o00001?ooool00ol0003o
ooooooooo`3oooooof7ooooo002/ooooo`;o00003oooool2o`0000Cooooo00?o0000ooooooooool0
oooooomQooooo`00[_ooool00ol0003oooooooooo`0<ooooo`;o00001?ooool00ol0003ooooooooo
o`3oooooof7ooooo002_ooooo`;o00003?ooool2o`0000Cooooo00?o0000ooooooooool0oooooomQ
ooooo`00/Oooool2o`0000[ooooo1?l00002ooooo`03o`000?oooooooooo0?ooooooHOooool00;?o
oooo0_l00008ooooo`;o00001?ooool00ol0003oooooooooo`3oooooof7ooooo002eooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3ooooo
002fooooo`;o00001_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?oo
ool00;Sooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomP
ooooo`00^_ooool2o`0000;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooo
of3ooooo002/ooooo`Go00000oooool2o`0000Kooooo1ol000000ooooooo0000ooooo`3oooooof7o
oooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001oooool2o`00
00?ooooo0_l0003oooooof;ooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00001oooool3o`0000;ooooo0_l0003oooooof;ooooo002_ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`05ooooo`Go000000?oooooo`000?ooool0oooooomQoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo0ol000000ooooooo0000o`00
003oooooof?ooooo002]ooooo`?o00001?ooool2o`0000Sooooo00Co0000oooooooooooo0000oooo
oomUooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000
oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_oooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?oooooo
ooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000
ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003o
ooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34427 .16207 .00609 0 365.73 arc
s
newpath
.32787 .04138 .00609 0 365.73 arc
s
newpath
.34589 .03119 .00609 0 365.73 arc
s
.33823 .16289 m
.32183 .0422 L
s
.3503 .16125 m
.3339 .04056 L
s
.33086 .04668 m
.34889 .03649 L
s
.32487 .03608 m
.34289 .02589 L
s
.33324 .02897 m
.33564 .04503 L
s
.35974 .04144 m
.35734 .02537 L
s
.34427 .16207 m
.22984 .12035 L
s
.33324 .02897 m
.35734 .02537 L
s
.33564 .04503 m
.35974 .04144 L
s
.33324 .02897 m
.34589 .03119 L
s
.35734 .02537 m
.34589 .03119 L
s
newpath
.22984 .12035 .00457 0 365.73 arc
s
newpath
.22984 .12035 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00Co0000oooooooooooooooo1Ol0
00000ooooooo0000o`000002o`0000oooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool0
0ol0003oooooooooo`0Iooooo`03o`000?oooooo000000Wo000000?oooooo`000?ooool03Oooool0
0ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01Sooooo1Ol00003oooo
o`;o00000oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooBoooool00:Co
oooo00?o0000ooooooooool05_ooool4o`000003ooooool0003o000000;o00000_ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o0000oooooooo
ool04oooool2o`000003ooooool0003ooooo00;ooooo00?o0000ooooooooool00oooool01?l0003o
ooooooooool0000;ooooo`03o`000?oooooooooo0?ooooooCOooool00:Kooooo00?o0000oooooooo
ool04Oooool6o`0000?ooooo1Ol00004ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0?ooooo`;o00000oooool2o`0000Cooooo
0_l00006ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooooom?ooooo`00Z?oo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`;o00002?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`03ooooo`;o000000?oooooo`000?ooool01_ooool4
o`0000Kooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00?ooooo0ol00002ooooo`Ko00002Oooool00ol0003oooooooooo`3ooooo
oe;ooooo002[ooooo`03o`000?oooooooooo00[ooooo0ol00002ooooo`Ko00003_ooool00ol0003o
ooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
1Ol0000@ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`02ooooo`?o00003_ooool00ol0003oooooooooo`3ooooooeGooooo002^
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00000=
ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool0oooooomGoooo
o`00/?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool0
00002oooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool00_ooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo0?oooooo
FOooool00;;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooo000000Wooooo00?o0000ooooooooool0oooooomJooooo`00/oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`3o
oooooe_ooooo002dooooo`03o`000?oooooooooo00?ooooo00Oo0000ooooooooooooooooo`000?oo
oooo000000Oooooo00?o0000ooooooooool0oooooomLooooo`00]Oooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooooooo`?o00001_ooool00ol0003oooooooooo`3ooooooegooooo002f
ooooo`05o`000?ooooooooooooooool000000oooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooooooo0?ooooooG_ooool00;Oooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00003ooooo`03o`000?oooooooooo0?ooooooGoooool00;Sooooo00?o0000ooooool00000
0oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Wooooo
0_l00003ooooo`06o`000?ooooooooooo`000?oooooo0000oooooomSooooo`00^_ooool01Ol0003o
oooooooooooooooo000000;ooooo0_l0003oooooofCooooo002]ooooo`?o00001?ooool2o`0000Go
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002^ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000003ooooool0003ooooo
00;o0000oooooomUooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Cooooo00?o0000ooooool000000_l00002ooooo`03o`000?oooooooooo0?ooooooH_ooool00:ko
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo
00Go0000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002]oooo
o`;o00001?ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000?ooooo00?o
0000ooooooooool0oooooomRooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool00;cooooo00?o0000
ooooool000000oooool00ol0003oooooooooo`3oooooof;ooooo002looooo`03o`000?oooooo0000
00?ooooo00?o0000ooooooooool0oooooomRooooo`00_?ooool00ol0003oooooo`000003ooooo`03
o`000?oooooooooo0?ooooooH_ooool00;cooooo00?o0000ooooool000001?ooool00ol0003ooooo
ooooo`3oooooof7ooooo002looooo`03o`000?oooooo000000;o00000_ooool00ol0003ooooooooo
o`3oooooof7ooooo002looooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0oooooomQ
ooooo`00_?ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooHOooool00;go
oooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo0_l00004ooooo`03o`00
0?oooooooooo0?ooooooHOooool00;gooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOoo
ool00;gooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo0_l00005oooo
o`03o`000?oooooooooo0?ooooooH?ooool00;gooooo1?l00003ooooo`03o`000?oooooooooo0?oo
ooooH?ooool00;gooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool008Oooooo1Ol0
000booooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPooooo`00Qoooool0
0ol0003oooooooooo`02o`0003;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3o
ooooof3ooooo0026ooooo`;o000000Coooooo`000?l0003o0000<_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo0?ooooooH?ooool008Kooooo0ol000000ooooooo0000o`000002o`00
033ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3ooooo0027ooooo`Co
00000oooool3o`0002gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3o
oooo002Aooooo`;o0000:oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo
Goooool009?ooooo0ol0000Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooo
oomOooooo`00U_ooool3o`0002Gooooo0ol00004ooooo`03o`000?oooooooooo0?ooooooGoooool0
09Wooooo0_l0000Sooooo`;o00001Oooool00ol0003oooooooooo`3ooooooeoooooo002Kooooo`?o
00008?ooool2o`0000Gooooo00?o0000ooooooooool0oooooomOooooo`00W_ooool3o`0001gooooo
0_l00005ooooo`03o`000?oooooooooo0?ooooooGoooool00:7ooooo0_l0000Kooooo`;o00001Ooo
ool00ol0003oooooooooo`3ooooooeoooooo002Sooooo`?o00006?ooool2o`0000Kooooo00?o0000
ooooooooool0oooooomNooooo`00Y_ooool3o`0001Gooooo0_l00006ooooo`03o`000?oooooooooo
0?ooooooG_ooool00:Wooooo0ol0000Booooo`03o`000?oooooo000000Gooooo00?o0000oooooooo
ool0oooooomNooooo`00[?ooool2o`00013ooooo0ol00005ooooo`03o`000?oooooooooo0?oooooo
G_ooool00:kooooo0ol0000=ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0oooo
oomNooooo`00/Oooool3o`0000[ooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`3o
oooooekooooo002dooooo`;o00002?ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo
0?ooooooG_ooool00;Kooooo0ol00005ooooo`03o`000?oooooo000000Gooooo00?o0000oooooooo
ool0oooooomNooooo`00^Oooool3o`0000;ooooo00?o0000ooooool000000_ooool3o`000003oooo
ool0003ooooo0?ooooooG_ooool00:cooooo1Ol00003ooooo`;o00001_ooool3o`0000;ooooo0_l0
0003ooooo`;o0000oooooomOooooo`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000Oooooo1Ol00003ooooo`;o0000oooooomOooooo`00[_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool00ol00003ooooo`03o`00
0?oooooooooo0?ooooooGOooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo1Ol000001Ooooooo0000oooooooooooo00000?ooooooGoooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo0?ooooooGOooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00Co0000oooooooooooooooo
0_l000000ooooooo0000o`00003oooooof3ooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3ooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooo
oomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`00
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?oo
ool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002`oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool0
0:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`00
00?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34943 .1612 .00609 0 365.73 arc
s
newpath
.32528 .04181 .00609 0 365.73 arc
s
newpath
.34288 .0309 .00609 0 365.73 arc
s
.34346 .16241 m
.31931 .04302 L
s
.3554 .15999 m
.33125 .04061 L
s
.32849 .04699 m
.34609 .03608 L
s
.32207 .03664 m
.33967 .02573 L
s
.33052 .03437 m
.33963 .04782 L
s
.3598 .03416 m
.35069 .02071 L
s
.34943 .1612 m
.22991 .13773 L
s
.33052 .03437 m
.35069 .02071 L
s
.33963 .04782 m
.3598 .03416 L
s
.33052 .03437 m
.34288 .0309 L
s
.35069 .02071 m
.34288 .0309 L
s
newpath
.22991 .13773 .00457 0 365.73 arc
s
newpath
.22991 .13773 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool01Oooool2o`0001Kooooo00?o0000ooooooooool0oooooom6ooooo`00
Woooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Cooooo00?o0000ooooool00000
5Oooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool00_ooool2o`000004ooooool0003oooooo`0001?ooooo00?o0000ooooooooool0
oooooom8ooooo`00XOooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo00;o00000_oo
ool01Ol0003ooooooooooooooooo0000017ooooo00?o0000ooooooooool0oooooom9ooooo`00X_oo
ool00ol0003oooooooooo`0Iooooo`04o`000?oooooo0000o`0000?ooooo0_l00003ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003ooooooooo
o`0Hooooo`?o00000oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0Fooooo`Oo00000_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooom<
ooooo`00YOooool00ol0003oooooooooo`0Cooooo`Go000000?oooooo`000?ooool00oooool00ol0
003oooooooooo`02ooooo`;o00002_ooool00ol0003oooooooooo`3oooooodgooooo002Vooooo`03
o`000?oooooooooo013ooooo1_l00002ooooo`;o000000Coooooo`000?l0003o00000oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o0000oooooooo
ool03_ooool2o`0000?ooooo0_l00004ooooo`;o00000oooool2o`0000_ooooo00?o0000oooooooo
ool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo
0ol000000ooooooo0000o`000004ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
oooooom@ooooo`00ZOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?ooooo0_l0
00000ooooooo0000ooooo`04ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooo
oomAooooo`00Z_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00?ooooo1?l00003
ooooo`;o00003?ooool00ol0003oooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo
00Wooooo0ol00002ooooo`?o00000_ooool00ol0003oooooo`00000=ooooo`03o`000?oooooooooo
0?ooooooDoooool00:cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03o`000003
ooooool0003ooooo00;ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeCo
oooo002]ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool3o`0000kooooo
00?o0000ooooooooool0oooooomEooooo`00[_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooeKooooo002_
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo0?ooooooEoooool00;3ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHoooo
o`00/Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo0_l0000;ooooo`03
o`000?oooooooooo0?ooooooFOooool00;;ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`02ooooo`;o00002_ooool00ol0003oooooooooo`3ooooooe[ooooo002cooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00_ooool2o`0000Wooooo00?o0000ooooooooool0oooo
oomKooooo`00]?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooG?ooool00;Gooooo00Go0000ooooooooooooooooo`000004
ooooo`?o00001_ooool00ol0003oooooooooo`3ooooooegooooo002fooooo`04o`000?oooooooooo
o`0000Cooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`3ooooooekooooo002goooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3o
oooooeoooooo002hooooo`03o`000?oooooo000000?ooooo00?o0000ooooool000000oooool00ol0
003oooooooooo`3oooooof3ooooo002iooooo`;o00000oooool00ol0003oooooo`000002ooooo`03
o`000?oooooooooo0?ooooooHOooool00;[ooooo00Go0000ooooooooooooooooo`000002ooooo`;o
0000oooooomTooooo`00[Oooool3o`0000Cooooo0_l00004ooooo`;o00000_ooool01?l0003ooooo
ooooool0003oooooofGooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001?ooool2o`000003ooooool0003ooooo00;o0000oooooomUooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooool000000_l000000ooooooo
0000ooooo`3oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001?ooool00ol0003oooooooooo`05o`000?ooooooI?ooool00:kooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooo
ooooool0oooooomRooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0
003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:kooooo00?o0000oooooooo
ool00oooool2o`0000Kooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3oooooof;o
oooo002looooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0oooooomRooooo`00_?oo
ool00ol0003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool00;cooooo00?o0000
ooooool000001?ooool00ol0003oooooooooo`3oooooof7ooooo002mooooo`;o00001?ooool00ol0
003oooooooooo`3oooooof7ooooo002mooooo`Co00000_ooool00ol0003oooooooooo`3oooooof7o
oooo002mooooo`;o00001?ooool00ol0003oooooooooo`3oooooof7ooooo002mooooo`;o00001Ooo
ool00ol0003oooooooooo`3oooooof3ooooo002mooooo`;o00001Oooool00ol0003oooooooooo`3o
ooooof3ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPoooo
o`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00;kooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3ooooo002nooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0oooooomOooooo`00__ooool3o`0000Cooooo00?o0000
ooooooooool0oooooomOooooo`00__ooool2o`0000Gooooo00?o0000ooooooooool0oooooomOoooo
o`00__ooool2o`0000Gooooo00?o0000ooooooooool0oooooomOooooo`00__ooool2o`0000Gooooo
00?o0000ooooooooool0oooooomOooooo`00__ooool2o`0000Kooooo00?o0000ooooooooool0oooo
oomNooooo`00__ooool2o`0000Kooooo00?o0000ooooooooool0oooooomNooooo`00__ooool00ol0
003oooooo`000005ooooo`03o`000?oooooooooo0?ooooooG_ooool00;kooooo00?o0000ooooool0
00001Oooool00ol0003oooooooooo`3ooooooekooooo002nooooo`03o`000?oooooo000000Gooooo
00?o0000ooooooooool0oooooomNooooo`00__ooool3o`0000Kooooo00?o0000ooooooooool0oooo
oomMooooo`00__ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo0?ooooooGOoo
ool008Oooooo1Ol0000booooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool0oooo
oomMooooo`00Qoooool00ol0003oooooooooo`02o`0003;ooooo00Co0000oooooooooooo00001Ooo
ool00ol0003oooooooooo`3ooooooegooooo0026ooooo`;o000000?oooooo`000?l000000_l0000a
ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool0oooooomLooooo`00Q_ooool3
o`000004ooooool0003o0000ooooo`Go0000;?ooool01?l0003oooooooooool00006ooooo`03o`00
0?oooooooooo0?ooooooG?ooool008Oooooo1?l00007ooooo`Go00009oooool01Ol0003ooooooooo
oooooooo000000Gooooo00?o0000ooooooooool0oooooomLooooo`00Uoooool5o`0002;ooooo00Go
0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo0?ooooooG?ooool009cooooo1Ol0
000Mooooo`?o000000?oooooo`000?ooool01?ooool00ol0003oooooooooo`3ooooooecooooo002Q
ooooo`Go00006?ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool0oooo
oomKooooo`00Y_ooool6o`0001;ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oo
oooooooo0?ooooooFoooool00:cooooo1Ol0000=ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`3ooooooe_ooooo002aooooo`Go00002?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomKoooo
o`00]_ooool5o`0000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04o`000?oo
ooooGOooool00:cooooo1Ol00003ooooo`;o00001Oooool5o`0000?ooooo00?o0000ooooool00000
0oooool2o`000?ooooooG?ooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooo000000Go00000oooool2o`000?ooooooG?ooool00:kooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00?o
oooo1?l00002ooooo`03o`000?oooooooooo0?ooooooF_ooool00:oooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00Gooooo1Ol000000ooooooo0000ooooo`04ooooo`03
o`000?oooooooooo0?ooooooF_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool00oooool3o`000003ooooool0003o0000
0?ooooooGOooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3ooooooegooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool0
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCo
oooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35338 .1603 .00609 0 365.73 arc
s
newpath
.32331 .04226 .00609 0 365.73 arc
s
newpath
.3406 .03086 .00609 0 365.73 arc
s
.34748 .1618 m
.31741 .04377 L
s
.35928 .15879 m
.32921 .04076 L
s
.32667 .04735 m
.34395 .03594 L
s
.31996 .03718 m
.33724 .02578 L
s
.33104 .03943 m
.34514 .04747 L
s
.35721 .02631 m
.3431 .01827 L
s
.35338 .1603 m
.23169 .15508 L
s
.33104 .03943 m
.3431 .01827 L
s
.34514 .04747 m
.35721 .02631 L
s
.33104 .03943 m
.3406 .03086 L
s
.3431 .01827 m
.3406 .03086 L
s
newpath
.23169 .15508 .00457 0 365.73 arc
s
newpath
.23169 .15508 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool00_ooool2o`0001[ooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo00;ooooo00Co0000ooooool0003o00005oooool00ol0
003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo01cooooo00Co0000oooooooo
oooooooo0_l00003ooooo`;o00005?ooool00ol0003oooooooooo`3oooooodOooooo002Pooooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool00ol00005ooooo`;o00004Oooool00ol0003o
ooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo1Ol000000ooooooo0000
ooooo`05ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooom9ooooo`00X_oo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooo000000;o00000_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool0
0ol0003oooooooooo`0Fooooo`Go000000Goooooo`000?ooooooooooo`000004ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0D
ooooo`03o`000?oooooooooo00Go00000_ooool01Ol0003ooooooooooooooooo000000kooooo00?o
0000ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0Aooooo`;o00000oooool3
o`0000Cooooo00Go0000ooooooooooooooooo`00000=ooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool03oooool4o`0000;ooooo1?l000000ooooooo0000o`000003
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000000oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooom?oooo
o`00Z?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo0ol000000ooooooo
0000o`000005ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooom@ooooo`00
ZOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000
0_l00005ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooomAooooo`00Z_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo0ol00002ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe;ooooo002[
ooooo`03o`000?oooooooooo00Sooooo0_l00003ooooo`;o000000?oooooo`000?ooool00_ooool2
o`000003ooooool0003ooooo00[ooooo00?o0000ooooooooool0oooooomCooooo`00[?ooool00ol0
003oooooooooo`07ooooo`?o000000Coooooo`000?l0003ooooo0_l00005ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool0oooooomDooooo`00[Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooo000000?ooooo1?l0000>ooooo`03o`000?oooooooooo0?ooooooEOooool00:ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`;o00003oooool00ol0003o
ooooooooo`3ooooooeKooooo002_ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
0oooool2o`0000kooooo00?o0000ooooooooool0oooooomGooooo`00/?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`3ooooooeSooooo002aooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00;;ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0oooooomJooooo`00/oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooe_ooooo002dooooo`05o`00
0?ooooooooooooooool000001Oooool2o`0000Sooooo00?o0000ooooooooool0oooooomLooooo`00
]Oooool01Ol0003ooooooooooooooooo000000Cooooo0ol00006ooooo`03o`000?oooooooooo0?oo
ooooGOooool00;Kooooo00Co0000oooooooooooo00001?ooool2o`0000Kooooo00?o0000oooooooo
ool0oooooomNooooo`00]oooool00ol0003oooooo`000004ooooo`03o`000?oooooo000000Cooooo
00?o0000ooooooooool0oooooomOooooo`00^?ooool00ol0003oooooo`000003ooooo`03o`000?oo
oooo000000?ooooo00?o0000ooooooooool0oooooomPooooo`00^Oooool2o`0000?ooooo00?o0000
ooooool000000_ooool00ol0003oooooooooo`3oooooof7ooooo002jooooo`09o`000?oooooooooo
ooooool0003oooooo`000?oooooo00000?ooooooI?ooool00:gooooo0ol00004ooooo`;o00001?oo
ool2o`0000;ooooo00Co0000oooooooooooo0000oooooomUooooo`00[_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000Cooooo0_l000000ooooooo0000ooooo`02o`000?oooooo
IOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooo000000;o000000?oooooo`000?ooool0oooooomTooooo`00[_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol0003oooooofCooooo
002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0003ooooo
ooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:gooooo0_l00004ooooo`04o`00
0?ooooooooooo`0000Gooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3oooooof;o
oooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00006ooooo`03o`000?oooooo000000?ooooo
00?o0000ooooooooool0oooooomRooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`000?oo
oooooooo0?ooooooH_ooool00;cooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3o
ooooof7ooooo002mooooo`;o00001?ooool00ol0003oooooooooo`3oooooof7ooooo002mooooo`;o
00001?ooool00ol0003oooooooooo`3oooooof7ooooo002mooooo`Co00000_ooool00ol0003ooooo
ooooo`3oooooof7ooooo002mooooo`;o00001Oooool00ol0003oooooooooo`3oooooof3ooooo002n
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00;kooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003ooooo
ooooo`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003oooooooooo`3ooooooeoooooo002n
ooooo`;o00001Oooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`?o00001Oooool00ol0
003oooooooooo`3ooooooekooooo002nooooo`03o`000?oooooo000000Gooooo00?o0000oooooooo
ool0oooooomNooooo`00__ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;kooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`3ooooooekooooo002n
ooooo`03o`000?oooooo000000Kooooo00?o0000ooooooooool0oooooomMooooo`00__ooool01?l0
003oooooooooool00005ooooo`03o`000?oooooooooo0?ooooooGOooool00;kooooo00Co0000oooo
oooooooo00001Oooool00ol0003oooooooooo`3ooooooegooooo002nooooo`04o`000?oooooooooo
o`0000Gooooo00?o0000ooooooooool0oooooomMooooo`00__ooool01?l0003oooooooooool00006
ooooo`03o`000?oooooooooo0?ooooooG?ooool00;kooooo0ol000000ooooooo0000ooooo`04oooo
o`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00Go0000ooooooooooooooooo`000005oooo
o`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00Go0000ooooooooooooooooo`000005oooo
o`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00Go0000ooooooooooooooooo`000006oooo
o`03o`000?oooooooooo0?ooooooFoooool00;kooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFoooool00;kooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFoooool00;kooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooF_oo
ool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo0?ooooooF_ooool00;kooooo0ol00003ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0oooooomJooooo`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0oooooomJooooo`00__ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0oooooomIooooo`00R?ooool5o`00037ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFOoo
ool008Sooooo00?o0000ooooooooool00_l0000aooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool00_l000000ooooooo0000ooooo`3ooooooe[ooooo0027ooooo`;o000000?oooooo`00
0?l000002_l0000Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool000000_ooool2o`00
0?ooooooFoooool008Oooooo0ol000000ooooooo0000o`000009oooooaGo000000?oooooo`000?l0
00000ol00003ooooo`;o00002?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000?o
oooo0_l0003ooooooe[ooooo0028ooooo`Co00007ooooolEo`0000Kooooo00?o0000ooooooooool0
0_ooool2o`000?ooooooF_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooo000000Wo00000_ooool00ol0003oooooooooo`3ooooooeSooooo
002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`Go0000
0oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooF?ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool01Oooool3o`000003ooooool0003o00000?ooooooFoooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`3ooooooe_ooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo
00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol0
0003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo
1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35593 .1596 .00609 0 365.73 arc
s
newpath
.32203 .04261 .00609 0 365.73 arc
s
newpath
.33908 .03086 .00609 0 365.73 arc
s
.35008 .1613 m
.31618 .04431 L
s
.36178 .15791 m
.32788 .04092 L
s
.32549 .04762 m
.34254 .03587 L
s
.31858 .0376 m
.33562 .02584 L
s
.33471 .04293 m
.35095 .04334 L
s
.35156 .01898 m
.33533 .01858 L
s
.35593 .1596 m
.23493 .17355 L
s
.33471 .04293 m
.33533 .01858 L
s
.35095 .04334 m
.35156 .01898 L
s
.33471 .04293 m
.33908 .03086 L
s
.33533 .01858 m
.33908 .03086 L
s
newpath
.23493 .17355 .00457 0 365.73 arc
s
newpath
.23494 .17355 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo2ol0000Foooo
o`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000ooooooooool07Oooool2o`0000So
oooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo0_l00008ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
oooooom7ooooo`00X?ooool00ol0003oooooooooo`0Kooooo`Go00001Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool06_ooool3
o`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool06Oooool3o`0000?ooooo00Go0000oooo
ooooooooooooo`00000Aooooo`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000oooo
ooooool05_ooool4o`000005ooooool0003oooooooooool000000oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo0?ooooooBoooool00:Cooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`04o`0000;ooooo00Co0000oooooooooooo00004?ooool00ol0003oooooooooo`3o
ooooodcooooo002Uooooo`03o`000?oooooooooo017ooooo0_l00003ooooo`;o000000Goooooo`00
0?ooooooooooo`000002ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooom=
ooooo`00Y_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00?ooooo0ol000001?oo
oooo0000o`000?l00002ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooom>
ooooo`00Yoooool00ol0003oooooooooo`0<ooooo`Go00000oooool5o`0000Cooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03o`0000Kooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`3ooooooe3ooooo002Yooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool00oooool2o`000003ooooool0003o000000Oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01?ooool<o`0000[ooooo00?o0000ooooooooool0oooooomBooooo`00Zoooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo0_l000000ooooooo0000ooooo`0A
ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o0000ooooooooool01_ooool3o`00
00;ooooo0_l000000ooooooo0000o`00000Aooooo`03o`000?oooooooooo0?ooooooE?ooool00:go
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`02o`0000?ooooo1?l0000>ooooo`03
o`000?oooooooooo0?ooooooEOooool00:kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`;o00003oooool00ol0003oooooooooo`3ooooooeKooooo002_ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo0?ooooooEoooool00;3ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00/Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`3ooooooeWooooo002booooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooF_ooool00;?ooooo
00Go0000ooooooooooooooooo`000006ooooo`;o00002Oooool00ol0003oooooooooo`3ooooooe_o
oooo002dooooo`05o`000?ooooooooooooooool000001Oooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomLooooo`00]Oooool01?l0003oooooooooool00005ooooo`?o00001_ooool00ol0003o
ooooooooo`3ooooooegooooo002fooooo`03o`000?oooooo000000Gooooo00?o0000ooooool00000
1Oooool00ol0003oooooooooo`3ooooooekooooo002gooooo`;o00001Oooool00ol0003oooooo`00
0004ooooo`03o`000?oooooooooo0?ooooooGoooool00;Sooooo0_l00004ooooo`03o`000?oooooo
000000?ooooo00?o0000ooooooooool0oooooomPooooo`00^Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooo000000;ooooo00?o0000ooooooooool0oooooomQooooo`00^Oooool2o`0000?o
oooo00?o0000ooooooooool00_l0003oooooofCooooo002]ooooo`?o00001?ooool2o`0000Cooooo
0_l00002ooooo`04o`000?ooooooooooo`000?ooooooIOooool00:kooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00003ooooo`06o`000?oooooo0000ooooool0003ooooo0_l0003o
ooooofGooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`03o`0000;ooooo00?o0000ooooooooool0oooooomRooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol0003o
ooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:gooooo0_l00004
ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000oooool00ol0003ooooo
ooooo`3oooooof;ooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`04o`000?oo
ooooooooo`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00_?ooool00ol0003oooooo`00
0004ooooo`03o`000?oooooooooo0?ooooooHOooool00;cooooo00?o0000ooooool000001?ooool0
0ol0003oooooooooo`3oooooof7ooooo002looooo`03o`000?oooooo000000Gooooo00?o0000oooo
ooooool0oooooomPooooo`00_Oooool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00
_Oooool4o`0000?ooooo00?o0000ooooooooool0oooooomPooooo`00_Oooool2o`0000Gooooo00?o
0000ooooooooool0oooooomPooooo`00__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?ooooooGoooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooo
oeoooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomOooooo`00
__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooGoooool00;kooooo0_l0
0006ooooo`03o`000?oooooooooo0?ooooooG_ooool00;kooooo0_l00006ooooo`03o`000?oooooo
oooo0?ooooooG_ooool00;kooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooG_ooool00;ko
oooo00?o0000ooooool000001_ooool00ol0003oooooooooo`3ooooooegooooo002nooooo`03o`00
0?oooooo000000Kooooo00?o0000ooooooooool0oooooomMooooo`00__ooool00ol0003oooooo`00
0006ooooo`03o`000?oooooooooo0?ooooooGOooool00;kooooo00Co0000oooooooooooo00001Ooo
ool00ol0003oooooooooo`3ooooooegooooo002nooooo`04o`000?ooooooooooo`0000Kooooo00?o
0000ooooooooool0oooooomLooooo`00__ooool01?l0003oooooooooool00006ooooo`03o`000?oo
oooooooo0?ooooooG?ooool00;kooooo00Co0000oooooooooooo00001_ooool00ol0003ooooooooo
o`3ooooooecooooo002nooooo`05o`000?ooooooooooooooool000001_ooool00ol0003ooooooooo
o`3ooooooe_ooooo002nooooo`?o000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`3o
oooooe_ooooo002nooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`3o
oooooe_ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`3ooooooe_ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe[ooooo002n
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3o
oooooeWooooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`3ooooooeWooooo002nooooo`?o00000oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo0?ooooooFOooool00;kooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo0?ooooooFOooool00;kooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooF?ooool00;kooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooF?ooool0
0;kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04o`000?ooooooF_ooool00;ko
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`000003ooooo`;o0000oooooomIooooo`00
[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool00000
0oooool2o`000?ooooooFOooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo00Gooooo1Ol00002ooooo`03o`000?oooooooooo0?oo
ooooEoooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00006ooooo`Wo
000000?oooooo`000?ooool01?ooool00ol0003oooooooooo`3ooooooeOooooo002_ooooo`04o`00
0?ooooooooooooooo`[o000000?oooooo`000?l000000ol00005ooooo`;o000000?oooooo`000?l0
0000oooooomJooooo`00Zoooool9o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo0?ooooooF_ooool00:;ooooo2Ol000000ooooooo0000oooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002;ooooo`;o00003?ooool9o`0000_ooooo0ol00004ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002:ooooo`04o`000?ooooooooooo`0000;ooooo2Ol0
000Uooooo`03o`000?oooooooooo0?ooooooI_ooool008Wooooo00?o0000ooooool000001?l0000^
ooooo`03o`000?oooooooooo0?ooooooI_ooool008Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo0?ooooooI_ooool008[ooooo00Co0000ooooool0
003o0000<?ooool00ol0003oooooooooo`3oooooofKooooo002;ooooo`03o`000?oooooooooo033o
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go
0000oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?ooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooooooo
o`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?oo
ooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo
002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?oooooo
I?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo00?o
0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35651 .15943 .00609 0 365.73 arc
s
newpath
.32174 .0427 .00609 0 365.73 arc
s
newpath
.33849 .03052 .00609 0 365.73 arc
s
.35067 .16117 m
.31591 .04443 L
s
.36235 .15769 m
.32758 .04096 L
s
.32533 .04762 m
.34207 .03545 L
s
.31816 .03777 m
.33491 .0256 L
s
.34013 .04326 m
.35476 .0362 L
s
.34417 .01426 m
.32954 .02132 L
s
.35651 .15943 m
.23896 .19135 L
s
.34013 .04326 m
.32954 .02132 L
s
.35476 .0362 m
.34417 .01426 L
s
.34013 .04326 m
.33849 .03052 L
s
.32954 .02132 m
.33849 .03052 L
s
newpath
.23896 .19135 .00457 0 365.73 arc
s
newpath
.23896 .19135 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00;ooooo0_l0
000Looooo`03o`000?oooooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool07oooool5
o`000003ooooool0003ooooo01[ooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0
003oooooooooo`0Nooooo`?o00001?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
0?ooooooAOooool009kooooo00?o0000ooooooooool07?ooool2o`0000Kooooo00?o0000oooooooo
ool05_ooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo01[ooooo
0ol00007ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooooom7ooooo`00X?oo
ool00ol0003oooooooooo`0Iooooo`04o`000?oooooo0000ooooo`?o00000oooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool06Ooo
ool3o`0000?ooooo00Go0000ooooooooooooooooo`00000Cooooo`03o`000?oooooooooo0?oooooo
BOooool00:;ooooo00?o0000ooooooooool06?ooool4o`0000;ooooo00Go0000oooooooooooooooo
o`00000Booooo`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool05_oo
ool00ol0003oooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
3oooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`000?oooooooooo01?ooooo0_l0
0002ooooo`Co00000_ooool01Ol0003ooooooooooooooooo000000oooooo00?o0000ooooooooool0
oooooom<ooooo`00YOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00;ooooo0_l0
00001?oooooo0000ooooool00004ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00?ooooo1_l0
0004ooooo`;o00003?ooool00ol0003oooooooooo`3oooooodkooooo002Wooooo`03o`000?oooooo
oooo00cooooo1Ol00003ooooo`03o`000?oooooo000000;o00000oooool2o`0000gooooo00?o0000
ooooooooool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool01Ol00002ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool0oooooom@ooooo`00ZOooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?o
oooo00Co0000oooooooooooo00000_ooool4o`0000kooooo00?o0000ooooooooool0oooooomAoooo
o`00Z_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?ooooo1?l00003ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooomBooooo`00Zoooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00?ooooo0_l000000ooooooo0000ooooo`0Aooooo`03o`00
0?oooooooooo0?ooooooDoooool00:cooooo00?o0000ooooooooool01_ooool3o`0000;ooooo0ol0
00000ooooooo0000ooooo`0@ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`02o`0000;ooooo00?o0000ooooool000000_l0000>
ooooo`03o`000?oooooooooo0?ooooooEOooool00:kooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooo000000oooooo00?o0000ooooooooool0oooooomFoooo
o`00[oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo0_l0000>ooooo`03
o`000?oooooooooo0?ooooooEoooool00;3ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`04ooooo`;o00003Oooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00oooool2o`0000cooooo00?o0000ooooooooool0oooo
oomIooooo`00/_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002cooooo`05o`000?oooooooooo
ooooool000001_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooFoooool0
0;Cooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0oooooomLooooo`00]Oooool01?l0003oooooooooool00005ooooo`?o00001_ooool0
0ol0003oooooooooo`3ooooooegooooo002fooooo`03o`000?oooooo000000Gooooo0_l00006oooo
o`03o`000?oooooooooo0?ooooooG_ooool00;Oooooo0_l00005ooooo`;o00001Oooool00ol0003o
ooooooooo`3ooooooeoooooo002hooooo`;o00001?ooool2o`0000Cooooo00?o0000ooooooooool0
oooooomPooooo`00^Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000;ooooo00?o
0000ooooooooool0oooooomQooooo`00^Oooool2o`0000?ooooo00Go0000ooooool0003oooooo`00
003oooooofCooooo002]ooooo`?o00001?ooool2o`0000Cooooo0_l00002ooooo`04o`000?oooooo
0000o`000?ooooooIOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0003ooooo`06o`000?oooooo0000ooooool0003ooooo0_l0003oooooofGooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`03o`000003
ooooool0003ooooo0?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo00Go0000oooooomTooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`3oooooof?ooooo002]ooooo`;o00001?ooool01?l0003oooooooooool00004oooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooomRooooo`00[_ooool00ol0
003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool00003ooooo`03o`000?oooooo
oooo0?ooooooH_ooool00;cooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3ooooo
of;ooooo002looooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0oooooomQooooo`00
_?ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo0_l0
0004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo1?l00003ooooo`03o`000?oooooo
oooo0?ooooooH?ooool00;gooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3ooooo002nooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo0?ooooooGoooool00;kooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003oooooooooo`3ooooo
oeoooooo002nooooo`;o00001_ooool00ol0003oooooooooo`3ooooooekooooo002nooooo`?o0000
1Oooool00ol0003oooooooooo`3ooooooekooooo002nooooo`03o`000?oooooo000000Gooooo00?o
0000ooooooooool0oooooomNooooo`00__ooool00ol0003oooooo`000006ooooo`03o`000?oooooo
oooo0?ooooooGOooool00;kooooo00?o0000ooooool000001_ooool00ol0003oooooooooo`3ooooo
oegooooo002nooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool0oooooomMoooo
o`00__ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo0?ooooooGOooool00;ko
oooo00Co0000oooooooooooo00001_ooool00ol0003oooooooooo`3ooooooecooooo002nooooo`04
o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool0oooooomLooooo`00__ooool01Ol0003o
oooooooooooooooo000000Gooooo00?o0000ooooooooool0oooooomLooooo`00__ooool3o`000003
ooooool0003ooooo00Gooooo00?o0000ooooooooool0oooooomKooooo`00__ooool01Ol0003ooooo
oooooooooooo000000Kooooo00?o0000ooooooooool0oooooomKooooo`00__ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomKooooo`00__oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooo
oomJooooo`00__ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0oooooomJooooo`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0oooooomJooooo`00__ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomJooooo`00__ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomIooooo`00__oo
ool3o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeWooooo002n
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3o
oooooeWooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`3ooooooeSooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`3ooooooeSooooo002nooooo`03o`000?oooooooooo00Gooooo
00Co0000oooooooooooooooo0ol0003ooooooe[ooooo002nooooo`03o`000?oooooooooo00Gooooo
00Co0000ooooool0003o00000oooool00ol0003oooooooooo`3ooooooeOooooo002/ooooo`Go0000
0oooool2o`0000Sooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000004ooooo`03o`00
0?oooooooooo0?ooooooEoooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo00Kooooo1?l00003ooooo`03o`000?oooooooooo0?oo
ooooE_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo00Cooooo0ol00006ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo
00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo1ol00003ooooo`;o
00000_ooool2o`000?ooooooFOooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo0ol00009ooooo`;o0000oooooomKooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool5o`000?ooooooJ?ooool0
0:gooooo0ol00004ooooo`;o000000Coooooo`000?l0003o00001?ooool00ol0003oooooooooo`3o
ooooofKooooo002cooooo`Co00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`?o
00002oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00003_ooool00ol0003ooooo
ooooo`3oooooofKooooo002Xooooo`Co00004_ooool00ol0003oooooooooo`3oooooofKooooo002U
ooooo`?o00005_ooool3o`000?ooooooI_ooool00:7ooooo1?l0000Iooooo`03o`000?oooooooooo
0?ooooooI_ooool009kooooo0ol0000Mooooo`03o`000?oooooooooo0?ooooooI_ooool009[ooooo
1?l0000Pooooo`03o`000?oooooooooo0?ooooooI_ooool008gooooo0_l00008ooooo`?o00009?oo
ool00ol0003oooooooooo`3oooooofKooooo002<ooooo`Co00000oooool4o`0002Oooooo00?o0000
ooooooooool0oooooomVooooo`00S?ooool00ol0003oooooooooo`04o`0002_ooooo00?o0000oooo
ooooool0oooooomVooooo`00Roooool00ol0003oooooooooo`03o`0002gooooo00?o0000oooooooo
ool0oooooomVooooo`00S?ooool01?l0003oooooo`000?l0000^ooooo`03o`000?oooooooooo0?oo
ooooI_ooool008gooooo00?o0000ooooooooool0;_ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooo
oomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`00
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?oo
ool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002`oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool0
0:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`00
00?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35514 .15983 .00609 0 365.73 arc
s
newpath
.32243 .0425 .00609 0 365.73 arc
s
newpath
.33858 .02954 .00609 0 365.73 arc
s
.34928 .16146 m
.31656 .04413 L
s
.36101 .15819 m
.32829 .04086 L
s
.32624 .04725 m
.34239 .03429 L
s
.31862 .03775 m
.33476 .02479 L
s
.3456 .04029 m
.35569 .02756 L
s
.3366 .01242 m
.32651 .02515 L
s
.35514 .15983 m
.24338 .20825 L
s
.3456 .04029 m
.32651 .02515 L
s
.35569 .02756 m
.3366 .01242 L
s
.3456 .04029 m
.33858 .02954 L
s
.32651 .02515 m
.33858 .02954 L
s
newpath
.24338 .20825 .00457 0 365.73 arc
s
newpath
.24338 .20825 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`04o`000?oooooo0000o`00023ooooo00?o0000oooooooo
ool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`05o`000?oooooo0000ooooool0
00007_ooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`000?oooooooooo01oooooo
0ol00002ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0oooooom4ooooo`00WOoo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01cooooo0_l00006
ooooo`;o00005oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`000?oooooooooo
01_ooooo0_l00008ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom7oooo
o`00X?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo000000Go00001?ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool0
5oooool5o`0000Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool05oooool5o`0000?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooB_oo
ool00:?ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`02o`000005ooooool0003o
ooooooooool000001Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooBooo
ool00:Cooooo00?o0000ooooooooool04oooool01?l0003oooooooooooooool4o`0000;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooC?oo
ool00:Gooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`Ko00001?ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooCOooool00:Kooooo00?o0000oooo
ooooool03oooool2o`0000Cooooo00?o0000ooooooooool00ol00003ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0=ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooool000000oooool00ol0003oooooo`00000>oooo
o`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool03?ooool01Ol0003o
oooooooooooooooo000000;ooooo0_l00005ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool0oooooom@ooooo`00ZOooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00;o
oooo0_l000000ooooooo0000ooooo`0Cooooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`?o00004oooool00ol0003ooooo
ooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00ooo
ool00ol0003oooooo`00000Booooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o0000
ooooooooool01oooool3o`000004ooooool0003o0000ooooo`;o00004Oooool00ol0003ooooooooo
o`3ooooooeCooooo002]ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool000000oooool4
o`0000kooooo00?o0000ooooooooool0oooooomEooooo`00[_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00?ooooo0_l0000?ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oo
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool0oooooomGooooo`00/?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeSooooo
002aooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00;;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJ
ooooo`00/oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo0_l00009oooo
o`03o`000?oooooooooo0?ooooooFoooool00;Cooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3ooooooecooooo002eooooo`05o`00
0?ooooooooooooooool000001?ooool3o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00
]_ooool01?l0003oooooooooool00004ooooo`;o00001_ooool00ol0003oooooooooo`3ooooooeko
oooo002gooooo`03o`000?oooooo000000Cooooo00?o0000ooooool000001?ooool00ol0003ooooo
ooooo`3ooooooeoooooo002hooooo`03o`000?oooooo000000?ooooo00?o0000ooooool000000ooo
ool00ol0003oooooooooo`3oooooof3ooooo002iooooo`;o00000oooool00ol0003oooooo`000002
ooooo`03o`000?oooooooooo0?ooooooHOooool00;[ooooo00Go0000ooooooooooooooooo`000002
ooooo`;o0000oooooomTooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00[_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Cooooo0_l000000ooooooo0000ooooo`02o`000?ooooooIOooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo
000000;o000000?oooooo`000?ooool0oooooomTooooo`00[_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol0003oooooofCooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`000003
ooooo`03o`000?oooooooooo0?ooooooH_ooool00:gooooo0_l00004ooooo`04o`000?oooooooooo
o`0000Gooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3oooooof;ooooo002^oooo
o`03o`000?oooooooooo00?ooooo0_l00006ooooo`03o`000?oooooo000000Cooooo00?o0000oooo
ooooool0oooooomQooooo`00_Oooool2o`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00
_Oooool2o`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00_Oooool2o`0000Cooooo00?o
0000ooooooooool0oooooomQooooo`00_Oooool2o`0000Gooooo00?o0000ooooooooool0oooooomP
ooooo`00__ooool3o`0000?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00;kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003ooooooooo
o`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003oooooooooo`3ooooooeoooooo002noooo
o`;o00001Oooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001_ooool00ol0003o
ooooooooo`3ooooooekooooo002nooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0
oooooomNooooo`00__ooool3o`0000Gooooo00?o0000ooooooooool0oooooomNooooo`00__ooool0
0ol0003oooooo`000005ooooo`03o`000?oooooooooo0?ooooooG_ooool00;kooooo00?o0000oooo
ool000001_ooool00ol0003oooooooooo`3ooooooegooooo002nooooo`04o`000?ooooooooooo`00
00Gooooo00?o0000ooooooooool0oooooomMooooo`00__ooool01?l0003oooooooooool00005oooo
o`03o`000?oooooooooo0?ooooooGOooool00;kooooo00Co0000oooooooooooo00001_ooool00ol0
003oooooooooo`3ooooooecooooo002nooooo`05o`000?ooooooooooooooool000001Oooool00ol0
003oooooooooo`3ooooooecooooo002nooooo`05o`000?ooooooooooooooool000001Oooool00ol0
003oooooooooo`3ooooooecooooo002nooooo`05o`000?ooooooooooooooool000001Oooool00ol0
003oooooooooo`3ooooooecooooo002nooooo`?o000000?oooooo`000?ooool01Oooool00ol0003o
ooooooooo`3ooooooe_ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`3ooooooe_ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe_ooooo002nooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooe[ooooo002noooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooo
oe[ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeWooooo002nooooo`?o00001?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFOooool00;kooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFOooool00;ko
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oo
ooooFOooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo0?ooooooF?ooool00;kooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`04o`000?ooooooF_ooool00;kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000003
ooooo`03o`000?oooooooooo0?ooooooF?ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooo000000?ooooo0_l0003ooooooeWooooo002]ooooo`04
o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`06
ooooo`04o`000?oooooo0000o`0000;ooooo00?o0000ooooooooool0oooooomGooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01_oo
ool2o`0000Cooooo00?o0000ooooooooool0oooooomGooooo`00[oooool01Ol0003ooooooooooooo
oooo000000;ooooo00?o0000ooooooooool01Oooool5o`000003ooooool0003o000000;o00001?oo
ool00ol0003oooooooooo`3ooooooeSooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`04o`000?ooooooooooooooo`;o00000oooool3o`000003
ooooool0003o00000?ooooooF_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00Co0000ooooool0003o00002?ooool00ol0003oooooooooo`3o
oooooe[ooooo002]ooooo`?o00001?ooool2o`0000Oooooo0ol0003oooooofOooooo002kooooo`;o
000000?oooooo`000?ooool0oooooomWooooo`00^Oooool2o`0000?ooooo00?o0000ooooooooool0
oooooomVooooo`00]_ooool3o`0000Gooooo00?o0000ooooooooool0oooooomVooooo`00]?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00/_ooool2o`0000[ooooo0ol0003ooooo
ofKooooo002_ooooo`?o00003?ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`;o0000
3oooool00ol0003oooooooooo`3oooooofKooooo002[ooooo`;o00004Oooool00ol0003ooooooooo
o`3oooooofKooooo002Xooooo`?o00004oooool00ol0003oooooooooo`3oooooofKooooo002Voooo
o`;o00005_ooool00ol0003oooooooooo`3oooooofKooooo002Tooooo`;o00006?ooool00ol0003o
ooooooooo`3oooooofKooooo002Qooooo`?o00006_ooool00ol0003oooooooooo`3oooooofKooooo
002Oooooo`;o00007Oooool00ol0003oooooooooo`3oooooofKooooo002Mooooo`;o00007oooool3
o`000?ooooooI_ooool009[ooooo0ol0000Qooooo`03o`000?oooooooooo0?ooooooI_ooool009So
oooo0_l0000Tooooo`03o`000?oooooooooo0?ooooooI_ooool009Kooooo0_l0000Vooooo`03o`00
0?oooooooooo0?ooooooI_ooool008oooooo0ol000001?oooooo0000o`000?l0000Xooooo`03o`00
0?oooooooooo0?ooooooI_ooool008kooooo00?o0000ooooooooool00_l0000[ooooo`03o`000?oo
oooooooo0?ooooooI_ooool008gooooo0_l000001?oooooo0000o`000?l0000[ooooo`03o`000?oo
oooooooo0?ooooooI_ooool008gooooo0_l00003ooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool0oooooomVooooo`00S_ooool2o`000003ooooool0003ooooo02_ooooo0ol0003ooooo
ofKooooo002@ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool0
1?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000
oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool0
0ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`00
00?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5
o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35152 .16075 .00609 0 365.73 arc
s
newpath
.32424 .04204 .00609 0 365.73 arc
s
newpath
.33903 .02754 .00609 0 365.73 arc
s
.34558 .16211 m
.31831 .0434 L
s
.35745 .15938 m
.33018 .04067 L
s
.3285 .04639 m
.34329 .03189 L
s
.31998 .03769 m
.33476 .02319 L
s
.35013 .034 m
.35343 .01809 L
s
.32958 .01314 m
.32627 .02904 L
s
.35152 .16075 m
.24841 .22559 L
s
.35013 .034 m
.32627 .02904 L
s
.35343 .01809 m
.32958 .01314 L
s
.35013 .034 m
.33903 .02754 L
s
.32627 .02904 m
.33903 .02754 L
s
newpath
.24841 .22559 .00457 0 365.73 arc
s
newpath
.24842 .22559 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Oooooo`?o00008oooool00ol0003oooooooooo`3ooooood;ooooo
002Kooooo`03o`000?oooooooooo01kooooo00?o0000ooooool000001Ol0000Mooooo`03o`000?oo
oooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool07Oooool00ol0003oooooo`000002
o`0000?ooooo1?l0000Hooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000oooo
ooooool07?ooool00ol0003oooooo`000009ooooo`;o00005Oooool00ol0003oooooooooo`3ooooo
odGooooo002Nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooool000002_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool0
6Oooool00ol0003oooooooooo`06o`0000Gooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`3oooooodOooooo002Pooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00_l0
0004ooooo`05o`000?ooooooooooooooool000004oooool00ol0003oooooooooo`3oooooodSooooo
002Qooooo`03o`000?oooooooooo01Oooooo00Co0000ooooool0003o00001Oooool01Ol0003ooooo
oooooooooooo000001;ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003ooooo
ooooo`0Fooooo`;o000000?oooooo`000?l000000ol000000ooooooo0000ooooo`02ooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003ooooooooo
o`0Eooooo`Co00001?ooool2o`0000?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`3ooooood_ooooo002Tooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooooooo2_l0
000@ooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?o000000Coooooo`000?l0003o00003ooo
ool00ol0003oooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo00oooooo1?l00002
ooooo`05o`000?ooooooooooooooool000004oooool00ol0003oooooooooo`3oooooodkooooo002W
ooooo`03o`000?oooooooooo00gooooo0_l00003ooooo`03o`000?oooooo000000;ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo
00gooooo00Wo0000ooooooooooooooooo`000?oooooo0000ooooool000004oooool00ol0003ooooo
ooooo`3ooooooe3ooooo002Yooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00ooo
ool3o`0001?ooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00?ooooo0_l0000Cooooo`03o`000?oooooooooo0?ooooooD_ooool0
0:_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`?o00004_ooool00ol0
003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00Sooooo0ol000001Ooooooo
0000o`000?oooooo0000017ooooo00?o0000ooooooooool0oooooomDooooo`00[Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooo000000?ooooo0ol0000>ooooo`03o`000?oooooooooo0?oo
ooooEOooool00:kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0oooooomFooooo`00[oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`3ooooooeOooooo002`ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00;7ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`03ooooo`;o00002oooool00ol0003oooooooooo`3ooooo
oeWooooo002booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool2o`0000[o
oooo00?o0000ooooooooool0oooooomJooooo`00/oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo0_l00009ooooo`03o`000?oooooooooo0?ooooooFoooool00;Cooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003ooooooooo
o`3ooooooecooooo002eooooo`05o`000?ooooooooooooooool000001?ooool3o`0000Kooooo00?o
0000ooooooooool0oooooomMooooo`00]_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooool000001Oooool00ol0003oooooooooo`3ooooooekooooo002gooooo`04o`000?oooooo
ooooo`0000?ooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`3ooooooeoooooo002h
ooooo`03o`000?oooooo000000?ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3o
ooooof3ooooo002iooooo`;o00000oooool01_l0003oooooooooool0003oooooo`000?ooooooHooo
ool00;[ooooo0_l00002ooooo`03o`000?oooooooooo00;o0000oooooomTooooo`00[Oooool3o`00
00Cooooo0_l00005ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomS
ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo0_l00000
0ooooooo0000ooooo`02o`000?ooooooIOooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`03o`000?oooooo000000;o000000?oooooo`000?ooool0oooooomT
ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool01Ol0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00001Oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool0
0:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool000000oooool0
0ol0003oooooooooo`3oooooof;ooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00006oooo
o`03o`000?oooooo000000?ooooo00?o0000ooooooooool0oooooomRooooo`00_?ooool00ol0003o
ooooo`000004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo0_l00004ooooo`03o`00
0?oooooooooo0?ooooooHOooool00;gooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOoo
ool00;gooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo1?l00003oooo
o`03o`000?oooooooooo0?ooooooH?ooool00;gooooo0_l00005ooooo`03o`000?oooooooooo0?oo
ooooH?ooool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3ooooo
002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00;kooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003o
ooooooooo`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003oooooooooo`3ooooooeoooooo
002nooooo`?o00001?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001_ooool0
0ol0003oooooooooo`3ooooooekooooo002nooooo`;o00001_ooool00ol0003oooooooooo`3ooooo
oekooooo002nooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0oooooomNooooo`00
__ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo0?ooooooG_ooool00;kooooo00?o
0000ooooool000001_ooool00ol0003oooooooooo`3ooooooegooooo002nooooo`03o`000?oooooo
000000Kooooo00?o0000ooooooooool0oooooomMooooo`00__ooool01?l0003oooooooooool00005
ooooo`03o`000?oooooooooo0?ooooooGOooool00;kooooo00Co0000oooooooooooo00001Oooool0
0ol0003oooooooooo`3ooooooegooooo002nooooo`Co00001Oooool00ol0003oooooooooo`3ooooo
oegooooo002nooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool0oooooomLoooo
o`00__ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool0oooooomLoooo
o`00__ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool0oooooomLoooo
o`00__ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool0oooooomLoooo
o`00__ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool0oooooomKoooo
o`00__ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool0oooooomKoooo
o`00__ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0oooooomKooooo`00__ooool3o`0000;ooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`3ooooooe_ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe[o
oooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool000001?l0003ooooooecooooo
002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool00oooool00ol0003oooooo`00
0003ooooo`;o0000oooooomKooooo`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l0003ooooooe_ooooo
002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`04ooooo`04o`000?oooooo0000o`0000;ooooo00?o0000ooooooooool0oooooomIooooo`00
[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`0000;o
oooo0_l00004ooooo`03o`000?oooooooooo0?ooooooFOooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool00oooool4o`00
0003ooooool0003o00000?ooooooG?ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00Co0000oooooooooooooooo0_l00004ooooo`03o`000?oo
oooooooo0?ooooooG?ooool00:gooooo0ol00004ooooo`;o00002?ooool01?l0003oooooooooool0
003oooooofGooooo002nooooo`?o0000oooooomVooooo`00_Oooool2o`000?ooooooJ?ooool00;co
oooo00?o0000ooooool00000oooooomXooooo`00^_ooool2o`0000;ooooo00?o0000ooooooooool0
oooooomVooooo`00^?ooool2o`0000Cooooo0ol0003oooooofKooooo002gooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0oooooomVooooo`00]Oooool2o`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00]?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;;ooooo0_l0000:ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo0_l0
000<ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`;o00003oooool00ol0003oooooooooo`3ooooo
ofKooooo002[ooooo`;o00004Oooool00ol0003oooooooooo`3oooooofKooooo002Zooooo`03o`00
0?oooooooooo017ooooo0ol0003oooooofKooooo002Xooooo`;o00005?ooool00ol0003ooooooooo
o`3oooooofKooooo002Vooooo`;o00005_ooool00ol0003oooooooooo`3oooooofKooooo002Uoooo
o`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooomVooooo`00Xoooool2o`0001Wo
oooo00?o0000ooooooooool0oooooomVooooo`00X_ooool00ol0003oooooooooo`0Iooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:3ooooo0_l0000Looooo`03o`000?oooooooooo0?ooooooI_oo
ool009kooooo0_l0000Nooooo`03o`000?oooooooooo0?ooooooI_ooool009gooooo00?o0000oooo
ooooool07_ooool3o`000?ooooooI_ooool009_ooooo0_l0000Qooooo`03o`000?oooooooooo0?oo
ooooI_ooool009Wooooo0_l0000Sooooo`03o`000?oooooooooo0?ooooooI_ooool009Sooooo00?o
0000ooooooooool08oooool00ol0003oooooooooo`3oooooofKooooo002Fooooo`;o00009_ooool0
0ol0003oooooooooo`3oooooofKooooo002Booooo`Co0000:?ooool00ol0003oooooooooo`3ooooo
ofKooooo002Aooooo`04o`000?oooooo0000o`0002Wooooo00?o0000ooooooooool0oooooomVoooo
o`00T?ooool01?l0003oooooo`000?ooool2o`0002Sooooo00?o0000ooooooooool0oooooomVoooo
o`00T?ooool01?l0003oooooooooooooool2o`0002Sooooo0ol0003oooooofKooooo002Aooooo`04
o`000?oooooo0000o`0002Wooooo00?o0000ooooooooool0oooooomVooooo`00T_ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003oooo
o`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`00
00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_oooo
o`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:go
oooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Co
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34486 .16199 .00609 0 365.73 arc
s
newpath
.32757 .04142 .00609 0 365.73 arc
s
newpath
.33942 .02444 .00609 0 365.73 arc
s
.33883 .16285 m
.32154 .04228 L
s
.35089 .16112 m
.3336 .04055 L
s
.33256 .0449 m
.34442 .02793 L
s
.32257 .03793 m
.33443 .02095 L
s
.35224 .02511 m
.34791 .00945 L
s
.32444 .01595 m
.32876 .0316 L
s
.34486 .16199 m
.25382 .24289 L
s
.35224 .02511 m
.32876 .0316 L
s
.34791 .00945 m
.32444 .01595 L
s
.35224 .02511 m
.33942 .02444 L
s
.32876 .0316 m
.33942 .02444 L
s
newpath
.25382 .24289 .00457 0 365.73 arc
s
newpath
.25382 .24289 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo00Cooooo0_l0000Mooooo`03o`000?oooooooooo0?oooooo@?ooool009Wo
oooo00?o0000ooooooooool08_ooool01?l0003oooooooooooooool3o`000003ooooool0003ooooo
01_ooooo00?o0000ooooooooool0oooooom1ooooo`00V_ooool00ol0003oooooooooo`0Qooooo`Co
00001?ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?oooooo@_ooool009_ooooo
00?o0000ooooooooool07_ooool3o`0000Sooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`3ooooood?ooooo002Looooo`03o`000?oooooooooo01_ooooo0_l00002ooooo`?o00001_oo
ool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooA?ooool009gooooo00?o0000
ooooooooool06_ooool01Ol0003ooooooooooooooooo000000;ooooo0ol00003ooooo`03o`000?oo
oooooooo01Gooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003oooooooooo`0I
ooooo`04o`000?ooooooooooooooo`?o00000oooool01?l0003oooooooooool0000Fooooo`03o`00
0?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool06Oooool00ol0003ooooooooo
o`02o`0000Cooooo00Co0000oooooooooooo00005Oooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01Sooooo00Co0000oooooooooooo00000_ooool5o`0000;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oo
oooooooo01Oooooo00Ko0000ooooool0003o0000ooooool00004ooooo`Co00004_ooool00ol0003o
ooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Kooooo00?o0000ooooool00000
0ol000000ooooooo0000o`000002o`0001Cooooo00?o0000ooooooooool0oooooom:ooooo`00Xooo
ool00ol0003oooooooooo`0Fooooo`Wo00005?ooool00ol0003oooooooooo`3ooooood_ooooo002T
ooooo`03o`000?oooooooooo01Cooooo1_l00002ooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0Cooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`3oooooodgooooo002Voooo
o`03o`000?oooooooooo017ooooo1Ol00003ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0?ooooo`;o00000oooool01?l0003o
ooooooooool0000Cooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000001?ooooo00?o0000oooooooo
ool0oooooom@ooooo`00ZOooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00?ooooo
0ol0000Booooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`03ooooo`;o00004_ooool00ol0003oooooooooo`3ooooooe;ooooo002[
ooooo`03o`000?oooooooooo00[ooooo0ol00002ooooo`?o00004Oooool00ol0003oooooooooo`3o
oooooe?ooooo002/ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_l000000ooo
oooo0000o`00000@ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`02ooooo`?o00003_ooool00ol0003oooooooooo`3ooooooeGo
oooo002^ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool00ol0003ooooo
o`00000=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool0oooo
oomGooooo`00/?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooool000002oooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo
0?ooooooFOooool00;;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooo000000Wooooo00?o0000ooooooooool0oooooomJooooo`00/oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000002?ooool00ol0003ooooo
ooooo`3ooooooe_ooooo002dooooo`03o`000?oooooooooo00?ooooo00Oo0000oooooooooooooooo
o`000?oooooo000000Oooooo00?o0000ooooooooool0oooooomLooooo`00]Oooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooooooo`?o00001_ooool00ol0003oooooooooo`3ooooooego
oooo002fooooo`05o`000?ooooooooooooooool000000oooool01?l0003oooooooooool00004oooo
o`03o`000?oooooooooo0?ooooooG_ooool00;Oooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooGoooool00;Sooooo00?o0000oooo
ool000000oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooH?ooool0
0;Wooooo0_l00003ooooo`06o`000?ooooooooooo`000?oooooo0000oooooomSooooo`00^_ooool0
1Ol0003ooooooooooooooooo000000;ooooo0_l0003oooooofCooooo002]ooooo`?o00001?ooool2
o`0000Gooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000003ooooool0
003ooooo00;o0000oooooomUooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooool000000_l00002ooooo`03o`000?oooooooooo0?ooooooH_oo
ool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oo
oooooooo00Go0000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo
002]ooooo`;o00001?ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool0oooooomRooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o0000
1Oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool00;cooooo
00?o0000ooooool000000oooool00ol0003oooooooooo`3oooooof;ooooo002looooo`03o`000?oo
oooo000000?ooooo00?o0000ooooooooool0oooooomRooooo`00_?ooool00ol0003oooooo`000003
ooooo`03o`000?oooooooooo0?ooooooH_ooool00;cooooo00?o0000ooooool000001?ooool00ol0
003oooooooooo`3oooooof7ooooo002looooo`03o`000?oooooo000000;o00000_ooool00ol0003o
ooooooooo`3oooooof7ooooo002looooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0
oooooomQooooo`00_?ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo0?ooooooHOoo
ool00;gooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo0_l00004oooo
o`03o`000?oooooooooo0?ooooooHOooool00;gooooo0_l00004ooooo`03o`000?oooooooooo0?oo
ooooHOooool00;gooooo0_l00004ooooo`03o`000?oooooooooo0?ooooooHOooool00;gooooo0_l0
0005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;gooooo1?l00003ooooo`03o`000?oooooo
oooo0?ooooooH?ooool00;gooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooof3ooooo002nooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00;kooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`3oooooof3ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0oooooomPooooo`00__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oo
ooooGoooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeoooooo
002nooooo`?o00001?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001Oooool0
0ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001Oooool00ol0003oooooooooo`3ooooo
oeoooooo002nooooo`;o00001Oooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o0000
1Oooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`;o00001_ooool00ol0003ooooooooo
o`3ooooooekooooo002nooooo`;o00001_ooool00ol0003oooooooooo`3ooooooekooooo002noooo
o`03o`000?oooooo000000Gooooo00?o0000ooooooooool0oooooomNooooo`00__ooool3o`0000Go
oooo00?o0000ooooooooool0oooooomNooooo`00__ooool00ol0003oooooo`000005ooooo`03o`00
0?oooooooooo0?ooooooG_ooool00;kooooo00?o0000ooooool000001Oooool00ol0003ooooooooo
o`3ooooooekooooo002nooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0oooooomN
ooooo`00__ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo0?ooooooG_ooool00;ko
oooo00?o0000ooooool000000oooool4o`000?ooooooGoooool00:cooooo1Ol00003ooooo`;o0000
2?ooool00ol0003oooooooooo`03o`0000?ooooo00?o0000ooooooooool0oooooomMooooo`00[Ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool00_l00004ooooo`03o`000?oooooooooo0?ooooooGOooool00:kooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00007ooooo`05o`000?ooooooooooo`000?ooool00_l00002oooo
o`03o`000?oooooooooo0?ooooooGOooool00:oooooo00Go0000ooooooooooooooooo`000002oooo
o`03o`000?oooooooooo00Gooooo1Ol00004ooooo`03o`000?oooooooooo0?ooooooGOooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool00_l00004ooooo`03o`000?oooooooooo0?ooooooGOooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00Co0000ooooool0003ooooo
0_l00002ooooo`;o0000oooooomOooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`;o00001?oo
ool2o`000?ooooooHOooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00_Oooool2o`00
0?ooooooJ?ooool00;cooooo00?o0000ooooool00000oooooomXooooo`00^_ooool2o`0000;ooooo
00?o0000ooooooooool0oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`?o0000oooo
oomVooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooofKooooo002fooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00]Oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Cooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`3oooooofKooooo002cooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0oooooomVooooo`00/_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;3ooooo0_l0000<ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00?o0000ooooooooool03?ooool3o`000?ooooooI_ooool00:kooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:_ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3oooooofKo
oooo002Zooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooomVooooo`00ZOoo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooI_ooool00:Oooooo0_l0000E
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Kooooo00?o0000ooooooooool05Oooool3o`00
0?ooooooI_ooool00:Gooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`3oooooofKo
oooo002Tooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0oooooomVooooo`00Xooo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?ooooooI_ooool00:;ooooo00?o0000
ooooooooool06Oooool00ol0003oooooooooo`3oooooofKooooo002Qooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool0oooooomVooooo`00X?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo0?ooooooI_ooool009oooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`3oooooofKooooo002Mooooo`;o00007oooool3o`000?ooooooI_ooool009cooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`3oooooofKooooo002Kooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool0oooooomVooooo`00V_ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo0?ooooooI_ooool009Wooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`3oooooofKooooo002Hooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooo
oomVooooo`00UOooool3o`0001Gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002Dooooo`04o`000?oooooo0000o`0001Cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00Tooo
ool01?l0003oooooo`000?ooool2o`0001Oooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool009?ooooo00Co0000oooooooooooo
oooo0_l0000Eooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomToooo
o`00Toooool5o`0001Sooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooI_ooool009Gooooo00?o0000ooooooooool05?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooo
oooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003o
ooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?oo
ooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.33308 .16281 .00609 0 365.73 arc
s
newpath
.33346 .04101 .00609 0 365.73 arc
s
newpath
.3391 .02108 .00609 0 365.73 arc
s
.32699 .16279 m
.32737 .04099 L
s
.33917 .16283 m
.33955 .04103 L
s
.33932 .04267 m
.34496 .02274 L
s
.3276 .03935 m
.33324 .01942 L
s
.35074 .01567 m
.33959 .00386 L
s
.32188 .02059 m
.33304 .0324 L
s
.33308 .16281 m
.25876 .25931 L
s
.35074 .01567 m
.33304 .0324 L
s
.33959 .00386 m
.32188 .02059 L
s
.35074 .01567 m
.3391 .02108 L
s
.33304 .0324 m
.3391 .02108 L
s
newpath
.25876 .25931 .00457 0 365.73 arc
s
newpath
.25876 .25931 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`02o`00013ooooo00?o0000ooooooooool04?ooool00ol0003oooooo`00000Dooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool05?ooool001Kooooo00?o0000ooooooooool0DOooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02Cooooo00Go0000ooooool0003oooooo`00
000Rooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0D_ooool00ol0003ooooooooo
o`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool05?ooool009Sooooo00?o0000
ooooooooool08oooool2o`0000?ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3o
oooood3ooooo002Iooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo0?oooooo@Oooool009[ooooo00?o0000oooooooo
ool07oooool3o`0000Kooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`3ooooood;o
oooo002Kooooo`03o`000?oooooooooo01gooooo00Co0000oooooooooooo00000_ooool3o`0000;o
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood?ooooo002Looooo`03o`00
0?oooooooooo01_ooooo00Co0000oooooooooooooooo0ol00003ooooo`04o`000?oooooo0000o`00
01Sooooo00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0Iooooo`03
o`000?oooooooooo00;ooooo0_l00004ooooo`;o00006Oooool00ol0003oooooooooo`3oooooodGo
oooo002Nooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool00oooool01?l0003ooooo
ooooooooool3o`0001Wooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo0000ooooo`03o`0001Oo
oooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003oooooooooo`0Gooooo`04o`00
0?ooooooooooooooo`;o000000Coooooo`000?l0003ooooo0_l0000Fooooo`03o`000?oooooooooo
0?ooooooB?ooool00:7ooooo00?o0000ooooooooool05oooool00ol0003oooooo`000004o`000003
ooooool0003o000001Kooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003ooooo
ooooo`0Gooooo`So00005_ooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oo
oooooooo01Oooooo0ol00003ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooo
oom;ooooo`00Y?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooo000000;o00000_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o0000oooo
ooooool05?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool0oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0Cooooo`Go000000?oooooo`000?oo
ool04_ooool00ol0003oooooooooo`3oooooodkooooo002Wooooo`03o`000?oooooooooo017ooooo
0_l000001?oooooo0000ooooooooool2o`0001;ooooo00?o0000ooooooooool0oooooom?ooooo`00
Z?ooool00ol0003oooooooooo`0@ooooo`04o`000?ooooooooooo`0000;ooooo0_l0000Aooooo`03
o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool03oooool01?l0003ooooo
ooooool00002ooooo`;o00004?ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`00
0?oooooooooo00kooooo00Co0000oooooooooooo00000_ooool2o`0000oooooo00?o0000oooooooo
ool0oooooomBooooo`00Zoooool00ol0003oooooooooo`0=ooooo`Co000000Coooooo`000?l0003o
00003_ooool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool00_l00002ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
oooooomDooooo`00[Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?o000000?o
ooooo`000?ooool02oooool00ol0003oooooooooo`3ooooooeGooooo002^ooooo`03o`000?oooooo
oooo00[ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool02Oooool01?l0003oooooooooool0
0003ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooomGooooo`00/?ooool0
0ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oooooooooo00Oooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooFOoo
ool00;;ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00003ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0oooooomJooooo`00/oooool00ol0003oooooooooo`05
ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`3ooooooe_ooooo002dooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooG?ooool00;Gooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`03o`000003ooooool0003ooooo00?ooooo00?o0000
ooooooooool0oooooomMooooo`00]_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000?ooooo00Go0000ooooooooooooooooo`00003oooooof3ooooo002gooooo`05o`000?oooooo
ooooooooool000000_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
oooooomOooooo`00^?ooool01?l0003oooooooooool00002ooooo`07o`000?ooooooooooooooool0
003oooooo`00003oooooof;ooooo002iooooo`03o`000?oooooo000000;ooooo00Co0000oooooooo
oooooooo0_l0003oooooof?ooooo002jooooo`;o00000_ooool01Ol0003ooooooooooooooooo0000
0?ooooooI?ooool00:gooooo0ol00004ooooo`;o00001Oooool01?l0003oooooooooool00002oooo
o`;o0000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Cooooo0_l000001_oooooo0000ooooool0003oooooo`000?ooooooI?ooool00:kooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo000000;o00000_oo
ool00ol0003oooooooooo`3oooooof;ooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00001?ooool00ol0003oooooooooo`05o`000?ooooooI?ooool00:kooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000?ooooo
00?o0000ooooooooool0oooooomRooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo0000
1?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:kooooo
00?o0000ooooooooool00oooool2o`0000Gooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`3oooooof;ooooo002kooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooooooo
ool0oooooomRooooo`00^oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?oo
ooooH_ooool00;_ooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;o
oooo002kooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooomRooooo`00
^oooool00ol0003oooooooooo`03o`000003ooooool0003ooooo0?ooooooHoooool00;_ooooo00Co
0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002kooooo`04o`000?oo
ooooooooo`0000?ooooo00?o0000ooooooooool0oooooomRooooo`00^oooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`3oooooof?ooooo002kooooo`03o`000?oooooooooo00Co0000oooooomUooooo`00^oooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`3oooooof?ooooo002kooooo`03o`000?oooooooooo00Co0000oooooomUooooo`00^oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo0?ooooooHoooool00;_ooooo00?o0000ooooooooool01?l0003oooooofGooooo002kooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo0?ooooooHoooool00:cooooo1Ol00003ooooo`;o00001Oooool00ol0003o
ooooo`000004o`000?ooooooIOooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool00004ooooo`;o000000Goooooo`000?ooooooooooo`00003oooooofGooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000005ooooool0003o
ooooooooool00000oooooomUooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`05o`000?ooooooI?ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`3oooooof?ooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00005ooooo`Go0000oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00006ooooo`03o`000?oooooo00000?ooooooJ?ooool00;_ooooo00Co0000oooooooooooo
0000oooooomXooooo`00^oooool01?l0003oooooooooool0003oooooofSooooo002jooooo`05o`00
0?ooooooooooooooool00000oooooomXooooo`00^Oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;Sooooo00?o0000ooooooooool00oooool3o`000?ooooooI_oo
ool00;Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo002goooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomVooooo`00]_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Gooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`3oooooofKooooo002dooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0oooooomVooooo`00]?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooo
ofKooooo002booooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomVooooo`00
/Oooool00ol0003oooooooooo`0:ooooo`?o0000oooooomVooooo`00/Oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooI_ooool00:_ooooo00?o0000oooo
ooooool04?ooool3o`000?ooooooI_ooool00:_ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`3oooooofKooooo002Zooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
oooooomVooooo`00ZOooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooI_oo
ool00:Sooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3oooooofKooooo002Xoooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooomVooooo`00Yoooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooI_ooool00:Kooooo00?o0000ooooooooool0
5Oooool00ol0003oooooooooo`3oooooofKooooo002Uooooo`03o`000?oooooooooo01Kooooo0ol0
003oooooofKooooo002Uooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool0oooooomV
ooooo`00Y?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo0?ooooooI_ooool00:?o
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3oooooofKooooo002Rooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool0oooooomVooooo`00XOooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo0?ooooooI_ooool00:7ooooo00?o0000ooooooooool02Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:3ooooo00?o0000oooo
ooooool02Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002Oooooo`03o`000?oooooooooo00kooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_oo
ool009kooooo00?o0000ooooooooool03Oooool2o`0000?ooooo00Co0000oooooooooooo00001ooo
ool5o`000?ooooooI?ooool009kooooo00?o0000ooooooooool03oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00WOooool0
0ol0003oooooooooo`0<ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool009cooooo00?o0000ooooooooool03_oo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool009_ooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`3oooooofKooooo002Kooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool0oooooomVooooo`00U_ooool5o`0002?ooooo00?o0000oooooooo
ool0oooooomVooooo`00U_ooool00ol0003oooooooooo`02o`0002?ooooo00?o0000ooooooooool0
oooooomVooooo`00UOooool2o`000004ooooool0003oooooo`0002?ooooo0ol0003oooooofKooooo
002Fooooo`;o000000?oooooo`000?l000008oooool00ol0003oooooooooo`3oooooofKooooo002H
ooooo`;o00009?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?oo
ooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000ooo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o
0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0
003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.37517 .1512 .00609 0 365.73 arc
s
newpath
.31242 .04681 .00609 0 365.73 arc
s
newpath
.33263 .0423 .00609 0 365.73 arc
s
.36995 .15434 m
.3072 .04995 L
s
.38039 .14807 m
.31764 .04367 L
s
.31374 .05275 m
.33395 .04824 L
s
.31109 .04087 m
.3313 .03635 L
s
.3294 .02987 m
.31578 .03871 L
s
.32904 .05915 m
.34266 .0503 L
s
.37517 .1512 m
.32765 .26336 L
s
.3294 .02987 m
.34266 .0503 L
s
.31578 .03871 m
.32904 .05915 L
s
.3294 .02987 m
.33263 .0423 L
s
.34266 .0503 m
.33263 .0423 L
s
newpath
.32765 .26336 .00457 0 365.73 arc
s
newpath
.31763 .30127 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01Go
oooo0_l000000ooooooo0000ooooo`0Iooooo`03o`000?oooooooooo0?ooooooBoooool00:Cooooo
00?o0000ooooooooool04oooool01?l0003oooooo`000?ooool3o`0001Oooooo00?o0000oooooooo
ool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0@ooooo`;o00000oooool2o`0001Sooooo
00?o0000ooooooooool0oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0>ooooo`04o`000?oo
ooooooooooooo`Go00005_ooool00ol0003oooooooooo`3oooooodkooooo002Wooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooool000000_l000001_oooooo0000o`000?l0003oooooo`0001Co
oooo00?o0000ooooooooool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0:ooooo`?o0000
1?ooool00ol0003oooooo`000002o`0001?ooooo00?o0000ooooooooool0oooooom@ooooo`00ZOoo
ool00ol0003oooooooooo`05ooooo`Go00001Oooool01Ol0003oooooooooool0003ooooo00;o0000
4Oooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Co00004?oo
ool00ol0003oooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00oooool2o`0000Cooooo00Co0000ooooool0003ooooo0_l0000?ooooo`03o`000?oo
oooooooo0?ooooooDoooool00:cooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oo
oooooooo00;ooooo1_l0000>ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000
ooooooooool00_l00005ooooo`;o00000oooool5o`000003ooooool0003ooooo00_ooooo00?o0000
ooooooooool0oooooomEooooo`00[_ooool00ol0003oooooooooo`02o`0000;ooooo1ol00002oooo
o`04o`000?ooooooooooooooo`;o00002_ooool00ol0003oooooooooo`3ooooooeKooooo002_oooo
o`03o`000?oooooooooo00Go00000_ooool2o`0000?ooooo00Co0000ooooool0003o00002oooool0
0ol0003oooooooooo`3ooooooeOooooo002`ooooo`03o`000?oooooo000000Kooooo0_l00003oooo
o`;o00003?ooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oooooo000000Ko
oooo0_l000000ooooooo0000o`00000<ooooo`03o`000?oooooooooo0?ooooooFOooool00;;ooooo
00?o0000ooooool000001_ooool2o`000003ooooool0003ooooo00[ooooo00?o0000ooooooooool0
oooooomJooooo`00/oooool2o`0000Kooooo00Co0000oooooooooooo00002_ooool00ol0003ooooo
ooooo`3ooooooe_ooooo002dooooo`;o00001_ooool00ol0003oooooo`000009ooooo`03o`000?oo
oooooooo0?ooooooG?ooool00;Gooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000002
o`0000Kooooo00?o0000ooooooooool0oooooomMooooo`00]_ooool00ol0003oooooooooo`04oooo
o`;o00001oooool00ol0003oooooooooo`3ooooooekooooo002gooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeoooooo002gooooo`;o0000
1Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Sooooo0_l0
0004ooooo`;o00000oooool00ol0003oooooooooo`3oooooof7ooooo002hooooo`03o`000?oooooo
000000?ooooo0_l00002ooooo`03o`000?oooooooooo0?ooooooH_ooool00:gooooo0ol00004oooo
o`;o00000oooool00ol0003oooooo`000002ooooo`04o`000?oooooo0000o`000?ooooooIOooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`07o`000?oooooo
ooooo`000?oooooo0000ooooo`02o`000?ooooooIOooool00:kooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00?o000000?oooooo`000?ooool0
oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool01Ol0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0?oo
ooooHOooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool0
00001?ooool00ol0003oooooooooo`3oooooof7ooooo002^ooooo`03o`000?oooooooooo00?ooooo
0_l00006ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0oooooomPooooo`00_Ooo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo0?ooooooGoooool00;kooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3ooooooekooooo002nooooo`;o00001_ooool00ol0003oooooooooo`3ooooooeko
oooo002nooooo`?o00001_ooool00ol0003oooooooooo`3ooooooegooooo002nooooo`03o`000?oo
oooo000000Kooooo00?o0000ooooooooool0oooooomMooooo`00__ooool00ol0003oooooo`000007
ooooo`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3ooooooe_ooooo002nooooo`05o`000?ooooooooooooooool000001_ooool0
0ol0003oooooooooo`3ooooooe_ooooo002nooooo`05o`000?ooooooooooooooool000001oooool0
0ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooeWooooo002nooooo`?o0000
0oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooF?ooool00;kooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooF?oo
ool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooEoooool00;kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooE_ooool00;kooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooE_ooool00;kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooEOooool00;kooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooEOoo
ool00;kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooE?ooool00;kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooDoooool00;kooooo0ol00008ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomCooooo`00__ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomBooooo`00__ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomA
ooooo`00__ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0oooooom@ooooo`00__ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooom@ooooo`00__ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooom?ooooo`00__ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooom?ooooo`00__ooool3
o`0000gooooo00?o0000ooooooooool00_ooool4o`000?ooooooD?ooool00;kooooo00?o0000oooo
ooooool03Oooool01Ol0003ooooooooooooooooo000000?ooooo0_l0003oooooodoooooo002noooo
o`03o`000?oooooooooo00kooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3o
ooooodkooooo002nooooo`03o`000?oooooooooo00oooooo0_l00002ooooo`04o`000?oooooooooo
o`000?ooooooCoooool00;kooooo00?o0000ooooooooool03oooool2o`0000;ooooo00Co0000oooo
oooooooo0000oooooom?ooooo`00__ooool00ol0003oooooooooo`0@ooooo`?o000000?oooooo`00
0?l00000oooooom@ooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo01;o
oooo0_l0003ooooooe;ooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool00:ko
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool0oooooomBooooo`00[oooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool01Oooool5o`0000oooooo00?o0000ooooooooool0oooooomBoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`3ooooooe?ooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002nooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0oooooomDooooo`00__ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo0?ooooooEOooool00;kooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`3ooooooeGooooo002nooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0oooo
oomEooooo`00__ooool3o`0000gooooo00?o0000ooooooooool0oooooomFooooo`00__ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00;kooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`3ooooooeOooooo002nooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool0oooooomGooooo`00__ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo0?ooooooF?ooool00;kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3o
oooooeSooooo002nooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHoooo
o`00__ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00;kooooo
00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002nooooo`?o00002Ooo
ool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool0oooooomJooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
0?ooooooFoooool00;kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooe_o
oooo002nooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooomKooooo`00__oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002nooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0oooooomMooooo`00__ooool3o`0000Kooooo00?o0000oooooooo
ool0oooooomMooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
G_ooool00;kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooekooooo002n
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00__ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooGoooool00;kooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo0?ooooooH?ooool00;kooooo0ol00002ooooo`03o`000?oooooooooo0?ooooooHOooool0
0;kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3oooooof7ooooo002nooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomQooooo`00__ooool01Ol0003ooooo
oooooooooooo00000?ooooooI?ooool00;kooooo00Go0000ooooooooooooooooo`00003oooooofCo
oooo002nooooo`04o`000?ooooooooooo`000?ooooooIOooool00:gooooo0ol00004ooooo`;o0000
2?ooool01?l0003oooooooooool0003oooooofGooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo00000?ooooooI_ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo0000
0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool2o`00
0?ooooooIoooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo0_l0003oooooofOooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002mooooo`;o0000
oooooomXooooo`00_Oooool2o`000?ooooooJ?ooool00;gooooo0_l0003oooooofSooooo002joooo
o`Oo0000oooooomVooooo`00^_ooool00ol0003oooooo`000002o`000?ooooooJ?ooool00;Wooooo
00?o0000ooooool000000_ooool00ol0003oooooooooo`3oooooofKooooo002iooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00^_ooool5o`000?ooooooJ?ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00]_ooool2o`0000Kooooo00?o0000ooooooooool0oooooomVooooo`00]Oooool01?l0
003oooooooooool00005ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Cooooo00Go0000oooo
ooooooooooooo`000005ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Cooooo00Go0000oooo
ooooooooooooo`000005ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Gooooo00Co0000oooo
ool0003o00001Oooool00ol0003oooooooooo`3oooooofKooooo002fooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00
[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?oo
ool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000ooo
ool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003ooooooooo
o`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.37661 .15032 .00609 0 365.73 arc
s
newpath
.31169 .04725 .00609 0 365.73 arc
s
newpath
.32312 .02999 .00609 0 365.73 arc
s
.37146 .15356 m
.30654 .0505 L
s
.38176 .14707 m
.31685 .04401 L
s
.31677 .05062 m
.3282 .03335 L
s
.30662 .04389 m
.31804 .02663 L
s
.31063 .03294 m
.31917 .04675 L
s
.33989 .03394 m
.33135 .02013 L
s
.37661 .15032 m
.33549 .26496 L
s
.31063 .03294 m
.33135 .02013 L
s
.31917 .04675 m
.33989 .03394 L
s
.31063 .03294 m
.32312 .02999 L
s
.33135 .02013 m
.32312 .02999 L
s
newpath
.33549 .26496 .00457 0 365.73 arc
s
newpath
.32767 .3055 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01_o
oooo0ol0000Oooooo`03o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool0
6Oooool01?l0003oooooo`000?l0000Nooooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo
00?o0000ooooooooool05Oooool3o`000004ooooool0003oooooo`0001gooooo00?o0000oooooooo
ool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0Booooo`?o00000_ooool00ol0003ooooo
ooooo`02o`0001_ooooo00?o0000ooooooooool0oooooom9ooooo`00X_ooool00ol0003ooooooooo
o`0Aooooo`;o00000_ooool2o`0000;ooooo00?o0000ooooool000006Oooool00ol0003ooooooooo
o`3ooooood[ooooo002Sooooo`03o`000?oooooooooo00oooooo0_l000000ooooooo0000o`000002
ooooo`05o`000?oooooo0000ooooool000006?ooool00ol0003oooooooooo`3ooooood_ooooo002T
ooooo`03o`000?oooooooooo00gooooo1?l00004ooooo`03o`000?oooooo000000?o00005_ooool0
0ol0003oooooooooo`3oooooodcooooo002Uooooo`03o`000?oooooooooo00_ooooo0_l00002oooo
o`;o000000Koooooo`000?l0003o0000ooooool00002ooooo`;o00005?ooool00ol0003ooooooooo
o`3oooooodgooooo002Vooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00oooool0
2?l0003oooooooooool0003oooooo`000?oooooo00005Oooool00ol0003oooooooooo`3oooooodko
oooo002Wooooo`03o`000?oooooooooo00Wooooo0_l00006ooooo`03o`000?oooooooooo00;o0000
5Oooool00ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooool000001Oooool00ol0003oooooo`000002o`0001Gooooo00?o0000ooooooooool0oooo
oom@ooooo`00ZOooool00ol0003oooooooooo`06ooooo`Co00001?ooool2o`0000;ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02o`0000?ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool0oooooomCooooo`00[?ooool01Ol0003ooooooooooooooooo000000Go
oooo0ol00005ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooomDooooo`00
[Oooool01?l0003oooooooooool00005ooooo`?o00001Oooool3o`0000kooooo00?o0000oooooooo
ool0oooooomEooooo`00[_ooool00ol0003oooooo`000002o`000006ooooool0003o0000o`000?oo
oooo00001Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oo
oooo0_l00002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00;3ooooo0_l00007ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooooeSooooo
002aooooo`;o00001oooool01Ol0003ooooooooooooooooo000000cooooo00?o0000ooooooooool0
oooooomIooooo`00/_ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000_ooooo
00?o0000ooooooooool0oooooomJooooo`00/oooool00ol0003oooooooooo`05ooooo`04o`000?oo
ooooooooo`0000[ooooo00?o0000ooooooooool0oooooomKooooo`00]?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooo000000Wooooo00?o0000ooooooooool0oooooomLooooo`00]?ooool2
o`0000Kooooo00?o0000ooooool000000_l00006ooooo`03o`000?oooooooooo0?ooooooGOooool0
0;Gooooo0_l00006ooooo`;o00001oooool00ol0003oooooooooo`3ooooooekooooo002eooooo`03
o`000?oooooo000000Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeoo
oooo002fooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`3oooooof3ooooo002gooooo`03o`000?oooooo000000Cooooo0_l00003ooooo`03o`000?oo
oooooooo0?ooooooHOooool00;Oooooo00Co0000oooooooooooo00000oooool2o`0000;ooooo00?o
0000ooooooooool0oooooomRooooo`00[Oooool3o`0000Cooooo0_l00002ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000ooooool0003o0000oooooomUooooo`00[_ooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000;ooooo00Oo0000oooooooooooo0000ooooool0003ooooo
00;o0000oooooomUooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooooooo0ol000000ooooooo0000ooooo`3oooooofCooooo002^oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01?l0003ooooooooooooo
ool5o`000?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0004ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00[Ooo
ool2o`0000Cooooo00Co0000oooooooooooo00001?ooool01?l0003oooooooooool00004ooooo`03
o`000?oooooooooo0?ooooooHOooool00:kooooo00?o0000ooooooooool00oooool2o`0000Kooooo
00?o0000ooooool000001Oooool00ol0003oooooooooo`3oooooof3ooooo002mooooo`;o00001Ooo
ool00ol0003oooooooooo`3oooooof3ooooo002mooooo`;o00001_ooool00ol0003oooooooooo`3o
oooooeoooooo002nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomNoooo
o`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooG_ooool00;kooooo
0ol00006ooooo`03o`000?oooooooooo0?ooooooGOooool00;kooooo00?o0000ooooool000001_oo
ool00ol0003oooooooooo`3ooooooegooooo002nooooo`03o`000?oooooo000000Oooooo00?o0000
ooooooooool0oooooomLooooo`00__ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooFoooool00;kooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooo
oooo0?ooooooFoooool00;kooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooo
oooo0?ooooooF_ooool00;kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo0?ooooooF_ooool00;kooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo0?ooooooFOooool00;kooooo0ol00003ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomHooooo`00__ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomHooooo`00__ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomG
ooooo`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomFooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0oooooomFooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomEooooo`00__ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomEooooo`00__ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomD
ooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomCooooo`00__ooool3o`0000Wooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`3ooooooe?ooooo002nooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooe7ooooo002noooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooo
oe3ooooo002nooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`3ooooooe3ooooo002nooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3oooooodoooooo002nooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool00oooool3o`000?ooooooD?ooool00;kooooo0ol0000>ooooo`05o`000?oooooo
ooooooooool000000_ooool2o`000?ooooooCoooool00;kooooo00?o0000ooooooooool03oooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooCOooool00;kooooo00?o0000
ooooooooool03oooool00ol0003oooooo`000002ooooo`04o`000?ooooooooooo`000?ooooooC_oo
ool00;kooooo00?o0000ooooooooool04?ooool2o`0000;ooooo00Co0000oooooooooooo0000oooo
oom>ooooo`00__ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo000000;ooooo00?o0000
ooooooooool0oooooom=ooooo`00__ooool00ol0003oooooooooo`0Aooooo`?o000000?oooooo`00
0?l00000oooooom?ooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo01?o
oooo0_l0003ooooooe7ooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooDOooool00:ko
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool0oooooomAooooo`00[oooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool01Oooool5o`00013ooooo00?o0000ooooooooool0oooooomAoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`3ooooooe;ooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool0oooooomCooooo`00__ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool03oooool00ol0003ooooo
ooooo`3ooooooeCooooo002nooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooo
oomDooooo`00__ooool3o`0000oooooo00?o0000ooooooooool0oooooomDooooo`00__ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo0?ooooooEOooool00;kooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`3ooooooeGooooo002nooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool0oooooomEooooo`00__ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo0?ooooooE_ooool00;kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3o
oooooeKooooo002nooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomGoooo
o`00__ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00;kooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo002nooooo`?o00002ooo
ool00ol0003oooooooooo`3ooooooeSooooo002nooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool0oooooomHooooo`00__ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo
0?ooooooF?ooool00;kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWo
oooo002nooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooomIooooo`00__oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00;kooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool0oooooomJooooo`00__ooool3o`0000Sooooo00?o0000oooooooo
ool0oooooomKooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?oooooo
Foooool00;kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooe_ooooo002n
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00__ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`3ooooooecooooo002nooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0oooooomMooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo0?ooooooGOooool00;kooooo0ol00006ooooo`03o`000?oooooooooo0?ooooooGOooool0
0;kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooekooooo002nooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00__ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo0?ooooooGoooool00;kooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`3ooooooeoooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0oooooomOooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0oooooomPooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo0?ooooooH?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPooooo`00[_ooool2o`00
00?ooooo00Co0000oooooooooooo00001oooool6o`000?ooooooHoooool00;3ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool0oooooomQooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool01Ol0003ooooooooooooooooo00000?ooooooI?ooool00:gooooo0ol0
0004ooooo`;o00002?ooool01Ol0003ooooooooooooooooo00000?ooooooI?ooool00;kooooo00Go
0000ooooooooooooooooo`00003oooooofCooooo002nooooo`04o`000?ooooooooooo`000?oooooo
IOooool00;kooooo00Co0000oooooooooooo0000oooooomUooooo`00__ooool01?l0003ooooooooo
ool0003oooooofGooooo002nooooo`?o0000oooooomVooooo`00__ooool01?l0003oooooo`000?l0
003oooooofGooooo002nooooo`04o`000?oooooo0000o`000?ooooooIOooool00;gooooo0ol00002
ooooo`03o`000?oooooooooo0?ooooooH_ooool00;kooooo00Co0000ooooool0003o0000oooooomU
ooooo`00__ooool2o`000?ooooooIoooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;[ooooo1Ol0003oooooofSooooo
002jooooo`03o`000?oooooooooo00;o0000oooooomXooooo`00^Oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;[ooooo00?o0000ooooool000001?l0003ooooo
ofKooooo002kooooo`04o`000?ooooooooooo`000?ooooooJ?ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`00
00?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooo
ooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5
o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`00
0?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:co
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.36939 .15436 .00609 0 365.73 arc
s
newpath
.3153 .04523 .00609 0 365.73 arc
s
newpath
.31696 .02459 .00609 0 365.73 arc
s
.36394 .15707 m
.30985 .04793 L
s
.37485 .15166 m
.32076 .04253 L
s
.32137 .04572 m
.32303 .02508 L
s
.30923 .04474 m
.31089 .0241 L
s
.31983 .0371 m
.3337 .02865 L
s
.32102 .00785 m
.30715 .0163 L
s
.36939 .15436 m
.34145 .27292 L
s
.31983 .0371 m
.30715 .0163 L
s
.3337 .02865 m
.32102 .00785 L
s
.31983 .0371 m
.31696 .02459 L
s
.30715 .0163 m
.31696 .02459 L
s
newpath
.34145 .27292 .00457 0 365.73 arc
s
newpath
.33834 .3095 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Loooo
o`;o00001Oooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo0?oooooo@?ooool009Wo
oooo00?o0000ooooooooool06Oooool2o`000003ooooool0003ooooo00Cooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`3ooooood7ooooo002Jooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool0oooooom2ooooo`00Voooool00ol0003oooooooooo`0Dooooo`;o00001_oo
ool01Ol0003ooooooooooooooooo000002;ooooo00?o0000ooooooooool0oooooom3ooooo`00W?oo
ool00ol0003oooooooooo`0Booooo`;o00001oooool01?l0003oooooooooooooool3o`0001oooooo
00?o0000ooooooooool0oooooom4ooooo`00WOooool00ol0003oooooooooo`0Aooooo`04o`000?oo
oooo0000ooooo`?o00000oooool01?l0003oooooooooool0000Pooooo`03o`000?oooooooooo0?oo
ooooAOooool009kooooo00?o0000ooooooooool04Oooool00ol0003oooooo`000003ooooo`07o`00
0?ooooooooooooooool0003oooooo`00000Oooooo`03o`000?oooooooooo0?ooooooA_ooool009oo
oooo00?o0000ooooooooool04?ooool01?l0003oooooo`000?l00002ooooo`03o`000?oooooooooo
00;ooooo0_l0000Nooooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000oooooooo
ool04?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooooooo`;o00007Oooool0
0ol0003oooooooooo`3oooooodSooooo002Qooooo`03o`000?oooooooooo00oooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool0oooooom9ooooo`00X_ooool00ol0003oooooooooo`0>ooooo`Co000000?oooooo`00
0?l000001?ooool2o`0001[ooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooo000000Co00000oooool2o`0001[ooooo00?o0000oooooooo
ool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0<ooooo`08o`000?oooooo0000ooooool0
003oooooo`000?ooool2o`000004ooooool0003o0000o`0001Oooooo00?o0000ooooooooool0oooo
oom<ooooo`00YOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;o000000?ooooo
o`000?l000000oooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool0
0:Kooooo00?o0000ooooooooool02Oooool01?l0003oooooooooooooool4o`0000Cooooo00?o0000
ooooooooool05Oooool00ol0003oooooooooo`3oooooodkooooo002Wooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool0
00000_l000000ooooooo0000ooooo`04ooooo`03o`000?oooooooooo01?ooooo00?o0000oooooooo
ool0oooooom@ooooo`00ZOooool00ol0003oooooooooo`06ooooo`;o00000oooool2o`0000Gooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oo
oooooooo00Gooooo0_l00003ooooo`;o00001Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo0?ooooooD_ooool00:_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3o
oooooe?ooooo002/ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool2o`00
00Cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002]ooooo`03
o`000?oooooooooo00;ooooo0ol000001Ooooooo0000o`000?oooooo000000Cooooo0ol0000>oooo
o`03o`000?oooooooooo0?ooooooEOooool00:kooooo00?o0000ooooooooool00_ooool00ol0003o
ooooo`000004ooooo`05o`000?ooooooooooooooool000003oooool00ol0003oooooooooo`3ooooo
oeKooooo002_ooooo`05o`000?ooooooooooooooool000001_ooool01Ol0003ooooooooooooooooo
000000kooooo00?o0000ooooooooool0oooooomGooooo`00/?ooool01Ol0003ooooooooooooooooo
000000Kooooo00Co0000oooooooooooo00003Oooool00ol0003oooooooooo`3ooooooeSooooo002a
ooooo`04o`000?ooooooooooo`0000Kooooo00Co0000oooooooooooo00003?ooool00ol0003ooooo
ooooo`3ooooooeWooooo002booooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooool00000
2oooool00ol0003oooooooooo`3ooooooe[ooooo002cooooo`03o`000?oooooo000000Kooooo00?o
0000ooooool000002_ooool00ol0003oooooooooo`3ooooooe_ooooo002dooooo`03o`000?oooooo
000000Kooooo0_l00009ooooo`03o`000?oooooooooo0?ooooooG?ooool00;Gooooo0_l00006oooo
o`Co00001_ooool00ol0003oooooooooo`3ooooooegooooo002fooooo`;o00001_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooG_ooool00;Oooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooGoooool00;Sooooo00?o
0000ooooooooool00oooool2o`0000Cooooo00?o0000ooooooooool0oooooomPooooo`00^?ooool2
o`0000Cooooo0_l00003ooooo`03o`000?oooooooooo0?ooooooHOooool00;Wooooo0_l00003oooo
o`05o`000?oooooo0000ooooool00000oooooomTooooo`00[Oooool3o`0000Cooooo0_l00003oooo
o`03o`000?oooooo000000;ooooo00Co0000ooooool0003o0000oooooomUooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Ko0000ooooool0003oooooo`00
0?ooool2o`000?ooooooIOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00003ooooo`03o`000?oooooooooo00?o000000?oooooo`000?ooool0oooooomTooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0
1Ol0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:gooooo
0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool000001?ooool00ol0003o
ooooooooo`3oooooof7ooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00006ooooo`03o`00
0?oooooo000000Cooooo00?o0000ooooooooool0oooooomQooooo`00_Oooool2o`0000Gooooo00?o
0000ooooooooool0oooooomPooooo`00_Oooool2o`0000Gooooo00?o0000ooooooooool0oooooomP
ooooo`00__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooGoooool00;ko
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`?o0000
1Oooool00ol0003oooooooooo`3ooooooekooooo002nooooo`;o00001_ooool00ol0003ooooooooo
o`3ooooooekooooo002nooooo`03o`000?oooooo000000Kooooo00?o0000ooooooooool0oooooomM
ooooo`00__ooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo0?ooooooGOooool00;ko
oooo00?o0000ooooool000001oooool00ol0003oooooooooo`3ooooooecooooo002nooooo`04o`00
0?ooooooooooo`0000Kooooo00?o0000ooooooooool0oooooomLooooo`00__ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooFoooool00;kooooo00Go0000oooooooooooo
ooooo`000006ooooo`03o`000?oooooooooo0?ooooooFoooool00;kooooo0ol000000ooooooo0000
ooooo`06ooooo`03o`000?oooooooooo0?ooooooF_ooool00;kooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooF_ooool00;kooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooFOooool0
0;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
0?ooooooFOooool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooF?ooool00;kooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo0?ooooooF?ooool00;kooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooEoooool00;kooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooEoooool0
0;kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooE_ooool00;kooooo0ol00006ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0oooooomFooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomEooooo`00__ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0oooooomEooooo`00__ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomDooooo`00__ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomDoooo
o`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0oooooomCooooo`00__ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0oooooomCooooo`00__ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0oooooomBooooo`00__ooool3o`0000[ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool00_ooool4o`000?ooooooDoooool00;kooooo00?o0000oooooooo
ool02oooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooDOooool00;ko
oooo00?o0000ooooooooool02oooool01?l0003oooooooooool00003ooooo`;o0000oooooomBoooo
o`00__ooool00ol0003oooooooooo`0<ooooo`;o00001Oooool00ol0003oooooooooo`3ooooooe3o
oooo002nooooo`03o`000?oooooooooo00cooooo0_l00002ooooo`04o`000?ooooooooooo`000?oo
ooooD_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`0=ooooo`;o0000
00Goooooo`000?ooooooooooo`00003ooooooe;ooooo002]ooooo`04o`000?ooooooooooo`0000;o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`0>ooooo`Go0000oooooomCoooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool03oooool2o`000?ooooooEOooool00:oooooo00Go0000ooooooooooooooooo`000002oooo
o`03o`000?oooooooooo00Gooooo1Ol0000=ooooo`03o`000?oooooooooo0?ooooooE?ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00oooooo00?o
0000ooooooooool0oooooomDooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool0oooooomDooooo`00__ooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo0?ooooooEOooool00;kooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`3ooooooeGooooo002nooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
oooooomEooooo`00__ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo0?ooooooEOoo
ool00;kooooo0ol0000=ooooo`03o`000?oooooooooo0?ooooooE_ooool00;kooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`3ooooooeKooooo002nooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool0oooooomFooooo`00__ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo0?ooooooE_ooool00;kooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`3ooooooeOooooo002nooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomG
ooooo`00__ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo0?ooooooEoooool00;ko
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo002nooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool0oooooomGooooo`00__ooool3o`0000_ooooo00?o
0000ooooooooool0oooooomHooooo`00__ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo0?ooooooF?ooool00;kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`3ooooo
oeSooooo002nooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00
__ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00;kooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo002nooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool0oooooomIooooo`00__ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo0?ooooooFOooool00;kooooo0ol00009ooooo`03o`000?oooooooooo0?oo
ooooF_ooool00;kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo
002nooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomJooooo`00__ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooF_ooool00;kooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool0oooooomKooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0?ooooooFoooool00;kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`3ooooooe_ooooo002nooooo`?o00002?ooool00ol0003oooooooooo`3ooooooe_ooooo002noooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00__ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`3ooooooecooooo002nooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0oooooomLooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo0?ooooooGOooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo0?ooooooGOooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3o
oooooegooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooGOooool00:kooooo0_l00003oooo
o`04o`000?ooooooooooo`0000Oooooo1Ol00004ooooo`03o`000?oooooooooo0?ooooooGOooool0
0;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomNooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooG_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooG_ooool00;kooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3ooooooekooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0oooooomOooooo`00__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo
Goooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooeoooooo002n
ooooo`?o00001?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo0?ooooooH?ooool00;kooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`3oooooof3ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooo
oomPooooo`00__ooool00ol0003oooooooooo`04o`000?ooooooH_ooool00;kooooo00Go0000oooo
oooooooo0000ooooo`02o`000?ooooooH_ooool00;kooooo00?o0000ooooool000000_ooool00ol0
003oooooo`00003oooooof7ooooo002nooooo`03o`000?oooooo000000Cooooo00?o0000oooooooo
ool0oooooomOooooo`00__ooool7o`000?ooooooH_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooool000000_l0003oooooofCooooo002nooooo`?o00000_ooool00ol0003ooooooooo
o`3oooooof7ooooo002nooooo`;o00000oooool00ol0003oooooooooo`3oooooof7ooooo002noooo
o`?o000000?oooooo`000?ooool0oooooomSooooo`00__ooool01?l0003oooooooooool0003ooooo
ofGooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co
0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000ooo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l0
0003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[ooo
ool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]
ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5
o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001ooo
ool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32404 .16228 .00609 0 365.73 arc
s
newpath
.33798 .04127 .00609 0 365.73 arc
s
newpath
.32357 .05615 .00609 0 365.73 arc
s
.31799 .16158 m
.33193 .04058 L
s
.33009 .16297 m
.34403 .04197 L
s
.3336 .03704 m
.3192 .05191 L
s
.34235 .04551 m
.32795 .06039 L
s
.31449 .04707 m
.30723 .0616 L
s
.32902 .07249 m
.33628 .05796 L
s
.32404 .16228 m
.39347 .26236 L
s
.31449 .04707 m
.33628 .05796 L
s
.30723 .0616 m
.32902 .07249 L
s
.31449 .04707 m
.32357 .05615 L
s
.33628 .05796 m
.32357 .05615 L
s
newpath
.39347 .26236 .00457 0 365.73 arc
s
newpath
.45099 .32204 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool00ol0003oooooo`000002o`0001?ooooo00?o0000
ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0Dooooo`;o00000oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000oooooooo
ool04_ooool3o`0000?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`3ooooooe3o
oooo002Yooooo`03o`000?oooooooooo013ooooo00?o0000ooooool000001Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo00?o0000ooooooooool03_oo
ool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
oooooomBooooo`00Zoooool00ol0003oooooooooo`0<ooooo`04o`000?ooooooooooooooo`?o0000
00Coooooo`000?l0003o00003?ooool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`00
0?oooooooooo00Kooooo0_l00002ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
0000ooooo`02o`0000_ooooo00?o0000ooooooooool0oooooomDooooo`00[Oooool00ol0003ooooo
ooooo`05ooooo`04o`000?oooooo0000o`0000Gooooo0ol000001?oooooo0000ooooool0000:oooo
o`03o`000?oooooooooo0?ooooooEOooool00:kooooo00?o0000ooooooooool00oooool00ol0003o
ooooo`000005o`000003ooooool0003o000000;ooooo00?o0000ooooool000002_ooool00ol0003o
ooooooooo`3ooooooeKooooo002_ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00000oooool4o`000005ooooool0003oooooooooool000002Oooool00ol0003oooooooooo`3ooooo
oeOooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooool000000oooool4o`00
00?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`;o
00000oooool00ol0003oooooooooo`07o`0000?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3ooooooeWooooo002booooo`05o`000?ooooooooooooooool000001Oooool5o`0000;o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooooe[ooooo002aooooo`?o0000
0oooool2o`0000;ooooo1?l000001Ooooooo0000oooooooooooo000000Gooooo00?o0000oooooooo
ool0oooooomKooooo`00/oooool2o`0000Cooooo0_l00002ooooo`?o00000oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo0?ooooooG?ooool00;Gooooo0_l00006ooooo`Co00000_oo
ool01Ol0003ooooooooooooooooo00000?ooooooGoooool00;Kooooo0_l00004ooooo`03o`000?oo
oooo000000Cooooo00Co0000oooooooooooo0000oooooomPooooo`00]oooool3o`0000;ooooo0ol0
0003ooooo`04o`000?ooooooooooo`000?ooooooHOooool00;Sooooo00?o0000ooooool000001?l0
0003ooooo`03o`000?oooooo00000?ooooooH_ooool00;Wooooo00Ko0000oooooooooooo0000oooo
ool00003ooooo`;o0000oooooomSooooo`00^_ooool01Ol0003oooooo`000?oooooo000000?ooooo
00?o0000ooooooooool0oooooomRooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`;o000000Co
ooooo`000?oooooooooo0_l0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001Oooool01ol0003oooooo`000?oooooo0000ooooool00000oooooomToooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooo
ool000000_l00002ooooo`03o`000?oooooooooo0?ooooooH_ooool00:kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Go0000oooooomToooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooo
oooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002]ooooo`;o00001?ooool01?l0
003oooooooooool00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooo
oomSooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo0?ooooooHoooool00;[ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oo
oooooooo0?ooooooHoooool00;[ooooo00Co0000oooooooooooooooo1?l0003oooooofGooooo002j
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002j
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002j
ooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`07o`000?oo
ooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`07o`000?ooooooooooooooool0
003oooooo`00003oooooofKooooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00003o
ooooofKooooo002iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool00000oooooomVoooo
o`00^Oooool00ol0003oooooooooo`02ooooo`?o0000oooooomVooooo`00^Oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooo00000?ooooooI_ooool00;Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooo`00003oooooofKooooo002iooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooool00000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWoooo
o`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00^Oooool00ol0003ooooo
ooooo`02ooooo`;o0000oooooomWooooo`00^?ooool00ol0003oooooooooo`03ooooo`;o0000oooo
oomWooooo`00^?ooool00ol0003oooooooooo`03ooooo`;o0000oooooomWooooo`00^?ooool00ol0
003oooooooooo`03ooooo`?o0000oooooomVooooo`00^?ooool00ol0003oooooooooo`03ooooo`;o
0000oooooomWooooo`00^?ooool00ol0003oooooooooo`03ooooo`;o0000oooooomWooooo`00^?oo
ool00ol0003oooooooooo`03ooooo`;o0000oooooomWooooo`00^?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Oooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`3oooooofKooooo002gooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0oooooomVooooo`00]oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;Oooooo00?o0000ooooooooool01?ooool3o`000?ooooooI_ooool00;Oooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`3oooooofKooooo002gooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0oooooomVooooo`00]oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;Oooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`3oooooofKooooo002fooooo`03o`000?oooooooooo00;o00000_ooool2o`000?ooooooJ?oo
ool00:cooooo1Ol00003ooooo`Go00000_ooool01?l0003oooooo`000?l0003oooooofSooooo002]
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00_l00004ooooo`?o0000oooo
oomXooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo0ol0
003oooooofSooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool01Ol0003ooooooooo
oooooooo000000;ooooo1_l0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool00ol0003oooooooooo`02o`0000;ooooo00?o0000ooooooooool00_l0003oooooofSooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`03o`0000;ooooo
0_l000000ooooooo0000ooooo`3oooooofOooooo002]ooooo`?o00001?ooool2o`0000?ooooo0_l0
00001?oooooo0000ooooool0003oooooofSooooo002looooo`03o`000?oooooo00000?ooooooJ?oo
ool00;gooooo0_l0003oooooofSooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0_l0003oooooofOooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooo`00
003oooooofKooooo002nooooo`04o`000?ooooooooooo`000?ooooooIOooool00;kooooo00Co0000
oooooooooooo0000oooooomUooooo`00__ooool01Ol0003ooooooooooooooooo00000?ooooooI?oo
ool00;kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3oooooof7ooooo002noooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo0?ooooooH?ooool00;kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3ooooooeoooooo002nooooo`?o00001Oooool00ol0003ooooooooo
o`3ooooooekooooo002nooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomN
ooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooGOooool00;ko
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002nooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00__ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo0?ooooooFoooool00;kooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`3ooooooe[ooooo002nooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool0oooooomIooooo`00__ooool3o`0000[ooooo00?o0000ooooooooool0oooooomIooooo`00
__ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00;kooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo002nooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool0oooooomGooooo`00__ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo0?ooooooE_ooool00;kooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`3ooooooeGooooo002nooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
oooooomDooooo`00__ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?oo
ool00;kooooo0ol0000@ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo0?ooooooDOooool00;kooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`3ooooooe3ooooo002nooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom@
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo01Cooooo00?o0000oooo
ooooool0oooooom?ooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool0
0;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool0oooooom=ooooo`00[_ooool2o`0000?ooooo00Co0000oooo
oooooooo00001oooool5o`0001Cooooo00?o0000ooooooooool0oooooom=ooooo`00/?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`3oooooodcooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooo
oom;ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool0oooooom;ooooo`00__ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo
0?ooooooB_ooool00;kooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`3oooooodWo
oooo002nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00__oo
ool00ol0003oooooooooo`0Kooooo`?o0000oooooom8ooooo`00__ooool3o`0001_ooooo0_l00000
0ooooooo0000ooooo`3oooooodKooooo002nooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool00ol0003oooooodKooooo002nooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`3oooooodCooooo002nooooo`03o`000?oooooooooo01_ooooo
00Co0000ooooool0003o0000oooooom7ooooo`00__ooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo0?ooooooAoooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`0jooooo`;o0000oooooolZooooo`00[_ooool3
o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo03Wooooo00Co0000oooooooooooo0000oooo
oolYooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0hooooo`05o`000?ooooooooooooooool00000oooooolYooooo`00[?oo
ool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`0hooooo`05o`00
0?ooooooooooooooool00000oooooolYooooo`00[?ooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000Oooooo1Ol0000gooooo`Co0000oooooolYooooo`00[Oooool00ol0003o
ooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32923 .16271 .00609 0 365.73 arc
s
newpath
.33538 .04106 .00609 0 365.73 arc
s
newpath
.32116 .05611 .00609 0 365.73 arc
s
.32315 .1624 m
.3293 .04075 L
s
.33532 .16301 m
.34147 .04137 L
s
.33096 .03688 m
.31674 .05193 L
s
.33981 .04524 m
.32559 .06029 L
s
.30839 .05741 m
.31506 .07222 L
s
.33727 .06222 m
.3306 .04741 L
s
.32923 .16271 m
.40087 .26121 L
s
.30839 .05741 m
.3306 .04741 L
s
.31506 .07222 m
.33727 .06222 L
s
.30839 .05741 m
.32116 .05611 L
s
.3306 .04741 m
.32116 .05611 L
s
newpath
.40087 .26121 .00457 0 365.73 arc
s
newpath
.46147 .32044 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05?ooool5o`0001Cooooo00?o0000ooooooooool0oooooom>
ooooo`00Yoooool00ol0003oooooooooo`0Cooooo`;o00000oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool04Oooool00ol0003o
ooooo`000003ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooom@ooooo`00
ZOooool00ol0003oooooooooo`0?ooooo`;o000000?oooooo`000?ooool00oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo00?o0000ooooooooool03Ooo
ool01Ol0003oooooo`000?oooooo000000Cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00ol0
0002ooooo`?o00003Oooool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooo
oooo00Wooooo00Co0000oooooooooooooooo1_l000000ooooooo0000ooooo`0;ooooo`03o`000?oo
oooooooo0?ooooooE?ooool00:gooooo00?o0000ooooooooool01oooool00ol0003oooooo`000007
o`0000;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooeGooooo002^oooo
o`03o`000?oooooooooo00Gooooo1?l000001?oooooo0000o`000?ooool2o`0000?ooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`3ooooooeKooooo002_ooooo`03o`000?oooooooooo
00?ooooo0_l00003ooooo`05o`000?oooooo0000ooooool000001?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo0?ooooooEoooool00;3ooooo00?o0000ooooool000000ol00003oooo
o`;o000000Coooooo`000?l0003o00001?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo0?ooooooF?ooool00;7ooooo2?l00002ooooo`;o000000?oooooo`000?l000000oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooFOooool00;7ooooo0_l00003ooooo`03
o`000?oooooooooo00;ooooo0_l000000ooooooo0000o`000002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomJooooo`00/_ooool2o`0000;ooooo0_l000001_oooooo0000
o`000?oooooo0000ooooo`;o00000_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
0?ooooooFoooool00;;ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00002oooo
o`?o000000?oooooo`000?ooool01?ooool00ol0003oooooooooo`3ooooooecooooo002cooooo`03
o`000?oooooo000000Gooooo00?o0000ooooool000000ol000000ooooooo0000ooooo`03ooooo`03
o`000?oooooooooo0?ooooooGOooool00;?ooooo00Co0000oooooooooooo00000oooool3o`000003
ooooool0003ooooo00;ooooo00Go0000ooooooooooooooooo`00003oooooof3ooooo002dooooo`03
o`000?oooooooooo00?o000000Goooooo`000?ooooooooooo`000003ooooo`04o`000?oooooooooo
o`000?ooooooHOooool00;Cooooo00?o0000ooooool000000_l00002ooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooool00000oooooomRooooo`00]Oooool01ol0003ooooooooooooooooo
0000ooooool000000_ooool01?l0003oooooooooooooool2o`000?ooooooHoooool00;[ooooo0_l0
0002ooooo`05o`000?ooooooooooooooool00000oooooomTooooo`00[Oooool3o`0000Cooooo0_l0
0005ooooo`04o`000?ooooooooooo`0000;ooooo0_l0003oooooofCooooo002^ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001?ooool2o`000006ooooool0003oooooo`000?oo
oooo0000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Cooooo00?o0000ooooool000000_l00002ooooo`03o`000?oooooooooo0?ooooooH_ooool00:ko
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo
00Go0000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002]oooo
o`;o00001?ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000?ooooo00?o
0000ooooooooool0oooooomRooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo0?ooooooH_ooool00;_ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`3oooooof?ooooo002kooooo`03o`000?oooooooooo00Co0000oooooomU
ooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool0
0;_ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002joooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002joooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002joooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002joooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002joooo
o`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002joooo
o`04o`000?ooooooooooooooo`Co0000oooooomUooooo`00^_ooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooooooool0oooooomSooooo`00^_ooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooooooool0oooooomSooooo`00^_ooool01ol0003ooooooooooooooooo
0000ooooool00000oooooomVooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool00000
oooooomVooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool00000oooooomVooooo`00
^_ooool01ol0003ooooooooooooooooo0000ooooool00000oooooomVooooo`00^_ooool01ol0003o
oooooooooooooooo0000ooooool00000oooooomVooooo`00^_ooool01ol0003ooooooooooooooooo
0000ooooool00000oooooomVooooo`00^_ooool01?l0003oooooooooooooool3o`000?ooooooI_oo
ool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00;[ooooo00Oo
0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00;[ooooo00Oo0000oooooooooooo
ooooo`000?oooooo00000?ooooooI_ooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo
00000?ooooooI_ooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_oo
ool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00;Wooooo00?o
0000ooooooooool00_ooool00ol0003oooooo`00003oooooofKooooo002iooooo`03o`000?oooooo
oooo00;ooooo0ol0003oooooofKooooo002iooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ool00000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00
^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00^Oooool00ol0003ooooooooo
o`02ooooo`;o0000oooooomWooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomW
ooooo`00[?ooool5o`0000?ooooo0_l00003ooooo`Oo0000oooooomWooooo`00[Oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo0_l00003ooooo`;o0000oooooomW
ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool00_ooool2o`000?ooooooIoooool00:oooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooool000001?l0003oooooofCooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`05o`00
0?ooooooooooo`000?ooool00_l0003oooooofOooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00003ooooo`;o000000?oooooo`000?l00000oooooomXoooo
o`00[Oooool3o`0000Cooooo0_l00006ooooo`03o`000?oooooo00000?ooooooJ?ooool00;kooooo
0_l0003oooooofOooooo002nooooo`;o0000oooooomWooooo`00__ooool00ol0003oooooo`00003o
ooooofKooooo002nooooo`04o`000?ooooooooooo`000?ooooooIOooool00;kooooo1?l0003ooooo
ofGooooo002nooooo`05o`000?ooooooooooooooool00000oooooomTooooo`00__ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo0?ooooooHOooool00;kooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`3oooooof3ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0oooooomPooooo`00__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?ooooooGoooool00;kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooo
oekooooo002nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooooomMooooo`00
__ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooGOooool00;kooooo0ol0
0007ooooo`03o`000?oooooooooo0?ooooooG?ooool00;kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`3ooooooe_ooooo002nooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool0oooooomKooooo`00__ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?oo
ooooF_ooool00;kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo
002nooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00__ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooF?ooool00;kooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo002nooooo`?o00003Oooool00ol0003o
ooooooooo`3ooooooeKooooo002nooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
oooooomEooooo`00__ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo0?ooooooEOoo
ool00;kooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`3ooooooeCooooo002noooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool0oooooomCooooo`00__ooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`3ooooooe;ooooo002nooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool0oooooomAooooo`00__ooool3o`0001?ooooo00?o0000ooooooooool0oooooom@
ooooo`00__ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo0?ooooooD?ooool00;ko
oooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3oooooodoooooo002nooooo`03o`00
0?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>ooooo`00__ooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo0?ooooooC_ooool00;kooooo00?o0000ooooooooool05_ooool0
0ol0003oooooooooo`3oooooodgooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`3oooooodcooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool0oooooom;ooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002^oooo
o`;o00000oooool01?l0003oooooooooool00007ooooo`Go00005oooool00ol0003oooooooooo`3o
oooood[ooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0Jooooo`03o`000?oooooooooo0?ooooooBOooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`3oooooodSooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`3oooooodSooooo002nooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool0oooooom7ooooo`00__ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo0?ooooooA_ooool00;kooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`02o`000?ooooooA?ooool00;kooooo00?o0000ooooooooool07_ooool2o`0000;ooooo00?o
0000ooooooooool0oooooom1ooooo`00__ooool3o`0001oooooo00Co0000oooooooooooo0000oooo
oom3ooooo`00__ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo000000;ooooo00?o0000
ooooooooool0oooooom0ooooo`00__ooool00ol0003oooooooooo`0Oooooo`05o`000?oooooooooo
ooooool00000oooooom2ooooo`00__ooool00ol0003oooooooooo`0Pooooo`?o0000oooooom3oooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo03oooooo0_l0003oooooobGooooo002nooooo`03o`000?oooooooooo03kooooo
00Co0000oooooooooooo0000oooooolTooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo03kooooo00Co0000oooooooooooo0000oooooolTooooo`00[oooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0nooooo`05
o`000?ooooooooooooooool00000oooooolSooooo`00[?ooool5o`0000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`0nooooo`;o000000?oooooo`000?ooool0oooooolSoooo
o`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0000n
ooooo`03o`000?oooooooooo0?oooooo8oooool00:gooooo00?o0000ooooool000000oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0
003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o
00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.33061 .16276 .00609 0 365.73 arc
s
newpath
.3347 .04103 .00609 0 365.73 arc
s
newpath
.32758 .06048 .00609 0 365.73 arc
s
.32452 .16256 m
.32861 .04083 L
s
.33669 .16297 m
.34078 .04123 L
s
.32898 .03894 m
.32186 .05838 L
s
.34042 .04312 m
.3333 .06257 L
s
.33766 .05252 m
.32409 .04361 L
s
.31071 .06397 m
.32429 .07288 L
s
.33061 .16276 m
.42313 .24198 L
s
.33766 .05252 m
.32429 .07288 L
s
.32409 .04361 m
.31071 .06397 L
s
.33766 .05252 m
.32758 .06048 L
s
.32429 .07288 m
.32758 .06048 L
s
newpath
.42313 .24198 .00457 0 365.73 arc
s
newpath
.50483 .30882 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05?ooool4o`0001Gooooo00?o0000ooooooooool0oooooom>
ooooo`00Yoooool00ol0003oooooooooo`0Cooooo`;o00000_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool04Oooool00ol0003o
ooooo`000002ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0oooooom@ooooo`00
ZOooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo00gooooo0ol0
00000ooooooo0000ooooo`02ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0oooo
oomBooooo`00Zoooool00ol0003oooooooooo`0<ooooo`Go000000Coooooo`000?l0003o00003_oo
ool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooool000001?l000000ooooooo0000o`00000=ooooo`03o`000?oooooooooo0?ooooooE?ooool0
0:gooooo00?o0000ooooooooool02?ooool01_l0003oooooo`000?oooooo0000ooooo`Go00003?oo
ool00ol0003oooooooooo`3ooooooeGooooo002^ooooo`03o`000?oooooooooo00Oooooo00So0000
ooooool0003oooooo`000?oooooo0000ooooo`?o00002oooool00ol0003oooooooooo`3ooooooeKo
oooo002_ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000000_ooool01?l0003ooooo
o`000?ooool3o`0000[ooooo00?o0000ooooooooool0oooooomGooooo`00/?ooool00ol0003ooooo
ooooo`03ooooo`05o`000?ooooooooooo`000?ooool02?l00009ooooo`03o`000?oooooooooo0?oo
ooooF?ooool00;7ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02o`000003oooo
ool0003o000000?o000000?oooooo`000?ooool01oooool00ol0003oooooooooo`3ooooooeWooooo
002booooo`04o`000?ooooooooooo`0000;ooooo0_l00002ooooo`04o`000?oooooo0000o`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooe[ooooo002cooooo`03o`00
0?oooooo000000;ooooo00?o0000ooooooooool00_l000000ooooooo0000o`000002ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0oooooomKooooo`00]?ooool01Ol0003ooooooooo
oooooooo000000;ooooo0_l000000ooooooo0000o`000002ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0oooooomLooooo`00/oooool3o`0000?ooooo2?l000000ooooooo0000oooo
o`03ooooo`03o`000?oooooooooo0?ooooooGOooool00;Gooooo0_l00004ooooo`;o000000?ooooo
o`000?ooool00_ooool01Ol0003ooooooooooooooooo00000?ooooooH?ooool00;Oooooo00So0000
oooooooooooo0000ooooool0003oooooo`0000?ooooo00Co0000oooooooooooo0000oooooomQoooo
o`00^?ooool5o`000003ooooool0003ooooo00;ooooo00?o0000ooooool00000oooooomRooooo`00
^Oooool2o`000004ooooool0003oooooo`0000?ooooo0_l0003oooooof?ooooo002jooooo`;o0000
0_ooool00ol0003oooooooooo`02o`000?ooooooI?ooool00:gooooo0ol00004ooooo`;o00001Ooo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00:kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`;o000000?oooooo`000?ooool0
0_l0003oooooofGooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooo`000002o`000003ooooool0003ooooo0?ooooooI?ooool00:kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Go0000
oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002]ooooo`;o0000
1?ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool0oooooomSooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`3oooooof?ooooo002kooooo`03o`000?oooooooooo00Co0000oooooomUooooo`00
^oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo0?ooooooHoooool00;_ooooo00?o0000ooooooooool01?l0003oooooofGooooo
002kooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^ooo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo0?ooooooHoooool00;_ooooo00?o0000ooooooooool01?l0003oooooofGooooo002k
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^_ooool0
1ol0003ooooooooooooooooo0000ooooool00000oooooomVooooo`00^_ooool01ol0003ooooooooo
oooooooo0000ooooool00000oooooomVooooo`00^_ooool01ol0003ooooooooooooooooo0000oooo
ool00000oooooomVooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool00000oooooomV
ooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool00000oooooomVooooo`00^_ooool0
1ol0003ooooooooooooooooo0000ooooool00000oooooomVooooo`00^_ooool01?l0003ooooooooo
ooooool3o`000?ooooooI_ooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo00000?oo
ooooI_ooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00;[o
oooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00;[ooooo00Oo0000oooo
ooooooooooooo`000?oooooo00000?ooooooI_ooool00;[ooooo00Oo0000ooooooooooooooooo`00
0?oooooo00000?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00001?ooool00ol0003oooooo`00
0002o`000003ooooool0003ooooo0?ooooooIOooool00:gooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00003ooooo`;o00000_ooool3o`000?ooooooI_ooool00:kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`;o00000_ooool3o`000?oooooo
I_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?ooooooooooooooool0
00000_ooool6o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooooooo0ol0003oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00004ooooo`;o000000Co
ooooo`000?l0003o0000oooooomVooooo`00[Oooool3o`0000Cooooo0_l00007ooooo`;o00000_oo
ool00ol0003oooooooooo`3oooooof?ooooo002nooooo`05o`000?ooooooooooooooool00000oooo
oomTooooo`00__ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooHOooool0
0;kooooo00?o0000ooooooooool00oooool2o`000?ooooooHOooool00;kooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3ooooooekooooo002nooooo`?o00001_ooool00ol0003ooooo
ooooo`3ooooooegooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooo
oomLooooo`00__ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooFoooool0
0;kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe[ooooo002nooooo`03
o`000?oooooooooo00[ooooo0_l0003ooooooe[ooooo002nooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool0oooooomGooooo`00__ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo0?ooooooE_ooool00;kooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`3o
oooooeGooooo002nooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooomDoooo
o`00__ooool3o`00013ooooo00?o0000ooooooooool0oooooomCooooo`00__ooool00ol0003ooooo
ooooo`0Aooooo`;o0000oooooomCooooo`00__ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo0?ooooooD?ooool00;kooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`3o
ooooodoooooo002nooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom>oooo
o`00__ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOooool00;kooooo
00?o0000ooooooooool05oooool2o`000?ooooooCOooool00;kooooo00?o0000ooooooooool06Ooo
ool00ol0003oooooooooo`3ooooood[ooooo002nooooo`?o00006_ooool00ol0003oooooooooo`3o
ooooodWooooo002nooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8oooo
o`00__ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooAoooool00;kooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002nooooo`03o`000?oo
oooooooo01kooooo0_l0003oooooodKooooo002nooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool0oooooom3ooooo`00__ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
0?oooooo@_ooool00;kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3ooooood7o
oooo002nooooo`?o00008oooool00ol0003oooooooooo`3ooooood3ooooo002nooooo`03o`000?oo
oooooooo02Cooooo00?o0000ooooooooool0ooooooloooooo`00__ooool00ol0003oooooooooo`0U
ooooo`;o0000ooooooloooooo`00__ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo
0?oooooo??ooool00;kooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`3ooooooc_o
oooo002nooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0ooooooljooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo02[ooooo1Ol0003oooooocOooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo02[ooooo0_l00002ooooo`03o`000?oooooooooo0?oooooo=Oooool00;3ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02[ooooo
00Go0000ooooool0003oooooo`00003oooooocOooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000:?ooool01Ol0003ooooooooooooooooo00000?oooooo=oooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
02[ooooo1Ol0003oooooocOooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo05Kooooo0_l0
003oooooo`kooooo002nooooo`03o`000?oooooooooo05Gooooo00Co0000oooooooooooo0000oooo
ool=ooooo`00__ooool3o`0005Cooooo00Go0000ooooooooooooooooo`00003oooooo`gooooo002n
ooooo`03o`000?oooooooooo05Cooooo00Go0000ooooooooooooooooo`00003oooooo`gooooo002n
ooooo`03o`000?oooooooooo05Gooooo00Co0000ooooool0003o0000ooooool=ooooo`00__ooool0
0ol0003oooooooooo`1Fooooo`03o`000?oooooooooo0?oooooo3Oooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o0000
0oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go
0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000
oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32012 .16173 .00609 0 365.73 arc
s
newpath
.33994 .04155 .00609 0 365.73 arc
s
newpath
.32706 .05776 .00609 0 365.73 arc
s
.31411 .16074 m
.33393 .04056 L
s
.32613 .16272 m
.34595 .04254 L
s
.33517 .03776 m
.32229 .05397 L
s
.34471 .04534 m
.33183 .06155 L
s
.32636 .04494 m
.31126 .05091 L
s
.32021 .07356 m
.33531 .0676 L
s
.32012 .16173 m
.42196 .22853 L
s
.32636 .04494 m
.33531 .0676 L
s
.31126 .05091 m
.32021 .07356 L
s
.32636 .04494 m
.32706 .05776 L
s
.33531 .0676 m
.32706 .05776 L
s
newpath
.42196 .22853 .00457 0 365.73 arc
s
newpath
.51584 .30458 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`03o`0001;ooooo00?o0000
ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0Dooooo`?o00000oooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000oooooooo
ool04oooool3o`0000?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooe3o
oooo002Yooooo`03o`000?oooooooooo01;ooooo0_l00005ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003oooooooooo`0@ooooo`?o00001Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooD_ooool00:_ooooo00?o0000
ooooooooool03?ooool2o`000003ooooool0003o000000?o000000Coooooo`000?l0003o00002ooo
ool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00Sooooo0ol00000
1?oooooo0000o`000?ooool2o`0000;ooooo00Co0000ooooool0003o00002_ooool00ol0003ooooo
ooooo`3ooooooeCooooo002]ooooo`03o`000?oooooooooo00Cooooo0ol00004ooooo`;o000000Co
ooooo`000?l0003o00000_ooool00ol0003oooooo`000009ooooo`03o`000?oooooooooo0?oooooo
EOooool00:kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`Go00000ooo
ool00ol0003oooooo`000009ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00Go0000
ooooooooooooooooo`000005ooooo`Co000000Goooooo`000?ooooooooooo`000002ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool0oooooomGooooo`00/?ooool01Ol0003ooooooooo
oooooooo000000Cooooo00Co0000ooooool0003ooooo0_l00002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomHooooo`00/Oooool01?l0003oooooooooool00003oooo
o`05o`000?ooooooooooo`000?ooool00_l000000ooooooo0000ooooo`02ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0oooooomIooooo`00/_ooool00ol0003oooooo`000003oooo
o`05o`000?ooooooooooo`000?ooool00ol00004ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0oooooomJooooo`00/oooool00ol0003oooooo`000003ooooo`04o`000?oooooo0000
ooooo`;o00001Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooFoooool0
0;Cooooo0_l00003ooooo`;o000000Coooooo`000?l0003o00001?ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo0?ooooooG?ooool00;Gooooo0_l00004ooooo`03o`000?oooooo0000
00?o00000_ooool01Ol0003ooooooooooooooooo00000?ooooooGoooool00;Kooooo00?o0000oooo
ooooool01?ooool3o`0000?ooooo00Co0000oooooooooooo0000oooooomPooooo`00]oooool00ol0
003oooooooooo`03ooooo`?o00000oooool00ol0003oooooo`00003oooooof7ooooo002gooooo`;o
00000_ooool4o`0000Cooooo0_l0003oooooof;ooooo002gooooo`08o`000?oooooo0000o`000?oo
oooo0000ooooool00004ooooo`03o`000?oooooooooo0?ooooooHOooool00;Sooooo00Oo0000oooo
ool0003oooooo`000?oooooo000000?ooooo00?o0000ooooooooool0oooooomRooooo`00[Oooool3
o`0000Cooooo0_l00005ooooo`;o000000Coooooo`000?oooooooooo0_l0003oooooofCooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool01ol0003oooooo`00
0?oooooo0000ooooool00000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000Gooooo1?l00002ooooo`03o`000?oooooooooo0?ooooooH_ooool00:kooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Go
0000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Co
oooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`3oooooof;ooooo002]ooooo`;o
00001?ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool0oooooomRooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002jooooo`05o`000?oooooooooo
ooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002jooooo`05o`000?oooooooooo
ooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002jooooo`05o`000?oooooooooo
ooooool000000_ooool00ol0003oooooooooo`3oooooof?ooooo002jooooo`04o`000?oooooooooo
ooooo`Co0000oooooomUooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool00000oooo
oomVooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool00000oooooomVooooo`00^Ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooo00000?ooooooI_ooool00;Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooo`00003oooooofKooooo002iooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooool00000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`03
o`000?oooooo00000?ooooooI_ooool00;Wooooo00?o0000ooooooooool00_ooool2o`000?oooooo
Ioooool00;Wooooo00?o0000ooooooooool00_ooool3o`000?ooooooI_ooool00;Sooooo00?o0000
ooooooooool00oooool2o`000?ooooooIoooool00;Sooooo00?o0000ooooooooool00oooool2o`00
0?ooooooIoooool00;Sooooo00?o0000ooooooooool00oooool2o`000?ooooooIoooool00;Sooooo
00?o0000ooooooooool00oooool2o`000?ooooooIoooool00;Sooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`3oooooofKooooo002gooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0oooooomVooooo`00]oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooofKo
oooo002gooooo`03o`000?oooooooooo00Cooooo0ol0003oooooofKooooo002gooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0oooooomVooooo`00]oooool00ol0003oooooooooo`03
ooooo`;o0000oooooomXooooo`00]_ooool00ol0003oooooooooo`04ooooo`;o0000oooooomXoooo
o`00]_ooool00ol0003oooooooooo`04ooooo`;o0000oooooomXooooo`00]_ooool00ol0003ooooo
ooooo`04ooooo`;o0000oooooomXooooo`00]_ooool00ol0003oooooooooo`04ooooo`;o0000oooo
oomXooooo`00]_ooool00ol0003oooooooooo`04ooooo`;o0000oooooomXooooo`00]_ooool00ol0
003oooooooooo`04ooooo`Co0000oooooomVooooo`00]Oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooo00000?ooooooJ?ooool00;Gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
o`00003oooooofSooooo002eooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool00000oooo
oomXooooo`00]Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo00000?ooooooJ?ooool0
0;Gooooo00?o0000ooooool000000_l00002ooooo`03o`000?oooooo00000?ooooooJ?ooool00:co
oooo1Ol00003ooooo`?o00000oooool01Ol0003oooooo`000?oooooo00000?ooooooJ?ooool00:go
oooo00Co0000oooooooooooo00000_ooool4o`0000?ooooo0_l00002ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool2o`000003ooooool0003ooooo00;o
000000Goooooo`000?ooooooooooo`00003oooooofSooooo002_ooooo`04o`000?oooooooooooooo
o`;o000000?oooooo`000?ooool00_ooool2o`0000;ooooo1Ol0003oooooofCooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooo`000?l00003ooooo`?o000000?ooooo
o`000?ooool0oooooomWooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooooooool01Ol00002ooooo`;o0000oooooomXooooo`00[Oooool3o`0000Cooooo0_l00008oooo
o`;o0000oooooomWooooo`00__ooool00ol0003oooooo`00003oooooofKooooo002nooooo`03o`00
0?oooooooooo00;o0000oooooomTooooo`00__ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0?ooooooHOooool00;kooooo00?o0000ooooooooool00oooool2o`000?ooooooHOooool0
0;kooooo0ol00005ooooo`03o`000?oooooooooo0?ooooooG_ooool00;kooooo00?o0000oooooooo
ool01_ooool2o`000?ooooooG_ooool00;kooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`3ooooooe_ooooo002nooooo`03o`000?oooooooooo00Wooooo0_l0003ooooooe_ooooo002n
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooomHooooo`00__ooool00ol0
003oooooooooo`0<ooooo`;o0000oooooomHooooo`00__ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo0?ooooooEOooool00;kooooo00?o0000ooooooooool03oooool2o`000?oooooo
EOooool00;kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3ooooooe;ooooo002n
ooooo`?o00004_ooool00ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo
01?ooooo0_l0003ooooooe7ooooo002nooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool0oooooom>ooooo`00__ooool00ol0003oooooooooo`0Fooooo`;o0000oooooom>ooooo`00__oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?ooooooBoooool00;kooooo00?o0000
ooooooooool06Oooool2o`000?ooooooBoooool00;kooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`3oooooodSooooo002nooooo`03o`000?oooooooooo01cooooo0_l0003oooooodSo
oooo002nooooo`?o00007_ooool00ol0003oooooooooo`3oooooodGooooo002nooooo`03o`000?oo
oooooooo01oooooo0_l0003oooooodGooooo002nooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool0oooooom2ooooo`00__ooool00ol0003oooooooooo`0Rooooo`;o0000oooooom2oooo
o`00__ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo0?oooooo?oooool00;kooooo
00?o0000ooooooooool09Oooool2o`000?oooooo?oooool00;kooooo00?o0000ooooooooool09ooo
ool00ol0003oooooooooo`3ooooooccooooo002nooooo`03o`000?oooooooooo02Sooooo1_l0003o
ooooocSooooo002nooooo`?o0000:_ooool01?l0003oooooooooool0003oooooocSooooo002noooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`3ooooo
ocGooooo002nooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`3oooooocGooooo002nooooo`03o`000?oooooooooo02[ooooo1?l0003oooooocSooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooo
oooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`1Kooooo`;o0000ooooool9ooooo`00__ooool00ol0003oooooooooo`1Jooooo`04
o`000?ooooooooooo`000?oooooo2?ooool00;kooooo00?o0000ooooooooool0F_ooool00ol0003o
ooooooooo`02o`000?oooooo1oooool00;kooooo00?o0000ooooooooool0F_ooool01Ol0003ooooo
oooooooooooo00000?oooooo1oooool00;kooooo0ol0001Jooooo`Co0000ooooool8ooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/
ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003
ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]
ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31762 .16127 .00609 0 365.73 arc
s
newpath
.34119 .04177 .00609 0 365.73 arc
s
newpath
.32448 .05401 .00609 0 365.73 arc
s
.31164 .1601 m
.33522 .0406 L
s
.32359 .16245 m
.34717 .04295 L
s
.33759 .03686 m
.32088 .04909 L
s
.34479 .04669 m
.32808 .05892 L
s
.31373 .04699 m
.30961 .0627 L
s
.33318 .06888 m
.33729 .05317 L
s
.31762 .16127 m
.42595 .21696 L
s
.31373 .04699 m
.33729 .05317 L
s
.30961 .0627 m
.33318 .06888 L
s
.31373 .04699 m
.32448 .05401 L
s
.33729 .05317 m
.32448 .05401 L
s
newpath
.42595 .21696 .00457 0 365.73 arc
s
newpath
.52758 .29949 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool01?l0003oooooooooooooool3o`00017ooooo00?o
0000ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0Dooooo`04o`000?oooooo
0000o`0000?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3oooooodoooooo002X
ooooo`03o`000?oooooooooo01?ooooo0ol00004ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool0oooooom@ooooo`00ZOooool00ol0003oooooooooo`0Aooooo`?o00001_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo00?o0000oooooooo
ool03oooool01?l0003oooooo`000?l00006ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool0oooooomBooooo`00Zoooool00ol0003oooooooooo`0<ooooo`;o00000_ooool4o`0000;o
oooo0ol0000:ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o0000ooooooooool0
1Oooool3o`0000;ooooo0_l00003ooooo`;o00000_ooool3o`000003ooooool0003ooooo00Sooooo
00?o0000ooooooooool0oooooomDooooo`00[Oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooo000000Go00000_ooool3o`000005ooooool0003oooooooooool000002Oooool00ol0003ooooo
ooooo`3ooooooeGooooo002^ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_l0
0002ooooo`Co00000_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0
oooooomFooooo`00[oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooool00000
0_ooool5o`0000Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooeOooooo
002`ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool01Ol000000ooooooo0000
ooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomHooooo`00/Ooo
ool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00?ooooo0_l000000ooooooo0000oooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomIooooo`00/_ooool2
o`0000?ooooo0ol000000ooooooo0000o`000003o`0000Cooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`3ooooooe[ooooo002booooo`;o00001_ooool00ol0003oooooooooo`03o`00
00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooe_ooooo002booooo`?o
00002?ooool3o`0000Cooooo00Go0000ooooooooooooooooo`00003ooooooekooooo002eooooo`Co
00001?ooool4o`0000?ooooo00Co0000oooooooooooo0000oooooomOooooo`00]_ooool00ol0003o
ooooooooo`06o`0000Gooooo00?o0000ooooool00000oooooomPooooo`00]oooool00ol0003ooooo
ooooo`02ooooo`?o00001?ooool00ol0003oooooo`00003oooooof7ooooo002hooooo`07o`000?oo
ooooooooooooool0003oooooo`000004ooooo`;o0000oooooomRooooo`00^Oooool01_l0003ooooo
ooooool0003oooooo`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00^_ooool01Ol0003o
ooooo`000?oooooo000000?ooooo0_l0003oooooof?ooooo002]ooooo`?o00001?ooool2o`0000Go
oooo0_l000001ooooooo0000oooooooooooo0000ooooool00000oooooomSooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo0_l000001_oooooo0000ooooool0
003oooooo`000?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooo000000;o00000_ooool00ol0003oooooooooo`3oooooof;ooooo
002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooo
ooooo`05o`000?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00004ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooomRooooo`00
[Oooool2o`0000Cooooo00Co0000oooooooooooo00001?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo0?ooooooHoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Co
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[o
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[o
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[o
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[o
oooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00;Wooooo00?o0000oooo
ooooool00_ooool3o`000?ooooooI_ooool00;Wooooo00?o0000ooooooooool00_ooool00ol0003o
ooooo`00003oooooofKooooo002iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool00000
oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo00000?ooooooI_oo
ool00;Wooooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool00;Sooooo00?o0000oooo
ooooool00oooool2o`000?ooooooIoooool00;Sooooo00?o0000ooooooooool00oooool2o`000?oo
ooooIoooool00;Sooooo00?o0000ooooooooool00oooool2o`000?ooooooIoooool00;Sooooo00?o
0000ooooooooool00oooool3o`000?ooooooI_ooool00;Sooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`3oooooofKooooo002gooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool0oooooomVooooo`00]oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooofKooooo
002gooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomVooooo`00]oooool0
0ol0003oooooooooo`03ooooo`;o0000oooooomXooooo`00]_ooool00ol0003oooooooooo`04oooo
o`;o0000oooooomXooooo`00]_ooool00ol0003oooooooooo`04ooooo`;o0000oooooomXooooo`00
]_ooool00ol0003oooooooooo`04ooooo`Co0000oooooomVooooo`00]_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooo00000?ooooooJ?ooool00;Kooooo00?o0000ooooooooool00oooool0
0ol0003oooooo`00003oooooofSooooo002eooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ool00000oooooomXooooo`00]Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo00000?oo
ooooJ?ooool00;Gooooo00?o0000ooooooooool01?ooool00ol0003oooooo`00003oooooofSooooo
002eooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000oooooomXooooo`00]Ooo
ool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`000?ooooooJ?ooool00;Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03o`000?ooooooI_ooool00;Cooooo00?o0000
ooooooooool01?ooool01?l0003oooooooooool0003oooooofSooooo002dooooo`03o`000?oooooo
oooo00Cooooo00Co0000oooooooooooo0000oooooomXooooo`00]?ooool00ol0003oooooooooo`03
ooooo`05o`000?ooooooooooooooool00000oooooomXooooo`00]?ooool00ol0003oooooooooo`03
ooooo`05o`000?ooooooooooooooool00000oooooomXooooo`00/oooool00ol0003oooooo`000003
o`000003ooooool0003ooooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`00
00;ooooo0ol00003ooooo`;o00000oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04
o`000?ooooooooooo`0000;ooooo0_l000001?oooooo0000ooooooooool2o`0000?ooooo00?o0000
ooooooooool0oooooomVooooo`00[_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;o000000?oooooo`000?ooool00oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooo`000?l00004ooooo`Go0000oooooomT
ooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo1_l000000ooooooo0000o`000002
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Gooooo0ol0003oooooofSooooo002]ooooo`?o00001?ooool2
o`0000Sooooo0_l0003oooooofOooooo002nooooo`04o`000?oooooo0000o`000?ooooooIOooool0
0;kooooo00Co0000oooooooooooooooo0_l0003oooooof?ooooo002nooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0oooooomPooooo`00__ooool00ol0003oooooooooo`04ooooo`;o
0000oooooomPooooo`00__ooool3o`0000Kooooo0_l0003ooooooekooooo002nooooo`03o`000?oo
oooooooo00Sooooo0_l0003ooooooecooooo002nooooo`03o`000?oooooooooo00[ooooo0_l0003o
oooooe[ooooo002nooooo`03o`000?oooooooooo00cooooo0_l0003ooooooeSooooo002nooooo`03
o`000?oooooooooo00kooooo0_l0003ooooooeKooooo002nooooo`03o`000?oooooooooo013ooooo
0_l0003ooooooeCooooo002nooooo`03o`000?oooooooooo01;ooooo0_l0003ooooooe;ooooo002n
ooooo`03o`000?oooooooooo01Cooooo0_l0003ooooooe3ooooo002nooooo`03o`000?oooooooooo
01Kooooo0_l0003oooooodkooooo002nooooo`?o00006?ooool2o`000?ooooooC?ooool00;kooooo
00?o0000ooooooooool06_ooool2o`000?ooooooB_ooool00;kooooo00?o0000ooooooooool07?oo
ool2o`000?ooooooB?ooool00;kooooo00?o0000ooooooooool07_ooool2o`000?ooooooA_ooool0
0;kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`3ooooood?ooooo002nooooo`03
o`000?oooooooooo027ooooo0_l0003ooooood?ooooo002nooooo`03o`000?oooooooooo02?ooooo
0_l0003ooooood7ooooo002nooooo`03o`000?oooooooooo02Gooooo0_l0003oooooocoooooo002n
ooooo`?o00009oooool2o`000?oooooo?Oooool00;kooooo00?o0000ooooooooool0:Oooool2o`00
0003ooooool0003o000000;o0000oooooolfooooo`00__ooool00ol0003oooooooooo`0[ooooo`;o
00000_ooool00ol0003oooooooooo`3oooooocCooooo002nooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooool000000_ooool00ol0003oooooooooo`3ooooooc?ooooo002nooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooc?ooooo002n
ooooo`03o`000?oooooooooo02cooooo1?l0003oooooocKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000
oooooomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0HOooool4o`000?oo
oooo0Oooool00;kooooo00?o0000ooooooooool0HOooool01?l0003oooooooooool0003oooooo`7o
oooo002nooooo`03o`000?oooooooooo063ooooo00Go0000ooooooooooooooooo`00003oooooo`7o
oooo002nooooo`03o`000?oooooooooo063ooooo0_l000000ooooooo0000ooooo`3oooooo`7ooooo
002nooooo`03o`000?oooooooooo06;ooooo00?o0000ooooooooool0ooooool1ooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003ooooo
ooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03
o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co0000
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32063 .16181 .00609 0 365.73 arc
s
newpath
.33968 .04151 .00609 0 365.73 arc
s
newpath
.32184 .05201 .00609 0 365.73 arc
s
.31462 .16086 m
.33367 .04055 L
s
.32665 .16276 m
.3457 .04246 L
s
.33659 .03626 m
.31875 .04676 L
s
.34277 .04675 m
.32493 .05726 L
s
.30961 .05592 m
.31919 .06903 L
s
.33886 .05466 m
.32928 .04155 L
s
.32063 .16181 m
.4335 .2076 L
s
.30961 .05592 m
.32928 .04155 L
s
.31919 .06903 m
.33886 .05466 L
s
.30961 .05592 m
.32184 .05201 L
s
.32928 .04155 m
.32184 .05201 L
s
newpath
.4335 .2076 .00457 0 365.73 arc
s
newpath
.53862 .29417 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool6o`0001;ooooo00?o0000ooooooooool0oooooom>
ooooo`00Yoooool00ol0003oooooooooo`0Dooooo`03o`000?oooooo000000?ooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo017o
oooo0ol000000ooooooo0000ooooo`02ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool0oooooom@ooooo`00ZOooool00ol0003oooooooooo`0?ooooo`;o000000?oooooo`000?l00000
1Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo00?o
0000ooooooooool03?ooool2o`000003ooooool0003ooooo00;o00001Oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo0?ooooooD_ooool00:_ooooo00?o0000ooooooooool02_ooool2
o`000003ooooool0003ooooo00Go000000Coooooo`000?l0003o00002oooool00ol0003ooooooooo
o`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00Oooooo0ol000000ooooooo0000ooooo`02
ooooo`;o00000_ooool2o`000003ooooool0003ooooo00Wooooo00?o0000ooooooooool0oooooomD
ooooo`00[Oooool00ol0003oooooooooo`06ooooo`;o00000_ooool2o`0000;ooooo1?l00003oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomEooooo`00[_ooool00ol0003o
ooooooooo`04ooooo`07o`000?ooooooooooooooool0003oooooo`000002ooooo`;o00001?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000oooo
ooooool00_ooool2o`000003ooooool0003o000000?ooooo0ol000000ooooooo0000ooooo`02oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooooomGooooo`00/?ooool00ol0003o
ooooooooo`04o`0000Cooooo0_l000000ooooooo0000ooooo`02o`0000;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`?o00000_ooool2o`0000;ooooo
0_l00002ooooo`;o00001?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo
FOooool00;;ooooo00?o0000ooooooooool00oooool2o`0000?ooooo0_l00005ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool0oooooomJooooo`00/oooool00ol0003oooooooooo`06
ooooo`?o00001Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooFoooool0
0;Cooooo00?o0000ooooooooool01?ooool01?l0003oooooo`000?l00004ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0oooooomLooooo`00]Oooool01?l0003oooooooooooooool2
o`0000;ooooo1?l00002ooooo`05o`000?ooooooooooooooool00000oooooomOooooo`00]_ooool0
0ol0003oooooo`000004ooooo`;o00001?ooool01?l0003oooooooooool0003oooooof3ooooo002g
ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`03o`000?oooooo00000?ooooooHOooool0
0;Sooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0003oooooof;ooooo002iooooo`06
o`000?ooooooooooo`000?oooooo00001?ooool00ol0003oooooooooo`3oooooof7ooooo002joooo
o`05o`000?oooooo0000ooooool000000oooool00ol0003oooooooooo`3oooooof;ooooo002]oooo
o`?o00001?ooool2o`0000Gooooo0_l000001?oooooo0000ooooooooool2o`000?ooooooI?ooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00005ooooo`07o`000?oooooo
0000ooooool0003oooooo`00003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001Oooool4o`0000;ooooo00?o0000ooooooooool0oooooomRooooo`00[_oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool00000
1?l0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1Oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:gooooo0_l0
0004ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`3oooooof;ooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo0?ooooooHoooool00;[ooooo00Co0000oooooooooooooooo1?l0003oooooofGo
oooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`07
o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`07o`000?oooooooooo
ooooool0003oooooo`00003oooooofKooooo002jooooo`07o`000?ooooooooooooooool0003ooooo
o`00003oooooofKooooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKo
oooo002iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool00000oooooomVooooo`00^Ooo
ool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00^Oooool00ol0003oooooooooo`02
ooooo`?o0000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWoooo
o`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00^Oooool00ol0003ooooo
ooooo`02ooooo`;o0000oooooomWooooo`00^?ooool00ol0003oooooooooo`03ooooo`;o0000oooo
oomWooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo002hooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomVooooo`00^?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Sooooo00?o0000ooooooooool00ooo
ool3o`000?ooooooI_ooool00;Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3o
ooooofKooooo002gooooo`03o`000?oooooooooo00?ooooo0_l0003oooooofSooooo002gooooo`03
o`000?oooooooooo00?ooooo0_l0003oooooofSooooo002gooooo`03o`000?oooooooooo00?ooooo
0_l0003oooooofSooooo002gooooo`03o`000?oooooooooo00?ooooo0_l0003oooooofSooooo002g
ooooo`03o`000?oooooooooo00?ooooo0_l0003oooooofSooooo002gooooo`03o`000?oooooooooo
00?ooooo0_l0003oooooofSooooo002fooooo`03o`000?oooooooooo00Cooooo1?l0003oooooofKo
oooo002fooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000oooooomXooooo`00]_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooo00000?ooooooJ?ooool00;Kooooo00?o0000
ooooooooool00oooool00ol0003oooooo`00003oooooofSooooo002fooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooool00000oooooomXooooo`00]_ooool4o`0000;ooooo00?o0000ooooool0
0000oooooomXooooo`00[?ooool5o`0000?ooooo0ol00003ooooo`05o`000?oooooo0000ooooool0
0000oooooomXooooo`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?oooooo0000o`00
00?ooooo0_l00002ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000oooooooo
ool00_ooool01Ol0003oooooo`000?l0003ooooo00;o000000Goooooo`000?ooooooooooo`00003o
ooooofSooooo002_ooooo`06o`000?ooooooooooooooool0003ooooo0_l00003ooooo`?o000000?o
ooooo`000?l000000ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooo`000?l00003ooooo`03o`000?oooooooooo00;o0000oooooomXooooo`00[?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooool000000_l000000ooooooo0000
o`000003ooooo`?o0000oooooomVooooo`00[Oooool3o`0000Cooooo0_l00002ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00ol0003oooooof?ooooo002nooooo`03o`000?oooooo
oooo00?ooooo0_l0003oooooof7ooooo002nooooo`03o`000?oooooooooo00Gooooo0ol0003ooooo
oekooooo002nooooo`03o`000?oooooooooo00Sooooo0_l0003ooooooecooooo002nooooo`03o`00
0?oooooooooo00[ooooo0ol0003ooooooeWooooo002nooooo`?o00003Oooool2o`000?ooooooEooo
ool00;kooooo00?o0000ooooooooool03oooool2o`000?ooooooEOooool00;kooooo00?o0000oooo
ooooool04Oooool3o`000?ooooooD_ooool00;kooooo00?o0000ooooooooool05?ooool2o`000?oo
ooooD?ooool00;kooooo00?o0000ooooooooool05_ooool3o`000?ooooooCOooool00;kooooo00?o
0000ooooooooool06Oooool2o`000?ooooooBoooool00;kooooo00?o0000ooooooooool06oooool2
o`000?ooooooBOooool00;kooooo00?o0000ooooooooool07Oooool3o`000?ooooooA_ooool00;ko
oooo00?o0000ooooooooool08?ooool2o`000?ooooooA?ooool00;kooooo0ol0000Rooooo`?o0000
oooooom1ooooo`00__ooool00ol0003oooooooooo`0Uooooo`;o0000ooooooloooooo`00__ooool0
0ol0003oooooooooo`0Wooooo`?o0000oooooollooooo`00__ooool00ol0003oooooooooo`0Zoooo
o`;o0000ooooooljooooo`00__ooool00ol0003oooooooooo`0/ooooo`;o00000_ooool3o`000?oo
oooo<oooool00;kooooo00?o0000ooooooooool0;_ooool3o`0000;ooooo00?o0000ooooooooool0
ooooool`ooooo`00__ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo000000;ooooo00?o
0000ooooooooool0ooooool_ooooo`00__ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0ooooool_ooooo`00__ooool3o`00033ooooo1?l0003ooooo
oc;ooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001ooo
ool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`1Vooooo`?o0000o?ooool00;kooooo0ol0001Voooo
o`04o`000?ooooooooooo`000?_ooooo002nooooo`03o`000?oooooooooo06Kooooo00Go0000oooo
ooooooooooooo`00003jooooo`00__ooool00ol0003oooooooooo`1Vooooo`;o000000?oooooo`00
0?ooool0n_ooool00;kooooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`3jooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo
00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol0
0003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo
1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3227 .16211 .00609 0 365.73 arc
s
newpath
.33865 .04136 .00609 0 365.73 arc
s
newpath
.32071 .0517 .00609 0 365.73 arc
s
.31667 .16131 m
.33261 .04056 L
s
.32874 .16291 m
.34469 .04215 L
s
.3356 .03608 m
.31767 .04643 L
s
.34169 .04663 m
.32376 .05698 L
s
.3161 .06369 m
.33232 .06443 L
s
.33344 .04009 m
.31721 .03935 L
s
.3227 .16211 m
.43943 .19691 L
s
.3161 .06369 m
.31721 .03935 L
s
.33232 .06443 m
.33344 .04009 L
s
.3161 .06369 m
.32071 .0517 L
s
.31721 .03935 m
.32071 .0517 L
s
newpath
.43943 .19691 .00457 0 365.73 arc
s
newpath
.54987 .2882 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool6o`0001;ooooo00?o0000ooooooooool0oooooom>
ooooo`00Yoooool00ol0003oooooooooo`0Cooooo`?o00001?ooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool02oooool:o`0000Co
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooe3ooooo002Yooooo`03o`00
0?oooooooooo00[ooooo00Co0000oooooooooooooooo0_l00002ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`00
0?oooooooooo00Wooooo1?l00004ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
2oooool00ol0003oooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo00Sooooo1?l0
0004ooooo`?o000000Coooooo`000?l0003o00003?ooool00ol0003oooooooooo`3ooooooe?ooooo
002/ooooo`03o`000?oooooooooo00Oooooo0_l00002ooooo`05o`000?ooooooooooooooool00000
0_ooool4o`0000_ooooo00?o0000ooooooooool0oooooomDooooo`00[Oooool00ol0003ooooooooo
o`06ooooo`05o`000?oooooo0000ooooool000000oooool4o`0000;ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`3ooooooeGooooo002^ooooo`03o`000?oooooooooo00Cooooo0_l0
00001_oooooo0000oooooooooooo0000ooooo`?o00000oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool00oooool01?l0003ooooo
ooooool00002ooooo`Co00001?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oo
ooooEoooool00;3ooooo00?o0000ooooooooool00_ooool3o`0000;ooooo0_l000000ooooooo0000
o`000004ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooooomHooooo`00/Ooo
ool01?l0003oooooooooooooool3o`000003ooooool0003o000000;ooooo0_l00004ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomIooooo`00/_ooool00ol0003ooooooooo
o`02o`000003ooooool0003ooooo00?ooooo0_l00004ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0oooooomJooooo`00/oooool01?l0003oooooo`000?l00006ooooo`;o00001?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFoooool00;Cooooo0ol00006
ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooG?ooool0
0;Gooooo3?l00002ooooo`05o`000?ooooooooooooooool00000oooooomOooooo`00]_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooo000000?ooooo00Go0000ooooooooooooooooo`00003o
ooooof3ooooo002gooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000000oooool01?l0
003oooooooooool0003oooooof7ooooo002hooooo`07o`000?ooooooooooooooool0003oooooo`00
0003ooooo`03o`000?oooooo00000?ooooooH_ooool00;Wooooo00Ko0000oooooooooooo0000oooo
ool00003ooooo`;o0000oooooomSooooo`00^_ooool01Ol0003oooooo`000?oooooo000000?ooooo
00?o0000ooooooooool0oooooomRooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`;o000000Co
ooooo`000?oooooooooo0_l0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001Oooool01ol0003oooooo`000?oooooo0000ooooool00000oooooomToooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooo
ool000000_l00002ooooo`03o`000?oooooooooo0?ooooooH_ooool00:kooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Go0000oooooomToooo
o`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`3oooooof?ooooo002]ooooo`;o00001?ooool01?l0
003oooooooooool00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooo
oomSooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo0?ooooooHoooool00;[ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oo
oooooooo0?ooooooHoooool00;[ooooo00Co0000oooooooooooooooo0ol0003oooooofKooooo002j
ooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`07o`000?oo
ooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`07o`000?ooooooooooooooool0
003oooooo`00003oooooofKooooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00003o
ooooofKooooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002j
ooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002iooooo`03o`000?oo
oooooooo00;ooooo0_l0003oooooofOooooo002iooooo`03o`000?oooooooooo00;ooooo0ol0003o
ooooofKooooo002iooooo`03o`000?oooooooooo00;ooooo0_l0003oooooofOooooo002iooooo`03
o`000?oooooooooo00;ooooo0_l0003oooooofOooooo002iooooo`03o`000?oooooooooo00;ooooo
0_l0003oooooofOooooo002iooooo`03o`000?oooooooooo00;ooooo0_l0003oooooofOooooo002i
ooooo`03o`000?oooooooooo00;ooooo0_l0003oooooofOooooo002iooooo`03o`000?oooooooooo
00;ooooo0_l0003oooooofOooooo002hooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0oooooomVooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;Sooooo00?o0000ooooooooool00oooool3o`000?ooooooI_ooool00;Sooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo002hooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool0oooooomVooooo`00^?ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;Sooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`3oooooofKooooo002gooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooo
oomVooooo`00]oooool00ol0003oooooooooo`03ooooo`;o0000oooooomXooooo`00]oooool00ol0
003oooooooooo`03ooooo`;o0000oooooomXooooo`00]oooool00ol0003oooooooooo`03ooooo`Co
0000oooooomVooooo`00]oooool00ol0003oooooooooo`03ooooo`;o0000oooooomXooooo`00]ooo
ool00ol0003oooooooooo`03ooooo`;o0000oooooomXooooo`00]oooool00ol0003oooooooooo`03
ooooo`;o0000oooooomXooooo`00]oooool00ol0003oooooooooo`03ooooo`;o0000oooooomXoooo
o`00]_ooool01?l0003oooooo`000?l00003ooooo`;o0000oooooomXooooo`00[?ooool5o`0000?o
oooo1?l00002ooooo`05o`000?oooooo0000ooooool00000oooooomXooooo`00[Oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo00;o00000oooool2o`000003ooooool0003ooooo
0?ooooooIoooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004oooo
o`;o000000?oooooo`000?ooool0oooooomWooooo`00[oooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool01?l000000ooooooo0000o`000003o`000?ooooooI?ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00;o00001?ooool3o`00
0?ooooooJ?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo
00?o000000?oooooo`000?l000000_ooool4o`000?ooooooIOooool00:gooooo0ol00004ooooo`;o
00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooooooo`Co0000oooooomQoooo
o`00__ooool00ol0003oooooooooo`05ooooo`?o0000oooooomNooooo`00__ooool00ol0003ooooo
ooooo`08ooooo`?o0000oooooomKooooo`00__ooool00ol0003oooooooooo`0;ooooo`Co0000oooo
oomGooooo`00__ooool00ol0003oooooooooo`0?ooooo`?o0000oooooomDooooo`00__ooool3o`00
01;ooooo0ol0003ooooooe7ooooo002nooooo`03o`000?oooooooooo01Gooooo1?l0003oooooodgo
oooo002nooooo`03o`000?oooooooooo01Wooooo0ol0003ooooood[ooooo002nooooo`03o`000?oo
oooooooo01cooooo0ol0003oooooodOooooo002nooooo`03o`000?oooooooooo01oooooo1?l0003o
oooood?ooooo002nooooo`03o`000?oooooooooo02?ooooo0ol0003ooooood3ooooo002nooooo`03
o`000?oooooooooo02Kooooo0ol0003oooooocgooooo002nooooo`03o`000?oooooooooo02Wooooo
1?l00007ooooo`;o0000ooooool`ooooo`00__ooool00ol0003oooooooooo`0]ooooo`?o00000ooo
ool01?l0003oooooooooool0003ooooooboooooo002nooooo`?o0000<?ooool3o`0000?ooooo00?o
0000ooooooooool0ooooool]ooooo`00__ooool00ol0003oooooooooo`0booooo`?o00000_ooool0
0ol0003oooooooooo`3oooooobcooooo002nooooo`03o`000?oooooooooo03?ooooo00Co0000oooo
ool0003o0000ooooool_ooooo`00__ooool00ol0003oooooooooo`0dooooo`03o`000?oooooooooo
0?oooooo;oooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^
ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo06cooooo1?l0003eooooo`00__ooool00ol0003ooooo
ooooo`1/ooooo`04o`000?ooooooooooo`000?Gooooo002nooooo`03o`000?oooooooooo06_ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`3booooo`00__ooool00ol0003ooooooooo
o`1/ooooo`04o`000?oooooo0000o`000?Gooooo002nooooo`?o0000KOooool00ol0003ooooooooo
o`3eooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oo
ooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool0
0_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo
1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31914 .16156 .00609 0 365.73 arc
s
newpath
.34043 .04163 .00609 0 365.73 arc
s
newpath
.32195 .05097 .00609 0 365.73 arc
s
.31314 .16049 m
.33444 .04057 L
s
.32513 .16262 m
.34643 .0427 L
s
.33768 .0362 m
.3192 .04554 L
s
.34318 .04707 m
.3247 .05641 L
s
.32907 .06166 m
.33905 .04884 L
s
.31982 .03388 m
.30985 .0467 L
s
.31914 .16156 m
.43909 .1827 L
s
.32907 .06166 m
.30985 .0467 L
s
.33905 .04884 m
.31982 .03388 L
s
.32907 .06166 m
.32195 .05097 L
s
.30985 .0467 m
.32195 .05097 L
s
newpath
.43909 .1827 .00457 0 365.73 arc
s
newpath
.56212 .28109 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool03oooool2o`0000Gooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`3oooooodgooooo002Vooooo`03o`000?oooooooooo00kooooo00?o0000ooooool000001?ooool0
0ol0003oooooo`000003o`0001;ooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0
003oooooooooo`0<ooooo`05o`000?ooooooooooooooool000000oooool3o`0000?ooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool00oooool4o`000003ooooool0003ooooo00;ooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`3ooooooe3ooooo002Yooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool00oooool6o`0000Gooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooo
oooo0_l00004ooooo`;o00001Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?oo
ooooD_ooool00:_ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooooooool4o`0000?o
oooo1?l000001?oooooo0000o`000?l0000;ooooo`03o`000?oooooooooo0?ooooooDoooool00:co
oooo00?o0000ooooooooool00oooool3o`000003ooooool0003o000000?ooooo00?o0000oooooooo
ool00ol000001Ooooooo0000o`000?oooooo000000[ooooo00?o0000ooooooooool0oooooomDoooo
o`00[Oooool00ol0003oooooooooo`04ooooo`Co00000oooool00ol0003oooooooooo`04o`0000?o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooeGooooo002^ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00000oooool01_l0003oooooo`000?l0003ooooo
o`0000;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooeKooooo002_oooo
o`03o`000?oooooooooo00?ooooo0_l000000ooooooo0000ooooo`02ooooo`?o000000?oooooo`00
0?ooool00_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooEoooool00;3o
oooo00?o0000ooooooooool00oooool7o`000003ooooool0003o000000Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oooooooooo00Cooooo
0ol00003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`3ooooooeWooooo002booooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_l0
0005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomJooooo`00/oooool0
0ol0003oooooooooo`05ooooo`04o`000?oooooo0000o`0000Cooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`3ooooooe_ooooo002dooooo`03o`000?oooooooooo00Gooooo0ol00004
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomLooooo`00]Oooool00ol0
003oooooooooo`05ooooo`Co00000_ooool01Ol0003ooooooooooooooooo00000?ooooooGoooool0
0;Kooooo00?o0000ooooooooool01?ooool2o`0000Cooooo00Co0000oooooooooooo0000oooooomP
ooooo`00]oooool00ol0003oooooooooo`03ooooo`;o00001?ooool00ol0003oooooo`00003ooooo
of7ooooo002hooooo`07o`000?ooooooooooooooool0003oooooo`000004ooooo`;o0000oooooomR
ooooo`00^Oooool01_l0003oooooooooool0003oooooo`0000?ooooo0_l0003oooooof?ooooo002j
ooooo`05o`000?oooooo0000ooooool000000oooool00ol0003oooooooooo`3oooooof;ooooo002]
ooooo`?o00001?ooool2o`0000Gooooo0_l000001?oooooo0000ooooooooool2o`000?ooooooI?oo
ool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00005ooooo`07o`000?oo
oooo0000ooooool0003oooooo`00003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00001Oooool4o`0000;ooooo00?o0000ooooooooool0oooooomRooooo`00
[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooooooo
ool01Ol0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00:go
oooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`3oooooof?ooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00005oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[ooooo00Go0000oooo
ooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[ooooo00Oo0000oooo
ooooooooooooo`000?oooooo00000?ooooooI_ooool00;[ooooo00Oo0000ooooooooooooooooo`00
0?oooooo00000?ooooooI_ooool00;[ooooo00Co0000oooooooooooooooo0ol0003oooooofKooooo
002jooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`07o`00
0?ooooooooooooooool0003oooooo`00003oooooofKooooo002iooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooool00000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o0000
oooooomWooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00^Oooool0
0ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00^Oooool00ol0003oooooooooo`02oooo
o`;o0000oooooomWooooo`00^Oooool00ol0003oooooooooo`02ooooo`?o0000oooooomVooooo`00
^?ooool00ol0003oooooooooo`03ooooo`;o0000oooooomWooooo`00^?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Sooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`3oooooofKooooo002hooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0oooooomVooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooofKooooo
002gooooo`03o`000?oooooooooo00?ooooo0_l0003oooooofSooooo002gooooo`03o`000?oooooo
oooo00?ooooo0_l0003oooooofSooooo002gooooo`03o`000?oooooooooo00?ooooo1?l0003ooooo
ofKooooo002gooooo`03o`000?oooooooooo00?ooooo0_l0003oooooofSooooo002gooooo`03o`00
0?oooooooooo00?ooooo0_l0003oooooofSooooo002fooooo`03o`000?oooooooooo00Cooooo0_l0
003oooooofSooooo002fooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000oooooomX
ooooo`00]_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo00000?ooooooJ?ooool00;Ko
oooo00?o0000ooooooooool00oooool00ol0003oooooo`00003oooooofSooooo002fooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooool00000oooooomXooooo`00]_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooo000000;o0000oooooomVooooo`00]Oooool00ol0003oooooooooo`04
ooooo`03o`000?oooooo00000?ooooooJ?ooool00;Gooooo00?o0000ooooooooool00oooool01?l0
003oooooooooool0003oooooofSooooo002eooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo0000oooooomXooooo`00]Oooool00ol0003oooooooooo`03ooooo`04o`000?oooooooooo
o`000?ooooooJ?ooool00;Gooooo1?l00002ooooo`04o`000?ooooooooooo`000?ooooooJ?ooool0
0:cooooo1Ol00003ooooo`;o00000oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo00Co0000oooooooooooo00000_ooool4o`0000;ooooo0_l00003oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooooooool00_ooool2o`000003
ooooool0003o000000?o00000oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`04o`00
0?ooooooooooooooo`;o000000?oooooo`000?ooool00_ooool9o`000?ooooooI?ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo0000o`0000;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooo`000005o`000?ooooooHOooool00:cooooo00Go0000oooooooo
ooooooooo`000002ooooo`03o`000?oooooooooo00Co00001?ooool00ol0003oooooooooo`05oooo
o`Ko0000oooooomKooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo00_o
oooo1Ol0003ooooooeKooooo002nooooo`03o`000?oooooooooo013ooooo1_l0003ooooooe3ooooo
002nooooo`03o`000?oooooooooo01Kooooo1_l0003ooooood[ooooo002nooooo`03o`000?oooooo
oooo01cooooo1Ol0003oooooodGooooo002nooooo`03o`000?oooooooooo027ooooo1_l0003ooooo
ocoooooo002nooooo`?o00009oooool6o`0000Kooooo0ol0003ooooooc3ooooo002nooooo`03o`00
0?oooooooooo02gooooo1Ol000001Ooooooo0000oooooooooooo00000?oooooo;oooool00;kooooo
00?o0000ooooooooool0<_ooool3o`000003ooooool0003ooooo0?oooooo;_ooool00;kooooo00?o
0000ooooooooool0<_ooool01Ol0003ooooooooooooooooo00000?oooooo;oooool00;kooooo00?o
0000ooooooooool0<_ooool2o`000003ooooool0003o00000?oooooo;oooool00;kooooo00?o0000
ooooooooool0=?ooool00ol0003oooooooooo`3ooooooboooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`0007?ooooo0_l0003`ooooo`00__ooool00ol0003oooooooooo`1b
ooooo`04o`000?ooooooooooo`000>oooooo002nooooo`03o`000?oooooooooo07;ooooo00Go0000
ooooooooooooooooo`00003^ooooo`00__ooool00ol0003oooooooooo`1booooo`05o`000?oooooo
ooooooooool00000k_ooool00;kooooo00?o0000ooooooooool0L_ooool4o`000>oooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool00000
0_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol0
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCo
oooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo
002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l0
0003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oo
oooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31096 .15967 .00609 0 365.73 arc
s
newpath
.34452 .04258 .00609 0 365.73 arc
s
newpath
.32437 .04735 .00609 0 365.73 arc
s
.30511 .15799 m
.33867 .0409 L
s
.31681 .16134 m
.35037 .04426 L
s
.34312 .03665 m
.32297 .04142 L
s
.34592 .0485 m
.32577 .05328 L
s
.33718 .04827 m
.33316 .03253 L
s
.30955 .03856 m
.31357 .0543 L
s
.31096 .15967 m
.43251 .16745 L
s
.33718 .04827 m
.31357 .0543 L
s
.33316 .03253 m
.30955 .03856 L
s
.33718 .04827 m
.32437 .04735 L
s
.31357 .0543 m
.32437 .04735 L
s
newpath
.43251 .16745 .00457 0 365.73 arc
s
newpath
.57372 .27376 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Kooooo1?l0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool04_ooool3o`000003ooooool0003ooooo01Oooooo00?o0000ooooooooool0oooo
oom=ooooo`00Y_ooool00ol0003oooooooooo`0>ooooo`?o00001?ooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o0000ooooooooool02_ooool3o`00
00Oooooo0_l000000ooooooo0000o`000004o`0000kooooo00?o0000ooooooooool0oooooom?oooo
o`00Z?ooool00ol0003oooooooooo`07ooooo`;o00002?ooool5o`000003ooooool0003ooooo00?o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooe3ooooo002Yooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01?ooool3o`0000;ooooo0_l000000ooooooo0000
ooooo`04ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomAooooo`00Z_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00Ko0000oooooooooooooooo
o`000?ooool2o`000003ooooool0003ooooo00Cooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
0_ooool01_l0003ooooooooooooooooo0000ooooo`;o000000?oooooo`000?l000001?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o0000oooooooo
ool01?ooool01_l0003ooooooooooooooooo0000ooooo`Ko000000?oooooo`000?ooool00_l00000
1?oooooo0000o`000?l00008ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000
ooooooooool00oooool01?l0003oooooooooooooool2o`0000Cooooo1?l000000ooooooo0000o`00
0002o`000003ooooool0003ooooo00Kooooo00?o0000ooooooooool0oooooomEooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00co00001?ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool00_ooool9o`00
0003ooooool0003o000000Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooo
oeOooooo002`ooooo`04o`000?ooooooooooooooo`;o00002?ooool2o`0000Kooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oooooooooo00[o
oooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomIooooo`00
/_ooool00ol0003oooooooooo`09ooooo`;o00001Oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo0?ooooooF_ooool00;?ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`04ooooo`05o`000?ooooooooooooooool00000oooooomMooooo`00]?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000oooooomNooooo`00]Ooo
ool00ol0003oooooooooo`06ooooo`?o00000oooool01?l0003oooooooooool0003ooooooeoooooo
002fooooo`03o`000?oooooooooo00Cooooo0_l00005ooooo`03o`000?oooooo00000?ooooooH?oo
ool00;Oooooo00?o0000ooooooooool00oooool2o`0000Gooooo0_l0003oooooof7ooooo002hoooo
o`03o`000?oooooooooo00;ooooo0_l00004ooooo`;o0000oooooomRooooo`00^Oooool01?l0003o
ooooooooooooool2o`0000Cooooo00?o0000ooooooooool0oooooomQooooo`00^_ooool01Ol0003o
ooooo`000?oooooo000000?ooooo0_l0003oooooof?ooooo002]ooooo`?o00001?ooool2o`0000Go
oooo0_l000001ooooooo0000oooooooooooo0000ooooool00000oooooomSooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo00Oo0000ooooool0003oooooo`00
0?oooooo00000?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooo000000;o00000_ooool00ol0003oooooooooo`3oooooof;ooooo
002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooo
ooooo`05o`000?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00
[Oooool2o`0000Cooooo00Co0000oooooooooooo00001?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo0?ooooooHoooool00:kooooo00?o0000ooooooooool00oooool2o`0000Co
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[o
oooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo0?ooooooHoooool00;[o
oooo00Oo0000ooooooooooooooooo`000?oooooo00000?ooooooI_ooool00;Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooo`00003oooooofKooooo002iooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooool00000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`?o0000
oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o0000oooooomWooooo`00^?ooool0
0ol0003oooooooooo`03ooooo`;o0000oooooomWooooo`00^?ooool00ol0003oooooooooo`03oooo
o`;o0000oooooomWooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo
002gooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomVooooo`00]oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Oooooo00?o0000oooo
ooooool00oooool4o`000?ooooooI_ooool00;Kooooo00?o0000ooooooooool01?ooool2o`000?oo
ooooJ?ooool00;Kooooo00?o0000ooooooooool01?ooool2o`000?ooooooJ?ooool00;Kooooo00?o
0000ooooooooool00oooool00ol0003oooooo`00003oooooofSooooo002fooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooool00000oooooomXooooo`00]Oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooo00000?ooooooJ?ooool00;Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooo`00003oooooofSooooo002eooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo
0000oooooomXooooo`00]?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`000?oo
ooooJ?ooool00;Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03o`000?oooooo
I_ooool00;Cooooo00?o0000ooooooooool00oooool01Ol0003ooooooooooooooooo00000?oooooo
J?ooool00;Cooooo00?o0000ooooooooool00oooool01Ol0003ooooooooooooooooo00000?oooooo
J?ooool00;?ooooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooooooo00000?oooooo
J?ooool00;?ooooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooooooo00000?oooooo
J?ooool00;?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;;ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooI_ooool00;;ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`?o0000oooooomVooooo`00/_ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomVooooo`00/Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooo
oomVooooo`00/Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0oooooomVooooo`00/Oooool4o`0000;ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`3oooooofKooooo002`ooooo`;o00000oooool00ol0003oooooo`000006ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1_l00002ooooo`;o000000?oooooo`000?ooool0
1Oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo
2Ol00002ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo00?o0000ooooool000000_oo
ool01?l0003oooooooooool00005oooooa3o0000oooooomKooooo`00[oooool5o`000003ooooool0
003o000000Oooooo1Ol00009ooooo`oo00005_ooool3o`000?oooooo<oooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`Co00001oooool00ol0003oooooooooo`0Joooooa3o00001Ooo
ool01Ol0003ooooooooooooooooo00000?oooooo<_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0:_ooool8o`000003
ooooool0003ooooo0?oooooo<Oooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`0^ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0ooooool`ooooo`00__oo
ool00ol0003oooooooooo`0_ooooo`;o000000?oooooo`000?ooool0oooooolbooooo`00__ooool0
0ol0003oooooooooo`0aooooo`03o`000?oooooooooo0?oooooo<_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?oooooo
I?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`1iooooo`;o0000j_ooool00;kooooo00?o
0000ooooooooool0N?ooool01?l0003oooooooooool0003Yooooo`00__ooool00ol0003ooooooooo
o`1hooooo`03o`000?oooooooooo00;o0000j?ooool00;kooooo00?o0000ooooooooool0N?ooool0
1Ol0003ooooooooooooooooo00000>Sooooo002nooooo`?o0000N?ooool4o`000>Wooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool3o`0000?o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool00ol0003oooooooooo`02ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool5o`000?oo
ooooI?ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000?ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooooooo
o`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:cooooo
00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.30652 .15826 .00609 0 365.73 arc
s
newpath
.34674 .04328 .00609 0 365.73 arc
s
newpath
.32629 .04 .00609 0 365.73 arc
s
.30078 .15625 m
.34099 .04127 L
s
.31227 .16027 m
.35249 .04529 L
s
.3477 .03727 m
.32726 .03398 L
s
.34577 .0493 m
.32533 .04601 L
s
.33522 .03076 m
.32057 .02375 L
s
.31005 .04572 m
.3247 .05274 L
s
.30652 .15826 m
.42815 .1516 L
s
.33522 .03076 m
.3247 .05274 L
s
.32057 .02375 m
.31005 .04572 L
s
.33522 .03076 m
.32629 .04 L
s
.3247 .05274 m
.32629 .04 L
s
newpath
.42815 .1516 .00457 0 365.73 arc
s
newpath
.58531 .26587 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01Gooooo0_l00004ooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0Dooooo`04o`000?oooooo
0000o`0000;ooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`3oooooodWooooo002R
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00000K
ooooo`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`03ooooo`;o00006_ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03
o`000?oooooooooo00oooooo00?o0000ooooooooool01Oooool3o`0001Oooooo00?o0000oooooooo
ool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0>ooooo`04o`000?ooooooooooooooo`Ko
00005oooool00ol0003oooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo00cooooo
00Go0000ooooooooooooooooo`000003ooooo`Oo00004_ooool00ol0003oooooooooo`3oooooodko
oooo002Wooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`03o`0000Gooooo1?l0000=ooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o
0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000ooooool0003o
00001?ooool2o`0000?ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3ooooooe3o
oooo002Yooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
ooooool0003ooooo00;o00000oooool2o`0000Cooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
0_ooool7o`0000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo0?ooooooD_ooool00:_ooooo00?o0000ooooooooool01?ooool2o`0000Kooooo1Ol0
0002ooooo`;o00001Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?ooooooDooo
ool00:cooooo00?o0000ooooooooool01Oooool2o`0000Cooooo00Co0000ooooool0003ooooo1ol0
0002ooooo`;o00001oooool00ol0003oooooooooo`3ooooooeCooooo002]ooooo`03o`000?oooooo
oooo00Kooooo0_l00002ooooo`;o00000_ooool4o`000003ooooool0003o000000?o00001oooool0
0ol0003oooooooooo`3ooooooeGooooo002^ooooo`03o`000?oooooooooo00Oooooo1?l00002oooo
o`03o`000?oooooo000000Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooo
oeKooooo002_ooooo`03o`000?oooooooooo00Sooooo00Oo0000ooooooooooooooooo`000?oooooo
000000Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooeOooooo002`oooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo0?ooooooF?ooool00;7ooooo00?o0000ooooooooool02_ooool2o`0000Ko
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooeWooooo002booooo`03o`00
0?oooooooooo00Wooooo0_l00006ooooo`05o`000?ooooooooooooooool00000oooooomLooooo`00
/oooool00ol0003oooooooooo`08ooooo`;o00001Oooool01Ol0003ooooooooooooooooo00000?oo
ooooGOooool00;Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`000?ooooooG_ooool00;Gooooo00?o0000ooooooooool01_ooool3o`0000Cooooo
00?o0000ooooool00000oooooomOooooo`00]_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooool00000oooooomPooooo`00]oooool00ol0003oooooooooo`03
ooooo`;o00001Oooool2o`000?ooooooHOooool00;Sooooo00?o0000ooooooooool00_ooool2o`00
00Gooooo00?o0000ooooooooool0oooooomPooooo`00^Oooool01?l0003oooooooooooooool2o`00
00Cooooo00?o0000ooooooooool0oooooomQooooo`00^_ooool01Ol0003oooooo`000?oooooo0000
00?ooooo0_l0003oooooof?ooooo002]ooooo`?o00001?ooool2o`0000Gooooo0_l000001ooooooo
0000oooooooooooo0000ooooool00000oooooomSooooo`00[_ooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000Gooooo00Oo0000ooooool0003oooooo`000?oooooo00000?oooooo
I?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`00
0?oooooo000000;o00000_ooool00ol0003oooooooooo`3oooooof;ooooo002^ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05o`000?oooooo
I?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00[Oooool2o`0000Cooooo
00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0oooooomSooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001?ooool01ol0003o
oooooooooooooooo0000ooooool00000oooooomVooooo`00^_ooool01ol0003ooooooooooooooooo
0000ooooool00000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
00000?ooooooI_ooool00;Wooooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool00;Wo
oooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool00;Sooooo00?o0000ooooooooool0
0oooool3o`000?ooooooI_ooool00;Sooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`3oooooofKooooo002hooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0oooooomV
ooooo`00]oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooI_ooool00;Oo
oooo00?o0000ooooooooool00oooool2o`000?ooooooJ?ooool00;Oooooo00?o0000ooooooooool0
0oooool2o`000?ooooooJ?ooool00;Kooooo00?o0000ooooooooool01?ooool2o`000?ooooooJ?oo
ool00;Kooooo00?o0000ooooooooool00oooool00ol0003oooooo`00003oooooofSooooo002foooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooool000000_l0003oooooofKooooo002eooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooool00000oooooomXooooo`00]Oooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooo`000?ooooooJ?ooool00;Gooooo00?o0000ooooooooool0
0oooool01?l0003oooooooooool0003oooooofSooooo002dooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000oooooomXooooo`00]?ooool00ol0003oooooooooo`03ooooo`05o`00
0?ooooooooooooooool00000oooooomXooooo`00]?ooool00ol0003oooooooooo`03ooooo`05o`00
0?ooooooooooooooool00000oooooomXooooo`00/oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00/oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00/oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo0ol0003oooooofKooooo002boooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooo
ofKooooo002booooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`3oooooofKooooo002booooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`3oooooofKooooo002aooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`3oooooofKooooo002aooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooofKooooo002aoooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooo
ofKooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002`ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
1Oooool3o`000?ooooooI_ooool00;3ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo02gooooo0ol0003oooooocKooooo002_ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0]ooooo`04o`000?oooooo
ooooo`000?oooooo=Oooool00:oooooo0ol00003ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool09_ooool9o`0000;ooooo00?o0000ooooooooool0oooooolbooooo`00[_ooool2o`00
00;ooooo00Co0000oooooooooooo00002?ooool00ol0003oooooooooo`0Foooooa3o00001_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?oooooo<_ooool00:kooooo00?o0000oooo
ooooool00_ooool2o`0000Wooooo00?o0000ooooooooool01oooool?o`0001Oooooo1?l0003ooooo
ocGooooo002/ooooo`Go00000_ooool3o`0000;ooooo4?l0003ooooooeoooooo002]ooooo`03o`00
0?oooooooooo00So00001_ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`03o`000?oo
oooooooo00;ooooo0_l000000ooooooo0000ooooo`06ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:kooooo0_l00002ooooo`;o00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomT
ooooo`00[?ooool01?l0003oooooooooooooool2o`000005ooooool0003oooooooooool000001ooo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooo
oomTooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`1oooooo`;o0000i?ooool00;kooooo00?o0000oooo
ooooool0O_ooool01?l0003oooooooooool0003Sooooo`00__ooool00ol0003oooooooooo`1noooo
o`05o`000?ooooooooooooooool00000h_ooool00;kooooo00?o0000ooooooooool0O_ooool01Ol0
003ooooooooooooooooo00000>;ooooo002nooooo`03o`000?oooooooooo07kooooo1?l0003Soooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007oooo
o`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;o
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go
0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00
[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001
\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31312 .16025 .00609 0 365.73 arc
s
newpath
.34344 .04229 .00609 0 365.73 arc
s
newpath
.32672 .03007 .00609 0 365.73 arc
s
.30722 .15874 m
.33754 .04077 L
s
.31901 .16177 m
.34934 .0438 L
s
.34703 .03737 m
.33031 .02515 L
s
.33985 .0472 m
.32313 .03499 L
s
.32496 .01736 m
.3104 .02456 L
s
.32121 .04639 m
.33576 .03919 L
s
.31312 .16025 m
.43188 .13321 L
s
.32496 .01736 m
.33576 .03919 L
s
.3104 .02456 m
.32121 .04639 L
s
.32496 .01736 m
.32672 .03007 L
s
.33576 .03919 m
.32672 .03007 L
s
newpath
.43188 .13321 .00457 0 365.73 arc
s
newpath
.59788 .25665 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01Wooooo0_l00003oooo
o`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003o
ooooooooo`0Eooooo`?o000000?oooooo`000?ooool00_ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool04Oooool3o`0000Cooooo
0_l00002ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooom7ooooo`00X?oo
ool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00Gooooo0ol000000ooooooo0000oooo
o`0Looooo`03o`000?oooooooooo0?ooooooB?ooool00:7ooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooo000000?o00007?ooool00ol0003oooooooooo`3o
ooooodWooooo002Rooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool00oooool00ol0
003oooooo`000004o`0001[ooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo0000ooooo`02o`00
0003ooooool0003ooooo01Oooooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0003o
ooooooooo`0=ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooo`000004o`00
01Gooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo00;ooooo0_l000001?oooooo0000o`000?l00004ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool0oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0<ooooo`04
o`000?ooooooooooooooo`?o00000_ooool2o`0000?ooooo0ol0000@ooooo`03o`000?oooooooooo
0?ooooooC_ooool00:Oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00;o00000_ooool00ol0003oooooooooo`02o`0000kooooo00?o0000oooooooo
ool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00?ooooo
1_l00004ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooom@ooooo`00ZOoo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Cooooo0_l000000ooooooo0000o`00
0005ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool0
0ol0003oooooooooo`0:ooooo`04o`000?ooooooooooooooo`;o000000?oooooo`000?l000000_l0
0005ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooomBooooo`00Zoooool0
0ol0003oooooooooo`09ooooo`04o`000?oooooo0000o`0000?ooooo00Co0000oooooooooooo0000
1?ooool2o`0000Wooooo00?o0000ooooooooool0oooooomCooooo`00[?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool000000ol000001?oooooo0000o`00
0?l00008ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000ooooooooool03_oo
ool3o`0000?ooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`3ooooooeGooooo002^
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool03?ooool00ol0
003oooooo`000005ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomGoooo
o`00/?ooool00ol0003oooooooooo`0;ooooo`;o00001_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo0?ooooooF?ooool00;7ooooo00?o0000ooooooooool02_ooool2o`0000Gooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooeWooooo002booooo`03o`000?oo
oooooooo00Wooooo0_l00005ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooo
oomJooooo`00/oooool00ol0003oooooooooo`08ooooo`;o00001Oooool01Ol0003ooooooooooooo
oooo00000?ooooooGOooool00;Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`000?ooooooG_ooool00;Gooooo00?o0000ooooooooool01_ooool3
o`0000?ooooo00Co0000oooooooooooo0000oooooomOooooo`00]_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000oooooomPooooo`00]oooool00ol0
003oooooooooo`03ooooo`;o00001Oooool2o`000?ooooooHOooool00;Sooooo00?o0000oooooooo
ool00_ooool2o`0000Cooooo0_l0003oooooof;ooooo002iooooo`04o`000?ooooooooooooooo`;o
00001?ooool00ol0003oooooooooo`3oooooof7ooooo002jooooo`03o`000?oooooooooo00;o0000
0oooool2o`000?ooooooHoooool00:gooooo0ol00004ooooo`;o00001Oooool2o`000007ooooool0
003oooooooooool0003oooooo`00003oooooof?ooooo002^ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00001Oooool01ol0003oooooo`000?oooooo0000ooooool00000oooooomT
ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo1?l00002
ooooo`03o`000?oooooooooo0?ooooooH_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00005ooooo`03o`000?oooooo000000Co0000oooooomTooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`3oooooof;ooooo002]ooooo`;o00001?ooool01?l0003oooooooooool0
0004ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00[_oo
ool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`3oooooof?ooooo002jooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooo
ooooo`3oooooof?ooooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKo
oooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00003oooooofKooooo002jooooo`04
o`000?ooooooooooooooo`?o0000oooooomVooooo`00^Oooool00ol0003oooooooooo`02ooooo`03
o`000?oooooo00000?ooooooI_ooool00;Wooooo00?o0000ooooooooool00_ooool2o`000?oooooo
Ioooool00;Wooooo00?o0000ooooooooool00_ooool2o`000?ooooooIoooool00;Sooooo00?o0000
ooooooooool00oooool2o`000?ooooooIoooool00;Sooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`3oooooofKooooo002hooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0oooooomVooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;Oooooo00?o0000ooooooooool01?ooool3o`000?ooooooI_ooool00;Oooooo00?o0000
ooooooooool00oooool2o`000?ooooooJ?ooool00;Oooooo00?o0000ooooooooool00oooool2o`00
0?ooooooJ?ooool00;Oooooo00?o0000ooooooooool00oooool2o`000?ooooooJ?ooool00;Kooooo
00?o0000ooooooooool01?ooool2o`000?ooooooJ?ooool00;Kooooo00?o0000ooooooooool00ooo
ool00ol0003oooooo`00003oooooofSooooo002fooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooool00000oooooomXooooo`00]_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo0000
0?ooooooJ?ooool00;Gooooo00?o0000ooooooooool01?ooool00ol0003oooooo`00000booooo`;o
0000ooooooldooooo`00]Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o0000
;oooool01?l0003oooooooooool0003ooooooc?ooooo002eooooo`03o`000?oooooooooo00?ooooo
00Co0000oooooooooooo0000<?ooool01Ol0003ooooooooooooooooo00000?oooooo<oooool00;Go
oooo00?o0000ooooooooool00oooool01?l0003oooooooooool0000`ooooo`?o00000_ooool00ol0
003oooooooooo`3ooooooc3ooooo002dooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooo
oooo0000:oooool5o`000003ooooool0003ooooo00;o0000oooooolcooooo`00]?ooool00ol0003o
ooooooooo`03ooooo`05o`000?ooooooooooooooool000009oooool4o`0000Oooooo00?o0000oooo
ooooool0oooooolcooooo`00]?ooool00ol0003oooooooooo`03ooooo`05o`000?oooooooooooooo
ool000008oooool4o`000?oooooo@Oooool00;?ooooo00?o0000ooooooooool01?ooool01Ol0003o
oooooooooooooooo000001kooooo1Ol0003oooooodGooooo002cooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Hooooo`Co0000oooooom:ooooo`00
/oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo0ol0000Dooooo`Co0000
oooooom>ooooo`00/oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool03oooool5o`000?ooooooD_ooool00;;ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00_ooooo1?l0003ooooooeOooooo002boooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07oooo
o`Co0000oooooomKooooo`00/_ooool3o`0000?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02ooooo`Go0000oooooomOooooo`00/_ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00?ooooo1Ol0003oooooofCooooo002/ooooo`Oo000000Koooooo`000?l0003o
0000ooooool00002ooooo`Co0000oooooomXooooo`00[Oooool00ol0003oooooooooo`02o`000004
ooooool0003oooooooooo`Go00000oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`05
o`000?ooooooooooo`000?ooool01Ol00006ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oo
oooo00?o0000ooooooooool00_l00002ooooo`;o00001_ooool5o`000?ooooooI?ooool00:cooooo
00Ko0000ooooooooooooooooo`000?ooool2o`000003ooooool0003o000000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo0_l000000ooo
oooo0000ooooo`06ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00
/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`26ooooo`;o0000
gOooool00;kooooo00?o0000ooooooooool0QOooool01?l0003oooooooooool0003Looooo`00__oo
ool00ol0003oooooooooo`24ooooo`05o`000?ooooooooooooooool00000g?ooool00;kooooo00?o
0000ooooooooool0Q?ooool01Ol0003ooooooooooooooooo00000=cooooo002nooooo`?o0000QOoo
ool01?l0003oooooo`000?l0003Looooo`00__ooool00ol0003oooooooooo`26ooooo`03o`000?oo
oooooooo0=cooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co
0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000ooo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l0
0003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[ooo
ool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]
ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0
003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5
o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001ooo
ool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3343 .1628 .00609 0 365.73 arc
s
newpath
.33285 .04101 .00609 0 365.73 arc
s
newpath
.32562 .02161 .00609 0 365.73 arc
s
.32821 .16288 m
.32676 .04108 L
s
.34039 .16273 m
.33894 .04094 L
s
.33856 .03888 m
.33133 .01948 L
s
.32715 .04314 m
.31991 .02374 L
s
.31431 .01552 m
.31153 .03152 L
s
.33553 .03569 m
.33831 .01969 L
s
.3343 .1628 m
.4451 .11223 L
s
.31431 .01552 m
.33831 .01969 L
s
.31153 .03152 m
.33553 .03569 L
s
.31431 .01552 m
.32562 .02161 L
s
.33831 .01969 m
.32562 .02161 L
s
newpath
.4451 .11223 .00457 0 365.73 arc
s
newpath
.61014 .24701 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Fooooo`So000000Cooooo
o`000?l0003o00007oooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooo
oooo01Gooooo00?o0000ooooool000001ol0000Pooooo`03o`000?oooooooooo0?ooooooAOooool0
09kooooo00?o0000ooooooooool05?ooool01Ol0003oooooo`000?oooooo000000?ooooo1Ol0000L
ooooo`03o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool04_ooool01?l0
003oooooooooool00002ooooo`Go00000_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooo
oooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool04Oooool01?l0003oooooooooool00006
ooooo`04o`000?ooooooooooo`0001[ooooo00?o0000ooooooooool0oooooom8ooooo`00XOooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00?o00000_ooool3o`0000;ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo
00oooooo00Ko0000ooooooooooooooooo`000?ooool2o`0000;ooooo00Co0000oooooooooooo0000
6?ooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`?o00006?ooool00ol0003ooooooooo
o`3ooooood_ooooo002Tooooo`03o`000?oooooooooo00cooooo1?l000000ooooooo0000ooooo`04
ooooo`?o00005oooool00ol0003oooooooooo`3oooooodcooooo002Uooooo`03o`000?oooooooooo
00oooooo2?l000000ooooooo0000ooooo`0Eooooo`03o`000?oooooooooo0?ooooooCOooool00:Ko
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`05o`0001Gooooo00?o0000oooooooo
ool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0@ooooo`06o`000?oooooo0000ooooool0
003ooooo0_l0000Cooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000oooooooo
ool03oooool2o`0000;ooooo00Co0000oooooooooooo00004_ooool00ol0003oooooooooo`3ooooo
oe3ooooo002Yooooo`03o`000?oooooooooo00kooooo0_l00002ooooo`04o`000?ooooooooooo`00
017ooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003oooooooooo`0>ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`3ooooo
oe;ooooo002[ooooo`03o`000?oooooooooo00gooooo1ol0000?ooooo`03o`000?oooooooooo0?oo
ooooDoooool00:cooooo00?o0000ooooooooool03?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool0oooooomDooooo`00[Oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00Co00003Oooool00ol0003oooooooooo`3ooooooeGooooo
002^ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool02Ooo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
oooooomGooooo`00/?ooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oo
oooooooo00Oooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo0?ooooooFOooool00;;ooooo00?o0000ooooooooool01_ooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooooomJooooo`00/ooo
ool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`3ooooooe_ooooo002dooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo
G?ooool00;Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04o`0000Gooooo00?o
0000ooooooooool0oooooomMooooo`00]_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooekooooo002g
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00003ooooo`03o`00
0?oooooooooo0?ooooooGoooool00;Sooooo00Co0000oooooooooooo00000_ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Wooooo00?o0000ooooool00000
0_ooool01_l0003oooooooooool0003oooooo`000?ooooooHoooool00;[ooooo0_l00002ooooo`03
o`000?oooooooooo00;o0000oooooomTooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo0_l000000ooooooo0000ooooo`02o`000?oo
ooooIOooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03
o`000?oooooo000000;o000000?oooooo`000?ooool0oooooomTooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol0003oooooofCo
oooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00:gooooo0_l00004ooooo`04
o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3o
ooooof?ooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`04o`000?oooooooooo
o`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo0?ooooooHoooool00;_ooooo00Co0000oooooooooooo00000_ooool0
0ol0003oooooooooo`3oooooof?ooooo002kooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool0oooooomSooooo`00^oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo0?ooooooHoooool00;_ooooo00?o0000ooooooooool01?l0003oooooofGooooo002kooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomSooooo`00^oooool01?l0003o
ooooooooool00002ooooo`03o`000?oooooooooo0?ooooooHoooool00;cooooo00?o0000ooooool0
00000oooool00ol0003oooooooooo`3oooooof;ooooo002looooo`03o`000?oooooo000000?ooooo
00?o0000ooooooooool0oooooomRooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`000?oo
oooooooo03?ooooo0_l0003oooooobgooooo002looooo`03o`000?oooooo000000?ooooo00?o0000
ooooooooool0<_ooool01?l0003oooooooooool0003oooooobcooooo002looooo`03o`000?oooooo
000000?ooooo00?o0000ooooooooool0<_ooool01?l0003oooooooooool0003oooooobcooooo002l
ooooo`03o`000?oooooo000000;o000000?oooooo`000?ooool0<_ooool3o`0000;ooooo00?o0000
ooooooooool0oooooolYooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo
033ooooo0ol000000ooooooo0000o`00003oooooobcooooo002looooo`03o`000?oooooo000000?o
oooo00?o0000ooooooooool0;_ooool2o`0000?ooooo00?o0000ooooooooool0ooooool/ooooo`00
_?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo02_ooooo0ol0003oooooocCooooo
002looooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0:Oooool2o`000?oooooo=ooo
ool00;cooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0Wooooo`;o0000ooooooli
ooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo02Gooooo0_l0003ooooo
oc_ooooo002looooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool08oooool2o`000?oo
oooo?Oooool00;cooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0Pooooo`?o0000
ooooooloooooo`00_?ooool00ol0003oooooo`000002o`000003ooooool0003ooooo01oooooo0_l0
003ooooood;ooooo002looooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool07?ooool2
o`000?ooooooA?ooool00;cooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0Joooo
o`;o0000oooooom6ooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo01So
oooo0_l0003oooooodSooooo002looooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool0
5Oooool3o`000?ooooooB_ooool00;cooooo00?o0000ooooool000000oooool00ol0003ooooooooo
o`0Cooooo`;o0000oooooom=ooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`000?oooooo
oooo017ooooo0_l0003oooooodoooooo002looooo`03o`000?oooooo000000?ooooo00?o0000oooo
ooooool03oooool2o`000?ooooooDOooool00;cooooo00?o0000ooooool000000_l000000ooooooo
0000ooooo`0>ooooo`;o0000oooooomCooooo`00_?ooool00ol0003oooooo`000003ooooo`03o`00
0?oooooooooo00[ooooo0ol0003ooooooeGooooo002looooo`03o`000?oooooo000000?ooooo00?o
0000ooooooooool02?ooool2o`000?ooooooF?ooool00;cooooo00?o0000ooooool000000oooool0
0ol0003oooooooooo`06ooooo`;o0000oooooomJooooo`00_?ooool00ol0003oooooo`000003oooo
o`03o`000?oooooooooo00Cooooo0_l0003ooooooecooooo002looooo`03o`000?oooooo000000?o
oooo00?o0000ooooooooool00_ooool2o`000?ooooooG_ooool00:cooooo1Ol00003ooooo`;o0000
1_ooool00ol0003oooooo`000002o`000003ooooool0003ooooo00?o0000oooooomPooooo`00[Ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Gooooo0ol00002ooooo`?o
0000oooooomSooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Go
oooo0ol000001?oooooo0000o`000?l0003oooooofCooooo002_ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo000000Co0000oooooomToooo
o`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001Oooool0
0ol0003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooH_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Kooooo0_l000000ooooooo0000o`00
003oooooofGooooo002]ooooo`?o00001?ooool2o`0000Sooooo0_l0003oooooofOooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`2<ooooo`;o0000eoooool00:kooooo0_l00003ooooo`04o`000?oooooooooo
o`0000Oooooo1Ol00029ooooo`04o`000?ooooooooooo`000=Kooooo002`ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2;ooooo`03o`000?oo
oooooooo00;o0000eOooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0Roooool01Ol0003ooooooooooooooooo00000=Go
oooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0Roooool2o`000003oooo
ool0003ooooo0=Gooooo002nooooo`03o`000?oooooooooo08gooooo00?o0000ooooooooool0eOoo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000
oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Ooo
ool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4
o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/
ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool0
1?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool0
0ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.36695 .15553 .00609 0 365.73 arc
s
newpath
.31653 .04465 .00609 0 365.73 arc
s
newpath
.32598 .02622 .00609 0 365.73 arc
s
.3614 .15805 m
.31098 .04717 L
s
.37249 .15301 m
.32207 .04213 L
s
.32195 .04743 m
.3314 .029 L
s
.31111 .04187 m
.32056 .02344 L
s
.31493 .03278 m
.32721 .04341 L
s
.34316 .02499 m
.33088 .01436 L
s
.36695 .15553 m
.46807 .08763 L
s
.31493 .03278 m
.33088 .01436 L
s
.32721 .04341 m
.34316 .02499 L
s
.31493 .03278 m
.32598 .02622 L
s
.33088 .01436 m
.32598 .02622 L
s
newpath
.46807 .08763 .00457 0 365.73 arc
s
newpath
.62215 .23694 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Oooooo`;o00008_ooool00ol0003ooooooooo
o`3ooooood?ooooo002Looooo`03o`000?oooooooooo01kooooo1?l0000Oooooo`03o`000?oooooo
oooo0?ooooooA?ooool009gooooo00?o0000ooooooooool07?ooool01?l0003oooooo`000?l0000O
ooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000ooooooooool06Oooool3o`00
0004ooooool0003oooooo`0001gooooo00?o0000ooooooooool0oooooom6ooooo`00Woooool00ol0
003oooooooooo`0Fooooo`?o000000Coooooo`000?l0003o00000_ooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool05Oooool2o`00
0003ooooool0003ooooo00;o00000oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
0?ooooooB?ooool00:7ooooo00?o0000ooooooooool04oooool5o`0000;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo
00?o0000ooooooooool04_ooool3o`0000Cooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Dooooo`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool04Ooo
ool3o`0000;ooooo0ol00003ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooo
oom;ooooo`00Y?ooool00ol0003oooooooooo`0?ooooo`04o`000?ooooooooooooooo`;o000000?o
ooooo`000?l000000ol0000Fooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o0000
ooooooooool03Oooool2o`0000Gooooo00Go0000ooooool0003oooooo`00000Fooooo`03o`000?oo
oooooooo0?ooooooCOooool00:Kooooo00?o0000ooooooooool03?ooool00ol0003oooooo`000004
ooooo`04o`000?oooooo0000o`0001Kooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool0
0ol0003oooooooooo`0:ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool0000Fooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool02Ooo
ool4o`000003ooooool0003o000000;ooooo0_l0000Eooooo`03o`000?oooooooooo0?ooooooD?oo
ool00:Wooooo00?o0000ooooooooool01oooool2o`0000?ooooo0ol000001?oooooo0000ooooool0
000Dooooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`02ooooo`;o000000Goooooo`000?ooooooooooo`00000Cooooo`03o`000?oo
oooooooo0?ooooooD_ooool00:_ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`03
ooooo`;o00000oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDoooool0
0:cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`?o00000oooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000oooooooo
ool00oooool3o`000003ooooool0003o000000;ooooo00?o0000ooooooooool00ol0000>ooooo`03
o`000?oooooooooo0?ooooooEOooool00:kooooo00?o0000ooooooooool00oooool00ol0003ooooo
o`000004ooooo`04o`000?ooooooooooo`0000oooooo00?o0000ooooooooool0oooooomFooooo`00
[oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00003_ooool00ol0003oooooooooo`3ooooooeOooooo002`ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool01?ooool00ol0003oooooo`00000=ooooo`03o`000?oooooooooo0?oooooo
F?ooool00;7ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooo000000cooooo
00?o0000ooooooooool0oooooomIooooo`00/_ooool01Ol0003ooooooooooooooooo000000Kooooo
0_l0000;ooooo`03o`000?oooooooooo0?ooooooF_ooool00;?ooooo00Co0000oooooooooooo0000
1_ooool2o`0000[ooooo00?o0000ooooooooool0oooooomKooooo`00]?ooool00ol0003oooooo`00
0007ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomLooooo`00]Oooool0
0ol0003oooooo`000006ooooo`?o00001_ooool00ol0003oooooooooo`3ooooooegooooo002foooo
o`;o00001_ooool2o`0000Kooooo00?o0000ooooooooool0oooooomNooooo`00]oooool2o`0000Go
oooo0_l00005ooooo`03o`000?oooooooooo0?ooooooGoooool00;Sooooo00?o0000ooooooooool0
0oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo0?ooooooH?ooool00;Wooooo00?o
0000ooooooooool00_ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo0?ooooooHOoo
ool00;Wooooo0_l00003ooooo`05o`000?oooooo0000ooooool00000oooooomTooooo`00[Oooool3
o`0000Cooooo0_l00004ooooo`;o00000_ooool01?l0003oooooooooool0003oooooofGooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01_l0003oooooo`00
0?oooooo0000ooooo`;o0000oooooomUooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooool000000_l00002ooooo`03o`000?oooooooooo0?oo
ooooH_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03
o`000?oooooooooo00Go0000oooooomTooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000Cooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0moooo
o`Co0000oooooolPooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001Oooool00ol0
003oooooo`000004ooooo`03o`000?oooooooooo03gooooo00Co0000oooooooooooo0000oooooolP
ooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001_ooool00ol0003oooooo`000005oooo
o`03o`000?oooooooooo03_ooooo0ol000000ooooooo0000o`00003ooooooaoooooo002mooooo`;o
00001Oooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool0oooooolMooooo`00_Oooool2o`0000Gooooo00?o0000ooooooooool0>Oooool7o`000?oooooo
8?ooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0gooooo`03o`000?oo
oooooooo0?oooooo9Oooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0e
ooooo`;o0000oooooolXooooo`00__ooool3o`0000Gooooo00?o0000ooooooooool0<oooool00ol0
003oooooooooo`3oooooobSooooo002nooooo`;o00001_ooool00ol0003oooooooooo`0aooooo`;o
0000ooooool[ooooo`00__ooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo02oooooo
00?o0000ooooooooool0ooooool[ooooo`00__ooool00ol0003oooooo`000006ooooo`03o`000?oo
oooooooo02gooooo0_l0003oooooobkooooo002nooooo`03o`000?oooooo000000Oooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`3oooooobkooooo002nooooo`04o`000?oooooooooo
o`0000Kooooo00?o0000ooooooooool0:Oooool2o`000?oooooo<Oooool00;kooooo00Co0000oooo
oooooooo00001_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo0?oooooo<Oooool0
0;kooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo02Gooooo0_l0003o
ooooocCooooo002nooooo`?o000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`0Toooo
o`03o`000?oooooooooo0?oooooo=?ooool00;kooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo027ooooo0_l0003oooooocOooooo002nooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo0?oooooo=oooool00;kooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo01gooooo0_l0003ooooooc[ooooo002nooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo0?oooooo>_ooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0oooooolkooooo`00__ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool06?ooool2o`000?oo
oooo?_ooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo01Kooooo00?o0000ooooooooool0oooooolnooooo`00__ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool05?ooool2o`000?oooooo@Ooo
ool00;kooooo0ol00005ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`3ooooood7ooooo002nooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0@ooooo`;o0000oooooom4ooooo`00__ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`3oooooodCooooo002nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`;o0000oooooom7ooooo`00__ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`3oooooodOooooo002nooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`08ooooo`;o0000oooooom:ooooo`00__ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooo
od[ooooo002nooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`;o0000oooooom=ooooo`00__ooool3o`0000Wooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooCOooool00;kooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooooooo`;o0000
oooooom@ooooo`00__ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooooooo`Co0000
00?oooooo`000?ooool0oooooomAooooo`00__ooool00ol0003oooooooooo`0:ooooo`04o`000?oo
ooooooooo`0000?ooooo0_l0003ooooooe?ooooo002nooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooool000000_ooool3o`000?ooooooDoooool00;kooooo00?o0000ooooooooool02oooool2
o`0000;ooooo00Co0000oooooooooooo0000oooooomCooooo`00[?ooool5o`0000?ooooo0_l00008
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3o
oooooe7ooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`0<ooooo`?o000000?oooooo`000?l00000oooooomDooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool03ooo
ool00ol0003oooooooooo`3ooooooeCooooo002_ooooo`05o`000?ooooooooooooooool000000_oo
ool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
09?ooooo0_l0003@ooooo`00__ooool00ol0003oooooooooo`2Booooo`04o`000?ooooooooooo`00
0<oooooo002nooooo`03o`000?oooooooooo097ooooo00Go0000ooooooooooooooooo`00003?oooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo097ooooo00Go0000oooooooo
ooooooooo`00003?ooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`2Aooooo`Co0000d?ooool00;3ooooo00Co0000oooo
oooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooo
oooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0
003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003o
ooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003o
ooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.37975 .14824 .00609 0 365.73 arc
s
newpath
.31013 .04829 .00609 0 365.73 arc
s
newpath
.32855 .03884 .00609 0 365.73 arc
s
.37475 .15172 m
.30513 .05178 L
s
.38475 .14475 m
.31512 .04481 L
s
.31291 .05371 m
.33133 .04426 L
s
.30734 .04288 m
.32577 .03342 L
s
.32719 .05161 m
.34305 .04813 L
s
.33784 .02434 m
.32198 .02781 L
s
.37975 .14824 m
.47508 .07242 L
s
.32719 .05161 m
.32198 .02781 L
s
.34305 .04813 m
.33784 .02434 L
s
.32719 .05161 m
.32855 .03884 L
s
.32198 .02781 m
.32855 .03884 L
s
newpath
.47508 .07242 .00457 0 365.73 arc
s
newpath
.6349 .22557 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo1?l0000Jooooo`03o`000?oooooooooo0?ooooooB?oo
ool00:7ooooo00?o0000ooooooooool05_ooool5o`0000;ooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01?ooooo0_l00004oooo
o`04o`000?ooooooooooo`0001Sooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00005oooool0
0ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`000?oooooooooo017ooooo0_l00004oooo
o`?o000000?oooooo`000?ooool05?ooool00ol0003oooooooooo`3oooooodcooooo002Uooooo`03
o`000?oooooooooo017ooooo1_l00003ooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool0oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0>ooooo`Co00000oooool01Ol0003ooooo
oooooooooooo000001?ooooo00?o0000ooooooooool0oooooom>ooooo`00Yoooool00ol0003ooooo
ooooo`0;ooooo`;o00000_ooool00ol0003oooooo`000002ooooo`05o`000?ooooooooooooooool0
00004_ooool00ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool00_ooool01Ol0003oooooooooool0003ooooo00;o00000_ooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool0
1_ooool2o`0000Gooooo0_l000000ooooooo0000ooooo`02o`0000;ooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03o`000?oooooooooo00?ooooo0_l0
0002ooooo`03o`000?oooooooooo00?ooooo1Ol00003ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool0oooooomBooooo`00Zoooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000002o`0000Cooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`04o`000?oooooooooo
o`0000Gooooo00?o0000ooooooooool00_ooool2o`0000;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00?o0000oooo
ool000001Oooool5o`000004ooooool0003oooooooooo`Ko00002oooool00ol0003oooooooooo`3o
oooooeGooooo002^ooooo`03o`000?oooooo000000Cooooo0ol00003ooooo`Co00003oooool00ol0
003oooooooooo`3ooooooeKooooo002_ooooo`?o00000_ooool2o`000003ooooool0003ooooo00Go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo002`ooooo`Co0000
1?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
oooooomHooooo`00/Oooool2o`0000Kooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo0?ooooooFOooool00;;ooooo00?o0000ooooooooool01Oooool0
1Ol0003ooooooooooooooooo000000_ooooo00?o0000ooooooooool0oooooomJooooo`00/oooool0
0ol0003oooooooooo`04ooooo`05o`000?ooooooooooooooool000002_ooool00ol0003ooooooooo
o`3ooooooe_ooooo002dooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002Ooo
ool00ol0003oooooooooo`3ooooooecooooo002eooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooool000000_l00006ooooo`03o`000?oooooooooo0?ooooooGOooool00;Gooooo0_l00005oooo
o`03o`000?oooooo000000Oooooo00?o0000ooooooooool0oooooomNooooo`00]_ooool2o`0000Go
oooo0_l00006ooooo`03o`000?oooooooooo03kooooo1?l0003ooooooagooooo002gooooo`;o0000
1Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo03oooooo00Go0000oooooooooooo
ooooo`00003ooooooacooooo002gooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`0oooooo`06o`000?oooooo0000o`000?oooooo0000oooooolLoooo
o`00^?ooool00ol0003oooooo`000003ooooo`;o00000_ooool00ol0003oooooooooo`10ooooo`;o
00000oooool00ol0003oooooooooo`3ooooooa[ooooo002]ooooo`?o00001?ooool2o`0000?ooooo
00?o0000ooooool000000_ooool01?l0003oooooo`000?l00013ooooo`Go0000oooooolMooooo`00
[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00So0000oooooooo
oooo0000ooooool0003oooooo`0004?ooooo00?o0000ooooooooool0oooooolPooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00ol0
00000ooooooo0000ooooo`0oooooo`;o0000oooooolSooooo`00[_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol0000nooooo`03o`000?oo
oooooooo0?oooooo8oooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0004ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0>_ooool00ol0003ooooo
ooooo`3oooooobCooooo002]ooooo`;o00001?ooool01?l0003oooooooooool00005ooooo`03o`00
0?oooooo000000Cooooo00?o0000ooooooooool0>?ooool2o`000?oooooo9oooool00:kooooo00?o
0000ooooooooool00oooool2o`0000Oooooo0_l00005ooooo`03o`000?oooooooooo03Kooooo00?o
0000ooooooooool0oooooolWooooo`00__ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo03Cooooo00?o0000ooooooooool0oooooolXooooo`00__ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0oooooolYooooo`00__ooool2o`0000Ko
oooo00?o0000ooooooooool0<?ooool2o`000?oooooo;?ooool00;kooooo00?o0000ooooool00000
1_ooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo0?oooooo;?ooool00;kooooo0ol0
0006ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0ooooool]ooooo`00__ooool0
1?l0003oooooooooool00006ooooo`03o`000?oooooooooo02[ooooo0_l0003ooooooc3ooooo002n
ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`0Xooooo`03o`000?oo
oooooooo0?oooooo<?ooool00;kooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oo
oooooooo02Oooooo00?o0000ooooooooool0oooooolaooooo`00__ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3o
oooooc;ooooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`0Rooooo`;o0000ooooooleooooo`00__ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`3oooooocGo
oooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo0?oooooo=_ooool00;kooooo0ol00005ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool07?ooool2o`000?oooooo>Oooool00;kooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01[ooooo00?o0000
ooooooooool0ooooooliooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3ooooooc[ooooo002nooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo0?oooooo>oooool00;kooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo01Cooooo0_l0003oooooockooooo002nooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooooooo0?oooooo?_ooool00;kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0ooooooloooooo`00__ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03_ooool2o`00
0?oooooo@_ooool00;kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool0oooooom2ooooo`00__ooool3o`0000_ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?oooooo
@oooool00;kooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool0oooooom4ooooo`00__ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool2o`000?ooooooAoooool0
0;kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooom7ooooo`00__ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3oooooodSo
oooo002nooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`02o`000?ooooooBoooool00;kooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`03ooooo`Co0000oooooom=ooooo`00__ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo00;o00000_ooool2o`000?ooooooCOooool00;kooooo0ol0000Aooooo`03o`000?oooooo0000
00;ooooo00?o0000ooooool00000oooooom=ooooo`00__ooool00ol0003oooooooooo`0Aooooo`;o
00000_ooool01Ol0003ooooooooooooooooo00000?ooooooC?ooool00;kooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?ooooooB_ooool00;kooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?oooooo
Boooool00;kooooo00?o0000ooooooooool04oooool2o`0000;ooooo0_l0003oooooodgooooo002n
ooooo`03o`000?oooooooooo01Gooooo0_l0003oooooodoooooo002/ooooo`Go00000oooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5
o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0VOooool2o`000<[ooooo002nooooo`03
o`000?oooooooooo09Sooooo00Co0000oooooooooooo0000bOooool00;kooooo00?o0000oooooooo
ool0Uoooool01?l0003oooooooooooooool2o`000<Sooooo002nooooo`?o0000Uoooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo0<Kooooo002nooooo`03o`000?oooooooooo09Sooooo
1?l00039ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
0oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo
00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool00000
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003ooooooooo
o`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo0000
1oooool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00ooo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3759 .15076 .00609 0 365.73 arc
s
newpath
.31205 .04703 .00609 0 365.73 arc
s
newpath
.33225 .05158 .00609 0 365.73 arc
s
.37071 .15395 m
.30687 .05022 L
s
.38108 .14757 m
.31724 .04384 L
s
.31071 .05297 m
.33091 .05753 L
s
.31339 .04109 m
.33359 .04564 L
s
.3414 .06059 m
.34855 .04601 L
s
.32668 .03529 m
.31953 .04987 L
s
.3759 .15076 m
.4662 .06903 L
s
.3414 .06059 m
.31953 .04987 L
s
.34855 .04601 m
.32668 .03529 L
s
.3414 .06059 m
.33225 .05158 L
s
.31953 .04987 m
.33225 .05158 L
s
newpath
.4662 .06903 .00457 0 365.73 arc
s
newpath
.64786 .2133 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool04_ooool2o`000003ooooool0003ooooo01Kooooo00?o0000
ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0Aooooo`04o`000?oooooo0000
o`0001Kooooo00?o0000ooooooooool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0?oooo
o`04o`000?ooooooooooooooo`Co00004_ooool00ol0003oooooooooo`3ooooooe3ooooo002Yoooo
o`03o`000?oooooooooo00Oooooo1Ol00002ooooo`05o`000?ooooooooooooooool000000oooool2
o`0000oooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003oooooooooo`04oooo
o`;o00000oooool00ol0003oooooo`000004o`000003ooooool0003ooooo00Cooooo0_l0000<oooo
o`03o`000?oooooooooo0?ooooooD_ooool00:_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooo000000Cooooo0ol00006ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool0oooooomCooooo`00[?ooool01Ol0003ooooooooooooooooo000000Go
oooo0ol00003ooooo`05o`000?oooooo0000ooooool000001Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo0?ooooooE?ooool00:gooooo00Co0000oooooooooooo00001_ooool6o`00
0004ooooool0003o0000o`0000Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3o
oooooeGooooo002^ooooo`03o`000?oooooooooo00;o00000_ooool2o`000003ooooool0003o0000
00Go00000_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0oooooomF
ooooo`00[oooool01?l0003oooooo`000?ooool4o`0000;ooooo00Go0000ooooool0003o0000oooo
o`02o`000003ooooool0003ooooo00;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`3ooooooeOooooo002`ooooo`03o`000?oooooo000000Cooooo2?l000000ooooooo0000ooooo`02
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomHooooo`00/Oooool00ol0
003oooooo`000006ooooo`03o`000?oooooo000000Go00000_ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo0?ooooooFOooool00;;ooooo0_l00007ooooo`04o`000?ooooooooooo`00
00;ooooo0_l000000ooooooo0000ooooo`04ooooo`03o`000?oooooooooo0?ooooooF_ooool00;?o
oooo0_l00006ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`3ooooooe_ooooo002dooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool0
00002Oooool00ol0003oooooooooo`3ooooooecooooo002eooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooool000000_l00006ooooo`03o`000?oooooooooo03Wooooo0_l0003oooooob;ooooo
002fooooo`03o`000?oooooooooo00Cooooo0_l00007ooooo`03o`000?oooooooooo03Wooooo00Co
0000oooooooooooo0000oooooolQooooo`00]_ooool2o`0000Kooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0iooooo`?o000000?oooooo`000?l00000oooooolPooooo`00]oooool2
o`0000Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0jooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0oooooolNooooo`00^?ooool2o`0000Cooooo0_l00003oooo
o`03o`000?oooooooooo03[ooooo0ol000000ooooooo0000o`00003oooooob7ooooo002hooooo`03
o`000?oooooo000000?ooooo0_l00002ooooo`03o`000?oooooooooo03[ooooo00Go0000oooooooo
ooooooooo`00003oooooob?ooooo002]ooooo`?o00001?ooool2o`0000?ooooo00?o0000ooooool0
00000_ooool01?l0003oooooo`000?l0000looooo`03o`000?oooooooooo0?oooooo9_ooool00:ko
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`07o`000?oooooooooo
o`000?oooooo0000ooooo`02o`0003_ooooo00?o0000ooooooooool0oooooolWooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00ol0
00000ooooooo0000ooooo`0iooooo`03o`000?oooooooooo0?oooooo:?ooool00:kooooo00?o0000
ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Go0000>?oo
ool00ol0003oooooooooo`3oooooobWooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00001?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo03Cooooo
00?o0000ooooooooool0oooooolZooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo0000
1Oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo03?ooooo00?o0000ooooooooool0
ooooool[ooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001oooool2o`0000Gooooo00?o
0000ooooooooool0<Oooool00ol0003oooooooooo`3oooooobcooooo002mooooo`;o00001Oooool0
0ol0003oooooooooo`0_ooooo`;o0000ooooool_ooooo`00__ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0ooooool_ooooo`00__ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0ooooool`ooooo`00
__ooool2o`0000Kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`3ooooooc7ooooo
002nooooo`?o00001_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo0?oooooo<_oo
ool00;kooooo00?o0000ooooool000001_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooo
oooo0?oooooo<oooool00;kooooo00Co0000oooooooooooo00001_ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo=?ooool00;kooooo00Go0000ooooooooooooooooo`000006
ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0ooooooleooooo`00__ooool01Ol0
003ooooooooooooooooo000000Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3o
ooooocKooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo0?oooooo=oooool00;kooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01kooooo0_l0003ooooooc[o
oooo002nooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo0?oooooo>_ooool00;kooooo0ol00004ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool06_ooool00ol0003oooooooooo`3ooooooc_ooooo002n
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0I
ooooo`03o`000?oooooooooo0?oooooo??ooool00;kooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0oooooolmoooo
o`00__ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`3oooooockooooo002nooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?oooooo
?oooool00;kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool0oooooom0ooooo`00__ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`3o
oooood7ooooo002nooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`0?ooooo`03o`000?oooooooooo0?oooooo@_ooool00;kooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool0oooooom3ooooo`00__ooool3o`0000Wooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0;ooooo`;o0000oooooom6ooooo`00__ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3oooooodKooooo002n
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo0?ooooooAoooool00;kooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooooom8oooo
o`00__ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`3oooooodWooooo002nooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oooooo
B_ooool00;kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`05o`000?oo
ooooooooooooool00000oooooom=ooooo`00__ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00?ooooo00Co0000oooooooooooo0000oooooom>ooooo`00__ooool3o`0000kooooo00?o
0000ooooooooool01_l0003oooooodoooooo002nooooo`03o`000?oooooooooo00oooooo00?o0000
ooooool000000oooool2o`000?ooooooCoooool00;kooooo00?o0000ooooooooool03oooool2o`00
00?ooooo00?o0000ooooool00000oooooom?ooooo`00__ooool00ol0003oooooooooo`0@ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0oooooom<ooooo`00__ooool00ol0003o
ooooooooo`0@ooooo`;o00001Oooool00ol0003oooooooooo`3oooooodcooooo002nooooo`03o`00
0?oooooooooo017ooooo0_l00002ooooo`;o0000oooooom?ooooo`00[?ooool5o`0000?ooooo0_l0
0008ooooo`03o`000?oooooooooo01?ooooo0_l0003ooooooe7ooooo002]ooooo`04o`000?oooooo
ooooo`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003ooooo
ooooo`05ooooo`Go0000oooooomTooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0Woooool3o`000<?ooooo
002nooooo`?o0000Woooool01?l0003oooooooooool00032ooooo`00__ooool00ol0003ooooooooo
o`2Nooooo`05o`000?ooooooooooooooool00000`_ooool00;kooooo00?o0000ooooooooool0Wooo
ool01?l0003oooooooooool00032ooooo`00__ooool00ol0003oooooooooo`2Pooooo`?o0000`_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool0
1?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo00Co0000
oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool000000oooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool0
0ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003oooooooooo`04oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`00
00?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool5
o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00oooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35211 .16061 .00609 0 365.73 arc
s
newpath
.32394 .04211 .00609 0 365.73 arc
s
newpath
.3344 .05998 .00609 0 365.73 arc
s
.34619 .16202 m
.31802 .04352 L
s
.35804 .1592 m
.32987 .0407 L
s
.31869 .04518 m
.32914 .06306 L
s
.3292 .03903 m
.33965 .05691 L
s
.34695 .05728 m
.33869 .0433 L
s
.31771 .05569 m
.32598 .06967 L
s
.35211 .16061 m
.44233 .07878 L
s
.34695 .05728 m
.32598 .06967 L
s
.33869 .0433 m
.31771 .05569 L
s
.34695 .05728 m
.3344 .05998 L
s
.32598 .06967 m
.3344 .05998 L
s
newpath
.44233 .07878 .00457 0 365.73 arc
s
newpath
.66031 .20084 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool04?ooool3o`0000;ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`3oooooodkooooo002Wooooo`03o`000?oooooooooo00gooooo0_l00003oooo
o`03o`000?oooooo000001Kooooo00?o0000ooooooooool0oooooom?ooooo`00Z?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000005Oooool00ol0003o
ooooooooo`3ooooooe3ooooo002Yooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
0oooool3o`0001Cooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Cooooo0_l000000ooooooo0000o`00000@ooooo`03o`000?oo
oooooooo0?ooooooD_ooool00:_ooooo00?o0000ooooooooool02?ooool2o`0000Cooooo1?l00000
0ooooooo0000ooooo`0>ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o0000oooo
ooooool01oooool3o`0000;ooooo1?l00003ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool0oooooomDooooo`00[Oooool00ol0003oooooooooo`07ooooo`Go00000_ooool3o`000003
ooooool0003ooooo00_ooooo00?o0000ooooooooool0oooooomEooooo`00[_ooool00ol0003ooooo
ooooo`06ooooo`Co00000oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool0oooooomFooooo`00[oooool00ol0003oooooooooo`05ooooo`?o00001?oo
ool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooo
oomGooooo`00/?ooool00ol0003oooooooooo`03ooooo`;o00000_ooool00ol0003oooooooooo`05
o`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooeSooooo002aoooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooool0003oooooo`000002ooooo`?o000000Cooooo
o`000?l0003ooooo0_l00005ooooo`03o`000?oooooooooo0?ooooooFOooool00;;ooooo00?o0000
ooooooooool00_ooool2o`0000;ooooo0_l000001?oooooo0000o`000?ooool3o`0000Kooooo00?o
0000ooooooooool0oooooomJooooo`00/oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;o000000?oooooo`000?l000000ol00006ooooo`03o`000?oooooooooo0?ooooooFoooool0
0;Cooooo00Go0000ooooooooooooooooo`000003ooooo`Go000000?oooooo`000?ooool01?ooool0
0ol0003oooooooooo`3ooooooecooooo002eooooo`05o`000?ooooooooooooooool000000oooool5
o`0000Gooooo00?o0000ooooooooool0oooooomMooooo`00]_ooool01?l0003oooooooooool00003
ooooo`Co00001Oooool00ol0003oooooooooo`3ooooooekooooo002gooooo`0:o`000?oooooo0000
o`000?oooooo0000ooooool0003oooooo`0000Cooooo00?o0000ooooooooool0oooooomOooooo`00
^?ooool2o`000007ooooool0003oooooooooool0003oooooo`000003ooooo`03o`000?oooooooooo
0?ooooooH?ooool00;Wooooo0_l00003ooooo`06o`000?ooooooooooo`000?oooooo0000oooooomS
ooooo`00^_ooool01Ol0003ooooooooooooooooo000000;ooooo0_l0000cooooo`?o0000ooooool^
ooooo`00[Oooool3o`0000Cooooo0_l00004ooooo`;o00000_ooool01?l0003oooooooooool0000c
ooooo`05o`000?ooooooooooooooool00000ooooool]ooooo`00[_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000?ooooo00Ko0000ooooool0003oooooo`000?ooool2o`0003;o
oooo00Ko0000ooooool0003o0000ooooool0003oooooobgooooo002^ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooo`000002o`000003ooooool0003o
oooo037ooooo0_l00003ooooo`03o`000?oooooooooo0?oooooo:oooool00:kooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Go0000<Oooool3
o`000003ooooool0003ooooo0?oooooo;Oooool00:kooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0;_oo
ool01Ol0003ooooooooooooooooo00000?oooooo;oooool00:gooooo0_l00004ooooo`04o`000?oo
ooooooooo`0000Cooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo0?oooooo<_ooool00:kooooo00?o0000ooooooooool00oooool2o`0000Kooooo
00?o0000ooooool000000oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooooooo0?oooooo
<oooool00;cooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo0?oooooo=?ooool00;cooooo00?o0000ooooool000001?ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo0?oooooo=Oooool00;cooooo00?o0000ooooool000001?ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo0?oooooo=_ooool00;gooooo0_l00004ooooo`03
o`000?oooooooooo02Oooooo00?o0000ooooooooool0oooooolgooooo`00_Oooool4o`0000?ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooocSooooo002mooooo`;o00001Ooo
ool00ol0003oooooooooo`0Sooooo`;o0000oooooolkooooo`00_Oooool2o`0000Gooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`3ooooooc_ooooo002nooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3ooooooccooooo002nooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`3oooooocgo
oooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`3oooooockooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`3oooooocoooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`3ooooood3ooooo002nooooo`?o00001?ooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo0?oooooo@Oooool00;kooooo0_l00006ooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool0oooooom2ooooo`00__ooool2o`0000Kooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood?ooooo002nooooo`;o00001_oo
ool00ol0003oooooooooo`0Fooooo`;o0000oooooom6ooooo`00__ooool00ol0003oooooo`000005
ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooooom6ooooo`00__ooool00ol0
003oooooo`000006ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool0oooooom7oooo
o`00__ooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool0oooooom8ooooo`00__ooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0oooooom9ooooo`00__ooool01?l0003oooooooooool00005ooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool0oooooom:ooooo`00__ooool4o`0000Gooooo00?o
0000ooooooooool03oooool00ol0003oooooooooo`3ooooood_ooooo002nooooo`04o`000?oooooo
ooooo`0000Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3oooooodcooooo002n
ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`3oooooodgooooo002nooooo`05o`000?ooooooooooooooool000001Oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo0?ooooooC_ooool00;kooooo00Go0000ooooooooooooooooo`00
0005ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooom?ooooo`00__ooool0
1Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool01oooool2o`000?ooooooD_oo
ool00;kooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooooe?ooooo002noooo
o`?o00000_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool0oooooomDooooo`00__ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooeGooooo002nooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooooooo00000?oo
ooooF?ooool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`04o`00
0?ooooooooooo`000?ooooooFOooool00;kooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooo00000?ooooooF_ooool00;kooooo00?o0000ooooooooool00ooo
ool00ol0003oooooo`000005o`000?ooooooFoooool00:cooooo1Ol00003ooooo`;o00002?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooo000000?ooooo0_l0003ooooooe_ooooo002]oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`04ooooo`07o`000?ooooooooooooooool0003oooooo`00003ooooooe_ooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0oooooomIooooo`00[oooool01Ol0003o
oooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`0000;ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`3ooooooeWooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Gooooo0_l00000
0ooooooo0000o`00003ooooooecooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooo
oomLooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000Y_oo
ool2o`000;gooooo002nooooo`03o`000?oooooooooo0:Gooooo00Co0000oooooooooooo0000_?oo
ool00;kooooo00?o0000ooooooooool0YOooool01?l0003oooooooooool0002looooo`00__ooool0
0ol0003oooooooooo`2Uooooo`05o`000?ooooooooooooooool00000^oooool00;kooooo00?o0000
ooooooooool0YOooool2o`000003ooooool0003ooooo0;_ooooo002nooooo`03o`000?oooooooooo
0:Oooooo00?o0000ooooooooool0^oooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o0000
2?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCo
oooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo
00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co
0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00
[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?oo
ool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o
0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000ooo
ool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003ooooooooo
o`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31522 .16076 .00609 0 365.73 arc
s
newpath
.34239 .04203 .00609 0 365.73 arc
s
newpath
.33274 .06035 .00609 0 365.73 arc
s
.30929 .15941 m
.33645 .04067 L
s
.32116 .16212 m
.34833 .04339 L
s
.337 .03919 m
.32735 .05751 L
s
.34778 .04487 m
.33813 .06319 L
s
.33849 .04887 m
.32242 .04656 L
s
.31895 .07068 m
.33503 .07298 L
s
.31522 .16076 m
.41496 .09084 L
s
.33849 .04887 m
.33503 .07298 L
s
.32242 .04656 m
.31895 .07068 L
s
.33849 .04887 m
.33274 .06035 L
s
.33503 .07298 m
.33274 .06035 L
s
newpath
.41496 .09084 .00457 0 365.73 arc
s
newpath
.67322 .18721 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool01?l0003oooooooooooooool3o`00017ooooo00?o
0000ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0Dooooo`04o`000?oooooo
ooooo`0000?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3oooooodoooooo002X
ooooo`03o`000?oooooooooo01?ooooo00Co0000ooooool0003o00000oooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool04_ooool0
0ol0003oooooo`000005ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooomA
ooooo`00Z_ooool00ol0003oooooooooo`0Aooooo`?o00001Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo0?ooooooD_ooool00:_ooooo00?o0000ooooooooool04?ooool4o`0000?o
oooo0_l0000:ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o0000ooooooooool0
2_ooool7o`000004ooooool0003o0000ooooo`?o00002Oooool00ol0003oooooooooo`3ooooooeCo
oooo002]ooooo`03o`000?oooooooooo00Wooooo00Co0000oooooooooooooooo1Ol000001?oooooo
0000ooooool00009ooooo`03o`000?oooooooooo0?ooooooEOooool00:kooooo00?o0000oooooooo
ool02?ooool01?l0003oooooooooooooool3o`000003ooooool0003ooooo00;ooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`3ooooooeKooooo002_ooooo`03o`000?oooooooooo00Oo
oooo00Go0000oooooooooooo0000ooooo`04o`0000;ooooo0_l00007ooooo`03o`000?oooooooooo
0?ooooooEoooool00;3ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooooooool6o`00
0004ooooool0003oooooo`0000Kooooo00?o0000ooooooooool0oooooomHooooo`00/Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00;o000000Coooooo`000?l0003o00000_ooool0
0ol0003oooooo`000005ooooo`03o`000?oooooooooo0?ooooooFOooool00;;ooooo00?o0000oooo
ooooool00oooool01?l0003oooooooooool00002ooooo`?o000000Coooooo`000?oooooo00001Ooo
ool00ol0003oooooooooo`3ooooooe[ooooo002cooooo`03o`000?oooooooooo00;ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooo`000002o`000003ooooool0003ooooo00?ooooo00?o
0000ooooooooool0oooooomKooooo`00]?ooool01Ol0003ooooooooooooooooo000000;ooooo00Go
0000oooooooooooo0000ooooo`02o`0000;ooooo00Go0000ooooooooooooooooo`00003ooooooeko
oooo002eooooo`04o`000?ooooooooooo`0000?ooooo1Ol00003ooooo`04o`000?ooooooooooo`00
0?ooooooGoooool00;Kooooo0_l00005ooooo`;o000000Goooooo`000?ooooooooooo`000002oooo
o`03o`000?oooooooooo0?ooooooG_ooool00;Oooooo00?o0000ooooooooool00oooool3o`0000?o
oooo00?o0000ooooool00000oooooomQooooo`00]oooool5o`000004ooooool0003o0000o`0000?o
oooo0_l0003oooooof;ooooo002iooooo`03o`000?oooooooooo00Co00000oooool00ol0003ooooo
ooooo`3oooooof7ooooo002jooooo`05o`000?oooooo0000ooooool000000oooool00ol0003ooooo
ooooo`3oooooof;ooooo002]ooooo`?o00001?ooool2o`0000Gooooo0_l000001?oooooo0000oooo
ooooool2o`000?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00005ooooo`07o`000?oooooo0000ooooool0003oooooo`00003oooooofCooooo002^ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool4o`0000;ooooo00?o0000oooo
ooooool0oooooomRooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00Cooooo00?o0000ooooooooool01Ol0003oooooofCooooo002^ooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00001?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo0?ooooooHoooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`0Tooooo`;o0000oooooolmooooo`00[_ooool0
0ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo02?ooooo00Co0000oooooooooooo0000oooooollooooo`00^_ooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooooooool08oooool01?l0003oooooooooool0003oooooocco
oooo002jooooo`07o`000?ooooooooooooooool0003oooooo`00000Uooooo`06o`000?oooooo0000
o`000?oooooo0000oooooolkooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool00000
9_ooool2o`000003ooooool0003ooooo0?oooooo>oooool00;[ooooo00Oo0000oooooooooooooooo
o`000?oooooo000002Cooooo0_l00002ooooo`03o`000?oooooooooo0?oooooo>oooool00;Wooooo
00?o0000ooooooooool00_ooool3o`0002?ooooo00?o0000ooooooooool0oooooom0ooooo`00^Ooo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooo0000027ooooo0_l0003ooooood?ooooo002i
ooooo`03o`000?oooooooooo00;ooooo0_l0000Qooooo`03o`000?oooooooooo0?oooooo@oooool0
0;Wooooo00?o0000ooooooooool00_ooool2o`00023ooooo00?o0000ooooooooool0oooooom4oooo
o`00^Oooool00ol0003oooooooooo`02ooooo`;o00007_ooool2o`000?ooooooAoooool00;Sooooo
00?o0000ooooooooool00oooool2o`0001gooooo00?o0000ooooooooool0oooooom7ooooo`00^?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01[ooooo0_l0003ooooood[ooooo002h
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`3o
oooood[ooooo002hooooo`03o`000?oooooooooo00?ooooo0ol0000Gooooo`;o0000oooooom=oooo
o`00]oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool0oooooom=ooooo`00]oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01Cooooo
0_l0003ooooooe3ooooo002gooooo`03o`000?oooooooooo00?ooooo0_l0000Eooooo`03o`000?oo
oooooooo0?ooooooD?ooool00;Oooooo00?o0000ooooooooool00oooool2o`0001Cooooo00?o0000
ooooooooool0oooooomAooooo`00]_ooool00ol0003oooooooooo`04ooooo`;o00004_ooool2o`00
0?ooooooE?ooool00;Kooooo00?o0000ooooooooool01?ooool2o`00017ooooo00?o0000oooooooo
ool0oooooomDooooo`00]_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo000000oooooo
0_l0003ooooooeOooooo002fooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool000003_oo
ool00ol0003oooooooooo`3ooooooeOooooo002fooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooool000000_l0000:ooooo`;o0000oooooomJooooo`00]Oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooo000000_ooooo00?o0000ooooooooool0oooooomJooooo`00]Oooool00ol0003o
ooooooooo`03ooooo`04o`000?ooooooooooo`0000Wooooo0_l0003ooooooegooooo002eooooo`03
o`000?oooooooooo00?ooooo00Co0000oooooooooooo00002?ooool00ol0003oooooooooo`3ooooo
oegooooo002eooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3ooooooekooooo002dooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooo
oooo00001Oooool2o`000?ooooooHOooool00;Cooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooool00004ooooo`03o`000?oooooooooo0?ooooooHOooool00;Cooooo00?o0000oooooooo
ool00oooool01Ol0003ooooooooooooooooo000000;ooooo0_l0003oooooofCooooo002dooooo`03
o`000?oooooooooo00?ooooo00Co0000oooooooooooooooo0ol0003oooooofKooooo002cooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooooooo0_l0003oooooofOooooo002cooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0003oooooofSooooo002cooooo`03o`00
0?oooooooooo00?ooooo00Ko0000ooooool0003o0000ooooool0003oooooofSooooo002cooooo`03
o`000?oooooooooo00?ooooo0_l00003ooooo`03o`000?oooooooooo0?ooooooI_ooool00;?ooooo
1?l00002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`000003ooooool0003o000000;o000000Coooooo`000?l0003o00001?ooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`05o`000?ooooooooooo`000?ooool00_l00002ooooo`;o0000
00?oooooo`000?ooool00oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`04o`000?oo
ooooooooooooo`;o000000Goooooo`000?l0003oooooo`000005ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:oooooo00?o0000ooooooooool00_l00002ooooo`03o`000?oooooo000000Gooooo
1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool2o`000003oooo
ool0003o000000Kooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000ooooool0003o00001oooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0:gooooo0_l0002fooooo`00__ooool00ol0003oooooooooo`2/oooo
o`04o`000?ooooooooooo`000;Gooooo002nooooo`03o`000?oooooooooo0:_ooooo00Go0000oooo
ooooooooooooo`00002eooooo`00__ooool00ol0003oooooooooo`2[ooooo`05o`000?oooooooooo
ooooool00000]Oooool00;kooooo00?o0000ooooooooool0[?ooool01?l0003oooooo`000?l0002e
ooooo`00__ooool00ol0003oooooooooo`2]ooooo`03o`000?oooooooooo0;Gooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooo
oomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?oo
ool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool0
0ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool000000_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0
003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]
ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/oooo
o`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003oooo
o`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29558 .1535 .00609 0 365.73 arc
s
newpath
.35221 .04566 .00609 0 365.73 arc
s
newpath
.33234 .0515 .00609 0 365.73 arc
s
.29019 .15067 m
.34682 .04283 L
s
.30097 .15633 m
.3576 .04849 L
s
.35049 .03982 m
.33063 .04565 L
s
.35393 .0515 m
.33406 .05734 L
s
.33357 .03872 m
.31774 .04236 L
s
.3232 .0661 m
.33903 .06246 L
s
.29558 .1535 m
.40099 .09246 L
s
.33357 .03872 m
.33903 .06246 L
s
.31774 .04236 m
.3232 .0661 L
s
.33357 .03872 m
.33234 .0515 L
s
.33903 .06246 m
.33234 .0515 L
s
newpath
.40099 .09246 .00457 0 365.73 arc
s
newpath
.68689 .172 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooo
oooo0?ooooooC_ooool00:Oooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool04Oooool3o`0000Ko
oooo1_l00009ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool0
3?ooool4o`0000;ooooo00Co0000oooooooooooooooo0ol000000ooooooo0000ooooo`03ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomAooooo`00Z_ooool00ol0003ooooo
ooooo`09ooooo`;o00001_ooool4o`0000?ooooo0_l00004ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0oooooomBooooo`00Zoooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Cooooo0ol00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool00oooool00ol0003oooooo`000002o`0000?ooooo0_l00005ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0oooooomDooooo`00[Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooool000000_l00003ooooo`05o`000?oooooo0000
o`000?ooool00ol00003ooooo`03o`000?oooooooooo0?ooooooEOooool00:kooooo00?o0000oooo
ooooool01_ooool01Ol0003ooooooooooooooooo000000;ooooo0_l000001?oooooo0000ooooool0
0003ooooo`?o000000Goooooo`000?ooooooooooo`00003ooooooeSooooo002_ooooo`03o`000?oo
oooooooo00Gooooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?oooooo0000o`000?oo
ool01?l00003ooooo`04o`000?ooooooooooo`000?ooooooFOooool00;3ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`02ooooo`So00001_ooool00ol0003oooooo`00003ooooooe[o
oooo002aooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool3o`000003oooo
ool0003ooooo00Gooooo00?o0000ooooool00000oooooomKooooo`00/_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00Co0000ooooool0003o00001oooool2o`000?oooooo
G?ooool00;?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`04o`000?oo
oooo0000o`0000Kooooo0_l0003ooooooegooooo002dooooo`05o`000?ooooooooooooooool00000
1Oooool4o`0000Kooooo00?o0000ooooooooool0oooooomLooooo`00]Oooool01_l0003ooooooooo
oooooooo0000ooooo`Ko00001_ooool00ol0003oooooooooo`3ooooooegooooo002fooooo`03o`00
0?oooooooooo00;o00000oooool2o`0000Kooooo0_l0003ooooooeoooooo002gooooo`03o`000?oo
oooooooo00Cooooo0_l00005ooooo`;o0000oooooomPooooo`00^?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000oooooomPooooo`00^Oooool01?l0
003oooooooooooooool2o`0000Cooooo00?o0000ooooool00000oooooomQooooo`00^_ooool00ol0
003oooooooooo`02o`0000?ooooo00Co0000oooooooooooo0000oooooomQooooo`00[Oooool3o`00
00Cooooo0_l00005ooooo`;o000000Goooooo`000?ooooooooooo`000002ooooo`03o`000?oooooo
oooo0?ooooooH?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00005
ooooo`05o`000?oooooo0000ooooool000000_ooool00ol0003oooooooooo`3oooooof7ooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooo`00
0002o`0000?ooooo00?o0000ooooooooool0oooooomQooooo`00[_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool01Ol0003oooooofCooooo002^
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool0oooooomRooooo`00[Oooool2o`0000Cooooo00Co
0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooooooo
ool0oooooomSooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00000oooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0001oooooo0_l0003oooooodCooooo002iooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooool000007oooool01?l0003oooooooooool0003ooooood?o
oooo002hooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool000007_ooool3o`000003oooo
ool0003o00000?oooooo@_ooool00;Sooooo00?o0000ooooooooool00oooool2o`0001kooooo0_l0
0004ooooo`03o`000?oooooooooo0?oooooo@?ooool00;Oooooo00?o0000ooooooooool01?ooool2
o`0001gooooo00Go0000oooooooooooo0000ooooo`02o`000?oooooo@oooool00;Oooooo00?o0000
ooooooooool01?ooool3o`0001[ooooo0_l00004ooooo`03o`000?oooooooooo0?oooooo@oooool0
0;Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Hooooo`;o0000oooooom<oooo
o`00]_ooool00ol0003oooooooooo`04ooooo`;o00006Oooool00ol0003oooooooooo`3oooooodco
oooo002eooooo`03o`000?oooooooooo00Gooooo0_l0000Gooooo`;o0000oooooom?ooooo`00]Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooo000001Gooooo0_l0003ooooooe7ooooo002d
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000005?ooool00ol0003oooooooooo`3o
oooooe7ooooo002dooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00004_ooool2
o`000?ooooooE?ooool00;?ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0000@
ooooo`;o0000oooooomFooooo`00/oooool00ol0003oooooooooo`04ooooo`04o`000?oooooooooo
ooooo`?o00003Oooool00ol0003oooooooooo`3ooooooeKooooo002booooo`03o`000?oooooooooo
00Gooooo00Go0000ooooooooooooooooo`00000=ooooo`;o0000oooooomIooooo`00/_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool2o`00
0?ooooooFoooool00;7ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooomKooooo`00/Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01_ooool2o`000?oooooo
G_ooool00;3ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00Cooooo0_l0003oooooof3ooooo002`ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`02ooooo`;o0000oooooomRooooo`00[oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00Go0000ooooooooooooooooo`00003o
ooooofCooooo002^ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool01?l0
003oooooo`000?l0003oooooofGooooo002^ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool3o`000?ooooooI_ooool00:gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`05ooooo`;o0000oooooomXooooo`00[Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo0_l000000ooooooo0000ooooo`3oooooofOooooo002/ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool00_ooool2o`0000?ooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`3oooooofKooooo002[ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool00_l00006ooooo`03o`000?oooooooooo0?ooooooI_ooool00:_o
oooo00?o0000ooooooooool01?ooool01?l0003oooooo`000?l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:[ooooo00?o0000ooooooooool01Oooool2o`0000[ooooo00?o0000oooooooo
ool0oooooomVooooo`00Z_ooool00ol0003oooooooooo`04ooooo`;o00002oooool3o`000?oooooo
I_ooool00:Wooooo1?l00002ooooo`?o00003?ooool00ol0003oooooooooo`3oooooofKooooo002Y
ooooo`04o`000?ooooooooooooooo`;o000000?oooooo`000?ooool03?ooool00ol0003ooooooooo
o`3oooooofKooooo002Xooooo`;o00000_ooool2o`0000;ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`3oooooofKooooo002Xooooo`04o`000?ooooooooooo`0000;ooooo0_l0000>
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Sooooo00?o0000ooooooooool00oooool2o`00
00kooooo00?o0000ooooooooool0oooooomVooooo`00ZOooool2o`000003ooooool0003o000000?o
00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00Zoooool00ol0003ooooo
o`000002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool0
00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0
003oooooooooo`2cooooo`Co0000[_ooool00;kooooo00?o0000ooooooooool0/oooool01?l0003o
ooooooooool0002^ooooo`00__ooool00ol0003oooooooooo`2booooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool0Zoooool00;kooooo00?o0000ooooooooool0/oooool01?l0003ooooo
o`000?l0002^ooooo`00__ooool00ol0003oooooooooo`2dooooo`03o`000?oooooooooo0:kooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3
o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001ooo
ool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?oooooooooo
ooooool000000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomV
ooooo`00[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0
003oooooofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001ooo
ool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool0
0007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2
o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomV
ooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003o
ooooofCooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/oooo
o`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29211 .15157 .00609 0 365.73 arc
s
newpath
.35395 .04663 .00609 0 365.73 arc
s
newpath
.33391 .04139 .00609 0 365.73 arc
s
.28686 .14848 m
.3487 .04354 L
s
.29736 .15466 m
.35919 .04972 L
s
.35549 .04074 m
.33545 .0355 L
s
.3524 .05252 m
.33237 .04728 L
s
.33155 .02877 m
.31735 .03666 L
s
.32918 .05795 m
.34338 .05007 L
s
.29211 .15157 m
.39617 .08826 L
s
.33155 .02877 m
.34338 .05007 L
s
.31735 .03666 m
.32918 .05795 L
s
.33155 .02877 m
.33391 .04139 L
s
.34338 .05007 m
.33391 .04139 L
s
newpath
.39617 .08826 .00457 0 365.73 arc
s
newpath
.69976 .15695 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Oooooo0ol0000Koooo
o`03o`000?oooooooooo0?ooooooB_ooool00:?ooooo00?o0000ooooooooool05Oooool01?l0003o
ooooo`000?l0000Jooooo`03o`000?oooooooooo0?ooooooBoooool00:Cooooo00?o0000oooooooo
ool04_ooool2o`0000;ooooo1?l0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Kooooo
00?o0000ooooooooool0oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00Cooooo1?l0000Dooooo`03o`000?oooooooooo0?ooooooC_ooool00:Oooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`;o000000?oooooo`000?l000001?l0000?
ooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`04ooooo`Go00001?ooool3o`0000_ooooo00?o0000ooooooooool0oooooom@oooo
o`00ZOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooool0
003o0000ooooo`02o`0000Cooooo1?l00008ooooo`03o`000?oooooooooo0?ooooooDOooool00:[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooo0000oooo
o`?o00000oooool2o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooo
oe;ooooo002[ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooooooo0ol000001?oo
oooo0000o`000?l00003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00oooool3o`000004ooooool0003o0000ooooo`;o00001Oooool01Ol0003ooooooooooooo
oooo00000?ooooooE_ooool00:gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02
ooooo`Ko000000?oooooo`000?l000001Oooool01?l0003oooooooooool0003ooooooeOooooo002^
ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`000004ooooo`Ko000000Ko
ooooo`000?l0003o0000ooooool0003ooooooeSooooo002_ooooo`03o`000?oooooooooo00Sooooo
00Go0000ooooooooooooooooo`000002ooooo`?o00000oooool3o`000004ooooool0003oooooo`00
0?ooooooFOooool00;3ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03o`0000;o
oooo00?o0000ooooooooool01Oooool2o`000?ooooooF_ooool00;7ooooo00?o0000ooooooooool0
1oooool01?l0003oooooo`000?l00003ooooo`03o`000?oooooooooo00Gooooo0_l0003ooooooe_o
oooo002booooo`03o`000?oooooooooo00Oooooo00?o0000ooooool000000oooool00ol0003ooooo
ooooo`04ooooo`;o0000oooooomLooooo`00/oooool00ol0003oooooooooo`08ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomKooooo`00]?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooo000000Oooooo00?o0000ooooooooool0oooooomLooooo`00]Oooool0
0ol0003oooooooooo`06ooooo`?o00001_ooool2o`000?ooooooG_ooool00;Kooooo00?o0000oooo
ooooool01Oooool2o`0000Kooooo0_l0003ooooooeoooooo002gooooo`03o`000?oooooooooo00Co
oooo0_l00005ooooo`;o0000oooooomPooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooool00000oooooomPooooo`00^Oooool01?l0003ooooooooo
ooooool2o`0000Cooooo00?o0000ooooool00000oooooomQooooo`00^_ooool00ol0003ooooooooo
o`02o`0000?ooooo00Co0000oooooooooooo0000oooooomQooooo`00[Oooool3o`0000Cooooo0_l0
0005ooooo`;o000000Goooooo`000?ooooooooooo`000002ooooo`03o`000?oooooooooo0?oooooo
H?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00005ooooo`05o`00
0?oooooo0000ooooool000000oooool00ol0003oooooooooo`3oooooof3ooooo002^ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooo`000002o`0000?o
oooo00?o0000ooooooooool0oooooomQooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000?ooooo00Co0000oooooooooooooooo1Ol0003oooooofCooooo002^ooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo
000000?ooooo00?o0000ooooooooool06Oooool3o`000?ooooooA_ooool00:gooooo0_l00004oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
000Kooooo`05o`000?ooooooooooooooool00000oooooom5ooooo`00[_ooool00ol0003ooooooooo
o`03ooooo`;o00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001_ooooo
0ol000000ooooooo0000ooooo`3oooooodCooooo002hooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooool000007?ooool01Ol0003ooooooooooooooooo00000?ooooooAOooool00;Oooooo00?o
0000ooooooooool01?ooool2o`0001_ooooo1?l000000ooooooo0000o`00003oooooodGooooo002g
ooooo`03o`000?oooooooooo00Cooooo0_l0000Iooooo`;o00001?ooool00ol0003oooooooooo`3o
ooooodGooooo002fooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`3oooooodcooooo002fooooo`03o`000?oooooooooo00Gooooo0ol0000Eooooo`;o
0000oooooom?ooooo`00]Oooool00ol0003oooooooooo`05ooooo`;o00005Oooool2o`000?oooooo
DOooool00;Gooooo00?o0000ooooooooool01Oooool2o`0001Cooooo00?o0000ooooooooool0oooo
oomAooooo`00]?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000001;ooooo0_l0003o
oooooeCooooo002cooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00004?ooool2
o`000?ooooooE_ooool00;?ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool0000?
ooooo`03o`000?oooooooooo0?ooooooE_ooool00;;ooooo00?o0000ooooooooool01Oooool01Ol0
003ooooooooooooooooo000000gooooo0_l0003ooooooeWooooo002booooo`03o`000?oooooooooo
00Gooooo00Go0000ooooooooooooooooo`00000<ooooo`03o`000?oooooooooo0?ooooooFOooool0
0;7ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`02ooooo`?o00002?ooool2o`00
0?ooooooG?ooool00;3ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00Kooooo0_l0003ooooooekooooo002`ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
G_ooool00:oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00?ooooo0_l0003oooooof7ooooo002_ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool01?ooool01?l0003oooooooooooooool2o`000?ooooooHoooool00:kooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`000?ooooooIOoo
ool00:gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`?o0000oooooomV
ooooo`00[Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo0_l0003ooooo
ofSooooo002/ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooo`00003oooooofSooooo002/ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
0oooool2o`0000;ooooo0ol0003oooooofKooooo002[ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:[ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool2o`0000Gooooo00?o
0000ooooooooool0oooooomVooooo`00Z_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00;o00001oooool00ol0003oooooooooo`3oooooofKooooo002Yooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooool000002Oooool00ol0003oooooooooo`3oooooofKooooo002Yooooo`03
o`000?oooooooooo00Gooooo0ol0000:ooooo`03o`000?oooooooooo0?ooooooI_ooool00:Sooooo
00?o0000ooooooooool01Oooool2o`0000cooooo00?o0000ooooooooool0oooooomVooooo`00Yooo
ool00ol0003oooooooooo`05ooooo`;o00003Oooool00ol0003oooooooooo`3oooooofKooooo002W
ooooo`Co00000_ooool3o`0000kooooo0ol0003oooooofKooooo002Vooooo`;o00000oooool2o`00
00;ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3oooooofKooooo002Wooooo`03
o`000?oooooooooo00;o00000_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:Kooooo00Co0000oooooooooooo00000_ooool2o`00013ooooo00?o0000oooooooo
ool0oooooomVooooo`00Y_ooool00ol0003oooooooooo`03ooooo`;o00004?ooool00ol0003ooooo
ooooo`2jooooo`?o0000Z?ooool00:Oooooo0_l000001?oooooo0000o`000?l0000Aooooo`03o`00
0?oooooooooo0;[ooooo00Co0000oooooooooooo0000Yoooool00:Wooooo00?o0000ooooooooool0
1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`2iooooo`05o`000?ooooooooooooooool0
0000Yoooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0;[ooooo00Co0000ooooool0003o0000Yoooool00:kooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0;_ooooo00?o0000
ooooooooool0Yoooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooo
oooo00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?oooooo
ooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^
ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0
003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0
0007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooo
oooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`00
00Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomT
ooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008oooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29801 .15473 .00609 0 365.73 arc
s
newpath
.35099 .04505 .00609 0 365.73 arc
s
newpath
.33629 .03047 .00609 0 365.73 arc
s
.29253 .15208 m
.34551 .0424 L
s
.3035 .15737 m
.35648 .0477 L
s
.35528 .04072 m
.34057 .02615 L
s
.34671 .04937 m
.332 .0348 L
s
.33015 .0192 m
.31907 .03107 L
s
.33689 .04769 m
.34796 .03581 L
s
.29801 .15473 m
.39496 .08099 L
s
.33015 .0192 m
.34796 .03581 L
s
.31907 .03107 m
.33689 .04769 L
s
.33015 .0192 m
.33629 .03047 L
s
.34796 .03581 m
.33629 .03047 L
s
newpath
.39496 .08099 .00457 0 365.73 arc
s
newpath
.71287 .14089 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01co
oooo0_l0000Oooooo`03o`000?oooooooooo0?ooooooA_ooool009oooooo00?o0000ooooooooool0
6_ooool4o`0001gooooo00?o0000ooooooooool0oooooom7ooooo`00X?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00Co00006_ooool00ol0003oooooooooo`3oooooodSooooo002Q
ooooo`03o`000?oooooooooo01Kooooo00Co0000oooooooooooooooo0_l000000ooooooo0000o`00
000Hooooo`03o`000?oooooooooo0?ooooooBOooool00:;ooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`02ooooo`;o00000_ooool2o`0001Kooooo00?o0000ooooooooool0oooooom:
ooooo`00Xoooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00;ooooo0_l000001?oo
oooo0000o`000?ooool2o`0001Cooooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0
003oooooooooo`0@ooooo`;o00001?ooool4o`000003ooooool0003o000000;o00004_ooool00ol0
003oooooooooo`3oooooodcooooo002Uooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool00_ooool01_l0003ooooooooooooooooo0000ooooo`?o00004?ooool00ol0003oooooooooo`3o
ooooodgooooo002Vooooo`03o`000?oooooooooo017ooooo00Co0000oooooooooooooooo0_l00000
0ooooooo0000o`000003ooooo`;o00003_ooool00ol0003oooooooooo`3oooooodkooooo002Woooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool00ol00004ooooo`04o`000?oooooooooo
o`0000cooooo00?o0000ooooooooool0oooooom?ooooo`00Z?ooool00ol0003oooooooooo`0Aoooo
o`05o`000?oooooo0000ooooool000000oooool00ol0003oooooooooo`03o`0000[ooooo00?o0000
ooooooooool0oooooom@ooooo`00ZOooool00ol0003oooooooooo`0Aooooo`;o00000_ooool01?l0
003oooooo`000?ooool2o`0000?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3o
oooooe7ooooo002Zooooo`03o`000?oooooooooo017ooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3o
oooooe;ooooo002[ooooo`03o`000?oooooooooo013ooooo0_l000000ooooooo0000ooooo`03o`00
00Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03
o`000?oooooooooo00oooooo00?o0000ooooool000000oooool00ol0003oooooooooo`03ooooo`;o
00001?ooool00ol0003oooooooooo`3ooooooeCooooo002]ooooo`03o`000?oooooooooo00kooooo
0ol00003ooooo`?o00000_ooool2o`0000Cooooo00?o0000ooooooooool0oooooomEooooo`00[_oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooooooo
0ol00004ooooo`03o`000?oooooooooo0?ooooooE_ooool00:oooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooooooooooo
o`00003ooooooeWooooo002`ooooo`03o`000?oooooooooo00_ooooo00Go0000oooooooooooooooo
o`000005ooooo`05o`000?ooooooooooooooool00000oooooomJooooo`00/Oooool00ol0003ooooo
ooooo`0:ooooo`05o`000?ooooooooooooooool000001Oooool01?l0003oooooooooool0003ooooo
oe_ooooo002booooo`03o`000?oooooooooo00Wooooo00Co0000oooooooooooo00001Oooool01?l0
003oooooooooool0003ooooooecooooo002cooooo`03o`000?oooooooooo00Sooooo00Co0000oooo
oooooooo00001Oooool00ol0003oooooo`00003ooooooegooooo002dooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooool000001Oooool00ol0003oooooo`00003ooooooekooooo002eooooo`03
o`000?oooooooooo00Kooooo0ol00005ooooo`;o0000oooooomOooooo`00]_ooool00ol0003ooooo
ooooo`05ooooo`;o00001Oooool2o`000?ooooooH?ooool00;Oooooo00?o0000ooooooooool01?oo
ool2o`0000Gooooo00?o0000ooooooooool0oooooomOooooo`00^?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo0_l0003oooooof7ooooo002iooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool2o`000?ooooooH_ooool00;[ooooo00?o0000oooooooo
ool00_l00003ooooo`03o`000?oooooo00000?ooooooH_ooool00:gooooo0ol00004ooooo`;o0000
1Oooool01?l0003oooooo`000?l00002ooooo`03o`000?oooooo000001[ooooo0_l0003oooooodOo
oooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool01Ol0003o
ooooo`000?oooooo000000;ooooo00?o0000ooooooooool05oooool01?l0003oooooooooool0003o
ooooodKooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool4
o`0000;ooooo00?o0000ooooooooool05oooool01Ol0003ooooooooooooooooo00000?ooooooA_oo
ool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oo
oooooooo00Go00006Oooool3o`0000;ooooo00?o0000ooooooooool0oooooom3ooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0Hooooo`;o000000?oooooo`000?l00000oooooom6ooooo`00[Ooo
ool2o`0000Cooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool05oooool01?l0003oooooooooool0003oooooodSooooo002^ooooo`03
o`000?oooooooooo00?ooooo0_l00004ooooo`07o`000?ooooooooooooooool0003oooooo`00000H
ooooo`;o0000oooooom<ooooo`00^Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo0000
01Oooooo00?o0000ooooooooool0oooooom<ooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o
00005oooool00ol0003oooooooooo`3oooooodgooooo002hooooo`03o`000?oooooooooo00?ooooo
0_l0000Eooooo`;o0000oooooom@ooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo01?ooooo00?o0000ooooooooool0oooooom@ooooo`00]oooool00ol0003oooooooooo`04
ooooo`?o00004_ooool00ol0003oooooooooo`3ooooooe7ooooo002gooooo`03o`000?oooooooooo
00?ooooo0_l0000Booooo`;o0000oooooomDooooo`00]_ooool00ol0003oooooooooo`04ooooo`;o
00004Oooool00ol0003oooooooooo`3ooooooeCooooo002fooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooool000004?ooool00ol0003oooooooooo`3ooooooeGooooo002eooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooool000003oooool00ol0003oooooooooo`3ooooooeKooooo002e
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool000003Oooool2o`000?ooooooFOooool0
0;Cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooo
oooo0?ooooooFOooool00;Cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000;
ooooo`03o`000?oooooooooo0?ooooooF_ooool00;?ooooo00?o0000ooooooooool01?ooool01?l0
003oooooooooooooool3o`0000Oooooo0_l0003ooooooegooooo002cooooo`03o`000?oooooooooo
00Cooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo0?ooooooGOooool0
0;;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0oooooomNooooo`00/_ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool2o`000?ooooooHOooool00;7ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0oooooomQooooo`00/Oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00?ooooo00Go0000ooooooooooooooooo`00003oooooofCooooo002`ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool01?l0003oooooo`000?l0003oooooofGooooo
002`ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool2o`000?ooooooIooo
ool00:oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03oooo
o`Go0000oooooomVooooo`00[_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00Co0000oooooooooooo0000oooooomXooooo`00[_ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00003oooooofSooooo002]ooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooooooo0_l00004ooooo`03o`000?oooooooooo
0<;ooooo0_l0002Qooooo`00[Oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00
00Kooooo00?o0000ooooooooool0`Oooool01?l0003oooooooooool0002Pooooo`00[?ooool00ol0
003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0`?ooool0
1Ol0003ooooooooooooooooo00000:3ooooo002/ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooool000002?ooool00ol0003oooooooooo`30ooooo`05o`000?ooooooooooooooool00000X?oo
ool00:_ooooo00?o0000ooooooooool01Oooool2o`0000Wooooo00?o0000ooooooooool0`?ooool2
o`000003ooooool0003ooooo0:3ooooo002[ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool02Oooool3o`000<;ooooo00?o0000ooooooooool0X?ooool00:[ooooo00?o0000oooooooo
ool01?ooool2o`0000_ooooo00?o0000ooooooooool0oooooomVooooo`00Z_ooool4o`000004oooo
ool0003o0000o`0000cooooo00?o0000ooooooooool0oooooomVooooo`00ZOooool2o`0000?ooooo
00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`3oooooofKooooo002Yooooo`04o`00
0?ooooooooooooooo`;o000000?oooooo`000?ooool03?ooool00ol0003oooooooooo`3oooooofKo
oooo002Yooooo`04o`000?ooooooooooo`0000;ooooo0_l0000=ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:Wooooo00?o0000ooooooooool01Ol00003ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002Zooooo`;o000000Goooooo`000?l0003oooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003ooooo
o`000004ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool5o`000?oo
ooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002]oooo
o`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Co
oooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool5o`00
0?ooooooI?ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0ol00003ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`05o`000?ooooooooooooooool0
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002]ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`;o00000oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:oooooo00?o0000ooooooooool00_ooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo1Ol0003oooooofCo
oooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooo
oomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1?l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002/ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002]ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002^ooooo`;o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32653 .16252 .00609 0 365.73 arc
s
newpath
.33673 .04115 .00609 0 365.73 arc
s
newpath
.33963 .02065 .00609 0 365.73 arc
s
.32046 .16201 m
.33067 .04064 L
s
.3326 .16303 m
.3428 .04166 L
s
.34276 .042 m
.34566 .0215 L
s
.3307 .0403 m
.3336 .0198 L
s
.32893 .01355 m
.32469 .02923 L
s
.34821 .03558 m
.35244 .01991 L
s
.32653 .16252 m
.40077 .06596 L
s
.32893 .01355 m
.35244 .01991 L
s
.32469 .02923 m
.34821 .03558 L
s
.32893 .01355 m
.33963 .02065 L
s
.35244 .01991 m
.33963 .02065 L
s
newpath
.40077 .06596 .00457 0 365.73 arc
s
newpath
.72711 .12262 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Nooooo`?o00000_ooool3o`0001gooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
000000Co000000?oooooo`000?ooool06_ooool00ol0003oooooooooo`3oooooodCooooo002Moooo
o`03o`000?oooooooooo01cooooo00?o0000ooooool000000ol000000ooooooo0000o`000002o`00
01Sooooo00?o0000ooooooooool0oooooom5ooooo`00W_ooool00ol0003oooooooooo`0Jooooo`03
o`000?oooooooooo00;o00000_ooool7o`0001Gooooo00?o0000ooooooooool0oooooom6ooooo`00
Woooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo00;o00001Oooool01?l0003ooooo
ooooool0000Dooooo`03o`000?oooooooooo0?ooooooAoooool00:3ooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`04o`0000;ooooo0_l00002ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0Gooooo`04o`000?oo
ooooooooo`0000?ooooo1?l000000ooooooo0000ooooo`0Booooo`03o`000?oooooooooo0?oooooo
BOooool00:;ooooo00?o0000ooooooooool05Oooool01Ol0003ooooooooooooooooo000000Gooooo
00Co0000oooooooooooo00004_ooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`00
0?oooooooooo01Cooooo0ol000000ooooooo0000ooooo`04ooooo`04o`000?ooooooooooo`00017o
oooo00?o0000ooooooooool0oooooom;ooooo`00Y?ooool00ol0003oooooooooo`0Fooooo`Co0000
0oooool01?l0003oooooooooool0000@ooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo
00?o0000ooooooooool05_ooool00ol0003oooooooooo`04o`000003ooooool0003ooooo00oooooo
00?o0000ooooooooool0oooooom=ooooo`00Y_ooool00ol0003oooooooooo`0Dooooo`Ko000000Co
ooooo`000?l0003o00003oooool00ol0003oooooooooo`3oooooodkooooo002Wooooo`03o`000?oo
oooooooo01?ooooo0_l00004ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooo
oom?ooooo`00Z?ooool00ol0003oooooooooo`0Booooo`;o00001?ooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool04Oooool2o`00
00Cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`3ooooooe7ooooo002Zooooo`03
o`000?oooooooooo013ooooo0_l00004ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool0oooooomBooooo`00Zoooool00ol0003oooooooooo`0?ooooo`?o000000Coooooo`000?l0003o
00003Oooool00ol0003oooooooooo`3ooooooe?ooooo002/ooooo`03o`000?oooooooooo00kooooo
0_l000001Ooooooo0000oooooooooooo000000cooooo00?o0000ooooooooool0oooooomDooooo`00
[Oooool00ol0003oooooooooo`0=ooooo`Co00000_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo0?ooooooEOooool00:kooooo00?o0000ooooooooool03?ooool2o`0000Cooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooeKooooo002_ooooo`03o`000?oooooo
oooo00_ooooo0_l00004ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooomG
ooooo`00/?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000000?ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`3ooooooeSooooo002aooooo`03o`000?oooooooooo00So
oooo00?o0000ooooool000000oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0?oo
ooooFOooool00;;ooooo00?o0000ooooooooool01oooool00ol0003oooooo`000003ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool0oooooomJooooo`00/oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`0Eooooo`;o0000oooooom4ooooo`00]?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
000000?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Eooooo`04o`000?oooooo
ooooo`000?oooooo@oooool00;Gooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000002
o`000003ooooool0003ooooo00?ooooo00?o0000ooooooooool05_ooool01?l0003oooooooooool0
003ooooood?ooooo002fooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool000000oooool0
1Ol0003ooooooooooooooooo000001Sooooo00?o0000ooooool000000_ooool00ol0003ooooooooo
o`3ooooood3ooooo002gooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000000oooool0
1?l0003oooooooooool0000Jooooo`Co0000oooooom3ooooo`00^?ooool01ol0003ooooooooooooo
oooo0000ooooool000000oooool00ol0003oooooo`00000Kooooo`;o0000oooooom5ooooo`00^Ooo
ool01_l0003oooooooooool0003oooooo`0000?ooooo0_l0000Kooooo`03o`000?oooooooooo0?oo
ooooAOooool00;[ooooo00Go0000ooooool0003oooooo`000003ooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool0oooooom6ooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`;o0000
00Coooooo`000?oooooooooo0_l0000Kooooo`03o`000?oooooooooo0?ooooooA_ooool00:kooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00005ooooo`07o`000?oooooo0000oooo
ool0003oooooo`00000Jooooo`03o`000?oooooooooo0?ooooooAoooool00:kooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo000000;o000000?ooooo
o`000?ooool06Oooool00ol0003oooooooooo`3oooooodSooooo002^ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05o`0001Sooooo00?o0000
ooooooooool0oooooom9ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo0?ooooooBOooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Cooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?oooooo
B_ooool00:kooooo00?o0000ooooooooool00oooool2o`0000Gooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooBoooool00;_ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?oooooo
C?ooool00;_ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooooooo0?ooooooCOooool00;_ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo0?ooooooCOooool00;_ooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooC_ooool00;_ooooo00?o
0000ooooooooool01?l0000Cooooo`03o`000?oooooooooo0?ooooooCoooool00;_ooooo00Co0000
oooooooooooo00000_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooD?oo
ool00;_ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo0?ooooooD?ooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo000001;ooooo
00?o0000ooooooooool0oooooomAooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool0
00004Oooool00ol0003oooooooooo`3ooooooe;ooooo002jooooo`07o`000?ooooooooooooooool0
003oooooo`00000@ooooo`03o`000?oooooooooo0?ooooooDoooool00;[ooooo00Oo0000oooooooo
ooooooooo`000?oooooo0000013ooooo00?o0000ooooooooool0oooooomCooooo`00^_ooool01ol0
003ooooooooooooooooo0000ooooool000003oooool00ol0003oooooooooo`3ooooooeCooooo002j
ooooo`04o`000?ooooooooooooooo`?o00003_ooool00ol0003oooooooooo`3ooooooeGooooo002j
ooooo`07o`000?ooooooooooooooool0003oooooo`00000=ooooo`03o`000?oooooooooo0?oooooo
E_ooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo000000gooooo00?o0000oooooooo
ool0oooooomFooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool000003?ooool00ol0
003oooooooooo`2jooooo`;o0000V_ooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo
000000_ooooo00?o0000ooooooooool0^_ooool01?l0003oooooooooool0002Iooooo`00^_ooool0
1ol0003ooooooooooooooooo0000ooooool000002_ooool00ol0003oooooooooo`2jooooo`05o`00
0?ooooooooooooooool00000VOooool00;[ooooo00Oo0000ooooooooooooooooo`000?oooooo0000
00[ooooo00?o0000ooooooooool0^_ooool01Ol0003ooooooooooooooooo000009Wooooo002ioooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooool000002Oooool00ol0003oooooooooo`2loooo
o`Co0000VOooool00;Wooooo00?o0000ooooooooool00_ooool2o`0000Wooooo00?o0000oooooooo
ool0oooooomKooooo`00^Oooool00ol0003oooooooooo`02ooooo`?o00001oooool00ol0003ooooo
ooooo`3ooooooecooooo002iooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooG?ooool00;Wooooo00?o0000ooooooooool00_ooool2o`0000Oooooo00?o0000
ooooooooool0oooooomMooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o00001_ooool00ol0
003oooooooooo`3ooooooekooooo002iooooo`03o`000?oooooooooo00;ooooo0_l00005ooooo`03
o`000?oooooooooo0?ooooooGoooool00;Wooooo00?o0000ooooooooool00_ooool2o`0000Cooooo
00?o0000ooooooooool0oooooomPooooo`00^Oooool00ol0003oooooooooo`02ooooo`;o00001?oo
ool00ol0003oooooooooo`3oooooof3ooooo002iooooo`03o`000?oooooooooo00;ooooo0_l00003
ooooo`03o`000?oooooooooo0?ooooooHOooool00;Wooooo00?o0000ooooooooool00_ooool3o`00
0003ooooool0003ooooo0?ooooooHoooool00;Wooooo00?o0000ooooooooool00_ooool2o`000003
ooooool0003ooooo0?ooooooI?ooool00;Wooooo00?o0000ooooooooool00_ooool2o`000003oooo
ool0003ooooo0?ooooooI?ooool00;Sooooo00?o0000ooooooooool00oooool3o`000?ooooooI_oo
ool00;Sooooo00?o0000ooooooooool00oooool2o`000?ooooooIoooool00;Sooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000;o
oooo1Ol000000ooooooo0000ooooo`3oooooofOooooo002]ooooo`04o`000?ooooooooooo`0000;o
oooo00Go0000oooooooooooo0000ooooo`02o`0000?ooooo0_l0003oooooofSooooo002^ooooo`03
o`000?oooooooooo00;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`?o0000oooooomX
ooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooool000000_ooool0
0ol0003oooooooooo`05o`000?ooooooI?ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`06o`000?ooooooooooo`000?oooooo00001Oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00002ooooo`;o
000000Coooooo`000?l0003o0000oooooomXooooo`00[Oooool3o`0000Cooooo0_l00005ooooo`04
o`000?ooooooooooo`000?ooooooJ?ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:ko
oooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo
00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[Oooool00ol0003o
ooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Ooo
ool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003ooooo
ooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003ooooo
ooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35629 .1595 .00609 0 365.73 arc
s
newpath
.32186 .04266 .00609 0 365.73 arc
s
newpath
.3398 .03233 .00609 0 365.73 arc
s
.35045 .16122 m
.31601 .04438 L
s
.36213 .15778 m
.3277 .04094 L
s
.3249 .04794 m
.34284 .0376 L
s
.31882 .03739 m
.33676 .02705 L
s
.327 .03337 m
.33337 .04831 L
s
.35578 .03875 m
.34941 .02381 L
s
.35629 .1595 m
.40981 .05008 L
s
.327 .03337 m
.34941 .02381 L
s
.33337 .04831 m
.35578 .03875 L
s
.327 .03337 m
.3398 .03233 L
s
.34941 .02381 m
.3398 .03233 L
s
newpath
.40981 .05008 .00457 0 365.73 arc
s
newpath
.74053 .10459 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool01Oooool2o`0001Cooooo00?o
0000ooooooooool0oooooom8ooooo`00XOooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo00Go000000?oooooo`000?ooool04_ooool00ol0003oooooooooo`3oooooodWooooo002Roooo
o`03o`000?oooooooooo01Wooooo1Ol000000ooooooo0000ooooo`02ooooo`03o`000?oooooooooo
00oooooo00?o0000ooooooooool0oooooom:ooooo`00Xoooool00ol0003oooooooooo`0Gooooo`Co
00000_ooool2o`0000?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`3ooooood_o
oooo002Tooooo`03o`000?oooooooooo01Cooooo2?l00002ooooo`04o`000?ooooooooooo`0000oo
oooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0Booooo`Ko0000
1Oooool01Ol0003ooooooooooooooooo000000gooooo00?o0000ooooooooool0oooooom=ooooo`00
Y_ooool00ol0003oooooooooo`0?ooooo`;o000000Coooooo`000?oooooooooo1?l00002ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooodko
oooo002Wooooo`03o`000?oooooooooo00cooooo1Ol000001?oooooo0000ooooool00003ooooo`?o
00001?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`02ooooo`;o000000?oooooo`000?ooool0
0_l00007ooooo`;o00002Oooool00ol0003oooooooooo`3ooooooe3ooooo002Yooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool00oooool2o`000003ooooool0003o000000Kooooo0ol0
000:ooooo`03o`000?oooooooooo0?ooooooDOooool00:[ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`03ooooo`Co00001Oooool2o`0000cooooo00?o0000ooooooooool0oooooomB
ooooo`00Zoooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo1?l00003oooo
o`;o00003Oooool00ol0003oooooooooo`0Aooooo`?o0000ooooooloooooo`00[?ooool00ol0003o
ooooooooo`06ooooo`?o00000_ooool8o`0000kooooo00?o0000ooooooooool04Oooool01Ol0003o
oooooooooooooooo00000?oooooo?_ooool00:gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`02o`0000;ooooo00?o0000ooooool000000_l0000>ooooo`03o`000?oooooooooo01;o
oooo00Go0000ooooooooooooooooo`00003oooooockooooo002^ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool00oooool00ol0003oooooo`00000?ooooo`03o`000?oooooooooo01?o
oooo00Go0000ooooool0003oooooo`00003oooooockooooo002_ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01?ooool2o`0000kooooo00?o0000ooooooooool05?ooool5o`000?oo
oooo?_ooool00;3ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`;o0000
3Oooool00ol0003oooooooooo`0Fooooo`;o0000oooooom0ooooo`00/Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo0_l0000<ooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool0ooooooloooooo`00/_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo0?oooooo@?ooool00;?ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood3ooooo002doooo
o`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool0oooooom1ooooo`00]Oooool01?l0003oooooooooool00005
ooooo`?o00001_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?oooooo@Oooool0
0;Kooooo00?o0000ooooool000001Oooool2o`0000Kooooo00?o0000ooooooooool06Oooool00ol0
003oooooooooo`3ooooood;ooooo002gooooo`;o00001Oooool2o`0000Gooooo00?o0000oooooooo
ool06_ooool00ol0003oooooooooo`3ooooood;ooooo002hooooo`;o00001?ooool2o`0000Cooooo
00?o0000ooooooooool06_ooool00ol0003oooooooooo`3ooooood?ooooo002iooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo0?oooooo@oooool00;Wooooo0_l00003ooooo`05o`000?oooooo0000ooooool000007Ooo
ool00ol0003oooooooooo`3oooooodCooooo002]ooooo`?o00001?ooool2o`0000Cooooo0_l00002
ooooo`04o`000?oooooo0000o`0001kooooo00?o0000ooooooooool0oooooom4ooooo`00[_ooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00Ko0000ooooool0003ooooo
o`000?ooool2o`0001gooooo00?o0000ooooooooool0oooooom5ooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00ol000000ooooooo
0000ooooo`0Looooo`03o`000?oooooooooo0?ooooooAOooool00:kooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Go00006oooool00ol0003o
ooooooooo`3oooooodKooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00001?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01[ooooo00?o0000oooo
ooooool0oooooom6ooooo`00[Oooool2o`0000Cooooo00Co0000oooooooooooo00001?ooool01?l0
003oooooooooool00003ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom7
ooooo`00[_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool01?l0003oooooooooool00003
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooom7ooooo`00_?ooool00ol0
003oooooo`000003ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0oooooom8oooo
o`00_?ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo01Kooooo00?o0000oooooooo
ool0oooooom8ooooo`00_?ooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo01Gooooo
00?o0000ooooooooool0oooooom9ooooo`00_Oooool2o`0000Cooooo00?o0000ooooooooool05Ooo
ool00ol0003oooooooooo`3oooooodWooooo002mooooo`Co00000oooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo0?ooooooB_ooool00;gooooo0_l00005ooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool0oooooom:ooooo`00__ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool0]?ooool4o`0009;ooooo002nooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`2dooooo`04o`00
0?ooooooooooo`0009;ooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`2dooooo`05o`000?ooooooooooooooool00000T_ooool00;kooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0;Gooooo
00Co0000ooooool0003o0000T_ooool00;kooooo0_l00005ooooo`03o`000?oooooooooo00oooooo
00?o0000ooooooooool0]oooool00ol0003oooooooooo`2Booooo`00__ooool2o`0000Kooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`3oooooodgooooo002nooooo`?o00001Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooC_ooool00;kooooo00?o0000oooo
ool000001Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooC_ooool00;ko
oooo00?o0000ooooool000001_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0?oo
ooooCoooool00;kooooo00?o0000ooooool000001_ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo0?ooooooCoooool00;kooooo00Co0000oooooooooooo00001Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo0?ooooooD?ooool00;kooooo00Co0000oooooooooooo0000
1Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooD?ooool00;kooooo00Co
0000oooooooooooo00001_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?oooooo
DOooool00;kooooo00Co0000oooooooooooo00001_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0?ooooooDOooool00;kooooo00Go0000ooooooooooooooooo`000005ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0oooooomBooooo`00__ooool3o`000003ooooool0
003ooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3ooooooe;ooooo002n
ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomCooooo`00__ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`3ooooooeCooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooE?ooool00;kooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool0oooooomEooooo`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3ooooooeGooooo002n
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
003ooooooeSooooo002nooooo`?o00000oooool00ol0003oooooooooo`04ooooo`04o`000?oooooo
ooooo`000?ooooooF?ooool00;kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooo00000?ooooooFOooool00;kooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`04ooooo`;o0000oooooomIooooo`00__ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomHooooo`00__ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Co0000oooooomJooooo`00__ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooo000000;ooooo00?o0000ooooool00000oooooomIooooo`00[?ooool5
o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000000_ooool0
0ol0003oooooo`00003ooooooeWooooo002]ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00001oooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool0oooooomGooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo0?ooooooEoooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo1Ol00005ooooo`;o000000?oooooo`000?l00000oooooomJooooo`00[?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo0?ooooooF_ooool00:cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo
0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:go
oooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o0000
0oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go
0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo
0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?oo
ool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000
oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.36365 .15694 .00609 0 365.73 arc
s
newpath
.31818 .04394 .00609 0 365.73 arc
s
newpath
.33864 .04713 .00609 0 365.73 arc
s
.358 .15921 m
.31253 .04622 L
s
.3693 .15467 m
.32383 .04167 L
s
.31724 .04996 m
.3377 .05315 L
s
.31911 .03792 m
.33957 .04111 L
s
.3282 .05461 m
.34134 .06414 L
s
.35565 .04443 m
.3425 .03489 L
s
.36365 .15694 m
.41264 .04542 L
s
.3282 .05461 m
.3425 .03489 L
s
.34134 .06414 m
.35565 .04443 L
s
.3282 .05461 m
.33864 .04713 L
s
.3425 .03489 m
.33864 .04713 L
s
newpath
.41264 .04542 .00457 0 365.73 arc
s
newpath
.75394 .0858 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`02ooooo`;o00004Oooool0
0ol0003oooooooooo`3oooooodkooooo002Wooooo`03o`000?oooooooooo00cooooo1Ol00003oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooool000003oooool00ol0003oooooooooo`3ooooo
odoooooo002Xooooo`03o`000?oooooooooo00Wooooo0_l00003ooooo`03o`000?oooooo000000Co
00000_ooool01?l0003oooooooooooooool2o`0000cooooo00?o0000ooooooooool0oooooom@oooo
o`00ZOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooo`000003o`0000Cooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`0@ooooo`?o0000oooooolnooooo`00Z_ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00?ooooo0_l00003ooooo`;o000000Goooooo`000?l0003oooooo`000004ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool04Oooool01?l0003oooooooooool0003ooooo
ocgooooo002[ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool01?l0003o
ooooooooooooool4o`0000;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`3ooooo
oc[ooooo002/ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool2o`0000?o
oooo1?l00002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool0ooooooljooooo`00
[Oooool00ol0003oooooooooo`04ooooo`Oo00000oooool3o`0000?ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Cooooo1?l0003oooooocgooooo
002^ooooo`03o`000?oooooooooo00Cooooo0ol00002ooooo`Oo000000?oooooo`000?l000001?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0oooo
oolnooooo`00[oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooool000001?l00006ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool05Oooool0
0ol0003oooooooooo`3oooooocoooooo002`ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool01?ooool3o`0000Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Foooo
o`03o`000?oooooooooo0?oooooo?oooool00;7ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooo000000Oooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo0?oooooo?oooool00;;ooooo00Go0000oooooooooooo
ooooo`000005ooooo`03o`000?oooooo000000;o00001?ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool0oooooom0ooooo`00/oooool01Ol0003ooooo
oooooooooooo000000Gooooo0_l00002ooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo0?oooooo@?ooool00;Cooooo00Co0000oooooooo
oooo00001Oooool2o`0000?ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0?oooooo@Oooool00;Gooooo00?o0000ooooool000001_ooool3o`0000;o
oooo00Go0000ooooooooooooooooo`00000Kooooo`03o`000?oooooooooo0?oooooo@Oooool00;Ko
oooo00?o0000ooooool000001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01Wo
oooo00?o0000ooooooooool0oooooom2ooooo`00]oooool2o`0000Gooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo0?oooooo@_ooool00;Sooooo0_l0
0004ooooo`;o00001?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?oooooo@_oo
ool00;Wooooo00?o0000ooooooooool00_ooool2o`0000?ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`3ooooood?ooooo002iooooo`;o00000oooool01Ol0003oooooo`000?oooooo
000001kooooo00?o0000ooooooooool0oooooom3ooooo`00[Oooool3o`0000Cooooo0_l00004oooo
o`;o00000_ooool01?l0003oooooo`000?l0000Nooooo`03o`000?oooooooooo0?ooooooA?ooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`06o`000?oooooo
0000ooooool0003ooooo0_l0000Nooooo`03o`000?oooooooooo0?ooooooA?ooool00:kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo000000;o0000
00?oooooo`000?ooool07?ooool00ol0003oooooooooo`3oooooodGooooo002^ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05o`0001cooooo
00?o0000ooooooooool0]Oooool3o`0008cooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo01[o
oooo00?o0000ooooooooool0]Oooool01?l0003oooooooooool0002;ooooo`00[Oooool2o`0000Co
oooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo
01Wooooo00?o0000ooooooooool0]Oooool01Ol0003ooooooooooooooooo000008_ooooo002^oooo
o`03o`000?oooooooooo00?ooooo0_l00006ooooo`03o`000?oooooo000000Cooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`2fooooo`04o`000?ooooooooooo`0008_ooooo002moooo
o`;o00001?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo0;Sooooo0ol0002;oooo
o`00_Oooool2o`0000Cooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`3oooooodOo
oooo002mooooo`;o00001Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?oooooo
B?ooool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Eooooo`03o`000?oo
oooooooo0?ooooooB?ooool00;kooooo0ol00004ooooo`03o`000?oooooooooo01Cooooo00?o0000
ooooooooool0oooooom8ooooo`00__ooool2o`0000Gooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`3oooooodWooooo002nooooo`;o00001Oooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo0?ooooooBOooool00;kooooo0_l00006ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool0oooooom:ooooo`00__ooool00ol0003oooooo`000005ooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool0oooooom:ooooo`00__ooool00ol0003oooooo`000006
ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooom;ooooo`00__ooool00ol0
003oooooo`000006ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0oooooom;oooo
o`00__ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo00oooooo00?o0000oooo
ooooool0oooooom;ooooo`00__ooool4o`0000Kooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`3oooooodcooooo002nooooo`05o`000?ooooooooooooooool000001Oooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo0?ooooooC?ooool00;kooooo00Go0000oooooooooooo
ooooo`000006ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0oooooom=ooooo`00
__ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`3oooooodgooooo002nooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooC_ooool00;kooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool0oooooom>ooooo`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3oooooodkooooo002noooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo0?ooooooCoooool00;kooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooom?ooooo`00
__ooool3o`0000Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooD?ooool00;kooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooom@ooooo`00__ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`3ooooooe7ooooo002nooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooDOooool00;ko
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0oooooomAooooo`00__ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Cooooo00Go0000ooooooooooooooooo`00003ooooooeCooooo002nooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01?ooool01Ol0003ooooooooooooooooo00000?oo
ooooE?ooool00;kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`04o`00
0?ooooooooooo`000?ooooooEOooool00;kooooo0ol00007ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooool00000oooooomEooooo`00__ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Cooooo0_l0003ooooooeKooooo002nooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`3ooooooeCooooo002nooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01Ol0003ooooooeKooooo002nooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooool000000_ooool2o`000?ooooooE_ooool00;kooooo00?o0000ooooooooool0
2Oooool2o`0000?ooooo0ol0003ooooooeGooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o
0000ooooooooool02Oooool2o`0000;ooooo00Co0000oooooooooooo0000oooooomEooooo`00[Ooo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooDoooool00:kooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00_o
oooo0_l000000ooooooo0000o`00003ooooooeKooooo002_ooooo`05o`000?ooooooooooooooool0
00000_ooool00ol0003oooooooooo`05ooooo`Go00002oooool00ol0003oooooooooo`3ooooooeKo
oooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`00
00Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo1Ol0003ooooo
ofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004oooo
o`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`?o00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003ooooooooooooooooo000000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go0000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomToooo
o`00[Oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo00;ooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`Go0000oooooomTooooo`00
[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKo
oooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001oooool00ol0003o
ooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Co0000
0oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00[?ooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34198 .16235 .00609 0 365.73 arc
s
newpath
.32901 .04124 .00609 0 365.73 arc
s
newpath
.33421 .06128 .00609 0 365.73 arc
s
.33593 .163 m
.32295 .04189 L
s
.34804 .1617 m
.33506 .04059 L
s
.32311 .04277 m
.32831 .06281 L
s
.3349 .03971 m
.3401 .05975 L
s
.32946 .07321 m
.34567 .07414 L
s
.34706 .04982 m
.33085 .04889 L
s
.34198 .16235 m
.40663 .05912 L
s
.32946 .07321 m
.33085 .04889 L
s
.34567 .07414 m
.34706 .04982 L
s
.32946 .07321 m
.33421 .06128 L
s
.33085 .04889 m
.33421 .06128 L
s
newpath
.40663 .05912 .00457 0 365.73 arc
s
newpath
.7685 .06454 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool04_ooool4o`0001Oooooo00?o0000ooooooooool0oooooom>
ooooo`00Yoooool00ol0003oooooooooo`0@ooooo`04o`000?ooooooooooooooo`;o00005Oooool0
0ol0003oooooooooo`3oooooodoooooo002Xooooo`03o`000?oooooooooo00oooooo00Co0000oooo
oooooooooooo0_l0000Dooooo`03o`000?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`02ooooo`;o00004oooool00ol0003oooooooooo`3ooooo
oe7ooooo002Zooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool2o`0001;o
oooo00?o0000ooooooooool0oooooomBooooo`00Zoooool00ol0003oooooooooo`0;ooooo`?o0000
00?oooooo`000?l000000_l0000@ooooo`03o`000?oooooooooo0?ooooooDoooool00:cooooo00?o
0000ooooooooool02_ooool01Ol0003oooooooooool0003ooooo00?o00003oooool00ol0003ooooo
ooooo`3ooooooeCooooo002]ooooo`03o`000?oooooooooo00Wooooo0_l00002ooooo`Wo00002Ooo
ool00ol0003oooooooooo`3ooooooeGooooo002^ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_l000000ooooooo0000o`000003ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0oooooomFooooo`00[oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00;o000000?oooooo`000?l000000oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooEoooool00;3ooooo00?o0000ooooooooool01oooool2o`000003ooooool0003o000000?o
00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo01Cooooo0ol0003ooooood7o
oooo002aooooo`03o`000?oooooooooo00Kooooo0_l000001?oooooo0000o`000?ooool2o`0000?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Eooooo`04o`000?ooooooooooo`00
0?oooooo@?ooool00;;ooooo00?o0000ooooooooool01Oooool2o`000003ooooool0003o000000Co
00000_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooool0
00000_ooool00ol0003oooooooooo`3oooooocgooooo002cooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooool000001?l000001Ooooooo0000oooooooooooo000000?ooooo00?o0000oooooooo
ool05_ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo0;Cooooo0ol00025ooooo`00
]?ooool00ol0003oooooooooo`03ooooo`04o`000?oooooo0000ooooo`?o000000Goooooo`000?oo
ooooooooo`000002ooooo`03o`000?oooooooooo01Sooooo00Co0000ooooool0003o0000]oooool0
1?l0003oooooooooool00024ooooo`00]Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
000000Go00000oooool00ol0003oooooo`00000Jooooo`03o`000?oooooo00000;Wooooo00Go0000
ooooooooooooooooo`000023ooooo`00]_ooool02?l0003ooooooooooooooooo0000ooooool0003o
oooo1?l00003ooooo`;o00006oooool00ol0003oooooooooo`2iooooo`;o00000_ooool00ol0003o
ooooooooo`21ooooo`00]oooool01?l0003oooooooooooooool4o`0000;ooooo00Go0000oooooooo
ooooooooo`00000Kooooo`03o`000?oooooooooo0;cooooo0_l00024ooooo`00^?ooool00ol0003o
ooooooooo`04o`0000;ooooo00?o0000ooooooooool00_l0000Kooooo`03o`000?oooooooooo0?oo
oooo@oooool00;Wooooo00?o0000ooooool000000ol00002ooooo`05o`000?oooooo0000ooooool0
00006_ooool00ol0003oooooooooo`3oooooodCooooo002jooooo`co00006Oooool00ol0003ooooo
ooooo`3oooooodGooooo002]ooooo`?o00001?ooool2o`0000Gooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?ooooooAOooool00:kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`;o000000?oooooo`000?ooool0
0_l0000Looooo`03o`000?oooooooooo0?ooooooA_ooool00:kooooo00?o0000ooooooooool00_oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooo000000;o000000?oooooo`000?ooool0
6oooool00ol0003oooooooooo`3oooooodKooooo002^ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00001?ooool00ol0003oooooooooo`05o`0001[ooooo00?o0000ooooooooool0
oooooom7ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?oo
ooooB?ooool00:gooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooool0
00000oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo0?ooooooB?ooool00:kooooo
00?o0000ooooooooool00oooool2o`0000Kooooo00?o0000ooooool000000oooool00ol0003ooooo
ooooo`0Fooooo`03o`000?oooooooooo0?ooooooBOooool00;cooooo00?o0000ooooool000000ooo
ool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooBOooool00;cooooo00?o0000
ooooool000000oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo0?ooooooB_ooool0
0;cooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
0?ooooooBoooool00;cooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0Dooooo`03
o`000?oooooooooo0?ooooooBoooool00;cooooo00?o0000ooooool000000_l000000ooooooo0000
ooooo`0Dooooo`03o`000?oooooooooo0?ooooooC?ooool00;cooooo00?o0000ooooool000000ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooCOooool00;cooooo00?o0000
ooooool000000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo0?ooooooCOooool0
0;gooooo0_l00004ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0oooooom>oooo
o`00_Oooool2o`0000Cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`3oooooodko
oooo002mooooo`;o00001?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo0?oooooo
Coooool00;gooooo0_l00004ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0oooo
oom@ooooo`00_Oooool2o`0000Cooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`3o
oooooe3ooooo002mooooo`Co00000_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
0?ooooooDOooool00;gooooo0_l00004ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool0oooooomAooooo`00_Oooool2o`0000Cooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`3ooooooe;ooooo002mooooo`;o00001?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooE?ooool00;kooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooE?ooool00;kooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?oooooo
EOooool00;kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo0?ooooooE_ooool00;kooooo0ol00003ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0oooooomFooooo`00__ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0oooooomGooooo`00__ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomHooooo`00__ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomHooooo`00__oo
ool2o`0000Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooeWooooo002n
ooooo`;o00001Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?ooooooFOooool0
0;kooooo0_l00005ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomJoooo
o`00__ooool2o`0000Gooooo00Go0000ooooooooooooooooo`00003ooooooegooooo002nooooo`?o
00001?ooool01Ol0003ooooooooooooooooo00000?ooooooGOooool00;kooooo0_l00005ooooo`04
o`000?ooooooooooo`000?ooooooG_ooool00;kooooo0_l00005ooooo`04o`000?ooooooooooo`00
0?ooooooG_ooool00;kooooo0_l00005ooooo`03o`000?oooooo00000?ooooooGoooool00;kooooo
0_l00005ooooo`;o0000oooooomPooooo`00__ooool00ol0003oooooo`000005ooooo`03o`000?oo
oooooooo0?ooooooG_ooool00:cooooo1Ol00003ooooo`;o00002?ooool00ol0003oooooo`000006
o`000?ooooooH?ooool00:gooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0
0007ooooo`04o`000?oooooo0000o`0000?ooooo0_l0003oooooof3ooooo002^ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooo`000003ooooo`?o0000
oooooomPooooo`00[oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool0
1Oooool6o`0000;ooooo00?o0000ooooooooool0oooooomNooooo`00[?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooo`000005ooooo`03
o`000?oooooooooo0?ooooooG_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04
o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool00_l000000ooooooo0000o`00003ooooo
of7ooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`3oooooof7ooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0
oooooomVooooo`00[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
0oooool01?l0003oooooooooool00007ooooo`Go0000oooooomTooooo`00/?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00
[?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00[_ooool3o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool5o`0000;ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`04o`000?ooooooooooo`0000?ooooo
00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00:gooooo00?o0000ooooool00000
0oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo
0_l00003ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00
[oooool00ol0003oooooooooo`02ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`3oooooofKooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo
00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo1?l00003ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool00ol0003ooooooooo
o`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004
ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo0000
1oooool5o`000?ooooooI?ooool00:cooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00?o0000ooooooooool00ooo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo0000\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2981 .15477 .00609 0 365.73 arc
s
newpath
.35095 .04503 .00609 0 365.73 arc
s
newpath
.33096 .05042 .00609 0 365.73 arc
s
.29262 .15213 m
.34546 .04238 L
s
.30359 .15741 m
.35644 .04767 L
s
.34936 .03915 m
.32937 .04454 L
s
.35253 .05091 m
.33254 .0563 L
s
.34366 .05228 m
.34081 .03629 L
s
.31683 .04056 m
.31968 .05655 L
s
.2981 .15477 m
.39678 .08337 L
s
.34366 .05228 m
.31968 .05655 L
s
.34081 .03629 m
.31683 .04056 L
s
.34366 .05228 m
.33096 .05042 L
s
.31968 .05655 m
.33096 .05042 L
s
newpath
.39678 .08337 .00457 0 365.73 arc
s
newpath
.7826 .04307 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooom2ooooo`00Voooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Oooooo`?o00007oooool0
0ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooodGooooo002Nooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooodKooooo002Oooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooodOooooo
002Pooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`3oooooodSooooo002Qooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool06_ooool0
0ol0003oooooooooo`3oooooodWooooo002Rooooo`03o`000?oooooooooo01Wooooo00?o0000oooo
ooooool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Sooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03o`00
0?oooooooooo01Oooooo0ol0000Gooooo`03o`000?oooooooooo0?ooooooC?ooool00:Gooooo00?o
0000ooooooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo0?ooooooCOoo
ool00:Kooooo00?o0000ooooooooool05Oooool00ol0003oooooo`000002o`0001?ooooo00?o0000
ooooooooool0oooooom>ooooo`00Yoooool00ol0003oooooooooo`0Booooo`Co00000_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooCoooool00:Sooooo00?o0000oooooooo
ool03Oooool4o`0000;ooooo00Go0000ooooooooooooooooo`000002ooooo`Go00002_ooool00ol0
003oooooooooo`3?ooooo`?o0000OOooool00:Wooooo00?o0000ooooooooool02_ooool2o`0000Ko
oooo00?o0000ooooooooool01_l00003ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0d?ooool01?l0003oooooooooool0001looooo`00Z_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Gooooo0ol00002ooooo`03o`000?oooooo000000Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`3@ooooo`05o`000?ooooooooooooooool00000O?ooool00:_o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`02ooooo`Go00000oooool3o`0000Go
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3Aooooo`;o000000?oooooo`000?oo
ool0O?ooool00:cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`06o`00
0?ooooooooooo`000?oooooo00000_ooool2o`0000Gooooo0_l00004ooooo`03o`000?oooooooooo
0=Cooooo00?o0000ooooooooool0O?ooool00:gooooo00?o0000ooooooooool01_ooool01Ol0003o
oooooooooooooooo000000?ooooo0ol00002ooooo`Co00000_ooool2o`0000Cooooo00?o0000oooo
ooooool0oooooomEooooo`00[_ooool00ol0003oooooooooo`06ooooo`05o`000?ooooooooooo`00
0?ooool01_l000001?oooooo0000o`000?ooool4o`0000Cooooo00?o0000ooooooooool0oooooomF
ooooo`00[oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00;o00000_ooool00ol0
003oooooo`000005o`0000?ooooo00Go0000ooooooooooooooooo`00003ooooooeWooooo002`oooo
o`03o`000?oooooooooo00Cooooo3?l00005ooooo`05o`000?ooooooooooooooool00000oooooomJ
ooooo`00/Oooool00ol0003oooooooooo`03ooooo`?o00000oooool3o`0000;ooooo00?o0000oooo
ooooool00oooool01?l0003oooooooooool0003ooooooe_ooooo002booooo`03o`000?oooooooooo
00Wooooo00Co0000oooooooooooo00001Oooool01?l0003oooooooooool0003ooooooecooooo002c
ooooo`03o`000?oooooooooo00Sooooo00Co0000oooooooooooo00001Oooool00ol0003oooooo`00
003ooooooegooooo002dooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool000001Oooool0
0ol0003oooooo`00003ooooooekooooo002eooooo`03o`000?oooooooooo00Kooooo0ol00005oooo
o`;o0000oooooomOooooo`00]_ooool00ol0003oooooooooo`05ooooo`;o00001Oooool2o`000?oo
ooooH?ooool00;Oooooo00?o0000ooooooooool01?ooool2o`0000Gooooo00?o0000ooooooooool0
oooooomOooooo`00^?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo0_l0
003oooooof7ooooo002iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool2
o`000?ooooooH_ooool00;[ooooo00?o0000ooooooooool00_l00003ooooo`03o`000?oooooo0000
0?ooooooH_ooool00:gooooo0ol00004ooooo`;o00001Oooool01?l0003oooooo`000?l00002oooo
o`03o`000?oooooo00000?ooooooHoooool00:kooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00005ooooo`05o`000?oooooo0000ooooool000000_ooool00ol0003oooooooooo`0I
ooooo`;o0000oooooom6ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Gooooo1?l00002ooooo`03o`000?oooooooooo01Wooooo00Co0000oooooooooooo0000oooo
oom5ooooo`00[_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool01Ol0000Kooooo`04o`000?ooooooooooo`000?ooooooAOooool00:kooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool06Oooool3o`0000;ooooo00?o0000ooooooooool0oooooom2ooooo`00
[Oooool2o`0000Cooooo00Co0000oooooooooooo00000oooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool06Oooool2o`000003ooooool0003o00000?ooooooAOooool00:ko
oooo00?o0000ooooooooool00oooool2o`0000Cooooo00Oo0000ooooooooooooooooo`000?oooooo
000001_ooooo00Co0000oooooooooooo0000oooooom7ooooo`00^Oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooo000001Wooooo0_l0003ooooood_ooooo002iooooo`03o`000?oooooooooo
00;ooooo0_l0000Iooooo`03o`000?oooooooooo0?ooooooBoooool00;Sooooo00?o0000oooooooo
ool00oooool2o`0001Oooooo0_l0003oooooodkooooo002hooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool05Oooool00ol0003oooooooooo`3oooooodkooooo002gooooo`03o`000?oo
oooooooo00Cooooo0ol0000Dooooo`03o`000?oooooooooo0?ooooooCoooool00;Oooooo00?o0000
ooooooooool00oooool2o`0001Cooooo0_l0003ooooooe;ooooo002fooooo`03o`000?oooooooooo
00Cooooo0_l0000Cooooo`03o`000?oooooooooo0?ooooooD_ooool00;Kooooo00?o0000oooooooo
ool00oooool00ol0003oooooo`00000Booooo`03o`000?oooooooooo0?ooooooDoooool00;Gooooo
00?o0000ooooooooool01?ooool00ol0003oooooo`00000@ooooo`;o0000oooooomFooooo`00]Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000oooooo00?o0000ooooooooool0oooo
oomFooooo`00]?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000gooooo0_l0
003ooooooeWooooo002dooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00003?oo
ool00ol0003oooooooooo`3ooooooeWooooo002cooooo`03o`000?oooooooooo00Cooooo00Co0000
oooooooooooooooo0ol00009ooooo`03o`000?oooooooooo0?ooooooF_ooool00;?ooooo00?o0000
ooooooooool01?ooool01Ol0003ooooooooooooooooo000000Wooooo0_l0003ooooooegooooo002b
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo0?ooooooGOooool00;;ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo0_l0003oooooof3ooooo002aooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo0?ooooooH?ooool00;7ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooooomQooooo`00/?oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l0
003oooooofCooooo002`ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooo`00003oooooofKooooo002_ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01Oooool2o`000?ooooooIoooool00:oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`04ooooo`Co0000oooooomVooooo`00[_ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooool00000oooooomXooooo`00[_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`04oooo
o`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`3oooooofKooooo002/oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l00006ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:_ooooo00?o0000ooooooooool01Oooool2o`0000Wooooo
00?o0000ooooooooool0oooooomVooooo`00Zoooool00ol0003oooooooooo`04ooooo`;o00002_oo
ool3o`000?ooooooI_ooool00:[ooooo00?o0000ooooooooool01?ooool2o`0000_ooooo00?o0000
ooooooooool0oooooomVooooo`00Z_ooool8o`0000cooooo00?o0000ooooooooool0oooooomVoooo
o`00ZOooool2o`0000?ooooo0_l000000ooooooo0000ooooo`0;ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:Wooooo00Ko0000ooooooooooooooooo`000?ooool2o`0000gooooo00?o0000oooo
ooooool0oooooomVooooo`00ZOooool01?l0003oooooooooool00002ooooo`;o00003Oooool00ol0
003oooooooooo`3oooooofKooooo002Yooooo`03o`000?oooooooooo00Go00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00Z_ooool2o`000005ooooool0003o0000ooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00?o0000ooooool000001?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo
00Gooooo1Ol0003oooooofCooooo002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooo
oomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o
0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05
o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`000?oooooooooo
o`0000Oooooo1Ol0003oooooofCooooo002`ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_oo
ool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3
o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002^oooo
o`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003o
oooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00007
ooooo`Go0000oooooomTooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo00Co0000oooo
oooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`000?oooooooooo
00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol00004ooooo`;o
00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00;3o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05oooo
o`Go0000oooooomTooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo00001oooool00ol0
003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooo
oooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000oooool2o`0000So
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3ooooo
ofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Go0000oooooomToooo
o`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l00008ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0001\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31202 .15996 .00609 0 365.73 arc
s
newpath
.34399 .04243 .00609 0 365.73 arc
s
newpath
.33375 .02443 .00609 0 365.73 arc
s
.30615 .15837 m
.33811 .04083 L
s
.3179 .16156 m
.34986 .04403 L
s
.34928 .03942 m
.33904 .02142 L
s
.33869 .04544 m
.32846 .02744 L
s
.33416 .0116 m
.3186 .01624 L
s
.32556 .03958 m
.34112 .03494 L
s
.31202 .15996 m
.41081 .08871 L
s
.33416 .0116 m
.34112 .03494 L
s
.3186 .01624 m
.32556 .03958 L
s
.33416 .0116 m
.33375 .02443 L
s
.34112 .03494 m
.33375 .02443 L
s
newpath
.41081 .08871 .00457 0 365.73 arc
s
newpath
.79644 .02119 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{550.75, 275.375},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationDisplayTime->0.5,
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001=ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Cooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001=ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Booooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0001:ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000B
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Sooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Booooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004_ooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004cooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Booooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004kooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Cooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000Wo00003Oooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`;o00005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01Cooooo
000Fooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000001;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo013ooooo00?o0000ooooool000005?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01Cooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo02Cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool0DOooool00ol0003oooooooooo`0Dooooo`00V?ooool00ol0003oooooooooo`0Soooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0oooooom0ooooo`00VOooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooom1ooooo`00
V_ooool00ol0003oooooooooo`0Pooooo`?o00008_ooool00ol0003oooooooooo`3ooooood;ooooo
002Kooooo`03o`000?oooooooooo01_ooooo1?l000000ooooooo0000o`00000Qooooo`03o`000?oo
oooooooo0?oooooo@oooool009cooooo00?o0000ooooooooool06?ooool2o`0000Gooooo0ol0000O
ooooo`03o`000?oooooooooo0<_ooooo0_l0001fooooo`00WOooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00Cooooo0ol0000Nooooo`03o`000?oooooooooo0<_ooooo00Co0000oooo
oooooooo0000MOooool009kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`02oooo
o`Ko00007?ooool00ol0003oooooooooo`3;ooooo`05o`000?ooooooooooooooool00000MOooool0
09oooooo00?o0000ooooooooool05_ooool01_l0003ooooooooooooooooo0000ooooo`Co00006ooo
ool00ol0003oooooooooo`3<ooooo`05o`000?ooooooooooooooool00000MOooool00:3ooooo00?o
0000ooooooooool05Oooool01?l0003oooooooooool00002ooooo`Go00006Oooool00ol0003ooooo
ooooo`3>ooooo`04o`000?oooooo0000o`0007Gooooo002Qooooo`03o`000?oooooooooo01Cooooo
00Co0000oooooooooooo00000_ooool2o`000003ooooool0003o000001Sooooo00?o0000oooooooo
ool0d?ooool00ol0003oooooooooo`1eooooo`00X_ooool00ol0003oooooooooo`0Cooooo`04o`00
0?ooooooooooooooo`?o000000Goooooo`000?l0003oooooo`00000Fooooo`03o`000?oooooooooo
0?ooooooB_ooool00:?ooooo00?o0000ooooooooool04oooool01Ol0003oooooooooool0003ooooo
00Co000000?oooooo`000?ooool05?ooool00ol0003oooooooooo`3ooooood_ooooo002Tooooo`03
o`000?oooooooooo01;ooooo00Co0000oooooooooooooooo1Ol00002ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool0oooooom<ooooo`00YOooool00ol0003oooooooooo`0Aooooo`04
o`000?ooooooooooooooo`;o00000_ooool2o`0000;ooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`3oooooodgooooo002Vooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooo`000005o`00013ooooo00?o0000ooooooooool0oooooom>ooooo`00
Yoooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo000000?o00000_ooool00ol0003ooooo
ooooo`02o`0000kooooo00?o0000ooooooooool0oooooom?ooooo`00Z?ooool00ol0003ooooooooo
o`0?ooooo`;o00000_ooool2o`0000;ooooo00Co0000oooooooooooooooo0_l0000<ooooo`03o`00
0?oooooooooo0?ooooooD?ooool00:Wooooo00?o0000ooooooooool04_ooool01?l0003oooooo`00
0?l00004ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooomAooooo`00Z_oo
ool00ol0003oooooooooo`0Aooooo`04o`000?oooooo0000o`0000Gooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`3ooooooe;ooooo002[ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool00_l00004ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooo
oomCooooo`00[?ooool00ol0003oooooooooo`0?ooooo`04o`000?oooooo0000ooooo`;o000000Co
ooooo`000?l0003o00002?ooool00ol0003oooooooooo`3ooooooeCooooo002]ooooo`03o`000?oo
oooooooo00kooooo0ol00003ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool0oooo
oomEooooo`00[_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo000000Gooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`3ooooooeKooooo002_ooooo`03o`000?oooooooooo
00cooooo0_l00006ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooomGoooo
o`00/?ooool00ol0003oooooooooo`0;ooooo`;o00001Oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo0?ooooooF?ooool00;7ooooo00?o0000ooooooooool02_ooool2o`0000Gooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooooeWooooo002booooo`03o`000?oo
oooooooo00Wooooo0_l00005ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0oooo
oomJooooo`00/oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00Go0000
ooooooooooooooooo`00003ooooooegooooo002dooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool00oooool01Ol0003ooooooooooooooooo00000?ooooooG_ooool00;Gooooo00?o0000
ooooooooool01_ooool3o`0000?ooooo00Co0000oooooooooooo0000oooooomOooooo`00]_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool00000oooooomP
ooooo`00]oooool00ol0003oooooooooo`03ooooo`;o00001Oooool2o`000?ooooooHOooool00;So
oooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0003oooooof;ooooo002iooooo`04o`00
0?ooooooooooooooo`;o00001?ooool00ol0003oooooooooo`3oooooof7ooooo002jooooo`05o`00
0?oooooo0000ooooool000000oooool2o`000?ooooooHoooool00:gooooo0ol00004ooooo`;o0000
1Oooool2o`000004ooooool0003oooooooooo`;o0000oooooomTooooo`00[_ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo00Oo0000ooooool0003oooooo`000?oooooo
00000?ooooooI?ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00005
ooooo`Co00000_ooool00ol0003oooooooooo`3oooooof;ooooo002^ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`05o`000?ooooooI?ooool0
0:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool08_ooool2o`000?oooooo?oooool00:gooooo0_l00004
ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0Qooooo`04o`000?ooooooooooo`000?oooooo?_ooool00:kooooo00?o0000ooooooooool0
0oooool2o`0000Cooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo023o
oooo00Go0000ooooooooooooooooo`00003oooooockooooo002jooooo`07o`000?oooooooooooooo
ool0003oooooo`00000Sooooo`?o00000_ooool00ol0003oooooooooo`3ooooooc_ooooo002joooo
o`07o`000?ooooooooooooooool0003oooooo`00000Sooooo`;o000000?oooooo`000?l00000oooo
oolnooooo`00^_ooool01ol0003ooooooooooooooooo0000ooooool000008Oooool2o`0000;ooooo
00?o0000ooooooooool0oooooolnooooo`00^Oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooo0000023ooooo00?o0000ooooooooool0oooooom3ooooo`00^Oooool00ol0003oooooooooo`02
ooooo`?o00007oooool00ol0003oooooooooo`3oooooodCooooo002iooooo`03o`000?oooooooooo
00;ooooo0_l0000Nooooo`;o0000oooooom7ooooo`00^?ooool00ol0003oooooooooo`03ooooo`;o
00007Oooool00ol0003oooooooooo`3oooooodOooooo002hooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool06_ooool2o`000?ooooooB_ooool00;Sooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0?ooooooB_ooool00;Sooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?ooooooBoooool0
0;Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Fooooo`;o0000oooooom>oooo
o`00]oooool00ol0003oooooooooo`03ooooo`;o00005oooool00ol0003oooooooooo`3oooooodko
oooo002gooooo`03o`000?oooooooooo00?ooooo1?l0000Cooooo`;o0000oooooomAooooo`00]ooo
ool00ol0003oooooooooo`03ooooo`;o00005?ooool00ol0003oooooooooo`3ooooooe7ooooo002f
ooooo`03o`000?oooooooooo00Cooooo0_l0000Booooo`;o0000oooooomDooooo`00]_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooo0000017ooooo00?o0000ooooooooool0oooooomDoooo
o`00]_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo0000013ooooo00?o0000oooooooo
ool0oooooomEooooo`00]Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000kooooo
0_l0003ooooooeSooooo002eooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo0000
3Oooool00ol0003oooooooooo`3ooooooeSooooo002eooooo`03o`000?oooooooooo00?ooooo00Co
0000oooooooooooo00002oooool2o`000?ooooooFoooool00;Gooooo00?o0000ooooooooool00ooo
ool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo0?ooooooFoooool00;Cooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`03o`0000Oooooo00?o0000ooooooooool0oooo
oomLooooo`00]?ooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooooooool000001ooo
ool2o`000?ooooooGoooool00;Cooooo00?o0000ooooooooool00oooool01Ol0003ooooooooooooo
oooo000000Kooooo00?o0000ooooooooool0oooooomOooooo`00/oooool00ol0003oooooooooo`04
ooooo`05o`000?ooooooooooooooool000001?ooool2o`000?ooooooH_ooool00;?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000oooo
oomTooooo`00/oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00Co0000
ooooool0003o0000oooooomUooooo`00/oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00;ooooo0_l0003oooooofOooooo002booooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`3oooooofKooooo002booooo`03o`000?oooooooooo00?o
oooo00Co0000oooooooooooooooo1Ol0003oooooofKooooo002booooo`03o`000?oooooooooo00?o
oooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`3oooooofKooooo002booooo`03
o`000?oooooooooo00?ooooo0ol00003ooooo`03o`000?oooooooooo0?ooooooI_ooool00;7ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;7ooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`05ooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;7ooooo0_l00002ooooo`?o00001_ooool00ol0003oooooooooo`3o
ooooofKooooo002/ooooo`Ko00000_ooool4o`0000Kooooo00?o0000ooooooooool0oooooomVoooo
o`00[Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[_ooool00ol0003oooooo`000002ooooo`04o`000?oooooooooo
o`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[oooool01Ol0003oooooo`000?oooooo
000000;ooooo00?o0000ooooooooool01Oooool5o`000?ooooooI?ooool00:cooooo00Co0000oooo
oooooooooooo1?l000000ooooooo0000o`000007ooooo`03o`000?oooooooooo0?ooooooI_ooool0
0:cooooo00Go0000ooooooooooooooooo`000002ooooo`;o000000?oooooo`000?ooool01_ooool0
0ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?ooool2o`0000Sooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00Oooooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?o
oooo00Co0000oooooooooooo00001oooool5o`000?ooooooI?ooool00;3ooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:co
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000
ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00:kooooo0ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002_ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1Ol00002ooooo`04o`000?ooooooooooo`0000Oo
oooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01?l0003oooooooooool00003ooooo`04
o`000?ooooooooooo`0000Oooooo1Ol0003oooooofCooooo002]ooooo`03o`000?oooooo000000?o
oooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o
00000oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:oo
oooo00?o0000ooooooooool00_ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0
003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooooooo
ool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0oooooomVooooo`00/?ooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Gooooo1Ol0003oooooofCooooo002/ooooo`Co00000oooool01?l0003ooooo
ooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00?o0000ooooooooool0
1?ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
1Ol00003ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`?o00001?oo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool01Ol0003ooooooooooooo
oooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00:cooooo1?l00003ooooo`04o`000?ooooooooooo`0000Oo
oooo1Ol0003oooooofCooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo
00001oooool00ol0003oooooooooo`3oooooofKooooo002]ooooo`03o`000?oooooooooo00?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002^ooooo`;o0000
1?ooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00\
\>"],
  ImageRangeCache->{{{0, 549.75}, {274.375, 0}} -> {-45.3944, -3.68019, \
0.237833, 0.237833}}]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1542}, {0, 1002}},
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{894, 717},
WindowMargins->{{Automatic, 90}, {Automatic, 64}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
CharacterEncoding->"NeXTAutomaticEncoding"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 76, 2, 108, "Title",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1877, 59, 114, 2, 56, "Section",
  Evaluatable->False],
Cell[1994, 63, 210, 6, 32, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2229, 73, 125, 3, 27, "Input"],
Cell[2357, 78, 103, 2, 23, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[2509, 86, 90, 2, 56, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2624, 92, 130, 3, 46, "Subsection",
  Evaluatable->False],
Cell[2757, 97, 73687, 1135, 283, 73595, 1132, "GraphicsData", "PICT", \
"Graphics"],
Cell[76447, 1234, 242, 6, 32, "Text",
  Evaluatable->False],
Cell[76692, 1242, 224, 6, 32, "Text",
  Evaluatable->False],
Cell[76919, 1250, 507, 10, 155, "Input"],
Cell[77429, 1262, 211, 6, 32, "Text",
  Evaluatable->False],
Cell[77643, 1270, 5336, 136, 2251, "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[83028, 1412, 108, 2, 36, "Section",
  Evaluatable->False],
Cell[83139, 1416, 70936, 1093, 273, 70844, 1090, "GraphicsData", "PICT", \
"Graphics"],
Cell[154078, 2511, 203, 6, 32, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[154306, 2521, 614, 12, 91, "Input"],
Cell[154923, 2535, 927, 24, 29, "Output"],
Cell[155853, 2561, 1331, 32, 29, "Output"],
Cell[157187, 2595, 148, 2, 28, "Output"],
Cell[157338, 2599, 131, 2, 30, "Output"],
Cell[157472, 2603, 88, 1, 30, "Output"]
}, Open  ]],
Cell[157575, 2607, 178, 5, 32, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[157778, 2616, 684, 11, 91, "Input"],
Cell[158465, 2629, 759, 15, 30, "Output"],
Cell[159227, 2646, 634, 13, 30, "Output"],
Cell[159864, 2661, 234, 5, 30, "Output"]
}, Open  ]],
Cell[160113, 2669, 184, 4, 32, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[160322, 2677, 645, 14, 123, "Input"],
Cell[160970, 2693, 2445, 64, 32, "Output"],
Cell[163418, 2759, 2445, 64, 28, "Output"],
Cell[165866, 2825, 2445, 64, 32, "Output"]
}, Open  ]],
Cell[168326, 2892, 99, 2, 32, "Text",
  Evaluatable->False],
Cell[168428, 2896, 265, 4, 59, "Input"],
Cell[168696, 2902, 122, 2, 32, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[168843, 2908, 1636, 44, 75, "Input"],
Cell[170482, 2954, 355, 9, 28, "Output"],
Cell[170840, 2965, 170, 4, 30, "Output"],
Cell[171013, 2971, 355, 9, 28, "Output"],
Cell[171371, 2982, 482, 12, 30, "Output"]
}, Open  ]],
Cell[171868, 2997, 115, 2, 32, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[172008, 3003, 157, 4, 59, "Input"],
Cell[172168, 3009, 222, 5, 32, "Output"],
Cell[172393, 3016, 407, 10, 28, "Output"],
Cell[172803, 3028, 534, 13, 32, "Output"]
}, Open  ]],
Cell[173352, 3044, 289, 8, 68, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[173666, 3056, 114, 2, 27, "Input"],
Cell[173783, 3060, 838, 19, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[174658, 3084, 114, 2, 27, "Input"],
Cell[174775, 3088, 866, 20, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[175678, 3113, 88, 1, 27, "Input"],
Cell[175769, 3116, 673, 17, 27, "Output"]
}, Open  ]],
Cell[176457, 3136, 115, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[176597, 3143, 184, 4, 27, "Input"],
Cell[176784, 3149, 1983, 42, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[178804, 3196, 188, 4, 27, "Input"],
Cell[178995, 3202, 1975, 42, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[181007, 3249, 157, 4, 27, "Input"],
Cell[181167, 3255, 618, 13, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[181822, 3273, 157, 4, 27, "Input"],
Cell[181982, 3279, 634, 13, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[182653, 3297, 181, 5, 27, "Input"],
Cell[182837, 3304, 958, 21, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[183832, 3330, 181, 5, 27, "Input"],
Cell[184016, 3337, 1028, 23, 30, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[185081, 3365, 214, 6, 27, "Input"],
Cell[185298, 3373, 1879, 41, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[187214, 3419, 214, 6, 27, "Input"],
Cell[187431, 3427, 1925, 43, 49, "Output"]
}, Open  ]],
Cell[189371, 3473, 261, 6, 50, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[189657, 3483, 91, 2, 27, "Input"],
Cell[189751, 3487, 2219, 46, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[192007, 3538, 66, 1, 27, "Input"],
Cell[192076, 3541, 181, 3, 21, "Message"],
Cell[192260, 3546, 2512, 53, 70, "Output"]
}, Open  ]],
Cell[194787, 3602, 75, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[194887, 3606, 55, 1, 27, "Input"],
Cell[194945, 3609, 182, 3, 21, "Message"],
Cell[195130, 3614, 48, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[195215, 3620, 110, 2, 27, "Input"],
Cell[195328, 3624, 185, 3, 21, "Message"],
Cell[195516, 3629, 1546, 35, 53, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[197099, 3669, 110, 2, 27, "Input"],
Cell[197212, 3673, 191, 3, 35, "Message"],
Cell[197406, 3678, 2400, 54, 53, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[199843, 3737, 86, 1, 27, "Input"],
Cell[199932, 3740, 197, 3, 35, "Message"],
Cell[200132, 3745, 4533, 99, 91, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[204714, 3850, 105, 2, 36, "Section",
  Evaluatable->False],
Cell[204822, 3854, 99, 3, 32, "Text"],
Cell[204924, 3859, 73687, 1135, 283, 73595, 1132, "GraphicsData", "PICT", \
"Graphics"],

Cell[CellGroupData[{
Cell[278636, 4998, 133, 3, 27, "Input"],
Cell[278772, 5003, 131, 2, 30, "Output"]
}, Open  ]],
Cell[278918, 5008, 92, 2, 32, "Text",
  Evaluatable->False],
Cell[279013, 5012, 586, 10, 91, "Input"],

Cell[CellGroupData[{
Cell[279624, 5026, 66, 1, 27, "Input"],
Cell[279693, 5029, 139, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[279869, 5037, 70, 1, 27, "Input"],
Cell[279942, 5040, 181, 3, 21, "Message"],
Cell[280126, 5045, 133, 3, 27, "Output"]
}, Open  ]],
Cell[280274, 5051, 130, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[280429, 5058, 126, 3, 27, "Input"],
Cell[280558, 5063, 160, 3, 21, "Message"],
Cell[280721, 5068, 2158, 39, 566, "Output"]
}, Open  ]],
Cell[282894, 5110, 105, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[283024, 5117, 50, 1, 27, "Input"],
Cell[283077, 5120, 184, 3, 21, "Message"],
Cell[283264, 5125, 1218, 28, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[284519, 5158, 50, 1, 27, "Input"],
Cell[284572, 5161, 190, 3, 21, "Message"],
Cell[284765, 5166, 1218, 28, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[286020, 5199, 137, 3, 27, "Input"],
Cell[286160, 5204, 186, 3, 21, "Message"],
Cell[286349, 5209, 1519, 36, 67, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[287905, 5250, 50, 1, 27, "Input"],
Cell[287958, 5253, 3162, 67, 99, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[291157, 5325, 50, 1, 27, "Input"],
Cell[291210, 5328, 181, 3, 21, "Message"],
Cell[291394, 5333, 3166, 67, 99, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[294597, 5405, 161, 3, 27, "Input"],
Cell[294761, 5410, 188, 3, 21, "Message"],
Cell[294952, 5415, 3743, 80, 111, "Output"]
}, Open  ]],
Cell[298710, 5498, 168, 4, 32, "Text"],

Cell[CellGroupData[{
Cell[298903, 5506, 132, 2, 27, "Input"],
Cell[299038, 5510, 158, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[299233, 5517, 156, 3, 27, "Input"],
Cell[299392, 5522, 184, 3, 21, "Message"],
Cell[299579, 5527, 1243, 29, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[300859, 5561, 159, 3, 27, "Input"],
Cell[301021, 5566, 186, 3, 21, "Message"],
Cell[301210, 5571, 3378, 71, 83, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[304637, 5648, 109, 2, 36, "Section",
  Evaluatable->False],
Cell[304749, 5652, 260, 6, 50, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[305034, 5662, 124, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[305183, 5668, 135, 3, 27, "Input"],
Cell[305321, 5673, 86807, 1695, 1425, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[392165, 7373, 114, 2, 27, "Input"],
Cell[392282, 7377, 16191, 345, 279, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[408510, 7727, 114, 2, 27, "Input"],
Cell[408627, 7731, 2892, 66, 69, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[411556, 7802, 93, 2, 27, "Input"],
Cell[411652, 7806, 23831, 510, 669, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[435520, 8321, 93, 2, 27, "Input"],
Cell[435616, 8325, 4004, 91, 101, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[439657, 8421, 93, 2, 27, "Input"],
Cell[439753, 8425, 2653, 61, 83, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[442443, 8491, 88, 1, 27, "Input"],
Cell[442534, 8494, 1909, 41, 61, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[444480, 8540, 88, 1, 27, "Input"],
Cell[444571, 8543, 1463, 34, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[446071, 8582, 55, 1, 27, "Input"],
Cell[446129, 8585, 134, 3, 27, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[446312, 8594, 124, 2, 28, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[446461, 8600, 136, 3, 27, "Input"],
Cell[446600, 8605, 183, 3, 21, "Message"],
Cell[446786, 8610, 65242, 1293, 979, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[512065, 9908, 115, 2, 27, "Input"],
Cell[512183, 9912, 183, 3, 21, "Message"],
Cell[512369, 9917, 16191, 345, 279, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[528597, 10267, 115, 2, 27, "Input"],
Cell[528715, 10271, 183, 3, 21, "Message"],
Cell[528901, 10276, 2892, 66, 69, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[531830, 10347, 57, 1, 27, "Input"],
Cell[531890, 10350, 183, 3, 21, "Message"],
Cell[532076, 10355, 1687, 36, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[533800, 10396, 93, 2, 27, "Input"],
Cell[533896, 10400, 12400, 265, 330, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[546333, 10670, 93, 2, 27, "Input"],
Cell[546429, 10674, 4004, 91, 101, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[550470, 10770, 93, 2, 27, "Input"],
Cell[550566, 10774, 2653, 61, 83, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[553256, 10840, 67, 1, 27, "Input"],
Cell[553326, 10843, 1397, 34, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[554760, 10882, 83, 1, 27, "Input"],
Cell[554846, 10885, 183, 3, 21, "Message"],
Cell[555032, 10890, 1454, 33, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[556523, 10928, 85, 1, 27, "Input"],
Cell[556611, 10931, 183, 3, 21, "Message"],
Cell[556797, 10936, 1459, 33, 45, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[558305, 10975, 127, 2, 28, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[558457, 10981, 218, 4, 27, "Input"],
Cell[558678, 10987, 188, 3, 21, "Message"],
Cell[558869, 10992, 80619, 1592, 1296, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[639525, 12589, 195, 3, 27, "Input"],
Cell[639723, 12594, 188, 3, 21, "Message"],
Cell[639914, 12599, 16191, 345, 279, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[656142, 12949, 195, 3, 27, "Input"],
Cell[656340, 12954, 188, 3, 21, "Message"],
Cell[656531, 12959, 2892, 66, 69, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[659460, 13030, 133, 2, 27, "Input"],
Cell[659596, 13034, 188, 3, 21, "Message"],
Cell[659787, 13039, 5430, 113, 152, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[665254, 13157, 130, 3, 27, "Input"],
Cell[665387, 13162, 188, 3, 21, "Message"],
Cell[665578, 13167, 550, 14, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[666165, 13186, 130, 3, 27, "Input"],
Cell[666298, 13191, 188, 3, 21, "Message"],
Cell[666489, 13196, 568, 14, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[667094, 13215, 93, 2, 27, "Input"],
Cell[667190, 13219, 24695, 520, 740, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[691922, 13744, 93, 2, 27, "Input"],
Cell[692018, 13748, 4004, 91, 101, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[696059, 13844, 93, 2, 27, "Input"],
Cell[696155, 13848, 2653, 61, 83, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[698845, 13914, 67, 1, 27, "Input"],
Cell[698915, 13917, 5399, 114, 167, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[704351, 14036, 69, 1, 27, "Input"],
Cell[704423, 14039, 550, 14, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[705010, 14058, 69, 1, 27, "Input"],
Cell[705082, 14061, 633, 17, 29, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[705764, 14084, 120, 2, 28, "Subsubsection",
  Evaluatable->False],
Cell[705887, 14088, 245, 5, 50, "Text"],

Cell[CellGroupData[{
Cell[706157, 14097, 212, 3, 27, "Input"],
Cell[706372, 14102, 799214, 12962, 25638, "Output"]
}, Closed]],
Cell[1505601, 27067, 101, 3, 29, "Text"],

Cell[CellGroupData[{
Cell[1505727, 27074, 162, 2, 27, "Input"],
Cell[1505892, 27078, 3856, 85, 149, "Output"]
}, Open  ]],
Cell[1509763, 27166, 53, 1, 27, "Input"],
Cell[1509819, 27169, 108, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[1509952, 27176, 74, 1, 27, "Input"],
Cell[1510029, 27179, 385907, 6411, 12817, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1895997, 33597, 86, 2, 36, "Section",
  Evaluatable->False],
Cell[1896086, 33601, 317, 6, 68, "Text"],
Cell[1896406, 33609, 288, 10, 32, "Text",
  Evaluatable->False],
Cell[1896697, 33621, 73687, 1135, 283, 73595, 1132, "GraphicsData", "PICT", \
"Graphics"],

Cell[CellGroupData[{
Cell[1970409, 34760, 1449, 36, 628, "Input"],
Cell[1971861, 34798, 181, 3, 21, "Message"]
}, Open  ]],
Cell[1972057, 34804, 141, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[1972223, 34811, 337, 7, 123, "Input"],
Cell[1972563, 34820, 125, 2, 21, "Message"],
Cell[1972691, 34824, 125, 2, 21, "Message"],
Cell[1972819, 34828, 125, 2, 21, "Message"],
Cell[1972947, 34832, 125, 2, 21, "Message"],
Cell[1973075, 34836, 123, 2, 21, "Message"],
Cell[1973201, 34840, 123, 2, 21, "Message"]
}, Open  ]],
Cell[1973339, 34845, 159, 5, 32, "Text",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1973523, 34854, 1459, 32, 347, "Input"],
Cell[1974985, 34888, 35, 1, 27, "Output"],
Cell[1975023, 34891, 57, 1, 27, "Output"],
Cell[1975083, 34894, 35, 1, 27, "Output"],
Cell[1975121, 34897, 53, 1, 27, "Output"]
}, Open  ]],
Cell[1975189, 34901, 226, 6, 32, "Text",
  Evaluatable->False],
Cell[1975418, 34909, 12604, 233, 2297, "Input"],
Cell[1988025, 35144, 112, 2, 32, "Text",
  Evaluatable->False],
Cell[1988140, 35148, 73687, 1135, 283, 73595, 1132, "GraphicsData", "PICT", \
"Graphics"],

Cell[CellGroupData[{
Cell[2061852, 36287, 110, 2, 27, "Input"],
Cell[2061965, 36291, 224, 3, 35, "Message"],
Cell[2062192, 36296, 32452, 861, 186, 8399, 560, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2094647, 37159, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2094814, 37167, 84, 1, 27, "Input"],
Cell[2094901, 37170, 224, 3, 35, "Message"],
Cell[2095128, 37175, 27465, 793, 186, 8193, 551, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2122596, 37970, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2122763, 37978, 84, 1, 27, "Input"],
Cell[2122850, 37981, 224, 3, 35, "Message"],
Cell[2123077, 37986, 22827, 633, 186, 6267, 424, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2145907, 38621, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2146074, 38629, 84, 1, 27, "Input"],
Cell[2146161, 38632, 224, 3, 35, "Message"],
Cell[2146388, 38637, 26086, 795, 186, 8561, 574, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2172477, 39434, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2172644, 39442, 83, 1, 27, "Input"],
Cell[2172730, 39445, 224, 3, 35, "Message"],
Cell[2172957, 39450, 23696, 629, 186, 5890, 405, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2196656, 40081, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2196823, 40089, 83, 1, 27, "Input"],
Cell[2196909, 40092, 224, 3, 35, "Message"],
Cell[2197136, 40097, 25083, 577, 186, 4740, 321, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2222222, 40676, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2222389, 40684, 113, 2, 27, "Input"],
Cell[2222505, 40688, 224, 3, 35, "Message"],
Cell[2222732, 40693, 224, 3, 35, "Message"],
Cell[2222959, 40698, 18990, 505, 186, 4693, 324, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2241952, 41205, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2242119, 41213, 82, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[2242204, 41217, 362, 8, 68, "Text",
  Evaluatable->False],
Cell[2242569, 41227, 73687, 1135, 283, 73595, 1132, "GraphicsData", "PICT", \
"Graphics"],

Cell[CellGroupData[{
Cell[2316281, 42366, 7464, 148, 1808, "Input"],

Cell[CellGroupData[{
Cell[2323770, 42518, 25410, 573, 284, 4027, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2349183, 43093, 25410, 573, 284, 4027, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2374596, 43668, 25410, 573, 284, 4027, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2400009, 44243, 25410, 573, 284, 4027, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2425422, 44818, 25409, 573, 284, 4026, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2450834, 45393, 25409, 573, 284, 4026, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2476246, 45968, 25408, 573, 284, 4025, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2501657, 46543, 25407, 573, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2527067, 47118, 25406, 573, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2552476, 47693, 25406, 573, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2577885, 48268, 25395, 572, 284, 4021, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2603283, 48842, 25394, 572, 284, 4020, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2628680, 49416, 25260, 571, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2653943, 49989, 25261, 571, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2679207, 50562, 25248, 571, 284, 4011, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2704458, 51135, 25274, 571, 284, 4017, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2729735, 51708, 25303, 571, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2755041, 52281, 25279, 571, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2780323, 52854, 25291, 571, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2805617, 53427, 25241, 570, 284, 4025, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2830861, 53999, 25193, 570, 284, 4025, 302, "GraphicsData", "PostScript",
   "Graphics",
  Evaluatable->False],
Cell[2856057, 54571, 25199, 570, 284, 4019, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2881259, 55143, 25141, 569, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2906403, 55714, 25229, 570, 284, 4021, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2931635, 56286, 25180, 570, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2956818, 56858, 25072, 568, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[2981893, 57428, 25148, 569, 284, 4017, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3007044, 57999, 25090, 569, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3032137, 58570, 25141, 569, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3057281, 59141, 25092, 569, 284, 4025, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3082376, 59712, 25039, 568, 284, 4025, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3107418, 60282, 25068, 568, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3132489, 60852, 25027, 568, 284, 4009, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3157519, 61422, 25065, 568, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3182587, 61992, 25009, 568, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3207599, 62562, 24934, 567, 284, 4017, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3232536, 63131, 24945, 567, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3257484, 63700, 24883, 566, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3282370, 64268, 24764, 565, 284, 4017, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3307137, 64835, 24778, 565, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3331918, 65402, 24752, 564, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3356673, 65968, 24845, 566, 284, 4017, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3381521, 66536, 24803, 565, 284, 4020, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3406327, 67103, 24708, 564, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3431038, 67669, 24758, 565, 284, 4019, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3455799, 68236, 24971, 567, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3480773, 68805, 25022, 568, 284, 4020, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3505798, 69375, 25147, 569, 284, 4020, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3530948, 69946, 25260, 571, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3556211, 70519, 25580, 575, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3581794, 71096, 25586, 575, 284, 4013, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3607383, 71673, 25729, 577, 284, 4010, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3633115, 72252, 26182, 582, 284, 4010, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3659300, 72836, 26603, 587, 284, 4014, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3685906, 73425, 26884, 591, 284, 4019, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3712793, 74018, 27041, 593, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3739837, 74613, 26915, 591, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3766755, 75206, 26510, 586, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3793268, 75794, 26164, 582, 284, 4020, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3819435, 76378, 26167, 582, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3845605, 76962, 26322, 584, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3871930, 77548, 25497, 574, 284, 4021, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3897430, 78124, 25305, 571, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3922738, 78697, 25466, 573, 284, 4019, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3948207, 79272, 25664, 576, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3973874, 79850, 25555, 574, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[3999432, 80426, 25709, 576, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4025144, 81004, 25991, 580, 284, 4021, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4051138, 81586, 25831, 578, 284, 4019, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4076972, 82166, 25984, 580, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4102959, 82748, 26553, 587, 284, 4020, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4129515, 83337, 26425, 585, 284, 4014, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4155943, 83924, 26779, 589, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4182725, 84515, 27367, 597, 284, 4016, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4210095, 85114, 25851, 578, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4235949, 85694, 26231, 583, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4262183, 86279, 25889, 578, 284, 4025, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4288075, 86859, 25463, 573, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4313541, 87434, 25369, 572, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4338913, 88008, 25182, 570, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4364098, 88580, 25076, 569, 284, 4017, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4389177, 89151, 25218, 570, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4414398, 89723, 25315, 571, 284, 4022, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4439716, 90296, 25475, 574, 284, 4011, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4465194, 90872, 25592, 575, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4490789, 91449, 25699, 576, 284, 4021, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4516491, 92027, 26341, 584, 284, 4023, 302, "GraphicsData", "PostScript",
   "Graphics",
  Evaluatable->False],
Cell[4542835, 92613, 26490, 586, 284, 4026, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4569328, 93201, 26556, 587, 284, 4019, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4595887, 93790, 26268, 583, 284, 4019, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4622158, 94375, 25622, 575, 284, 4025, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4647783, 94952, 25955, 579, 284, 4014, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4673741, 95533, 25901, 579, 284, 4024, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4699645, 96114, 26113, 581, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4725761, 96697, 26089, 581, 284, 4018, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4751853, 97280, 26768, 589, 284, 4013, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4778624, 97871, 27079, 593, 284, 4016, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4805706, 98466, 25918, 579, 284, 4021, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4831627, 99047, 25896, 579, 284, 4023, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False],
Cell[4857526, 99628, 25833, 578, 284, 4021, 302, "GraphicsData", \
"PostScript", "Graphics",
  Evaluatable->False]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

