(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   3839743,      88036]*)
(*NotebookOutlinePosition[   3840573,      88064]*)
(*  CellTagsIndexPosition[   3840529,      88060]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData["Run this first"], "Section"],

Cell[TextData[
"This is just the needed equations with no other stuff.  Run this first.  \
Then proceed by running the solve interpret section over and over again.  \
First I'll turm off spelling warnings."], "Text"],

Cell[BoxData[{
    \(Off[General::"\<spell1\>"]\), 
    \(Off[General::"\<spell\>"]\)}], "Input"],

Cell[CellGroupData[{

Cell[TextData[
"Input the definitions for the vector operations"], "Subsubsection"],

Cell[TextData[
"Input the vector definition with the command that follows.  The path will \
depend on where  the definitions reside on the local system."], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(<< "\</Volumes/Users/alan/Book/Rev2004/dynmath/math3/vectors3\>"\)], 
  "Input"],

Cell[TextData[
"These Engineering Vector algorithms are copyright Alan A. Barhorst"], "Print"]
}, Open  ]],

Cell[TextData[
"Define Unit Vectors and Unit Dyads for however many frames we need for the \
system. For this example we will use five frames of reference as shown.  "], 
  "Text"],

Cell[BoxData[{
    \(a[x_] := unitVector[A, a, x]\), 
    \(b[x_] := unitVector[B, b, x]\), 
    \(c[x_] := unitVector[C, c, x]\), 
    \(d[x_] := unitVector[D, d, x]\), 
    \(n[x_] := unitVector[N, n, x]\)}], "Input"],

Cell[TextData[
"Define fixed relationships between the frames of reference.   Note: these \
are different for different base orientations of the frames. "], "Text"],

Cell[BoxData[{
    \(\(Unprotect[Dot]; \)\), 
    \(a[3].n[1] := 0\), 
    \(a[3].n[2] := 0\), 
    \(a[3].n[3] := \(-1\)\), 
    \(a[3].b[1] := 0\), 
    \(a[3].b[2] := 0\), 
    \(a[3].b[3] := 1\), 
    \(a[3].c[1] := 0\), 
    \(a[3].c[2] := 0\), 
    \(a[3].c[3] := 1\), 
    \(a[3].d[1] := 0\), 
    \(a[3].d[2] := 0\), 
    \(a[3].d[3] := 1\), 
    \(b[3].n[1] := 0\), 
    \(b[3].n[2] := 0\), 
    \(b[3].n[3] := \(-1\)\), 
    \(b[3].a[1] := 0\), 
    \(b[3].a[2] := 0\), 
    \(b[3].c[1] := 0\), 
    \(b[3].c[2] := 0\), 
    \(b[3].c[3] := 1\), 
    \(b[3].d[1] := 0\), 
    \(b[3].d[2] := 0\), 
    \(b[3].d[3] := 1\), 
    \(c[3].n[1] := 0\), 
    \(c[3].n[2] := 0\), 
    \(c[3].n[3] := \(-1\)\), 
    \(c[3].a[1] := 0\), 
    \(c[3].a[2] := 0\), 
    \(c[3].b[1] := 0\), 
    \(c[3].b[2] := 0\), 
    \(c[3].d[1] := 0\), 
    \(c[3].d[2] := 0\), 
    \(c[3].d[3] := 1\), 
    \(d[3].n[1] := 0\), 
    \(d[3].n[2] := 0\), 
    \(d[3].n[3] := \(-1\)\), 
    \(n[3].a[1] := 0\), 
    \(n[3].a[2] := 0\), 
    \(n[3].b[1] := 0\), 
    \(n[3].b[2] := 0\), 
    \(n[3].c[1] := 0\), 
    \(n[3].c[2] := 0\), 
    \(n[3].d[1] := 0\), 
    \(n[3].d[2] := 0\), 
    \(\(Protect[Dot]; \)\), 
    \(\(Unprotect[Cross]; \)\), 
    \(a[3]\[Cross]b[1] := b[2]\), 
    \(a[3]\[Cross]b[2] := \(-b[1]\)\), 
    \(a[3]\[Cross]c[1] := c[2]\), 
    \(a[3]\[Cross]c[2] := \(-c[1]\)\), 
    \(a[3]\[Cross]d[1] := d[2]\), 
    \(a[3]\[Cross]d[2] := \(-d[1]\)\), 
    \(a[3]\[Cross]n[1] := \(-n[2]\)\), 
    \(a[3]\[Cross]n[2] := n[1]\), 
    \(b[3]\[Cross]a[1] := a[2]\), 
    \(b[3]\[Cross]a[2] := \(-a[1]\)\), 
    \(b[3]\[Cross]c[1] := c[2]\), 
    \(b[3]\[Cross]c[2] := \(-c[1]\)\), 
    \(b[3]\[Cross]d[1] := d[2]\), 
    \(b[3]\[Cross]d[2] := \(-d[1]\)\), 
    \(b[3]\[Cross]n[1] := \(-n[2]\)\), 
    \(b[3]\[Cross]n[2] := n[1]\), 
    \(c[3]\[Cross]a[1] := a[2]\), 
    \(c[3]\[Cross]a[2] := \(-a[1]\)\), 
    \(c[3]\[Cross]b[1] := b[2]\), 
    \(c[3]\[Cross]b[2] := \(-b[1]\)\), 
    \(c[3]\[Cross]d[1] := d[2]\), 
    \(c[3]\[Cross]d[2] := \(-d[1]\)\), 
    \(c[3]\[Cross]n[1] := \(-n[2]\)\), 
    \(c[3]\[Cross]n[2] := n[1]\), 
    \(d[3]\[Cross]a[1] := a[2]\), 
    \(d[3]\[Cross]a[2] := \(-a[1]\)\), 
    \(d[3]\[Cross]b[1] := b[2]\), 
    \(d[3]\[Cross]b[2] := \(-b[1]\)\), 
    \(d[3]\[Cross]c[1] := c[2]\), 
    \(d[3]\[Cross]c[2] := \(-c[1]\)\), 
    \(d[3]\[Cross]n[1] := \(-n[2]\)\), 
    \(d[3]\[Cross]n[2] := n[1]\), 
    \(n[3]\[Cross]a[1] := \(-a[2]\)\), 
    \(n[3]\[Cross]a[2] := a[1]\), 
    \(n[3]\[Cross]a[3] := 0\), 
    \(n[3]\[Cross]b[1] := \(-b[2]\)\), 
    \(n[3]\[Cross]b[2] := b[1]\), 
    \(n[3]\[Cross]b[3] := 0\), 
    \(n[3]\[Cross]c[1] := \(-c[2]\)\), 
    \(n[3]\[Cross]c[2] := c[1]\), 
    \(n[3]\[Cross]c[3] := 0\), 
    \(n[3]\[Cross]d[1] := \(-d[2]\)\), 
    \(n[3]\[Cross]d[2] := d[1]\), 
    \(n[3]\[Cross]d[3] := 0\), 
    \(\(Protect[Cross]; \)\)}], "Input"],

Cell[BoxData[
    \(transform[x_] := 
      x //. {d[1] \[Rule] Cos[q3[t]]\ c[1] + Sin[q3[t]]\ c[2], 
          d[2] \[Rule] \(-Sin[q3[t]]\)\ c[1] + Cos[q3[t]]\ c[2], 
          c[1] \[Rule] Cos[q2[t]]\ b[1] + Sin[q2[t]]\ b[2], 
          c[2] \[Rule] \(-Sin[q2[t]]\)\ b[1] + Cos[q2[t]]\ b[2], 
          a[1] \[Rule] Cos[q4[t]]\ b[1] + Sin[q4[t]]\ b[2], 
          a[2] \[Rule] \(-Sin[q4[t]]\)\ b[1] + Cos[q4[t]]\ b[2], 
          b[1] \[Rule] \(-Cos[q1[t]]\)\ n[1] + Sin[q1[t]]\ n[2], 
          b[2] \[Rule] Sin[q1[t]]\ n[1] + Cos[q1[t]]\ n[2]}\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Constraints"], "Subsubsection"],

Cell[BoxData[
    \(\(solq4x
       = {{x[t] \[Rule] 
            \(-l2\)\ Cos[q1[t]] - 
              1\/2\ \[Sqrt]\((
                    \( - 2\)\ 
                        \((2\ H\^2 + l2\^2 - 2\ l3\^2 - 
                            l2\^2\ Cos[2\ q1[t]] + 4\ H\ l2\ Sin[q1[t]])\) + 
                      8\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 4\ y[t]\^2)\), 
          q4[t] \[Rule] 
            \(-ArcCos[
                1\/l3\((
                  \(-H\)\ Sin[q1[t]] - l2\ Sin[q1[t]]\^2 + Sin[q1[t]]\ y[t] + 
                    \(1\/\@2\((
                      Cos[q1[t]]\ 
                        \[Sqrt]\((
                            \( - 2\)\ H\^2 - l2\^2 + 2\ l3\^2 + 
                              l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 
                              4\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 2\ y[t]\^2)
                            \))\)\))\)]\)}, {
          x[t] \[Rule] 
            \(-l2\)\ Cos[q1[t]] - 
              1\/2\ \[Sqrt]\((
                    \( - 2\)\ 
                        \((2\ H\^2 + l2\^2 - 2\ l3\^2 - 
                            l2\^2\ Cos[2\ q1[t]] + 4\ H\ l2\ Sin[q1[t]])\) + 
                      8\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 4\ y[t]\^2)\), 
          q4[t] \[Rule] 
            ArcCos[1\/l3\((
                \(-H\)\ Sin[q1[t]] - l2\ Sin[q1[t]]\^2 + Sin[q1[t]]\ y[t] + 
                  \(1\/\@2\((
                    Cos[q1[t]]\ 
                      \[Sqrt]\((
                          \( - 2\)\ H\^2 - l2\^2 + 2\ l3\^2 + 
                            l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 
                            4\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 2\ y[t]\^2)\))
                    \)\))\)]}, {
          x[t] \[Rule] 
            \(-l2\)\ Cos[q1[t]] + 
              \[Sqrt]\((
                  \(-H\^2\) - l2\^2\/2 + l3\^2 + 1\/2\ l2\^2\ Cos[2\ q1[t]] - 
                    2\ H\ l2\ Sin[q1[t]] + 
                    2\ \((H + l2\ Sin[q1[t]])\)\ y[t] - y[t]\^2)\), 
          q4[t] \[Rule] 
            \(-ArcCos[
                \(-\(1\/l3\((
                    H\ Sin[q1[t]] + l2\ Sin[q1[t]]\^2 - Sin[q1[t]]\ y[t] + 
                      \(1\/\@2\((
                        Cos[q1[t]]\ 
                          \[Sqrt]\((
                              \( - 2\)\ H\^2 - l2\^2 + 2\ l3\^2 + 
                                l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 
                                4\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 
                                2\ y[t]\^2)\))\)\))\)\)\)]\)}, {
          x[t] \[Rule] 
            \(-l2\)\ Cos[q1[t]] + 
              \[Sqrt]\((
                  \(-H\^2\) - l2\^2\/2 + l3\^2 + 1\/2\ l2\^2\ Cos[2\ q1[t]] - 
                    2\ H\ l2\ Sin[q1[t]] + 
                    2\ \((H + l2\ Sin[q1[t]])\)\ y[t] - y[t]\^2)\), 
          q4[t] \[Rule] 
            ArcCos[\(-
                \(1\/l3\((
                  H\ Sin[q1[t]] + l2\ Sin[q1[t]]\^2 - Sin[q1[t]]\ y[t] + 
                    \(1\/\@2\((
                      Cos[q1[t]]\ 
                        \[Sqrt]\((
                            \( - 2\)\ H\^2 - l2\^2 + 2\ l3\^2 + 
                              l2\^2\ Cos[2\ q1[t]] - 4\ H\ l2\ Sin[q1[t]] + 
                              4\ \((H + l2\ Sin[q1[t]])\)\ y[t] - 2\ y[t]\^2)
                            \))\)\))\)\)\)]}}; \)\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"solDq4x", "=", 
        RowBox[{"{", 
          RowBox[{"{", 
            RowBox[{
              RowBox[{
                RowBox[{
                  SuperscriptBox["x", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
                RowBox[{
                  RowBox[{
                  \(-l2\), " ", \(Sec[q1[t] + q4[t]]\), " ", \(Sin[q4[t]]\), 
                    " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{\(Tan[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["y", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}]}], ",", 
              
              RowBox[{
                RowBox[{
                  SuperscriptBox["q4", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
                RowBox[{\(1\/l3\), 
                  RowBox[{"(", 
                    RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                          \(-\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\)\), 
                            " ", 
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{
                            SuperscriptBox["y", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}]}], ")"}]}]}]}], "}"}], "}"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Dragging sets of equations of motion"], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom1d", "=", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
            \(d1\ g\ mb\ Cos[q4[t]]\), "+", \(g\ l1\ mc\ Cos[q4[t]]\), "+", 
              \(g\ l1\ md\ Cos[q4[t]]\), "+", 
              \(d1\ g\ mb\ Cos[2\ q1[t] + q4[t]]\), "+", 
              \(g\ l1\ mc\ Cos[2\ q1[t] + q4[t]]\), "+", 
              \(g\ l1\ md\ Cos[2\ q1[t] + q4[t]]\), "+", 
              RowBox[{
              "2", " ", "l1", " ", \((
                \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                  d3\ md\ Cos[q2[t] + q3[t]])\), " ", \(Cos[q1[t] + q4[t]]\), 
                " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"2", " ", "dB", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "d2", " ", "l1", " ", "mc", " ", \(Cos[q1[t] - q2[t] + q4[t]]\),
                 " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "l1", " ", "l4", " ", "md", " ", \(Cos[q1[t] - q2[t] + q4[t]]\),
                 " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "d2", " ", "l1", " ", "mc", " ", \(Cos[q1[t] + q2[t] + q4[t]]\),
                 " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "l1", " ", "l4", " ", "md", " ", \(Cos[q1[t] + q2[t] + q4[t]]\),
                 " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"2", " ", "dC", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"4", " ", "l1", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                    \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                          d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "d3", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}]}], "-", 
              RowBox[{"2", " ", "B33", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "2", " ", \(d1\^2\), " ", "mb", " ", \(Cos[q1[t] + q4[t]]\), 
                " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "2", " ", \(l1\^2\), " ", "mc", " ", \(Cos[q1[t] + q4[t]]\), 
                " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "2", " ", \(l1\^2\), " ", "md", " ", \(Cos[q1[t] + q4[t]]\), 
                " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] - q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] - q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] + q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] + q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] - q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] - q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "d2", " ", "l1", " ", "mc", " ", \(Sin[q1[t] + q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "l1", " ", "l4", " ", "md", " ", \(Sin[q1[t] + q2[t] + q4[t]]\),
                 " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"2", " ", "d1", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"2", " ", "l2", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"2", " ", "d1", " ", "mh", " ", \(Sin[q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"2", " ", "l2", " ", "mh", " ", \(Sin[q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                  \(\(-2\)\ d1\ g\ ma\ \[Mu]\ Sin[q4[t]]\), "+", 
                    \(2\ g\ l2\ ma\ \[Mu]\ Sin[q4[t]]\), "-", 
                    \(d1\ g\ mb\ \[Mu]\ Sin[q4[t]]\), "-", 
                    \(g\ l1\ mc\ \[Mu]\ Sin[q4[t]]\), "-", 
                    \(g\ l1\ md\ \[Mu]\ Sin[q4[t]]\), "-", 
                    \(2\ d1\ g\ mh\ \[Mu]\ Sin[q4[t]]\), "+", 
                    \(2\ g\ l2\ mh\ \[Mu]\ Sin[q4[t]]\), "-", 
                    \(d1\ g\ mb\ \[Mu]\ Sin[2\ q1[t] + q4[t]]\), "-", 
                    \(g\ l1\ mc\ \[Mu]\ Sin[2\ q1[t] + q4[t]]\), "-", 
                    \(g\ l1\ md\ \[Mu]\ Sin[2\ q1[t] + q4[t]]\), "-", 
                    RowBox[{
                    "2", " ", "l1", " ", "\[Mu]", " ", \((
                      \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                      \(Sin[q1[t] + q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{
                    "2", " ", "l1", " ", "\[Mu]", " ", \((
                      \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                      \(Sin[q1[t] + q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q2", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{
                    "2", " ", "dC", " ", "\[Mu]", " ", \(Sin[q1[t] + q4[t]]\),
                       " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q3", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q3", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{
                    "4", " ", "l1", " ", "\[Mu]", " ", \(Sin[q1[t] + q4[t]]\),
                       " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                          \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                            RowBox[{
                              SuperscriptBox["q2", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{
                          "d3", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q3", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         ")"}]}], "+", 
                    RowBox[{
                    "2", " ", "\[Mu]", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], " ", 
                      RowBox[{"(", 
                        RowBox[{"dB", "-", 
                          RowBox[{
                          "2", " ", "d3", " ", "l1", " ", "md", " ", 
                            \(Cos[q2[t] + q3[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q3", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         ")"}]}], "-", 
                    RowBox[{
                    "2", " ", "Aa", " ", "Cd", " ", "d1", " ", \(Sin[q4[t]]\),
                       " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["x", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "+", 
                    RowBox[{
                    "2", " ", "Aa", " ", "Cd", " ", "l2", " ", \(Sin[q4[t]]\),
                       " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["x", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{
                    "2", " ", "Aa", " ", "Cd", " ", "d1", " ", "\[Mu]", " ", 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "]"}], 
                      " ", \(Sin[q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "+", 
                    RowBox[{
                    "2", " ", "Aa", " ", "Cd", " ", "l2", " ", "\[Mu]", " ", 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "]"}], 
                      " ", \(Sin[q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["y", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{
                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "2", " ", "B33", " ", "\[Mu]", " ", 
                      \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "2", " ", \(d1\^2\), " ", "mb", " ", "\[Mu]", " ", 
                      \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "2", " ", \(l1\^2\), " ", "mc", " ", "\[Mu]", " ", 
                      \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "2", " ", \(l1\^2\), " ", "md", " ", "\[Mu]", " ", 
                      \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", " ", 
                      \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "2", " ", "d1", " ", "ma", " ", "\[Mu]", " ", 
                      \(Sin[q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["y", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "2", " ", "l2", " ", "ma", " ", "\[Mu]", " ", 
                      \(Sin[q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["y", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{
                    "2", " ", "d1", " ", "mh", " ", "\[Mu]", " ", 
                      \(Sin[q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["y", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "2", " ", "l2", " ", "mh", " ", "\[Mu]", " ", 
                      \(Sin[q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["y", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}]}]}], ")"}], "/", 
          RowBox[{"(", 
            RowBox[{"2", " ", 
              RowBox[{"(", 
                RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                  RowBox[{"\[Mu]", " ", 
                    RowBox[{"Sign", "[", 
                      RowBox[{
                        SuperscriptBox["x", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "]"}], 
                    " ", \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], ")"}]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom2d", "=", 
        RowBox[{
        \(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), "-", 
          \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
          RowBox[{
          \((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - d3\ l4\ md\ Sin[q3[t]])
              \), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dC", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "+", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], "+",
           
          RowBox[{"dD", " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"C33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(d2\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(l4\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"C33", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(d2\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(l4\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], ";"}]], 
  "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom3d", "=", 
        RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
          RowBox[{
          "d3", " ", "md", " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\),
             " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dD", " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], ";"}]], 
  "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom4d", "=", 
        RowBox[{
          RowBox[{"-", 
            RowBox[{
              SuperscriptBox["q4", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(1\/l3\), 
            RowBox[{"(", 
              RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "+", 
                    RowBox[{
                    "2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q4", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "-", 
                    RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "-", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                      SuperscriptBox["y", "\[DoublePrime]",
                        MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], 
              ")"}]}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom5d", "=", 
        RowBox[{
          RowBox[{"-", 
            RowBox[{
              SuperscriptBox["x", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(Sec[q1[t] + q4[t]]\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"2", " ", "l3", " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{"l2", " ", \(Sin[q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{\(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["y", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], 
              ")"}]}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom6d", "=", 
        RowBox[{
          SuperscriptBox["y", "\[DoublePrime]",
            MultilineFunction->None], "[", "t", "]"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Swinging sets of equations of motion"], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom1s", "=", 
        RowBox[{\(1\/2\), " ", 
          RowBox[{"(", 
            RowBox[{
            \(d1\ g\ ma\ Cos[q1[t]]\), "-", \(g\ l2\ ma\ Cos[q1[t]]\), "+", 
              \(2\ d1\ g\ mb\ Cos[q1[t]]\), "+", \(2\ g\ l1\ mc\ Cos[q1[t]]\),
               "+", \(2\ g\ l1\ md\ Cos[q1[t]]\), "+", 
              \(d1\ g\ mh\ Cos[q1[t]]\), "-", \(g\ l2\ mh\ Cos[q1[t]]\), "-", 
              \(d1\ g\ ma\ Cos[q1[t] + 2\ q4[t]]\), "+", 
              \(g\ l2\ ma\ Cos[q1[t] + 2\ q4[t]]\), "-", 
              \(d1\ g\ mh\ Cos[q1[t] + 2\ q4[t]]\), "+", 
              \(g\ l2\ mh\ Cos[q1[t] + 2\ q4[t]]\), "+", 
              RowBox[{
              "2", " ", "l1", " ", \((
                \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                  d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "2", " ", "l1", " ", \((
                \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                  d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"2", " ", "dC", " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q2[t] + q3[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"4", " ", "l1", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                    \((\((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                          d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "d3", " ", "md", " ", \(Cos[q2[t] + q3[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}]}], "-", 
              RowBox[{"2", " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{"(", 
                  RowBox[{"dB", "-", 
                    RowBox[{
                    "2", " ", "d3", " ", "l1", " ", "md", " ", 
                      \(Cos[q2[t] + q3[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}]}], "+", 
              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                \(Sin[q1[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                \(Sin[q1[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(Cos[q1[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(Cos[q1[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "d1", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ",
                 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "l2", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ",
                 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"2", " ", "B33", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"2", " ", \(d1\^2\), " ", "mb", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"2", " ", \(l1\^2\), " ", "mc", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"2", " ", \(l1\^2\), " ", "md", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q2[t] + q3[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q2[t] + q3[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "2", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q2[t] + q3[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"d1", " ", "ma", " ", \(Sin[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"l2", " ", "ma", " ", \(Sin[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"d1", " ", "mh", " ", \(Sin[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"l2", " ", "mh", " ", \(Sin[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"d1", " ", "ma", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l2", " ", "ma", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"d1", " ", "mh", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l2", " ", "mh", " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["x", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"d1", " ", "ma", " ", \(Cos[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"l2", " ", "ma", " ", \(Cos[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"d1", " ", "mh", " ", \(Cos[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"l2", " ", "mh", " ", \(Cos[q1[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"d1", " ", "ma", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l2", " ", "ma", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"d1", " ", "mh", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"l2", " ", "mh", " ", \(Cos[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom2s", "=", 
        RowBox[{
        \(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), "-", 
          \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
          RowBox[{
          \((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - d3\ l4\ md\ Sin[q3[t]])
              \), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dC", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "+", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], "+",
           
          RowBox[{"dD", " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"C33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(d2\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(l4\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"C33", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(d2\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(l4\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], ";"}]], 
  "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom3s", "=", 
        RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
          RowBox[{
          "d3", " ", "md", " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\),
             " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dD", " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], ";"}]], 
  "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom4s", "=", 
        RowBox[{
          RowBox[{\(-Aa\), " ", "Cd", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            \(Sin[q1[t] + q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{\((ma + mh)\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["x", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{\(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{"(", 
                    RowBox[{"g", "+", 
                      RowBox[{
                        SuperscriptBox["y", "\[DoublePrime]",
                          MultilineFunction->None], "[", "t", "]"}]}], 
                    ")"}]}]}], ")"}]}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom5s", "=", 
        RowBox[{
          RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q4", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
            SuperscriptBox["x", "\[DoublePrime]",
              MultilineFunction->None], "[", "t", "]"}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom6s", "=", 
        RowBox[{
          RowBox[{\(-\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\)\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q4", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
            SuperscriptBox["y", "\[DoublePrime]",
              MultilineFunction->None], "[", "t", "]"}]}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Free flying sets of equations of motion"], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom1f", "=", 
        RowBox[{\(1\/8\), " ", 
          RowBox[{"(", 
            RowBox[{
            \(4\ d1\ g\ ma\ Cos[q1[t]]\), "-", \(4\ g\ l2\ ma\ Cos[q1[t]]\), 
              "+", \(8\ d1\ g\ mb\ Cos[q1[t]]\), "+", 
              \(8\ g\ l1\ mc\ Cos[q1[t]]\), "+", \(8\ g\ l1\ md\ Cos[q1[t]]\),
               "-", \(4\ d1\ g\ ma\ Cos[q1[t] + 2\ q4[t]]\), "+", 
              \(4\ g\ l2\ ma\ Cos[q1[t] + 2\ q4[t]]\), "+", 
              RowBox[{"4", " ", 
                RowBox[{"(", 
                  RowBox[{
                  \(2\ d2\ l1\ mc\ Cos[q2[t]]\), "+", 
                    \(2\ l1\ l4\ md\ Cos[q2[t]]\), "+", 
                    \(2\ d3\ l1\ md\ Cos[q2[t] + q3[t]]\), "-", 
                    \(2\ d1\ l3\ ma\ Sin[q4[t]]\), "+", 
                    \(2\ l2\ l3\ ma\ Sin[q4[t]]\), "-", 
                    \(d1\ l2\ ma\ Sin[2\ q4[t]]\), "+", 
                    \(l2\^2\ ma\ Sin[2\ q4[t]]\), "+", 
                    RowBox[{
                    "2", " ", "Aa", " ", "Cd", " ", \((d1 - l2)\), " ", 
                      \(\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\)\^2\), 
                      " ", 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{
                          \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                            
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         "]"}], " ", \(Sin[q4[t]]\), " ", 
                      \(Sin[q1[t] + q4[t]]\)}], "-", 
                    RowBox[{
                    "2", " ", "Aa", " ", "Cd", " ", \((d1 - l2)\), " ", 
                      \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{"Sign", "[", 
                        RowBox[{
                          RowBox[{
                          \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                            
                            RowBox[{
                              SuperscriptBox["q1", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          "+", 
                          RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                            RowBox[{
                              SuperscriptBox["q4", "\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}]}],
                         "]"}], " ", \(Sin[q4[t]]\), " ", 
                      \(\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\)\^2
                          \)}]}], ")"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "8", " ", "l1", " ", \((
                \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                  d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"8", " ", "dC", " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Cos[q2[t] + q3[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q3", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"8", " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{"(", 
                  RowBox[{"dB", "-", 
                    RowBox[{
                    "2", " ", "d3", " ", "l1", " ", "md", " ", 
                      \(Cos[q2[t] + q3[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}]}], "+", 
              RowBox[{
              "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", \(Cos[q1[t]]\),
                 " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", \(Cos[q1[t]]\),
                 " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
                \(Cos[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
                \(Cos[q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
                \(Cos[3\ q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
                \(Cos[3\ q1[t] + 2\ q4[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
                \(Cos[3\ q1[t] + 4\ q4[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
                \(Cos[3\ q1[t] + 4\ q4[t]]\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[q1[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[q1[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{
              "8", " ", "d1", " ", "l3", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
                
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{
              "8", " ", "l2", " ", "l3", " ", "ma", " ", \(Sin[q4[t]]\), " ", 
                
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[q1[t] + 2\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[3\ q1[t] + 2\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[3\ q1[t] + 2\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"Aa", " ", "Cd", " ", "d1", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[3\ q1[t] + 4\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
              
              RowBox[{"Aa", " ", "Cd", " ", "l2", " ", \(l3\^2\), " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    RowBox[{
                    \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  "]"}], " ", \(Sin[3\ q1[t] + 4\ q4[t]]\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"2", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                    "8", " ", "l1", " ", \((
                      \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                      RowBox[{
                        SuperscriptBox["q2", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "8", " ", "d3", " ", "l1", " ", "md", " ", 
                      \(Cos[q2[t] + q3[t]]\), " ", 
                      RowBox[{
                        SuperscriptBox["q3", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{
                    "2", " ", \((d1 - l2)\), " ", "l3", " ", \(Sin[q4[t]]\), 
                      " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                          "2", " ", "Aa", " ", "Cd", " ", \((
                            l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                            RowBox[{"Sign", "[", 
                              RowBox[{
                                RowBox[{
                                \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\),
                                   " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], "]"}], " ", 
                            \(Sin[2\ \((q1[t] + q4[t])\)]\)}], "-", 
                          RowBox[{"2", " ", 
                            RowBox[{"(", 
                              RowBox[{\(2\ ma\), "+", 
                                RowBox[{"Aa", " ", "Cd", " ", 
                                  RowBox[{"Sign", "[", 
                                    RowBox[{
                                      RowBox[{
                                      \((l2\ Sin[q1[t]] + 
                                        l3\ Sin[q1[t] + q4[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                      RowBox[{
                                      "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                                        
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], "]"}], " ", 
                                  \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])
                                    \), " ", 
                                  \(Sin[2\ \((q1[t] + q4[t])\)]\)}]}], 
                              ")"}]}]}], ")"}], " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}]}], 
                  ")"}]}], "-", 
              RowBox[{"8", " ", "B33", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{"4", " ", "d1", " ", "l2", " ", "ma", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"4", " ", \(l2\^2\), " ", "ma", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"8", " ", \(d1\^2\), " ", "mb", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"8", " ", \(l1\^2\), " ", "mc", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{"8", " ", \(l1\^2\), " ", "md", " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "-", 
              RowBox[{
              "4", " ", "d1", " ", "l2", " ", "ma", " ", \(Cos[2\ q4[t]]\), 
                " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "4", " ", \(l2\^2\), " ", "ma", " ", \(Cos[2\ q4[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q2[t] + q3[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q1", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
                
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q2[t] + q3[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q2", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
              "8", " ", "d3", " ", "l1", " ", "md", " ", 
                \(Sin[q2[t] + q3[t]]\), " ", 
                RowBox[{
                  SuperscriptBox["q3", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
      ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom2f", "=", 
        RowBox[{
        \(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), "-", 
          \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
          RowBox[{
          \((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - d3\ l4\ md\ Sin[q3[t]])
              \), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dC", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["q2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "+", 
                RowBox[{
                  SuperscriptBox["q3", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], "+",
           
          RowBox[{"dD", " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"C33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(d2\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(l4\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d2", " ", "l1", " ", "mc", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"l1", " ", "l4", " ", "md", " ", \(Sin[q2[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"C33", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(d2\^2\), " ", "mc", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{\(l4\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], ";"}]], 
  "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom3f", "=", 
        RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
          RowBox[{
          "d3", " ", "md", " ", \((l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\),
             " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
          RowBox[{
          "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], " ", 
            RowBox[{
              SuperscriptBox["q2", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"dD", " ", 
            RowBox[{
              SuperscriptBox["q4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{
          "d3", " ", "l1", " ", "md", " ", \(Sin[q2[t] + q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q1", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{"d3", " ", "l4", " ", "md", " ", \(Cos[q3[t]]\), " ", 
            RowBox[{
              SuperscriptBox["q2", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "-", 
          RowBox[{"D33", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}], "+", 
          RowBox[{\(d3\^2\), " ", "md", " ", 
            RowBox[{
              SuperscriptBox["q3", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], ";"}]], 
  "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom4f", "=", 
        RowBox[{\(\(-g\)\ ma\ Cos[q1[t] + q4[t]]\), "-", 
          RowBox[{"Aa", " ", "Cd", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{
                  \((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
              "^", "2"}]}], "-", 
          RowBox[{"Aa", " ", "Cd", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], "]"}], 
            " ", \(Sin[q1[t] + q4[t]]\), " ", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{
                  RowBox[{
                  \((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
              "^", "2"}]}], "+", 
          RowBox[{"ma", " ", \(Cos[q1[t] + q4[t]]\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\((l2\ Sin[q1[t]] + l3\ Sin[q1[t] + q4[t]])\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"2", " ", "l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "-", 
                RowBox[{"l2", " ", \(Cos[q1[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "-", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], 
          "-", 
          RowBox[{"ma", " ", \(Sin[q1[t] + q4[t]]\), " ", 
            RowBox[{"(", 
              RowBox[{
                RowBox[{\((l2\ Cos[q1[t]] + l3\ Cos[q1[t] + q4[t]])\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"2", " ", "l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                  SuperscriptBox[
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                "+", 
                RowBox[{"l2", " ", \(Sin[q1[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q1", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}], "+", 
                RowBox[{"l3", " ", \(Sin[q1[t] + q4[t]]\), " ", 
                  RowBox[{
                    SuperscriptBox["q4", "\[DoublePrime]",
                      MultilineFunction->None], "[", "t", "]"}]}]}], 
              ")"}]}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom5f", "=", 
        RowBox[{
          RowBox[{\(-Aa\), " ", "Cd", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"mh", " ", 
            RowBox[{
              SuperscriptBox["x", "\[DoublePrime]",
                MultilineFunction->None], "[", "t", "]"}]}]}]}], ";"}]], 
  "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"eom6f", "=", 
        RowBox[{
          RowBox[{\(-Aa\), " ", "Cd", " ", 
            RowBox[{"Sign", "[", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
            SuperscriptBox[
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
          RowBox[{"mh", " ", 
            RowBox[{"(", 
              RowBox[{"g", "+", 
                RowBox[{
                  SuperscriptBox["y", "\[DoublePrime]",
                    MultilineFunction->None], "[", "t", "]"}]}], ")"}]}]}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData["Switching info"], "Subsubsection"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(Na[t_]\), "=", 
        RowBox[{
          RowBox[{"(", 
            RowBox[{
            \(g\ ma\ \((Cos[q1[t]]\ Cos[q4[t]] - Sin[q1[t]]\ Sin[q4[t]])\)\), 
              "+", \(g\ mh\ \((
                Cos[q1[t]]\ Cos[q4[t]] - Sin[q1[t]]\ Sin[q4[t]])\)\), "+", 
              RowBox[{
              "ma", " ", \(Sec[q1[t] + q4[t]]\), " ", 
                \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\), " ", 
                RowBox[{"(", 
                  RowBox[{\(\(-l2\)\ q1DD[t]\ Sin[q4[t]]\), "+", 
                    RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "+", 
                    RowBox[{"2", " ", "l3", " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q4", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], 
                        "2"]}]}], ")"}]}], "+", 
              RowBox[{
              "mh", " ", \(Sec[q1[t] + q4[t]]\), " ", 
                \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\), " ", 
                RowBox[{"(", 
                  RowBox[{\(\(-l2\)\ q1DD[t]\ Sin[q4[t]]\), "+", 
                    RowBox[{\((l3 + l2\ Cos[q4[t]])\), " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], "2"]}],
                     "+", 
                    RowBox[{"2", " ", "l3", " ", 
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], " ", 
                      RowBox[{
                        SuperscriptBox["q4", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], "+", 
                    RowBox[{"l3", " ", 
                      SuperscriptBox[
                        RowBox[{
                          SuperscriptBox["q4", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}], 
                        "2"]}]}], ")"}]}], "+", 
              RowBox[{"Aa", " ", "Cd", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
              
              RowBox[{"Aa", " ", "Cd", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                \((Cos[q1[t]]\ Cos[q4[t]] - Sin[q1[t]]\ Sin[q4[t]])\), " ", 
                SuperscriptBox[
                  RowBox[{
                    SuperscriptBox["y", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
            ")"}], "/", 
          RowBox[{"(", 
            RowBox[{
            \(Cos[q1[t]]\ Cos[q4[t]]\), "-", \(Sin[q1[t]]\ Sin[q4[t]]\), "-", 
              
              RowBox[{"\[Mu]", " ", 
                RowBox[{"Sign", "[", 
                  RowBox[{
                    SuperscriptBox["x", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}], "]"}], " ", 
                \((Cos[q4[t]]\ Sin[q1[t]] + Cos[q1[t]]\ Sin[q4[t]])\)}]}], 
            ")"}]}]}], ";"}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{\(q1DD[t_]\), "=", 
        RowBox[{
          RowBox[{"-", 
            RowBox[{
              RowBox[{"(", 
                RowBox[{\(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
                  RowBox[{
                  "d3", " ", "md", " ", \((
                    l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q1", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "+", 
                  RowBox[{
                  "2", " ", "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), 
                    " ", 
                    RowBox[{
                      SuperscriptBox["q1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}], " ", 
                    RowBox[{
                      SuperscriptBox["q2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                  "d3", " ", "l4", " ", "md", " ", \(Sin[q3[t]]\), " ", 
                    SuperscriptBox[
                      RowBox[{
                        SuperscriptBox["q2", "\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}], "2"]}], 
                  "-", 
                  RowBox[{"dD", " ", 
                    RowBox[{
                      SuperscriptBox["q4", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}], 
              "/", \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                  d3\ l1\ md\ Sin[q2[t] + q3[t]])\)}]}], "+", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"-", 
                        RowBox[{"(", 
                          RowBox[{
                            RowBox[{
                            \((\(-D33\) + d3\^2\ md + 
                                  d3\ l4\ md\ Cos[q3[t]] - 
                                  d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                      RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                  \((d2\ l1\ mc\ Sin[q1[t] - q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                  \((l1\ l4\ md\ Sin[q1[t] - q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((d2\ l1\ mc\ Sin[q1[t] + q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((l1\ l4\ md\ Sin[q1[t] + q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                  \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                     "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                     "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}]}], ")"}]}], "-", 
                            RowBox[{
                            \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])
                                \), " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                    \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                   "-", 
                                  RowBox[{
                                  \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                  \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                  \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      \(d1\^2\), " ", "mb", " ", "\[Mu]", " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      \(l1\^2\), " ", "mc", " ", "\[Mu]", " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      \(l1\^2\), " ", "md", " ", "\[Mu]", " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                  \((d2\ l1\ mc\ Sin[q1[t] - q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                  \((l1\ l4\ md\ Sin[q1[t] - q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((d2\ l1\ mc\ Sin[q1[t] + q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((l1\ l4\ md\ Sin[q1[t] + q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                  \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                     "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                     "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}]}], ")"}]}]}], ")"}]}], " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                          \(-\((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                  d3\ l4\ md\ Cos[q3[t]] + 
                                  d2\ l1\ mc\ Sin[q2[t]] + 
                                  l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                              \(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
                                
                                RowBox[{
                                "d3", " ", "md", " ", \((
                                  l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), 
                                  " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}], "+", 
                          RowBox[{
                          \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                              \(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), "-", 
                                \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
                                RowBox[{
                                \((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - 
                                      d3\ l4\ md\ Sin[q3[t]])\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dC", " ", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    \((\(-\((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])
                                \)\)\ \((
                              \(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) + 
                          \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]])\)\ 
                            \((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                            RowBox[{"-", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                    \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                   "-", 
                                  RowBox[{
                                  \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                  \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                  \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      \(d1\^2\), " ", "mb", " ", "\[Mu]", " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      \(l1\^2\), " ", "mc", " ", "\[Mu]", " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "+", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      \(l1\^2\), " ", "md", " ", "\[Mu]", " ",
                                         
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                    
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                  "-", 
                                  RowBox[{
                                  \((d2\ l1\ mc\ Sin[q1[t] - q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                  \((l1\ l4\ md\ Sin[q1[t] - q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((d2\ l1\ mc\ Sin[q1[t] + q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((l1\ l4\ md\ Sin[q1[t] + q2[t] + q4[t]])
                                      \), "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "-", 
                                  RowBox[{
                                  \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                     "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}], "+", 
                                  RowBox[{
                                  \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                     "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}]}], ")"}]}], " ", 
                            RowBox[{"(", 
                              RowBox[{
                              \(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
                                
                                RowBox[{
                                "d3", " ", "md", " ", \((
                                  l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), 
                                  " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}], "+", 
                          RowBox[{
                          \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{\((d1\ g\ mb\ Cos[q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{\((g\ l1\ mc\ Cos[q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{\((g\ l1\ md\ Cos[q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d1\ g\ mb\ Cos[2\ q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((g\ l1\ mc\ Cos[2\ q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((g\ l1\ md\ Cos[2\ q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "g", " ", "ma", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                    ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "g", " ", "l2", " ", "ma", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                    ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "g", " ", "mb", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                    ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "g", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                    ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "g", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                    ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "g", " ", "mh", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                    ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "g", " ", "l2", " ", "mh", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                    ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "g", " ", "mb", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[2\ q1[t] + q4[t]]\)}], ")"}], "/",
                                   
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "g", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[2\ q1[t] + q4[t]]\)}], ")"}], "/",
                                   
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "g", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[2\ q1[t] + q4[t]]\)}], ")"}], "/",
                                   
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", \((
                                      \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                      \(Cos[q1[t] + q4[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "\[Mu]", " ", \((
                                      \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "dB", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", 
                                      \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", 
                                      \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", 
                                      \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", 
                                      \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", 
                                      \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", 
                                      \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "\[Mu]", " ", \((
                                      \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\), " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "dC", " ", \(Cos[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{"dC", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", 
                                      \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", 
                                      \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", 
                                      \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", 
                                      \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "2", " ", "l1", " ", 
                                      \(Cos[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((\((d2\ mc + l4\ md)\)\ 
                                        Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", 
                                        \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "2", " ", "l1", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((\((d2\ mc + l4\ md)\)\ 
                                        Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", 
                                        \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{"\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\), " ", 
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{"dB", "-", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{"Aa", " ", "Cd", " ", "d1", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{"Aa", " ", "Cd", " ", "l2", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "Aa", " ", "Cd", " ", "d1", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "Aa", " ", "Cd", " ", "l2", " ", "\[Mu]", 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                      " ", 
                                      SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "ma", " ", 
                                      \(Sec[q1[t] + q4[t]]\), " ", 
                                      \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((l3 + l2\ Cos[q4[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l2", " ", "ma", " ", 
                                      \(Sec[q1[t] + q4[t]]\), " ", 
                                      \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((l3 + l2\ Cos[q4[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d1", " ", "mh", " ", 
                                      \(Sec[q1[t] + q4[t]]\), " ", 
                                      \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((l3 + l2\ Cos[q4[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l2", " ", "mh", " ", 
                                      \(Sec[q1[t] + q4[t]]\), " ", 
                                      \(Sin[q4[t]]\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((l3 + l2\ Cos[q4[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                               ")"}]}]}], ")"}]}]}], ")"}]}], ")"}], "/", 
            RowBox[{"(", 
              RowBox[{
              \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                    \((\(-\((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])
                                \)\)\ \((
                              \(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) + 
                          \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]])\)\ 
                            \((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                          \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] - q2[t] - q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] + q2[t] + q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}]}], ")"}]}], "-", 
                          RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{
                                  \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                 "-", 
                                RowBox[{
                                \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{"B33", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    \(d1\^2\), " ", "mb", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    \(l1\^2\), " ", "mc", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    \(l1\^2\), " ", "md", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                \((d2\ l1\ mc\ Sin[q1[t] - q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((l1\ l4\ md\ Sin[q1[t] - q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d2\ l1\ mc\ Sin[q1[t] + q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((l1\ l4\ md\ Sin[q1[t] + q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] - q2[t] - q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] + q2[t] + q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                    RowBox[{
                    \((\(-\((\(-D33\) + d3\^2\ md)\)\)\ 
                            \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) - 
                          d3\ l4\ md\ Cos[q3[t]]\ 
                            \((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                          \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{
                                    RowBox[{"(", 
                                      RowBox[{
                                      "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                    RowBox[{"(", 
                                      RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                      ")"}]}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((d2\ l1\ mc\ Sin[q1[t] - q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((l1\ l4\ md\ Sin[q1[t] - q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d2\ l1\ mc\ Sin[q1[t] + q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((l1\ l4\ md\ Sin[q1[t] + q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] - q2[t] - q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] + q2[t] + q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}]}], ")"}]}], "-", 
                          RowBox[{
                          \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])\),
                             " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{
                                  \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                    RowBox[{"(", 
                                      RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                 "-", 
                                RowBox[{
                                \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] - q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d2", " ", "l1", " ", "mc", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "l1", " ", "l4", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[q1[t] + q2[t] + q4[t]]\), 
                                      " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] - q2[t] - q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    "d3", " ", "l1", " ", "md", " ", "\[Mu]", 
                                      " ", \(Cos[
                                        q1[t] + q2[t] + q3[t] + q4[t]]\), " ",
                                       
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{"B33", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    \(d1\^2\), " ", "mb", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    \(l1\^2\), " ", "mc", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "+", 
                                RowBox[{
                                  RowBox[{"(", 
                                    RowBox[{
                                    \(l1\^2\), " ", "md", " ", "\[Mu]", " ", 
                                      RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                      \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                  RowBox[{"(", 
                                    RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                      RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                "-", 
                                RowBox[{
                                \((d2\ l1\ mc\ Sin[q1[t] - q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((l1\ l4\ md\ Sin[q1[t] - q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d2\ l1\ mc\ Sin[q1[t] + q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((l1\ l4\ md\ Sin[q1[t] + q2[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "-", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] - q2[t] - q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}], "+", 
                                RowBox[{
                                \((d3\ l1\ md\ 
                                      Sin[q1[t] + q2[t] + q3[t] + q4[t]])\), 
                                  "/", 
                                  RowBox[{"(", 
                                    RowBox[{"2", " ", 
                                      RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
              ")"}]}], "+", 
          RowBox[{
            RowBox[{"(", 
              RowBox[{
              \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])\), " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{
                          \(-\((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                  d3\ l4\ md\ Cos[q3[t]] + 
                                  d2\ l1\ mc\ Sin[q2[t]] + 
                                  l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                              \(d3\ g\ md\ Sin[q1[t] + q2[t] + q3[t]]\), "+", 
                                
                                RowBox[{
                                "d3", " ", "md", " ", \((
                                  l1\ Cos[q2[t] + q3[t]] + l4\ Sin[q3[t]])\), 
                                  " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}], "+", 
                          RowBox[{
                          \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\), " ", 
                            RowBox[{"(", 
                              RowBox[{
                              \(\(-d2\)\ g\ mc\ Sin[q1[t] + q2[t]]\), "-", 
                                \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), "-", 
                                RowBox[{
                                \((l1\ \((d2\ mc + l4\ md)\)\ Cos[q2[t]] - 
                                      d3\ l4\ md\ Sin[q3[t]])\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "-", 
                                RowBox[{"dC", " ", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  SuperscriptBox[
                                    RowBox[{
                                      SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}], "2"]}], "+", 
                                RowBox[{
                                "2", " ", "d3", " ", "l4", " ", "md", " ", 
                                  \(Sin[q3[t]]\), " ", 
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}], " ", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                      RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                RowBox[{"dD", " ", 
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}]}], ")"}]}]}], ")"}], "/", 
                      \((\(-\((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]])
                                \)\)\ \((
                              \(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]] + 
                                d2\ l1\ mc\ Sin[q2[t]] + 
                                l1\ l4\ md\ Sin[q2[t]])\) + 
                          \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                d3\ l4\ md\ Cos[q3[t]])\)\ 
                            \((\(-D33\) + d3\^2\ md + 
                                d3\ l4\ md\ Cos[q3[t]] - 
                                d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\)}], "-", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                        \((\(-\((\(-D33\) + d3\^2\ md)\)\)\ 
                                \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) - 
                              d3\ l4\ md\ Cos[q3[t]]\ 
                                \((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{"(", 
                                    RowBox[{
                                      RowBox[{
                                      \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                        " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], ")"}]}], "-", 
                                      RowBox[{
                                      \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                         "-", 
                                        RowBox[{
                                        \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{"d2", " ", "l1", " ", "mc", 
                                        " ", "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "md", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}], " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{
                                    \(-\((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\)\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        \(d3\ g\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t]]\), "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", \((
                                        l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", " ", 
                                        \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                                    RowBox[{
                                    \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                      " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        \(\(-d2\)\ g\ mc\ 
                                        Sin[q1[t] + q2[t]]\), "-", 
                                        \(g\ l4\ md\ Sin[q1[t] + q2[t]]\), 
                                        "-", 
                                        RowBox[{
                                        \((l1\ \((d2\ mc + l4\ md)\)\ 
                                        Cos[q2[t]] - d3\ l4\ md\ Sin[q3[t]])
                                        \), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", " ", 
                                        \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{"dC", " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", " ", 
                                        \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "+", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                        RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
                              RowBox[{
                              \((\(-\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]])\)\)\ 
                                      \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\) + 
                                    \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]])\)\ 
                                      \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                                " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{
                                      RowBox[{"-", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                         "-", 
                                        RowBox[{
                                        \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "md", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], ")"}]}], " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        \(d3\ g\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t]]\), "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", \((
                                        l1\ Cos[q2[t] + q3[t]] + 
                                        l4\ Sin[q3[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l4", " ", "md", 
                                        " ", \(Sin[q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "l4", " ", "md", " ", 
                                        \(Sin[q3[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{"dD", " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], "+", 
                                    RowBox[{
                                    \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                      " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((d1\ g\ mb\ Cos[q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((g\ l1\ mc\ Cos[q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((g\ l1\ md\ Cos[q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d1\ g\ mb\ Cos[2\ q1[t] + q4[t]])
                                        \), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((g\ l1\ mc\ Cos[2\ q1[t] + q4[t]])
                                        \), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((g\ l1\ md\ Cos[2\ q1[t] + q4[t]])
                                        \), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "g", " ", "ma", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "g", " ", "l2", " ", "ma", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "g", " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "g", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "g", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "g", " ", "mh", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "g", " ", "l2", " ", "mh", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\)}], 
                                        ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "g", " ", "mb", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[2\ q1[t] + q4[t]]\)}], ")"}], 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "g", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[2\ q1[t] + q4[t]]\)}], ")"}], 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "g", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[2\ q1[t] + q4[t]]\)}], ")"}], 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", \((
                                        \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        \(Cos[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "\[Mu]", " ", \((
                                        \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "dB", " ", \(Cos[q1[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "\[Mu]", " ", \((
                                        \((d2\ mc + l4\ md)\)\ Cos[q2[t]] + 
                                        d3\ md\ Cos[q2[t] + q3[t]])\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "dC", " ", \(Cos[q1[t] + q4[t]]\), 
                                        " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{"dC", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", " ", 
                                        \(Cos[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((\((d2\ mc + l4\ md)\)\ 
                                        Cos[q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", 
                                        \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "2", " ", "l1", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((\((d2\ mc + l4\ md)\)\ 
                                        Cos[q2[t]] + d3\ md\ Cos[
                                        q2[t] + q3[t]])\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        "d3", " ", "md", " ", 
                                        \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{"(", 
                                        RowBox[{"dB", "-", 
                                        RowBox[{
                                        "2", " ", "d3", " ", "l1", " ", "md", 
                                        " ", \(Cos[q2[t] + q3[t]]\), " ", 
                                        RowBox[{
                                        SuperscriptBox["q3", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "d1", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "l2", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "d1", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "Aa", " ", "Cd", " ", "l2", " ", 
                                        "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", \(Sin[q4[t]]\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["y", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "ma", " ", 
                                        \(Sec[q1[t] + q4[t]]\), " ", 
                                        \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((l3 + l2\ Cos[q4[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "ma", " ", 
                                        \(Sec[q1[t] + q4[t]]\), " ", 
                                        \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((l3 + l2\ Cos[q4[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d1", " ", "mh", " ", 
                                        \(Sec[q1[t] + q4[t]]\), " ", 
                                        \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{
                                        \((l3 + l2\ Cos[q4[t]])\), " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l2", " ", "mh", " ", 
                                        \(Sec[q1[t] + q4[t]]\), " ", 
                                        \(Sin[q4[t]]\), " ", 
                                        RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{\((l3 + l2\ Cos[q4[t]])\), 
                                        " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "+", 
                                        RowBox[{"2", " ", "l3", " ", 
                                        RowBox[{
                                        SuperscriptBox["q1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], " ", 
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{"l3", " ", 
                                        SuperscriptBox[
                                        RowBox[{
                                        SuperscriptBox["q4", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "2"]}], "-", 
                                        RowBox[{
                                        "l2", " ", \(Sin[q4[t]]\), " ", 
                                        RowBox[{
                                        
                                        SuperscriptBox["q1", "\[DoublePrime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}]}], ")"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                         ")"}]}]}], ")"}]}]}], ")"}]}], ")"}],
                       "/", 
                      RowBox[{"(", 
                        RowBox[{
                        \((\(-\((\(-D33\) + d3\^2\ md + 
                                      d3\ l4\ md\ Cos[q3[t]])\)\)\ 
                                \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]] + 
                                    d2\ l1\ mc\ Sin[q2[t]] + 
                                    l1\ l4\ md\ Sin[q2[t]])\) + 
                              \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                    d3\ l4\ md\ Cos[q3[t]])\)\ 
                                \((\(-D33\) + d3\^2\ md + 
                                    d3\ l4\ md\ Cos[q3[t]] - 
                                    d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), " ",
                           
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{
                              \((\(-\((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]])\)\)\ 
                                      \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\) + 
                                    \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]])\)\ 
                                      \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                                " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{
                                    \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                      " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], ")"}]}], "-", 
                                    RowBox[{\((\(-D33\) + d3\^2\ md)\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                         "-", 
                                        RowBox[{
                                        \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "md", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}], "-", 
                              RowBox[{
                              \((\(-\((\(-D33\) + d3\^2\ md)\)\)\ 
                                      \((\(-C33\) - d2\^2\ mc - l4\^2\ md - 
                                        d3\ l4\ md\ Cos[q3[t]] + 
                                        d2\ l1\ mc\ Sin[q2[t]] + 
                                        l1\ l4\ md\ Sin[q2[t]])\) - 
                                    d3\ l4\ md\ Cos[q3[t]]\ 
                                      \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\))\), 
                                " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{
                                    \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]] - 
                                        d3\ l1\ md\ Sin[q2[t] + q3[t]])\), 
                                      " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], ")"}]}], "-", 
                                    RowBox[{
                                    \((\(-D33\) + d3\^2\ md + 
                                        d3\ l4\ md\ Cos[q3[t]])\), " ", 
                                      RowBox[{"(", 
                                        RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        \((B33\ Cos[q1[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}]}],
                                         "-", 
                                        RowBox[{
                                        \((d1\^2\ mb\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ mc\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((l1\^2\ md\ Cos[q1[t] + q4[t]])\), 
                                        "/", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d2", " ", "l1", " ", "mc", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "l1", " ", "l4", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q4[t]]\), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] - q2[t] - q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        "d3", " ", "l1", " ", "md", " ", 
                                        "\[Mu]", " ", 
                                        \(Cos[q1[t] + q2[t] + q3[t] + q4[t]]
                                        \), " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}]}], ")"}], "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{"B33", " ", "\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(d1\^2\), " ", "mb", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "mc", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "+", 
                                        RowBox[{
                                        RowBox[{"(", 
                                        RowBox[{
                                        \(l1\^2\), " ", "md", " ", "\[Mu]", 
                                        " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}], ")"}], "/", 
                                        
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        "-", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] - q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d2\ l1\ mc\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((l1\ l4\ md\ 
                                        Sin[q1[t] + q2[t] + q4[t]])\), "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "-", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] - q2[t] - q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}], "+", 
                                        RowBox[{
                                        \((d3\ l1\ md\ 
                                        Sin[q1[t] + q2[t] + q3[t] + q4[t]])\),
                                         "/", 
                                        RowBox[{"(", 
                                        RowBox[{"2", " ", 
                                        RowBox[{"(", 
                                        RowBox[{\(Cos[q1[t] + q4[t]]\), "-", 
                                        RowBox[{"\[Mu]", " ", 
                                        RowBox[{"Sign", "[", 
                                        RowBox[{
                                        SuperscriptBox["x", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}], "]"}], " ", 
                                        \(Sin[q1[t] + q4[t]]\)}]}], ")"}]}], 
                                        ")"}]}]}], ")"}]}]}], ")"}]}]}], 
                            ")"}]}], ")"}]}]}], ")"}]}], ")"}], "/", 
            \((\(-D33\) + d3\^2\ md + d3\ l4\ md\ Cos[q3[t]] - 
                d3\ l1\ md\ Sin[q2[t] + q3[t]])\)}]}]}], ";"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Solve and Interpret"], "Section"],

Cell[TextData[
"********NOTE********\nWhen running this simulation make changes in this \
section and execute this section as many times as needed to get the results. \
The steps above need only be executed during the first pass through the \
notebook. "], "Text"],

Cell[TextData["Define the constants.  Use consistent units."], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!PS-Adobe-2.0 EPSF-1.2
%%BoundingBox: 4 4 377 279
%%HiResBoundingBox: 4 4 377 279
%%Creator: (Mathematica 4.2 for Macintosh)
%%CreationDate: (Friday, April 29, 2005) (19:00:15)
%%Title: Clipboard
%%DocumentNeededResources: (atend)
%%DocumentFonts: (atend)
%%DocumentNeededFonts: (atend)
%%EndComments
0 283 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def

%%MathematicaCell
%Cell[GraphicsData[\"PICT\", \\
%\"\\<\\
%000000000A<1M@0A0_l<0?on0000B00004P0000000014`\\
%5e0000000N00402P00
%00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
%00400000000000000000040000000000000000000000@00000014`5e00030000
%00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
%04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
%ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
%dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
%BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
%>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
%oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
%JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
%>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
%i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
%LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
%P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
%d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
%EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
%`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
%ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
%Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
%^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
%CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
%RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
%lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
%l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
%ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
%dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
%aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
%IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
%1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
%GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
%iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
%ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
%<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
%e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
%3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
%bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
%1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
%X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
%96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
%0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
%Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
%RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
%aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
%k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
%K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
%W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
%<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
%coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
%85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
%BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
%XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
%@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
%DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
%R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
%A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
%8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
%3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
%ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
%6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
%A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
%IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
%I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
%QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
%5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
%ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
%RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
%8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
%58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
%Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
%<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
%kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
%LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
%M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
%[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
%2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
%2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
%:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
%BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
%=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
%LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
%IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
%>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
%aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
%Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
%DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
%[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
%4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
%1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
%PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
%?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
%mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
%X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
%bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
%en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
%Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
%CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
%54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
%K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
%:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
%oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
%ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
%]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
%WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
%>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
%AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
%EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
%A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
%jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
%[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
%21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
%81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
%>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
%j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
%S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
%Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
%khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
%TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
%Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
%RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
%Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
%Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
%iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
%^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
%d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
%^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
%B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
%CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
%4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
%ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
%aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
%B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
%<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
%2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
%^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
%L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
%Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
%0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
%jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
%=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
%Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
%M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
%34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
%jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
%5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
%6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
%I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
%3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
%5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
%7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
%3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
%WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
%80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
%FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
%EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
%jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
%CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
%7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
%l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
%YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
%BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
%876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
%dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
%[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
%e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
%j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
%iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
%//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
%o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
%12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
%A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
%oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
%0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
%d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
%@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
%89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
%452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
%n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
%lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
%KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
%UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
%5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
%7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
%1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
%AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
%`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
%]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
%j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
%54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
%[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
%d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
%VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
%bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
%:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
%lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
%A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
%0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
%P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
%Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
%WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
%PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
%P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
%>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
%@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
%5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
%6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
%</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
%BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
%GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
%Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
%ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
%L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
%acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
%a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
%j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
%7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
%0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
%F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
%X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
%kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
%NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
%K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
%Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
%<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
%d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
%IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
%mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
%NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
%nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
%FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
%lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
%akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
%K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
%_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
%b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
%iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
%XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
%ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
%502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
%_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
%VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
%hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
%5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
%1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
%eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
%eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
%Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
%8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
%X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
%<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
%;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
%j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
%bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
%BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
%33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
%Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
%dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
%J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
%QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
%]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
%TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
%Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
%50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
%GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
%327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
%8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
%Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
%k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
%o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
%2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
%1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
%2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
%G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
%FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
%6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
%4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
%8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
%6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
%4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
%5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
%0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
%0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
%IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
%101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
%7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
%0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
%1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
%K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
%6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
%A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
%?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
%c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
%Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
%3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
%:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
%0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
%oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
%DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
%1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
%1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
%@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
%EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
%fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
%78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
%<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
%423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
%721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
%8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
%1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
%KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
%4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
%343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
%bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
%0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
%7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
%cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
%bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
%4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
%7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
%CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
%AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
%bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
%C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
%6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
%0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
%787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
%D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
%nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
%XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
%EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
%Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
%[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
%=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
%QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
%J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
%2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
%PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
%=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
%W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
%KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
%H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
%<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
%YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
%1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
%5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
%L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
%LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
%kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
%ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
%3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
%R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
%R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
%4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
%fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
%44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
%>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
%OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
%ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
%?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
%W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
%WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
%Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
%b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
%Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
%F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
%P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
%<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
%TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
%8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
%:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
%7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
%AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
%m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
%aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
%W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
%?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
%fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
%APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
%Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
%:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
%@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
%WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
%A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
%U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
%L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
%hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
%O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
%O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
%F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
%aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
%g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
%]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
%0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
%AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
%h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
%C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
%MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
%QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
%j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
%4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
%<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
%:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
%o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
%U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
%F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
%P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
%1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
%LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
%T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
%jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
%<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
%DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
%9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
%PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
%e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
%X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
%Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
%MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
%T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
%:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
%cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
%F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
%9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
%Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
%2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
%ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
%0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
%[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
%h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
%A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
%?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
%]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
%Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
%h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
%D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
%ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
%kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
%OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
%JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
%WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
%=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
%CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
%Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
%Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
%iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
%EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
%Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
%VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
%Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
%c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
%aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
%ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
%lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
%2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
%e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
%9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
%jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
%nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
%>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
%PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
%<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
%1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
%@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
%ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
%1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
%Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
%EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
%[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
%AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
%AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
%c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
%2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
%D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
%4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
%@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
%<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
%nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
%?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
%bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
%>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
%JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
%aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
%TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
%N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
%>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
%7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
%:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
%WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
%2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
%iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
%7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
%BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
%elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
%^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
%eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
%Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
%T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
%L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
%CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
%DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
%<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
%@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
%6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
%c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
%`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
%3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
%;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
%0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
%B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
%;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
%7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
%VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
%@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
%0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
%N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
%E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
%0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
%I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
%A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
%2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
%NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
%@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
%FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
%1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
%DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
%oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
%4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
%>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
%<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
%FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
%7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
%cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
%n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
%7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
%eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
%eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
%CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
%nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
%gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
%JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
%Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
%bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
%0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
%`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
%U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
%978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
%V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
%_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
%o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
%:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
%WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
%Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
%520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
%:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
%4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
%g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
%>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
%NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
%]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
%AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
%5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
%44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
%k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
%Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
%B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
%=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
%V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
%0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
%AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
%0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
%V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
%oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
%cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
%E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
%d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
%LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
%6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
%QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
%Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
%QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
%l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
%EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
%S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
%G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
%ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
%9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
%dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
%5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
%jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
%A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
%TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
%_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
%1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
%?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
%5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
%6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
%L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
%Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
%=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
%4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
%S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
%K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
%WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
%2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
%JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
%jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
%ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
%CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
%PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
%NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
%BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
%j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
%KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
%3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
%G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
%RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
%`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
%]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
%LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
%^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
%BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
%>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
%n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
%9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
%=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
%>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
%l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
%XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
%BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
%BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
%=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
%U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
%PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
%BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
%PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
%Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
%YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
%RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
%dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
%^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
%l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
%>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
%SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
%gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
%/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
%l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
%B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
%Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
%7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
%]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
%lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
%1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
%6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
%EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
%1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
%Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
%@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
%lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
%?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
%10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
%I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
%GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
%Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
%6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
%lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
%mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
%]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
%QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
%hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
%[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
%@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
%>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
%6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
%VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
%i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
%^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
%@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
%94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
%XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
%7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
%M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
%d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
%Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
%</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
%=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
%0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
%3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
%@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
%=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
%dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
%06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
%0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
%/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
%UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
%;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
%TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
%?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
%KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
%=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
%<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
%G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
%5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
%`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
%7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
%L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
%H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
%7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
%3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
%`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
%Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
%?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
%YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
%527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
%7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
%HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
%lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
%5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
%7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
%LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
%5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
%a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
%ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
%X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
%3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
%8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
%]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
%j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
%A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
%?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
%/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
%`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
%9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
%[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
%N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
%8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
%Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
%1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
%QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
%1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
%fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
%GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
%`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
%`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
%dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
%LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
%?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
%=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
%A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
%Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
%_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
%17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
%3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
%Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
%Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
%?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
%4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
%i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
%PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
%PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
%6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
%HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
%UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
%4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
%3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
%Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
%:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
%=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
%5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
%FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
%88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
%29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
%]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
%@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
%6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
%f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
%D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
%fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
%l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
%c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
%ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
%7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
%?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
%>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
%bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
%>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
%4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
%0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
%`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
%Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
%NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
%hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
%=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
%4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
%YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
%COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
%^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
%4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
%PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
%]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
%T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
%TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
%h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
%eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
%1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
%?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
%?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
%EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
%i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
%MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
%Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
%N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
%9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
%D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
%A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
%adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
%NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
%QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
%8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
%6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
%B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
%ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
%04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
%;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
%]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
%hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
%`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
%040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
%lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
%9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
%8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
%7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
%H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
%oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
%OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
%lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
%6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
%]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
%3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
%ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
%00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
%d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
%0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
%Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
%0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
%;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
%3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
%5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
%_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
%8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
%<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
%7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
%Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
%bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
%V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
%R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
%9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
%NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
%:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
%PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
%7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
%5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
%K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
%i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
%RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
%mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
%;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
%c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
%XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
%6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
%SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
%S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
%3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
%[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
%6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
%Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
%=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
%Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
%<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
%;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
%`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
%<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
%H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
%]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
%;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
%4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
%Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
%;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
%m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
%1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
%92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
%hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
%EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
%HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
%1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
%1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
%LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
%72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
%gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
%2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
%NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
%0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
%PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
%AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
%:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
%L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
%dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
%EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
%V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
%:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
%ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
%Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
%CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
%aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
%R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
%/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
%D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
%im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
%`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
%k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
%F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
%6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
%;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
%OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
%@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
%7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
%Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
%Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
%1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
%eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
%H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
%^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
%lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
%61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
%OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
%anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
%6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
%bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
%b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
%<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
%Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
%iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
%kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
%_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
%k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
%]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
%:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
%SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
%nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
%EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
%;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
%oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
%`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
%NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
%G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
%19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
%L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
%MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
%PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
%H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
%lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
%1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
%B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
%5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
%KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
%<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
%3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
%/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
%1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
%LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
%VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
%N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
%79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
%mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
%34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
%NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
%@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
%7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
%[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
%P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
%RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
%//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
%=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
%M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
%851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
%?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
%<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
%GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
%86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
%EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
%k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
%?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
%;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
%:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
%A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
%c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
%=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
%m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
%BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
%5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
%o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
%XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
%C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
%T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
%R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
%S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
%UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
%4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
%?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
%9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
%9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
%H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
%6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
%KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
%<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
%F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
%5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
%L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
%HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
%c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
%[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
%HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
%;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
%5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
%7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
%M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
%nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
%o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
%VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
%fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
%loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
%hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
%<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
%B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
%=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
%@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
%[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
%ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
%7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
%j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
%@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
%VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
%22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
%HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
%E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
%@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
%n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
%Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
%HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
%Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
%<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
%I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
%:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
%DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
%eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
%i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
%JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
%o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
%P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
%:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
%E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
%34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
%f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
%WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
%oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
%iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
%9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
%hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
%<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
%PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
%mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
%Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
%[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
%daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
%mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
%Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
%X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
%S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
%k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
%U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
%oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
%g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
%:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
%DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
%<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
%1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
%Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
%F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
%1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
%<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
%jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
%b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
%9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
%HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
%JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
%o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
%k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
%Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
%d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
%BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
%eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
%00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
%51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
%=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
%9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
%MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
%HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
%9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
%lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
%ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
%@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
%/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
%=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
%?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
%7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
%PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
%al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
%k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
%VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
%6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
%nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
%oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
%>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
%_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
%Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
%003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
%00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
%003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
%3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
%8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
%00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
%02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
%M6lPLfEU87AXJG<PL6USM7EbIBh0003o\\>\"], \"Graphics\",
%  ImageSize->{373, 275},
%  ImageMargins->{{0, 0}, {0, 0}},
%  ImageRegion->{{0, 1}, {0, 1}}]
%%EndMathematicaCell
1 setgray
4 279 moveto
377 279 lineto
377 4 lineto
4 4 lineto
closepath
fill
gsave
4 279 translate
373 -275 scale
1 string
373 275 8 [373 0 0 275 0 0] {
 currentfile
  1 index
   readhexstring
    pop
    } false 3 colorimage
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFEFFFFFEFFFFFFFFFFFFFD
FFFFFDFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFEFBFFFEFB
FFFFFFFFFEFFFFFEFFFFFFFFFFFEFDFFFFFDFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFAFDFFFEFFFFFEFF
FAFBFBFEFFFFFEFFFFFDFEFEFEFFFFF9F9F9FFFFFFFFFEFFFFFBFBFFFCFC
FFF9FAFFFAFDFFFAFDFFFAFFFBF6FAFFFEFFF7F8FAFCFFFFFBFFFFFCFFFF
F8F9FBFEFFFFFFFEFFFFFEFFFFFEFFF8F7FAFDFEFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFDFFFFFBFFFEFDFFFDFFFFFDFFFFFDFEFFFFFB
FBFBF7FEFFFFFCFEFFFCFEFFF6FCFCFBFFFDFBFFFCFEFFF9FFFDF4FFFDF6
FDFBFCFEFEFFF7F8FCFFFFFFFFFEFAFFFFFAFCFFFDFBFFFFFEFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFEFFFBFAFD
FEFFFFFEFFFFFBFCFCFEFFFFF9FAFAFEFFFFFFFEFFFDF8FAFFFDFDFFF7F8
5F545613080AFCF1F7988F940C050AE8E6E9FEFFFFFCFFFFFBFFFFFAFFFF
FEFFFFFBFCFEFAF9FEF6F5FAFFFEFFFBFAFFFEFFFFFBFCFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFEFDFFFEFFFFFEFFFFFEFFFDFDFB
FFFFFDFDFEFEFCFFFFF7FAFFFBFFFFFBFFFFFBFFFDFEFFF9FFFDF3FFFAF2
FAF8FBF9FCFFFEFEFFFBFBFBFFFFF8FFFFF8FBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFEFFFEFFF9F8FBFFFEFF
FDFEFEFCFDFDF8F9F9FEFFFFFEFFFFFCFDFDFEFCFDFFFDFFFFFAFAFFFBFC
FFFAFCECE1E37B72771A1318C7C2C6BCBBBEF9FAFCFCFFFFFBFFFFF8FEFE
FEFFFFFBFCFEFFFEFFFFFEFFFEFDFFFFFEFFF5F6F8FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFBFFFFFBFFFFFFFEFDFF
FAF9FEFFFEFFFEFFFBFDFFFAFAFBFDFCFFFFF2FAFAFEFFFBFFF6EDFFFBF4
FFFEFFFCFFFFFEFEFFFEFDFFFFFEFAFFFFF8FBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFAF8FBFDFCFFFFFEFF
FEFFFFFEFFFFF9FAFAFEFFFFFEFFFFFBFBFBFFFEFFFBF9FAFFFDFDFEF8F8
FFFAFBFFFAFEA59CA1191217F1ECF0F9F8FBFEFFFFFCFFFFF7FDFDFCFFFF
F9FAFCFEFFFFFEFDFFF7F6F9FFFEFFFFFEFF000002FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFFFFFEFFFFFEFFFFFEFFFFFFFAFFFFF8FEFEFEFFFEFF
FFFEFFFAF8FBFFFFF5FFFFF6FFFEFFF9F8FEF9FFFFFAFEFDDFD8D019100B
C6C7CBF9FDFFFAFDFFFFFEFFFFFEFAFFFFFAFBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFEFFFFFEFFFDFCFF
F8F9F9FBFCFC5C5D5DF7F8F8FFFFFFFEFEFEFAF8F9FFFEFFFFFCFCFFFDFD
FFFCFDFFFCFFCAC1C6171017F7F1F8FFFEFFFEFFFFFAFDFFFAFEFFFBFFFF
FDFEFFFEFFFFF9F9F9FFFEFFFFFFFFF1F1F1070808FBFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFEFFFFFEFFFFFEFFFAFEFFF8FFFFFFFDFCFF
FDFAFFFFFDFFFFFEF4FFFEF4FFFBFCFFFDFFF9FFFFF7FDFDFFFEF8928A87
C8C8CEFBFFFFF6F9FFFEFFFFFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFEFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFAFDFAF9FCE7E6E9
B9BABAFDFEFE030404FEFFFFFDFDFDFFFFFFFFFEFFF9F7F8FDF8F8FFFDFD
FFF8F9FFFAFD8C8388070007979198D4D3D8FEFFFFFCFFFFFCFFFFF8FCFD
FCFDFFFFFFFFC9C7C8D2D0D1FFFFFFFFFFFF000000FCFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFBFEFFFBFEFFFDFBFBFB
FFFDFFFFFDFDFFFAF5FFF8F1FFFBFBFFF9FEF9FFFFF0F7FBFAF6F3D9D3D1
808388F8FFFFFBFFFFFBFCFEFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFDFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F6F9FFFEFFFBFAFDFFFEFF
424242919191000000FEFFFFFFFFFFFFFFFFFAF8F9FEFCFDFFFDFDFFFBFB
FFFDFD9C9598100910D6D0D8ABA8AE0E0D12EEEFF3FCFFFFF4F8F9FCFFFF
FEFFFFF9F9F9E1DFE0181615DDDBDAF7F7F5000100FEFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFDFCFFFDFCFFFFFCFFFFFEFFFDFCFDF7
FEFBF4FEF6F3FFFBFDFFFAFDFFFAF8FFF9F7F8FFFFF6FFFFFFFEFDF4EFEF
494D54F2FAFFFBFFFFFCFDFFFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFDFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFBF9FCFFFEFFFFFEFF
D9D9D9131313040505FDFEFEFDFDFDFFFFFFFFFEFFFFFEFFFFFCFCFEF9F9
FFFDFDFFFCFFFFFAFFFFFCFFFFFCFFFEFFFFFBFCFFFCFFFFFCFFFFFEFFFF
FEFEFEFFFFFFFFFEFD8D8B8A3E3C3BFFFFFD040402FEFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFEFFFDFCFFFBFCFFFDFBFFFFFCFFFFFEFFFDFFFFF8
FFFFF4F7F0E8271A1FFBEAF0FFF1EB221914606872F1FDFFF9F8FBFFFEFD
7F868CD1D9E1FBFFFFFEFFFFFFFEFAFFFFFBFBFFFFF9FFFFFEFFFFFFFFFD
FFFDFDFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FCFCFCFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFEFFFEFDFFFFFEFF
FEFEFE868686040404000000020202000000010101000000020000010000
020000030000030002030004010004000004000004000004000102000002
000000010000050000050000010000A2A2A0000000FEFFFDFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFEFFFDFCFFFBFCFFFDFCFFFFFCFFFFFEFFFDFFFFF8
FFFFF3FFFEF6302126BCABAFFFF8F04A413C87909BD2DEECFEFDFFEEECED
484F538F989DF8FDFFFEFFFFFFFEFAFFFFFBFCFFFFFBFFFFFEFFFFFFFFFD
FFFDFDFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFF
F8F8F8F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFF8F8F8F7F7F7
FFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFBFBFBFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFEFDFFFFFEFF
FBFBFBFAFAFA2A2A2AA9A9A9FBFBFBFFFFFFF4F4F4FFFFFFFFFEFDFFFEFD
FFFDFCFFFEFFFFFDFFFFFDFFFFFEFFFEFFFFFCFFFFFCFFFFFCFFFFFEFFFF
FFFFFFFFFEFFFFFDFDF9F4F4D4D2D1121210050501FEFFFDFFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFCFFFDFCFFFDFCFFFFFEFFFFFBFBF9FFFFFA
FFFCF3FFFCF4A69A9A221212FFFAF4978F8D7C8594F4FFFFFDFCFFFFFEFF
F2F9FDF8FFFFF6FBFEFEFFFDFFFEFAFFFFFBFCFFFFFBFFFFFEFFFFFFFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FF4F4F4FFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFBFBFB8F8F8FF4F4F4FFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFA5A5A5FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF9FCFFFEFFFFFEFFFFFEFF
FFFFFFFFFFFFC2C2C21F1F1FEAEAEAF8F8F8FFFFFFFFFFFFFFFFFDFBFBF9
FDFDFBFFFFFFFFFEFFFFFEFFFFFEFFFEFFFFFCFFFFFCFFFFFEFFFFFEFFFF
FFFFFFFFFEFFFFFCFCFFFCFCFFFEFD71716F000000FCFEFBFAFAFAFAFAFA
FBFBFBFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFDFEFFFBFFFFFFF8F6F7
FFFDFFFFFDFAD7CCC40A0000A69893E3DCE10C1427E2EFFFFFFEFFFFFDFE
FBFFFFF5FCFFFCFFFFFDFDFBFFFDFAFFFEFBFCFFFFFBFFFFFCFFFFFFFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB1B1B1393939F0F0F0FFFFFF
FDFDFDFEFEFEF8F8F8FFFFFFB1B1B1393939F0F0F0FFFFFFFDFDFDFEFEFE
F8F8F8FFFFFFFFFFFF181818838383FBFBFBFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFFFEFFF8F7FAFBFAFD
FFFFFFFFFFFFFFFFFF6464646A6A6AFFFFFFFBFBFBFDFDFDF7F7F5FFFFFD
FFFFFDF8F8F6FFFDFEFEFDFFFDFEFFFDFEFFFBFFFFFBFFFFFDFEFEFEFEFE
FFFDFEFFFEFFFFFBFBFFFBFBFFFEFDF3F3F1070705B7B9B6FFFFFFFFFFFF
FFFFFFFDFDFDFDFDFDFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFEFFFFFEFFFFFEFFFFFEFFFFFEFFFBFFFFFAF9F7F8FFFDFF
FFFCFFFFFCFCF7EFE2120A00665B57A6A0A800081DEDF7FFFAF9FFFFFDFE
FBFFFFF5FDFFFCFFFFFFFFFBFFFDFAFFFEFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD7B7B7B2A2A2ADEDEDE
FEFEFEFEFEFEFFFFFFF7F7F7FDFDFD7B7B7B2A2A2ADEDEDEFEFEFEFEFEFE
FFFFFFF7F7F7FFFFFFEDEDED3B3B3B606060F4F4F4FFFFFFF7F7F7FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFEFFFFFEFFFFFEFF
FFFFFFFFFFFF525252F6F6F61B1B1BBFBFBFFEFEFEFFFFFFFCFEFBFDFFFC
FEFFFDFEFFFDFFFFFFFFFFFFFEFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFFFF
FDFBFCFFFAFCFFFDFFFFFDFFF6F4F5FDFDFD000000232424EFEFEFFEFEFE
FFFFFFFAFAFAFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFFFBFFFFFAFFFEFFFFFCFF
FFFAFFFFFCFCABA7993D3727CAC2BD87868C212B40E3EDFFFFFEFFFAF5F5
F7FBFCF9FFFFFEFFFDFFFFFAFFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFC8F8F8F1A1A1A
CECECEFFFFFFFFFFFFFEFEFEFEFEFEFCFCFC8F8F8F1A1A1ACECECEFFFFFF
FFFFFFFEFEFEFFFFFFF5F5F5F2F2F2535353474747EEEEEEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFDFFFFFEFFFFFEFF
FDFDFDFEFEFE030303FFFFFFE1E1E1BABABAFFFFFFF6F6F6FEFFFDFCFEFB
FEFFFDFEFFFDFDFDFDFDFDFDFCFDFDFCFDFDFAFEFDFAFEFDFCFDFDFDFDFD
FFFEFFFFFDFFFCF7F9FDF8FAFFFEFFFFFFFF000000CECFCFDCDCDCF2F2F2
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFFFFFEFDFFFDFDFFFDFFFBF6FA
FFFDFFFFFDFDF5F2E9FFFFF4FFFDF6FEFFFFF5FFFFF1F9FFFFFDFFFFFDFD
FCFFFFFBFFFFFEFFFDFEFDF8FFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFABABAB
1B1B1BB1B1B1FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFABABAB1B1B1BB1B1B1
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFF6F6F6656565323232EEEEEEFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFBFAFDFFFEFF
FFFFFFFFFFFF010101FAFAFAFFFFFFFBFBFBFFFFFFFFFFFFFEFFFDFCFEFB
FEFFFDFEFFFDFFFFFDFFFFFDFEFFFDFCFFFDFCFFFDFCFFFDFEFFFFFFFFFF
FFFEFFFDF8FAFFFCFFFFFDFFFBF9FAF9F9F9040404F4F5F5FCFCFCFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFFFFFDFFFFFDFFFEFDFFFEFFFFFCFFFFFBFFFFFCFFFFFCFC
FFFEFBF7F3F0746F71FAF8F7FFFFF8F8FCFB818C9ED0D8EDFEFBFFFFFCFC
FEFFFFFAFEFDF9FBF6FFFFFAFFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFDFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
BEBEBE1F1F1F9E9E9EFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFBEBEBE1F1F1F
9E9E9EFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFF8181811A1A1ADFDFDF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFBFFFEFDFBFFFFF3FAFF
FEFFFFFEFCFD010000FFFEFDFEFFFFFDFEFEFFFEFDFFFDFCFEFFFDFEFFFD
FEFFFFFBFCFCFEFEFEFEFEFCFDFFFCFBFFFCFDFFFCFDFFFCFDFEFEFEFEFE
FFFEFFFFFAFCFFFDFFFFFDFFFFFDFEFFFFFF010101FEFFFFFFFFFFFEFEFE
FBFBFBFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFFFFFDFFFFFDFFFEFDFFFEFFFFFCFFFFFCFFFFFDFFFFFEFB
FFFBF7FFFEFBB3B0B6848285FEFDF6D2D4D1555C6AF8FDFFFFFDFFFFFDFD
FDFEFEFBFFFEFEFFFDFFFEF9FFFDFAFFFEFBFEFFFFFCFFFFFEFFFFFEFFFF
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFCFCFCFDFDFDFFFFFFFFFFFF
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFCDCDCD000000060606020202787878FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFE
FCFCFCFFFFFFFFFFFFFCFCFCFFFFFFFEFEFEFDFDFDFFFFFFFCFCFCFFFFFF
FAFAFAFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFDFDFD
FFFFFFFAFAFAFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFDF7F7F5
FFFEFDF8F6F5EDEBEA464443010000010000302E31E0DFE2F8FEFEF9FFFF
FEFFFFF6F5F8060707FAFEFDFBFFFFFCFFFFFFFDFFFFFCFDFFFEF8FFFFFA
FCFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFEEEEEE4F4F4F2F2F2F6868689E9E9E8383835757571515158E8E8E
F0F0F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000
7171715A5A5AFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
707070010101050505010101CCCCCCFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9
FFFEFFFFFEFFFCFAFBFFFEFFFFFEFFFEFCFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFADADAD0101010C0C0C0606063C3C3C
AEAEAEE5E5E5FEFEFEFDFDFDFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFD9D9D90B0B0B
0000000505055E5E5EFFFFFFF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFDF9F4F4
FCF7F7FFFDFDFFF9F9FFFCFCFFFDFDFFFDFFFFFDFFFEFEFFFEFFFBFFFFFA
FFFFFDFAFBFB000302F7FDFDFBFFFFFEFEFFFFFCFFFFFCFFFFFDFAFFFFF8
FCFFFFFCFFFFFBFCFEFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFB0D0D0D
F2F2F2FFFFFFF9F9F9FAFAFAFFFFFFFDFDFDFFFFFFF9F9F9FFFFFFFBFBFB
FBFBFB9A9A9A636363FDFDFDFFFFFFF7F7F7FFFFFFFFFFFFFEFEFE040404
000000E0E0E0FFFFFFF6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBF8F8F83D3D3D0000000404041B1B1BECECEC
FFFFFFFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFCFCFCFEFEFE
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F9F9FFFFFFFFFFFF4A4A4A0000000000001D1D1DE7E7E7FAFAFAFFFFFF
FCFCFCFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF9F9F9FFFFFF
FEFEFEFAFAFAFFFFFFF8F8F8F2F1F4FFFEFFFFFFFFF8F8F8FFFFFDFCFCFA
FBFBF9FFFFFFFFFEFFFEFDFFFFFDFEFFFEFFFFFDFDFFFEFBFFFDF6FFFFF8
F5FEF7F7FFFFFFF8FFFEF5FFFFFDFFFFFDFFFFFAF4A49695B3BAC8EFFFFF
F0FFFDF7FFF7FFFFFBFFFCFFFFFCFFFEFBFFFFFEFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFCFCFCDBDBDB2F2F2F585858F7F7F7
FFFFFFFFFFFFF5F5F5FCFCFCE6E6E6AEAEAECECECEF4F4F4FEFEFEFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFBFBFB
FFFFFFFFFFFFFCFCFCFFFEFDFFFCFCFFFDFDFFFFFFFAFAFAD0CCC94B4948
6B6E72F6F9FDFEFCFBFFFDFCF8FBFFFCFFFFFFFFFFFDFBFAFFFFFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFEFEFEFBFBFBFFFFFFFEFEFE
C0C0C00000000202020101017F7F7FFFFFFFFCFCFCFCFCFCFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFF9F9F9FFFFFFBBBBBB000000050505010101848484FFFFFF
FBFBFBFFFFFFF7F7F7FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFDFDFD
F8F8F8FFFFFF6B6B6B040404E6E5EAFBFAFDF5F4F7FFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFCFAFBFFFEFFFFFAFCFFFDFDFFFBF8FFFDF7FFFEF6D9DAD4
000405272B32AA95A10B0007A0A7B9F5FFFFFFFCF6FFF4EF595B68EAF6FF
F7FFFFF2FDF5FCFFFAFFFFFBFFFBFFFFFCFFFAF8FBFFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFAFAFA6F6F6F262626C5C5C5FFFFFFFEFEFEFCFCFC
FFFFFFFAFAFAFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFDFFFEFDFFFBF9FCF7F7969A9B5A5E5F
FFFDFD7D787ADEE6E8F9FFFFFFFDFFFFFBFBFEFFFFFAFEFFFFFFFFFDFBFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF8F8F8FFFFFFFEFEFEFEFEFE4C4C4C
0000000606061D1D1DE0E0E0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3D3D3D020202000000262626
EEEEEEFFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFDFDFD
FAFAFAFFFFFFFFFFFFACACAC040308121114DDDCDFFEFEFEFFFFFDFBFBF9
FFFFFDFEFEFCFCFAFBFFFEFFFEF9F9FFFEFBFFFDFAFFFEF6FFFDF5DBD7D4
0B0E1DFAF8FFFFEFEA1B0B09C5D5EAEDFFFFF7F7F5FFFEF6FEFDFFF3F6FD
FFFEFFFFFEFFFFFFFBFCFEF9FFFFFFFBFBFBFFFFFFFCFCFCFCFCFCFEFEFE
FFFFFF575757A3A3A3FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
FCFCFCB1B1B1111111989898F9F9F9FFFFFFFEFEFEFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBF9FFFFFBFFFBFAA49E9C131B1DC4CACA
FFFCFD625C5CC6CFD2F0FBFDFFFDFDFFF9F7FCFFFFFBFFFFFAFAFAFFFEFD
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFF
FCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF090909020202
000000767676FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDADADA0C0C0C0B0B0B000000
585858FFFFFFFEFEFEFCFCFCFBFBFBFDFDFDFCFCFCFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFBFBFBFDFDFDFEFEFE33323700000218171AD0D0D0FBFBF9FEFEFC
FEFEFCFFFFFDFFFEFFFCFAFBFFFDFFFFFDFDFFFDFAF9F4EEFFFEF6F2EDED
1E1B2ED6CFDFFFF9ED9B93888599AFE5FDFFFEFFFFFFFDF7FCFEFBFDFEFF
FFFCFFFFFBFFFDF8F8FDFCF8FCFFFDFBFFFFF7F8F8FFFFFFFFFFFF979797
0101010D0D0DFFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFDFDFDF9F9F9
777777202020C9C9C9F4F4F4FFFFFFFBFBFBFCFCFCFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFCFFFEFDFFFAF8FFFCFCF8FCFDFCFFFF
FFFDFDFFFDFFEFF7F9F9FFFFFFFDFFFCF6F6FEFFFFFCFFFFFCFCFCFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FEFEFEFBFBFBFFFFFFFDFDFDFFFFFFFCFCFCF3F3F3232323000000000000
3F3F3FFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA1A1A1000000050505
030303A2A2A2FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFFEFEFE
FCFCFCFEFEFEFEFEFEFFFFFFDDDCE10D0C0F000002050505ACACAAFFFFFD
FBFBF9FFFFFDFAFAFAFFFFFFFFFEFFFBF9F8FFFEFBFFFEFAFFFEF6FFFCFF
C8BED6110517FFF8E68D8E7C283D50EDFFFFFEFEFFF5EFECFAFFF8FCFFFD
FFFBFFFFF3FFFFFAFFFFF9F7FBFFFDF5FFFAFCFFFFB7B7B71717170C0C0C
090909F3F3F3FFFFFFFDFDFDFDFDFDFFFFFFFAFAFAFFFFFFE1E1E13D3D3D
434343EFEFEFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFEFDFFFDFFFDFBFCFFFFFDFDFDFB
FEFDFFFEFDFFFEFFFFFEFFFFFDFCFFFDFCFFFFFFFFFFFFFDFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFFF8F8F8F4F4F4FFFFFFFFFFFFFEFEFE464646010101030303161616
E4E4E4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF646464000000
030303070707D3D3D3FFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFEFEFEFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFF7F7F7FFFEFF4A494C0A0A0A0000000B0B0950504E
EEEEECFFFFFFFDFCFFFFFEFFFFFEFFF9F7F8FCF7F7FEFAF7FFFFF8FFFCFF
FFF3FFC6B9CA65624F656C58324554E0F1FFFBFBFFFFFEFBFBFFF8F9FFF9
FFFCFFFFFAFFFFF6FBFFFDFBF4FDF89DA7A2222625040404000000222222
FDFDFDFFFFFFFFFFFFFDFDFDFFFFFFFEFEFEFFFFFFBABABA141414838383
FFFFFFF9F9F9F8F8F8FAFAFAFEFEFEFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFDFFFDFDFDF8F8F9F9F9FFFFFFFDF9F6FEFCFB
FCFFFFFCFFFFFEFCFBFBF9F8FAFDFFFCFFFFFFFFFFFFFDFCFEFEFEFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFAFFFFFF
FBFBFBFFFFFFFFFFFFF1F1F1FFFFFF919191030303000000000000B6B6B6
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3292929
000000000000343434F6F6F6FFFFFFFAFAFAFEFEFEFFFFFFFCFCFCFCFCFC
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF8F8F8FBFBFB
FFFFFFF7F7F7F9F9F9FFFFFFFEFCFFD5D3D60A0A0A000000000000080806
1516169E9F9FFEFFFFFDFEFFFCFBFEFFFFFFFFFEFDFFFFFBFBFAF5FFFCFF
FFF9FFFFF5FFFBFBEEFBFFF4F3FFFFF5FFFFFCFCFFFFFFFDFAFFF9FBFFFA
FDFAFFFEF4FDB8ABB0534D4D0E1410020B06000000000000000000FCFCFC
FBFBFBFCFCFC515151FFFFFFFDFDFDFFFFFF7979791A1A1AC5C5C5FFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFDFDF8F8FFFDFDFFFFFFFFFFFFFEF8F6FFFDFD
F9FEFFF6FBFEFFFDFDFFFBFBFBFFFFFBFFFFFBF9FAFEF9F9FFFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FDFDFDFFFFFFFDFDFDFFFFFFCBCBCB000000030303000000797979FFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAD7D7D7
0E0E0E0000000808086B6B6BFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FEFEFEFEFEFEFFFFFFF7F7F7FFFEFFFEFCFF494949000000050503000000
0000000304040B0C0E808183FFFEFFFDFCFFFCFCFCF9F7F6FFFFFBD6D1D3
968E9BFFFBFFFFFFF8ECF2E8717880F5FDFFFCFFFFFAFBFD555A54242923
0F0E1109030A160F12030000000100000100050606222222EAEAEAF9F9F9
FEFEFEFFFFFF030303FFFFFFE8E8E8404040414141E9E9E9FFFFFFF8F8F8
FEFEFEFFFFFFFFFFFFFAFAFAFCFCFCFFFFFFFFFFFFFDFDFDFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFDFDFDF8F8FBFBFBFFFFFFFFFDFDFFFBFB
FBFFFFFBFFFFFFFEFFFFFDFFFBFFFFFBFFFFFCFCFCFFFEFDFFFFFFFDFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF8F8F8EDEDED2525250000000404043F3F3FF0F0F0FCFCFC
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
8B8B8B040404000000010101A9A9A9FFFFFFFAFAFAFEFEFEFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF919191020202303030AEAEAE
FCFCFCFFFFFFFFFFFFFEFEFEFBF9FCFFFEFFA4A2A30D0B0C010100040402
232424232424141517000004414246FEFFFFFDFEFEFFFFFDFDFDF9FFFFFD
555258D8D5DBFAF5F7888687AEADB2F8FBFFF9FFFFF9FFFF777976383836
161518000002080909010202030000030000141213EBEBEBFFFFFFFFFFFF
FFFFFFF8F8F8060606B7B7B7171717808080FFFFFFFCFCFCFEFEFEFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFEFEFEFFFFFFFDFDFDFBFBFBFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFBFBFFFDFDFFFFFBFAFAF8FFFEFFFDFBFE
F2F6F3FBFFFEFDFCFFFCFBFFFAFEFDFCFFFDFFFFFFFFFEFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF2F2F2FFFFFF
F7F7F7FFFFFFFFFFFF5555550202020000000D0D0DDDDDDDFFFFFFFEFEFE
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FDFDFD525252040404000000171717E4E4E4FDFDFDFFFFFFFCFCFCFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FFFFFBFFFFFBFFFFFDFFFFFFFEFFFFFEFFFFFDFBFEA19FA2DBDBD9F1F1EF
FBFCFCFEFFFFFDFDFDFEFCFDFFFEFFFFFEFFFBF9FA06040500000050504E
242525EFF0F0F9FAFCFEFFFFF4F5F9F6F7F9FEFFFFFDFEFEFFFFFDFCFCFA
E6E7E948474AD1CBD2595458FFFEFFFEFFFFF4FCFEF9FFFFFEFFFFF9F9F9
F9F9F9C3C4C6161A190607070300000F0909C8C6C7FCFCFCFFFFFFFCFCFC
FFFFFFFEFEFE0000001B1B1BC0C0C0FDFDFDFBFBFBFFFFFFFBFBFBFDFDFD
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFBF9F8FEFEFAFFFFFDF8F6F9FFFEFF
FEFFFDFEFFFDFFFEFFFFFEFFFCFEFBFEFFFDFFFEFFFDFCFFFCFCFCFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFAFAFA
FFFFFFFFFFFF909090020202000000030303ACACACFEFEFEFFFFFFFCFCFC
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFF
FFFFFFEDEDED1C1C1C0202020000003E3E3EFFFFFFFFFFFFFFFFFFFDFDFD
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFB
FFFAF0FFFEF4FFFFFBF7F8F8FCFFFFFBFEFFFEF8FFFFFBFF94938FD6D8D3
FBFFFFFCFFFFFAF8FBFFFDFFFFFEFFFFFFFFFCFCFC4545450B0B0BAFAFAF
6A6A6A4C4C4CFBFBFBFFFFFFFCFBFEFFFFFFFCFCFCFFFFFFFBFBFBFFFFFF
FCFCFCABABAB020003E9E7E8FFFFFFFAFAFAFEFFFFFBFCFCFFFFFFF8F8F8
9898981515158788880A0A0A100E0F6A6869FEFEFEFDFDFDFFFFFFFFFFFF
EBEBEB4343432C2C2CE3E3E3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFEFEFE
FDFDFDD2D2D20909090000000000006A6A6AFFFFFFFFFFFFFEFEFEFEFEFE
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF9F9F9
FCFCFCFFFFFFBCBCBC010101020202030303828282FDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFDF8
FFFCF1FFF3E5FCF9F2FCFFFFF4FDFFF9FDFFFFFBFFFFF7FFFCF8F571736E
E6F2F0F8FFFFFFFEFFFDF6FBFCFAFBFCFCFCFFFFFF838383000000D8D8D8
FAFAFA3D3D3D858585FCFCFCFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFDFDFD
FFFFFFFFFFFFD4D4D4FCFCFCFEFEFEFBFBFBFCFCFCFFFFFFEDEDED505050
393939D7D7D7BCBCBC060606212121FFFFFFFDFDFDFFFFFFFEFEFEBDBDBD
121212818181FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFF
F1F1F12A2A2A000000030303313131FEFEFEFBFBFBFFFFFFFFFFFFFDFDFD
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFF
F9F9F9FFFFFFFFFFFF7E7E7E000000000000050505C7C7C7FFFFFFFDFDFD
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF9FFFFFCFCF8
A28E8511000079746A8F9893000911CCD5E0FFF7FDECD9DBFFFBFC828685
ABBFBDE9FBFAFFFBFFFFFAFFFFFDFFFFFFFFFFFFFFA6A6A6020202FFFFFF
FDFDFDE7E7E7191919BABABAFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDC2C2C2202020727272
F0F0F0FCFCFCB0B0B0000000A3A3A3FEFEFEFEFEFEFFFFFF8484841D1D1D
BDBDBDF9F9F9FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFB
5F5F5F000000000000121212D7D7D7FFFFFFFCFCFCFFFFFFF7F7F7FFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFF8F8F8FFFFFF
FFFFFFFBFBFBF6F6F6FFFFFF474747000000000000272727EAEAEAFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF5FDFBFDFDF9
54413AD2BEB5EDE9DD000400495760C9D2DFFFFBFFD0C0C131282B090D0E
D9ECE8F4FFFFFFFDFFFFFBFFFEF9FBFFFFFFFCFCFCF2F2F2888888F9F9F9
FFFFFFFCFCFCC2C2C2121212DBDBDBFFFFFFFFFFFFFEFEFEFEFEFEFFFFFF
FFFFFFF8F8F8FFFFFFFBFBFBFFFFFFFBFBFB8A8A8A1B1B1BB0B0B0FCFCFC
FFFFFFFFFFFF797979040404FFFFFFFAFAFAECECEC454545373737E4E4E4
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F99A9A9A
0A0A0A000000000000A2A2A2FFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFBFBFB
FFFFFFF9F9F9FEFEFEFFFFFFDBDBDB101010050505000000545454FFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFB
857C779B928BFDFAEFC1C3BD0B0F18F4F6FFFAF7FDFBF4F7FFFEFFFCFDFF
F9FFFBF9FFFBFBF8FEFFFCFFFFFEFFFFFFFFFFFFFFF8F8F8FDFDFDFFFFFF
FCFCFCFDFDFDFFFFFF9F9F9F272727F4F4F4FCFCFCFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFDFDFDFAFAFAE8E8E8474747363636DFDFDFFFFFFFFFFFFF
F6F6F6FFFFFFCBCBCBD5D5D5FFFFFFC8C8C81F1F1F787878FFFFFFFFFFFF
FFFFFFFBFBFB525252FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCD7D7D70C0C0C
0000000000006C6C6CFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFF9F9F9FBFBFB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFDFDFDFFFFFFF9F9F9FFFFFFB0B0B00000000404040000009C9C9C
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFDFCF8F5
CCC5BD140F05FFFFF6FDFDF91D1D25DFDEEBFFFEFFFFFEFFFFFFFFF9FAFA
FBFFFCFAFEFBFFFEFFFEFBFFFFFEFFFBFBFBF9F9F9FFFFFFFFFFFFFFFFFF
F9F9F9FFFFFFF5F5F5FFFFFF5E5E5E585858FFFFFFF6F6F6FFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFB2B2B21313137F7F7FFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFF909090151515B1B1B1FBFBFBFBFBFBFAFAFA
FAFAFAFFFFFF000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFCFCFC292929000000
080808272727F5F5F5FFFFFFFFFFFFF6F6F6FEFEFEFFFFFFFDFDFDFFFFFF
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FDFDFDFEFEFEF8F8F8FFFFFFF9F9F9FFFFFF646464000000060606070707
D4D4D4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFD
FFFEEF645D4B898581FCFDFF4448539FA1ADFFFDFFFEF9FBFFFFFAFCFEF9
F9FFFFFBFFFFFAF8F9FFFDFDFFFDFEFFFFFFFFFFFFFAFAFAF8F8F8FFFFFF
FCFCFCFBFBFBFFFFFFFFFFFFFFFFFF2E2E2E8B8B8BFFFFFFFBFBFBFDFDFD
FDFDFDFBFBFB676767252525C2C2C2FBFBFBFFFFFFF7F7F7FFFFFFFCFCFC
FFFFFFFEFEFEF2F2F25050502F2F2FE0E0E0FFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFF010101FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF575757010101040404
0A0A0AD8D8D8FDFDFDFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEF8F8F8
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDFCFCFC2F2F2F000000030303
292929F6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFAF5F5
FFFBECFFFFED8783806D6D732E323B868892FBF7FFFFFCFFFFFFFAF9FBF5
F8FFFFFBFFFFFDFBFCFFFBFBFFFDFEFFFFFFFBFBFBFDFDFDFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFF5F5F5FFFFFFE6E6E6161616B8B8B8FFFFFFFFFFFF
DEDEDE303030545454E9E9E9FCFCFCFFFFFFFCFCFCFFFFFFFDFDFDFFFFFF
FCFCFCCECECE1D1D1D6F6F6FFCFCFCFCFCFCFFFFFFF9F9F9FFFFFFFFFFFF
FDFDFDF9F9F9070707FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9F070707000000000000
9D9D9DFCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFF
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBD4D4D4070707030303
000000686868F7F7F7FFFFFFF9F9F9FFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFD
FFFEF6FFFCF2FFFEFBFDFCFFFCFFFFFCFFFFFFFCFFFFFCFFFFFEFDFEFFFA
FCFFFDFCFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFCFCFCC0C0C0191919DEDEDEA3A3A3
171717969696FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFDFDFDFFFFFFFEFEFE
959595141414AEAEAEFAFAFAFFFFFFFCFCFCFEFEFEFFFFFFFDFDFDFDFDFD
FFFFFFFEFEFEA6A6A6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FFFFFFFBFBFBFFFFFFFEFEFEFFFFFFD4D4D40A0A0A0202020101015C5C5C
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9FFFFFFFFFFFF959595000000
010101060606B4B4B4F9F9F9FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFBF6F6
9A928DD5CEC6FFFCF9FFFFFFC6C9CD93969DFFFCFFFFFCFFFFFEFDFEFFFB
FCFFFDFCFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDB6B6B64F4F4F2B2B2B
C9C9C9FFFFFFFFFFFFF9F9F9FFFFFFFBFBFBFFFFFFFFFFFFEEEEEE5B5B5B
2C2C2CDADADAFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFAFAFAFFFFFF
FAFAFAFEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFF6F6F63232320000000000002D2D2DF9F9F9
F6F6F6FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFDFDFD565656
000000000000101010E9E9E9FFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFF
F3EAE1453D32F6F3ECF4F5F5282B3AECEDFDFFFDFFFFFDFBFFFDFDFEFFFF
F9FFFFF9FFFFFFFEFFFFFDFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFB0B0B0F2F2F2
FFFFFFFDFDFDFFFFFFFFFFFFF6F6F6FAFAFAFFFFFFCCCCCC2424246A6A6A
F0F0F0FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFFFFFFFFDFDFD696969000000080808080808D1D1D1FFFFFF
FFFFFFF2F2F2FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFDFDFDF3F3F3
1D1D1D0909090000003C3C3CF9F9F9FBFBFBFFFFFFFFFFFFF6F6F6FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCF9FFFFFDFF
FFFAF2AAA69AA6A39A8D8D8DACAABDFDFBFFFFFEFFFFFFFAFFFEFDFEFFFF
FCFFFFFCFFFFFFFEFFFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF9B9B9B131313A7A7A7FFFFFF
FFFFFFFDFDFDFBFBFBFFFFFFFFFFFFFAFAFAFCFCFCFFFFFFFAFAFAFFFFFF
FEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFEFEFEADADAD050505000000000000989898FFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFFFFFFFBFBFBFFFFFFFCFCFC
C8C8C80000000505050202027F7F7FFFFFFFFAFAFAFFFFFFFFFFFFF6F6F6
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFFFDF6F9
F7F9F4FCFFF829291F474141FFF9FFFFF9FFFCFFFFF9FFFFFCFFFFFFFEFF
FFFDFDFFFDFDFEFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFAFAFA
FEFEFEFFFFFFFAFAFAFEFEFEF4F4F45A5A5A252525D8D8D8FBFBFBFCFCFC
FFFFFFFDFDFDFDFDFDFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFDCDCDC0505050000000101015A5A5AFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFF3F3F3FFFFFF
FFFFFF818181000000000000050505CACACAFFFFFFFCFCFCFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF9FFFFFCFF
FEFFFBFAFFF6DFDED9F4EDF0FFF3FFFFFAFFFBFFFFF8FFFFFCFFFFFFFFFF
FFFCFDFFFCFDFEFFFFFBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFAFAFAFFFFFFD2D2D22B2B2B5F5F5FFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFDFDFDFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFAFAFAFEFEFEFFFFFF
FFFFFFFCFCFC010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEF4F4F4333333060606000000242424ECECECFFFFFFFFFFFFF8F8F8
FFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFFFEFEFE
FFFFFFFCFCFC4141410B0B0B0000001C1C1CE7E7E7FEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEF8FFFFFAFF
FFFFF6FFFDF2FFFEFDFFFDFFFFFCFFFBF9FFFFFDFFFEFFFFFFFFFDFFFFFB
FFFEFFFFFEFFFFFFFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF6F6F6
FFFFFFFCFCFCA4A4A41313139D9D9DFFFFFFFDFDFDFDFDFDFFFFFFFFFFFF
F9F9F9FFFFFFFDFDFDF8F8F8FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FEFEFE6D6D6D000000000000070707CBCBCBFFFFFFF5F5F5FFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFDFEFFFBFEFFFDFEFEFFFEFEFFFFFEFFFFFFFB
FFFFF8FFFFFAFFFDFFFFFDFFFFFEFFFFFEFDFFFFF6FFFFF6FFFFFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFDFDFDFEFEFEFFFFFFFAFAFACFCFCF020202
010101000000797979FDFDFDFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
B1B1B11818188A8A8AFFFFFFFFFFFFFEFEFEFFFFFFFBFBFBFFFFFFFDFDFD
FDFDFDFFFFFFFCFCFCFFFFFFFDFDFDFEFEFEFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFBFBFBC1C1C1020202000000000000848484FFFFFF
F9F9F9FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFEFDFCFBF7FFFCF8FFFDFD
FFF9FFFFFBFFFFFCFFFEFDF9FFFFFB545557F1F2FFFBFEFFFBFFFFF7FDF9
FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFF
FFFFFFFCFCFC757575000000000000040404D5D5D5FCFCFCFCFCFCF9F9F9
FFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFEFEFEF4242423A3A3AE9E9E9FFFFFFFAFAFAFBFBFB
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFF
E7E7E7181818000000000000434343F8F8F8FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFDFFFFFBFFFEF4F2FFFFEBBCBCAF121524FAF8FF
FFF8F2221B10C7D9D8ECFEFFFDFCFFFFFCFFFAFBF5F6F9F0FEFFFFF2F3F7
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFF9F9F9FFFFFFFCFCFC8F8F8F020202000000
000000B9B9B9FEFEFEFFFFFFD2D2D21F1F1F6C6C6CF5F5F5FDFDFDF8F8F8
FFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFAFFFFFDFAFAFAFFFEFF
FEFDFFFFFEFFFBF9FCFFFEFFFEFDF9FFFFFBFFFFFAFAFAF6FDFDFBFFFFFF
FFFEFFFCFDFFFEFFFAFAFBF5FFF9FCFFFCFFFFFBFFFFFEFFFCFFFAFEFFFB
FFFAFFFFF9FFFFFEFDFCFFFAFCFFFBFEFFFDFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFC0C0C00303030404040606066E6E6E
FFFFFFFCFCFCFFFFFFFDFDFDFFFFFFF9F9F9FEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFEFEFEFEFEFEFCFCFCFFFFFFFCFCFC
5757578D8D8DFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF7FDF9F8FAF7FFFBFDFFFCFB
CDCCC8959B9B949DAAD1D8E0FFFEF4FFFCEFFFFAF8EAE2EB637283F0FFFF
FAFEFFFFFEFBFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFCF7F9C7BDC6251E256A6965D6D8D2
F2FAFAF9FFFFFCFCFCFFFFFBFEFFFAF9FDFAF8FDFFFCFFFFFFFEFDFBFAF6
FFFDFCFEFEFEFEFEFEFEFEFEFCFCFCFBFBFBFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFB8B8B8323232
343434BBBBBBFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF8F8F8FFFFFFFDFDFDFFFFFFFBFBFBFBFBFBFFFFFFEFEFEF
6969691F1F1FD6D6D6FEFEFEFDFDFDFFFFFFFAFAFAFDFDFDFCFCFCFFFFFF
FCFCFCFFFFFFFBFBFBFFFFFFFFFFFF8E8E8E060606000000060606B1B1B1
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FAF7FEFFFDFEFFFDFEFFFB
F7FBF8FCFFFD000002FAFBFFFFFEFFF8F5FCFFFCFFFFFDFBFFF7EFFFFDEC
FFF4DA716A58000004A9B2B7F7FFF2E1E8DE261E35120B2ABBC1CCF9FFFF
FFFCFDFFFBFDFFFBFFFFFDFFFBFFFFFBFFFDFFFEFFFFFDFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FDFDFDA9A9A9010101000000
000000A2A2A2FFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFF202020DADADAFEFEFE
FFFFFFFFFFFFFFFFFFCBCBCB5454541E1E1E838383FDFDFDF9F9F9FFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFDFDFBFFFFFBFBFAF5FEFFFAFBFDFA
F5F9FAFBFFFFF9FFFDFCFFFBFFFDF9FFFCFDFFFBFFF8F3F7FCFFF6F9FFF6
F9FEFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FBFBFB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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFF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FEFFFDFFFFFDFFFEFFFFFEFFFFFFFFFFFFFDFFFFFBFFFFFDFFFEFFF8F9FD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FBFFF7FEFFFBFFFDFFFFFAFFFFFEFDFEFDF6F8F5EC9E9D999D9DA5ABADB9
FFFEFFFFFAFDFFEFED6B5F5EEEEEF6FBFFFFFEFFFFFFFFFFFEFEFE969696
656565FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFDFDFD939393F8F8F8FFFFFFFBFBFB
FEFEFCF9F9F7FDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFDFDFDFDFDFDFFFFFF
FFFFFDFDFDFBFFFFFDFFFFFDFDFDFBFFFFFBFFFCF7FFFDFAFBFFFFF7FFFF
FEFFFFFFFBF7FFFBE4A6A292B4BEC7F3FEFFFFFDFFFFFAFFFFFBFFFDFBFF
FFFFFAFFFFF5FFFFFBFFFFFFFFFFFFE9E9E99E9E9E6969698C8C8CD3D3D3
FFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFCFCFCFDFDFDFFFFFF
FFFFFFFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
5B5B5B0707070000000E0E0EDFDFDFFFFFFFFFFFFFFDFDFDFFFFFFFDFDFD
FFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFDFDFDFDFDFD
FFFFFFFEFEFEA6A6A6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9F9F9FEFEFEFFFFFFFEFEFEF9F9F9FFFFFFFCFCFC
FFFFFFFBFBFB5858580505050000000F0F0FDEDEDEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFEFFFEFFFFFFFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFCFCFCADADAD0F0F0FF2F2F2
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFDFDFDFFFFFFFEFEFEFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFF
FFFFFFC8C8C81F1F1FFBF8F1FFFBE7E0DACC00020E293048C3B3CB08000B
ABB9BAF1FFF8E8E6D5FFFCF0BDC1C86B7385F8FCFFFCFEFFFFFFF8EEECDD
2A2924292929919191F4F4F4FCFCFCFFFFFF222222808080CECECEFCFCFC
FFFFFFF9F9F9FFFFFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFFFBFBFBFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FBFFF8FEFFFBFFFCFFFFFCFFFFFDF6FFFDF4FDF9F5E4E2E315131EC8C7D4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F9FDFCF8F9F9FFFDFFFFFDFAFFFFF1FFFFF3F9F9FFFFFCFF756D78ADA5AE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FEFEFFFFFEFFFFFDFDFFFBF3FFFFECDCDCD0000011211F358B7B855E5254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FEFCFFFEFBFFFFFDFBFFFCF1FDF8E2B3B3A9070D25F5F4FF3520231F0D07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FEFAFFFFFCFFFFFDFBFFFEF4FFFFECCCCDC5090E2BFEFBFFFEE9E40E0000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FFFCFFFFFCFFFEF9FBFFFEFAFFFFF3F0F0EC1A1B35CEC8E0FFFAEF9A8A7A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FFFAFCFFFCFFFFFEFFF9F9F9FEFFFAFDFEFEB2AEC41C1324FFF6EAB8AF9E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FFFBFBFFFCFDFDFCFFFCFFFFFAFFFEFEFFFFFEF6FFC6B8C35E544A6E695F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FFFCFBFFFCFCFFFEFFFBFFFFF6FCFCFAFBFDFFFAFFFDEEF3FFFDFAFAFAF6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FFFCFDFFFBFBFBFCFEFBFFFFFBFFFFFAFBFBFFFBFDFFFAFDFFFCFFFBFEFF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FFFDFDFFFEFDFDFDFDFCFDFFFCFFFFFFFFFFFFFCFAFFF7F6FFFDFFFCFFFF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FBFDF8FEFFFDFFFFFFFBF9FCFCFBFFFFFFFFFFFFF8FFFEFAFFFCFFFEFCFF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F9FFFAFCFFFBFFFEFFFFFCFFFFFCFFFFFEFFF8FFF3FCFFF6FFFAFFFCF5FC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F5FFF4F4FEF3FFFDFFFFFAFFFFF9FFFFFDFFF0FFF1F4FFEEFFFDF8FFFBFD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F7FFF4F7FEF4FFFDFFFFF8FFFFF4FFFFFDFFF5FFF8F7FFF3FFFBF3FFF8F7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FCFFFBFEFFFDFFFEFFFFFEFFFFFCFFFFFEFFFCFFFDFCFFFBFFFFFBFFFDFD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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FFFFFFFEFEFEF7F7F7FFFFFFFFFFFFF6F6F6FEFEFE8080807E7E7EFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF2D2D2DBDBDBD070707FFFFFFF9F9F9FFFFFFF4F4F4FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBFBFBFBFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC
FDFDFDFFFFFFF8F8F8F8F8F8FFFFFFCFCFCF8484846A6A6AA4A4A4EFEFEF
FFFFFFF7F7F7FFFFFFFFFFFFF8F8F8FFFFFFFCFCFCFAFAFAFFFFFFFFFFFF
FBFBFBFDFDFDFFFFFFFEFEFEFAFAFAFFFFFFFFFFFFE2E2E2181818FDFDFD
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFBFBFBF9F9F9FDFDFDFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFF373737000000020202181818969696E5E5E5
FFFFFFFFFFFFF5F5F5FFFFFFF9F9F9FEFEFEFFFFFFFFFFFF3B3B3B000000
0000001F1F1FE6E6E6FFFFFFFDFDFDFFFFFFFCFCFCF7F7F7FFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFBFBFBFBF7F4
FFFEF8FFFDF8ECE6E4050100DCDBD7DADAD8101115F9FCFFFBFFFFF6FBFE
FBFEFFFCFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFE2B2B2BB3B3B3FFFFFFFCFCFCFFFFFF
FFFFFFFEFEFEFFFFFF030303040404F6F6F6FDFDFDFBFBFBFFFFFFF9F9F9
FFFFFFFFFFFFE8E8E8181818828282FFFFFFF9F9F9FAFAFAFFFFFFF9F9F9
FFFFFFFFFFFFF2F2F2898989232323393939B4B4B4FFFFFFFFFFFFFFFFFF
FFFFFDFAFAF8FDFDFBFFFFFDFFFFFFFFFFFFFFFEFFFCFBFEFFFEFFFDFCFF
FBFAFDFFFEFFFEFEFE2A2A2AC2C2C2FBFCFCF9FFFFFCFFFFFFFBFAFFFBFB
FFFEFFFBFFFFF8FFFFFBFFFFFFFDFDFFFCFBFFFDFDFEFFFFF7FFFFF8FFFF
FFFDFFFFFCFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFAFAFA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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFA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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFBFEFEFED2D5DA767779
26231A252219747472C4C5C9FDFDFFFFFDFFFFFDFCFEFEFAF9FFFDFBFFFF
FFFCFFFFFCFFFFFDFFFEFCFFFFFFFFFCFCFCFEFFFFFEFFFFFAFAF8FFFFFD
FFFEFDFDFBFAFCFAFBFFFEFFFFFFFFFDFEFEFBFFFFFCFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFF
F8F8F8FFFFFFFBFBFBC1C1C1373737FAFAFAFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFBFBFBBEBEBE7A7A7A686868BCBCBC
F8F8F8FDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD4D4D47E7E7E737373AEAEAE
F7F7F7FFFFFFF5F5F5FFFFFFFFFEFFFBF9FCFFFBFFFFFAFDFFFDFDF9F9F5
FEFFFAFDFFF9FFFFFDFFFFFFFCFDFFFCFDFFFEFFFFFEFEFCFFF9FCFFFCFF
FFFDFFFDFBFCFBFAFDFEFFFFFCFFFFFCFFFFFBFFFEFCFFFFFEFFFDFFFFFB
FFFEFDFFFEFDFFFEFFFFFEFFFFFEFFFFFEFFF9F9F7FFFFFDFFFEFFFBFBFF
FEFFFFFCFEFBFEFFF6FEFFF6FEFDFFD6D4DD0A0610010005040205000000
2527225C615B979996B1B1B1DADADA686868EDEDEDFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFE
BABABACACACAFFFFFFF9F9F9FFFFFFFFFFFF939393D1D1D1FFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF8F8F8FEFEFEFFFFFFFFFFFF
FAFAFAFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFDFDFDFDFDFDFFFFFF
FEFFFDFDFFFCFEFFFFFEFFFFFFFEFFFFFEFFECEBEE141414E2E0E1FFFEFD
FFFEFAFEFDF8FFFCF3FFFFF4FEFBF0605D54969590FDFDFD54525D9A98A1
FCFCFAFFFFFBFBFAFDFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFDFDFDF7FCFFFCFFFF
FFFDF3D3CFC37878742C2F341A19266A6873C7C5C4FCFDF7F1FBF6F6FEFC
FFFCFFFFFBFFFFFCFFFFFEFFFBF9FAFFFFFFF5F6F6FEFFFFFFFFFDFDFDFB
FEFCFBFFFEFDFFFDFFFFFEFFFCFCFCFBFCFCFBFFFFFBFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFDFDFD
FFFFFFF8F8F8FFFFFF686868828282FCFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFDFDFDFCFCFCFDFDFDFDFDFDFBFBFBFFFFFFC8C8C8
7B7B7B6C6C6CACACACEEEEEEFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFFFFFF
FAFAFAF4F4F4B7B7B7FCFCFCFCFCFCFEFEFEFFFFFFFFFFFFFEFEFEFBFBFB
FEFEFEFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFDEDEDE
8686866B6B6BA9A9A9EFEFEFFFFEFFFFFDFFFFFBFFFFFBFFFFFDFEFDFFFC
FEFFFAFEFFF8FEFEFAFBFBF9FEFFFFFEFFFFFBFCFEFFFFFFFFFCFFFFF9FC
FFFDFFFFFEFFFFFEFFFEFFFFFBFEFFF9FFFFFAFFFEFCFFFFFEFFFDFFFFFB
FFFFFBFFFEFDFFFEFFFFFEFFFEFEFFFFFEFFFFFEFBF6F5F1F5F8FDFBFFFF
F3F7F8FAFAF6FFFFF6FFFFF6FEFFFFF8F8FE75717D0B050F0E090D2E2C2B
333935EDF3EFF9FAFAC1C1C1777777FAFAFAFFFFFFF7F7F7FDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF8F8F8FFFFFF
FCFCFCFEFEFEFFFFFFFFFFFFFEFEFE8A8A8ABEBEBEF7F7F7FEFEFEFFFFFF
FDFDFDFFFFFFF8F8F8FEFEFEFFFFFFB4B4B4F4F4F4FFFFFFFDFDFDFFFFFF
F7F7F7FDFDFDF7F7F7FFFFFFFFFFFFF6F6F6FFFFFFFCFCFCFFFFFFFFFFFF
FDFFFCF8FAF7FEFFFFFCFDFDFEFDFFF8F7FA8E8D90565558FFFDFEFDFBFA
FFFEFBFFFEFAFFFFF6FBF8EDFFFDF3FFFDF48684836F6E7116151849484B
FEFDFFFFFEFFFCFBFEFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFFFFAFFFFFBFFFF
FFFEF6FFFEF4FFFFFDFEFFFFD5D7E182828A3432311818145F6765C0C6C6
FFFDFFFFF8FBFFFCFFFFFDFEFFFEFFFFFFFFFEFFFFF9FAFAFEFFFFFBFBFB
FFFEFFFBF9FAF8F6F7FFFEFFFFFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFDFDFDFAFAFA1F1F1FD7D7D7FDFDFDFFFFFFFFFFFFFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFD4D4D48282826F6F6F9B9B9BF3F3F3FFFFFFFFFFFFF8F8F8
FFFFFF8080806A6A6AFFFFFFFFFFFFFFFFFFFCFCFCFAFAFAFFFFFFFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAF9F9F9
FFFFFFFFFFFFE1E1E18B8B8B6B6B6B9C9A9BF1EBEBFFFCFEFCFFFFFBFFFF
FBFDF8FEFFF8FEFFFAFEFFFAFCFCFAFFFEFFFDFDFFFEFEFFFBF9FAFFFEFD
FFFAFAFEFCFBFFFFFFFEFFFFFCFFFFFCFFFFFCFFFFF9FDFCFEFFFDFFFFFD
FFFEFDFFFEFDFFFFFFFFFEFFFEFFFFFFFEFFFFFBF8FFFBF9F8FFFFF4FFFF
F9FFFFFFFFFBFFFEF6FFFBF5FAFBFBFBFFFFF6F6FF1B17210C0107898383
8389850D1611757676A3A3A3FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFAFAFA686868C9C9C9FFFFFFFCFCFCFFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFBFBFBFFFFFF6666660F0F0F6F6F6FDCDCDCFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFBFBFBFFFFFFFBFBFB
FEFFFDFEFFFDFCFDFDFDFEFEFFFEFFF8F7FA0F0E11DAD9DCFFFEFFFFFEFD
FFFEFBF9F5F1FFFFF8FFFFF6F9F6EBFFFFF8FEFCFBFFFEFFEAE9EC070609
ECEBEEFAF9FCFFFEFFFEFDFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFAFFFFFFFBFFFFFBFFFF
FEF8F5FEF9F3FBFBF9FBFCFFFBFEFFFEFFFFF3F1F0E2E0DF8B8F902C2F33
171514666060BBB6B8FAF8F9FFFDFEFEFEFEF9FAFAFEFFFFF8F9F9FEFFFF
FFFDFEFFFEFFFFFEFFFDFBFCFBFBFBFEFFFFFEFFFFF9FDFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
F9F9F9FFFFFFCACACA2B2B2BFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFCFCFCFAFAFAFAFAFAFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFF2F2F2E3E3E38B8B8B6363638F8F8FE9E9E9
FFFFFF222222C7C7C7FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF8F8F8FFFFFFFBFBFB
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFE8E6E5A3A29E6D6D6D8C939BDBE2EA
FCFEFBFFFFF8FBFFF7FBFEF5FFFBF7FFFDFFF8F8FFFCFEFFFCFFFFF9FBF6
FFFEFDFFFEFDFDFDFDFCFCFCFCFDFFFCFFFFFEFFFFFEFFFFFFFFFFFFFFFD
FFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFFFEFFFFFCF8FFFDFAF2FBFDF4FFFF
F9FFFFEEEEEC4B423D372E29171717D8DDE1FAFCFFA6A4AD0D04097E777A
FAFEFB525854131414959595F7F7F7FFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFAFAFA
FFFFFFFBFBFBEBEBEB595959EFEFEFFAFAFAFDFDFDFFFFFFFEFEFEFCFCFC
FFFFFFF8F8F8FBFBFBFFFFFFFEFEFEFFFFFFE3E3E37F7F7F0F0F0F414141
B7B7B7FBFBFBFFFFFFFFFFFFF7F7F7FFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FBFDFAFEFFFD454646E1E2E2FDFCFF959497565558FCFBFEFDFBFCFFFEFF
FFFDFDFFFEFBFFFEFAFFFFF8FFFFF6F7F6EFFBF9F8FFFEFFECEBEE222124
B7B6B9FFFEFFFDFCFFFDFCFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFCFEFDFFFCFFFFFEFFFF
FFFEFBFFFDFBFFFFFFFEFFFFFCFFFFF9FAFAFFFFFBFFFAFAFEFEFFFEFFFF
E3E3E18F8E8A403B3B121011555354B9B9B9FCFDFDFDFEFEFEFFFFFBFCFC
FEFCFDFEFCFDFFFEFFFFFEFFFFFFFFFEFFFFFDFEFEFBFFFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFF777777787878FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFDFDFD
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFDFDFDF9F9F9FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC5C5C5999999
505050181818D5D5D5FFFFFFFFFFFFFFFFFFFAFAFAFAFAFAFFFFFFFFFFFF
FBFBFBFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFB9E9E9E
4A4A4A1515154444448D8D8DF9F7F6FFFFFBF5F5F1FCFFFFEEF7FFA1A9B4
74737684837ECFD6CEFCFFF8FFFEF6FFF9F7FEFEFFF9FFFFF2FAFAFBFFFB
F9F9F5FBFAF6FDFDFBFFFFFDFFFFFFFBFCFCFDFCFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFEFDFFFBF5FFFCF7F5FDFFF5FFFF
F8FFFFFEFFFDFFF9F49C938EF1ECEEE8E7EDFCFFFFF6F9FF0000024B4B4B
5F5F5FE4E5E5D6D6D62E2E2E636363F8F8F8FFFFFFF6F6F6FFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFDBDBDB636363FFFFFFF9F9F9FFFFFFFFFFFFFAFAFAFFFFFFFDFDFD
F8F8F8FFFFFFF7F7F7FFFFFFFFFFFFF7F7F7FFFFFFF7F7F7FFFFFFABABAB
3131311B1B1B808080F1F1F1FFFFFFFBFBFBFFFFFFF9F9F9FFFFFFFCFCFC
FEFFFDFEFFFD40423FBEBFBFF3F2F51C1B1EC7C6C9FFFEFFFFFEFFFFFEFF
FEFCFDFFFEFDFEFAF7FEFAF6FFFEFAFFFFFAFFFEFDF9F9F9E3E3E3A6A6A6
B2B2B2FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFF9FCFFFBFCFF
FFFBFDFFFDFDFFFEFFFEFFFFFBFFFDFCFFFBF9F5F2FFFDFFFFFDFFFFFEFF
F5F7F2FFFFFAFAF8F7EAE5E79C9A9B3737370F10105A5B5BAAABABF7F8F8
FFFFFFFFFEFFFDFBFCFBF9FAFCFCFCFDFEFEFEFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFF222222CFCFCFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFCFCFCFFFFFFFFFFFFFFFFFFFDFDFDF9F9F9FAFAFAFEFEFE
FFFFFFFFFFFFFEFEFEFCFCFCFEFEFEFFFFFFF9F9F9FCFCFC111111EAEAEA
7777776E6E6EAFAFAF6565657A7A7AC8C8C8FFFFFFFFFFFFFFFFFFFBFBFB
FAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFA040404030303
000000010101000000121210353332F8F8F4FEFFFAF9FFFFEFF8FFF8FFFF
FDFBFEFFFEFDB2B8B473756F7E7468CFC4BEFFFDFFF9FFFFF6FFFFF9FFFD
FEFFFDFFFFFBFFFFFDFFFFFDFFFFFFFFFFFFFFFDFFFDFCFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFBFFFAF2FFFDF6FBFFFFF7FFFF
F3FEFFFAFFFCFEF9F3F9F0EB7C7376FFF9FFFCFFFFF8FCFF595F5F0D1110
F0EEEFFFFEFFFFFEFFF3F3F3595959303030CACACAFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF
ABABAB828282FFFFFFFCFCFCFFFFFFF9F9F9FBFBFBFCFCFCFFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFCFCFC
FFFFFFD3D3D36767670C0C0C5E5E5EC7C7C7FFFFFFFFFFFFFBFBFBFFFFFF
F9FBF8FEFFFD626461939592AAAAAA454447FDFCFFFFFEFFFFFDFFFFFEFF
FFFEFFFDFBFCFFFBFBFFFEFBFFFCF9F9F8F4FFFFFDFFFFFFF9F9F9FDFDFD
FFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFEFFFCFFFFFEFFFF
FFFDFFFFFDFFFEFCFFFBFCFCF9FFF9FCFFFAFFFEFBFDF6F9FFFBFFFEFBFF
FCFFFDFBFFF9FFFEFDFFFBFBFFFEFFFAFAFAE7E8E8979B9A4243450C0D0F
525154A5A4A7F3F1F2FFFEFFFDFDFDFDFEFEFEFFFDF8FCF9FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
F7F7F7D6D6D6242424FDFDFDFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF3C3C3CC2C2C2
1C1C1CD7D7D7FDFDFDFFFFFFF4F4F4BABABA7070706E6E6EBCBCBCFDFDFD
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD606060050505000000
03030300000001010101000004000024231FFCFFFBF9FFFFF7FFFFF9FFFF
FFFCFFFBF6F8F8FBFFFFFFFBFFFCEFCDBCB07775786B727ABBC4C7F5FDFF
F1F5F4FDFDFBFFFFFDFDFDFBFBF9FAFFFEFFFFFDFFFFFEFFFFFDFFFFFEFF
FFFEFFFEFFFFFEFFFFFEFFFDFEFFFDFFFFFAFFFCF2FFFDF4EDEEF0EFF8FB
F6FFFFF9FFFFFFFEFAFFFBF9F6E9EE726A73F7FAFFB7C0C5707A79F9FFFD
FFFDFFFDF6FBF9F7F8FCFCFCFFFFFF8080800B0B0BFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF6F6F6909090
AAAAAAFFFFFFFEFEFEFAFAFAFFFFFFFFFFFFF7F7F7BDBDBDDCDCDCF7F7F7
FCFCFCFFFFFFFBFBFBFFFFFFF5F5F5FFFFFFFCFCFCFDFDFDF6F6F6FFFFFF
FDFDFDFCFCFCF9F9F9F1F1F18E8E8E202020333333959595F6F6F6FFFFFF
FEFFFDFEFFFD7A7C797A7C79292929BEBEBEFBFAFDFDFCFFFEFDFFFDFCFF
FEFCFFFFFEFFFFFDFEFEFCFBF7F5F4FFFEFDFBFBFBFFFFFFFFFFFFFDFDFD
F5F5F5FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFCFDFFFEFFFF
FFFDFFFFFCFFFFFEFFFEFFFFFBFFFAFAFFF8FFFDFAFFFCFDFFF7FFFFFCFF
FBFFFFF9FFFDFBF9F8FFFDFDFFFEFFFFFFFFFDFEFEFBFFFEFEFFFFEBECEE
9D9C9F48474A141213464445AAAAAAEEEEEEFEFFFDFCFEFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFF8282826D6D6DFFFFFFFFFFFFFAFAFAFDFDFDFFFFFFFEFEFEFFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFCFCFC
FEFEFEFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFBFBFB5454547E7E7E
323232FEFEFEFFFFFFFDFDFDFFFFFFFDFDFDFEFEFEFAFAFAC4C4C4707070
6D6D6DB4B4B4FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCBCBCB040404060606000000
000000000000020202030102070101120E0BB8BDB7F6FEFCF8FFFFFAFFFF
F9F3FAFFFCFFFEFEFFF8F6F9FFF5E7BBA99A76757191969AB7BEC4787F85
767C7CB4B8B7F1F2F2FFFFFFFFFDFFFFFCFEFFFCFFFEF9FDFFFDFFFFFEFF
FEFFFFFEFFFFFEFFFFFEFFFDFEFFFBFFFFF8FFF9EE8D8077030706566065
7B8688F2F8F8FDF7F4EBDFDEFFF8FD30283180848BA3ACAFF4FEFDFBFFFF
FFFCFFFFFCFFFFFEFFFEFEFEE2E2E22727275B5B5BFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE696969CACACA
FEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFD2D2D21B1B1BABABAB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFDFDFDB9B9B95050500E0E0E727272
DADCD9FBFDFA9C9E9B3F413E383838FAFAFAFFFEFFFFFEFFFFFEFFFFFEFF
FAF8FBFFFEFFFDFBFCFFFEFFFFFEFFFCFAFBFEFEFEFDFDFDFFFFFFFDFDFD
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFDFFFFFDFFFFFEFFFEFFFDFBFFFBFBFFFAFFFEFBFFFBFDFFF9FEFFFCFF
F8FFFFF7FFFF8E8E8E040000333132AEAEAEFEFFFFFAFEFDFCFFFFFEFFFF
FFFEFFFFFEFFEEECEDA9A7A8434343111111484A479EA09DEDEDEDFFFFFF
FEFEFEFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFF6F6F6
FFFFFF3B3B3BBCBCBCFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF747474383838
8C8C8CFFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFF
FDFDFDC8C8C87D7D7D666666ABABABFAFAFAFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFEFEFEFFFFFF
FDFDFDFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFA1A1A10F0F0F000000010101
0303030000000606060200010400000D0707999B98FBFFFDFCFFFDF7F8F8
FFFDFFFFF9FFFBF8FFFFFBFF917D701100009A978E676B6C080812D2D4E0
F6FAFFD9DEE18488896A6A6AB0ABADF5EFEFFEF7FAFFFDFFFCF9FFFFFEFF
FEFFFFF4F8F9FEFFFFFEFFFDFDFDF9FFFEF6FFF2E7190B00D1D9D7F2FFFF
C2CFD3CCCFD3FFF7F7A29293160D12222126C4CBCFF8FFFFE6EAEB030303
D4D1D7FFFEFFFDFCFFE5E5E51919198F8F8FFFFFFFFDFDFDFFFFFFFCFCFC
FDFDFDFFFFFFFDFDFDFBFBFBFFFFFFFFFFFFE5E5E55C5C5CEEEEEEF9F9F9
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFD4D4D4111111
B2B2B2FFFFFFFEFEFEFEFEFEFDFDFDFFFFFFFDFDFDFEFEFEFFFFFFF7F7F7
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFDBDBDB787878
15171445474482828011110FD5D5D5FAFAFAFFFEFFFDFCFFFFFEFFFFFEFF
FDFCFFFFFEFFFEFDFFFFFEFFFCFBFEFFFEFFFFFFFFFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFF
FFFEFFFFFDFFFFFEFFFEFFFDF8FFFCF8FFF8FFFBF8FFFBFAFFF6F7FFFBFD
F7FFFFEEFDFFFCFCFCABA5A5E2DDDFEAEAEAF9FAFAFCFFFFFCFFFFF7FBFC
FBFCFEFFFEFFFEFCFFFEFCFDFFFFFFF2F2F0A4A6A3525451101010454545
9C9C9CEAEAEAFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFFFFFFFF
E6E6E60C0C0CFCFCFCFCFCFCFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC909090040404
7B7B7BE1E1E1FFFFFFFAFAFAFBFBFBFFFFFFFEFEFEF9F9F9FDFDFDFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFD2D2D28686866262629F9F9FF4F4F4F3F3F3
FFFFFFFAFAFAFFFFFFFCFCFCFCFCFCFFFFFFFBFBFBFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFFFFFF8686860E0E0E050505000000
0000000404040000000100000903030A0404828282FEFFFBFCFCF2FFFFF8
F8F5FBECE8F6FFFBFFFFF7FFC3AFA2E7D6C2F9F9EDFCFFFD96909A44404E
F9FFFFF8FFFFFAFFFFFEFFFFE5E0E2938D8D7B75759D989AF2F0F3F5F6FA
FCFFFFFCFFFFFEFFFFFEFFFDFFFFFBFFFBF3FCE6D92C1B11D7DFDDF1FFFF
F7FFFFFEFEFFFFF4F7F7E7E85D565BE2E5E9F8FFFFF6FEFFA5A4A7010000
DEDDE0FDFCFFDEDDE01414149C9C9CFDFDFDFDFDFDFAFAFAFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBCFCFCF6F6F6FFDFDFDF8F8F8FEFEFE
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFFFFFFF5F5F5FFFFFFD2D2D2
0F0F0FBBBBBBFEFEFEFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFF5F5F5FFFFFF
FFFFFFFBFBFBFFFFFFFBFBFBFFFFFFFFFFFFF8F8F8FBFBFBFFFFFFFDFDFD
F5F7F4A4A6A330302E11110F818181EAEAEAFFFEFFFFFEFFFDFCFFFFFEFF
FFFEFFFCFBFEFEFDFFFFFEFFFFFEFFFBFAFDFDFDFDFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFF
FFFEFFFFFEFFFFFEFFFEFFFFF9FFFFFBFFFFFFFEFBFFFBF6FFF5EFFFFBFA
F1FEFFF2FFFFFAFBFDFFFBF9948F8FD7D7D7FEFFFFFCFFFFF5F8FCFCFFFF
FEFFFFFFFEFFFFFEFFFEFCFDFCFCFCFDFDFBFEFFFDFEFFFDF6F6F6A9A9A9
5858580E0E0E353535999999E6E6E6F8F8F8FDFDFDFFFFFFFFFFFFFDFDFD
8C8C8C686868FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFCFCFCFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB868686060606
6464641717172C2C2C7F7F7FCFCFCFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFF
F1F1F1FFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFDFDFDE0E0E09595956C6C6C
8B8B8BEFEFEFFFFFFFFBFBFBFEFEFEFCFCFCFFFFFFFFFFFFFCFCFCF8F8F8
FCFCFCFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFBEBEBE111111000000040404
060606000000040404020001040000140F11BAB8B9FFFFFAFFFBEC989186
00000400000D0E0518D5C7D2FFFAF1AB9E8D00030000010020141D070008
E4EAF6F5FFFFF8FFFFF7FAFFFFFEFFFFFDFDFFFDFDEAE5E59A989B757678
929599DCE2E2FAFEFFF9FBF8FFFFFBFFFEF6FFFAED605247969A9BF3FFFF
F1F9FFEBEBF3D9CED26D6163FDF8FAFEFFFFF9FFFFF3F9F93939390A0809
CBCACDD2D1D41B1A1D9E9E9EFFFFFFFFFFFFFDFDFDFFFFFFF5F5F5FFFFFF
FEFEFEF7F7F7FFFFFFFBFBFBA3A3A3929292FFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFF
CACACA090909B6B6B6FFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFFFFFFFFFFFF
FBFBFBFFFFFFFEFEFEFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FDFDFDFFFFFFF9F9F9000000616161131313555555C6C6C6FFFFFFF4F4F4
FFFEFFFFFEFFFEFDFFF6F5F8FFFEFFFFFEFFFDFDFDFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFD
FFFFFFFFFFFFFFFEFDFEFFFFF9FFFFFBFFFFFFFEFBFFF4ECFFF4E8FFF9F2
F1FEFFEBFEFFFEFFFFFFFDFBFDF8F86E6E6CF6F7F9FBFFFFFCFFFFFCFFFF
FBFCFFFCFDFFFFFEFFFFFEFFFFFFFFFFFFFDFDFDF9FBFDF8FCFCFCFFFFFF
FEFEFEFDFDFDBABABA5555551212123E3E3E929292E6E6E6F6F6F6FFFFFF
3E3E3EAAAAAAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF404040181818
FDFDFDFFFFFFC9C9C97070702525251D1D1D6D6D6DB5B5B5FFFFFFFDFDFD
FFFFFFFDFDFDF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFBFBFBFDFDFD
EFEFEF9090905B5B5B8C8C8CDCDCDCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF0B0B0B030303000000
0101010000000000000505050503041B191AFCFAFBFCF7F1FFF5E4190F01
9A9FA3F0F6FF877F8A1A0B10F4E5DE0E0500A8AEAAF8FCFB7F6F700E0004
C3CAD8F1FFFFF7FFFFFBFFFFFFFEFFFCF7F7FFFDFBFFFEFBFDFBFCFEFFFF
EBEEF2A6ABAE6D71728D8F8CD7D7D3FEF7EFFFFCEDECDED3030205D6DDE5
D7DBE60A0A12888184FFF9FAFFFDFFF8F7FAFAFEFFD8DCDD080A070B0B0B
A4A3A6121114A4A3A6FFFFFFFAFAFAFFFFFFFAFAFAF9F9F9FFFFFFFCFCFC
FFFFFFFFFFFFF4F4F4828282BEBEBEF9F9F9FAFAFAFDFDFDFFFFFFFFFFFF
FEFEFEFDFDFDFEFEFEFFFFFFFFFFFFFDFDFDFBFBFBFFFFFFFFFFFFFBFBFB
FFFFFFC6C6C6212121BBBBBBF9F9F9FDFDFDFFFFFFFFFFFFF9F9F9FFFFFF
FDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFBF7F7F7
FFFFFFFFFFFFFFFFFF212121DFDFDFE9E9E99292922626262D2D2DA3A3A3
FAFAFAFDFCFFFFFEFFFFFEFFFEFDFFFBFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFD
FEFFFBFFFFFBFFFFFBFFFFFFF7FFFFF9FFFFFFFCFAFFFBEFFFF4E1301F15
323F50DDF1FFFEFEFFE2DCDAFFFDFD7A7A78B1B2B4FCFFFFFBFFFFF4F7FB
FAFBFFFEFFFFFFFEFFFCFAFBFEFCFDFFFFFDFFFFFBFDFDF9FFFFFFF8F8F8
FFFFFFFAFAFAFEFEFEFFFFFFFAFAFAB9B9B96363631111113737377E7E7E
111111FFFFFFF9F9F9FFFFFFFCFCFCFBFBFBFAFAFAFAFAFAFEFEFEFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEEEEE151515050505
FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFD2D2D28383833D3D3D020202595959
AFAFAFEFEFEFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFEFA8A8A86161617A7A7AD2D2D2FBFBFBFDFDFD
FFFFFFFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFAFAFAE1E1E1010101040404
0000000606060A0A0A000000020305F6F6F6FFFEFFFFFDF6EED9C6130500
E7F1F8F4FFFFFFFCFC978984CBC2BD0C0C0CECF6FFF3F8FCFFF8F233211D
939AAAF0FFFFEEFBFFF9FFFFFCFBFEFFFEFBFFFCF9FFFEFAFFFFFDFBFCFC
FAFEFFFBFFFFFCFFFFF2F3F3BAB8B77E7971897D6DDFD2C7E3DCE164626F
3F3E4C4A4C56FFFEFFFFFDFCFFFEFFFFFEFFFDFCFF4A4B4B000100000100
121114A09EA1F5F4F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF2F2F26A6A6ACBCBCBFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFEFEFE
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFEFEFEFEFEFEFDFDFDFCFCFCFDFDFD
FFFFFFFAFAFABDBDBD101010C9C9C9FFFFFFFDFDFDFFFFFFFBFBFBFEFEFE
FFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFF3A3A3AB7B7B7FFFFFFFEFFFDF9FBF8BBBDBA454744
10120F6D6E6ED7D8D8FEFFFFFDFEFEFCFDFDFFFFFFFFFFFDFBFBF9FFFFFD
FFFFFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFB
FEFFFAFFFFFAFFFFFAFFFFFFF8FFFFF7FDFFFFFBF9FFF6E7FFF9DF685648
6D7C91CFE4FFF8FAFFC9C3C12E292911110FECEDEFF8FCFDF8FDFFFBFFFF
FEFFFFFEFFFFFFFEFFFFFEFFFFFDFEF8F6F5FAFAF6FFFFFBF9F9F9FFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFBFBFBC0C0C03F3F3F
0000002929298A8A8ADDDDDDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9F4F4F4F111111
E8E8E8FFFFFFFFFFFFF6F6F6FFFFFFF8F8F8FFFFFFFFFFFFE7E7E7999999
4646460A0A0A4646468C8C8CEAEAEAFFFFFFFAFAFAFFFFFFFCFCFCFFFFFF
FBFBFBFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFF7F7F7B4B4B46E6E6E757575
BCBCBCFFFFFFFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFFE0E0E0474747
0101010A0A0A030303393A3AEAEEEFF6FAF9FFFEFDFFF7EFFFF4E1241405
A9BAC1F0FFFFFFFFF3FFFDEDF7F3F0161A25B8C4D8FBFEFFFFFAECA99588
4D5665EDFFFFEEFDFFF8FFFFFFFEFFFFFEFBFDF7F4FFFFF8FEFEFAFCFFFF
FBFFFFF7FCFFF9FDFEFBFCFCFAF8F7FEF9F1FCF3E2574D41766D723E3746
D8D5E48B8B95D3D2D5FFFFFFFBFBFBFDFDFDCCCCCC020200040400070705
0000020A090C000000000000000000FFFFFFFCFCFCFFFFFFF7F7F7FFFFFF
E6E6E65E5E5EEEEEEEFFFFFFFDFDFDFFFFFF5D5D5DF5F5F5FEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F3F3F3FFFFFFFFFFFFC0C0C00F0F0FC3C3C3FDFDFDB1B1B17A7A7AFEFEFE
FFFFFFFEFEFEFFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFF1F1F1FFFFFF7F7F7FADADADFBFBFBFEFFFDFEFFFDFBFDFAFEFFFD
DEE0DD7A7C79191A1A454646B3B4B4FDFEFEF7F7F5FFFFFDFAFAF8FFFFFD
FFFFFDFBFBF9FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFBFFFFFB
FEFFF8FFFFF8FFFFF8FFFEFFF8FFFFF9FEFFFFFDFBFFF8E9FFFADAB7A694
56647EE4FAFFFCFEFFFFFBF9FCF7F7FBFBF9FCFDFFFCFFFFFBFFFFF3F8FB
FDFEFFFDFEFFFCFBFEFCFCFCFFFEFFFFFEFDFFFFFBFDFDF9FFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFFCFCFCFFFFFFFFFFFFFCFCFCFFFFFFFBFBFB474747
AEAEAEBFBFBF6D6D6D1111112F2F2F787878CFCFCFFEFEFEFFFFFFFBFBFB
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4E4E4E9E9E9E373737
CBCBCBFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFFFFFFFF
FEFEFEF9F9F9ABABAB6262621111113030308B8B8BD0D0D0FDFDFDFEFEFE
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFF6F6F6FEFEFEFFFFFFF9F9F9
C0C0C06D6D6D656565BDBDBDFFFFFFFBFBFBFCFCFCFFFFFFFEFEFEF9F9F9
FFFFFFD8D8D8FFFFFFFCFDFDF9FFFFFBFFFFFFFFFBFFFBF3FFF8E679695A
3F565CEAFFFFFFFFE7CEC7AB7F80805C64774E5E7FF5FAFFFFF8E2B49E87
0A1322E1F8FFF1FFFFF2FBFFF7F8FCFFFEFBFFFEF8FFFFF8FDFDF9FAFEFB
FBFFFFFBFFFFFCFFFFFEFFFFFFFEFDFFFDF8FFFDEFA4978C363135F2EFFE
CFCADC605C6AFEF8FFFEFEFEFBFFFFF9FFFF212222030100060000040000
030404080E0E171818757575A3A3A3FBFBFBFFFFFFFFFFFFFFFFFFC5C5C5
767676FDFDFDFBFBFB9A9A9A242424E7E7E71F1F1FDDDDDDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFF5F5F5BBBBBB161616D5D5D5BDBDBD3E3E3EFFFFFF
F4F4F4FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFFFFFF
FEFDFFFFFEFFFFFFFFFCFCFCFCFCFCFEFEFEFEFFFDF8FAF7FEFFFDFEFFFD
F8FAF7FEFFFDF7F9F69EA09D3739361B1D1ADEDEDCFFFFFDFDFDFBFDFDFB
FFFFFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFDFFFFFDFFFFFB
FEFFFAFFFFF8FFFFFAFFFFFFF7FDFFFBFEFFFFFEFBFFFDEDFFF6DCECDECF
061123EAF9FFFCFFFFFEF9F9FFFEFDFFFFFFFEFFFFFAFEFFFCFFFFFCFFFF
FEFFFFFDFEFFFEFDFFFFFFFFFFFEFFFCFAF9FCFCFAFFFFFDFFFFFFFAFAFA
FFFFFDFFFFFDFCFCFCFFFEFFFCFBFEFFFEFFFFFFFDFEFEFCF4F4F20E0E0E
F5F4F7FFFEFFFCFCFCFFFFFFC4C4C4737373232323252525797979D6D6D6
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE9E9E9121212F3F3F3AAAAAA
D4D4D4FFFFFFF9F9F9FFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFBFBFBFCFCFC
FFFFFFFCFCFCFEFDFFFFFEFFF8F8F8C1C1C16B6B692020202524276D6C6F
C0C0C0F5F5F3FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFDFFFCFCFCFFFFFF
FCFCFCFFFFFFFFFFFFC2C2C2787878676767B1B1B1F3F3F3FFFFFFFDFDFD
FBFBFBFFFFFFFFFFFFFDFEFEFBFFFFF7FDFBFFFEFDFFFBF5FFF9EBE7DAD1
00050B617979D2D4BC49442C565757D6DEF000011C707384CFBCA92B1A06
000510DAECFFF4FFFFF6FCFFFEFFFFFFFFFBFFFEFAFEFDF8FFFFFBFAFCF9
FBFFFFFBFFFFFAFEFFFCFDFDFFFEFFFFF9F6D1C7BD70675E4B494CD3D3DD
2C2836ECE5F2FFFCFFFDFDFDFBFFFF69716F0608050402010900000D0503
4A4B4BC9CFCDFCFFFFF8FAF7FFFFFFFFFFFFFCFAFBFEFCFDA6A4A5969696
FFFFFFF7F8F8FEFFFDFEFFFD8E8E8E242424424041B8B6B7FFFFFFFEFEFE
FDFDFDFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFE
FFFFFFFEFEFEFFFFFFFFFFFFFBFBFBACACAC171717BABABA1A1A1AFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFDFDFDFFFFFF
FFFEFFFBFAFDFFFFFFFDFDFDFFFFFFFFFFFFFAFCF9FDFFFCFDFFFCFBFDFA
FEFFFDFBFDFAFEFFFDFEFFFDFBFDFACFD1CECACAC8FDFDFBFFFFFDFCFCFA
FFFFFDFDFDFBFFFFFDFEFEFCFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFDFFFFFDFFFFFDFFFFFFFDFEFFFCFDFFFFFFFBFFFEF6FFF8EDFFFEF6
1E2125CCD0D7FDFEFFFDFDFDFFFFFFFEFFFFFDFDFDFCFDFDFEFFFFFEFFFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFDFCFFFFFFFF
FFFFFBFDFDF9FCFBFEFFFEFFF9F8FEFFFEFFFFFFFBFFFFFAA0A19B4E4E4C
FDFEFFFEFFFFFEFFFFFFFFFDFFFFFDFFFEFDFDFBFCCDCBCC737275232225
1F202278797BD0D1D3F7F8FAFFFFFFFEFEFEFFFDFCFFFDFCFFFEFDFEFCFB
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFBFBFB
FFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFDFDFD9494945A5A5AFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFFFBFBFFFEFEFFF7F5F6FFFEFDFCFEF9FEFFFDCFCED3818085
30322F151712595957B3B1B0F6F4F5FFFEFFFFFEFFFAF9FEFFFEFFFFFFFF
FEFEFEFBFBFBFEFEFEFFFFFFFFFFFFFFFFFF4848488080806565656B6B6B
EFEFEFFFFFFFFAFAFAFFFFFFFEFFFFFBFCFCFEFEFEFFFEFBFBF3EEFFFEFB
DDE2E5505858030400302F28D2D2D2FCFFFFDBDFE85D5D630800008F8A84
7D8084CAD1D9FBFFFFFEFFFFFFFEFFFDFDFBFFFEFDFEFEFCFDFDFBFFFFFF
FDFEFEFEFFFFFCFDFDFFFFFFFFFFFFB8B6B58C8885FFFCF9ECECEC000004
B2B1B6FFFDFFFBF9FCFFFFFFCBCCCC090A0A0000000707074F4A4ADDDBDA
FEFEFEFCFFFFFBFFFBFCFFFBFFFFFDFFFEFFFFFCFF7A7378BBB6B8FFFEFF
FEFFFFFBFFFFFBFFFAF6FDF5FDFEFE7A797C1B16188B8688FFFEFDFDFBFA
FFFEFFFFFEFFFFFFFFFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFF7F6F9FFFEFFF9F9F9FFFFFFA4A4A4111111090909FAFAFA
FFFFFFFEFEFEFEFEFEFFFFFFFBFBFBFFFFFFFFFFFFF9F9F9FFFFFFFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFCFCF8FFFFFBFFFFFBFBFAF6
83827D8B8B87FFFFFDFEFFFFFEFFFFFCFDFDFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFF9F9F9
FFFFFAFFFFFAFBFAFDF5F4FA787681D8D7DCFCFCF8FFFFF6595A54A1A19F
FBFBFFFEFEFFF8F9F9FFFFFBFDFBFAFFFEFDFFFEFFF9F7F8FFFEFFFFFEFF
C5C6C8797A7C1D1E20262729707070CDCDCDFAF8F7FFFEFDFFFEFBFFFEFD
FFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFEFEFE
FAFAFAFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF393939B2B2B2FFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFCFFFFFAFAFFFFFCFFFFFCFAFFFFF8F5FAF3FEFFFFFEFEFF
FEFFFFE0E1E193958F48474208020050494C949399F0F0F6FBFAFDFDFDFD
FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9272727D6D6D67D7D7D626262
929292636363909090E3E3E3FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF5F5F5
FFFFFFFFFFFFFDFDFDFCFCFCCDCDCD909090FEFEFEFFFFFFF7F7F7DFDFDF
F6F6F6FBFBFBFFFFFFE4E4E4030303000000131313BBBBBBFFFFFFFFFFFF
FFFFFFF8FAF7FCFFFBFCFFFBFBFBF9F5F3F4625D5FE3DEE0FFFEFFFCFBFE
FEFFFFFCFFFFFAFFF9FCFFF8FEFFFDFAFAFA3B3638201B1DF7F5F6FFFDFC
FFFEFFFFFEFFFAFAFAFEFEFEFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFAF9FCFFFFFFF9F9F9FFFFFF7B7B7B000000BEBEBE
FFFFFFFFFFFFFFFFFFF8F8F8FFFFFFF7F7F7FFFFFFFFFFFFF2F2F2FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFAFAF8FDFDF9FFFFFBFCFBF7FFFFFB
DBDAD623231FF8F8F6FEFFFFFEFFFFFAFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FCFDF7FFFFFBFFFEFFFFFEFF3C3A45151419FFFFFBEDEEE411120CEBEBE9
FCFBFFF7F6FCFFFFFFFDFDFBFFFEFDFFFAFAFDFBFCFFFDFEFFFEFFFFFEFF
FEFFFFFEFFFFFEFFFFCFD0D27D7E7E2526261F1F1D6B6B69BFBDBCFEFCFB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFF7F7F7FAFAFAFFFFFFFDFDFDFCFCFC
FFFFFFFFFFFFFDFDFDFEFEFEFFFFFFDBDBDB131313FDFDFDFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFBFFFFF7F7FDFFFBFFFFFBFDFBFBEEFCFFF4F9FDFEF5F7FF
7C7A8D494855F3F9EDFDFFEFFAF1EAAA9FA15F5F67070B143E3F43898989
DDDDDDF9F9F9FFFFFFFFFFFFF7F7F7FFFFFF434343B7B7B7252525C2C2C2
FFFFFFFFFFFFDFDFDFA1A1A16A6A6A808080D5D5D5FFFFFFF9F9F9FFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FBFBFBFFFFFFFAFAFAFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFF8F8F8FFFFFF
FEFEFEFFFFFFFFFFFFE3E3E36E6E6EFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
E1E1E1FFFFFFF8F8F80E0E0E0505055A5A5AF3F3F3FFFFFFF8F8F8FAFAFA
FFFFFFFDFDFDFBF9F8FFFDFCDEDEDC626461EDEFECFBFFFEF4F5F7FEFFFF
FFFEFFFBF9FAFFFFFAFCFBF4FFFFFBDCDCDA0E0F0F202121444444FBF9FA
FFFDFEFFFEFFFFFFFFFFFFFFF6F6F6FFFFFFF9F9F9FFFFFFFAFAFAFFFFFF
FEFEFEF8F8F8FFFFFFFFFFFFFFFFFFFFFFFF979797151515232323171717
E4E4E4FFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF8F8F6FFFFFBFFFFFBFCFBF7FFFFFB
CCCBC7080804E5E5E5FBFCFCFEFFFFFBFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFAFFFFFBFAF9FCFFFEFF97959E0403089E9E9AADAEA6393A34FFFFFD
FFFEFFB7B6BCD3D3D3FFFFFDFAF5F5FFFDFDFFFEFFFFFEFFF4F3F6FFFEFF
FEFFFFFBFCFEFBFCFEFEFFFFFEFFFFFCFDFDD8D8D8888886323230141412
6C6C6CBBBBBBFCFCFCFFFFFFF9F9F9FFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
FAFAFAFEFEFEE8E8E86A6A6AFFFFFF858585616161FFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFCFEFFFEFFFFFCFFFFFDFDFDFFF2FEFFF6FCFFFFF8F7FF
F2EDFF656370F9FFFAFBFFF4FFFCF9FFFBFFF8F8FEF5F8FFB4B5B7676767
1919192A2A2A737373C8C8C8FFFFFFF9F9F9616161818181242424FFFFFF
FAFAFAFFFFFFFBFBFBFCFCFCFFFFFFE2E2E2ABABAB696969808080D7D7D7
FAFAFAFFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFBFBFBFFFFFFFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
FFFFFFFAFAFAFEFEFEAEAEAEC8C8C8FDFDFDFFFFFFFFFFFFDDDDDD131313
0F0F0F1919191616160303039B9B9BFCFCFCFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFB9B7B87F7F7DFDFFFAF8FCF9FCFFFDFEFFFFFEFDFF
FDFAFFFFFEFFFEFDF8FDFCF5BDBCB520201C7374743B3C3E585858504E4F
FBF9FAFFFEFFFDFDFDFFFFFFFFFFFFF9F9F9FFFFFFFEFEFEFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFC7A7A7A262626DDDDDD5A5A5A5C5C5C
232323E5E5E5FEFEFEFEFEFEFAFAFAFFFFFFFBFBFBFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFCFFFFFDFEFEFCFDFDFBFFFFFBFFFEFA
CAC9C5979793E5E5E5FBFCFCFEFFFFFBFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFF8F8F6
FEFEFAFBFBF7FFFEFFFFFEFFC0BEC700000404040063645C90918B9F9F9D
18171C000004F0EFF2FFFFFFFFFDFDFEF9F9FFFDFCFFFEFDFFFFFFF9F9F9
FEFFFFFEFFFFFEFFFFF8F9FBF6F7F9FEFFFFFEFFFFFEFFFFFAFBFBE0E0E0
8282823737371818185E5E5EC1C1C1F3F3F3FCFCFCFCFCFCF9F9F9FCFCFC
FFFFFFF9F9F9FAFAFA050505FBFBFB323232CACACAFAFAFAFFFFFFFBFBFB
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFFFFFDFDFFF9F9FAFAF8FCFFFDF8F9F9FCFDFFFEFEFFFFFCFF
FFF4FA665F62D6E2E0F1FFFFFEFEFFFFFCFFFFFEFFFEFEFCFEFEFEFEFEFE
FFFFFFD0D0D07676762323231A1A1A6666666868682F2F2F7D7D7DFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFF9F9F9F1F1F1ADADAD
6B6B6B6F6F6FC5C5C5FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFF9F9F9FFFFFF
FEFEFEFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFDFDFDFEFEFECDCDCDA8A8A8FFFFFFFCFCFCFAFAFA4C4C4C070707
000000000000000000A3A3A3FCFCFCFFFFFFFFFFFFFFFFFFFCFCFCFAFAFA
F9F9F9FFFEFF8B8C909F9EA3F7F7F5FFFFFAFFFFFBFAF8F7FFFDFFFEFBFF
FFFEFFFEFFFFF8FAF4ACAFA417180EAFB0A8EAE8E9110E14F8F7FA3D3D3D
656565FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFBFBFBFCFCFCF6F6F6575757363636ECECECFFFFFF8484847D7D7D
8C8C8C252525E9E9E9FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFEFEFCF7F7F5FFFFFBFFFFFB
FEFDF9FFFFFDF8F8F8FEFFFFFEFFFFFAFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFCFCFCFFFFFD
FFFFFBFFFFFDFAF9FCFFFEFFDEDDE30F0E130909050102000C0C080A0A08
070609AFAEB3FEFDFFFEFCFDFFFDFDFFFAFA8E8C8B090706353535AEAEAE
F8F9FBFEFFFFFDFEFFFEFFFFFEFFFFFEFFFFFEFFFFFBFCFCFEFFFFFBFCFC
FFFFFFFEFEFEDFDFDF9191913434341717175D5D5DB8B8B8FFFFFFFFFFFF
FFFFFFFBFBFBFFFFFF191919BEBEBE1C1C1CF8F8F8FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFBFFF6F0FFFEF6F0F8F8F7FFFFFFFEFFFAF6FFF6F6FFFAF7FD
FFFBF6AEA5A0A5ADB8F2FFFFF2F7FFFBFBFFFFFEFBFFFFF8FFFEFDFFFFFF
F9F9F9FDFDFDFFFFFFFFFFFFDCDCDC8C8C8C383838050505E0E0E0FDFDFD
FFFFFFFCFCFCFBFBFBFFFFFFFFFFFFFEFEFEF8F8F8FFFFFFFFFFFFFDFDFD
FFFFFFFCFCFCBEBEBE7171715F5F5FC1C1C1FBFBFBF8F8F8FFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFEFEFEFEFEFEFFFFFFFEFEFEFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFEFEFEFFFFFF606060F5F5F5FFFFFFD6D6D6080808000000
0000000606060101014A4A4AFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFF6A6B6DCACDD4FCFFFFFDFDFBFFFCF5FFFDFAFFFDFBFCF5FCFFFCFF
FFFEFFF5F9F87E857E151C12DBDFD0FFFFF6FFFCFF0B050CFCFAFDFDFDFD
3C3C3C626262F9F9F9FFFFFFFCFCFCFFFFFFFFFFFFF7F7F7FBFBFBFFFFFF
FDFDFDFFFFFFF3F3F33B3B3B595959FBFBFBFBFBFBFFFFFF959595626262
FBFBFB8585852F2F2FF0F0F0FDFDFDF4F4F4FFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFBFBFBFFFFFDFFFFFDFDFBFAFFFEFD
FFFEFDF6F6F4FFFFFFFEFFFFFEFFFFFCFDFDFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFD
F8F8F6FFFFFDFDFCFFF9F8FDDCDBE00706090000000202000B0A06010000
A6A4A7FFFEFFFFFDFFFFFEFFFFFDFDFFFDFDFDFBFAA3A1A0D8D8D8E5E5E5
FFFFFFFCFCFCF9FAFCFEFFFFFCFDFFF6F7F9FCFFFFFCFFFFFAFEFFFEFFFF
FEFEFEFFFFFFFEFEFEFFFFFFFFFFFFE6E6E69090903A3A3A0606065F5F5F
A9A9A9FEFEFEFBFBFB3939395C5C5C757575FDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF8FFFAE8E0D8CB00030E2A394CBEB6C3070004AFB2B9FCFFFF
FFFDECF1E6E06B6D84ECF6FFF5FFFFF9FFFFFFFCF5FFFCF4FFFEFAFFFFFF
FFFFFFF9F9F9FEFEFEFFFFFFF9F9F9FFFFFF8B8B8B101010FAFAFAFFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFBFBFB
FEFEFEFFFFFFF7F7F7FFFFFFFFFFFFC1C1C17171716B6B6BB0B0B0F5F5F5
FFFFFFFCFCFCFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7
FFFFFFFFFFFFFBFBFBFAFAFAF0F0F0707070FFFFFFECECEC040404000000
050505000000020202686868FFFFFFFAFAFAFFFFFFF5F5F5FFFFFFF1F1F1
555555E4E5E9F3F7FFFBFFFFFCFCF8FFFEF6FFFBF6FFFCFBFFFBFFFFFCFF
FCFDFF494F4D353F3AEBF4ECF4FBEBFDFDF1FFFCFF271D26D2D0D3FEFFFF
F8F9F9BCBDBDDCDCDCFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFF8F8F8
FFFFFFD7D7D7262626727272FCFCFCFFFFFFFEFEFEFFFFFFBFBFBF3F3F3F
FFFFFFFEFEFE7777772E2E2EF5F5F5FEFEFEFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFBFFFFFDFFFEFDFFFEFD
FDFBFAFFFFFDFEFEFEFCFDFDFEFFFFFEFFFFFDFDFDFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFBFBF9FFFFFD
FEFEFCF7F7F7FCFBFEFFFEFFDAD9DE100F12010100010100070602514F4E
FFFEFFFDFBFEFFFEFFFFFDFFFFFEFFFFFEFDFFFEFDFDFBFA919191E0E0E0
F9F9F9FFFFFFFEFFFFF5F6F8FEFFFFFEFFFFFBFFFFFCFFFFF9FDFEFCFFFF
FEFEFEFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFEBEBEB979797
4343430D0D0D5151513A3A3A141414D1D1D1FFFFFFFDFDFDFEFEFEFEFEFE
FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF6FFFAE29F9989485468EFF8FF2616201A0A0BACB3BBF0FBFD
FFFFF1BBB2AB0B091FECEFFFF7FFFFF8FFFFFCFBF4FFFFF6FFFFFBFEFEFE
FEFEFEFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF4D4D4D0E0E0EFFFFFFFCFCFC
FEFEFEFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFBFBFBFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFDFDFDCECECE7E7E7E
6464649F9F9FECECECFFFFFFFDFDFDFDFDFDFCFCFCFFFFFFFFFFFFFFFFFF
FAFAFAFDFDFDFFFFFFFFFFFFFCFCFCC1C1C18D8D8D9999991F1F1F060606
010101010101000000E9E9E9FFFFFFFFFFFFFFFFFFFFFFFFD5D5D5656565
F7F7F7FDFEFFFCFEFFF8FBFFFFFFFBFFFDF4FFFEF6FFF7F4FFFCFFE9E3EB
3132325A5E5DF2F8F8F8FEFAFEFFF3FFFFF3FFFBFE463E47BBBABDF9FAFA
FEFFFFFCFDFDFDFDFDFCFCFCFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFF
C4C4C41414149D9D9DFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCE5E5E5414141
FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFD
FCFCFCFEFDFFFFFEFFFAF9FEE0DFE20A0A0A0503040402013F3E3AFDFCF8
FFFEFDF3F1F2F4EFF3FEFCFFFFFEFFFFFFFFFEFEFEFFFFFFFDFDFD6A6A6A
F4F4F4FFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFE4E4E4A3A3A31B1B1B0101014B4B4B9C9C9CEAEAEAFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFF
FDFDFDFFFFF8FFFFE9C9C6BB090F27F8F8FFF6DFD9120000D0DCE8F0FFFF
FCFFFFFFFEFBFFFBFFFFFAFFFEFDFFFCFEFFFCFFFBFCFFF8FEFFFDFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFBFBFBF6F6F60C0C0C050505F7F7F7F9F9F9
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F9F9DDDDDD8D8D8D5E5E5E969696E6E6E6FFFFFFFEFEFEFBFBFBFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFEFEFEDFDFDF1A1A1A949494FAFAFA919191
1919194F4F4FE3E3E3FFFFFFFFFFFFFEFEFEFFFFFFB4B4B4828282FFFFFF
F9F9F9FFFEFFFFFBFFFFFCFFFCFAF9FFFFF8FEFFF5FDFEF8D2D1D41F1E23
807E7DFFFEFDFEFBFFFFFEFF8585780A0C00303030AAAAB0FBFFFFFCFFFF
FAFEFFFCFFFFFAFBFDFEFFFFFCFCFCFDFDFDFFFEFFFDFBFCFCFCFAADADAB
121210BABAB8FEFFFDFAFCF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFFFFFBFDFDFB
FFFEFFFFFEFFFFFEFFFDFCFFC0C0C00F0F0F0100000B090AE8E6E5FFFFFB
9998945A5857A09B9F5B585EE5E4E7FDFCFFF9F8FBDFDFDFFDFDFD7D7D7D
B6B6B6FFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FEFEFEFFFFFFFEFEFE3C3C3C343434A9A9A95757570C0C0C3D3D3D909090
E7E7E7FAFAFAFFFFFFFBFBFBFEFEFEFDFDFDFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFFEFFF9FFFFF1F0F1E9101026E2DAEDFFF7E77B6A58838F9DEEFFFF
F9FFFFFFFFFFFFFDFAFFFCFCFFFAFFFFFCFFFBFFFFF9FFFAFEFFFDFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFDFDFDFBFBFBFBFBFB292929DCDCDCFFFFFF
FBFBFBFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFBFBFBFFFFFFE5E5E59393936A6A6A828282E3E3E3FAFAFA
FAFAFAFFFFFFFFFFFFFBFBFBECECEC191919909090797979E4E4E4FFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFFFFFFF9F9F9919191A7A7A7FDFDFDFFFFFF
FFFFFFFFFDFFFFFBFFFFFCFFFFFEFDFCFDF5FBFEF5B7B9B3161717A5A5A5
FFFFF8FFFEFBFFFBFFFEF8FFFFFFF4A1A395DCDEDBE8EBEFFBFFFFFAFFFF
F7FBFCFCFFFFFEFFFFF9FAFCFFFFFFFFFFFFFFFEFFFFFEFF898987191917
D1D1CFFFFFFDF7F9F6FEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFCFCF8FCFCFA
FFFEFFFBFAFFFFFEFFFFFEFFA9A7A60604030604077B797CFFFBFBFFFEFB
8B87848B8686FFFDFFDEDBE2090A0EFBFCFFFAFBFFBFC0C22F3032161719
EAEAEAFDFDFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFF0E0E0E383838FBFBFBFFFFFFF9F9F9B4B4B4676767
0808082F2F2F878787DCDCDCFFFFFFFDFDFDFAFAFAFCFCFCFFFFFFFCFCFC
FAFAFAFFFFFDF5F7F2FFFFFDB7B3BD332A2DFFFDE8978E7D363E50E9F7FF
FBFEFFFFFEFFFDFFF2FFFFF4FFF9FFFFF9FFFBFFFFF8FFFBFCFFFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3E3E3EB2B2B2FFFFFF
FDFDFDFBFBFBFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFEFEFEFBFBFBFFFFFFFFFFFFF7F7F7EEEEEEA5A5A5656565
7E7E7ED9D9D9FBFBFBFFFFFF949494ACACACF9F9F9FFFFFF585858EEEEEE
FDFDFDFBFBFBFFFFFFFFFFFFF4F4F46E6E6ECECECEFFFFFFFEFEFEFFFFFF
FCFCFCFEFDFFFFFCFFF8F5FCFDFBFAFFFFF898979014130ECECCCBFFFEFA
FFFFF4F7F6F1FFFBFFFEF9FFFFFEF7FBFBEE8F8F8DD9DADCFBFFFFF7FFFF
FBFFFFFCFFFFFAFBFDFEFFFFFFFFFFF8F8F8F5F3F4666465343231EBE9E8
FFFFFDFFFFFDFBFDFAFCFEFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFEFEFAFFFFFB
FFFEFFFCFBFFFFFEFFFEFEFE949291020000110F12FFFEFFFBF6F8FFFBF8
DDD9D5120E0BF3EDF4FFFDFF79797F898C91FCFFFFFBFCFFF3F4F8F2F3F5
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFEFEFEADADAD343434272727FFFFFFFCFCFCFFFFFFFAFAFAF6F6F6
FFFFFFC1C1C16A6A6A1919192A2A2A7C7C7CD0D0D0FAFAFAFFFFFFFFFFFF
FEFEFEFFFFFFFEFFFFFEFEFEFDF8FABCB4B166604E61615400000BE7EDFF
FFFCFFFFFEFFFBFFF3FCFFF3FFFBFFFFFAFFFCFFFFF9FFFFFEFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFDFDFD
EDEDEDA8A8A8717171707070B1B1B1FCFCFCFFFFFFF7F7F7FFFFFF494949
E7E7E7FFFFFFF8F8F8D5D5D5575757E8E8E8FDFDFDFFFFFFFFFFFFFDFDFD
FCFCFCFDFCFFFEFEFFFEFFFFFFFEFD6864602D2724E6E0DDFDF9F6F8F7F0
FFFFEFFFFFF8FDFBFFFBF9FFFDFDFBFFFFF4FFFBF86E6C6FEDF3F3F9FFFF
FBFFFFEFF5F5FEFFFFFEFFFFFCFCFCF3F3F3484647535152EBE9E8FEFCFB
FFFFFDFFFFFDFDFFFCFEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFFFFFAFEFFFB
FCFBFFFFFDFFFDFCFFF8F8F854534F0100009C9A9DF8F5FBFFFDFFFFFEFB
FFFDF71F1917E2DBE2FFFCFFA6A9B0454950F9FDFFFCFFFFF9FCFFFEFFFF
FEFEFEFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFEFEFE
FAFAFAFCFCFC6363638F8F8F000000FDFDFDFFFFFFFFFFFFFFFFFFFDFDFD
F3F3F3FFFFFFF8F8F8FEFEFECACACA7373732B2B2B262626616161C5C5C5
FFFFFFFBFBFBFEFCFDF9F7F8FFFDFFFFFDFCF5FAF3FAFFF9555754AEACAF
FFFAFFFFFCFFF8FFFDF8FFF8FFFFF8FFFDFBFFFEFFFEFFFFFEFDFFFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFCFCFCF6F6F6FFFFFFFFFFFF
FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFC1C1C1F8F8F8FDFDFDABABAB7C7C7C6F6F6FBCBCBCF0F0F0FEFEFE
6B6B6B7575755F5F5F333333FCFCFCFFFFFFFBFBFBD8D8D8525252F8F8F8
FFFFFFFEFFFFF6FBFEEBEFF04343434F4949FFF5F4FFFAF9928984030100
7C8067A5ADA0000019DEDFFDFEFFFFD8D5CCFFFCFA857E81B2B6B7F9FFFF
F4FAFAFBFFFFFEFFFFFEFFFFE0E0E0312F306C6A6BFAF8F9FFFEFDFFFEFD
F9F9F7F8F8F6FEFFFBF9FBF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFEFFF9FAFCF7
FDFCFFFFFDFFF7F6FBFFFFFF0F0E0A040300FCF9FFFFFDFFFFFBFDFFFEFB
F9F4EE746E6B1F181FF4F0FA878993515860FBFFFFFBFFFFFBFEFFF6FAFB
FFFEFFFAFAFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF9F9F90E0E0EEAEAEA151515E6E6E6FFFFFFF6F6F6FFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF2F2F2D4D4D48F8F8F292929
181818616161B3B1B2FFFDFFFEF9F9FBFBFBF9FFFFF9FFFD64635C544E4B
FFFBFEFFFDFFF8FFFFF8FFFDFFFFF6FFFEF8FFFDFFFFFDFFFEFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFF4F4F4
F8F8F8FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF6F6F6
777777878787FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFC5C5C58C8C8C707070
7474746A6A6A808080FDFDFDFFFFFFF8F8F8FEFEFEECECEC101010FFFFFF
FFFFFFF8F9F9E2E6E5222625716F70FCF5F8FFF6F8FFFCFA575048C0BEAD
DDE1C4000300555674C5C5E9F7F7FDC5C4BD342C2A0E070AEBEFF0F0F9FB
F9FFFFFBFFFFF7FBFCD0D1D31A18198E8C8DFFFEFFFBF9FAFFFEFDFFFEFD
FFFFFDFFFFFDFEFFFBFEFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFAFEFFFB
FFFEFFFFFDFFFFFEFFFBFBFB0100006F6E6AFFFCFFFDF7FFFFFCFEFFFEFB
FFFBF3D1CBC8040004605C6600020BBFC7CFF0F7FFF9FDFFFCFFFFFCFFFF
FFFEFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8
F9F9F9AAAAAA434343F8F8F8FFFFFFFAFAFAFBFBFBFFFFFFFBFBFBFCFCFC
FFFFFFFAFAFAFFFFFFF7F7F7FDFDFDFBFBFBFFFFFFFFFFFFF9F9F9FFFFFF
DFDFDF9292923F3C420B090C5F5D5CA7A9A4EBF1EFEDF3F1B3B1B0A39F9C
FFFEF7FFFFF8FCFFFFFCFFFFFFFFFAFFFEF9FFFDFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFCFCFCFFFFFF
FCFCFCFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEF5F5F5FCFCFC5B5B5B
414141EDEDEDFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFCFCFCF9F9F9
FFFFFFFFFFFFFCFCFCFFFFFFF9F9F9FFFFFFFDFDFDFFFFFF0E0E0EF2F2F2
FCFCFCC7C7C7151513929290FFFEFFFFFEFFFAF5F7FFFEFB6464588F907C
FFFFE49A9A8D0B0527FEF7FFFBF7FFFFFFFAFFFEFBFAFAF8FBFFFFF8FFFF
F4FCFEF6FBFEB7BBBC141517ADABACFFFEFFFEFCFDFFFEFFFFFEFDFFFEFD
FFFFFBF6F6F2FDFFFAFDFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFEFFFBFCFEFB
FFFEFFFCFAFFFFFEFFBFBFBF010000F8F7F3FFFCFFFFFCFFFFFDFFFFFEFB
FFFCF6F3EDEA231C21F2EEF8FCFEFFF5FCFFFBFFFFFBFFFFFCFFFFFEFFFF
FFFFFFFDFDFDFFFEFDFFFEFDFFFEFDFFFEFDFFFFFDFFFFFDFFFFFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFA4A4A4CECECEFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFEFEFE
FFFFFFFFFFFFFAFAFAFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF
FBFBFBFFFEFFFFFEFFE5E4E797979550524D0206034B4F4EA2A0A1EEECEB
FFFFF5FFFFF6FFFFFDFFFFFFFFFFFBFFFEFAFFFEFDFFFEFFFFFFFFFEFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFEFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFB2B2B2505050
F4F4F4FFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFEFEFEFFFFFFFDFDFDFFFFFF
FEFEFEFEFEFEFEFEFEFCFCFCFFFFFFFFFFFF797979989898212121D3D3D3
A6A6A6131313B8B6B5FFFEFDFEFCFDFEFEFEFFFFFFFCFCF8BDBEB43D3E2C
FFFFE5FDFAEF130A27DDD5F8FFFCFFFDFDFBFDFDFBFEFFFFFAFFFFF4FCFC
FBFFFF9A9DA1101113C8C8C8FFFEFDFFFEFDFFFEFFFAF9FCFFFEFFFEFCFB
F4F4F2FFFFFDFEFFFFFDFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFEFDFFFEFDFFFDFFFFFDFFFFFDFFFFFCFC
FFFDFDF0EAEA20191CC0BAC1FCFAFFFDFDFFFEFEFFFBFBFFFDFEFFFFFEFF
FEFEFEFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFEFDFFFFFFFFFFFFFDEAEBEBABABAB525051100E0D
41403C94938FE5E3E2FFFEFDFFFEFDFFFDFCFFFEFDFFFFFFF9FDFEFCFFFF
FFFEFFFBFAFDFCFFFFFCFFFFF9F9F7FFFEFDFFFCFCFFFEFDFEFFFDFDFFFC
FEFCFDFFFEFFFEFFFFFEFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFDFDFDFEFEFE
FCFCFCFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFCFCFCFFFFFFDADADAFFFFFF
F9F9F9FFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBF6F6F63E3E3E1C1C1C979797
1E1E1ED3D3D3FEFFFFFEFFFDFAFBFBFEFEFCFFFFFDFBFAF6FEFDF6605D54
959287FFFDF9524E589B97A5FEFDFFFEFFFFFEFFFFF8FBFFF8FCFBFCFFFF
71727626272BDFDFDDFDFCF7FFFEF8FEFAF6FFFEFFFAFBFFFDFBFEFFFEFF
AEAEACB3B4B4FCFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFF8F3F5FFFDFFFAF5F7
FFFBFEDDD6D9A69FA2C4BFC3FFFCFFFDFBFFFBF9FFFFFEFFF9F8FDFEFEFE
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFEFEFEFEFEFEFFFFFFFFFFFFFEFCFBFBF9F8
B2B0AF5C5A591917162E2C2B858382DFDDDCFFFEFDFEFEFEF9FDFEFCFFFF
FFFDFFFFFEFFFCFFFFF3F9F7FFFFFDFFFBFBFFFDFDFFFFFDFCFFFDFCFFFD
FFFDFFFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFE5E5E5FAFAFAFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFFEFEFEFFFFFFF5F5F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEE3E3E30F0F0F4C4C4C
EDEDEDFDFEFEF8F9F9F6FAF9FEFFFDFEFFFDFBFAF6FEFDF9FFFEFAFFFEFA
8F8B88726E6B171516525154FBFAFFFCFCFFFBFEFFFCFFFFF3F7F6525451
3F3E43ECEAEDFFFFFBF8F5EEFFFEF4FFFEF7FBFEFFFCFEFFE8E6E9A09B9B
8985822D2D2DD6DAE5F4FAFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFBF9FAFFFDFFFFFDFF
989194D9D2D5FFFBFEFFFCFFCDC9D392909BFFFDFFFEFDFFFEFDFFFDFDFD
FFFFFFFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFDFC
FDFBFAFFFEFDF7F5F4C8C6C56969691515152828287B7B7BC9CDCCFEFFFF
FBF9FAFFFEFFF3F7F6FBFFFFFCFCFCFBF9FAFFFEFFFDFDFDFAFEFDFAFEFD
FFFCFEFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFD
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFCFCFCFBFBFBF9F9F9
FBFBFBFFFFFFFBFBFBFFFFFFCECECE747474FFFFFFFEFEFEFFFFFFFDFDFD
FCFCFCFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFEFEFE6D6D6D0A0A0A
C7C7C7FEFFFFFEFFFFFCFFFFFEFFFDFCFEFBFFFFFBFDFCF8FFFEFBFFFCF9
FFFDFAFCF8F5F9F7F8010003E9E8EDFEFEFFFCFFFFE6E9EE363C3C5A5E5D
F4F2F5FBF6F8FFFEFBFFFFF6FFFCEEFFFFF8F4FAFFF8FBFFFFFDFF4F4840
DBD4CC666463D7DDE9F8FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFAF8F9FFFEFFFAF5F7FDF8FA
F2EBEE3B3437FFF8FBFDF8FC2B2731E7E5EEFFFEFFFFFEFFF6F5FAFFFEFF
FDFDFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFCFCFCFFFFFFFFFFFFFFFEFDFFFDFC
FFFEFDFFFEFDFEFCFBFCFCFCFFFFFFFFFFFFC9C9C97475752324241F1F1F
726D6FC2BDBFF9FDFCFBFFFFFFFFFFFFFEFFF9F7FAFEFEFEFBFFFFFCFFFF
FFFDFFFFFCFFFFFFFFFDFEFEFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFEFEFEFEFEFEFFFFFF
FDFDFDFFFFFFFBFBFBBBBBBB151515CDCDCDFFFFFFFCFCFCFAFAFAFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFA9A9A93C3C3C
1F1F1FE8E9E9F8F9F9F5F9F8FEFFFDF2F4F1FFFFFBFFFFFBFDF9F6FFFEFB
FFFEFBFFFDFDF3F1F2202020B6B5BAF6F7FBE0E3E81E2126767C7CF6FAF9
FFFEFFFFFDFFFFFBF8FEF9F1FFFFEDFFFEF7F1FEFFF2FCFFFFFDFDFAEBE3
83796D8A8683BDC4D2F7FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFAF8F9FFFDFFFFFDFF
FFFDFFA7A2A49A9597979296ACA9B0FFFDFFFBFAFFF4F3F8FDFCFFFFFEFF
FDFDFDFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
F6F6F6FFFFFFFFFFFFFBFCFEFEFFFFFEFFFFF9FAFCFEFFFFFFFFFDCDCBCA
888282342F31171B1A5E6464B5B6B8F5F4F7FFFEFFFDFEFFF5FBFBFCFFFF
FFFDFFFDF6F9FBF9F8FFFFFDFDFDFDFEFEFEFEFEFEFDFDFDFEFEFEFFFFFF
FFFFFFFBFBFBFDFDFDFFFFFFFFFFFFF7F7F7FEFEFEFFFFFFFCFCFCFBFBFB
FFFFFFFDFDFDE6E6E60F0F0FC8C8C8FFFFFFFFFFFFFBFBFBFFFFFFFBFBFB
FFFFFFFCFCFCFFFFFFF3F3F3858585FDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFC5C5C5303030
7B7B7B363737FCFDFDFCFFFFFCFEFBFEFFFDFDFBFAF8F6F5FFFEFBFFFBF8
FBF6F6FFFBFBE1DFE09D9D9DBCBBC0CACBCF0C0F149DA0A5FBFFFFFCFFFF
F8F7FAFFFEFFFEFEFAFFFEF4FFF6E7A19893000A1DC3DCF0F8EFF0FFF9EF
FFF7EC221C195D6675F2FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFCFDFDF8FAFFFDFF
F7F2F4FFFDFF2D282A444245FEFBFFFFFEFFFFFEFFFFFEFFFFFEFFFEFDFF
FFFFFFFCFCFCFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFCFCFCFFFFFFFFFFFF
FFFFFFFCFCFCFEFFFFFEFFFFFBFCFEFEFFFFFEFFFFFDFDFDFFFEFDFFFEFB
FFFAFBFFFBFBD6DAD98C9292424347111015555459A9AAAEF0F5F8FCFFFF
FFFAFCFFFCFFFFFEFDFBFBF9FFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFF
FFFFFFFEFEFEFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFEFEFEFFFFFF
F6F6F6FFFFFFAAAAAAD7D7D7FFFFFFF9F9F9FEFEFEFFFFFFFEFEFEFFFFFF
FBFBFBFBFBFBFFFFFFB3B3B3464646FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9FFFFFFFEFEFEE6E6E61A1A1A
FEFEFE535353626363FCFFFFF8FAF7FCFCFAFAFAF8FFFEFDFFFEFBFFFCF9
FFFDFDFFFEFDFFFEFFFFFFFFA9A8AB0E0F13B9B9BFFCFFFFFCFFFFFCFFFF
FDFCFFFFFEFFFCFBF7FFFEF6FFFBEDBAB1AC3C51649DB3C8FFFCFDFFF1E6
FFF7EBFFFCF9636C79EDFAFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFEFCFDFCFAFBFFFEFF
FFFEFFFFFEFFE8E3E5E9E7EAFEFBFFFAF9FFFEFDFFFFFEFFFCFBFEF9F8FB
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFBFAFEFCFBFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFBFCFE
F9FAFCFEFFFFFEFFFFF9FAFCFCFDFFFDFEFFFBFCFEFFFFFFFEFAF7FFFDFA
FFFCFBFFFDFDFCFFFFF6FCFCEFF2F6EBEBF197979D4245490D1517424848
ABA6A8EDE6E9FFFCFCFFFEFDFAFAFAFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFBFBFBFFFFFFF8F8F8
FFFFFFF8F8F8F6F6F6FFFFFFFFFFFFFFFFFFFEFEFEFAFAFAFBFBFBFFFFFF
FAFAFAFFFFFFFFFFFF5A5A5A919191FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFFFFFF303030
F3F3F3F4F4F42E2F2F8A8B8BFFFFFFFFFFFFBDBDBBC0C0BEF7F5F4FFFEFD
F7F5F4FFFEFDFFFDFE7F7F7F242326D2D3D5FCFDFFFCFFFFFBFFFFF7FBFA
FCFAFDFFFCFFFFFDFDFCF7F1FFFFF1E9EAE2080D1EEFF1FFFFFDFFFFFDF4
FFFDF2F9F8F4F5FBFFF8FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFFFEFFFFFEFFFFFDFE
FEFCFDF9F7F8FFFDFFFCFAFDFFFEFFFFFEFFFFFEFFFAF9FCFFFEFFFFFEFF
FDFDFDFDFDFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFCFCFCFCFCFCFEFFFFFEFFFF
FEFFFFFCFDFFFCFDFFFEFFFFFEFFFFFEFFFFFDFEFFFEFEFEFFFEFBFFFBF8
B6ACAB0E0808DFE3E2FBFFFFFCFFFFFBFBFFFEFEFFFBFEFFE5EDEFA8AEAE
4B464A140D10454040999796EDEDEDF8F8F8FFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFEFEFEFBFBFBFFFFFFFDFDFDFFFFFFF9F9F9FFFFFFF4F4F4969696
FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFDFDFD101010E8E8E8FCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFFFFFFFF
F9F9F9FFFFFFDBDCDC1A1B1BB9B9B9FCFCFCA2A2A05A5A58FFFEFDFFFEFD
FFFEFDF5F3F2676767353535DFDEE1FFFEFFFEFFFFFDFEFFF9FDFAFCFFFD
FFFEFFFFF9FFFFFCFCFFFEFAFBFCF2FFFFFA27232DCAC6D4FCFAFDFEFDF9
FDFEF8FEFFFDF4F8FFFBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFF
FEFFFFFDFEFFFAFBFDFEFFFFFBFBFBFEFEFEFAFAFAFFFFFFFEFDF9FFFEFB
FFF6F7635D5DF0F4F3FBFFFFFBFEFFFEFEFFFEFEFFFCFFFFF6FEFFF6FCFC
FFFDFFF7F0F3AEA9A95D5B5A131313383838898989DADADAFFFFFFFFFFFF
FBFBFBFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFFEFEFEF4545458E8E8E
FCFCFCFFFFFFF8F8F8FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF8F8F8FFFFFF
FEFEFEFFFFFFC3C3C32E2E2EFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFC2C3C3151515DBDBDBBCBCBC444444FCFAF9FFFEFD
F7F5F64341424C4C4CF8F8F8F1F0F3FFFEFFFEFFFFFEFFFFFFFFFBFFFFFD
FCFFFFFCFFFFFEFFFFFFFFFDFFFDFDFFFDFB94908D767475FFFEFFF8F8FE
FCFFFFFBFFFFFCFFFFFDFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEF9F9F9
F9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFF
FBFCFEFDFEFFFDFEFFFFFFFFFFFFFFFFFEFDFFFEFDFCFAF9FFFFFDFFFEFD
FFFDFD9B9698B7BBBCFBFFFFF9FCFFFEFFFFF9F9FFFCFFFFF9FFFFFBFFFF
FFFDFFFFFCFFFFFEFDFFFFFDF4F4F4BDBDBD6969691212123131317B7B7B
D2D2D2FFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FBFBFB353535686868FFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFAFAFAFFFFFFFBFBFBFFFFFFF8F8F8
FBFBFBFFFFFF717171858585FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9FAFAFDFEFE9B9B9B292929D9D9D9191919FFFEFDE0DEDD
2A2829706E6FFCFCFCFEFEFEFFFEFFFEFDFFF8F9FBFEFEFCFFFFFAFFFFFB
FCFFFFFBFFFFFCFFFFFEFFFFFFFDFFFFFDFDE4D7CE190E08F1F1F9F8FFFF
F5FFFFF6FDFFFFFFFFFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDF7F7F7FFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFFFFFFF7F7F7FCFAF9FFFEFBFFFBF8F5F4F0FCFDFDF8F9F9
FFFAFCDEDCDF6B7171F5FDFDFEFFFFFAF9FCFFFEFFFDFEFFF8FEFEFCFFFF
FFFBFDFDF6F9F9F7F8FCFCFCFFFFFFFBFBFBFCFCFCFFFFFFC6C6C6727272
2020201F1F1F757575CACACAF8F8F8FFFFFFBDBDBD7C7C7CFFFFFFFAFAFA
FFFFFFF6F6F6FBFBFBFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFF181818DADADAFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF646464414141090909DCDCDC1C1C1C
8F8F8FFFFFFFF9F9F9FFFFFFF8F8F8FFFFFFFFFFFFFDFDFBFFFFFAFFFFFB
FEFEFFFEFEFFFFFEFFFEFFFFF5FFFFFCFFFFFFEBE13A1D17DEE0EAE9FCFF
F0FFFFF3FFFFFFFBF8FFFCF9FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFF
FFFFFF000000FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FCFDFFF7F7F7FFFFFFFFFEFDFCF8F5FFFDFA9A949114100DCCD0D1FAFFFF
FFFEFFFCFBFF545A5AF3FBFBFEFFFFFFFDFEFCFAFBFEFEFEFCFFFFFCFFFF
FFFDFFFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFF6F6F6FAFAFAFFFFFF
F9F9F9D1D1D17878782A2A2A1B1B1B6D6D6DA0A0A0FFFFFFFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFF8F8F8FBFBFBFBFBFBFFFFFFFDFDFDFFFFFF8F8F8F
666666D4D4D41C1C1CFDFDFDFEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFAFAFAFBFBFBFFFFFF444444080808585858ADADAD
FEFEFEFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFAFAFAFFFFFDFFFFF8FFFFFB
FEFEFFFEFEFFFFFEFFFEFFFFF4FFFFFCFFFFFFF1E733140F9FA1ABEEFFFF
F0FFFFF4FFFFFCF8F5FFFDF8FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFFFFFF
F8F8F8000000FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFFFFFAF8F7FFFCF9FFFDFAFFFCF7B5ACA5494541B1B6B9F7FFFF
F7FAFFD2D2D8171F21C6CCCCFBFBFBFFFDFDFFFDFDFFFEFDFCFFFDF8FCFB
FDF8FAFFFCFEFEFFFFFAFEFFFCFDFDFBFBFBFFFFFFFEFEFEFBFBFBF8F8F8
FFFFFFFEFEFEFFFFFFCDCDCDDADADA8C8C8C3737370B0B0B616161B1B1B1
EEEEEEFFFFFFFBFBFBFFFFFFFDFDFDFCFCFCFFFFFFFEFEFEF6F6F6B4B4B4
5353538585856F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF1F1F10B0B0B666666FDFDFD
FFFFFFFFFFFFF8F8F8FCFCFCFCFCFCFEFEFEFFFFFDF8F8F4FFFFFAFFFFFB
FEFEFFFCFFFFFEFFFFFEFFFFFCFFFFFFFEFFEBD7CEB7A39EABADB7F1FDFF
F4FFFFF8FFFFFFFFFBFDF7F4FFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFA070707FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFEFDFFFEFBFFFCF9FDF5F0FFFDF6F7ECE4110B08EDF4F8F6FFFF
FBFFFFFBFEFFF7FFFFF4FAF8FEFEFCFFFEFBFFFDFBFFFDFAFCFEFBFEFFFD
FFFDFFFFFEFFFCFFFFFAFEFFFCFDFDFFFFFFF5F5F5FFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDA7A7A7535353FBFBFBFFFFFFFBFBFBE3E3E39E9E9E3E3E3E
0F0F0F5858589F9F9FEAEAEAFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFCBCBCB
2F2F2F2F2F2FC1C1C1F9F9F9FDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9F9F9FCFCFCFEFEFEFEFEFEFCFCFC4F4F4F060606CACACA
FAFAFAFFFFFFFFFFFFFEFEFEFFFFFFFCFCFCFFFFFDFFFFFBFFFFFAFFFFFB
FEFEFFFCFFFFFEFFFFFFFEFFFFFEFFFFFCFFFFFBF6FFFBFAFEFEFFF8FFFF
F2FBFEF9FFFFFCFCFAFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEF8F8F8FFFFFF
FFFFFF000000FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFDFBFAFFFBF8FFFDFAFFFDF6FFFBF3FFFAF22C2623BDC7CCF4FFFF
F4FAFFFBFFFFF2FBFDF9FFFFFFFEFDFFFDFBFFFDFBFFFEFAFEFFFBFEFFFD
FFFBFDFAF8F9FBFFFFFBFFFFFCFDFDFFFFFFFFFFFFEFEFEFFFFFFFFEFEFE
FCFCFC8E8E8E191919EBEBEBFFFFFFF6F6F6FFFFFFFFFFFFFDFDFDFFFFFF
E9E9E9A0A0A05454540404044C4C4C919191E1E1E1FFFFFFFEFEFEF1F1F1
070707111111FBFBFBFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFF0F0F0FFFEFF84838658595B17181A
E8E9E9FDFEFEF6F6F6FFFFFFFFFFFDFFFFFDFBF9F8FCFCF8FFFFFAFFFFFD
FEFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFEFFFFFBFDFFF9FDFCFBFFFBFFFF
F4FAFAF8FEFAFEFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEFFFFFF
FCFCFC050505FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFEFDFFFEFBFEF9F3FFFEF6FFF9F0FFFDF394908C747D82F3FFFF
F9FFFFF9FDFFF9FFFFFBFFFFFFFEFDFFFEFBFFFDFBFFFEFBFEFEFAFDFFFC
FFFEFFFFFEFFFCFFFFF9FDFEFEFFFFF5F5F5FFFFFFFFFFFFFBFBFBFDFDFD
E2E2E2272727E5E5E5FBFBFBFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFF
FFFFFFFCFCFCFFFFFFF3F3F3AAAAAA5E5E5E0D0D0D3C3C3C8D8D8DE4E4E4
0E0E0E515151FEFEFEFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFF7F5F6FFFFFFFFFFFFFAF9FC99989B5C5D5FB3B4B6
717272FCFDFDFFFFFFFFFFFFFDFDFBFFFFFDFFFEFDFFFFFDFFFFFBFEFFFD
FFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFEFFFFFCFFFFFAFFFFFEFFF9FDFE
FCFFFDFCFFFDFAFBFBFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFDFCFFFBF8FFFFF8FFFDF5FFFEF4FFF9EEDDD9D50F0F17F8FAFF
FBFAFFFEFEFFFDFDFFFEFFFFFAFAFAFFFEFDFFFDFCFFFEFDFFFFFDFFFFFD
FFFFFFD2D2D2A7A8AAFEFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFBFBFB
CFCFCFEEEEEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFF1F1F1B9B9B96464643B3B3B
0D0D0D8B8B8BFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFBEBEBE444444FCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFFFF
FEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFDFFFEFBFFFEFAFCF9F0FFFDF2FFFEF4FAF6F2221F26DDDBE8
FFFDFFFFFDFFFDFCFFFFFEFFFFFEFFFEFEFEFFFFFDFFFFFDF7F7F5FCFCFA
FFFFFFECECEC141316F9F8FBFFFFFFFFFFFFFBFBFBF7F7F7FCFCFCFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFBFDFDFDF7F7F7
010101A1A1A1FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFEFEFEFBFBFBD5D5D5FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFDFEFFFEFDFFFEFBFFFEFAFFFCF5FFFFF6FFFFF4F3EFEB1F1C239F9DAA
FEFCFFFFFDFFFDFCFFFEFDFFFFFEFFFFFFFFFFFFFDFCFCFAFFFFFDFFFFFD
FFFFFFFBFBFB2E2D30C0BFC2FAFAFAF9F9F9EFEFEF5F5F5FFFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFBFBFBF9F9F9FFFFFFFFFFFFFFFFFFA5A5A5
2121218A8A8AFCFCFCFFFFFFF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFEFCFDFDF8F8FFFEFBFFFEFAFFFFF8FDFAF1E5E4DFA29FA6C2C0CB
FCFAFFFDFCFFFFFEFFFEFDFFFEFEFEFDFDFDFAFAF8FAFAF8FFFFFDFAFAF8
FAFAFAFFFFFF7C7B7E79787BFFFFFFD8D8D82828289E9E9EFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFAFAFAFBFBFB606060
555555696969FFFFFFF9F9F9FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFAFAFAF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFDFEFFFEFDFFFDFAFFFCF8FFFEFAFAF9F5FFFDFFFDFCFF
FFFEFFFFFEFFFFFEFFFDFDFDFEFEFEFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFFFBFAFDC3C2C5343336EDEDED1C1C1C999999FEFEFEFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFAFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC131313
959595525252FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFEFFFFFEFFFFFEFF
FDFBFEFFFEFFFFFEFFFFFEFFFFFDFDFFFBF8FFFEFBFFFEFDF7F6F9FFFEFF
FCFBFFFFFEFFFFFFFFFEFEFEFEFEFCFFFFFDFFFFFDF5F5F3FFFFFDFFFFFF
FCFBFEFFFEFFFFFEFF0B0A0D858585BABABAFFFFFFFFFFFFFFFFFFFAFAFA
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFBFBFBFAFAFAFEFEFEC5C5C54A4A4A
E5E5E5717171F4F4F4FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFAFAFAFFFFFFFBFBFBFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FDFCFFFFFEFFFCFAFDFFFEFFFFFEFFFEFCFBFFFDFCFDFBFCFFFFFFFFFEFF
FAF9FCFFFFFFFFFFFFFFFFFDFFFFFDFBFBF9FEFEFCFFFFFDFFFFFFFCFCFC
F7F6F9FFFEFFFFFEFF535255191919A2A2A2FBFBFBFFFFFFFEFEFEFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF666666888888
FEFEFEFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFF9F9F9FFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFEFCFFFFFEFFFFFEFFFDFBFCFFFDFEFFFEFFFCFCFCFFFFFF
FDFDFDFFFFFFFEFEFCFCFCFAFCFCFAFFFFFDFFFFFDFFFFFDFEFEFEFFFFFF
FFFEFF9D9C9FFEFDFF98979A4C4C4C181818A7A7A7FFFFFFFFFFFFFBFBFB
FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFEFEFEFBFBFBFDFDFDFDFDFDF9F9F90F0F0FE7E7E7
FFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFEFEFCFFFFFDFFFFFFF5F5F5
727174535255FFFEFFDFDEE1171717D6D6D6171717999999FFFFFFFEFEFE
FAFAFAFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFAFAFAFFFFFFFAFAFAFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFF5F5F5FFFFFFFFFFFFADADAD414141FFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDF9F9F7FEFEFE606060
3C3B3EEFEEF1FEFDFFFFFEFF252525C7C7C7E5E5E51D1D1D979797FBFBFB
FFFFFFF9F9F9FFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFDFDFDFCFCFC989898BDBDBDFFFFFF
F9F9F9FEFEFEFEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFDCDCDC4C4C4C
F9F9F9FFFFFFFFFFFFFCFCFCA2A2A2B0B0B0FCFCFCE0E0E0242424676767
F6F6F6FFFFFFFCFCFCFDFDFDFFFFFFF7F7F7F8F8F8FCFCFCFFFFFFFFFFFF
FCFCFCFFFFFFF7F7F7FFFFFFFFFFFFFEFEFEF9F9F9FFFFFFFFFFFFFFFFFF
FDFDFDFEFEFEFFFFFFFDFDFDFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFDFDFDFBFBFBFEFEFEFCFCFC
FFFFFFF8F8F8FAFAFAFFFFFFFFFFFFFDFDFDFAFAFAFFFFFFEBEBEB646464
1F1F1FD0D0D0FFFFFFFCFCFCFBFBFBFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFFFFFFFF8F8F8FCFCFCFEFEFE
FFFFFFFDFDFDFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFDFFFFFEFFFFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFBFBFBFCFCFCFEFEFEFFFFFFFCFCFCFFFFFFFFFFFF
A3A3A3181818949494F8F8F8FFFFFFFCFCFCFCFCFCFBFBFBFFFFFFFFFFFF
FCFCFCFDFDFDFDFDFDFFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFAFAFAFFFFFF
FCFCFCFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFF7F6F9FFFFFFF9F9F9
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FAFAFAFFFFFFFCFCFCFDFDFD
FEFEFED8D8D83131315C5C5CDCDCDCFFFFFFFFFFFFFFFFFFF7F7F7FDFDFD
FDFDFDFFFFFFA2A2A2CECECEFFFFFFEFEFEF696969F8F8F8FFFFFFFFFFFF
F8F8F8FFFFFFFCFCFCFEFEFEFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFFFFFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFAFAFAFFFFFFFAFAFAFCFCFCFFFFFF
FDFDFDFFFFFFFEFEFE7474741313136C6C6CEAEAEAFDFDFDFFFFFFFCFCFC
FFFFFFFCFCFCBEBEBE2B2B2BFDFDFD898989666666FFFFFFFFFFFFFBFBFB
FDFDFDFFFFFFFBFBFBFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFEFFFDFEFFFDFEFFFDFFFEFFFFFDFFFFFEFFFFFFFF
FFFFFFFEFFFDFEFFFDFFFFFDFFFEFFFFFEFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFEFDFFFFFEFFFCFCFC
FDFCFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFFF9F8FBFFFFFFFCFCF8FDFEF8
FFFFFBF9F9F9FCFDFFFEFFFFE8E6E9716F72121315808181F5F5F5FEFEFC
FAFAFAFFFFFFFBFBFB292929C1C1C1323232BFBFBFFEFEFEFEFEFEFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFFFDFFFEFFFFFCFFFBFBFFF8FCFFFBFFFCFFFFFBFFFCF9FFFFFFFF
F8FAF7F9FEF8FCFFF8FEFFFAFFFCFFFFFBFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFF
FFFEFFFFFEFFFFFFFDFFFFFBFEFFFBFEFFFDFEFFFFF9FAFCFBFCFEFEFFFF
FBFCFFFEFFFFFCFBFEFEFEFEFEFCFDFFFEFFFBFBFFFEFFFFFEFEF1FDFEEC
FFFFF6FEFFFDF9FDFFFCFEFFFFFCFFFFF9FFD8DDE15159591A1A188D8C88
E5E5E3FFFFFFFFFFFF9696963D3D3D202020F9F9F9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFFFDFFFEFFFFFBFFFBF9FFF8FBFFFBFFFCFFFFFBFFFFFCFFFFFFFF
FEFFFDFCFFFBFBFFF7F4F6F0FFFCFFFFFBFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFAFEFFFAFEFFFBFEFFFFFEFFFFFEFFFFFEFFFF
F7F8FCFFFEFFFFFEFFFFFEFFFFFDFDF9F7F8FBFEFFFCFFFFF9F9EDEBECDA
0B0C02414542293038F1F3FFFEF8FFFFFCFFFBFFFFF9FFFFCDCDCD605E5D
0F0F0F4A4A4AA4A4A4EFEFEF101010CFCFCFFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFCFFFFFBFFFDFCFFFDFFFEFFFFFDFFFFFEFDF9F9F7
F7F8F8FCFFFFFCFFFDFEFFFDFFFEFFFFFBFDFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFFFDFFFFFBFFFFFBFEFFFBFEFFFDFDFEFEFEFFFFFDFCFFFFFEFF
FDFCFFFFFEFFFFFEFDFCFBF7F1EDE99C9A999B9EA5A5A8AFFFFEFFFFFFFA
DFE4DD9FA5A1E8EAF4FCFCFFFCFBFEFFFFFDF9FDFCFCFFFFFFFEFFFDFCFF
FAF9FC9D9D9D4C4C4C0F0F0F383838717171FFFFFFFCFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFEFFFFFDFFFFFEFDFFFEFD
FEFFFFFEFFFFF8FCF9FEFFFDFFFEFFFFFEFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFDFFFFFDFFFFFBFEFFFDFEFFFFFEFFFFFEFFFFFBFAFDFFFEFF
FFFEFFFFFDFCFFFEFAFFFFFBFFFDFDE3E1E2101115D5D5DBFFFDFFFDFCFF
F7FBF8DADEDD8E8E96F9F9FFFEFFFFFBFDFAF7F8FAFEFFFFF8F9FDFFFEFF
FFFEFFFDFDFDFFFFFFE2E2E2919191141414EEEEEEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFFFFFEFFFEFFFBFCFFFAFCFFFBFEFFFDFFFEFFFFFDFFFCF6FDFFFEFF
FDFFFAF8FDF6FEFFFAFEFFFBFDFBFEFFFEFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFCFCFCF8F5FFFFF8FFFDFDFBF7FFFEFAFF706C69A09F9BFDFDFFFCFFFF
FFFEFFFFFFFFC4C7CC95989DFDFEFEFEFFFFFBFBFFFEFEFFFEFFFDFEFFFB
F5F5F3FFFFFFFFFFFFEEEEEEF6F6F6515151969696FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFEFFFFFEFFFFFFF8FFFFF6FFFFF8FFFFFBFEFFFFFEFEFFFFFDFFFFFEFF
FFFFFAFFFFF4FFFFF6FFFFFBF8F9FDFEFEFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFEFFFEFDFFFFFEFFFFFEFFFDFBFC
FFFDFAFFFEFAFFFDF5DAD5D500000E2621318D858266615BF5FCFFF9FFFF
EBE6E8FBF6F6E7ECF03B4248F7F8FCF7F6FBFDFBFFFEFEFFFDFFF9FBFEF5
FFFFFDFEFEFEFBFBFB151515E6E6E6C0C0C0272727FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
F9FFFFFCFFFFFFFFF6FFFDF3FFFBF6FFFCFAFBFFFFF7FFFFF9FFFFF8F8FE
FFFFF8FFFDF2FEF3EBFFFDFBFBFFFFF8FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFCFFFFFAFEFEF9FB
FFFDFBFFFEF8FFF8EEBBB7B4090818FFFBFF2A1B1E18100EE2EEF8F5FFFF
FFFDFA685E5C00010989929FFFFDFFFFFCFFFEFEFFFAFEFFFEFFFAFFFFF8
FFFFFDFBFBFBB5B5B5393939FDFDFDF8F8F83B3B3BB1B1B1FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
F9FFFFFBFFFFFFFEF8FFFCF4FFF9F6FFFBFAF9FFFFF5FFFFF5FCFFFEFFFF
FDFAF390877E1C0E0B352D2BA3ABADF7FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFEFBFFFFFCFFFFFDFF
FFFDFAFFFDF5FFFEF3CDC9C5100F1FFAF5FFFAEAEB070000C7D7E4EEFEFF
FFF7F9FFFBFAEDF7FEF2FFFFFBF8FEFFFCFFF7F8FCF8FCFDFEFFFBFEFFF9
FFFFFDFEFEFE5656569C9C9CFFFFFFFFFFFFCCCCCCA5A5A5FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFAFCF9FEFDF9FFFDFAFFF9FAFFFCFBF9FDFCF9FFFFFFFEFFFFFDFF
FFFEFDF9F8F4AEA5A6DCD5D8E5EBEBF9FFFFFEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFDFFFFFBFFFFFDFF
FFFDFAFFFEF6FFF9EEF8F4F011101ED6D2E0FFFBF49289847B8A9FEEFCFF
FFF8FFFFF9FFF7FFFFF4FFFDFFFFF8FFFDFAFEFEFFFCFEFFFEFFFFFFFFFB
FDFDFBFAFAFA5B5B5BF4F4F4FEFEFEFCFCFCFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFBFAFFFEFDFEFFFDFFFEFDFFF9F8FFF8F6FEFFFFFCFDFDFFFCFDFFFAFB
FAFBFBFCFFFFF7F5F68F8D8EE1E5E6F6FAFBFEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFCFFFFFBFFFFFCFE
FFFDFBFFFEF8FFFDF3FFFBF7B4B4BE16121CFFF4ECB6AEAC212B42F5FEFF
FFF7FFFFFBFFF8FFFFF7FFFAFFFFF4FFFFF8FEFEFFFCFFFFFEFFFFFFFFFD
FFFFFFFEFEFEFFFFFFF9F9F9FFFFFFFDFDFDF5F5F5FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFBFEFFFDFFFAFEFDFCFEF9FFFEF8FFFDFAFEFDFFFFFCFFFEEFF4FFFBFD
F9FDFEF6FFFFFEFFFDF8F8F66E6F73F0F1F5FFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFEFFFFFEFFFEFDFFFFFDFFFFFDFE
FFFEFBFFFEFAFFFEF6FFFEFAFFFEFFB1AEB4685F60696269373C50E8EDFF
FFFBFFFDF8F8FBFFFFF9FFFFFEFFF8FFFFF8FFFFFDFEFFFFFEFFFFFEFFFF
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFBF9FCFCFDFDFFFFFBFFFAEF524944BFBFC9FAF7FFA3939B100406
E6E9EDF6FEFEDFE0DAFFFFFB7A7D82B6B9C0FEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFCFCFFFEFBFFFFF8FFFEFAFFFEFFFFFEFFFEF9FDFFFDFFFEFDFFFAFCFF
FFFFFDFFFFFBFCFFFFFCFFFFFEFFFBFEFFFAFEFFFDFEFFFFFEFFFFFEFFFF
FFFFFFFDFDFDF8F8F8FEFEFEFBFBFBFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FEFFFFFEFFFFFFFEFFFFFDF8FFF7E9B3A49D474A59F8FEFFA9A2A94C4143
BEBDC2FBFAFDCAC1BA36312B00060EE4EDF8FCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFDFFFFFDFFFFFBFEFFFDFEFFFFFEFFFFFEFFFFFFFEFFFFFEFF
FFFEFFFFFDFCFFFEFAFFFFFBFFFDFFFBF9FCFEFFFFFEFFFFF2F0F1FFFFFF
FCFFFBFAFEFBFEFFFFFEFFFFFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
F7F6FBFFFEFFFFFEFFFDF7F4FFFBEDEBDCD5000012D4D8EFE6DDE0170D0C
FCFAFFF9F9FFFFFDF5F8F3EDF2F9FFF8FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFFFDFFFFFBFFFFFBFEFFFBFEFFFDFDFEFEFEFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFDFFFFFBFFFEFAFEFDF9F6FAFBF9FDFEFFFFFBFFFFFA
FCFFFBFAFFFCFCFFFFFEFFFFFFFFFBFFFFFBFCFFFFFCFFFFFFFFFFFFFFFF
FAFAFAFFFFFFF1F1F1FFFFFFFBFBFBFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFF
FFFBFDFBF4F7FBFFFFFBFFFFFFFFF1FFF8F11B162A1B1129FFF2F42D1B19
CFD5E0F4FFFFFBFFFBFFFFFAFDFBFFFEFCFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFAFEFFFAFEFFFBFDFEFEFDFEFFFEFFFFFEFFFF
FEFFFFFFFEFFFFFEFFFFFFFAFFFEEFFFFFF4F8FBFFF8FAFFFFFEFFF9F8F4
FEFEFCFCFFFFF9FFFFFCFFFDFFFFF6FFFFF4FBFFFAF9FFFFFFFDFFFFFCFF
FFFEFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFD
FFFBFBFFFAFBFBFFFFF9FFFFFAFAEDFFFEF6776F824A3C51A28D8A2D1E19
B5BDC8F1FFFFF8FFFFF9FBF6FFFCFFFFFCFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFBFEFFFBFEFFFBFEFFFDFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFFFEFFFFFFFBFFFFF1FBFBEEFEFEFFFEFEFFFBF9FAFFFFFB
FFFFFDFAFBFBFBFFFFFCFFFDFFFFF6FFFFF4FBFFFAF9FFFFFFFDFFFFFCFF
FCFBFFFEFEFEFFFFFFFCFCFCFCFCFCFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFD
FFFDFAFFFBFBFFFEFFFDFCFFFFFEF2D3CEC45E5A68958E9DC5BDB8040100
C3C9D5F8FFFFF5FBF9FBFDF8FFFEFFFBFAFFFDFCFFFFFFFFFFFFFFFBFBFB
FFFFFF000000FCFCFCFFFFFFFFFFFFFCFCFCFEFEFEFEFEFEFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFFFFFFFFFFFDFFFFFAFFFFFBFFFEFFFFFEFFFFFFFFFFFFFD
FFFFFFFFFFFFFEFFFFFEFFFFFFFFFBFFFFFBFEFFFDFEFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FBFAF6FFFEFDFEFDFFFFFEFFFFFCF1FCF7EFFFFDFFF5F5FFFFFFFAFFFFFB
FBFEFFF1F7FFFEFFFFFFFFFBF7F8F8FEFFFFFFFFFFFFFFFFF6F6F6FFFFFF
FFFFFF000000FFFFFFF9F9F9F7F7F7FFFFFFFFFFFFF9F9F9FBFBFBFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FFFFFBFFFFFDF7F8FAFDFBFCFFFDF6FFFDF8FDFDFFFCFEFFFFFEFBFEFCFB
F9FFFFF5FDFFFEFFFFF8F7F3FFFFFFFEFFFFFDFDFDFFFFFFFEFEFEFFFFFF
F3F3F3000000FFFFFFFFFFFFFFFFFFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFCFBFFFFFDFEFFFFFFFEFDFFFCF7A09895C5C5CBF9FCFFFEF9FBCFCDCE
888F97F8FFFFFDFEFFFFFEFDFFFFFFFCFDFFFFFFFFF9F9F9FFFFFFFBFBFB
FFFFFF020202FCFCFCFDFDFDF6F6F6FFFFFFF6F6F6FFFFFFFCFCFCFCFCFC
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFEFDFFFAF8F0EAE8343336FEFFFFFFFDFF28272C
EEF2F9F6FDFFFBFCFFF8F8F8FFFFFFFDFDFDFFFFFFC8C8C8FFFFFFF9F9F9
FDFDFD000000FFFFFFFCFCFCF9F9F9DCDCDCFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEF9F9FFFDFDFFFDFDFFFDFDACA7A9979598939498A4A7AC
FCFFFFFBFEFFFCFFFFFCFFFFFDFDFDFFFFFFF9F9F9000000484848FEFEFE
FEFEFE050505FFFFFFF0F0F0101010696969FCFCFCFFFFFFFDFDFDFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFFFFFFFFFDFBFCF6F4F6F7F7FDFDFDFFFCFB2E25263E4549F6FFFF
FFFEFFFEFBFFF9FEFFFBFFFFFFFFFFFBF9F8FFFFFF959595040404545454
FEFEFE000000D7D7D7141414000000E9E9E9FAFAFAFFFFFFFBFBFBFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FBFFFFFFFFFFFFF7F5FFFDFBFCFFFFFEFFFFFFF6F5F2E8E7E3ECF1F7FFFF
FFFEFFFFFBFFFBFFFFF5FDFFFBFBF9FFFEFBFFFEFDFCFCFC121212000000
3434340606060D0D0D060606707070FDFDFDFFFFFFFBFBFBFFFFFFFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FCFFFFFEFFFFFFFDFBFFFDFBFCFFFFFEFFFFFFFBFAFFFCFBF8FFFFF7FFFF
FFFEFFFFFDFFFBFFFFF9FFFFFFFEFDFFFEFBFBF9F8FFFFFF9B9B9B080808
121212000000030303030303F0F0F0F9F9F9FFFFFFFFFFFFFDFDFDFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FCFFFFFEFFFFFFFDFBFFFEFBFEFFFFFFFEFFFFFCFAFFFDFBF9FFFFF8FFFF
FFFFFFFFFEFDFCFFFFFBFFFFFFFEFDFFFEFBFFFEFDF9F9F9EFEFEF030303
0000000000000606063A3A3AFAFAFAFEFEFEFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFFFFFBFFFFFBFFFDFFFFFEFFFFFEFAFFFFFBFEFEFFFCFEFF
FEFFFFFEFFFDFEFFFFFFFEFFFFFEFDFFFFFBFFFFFDFCFCFCFFFFFF434343
000000000000090909A3A3A3FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFDFFFFFDFFFCFFFFFDFFFFFFFAFEFFFBFFFCFFFFFDFF
FCFFFFFBFFFFFFFEFFFFFEFFFFFFFBFFFFFBFAFAF8FFFFFFF5F5F5A0A0A0
0E0E0E010101080808F3F3F3FFFFFFFEFEFEFDFDFDFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFCFFFDFFFFFDFFFCFFFFFCFFFEFFFBFCFFFDFFFCFFFFFCFF
FBFFFFF9FFFFFFFEFFFFFDFFFFFFFBFFFFFBFFFFFDFFFFFFFFFFFFD5D5D5
0A0A0A030303191919FFFFFFFDFDFDFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFCFFFFFCFFFFFFFFFFFFFCFFFFFCFFFEFFFDFCFFFFFFFCFFFFFDFF
FBFFFFF9FFFFFFFEFFFFFDFFFFFEFBFFFFFBFFFFFDFBFBFBFFFFFFF7F7F7
0A0A0A000000585858FDFDFDFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFCFFFFFCFFFFFFFFFFFFFDFFFFFDFFFFFFFFFEFFFFFFFDFFFFFEFF
FCFFFFFCFFFFFFFEFFFFFDFFFFFEFBFFFFFBFEFEFCFFFFFFF8F8F8FFFFFF
3232320000009E9E9EFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFEFFFFFEFF
FEFFFFFEFFFFFFFFFFFFFEFFFFFEFDFFFEFDFDFDFDFFFFFFFFFFFFFAFAFA
616161010101BDBDBDFEFEFEFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFCFCFC
8D8D8D020202DADADAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
A6A6A6000000FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6F9F9F9
D0D0D0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF6F6F6
FFFFFFFDFDFDFBFBFBFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFF
F7F7F7FFFFFFF6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFEFEFEF9F9F9
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
pop
grestore
%%Trailer
%%EOF
\
\>"], "Graphics",
  ImageSize->{373, 274},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005e00014R000`400?l00000o`00003oo`3ooomf
0?ooo`00o`3ooomf0?ooo`00_03oool70?ono`80oooo0`3nool40?ooo`030?ono`3oool0ooko07D0
oooo00D0ooom0?ooo`3oo_l0ooko0?ooo`020?ooo@030?ooo`3nool0o_oo00<0o_oo00@0ooom0?on
n`3oo_/0oooo0P3oo_l00`3oool0ookm0?ooo@020?kooaT0oooo002`0?ooo`050?ono`3ln_d0ooko
0?ono`3jno/00P3nool0203mo_h0o_oo0?Win@3oool0ooko0?okn`3oo?`0ooWj0P3on_d02@3on_l0
noKj0?ono`3gn?X0o?oo0?_oo`3lool0n?Wk0?koo`030?ono`030?SgnP3mo_l0o_oo0700oooo0P3o
o_l0103oool0ooom0?oon`3oo_d20?omo`040?omoP3ooo/0no_g0?koo`80o?ko0100m_cl0?_oo@3k
oo`0o_oi0?omm03ooOH0oO_l0?kno`3gn?`0oooo0?onnP3oooX0o?om0?_oo`3nool0oooo0P3oo_lE
0?ooo`00/03oool20?omo`0N0?ono`3kn_d0o_oo0?koo`3ko?`0o_oo0?WjnP3nool0ooko0?ghnP3o
oOd0ooOh05mDEP0C20X0o?7g09R?U00<1@X0j>KY0?koo`3lool0nooo0?[oo`3nool0nocn0?[ioP3f
mOX0ooko0?_jo`3nool0nocnM03oool20?ono@<0ooko00D0oOgk0?ooo@3mo_h0o?oo0?Ojo`020?_o
o`080?_oo@3nooT0oogc0?ojlP3jn?/0nOco0?kno`3kno/20?oon0040?_oo`3iool0o?oo0?ooo`<0
ooko503oool00;00oooo00L0oO_n0?ono`3in?/0ooko0?gnoP3loOd0n?Wi0080o_oo0140o?gm0?kl
o@3ooOl0oo[j0?oko03on_`0k>7S07]bM`0J4aP0al;60;bk_P3in_`0o?oo0?_oo`3ho_h0o_oo0?_l
oP020?ono`040?kmo`3oo_l0mOKh0?koog@0oooo01X0ooko0?ooo`3ooo/0oook0?ooo`3noOl0n_Wn
0?ono`3noo/0oOoj0?[ko@3lool0l_[j0?kon`3om^d0oo_d0?ono`3lool0o_ko0?kmo`3oo_X0oooh
0?_oo`3iool0o?oo0?ooo`<0ooko503oool00;00oooo00@0ooko0?[hn`3mo?l0ooko0P3nool05P3i
n_X0o_oo0?koo`3kno/0ooko0?_inP3ooOd0o_Sh0?ojn`3on_h0YIbQ01TB5`3ak?00nOSk0?koo`3l
ool0mogm0?coo`3in_`0o_oo0?kmo`3gm_T20?ono`0300000P3nool0oooo06l0oooo0P3oood01`3o
ool0ooko0?ono`3oo_l0oooj0?oon03no_h00P3oo_l04`3jn?/0oooe0?oomP3oo_l0nOSn0?Woo`3j
o_d0gmS@01T@2`36al/0nOgo0?[mo`3oo_l0ookj0?oonP3kool0nOoo0?coo`3oool00`3oo_lD0?oo
o`00/03oool0803ooOl0ooko0?ono`3mo?l0n?Wi0?_lo01LGEd0moSh0?ooo`3no_h0n_Si0?ono`3o
o?`0oogm0?olo@3oo?l0b/7601L@5`3glOP0ooko0?koo`3joOl0n_ko0?_oo`3mo_l0o_oo0?Win@3o
o_l0oooo0?7al@0720P0noclL`3oool02@3oo_l0o_oo0?koo`3nooX0o_oh0?ooo`3mo?l0oO[o0?om
o`020?onm00@0?oko03ooOl0nOoo0?Omo@3oo_P0TXZ70<S8cP3kool0m_Wo0?koo`3oo_X0oooj0?_o
o`3iool0o_oo0?ooo`80ookm00<0ooko0?ooo`3oool04P3oool00;00oooo01D0ooko0?cjo@3jnO`0
inKY0;Vj^P3mo_h00`@40?koo`3moOd0oooo0?ono`3imoP0oOSh0?omo@3on?T0oo[m08b3R00700L0
Ui6H0=CCf03nool00P3lool01@3ho?d0o?go0?ooo`39alP0d]3A0080oooo00<000000?cmo@3oool0
LP3oool30?koo`80o_ok01T0o_om0?_kn`3ooOl0oogm0?ojm@3on?40oo_k0?oioP3iool0l?Ok0?[f
l`3Idm40P8>80?Soo`3kool0nocn0?onnP3oooX0nooo0?Woo`3nool0oooo0?omo@3oo_d0ooko01@0
oooo002`0?ooo`080?Sfn@3oo_l0no[m0?ono`12@T80TI6A0000003nool20?ooo`0F0?[hn@3no?d0
oogm0?okn`3ooOd0W9FH0109403Fd=P0ZjR^00h=4P3^ko<0o?oo0?Chn@3lool0o_oo0?Win@3Qgn00
61HE0=gKfP3gmoD000400?kooG00oooo0P3oo_l0103oool0o_oo0?koo@3lood20?coo`0I0?koo@3l
oOL0o__d0?kfl`3onod0oo[m0?ojn03onOL0n?oo0?Koo`3oo_d0m>o_04U=E03bn_l0nooo0?cmo`3o
o_X0oooj0?_oo`3iool0o_oo0?ooo`3ooOd0ookm0?ono`0D0?ooo`00/03oool02P3oo_l0noWl0?on
o`3oo_l0fMWI01<C4`041@D0oOkn0?gmo@3oool20?ono`050?olo03nnOT0oogm0?olo`3on_l00P3o
o?l03@3nool0noco0?coo`3lool0o_oo0?knoP3oool0ookm08f;RP0n?3/0ooom00@40P3nood0L03o
ool20?ono`0O0?koo`3nood0o?ok0?coo@3kool0o?oo0?koo@3oooP0oood0?O`j00W6Ql0nn[`0?oa
j`0R6A@0H6Qb0?7mo`3in?/0ookm07n6S03AfN40nooo0?koo`3oo_X0oook0?_oo`3iool0o_oo0?oo
o@3ooOd0oook0?ono`0D0?ooo`00R03oool0103lo?`0oooo0?ooo`3kno/20?ooo`030?clo03oool0
o?cl0080oooo00@0no_k0?ooo`3oool0o?cl0P3oool00`3moOd0o?cl0?ooo`020?ooo`030?Win@3o
ool0oooo00l0oooo01<0o?_n0?ono`3noOl0ooko0?knoP26QXH010@4000000020P80000000410@00
00000P000040000200000`0000<00P0300@00@0400<0000400@0004200000P0000000@000P050000
1@010000XZ:P0000003nood0no_k00@0oooo00<0o_kn0?gmo@3oool0J03oool20?ono`040?koo`3n
ood0o?ok0?coo@80o?oo01T0o_om0?oon03ooo<0ookf030Q9P2lZjl0ooS`04Y1?027T9/0d]k/0?km
o`3^k>d0B4mC08nHW@3hoOl0o_oo0?onnP3ooo/0o?oo0?_oo`3nool0ooom0?omo@3ooo/0ooko01@0
oooo002:0?ooo`040?KfmP3oool0n?Sh0?Ogm`@0oooo00@0m_Kf0?ooo`3hn?P0moOg0P3oool01P3h
n?P0o_kn0?ooo`3kno/0oooo0?gmoA80oooo0P3oo_l02P3noOl0ooko0?_kn`3jn_X0:RXZ0:VYZ@3k
no/0oooo0?Cdm03oool20?ono@060?omo03oo_l0oogo0?omo`3oo_l0o_oo0`3lool02@3nool0oooo
0?ono`3ooOd0nOCd0=CBd@0B4Q001@D10?koo@020?ooo`80oOgm00<0oooo0?knoP3no_h0J`3oool2
0?koo`80o?om01P0o?oo0?koo`3knoT0oooj0?oll`3oo?@0YYZJ028B4P3on_@0Uhn=07b5U03dool0
oOco0?ono`3bnOd0n?oo0?KkoP3nood0ookj0?oon`3lool0nooo0?koo`3oool20?oon`030?ooo@3o
ool0oooo0180oooo00280?ooo`0408n?S`3dm?@0oooo0?gmo@<0oooo00D0no_k08n?S`3dm?@0oooo
0?gmo@030?ooo`060?_kn`3oool0YJFU0?ooo`3moOd0o_kn0P3oool00`3no_h0oooo0?ooo`0>0?oo
o`040?[io03oo_l0ooko0?ono`80oooo00@0`/;201lO7`3Zj^X0n?Sh0P3oool0103oood0no_i0?gm
n`3oool30?ono`030?koo`3lool0o?oo0080o_oo00P0oooo0?ono`3oo?`0oocl0?ono@1aLFl00000
0?cnn`80n_[j00H0no_k0?ooo`3oool0oooo0?clo03moOeZ0?ooo`@0o_oo01P0o_om0?kon`3oool0
n?Kg0?omo`3ooOX0elc400X0002VV9<0hmcQ00`D9`3Rkol0ooko0?omoP3kool0mOco0?coo`3moO/0
oogj0?onn`3lool0nooo0?coo`3oool20?oon`030?ooo@3oool0oooo0180oooo00280?ooo`0?0;6a
/@0i>CT0l?3`0?ooo`3moOd0o_kn0?Shn03oool0/K6a03Ti>@3`l?00oooo0?gmo@3no_h0n?Sh0080
oooo00L061PH08>3P`3kno/0oooo0?knoP3oool0o?cl0100oooo00@0o_go0?ono`3hmoX0no[m0`3o
ool01P1TI6@0JVYZ0?ooo`3kno/0oOgm0?Ogm@80ooom00<0n?Sf0?omoP3noOl00P3mo_l20?_oo`04
0?gnoP3no_h0oogn0?ono`80oo_k00@0ookm0??cl@071`D0]kVf0`3oool20?gmo@80o_knJ@3oool2
0?ooo@@0o_oo01P0o_ok0?oonP3imoP0oogo0?olo`3oo?`0mnoR018:001VFeL0YZ2X00087@3]mol0
n_Wo0?omoP3kool0mOgo0?coo`3ooo/0oogj0?onn`3lool0nooo0?coo`3nool20?oon`030?ooo@3o
ool0oooo0180oooo00280?ooo`040?gmo@1kNg/0:RXZ0=kNgP80o_kn00H0oooo0?Ogm`3moOd0Ng]k
02XZ:P3Ng]h20?knoP090?ooo`3gmoL0oooo0>g]k@0k>c/0H61P0?Cdm03oool0moOg0140oooo00@0
o?_n0?ono`3oo_l0ooko0P3oool0201BDU80m_Kf01/K6`2o_kl0o_kn0?ooo`3lo_/0oOol0P3nood2
0?ooo`80o_oo0P3lool0103nool0oooo0?gko03on_`20?omo`070?Kdm@3moOd0000002<T903_knl0
o_kn0?ooo`020?[jnV/0oooo0P3nood20?koo`80ooko01P0oook0?oonP3oo_l0ooco0?ojo`3oo?`0
ZjNI03dg9`3:`[d0QhJ<024[@03SkOl0ooko0?[em@3gno`0nOoo0?koo@3oooX0oogh0?omn`3lool0
nooo0?coo`3nool20?oon`030?ooo@3oool0oooo0180oooo00280?ooo`050?knoP3lo?`0Shn?01XJ
6P3>c/h00P3oool20?knoP040?clo02?Shl06QXJ0<k>cP80oooo00L0o_kn0?ooo`3emOD0l_;b05=C
D`17AdL0k^k^0180oooo00h0ooko0?kmo`3oo_l0ooko0?gmo@3no_h00`<30?ooo`3QhN40^[Zj0?oo
o`3fm_H0o_om0?cnn`80o_om0P3moOd20?cmo@80n_km00h0o?gm0?gmo@3oo_l0oogo0?cgn@3mn?X0
ooko0?ooo`000000c/o?0=cLg03bl_80oooo0?knoP<0oooo00<0no_k0?ooo`3oool0IP3oool30?ko
o@0K0?koo`3oo_l0ooko0?ono@3ooOd0oogo0?_fnP3ooOl0oogm0?Gbj@3ooo@0oogf0?koo`3eool0
lOWo0?omo`3ooOd0o?oo0?_oo`3nood0o_gh0?omn03ooO/0o?oo0?_oo`3lool0o_oo0080oook00<0
ooom0?ooo`3oool04P3oool008T0oooo00D0oOgm0?ooo`2[Zj/06a/K0;6a/@030?ooo`050?gmo@3o
ool0Zj^[01/K6`2a/K400P3oool0203jn_X0oooo0?ooo`3fm_H0IFEU038b<P3^k^h0n_[j403oool2
0?ono`080?_jo@3oo_l0oooo0?ooo`010@40n_[j0?ooo`3kno/20?ooo`040?koo@3lo_/0o_om0?ko
o@80ooom00l0o_om0?coo@3lood0o?om0?koo`3oool0ooko0?ghnP3oo?l0oogo0?_inP3inOT010@4
0?Cem@3lo?`00`3oool20?knoP030?gmo@3oool0oooo06L0oooo0P3nood20?ooo@0M0?ono@3oo_l0
ooco0?oko`3oo?l0oocl0?onn`3glo00M6ma0?[hm`3oooP0n?ck086<WP3@f>d0o__o0?olo03nool0
n_km0?WkmP3oooX0oogh0?omn`3lool0nooo0?coo`3nool0ooom0?oon`3oood0503oool008T0oooo
00H0n?Sh0?ooo`3oool0_[jn01lO7`2NWYh20?ooo`060?Shn03oool0oooo0;jn_P0O7al0WYjN0`3o
ool01P3gmoL0oooo0?ooo`21PH406QXJ0=oOg`l0oooo00d0ooom0?onn`3oo_d0nooo0??jo`3nool0
o_cm0040003oo_d0o_oo0?gnoP3oo_d0oogl0080o_om00H0o_oo0?_lo03no_h0o_kl0?goo03koo`2
0?goo0040?gnoP3no_h0ooko0?ojo080oogo00P0oogn0?ooo`010@40o_oo0?ooo`3no_h0no_k0?kn
oP80oooo00<0oOgm0?ooo`3oool0I`3oool20?koo@80ooom01P0ookm0?ono`3oo?l0ooco0?omo`3o
o_/0oo_g0?onn`2c/;H0Q8:50?kmmP3Be=40EEaZ0?Smo`3ooOl0oogm0?gnoP3kooh0o_om0?onn@3o
oOX0ookk0?koo`3lool20?koo`80ooom5@3oool00400oooo00H0o?cl0?ooo`3oool0n_[j0?ooo`3k
no/:0?ooo`080?[jnP3no_h0oooo0?clo03oool0oOgm0?ooo`3no_hb0?ooo`070?[jnP3oool0oooo
0=KFeP0L71`0S8b<0?[jnP020?ooo`080?knoP3lo?`0g=cL01HF5P2:RXX0no_k0?ooo`3gmoL20?oo
o`060?gmo@2LW9`061PH0<_;b`3oool0nOWi0P3oool00`3kno/0oooo0?ooo`040?ooo@<0o_om00T0
o?_f0?oml@3oo_L0jogo0?3oo`3inol0ooco0;N^[`3ln?D00P3lool00`3oo_/0ookj0?oon`020?ko
o`80ooko0P3oool00`3nool0oooo0?ooo`030?ooo`80ooko00@0oO_l0?ooo`3lo?`00`<30P3moOd0
103no_h0oooo0?ooo`3moOd20?ooo`050?clo03jn_X0oooo0?knoP3lo?`00`3oool00`3no_h0oooo
0?ooo`0f0?ooo`050?clo03oool0oOgm0?ooo`3inOT0103oool01P3lo?`0oooo0?gmo@3no_h0oooo
0?KfmQT0oooo103nool20?ooo`<0ooko0`3ooOd01P3im?P0E4mA0=KAd@0_;Bh0l?3f0?ShoP80ooko
00/0oooo0?koo`3oool0o_kl0?Sfm@3oo_d0oOco0?koo`3mo?l0oooo0?Win@020?ooo`030?_kn`3o
ool0o?cl00<0oooo00<0no_k0?ooo`3oool02`3oool00440oooo00<0moOg0?knoP3oool00P3moOd0
0`3oool0o?cl0?knoP070?knoP80oooo0P3kno/0103moOd0oooo0?[jnP3oool`0?knoP0;0?_kn`3n
o_h0oooo0?clo03moOd0oooo0>SXj00V9RH0Lg=c0?Gem@3kno/00P3oool0103kno/0jNWY030`<01[
Jf/20?ooo`0=0?_kn`3no_h0oooo0?ooo`2a/K405ADE0;6a/@3oool0moOg0?ooo`3no_h0oooo0?cl
o0030?ooo@0=0?_kn@3nood0moWf0?_mnP3oo_X0ooga0?_hl@3`ool0k_oo0?Oio`3onOl0oocj0?oo
n`020?[oo`040?omnP3ooOL0o_oi0?goo080oOgo00<0o_go0?knoP3no_h01@3no_h00`3jn_X0oooo
0?Ogm`020?ooo`030?gmo@3lo?`0o?cl00@0oooo00`0oOgm0?clo03oool0oooo0<k>cP20P800o?cl
0?ooo`3jn_X0oooo0?gmo@3ooolh0?knoP030?ooo`3inOT0oooo0080oooo00P0oOgm0?ooo`3lo?`0
o_kn0?ooo`3no_h0oooo0?Ogm`80oooo00<0oOgm0?knoP3no_h05P3no_h40?gnoP@0o_kn00<0nOOh
0?ono`3jmOL00P3ooOl0103XhnD010000;>^/03knOX20?ooo`0<0?knoP3moOd0o_kn0?clo03gmoL0
HV9R06=SH`3fm_H0no_k0?clo03inOT0oooo0P3moOd30?ooo`030?[jnP3kno/0o_kn00h0oooo0011
0?ooo`050?Ogm`3oool0oooo0?knoP3oool00P3no_h90?ooo`070?Shn03lo?`0oooo0?ooo`3kno/0
oooo0?Win@0a0?ooo`0:0?clo03moOd0oooo0?Shn03moOd0o?cl0?Shn012@T80DE5A0?Ogm`80oooo
00H0o?cl0?ooo`3[jn/0ADE50451@@3fm_H20?ooo`070?clo03no_h0oooo0<O7a`0I6AT0WinO0?oo
o`020?knoP060?Cdm03oool0no_i0?ooo@3knoT0o?cj0P3oood0403jn_P0ookj0?oimP3oo_d0logo
0>olo`3no_l0ooko0?ono@3koOX0nooo0?coo`3ooOl0oogk0?oonP3ooo/20?coo`030?koo`3oool0
oooo00P0oooo00@0n_[j0?_kn`3oool0moOg0P3oool20?clo0<0oooo0P3moOd0103inOT0A4A408B4
Q03inOT20?ooo`030?clo03oool0oooo03L0oooo00D0o_kn0?ooo`3fm_H0oOgm0?ooo`020?clo080
oooo00<0o?cl0?knoP3oool00`3oool00`3inOT0oooo0?ooo`0F0?ooo`@0o_oo103oool20?ono`07
0?omo`3on_`0oogo0?oloP3Of]`0oo[l0?ono`020?ooo`0B0?knoP3oool0oooo0?ooo`3lo?`0a<C4
000000061PH0UIFE0?Cdm03oool0m_Kf0?ooo`3no_h0oooo0?[jnP3oool0oOgm403oool00400oooo
00D0moOg0?gmo@3oool0n?Sh0?knoP030?ooo`P0o_kn00P0oooo0?Win@3oool0nOWi0?gmo@3oool0
nOWi0?oooc00o_kn00<0oOgm0?ooo`3emOD00P3oool02@3jn_X0oooo0?_kn`3fm_H0GUiN03Xj>P3[
jn/0oooo0?Win@020?ooo`060?clo01TI6@0?3`l0>g]k@3lo?`0n?Sh0P3oool0103lo?`0g]kN01LG
5`21PH430?ooo`050?knoP3moO/0ooom0?gmn`3knoT00P3oood04`3no_`0oooo0?ono`3nool0n?ck
0?coo@3oool0n?Sh0?koo`3iool0n_oo0?gmo`3onol0oo_n0?onm`3nooT0nooo0?[oo`3mo_l01`3n
o_h02@3lo?`0o_kn0?ooo`3oool0nOWi0?gmo@3oool0n?Sh0?gmo@020?ooo`030?clo03no_h0oooo
00<0oooo00D0inOW018B4P3Ph>00oooo0?KfmP020?ooocP0o_kn00L0oooo0?_kn`3oool0oooo0?_k
n`3oool0no_k0080oooo00L0no_k0?ooo`3oool0oooo0?Ogm`3kno/0oooo01P0o_kn103mo_h40?kn
oP80ooko00P0noKh0?omo`3oo?h0oo[l0?omo`3ln_/0o_cm0?gmo@80o?cl01@0o_kn0?ooo`3oool0
o_kn0?ooo`2d];@00@4100P820000000@T920;6a/@3Ph>00oooo0?gmo@3oool0no_k0?Win@3oool0
o_kn0?clo0d0oooo00110?ooo`050?clo03kno/0oooo0?ooo`3gmoL02P3oool0203inOT0oooo0?kn
oP3oool0mOGe0?7al@3oool0oOgm<03oool0103moOd0no_k0?gmo@3gmoL50?ooo`0=0?knoP1nOWh0
7QhN0?KfmP3oool0n?Sh0?knoP3jn_X0oooo07IfMP0V9RH0oOgm0?clo0030?ooo`040?clo03`l?00
=CDe05]KF`80oooo00<0n_[j0?ooo@3jn_P00`3oood04@3dm?80ooom0?koo`3inol0mo[o0?onn@3o
ooH0nOSd0?koo`1BF5P0nOoo0?coo`3oo_l0oo_o0?olo`3oo_P0oooh0080nooo00<0o_oo0?ooo`3o
ool01`3oool01`3fm_H0oooo0?ooo`3no_h0oOgm0?ooo`3moOd00`3oool02@3no_h0o?cl0?Win@3k
no/0o_kn0?Shn02HV9P000000?Shn0020?ooo`030?Ogm`3oool0oooo03H0oooo00l0no_k0?ooo`3a
lO40moOg0?ooo`3lo?`0oooo0?Win@3kno/0oooo0?gmo@3fm_H0n?Sh0?ooo`3moOd06@3oool40?ko
o`@0oooo0`3oo_l0103imoP0oogo0?omo`3oo?h20?ono`H0oooo00D0o_kn0?ooo`3fm_H0Vi^K010@
40020000000900D51@0<30`03`l?03/k>`2@T900Xj>S0<S8b03]kNd0oOgm00h0oooo00100?ooo`03
0?Ogm`3oool0o_kn0080000000<01`L7000000010@40200000001`030`<000000000000000003@d=
0000000410@0<@0000001P051@D00000000000071`L0000000<30`D0000000@00@41000000010@40
0@410P020P802@0000001@D5000000010@400P82000000020P80000000P820050000000300P82001
0@000@4000<0000000/010@20082000000@0004>00D74@0710001000004000000000008200031@02
00001@0700@01`0600801P0000<000000P00008400000P080000000300<30`0:2PX0000000800000
0P010@40100000000@4100000000000200@41006000000051@D0000000@4100000000P820`000000
0`071`L000000000000f0000000400410@071`L0000000P8208000000P051@D300000080oooo00<0
m_Kf00820P000000800000030040000500<10P0910H00`0000<0000100000P00000200410@@00000
00<010@40000000000000P0000001`0820P01PH60000000000003`l?000000010@400P0000000`2Y
ZJT0oooo0?ooo`0<0?ooo`00@@3oool01@3inOT0oooo0?ooo`3no_h0o?cl0080oooo203no_h0203k
no/0oooo0?ooo`1TI6@0000000410@0b<S80oOgm<03no_h0103jn_X0no_k0?ooo`3jn_X20?ooo`07
0?[jnP3oool0oooo0?[jnP3oool0oOgm0>SXj0040?ooo`80n_[j00L0oooo0=oOg`3oool0oooo0?cl
o03oool0nOWi00D0oooo00@0nOWi0?gmn`3oood0nOOf0P3oo_d0503imoH0h^3O0>[Yk03fm_l0o_ko
0?oon`3ko?@0ooom0?koo`000P00nooo0?[oo`3moOl0oo_o0?okoP3ooOL0ookg0?_oo`3jool0oOko
1`3no_h02P3moOd0no_k0?knoP2i^KT0V9RH06ATI01dM7@0Y:BT0=OGe`3jn_X30?ooo`0;0?knoP3l
o?`0oooo0?knoP3lo?`0n_[j00@4100M7Ad0jn_[0?ooo`3jn_X0>03no_h01@3gmoL0<30`00000001
0@40JVYZ0080oooo00D0m_Kf0?gmo@3oool0oooo0?Cdm0020?ooo`030?gmo@3oool0o_kn01L0o_kn
103mo_h50?knoP040?ooo`3mno`0o_cm0?OemP<0ooko0P3moOd30?ooo`070?knoP3oool0oooo0?Sh
n03oool0Vi^K00H61P020000000800P820030`<04a<C0410@023Ph<0XZ:R0<[:bP3Rh^8?0?ooo`00
@03oool0103moOd0oooo0?clo03moOd20?ooo`030?Win@3oool0oooo00P0oooo00L0nOWi0?ooo`3=
cLd0000000H61P020P80N7Qh0380oooo0P3no_h02`3lo?`0oooo0?ooo`3lo?`0oooo0?knoP3moOd0
oooo0?clo03oool0n_[j0080oooo00T0o?cl0?ooo`3oool0oOgm0?clo03oool0oOgm0?ooo`3jn_X0
0P3oool02P3lo?`0oooo0?ooo`3oool0ooom0?Ogm@3oo_d0n?Ke0>g[jP16A4<20040000>030^<@3P
gn80n?kn0?Woo`3nool0m_Gh00H71`3jo_d0nooo0?coo`3ooOl0oocm0?onn03oooX20?coo`030?ko
o`3oool0oooo00H0oooo00X0k^k^04m?C`0_;bl0J6QX09jNWP23Ph<0EeMG01DE5@2>SXh0l?3`203o
ool00`000000LG5a05YJFP0j0?ooo`07071`L0010@401@D500410@3<c<`0oooo0?[jnP040?ooo`03
0?gmo@3oool0no_k01X0oooo103nool50?ooo`040?Win@3oo_l0ooko0?cjn`80ooko00<0o_cm0?oo
o`3oool01`3oool03`2][Jd00@4100`<30061PH0?3`l0:j^[P3UiND0o_kn0?gmo@3oool0o?cl0?oo
o`3no_h0oooo0?Shn00=0?ooo`00D@3oool0103moOd0o?cl0?ooo`28R8P3000000040;fm_@3oool0
n?Sh0?clo080oooo00<0o?cl0?ooo`3oool0A`3oool30?ono@0Z0?Sfm@2_[J`02@L60>;Mg@3onOL0
OGA]00`81@3]nol0kooo0?cno`3onol0[jZZ0?kno03jool0nOoo0?omo@3ooOX0oooj0?oon`3loOl0
oOgo0?kmo`3moOd0oooo0?[jnP3oool0o_kn0?_kn`3oool0emOG0000001fMWH0nOWi0?knoP3oool0
no_k0?ooo`3Zj^X0ADE500X:2P3jn_X0o_kn0P3oool02`3no_h0dm?C0?_kn`3oool000000?Gem@0O
7al0^[Zj0?_kn`3no_h0oOgm00@0oooo00@0oOgm0?knoP3no_h0oOgm103oool0103moOd0o_kn0?kn
oP3moOd40?ooo`040?gmo@3no_h0o_kn0?gmo@@0oooo00@0oOgm0?knoP3no_h0oOgm103oool0203m
oOd0o_kn0?clo03oool0n?Sh0?ooo`3no_h0no_k0`3oool02`3no_h0oooo0?gmo@3oool0o?cl0?kn
oP2b/[80000000410@020P80T92@02@0oooo0P3nool@0?ooo`0=0?knoP3oool0oooo0?ooo`3moOd0
no_k0;no_`0000002@T908^;R`3bl_80nOWi0?knoP0F0?ooo`00D03oool20?_kn`080?ooo`3inOT0
nOWi04i>CP0000001@D501/K6`3Zj^X20?ooo`040>g]k@3kno/0oooo0?_kndP0oooo01H0oogl0?gk
nP3oo_d0ookm0::PW`0e<c80o_Wi0?oim03om>L091lG0:2c_`3]ool0o?ko0?oko`3ooO/0oo_h0?Wo
o`3kool0o_[f0?onn03oooX0n_ci0`3oo_l20?ooo`80no_k0P3oool01`3clo<09RHV0:>SX`3lo?`0
oooo0?clo03no_h00`3oool03@3moOd0000007alO03oool0moOg0?clo03oool0Ng]k00X:2P3gmoL0
00000?ooo`3no_h0103oool0103kno/0oooo0?ooo`3kno/40?ooo`040?_kn`3oool0oooo0?_kn`@0
oooo00@0no_k0?ooo`3oool0no_k103oool0103kno/0oooo0?ooo`3kno/40?ooo`040?_kn`3oool0
oooo0?_kn`<0oooo00<0lo?c0?ooo`3no_h00`3oool01@3hn?P0oOgm0?ooo`3oool0o_kn0080oooo
00H0g=cL01@D50061PH0000005=CD`3no_h20?ooo`030?Shn03oool0oooo01l0oooo0P3nool@0?oo
o`090?knoP3oool0oooo0?ooo`3no_h0no_k069RHP1mOGd0iNGU0080oooo00<0o_kn0?ooo`3hn?P0
5@3oool00540oooo00/0moOg0?ooo`3moOd0o?cl0>OWi`0N7Qh0000000<30`13@d<0oOgm0?Win@02
0?ooo`030?clo03oool0oooo04D0oooo0P3oo_l20?ono@0H0?omo@3lmoL0aL3000l:2P3gl_80oogh
0?okk01nMfd0Efik0>Woo`3ko_l0oO?k0?ohm`3oo_X0mOgk0?Ooo@3oooP0ookf0?konP3lood0oOco
0?cho`3oo_l0moOg0`3oool01`3fm_H0oooo07alO01MGEd0n_[j0?ooo`3gmoL00P3oool01`3kno/0
oooo0?ooo`3lo?`0lO7a01hN7P31`L400P3oool02`3no_h0n_[j014A4@1CDe<010@40?clo03oool0
n?Sh0?gmo@3kno/0oOgm00@0oooo00@0oOgm0?_kn`3kno/0oOgm103oool0103moOd0no_k0?_kn`3m
oOd40?ooo`040?gmo@3kno/0no_k0?gmo@@0oooo00@0oOgm0?_kn`3kno/0oOgm103oool02@3moOd0
no_k0?ooo`3oool0o_kn0?ooo`3lo?`0o_kn0?_kn`020?ooo`060?gmo@3oool0oooo0?Win@3jn_X0
?Cdm0P0000000`0W9bL0kno_0?Shn0020?ooo`030?Gem@3oool0oooo0340oooo00X0o_kn0?ooo`3o
ool0oooo0?knoP3lo?`0mOGe0?Shn03oool0oOgm0P3kno/G0?ooo`00D03oool01`3kno/0oooo0?_k
n`3no_h0oooo0?clo02i^KT00`000000102BTY80o?cl0?ooo`3lo?a80?ooo`80ooko0100moGd0?on
o@3ooOd0oogm0?G`l00D3`l0^;>c0?omn03onNX0YZ6G01D[=P3Wool0o?ko0?oko`3ooO/0oOWe0P3i
ool02P3oo_X0oocf0?gnn03lood0ooko0?omo`3oo_l0o_kn0?ooo`3jn_X20?ooo`030?gmo@0Y:BT0
clo?00@0oooo00T0o_kn0?_kn`3oool0oOgm0?ooo`3fm_H0OGem08>3P`3hn?P00`3oool00`2k^k/0
000000820P070?ooo`80oOgm1P3oool20?gmo@H0oooo0P3moOd60?ooo`80oOgm1P3oool20?gmo@<0
oooo00/0n?Sh0?_kn`3no_h0o_kn0?gmo@3oool0n_[j0?ooo`3no_h0oooo0?Gem@020?ooo`0507Ee
M@0000002@T900<30`39bLT00P3oool0103hn?P0o_kn0?ooo`3lo?`b0?ooo`060?knoP3oool0oooo
0?ooo`3no_h0oOgm0P3oool00`3inOT0oOgm0?ooo`020?clo1H0oooo001@0?ooo`0?0?[jnP3oool0
oooo0?ooo`3no_h0oooo0?clo01kNg/0000000820P030`<0c<c<0?[jnP3oool0mOGe0440oooo0P3n
ool40?ooo`80ooko01/0ookm0?kln`3ono/0oocl0?omo@2YXj<010000;6YYP3Hbl<09R8N06=dN`3]
ool0o?ko0?omo`0^:BT0PH5o07InOP1oQHD0o_[g0?omnP3oooX0n_cg08:3Q`1lNh40O7]n08>3P`3i
nOT00`3oool0101fMWH02@T907QhN024Q8@20?clo00G0?_kn`3oool0QhN707]kN`1mOGd0O7al0?oo
o`2PX:00EEEE0?ooo`1mOGd0NWYj0861P@1kNg/0D51@0000003no_h0oooo07YjNP20P800O7al08>3
P`3kno/00P3oool01P3kno/0Ph>307alO01lO7`0Ph>30?_kn`80oooo00H0no_k08>3P`1lO7`0O7al
08>3P`3kno/20?ooo`060?_kn`23Ph<0O7al07alO023Ph<0no_k0P3oool01P3kno/0Ph>307alO01l
O7`0Ph>30?_kn`80oooo00D0no_k08>3P`1lO7`0QXJ607moO`040?ooo`0?0?gmo@3jn_X0oooo0?_k
n`3oool0n?Sh0;Vi^@0000002PX:0000002=SHd0oooo0?clo03oool0oOgm0080oooo00<0o?cl0?oo
o`3oool0903oool:0?koo`L0oooo00@0o_kn0?_kn`3oool0o_kn103oool00`3emOD0oooo0?ooo`0C
0?ooo`00D@3oool0303hn?P0oooo0?[jnP3oool0nOWi0?ooo`3bl_80<S8b00H61P030`<08R8R0??c
ld<0oooo0P3nool40?ooo`80ooko01X0oO_j0?ono@3ooOd0o_Wi0?oin@3ooOd0^kFe01PB4P040000
FeUJ0>?/k`3gool0o_oo0?klo`061P@0OGin07^0P`1jOH40oogo0?olnP3ooOT0oooj07amP@1nOX@0
P7n207alO080oooo0P3inOT0101dM7@04A4A07emO@1lO7`30?ooo`0F0?Win@1kNg/0PH6107moO`21
PH40oooo0=;BdP0Y:BT0oOgm07YjNP28R8P0NWYj0820P03^k^h020P806UYJ@3oool0O7al0820P01o
Ogl0OGem0?ooo`80o_kn00H0oooo07emO@1oOgl0Ogmo07emO@3oool20?knoP060?ooo`1mOGd0Ogmo
07moO`1mOGd0oooo0P3no_h01P3oool0OGem07moO`1oOgl0OGem0?ooo`80o_kn00H0oooo07emO@1o
Ogl0Ogmo07emO@3oool20?knoP060?ooo`1mOGd0Ogmo07UiN@24Q8@0no_k0P3oool0403moOd0oooo
0?ooo`3oool0o?cl0?ooo`3/k>`030`<0000000410@0CDe=0?clo03oool0no_k0?ooo`3lo?`Y0?oo
o`X0o_oo203oool01P3no_h0o?cl0?knoP3oool0o?cl0?gmoAL0oooo001A0?ooo`030?Win@3moOd0
oooo0080oooo00X0o_kn0?ooo`3IfMT02`/;000000051@D0GUiN0?ooo`3hn?P0o_kn@03oool20?ko
o`@0oooo0P3oo_l01`3ooOd0nOCd0?cgm`3ooOd0ooWi0?olo03ooOd00P3ooOl02@3no_l0o_ok0?oo
nP3oood0n__k00030P3goOd0nooo0?kno`020?olo`050?omnP3oooP0o?oo0?coo`3ko?h00P3oool0
3P3jn_X0oooo0?ooo`3kno/03@d=0?;blP3oool0nOWi0?[jnP3oool0oOgm0?ooo`3inOT0oooo0P3k
no/01@2JVYX0Hf=S0?gmo@3oool0moOg0080oooo00H0o_kn00@410000000h>3P0?ooo`3fm_HZ0?oo
o`030?clo03oool0oooo00@0oooo00/0no_k0?Shn00m?Cd0000000@4100K6a/0k>c/0?ooo`3moOd0
oooo0?knoP030?ooo`030?_kn`3oool0oooo02@0oooo2P3nool90?ooo`070?knoP3oool0oooo0?cl
o03no_h0oooo0?[jnP0E0?ooo`00D03oool01@3moOd0oooo0?ooo`3jn_X0oooo0080oOgm0P3oool0
1@2VYZH00000000000000000Y:BT03`0oooo00<0ooko0?ooo`3oool00P3oool00`3oood0o_oo0?ko
o`060?ooo`0J0?oloP3ooOd0oogo0?omo`3oo_l0o?[k0?omo`3knO`0o?ko0?coo`3lnoH0ooof0?km
n@3nool000H40?_oo`3joOl0ooko0?oio`3onol0ooci0?glm`3nool0n_ko0?koo`3dm?@20?ooo`0:
0?_kn`3oool0no_k03Lg=`2l_;`0oOgm0?ooo`3jn_X0o?cl0?knoP<0oooo00H0oOgm0?ooo`1[Jf/0
PX:20?ooo`3no_h20?ooo`0:0?Win@3oool0000002XZ:P0];Bd0no_k0?ooo`3moOd0oooo0?clnP80
o_kn00H0o?cl0?ooo`3moOd0oOco0?ono`3lo?`20?knoP060?clo03oool0oOgm0?gmo@3oool0o?cl
0P3no_h01P3lo?`0oooo0?gmo@3moOd0oooo0?clo080o_kn00H0o?cl0?ooo`3moOd0oOgm0?ooo`3l
o?`20?knoP050?clo03oool0oOgm0?ooo`3kno/00`3oool00`3moOd0oooo0?knoP020?ooo`0=08>3
P`0000000`<300820P31`L40oooo0?knoP3oool0moOg0?ooo`3kno/0oooo0?knoP0W0?ooo`X0o_oo
2@3oool0103jn_X0oooo0?clo03oool20?knoQH0oooo001H0?ooo`030?gmo@3oool0HV9R00800000
00L03@d=0>7Qh@3inOT0no_k0?ooo`3no_h0o?cl0080oooo00<0o?cl0?ooo`3oool0803oool0203n
o_h0oooo0?ooo`3oool0no_k0?ooo`3kno/0o_co0P3oo_l0103ooOh0ooom0?ooo@3mo_h30?koo`0>
0?cmo`3nool0o_oo0?gnoP3oood0oOgi0?koo@3lo_/0ooko0?cjo@3oood0oOol0?_oo`3jo_l20?ol
o`0=0?omo`3oo_l0n_ko0?WmoP3noOl0oogo0?kmo`3nool0oOgk0?kmn@3oood0o_kn0:FVYP020?ko
o`<0ooko00@0ookm0?ooo@3oool0o_oo0P3oool0503kno/0oooo0?ooo`3oool0oOgm0;>c/`0I6AT0
no_k0?[jnP3lo?`0oooo0?knoP3moOd0oooo0?_kn`3oool0`L7101PH603dm?@0m_Kf0`3oool03@3k
no/0oooo0000003UiND03@d=0:n_[`3moOd0ookm0?[hm`2UYJ40emOE0?gkoP3oo_l00P3nood0103o
o_l0oOco0?koo@3nood20?ono`030?_kn`3oood0oooo01L0oooo00L0o_kn0?ooo`3no_h0o?cl0?oo
o`3kno/0o?cl0080oooo00L0_Kfm0000000410@0000008J6QP3oool0oOgm05d0oooo001I0?ooo`09
0?gmo@3`l?009bLW00H61P000000=cLg0?clo03oool0moOg0080oooo00@0no_k0?gmo@3oool0o_kn
803oool0103moOd0oooo0?knoP3kno/20?ooo`040?Shn03oool0ooko0?gkoP80oO_l0P3oood00`3c
m?@0o_oo0?_loP030?koo`060?cmo@3no_`0oook0?oon`3loo/0mo_h0P3oo_l0203oood0oOgi0?[k
n`3nool0oogo0?olo`3kn_d0n__k0P3lool02P3oo_l0oO[o0?[io03oool0n_[j0?ooo`3jn_X0o_kn
0?ooo`3jn_X80?ooo`050?gmo@3inOT0oooo0?gmo@3inOT00P3oool00`3jn_X08B4Q04=3@`020?oo
o`030?gmo@3oool0oooo0080oooo00@0hN7Q0000002h^;P0nOWi0P3oool20?knoP0E0?ooo`3fm_H0
oooo0?ooo`3lo?`0oooo0?cjn`3ooOd0o?Og07alN01@D4h0b<K90?omo`3jo_/0n_km0?ono`3lnol0
nOgl0?WmnP3oool0ooko01X0oooo00<0oOgm0?clo03oool01@3oool01`3UiND05aLG00<30`010@40
@4100?gmo@3no_h0GP3oool005P0oooo00/0o?cl0?ooo`3oool0a/K600/;2`0000000@4107EeM@3n
o_h0oooo0?Win@020?ooo`030?Win@3oool0oOgm0280oooo0P3moOd01P3oool0nOWi0?ooo`3hn?P0
noWl0?klo`80oooo01X0n?Sf0?ooo@3mo_h0o?gm0?_loP3nool0ooko0?glo`3no_h0ookm0?gln03o
ooX0m?Wb0?coo`3inOl0oogo0?ooo`3ooOX0^[:`00X51`3Vj?80mOco0?Woo`3lood0oooo0?gkoP<0
ooko0P3oool0103clo<0oooo0?ooo`3bl_890?ooo`030?knoP3oool0oooo00@0oooo00h0Xj>S01HF
5P18B4P0:b/[0=WIf@3gmoL0oooo0?clo03gmoL0[Jf]00X:2P3AdM40oooo0?_kn`80oooo00/0mOGe
0?gmo@3oool0o_kn0?Shn03oool0o_kn0?ooo`3oo_l0oogm0?cgm`020?ooo`0<085kN`3Mf=P0n?kn
0?_oo`3oo_l0oogo0?_oo`3jool0oOgm0?ono@3oool0nocl6@3oool0303inOT0oooo0?_kn`3oool0
moOg0?ooo`3fm_H0@d=300D51@0000003`l?0>c/k600oooo001I0?ooo`040?_kn`3moOd0oooo08f=
S@800@4100<000000;Jf]P3oool00P3oool0103jn_X0oooo0?gmo@3moOdP0?ooo`080?[jnP3oool0
oooo0?ooo`3lo?`0oooo0?Shn03oool20?ono`0U0?[jnP3oool0ooom0?gmn`3nool0n__k0?koo`3m
o_l0ooko0?gmo@3oo_d0oook0?[im03nooT0nooj0?_oo`3no?l0o_Wo0?ono`3oo?T0ooGb06MMG03V
k?P0m?oo0?Goo`3gooP0o_ck0?ojo@3ooOl0o_go0?ckoP3oool0n_[j0?ooo`3no_h0oooo0?[jnP0:
0?ooo`80oOgm01@0o?cl0?ooo`3gmoL0Hf=S02DU9@3AdM40o_kn0:NWY`0F5QH06ATI04a<C00_;bl0
1`L702l_;`3Jf]X0o?cl0?[jnP3oool0no_k0?clo0D0oooo00h0nOWi0?ooo`3oool0nOOf0?ojnP3o
oOd0no_k0?ooo`3Rg=X01P410>odm`3jool0oocl0?omo@80nooo00@0oogn0?okn`3oool0o?go603o
ool03`3moOd0o_kn0?ooo`3oool0o_kn0?gmo@3no_h0QhN7000000051@D000000<O7a`3oool0o?cl
0??cl`1N0?ooo`00FP3oool0103inOT0oooo0?ooo`1:BTX20000000701dM7@3WinL0n_[j0?ooo`3l
o?`0o_kn0?gmo@0R0?ooo`0K0?clo03inOT0oooo0?knoP3jn_X0oooo0?Shn03blO@0ooko0?ooo`3h
n?P0ooom0?clnP3knoT0oooo0?ono`3noOl0oogn0?ono`3ooOd0ookk0?ommP3oooP0mOkg0?Ooo`3o
n?l0o_Go0080oogo00L0oo[d0:BFU@2c^/P0kooo0?3oo@3gooL0oook0080ooco00T0o__o0?ono`3o
ool0oooo0?KfmP3kno/0o_kn05]KF`3hn?P0203oool0203fm_H0oooo0?ooo`3lo?`0fm_K02l_;`1H
F5P0moOg0P3oool02@3emOD0o?cl0>KViP2^[Zh0c/k>0?Cdm03no_h0oooo0?gmo@040?ooo`050?Wi
n@3oool0oooo0?knoP3kno/00P3oool04P3lo?`0ookm0?olo03ooOd0oooo0?[jnP3@c<T0BdU806]^
LP3fnOd0o_ck0?omo03hnol0o?oo0?ooo`3mnoX0oooo0?onoaP0oooo00`0moOg0?ooo`3no_h0no_k
0?ooo`3no_h0`<30000000020P800@4107moO`3oool20?clo0030?ooo`3inOT0oooo05`0oooo001H
0?ooo`0@0?KfmP3oool0oOgm0?[jnP3oool0iNGU01/K6`051@D000000451@@3oool0no_k0?ooo`3l
o?`0oooo0?_knb00oooo00D0o_kn0?Win@3oool0oooo0?gmo@020?ooo`0T0>o_k`3oo_l0o_go0?on
o`3moOd0no_i0?ooo@3no_`0ooom0?gmo@3oool0oogn0?ono@3oo?T0oo_g0?onmP3mo_H0k?Sb0?Wo
o`3onOl0oo?o0>k`o@3nool0oo[d0>OGe@1aMhD0i?Go0?;oo`3hooP0oooj0?ojnP3onol0ooco0?on
o`3jn_X0o_kn0P3oool00`3lo?`00@410?ooo`090?ooo`080?Ogm`3moOd0Z:RX01HF5P2NWYh0m_Kf
0?ooo`3no_h50?ooo`030?_kn`3oool0n_[j00@0oooo00D0nOWi0?ooo`3oool0oooo0?Ogm`020?oo
o`0D0?clo03jn_X0oooo0?gmo@3oo_d0mO?b0?omo`3oo_l0YJFS08J6Q039b</0Z:NZ0?cmo@3nool0
n_Wl0?glo`3oool0o_kl0?ooo`3lo?`I0?ooo`0;0?Ogm`3oool0oooo0?gmo@3YjNT07alO00000001
0@40?Shn0?Win@3moOd00P3oool00`3kno/0oooo0?ooo`1L0?ooo`00F@3oool03`3kno/0oooo0?oo
o`3inOT0oooo0;^k^`0000001@D500410@24Q8@0oooo0?_kn`3oool0moOg0?knoP0R0?ooo`0:0?_k
n`3moOd0n?Sh0?ooo`1[Jf/010@40>KUjP3kn_d0mOCg0?ooo`@0ooom01T0o?[k0?ono`3on_`0oogm
0?okn03ooOL0ookf0=WJe00010D09b/b0:ZEX@0;00L0X:Ni0?Goo`3oo?H0ooC_05UKJ03Zm_l0mooo
0?;mm@3looX0oook0?oko`3oo?l0n_Sk00<0oooo00@0n_[j0?ooo`000000no_k203oool02`3lo?`0
n_[j06m_K`0V9RH0aLG50?ooo`3no_h0o?cl0?ooo`3jn_X0oooo0080o?cl0P3oool01@3kno/0oooo
0?ooo`3oool0nOWi00D0oooo00<0no_k0?[jnP3oool00`3oool04@3lo?`0ooom0?ono@3onoT0o?Og
09JJV`1JGUl0oogm07ehNP3Ni^P0nOoo0?omo`3ono/0o_oo0?[no`3oool0oO_l01P0oooo00<0o_kn
0?Shn03oool00P3no_h01@1<C4`0000000H61P0M7Ad0h>3P00D0oooo00<0o?cl0?ooo`3oool0F`3o
ool005T0oooo00<0oOgm0?clo03oool00`3oool01`1hN7P000000000000410@0clo?0?ooo`3jn_X0
8`3oool03@3lo?`0oooo0?ooo`3oool0o?cl0?Shn00000001PD:0>g/k`3oo_l0oooo0?_kn@3no_`0
0P3oood06@3no?d0ooko0?cgm`3oo_/0oogj0?onmP3on?00/:nZ04UAF@3lo_l0=R0S01T53P2h`]L0
hoCo0?omnP3Pem004Q8L0=3FhP3io_l0mogi0?con`3noo/0o_Wk0?omo`3oo_l00`3oool20?knoP03
00410@3oool0oooo00L0oooo00`0g]kN03Hf=P1?Cdl0mOGe0?clo03moOd0oooo0?knoP3moOd0oooo
0?[jnP3oool20?gmo@0=0?ooo`3no_h0oooo0?knoP3jn_X0oooo0?knoP3kno/0o?cl0?ooo`3inOT0
oooo0?clo0030?ooo`0C0?[jnP3oool0ooom0?ckm`3oo?/0oocj05mWJ@2a]kL0oocm09ZDU02f_l80
lOcn0?omo@3oo?X0o?oo0?SnoP3oool0ookm0?ono`0I0?ooo`0;0?clo03oool0QHF5000000030`<0
00000;Fe]@3oool0oOgm0?knoP3moOd0H03oool00600oooo00L0?Cdm00820P0000009RHV0>k^kP3o
ool0o?cl0080oooo00H0no_k0?ooo`3oool0no_k0?ooo`3moOdI0?ooo`80oOgm00<0oooo0?gmo@3j
n_X00P3oool06`2/[:`010<8018A503Mg=l0o_kn0?ooo@3knoT0ooom0?kno03ln_/0ooko0?kin@3o
o_/0oogj0?onmP3ooOD0fmOD00/>7@3jn?l0onoZ01/;2@35eNX0kOoo0?Ogm@3oo_H0o_go0??fo@02
0?ono`050?oon`3lo_T0oooo0?_kn`3oool00P3lo?`0103no_h0oooo05MGE`2SXj<40?ooo`0<0?Sh
n03oool0oooo0?clo02a/K404A4A09RHV03inOT0oooo0?knoP3oool0oOgm6@3oool04@3knoT0oook
0?oknP2TWY`04a/M0<C:bP3oo?d0HUaL0<K?dP3`nod0oogm0?oim`3lool0nooo0?[jnP3oo_d0ooko
0100oooo00H0nOWi0?ooo`3oool0o?cl0?ooo`3no_h40?ooo`050;no_`092@T00P820000001fMWH0
I@3oool00600oooo00/0f][J00`<300;2`/0000005QHF03oool0o_kn0?clo03kno/0oOgm0?clo002
0?ooo`80oOgm6`3oool02`3no_h0oooo0?ooo`3kno/0oOgm0?knoP0c<SL0000201PG6P3@d=00no_i
0080o_kl01X0ooom0?ono`3ln_/0oogo0?omo@3ooOX0nOC^0?onmP3bkNd07Q/^0=K?g`3onNd0Vi>8
08FI[`3UoOl0o_oo0?omm`3lo_/0oOko0?olo`3onol0oOSh0?gln03lood0nooo0?Ohn080oooo00L0
UiNG00410@0=3@d0oooo0?gmo@3oool0o?cl0080oooo00/0oOgm0?Win@1gMgL0820P0<W9b@3dm?@0
oooo0?_kn`3lo?`0oooo0?gmo@0I0?ooo`0@0?kno03oo_d0oo[h0?olo03ho?d0o?oo0?omo@3ooOl0
koOi0?Woo`3ooOl0o?Kf0?koo`3lool0o?cl0?onoa80oooo00X0o_kn0?ooo`3no_h0no_k0?ooo`3m
oOd0oooo0?clo03clo<08b<S0P0000000`0o?cl0no_k0?ooo`1T0?ooo`00H@3oool01@2QXJ400000
00D51@030`<0XZ:R00@0oooo00H0oOgm0?knoP3oool0o_kn0?ooo`3lo?`H0?ooo`050?clo03kno/0
oooo0?knoP3lo?`00P3no_h0:03oool0gMcQ00d<3`0000801@D50:b/ZP3oood0no_i0?ooo@3jn_X0
oooo0?ono`3knOP0ookk0?onnP3oo_H0ooco0<RneP0A1AL0ooSV08f>O00X?E00kOoo0?kno`3ekn`0
n_oh0?coo@3onol0oo?o0?ojo`3onOL0noom0?GonP3lool0]kNg01LG5`0<30`02@T90??cl`3oool2
0?gmo@070?ooo`3jn_X0oooo0>7Qh@0m?Cd0@d=30>o_k`030?ooo`030?gmo@3oool0oooo0080o?cl
603oool20?ono@040?omo`3mno`0ooom0?gmn`80o_go0P3nool20?glo`030?ooo`3oood0oOgm0140
oooo00<0o?cl0?ooo`3oool00P3oool02P3hn?P0m?Cd0?ooo`3oool0o_kn04I6AP010@400`<301HF
5P3Ti>AV0?ooo`00H03oool02@3lo?`0oooo06ATI00000000`<300L71`3Cdm<0oooo0?gmo@020?oo
o`050?gmo@3no_h0oooo0?ooo`3lo?`06P3oool00`3no_h0oooo0?ooo`020?ooo`0:0?Ogm`3oo_l0
BTU<00X:2P0000002`/9051@CP3^k^`0oooo0?glo`80ooko01X0nOOh0?cgm`3nn_L0oooh0?olo`3o
lol0a[W:06ERC`1UK5P0<TED0>3ao`3knol0ookk0?_on03iooT0ooco0?ojo`3om_/0oogk0?Cmn02M
Yj808RHU00@4100000008R8R0?gmo@80oooo00d0oOgm0?ooo`3no_h0oooo0;Zj^P0D51@0Ph>30?oo
o`3inOT0n?Sh0?[jnP3no_h0oooo0080o_kn6@3oool01`3oo_d0oogm0?ghn03inOT0oooo0?gimP3n
o?/00P3lool0203no?/0noWh0?[mo`3lool0oooo0?omo03no_h0ooko4@3oool0103moOd0n_[j0?oo
o`3kno/20?ooo`040?7al@3oool0TI6A00<30`80000000<0][Jf0?Win@3oool0I@3oool00680oooo
00X0lo?c02TY:@000000000003@d=03fm_H0oooo0?[jnP3no_h0oooo0P3lo?`00`3no_h0oooo0?oo
o`0G0?ooo`0;0?gmo@3oool0n?Sh0?_kn`3oool0moOg0?Win@3oool0o_co0=GCeP0:2PX00P000000
6`0820H05AHF09jOW`3nool0oOko0?ckoP3oool0ookm0?oon`3kn_D0ooco0?oio`3omOl0no_^0?_o
m03cool0mOoo0?clo`3oood0n_oi0?_onP3mn_l0o_Cm0;R[/01CCDd03Q@@008;1P030000000<0?cl
o03kno/0o?cl055AD@3oool0oOgm0?ooo`1iNGT06QXJ0<G5a@3oool0no_k1@3oool00`3lo?`0oOgm
0?ooo`0H0?ooo`030?ono@3mn?P0oogm0080oooo00H0o_Sf0?omo@3io_l0m__n0?omo@3ono/20?_o
o`040?_inP3nnOT0oooo0?kooa40oooo00h0n_[j0?ooo`3oool0oOgm0?ooo`3moOd0oooo0<_;b`00
00000`<30000001iNGT0oooo0?gmoFH0oooo001P0?ooo`080?gmo@3oool0n_[j0=OGe`0>3Ph00000
00P8201[Jf/20?ooo`050?[jnP3oool0oooo0?ooo`3kno/06P3oool00`3jn_X0oooo0?ooo`020?kn
oP070?ooo`3gmoL0ooko0?klo`19BDT0000000D50`020000000G00<4100;30h0P8630?ono`3mo?l0
o?cl0?WgmP3ooo/0e]7C09J>V`3onol0oooh0>cbj01aN800mOgo0?coo`3jnod0EEYD02@Y8`0?3Q40
2@<:01H?4P0300000P000@003`051PH08R8R0>[ZjP3inOT0o_kn0?ooo`030`<0oooo0>SXj010@400
@D510>WYj@3oool0n?Sh0?knoP020?ooo`040?[jnP3lo?`0oooo0?ooo`80oOgm603oool01`3oo_l0
oogm0?ghn03kno/0oooo0?omo@3ono/00P3kool0203oo_l0oogo0?_oo`3kool0o?cl0?ono@3oool0
oOkn403oool00`3kno/0oooo0?ooo`030?ooo`0:0?Shn03]kNd09BDU0000000410@0?clo0?3`l03l
o?`0oooo0?knoVD0oooo001T0?ooo`0808^;R`0410@0000000410@2YZJT0oooo0?[jnP3no_h20?oo
o`030?knoP3oool0oooo01L0oooo00D0TI6A00820P0`<300[Zj^0?clo0020?ooo`070?knoP3knO`0
ooko0:BRX`0=2``00@4000@40P0202<T900>01@E5`0000@0@D960?koo`3mo_h0ooom0?gmn@3oood0
EE9H0=SEf`3jmOL0R8J70:j]/P3hnol20?Woo`0607MiMP0h>3H05QDH00000P082@T00@820P030000
0`0D4Q<0jn_[0?ooo`020?ooo`080?Shn0061PH0]kNg01LG5`20P800oooo0?clo03no_h20?ooo`08
0?_kn`3oool0oooo0?knoP3oool0oOgm0?_kn`3no_hH0?ooo`0A0?ono`3ono/0oogm0?oon`3jn_P0
ooko0?gkoP3bm_<0noon0?glo`3lnol0n_km0?coo@3oool0ooko0?ooo`3moOd0403oool01@3lo?`0
oooo0?;blP3oool0moOg0080oooo00P0EEEE00820P0000003@d=0=gMg@3oool0o_kn0?_knfH0oooo
001P0?ooo`80o_kn0P3oool02P3moOd0DU9B00@4100000005aLG0>CTi03moOd0oooo0?clo03kno/C
0?ooo`050?ooo@3ooo/0oook0?ooo@3oool00P3nool0203mnoh0XInR0=_Kf@3alNl0nocl0?koo`3m
oOd0o_cm0P3oo_l05`3knOX01P@50000001@D4h092DU0>o`l03in_`0o_oo0?Cen@3fmoT0o_oo0?gn
oP3oood0o?cj0>KWj@18AdX0dL_B05UDF03oo_l0o_oo0?CloP3iool0o_oo0080nOWi01<0`lC601HJ
6@061`L00`0000l92@38a/L0o?cl0?ooo`3lo?`0oooo0?knoP0000006a/K0<30`03moOd0no_k0?oo
o`3kno/0oOgm0080oooo00@0no_k0?ooo`3oool0o?cl0`3oool00`3moOd0oooo0?ooo`0F0?ooo`06
0?ono@3knOP0o_kj0?ooo@3hm_T0ooko0P3nood20?ono`060?cnn`3nood0ooko0?glo`3lo?`0ooom
4@3oool00`3kno/0oooo0?[jnP020?ooo`0:092@T0020P80000000<30`2/[:`0o_kn0?ooo`3lo?`0
oooo0?WinFD0oooo001Q0?ooo`090?Win@3oool0oooo0?ooo`3]kNd071`L00820P000000?Shn00<0
oooo00<0oOgm0?clo03oool0403oool0<P3moOd0oook0?ojl03oo_@0oook0?Ohn03lool0noko0?kh
o`3onol0U9>?0=KHd`3kool0o?oo0?[hn`3ooOl0ooko0?ooo`3lo?`0ADE500/;2`2_[jl0JVYZ04a<
C03kno/0oooo0?ckoP3oool0o?cl0?ooo`3kno/0oooo0?clo02[Zj/00P030>WWj03oool0n_[j0?ko
o`3ko?`0oooo0?Shn02HV9P05ADE08N8R00:2PX040h?06YXJ@3no_h0oOgm0P3oool0103[jn/0@d=3
02`/;03Shn<Z0?ooo`030?ooo@3oool0oooo00<0oooo0P3oo_lF0?ooo`80oOgm00D0oooo0?knoP3m
oOd0d];B00T92@020000000306YZJP3oool0oooo0080o_kn00<0oooo0?knoP3oool0I03oool00640
oooo00/0o_kn0?ooo`3inOT0o?cl0?ooo`2l_;`00@4100820P030`<0PX:20?gmo@0D0?ooo`0P0?ko
o`3noOP0ooca0?oci@3lnO80o?oo0?Cmo`3ioOl0oo_o0?ogo`3ln?D0LG=^0>Kbl03hool0ooko0?gf
n`3ln_/0o?cl0?ooo`23Ph<000000=SHf03jn_X0?Cdm08F5Q@3lo?`0oooo0?gmo@3oool0n_[j0?oo
o`3moOd20?ooo`0E0=CDe03lo?`0o_kn0?_kn`3lo?`0oooo0>g]k@1@D500>CTi0=OGe`2l_;`01PH6
024Q8@3oool0oOgm0?ooo`3no_h0_Kfm018B4P21PH40no_k04/0oooo00T0mOGe0?ooo`3alO40:RXZ
000000030`<0<C4a0?knoP3kno/00P3oool00`3moOd0oooo0?knoP1U0?ooo`00H03oool01@3moOd0
o_kn0?ooo`3oool0nOWi0080oooo00T0OWin0000000000001@D50<O7a`3oool0oOgm0?ooo`3jn_X0
3`3oool04P3nool0nOoo0?cln02RSXD04@0007UdJP2?V9<000TA0<cEh03omod0k=WK0?oko022QXD0
Zknm0>WknP3onol0oo[o0?omo`80oooo00X0YZJV00820P3oool0oOgm0>OWi`0I6AT0^[Zj0?clo03o
ool0oOgm0`3oool00`3moOd0oooo0?ooo`020?ooo`0:0?knoP3moOd0`/;2020P801bLW80l?3`0?cl
o02`/;0000000:>SX`80o_kn00L0oooo08B4Q00M7Ad0_Kfm0?Win@3oool0nOWi04P0oooo00D0n_[j
0?ooo`3oool0no_k05mOG`0200000006018B4P3GemL0oooo0?clo03oool0moOg0P3oool00`3moOd0
oooo0?ooo`1S0?ooo`00H03oool00`3kno/0oooo0?Shn0020?ooo`040?_kn`3fm_H0oooo04M7A`80
000000@09bLW0>[ZjP3no_h0oOgm403oool0703nool0mOgk0?gmn@1D@CX0d[je0>gYg@001000BEMP
0<WBg`3onol0d<31034X:`093@h0fNcX0?Coo`3ooOl0oo_o0?kin`3oool0o?cl0?;blP28R8P0nOWi
0?ooo`3lo?`0`/;2018B4P3Kfm/20?ooo`80o_kn0P3oool02@3hn?P0oooo0?_kn`3oool0no_k08Z:
RP0K6a/0/;2`0?clo0020?ooo`0907UiN@0410@0oooo0?[jnP3/k>`0ADE503Lg=`3Ti>@0o?cl04d0
oooo00<0nOWi09ZJVP0:2PX00P0000001P2RXZ80oooo0?ooo`3oool0m_Kf0?ooo`80oOgmIP3oool0
0600oooo00d0oOgm0?ooo`3kno/0no_k0?ooo`3inOT0o_kn0?ooo`3Kfm/0410@00D51@000000E5AD
0080oooo00<0o?cl0?ooo`3oool03P3oool0303oood0ookk08ElM`2KTX/0oO[_0<73_@0;3aP0m?Ko
0?[go@3km?L0ooko0?cmo`80nOok00<0noSn0?olo`3oo_l00P3oool02P3hn?P0oOgm0?ooo`3lo?`0
oOgm0?ooo`2OWil09bLW0?Cdm03lo?`20?ooo`80oOgm00L0oooo0?gmo@3jn_X0j>SX04M7A`0f=SH0
gmoO0080oooo00P0m_Kf0?ooo`3;bl/0eMGE0?ooo`38b<P07alO07QhN0<0oooo00<0no_k059BDP3o
ool0B03oool0103kno/0o?cl0=OGe`0<30`20000000406a/K03oool0no_k0?clo080oooo00@0nOWi
0?_kn`3oool0oOgmI@3oool00640oooo00h0o_kn0?ooo`3lo?`0oooo0?gmo@3oool0nOWi0?ooo`2`
/;00000000@410000000W9bL0?gmoA40oooo00P0o_cm0?chm@3<aKd050l50?oomP3moOT07AdU0=oN
j`80ooko00T0oooo0?WjnP3koo`0n_kk0?ono`3nnol0ooko0?_kn`3inOT00`3oool0203inOT0oooo
0?Gem@3oool0GUiN05QHF03oool0m_Kf0P3oool20?gmo@040?ooo`2b/[804a<C07moO`<0oooo00<0
oOgm0?ooo`3oool00P3oool00`2@T9005ADE0;6a/@020?_kn`80n_[j00<0oooo0000003oool0B03o
ool01`3jn_X0o?cl02TY:@00000020P802LW9`3emOD00P3oool01P3fm_H0o_kn0?ooo`3moOd0oooo
0?clo6H0oooo001Q0?ooo`0>0?_kn`3oool0oooo0?gmo@3no_h0n?Sh0?ooo`3inOT0oooo06ATI000
00001PH600L71`3De=@@0?ooo`80ooko0100ookm0?onk`1TGD/0RHF10?cmo`14B5<0Wj6]0?omo`3n
nO/0oooj0?cnn@3iool0nooo0?[hn@3ooOd0oogn0P3oool01@3jn_X0n?Sh0?ooo`3lo?`0no_k00<0
oooo00@0;Rh^08^;R`3oool0no_k0P3moOd03`3kno/0IfMW02DU9@32`/80no_k0?ooo`3gmoL0oooo
0?clo03oool0o_kn0?;blP1@D500;bl_0>3Ph0030?ooo`050?gmo@3oool0oooo00410@3no_h0B@3o
ool0201GEeL00@4100@4100:2PX0f=SH0?gmo@3oool0nOWi103oool00`3lo?`0oooo0?Ogm`1U0?oo
o`00H03oool0103no_h0oooo0?knoP3hn?P30?ooo`090?Win@3oool0oOgm0?clo00_;bl0000000<3
0`0Y:BT0m_Kf00l0oooo0P3oo_l05@3jmOD0oo_/0?ook@27Ph00KFec02hb>`26R980noOo0?olo`3o
ooX0nO_e0?Soo`3kool0oO_l0?okn`3ooOh0oooo0?_kn`3moOd0oooo0?gmo@030?ooo`050?Gem@3o
ool0i^KV01HF5P2h^;P00P3oool03P3Ng]h0<30`05ADE03YjNT0o?cl0?ooo`3lo?`0oooo0?gmo@3o
ool0o?cl0<k>cP0M7Ad0Kfm_0P3lo?`0203oool0nOWi0?ooo`3oool0oOgm0?Win@071`L0o?clB03o
ool0202OWil01`L7000000000000WIfM0?clo03oool0o?cl0P3oool01@3jn_X0oooo0?clo03oool0
o?cl06H0oooo001Z0?ooo`0=0?_kn`3De=@01`L700<30`000000J6QX0?Ogm`3oool0nOWi0?ooo`3k
no/0oooo0?gmo@090?ooo`060?omo`3ooOd0ookf0?ollP3oo_/0oOco0P3lool20?olo`040?ono@3n
ooX0o?om0?coo`80ooko2@3oool02P3moOd0oooo0?clo030`<006ATI0=kNgP2SXj<05aLG09JFUP3n
o_h20?ooo`0=0?gmo@3oool0oOgm0?ooo`3no_h0UIFE01@D502^[Zh0n_[j0?ooo`3lo?`0o_kn0?oo
o`020?gmo@030?ooo`3no_h0YZJV0480oooo00/0m_Kf0?ooo`3kno/0oooo0?knoP3oool0e=CD00X:
2P020P800@4105aLG0020?ooo`030?clo03oool0oooo06`0oooo001X0?ooo`0<0?_kn`3inOT0oooo
0?ooo`2EUID0000000410@061PH0];Bd0?Win@3oool0o_kn0`3oool00`3inOT0oooo0?ooo`060?oo
o`080?ono`3km_H0VY:=0=G>aP3oo?T0oooo0<K9c@2CUYd20?olo`040?ono@3noo/0o?om0?coo`80
ooko2P3oool01`3inOT0oooo0?gmo@2f][H0Cdm?02/[:`39bLT00P3oool00`3inOT0oooo0?_kn`02
0?ooo`050>k^kP1KFe/0;2`/0=[JfP3moOd00`3oool0203jn_X0oooo0?[jnP3oool0n_[j0?knoP3o
ool0n_[j@03oool0203lo?`0oooo0?ooo`3moOd0o_kn0?ooo`3fm_H0<S8b0P0000001@0];Bd0nOWi
0?KfmP3oool0oOgm06h0oooo001Z0?ooo`040?_kn`3oool0oOgm05IFEP80000000H0410@0>WYj@3o
ool0oOgm0?ooo`3kno/90?ooo`80ooko00/0oogo0??Zh@15?C80m_?/0?Cem@0X:cX0k>gm0?omo`3o
oO/0oogm0?koo`020?Woo`030?ono`3ooOd0ooko00L0oooo00X0oOgm0?ooo`3lo?`0oooo0?knoP3o
ool0/;2`0?;blP3oool0oOgm0P3oool01`3fm_H0n_[j0?ooo`3<c<`092@T06YZJP3`l?000`3oool0
0`3lo?`0oooo0?ooo`020?ooo`040??cl`3oool0oooo0?;blT80oooo00L0n_[j0?ooo`3oool0oooo
0?gmo@1YJFT00000008020P800H0dM7A0?ooo`3oool0l_;b0?ooo`3lo?a]0?ooo`00J@3oool02`3m
oOd0oooo0?[jnP3moOd0lo?c01dM7@092@T0000003`l?03inOT0no_k0080oooo00<0m_Kf0?ooo`3o
ool01P3oool03@3oo_l0o?Wo0?omo`3on_80ZZJJ0:JSVP2=SHd0[:Zm0?gko`3oo_l0oooj0?ono@3n
ool00P3lool00`3oo_l0ookm0?ooo`080?ooo`80o_kn00D0oooo0?clo03oool0oooo0?knoP020?oo
o`070?_kn`3oool0oooo0?ooo`2KVi/04a<C0:NWY`020?ooo`0<0?gmo@3kno/0oooo0?ooo`3jn_X0
o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[jA03oool0103kno/0o_kn0:f][@051@D20000000409RH
V03oool0oooo0?Ogm`80oooo00<0oOgm0?ooo`3oool0J`3oool006P0oooo00d0o_kn0?_kn`3oool0
no_k0?ooo`3lo?`0b<S8000000051@D00P8207moO`3oool0n_[j0080oooo00<0m_Kf0?ooo`3oool0
1@3oool01`3oo_l0oo_o0?gfn@3gnO@0o?oh02TY7`17@D400P3onOl0103lool0nOoo0?coo`3oo_l2
0?omo@030?koo`3lool0o_oo00L0oooo01<0oOgm0?ooo`3oool0oooo0?_kn`3lo?`0oooo0?[jnP3n
o_h0oooo0?[jnP3no_h0m?Cd05YJFP0U9BD0f=SH0?_kn`3lo?`0oooo0080oOgm00<0oooo0?_kn`3o
ool00`3oool01@3fm_H0no_k0?knoP1KFe/0n?Sh0400oooo00/0n?Sh0?ooo`3oool0oooo0=cLg005
1@D0000000410@1JFUX0oooo0?clo01b0?ooo`00J@3oool0103lo?`0o_kn0?ooo`3clo<20?ooo`08
0861P@000000000000D51@3:b/X0oooo0?clo03no_h80?ooo`0=0?omo`3onOl0ooco0?kon`3jooH0
gmkI0?C]l03olol0oo[o0?_oo`3hool0o?oo0?ooo`020?olo@030?koo`3kool0o_oo00T0oooo00D0
no_k0?clo03oool0oooo0?Win@020?ooo`060?[jnP3oool0d];B02/[:`1OGel0n_[j0`3oool01@3k
no/0oOgm0?ooo`3oool0n?Sh0080oooo00H0n_[j0?knoP3oool0oooo0?clo0010@530?ooo`070?kn
oP3dm?@0<c<c00H61P00000092@T0>c/k0020?ooo`040?Shn03oool0nOWi0?gmoFh0oooo001X0?oo
o`030?gmo@3oool0n_[j0080oooo00/0o_kn0?ooo`3lo?`0@D5100/;2`00000071`L0>OWi`3no_h0
oooo0?clo0070?ooo`0=0?ono`3nn?l0oo[o0?oomP3ooO80ookm0?omo`3oo?l0noWo0?omo`3nool0
ooom0?oon`020?ono`030?ooo`3oood0oooo00L0oooo00@0oOgm0?ooo`3oool0n_[j0`3oool01`3f
m_H0oooo0?clo02TY:@04a<C09fMW@3oool00P3moOd20?ooo`040?Win@3oool0oOgm0?Shn080oooo
00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_knd00oooo00@0n?Sh0?ooo`3no_h0KFe]0P00
000010071`L0bl_;0?ooo`3emOD30?ooo`030?gmo@3oool0o?cl06d0oooo00120?ooo`80ooom0P3o
o_l40?ooo`80ooko00@0oooo0?ooo@3oo_l0ooko6@3oool02@3moOd0oooo0?knoP3no_h0oooo0?gm
o@3oool0h^;R01LG5`0200000003051@D03oool0oOgm00P0oooo00d0ooko0?omo`3no?l0ookf0?oj
lP3oo_l0o?_o0?kno`3lo?l0ooco0?omo`3ooo/0o_ok0080o?oo00<0oooo0?ono@3oool0203oool0
0`3jn_X0oooo0?ooo`020?ooo`080?clo03oool0m?Cd06a/K00P8200e]KF0?ooo`3jn_X30?ooo`03
0?knoP3oool0oooo0080oooo00<0oOgm0?clo03oool00`3oool20?knoP0300410@3oool0oooo0400
oooo00<0o?cl0:n_[`0000000P0000000`2BTY80oooo0?Win@030?ooo`030?gmo@3oool0o?cl06h0
oooo00100?ooo`80ooko0P3ooo/20?ono`040?ooo`3oood0o_om0?koo`80o_ko00<0o_om0?kon`3o
o_l00P3oo_lP0?ooo`090;Ng]`0000000@410000002EUID0oooo0?[jnP3oool0m_Kf0080oooo00H0
o?cl0?knoP3oool0oooo0?ono`3oool20?oon`030?ooo`3oo_l0ooko00<0ooko0P3oood20?koo`@0
oooo0P3no_h20?ooo`030?_kn`3oool0no_k00<0oooo00L0no_k0?clo03oool0f][J030`<01<C4`0
no_k0080oooo00<0no_k0?clo03oool0203oool01`3no_h0oooo0?gmo@3moOd0oooo0?knoP2VYZH0
>P3oool0103jn_X0oooo0?ooo`3jn_X30?ooo`030?gmo@3Ph>00410@0080000000<0FEUI0?gmo@3n
o_h0M@3oool00400oooo0P3oo_l0203oooX0oook0?ono`3oo_l0ooom0?oon`3nood0o_oo0P3no_l2
0?kon`<0ooko803oool0203inOT0JVYZ00H61P0000002@T90=3@d03oool0oOgm0P3oool01@3gmoL0
oooo0?_kn`3oool0oOgm0100oooo00D0oOgm0?ooo`3oool0oOgm0?Shn0030?ooo`040?knoP3oool0
oooo0?gmo@80oooo00H0Y:BT014A4@2HV9P0oooo0?Win@3jn_X30?ooo`030?_kn`3oool0oooo00H0
oooo00P0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnSP0oooo00l0o?cl0?ooo`3jn_X0n_[j
0?ooo`3jn_X0oooo0?knoP3lo?`0=cLg0000000410@09BDU0>OWi`3kno/0MP3oool00400oooo0P3o
o_l02P3ooo/0ooom0?ono`3oo_l0oook0?oonP3oool0ooko0?omo`3oo_l20?oonP<0ooko7`3oool0
3`3inOT0oooo0?Ogm`0`<3000`<300@4100V9RH0moOg0?clo03oool0n_[j0?ooo`3moOd0oooo0?kn
oP0B0?ooo`030?[jnP3lo?`0oooo00<0oooo0100nOWi0?ooo`3oool0oooo0?KfmP3jn_X0J6QX024Q
8@3De=@0o?cl0?ooo`3lo?`0oooo0?Win@3oool0oOgm303oool0103clo<0oooo0?ooo`3bl_8i0?oo
o`030?gmo@3lo?`0oooo0080oooo00P0o?cl0?ooo`3no_h0M7Ad00820P0000002@T90<C4a080oooo
00<0o?cl0?ooo`3oool0L`3oool00480oooo00X0ooom0?ooo`3oo_l0ooko0?oon`3oooX0oooo0?on
o`3ooOl0ooko0P3oooP30?onoal0oooo00D0o_kn0?ooo`3oool0d];B01<C4`020000000406=SH`3o
ool0oooo0?clo080oooo00<0no_k0?ooo`3no_h0503oool0103no_h0n_[j0?ooo`3oool20?clo008
0?knoP3Vi^H0=SHf04i>CP3]kNd0o_kn0?ooo`3emOD30?ooo`030?gmo@3oool0o_kn00P0oooo00L0
o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[j03T0oooo00`0no_k0?ooo`3oool0oOgm0?knoP3oool0
o_kn0;:b/P0000000P8200410@2:RXX20?ooo`030?knoP3oool0oooo07@0oooo00100?ooo`030?oo
o@3oool0ooko0080ooko00<0oooo0?oonP3oooP0103oo_l20?oomP030?ono`3ooOl0ooko0240oooo
00P0nOWi0?ooo`2BTY80000000<30`0410@0[Zj^0?clo080oooo00@0mOGe0?ooo`3oool0oOgm403o
ool0103clo<0oooo0?clo03kno/60?ooo`0;0;Fe]@0@4100SHf=0?ooo`3no_h0oooo0?[jnP3oool0
oOgm0?ooo`3no_h00P3oool00`3kno/0oooo0?ooo`090?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P0
>P3oool01P3hn?P0oooo0?ooo`3inOT0hn?S01PH6080000000@0BTY:0?ooo`3oool0oOgmM`3oool0
0400oooo00<0o_om0?koo`3oo_l00P3oo_l00`3oool0oooh0?oon0030?ono`060?ooo`3ooo@0oood
0?ono`3ooOl0ooko803oool01@3no_h0oooo0?[jnP3oool0IVIV0080000000H0410@0=oOg`3moOd0
oOgm0?ooo`3inOTD0?ooo`040?gmo@3oool0oooo0?clo0<0oooo00`0KFe]01`L703;bl/0n_[j0?kn
oP3oool0n_[j0?ooo`3gmoL0o?cl0?ooo`3gmoL<0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@41
>P3oool03`3lo?`0oooo0?ooo`3moOd0oooo03Lg=`00000010@401lO7`3YjNT0oooo0?Ogm`3moOd0
oooo0?[jnP1e0?ooo`00?`3oool00`3oood0o_ok0?koo@020?kno`050?ono`3oood0oooh0?oon03o
o_l00P3ooOl0103oo_d0oood0?oom03oool20?onoal0oooo00<0o?cl0?ooo`3oool00P3oool01@3Z
j^X08B4Q00@410000000>SXj0080oooo00@0o?cl0?ooo`3oool0no_k403oool00`3jn_X0oOgm0?[j
nP040?ooo`040>3Ph00f=SH0BTY:0>k^kPD0oooo00P0no_k0?ooo`3oool0no_k0?ooo`3moOd0oooo
0?clo0P0oooo00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_kncP0oooo00/0o?cl0?_kn`3o
ool0n?Sh0?ooo`1fMWH010@400410@0410@0`<300?ooo`020?gmo@030?ooo`3inOT0oooo07D0oooo
000o0?ooo`030?ooo@3noo/0o_om0080o_ko00@0ooko0?oon`3oooP0oooj0P3ooOl01P3oo_l0ookm
0?oomP3oooH0oooo0?onob00oooo00`0o_kn0?ooo`3moOd0o_kn0?ooo`3jn_X0clo?00820P010@40
000007UiN@3moOd20?ooo`030?Shn03oool0oooo01D0oooo00<0/K6a01PH602:RXX00P3oool0103n
o_h0oooo0?_kn`3oool20?gmo@060?ooo`3lo?`0oooo0?gmo@3no_h0o?cl3@3oool20?knoP030041
0@3oool0oooo03T0oooo00@0oOgm0?_kn`31`L400P820P0000000`24Q8@0oooo0?Win@030?ooo`03
0?_kn`3oool0oooo07@0oooo000o0?ooo`0A0?ooo@3mooX0o?oo0?ShoP3lo?l0oooo0?gmn@3oooX0
oook0?olo`3nnol0ooko0?Whm03oooP0oooj0?clo03nool0803oool0203inOT0oooo0?[jnP3oool0
no_k0?ooo`3gmoL0SHf=0P0000001@092@T0_[jn0?gmo@3oool0n?Sh0080oooo00@0o_kn0?_kn`3n
o_h0oOgm0P3oool00`3hn?P0oooo0?ooo`020?ooo`030?_kn`3oool0n_[j0080oooo00L0mOGe0?oo
o`3oool0no_k07IfMP0N7Qh0a<C401P0oooo00L0o_kn0?ooo`3moOd0oOgm0?ooo`3no_h0YZJV0340
oooo00@0oOgm0?ooo`3oool0nOWi103oool20?knoP060?ooo`3UiND051@D000000010@40BDU9O@3o
ool00400oooo0100o_om0?Kjn@3no_l0o_ko0?ooo@3ooo/0no[f0?kln`3oo_l0oogo0?Wgn03oood0
nOWe0?koo@3nool0oOko8@3oool03`3no_h0moOg0?ooo`3oool0oOgm0?ooo`3fm_H0C4a<00<30`00
000051@D0?3`l03gmoL0oooo0?_kn`050?ooo`050?clo03moOd0oooo0?ooo`3lo?`00P3oool01@3k
no/0oooo0?ooo`3inOT0o_kn0080oooo00D0hn?S03Xj>P1:BTX0jn_[0?clo00H0?ooo`080?[jnP3o
ool0n_[j0?ooo`3jn_X0o_kn0?ooo`3jn_Xa0?ooo`070?gmo@3oool0oooo0?ooo`3no_h0no_k0?gm
o@020?ooo`060?Cdm012@T8020P80000000G5aL0inOWO@3oool00400oooo00H0o_om0?cmo@3oo_l0
oOco0?Sfm@3oo_X20?omo`080?gkoP3no?l0ooom0?ooo@3oo_l0o_oo0?gno`3noolQ0?ooo`090?gm
o@3oool0oooo0?ooo`3moOd0n?Sh0?ooo`3QhN405QHF0080000000H0EEEE0?gmo@3no_h0oooo0?kn
oP3moOd20?[jnP80oooo00<0no_k0?ooo`3moOd00P3oool0303kno/0oooo0?knoP3no_h0oooo0?gm
o@3oool0^k^k01HF5P26QXH0n?Sh0?knoQ`0oooo00@0lo?c0?ooo`3oool0l_;b<P3oool02P3kno/0
oooo0?ooo`3moOd0oooo0?knoP3oool0moOg0?ooo`26QXH20000000300410@38b<P0n_[j07d0oooo
00100?ooo`80o_oo00H0m?Cd0?ooo`3ooo/0oO_j0?olo`3lm_h20?ono`070?Ogl`3clo<0o_ko0?Wk
o`3lool0n?ck0?koo`0O0?ooo`0>0?knoP3oool0oooo0?Shn03no_h0oooo0?[jnP3oool0oOgm0;bl
_0010@401@D50000002ATI450?ooo`0C0?gmo@3no_h0oooo0?gmo@3no_h0oOgm0?ooo`3kno/0oOgm
0?ooo`3inOT0oooo0?Gem@3oool0O7al01LG5`32`/80oOgm0?ooo`020?clo1P0oooo00L0o?cl0?oo
o`3jn_X0oooo0?knoP3oool0n_[j03@0oooo00@0oOgm0?clo03oool0oOgm0P3oool01P2m_Kd00000
00L71`000000PX:20?clo7h0oooo00100?ooo`0A0?Shn03oool0ookm0?ckm`3oo?P0oogm0?oio`3o
nol0ooco0?kmn@3ooo/0E5EG0?7bo`3ko_l0nooo0?Omn@3nool07`3oool01P3moOd0o_kn0?ooo`3o
ool0o_kn0?gmo@<0oooo00H0o?cl07EeM@000000000000@4103EeMD20?clo0090?Win@3oool0oooo
0?clo03moOd0oooo0?knoP3oool0o?cl00<0oooo00X0o?cl0?ooo`3_knl0@T9203Xj>P3YjNT0oooo
0?[jnP3kno/0o_kn703oool01@3fm_H0no_k0?knoP1KFe/0n?Sh0300oooo00<0o?cl0?ooo`3oool0
0P3oool20?gmo@030?ooo`3WinL061PH0080000000<0@d=30?Shn03oool0OP3oool00400oooo0140
ooko0?ooo`3jnOD0oooh0=OCc`2IU9H0Z:6`0=WBh@3ooOl0`;nj0:FVX00B4aL0V9R^0?3eo`3anO/0
nook0?koo@0O0?ooo`030?_kn`3no_h0oooo0080oooo00<0n_[j0?ooo`3fm_H00P3oool0303clo<0
>CTi00410@0000008B4Q0?Cdm03oool0o?cl0?Ogm`3oool0o_kn0?_kn`@0oooo00X0no_k0?ooo`3o
ool0oooo0;fm_@0I6AT0P8200?knoP3oool0nOWi0P3oool00`3no_h0oOgm0?ooo`0H0?ooo`060?[j
nP3no_h0oooo0?ooo`3lo?`00@41=P3oool0103moOd0oooo0?KfmP16ATH20000000301<C4`3/k>`0
oooo0080o_knO@3oool003l0oooo0180ooko0?omo`3knO`0ookj0?oomP3onoD0/jb_01486`3mm?l0
oOSj0;fl]`1WJ680aLS<07EfT03ioOl0moko0?Kon03noodQ0?ooo`030?gmo@3kno/0oOgm0080oooo
00X0o_kn0?gmo@3oool0oooo0=CDe00@41001PH60000001TI6@0m_Kf0P3oool0103no_h0oooo0?gm
o@3oool20?_kn`0>0?knoP3oool0oooo0?ooo`1nOWh071`L0;Ng]`3moOd0no_k0?[jnP3oool0no_k
0?knoP3moOdI0?ooo`080?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/a0?ooo`070?clo03m
oOd0o_kn0?ooo`3no_h0nOWi08n?S`020000000600H61P2j^[X0o_kn0?Win@3oool0o?clO@3oool0
03l0oooo0180ooko0?glo`3ooOl0ooO_0?oml`3bk^/0no[o02<N;P3Xi?80ooko0?onn@30_kX0VIZN
06YaR@3`mol0nooo0?konP3ooodO0?ooo`<0o_kn00@0oOgm0?ooo`3no_h0n?Sh0P3oool03@3moOd0
o?cl0?ooo`2RXZ80000000@410000000YjNW0?[jnP3oool0n_[j0?ooo`3kno/01@3oool0103[jn/0
AdM703Xj>P3Vi^H20?ooo`070?knoP3lo?`0no_k0?ooo`3lo?`0oooo0?gmo@0H0?ooo`80ooom0P3o
ool20?kmo`0300400`3oool0oooo00@0ooom0`3oool20?koo@80ooko0P3nool20?ono@<0ooko0P3o
ood00`3nool0oooo0?ooo`0I0?ooo`0>0?_kn`3oool0o_kn0?knoP3hn?P0c<c<00820P030`<00000
07UiN@3oool0oOgm0?ooo`3kno]H0?ooo`050?koo`3kool0o?oo0?ono`3ooOl00P3oool20?ono@05
0?omo`3oo_l0o_ok0?con`3nool00`3oo_lE0?ooo`00?`3oool20?ono`0@0?ohn@3on>d0ZiB:0081
1P1NJ740@dYB0;2e^@3joOl0oooo0?onn02d]KD000@C0>3ao`3oo_l0oogf0?omoBL0oooo00H0o_kn
0?gmo@3oool0oooo0?Win@1PH60200000005018B4P3IfMT0oooo0?clo03moOd00P3oool0203lo?`0
oooo0?ooo`30`<008b<S07MgM`3oool0no_k803oool02`3oood0o_kj0?oon`3moO/0oOco0?omo`3o
o?l0YjBZ0?ono`3oo_d0o_gi0080oooj01@0o?_g0?omo03oo_l0nO[j0?_onP3looX0ooco0?oho`3i
o?l0o?oo0?oln03on_P0oo_o0?olo`3ooOd0oooj0?kon`3lood0o_oo0?onoaP0oooo00/0oOgm0?oo
o`3oool0no_k0?clo03`l?005aLG00<30`000000@d=30?KfmP020?ooo`030?knoP3kno/0oooo0400
oooo00X0oOgm0?ooo`3oool0oOgm0?ooo`3jn_X0oooo0?knoP3oool0o?cl0`3oool00`3inOT0oooo
0?ooo`070?ooo`0?0?_oo`3cool0mooo0?kin@3onod0noWl0?ooo`3oo_X0oo_h0?ojo`3onol0mOo`
0?Som03kool0o?co0080o_ko00<0ooko0?ooo`3oool04P3oool003l0oooo0180ooko0?[go@3oo?/0
oo7Q03dW6@2Z[;H0h>cj00072@1OIF40n?oo0?_oo`3ooOd0oOgm0::e^`2Y_<80o_Wi0?oin03ooOdZ
0?ooo`040?Win@3oool0l_;b02TY:@80000000<0>c/k0?Cdm03oool00P3oool0203kno/0oooo0?Wi
n@2>SXh06ATI0:ZZZP3inOT0o_kn8@3oool0803oood0n__e0?oonP3jn_P0ooko0?_ho`3oo?l0oogo
0?_io03oo_d0oook0?[im03hmo80oook0?ono@3mo?l0o_oo0?Kom@3io_L0oo_o0?ojo`3lo?l0noon
0?oon03ooOX0oo[o0?oko`3ooO/0oooh0?conP3lood0o_oo0P3oo_lH0?ooo`80oOgm00X0oooo0?[j
nP1:BTX02`/;0000000E5AD0h^;R0?ooo`3moOd0n_[j0P3oool00`3kno/0oooo0?ooo`110?ooo`04
0?[jnP3oool0oooo0?Gem@80oooo00@0o_kn0?gmo@3moOd0n_[j0P3oool00`3jn_X0oooo0?ooo`05
0?ooo`0B0?_oo`3bool0l_on0?olo@3onod0oogo0?OhnP3oo_X0oo[g0?kamP3onod0l?SY0?GomP3f
ool0nooo0?kno`3noOl0ooko503oool003l0oooo0180ooko0?oko`3ono/0oogT07I]F`1mP940n?go
0;^g]00C4`L0kO_i0?Goo`3glol0ooco0?Woo`3eooP0oooo0?omo`3oo_lW0?ooo`030?knoP3moOd0
n?Sh0080oooo0100o_kn0<G5a@0;2`/0000000D51@1aLG40oooo0?clo03moOd0o?cl0>o_k`1GEeL0
<30`0>CTi03oool0no_k0P3oool00`3jn_X0oooo0?ooo`0M0?ooo`050?ooo@3ooo/0oook0?ooo`3c
l_D00P3oo_l0103cl?H0ooko0?ono@3lnoL20?oonP0<0?oon`3lo?`0m_Gj0?koo`3jooP0o_oj0?oh
o@3omol0oogo0?Wjo03hnO40oOcg0P3on_l0103ooOd0oooh0?conP3lood30?onoaL0oooo00D0o?cl
0?ooo`3moOd0oooo09JFUP020000000300<30`2d];@0n?Sh0080oooo00@0nOWi0?ooo`3moOd0oOgm
@@3oool03P3lo?`0oooo0?gmo@3oool0no_k0?ooo`3moOd0l?3`0>GUi@3oool0no_k0?ooo`3kno/0
o_kn203oool04@3lool0mooo0?Woo@3on_/0ooKh0?omo`3lool0nOoo0?koo@3oo?<0OVmW05A@C@27
S900gnSe0>oho`3lool0no_k01D0oooo000o0?ooo`0B0?omo`3onol0o_Cb0?ooj`2l_:l04QDT0?[h
o`3on?808Q/@0<OIf03/o_l0oOco0?olo`3jnoD0m_W`0?koo`3bloL0ooko:03oool0203inOT0oooo
0?ooo`3inOT0oooo0?clo02?Shl00P820P0000002P2i^KT0o_kn0?ooo`3Bd]807alO06a/K03emOD0
oOgm0?Shn03oool20?gmoB40oooo01h0o?cj0?ooo@3jn_X0ooko0?kmo`3oo_l0noWl0?ono`3noOT0
oook0?oonP3jn_H0oOgk0?ooo`3oo_l0o?go0?konP3jnoD0ooWl0?olo`3onol0ooko0?conP3noo/0
oo[o0?oio`3oo_d0o?oj0?con`3nood30?onoaP0oooo00h0oOgm0?ooo`30`<000`<300@410061PH0
KVi^0?ooo`3lo?`0oooo0?gmo@3oool0nOWi0?knoT40oooo00<0oOgm0?knoP3oool00P3no_h01@3l
o?`0oooo0?clo01GEeL0SHf=0080oooo00@0oOgm0?ooo`3oool0o_kn1`3oool04P3nool0mogi0?Sj
m`3onod0oock0<g<b02EVi/0U9fZ0=7Hh03oo_@0ooc_0?ojn03Zh^/0Hg:30?3oo`3jo_l0ookk0?on
oA@0oooo000o0?ooo`0B0?omo@3on_P0oogh0?[lm`3jooh0CeIL08J3R@3on_<0GE9<096RZP3Yool0
o?oo0?Wcl@3ooO/0oogm0?coo`3kool0o_oo:@3oool00`3inOT0oooo0?knoP020?ooo`090?_kn`15
ADD010@400820P0F5QH0i^KV09ZJVP051@D0[jn_00L0oooo00<0o?cl0?ooo`3oool0803oool0403o
o_l0m_Gh0?_jo@3noOl0Fe]K0?ShmP3lo?P0oooj0?Shm03mooX0o_oo0?Wjo03jn_l0o_oo0?knnP3k
n_D20?olo`040?ogo`3mn_l0lOcc0?Won`80oo[o00@0o_om0?_onP3noo/0ooom0`3oo_lG0?ooo`04
0?_kn`3oool0j>SX02LW9`80000000X0>SXj0?[jnP3gmoL0oooo0?gmo@3no_h0oOgm0?knoP3oool0
oOgm@@3oool00`3no_h0nOWi0?ooo`020?gmo@080?ooo`3YjNT0410@0>k^kP3oool0o_kn0?ooo`3i
nOT:0?ooo`0A0?ono`3nmoX0oo_o0?kfl@3non`0[kJ/00H=9`3bn?l0nocn0?oik@3okN<0^ZJU04=K
LP3Tool0o_oo0?okmP3ooOd0503oool003l0oooo0180oook0?onmP3hlnd0o?oo0?Soo`3kool0M7=_
07MTF`1TEU<0JWJ40?7oo`3ho?/0ookh0?omn`3oo?h0loWi0?Woo`3noolX0?ooo`0>0?Cdm03oool0
oOgm0?gmo@3oool0o_kn0?ooo`3`l?005QHF000000010@406QXJ02PX:03Vi^H20?knoP80oooo00D0
nOWi0?_kn`3oool0oooo0?knoP0Q0?ooo`0G0?[jnP3noOl0ooko0?ono`3lo?`00@400?oon`3oooX0
o_oi0?gonP3nood0nocl0?gno`3no_l0oOco0?ooo@3oo?T0oocm0?oioP3onol0o_ko0?KonP3ioo/0
0P3onol0103kool0nOok0?kon`3oo_d30?onoaP0oooo00H0no_k05]KF`0000000000014A4@3Lg=`2
0?ooo`070?KfmP3no_h0oooo0?clo03oool0o_kn0?clo0100?ooo`0:0?Gem@3oool0oooo0?clo03o
ool0:RXZ0?gmo@1eMGD0Kfm_0?_kn`80oooo00@0oOgm0?ooo`3oool0nOWi1`3oool04P3oo_l0ooSk
0?oko@3on?L0oogd0?3dh@3eooL05Qdi0>;Xo`3kool0oogf0?GEaP1>>C@0SjBm0>3mo`3nool0oo_d
0?onna@0oooo000o0?ooo`040?oon`3oooH0oooj0?OjoP80nooo00`0oook0?ogk`3oo?P0nOoo0?Cm
o`3oo_l0ookh0?_elP3ooo/0o?oo0?_oo`3noolW0?ooo`030?clo03oool0o_kn00<0oooo00D0moOg
0?ooo`3oool0^k^k00H61P020000000508J6QP3hn?P0oooo0?ooo`3kno/00`3oool00`3kno/0o_kn
0?knoP0P0?ooo`080?Whn`3oo_l0ooko0?ono`3jn_X0oooo0001003jo?L20?cnn00>0?kon`3gnOH0
oOkn0?koo`3gm_`0ooko0?clo03ooOd0oo[j0?ojo`3onol0n?co0?Ooo@3go_L20?oko`040?Woo`3h
oo/0oook0?omo@<0ooko5`3oool02@3no_h0U9BD000000030`<000000;>c/`3oool0o?cl0?_kn`02
0?ooo`030?Win@3oool0nOWi04<0oooo00h0m_Kf0?Shn03oool0oOgm00X:2P3emOD0S8b<0?3`l03o
ool0n_[j0?Gem@3oool0nOWi0?clo0P0oooo0180ooko0?oloP3oo?X0ooCW0:FGRP031`H0FFI^03i6
F02`]LH0o_co0?oim`3olNH0oogk024ZA`3PkOl0m_Gh0?onm03ooo/D0?ooo`00?`3oool04P3oood0
o?kh0?konP3jnod0o_oo0?Ojo`3oool0oocd0?omn03lo_l0noko0?oio`3ooO/0oooj0?_mn03lool0
n_go0?koobL0oooo00H0o?cl0?ooo`3jn_X0oOgm0?ooo`3hn?P20?ooo`0=0?gmo@2LW9`020P80000
00010@401@D50<g=c@3moOd0oooo0?[jnP3kno/0oooo0?knoP0S0?ooo`<0ooko01/0oooo0?knoP3n
o_`000800?kon`3mooX0o_ok0?koo@3moo`0jnc/05YIG00000@0T8nD0?cmo`3Ed=807P/<01421`2l
_/X0mooo0?;ln@3lood0ooco0?omo`3gool0moom0?oon`3ooOd00`3oo_lG0?ooo`070<c<c00:2PX0
00000000001^KVh0o?cl0?_kn`020?ooo`030?_kn`3oool0oOgm0080oooo00<0o?cl0?gmo@3oool0
@P3oool01@3moOd0oooo00H61P3emOD0oooo0080oOgm0P3oool0103moOd0oooo0?clo03moOd80?oo
o`0A0?ono`3onoH0oo_T03LU5P2TZ[P0hNgo00002P1QH6D0oogo0?ono`3LfmH0KFa_00P98`3/kOl0
o_go0?olm@3oo_d0503oool003l0oooo0180o_oo0?_oo03lood0no_g0?ooo@3inOl0o_oo0?onn03l
mo40ooko0?cjo`3on?l0oogo0?konP3looX0oOko0?koo`3oo_l20?gmo@<0oooo00<0o_kn0?ooo`3n
o_h00P3no_h20?ooo`030?knoP3oool0oooo00D0oooo00<0o?cl0?gmo@3oool02@3oool00`3kno/0
oooo0?ooo`020?ooo`030?gmo@3oool0n_[j0080oooo00d0o_kn0?_kn`3oool0nOWi0??cl`1NGUh0
:2PX0=GEe@0i>CT0000000D51@0T92@0lO7a00D0oooo00<0n_[j0?gmo@3oool0803oool01`3noOl0
ooko0?glo`3moOd0o_oo0?goo02UYj800P3noo/0603moo`0oOgk0?[jn03no_h0m_Ce00800`3Pgn80
o?oo0?cgn@3D^kh07PX?0?Clo`3bool0mogm0?ono@3ooOl0ooko0?Goo`3good0ookk0?olo@3oo_l0
o_oo0?ono`l0oooo00<0oOgm0?ooo`3inOT00`3oool02@3lo?`0lo?c02@T90020P80000003Xj>P3f
m_H0oooo0?_kn`1:0?ooo`0=0?[jnP3oool0oooo0?knoP0@4100kNg]0?ooo`3no_h0no_k0?ooo`3n
o_h0oooo0?_kn`030?knoP@0oooo00l0oOgm0?knoP3oo_l0o_oo0?olm03on]d0PFiK07AkU@3do_l0
`[Fj01X<1`3_n?/0m?oo0?_oo`3hmod00P3noOl00`3onol0oocl0?ono`0D0?ooo`00?`3oool05@3n
ool0o?oo0?[no@3ooo/0n?Ke0?koo`3noOl0o?Og0?onn`3oo_l0oogo0?olo`3nnO/0nO_h0?[nn`3n
ool0o_go0=kNgP3QhN40h^;R0=_Kf`020=;BdP030=kNgP3/k>`0oooo00L0oooo00L0oOgm0?[jnP3o
ool0n_[j0?clo03oool0o_kn00`0oooo00<0nOWi0?ooo`3oool00P3lo?`0103moOd0oooo0?gmo@3n
o_h20?ooo`070=cLg00[:b/0GEeM0?Shn03oool0f][J01HF5P020000000505iNGP3kno/0o_kn0?oo
o`3gmoL00P3oool00`3moOd0oooo0?ooo`0O0?ooo`080?[io03oo_l0n_[j0?ooo@3inoP0oOol0?ko
n`3inoP20?[ln@0F0?ooo@3oo_d0ookm0?ojnP1<AdL0UYJF0?Wno`3oo_l0on_/01L21@38e>00jOco
0?coo`3ooOd0oogo0?koo`3gool0n?oo0?omo@3oo?d0ooko0?kooa00oooo00D0oOgm0?_kn`3oool0
oooo0?Win@020?ooo`0905YJFP051@D0000000l?3`3Jf]X0oooo0?knoP3oool0no_k04P0oooo00<0
oOgm0?ooo`3jn_X00P3oool00`0820P0mOGe0?ooo`020?ooo`030?clo03oool0oooo00D0oooo00<0
o_kn0?gmo@3no_h00P3oool03`3no_h0o_oo0?olm03onMd0bk^Y00/?:03bmOl0ooWk02HG4039e]`0
kOoo0?Gno`3nool0m_Ok0?_ho`020?olo`030?ono`3oool0oooo0180oooo00100?ooo`040?cmo@3m
o_h0o_go0?ooo`80ooom01L0oo_o0?cfo@3im_`0ooko0?oonP3Ui>00/k:h07IfOP0h>SL03Q0;024Q
7`0N7Qh07AdM024Q8@0Y:BT0:RXZ024Q8@0E5AD0:2PX04e=C@27QhL0`L710>_[j`020?ooo`040?cl
o03oool0oooo0?gmo@80oooo00<0no_k0?clo03oool0203oool0103kno/0oOgm0?Gem@3no_h30?oo
o`0B0?gmo@3oool0no_k0?ooo`3kno/0oOgm0:2PX00E5AD0UYJF0?knoP3oool0moOg0?ooo`2TY:@0
000000L71`000000XZ:R0P3oool01@3fm_H0oooo0?clo03oool0o_kn0200oooo0P3oo_l06P3nool0
l_Ca0?koo@3noo/0lO?`0?koo@3nool0nocl0?knoP3mnoX0ookk0?omnP2TWiT0@d8m0?7ho03mo?l0
ooKd065>C`28UJ<0l?oo0?kno`3mm_T0oogo0?koo`3hool0nOoo0P3ooOd20?onoa00oooo00<0oOgm
0?ooo`3oool00P3oool01`3moOd0Vi^K00000000000020P80:RXZ03gmoL00P3oool00`3hn?P0oooo
0?ooo`180?ooo`080?[jnP3oool0oooo0?Win@0@4100JVYZ0?;blP3no_h30?ooo`040??cl`3moOd0
oooo0?_kn`<0oooo01H0o_kn0?ooo`3oool0oooo0?_kn`3knOP0oooh0?olj@3ooo<0HUYW08AhRP3o
n_/0FU5B09>O[@3aool0logj0?con03inoP0ooko0?oko`3onOl0ooko503oool00400oooo0140no_i
0?ooo`3oo_l0moKi0?oonP3ooo/0oO[o0?olo`3>cM00K6aX01HG3@0D5@l0AdE@08>1SP2n`;d0k>oV
0?kno0060?ooo`0A0?Win@3@d=00ZJVY07=cL`0i>CT03@d=01dM7@1nOWh0hn?S0?Shn03oool0o_kn
0?ooo`3moOd0no_k0?ooo`3lo?`02@3oool01@3moOd0oooo0?ooo`3gmoL0m_Kf0080oooo00T0n_[j
0?ooo`3oool0o?cl05mOG`0X:2P0c<c<0?ooo`3moOd00`3oool01`3lo?`0IFEU00<30`0000003@d=
0=[JfP3kno/00P3oool20?gmoB40oooo00L0o?_n0?ooo`3inoP0o_om0?gonP3noo/0nO_h0080o_oo
0140nOSk0?ono`3ooOd0mNo/0?onmP3dk>40104006E/L01NHFD0OF]W01h@3`0`?4X0k_oo0?gmo`3o
o?l0oogo0?ooo`020?_oo`040?ono`3ooOd0ooko0?onoa80oooo00T0n?Sh0?knoP3oool0d=3@00h>
3P020P800000069RHP3moOd00P3oool00`3lo?`0no_k0?ooo`180?ooo`0<0?[jnP3kno/0oooo0?oo
o`3Kfm/0000008:2PP0E5AD0QHF50?7al@3oool0no_k0P3oool00`3jn_X0oooo0?clo0050?ooo`0C
0?knoP3oood0ookj0?onm`3loO<0oooj0?oeo@2>PHX0K61P05aGF@1cO8L0k?[o0?Woo@3looP0oOoj
0?ooo`3on_l0ooco0?ono`0D0?ooo`00@03oool20?ono`0?0?Ccn03oo_l0oooj0?Gel@2/Zk40?3]1
020Q8@1oPG`0h^GJ0?kon`3ooOl0n_So0?cnn`3nooX0o?cj0080oooo00<0no_k0?KfmP3jn_X00P3o
ool00`3no_h0oooo0?ooo`020?ooo`0:0=WIf@1cLg<03`l?04A4A02JVYX0n_[j0?ooo`3hn?P0oooo
0?knoPT0oooo00D0o_kn0?Ogm`3oool0oOgm0?_kn`020?ooo`0I0?_kn`3oool0n_[j0=gMg@0X:2P0
FEUI0?;blP3oool0mOGe0?ooo`3moOd0n_[j0?gmo@3oool0l?3`02DU9@051@D00000034a<@3moOd0
o?cl0?ooo`3no_h0oooo0?[jnP0P0?ooo`80o_oo00H0o_om0?Ggm03hoOL0nool05YKF`3gn?X20?on
o`0D0?ojoP3ooO/0oogh0?onl`3hkmh07a/?0:bc]`3fnol0ooW_0=O?bP000A@0inko0?Oio`3oo_l0
oogm0?omo`3oo_l0o_oo0?ooo`3oood20?onoa40oooo00`0lo?c0?ooo`3oool0l?3`02DU9@000000
0P82034a<@3kno/0o?cl0?ooo`3moOd20?ooo`030?clo03oool0oooo04T0oooo00<0o_kn07]kN`0B
4Q800P3IfMT02`1OGel04A4A08b<S03`l?00nOWi0?ooo`3kno/0oooo0?gmo@3kno/0o?cl0080oooo
01@0oOgm0?ooo`3ooo/0m?KY0?oom03ooOd0oO[o0?clo`3ooOl0oock0?omnP3iool0mooo0?KkoP3n
ool0oOgk0?kno03oo_l0o_go0?onoa@0oooo00100?ooo`0A0?cjn`3nnO/0ooco0>o]l01gMW8071`H
04A7B`2VZJh0nocl0?kon`3nooP0o?ok0?kno`3ooOl0ooom0?oonP3oood01P3oool00`3kno/0oooo
0?knoP030?ooo`0;0?clo03kno/0no_k0:NWY`1DE5@08b<S0:FUY@3oool0nOWi0?ooo`3lo?`02`3o
ool0103moOd0oooo0?ooo`3jn_X20?ooo`040:VYZ@0:2PX0Vi^K0?ooo`80no_k00D0oooo0?gmo@3o
ool0oooo0?gmo@020?ooo`050<[:bP061PH0000000L71`1YJFT00P3oool00`3kno/0oooo0?knoP0P
0?ooo`0N0?koo`3inoP0oOol0?koo@3loo/0nOgj00010`3nool0o_go0?omo`3onOh0ooOe0?olm03o
n>X0ookX09nIR@1DFEd0nOoo0?oom03lno@0:BLl0:NW`@3kool0o_oo0?omo@3oo?d0ooco0?ono`3n
ool0o_om0P3oo_l@0?ooo`050?Win@3oool0moOg0?_kn`1TI6@00P030`<010061PH0eMGE0?ooo`3k
no/20?ooo`030?KfmP3moOd0oooo04T0oooo00l0o?cl0?ooo`3clo<0<30`01TI6@3Ti>@0oooo0?kn
oP3EeMD0F5QH01lO7`2:RXX0jNWY0?ooo`3jn_X00P3oool0203lo?`0o_kn0?ooo`3oool0o_kn0?oo
n`3ooo@0moS^0P3ooOl03@3lool0n?_o0?[im@3nno@0o?oj0?Gin03oo_l0oogo0?kon`3inoH0n_ko
0?koo`3oo_l0503oool00400oooo0140ookm0?cgn@37_LH09AhU06YYI@3Ff=80l_[j0?Woo`3lo?`0
oook0?konP3ioOX0n?go0?coo`3oo_d0no[f0?omo0030?knoP030?clo03kno/0oOgm00@0oooo0P3m
oOd30?ooo`080?gmo@3oool0^;Rh038b<P0d=3@0^k^k0?ooo`3moOd80?ooo`040?Shn03oool0oOgm
0?ooo`80no_k00l0oooo0>o_k`1YJFT07alO0=KFeP3no_h0oOgm0?ooo`3jn_X0oOgm0?clo03oool0
o?cl0?ooo`3kno/00P3oool01@2>SXh01PH6000000061PH0/K6a00<0oooo00<0oOgm0?ooo`3oool0
7P3oool08@3hn_L0o_om0?koo@3noo/0mo_h0?coo@000080n__o0?ono`3hmO`0ooco0?omn`3omnl0
oog/0?odfP1aJUP000040:Vb]`3goo80hNSN02HN=@0B2bX0^l7<0?Woo`3oo?d0oo_m0?oko`3ooOl0
nooo0?_oo@3oo_l0oogo0?ono`0@0?ooo`040?Shn03moOd0ZJVY00410@80000000D0XZ:R0?ooo`3o
ool0o_kn0?clo0020?ooo`030?Win@3oool0oooo04L0oooo00<0oOgm0?ooo`3jn_X00P3oool00`0P
8200f][J0?knoP030?ooo`060<_;b`1DE5@07QhN08>3P`3moOd0nOWi0`3oool05@3no_h0oooo0?oo
o`3moO/0oook0?_jm@3nooX0nogj0?GinP3kool0nOom0?con`3ooOT0oocm0?oko`3hloL0o?of0?Wo
mP3io_l0o?oo0?koo`0D0?ooo`00@03oool04`3aknh0I5mQ02@J8`2l]K`0oook0?kon`3hool0nooo
0?ooo`3ooO`0oOoj0?coo@3kool0noko0?klo@3ooOd0ooko0?gmo@3no_h00P3oool0103no_h0oOgm
0?ooo`3no_h50?ooo`0:0?knoP3lo?`0oooo0?Win@3kno/0oooo09nOW`0T92@0Kfm_0?Shn0L0oooo
0`3nool03P3hm_L0ookm0?clnP3nood0f][J03Hf=P1ADU80m?Ge0?kln`3oo_d0noWj0?7_l03oo_l0
o?go103oool02`3moOd0oooo0?clo03oool0AdM700T92@0000006QXJ0>KViP3no_h0oOgm0240oooo
103nood00`3moo`0oOkn00010`020?ono`80oogo00h0ooWg0?ommP3on>`0ooSS0=WCa@3LgN40cmKJ
0?3lkP3XknL0f];U0=gEk03FgND0n?oo0?omo@80oo_o00H0oogo0?_oo`3kool0ooko0?omo`3oo_l@
0?ooo`080?clo03IfMT03@d=000000051@D0IfMW0?_kn`3lo?`20?ooo`040?_kn`3moOd0oooo0?kn
oQ40oooo00@0o_oo0?ono`3oo_l0ooko0P3oool01@3nool0oooo0?ono@3oo_d0oooo00<0o_oo00<0
ooko0?ono@3oo_d0103oool00`3nool0ooko0?ooo`0P0?ooo`070?gmo@3oool0oooo0?[jnP3no_h0
8R8R0>3Ph0030?knoP080?ooo`3moOd0oooo0=CDe01>CTh0<c<c0=_Kf`3dm?@20?ooo`0E0?_kn`3o
ool0oooo0?ooo`3mnoX0oook0?konP3loo/0o_oo0?_oo`3do_/0noom0?omnP3on_`0oo_o0?oloP3l
ooH0n?og0?_oo`3ko_l0o_oo01@0oooo000B0?ooo`030?[jnP3oool0nOWi0080oooo00D0moOg0?oo
o`3lo?`0oooo0?_kn`020?ooo`030??cl`3oool0oooo01T0oooo00`0no_k0?ooo`3oool0o_kn0?oo
o`2i^KT05aLG07EcM03`k_40ooko0?ShmP3oood20?gnoP80oooo00H0ooom0?koo`3nool0o_oo0?oo
o`3oo_lA0?ooo`0<0?knoP3lo?`0o?cl0?ooo`3lo?`0AdM703@d=03Hf=P0oooo0?knoP0N7Qh0fMWI
0P3oool02@3lool0nOoo0?Smo`3oo?l0oo[h0?konP2W[:D0518A09:@T@020?_oo`070?oon03gknX0
:B0Q07YeN@2>SY@0o?oo0?gno`070?ooo`050>[ZjP0N7Qh00@410000001>CTh00P3kno/02@3oool0
o_kn0?ooo`3kno/0oooo0?clo03no_h0oooo0?[jnP0H0?ooo`070?knoP3oool0oOgm0?gmo@3oool0
o_kn0:JVYP040?ono`090?ono@3oo_/0ookj0?oon03oooX0ooko0?koo`3loo/0o_om0080oogo0P3n
ool0103oo_l0oogo0?ono`3oo_l20?koo`030?ooo`3oo_l0oooo00T0oooo00<0o?cl0?[jnP3oool0
0P3oool0103lo?`0oooo0>g]k@0_;bl20000000302XZ:P3emOD0oooo01L0oooo01T0o_oo0?coo`3n
ool0oogo0?omo@3oood0o_oo0?coo`3nool0ookk0?onnP3oood0o?oo0?Woo`3kool0oogm0?omnP3o
o_/0ookm0?[jnP3oool0o_oo0?Oko03loOl0o_oo0080oooo0`3oo_d20?ooo`040?koo`3oool0oooo
0?_kn`80oooo00<0oOgm0?ooo`3no_h0103oool00`3no_h0oOgm0?ooo`0;0?ooo`0P0?knoP3oool0
o_kn02LW9`3MgMd0o_kn0?clo03oool0o?cl0?ooo`3kno/0oooo0?[jnP2OWil06ATI07QhN03oool0
no_k0?knoP3oool0n_[j0?ooo`3jn_X0ooom0?[jn03nood0oooo0?WjnP3lool0o_oo0?ono@3ooOl2
0?ono`040?kon`3nood0o_oo0?kooaD0oooo000A0?ooo`060?gmo@3oool0oooo0?ooo`3hn?P0moOg
1@3oool00`3inOT0oooo0?ooo`0I0?ooo`0:0?gmo@3lo?`0oooo0?ooo`3hn?P0oooo075aL@0L71`0
_[jn0?;blP80oOgm00<0oooo0?_kn`3oool06@3oool0103inOT0oooo0?ooo`3oool20?_kn`0K0?oo
o`2IVIT05aLG0:^[Z`3lo?`0H61P09bLW03no_h0oooo0?_oo`3gool0koCh0?olo`3onOL0JFaS01/P
6@3?cL`0ooko0?_oo`3ioOX0nOK_0?omn03oo?/0ooco0;Fe_@2SYZd0oOko00P0oooo00L0`l?30000
000820P0000008>3P`3oool0m_Kf00<0oooo00@0m_Kf0?ooo`3oool0mOGe6@3oool0203jn_X0oooo
0?[jnP3oool0n_[j0?knoP3oool0n_[j8@3oool03`3kno/0oooo0?ooo`3emOD0m_Kf0?ooo`3kno/0
o_kn06i^KP0410@0000000T92@3De=@0oooo0?clo00G0?ooo`0K0?koo`3lool0o_ko0?olo`3ooO/0
ookm0?koo`3lool0o_oo0?onnP3oooP0ooom0?_oo`3hool0nOoo0?omn`3ooOP0oo_h0?oon`3no?d0
l_?c0?koo`3joOl0o?oo0?WmoP3oo_l0oooo00<0ookm00@0ooom0?ono`3nool0nOWi0`3oool01@3k
no/0oooo0?gmo@3kno/0o?cl0080oOgm00D0o_kn0?ooo`3oool0oooo0?Shn0090?ooo`060?knoP2a
/K40d=3@0?ooo`2i^KT0i^KV0`3oool02P3gmoL0oooo0?knoP3kno/0oooo0?_kn`3Ti>@0BTY:02l_
;`3Cdm<20?ooo`070?_kn`3jn_X0oooo0?clo03oool0o_kn0?KfmP020?ooo`030?clo03oool0oooo
01/0oooo000A0?ooo`040?clo03inOT0no_k0?Ogm`80oooo00H0o_kn0?_kn`3no_h0nOWi0?ooo`3m
oOd20?ooo`030?gmo@3oool0oooo01P0oooo00T0n?Sh0?ooo`3oool0J6QX03@d=03kno/0o_kn0?oo
o`3moOd00P3oool00`3hn?P0oooo0?Shn00I0?ooo`090?[jnP3oool0no_k0?ooo`3moOd0oooo0?cl
o03AdM405ADE0080WinO01D0FEUI0?ooo`3oool0o?go0?Woo`3kool0iN3P03Pb<019BT@0mOOa0?ko
o@3lo?`0ookm0?oon`3nood0moOe0?ohnP3il?<0LW9j09NKXP3mo_l0203oool01P3kno/0P8200000
000410@000000<[:bP80oooo00H0nOWi0?clo03oool0no_k0?ooo`3moOdL0?ooo`040??cl`3oool0
oooo0?;blR80oooo00<0oOgm0?Shn03oool00P3oool00`3hn?P0oooo0::RXP03000000030:6QX@3m
oOd0n?Sh01P0oooo00T0o_oo0?coo`3nool0oogm0?omn`3oo_d0o_oo0?coo`3nool00P3oo_X0403o
ood0o?oo0?Woo`3kool0ookk0?omn03ooOX0m_Ga0?ono`3nool0o?go0?coo`3hnol0nOgn0?ono`3o
ool30?ono@030?ooo@3oo_l0o_oo00@0oooo00<0no_k0?clo03oool01@3oool00`3lo?`0n?Sh0?gm
o@090?ooo`040?Win@3]kNd02PX:0?Gem@80oooo00D0o_kn0?ooo`3lo?`0oooo0?gmo@020?ooo`09
0?Win@3lo?`0oooo0?[jnP3oool0VIVI014A4@1lO7`0no_k0080oooo00<0o_kn0?ooo`3jn_X00`3o
ool00`3kno/0oooo0?ooo`0L0?ooo`005@3oool00`3moOd0n_[j0?ooo`020?ooo`050?gmo@3lo?`0
oooo0?knoP3inOT06@3oool03P3moOd0oooo0?ooo`3jn_X0L71`03Ph>03bl_80mOGe0?ooo`3emOD0
o_kn0?ooo`3kno/0o_kn6`3oool01P3no_h0oooo0?ooo`3kno/0oooo0?Ogm`80oooo0140gmoO01hN
7P23Ph<061PH0?clo03kno/0o_oo0?Gho02^/[<05aLE08^:QP3ooo/0mOGa0?Kjm`3noo/0oocg0?Oa
kP020?_oo`050?olo@37_[l05QHN0=?GgP3mo_l0203oool0203moOd0n_[j0451@@0000000`<3020P
803/k>`0o?cl0`3oool0103fm_H0oooo0?ooo`3moOdH0?ooo`070?clo03oool0n_[j0?ooo`3no_h0
oooo0?[jnP0Q0?ooo`030?Shn03oool0oooo0080oooo00P0n_[j0?ooo`3De=@03`l?00410@0;2`/0
DU9B0?clo080oooo00<0o?cl0?ooo`3oool05@3oool01`3nool0o?oo0?koo`3oo_/0oogj0?ono@3n
ool00P3lool03P3ooo/0ookk0?ooo@3nool0nooo0?coo`3oo_d0oogj0?_gm03ooo/0o_cm0?[kn`3m
o_l0n_go0P3lool00`3oo_l0oooo0?ono@020?ono@0:0?ooo@3oo_l0o_oo0?ooo`3jn_X0oOgm0?oo
o`3moOd0oooo0?;blP80oooo0P3jn_X30?ooo`030?clo03moOd0oooo00P0oooo00H0L71`07MgM`3o
ool0oooo0?[jnP3oool20?gmo@80oooo00<0n?Sh0?ooo`3oool00P3lo?`0203oool0o_kn0?ooo`3Z
j^X0BTY:02h^;P3Cdm<0no_k0P3oool01P3no_h0m_Kf0?ooo`3fm_H0oooo0?WinAd0oooo000A0?oo
o`80oOgm00@0oooo0?Shn03oool0oooo0`3kno/01@3oool0no_k0?ooo`3oool0oOgm01T0oooo00L0
o_kn0?Shn03oool0Kfm_03@d=03emOD0o?cl00@0oooo00@0moOg0?ooo`3oool0mOGe6@3oool00`3n
o_h0oooo0?ooo`020?ooo`0L0?gmo@3oool0no_k0?knoP3moOd0g=cL01hN7P0K6a/0hN7Q0?ooo`3e
mOD0NWUl028R8P30a<40n_ci0?olo03knOP0noom0?konP3TeLd0200008F?UP3eool0ooWi0?S^k@3h
n?h06alV0?gno`X0oooo00T0g=cL00l?3`00000010@405MGE`3no_h0o?cl0?ooo`3hn?P00`3oool0
0`3no_h0oooo0?ooo`0I0?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P08@3oool0303hn?P0o_kn0?kn
oP3no_h0oooo0?;blP0g=cL0000000820P0P8200n?Sh0?WinAX0oooo00L0o_oo0?coo`3nool0ookj
0?omnP3oo_d0o_oo0080o?oo00@0ooko0?omo@3oo_l0ooko0P3lool0303oo_d0ookk0?onn`3mo?P0
ooko0?Ohn03nool0noko0?coo`3ho?d0ooko0?ooo`<0ookm00T0ooom0?ono`3nool0oOgm0<W9b@2k
^k/0m_Kf0?ooo`3no_h01@3oool20?gmo@80oooo00<0o?cl0?ooo`3oool01P3oool0103hn?P061PH
0>;RhP3jn_X50?ooo`030?[jnP3oool0oooo00@0oooo00T0n?Sh0?ooo`3oool0moOg0?ooo`2WYjL0
3`l?0<71`@3jn_X00`3oool00`3kno/0oooo0?clo00N0?ooo`004@3oool02P3jn_X0oooo0?[jnP3n
o_h0n?Sh01/K6`2^[Zh0oooo0?[jnP3lo?`40?ooo`030?gmo@3oool0oooo01P0oooo00P0IVIV03@d
=03clo<0o?cl0?[jnP3oool0no_k0?knoP@0oooo00<0o_kn0?ooo`3oool0603oool01P3moOd0oooo
0?Win@3oool0o_kn0?KfmP80oooo00/0oOgm0?ooo`3Xj>P0@T9209^KV`3Kfm/0A49304]6B03Xi^D0
noom0?[nn`020?omo`0;0?;kmP3nooP0nNOI028C302P[[L0e^Sd0?omo@37_K/0EeMM04eAF03mo_l0
1`3oool0403jn_X0m_Kf0?ooo`3oool0Zj^[00L71`0000000P8209^KV`3oool0n_[j0?knoP3oool0
o_kn0?ooo`3no_hI0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@418P3oool00`3lo?`0oooo0?oo
o`020?knoP0507=cL`00000010@400@4103?cll00`3oool00`3lo?`0o_kn0?ooo`0F0?ooo`<0o_oo
00@0ookj0?onn03oo_l0o_oo0P3lool03@3oo_l0oogo0?omo`3oo_l0oooo0?koo`3oood0ookm0?ol
n@3kn_H0ooko0?koo`3hnOd00`3lool00`3oo_l0oooo0?ono@020?ono@0>0?ooo@3oo_l0o_oo0>[Z
jP051@D0:BTY02h^;P2=SHd0jn_[0?ooo`3jn_X0oOgm0?_kn`3lo?`30?ooo`030?knoP3oool0oooo
00L0oooo00L0i^KV0=WIf@3no_h0oooo0?clo03oool0n?Sh0080oooo00D0n?Sh0?ooo`3oool0oooo
0?clo0020?[jnP030?ooo`3no_h0m_Kf0080oooo00/0n_[j0<K6aP0A4A40WinO0?ooo`3emOD0oooo
0?Win@3gmoL0oooo0?Shn00M0?ooo`00403oool03P3kno/0oooo0?Shn02b/[80o?cl0?[jnP3?cll0
4a<C0=;BdP3oool0o?cl0?ooo`3jn_X0no_k6`3oool01@2b/[8020P80>o_k`3oool0o_kn00<0oooo
00L0o_kn0?ooo`3oool0n_[j0?Shn03oool0o_kn01P0oooo00D0n_[j0?ooo`3oool0oooo0?gmo@02
0?ooo`0J0?clo03inOT0oooo0?ooo`3hn?P0XJ6Q04U9B@0B4Q80Ph620?oin@3ooOd0noom0?_oo`3o
n_h0oOSl0?Woo`3nooH0oo_Z03HW7`2ibMP0jooo0?ooo`3ooOX0k>_a0?coo`3mo_l80?ooo`0>0?kn
oP3jn_X0oooo0?gmo@1WIfL00`<30000000410@0f=SH0?ooo`3hn?P0no_k0?ooo`3kno/I0?ooo`08
0?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/R0?ooo`090?Win@3jn_X0oooo0:f][@030`<0
0P820000002GUiL0oOgm0080oooo00<0n?Sh0?ooo`3oool05`3oool20?koo`030?koo@3oooP0ookh
0080ooko0P3lool20?ono`0@0?olo`3ooOd0oook0?oon`3nool0oooo0?ono@3ooo/0noWj0?koo`3l
oOl0n_go0?coo`3ho?d0ooko0?ooo`<0ookm00/0ooom0?ono`3nool0Ph>306EUI@3oool0_kno05MG
E`0B4Q80HV9R0<o?c`040?ooo`80oOgm2`3oool00`3jn_X0o?cl0?ooo`020?knoP070?ooo`3moOd0
oooo0?ooo`3moOd0o?cl0?knoP030?ooo`050?clo03oool0oooo0?knoP3inOT00P3oool01@3Ng]h0
92@T07=cL`3oool0oOgm0080oooo00<0o?cl0?ooo`3oool0703oool00140oooo00T0o?cl0?ooo`1e
MGD030`<04M7A`2TY:@0WYjN02TY:@3`l?000P3oool0103moOd0oooo0?gmo@3moOdH0?ooo`080>OW
i`0F5QH0alO70?ooo`3inOT0oOgm0?ooo`3kno/20?ooo`80o?cl0P3oool00`3jn_X0oooo0?ooo`0H
0?ooo`060?knoP3oool0nOWi0?ooo`3no_h0no_k0P3oool20?Shn00F0?ooo`1XJ6P000000<O7a`3o
o_d0ooSi0?onn`3kood0n_on0?klo`3oo_l0loWg0?oomP3onnP0Z9^@059QLP3^ool0nO[j0?onn03o
o_l0oOgo0?kmo`L0oooo00L0no_k0?ooo`3oool0n_[j0?ooo`3clo<0;Bd]0080000000L0:b/[0?7a
l@3oool0oooo0?clo03oool0o?cl01`0oooo0P3no_h00`010@40oooo0?ooo`0O0?ooo`0<0?knoP3o
ool0oooo0?clo03Rh^80410@000000010@40De=C0?gmo@3oool0mOGe0P3oool00`3gmoL0oooo0?oo
o`0G0?ooo`060?koo`3nood0ooof0?oon03ooOl0ooko0P3lool01P3nool0ooko0?olo`3oo?d0ookh
0?oonP80o?oo00X0c/c;01DD4034`/<0n__k0?cmo`3lool0n?_o0?coo`3oo_l0oooo0`3oo_d0403o
ood0ooko0?koo`0L71`0dm?C0?clo03no_h0oooo0>g]k@23Ph<092@T034a<@2HV9P0lo?c0?ooo`3i
nOT20?ooo`030?clo03oool0oooo00H0oooo00<0moOg0?ooo`3no_h00`3oool01@3lo?`0oooo0?_k
n`3oool0oOgm0080oooo00@0oOgm0?knoP3oool0oooo0`3moOd0303oool0oOgm0?knoP3lo?`0jn_[
03`l?01JFUX0kno_0?knoP3oool0o_kn0?clo1d0oooo000A0?ooo`0@0?clo03kno/0oooo0?KfmP2R
XZ80FUYJ0?Win@1UIFD0EEEE0?_kn`3moOd0no_k0?ooo`3jn_X0oooo0?_kn`<0oooo00@0nOWi0?oo
o`3oool0o?cl0P3oool00`3inOT0oooo0?ooo`020?ooo`0<0?knoP3oool0oOgm0?ooo`3no_h0oooo
0?clo03moOd0oooo04];B`1mOGd0no_k0P3oool00`3moOd0no_k0?ooo`0Q0?ooo`0P0?knoP3oool0
n_[j0?ooo`3moOd0oooo0?knoP3oool0o?cl0>WYj@12@T80?clo01LG5`3QhN40ookm0?omo@3oo_/0
o_om0?coo`3nool0ooko0?koo`3oooP0oo_V0>WOd`013Ql0j?So0?cnn`3oo_D0ooko0?kno`3oo_l9
0?ooo`060?_kn`3oool0oooo0?[jnP3Hf=P01`L70P0000000`1`L700oooo0?gmo@020?ooo`030?kn
oP3oool0oooo01H0oooo00L0o_kn0?ooo`3moOd0oOgm0?ooo`3no_h0YZJV01X0oooo00H0o_kn0?oo
o`3lo?`0oooo0?knoP3inOT30?ooo`030?[jnP3oool0=SHf0080000000<08b<S0?Gem@3jn_X00`3o
ool00`3no_h0oooo0?ooo`0H0?ooo`040?koo`3oood0ooof0?oomP80oogo00l0o_ko0?coo`3mo_l0
oO_n0?oko`3onOT0oocc0?oon03fn_l0nOoo0?ooo`2EU900c/c=0?[kn`3nool00P3lool03`3kool0
ooko0?clo03ooO`0ookm0?gknP3oood0ooko0;6b]00b<S80oooo0?_kn`3oool0o_kn0?ooo`020?gm
o@090;Jf]P1BDU805QHF06MWI`3De=@0oooo0?[jnP3oool0oOgm00<0oooo00H0no_k0?ooo`3oool0
j>SX0?[jnP3kno/20?ooo`040?clo03moOd0oooo0?knoQ00oooo00D0n_[j0?ooo`1GEeL0>3Ph0?3`
l0020?ooo`80oOgm0P3oool01P3moOd0o_kn0?ooo`3kno/0oooo0?clo080oooo00@0nOWi0?ooo`3o
ool0m?Cd3P3oool00100oooo00<0oOgm0?ooo`3oool00`3oool02@3no_h0oooo0?[jnP0O7al0Lg=c
03dm?@2EUID0j>SX0?Shn0020?ooo`050?[jnP3lo?`0oooo0?ooo`3inOT00P3oool01P3moOd0o?cl
0?ooo`3jn_X0oooo0?KfmP80oooo00D0o_kn0?clo03kno/0oooo0?Win@020?ooo`0509^KV`0`<300
o?cl0?knoP3jn_X00P3no_hV0?ooo`0<0?Win@3no_h0oooo0?knoP3moOd0a<C401dM7@1lO7`0oooo
0<G5a@3Lg=`0o_cm0P3ooOd03`3oood0o_oo0?coo`3nool0ooko0?onn03ooN`0n_?X01XR=03;en/0
o_om0?oomP3lnoh0o_ko0?ono`080?ooo`040?gmo@3no_h0oooo0?ooo`80o_kn00L0UYJF00000009
2@T000000:n_[`3oool0n?Sh01X0oooo00P0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnQT0
oooo00<0o_kn0?gmo@3oool0103oool02P3no_h0oooo0?ooo`1]KFd0000000@4100;2`/0b<S80?cl
o03no_h20?ooo`030?knoP3moOd0o_kn01T0oooo00@0o_oo0?ooo@3ooo@0ooof0P3ooOl03`3nool0
o?oo0?coo`3ln_d0oo[n0?oknP3ooO40n??[0?Woo`3hool0o?_n0=7@c01kNGX0o_oo0?WjoP030?co
o`030?kmo`3oool0ookm0080ookm00D0mOGc0?kmo`1<CDl0XZ:R0?knoP020?ooo`030?gmo@3lo?`0
o?cl00<0oooo00L0h>3P07inOP0J6QX0>3Ph0:VYZ@3fm_H0o?cl0080oooo00T0o?cl0?ooo`3hn?P0
h>3P01LG5`3emOD0o?cl0?ooo`3no_h05@3oool0503no_h0oooo04a<C0020P80k>c/0?ooo`3no_h0
oooo0?gmo@3inOT0o_kn0?clo03oool0o_kn0?_kn`3lo?`0oooo0=kNgP1gMgL0oOgm0P3oool00`3e
mOD0oooo0?ooo`0;0?ooo`004@3oool0403hn?P0oooo0?ooo`3inOT0no_k0?ooo`3lo?`0inOW00l?
3`0>3Ph0Rh^;05aLG00=3@d0SHf=0?gmo@3lo?`20?ooo`040?[jnP3kno/0oooo0?Ogm`80oooo00L0
lo?c0?ooo`3oool0n_[j0?ooo`3kno/0oOgm00D0oooo00@0nOWi0=cLg00F5QH0cLg=0`3oool00`3g
moL0oooo0?ooo`0Q0?ooo`0=0?knoP3gmoL0oooo0?gmo@3oool0o?cl0?ooo`3kno/0QhN701@D502h
^;P0oooo0?Shn0030?ooo`040?ono`3oo_d0ookm0?ooo`80o?oo00/0ooko0?omn`3oo^l0noS_07Z0
SP2<Tj<0no_g0?oom@3oo_l0no_o0?ono`080?ooo`0?0?knoP3oool0oooo0?ooo`3moOd0oooo0?[j
nP1?Cdl01@D50000000?3`l0j^[Z0?knoP3oool0o_kn01/0oooo00@0lo?c0?ooo`3oool0l_;b6`3o
ool03@3no_h0oooo0?[jnP3inOT0oooo0?clo03no_h0oooo0;Bd]00410@020P800000026QXH01@3o
ool30?knoQP0oooo00<0ooko0?koo`3oool00P3oooH0803ooOl0ooco0?koo`3lool0mOWj0?ono`3o
m?H0oo;`0?oik03on?00moko0?Ooo`3nool0n?Oc04e;C03ko?`0oOko0?[mo`3io?l0nooo0?ckoP3o
ool0oO_j0?omo03oo_d0o_kl0>KUj00A4Q@0m?Cd0?gmo@3oool0o_kn0`3oool00`3moOd0n_[j0?oo
o`020?ooo`080?gmo@2ZZZX0@d=301HF5P1cLg<0hN7Q0?knoP3inOT20?ooo`0306i^KP1hN7P0oooo
0080oooo00D0no_k0?knoP3no_h0oooo0?gmo@0@0?ooo`0F0?Win@3oool0moOg0?ooo`2<S8`071`L
0>?Sh`3oool0o_kn0?[jnP2FUYH0b<S80?ooo`3fm_H0oooo0?gmo@3oool0_[jn01<C4`2h^;P0oooo
0?KfmPl0oooo000@0?ooo`040?gmo@3no_h0oooo0?[jnP80oooo00T0n?Sh0?ooo`2JVYX0EeMG0;>c
/`0M7Ad0l?3`0?ooo`39bLT00P3oool0203gmoL0_Kfm0=[JfP3oool0o?cl0?knoP3oool0moOg0P3o
ool00`3moOd0o_kn0?clo0040?ooo`0=0?[jnP3inOT0o?cl0?ooo`1FEUH0SXj>0?ooo`3moOd0oooo
0?KfmP3oool0o?cl0?KfmP0T0?ooo`0A0?knoP3dm?@0oooo0?7al@13@d<0>SXj0>OWi`3oool0o?cl
0?gmo@3oool0o?cl0?ooo`3nool0oooo0?omo@3oo_d00P3lool02`3oo_l0oogm0?_fk03oooP0U9RQ
02hb>`3oooX0oooh0?7al@3nool0ooko00L0oooo00@0oOgm0?ooo`3oool0oOgm0P3oool02P3lo?`0
oooo0?3`l00J6QX00@4100<30`11@D40moOg0?ooo`3no_hH0?ooo`070?clo03oool0n_[j0?ooo`3n
o_h0oooo0?[jnP0I0?ooo`030?[jnP3oool0oooo00D0oooo00<0o_kn0>;RhP0=3@d00P0000000`1A
DE40n_[j0?gmo@030?ooo`030?knoP3oool0oooo01T0oooo00<0ooko0?kno`3oo_l00P3oooH20?ol
o`0J0?koo@3lood0nooo0??cl`0_82404P000;bZV`0V7A@0GfMi0>_go`3moOl0oook08J4Q@3Ee]H0
o_oo0?coo`3ko_l0o?oo0?ono`3emOD0ookm0?omo03oo_d0ooom07QgNP1^Kg420?ooo`080?clo03n
o_h0oooo0?gmo@3oool0o?cl0?ooo`3inOT20?ooo`0A0?knoP3oool0oooo0=[JfP1iNGT03Ph>04a<
C02_[jl0no_k0??cl`0E5AD0fMWI0?ooo`3kno/0n_[j0?ooo`3moOd05P3oool05@3moOd0o?cl08N7
Q`0_;bl0j^[Z0?ooo`3no_h0EeMG09nOW`3moOd0oooo0?gmo@3oool0d=3@01XJ6P2m_Kd0oooo0?Wi
n@3oool0no_k0?gmo@0=0?ooo`00403oool01@3jn_X0oooo0?knoP3moOd0no_k0080oooo00L0m_Kf
05eMG@2HV9P0o_kn075aL@19BDT0no_k0080oooo00`0o_kn0?ooo`2_[jl061PH02PX:01lO7`0lO7a
0?gmo@3kno/0o_kn0?Shn03no_h20?ooo`030?_kn`3lo?`0no_k00<0oooo00D0o?cl0>GUi@0<30`0
kno_0?KfmP030?ooo`040?_kn`3inOT0oooo0?_knb80oooo00X0n?Sh0?ooo`3oool0b<S801HF5P1j
NWX0n?Sh0?ooo`3kno/0n_[j0P3oool0203lo?`0o?go0?coo`3nool0oogo0?omo@3oood0o_oo0P3o
o_l02@3ooOT0oOch0;>f^P2DUIL0noGb0?okm@3nool0mo[n0?koo`070?ooo`040?knoP3oool0no_k
0?gmo@<0oooo00P0o?cl0?ooo`35aLD0000000<30`000000QXJ60?KfmQ`0oooo00D0m_Kf0?_kn`3n
o_h0Fe]K0?Shn00I0?ooo`80oOgm00@0o_kn0?ooo`3oool0o?cl0P3oool0200f=SH01PH60000000L
71`0inOW0?ooo`3lo?`0oooo0P3no_hL0?ooo`030?ono`3ooOl0ooko0080ooof01`0ooco0?omo`3n
oo/0o?oj0?_oo@3bl_008A4B0?;Mf02EPW401`000:2X_@3<f_@0o?oo0>k]j@1?CDh0SXn?0?_lo`3f
nOd0mo[n0?coo`3kn_d0oooo0?ono@3no?/0n_Sg0?ooo@0B4A@0fM[L0P3oool01@3no_h0oooo0?gm
o@3jn_X0no_k00@0oooo00l0moOg0?ooo`3inOT0o?cl0?ooo`3moOd0oooo09^KV`0m?Cd092@T05EE
E@2ATI40oooo0?clo03no_h00P3oool00`3jn_X0oooo0?ooo`0B0?ooo`0;0?Ogm`3moOd0oooo0?cl
o03oool0L71`03hn?P3fm_H0o?cl065QH@2NWYh0103oool01`2RXZ80gmoO0?gmo@3no_h0oooo0?Og
m`3no_h03P3oool00100oooo00H0oOgm0?_kn`3kno/0oooo0?knoP3kno/20?ooo`0601PH603Kfm/0
oooo0?ooo`1lO7`0X:2P0P3no_h01`3oool0no_k0?Shn03lo?`0c<c<07EeM@3@d=001@3oool01P3j
n_X0oooo0?ooo`33`l<05aLG0>[ZjP80moOg00<0oooo07QhN01WIfL00P3oool01P3no_h0oooo0?oo
o`3moOd0oooo0?clo240oooo00L0m_Kf0?ooo`3oool0o_kn08V9R@0D51@0/;2`0080oooo00h0o?cl
0?ooo`3oool0o?cl0?ooo`3kno/0o_oo0?Woo`3kool0oogo0?omo@3oo_d0o_om0?koo`<0ooko00L0
n_ci0?oon`3ooOP0oo_h0?koo`3iool0o_oo00L0oooo00<0o_kn0?ooo`3lo?`00P3oool01P3lo?`0
oooo0?ooo`3gmoL0oooo08N7Q`80000000<010@40<O7a`3oool06@3oool01P3jn_X0o_kn0?ooo`3o
ool0o?cl00410AX0oooo00D0oOgm0?ooo`3no_h0oOgm0?KfmP020?ooo`0607YjNP0000002PX:00@4
1036a/H0oooo0P3moOd70?ooo`030?knoP3oool0oooo01D0oooo01@0ooko0?omo`3oo_l0oooh0?oo
mP3oo?l0oogo0?oonP3kooP0n?oj0?;bkP0]7Ad0kMK@0?oji`0`9Ad0OXRQ0?7oo`3dmoh0oook0?Wg
n080o_oo00H0@4=701`O8`26RX/0hn;U0?ooo`3ooO`20?ono@070:ZZZ010?d80nocn0?ooo`3hn?P0
oooo0?Win@020?ooo`80n_[j00<0o?cl0?ooo`3oool0103oool02P3moOd0no_k0?ooo`3oool0o?cl
0=7Ad@1bLW802`/;04I6AP2i^KT20?ooo`040?Ogm`3hn?P0oooo0?Shn180oooo00<0no_k0?ooo`3o
ool00`3oool03@1MGEd0Bd];0?ooo`1OGel0WIfM0?ooo`3^k^h0no_k0?ooo`3kno/0o?cl0?ooo`3m
oOd00`3oool00`3fm_H0oooo0?ooo`0;0?ooo`004`3oool02P3kno/0oooo0?ooo`3fm_H0alO702TY
:@3moOd0oooo0?Shn03moOd40?ooo`0<0?clo03oool0oooo0?_kn`3dm?@0oooo0?knoP3kno/0oooo
024Q8@1gMgL0bLW90P3jn_X0303oool0RHV903Lg=`3jn_X0oooo0?_kn`0O7al0e]KF0?Win@3jn_X0
o_kn0?_kn`80oooo00<0nOWi0?ooo`3jn_X08P3oool0203QhN40DE5A03Xj>P3Jf]X0oooo0?gmo@3h
n?P0oOgm103oool0203jn_X0o?oo0?Soo`3iool0ooko0?omo@3oo_/0ooom0P3lool02@3oo?l0oO_n
0?konP3gmnd0ooch0?okn`3gn?P0nooo0?koo`0<0?ooo`030?[jnP3moOd0oooo0080oooo00H0moOg
04=3@`020P800@4101`L703/k>`H0?ooo`080?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/H
0?ooo`80o_kn0`3oool00`3no_h0oooo0;2`/00200410@0500000023Ph<0oooo0?ooo`3kno/01`3o
ool20?knoQL0oooo02H0ooko0?omo`3ooOl0oooh0?oomP3oo?l0oogo0?oon03kooH0m_og0?oon`1W
EeL0Z8n:0?ojj03=`[X01a8]0>cko`3lo_l0o?_g0?ono`3fmoL0mOKj0=gPi00C5QX0004200<21@09
2@T0D4i=07MeM02`[Zd0<C4_09NFV@3`lO<0n_[j0=oOg`2o_kl0W9bL0?;blP@0oooo00<0o?cl0?oo
o`3oool00P3hn?P04P3no_h0oooo0?ooo`3oool0oOgm0?ooo`3kno/0nOWi0?Shn02PX:00;Rh^02TY
:@25QHD0l_;b0?ooo`3moOd0oooo0?[jnQ40oooo00@0oOgm0?clo03oool0n?Sh0P3oool01`3gmoL0
B4Q805QHF01VIVH0X:2P0<?3``2JVYX01@3oool00`3no_h0n_[j0?knoP0?0?ooo`00403oool00`3h
n?P0oooo0?knoP020?ooo`040?[jnP3oool0Q8B407=cL`@0oooo00@0oOgm0?ooo`3kno/0nOWi0P3o
ool0303emOD0oooo0?ooo`3moOd0oooo0?gmo@3oool0dm?C07]kN`0Y:BT0ADE50?ooo`80o?cl00D0
BDU907IfMP3no_h0[Jf]03Ti>@040?ooo`060?clo03oool0no_k0?gmo@3oool0o_kn8@3oool01P36
a/H092@T071`L03gmoL0oooo0?_kn`<0oooo00`0m_Kf0?ooo`3no_h0o_kn0?ooo`3mo_l0nOoo0?_o
o`3oo_l0oogm0?onn`3oood20?coo`80ooko00L0o?kh0?oomP3oo?X0ooGd0?koo`3jool0o_oo00X0
oooo00H0m_Kf0?ooo`3oool0o_kn0?ooo`3lo?`20?ooo`050>3Ph00F5QH00`<30000001BDU80703o
ool20?knoP0300410@3oool0oooo01L0oooo00/0oOgm0?ooo`3lo?`0o_kn0?ooo`3moOd0hn?S01HF
5P0000000`<304U9B@020?ooo`030?knoP3lo?`0oooo01l0oooo02T0ooko0?omo`3oo_l0oooj0?oo
n03ooOd0oogo0?konP3looP0nook0?Oim03jk^h070X60>KFa`3ilN`000HK0=3Nn03joOl0o_ck0?kn
o03loOd0o_oo0?coo`3amOH0^KZl01<C4`0000000@0000T71P071@@00000014@4`010P@0000000@4
10000000:RXZ0?ooo`3kno/0oooo0?knoP020?ooo`050?[jnP3oool0oooo0?ooo`3moOd00P3oool0
3@3hn?P0oooo0?ooo`3kno/0oooo0?gmo@3lo?`0oooo0<W9b@1OGel03Ph>05YJFP32`/804P3oool0
103no_h0oooo0?ooo`3fm_H30?ooo`0<0?gmo@3fm_H00P82069RHP1GEeL05aLG0>7Qh@3kno/0o_kn
0?gmo@3oool0n?Sh0P3oool00`3no_h0oooo0?gmo@0=0?ooo`004@3oool02`3kno/0oooo0?ooo`3i
nOT0oOgm0?ooo`0a<C40`<300?[jnP3oool0oOgm00<0oooo00<0o_kn0?ooo`3oool01`3oool04@3m
oOd0oooo0?_kn`3moOd0i^KV0?[jnP3oool0oOgm0;no_`0K6a/0YJFU04a<C02RXZ80oooo0?knoP3o
ool0no_k00L0oooo00H0o?cl0?ooo`3oool0nOWi0?ooo`3lo?`20?ooo`0B0?clo03jn_X0oooo0?oo
o`3lo?`0oooo0?[jnP3no_h0oooo0?gmo@3kno/0o_kn0?ooo`3no_h0oooo0?gmo@3oool0oOgm0P3o
ool01P3hn?P0oooo0?gmo@2ATI405ADE0:j^[P80oooo00<0no_k0?ooo`3oool0203oool20?koo`04
0?ooo`3oo_l0ookm0?ooo`80o_oo00@0ooko0?ooo`3oood0oook0P3ooOd00`3oool0o_oo0?ooo`0@
0?ooo`090?gmo@3oool0o?cl0;Ng]`020P80000000820P2CTi<0oooo0080o_kn0P3oool00`3kno/0
oooo0?ooo`0?0?ooo`070?knoP3oool0oOgm0?gmo@3oool0o_kn0:JVYP0J0?ooo`0:0?KfmP3oool0
nOWi0?ooo`3kno/0?clo00820P010@406a/K0>_[j`80oooo00<0o_kn0?Win@3oool07`3oool01`3o
o_l0oogo0?omo`3oood0oook0?ono@3oood00P3noo/0703lood0n__k0?klo@3VhN40If=P06m^L@00
00`0XZRd0?[ko`3oood0o_om0?_mnP3nool0oOkn0?_lo03nool0no_i08B4PP0:2PX0000000H61P00
00801@@700000P0;2`/0=CDe0<[:bP3lo?`20?ooo`030?clo03moOd0o_kn0080oooo00`0o?cl0?gm
o@3oool0oooo0?knoP3oood0n_[h0?ooo@3Ti>@0C4a<0?[io03mo?l20?ono`0<0?SgnP3oo_l0l?3`
08Z:RP0R8R00=SHd09:BT03clo<0o?cl0?ooo`3no_h0oOgm0P3oool30?gmo@030?ooo`3lo?`0oooo
0080o_kn00H0oooo0?knoP3no_h0n_[j0?ooo`3gmoL20?ooo`090?[jnP3oool0nOWi01/K6`0G5aL0
g=cL0?clo03oool0o_kn01D0oooo000B0?ooo`80o_kn0P3oool02@3Ti>@061PH0?3`l03oool0o_kn
0?clo03oool0o?cl0?gmo@0>0?ooo`0;0??cl`3oool0oooo0?ooo`3Cdm<0:b/[00<30`0J6QX0h>3P
0?gmo@3lo?`00`3oool01`3lo?`0oooo0?[jnP3oool0n_[j0?ooo`3no_h00`3oool0103kno/0o_kn
0?_kn`3inOT20?ooo`80o?cl00@0oooo0?knoP3oool0mOGe103oool04`3jn_X0oooo0?gmo@3moOd0
oooo0?Cdm03kno/0o_kn0?ooo`3/k>`0FUYJ02l_;`3Ogml0oOgm0?knoP3moOd0oooo0?gmo@3no_h0
:03oool01P3lo?`0oooo0?ooo`3jn_X0oooo06MWI`800P8200H020P80<k>cP3oool0oooo0?knoP3j
n_XB0?ooo`080?[jnP3oool0n_[j0?ooo`3jn_X0o_kn0?ooo`3jn_XH0?ooo`0?0?knoP3oool0moOg
0?ooo`3lo?`0PH6100@4100000000@410;bl_03oool0o?cl0?Win@3oool0o_kn0240oooo0P3oo_l2
0?ooo`80ooom0P3nood00`3ko?`0o_oo0?Wjo0020?coo`060?Sko`2a];T0C4mD0?koo`3jno/0nO[j
0P3nood04@3lo_/0o_om0?[ln@3oood0no_i0=CDe00V9RH0000200<21@0000800P4406MWI`3UiND0
oooo0?gmo@3oool0oOgm00<0oooo00L0o_kn0?clo03oool0oooo0?_kn`3jn_X0oooo00<0ooom00H0
K6a/07QhN03oo_l0ooko0?glo`3noOl20?ono`080?gmo@3oool0o_kl0;6a[`1HF5H04Q8B06a/K03A
dM420?ooo`030?[jnP3moOd0oooo00<0oooo00D0no_k0?ooo`3lo?`0oooo0?clo0020?ooo`0:0?gm
o@3lo?`0oooo0?gmo@3kno/0oooo0?gmo@3oool0DU9B0861P@80oooo00<0m?Cd0?ooo`3oool0503o
ool00100oooo00@0o_kn0?ooo`3moOd0o_kn0P3oool01`2XZ:P0@d=30?ooo`3oool0n_[j0?knoP3o
ool00P3no_h;0?ooo`040?gmo@3oool0oooo0?knoP<0oooo00h0o_kn0?ooo`26QXH06a/K0:FUY@3h
n?P0oooo0?Ogm`3lo?`0oooo0?gmo@3no_h0oooo0?knoP80oooo00@0oOgm0?ooo`3no_h0o?cl1@3o
ool07@3kno/0o_kn0?ooo`3oool0nOWi0?_kn`3oool0m_Kf0?clo03kno/0o_kn0?[jnP3oool0no_k
0?ooo`3kno/0oooo0?[jnP3oool0dM7A028R8P1YJFT0o?cl0?ooo`3kno/0oooo0?gmo@3oool0n?Sh
02X0oooo00<0o_kn0?ooo`3moOd00P3oool02P0Z:RX0000000<30`0_;bl0n?Sh0?_kn`3oool0o?cl
0?knoP3moOdC0?ooo`040??cl`3oool0oooo0?;blQT0oooo00H0o?cl0?ooo`3moOd0nOWi0;jn_P01
0@420000000407inOP3oool0oooo0?Win@<0oooo00<0o_kn0?ooo`3oool07P3oool20?ono`@0oooo
0P3oood08@3lo?X0o_om0?cmo@3in_`0nocn0?koo`3Fem/000450>SYj`3nool0m_Oi0?cmo@3nool0
o?gm0?goo03nood0moOe0?ooo@3oool0V9RH01lO7`061PH01`H901HE601SHf<04a<C055AD@2h^;P0
no_k0?ooo`3^k^h0oooo0?_kn`030?ooo`0@0?knoP3oool0oooo0?knoP3oood0oOgk0?7al@0E5AD0
iNGU0?Gem@3noOl0no[m0?ckoP3kn_d0o?cl0?knoP80oooo0P3oood03@3Ti>@0Ng]k01lO7`0d=3@0
WinO0?[jnP3oool0moOg0?ooo`3kno/0o_kn0?ooo`3lo?`00`3oool03`3moOd0o_kn0?ooo`3oool0
n_[j0?clo03oool0lo?c0?ooo`3moOd0LW9b09BDU03no_h0oooo0?[jnP0F0?ooo`004P3oool0203l
o?`0oooo0?gmo@3no_h0Fe]K09jNWP3lo?`0o_kn0P3oool0103no_h0oooo0?ooo`3moOd:0?ooo`0I
0?clo03oool0o_kn0?ooo`3no_h0no_k0?[jnP3oool0no_k0?gmo@1OGel0GUiN0?ooo`3moOd0oooo
04A4A01HF5P0YZJV0?clo03moOd0nOWi0?clo03oool0nOWi0?clo0030?ooo`060?Cdm03oool0oooo
0?ooo`3gmoL0oooo0P3kno/60?ooo`0@0?_kn`3oool0lo?c0?ooo`3inOT0oooo0?[jnP3oool0V9RH
00d=3@2`/;00no_k0?knoP3dm?@0oooo0?gmo@80oooo00<0o?cl0?gmo@3oool0:03oool03P3moOd0
o_kn0?knoP3oool0oOgm0=GEe@0>3Ph020P80000001XJ6P0oooo0?Win@3oool0o_kn4@3oool01`3l
o?`0oooo0?[jnP3oool0o_kn0?ooo`3jn_X06P3oool02P3kno/0oooo0>c/k00L71`00`<300000019
BDT0oooo0?KfmP3kno/20?ooo`030?Win@3oool0oOgm0200oooo0P3oo_l40?ooo`<0ooom00T0no_i
0?ooo`3mo_h0oooo0?koo`34`lH0X:6S0>GVjP3dmOL00`3nool05`3mo_h0nocl0?_mnP3oood0kno]
0?ooo`0l?3`0/;2`04i>CP020@@01@@70<S8b03`l?00WIfM02l_;`0V9RH0R8R80>_[j`3oool0no_k
0?ooo`3kno/0n_[j0080oooo00H0n?Sh0?ooo`3inOL0ooom09fMW@1WIfL20?ooo`@0ooko00H0oooo
0?_kn`3lo?`0oooo0?ooo@3jn_P20?ooo`070?_kn`2i^KT0BTY:01DE5@1UIFD0gmoO0?knoP030?oo
o`080?[jnP3oool0o_kn0?_kn`3lo?`0oooo0?_kn`3moOd20?ooo`0709nOW`3>c/h0o_kn0?ooo`1h
N7P0Q8B40?[jnP020?ooo`030?_kn`3oool0oooo01<0oooo000A0?ooo`080?gmo@3lo?`0oooo0?oo
o`3jn_X071`L0=cLg03no_h20?ooo`050?knoP3inOT0oooo0?ooo`3no_h02P3oool0103no_h0oooo
0?_kn`3oool20?gmo@80oooo00`0n_[j0?ooo`3clo<092@T09VIV@3lo?`0n_[j0?Ogm`2CTi<0AdM7
00/;2`3gmoL20?ooo`060?clo03oool0o?cl0?[jnP3oool0no_k0P3oool00`3lo?`0oooo0?gmo@03
0?ooo`030?clo03moOd0oooo00<0oOgm00@0oooo0?gmo@3oool0no_k0P3oool01@3/k>`0FEUI034a
<@3GemL0n?Sh00<0oooo00<0no_k0?ooo`3moOd00P3oool00`3kno/0oooo0?ooo`0V0?ooo`030?[j
nP3oool0o?cl0080oooo00P0o_kn0?gmo@2LW9`0000000410@061PH0YjNW0?knoQH0oooo00D0m_Kf
0?_kn`3no_h0Fe]K0?Shn00J0?ooo`0>0?_kn`12@T8000000000000P8200h^;R0?ooo`3no_h0nOWi
0?ooo`3kno/0o?cl0?ooo`3no_hP0?ooo`80ooko103oool30?ooo@0S0?gmn`3no_`0o?cj0?Oem01[
Jf/0o_cm0?Gdm`3loOl0Rhb@0=7BeP3gn?X0o_oo0?gnoP3loOd0o_oo0?knoP3oool0e]KF01/K6`3j
n_X0oooo07AdM0020P80HV9R0?ooo`3no_h0n_[j0<?3``1UIFD04Q8B05IFEP30`<00no_k0?ooo`3j
n_X00P3oool01P3jn_X0oooo0?ooo@3lo?X0oooo0?Ogm`80oooo00D0nOSk0?ono`3oo_l0oOco0?gm
o@030?ooo`80ooom00h0n?Sh0?ooo`3oool0n_[j0?_kn`3Lg=`0O7al01TI6@16ATH0[:b/0??cl`3j
n_X0oooo0?gmo@@0oooo00X0o_kn0?gmo@3jn_X0Jf][02LW9`3`l?00o?cl0?ooo`1aLG40R8R80P3o
ool00`3lo?`0oooo0?ooo`0D0?ooo`00403oool02P3lo?`0oOgm0?ooo`3no_h0oooo0=KFeP0R8R80
o?cl0?ooo`3moOd40?ooo`80o_kn303oool01P3jn_X0oooo0?gmo@3oool0no_k0?Win@80oooo00H0
o?cl0>_[j`1YJFT0gmoO0?ooo`3jn_X20?ooo`090>_[j`3inOT0oooo0?knoP3UiND0UYJF0??cl`3o
ool0n?Sh0080oooo00D0o_kn0?ooo`3lo?`0oooo0?_kn`020?ooo`080?Gem@3oool0hN7Q07EeM@1g
MgL0PH610<71`@3lo?`20?ooo`050?[jnP3?cll0:b/[065QH@3dm?@00P3oool01@3no_h0o?cl0?gm
o@3lo?`0nOWi0080oooo00<0moOg0?ooo`3oool0:03oool03P3emOD0o_kn0?ooo`3oool0n_[j0?oo
o`3hn?P0Fe]K00H61P0000004A4A0>3Ph03oool0no_k4P3oool01P3jn_X0o_kn0?ooo`3oool0o?cl
00410AT0oooo00<0o?cl0?_kn`27QhL00P020P802P092@T0/[:b0?ooo`3hn?P0oooo0?gmo@3oool0
o?cl0?ooo`3no_hQ0?ooo`80ooko103oool20?ooo@030?[jn03oood0nOOf0080ookm01H0/:j]08F3
PP3oo_l0c/gB061PIP3no_l0o?go0?koo`3mo_l0o_oo0?[kn`3moOd0oooo06=SH`1lO7`0oooo0?kn
oP3moOd0De=C0000003moOd0o_kn0P3oool03`3jn_X0lO7a096AT@0];Bd0:BTY08V9R@3alO40n_[j
0?KfmP3oool0oOgm0?ooo@3jn_P0o_kn0?ooo`020?clo0080?ono`3noOl0oOco0?ono`3oool0oOgm
0?Shn03jn_X20?ooo@H0oooo00L0o_kn0?Ogm`2RXZ80?clo01/K6`3UiND0l_;b0080oooo00P0o_kn
0?ooo`3fm_H0n_[j0?ooo`1;Bd/0ATI60?KfmP80oooo00D0oOgm0820P026QXH0oOgm0?[jnP0G0?oo
o`00403oool01`3jn_X0oooo0?ooo`3oool0n_[j09>CT`1TI6@00P3oool00`3inOT0oooo0?ooo`02
0?ooo`030?[jnP3no_h0oooo00P0oooo00H0o?cl0?ooo`3oool0o?cl0?ooo`3lo?`30?ooo`060?Sh
n03lo?`0oooo0?_kn`3oool0o?cl0P3oool02`3jn_X0moOg0?ooo`3hn?P0oOgm0?ooo`3_knl0Fe]K
00`<3012@T80_[jn0080oooo01D0n_[j0?ooo`3moOd0oooo0?clo03jn_X0oOgm0?ooo`3[jn/0I6AT
0?ooo`3hn?P0oOgm0<o?c`1iNGT0IVIV0:ZZZP2HV9P06QXJ09bLW03lo?`00P3oool00`3gmoL0oooo
0?ooo`040?ooo`030?[jnP3oool0no_k02T0oooo00<0oOgm0?clo03inOT00P3oool0203lo?`0oooo
0?;blP0M7Ad00P8200D51@0i>CT0n?Sh4P3oool0203inOT0oooo0?ooo`3oool0n_[j0?ooo`000000
no_k6@3oool02`33`l<00@41000000000000LW9b0?ooo`3lo?`0oooo0?Ogm`3no_h0o?cl0080oooo
00<0no_k0?ooo`3oool07`3oool20?koo`@0oooo0P3oo_d0703ooO`0noWh0?onn`3nn_L0ookk0?ol
n@1>BTL0dLo@030_=03UiN/0moOm0?koo`3hnOd0o_oo0?cmo`3nool0o_kn0?KfmP0<30`0kNg]0?gm
o@3lo?`0no_k0?ooo`2>SXh0bl_;0?Shn03jn_X30?ooo`070?knoP3kno/0`l?305IFEP0J6QX0GEeM
0<_;b`020?gmo@040?clo03oool0o_kn0?gmo@80oooo00D0moOg0?ooo`3oool0n_[j0?Win@030?oo
o`050?knoP3oool0oooo0?gmo@3kno/00P3no_h01`3jn_X0no_k0?ooo`3oool0moOg03Ph>02TY:@0
0P3oool03P3emOD0oooo0?ooo`3no_h0oooo0?knoP21PH40oooo0?clo03kno/0o_kn0?_kn`32`/80
]kNg0`3oool00`3jn_X0oooo0?ooo`0C0?ooo`004P3oool01P3inOT0oooo0?knoP1OGel0WYjN0?[j
nP<0oooo00@0no_k0?clo03oool0no_k2P3oool00`3kno/0oooo0?ooo`020?ooo`090?_kn`3oool0
oooo0?ooo`3moOd0oooo0?[jnP3oool0oOgm0080oooo00@0n_[j0?ooo`3oool0o?cl0P3oool07P3m
oOd0oooo0?knoP3emOD0ZJVY09BDU03oool0n?Sh0?ooo`3bl_80o?cl0?gmo@3oool0o_kn0?ooo`3n
o_h0CDe=0?Shn03no_h0oooo0?knoP3kno/0oooo0?Ogm`1HF5P05ADE05ADE02NWYh0j^[Z0?[jnP<0
oooo00@0o?cl0?ooo`3oool0no_k0P3oool00`3kno/0oooo0?ooo`0W0?ooo`050?clo03oool0oooo
0?ooo`3kno/00`3no_h01P3jn_X0clo?00<30`0000000P820820P080oOgm503oool20?knoP030041
0@3oool0oooo01L0oooo00h0inOW01`L700000000@410492@P3jn_X0oooo0?clo03inOT0oooo0?kn
oP3oool0n?Sh0?knoR80oooo0P3nool40?ooo`<0ookm01<0oO_j0?omnP3oo_/0n_Kc0?onn`3/j>D0
0@000:ZY[`3no_l0oOgo0?kno`3nool0nO[n0?koo`3loOl0o_kn09FEU@1HF5P0n_[j00<0oooo00<0
o?cl0?ooo`3kno/00P3oool00`3kno/0o_kn0?knoP030?ooo`080?knoP3Xj>P0SHf=024Q8@0^;Rh0
U9BD0??cl`3no_h20?ooo`030?_kn`3oool0oooo00@0oooo00<0oOgm0?clo03oool00P3oool00`3m
oOd0oooo0?ooo`040?ooo`80o_kn00@0dm?C01TI6@3oool0o?cl0P3oool0103kno/0o?cl0?ooo`3l
o?`20?ooo`030?_kn`3oool0oooo0080oooo00D0o?cl0?ooo`3moOd0oooo0?clo00F0?ooo`002P3o
ool00`3hn?P0oooo0?ooo`020?ooo`80o_kn00H0oooo0?gmo@3oool0oooo02`/;037alLa0?ooo`0;
07moO`0j>SX0SHf=0>;RhP3no_h0oOgm0>WYj@2=SHd0o_kn0?ooo`3no_h00P3oool0303Jf]X0:RXZ
05UIF@3dm?@0oooo0>KViP2HV9P0KFe]09:BTP3Hf=P0oooo0?knoP<0oooo00<0no_k0?Shn03oool0
0P3lo?`20?ooo`070?knoP3oool0oooo0?_kn`3no_h0oooo0?gmo@030?ooo`030?knoP3oool0oOgm
0280oooo00D0R8R8000000061PH000000<30`0020?knoP050?ooo`3no_h0oooo0?_kn`3no_h02P3o
ool01`3no_h0oooo0?gmo@3moOd0oooo0?knoP2VYZH04`3oool02`3inOT0oooo0?ooo`3oool0o?cl
0?knoP17AdL02PX:0000000E5AD0i>CT0080oooo00<0o?cl0?ooo`3oool09P3oool20?koo`@0oooo
0P3oo_l0103mnoX0ookm0?omo@3on_X20?onn`030?Sdl@3Qgmh0mOCj0080o_ko00P0m_Kl0?gno`3n
ool0o?go0?koo`3kno/0:BTY0;no_`80oooo00<0n_[j0?ooo`3moOd02P3oool0303kno/0oooo0?kn
oP3no_h0_[jn05=CD`0A4A40UYJF0?ooo`3lo?`0o_kn0?gmo@<0oooo0P3no_h01P3oool0o_kn0?oo
o`3no_h0oooo0?gmo@80oooo00<0n_[j0?ooo`3no_h00P3oool00`3lo?`0KVi^07]kN`020?ooo`09
0?[jnP3oool0oOgm07MgM`3oool0o_kn0?ooo`3moOd0o_kn01l0oooo00080?ooo`080?Win@3kno/0
oooo0?clo03no_h0nOWi0?ooo`3kno/30?ooo`050?clo03jn_X02PX:0?gmo@3inOT0<03oool0203j
n_X0^[Zj05]KF`0H61P0clo?0?knoP2CTi<0k^k^0P3oool04P3`l?00oooo0::RXP0A4A40X:2P0?oo
o`3moOd0oooo0?gmo@3lo?`0oooo0>o_k`2][Jd0J6QX08J6QP3IfMT0nOWi0?_kn`<0oooo00L0oOgm
0?ooo`3emOD0o?cl0?ooo`3fm_H0nOWi0080oooo00D0o?cl0?ooo`3oool0oOgm0?[jnP0S0?ooo`80
oOgm00P0nOWi04A4A00000001`L701XJ6P3/k>`0oooo0?knoP@0oooo00<0no_k0?gmo@3oool01`3o
ool0203jn_X0oooo0?[jnP3oool0n_[j0?knoP3oool0n_[j403oool03P3jn_X0oooo0?ooo`3gmoL0
nOWi0?ooo`3moOd0T92@00<30`00000020P80;Fe]@3no_h0nOWi:P3oool20?koo`@0oooo0`3oo_l0
103oo_d0oogm0?okn`3ooOd20?onn`040?WgmP3oo_l0moOm0?gmo`80o_oo00L0o?go0?koo`3jnod0
b/[:02TY:@3hn?P0oOgm0080oooo00<0oOgm0?ooo`3oool01`3oool0103hn?P0oooo0?ooo`3kno/4
0?ooo`030=?Cd`0410@0lo?c0080oooo00X0n_[j0?knoP3moOd0mOGe0?ooo`3kno/0oooo0?Win@3o
ool0nOWi0P3oool01P3emOD0oooo0?ooo`3gmoL0oooo0?knoP80no_k00/02`/;0>o_k`3no_h0mOGe
0?ooo`3]kNd0A4A404U9B@3gmoL0oooo0?Win@020?ooo`030?Win@3moOd0oooo01`0oooo000:0?oo
o`040?Gem@3no_h0oooo0?Shn0<0oooo00L0no_k0?ooo`3oool0alO702d];@3oool0o_kn03<0oooo
00P0n?Sh0>KViP3no_h0JVYZ0?ooo`0a<C400000014A4@809BDU00<0f=SH0?Ogm`3no_h00`3oool0
0`3no_h0n_[j0?clo0020?ooo`060?;blP2b/[80Jf][07moO`34a<@0n_[j2@3oool00`3gmoL0oooo
0?knoP030?ooo`030?[jnP3inOT0o?cl0240oooo00d0n_[j0?ooo`3Zj^X04a<C000000071`L0C4a<
0?knoP3oool0o?cl0?Win@3oool0o_kn00d0oooo00@0lo?c0?ooo`3oool0l_;b4`3oool02@3gmoL0
oooo0?clo03oool0a<C400<30`010@401@D506EUI@020?ooo`030?clo03oool0o_kn02P0oooo0P3o
ood40?ooo`050?ono`3oool0oooo0?ooo`3ooOh00P3oo_d0203no?/0oook0?ono@3oo_l0n?Sn0?kn
o`3nool0noco0`3nool0201FEUH0RHV90?ooo`3kno/0oOgm0?ooo`3lo?`0o_kn2@3oool20?knoP0=
0?gmo@3oool0no_k0?Gem@3oool0Lg9e07IeN03jn_X0oooo0?knoP3oool0ooom0?gmn`020?ooo@04
0?gmo@3oool0oooo0?_kn`80ooko00H0n_[j0?ooo`3oool0n_[j0?ooo`3jn_X20?ooo`0809NGU`1A
DE40n?Sh0?gmo@3oool0nOWi01lO7`1dM7@20?ooo`040?KfmP3oool0no_k0?Ogmal0oooo00080?oo
o`040?_kn`3inOT0oooo0?gmo@80oooo00@0n?Sh0?ooo`3oool0n_[j0P3oool00`2=SHd0L71`0?Ge
m@0a0?ooo`030?knoP3lo?`0m_Kf0080oooo00P0kno_09:BTP2UYJD010@400d=3@020P80000002HV
9P<0oooo0P3jn_X01P3moOd0oooo0?ooo`3oool0o_kn0?gmo@<0oooo00L0oOgm0;jn_P1fMWH0Lg=c
0;bl_03jn_X0o_kn00<0oooo00@0o_kn0?ooo`3oool0no_k0P3oool01@3lo?`0oooo0?ooo`3oool0
o?cl0200oooo0P3no_h01`3oool0o_kn0;Bd]00410@01`L70000002CTi<00P3oool01@3inOT0oooo
0?gmo@3oool0o?cl00P0oooo00L0o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[j0180oooo00H0o_kn
0?ooo`3kno/0oooo0>c/k00N7Qh20000000703Lg=`3oool0oOgm0?clo03no_h0oooo0?_kn`0X0?oo
o`80ooom103oool30?ono`080?knoP3oool0oooo0?ono`3jn_P0oO_j0?ooo@3in_h20?koo`0=0?_l
oP3loOl0o_oo0?Sin@3]k^h04a<C0?7al@3kno/0o?cl0?ooo`3moOd0oooo0?gmo@090?ooo`040?[j
nP3oool0oooo0?knoP80oooo0280m_Kf01<B5@3Kf]d0oooo0?Ogm`3no_h0oooo0?[jn03oood0o_kl
0?Kfm03oool0o_kn0?clo03oool0oOco0?[io03oool0oOgm0?ooo`3kno/0oooo0?clo03oool0mOGe
02`/;02k^k/0oooo0?gmo@3oool0gMgM0:RXZ03oool0n_[j0`3oool0103inOT0o_kn0?ooo`3hn?PM
0?ooo`002@3oool03@3inOT0oooo0?ooo`3moOd0nOWi0?ooo`3moOd0oooo0?knoP3oool0oOgm06AT
I02FUYH0=@3oool01@3inOT0o_kn09VIV@3Xj>P0:RXZ0080000000H010@400410@0;2`/0k^k^0?gm
o@3jn_X90?ooo`0>0?Win@3lo?`0oooo0?Ogm`3oool0nOWi0=3@d01gMgL0MGEe0:f][@3emOD0oooo
0?_kn`3moOd30?ooo`050?knoP3moOd0oooo0?gmo@3kno/08@3oool03P3no_h0oooo0?Win@3kno/0
oooo06e]K@0000002PX:00/;2`3;bl/0no_k0?ooo`3kno/0o_kn3@3oool01@3fm_H0no_k0?knoP1K
Fe/0n?Sh0100oooo00X0o_kn0?_kn`3oool0no_k0?[jnP1FEUH00`<30000000A4A40hN7Q0`3oool0
0`3moOd0oooo0?ooo`0X0?ooo`@0ooom0P3oool20?ono`0;0?ckoP3noOl0ooko0?koo`3oool0o_oo
0?ooo`3nool0o?go0?koo`3jnod0103nool01`2;SHX0G5aJ0?kno03moOd0o_kn0?ooo`3gmoL00P3o
o_l80?ooo`030?Win@3no_h0oooo0080oooo00D0n?Sh0?ooo`2<S8`0E5=F0?ono`030?ooo`0=0?Wi
n@3oood0_[jl0000001CDe40MGEe0?ooo`3moOd0oooo0?_jo@3oo_l0oooo0?Shn0020?ooo`060?kn
oP3oool0l?3`0<k>cP0W9bL0o_kn0P3oool0103inOT0mOGe0?knoP3moOd20?ooo`050?[jnP3gmoL0
oooo0?ooo`3fm_H07P3oool000P0oooo00<0m_Kf0?ooo`3kno/00`3oool0203lo?`0oooo0?ooo`3o
ool0oOgm0?ooo`0Y:BT0b<S8<P3oool03P3no_h0oooo0?[jnP3moOd0no_k06a/K03oool0=cLg00H6
1P0000000@410000000I6AT0n?Sh0P3oool01P3lo?`0oooo0?knoP3lo?`0no_k0?knoP80oooo00<0
oOgm0?ooo`3no_h00P3oool02P3lo?`0oooo0?[jnP3no_h0oooo0=7Ad@23Ph<0KVi^0:^[Z`3/k>`3
0?ooo`80o?cl0P3oool00`3kno/0oooo0?ooo`0S0?ooo`030?Cdm03lo?`0>CTi0080000000H0;2`/
0?KfmP3kno/0o_kn0?ooo`3gmoL:0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@414P3oool0103j
n_X0oooo0?ooo`2DU9@20000000900410@2_[jl0oooo0?ooo`3dm?@0oooo0?knoP3oool0o?cl02P0
oooo103oood20?ooo`80ooko00<0o_go0?koo`3nool00P3mo_l20?koo`050?gnoP3nool0nocn0?cm
o`3mo_h00P3nool01P3jo?T07b4N0<_;b@3moO/0oooo0?knoP80oooo00<0no[m0?ono`3oool02P3o
ool02@3gmoL0oooo0?ooo`3kno/092@T0<?2a@3oo_l0mOGe0?_kn`020?ooo`80ooom00T0a<C20;Rh
]P3alO40o_kn0?gmo@3lo?`0ooko0?ckoP3no_h00P3oool02P3kno/0oooo0?ooo`3oool0GemO08F5
Q@3alO40MWIf0?_kn`3lo?`20?ooo`80oOgm00D0n_[j0?ooo`3oool0nOWi0?clo00O0?ooo`00203o
ool0203moOd0oooo0?ooo`3lo?`0oooo0?gmo@3oool0no_k0P3oool01@3kno/0mOGe00h>3P3jn_X0
nOWi0340oooo0140no_k0?ooo`3oool0oOgm0?clo027QhL0lo?c0;2`/0092@T0000000820P000000
XZ:R0?Win@3oool0nOWi0?gmo@070?ooo`090?knoP3moOd0nOWi0?clo03oool0mOGe0;2`/00@4100
h^;R0080oooo00L0o?cl0?ooo`3Jf]X0TY:B06MWI`2PX:00g=cL00@0oooo00<0o_kn0?ooo`3oool0
8P3oool02P3lo?`0oooo0?ooo`3Jf]X03@d=00820P000000HF5Q0?ooo`3lo?`20?ooo`030?KfmP3o
ool0oooo00H0oooo00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_kna40oooo00P0n_[j0?oo
o`3@d=000`<30000000820P0IfMW0?clo080oooo00@0o?cl0?ooo`3no_h0n_[j:@3oool01P3oo_d0
oook0?ooo@3oood0oooo0?ono`D0o_oo0P3jo_l20?_oo`040?[no`3mo_h0o_oo0?koo`80n_ci00/0
o_om0;:d/@0b=340o?cj0?ooo@3kno/0oooo0?kmo`3oo_l0o?_n0?kmo`080?ooo`090?knoP3lo?`0
oooo0?ooo`3lo?`0oooo0:f][@0i>CT0o?_n0080ooko00<0n_[j0?ooo`3lo?X00P3oood00`3lo?X0
^;Rf0:b/ZP020?ooo`80n_Wl00`0ooko0?ooo`3moOd0oOgm0?ooo`3lo?`0o_kn0?;blP092@T0aLG5
02HV9P2HV9P30?ooo`030?gmo@3oool0o_kn00D0oooo00<0oOgm0?ooo`3oool0703oool0000E0?ko
o@3oood0ooko0?ono`3oool0ooom0?oon`3oood0ooko0?Sio@3mo?l0ooko0;2ZZP0<1`L0jn[]0?ko
o`3noOl0o_kn0?ooo`3;bl/0;2`/0080oooo00<0o?cl0?ooo`3oool0;`3oool02`3hn?P0oooo0?gm
o@2k^k/0d=3@0?ooo`3no_h0/k>c04I6AP0V9RH0[Jf]00<0oooo00<0o_kn0?ooo`3oool0103oool0
3P3no_h0o_kl0?omo@3oo_d0o_oo0?coo`3jnO`0ookm0?_hl@1LFeH0l??g0?[mo`3mo?l0oO_n0P3o
o_l02@3no_`0oook0>CThP2OWil0JVYZ08n?S`3Ogml0oooo0?gmo@0R0?ooo`030?gmo@3lo?`0oooo
0080oooo00T0n?Sh0:JVYP030`<0000000410@2^[Zh0nOWi0?ooo`3no_h03@3oool20?knoP030041
0@3oool0oooo00l0oooo00P0n_[j0?ooo`3_knl07QhN00D51@000000<C4a0?knoPD0oooo00<0oOgm
0?knoP3no_h0:03oool20?ono@040?ooo@3oool0oooo0?ono`<0o_oo00D0oOko0?koo`3lool0o_oo
0?coo`020?koo`0@0?cmo@3nool0o_om0?goo03nood0nogj059DD@2HVYL0ooom0?Wim`3no_h0oooo
0?glo`3jnO`0ooko0?kmo`P0oooo00<0o_kn0?ooo`3lo?`00P3oool03`3gmoL0@D510:VWYP3oo_X0
o?_g0>[]lP3lo_l0ooWo0?Scm`3lool0n?kj0?onm`3oooX0T96C0<_>d`020?kno`050?ooo@3Sh]h0
_Kfk0?ooo`3no_h00P3oool01@3kno/0T92@055AD@0D51@0X:2P0080oooo00<0no_k0?ooo`3gmoL0
0`3oool00`3moOd0oooo0?Win@020?ooo`030?_kn`3oool0oooo01/0oooo00005`3kooL0o_ok0?om
o`3on_l0ookm0?kmmP3hmN`0WYfI09fMY@2[[KT0ooko0?ojo@3oknd0JemN0>k^mP3kool0o_oo0?oo
o`3no_h0UYJF06EUI@3oool0o_kn0340oooo00/0o_kn0?ooo`3oool0oOgm09>CT`3hn?P0oooo0?_k
n`3no_`0nOWg0?gmo@020?ooo`070?knoP3oool0oOgm0?gmo@3oool0ooom0?gmn`020?ooo@0C0?gm
n`3ooo/0oocg0?omnP3kool0mooo0?koo`3onoL0oo_T0:JRTP2d_/L0loko0?omo`3on_l0oo_o0?gk
o`3oooX0oooe0?oon`020?ooo`050>WYj@2NWYh0JFUY08b<S03Cdm<00P3oool0203hn?P0oooo0?oo
o`3oool0o?cl0?knoP3oool0oOgm0`3oool01P3jn_X0oooo0?knoP3oool0o?cl0?gmo@80oooo00<0
o?cl0?gmo@3oool0403oool01@1KFe/01`L70000000>3Ph0gmoO0080oooo00<0oOgm0?ooo`3moOd0
0P3oool01P3hn?P0oooo0?ooo`3oool0o_kn0?ooo`80oOgm00<0oooo0?knoP2VYZH02P3oool03P3i
nOT0o_kn0?ooo`3no_h0nOWi0?ooo`3lo?`0oooo0?_kn`1HF5P01@D50000000?3`l0g]kN>@3oool0
1P3oo_l0oooo0?ono`3nool0oooo0?koo`<0oooo00P0n_[j0?ooo`3oool0o?cl0:f][@0?3`l0l_;b
0?knoP<0oooo00@0o_kn0?ooo`3moOd0oooo0`3no_h40?ooo`040?gmo@3oool0oooo0?[jnP80oooo
01l0b<S801lO7`3kn?40oo_W0>3Jc0000Ph0:C180<>cb`0800/0ZkVj0?7on03Xi]D0ooc`0;g1b01[
LhD0n?co0?cno`3oooP0k^cM02XY900Y:BT0TI6A0?Cdm03lo?`0oooo028R8P20P800c/k>0?clo03o
ool0nOWi0080oooo00D0n_[j0?ooo`3lo?`0oooo0?_kn`020?ooo`030?knoP3oool0oooo01d0oooo
00004@3kooP0o_ok0?olo`3oo?l0oogf0?omm03mnOD0i>;S01DC7P38am@0oO_o0?olo`3on_H0Z9ZG
0;Jf`03iool0o_oo0080oooo00@0JVYZ09:BTP3oool0o?cl<P3oool0103inOT0oooo0?ooo`1kNg/2
0?_kn`060?ooo`3oood0ooom0?ooo`3inOT0o?cl0`3oool06`3kno/0oooo0?ooo@3no_`0n_[h0?oo
o@3ooo/0oogi0?oimP3hk^`0k_Cd0?Coo`3hool0o_oj0?ooiP3Je<80IF]i0?Ono`3lnOl0oOWo0?ol
o`3mnol0oOcg0?oom@3knoL0oooo0?Win@030?ooo`070>[ZjP2f][H0IVIV08B4Q03?cll0n_[j0?Sh
n0050?ooo`040?clo03oool0nOWi0?knoP@0oooo00<0o_kn0?_kn`3moOd00P3oool00`3lo?`0oooo
0?ooo`0>0?ooo`060?Gem@0N7Qh00@4100@4100j>SX0kno_0`3oool00`3jn_X0no_k0?ooo`020?oo
o`0:0?clo03oool0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnPP0oooo00<0no_k0?ooo`3m
oOd00`3oool0103emOD0oooo0?ooo`2QXJ43000000030:b/[03hn?P0oooo04@0oooo00L0n_[j08J6
QP000000HF5Q0<G5a@3oool0no_k0080oooo00<0n_[j0?gmo@3oool0103oool09P3lo?`0oOgm0?oo
o`3oool0oOgm0?Ogm`3oool0no_k0?KfmP1WIfL0RXZ:0?omm@3on=l0W9F304eJJ`3co?l08``T01`7
5P2P/KH0j?ok0>KWe`19ACT00PH=0;g5e`3ho_l0n_co0?oon03ooo40oOcg0<?3``1MGEd03@d=06QX
J02JVYX0<C4a0?Shn03oool0o?cl0P3oool0103inOT0no_k0?ooo`3no_h30?ooo`030?Ogm`3lo?`0
o_kn01l0oooo00005`3ioO`0n?Wi0?omo`3ooOX0oooa0?ool`3inOl0ooco07E]N02]YJh0o_ko0?kn
oP3oo?H0h=KD07EdP@3en?l0o_ko0?gmo@3oool0;bl_0<c<c03oool0o?cl0340oooo00/0no_k0?oo
o`3oool0moOg0;Rh^02OWil0oooo0?clo03oood0nOWg0?clo0020?ooo`80o_kn0P3oool00`3jn_X0
n_[h0?ooo@020?ooo@0C0?knnP3onOT0H4mE08n0P`23Q7`0PHj40>[oo`3bool0m?GU0?omm01QF6P0
ln_o0?omo`3fnOl0noko0?koo`3ooo/0oooj0?clnP020?ooo`030?knoP3gmoL0moOg00<0oooo00D0
n?Sh0;Jf]P1jNWX0NWYj0;bl_0020?knoP030?gmo@3jn_X0oooo0080oooo00@0n_[j0?ooo`3hn?P0
oOgm0`3oool00`3no_h0o?cl0?knoP0B0?ooo`070<g=c@0820P000000000001nOWh0oooo0?Shn003
0?ooo`040?clo03oool0oooo0?[jnP@0oooo00@0lo?c0?ooo`3oool0l_;b2P3oool03@3hn?P0o_kn
0?gmo@3oool0no_k0?knoP3oool0clo?00<30`0000000`<306e]K@3moOd0A03oool02P3lo?`0n_[j
0?ooo`3emOD02`/;07alO00P8200<30`0:2PX03_knl20?ooo`050?_kn`3no_h0oooo0?_kn`3hn?P0
0P3oool01@3no_h0no_k0?ooo`3oool0oOgm0080oooo0200i^KV00d=3@3]kNd0oooh0?ooj03;a;T0
1PdU0?7do`3hh^D03@000<gNiP3]ool0o?om0?_jm@3al_@0nooo0?Wlo`3nool0ooom0?knnP3oood0
o_kn0?Gem@33`l<0B4Q80000000S8b<0[Jf]0?Win@3oool0n_[j0?Ogm`80oooo00D0mOGe0?ooo`3o
ool0moOg0?gmo@020?ooo`030?knoP3oool0o?cl01d0oooo00005`3no_l0ooko0?omo@3ono<0ooo/
0=cLd00001408Ale08]kQ@1NDU@0o?oo0?Soo`3oo_P0no?`05eKJ03jo?l0o_ko0?knoP3oool02PX:
0??cl`3oool0o_kn0380oooo00`0mOGe0?ooo`3oool0oooo0;Jf]P1^KVh0lO7a0?ooo@3jn_P0o_kn
0?ooo`3inOT20?ooo`0K0?Gem@3inOT0oooo0?ooo@3no_`0no_i0?kno03ooo/0oo[j02LJ8@3SemT0
oood096KSP1BIVD0kooo0?konP3Rf]L06@dI0=G<g03fnOl0nOoo0?WmoP3nool0ookm0?_in03oool0
n_[j00@0oooo00/0o_kn0?gmo@3no_h0no_k0?knoP3oool0n?Sh0<[:bP1iNGT0Kfm_0;>c/`020?oo
o`040?Ogm`3kno/0oooo0?_kn`<0oooo00H0oOgm0?knoP3oool0oooo0?gmo@3lo?`@0?ooo`80oOgm
00D0Rh^;000000061PH000000;^k^`020?ooo`040?knoP3oool0oOgm0?_kn`80o_kn00P0oooo0?cl
o03oool0n_[j0?ooo`3no_h0oooo0?[jnPX0oooo00<0no_k0?ooo`3no_h00`3oool02@3Zj^X09BDU
00L71`061PH0:2PX0??cl`3no_h0oooo0?[jnP110?ooo`0=0?clo03oool0oooo0?Shn03oool0N7Qh
07AdM03oool0]kNg059BDP0<30`0Jf][0=KFeP020?ooo`030?Win@3no_h0oooo00D0oooo02@0o_kn
0?ooo`3oool0oooo07MgM`1WIfL0oooo0?omn@3ooNh0l>_S01HK;`3Qgo@0ooW^089aI@1mSI`0j_oo
0?Woo`3dm?00oook0?ooo@3lo?`0oOco0?[ko@3nool0o_kn0?ooo`2f][H06a/K0;^k^`0@4100YZJV
03De=@0G5aL0P8200>?Sh`3oool20?knoP80oooo00H0o_kn0?ooo`3moOd0m_Kf0?ooo`3lo?`O0?oo
o`0001P0o_co0?kko`3ooO/0ooca0?ghhP2c/jT01`dU0?Gdo`0e82<07`d70?3en@3eool0ooom0>;M
g@0B41/0a/GB0?kmo`3oool0lo?c00X:2P3oool0o_kn0?ooo`3no_hb0?ooo`090?knoP3oool0moOg
0?gmo@3`l?00TI6A06][J@2^[Z`0kno_0080oooo00<0oOgm0?ooo`3oool00P3oool06P3oood0oOgk
0?ooo@3oood0no_g0?oon`2=Rh`0QX610?onn03hm?405QTP0=_Mi`3oo_l0m?;c0?omo`3hn?h0n?oo
0?GooP0n?S`0Thj>0>7LgP3ooOl0oooo0?knoP3lo?`0oooo0P3moOd01P3oool0o_kn0?ooo`3clo<0
c/k>0?KfmP80oooo00/0no_k0?ooo`3De=@0OWin06][J`2][Jd0nOWi0?KfmP3no_h0oooo0?Shn002
0?ooo`050?knoP3moOd0oooo0?ooo`3no_h04P3oool0203lo?`0BDU900410@0000006ATI0>KViP3o
ool0oOgm0P3oool0103moOd0oooo0?ooo`3moOd30?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P0203o
ool00`3no_h0oooo0?clo0020?ooo`070?Ogm`3oool0Hf=S000000030`<02@T90=kNgP030?clo4<0
oooo00h0mOGe0?ooo`3oool0m_Kf0>GUi@0>3Ph0no_k0?knoP3oool0hn?S07emO@0K6a/0@T9209nO
W`80oooo00<0o?cl0?_kn`3lo?`00`3oool05P3lo?`0oooo0?Win@3fm_H05aLG0>CTi03inOT0oogl
0?omn03ooO/0Zjnh034`=@3ol=`0VHeo038lE@3^o_l0m?go0?kon03ooO@0ookg0?ooo`3nool20?on
o`0?0?gmo@2j^[X05aLG0<W9b@23Ph<0HF5Q0?knoP3oool0f=SH06IVIP0J6QX0DU9B0<;2`P3lo?`0
o_kn0080nOWi00H0oooo0:NWY`1NGUh0no_k0?ooo`3moOdN0?ooo`0001@0o_[o0?olo`3ooO/0ookd
0?ook03<cLD02@h[0?kko`3njN@03P000<_BeP3Znol0noko0?ono`3knOl0oogo0?kmo`3oool0e]KF
02PX:080oOgm00<0oooo0?gmo@3oool0;`3oool00`3lo?`0oooo0?gmo@030?ooo`80oOgm00`0nOWg
0=gMf`2:RXX0IFEU0:VYZ@3]kNd0n_[j0?gmo@3oool0o_kn0?[jn03moO/20?ooo@0Z0?knnP3oooX0
e]?<02l[9`3oool0oOco04U5D@2d/;`0oOco0?ooo`3moOd0n?ck0?Ooo`3hool09B@P00@000010080
0`8501`L700n?Sh0EEEE07]kN`20P800KFe]06YZJP1<C4`03`l?00H61P1kNg/0oooo0?Shn03lo?`0
no_k0?ooo`3lo?`0oooo0?gmo@3Shn<0QhN706m_K`2WYjL0jn_[0P3oool00`3moOd0oooo0?ooo`02
0?gmoA80oooo00X0oOgm0?ooo`3/k>`04a<C000000020P80AdM70?Ogm`3oool0no_k103oool0103m
oOd0oooo0?[jnP3no_h20?ooo`030?clo0010@40oooo00T0oooo00X0n_[j0?gmo@3oool0oooo0?_k
n`2QXJ40000000L71`000000ZZZZ0`3oool00`3moOd0oooo0?ooo`0o0?ooo`090?Shn03oool0oooo
0?ooo`3no_h0oooo0?clo01ADE40V9RH00<0oooo00T0oOgm0?clo02YZJT0BTY:00d=3@1fMWH0gMgM
0?ooo`3no_h00P3oool05`3jn_X0oooo0?ooo`3no_h0V9RH051@D03inOT0oooo0?ono@3onoT0oogm
0?coo`2c]K00KV=?06ALD@0001D0h>Wo0?Woo`3dm_40oocc0?oomP3nood0mo_j0080ooko00L0o_kn
08>3P`3[jn/0n_[j01XJ6P3Hf=P0nOWi00<0oooo00h0j^[Z09:BTP0Z:RX0:BTY09JFUP3hn?P0oooo
0?clo02l_;`0>CTi0?ooo`3gmoL0o_kn0?gmoAd0oooo00005@3onoh0ooco0?olo@3lo?X0ooog0?Og
m@1VIGd0MFj20?ohk@2YWH`0DU]R0?7oo`3joOl0no[n0?kmo`3kno/0oooo0?gmo@2UYJD0F5QH0?kn
oP0d0?ooo`030?knoP3moOd0o_kn0080o_kn02D0no_k0?ooo`3oood0o_kl0?gmo@3oool0kno_0<O7
a`2e]KD0`L710<K6aP2`/;00a<C20>o_k@3moO/0o_kl0?oon`3mn_40ooGT04Lk<@11Be/0U:Fc02`_
@03CcmT0ooko0?kmo03oo_X0oool0?Omo03lool0ookj0?7]jP2][Jd0MWQj03Ti>@061PH000000080
0P8200X0000000@4100];Bd0O7al0<W9b@3jn_X0oooo0?knoP3moOd0oooo0P3no_h03`3lo?`0o_kn
0?knoP3lo?`0oooo0?Cdm036a/H0/[:b0<;2`P30`<00][Jf0<;2`P3[jn/0o_kn0?gmo@0A0?ooo`80
o?cl00h0o_kn0=cLg00o?cl00@410000001;Bd/0i^KV0?knoP3oool0o_kn0?ooo`3lo?`0oooo0?cl
o0<0oooo00@0o?cl0?ooo`010@40oOgm203oool01P3no_h0oooo0?knoP3moOd0no_k0820P08010@4
00@05aLG0:^[Z`3oool0no_k0P3oool00`3lo?`0oooo0?ooo`0o0?ooo`0C0?clo03jn_X0oooo0?_k
n`3moOd0oooo0?gmo@3Kfm/0;Bd]0>3Ph03moOd0no_k0?ooo`3moOd0no_k0?knoP3`l?00][Jf08N7
Q`0207MgM`0808F5Q@2_[jl0h>3P0?gmo@3oool0fMWI02l_;`3Lg=`20?ooo`80oo_k01H0ooWg0?_n
o03koo`0o_gf0?omn01THfT0Ngb60?cmo`3oool0o_gl0?cmn03fo_P0d]WC0=oIg@3on_h0o_cm0?_k
n`3no_h0P82006a/K03jn_X0oooo0P3moOd01`3lo?`0oooo0?knoP3moOd0gmoO0:RXZ01kNg/00P1e
MGD01@2BTY803Ph>0?Shn03oool0o?cl01h0oooo0000503ono/0oocm0?glo`3lool0n_on0?koo`3n
m_l0a[S305iDBP1^JEl0>dE<0>?_o@3lo_l0ooco0?koo`3nood0oOgm0?ooo`1aLG40Rh^;0P3no_hc
0?ooo`070?knoP3oool0o_kn0?gmo@3oool0no_k0?ooo`020?ooo@H0oooo02@0no_k0?ooo`3^k^`0
YjNU06YZJ024Q880dM7=0?onm03on^H0`[BY05m^P@3]ool0nOko0?olo`3nnol0ooko0?ommP3oooP0
o?om0?_ooP3oooX0ookj0?gnoP3kool0oooo0>3Ph014A4@020P800820P010@403Ph>00d=3@11@D40
V9RH0>;RhP3kno/40?ooo`030?knoP3inOT0oooo00<0oooo0140nOWi0?ooo`3oool0oooo0?knoP3o
ool0l?3`0:RXZ01dM7@0OWin0<g=c@3oool0o_kn0?Win@3oool0no_k0?clo0040?ooo`080?gmo@3o
ool0oooo0?clo03oool0no_k0?ooo`3inOT20?ooo`0:0?Cdm00l?3`000000000000[:b/0kNg]0?kn
oP3oool0o_kn0?ooo`80o_kn00H0oooo0?gmo@3moOd0oooo0?knoP2VYZH20?ooo`0<0?KfmP3oool0
oooo0?gmo@3oool0no_k0?ooo`3moOd0oooo0?_kn`3lo?`0Jf][0P0000000`0>3Ph0gMgM0?KfmP02
0?ooo`030?_kn`3oool0oooo0380oooo00@0o?cl0?[jnP3oool0oooo0P3no_h0103oool0o_kn0?oo
o`3inOT20?ooo`030?knoP3moOd0oOgm00P0oooo00<0SXj>05aLG03oool00P3oool20?_kn`0]0?oo
o`3no_h0oooo0?ooo`3kno/0oooo0=7Ad@0W9bL00@4105EEE@2j^[X0?Shn0:JVYP3kno/0o?cl0?oo
o`3ooOd0oo_j0?omn`3no_`0o?om0?Ohn03`l>h0]kFd0:BRX`3oo_l0n?Om0?omo`3oool0Phb501<J
4`3`j^X0oo_n0?omo`3inOT0inOW00d=3@3no_h0no_k0?ooo`3lo?`0oooo0?gmo@3oool0o_kn00<0
oooo00P0no_k0?clo03no_h0Hf=S00410@0E5AD0P8200=oOg`80oooo00H0n_[j0?ooo`3lo?`0oOgm
0?ooo`3moOdF0?ooo`0000`0oock0?olo03oo_l0nooo0?Klo03jnod0oo[o0?g^l`3ooOX0n_[f0?Cm
o`3hool20?omo`0:0?OhnP3kooh0o_oo0?ooo`1OGel0X:2P0?gmo@3no_h0oooo0?knoS00oooo00<0
moOg0?ooo`3oool00P3oool00`3moOd0oooo0?ooo`020?ooo@L0oooo02L0o?cl0?ooo@3oood0ooom
0>o_k@2c/jl0KfYR07m_G`2WWI<0000B0>Kdo`3ko?l0o_[o0?olo`3oo_l0oooh0?[kl@3iool0nooo
0?kmmP3ooOH0ooko0?gno`3mo?l0oooo0?_kn`2d];@00@4100L71`0?3`l0e=CD0;Fe]@1PH600410@
03Ph>027QhL0clo?0?ooo`3fm_H00P3oool00`3kno/0oooo0?[jnP020?ooo`040?Shn03no_h0n?Sh
0?clo0<0oooo00h0oOgm0?Win@2i^KT0LW9b07MgM`37alL0oOgm0?ooo`3kno/0oooo0?clo03jn_X0
no_k0?knoPD0oooo00d0no_k0?ooo`3no_h0o_kn0?ooo`3AdM404a<C00410@000000GEeM0?ooo`3k
no/0nOWi0080oooo00L0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0080n_[j0P3oool00`3inOT0
o_kn0?ooo`030?ooo`080?_kn`3jn_X0Zj^[0000000:2PX0000009bLW03inOT30?ooo`040?knoP3o
ool0oooo0?knoS00oooo00P0no_k0?ooo`3oool0oooo0?gmo@3no_h0oOgm0?[jnP@0oooo00<0lO7a
0?ooo`3oool02@3oool02@3^k^h04a<C0>SXj03hn?P0oooo0?knoP3oool0n?Sh0?_kn`020?ooo`0@
0?gmo@3oool0oooo08J6QP000000Jf][038b<P000000RHV90?Shn03oool0o_kn0?ono`3oo?`0oogm
0?omo080o_ok00l0ooom0?ono`3hm_T0oOko0?koo`3on_h0L6ia02da<03WjnP0oogm0?okn`3oo_l0
oooo079bLP1cLg<00P3moOd05`3oool0o_kn0?ooo`3lo?`0oOgm0?ooo`3no_h0n?Sh0?ooo`3moOd0
oooo0=[JfP0C4a<0ADE509BDU01XJ6P06ATI04a<C02l_;`0oooo0?_kn`3oool0m_Kf01P0oooo0000
0`3oo?d0oo_k0?_loP020?_oo`0C0?[kn`3onod0oo[m0?olo`3ko_l0n?oo0?SnoP3oo?l0oogo0?co
o`3kool0o_oo0?gmo@0m?Cd0`/;20?knoP3moOd0oooo0?knoP0a0?ooo`070?knoP3clo<0oooo0?oo
o`3moOd0oooo0?clo0020?ooo@H0oooo0P3no_h0503oood0o?cj0?Wim`3oood0oook0?ckmP3kn>d0
S8V204Q7C@1`KW/0_k[:0?ojo`3oo?l0oogo0?gnmP3looH0look0?3jm`3oooH0ookf0`3oo_l20?oo
o`0A0?Win@3GemL02`/;0000001VIVH0oOgm0?KfmP3lo?`0`L71069RHP0Z:RX071`L07MgM`36a/H0
mOGe0?clo03oool00P3lo?`0103no_h0oooo0?ooo`3no_h20?ooo`030?[jnP3oool0oooo0080oooo
00<0n_[j0?ooo`3<c<`00P1_Kfl00`2n_[h0n?Sh0?ooo`030?ooo`050?knoP3oool0oooo0?Win@3l
o?`00P3oool01P3no_h0oooo0?ooo`3oool0Xj>S00820P80000000D0WinO0?ooo`3lo?`0n_[j0?_k
n`030?ooo`040??cl`3oool0oooo0?;blP<0oooo00H0o?cl0?Shn03oool0oooo0?gmo@3gmoL20?oo
o`060=gMg@0820P000000000001MGEd0oOgm0P3oool00`3lo?`0o_kn0?ooo`0e0?ooo`80o?cl00<0
oOgm0?ooo`3oool00P3oool01`3hn?P0no_k0?gmo@3oool0n_[j0?ooo`3fm_H02@3oool00`1RHV80
P8200?ooo`020?ooo`0V0?Gem@3oool0oooo0?ooo`3no_h0oooo0?gmo@3oool0Y:BT0000001<C4`0
GUiN05mOG`1MGEd02PX:00l?3`35aLD0oooo0?ono`3ln_d0oo_k0?oon03Fe/T0U9><0?gko`3lo_l0
lOKi06U]JP3onod0RhB90?_hoP3al?D0ookm0?gln03lo?X0moOg01PH603Jf]X20?knoP<0oooo00D0
oOgm0?clo03oool0o_kn0?_kn`030?ooo`0;06=SH`1kNg/0H61P09RHV03oool0kno_092@T00W9bL0
<C4a09BDU03`l?000P3oool00`3fm_H0n_[j0?ooo`0D0?ooo`0001H0oogm0?ono@3moOd0o?go0?co
o`3oool0oocj0?ogmP3ooOl0o?oo0>kfmP3lood0oogm0?oio03lool0m_ko0?koo`3oool061PH0>?S
h`3oool0oOgm<P3oool0203kno/0oooo0?ooo`3lo?`0b/[:0>;RhP3inOT0o_kn0P3oood70?ooo`03
0?knoP3oood0ooom0080ooom00`0lo?_0>3Pg02LViH0o_[f0?okoP3/i^d0FUaV07UkR01QGVl0/Zjh
0?Kel03nooP20?Soo`070?oomP3mn_40n_Gi0?omo`3noOl0no_k0?gmo@020?ooo`0@0??cl`0/;2`0
00000>g]k@3oool0o_kn0?ooo`3gmoL0oooo0=;BdP1nOWh0;Bd]01PH601UIFD0[jn_0?clo080oooo
00<0n?Sh0?gmo@3oool00`3oool01`3kno/0n?Sh0?ooo`3jn_X0oooo0?KfmP3moOd00P3oool01@3D
e=@0N7Qh06][J`2][Jd0j^[Z0080oooo0100o?cl0?gmo@3oool0oooo0?[jnP3lo?`0o_kn0??cl`3o
ool0oOgm0?ooo`1RHV800@4100<30`0;2`/0clo?0`3oool01`3lo?`0oooo0?[jnP3oool0o_kn0?oo
o`3jn_X00P3oool00`3jn_X0oooo0?ooo`020?knoP<0oooo00H0kNg]02d];@071`L00P8202@T903f
m_H20?ooo`060?clo03moOd0oooo0?ooo`3moOd0o_kn<@3oool00`3kno/0oooo0?ooo`020?ooo`04
0?clo03kno/0oOgm0?[jnP80oooo00<0j>SX03dm?@2GUiL02`3oool02@3De=@0820P0?[jnP3lo?`0
o_kn0?ooo`3jn_X0oooo0?[jnP030?ooo`0N0?Win@2BTY8030`<00820P0E5AD0PH6102<S8`000000
10@4028R8P0/:bh0TY>G0?glo`3lmoT0oogj0?onk@1ADD@0f=SR0?Wlo`1iP8@0/kNf0?omo`3oo?l0
ooWo0?ono`3oool0nogj0?ooo`2YZJT0?Cdm0P3oool0103moOd0oooo0?knoP3no_h50?ooo`080?_k
n`3oool0h^;R01DE5@3Ti>@0RXZ:07EeM@3no_h30?ooo`050;Zj^P1FEUH0410@06MWI`3>c/h05`3o
ool0000E0?_mn03nood0oooo0?_io03lnol0oooo0?oon03oo_X0ooco0?klo`3kool0mocf0?olo@3o
no`0o?oo0?Woo`3mo_h0oOgm00H61P3hn?P0oooo0080o_kn<P3oool01@3kno/0n?Sh0?Ogm`0E5AD0
gMgM0080oooo0P3oood70?ooo`030?clo03moO/0ooom0080ooom01@0oook0?chm@1MDE40fLg=0?om
o@1lQ8@0XkJj0?;oo`3noOl0f]3I08MmO01_JFL0WJ2T0>S`l03looP0oOog0?ono`3ooOl0no[m0?oo
o`80oOgm00T0no_k0?ooo`3emOD01PH604=3@`3oool0o_kn0?[jnP3oool00P3kno/02@3oool0o?cl
0>CTi02<S8`0>c/k00`<301ADE40VIVI0?Win@020?ooo`030?Win@3hn?P0oooo00<0oooo00<0oOgm
0?ooo`3oool00P3oool02@3jn_X0oooo0?gmo@3oool0g=cL08f=S@1YJFT0XZ:R0>WYj@030?ooo`05
0?gmo@3oool0oooo0?ooo`3jn_X00P3oool01P3alO409bLW00<30`000000=cLg0?Cdm0D0oooo00D0
m_Kf0?_kn`3no_h0Fe]K0?Shn0020?knoP80oooo00/0o?cl0?ooo`3inOT0o?cl0?Win@1eMGD00000
00820P061PH0cLg=0?ooo`020?gmo@@0oooo0P3no_hc0?ooo`030?knoP3kno/0oooo0080oooo00P0
no_k0?ooo`3lo?`0oOgm0?ooo`36a/H0TI6A0?[jnPT0oooo00H0oOgm0?ooo`0j>SX0YjNW0?ooo`3n
o_h20?ooo`040?knoP3oool0oooo0?Shn080oooo01l0Q8B400L71`0820P0000000820P051@D0?3`l
0?Win@3lo?`0_Kjn055EEP0=3Q80IfA[0=WDe03oonl0iNKF04=7B01ZL7/0DUIQ0?Ggo`3oo?l0oo[l
0?omn`3oo_/0lO;d0?coo`3nool0?Shn0:ZZZP3moOd0oooo0080o_kn103oool0303kno/0o_kn0?oo
o`3hn?P0oooo0861P@1YJFT0oooo09nOW`1LG5`0oooo0?Shn0<0oooo00H0oOgm0>GUi@22PX80820P
03Ti>@3jn_XE0?ooo`0000<0nOoj0?con`3oo_l00P3oo?l01`3oo_l0n?oc0?comP3on_l0o?Gl0?co
o`3ho?/00P3oo?l01@3koo`0n?oj0?cmo@3Xj>P05ADE0080oooo00<0o_kn0?clo03oool0<`3oool0
1@34a<@0=CDe0?ooo`3oool0o_kn0080ooom203oool06P3oood0o_kl0?clnP3lo?X0oOgi0?omnP3/
g=X0GU1?0<k=d01?FEh0j_oo0?7oo`3nnol0ooSn0?olo`3oo?h0g]gS08jAU@1PIEl0VYbF0>SXj03l
n_d0oooo0?[jnP3oool0o_kn0P3oool00`3kno/0oooo0?ooo`030?ooo`060?[jnP3oool0oooo0?kn
oP3oool0o?cl0P3oool02`3^k^h0WinO05EEE@061PH0@D5108f=S@3Vi^H0oooo0?gmo@3jn_X0oooo
0080no_k00@0nOWi0?knoP3lo?`0o_kn0`3oool02@3no_h0no_k0?clo03oool0j>SX09JFUP1`L700
Shn?0>3Ph0020?ooo`0<0?Shn03oool0no_k0?ooo`3lo?`0oooo0=OGe`020P80000000H61P1bLW80
nOWi0P3oool01P3jn_X0o_kn0?ooo`3oool0o?cl00410@<0oooo00d0no_k0?clo03oool0oooo0?Wi
n@3oool0ZJVY000000051@D0000009VIV@3kno/0o?cl00@0oooo00D0oOgm0?ooo`3oool0oooo0?gm
o@0a0?ooo`040?clo03no_h0oooo0?ooo`80o?cl00<0oooo0?_kn`3oool00P3jn_X00`3kno/0CTi>
0?Win@090?ooo`060?knoP3oool0ZZZZ03lo?`3no_h0no_k0P3oool01`3kno/0oooo0?ooo`3lo?`0
oooo0?knoP1/K6`00P0000007P0:2PX02@T904i>CP3jn_X0oOgm0?knoP3oo_l0o_oo0=oPi028QhX0
6ALF03De:@2KWI00>T0l00031`3ViO80ooco0?Wio`3no_h0oogj0?gimP3nool0o?oo0=SGfP0K6a/0
n?Sh0?knoP3moOd0oooo0?gmo@80oooo00<0o?cl0?ooo`3moOd00`3oool0403/k>`01@D50=kNgP3o
ool0_Kfm03Ti>@3no_h0oooo0?Win@3moOd0oooo0?knoP3kno/0oooo0?Win@2YZJTF0?ooo`0001@0
mOod0?Cnl`3ooOl0oo[o0?oio`3ooOl0l?oa0?CokP3ooOP0oo_m0??gn03ko_l0ooSo0?oko`3kooT0
nOof0?goo032`/80?3`l0?knoP80oooo00<0oOgm0?ooo`3oool0;`3oool0203no_h0o?cl0?knoP1^
KVh0Q8B40?ooo`3jn_X0oooo0P3oood60?ooo`040?clo03oool0ooom0?gmn`80ooom01P0oook0?oo
n03oo?40[JBM00003@3KhoD0n?oo0?gno`3onoT0oogj0?Gmo@3gool0oO_o0?gjo`3oo_l0hn?Q09jL
V`1XIVD0RXZ:0>7Qh@3oool0o_kn0?Gem@3lo?`30?ooo`0E0?Win@3oool0oooo0?clo03oool0oOgm
0?ooo`3jn_X0oooo0?[jnP3gmoL0oooo0?gmo@3oool0n_[j0;6a/@1OGel06ATI02LW9`1mOGd0emOG
00D0oooo00@0no_k0?knoP3oool0o?cl0`3oool20?gmo@080?ooo`3moOd0moOg0?Ogm`2TY:@0Jf][
08R8R03IfMT20?ooo`050?Win@3oool0oooo0?Win@2BTY800P000000100;2`/0/k>c0?ooo`3inOT3
0?ooo`050?[jnP3oool000000?_kn`3moOd00P3oool02@3jn_X0o_kn0?Shn03oool0fm_K01<C4`01
0@40000005=CD`020?ooo`070?_kn`3oool0o_kn0?knoP3moOd0o?cl0?knoP0c0?ooo`030?gmo@3o
ool0oooo00<0oooo00<0o?cl0?Ogm`3gmoL00P3oool01@3lo?`0no_k06MWI`3WinL0nOWi00P0oooo
00X0o?cl0?ooo`3clo<06QXJ0=_Kf`3moOd0oooo0?gmo@3lo?`0o_kn0`3oool07@3lo?`0A4A400@4
100000002PX:05QHF03jn_X0oooo0?[jnP3oool0ooko0?olo`3kn_l0o?oh0?comP2`/K40414C0004
001KGEX0f];M0?oio`3kool0m_go0?koo`3oo_l0oooo0?clo01bLW80M7Ad0080oooo00H0o_kn0?oo
o`3moOd0oooo0?knoP3moOd50?ooo`0708V9R@1TI6@0oooo0?KfmP3^k^h0IfMW0?clo0030?ooo`06
0?[jnP3moOd0oooo0?ooo`3inOT0no_k5P3oool0000D0?Oom03go_@0oogo0?oho`3om?l0oogo0?Go
n03goo<0oo_c0?ohm`3nool0noko0?ojo`3oo?l0o?kh0?_omP3nood0Y:BT05eMG@3jn_Xe0?ooo`04
0?clo03oool071`L0=?Cd`80oooo00<0o?cl0?ooo@3oood01P3oool0103no_h0oooo0?ooo@3moO/2
0?ooo@0:0?gmn`3noOH0ooka0?okm@3Ef>D0n?oo0?Ogo`3ooOl0ooch0?kil`80mOoo00/0o_co0?oj
o`3ooOl0o_kn0?kln`3ooo/0kno]0:JVYP1]KFd0Ogmo0=WIf@020?ooo`030?_kn`3oool0oOgm00L0
oooo00L0o?cl0?ooo`3oool0n_[j0?ooo`3jn_X0o_kn0080oooo00d0mOGe0<O7a`1gMgL07alO020P
801/K6`0^k^k0?Win@3oool0oOgm0?ooo`3lo?`0o_kn0080oooo00@0no_k0?ooo`3oool0n_[j0P3o
ool0203moOd0o_kn0?gmo@3fm_H0[Zj^06a/K01nOWh0dm?C0P3oool01`3no_h0oOgm059BDP020P80
000001LG5`3UiND0103oool20?knoP0600410@3oool0o?cl0?knoP3oool0no_k0P3oool02`3dm?@0
<C4a000000000000:2PX0?;blP3kno/0oOgm0?ooo`3lo?`0o_kn00<0oooo00<0o_kn0?clo03no_h0
<@3oool0403no_h0oooo0?clo03gmoL0oook0?[im@28QXL0108305aLFP21PGl0no[m0?koo`3mo_h0
`<7109jOX@3nool90?ooo`060?Win@3oool0Q8B406QXJ03no_h0oOgm0P3oool0303kno/0oooo0?_k
n`3no_h0oooo010@400000001`L704E5A@3no_h0oooo0?_kn`80oooo01<0oOco0?gio`3oo_l0n_od
0?Wom03[k_80SHfC0=cNf`1kNWH07aPO048lAP2Y[K@0l__n0?koo`3kn_d0ooko0?Kdl`0A4A40inOW
0080no_k0P3oool03P3no_h0oOgm0?knoP3oool0o_kn0?ooo`3lo?`0oooo0?Cdm00G5aL0eMGE0?Og
m`3oool0n_[j0P3oool01`3gmoL0ooom0?ooo`3moOd0oooo0?Win@3kno/00P3oool00`3kno/0oooo
0?ooo`0C0?ooo`0001@0o?ok0?koo@3oo_l0ooko0?olo`3oo_l0o?om0?con`3ooo/0oogm0?clo03n
ool0oogo0?ono`3moO/0o_ok0?ooo`2LW9`0HV9R0?ooo`80o_kn<P3oool01@3no_h0no_k0=GEe@0P
8200oOgm0180oooo00D0ooom0?onnP3oo_d0o_oo0?coo`020?ono`040?omo@3oo_d0o?oo0?coo`<0
ooko0P3oool02P3oood0oooo0?[jnP3oool0m_Kf0:f][@1VIVH0OGem0<S8b03lo?`20?ooo`030?gm
o@3oool0oooo0080oooo00@0n_[j0?ooo`3oool0oOgm103oool0403moOd0o_kn0?ooo`3oool0o?cl
0?ooo`3EeMD0Q8B403De=@0B4Q80GEeM0:^[Z`3`l?00oooo0?knoP3lo?`80?ooo`0@0?_kn`3oool0
o_kn0?_kn`3oool0n?Sh0;^k^`1eMGD0OGem0<C4a03moOd0jNWY02<S8`0000000`<30410@080oooo
00D0o?cl0?ooo`3oool0no_k0:ZZZP020?ooo`0<0?Shn03oool0oooo0?knoP3oool0LW9b00000002
0P801PH60<g=c@3oool0o_kn0P3oool00`3no_h0oooo0?ooo`0f0?ooo`0A0?koo`3in_X0ooko0?on
o@3oo?<0m_7Y01TB5@3Gd]H0oooh0<g>b039bLl0mo[o0?coo`22QXD0B4]@0?Wlo`3nool0203oool0
1`3hn?P0oooo0>GUi@0:2PX0m_Kf0?ooo`3no_h00P3oool0303hn?P0oooo0?ooo`3WinL0000000H6
1P0>3Ph0l_;b0?ooo`3moOd0oooo0?gmo@80oooo0140o_go0?ono`3noo/0o_ok0?[ko@3kn_d0oooo
0?kno03ln_d0YjFX03dn@00H71d0NWUl0>3Ph03oool0Shn?04i>C0020?kno0090?ooo@3oool0oooo
0?ono`3noOl0ooko0?glo`3oo_l0o?_n0080oooo00@0S8b<05ADE03nool0oooo0P3oo_d01P3oo_l0
o_go0?koo@3noo/0ookm0?ono`80oooo0P3nool00`3oool0ooko0?ooo`0D0?ooo`002@3oool0103n
o_h0o?cl0?ooo`3kno/20?ooo`040?clo03no_h0UYJF06QXJ080oooo00<0o_kn0?ooo`3no_h0<@3o
ool01P3moOd0PH61071`L03no_h0oooo0?WinB<0oooo00H0no_k0?Win@3oool0oooo0>_[j`31`L42
079bLP090;Zj^P3oool0oooo0?KfmP3oool0oOgm0?ooo`3lo?`0mOGe0080oooo00<0no_k0?clo03o
ool00P3oool03@3inOT0o?cl0?ooo`3oool0o?cl0?ooo`3jn_X0hN7Q09JFUP1=CDd0410@0=3@d03g
moL02@3oool0103no_h0oooo0?ooo`3no_h20?clo00;0?_kn`3hn?P0n_[j0<S8b01kNg/0MGEe07em
O@071`L0000000H61P25QHD00P3oool0303kno/0n_[j0?ooo`3moOd0oooo0?gmo@3oool0nOWi0?cl
o03no_h0[Zj^00L71`80000000<0U9BD0?Gem@3kno/00P3oool00`3jn_X0oooo0?ooo`0f0?ooo`<0
o_oo00l0n_Wl0?cgm`3oo_@0n_?Y01lF6@3PfM`0ookg0?kon@3no_l0o?ko0?Smo`3kool0koCh0?co
o`3nool02`3oool00`1HF5P0Shn?0?ooo`040?ooo`070?clo03moOd0/K6a00`<30000000a<C40?Ge
m@020?ooo`060?knoP3oool0oooo0?gmo@3inOT0O7al0P3oool00`3jn_X0oooo0?ooo`020?ooo`0@
0?_kn`3oool0eMGE06m_K`0A4A4071`L00`<302b/[00ooom0?_kn@3no_`0oooo0?gmo@3lnoh0ooko
0?kmo`80ooko00L0oOco0?clo03moOd08B4Q0<C5a@3lool0o_oo0080oogm00d0ooko0?koo`3kood0
o?ok0?omo@3oo?l0ooko0?koo`3kool0o?oo0?ono`3ooOl0ooko01@0oooo00080?ooo`040?clo03o
ool0oOgm0?gmo@80oooo00D0n?Sh0?ooo`3moOd0S8b<079bLP040?ooo`030?gmo@3oool0oooo02h0
oooo00P0D51@0?ooo`0h>3P0^[Zj0?ooo`3inOT0oooo0?[jnR00oooo00H0oOgm0?ooo`3oool0o_kn
0?Win@3kno/20?ooo`070?knoP3moOd0c<c<07YjNP1YJFT0][Jf0?[jnP030?knoP80oooo00@0o?cl
0?ooo`3oool0nOWi103oool0103moOd0oooo0?ooo`3lo?`20?ooo`060?clo03moOd0;2`/0;Zj^P3o
ool0o_kn2@3oool00`3lo?`0no_k0?ooo`050?ooo`050?Shn03oool0no_k0=[JfP0j>SX00P000000
1`061PH0_[jn0?ooo`3oool0n?Sh0?ooo`3inOT00P3oool02@3lo?`0oooo0?_kn`3Xj>P04Q8B0000
00020P80FUYJ0?[jnP030?ooo`030?knoP3oool0o_kn03L0oooo00d0o_oo0?Kgn@3nool0o?_n0?om
o@3ono<0ookf05YDDP2HTY80ookj0?oon`3OgnD0n?_o0080nooo0P3hnol00`3nool0oooo0?ooo`07
0?ooo`040?[jnP3moOd0`<3002d];@<0oooo00L0n?Sh0?[jnP3moOd0oooo04a<C0051@D0LG5a00<0
oooo00T0no_k0?ooo`3gmoL0oooo0>[ZjP0d=3@0N7Qh0?ooo`3moOd00P3oool03P3clo<0o?cl0?[j
nP3oool0moOg0:NWY`0n?Sh06ATI04i>CP1YJFT0no_i0?ooo@3jn_P0ooom0P3oool0103kn_d0ooko
0?kmo`3mo?l20?ono`0E0?ooo`2MWId0?clo0?koo`3iool0o?oo0?oknP3ono/0ooko0?_oo`3hool0
nooo0?omo@3onod0oogm0?koo`3gool0n?oo0?omo`3oo?d0ooko01@0oooo00090?ooo`040?knoP3o
ool0o_kn0?Ogm`80oooo00@0m_Kf0?knoP20P800OWin103oool00`3no_h0oooo0?ooo`0^0?ooo`07
02d];@2m_Kd01`L70?ooo`3inOT0oooo0?Cdm00R0?ooo`80no_k0`3oool20?clo00<0?gmo@3oool0
n?Sh0?Shn03oool0clo?08B4Q01ZJVX0Y:BT0>o_k`3oool0moOg0P3oool0103hn?P0oooo0?clo03j
n_X20?ooo`050?_kn`3moOd0oooo0?knoP3jn_X00P3oool01@3Rh^8061PH0?gmo@3oool0o?cl00P0
oooo00@0o?cl0?ooo`3oool0oooo0P3moOd00`3kno/0nOWi0?gmo@020?ooo`090?gmo@3oool0oooo
03Lg=`0000000P8201PH602FUYH0iNGU0080oooo00@0mOGe0?ooo`3inOT0o_kn0P3oool0300k>c/0
00000000000O7al0i^KV0?ooo`3moOd0oooo0?clo03gmoL0oooo0?clo3L0oooo0`3nool03`3kno/0
noOd0?onn03ooOP0k>KT00D1003LfmL0f][H010A5@3io?l0nooo0?KkoP3ko_l0o?oo0?ono`070?oo
o`090?knoP3oool0oooo0?ooo`3no_h0:b/[0;>c/`3oool0o?cl0080oooo00T0o_kn0?ooo`030`<0
10@40?KfmP3moOd0no_k0?ooo`3inOT00P3oool0203Xj>P061PH08:2PP3oool0nOWi0?[jnP3oool0
nOWi0P3oool01@3bl_80RHV902<S8`0i>CT0];Bd00<0oooo00@0ooom0?[jn03moO/0ooom0P3oool0
6`3oo_l0o?_n0?ono`3mo?l0no[m0?ono`3no_h0:RXZ0<;2`P3ko?`0nOoo0?coo`3onoX0oo_k0?on
o`3kool0n?oo0?_oo`3ooOd0oock0?omo@3nool0mooo0?Soo`3ooOl0oocm0?ono`0D0?ooo`00203o
ool00`3no_h0n_[j0?ooo`020?ooo`060?Win@3oool0oooo0?ooo`1cLg<0RXZ:0P3no_hc0?ooo`03
04E5A@1XJ6P0HV9R02P0oooo00<0o_kn0?ooo`3oool0103oool03P3moOd0oooo0?ooo`3lo?`0moOg
0?ooo`3Jf]X0T92@06EUI@2OWil0jNWY0?knoP3moOd0o_kn0P3oool01@3jn_X0n?Sh0?ooo`3oool0
n?Sh0080oooo00H0n_[j0?ooo`2ATI40F5QH0?ooo`3inOT90?ooo`060?clo03oool0oooo0?clo03h
n?P0oOgm103oool01P3no_h0o?cl0?ooo`3lo?`0g]kN01DE5@80000000H0BTY:096AT@1eMGD0Ti>C
0>g]k@3lo?`30?ooo`07071`L00000001@D500P82037alL0oooo0?_kn`020?knoP030?ooo`3no_h0
oooo03P0oooo0P3nool00`3fmoL0ooom0?onn`020?omnP050?okn03Zi^<0Hf5P07AdM01^Kg<00P3k
o_l0103hnol0o?oo0?[mo`3oo_l70?ooo`0:0?knoP3oool0o?cl0?ooo`3hn?P0Vi^K05MGE`3moOd0
oooo0?clo080no_k00<0aLG50000002QXJ400`3oool01P3no_h0oooo0?gmo@3gmoL0]kNg0;bl_080
oOgm0P3oool03`3moOd0oooo0=CDe01XJ6P04Q8B05YJFP3>c/h0oooo0?Win@3kno/0oooo0?gmo@3n
o_`0ooom0?ooo`020?knoP030?_kn`3oo_l0ooko0080ooko01L0oOgm0?ooo`2_[jl0>CTi0?ShmP3n
ool0o?oo0?koo`3oo_/0oogj0?ono@3nool0nooo0?coo`3oo_/0oogj0?oon`3nool0nooo0?coo`3o
o_d0ookk0?ono@0D0?ooo`002`3oool02P3kno/0oooo0?knoP3no_h0moOg0?ooo`1WIfL0UYJF0?gm
o@3no_hc0?ooo`07069RHP0/;2`0Zj^[0?clo03jn_X0oooo0?gmo@0Q0?ooo`030?gmo@3lo?`0oooo
0080oooo00D0n_[j0?Shn03kno/0o_kn0?gmo@020?ooo`040?knoP3oool0oooo0?Win@80oooo00P0
n_[j0>;RhP2HV9P0HV9R09BDU03WinL0m_Kf0?clo0<0oooo00P0o?cl0?knoP3oool0oOgm0?ooo`3g
moL0A4A40;6a/@80oooo00<0no_k0?ooo`3oool01`3oool00`3moOd0o?cl0?ooo`020?ooo`040?gm
o@3jn_X0oOgm0?clo080oooo01L0n?Sh0?ooo`3oool0Z:RX00H61P010@401@D50:JVYP3inOT0k^k^
09bLW01^KVh0SXj>0=oOg`2b/[801`L700410@020P80P8200?ooo`3inOT0oooo0?knoP030?ooo`03
0?[jnP3oool0oooo03H0oooo0180o_oo0?[kn`3nool0n_[j0?oon`3on_@0oogg0?olo03nnOT0oook
0?koo@3no_l0mOSm0?_no`3kool0o?oo0?koo`3oo_l80?ooo`0C0?KfmP3oool0nOWi0?ooo`3fm_H0
2PX:0>KViP2FUYH0GUiN075aL@1bLW80?Cdm01`L703oool0n_[j0?knoP3lo?`0oooo0?clo0020?oo
o`0;0?[jnP3gmoL0oooo0?_kn`3lo?`0nOWi0;jn_P12@T807AdM07]kN`3]kNd00P3lo?`0203hn?P0
oooo0?ooo`3lo?`0oooo0?kno03oood0oOgm0P3oool01@3inOT0ooko0?ono`3oo_l0o?_n0080oooo
00@0;Rh^0:f]Z`3lo?X0oooo0P3oo_l0103ooo/0oooj0?ooo@3noOl20?omo`040?oon`3oooP0oook
0?ono`80o_ko00<0ooom0?oon`3oood0503oool000P0oooo00@0oOgm0?[jnP3oool0o_kn0`3oool0
1@3no_h0oooo05eMG@2PX:00o_kn03@0oooo00<0JFUY00d=3@3YjNT0103oool00`3moOd0oooo0?oo
o`0N0?ooo`030?_kn`3oool0oooo0080n_[j203oool20?[jnP030?ooo`3no_h0o?cl0080oooo01<0
o?cl0?ooo`3/k>`0W9bL06YZJP2;Rh/0dm?C0?ooo`3no_h0no_k0?ooo`3jn_X0oOgm0?ooo`3/k>`0
4a<C0?KfmP3oool0o_kn00X0oooo00D0o_kn0?ooo`3oool0oooo0?clo0050?ooo`060?clo03oool0
oooo0?Gem@3oool0HV9R0P0000002`030`<0fMWI0?ooo`3oool0o_kn0?Cdm02IVIT020P800000006
1PH0ATI60080oooo00H0o?cl0?ooo`3jn_X0oooo0?clo03oool20?knoSL0oooo0`3nool03`3oo_l0
n_Si0?onm03ooO<0JF=Z0?cfo@3oooH0m?O^08V9T`3Be>00o?oo0?coo@3fmo/0o_oo0?ono`090?oo
o`0<0?Shn03oool0oooo0?ooo`1WIfL0:BTY0=7Ad@3oool0n?Sh0>?Sh`1lO7`0k^k^0`3oool0403h
n?P0h^;R09^KV`3moOd0oooo0?_kn`3oool0oOgm0?clo02EUID0:RXZ02l_;`2LW9`0mOGe0?ooo`3h
n?P20?ooo`080?clo03oool0oooo0?knoP3lo?`0oOgk0?kno03lo?`30?ooo`0F0?glo`3noOl0oooo
0?gmo@3oool0^k^k02/[:@3knoT0ooom0?_kn@3ooOl0ooko0?koo@3noo/0oOgi0?gkoP3onOl0ooco
0?kon`3looH0o_ok0?ono`80ooco00<0ooom0?konP3oood0503oool000P0oooo00<0n_[j0?ooo`3f
m_H00P3oool01P1XJ6P0CTi>0?ooo`3oool0F5QH0:FUY@@0oooo00<0o_kn0?ooo`3oool0;P3oool0
1P14A4@00000055AD@2QXJ40kNg]0?gmoB<0oooo00@0oOgm0?knoP3oool0oooo0P3lo?`01@3no_h0
oOgm0?knoP3moOd0o_kn0080oooo0P3no_h20?ooo`040?gmo@3oool0o_kn0?Win@<0oooo00D0k^k^
0:n_[`1[Jf/0MgMg0<_;b`030?ooo`070?clo02KVi/0EEEE0?ooo`3no_h0oooo0?gmo@0;0?ooo`80
o_kn0P3oool0103lo?`0oooo0?[jnP3no_h20?ooo`0E0?_kn`3oool0oooo0?KfmP0/;2`0000000<3
0`0[:b/0o?cl0?ooo`3lo?`0n_[j03lo?`010@40000001LG5`1SHf<0P8200<G5a@3oool0oOgm0080
o_kn00@0o?cl0?ooo`3oool0o_kn=`3oool04@3nool0nocl0?koo`3mo?l0ooko0?onm@3ono<0/:^]
08b:S@3nooT0eMOB05QKHP3lo_l0nOgn0?WjnP3nool0o_go00P0oooo00P0oOgm0?ooo`3oool0o_kn
0?[jnP3Cdm<0F5QH01LG5`80no_k0P3oool00`3]kNd0J6QX0?_kn`020?clo00<0<o?c`0N7Qh0/k>c
0?ooo`3moOd0oooo0>?Sh`1iNGT04a<C04m?C`2o_kl0oOgm0P3oool00`3jn_X0oooo0?knoP030?oo
o`050?Win@3oool0o_kn0?ooo@3lo?X00P3oool0603inOT0oooo0?ono`3oo_l0no_k0?ooo`3kno/0
ATI409^KV@3oood0n_[f0?ooo@3no?d0ooko0?koo`3nood0o?gg0?_inP3mn?l0oo_o0?kon`3nooH0
o_ok0?ono`80ooco00<0ooom0?konP3oood0503oool000/0oooo00P0no_k0?ooo`3gmoL0=CDe08j>
SP3moOd0C4a<0;Fe]@80oooo00@0m?Cd0?ooo`3inOT0oOgm0`3oool01@3no_h0oooo0?Win@3oool0
oOgm00<0oooo00D0o_kn0?ooo`3inOT0oooo0?gmo@030?ooo`050?knoP3oool0nOWi0?ooo`3moOd0
0`3oool01@3no_h0oooo0?Win@3oool0oOgm00<0oooo00<0o_kn0?ooo`3inOT00P3oool01@3lo?`0
oooo0?ooo`3jn_X0o_kn0080oooo00T0AdM701dM7@2YZJT0Cdm?00/;2`1:BTX0V9RH0>g]k@3lo?`0
0P3oool0103moOd0oooo0?clo03moOd20?ooo`060?KfmP3oool0oooo0?_kn`3oool0o?cl0P3oool0
103no_h0n_[j0?ooo`3moOd20?ooo`030?gmo@3oool0oooo0200oooo00X0oOgm0?ooo`3hn?P0];Bd
07EeM@1^KVh0`/;20?gmo@1:BTX0YjNW0P3no_h20?ooo`040?gmo@3oool0oooo0?gmo@80oooo00@0
oOgm0?ooo`3oool0oOgm0P3oool00`3no_h0o?cl0?ooo`090?ooo`0@0?clo03EeMD01`L700000001
0@40KFe]0?ooo`3no_h0PH61000000061PH000000;no_`3oool0m_Kf0<O7a`80MgMg00D0^[Zj0?_k
n`3oool0n_[j0?knoP030?ooo`030?clo03oool0o_kn0080oooo00@0o_kn0?gmo@3oool0oooo0P3m
oOd20?ooo`050?clo03oool0oooo0?gmo@3kno/08`3oool20?koo`030?gnoP3no_X0ookj0080oogo
00d0ooof04]:@`3@cmD0<c<k0>KZj@3lood0o_ko0?gmo`3oo_l0n_[h0?clo03oool0oOgm0080oooo
0280n?Sh0?ooo`3jn_X0no_k0?ooo`3lo?`0o_kn0:RXZ02=SHd0oooo04I6AP2OWil0oooo0?clo03o
ool0no_k0>SXj01cLg<0no_k0<W9b@0H61P0/;2`0?knoP3lo?`0cLg=05MGE`0B4Q80LW9b0=KFeP3o
ool0no_k0?knoP3oool0nOWi2@3oool01`3no_h0oooo0?ooo`3lo?`0oooo0?gmo@3gmoL00`3oool0
5`37alD07alM0?gmn`3ooo/0o_kj0?gmn@3nood0oooo0?omo`3jn?T0P85i05]MF022PHl0jNSf0?on
o@3oooP0ookm0?ono`3no_l0oOgo0?kno03oooX0ooom01@0oooo000:0?ooo`0=0?_kn`3oool0oooo
0?_kn`3Ng]h06ATI0<?3``0n?Sh0^;Rh0?knoP3inOT0oooo0?KfmP030?ooo`040?clo03moOd0oooo
0?[jnP@0oooo00@0o?cl0?gmo@3oool0n_[j103oool0103lo?`0oOgm0?ooo`3jn_X40?ooo`040?cl
o03moOd0oooo0?[jnP@0oooo00@0o?cl0?gmo@3oool0n_[j0P3oool00`3hn?P0oooo0?Win@030?oo
o`0?0?knoP3jn_X04A4A018B4P3kno/0oooo0?Ogm`2XZ:P0DU9B00d=3@13@d<0UYJF0>KViP3oool0
m?Cd0080oooo00D0oOgm0?clo03oool0oOgm0?knoP030?ooo`060?_kn`3oool0o?cl0?ooo`3kno/0
o?cl0P3oool00`3lo?`0oooo0?ooo`0N0?ooo`040?gmo@3oool0no_k0?_kn`80oooo00P0nOWi0?oo
o`35aLD0JVYZ00/;2`2/[:`0m_Kf0?knoP<0oooo0P3kno/20?ooo`80o?cl00H0o_kn0?clo03oool0
oooo0?clo03no_h20?ooo`030?Shn03oool0oooo00L0oooo00<0o?cl09VIV@0000000P0000000`2]
[Jd0^k^k00820P020000000408>3P`3oool0nOWi0?ooo`80o?cl00L0oOgm0=?Cd`20P800KVi^0;Vi
^@3gmoL0oooo0080o_kn0`3oool01P3inOT0oooo0?ooo`3oool0mOGe0?gmo@80oooo00D0oOgm0?oo
o`3oool0no_k0?clo0030?ooo`80oOgm803oool00`3nool0oOko0?coo`020?oonP0<0?ojo`3Sg^80
oO[_0>SXgP0000L0[jjk0?WmnP3loo/0nOWo0?omo`3no?d0ookm0P3oool01@3kno/0oOgm0?knoP3o
ool0oOgm00<0oooo00L0nOWi08j>SP2d];@0n_[j0?ooo`2`/;00>3Ph0080o_kn0P3oool03`3inOT0
dm?C09fMW@2=SHd0dM7A0?Shn02][Jd0?Cdm01TI6@2>SXh0k^k^0?clo03oool0o?cl0?Win@020?oo
o`030?clo03oool0oooo00L0oooo00<0o_kn0?ooo`3moOd0103oool01`3kno/0oooo0?knoP1>CT`0
V9RF0?cln03moOT00P3ooo/0303noo/0m_Og0?kjo`3ooOl0n__a0?[lmP3Pgnd0MWF50?omoP3oo_T0
oogl0?kmo`80o_ko00<0ookm0?oon`3oood0503oool000T0oooo00<0m?Cd0?ooo`3oool00P3oool0
1@3moOd0^KVi01DE5@0l?3`0aLG500@0oooo00<0n_[j0?ooo`3no_h00P3oool20?knoP040?ooo`3m
oOd0oooo0?knoP80oooo0P3no_h0103oool0oOgm0?ooo`3no_h20?ooo`80o_kn00@0oooo0?gmo@3o
ool0o_kn0P3oool20?knoP040?ooo`3moOd0oooo0?knoP80oooo0P3no_h00`3oool0oOgm0?ooo`02
0?ooo`070?[jnP3oool0no_k0?clo032`/80=CDe000000020?ooo`0E0?Shn03no_h0oooo0?Shn02g
]kL0D51@018B4P15ADD0RXZ:0>?Sh`3hn?P0oooo0?clo03jn_X0oooo0?gmo@3kno/0oooo0?knoP3o
ool0no_k00@0oooo00<0moOg0?KfmP3oool0803oool0103kno/0oooo0?ooo`3lo?`30?ooo`090?kn
oP3hn?P0[:b/04E5A@3>c/h0Ph>306EUI@2UYJD0lO7a00<0oooo00<0o_kn0?[jnP3no_h00`3oool0
1P3no_h0oooo0?ooo`3oool0no_k0?clo0T0oooo00l0oOgm0?clo03oool0Bd];000000030`<00000
00L71`020P801@D504=3@`3oool0no_k0?ooo`3no_h00P3oool03P3moOd0o?cl0?ooo`3oool0e]KF
08n?S`1YJFT0ZJVY0?;blP3moOd0n_[j0?gmo@3oool0o?cl0P3oool0103kno/0oooo0?knoP3jn_X2
0?ooo`030?_kn`3oool0o_kn00D0oooo00<0o_kn0?ooo`3oool07@3oool20?koo`090?Wmo03oood0
lo?_0:NRXP0=20P0PX5l0?oon`3Ge]/0l?3f0080o?oo00H0o_oo0?ono`3hm_L0ookm0?Win@3dm?@2
0?ooo`030?_kn`3oool0o?cl0080oooo01H0lO7a06a/K03Cdm<0oooo0?gmo@3kno/0oooo01hN7P35
aLD0PH6109RHV03_knl0lo?c0?gmo@2HV9P0ZZZZ08R8R00Q8B40?Cdm0:RXZ03oool0moOg1P3oool0
0`3no_h0oooo0?gmo@0:0?ooo`0<0?[jnP3oool0n_[j0?[jnP3oool0no_k0?ooo`3>c/h06ATG0?Og
m@3ooo/0o_kj0P3oooX0403loOD0ooom0?omo`3no_l0nocb0?oomP2c[kd0AdAE0?kmo`3nood0oooo
0?ono`3ooOl0ooko0?ooo@3moO/E0?ooo`00203oool0F03gmoL0oooo0?ooo`3_knl0emOG0=7Ad@3F
e]H0gmoO07inOP061PH0bl_;0?;blP3GemL0eMGE0=3@d03WinL0oooo0?KfmP3moOd0m?Cd0<[:bP3Q
hN40d=3@0>CTi03oool0m_Kf0?gmo@3dm?@0b/[:0>7Qh@3@d=00i>CT0?ooo`3fm_H0oOgm0?Cdm03:
b/X0hN7Q0=3@d03Ti>@0oooo0?KfmP3moOd0m?Cd0<[:bP3QhN40d=3@0>CTi03oool0m_Kf0?gmo@3d
m?@0b/[:0>7Qh@3@d=00i>CT0?ooo`3emOD0oooo0?3`l03IfMT0f=SH0=;BdP1YJFT0PH6102@T903J
f]X0l_;b0=?Cd`3MgMd0f][J0>7Qh@3moOd0oooo0?_kn`2XZ:P0EUIF01HF5P0];Bd0OGem0>;RhP3o
ool0nOWi0??cl`3Hf=P0dM7A0=GEe@3Zj^X20?ooo`060?Ogm`3clo<0d=3@0=kNgP3De=@0jn_[803o
ool20?gmo@L0oooo00X0FUYJ09nOW`3moOd0no_k0?ooo`3Ogml0QHF505UIF@2SXj<0jNWY0`3oool0
1P3moOd0o?cl0?ooo`3oool0n_[j0?_kn`80oooo0P3lo?`90?ooo`040?[jnP3lo?`0Vi^K00L71`<0
000000`00@4100`<303/k>`0oooo0?knoP3oool0moOg0?ooo`3no_h0oooo0?knoP3inOT20?ooo`0;
0?Win@3oool0i>CT092@T01aLG40X:2P0>g]k@3gmoL0oooo0?clo03kno/00P3oool0103no_h0oooo
0?ooo`3jn_X40?ooo`050?gmo@3jn_X0oooo0?ooo`3lo?`0803oool20?koo`0>0?gmn`3ooo/0n_We
03hj=`0100006a/I0=SGfP3nool0n_go0?coo`3hmoX0ooko0?ono@3ln_T20?ooo`0;0?gmo@3oool0
oooo0?clo03oool0mOGe0=kNgP1UIFD0jn_[0?ooo`3kno/00P3oool04`3jn_X0IVIV0000000?3`l0
410@00410@2HV9P0fMWI06IVIP0410@0EeMG0<o?c`3kno/0o_kn0?gmo@3oool0n?Sh0?Ogm`3jn_X0
0P3oool0103inOT0oooo0?ooo`3inOT90?ooo`040?knoP3lo?`0oooo0?clo0<0oooo01T0nOWi069R
H028R8H0o_kj0?oon`3jnoD0o_oi0?Gdk@3oooH0noWh0?Ceo`3gn_l0o_od0=oOd`0j<Sl0Zj>f0?Ki
oP3kool0o_oo0?ono`3onol0oogo0?koo`3ioO`0o_oo01@0oooo000:0?ooo`0;0?Cdm02n_[h09RHV
02LW9`0/;2`0MWIf0?ooo`0b<S80M7Ad0;Fe]@0U9BD00P0/;2`02P1`L700o_kn0?ooo`3oool0][Jf
03<c<`0O7al0:b/[06i^KP3no_h20?ooo`060;Jf]P0c<c<07alO02/[:`1^KVh0o_kn0P3oool01P2f
][H0<c<c01lO7`0[:b/0KVi^0?knoP80oooo00H0][Jf03<c<`0O7al0:b/[06i^KP3no_h20?ooo`06
0;Jf]P0c<c<07alO02/[:`1^KVh0no_k0P3oool09@2i^KT0;bl_020P800X:2P03Ph>0<o?c`1:BTX0
/[:b0:f][@0c<c<07alO02HV9P1dM7@0oOgm0?ooo`3moOd0_[jn02<S8`0Q8B406a/K02LW9`0>3Ph0
=CDe08n?S`2PX:008R8R02TY:@0[:b/0JVYZ0?ooo`3hn?P0oooo0;Ng]`0^;Rh092@T02/[:`1^KVh0
8@3oool02P3no_h0oOgm0?ooo`3lo?`0nOWi0?gmo@3oool0n_[j0000003_knl20?ooo`0;0?Win@3o
ool0o?cl0?ooo`3Shn<0SXj>05eMG@2DU9@0hn?S0?ooo`3no_h00`3oool20?gmo@030?knoP3oool0
oooo00T0oooo00/0o?cl0?_kn`0X:2P0000000D51@0820P00`<30000002m_Kd0n_[j0?clo0020?oo
o`040?knoP3oool0oooo0?gmo@@0oooo00/0n_[j0?ooo`3lo?`0oooo0?Ogm`3]kNd0X:2P075aL@2@
T900i>CT0?ooo`020?gmo@070?[jnP3moOd0oooo0?ooo`3lo?`0n_[j0?knoP020?ooo`030?clo03m
oOd0oooo0240oooo00`0o_oo0?_lo03lo?X0oook0?kln`3oo_d0DU5=000000061@X0CTiD0=7EeP3k
ool20?ono`040?[hm`3ooO`0oooo0?Cdm080oooo0P3lo?`0103oool0cLg=06a/K03no_h20?gmo@06
0?ooo`3kno/0no_k0?ooo`0_;bl01`L70`0000002@0<30`06QXJ0861P@3Ti>@0Hf=S0?ooo`3kno/0
oooo0?knoP040?ooo`80o_kn00<0oooo0?gmo@3no_h02@3oool02`3no_h0oooo0?ooo`3moOd0o?cl
0?ooo`3jn_X0o_kn0>CThP0;2`T0lo?a0080oook01@0oooj08^<QP010@00RH9g0:NSX0032Ad0g>Gd
0?gol`3hm>H0ooGo03T`@`3YkO@0lO[l0?_oo`3oo_l0ooWk0?oko@3lool0nOoo0?kooa@0oooo0008
0?ooo`80o?cl00<0oooo0?knoP3oool00P3oool01@3inOT0oooo0>OWi`0M7Ad0^k^k0080o?cl00P0
oOgm0?ooo`3moOd0n_[j0?_kn`3oool0nOWi0?gmo@80oooo00H0oOgm0?[jnP3kno/0oooo0?Win@3m
oOd20?ooo`060?gmo@3jn_X0no_k0?ooo`3inOT0oOgm0P3oool01P3moOd0n_[j0?_kn`3oool0nOWi
0?gmo@80oooo00H0oOgm0?[jnP3kno/0oooo0?Win@3moOd30?ooo`040?knoP3oool0oooo0?;blP80
oooo00<0oOgm0?ooo`3no_h00P3oool0203moOd0oooo0?ooo`3no_h0oooo0?gmo@3oool0o?cl1@3o
ool0202o_kl0J6QX00`<300k>c/0P8200=CDe03oool0n?Sh0P3oool00`3moOd0o?cl0?ooo`0S0?oo
o`030?gmo@3oool0oooo00<0oooo00<0o?cl0;6a/@14A4@0103oool00`3emOD0oooo0?[jnP030?oo
o`060>KViP2HV9P0K6a/0820P03Lg=`0kno_0P3oool0103no_h0oooo0?ooo`3gmoL80?ooo`040?Og
m`3oool0oooo03Xj>P800@410P0000003@0:2PX0no_k0?gmo@3oool0oOgm0?ooo`3clo<0o_kn0?_k
n`3no_h0oooo0?clo03hn?P00P3oool0403lo?`0oooo0?clo03oool0oOgm0?[jnP3moOd0l_;b0:VY
Z@1]KFd0QhN70=?Cd`3oool0oOgm0?Shn03no_h30?ooo`050?_kn`3moOd0oooo0?ooo`3lo?`08@3o
ool04@3nool0nocl0?oon`3ooo/0ooko0?cjn`3in?<0EeMC00001@030`/00PH705IJF@2m_<40n_Sk
0?omo@3oo_/0oogl0080oooo00D0o_kn0?clo03oool0WYjN09:BTP020?ooo`0D0?gmo@3jn_X0oooo
0?knoP3moOd0fm_K00`<300000000`<30000000;2`/020P80>o_k`3kno/0oOgm0:NWY`3;bl/0o?cl
0?knoP3oool20?gmo@030?Shn03no_h0oooo0080oooo00<0o?cl0?Win@3oool02@3oool00`3kno/0
oooo0?knoP030?clo00J0?ooo`1]KF/0MWId0?oon`3knoL0oooj0?Sil`1OH5P0`<2f0>CNd0030000
CUA/0;[2e`3noo@0f=C407mcO@0>1AP0k?3k0?;ko`3kool0ooko0?ojnP3onoT0o?oo0?Woo`3noolD
0?ooo`002@3oool00`3moOd0o_kn0?ooo`040?ooo`070?gmo@3oool0aLG500d=3@3WinL0o_kn0?[j
nP030?ooo`060?_kn`3no_h0oooo0?knoP3oool0no_k0P3oool01P3kno/0o_kn0?ooo`3no_h0oooo
0?_kn`80oooo00H0no_k0?knoP3oool0o_kn0?ooo`3kno/20?ooo`060?_kn`3no_h0oooo0?knoP3o
ool0no_k0P3oool0303kno/0o_kn0?ooo`3no_h0oooo0?_kn`3moOd0o?cl0?ooo`3kno/0oooo0?Sh
n0<0oooo00@0oOgm0?[jnP3inOT0o_kn0P3oool02P3no_h0oOgm0?knoP3oool0oOgm0?ooo`3kno/0
nOWi0?ooo`3lo?`30?ooo`070;fm_@1^KVh07AdM02LW9`1lO7`0f=SH0?Ogm`020?ooo`030?KfmP3o
ool0o?cl02<0oooo00T0o?cl0?gmo@3oool0oooo0?clo01QHF40T92@0?gmo@3kno/00P3oool20?kn
oP80oooo0P3lo?`20?ooo`090?Win@3emOD0[Jf]06i^KP1fMWH0b/[:0?knoP3moOd0o?cl00X0oooo
00`0o_kn0?gmo@2TY:@02PX:00D51@00000020P80:NWY`3oool0oOgm0?ooo`3moOd20?ooo`040?_k
n`3oool0o_kn0?knoP<0oooo00D0o?cl0?ooo`3oool0oooo0?Win@030?ooo`80o_kn00`0oooo0?3`
l02j^[X0MWIf07emO@3=cLd0o_kn0?ooo`3gmoL0oooo0?clo03hn?P20?ooo`030?_kn`3oool0oooo
01l0oooo0P3nool04@3ko?H0oook0?[go@3oo_l0oooh0?Kgl@0_;cL00P8<004510000@005aHK018?
5@1dKfl0[j^X0>WWiP3oool0m_Kf0080oooo00<0Ng]k0;Rh^03oool00P3oool00`3lo?`0o_kn0?[j
nP030?ooo`0301/K6`020P8010@40080000000X0LG5a0?gmo@3oool0oooo0=7Ad@2_[jl0oooo0?Og
m`3oool0oOgm0`3oool00`3moOd0nOWi0?ooo`020?ooo`030?[jnP3oool0oooo00L0oooo00<0nOWi
0?knoP3oool00`3oool00`3Rh^8030`:0>g]j`020?oon`80oooj01<0FEYB08j>PP3imnH0YZFP014@
;@3gn?l0o_od0?ook@3km?/0ooSo0?Wko`3kool0o_ko0?ono`3oo_P0oogf0?gnoP3lool0o_oo01@0
oooo00090?ooo`030?clo03oool0o?cl0080oooo00<0o?cl0?ooo`3no_h00P3oool00`2h^;P0MGEe
0?gmo@020?ooo`090?gmo@3oool0oooo0?ooo`3lo?`0oooo0?[jnP3oool0oOgm00<0oooo00D0o?cl
0?ooo`3jn_X0oooo0?gmo@030?ooo`050?clo03oool0n_[j0?ooo`3moOd00`3oool01@3lo?`0oooo
0?[jnP3oool0oOgm00<0oooo00L0o?cl0?ooo`3jn_X0oooo0?gmo@3oool0o?cl0080oooo00@0no_k
0?ooo`3inOT0o?cl0`3oool0103no_h0oooo0?knoP3no_h20?ooo`030?clo03oool0o_kn00D0oooo
00h0no_k0?ooo`3oool0oooo0?knoP38b<P0MGEe024Q8@0T9BL0NWYj0<S7``3ooo/0oooo0?kmo`80
ooko00@0oooo0?ooo@3nool0o_oo0`3oo_l=0?ooo`80o_oo3@3oool01@3no_h0oOgm0?ooo`0C4a<0
hN7Q0080oooo00H0o?cl0?_kn`3oool0oOgm0?ooo`3inOT20?ooo`0<0?gmo@3oool0oooo0?clo03m
oOd0oooo0?Ogm`2j^[X0K6a/079bLP31`L40no_k2@3oool02@3moOd0o_kn0?ooo`2e]KD0?clo02`/
;02/[:`0o_kn0?gmo@020?ooo`80o_kn00<0n_[j0?ooo`3jn_X00P3oool01P3lo?`0oooo0?ooo`3i
nOT0oooo0?knoP80oooo00<0o_kn0?ooo`3lo?`0103oool02P3jn_X0no_k0?ooo`30`<00MgMg07Ui
N@33`l<0n?Sh0?ooo`3kno/20?ooo`050?clo03no_h0oooo0?ooo`3ooOl00P3oo_l30?ooo@H0oooo
0`3oo_l30?ooo`@0o_oo00<0oooo0?ooo@3oool00`3oool20?ono`040?_jo@3oool0o_kj0?kno080
ooko00X0m_O]0?oon03Xj?003`lI00010`000000000400000P050`8030/70P0000001@3oool0l?3`
065QH@3Ti>@0oooo0080o_kn00<0no_k0?ooo`3no_h00P3oool03@3moOd0o?cl0=CDe00A4A402PX:
00`<300m?Cd0oOgm0?knoP3moOd0o?cl06YZJP3Ph>000P3oool01@3no_h0oooo0?clo03oool0oOgm
0080oooo00<0no_k0?clo03oool02@3oool08@3moOd0oooo0?ooo`3kno/0o?cl0?ooo`3moOd0MWIf
06a/K03oood0o?ch0?cmm`3oooX0ookg0<2o^00k>bl0oooa0>k^jP0B3bP0e=;X0?kom`3ooo<0oO_n
0?oko`3noOl0o_ko0?kmo`3oo_l0oooj0?onn@3noOl0o_oo0?ono`0D0?ooo`00H03oool03P3no?/0
o_kn0=;EfP1fMgT09R<J02DR6@1dM780a<G90?gmo`3ooOl0oogl0?knnP3iood0nooo0P3oo?l0103o
oOl0o_co0?ooo`3lo?`20?koo`0;0?[jn03oood0ookm0?gknP3ln_/0ooko0?ooo`3mo_h0nooo0?co
o`3nool0203oool20?knoP070?ooo`3hn?P0oooo0?_kn`31`L40=cLg0?[jnP050?ooo`030?knoP3o
ool0oooo00H0oooo00/0oOgm0?ooo`3oool0o?cl0?ooo`3kno/0_[jn07YjNP1XJ6P0_;bl0?Shn002
0?gmo@@0oooo00D0o_kn0?clo03oool0oooo0?clo0040?ooo`030?knoP3oool0oooo0080oooo00<0
oOgm0?knoP3oool05P3oool04P3De=@0OWin07=cL`2^[Zh0moOg0?ooo`3emOD0oooo0?ono`3knO`0
oo_o0?ojo@3ooOd0nOWe0?konP3mooT0ooom0?ooo`80o?go00P0o_oo0?kno03onO`0ooco0?omo`3m
no`0no[m0?koo`80o?oo00@0noon0?coo`3nood0oook0P3oo_d40?ono`060?Wim`3oood0ooko0?_k
o`3nool0o?kk0P3nooH03@3noOl0e]CM00X6400100D010850000000U9b80G65K09NIUP2a/K40f][J
06QXJ03]kNd00P3oool00`3lo?`0oooo0?ooo`050?ooo`070?knoP3oool0o_kn0;Zj^P3:b/X0oooo
0?Win@020?ooo`0509>CT`3AdM40oooo0?ooo`3gmoL00`3oool0103moOd0oooo0?Shn03no_h20?oo
o`040?[jnP3oool0oooo0?Win@80oooo00H0o_kn0?gmo@3moOd0oooo0?koo@3moo`20?koo`80ooko
0140k>_^01@D503Rh>40ookm0?onnP3noOP0oocc0?oom03nno00H5eD09JET03moOd0E59M09ZHX@3l
o?X0oook0?_jo@050?ono`80oooo0P3oo_lE0?ooo`00H03oool07P3oo_d0oOgm0?Olo`3lool0oogc
0=??``1hN7@0;2ld01XI9P1ZJ7<0alG40?cmm`3anoH0m_kl0?olo`3onol0ooco0?ono`3knOX0oooo
0?GfmP3nool0ooom0?gmn`3no?/0ookm0?omo`3oo_l0o?cl0?_lo080nooo00<0o_oo0?ooo`3oool0
1@3oool02P3moOd0oooo0?_kn`3moOd0oooo0?Shn03oool0J6QX08:2PP3lo?`20?ooo`030?clo03o
ool0oooo00T0oooo00D0o_kn0?ooo`3oool0oOgm0?clo0020?gmo@080?_kn`3oool0b<S807]kN`1/
K6`0[:b/0>k^kP3oool20?clo0<0oooo00<0n_[j0?Cdm02g]kL00P3lo?`0203no_h0oooo0?ooo`3n
o_h0no_k0?knoP3oool0o_kn5`3oool02P3hn?P0oooo0?ooo`3Ng]h0QXJ606][J`2YZJT0kno_0?on
o`3ooOl20?oko`060?omoP3moo`0o_oj0?kon03no_X0no_i0P3nool01@3ko?h0oooo0?olo`3onO`0
oogo0080ooko00H0o_oo0?_no`3iool0n_on0?coo`3nood20?oon`0;0?ono@3oo_l0ooko0?kno`3o
o_l0ookk0?Kel@3en?d0nooo0??gn03jn_H00P3oooH03`3nool0n?Sn07EaO@0;1@l03PT=02h/:`0c
>CD0kO?_0?WjnP31`L40MgMg0?[jnP3oool0moOg0?gmo@080?ooo`050?knoP3hn?P0oooo0?clo03n
o_h00P3oool04`3no_h0RXZ:0;jn_P3gmoL0o_kn0?ooo`3moOd0oooo0?Shn03no_h0oooo0;Bd]03d
m?@0oooo0?gmo@3oool0moOg0?gmo@3gmoL00P3oool00`3fm_H0oooo0?clo0020?ooo`0G0?goo03h
n_L0o_oo0?cmo@3noOl0n?Oj08j=T01FEEP0oogn0?gknP3oo_/0ookj0?oomP3kn>d0oogc0?omm026
Q8<0Kfia01HE6019B4/0o_go0?ono`3lnoh02@3oo_lE0?ooo`00H03oool07P3ooO`0oooo0?[oo`3k
ool0ookf0?onm03oood0o_oo0=GGh@22PXX0=38a01PH501OIfD0`<K60?omo`3on?/0ooco0?omoP3o
o_l0oooo0?koo`3in_X0o_oo0?_kn`3oo_l0noWj0?Sfm`3oo_l0oooo0?koo`80o?oo00<0o_oo0?oo
o`3oool01`3oool0203no_h0oooo0?ooo`3moOd0n_[j01lO7`3GemL0oOgm0P3oool00`3kno/0oooo
0?ooo`0:0?ooo`030?_kn`3jn_X0oooo00D0oooo00P0n_[j0?ooo`3oool0e=CD08:2PP1_Kfl0Vi^K
0??cl`80oooo00@0n?Sh0?ooo`20P800JVYZ0`3oool00`3lo?`0n_[j0?ooo`020?ooo`030?gmo@3n
o_h0oooo01P0oooo00h0n_[j0?Win@3oool0oooo0>7Qh@2;Rh/0Jf][09bJV`3ajn/0oocn0?coo`3k
ool0nogh0?kon080o_oj00X0o?cj0?ono`3moOl0o_ko0?_inP3oo_d0oo[j0?kln`3oool0o_oo0`3l
ool00`3ioO`0o_om0?ooo@020?ono@0H0?ooo`3oo_l0o_oo0?ono`3onoP0oo_i0?Soo`3dool0nOoo
0?oon`3oo_H0oo_e0?[kn`3kool0m_Ko01/G8@0<0@L0RH>308>9Q@0=5Q40MGIf0:>SX`3oool0o?cl
0`3oool00`3lo?`0oooo0?ooo`050?ooo`030?knoP3oool0n?Sh00<0oooo00D0n_[j06QXJ039bLT0
oooo0?clo0020?ooo`090?knoP3moOd0oooo0?_kn`3oool0IVIV00l?3`1_Kfl0g=cL00@0oooo00L0
oOgm0?ooo`3oool0oOgm0?_kn`3oool0no_k0080o_om01H0o?gm0?gnoP3oo_l0n?Oj00l>4@3JfM`0
ooko0?ono@3oo_/0nOGa0?oon03oooH0nOK[0?oon03no?/0ooko0>[Yk0071PT0k>_^0?[io03oo_l0
o_go203oo_lE0?ooo`00H03oool06@3mnoX0oooo0?_oo`3kool0o_Se0?kil`3knoT0noco0?_no`3n
ool0lo7`0>;Pg`2;Si00;2lc01LE501VH600^kJh0?[hn@3ooOh0o_kn0?WjnP3nool0n?Wi0?koo`3o
oOh00P3oo_l01@3mno`0no_k0?koo`3nool0nOgl00T0oooo00T0n_[j0?ooo`3oool0nOWi0?ooo`3:
b/X0:b/[0?ooo`3moOd03P3oool0103moOd0oooo0?ooo`3oool20?gmo@030?clo03jn_X0n_[j0080
oooo00h0oOgm0?ooo`3oool0l_;b0>?Sh`2;Rh/0Hf=S08n?S`3YjNT0oooo028R8P37alL0oooo0?_k
n`@0oooo00@0o_kn0?clo03oool0o_kn5`3oool01@3lo?`0n?Sh0?ooo`3kno/0o?cl00@0oooo00l0
j>KU0:>RWP1]KFd0S9>K0=_RjP3lo_/0oooh0?_om`3ko_D0oo_g0?omo`3hn?l0o?ko0?coo`3inoH0
0P3oo_d0103moOd0o?cl0?cmo`3lool20?koo`040?ooo`3oood0ookm0?ono@80oooo01D0o_oo0?on
o`3oo?P0oogj0?;ko@3dool0nOoo0>k^k01;@Sd0=bhY01LG5`3HgN40n_co0:JT[@0=10T0OWMj0?[n
n`1BF5@04a@D09FEU@3gmoL00`3oool00`3hn?P0oooo0?ooo`060?ooo`0I0?knoP3oool0n_[j0?oo
o`3kno/0jn_[05UIF@3_knl0n_[j0?gmo@3oool0o_kn0?clo03oool0n?Sh0?_kn`3oool0o_kn0?oo
o`3Shn<0Ogmo00l?3`11@D40]kNg0?_kn`020?ooo`030?Ogm`3oool0o?cl00<0oooo01H0nogj0?ko
o@15ATH0hN;R0?glo`2EU9L0EUEH0?ckoP3mno`0ooko0?omo@3oo_/0ookj0?oon03oooH0moK_0?_i
n03oo_l0k>_^028Q902g][T0ooko0P3mo?l80?onoaD0oooo001P0?ooo`0H0?gko03noOl0o?oo0?ko
o`3oo_/0oogk0?ooo`3nool0o?oo0?WjnP3ooo/0oo[j0?kno`3nool0hn?Q08n>RP10>c/04Q0A05EC
E02i^KT0o?gm0?gnoP3nool0nocl0P3no?d20?ono`040?ooo`3nool0oOkn0?_ooPT0oooo00<0o_kn
0?ooo`3lo?`00P3oool00`1gMgL0N7Qh0?ooo`020?ooo`050?knoP3oool0oOgm0?ooo`3no_h0203o
ool01P3moOd0oooo0?ooo`3moOd0nOWi0?knoP@0oooo00<0o?cl0?Win@3oool01@3oool01@35aLD0
VIVI051@D00H61P0eMGE00<0oooo0P3jn_X20?ooo`030?_kn`3no_h0o_kn01P0oooo01h0o_kn0?_k
n`2NWYh0BTY:01DE5@14A4@0SHf=0?WgmP3ooo/0mOGa0?coo`3^mol0XJVd07AcMP24Pgh0cmK>0?co
n03oo_H0ooWg0?kno`3iool0l_[j0?_on`3inOD0no[f0?gmn`3oood0oooo0?_lo03mo?l20?ono`D0
oooo01X0o_oo0?ono@3onoD0oocg0?Gmo`3eool0n?oo0?koo@3onO@0W9>>0?7/kP3Xind0o?oo0?Ki
o`000080Bd];05mOG`3TiND0e]KF02h^;P1SHf<0n?Sh0?ooo`3fm_H0oooo0?Shn0L0oooo00P0o_kn
0?ooo`3oool0oooo0=_Kf`1SHf<0oooo0?Win@80oooo00H0n_[j0?ooo`3moOd0n?Sh0?ooo`3gmoL2
0?ooo`0?0?Ogm`3oool0moOg0?ooo`2[Zj/0<C4a01/K6`20P800lO7a0?ooo`3kno/0oooo0?Win@3o
ool0o?cl0080o_om00D0@48o0;jo_`3cl_D071/N0<O6b@030?ono`0=0?klo@3oo_d0o_[g0?kjmP3o
o_X0oooj0?ono@3inOT0hn?S0:JVYP2b/[80oooo0?knoP0N0?ooo`00H03oool20?ono`090?Wlo`3k
o?l0oo_m0?omo@3oo_l0o_oo0?_oo@3loo/0nOGb0080oogo01<0ooko0?GglP3oooX0n_Sg0>[Ui`2L
VY/0=cLg00l@401JFe/0ZZ^[0?Ohn03oool0ooko0?gko03knOX0o?cl0?gnoP3nool0o?oo00/0oooo
00H0o?cl0?ooo`3oool08R8R0<o?c`3jn_X20?ooo`030?gmo@3oool0no_k00/0oooo00<0o_kn0?cl
o03oool00P3oool0103moOd0nOWi0?[jnP3no_h20?ooo`0>0?knoP3lo?`0o_kn0?ooo`3inOT0o?cl
014A4@3Zj^X0MgMg06i^KP2_[jl0IFEU07YjNP38b<P30?ooo`040?_kn`3jn_X0oooo0?knoQL0oooo
01X0oOgm0?[jnP0410@00`<3000000010@400000018B400e<c80n?Sd0?konP3iool0koSo0?Soo`3m
noh0ookm0;:h]01cMFl0OWAX0<o4_P3ooOl0nOoo0?Koo`3iood0o_om0?oon`80ooom0P3oool00`3o
oOl0oOco0?ono`020?ono`<0oooo0140o_oo0?oon`3on_80oogf0?_oo`3gool0loko0?[oo03nnO<0
nO3[07acMP3onOl0o?oo0?Slo`1IGel03A4@0?3^k`020?ono`060??cl`1IFET0<30`0<[:bP3oool0
o_kn203oool02`3no_h0o?cl0?ooo`2[Zj/0PX:20?ooo`3lo?`0oooo0?Win@3kno/0o?cl00<0oooo
00D0n?Sh0?ooo`3jn_X0oooo0?knoP020?ooo`080?_kn`3lo?`0oooo0=?Cd`1WIfL030`<05iNGP37
alL20?ooo`0;0?_kn`3oool0nO_h0?koo@1RI640TiFB0:ZZZP15A4L0oOco0?ono`3ooOl00P3oo_l0
2@3mno`0oo_k0?onn`3oo?T0nOSd0?ooo@3oool0nOWi0?gmo@020?ooo`80oOgm7@3oool00600oooo
00@0o_kn0?ono`3lool0o_oo0P3ooOl06P3no?l0nocl0?Won@3looX0ookk0?gfn@3onol0o__o0?co
o@3kooT0ookm0?okn`3oo_l0n_[j0>OXj02GViX0@T=500`=3`1BDE@0YJBW0??alP3oo_l0oOgm0?gn
oP3nood0n?ci2@3oool01P3lo?`0oooo0?ooo`3gmoL0e]KF02@T9080oOgm00H0oooo0?knoP3oool0
oooo0?knoP3moOd:0?ooo`060?knoP3oool0oooo0?ooo`3lo?`0o_kn203oool0403moOd0oooo0?oo
o`0l?3`0`/;201`L703GemL0oOgm0?ooo`3dm?@0^[Zj071`L01^KVh0_;bl0?gmo@3oool20?knoQL0
oooo0240oOgm061PH0051@D0000000<30`0000000@4100400004000092<O0?con`3iool0mooo0?Wo
o`3oo?l0noKh0?Sko`3ooo/0ooc_0<fl/01gMGP0Jg9j0;_4a`3eoOl0lOGd0?gmn`3oood0oOgk0?_i
nP3oo_l0oogo0?ono`3ooOl00P3oo_l20?koo`80o_om01P0oooj0?ollP3ooO@0kNk`0>ohn`3fool0
nOoo0?onnP3onoT0m^W^079ZL`3gn_l0]l35071jN@3iood0oogo0?gfn`3imoP0o?cl0?ooo`20P800
2`/;0?ooo`3hn?P80?ooo`070?knoP3fm_H0T92@0:ZZZP3oool0o_kn0?[jnP020?ooo`0H0?Ogm`2m
_Kd0g=cL0?Ogm`3lo?`0oooo0?_kn`3oool0mOGe0?ooo`3lo?`0oOgm0?KfmP3oool0oOgm0?clo03i
nOT0lO7a08j>SP0P8200<c<c09FEU@3fm_H0oooo0P3nood207YlN@0=02TY:@2n_[h0no[m0?glo`3n
oOl0oOco0?klo`3oo_l0oogn0?kln`3gmO@0ookm0?_kn`020?ooo`050?gmo@3emOD0o?cl0?ooo`3m
oOd07@3oool00640oooo01l0oOgm0?cmo`3nool0oogo0?olo`3oo_l0o_oo0?_onP3jooP0oogj0?ol
o@3omol0ooco0?_oo`3iood0noWh0?omo@3oo_l0oooo0?gnoP3kooh0o_oo0>_/kP2MW9l0B4M:01@B
4`16A4D0ZZZZ0>k^kP3nood0o?kk00X0oooo00D0o?cl0?ooo`3oool0PX:206e]K@020?ooo`060?[j
nP3moOd0oooo0?knoP3oool0n_[j403oool01P3lo?`0oooo0?clo03no_h0oooo0?gmo@80oooo0180
o_kn0?ooo`3kno/0E5AD07inOP0b<S80o_kn0?ooo`3moOd0oooo0?gmo@3no_h0n_[j0<C4a01`L700
KFe]0;Bd]03no_hG0?ooo`030<_;b`0410@01PH600<0000001`00P8200<10P070@404Ph;0;Rm]`3f
o_`0n?oo0?[oo`3iloX0ooco0?kno`3hm_T0ooGW0;^YVP1fMG40TIJJ0;Nna01hOhD0MWal0;Bh]`3a
l_80oooo0?omo`3oo?h0ooco0?kio@3ooOl0ooko0`3nool04@3nood0o_ok0?oon03onNh0SH1g00<7
1P1FH6D0NhJ80?;hn03mmo@0jmoN0?oho@0`:340P8B;0:>/[`3do_d0nooo0080ooco00L0ooko0?kn
oP3Rh^809bLW05]KF`3oool0o?cl00P0oooo00@0o_kn06UYJ@3:b/X0o_kn0`3oool0203lo?`0oOgm
0?ooo`3Bd]806a/K0:^[Z`3oool0oOgm0`3oool01@3jn_X0oooo0?ooo`3oool0no_k00<0oooo00d0
no_k0?ooo`3moOd0^KVi051@D00>3Ph0LW9b0=[Lf@3koOX0W9jK03m1?P0h>3P0n_[j00@0ooko00<0
n_Sk0?ono`3mno`00P3oo_l01@3ln_/0o_kn0?gmo@3oool0oOgm0080oooo00<0n_[j0?ooo`3oool0
703oool00680oooo0P3nool20?omo`0B0?ono`3nood0nook0?_onP3oo_/0oo_m0?oioP3oo?l0n?oo
0?Ooo`2>SXh0100003<a<P2^[Zh0o_oo0?[no@3lool0o_oo0P3oo_l0203^k>d0ZJNX04=3@`0A4A40
B4Y709jPW@3]kNd0oooo0P3no_h30?ooo`080?Win@3oool0oooo0?ooo`3fm_H0oooo03/k>`2l_;`4
0?ooo`040?knoP3moOd0oOgm0?knoQ/0oooo00D0M7Ad03Ph>02<S8`0oooo0?gmo@020?ooo`0=0?_k
n`3oool0oooo0?_kn`3oool0oOgm0<S8b01mOGd0IVIV0:^[Z`3jn_X0oooo0?_kn`040?ooo`050?cl
o03oool0oooo0?[jnP3oool00P3no_h00`3oool0oOgm0?gmo@020?ooo`160?_kn`3oool0XJ6Q00l?
3`0000000@4100<30`0000001PH600800@0400003@L709VKV03kood0o?om0?Ohn03ooOl0ooWo0?_h
o`3onol0TGe`0140002JUhh0If]/00P84P3Be>00m_[o0=WNh@24R8T0JVYZ0;2[[@3eknl0o_Oj0?om
o`3lnOl0ooko0?koo`3dn?T0o_oo0?koo@3moOT0ookf0?obi`0I2`00dMWG0?;oo`32cm<0c<oC0?og
m`2RTY<05PdB028Q9P34bll0n?oo0>KZj`030`<0e=7G0?ono`3mo?l0iNGU01TI6@2?Shl0oooo0?gm
o@3oool0o?cl0?gmo@3oool0oOgm0?_kn`80oooo00@0iNGU05aLG03^k^h0nOWi0P3oool02P3moOd0
oooo0?ooo`3oool0oOgm0?ooo`3De=@04A4A0;:b/P3oool20?knoP060?gmo@3oool0oOgm0?knoP3o
ool0moOg0`3oool03`3jn_X0oooo0?ooo`3moOd0oooo0=_Kf`1hN7P05ALD04E7A022PX004A4?0=GE
e@3jn_X0ooko0?glo`020?ono`060?glo`3oo_l0o_go0?ono`3lnoh0ooko0`3oool0103no_h0oooo
0?ooo`3kno/N0?ooo`00HP3oool04`3nool0oooo0?ono`3ooOl0ooko0?koo@3hoo`0n?oh0?okn03o
noX0ooKg0?oko@3gool0k_go0?clo02[YJD0h]gO0>[ZjP3in_X00P3lool03P3gno`0nocn0?ono`3n
o?l0o_cm0?ooo`3bl_00Y:JS059DD@0@4100ADE509bLW03Zj^X0o?cl103oool01@3emOD0oooo0?oo
o`3Vi^H030`<00<0o?cl00<0oOgm0?ooo`3oool00`3oool00`3no_h0oooo0?ooo`0F0?ooo`80o?cl
00/0T92@00@4101kNg/0hN7Q0?ooo`3jn_X0no_k0?ooo`3no_h0nOWi0?gmo@030?ooo`0;0?[jnP3o
ool0d];B08J6QP1RHV80WinO0?Cdm03clo<0oooo0?[jnP3oool00P3lo?`00`3oool0no_k0?gmo@04
0?ooo`070?_kn`3no_h0oooo0?ooo`26QXH03Ph>00D51@020000000M00@4100000000@0000T30`0:
10@0PX:20?kon`3lo?80oooh0?Sen`3/j?H0oo_o0?ogo`33[j80imK20?Wik@3lood0UY2J04A0CP3i
ool0n?oo0?[oo`3nool0iN3R09>=S@1kMGD0WIRJ0?;`l`3em_X00P3lool05`3nool0o_om0?oon`3o
no<0o>KI02`K4@3Ggmd0lOoo0?Ooo`3no_l0ooCg0?OWj01MEU/0h^GY0?Soo`3fo_l0YJBW0040003N
gN00oOco0=kMh00D51@0W9bL0080oOgm00<0n_[j0?ooo`3no_h0103oool01P3kno/0clo?06m_K`3m
oOd0n?Sh0?knoP80oooo00/0o_kn0?ooo`3oool0o_kn0?ooo`3emOD0oooo0=;BdP0?3`l0^k^k0?kn
oP020?ooo`040?_kn`3lo?`0oooo0?Gem@80oooo00<0no_k0?ooo`3kno/00P3oool02P3hn?P0no_k
0?ooo`3moOd0mOOd0:BVX`0`<2h04A4?0861P@3Zj^X20?ono`050?glo`3oo_l0ooko0?ckoP3noOl0
0P3oo_l00`3kn_d0oOgm0?knoP040?ooo`030?knoP3oool0oooo01`0oooo001P0?ooo`80o_om00<0
ooom0?ooo`3oo_l00P3oo_l04P3nool0nOoo0?_oo`3oo_/0oo_f0?oek`3onoX0lOko0?;oo`3jnod0
oo_i09B?S`3GemL0o_oo0?coo`3en?`0o?oo0?koo`80ooko00<0o_cm0?clo03moO/00P3nood02@3f
m_H0ZJVY05QHF00>3Ph0=CDe09VIV@3Vi^H0n?Sh0?gmo@020?ooo`030?gmo@2<S8`0J6QX0080oooo
00@0o_kn0?ooo`3oool0o_kn0P3lo?`K0?ooo`090?_kn`26QXH01PH606ATI00G5aL0;2`/07moO`3?
cll0m?Cd00@0oooo00@0lO7a0?ooo`3oool0moOg0P3oool02P3moOd0h>3P09FEU@1/K6`0Rh^;0>o_
k`3oool0no_k0?knoP3lo?`20?ooo`030?clo03hn?P0o?cl00<0oooo01l0o_kn0?ooo`2n_[h04A4A
0000000410@01PH60000000410@00P0100@0000D3a40^[Ri0?oonP3onn`0V9660000100000d03PDH
0=G7dP3on_40Zij=000300000@0081@M00L0203Tj_H0mOoo0?Soo`3gn_l0ooko0080oogm01/0j^GU
09ZHV`1eMWP0TYFI0=cRhP3jo_l0nO_h0?oon`3oo_H0oo[]061BA`2FVY/0looo0?7io`3[jo<0fLkB
06eQH`3mn?X0o_oo0?Woo`3cnOT0>CTi00X82@3;b/d0d]7D01/J7@2NWYh00P3oool0303moOd0oooo
0?Gem@3oool0o_kn0?Ogm`3oool0no_k0:>SX`2BTY80oooo0?[jnP<0oooo0P3no_h20?ooo`030?gm
o@3oool0no_k0080oooo00<0b/[:00T92@2f][H00P3oool00`3hn?P0oooo0?knoP020?ooo`040?_k
n`3oool0o_kn0?ooo`80oOgm0P3oool0303no_h0oooo0?gmo@3oool0nOWi0000001QHF404a<C05EE
E@36a/H0oooo0?Cdm080ooko00H0o_go0?Ken03oo_l0ooko0?gmo@3no_h20?ooo`040?gmo@3oool0
oooo0?clo1d0oooo001P0?ooo`80o_om0P3oood20?ooo`0@0?ono@3nool0nOoo0?_oo`3oo_/0ooC/
0?odj03onO80lOko0>_no`3nool0oogk0?ghn01^KV`0m_Oi0?_oo`80o?oo01P0noco0?cmo`3oo_l0
ooko0?ooo`3oood0oOgi0?_mn03lo?`0oooo0?knoP3moOd0^[Zj05EEE@0B4Q80?Shn09:BTP3Vi^H0
m_Kf0?ooo`0n?Sh0ZZZZ0?ooo`3no_h60?ooo`030?knoP3kno/0oooo01T0oooo0140@41001PH603m
oOd0oooo0<W9b@1`L7009BDU01dM7@1]KFd0]KFe0?ooo`3moOd0oooo0?gmo@3inOT0oooo0?gmo@02
0?ooo`80no_k00H0oOgm0>o_k`2@T900Fe]K08b<S03Lg=`20?ooo`050?_kn`3oool0oooo0?ooo`3k
no/00P3oool01`3lo?`0oooo0?ooo`0;2`/00`<3000000010@400P000000>@051@D01@<401/I6P3l
n_/0o?Oa0?oei00I3`40VYnS0?3fo`27OhX06P/@0?CUgP0>1@00Z:jZ0?Sln`1oKg003P040<?:f03a
ool0mooo0?_oo`3oo_l0o?Og0?omn`3oo_/0oO_l0?koo`3[k_80YZ^^06eaLP2=Sh`0emOC0?kgk`3o
o>d0k=kC00<21@3FgND0em_V00X:4P28PH@0ooWj0?omo`3hmoX0n_ko0=SLg@082PL02`/;0:BSYP0B
4A@0Y:>V0?ooo`3jn_X0oooo0?[jnP3inOT0oooo0?clo0020?ooo`060?Cdm022PX80_[jn0?Win@3j
n_X0oOgm0P3oool00`3no_h0oOgm0?knoP020?ooo`0;0?gmo@3kno/0oooo0?ooo`3kno/0oooo0<K6
aP0Q8B40^k^k0?Win@3moOd00P3oool01@3inOT0oooo0?gmo@3oool0o?cl0080oooo00D0n_[j0?oo
o`3oool0no_k0?Ogm`030?ooo`09024Q8@3Ogml0jNWY09:BTP0V9RH0;Bd]0:>SX`3jn_X0oOco0080
ooko00L0o_go0?_kn`3oool0oooo0?knoP3oool0o_kn0080oooo00<0o?cl0?ooo`3oool06`3oool0
0600oooo0P3nood20?ooo@0^0?kon`3ooo/0oook0?ooo`3gool0nOoo0?olnP3onnl0ooCQ030O5@0b
?e00gO7o0?kno`3Rg=X0oogm07YjN02a/[@0o?oo0?_oo`3dmo/0n__o0?koo`3oo_l0o?[k0?klo@3o
ood0oook0?gmn@3oool0n?Sh0?ooo`3jn_X0o_kn0?ooo`3jn_X0^KVi06=SH`0A4A40=cLg07inOP0A
4A40oooo0?Win@3oool0o?cl0?_kn`80n_[j00@0o_kn0?ooo`3oool0oOgm6@3oool00`3^k^h05ADE
00D51@020?ooo`0:0?Win@3oool0oooo0=;BdP23Ph<0?Cdm00820P1IFET0[jn_0>o_k`80oooo00@0
o?cl0?knoP3oool0o_kn1@3oool01`3_knl0Z:RX065QH@1jNWX0d];B0?_kn`3moOd00P3oool20?cl
o080oooo0300n_[j0>7Qh@010@4010@4000000061PH02PX:000000020`D0m_Kf0?ono`3ooOH0k]W6
01<5003WlOP0m?oo0?olo02GRH@0bl:m00`<303/m_l0loSl0?ohlP0c8Ad0TiZZ0?3oo`3^nol0nOoo
0?ckoP3oo_/0ooci0?onnP3oood0nocl0?[no`3kool0o?oo0?;cl`2j^;L0OWUa08UmK@3Od/L0hmcQ
06ARK`0o?T`0BTaF0?ono`3ooO`20?ono`070?glo`1:Bd/000400001000B4A@0X9jQ0?Gdm`080?oo
o`050?;blP1ZJVX0bl_;0?ooo`3jn_X00P3oool00`3moOd0o_kn0?ooo`020?knoP80oooo0P3no_h0
3@3moOd0o?cl0?gmo@3oool0n_[j0;fm_@0@4100bLW90?ooo`3moOd0oooo0?_kn`3no_h00`3oool0
0`3no_h0oOgm0?ooo`020?knoP<0oooo0180o_kn0?ooo`0j>SX0]kNg0?ooo`3nood0nO_h0;^m^P15
Ad@0418?06e^KP3Gf=P0o_oo0?gnoP3loOd0oooo0?ooo@3knoT20?ooo@030?clnP3oood0ooom00P0
ooom5@3oool00600oooo0P3nood00`3oood0oook0?konP020?oonP0A0?ooo`3hool0mogo0?okn@3o
m^L0ooWO06QFB01]O940cnCo0?Sjo`39`l40;RTY014A3`3/kNl0n?cm0?Smo`3kool00P3nool20?on
o`070?omoP3hm_D0n_[f0?oon`3inOT0oooo0?Ogm`030?ooo`0:0?clo03no_h0oooo0?_kn`30`<00
?clo0000000Y:BT0RXZ:0=gMg@@0oooo0P3no_hK0?ooo`0409nOW`1?Cdl04A4A0>SXj080oooo00<0
m_Kf0?ooo`3hn?P00P3oool03`3WinL0VIVI04I6AP0:2PX0ATI608b<S03Zj^X0oooo0?[jnP3oool0
o?cl0?ooo`3kno/0oooo0?Ogm`030?ooo`050?Ogm`2d];@0KVi^07EeM@2l_;`00P3oool00`3jn_X0
oooo0?gmo@020?ooo`0f0>3Ph017AdL00@4100X:2P030`<0>CXj0>[^k`3fn_T0ookm0?ogk`3om>40
91@50:Vj`@3`ool0oooc0?omk@3glo005QXU0;S4f03ko_l0oo[/0:VER01=EVD0kOoo0>kmo`3hool0
ooko0?onn`3mmo@0oooh0?knnP3lool0nooo0?Olo`3ioOh0nocl0?[hm`3nnO40o??R05M=@@1fKG80
?SM60=SEi02;RiD0dm;E0?ooo`3kno/0oOgm0<c<c0020P0010@000L71@0000802PT<0`0000003P3o
ool0o?cl0?ooo`3gmoL0oooo0>KViP1NGUh0k^k^0?ooo`3moOd0oooo05eMG@3emOD0o_kn103oool2
0?knoPD0oooo00l0lo?c0?ooo`3oool0`<3000l?3`33`l<0oOgm0;6a/@1jNWX0o_kn0?ooo`3no_h0
oooo0?Win@3lo?`0103oool01`3inOT0oooo0?7al@3oool0Ogmo0:f][@3kno/00P3nood02`3koOX0
o_om0=kPg@1jO7T06AXJ04E6AP2c];@0oOkn0?Ogm@3oood0n_[h0080ooom00<0no_i0?ooo@3oood0
203ooodE0?ooo`00H03oool20?koo@80oook01@0o_oh0?oon03oooP0ooko0?Soo`3io_l0oogk0?oh
j@3on]X0]jJD05ITOP3Tn_l0o?ko0?okn@3lmoL0no_i0?cmo`3lool0nooo0??hn`80oOko00H0o?_n
0?clo03oo_l0ookm0?oon`3moOT30?ooo`030?Shn03oool0o?cl0080oooo00l0o?cl0?ooo`3kno/0
AdM70:j^[P2o_kl0KFe]014A4@0_;bl0N7Qh0<o?c`3no_h0oooo0?_kn`3moOd06P3oool01P1>CTh0
WYjN03Lg=`3;bl/0o_kn0?gmo@<0oooo00h0n_[j0?_kn`3oool0oooo0?knoP3inOT0Zj^[069RHP0A
4A40<30`08^;R`3@d=00oOgm0?knoP<0oooo02l0nOWi0?ooo`3oool0m_Kf0?knoP3oool0nOWi0<30
`01]KFd0IFEU0;fm_@3oool0no_k0?clo03oool0o_kn0?Win@3oool0f=SH0?ooo`3loOd0nOoo0?_o
o`3ooo/0oo_c0?ohiP1iJEX0?eIL0>[oo`3oonL0c/N[07n0P01LI7L0CUio0?Gjo`3on>80]9j700XC
8P3Qn?l0lOoo0?;ko`3gn?`0ookk0?onn03oooP0oOgi0?[nn`020?_oo`0H0?coo`3nool0ookm0?om
n03ooNl0Y9N<03Ha=@3bkoh0cl[L061LJP3nn?l0o_kn0?_oo`3iool08B8R00<100060000100000<4
10083Ph05aPH07EeM@2SXj<0no_k0`3oool02@35aLD0MWIf0?gmo@3kno/0VYZJ02@T903WinL07alO
0=gMg@050?ooo`80o_kn0P3oool00`3moOd0oooo0?knoP030?ooo`0:0?Gem@2k^k/05QHF0=GEe@2m
_Kd0?Shn0?ooo`3dm?@0oooo0?_kn`<0oooo00L0no_k0?knoP3oool0oooo0?kmo`3oo_l0oooo0080
o?cl00<0o_kn0?koo@3hn_L00P3nood0203hn_L0o_om0?OimP2NX9d0=cTf01/M6P3Ng]`0ooom0P3m
oO/00`3oood0o?cj0?ooo@090?oooAD0oooo001P0?ooo`0F0?koo`3nood0ooom0?oon`3nooX0oooh
0?oonP3oool0mogo0?_no`3oo_/0oog]0?ofg03/g/l01Q4S0>[io`3lool0o_Wi0?ono@3oool0o_oo
0?[no`80o?oo00X0o_oo0?gno`3noOl0oooo0?ono`3ln_T0o?cj0?ooo@3oool0n_[j0P3oood0503l
o?`0ooko0?ckoP3oo_l0ooom0?kno03dm?803Ph>0?Gdm`3oo_l0o?cl0?ooo`34a<@0Lg=c02<S8`0U
9BD0NGUi0=KFeP3no_h0no_k603oool06P3YjNT04Q8B0??cl`2ZZZX0e=CD0?ooo`3inOT0oooo0?kn
oP3oool0o?cl0?ooo`3kno/0o?cl0?ooo`3lo?`0o_go0?ono`3hn?P0`L7106][J@0P82009B@W06e/
K`30`<00mOGc103oool01@3oo_l0o_go0?clo03oool0o?cl0080oooo00P0`/;207QhN01WIfL0/K6a
0??cl`3oool0oOgm0?_kn`80oooo01/0oOkn0?_oo`3goO/0ookm0?okm@3onN/0im[A00052`1QNGT0
d]Bl04U4;01FEeL0e]k`0001701`Lh@0ckbY02/J1P001A00f^co0?Coo`3fo?l0o_oo0?oon`3oo_X0
o_gh0?oon`3jo?T00P3kool05P3jo_l0o?gm0?ono`3onOH0dLNm071WGP1;BD`0dm?M02`X=P3/iO80
ooco0?gmo@3kool0JG5_00H81@040P402@0000d50`1:Bd/0bLo=0?coo`3hn_L20?ooo`060?cjn`3n
o?d0YZBU09JFUP3oool0moSh0P3nood01`2>SXh092@T0490@@2h][L0oooo0?knoP3moOd00`3no_h4
0?ooo`040?gmo@3no_h0oooo0?knoP80oooo00P0no_k0:b/[00G5aL0^[Zj01XJ6P3no_h0oooo0?_k
n`80oooo00X0oOgm0?clo03oool0oooo0?gmo@3oool0ooko0?_jo@3oool0oOgm0P3oool01P3jo?T0
oOol0?goo03koOX0o_om0?_mnP80o_om00X0nogj0<oAcP3:b/P0oOgk0?ooo@3lo?X0ooom0?gmn`3o
ood0o_kl203ooodE0?ooo`00H03oool40?koo`<0ooom00l0oooo0?gno`3loOl0oook0?onmP3on>d0
ookf01hQ9@3<d=L0oOko0?gmo@3oool0o_oo0?gmo@3loOd00P3nool0103oo_l0oooo0?ooo`3oool4
0?ono`0=0?glo`3oool0oook0?gmn@3lnoh0ooko0?WhoP3oo_l0oook0?oonP2PXI/0CTi<0?gno`02
0?koo`80ooom00/0ookm0?gko03=bl`0Lg9e02<R9@0O8280N7Uk0=3Ad`3gn?X0oooo0?knoP020?om
o0050?ono@3no?/0oooo0?ooo`3no_h00P3oool0203moOd0o_kn0?ooo`3oool0no_k0?ooo`3jn_X0
oOgm0P3oool01`3moOd0U9BD05YJFP3oool0o_kn0?ooo`3lo?`02@3oool03P3oo_l0no_o0?kno`3g
mOH0ookm0?cnn@3nood0clkC0860Q@0`<Rl05ALB05UIE`2c/K00m_Ce0P3oo_l01P3jnOh0ooko0?oo
o`3no_h0no_k0?knoP<0oooo02D0B4Q80820P01UIFD0Jf][0>o_k`3oool0n_[j0?ooo`3nool0nocl
0?knoP3oo_/0no?^0?onn`3Mh^D0D5QH00<4000`;bP0d];B0?coo`3KgnP0GEeS00P0002?RX@0OH24
0<[Af@3kool0o_oo0?ono`3moO/0ookm0?kno03moO/0oooo0?gnoP3nool0o?gm0080oooo02<0^;Je
08b8Q@3oo?T0k>c/0000102b/KH0oogo0?_io03oool0blc<00T:2P0000001`L704m:BP3MfmX0o_kn
0?coo`3koo/0o?ok0?ooo@3oo_l0ooco07YcN02k][P0ooko0?koo`3kool0nooj0?Kmm@3mo_h0NWUl
01/F602;QXP0ookm0?gknP020?ono`040?ooo`3moOd0oooo0?knoP<0oooo00`0n_[j0?ooo`3oool0
moKi0?ono`3inOT0oooo0:BTY00A4A402@T90?[jnP3oool20?knoP070?ooo`3kno/0oooo0?ooo`3i
nOT0oooo0?[jnP0e0?ooo`00H03oool40?koo`@0oooo0P3oood01`3lo?P0oook0?oon`3kn_H0Ph9m
08^;Q`3oood00P3nool01@3loOd0oooo0?ooo`3oool0oOgm00@0oooo1@3oo_l04`3inOT0oooj0?oo
nP3kn_d0mOCj07QfP@3Hem`0o?ch0?oomP1IFU@0XJ6O0?_ko`3no_l0n?Wi0?oon`3mnoX0ookm0?on
o`3imoP00P3oo_l02P35a/P0NGYl01dN800V9bT0L71`0<g=c@3jn?L0ookm0?onn`3oo_d20?ooo`03
0?knoP3moOd0oooo0080oooo00@0no_k0?ooo`3no_h0n_[j0P3oool01@3hn?P0oooo0?ooo`0i>CT0
/[:b0080oooo0P3moOd00`3oool0oOgm0?ooo`060?ooo`0D0?koo`3lool0n_[o0?olo`3oo?X0oooh
0?Gjl`3nool0o_ko0?koo`3PhN40TiF?04Q7@P080P00D4U<09BCV@3`l?H0no[m0?gmo@3no_h20?oo
o`0<0?gmo@3oool0nOWi02LW9`3Fe]H0OGem069RHP2BTY80Hf=S092@T03Shn<0n_[j1@3oool0103n
o_h0oooo0?[jnP3moOd30?ooo`030?gmo@3oool0no_k00<0oooo00<0n_[j0?ooo`3no_h00`3oool0
4`3emOD0oooo0?ooo`3moOd0o?cl0<g=c@2@T900o_kn0?ooo`3gmoL0gmoO0?KfmP3kno/0oooo0>CT
i0030`<0000001<C4`2k^k/00`3oool04`3hn_L0o?ok0?con`3knoT0mO?d069MG`3Sg^00ooko0?ck
oP3nool0o?oo0?[on@3looP0o_om0?[jnP0k=SP081/M0?OemP3ooO`00P3oo_l01P3jn_X0o_kn0?oo
o`3jn_X0oooo0?gmo@@0oooo00P0ooko0?[io03oool0nOWi0?ooo`1kNg/000000;jn_P<0oooo00<0
n?Sh0?ooo`3gmoL00P3oool00`3bl_80oooo0?ooo`0d0?ooo`00H03oool40?koo`@0oooo00T0ooom
0?[jn03moOT0oook0?ckm`3ooo/0fm[F02<S7`3hn?H00P3nool0103jno/0oooo0?ooo`3no_h50?oo
o`D0ooko00<0oooo0?cmm`3ooo/00P3oo_l03P0l>TD05A@I0?oon`3]k^@04A8<0>_[j@3lnol0moKl
0?ooo`3moO/0ookm0?ojnP3mno`0oogn0P3oo_l30?koo`090<o@dP1mOWh09BHV01lO7@1[JfT0_kfl
0?kln`3oool0oOgm00<0oooo00D0moOg0?[jnP3oool0oOgm0?clo0020?ooo`060?gmo@3no_h0oooo
0=_Kf`0C4a<0oOgm0P3oool0103kno/0oooo0?ooo`3moOd70?ooo`0E0?koo`3kool0moOm0?oko`3o
nod0no_^0?com03ioOh0mOOo07ajS@19B5D0loW]0?gok`3jlNX0ZYnQ05mOI`072a@0?Sm308V9R@3M
gMd0nOWi0080oooo00H0moOg0?ooo`13@d<0]kNg02DU9@32`/820?ooo`070=oOg`2QXJ40JVYZ0820
P03EeMD0oooo0?Win@020?ooo`040?gmo@3oool0oooo0?[jnP80oooo00H0o_kn0?ooo`3oool0no_k
0?ooo`3jn_X20?ooo`060?clo03kno/0oooo0?Shn03oool0o_kn0P3oool0103Shn<0KVi^0?ooo`3m
oOd30?ooo`0P0>7Qh@3oool0n?Sh00h>3P051@D0FUYJ0??cl`3oool0n?Sh0?[jnP3oool0oOgm0?_i
n03ooO`0g]kL069TH@3]kn`0noon0?Cem`3nool0ooko0?_inP3oooX0o?_d0?oon`3Lg=X03Pl?020Q
8@14A4@0noWj0?omoP3oo_l20?ooo`080?KfmP3oool0nOWi0?ooo`3jn_X0oooo0?knoP3hn?P40?oo
o`0709NGU`0E5AD08b<S01LG5`3Ti>@0oooo0?knoP020?ooo`050?_kn`3oool0oooo0?ooo`3inOT0
=@3oool00600oooo103nool40?ooo`0<0?ooo@3hn?H0oook0?oon`3lnoL0oook0<c;a`0820@0iNGU
0?_lo03nool0nocl0P3oool00`3lo?`0oooo0?ooo`030?ooo`D0ooko0140oooo0?oonP3ooo/0n_Wl
0?ono`2GUIh010<809jNVP2][ZH0>CXd0?ooo@3oo_l0]kJl0=?Cd`3oood0n_Ge0?omo@020?ono`03
0?CcmP3oo_l0o_oo0080nocn0P3nool02P3loOd0f=SH08R8QP0b<S0051@B06a/K02k^k/0o?cl0?oo
o`3inOT20?ooo`0:0?clo03oool0oooo0?[jnP3no_h0j>SX06YZJP3oool0QHF5065QH@80oooo00@0
no_k0?ooo`3oool0o_kn2@3oool09`3ko?h0ooko0?olo`3ooOd0oOob0?komP3lool0n?Oo0?;]o`1U
Hg00nOoj0?_om03oo?T0oo_o0?ShoP3en?l0];Fg06MWI`0I6AT0:RXZ07=cL`38b<P0oooo0?Win@1Q
HF40PH6102@T903oool0n_[j0?ooo`3kno/0o?cl0?ooo`3Rh^80Zj^[06UYJ@20P800emOG0?[jnP02
0?ooo`060?_kn`3no_h0oooo0?_kn`3oool0no_k1`3oool02P3moOd0oooo0?ooo`3lo?`0oooo0?[j
nP3no_h0[Zj^0<S8b03moOd20?ooo`090=gMg@0C4a<03`l?01TI6@0F5QH00`<309^KV`3lo?`0oOgm
00D0oooo01D0ooko0;Vg^01oOgd0oOoj0?Sln@3lood0o_oo0?kmo`3mn_l0ooko0?kmn03mo?D0_Kbe
020P701cM7@0>c`n05QHF01@CTl0noWj0?ono`3moOd00P3oool01@3inOT0oooo0?knoP3oool0n?Sh
00@0oooo00P0o?cl07YjNP0V9RH0gMgM05YJFP1LG5`08b<S0>GUi@80o_kn00D0n_[j0?ooo`3kno/0
oooo0?knoP0f0?ooo`00H03oool40?koo`@0oooo00`0o_kl0?ooo@3no_`0oOgk0?oon`3oo_X0b/W5
09NGT`3UiND0nocl0?koo`3ko?`20?ooo`030?clo03oool0oooo00<0oooo103oo_l0103oool0n?Sf
0?knnP3knoL20?ono`0@0<2na`0000@010@006=TG02@TH/0WinM01PG700000@0l>ob0?ooo`3ooOd0
o_Wi0?omo03oo_d0oooo0?Win@<0o_oo00<0n?Wk0?Kgn@3nool00P3nool0203jno/0h>3P08:2PP0g
=cL061PH05iNGP31`L40lo?c0P3lo?`0303inOT0o?cl0?ooo`3inOT0n_[j00D51@3kno/0<S8b0<[:
bP3jn_X0oooo0?_kn`80oooo00<0n_[j0?ooo`3oool01P3oool04@3oo_l0oogm0?oin@3jn_P0o?om
0?Sin@3loOl0o_ko0?olo`3om?X0IUmR0=KRh03aool0o_ko0?olo`3oo_l0o_kl0080o_kn00T0oooo
0=3@d01fMWH08b<S01XJ6P1VIVH0J6QX02l_;`1mOGd0103oool20?clo080oooo00L0nOWi0?7al@2]
[Jd0Jf][06m_K`35aLD0oooo0080o_kn0P3oool00`3inOT0oooo0?knoP020?ooo`030?_kn`3lo?`0
oooo00<0oooo00/0o?cl0?ooo`3moOd0o_kn0<g=c@2XZ:P0oooo0?clo03jn_X0C4a<00L71`030000
00030:>SX`3lo?`0oooo0080oooo01L0o?cl0?[jnP3inOT0ooko08^<T02OWZ<0moOe0?oonP3ooo/0
n_Sg0?omo`3nnol0ooko0?koo`3hn_@0[:nT01LH3P2_/:P0j^SY014>503hmoX0?Cdm06EUI@020?oo
o`060?Win@3oool0oooo0?_kn`3oool0oOgm0P3oool03@3kno/0o?cl0?KfmP1GEeL0=SHf0>c/k03o
ool0Q8B407emO@2<S8`09BDU0>WYj@3no_h00`3oool00`3no_h0oooo0?knoP0e0?ooo`00H03oool4
0?koo`@0oooo0P3oood01`3no_`0moOe0?oon`3ooo/0o_gi0?ooo@3hn?P00P3nool0103jno/0oooo
0?ooo`3no_h50?ooo`@0ooko01T0o?cl0?ooo@3ooo/0ooom0?[io03oo_l0g]gS00l>4`092@D00@80
00`<200:2PP01`H90:n^/`3noOl0o_cm0?omo@3on_X0SXb;00T71P0e=CD0[Zj^0?Sin`3nool0oOko
00@0o_oo00/0nocl0?koo`3ko?`0oooo0?knoP3Ogml0TI6A03@d=00G5aL0GEeM0;Rh^0030?ooo`06
0?_kn`3oool06ATI0;jn_P0L71`0n?Sh1@3oool00`3jn_X0oooo0?ooo`060?ooo`0E0?onn`3om_00
ookf0?3hn03gool0ooko0?[fo`3fm_l0n_Om0?okmP2^YJ00YJfh0?;oo`3bmol0no_o0?onn`3oooP0
ookm0?ooo`3inOT0oOgm0080oooo00T0g=cL08b<S00h>3P01@D50>3Ph03moOd0oooo0?clo03kno/0
0P3oool03@3no_h0n?Sh0?ooo`3oool0oOgm0?ooo`3lo?`0_[jn075aL@1OGel0`L710?_kn`3hn?P0
0`3oool0203no_h0oooo0?knoP3no_h0oooo0?knoP3oool0nOWi0`3oool01`3no_h0oooo061PH03e
mOD0oooo0=KFeP0820P00P0000000`061PH00@4104Y:BP020?ooo`030?clo03oool0oooo0080oooo
01P0JV]]0<[=e03lool0oOgk0?olm@3ooOX0oogk0?ceo03oo?l0ooko0?Gin01nQGh05A`B0=_Od03o
ooH0ooco00/5303ln_d0oOgm03`l?01RHV80nOWi0?ooo`3lo?`20?ooo`080?Ogm`3kno/0oooo0?gm
o@3oool0lo?c03/k>`1IFET20?_kn`0:0?ooo`2EUID0HV9R0?_kn`25QHD0;bl_0?3`l03moOd0m?Cd
0?ooo`80o?cl=P3oool00600oooo103nool40?ooo`80no_k0P3oood01@3mnoX0ookm0?ono@3fm_@0
oooo0080o_oo00D0o?gm0?ooo`3oool0oooo0?gmo@040?ooo`@0ooko0P3oood03P3hn?H0ooom0?gl
o`3in?d0g=_P00L62@0000000P8000/:1P010000YZBW0?ono`3ooOl0ooko0P3ooOd02P3mnoX0Xj6P
0=SHf03UiND0oooo0?clo03in_`0o_oo0?cmo`3fmoT20?coo`050?[no`3nool0o_kn0?ooo`3no_h0
0P3oool0303Vi^H0T92@03Xj>P061PH0GemO0:VYZ@3no_h0no_k03Ti>@1LG5`0MGEe0?gmo@@0oooo
0`3no_h70?ooo`0B0?onn03on^P0h=S;00033P0Z>D`0_[K300L0102_/[T0o?oo0?omk03ai^00Jff4
0>cfo`3eool0nOoo0?olm@3oo?@0ookj0P3oool02P3inOT0o_kn0?ooo`3inOT0oooo08^;R`0@4100
n_[j0?ooo`3jn_X30?ooo`030?Win@3oool0oOgm0080oooo00@0no_k0?knoP3oool0moOg0P3oool0
1`31`L40LG5a06][J`2`/;00mOGe0?ooo`3lo?`00P3oool00`3moOd0oooo0?ooo`020?ooo`0/0?Og
m`3oool0oooo0?_kn`3jn_X0l?3`071`L03oool0k>c/00@4100000001@D5000000020P80J6QX0?oo
o`3jn_X0oooo0?Gem@3oool0lO7a05EEE@3TiNT0loOo0?_oo`3lo?P0ookf0?okmP3oo?/0oo_o0?ol
o`3loOl0BDm=03Do>P3[m>`0m?_[0?gml@3oo?l09adV0=;@d`3nool0n?Wi0;bm_@3Lg=`30?ooo`0H
0?clo03oool0oooo0?Shn03oool0emOG02HV9P1bLW80o?cl0?ooo`3no_h0oooo0;no_`0o?cl0oooo
0?knoP1gMgL0;Rh^0?Gem@3no_h0oooo0?knoP3oool0o?cl=@3oool00600oooo103nool60?ooo`08
0?gmn`3oood0ookm0?ono@3mnoX0ooom0?knoP3loOd20?koo`80oOgm1P3oool40?ono`080?_kn@3o
ood0o_kl0?Ogm`3lnoh0ooko0=[IgP0@3a820041000700L60P1ACdh0ooko0?gkoP3oo_l0oogo0?on
o`020?ono@070?gknP2ATI40h>3P0?Win@3oool0o_oo0?Gfn0020?koo`050?_oo`3lool0nOgn0?co
o`3no_h00P3oool00`3no_h0oOgm0?ooo`020?ooo`0:0>_[j`2GUiL0@d=300d=3@1ADE40>SXj01@D
503AdM40oooo0?gmo@80o_kn00@0oooo0?[jnP3oool0o_kn1`3oool04P3oo_H0oo[R09nIR@18E6P0
koSo02HF800J2P/0[;>k0?3ko@3ooo40^k:[00/97`3/kol0mooo0?Soo`3lno@0ooof0?oon`80o_kn
0P3oool02`3kno/0oooo0?ooo`1=CDd03Ph>0?ooo`3lo?`0o_kn0?ooo`3no_h0oOgm00<0oooo0P3l
o?`20?ooo`0=0?_kn`3oool0oOgm0?ooo`3kno/0oooo0?gmo@3>c/h0OWin06ATI02OWil0k>c/0?oo
o`020?gmo@060?clo03oool0oooo0?ooo`3jn_X0oOgm0P3oool01P3lo?`0`L7108f=S@2IVIT07alO
00H61P800@4100<000000>WYj@3oool00`3oool07@3EeMD0IFEU0?Ogm`3mo_l0o?ko0?Sko`3ooo/0
oogd0?onmP3omo@0ooco0>WSj`0a<S80FUiM0?;hn03ho_X0o_oc0?ool`3onoh0ASi70;^j_@3in_X0
o_oo0?cmo@3moOd0o?cl0?ooo`3no_h0oOgm00<0oooo00<0a<C401@D502MWId00`3oool01P3no_h0
o?cl0>GUi@11@D40oooo0?gmo@80oooo00<0no_k0?ooo`3oool00P3lo?`f0?ooo`00H03oool40?ko
o`P0oooo0`3oo_l20?ooo`<0o_oo203oool40?ono`80ooom01H0o?cl0?kmo`3oo_l0n_Wn0>3OhP0:
2PX01@<400@20@0o?SX0oOch0?ono@3clO80m>oc0?klo`3oo_l0oooo0?knoP3oool0oOgm06YZJP3d
m?@0oooo103nool40?coo`P0oooo00X0oOgm0?ooo`3oool0i>CT0:>SX`0K6a/00@4104];B`2LW9`0
j^[Z0P3oool00`3kno/0oooo0?ooo`030?ooo`80oOgm0P3oool04`3moOd0oooh0?ooj@39a[/02@lW
0?Sho`3fgmT04P000=3Lj03`ool0o?oo0?onn`3onol0oo[o0?kmo`3lo_l0o?ok0?con03nood00P3n
o_h30?ooo`060?_kn`3fm_H030`<00D51@3gmoL0nOWi0`3oool00`3no_h0oooo0?ooo`0>0?ooo`09
0?Win@3MgMd0SHf=05iNGP2FUYH0i^KV0?ooo`3no_h0no_k0080oooo00`0oOgm0?knoP3oool0o_kn
0=oOg`0J6QX0U9BD0?[jnP2ATI406ATI04m?C`3Shn<20?ooo`0W0?knoP3oool0];Bd08:2PP3oool0
nOWi0?ono`3onol0ooco0?cjn@3oooP0o_oe0?gnn03BdM@07ahS081nO@3oo_d0o__o0?ono`25QGP0
2P`0030`<02ZZ[00nooo0?coo`3jo_l0o?oo0?[ko@3nool0o?cl0?gmo@3oo_l0oO_l0?clnP2][J/0
4Q8@0;Zj^03nood0n_ci04D0oooo001P0?ooo`@0o_oo203oool30?ono`80oooo0`3nool80?ooo`<0
ooko00<0ookm0?oon`3moO/00`3oo_l04`3mo?l0`<3000l?3`0100002`T:0>SVi@3ooo/0VIRD05YH
E`2PVil0FeQN0>GTi`3mo?l0nOSk0=oOg`3moOd0OGem0;Jf]P3oool0103nool40?coo`T0oooo0140
o?cl0?knoP3oool0o_kn03`l?00d=3@0ZJVY05MGE`0<30`0?Cdm092@T03WinL0n_[j0?ooo`3kno/0
o_kn0?gmo@020?ooo`0G0?gmo@3oool0oooo0?kon@3ooo40l?7Y010@9P3Rf^d0ooOW07]ZF023Sid0
k_oo0?Woo`3oool0oogj0?olo03on_l0ooco0?_oo`3iooX0o_om0?ooo`3no_h00`3oool02@3moOd0
no_k0?_kn`0Y:BT0g=cL0?ooo`3kno/0oooo0?Win@0B0?ooo`080?clo03kno/0oooo0>GUi@2CTi<0
JVYZ08:2PP3Shn<20?[jnP80oooo00H0no_k0>c/k00I6AT0T92@07UiN@3Ti>@20?ooo`080?clo03n
o_h0oooo0?ooo`3inOT0TI6A0:NWY`3moOd20?ooo`0G0?omo`3onol0ooco0?ono@3loOD0noke0;Ni
/`0F5aL0YJFU0?oon03oo_/0oo_o0?kho`3ooo@0XJ>E0=cNf`3Xjnl0nooo0?[oo`3gno`0o?oo0?ko
o`3in_`00P3oool20?ono`0608V9Q`0I6AL0dM7?0?ooo@3gnOH0o_omA@3oool00600oooo103nool8
0?ooo`<0ooko0P3oool30?koo`P0oooo0`3oo_l01@3oo_d0o?ch0?clnP3oo_l0no[o0080ooko0180
ZJNV00H40`0610L0NgUl0?okn`3oo_/0RhN408^6QP3ooOl0g]_R00T:3P3ko?l0n__o0;o0`P0_<380
5QLI0>[ZjP3moOd20?ooo`@0o_oo0P3lool;0?ooo`0Q0?knoP3oool03Ph>03Ph>03kno/0oooo0?Wi
n@2d];@0IfMW00P8200_;bl0QhN70=cLg03oool0oOgm0?[jnP3lo?`0oooo0?clo03jn_X0ooom0?Gg
lP3oood0]k>m03<Z;@3ooNP0Uhim03HnD03Ymol0noko0?ono`3moo80oood0080ooWo00<0nooo0?So
n`3lood0203oool01`0n?Sh0/[:b0?ooo`3moOd0no_k0?ooo`3no_h0403oool0103kno/0oooo0?kn
oP3kno/20?ooo`0@0?Ogm`3^k^h0YJFU06EUI@1nOWh0fMWI0?_kn`3oool0U9BD0:b/[03inOT0oooo
05QHF03^k^h0oOgm0?_kn`80oooo02@0m?Cd06i^KP3>c/h0oooo0?knoP3oool0o?cl0?kmo`3oo?l0
n?Gl0?gknP3oooP0V9N@01@C3P3>c</0ookj0?oom03gm_40oo_o0?kio`3oo_L0no_^08n?S@3If]`0
nooo0?Ooo`3kool0o?oo0?[ko@3nool0oooo0?Shn03elo@0IVAU03@b<@3[jNP20?ooo@030?_mnP3l
o_/0oooo04@0oooo001P0?ooo`@0o_oo203oool30?ono`80oooo0`3nool80?ooo`<0ooko01L0ookm
0?knnP3ooo/0ooko0?cko`3oo_l0o_kn09BBT@0200004@lB0?ono`3km_P0oo_h0=gIe@0B3P/0lngd
0?omo`1iNGl0RHbA0?coo`3ko?l0loCh0?;cm@040?ooo`H0o_oo2@3oool04`3inOT0oooo0?knoP2]
[Jd0=3@d02LW9`3oool0o?cl0?ooo`3jn_X0m_Kf0?ooo`31`L40JVYZ01TI6@0Z:RX0O7al0=3@d03j
n_X00P3oool04`3no_h0oooo0?koo`3no_h0oOSj0;bd/@1VH4h0HF5D00002`3WkOl0ooco0?ono`3k
oo<0o?oc0?oko`3on_l0o?oo0?Woo`3nool00`3oool00`3no_h0oooo0?ooo`020?ooo`030?gmo@3o
ool0nOWi00<0oooo00<0o?cl0?ooo`3oool03P3oool01@3no_h0oooo0?ooo`3oool0o_kn00<0oooo
01<0o?cl0?gmo@3]kNd0Z:RX075aL@1`L700/K6a0?clo03oool0moOg0?ooo`19BDT0inOW0?ooo`3h
n?P0eMGE05MGE`3Xj>P0oOgm0080oooo01L0oOgm0?clo03mo?l0o_ko0?koo`3oo_d0J6AP02dW903V
h=d0oOWf0?Sgl03oonl0oooh0?gko`3knOl0oOgk0?oom03onoP0KVa_0>gcl`3iool0nooo0>oem@02
0?koo`060?clo03clo<0B4I705=ADP3[jNP0o_ck0P3oood00`3moo`0o_om0?ooo`140?ooo`00H03o
ool40?koo`80oooo2P3oo_l0103oool0o_oo0?koo`3nool80?ooo`<0ooko01T0ookm0?oonP3noo/0
o?_o0?omo`3mo?l0n?Sh05ACC`010000W9ZM0?Sen`3ooOl0ookk0?omm`0O6AL0h]_R0?olo`2VZK00
ADU@0?Wmo`3lool0nOco0?koo`3no_h0oooo00@0ooom00@0oooo0?koo`3nool0o_oo203oool0203k
no/0o_kn0?[jnP3lo?`0Hf=S08n?S`000000oOgm0`3oool07P3moOd0lo?c0?ooo`3hn?P0o_kn0<[:
bP1cLg<0:b/[02HV9P1QHF40aLG50?ooo`3kno/0o_cm0?Wgn03ooOl0oogl0?Gjl`3jooT0EEMD0:j/
[`3on_l0ooco0?Soo@3hooP0oooh0?omn`3oo_l0o_oo0?kmo`<0oooo0P3no_h20?ooo`030?clo03f
m_H0oooo00<0oooo00<0nOWi0?ooo`3oool04`3oool0103lo?`0oooo0?ooo`3jn_X30?ooo`0Y0<71
`@3hn?P0oOgm0:^[Z`1lO7`0Kfm_0;bl_03`l?00o_kn06][J`1eMGD0GemO03<c<`3lo?`0oooo0?_k
n`3Hf=P0DU9B0?Shn03oool0o_oo0?KkoP3[ko00@d=304m9B@3omO@0oo[i09:9Q0030@00O81W0:F]
X00001T0g]om0?koo`3HeL`0oocj08EnP@2b][L0nOoo0?CjnP3kool00P3nool0103Ph>00<Bl`06aZ
J`3jn?T20?ono@040?Wim`3hn?H0o_ok0?Wkn4D0oooo001P0?ooo`@0o_oo0P3oool:0?ono`040?oo
o`3nool0o_oo0?koo`P0oooo0`3oo_l04`3oood0o_oi0?[lm`3mo?l0oogo0?Ofn`3oool03`h:00@3
003lnOl0oogo0?oko@3oo_/0nOC^07A^J`0O61l0m?3j08N9T`1AF6000P3kool0103ko_l0m_[k0?on
o`3jn_X40?ooo@80oooo0P3nool;0?ooo`070?Win@0>3Ph0j^[Z01DE5@3Vi^H0oooo0?KfmP020?oo
o`030?knoP3moOd0oooo00<0oooo01@0l_;b0=CDe02?Shl0:BTY01PH601QHF40/k6b0?omo`3nnOT0
no_k0?Woo`3iood0I6=L05A>B`3onoh0oogo0?Soo`3hood0ooof0?onn080oogo00<0o_go0?ooo`3o
ool00P3oool30?knoP<0oooo00@0m?Cd0?Shn03oool0nOWi4P3oool01@3jn_X0oOgm0?ooo`3oool0
n_[j00<0oooo00<0m_Kf07MgM`27QhL00`3oool03P3jn_X0oooo0<G5a@2<S8`0L71`07AdM01ZJVX0
P8200?gmo@3oool0n?Sh0?knoP3/k>`0410@0P3oool06`3hnOT0h^KU028V9@1aKg00o?Gh0?ofn03o
o?X0Ee180<2n[@3MhL@000<005EFM035aNT0moOm0<G4_@0d;2X03PL:0>__l03`nO/0nOoo0?_oo`3g
no`0d=7C01XH6@2>S8d0ooko0?_inP020?ono@80ooom0P3noo]50?ooo`00H03oool40?koo`80oooo
2P3oo_l0103oool0o_oo0?koo`3nool80?ooo`<0ooko01D0ooom0?oonP3noo/0ooko0?omo`3oo_l0
no_k0040001_KVX0ooco0?ggo`3oo?h0ookk0?okl`3AblP01004061LIP000P/0_lO?0?3go`3ioOl0
0P3lool00`3oo_l0oooo0?ono@030?ono@@0ooom2@3oool04@3hn?P0nOWi0:ZZZP13@d<0n?Sh0?oo
o`3jn_X0no_k0?ooo`3kno/0o?cl0?ooo`3jn_X0oooo0?Ogm`3moOd0no_k0080oooo00h0nOWi0?oo
o`3Ogml0TY:B03ll@P0;2@`0GeeL0:NYY03[lNl0kO?a0;>a/02SWi`0ookg0?oon080o?oo00@0oooj
0?onn@3ooOl0ooko203oool0103no_h0o?cl0?clo03oool20?clo0030?ooo`3moOd0oooo00l0oooo
00@0o_kn0?ooo`3oool0oOgm0P3oool01P3no_h0mOGe0?clo01KFe/0@D510>g]k@80oooo00H0nOWi
0?ooo`3oool0o_kn0?clo03inOT20?ooo`0<0?clo03oool0nOWi0?ooo`3moOd0oooo00h>3P3bl_80
o?cl0<O7a`0E5A<0TY:@0P3oo_l05P3jmOL0ookk06ATF02?T7`0oooT09ZJS@0;1BL0o_Oo0?_go`3o
ooX0ookk0?[jn03kool0n?oo0?CloP3fnoh0]k^l01@E5`2]Zj`0ooko0?klo@3oo_l20?ono@040?oo
n`3fm_80oOoj0?gonTD0oooo001P0?ooo`@0o_oo0P3oool:0?ono`040?ooo`3nool0o_oo0?koo`P0
oooo0`3oo_l02@3oood0o_ok0?cnn`3oo_l0o?[o0?ono`2o_kl00@000?Sgl`020?olo`080?omo`3o
o_/0oocf0??]jP0S7240l^kh0?cno`3eo?l20?_oo`040?coo`3nool0oooo0?gmo@@0ookm0`3oood<
0?ooo`040:BTY03>c/h0oooo0?[jnP80oooo00<0oOgm0?ooo`3no_h00P3oool00`3jn_X0oooo0?[j
nP020?ooo`040?gmo@3oool0oooo0?_kn`80ooko0140iNCW09NGU@1@DTd00PH304]?CP2RX:40k^c[
0?oom@3oooH0ooom0?ooo`3ooo/0ookj0?ono@3oo_l0oooo0?koo`020?ooo`80o_oo0P3oool00`3o
o_l0o_kn0?ooo`040?ooo`030?knoP3oool0oooo00h0oooo00@0o?cl0?ooo`3oool0o_kn103oool0
0`2b/[80D51@0?Cdm0020?ooo`070?[jnP3oool0o_kn0?knoP3oool0oOgm0?ooo`030?knoP0F0?cl
o03oool0oooo07UiN@2HV9P08B4Q0=?Cd`2VYZH04a<C0;Rf]@3oo_d0o_cm0?knoP3oool0o?ch0;fn
]00m?R`0oooU0?gjk`0C2RL0gMGh0?olo`80oOgk00L0o_oo0?[oo`3do?`0nooo09ZMX@0@4A<0b<S8
0080ookm00P0ooko0?[io03oo_l0o_ck0?CdlP3oood0o_oo0?gnoTD0oooo00200?ooo`030?koo@3n
ool0ooko0080ooko00<0oooo0?ono@3oo_d00`3ooOl0303oo?`0oogm0?3ZjP0P6A`0`;[10?cjo`3m
oOl0o_ko0?_ko`3mo_l0ooko0?knoPD0ooom903oool02`3oo_l0o_go0?ooo`3oood0j^_[0:^[Z`1B
D54040h=0450?02DThl0iN?R0080ookm00L0oogl0?ono@3oool0nOgn0?coo`3oo_l0no[m0080o?oo
00P0nOWg0?ono@3oo?`0ookm0?koo@3moo`0o_cm0?ono`80o_oo00<0oooo0?knoP3no_h01@3oool0
0`3jn_X0oooo0?knoP020?ooo`80oOgm00@0o_kn0?clo03oool0oooo0P3moOd0203oool0o?cl0?oo
o`3Jf]X0oooo0?Win@3oool0o?cl0P3oool00`3kno/0oooo0?ooo`060?ooo`0E0?knoP3kno/0m_Kf
03hn?P0L71`0UiNG01hN7P3Cdm<0o_oo0?koo@3jno/0o_kl0?ooo@3kn_H0o_gf061ME02ETXL0oogi
059>F02KUjD0o_go0080o_oo00l0n?_o0?Sln`3lool0LG9f02HW:`3Ogmd0oOcg0?onn03nn_H0ooko
0?[ko`3mnoh0ooko0:j^[02c];@00P3lool00`3nool0oooo0?ooo`120?ooo`00P03oool20?koo`@0
oooo0P3oo_l03`3ooOl0n??e0?omo`3jmOL0oo_n0=gFf@2VWj80a;o30?olo`3mnol0noWo0?ono`3i
n?d0o_kn0?ooo`050?ooo@80oooo0P3oo_lP0?ooo`80o_oo0P3no_h20?ooo`0D0?kln`3knOP0/[2_
05aJF@0I5aH0;R`[08F3PP3OgM`0ookm0?knoP3ioOh0o?oo0?omo`3oo_l0o?oo0??im`3oood0oo_k
0?omo@3oood20?coo@80oogo00<0oooo0?koo`3oool00P3oool0103no_h0oOgm0?gmo@3no_h30?oo
o`030?knoP3kno/0oOgm00D0oooo00D0n_[j0?ooo`3oool0iNGU0?[jnP020?ooo`060?[jnP3oool0
oooo0?knoP3oool0mOGe2@3oool02P3no_h0oooo0?knoP3Shn<03`l?04a<C03]kNd0oOkn0?Sin@3f
n_T20?koo@0M0?_jmP3noOT0ookj0?onnP2?RhP0LVi[01LE5P1BDE@0no[o0?clo`3ko_l0o?oo0??g
mP1BE540?ci30>cZk@3ooo/0n?G^0?onm03oo_L0noko0?cno`3Xi^T0X9^K08V5PP0];Bd0e][U0?Cj
o`3nool0A03oool00800oooo0P3nool40?ooo`<0ooko00X0noWj0?omo`3ooOl0V96D0=WBe@3onoh0
ooco0<g9d`2BT9/0oogo0P3noOl00`3moOd0oooo0?clnP040?ooo@80oooo0P3oo_lP0?ooo`030?kn
oP3oool0oooo00<0oooo0P3ooO`04P3mnoX0ookm0?Oem038a/D0JFUY01DE5@0X:2P0Ng]k0<W=c03n
ool0noWj0?ono`3cmoH0nooo0?clo03knOX0ooko0?gmo@80n_km00@0oocn0?omo`3oool0o_oo103o
ool00`3no_h0oOgm0?ooo`020?ooo`0C0?Win@3oool0oooo0?knoP3lo?`0no_k0?Win@3kno/0oooo
0?_kn`3oool0c/k>07AdM03oool0o_kn0?ooo`3moOd0o?cl0?ooo`020?clo0X0oooo00L0o_kn0?gm
o@3oool0o_kn06e]K@0:2PX0alO70080o_oo0200o?oo0?koo@3lo_/0oook0?gln03oo_/0ooci0?om
nP3ln?D0nOOh00400`3Yj>d0o_ko0?coo`3VjNh0=S`l05YNG@3dl_D0noKh0?onn`3oooH0ooc^0?oo
n03dn_l0n?_o0?omo`1?B400fmC<06ITH`3GgNT0n?oo0?cood@0oooo00200?ooo`80o_oo103oool2
0?ono`0:0?[hn@3oo_l0n_Gg0?ghnP3bjnh0>c@g0?ohn`3mn?`0:bLa0>OUkP80ooko00@0m_Gj0?on
o`3moOd0o?cj103oood20?ooo`80ooko8@3oool00`3no_h0no_k0?clo0020?ooo`060?ono@3ooO`0
ookm0?ono@3no?/0o?cl0P3oool05039bLT0M7Ee02<T900O7al0LVe_0<:m_`3ioO`0nooo0?ooo`3o
o_l0nOOj0?knoP3kool0o?oo0?omo`3oo?l0oooo0?gnoP3moOd0o_kn1@3oool00`3no_h0oooo0?_k
n`020?ooo`0=0?gmo@3no_h0o_kn0?ooo`3moOd0oooo0?_kn`2k^k/05ADE0<g=c@3oool0o?cl0?[j
nP020?ooo`050?gmo@3oool0oooo0?Win@3lo?`02@3oool02`3inOT0oooo0?ooo`2YZJT0?3`l01lO
7`3XjNT0n?Wi0?Gin03nood0l_Ca0080oook01/0oOWf0?onn`3oo_/0oogm0??alP0P8200][Fj0?Kg
n`3PhnP07R4V07IlO03fn_T0ooko0?omo`3onoP0o_Wa0?ook@3oo_L0lOko0?;lo`3ooOd0n^_S08=i
K@2:QX<0_LCB0?Ooo`3lool0A03oool008H0oooo0`3oo_l03`3jn?T0oogo0?omo`3ooOl0Yj:T09ZE
U`2GTYH0[:V`0?omo`3kn_l0m??h0?glo`3oo_l0oOgm0?ooo`040?ooo@80oooo0P3oo_lP0?ooo`03
0?clo03oool0oooo00<0oooo00<0o_kn0?ooo`3fm_H00P3oool05P3ko?h0o_oo0?koo`3in_`0o_oo
0?ooo@3=blX0R8:203@_<@0G6aX0GVAT0;Ff^03em?L0ooko0?gno`3eno/0o?oo0?omo`3mm_T0noWh
0?ooo@3moOd20?knoP060?gmo@3no_h0oooo0?ooo`3kno/0oOgm0P3oool02P3gmoL0o_kn0?ooo`3l
o?`0no_k0?ooo`3moOd0i^KV00l?3`38b<P20?ooo`090?_kn`3oool0no_k0?ooo`3lo?`0oooo0??c
l`25QHD0oOgm00X0oooo02L0n_[j0?ooo`35aLD0<30`07]kN`0f=cL0o?gm0?coo`3lo_/0o_om0?gk
nP3hm_D0ookk0?okn03km_H0oo_k0>7Oh02MWId0_;_00<[;c`0<3a@0WJ2U0?_oo`3lool0n?Oj0?on
o`3no_X0ookd0?ofi`2QV9<000XM0<?Ll03hko00ooW_0?ogk00R71T0GFIe0?;oo`3kool0A03oool0
08H0oooo0`3oo_l0203no?d0oOSj0?omo`3gl_@0oogo02dX:P14@TD0o__o103oo_l00`3noOl0oooo
0?clo0040?ooo@80oooo0P3oo_lS0?ooo`030?knoP3kno/0o?cl00<0oooo00@0o?cl0?koo`3nool0
nocn0P3nool04@3moOd0ookm0?onn`3on_/0oo_k0=KJf@2<TY80@T=7014@5@1EE5T0ZJZ^0?3en03l
ool0oo[l0?olo`3oo_d0no_i00<0oooo00P0o?cl0?gmo@3oool0oooo0?knoP3jn_X0oooo0?knoP80
oooo00d0no_k0?knoP3oool0m_Kf0?ooo`2ZZZX0emOG0?ooo`3inOT0o_kn0?ooo`3no_h0oooo0080
no_k00@0oooo0;>c/`16ATH0o_kn203oool05`3kno/0nOWi0?ooo`3no_h0i^KV01XJ6P3no_h0De=C
069SH`3lool0n?[g0?clnP3jn_P0ookm0?onn`3oo?T0oogm0?ono@3oo_l0oooo0:VXZ`0>3a<0^KVo
00<0o?oo00l0oOco0?ono`3lnoL0ookf0?okk@2j/J`0?55T09fcb03oo?d0oo7V0?ogj`3oo?T0Hfai
0>gjo`3kool0A03oool008P0oooo00<0oogn0?klo@3ln_/00`3oo_l0203XhnD0jNOZ0?kko`3jnOl0
o_go0?ono`3lnoh0nOSk0P3oool20?ooo@@0oooo0P3oo_lP0?ooo`040?gknP3no?/0ookm0?ono@80
oooo00<0o_oo0?_loP3in_`00P3nool05P3in_`0o?go0?gno`3ko?h0oooo0?kjm`3ooOX0oock0?om
o@3lool0m_cl0>obmP3[jo40UiNM0495B@0=5AL0@TQ80:^VZ03]i^T0oocl0?ono@3jn_X30?ooo`03
0?knoP3oool0oooo00<0oooo00T0n?Sh0?ooo`3no_h0no_k0?ooo`3hn?P0oooo0?Shn03fm_H00`3o
ool01@3no_h0n_[j0?_kn`3oool0n_[j0080oooo00<0FUYJ096AT@3oool0203oool02P3moOd0oooo
0?ooo`3lo?`0oooo030`<03clo<0m?Cd02h_;`2:Rh/20?ooo`0M0;fm^`30`;h0moGd0?ono@3gmO@0
ookm0?omoP1oOgl092<V0=;Ce@3loOl0o?oo0?_oo`3gnoX0o?[m0?olo`3ooOd0o?Oa0?ool@3Yj^80
20dN0>oao`3ooOl0oogd0?omlP3in?@0mO_o0?Soo`3lool0A03oool008P0oooo00P0oogn0?ono`3o
o_l0oogn0?klo@3imoP0oogo0?cjo@<0ooko00<0n_Wl0?ono`3oo_l00P3moOd20?ooo@@0oooo0P3o
o_lP0?ooo`@0ookm0P3lo?`30?koo`80o?go0`3nool0503mo_l0o_kn0?onn`3onoP0]Zb[00h8203O
hn80nooo0?coo`3knol0o_ko0?_no`3UkNl0Z:j^04]6BP0D3A00AD1009VGUP3]kNd0n?Sh0P3oool0
3P3no_h0oooo0?ooo`3no_h0no_k0?ooo`3moOd0oooo0?Win@3oool0m?Cd09JFUP3oool0oOgm0P3o
ool00`3kno/0o?cl0?ooo`020?ooo`070?_kn`3oool0oooo0?gmo@0@4100j>SX0?clo00:0?ooo`0<
0?[jnP3kno/0oooo0?ooo`3inOT0oooo0=_Lg00J6a/0^KVi0?clo02RXZ00FUYH0`3oo_d0603elo80
IfMW03De=@3Og^40ooko0?koo`3mo_l0nOgj0?coo@3oo_l0ooWo0?olo03oo_X0nocb0?oonP0W8bd0
b/KD0?cjo@3noOT0oOkh0?koo@3dn?l0nooo0?kood@0oooo002:0?ooo`/0ooko6`3oool00`3jn_X0
oooo0?ooo`030?ooo`80o_kn203oool40?ono@80oooo0`3nool03P3mo_l0n__m0?koo`3kno/0o_kn
0?[jnP3oool0o_gi0?onn`3om_L0HeeM0?3dl`3kool0noko0P3no_l02`3lool0m_ko0?Klo03ooOl0
mo3c0:jYZ@1MFeX04a<C03Ph>029RHT0f][J0080oooo00D0no_k0?ooo`3moOd0oooo0?[jnP020?oo
o`060>o_k`15ADD0SXj>0?clo03oool0n?Sh0P3oool02`3no_h0oooo0?ooo`3hn?P0oooo0?knoP3o
ool0`l?302h^;P3oool0o_kn0100oooo00h0o_oo0<;3``0E5AD0fm_K0;bl_014A4@0o?[i0?ono@3g
mOH0@d5204a<C03hn?P0lO3c0?ono`80o_oo0140oook0?ooo@3lool0o?oo0?koo`3oood0oogm0?om
n`2DT8d0MWAe0?ono`3hn?h0o?oo0?_oo`3lool0oOko0?ono`140?ooo`00RP3oool:0?onoad0oooo
00H0o?cl0?knoP3inOT0nOWi0?ooo`3moOd90?ooo`@0ookm0P3oool20?koo`030?_loP3mo_l0oOko
0080oooo0P3oo_d0603ln_T0ooom0?ono@3ooOd0ViJH0;Nk_03kool0nOco0?koo`3inOl0o?oo0?Wo
o`3kool0oogo0?olo`3oo_d0ooom0?Cdm02m_Kd0JFUY018B4P0a<C40Ng]k0=;BdP@0oooo00@0mOGe
0?_kn`0e=CD0J6QX103oool02`3kno/0oooo0?[jnP3oool0no_k0?ooo`3hn?P0no_k0?ooo`1aLG40
QHF50180oooo0240nO[j0?gnoP2KVi/0:BTY0=WIf@0I6AT0ookm0>3Ng@0Z:2T0L6i_0?clo03no_h0
ooko0?kmo`3hnO/0o_kl0?oonP3ooo/0o?oo0?_oo`3lool0o_oo0?omo`3ooOd0i=O>01T>203alOT0
n?oo0?Goo`3foOl0oooo0?ono@3oo_l0A03oool00;00oooo00<0oOgm0?Ogm`3oool00P3oool00`3l
o?`0oooo0?Win@080?ooo`@0ookm00<0oooo0?koo`3nool00`3nool0:@3oool0moOg0?cjn@3oo_/0
oo_h0?Gdl03loOd0n?Wi0?ojo03Ng=l0Jg5a0?Gmo@3nool0n_Wl0?ono`3mo_l0n?kn0?coo`3onod0
oOKi0?Wgn03lo?`0oooo0?_kn`3lo?`0oooo0<K6aP1bLW80820P01lO7`1eMGD0b/[:0?Shn03oool0
_Kfm07alO03oool0n_[j0?ooo`3fm_H0no_k00<0oooo00<0oOgm0?ooo`3moOd00`3oool00`0H61P0
f][J0?gmo@0D0?ooo`0:06ATI011@D402@T90=cLg00L71`0Shn?0?ooo`3inOT0oooo0?Shn080oooo
00<0oOgk0?oonP3ooo/00P3no_l03@3oo_l0o_oo0?Goo`3lool0on_Q03XM5`3Nh>X0jOco0?3oo`3c
ool0oo_h0?oln@3ooOd0A03oool00;80oooo00D0moOg0?ooo`3oool000000?knoP090?ooo`<0ookm
00<0oooo0?koo`3nool00P3nool04P3loOl0moOg0?ooo`3oo_d0o?Se0?omnP2JU940510=0<c@d@3j
ool0ooko0?cko`1DFUX0lo_k0?koo`3ooOh0o?[k0?knoP80o?oo0P3ooOl00`3oool0o_oo0?ooo`02
0?ooo`0<0?KfmP3jn_X0oooo0?Win@3AdM40N7Qh02XZ:P0K6a/0KFe]0:2PX03oool0n_[j103oool0
3@3hn?P0no_k0?_kn`3oool0oOgm0?ooo`2?Shl0IVIV0=CDe00L71`0oOgm0?knoP3kno/0403oool0
303moOd0n_[j0?_kn`3oool0A4A400P8201HF5P0[Jf]0?knoP3jn_X0oooo0?knoP80oooo00@0n_[j
0?ooo@3oooP0oook0P3no_l03@3oo_l0o_oo0?Coo`3lool0oo7W03<D3`2OXJ/0k_oo0?3oo`3dool0
o?Se0?omn03ooOd0A03oool00900oooo103ooodL0?ooo`070?Shn03oool0o_kn0?ooo`3hn?P00000
0?knoP090?ooo`80ookm0P3oool40?koo`0?0?knoP3oool0n_Sg0?oln@3ooOX0oocg0;F/Y@19AD40
/KJi0?Ooo`3gn_l0d];H01LO8@36c<`0no_k0080oogm02@0ookm0?coo@3ho?/0oOSj0?oloP3nool0
n_ko0?cmo@3kno/0oooo0?knoP3kno/0n?Sh0?ooo`3no_h0oooo0<g=c@3Jf]X0S8b<03Lg=`0;2`/0
HF5Q0;6a/@3^k^h0oooo0?_kn`3oool0oOgm0?clo03oool0o_kn0?KfmP2d];@0De=C08F5Q@1_KflE
0?ooo`060?clo03oool0lO7a00/;2`1VIVH0oOgm0P3oool02P3hn?P0o?cl0?clo03no_h0ooom0?Sh
m03oooX0oook0?kno`3lool20?koo`0;0?coo`3oo_l0jmO>0;NSWP2[[KL0lOgo0?Coo`3hool0oook
0?ggm03oo_d0A03oool00900oooo103ooodP0?ooo`030?[jnP071`L0oOgm00T0oooo0P3oo_d20?oo
o`@0o_oo01/0o_kn0?ono@3oo_/0ooci0?gel03ooOH0mncT014;203]m?P0m_oo0?_oo`3ko_l0mooo
0?Cjn03no_`0ookk0?omn`3ooOX0o?kk0?koo@3ooOl0ooko0?coo`3jo_l0o?gm0?ooo`3emOD0103o
ool03@3moOd0YjNW05=CD`3kno/0oooo0?_kn`3Shn<0WYjN03hn?P0?3`l0F5QH09nOW`3Zj^X00`3o
ool00`3lo?`0oooo0<_;b`0202l_;`040<71`@3inOT0oOgm0?gmoA00oooo00T0nOWi0?clo03no_h0
o_kn0?clo01?Cdl01PH60<[:bP3jn_X00P3oool02P3no_h0oooo0?clo03oood0oook0?oonP3ooo/0
o_ko0?coo`3nool20?ono`0:0?olo`3onoH0oo_j0?kno`3hool0l__n0?Woo`3lo?X0oook0?onod@0
oooo002<0?ooo`@0o_oo103ooodL0?ooo`80o_kn00H0n?Sh0?ooo`3oool000000?ooo`3lo?`80?oo
o`80ookm0P3oool40?koo`0?0?ooo`3mnoX0oo_h0?omnP3ooOH0oo_c0?ojlP0/9R<0_LO<0?Coo`3d
n_l0nooo0?;ko@3iool0ookm0080oogk00D0ookj0?kon`3nood0oo_m0?[hn@020?_oo`0<0?cmo@3o
ool0oooo0>o_k`3oool0o_kn0?clo02>SXh06ATI0>_[j`3oool0m_Kf0P3oool04@3moOd0oooo0>WY
j@2PX:00E5AD00@4101<C4`0TI6A0>7Qh@3oool0o_kn0?7al@071`L04A4A0?_kn`3oool0no_k0140
oooo0P3oo_l02P3oool0l?3`0?ono`24PhH0F5UK01LH6P3XjNT0oOkn0?KfmP3oool20?ooo@050?_i
n03lo?P0oooj0?ooo@3nool00`3oo_l02P3oool0ooko0?oko@3onOd0o?_o0?_oo`3dn_X0n?kj0?ko
o`3jn_Y50?ooo`00S03oool40?koo`@0ooom703oool01`3no_h0oooo0?knoP3oool0o?cl00D51@3l
o?`02@3oool20?ooo@80oooo103nool0503no_h0ookm0?onn`3nnO<0ookf0?oil03ooO<0U92<07Am
PP3cool0nOoo0?Wmo`3iool0nooo0?ono@3oo_/0oogk0?onn`3no_X0oOol0P3oo_l0103lool0nOgn
0?koo`3emOD20?ooo`060?_kn`3moOd0h^;R02LW9`3UiND0no_k0P3oool00`3jn_X0oooo0?knoP02
0?ooo`0;0?clo03oool0lo?c0:ZZZP1NGUh03@d=03`l?02=SHd0i>CT00h>3P1ADE400P3no_h00`3o
ool0o?cl0?ooo`0?0?ooo`0:0?ono`3gmOH0oooo0?ooo`3jnO`0VIRK05aMG`2c];H0LG9b0?cmo@80
oooo00H0oOgk0?ooo@3oo_d0ooom0?oon`3nood40?ono`060?ooo@3oo_l0ooco0?ojo`3oo_l0nOgn
0P3lood00`3jno/0o_oo0?ooo`140?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@4100X0oooo
00@0ooom0?koo@3nool0o_oo1@3oo_l04@3ooO`0oo_h0?oon03ooOD0ookd0?oikP3MfMD03`lG0?Sj
o`3kn_l0o_ko0?gmo`3nool0n_[j0?ono@3ooO`0ookm0080ooom00@0oooo0=;BdP2WZ:X0o_oo0P3o
ool01P3lo?`0oooo0?ooo`3kno/0clo?0>k^kPT0oooo00d0o?cl0?ooo`3oool0no_k0?ooo`3alO40
^KVi06ATI00k>c/03@d=08^;R`3moOd0o_kn01D0oooo00D0no_k0?ooo`2n_[h0A4A40?clo0080?oo
o`040?ooo@3oool0ooko0?ono`@0oooo0`3oo_l30?koodL0oooo002a0?ooo`050?knoP3oool0oooo
0?knoP010@402P3oool20?koo@80o_oo1@3oo_l02@3oo_d0ookk0?onnP3lnO00oogb0?onm03jm_80
8QlV0=gKj0020?omo`040?glo`3oo_l0ooko0?knoP80ooom00H0moOe0?clnP3oool0k>c/01@C5P3i
n?/20?ooo`030?_kn`3gmoL0o?cl0080oooo00<0oOgm0?ooo`3oool01`3oool0103jn_X0oooo0?oo
o`3jn_X20?ooo`090?_kn`3moOd0moOg00410@2QXJ40oooo0?gmo@3oool0o?cl0100oooo00L0o_kn
0?gmo@3oool0oooo0?knoP3kno/0eMGE05h0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40
2P3oool20?koo@80o_oo103oo_l04P3ooOh0ookm0?onn`3oo_X0ooce0?oomP3ooo@0lno[01lL8`2O
WJX0o_co0?omo`3mo?l0o_go0?ono`3oool0ooom0?clnP80ooom00P0oooo0?_kn`0^;C00`;o20?[j
nP3inOT0kno_05mOG`80oooo00<0moOg0?ooo`3oool0203oool01@3lo?`0o_kn0?ooo`3kno/0nOWi
00<0oooo00L0YJFU024Q8@2:RXX0o?cl0?ooo`3hn?P0o_kn0100oooo00D0o_kn0?ooo`3oool0o_kn
0?clo0020?ooo`030?clo03oool0oooo05/0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40
2P3oool20?koo@80o_oo1@3oo_l03`3no?d0oOSh0?onn`3oo_X0oooh0?gjl@3Ui=l0XYnV0<;0b`3l
n_l0oOco0?ono`3noOl0o_kn0?gmo@020?[jn00>0?ooo@3jn_P0n_[j0?ooo`1lNgh0NGQk0?ooo`3H
f=P0:2PX09jNWP3oool0o_kn0?ooo`3lo?`80?ooo`040?gmo@3oool0o_kn0?knoP<0oooo00P0n_[j
0?_kn`1PH600EEEE06UYJ@3oool0nOWi0?_kna40oooo00L0oOgm0?ooo`3oool0o?cl0?ooo`3jn_X0
nOWi05h0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@402P3oool30?koo@030?koo`3oo_l0
ooko00@0ooko00P0oogn0?ono@3ooOX0ooch0?onnP3jnOD0oogo0?glo`<0ooko00<0oOgm0?knoP3o
ood0103oood02@3oool0no[m0<?2a@0d<cH0kNg]01`L702IVIT0o_kn0?_kn`0;0?ooo`040?[jnP3o
ool0oooo0?clo0@0oooo00H0o?cl01<C4`2EUID0DU9B0?ooo`3kno/C0?ooo`030?knoP3oool0oooo
00<0oooo00<0o_kn0?ooo`3oool0F`3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn00410@0:0?oo
o`@0o_om00D0oooo0?ono`3oo_l0ooko0?gkoP030?ono`0;0?omo@3onoP0ookk0?ono@3gm_T0ooko
0?cko`3oo_l0oooo0?knoP3no_`00P3oood0103emO<0ooom0?ooo`3lnoh20?ono`0300/:3@25QHD0
^[Zj00<0oooo00<0n_[j0?knoP3kno/02`3oool02P3moOd0o_kn0?_kn`3jn_X0o_kn0<G5a@1:BTX0
iNGU075aL@3dm?@20?ooo`030?clo03oool0oooo00h0oooo00D0o_kn0?ooo`3jn_X0oooo0?_kn`02
0?ooo`030?Win@3oool0oooo05/0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@402P3oool4
0?koo@80oooo0P3oo_l00`3mo?l0ooko0?cjo@020?ono`060?kln`3ooO`0oO_l0?ooo`3oo_l0n_Wl
0P3oool20?ooo@060?_kn@3no_`0ooom0?ooo`3lo?`0moKi0P3oo_l0201CDUD06ATI0::RXP3kno/0
oooo0?knoP3oool0o_kn2P3oool20?_kn`D0oooo00<0IVIV08R8R03no_h00`3oool00`3gmoL0oooo
0?ooo`0?0?ooo`030?[jnP3oool0nOWi0080oooo00<0no_k0?ooo`3oool0G@3oool00;40oooo00D0
o_kn0?ooo`3oool0o_kn00410@0:0?ooo`@0o_om0P3oool40?ono`0;0?klo`3oo_l0ooko0?gko03o
oOh0ooko0?clo03oool0oOgm0?ooo`3no_`00P3lo?X30?ooo@090?knoP3oool0ooko09fLW`3noOl0
V9NJ04a<C00H61P0YjNW0080oooo00<0no_k0?ooo`3kno/0203oool01@3no_h0oOgm0?ooo`3no_h0
no_k0080oOgm00D0nOWi00l?3`3WinL0oooo0?knoP020?ooo`030?knoP3oool0oooo0100oooo00@0
nOWi0?ooo`3oool0oOgm0P3oool00`3lo?`0oooo0?ooo`1K0?ooo`00/@3oool01@3no_h0oooo0?oo
o`3no_h00@4100X0oooo0P3nood20?ooo@80oooo2@3oo_l20?ooo`L0ooom01L0o_kl0?ooo@3oool0
mOGe079aM01CDUD0ooko0=oNh@0G5aL0e]KF01LG5`2IVIT0oooo0?knoP3jn_X0oooo0?[jnP3oool0
o_kn0?ooo`3jn_X0oooo0?[jnP020?ooo`040?[jnP3oool0oooo0?Gem@80oooo00@0[Jf]0451@@3o
ool0oOgm0`3oool00`3hn?P0oooo0?ooo`1d0?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@41
00X0oooo0P3nood20?ooo@80oooo2@3oo_l20?ooo`P0ooom00l0nOWg0?knoP1PH600?3/n0>o^l@3n
oOl0ooko02DU9@37alL0iNGU01dM7@2GUiL0no_k0?ooo`3inOT00P3oool01P3moOd0o?cl0?ooo`3n
o_h0oooo0?clo0<0oooo00P0o?cl0?ooo`3moOd0o?cl09RHV02m_Kd0oooo0?Win@80o_kn0P3oool0
0`3lo?`0oooo0?ooo`1c0?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@4101@0oooo1@3oo_l2
0?ooo`D0ooom103oool00`3Lg=`0C4a<0?Win@020?ooo`0?0?clo02RXZ80/;2`0?clo03Ph>0092@T
06MWI`3fm_H0oooo0?clo03moOd0oooo0?Ogm`3hn?P0o?cl0080oooo00<0o?cl0?ooo`3gmoL00P3o
ool00`3no_h0nOWi0?ooo`020?ooo`060?gmo@3no_h0oooo0?gmo@3oool0oOgmM@3oool00;40oooo
00D0o_kn0?ooo`3oool0o_kn00410@0E0?ooo`@0ooko0P3oool40?ooo@<0oooo00L0oOgm0?_kn`3n
o_h0o?cl0?ooo`3hn?P0n_[j0080oooo00X0oOgm0?[jnP3oool0jn_[06ATI00O7al0d=3@0?ooo`3l
o?`0no_k0`3oool00`3hn?P0oooo0?ooo`020?ooo`0<0?clo03kno/0oooo0?ooo`3hn?P0o?cl0?kn
oP3oool0oOgm0?ooo`3kno/0o?clMP3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn00410@0@0?oo
o`D0o_om1@3nool50?ooo`<0ooko00D0o_go0?ono`3oool0oooo0?Ogm`020?ooo`050?_kn`3lo?`0
o_kn0?ooo`3lo?`00P3oool01@2SXj<061PH09BDU03hn?P0oooo0080o?cl00@0no_k0?ooo`3oool0
o?cl0P3moOd20?ooo`070?Shn03no_h0oooo0?[jnP3oool0o?cl0?gmo@020?ooo`030?knoP3oool0
oooo07@0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40403oool60?koo@@0o_oo103oool5
0?ono`040?Ofn@3oool0nOWi0?knoP@0oooo00X0nOWi0?[jnP3oool0o?cl0?gmo@3no_h0f=SH034a
<@1LG5`0g=cL0`3oool02P3gmoL0oOgm0?gmo@3oool0XZ:R0<k>cP3oool0kno_06UYJ@3hn?P20?oo
o`060?Shn03oool0o?cl0?knoP3oool0oOgmM@3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn0041
0@0:0?ooo`80ooko103oool90?koo@030?koo`3oool0ooko00P0ooko00@0o?cl0?ooo`3oool0oooo
0P3oood05`3oool0n_[j0?ooo`3jn_X0o?cl0?ooo`3moOd0oooo0?knoP1dM7@04a<C06a/K03Zj^X0
oOgm0?ooo`3lo?`0oooo0?clo02n_[h0:b/[0?gmo@29RHT0IVIV0080oooo00L0no_k0?gmo@3oool0
no_k0?clo03oool0oOgm07D0oooo002P0?ooo`80ooko00L0oooo0?koo@3nood0o_om0?ono`3ooOl0
ooko0080oooo0P3nood01@3oood0ooko0?ono`3oool0o_kn0080oooo00<0o_kn00410@3oool02@3o
ool20?ono`@0oooo2@3nood00`3nool0ooko0?ono`020?ono`@0oooo01l0oOco0?kmo`3oo_l0o?cl
0?glo`3oool0n_[j0?ooo`3lo?`0oooo0?Whn`3oool0o?ch0?gnn03ooo/0nOWi0?cmo`3nool0j>KY
075_LP0B4aD0P8610?Gem@3no_`0n_[j0?ooo`3kno/0:BTY0<71`@0b<S80_kno00<0o_kn00D0oooo
0?_kn`3oool0oooo0?gmo@1f0?ooo`00W`3oool04`3oo_l0oogo0?omo`3nool0o?ok0?_on03loo/0
ooco0?oko`3lnOl0oooo0?Sjm`3io_P0o?oh0?konP3oo?l0oo_o0?ono`3no_h00P3oool00`3no_h0
0@410?ooo`0I0?ooo`80oogo0P3oo_l07@3oood0oook0?kon`3nood0o_oo0?Wjo03ko?h0o_oo0?_l
o`3nool0o?_n0?knoP3no?d0ooko0?_ko`3nool0o_ka0?gnk03oooH0o_om0?Wmo`3lo_l0ooco0?oi
o`3HgN40DEUI01XJ602=S8P0iNGS0080oooo00@0UYJF03dm?@0P8200nOWiOP3oool009l0oooo01<0
ooko0?omo`3ooOl0o_oo0?_on`3iooP0nook0?olo`3onol0ooco0?ooo`3nood0o?ok0?_om`3dm_00
ooco0?oko`3oo_l0o_kn0080oooo00<0o_kn00410@3oool0603oool02@3oo_l0oogo0?omo`3oo_l0
ookm0?oon`3oooX0o_oj0?kon`040?koo`0L0?Oho03oo_l0ooko0?ono`3ooOd0nOOh0?_no`3lool0
nOW]0>_/fP0;3080@DE202T`>03alol0o_So0?olo`3kool0nOoo0<g=c@1PGUd03`l?04Y:BP2TY:@0
kno_010@403?cll0oooo0?gmoGd0oooo002P0?ooo`80ooko0100o_oo0?coo`3kood0o?om0?ono`3o
oOl0ookm0?Wim`3gn?P0o?oo0?coo@3nood0ooko0?oko@3oo_l0o_kn0P3oool00`3no_h00@410?oo
o`0H0?ooo`050?ono`3ooOl0oogo0?ono`3oood00P3ooo/08P3noo/0o_om0?gnoP3nool0oOco0?on
o`3mo?l0ooko0?ono@3lnoL0lNgY09bJV@2KWZD0YJR_0?ono`3oooX0gnCM09nUX@3Xj_@0o?co0?ck
oP3oood0nOgl0?coo`3oo_l0oOco0?[io02MWId0C4a<00l?3`0h>3P0LG5a0?ooo`3lo?am0?ooo`00
X03oool00`3oo_l0oooo0?koo`020?coo`030?koo`3oo_l0oogo0080ookm0P3nool01P3ho?T0o_om
0?ono`3oo_l0oooo0?knoP80oooo00<0o_kn00410@3oool06@3oool20?ono`050?ooo`3oood0ooom
0?oon`3nood00`3nool05@3kn_d0ooko0?ono`3ooO`0ookj0?oon`3ooOd0hn7R010A5@3EeM/0oogo
0?glo`3gnoP0f]kM08j>UP3inOl0o_oo0?_mnP3gn?X0o_oo0?Sio@020?ono`060?gmo@3oool0h^;R
096AT@0D51@0k^k^OP3oool00:00oooo00l0oogo0?ono`3noo/0o?oj0?con`3nood0ooko0?omo`3l
m_d0ooko0?gonP3hoOH0o_oj0?kon`3mnoh00P3oo_l01@3no_h0oooo0?ooo`3no_h00@4101d0oooo
0`3oood20?ooo`@0ooko01D0oocl0?chm@3oooP0oogm0?_go`3nn_l0L6aY0:2OV`3moOl0o?oo0?on
o`3oool0a<O<09FHW@3mo_h0o_oo0?_ko`3no_l0o_om0?kon`3emO<00P3oool0103^k^h0m_Kf055A
D@2FUYIn0?ooo`00W`3oool30?ono`0@0?oon03oooH0oooh0?oon`3nool0o_ko0?omo`3oo_l0oooj
0?oom03oooH0oook0?Sio@3no_l0ooko0?knoP80oooo00<0o_kn00410@3oool06`3oool40?ooo@03
0?ooo`3oo_l0o_go0080ooko01`0oO_l0?omnP3oo_X0ooge0=[Ee@0000h09R4a08f5PP1VHE/0mOco
0?Woo`3[i^P0noKf0>O/l00k@TP0moSl0?Ofn`3mnol0o_ko0?gon@3ko_D0ooom0?knoP3kno/05ADE
0>KViP30`<009bLWOP3oool009l0oooo01<0o_oo0?Woo`3lool0ooof0?oml`3onoH0oocj0?_oo`3g
ool0nOoo0?ShoP3oooP0oogb0?kcj`3ooO/0nooo0?Soo`3lool0o_kn0080oooo00<0o_kn00410@3o
ool06@3oool40?ooo@80oooo0P3oo_l0803ooOl0ooco0?ojoP3nnO/0oogk0?onn03on>h0^kNd00T8
603onol0:Q/N01P@3P3Rk_P0mOoo0?omnP1XGU`0004908VBW`3ooOl0ooco0?kno`3jo_l0o_oj0?oo
n03oood0no_k0;Fe]@0i>CT0oOgm0?Shn00k>c/0/K6aO@3oool009l0oooo01<0o_oo0?Woo`3kool0
ookh0?olm03onOH0oo_j0?Woo`3eool0mOco0?koo`3mn_<0T8Mn01`>2`0e;B/0Xj^]0?Ooo`3lool0
o_kn0080oooo00<0o_kn00410@3oool06@3oool40?ooo@80oooo0P3oo_l0703ooOl0o__o0?olo`3o
oOl0oogj0?omm@3oo_<0cLW5010?7`3jmOl0n^[[00L00037en@0k_ko0?ogn@3onoX0kOOn0?;oo`3k
n?h0ooco0?Oho03ho?d0o_ok0?kon@3oood0o_kn05IFEP2LW9`20?ooo`030<c<c02UYJD0oooo07`0
oooo002P0?ooo`0B0?koo`3jo?T0o_gi0?omnP3onOX0oock0?Wmo03iool0ooko0?omo`3oo_d0nOSd
0:jUYP3LeMP0iN_[0?Woo`3nool0o_kn0P3oool00`3no_h00@410?ooo`0I0?ooo`@0ooom0P3oool2
0?ono`80oogo01h0oo_o0?omo`3ooOX0ookf0?oikP3hm?004A0N0=KBh03ono@0TXV407^:W`3^o?l0
ooSo0?oio`3gool0m?om0?oon03ooOX0o_ko0?cno`3nool0oook0?gmn`3jn_X0Fe]K0?Cdm03no_h0
o?cl0?ooo`3moOem0?ooo`00X03oool04P3mnoX0ookm0?koo@3oo_d0ooWh0?ohmP3nool0o?gm0?ol
o@3on_/0n__k0?coo`3gmOH0Shf>0>7UiP3fn_/0o_oo0?knoP80oooo00<0o_kn00410@3oool06@3o
ool40?ooo@80oooo0P3oo_l07`3ooOl0ooco0?oko`3oo?h0oogk0?onn03ooO<0oo_g0;Bd_P0F4Q`0
ooC/0;J^[00Q:d80mOko0?ogo`3onol0n?oo0?OonP3ooo@0oooh0?kno`3lool0o_oo0?ooo@3oool0
o_kn0?ooo`3inOT0oooo0?gmo@3emOD0OP3oool009l0oooo01<0ooko0?okoP3ooOl0n_km0?cnn@3o
o_P0oogj0?kmo`3oo?l0o^od0?oko@3ioOh0m_oo0?koo@3hn?H0KVmc0?3am@3oo_l0o_kn0080oooo
00<0o_kn00410@3oool06`3oool40?ooo@0G0?ooo`3oo_l0ooko0?kmo`3ooOl0oogn0?onn`3oo_X0
ookf0?onnP3oo_l0/Jjd06QOH01YHVT0=ca@0>S]o`3onol0oOSh0?_oo`3iool0o_oh0?oon03oood0
0`3nool00`3inOT0oooo0?ooo`220?ooo`00W`3oool04`3oo_l0oogo0?_io03loOd0oook0?ojk`1B
BD@0_ko90?[go`2STi/040@60>KYk@3fo_h0gn3J0?oon`1jOH80][W00?koo`3no_h00P3oool00`3n
o_h00@410?ooo`0L0?ooo`<0ooom0P3oool40?ono`040?olo03oo_/0oooh0?onnP80ooko00H0o_Wm
0?omo`3noOl0n_co0?ooo@3ooo/20?coo`030?kon`3nooX0o_om00<0o_oo00L0oooo0?gmo@3hn?P0
o_kn0?_kn`3moOd0o_kn07h0oooo002O0?ooo`0C0?ono`3nool0o_oo0?ono`3ooOP0ooOY0;>TW@17
BUT0n?ko0:VRZ@1<@D<0_[g20?_jo@3:`KX0=S4[00063P3TkOP0o?oo0?knoP020?ooo`030?knoP01
0@40oooo01T0oooo0P3oo_l01@3oool0ooom0?ooo@3ooo/0o_om00<0o_oo0`3oo_l01@3ooO`0ookj
0?oon`3ooOl0noWl0080o_oo00@0l_3a0?ooo`3loo/0n_kk0P3nool20?koo@<0o_oo00<0ooom0?oo
o`3oool00P3oool00`3jn_X0oOgm0?knoP1n0?ooo`00W`3oool04`3oo_l0moKk0?ono`3oo_l0oOOd
0?okk@3[g=D0000B0=CHk`3VgN005`d<0?cjo`3inOl0ooge0?Sck@3bnOl0n?oo0?coo`3no_h00P3o
ool00`3no_h00@410?ooo`0H0?ooo`050?ono`3ooOl0oogo0?ono`3oood00P3ooo/0103noo/0o_om
0?gnoP3nool40?ono`0<0?ono@3ooo/0ookj0?kmn@3fn_/0nOgn0?oon`3oooX0o?ok0?[oo03lool0
o_oo0P3ooo/20?coo`80oooo00D0n_[j0?ooo`3alO40oooo0?_kn`020?ooo`030?[jnP3oool0oooo
07/0oooo002O0?ooo`030?omo`3onod0noCg0080nooo00h0oooa0?ohl@0K5RX06a4Y0?obm00]6aT0
cmGP0?Coo`3koo/0oooj0?gko`3no?l0ooko0?knoP80oooo00<0o_kn00410@3oool0603oool02`3o
o_l0oogo0?omo`3oo_l0ookm0?oon`3oooX0o_oj0?kon`3mo_h0oOko00<0o_oo0P3oo_l05@3oooX0
ook_0?oom03hnol0n?[o0?ono`3in?@0o_kl0?coo`3iool0o?om0?oomP3ooo@0nooj0?Woo`3ooOl0
ooco0?ono`3jn_X0oooo0?knoP020?ooo`030?Win@3oool0oooo07`0oooo002O0?ooo`0?0?omo@3o
no/0oo[k0?_oo`3iool0n_[]0?onmP1gKh80BSaA0::=RP0]7QT0]Kg80?7oo`3hool0nO_f0080ooco
00H0ooko0?knoP3oool0oooo0?knoP010@4I0?ooo`050?ono`3ooOl0oogo0?ono`3oo_d00P3ooo/2
0?kon`030?koo@3nool0o_oo00<0o_oo00@0ooko0?oon`3ooo40no_^0P3no_l03`3knOX0oook0?oo
o@3jno/0nooo0?coo@3oooH0oood0?_onP3iool0oogo0?olo`3lnol0o_kn0?ooo`020?clo0030?oo
o`3kno/0oooo07d0oooo002O0?ooo`0B0?ono@3ooOX0oo_k0?ono`3mo?l0ookb0=?>a01NFVP0UHjM
0<Fm^0040@00`lWE0?Soo`3enoT0nogh0?ono`3kn_l0oOco0P3oool0103kno/0oooo0000003lo?`2
0?ooo`040?clo03no_h0o_kn0?ooo`80oOgm4@3oool20?ono`80oooo103oood40?ooo`060?ono`3o
ool0oooo0?ooo@3oooX0oook0P3oo_l0103oool0ooom0?ooo`3oool20?koo`80oook00<0o_om0?ko
o`3oo_l00P3oo_n40?ooo`00W`3oool04@3oood0no[f0?ono@3noOl0ooko0?oll@3lmnl0oogo0?Ge
o`3oooX0oook0?_no`3amol0o_oo0?oon`3gn?P0o_oo0080oooo00L0m_Kf0?ooo`3oool000000?oo
o`3inOT0moOg0080oooo00D0nOWi0?_kn`3oool0oooo0?gmo@2e0?ooo`00W`3oool05`3oood0oook
0?ooo@3gn?X0oO_l0?ommP3ooOP0oOgo0?cno`3oo_/0o_ck0?Woo`3eoOl0o_oo0?Sgl`3oool0o_oo
0?gmo@3oool0o_kn0?ooo`3clo<0000000<0oooo00<0m?Cd0?ooo`3oool00`3oool00`3moOd0oooo
0?ooo`2c0?ooo`00X03oool0703no?/0ooom0?koo`3oo_d0oocg0:2HU@35aL/0nOco0?kin`3?cLh0
R8nG0?Soo`3mo_l0ookm0?ooo`3loOl0oooo0?Win@3oool0no_k0?ooo`020P80o?cl0?gmo@3fm_H0
oooo0?KfmP3oool30?clo;H0oooo002Q0?ooo`0K0?[jnP3oool0ookm0?ojn03`j^P0=3<f0?koo`3o
oOl0:2L/0>kbn@3foOl0noco0?Shn03oool0oOgm0?ooo`38b<P0oooo0?Win@3moOd000000?ooo`3l
o?`0nOWi0=cLg03oool0no_k00<0oooo00<0nOWi0?ooo`3oool0/`3oool00:80oooo00X0o_Wi0?om
o@3ooOd0oogm0:bWZ@2GUIP0TiBH0:BW[03lool0noko0P3lool01@3moOd0oooo0?Win@000000B4Q8
0080o_kn00T01@D50?ooo`3`l?00410@06UYJ@3lo?`0oooo0?gmo@3jn_X0]`3oool00:00oooo01d0
o_oo0?ooo`3ooO/0o?Kd0?Kgm`3moOd0oock02hU9P0nADT0m_oo0?ono`3nnol0nOko0?_oo`3oool0
noWh0?ooo`2EUID010@405ADE03no_h000000=OGe`0D51@000000>WYj@3jn_X0oooo0?_kn`020?oo
o`030?gmo@3oool0oooo0;<0oooo002O0?ooo`0P0?koo`3kool0oooo0?ogm@3ooO/0o?oo0?koo`3o
m_D0l^SW0>?/l@3gool0ooko0?oko`3kool0mOgo0?_kn@3oo_/0ookm0?clo00B4Q80000003@d=006
1PH03@d=00H61P1`L700oOgm0?ooo`3kno/0oooo0?gmo@3no_jf0?ooo`00W`3oool00`3nool0o?oo
0?koo`020?omn`0B0?coo`3nool0oo_j0?oln`3hool0mooo0?ono`3ooOl0nooo0?Woo`3oo_d0ookk
0?_in03oool0Vi^K00P8200B4Q8000000P030`<0103`l?00nOWi0?ooo`3oool20?gmoKL0oooo002O
0?ooo`0E0?koo`3lool0o_oo0?omn`3oo_/0o_oo0?ono`3oo?X0oogk0?Woo`3hool0oooo0?ono@3l
ool0nooo0?ono@3oo_/0ookm0?Win@3_knl00`<30080000000@01PH603Xj>P3jn_X0o_kn0P3oool0
0`3no_h0oooo0?ooo`2f0?ooo`00X03oool20?koo`80oook0100oogo0?ono`3oo_X0oook0?kno`3l
o_l0o_oo0?koo@3nool0ooko0?ono@3ooo/0ooom0?clo03oool0@d=30P0000000`092@T0Xj>S0?oo
o`020?ooo`050?knoP3oool0oooo0?ooo`3no_h0]@3oool00:00oooo0P3nool02P3nood0ooom0?ol
o`3ooOl0oooj0?kon`3oo?l0oogo0?coo`3kool20?ono`80oook00X0n_[h0?ooo`3emOD0X:2P00h>
3P010@4020P80??cl`3oool0o_kn0P3moOfi0?ooo`00X03oool20?koo`060?coo@3oood0ooco0?ol
o`3noo/0o?om0P3oo?l0103kool0nOoo0?ono`3ooOl20?oon`080?ooo@3oool0oooo0=GEe@0:2PX0
0`<301TI6@3oool20?gmo@030?knoP3oool0oooo0;P0oooo002P0?ooo`040?koo`3lool0o?oo0?oo
o`80ooco0180o_om0?coo`3oo?l0oogo0?_oo`3iool0ooko0?omo`3oo_/0oook0?ooo@3kno/0oooo
0?Ogm`0:2PX0000005QHF03moOd20?knoP<0oooo00<0o_kn0?gmo@3oool0]@3oool00:00oooo00@0
o_oo0?coo`3lool0oooo0P3ooOl0103oool0o_oo0?omo`3oo_l20?coo`0;0?ono`3ooOl0ookk0?oo
n`3no_`0oooo0?Shn03oool0<S8b0000002NWYh01P3oool20?gmoKH0oooo002P0?ooo`<0o_oo00<0
oooo0?ono`3oo_l00P3oool20?ono`80o_oo00D0oooo0?ono`3oo_d0ookm0?gmo@020?ooo`060?[j
nP1QHF400@410;fm_@3no_h0oooo0P3moOd20?ooo`80o_kn]P3oool00:X0oooo00<0ooko0?ooo`3o
ool0103oool01P3lo?`0o_kn0?clo02=SHd00P820=[Jf[h0oooo002`0?ooo`080?[jnP3oool0oooo
0?ooo`2VYZH000000?ooo`3no_jm0?ooo`00/P3oool0103fm_H0nOWi0=3@d000002o0?ooo`00/03o
ool01@3jn_X0oooo0?ooo`3oool0no_k0<00oooo002b0?ooo`060?knoP3fm_H0oooo0?gmo@3kno/0
oOgm_@3oool00;40oooo00D0no_k0?ooo`3oool0oooo0?clo02o0?ooo`00/@3oool01P3fm_H0oooo
0?ooo`3gmoL0oooo0?Kfm[h0oooo002`0?ooo`040?gmo@3oool0o_kn0?Win@80oooo00<0o?cl0?oo
o`3oool0_03oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool0
0?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00001\
\>"]],

Cell[BoxData[{
    \(\(l3 = 15; \)\), 
    \(\(ma = 1; \)\), 
    \(\(mh = 100; \)\), 
    \(\(rH = 0.5; \)\), 
    \(\(Cd = 0.1; \)\), 
    \(\(Aa = \[Pi]\ rH\^2; \)\), 
    \(\(l1 = 5; \)\), 
    \(\(l2 = 10; \)\), 
    \(\(d1 = 2.5; \)\), 
    \(\(mb = 100; \)\), 
    \(\(B33 = 1\/12\ mb\ \((l1 + l2)\)\^2; \)\), 
    \(\(dB = 1.; \)\), 
    \(\(l4 = 2.55; \)\), 
    \(\(d2 = l4\/2; \)\), 
    \(\(mc = 20; \)\), 
    \(\(C33 = \(mc\ l4\^2\)\/12; \)\), 
    \(\(dC = 500.; \)\), 
    \(\(d3 = 0.5; \)\), 
    \(\(md = 500; \)\), 
    \(\(boxH = 2; \)\), 
    \(\(boxL = 3; \)\), 
    \(\(D33 = 1\/12\ md\ \((boxL\^2 + boxH\^2)\); \)\), 
    \(\(dD = 500.; \)\), 
    \(\(H = l1 + l4 + d3 + boxH; \)\), 
    \(\(\[Mu] = 0.5; \)\), 
    \(\(g = 9.81; \)\)}], "Input"],

Cell[TextData[
"Clear the integration variables. It may complain if not initialized first \
time through, just ignore complaint.     "], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(\((q1[t_])\) =. ; \)\), 
    \(\(\((q2[t_])\) =. ; \)\), 
    \(\(\((q3[t_])\) =. ; \)\), 
    \(\(\((q4[t_])\) =. ; \)\), 
    \(\(\((x[t_])\) =. ; \)\), 
    \(\(\((y[t_])\) =. ; \)\), 
    \(\(t =. ; \)\)}], "Input"],

Cell[TextData[
"Unset::norep: Assignment on q1 for q1[t_] not found."], "Message"],

Cell[TextData[
"Unset::norep: Assignment on q2 for q2[t_] not found."], "Message"],

Cell[TextData[
"Unset::norep: Assignment on q3 for q3[t_] not found."], "Message"],

Cell[TextData[
"Unset::norep: Assignment on q4 for q4[t_] not found."], "Message"],

Cell[TextData["Unset::norep: Assignment on x for x[t_] not found."], "Message"],

Cell[TextData["Unset::norep: Assignment on y for y[t_] not found."], "Message"]
}, Open  ]],

Cell[TextData[
"Initial conditions and release angle.  These can be adjusted per the given \
situation."], "Text"],

Cell[BoxData[{\(W1o = 0; \), \(Q1o = \(-\(\(40\ \[Pi]\)\/180\)\); \), 
  \(W2o = 0; \), \(Q2o = \(30\ \[Pi]\)\/180; \), \(W3o = 0; \), 
  \(Q3o = \(10\ \[Pi]\)\/180; \), \(Vyo = 0; \), \(Yo = rH; \), 
    RowBox[{
      RowBox[{"W4o", "=", 
        RowBox[{
          RowBox[{
            RowBox[{
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "//.", 
              \(solDq4x\[LeftDoubleBracket]1\[RightDoubleBracket]\)}], "//.", 
            \(solq4x\[LeftDoubleBracket]3\[RightDoubleBracket]\)}], "//.", 
          RowBox[{"{", 
            RowBox[{\(q1[t] \[Rule] Q1o\), ",", \(y[t] \[Rule] Yo\), ",", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
                "W1o"}], ",", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
                "Vyo"}]}], "}"}]}]}], ";"}], 
  \(Q4o = \(q4[t] //. solq4x\[LeftDoubleBracket]3\[RightDoubleBracket]\) //. {
          q1[t] \[Rule] Q1o, y[t] \[Rule] Yo}; \), 
    RowBox[{
      RowBox[{"Vxo", "=", 
        RowBox[{
          RowBox[{
            RowBox[{
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], "//.", 
              \(solDq4x\[LeftDoubleBracket]1\[RightDoubleBracket]\)}], "/.", 
            \(solq4x\[LeftDoubleBracket]4\[RightDoubleBracket]\)}], "//.", 
          RowBox[{"{", 
            RowBox[{\(q1[t] \[Rule] Q1o\), ",", \(y[t] \[Rule] Yo\), ",", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["q1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
                "W1o"}], ",", 
              RowBox[{
                RowBox[{
                  SuperscriptBox["y", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "\[Rule]", 
                "Vyo"}]}], "}"}]}]}], ";"}], 
  \(Xo = \(x[t] //. solq4x\[LeftDoubleBracket]3\[RightDoubleBracket]\) //. {
          q1[t] \[Rule] Q1o, y[t] \[Rule] Yo}; \), 
  \(q4R = \(-\(\(10\ \[Pi]\)\/180\)\); \)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Print["\<W4o=\>", W4o]; \)\), 
    \(\(Print["\<q4o=\>", Q4o]; \)\), 
    \(\(Print["\<Vxo=\>", Vxo]; \)\), 
    \(\(Print["\<Xo=\>", Xo]; \)\)}], "Input"],

Cell[TextData["W4o=\\[InvisibleSpace]0"], "Print"],

Cell[TextData["q4o=\\[InvisibleSpace]q4o"], "Print"],

Cell[TextData["Vxo=\\[InvisibleSpace]0"], "Print"],

Cell[TextData["Xo=\\[InvisibleSpace]7.01104"], "Print"]
}, Open  ]],

Cell[TextData[
"Numerical solution to the equations of motion.  This switches regimes based \
on the normal force then the string angle relative to the arm for release."], 
  "Text"],

Cell[BoxData[{\(tf = 1.; \), \(nIntPnts = 50000\ tf; \), 
  \(tip1 = tf\/nIntPnts; \), \(ti = 0.; \), \(dt = tip1\/2; \), 
  \(dts = dt\/5; \), \(pntdiv = 5; \), \(flag = 0; \), \(flagNa = 0; \), 
  \(flagQr = 0; \), \(dbFlag = 0; \), 
    RowBox[{
      RowBox[{"While", "[", 
        RowBox[{\(ti \[LessEqual] tf && Yo \[GreaterEqual] 0\), ",", 
          RowBox[{
          \(If[flag == 0, NaHold = \((ma + mh)\)\ g, 
              NaHold = First[Na[ti] /. sol]]\), ";", 
            RowBox[{"If", "[", 
              RowBox[{\(NaHold > 0 && flagNa == 0\), ",", 
                RowBox[{
                \(If[dbFlag == 1, Print["\<Na[\>", ti, "\<]=\>", NaHold]; 
                    Print["\<q1[\>", ti, "\<]=\>", q1h[ti]]; 
                    Print["\<q4[\>", ti, "\<]=\>", q4h[ti]]]\), ";", 
                  RowBox[{"sol", "=", 
                    RowBox[{"NDSolve", "[", 
                      RowBox[{
                        RowBox[{"{", 
                          RowBox[{
                          \(eom1d == 0\), ",", \(eom2d == 0\), ",", 
                            \(eom3d == 0\), ",", \(eom4d == 0\), ",", 
                            \(eom5d == 0\), ",", \(eom6d == 0\), ",", 
                            RowBox[{
                              RowBox[{
                                SuperscriptBox["q1", "\[Prime]",
                                  MultilineFunction->None], "[", "0", "]"}], 
                              "==", "W1o"}], ",", 
                            RowBox[{
                              RowBox[{
                                SuperscriptBox["q2", "\[Prime]",
                                  MultilineFunction->None], "[", "0", "]"}], 
                              "==", "W2o"}], ",", 
                            RowBox[{
                              RowBox[{
                                SuperscriptBox["q3", "\[Prime]",
                                  MultilineFunction->None], "[", "0", "]"}], 
                              "==", "W3o"}], ",", 
                            RowBox[{
                              RowBox[{
                                SuperscriptBox["q4", "\[Prime]",
                                  MultilineFunction->None], "[", "0", "]"}], 
                              "==", "W4o"}], ",", 
                            RowBox[{
                              RowBox[{
                                SuperscriptBox["x", "\[Prime]",
                                  MultilineFunction->None], "[", "0", "]"}], 
                              "==", "Vxo"}], ",", 
                            RowBox[{
                              RowBox[{
                                SuperscriptBox["y", "\[Prime]",
                                  MultilineFunction->None], "[", "0", "]"}], 
                              "==", "Vyo"}], ",", \(q1[0] == Q1o\), ",", 
                            \(q2[0] == Q2o\), ",", \(q3[0] == Q3o\), ",", 
                            \(q4[0] == Q4o\), ",", \(x[0] == Xo\), ",", 
                            \(y[0] == Yo\)}], "}"}], ",", 
                        \({q1, q2, q3, q4, x, y}\), ",", \({t, ti, tip1}\)}], 
                      "]"}]}]}], ",", 
                RowBox[{"If", "[", 
                  RowBox[{\(q4h[ti] \[LessEqual] q4R && flagQr == 0\), ",", 
                    RowBox[{
                    \(If[dbFlag == 1, 
                        Print["\<q1[\>", ti, "\<]=\>", q1h[ti]]; 
                        Print["\<q4[\>", ti, "\<]=\>", q4h[ti]]]\), ";", 
                      \(flagNa = 1\), ";", 
                      RowBox[{"sol", "=", 
                        RowBox[{"NDSolve", "[", 
                          RowBox[{
                            RowBox[{"{", 
                              RowBox[{
                              \(eom1s == 0\), ",", \(eom2s == 0\), ",", 
                                \(eom3s == 0\), ",", \(eom4s == 0\), ",", 
                                \(eom5s == 0\), ",", \(eom6s == 0\), ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W1o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W2o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W3o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W4o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "Vxo"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["y", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "Vyo"}], ",", 
                                \(q1[0] == Q1o\), ",", \(q2[0] == Q2o\), ",", 
                                \(q3[0] == Q3o\), ",", \(q4[0] == Q4o\), ",", 
                                \(x[0] == Xo\), ",", \(y[0] == Yo\)}], "}"}], 
                            ",", \({q1, q2, q3, q4, x, y}\), ",", 
                            \({t, ti, tip1}\)}], "]"}]}]}], ",", 
                    RowBox[{
                    \(If[dbFlag == 1, Print["\<t=\>", ti]]\), ";", 
                      \(flagQr = 1\), ";", 
                      RowBox[{"sol", "=", 
                        RowBox[{"NDSolve", "[", 
                          RowBox[{
                            RowBox[{"{", 
                              RowBox[{
                              \(eom1f == 0\), ",", \(eom2f == 0\), ",", 
                                \(eom3f == 0\), ",", \(eom4f == 0\), ",", 
                                \(eom5f == 0\), ",", \(eom6f == 0\), ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q1", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W1o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q2", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W2o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q3", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W3o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["q4", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "W4o"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["x", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "Vxo"}], ",", 
                                RowBox[{
                                  RowBox[{
                                    SuperscriptBox["y", "\[Prime]",
                                      MultilineFunction->None], "[", "0", 
                                    "]"}], "==", "Vyo"}], ",", 
                                \(q1[0] == Q1o\), ",", \(q2[0] == Q2o\), ",", 
                                \(q3[0] == Q3o\), ",", \(q4[0] == Q4o\), ",", 
                                \(x[0] == Xo\), ",", \(y[0] == Yo\)}], "}"}], 
                            ",", \({q1, q2, q3, q4, x, y}\), ",", 
                            \({t, ti, tip1}\)}], "]"}]}]}]}], "]"}]}], "]"}], 
            ";", \(q1h[t_] = First[q1[t] /. sol]\), ";", 
            \(q2h[t_] = First[q2[t] /. sol]\), ";", 
            \(q3h[t_] = First[q3[t] /. sol]\), ";", 
            \(q4h[t_] = First[q4[t] /. sol]\), ";", 
            \(q5h[t_] = First[q6[t] /. sol]\), ";", 
            \(q7h[t_] = First[q7[t] /. sol]\), ";", 
            \(xh[t_] = First[x[t] /. sol]\), ";", 
            \(yh[t_] = First[y[t] /. sol]\), ";", \(q1[t_] = q1h[t]\), ";", 
            \(q2[t_] = q2h[t]\), ";", \(q3[t_] = q3h[t]\), ";", 
            \(q4[t_] = q4h[t]\), ";", \(x[t_] = xh[t]\), ";", 
            \(y[t_] = yh[t]\), ";", 
            \(If[flag == 0, 
              q1tab = Table[{t, q1[t]}, {t, ti, tip1, 
                    \(tip1 - ti\)\/pntdiv}]; 
              q2tab = Table[{t, q2[t]}, {t, ti, tip1, 
                    \(tip1 - ti\)\/pntdiv}]; 
              q3tab = Table[{t, q3[t]}, {t, ti, tip1, 
                    \(tip1 - ti\)\/pntdiv}]; 
              q4tab = Table[{t, q4[t]}, {t, ti, tip1, 
                    \(tip1 - ti\)\/pntdiv}]; 
              xtab = Table[{t, x[t]}, {t, ti, tip1, \(tip1 - ti\)\/pntdiv}]; 
              ytab = Table[{t, y[t]}, {t, ti, tip1, \(tip1 - ti\)\/pntdiv}]; 
              flag = 1; , 
              q1tab = Join[q1tab, 
                  Table[{t, q1[t]}, {t, ti + dts, tip1, 
                      \(tip1 - ti\)\/pntdiv}]]; 
              q2tab = Join[q2tab, 
                  Table[{t, q2[t]}, {t, ti + dts, tip1, 
                      \(tip1 - ti\)\/pntdiv}]]; 
              q3tab = Join[q3tab, 
                  Table[{t, q3[t]}, {t, ti + dts, tip1, 
                      \(tip1 - ti\)\/pntdiv}]]; 
              q4tab = Join[q4tab, 
                  Table[{t, q4[t]}, {t, ti + dts, tip1, 
                      \(tip1 - ti\)\/pntdiv}]]; 
              xtab = Join[xtab, 
                  Table[{t, x[t]}, {t, ti + dts, tip1, 
                      \(tip1 - ti\)\/pntdiv}]]; 
              ytab = Join[ytab, 
                  Table[{t, y[t]}, {t, ti + dts, tip1, 
                      \(tip1 - ti\)\/pntdiv}]]; ]\), ";", \(Q1o = q1[tip1]\), 
            ";", \(Q2o = q2[tip1]\), ";", \(Q3o = q3[tip1]\), ";", 
            \(Q4o = q4[tip1]\), ";", \(Xo = x[tip1]\), ";", \(Yo = y[tip1]\), 
            ";", 
            RowBox[{"W1o", "=", 
              RowBox[{
                SuperscriptBox["q1", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            RowBox[{"W2o", "=", 
              RowBox[{
                SuperscriptBox["q2", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            RowBox[{"W3o", "=", 
              RowBox[{
                SuperscriptBox["q3", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            RowBox[{"W4o", "=", 
              RowBox[{
                SuperscriptBox["q4", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            RowBox[{"Vxo", "=", 
              RowBox[{
                SuperscriptBox["x", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            RowBox[{"Vyo", "=", 
              RowBox[{
                SuperscriptBox["y", "\[Prime]",
                  MultilineFunction->None], "[", "tip1", "]"}]}], ";", 
            \(\((q1[t_])\) =. \), ";", \(\((q2[t_])\) =. \), ";", 
            \(\((q3[t_])\) =. \), ";", \(\((q4[t_])\) =. \), ";", 
            \(\((x[t_])\) =. \), ";", \(\((y[t_])\) =. \), ";", \(t =. \), 
            ";", \(If[Abs[Abs[q4h[ti]] - Abs[q4R]] > 0.5, 
              If[dbFlag == 1, Print["\<diff=\>", Abs[q4h[ti]] - Abs[q4R]]]; 
              ti = tip1; tip1 = tip1 + dt; , ti = tip1; 
              If[dbFlag == 1, 
                Print["\<near release, diff=\>", Abs[q4h[ti]] - Abs[q4R]]]; 
              tip1 = tip1 + dt\/100]\)}]}], "]"}], ";"}], 
  \(q1final[t_] := \(Interpolation[q1tab, InterpolationOrder \[Rule] 3]\)[t]; 
    \), \(q2final[t_] := 
      \(Interpolation[q2tab, InterpolationOrder \[Rule] 3]\)[t]; \), 
  \(q3final[t_] := \(Interpolation[q3tab, InterpolationOrder \[Rule] 3]\)[t]; 
    \), \(q4final[t_] := 
      \(Interpolation[q4tab, InterpolationOrder \[Rule] 3]\)[t]; \), 
  \(xfinal[t_] := \(Interpolation[xtab, InterpolationOrder \[Rule] 3]\)[t]; 
    \), \(yfinal[t_] := 
      \(Interpolation[ytab, InterpolationOrder \[Rule] 3]\)[t]; \), 
  \(tf = ti; \)}], "Input"],

Cell[TextData["Plot the coordinates for each degree of freedom."], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!PS-Adobe-2.0 EPSF-1.2
%%BoundingBox: 4 4 377 279
%%HiResBoundingBox: 4 4 377 279
%%Creator: (Mathematica 4.2 for Macintosh)
%%CreationDate: (Friday, April 29, 2005) (19:00:52)
%%Title: Clipboard
%%DocumentNeededResources: (atend)
%%DocumentFonts: (atend)
%%DocumentNeededFonts: (atend)
%%EndComments
0 283 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def

%%MathematicaCell
%Cell[GraphicsData[\"PICT\", \\
%\"\\<\\
%000000000A<1M@0A0_l<0?on0000B00004P0000000014`\\
%5e0000000N00402P00
%00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
%00400000000000000000040000000000000000000000@00000014`5e00030000
%00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
%04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
%ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
%dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
%BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
%>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
%oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
%JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
%>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
%i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
%LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
%P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
%d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
%EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
%`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
%ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
%Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
%^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
%CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
%RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
%lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
%l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
%ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
%dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
%aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
%IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
%1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
%GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
%iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
%ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
%<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
%e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
%3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
%bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
%1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
%X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
%96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
%0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
%Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
%RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
%aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
%k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
%K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
%W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
%<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
%coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
%85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
%BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
%XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
%@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
%DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
%R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
%A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
%8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
%3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
%ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
%6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
%A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
%IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
%I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
%QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
%5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
%ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
%RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
%8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
%58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
%Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
%<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
%kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
%LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
%M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
%[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
%2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
%2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
%:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
%BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
%=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
%LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
%IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
%>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
%aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
%Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
%DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
%[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
%4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
%1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
%PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
%?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
%mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
%X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
%bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
%en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
%Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
%CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
%54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
%K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
%:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
%oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
%ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
%]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
%WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
%>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
%AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
%EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
%A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
%jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
%[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
%21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
%81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
%>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
%j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
%S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
%Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
%khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
%TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
%Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
%RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
%Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
%Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
%iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
%^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
%d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
%^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
%B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
%CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
%4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
%ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
%aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
%B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
%<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
%2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
%^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
%L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
%Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
%0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
%jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
%=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
%Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
%M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
%34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
%jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
%5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
%6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
%I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
%3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
%5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
%7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
%3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
%WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
%80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
%FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
%EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
%jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
%CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
%7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
%l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
%YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
%BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
%876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
%dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
%[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
%e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
%j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
%iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
%//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
%o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
%12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
%A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
%oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
%0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
%d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
%@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
%89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
%452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
%n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
%lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
%KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
%UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
%5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
%7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
%1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
%AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
%`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
%]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
%j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
%54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
%[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
%d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
%VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
%bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
%:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
%lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
%A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
%0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
%P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
%Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
%WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
%PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
%P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
%>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
%@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
%5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
%6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
%</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
%BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
%GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
%Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
%ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
%L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
%acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
%a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
%j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
%7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
%0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
%F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
%X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
%kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
%NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
%K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
%Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
%<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
%d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
%IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
%mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
%NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
%nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
%FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
%lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
%akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
%K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
%_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
%b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
%iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
%XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
%ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
%502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
%_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
%VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
%hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
%5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
%1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
%eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
%eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
%Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
%8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
%X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
%<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
%;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
%j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
%bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
%BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
%33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
%Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
%dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
%J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
%QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
%]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
%TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
%Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
%50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
%GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
%327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
%8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
%Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
%k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
%o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
%2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
%1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
%2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
%G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
%FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
%6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
%4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
%8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
%6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
%4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
%5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
%0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
%0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
%IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
%101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
%7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
%0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
%1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
%K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
%6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
%A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
%?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
%c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
%Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
%3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
%:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
%0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
%oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
%DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
%1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
%1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
%@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
%EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
%fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
%78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
%<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
%423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
%721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
%8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
%1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
%KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
%4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
%343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
%bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
%0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
%7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
%cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
%bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
%4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
%7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
%CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
%AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
%bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
%C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
%6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
%0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
%787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
%D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
%nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
%XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
%EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
%Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
%[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
%=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
%QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
%J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
%2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
%PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
%=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
%W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
%KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
%H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
%<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
%YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
%1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
%5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
%L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
%LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
%kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
%ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
%3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
%R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
%R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
%4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
%fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
%44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
%>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
%OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
%ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
%?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
%W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
%WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
%Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
%b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
%Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
%F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
%P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
%<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
%TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
%8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
%:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
%7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
%AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
%m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
%aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
%W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
%?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
%fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
%APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
%Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
%:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
%@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
%WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
%A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
%U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
%L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
%hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
%O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
%O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
%F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
%aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
%g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
%]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
%0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
%AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
%h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
%C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
%MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
%QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
%j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
%4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
%<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
%:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
%o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
%U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
%F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
%P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
%1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
%LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
%T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
%jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
%<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
%DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
%9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
%PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
%e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
%X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
%Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
%MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
%T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
%:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
%cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
%F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
%9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
%Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
%2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
%ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
%0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
%[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
%h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
%A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
%?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
%]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
%Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
%h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
%D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
%ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
%kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
%OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
%JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
%WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
%=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
%CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
%Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
%Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
%iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
%EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
%Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
%VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
%Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
%c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
%aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
%ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
%lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
%2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
%e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
%9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
%jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
%nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
%>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
%PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
%<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
%1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
%@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
%ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
%1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
%Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
%EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
%[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
%AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
%AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
%c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
%2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
%D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
%4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
%@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
%<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
%nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
%?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
%bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
%>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
%JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
%aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
%TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
%N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
%>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
%7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
%:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
%WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
%2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
%iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
%7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
%BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
%elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
%^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
%eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
%Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
%T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
%L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
%CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
%DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
%<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
%@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
%6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
%c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
%`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
%3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
%;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
%0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
%B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
%;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
%7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
%VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
%@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
%0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
%N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
%E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
%0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
%I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
%A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
%2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
%NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
%@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
%FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
%1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
%DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
%oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
%4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
%>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
%<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
%FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
%7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
%cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
%n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
%7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
%eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
%eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
%CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
%nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
%gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
%JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
%Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
%bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
%0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
%`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
%U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
%978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
%V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
%_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
%o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
%:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
%WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
%Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
%520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
%:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
%4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
%g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
%>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
%NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
%]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
%AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
%5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
%44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
%k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
%Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
%B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
%=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
%V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
%0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
%AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
%0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
%V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
%oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
%cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
%E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
%d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
%LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
%6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
%QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
%Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
%QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
%l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
%EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
%S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
%G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
%ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
%9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
%dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
%5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
%jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
%A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
%TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
%_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
%1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
%?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
%5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
%6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
%L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
%Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
%=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
%4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
%S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
%K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
%WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
%2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
%JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
%jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
%ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
%CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
%PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
%NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
%BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
%j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
%KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
%3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
%G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
%RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
%`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
%]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
%LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
%^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
%BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
%>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
%n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
%9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
%=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
%>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
%l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
%XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
%BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
%BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
%=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
%U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
%PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
%BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
%PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
%Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
%YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
%RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
%dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
%^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
%l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
%>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
%SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
%gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
%/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
%l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
%B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
%Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
%7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
%]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
%lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
%1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
%6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
%EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
%1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
%Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
%@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
%lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
%?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
%10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
%I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
%GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
%Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
%6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
%lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
%mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
%]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
%QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
%hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
%[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
%@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
%>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
%6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
%VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
%i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
%^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
%@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
%94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
%XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
%7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
%M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
%d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
%Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
%</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
%=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
%0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
%3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
%@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
%=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
%dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
%06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
%0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
%/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
%UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
%;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
%TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
%?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
%KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
%=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
%<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
%G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
%5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
%`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
%7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
%L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
%H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
%7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
%3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
%`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
%Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
%?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
%YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
%527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
%7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
%HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
%lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
%5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
%7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
%LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
%5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
%a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
%ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
%X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
%3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
%8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
%]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
%j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
%A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
%?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
%/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
%`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
%9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
%[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
%N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
%8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
%Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
%1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
%QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
%1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
%fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
%GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
%`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
%`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
%dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
%LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
%?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
%=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
%A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
%Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
%_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
%17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
%3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
%Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
%Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
%?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
%4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
%i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
%PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
%PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
%6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
%HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
%UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
%4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
%3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
%Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
%:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
%=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
%5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
%FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
%88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
%29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
%]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
%@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
%6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
%f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
%D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
%fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
%l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
%c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
%ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
%7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
%?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
%>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
%bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
%>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
%4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
%0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
%`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
%Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
%NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
%hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
%=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
%4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
%YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
%COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
%^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
%4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
%PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
%]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
%T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
%TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
%h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
%eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
%1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
%?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
%?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
%EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
%i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
%MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
%Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
%N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
%9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
%D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
%A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
%adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
%NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
%QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
%8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
%6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
%B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
%ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
%04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
%;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
%]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
%hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
%`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
%040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
%lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
%9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
%8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
%7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
%H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
%oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
%OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
%lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
%6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
%]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
%3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
%ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
%00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
%d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
%0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
%Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
%0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
%;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
%3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
%5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
%_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
%8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
%<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
%7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
%Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
%bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
%V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
%R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
%9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
%NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
%:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
%PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
%7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
%5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
%K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
%i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
%RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
%mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
%;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
%c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
%XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
%6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
%SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
%S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
%3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
%[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
%6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
%Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
%=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
%Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
%<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
%;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
%`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
%<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
%H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
%]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
%;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
%4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
%Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
%;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
%m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
%1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
%92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
%hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
%EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
%HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
%1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
%1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
%LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
%72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
%gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
%2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
%NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
%0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
%PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
%AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
%:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
%L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
%dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
%EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
%V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
%:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
%ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
%Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
%CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
%aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
%R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
%/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
%D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
%im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
%`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
%k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
%F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
%6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
%;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
%OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
%@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
%7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
%Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
%Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
%1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
%eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
%H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
%^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
%lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
%61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
%OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
%anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
%6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
%bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
%b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
%<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
%Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
%iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
%kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
%_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
%k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
%]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
%:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
%SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
%nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
%EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
%;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
%oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
%`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
%NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
%G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
%19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
%L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
%MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
%PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
%H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
%lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
%1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
%B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
%5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
%KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
%<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
%3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
%/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
%1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
%LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
%VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
%N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
%79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
%mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
%34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
%NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
%@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
%7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
%[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
%P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
%RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
%//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
%=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
%M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
%851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
%?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
%<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
%GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
%86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
%EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
%k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
%?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
%;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
%:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
%A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
%c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
%=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
%m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
%BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
%5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
%o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
%XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
%C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
%T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
%R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
%S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
%UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
%4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
%?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
%9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
%9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
%H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
%6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
%KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
%<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
%F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
%5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
%L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
%HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
%c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
%[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
%HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
%;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
%5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
%7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
%M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
%nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
%o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
%VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
%fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
%loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
%hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
%<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
%B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
%=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
%@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
%[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
%ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
%7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
%j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
%@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
%VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
%22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
%HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
%E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
%@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
%n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
%Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
%HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
%Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
%<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
%I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
%:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
%DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
%eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
%i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
%JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
%o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
%P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
%:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
%E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
%34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
%f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
%WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
%oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
%iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
%9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
%hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
%<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
%PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
%mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
%Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
%[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
%daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
%mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
%Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
%X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
%S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
%k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
%U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
%oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
%g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
%:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
%DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
%<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
%1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
%Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
%F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
%1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
%<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
%jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
%b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
%9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
%HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
%JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
%o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
%k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
%Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
%d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
%BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
%eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
%00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
%51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
%=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
%9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
%MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
%HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
%9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
%lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
%ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
%@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
%/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
%=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
%?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
%7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
%PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
%al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
%k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
%VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
%6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
%nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
%oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
%>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
%_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
%Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
%003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
%00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
%003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
%3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
%8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
%00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
%02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
%M6lPLfEU87AXJG<PL6USM7EbIBh0003o\\>\"], \"Graphics\",
%  ImageSize->{373, 275},
%  ImageMargins->{{0, 0}, {0, 0}},
%  ImageRegion->{{0, 1}, {0, 1}}]
%%EndMathematicaCell
1 setgray
4 279 moveto
377 279 lineto
377 4 lineto
4 4 lineto
closepath
fill
gsave
4 279 translate
373 -275 scale
1 string
373 275 8 [373 0 0 275 0 0] {
 currentfile
  1 index
   readhexstring
    pop
    } false 3 colorimage
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFEFFFFFEFFFFFFFFFFFFFD
FFFFFDFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFEFBFFFEFB
FFFFFFFFFEFFFFFEFFFFFFFFFFFEFDFFFFFDFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFAFDFFFEFFFFFEFF
FAFBFBFEFFFFFEFFFFFDFEFEFEFFFFF9F9F9FFFFFFFFFEFFFFFBFBFFFCFC
FFF9FAFFFAFDFFFAFDFFFAFFFBF6FAFFFEFFF7F8FAFCFFFFFBFFFFFCFFFF
F8F9FBFEFFFFFFFEFFFFFEFFFFFEFFF8F7FAFDFEFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFDFFFFFBFFFEFDFFFDFFFFFDFFFFFDFEFFFFFB
FBFBF7FEFFFFFCFEFFFCFEFFF6FCFCFBFFFDFBFFFCFEFFF9FFFDF4FFFDF6
FDFBFCFEFEFFF7F8FCFFFFFFFFFEFAFFFFFAFCFFFDFBFFFFFEFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFEFFFBFAFD
FEFFFFFEFFFFFBFCFCFEFFFFF9FAFAFEFFFFFFFEFFFDF8FAFFFDFDFFF7F8
5F545613080AFCF1F7988F940C050AE8E6E9FEFFFFFCFFFFFBFFFFFAFFFF
FEFFFFFBFCFEFAF9FEF6F5FAFFFEFFFBFAFFFEFFFFFBFCFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFEFDFFFEFFFFFEFFFFFEFFFDFDFB
FFFFFDFDFEFEFCFFFFF7FAFFFBFFFFFBFFFFFBFFFDFEFFF9FFFDF3FFFAF2
FAF8FBF9FCFFFEFEFFFBFBFBFFFFF8FFFFF8FBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFEFFFEFFF9F8FBFFFEFF
FDFEFEFCFDFDF8F9F9FEFFFFFEFFFFFCFDFDFEFCFDFFFDFFFFFAFAFFFBFC
FFFAFCECE1E37B72771A1318C7C2C6BCBBBEF9FAFCFCFFFFFBFFFFF8FEFE
FEFFFFFBFCFEFFFEFFFFFEFFFEFDFFFFFEFFF5F6F8FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFBFFFFFBFFFFFFFEFDFF
FAF9FEFFFEFFFEFFFBFDFFFAFAFBFDFCFFFFF2FAFAFEFFFBFFF6EDFFFBF4
FFFEFFFCFFFFFEFEFFFEFDFFFFFEFAFFFFF8FBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFAF8FBFDFCFFFFFEFF
FEFFFFFEFFFFF9FAFAFEFFFFFEFFFFFBFBFBFFFEFFFBF9FAFFFDFDFEF8F8
FFFAFBFFFAFEA59CA1191217F1ECF0F9F8FBFEFFFFFCFFFFF7FDFDFCFFFF
F9FAFCFEFFFFFEFDFFF7F6F9FFFEFFFFFEFF000002FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFFFFFEFFFFFEFFFFFEFFFFFFFAFFFFF8FEFEFEFFFEFF
FFFEFFFAF8FBFFFFF5FFFFF6FFFEFFF9F8FEF9FFFFFAFEFDDFD8D019100B
C6C7CBF9FDFFFAFDFFFFFEFFFFFEFAFFFFFAFBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFEFFFFFEFFFDFCFF
F8F9F9FBFCFC5C5D5DF7F8F8FFFFFFFEFEFEFAF8F9FFFEFFFFFCFCFFFDFD
FFFCFDFFFCFFCAC1C6171017F7F1F8FFFEFFFEFFFFFAFDFFFAFEFFFBFFFF
FDFEFFFEFFFFF9F9F9FFFEFFFFFFFFF1F1F1070808FBFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFEFFFFFEFFFFFEFFFAFEFFF8FFFFFFFDFCFF
FDFAFFFFFDFFFFFEF4FFFEF4FFFBFCFFFDFFF9FFFFF7FDFDFFFEF8928A87
C8C8CEFBFFFFF6F9FFFEFFFFFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFEFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFAFDFAF9FCE7E6E9
B9BABAFDFEFE030404FEFFFFFDFDFDFFFFFFFFFEFFF9F7F8FDF8F8FFFDFD
FFF8F9FFFAFD8C8388070007979198D4D3D8FEFFFFFCFFFFFCFFFFF8FCFD
FCFDFFFFFFFFC9C7C8D2D0D1FFFFFFFFFFFF000000FCFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFBFEFFFBFEFFFDFBFBFB
FFFDFFFFFDFDFFFAF5FFF8F1FFFBFBFFF9FEF9FFFFF0F7FBFAF6F3D9D3D1
808388F8FFFFFBFFFFFBFCFEFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFDFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F6F9FFFEFFFBFAFDFFFEFF
424242919191000000FEFFFFFFFFFFFFFFFFFAF8F9FEFCFDFFFDFDFFFBFB
FFFDFD9C9598100910D6D0D8ABA8AE0E0D12EEEFF3FCFFFFF4F8F9FCFFFF
FEFFFFF9F9F9E1DFE0181615DDDBDAF7F7F5000100FEFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFDFCFFFDFCFFFFFCFFFFFEFFFDFCFDF7
FEFBF4FEF6F3FFFBFDFFFAFDFFFAF8FFF9F7F8FFFFF6FFFFFFFEFDF4EFEF
494D54F2FAFFFBFFFFFCFDFFFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFDFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFBF9FCFFFEFFFFFEFF
D9D9D9131313040505FDFEFEFDFDFDFFFFFFFFFEFFFFFEFFFFFCFCFEF9F9
FFFDFDFFFCFFFFFAFFFFFCFFFFFCFFFEFFFFFBFCFFFCFFFFFCFFFFFEFFFF
FEFEFEFFFFFFFFFEFD8D8B8A3E3C3BFFFFFD040402FEFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFEFFFDFCFFFBFCFFFDFBFFFFFCFFFFFEFFFDFFFFF8
FFFFF4F7F0E8271A1FFBEAF0FFF1EB221914606872F1FDFFF9F8FBFFFEFD
7F868CD1D9E1FBFFFFFEFFFFFFFEFAFFFFFBFBFFFFF9FFFFFEFFFFFFFFFD
FFFDFDFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FCFCFCFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFEFFFEFDFFFFFEFF
FEFEFE868686040404000000020202000000010101000000020000010000
020000030000030002030004010004000004000004000004000102000002
000000010000050000050000010000A2A2A0000000FEFFFDFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFEFFFDFCFFFBFCFFFDFCFFFFFCFFFFFEFFFDFFFFF8
FFFFF3FFFEF6302126BCABAFFFF8F04A413C87909BD2DEECFEFDFFEEECED
484F538F989DF8FDFFFEFFFFFFFEFAFFFFFBFCFFFFFBFFFFFEFFFFFFFFFD
FFFDFDFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFF
F8F8F8F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFF8F8F8F7F7F7
FFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFBFBFBFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFEFDFFFFFEFF
FBFBFBFAFAFA2A2A2AA9A9A9FBFBFBFFFFFFF4F4F4FFFFFFFFFEFDFFFEFD
FFFDFCFFFEFFFFFDFFFFFDFFFFFEFFFEFFFFFCFFFFFCFFFFFCFFFFFEFFFF
FFFFFFFFFEFFFFFDFDF9F4F4D4D2D1121210050501FEFFFDFFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFCFFFDFCFFFDFCFFFFFEFFFFFBFBF9FFFFFA
FFFCF3FFFCF4A69A9A221212FFFAF4978F8D7C8594F4FFFFFDFCFFFFFEFF
F2F9FDF8FFFFF6FBFEFEFFFDFFFEFAFFFFFBFCFFFFFBFFFFFEFFFFFFFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FF4F4F4FFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFBFBFB8F8F8FF4F4F4FFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFA5A5A5FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF9FCFFFEFFFFFEFFFFFEFF
FFFFFFFFFFFFC2C2C21F1F1FEAEAEAF8F8F8FFFFFFFFFFFFFFFFFDFBFBF9
FDFDFBFFFFFFFFFEFFFFFEFFFFFEFFFEFFFFFCFFFFFCFFFFFEFFFFFEFFFF
FFFFFFFFFEFFFFFCFCFFFCFCFFFEFD71716F000000FCFEFBFAFAFAFAFAFA
FBFBFBFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFDFEFFFBFFFFFFF8F6F7
FFFDFFFFFDFAD7CCC40A0000A69893E3DCE10C1427E2EFFFFFFEFFFFFDFE
FBFFFFF5FCFFFCFFFFFDFDFBFFFDFAFFFEFBFCFFFFFBFFFFFCFFFFFFFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB1B1B1393939F0F0F0FFFFFF
FDFDFDFEFEFEF8F8F8FFFFFFB1B1B1393939F0F0F0FFFFFFFDFDFDFEFEFE
F8F8F8FFFFFFFFFFFF181818838383FBFBFBFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFFFEFFF8F7FAFBFAFD
FFFFFFFFFFFFFFFFFF6464646A6A6AFFFFFFFBFBFBFDFDFDF7F7F5FFFFFD
FFFFFDF8F8F6FFFDFEFEFDFFFDFEFFFDFEFFFBFFFFFBFFFFFDFEFEFEFEFE
FFFDFEFFFEFFFFFBFBFFFBFBFFFEFDF3F3F1070705B7B9B6FFFFFFFFFFFF
FFFFFFFDFDFDFDFDFDFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFEFFFFFEFFFFFEFFFFFEFFFFFEFFFBFFFFFAF9F7F8FFFDFF
FFFCFFFFFCFCF7EFE2120A00665B57A6A0A800081DEDF7FFFAF9FFFFFDFE
FBFFFFF5FDFFFCFFFFFFFFFBFFFDFAFFFEFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD7B7B7B2A2A2ADEDEDE
FEFEFEFEFEFEFFFFFFF7F7F7FDFDFD7B7B7B2A2A2ADEDEDEFEFEFEFEFEFE
FFFFFFF7F7F7FFFFFFEDEDED3B3B3B606060F4F4F4FFFFFFF7F7F7FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFEFFFFFEFFFFFEFF
FFFFFFFFFFFF525252F6F6F61B1B1BBFBFBFFEFEFEFFFFFFFCFEFBFDFFFC
FEFFFDFEFFFDFFFFFFFFFFFFFEFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFFFF
FDFBFCFFFAFCFFFDFFFFFDFFF6F4F5FDFDFD000000232424EFEFEFFEFEFE
FFFFFFFAFAFAFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFFFBFFFFFAFFFEFFFFFCFF
FFFAFFFFFCFCABA7993D3727CAC2BD87868C212B40E3EDFFFFFEFFFAF5F5
F7FBFCF9FFFFFEFFFDFFFFFAFFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFC8F8F8F1A1A1A
CECECEFFFFFFFFFFFFFEFEFEFEFEFEFCFCFC8F8F8F1A1A1ACECECEFFFFFF
FFFFFFFEFEFEFFFFFFF5F5F5F2F2F2535353474747EEEEEEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFDFFFFFEFFFFFEFF
FDFDFDFEFEFE030303FFFFFFE1E1E1BABABAFFFFFFF6F6F6FEFFFDFCFEFB
FEFFFDFEFFFDFDFDFDFDFDFDFCFDFDFCFDFDFAFEFDFAFEFDFCFDFDFDFDFD
FFFEFFFFFDFFFCF7F9FDF8FAFFFEFFFFFFFF000000CECFCFDCDCDCF2F2F2
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFFFFFEFDFFFDFDFFFDFFFBF6FA
FFFDFFFFFDFDF5F2E9FFFFF4FFFDF6FEFFFFF5FFFFF1F9FFFFFDFFFFFDFD
FCFFFFFBFFFFFEFFFDFEFDF8FFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFABABAB
1B1B1BB1B1B1FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFABABAB1B1B1BB1B1B1
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFF6F6F6656565323232EEEEEEFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFBFAFDFFFEFF
FFFFFFFFFFFF010101FAFAFAFFFFFFFBFBFBFFFFFFFFFFFFFEFFFDFCFEFB
FEFFFDFEFFFDFFFFFDFFFFFDFEFFFDFCFFFDFCFFFDFCFFFDFEFFFFFFFFFF
FFFEFFFDF8FAFFFCFFFFFDFFFBF9FAF9F9F9040404F4F5F5FCFCFCFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFFFFFDFFFFFDFFFEFDFFFEFFFFFCFFFFFBFFFFFCFFFFFCFC
FFFEFBF7F3F0746F71FAF8F7FFFFF8F8FCFB818C9ED0D8EDFEFBFFFFFCFC
FEFFFFFAFEFDF9FBF6FFFFFAFFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFDFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
BEBEBE1F1F1F9E9E9EFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFBEBEBE1F1F1F
9E9E9EFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFF8181811A1A1ADFDFDF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFBFFFEFDFBFFFFF3FAFF
FEFFFFFEFCFD010000FFFEFDFEFFFFFDFEFEFFFEFDFFFDFCFEFFFDFEFFFD
FEFFFFFBFCFCFEFEFEFEFEFCFDFFFCFBFFFCFDFFFCFDFFFCFDFEFEFEFEFE
FFFEFFFFFAFCFFFDFFFFFDFFFFFDFEFFFFFF010101FEFFFFFFFFFFFEFEFE
FBFBFBFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFFFFFDFFFFFDFFFEFDFFFEFFFFFCFFFFFCFFFFFDFFFFFEFB
FFFBF7FFFEFBB3B0B6848285FEFDF6D2D4D1555C6AF8FDFFFFFDFFFFFDFD
FDFEFEFBFFFEFEFFFDFFFEF9FFFDFAFFFEFBFEFFFFFCFFFFFEFFFFFEFFFF
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FDFDFDFFFFFFF8F8F8FEFEFEFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFF9F9F9FFFFFFF9F9F9FDFDFDFFFFFFF9F9F9FFFFFFFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFDFDFDFFFFFFF5F5F5FFFFFF
FFFFFFFAFAFAFFFFFFFBFBFBF6F6F65E5E5E3A3A3AEBEBEBFFFFFFF9F9F9
FFFFFFFFFFFFFCFCFC6464643C3C3CEDEDEDFCFCFCF8F8F8FFFFFFFFFFFF
FCFCFCDEDEDE171717818181FFFFFFFFFFFFFFFFFFFEFEFEFDFDFBFFFFFD
FDFDFBFBFBF9FFFFFDFFFFFDFEFEFCFFFFFFFFFEFFFEFFFFF8FCFBFCFFFD
FFFFFFF8F8F8FEFFFFF9FFFFFAFFFFFDFDFFFFFBFFFFFBFEFFFEF7FEFFF9
FBFFFFFAFFFFFDFEFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FCFCFCFEFEFEFFFFFFFFFFFFF9F9F9FDFDFDFFFFFFF8F8F8FDFDFDFFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFE7E7E7121212E0E0E0
FFFFFFF6F6F6FFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFFFBFBFBFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFF7F7F7FBFBFBFFFFFFFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FDFEFEFDFEFEFDFEFEFDFEFEFEFEFEFEFEFEFEFEFEFEFEFEFFFEFFFFFEFF
FBF6F8FFFDFFFFFCFEFFFAFCFFFDFFFCFAFBFEFCFDFDFDFDFCFCFCFCFCFC
FEFEFEFFFFFFFFFFFFFEFEFEFFFFFFB4B4B4010101080808000000424242
B1B1B1E0E0E0FFFFFFFDFDFDFFFFFFFBFBFBF9F9F9FFFFFFFEFEFEFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFCFCFC
FFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FBFBFBFFFFFFFFFFFF646464000000010101323232FDFDFDFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFAFAFAFBFBFBFFFFFFFAFAFA
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFAFAFAFFFFFFFDFDFDE8E8E8FFFFFF
FFFFFFFFFFFFFFFFFFFAFAFAFAFAFAFFFFFFDFDFDFFFFFFFFFFFFFFCFCFC
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FDFDFBFFFFFD
F9F7F6FFFEFDFFFEFDF9F7F6E2E0DFEAE9ECF6F6FFFEFEFFFFFFFBFBFCF4
FFFFFDFEFFFF000200FBFFFFFAFFFFFDFDFFFFFBFFFFFBFEFFFDF7FFFEF7
FBFFFFFAFFFFFDFEFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FDFDFDFBFBFBFEFEFEB9B9B9989898646464747474A4A4A4D7D7D7FAFAFA
FFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFEFEFEFCFCFCFAFAFA040404
1D1D1DEBEBEBFFFFFFFAFAFAFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
F7F7F73030300000000101016A6A6AFFFFFFFFFFFFF6F6F6FDFDFDFFFFFF
FFFFFFF4F4F4FFFFFFFFFFFFFDFDFDFFFFFFFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FDFEFEFDFEFEFDFEFEFDFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFFFFFF
FDFBFCFEFCFDF7F5F6FFFEFFFFFEFFFFFEFFFDFDFDFDFDFDFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFF8F8F8FFFFFF9B9B9B060606000000000000
080808030303131313404040838383A2A2A2CACACAE2E2E2FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFBFBFBFEFEFEFFFFFFFCFCFCB9B9B9000000000000000000
929292FCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFF7F5F4FFFEFD
FFFDFDFFFDFDF5F0F0140F0FB8B3B3FFFDF8FFF9EAA6A197152B36E7FFFF
FCFEFFFFFBFFFFFDFBFDF9F5F9FFFFF9FFFFFFFEFAFFFCF6FDFEF8FCFFFD
FFFEFFFFFDFFFFFEFFFEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFDFDFD292929
CFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFFFFFFFDFDFDFFFFFF
F6F6F67D7D7D838383F8F8F8FFFFFFFFFFFFFFFFFFBBBBBB000000020202
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFF8F8F8FBFBFBFEFEFEFEFEFEFDFDFDFFFFFF
FAFAFAFFFFFFFEFEFEFFFFFFF5F5F5FFFFFFFFFFFF757575000000090909
030303C9C9C9FFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFCFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFF9F9F9FDFDFDFFFFFFFCFCFC
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFC6C6C60B0B0B000000010101757575FEFEFEFFFFFFF9F9F9FFFFFF
FFFFFFF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFD
FFFFFFF9F9F9FFFFFFF8F8F8FBF9FCFEFCFFFFFFFFFFFFFFF8F8F6FFFFFD
FDFEFEFCFDFDFBFCFEFEFFFFFFFEFFFDFCFFFEFEFEFFFEFDFDFCF8FFFFFA
F4F9F2FCFFFFF9F9FFFFFDFFFFFFFFFFFDFABAB2B00A0507E6E8F2F5FCFF
F9FFFFFCFFFDFFFFFFFDFBFEFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA3A3A3
1616164848482B2B2BD9D9D9F7F7F7FFFFFFFCFCFCF7F7F7ADADAD0A0A0A
D1D1D1FFFFFFFBFBFBFFFFFFFFFFFFF5F5F5FDFDFDFFFFFFFEFEFEF8F8F8
FFFFFFFEFEFEFFFFFFFFFEFFFFFDFDFCF7F7FFFFFFFFFFFF817B7BDDD8D8
F8FEFEFBFFFFFFFEFFFFFDFFFBFFFFFAFFFFFDFDFDFFFEFDFFFFFFFBFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFBFBFBFFFFFFF7F7F7
FFFFFFF6F6F64343430505050000000F0F0FECECECFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F9F9FFFFFFFFFFFF4A4A4A0000000000001D1D1DE7E7E7FAFAFAFFFFFF
FCFCFCFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF9F9F9FFFFFF
FEFEFEFAFAFAFFFFFFF8F8F8F2F1F4FFFEFFFFFFFFF8F8F8FFFFFDFCFCFA
FBFBF9FFFFFFFFFEFFFEFDFFFFFDFEFFFEFFFFFDFDFFFEFBFFFDF6FFFFF8
F5FEF7F7FFFFFFF8FFFEF5FFFFFDFFFFFDFFFFFAF4A49695B3BAC8EFFFFF
F0FFFDF7FFF7FFFFFBFFFCFFFFFCFFFEFBFFFFFEFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFCFCFCDBDBDB2F2F2F585858F7F7F7
FFFFFFFFFFFFF5F5F5FCFCFCE6E6E6AEAEAECECECEF4F4F4FEFEFEFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFBFBFB
FFFFFFFFFFFFFCFCFCFFFEFDFFFCFCFFFDFDFFFFFFFAFAFAD0CCC94B4948
6B6E72F6F9FDFEFCFBFFFDFCF8FBFFFCFFFFFFFFFFFDFBFAFFFFFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFEFEFEFBFBFBFFFFFFFEFEFE
C0C0C00000000202020101017F7F7FFFFFFFFCFCFCFCFCFCFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFF9F9F9FFFFFFBBBBBB000000050505010101848484FFFFFF
FBFBFBFFFFFFF7F7F7FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFDFDFD
F8F8F8FFFFFF6B6B6B040404E6E5EAFBFAFDF5F4F7FFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFCFAFBFFFEFFFFFAFCFFFDFDFFFBF8FFFDF7FFFEF6D9DAD4
000405272B32AA95A10B0007A0A7B9F5FFFFFFFCF6FFF4EF595B68EAF6FF
F7FFFFF2FDF5FCFFFAFFFFFBFFFBFFFFFCFFFAF8FBFFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFAFAFA6F6F6F262626C5C5C5FFFFFFFEFEFEFCFCFC
FFFFFFFAFAFAFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFDFFFEFDFFFBF9FCF7F7969A9B5A5E5F
FFFDFD7D787ADEE6E8F9FFFFFFFDFFFFFBFBFEFFFFFAFEFFFFFFFFFDFBFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF8F8F8FFFFFFFEFEFEFEFEFE4C4C4C
0000000606061D1D1DE0E0E0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3D3D3D020202000000262626
EEEEEEFFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFDFDFD
FAFAFAFFFFFFFFFFFFACACAC040308121114DDDCDFFEFEFEFFFFFDFBFBF9
FFFFFDFEFEFCFCFAFBFFFEFFFEF9F9FFFEFBFFFDFAFFFEF6FFFDF5DBD7D4
0B0E1DFAF8FFFFEFEA1B0B09C5D5EAEDFFFFF7F7F5FFFEF6FEFDFFF3F6FD
FFFEFFFFFEFFFFFFFBFCFEF9FFFFFFFBFBFBFFFFFFFCFCFCFCFCFCFEFEFE
FFFFFF575757A3A3A3FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
FCFCFCB1B1B1111111989898F9F9F9FFFFFFFEFEFEFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBF9FFFFFBFFFBFAA49E9C131B1DC4CACA
FFFCFD625C5CC6CFD2F0FBFDFFFDFDFFF9F7FCFFFFFBFFFFFAFAFAFFFEFD
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFF
FCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF090909020202
000000767676FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDADADA0C0C0C0B0B0B000000
585858FFFFFFFEFEFEFCFCFCFBFBFBFDFDFDFCFCFCFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFBFBFBFDFDFDFEFEFE33323700000218171AD0D0D0FBFBF9FEFEFC
FEFEFCFFFFFDFFFEFFFCFAFBFFFDFFFFFDFDFFFDFAF9F4EEFFFEF6F2EDED
1E1B2ED6CFDFFFF9ED9B93888599AFE5FDFFFEFFFFFFFDF7FCFEFBFDFEFF
FFFCFFFFFBFFFDF8F8FDFCF8FCFFFDFBFFFFF7F8F8FFFFFFFFFFFF979797
0101010D0D0DFFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFDFDFDF9F9F9
777777202020C9C9C9F4F4F4FFFFFFFBFBFBFCFCFCFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFCFFFEFDFFFAF8FFFCFCF8FCFDFCFFFF
FFFDFDFFFDFFEFF7F9F9FFFFFFFDFFFCF6F6FEFFFFFCFFFFFCFCFCFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FEFEFEFBFBFBFFFFFFFDFDFDFFFFFFFCFCFCF3F3F3232323000000000000
3F3F3FFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA1A1A1000000050505
030303A2A2A2FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFFEFEFE
FCFCFCFEFEFEFEFEFEFFFFFFDDDCE10D0C0F000002050505ACACAAFFFFFD
FBFBF9FFFFFDFAFAFAFFFFFFFFFEFFFBF9F8FFFEFBFFFEFAFFFEF6FFFCFF
C8BED6110517FFF8E68D8E7C283D50EDFFFFFEFEFFF5EFECFAFFF8FCFFFD
FFFBFFFFF3FFFFFAFFFFF9F7FBFFFDF5FFFAFCFFFFB7B7B71717170C0C0C
090909F3F3F3FFFFFFFDFDFDFDFDFDFFFFFFFAFAFAFFFFFFE1E1E13D3D3D
434343EFEFEFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFEFDFFFDFFFDFBFCFFFFFDFDFDFB
FEFDFFFEFDFFFEFFFFFEFFFFFDFCFFFDFCFFFFFFFFFFFFFDFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFFF8F8F8F4F4F4FFFFFFFFFFFFFEFEFE464646010101030303161616
E4E4E4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF646464000000
030303070707D3D3D3FFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFEFEFEFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFF7F7F7FFFEFF4A494C0A0A0A0000000B0B0950504E
EEEEECFFFFFFFDFCFFFFFEFFFFFEFFF9F7F8FCF7F7FEFAF7FFFFF8FFFCFF
FFF3FFC6B9CA65624F656C58324554E0F1FFFBFBFFFFFEFBFBFFF8F9FFF9
FFFCFFFFFAFFFFF6FBFFFDFBF4FDF89DA7A2222625040404000000222222
FDFDFDFFFFFFFFFFFFFDFDFDFFFFFFFEFEFEFFFFFFBABABA141414838383
FFFFFFF9F9F9F8F8F8FAFAFAFEFEFEFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFDFFFDFDFDF8F8F9F9F9FFFFFFFDF9F6FEFCFB
FCFFFFFCFFFFFEFCFBFBF9F8FAFDFFFCFFFFFFFFFFFFFDFCFEFEFEFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFAFFFFFF
FBFBFBFFFFFFFFFFFFF1F1F1FFFFFF919191030303000000000000B6B6B6
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3292929
000000000000343434F6F6F6FFFFFFFAFAFAFEFEFEFFFFFFFCFCFCFCFCFC
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF8F8F8FBFBFB
FFFFFFF7F7F7F9F9F9FFFFFFFEFCFFD5D3D60A0A0A000000000000080806
1516169E9F9FFEFFFFFDFEFFFCFBFEFFFFFFFFFEFDFFFFFBFBFAF5FFFCFF
FFF9FFFFF5FFFBFBEEFBFFF4F3FFFFF5FFFFFCFCFFFFFFFDFAFFF9FBFFFA
FDFAFFFEF4FDB8ABB0534D4D0E1410020B06000000000000000000FCFCFC
FBFBFBFCFCFC515151FFFFFFFDFDFDFFFFFF7979791A1A1AC5C5C5FFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFDFDF8F8FFFDFDFFFFFFFFFFFFFEF8F6FFFDFD
F9FEFFF6FBFEFFFDFDFFFBFBFBFFFFFBFFFFFBF9FAFEF9F9FFFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FDFDFDFFFFFFFDFDFDFFFFFFCBCBCB000000030303000000797979FFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAD7D7D7
0E0E0E0000000808086B6B6BFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FEFEFEFEFEFEFFFFFFF7F7F7FFFEFFFEFCFF494949000000050503000000
0000000304040B0C0E808183FFFEFFFDFCFFFCFCFCF9F7F6FFFFFBD6D1D3
968E9BFFFBFFFFFFF8ECF2E8717880F5FDFFFCFFFFFAFBFD555A54242923
0F0E1109030A160F12030000000100000100050606222222EAEAEAF9F9F9
FEFEFEFFFFFF030303FFFFFFE8E8E8404040414141E9E9E9FFFFFFF8F8F8
FEFEFEFFFFFFFFFFFFFAFAFAFCFCFCFFFFFFFFFFFFFDFDFDFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFDFDFDF8F8FBFBFBFFFFFFFFFDFDFFFBFB
FBFFFFFBFFFFFFFEFFFFFDFFFBFFFFFBFFFFFCFCFCFFFEFDFFFFFFFDFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF8F8F8EDEDED2525250000000404043F3F3FF0F0F0FCFCFC
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
8B8B8B040404000000010101A9A9A9FFFFFFFAFAFAFEFEFEFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF919191020202303030AEAEAE
FCFCFCFFFFFFFFFFFFFEFEFEFBF9FCFFFEFFA4A2A30D0B0C010100040402
232424232424141517000004414246FEFFFFFDFEFEFFFFFDFDFDF9FFFFFD
555258D8D5DBFAF5F7888687AEADB2F8FBFFF9FFFFF9FFFF777976383836
161518000002080909010202030000030000141213EBEBEBFFFFFFFFFFFF
FFFFFFF8F8F8060606B7B7B7171717808080FFFFFFFCFCFCFEFEFEFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFEFEFEFFFFFFFDFDFDFBFBFBFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFBFBFFFDFDFFFFFBFAFAF8FFFEFFFDFBFE
F2F6F3FBFFFEFDFCFFFCFBFFFAFEFDFCFFFDFFFFFFFFFEFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF2F2F2FFFFFF
F7F7F7FFFFFFFFFFFF5555550202020000000D0D0DDDDDDDFFFFFFFEFEFE
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FDFDFD525252040404000000171717E4E4E4FDFDFDFFFFFFFCFCFCFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FFFFFBFFFFFBFFFFFDFFFFFFFEFFFFFEFFFFFDFBFEA19FA2DBDBD9F1F1EF
FBFCFCFEFFFFFDFDFDFEFCFDFFFEFFFFFEFFFBF9FA06040500000050504E
242525EFF0F0F9FAFCFEFFFFF4F5F9F6F7F9FEFFFFFDFEFEFFFFFDFCFCFA
E6E7E948474AD1CBD2595458FFFEFFFEFFFFF4FCFEF9FFFFFEFFFFF9F9F9
F9F9F9C3C4C6161A190607070300000F0909C8C6C7FCFCFCFFFFFFFCFCFC
FFFFFFFEFEFE0000001B1B1BC0C0C0FDFDFDFBFBFBFFFFFFFBFBFBFDFDFD
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFBF9F8FEFEFAFFFFFDF8F6F9FFFEFF
FEFFFDFEFFFDFFFEFFFFFEFFFCFEFBFEFFFDFFFEFFFDFCFFFCFCFCFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFAFAFA
FFFFFFFFFFFF909090020202000000030303ACACACFEFEFEFFFFFFFCFCFC
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFF
FFFFFFEDEDED1C1C1C0202020000003E3E3EFFFFFFFFFFFFFFFFFFFDFDFD
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFB
FFFAF0FFFEF4FFFFFBF7F8F8FCFFFFFBFEFFFEF8FFFFFBFF94938FD6D8D3
FBFFFFFCFFFFFAF8FBFFFDFFFFFEFFFFFFFFFCFCFC4545450B0B0BAFAFAF
6A6A6A4C4C4CFBFBFBFFFFFFFCFBFEFFFFFFFCFCFCFFFFFFFBFBFBFFFFFF
FCFCFCABABAB020003E9E7E8FFFFFFFAFAFAFEFFFFFBFCFCFFFFFFF8F8F8
9898981515158788880A0A0A100E0F6A6869FEFEFEFDFDFDFFFFFFFFFFFF
EBEBEB4343432C2C2CE3E3E3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFEFEFE
FDFDFDD2D2D20909090000000000006A6A6AFFFFFFFFFFFFFEFEFEFEFEFE
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF9F9F9
FCFCFCFFFFFFBCBCBC010101020202030303828282FDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFDF8
FFFCF1FFF3E5FCF9F2FCFFFFF4FDFFF9FDFFFFFBFFFFF7FFFCF8F571736E
E6F2F0F8FFFFFFFEFFFDF6FBFCFAFBFCFCFCFFFFFF838383000000D8D8D8
FAFAFA3D3D3D858585FCFCFCFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFDFDFD
FFFFFFFFFFFFD4D4D4FCFCFCFEFEFEFBFBFBFCFCFCFFFFFFEDEDED505050
393939D7D7D7BCBCBC060606212121FFFFFFFDFDFDFFFFFFFEFEFEBDBDBD
121212818181FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFF
F1F1F12A2A2A000000030303313131FEFEFEFBFBFBFFFFFFFFFFFFFDFDFD
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFF
F9F9F9FFFFFFFFFFFF7E7E7E000000000000050505C7C7C7FFFFFFFDFDFD
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF9FFFFFCFCF8
A28E8511000079746A8F9893000911CCD5E0FFF7FDECD9DBFFFBFC828685
ABBFBDE9FBFAFFFBFFFFFAFFFFFDFFFFFFFFFFFFFFA6A6A6020202FFFFFF
FDFDFDE7E7E7191919BABABAFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDC2C2C2202020727272
F0F0F0FCFCFCB0B0B0000000A3A3A3FEFEFEFEFEFEFFFFFF8484841D1D1D
BDBDBDF9F9F9FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFB
5F5F5F000000000000121212D7D7D7FFFFFFFCFCFCFFFFFFF7F7F7FFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFF8F8F8FFFFFF
FFFFFFFBFBFBF6F6F6FFFFFF474747000000000000272727EAEAEAFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF5FDFBFDFDF9
54413AD2BEB5EDE9DD000400495760C9D2DFFFFBFFD0C0C131282B090D0E
D9ECE8F4FFFFFFFDFFFFFBFFFEF9FBFFFFFFFCFCFCF2F2F2888888F9F9F9
FFFFFFFCFCFCC2C2C2121212DBDBDBFFFFFFFFFFFFFEFEFEFEFEFEFFFFFF
FFFFFFF8F8F8FFFFFFFBFBFBFFFFFFFBFBFB8A8A8A1B1B1BB0B0B0FCFCFC
FFFFFFFFFFFF797979040404FFFFFFFAFAFAECECEC454545373737E4E4E4
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F99A9A9A
0A0A0A000000000000A2A2A2FFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFBFBFB
FFFFFFF9F9F9FEFEFEFFFFFFDBDBDB101010050505000000545454FFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFB
857C779B928BFDFAEFC1C3BD0B0F18F4F6FFFAF7FDFBF4F7FFFEFFFCFDFF
F9FFFBF9FFFBFBF8FEFFFCFFFFFEFFFFFFFFFFFFFFF8F8F8FDFDFDFFFFFF
FCFCFCFDFDFDFFFFFF9F9F9F272727F4F4F4FCFCFCFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFDFDFDFAFAFAE8E8E8474747363636DFDFDFFFFFFFFFFFFF
F6F6F6FFFFFFCBCBCBD5D5D5FFFFFFC8C8C81F1F1F787878FFFFFFFFFFFF
FFFFFFFBFBFB525252FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCD7D7D70C0C0C
0000000000006C6C6CFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFF9F9F9FBFBFB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFDFDFDFFFFFFF9F9F9FFFFFFB0B0B00000000404040000009C9C9C
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFDFCF8F5
CCC5BD140F05FFFFF6FDFDF91D1D25DFDEEBFFFEFFFFFEFFFFFFFFF9FAFA
FBFFFCFAFEFBFFFEFFFEFBFFFFFEFFFBFBFBF9F9F9FFFFFFFFFFFFFFFFFF
F9F9F9FFFFFFF5F5F5FFFFFF5E5E5E585858FFFFFFF6F6F6FFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFB2B2B21313137F7F7FFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFF909090151515B1B1B1FBFBFBFBFBFBFAFAFA
FAFAFAFFFFFF000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFCFCFC292929000000
080808272727F5F5F5FFFFFFFFFFFFF6F6F6FEFEFEFFFFFFFDFDFDFFFFFF
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FDFDFDFEFEFEF8F8F8FFFFFFF9F9F9FFFFFF646464000000060606070707
D4D4D4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFD
FFFEEF645D4B898581FCFDFF4448539FA1ADFFFDFFFEF9FBFFFFFAFCFEF9
F9FFFFFBFFFFFAF8F9FFFDFDFFFDFEFFFFFFFFFFFFFAFAFAF8F8F8FFFFFF
FCFCFCFBFBFBFFFFFFFFFFFFFFFFFF2E2E2E8B8B8BFFFFFFFBFBFBFDFDFD
FDFDFDFBFBFB676767252525C2C2C2FBFBFBFFFFFFF7F7F7FFFFFFFCFCFC
FFFFFFFEFEFEF2F2F25050502F2F2FE0E0E0FFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFF010101FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF575757010101040404
0A0A0AD8D8D8FDFDFDFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEF8F8F8
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDFCFCFC2F2F2F000000030303
292929F6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFAF5F5
FFFBECFFFFED8783806D6D732E323B868892FBF7FFFFFCFFFFFFFAF9FBF5
F8FFFFFBFFFFFDFBFCFFFBFBFFFDFEFFFFFFFBFBFBFDFDFDFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFF5F5F5FFFFFFE6E6E6161616B8B8B8FFFFFFFFFFFF
DEDEDE303030545454E9E9E9FCFCFCFFFFFFFCFCFCFFFFFFFDFDFDFFFFFF
FCFCFCCECECE1D1D1D6F6F6FFCFCFCFCFCFCFFFFFFF9F9F9FFFFFFFFFFFF
FDFDFDF9F9F9070707FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9F070707000000000000
9D9D9DFCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFF
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBD4D4D4070707030303
000000686868F7F7F7FFFFFFF9F9F9FFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFD
FFFEF6FFFCF2FFFEFBFDFCFFFCFFFFFCFFFFFFFCFFFFFCFFFFFEFDFEFFFA
FCFFFDFCFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFCFCFCC0C0C0191919DEDEDEA3A3A3
171717969696FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFDFDFDFFFFFFFEFEFE
959595141414AEAEAEFAFAFAFFFFFFFCFCFCFEFEFEFFFFFFFDFDFDFDFDFD
FFFFFFFEFEFEA6A6A6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FFFFFFFBFBFBFFFFFFFEFEFEFFFFFFD4D4D40A0A0A0202020101015C5C5C
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9FFFFFFFFFFFF959595000000
010101060606B4B4B4F9F9F9FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFBF6F6
9A928DD5CEC6FFFCF9FFFFFFC6C9CD93969DFFFCFFFFFCFFFFFEFDFEFFFB
FCFFFDFCFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDB6B6B64F4F4F2B2B2B
C9C9C9FFFFFFFFFFFFF9F9F9FFFFFFFBFBFBFFFFFFFFFFFFEEEEEE5B5B5B
2C2C2CDADADAFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFAFAFAFFFFFF
FAFAFAFEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFF6F6F63232320000000000002D2D2DF9F9F9
F6F6F6FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFDFDFD565656
000000000000101010E9E9E9FFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFF
F3EAE1453D32F6F3ECF4F5F5282B3AECEDFDFFFDFFFFFDFBFFFDFDFEFFFF
F9FFFFF9FFFFFFFEFFFFFDFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFB0B0B0F2F2F2
FFFFFFFDFDFDFFFFFFFFFFFFF6F6F6FAFAFAFFFFFFCCCCCC2424246A6A6A
F0F0F0FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFFFFFFFFDFDFD696969000000080808080808D1D1D1FFFFFF
FFFFFFF2F2F2FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFDFDFDF3F3F3
1D1D1D0909090000003C3C3CF9F9F9FBFBFBFFFFFFFFFFFFF6F6F6FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCF9FFFFFDFF
FFFAF2AAA69AA6A39A8D8D8DACAABDFDFBFFFFFEFFFFFFFAFFFEFDFEFFFF
FCFFFFFCFFFFFFFEFFFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF9B9B9B131313A7A7A7FFFFFF
FFFFFFFDFDFDFBFBFBFFFFFFFFFFFFFAFAFAFCFCFCFFFFFFFAFAFAFFFFFF
FEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFEFEFEADADAD050505000000000000989898FFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFFFFFFFBFBFBFFFFFFFCFCFC
C8C8C80000000505050202027F7F7FFFFFFFFAFAFAFFFFFFFFFFFFF6F6F6
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFFFDF6F9
F7F9F4FCFFF829291F474141FFF9FFFFF9FFFCFFFFF9FFFFFCFFFFFFFEFF
FFFDFDFFFDFDFEFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFAFAFA
FEFEFEFFFFFFFAFAFAFEFEFEF4F4F45A5A5A252525D8D8D8FBFBFBFCFCFC
FFFFFFFDFDFDFDFDFDFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFDCDCDC0505050000000101015A5A5AFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFF3F3F3FFFFFF
FFFFFF818181000000000000050505CACACAFFFFFFFCFCFCFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF9FFFFFCFF
FEFFFBFAFFF6DFDED9F4EDF0FFF3FFFFFAFFFBFFFFF8FFFFFCFFFFFFFFFF
FFFCFDFFFCFDFEFFFFFBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFAFAFAFFFFFFD2D2D22B2B2B5F5F5FFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFDFDFDFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFAFAFAFEFEFEFFFFFF
FFFFFFFCFCFC010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEF4F4F4333333060606000000242424ECECECFFFFFFFFFFFFF8F8F8
FFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFFFEFEFE
FFFFFFFCFCFC4141410B0B0B0000001C1C1CE7E7E7FEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEF8FFFFFAFF
FFFFF6FFFDF2FFFEFDFFFDFFFFFCFFFBF9FFFFFDFFFEFFFFFFFFFDFFFFFB
FFFEFFFFFEFFFFFFFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF6F6F6
FFFFFFFCFCFCA4A4A41313139D9D9DFFFFFFFDFDFDFDFDFDFFFFFFFFFFFF
F9F9F9FFFFFFFDFDFDF8F8F8FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FEFEFE6D6D6D000000000000070707CBCBCBFFFFFFF5F5F5FFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFEFDFCFBF7FFFCF8FFFDFD
FFF9FFFFFBFFFFFCFFFEFDF9FFFFFB545557F1F2FFFBFEFFFBFFFFF7FDF9
FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFF
FFFFFFFCFCFC757575000000000000040404D5D5D5FCFCFCFCFCFCF9F9F9
FFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFEFEFEF4242423A3A3AE9E9E9FFFFFFFAFAFAFBFBFB
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFF
E7E7E7181818000000000000434343F8F8F8FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFAFBFEF9FBFFFCFFEFEDF07776721C1C18
44474BA6A9AEFBFCFCFEFFFBFEFFF8FCFFFBFEFEFFFFFDFFFFFFFDFFFFFA
FFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFCFCFCFBFBFBFBFBFBA7A7A7545454232323A5A5A5
FFFFFFF9F9F9FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFF
FFFFFFA9A9A90A0A0A9B9B9BFFFFFFFBFBFBFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFCACACA060606000000070707696969FFFFFF
FFFFFFFBFBFBFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF9FBF8FDFFFCFEFFFD
FCFFFBF9FDFA000103FEFFFFFEFDFFFFFDFFFFF9FEFFF7F5FFFCF4FFF8EA
FFFEE89F998954595DF9FFFFFFFFF4FCFBF429273CA7A7C1FBFFFFFEFFFF
FFFDFDFFFCFDFFFCFFFFFEFFFEFFFFFEFFFDFFFEFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFF7F7F7FBFBFB646464030303
030303060606D5D5D5FFFFFFFBFBFBFFFFFFFFFFFFF6F6F6FDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF3F3F3303030191919E4E4E4FFFFFF
FEFEFED5D5D55858581F1F1F8A8A8AE9E9E9FFFFFFFAFAFAFFFFFFFFFFFF
FCFCFCFEFEFEFFFFFFFFFFFFFEFEFEFFFFFBFFFFF4F7F8EEFFFDFFFFFDFF
FCFFFFF8FBFFFAF9F5FEFBF4FCFFFAF5F9F8FFFEFFFFFDFFFEFFFBF9FBF6
FAFEFFFEFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFCF7F9C7BDC6251E256A6965D6D8D2
F2FAFAF9FFFFFCFCFCFFFFFBFEFFFAF9FDFAF8FDFFFCFFFFFFFEFDFBFAF6
FFFDFCFEFEFEFEFEFEFEFEFEFCFCFCFBFBFBFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFB8B8B8323232
343434BBBBBBFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF8F8F8FFFFFFFDFDFDFFFFFFFBFBFBFBFBFBFFFFFFEFEFEF
6969691F1F1FD6D6D6FEFEFEFDFDFDFFFFFFFAFAFAFDFDFDFCFCFCFFFFFF
FCFCFCFFFFFFFBFBFBFFFFFFFFFFFF8E8E8E060606000000060606B1B1B1
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FAF7FEFFFDFEFFFDFEFFFB
F7FBF8FCFFFD000002FAFBFFFFFEFFF8F5FCFFFCFFFFFDFBFFF7EFFFFDEC
FFF4DA716A58000004A9B2B7F7FFF2E1E8DE261E35120B2ABBC1CCF9FFFF
FFFCFDFFFBFDFFFBFFFFFDFFFBFFFFFBFFFDFFFEFFFFFDFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FDFDFDA9A9A9010101000000
000000A2A2A2FFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFF202020DADADAFEFEFE
FFFFFFFFFFFFFFFFFFCBCBCB5454541E1E1E838383FDFDFDF9F9F9FFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFDFDFBFFFFFBFBFAF5FEFFFAFBFDFA
F5F9FAFBFFFFF9FFFDFCFFFBFFFDF9FFFCFDFFFBFFF8F3F7FCFFF6F9FFF6
F9FEFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF9F9F9FBFBFB
F7F7F7FFFFFFFFFFFFFEFEFEFBFBFBFEFEFEF9F9F9FFFFFFFDFDFDFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFF686868343434FBFBFBFEFEFEFFFFFFFDFDFDFFFFFFFFFFFFF8F8F8
FFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFBFBFB
FFFFFFFDFDFDFFFFFFFCFCFCD1D1D11515159F9F9F9F9F9F595959FFFFFF
FFFFFFFCFDFFF9FFFFFBFFFFE5E0E0383230494A44F5F7F1FEFFFDFCFCFC
FFFEFDFFFFFBFEFFFDF7F7F5FFF8FAF9F0F372727A979BA2FDFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB808080000000
040404000000CACACAFFFFFFFFFFFFF9F9F9FCFCFCFFFFFFFBFBFBFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDF8F8F8FFFFFF
FFFFFFFFFFFFF8F8F8FFFFFFA2A2A2000000000000000000A1A1A1FDFDFD
F8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFCFFFFFEFFFFFFFDFDFFFDFB
FFFEFDFEFFFFFCFFFFFEFFFFFFFEFAFFFEFAFFFFFDFCFFFFF9FFFFFBFFFF
FFFEFBFFFDF8FFFDFAF6F5F1FFFEFFFEFFFFFCFDFFFCFFFFF8FBFFF9FDFE
FFFEFFFFFFFFFFFEFDFFFEFDFFFEFDFFFFFDFFFEFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCF8F8F8FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9F9F9EDEDED0A0A0AF5F5F5FFFFFFFFFFFFFEFEFEFFFFFF
FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFF9F9F9FCFCFCFFFFFFFAFAFAFFFFFF
9999991111117C7C7CFBFBFBFFFFFFFFFFFFFEFEFEFFFFFFFAFAFAFFFFFF
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFAFAFA
FEFEFEF8F8F81B1B1BAEAEAEFFFFFFFAFAFAFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF666666343434
F3F3F3FCFCFCFAFAFAFFFFFFFBFBFBFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9
FFFFFFFEFEFEF6F6F6FFFFFFFFFFFFFDFDFDFFFFFFE8E8E84242429B9B9B
DBDBDB4442434B4648E8E6E5FBFFFDFAFEFBFFFDFFFFFDFFF2FBF6FEFFF8
F9E7D922130CA0AEB7D6E8F4FFFDFDC7BDBB57575D4D5158FDFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAF6F6F6FFFFFFFFFFFF
ABABAB0707070000000202029B9B9BFFFFFFFAFAFAFEFEFEFFFFFFFEFEFE
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFEFEFEFFFFFF
FFFFFFFCFCFC010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
FEFEFEFEFEFE737373000000040404040404CFCFCFFFFFFFFFFFFFFFFFFF
FCFCFCFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFEFAFFFEF8
FFFEFFFEFFFFFCFFFFFCFFFFFFFEFFFFFDFFFFFDFFFFFEFFFFFFFFFEFFFF
FFFFFDFFFEFDFFFCF9FBFAF6FFFEFFFEFFFFF8F9FDFCFFFFFCFFFFFCFFFF
FFFEFFFFFFFFFFFEFDFFFEFDFFFEFDFFFFFDFFFEFFFEFFFFEAEAEA050505
2929292E2E2E8D8D8DEBEBEBFFFFFFFAFAFAFDFDFDFBFBFBFCFCFCFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFE6E6E6D9D9D9FEFEFEFFFFFFFCFCFCFFFFFFF8F8F8FFFFFF
FFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFCFCFCFAFAFAFAFAFAFFFFFFFEFEFE
F6F6F6FFFFFFFFFFFFFAFAFAC6C6C61111119F9F9FFFFFFFF5F5F5FFFFFF
F9F9F9F7F7F7FFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FDFDFDFEFEFE5B5B5B9E9E9EFCFCFCFEFEFEFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFFEFEFEFBFBFBFAFAFAFFFFFF
FBFBFBFDFDFD5F5F5F5E5E5EFFFFFFFDFDFDFFFFFF444444585858A6A6A6
FCFCFCFDFDFDF9F9F9FCFCFCFFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFF
F4F4F4FFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFBFBFBFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFF3F3F3FFFFFFF9F9F9FFFFFF
FAFAFAFFFFFF9898980D0D0DB0B0B0FBFBFBFEFEFEF4F4F4FFFFFFFDFDFD
FFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFEFEFEFFFFFFFDFDFD
D5D5D50E0E0E080808000000686868FFFFFFF9F9F9FFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFAFAFAFFFFFF
FEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFECECEC1C1C1C030303000000494949FFFFFFF6F6F6FBFBFBFFFFFF
FFFFFFF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFBFBF9FFFFFFFDFEFEFFFFFFFEFFFF
C4C3C6A0A1A3E5E6EAF4F5F7FEFFFFFEFFFFFEFFFFFDFEFEFBFCFCFBFDFA
FFFFFDEFEFEDFFFFFF3C3C3CB0B0B04E4E4E020104050407C8C8C8F0F0F0
9D9D9D2F2F2F262626888888EBEBEBFFFFFFFBFBFBFFFFFFFBFBFBFAFAFA
FFFFFFFFFFFFF8F8F8FFFFFFF9F9F7FFFFFD9D9D9D676767FFFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFDFAFAF8
FFFFFFFFFFFFFBFBFBB9B9B94A4A4A151515656565DFDFDFFEFEFEFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFBFBFBFCFCFCFFFFFFFBFBFBFDFDFD
FFFFFFFFFFFF9F9F9FCECECEFEFEFEFFFFFF787878848484FAFAFAFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FBFBFB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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFF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FEFFFDFFFFFDFFFEFFFFFEFFFFFFFFFFFFFDFFFFFBFFFFFDFFFEFFF8F9FD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FBFFF7FEFFFBFFFDFFFFFAFFFFFEFDFEFDF6F8F5EC9E9D999D9DA5ABADB9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FBFFF8FEFFFBFFFCFFFFFCFFFFFDF6FFFDF4FDF9F5E4E2E315131EC8C7D4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F9FDFCF8F9F9FFFDFFFFFDFAFFFFF1FFFFF3F9F9FFFFFCFF756D78ADA5AE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FEFEFFFFFEFFFFFDFDFFFBF3FFFFECDCDCD0000011211F358B7B855E5254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FEFCFFFEFBFFFFFDFBFFFCF1FDF8E2B3B3A9070D25F5F4FF3520231F0D07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FEFAFFFFFCFFFFFDFBFFFEF4FFFFECCCCDC5090E2BFEFBFFFEE9E40E0000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FFFCFFFFFCFFFEF9FBFFFEFAFFFFF3F0F0EC1A1B35CEC8E0FFFAEF9A8A7A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FFFAFCFFFCFFFFFEFFF9F9F9FEFFFAFDFEFEB2AEC41C1324FFF6EAB8AF9E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FFFBFBFFFCFDFDFCFFFCFFFFFAFFFEFEFFFFFEF6FFC6B8C35E544A6E695F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FFFCFBFFFCFCFFFEFFFBFFFFF6FCFCFAFBFDFFFAFFFDEEF3FFFDFAFAFAF6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FFFCFDFFFBFBFBFCFEFBFFFFFBFFFFFAFBFBFFFBFDFFFAFDFFFCFFFBFEFF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FFFDFDFFFEFDFDFDFDFCFDFFFCFFFFFFFFFFFFFCFAFFF7F6FFFDFFFCFFFF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FBFDF8FEFFFDFFFFFFFBF9FCFCFBFFFFFFFFFFFFF8FFFEFAFFFCFFFEFCFF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F9FFFAFCFFFBFFFEFFFFFCFFFFFCFFFFFEFFF8FFF3FCFFF6FFFAFFFCF5FC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F5FFF4F4FEF3FFFDFFFFFAFFFFF9FFFFFDFFF0FFF1F4FFEEFFFDF8FFFBFD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F7FFF4F7FEF4FFFDFFFFF8FFFFF4FFFFFDFFF5FFF8F7FFF3FFFBF3FFF8F7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FCFFFBFEFFFDFFFEFFFFFEFFFFFCFFFFFEFFFCFFFDFCFFFBFFFFFBFFFDFD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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FCFCFCFFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFEFEFE969696686868FFFFFF
FFFFFFFEFEFEFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFD818181707070FEFEFEFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9FFFFFFFFFFFFEBEBEBC1C1C1
727272727272BABABAFFFFFFFFFFFFF6F6F6FFFFFFFDFDFDFFFFFFFCFCFC
F5F5F5FFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFF9F9F9FCFCFC
FFFFFFFFFFFFFCFCFCFFFFFFFAFAFAE1E1E19696964D4D4D101010D0D0D0
F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFEFEFEFCFCFCFCFCFCFBFBFBF8F8F8FAFAFAC8C8C8
7B7B7B7575757D7D7D070707000000060606858585FFFFFFFFFFFFFBFBFB
FAFAFAFFFFFFFDFDFDFFFFFFFDFDFDFFFFFFF9F9F9FCFCFCFEFEFEAEAEAE
070707000000000000949494F5F5F5FBFBFBFFFFFFFFFFFFFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFAF9FCFCF7F7
FFFEF4FAF3E91F1619E0D9DCFFFEF7FEFFF9FEFEFFFCFEFFF8FDFFFBFFFF
EFF4F8FCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF5858588F8F8FFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFDFDFDB1B1B10C0C0C000000C4C4C4F5F5F5FFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFDFDFDF9F9F97C7C7CFFFFFFFFFFFFFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFD5D5D56F6F6F1111111C1C1C0C0C0C
B2B2B0FFFFFDFBFBF9FEFEFCFFFFFFFDFDFDFCFBFEFFFEFFFEFDFFFFFEFF
FFFEFFFDFCFFFCFCFCFDFDFD212121C4C5C5FCFFFFFEFFFFFFFDFDFFFDFD
FFFEFFFEFFFFFBFFFDFCFFFBFFFDFDFFFCFFFFFEFFFEFFFFFBFFFFFCFFFF
FFFEFFFFFDFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFAFAFA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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFA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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFF
F6F6F6FFFFFFFFFFFF6868684E4E4EFFFFFFFFFFFF585858A5A5A5FFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF444444000000515151A1A1A1EDEDEDFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFCFCFCFCFCFCFEFEFE
FDFDFDFEFEFEFDFDFDFEFEFEFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFEFEFEF9F9F9FFFFFFFFFFFFFFFFFFEEEEEEAFAFAF6B6B6B
777777CBCBCBFFFFFFFFFFFFFFFFFFFCFCFC9B9B9B555555FFFFFFFEFEFE
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFAFAFA
FEFEFEFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFF6F6F62C2C2C000000030303
2B2B2BFCFCFCFFFFFFFCFCFCFAFAFA3F3F3F010101000000171717636363
808080C5C5C5FFFFFFFDFDFDFEFEFEFEFEFEFCFCFCFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFCFCFEFFFFFDFCFFFFFEFF
FFFEF5FFFBF3B0ABAD8C8A8DFEFFF9D5D7D2585B62FCFEFFF9FDFEF9FAFA
FEFFFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFEFEFEFAFAFAD3D3D3585858171717FBFBFBFBFBFB
FFFFFFFFFFFFEDEDED686868FBFBFBFCFCFCFCFCFCCFCFCF1E1E1EB3B3B3
FFFFFFFDFDFDFFFFFFE3E3E37979791313134F4F4FBFBFBFFDFDFDFFFFFF
FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFEFEFE
FFFFFDFCFCFAFFFFFFFFFFFFF9F9F9FFFFFFFFFEFFFFFEFFFBFBFBFFFFFF
FBFBFB4646449B9B99FFFFFDFAFAF6FFFFFDFEFCFDFFFEFFFEFFFFFEFFFD
FCFDF7FBF9FAFDF8FFFFFBFFFEFFFBFEFFF6FEFFFBFFFEFFFFFCFFFFFCFF
FFFFFDFEFFFAFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFE7E7E71D1D1DBBBBBB
FCFCFCFCFCFCFDFDFDFFFFFFFDFDFDFAFAFAFBFBFBFFFFFFF9F9F9FDFDFD
FFFFFFFFFFFFFDFDFDFAFAFAFBFBFBFFFFFFF9F9F9FDFDFDFFFFFFFFFFFF
FDFDFDFAFAFAFBFBFBFFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFDFDFDFAFAFA
FBFBFBFFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFDFDFDFAFAFAFBFBFBFFFFFF
F9F9F9FDFDFDFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF2F2F2FFFFFF
FFFFFFFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFE
FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF
6868680C0C0C3B3B3B808080D4D4D4FFFFFFF8F8F8FFFFFFFFFFFFFDFDFD
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCB1B1B1444444FFFFFFFFFFFFFFFFFFFFFFFF
F5F5F5FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFE6E6E69898986C6C6C808080
DCDCDCEFEFEFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF7F7F7FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFF3A3A3A
0101010101010000000000000A0A0AFBFBFBFDFDFDFFFFFFFDFDFDFFFFFF
F3F3F3FEFEFEFBFBFBFEFEFEFFFFFFFCFCFCF8F8F8FFFFFFFFFFFFFCFCFC
FFFFFFFCFCFCFFFFFFFDFDFDFAFAFAFDFDFDF2F2F2A9A9A96D6D6D878787
D3D3D3FFFFFFFDFDFDF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFBFBFBFDFDFD
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFCFCFFFFFBFFFFFB
FFFEFFFCFAFBF9F8F357575300000503030B020607565A59BDBCC1FAF8FB
FFFDFDFFFEFBFFFDFCFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF9E9E9E929292
FFFFFFFFFFFFFDFDFDFAFAFAFFFFFFFEFEFEFDFDFDDBDBDB0C0C0C000000
0303030000000B0B0B080808EFEFEFFBFBFBFDFDFDA7A7A7CBCBCBFCFCFC
FEFEFEFFFFFFFDFDFDFDFDFDF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFCFCFC
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFFEFEFEFCFCFCFCFCFCFCFCFCFFFFFF6D6D6B767674
FFFFFBFBFBF7FFFFFAF8F9F35F6058C0C0B6E4DED00300004E546CBAC2D7
FEFFF4D8D4C47F737D0E0518ECF0FBF2FBFFFBFFFFFFFEFFFFFAFAFFFBF9
FCFFFFF9FFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFCFCFCFFFFFFFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFFFFFFFB8B8B8
757575FDFDFDFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FAFAFAFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFAFAFAFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFAFAFAFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
FCFCFCFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFBFBFB
FFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEFEFEFE
FFFFFFFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFEFEFEC8C8C87575752121212425277A7A7A
C8C7C3FFFFFBFFFFFFFEFDFFFFFEFFFFFEFFFFFFFFFFFFFDFEFFFFFEFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFDFDFDFFFFFF131313E1E1E1FFFFFFFFFFFFFCFCFCFBFBFB
FFFFFFFDFDFDFFFFFFF9F9F9FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
FDFDFDFFFFFFF7F7F7BABABA6C6C6C727272C1C1C1FBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFF
B5B5B53F3F3F2C2C2CACACACFEFEFEFDFDFDFFFFFFFFFFFFFEFEFEFEFEFE
FAFAFAFFFFFFFAFAFAFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFF9F9F9FFFFFF
FEFEFEFFFFFFFFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFAFBFBFBFFFFFFC0C0C0777777797979C3C3C3F8F8F8FFFFFFFBFBFB
FFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFFFFFFFFFDFFFFFEFFFFFEFFFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFBFAFDFFFFFFFEFEFAFEFEFC
FFFEFFFFFEFFF6F7EDFFFFF8E8E8F00F0F19000103000000000004000002
0503020C0B07000000000000FFFFFFF0F0F0616161E4E4E4FFFFFFFEFEFE
FEFEFEFBFBFBFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFCFCFCD4D4D4111111
0A0A0A0C0C0C3D3D3DFDFDFDFEFEFEFDFDFDFCFCFC6A6A6AE0E0E0FFFFFF
FFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFDFDFD7676766C6C6CFFFFFD
FCFCF8FCFDF7FFFFFAFFFEF7C0BFB83B3B2FFFFFF1EEEEEA120F28D4D2E8
FEFFF7FFFFF3FDFBFEFFFBFFFEFDFFFEFEFFFEFDFFFFFEFFFFFFFAFFFEF9
FEFDFFFEFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFBFEFEFED2D5DA767779
26231A252219747472C4C5C9FDFDFFFFFDFFFFFDFCFEFEFAF9FFFDFBFFFF
FFFCFFFFFCFFFFFDFFFEFCFFFFFFFFFCFCFCFEFFFFFEFFFFFAFAF8FFFFFD
FFFEFDFDFBFAFCFAFBFFFEFFFFFFFFFDFEFEFBFFFFFCFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFF
F8F8F8FFFFFFFBFBFBC1C1C1373737FAFAFAFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFBFBFBBEBEBE7A7A7A686868BCBCBC
F8F8F8FDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD4D4D47E7E7E737373AEAEAE
F7F7F7FFFFFFF5F5F5FFFFFFFFFEFFFBF9FCFFFBFFFFFAFDFFFDFDF9F9F5
FEFFFAFDFFF9FFFFFDFFFFFFFCFDFFFCFDFFFEFFFFFEFEFCFFF9FCFFFCFF
FFFDFFFDFBFCFBFAFDFEFFFFFCFFFFFCFFFFFBFFFEFCFFFFFEFFFDFFFFFB
FFFEFDFFFEFDFFFEFFFFFEFFFFFEFFFFFEFFF9F9F7FFFFFDFFFEFFFBFBFF
FEFFFFFCFEFBFEFFF6FEFFF6FEFDFFD6D4DD0A0610010005040205000000
2527225C615B979996B1B1B1DADADA686868EDEDEDFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFE
BABABACACACAFFFFFFF9F9F9FFFFFFFFFFFF939393D1D1D1FFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF8F8F8FEFEFEFFFFFFFFFFFF
FAFAFAFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFDFDFDFDFDFDFFFFFF
FEFFFDFDFFFCFEFFFFFEFFFFFFFEFFFFFEFFECEBEE141414E2E0E1FFFEFD
FFFEFAFEFDF8FFFCF3FFFFF4FEFBF0605D54969590FDFDFD54525D9A98A1
FCFCFAFFFFFBFBFAFDFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFDFDFDF7FCFFFCFFFF
FFFDF3D3CFC37878742C2F341A19266A6873C7C5C4FCFDF7F1FBF6F6FEFC
FFFCFFFFFBFFFFFCFFFFFEFFFBF9FAFFFFFFF5F6F6FEFFFFFFFFFDFDFDFB
FEFCFBFFFEFDFFFDFFFFFEFFFCFCFCFBFCFCFBFFFFFBFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFDFDFD
FFFFFFF8F8F8FFFFFF686868828282FCFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFDFDFDFCFCFCFDFDFDFDFDFDFBFBFBFFFFFFC8C8C8
7B7B7B6C6C6CACACACEEEEEEFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFFFFFF
FAFAFAF4F4F4B7B7B7FCFCFCFCFCFCFEFEFEFFFFFFFFFFFFFEFEFEFBFBFB
FEFEFEFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFDEDEDE
8686866B6B6BA9A9A9EFEFEFFFFEFFFFFDFFFFFBFFFFFBFFFFFDFEFDFFFC
FEFFFAFEFFF8FEFEFAFBFBF9FEFFFFFEFFFFFBFCFEFFFFFFFFFCFFFFF9FC
FFFDFFFFFEFFFFFEFFFEFFFFFBFEFFF9FFFFFAFFFEFCFFFFFEFFFDFFFFFB
FFFFFBFFFEFDFFFEFFFFFEFFFEFEFFFFFEFFFFFEFBF6F5F1F5F8FDFBFFFF
F3F7F8FAFAF6FFFFF6FFFFF6FEFFFFF8F8FE75717D0B050F0E090D2E2C2B
333935EDF3EFF9FAFAC1C1C1777777FAFAFAFFFFFFF7F7F7FDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF8F8F8FFFFFF
FCFCFCFEFEFEFFFFFFFFFFFFFEFEFE8A8A8ABEBEBEF7F7F7FEFEFEFFFFFF
FDFDFDFFFFFFF8F8F8FEFEFEFFFFFFB4B4B4F4F4F4FFFFFFFDFDFDFFFFFF
F7F7F7FDFDFDF7F7F7FFFFFFFFFFFFF6F6F6FFFFFFFCFCFCFFFFFFFFFFFF
FDFFFCF8FAF7FEFFFFFCFDFDFEFDFFF8F7FA8E8D90565558FFFDFEFDFBFA
FFFEFBFFFEFAFFFFF6FBF8EDFFFDF3FFFDF48684836F6E7116151849484B
FEFDFFFFFEFFFCFBFEFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFFFFAFFFFFBFFFF
FFFEF6FFFEF4FFFFFDFEFFFFD5D7E182828A3432311818145F6765C0C6C6
FFFDFFFFF8FBFFFCFFFFFDFEFFFEFFFFFFFFFEFFFFF9FAFAFEFFFFFBFBFB
FFFEFFFBF9FAF8F6F7FFFEFFFFFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFDFDFDFAFAFA1F1F1FD7D7D7FDFDFDFFFFFFFFFFFFFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFD4D4D48282826F6F6F9B9B9BF3F3F3FFFFFFFFFFFFF8F8F8
FFFFFF8080806A6A6AFFFFFFFFFFFFFFFFFFFCFCFCFAFAFAFFFFFFFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAF9F9F9
FFFFFFFFFFFFE1E1E18B8B8B6B6B6B9C9A9BF1EBEBFFFCFEFCFFFFFBFFFF
FBFDF8FEFFF8FEFFFAFEFFFAFCFCFAFFFEFFFDFDFFFEFEFFFBF9FAFFFEFD
FFFAFAFEFCFBFFFFFFFEFFFFFCFFFFFCFFFFFCFFFFF9FDFCFEFFFDFFFFFD
FFFEFDFFFEFDFFFFFFFFFEFFFEFFFFFFFEFFFFFBF8FFFBF9F8FFFFF4FFFF
F9FFFFFFFFFBFFFEF6FFFBF5FAFBFBFBFFFFF6F6FF1B17210C0107898383
8389850D1611757676A3A3A3FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFAFAFA686868C9C9C9FFFFFFFCFCFCFFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFBFBFBFFFFFF6666660F0F0F6F6F6FDCDCDCFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFBFBFBFFFFFFFBFBFB
FEFFFDFEFFFDFCFDFDFDFEFEFFFEFFF8F7FA0F0E11DAD9DCFFFEFFFFFEFD
FFFEFBF9F5F1FFFFF8FFFFF6F9F6EBFFFFF8FEFCFBFFFEFFEAE9EC070609
ECEBEEFAF9FCFFFEFFFEFDFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFAFFFFFFFBFFFFFBFFFF
FEF8F5FEF9F3FBFBF9FBFCFFFBFEFFFEFFFFF3F1F0E2E0DF8B8F902C2F33
171514666060BBB6B8FAF8F9FFFDFEFEFEFEF9FAFAFEFFFFF8F9F9FEFFFF
FFFDFEFFFEFFFFFEFFFDFBFCFBFBFBFEFFFFFEFFFFF9FDFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
F9F9F9FFFFFFCACACA2B2B2BFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFCFCFCFAFAFAFAFAFAFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFF2F2F2E3E3E38B8B8B6363638F8F8FE9E9E9
FFFFFF222222C7C7C7FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF8F8F8FFFFFFFBFBFB
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFE8E6E5A3A29E6D6D6D8C939BDBE2EA
FCFEFBFFFFF8FBFFF7FBFEF5FFFBF7FFFDFFF8F8FFFCFEFFFCFFFFF9FBF6
FFFEFDFFFEFDFDFDFDFCFCFCFCFDFFFCFFFFFEFFFFFEFFFFFFFFFFFFFFFD
FFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFFFEFFFFFCF8FFFDFAF2FBFDF4FFFF
F9FFFFEEEEEC4B423D372E29171717D8DDE1FAFCFFA6A4AD0D04097E777A
FAFEFB525854131414959595F7F7F7FFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFAFAFA
FFFFFFFBFBFBEBEBEB595959EFEFEFFAFAFAFDFDFDFFFFFFFEFEFEFCFCFC
FFFFFFF8F8F8FBFBFBFFFFFFFEFEFEFFFFFFE3E3E37F7F7F0F0F0F414141
B7B7B7FBFBFBFFFFFFFFFFFFF7F7F7FFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FBFDFAFEFFFD454646E1E2E2FDFCFF959497565558FCFBFEFDFBFCFFFEFF
FFFDFDFFFEFBFFFEFAFFFFF8FFFFF6F7F6EFFBF9F8FFFEFFECEBEE222124
B7B6B9FFFEFFFDFCFFFDFCFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFCFEFDFFFCFFFFFEFFFF
FFFEFBFFFDFBFFFFFFFEFFFFFCFFFFF9FAFAFFFFFBFFFAFAFEFEFFFEFFFF
E3E3E18F8E8A403B3B121011555354B9B9B9FCFDFDFDFEFEFEFFFFFBFCFC
FEFCFDFEFCFDFFFEFFFFFEFFFFFFFFFEFFFFFDFEFEFBFFFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFF777777787878FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFDFDFD
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFDFDFDF9F9F9FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC5C5C5999999
505050181818D5D5D5FFFFFFFFFFFFFFFFFFFAFAFAFAFAFAFFFFFFFFFFFF
FBFBFBFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFB9E9E9E
4A4A4A1515154444448D8D8DF9F7F6FFFFFBF5F5F1FCFFFFEEF7FFA1A9B4
74737684837ECFD6CEFCFFF8FFFEF6FFF9F7FEFEFFF9FFFFF2FAFAFBFFFB
F9F9F5FBFAF6FDFDFBFFFFFDFFFFFFFBFCFCFDFCFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFEFDFFFBF5FFFCF7F5FDFFF5FFFF
F8FFFFFEFFFDFFF9F49C938EF1ECEEE8E7EDFCFFFFF6F9FF0000024B4B4B
5F5F5FE4E5E5D6D6D62E2E2E636363F8F8F8FFFFFFF6F6F6FFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFDBDBDB636363FFFFFFF9F9F9FFFFFFFFFFFFFAFAFAFFFFFFFDFDFD
F8F8F8FFFFFFF7F7F7FFFFFFFFFFFFF7F7F7FFFFFFF7F7F7FFFFFFABABAB
3131311B1B1B808080F1F1F1FFFFFFFBFBFBFFFFFFF9F9F9FFFFFFFCFCFC
FEFFFDFEFFFD40423FBEBFBFF3F2F51C1B1EC7C6C9FFFEFFFFFEFFFFFEFF
FEFCFDFFFEFDFEFAF7FEFAF6FFFEFAFFFFFAFFFEFDF9F9F9E3E3E3A6A6A6
B2B2B2FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFF9FCFFFBFCFF
FFFBFDFFFDFDFFFEFFFEFFFFFBFFFDFCFFFBF9F5F2FFFDFFFFFDFFFFFEFF
F5F7F2FFFFFAFAF8F7EAE5E79C9A9B3737370F10105A5B5BAAABABF7F8F8
FFFFFFFFFEFFFDFBFCFBF9FAFCFCFCFDFEFEFEFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFF222222CFCFCFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFCFCFCFFFFFFFFFFFFFFFFFFFDFDFDF9F9F9FAFAFAFEFEFE
FFFFFFFFFFFFFEFEFEFCFCFCFEFEFEFFFFFFF9F9F9FCFCFC111111EAEAEA
7777776E6E6EAFAFAF6565657A7A7AC8C8C8FFFFFFFFFFFFFFFFFFFBFBFB
FAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFA040404030303
000000010101000000121210353332F8F8F4FEFFFAF9FFFFEFF8FFF8FFFF
FDFBFEFFFEFDB2B8B473756F7E7468CFC4BEFFFDFFF9FFFFF6FFFFF9FFFD
FEFFFDFFFFFBFFFFFDFFFFFDFFFFFFFFFFFFFFFDFFFDFCFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFBFFFAF2FFFDF6FBFFFFF7FFFF
F3FEFFFAFFFCFEF9F3F9F0EB7C7376FFF9FFFCFFFFF8FCFF595F5F0D1110
F0EEEFFFFEFFFFFEFFF3F3F3595959303030CACACAFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF
ABABAB828282FFFFFFFCFCFCFFFFFFF9F9F9FBFBFBFCFCFCFFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFCFCFC
FFFFFFD3D3D36767670C0C0C5E5E5EC7C7C7FFFFFFFFFFFFFBFBFBFFFFFF
F9FBF8FEFFFD626461939592AAAAAA454447FDFCFFFFFEFFFFFDFFFFFEFF
FFFEFFFDFBFCFFFBFBFFFEFBFFFCF9F9F8F4FFFFFDFFFFFFF9F9F9FDFDFD
FFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFEFFFCFFFFFEFFFF
FFFDFFFFFDFFFEFCFFFBFCFCF9FFF9FCFFFAFFFEFBFDF6F9FFFBFFFEFBFF
FCFFFDFBFFF9FFFEFDFFFBFBFFFEFFFAFAFAE7E8E8979B9A4243450C0D0F
525154A5A4A7F3F1F2FFFEFFFDFDFDFDFEFEFEFFFDF8FCF9FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
F7F7F7D6D6D6242424FDFDFDFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF3C3C3CC2C2C2
1C1C1CD7D7D7FDFDFDFFFFFFF4F4F4BABABA7070706E6E6EBCBCBCFDFDFD
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD606060050505000000
03030300000001010101000004000024231FFCFFFBF9FFFFF7FFFFF9FFFF
FFFCFFFBF6F8F8FBFFFFFFFBFFFCEFCDBCB07775786B727ABBC4C7F5FDFF
F1F5F4FDFDFBFFFFFDFDFDFBFBF9FAFFFEFFFFFDFFFFFEFFFFFDFFFFFEFF
FFFEFFFEFFFFFEFFFFFEFFFDFEFFFDFFFFFAFFFCF2FFFDF4EDEEF0EFF8FB
F6FFFFF9FFFFFFFEFAFFFBF9F6E9EE726A73F7FAFFB7C0C5707A79F9FFFD
FFFDFFFDF6FBF9F7F8FCFCFCFFFFFF8080800B0B0BFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF6F6F6909090
AAAAAAFFFFFFFEFEFEFAFAFAFFFFFFFFFFFFF7F7F7BDBDBDDCDCDCF7F7F7
FCFCFCFFFFFFFBFBFBFFFFFFF5F5F5FFFFFFFCFCFCFDFDFDF6F6F6FFFFFF
FDFDFDFCFCFCF9F9F9F1F1F18E8E8E202020333333959595F6F6F6FFFFFF
FEFFFDFEFFFD7A7C797A7C79292929BEBEBEFBFAFDFDFCFFFEFDFFFDFCFF
FEFCFFFFFEFFFFFDFEFEFCFBF7F5F4FFFEFDFBFBFBFFFFFFFFFFFFFDFDFD
F5F5F5FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFCFDFFFEFFFF
FFFDFFFFFCFFFFFEFFFEFFFFFBFFFAFAFFF8FFFDFAFFFCFDFFF7FFFFFCFF
FBFFFFF9FFFDFBF9F8FFFDFDFFFEFFFFFFFFFDFEFEFBFFFEFEFFFFEBECEE
9D9C9F48474A141213464445AAAAAAEEEEEEFEFFFDFCFEFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFF8282826D6D6DFFFFFFFFFFFFFAFAFAFDFDFDFFFFFFFEFEFEFFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFCFCFC
FEFEFEFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFBFBFB5454547E7E7E
323232FEFEFEFFFFFFFDFDFDFFFFFFFDFDFDFEFEFEFAFAFAC4C4C4707070
6D6D6DB4B4B4FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCBCBCB040404060606000000
000000000000020202030102070101120E0BB8BDB7F6FEFCF8FFFFFAFFFF
F9F3FAFFFCFFFEFEFFF8F6F9FFF5E7BBA99A76757191969AB7BEC4787F85
767C7CB4B8B7F1F2F2FFFFFFFFFDFFFFFCFEFFFCFFFEF9FDFFFDFFFFFEFF
FEFFFFFEFFFFFEFFFFFEFFFDFEFFFBFFFFF8FFF9EE8D8077030706566065
7B8688F2F8F8FDF7F4EBDFDEFFF8FD30283180848BA3ACAFF4FEFDFBFFFF
FFFCFFFFFCFFFFFEFFFEFEFEE2E2E22727275B5B5BFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE696969CACACA
FEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFD2D2D21B1B1BABABAB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFDFDFDB9B9B95050500E0E0E727272
DADCD9FBFDFA9C9E9B3F413E383838FAFAFAFFFEFFFFFEFFFFFEFFFFFEFF
FAF8FBFFFEFFFDFBFCFFFEFFFFFEFFFCFAFBFEFEFEFDFDFDFFFFFFFDFDFD
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFDFFFFFDFFFFFEFFFEFFFDFBFFFBFBFFFAFFFEFBFFFBFDFFF9FEFFFCFF
F8FFFFF7FFFF8E8E8E040000333132AEAEAEFEFFFFFAFEFDFCFFFFFEFFFF
FFFEFFFFFEFFEEECEDA9A7A8434343111111484A479EA09DEDEDEDFFFFFF
FEFEFEFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFF6F6F6
FFFFFF3B3B3BBCBCBCFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF747474383838
8C8C8CFFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFF
FDFDFDC8C8C87D7D7D666666ABABABFAFAFAFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFEFEFEFFFFFF
FDFDFDFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFA1A1A10F0F0F000000010101
0303030000000606060200010400000D0707999B98FBFFFDFCFFFDF7F8F8
FFFDFFFFF9FFFBF8FFFFFBFF917D701100009A978E676B6C080812D2D4E0
F6FAFFD9DEE18488896A6A6AB0ABADF5EFEFFEF7FAFFFDFFFCF9FFFFFEFF
FEFFFFF4F8F9FEFFFFFEFFFDFDFDF9FFFEF6FFF2E7190B00D1D9D7F2FFFF
C2CFD3CCCFD3FFF7F7A29293160D12222126C4CBCFF8FFFFE6EAEB030303
D4D1D7FFFEFFFDFCFFE5E5E51919198F8F8FFFFFFFFDFDFDFFFFFFFCFCFC
FDFDFDFFFFFFFDFDFDFBFBFBFFFFFFFFFFFFE5E5E55C5C5CEEEEEEF9F9F9
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFD4D4D4111111
B2B2B2FFFFFFFEFEFEFEFEFEFDFDFDFFFFFFFDFDFDFEFEFEFFFFFFF7F7F7
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFDBDBDB787878
15171445474482828011110FD5D5D5FAFAFAFFFEFFFDFCFFFFFEFFFFFEFF
FDFCFFFFFEFFFEFDFFFFFEFFFCFBFEFFFEFFFFFFFFFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFF
FFFEFFFFFDFFFFFEFFFEFFFDF8FFFCF8FFF8FFFBF8FFFBFAFFF6F7FFFBFD
F7FFFFEEFDFFFCFCFCABA5A5E2DDDFEAEAEAF9FAFAFCFFFFFCFFFFF7FBFC
FBFCFEFFFEFFFEFCFFFEFCFDFFFFFFF2F2F0A4A6A3525451101010454545
9C9C9CEAEAEAFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFFFFFFFF
E6E6E60C0C0CFCFCFCFCFCFCFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC909090040404
7B7B7BE1E1E1FFFFFFFAFAFAFBFBFBFFFFFFFEFEFEF9F9F9FDFDFDFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFD2D2D28686866262629F9F9FF4F4F4F3F3F3
FFFFFFFAFAFAFFFFFFFCFCFCFCFCFCFFFFFFFBFBFBFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFFFFFF8686860E0E0E050505000000
0000000404040000000100000903030A0404828282FEFFFBFCFCF2FFFFF8
F8F5FBECE8F6FFFBFFFFF7FFC3AFA2E7D6C2F9F9EDFCFFFD96909A44404E
F9FFFFF8FFFFFAFFFFFEFFFFE5E0E2938D8D7B75759D989AF2F0F3F5F6FA
FCFFFFFCFFFFFEFFFFFEFFFDFFFFFBFFFBF3FCE6D92C1B11D7DFDDF1FFFF
F7FFFFFEFEFFFFF4F7F7E7E85D565BE2E5E9F8FFFFF6FEFFA5A4A7010000
DEDDE0FDFCFFDEDDE01414149C9C9CFDFDFDFDFDFDFAFAFAFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBCFCFCF6F6F6FFDFDFDF8F8F8FEFEFE
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFFFFFFF5F5F5FFFFFFD2D2D2
0F0F0FBBBBBBFEFEFEFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFF5F5F5FFFFFF
FFFFFFFBFBFBFFFFFFFBFBFBFFFFFFFFFFFFF8F8F8FBFBFBFFFFFFFDFDFD
F5F7F4A4A6A330302E11110F818181EAEAEAFFFEFFFFFEFFFDFCFFFFFEFF
FFFEFFFCFBFEFEFDFFFFFEFFFFFEFFFBFAFDFDFDFDFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFF
FFFEFFFFFEFFFFFEFFFEFFFFF9FFFFFBFFFFFFFEFBFFFBF6FFF5EFFFFBFA
F1FEFFF2FFFFFAFBFDFFFBF9948F8FD7D7D7FEFFFFFCFFFFF5F8FCFCFFFF
FEFFFFFFFEFFFFFEFFFEFCFDFCFCFCFDFDFBFEFFFDFEFFFDF6F6F6A9A9A9
5858580E0E0E353535999999E6E6E6F8F8F8FDFDFDFFFFFFFFFFFFFDFDFD
8C8C8C686868FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFCFCFCFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB868686060606
6464641717172C2C2C7F7F7FCFCFCFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFF
F1F1F1FFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFDFDFDE0E0E09595956C6C6C
8B8B8BEFEFEFFFFFFFFBFBFBFEFEFEFCFCFCFFFFFFFFFFFFFCFCFCF8F8F8
FCFCFCFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFBEBEBE111111000000040404
060606000000040404020001040000140F11BAB8B9FFFFFAFFFBEC989186
00000400000D0E0518D5C7D2FFFAF1AB9E8D00030000010020141D070008
E4EAF6F5FFFFF8FFFFF7FAFFFFFEFFFFFDFDFFFDFDEAE5E59A989B757678
929599DCE2E2FAFEFFF9FBF8FFFFFBFFFEF6FFFAED605247969A9BF3FFFF
F1F9FFEBEBF3D9CED26D6163FDF8FAFEFFFFF9FFFFF3F9F93939390A0809
CBCACDD2D1D41B1A1D9E9E9EFFFFFFFFFFFFFDFDFDFFFFFFF5F5F5FFFFFF
FEFEFEF7F7F7FFFFFFFBFBFBA3A3A3929292FFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFF
CACACA090909B6B6B6FFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFFFFFFFFFFFF
FBFBFBFFFFFFFEFEFEFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FDFDFDFFFFFFF9F9F9000000616161131313555555C6C6C6FFFFFFF4F4F4
FFFEFFFFFEFFFEFDFFF6F5F8FFFEFFFFFEFFFDFDFDFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFD
FFFFFFFFFFFFFFFEFDFEFFFFF9FFFFFBFFFFFFFEFBFFF4ECFFF4E8FFF9F2
F1FEFFEBFEFFFEFFFFFFFDFBFDF8F86E6E6CF6F7F9FBFFFFFCFFFFFCFFFF
FBFCFFFCFDFFFFFEFFFFFEFFFFFFFFFFFFFDFDFDF9FBFDF8FCFCFCFFFFFF
FEFEFEFDFDFDBABABA5555551212123E3E3E929292E6E6E6F6F6F6FFFFFF
3E3E3EAAAAAAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF404040181818
FDFDFDFFFFFFC9C9C97070702525251D1D1D6D6D6DB5B5B5FFFFFFFDFDFD
FFFFFFFDFDFDF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFBFBFBFDFDFD
EFEFEF9090905B5B5B8C8C8CDCDCDCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF0B0B0B030303000000
0101010000000000000505050503041B191AFCFAFBFCF7F1FFF5E4190F01
9A9FA3F0F6FF877F8A1A0B10F4E5DE0E0500A8AEAAF8FCFB7F6F700E0004
C3CAD8F1FFFFF7FFFFFBFFFFFFFEFFFCF7F7FFFDFBFFFEFBFDFBFCFEFFFF
EBEEF2A6ABAE6D71728D8F8CD7D7D3FEF7EFFFFCEDECDED3030205D6DDE5
D7DBE60A0A12888184FFF9FAFFFDFFF8F7FAFAFEFFD8DCDD080A070B0B0B
A4A3A6121114A4A3A6FFFFFFFAFAFAFFFFFFFAFAFAF9F9F9FFFFFFFCFCFC
FFFFFFFFFFFFF4F4F4828282BEBEBEF9F9F9FAFAFAFDFDFDFFFFFFFFFFFF
FEFEFEFDFDFDFEFEFEFFFFFFFFFFFFFDFDFDFBFBFBFFFFFFFFFFFFFBFBFB
FFFFFFC6C6C6212121BBBBBBF9F9F9FDFDFDFFFFFFFFFFFFF9F9F9FFFFFF
FDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFBF7F7F7
FFFFFFFFFFFFFFFFFF212121DFDFDFE9E9E99292922626262D2D2DA3A3A3
FAFAFAFDFCFFFFFEFFFFFEFFFEFDFFFBFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFD
FEFFFBFFFFFBFFFFFBFFFFFFF7FFFFF9FFFFFFFCFAFFFBEFFFF4E1301F15
323F50DDF1FFFEFEFFE2DCDAFFFDFD7A7A78B1B2B4FCFFFFFBFFFFF4F7FB
FAFBFFFEFFFFFFFEFFFCFAFBFEFCFDFFFFFDFFFFFBFDFDF9FFFFFFF8F8F8
FFFFFFFAFAFAFEFEFEFFFFFFFAFAFAB9B9B96363631111113737377E7E7E
111111FFFFFFF9F9F9FFFFFFFCFCFCFBFBFBFAFAFAFAFAFAFEFEFEFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEEEEE151515050505
FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFD2D2D28383833D3D3D020202595959
AFAFAFEFEFEFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFEFA8A8A86161617A7A7AD2D2D2FBFBFBFDFDFD
FFFFFFFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFAFAFAE1E1E1010101040404
0000000606060A0A0A000000020305F6F6F6FFFEFFFFFDF6EED9C6130500
E7F1F8F4FFFFFFFCFC978984CBC2BD0C0C0CECF6FFF3F8FCFFF8F233211D
939AAAF0FFFFEEFBFFF9FFFFFCFBFEFFFEFBFFFCF9FFFEFAFFFFFDFBFCFC
FAFEFFFBFFFFFCFFFFF2F3F3BAB8B77E7971897D6DDFD2C7E3DCE164626F
3F3E4C4A4C56FFFEFFFFFDFCFFFEFFFFFEFFFDFCFF4A4B4B000100000100
121114A09EA1F5F4F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF2F2F26A6A6ACBCBCBFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFEFEFE
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFEFEFEFEFEFEFDFDFDFCFCFCFDFDFD
FFFFFFFAFAFABDBDBD101010C9C9C9FFFFFFFDFDFDFFFFFFFBFBFBFEFEFE
FFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFF3A3A3AB7B7B7FFFFFFFEFFFDF9FBF8BBBDBA454744
10120F6D6E6ED7D8D8FEFFFFFDFEFEFCFDFDFFFFFFFFFFFDFBFBF9FFFFFD
FFFFFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFB
FEFFFAFFFFFAFFFFFAFFFFFFF8FFFFF7FDFFFFFBF9FFF6E7FFF9DF685648
6D7C91CFE4FFF8FAFFC9C3C12E292911110FECEDEFF8FCFDF8FDFFFBFFFF
FEFFFFFEFFFFFFFEFFFFFEFFFFFDFEF8F6F5FAFAF6FFFFFBF9F9F9FFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFBFBFBC0C0C03F3F3F
0000002929298A8A8ADDDDDDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9F4F4F4F111111
E8E8E8FFFFFFFFFFFFF6F6F6FFFFFFF8F8F8FFFFFFFFFFFFE7E7E7999999
4646460A0A0A4646468C8C8CEAEAEAFFFFFFFAFAFAFFFFFFFCFCFCFFFFFF
FBFBFBFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFF7F7F7B4B4B46E6E6E757575
BCBCBCFFFFFFFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFFE0E0E0474747
0101010A0A0A030303393A3AEAEEEFF6FAF9FFFEFDFFF7EFFFF4E1241405
A9BAC1F0FFFFFFFFF3FFFDEDF7F3F0161A25B8C4D8FBFEFFFFFAECA99588
4D5665EDFFFFEEFDFFF8FFFFFFFEFFFFFEFBFDF7F4FFFFF8FEFEFAFCFFFF
FBFFFFF7FCFFF9FDFEFBFCFCFAF8F7FEF9F1FCF3E2574D41766D723E3746
D8D5E48B8B95D3D2D5FFFFFFFBFBFBFDFDFDCCCCCC020200040400070705
0000020A090C000000000000000000FFFFFFFCFCFCFFFFFFF7F7F7FFFFFF
E6E6E65E5E5EEEEEEEFFFFFFFDFDFDFFFFFF5D5D5DF5F5F5FEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F3F3F3FFFFFFFFFFFFC0C0C00F0F0FC3C3C3FDFDFDB1B1B17A7A7AFEFEFE
FFFFFFFEFEFEFFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFF1F1F1FFFFFF7F7F7FADADADFBFBFBFEFFFDFEFFFDFBFDFAFEFFFD
DEE0DD7A7C79191A1A454646B3B4B4FDFEFEF7F7F5FFFFFDFAFAF8FFFFFD
FFFFFDFBFBF9FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFBFFFFFB
FEFFF8FFFFF8FFFFF8FFFEFFF8FFFFF9FEFFFFFDFBFFF8E9FFFADAB7A694
56647EE4FAFFFCFEFFFFFBF9FCF7F7FBFBF9FCFDFFFCFFFFFBFFFFF3F8FB
FDFEFFFDFEFFFCFBFEFCFCFCFFFEFFFFFEFDFFFFFBFDFDF9FFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFFCFCFCFFFFFFFFFFFFFCFCFCFFFFFFFBFBFB474747
AEAEAEBFBFBF6D6D6D1111112F2F2F787878CFCFCFFEFEFEFFFFFFFBFBFB
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4E4E4E9E9E9E373737
CBCBCBFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFFFFFFFF
FEFEFEF9F9F9ABABAB6262621111113030308B8B8BD0D0D0FDFDFDFEFEFE
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFF6F6F6FEFEFEFFFFFFF9F9F9
C0C0C06D6D6D656565BDBDBDFFFFFFFBFBFBFCFCFCFFFFFFFEFEFEF9F9F9
FFFFFFD8D8D8FFFFFFFCFDFDF9FFFFFBFFFFFFFFFBFFFBF3FFF8E679695A
3F565CEAFFFFFFFFE7CEC7AB7F80805C64774E5E7FF5FAFFFFF8E2B49E87
0A1322E1F8FFF1FFFFF2FBFFF7F8FCFFFEFBFFFEF8FFFFF8FDFDF9FAFEFB
FBFFFFFBFFFFFCFFFFFEFFFFFFFEFDFFFDF8FFFDEFA4978C363135F2EFFE
CFCADC605C6AFEF8FFFEFEFEFBFFFFF9FFFF212222030100060000040000
030404080E0E171818757575A3A3A3FBFBFBFFFFFFFFFFFFFFFFFFC5C5C5
767676FDFDFDFBFBFB9A9A9A242424E7E7E71F1F1FDDDDDDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFF5F5F5BBBBBB161616D5D5D5BDBDBD3E3E3EFFFFFF
F4F4F4FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFFFFFF
FEFDFFFFFEFFFFFFFFFCFCFCFCFCFCFEFEFEFEFFFDF8FAF7FEFFFDFEFFFD
F8FAF7FEFFFDF7F9F69EA09D3739361B1D1ADEDEDCFFFFFDFDFDFBFDFDFB
FFFFFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFDFFFFFDFFFFFB
FEFFFAFFFFF8FFFFFAFFFFFFF7FDFFFBFEFFFFFEFBFFFDEDFFF6DCECDECF
061123EAF9FFFCFFFFFEF9F9FFFEFDFFFFFFFEFFFFFAFEFFFCFFFFFCFFFF
FEFFFFFDFEFFFEFDFFFFFFFFFFFEFFFCFAF9FCFCFAFFFFFDFFFFFFFAFAFA
FFFFFDFFFFFDFCFCFCFFFEFFFCFBFEFFFEFFFFFFFDFEFEFCF4F4F20E0E0E
F5F4F7FFFEFFFCFCFCFFFFFFC4C4C4737373232323252525797979D6D6D6
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE9E9E9121212F3F3F3AAAAAA
D4D4D4FFFFFFF9F9F9FFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFBFBFBFCFCFC
FFFFFFFCFCFCFEFDFFFFFEFFF8F8F8C1C1C16B6B692020202524276D6C6F
C0C0C0F5F5F3FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFDFFFCFCFCFFFFFF
FCFCFCFFFFFFFFFFFFC2C2C2787878676767B1B1B1F3F3F3FFFFFFFDFDFD
FBFBFBFFFFFFFFFFFFFDFEFEFBFFFFF7FDFBFFFEFDFFFBF5FFF9EBE7DAD1
00050B617979D2D4BC49442C565757D6DEF000011C707384CFBCA92B1A06
000510DAECFFF4FFFFF6FCFFFEFFFFFFFFFBFFFEFAFEFDF8FFFFFBFAFCF9
FBFFFFFBFFFFFAFEFFFCFDFDFFFEFFFFF9F6D1C7BD70675E4B494CD3D3DD
2C2836ECE5F2FFFCFFFDFDFDFBFFFF69716F0608050402010900000D0503
4A4B4BC9CFCDFCFFFFF8FAF7FFFFFFFFFFFFFCFAFBFEFCFDA6A4A5969696
FFFFFFF7F8F8FEFFFDFEFFFD8E8E8E242424424041B8B6B7FFFFFFFEFEFE
FDFDFDFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFE
FFFFFFFEFEFEFFFFFFFFFFFFFBFBFBACACAC171717BABABA1A1A1AFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFDFDFDFFFFFF
FFFEFFFBFAFDFFFFFFFDFDFDFFFFFFFFFFFFFAFCF9FDFFFCFDFFFCFBFDFA
FEFFFDFBFDFAFEFFFDFEFFFDFBFDFACFD1CECACAC8FDFDFBFFFFFDFCFCFA
FFFFFDFDFDFBFFFFFDFEFEFCFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFDFFFFFDFFFFFDFFFFFFFDFEFFFCFDFFFFFFFBFFFEF6FFF8EDFFFEF6
1E2125CCD0D7FDFEFFFDFDFDFFFFFFFEFFFFFDFDFDFCFDFDFEFFFFFEFFFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFDFCFFFFFFFF
FFFFFBFDFDF9FCFBFEFFFEFFF9F8FEFFFEFFFFFFFBFFFFFAA0A19B4E4E4C
FDFEFFFEFFFFFEFFFFFFFFFDFFFFFDFFFEFDFDFBFCCDCBCC737275232225
1F202278797BD0D1D3F7F8FAFFFFFFFEFEFEFFFDFCFFFDFCFFFEFDFEFCFB
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFBFBFB
FFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFDFDFD9494945A5A5AFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFFFBFBFFFEFEFFF7F5F6FFFEFDFCFEF9FEFFFDCFCED3818085
30322F151712595957B3B1B0F6F4F5FFFEFFFFFEFFFAF9FEFFFEFFFFFFFF
FEFEFEFBFBFBFEFEFEFFFFFFFFFFFFFFFFFF4848488080806565656B6B6B
EFEFEFFFFFFFFAFAFAFFFFFFFEFFFFFBFCFCFEFEFEFFFEFBFBF3EEFFFEFB
DDE2E5505858030400302F28D2D2D2FCFFFFDBDFE85D5D630800008F8A84
7D8084CAD1D9FBFFFFFEFFFFFFFEFFFDFDFBFFFEFDFEFEFCFDFDFBFFFFFF
FDFEFEFEFFFFFCFDFDFFFFFFFFFFFFB8B6B58C8885FFFCF9ECECEC000004
B2B1B6FFFDFFFBF9FCFFFFFFCBCCCC090A0A0000000707074F4A4ADDDBDA
FEFEFEFCFFFFFBFFFBFCFFFBFFFFFDFFFEFFFFFCFF7A7378BBB6B8FFFEFF
FEFFFFFBFFFFFBFFFAF6FDF5FDFEFE7A797C1B16188B8688FFFEFDFDFBFA
FFFEFFFFFEFFFFFFFFFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFF7F6F9FFFEFFF9F9F9FFFFFFA4A4A4111111090909FAFAFA
FFFFFFFEFEFEFEFEFEFFFFFFFBFBFBFFFFFFFFFFFFF9F9F9FFFFFFFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFCFCF8FFFFFBFFFFFBFBFAF6
83827D8B8B87FFFFFDFEFFFFFEFFFFFCFDFDFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFF9F9F9
FFFFFAFFFFFAFBFAFDF5F4FA787681D8D7DCFCFCF8FFFFF6595A54A1A19F
FBFBFFFEFEFFF8F9F9FFFFFBFDFBFAFFFEFDFFFEFFF9F7F8FFFEFFFFFEFF
C5C6C8797A7C1D1E20262729707070CDCDCDFAF8F7FFFEFDFFFEFBFFFEFD
FFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFEFEFE
FAFAFAFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF393939B2B2B2FFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFCFFFFFAFAFFFFFCFFFFFCFAFFFFF8F5FAF3FEFFFFFEFEFF
FEFFFFE0E1E193958F48474208020050494C949399F0F0F6FBFAFDFDFDFD
FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9272727D6D6D67D7D7D626262
929292636363909090E3E3E3FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF5F5F5
FFFFFFFFFFFFFDFDFDFCFCFCCDCDCD909090FEFEFEFFFFFFF7F7F7DFDFDF
F6F6F6FBFBFBFFFFFFE4E4E4030303000000131313BBBBBBFFFFFFFFFFFF
FFFFFFF8FAF7FCFFFBFCFFFBFBFBF9F5F3F4625D5FE3DEE0FFFEFFFCFBFE
FEFFFFFCFFFFFAFFF9FCFFF8FEFFFDFAFAFA3B3638201B1DF7F5F6FFFDFC
FFFEFFFFFEFFFAFAFAFEFEFEFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFAF9FCFFFFFFF9F9F9FFFFFF7B7B7B000000BEBEBE
FFFFFFFFFFFFFFFFFFF8F8F8FFFFFFF7F7F7FFFFFFFFFFFFF2F2F2FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFAFAF8FDFDF9FFFFFBFCFBF7FFFFFB
DBDAD623231FF8F8F6FEFFFFFEFFFFFAFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FCFDF7FFFFFBFFFEFFFFFEFF3C3A45151419FFFFFBEDEEE411120CEBEBE9
FCFBFFF7F6FCFFFFFFFDFDFBFFFEFDFFFAFAFDFBFCFFFDFEFFFEFFFFFEFF
FEFFFFFEFFFFFEFFFFCFD0D27D7E7E2526261F1F1D6B6B69BFBDBCFEFCFB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFF7F7F7FAFAFAFFFFFFFDFDFDFCFCFC
FFFFFFFFFFFFFDFDFDFEFEFEFFFFFFDBDBDB131313FDFDFDFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFBFFFFF7F7FDFFFBFFFFFBFDFBFBEEFCFFF4F9FDFEF5F7FF
7C7A8D494855F3F9EDFDFFEFFAF1EAAA9FA15F5F67070B143E3F43898989
DDDDDDF9F9F9FFFFFFFFFFFFF7F7F7FFFFFF434343B7B7B7252525C2C2C2
FFFFFFFFFFFFDFDFDFA1A1A16A6A6A808080D5D5D5FFFFFFF9F9F9FFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FBFBFBFFFFFFFAFAFAFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFF8F8F8FFFFFF
FEFEFEFFFFFFFFFFFFE3E3E36E6E6EFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
E1E1E1FFFFFFF8F8F80E0E0E0505055A5A5AF3F3F3FFFFFFF8F8F8FAFAFA
FFFFFFFDFDFDFBF9F8FFFDFCDEDEDC626461EDEFECFBFFFEF4F5F7FEFFFF
FFFEFFFBF9FAFFFFFAFCFBF4FFFFFBDCDCDA0E0F0F202121444444FBF9FA
FFFDFEFFFEFFFFFFFFFFFFFFF6F6F6FFFFFFF9F9F9FFFFFFFAFAFAFFFFFF
FEFEFEF8F8F8FFFFFFFFFFFFFFFFFFFFFFFF979797151515232323171717
E4E4E4FFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF8F8F6FFFFFBFFFFFBFCFBF7FFFFFB
CCCBC7080804E5E5E5FBFCFCFEFFFFFBFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFAFFFFFBFAF9FCFFFEFF97959E0403089E9E9AADAEA6393A34FFFFFD
FFFEFFB7B6BCD3D3D3FFFFFDFAF5F5FFFDFDFFFEFFFFFEFFF4F3F6FFFEFF
FEFFFFFBFCFEFBFCFEFEFFFFFEFFFFFCFDFDD8D8D8888886323230141412
6C6C6CBBBBBBFCFCFCFFFFFFF9F9F9FFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
FAFAFAFEFEFEE8E8E86A6A6AFFFFFF858585616161FFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFCFEFFFEFFFFFCFFFFFDFDFDFFF2FEFFF6FCFFFFF8F7FF
F2EDFF656370F9FFFAFBFFF4FFFCF9FFFBFFF8F8FEF5F8FFB4B5B7676767
1919192A2A2A737373C8C8C8FFFFFFF9F9F9616161818181242424FFFFFF
FAFAFAFFFFFFFBFBFBFCFCFCFFFFFFE2E2E2ABABAB696969808080D7D7D7
FAFAFAFFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFBFBFBFFFFFFFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
FFFFFFFAFAFAFEFEFEAEAEAEC8C8C8FDFDFDFFFFFFFFFFFFDDDDDD131313
0F0F0F1919191616160303039B9B9BFCFCFCFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFB9B7B87F7F7DFDFFFAF8FCF9FCFFFDFEFFFFFEFDFF
FDFAFFFFFEFFFEFDF8FDFCF5BDBCB520201C7374743B3C3E585858504E4F
FBF9FAFFFEFFFDFDFDFFFFFFFFFFFFF9F9F9FFFFFFFEFEFEFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFC7A7A7A262626DDDDDD5A5A5A5C5C5C
232323E5E5E5FEFEFEFEFEFEFAFAFAFFFFFFFBFBFBFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFCFFFFFDFEFEFCFDFDFBFFFFFBFFFEFA
CAC9C5979793E5E5E5FBFCFCFEFFFFFBFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFF8F8F6
FEFEFAFBFBF7FFFEFFFFFEFFC0BEC700000404040063645C90918B9F9F9D
18171C000004F0EFF2FFFFFFFFFDFDFEF9F9FFFDFCFFFEFDFFFFFFF9F9F9
FEFFFFFEFFFFFEFFFFF8F9FBF6F7F9FEFFFFFEFFFFFEFFFFFAFBFBE0E0E0
8282823737371818185E5E5EC1C1C1F3F3F3FCFCFCFCFCFCF9F9F9FCFCFC
FFFFFFF9F9F9FAFAFA050505FBFBFB323232CACACAFAFAFAFFFFFFFBFBFB
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFFFFFDFDFFF9F9FAFAF8FCFFFDF8F9F9FCFDFFFEFEFFFFFCFF
FFF4FA665F62D6E2E0F1FFFFFEFEFFFFFCFFFFFEFFFEFEFCFEFEFEFEFEFE
FFFFFFD0D0D07676762323231A1A1A6666666868682F2F2F7D7D7DFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFF9F9F9F1F1F1ADADAD
6B6B6B6F6F6FC5C5C5FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFF9F9F9FFFFFF
FEFEFEFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFDFDFDFEFEFECDCDCDA8A8A8FFFFFFFCFCFCFAFAFA4C4C4C070707
000000000000000000A3A3A3FCFCFCFFFFFFFFFFFFFFFFFFFCFCFCFAFAFA
F9F9F9FFFEFF8B8C909F9EA3F7F7F5FFFFFAFFFFFBFAF8F7FFFDFFFEFBFF
FFFEFFFEFFFFF8FAF4ACAFA417180EAFB0A8EAE8E9110E14F8F7FA3D3D3D
656565FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFBFBFBFCFCFCF6F6F6575757363636ECECECFFFFFF8484847D7D7D
8C8C8C252525E9E9E9FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFEFEFCF7F7F5FFFFFBFFFFFB
FEFDF9FFFFFDF8F8F8FEFFFFFEFFFFFAFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFCFCFCFFFFFD
FFFFFBFFFFFDFAF9FCFFFEFFDEDDE30F0E130909050102000C0C080A0A08
070609AFAEB3FEFDFFFEFCFDFFFDFDFFFAFA8E8C8B090706353535AEAEAE
F8F9FBFEFFFFFDFEFFFEFFFFFEFFFFFEFFFFFEFFFFFBFCFCFEFFFFFBFCFC
FFFFFFFEFEFEDFDFDF9191913434341717175D5D5DB8B8B8FFFFFFFFFFFF
FFFFFFFBFBFBFFFFFF191919BEBEBE1C1C1CF8F8F8FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFBFFF6F0FFFEF6F0F8F8F7FFFFFFFEFFFAF6FFF6F6FFFAF7FD
FFFBF6AEA5A0A5ADB8F2FFFFF2F7FFFBFBFFFFFEFBFFFFF8FFFEFDFFFFFF
F9F9F9FDFDFDFFFFFFFFFFFFDCDCDC8C8C8C383838050505E0E0E0FDFDFD
FFFFFFFCFCFCFBFBFBFFFFFFFFFFFFFEFEFEF8F8F8FFFFFFFFFFFFFDFDFD
FFFFFFFCFCFCBEBEBE7171715F5F5FC1C1C1FBFBFBF8F8F8FFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFEFEFEFEFEFEFFFFFFFEFEFEFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFEFEFEFFFFFF606060F5F5F5FFFFFFD6D6D6080808000000
0000000606060101014A4A4AFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFF6A6B6DCACDD4FCFFFFFDFDFBFFFCF5FFFDFAFFFDFBFCF5FCFFFCFF
FFFEFFF5F9F87E857E151C12DBDFD0FFFFF6FFFCFF0B050CFCFAFDFDFDFD
3C3C3C626262F9F9F9FFFFFFFCFCFCFFFFFFFFFFFFF7F7F7FBFBFBFFFFFF
FDFDFDFFFFFFF3F3F33B3B3B595959FBFBFBFBFBFBFFFFFF959595626262
FBFBFB8585852F2F2FF0F0F0FDFDFDF4F4F4FFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFBFBFBFFFFFDFFFFFDFDFBFAFFFEFD
FFFEFDF6F6F4FFFFFFFEFFFFFEFFFFFCFDFDFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFD
F8F8F6FFFFFDFDFCFFF9F8FDDCDBE00706090000000202000B0A06010000
A6A4A7FFFEFFFFFDFFFFFEFFFFFDFDFFFDFDFDFBFAA3A1A0D8D8D8E5E5E5
FFFFFFFCFCFCF9FAFCFEFFFFFCFDFFF6F7F9FCFFFFFCFFFFFAFEFFFEFFFF
FEFEFEFFFFFFFEFEFEFFFFFFFFFFFFE6E6E69090903A3A3A0606065F5F5F
A9A9A9FEFEFEFBFBFB3939395C5C5C757575FDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF8FFFAE8E0D8CB00030E2A394CBEB6C3070004AFB2B9FCFFFF
FFFDECF1E6E06B6D84ECF6FFF5FFFFF9FFFFFFFCF5FFFCF4FFFEFAFFFFFF
FFFFFFF9F9F9FEFEFEFFFFFFF9F9F9FFFFFF8B8B8B101010FAFAFAFFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFBFBFB
FEFEFEFFFFFFF7F7F7FFFFFFFFFFFFC1C1C17171716B6B6BB0B0B0F5F5F5
FFFFFFFCFCFCFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7
FFFFFFFFFFFFFBFBFBFAFAFAF0F0F0707070FFFFFFECECEC040404000000
050505000000020202686868FFFFFFFAFAFAFFFFFFF5F5F5FFFFFFF1F1F1
555555E4E5E9F3F7FFFBFFFFFCFCF8FFFEF6FFFBF6FFFCFBFFFBFFFFFCFF
FCFDFF494F4D353F3AEBF4ECF4FBEBFDFDF1FFFCFF271D26D2D0D3FEFFFF
F8F9F9BCBDBDDCDCDCFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFF8F8F8
FFFFFFD7D7D7262626727272FCFCFCFFFFFFFEFEFEFFFFFFBFBFBF3F3F3F
FFFFFFFEFEFE7777772E2E2EF5F5F5FEFEFEFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFBFFFFFDFFFEFDFFFEFD
FDFBFAFFFFFDFEFEFEFCFDFDFEFFFFFEFFFFFDFDFDFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFBFBF9FFFFFD
FEFEFCF7F7F7FCFBFEFFFEFFDAD9DE100F12010100010100070602514F4E
FFFEFFFDFBFEFFFEFFFFFDFFFFFEFFFFFEFDFFFEFDFDFBFA919191E0E0E0
F9F9F9FFFFFFFEFFFFF5F6F8FEFFFFFEFFFFFBFFFFFCFFFFF9FDFEFCFFFF
FEFEFEFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFEBEBEB979797
4343430D0D0D5151513A3A3A141414D1D1D1FFFFFFFDFDFDFEFEFEFEFEFE
FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF6FFFAE29F9989485468EFF8FF2616201A0A0BACB3BBF0FBFD
FFFFF1BBB2AB0B091FECEFFFF7FFFFF8FFFFFCFBF4FFFFF6FFFFFBFEFEFE
FEFEFEFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF4D4D4D0E0E0EFFFFFFFCFCFC
FEFEFEFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFBFBFBFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFDFDFDCECECE7E7E7E
6464649F9F9FECECECFFFFFFFDFDFDFDFDFDFCFCFCFFFFFFFFFFFFFFFFFF
FAFAFAFDFDFDFFFFFFFFFFFFFCFCFCC1C1C18D8D8D9999991F1F1F060606
010101010101000000E9E9E9FFFFFFFFFFFFFFFFFFFFFFFFD5D5D5656565
F7F7F7FDFEFFFCFEFFF8FBFFFFFFFBFFFDF4FFFEF6FFF7F4FFFCFFE9E3EB
3132325A5E5DF2F8F8F8FEFAFEFFF3FFFFF3FFFBFE463E47BBBABDF9FAFA
FEFFFFFCFDFDFDFDFDFCFCFCFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFF
C4C4C41414149D9D9DFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCE5E5E5414141
FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFD
FCFCFCFEFDFFFFFEFFFAF9FEE0DFE20A0A0A0503040402013F3E3AFDFCF8
FFFEFDF3F1F2F4EFF3FEFCFFFFFEFFFFFFFFFEFEFEFFFFFFFDFDFD6A6A6A
F4F4F4FFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFE4E4E4A3A3A31B1B1B0101014B4B4B9C9C9CEAEAEAFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFF
FDFDFDFFFFF8FFFFE9C9C6BB090F27F8F8FFF6DFD9120000D0DCE8F0FFFF
FCFFFFFFFEFBFFFBFFFFFAFFFEFDFFFCFEFFFCFFFBFCFFF8FEFFFDFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFBFBFBF6F6F60C0C0C050505F7F7F7F9F9F9
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F9F9DDDDDD8D8D8D5E5E5E969696E6E6E6FFFFFFFEFEFEFBFBFBFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFEFEFEDFDFDF1A1A1A949494FAFAFA919191
1919194F4F4FE3E3E3FFFFFFFFFFFFFEFEFEFFFFFFB4B4B4828282FFFFFF
F9F9F9FFFEFFFFFBFFFFFCFFFCFAF9FFFFF8FEFFF5FDFEF8D2D1D41F1E23
807E7DFFFEFDFEFBFFFFFEFF8585780A0C00303030AAAAB0FBFFFFFCFFFF
FAFEFFFCFFFFFAFBFDFEFFFFFCFCFCFDFDFDFFFEFFFDFBFCFCFCFAADADAB
121210BABAB8FEFFFDFAFCF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFFFFFBFDFDFB
FFFEFFFFFEFFFFFEFFFDFCFFC0C0C00F0F0F0100000B090AE8E6E5FFFFFB
9998945A5857A09B9F5B585EE5E4E7FDFCFFF9F8FBDFDFDFFDFDFD7D7D7D
B6B6B6FFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FEFEFEFFFFFFFEFEFE3C3C3C343434A9A9A95757570C0C0C3D3D3D909090
E7E7E7FAFAFAFFFFFFFBFBFBFEFEFEFDFDFDFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFFEFFF9FFFFF1F0F1E9101026E2DAEDFFF7E77B6A58838F9DEEFFFF
F9FFFFFFFFFFFFFDFAFFFCFCFFFAFFFFFCFFFBFFFFF9FFFAFEFFFDFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFDFDFDFBFBFBFBFBFB292929DCDCDCFFFFFF
FBFBFBFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFBFBFBFFFFFFE5E5E59393936A6A6A828282E3E3E3FAFAFA
FAFAFAFFFFFFFFFFFFFBFBFBECECEC191919909090797979E4E4E4FFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFFFFFFF9F9F9919191A7A7A7FDFDFDFFFFFF
FFFFFFFFFDFFFFFBFFFFFCFFFFFEFDFCFDF5FBFEF5B7B9B3161717A5A5A5
FFFFF8FFFEFBFFFBFFFEF8FFFFFFF4A1A395DCDEDBE8EBEFFBFFFFFAFFFF
F7FBFCFCFFFFFEFFFFF9FAFCFFFFFFFFFFFFFFFEFFFFFEFF898987191917
D1D1CFFFFFFDF7F9F6FEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFCFCF8FCFCFA
FFFEFFFBFAFFFFFEFFFFFEFFA9A7A60604030604077B797CFFFBFBFFFEFB
8B87848B8686FFFDFFDEDBE2090A0EFBFCFFFAFBFFBFC0C22F3032161719
EAEAEAFDFDFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFF0E0E0E383838FBFBFBFFFFFFF9F9F9B4B4B4676767
0808082F2F2F878787DCDCDCFFFFFFFDFDFDFAFAFAFCFCFCFFFFFFFCFCFC
FAFAFAFFFFFDF5F7F2FFFFFDB7B3BD332A2DFFFDE8978E7D363E50E9F7FF
FBFEFFFFFEFFFDFFF2FFFFF4FFF9FFFFF9FFFBFFFFF8FFFBFCFFFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3E3E3EB2B2B2FFFFFF
FDFDFDFBFBFBFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFEFEFEFBFBFBFFFFFFFFFFFFF7F7F7EEEEEEA5A5A5656565
7E7E7ED9D9D9FBFBFBFFFFFF949494ACACACF9F9F9FFFFFF585858EEEEEE
FDFDFDFBFBFBFFFFFFFFFFFFF4F4F46E6E6ECECECEFFFFFFFEFEFEFFFFFF
FCFCFCFEFDFFFFFCFFF8F5FCFDFBFAFFFFF898979014130ECECCCBFFFEFA
FFFFF4F7F6F1FFFBFFFEF9FFFFFEF7FBFBEE8F8F8DD9DADCFBFFFFF7FFFF
FBFFFFFCFFFFFAFBFDFEFFFFFFFFFFF8F8F8F5F3F4666465343231EBE9E8
FFFFFDFFFFFDFBFDFAFCFEFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFEFEFAFFFFFB
FFFEFFFCFBFFFFFEFFFEFEFE949291020000110F12FFFEFFFBF6F8FFFBF8
DDD9D5120E0BF3EDF4FFFDFF79797F898C91FCFFFFFBFCFFF3F4F8F2F3F5
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFEFEFEADADAD343434272727FFFFFFFCFCFCFFFFFFFAFAFAF6F6F6
FFFFFFC1C1C16A6A6A1919192A2A2A7C7C7CD0D0D0FAFAFAFFFFFFFFFFFF
FEFEFEFFFFFFFEFFFFFEFEFEFDF8FABCB4B166604E61615400000BE7EDFF
FFFCFFFFFEFFFBFFF3FCFFF3FFFBFFFFFAFFFCFFFFF9FFFFFEFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFDFDFD
EDEDEDA8A8A8717171707070B1B1B1FCFCFCFFFFFFF7F7F7FFFFFF494949
E7E7E7FFFFFFF8F8F8D5D5D5575757E8E8E8FDFDFDFFFFFFFFFFFFFDFDFD
FCFCFCFDFCFFFEFEFFFEFFFFFFFEFD6864602D2724E6E0DDFDF9F6F8F7F0
FFFFEFFFFFF8FDFBFFFBF9FFFDFDFBFFFFF4FFFBF86E6C6FEDF3F3F9FFFF
FBFFFFEFF5F5FEFFFFFEFFFFFCFCFCF3F3F3484647535152EBE9E8FEFCFB
FFFFFDFFFFFDFDFFFCFEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFFFFFAFEFFFB
FCFBFFFFFDFFFDFCFFF8F8F854534F0100009C9A9DF8F5FBFFFDFFFFFEFB
FFFDF71F1917E2DBE2FFFCFFA6A9B0454950F9FDFFFCFFFFF9FCFFFEFFFF
FEFEFEFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFEFEFE
FAFAFAFCFCFC6363638F8F8F000000FDFDFDFFFFFFFFFFFFFFFFFFFDFDFD
F3F3F3FFFFFFF8F8F8FEFEFECACACA7373732B2B2B262626616161C5C5C5
FFFFFFFBFBFBFEFCFDF9F7F8FFFDFFFFFDFCF5FAF3FAFFF9555754AEACAF
FFFAFFFFFCFFF8FFFDF8FFF8FFFFF8FFFDFBFFFEFFFEFFFFFEFDFFFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFCFCFCF6F6F6FFFFFFFFFFFF
FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFC1C1C1F8F8F8FDFDFDABABAB7C7C7C6F6F6FBCBCBCF0F0F0FEFEFE
6B6B6B7575755F5F5F333333FCFCFCFFFFFFFBFBFBD8D8D8525252F8F8F8
FFFFFFFEFFFFF6FBFEEBEFF04343434F4949FFF5F4FFFAF9928984030100
7C8067A5ADA0000019DEDFFDFEFFFFD8D5CCFFFCFA857E81B2B6B7F9FFFF
F4FAFAFBFFFFFEFFFFFEFFFFE0E0E0312F306C6A6BFAF8F9FFFEFDFFFEFD
F9F9F7F8F8F6FEFFFBF9FBF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFEFFF9FAFCF7
FDFCFFFFFDFFF7F6FBFFFFFF0F0E0A040300FCF9FFFFFDFFFFFBFDFFFEFB
F9F4EE746E6B1F181FF4F0FA878993515860FBFFFFFBFFFFFBFEFFF6FAFB
FFFEFFFAFAFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF9F9F90E0E0EEAEAEA151515E6E6E6FFFFFFF6F6F6FFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF2F2F2D4D4D48F8F8F292929
181818616161B3B1B2FFFDFFFEF9F9FBFBFBF9FFFFF9FFFD64635C544E4B
FFFBFEFFFDFFF8FFFFF8FFFDFFFFF6FFFEF8FFFDFFFFFDFFFEFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFF4F4F4
F8F8F8FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF6F6F6
777777878787FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFC5C5C58C8C8C707070
7474746A6A6A808080FDFDFDFFFFFFF8F8F8FEFEFEECECEC101010FFFFFF
FFFFFFF8F9F9E2E6E5222625716F70FCF5F8FFF6F8FFFCFA575048C0BEAD
DDE1C4000300555674C5C5E9F7F7FDC5C4BD342C2A0E070AEBEFF0F0F9FB
F9FFFFFBFFFFF7FBFCD0D1D31A18198E8C8DFFFEFFFBF9FAFFFEFDFFFEFD
FFFFFDFFFFFDFEFFFBFEFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFAFEFFFB
FFFEFFFFFDFFFFFEFFFBFBFB0100006F6E6AFFFCFFFDF7FFFFFCFEFFFEFB
FFFBF3D1CBC8040004605C6600020BBFC7CFF0F7FFF9FDFFFCFFFFFCFFFF
FFFEFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8
F9F9F9AAAAAA434343F8F8F8FFFFFFFAFAFAFBFBFBFFFFFFFBFBFBFCFCFC
FFFFFFFAFAFAFFFFFFF7F7F7FDFDFDFBFBFBFFFFFFFFFFFFF9F9F9FFFFFF
DFDFDF9292923F3C420B090C5F5D5CA7A9A4EBF1EFEDF3F1B3B1B0A39F9C
FFFEF7FFFFF8FCFFFFFCFFFFFFFFFAFFFEF9FFFDFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFCFCFCFFFFFF
FCFCFCFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEF5F5F5FCFCFC5B5B5B
414141EDEDEDFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFCFCFCF9F9F9
FFFFFFFFFFFFFCFCFCFFFFFFF9F9F9FFFFFFFDFDFDFFFFFF0E0E0EF2F2F2
FCFCFCC7C7C7151513929290FFFEFFFFFEFFFAF5F7FFFEFB6464588F907C
FFFFE49A9A8D0B0527FEF7FFFBF7FFFFFFFAFFFEFBFAFAF8FBFFFFF8FFFF
F4FCFEF6FBFEB7BBBC141517ADABACFFFEFFFEFCFDFFFEFFFFFEFDFFFEFD
FFFFFBF6F6F2FDFFFAFDFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFEFFFBFCFEFB
FFFEFFFCFAFFFFFEFFBFBFBF010000F8F7F3FFFCFFFFFCFFFFFDFFFFFEFB
FFFCF6F3EDEA231C21F2EEF8FCFEFFF5FCFFFBFFFFFBFFFFFCFFFFFEFFFF
FFFFFFFDFDFDFFFEFDFFFEFDFFFEFDFFFEFDFFFFFDFFFFFDFFFFFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFA4A4A4CECECEFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFEFEFE
FFFFFFFFFFFFFAFAFAFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF
FBFBFBFFFEFFFFFEFFE5E4E797979550524D0206034B4F4EA2A0A1EEECEB
FFFFF5FFFFF6FFFFFDFFFFFFFFFFFBFFFEFAFFFEFDFFFEFFFFFFFFFEFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFEFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFB2B2B2505050
F4F4F4FFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFEFEFEFFFFFFFDFDFDFFFFFF
FEFEFEFEFEFEFEFEFEFCFCFCFFFFFFFFFFFF797979989898212121D3D3D3
A6A6A6131313B8B6B5FFFEFDFEFCFDFEFEFEFFFFFFFCFCF8BDBEB43D3E2C
FFFFE5FDFAEF130A27DDD5F8FFFCFFFDFDFBFDFDFBFEFFFFFAFFFFF4FCFC
FBFFFF9A9DA1101113C8C8C8FFFEFDFFFEFDFFFEFFFAF9FCFFFEFFFEFCFB
F4F4F2FFFFFDFEFFFFFDFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFEFDFFFEFDFFFDFFFFFDFFFFFDFFFFFCFC
FFFDFDF0EAEA20191CC0BAC1FCFAFFFDFDFFFEFEFFFBFBFFFDFEFFFFFEFF
FEFEFEFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFEFDFFFFFFFFFFFFFDEAEBEBABABAB525051100E0D
41403C94938FE5E3E2FFFEFDFFFEFDFFFDFCFFFEFDFFFFFFF9FDFEFCFFFF
FFFEFFFBFAFDFCFFFFFCFFFFF9F9F7FFFEFDFFFCFCFFFEFDFEFFFDFDFFFC
FEFCFDFFFEFFFEFFFFFEFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFDFDFDFEFEFE
FCFCFCFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFCFCFCFFFFFFDADADAFFFFFF
F9F9F9FFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBF6F6F63E3E3E1C1C1C979797
1E1E1ED3D3D3FEFFFFFEFFFDFAFBFBFEFEFCFFFFFDFBFAF6FEFDF6605D54
959287FFFDF9524E589B97A5FEFDFFFEFFFFFEFFFFF8FBFFF8FCFBFCFFFF
71727626272BDFDFDDFDFCF7FFFEF8FEFAF6FFFEFFFAFBFFFDFBFEFFFEFF
AEAEACB3B4B4FCFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFF8F3F5FFFDFFFAF5F7
FFFBFEDDD6D9A69FA2C4BFC3FFFCFFFDFBFFFBF9FFFFFEFFF9F8FDFEFEFE
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFEFEFEFEFEFEFFFFFFFFFFFFFEFCFBFBF9F8
B2B0AF5C5A591917162E2C2B858382DFDDDCFFFEFDFEFEFEF9FDFEFCFFFF
FFFDFFFFFEFFFCFFFFF3F9F7FFFFFDFFFBFBFFFDFDFFFFFDFCFFFDFCFFFD
FFFDFFFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFE5E5E5FAFAFAFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFFEFEFEFFFFFFF5F5F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEE3E3E30F0F0F4C4C4C
EDEDEDFDFEFEF8F9F9F6FAF9FEFFFDFEFFFDFBFAF6FEFDF9FFFEFAFFFEFA
8F8B88726E6B171516525154FBFAFFFCFCFFFBFEFFFCFFFFF3F7F6525451
3F3E43ECEAEDFFFFFBF8F5EEFFFEF4FFFEF7FBFEFFFCFEFFE8E6E9A09B9B
8985822D2D2DD6DAE5F4FAFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFBF9FAFFFDFFFFFDFF
989194D9D2D5FFFBFEFFFCFFCDC9D392909BFFFDFFFEFDFFFEFDFFFDFDFD
FFFFFFFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFDFC
FDFBFAFFFEFDF7F5F4C8C6C56969691515152828287B7B7BC9CDCCFEFFFF
FBF9FAFFFEFFF3F7F6FBFFFFFCFCFCFBF9FAFFFEFFFDFDFDFAFEFDFAFEFD
FFFCFEFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFD
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFCFCFCFBFBFBF9F9F9
FBFBFBFFFFFFFBFBFBFFFFFFCECECE747474FFFFFFFEFEFEFFFFFFFDFDFD
FCFCFCFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFEFEFE6D6D6D0A0A0A
C7C7C7FEFFFFFEFFFFFCFFFFFEFFFDFCFEFBFFFFFBFDFCF8FFFEFBFFFCF9
FFFDFAFCF8F5F9F7F8010003E9E8EDFEFEFFFCFFFFE6E9EE363C3C5A5E5D
F4F2F5FBF6F8FFFEFBFFFFF6FFFCEEFFFFF8F4FAFFF8FBFFFFFDFF4F4840
DBD4CC666463D7DDE9F8FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFAF8F9FFFEFFFAF5F7FDF8FA
F2EBEE3B3437FFF8FBFDF8FC2B2731E7E5EEFFFEFFFFFEFFF6F5FAFFFEFF
FDFDFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFCFCFCFFFFFFFFFFFFFFFEFDFFFDFC
FFFEFDFFFEFDFEFCFBFCFCFCFFFFFFFFFFFFC9C9C97475752324241F1F1F
726D6FC2BDBFF9FDFCFBFFFFFFFFFFFFFEFFF9F7FAFEFEFEFBFFFFFCFFFF
FFFDFFFFFCFFFFFFFFFDFEFEFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFEFEFEFEFEFEFFFFFF
FDFDFDFFFFFFFBFBFBBBBBBB151515CDCDCDFFFFFFFCFCFCFAFAFAFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFA9A9A93C3C3C
1F1F1FE8E9E9F8F9F9F5F9F8FEFFFDF2F4F1FFFFFBFFFFFBFDF9F6FFFEFB
FFFEFBFFFDFDF3F1F2202020B6B5BAF6F7FBE0E3E81E2126767C7CF6FAF9
FFFEFFFFFDFFFFFBF8FEF9F1FFFFEDFFFEF7F1FEFFF2FCFFFFFDFDFAEBE3
83796D8A8683BDC4D2F7FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFAF8F9FFFDFFFFFDFF
FFFDFFA7A2A49A9597979296ACA9B0FFFDFFFBFAFFF4F3F8FDFCFFFFFEFF
FDFDFDFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
F6F6F6FFFFFFFFFFFFFBFCFEFEFFFFFEFFFFF9FAFCFEFFFFFFFFFDCDCBCA
888282342F31171B1A5E6464B5B6B8F5F4F7FFFEFFFDFEFFF5FBFBFCFFFF
FFFDFFFDF6F9FBF9F8FFFFFDFDFDFDFEFEFEFEFEFEFDFDFDFEFEFEFFFFFF
FFFFFFFBFBFBFDFDFDFFFFFFFFFFFFF7F7F7FEFEFEFFFFFFFCFCFCFBFBFB
FFFFFFFDFDFDE6E6E60F0F0FC8C8C8FFFFFFFFFFFFFBFBFBFFFFFFFBFBFB
FFFFFFFCFCFCFFFFFFF3F3F3858585FDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFC5C5C5303030
7B7B7B363737FCFDFDFCFFFFFCFEFBFEFFFDFDFBFAF8F6F5FFFEFBFFFBF8
FBF6F6FFFBFBE1DFE09D9D9DBCBBC0CACBCF0C0F149DA0A5FBFFFFFCFFFF
F8F7FAFFFEFFFEFEFAFFFEF4FFF6E7A19893000A1DC3DCF0F8EFF0FFF9EF
FFF7EC221C195D6675F2FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFCFDFDF8FAFFFDFF
F7F2F4FFFDFF2D282A444245FEFBFFFFFEFFFFFEFFFFFEFFFFFEFFFEFDFF
FFFFFFFCFCFCFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFCFCFCFFFFFFFFFFFF
FFFFFFFCFCFCFEFFFFFEFFFFFBFCFEFEFFFFFEFFFFFDFDFDFFFEFDFFFEFB
FFFAFBFFFBFBD6DAD98C9292424347111015555459A9AAAEF0F5F8FCFFFF
FFFAFCFFFCFFFFFEFDFBFBF9FFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFF
FFFFFFFEFEFEFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFEFEFEFFFFFF
F6F6F6FFFFFFAAAAAAD7D7D7FFFFFFF9F9F9FEFEFEFFFFFFFEFEFEFFFFFF
FBFBFBFBFBFBFFFFFFB3B3B3464646FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9FFFFFFFEFEFEE6E6E61A1A1A
FEFEFE535353626363FCFFFFF8FAF7FCFCFAFAFAF8FFFEFDFFFEFBFFFCF9
FFFDFDFFFEFDFFFEFFFFFFFFA9A8AB0E0F13B9B9BFFCFFFFFCFFFFFCFFFF
FDFCFFFFFEFFFCFBF7FFFEF6FFFBEDBAB1AC3C51649DB3C8FFFCFDFFF1E6
FFF7EBFFFCF9636C79EDFAFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFEFCFDFCFAFBFFFEFF
FFFEFFFFFEFFE8E3E5E9E7EAFEFBFFFAF9FFFEFDFFFFFEFFFCFBFEF9F8FB
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFBFAFEFCFBFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFBFCFE
F9FAFCFEFFFFFEFFFFF9FAFCFCFDFFFDFEFFFBFCFEFFFFFFFEFAF7FFFDFA
FFFCFBFFFDFDFCFFFFF6FCFCEFF2F6EBEBF197979D4245490D1517424848
ABA6A8EDE6E9FFFCFCFFFEFDFAFAFAFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFBFBFBFFFFFFF8F8F8
FFFFFFF8F8F8F6F6F6FFFFFFFFFFFFFFFFFFFEFEFEFAFAFAFBFBFBFFFFFF
FAFAFAFFFFFFFFFFFF5A5A5A919191FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFFFFFF303030
F3F3F3F4F4F42E2F2F8A8B8BFFFFFFFFFFFFBDBDBBC0C0BEF7F5F4FFFEFD
F7F5F4FFFEFDFFFDFE7F7F7F242326D2D3D5FCFDFFFCFFFFFBFFFFF7FBFA
FCFAFDFFFCFFFFFDFDFCF7F1FFFFF1E9EAE2080D1EEFF1FFFFFDFFFFFDF4
FFFDF2F9F8F4F5FBFFF8FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFFFEFFFFFEFFFFFDFE
FEFCFDF9F7F8FFFDFFFCFAFDFFFEFFFFFEFFFFFEFFFAF9FCFFFEFFFFFEFF
FDFDFDFDFDFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFCFCFCFCFCFCFEFFFFFEFFFF
FEFFFFFCFDFFFCFDFFFEFFFFFEFFFFFEFFFFFDFEFFFEFEFEFFFEFBFFFBF8
B6ACAB0E0808DFE3E2FBFFFFFCFFFFFBFBFFFEFEFFFBFEFFE5EDEFA8AEAE
4B464A140D10454040999796EDEDEDF8F8F8FFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFEFEFEFBFBFBFFFFFFFDFDFDFFFFFFF9F9F9FFFFFFF4F4F4969696
FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFDFDFD101010E8E8E8FCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFFFFFFFF
F9F9F9FFFFFFDBDCDC1A1B1BB9B9B9FCFCFCA2A2A05A5A58FFFEFDFFFEFD
FFFEFDF5F3F2676767353535DFDEE1FFFEFFFEFFFFFDFEFFF9FDFAFCFFFD
FFFEFFFFF9FFFFFCFCFFFEFAFBFCF2FFFFFA27232DCAC6D4FCFAFDFEFDF9
FDFEF8FEFFFDF4F8FFFBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFF
FEFFFFFDFEFFFAFBFDFEFFFFFBFBFBFEFEFEFAFAFAFFFFFFFEFDF9FFFEFB
FFF6F7635D5DF0F4F3FBFFFFFBFEFFFEFEFFFEFEFFFCFFFFF6FEFFF6FCFC
FFFDFFF7F0F3AEA9A95D5B5A131313383838898989DADADAFFFFFFFFFFFF
FBFBFBFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFFEFEFEF4545458E8E8E
FCFCFCFFFFFFF8F8F8FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF8F8F8FFFFFF
FEFEFEFFFFFFC3C3C32E2E2EFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFC2C3C3151515DBDBDBBCBCBC444444FCFAF9FFFEFD
F7F5F64341424C4C4CF8F8F8F1F0F3FFFEFFFEFFFFFEFFFFFFFFFBFFFFFD
FCFFFFFCFFFFFEFFFFFFFFFDFFFDFDFFFDFB94908D767475FFFEFFF8F8FE
FCFFFFFBFFFFFCFFFFFDFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEF9F9F9
F9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFF
FBFCFEFDFEFFFDFEFFFFFFFFFFFFFFFFFEFDFFFEFDFCFAF9FFFFFDFFFEFD
FFFDFD9B9698B7BBBCFBFFFFF9FCFFFEFFFFF9F9FFFCFFFFF9FFFFFBFFFF
FFFDFFFFFCFFFFFEFDFFFFFDF4F4F4BDBDBD6969691212123131317B7B7B
D2D2D2FFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FBFBFB353535686868FFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFAFAFAFFFFFFFBFBFBFFFFFFF8F8F8
FBFBFBFFFFFF717171858585FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9FAFAFDFEFE9B9B9B292929D9D9D9191919FFFEFDE0DEDD
2A2829706E6FFCFCFCFEFEFEFFFEFFFEFDFFF8F9FBFEFEFCFFFFFAFFFFFB
FCFFFFFBFFFFFCFFFFFEFFFFFFFDFFFFFDFDE4D7CE190E08F1F1F9F8FFFF
F5FFFFF6FDFFFFFFFFFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDF7F7F7FFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFFFFFFF7F7F7FCFAF9FFFEFBFFFBF8F5F4F0FCFDFDF8F9F9
FFFAFCDEDCDF6B7171F5FDFDFEFFFFFAF9FCFFFEFFFDFEFFF8FEFEFCFFFF
FFFBFDFDF6F9F9F7F8FCFCFCFFFFFFFBFBFBFCFCFCFFFFFFC6C6C6727272
2020201F1F1F757575CACACAF8F8F8FFFFFFBDBDBD7C7C7CFFFFFFFAFAFA
FFFFFFF6F6F6FBFBFBFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFF181818DADADAFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF646464414141090909DCDCDC1C1C1C
8F8F8FFFFFFFF9F9F9FFFFFFF8F8F8FFFFFFFFFFFFFDFDFBFFFFFAFFFFFB
FEFEFFFEFEFFFFFEFFFEFFFFF5FFFFFCFFFFFFEBE13A1D17DEE0EAE9FCFF
F0FFFFF3FFFFFFFBF8FFFCF9FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFF
FFFFFF000000FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FCFDFFF7F7F7FFFFFFFFFEFDFCF8F5FFFDFA9A949114100DCCD0D1FAFFFF
FFFEFFFCFBFF545A5AF3FBFBFEFFFFFFFDFEFCFAFBFEFEFEFCFFFFFCFFFF
FFFDFFFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFF6F6F6FAFAFAFFFFFF
F9F9F9D1D1D17878782A2A2A1B1B1B6D6D6DA0A0A0FFFFFFFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFF8F8F8FBFBFBFBFBFBFFFFFFFDFDFDFFFFFF8F8F8F
666666D4D4D41C1C1CFDFDFDFEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFAFAFAFBFBFBFFFFFF444444080808585858ADADAD
FEFEFEFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFAFAFAFFFFFDFFFFF8FFFFFB
FEFEFFFEFEFFFFFEFFFEFFFFF4FFFFFCFFFFFFF1E733140F9FA1ABEEFFFF
F0FFFFF4FFFFFCF8F5FFFDF8FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFFFFFF
F8F8F8000000FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFFFFFAF8F7FFFCF9FFFDFAFFFCF7B5ACA5494541B1B6B9F7FFFF
F7FAFFD2D2D8171F21C6CCCCFBFBFBFFFDFDFFFDFDFFFEFDFCFFFDF8FCFB
FDF8FAFFFCFEFEFFFFFAFEFFFCFDFDFBFBFBFFFFFFFEFEFEFBFBFBF8F8F8
FFFFFFFEFEFEFFFFFFCDCDCDDADADA8C8C8C3737370B0B0B616161B1B1B1
EEEEEEFFFFFFFBFBFBFFFFFFFDFDFDFCFCFCFFFFFFFEFEFEF6F6F6B4B4B4
5353538585856F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF1F1F10B0B0B666666FDFDFD
FFFFFFFFFFFFF8F8F8FCFCFCFCFCFCFEFEFEFFFFFDF8F8F4FFFFFAFFFFFB
FEFEFFFCFFFFFEFFFFFEFFFFFCFFFFFFFEFFEBD7CEB7A39EABADB7F1FDFF
F4FFFFF8FFFFFFFFFBFDF7F4FFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFA070707FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFEFDFFFEFBFFFCF9FDF5F0FFFDF6F7ECE4110B08EDF4F8F6FFFF
FBFFFFFBFEFFF7FFFFF4FAF8FEFEFCFFFEFBFFFDFBFFFDFAFCFEFBFEFFFD
FFFDFFFFFEFFFCFFFFFAFEFFFCFDFDFFFFFFF5F5F5FFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDA7A7A7535353FBFBFBFFFFFFFBFBFBE3E3E39E9E9E3E3E3E
0F0F0F5858589F9F9FEAEAEAFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFCBCBCB
2F2F2F2F2F2FC1C1C1F9F9F9FDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9F9F9FCFCFCFEFEFEFEFEFEFCFCFC4F4F4F060606CACACA
FAFAFAFFFFFFFFFFFFFEFEFEFFFFFFFCFCFCFFFFFDFFFFFBFFFFFAFFFFFB
FEFEFFFCFFFFFEFFFFFFFEFFFFFEFFFFFCFFFFFBF6FFFBFAFEFEFFF8FFFF
F2FBFEF9FFFFFCFCFAFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEF8F8F8FFFFFF
FFFFFF000000FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFDFBFAFFFBF8FFFDFAFFFDF6FFFBF3FFFAF22C2623BDC7CCF4FFFF
F4FAFFFBFFFFF2FBFDF9FFFFFFFEFDFFFDFBFFFDFBFFFEFAFEFFFBFEFFFD
FFFBFDFAF8F9FBFFFFFBFFFFFCFDFDFFFFFFFFFFFFEFEFEFFFFFFFFEFEFE
FCFCFC8E8E8E191919EBEBEBFFFFFFF6F6F6FFFFFFFFFFFFFDFDFDFFFFFF
E9E9E9A0A0A05454540404044C4C4C919191E1E1E1FFFFFFFEFEFEF1F1F1
070707111111FBFBFBFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFF0F0F0FFFEFF84838658595B17181A
E8E9E9FDFEFEF6F6F6FFFFFFFFFFFDFFFFFDFBF9F8FCFCF8FFFFFAFFFFFD
FEFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFEFFFFFBFDFFF9FDFCFBFFFBFFFF
F4FAFAF8FEFAFEFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEFFFFFF
FCFCFC050505FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFEFDFFFEFBFEF9F3FFFEF6FFF9F0FFFDF394908C747D82F3FFFF
F9FFFFF9FDFFF9FFFFFBFFFFFFFEFDFFFEFBFFFDFBFFFEFBFEFEFAFDFFFC
FFFEFFFFFEFFFCFFFFF9FDFEFEFFFFF5F5F5FFFFFFFFFFFFFBFBFBFDFDFD
E2E2E2272727E5E5E5FBFBFBFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFF
FFFFFFFCFCFCFFFFFFF3F3F3AAAAAA5E5E5E0D0D0D3C3C3C8D8D8DE4E4E4
0E0E0E515151FEFEFEFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFF7F5F6FFFFFFFFFFFFFAF9FC99989B5C5D5FB3B4B6
717272FCFDFDFFFFFFFFFFFFFDFDFBFFFFFDFFFEFDFFFFFDFFFFFBFEFFFD
FFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFEFFFFFCFFFFFAFFFFFEFFF9FDFE
FCFFFDFCFFFDFAFBFBFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFDFCFFFBF8FFFFF8FFFDF5FFFEF4FFF9EEDDD9D50F0F17F8FAFF
FBFAFFFEFEFFFDFDFFFEFFFFFAFAFAFFFEFDFFFDFCFFFEFDFFFFFDFFFFFD
FFFFFFD2D2D2A7A8AAFEFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFBFBFB
CFCFCFEEEEEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFF1F1F1B9B9B96464643B3B3B
0D0D0D8B8B8BFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFBEBEBE444444FCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFFFF
FEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFDFFFEFBFFFEFAFCF9F0FFFDF2FFFEF4FAF6F2221F26DDDBE8
FFFDFFFFFDFFFDFCFFFFFEFFFFFEFFFEFEFEFFFFFDFFFFFDF7F7F5FCFCFA
FFFFFFECECEC141316F9F8FBFFFFFFFFFFFFFBFBFBF7F7F7FCFCFCFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFBFDFDFDF7F7F7
010101A1A1A1FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFEFEFEFBFBFBD5D5D5FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFDFEFFFEFDFFFEFBFFFEFAFFFCF5FFFFF6FFFFF4F3EFEB1F1C239F9DAA
FEFCFFFFFDFFFDFCFFFEFDFFFFFEFFFFFFFFFFFFFDFCFCFAFFFFFDFFFFFD
FFFFFFFBFBFB2E2D30C0BFC2FAFAFAF9F9F9EFEFEF5F5F5FFFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFBFBFBF9F9F9FFFFFFFFFFFFFFFFFFA5A5A5
2121218A8A8AFCFCFCFFFFFFF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFEFCFDFDF8F8FFFEFBFFFEFAFFFFF8FDFAF1E5E4DFA29FA6C2C0CB
FCFAFFFDFCFFFFFEFFFEFDFFFEFEFEFDFDFDFAFAF8FAFAF8FFFFFDFAFAF8
FAFAFAFFFFFF7C7B7E79787BFFFFFFD8D8D82828289E9E9EFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFAFAFAFBFBFB606060
555555696969FFFFFFF9F9F9FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFAFAFAF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFDFEFFFEFDFFFDFAFFFCF8FFFEFAFAF9F5FFFDFFFDFCFF
FFFEFFFFFEFFFFFEFFFDFDFDFEFEFEFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFFFBFAFDC3C2C5343336EDEDED1C1C1C999999FEFEFEFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFAFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC131313
959595525252FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFEFFFFFEFFFFFEFF
FDFBFEFFFEFFFFFEFFFFFEFFFFFDFDFFFBF8FFFEFBFFFEFDF7F6F9FFFEFF
FCFBFFFFFEFFFFFFFFFEFEFEFEFEFCFFFFFDFFFFFDF5F5F3FFFFFDFFFFFF
FCFBFEFFFEFFFFFEFF0B0A0D858585BABABAFFFFFFFFFFFFFFFFFFFAFAFA
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFBFBFBFAFAFAFEFEFEC5C5C54A4A4A
E5E5E5717171F4F4F4FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFAFAFAFFFFFFFBFBFBFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FDFCFFFFFEFFFCFAFDFFFEFFFFFEFFFEFCFBFFFDFCFDFBFCFFFFFFFFFEFF
FAF9FCFFFFFFFFFFFFFFFFFDFFFFFDFBFBF9FEFEFCFFFFFDFFFFFFFCFCFC
F7F6F9FFFEFFFFFEFF535255191919A2A2A2FBFBFBFFFFFFFEFEFEFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF666666888888
FEFEFEFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFF9F9F9FFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFEFCFFFFFEFFFFFEFFFDFBFCFFFDFEFFFEFFFCFCFCFFFFFF
FDFDFDFFFFFFFEFEFCFCFCFAFCFCFAFFFFFDFFFFFDFFFFFDFEFEFEFFFFFF
FFFEFF9D9C9FFEFDFF98979A4C4C4C181818A7A7A7FFFFFFFFFFFFFBFBFB
FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFEFEFEFBFBFBFDFDFDFDFDFDF9F9F90F0F0FE7E7E7
FFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFEFEFCFFFFFDFFFFFFF5F5F5
727174535255FFFEFFDFDEE1171717D6D6D6171717999999FFFFFFFEFEFE
FAFAFAFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFAFAFAFFFFFFFAFAFAFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFF5F5F5FFFFFFFFFFFFADADAD414141FFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDF9F9F7FEFEFE606060
3C3B3EEFEEF1FEFDFFFFFEFF252525C7C7C7E5E5E51D1D1D979797FBFBFB
FFFFFFF9F9F9FFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFDFDFDFCFCFC989898BDBDBDFFFFFF
F9F9F9FEFEFEFEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFDCDCDC4C4C4C
F9F9F9FFFFFFFFFFFFFCFCFCA2A2A2B0B0B0FCFCFCE0E0E0242424676767
F6F6F6FFFFFFFCFCFCFDFDFDFFFFFFF7F7F7F8F8F8FCFCFCFFFFFFFFFFFF
FCFCFCFFFFFFF7F7F7FFFFFFFFFFFFFEFEFEF9F9F9FFFFFFFFFFFFFFFFFF
FDFDFDFEFEFEFFFFFFFDFDFDFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFDFDFDFBFBFBFEFEFEFCFCFC
FFFFFFF8F8F8FAFAFAFFFFFFFFFFFFFDFDFDFAFAFAFFFFFFEBEBEB646464
1F1F1FD0D0D0FFFFFFFCFCFCFBFBFBFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFFFFFFFF8F8F8FCFCFCFEFEFE
FFFFFFFDFDFDFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFDFFFFFEFFFFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFBFBFBFCFCFCFEFEFEFFFFFFFCFCFCFFFFFFFFFFFF
A3A3A3181818949494F8F8F8FFFFFFFCFCFCFCFCFCFBFBFBFFFFFFFFFFFF
FCFCFCFDFDFDFDFDFDFFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFAFAFAFFFFFF
FCFCFCFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFF7F6F9FFFFFFF9F9F9
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FAFAFAFFFFFFFCFCFCFDFDFD
FEFEFED8D8D83131315C5C5CDCDCDCFFFFFFFFFFFFFFFFFFF7F7F7FDFDFD
FDFDFDFFFFFFA2A2A2CECECEFFFFFFEFEFEF696969F8F8F8FFFFFFFFFFFF
F8F8F8FFFFFFFCFCFCFEFEFEFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFFFFFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFAFAFAFFFFFFFAFAFAFCFCFCFFFFFF
FDFDFDFFFFFFFEFEFE7474741313136C6C6CEAEAEAFDFDFDFFFFFFFCFCFC
FFFFFFFCFCFCBEBEBE2B2B2BFDFDFD898989666666FFFFFFFFFFFFFBFBFB
FDFDFDFFFFFFFBFBFBFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFEFFFDFEFFFDFEFFFDFFFEFFFFFDFFFFFEFFFFFFFF
FFFFFFFEFFFDFEFFFDFFFFFDFFFEFFFFFEFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFEFDFFFFFEFFFCFCFC
FDFCFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFFF9F8FBFFFFFFFCFCF8FDFEF8
FFFFFBF9F9F9FCFDFFFEFFFFE8E6E9716F72121315808181F5F5F5FEFEFC
FAFAFAFFFFFFFBFBFB292929C1C1C1323232BFBFBFFEFEFEFEFEFEFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFFFDFFFEFFFFFCFFFBFBFFF8FCFFFBFFFCFFFFFBFFFCF9FFFFFFFF
F8FAF7F9FEF8FCFFF8FEFFFAFFFCFFFFFBFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFF
FFFEFFFFFEFFFFFFFDFFFFFBFEFFFBFEFFFDFEFFFFF9FAFCFBFCFEFEFFFF
FBFCFFFEFFFFFCFBFEFEFEFEFEFCFDFFFEFFFBFBFFFEFFFFFEFEF1FDFEEC
FFFFF6FEFFFDF9FDFFFCFEFFFFFCFFFFF9FFD8DDE15159591A1A188D8C88
E5E5E3FFFFFFFFFFFF9696963D3D3D202020F9F9F9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFFFDFFFEFFFFFBFFFBF9FFF8FBFFFBFFFCFFFFFBFFFFFCFFFFFFFF
FEFFFDFCFFFBFBFFF7F4F6F0FFFCFFFFFBFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFAFEFFFAFEFFFBFEFFFFFEFFFFFEFFFFFEFFFF
F7F8FCFFFEFFFFFEFFFFFEFFFFFDFDF9F7F8FBFEFFFCFFFFF9F9EDEBECDA
0B0C02414542293038F1F3FFFEF8FFFFFCFFFBFFFFF9FFFFCDCDCD605E5D
0F0F0F4A4A4AA4A4A4EFEFEF101010CFCFCFFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFCFFFFFBFFFDFCFFFDFFFEFFFFFDFFFFFEFDF9F9F7
F7F8F8FCFFFFFCFFFDFEFFFDFFFEFFFFFBFDFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFFFDFFFFFBFFFFFBFEFFFBFEFFFDFDFEFEFEFFFFFDFCFFFFFEFF
FDFCFFFFFEFFFFFEFDFCFBF7F1EDE99C9A999B9EA5A5A8AFFFFEFFFFFFFA
DFE4DD9FA5A1E8EAF4FCFCFFFCFBFEFFFFFDF9FDFCFCFFFFFFFEFFFDFCFF
FAF9FC9D9D9D4C4C4C0F0F0F383838717171FFFFFFFCFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFEFFFFFDFFFFFEFDFFFEFD
FEFFFFFEFFFFF8FCF9FEFFFDFFFEFFFFFEFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFDFFFFFDFFFFFBFEFFFDFEFFFFFEFFFFFEFFFFFBFAFDFFFEFF
FFFEFFFFFDFCFFFEFAFFFFFBFFFDFDE3E1E2101115D5D5DBFFFDFFFDFCFF
F7FBF8DADEDD8E8E96F9F9FFFEFFFFFBFDFAF7F8FAFEFFFFF8F9FDFFFEFF
FFFEFFFDFDFDFFFFFFE2E2E2919191141414EEEEEEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFFFFFEFFFEFFFBFCFFFAFCFFFBFEFFFDFFFEFFFFFDFFFCF6FDFFFEFF
FDFFFAF8FDF6FEFFFAFEFFFBFDFBFEFFFEFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFCFCFCF8F5FFFFF8FFFDFDFBF7FFFEFAFF706C69A09F9BFDFDFFFCFFFF
FFFEFFFFFFFFC4C7CC95989DFDFEFEFEFFFFFBFBFFFEFEFFFEFFFDFEFFFB
F5F5F3FFFFFFFFFFFFEEEEEEF6F6F6515151969696FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFEFFFFFEFFFFFFF8FFFFF6FFFFF8FFFFFBFEFFFFFEFEFFFFFDFFFFFEFF
FFFFFAFFFFF4FFFFF6FFFFFBF8F9FDFEFEFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFEFFFEFDFFFFFEFFFFFEFFFDFBFC
FFFDFAFFFEFAFFFDF5DAD5D500000E2621318D858266615BF5FCFFF9FFFF
EBE6E8FBF6F6E7ECF03B4248F7F8FCF7F6FBFDFBFFFEFEFFFDFFF9FBFEF5
FFFFFDFEFEFEFBFBFB151515E6E6E6C0C0C0272727FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
F9FFFFFCFFFFFFFFF6FFFDF3FFFBF6FFFCFAFBFFFFF7FFFFF9FFFFF8F8FE
FFFFF8FFFDF2FEF3EBFFFDFBFBFFFFF8FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFCFFFFFAFEFEF9FB
FFFDFBFFFEF8FFF8EEBBB7B4090818FFFBFF2A1B1E18100EE2EEF8F5FFFF
FFFDFA685E5C00010989929FFFFDFFFFFCFFFEFEFFFAFEFFFEFFFAFFFFF8
FFFFFDFBFBFBB5B5B5393939FDFDFDF8F8F83B3B3BB1B1B1FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
F9FFFFFBFFFFFFFEF8FFFCF4FFF9F6FFFBFAF9FFFFF5FFFFF5FCFFFEFFFF
FDFAF390877E1C0E0B352D2BA3ABADF7FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFEFBFFFFFCFFFFFDFF
FFFDFAFFFDF5FFFEF3CDC9C5100F1FFAF5FFFAEAEB070000C7D7E4EEFEFF
FFF7F9FFFBFAEDF7FEF2FFFFFBF8FEFFFCFFF7F8FCF8FCFDFEFFFBFEFFF9
FFFFFDFEFEFE5656569C9C9CFFFFFFFFFFFFCCCCCCA5A5A5FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFAFCF9FEFDF9FFFDFAFFF9FAFFFCFBF9FDFCF9FFFFFFFEFFFFFDFF
FFFEFDF9F8F4AEA5A6DCD5D8E5EBEBF9FFFFFEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFDFFFFFBFFFFFDFF
FFFDFAFFFEF6FFF9EEF8F4F011101ED6D2E0FFFBF49289847B8A9FEEFCFF
FFF8FFFFF9FFF7FFFFF4FFFDFFFFF8FFFDFAFEFEFFFCFEFFFEFFFFFFFFFB
FDFDFBFAFAFA5B5B5BF4F4F4FEFEFEFCFCFCFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFBFAFFFEFDFEFFFDFFFEFDFFF9F8FFF8F6FEFFFFFCFDFDFFFCFDFFFAFB
FAFBFBFCFFFFF7F5F68F8D8EE1E5E6F6FAFBFEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFCFFFFFBFFFFFCFE
FFFDFBFFFEF8FFFDF3FFFBF7B4B4BE16121CFFF4ECB6AEAC212B42F5FEFF
FFF7FFFFFBFFF8FFFFF7FFFAFFFFF4FFFFF8FEFEFFFCFFFFFEFFFFFFFFFD
FFFFFFFEFEFEFFFFFFF9F9F9FFFFFFFDFDFDF5F5F5FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFBFEFFFDFFFAFEFDFCFEF9FFFEF8FFFDFAFEFDFFFFFCFFFEEFF4FFFBFD
F9FDFEF6FFFFFEFFFDF8F8F66E6F73F0F1F5FFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFEFFFFFEFFFEFDFFFFFDFFFFFDFE
FFFEFBFFFEFAFFFEF6FFFEFAFFFEFFB1AEB4685F60696269373C50E8EDFF
FFFBFFFDF8F8FBFFFFF9FFFFFEFFF8FFFFF8FFFFFDFEFFFFFEFFFFFEFFFF
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFBF9FCFCFDFDFFFFFBFFFAEF524944BFBFC9FAF7FFA3939B100406
E6E9EDF6FEFEDFE0DAFFFFFB7A7D82B6B9C0FEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFCFCFFFEFBFFFFF8FFFEFAFFFEFFFFFEFFFEF9FDFFFDFFFEFDFFFAFCFF
FFFFFDFFFFFBFCFFFFFCFFFFFEFFFBFEFFFAFEFFFDFEFFFFFEFFFFFEFFFF
FFFFFFFDFDFDF8F8F8FEFEFEFBFBFBFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FEFFFFFEFFFFFFFEFFFFFDF8FFF7E9B3A49D474A59F8FEFFA9A2A94C4143
BEBDC2FBFAFDCAC1BA36312B00060EE4EDF8FCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFDFFFFFDFFFFFBFEFFFDFEFFFFFEFFFFFEFFFFFFFEFFFFFEFF
FFFEFFFFFDFCFFFEFAFFFFFBFFFDFFFBF9FCFEFFFFFEFFFFF2F0F1FFFFFF
FCFFFBFAFEFBFEFFFFFEFFFFFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
F7F6FBFFFEFFFFFEFFFDF7F4FFFBEDEBDCD5000012D4D8EFE6DDE0170D0C
FCFAFFF9F9FFFFFDF5F8F3EDF2F9FFF8FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFFFDFFFFFBFFFFFBFEFFFBFEFFFDFDFEFEFEFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFDFFFFFBFFFEFAFEFDF9F6FAFBF9FDFEFFFFFBFFFFFA
FCFFFBFAFFFCFCFFFFFEFFFFFFFFFBFFFFFBFCFFFFFCFFFFFFFFFFFFFFFF
FAFAFAFFFFFFF1F1F1FFFFFFFBFBFBFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFF
FFFBFDFBF4F7FBFFFFFBFFFFFFFFF1FFF8F11B162A1B1129FFF2F42D1B19
CFD5E0F4FFFFFBFFFBFFFFFAFDFBFFFEFCFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFAFEFFFAFEFFFBFDFEFEFDFEFFFEFFFFFEFFFF
FEFFFFFFFEFFFFFEFFFFFFFAFFFEEFFFFFF4F8FBFFF8FAFFFFFEFFF9F8F4
FEFEFCFCFFFFF9FFFFFCFFFDFFFFF6FFFFF4FBFFFAF9FFFFFFFDFFFFFCFF
FFFEFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFD
FFFBFBFFFAFBFBFFFFF9FFFFFAFAEDFFFEF6776F824A3C51A28D8A2D1E19
B5BDC8F1FFFFF8FFFFF9FBF6FFFCFFFFFCFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFBFEFFFBFEFFFBFEFFFDFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFFFEFFFFFFFBFFFFF1FBFBEEFEFEFFFEFEFFFBF9FAFFFFFB
FFFFFDFAFBFBFBFFFFFCFFFDFFFFF6FFFFF4FBFFFAF9FFFFFFFDFFFFFCFF
FCFBFFFEFEFEFFFFFFFCFCFCFCFCFCFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFD
FFFDFAFFFBFBFFFEFFFDFCFFFFFEF2D3CEC45E5A68958E9DC5BDB8040100
C3C9D5F8FFFFF5FBF9FBFDF8FFFEFFFBFAFFFDFCFFFFFFFFFFFFFFFBFBFB
FFFFFF000000FCFCFCFFFFFFFFFFFFFCFCFCFEFEFEFEFEFEFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFFFFFFFFFFFDFFFFFAFFFFFBFFFEFFFFFEFFFFFFFFFFFFFD
FFFFFFFFFFFFFEFFFFFEFFFFFFFFFBFFFFFBFEFFFDFEFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FBFAF6FFFEFDFEFDFFFFFEFFFFFCF1FCF7EFFFFDFFF5F5FFFFFFFAFFFFFB
FBFEFFF1F7FFFEFFFFFFFFFBF7F8F8FEFFFFFFFFFFFFFFFFF6F6F6FFFFFF
FFFFFF000000FFFFFFF9F9F9F7F7F7FFFFFFFFFFFFF9F9F9FBFBFBFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FFFFFBFFFFFDF7F8FAFDFBFCFFFDF6FFFDF8FDFDFFFCFEFFFFFEFBFEFCFB
F9FFFFF5FDFFFEFFFFF8F7F3FFFFFFFEFFFFFDFDFDFFFFFFFEFEFEFFFFFF
F3F3F3000000FFFFFFFFFFFFFFFFFFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFCFBFFFFFDFEFFFFFFFEFDFFFCF7A09895C5C5CBF9FCFFFEF9FBCFCDCE
888F97F8FFFFFDFEFFFFFEFDFFFFFFFCFDFFFFFFFFF9F9F9FFFFFFFBFBFB
FFFFFF020202FCFCFCFDFDFDF6F6F6FFFFFFF6F6F6FFFFFFFCFCFCFCFCFC
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFEFDFFFAF8F0EAE8343336FEFFFFFFFDFF28272C
EEF2F9F6FDFFFBFCFFF8F8F8FFFFFFFDFDFDFFFFFFC8C8C8FFFFFFF9F9F9
FDFDFD000000FFFFFFFCFCFCF9F9F9DCDCDCFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEF9F9FFFDFDFFFDFDFFFDFDACA7A9979598939498A4A7AC
FCFFFFFBFEFFFCFFFFFCFFFFFDFDFDFFFFFFF9F9F9000000484848FEFEFE
FEFEFE050505FFFFFFF0F0F0101010696969FCFCFCFFFFFFFDFDFDFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFFFFFFFFFDFBFCF6F4F6F7F7FDFDFDFFFCFB2E25263E4549F6FFFF
FFFEFFFEFBFFF9FEFFFBFFFFFFFFFFFBF9F8FFFFFF959595040404545454
FEFEFE000000D7D7D7141414000000E9E9E9FAFAFAFFFFFFFBFBFBFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FBFFFFFFFFFFFFF7F5FFFDFBFCFFFFFEFFFFFFF6F5F2E8E7E3ECF1F7FFFF
FFFEFFFFFBFFFBFFFFF5FDFFFBFBF9FFFEFBFFFEFDFCFCFC121212000000
3434340606060D0D0D060606707070FDFDFDFFFFFFFBFBFBFFFFFFFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FCFFFFFEFFFFFFFDFBFFFDFBFCFFFFFEFFFFFFFBFAFFFCFBF8FFFFF7FFFF
FFFEFFFFFDFFFBFFFFF9FFFFFFFEFDFFFEFBFBF9F8FFFFFF9B9B9B080808
121212000000030303030303F0F0F0F9F9F9FFFFFFFFFFFFFDFDFDFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FCFFFFFEFFFFFFFDFBFFFEFBFEFFFFFFFEFFFFFCFAFFFDFBF9FFFFF8FFFF
FFFFFFFFFEFDFCFFFFFBFFFFFFFEFDFFFEFBFFFEFDF9F9F9EFEFEF030303
0000000000000606063A3A3AFAFAFAFEFEFEFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFFFFFBFFFFFBFFFDFFFFFEFFFFFEFAFFFFFBFEFEFFFCFEFF
FEFFFFFEFFFDFEFFFFFFFEFFFFFEFDFFFFFBFFFFFDFCFCFCFFFFFF434343
000000000000090909A3A3A3FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFDFFFFFDFFFCFFFFFDFFFFFFFAFEFFFBFFFCFFFFFDFF
FCFFFFFBFFFFFFFEFFFFFEFFFFFFFBFFFFFBFAFAF8FFFFFFF5F5F5A0A0A0
0E0E0E010101080808F3F3F3FFFFFFFEFEFEFDFDFDFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFCFFFDFFFFFDFFFCFFFFFCFFFEFFFBFCFFFDFFFCFFFFFCFF
FBFFFFF9FFFFFFFEFFFFFDFFFFFFFBFFFFFBFFFFFDFFFFFFFFFFFFD5D5D5
0A0A0A030303191919FFFFFFFDFDFDFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFCFFFFFCFFFFFFFFFFFFFCFFFFFCFFFEFFFDFCFFFFFFFCFFFFFDFF
FBFFFFF9FFFFFFFEFFFFFDFFFFFEFBFFFFFBFFFFFDFBFBFBFFFFFFF7F7F7
0A0A0A000000585858FDFDFDFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFCFFFFFCFFFFFFFFFFFFFDFFFFFDFFFFFFFFFEFFFFFFFDFFFFFEFF
FCFFFFFCFFFFFFFEFFFFFDFFFFFEFBFFFFFBFEFEFCFFFFFFF8F8F8FFFFFF
3232320000009E9E9EFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFEFFFFFEFF
FEFFFFFEFFFFFFFFFFFFFEFFFFFEFDFFFEFDFDFDFDFFFFFFFFFFFFFAFAFA
616161010101BDBDBDFEFEFEFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFCFCFC
8D8D8D020202DADADAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
A6A6A6000000FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6F9F9F9
D0D0D0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF6F6F6
FFFFFFFDFDFDFBFBFBFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFF
F7F7F7FFFFFFF6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFEFEFEF9F9F9
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
pop
grestore
%%Trailer
%%EOF
\
\>"], "Graphics",
  ImageSize->{373, 274},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005e00014R000`400?l00000o`00003oo`3ooomf
0?ooo`00o`3ooomf0?ooo`00_03oool70?ono`80oooo0`3nool40?ooo`030?ono`3oool0ooko07D0
oooo00D0ooom0?ooo`3oo_l0ooko0?ooo`020?ooo@030?ooo`3nool0o_oo00<0o_oo00@0ooom0?on
n`3oo_/0oooo0P3oo_l00`3oool0ookm0?ooo@020?kooaT0oooo002`0?ooo`050?ono`3ln_d0ooko
0?ono`3jno/00P3nool0203mo_h0o_oo0?Win@3oool0ooko0?okn`3oo?`0ooWj0P3on_d02@3on_l0
noKj0?ono`3gn?X0o?oo0?_oo`3lool0n?Wk0?koo`030?ono`030?SgnP3mo_l0o_oo0700oooo0P3o
o_l0103oool0ooom0?oon`3oo_d20?omo`040?omoP3ooo/0no_g0?koo`80o?ko0100m_cl0?_oo@3k
oo`0o_oi0?omm03ooOH0oO_l0?kno`3gn?`0oooo0?onnP3oooX0o?om0?_oo`3nool0oooo0P3oo_lE
0?ooo`00/03oool20?omo`0N0?ono`3kn_d0o_oo0?koo`3ko?`0o_oo0?WjnP3nool0ooko0?ghnP3o
oOd0ooOh05mDEP0C20X0o?7g09R?U00<1@X0j>KY0?koo`3lool0nooo0?[oo`3nool0nocn0?[ioP3f
mOX0ooko0?_jo`3nool0nocnM03oool20?ono@<0ooko00D0oOgk0?ooo@3mo_h0o?oo0?Ojo`020?_o
o`080?_oo@3nooT0oogc0?ojlP3jn?/0nOco0?kno`3kno/20?oon0040?_oo`3iool0o?oo0?ooo`<0
ooko503oool00;00oooo00L0oO_n0?ono`3in?/0ooko0?gnoP3loOd0n?Wi0080o_oo0140o?gm0?kl
o@3ooOl0oo[j0?oko03on_`0k>7S07]bM`0J4aP0al;60;bk_P3in_`0o?oo0?_oo`3ho_h0o_oo0?_l
oP020?ono`040?kmo`3oo_l0mOKh0?koog@0oooo01X0ooko0?ooo`3ooo/0oook0?ooo`3noOl0n_Wn
0?ono`3noo/0oOoj0?[ko@3lool0l_[j0?kon`3om^d0oo_d0?ono`3lool0o_ko0?kmo`3oo_X0oooh
0?_oo`3iool0o?oo0?ooo`<0ooko503oool00;00oooo00@0ooko0?[hn`3mo?l0ooko0P3nool05P3i
n_X0o_oo0?koo`3kno/0ooko0?_inP3ooOd0o_Sh0?ojn`3on_h0YIbQ01TB5`3ak?00nOSk0?koo`3l
ool0mogm0?coo`3in_`0o_oo0?kmo`3gm_T20?ono`0300000P3nool0oooo06l0oooo0P3oood01`3o
ool0ooko0?ono`3oo_l0oooj0?oon03no_h00P3oo_l04`3jn?/0oooe0?oomP3oo_l0nOSn0?Woo`3j
o_d0gmS@01T@2`36al/0nOgo0?[mo`3oo_l0ookj0?oonP3kool0nOoo0?coo`3oool00`3oo_lD0?oo
o`00/03oool0803ooOl0ooko0?ono`3mo?l0n?Wi0?_lo01LGEd0moSh0?ooo`3no_h0n_Si0?ono`3o
o?`0oogm0?olo@3oo?l0b/7601L@5`3glOP0ooko0?koo`3joOl0n_ko0?_oo`3mo_l0o_oo0?Win@3o
o_l0oooo0?7al@0720P0noclL`3oool02@3oo_l0o_oo0?koo`3nooX0o_oh0?ooo`3mo?l0oO[o0?om
o`020?onm00@0?oko03ooOl0nOoo0?Omo@3oo_P0TXZ70<S8cP3kool0m_Wo0?koo`3oo_X0oooj0?_o
o`3iool0o_oo0?ooo`80ookm00<0ooko0?ooo`3oool04P3oool00;00oooo01D0ooko0?cjo@3jnO`0
inKY0;Vj^P3mo_h00`@40?koo`3moOd0oooo0?ono`3imoP0oOSh0?omo@3on?T0oo[m08b3R00700L0
Ui6H0=CCf03nool00P3lool01@3ho?d0o?go0?ooo`39alP0d]3A0080oooo00<000000?cmo@3oool0
LP3oool30?koo`80o_ok01T0o_om0?_kn`3ooOl0oogm0?ojm@3on?40oo_k0?oioP3iool0l?Ok0?[f
l`3Idm40P8>80?Soo`3kool0nocn0?onnP3oooX0nooo0?Woo`3nool0oooo0?omo@3oo_d0ooko01@0
oooo002`0?ooo`080?Sfn@3oo_l0no[m0?ono`12@T80TI6A0000003nool20?ooo`0F0?[hn@3no?d0
oogm0?okn`3ooOd0W9FH0109403Fd=P0ZjR^00h=4P3^ko<0o?oo0?Chn@3lool0o_oo0?Win@3Qgn00
61HE0=gKfP3gmoD000400?kooG00oooo0P3oo_l0103oool0o_oo0?koo@3lood20?coo`0I0?koo@3l
oOL0o__d0?kfl`3onod0oo[m0?ojn03onOL0n?oo0?Koo`3oo_d0m>o_04U=E03bn_l0nooo0?cmo`3o
o_X0oooj0?_oo`3iool0o_oo0?ooo`3ooOd0ookm0?ono`0D0?ooo`00/03oool02P3oo_l0noWl0?on
o`3oo_l0fMWI01<C4`041@D0oOkn0?gmo@3oool20?ono`050?olo03nnOT0oogm0?olo`3on_l00P3o
o?l03@3nool0noco0?coo`3lool0o_oo0?knoP3oool0ookm08f;RP0n?3/0ooom00@40P3nood0L03o
ool20?ono`0O0?koo`3nood0o?ok0?coo@3kool0o?oo0?koo@3oooP0oood0?O`j00W6Ql0nn[`0?oa
j`0R6A@0H6Qb0?7mo`3in?/0ookm07n6S03AfN40nooo0?koo`3oo_X0oook0?_oo`3iool0o_oo0?oo
o@3ooOd0oook0?ono`0D0?ooo`00R03oool0103lo?`0oooo0?ooo`3kno/20?ooo`030?clo03oool0
o?cl0080oooo00@0no_k0?ooo`3oool0o?cl0P3oool00`3moOd0o?cl0?ooo`020?ooo`030?Win@3o
ool0oooo00l0oooo01<0o?_n0?ono`3noOl0ooko0?knoP26QXH010@4000000020P80000000410@00
00000P000040000200000`0000<00P0300@00@0400<0000400@0004200000P0000000@000P050000
1@010000XZ:P0000003nood0no_k00@0oooo00<0o_kn0?gmo@3oool0J03oool20?ono`040?koo`3n
ood0o?ok0?coo@80o?oo01T0o_om0?oon03ooo<0ookf030Q9P2lZjl0ooS`04Y1?027T9/0d]k/0?km
o`3^k>d0B4mC08nHW@3hoOl0o_oo0?onnP3ooo/0o?oo0?_oo`3nool0ooom0?omo@3ooo/0ooko01@0
oooo002:0?ooo`040?KfmP3oool0n?Sh0?Ogm`@0oooo00@0m_Kf0?ooo`3hn?P0moOg0P3oool01P3h
n?P0o_kn0?ooo`3kno/0oooo0?gmoA80oooo0P3oo_l02P3noOl0ooko0?_kn`3jn_X0:RXZ0:VYZ@3k
no/0oooo0?Cdm03oool20?ono@060?omo03oo_l0oogo0?omo`3oo_l0o_oo0`3lool02@3nool0oooo
0?ono`3ooOd0nOCd0=CBd@0B4Q001@D10?koo@020?ooo`80oOgm00<0oooo0?knoP3no_h0J`3oool2
0?koo`80o?om01P0o?oo0?koo`3knoT0oooj0?oll`3oo?@0YYZJ028B4P3on_@0Uhn=07b5U03dool0
oOco0?ono`3bnOd0n?oo0?KkoP3nood0ookj0?oon`3lool0nooo0?koo`3oool20?oon`030?ooo@3o
ool0oooo0180oooo00280?ooo`0408n?S`3dm?@0oooo0?gmo@<0oooo00D0no_k08n?S`3dm?@0oooo
0?gmo@030?ooo`060?_kn`3oool0YJFU0?ooo`3moOd0o_kn0P3oool00`3no_h0oooo0?ooo`0>0?oo
o`040?[io03oo_l0ooko0?ono`80oooo00@0`/;201lO7`3Zj^X0n?Sh0P3oool0103oood0no_i0?gm
n`3oool30?ono`030?koo`3lool0o?oo0080o_oo00P0oooo0?ono`3oo?`0oocl0?ono@1aLFl00000
0?cnn`80n_[j00H0no_k0?ooo`3oool0oooo0?clo03moOeZ0?ooo`@0o_oo01P0o_om0?kon`3oool0
n?Kg0?omo`3ooOX0elc400X0002VV9<0hmcQ00`D9`3Rkol0ooko0?omoP3kool0mOco0?coo`3moO/0
oogj0?onn`3lool0nooo0?coo`3oool20?oon`030?ooo@3oool0oooo0180oooo00280?ooo`0?0;6a
/@0i>CT0l?3`0?ooo`3moOd0o_kn0?Shn03oool0/K6a03Ti>@3`l?00oooo0?gmo@3no_h0n?Sh0080
oooo00L061PH08>3P`3kno/0oooo0?knoP3oool0o?cl0100oooo00@0o_go0?ono`3hmoX0no[m0`3o
ool01P1TI6@0JVYZ0?ooo`3kno/0oOgm0?Ogm@80ooom00<0n?Sf0?omoP3noOl00P3mo_l20?_oo`04
0?gnoP3no_h0oogn0?ono`80oo_k00@0ookm0??cl@071`D0]kVf0`3oool20?gmo@80o_knJ@3oool2
0?ooo@@0o_oo01P0o_ok0?oonP3imoP0oogo0?olo`3oo?`0mnoR018:001VFeL0YZ2X00087@3]mol0
n_Wo0?omoP3kool0mOgo0?coo`3ooo/0oogj0?onn`3lool0nooo0?coo`3nool20?oon`030?ooo@3o
ool0oooo0180oooo00280?ooo`040?gmo@1kNg/0:RXZ0=kNgP80o_kn00H0oooo0?Ogm`3moOd0Ng]k
02XZ:P3Ng]h20?knoP090?ooo`3gmoL0oooo0>g]k@0k>c/0H61P0?Cdm03oool0moOg0140oooo00@0
o?_n0?ono`3oo_l0ooko0P3oool0201BDU80m_Kf01/K6`2o_kl0o_kn0?ooo`3lo_/0oOol0P3nood2
0?ooo`80o_oo0P3lool0103nool0oooo0?gko03on_`20?omo`070?Kdm@3moOd0000002<T903_knl0
o_kn0?ooo`020?[jnV/0oooo0P3nood20?koo`80ooko01P0oook0?oonP3oo_l0ooco0?ojo`3oo?`0
ZjNI03dg9`3:`[d0QhJ<024[@03SkOl0ooko0?[em@3gno`0nOoo0?koo@3oooX0oogh0?omn`3lool0
nooo0?coo`3nool20?oon`030?ooo@3oool0oooo0180oooo00280?ooo`050?knoP3lo?`0Shn?01XJ
6P3>c/h00P3oool20?knoP040?clo02?Shl06QXJ0<k>cP80oooo00L0o_kn0?ooo`3emOD0l_;b05=C
D`17AdL0k^k^0180oooo00h0ooko0?kmo`3oo_l0ooko0?gmo@3no_h00`<30?ooo`3QhN40^[Zj0?oo
o`3fm_H0o_om0?cnn`80o_om0P3moOd20?cmo@80n_km00h0o?gm0?gmo@3oo_l0oogo0?cgn@3mn?X0
ooko0?ooo`000000c/o?0=cLg03bl_80oooo0?knoP<0oooo00<0no_k0?ooo`3oool0IP3oool30?ko
o@0K0?koo`3oo_l0ooko0?ono@3ooOd0oogo0?_fnP3ooOl0oogm0?Gbj@3ooo@0oogf0?koo`3eool0
lOWo0?omo`3ooOd0o?oo0?_oo`3nood0o_gh0?omn03ooO/0o?oo0?_oo`3lool0o_oo0080oook00<0
ooom0?ooo`3oool04P3oool008T0oooo00D0oOgm0?ooo`2[Zj/06a/K0;6a/@030?ooo`050?gmo@3o
ool0Zj^[01/K6`2a/K400P3oool0203jn_X0oooo0?ooo`3fm_H0IFEU038b<P3^k^h0n_[j403oool2
0?ono`080?_jo@3oo_l0oooo0?ooo`010@40n_[j0?ooo`3kno/20?ooo`040?koo@3lo_/0o_om0?ko
o@80ooom00l0o_om0?coo@3lood0o?om0?koo`3oool0ooko0?ghnP3oo?l0oogo0?_inP3inOT010@4
0?Cem@3lo?`00`3oool20?knoP030?gmo@3oool0oooo06L0oooo0P3nood20?ooo@0M0?ono@3oo_l0
ooco0?oko`3oo?l0oocl0?onn`3glo00M6ma0?[hm`3oooP0n?ck086<WP3@f>d0o__o0?olo03nool0
n_km0?WkmP3oooX0oogh0?omn`3lool0nooo0?coo`3nool0ooom0?oon`3oood0503oool008T0oooo
00H0n?Sh0?ooo`3oool0_[jn01lO7`2NWYh20?ooo`060?Shn03oool0oooo0;jn_P0O7al0WYjN0`3o
ool01P3gmoL0oooo0?ooo`21PH406QXJ0=oOg`l0oooo00d0ooom0?onn`3oo_d0nooo0??jo`3nool0
o_cm0040003oo_d0o_oo0?gnoP3oo_d0oogl0080o_om00H0o_oo0?_lo03no_h0o_kl0?goo03koo`2
0?goo0040?gnoP3no_h0ooko0?ojo080oogo00P0oogn0?ooo`010@40o_oo0?ooo`3no_h0no_k0?kn
oP80oooo00<0oOgm0?ooo`3oool0I`3oool20?koo@80ooom01P0ookm0?ono`3oo?l0ooco0?omo`3o
o_/0oo_g0?onn`2c/;H0Q8:50?kmmP3Be=40EEaZ0?Smo`3ooOl0oogm0?gnoP3kooh0o_om0?onn@3o
oOX0ookk0?koo`3lool20?koo`80ooom5@3oool00400oooo00H0o?cl0?ooo`3oool0n_[j0?ooo`3k
no/:0?ooo`080?[jnP3no_h0oooo0?clo03oool0oOgm0?ooo`3no_hb0?ooo`070?[jnP3oool0oooo
0=KFeP0L71`0S8b<0?[jnP020?ooo`080?knoP3lo?`0g=cL01HF5P2:RXX0no_k0?ooo`3gmoL20?oo
o`060?gmo@2LW9`061PH0<_;b`3oool0nOWi0P3oool00`3kno/0oooo0?ooo`040?ooo@<0o_om00T0
o?_f0?oml@3oo_L0jogo0?3oo`3inol0ooco0;N^[`3ln?D00P3lool00`3oo_/0ookj0?oon`020?ko
o`80ooko0P3oool00`3nool0oooo0?ooo`030?ooo`80ooko00@0oO_l0?ooo`3lo?`00`<30P3moOd0
103no_h0oooo0?ooo`3moOd20?ooo`050?clo03jn_X0oooo0?knoP3lo?`00`3oool00`3no_h0oooo
0?ooo`0f0?ooo`050?clo03oool0oOgm0?ooo`3inOT0103oool01P3lo?`0oooo0?gmo@3no_h0oooo
0?KfmQT0oooo103nool20?ooo`<0ooko0`3ooOd01P3im?P0E4mA0=KAd@0_;Bh0l?3f0?ShoP80ooko
00/0oooo0?koo`3oool0o_kl0?Sfm@3oo_d0oOco0?koo`3mo?l0oooo0?Win@020?ooo`030?_kn`3o
ool0o?cl00<0oooo00<0no_k0?ooo`3oool02`3oool00440oooo00<0moOg0?knoP3oool00P3moOd0
0`3oool0o?cl0?knoP070?knoP80oooo0P3kno/0103moOd0oooo0?[jnP3oool`0?knoP0;0?_kn`3n
o_h0oooo0?clo03moOd0oooo0>SXj00V9RH0Lg=c0?Gem@3kno/00P3oool0103kno/0jNWY030`<01[
Jf/20?ooo`0=0?_kn`3no_h0oooo0?ooo`2a/K405ADE0;6a/@3oool0moOg0?ooo`3no_h0oooo0?cl
o0030?ooo@0=0?_kn@3nood0moWf0?_mnP3oo_X0ooga0?_hl@3`ool0k_oo0?Oio`3onOl0oocj0?oo
n`020?[oo`040?omnP3ooOL0o_oi0?goo080oOgo00<0o_go0?knoP3no_h01@3no_h00`3jn_X0oooo
0?Ogm`020?ooo`030?gmo@3lo?`0o?cl00@0oooo00`0oOgm0?clo03oool0oooo0<k>cP20P800o?cl
0?ooo`3jn_X0oooo0?gmo@3ooolh0?knoP030?ooo`3inOT0oooo0080oooo00P0oOgm0?ooo`3lo?`0
o_kn0?ooo`3no_h0oooo0?Ogm`80oooo00<0oOgm0?knoP3no_h05P3no_h40?gnoP@0o_kn00<0nOOh
0?ono`3jmOL00P3ooOl0103XhnD010000;>^/03knOX20?ooo`0<0?knoP3moOd0o_kn0?clo03gmoL0
HV9R06=SH`3fm_H0no_k0?clo03inOT0oooo0P3moOd30?ooo`030?[jnP3kno/0o_kn00h0oooo0011
0?ooo`050?Ogm`3oool0oooo0?knoP3oool00P3no_h90?ooo`070?Shn03lo?`0oooo0?ooo`3kno/0
oooo0?Win@0a0?ooo`0:0?clo03moOd0oooo0?Shn03moOd0o?cl0?Shn012@T80DE5A0?Ogm`80oooo
00H0o?cl0?ooo`3[jn/0ADE50451@@3fm_H20?ooo`070?clo03no_h0oooo0<O7a`0I6AT0WinO0?oo
o`020?knoP060?Cdm03oool0no_i0?ooo@3knoT0o?cj0P3oood0403jn_P0ookj0?oimP3oo_d0logo
0>olo`3no_l0ooko0?ono@3koOX0nooo0?coo`3ooOl0oogk0?oonP3ooo/20?coo`030?koo`3oool0
oooo00P0oooo00@0n_[j0?_kn`3oool0moOg0P3oool20?clo0<0oooo0P3moOd0103inOT0A4A408B4
Q03inOT20?ooo`030?clo03oool0oooo03L0oooo00D0o_kn0?ooo`3fm_H0oOgm0?ooo`020?clo080
oooo00<0o?cl0?knoP3oool00`3oool00`3inOT0oooo0?ooo`0F0?ooo`@0o_oo103oool20?ono`07
0?omo`3on_`0oogo0?oloP3Of]`0oo[l0?ono`020?ooo`0B0?knoP3oool0oooo0?ooo`3lo?`0a<C4
000000061PH0UIFE0?Cdm03oool0m_Kf0?ooo`3no_h0oooo0?[jnP3oool0oOgm403oool00400oooo
00D0moOg0?gmo@3oool0n?Sh0?knoP030?ooo`P0o_kn00P0oooo0?Win@3oool0nOWi0?gmo@3oool0
nOWi0?oooc00o_kn00<0oOgm0?ooo`3emOD00P3oool02@3jn_X0oooo0?_kn`3fm_H0GUiN03Xj>P3[
jn/0oooo0?Win@020?ooo`060?clo01TI6@0?3`l0>g]k@3lo?`0n?Sh0P3oool0103lo?`0g]kN01LG
5`21PH430?ooo`050?knoP3moO/0ooom0?gmn`3knoT00P3oood04`3no_`0oooo0?ono`3nool0n?ck
0?coo@3oool0n?Sh0?koo`3iool0n_oo0?gmo`3onol0oo_n0?onm`3nooT0nooo0?[oo`3mo_l01`3n
o_h02@3lo?`0o_kn0?ooo`3oool0nOWi0?gmo@3oool0n?Sh0?gmo@020?ooo`030?clo03no_h0oooo
00<0oooo00D0inOW018B4P3Ph>00oooo0?KfmP020?ooocP0o_kn00L0oooo0?_kn`3oool0oooo0?_k
n`3oool0no_k0080oooo00L0no_k0?ooo`3oool0oooo0?Ogm`3kno/0oooo01P0o_kn103mo_h40?kn
oP80ooko00P0noKh0?omo`3oo?h0oo[l0?omo`3ln_/0o_cm0?gmo@80o?cl01@0o_kn0?ooo`3oool0
o_kn0?ooo`2d];@00@4100P820000000@T920;6a/@3Ph>00oooo0?gmo@3oool0no_k0?Win@3oool0
o_kn0?clo0d0oooo00110?ooo`050?clo03kno/0oooo0?ooo`3gmoL02P3oool0203inOT0oooo0?kn
oP3oool0mOGe0?7al@3oool0oOgm<03oool0103moOd0no_k0?gmo@3gmoL50?ooo`0=0?knoP1nOWh0
7QhN0?KfmP3oool0n?Sh0?knoP3jn_X0oooo07IfMP0V9RH0oOgm0?clo0030?ooo`040?clo03`l?00
=CDe05]KF`80oooo00<0n_[j0?ooo@3jn_P00`3oood04@3dm?80ooom0?koo`3inol0mo[o0?onn@3o
ooH0nOSd0?koo`1BF5P0nOoo0?coo`3oo_l0oo_o0?olo`3oo_P0oooh0080nooo00<0o_oo0?ooo`3o
ool01`3oool01`3fm_H0oooo0?ooo`3no_h0oOgm0?ooo`3moOd00`3oool02@3no_h0o?cl0?Win@3k
no/0o_kn0?Shn02HV9P000000?Shn0020?ooo`030?Ogm`3oool0oooo03H0oooo00l0no_k0?ooo`3a
lO40moOg0?ooo`3lo?`0oooo0?Win@3kno/0oooo0?gmo@3fm_H0n?Sh0?ooo`3moOd06@3oool40?ko
o`@0oooo0`3oo_l0103imoP0oogo0?omo`3oo?h20?ono`H0oooo00D0o_kn0?ooo`3fm_H0Vi^K010@
40020000000900D51@0<30`03`l?03/k>`2@T900Xj>S0<S8b03]kNd0oOgm00h0oooo00100?ooo`03
0?Ogm`3oool0o_kn0080000000<01`L7000000010@40200000001`030`<000000000000000003@d=
0000000410@0<@0000001P051@D00000000000071`L0000000<30`D0000000@00@41000000010@40
0@410P020P802@0000001@D5000000010@400P82000000020P80000000P820050000000300P82001
0@000@4000<0000000/010@20082000000@0004>00D74@0710001000004000000000008200031@02
00001@0700@01`0600801P0000<000000P00008400000P080000000300<30`0:2PX0000000800000
0P010@40100000000@4100000000000200@41006000000051@D0000000@4100000000P820`000000
0`071`L000000000000f0000000400410@071`L0000000P8208000000P051@D300000080oooo00<0
m_Kf00820P000000800000030040000500<10P0910H00`0000<0000100000P00000200410@@00000
00<010@40000000000000P0000001`0820P01PH60000000000003`l?000000010@400P0000000`2Y
ZJT0oooo0?ooo`0<0?ooo`00@@3oool01@3inOT0oooo0?ooo`3no_h0o?cl0080oooo203no_h0203k
no/0oooo0?ooo`1TI6@0000000410@0b<S80oOgm<03no_h0103jn_X0no_k0?ooo`3jn_X20?ooo`07
0?[jnP3oool0oooo0?[jnP3oool0oOgm0>SXj0040?ooo`80n_[j00L0oooo0=oOg`3oool0oooo0?cl
o03oool0nOWi00D0oooo00@0nOWi0?gmn`3oood0nOOf0P3oo_d0503imoH0h^3O0>[Yk03fm_l0o_ko
0?oon`3ko?@0ooom0?koo`000P00nooo0?[oo`3moOl0oo_o0?okoP3ooOL0ookg0?_oo`3jool0oOko
1`3no_h02P3moOd0no_k0?knoP2i^KT0V9RH06ATI01dM7@0Y:BT0=OGe`3jn_X30?ooo`0;0?knoP3l
o?`0oooo0?knoP3lo?`0n_[j00@4100M7Ad0jn_[0?ooo`3jn_X0>03no_h01@3gmoL0<30`00000001
0@40JVYZ0080oooo00D0m_Kf0?gmo@3oool0oooo0?Cdm0020?ooo`030?gmo@3oool0o_kn01L0o_kn
103mo_h50?knoP040?ooo`3mno`0o_cm0?OemP<0ooko0P3moOd30?ooo`070?knoP3oool0oooo0?Sh
n03oool0Vi^K00H61P020000000800P820030`<04a<C0410@023Ph<0XZ:R0<[:bP3Rh^8?0?ooo`00
@03oool0103moOd0oooo0?clo03moOd20?ooo`030?Win@3oool0oooo00P0oooo00L0nOWi0?ooo`3=
cLd0000000H61P020P80N7Qh0380oooo0P3no_h02`3lo?`0oooo0?ooo`3lo?`0oooo0?knoP3moOd0
oooo0?clo03oool0n_[j0080oooo00T0o?cl0?ooo`3oool0oOgm0?clo03oool0oOgm0?ooo`3jn_X0
0P3oool02P3lo?`0oooo0?ooo`3oool0ooom0?Ogm@3oo_d0n?Ke0>g[jP16A4<20040000>030^<@3P
gn80n?kn0?Woo`3nool0m_Gh00H71`3jo_d0nooo0?coo`3ooOl0oocm0?onn03oooX20?coo`030?ko
o`3oool0oooo00H0oooo00X0k^k^04m?C`0_;bl0J6QX09jNWP23Ph<0EeMG01DE5@2>SXh0l?3`203o
ool00`000000LG5a05YJFP0j0?ooo`07071`L0010@401@D500410@3<c<`0oooo0?[jnP040?ooo`03
0?gmo@3oool0no_k01X0oooo103nool50?ooo`040?Win@3oo_l0ooko0?cjn`80ooko00<0o_cm0?oo
o`3oool01`3oool03`2][Jd00@4100`<30061PH0?3`l0:j^[P3UiND0o_kn0?gmo@3oool0o?cl0?oo
o`3no_h0oooo0?Shn00=0?ooo`00D@3oool0103moOd0o?cl0?ooo`28R8P3000000040;fm_@3oool0
n?Sh0?clo080oooo00<0o?cl0?ooo`3oool0A`3oool30?ono@0Z0?Sfm@2_[J`02@L60>;Mg@3onOL0
OGA]00`81@3]nol0kooo0?cno`3onol0[jZZ0?kno03jool0nOoo0?omo@3ooOX0oooj0?oon`3loOl0
oOgo0?kmo`3moOd0oooo0?[jnP3oool0o_kn0?_kn`3oool0emOG0000001fMWH0nOWi0?knoP3oool0
no_k0?ooo`3Zj^X0ADE500X:2P3jn_X0o_kn0P3oool02`3no_h0dm?C0?_kn`3oool000000?Gem@0O
7al0^[Zj0?_kn`3no_h0oOgm00@0oooo00@0oOgm0?knoP3no_h0oOgm103oool0103moOd0o_kn0?kn
oP3moOd40?ooo`040?gmo@3no_h0o_kn0?gmo@@0oooo00@0oOgm0?knoP3no_h0oOgm103oool0203m
oOd0o_kn0?clo03oool0n?Sh0?ooo`3no_h0no_k0`3oool02`3no_h0oooo0?gmo@3oool0o?cl0?kn
oP2b/[80000000410@020P80T92@02@0oooo0P3nool@0?ooo`0=0?knoP3oool0oooo0?ooo`3moOd0
no_k0;no_`0000002@T908^;R`3bl_80nOWi0?knoP0F0?ooo`00D03oool20?_kn`080?ooo`3inOT0
nOWi04i>CP0000001@D501/K6`3Zj^X20?ooo`040>g]k@3kno/0oooo0?_kndP0oooo01H0oogl0?gk
nP3oo_d0ookm0::PW`0e<c80o_Wi0?oim03om>L091lG0:2c_`3]ool0o?ko0?oko`3ooO/0oo_h0?Wo
o`3kool0o_[f0?onn03oooX0n_ci0`3oo_l20?ooo`80no_k0P3oool01`3clo<09RHV0:>SX`3lo?`0
oooo0?clo03no_h00`3oool03@3moOd0000007alO03oool0moOg0?clo03oool0Ng]k00X:2P3gmoL0
00000?ooo`3no_h0103oool0103kno/0oooo0?ooo`3kno/40?ooo`040?_kn`3oool0oooo0?_kn`@0
oooo00@0no_k0?ooo`3oool0no_k103oool0103kno/0oooo0?ooo`3kno/40?ooo`040?_kn`3oool0
oooo0?_kn`<0oooo00<0lo?c0?ooo`3no_h00`3oool01@3hn?P0oOgm0?ooo`3oool0o_kn0080oooo
00H0g=cL01@D50061PH0000005=CD`3no_h20?ooo`030?Shn03oool0oooo01l0oooo0P3nool@0?oo
o`090?knoP3oool0oooo0?ooo`3no_h0no_k069RHP1mOGd0iNGU0080oooo00<0o_kn0?ooo`3hn?P0
5@3oool00540oooo00/0moOg0?ooo`3moOd0o?cl0>OWi`0N7Qh0000000<30`13@d<0oOgm0?Win@02
0?ooo`030?clo03oool0oooo04D0oooo0P3oo_l20?ono@0H0?omo@3lmoL0aL3000l:2P3gl_80oogh
0?okk01nMfd0Efik0>Woo`3ko_l0oO?k0?ohm`3oo_X0mOgk0?Ooo@3oooP0ookf0?konP3lood0oOco
0?cho`3oo_l0moOg0`3oool01`3fm_H0oooo07alO01MGEd0n_[j0?ooo`3gmoL00P3oool01`3kno/0
oooo0?ooo`3lo?`0lO7a01hN7P31`L400P3oool02`3no_h0n_[j014A4@1CDe<010@40?clo03oool0
n?Sh0?gmo@3kno/0oOgm00@0oooo00@0oOgm0?_kn`3kno/0oOgm103oool0103moOd0no_k0?_kn`3m
oOd40?ooo`040?gmo@3kno/0no_k0?gmo@@0oooo00@0oOgm0?_kn`3kno/0oOgm103oool02@3moOd0
no_k0?ooo`3oool0o_kn0?ooo`3lo?`0o_kn0?_kn`020?ooo`060?gmo@3oool0oooo0?Win@3jn_X0
?Cdm0P0000000`0W9bL0kno_0?Shn0020?ooo`030?Gem@3oool0oooo0340oooo00X0o_kn0?ooo`3o
ool0oooo0?knoP3lo?`0mOGe0?Shn03oool0oOgm0P3kno/G0?ooo`00D03oool01`3kno/0oooo0?_k
n`3no_h0oooo0?clo02i^KT00`000000102BTY80o?cl0?ooo`3lo?a80?ooo`80ooko0100moGd0?on
o@3ooOd0oogm0?G`l00D3`l0^;>c0?omn03onNX0YZ6G01D[=P3Wool0o?ko0?oko`3ooO/0oOWe0P3i
ool02P3oo_X0oocf0?gnn03lood0ooko0?omo`3oo_l0o_kn0?ooo`3jn_X20?ooo`030?gmo@0Y:BT0
clo?00@0oooo00T0o_kn0?_kn`3oool0oOgm0?ooo`3fm_H0OGem08>3P`3hn?P00`3oool00`2k^k/0
000000820P070?ooo`80oOgm1P3oool20?gmo@H0oooo0P3moOd60?ooo`80oOgm1P3oool20?gmo@<0
oooo00/0n?Sh0?_kn`3no_h0o_kn0?gmo@3oool0n_[j0?ooo`3no_h0oooo0?Gem@020?ooo`0507Ee
M@0000002@T900<30`39bLT00P3oool0103hn?P0o_kn0?ooo`3lo?`b0?ooo`060?knoP3oool0oooo
0?ooo`3no_h0oOgm0P3oool00`3inOT0oOgm0?ooo`020?clo1H0oooo001@0?ooo`0?0?[jnP3oool0
oooo0?ooo`3no_h0oooo0?clo01kNg/0000000820P030`<0c<c<0?[jnP3oool0mOGe0440oooo0P3n
ool40?ooo`80ooko01/0ookm0?kln`3ono/0oocl0?omo@2YXj<010000;6YYP3Hbl<09R8N06=dN`3]
ool0o?ko0?omo`0^:BT0PH5o07InOP1oQHD0o_[g0?omnP3oooX0n_cg08:3Q`1lNh40O7]n08>3P`3i
nOT00`3oool0101fMWH02@T907QhN024Q8@20?clo00G0?_kn`3oool0QhN707]kN`1mOGd0O7al0?oo
o`2PX:00EEEE0?ooo`1mOGd0NWYj0861P@1kNg/0D51@0000003no_h0oooo07YjNP20P800O7al08>3
P`3kno/00P3oool01P3kno/0Ph>307alO01lO7`0Ph>30?_kn`80oooo00H0no_k08>3P`1lO7`0O7al
08>3P`3kno/20?ooo`060?_kn`23Ph<0O7al07alO023Ph<0no_k0P3oool01P3kno/0Ph>307alO01l
O7`0Ph>30?_kn`80oooo00D0no_k08>3P`1lO7`0QXJ607moO`040?ooo`0?0?gmo@3jn_X0oooo0?_k
n`3oool0n?Sh0;Vi^@0000002PX:0000002=SHd0oooo0?clo03oool0oOgm0080oooo00<0o?cl0?oo
o`3oool0903oool:0?koo`L0oooo00@0o_kn0?_kn`3oool0o_kn103oool00`3emOD0oooo0?ooo`0C
0?ooo`00D@3oool0303hn?P0oooo0?[jnP3oool0nOWi0?ooo`3bl_80<S8b00H61P030`<08R8R0??c
ld<0oooo0P3nool40?ooo`80ooko01X0oO_j0?ono@3ooOd0o_Wi0?oin@3ooOd0^kFe01PB4P040000
FeUJ0>?/k`3gool0o_oo0?klo`061P@0OGin07^0P`1jOH40oogo0?olnP3ooOT0oooj07amP@1nOX@0
P7n207alO080oooo0P3inOT0101dM7@04A4A07emO@1lO7`30?ooo`0F0?Win@1kNg/0PH6107moO`21
PH40oooo0=;BdP0Y:BT0oOgm07YjNP28R8P0NWYj0820P03^k^h020P806UYJ@3oool0O7al0820P01o
Ogl0OGem0?ooo`80o_kn00H0oooo07emO@1oOgl0Ogmo07emO@3oool20?knoP060?ooo`1mOGd0Ogmo
07moO`1mOGd0oooo0P3no_h01P3oool0OGem07moO`1oOgl0OGem0?ooo`80o_kn00H0oooo07emO@1o
Ogl0Ogmo07emO@3oool20?knoP060?ooo`1mOGd0Ogmo07UiN@24Q8@0no_k0P3oool0403moOd0oooo
0?ooo`3oool0o?cl0?ooo`3/k>`030`<0000000410@0CDe=0?clo03oool0no_k0?ooo`3lo?`Y0?oo
o`X0o_oo203oool01P3no_h0o?cl0?knoP3oool0o?cl0?gmoAL0oooo001A0?ooo`030?Win@3moOd0
oooo0080oooo00X0o_kn0?ooo`3IfMT02`/;000000051@D0GUiN0?ooo`3hn?P0o_kn@03oool20?ko
o`@0oooo0P3oo_l01`3ooOd0nOCd0?cgm`3ooOd0ooWi0?olo03ooOd00P3ooOl02@3no_l0o_ok0?oo
nP3oood0n__k00030P3goOd0nooo0?kno`020?olo`050?omnP3oooP0o?oo0?coo`3ko?h00P3oool0
3P3jn_X0oooo0?ooo`3kno/03@d=0?;blP3oool0nOWi0?[jnP3oool0oOgm0?ooo`3inOT0oooo0P3k
no/01@2JVYX0Hf=S0?gmo@3oool0moOg0080oooo00H0o_kn00@410000000h>3P0?ooo`3fm_HZ0?oo
o`030?clo03oool0oooo00@0oooo00/0no_k0?Shn00m?Cd0000000@4100K6a/0k>c/0?ooo`3moOd0
oooo0?knoP030?ooo`030?_kn`3oool0oooo02@0oooo2P3nool90?ooo`070?knoP3oool0oooo0?cl
o03no_h0oooo0?[jnP0E0?ooo`00D03oool01@3moOd0oooo0?ooo`3jn_X0oooo0080oOgm0P3oool0
1@2VYZH00000000000000000Y:BT03`0oooo00<0ooko0?ooo`3oool00P3oool00`3oood0o_oo0?ko
o`060?ooo`0J0?oloP3ooOd0oogo0?omo`3oo_l0o?[k0?omo`3knO`0o?ko0?coo`3lnoH0ooof0?km
n@3nool000H40?_oo`3joOl0ooko0?oio`3onol0ooci0?glm`3nool0n_ko0?koo`3dm?@20?ooo`0:
0?_kn`3oool0no_k03Lg=`2l_;`0oOgm0?ooo`3jn_X0o?cl0?knoP<0oooo00H0oOgm0?ooo`1[Jf/0
PX:20?ooo`3no_h20?ooo`0:0?Win@3oool0000002XZ:P0];Bd0no_k0?ooo`3moOd0oooo0?clnP80
o_kn00H0o?cl0?ooo`3moOd0oOco0?ono`3lo?`20?knoP060?clo03oool0oOgm0?gmo@3oool0o?cl
0P3no_h01P3lo?`0oooo0?gmo@3moOd0oooo0?clo080o_kn00H0o?cl0?ooo`3moOd0oOgm0?ooo`3l
o?`20?knoP050?clo03oool0oOgm0?ooo`3kno/00`3oool00`3moOd0oooo0?knoP020?ooo`0=08>3
P`0000000`<300820P31`L40oooo0?knoP3oool0moOg0?ooo`3kno/0oooo0?knoP0W0?ooo`X0o_oo
2@3oool0103jn_X0oooo0?clo03oool20?knoQH0oooo001H0?ooo`030?gmo@3oool0HV9R00800000
00L03@d=0>7Qh@3inOT0no_k0?ooo`3no_h0o?cl0080oooo00<0o?cl0?ooo`3oool0803oool0203n
o_h0oooo0?ooo`3oool0no_k0?ooo`3kno/0o_co0P3oo_l0103ooOh0ooom0?ooo@3mo_h30?koo`0>
0?cmo`3nool0o_oo0?gnoP3oood0oOgi0?koo@3lo_/0ooko0?cjo@3oood0oOol0?_oo`3jo_l20?ol
o`0=0?omo`3oo_l0n_ko0?WmoP3noOl0oogo0?kmo`3nool0oOgk0?kmn@3oood0o_kn0:FVYP020?ko
o`<0ooko00@0ookm0?ooo@3oool0o_oo0P3oool0503kno/0oooo0?ooo`3oool0oOgm0;>c/`0I6AT0
no_k0?[jnP3lo?`0oooo0?knoP3moOd0oooo0?_kn`3oool0`L7101PH603dm?@0m_Kf0`3oool03@3k
no/0oooo0000003UiND03@d=0:n_[`3moOd0ookm0?[hm`2UYJ40emOE0?gkoP3oo_l00P3nood0103o
o_l0oOco0?koo@3nood20?ono`030?_kn`3oood0oooo01L0oooo00L0o_kn0?ooo`3no_h0o?cl0?oo
o`3kno/0o?cl0080oooo00L0_Kfm0000000410@0000008J6QP3oool0oOgm05d0oooo001I0?ooo`09
0?gmo@3`l?009bLW00H61P000000=cLg0?clo03oool0moOg0080oooo00@0no_k0?gmo@3oool0o_kn
803oool0103moOd0oooo0?knoP3kno/20?ooo`040?Shn03oool0ooko0?gkoP80oO_l0P3oood00`3c
m?@0o_oo0?_loP030?koo`060?cmo@3no_`0oook0?oon`3loo/0mo_h0P3oo_l0203oood0oOgi0?[k
n`3nool0oogo0?olo`3kn_d0n__k0P3lool02P3oo_l0oO[o0?[io03oool0n_[j0?ooo`3jn_X0o_kn
0?ooo`3jn_X80?ooo`050?gmo@3inOT0oooo0?gmo@3inOT00P3oool00`3jn_X08B4Q04=3@`020?oo
o`030?gmo@3oool0oooo0080oooo00@0hN7Q0000002h^;P0nOWi0P3oool20?knoP0E0?ooo`3fm_H0
oooo0?ooo`3lo?`0oooo0?cjn`3ooOd0o?Og07alN01@D4h0b<K90?omo`3jo_/0n_km0?ono`3lnol0
nOgl0?WmnP3oool0ooko01X0oooo00<0oOgm0?clo03oool01@3oool01`3UiND05aLG00<30`010@40
@4100?gmo@3no_h0GP3oool005P0oooo00/0o?cl0?ooo`3oool0a/K600/;2`0000000@4107EeM@3n
o_h0oooo0?Win@020?ooo`030?Win@3oool0oOgm0280oooo0P3moOd01P3oool0nOWi0?ooo`3hn?P0
noWl0?klo`80oooo01X0n?Sf0?ooo@3mo_h0o?gm0?_loP3nool0ooko0?glo`3no_h0ookm0?gln03o
ooX0m?Wb0?coo`3inOl0oogo0?ooo`3ooOX0^[:`00X51`3Vj?80mOco0?Woo`3lood0oooo0?gkoP<0
ooko0P3oool0103clo<0oooo0?ooo`3bl_890?ooo`030?knoP3oool0oooo00@0oooo00h0Xj>S01HF
5P18B4P0:b/[0=WIf@3gmoL0oooo0?clo03gmoL0[Jf]00X:2P3AdM40oooo0?_kn`80oooo00/0mOGe
0?gmo@3oool0o_kn0?Shn03oool0o_kn0?ooo`3oo_l0oogm0?cgm`020?ooo`0<085kN`3Mf=P0n?kn
0?_oo`3oo_l0oogo0?_oo`3jool0oOgm0?ono@3oool0nocl6@3oool0303inOT0oooo0?_kn`3oool0
moOg0?ooo`3fm_H0@d=300D51@0000003`l?0>c/k600oooo001I0?ooo`040?_kn`3moOd0oooo08f=
S@800@4100<000000;Jf]P3oool00P3oool0103jn_X0oooo0?gmo@3moOdP0?ooo`080?[jnP3oool0
oooo0?ooo`3lo?`0oooo0?Shn03oool20?ono`0U0?[jnP3oool0ooom0?gmn`3nool0n__k0?koo`3m
o_l0ooko0?gmo@3oo_d0oook0?[im03nooT0nooj0?_oo`3no?l0o_Wo0?ono`3oo?T0ooGb06MMG03V
k?P0m?oo0?Goo`3gooP0o_ck0?ojo@3ooOl0o_go0?ckoP3oool0n_[j0?ooo`3no_h0oooo0?[jnP0:
0?ooo`80oOgm01@0o?cl0?ooo`3gmoL0Hf=S02DU9@3AdM40o_kn0:NWY`0F5QH06ATI04a<C00_;bl0
1`L702l_;`3Jf]X0o?cl0?[jnP3oool0no_k0?clo0D0oooo00h0nOWi0?ooo`3oool0nOOf0?ojnP3o
oOd0no_k0?ooo`3Rg=X01P410>odm`3jool0oocl0?omo@80nooo00@0oogn0?okn`3oool0o?go603o
ool03`3moOd0o_kn0?ooo`3oool0o_kn0?gmo@3no_h0QhN7000000051@D000000<O7a`3oool0o?cl
0??cl`1N0?ooo`00FP3oool0103inOT0oooo0?ooo`1:BTX20000000701dM7@3WinL0n_[j0?ooo`3l
o?`0o_kn0?gmo@0R0?ooo`0K0?clo03inOT0oooo0?knoP3jn_X0oooo0?Shn03blO@0ooko0?ooo`3h
n?P0ooom0?clnP3knoT0oooo0?ono`3noOl0oogn0?ono`3ooOd0ookk0?ommP3oooP0mOkg0?Ooo`3o
n?l0o_Go0080oogo00L0oo[d0:BFU@2c^/P0kooo0?3oo@3gooL0oook0080ooco00T0o__o0?ono`3o
ool0oooo0?KfmP3kno/0o_kn05]KF`3hn?P0203oool0203fm_H0oooo0?ooo`3lo?`0fm_K02l_;`1H
F5P0moOg0P3oool02@3emOD0o?cl0>KViP2^[Zh0c/k>0?Cdm03no_h0oooo0?gmo@040?ooo`050?Wi
n@3oool0oooo0?knoP3kno/00P3oool04P3lo?`0ookm0?olo03ooOd0oooo0?[jnP3@c<T0BdU806]^
LP3fnOd0o_ck0?omo03hnol0o?oo0?ooo`3mnoX0oooo0?onoaP0oooo00`0moOg0?ooo`3no_h0no_k
0?ooo`3no_h0`<30000000020P800@4107moO`3oool20?clo0030?ooo`3inOT0oooo05`0oooo001H
0?ooo`0@0?KfmP3oool0oOgm0?[jnP3oool0iNGU01/K6`051@D000000451@@3oool0no_k0?ooo`3l
o?`0oooo0?_knb00oooo00D0o_kn0?Win@3oool0oooo0?gmo@020?ooo`0T0>o_k`3oo_l0o_go0?on
o`3moOd0no_i0?ooo@3no_`0ooom0?gmo@3oool0oogn0?ono@3oo?T0oo_g0?onmP3mo_H0k?Sb0?Wo
o`3onOl0oo?o0>k`o@3nool0oo[d0>OGe@1aMhD0i?Go0?;oo`3hooP0oooj0?ojnP3onol0ooco0?on
o`3jn_X0o_kn0P3oool00`3lo?`00@410?ooo`090?ooo`080?Ogm`3moOd0Z:RX01HF5P2NWYh0m_Kf
0?ooo`3no_h50?ooo`030?_kn`3oool0n_[j00@0oooo00D0nOWi0?ooo`3oool0oooo0?Ogm`020?oo
o`0D0?clo03jn_X0oooo0?gmo@3oo_d0mO?b0?omo`3oo_l0YJFS08J6Q039b</0Z:NZ0?cmo@3nool0
n_Wl0?glo`3oool0o_kl0?ooo`3lo?`I0?ooo`0;0?Ogm`3oool0oooo0?gmo@3YjNT07alO00000001
0@40?Shn0?Win@3moOd00P3oool00`3kno/0oooo0?ooo`1L0?ooo`00F@3oool03`3kno/0oooo0?oo
o`3inOT0oooo0;^k^`0000001@D500410@24Q8@0oooo0?_kn`3oool0moOg0?knoP0R0?ooo`0:0?_k
n`3moOd0n?Sh0?ooo`1[Jf/010@40>KUjP3kn_d0mOCg0?ooo`@0ooom01T0o?[k0?ono`3on_`0oogm
0?okn03ooOL0ookf0=WJe00010D09b/b0:ZEX@0;00L0X:Ni0?Goo`3oo?H0ooC_05UKJ03Zm_l0mooo
0?;mm@3looX0oook0?oko`3oo?l0n_Sk00<0oooo00@0n_[j0?ooo`000000no_k203oool02`3lo?`0
n_[j06m_K`0V9RH0aLG50?ooo`3no_h0o?cl0?ooo`3jn_X0oooo0080o?cl0P3oool01@3kno/0oooo
0?ooo`3oool0nOWi00D0oooo00<0no_k0?[jnP3oool00`3oool04@3lo?`0ooom0?ono@3onoT0o?Og
09JJV`1JGUl0oogm07ehNP3Ni^P0nOoo0?omo`3ono/0o_oo0?[no`3oool0oO_l01P0oooo00<0o_kn
0?Shn03oool00P3no_h01@1<C4`0000000H61P0M7Ad0h>3P00D0oooo00<0o?cl0?ooo`3oool0F`3o
ool005T0oooo00<0oOgm0?clo03oool00`3oool01`1hN7P000000000000410@0clo?0?ooo`3jn_X0
8`3oool03@3lo?`0oooo0?ooo`3oool0o?cl0?Shn00000001PD:0>g/k`3oo_l0oooo0?_kn@3no_`0
0P3oood06@3no?d0ooko0?cgm`3oo_/0oogj0?onmP3on?00/:nZ04UAF@3lo_l0=R0S01T53P2h`]L0
hoCo0?omnP3Pem004Q8L0=3FhP3io_l0mogi0?con`3noo/0o_Wk0?omo`3oo_l00`3oool20?knoP03
00410@3oool0oooo00L0oooo00`0g]kN03Hf=P1?Cdl0mOGe0?clo03moOd0oooo0?knoP3moOd0oooo
0?[jnP3oool20?gmo@0=0?ooo`3no_h0oooo0?knoP3jn_X0oooo0?knoP3kno/0o?cl0?ooo`3inOT0
oooo0?clo0030?ooo`0C0?[jnP3oool0ooom0?ckm`3oo?/0oocj05mWJ@2a]kL0oocm09ZDU02f_l80
lOcn0?omo@3oo?X0o?oo0?SnoP3oool0ookm0?ono`0I0?ooo`0;0?clo03oool0QHF5000000030`<0
00000;Fe]@3oool0oOgm0?knoP3moOd0H03oool00600oooo00L0?Cdm00820P0000009RHV0>k^kP3o
ool0o?cl0080oooo00H0no_k0?ooo`3oool0no_k0?ooo`3moOdI0?ooo`80oOgm00<0oooo0?gmo@3j
n_X00P3oool06`2/[:`010<8018A503Mg=l0o_kn0?ooo@3knoT0ooom0?kno03ln_/0ooko0?kin@3o
o_/0oogj0?onmP3ooOD0fmOD00/>7@3jn?l0onoZ01/;2@35eNX0kOoo0?Ogm@3oo_H0o_go0??fo@02
0?ono`050?oon`3lo_T0oooo0?_kn`3oool00P3lo?`0103no_h0oooo05MGE`2SXj<40?ooo`0<0?Sh
n03oool0oooo0?clo02a/K404A4A09RHV03inOT0oooo0?knoP3oool0oOgm6@3oool04@3knoT0oook
0?oknP2TWY`04a/M0<C:bP3oo?d0HUaL0<K?dP3`nod0oogm0?oim`3lool0nooo0?[jnP3oo_d0ooko
0100oooo00H0nOWi0?ooo`3oool0o?cl0?ooo`3no_h40?ooo`050;no_`092@T00P820000001fMWH0
I@3oool00600oooo00/0f][J00`<300;2`/0000005QHF03oool0o_kn0?clo03kno/0oOgm0?clo002
0?ooo`80oOgm6`3oool02`3no_h0oooo0?ooo`3kno/0oOgm0?knoP0c<SL0000201PG6P3@d=00no_i
0080o_kl01X0ooom0?ono`3ln_/0oogo0?omo@3ooOX0nOC^0?onmP3bkNd07Q/^0=K?g`3onNd0Vi>8
08FI[`3UoOl0o_oo0?omm`3lo_/0oOko0?olo`3onol0oOSh0?gln03lood0nooo0?Ohn080oooo00L0
UiNG00410@0=3@d0oooo0?gmo@3oool0o?cl0080oooo00/0oOgm0?Win@1gMgL0820P0<W9b@3dm?@0
oooo0?_kn`3lo?`0oooo0?gmo@0I0?ooo`0@0?kno03oo_d0oo[h0?olo03ho?d0o?oo0?omo@3ooOl0
koOi0?Woo`3ooOl0o?Kf0?koo`3lool0o?cl0?onoa80oooo00X0o_kn0?ooo`3no_h0no_k0?ooo`3m
oOd0oooo0?clo03clo<08b<S0P0000000`0o?cl0no_k0?ooo`1T0?ooo`00H@3oool01@2QXJ400000
00D51@030`<0XZ:R00@0oooo00H0oOgm0?knoP3oool0o_kn0?ooo`3lo?`H0?ooo`050?clo03kno/0
oooo0?knoP3lo?`00P3no_h0:03oool0gMcQ00d<3`0000801@D50:b/ZP3oood0no_i0?ooo@3jn_X0
oooo0?ono`3knOP0ookk0?onnP3oo_H0ooco0<RneP0A1AL0ooSV08f>O00X?E00kOoo0?kno`3ekn`0
n_oh0?coo@3onol0oo?o0?ojo`3onOL0noom0?GonP3lool0]kNg01LG5`0<30`02@T90??cl`3oool2
0?gmo@070?ooo`3jn_X0oooo0>7Qh@0m?Cd0@d=30>o_k`030?ooo`030?gmo@3oool0oooo0080o?cl
603oool20?ono@040?omo`3mno`0ooom0?gmn`80o_go0P3nool20?glo`030?ooo`3oood0oOgm0140
oooo00<0o?cl0?ooo`3oool00P3oool02P3hn?P0m?Cd0?ooo`3oool0o_kn04I6AP010@400`<301HF
5P3Ti>AV0?ooo`00H03oool02@3lo?`0oooo06ATI00000000`<300L71`3Cdm<0oooo0?gmo@020?oo
o`050?gmo@3no_h0oooo0?ooo`3lo?`06P3oool00`3no_h0oooo0?ooo`020?ooo`0:0?Ogm`3oo_l0
BTU<00X:2P0000002`/9051@CP3^k^`0oooo0?glo`80ooko01X0nOOh0?cgm`3nn_L0oooh0?olo`3o
lol0a[W:06ERC`1UK5P0<TED0>3ao`3knol0ookk0?_on03iooT0ooco0?ojo`3om_/0oogk0?Cmn02M
Yj808RHU00@4100000008R8R0?gmo@80oooo00d0oOgm0?ooo`3no_h0oooo0;Zj^P0D51@0Ph>30?oo
o`3inOT0n?Sh0?[jnP3no_h0oooo0080o_kn6@3oool01`3oo_d0oogm0?ghn03inOT0oooo0?gimP3n
o?/00P3lool0203no?/0noWh0?[mo`3lool0oooo0?omo03no_h0ooko4@3oool0103moOd0n_[j0?oo
o`3kno/20?ooo`040?7al@3oool0TI6A00<30`80000000<0][Jf0?Win@3oool0I@3oool00680oooo
00X0lo?c02TY:@000000000003@d=03fm_H0oooo0?[jnP3no_h0oooo0P3lo?`00`3no_h0oooo0?oo
o`0G0?ooo`0;0?gmo@3oool0n?Sh0?_kn`3oool0moOg0?Win@3oool0o_co0=GCeP0:2PX00P000000
6`0820H05AHF09jOW`3nool0oOko0?ckoP3oool0ookm0?oon`3kn_D0ooco0?oio`3omOl0no_^0?_o
m03cool0mOoo0?clo`3oood0n_oi0?_onP3mn_l0o_Cm0;R[/01CCDd03Q@@008;1P030000000<0?cl
o03kno/0o?cl055AD@3oool0oOgm0?ooo`1iNGT06QXJ0<G5a@3oool0no_k1@3oool00`3lo?`0oOgm
0?ooo`0H0?ooo`030?ono@3mn?P0oogm0080oooo00H0o_Sf0?omo@3io_l0m__n0?omo@3ono/20?_o
o`040?_inP3nnOT0oooo0?kooa40oooo00h0n_[j0?ooo`3oool0oOgm0?ooo`3moOd0oooo0<_;b`00
00000`<30000001iNGT0oooo0?gmoFH0oooo001P0?ooo`080?gmo@3oool0n_[j0=OGe`0>3Ph00000
00P8201[Jf/20?ooo`050?[jnP3oool0oooo0?ooo`3kno/06P3oool00`3jn_X0oooo0?ooo`020?kn
oP070?ooo`3gmoL0ooko0?klo`19BDT0000000D50`020000000G00<4100;30h0P8630?ono`3mo?l0
o?cl0?WgmP3ooo/0e]7C09J>V`3onol0oooh0>cbj01aN800mOgo0?coo`3jnod0EEYD02@Y8`0?3Q40
2@<:01H?4P0300000P000@003`051PH08R8R0>[ZjP3inOT0o_kn0?ooo`030`<0oooo0>SXj010@400
@D510>WYj@3oool0n?Sh0?knoP020?ooo`040?[jnP3lo?`0oooo0?ooo`80oOgm603oool01`3oo_l0
oogm0?ghn03kno/0oooo0?omo@3ono/00P3kool0203oo_l0oogo0?_oo`3kool0o?cl0?ono@3oool0
oOkn403oool00`3kno/0oooo0?ooo`030?ooo`0:0?Shn03]kNd09BDU0000000410@0?clo0?3`l03l
o?`0oooo0?knoVD0oooo001T0?ooo`0808^;R`0410@0000000410@2YZJT0oooo0?[jnP3no_h20?oo
o`030?knoP3oool0oooo01L0oooo00D0TI6A00820P0`<300[Zj^0?clo0020?ooo`070?knoP3knO`0
ooko0:BRX`0=2``00@4000@40P0202<T900>01@E5`0000@0@D960?koo`3mo_h0ooom0?gmn@3oood0
EE9H0=SEf`3jmOL0R8J70:j]/P3hnol20?Woo`0607MiMP0h>3H05QDH00000P082@T00@820P030000
0`0D4Q<0jn_[0?ooo`020?ooo`080?Shn0061PH0]kNg01LG5`20P800oooo0?clo03no_h20?ooo`08
0?_kn`3oool0oooo0?knoP3oool0oOgm0?_kn`3no_hH0?ooo`0A0?ono`3ono/0oogm0?oon`3jn_P0
ooko0?gkoP3bm_<0noon0?glo`3lnol0n_km0?coo@3oool0ooko0?ooo`3moOd0403oool01@3lo?`0
oooo0?;blP3oool0moOg0080oooo00P0EEEE00820P0000003@d=0=gMg@3oool0o_kn0?_knfH0oooo
001P0?ooo`80o_kn0P3oool02P3moOd0DU9B00@4100000005aLG0>CTi03moOd0oooo0?clo03kno/C
0?ooo`050?ooo@3ooo/0oook0?ooo@3oool00P3nool0203mnoh0XInR0=_Kf@3alNl0nocl0?koo`3m
oOd0o_cm0P3oo_l05`3knOX01P@50000001@D4h092DU0>o`l03in_`0o_oo0?Cen@3fmoT0o_oo0?gn
oP3oood0o?cj0>KWj@18AdX0dL_B05UDF03oo_l0o_oo0?CloP3iool0o_oo0080nOWi01<0`lC601HJ
6@061`L00`0000l92@38a/L0o?cl0?ooo`3lo?`0oooo0?knoP0000006a/K0<30`03moOd0no_k0?oo
o`3kno/0oOgm0080oooo00@0no_k0?ooo`3oool0o?cl0`3oool00`3moOd0oooo0?ooo`0F0?ooo`06
0?ono@3knOP0o_kj0?ooo@3hm_T0ooko0P3nood20?ono`060?cnn`3nood0ooko0?glo`3lo?`0ooom
4@3oool00`3kno/0oooo0?[jnP020?ooo`0:092@T0020P80000000<30`2/[:`0o_kn0?ooo`3lo?`0
oooo0?WinFD0oooo001Q0?ooo`090?Win@3oool0oooo0?ooo`3]kNd071`L00820P000000?Shn00<0
oooo00<0oOgm0?clo03oool0403oool0<P3moOd0oook0?ojl03oo_@0oook0?Ohn03lool0noko0?kh
o`3onol0U9>?0=KHd`3kool0o?oo0?[hn`3ooOl0ooko0?ooo`3lo?`0ADE500/;2`2_[jl0JVYZ04a<
C03kno/0oooo0?ckoP3oool0o?cl0?ooo`3kno/0oooo0?clo02[Zj/00P030>WWj03oool0n_[j0?ko
o`3ko?`0oooo0?Shn02HV9P05ADE08N8R00:2PX040h?06YXJ@3no_h0oOgm0P3oool0103[jn/0@d=3
02`/;03Shn<Z0?ooo`030?ooo@3oool0oooo00<0oooo0P3oo_lF0?ooo`80oOgm00D0oooo0?knoP3m
oOd0d];B00T92@020000000306YZJP3oool0oooo0080o_kn00<0oooo0?knoP3oool0I03oool00640
oooo00/0o_kn0?ooo`3inOT0o?cl0?ooo`2l_;`00@4100820P030`<0PX:20?gmo@0D0?ooo`0P0?ko
o`3noOP0ooca0?oci@3lnO80o?oo0?Cmo`3ioOl0oo_o0?ogo`3ln?D0LG=^0>Kbl03hool0ooko0?gf
n`3ln_/0o?cl0?ooo`23Ph<000000=SHf03jn_X0?Cdm08F5Q@3lo?`0oooo0?gmo@3oool0n_[j0?oo
o`3moOd20?ooo`0E0=CDe03lo?`0o_kn0?_kn`3lo?`0oooo0>g]k@1@D500>CTi0=OGe`2l_;`01PH6
024Q8@3oool0oOgm0?ooo`3no_h0_Kfm018B4P21PH40no_k04/0oooo00T0mOGe0?ooo`3alO40:RXZ
000000030`<0<C4a0?knoP3kno/00P3oool00`3moOd0oooo0?knoP1U0?ooo`00H03oool01@3moOd0
o_kn0?ooo`3oool0nOWi0080oooo00T0OWin0000000000001@D50<O7a`3oool0oOgm0?ooo`3jn_X0
3`3oool04P3nool0nOoo0?cln02RSXD04@0007UdJP2?V9<000TA0<cEh03omod0k=WK0?oko022QXD0
Zknm0>WknP3onol0oo[o0?omo`80oooo00X0YZJV00820P3oool0oOgm0>OWi`0I6AT0^[Zj0?clo03o
ool0oOgm0`3oool00`3moOd0oooo0?ooo`020?ooo`0:0?knoP3moOd0`/;2020P801bLW80l?3`0?cl
o02`/;0000000:>SX`80o_kn00L0oooo08B4Q00M7Ad0_Kfm0?Win@3oool0nOWi04P0oooo00D0n_[j
0?ooo`3oool0no_k05mOG`0200000006018B4P3GemL0oooo0?clo03oool0moOg0P3oool00`3moOd0
oooo0?ooo`1S0?ooo`00H03oool00`3kno/0oooo0?Shn0020?ooo`040?_kn`3fm_H0oooo04M7A`80
000000@09bLW0>[ZjP3no_h0oOgm403oool0703nool0mOgk0?gmn@1D@CX0d[je0>gYg@001000BEMP
0<WBg`3onol0d<31034X:`093@h0fNcX0?Coo`3ooOl0oo_o0?kin`3oool0o?cl0?;blP28R8P0nOWi
0?ooo`3lo?`0`/;2018B4P3Kfm/20?ooo`80o_kn0P3oool02@3hn?P0oooo0?_kn`3oool0no_k08Z:
RP0K6a/0/;2`0?clo0020?ooo`0907UiN@0410@0oooo0?[jnP3/k>`0ADE503Lg=`3Ti>@0o?cl04d0
oooo00<0nOWi09ZJVP0:2PX00P0000001P2RXZ80oooo0?ooo`3oool0m_Kf0?ooo`80oOgmIP3oool0
0600oooo00d0oOgm0?ooo`3kno/0no_k0?ooo`3inOT0o_kn0?ooo`3Kfm/0410@00D51@000000E5AD
0080oooo00<0o?cl0?ooo`3oool03P3oool0303oood0ookk08ElM`2KTX/0oO[_0<73_@0;3aP0m?Ko
0?[go@3km?L0ooko0?cmo`80nOok00<0noSn0?olo`3oo_l00P3oool02P3hn?P0oOgm0?ooo`3lo?`0
oOgm0?ooo`2OWil09bLW0?Cdm03lo?`20?ooo`80oOgm00L0oooo0?gmo@3jn_X0j>SX04M7A`0f=SH0
gmoO0080oooo00P0m_Kf0?ooo`3;bl/0eMGE0?ooo`38b<P07alO07QhN0<0oooo00<0no_k059BDP3o
ool0B03oool0103kno/0o?cl0=OGe`0<30`20000000406a/K03oool0no_k0?clo080oooo00@0nOWi
0?_kn`3oool0oOgmI@3oool00640oooo00h0o_kn0?ooo`3lo?`0oooo0?gmo@3oool0nOWi0?ooo`2`
/;00000000@410000000W9bL0?gmoA40oooo00P0o_cm0?chm@3<aKd050l50?oomP3moOT07AdU0=oN
j`80ooko00T0oooo0?WjnP3koo`0n_kk0?ono`3nnol0ooko0?_kn`3inOT00`3oool0203inOT0oooo
0?Gem@3oool0GUiN05QHF03oool0m_Kf0P3oool20?gmo@040?ooo`2b/[804a<C07moO`<0oooo00<0
oOgm0?ooo`3oool00P3oool00`2@T9005ADE0;6a/@020?_kn`80n_[j00<0oooo0000003oool0B03o
ool01`3jn_X0o?cl02TY:@00000020P802LW9`3emOD00P3oool01P3fm_H0o_kn0?ooo`3moOd0oooo
0?clo6H0oooo001Q0?ooo`0>0?_kn`3oool0oooo0?gmo@3no_h0n?Sh0?ooo`3inOT0oooo06ATI000
00001PH600L71`3De=@@0?ooo`80ooko0100ookm0?onk`1TGD/0RHF10?cmo`14B5<0Wj6]0?omo`3n
nO/0oooj0?cnn@3iool0nooo0?[hn@3ooOd0oogn0P3oool01@3jn_X0n?Sh0?ooo`3lo?`0no_k00<0
oooo00@0;Rh^08^;R`3oool0no_k0P3moOd03`3kno/0IfMW02DU9@32`/80no_k0?ooo`3gmoL0oooo
0?clo03oool0o_kn0?;blP1@D500;bl_0>3Ph0030?ooo`050?gmo@3oool0oooo00410@3no_h0B@3o
ool0201GEeL00@4100@4100:2PX0f=SH0?gmo@3oool0nOWi103oool00`3lo?`0oooo0?Ogm`1U0?oo
o`00H03oool0103no_h0oooo0?knoP3hn?P30?ooo`090?Win@3oool0oOgm0?clo00_;bl0000000<3
0`0Y:BT0m_Kf00l0oooo0P3oo_l05@3jmOD0oo_/0?ook@27Ph00KFec02hb>`26R980noOo0?olo`3o
ooX0nO_e0?Soo`3kool0oO_l0?okn`3ooOh0oooo0?_kn`3moOd0oooo0?gmo@030?ooo`050?Gem@3o
ool0i^KV01HF5P2h^;P00P3oool03P3Ng]h0<30`05ADE03YjNT0o?cl0?ooo`3lo?`0oooo0?gmo@3o
ool0o?cl0<k>cP0M7Ad0Kfm_0P3lo?`0203oool0nOWi0?ooo`3oool0oOgm0?Win@071`L0o?clB03o
ool0202OWil01`L7000000000000WIfM0?clo03oool0o?cl0P3oool01@3jn_X0oooo0?clo03oool0
o?cl06H0oooo001Z0?ooo`0=0?_kn`3De=@01`L700<30`000000J6QX0?Ogm`3oool0nOWi0?ooo`3k
no/0oooo0?gmo@090?ooo`060?omo`3ooOd0ookf0?ollP3oo_/0oOco0P3lool20?olo`040?ono@3n
ooX0o?om0?coo`80ooko2@3oool02P3moOd0oooo0?clo030`<006ATI0=kNgP2SXj<05aLG09JFUP3n
o_h20?ooo`0=0?gmo@3oool0oOgm0?ooo`3no_h0UIFE01@D502^[Zh0n_[j0?ooo`3lo?`0o_kn0?oo
o`020?gmo@030?ooo`3no_h0YZJV0480oooo00/0m_Kf0?ooo`3kno/0oooo0?knoP3oool0e=CD00X:
2P020P800@4105aLG0020?ooo`030?clo03oool0oooo06`0oooo001X0?ooo`0<0?_kn`3inOT0oooo
0?ooo`2EUID0000000410@061PH0];Bd0?Win@3oool0o_kn0`3oool00`3inOT0oooo0?ooo`060?oo
o`080?ono`3km_H0VY:=0=G>aP3oo?T0oooo0<K9c@2CUYd20?olo`040?ono@3noo/0o?om0?coo`80
ooko2P3oool01`3inOT0oooo0?gmo@2f][H0Cdm?02/[:`39bLT00P3oool00`3inOT0oooo0?_kn`02
0?ooo`050>k^kP1KFe/0;2`/0=[JfP3moOd00`3oool0203jn_X0oooo0?[jnP3oool0n_[j0?knoP3o
ool0n_[j@03oool0203lo?`0oooo0?ooo`3moOd0o_kn0?ooo`3fm_H0<S8b0P0000001@0];Bd0nOWi
0?KfmP3oool0oOgm06h0oooo001Z0?ooo`040?_kn`3oool0oOgm05IFEP80000000H0410@0>WYj@3o
ool0oOgm0?ooo`3kno/90?ooo`80ooko00/0oogo0??Zh@15?C80m_?/0?Cem@0X:cX0k>gm0?omo`3o
oO/0oogm0?koo`020?Woo`030?ono`3ooOd0ooko00L0oooo00X0oOgm0?ooo`3lo?`0oooo0?knoP3o
ool0/;2`0?;blP3oool0oOgm0P3oool01`3fm_H0n_[j0?ooo`3<c<`092@T06YZJP3`l?000`3oool0
0`3lo?`0oooo0?ooo`020?ooo`040??cl`3oool0oooo0?;blT80oooo00L0n_[j0?ooo`3oool0oooo
0?gmo@1YJFT00000008020P800H0dM7A0?ooo`3oool0l_;b0?ooo`3lo?a]0?ooo`00J@3oool02`3m
oOd0oooo0?[jnP3moOd0lo?c01dM7@092@T0000003`l?03inOT0no_k0080oooo00<0m_Kf0?ooo`3o
ool01P3oool03@3oo_l0o?Wo0?omo`3on_80ZZJJ0:JSVP2=SHd0[:Zm0?gko`3oo_l0oooj0?ono@3n
ool00P3lool00`3oo_l0ookm0?ooo`080?ooo`80o_kn00D0oooo0?clo03oool0oooo0?knoP020?oo
o`070?_kn`3oool0oooo0?ooo`2KVi/04a<C0:NWY`020?ooo`0<0?gmo@3kno/0oooo0?ooo`3jn_X0
o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[jA03oool0103kno/0o_kn0:f][@051@D20000000409RH
V03oool0oooo0?Ogm`80oooo00<0oOgm0?ooo`3oool0J`3oool006P0oooo00d0o_kn0?_kn`3oool0
no_k0?ooo`3lo?`0b<S8000000051@D00P8207moO`3oool0n_[j0080oooo00<0m_Kf0?ooo`3oool0
1@3oool01`3oo_l0oo_o0?gfn@3gnO@0o?oh02TY7`17@D400P3onOl0103lool0nOoo0?coo`3oo_l2
0?omo@030?koo`3lool0o_oo00L0oooo01<0oOgm0?ooo`3oool0oooo0?_kn`3lo?`0oooo0?[jnP3n
o_h0oooo0?[jnP3no_h0m?Cd05YJFP0U9BD0f=SH0?_kn`3lo?`0oooo0080oOgm00<0oooo0?_kn`3o
ool00`3oool01@3fm_H0no_k0?knoP1KFe/0n?Sh0400oooo00/0n?Sh0?ooo`3oool0oooo0=cLg005
1@D0000000410@1JFUX0oooo0?clo01b0?ooo`00J@3oool0103lo?`0o_kn0?ooo`3clo<20?ooo`08
0861P@000000000000D51@3:b/X0oooo0?clo03no_h80?ooo`0=0?omo`3onOl0ooco0?kon`3jooH0
gmkI0?C]l03olol0oo[o0?_oo`3hool0o?oo0?ooo`020?olo@030?koo`3kool0o_oo00T0oooo00D0
no_k0?clo03oool0oooo0?Win@020?ooo`060?[jnP3oool0d];B02/[:`1OGel0n_[j0`3oool01@3k
no/0oOgm0?ooo`3oool0n?Sh0080oooo00H0n_[j0?knoP3oool0oooo0?clo0010@530?ooo`070?kn
oP3dm?@0<c<c00H61P00000092@T0>c/k0020?ooo`040?Shn03oool0nOWi0?gmoFh0oooo001X0?oo
o`030?gmo@3oool0n_[j0080oooo00/0o_kn0?ooo`3lo?`0@D5100/;2`00000071`L0>OWi`3no_h0
oooo0?clo0070?ooo`0=0?ono`3nn?l0oo[o0?oomP3ooO80ookm0?omo`3oo?l0noWo0?omo`3nool0
ooom0?oon`020?ono`030?ooo`3oood0oooo00L0oooo00@0oOgm0?ooo`3oool0n_[j0`3oool01`3f
m_H0oooo0?clo02TY:@04a<C09fMW@3oool00P3moOd20?ooo`040?Win@3oool0oOgm0?Shn080oooo
00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_knd00oooo00@0n?Sh0?ooo`3no_h0KFe]0P00
000010071`L0bl_;0?ooo`3emOD30?ooo`030?gmo@3oool0o?cl06d0oooo00120?ooo`80ooom0P3o
o_l40?ooo`80ooko00@0oooo0?ooo@3oo_l0ooko6@3oool02@3moOd0oooo0?knoP3no_h0oooo0?gm
o@3oool0h^;R01LG5`0200000003051@D03oool0oOgm00P0oooo00d0ooko0?omo`3no?l0ookf0?oj
lP3oo_l0o?_o0?kno`3lo?l0ooco0?omo`3ooo/0o_ok0080o?oo00<0oooo0?ono@3oool0203oool0
0`3jn_X0oooo0?ooo`020?ooo`080?clo03oool0m?Cd06a/K00P8200e]KF0?ooo`3jn_X30?ooo`03
0?knoP3oool0oooo0080oooo00<0oOgm0?clo03oool00`3oool20?knoP0300410@3oool0oooo0400
oooo00<0o?cl0:n_[`0000000P0000000`2BTY80oooo0?Win@030?ooo`030?gmo@3oool0o?cl06h0
oooo00100?ooo`80ooko0P3ooo/20?ono`040?ooo`3oood0o_om0?koo`80o_ko00<0o_om0?kon`3o
o_l00P3oo_lP0?ooo`090;Ng]`0000000@410000002EUID0oooo0?[jnP3oool0m_Kf0080oooo00H0
o?cl0?knoP3oool0oooo0?ono`3oool20?oon`030?ooo`3oo_l0ooko00<0ooko0P3oood20?koo`@0
oooo0P3no_h20?ooo`030?_kn`3oool0no_k00<0oooo00L0no_k0?clo03oool0f][J030`<01<C4`0
no_k0080oooo00<0no_k0?clo03oool0203oool01`3no_h0oooo0?gmo@3moOd0oooo0?knoP2VYZH0
>P3oool0103jn_X0oooo0?ooo`3jn_X30?ooo`030?gmo@3Ph>00410@0080000000<0FEUI0?gmo@3n
o_h0M@3oool00400oooo0P3oo_l0203oooX0oook0?ono`3oo_l0ooom0?oon`3nood0o_oo0P3no_l2
0?kon`<0ooko803oool0203inOT0JVYZ00H61P0000002@T90=3@d03oool0oOgm0P3oool01@3gmoL0
oooo0?_kn`3oool0oOgm0100oooo00D0oOgm0?ooo`3oool0oOgm0?Shn0030?ooo`040?knoP3oool0
oooo0?gmo@80oooo00H0Y:BT014A4@2HV9P0oooo0?Win@3jn_X30?ooo`030?_kn`3oool0oooo00H0
oooo00P0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnSP0oooo00l0o?cl0?ooo`3jn_X0n_[j
0?ooo`3jn_X0oooo0?knoP3lo?`0=cLg0000000410@09BDU0>OWi`3kno/0MP3oool00400oooo0P3o
o_l02P3ooo/0ooom0?ono`3oo_l0oook0?oonP3oool0ooko0?omo`3oo_l20?oonP<0ooko7`3oool0
3`3inOT0oooo0?Ogm`0`<3000`<300@4100V9RH0moOg0?clo03oool0n_[j0?ooo`3moOd0oooo0?kn
oP0B0?ooo`030?[jnP3lo?`0oooo00<0oooo0100nOWi0?ooo`3oool0oooo0?KfmP3jn_X0J6QX024Q
8@3De=@0o?cl0?ooo`3lo?`0oooo0?Win@3oool0oOgm303oool0103clo<0oooo0?ooo`3bl_8i0?oo
o`030?gmo@3lo?`0oooo0080oooo00P0o?cl0?ooo`3no_h0M7Ad00820P0000002@T90<C4a080oooo
00<0o?cl0?ooo`3oool0L`3oool00480oooo00X0ooom0?ooo`3oo_l0ooko0?oon`3oooX0oooo0?on
o`3ooOl0ooko0P3oooP30?onoal0oooo00D0o_kn0?ooo`3oool0d];B01<C4`020000000406=SH`3o
ool0oooo0?clo080oooo00<0no_k0?ooo`3no_h0503oool0103no_h0n_[j0?ooo`3oool20?clo008
0?knoP3Vi^H0=SHf04i>CP3]kNd0o_kn0?ooo`3emOD30?ooo`030?gmo@3oool0o_kn00P0oooo00L0
o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[j03T0oooo00`0no_k0?ooo`3oool0oOgm0?knoP3oool0
o_kn0;:b/P0000000P8200410@2:RXX20?ooo`030?knoP3oool0oooo07@0oooo00100?ooo`030?oo
o@3oool0ooko0080ooko00<0oooo0?oonP3oooP0103oo_l20?oomP030?ono`3ooOl0ooko0240oooo
00P0nOWi0?ooo`2BTY80000000<30`0410@0[Zj^0?clo080oooo00@0mOGe0?ooo`3oool0oOgm403o
ool0103clo<0oooo0?clo03kno/60?ooo`0;0;Fe]@0@4100SHf=0?ooo`3no_h0oooo0?[jnP3oool0
oOgm0?ooo`3no_h00P3oool00`3kno/0oooo0?ooo`090?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P0
>P3oool01P3hn?P0oooo0?ooo`3inOT0hn?S01PH6080000000@0BTY:0?ooo`3oool0oOgmM`3oool0
0400oooo00<0o_om0?koo`3oo_l00P3oo_l00`3oool0oooh0?oon0030?ono`060?ooo`3ooo@0oood
0?ono`3ooOl0ooko803oool01@3no_h0oooo0?[jnP3oool0IVIV0080000000H0410@0=oOg`3moOd0
oOgm0?ooo`3inOTD0?ooo`040?gmo@3oool0oooo0?clo0<0oooo00`0KFe]01`L703;bl/0n_[j0?kn
oP3oool0n_[j0?ooo`3gmoL0o?cl0?ooo`3gmoL<0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@41
>P3oool03`3lo?`0oooo0?ooo`3moOd0oooo03Lg=`00000010@401lO7`3YjNT0oooo0?Ogm`3moOd0
oooo0?[jnP1e0?ooo`00?`3oool00`3oood0o_ok0?koo@020?kno`050?ono`3oood0oooh0?oon03o
o_l00P3ooOl0103oo_d0oood0?oom03oool20?onoal0oooo00<0o?cl0?ooo`3oool00P3oool01@3Z
j^X08B4Q00@410000000>SXj0080oooo00@0o?cl0?ooo`3oool0no_k403oool00`3jn_X0oOgm0?[j
nP040?ooo`040>3Ph00f=SH0BTY:0>k^kPD0oooo00P0no_k0?ooo`3oool0no_k0?ooo`3moOd0oooo
0?clo0P0oooo00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_kncP0oooo00/0o?cl0?_kn`3o
ool0n?Sh0?ooo`1fMWH010@400410@0410@0`<300?ooo`020?gmo@030?ooo`3inOT0oooo07D0oooo
000o0?ooo`030?ooo@3noo/0o_om0080o_ko00@0ooko0?oon`3oooP0oooj0P3ooOl01P3oo_l0ookm
0?oomP3oooH0oooo0?onob00oooo00`0o_kn0?ooo`3moOd0o_kn0?ooo`3jn_X0clo?00820P010@40
000007UiN@3moOd20?ooo`030?Shn03oool0oooo01D0oooo00<0/K6a01PH602:RXX00P3oool0103n
o_h0oooo0?_kn`3oool20?gmo@060?ooo`3lo?`0oooo0?gmo@3no_h0o?cl3@3oool20?knoP030041
0@3oool0oooo03T0oooo00@0oOgm0?_kn`31`L400P820P0000000`24Q8@0oooo0?Win@030?ooo`03
0?_kn`3oool0oooo07@0oooo000o0?ooo`0A0?ooo@3mooX0o?oo0?ShoP3lo?l0oooo0?gmn@3oooX0
oook0?olo`3nnol0ooko0?Whm03oooP0oooj0?clo03nool0803oool0203inOT0oooo0?[jnP3oool0
no_k0?ooo`3gmoL0SHf=0P0000001@092@T0_[jn0?gmo@3oool0n?Sh0080oooo00@0o_kn0?_kn`3n
o_h0oOgm0P3oool00`3hn?P0oooo0?ooo`020?ooo`030?_kn`3oool0n_[j0080oooo00L0mOGe0?oo
o`3oool0no_k07IfMP0N7Qh0a<C401P0oooo00L0o_kn0?ooo`3moOd0oOgm0?ooo`3no_h0YZJV0340
oooo00@0oOgm0?ooo`3oool0nOWi103oool20?knoP060?ooo`3UiND051@D000000010@40BDU9O@3o
ool00400oooo0100o_om0?Kjn@3no_l0o_ko0?ooo@3ooo/0no[f0?kln`3oo_l0oogo0?Wgn03oood0
nOWe0?koo@3nool0oOko8@3oool03`3no_h0moOg0?ooo`3oool0oOgm0?ooo`3fm_H0C4a<00<30`00
000051@D0?3`l03gmoL0oooo0?_kn`050?ooo`050?clo03moOd0oooo0?ooo`3lo?`00P3oool01@3k
no/0oooo0?ooo`3inOT0o_kn0080oooo00D0hn?S03Xj>P1:BTX0jn_[0?clo00H0?ooo`080?[jnP3o
ool0n_[j0?ooo`3jn_X0o_kn0?ooo`3jn_Xa0?ooo`070?gmo@3oool0oooo0?ooo`3no_h0no_k0?gm
o@020?ooo`060?Cdm012@T8020P80000000G5aL0inOWO@3oool00400oooo00H0o_om0?cmo@3oo_l0
oOco0?Sfm@3oo_X20?omo`080?gkoP3no?l0ooom0?ooo@3oo_l0o_oo0?gno`3noolQ0?ooo`090?gm
o@3oool0oooo0?ooo`3moOd0n?Sh0?ooo`3QhN405QHF0080000000H0EEEE0?gmo@3no_h0oooo0?kn
oP3moOd20?[jnP80oooo00<0no_k0?ooo`3moOd00P3oool0303kno/0oooo0?knoP3no_h0oooo0?gm
o@3oool0^k^k01HF5P26QXH0n?Sh0?knoQ`0oooo00@0lo?c0?ooo`3oool0l_;b<P3oool02P3kno/0
oooo0?ooo`3moOd0oooo0?knoP3oool0moOg0?ooo`26QXH20000000300410@38b<P0n_[j07d0oooo
00100?ooo`80o_oo00H0m?Cd0?ooo`3ooo/0oO_j0?olo`3lm_h20?ono`070?Ogl`3clo<0o_ko0?Wk
o`3lool0n?ck0?koo`0O0?ooo`0>0?knoP3oool0oooo0?Shn03no_h0oooo0?[jnP3oool0oOgm0;bl
_0010@401@D50000002ATI450?ooo`0C0?gmo@3no_h0oooo0?gmo@3no_h0oOgm0?ooo`3kno/0oOgm
0?ooo`3inOT0oooo0?Gem@3oool0O7al01LG5`32`/80oOgm0?ooo`020?clo1P0oooo00L0o?cl0?oo
o`3jn_X0oooo0?knoP3oool0n_[j03@0oooo00@0oOgm0?clo03oool0oOgm0P3oool01P2m_Kd00000
00L71`000000PX:20?clo7h0oooo00100?ooo`0A0?Shn03oool0ookm0?ckm`3oo?P0oogm0?oio`3o
nol0ooco0?kmn@3ooo/0E5EG0?7bo`3ko_l0nooo0?Omn@3nool07`3oool01P3moOd0o_kn0?ooo`3o
ool0o_kn0?gmo@<0oooo00H0o?cl07EeM@000000000000@4103EeMD20?clo0090?Win@3oool0oooo
0?clo03moOd0oooo0?knoP3oool0o?cl00<0oooo00X0o?cl0?ooo`3_knl0@T9203Xj>P3YjNT0oooo
0?[jnP3kno/0o_kn703oool01@3fm_H0no_k0?knoP1KFe/0n?Sh0300oooo00<0o?cl0?ooo`3oool0
0P3oool20?gmo@030?ooo`3WinL061PH0080000000<0@d=30?Shn03oool0OP3oool00400oooo0140
ooko0?ooo`3jnOD0oooh0=OCc`2IU9H0Z:6`0=WBh@3ooOl0`;nj0:FVX00B4aL0V9R^0?3eo`3anO/0
nook0?koo@0O0?ooo`030?_kn`3no_h0oooo0080oooo00<0n_[j0?ooo`3fm_H00P3oool0303clo<0
>CTi00410@0000008B4Q0?Cdm03oool0o?cl0?Ogm`3oool0o_kn0?_kn`@0oooo00X0no_k0?ooo`3o
ool0oooo0;fm_@0I6AT0P8200?knoP3oool0nOWi0P3oool00`3no_h0oOgm0?ooo`0H0?ooo`060?[j
nP3no_h0oooo0?ooo`3lo?`00@41=P3oool0103moOd0oooo0?KfmP16ATH20000000301<C4`3/k>`0
oooo0080o_knO@3oool003l0oooo0180ooko0?omo`3knO`0ookj0?oomP3onoD0/jb_01486`3mm?l0
oOSj0;fl]`1WJ680aLS<07EfT03ioOl0moko0?Kon03noodQ0?ooo`030?gmo@3kno/0oOgm0080oooo
00X0o_kn0?gmo@3oool0oooo0=CDe00@41001PH60000001TI6@0m_Kf0P3oool0103no_h0oooo0?gm
o@3oool20?_kn`0>0?knoP3oool0oooo0?ooo`1nOWh071`L0;Ng]`3moOd0no_k0?[jnP3oool0no_k
0?knoP3moOdI0?ooo`080?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/a0?ooo`070?clo03m
oOd0o_kn0?ooo`3no_h0nOWi08n?S`020000000600H61P2j^[X0o_kn0?Win@3oool0o?clO@3oool0
03l0oooo0180ooko0?glo`3ooOl0ooO_0?oml`3bk^/0no[o02<N;P3Xi?80ooko0?onn@30_kX0VIZN
06YaR@3`mol0nooo0?konP3ooodO0?ooo`<0o_kn00@0oOgm0?ooo`3no_h0n?Sh0P3oool03@3moOd0
o?cl0?ooo`2RXZ80000000@410000000YjNW0?[jnP3oool0n_[j0?ooo`3kno/01@3oool0103[jn/0
AdM703Xj>P3Vi^H20?ooo`070?knoP3lo?`0no_k0?ooo`3lo?`0oooo0?gmo@0H0?ooo`80ooom0P3o
ool20?kmo`0300400`3oool0oooo00@0ooom0`3oool20?koo@80ooko0P3nool20?ono@<0ooko0P3o
ood00`3nool0oooo0?ooo`0I0?ooo`0>0?_kn`3oool0o_kn0?knoP3hn?P0c<c<00820P030`<00000
07UiN@3oool0oOgm0?ooo`3kno]H0?ooo`050?koo`3kool0o?oo0?ono`3ooOl00P3oool20?ono@05
0?omo`3oo_l0o_ok0?con`3nool00`3oo_lE0?ooo`00?`3oool20?ono`0@0?ohn@3on>d0ZiB:0081
1P1NJ740@dYB0;2e^@3joOl0oooo0?onn02d]KD000@C0>3ao`3oo_l0oogf0?omoBL0oooo00H0o_kn
0?gmo@3oool0oooo0?Win@1PH60200000005018B4P3IfMT0oooo0?clo03moOd00P3oool0203lo?`0
oooo0?ooo`30`<008b<S07MgM`3oool0no_k803oool02`3oood0o_kj0?oon`3moO/0oOco0?omo`3o
o?l0YjBZ0?ono`3oo_d0o_gi0080oooj01@0o?_g0?omo03oo_l0nO[j0?_onP3looX0ooco0?oho`3i
o?l0o?oo0?oln03on_P0oo_o0?olo`3ooOd0oooj0?kon`3lood0o_oo0?onoaP0oooo00/0oOgm0?oo
o`3oool0no_k0?clo03`l?005aLG00<30`000000@d=30?KfmP020?ooo`030?knoP3kno/0oooo0400
oooo00X0oOgm0?ooo`3oool0oOgm0?ooo`3jn_X0oooo0?knoP3oool0o?cl0`3oool00`3inOT0oooo
0?ooo`070?ooo`0?0?_oo`3cool0mooo0?kin@3onod0noWl0?ooo`3oo_X0oo_h0?ojo`3onol0mOo`
0?Som03kool0o?co0080o_ko00<0ooko0?ooo`3oool04P3oool003l0oooo0180ooko0?[go@3oo?/0
oo7Q03dW6@2Z[;H0h>cj00072@1OIF40n?oo0?_oo`3ooOd0oOgm0::e^`2Y_<80o_Wi0?oin03ooOdZ
0?ooo`040?Win@3oool0l_;b02TY:@80000000<0>c/k0?Cdm03oool00P3oool0203kno/0oooo0?Wi
n@2>SXh06ATI0:ZZZP3inOT0o_kn8@3oool0803oood0n__e0?oonP3jn_P0ooko0?_ho`3oo?l0oogo
0?_io03oo_d0oook0?[im03hmo80oook0?ono@3mo?l0o_oo0?Kom@3io_L0oo_o0?ojo`3lo?l0noon
0?oon03ooOX0oo[o0?oko`3ooO/0oooh0?conP3lood0o_oo0P3oo_lH0?ooo`80oOgm00X0oooo0?[j
nP1:BTX02`/;0000000E5AD0h^;R0?ooo`3moOd0n_[j0P3oool00`3kno/0oooo0?ooo`110?ooo`04
0?[jnP3oool0oooo0?Gem@80oooo00@0o_kn0?gmo@3moOd0n_[j0P3oool00`3jn_X0oooo0?ooo`05
0?ooo`0B0?_oo`3bool0l_on0?olo@3onod0oogo0?OhnP3oo_X0oo[g0?kamP3onod0l?SY0?GomP3f
ool0nooo0?kno`3noOl0ooko503oool003l0oooo0180ooko0?oko`3ono/0oogT07I]F`1mP940n?go
0;^g]00C4`L0kO_i0?Goo`3glol0ooco0?Woo`3eooP0oooo0?omo`3oo_lW0?ooo`030?knoP3moOd0
n?Sh0080oooo0100o_kn0<G5a@0;2`/0000000D51@1aLG40oooo0?clo03moOd0o?cl0>o_k`1GEeL0
<30`0>CTi03oool0no_k0P3oool00`3jn_X0oooo0?ooo`0M0?ooo`050?ooo@3ooo/0oook0?ooo`3c
l_D00P3oo_l0103cl?H0ooko0?ono@3lnoL20?oonP0<0?oon`3lo?`0m_Gj0?koo`3jooP0o_oj0?oh
o@3omol0oogo0?Wjo03hnO40oOcg0P3on_l0103ooOd0oooh0?conP3lood30?onoaL0oooo00D0o?cl
0?ooo`3moOd0oooo09JFUP020000000300<30`2d];@0n?Sh0080oooo00@0nOWi0?ooo`3moOd0oOgm
@@3oool03P3lo?`0oooo0?gmo@3oool0no_k0?ooo`3moOd0l?3`0>GUi@3oool0no_k0?ooo`3kno/0
o_kn203oool04@3lool0mooo0?Woo@3on_/0ooKh0?omo`3lool0nOoo0?koo@3oo?<0OVmW05A@C@27
S900gnSe0>oho`3lool0no_k01D0oooo000o0?ooo`0B0?omo`3onol0o_Cb0?ooj`2l_:l04QDT0?[h
o`3on?808Q/@0<OIf03/o_l0oOco0?olo`3jnoD0m_W`0?koo`3bloL0ooko:03oool0203inOT0oooo
0?ooo`3inOT0oooo0?clo02?Shl00P820P0000002P2i^KT0o_kn0?ooo`3Bd]807alO06a/K03emOD0
oOgm0?Shn03oool20?gmoB40oooo01h0o?cj0?ooo@3jn_X0ooko0?kmo`3oo_l0noWl0?ono`3noOT0
oook0?oonP3jn_H0oOgk0?ooo`3oo_l0o?go0?konP3jnoD0ooWl0?olo`3onol0ooko0?conP3noo/0
oo[o0?oio`3oo_d0o?oj0?con`3nood30?onoaP0oooo00h0oOgm0?ooo`30`<000`<300@410061PH0
KVi^0?ooo`3lo?`0oooo0?gmo@3oool0nOWi0?knoT40oooo00<0oOgm0?knoP3oool00P3no_h01@3l
o?`0oooo0?clo01GEeL0SHf=0080oooo00@0oOgm0?ooo`3oool0o_kn1`3oool04P3nool0mogi0?Sj
m`3onod0oock0<g<b02EVi/0U9fZ0=7Hh03oo_@0ooc_0?ojn03Zh^/0Hg:30?3oo`3jo_l0ookk0?on
oA@0oooo000o0?ooo`0B0?omo@3on_P0oogh0?[lm`3jooh0CeIL08J3R@3on_<0GE9<096RZP3Yool0
o?oo0?Wcl@3ooO/0oogm0?coo`3kool0o_oo:@3oool00`3inOT0oooo0?knoP020?ooo`090?_kn`15
ADD010@400820P0F5QH0i^KV09ZJVP051@D0[jn_00L0oooo00<0o?cl0?ooo`3oool0803oool0403o
o_l0m_Gh0?_jo@3noOl0Fe]K0?ShmP3lo?P0oooj0?Shm03mooX0o_oo0?Wjo03jn_l0o_oo0?knnP3k
n_D20?olo`040?ogo`3mn_l0lOcc0?Won`80oo[o00@0o_om0?_onP3noo/0ooom0`3oo_lG0?ooo`04
0?_kn`3oool0j>SX02LW9`80000000X0>SXj0?[jnP3gmoL0oooo0?gmo@3no_h0oOgm0?knoP3oool0
oOgm@@3oool00`3no_h0nOWi0?ooo`020?gmo@080?ooo`3YjNT0410@0>k^kP3oool0o_kn0?ooo`3i
nOT:0?ooo`0A0?ono`3nmoX0oo_o0?kfl@3non`0[kJ/00H=9`3bn?l0nocn0?oik@3okN<0^ZJU04=K
LP3Tool0o_oo0?okmP3ooOd0503oool003l0oooo0180oook0?onmP3hlnd0o?oo0?Soo`3kool0M7=_
07MTF`1TEU<0JWJ40?7oo`3ho?/0ookh0?omn`3oo?h0loWi0?Woo`3noolX0?ooo`0>0?Cdm03oool0
oOgm0?gmo@3oool0o_kn0?ooo`3`l?005QHF000000010@406QXJ02PX:03Vi^H20?knoP80oooo00D0
nOWi0?_kn`3oool0oooo0?knoP0Q0?ooo`0G0?[jnP3noOl0ooko0?ono`3lo?`00@400?oon`3oooX0
o_oi0?gonP3nood0nocl0?gno`3no_l0oOco0?ooo@3oo?T0oocm0?oioP3onol0o_ko0?KonP3ioo/0
0P3onol0103kool0nOok0?kon`3oo_d30?onoaP0oooo00H0no_k05]KF`0000000000014A4@3Lg=`2
0?ooo`070?KfmP3no_h0oooo0?clo03oool0o_kn0?clo0100?ooo`0:0?Gem@3oool0oooo0?clo03o
ool0:RXZ0?gmo@1eMGD0Kfm_0?_kn`80oooo00@0oOgm0?ooo`3oool0nOWi1`3oool04P3oo_l0ooSk
0?oko@3on?L0oogd0?3dh@3eooL05Qdi0>;Xo`3kool0oogf0?GEaP1>>C@0SjBm0>3mo`3nool0oo_d
0?onna@0oooo000o0?ooo`040?oon`3oooH0oooj0?OjoP80nooo00`0oook0?ogk`3oo?P0nOoo0?Cm
o`3oo_l0ookh0?_elP3ooo/0o?oo0?_oo`3noolW0?ooo`030?clo03oool0o_kn00<0oooo00D0moOg
0?ooo`3oool0^k^k00H61P020000000508J6QP3hn?P0oooo0?ooo`3kno/00`3oool00`3kno/0o_kn
0?knoP0P0?ooo`080?Whn`3oo_l0ooko0?ono`3jn_X0oooo0001003jo?L20?cnn00>0?kon`3gnOH0
oOkn0?koo`3gm_`0ooko0?clo03ooOd0oo[j0?ojo`3onol0n?co0?Ooo@3go_L20?oko`040?Woo`3h
oo/0oook0?omo@<0ooko5`3oool02@3no_h0U9BD000000030`<000000;>c/`3oool0o?cl0?_kn`02
0?ooo`030?Win@3oool0nOWi04<0oooo00h0m_Kf0?Shn03oool0oOgm00X:2P3emOD0S8b<0?3`l03o
ool0n_[j0?Gem@3oool0nOWi0?clo0P0oooo0180ooko0?oloP3oo?X0ooCW0:FGRP031`H0FFI^03i6
F02`]LH0o_co0?oim`3olNH0oogk024ZA`3PkOl0m_Gh0?onm03ooo/D0?ooo`00?`3oool04P3oood0
o?kh0?konP3jnod0o_oo0?Ojo`3oool0oocd0?omn03lo_l0noko0?oio`3ooO/0oooj0?_mn03lool0
n_go0?koobL0oooo00H0o?cl0?ooo`3jn_X0oOgm0?ooo`3hn?P20?ooo`0=0?gmo@2LW9`020P80000
00010@401@D50<g=c@3moOd0oooo0?[jnP3kno/0oooo0?knoP0S0?ooo`<0ooko01/0oooo0?knoP3n
o_`000800?kon`3mooX0o_ok0?koo@3moo`0jnc/05YIG00000@0T8nD0?cmo`3Ed=807P/<01421`2l
_/X0mooo0?;ln@3lood0ooco0?omo`3gool0moom0?oon`3ooOd00`3oo_lG0?ooo`070<c<c00:2PX0
00000000001^KVh0o?cl0?_kn`020?ooo`030?_kn`3oool0oOgm0080oooo00<0o?cl0?gmo@3oool0
@P3oool01@3moOd0oooo00H61P3emOD0oooo0080oOgm0P3oool0103moOd0oooo0?clo03moOd80?oo
o`0A0?ono`3onoH0oo_T03LU5P2TZ[P0hNgo00002P1QH6D0oogo0?ono`3LfmH0KFa_00P98`3/kOl0
o_go0?olm@3oo_d0503oool003l0oooo0180o_oo0?_oo03lood0no_g0?ooo@3inOl0o_oo0?onn03l
mo40ooko0?cjo`3on?l0oogo0?konP3looX0oOko0?koo`3oo_l20?gmo@<0oooo00<0o_kn0?ooo`3n
o_h00P3no_h20?ooo`030?knoP3oool0oooo00D0oooo00<0o?cl0?gmo@3oool02@3oool00`3kno/0
oooo0?ooo`020?ooo`030?gmo@3oool0n_[j0080oooo00d0o_kn0?_kn`3oool0nOWi0??cl`1NGUh0
:2PX0=GEe@0i>CT0000000D51@0T92@0lO7a00D0oooo00<0n_[j0?gmo@3oool0803oool01`3noOl0
ooko0?glo`3moOd0o_oo0?goo02UYj800P3noo/0603moo`0oOgk0?[jn03no_h0m_Ce00800`3Pgn80
o?oo0?cgn@3D^kh07PX?0?Clo`3bool0mogm0?ono@3ooOl0ooko0?Goo`3good0ookk0?olo@3oo_l0
o_oo0?ono`l0oooo00<0oOgm0?ooo`3inOT00`3oool02@3lo?`0lo?c02@T90020P80000003Xj>P3f
m_H0oooo0?_kn`1:0?ooo`0=0?[jnP3oool0oooo0?knoP0@4100kNg]0?ooo`3no_h0no_k0?ooo`3n
o_h0oooo0?_kn`030?knoP@0oooo00l0oOgm0?knoP3oo_l0o_oo0?olm03on]d0PFiK07AkU@3do_l0
`[Fj01X<1`3_n?/0m?oo0?_oo`3hmod00P3noOl00`3onol0oocl0?ono`0D0?ooo`00?`3oool05@3n
ool0o?oo0?[no@3ooo/0n?Ke0?koo`3noOl0o?Og0?onn`3oo_l0oogo0?olo`3nnO/0nO_h0?[nn`3n
ool0o_go0=kNgP3QhN40h^;R0=_Kf`020=;BdP030=kNgP3/k>`0oooo00L0oooo00L0oOgm0?[jnP3o
ool0n_[j0?clo03oool0o_kn00`0oooo00<0nOWi0?ooo`3oool00P3lo?`0103moOd0oooo0?gmo@3n
o_h20?ooo`070=cLg00[:b/0GEeM0?Shn03oool0f][J01HF5P020000000505iNGP3kno/0o_kn0?oo
o`3gmoL00P3oool00`3moOd0oooo0?ooo`0O0?ooo`080?[io03oo_l0n_[j0?ooo@3inoP0oOol0?ko
n`3inoP20?[ln@0F0?ooo@3oo_d0ookm0?ojnP1<AdL0UYJF0?Wno`3oo_l0on_/01L21@38e>00jOco
0?coo`3ooOd0oogo0?koo`3gool0n?oo0?omo@3oo?d0ooko0?kooa00oooo00D0oOgm0?_kn`3oool0
oooo0?Win@020?ooo`0905YJFP051@D0000000l?3`3Jf]X0oooo0?knoP3oool0no_k04P0oooo00<0
oOgm0?ooo`3jn_X00P3oool00`0820P0mOGe0?ooo`020?ooo`030?clo03oool0oooo00D0oooo00<0
o_kn0?gmo@3no_h00P3oool03`3no_h0o_oo0?olm03onMd0bk^Y00/?:03bmOl0ooWk02HG4039e]`0
kOoo0?Gno`3nool0m_Ok0?_ho`020?olo`030?ono`3oool0oooo0180oooo00100?ooo`040?cmo@3m
o_h0o_go0?ooo`80ooom01L0oo_o0?cfo@3im_`0ooko0?oonP3Ui>00/k:h07IfOP0h>SL03Q0;024Q
7`0N7Qh07AdM024Q8@0Y:BT0:RXZ024Q8@0E5AD0:2PX04e=C@27QhL0`L710>_[j`020?ooo`040?cl
o03oool0oooo0?gmo@80oooo00<0no_k0?clo03oool0203oool0103kno/0oOgm0?Gem@3no_h30?oo
o`0B0?gmo@3oool0no_k0?ooo`3kno/0oOgm0:2PX00E5AD0UYJF0?knoP3oool0moOg0?ooo`2TY:@0
000000L71`000000XZ:R0P3oool01@3fm_H0oooo0?clo03oool0o_kn0200oooo0P3oo_l06P3nool0
l_Ca0?koo@3noo/0lO?`0?koo@3nool0nocl0?knoP3mnoX0ookk0?omnP2TWiT0@d8m0?7ho03mo?l0
ooKd065>C`28UJ<0l?oo0?kno`3mm_T0oogo0?koo`3hool0nOoo0P3ooOd20?onoa00oooo00<0oOgm
0?ooo`3oool00P3oool01`3moOd0Vi^K00000000000020P80:RXZ03gmoL00P3oool00`3hn?P0oooo
0?ooo`180?ooo`080?[jnP3oool0oooo0?Win@0@4100JVYZ0?;blP3no_h30?ooo`040??cl`3moOd0
oooo0?_kn`<0oooo01H0o_kn0?ooo`3oool0oooo0?_kn`3knOP0oooh0?olj@3ooo<0HUYW08AhRP3o
n_/0FU5B09>O[@3aool0logj0?con03inoP0ooko0?oko`3onOl0ooko503oool00400oooo0140no_i
0?ooo`3oo_l0moKi0?oonP3ooo/0oO[o0?olo`3>cM00K6aX01HG3@0D5@l0AdE@08>1SP2n`;d0k>oV
0?kno0060?ooo`0A0?Win@3@d=00ZJVY07=cL`0i>CT03@d=01dM7@1nOWh0hn?S0?Shn03oool0o_kn
0?ooo`3moOd0no_k0?ooo`3lo?`02@3oool01@3moOd0oooo0?ooo`3gmoL0m_Kf0080oooo00T0n_[j
0?ooo`3oool0o?cl05mOG`0X:2P0c<c<0?ooo`3moOd00`3oool01`3lo?`0IFEU00<30`0000003@d=
0=[JfP3kno/00P3oool20?gmoB40oooo00L0o?_n0?ooo`3inoP0o_om0?gonP3noo/0nO_h0080o_oo
0140nOSk0?ono`3ooOd0mNo/0?onmP3dk>40104006E/L01NHFD0OF]W01h@3`0`?4X0k_oo0?gmo`3o
o?l0oogo0?ooo`020?_oo`040?ono`3ooOd0ooko0?onoa80oooo00T0n?Sh0?knoP3oool0d=3@00h>
3P020P800000069RHP3moOd00P3oool00`3lo?`0no_k0?ooo`180?ooo`0<0?[jnP3kno/0oooo0?oo
o`3Kfm/0000008:2PP0E5AD0QHF50?7al@3oool0no_k0P3oool00`3jn_X0oooo0?clo0050?ooo`0C
0?knoP3oood0ookj0?onm`3loO<0oooj0?oeo@2>PHX0K61P05aGF@1cO8L0k?[o0?Woo@3looP0oOoj
0?ooo`3on_l0ooco0?ono`0D0?ooo`00@03oool20?ono`0?0?Ccn03oo_l0oooj0?Gel@2/Zk40?3]1
020Q8@1oPG`0h^GJ0?kon`3ooOl0n_So0?cnn`3nooX0o?cj0080oooo00<0no_k0?KfmP3jn_X00P3o
ool00`3no_h0oooo0?ooo`020?ooo`0:0=WIf@1cLg<03`l?04A4A02JVYX0n_[j0?ooo`3hn?P0oooo
0?knoPT0oooo00D0o_kn0?Ogm`3oool0oOgm0?_kn`020?ooo`0I0?_kn`3oool0n_[j0=gMg@0X:2P0
FEUI0?;blP3oool0mOGe0?ooo`3moOd0n_[j0?gmo@3oool0l?3`02DU9@051@D00000034a<@3moOd0
o?cl0?ooo`3no_h0oooo0?[jnP0P0?ooo`80o_oo00H0o_om0?Ggm03hoOL0nool05YKF`3gn?X20?on
o`0D0?ojoP3ooO/0oogh0?onl`3hkmh07a/?0:bc]`3fnol0ooW_0=O?bP000A@0inko0?Oio`3oo_l0
oogm0?omo`3oo_l0o_oo0?ooo`3oood20?onoa40oooo00`0lo?c0?ooo`3oool0l?3`02DU9@000000
0P82034a<@3kno/0o?cl0?ooo`3moOd20?ooo`030?clo03oool0oooo04T0oooo00<0o_kn07]kN`0B
4Q800P3IfMT02`1OGel04A4A08b<S03`l?00nOWi0?ooo`3kno/0oooo0?gmo@3kno/0o?cl0080oooo
01@0oOgm0?ooo`3ooo/0m?KY0?oom03ooOd0oO[o0?clo`3ooOl0oock0?omnP3iool0mooo0?KkoP3n
ool0oOgk0?kno03oo_l0o_go0?onoa@0oooo00100?ooo`0A0?cjn`3nnO/0ooco0>o]l01gMW8071`H
04A7B`2VZJh0nocl0?kon`3nooP0o?ok0?kno`3ooOl0ooom0?oonP3oood01P3oool00`3kno/0oooo
0?knoP030?ooo`0;0?clo03kno/0no_k0:NWY`1DE5@08b<S0:FUY@3oool0nOWi0?ooo`3lo?`02`3o
ool0103moOd0oooo0?ooo`3jn_X20?ooo`040:VYZ@0:2PX0Vi^K0?ooo`80no_k00D0oooo0?gmo@3o
ool0oooo0?gmo@020?ooo`050<[:bP061PH0000000L71`1YJFT00P3oool00`3kno/0oooo0?knoP0P
0?ooo`0N0?koo`3inoP0oOol0?koo@3loo/0nOgj00010`3nool0o_go0?omo`3onOh0ooOe0?olm03o
n>X0ookX09nIR@1DFEd0nOoo0?oom03lno@0:BLl0:NW`@3kool0o_oo0?omo@3oo?d0ooco0?ono`3n
ool0o_om0P3oo_l@0?ooo`050?Win@3oool0moOg0?_kn`1TI6@00P030`<010061PH0eMGE0?ooo`3k
no/20?ooo`030?KfmP3moOd0oooo04T0oooo00l0o?cl0?ooo`3clo<0<30`01TI6@3Ti>@0oooo0?kn
oP3EeMD0F5QH01lO7`2:RXX0jNWY0?ooo`3jn_X00P3oool0203lo?`0o_kn0?ooo`3oool0o_kn0?oo
n`3ooo@0moS^0P3ooOl03@3lool0n?_o0?[im@3nno@0o?oj0?Gin03oo_l0oogo0?kon`3inoH0n_ko
0?koo`3oo_l0503oool00400oooo0140ookm0?cgn@37_LH09AhU06YYI@3Ff=80l_[j0?Woo`3lo?`0
oook0?konP3ioOX0n?go0?coo`3oo_d0no[f0?omo0030?knoP030?clo03kno/0oOgm00@0oooo0P3m
oOd30?ooo`080?gmo@3oool0^;Rh038b<P0d=3@0^k^k0?ooo`3moOd80?ooo`040?Shn03oool0oOgm
0?ooo`80no_k00l0oooo0>o_k`1YJFT07alO0=KFeP3no_h0oOgm0?ooo`3jn_X0oOgm0?clo03oool0
o?cl0?ooo`3kno/00P3oool01@2>SXh01PH6000000061PH0/K6a00<0oooo00<0oOgm0?ooo`3oool0
7P3oool08@3hn_L0o_om0?koo@3noo/0mo_h0?coo@000080n__o0?ono`3hmO`0ooco0?omn`3omnl0
oog/0?odfP1aJUP000040:Vb]`3goo80hNSN02HN=@0B2bX0^l7<0?Woo`3oo?d0oo_m0?oko`3ooOl0
nooo0?_oo@3oo_l0oogo0?ono`0@0?ooo`040?Shn03moOd0ZJVY00410@80000000D0XZ:R0?ooo`3o
ool0o_kn0?clo0020?ooo`030?Win@3oool0oooo04L0oooo00<0oOgm0?ooo`3jn_X00P3oool00`0P
8200f][J0?knoP030?ooo`060<_;b`1DE5@07QhN08>3P`3moOd0nOWi0`3oool05@3no_h0oooo0?oo
o`3moO/0oook0?_jm@3nooX0nogj0?GinP3kool0nOom0?con`3ooOT0oocm0?oko`3hloL0o?of0?Wo
mP3io_l0o?oo0?koo`0D0?ooo`00@03oool04`3aknh0I5mQ02@J8`2l]K`0oook0?kon`3hool0nooo
0?ooo`3ooO`0oOoj0?coo@3kool0noko0?klo@3ooOd0ooko0?gmo@3no_h00P3oool0103no_h0oOgm
0?ooo`3no_h50?ooo`0:0?knoP3lo?`0oooo0?Win@3kno/0oooo09nOW`0T92@0Kfm_0?Shn0L0oooo
0`3nool03P3hm_L0ookm0?clnP3nood0f][J03Hf=P1ADU80m?Ge0?kln`3oo_d0noWj0?7_l03oo_l0
o?go103oool02`3moOd0oooo0?clo03oool0AdM700T92@0000006QXJ0>KViP3no_h0oOgm0240oooo
103nood00`3moo`0oOkn00010`020?ono`80oogo00h0ooWg0?ommP3on>`0ooSS0=WCa@3LgN40cmKJ
0?3lkP3XknL0f];U0=gEk03FgND0n?oo0?omo@80oo_o00H0oogo0?_oo`3kool0ooko0?omo`3oo_l@
0?ooo`080?clo03IfMT03@d=000000051@D0IfMW0?_kn`3lo?`20?ooo`040?_kn`3moOd0oooo0?kn
oQ40oooo00@0o_oo0?ono`3oo_l0ooko0P3oool01@3nool0oooo0?ono@3oo_d0oooo00<0o_oo00<0
ooko0?ono@3oo_d0103oool00`3nool0ooko0?ooo`0P0?ooo`070?gmo@3oool0oooo0?[jnP3no_h0
8R8R0>3Ph0030?knoP080?ooo`3moOd0oooo0=CDe01>CTh0<c<c0=_Kf`3dm?@20?ooo`0E0?_kn`3o
ool0oooo0?ooo`3mnoX0oook0?konP3loo/0o_oo0?_oo`3do_/0noom0?omnP3on_`0oo_o0?oloP3l
ooH0n?og0?_oo`3ko_l0o_oo01@0oooo000B0?ooo`030?[jnP3oool0nOWi0080oooo00D0moOg0?oo
o`3lo?`0oooo0?_kn`020?ooo`030??cl`3oool0oooo01T0oooo00`0no_k0?ooo`3oool0o_kn0?oo
o`2i^KT05aLG07EcM03`k_40ooko0?ShmP3oood20?gnoP80oooo00H0ooom0?koo`3nool0o_oo0?oo
o`3oo_lA0?ooo`0<0?knoP3lo?`0o?cl0?ooo`3lo?`0AdM703@d=03Hf=P0oooo0?knoP0N7Qh0fMWI
0P3oool02@3lool0nOoo0?Smo`3oo?l0oo[h0?konP2W[:D0518A09:@T@020?_oo`070?oon03gknX0
:B0Q07YeN@2>SY@0o?oo0?gno`070?ooo`050>[ZjP0N7Qh00@410000001>CTh00P3kno/02@3oool0
o_kn0?ooo`3kno/0oooo0?clo03no_h0oooo0?[jnP0H0?ooo`070?knoP3oool0oOgm0?gmo@3oool0
o_kn0:JVYP040?ono`090?ono@3oo_/0ookj0?oon03oooX0ooko0?koo`3loo/0o_om0080oogo0P3n
ool0103oo_l0oogo0?ono`3oo_l20?koo`030?ooo`3oo_l0oooo00T0oooo00<0o?cl0?[jnP3oool0
0P3oool0103lo?`0oooo0>g]k@0_;bl20000000302XZ:P3emOD0oooo01L0oooo01T0o_oo0?coo`3n
ool0oogo0?omo@3oood0o_oo0?coo`3nool0ookk0?onnP3oood0o?oo0?Woo`3kool0oogm0?omnP3o
o_/0ookm0?[jnP3oool0o_oo0?Oko03loOl0o_oo0080oooo0`3oo_d20?ooo`040?koo`3oool0oooo
0?_kn`80oooo00<0oOgm0?ooo`3no_h0103oool00`3no_h0oOgm0?ooo`0;0?ooo`0P0?knoP3oool0
o_kn02LW9`3MgMd0o_kn0?clo03oool0o?cl0?ooo`3kno/0oooo0?[jnP2OWil06ATI07QhN03oool0
no_k0?knoP3oool0n_[j0?ooo`3jn_X0ooom0?[jn03nood0oooo0?WjnP3lool0o_oo0?ono@3ooOl2
0?ono`040?kon`3nood0o_oo0?kooaD0oooo000A0?ooo`060?gmo@3oool0oooo0?ooo`3hn?P0moOg
1@3oool00`3inOT0oooo0?ooo`0I0?ooo`0:0?gmo@3lo?`0oooo0?ooo`3hn?P0oooo075aL@0L71`0
_[jn0?;blP80oOgm00<0oooo0?_kn`3oool06@3oool0103inOT0oooo0?ooo`3oool20?_kn`0K0?oo
o`2IVIT05aLG0:^[Z`3lo?`0H61P09bLW03no_h0oooo0?_oo`3gool0koCh0?olo`3onOL0JFaS01/P
6@3?cL`0ooko0?_oo`3ioOX0nOK_0?omn03oo?/0ooco0;Fe_@2SYZd0oOko00P0oooo00L0`l?30000
000820P0000008>3P`3oool0m_Kf00<0oooo00@0m_Kf0?ooo`3oool0mOGe6@3oool0203jn_X0oooo
0?[jnP3oool0n_[j0?knoP3oool0n_[j8@3oool03`3kno/0oooo0?ooo`3emOD0m_Kf0?ooo`3kno/0
o_kn06i^KP0410@0000000T92@3De=@0oooo0?clo00G0?ooo`0K0?koo`3lool0o_ko0?olo`3ooO/0
ookm0?koo`3lool0o_oo0?onnP3oooP0ooom0?_oo`3hool0nOoo0?omn`3ooOP0oo_h0?oon`3no?d0
l_?c0?koo`3joOl0o?oo0?WmoP3oo_l0oooo00<0ookm00@0ooom0?ono`3nool0nOWi0`3oool01@3k
no/0oooo0?gmo@3kno/0o?cl0080oOgm00D0o_kn0?ooo`3oool0oooo0?Shn0090?ooo`060?knoP2a
/K40d=3@0?ooo`2i^KT0i^KV0`3oool02P3gmoL0oooo0?knoP3kno/0oooo0?_kn`3Ti>@0BTY:02l_
;`3Cdm<20?ooo`070?_kn`3jn_X0oooo0?clo03oool0o_kn0?KfmP020?ooo`030?clo03oool0oooo
01/0oooo000A0?ooo`040?clo03inOT0no_k0?Ogm`80oooo00H0o_kn0?_kn`3no_h0nOWi0?ooo`3m
oOd20?ooo`030?gmo@3oool0oooo01P0oooo00T0n?Sh0?ooo`3oool0J6QX03@d=03kno/0o_kn0?oo
o`3moOd00P3oool00`3hn?P0oooo0?Shn00I0?ooo`090?[jnP3oool0no_k0?ooo`3moOd0oooo0?cl
o03AdM405ADE0080WinO01D0FEUI0?ooo`3oool0o?go0?Woo`3kool0iN3P03Pb<019BT@0mOOa0?ko
o@3lo?`0ookm0?oon`3nood0moOe0?ohnP3il?<0LW9j09NKXP3mo_l0203oool01P3kno/0P8200000
000410@000000<[:bP80oooo00H0nOWi0?clo03oool0no_k0?ooo`3moOdL0?ooo`040??cl`3oool0
oooo0?;blR80oooo00<0oOgm0?Shn03oool00P3oool00`3hn?P0oooo0::RXP03000000030:6QX@3m
oOd0n?Sh01P0oooo00T0o_oo0?coo`3nool0oogm0?omn`3oo_d0o_oo0?coo`3nool00P3oo_X0403o
ood0o?oo0?Woo`3kool0ookk0?omn03ooOX0m_Ga0?ono`3nool0o?go0?coo`3hnol0nOgn0?ono`3o
ool30?ono@030?ooo@3oo_l0o_oo00@0oooo00<0no_k0?clo03oool01@3oool00`3lo?`0n?Sh0?gm
o@090?ooo`040?Win@3]kNd02PX:0?Gem@80oooo00D0o_kn0?ooo`3lo?`0oooo0?gmo@020?ooo`09
0?Win@3lo?`0oooo0?[jnP3oool0VIVI014A4@1lO7`0no_k0080oooo00<0o_kn0?ooo`3jn_X00`3o
ool00`3kno/0oooo0?ooo`0L0?ooo`005@3oool00`3moOd0n_[j0?ooo`020?ooo`050?gmo@3lo?`0
oooo0?knoP3inOT06@3oool03P3moOd0oooo0?ooo`3jn_X0L71`03Ph>03bl_80mOGe0?ooo`3emOD0
o_kn0?ooo`3kno/0o_kn6`3oool01P3no_h0oooo0?ooo`3kno/0oooo0?Ogm`80oooo0140gmoO01hN
7P23Ph<061PH0?clo03kno/0o_oo0?Gho02^/[<05aLE08^:QP3ooo/0mOGa0?Kjm`3noo/0oocg0?Oa
kP020?_oo`050?olo@37_[l05QHN0=?GgP3mo_l0203oool0203moOd0n_[j0451@@0000000`<3020P
803/k>`0o?cl0`3oool0103fm_H0oooo0?ooo`3moOdH0?ooo`070?clo03oool0n_[j0?ooo`3no_h0
oooo0?[jnP0Q0?ooo`030?Shn03oool0oooo0080oooo00P0n_[j0?ooo`3De=@03`l?00410@0;2`/0
DU9B0?clo080oooo00<0o?cl0?ooo`3oool05@3oool01`3nool0o?oo0?koo`3oo_/0oogj0?ono@3n
ool00P3lool03P3ooo/0ookk0?ooo@3nool0nooo0?coo`3oo_d0oogj0?_gm03ooo/0o_cm0?[kn`3m
o_l0n_go0P3lool00`3oo_l0oooo0?ono@020?ono@0:0?ooo@3oo_l0o_oo0?ooo`3jn_X0oOgm0?oo
o`3moOd0oooo0?;blP80oooo0P3jn_X30?ooo`030?clo03moOd0oooo00P0oooo00H0L71`07MgM`3o
ool0oooo0?[jnP3oool20?gmo@80oooo00<0n?Sh0?ooo`3oool00P3lo?`0203oool0o_kn0?ooo`3Z
j^X0BTY:02h^;P3Cdm<0no_k0P3oool01P3no_h0m_Kf0?ooo`3fm_H0oooo0?WinAd0oooo000A0?oo
o`80oOgm00@0oooo0?Shn03oool0oooo0`3kno/01@3oool0no_k0?ooo`3oool0oOgm01T0oooo00L0
o_kn0?Shn03oool0Kfm_03@d=03emOD0o?cl00@0oooo00@0moOg0?ooo`3oool0mOGe6@3oool00`3n
o_h0oooo0?ooo`020?ooo`0L0?gmo@3oool0no_k0?knoP3moOd0g=cL01hN7P0K6a/0hN7Q0?ooo`3e
mOD0NWUl028R8P30a<40n_ci0?olo03knOP0noom0?konP3TeLd0200008F?UP3eool0ooWi0?S^k@3h
n?h06alV0?gno`X0oooo00T0g=cL00l?3`00000010@405MGE`3no_h0o?cl0?ooo`3hn?P00`3oool0
0`3no_h0oooo0?ooo`0I0?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P08@3oool0303hn?P0o_kn0?kn
oP3no_h0oooo0?;blP0g=cL0000000820P0P8200n?Sh0?WinAX0oooo00L0o_oo0?coo`3nool0ookj
0?omnP3oo_d0o_oo0080o?oo00@0ooko0?omo@3oo_l0ooko0P3lool0303oo_d0ookk0?onn`3mo?P0
ooko0?Ohn03nool0noko0?coo`3ho?d0ooko0?ooo`<0ookm00T0ooom0?ono`3nool0oOgm0<W9b@2k
^k/0m_Kf0?ooo`3no_h01@3oool20?gmo@80oooo00<0o?cl0?ooo`3oool01P3oool0103hn?P061PH
0>;RhP3jn_X50?ooo`030?[jnP3oool0oooo00@0oooo00T0n?Sh0?ooo`3oool0moOg0?ooo`2WYjL0
3`l?0<71`@3jn_X00`3oool00`3kno/0oooo0?clo00N0?ooo`004@3oool02P3jn_X0oooo0?[jnP3n
o_h0n?Sh01/K6`2^[Zh0oooo0?[jnP3lo?`40?ooo`030?gmo@3oool0oooo01P0oooo00P0IVIV03@d
=03clo<0o?cl0?[jnP3oool0no_k0?knoP@0oooo00<0o_kn0?ooo`3oool0603oool01P3moOd0oooo
0?Win@3oool0o_kn0?KfmP80oooo00/0oOgm0?ooo`3Xj>P0@T9209^KV`3Kfm/0A49304]6B03Xi^D0
noom0?[nn`020?omo`0;0?;kmP3nooP0nNOI028C302P[[L0e^Sd0?omo@37_K/0EeMM04eAF03mo_l0
1`3oool0403jn_X0m_Kf0?ooo`3oool0Zj^[00L71`0000000P8209^KV`3oool0n_[j0?knoP3oool0
o_kn0?ooo`3no_hI0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@418P3oool00`3lo?`0oooo0?oo
o`020?knoP0507=cL`00000010@400@4103?cll00`3oool00`3lo?`0o_kn0?ooo`0F0?ooo`<0o_oo
00@0ookj0?onn03oo_l0o_oo0P3lool03@3oo_l0oogo0?omo`3oo_l0oooo0?koo`3oood0ookm0?ol
n@3kn_H0ooko0?koo`3hnOd00`3lool00`3oo_l0oooo0?ono@020?ono@0>0?ooo@3oo_l0o_oo0>[Z
jP051@D0:BTY02h^;P2=SHd0jn_[0?ooo`3jn_X0oOgm0?_kn`3lo?`30?ooo`030?knoP3oool0oooo
00L0oooo00L0i^KV0=WIf@3no_h0oooo0?clo03oool0n?Sh0080oooo00D0n?Sh0?ooo`3oool0oooo
0?clo0020?[jnP030?ooo`3no_h0m_Kf0080oooo00/0n_[j0<K6aP0A4A40WinO0?ooo`3emOD0oooo
0?Win@3gmoL0oooo0?Shn00M0?ooo`00403oool03P3kno/0oooo0?Shn02b/[80o?cl0?[jnP3?cll0
4a<C0=;BdP3oool0o?cl0?ooo`3jn_X0no_k6`3oool01@2b/[8020P80>o_k`3oool0o_kn00<0oooo
00L0o_kn0?ooo`3oool0n_[j0?Shn03oool0o_kn01P0oooo00D0n_[j0?ooo`3oool0oooo0?gmo@02
0?ooo`0J0?clo03inOT0oooo0?ooo`3hn?P0XJ6Q04U9B@0B4Q80Ph620?oin@3ooOd0noom0?_oo`3o
n_h0oOSl0?Woo`3nooH0oo_Z03HW7`2ibMP0jooo0?ooo`3ooOX0k>_a0?coo`3mo_l80?ooo`0>0?kn
oP3jn_X0oooo0?gmo@1WIfL00`<30000000410@0f=SH0?ooo`3hn?P0no_k0?ooo`3kno/I0?ooo`08
0?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/R0?ooo`090?Win@3jn_X0oooo0:f][@030`<0
0P820000002GUiL0oOgm0080oooo00<0n?Sh0?ooo`3oool05`3oool20?koo`030?koo@3oooP0ookh
0080ooko0P3lool20?ono`0@0?olo`3ooOd0oook0?oon`3nool0oooo0?ono@3ooo/0noWj0?koo`3l
oOl0n_go0?coo`3ho?d0ooko0?ooo`<0ookm00/0ooom0?ono`3nool0Ph>306EUI@3oool0_kno05MG
E`0B4Q80HV9R0<o?c`040?ooo`80oOgm2`3oool00`3jn_X0o?cl0?ooo`020?knoP070?ooo`3moOd0
oooo0?ooo`3moOd0o?cl0?knoP030?ooo`050?clo03oool0oooo0?knoP3inOT00P3oool01@3Ng]h0
92@T07=cL`3oool0oOgm0080oooo00<0o?cl0?ooo`3oool0703oool00140oooo00T0o?cl0?ooo`1e
MGD030`<04M7A`2TY:@0WYjN02TY:@3`l?000P3oool0103moOd0oooo0?gmo@3moOdH0?ooo`080>OW
i`0F5QH0alO70?ooo`3inOT0oOgm0?ooo`3kno/20?ooo`80o?cl0P3oool00`3jn_X0oooo0?ooo`0H
0?ooo`060?knoP3oool0nOWi0?ooo`3no_h0no_k0P3oool20?Shn00F0?ooo`1XJ6P000000<O7a`3o
o_d0ooSi0?onn`3kood0n_on0?klo`3oo_l0loWg0?oomP3onnP0Z9^@059QLP3^ool0nO[j0?onn03o
o_l0oOgo0?kmo`L0oooo00L0no_k0?ooo`3oool0n_[j0?ooo`3clo<0;Bd]0080000000L0:b/[0?7a
l@3oool0oooo0?clo03oool0o?cl01`0oooo0P3no_h00`010@40oooo0?ooo`0O0?ooo`0<0?knoP3o
ool0oooo0?clo03Rh^80410@000000010@40De=C0?gmo@3oool0mOGe0P3oool00`3gmoL0oooo0?oo
o`0G0?ooo`060?koo`3nood0ooof0?oon03ooOl0ooko0P3lool01P3nool0ooko0?olo`3oo?d0ookh
0?oonP80o?oo00X0c/c;01DD4034`/<0n__k0?cmo`3lool0n?_o0?coo`3oo_l0oooo0`3oo_d0403o
ood0ooko0?koo`0L71`0dm?C0?clo03no_h0oooo0>g]k@23Ph<092@T034a<@2HV9P0lo?c0?ooo`3i
nOT20?ooo`030?clo03oool0oooo00H0oooo00<0moOg0?ooo`3no_h00`3oool01@3lo?`0oooo0?_k
n`3oool0oOgm0080oooo00@0oOgm0?knoP3oool0oooo0`3moOd0303oool0oOgm0?knoP3lo?`0jn_[
03`l?01JFUX0kno_0?knoP3oool0o_kn0?clo1d0oooo000A0?ooo`0@0?clo03kno/0oooo0?KfmP2R
XZ80FUYJ0?Win@1UIFD0EEEE0?_kn`3moOd0no_k0?ooo`3jn_X0oooo0?_kn`<0oooo00@0nOWi0?oo
o`3oool0o?cl0P3oool00`3inOT0oooo0?ooo`020?ooo`0<0?knoP3oool0oOgm0?ooo`3no_h0oooo
0?clo03moOd0oooo04];B`1mOGd0no_k0P3oool00`3moOd0no_k0?ooo`0Q0?ooo`0P0?knoP3oool0
n_[j0?ooo`3moOd0oooo0?knoP3oool0o?cl0>WYj@12@T80?clo01LG5`3QhN40ookm0?omo@3oo_/0
o_om0?coo`3nool0ooko0?koo`3oooP0oo_V0>WOd`013Ql0j?So0?cnn`3oo_D0ooko0?kno`3oo_l9
0?ooo`060?_kn`3oool0oooo0?[jnP3Hf=P01`L70P0000000`1`L700oooo0?gmo@020?ooo`030?kn
oP3oool0oooo01H0oooo00L0o_kn0?ooo`3moOd0oOgm0?ooo`3no_h0YZJV01X0oooo00H0o_kn0?oo
o`3lo?`0oooo0?knoP3inOT30?ooo`030?[jnP3oool0=SHf0080000000<08b<S0?Gem@3jn_X00`3o
ool00`3no_h0oooo0?ooo`0H0?ooo`040?koo`3oood0ooof0?oomP80oogo00l0o_ko0?coo`3mo_l0
oO_n0?oko`3onOT0oocc0?oon03fn_l0nOoo0?ooo`2EU900c/c=0?[kn`3nool00P3lool03`3kool0
ooko0?clo03ooO`0ookm0?gknP3oood0ooko0;6b]00b<S80oooo0?_kn`3oool0o_kn0?ooo`020?gm
o@090;Jf]P1BDU805QHF06MWI`3De=@0oooo0?[jnP3oool0oOgm00<0oooo00H0no_k0?ooo`3oool0
j>SX0?[jnP3kno/20?ooo`040?clo03moOd0oooo0?knoQ00oooo00D0n_[j0?ooo`1GEeL0>3Ph0?3`
l0020?ooo`80oOgm0P3oool01P3moOd0o_kn0?ooo`3kno/0oooo0?clo080oooo00@0nOWi0?ooo`3o
ool0m?Cd3P3oool00100oooo00<0oOgm0?ooo`3oool00`3oool02@3no_h0oooo0?[jnP0O7al0Lg=c
03dm?@2EUID0j>SX0?Shn0020?ooo`050?[jnP3lo?`0oooo0?ooo`3inOT00P3oool01P3moOd0o?cl
0?ooo`3jn_X0oooo0?KfmP80oooo00D0o_kn0?clo03kno/0oooo0?Win@020?ooo`0509^KV`0`<300
o?cl0?knoP3jn_X00P3no_hV0?ooo`0<0?Win@3no_h0oooo0?knoP3moOd0a<C401dM7@1lO7`0oooo
0<G5a@3Lg=`0o_cm0P3ooOd03`3oood0o_oo0?coo`3nool0ooko0?onn03ooN`0n_?X01XR=03;en/0
o_om0?oomP3lnoh0o_ko0?ono`080?ooo`040?gmo@3no_h0oooo0?ooo`80o_kn00L0UYJF00000009
2@T000000:n_[`3oool0n?Sh01X0oooo00P0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnQT0
oooo00<0o_kn0?gmo@3oool0103oool02P3no_h0oooo0?ooo`1]KFd0000000@4100;2`/0b<S80?cl
o03no_h20?ooo`030?knoP3moOd0o_kn01T0oooo00@0o_oo0?ooo@3ooo@0ooof0P3ooOl03`3nool0
o?oo0?coo`3ln_d0oo[n0?oknP3ooO40n??[0?Woo`3hool0o?_n0=7@c01kNGX0o_oo0?WjoP030?co
o`030?kmo`3oool0ookm0080ookm00D0mOGc0?kmo`1<CDl0XZ:R0?knoP020?ooo`030?gmo@3lo?`0
o?cl00<0oooo00L0h>3P07inOP0J6QX0>3Ph0:VYZ@3fm_H0o?cl0080oooo00T0o?cl0?ooo`3hn?P0
h>3P01LG5`3emOD0o?cl0?ooo`3no_h05@3oool0503no_h0oooo04a<C0020P80k>c/0?ooo`3no_h0
oooo0?gmo@3inOT0o_kn0?clo03oool0o_kn0?_kn`3lo?`0oooo0=kNgP1gMgL0oOgm0P3oool00`3e
mOD0oooo0?ooo`0;0?ooo`004@3oool0403hn?P0oooo0?ooo`3inOT0no_k0?ooo`3lo?`0inOW00l?
3`0>3Ph0Rh^;05aLG00=3@d0SHf=0?gmo@3lo?`20?ooo`040?[jnP3kno/0oooo0?Ogm`80oooo00L0
lo?c0?ooo`3oool0n_[j0?ooo`3kno/0oOgm00D0oooo00@0nOWi0=cLg00F5QH0cLg=0`3oool00`3g
moL0oooo0?ooo`0Q0?ooo`0=0?knoP3gmoL0oooo0?gmo@3oool0o?cl0?ooo`3kno/0QhN701@D502h
^;P0oooo0?Shn0030?ooo`040?ono`3oo_d0ookm0?ooo`80o?oo00/0ooko0?omn`3oo^l0noS_07Z0
SP2<Tj<0no_g0?oom@3oo_l0no_o0?ono`080?ooo`0?0?knoP3oool0oooo0?ooo`3moOd0oooo0?[j
nP1?Cdl01@D50000000?3`l0j^[Z0?knoP3oool0o_kn01/0oooo00@0lo?c0?ooo`3oool0l_;b6`3o
ool03@3no_h0oooo0?[jnP3inOT0oooo0?clo03no_h0oooo0;Bd]00410@020P800000026QXH01@3o
ool30?knoQP0oooo00<0ooko0?koo`3oool00P3oooH0803ooOl0ooco0?koo`3lool0mOWj0?ono`3o
m?H0oo;`0?oik03on?00moko0?Ooo`3nool0n?Oc04e;C03ko?`0oOko0?[mo`3io?l0nooo0?ckoP3o
ool0oO_j0?omo03oo_d0o_kl0>KUj00A4Q@0m?Cd0?gmo@3oool0o_kn0`3oool00`3moOd0n_[j0?oo
o`020?ooo`080?gmo@2ZZZX0@d=301HF5P1cLg<0hN7Q0?knoP3inOT20?ooo`0306i^KP1hN7P0oooo
0080oooo00D0no_k0?knoP3no_h0oooo0?gmo@0@0?ooo`0F0?Win@3oool0moOg0?ooo`2<S8`071`L
0>?Sh`3oool0o_kn0?[jnP2FUYH0b<S80?ooo`3fm_H0oooo0?gmo@3oool0_[jn01<C4`2h^;P0oooo
0?KfmPl0oooo000@0?ooo`040?gmo@3no_h0oooo0?[jnP80oooo00T0n?Sh0?ooo`2JVYX0EeMG0;>c
/`0M7Ad0l?3`0?ooo`39bLT00P3oool0203gmoL0_Kfm0=[JfP3oool0o?cl0?knoP3oool0moOg0P3o
ool00`3moOd0o_kn0?clo0040?ooo`0=0?[jnP3inOT0o?cl0?ooo`1FEUH0SXj>0?ooo`3moOd0oooo
0?KfmP3oool0o?cl0?KfmP0T0?ooo`0A0?knoP3dm?@0oooo0?7al@13@d<0>SXj0>OWi`3oool0o?cl
0?gmo@3oool0o?cl0?ooo`3nool0oooo0?omo@3oo_d00P3lool02`3oo_l0oogm0?_fk03oooP0U9RQ
02hb>`3oooX0oooh0?7al@3nool0ooko00L0oooo00@0oOgm0?ooo`3oool0oOgm0P3oool02P3lo?`0
oooo0?3`l00J6QX00@4100<30`11@D40moOg0?ooo`3no_hH0?ooo`070?clo03oool0n_[j0?ooo`3n
o_h0oooo0?[jnP0I0?ooo`030?[jnP3oool0oooo00D0oooo00<0o_kn0>;RhP0=3@d00P0000000`1A
DE40n_[j0?gmo@030?ooo`030?knoP3oool0oooo01T0oooo00<0ooko0?kno`3oo_l00P3oooH20?ol
o`0J0?koo@3lood0nooo0??cl`0_82404P000;bZV`0V7A@0GfMi0>_go`3moOl0oook08J4Q@3Ee]H0
o_oo0?coo`3ko_l0o?oo0?ono`3emOD0ookm0?omo03oo_d0ooom07QgNP1^Kg420?ooo`080?clo03n
o_h0oooo0?gmo@3oool0o?cl0?ooo`3inOT20?ooo`0A0?knoP3oool0oooo0=[JfP1iNGT03Ph>04a<
C02_[jl0no_k0??cl`0E5AD0fMWI0?ooo`3kno/0n_[j0?ooo`3moOd05P3oool05@3moOd0o?cl08N7
Q`0_;bl0j^[Z0?ooo`3no_h0EeMG09nOW`3moOd0oooo0?gmo@3oool0d=3@01XJ6P2m_Kd0oooo0?Wi
n@3oool0no_k0?gmo@0=0?ooo`00403oool01@3jn_X0oooo0?knoP3moOd0no_k0080oooo00L0m_Kf
05eMG@2HV9P0o_kn075aL@19BDT0no_k0080oooo00`0o_kn0?ooo`2_[jl061PH02PX:01lO7`0lO7a
0?gmo@3kno/0o_kn0?Shn03no_h20?ooo`030?_kn`3lo?`0no_k00<0oooo00D0o?cl0>GUi@0<30`0
kno_0?KfmP030?ooo`040?_kn`3inOT0oooo0?_knb80oooo00X0n?Sh0?ooo`3oool0b<S801HF5P1j
NWX0n?Sh0?ooo`3kno/0n_[j0P3oool0203lo?`0o?go0?coo`3nool0oogo0?omo@3oood0o_oo0P3o
o_l02@3ooOT0oOch0;>f^P2DUIL0noGb0?okm@3nool0mo[n0?koo`070?ooo`040?knoP3oool0no_k
0?gmo@<0oooo00P0o?cl0?ooo`35aLD0000000<30`000000QXJ60?KfmQ`0oooo00D0m_Kf0?_kn`3n
o_h0Fe]K0?Shn00I0?ooo`80oOgm00@0o_kn0?ooo`3oool0o?cl0P3oool0200f=SH01PH60000000L
71`0inOW0?ooo`3lo?`0oooo0P3no_hL0?ooo`030?ono`3ooOl0ooko0080ooof01`0ooco0?omo`3n
oo/0o?oj0?_oo@3bl_008A4B0?;Mf02EPW401`000:2X_@3<f_@0o?oo0>k]j@1?CDh0SXn?0?_lo`3f
nOd0mo[n0?coo`3kn_d0oooo0?ono@3no?/0n_Sg0?ooo@0B4A@0fM[L0P3oool01@3no_h0oooo0?gm
o@3jn_X0no_k00@0oooo00l0moOg0?ooo`3inOT0o?cl0?ooo`3moOd0oooo09^KV`0m?Cd092@T05EE
E@2ATI40oooo0?clo03no_h00P3oool00`3jn_X0oooo0?ooo`0B0?ooo`0;0?Ogm`3moOd0oooo0?cl
o03oool0L71`03hn?P3fm_H0o?cl065QH@2NWYh0103oool01`2RXZ80gmoO0?gmo@3no_h0oooo0?Og
m`3no_h03P3oool00100oooo00H0oOgm0?_kn`3kno/0oooo0?knoP3kno/20?ooo`0601PH603Kfm/0
oooo0?ooo`1lO7`0X:2P0P3no_h01`3oool0no_k0?Shn03lo?`0c<c<07EeM@3@d=001@3oool01P3j
n_X0oooo0?ooo`33`l<05aLG0>[ZjP80moOg00<0oooo07QhN01WIfL00P3oool01P3no_h0oooo0?oo
o`3moOd0oooo0?clo240oooo00L0m_Kf0?ooo`3oool0o_kn08V9R@0D51@0/;2`0080oooo00h0o?cl
0?ooo`3oool0o?cl0?ooo`3kno/0o_oo0?Woo`3kool0oogo0?omo@3oo_d0o_om0?koo`<0ooko00L0
n_ci0?oon`3ooOP0oo_h0?koo`3iool0o_oo00L0oooo00<0o_kn0?ooo`3lo?`00P3oool01P3lo?`0
oooo0?ooo`3gmoL0oooo08N7Q`80000000<010@40<O7a`3oool06@3oool01P3jn_X0o_kn0?ooo`3o
ool0o?cl00410AX0oooo00D0oOgm0?ooo`3no_h0oOgm0?KfmP020?ooo`0607YjNP0000002PX:00@4
1036a/H0oooo0P3moOd70?ooo`030?knoP3oool0oooo01D0oooo01@0ooko0?omo`3oo_l0oooh0?oo
mP3oo?l0oogo0?oonP3kooP0n?oj0?;bkP0]7Ad0kMK@0?oji`0`9Ad0OXRQ0?7oo`3dmoh0oook0?Wg
n080o_oo00H0@4=701`O8`26RX/0hn;U0?ooo`3ooO`20?ono@070:ZZZ010?d80nocn0?ooo`3hn?P0
oooo0?Win@020?ooo`80n_[j00<0o?cl0?ooo`3oool0103oool02P3moOd0no_k0?ooo`3oool0o?cl
0=7Ad@1bLW802`/;04I6AP2i^KT20?ooo`040?Ogm`3hn?P0oooo0?Shn180oooo00<0no_k0?ooo`3o
ool00`3oool03@1MGEd0Bd];0?ooo`1OGel0WIfM0?ooo`3^k^h0no_k0?ooo`3kno/0o?cl0?ooo`3m
oOd00`3oool00`3fm_H0oooo0?ooo`0;0?ooo`004`3oool02P3kno/0oooo0?ooo`3fm_H0alO702TY
:@3moOd0oooo0?Shn03moOd40?ooo`0<0?clo03oool0oooo0?_kn`3dm?@0oooo0?knoP3kno/0oooo
024Q8@1gMgL0bLW90P3jn_X0303oool0RHV903Lg=`3jn_X0oooo0?_kn`0O7al0e]KF0?Win@3jn_X0
o_kn0?_kn`80oooo00<0nOWi0?ooo`3jn_X08P3oool0203QhN40DE5A03Xj>P3Jf]X0oooo0?gmo@3h
n?P0oOgm103oool0203jn_X0o?oo0?Soo`3iool0ooko0?omo@3oo_/0ooom0P3lool02@3oo?l0oO_n
0?konP3gmnd0ooch0?okn`3gn?P0nooo0?koo`0<0?ooo`030?[jnP3moOd0oooo0080oooo00H0moOg
04=3@`020P800@4101`L703/k>`H0?ooo`080?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/H
0?ooo`80o_kn0`3oool00`3no_h0oooo0;2`/00200410@0500000023Ph<0oooo0?ooo`3kno/01`3o
ool20?knoQL0oooo02H0ooko0?omo`3ooOl0oooh0?oomP3oo?l0oogo0?oon03kooH0m_og0?oon`1W
EeL0Z8n:0?ojj03=`[X01a8]0>cko`3lo_l0o?_g0?ono`3fmoL0mOKj0=gPi00C5QX0004200<21@09
2@T0D4i=07MeM02`[Zd0<C4_09NFV@3`lO<0n_[j0=oOg`2o_kl0W9bL0?;blP@0oooo00<0o?cl0?oo
o`3oool00P3hn?P04P3no_h0oooo0?ooo`3oool0oOgm0?ooo`3kno/0nOWi0?Shn02PX:00;Rh^02TY
:@25QHD0l_;b0?ooo`3moOd0oooo0?[jnQ40oooo00@0oOgm0?clo03oool0n?Sh0P3oool01`3gmoL0
B4Q805QHF01VIVH0X:2P0<?3``2JVYX01@3oool00`3no_h0n_[j0?knoP0?0?ooo`00403oool00`3h
n?P0oooo0?knoP020?ooo`040?[jnP3oool0Q8B407=cL`@0oooo00@0oOgm0?ooo`3kno/0nOWi0P3o
ool0303emOD0oooo0?ooo`3moOd0oooo0?gmo@3oool0dm?C07]kN`0Y:BT0ADE50?ooo`80o?cl00D0
BDU907IfMP3no_h0[Jf]03Ti>@040?ooo`060?clo03oool0no_k0?gmo@3oool0o_kn8@3oool01P36
a/H092@T071`L03gmoL0oooo0?_kn`<0oooo00`0m_Kf0?ooo`3no_h0o_kn0?ooo`3mo_l0nOoo0?_o
o`3oo_l0oogm0?onn`3oood20?coo`80ooko00L0o?kh0?oomP3oo?X0ooGd0?koo`3jool0o_oo00X0
oooo00H0m_Kf0?ooo`3oool0o_kn0?ooo`3lo?`20?ooo`050>3Ph00F5QH00`<30000001BDU80703o
ool20?knoP0300410@3oool0oooo01L0oooo00/0oOgm0?ooo`3lo?`0o_kn0?ooo`3moOd0hn?S01HF
5P0000000`<304U9B@020?ooo`030?knoP3lo?`0oooo01l0oooo02T0ooko0?omo`3oo_l0oooj0?oo
n03ooOd0oogo0?konP3looP0nook0?Oim03jk^h070X60>KFa`3ilN`000HK0=3Nn03joOl0o_ck0?kn
o03loOd0o_oo0?coo`3amOH0^KZl01<C4`0000000@0000T71P071@@00000014@4`010P@0000000@4
10000000:RXZ0?ooo`3kno/0oooo0?knoP020?ooo`050?[jnP3oool0oooo0?ooo`3moOd00P3oool0
3@3hn?P0oooo0?ooo`3kno/0oooo0?gmo@3lo?`0oooo0<W9b@1OGel03Ph>05YJFP32`/804P3oool0
103no_h0oooo0?ooo`3fm_H30?ooo`0<0?gmo@3fm_H00P82069RHP1GEeL05aLG0>7Qh@3kno/0o_kn
0?gmo@3oool0n?Sh0P3oool00`3no_h0oooo0?gmo@0=0?ooo`004@3oool02`3kno/0oooo0?ooo`3i
nOT0oOgm0?ooo`0a<C40`<300?[jnP3oool0oOgm00<0oooo00<0o_kn0?ooo`3oool01`3oool04@3m
oOd0oooo0?_kn`3moOd0i^KV0?[jnP3oool0oOgm0;no_`0K6a/0YJFU04a<C02RXZ80oooo0?knoP3o
ool0no_k00L0oooo00H0o?cl0?ooo`3oool0nOWi0?ooo`3lo?`20?ooo`0B0?clo03jn_X0oooo0?oo
o`3lo?`0oooo0?[jnP3no_h0oooo0?gmo@3kno/0o_kn0?ooo`3no_h0oooo0?gmo@3oool0oOgm0P3o
ool01P3hn?P0oooo0?gmo@2ATI405ADE0:j^[P80oooo00<0no_k0?ooo`3oool0203oool20?koo`04
0?ooo`3oo_l0ookm0?ooo`80o_oo00@0ooko0?ooo`3oood0oook0P3ooOd00`3oool0o_oo0?ooo`0@
0?ooo`090?gmo@3oool0o?cl0;Ng]`020P80000000820P2CTi<0oooo0080o_kn0P3oool00`3kno/0
oooo0?ooo`0?0?ooo`070?knoP3oool0oOgm0?gmo@3oool0o_kn0:JVYP0J0?ooo`0:0?KfmP3oool0
nOWi0?ooo`3kno/0?clo00820P010@406a/K0>_[j`80oooo00<0o_kn0?Win@3oool07`3oool01`3o
o_l0oogo0?omo`3oood0oook0?ono@3oood00P3noo/0703lood0n__k0?klo@3VhN40If=P06m^L@00
00`0XZRd0?[ko`3oood0o_om0?_mnP3nool0oOkn0?_lo03nool0no_i08B4PP0:2PX0000000H61P00
00801@@700000P0;2`/0=CDe0<[:bP3lo?`20?ooo`030?clo03moOd0o_kn0080oooo00`0o?cl0?gm
o@3oool0oooo0?knoP3oood0n_[h0?ooo@3Ti>@0C4a<0?[io03mo?l20?ono`0<0?SgnP3oo_l0l?3`
08Z:RP0R8R00=SHd09:BT03clo<0o?cl0?ooo`3no_h0oOgm0P3oool30?gmo@030?ooo`3lo?`0oooo
0080o_kn00H0oooo0?knoP3no_h0n_[j0?ooo`3gmoL20?ooo`090?[jnP3oool0nOWi01/K6`0G5aL0
g=cL0?clo03oool0o_kn01D0oooo000B0?ooo`80o_kn0P3oool02@3Ti>@061PH0?3`l03oool0o_kn
0?clo03oool0o?cl0?gmo@0>0?ooo`0;0??cl`3oool0oooo0?ooo`3Cdm<0:b/[00<30`0J6QX0h>3P
0?gmo@3lo?`00`3oool01`3lo?`0oooo0?[jnP3oool0n_[j0?ooo`3no_h00`3oool0103kno/0o_kn
0?_kn`3inOT20?ooo`80o?cl00@0oooo0?knoP3oool0mOGe103oool04`3jn_X0oooo0?gmo@3moOd0
oooo0?Cdm03kno/0o_kn0?ooo`3/k>`0FUYJ02l_;`3Ogml0oOgm0?knoP3moOd0oooo0?gmo@3no_h0
:03oool01P3lo?`0oooo0?ooo`3jn_X0oooo06MWI`800P8200H020P80<k>cP3oool0oooo0?knoP3j
n_XB0?ooo`080?[jnP3oool0n_[j0?ooo`3jn_X0o_kn0?ooo`3jn_XH0?ooo`0?0?knoP3oool0moOg
0?ooo`3lo?`0PH6100@4100000000@410;bl_03oool0o?cl0?Win@3oool0o_kn0240oooo0P3oo_l2
0?ooo`80ooom0P3nood00`3ko?`0o_oo0?Wjo0020?coo`060?Sko`2a];T0C4mD0?koo`3jno/0nO[j
0P3nood04@3lo_/0o_om0?[ln@3oood0no_i0=CDe00V9RH0000200<21@0000800P4406MWI`3UiND0
oooo0?gmo@3oool0oOgm00<0oooo00L0o_kn0?clo03oool0oooo0?_kn`3jn_X0oooo00<0ooom00H0
K6a/07QhN03oo_l0ooko0?glo`3noOl20?ono`080?gmo@3oool0o_kl0;6a[`1HF5H04Q8B06a/K03A
dM420?ooo`030?[jnP3moOd0oooo00<0oooo00D0no_k0?ooo`3lo?`0oooo0?clo0020?ooo`0:0?gm
o@3lo?`0oooo0?gmo@3kno/0oooo0?gmo@3oool0DU9B0861P@80oooo00<0m?Cd0?ooo`3oool0503o
ool00100oooo00@0o_kn0?ooo`3moOd0o_kn0P3oool01`2XZ:P0@d=30?ooo`3oool0n_[j0?knoP3o
ool00P3no_h;0?ooo`040?gmo@3oool0oooo0?knoP<0oooo00h0o_kn0?ooo`26QXH06a/K0:FUY@3h
n?P0oooo0?Ogm`3lo?`0oooo0?gmo@3no_h0oooo0?knoP80oooo00@0oOgm0?ooo`3no_h0o?cl1@3o
ool07@3kno/0o_kn0?ooo`3oool0nOWi0?_kn`3oool0m_Kf0?clo03kno/0o_kn0?[jnP3oool0no_k
0?ooo`3kno/0oooo0?[jnP3oool0dM7A028R8P1YJFT0o?cl0?ooo`3kno/0oooo0?gmo@3oool0n?Sh
02X0oooo00<0o_kn0?ooo`3moOd00P3oool02P0Z:RX0000000<30`0_;bl0n?Sh0?_kn`3oool0o?cl
0?knoP3moOdC0?ooo`040??cl`3oool0oooo0?;blQT0oooo00H0o?cl0?ooo`3moOd0nOWi0;jn_P01
0@420000000407inOP3oool0oooo0?Win@<0oooo00<0o_kn0?ooo`3oool07P3oool20?ono`@0oooo
0P3oood08@3lo?X0o_om0?cmo@3in_`0nocn0?koo`3Fem/000450>SYj`3nool0m_Oi0?cmo@3nool0
o?gm0?goo03nood0moOe0?ooo@3oool0V9RH01lO7`061PH01`H901HE601SHf<04a<C055AD@2h^;P0
no_k0?ooo`3^k^h0oooo0?_kn`030?ooo`0@0?knoP3oool0oooo0?knoP3oood0oOgk0?7al@0E5AD0
iNGU0?Gem@3noOl0no[m0?ckoP3kn_d0o?cl0?knoP80oooo0P3oood03@3Ti>@0Ng]k01lO7`0d=3@0
WinO0?[jnP3oool0moOg0?ooo`3kno/0o_kn0?ooo`3lo?`00`3oool03`3moOd0o_kn0?ooo`3oool0
n_[j0?clo03oool0lo?c0?ooo`3moOd0LW9b09BDU03no_h0oooo0?[jnP0F0?ooo`004P3oool0203l
o?`0oooo0?gmo@3no_h0Fe]K09jNWP3lo?`0o_kn0P3oool0103no_h0oooo0?ooo`3moOd:0?ooo`0I
0?clo03oool0o_kn0?ooo`3no_h0no_k0?[jnP3oool0no_k0?gmo@1OGel0GUiN0?ooo`3moOd0oooo
04A4A01HF5P0YZJV0?clo03moOd0nOWi0?clo03oool0nOWi0?clo0030?ooo`060?Cdm03oool0oooo
0?ooo`3gmoL0oooo0P3kno/60?ooo`0@0?_kn`3oool0lo?c0?ooo`3inOT0oooo0?[jnP3oool0V9RH
00d=3@2`/;00no_k0?knoP3dm?@0oooo0?gmo@80oooo00<0o?cl0?gmo@3oool0:03oool03P3moOd0
o_kn0?knoP3oool0oOgm0=GEe@0>3Ph020P80000001XJ6P0oooo0?Win@3oool0o_kn4@3oool01`3l
o?`0oooo0?[jnP3oool0o_kn0?ooo`3jn_X06P3oool02P3kno/0oooo0>c/k00L71`00`<300000019
BDT0oooo0?KfmP3kno/20?ooo`030?Win@3oool0oOgm0200oooo0P3oo_l40?ooo`<0ooom00T0no_i
0?ooo`3mo_h0oooo0?koo`34`lH0X:6S0>GVjP3dmOL00`3nool05`3mo_h0nocl0?_mnP3oood0kno]
0?ooo`0l?3`0/;2`04i>CP020@@01@@70<S8b03`l?00WIfM02l_;`0V9RH0R8R80>_[j`3oool0no_k
0?ooo`3kno/0n_[j0080oooo00H0n?Sh0?ooo`3inOL0ooom09fMW@1WIfL20?ooo`@0ooko00H0oooo
0?_kn`3lo?`0oooo0?ooo@3jn_P20?ooo`070?_kn`2i^KT0BTY:01DE5@1UIFD0gmoO0?knoP030?oo
o`080?[jnP3oool0o_kn0?_kn`3lo?`0oooo0?_kn`3moOd20?ooo`0709nOW`3>c/h0o_kn0?ooo`1h
N7P0Q8B40?[jnP020?ooo`030?_kn`3oool0oooo01<0oooo000A0?ooo`080?gmo@3lo?`0oooo0?oo
o`3jn_X071`L0=cLg03no_h20?ooo`050?knoP3inOT0oooo0?ooo`3no_h02P3oool0103no_h0oooo
0?_kn`3oool20?gmo@80oooo00`0n_[j0?ooo`3clo<092@T09VIV@3lo?`0n_[j0?Ogm`2CTi<0AdM7
00/;2`3gmoL20?ooo`060?clo03oool0o?cl0?[jnP3oool0no_k0P3oool00`3lo?`0oooo0?gmo@03
0?ooo`030?clo03moOd0oooo00<0oOgm00@0oooo0?gmo@3oool0no_k0P3oool01@3/k>`0FEUI034a
<@3GemL0n?Sh00<0oooo00<0no_k0?ooo`3moOd00P3oool00`3kno/0oooo0?ooo`0V0?ooo`030?[j
nP3oool0o?cl0080oooo00P0o_kn0?gmo@2LW9`0000000410@061PH0YjNW0?knoQH0oooo00D0m_Kf
0?_kn`3no_h0Fe]K0?Shn00J0?ooo`0>0?_kn`12@T8000000000000P8200h^;R0?ooo`3no_h0nOWi
0?ooo`3kno/0o?cl0?ooo`3no_hP0?ooo`80ooko103oool30?ooo@0S0?gmn`3no_`0o?cj0?Oem01[
Jf/0o_cm0?Gdm`3loOl0Rhb@0=7BeP3gn?X0o_oo0?gnoP3loOd0o_oo0?knoP3oool0e]KF01/K6`3j
n_X0oooo07AdM0020P80HV9R0?ooo`3no_h0n_[j0<?3``1UIFD04Q8B05IFEP30`<00no_k0?ooo`3j
n_X00P3oool01P3jn_X0oooo0?ooo@3lo?X0oooo0?Ogm`80oooo00D0nOSk0?ono`3oo_l0oOco0?gm
o@030?ooo`80ooom00h0n?Sh0?ooo`3oool0n_[j0?_kn`3Lg=`0O7al01TI6@16ATH0[:b/0??cl`3j
n_X0oooo0?gmo@@0oooo00X0o_kn0?gmo@3jn_X0Jf][02LW9`3`l?00o?cl0?ooo`1aLG40R8R80P3o
ool00`3lo?`0oooo0?ooo`0D0?ooo`00403oool02P3lo?`0oOgm0?ooo`3no_h0oooo0=KFeP0R8R80
o?cl0?ooo`3moOd40?ooo`80o_kn303oool01P3jn_X0oooo0?gmo@3oool0no_k0?Win@80oooo00H0
o?cl0>_[j`1YJFT0gmoO0?ooo`3jn_X20?ooo`090>_[j`3inOT0oooo0?knoP3UiND0UYJF0??cl`3o
ool0n?Sh0080oooo00D0o_kn0?ooo`3lo?`0oooo0?_kn`020?ooo`080?Gem@3oool0hN7Q07EeM@1g
MgL0PH610<71`@3lo?`20?ooo`050?[jnP3?cll0:b/[065QH@3dm?@00P3oool01@3no_h0o?cl0?gm
o@3lo?`0nOWi0080oooo00<0moOg0?ooo`3oool0:03oool03P3emOD0o_kn0?ooo`3oool0n_[j0?oo
o`3hn?P0Fe]K00H61P0000004A4A0>3Ph03oool0no_k4P3oool01P3jn_X0o_kn0?ooo`3oool0o?cl
00410AT0oooo00<0o?cl0?_kn`27QhL00P020P802P092@T0/[:b0?ooo`3hn?P0oooo0?gmo@3oool0
o?cl0?ooo`3no_hQ0?ooo`80ooko103oool20?ooo@030?[jn03oood0nOOf0080ookm01H0/:j]08F3
PP3oo_l0c/gB061PIP3no_l0o?go0?koo`3mo_l0o_oo0?[kn`3moOd0oooo06=SH`1lO7`0oooo0?kn
oP3moOd0De=C0000003moOd0o_kn0P3oool03`3jn_X0lO7a096AT@0];Bd0:BTY08V9R@3alO40n_[j
0?KfmP3oool0oOgm0?ooo@3jn_P0o_kn0?ooo`020?clo0080?ono`3noOl0oOco0?ono`3oool0oOgm
0?Shn03jn_X20?ooo@H0oooo00L0o_kn0?Ogm`2RXZ80?clo01/K6`3UiND0l_;b0080oooo00P0o_kn
0?ooo`3fm_H0n_[j0?ooo`1;Bd/0ATI60?KfmP80oooo00D0oOgm0820P026QXH0oOgm0?[jnP0G0?oo
o`00403oool01`3jn_X0oooo0?ooo`3oool0n_[j09>CT`1TI6@00P3oool00`3inOT0oooo0?ooo`02
0?ooo`030?[jnP3no_h0oooo00P0oooo00H0o?cl0?ooo`3oool0o?cl0?ooo`3lo?`30?ooo`060?Sh
n03lo?`0oooo0?_kn`3oool0o?cl0P3oool02`3jn_X0moOg0?ooo`3hn?P0oOgm0?ooo`3_knl0Fe]K
00`<3012@T80_[jn0080oooo01D0n_[j0?ooo`3moOd0oooo0?clo03jn_X0oOgm0?ooo`3[jn/0I6AT
0?ooo`3hn?P0oOgm0<o?c`1iNGT0IVIV0:ZZZP2HV9P06QXJ09bLW03lo?`00P3oool00`3gmoL0oooo
0?ooo`040?ooo`030?[jnP3oool0no_k02T0oooo00<0oOgm0?clo03inOT00P3oool0203lo?`0oooo
0?;blP0M7Ad00P8200D51@0i>CT0n?Sh4P3oool0203inOT0oooo0?ooo`3oool0n_[j0?ooo`000000
no_k6@3oool02`33`l<00@41000000000000LW9b0?ooo`3lo?`0oooo0?Ogm`3no_h0o?cl0080oooo
00<0no_k0?ooo`3oool07`3oool20?koo`@0oooo0P3oo_d0703ooO`0noWh0?onn`3nn_L0ookk0?ol
n@1>BTL0dLo@030_=03UiN/0moOm0?koo`3hnOd0o_oo0?cmo`3nool0o_kn0?KfmP0<30`0kNg]0?gm
o@3lo?`0no_k0?ooo`2>SXh0bl_;0?Shn03jn_X30?ooo`070?knoP3kno/0`l?305IFEP0J6QX0GEeM
0<_;b`020?gmo@040?clo03oool0o_kn0?gmo@80oooo00D0moOg0?ooo`3oool0n_[j0?Win@030?oo
o`050?knoP3oool0oooo0?gmo@3kno/00P3no_h01`3jn_X0no_k0?ooo`3oool0moOg03Ph>02TY:@0
0P3oool03P3emOD0oooo0?ooo`3no_h0oooo0?knoP21PH40oooo0?clo03kno/0o_kn0?_kn`32`/80
]kNg0`3oool00`3jn_X0oooo0?ooo`0C0?ooo`004P3oool01P3inOT0oooo0?knoP1OGel0WYjN0?[j
nP<0oooo00@0no_k0?clo03oool0no_k2P3oool00`3kno/0oooo0?ooo`020?ooo`090?_kn`3oool0
oooo0?ooo`3moOd0oooo0?[jnP3oool0oOgm0080oooo00@0n_[j0?ooo`3oool0o?cl0P3oool07P3m
oOd0oooo0?knoP3emOD0ZJVY09BDU03oool0n?Sh0?ooo`3bl_80o?cl0?gmo@3oool0o_kn0?ooo`3n
o_h0CDe=0?Shn03no_h0oooo0?knoP3kno/0oooo0?Ogm`1HF5P05ADE05ADE02NWYh0j^[Z0?[jnP<0
oooo00@0o?cl0?ooo`3oool0no_k0P3oool00`3kno/0oooo0?ooo`0W0?ooo`050?clo03oool0oooo
0?ooo`3kno/00`3no_h01P3jn_X0clo?00<30`0000000P820820P080oOgm503oool20?knoP030041
0@3oool0oooo01L0oooo00h0inOW01`L700000000@410492@P3jn_X0oooo0?clo03inOT0oooo0?kn
oP3oool0n?Sh0?knoR80oooo0P3nool40?ooo`<0ookm01<0oO_j0?omnP3oo_/0n_Kc0?onn`3/j>D0
0@000:ZY[`3no_l0oOgo0?kno`3nool0nO[n0?koo`3loOl0o_kn09FEU@1HF5P0n_[j00<0oooo00<0
o?cl0?ooo`3kno/00P3oool00`3kno/0o_kn0?knoP030?ooo`080?knoP3Xj>P0SHf=024Q8@0^;Rh0
U9BD0??cl`3no_h20?ooo`030?_kn`3oool0oooo00@0oooo00<0oOgm0?clo03oool00P3oool00`3m
oOd0oooo0?ooo`040?ooo`80o_kn00@0dm?C01TI6@3oool0o?cl0P3oool0103kno/0o?cl0?ooo`3l
o?`20?ooo`030?_kn`3oool0oooo0080oooo00D0o?cl0?ooo`3moOd0oooo0?clo00F0?ooo`002P3o
ool00`3hn?P0oooo0?ooo`020?ooo`80o_kn00H0oooo0?gmo@3oool0oooo02`/;037alLa0?ooo`0;
07moO`0j>SX0SHf=0>;RhP3no_h0oOgm0>WYj@2=SHd0o_kn0?ooo`3no_h00P3oool0303Jf]X0:RXZ
05UIF@3dm?@0oooo0>KViP2HV9P0KFe]09:BTP3Hf=P0oooo0?knoP<0oooo00<0no_k0?Shn03oool0
0P3lo?`20?ooo`070?knoP3oool0oooo0?_kn`3no_h0oooo0?gmo@030?ooo`030?knoP3oool0oOgm
0280oooo00D0R8R8000000061PH000000<30`0020?knoP050?ooo`3no_h0oooo0?_kn`3no_h02P3o
ool01`3no_h0oooo0?gmo@3moOd0oooo0?knoP2VYZH04`3oool02`3inOT0oooo0?ooo`3oool0o?cl
0?knoP17AdL02PX:0000000E5AD0i>CT0080oooo00<0o?cl0?ooo`3oool09P3oool20?koo`@0oooo
0P3oo_l0103mnoX0ookm0?omo@3on_X20?onn`030?Sdl@3Qgmh0mOCj0080o_ko00P0m_Kl0?gno`3n
ool0o?go0?koo`3kno/0:BTY0;no_`80oooo00<0n_[j0?ooo`3moOd02P3oool0303kno/0oooo0?kn
oP3no_h0_[jn05=CD`0A4A40UYJF0?ooo`3lo?`0o_kn0?gmo@<0oooo0P3no_h01P3oool0o_kn0?oo
o`3no_h0oooo0?gmo@80oooo00<0n_[j0?ooo`3no_h00P3oool00`3lo?`0KVi^07]kN`020?ooo`09
0?[jnP3oool0oOgm07MgM`3oool0o_kn0?ooo`3moOd0o_kn01l0oooo00080?ooo`080?Win@3kno/0
oooo0?clo03no_h0nOWi0?ooo`3kno/30?ooo`050?clo03jn_X02PX:0?gmo@3inOT0<03oool0203j
n_X0^[Zj05]KF`0H61P0clo?0?knoP2CTi<0k^k^0P3oool04P3`l?00oooo0::RXP0A4A40X:2P0?oo
o`3moOd0oooo0?gmo@3lo?`0oooo0>o_k`2][Jd0J6QX08J6QP3IfMT0nOWi0?_kn`<0oooo00L0oOgm
0?ooo`3emOD0o?cl0?ooo`3fm_H0nOWi0080oooo00D0o?cl0?ooo`3oool0oOgm0?[jnP0S0?ooo`80
oOgm00P0nOWi04A4A00000001`L701XJ6P3/k>`0oooo0?knoP@0oooo00<0no_k0?gmo@3oool01`3o
ool0203jn_X0oooo0?[jnP3oool0n_[j0?knoP3oool0n_[j403oool03P3jn_X0oooo0?ooo`3gmoL0
nOWi0?ooo`3moOd0T92@00<30`00000020P80;Fe]@3no_h0nOWi:P3oool20?koo`@0oooo0`3oo_l0
103oo_d0oogm0?okn`3ooOd20?onn`040?WgmP3oo_l0moOm0?gmo`80o_oo00L0o?go0?koo`3jnod0
b/[:02TY:@3hn?P0oOgm0080oooo00<0oOgm0?ooo`3oool01`3oool0103hn?P0oooo0?ooo`3kno/4
0?ooo`030=?Cd`0410@0lo?c0080oooo00X0n_[j0?knoP3moOd0mOGe0?ooo`3kno/0oooo0?Win@3o
ool0nOWi0P3oool01P3emOD0oooo0?ooo`3gmoL0oooo0?knoP80no_k00/02`/;0>o_k`3no_h0mOGe
0?ooo`3]kNd0A4A404U9B@3gmoL0oooo0?Win@020?ooo`030?Win@3moOd0oooo01`0oooo000:0?oo
o`040?Gem@3no_h0oooo0?Shn0<0oooo00L0no_k0?ooo`3oool0alO702d];@3oool0o_kn03<0oooo
00P0n?Sh0>KViP3no_h0JVYZ0?ooo`0a<C400000014A4@809BDU00<0f=SH0?Ogm`3no_h00`3oool0
0`3no_h0n_[j0?clo0020?ooo`060?;blP2b/[80Jf][07moO`34a<@0n_[j2@3oool00`3gmoL0oooo
0?knoP030?ooo`030?[jnP3inOT0o?cl0240oooo00d0n_[j0?ooo`3Zj^X04a<C000000071`L0C4a<
0?knoP3oool0o?cl0?Win@3oool0o_kn00d0oooo00@0lo?c0?ooo`3oool0l_;b4`3oool02@3gmoL0
oooo0?clo03oool0a<C400<30`010@401@D506EUI@020?ooo`030?clo03oool0o_kn02P0oooo0P3o
ood40?ooo`050?ono`3oool0oooo0?ooo`3ooOh00P3oo_d0203no?/0oook0?ono@3oo_l0n?Sn0?kn
o`3nool0noco0`3nool0201FEUH0RHV90?ooo`3kno/0oOgm0?ooo`3lo?`0o_kn2@3oool20?knoP0=
0?gmo@3oool0no_k0?Gem@3oool0Lg9e07IeN03jn_X0oooo0?knoP3oool0ooom0?gmn`020?ooo@04
0?gmo@3oool0oooo0?_kn`80ooko00H0n_[j0?ooo`3oool0n_[j0?ooo`3jn_X20?ooo`0809NGU`1A
DE40n?Sh0?gmo@3oool0nOWi01lO7`1dM7@20?ooo`040?KfmP3oool0no_k0?Ogmal0oooo00080?oo
o`040?_kn`3inOT0oooo0?gmo@80oooo00@0n?Sh0?ooo`3oool0n_[j0P3oool00`2=SHd0L71`0?Ge
m@0a0?ooo`030?knoP3lo?`0m_Kf0080oooo00P0kno_09:BTP2UYJD010@400d=3@020P80000002HV
9P<0oooo0P3jn_X01P3moOd0oooo0?ooo`3oool0o_kn0?gmo@<0oooo00L0oOgm0;jn_P1fMWH0Lg=c
0;bl_03jn_X0o_kn00<0oooo00@0o_kn0?ooo`3oool0no_k0P3oool01@3lo?`0oooo0?ooo`3oool0
o?cl0200oooo0P3no_h01`3oool0o_kn0;Bd]00410@01`L70000002CTi<00P3oool01@3inOT0oooo
0?gmo@3oool0o?cl00P0oooo00L0o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[j0180oooo00H0o_kn
0?ooo`3kno/0oooo0>c/k00N7Qh20000000703Lg=`3oool0oOgm0?clo03no_h0oooo0?_kn`0X0?oo
o`80ooom103oool30?ono`080?knoP3oool0oooo0?ono`3jn_P0oO_j0?ooo@3in_h20?koo`0=0?_l
oP3loOl0o_oo0?Sin@3]k^h04a<C0?7al@3kno/0o?cl0?ooo`3moOd0oooo0?gmo@090?ooo`040?[j
nP3oool0oooo0?knoP80oooo0280m_Kf01<B5@3Kf]d0oooo0?Ogm`3no_h0oooo0?[jn03oood0o_kl
0?Kfm03oool0o_kn0?clo03oool0oOco0?[io03oool0oOgm0?ooo`3kno/0oooo0?clo03oool0mOGe
02`/;02k^k/0oooo0?gmo@3oool0gMgM0:RXZ03oool0n_[j0`3oool0103inOT0o_kn0?ooo`3hn?PM
0?ooo`002@3oool03@3inOT0oooo0?ooo`3moOd0nOWi0?ooo`3moOd0oooo0?knoP3oool0oOgm06AT
I02FUYH0=@3oool01@3inOT0o_kn09VIV@3Xj>P0:RXZ0080000000H010@400410@0;2`/0k^k^0?gm
o@3jn_X90?ooo`0>0?Win@3lo?`0oooo0?Ogm`3oool0nOWi0=3@d01gMgL0MGEe0:f][@3emOD0oooo
0?_kn`3moOd30?ooo`050?knoP3moOd0oooo0?gmo@3kno/08@3oool03P3no_h0oooo0?Win@3kno/0
oooo06e]K@0000002PX:00/;2`3;bl/0no_k0?ooo`3kno/0o_kn3@3oool01@3fm_H0no_k0?knoP1K
Fe/0n?Sh0100oooo00X0o_kn0?_kn`3oool0no_k0?[jnP1FEUH00`<30000000A4A40hN7Q0`3oool0
0`3moOd0oooo0?ooo`0X0?ooo`@0ooom0P3oool20?ono`0;0?ckoP3noOl0ooko0?koo`3oool0o_oo
0?ooo`3nool0o?go0?koo`3jnod0103nool01`2;SHX0G5aJ0?kno03moOd0o_kn0?ooo`3gmoL00P3o
o_l80?ooo`030?Win@3no_h0oooo0080oooo00D0n?Sh0?ooo`2<S8`0E5=F0?ono`030?ooo`0=0?Wi
n@3oood0_[jl0000001CDe40MGEe0?ooo`3moOd0oooo0?_jo@3oo_l0oooo0?Shn0020?ooo`060?kn
oP3oool0l?3`0<k>cP0W9bL0o_kn0P3oool0103inOT0mOGe0?knoP3moOd20?ooo`050?[jnP3gmoL0
oooo0?ooo`3fm_H07P3oool000P0oooo00<0m_Kf0?ooo`3kno/00`3oool0203lo?`0oooo0?ooo`3o
ool0oOgm0?ooo`0Y:BT0b<S8<P3oool03P3no_h0oooo0?[jnP3moOd0no_k06a/K03oool0=cLg00H6
1P0000000@410000000I6AT0n?Sh0P3oool01P3lo?`0oooo0?knoP3lo?`0no_k0?knoP80oooo00<0
oOgm0?ooo`3no_h00P3oool02P3lo?`0oooo0?[jnP3no_h0oooo0=7Ad@23Ph<0KVi^0:^[Z`3/k>`3
0?ooo`80o?cl0P3oool00`3kno/0oooo0?ooo`0S0?ooo`030?Cdm03lo?`0>CTi0080000000H0;2`/
0?KfmP3kno/0o_kn0?ooo`3gmoL:0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@414P3oool0103j
n_X0oooo0?ooo`2DU9@20000000900410@2_[jl0oooo0?ooo`3dm?@0oooo0?knoP3oool0o?cl02P0
oooo103oood20?ooo`80ooko00<0o_go0?koo`3nool00P3mo_l20?koo`050?gnoP3nool0nocn0?cm
o`3mo_h00P3nool01P3jo?T07b4N0<_;b@3moO/0oooo0?knoP80oooo00<0no[m0?ono`3oool02P3o
ool02@3gmoL0oooo0?ooo`3kno/092@T0<?2a@3oo_l0mOGe0?_kn`020?ooo`80ooom00T0a<C20;Rh
]P3alO40o_kn0?gmo@3lo?`0ooko0?ckoP3no_h00P3oool02P3kno/0oooo0?ooo`3oool0GemO08F5
Q@3alO40MWIf0?_kn`3lo?`20?ooo`80oOgm00D0n_[j0?ooo`3oool0nOWi0?clo00O0?ooo`00203o
ool0203moOd0oooo0?ooo`3lo?`0oooo0?gmo@3oool0no_k0P3oool01@3kno/0mOGe00h>3P3jn_X0
nOWi0340oooo0140no_k0?ooo`3oool0oOgm0?clo027QhL0lo?c0;2`/0092@T0000000820P000000
XZ:R0?Win@3oool0nOWi0?gmo@070?ooo`090?knoP3moOd0nOWi0?clo03oool0mOGe0;2`/00@4100
h^;R0080oooo00L0o?cl0?ooo`3Jf]X0TY:B06MWI`2PX:00g=cL00@0oooo00<0o_kn0?ooo`3oool0
8P3oool02P3lo?`0oooo0?ooo`3Jf]X03@d=00820P000000HF5Q0?ooo`3lo?`20?ooo`030?KfmP3o
ool0oooo00H0oooo00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_kna40oooo00P0n_[j0?oo
o`3@d=000`<30000000820P0IfMW0?clo080oooo00@0o?cl0?ooo`3no_h0n_[j:@3oool01P3oo_d0
oook0?ooo@3oood0oooo0?ono`D0o_oo0P3jo_l20?_oo`040?[no`3mo_h0o_oo0?koo`80n_ci00/0
o_om0;:d/@0b=340o?cj0?ooo@3kno/0oooo0?kmo`3oo_l0o?_n0?kmo`080?ooo`090?knoP3lo?`0
oooo0?ooo`3lo?`0oooo0:f][@0i>CT0o?_n0080ooko00<0n_[j0?ooo`3lo?X00P3oood00`3lo?X0
^;Rf0:b/ZP020?ooo`80n_Wl00`0ooko0?ooo`3moOd0oOgm0?ooo`3lo?`0o_kn0?;blP092@T0aLG5
02HV9P2HV9P30?ooo`030?gmo@3oool0o_kn00D0oooo00<0oOgm0?ooo`3oool0703oool0000E0?ko
o@3oood0ooko0?ono`3oool0ooom0?oon`3oood0ooko0?Sio@3mo?l0ooko0;2ZZP0<1`L0jn[]0?ko
o`3noOl0o_kn0?ooo`3;bl/0;2`/0080oooo00<0o?cl0?ooo`3oool0;`3oool02`3hn?P0oooo0?gm
o@2k^k/0d=3@0?ooo`3no_h0/k>c04I6AP0V9RH0[Jf]00<0oooo00<0o_kn0?ooo`3oool0103oool0
3P3no_h0o_kl0?omo@3oo_d0o_oo0?coo`3jnO`0ookm0?_hl@1LFeH0l??g0?[mo`3mo?l0oO_n0P3o
o_l02@3no_`0oook0>CThP2OWil0JVYZ08n?S`3Ogml0oooo0?gmo@0R0?ooo`030?gmo@3lo?`0oooo
0080oooo00T0n?Sh0:JVYP030`<0000000410@2^[Zh0nOWi0?ooo`3no_h03@3oool20?knoP030041
0@3oool0oooo00l0oooo00P0n_[j0?ooo`3_knl07QhN00D51@000000<C4a0?knoPD0oooo00<0oOgm
0?knoP3no_h0:03oool20?ono@040?ooo@3oool0oooo0?ono`<0o_oo00D0oOko0?koo`3lool0o_oo
0?coo`020?koo`0@0?cmo@3nool0o_om0?goo03nood0nogj059DD@2HVYL0ooom0?Wim`3no_h0oooo
0?glo`3jnO`0ooko0?kmo`P0oooo00<0o_kn0?ooo`3lo?`00P3oool03`3gmoL0@D510:VWYP3oo_X0
o?_g0>[]lP3lo_l0ooWo0?Scm`3lool0n?kj0?onm`3oooX0T96C0<_>d`020?kno`050?ooo@3Sh]h0
_Kfk0?ooo`3no_h00P3oool01@3kno/0T92@055AD@0D51@0X:2P0080oooo00<0no_k0?ooo`3gmoL0
0`3oool00`3moOd0oooo0?Win@020?ooo`030?_kn`3oool0oooo01/0oooo00005`3kooL0o_ok0?om
o`3on_l0ookm0?kmmP3hmN`0WYfI09fMY@2[[KT0ooko0?ojo@3oknd0JemN0>k^mP3kool0o_oo0?oo
o`3no_h0UYJF06EUI@3oool0o_kn0340oooo00/0o_kn0?ooo`3oool0oOgm09>CT`3hn?P0oooo0?_k
n`3no_`0nOWg0?gmo@020?ooo`070?knoP3oool0oOgm0?gmo@3oool0ooom0?gmn`020?ooo@0C0?gm
n`3ooo/0oocg0?omnP3kool0mooo0?koo`3onoL0oo_T0:JRTP2d_/L0loko0?omo`3on_l0oo_o0?gk
o`3oooX0oooe0?oon`020?ooo`050>WYj@2NWYh0JFUY08b<S03Cdm<00P3oool0203hn?P0oooo0?oo
o`3oool0o?cl0?knoP3oool0oOgm0`3oool01P3jn_X0oooo0?knoP3oool0o?cl0?gmo@80oooo00<0
o?cl0?gmo@3oool0403oool01@1KFe/01`L70000000>3Ph0gmoO0080oooo00<0oOgm0?ooo`3moOd0
0P3oool01P3hn?P0oooo0?ooo`3oool0o_kn0?ooo`80oOgm00<0oooo0?knoP2VYZH02P3oool03P3i
nOT0o_kn0?ooo`3no_h0nOWi0?ooo`3lo?`0oooo0?_kn`1HF5P01@D50000000?3`l0g]kN>@3oool0
1P3oo_l0oooo0?ono`3nool0oooo0?koo`<0oooo00P0n_[j0?ooo`3oool0o?cl0:f][@0?3`l0l_;b
0?knoP<0oooo00@0o_kn0?ooo`3moOd0oooo0`3no_h40?ooo`040?gmo@3oool0oooo0?[jnP80oooo
01l0b<S801lO7`3kn?40oo_W0>3Jc0000Ph0:C180<>cb`0800/0ZkVj0?7on03Xi]D0ooc`0;g1b01[
LhD0n?co0?cno`3oooP0k^cM02XY900Y:BT0TI6A0?Cdm03lo?`0oooo028R8P20P800c/k>0?clo03o
ool0nOWi0080oooo00D0n_[j0?ooo`3lo?`0oooo0?_kn`020?ooo`030?knoP3oool0oooo01d0oooo
00004@3kooP0o_ok0?olo`3oo?l0oogf0?omm03mnOD0i>;S01DC7P38am@0oO_o0?olo`3on_H0Z9ZG
0;Jf`03iool0o_oo0080oooo00@0JVYZ09:BTP3oool0o?cl<P3oool0103inOT0oooo0?ooo`1kNg/2
0?_kn`060?ooo`3oood0ooom0?ooo`3inOT0o?cl0`3oool06`3kno/0oooo0?ooo@3no_`0n_[h0?oo
o@3ooo/0oogi0?oimP3hk^`0k_Cd0?Coo`3hool0o_oj0?ooiP3Je<80IF]i0?Ono`3lnOl0oOWo0?ol
o`3mnol0oOcg0?oom@3knoL0oooo0?Win@030?ooo`070>[ZjP2f][H0IVIV08B4Q03?cll0n_[j0?Sh
n0050?ooo`040?clo03oool0nOWi0?knoP@0oooo00<0o_kn0?_kn`3moOd00P3oool00`3lo?`0oooo
0?ooo`0>0?ooo`060?Gem@0N7Qh00@4100@4100j>SX0kno_0`3oool00`3jn_X0no_k0?ooo`020?oo
o`0:0?clo03oool0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnPP0oooo00<0no_k0?ooo`3m
oOd00`3oool0103emOD0oooo0?ooo`2QXJ43000000030:b/[03hn?P0oooo04@0oooo00L0n_[j08J6
QP000000HF5Q0<G5a@3oool0no_k0080oooo00<0n_[j0?gmo@3oool0103oool09P3lo?`0oOgm0?oo
o`3oool0oOgm0?Ogm`3oool0no_k0?KfmP1WIfL0RXZ:0?omm@3on=l0W9F304eJJ`3co?l08``T01`7
5P2P/KH0j?ok0>KWe`19ACT00PH=0;g5e`3ho_l0n_co0?oon03ooo40oOcg0<?3``1MGEd03@d=06QX
J02JVYX0<C4a0?Shn03oool0o?cl0P3oool0103inOT0no_k0?ooo`3no_h30?ooo`030?Ogm`3lo?`0
o_kn01l0oooo00005`3ioO`0n?Wi0?omo`3ooOX0oooa0?ool`3inOl0ooco07E]N02]YJh0o_ko0?kn
oP3oo?H0h=KD07EdP@3en?l0o_ko0?gmo@3oool0;bl_0<c<c03oool0o?cl0340oooo00/0no_k0?oo
o`3oool0moOg0;Rh^02OWil0oooo0?clo03oood0nOWg0?clo0020?ooo`80o_kn0P3oool00`3jn_X0
n_[h0?ooo@020?ooo@0C0?knnP3onOT0H4mE08n0P`23Q7`0PHj40>[oo`3bool0m?GU0?omm01QF6P0
ln_o0?omo`3fnOl0noko0?koo`3ooo/0oooj0?clnP020?ooo`030?knoP3gmoL0moOg00<0oooo00D0
n?Sh0;Jf]P1jNWX0NWYj0;bl_0020?knoP030?gmo@3jn_X0oooo0080oooo00@0n_[j0?ooo`3hn?P0
oOgm0`3oool00`3no_h0o?cl0?knoP0B0?ooo`070<g=c@0820P000000000001nOWh0oooo0?Shn003
0?ooo`040?clo03oool0oooo0?[jnP@0oooo00@0lo?c0?ooo`3oool0l_;b2P3oool03@3hn?P0o_kn
0?gmo@3oool0no_k0?knoP3oool0clo?00<30`0000000`<306e]K@3moOd0A03oool02P3lo?`0n_[j
0?ooo`3emOD02`/;07alO00P8200<30`0:2PX03_knl20?ooo`050?_kn`3no_h0oooo0?_kn`3hn?P0
0P3oool01@3no_h0no_k0?ooo`3oool0oOgm0080oooo0200i^KV00d=3@3]kNd0oooh0?ooj03;a;T0
1PdU0?7do`3hh^D03@000<gNiP3]ool0o?om0?_jm@3al_@0nooo0?Wlo`3nool0ooom0?knnP3oood0
o_kn0?Gem@33`l<0B4Q80000000S8b<0[Jf]0?Win@3oool0n_[j0?Ogm`80oooo00D0mOGe0?ooo`3o
ool0moOg0?gmo@020?ooo`030?knoP3oool0o?cl01d0oooo00005`3no_l0ooko0?omo@3ono<0ooo/
0=cLd00001408Ale08]kQ@1NDU@0o?oo0?Soo`3oo_P0no?`05eKJ03jo?l0o_ko0?knoP3oool02PX:
0??cl`3oool0o_kn0380oooo00`0mOGe0?ooo`3oool0oooo0;Jf]P1^KVh0lO7a0?ooo@3jn_P0o_kn
0?ooo`3inOT20?ooo`0K0?Gem@3inOT0oooo0?ooo@3no_`0no_i0?kno03ooo/0oo[j02LJ8@3SemT0
oood096KSP1BIVD0kooo0?konP3Rf]L06@dI0=G<g03fnOl0nOoo0?WmoP3nool0ookm0?_in03oool0
n_[j00@0oooo00/0o_kn0?gmo@3no_h0no_k0?knoP3oool0n?Sh0<[:bP1iNGT0Kfm_0;>c/`020?oo
o`040?Ogm`3kno/0oooo0?_kn`<0oooo00H0oOgm0?knoP3oool0oooo0?gmo@3lo?`@0?ooo`80oOgm
00D0Rh^;000000061PH000000;^k^`020?ooo`040?knoP3oool0oOgm0?_kn`80o_kn00P0oooo0?cl
o03oool0n_[j0?ooo`3no_h0oooo0?[jnPX0oooo00<0no_k0?ooo`3no_h00`3oool02@3Zj^X09BDU
00L71`061PH0:2PX0??cl`3no_h0oooo0?[jnP110?ooo`0=0?clo03oool0oooo0?Shn03oool0N7Qh
07AdM03oool0]kNg059BDP0<30`0Jf][0=KFeP020?ooo`030?Win@3no_h0oooo00D0oooo02@0o_kn
0?ooo`3oool0oooo07MgM`1WIfL0oooo0?omn@3ooNh0l>_S01HK;`3Qgo@0ooW^089aI@1mSI`0j_oo
0?Woo`3dm?00oook0?ooo@3lo?`0oOco0?[ko@3nool0o_kn0?ooo`2f][H06a/K0;^k^`0@4100YZJV
03De=@0G5aL0P8200>?Sh`3oool20?knoP80oooo00H0o_kn0?ooo`3moOd0m_Kf0?ooo`3lo?`O0?oo
o`0001P0o_co0?kko`3ooO/0ooca0?ghhP2c/jT01`dU0?Gdo`0e82<07`d70?3en@3eool0ooom0>;M
g@0B41/0a/GB0?kmo`3oool0lo?c00X:2P3oool0o_kn0?ooo`3no_hb0?ooo`090?knoP3oool0moOg
0?gmo@3`l?00TI6A06][J@2^[Z`0kno_0080oooo00<0oOgm0?ooo`3oool00P3oool06P3oood0oOgk
0?ooo@3oood0no_g0?oon`2=Rh`0QX610?onn03hm?405QTP0=_Mi`3oo_l0m?;c0?omo`3hn?h0n?oo
0?GooP0n?S`0Thj>0>7LgP3ooOl0oooo0?knoP3lo?`0oooo0P3moOd01P3oool0o_kn0?ooo`3clo<0
c/k>0?KfmP80oooo00/0no_k0?ooo`3De=@0OWin06][J`2][Jd0nOWi0?KfmP3no_h0oooo0?Shn002
0?ooo`050?knoP3moOd0oooo0?ooo`3no_h04P3oool0203lo?`0BDU900410@0000006ATI0>KViP3o
ool0oOgm0P3oool0103moOd0oooo0?ooo`3moOd30?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P0203o
ool00`3no_h0oooo0?clo0020?ooo`070?Ogm`3oool0Hf=S000000030`<02@T90=kNgP030?clo4<0
oooo00h0mOGe0?ooo`3oool0m_Kf0>GUi@0>3Ph0no_k0?knoP3oool0hn?S07emO@0K6a/0@T9209nO
W`80oooo00<0o?cl0?_kn`3lo?`00`3oool05P3lo?`0oooo0?Win@3fm_H05aLG0>CTi03inOT0oogl
0?omn03ooO/0Zjnh034`=@3ol=`0VHeo038lE@3^o_l0m?go0?kon03ooO@0ookg0?ooo`3nool20?on
o`0?0?gmo@2j^[X05aLG0<W9b@23Ph<0HF5Q0?knoP3oool0f=SH06IVIP0J6QX0DU9B0<;2`P3lo?`0
o_kn0080nOWi00H0oooo0:NWY`1NGUh0no_k0?ooo`3moOdN0?ooo`0001@0o_[o0?olo`3ooO/0ookd
0?ook03<cLD02@h[0?kko`3njN@03P000<_BeP3Znol0noko0?ono`3knOl0oogo0?kmo`3oool0e]KF
02PX:080oOgm00<0oooo0?gmo@3oool0;`3oool00`3lo?`0oooo0?gmo@030?ooo`80oOgm00`0nOWg
0=gMf`2:RXX0IFEU0:VYZ@3]kNd0n_[j0?gmo@3oool0o_kn0?[jn03moO/20?ooo@0Z0?knnP3oooX0
e]?<02l[9`3oool0oOco04U5D@2d/;`0oOco0?ooo`3moOd0n?ck0?Ooo`3hool09B@P00@000010080
0`8501`L700n?Sh0EEEE07]kN`20P800KFe]06YZJP1<C4`03`l?00H61P1kNg/0oooo0?Shn03lo?`0
no_k0?ooo`3lo?`0oooo0?gmo@3Shn<0QhN706m_K`2WYjL0jn_[0P3oool00`3moOd0oooo0?ooo`02
0?gmoA80oooo00X0oOgm0?ooo`3/k>`04a<C000000020P80AdM70?Ogm`3oool0no_k103oool0103m
oOd0oooo0?[jnP3no_h20?ooo`030?clo0010@40oooo00T0oooo00X0n_[j0?gmo@3oool0oooo0?_k
n`2QXJ40000000L71`000000ZZZZ0`3oool00`3moOd0oooo0?ooo`0o0?ooo`090?Shn03oool0oooo
0?ooo`3no_h0oooo0?clo01ADE40V9RH00<0oooo00T0oOgm0?clo02YZJT0BTY:00d=3@1fMWH0gMgM
0?ooo`3no_h00P3oool05`3jn_X0oooo0?ooo`3no_h0V9RH051@D03inOT0oooo0?ono@3onoT0oogm
0?coo`2c]K00KV=?06ALD@0001D0h>Wo0?Woo`3dm_40oocc0?oomP3nood0mo_j0080ooko00L0o_kn
08>3P`3[jn/0n_[j01XJ6P3Hf=P0nOWi00<0oooo00h0j^[Z09:BTP0Z:RX0:BTY09JFUP3hn?P0oooo
0?clo02l_;`0>CTi0?ooo`3gmoL0o_kn0?gmoAd0oooo00005@3onoh0ooco0?olo@3lo?X0ooog0?Og
m@1VIGd0MFj20?ohk@2YWH`0DU]R0?7oo`3joOl0no[n0?kmo`3kno/0oooo0?gmo@2UYJD0F5QH0?kn
oP0d0?ooo`030?knoP3moOd0o_kn0080o_kn02D0no_k0?ooo`3oood0o_kl0?gmo@3oool0kno_0<O7
a`2e]KD0`L710<K6aP2`/;00a<C20>o_k@3moO/0o_kl0?oon`3mn_40ooGT04Lk<@11Be/0U:Fc02`_
@03CcmT0ooko0?kmo03oo_X0oool0?Omo03lool0ookj0?7]jP2][Jd0MWQj03Ti>@061PH000000080
0P8200X0000000@4100];Bd0O7al0<W9b@3jn_X0oooo0?knoP3moOd0oooo0P3no_h03`3lo?`0o_kn
0?knoP3lo?`0oooo0?Cdm036a/H0/[:b0<;2`P30`<00][Jf0<;2`P3[jn/0o_kn0?gmo@0A0?ooo`80
o?cl00h0o_kn0=cLg00o?cl00@410000001;Bd/0i^KV0?knoP3oool0o_kn0?ooo`3lo?`0oooo0?cl
o0<0oooo00@0o?cl0?ooo`010@40oOgm203oool01P3no_h0oooo0?knoP3moOd0no_k0820P08010@4
00@05aLG0:^[Z`3oool0no_k0P3oool00`3lo?`0oooo0?ooo`0o0?ooo`0C0?clo03jn_X0oooo0?_k
n`3moOd0oooo0?gmo@3Kfm/0;Bd]0>3Ph03moOd0no_k0?ooo`3moOd0no_k0?knoP3`l?00][Jf08N7
Q`0207MgM`0808F5Q@2_[jl0h>3P0?gmo@3oool0fMWI02l_;`3Lg=`20?ooo`80oo_k01H0ooWg0?_n
o03koo`0o_gf0?omn01THfT0Ngb60?cmo`3oool0o_gl0?cmn03fo_P0d]WC0=oIg@3on_h0o_cm0?_k
n`3no_h0P82006a/K03jn_X0oooo0P3moOd01`3lo?`0oooo0?knoP3moOd0gmoO0:RXZ01kNg/00P1e
MGD01@2BTY803Ph>0?Shn03oool0o?cl01h0oooo0000503ono/0oocm0?glo`3lool0n_on0?koo`3n
m_l0a[S305iDBP1^JEl0>dE<0>?_o@3lo_l0ooco0?koo`3nood0oOgm0?ooo`1aLG40Rh^;0P3no_hc
0?ooo`070?knoP3oool0o_kn0?gmo@3oool0no_k0?ooo`020?ooo@H0oooo02@0no_k0?ooo`3^k^`0
YjNU06YZJ024Q880dM7=0?onm03on^H0`[BY05m^P@3]ool0nOko0?olo`3nnol0ooko0?ommP3oooP0
o?om0?_ooP3oooX0ookj0?gnoP3kool0oooo0>3Ph014A4@020P800820P010@403Ph>00d=3@11@D40
V9RH0>;RhP3kno/40?ooo`030?knoP3inOT0oooo00<0oooo0140nOWi0?ooo`3oool0oooo0?knoP3o
ool0l?3`0:RXZ01dM7@0OWin0<g=c@3oool0o_kn0?Win@3oool0no_k0?clo0040?ooo`080?gmo@3o
ool0oooo0?clo03oool0no_k0?ooo`3inOT20?ooo`0:0?Cdm00l?3`000000000000[:b/0kNg]0?kn
oP3oool0o_kn0?ooo`80o_kn00H0oooo0?gmo@3moOd0oooo0?knoP2VYZH20?ooo`0<0?KfmP3oool0
oooo0?gmo@3oool0no_k0?ooo`3moOd0oooo0?_kn`3lo?`0Jf][0P0000000`0>3Ph0gMgM0?KfmP02
0?ooo`030?_kn`3oool0oooo0380oooo00@0o?cl0?[jnP3oool0oooo0P3no_h0103oool0o_kn0?oo
o`3inOT20?ooo`030?knoP3moOd0oOgm00P0oooo00<0SXj>05aLG03oool00P3oool20?_kn`0]0?oo
o`3no_h0oooo0?ooo`3kno/0oooo0=7Ad@0W9bL00@4105EEE@2j^[X0?Shn0:JVYP3kno/0o?cl0?oo
o`3ooOd0oo_j0?omn`3no_`0o?om0?Ohn03`l>h0]kFd0:BRX`3oo_l0n?Om0?omo`3oool0Phb501<J
4`3`j^X0oo_n0?omo`3inOT0inOW00d=3@3no_h0no_k0?ooo`3lo?`0oooo0?gmo@3oool0o_kn00<0
oooo00P0no_k0?clo03no_h0Hf=S00410@0E5AD0P8200=oOg`80oooo00H0n_[j0?ooo`3lo?`0oOgm
0?ooo`3moOdF0?ooo`0000`0oock0?olo03oo_l0nooo0?Klo03jnod0oo[o0?g^l`3ooOX0n_[f0?Cm
o`3hool20?omo`0:0?OhnP3kooh0o_oo0?ooo`1OGel0X:2P0?gmo@3no_h0oooo0?knoS00oooo00<0
moOg0?ooo`3oool00P3oool00`3moOd0oooo0?ooo`020?ooo@L0oooo02L0o?cl0?ooo@3oood0ooom
0>o_k@2c/jl0KfYR07m_G`2WWI<0000B0>Kdo`3ko?l0o_[o0?olo`3oo_l0oooh0?[kl@3iool0nooo
0?kmmP3ooOH0ooko0?gno`3mo?l0oooo0?_kn`2d];@00@4100L71`0?3`l0e=CD0;Fe]@1PH600410@
03Ph>027QhL0clo?0?ooo`3fm_H00P3oool00`3kno/0oooo0?[jnP020?ooo`040?Shn03no_h0n?Sh
0?clo0<0oooo00h0oOgm0?Win@2i^KT0LW9b07MgM`37alL0oOgm0?ooo`3kno/0oooo0?clo03jn_X0
no_k0?knoPD0oooo00d0no_k0?ooo`3no_h0o_kn0?ooo`3AdM404a<C00410@000000GEeM0?ooo`3k
no/0nOWi0080oooo00L0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0080n_[j0P3oool00`3inOT0
o_kn0?ooo`030?ooo`080?_kn`3jn_X0Zj^[0000000:2PX0000009bLW03inOT30?ooo`040?knoP3o
ool0oooo0?knoS00oooo00P0no_k0?ooo`3oool0oooo0?gmo@3no_h0oOgm0?[jnP@0oooo00<0lO7a
0?ooo`3oool02@3oool02@3^k^h04a<C0>SXj03hn?P0oooo0?knoP3oool0n?Sh0?_kn`020?ooo`0@
0?gmo@3oool0oooo08J6QP000000Jf][038b<P000000RHV90?Shn03oool0o_kn0?ono`3oo?`0oogm
0?omo080o_ok00l0ooom0?ono`3hm_T0oOko0?koo`3on_h0L6ia02da<03WjnP0oogm0?okn`3oo_l0
oooo079bLP1cLg<00P3moOd05`3oool0o_kn0?ooo`3lo?`0oOgm0?ooo`3no_h0n?Sh0?ooo`3moOd0
oooo0=[JfP0C4a<0ADE509BDU01XJ6P06ATI04a<C02l_;`0oooo0?_kn`3oool0m_Kf01P0oooo0000
0`3oo?d0oo_k0?_loP020?_oo`0C0?[kn`3onod0oo[m0?olo`3ko_l0n?oo0?SnoP3oo?l0oogo0?co
o`3kool0o_oo0?gmo@0m?Cd0`/;20?knoP3moOd0oooo0?knoP0a0?ooo`070?knoP3clo<0oooo0?oo
o`3moOd0oooo0?clo0020?ooo@H0oooo0P3no_h0503oood0o?cj0?Wim`3oood0oook0?ckmP3kn>d0
S8V204Q7C@1`KW/0_k[:0?ojo`3oo?l0oogo0?gnmP3looH0look0?3jm`3oooH0ookf0`3oo_l20?oo
o`0A0?Win@3GemL02`/;0000001VIVH0oOgm0?KfmP3lo?`0`L71069RHP0Z:RX071`L07MgM`36a/H0
mOGe0?clo03oool00P3lo?`0103no_h0oooo0?ooo`3no_h20?ooo`030?[jnP3oool0oooo0080oooo
00<0n_[j0?ooo`3<c<`00P1_Kfl00`2n_[h0n?Sh0?ooo`030?ooo`050?knoP3oool0oooo0?Win@3l
o?`00P3oool01P3no_h0oooo0?ooo`3oool0Xj>S00820P80000000D0WinO0?ooo`3lo?`0n_[j0?_k
n`030?ooo`040??cl`3oool0oooo0?;blP<0oooo00H0o?cl0?Shn03oool0oooo0?gmo@3gmoL20?oo
o`060=gMg@0820P000000000001MGEd0oOgm0P3oool00`3lo?`0o_kn0?ooo`0e0?ooo`80o?cl00<0
oOgm0?ooo`3oool00P3oool01`3hn?P0no_k0?gmo@3oool0n_[j0?ooo`3fm_H02@3oool00`1RHV80
P8200?ooo`020?ooo`0V0?Gem@3oool0oooo0?ooo`3no_h0oooo0?gmo@3oool0Y:BT0000001<C4`0
GUiN05mOG`1MGEd02PX:00l?3`35aLD0oooo0?ono`3ln_d0oo_k0?oon03Fe/T0U9><0?gko`3lo_l0
lOKi06U]JP3onod0RhB90?_hoP3al?D0ookm0?gln03lo?X0moOg01PH603Jf]X20?knoP<0oooo00D0
oOgm0?clo03oool0o_kn0?_kn`030?ooo`0;06=SH`1kNg/0H61P09RHV03oool0kno_092@T00W9bL0
<C4a09BDU03`l?000P3oool00`3fm_H0n_[j0?ooo`0D0?ooo`0001H0oogm0?ono@3moOd0o?go0?co
o`3oool0oocj0?ogmP3ooOl0o?oo0>kfmP3lood0oogm0?oio03lool0m_ko0?koo`3oool061PH0>?S
h`3oool0oOgm<P3oool0203kno/0oooo0?ooo`3lo?`0b/[:0>;RhP3inOT0o_kn0P3oood70?ooo`03
0?knoP3oood0ooom0080ooom00`0lo?_0>3Pg02LViH0o_[f0?okoP3/i^d0FUaV07UkR01QGVl0/Zjh
0?Kel03nooP20?Soo`070?oomP3mn_40n_Gi0?omo`3noOl0no_k0?gmo@020?ooo`0@0??cl`0/;2`0
00000>g]k@3oool0o_kn0?ooo`3gmoL0oooo0=;BdP1nOWh0;Bd]01PH601UIFD0[jn_0?clo080oooo
00<0n?Sh0?gmo@3oool00`3oool01`3kno/0n?Sh0?ooo`3jn_X0oooo0?KfmP3moOd00P3oool01@3D
e=@0N7Qh06][J`2][Jd0j^[Z0080oooo0100o?cl0?gmo@3oool0oooo0?[jnP3lo?`0o_kn0??cl`3o
ool0oOgm0?ooo`1RHV800@4100<30`0;2`/0clo?0`3oool01`3lo?`0oooo0?[jnP3oool0o_kn0?oo
o`3jn_X00P3oool00`3jn_X0oooo0?ooo`020?knoP<0oooo00H0kNg]02d];@071`L00P8202@T903f
m_H20?ooo`060?clo03moOd0oooo0?ooo`3moOd0o_kn<@3oool00`3kno/0oooo0?ooo`020?ooo`04
0?clo03kno/0oOgm0?[jnP80oooo00<0j>SX03dm?@2GUiL02`3oool02@3De=@0820P0?[jnP3lo?`0
o_kn0?ooo`3jn_X0oooo0?[jnP030?ooo`0N0?Win@2BTY8030`<00820P0E5AD0PH6102<S8`000000
10@4028R8P0/:bh0TY>G0?glo`3lmoT0oogj0?onk@1ADD@0f=SR0?Wlo`1iP8@0/kNf0?omo`3oo?l0
ooWo0?ono`3oool0nogj0?ooo`2YZJT0?Cdm0P3oool0103moOd0oooo0?knoP3no_h50?ooo`080?_k
n`3oool0h^;R01DE5@3Ti>@0RXZ:07EeM@3no_h30?ooo`050;Zj^P1FEUH0410@06MWI`3>c/h05`3o
ool0000E0?_mn03nood0oooo0?_io03lnol0oooo0?oon03oo_X0ooco0?klo`3kool0mocf0?olo@3o
no`0o?oo0?Woo`3mo_h0oOgm00H61P3hn?P0oooo0080o_kn<P3oool01@3kno/0n?Sh0?Ogm`0E5AD0
gMgM0080oooo0P3oood70?ooo`030?clo03moO/0ooom0080ooom01@0oook0?chm@1MDE40fLg=0?om
o@1lQ8@0XkJj0?;oo`3noOl0f]3I08MmO01_JFL0WJ2T0>S`l03looP0oOog0?ono`3ooOl0no[m0?oo
o`80oOgm00T0no_k0?ooo`3emOD01PH604=3@`3oool0o_kn0?[jnP3oool00P3kno/02@3oool0o?cl
0>CTi02<S8`0>c/k00`<301ADE40VIVI0?Win@020?ooo`030?Win@3hn?P0oooo00<0oooo00<0oOgm
0?ooo`3oool00P3oool02@3jn_X0oooo0?gmo@3oool0g=cL08f=S@1YJFT0XZ:R0>WYj@030?ooo`05
0?gmo@3oool0oooo0?ooo`3jn_X00P3oool01P3alO409bLW00<30`000000=cLg0?Cdm0D0oooo00D0
m_Kf0?_kn`3no_h0Fe]K0?Shn0020?knoP80oooo00/0o?cl0?ooo`3inOT0o?cl0?Win@1eMGD00000
00820P061PH0cLg=0?ooo`020?gmo@@0oooo0P3no_hc0?ooo`030?knoP3kno/0oooo0080oooo00P0
no_k0?ooo`3lo?`0oOgm0?ooo`36a/H0TI6A0?[jnPT0oooo00H0oOgm0?ooo`0j>SX0YjNW0?ooo`3n
o_h20?ooo`040?knoP3oool0oooo0?Shn080oooo01l0Q8B400L71`0820P0000000820P051@D0?3`l
0?Win@3lo?`0_Kjn055EEP0=3Q80IfA[0=WDe03oonl0iNKF04=7B01ZL7/0DUIQ0?Ggo`3oo?l0oo[l
0?omn`3oo_/0lO;d0?coo`3nool0?Shn0:ZZZP3moOd0oooo0080o_kn103oool0303kno/0o_kn0?oo
o`3hn?P0oooo0861P@1YJFT0oooo09nOW`1LG5`0oooo0?Shn0<0oooo00H0oOgm0>GUi@22PX80820P
03Ti>@3jn_XE0?ooo`0000<0nOoj0?con`3oo_l00P3oo?l01`3oo_l0n?oc0?comP3on_l0o?Gl0?co
o`3ho?/00P3oo?l01@3koo`0n?oj0?cmo@3Xj>P05ADE0080oooo00<0o_kn0?clo03oool0<`3oool0
1@34a<@0=CDe0?ooo`3oool0o_kn0080ooom203oool06P3oood0o_kl0?clnP3lo?X0oOgi0?omnP3/
g=X0GU1?0<k=d01?FEh0j_oo0?7oo`3nnol0ooSn0?olo`3oo?h0g]gS08jAU@1PIEl0VYbF0>SXj03l
n_d0oooo0?[jnP3oool0o_kn0P3oool00`3kno/0oooo0?ooo`030?ooo`060?[jnP3oool0oooo0?kn
oP3oool0o?cl0P3oool02`3^k^h0WinO05EEE@061PH0@D5108f=S@3Vi^H0oooo0?gmo@3jn_X0oooo
0080no_k00@0nOWi0?knoP3lo?`0o_kn0`3oool02@3no_h0no_k0?clo03oool0j>SX09JFUP1`L700
Shn?0>3Ph0020?ooo`0<0?Shn03oool0no_k0?ooo`3lo?`0oooo0=OGe`020P80000000H61P1bLW80
nOWi0P3oool01P3jn_X0o_kn0?ooo`3oool0o?cl00410@<0oooo00d0no_k0?clo03oool0oooo0?Wi
n@3oool0ZJVY000000051@D0000009VIV@3kno/0o?cl00@0oooo00D0oOgm0?ooo`3oool0oooo0?gm
o@0a0?ooo`040?clo03no_h0oooo0?ooo`80o?cl00<0oooo0?_kn`3oool00P3jn_X00`3kno/0CTi>
0?Win@090?ooo`060?knoP3oool0ZZZZ03lo?`3no_h0no_k0P3oool01`3kno/0oooo0?ooo`3lo?`0
oooo0?knoP1/K6`00P0000007P0:2PX02@T904i>CP3jn_X0oOgm0?knoP3oo_l0o_oo0=oPi028QhX0
6ALF03De:@2KWI00>T0l00031`3ViO80ooco0?Wio`3no_h0oogj0?gimP3nool0o?oo0=SGfP0K6a/0
n?Sh0?knoP3moOd0oooo0?gmo@80oooo00<0o?cl0?ooo`3moOd00`3oool0403/k>`01@D50=kNgP3o
ool0_Kfm03Ti>@3no_h0oooo0?Win@3moOd0oooo0?knoP3kno/0oooo0?Win@2YZJTF0?ooo`0001@0
mOod0?Cnl`3ooOl0oo[o0?oio`3ooOl0l?oa0?CokP3ooOP0oo_m0??gn03ko_l0ooSo0?oko`3kooT0
nOof0?goo032`/80?3`l0?knoP80oooo00<0oOgm0?ooo`3oool0;`3oool0203no_h0o?cl0?knoP1^
KVh0Q8B40?ooo`3jn_X0oooo0P3oood60?ooo`040?clo03oool0ooom0?gmn`80ooom01P0oook0?oo
n03oo?40[JBM00003@3KhoD0n?oo0?gno`3onoT0oogj0?Gmo@3gool0oO_o0?gjo`3oo_l0hn?Q09jL
V`1XIVD0RXZ:0>7Qh@3oool0o_kn0?Gem@3lo?`30?ooo`0E0?Win@3oool0oooo0?clo03oool0oOgm
0?ooo`3jn_X0oooo0?[jnP3gmoL0oooo0?gmo@3oool0n_[j0;6a/@1OGel06ATI02LW9`1mOGd0emOG
00D0oooo00@0no_k0?knoP3oool0o?cl0`3oool20?gmo@080?ooo`3moOd0moOg0?Ogm`2TY:@0Jf][
08R8R03IfMT20?ooo`050?Win@3oool0oooo0?Win@2BTY800P000000100;2`/0/k>c0?ooo`3inOT3
0?ooo`050?[jnP3oool000000?_kn`3moOd00P3oool02@3jn_X0o_kn0?Shn03oool0fm_K01<C4`01
0@40000005=CD`020?ooo`070?_kn`3oool0o_kn0?knoP3moOd0o?cl0?knoP0c0?ooo`030?gmo@3o
ool0oooo00<0oooo00<0o?cl0?Ogm`3gmoL00P3oool01@3lo?`0no_k06MWI`3WinL0nOWi00P0oooo
00X0o?cl0?ooo`3clo<06QXJ0=_Kf`3moOd0oooo0?gmo@3lo?`0o_kn0`3oool07@3lo?`0A4A400@4
100000002PX:05QHF03jn_X0oooo0?[jnP3oool0ooko0?olo`3kn_l0o?oh0?comP2`/K40414C0004
001KGEX0f];M0?oio`3kool0m_go0?koo`3oo_l0oooo0?clo01bLW80M7Ad0080oooo00H0o_kn0?oo
o`3moOd0oooo0?knoP3moOd50?ooo`0708V9R@1TI6@0oooo0?KfmP3^k^h0IfMW0?clo0030?ooo`06
0?[jnP3moOd0oooo0?ooo`3inOT0no_k5P3oool0000D0?Oom03go_@0oogo0?oho`3om?l0oogo0?Go
n03goo<0oo_c0?ohm`3nool0noko0?ojo`3oo?l0o?kh0?_omP3nood0Y:BT05eMG@3jn_Xe0?ooo`04
0?clo03oool071`L0=?Cd`80oooo00<0o?cl0?ooo@3oood01P3oool0103no_h0oooo0?ooo@3moO/2
0?ooo@0:0?gmn`3noOH0ooka0?okm@3Ef>D0n?oo0?Ogo`3ooOl0ooch0?kil`80mOoo00/0o_co0?oj
o`3ooOl0o_kn0?kln`3ooo/0kno]0:JVYP1]KFd0Ogmo0=WIf@020?ooo`030?_kn`3oool0oOgm00L0
oooo00L0o?cl0?ooo`3oool0n_[j0?ooo`3jn_X0o_kn0080oooo00d0mOGe0<O7a`1gMgL07alO020P
801/K6`0^k^k0?Win@3oool0oOgm0?ooo`3lo?`0o_kn0080oooo00@0no_k0?ooo`3oool0n_[j0P3o
ool0203moOd0o_kn0?gmo@3fm_H0[Zj^06a/K01nOWh0dm?C0P3oool01`3no_h0oOgm059BDP020P80
000001LG5`3UiND0103oool20?knoP0600410@3oool0o?cl0?knoP3oool0no_k0P3oool02`3dm?@0
<C4a000000000000:2PX0?;blP3kno/0oOgm0?ooo`3lo?`0o_kn00<0oooo00<0o_kn0?clo03no_h0
<@3oool0403no_h0oooo0?clo03gmoL0oook0?[im@28QXL0108305aLFP21PGl0no[m0?koo`3mo_h0
`<7109jOX@3nool90?ooo`060?Win@3oool0Q8B406QXJ03no_h0oOgm0P3oool0303kno/0oooo0?_k
n`3no_h0oooo010@400000001`L704E5A@3no_h0oooo0?_kn`80oooo01<0oOco0?gio`3oo_l0n_od
0?Wom03[k_80SHfC0=cNf`1kNWH07aPO048lAP2Y[K@0l__n0?koo`3kn_d0ooko0?Kdl`0A4A40inOW
0080no_k0P3oool03P3no_h0oOgm0?knoP3oool0o_kn0?ooo`3lo?`0oooo0?Cdm00G5aL0eMGE0?Og
m`3oool0n_[j0P3oool01`3gmoL0ooom0?ooo`3moOd0oooo0?Win@3kno/00P3oool00`3kno/0oooo
0?ooo`0C0?ooo`0001@0o?ok0?koo@3oo_l0ooko0?olo`3oo_l0o?om0?con`3ooo/0oogm0?clo03n
ool0oogo0?ono`3moO/0o_ok0?ooo`2LW9`0HV9R0?ooo`80o_kn<P3oool01@3no_h0no_k0=GEe@0P
8200oOgm0180oooo00D0ooom0?onnP3oo_d0o_oo0?coo`020?ono`040?omo@3oo_d0o?oo0?coo`<0
ooko0P3oool02P3oood0oooo0?[jnP3oool0m_Kf0:f][@1VIVH0OGem0<S8b03lo?`20?ooo`030?gm
o@3oool0oooo0080oooo00@0n_[j0?ooo`3oool0oOgm103oool0403moOd0o_kn0?ooo`3oool0o?cl
0?ooo`3EeMD0Q8B403De=@0B4Q80GEeM0:^[Z`3`l?00oooo0?knoP3lo?`80?ooo`0@0?_kn`3oool0
o_kn0?_kn`3oool0n?Sh0;^k^`1eMGD0OGem0<C4a03moOd0jNWY02<S8`0000000`<30410@080oooo
00D0o?cl0?ooo`3oool0no_k0:ZZZP020?ooo`0<0?Shn03oool0oooo0?knoP3oool0LW9b00000002
0P801PH60<g=c@3oool0o_kn0P3oool00`3no_h0oooo0?ooo`0f0?ooo`0A0?koo`3in_X0ooko0?on
o@3oo?<0m_7Y01TB5@3Gd]H0oooh0<g>b039bLl0mo[o0?coo`22QXD0B4]@0?Wlo`3nool0203oool0
1`3hn?P0oooo0>GUi@0:2PX0m_Kf0?ooo`3no_h00P3oool0303hn?P0oooo0?ooo`3WinL0000000H6
1P0>3Ph0l_;b0?ooo`3moOd0oooo0?gmo@80oooo0140o_go0?ono`3noo/0o_ok0?[ko@3kn_d0oooo
0?kno03ln_d0YjFX03dn@00H71d0NWUl0>3Ph03oool0Shn?04i>C0020?kno0090?ooo@3oool0oooo
0?ono`3noOl0ooko0?glo`3oo_l0o?_n0080oooo00@0S8b<05ADE03nool0oooo0P3oo_d01P3oo_l0
o_go0?koo@3noo/0ookm0?ono`80oooo0P3nool00`3oool0ooko0?ooo`0D0?ooo`002@3oool0103n
o_h0o?cl0?ooo`3kno/20?ooo`040?clo03no_h0UYJF06QXJ080oooo00<0o_kn0?ooo`3no_h0<@3o
ool01P3moOd0PH61071`L03no_h0oooo0?WinB<0oooo00H0no_k0?Win@3oool0oooo0>_[j`31`L42
079bLP090;Zj^P3oool0oooo0?KfmP3oool0oOgm0?ooo`3lo?`0mOGe0080oooo00<0no_k0?clo03o
ool00P3oool03@3inOT0o?cl0?ooo`3oool0o?cl0?ooo`3jn_X0hN7Q09JFUP1=CDd0410@0=3@d03g
moL02@3oool0103no_h0oooo0?ooo`3no_h20?clo00;0?_kn`3hn?P0n_[j0<S8b01kNg/0MGEe07em
O@071`L0000000H61P25QHD00P3oool0303kno/0n_[j0?ooo`3moOd0oooo0?gmo@3oool0nOWi0?cl
o03no_h0[Zj^00L71`80000000<0U9BD0?Gem@3kno/00P3oool00`3jn_X0oooo0?ooo`0f0?ooo`<0
o_oo00l0n_Wl0?cgm`3oo_@0n_?Y01lF6@3PfM`0ookg0?kon@3no_l0o?ko0?Smo`3kool0koCh0?co
o`3nool02`3oool00`1HF5P0Shn?0?ooo`040?ooo`070?clo03moOd0/K6a00`<30000000a<C40?Ge
m@020?ooo`060?knoP3oool0oooo0?gmo@3inOT0O7al0P3oool00`3jn_X0oooo0?ooo`020?ooo`0@
0?_kn`3oool0eMGE06m_K`0A4A4071`L00`<302b/[00ooom0?_kn@3no_`0oooo0?gmo@3lnoh0ooko
0?kmo`80ooko00L0oOco0?clo03moOd08B4Q0<C5a@3lool0o_oo0080oogm00d0ooko0?koo`3kood0
o?ok0?omo@3oo?l0ooko0?koo`3kool0o?oo0?ono`3ooOl0ooko01@0oooo00080?ooo`040?clo03o
ool0oOgm0?gmo@80oooo00D0n?Sh0?ooo`3moOd0S8b<079bLP040?ooo`030?gmo@3oool0oooo02h0
oooo00P0D51@0?ooo`0h>3P0^[Zj0?ooo`3inOT0oooo0?[jnR00oooo00H0oOgm0?ooo`3oool0o_kn
0?Win@3kno/20?ooo`070?knoP3moOd0c<c<07YjNP1YJFT0][Jf0?[jnP030?knoP80oooo00@0o?cl
0?ooo`3oool0nOWi103oool0103moOd0oooo0?ooo`3lo?`20?ooo`060?clo03moOd0;2`/0;Zj^P3o
ool0o_kn2@3oool00`3lo?`0no_k0?ooo`050?ooo`050?Shn03oool0no_k0=[JfP0j>SX00P000000
1`061PH0_[jn0?ooo`3oool0n?Sh0?ooo`3inOT00P3oool02@3lo?`0oooo0?_kn`3Xj>P04Q8B0000
00020P80FUYJ0?[jnP030?ooo`030?knoP3oool0o_kn03L0oooo00d0o_oo0?Kgn@3nool0o?_n0?om
o@3ono<0ookf05YDDP2HTY80ookj0?oon`3OgnD0n?_o0080nooo0P3hnol00`3nool0oooo0?ooo`07
0?ooo`040?[jnP3moOd0`<3002d];@<0oooo00L0n?Sh0?[jnP3moOd0oooo04a<C0051@D0LG5a00<0
oooo00T0no_k0?ooo`3gmoL0oooo0>[ZjP0d=3@0N7Qh0?ooo`3moOd00P3oool03P3clo<0o?cl0?[j
nP3oool0moOg0:NWY`0n?Sh06ATI04i>CP1YJFT0no_i0?ooo@3jn_P0ooom0P3oool0103kn_d0ooko
0?kmo`3mo?l20?ono`0E0?ooo`2MWId0?clo0?koo`3iool0o?oo0?oknP3ono/0ooko0?_oo`3hool0
nooo0?omo@3onod0oogm0?koo`3gool0n?oo0?omo`3oo?d0ooko01@0oooo00090?ooo`040?knoP3o
ool0o_kn0?Ogm`80oooo00@0m_Kf0?knoP20P800OWin103oool00`3no_h0oooo0?ooo`0^0?ooo`07
02d];@2m_Kd01`L70?ooo`3inOT0oooo0?Cdm00R0?ooo`80no_k0`3oool20?clo00<0?gmo@3oool0
n?Sh0?Shn03oool0clo?08B4Q01ZJVX0Y:BT0>o_k`3oool0moOg0P3oool0103hn?P0oooo0?clo03j
n_X20?ooo`050?_kn`3moOd0oooo0?knoP3jn_X00P3oool01@3Rh^8061PH0?gmo@3oool0o?cl00P0
oooo00@0o?cl0?ooo`3oool0oooo0P3moOd00`3kno/0nOWi0?gmo@020?ooo`090?gmo@3oool0oooo
03Lg=`0000000P8201PH602FUYH0iNGU0080oooo00@0mOGe0?ooo`3inOT0o_kn0P3oool0300k>c/0
00000000000O7al0i^KV0?ooo`3moOd0oooo0?clo03gmoL0oooo0?clo3L0oooo0`3nool03`3kno/0
noOd0?onn03ooOP0k>KT00D1003LfmL0f][H010A5@3io?l0nooo0?KkoP3ko_l0o?oo0?ono`070?oo
o`090?knoP3oool0oooo0?ooo`3no_h0:b/[0;>c/`3oool0o?cl0080oooo00T0o_kn0?ooo`030`<0
10@40?KfmP3moOd0no_k0?ooo`3inOT00P3oool0203Xj>P061PH08:2PP3oool0nOWi0?[jnP3oool0
nOWi0P3oool01@3bl_80RHV902<S8`0i>CT0];Bd00<0oooo00@0ooom0?[jn03moO/0ooom0P3oool0
6`3oo_l0o?_n0?ono`3mo?l0no[m0?ono`3no_h0:RXZ0<;2`P3ko?`0nOoo0?coo`3onoX0oo_k0?on
o`3kool0n?oo0?_oo`3ooOd0oock0?omo@3nool0mooo0?Soo`3ooOl0oocm0?ono`0D0?ooo`00203o
ool00`3no_h0n_[j0?ooo`020?ooo`060?Win@3oool0oooo0?ooo`1cLg<0RXZ:0P3no_hc0?ooo`03
04E5A@1XJ6P0HV9R02P0oooo00<0o_kn0?ooo`3oool0103oool03P3moOd0oooo0?ooo`3lo?`0moOg
0?ooo`3Jf]X0T92@06EUI@2OWil0jNWY0?knoP3moOd0o_kn0P3oool01@3jn_X0n?Sh0?ooo`3oool0
n?Sh0080oooo00H0n_[j0?ooo`2ATI40F5QH0?ooo`3inOT90?ooo`060?clo03oool0oooo0?clo03h
n?P0oOgm103oool01P3no_h0o?cl0?ooo`3lo?`0g]kN01DE5@80000000H0BTY:096AT@1eMGD0Ti>C
0>g]k@3lo?`30?ooo`07071`L00000001@D500P82037alL0oooo0?_kn`020?knoP030?ooo`3no_h0
oooo03P0oooo0P3nool00`3fmoL0ooom0?onn`020?omnP050?okn03Zi^<0Hf5P07AdM01^Kg<00P3k
o_l0103hnol0o?oo0?[mo`3oo_l70?ooo`0:0?knoP3oool0o?cl0?ooo`3hn?P0Vi^K05MGE`3moOd0
oooo0?clo080no_k00<0aLG50000002QXJ400`3oool01P3no_h0oooo0?gmo@3gmoL0]kNg0;bl_080
oOgm0P3oool03`3moOd0oooo0=CDe01XJ6P04Q8B05YJFP3>c/h0oooo0?Win@3kno/0oooo0?gmo@3n
o_`0ooom0?ooo`020?knoP030?_kn`3oo_l0ooko0080ooko01L0oOgm0?ooo`2_[jl0>CTi0?ShmP3n
ool0o?oo0?koo`3oo_/0oogj0?ono@3nool0nooo0?coo`3oo_/0oogj0?oon`3nool0nooo0?coo`3o
o_d0ookk0?ono@0D0?ooo`002`3oool02P3kno/0oooo0?knoP3no_h0moOg0?ooo`1WIfL0UYJF0?gm
o@3no_hc0?ooo`07069RHP0/;2`0Zj^[0?clo03jn_X0oooo0?gmo@0Q0?ooo`030?gmo@3lo?`0oooo
0080oooo00D0n_[j0?Shn03kno/0o_kn0?gmo@020?ooo`040?knoP3oool0oooo0?Win@80oooo00P0
n_[j0>;RhP2HV9P0HV9R09BDU03WinL0m_Kf0?clo0<0oooo00P0o?cl0?knoP3oool0oOgm0?ooo`3g
moL0A4A40;6a/@80oooo00<0no_k0?ooo`3oool01`3oool00`3moOd0o?cl0?ooo`020?ooo`040?gm
o@3jn_X0oOgm0?clo080oooo01L0n?Sh0?ooo`3oool0Z:RX00H61P010@401@D50:JVYP3inOT0k^k^
09bLW01^KVh0SXj>0=oOg`2b/[801`L700410@020P80P8200?ooo`3inOT0oooo0?knoP030?ooo`03
0?[jnP3oool0oooo03H0oooo0180o_oo0?[kn`3nool0n_[j0?oon`3on_@0oogg0?olo03nnOT0oook
0?koo@3no_l0mOSm0?_no`3kool0o?oo0?koo`3oo_l80?ooo`0C0?KfmP3oool0nOWi0?ooo`3fm_H0
2PX:0>KViP2FUYH0GUiN075aL@1bLW80?Cdm01`L703oool0n_[j0?knoP3lo?`0oooo0?clo0020?oo
o`0;0?[jnP3gmoL0oooo0?_kn`3lo?`0nOWi0;jn_P12@T807AdM07]kN`3]kNd00P3lo?`0203hn?P0
oooo0?ooo`3lo?`0oooo0?kno03oood0oOgm0P3oool01@3inOT0ooko0?ono`3oo_l0o?_n0080oooo
00@0;Rh^0:f]Z`3lo?X0oooo0P3oo_l0103ooo/0oooj0?ooo@3noOl20?omo`040?oon`3oooP0oook
0?ono`80o_ko00<0ooom0?oon`3oood0503oool000P0oooo00@0oOgm0?[jnP3oool0o_kn0`3oool0
1@3no_h0oooo05eMG@2PX:00o_kn03@0oooo00<0JFUY00d=3@3YjNT0103oool00`3moOd0oooo0?oo
o`0N0?ooo`030?_kn`3oool0oooo0080n_[j203oool20?[jnP030?ooo`3no_h0o?cl0080oooo01<0
o?cl0?ooo`3/k>`0W9bL06YZJP2;Rh/0dm?C0?ooo`3no_h0no_k0?ooo`3jn_X0oOgm0?ooo`3/k>`0
4a<C0?KfmP3oool0o_kn00X0oooo00D0o_kn0?ooo`3oool0oooo0?clo0050?ooo`060?clo03oool0
oooo0?Gem@3oool0HV9R0P0000002`030`<0fMWI0?ooo`3oool0o_kn0?Cdm02IVIT020P800000006
1PH0ATI60080oooo00H0o?cl0?ooo`3jn_X0oooo0?clo03oool20?knoSL0oooo0`3nool03`3oo_l0
n_Si0?onm03ooO<0JF=Z0?cfo@3oooH0m?O^08V9T`3Be>00o?oo0?coo@3fmo/0o_oo0?ono`090?oo
o`0<0?Shn03oool0oooo0?ooo`1WIfL0:BTY0=7Ad@3oool0n?Sh0>?Sh`1lO7`0k^k^0`3oool0403h
n?P0h^;R09^KV`3moOd0oooo0?_kn`3oool0oOgm0?clo02EUID0:RXZ02l_;`2LW9`0mOGe0?ooo`3h
n?P20?ooo`080?clo03oool0oooo0?knoP3lo?`0oOgk0?kno03lo?`30?ooo`0F0?glo`3noOl0oooo
0?gmo@3oool0^k^k02/[:@3knoT0ooom0?_kn@3ooOl0ooko0?koo@3noo/0oOgi0?gkoP3onOl0ooco
0?kon`3looH0o_ok0?ono`80ooco00<0ooom0?konP3oood0503oool000P0oooo00<0n_[j0?ooo`3f
m_H00P3oool01P1XJ6P0CTi>0?ooo`3oool0F5QH0:FUY@@0oooo00<0o_kn0?ooo`3oool0;P3oool0
1P14A4@00000055AD@2QXJ40kNg]0?gmoB<0oooo00@0oOgm0?knoP3oool0oooo0P3lo?`01@3no_h0
oOgm0?knoP3moOd0o_kn0080oooo0P3no_h20?ooo`040?gmo@3oool0o_kn0?Win@<0oooo00D0k^k^
0:n_[`1[Jf/0MgMg0<_;b`030?ooo`070?clo02KVi/0EEEE0?ooo`3no_h0oooo0?gmo@0;0?ooo`80
o_kn0P3oool0103lo?`0oooo0?[jnP3no_h20?ooo`0E0?_kn`3oool0oooo0?KfmP0/;2`0000000<3
0`0[:b/0o?cl0?ooo`3lo?`0n_[j03lo?`010@40000001LG5`1SHf<0P8200<G5a@3oool0oOgm0080
o_kn00@0o?cl0?ooo`3oool0o_kn=`3oool04@3nool0nocl0?koo`3mo?l0ooko0?onm@3ono<0/:^]
08b:S@3nooT0eMOB05QKHP3lo_l0nOgn0?WjnP3nool0o_go00P0oooo00P0oOgm0?ooo`3oool0o_kn
0?[jnP3Cdm<0F5QH01LG5`80no_k0P3oool00`3]kNd0J6QX0?_kn`020?clo00<0<o?c`0N7Qh0/k>c
0?ooo`3moOd0oooo0>?Sh`1iNGT04a<C04m?C`2o_kl0oOgm0P3oool00`3jn_X0oooo0?knoP030?oo
o`050?Win@3oool0o_kn0?ooo@3lo?X00P3oool0603inOT0oooo0?ono`3oo_l0no_k0?ooo`3kno/0
ATI409^KV@3oood0n_[f0?ooo@3no?d0ooko0?koo`3nood0o?gg0?_inP3mn?l0oo_o0?kon`3nooH0
o_ok0?ono`80ooco00<0ooom0?konP3oood0503oool000/0oooo00P0no_k0?ooo`3gmoL0=CDe08j>
SP3moOd0C4a<0;Fe]@80oooo00@0m?Cd0?ooo`3inOT0oOgm0`3oool01@3no_h0oooo0?Win@3oool0
oOgm00<0oooo00D0o_kn0?ooo`3inOT0oooo0?gmo@030?ooo`050?knoP3oool0nOWi0?ooo`3moOd0
0`3oool01@3no_h0oooo0?Win@3oool0oOgm00<0oooo00<0o_kn0?ooo`3inOT00P3oool01@3lo?`0
oooo0?ooo`3jn_X0o_kn0080oooo00T0AdM701dM7@2YZJT0Cdm?00/;2`1:BTX0V9RH0>g]k@3lo?`0
0P3oool0103moOd0oooo0?clo03moOd20?ooo`060?KfmP3oool0oooo0?_kn`3oool0o?cl0P3oool0
103no_h0n_[j0?ooo`3moOd20?ooo`030?gmo@3oool0oooo0200oooo00X0oOgm0?ooo`3hn?P0];Bd
07EeM@1^KVh0`/;20?gmo@1:BTX0YjNW0P3no_h20?ooo`040?gmo@3oool0oooo0?gmo@80oooo00@0
oOgm0?ooo`3oool0oOgm0P3oool00`3no_h0o?cl0?ooo`090?ooo`0@0?clo03EeMD01`L700000001
0@40KFe]0?ooo`3no_h0PH61000000061PH000000;no_`3oool0m_Kf0<O7a`80MgMg00D0^[Zj0?_k
n`3oool0n_[j0?knoP030?ooo`030?clo03oool0o_kn0080oooo00@0o_kn0?gmo@3oool0oooo0P3m
oOd20?ooo`050?clo03oool0oooo0?gmo@3kno/08`3oool20?koo`030?gnoP3no_X0ookj0080oogo
00d0ooof04]:@`3@cmD0<c<k0>KZj@3lood0o_ko0?gmo`3oo_l0n_[h0?clo03oool0oOgm0080oooo
0280n?Sh0?ooo`3jn_X0no_k0?ooo`3lo?`0o_kn0:RXZ02=SHd0oooo04I6AP2OWil0oooo0?clo03o
ool0no_k0>SXj01cLg<0no_k0<W9b@0H61P0/;2`0?knoP3lo?`0cLg=05MGE`0B4Q80LW9b0=KFeP3o
ool0no_k0?knoP3oool0nOWi2@3oool01`3no_h0oooo0?ooo`3lo?`0oooo0?gmo@3gmoL00`3oool0
5`37alD07alM0?gmn`3ooo/0o_kj0?gmn@3nood0oooo0?omo`3jn?T0P85i05]MF022PHl0jNSf0?on
o@3oooP0ookm0?ono`3no_l0oOgo0?kno03oooX0ooom01@0oooo000:0?ooo`0=0?_kn`3oool0oooo
0?_kn`3Ng]h06ATI0<?3``0n?Sh0^;Rh0?knoP3inOT0oooo0?KfmP030?ooo`040?clo03moOd0oooo
0?[jnP@0oooo00@0o?cl0?gmo@3oool0n_[j103oool0103lo?`0oOgm0?ooo`3jn_X40?ooo`040?cl
o03moOd0oooo0?[jnP@0oooo00@0o?cl0?gmo@3oool0n_[j0P3oool00`3hn?P0oooo0?Win@030?oo
o`0?0?knoP3jn_X04A4A018B4P3kno/0oooo0?Ogm`2XZ:P0DU9B00d=3@13@d<0UYJF0>KViP3oool0
m?Cd0080oooo00D0oOgm0?clo03oool0oOgm0?knoP030?ooo`060?_kn`3oool0o?cl0?ooo`3kno/0
o?cl0P3oool00`3lo?`0oooo0?ooo`0N0?ooo`040?gmo@3oool0no_k0?_kn`80oooo00P0nOWi0?oo
o`35aLD0JVYZ00/;2`2/[:`0m_Kf0?knoP<0oooo0P3kno/20?ooo`80o?cl00H0o_kn0?clo03oool0
oooo0?clo03no_h20?ooo`030?Shn03oool0oooo00L0oooo00<0o?cl09VIV@0000000P0000000`2]
[Jd0^k^k00820P020000000408>3P`3oool0nOWi0?ooo`80o?cl00L0oOgm0=?Cd`20P800KVi^0;Vi
^@3gmoL0oooo0080o_kn0`3oool01P3inOT0oooo0?ooo`3oool0mOGe0?gmo@80oooo00D0oOgm0?oo
o`3oool0no_k0?clo0030?ooo`80oOgm803oool00`3nool0oOko0?coo`020?oonP0<0?ojo`3Sg^80
oO[_0>SXgP0000L0[jjk0?WmnP3loo/0nOWo0?omo`3no?d0ookm0P3oool01@3kno/0oOgm0?knoP3o
ool0oOgm00<0oooo00L0nOWi08j>SP2d];@0n_[j0?ooo`2`/;00>3Ph0080o_kn0P3oool03`3inOT0
dm?C09fMW@2=SHd0dM7A0?Shn02][Jd0?Cdm01TI6@2>SXh0k^k^0?clo03oool0o?cl0?Win@020?oo
o`030?clo03oool0oooo00L0oooo00<0o_kn0?ooo`3moOd0103oool01`3kno/0oooo0?knoP1>CT`0
V9RF0?cln03moOT00P3ooo/0303noo/0m_Og0?kjo`3ooOl0n__a0?[lmP3Pgnd0MWF50?omoP3oo_T0
oogl0?kmo`80o_ko00<0ookm0?oon`3oood0503oool000T0oooo00<0m?Cd0?ooo`3oool00P3oool0
1@3moOd0^KVi01DE5@0l?3`0aLG500@0oooo00<0n_[j0?ooo`3no_h00P3oool20?knoP040?ooo`3m
oOd0oooo0?knoP80oooo0P3no_h0103oool0oOgm0?ooo`3no_h20?ooo`80o_kn00@0oooo0?gmo@3o
ool0o_kn0P3oool20?knoP040?ooo`3moOd0oooo0?knoP80oooo0P3no_h00`3oool0oOgm0?ooo`02
0?ooo`070?[jnP3oool0no_k0?clo032`/80=CDe000000020?ooo`0E0?Shn03no_h0oooo0?Shn02g
]kL0D51@018B4P15ADD0RXZ:0>?Sh`3hn?P0oooo0?clo03jn_X0oooo0?gmo@3kno/0oooo0?knoP3o
ool0no_k00@0oooo00<0moOg0?KfmP3oool0803oool0103kno/0oooo0?ooo`3lo?`30?ooo`090?kn
oP3hn?P0[:b/04E5A@3>c/h0Ph>306EUI@2UYJD0lO7a00<0oooo00<0o_kn0?[jnP3no_h00`3oool0
1P3no_h0oooo0?ooo`3oool0no_k0?clo0T0oooo00l0oOgm0?clo03oool0Bd];000000030`<00000
00L71`020P801@D504=3@`3oool0no_k0?ooo`3no_h00P3oool03P3moOd0o?cl0?ooo`3oool0e]KF
08n?S`1YJFT0ZJVY0?;blP3moOd0n_[j0?gmo@3oool0o?cl0P3oool0103kno/0oooo0?knoP3jn_X2
0?ooo`030?_kn`3oool0o_kn00D0oooo00<0o_kn0?ooo`3oool07@3oool20?koo`090?Wmo03oood0
lo?_0:NRXP0=20P0PX5l0?oon`3Ge]/0l?3f0080o?oo00H0o_oo0?ono`3hm_L0ookm0?Win@3dm?@2
0?ooo`030?_kn`3oool0o?cl0080oooo01H0lO7a06a/K03Cdm<0oooo0?gmo@3kno/0oooo01hN7P35
aLD0PH6109RHV03_knl0lo?c0?gmo@2HV9P0ZZZZ08R8R00Q8B40?Cdm0:RXZ03oool0moOg1P3oool0
0`3no_h0oooo0?gmo@0:0?ooo`0<0?[jnP3oool0n_[j0?[jnP3oool0no_k0?ooo`3>c/h06ATG0?Og
m@3ooo/0o_kj0P3oooX0403loOD0ooom0?omo`3no_l0nocb0?oomP2c[kd0AdAE0?kmo`3nood0oooo
0?ono`3ooOl0ooko0?ooo@3moO/E0?ooo`00203oool0F03gmoL0oooo0?ooo`3_knl0emOG0=7Ad@3F
e]H0gmoO07inOP061PH0bl_;0?;blP3GemL0eMGE0=3@d03WinL0oooo0?KfmP3moOd0m?Cd0<[:bP3Q
hN40d=3@0>CTi03oool0m_Kf0?gmo@3dm?@0b/[:0>7Qh@3@d=00i>CT0?ooo`3fm_H0oOgm0?Cdm03:
b/X0hN7Q0=3@d03Ti>@0oooo0?KfmP3moOd0m?Cd0<[:bP3QhN40d=3@0>CTi03oool0m_Kf0?gmo@3d
m?@0b/[:0>7Qh@3@d=00i>CT0?ooo`3emOD0oooo0?3`l03IfMT0f=SH0=;BdP1YJFT0PH6102@T903J
f]X0l_;b0=?Cd`3MgMd0f][J0>7Qh@3moOd0oooo0?_kn`2XZ:P0EUIF01HF5P0];Bd0OGem0>;RhP3o
ool0nOWi0??cl`3Hf=P0dM7A0=GEe@3Zj^X20?ooo`060?Ogm`3clo<0d=3@0=kNgP3De=@0jn_[803o
ool20?gmo@L0oooo00X0FUYJ09nOW`3moOd0no_k0?ooo`3Ogml0QHF505UIF@2SXj<0jNWY0`3oool0
1P3moOd0o?cl0?ooo`3oool0n_[j0?_kn`80oooo0P3lo?`90?ooo`040?[jnP3lo?`0Vi^K00L71`<0
000000`00@4100`<303/k>`0oooo0?knoP3oool0moOg0?ooo`3no_h0oooo0?knoP3inOT20?ooo`0;
0?Win@3oool0i>CT092@T01aLG40X:2P0>g]k@3gmoL0oooo0?clo03kno/00P3oool0103no_h0oooo
0?ooo`3jn_X40?ooo`050?gmo@3jn_X0oooo0?ooo`3lo?`0803oool20?koo`0>0?gmn`3ooo/0n_We
03hj=`0100006a/I0=SGfP3nool0n_go0?coo`3hmoX0ooko0?ono@3ln_T20?ooo`0;0?gmo@3oool0
oooo0?clo03oool0mOGe0=kNgP1UIFD0jn_[0?ooo`3kno/00P3oool04`3jn_X0IVIV0000000?3`l0
410@00410@2HV9P0fMWI06IVIP0410@0EeMG0<o?c`3kno/0o_kn0?gmo@3oool0n?Sh0?Ogm`3jn_X0
0P3oool0103inOT0oooo0?ooo`3inOT90?ooo`040?knoP3lo?`0oooo0?clo0<0oooo01T0nOWi069R
H028R8H0o_kj0?oon`3jnoD0o_oi0?Gdk@3oooH0noWh0?Ceo`3gn_l0o_od0=oOd`0j<Sl0Zj>f0?Ki
oP3kool0o_oo0?ono`3onol0oogo0?koo`3ioO`0o_oo01@0oooo000:0?ooo`0;0?Cdm02n_[h09RHV
02LW9`0/;2`0MWIf0?ooo`0b<S80M7Ad0;Fe]@0U9BD00P0/;2`02P1`L700o_kn0?ooo`3oool0][Jf
03<c<`0O7al0:b/[06i^KP3no_h20?ooo`060;Jf]P0c<c<07alO02/[:`1^KVh0o_kn0P3oool01P2f
][H0<c<c01lO7`0[:b/0KVi^0?knoP80oooo00H0][Jf03<c<`0O7al0:b/[06i^KP3no_h20?ooo`06
0;Jf]P0c<c<07alO02/[:`1^KVh0no_k0P3oool09@2i^KT0;bl_020P800X:2P03Ph>0<o?c`1:BTX0
/[:b0:f][@0c<c<07alO02HV9P1dM7@0oOgm0?ooo`3moOd0_[jn02<S8`0Q8B406a/K02LW9`0>3Ph0
=CDe08n?S`2PX:008R8R02TY:@0[:b/0JVYZ0?ooo`3hn?P0oooo0;Ng]`0^;Rh092@T02/[:`1^KVh0
8@3oool02P3no_h0oOgm0?ooo`3lo?`0nOWi0?gmo@3oool0n_[j0000003_knl20?ooo`0;0?Win@3o
ool0o?cl0?ooo`3Shn<0SXj>05eMG@2DU9@0hn?S0?ooo`3no_h00`3oool20?gmo@030?knoP3oool0
oooo00T0oooo00/0o?cl0?_kn`0X:2P0000000D51@0820P00`<30000002m_Kd0n_[j0?clo0020?oo
o`040?knoP3oool0oooo0?gmo@@0oooo00/0n_[j0?ooo`3lo?`0oooo0?Ogm`3]kNd0X:2P075aL@2@
T900i>CT0?ooo`020?gmo@070?[jnP3moOd0oooo0?ooo`3lo?`0n_[j0?knoP020?ooo`030?clo03m
oOd0oooo0240oooo00`0o_oo0?_lo03lo?X0oook0?kln`3oo_d0DU5=000000061@X0CTiD0=7EeP3k
ool20?ono`040?[hm`3ooO`0oooo0?Cdm080oooo0P3lo?`0103oool0cLg=06a/K03no_h20?gmo@06
0?ooo`3kno/0no_k0?ooo`0_;bl01`L70`0000002@0<30`06QXJ0861P@3Ti>@0Hf=S0?ooo`3kno/0
oooo0?knoP040?ooo`80o_kn00<0oooo0?gmo@3no_h02@3oool02`3no_h0oooo0?ooo`3moOd0o?cl
0?ooo`3jn_X0o_kn0>CThP0;2`T0lo?a0080oook01@0oooj08^<QP010@00RH9g0:NSX0032Ad0g>Gd
0?gol`3hm>H0ooGo03T`@`3YkO@0lO[l0?_oo`3oo_l0ooWk0?oko@3lool0nOoo0?kooa@0oooo0008
0?ooo`80o?cl00<0oooo0?knoP3oool00P3oool01@3inOT0oooo0>OWi`0M7Ad0^k^k0080o?cl00P0
oOgm0?ooo`3moOd0n_[j0?_kn`3oool0nOWi0?gmo@80oooo00H0oOgm0?[jnP3kno/0oooo0?Win@3m
oOd20?ooo`060?gmo@3jn_X0no_k0?ooo`3inOT0oOgm0P3oool01P3moOd0n_[j0?_kn`3oool0nOWi
0?gmo@80oooo00H0oOgm0?[jnP3kno/0oooo0?Win@3moOd30?ooo`040?knoP3oool0oooo0?;blP80
oooo00<0oOgm0?ooo`3no_h00P3oool0203moOd0oooo0?ooo`3no_h0oooo0?gmo@3oool0o?cl1@3o
ool0202o_kl0J6QX00`<300k>c/0P8200=CDe03oool0n?Sh0P3oool00`3moOd0o?cl0?ooo`0S0?oo
o`030?gmo@3oool0oooo00<0oooo00<0o?cl0;6a/@14A4@0103oool00`3emOD0oooo0?[jnP030?oo
o`060>KViP2HV9P0K6a/0820P03Lg=`0kno_0P3oool0103no_h0oooo0?ooo`3gmoL80?ooo`040?Og
m`3oool0oooo03Xj>P800@410P0000003@0:2PX0no_k0?gmo@3oool0oOgm0?ooo`3clo<0o_kn0?_k
n`3no_h0oooo0?clo03hn?P00P3oool0403lo?`0oooo0?clo03oool0oOgm0?[jnP3moOd0l_;b0:VY
Z@1]KFd0QhN70=?Cd`3oool0oOgm0?Shn03no_h30?ooo`050?_kn`3moOd0oooo0?ooo`3lo?`08@3o
ool04@3nool0nocl0?oon`3ooo/0ooko0?cjn`3in?<0EeMC00001@030`/00PH705IJF@2m_<40n_Sk
0?omo@3oo_/0oogl0080oooo00D0o_kn0?clo03oool0WYjN09:BTP020?ooo`0D0?gmo@3jn_X0oooo
0?knoP3moOd0fm_K00`<300000000`<30000000;2`/020P80>o_k`3kno/0oOgm0:NWY`3;bl/0o?cl
0?knoP3oool20?gmo@030?Shn03no_h0oooo0080oooo00<0o?cl0?Win@3oool02@3oool00`3kno/0
oooo0?knoP030?clo00J0?ooo`1]KF/0MWId0?oon`3knoL0oooj0?Sil`1OH5P0`<2f0>CNd0030000
CUA/0;[2e`3noo@0f=C407mcO@0>1AP0k?3k0?;ko`3kool0ooko0?ojnP3onoT0o?oo0?Woo`3noolD
0?ooo`002@3oool00`3moOd0o_kn0?ooo`040?ooo`070?gmo@3oool0aLG500d=3@3WinL0o_kn0?[j
nP030?ooo`060?_kn`3no_h0oooo0?knoP3oool0no_k0P3oool01P3kno/0o_kn0?ooo`3no_h0oooo
0?_kn`80oooo00H0no_k0?knoP3oool0o_kn0?ooo`3kno/20?ooo`060?_kn`3no_h0oooo0?knoP3o
ool0no_k0P3oool0303kno/0o_kn0?ooo`3no_h0oooo0?_kn`3moOd0o?cl0?ooo`3kno/0oooo0?Sh
n0<0oooo00@0oOgm0?[jnP3inOT0o_kn0P3oool02P3no_h0oOgm0?knoP3oool0oOgm0?ooo`3kno/0
nOWi0?ooo`3lo?`30?ooo`070;fm_@1^KVh07AdM02LW9`1lO7`0f=SH0?Ogm`020?ooo`030?KfmP3o
ool0o?cl02<0oooo00T0o?cl0?gmo@3oool0oooo0?clo01QHF40T92@0?gmo@3kno/00P3oool20?kn
oP80oooo0P3lo?`20?ooo`090?Win@3emOD0[Jf]06i^KP1fMWH0b/[:0?knoP3moOd0o?cl00X0oooo
00`0o_kn0?gmo@2TY:@02PX:00D51@00000020P80:NWY`3oool0oOgm0?ooo`3moOd20?ooo`040?_k
n`3oool0o_kn0?knoP<0oooo00D0o?cl0?ooo`3oool0oooo0?Win@030?ooo`80o_kn00`0oooo0?3`
l02j^[X0MWIf07emO@3=cLd0o_kn0?ooo`3gmoL0oooo0?clo03hn?P20?ooo`030?_kn`3oool0oooo
01l0oooo0P3nool04@3ko?H0oook0?[go@3oo_l0oooh0?Kgl@0_;cL00P8<004510000@005aHK018?
5@1dKfl0[j^X0>WWiP3oool0m_Kf0080oooo00<0Ng]k0;Rh^03oool00P3oool00`3lo?`0o_kn0?[j
nP030?ooo`0301/K6`020P8010@40080000000X0LG5a0?gmo@3oool0oooo0=7Ad@2_[jl0oooo0?Og
m`3oool0oOgm0`3oool00`3moOd0nOWi0?ooo`020?ooo`030?[jnP3oool0oooo00L0oooo00<0nOWi
0?knoP3oool00`3oool00`3Rh^8030`:0>g]j`020?oon`80oooj01<0FEYB08j>PP3imnH0YZFP014@
;@3gn?l0o_od0?ook@3km?/0ooSo0?Wko`3kool0o_ko0?ono`3oo_P0oogf0?gnoP3lool0o_oo01@0
oooo00090?ooo`030?clo03oool0o?cl0080oooo00<0o?cl0?ooo`3no_h00P3oool00`2h^;P0MGEe
0?gmo@020?ooo`090?gmo@3oool0oooo0?ooo`3lo?`0oooo0?[jnP3oool0oOgm00<0oooo00D0o?cl
0?ooo`3jn_X0oooo0?gmo@030?ooo`050?clo03oool0n_[j0?ooo`3moOd00`3oool01@3lo?`0oooo
0?[jnP3oool0oOgm00<0oooo00L0o?cl0?ooo`3jn_X0oooo0?gmo@3oool0o?cl0080oooo00@0no_k
0?ooo`3inOT0o?cl0`3oool0103no_h0oooo0?knoP3no_h20?ooo`030?clo03oool0o_kn00D0oooo
00h0no_k0?ooo`3oool0oooo0?knoP38b<P0MGEe024Q8@0T9BL0NWYj0<S7``3ooo/0oooo0?kmo`80
ooko00@0oooo0?ooo@3nool0o_oo0`3oo_l=0?ooo`80o_oo3@3oool01@3no_h0oOgm0?ooo`0C4a<0
hN7Q0080oooo00H0o?cl0?_kn`3oool0oOgm0?ooo`3inOT20?ooo`0<0?gmo@3oool0oooo0?clo03m
oOd0oooo0?Ogm`2j^[X0K6a/079bLP31`L40no_k2@3oool02@3moOd0o_kn0?ooo`2e]KD0?clo02`/
;02/[:`0o_kn0?gmo@020?ooo`80o_kn00<0n_[j0?ooo`3jn_X00P3oool01P3lo?`0oooo0?ooo`3i
nOT0oooo0?knoP80oooo00<0o_kn0?ooo`3lo?`0103oool02P3jn_X0no_k0?ooo`30`<00MgMg07Ui
N@33`l<0n?Sh0?ooo`3kno/20?ooo`050?clo03no_h0oooo0?ooo`3ooOl00P3oo_l30?ooo@H0oooo
0`3oo_l30?ooo`@0o_oo00<0oooo0?ooo@3oool00`3oool20?ono`040?_jo@3oool0o_kj0?kno080
ooko00X0m_O]0?oon03Xj?003`lI00010`000000000400000P050`8030/70P0000001@3oool0l?3`
065QH@3Ti>@0oooo0080o_kn00<0no_k0?ooo`3no_h00P3oool03@3moOd0o?cl0=CDe00A4A402PX:
00`<300m?Cd0oOgm0?knoP3moOd0o?cl06YZJP3Ph>000P3oool01@3no_h0oooo0?clo03oool0oOgm
0080oooo00<0no_k0?clo03oool02@3oool08@3moOd0oooo0?ooo`3kno/0o?cl0?ooo`3moOd0MWIf
06a/K03oood0o?ch0?cmm`3oooX0ookg0<2o^00k>bl0oooa0>k^jP0B3bP0e=;X0?kom`3ooo<0oO_n
0?oko`3noOl0o_ko0?kmo`3oo_l0oooj0?onn@3noOl0o_oo0?ono`0D0?ooo`00H03oool03P3no?/0
o_kn0=;EfP1fMgT09R<J02DR6@1dM780a<G90?gmo`3ooOl0oogl0?knnP3iood0nooo0P3oo?l0103o
oOl0o_co0?ooo`3lo?`20?koo`0;0?[jn03oood0ookm0?gknP3ln_/0ooko0?ooo`3mo_h0nooo0?co
o`3nool0203oool20?knoP070?ooo`3hn?P0oooo0?_kn`31`L40=cLg0?[jnP050?ooo`030?knoP3o
ool0oooo00H0oooo00/0oOgm0?ooo`3oool0o?cl0?ooo`3kno/0_[jn07YjNP1XJ6P0_;bl0?Shn002
0?gmo@@0oooo00D0o_kn0?clo03oool0oooo0?clo0040?ooo`030?knoP3oool0oooo0080oooo00<0
oOgm0?knoP3oool05P3oool04P3De=@0OWin07=cL`2^[Zh0moOg0?ooo`3emOD0oooo0?ono`3knO`0
oo_o0?ojo@3ooOd0nOWe0?konP3mooT0ooom0?ooo`80o?go00P0o_oo0?kno03onO`0ooco0?omo`3m
no`0no[m0?koo`80o?oo00@0noon0?coo`3nood0oook0P3oo_d40?ono`060?Wim`3oood0ooko0?_k
o`3nool0o?kk0P3nooH03@3noOl0e]CM00X6400100D010850000000U9b80G65K09NIUP2a/K40f][J
06QXJ03]kNd00P3oool00`3lo?`0oooo0?ooo`050?ooo`070?knoP3oool0o_kn0;Zj^P3:b/X0oooo
0?Win@020?ooo`0509>CT`3AdM40oooo0?ooo`3gmoL00`3oool0103moOd0oooo0?Shn03no_h20?oo
o`040?[jnP3oool0oooo0?Win@80oooo00H0o_kn0?gmo@3moOd0oooo0?koo@3moo`20?koo`80ooko
0140k>_^01@D503Rh>40ookm0?onnP3noOP0oocc0?oom03nno00H5eD09JET03moOd0E59M09ZHX@3l
o?X0oook0?_jo@050?ono`80oooo0P3oo_lE0?ooo`00H03oool07P3oo_d0oOgm0?Olo`3lool0oogc
0=??``1hN7@0;2ld01XI9P1ZJ7<0alG40?cmm`3anoH0m_kl0?olo`3onol0ooco0?ono`3knOX0oooo
0?GfmP3nool0ooom0?gmn`3no?/0ookm0?omo`3oo_l0o?cl0?_lo080nooo00<0o_oo0?ooo`3oool0
1@3oool02P3moOd0oooo0?_kn`3moOd0oooo0?Shn03oool0J6QX08:2PP3lo?`20?ooo`030?clo03o
ool0oooo00T0oooo00D0o_kn0?ooo`3oool0oOgm0?clo0020?gmo@080?_kn`3oool0b<S807]kN`1/
K6`0[:b/0>k^kP3oool20?clo0<0oooo00<0n_[j0?Cdm02g]kL00P3lo?`0203no_h0oooo0?ooo`3n
o_h0no_k0?knoP3oool0o_kn5`3oool02P3hn?P0oooo0?ooo`3Ng]h0QXJ606][J`2YZJT0kno_0?on
o`3ooOl20?oko`060?omoP3moo`0o_oj0?kon03no_X0no_i0P3nool01@3ko?h0oooo0?olo`3onO`0
oogo0080ooko00H0o_oo0?_no`3iool0n_on0?coo`3nood20?oon`0;0?ono@3oo_l0ooko0?kno`3o
o_l0ookk0?Kel@3en?d0nooo0??gn03jn_H00P3oooH03`3nool0n?Sn07EaO@0;1@l03PT=02h/:`0c
>CD0kO?_0?WjnP31`L40MgMg0?[jnP3oool0moOg0?gmo@080?ooo`050?knoP3hn?P0oooo0?clo03n
o_h00P3oool04`3no_h0RXZ:0;jn_P3gmoL0o_kn0?ooo`3moOd0oooo0?Shn03no_h0oooo0;Bd]03d
m?@0oooo0?gmo@3oool0moOg0?gmo@3gmoL00P3oool00`3fm_H0oooo0?clo0020?ooo`0G0?goo03h
n_L0o_oo0?cmo@3noOl0n?Oj08j=T01FEEP0oogn0?gknP3oo_/0ookj0?oomP3kn>d0oogc0?omm026
Q8<0Kfia01HE6019B4/0o_go0?ono`3lnoh02@3oo_lE0?ooo`00H03oool07P3ooO`0oooo0?[oo`3k
ool0ookf0?onm03oood0o_oo0=GGh@22PXX0=38a01PH501OIfD0`<K60?omo`3on?/0ooco0?omoP3o
o_l0oooo0?koo`3in_X0o_oo0?_kn`3oo_l0noWj0?Sfm`3oo_l0oooo0?koo`80o?oo00<0o_oo0?oo
o`3oool01`3oool0203no_h0oooo0?ooo`3moOd0n_[j01lO7`3GemL0oOgm0P3oool00`3kno/0oooo
0?ooo`0:0?ooo`030?_kn`3jn_X0oooo00D0oooo00P0n_[j0?ooo`3oool0e=CD08:2PP1_Kfl0Vi^K
0??cl`80oooo00@0n?Sh0?ooo`20P800JVYZ0`3oool00`3lo?`0n_[j0?ooo`020?ooo`030?gmo@3n
o_h0oooo01P0oooo00h0n_[j0?Win@3oool0oooo0>7Qh@2;Rh/0Jf][09bJV`3ajn/0oocn0?coo`3k
ool0nogh0?kon080o_oj00X0o?cj0?ono`3moOl0o_ko0?_inP3oo_d0oo[j0?kln`3oool0o_oo0`3l
ool00`3ioO`0o_om0?ooo@020?ono@0H0?ooo`3oo_l0o_oo0?ono`3onoP0oo_i0?Soo`3dool0nOoo
0?oon`3oo_H0oo_e0?[kn`3kool0m_Ko01/G8@0<0@L0RH>308>9Q@0=5Q40MGIf0:>SX`3oool0o?cl
0`3oool00`3lo?`0oooo0?ooo`050?ooo`030?knoP3oool0n?Sh00<0oooo00D0n_[j06QXJ039bLT0
oooo0?clo0020?ooo`090?knoP3moOd0oooo0?_kn`3oool0IVIV00l?3`1_Kfl0g=cL00@0oooo00L0
oOgm0?ooo`3oool0oOgm0?_kn`3oool0no_k0080o_om01H0o?gm0?gnoP3oo_l0n?Oj00l>4@3JfM`0
ooko0?ono@3oo_/0nOGa0?oon03oooH0nOK[0?oon03no?/0ooko0>[Yk0071PT0k>_^0?[io03oo_l0
o_go203oo_lE0?ooo`00H03oool06@3mnoX0oooo0?_oo`3kool0o_Se0?kil`3knoT0noco0?_no`3n
ool0lo7`0>;Pg`2;Si00;2lc01LE501VH600^kJh0?[hn@3ooOh0o_kn0?WjnP3nool0n?Wi0?koo`3o
oOh00P3oo_l01@3mno`0no_k0?koo`3nool0nOgl00T0oooo00T0n_[j0?ooo`3oool0nOWi0?ooo`3:
b/X0:b/[0?ooo`3moOd03P3oool0103moOd0oooo0?ooo`3oool20?gmo@030?clo03jn_X0n_[j0080
oooo00h0oOgm0?ooo`3oool0l_;b0>?Sh`2;Rh/0Hf=S08n?S`3YjNT0oooo028R8P37alL0oooo0?_k
n`@0oooo00@0o_kn0?clo03oool0o_kn5`3oool01@3lo?`0n?Sh0?ooo`3kno/0o?cl00@0oooo00l0
j>KU0:>RWP1]KFd0S9>K0=_RjP3lo_/0oooh0?_om`3ko_D0oo_g0?omo`3hn?l0o?ko0?coo`3inoH0
0P3oo_d0103moOd0o?cl0?cmo`3lool20?koo`040?ooo`3oood0ookm0?ono@80oooo01D0o_oo0?on
o`3oo?P0oogj0?;ko@3dool0nOoo0>k^k01;@Sd0=bhY01LG5`3HgN40n_co0:JT[@0=10T0OWMj0?[n
n`1BF5@04a@D09FEU@3gmoL00`3oool00`3hn?P0oooo0?ooo`060?ooo`0I0?knoP3oool0n_[j0?oo
o`3kno/0jn_[05UIF@3_knl0n_[j0?gmo@3oool0o_kn0?clo03oool0n?Sh0?_kn`3oool0o_kn0?oo
o`3Shn<0Ogmo00l?3`11@D40]kNg0?_kn`020?ooo`030?Ogm`3oool0o?cl00<0oooo01H0nogj0?ko
o@15ATH0hN;R0?glo`2EU9L0EUEH0?ckoP3mno`0ooko0?omo@3oo_/0ookj0?oon03oooH0moK_0?_i
n03oo_l0k>_^028Q902g][T0ooko0P3mo?l80?onoaD0oooo001P0?ooo`0H0?gko03noOl0o?oo0?ko
o`3oo_/0oogk0?ooo`3nool0o?oo0?WjnP3ooo/0oo[j0?kno`3nool0hn?Q08n>RP10>c/04Q0A05EC
E02i^KT0o?gm0?gnoP3nool0nocl0P3no?d20?ono`040?ooo`3nool0oOkn0?_ooPT0oooo00<0o_kn
0?ooo`3lo?`00P3oool00`1gMgL0N7Qh0?ooo`020?ooo`050?knoP3oool0oOgm0?ooo`3no_h0203o
ool01P3moOd0oooo0?ooo`3moOd0nOWi0?knoP@0oooo00<0o?cl0?Win@3oool01@3oool01@35aLD0
VIVI051@D00H61P0eMGE00<0oooo0P3jn_X20?ooo`030?_kn`3no_h0o_kn01P0oooo01h0o_kn0?_k
n`2NWYh0BTY:01DE5@14A4@0SHf=0?WgmP3ooo/0mOGa0?coo`3^mol0XJVd07AcMP24Pgh0cmK>0?co
n03oo_H0ooWg0?kno`3iool0l_[j0?_on`3inOD0no[f0?gmn`3oood0oooo0?_lo03mo?l20?ono`D0
oooo01X0o_oo0?ono@3onoD0oocg0?Gmo`3eool0n?oo0?koo@3onO@0W9>>0?7/kP3Xind0o?oo0?Ki
o`000080Bd];05mOG`3TiND0e]KF02h^;P1SHf<0n?Sh0?ooo`3fm_H0oooo0?Shn0L0oooo00P0o_kn
0?ooo`3oool0oooo0=_Kf`1SHf<0oooo0?Win@80oooo00H0n_[j0?ooo`3moOd0n?Sh0?ooo`3gmoL2
0?ooo`0?0?Ogm`3oool0moOg0?ooo`2[Zj/0<C4a01/K6`20P800lO7a0?ooo`3kno/0oooo0?Win@3o
ool0o?cl0080o_om00D0@48o0;jo_`3cl_D071/N0<O6b@030?ono`0=0?klo@3oo_d0o_[g0?kjmP3o
o_X0oooj0?ono@3inOT0hn?S0:JVYP2b/[80oooo0?knoP0N0?ooo`00H03oool20?ono`090?Wlo`3k
o?l0oo_m0?omo@3oo_l0o_oo0?_oo@3loo/0nOGb0080oogo01<0ooko0?GglP3oooX0n_Sg0>[Ui`2L
VY/0=cLg00l@401JFe/0ZZ^[0?Ohn03oool0ooko0?gko03knOX0o?cl0?gnoP3nool0o?oo00/0oooo
00H0o?cl0?ooo`3oool08R8R0<o?c`3jn_X20?ooo`030?gmo@3oool0no_k00/0oooo00<0o_kn0?cl
o03oool00P3oool0103moOd0nOWi0?[jnP3no_h20?ooo`0>0?knoP3lo?`0o_kn0?ooo`3inOT0o?cl
014A4@3Zj^X0MgMg06i^KP2_[jl0IFEU07YjNP38b<P30?ooo`040?_kn`3jn_X0oooo0?knoQL0oooo
01X0oOgm0?[jnP0410@00`<3000000010@400000018B400e<c80n?Sd0?konP3iool0koSo0?Soo`3m
noh0ookm0;:h]01cMFl0OWAX0<o4_P3ooOl0nOoo0?Koo`3iood0o_om0?oon`80ooom0P3oool00`3o
oOl0oOco0?ono`020?ono`<0oooo0140o_oo0?oon`3on_80oogf0?_oo`3gool0loko0?[oo03nnO<0
nO3[07acMP3onOl0o?oo0?Slo`1IGel03A4@0?3^k`020?ono`060??cl`1IFET0<30`0<[:bP3oool0
o_kn203oool02`3no_h0o?cl0?ooo`2[Zj/0PX:20?ooo`3lo?`0oooo0?Win@3kno/0o?cl00<0oooo
00D0n?Sh0?ooo`3jn_X0oooo0?knoP020?ooo`080?_kn`3lo?`0oooo0=?Cd`1WIfL030`<05iNGP37
alL20?ooo`0;0?_kn`3oool0nO_h0?koo@1RI640TiFB0:ZZZP15A4L0oOco0?ono`3ooOl00P3oo_l0
2@3mno`0oo_k0?onn`3oo?T0nOSd0?ooo@3oool0nOWi0?gmo@020?ooo`80oOgm7@3oool00600oooo
00@0o_kn0?ono`3lool0o_oo0P3ooOl06P3no?l0nocl0?Won@3looX0ookk0?gfn@3onol0o__o0?co
o@3kooT0ookm0?okn`3oo_l0n_[j0>OXj02GViX0@T=500`=3`1BDE@0YJBW0??alP3oo_l0oOgm0?gn
oP3nood0n?ci2@3oool01P3lo?`0oooo0?ooo`3gmoL0e]KF02@T9080oOgm00H0oooo0?knoP3oool0
oooo0?knoP3moOd:0?ooo`060?knoP3oool0oooo0?ooo`3lo?`0o_kn203oool0403moOd0oooo0?oo
o`0l?3`0`/;201`L703GemL0oOgm0?ooo`3dm?@0^[Zj071`L01^KVh0_;bl0?gmo@3oool20?knoQL0
oooo0240oOgm061PH0051@D0000000<30`0000000@4100400004000092<O0?con`3iool0mooo0?Wo
o`3oo?l0noKh0?Sko`3ooo/0ooc_0<fl/01gMGP0Jg9j0;_4a`3eoOl0lOGd0?gmn`3oood0oOgk0?_i
nP3oo_l0oogo0?ono`3ooOl00P3oo_l20?koo`80o_om01P0oooj0?ollP3ooO@0kNk`0>ohn`3fool0
nOoo0?onnP3onoT0m^W^079ZL`3gn_l0]l35071jN@3iood0oogo0?gfn`3imoP0o?cl0?ooo`20P800
2`/;0?ooo`3hn?P80?ooo`070?knoP3fm_H0T92@0:ZZZP3oool0o_kn0?[jnP020?ooo`0H0?Ogm`2m
_Kd0g=cL0?Ogm`3lo?`0oooo0?_kn`3oool0mOGe0?ooo`3lo?`0oOgm0?KfmP3oool0oOgm0?clo03i
nOT0lO7a08j>SP0P8200<c<c09FEU@3fm_H0oooo0P3nood207YlN@0=02TY:@2n_[h0no[m0?glo`3n
oOl0oOco0?klo`3oo_l0oogn0?kln`3gmO@0ookm0?_kn`020?ooo`050?gmo@3emOD0o?cl0?ooo`3m
oOd07@3oool00640oooo01l0oOgm0?cmo`3nool0oogo0?olo`3oo_l0o_oo0?_onP3jooP0oogj0?ol
o@3omol0ooco0?_oo`3iood0noWh0?omo@3oo_l0oooo0?gnoP3kooh0o_oo0>_/kP2MW9l0B4M:01@B
4`16A4D0ZZZZ0>k^kP3nood0o?kk00X0oooo00D0o?cl0?ooo`3oool0PX:206e]K@020?ooo`060?[j
nP3moOd0oooo0?knoP3oool0n_[j403oool01P3lo?`0oooo0?clo03no_h0oooo0?gmo@80oooo0180
o_kn0?ooo`3kno/0E5AD07inOP0b<S80o_kn0?ooo`3moOd0oooo0?gmo@3no_h0n_[j0<C4a01`L700
KFe]0;Bd]03no_hG0?ooo`030<_;b`0410@01PH600<0000001`00P8200<10P070@404Ph;0;Rm]`3f
o_`0n?oo0?[oo`3iloX0ooco0?kno`3hm_T0ooGW0;^YVP1fMG40TIJJ0;Nna01hOhD0MWal0;Bh]`3a
l_80oooo0?omo`3oo?h0ooco0?kio@3ooOl0ooko0`3nool04@3nood0o_ok0?oon03onNh0SH1g00<7
1P1FH6D0NhJ80?;hn03mmo@0jmoN0?oho@0`:340P8B;0:>/[`3do_d0nooo0080ooco00L0ooko0?kn
oP3Rh^809bLW05]KF`3oool0o?cl00P0oooo00@0o_kn06UYJ@3:b/X0o_kn0`3oool0203lo?`0oOgm
0?ooo`3Bd]806a/K0:^[Z`3oool0oOgm0`3oool01@3jn_X0oooo0?ooo`3oool0no_k00<0oooo00d0
no_k0?ooo`3moOd0^KVi051@D00>3Ph0LW9b0=[Lf@3koOX0W9jK03m1?P0h>3P0n_[j00@0ooko00<0
n_Sk0?ono`3mno`00P3oo_l01@3ln_/0o_kn0?gmo@3oool0oOgm0080oooo00<0n_[j0?ooo`3oool0
703oool00680oooo0P3nool20?omo`0B0?ono`3nood0nook0?_onP3oo_/0oo_m0?oioP3oo?l0n?oo
0?Ooo`2>SXh0100003<a<P2^[Zh0o_oo0?[no@3lool0o_oo0P3oo_l0203^k>d0ZJNX04=3@`0A4A40
B4Y709jPW@3]kNd0oooo0P3no_h30?ooo`080?Win@3oool0oooo0?ooo`3fm_H0oooo03/k>`2l_;`4
0?ooo`040?knoP3moOd0oOgm0?knoQ/0oooo00D0M7Ad03Ph>02<S8`0oooo0?gmo@020?ooo`0=0?_k
n`3oool0oooo0?_kn`3oool0oOgm0<S8b01mOGd0IVIV0:^[Z`3jn_X0oooo0?_kn`040?ooo`050?cl
o03oool0oooo0?[jnP3oool00P3no_h00`3oool0oOgm0?gmo@020?ooo`160?_kn`3oool0XJ6Q00l?
3`0000000@4100<30`0000001PH600800@0400003@L709VKV03kood0o?om0?Ohn03ooOl0ooWo0?_h
o`3onol0TGe`0140002JUhh0If]/00P84P3Be>00m_[o0=WNh@24R8T0JVYZ0;2[[@3eknl0o_Oj0?om
o`3lnOl0ooko0?koo`3dn?T0o_oo0?koo@3moOT0ookf0?obi`0I2`00dMWG0?;oo`32cm<0c<oC0?og
m`2RTY<05PdB028Q9P34bll0n?oo0>KZj`030`<0e=7G0?ono`3mo?l0iNGU01TI6@2?Shl0oooo0?gm
o@3oool0o?cl0?gmo@3oool0oOgm0?_kn`80oooo00@0iNGU05aLG03^k^h0nOWi0P3oool02P3moOd0
oooo0?ooo`3oool0oOgm0?ooo`3De=@04A4A0;:b/P3oool20?knoP060?gmo@3oool0oOgm0?knoP3o
ool0moOg0`3oool03`3jn_X0oooo0?ooo`3moOd0oooo0=_Kf`1hN7P05ALD04E7A022PX004A4?0=GE
e@3jn_X0ooko0?glo`020?ono`060?glo`3oo_l0o_go0?ono`3lnoh0ooko0`3oool0103no_h0oooo
0?ooo`3kno/N0?ooo`00HP3oool04`3nool0oooo0?ono`3ooOl0ooko0?koo@3hoo`0n?oh0?okn03o
noX0ooKg0?oko@3gool0k_go0?clo02[YJD0h]gO0>[ZjP3in_X00P3lool03P3gno`0nocn0?ono`3n
o?l0o_cm0?ooo`3bl_00Y:JS059DD@0@4100ADE509bLW03Zj^X0o?cl103oool01@3emOD0oooo0?oo
o`3Vi^H030`<00<0o?cl00<0oOgm0?ooo`3oool00`3oool00`3no_h0oooo0?ooo`0F0?ooo`80o?cl
00/0T92@00@4101kNg/0hN7Q0?ooo`3jn_X0no_k0?ooo`3no_h0nOWi0?gmo@030?ooo`0;0?[jnP3o
ool0d];B08J6QP1RHV80WinO0?Cdm03clo<0oooo0?[jnP3oool00P3lo?`00`3oool0no_k0?gmo@04
0?ooo`070?_kn`3no_h0oooo0?ooo`26QXH03Ph>00D51@020000000M00@4100000000@0000T30`0:
10@0PX:20?kon`3lo?80oooh0?Sen`3/j?H0oo_o0?ogo`33[j80imK20?Wik@3lood0UY2J04A0CP3i
ool0n?oo0?[oo`3nool0iN3R09>=S@1kMGD0WIRJ0?;`l`3em_X00P3lool05`3nool0o_om0?oon`3o
no<0o>KI02`K4@3Ggmd0lOoo0?Ooo`3no_l0ooCg0?OWj01MEU/0h^GY0?Soo`3fo_l0YJBW0040003N
gN00oOco0=kMh00D51@0W9bL0080oOgm00<0n_[j0?ooo`3no_h0103oool01P3kno/0clo?06m_K`3m
oOd0n?Sh0?knoP80oooo00/0o_kn0?ooo`3oool0o_kn0?ooo`3emOD0oooo0=;BdP0?3`l0^k^k0?kn
oP020?ooo`040?_kn`3lo?`0oooo0?Gem@80oooo00<0no_k0?ooo`3kno/00P3oool02P3hn?P0no_k
0?ooo`3moOd0mOOd0:BVX`0`<2h04A4?0861P@3Zj^X20?ono`050?glo`3oo_l0ooko0?ckoP3noOl0
0P3oo_l00`3kn_d0oOgm0?knoP040?ooo`030?knoP3oool0oooo01`0oooo001P0?ooo`80o_om00<0
ooom0?ooo`3oo_l00P3oo_l04P3nool0nOoo0?_oo`3oo_/0oo_f0?oek`3onoX0lOko0?;oo`3jnod0
oo_i09B?S`3GemL0o_oo0?coo`3en?`0o?oo0?koo`80ooko00<0o_cm0?clo03moO/00P3nood02@3f
m_H0ZJVY05QHF00>3Ph0=CDe09VIV@3Vi^H0n?Sh0?gmo@020?ooo`030?gmo@2<S8`0J6QX0080oooo
00@0o_kn0?ooo`3oool0o_kn0P3lo?`K0?ooo`090?_kn`26QXH01PH606ATI00G5aL0;2`/07moO`3?
cll0m?Cd00@0oooo00@0lO7a0?ooo`3oool0moOg0P3oool02P3moOd0h>3P09FEU@1/K6`0Rh^;0>o_
k`3oool0no_k0?knoP3lo?`20?ooo`030?clo03hn?P0o?cl00<0oooo01l0o_kn0?ooo`2n_[h04A4A
0000000410@01PH60000000410@00P0100@0000D3a40^[Ri0?oonP3onn`0V9660000100000d03PDH
0=G7dP3on_40Zij=000300000@0081@M00L0203Tj_H0mOoo0?Soo`3gn_l0ooko0080oogm01/0j^GU
09ZHV`1eMWP0TYFI0=cRhP3jo_l0nO_h0?oon`3oo_H0oo[]061BA`2FVY/0looo0?7io`3[jo<0fLkB
06eQH`3mn?X0o_oo0?Woo`3cnOT0>CTi00X82@3;b/d0d]7D01/J7@2NWYh00P3oool0303moOd0oooo
0?Gem@3oool0o_kn0?Ogm`3oool0no_k0:>SX`2BTY80oooo0?[jnP<0oooo0P3no_h20?ooo`030?gm
o@3oool0no_k0080oooo00<0b/[:00T92@2f][H00P3oool00`3hn?P0oooo0?knoP020?ooo`040?_k
n`3oool0o_kn0?ooo`80oOgm0P3oool0303no_h0oooo0?gmo@3oool0nOWi0000001QHF404a<C05EE
E@36a/H0oooo0?Cdm080ooko00H0o_go0?Ken03oo_l0ooko0?gmo@3no_h20?ooo`040?gmo@3oool0
oooo0?clo1d0oooo001P0?ooo`80o_om0P3oood20?ooo`0@0?ono@3nool0nOoo0?_oo`3oo_/0ooC/
0?odj03onO80lOko0>_no`3nool0oogk0?ghn01^KV`0m_Oi0?_oo`80o?oo01P0noco0?cmo`3oo_l0
ooko0?ooo`3oood0oOgi0?_mn03lo?`0oooo0?knoP3moOd0^[Zj05EEE@0B4Q80?Shn09:BTP3Vi^H0
m_Kf0?ooo`0n?Sh0ZZZZ0?ooo`3no_h60?ooo`030?knoP3kno/0oooo01T0oooo0140@41001PH603m
oOd0oooo0<W9b@1`L7009BDU01dM7@1]KFd0]KFe0?ooo`3moOd0oooo0?gmo@3inOT0oooo0?gmo@02
0?ooo`80no_k00H0oOgm0>o_k`2@T900Fe]K08b<S03Lg=`20?ooo`050?_kn`3oool0oooo0?ooo`3k
no/00P3oool01`3lo?`0oooo0?ooo`0;2`/00`<3000000010@400P000000>@051@D01@<401/I6P3l
n_/0o?Oa0?oei00I3`40VYnS0?3fo`27OhX06P/@0?CUgP0>1@00Z:jZ0?Sln`1oKg003P040<?:f03a
ool0mooo0?_oo`3oo_l0o?Og0?omn`3oo_/0oO_l0?koo`3[k_80YZ^^06eaLP2=Sh`0emOC0?kgk`3o
o>d0k=kC00<21@3FgND0em_V00X:4P28PH@0ooWj0?omo`3hmoX0n_ko0=SLg@082PL02`/;0:BSYP0B
4A@0Y:>V0?ooo`3jn_X0oooo0?[jnP3inOT0oooo0?clo0020?ooo`060?Cdm022PX80_[jn0?Win@3j
n_X0oOgm0P3oool00`3no_h0oOgm0?knoP020?ooo`0;0?gmo@3kno/0oooo0?ooo`3kno/0oooo0<K6
aP0Q8B40^k^k0?Win@3moOd00P3oool01@3inOT0oooo0?gmo@3oool0o?cl0080oooo00D0n_[j0?oo
o`3oool0no_k0?Ogm`030?ooo`09024Q8@3Ogml0jNWY09:BTP0V9RH0;Bd]0:>SX`3jn_X0oOco0080
ooko00L0o_go0?_kn`3oool0oooo0?knoP3oool0o_kn0080oooo00<0o?cl0?ooo`3oool06`3oool0
0600oooo0P3nood20?ooo@0^0?kon`3ooo/0oook0?ooo`3gool0nOoo0?olnP3onnl0ooCQ030O5@0b
?e00gO7o0?kno`3Rg=X0oogm07YjN02a/[@0o?oo0?_oo`3dmo/0n__o0?koo`3oo_l0o?[k0?klo@3o
ood0oook0?gmn@3oool0n?Sh0?ooo`3jn_X0o_kn0?ooo`3jn_X0^KVi06=SH`0A4A40=cLg07inOP0A
4A40oooo0?Win@3oool0o?cl0?_kn`80n_[j00@0o_kn0?ooo`3oool0oOgm6@3oool00`3^k^h05ADE
00D51@020?ooo`0:0?Win@3oool0oooo0=;BdP23Ph<0?Cdm00820P1IFET0[jn_0>o_k`80oooo00@0
o?cl0?knoP3oool0o_kn1@3oool01`3_knl0Z:RX065QH@1jNWX0d];B0?_kn`3moOd00P3oool20?cl
o080oooo0300n_[j0>7Qh@010@4010@4000000061PH02PX:000000020`D0m_Kf0?ono`3ooOH0k]W6
01<5003WlOP0m?oo0?olo02GRH@0bl:m00`<303/m_l0loSl0?ohlP0c8Ad0TiZZ0?3oo`3^nol0nOoo
0?ckoP3oo_/0ooci0?onnP3oood0nocl0?[no`3kool0o?oo0?;cl`2j^;L0OWUa08UmK@3Od/L0hmcQ
06ARK`0o?T`0BTaF0?ono`3ooO`20?ono`070?glo`1:Bd/000400001000B4A@0X9jQ0?Gdm`080?oo
o`050?;blP1ZJVX0bl_;0?ooo`3jn_X00P3oool00`3moOd0o_kn0?ooo`020?knoP80oooo0P3no_h0
3@3moOd0o?cl0?gmo@3oool0n_[j0;fm_@0@4100bLW90?ooo`3moOd0oooo0?_kn`3no_h00`3oool0
0`3no_h0oOgm0?ooo`020?knoP<0oooo0180o_kn0?ooo`0j>SX0]kNg0?ooo`3nood0nO_h0;^m^P15
Ad@0418?06e^KP3Gf=P0o_oo0?gnoP3loOd0oooo0?ooo@3knoT20?ooo@030?clnP3oood0ooom00P0
ooom5@3oool00600oooo0P3nood00`3oood0oook0?konP020?oonP0A0?ooo`3hool0mogo0?okn@3o
m^L0ooWO06QFB01]O940cnCo0?Sjo`39`l40;RTY014A3`3/kNl0n?cm0?Smo`3kool00P3nool20?on
o`070?omoP3hm_D0n_[f0?oon`3inOT0oooo0?Ogm`030?ooo`0:0?clo03no_h0oooo0?_kn`30`<00
?clo0000000Y:BT0RXZ:0=gMg@@0oooo0P3no_hK0?ooo`0409nOW`1?Cdl04A4A0>SXj080oooo00<0
m_Kf0?ooo`3hn?P00P3oool03`3WinL0VIVI04I6AP0:2PX0ATI608b<S03Zj^X0oooo0?[jnP3oool0
o?cl0?ooo`3kno/0oooo0?Ogm`030?ooo`050?Ogm`2d];@0KVi^07EeM@2l_;`00P3oool00`3jn_X0
oooo0?gmo@020?ooo`0f0>3Ph017AdL00@4100X:2P030`<0>CXj0>[^k`3fn_T0ookm0?ogk`3om>40
91@50:Vj`@3`ool0oooc0?omk@3glo005QXU0;S4f03ko_l0oo[/0:VER01=EVD0kOoo0>kmo`3hool0
ooko0?onn`3mmo@0oooh0?knnP3lool0nooo0?Olo`3ioOh0nocl0?[hm`3nnO40o??R05M=@@1fKG80
?SM60=SEi02;RiD0dm;E0?ooo`3kno/0oOgm0<c<c0020P0010@000L71@0000802PT<0`0000003P3o
ool0o?cl0?ooo`3gmoL0oooo0>KViP1NGUh0k^k^0?ooo`3moOd0oooo05eMG@3emOD0o_kn103oool2
0?knoPD0oooo00l0lo?c0?ooo`3oool0`<3000l?3`33`l<0oOgm0;6a/@1jNWX0o_kn0?ooo`3no_h0
oooo0?Win@3lo?`0103oool01`3inOT0oooo0?7al@3oool0Ogmo0:f][@3kno/00P3nood02`3koOX0
o_om0=kPg@1jO7T06AXJ04E6AP2c];@0oOkn0?Ogm@3oood0n_[h0080ooom00<0no_i0?ooo@3oood0
203ooodE0?ooo`00H03oool20?koo@80oook01@0o_oh0?oon03oooP0ooko0?Soo`3io_l0oogk0?oh
j@3on]X0]jJD05ITOP3Tn_l0o?ko0?okn@3lmoL0no_i0?cmo`3lool0nooo0??hn`80oOko00H0o?_n
0?clo03oo_l0ookm0?oon`3moOT30?ooo`030?Shn03oool0o?cl0080oooo00l0o?cl0?ooo`3kno/0
AdM70:j^[P2o_kl0KFe]014A4@0_;bl0N7Qh0<o?c`3no_h0oooo0?_kn`3moOd06P3oool01P1>CTh0
WYjN03Lg=`3;bl/0o_kn0?gmo@<0oooo00h0n_[j0?_kn`3oool0oooo0?knoP3inOT0Zj^[069RHP0A
4A40<30`08^;R`3@d=00oOgm0?knoP<0oooo02l0nOWi0?ooo`3oool0m_Kf0?knoP3oool0nOWi0<30
`01]KFd0IFEU0;fm_@3oool0no_k0?clo03oool0o_kn0?Win@3oool0f=SH0?ooo`3loOd0nOoo0?_o
o`3ooo/0oo_c0?ohiP1iJEX0?eIL0>[oo`3oonL0c/N[07n0P01LI7L0CUio0?Gjo`3on>80]9j700XC
8P3Qn?l0lOoo0?;ko`3gn?`0ookk0?onn03oooP0oOgi0?[nn`020?_oo`0H0?coo`3nool0ookm0?om
n03ooNl0Y9N<03Ha=@3bkoh0cl[L061LJP3nn?l0o_kn0?_oo`3iool08B8R00<100060000100000<4
10083Ph05aPH07EeM@2SXj<0no_k0`3oool02@35aLD0MWIf0?gmo@3kno/0VYZJ02@T903WinL07alO
0=gMg@050?ooo`80o_kn0P3oool00`3moOd0oooo0?knoP030?ooo`0:0?Gem@2k^k/05QHF0=GEe@2m
_Kd0?Shn0?ooo`3dm?@0oooo0?_kn`<0oooo00L0no_k0?knoP3oool0oooo0?kmo`3oo_l0oooo0080
o?cl00<0o_kn0?koo@3hn_L00P3nood0203hn_L0o_om0?OimP2NX9d0=cTf01/M6P3Ng]`0ooom0P3m
oO/00`3oood0o?cj0?ooo@090?oooAD0oooo001P0?ooo`0F0?koo`3nood0ooom0?oon`3nooX0oooh
0?oonP3oool0mogo0?_no`3oo_/0oog]0?ofg03/g/l01Q4S0>[io`3lool0o_Wi0?ono@3oool0o_oo
0?[no`80o?oo00X0o_oo0?gno`3noOl0oooo0?ono`3ln_T0o?cj0?ooo@3oool0n_[j0P3oood0503l
o?`0ooko0?ckoP3oo_l0ooom0?kno03dm?803Ph>0?Gdm`3oo_l0o?cl0?ooo`34a<@0Lg=c02<S8`0U
9BD0NGUi0=KFeP3no_h0no_k603oool06P3YjNT04Q8B0??cl`2ZZZX0e=CD0?ooo`3inOT0oooo0?kn
oP3oool0o?cl0?ooo`3kno/0o?cl0?ooo`3lo?`0o_go0?ono`3hn?P0`L7106][J@0P82009B@W06e/
K`30`<00mOGc103oool01@3oo_l0o_go0?clo03oool0o?cl0080oooo00P0`/;207QhN01WIfL0/K6a
0??cl`3oool0oOgm0?_kn`80oooo01/0oOkn0?_oo`3goO/0ookm0?okm@3onN/0im[A00052`1QNGT0
d]Bl04U4;01FEeL0e]k`0001701`Lh@0ckbY02/J1P001A00f^co0?Coo`3fo?l0o_oo0?oon`3oo_X0
o_gh0?oon`3jo?T00P3kool05P3jo_l0o?gm0?ono`3onOH0dLNm071WGP1;BD`0dm?M02`X=P3/iO80
ooco0?gmo@3kool0JG5_00H81@040P402@0000d50`1:Bd/0bLo=0?coo`3hn_L20?ooo`060?cjn`3n
o?d0YZBU09JFUP3oool0moSh0P3nood01`2>SXh092@T0490@@2h][L0oooo0?knoP3moOd00`3no_h4
0?ooo`040?gmo@3no_h0oooo0?knoP80oooo00P0no_k0:b/[00G5aL0^[Zj01XJ6P3no_h0oooo0?_k
n`80oooo00X0oOgm0?clo03oool0oooo0?gmo@3oool0ooko0?_jo@3oool0oOgm0P3oool01P3jo?T0
oOol0?goo03koOX0o_om0?_mnP80o_om00X0nogj0<oAcP3:b/P0oOgk0?ooo@3lo?X0ooom0?gmn`3o
ood0o_kl203ooodE0?ooo`00H03oool40?koo`<0ooom00l0oooo0?gno`3loOl0oook0?onmP3on>d0
ookf01hQ9@3<d=L0oOko0?gmo@3oool0o_oo0?gmo@3loOd00P3nool0103oo_l0oooo0?ooo`3oool4
0?ono`0=0?glo`3oool0oook0?gmn@3lnoh0ooko0?WhoP3oo_l0oook0?oonP2PXI/0CTi<0?gno`02
0?koo`80ooom00/0ookm0?gko03=bl`0Lg9e02<R9@0O8280N7Uk0=3Ad`3gn?X0oooo0?knoP020?om
o0050?ono@3no?/0oooo0?ooo`3no_h00P3oool0203moOd0o_kn0?ooo`3oool0no_k0?ooo`3jn_X0
oOgm0P3oool01`3moOd0U9BD05YJFP3oool0o_kn0?ooo`3lo?`02@3oool03P3oo_l0no_o0?kno`3g
mOH0ookm0?cnn@3nood0clkC0860Q@0`<Rl05ALB05UIE`2c/K00m_Ce0P3oo_l01P3jnOh0ooko0?oo
o`3no_h0no_k0?knoP<0oooo02D0B4Q80820P01UIFD0Jf][0>o_k`3oool0n_[j0?ooo`3nool0nocl
0?knoP3oo_/0no?^0?onn`3Mh^D0D5QH00<4000`;bP0d];B0?coo`3KgnP0GEeS00P0002?RX@0OH24
0<[Af@3kool0o_oo0?ono`3moO/0ookm0?kno03moO/0oooo0?gnoP3nool0o?gm0080oooo02<0^;Je
08b8Q@3oo?T0k>c/0000102b/KH0oogo0?_io03oool0blc<00T:2P0000001`L704m:BP3MfmX0o_kn
0?coo`3koo/0o?ok0?ooo@3oo_l0ooco07YcN02k][P0ooko0?koo`3kool0nooj0?Kmm@3mo_h0NWUl
01/F602;QXP0ookm0?gknP020?ono`040?ooo`3moOd0oooo0?knoP<0oooo00`0n_[j0?ooo`3oool0
moKi0?ono`3inOT0oooo0:BTY00A4A402@T90?[jnP3oool20?knoP070?ooo`3kno/0oooo0?ooo`3i
nOT0oooo0?[jnP0e0?ooo`00H03oool40?koo`@0oooo0P3oood01`3lo?P0oook0?oon`3kn_H0Ph9m
08^;Q`3oood00P3nool01@3loOd0oooo0?ooo`3oool0oOgm00@0oooo1@3oo_l04`3inOT0oooj0?oo
nP3kn_d0mOCj07QfP@3Hem`0o?ch0?oomP1IFU@0XJ6O0?_ko`3no_l0n?Wi0?oon`3mnoX0ookm0?on
o`3imoP00P3oo_l02P35a/P0NGYl01dN800V9bT0L71`0<g=c@3jn?L0ookm0?onn`3oo_d20?ooo`03
0?knoP3moOd0oooo0080oooo00@0no_k0?ooo`3no_h0n_[j0P3oool01@3hn?P0oooo0?ooo`0i>CT0
/[:b0080oooo0P3moOd00`3oool0oOgm0?ooo`060?ooo`0D0?koo`3lool0n_[o0?olo`3oo?X0oooh
0?Gjl`3nool0o_ko0?koo`3PhN40TiF?04Q7@P080P00D4U<09BCV@3`l?H0no[m0?gmo@3no_h20?oo
o`0<0?gmo@3oool0nOWi02LW9`3Fe]H0OGem069RHP2BTY80Hf=S092@T03Shn<0n_[j1@3oool0103n
o_h0oooo0?[jnP3moOd30?ooo`030?gmo@3oool0no_k00<0oooo00<0n_[j0?ooo`3no_h00`3oool0
4`3emOD0oooo0?ooo`3moOd0o?cl0<g=c@2@T900o_kn0?ooo`3gmoL0gmoO0?KfmP3kno/0oooo0>CT
i0030`<0000001<C4`2k^k/00`3oool04`3hn_L0o?ok0?con`3knoT0mO?d069MG`3Sg^00ooko0?ck
oP3nool0o?oo0?[on@3looP0o_om0?[jnP0k=SP081/M0?OemP3ooO`00P3oo_l01P3jn_X0o_kn0?oo
o`3jn_X0oooo0?gmo@@0oooo00P0ooko0?[io03oool0nOWi0?ooo`1kNg/000000;jn_P<0oooo00<0
n?Sh0?ooo`3gmoL00P3oool00`3bl_80oooo0?ooo`0d0?ooo`00H03oool40?koo`@0oooo00T0ooom
0?[jn03moOT0oook0?ckm`3ooo/0fm[F02<S7`3hn?H00P3nool0103jno/0oooo0?ooo`3no_h50?oo
o`D0ooko00<0oooo0?cmm`3ooo/00P3oo_l03P0l>TD05A@I0?oon`3]k^@04A8<0>_[j@3lnol0moKl
0?ooo`3moO/0ookm0?ojnP3mno`0oogn0P3oo_l30?koo`090<o@dP1mOWh09BHV01lO7@1[JfT0_kfl
0?kln`3oool0oOgm00<0oooo00D0moOg0?[jnP3oool0oOgm0?clo0020?ooo`060?gmo@3no_h0oooo
0=_Kf`0C4a<0oOgm0P3oool0103kno/0oooo0?ooo`3moOd70?ooo`0E0?koo`3kool0moOm0?oko`3o
nod0no_^0?com03ioOh0mOOo07ajS@19B5D0loW]0?gok`3jlNX0ZYnQ05mOI`072a@0?Sm308V9R@3M
gMd0nOWi0080oooo00H0moOg0?ooo`13@d<0]kNg02DU9@32`/820?ooo`070=oOg`2QXJ40JVYZ0820
P03EeMD0oooo0?Win@020?ooo`040?gmo@3oool0oooo0?[jnP80oooo00H0o_kn0?ooo`3oool0no_k
0?ooo`3jn_X20?ooo`060?clo03kno/0oooo0?Shn03oool0o_kn0P3oool0103Shn<0KVi^0?ooo`3m
oOd30?ooo`0P0>7Qh@3oool0n?Sh00h>3P051@D0FUYJ0??cl`3oool0n?Sh0?[jnP3oool0oOgm0?_i
n03ooO`0g]kL069TH@3]kn`0noon0?Cem`3nool0ooko0?_inP3oooX0o?_d0?oon`3Lg=X03Pl?020Q
8@14A4@0noWj0?omoP3oo_l20?ooo`080?KfmP3oool0nOWi0?ooo`3jn_X0oooo0?knoP3hn?P40?oo
o`0709NGU`0E5AD08b<S01LG5`3Ti>@0oooo0?knoP020?ooo`050?_kn`3oool0oooo0?ooo`3inOT0
=@3oool00600oooo103nool40?ooo`0<0?ooo@3hn?H0oook0?oon`3lnoL0oook0<c;a`0820@0iNGU
0?_lo03nool0nocl0P3oool00`3lo?`0oooo0?ooo`030?ooo`D0ooko0140oooo0?oonP3ooo/0n_Wl
0?ono`2GUIh010<809jNVP2][ZH0>CXd0?ooo@3oo_l0]kJl0=?Cd`3oood0n_Ge0?omo@020?ono`03
0?CcmP3oo_l0o_oo0080nocn0P3nool02P3loOd0f=SH08R8QP0b<S0051@B06a/K02k^k/0o?cl0?oo
o`3inOT20?ooo`0:0?clo03oool0oooo0?[jnP3no_h0j>SX06YZJP3oool0QHF5065QH@80oooo00@0
no_k0?ooo`3oool0o_kn2@3oool09`3ko?h0ooko0?olo`3ooOd0oOob0?komP3lool0n?Oo0?;]o`1U
Hg00nOoj0?_om03oo?T0oo_o0?ShoP3en?l0];Fg06MWI`0I6AT0:RXZ07=cL`38b<P0oooo0?Win@1Q
HF40PH6102@T903oool0n_[j0?ooo`3kno/0o?cl0?ooo`3Rh^80Zj^[06UYJ@20P800emOG0?[jnP02
0?ooo`060?_kn`3no_h0oooo0?_kn`3oool0no_k1`3oool02P3moOd0oooo0?ooo`3lo?`0oooo0?[j
nP3no_h0[Zj^0<S8b03moOd20?ooo`090=gMg@0C4a<03`l?01TI6@0F5QH00`<309^KV`3lo?`0oOgm
00D0oooo01D0ooko0;Vg^01oOgd0oOoj0?Sln@3lood0o_oo0?kmo`3mn_l0ooko0?kmn03mo?D0_Kbe
020P701cM7@0>c`n05QHF01@CTl0noWj0?ono`3moOd00P3oool01@3inOT0oooo0?knoP3oool0n?Sh
00@0oooo00P0o?cl07YjNP0V9RH0gMgM05YJFP1LG5`08b<S0>GUi@80o_kn00D0n_[j0?ooo`3kno/0
oooo0?knoP0f0?ooo`00H03oool40?koo`@0oooo00`0o_kl0?ooo@3no_`0oOgk0?oon`3oo_X0b/W5
09NGT`3UiND0nocl0?koo`3ko?`20?ooo`030?clo03oool0oooo00<0oooo103oo_l0103oool0n?Sf
0?knnP3knoL20?ono`0@0<2na`0000@010@006=TG02@TH/0WinM01PG700000@0l>ob0?ooo`3ooOd0
o_Wi0?omo03oo_d0oooo0?Win@<0o_oo00<0n?Wk0?Kgn@3nool00P3nool0203jno/0h>3P08:2PP0g
=cL061PH05iNGP31`L40lo?c0P3lo?`0303inOT0o?cl0?ooo`3inOT0n_[j00D51@3kno/0<S8b0<[:
bP3jn_X0oooo0?_kn`80oooo00<0n_[j0?ooo`3oool01P3oool04@3oo_l0oogm0?oin@3jn_P0o?om
0?Sin@3loOl0o_ko0?olo`3om?X0IUmR0=KRh03aool0o_ko0?olo`3oo_l0o_kl0080o_kn00T0oooo
0=3@d01fMWH08b<S01XJ6P1VIVH0J6QX02l_;`1mOGd0103oool20?clo080oooo00L0nOWi0?7al@2]
[Jd0Jf][06m_K`35aLD0oooo0080o_kn0P3oool00`3inOT0oooo0?knoP020?ooo`030?_kn`3lo?`0
oooo00<0oooo00/0o?cl0?ooo`3moOd0o_kn0<g=c@2XZ:P0oooo0?clo03jn_X0C4a<00L71`030000
00030:>SX`3lo?`0oooo0080oooo01L0o?cl0?[jnP3inOT0ooko08^<T02OWZ<0moOe0?oonP3ooo/0
n_Sg0?omo`3nnol0ooko0?koo`3hn_@0[:nT01LH3P2_/:P0j^SY014>503hmoX0?Cdm06EUI@020?oo
o`060?Win@3oool0oooo0?_kn`3oool0oOgm0P3oool03@3kno/0o?cl0?KfmP1GEeL0=SHf0>c/k03o
ool0Q8B407emO@2<S8`09BDU0>WYj@3no_h00`3oool00`3no_h0oooo0?knoP0e0?ooo`00H03oool4
0?koo`@0oooo0P3oood01`3no_`0moOe0?oon`3ooo/0o_gi0?ooo@3hn?P00P3nool0103jno/0oooo
0?ooo`3no_h50?ooo`@0ooko01T0o?cl0?ooo@3ooo/0ooom0?[io03oo_l0g]gS00l>4`092@D00@80
00`<200:2PP01`H90:n^/`3noOl0o_cm0?omo@3on_X0SXb;00T71P0e=CD0[Zj^0?Sin`3nool0oOko
00@0o_oo00/0nocl0?koo`3ko?`0oooo0?knoP3Ogml0TI6A03@d=00G5aL0GEeM0;Rh^0030?ooo`06
0?_kn`3oool06ATI0;jn_P0L71`0n?Sh1@3oool00`3jn_X0oooo0?ooo`060?ooo`0E0?onn`3om_00
ookf0?3hn03gool0ooko0?[fo`3fm_l0n_Om0?okmP2^YJ00YJfh0?;oo`3bmol0no_o0?onn`3oooP0
ookm0?ooo`3inOT0oOgm0080oooo00T0g=cL08b<S00h>3P01@D50>3Ph03moOd0oooo0?clo03kno/0
0P3oool03@3no_h0n?Sh0?ooo`3oool0oOgm0?ooo`3lo?`0_[jn075aL@1OGel0`L710?_kn`3hn?P0
0`3oool0203no_h0oooo0?knoP3no_h0oooo0?knoP3oool0nOWi0`3oool01`3no_h0oooo061PH03e
mOD0oooo0=KFeP0820P00P0000000`061PH00@4104Y:BP020?ooo`030?clo03oool0oooo0080oooo
01P0JV]]0<[=e03lool0oOgk0?olm@3ooOX0oogk0?ceo03oo?l0ooko0?Gin01nQGh05A`B0=_Od03o
ooH0ooco00/5303ln_d0oOgm03`l?01RHV80nOWi0?ooo`3lo?`20?ooo`080?Ogm`3kno/0oooo0?gm
o@3oool0lo?c03/k>`1IFET20?_kn`0:0?ooo`2EUID0HV9R0?_kn`25QHD0;bl_0?3`l03moOd0m?Cd
0?ooo`80o?cl=P3oool00600oooo103nool40?ooo`80no_k0P3oood01@3mnoX0ookm0?ono@3fm_@0
oooo0080o_oo00D0o?gm0?ooo`3oool0oooo0?gmo@040?ooo`@0ooko0P3oood03P3hn?H0ooom0?gl
o`3in?d0g=_P00L62@0000000P8000/:1P010000YZBW0?ono`3ooOl0ooko0P3ooOd02P3mnoX0Xj6P
0=SHf03UiND0oooo0?clo03in_`0o_oo0?cmo`3fmoT20?coo`050?[no`3nool0o_kn0?ooo`3no_h0
0P3oool0303Vi^H0T92@03Xj>P061PH0GemO0:VYZ@3no_h0no_k03Ti>@1LG5`0MGEe0?gmo@@0oooo
0`3no_h70?ooo`0B0?onn03on^P0h=S;00033P0Z>D`0_[K300L0102_/[T0o?oo0?omk03ai^00Jff4
0>cfo`3eool0nOoo0?olm@3oo?@0ookj0P3oool02P3inOT0o_kn0?ooo`3inOT0oooo08^;R`0@4100
n_[j0?ooo`3jn_X30?ooo`030?Win@3oool0oOgm0080oooo00@0no_k0?knoP3oool0moOg0P3oool0
1`31`L40LG5a06][J`2`/;00mOGe0?ooo`3lo?`00P3oool00`3moOd0oooo0?ooo`020?ooo`0/0?Og
m`3oool0oooo0?_kn`3jn_X0l?3`071`L03oool0k>c/00@4100000001@D5000000020P80J6QX0?oo
o`3jn_X0oooo0?Gem@3oool0lO7a05EEE@3TiNT0loOo0?_oo`3lo?P0ookf0?okmP3oo?/0oo_o0?ol
o`3loOl0BDm=03Do>P3[m>`0m?_[0?gml@3oo?l09adV0=;@d`3nool0n?Wi0;bm_@3Lg=`30?ooo`0H
0?clo03oool0oooo0?Shn03oool0emOG02HV9P1bLW80o?cl0?ooo`3no_h0oooo0;no_`0o?cl0oooo
0?knoP1gMgL0;Rh^0?Gem@3no_h0oooo0?knoP3oool0o?cl=@3oool00600oooo103nool60?ooo`08
0?gmn`3oood0ookm0?ono@3mnoX0ooom0?knoP3loOd20?koo`80oOgm1P3oool40?ono`080?_kn@3o
ood0o_kl0?Ogm`3lnoh0ooko0=[IgP0@3a820041000700L60P1ACdh0ooko0?gkoP3oo_l0oogo0?on
o`020?ono@070?gknP2ATI40h>3P0?Win@3oool0o_oo0?Gfn0020?koo`050?_oo`3lool0nOgn0?co
o`3no_h00P3oool00`3no_h0oOgm0?ooo`020?ooo`0:0>_[j`2GUiL0@d=300d=3@1ADE40>SXj01@D
503AdM40oooo0?gmo@80o_kn00@0oooo0?[jnP3oool0o_kn1`3oool04P3oo_H0oo[R09nIR@18E6P0
koSo02HF800J2P/0[;>k0?3ko@3ooo40^k:[00/97`3/kol0mooo0?Soo`3lno@0ooof0?oon`80o_kn
0P3oool02`3kno/0oooo0?ooo`1=CDd03Ph>0?ooo`3lo?`0o_kn0?ooo`3no_h0oOgm00<0oooo0P3l
o?`20?ooo`0=0?_kn`3oool0oOgm0?ooo`3kno/0oooo0?gmo@3>c/h0OWin06ATI02OWil0k>c/0?oo
o`020?gmo@060?clo03oool0oooo0?ooo`3jn_X0oOgm0P3oool01P3lo?`0`L7108f=S@2IVIT07alO
00H61P800@4100<000000>WYj@3oool00`3oool07@3EeMD0IFEU0?Ogm`3mo_l0o?ko0?Sko`3ooo/0
oogd0?onmP3omo@0ooco0>WSj`0a<S80FUiM0?;hn03ho_X0o_oc0?ool`3onoh0ASi70;^j_@3in_X0
o_oo0?cmo@3moOd0o?cl0?ooo`3no_h0oOgm00<0oooo00<0a<C401@D502MWId00`3oool01P3no_h0
o?cl0>GUi@11@D40oooo0?gmo@80oooo00<0no_k0?ooo`3oool00P3lo?`f0?ooo`00H03oool40?ko
o`P0oooo0`3oo_l20?ooo`<0o_oo203oool40?ono`80ooom01H0o?cl0?kmo`3oo_l0n_Wn0>3OhP0:
2PX01@<400@20@0o?SX0oOch0?ono@3clO80m>oc0?klo`3oo_l0oooo0?knoP3oool0oOgm06YZJP3d
m?@0oooo103nool40?coo`P0oooo00X0oOgm0?ooo`3oool0i>CT0:>SX`0K6a/00@4104];B`2LW9`0
j^[Z0P3oool00`3kno/0oooo0?ooo`030?ooo`80oOgm0P3oool04`3moOd0oooh0?ooj@39a[/02@lW
0?Sho`3fgmT04P000=3Lj03`ool0o?oo0?onn`3onol0oo[o0?kmo`3lo_l0o?ok0?con03nood00P3n
o_h30?ooo`060?_kn`3fm_H030`<00D51@3gmoL0nOWi0`3oool00`3no_h0oooo0?ooo`0>0?ooo`09
0?Win@3MgMd0SHf=05iNGP2FUYH0i^KV0?ooo`3no_h0no_k0080oooo00`0oOgm0?knoP3oool0o_kn
0=oOg`0J6QX0U9BD0?[jnP2ATI406ATI04m?C`3Shn<20?ooo`0W0?knoP3oool0];Bd08:2PP3oool0
nOWi0?ono`3onol0ooco0?cjn@3oooP0o_oe0?gnn03BdM@07ahS081nO@3oo_d0o__o0?ono`25QGP0
2P`0030`<02ZZ[00nooo0?coo`3jo_l0o?oo0?[ko@3nool0o?cl0?gmo@3oo_l0oO_l0?clnP2][J/0
4Q8@0;Zj^03nood0n_ci04D0oooo001P0?ooo`@0o_oo203oool30?ono`80oooo0`3nool80?ooo`<0
ooko00<0ookm0?oon`3moO/00`3oo_l04`3mo?l0`<3000l?3`0100002`T:0>SVi@3ooo/0VIRD05YH
E`2PVil0FeQN0>GTi`3mo?l0nOSk0=oOg`3moOd0OGem0;Jf]P3oool0103nool40?coo`T0oooo0140
o?cl0?knoP3oool0o_kn03`l?00d=3@0ZJVY05MGE`0<30`0?Cdm092@T03WinL0n_[j0?ooo`3kno/0
o_kn0?gmo@020?ooo`0G0?gmo@3oool0oooo0?kon@3ooo40l?7Y010@9P3Rf^d0ooOW07]ZF023Sid0
k_oo0?Woo`3oool0oogj0?olo03on_l0ooco0?_oo`3iooX0o_om0?ooo`3no_h00`3oool02@3moOd0
no_k0?_kn`0Y:BT0g=cL0?ooo`3kno/0oooo0?Win@0B0?ooo`080?clo03kno/0oooo0>GUi@2CTi<0
JVYZ08:2PP3Shn<20?[jnP80oooo00H0no_k0>c/k00I6AT0T92@07UiN@3Ti>@20?ooo`080?clo03n
o_h0oooo0?ooo`3inOT0TI6A0:NWY`3moOd20?ooo`0G0?omo`3onol0ooco0?ono@3loOD0noke0;Ni
/`0F5aL0YJFU0?oon03oo_/0oo_o0?kho`3ooo@0XJ>E0=cNf`3Xjnl0nooo0?[oo`3gno`0o?oo0?ko
o`3in_`00P3oool20?ono`0608V9Q`0I6AL0dM7?0?ooo@3gnOH0o_omA@3oool00600oooo103nool8
0?ooo`<0ooko0P3oool30?koo`P0oooo0`3oo_l01@3oo_d0o?ch0?clnP3oo_l0no[o0080ooko0180
ZJNV00H40`0610L0NgUl0?okn`3oo_/0RhN408^6QP3ooOl0g]_R00T:3P3ko?l0n__o0;o0`P0_<380
5QLI0>[ZjP3moOd20?ooo`@0o_oo0P3lool;0?ooo`0Q0?knoP3oool03Ph>03Ph>03kno/0oooo0?Wi
n@2d];@0IfMW00P8200_;bl0QhN70=cLg03oool0oOgm0?[jnP3lo?`0oooo0?clo03jn_X0ooom0?Gg
lP3oood0]k>m03<Z;@3ooNP0Uhim03HnD03Ymol0noko0?ono`3moo80oood0080ooWo00<0nooo0?So
n`3lood0203oool01`0n?Sh0/[:b0?ooo`3moOd0no_k0?ooo`3no_h0403oool0103kno/0oooo0?kn
oP3kno/20?ooo`0@0?Ogm`3^k^h0YJFU06EUI@1nOWh0fMWI0?_kn`3oool0U9BD0:b/[03inOT0oooo
05QHF03^k^h0oOgm0?_kn`80oooo02@0m?Cd06i^KP3>c/h0oooo0?knoP3oool0o?cl0?kmo`3oo?l0
n?Gl0?gknP3oooP0V9N@01@C3P3>c</0ookj0?oom03gm_40oo_o0?kio`3oo_L0no_^08n?S@3If]`0
nooo0?Ooo`3kool0o?oo0?[ko@3nool0oooo0?Shn03elo@0IVAU03@b<@3[jNP20?ooo@030?_mnP3l
o_/0oooo04@0oooo001P0?ooo`@0o_oo203oool30?ono`80oooo0`3nool80?ooo`<0ooko01L0ookm
0?knnP3ooo/0ooko0?cko`3oo_l0o_kn09BBT@0200004@lB0?ono`3km_P0oo_h0=gIe@0B3P/0lngd
0?omo`1iNGl0RHbA0?coo`3ko?l0loCh0?;cm@040?ooo`H0o_oo2@3oool04`3inOT0oooo0?knoP2]
[Jd0=3@d02LW9`3oool0o?cl0?ooo`3jn_X0m_Kf0?ooo`31`L40JVYZ01TI6@0Z:RX0O7al0=3@d03j
n_X00P3oool04`3no_h0oooo0?koo`3no_h0oOSj0;bd/@1VH4h0HF5D00002`3WkOl0ooco0?ono`3k
oo<0o?oc0?oko`3on_l0o?oo0?Woo`3nool00`3oool00`3no_h0oooo0?ooo`020?ooo`030?gmo@3o
ool0nOWi00<0oooo00<0o?cl0?ooo`3oool03P3oool01@3no_h0oooo0?ooo`3oool0o_kn00<0oooo
01<0o?cl0?gmo@3]kNd0Z:RX075aL@1`L700/K6a0?clo03oool0moOg0?ooo`19BDT0inOW0?ooo`3h
n?P0eMGE05MGE`3Xj>P0oOgm0080oooo01L0oOgm0?clo03mo?l0o_ko0?koo`3oo_d0J6AP02dW903V
h=d0oOWf0?Sgl03oonl0oooh0?gko`3knOl0oOgk0?oom03onoP0KVa_0>gcl`3iool0nooo0>oem@02
0?koo`060?clo03clo<0B4I705=ADP3[jNP0o_ck0P3oood00`3moo`0o_om0?ooo`140?ooo`00H03o
ool40?koo`80oooo2P3oo_l0103oool0o_oo0?koo`3nool80?ooo`<0ooko01T0ookm0?oonP3noo/0
o?_o0?omo`3mo?l0n?Sh05ACC`010000W9ZM0?Sen`3ooOl0ookk0?omm`0O6AL0h]_R0?olo`2VZK00
ADU@0?Wmo`3lool0nOco0?koo`3no_h0oooo00@0ooom00@0oooo0?koo`3nool0o_oo203oool0203k
no/0o_kn0?[jnP3lo?`0Hf=S08n?S`000000oOgm0`3oool07P3moOd0lo?c0?ooo`3hn?P0o_kn0<[:
bP1cLg<0:b/[02HV9P1QHF40aLG50?ooo`3kno/0o_cm0?Wgn03ooOl0oogl0?Gjl`3jooT0EEMD0:j/
[`3on_l0ooco0?Soo@3hooP0oooh0?omn`3oo_l0o_oo0?kmo`<0oooo0P3no_h20?ooo`030?clo03f
m_H0oooo00<0oooo00<0nOWi0?ooo`3oool04`3oool0103lo?`0oooo0?ooo`3jn_X30?ooo`0Y0<71
`@3hn?P0oOgm0:^[Z`1lO7`0Kfm_0;bl_03`l?00o_kn06][J`1eMGD0GemO03<c<`3lo?`0oooo0?_k
n`3Hf=P0DU9B0?Shn03oool0o_oo0?KkoP3[ko00@d=304m9B@3omO@0oo[i09:9Q0030@00O81W0:F]
X00001T0g]om0?koo`3HeL`0oocj08EnP@2b][L0nOoo0?CjnP3kool00P3nool0103Ph>00<Bl`06aZ
J`3jn?T20?ono@040?Wim`3hn?H0o_ok0?Wkn4D0oooo001P0?ooo`@0o_oo0P3oool:0?ono`040?oo
o`3nool0o_oo0?koo`P0oooo0`3oo_l04`3oood0o_oi0?[lm`3mo?l0oogo0?Ofn`3oool03`h:00@3
003lnOl0oogo0?oko@3oo_/0nOC^07A^J`0O61l0m?3j08N9T`1AF6000P3kool0103ko_l0m_[k0?on
o`3jn_X40?ooo@80oooo0P3nool;0?ooo`070?Win@0>3Ph0j^[Z01DE5@3Vi^H0oooo0?KfmP020?oo
o`030?knoP3moOd0oooo00<0oooo01@0l_;b0=CDe02?Shl0:BTY01PH601QHF40/k6b0?omo`3nnOT0
no_k0?Woo`3iood0I6=L05A>B`3onoh0oogo0?Soo`3hood0ooof0?onn080oogo00<0o_go0?ooo`3o
ool00P3oool30?knoP<0oooo00@0m?Cd0?Shn03oool0nOWi4P3oool01@3jn_X0oOgm0?ooo`3oool0
n_[j00<0oooo00<0m_Kf07MgM`27QhL00`3oool03P3jn_X0oooo0<G5a@2<S8`0L71`07AdM01ZJVX0
P8200?gmo@3oool0n?Sh0?knoP3/k>`0410@0P3oool06`3hnOT0h^KU028V9@1aKg00o?Gh0?ofn03o
o?X0Ee180<2n[@3MhL@000<005EFM035aNT0moOm0<G4_@0d;2X03PL:0>__l03`nO/0nOoo0?_oo`3g
no`0d=7C01XH6@2>S8d0ooko0?_inP020?ono@80ooom0P3noo]50?ooo`00H03oool40?koo`80oooo
2P3oo_l0103oool0o_oo0?koo`3nool80?ooo`<0ooko01D0ooom0?oonP3noo/0ooko0?omo`3oo_l0
no_k0040001_KVX0ooco0?ggo`3oo?h0ookk0?okl`3AblP01004061LIP000P/0_lO?0?3go`3ioOl0
0P3lool00`3oo_l0oooo0?ono@030?ono@@0ooom2@3oool04@3hn?P0nOWi0:ZZZP13@d<0n?Sh0?oo
o`3jn_X0no_k0?ooo`3kno/0o?cl0?ooo`3jn_X0oooo0?Ogm`3moOd0no_k0080oooo00h0nOWi0?oo
o`3Ogml0TY:B03ll@P0;2@`0GeeL0:NYY03[lNl0kO?a0;>a/02SWi`0ookg0?oon080o?oo00@0oooj
0?onn@3ooOl0ooko203oool0103no_h0o?cl0?clo03oool20?clo0030?ooo`3moOd0oooo00l0oooo
00@0o_kn0?ooo`3oool0oOgm0P3oool01P3no_h0mOGe0?clo01KFe/0@D510>g]k@80oooo00H0nOWi
0?ooo`3oool0o_kn0?clo03inOT20?ooo`0<0?clo03oool0nOWi0?ooo`3moOd0oooo00h>3P3bl_80
o?cl0<O7a`0E5A<0TY:@0P3oo_l05P3jmOL0ookk06ATF02?T7`0oooT09ZJS@0;1BL0o_Oo0?_go`3o
ooX0ookk0?[jn03kool0n?oo0?CloP3fnoh0]k^l01@E5`2]Zj`0ooko0?klo@3oo_l20?ono@040?oo
n`3fm_80oOoj0?gonTD0oooo001P0?ooo`@0o_oo0P3oool:0?ono`040?ooo`3nool0o_oo0?koo`P0
oooo0`3oo_l02@3oood0o_ok0?cnn`3oo_l0o?[o0?ono`2o_kl00@000?Sgl`020?olo`080?omo`3o
o_/0oocf0??]jP0S7240l^kh0?cno`3eo?l20?_oo`040?coo`3nool0oooo0?gmo@@0ookm0`3oood<
0?ooo`040:BTY03>c/h0oooo0?[jnP80oooo00<0oOgm0?ooo`3no_h00P3oool00`3jn_X0oooo0?[j
nP020?ooo`040?gmo@3oool0oooo0?_kn`80ooko0140iNCW09NGU@1@DTd00PH304]?CP2RX:40k^c[
0?oom@3oooH0ooom0?ooo`3ooo/0ookj0?ono@3oo_l0oooo0?koo`020?ooo`80o_oo0P3oool00`3o
o_l0o_kn0?ooo`040?ooo`030?knoP3oool0oooo00h0oooo00@0o?cl0?ooo`3oool0o_kn103oool0
0`2b/[80D51@0?Cdm0020?ooo`070?[jnP3oool0o_kn0?knoP3oool0oOgm0?ooo`030?knoP0F0?cl
o03oool0oooo07UiN@2HV9P08B4Q0=?Cd`2VYZH04a<C0;Rf]@3oo_d0o_cm0?knoP3oool0o?ch0;fn
]00m?R`0oooU0?gjk`0C2RL0gMGh0?olo`80oOgk00L0o_oo0?[oo`3do?`0nooo09ZMX@0@4A<0b<S8
0080ookm00P0ooko0?[io03oo_l0o_ck0?CdlP3oood0o_oo0?gnoTD0oooo00200?ooo`030?koo@3n
ool0ooko0080ooko00<0oooo0?ono@3oo_d00`3ooOl0303oo?`0oogm0?3ZjP0P6A`0`;[10?cjo`3m
oOl0o_ko0?_ko`3mo_l0ooko0?knoPD0ooom903oool02`3oo_l0o_go0?ooo`3oood0j^_[0:^[Z`1B
D54040h=0450?02DThl0iN?R0080ookm00L0oogl0?ono@3oool0nOgn0?coo`3oo_l0no[m0080o?oo
00P0nOWg0?ono@3oo?`0ookm0?koo@3moo`0o_cm0?ono`80o_oo00<0oooo0?knoP3no_h01@3oool0
0`3jn_X0oooo0?knoP020?ooo`80oOgm00@0o_kn0?clo03oool0oooo0P3moOd0203oool0o?cl0?oo
o`3Jf]X0oooo0?Win@3oool0o?cl0P3oool00`3kno/0oooo0?ooo`060?ooo`0E0?knoP3kno/0m_Kf
03hn?P0L71`0UiNG01hN7P3Cdm<0o_oo0?koo@3jno/0o_kl0?ooo@3kn_H0o_gf061ME02ETXL0oogi
059>F02KUjD0o_go0080o_oo00l0n?_o0?Sln`3lool0LG9f02HW:`3Ogmd0oOcg0?onn03nn_H0ooko
0?[ko`3mnoh0ooko0:j^[02c];@00P3lool00`3nool0oooo0?ooo`120?ooo`00P03oool20?koo`@0
oooo0P3oo_l03`3ooOl0n??e0?omo`3jmOL0oo_n0=gFf@2VWj80a;o30?olo`3mnol0noWo0?ono`3i
n?d0o_kn0?ooo`050?ooo@80oooo0P3oo_lP0?ooo`80o_oo0P3no_h20?ooo`0D0?kln`3knOP0/[2_
05aJF@0I5aH0;R`[08F3PP3OgM`0ookm0?knoP3ioOh0o?oo0?omo`3oo_l0o?oo0??im`3oood0oo_k
0?omo@3oood20?coo@80oogo00<0oooo0?koo`3oool00P3oool0103no_h0oOgm0?gmo@3no_h30?oo
o`030?knoP3kno/0oOgm00D0oooo00D0n_[j0?ooo`3oool0iNGU0?[jnP020?ooo`060?[jnP3oool0
oooo0?knoP3oool0mOGe2@3oool02P3no_h0oooo0?knoP3Shn<03`l?04a<C03]kNd0oOkn0?Sin@3f
n_T20?koo@0M0?_jmP3noOT0ookj0?onnP2?RhP0LVi[01LE5P1BDE@0no[o0?clo`3ko_l0o?oo0??g
mP1BE540?ci30>cZk@3ooo/0n?G^0?onm03oo_L0noko0?cno`3Xi^T0X9^K08V5PP0];Bd0e][U0?Cj
o`3nool0A03oool00800oooo0P3nool40?ooo`<0ooko00X0noWj0?omo`3ooOl0V96D0=WBe@3onoh0
ooco0<g9d`2BT9/0oogo0P3noOl00`3moOd0oooo0?clnP040?ooo@80oooo0P3oo_lP0?ooo`030?kn
oP3oool0oooo00<0oooo0P3ooO`04P3mnoX0ookm0?Oem038a/D0JFUY01DE5@0X:2P0Ng]k0<W=c03n
ool0noWj0?ono`3cmoH0nooo0?clo03knOX0ooko0?gmo@80n_km00@0oocn0?omo`3oool0o_oo103o
ool00`3no_h0oOgm0?ooo`020?ooo`0C0?Win@3oool0oooo0?knoP3lo?`0no_k0?Win@3kno/0oooo
0?_kn`3oool0c/k>07AdM03oool0o_kn0?ooo`3moOd0o?cl0?ooo`020?clo0X0oooo00L0o_kn0?gm
o@3oool0o_kn06e]K@0:2PX0alO70080o_oo0200o?oo0?koo@3lo_/0oook0?gln03oo_/0ooci0?om
nP3ln?D0nOOh00400`3Yj>d0o_ko0?coo`3VjNh0=S`l05YNG@3dl_D0noKh0?onn`3oooH0ooc^0?oo
n03dn_l0n?_o0?omo`1?B400fmC<06ITH`3GgNT0n?oo0?cood@0oooo00200?ooo`80o_oo103oool2
0?ono`0:0?[hn@3oo_l0n_Gg0?ghnP3bjnh0>c@g0?ohn`3mn?`0:bLa0>OUkP80ooko00@0m_Gj0?on
o`3moOd0o?cj103oood20?ooo`80ooko8@3oool00`3no_h0no_k0?clo0020?ooo`060?ono@3ooO`0
ookm0?ono@3no?/0o?cl0P3oool05039bLT0M7Ee02<T900O7al0LVe_0<:m_`3ioO`0nooo0?ooo`3o
o_l0nOOj0?knoP3kool0o?oo0?omo`3oo?l0oooo0?gnoP3moOd0o_kn1@3oool00`3no_h0oooo0?_k
n`020?ooo`0=0?gmo@3no_h0o_kn0?ooo`3moOd0oooo0?_kn`2k^k/05ADE0<g=c@3oool0o?cl0?[j
nP020?ooo`050?gmo@3oool0oooo0?Win@3lo?`02@3oool02`3inOT0oooo0?ooo`2YZJT0?3`l01lO
7`3XjNT0n?Wi0?Gin03nood0l_Ca0080oook01/0oOWf0?onn`3oo_/0oogm0??alP0P8200][Fj0?Kg
n`3PhnP07R4V07IlO03fn_T0ooko0?omo`3onoP0o_Wa0?ook@3oo_L0lOko0?;lo`3ooOd0n^_S08=i
K@2:QX<0_LCB0?Ooo`3lool0A03oool008H0oooo0`3oo_l03`3jn?T0oogo0?omo`3ooOl0Yj:T09ZE
U`2GTYH0[:V`0?omo`3kn_l0m??h0?glo`3oo_l0oOgm0?ooo`040?ooo@80oooo0P3oo_lP0?ooo`03
0?clo03oool0oooo00<0oooo00<0o_kn0?ooo`3fm_H00P3oool05P3ko?h0o_oo0?koo`3in_`0o_oo
0?ooo@3=blX0R8:203@_<@0G6aX0GVAT0;Ff^03em?L0ooko0?gno`3eno/0o?oo0?omo`3mm_T0noWh
0?ooo@3moOd20?knoP060?gmo@3no_h0oooo0?ooo`3kno/0oOgm0P3oool02P3gmoL0o_kn0?ooo`3l
o?`0no_k0?ooo`3moOd0i^KV00l?3`38b<P20?ooo`090?_kn`3oool0no_k0?ooo`3lo?`0oooo0??c
l`25QHD0oOgm00X0oooo02L0n_[j0?ooo`35aLD0<30`07]kN`0f=cL0o?gm0?coo`3lo_/0o_om0?gk
nP3hm_D0ookk0?okn03km_H0oo_k0>7Oh02MWId0_;_00<[;c`0<3a@0WJ2U0?_oo`3lool0n?Oj0?on
o`3no_X0ookd0?ofi`2QV9<000XM0<?Ll03hko00ooW_0?ogk00R71T0GFIe0?;oo`3kool0A03oool0
08H0oooo0`3oo_l0203no?d0oOSj0?omo`3gl_@0oogo02dX:P14@TD0o__o103oo_l00`3noOl0oooo
0?clo0040?ooo@80oooo0P3oo_lS0?ooo`030?knoP3kno/0o?cl00<0oooo00@0o?cl0?koo`3nool0
nocn0P3nool04@3moOd0ookm0?onn`3on_/0oo_k0=KJf@2<TY80@T=7014@5@1EE5T0ZJZ^0?3en03l
ool0oo[l0?olo`3oo_d0no_i00<0oooo00P0o?cl0?gmo@3oool0oooo0?knoP3jn_X0oooo0?knoP80
oooo00d0no_k0?knoP3oool0m_Kf0?ooo`2ZZZX0emOG0?ooo`3inOT0o_kn0?ooo`3no_h0oooo0080
no_k00@0oooo0;>c/`16ATH0o_kn203oool05`3kno/0nOWi0?ooo`3no_h0i^KV01XJ6P3no_h0De=C
069SH`3lool0n?[g0?clnP3jn_P0ookm0?onn`3oo?T0oogm0?ono@3oo_l0oooo0:VXZ`0>3a<0^KVo
00<0o?oo00l0oOco0?ono`3lnoL0ookf0?okk@2j/J`0?55T09fcb03oo?d0oo7V0?ogj`3oo?T0Hfai
0>gjo`3kool0A03oool008P0oooo00<0oogn0?klo@3ln_/00`3oo_l0203XhnD0jNOZ0?kko`3jnOl0
o_go0?ono`3lnoh0nOSk0P3oool20?ooo@@0oooo0P3oo_lP0?ooo`040?gknP3no?/0ookm0?ono@80
oooo00<0o_oo0?_loP3in_`00P3nool05P3in_`0o?go0?gno`3ko?h0oooo0?kjm`3ooOX0oock0?om
o@3lool0m_cl0>obmP3[jo40UiNM0495B@0=5AL0@TQ80:^VZ03]i^T0oocl0?ono@3jn_X30?ooo`03
0?knoP3oool0oooo00<0oooo00T0n?Sh0?ooo`3no_h0no_k0?ooo`3hn?P0oooo0?Shn03fm_H00`3o
ool01@3no_h0n_[j0?_kn`3oool0n_[j0080oooo00<0FUYJ096AT@3oool0203oool02P3moOd0oooo
0?ooo`3lo?`0oooo030`<03clo<0m?Cd02h_;`2:Rh/20?ooo`0M0;fm^`30`;h0moGd0?ono@3gmO@0
ookm0?omoP1oOgl092<V0=;Ce@3loOl0o?oo0?_oo`3gnoX0o?[m0?olo`3ooOd0o?Oa0?ool@3Yj^80
20dN0>oao`3ooOl0oogd0?omlP3in?@0mO_o0?Soo`3lool0A03oool008P0oooo00P0oogn0?ono`3o
o_l0oogn0?klo@3imoP0oogo0?cjo@<0ooko00<0n_Wl0?ono`3oo_l00P3moOd20?ooo@@0oooo0P3o
o_lP0?ooo`@0ookm0P3lo?`30?koo`80o?go0`3nool0503mo_l0o_kn0?onn`3onoP0]Zb[00h8203O
hn80nooo0?coo`3knol0o_ko0?_no`3UkNl0Z:j^04]6BP0D3A00AD1009VGUP3]kNd0n?Sh0P3oool0
3P3no_h0oooo0?ooo`3no_h0no_k0?ooo`3moOd0oooo0?Win@3oool0m?Cd09JFUP3oool0oOgm0P3o
ool00`3kno/0o?cl0?ooo`020?ooo`070?_kn`3oool0oooo0?gmo@0@4100j>SX0?clo00:0?ooo`0<
0?[jnP3kno/0oooo0?ooo`3inOT0oooo0=_Lg00J6a/0^KVi0?clo02RXZ00FUYH0`3oo_d0603elo80
IfMW03De=@3Og^40ooko0?koo`3mo_l0nOgj0?coo@3oo_l0ooWo0?olo03oo_X0nocb0?oonP0W8bd0
b/KD0?cjo@3noOT0oOkh0?koo@3dn?l0nooo0?kood@0oooo002:0?ooo`/0ooko6`3oool00`3jn_X0
oooo0?ooo`030?ooo`80o_kn203oool40?ono@80oooo0`3nool03P3mo_l0n__m0?koo`3kno/0o_kn
0?[jnP3oool0o_gi0?onn`3om_L0HeeM0?3dl`3kool0noko0P3no_l02`3lool0m_ko0?Klo03ooOl0
mo3c0:jYZ@1MFeX04a<C03Ph>029RHT0f][J0080oooo00D0no_k0?ooo`3moOd0oooo0?[jnP020?oo
o`060>o_k`15ADD0SXj>0?clo03oool0n?Sh0P3oool02`3no_h0oooo0?ooo`3hn?P0oooo0?knoP3o
ool0`l?302h^;P3oool0o_kn0100oooo00h0o_oo0<;3``0E5AD0fm_K0;bl_014A4@0o?[i0?ono@3g
mOH0@d5204a<C03hn?P0lO3c0?ono`80o_oo0140oook0?ooo@3lool0o?oo0?koo`3oood0oogm0?om
n`2DT8d0MWAe0?ono`3hn?h0o?oo0?_oo`3lool0oOko0?ono`140?ooo`00RP3oool:0?onoad0oooo
00H0o?cl0?knoP3inOT0nOWi0?ooo`3moOd90?ooo`@0ookm0P3oool20?koo`030?_loP3mo_l0oOko
0080oooo0P3oo_d0603ln_T0ooom0?ono@3ooOd0ViJH0;Nk_03kool0nOco0?koo`3inOl0o?oo0?Wo
o`3kool0oogo0?olo`3oo_d0ooom0?Cdm02m_Kd0JFUY018B4P0a<C40Ng]k0=;BdP@0oooo00@0mOGe
0?_kn`0e=CD0J6QX103oool02`3kno/0oooo0?[jnP3oool0no_k0?ooo`3hn?P0no_k0?ooo`1aLG40
QHF50180oooo0240nO[j0?gnoP2KVi/0:BTY0=WIf@0I6AT0ookm0>3Ng@0Z:2T0L6i_0?clo03no_h0
ooko0?kmo`3hnO/0o_kl0?oonP3ooo/0o?oo0?_oo`3lool0o_oo0?omo`3ooOd0i=O>01T>203alOT0
n?oo0?Goo`3foOl0oooo0?ono@3oo_l0A03oool00;00oooo00<0oOgm0?Ogm`3oool00P3oool00`3l
o?`0oooo0?Win@080?ooo`@0ookm00<0oooo0?koo`3nool00`3nool0:@3oool0moOg0?cjn@3oo_/0
oo_h0?Gdl03loOd0n?Wi0?ojo03Ng=l0Jg5a0?Gmo@3nool0n_Wl0?ono`3mo_l0n?kn0?coo`3onod0
oOKi0?Wgn03lo?`0oooo0?_kn`3lo?`0oooo0<K6aP1bLW80820P01lO7`1eMGD0b/[:0?Shn03oool0
_Kfm07alO03oool0n_[j0?ooo`3fm_H0no_k00<0oooo00<0oOgm0?ooo`3moOd00`3oool00`0H61P0
f][J0?gmo@0D0?ooo`0:06ATI011@D402@T90=cLg00L71`0Shn?0?ooo`3inOT0oooo0?Shn080oooo
00<0oOgk0?oonP3ooo/00P3no_l03@3oo_l0o_oo0?Goo`3lool0on_Q03XM5`3Nh>X0jOco0?3oo`3c
ool0oo_h0?oln@3ooOd0A03oool00;80oooo00D0moOg0?ooo`3oool000000?knoP090?ooo`<0ookm
00<0oooo0?koo`3nool00P3nool04P3loOl0moOg0?ooo`3oo_d0o?Se0?omnP2JU940510=0<c@d@3j
ool0ooko0?cko`1DFUX0lo_k0?koo`3ooOh0o?[k0?knoP80o?oo0P3ooOl00`3oool0o_oo0?ooo`02
0?ooo`0<0?KfmP3jn_X0oooo0?Win@3AdM40N7Qh02XZ:P0K6a/0KFe]0:2PX03oool0n_[j103oool0
3@3hn?P0no_k0?_kn`3oool0oOgm0?ooo`2?Shl0IVIV0=CDe00L71`0oOgm0?knoP3kno/0403oool0
303moOd0n_[j0?_kn`3oool0A4A400P8201HF5P0[Jf]0?knoP3jn_X0oooo0?knoP80oooo00@0n_[j
0?ooo@3oooP0oook0P3no_l03@3oo_l0o_oo0?Coo`3lool0oo7W03<D3`2OXJ/0k_oo0?3oo`3dool0
o?Se0?omn03ooOd0A03oool00900oooo103ooodL0?ooo`070?Shn03oool0o_kn0?ooo`3hn?P00000
0?knoP090?ooo`80ookm0P3oool40?koo`0?0?knoP3oool0n_Sg0?oln@3ooOX0oocg0;F/Y@19AD40
/KJi0?Ooo`3gn_l0d];H01LO8@36c<`0no_k0080oogm02@0ookm0?coo@3ho?/0oOSj0?oloP3nool0
n_ko0?cmo@3kno/0oooo0?knoP3kno/0n?Sh0?ooo`3no_h0oooo0<g=c@3Jf]X0S8b<03Lg=`0;2`/0
HF5Q0;6a/@3^k^h0oooo0?_kn`3oool0oOgm0?clo03oool0o_kn0?KfmP2d];@0De=C08F5Q@1_KflE
0?ooo`060?clo03oool0lO7a00/;2`1VIVH0oOgm0P3oool02P3hn?P0o?cl0?clo03no_h0ooom0?Sh
m03oooX0oook0?kno`3lool20?koo`0;0?coo`3oo_l0jmO>0;NSWP2[[KL0lOgo0?Coo`3hool0oook
0?ggm03oo_d0A03oool00900oooo103ooodP0?ooo`030?[jnP071`L0oOgm00T0oooo0P3oo_d20?oo
o`@0o_oo01/0o_kn0?ono@3oo_/0ooci0?gel03ooOH0mncT014;203]m?P0m_oo0?_oo`3ko_l0mooo
0?Cjn03no_`0ookk0?omn`3ooOX0o?kk0?koo@3ooOl0ooko0?coo`3jo_l0o?gm0?ooo`3emOD0103o
ool03@3moOd0YjNW05=CD`3kno/0oooo0?_kn`3Shn<0WYjN03hn?P0?3`l0F5QH09nOW`3Zj^X00`3o
ool00`3lo?`0oooo0<_;b`0202l_;`040<71`@3inOT0oOgm0?gmoA00oooo00T0nOWi0?clo03no_h0
o_kn0?clo01?Cdl01PH60<[:bP3jn_X00P3oool02P3no_h0oooo0?clo03oood0oook0?oonP3ooo/0
o_ko0?coo`3nool20?ono`0:0?olo`3onoH0oo_j0?kno`3hool0l__n0?Woo`3lo?X0oook0?onod@0
oooo002<0?ooo`@0o_oo103ooodL0?ooo`80o_kn00H0n?Sh0?ooo`3oool000000?ooo`3lo?`80?oo
o`80ookm0P3oool40?koo`0?0?ooo`3mnoX0oo_h0?omnP3ooOH0oo_c0?ojlP0/9R<0_LO<0?Coo`3d
n_l0nooo0?;ko@3iool0ookm0080oogk00D0ookj0?kon`3nood0oo_m0?[hn@020?_oo`0<0?cmo@3o
ool0oooo0>o_k`3oool0o_kn0?clo02>SXh06ATI0>_[j`3oool0m_Kf0P3oool04@3moOd0oooo0>WY
j@2PX:00E5AD00@4101<C4`0TI6A0>7Qh@3oool0o_kn0?7al@071`L04A4A0?_kn`3oool0no_k0140
oooo0P3oo_l02P3oool0l?3`0?ono`24PhH0F5UK01LH6P3XjNT0oOkn0?KfmP3oool20?ooo@050?_i
n03lo?P0oooj0?ooo@3nool00`3oo_l02P3oool0ooko0?oko@3onOd0o?_o0?_oo`3dn_X0n?kj0?ko
o`3jn_Y50?ooo`00S03oool40?koo`@0ooom703oool01`3no_h0oooo0?knoP3oool0o?cl00D51@3l
o?`02@3oool20?ooo@80oooo103nool0503no_h0ookm0?onn`3nnO<0ookf0?oil03ooO<0U92<07Am
PP3cool0nOoo0?Wmo`3iool0nooo0?ono@3oo_/0oogk0?onn`3no_X0oOol0P3oo_l0103lool0nOgn
0?koo`3emOD20?ooo`060?_kn`3moOd0h^;R02LW9`3UiND0no_k0P3oool00`3jn_X0oooo0?knoP02
0?ooo`0;0?clo03oool0lo?c0:ZZZP1NGUh03@d=03`l?02=SHd0i>CT00h>3P1ADE400P3no_h00`3o
ool0o?cl0?ooo`0?0?ooo`0:0?ono`3gmOH0oooo0?ooo`3jnO`0VIRK05aMG`2c];H0LG9b0?cmo@80
oooo00H0oOgk0?ooo@3oo_d0ooom0?oon`3nood40?ono`060?ooo@3oo_l0ooco0?ojo`3oo_l0nOgn
0P3lood00`3jno/0o_oo0?ooo`140?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@4100X0oooo
00@0ooom0?koo@3nool0o_oo1@3oo_l04@3ooO`0oo_h0?oon03ooOD0ookd0?oikP3MfMD03`lG0?Sj
o`3kn_l0o_ko0?gmo`3nool0n_[j0?ono@3ooO`0ookm0080ooom00@0oooo0=;BdP2WZ:X0o_oo0P3o
ool01P3lo?`0oooo0?ooo`3kno/0clo?0>k^kPT0oooo00d0o?cl0?ooo`3oool0no_k0?ooo`3alO40
^KVi06ATI00k>c/03@d=08^;R`3moOd0o_kn01D0oooo00D0no_k0?ooo`2n_[h0A4A40?clo0080?oo
o`040?ooo@3oool0ooko0?ono`@0oooo0`3oo_l30?koodL0oooo002a0?ooo`050?knoP3oool0oooo
0?knoP010@402P3oool20?koo@80o_oo1@3oo_l02@3oo_d0ookk0?onnP3lnO00oogb0?onm03jm_80
8QlV0=gKj0020?omo`040?glo`3oo_l0ooko0?knoP80ooom00H0moOe0?clnP3oool0k>c/01@C5P3i
n?/20?ooo`030?_kn`3gmoL0o?cl0080oooo00<0oOgm0?ooo`3oool01`3oool0103jn_X0oooo0?oo
o`3jn_X20?ooo`090?_kn`3moOd0moOg00410@2QXJ40oooo0?gmo@3oool0o?cl0100oooo00L0o_kn
0?gmo@3oool0oooo0?knoP3kno/0eMGE05h0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40
2P3oool20?koo@80o_oo103oo_l04P3ooOh0ookm0?onn`3oo_X0ooce0?oomP3ooo@0lno[01lL8`2O
WJX0o_co0?omo`3mo?l0o_go0?ono`3oool0ooom0?clnP80ooom00P0oooo0?_kn`0^;C00`;o20?[j
nP3inOT0kno_05mOG`80oooo00<0moOg0?ooo`3oool0203oool01@3lo?`0o_kn0?ooo`3kno/0nOWi
00<0oooo00L0YJFU024Q8@2:RXX0o?cl0?ooo`3hn?P0o_kn0100oooo00D0o_kn0?ooo`3oool0o_kn
0?clo0020?ooo`030?clo03oool0oooo05/0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40
2P3oool20?koo@80o_oo1@3oo_l03`3no?d0oOSh0?onn`3oo_X0oooh0?gjl@3Ui=l0XYnV0<;0b`3l
n_l0oOco0?ono`3noOl0o_kn0?gmo@020?[jn00>0?ooo@3jn_P0n_[j0?ooo`1lNgh0NGQk0?ooo`3H
f=P0:2PX09jNWP3oool0o_kn0?ooo`3lo?`80?ooo`040?gmo@3oool0o_kn0?knoP<0oooo00P0n_[j
0?_kn`1PH600EEEE06UYJ@3oool0nOWi0?_kna40oooo00L0oOgm0?ooo`3oool0o?cl0?ooo`3jn_X0
nOWi05h0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@402P3oool30?koo@030?koo`3oo_l0
ooko00@0ooko00P0oogn0?ono@3ooOX0ooch0?onnP3jnOD0oogo0?glo`<0ooko00<0oOgm0?knoP3o
ood0103oood02@3oool0no[m0<?2a@0d<cH0kNg]01`L702IVIT0o_kn0?_kn`0;0?ooo`040?[jnP3o
ool0oooo0?clo0@0oooo00H0o?cl01<C4`2EUID0DU9B0?ooo`3kno/C0?ooo`030?knoP3oool0oooo
00<0oooo00<0o_kn0?ooo`3oool0F`3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn00410@0:0?oo
o`@0o_om00D0oooo0?ono`3oo_l0ooko0?gkoP030?ono`0;0?omo@3onoP0ookk0?ono@3gm_T0ooko
0?cko`3oo_l0oooo0?knoP3no_`00P3oood0103emO<0ooom0?ooo`3lnoh20?ono`0300/:3@25QHD0
^[Zj00<0oooo00<0n_[j0?knoP3kno/02`3oool02P3moOd0o_kn0?_kn`3jn_X0o_kn0<G5a@1:BTX0
iNGU075aL@3dm?@20?ooo`030?clo03oool0oooo00h0oooo00D0o_kn0?ooo`3jn_X0oooo0?_kn`02
0?ooo`030?Win@3oool0oooo05/0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@402P3oool4
0?koo@80oooo0P3oo_l00`3mo?l0ooko0?cjo@020?ono`060?kln`3ooO`0oO_l0?ooo`3oo_l0n_Wl
0P3oool20?ooo@060?_kn@3no_`0ooom0?ooo`3lo?`0moKi0P3oo_l0201CDUD06ATI0::RXP3kno/0
oooo0?knoP3oool0o_kn2P3oool20?_kn`D0oooo00<0IVIV08R8R03no_h00`3oool00`3gmoL0oooo
0?ooo`0?0?ooo`030?[jnP3oool0nOWi0080oooo00<0no_k0?ooo`3oool0G@3oool00;40oooo00D0
o_kn0?ooo`3oool0o_kn00410@0:0?ooo`@0o_om0P3oool40?ono`0;0?klo`3oo_l0ooko0?gko03o
oOh0ooko0?clo03oool0oOgm0?ooo`3no_`00P3lo?X30?ooo@090?knoP3oool0ooko09fLW`3noOl0
V9NJ04a<C00H61P0YjNW0080oooo00<0no_k0?ooo`3kno/0203oool01@3no_h0oOgm0?ooo`3no_h0
no_k0080oOgm00D0nOWi00l?3`3WinL0oooo0?knoP020?ooo`030?knoP3oool0oooo0100oooo00@0
nOWi0?ooo`3oool0oOgm0P3oool00`3lo?`0oooo0?ooo`1K0?ooo`00/@3oool01@3no_h0oooo0?oo
o`3no_h00@4100X0oooo0P3nood20?ooo@80oooo2@3oo_l20?ooo`L0ooom01L0o_kl0?ooo@3oool0
mOGe079aM01CDUD0ooko0=oNh@0G5aL0e]KF01LG5`2IVIT0oooo0?knoP3jn_X0oooo0?[jnP3oool0
o_kn0?ooo`3jn_X0oooo0?[jnP020?ooo`040?[jnP3oool0oooo0?Gem@80oooo00@0[Jf]0451@@3o
ool0oOgm0`3oool00`3hn?P0oooo0?ooo`1d0?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@41
00X0oooo0P3nood20?ooo@80oooo2@3oo_l20?ooo`P0ooom00l0nOWg0?knoP1PH600?3/n0>o^l@3n
oOl0ooko02DU9@37alL0iNGU01dM7@2GUiL0no_k0?ooo`3inOT00P3oool01P3moOd0o?cl0?ooo`3n
o_h0oooo0?clo0<0oooo00P0o?cl0?ooo`3moOd0o?cl09RHV02m_Kd0oooo0?Win@80o_kn0P3oool0
0`3lo?`0oooo0?ooo`1c0?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@4101@0oooo1@3oo_l2
0?ooo`D0ooom103oool00`3Lg=`0C4a<0?Win@020?ooo`0?0?clo02RXZ80/;2`0?clo03Ph>0092@T
06MWI`3fm_H0oooo0?clo03moOd0oooo0?Ogm`3hn?P0o?cl0080oooo00<0o?cl0?ooo`3gmoL00P3o
ool00`3no_h0nOWi0?ooo`020?ooo`060?gmo@3no_h0oooo0?gmo@3oool0oOgmM@3oool00;40oooo
00D0o_kn0?ooo`3oool0o_kn00410@0E0?ooo`@0ooko0P3oool40?ooo@<0oooo00L0oOgm0?_kn`3n
o_h0o?cl0?ooo`3hn?P0n_[j0080oooo00X0oOgm0?[jnP3oool0jn_[06ATI00O7al0d=3@0?ooo`3l
o?`0no_k0`3oool00`3hn?P0oooo0?ooo`020?ooo`0<0?clo03kno/0oooo0?ooo`3hn?P0o?cl0?kn
oP3oool0oOgm0?ooo`3kno/0o?clMP3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn00410@0@0?oo
o`D0o_om1@3nool50?ooo`<0ooko00D0o_go0?ono`3oool0oooo0?Ogm`020?ooo`050?_kn`3lo?`0
o_kn0?ooo`3lo?`00P3oool01@2SXj<061PH09BDU03hn?P0oooo0080o?cl00@0no_k0?ooo`3oool0
o?cl0P3moOd20?ooo`070?Shn03no_h0oooo0?[jnP3oool0o?cl0?gmo@020?ooo`030?knoP3oool0
oooo07@0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40403oool60?koo@@0o_oo103oool5
0?ono`040?Ofn@3oool0nOWi0?knoP@0oooo00X0nOWi0?[jnP3oool0o?cl0?gmo@3no_h0f=SH034a
<@1LG5`0g=cL0`3oool02P3gmoL0oOgm0?gmo@3oool0XZ:R0<k>cP3oool0kno_06UYJ@3hn?P20?oo
o`060?Shn03oool0o?cl0?knoP3oool0oOgmM@3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn0041
0@0:0?ooo`80ooko103oool90?koo@030?koo`3oool0ooko00P0ooko00@0o?cl0?ooo`3oool0oooo
0P3oood05`3oool0n_[j0?ooo`3jn_X0o?cl0?ooo`3moOd0oooo0?knoP1dM7@04a<C06a/K03Zj^X0
oOgm0?ooo`3lo?`0oooo0?clo02n_[h0:b/[0?gmo@29RHT0IVIV0080oooo00L0no_k0?gmo@3oool0
no_k0?clo03oool0oOgm07D0oooo002P0?ooo`80ooko00L0oooo0?koo@3nood0o_om0?ono`3ooOl0
ooko0080oooo0P3nood01@3oood0ooko0?ono`3oool0o_kn0080oooo00<0o_kn00410@3oool02@3o
ool20?ono`@0oooo2@3nood00`3nool0ooko0?ono`020?ono`@0oooo01l0oOco0?kmo`3oo_l0o?cl
0?glo`3oool0n_[j0?ooo`3lo?`0oooo0?Whn`3oool0o?ch0?gnn03ooo/0nOWi0?cmo`3nool0j>KY
075_LP0B4aD0P8610?Gem@3no_`0n_[j0?ooo`3kno/0:BTY0<71`@0b<S80_kno00<0o_kn00D0oooo
0?_kn`3oool0oooo0?gmo@1f0?ooo`00W`3oool04`3oo_l0oogo0?omo`3nool0o?ok0?_on03loo/0
ooco0?oko`3lnOl0oooo0?Sjm`3io_P0o?oh0?konP3oo?l0oo_o0?ono`3no_h00P3oool00`3no_h0
0@410?ooo`0I0?ooo`80oogo0P3oo_l07@3oood0oook0?kon`3nood0o_oo0?Wjo03ko?h0o_oo0?_l
o`3nool0o?_n0?knoP3no?d0ooko0?_ko`3nool0o_ka0?gnk03oooH0o_om0?Wmo`3lo_l0ooco0?oi
o`3HgN40DEUI01XJ602=S8P0iNGS0080oooo00@0UYJF03dm?@0P8200nOWiOP3oool009l0oooo01<0
ooko0?omo`3ooOl0o_oo0?_on`3iooP0nook0?olo`3onol0ooco0?ooo`3nood0o?ok0?_om`3dm_00
ooco0?oko`3oo_l0o_kn0080oooo00<0o_kn00410@3oool0603oool02@3oo_l0oogo0?omo`3oo_l0
ookm0?oon`3oooX0o_oj0?kon`040?koo`0L0?Oho03oo_l0ooko0?ono`3ooOd0nOOh0?_no`3lool0
nOW]0>_/fP0;3080@DE202T`>03alol0o_So0?olo`3kool0nOoo0<g=c@1PGUd03`l?04Y:BP2TY:@0
kno_010@403?cll0oooo0?gmoGd0oooo002P0?ooo`80ooko0100o_oo0?coo`3kood0o?om0?ono`3o
oOl0ookm0?Wim`3gn?P0o?oo0?coo@3nood0ooko0?oko@3oo_l0o_kn0P3oool00`3no_h00@410?oo
o`0H0?ooo`050?ono`3ooOl0oogo0?ono`3oood00P3ooo/08P3noo/0o_om0?gnoP3nool0oOco0?on
o`3mo?l0ooko0?ono@3lnoL0lNgY09bJV@2KWZD0YJR_0?ono`3oooX0gnCM09nUX@3Xj_@0o?co0?ck
oP3oood0nOgl0?coo`3oo_l0oOco0?[io02MWId0C4a<00l?3`0h>3P0LG5a0?ooo`3lo?am0?ooo`00
X03oool00`3oo_l0oooo0?koo`020?coo`030?koo`3oo_l0oogo0080ookm0P3nool01P3ho?T0o_om
0?ono`3oo_l0oooo0?knoP80oooo00<0o_kn00410@3oool06@3oool20?ono`050?ooo`3oood0ooom
0?oon`3nood00`3nool05@3kn_d0ooko0?ono`3ooO`0ookj0?oon`3ooOd0hn7R010A5@3EeM/0oogo
0?glo`3gnoP0f]kM08j>UP3inOl0o_oo0?_mnP3gn?X0o_oo0?Sio@020?ono`060?gmo@3oool0h^;R
096AT@0D51@0k^k^OP3oool00:00oooo00l0oogo0?ono`3noo/0o?oj0?con`3nood0ooko0?omo`3l
m_d0ooko0?gonP3hoOH0o_oj0?kon`3mnoh00P3oo_l01@3no_h0oooo0?ooo`3no_h00@4101d0oooo
0`3oood20?ooo`@0ooko01D0oocl0?chm@3oooP0oogm0?_go`3nn_l0L6aY0:2OV`3moOl0o?oo0?on
o`3oool0a<O<09FHW@3mo_h0o_oo0?_ko`3no_l0o_om0?kon`3emO<00P3oool0103^k^h0m_Kf055A
D@2FUYIn0?ooo`00W`3oool30?ono`0@0?oon03oooH0oooh0?oon`3nool0o_ko0?omo`3oo_l0oooj
0?oom03oooH0oook0?Sio@3no_l0ooko0?knoP80oooo00<0o_kn00410@3oool06`3oool40?ooo@03
0?ooo`3oo_l0o_go0080ooko01`0oO_l0?omnP3oo_X0ooge0=[Ee@0000h09R4a08f5PP1VHE/0mOco
0?Woo`3[i^P0noKf0>O/l00k@TP0moSl0?Ofn`3mnol0o_ko0?gon@3ko_D0ooom0?knoP3kno/05ADE
0>KViP30`<009bLWOP3oool009l0oooo01<0o_oo0?Woo`3lool0ooof0?oml`3onoH0oocj0?_oo`3g
ool0nOoo0?ShoP3oooP0oogb0?kcj`3ooO/0nooo0?Soo`3lool0o_kn0080oooo00<0o_kn00410@3o
ool06@3oool40?ooo@80oooo0P3oo_l0803ooOl0ooco0?ojoP3nnO/0oogk0?onn03on>h0^kNd00T8
603onol0:Q/N01P@3P3Rk_P0mOoo0?omnP1XGU`0004908VBW`3ooOl0ooco0?kno`3jo_l0o_oj0?oo
n03oood0no_k0;Fe]@0i>CT0oOgm0?Shn00k>c/0/K6aO@3oool009l0oooo01<0o_oo0?Woo`3kool0
ookh0?olm03onOH0oo_j0?Woo`3eool0mOco0?koo`3mn_<0T8Mn01`>2`0e;B/0Xj^]0?Ooo`3lool0
o_kn0080oooo00<0o_kn00410@3oool06@3oool40?ooo@80oooo0P3oo_l0703ooOl0o__o0?olo`3o
oOl0oogj0?omm@3oo_<0cLW5010?7`3jmOl0n^[[00L00037en@0k_ko0?ogn@3onoX0kOOn0?;oo`3k
n?h0ooco0?Oho03ho?d0o_ok0?kon@3oood0o_kn05IFEP2LW9`20?ooo`030<c<c02UYJD0oooo07`0
oooo002P0?ooo`0B0?koo`3jo?T0o_gi0?omnP3onOX0oock0?Wmo03iool0ooko0?omo`3oo_d0nOSd
0:jUYP3LeMP0iN_[0?Woo`3nool0o_kn0P3oool00`3no_h00@410?ooo`0I0?ooo`@0ooom0P3oool2
0?ono`80oogo01h0oo_o0?omo`3ooOX0ookf0?oikP3hm?004A0N0=KBh03ono@0TXV407^:W`3^o?l0
ooSo0?oio`3gool0m?om0?oon03ooOX0o_ko0?cno`3nool0oook0?gmn`3jn_X0Fe]K0?Cdm03no_h0
o?cl0?ooo`3moOem0?ooo`00X03oool04P3mnoX0ookm0?koo@3oo_d0ooWh0?ohmP3nool0o?gm0?ol
o@3on_/0n__k0?coo`3gmOH0Shf>0>7UiP3fn_/0o_oo0?knoP80oooo00<0o_kn00410@3oool06@3o
ool40?ooo@80oooo0P3oo_l07`3ooOl0ooco0?oko`3oo?h0oogk0?onn03ooO<0oo_g0;Bd_P0F4Q`0
ooC/0;J^[00Q:d80mOko0?ogo`3onol0n?oo0?OonP3ooo@0oooh0?kno`3lool0o_oo0?ooo@3oool0
o_kn0?ooo`3inOT0oooo0?gmo@3emOD0OP3oool009l0oooo01<0ooko0?okoP3ooOl0n_km0?cnn@3o
o_P0oogj0?kmo`3oo?l0o^od0?oko@3ioOh0m_oo0?koo@3hn?H0KVmc0?3am@3oo_l0o_kn0080oooo
00<0o_kn00410@3oool06`3oool40?ooo@0G0?ooo`3oo_l0ooko0?kmo`3ooOl0oogn0?onn`3oo_X0
ookf0?onnP3oo_l0/Jjd06QOH01YHVT0=ca@0>S]o`3onol0oOSh0?_oo`3iool0o_oh0?oon03oood0
0`3nool00`3inOT0oooo0?ooo`220?ooo`00W`3oool04`3oo_l0oogo0?_io03loOd0oook0?ojk`1B
BD@0_ko90?[go`2STi/040@60>KYk@3fo_h0gn3J0?oon`1jOH80][W00?koo`3no_h00P3oool00`3n
o_h00@410?ooo`0L0?ooo`<0ooom0P3oool40?ono`040?olo03oo_/0oooh0?onnP80ooko00H0o_Wm
0?omo`3noOl0n_co0?ooo@3ooo/20?coo`030?kon`3nooX0o_om00<0o_oo00L0oooo0?gmo@3hn?P0
o_kn0?_kn`3moOd0o_kn07h0oooo002O0?ooo`0C0?ono`3nool0o_oo0?ono`3ooOP0ooOY0;>TW@17
BUT0n?ko0:VRZ@1<@D<0_[g20?_jo@3:`KX0=S4[00063P3TkOP0o?oo0?knoP020?ooo`030?knoP01
0@40oooo01T0oooo0P3oo_l01@3oool0ooom0?ooo@3ooo/0o_om00<0o_oo0`3oo_l01@3ooO`0ookj
0?oon`3ooOl0noWl0080o_oo00@0l_3a0?ooo`3loo/0n_kk0P3nool20?koo@<0o_oo00<0ooom0?oo
o`3oool00P3oool00`3jn_X0oOgm0?knoP1n0?ooo`00W`3oool04`3oo_l0moKk0?ono`3oo_l0oOOd
0?okk@3[g=D0000B0=CHk`3VgN005`d<0?cjo`3inOl0ooge0?Sck@3bnOl0n?oo0?coo`3no_h00P3o
ool00`3no_h00@410?ooo`0H0?ooo`050?ono`3ooOl0oogo0?ono`3oood00P3ooo/0103noo/0o_om
0?gnoP3nool40?ono`0<0?ono@3ooo/0ookj0?kmn@3fn_/0nOgn0?oon`3oooX0o?ok0?[oo03lool0
o_oo0P3ooo/20?coo`80oooo00D0n_[j0?ooo`3alO40oooo0?_kn`020?ooo`030?[jnP3oool0oooo
07/0oooo002O0?ooo`030?omo`3onod0noCg0080nooo00h0oooa0?ohl@0K5RX06a4Y0?obm00]6aT0
cmGP0?Coo`3koo/0oooj0?gko`3no?l0ooko0?knoP80oooo00<0o_kn00410@3oool0603oool02`3o
o_l0oogo0?omo`3oo_l0ookm0?oon`3oooX0o_oj0?kon`3mo_h0oOko00<0o_oo0P3oo_l05@3oooX0
ook_0?oom03hnol0n?[o0?ono`3in?@0o_kl0?coo`3iool0o?om0?oomP3ooo@0nooj0?Woo`3ooOl0
ooco0?ono`3jn_X0oooo0?knoP020?ooo`030?Win@3oool0oooo07`0oooo002O0?ooo`0?0?omo@3o
no/0oo[k0?_oo`3iool0n_[]0?onmP1gKh80BSaA0::=RP0]7QT0]Kg80?7oo`3hool0nO_f0080ooco
00H0ooko0?knoP3oool0oooo0?knoP010@4I0?ooo`050?ono`3ooOl0oogo0?ono`3oo_d00P3ooo/2
0?kon`030?koo@3nool0o_oo00<0o_oo00@0ooko0?oon`3ooo40no_^0P3no_l03`3knOX0oook0?oo
o@3jno/0nooo0?coo@3oooH0oood0?_onP3iool0oogo0?olo`3lnol0o_kn0?ooo`020?clo0030?oo
o`3kno/0oooo07d0oooo002O0?ooo`0B0?ono@3ooOX0oo_k0?ono`3mo?l0ookb0=?>a01NFVP0UHjM
0<Fm^0040@00`lWE0?Soo`3enoT0nogh0?ono`3kn_l0oOco0P3oool0103kno/0oooo0000003lo?`2
0?ooo`040?clo03no_h0o_kn0?ooo`80oOgm4@3oool20?ono`80oooo103oood40?ooo`060?ono`3o
ool0oooo0?ooo@3oooX0oook0P3oo_l0103oool0ooom0?ooo`3oool20?koo`80oook00<0o_om0?ko
o`3oo_l00P3oo_n40?ooo`00W`3oool04@3oood0no[f0?ono@3noOl0ooko0?oll@3lmnl0oogo0?Ge
o`3oooX0oook0?_no`3amol0o_oo0?oon`3gn?P0o_oo0080oooo00L0m_Kf0?ooo`3oool000000?oo
o`3inOT0moOg0080oooo00D0nOWi0?_kn`3oool0oooo0?gmo@2e0?ooo`00W`3oool05`3oood0oook
0?ooo@3gn?X0oO_l0?ommP3ooOP0oOgo0?cno`3oo_/0o_ck0?Woo`3eoOl0o_oo0?Sgl`3oool0o_oo
0?gmo@3oool0o_kn0?ooo`3clo<0000000<0oooo00<0m?Cd0?ooo`3oool00`3oool00`3moOd0oooo
0?ooo`2c0?ooo`00X03oool0703no?/0ooom0?koo`3oo_d0oocg0:2HU@35aL/0nOco0?kin`3?cLh0
R8nG0?Soo`3mo_l0ookm0?ooo`3loOl0oooo0?Win@3oool0no_k0?ooo`020P80o?cl0?gmo@3fm_H0
oooo0?KfmP3oool30?clo;H0oooo002Q0?ooo`0K0?[jnP3oool0ookm0?ojn03`j^P0=3<f0?koo`3o
oOl0:2L/0>kbn@3foOl0noco0?Shn03oool0oOgm0?ooo`38b<P0oooo0?Win@3moOd000000?ooo`3l
o?`0nOWi0=cLg03oool0no_k00<0oooo00<0nOWi0?ooo`3oool0/`3oool00:80oooo00X0o_Wi0?om
o@3ooOd0oogm0:bWZ@2GUIP0TiBH0:BW[03lool0noko0P3lool01@3moOd0oooo0?Win@000000B4Q8
0080o_kn00T01@D50?ooo`3`l?00410@06UYJ@3lo?`0oooo0?gmo@3jn_X0]`3oool00:00oooo01d0
o_oo0?ooo`3ooO/0o?Kd0?Kgm`3moOd0oock02hU9P0nADT0m_oo0?ono`3nnol0nOko0?_oo`3oool0
noWh0?ooo`2EUID010@405ADE03no_h000000=OGe`0D51@000000>WYj@3jn_X0oooo0?_kn`020?oo
o`030?gmo@3oool0oooo0;<0oooo002O0?ooo`0P0?koo`3kool0oooo0?ogm@3ooO/0o?oo0?koo`3o
m_D0l^SW0>?/l@3gool0ooko0?oko`3kool0mOgo0?_kn@3oo_/0ookm0?clo00B4Q80000003@d=006
1PH03@d=00H61P1`L700oOgm0?ooo`3kno/0oooo0?gmo@3no_jf0?ooo`00W`3oool00`3nool0o?oo
0?koo`020?omn`0B0?coo`3nool0oo_j0?oln`3hool0mooo0?ono`3ooOl0nooo0?Woo`3oo_d0ookk
0?_in03oool0Vi^K00P8200B4Q8000000P030`<0103`l?00nOWi0?ooo`3oool20?gmoKL0oooo002O
0?ooo`0E0?koo`3lool0o_oo0?omn`3oo_/0o_oo0?ono`3oo?X0oogk0?Woo`3hool0oooo0?ono@3l
ool0nooo0?ono@3oo_/0ookm0?Win@3_knl00`<30080000000@01PH603Xj>P3jn_X0o_kn0P3oool0
0`3no_h0oooo0?ooo`2f0?ooo`00X03oool20?koo`80oook0100oogo0?ono`3oo_X0oook0?kno`3l
o_l0o_oo0?koo@3nool0ooko0?ono@3ooo/0ooom0?clo03oool0@d=30P0000000`092@T0Xj>S0?oo
o`020?ooo`050?knoP3oool0oooo0?ooo`3no_h0]@3oool00:00oooo0P3nool02P3nood0ooom0?ol
o`3ooOl0oooj0?kon`3oo?l0oogo0?coo`3kool20?ono`80oook00X0n_[h0?ooo`3emOD0X:2P00h>
3P010@4020P80??cl`3oool0o_kn0P3moOfi0?ooo`00X03oool20?koo`060?coo@3oood0ooco0?ol
o`3noo/0o?om0P3oo?l0103kool0nOoo0?ono`3ooOl20?oon`080?ooo@3oool0oooo0=GEe@0:2PX0
0`<301TI6@3oool20?gmo@030?knoP3oool0oooo0;P0oooo002P0?ooo`040?koo`3lool0o?oo0?oo
o`80ooco0180o_om0?coo`3oo?l0oogo0?_oo`3iool0ooko0?omo`3oo_/0oook0?ooo@3kno/0oooo
0?Ogm`0:2PX0000005QHF03moOd20?knoP<0oooo00<0o_kn0?gmo@3oool0]@3oool00:00oooo00@0
o_oo0?coo`3lool0oooo0P3ooOl0103oool0o_oo0?omo`3oo_l20?coo`0;0?ono`3ooOl0ookk0?oo
n`3no_`0oooo0?Shn03oool0<S8b0000002NWYh01P3oool20?gmoKH0oooo002P0?ooo`<0o_oo00<0
oooo0?ono`3oo_l00P3oool20?ono`80o_oo00D0oooo0?ono`3oo_d0ookm0?gmo@020?ooo`060?[j
nP1QHF400@410;fm_@3no_h0oooo0P3moOd20?ooo`80o_kn]P3oool00:X0oooo00<0ooko0?ooo`3o
ool0103oool01P3lo?`0o_kn0?clo02=SHd00P820=[Jf[h0oooo002`0?ooo`080?[jnP3oool0oooo
0?ooo`2VYZH000000?ooo`3no_jm0?ooo`00/P3oool0103fm_H0nOWi0=3@d000002o0?ooo`00/03o
ool01@3jn_X0oooo0?ooo`3oool0no_k0<00oooo002b0?ooo`060?knoP3fm_H0oooo0?gmo@3kno/0
oOgm_@3oool00;40oooo00D0no_k0?ooo`3oool0oooo0?clo02o0?ooo`00/@3oool01P3fm_H0oooo
0?ooo`3gmoL0oooo0?Kfm[h0oooo002`0?ooo`040?gmo@3oool0o_kn0?Win@80oooo00<0o?cl0?oo
o`3oool0_03oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool0
0?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00001\
\>"]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q1final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 88.5047 0.143612 0.184632 [
[.20082 .13111 -15 -9 ]
[.20082 .13111 15 0 ]
[.37783 .13111 -15 -9 ]
[.37783 .13111 15 0 ]
[.55484 .13111 -15 -9 ]
[.55484 .13111 15 0 ]
[.73185 .13111 -15 -9 ]
[.73185 .13111 15 0 ]
[.90886 .13111 -12 -9 ]
[.90886 .13111 12 0 ]
[.01131 .0513 -24 -4.5 ]
[.01131 .0513 0 4.5 ]
[.01131 .23593 -18 -4.5 ]
[.01131 .23593 0 4.5 ]
[.01131 .32824 -6 -4.5 ]
[.01131 .32824 0 4.5 ]
[.01131 .42056 -18 -4.5 ]
[.01131 .42056 0 4.5 ]
[.01131 .51288 -6 -4.5 ]
[.01131 .51288 0 4.5 ]
[.01131 .60519 -18 -4.5 ]
[.01131 .60519 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20082 .14361 m
.20082 .14986 L
s
[(0.002)] .20082 .13111 0 1 Mshowa
.37783 .14361 m
.37783 .14986 L
s
[(0.004)] .37783 .13111 0 1 Mshowa
.55484 .14361 m
.55484 .14986 L
s
[(0.006)] .55484 .13111 0 1 Mshowa
.73185 .14361 m
.73185 .14986 L
s
[(0.008)] .73185 .13111 0 1 Mshowa
.90886 .14361 m
.90886 .14986 L
s
[(0.01)] .90886 .13111 0 1 Mshowa
.125 Mabswid
.06806 .14361 m
.06806 .14736 L
s
.11231 .14361 m
.11231 .14736 L
s
.15657 .14361 m
.15657 .14736 L
s
.24507 .14361 m
.24507 .14736 L
s
.28932 .14361 m
.28932 .14736 L
s
.33358 .14361 m
.33358 .14736 L
s
.42208 .14361 m
.42208 .14736 L
s
.46633 .14361 m
.46633 .14736 L
s
.51059 .14361 m
.51059 .14736 L
s
.59909 .14361 m
.59909 .14736 L
s
.64334 .14361 m
.64334 .14736 L
s
.68759 .14361 m
.68759 .14736 L
s
.7761 .14361 m
.7761 .14736 L
s
.82035 .14361 m
.82035 .14736 L
s
.8646 .14361 m
.8646 .14736 L
s
.95311 .14361 m
.95311 .14736 L
s
.99736 .14361 m
.99736 .14736 L
s
.25 Mabswid
0 .14361 m
1 .14361 L
s
.02381 .0513 m
.03006 .0513 L
s
[(-0.5)] .01131 .0513 1 0 Mshowa
.02381 .23593 m
.03006 .23593 L
s
[(0.5)] .01131 .23593 1 0 Mshowa
.02381 .32824 m
.03006 .32824 L
s
[(1)] .01131 .32824 1 0 Mshowa
.02381 .42056 m
.03006 .42056 L
s
[(1.5)] .01131 .42056 1 0 Mshowa
.02381 .51288 m
.03006 .51288 L
s
[(2)] .01131 .51288 1 0 Mshowa
.02381 .60519 m
.03006 .60519 L
s
[(2.5)] .01131 .60519 1 0 Mshowa
.125 Mabswid
.02381 .06976 m
.02756 .06976 L
s
.02381 .08822 m
.02756 .08822 L
s
.02381 .10669 m
.02756 .10669 L
s
.02381 .12515 m
.02756 .12515 L
s
.02381 .16208 m
.02756 .16208 L
s
.02381 .18054 m
.02756 .18054 L
s
.02381 .199 m
.02756 .199 L
s
.02381 .21747 m
.02756 .21747 L
s
.02381 .25439 m
.02756 .25439 L
s
.02381 .27285 m
.02756 .27285 L
s
.02381 .29132 m
.02756 .29132 L
s
.02381 .30978 m
.02756 .30978 L
s
.02381 .34671 m
.02756 .34671 L
s
.02381 .36517 m
.02756 .36517 L
s
.02381 .38363 m
.02756 .38363 L
s
.02381 .4021 m
.02756 .4021 L
s
.02381 .43902 m
.02756 .43902 L
s
.02381 .45749 m
.02756 .45749 L
s
.02381 .47595 m
.02756 .47595 L
s
.02381 .49441 m
.02756 .49441 L
s
.02381 .53134 m
.02756 .53134 L
s
.02381 .5498 m
.02756 .5498 L
s
.02381 .56827 m
.02756 .56827 L
s
.02381 .58673 m
.02756 .58673 L
s
.02381 .03283 m
.02756 .03283 L
s
.02381 .01437 m
.02756 .01437 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .01472 m
.02499 .01472 L
.02605 .01472 L
.02729 .01472 L
.02846 .01472 L
.02954 .01472 L
.03053 .01472 L
.03163 .01472 L
.03279 .01472 L
.03395 .01472 L
.0352 .01472 L
.03638 .01472 L
.03746 .01472 L
.03873 .01472 L
.03944 .01472 L
.04011 .01472 L
.04262 .01472 L
.04521 .01472 L
.04648 .01472 L
.04765 .01472 L
.04872 .01472 L
.04984 .01472 L
.05221 .01472 L
.05343 .01472 L
.05474 .01472 L
.05597 .01472 L
.05709 .01472 L
.05841 .01472 L
.05984 .01472 L
.06244 .01473 L
.06749 .01473 L
.07306 .01474 L
.07586 .01475 L
.07743 .01476 L
.07887 .01476 L
.08433 .01478 L
.08904 .0148 L
.09419 .01484 L
.10458 .01493 L
.10986 .01499 L
.11485 .01505 L
.11933 .01511 L
.12419 .01521 L
.13417 .01543 L
.14514 .01576 L
.15541 .01616 L
.16502 .01664 L
.17581 .01728 L
.18606 .01808 L
.20635 .02011 L
Mistroke
.22488 .02266 L
.24473 .02625 L
.26313 .0307 L
.28369 .03697 L
.30231 .04419 L
.32322 .05451 L
.34243 .06549 L
.38103 .09537 L
.42057 .13616 L
.4586 .18553 L
.47978 .21926 L
.49907 .25666 L
.50867 .27992 L
.51909 .31307 L
.53803 .36669 L
.54746 .38572 L
.55785 .40593 L
.57887 .44287 L
.59825 .47097 L
.60356 .47705 L
.60646 .47999 L
.60915 .4823 L
.61391 .48541 L
.61663 .48683 L
.61782 .48753 L
.61912 .48786 L
.62031 .48821 L
.62159 .48851 L
.62229 .48865 L
.62293 .48867 L
.62419 .48878 L
.62489 .48878 L
.62554 .48877 L
.62625 .48874 L
.627 .48865 L
.62827 .48845 L
.62899 .48835 L
.62967 .48813 L
.632 .48721 L
.63327 .48681 L
.63446 .48617 L
.63574 .48534 L
.63715 .48444 L
.63833 .48346 L
.63962 .48274 L
.64088 .48115 L
.64204 .48027 L
.64315 .47936 L
.64433 .47754 L
.64861 .47218 L
Mistroke
.65097 .46846 L
.65318 .46384 L
.6558 .4584 L
.65707 .45564 L
.65822 .45331 L
.65946 .44829 L
.66063 .44547 L
.66186 .44153 L
.66319 .43551 L
.66384 .43182 L
.66456 .44063 L
.66531 .49421 L
.66601 .50014 L
.66735 .50737 L
.66861 .51608 L
.66981 .52187 L
.6711 .52611 L
.67218 .53107 L
.67338 .53421 L
.67466 .53679 L
.67532 .53824 L
.67603 .53986 L
.67729 .54139 L
.67848 .54327 L
.67965 .54399 L
.68073 .54454 L
.68192 .54509 L
.68319 .54521 L
.68384 .54512 L
.68453 .54497 L
.68579 .54449 L
.68702 .54384 L
.68815 .54237 L
.68922 .5411 L
.69038 .5397 L
.69146 .53765 L
.69246 .53477 L
.69463 .52761 L
.69585 .52357 L
.69701 .51507 L
.69961 .49644 L
.70089 .48635 L
.70206 .47648 L
.70313 .47884 L
.70426 .48113 L
.70663 .48779 L
.71152 .49799 L
.71687 .50698 L
.73528 .53847 L
.74617 .5597 L
Mistroke
.75648 .58381 L
.76097 .59462 L
.76215 .59798 L
.76343 .59963 L
.76461 .60125 L
.76573 .60275 L
.76703 .60323 L
.76821 .60332 L
.76952 .60276 L
.77026 .60194 L
.77095 .60103 L
.77215 .59934 L
.77328 .59763 L
.77459 .5934 L
.77577 .59104 L
.78048 .57828 L
.78488 .56854 L
.78601 .566 L
.78709 .56458 L
.78833 .56355 L
.78946 .56223 L
.79071 .56128 L
.79187 .56082 L
.79314 .5603 L
.79379 .56028 L
.7945 .56023 L
.79516 .56031 L
.79586 .56053 L
.79711 .56087 L
.79781 .56135 L
.79846 .56193 L
.79917 .56228 L
.79994 .56272 L
.8006 .56342 L
.80131 .56427 L
.80261 .56528 L
.80387 .56683 L
.80505 .56755 L
.80621 .56829 L
.8075 .56877 L
.80875 .56871 L
.80945 .56839 L
.8101 .56776 L
.81124 .56682 L
.81249 .56461 L
.81359 .56206 L
.81475 .55984 L
.81539 .55735 L
.81609 .55517 L
.81731 .55157 L
Mistroke
.82008 .54133 L
.82509 .51688 L
.82743 .50603 L
.82872 .49671 L
.82994 .49061 L
.83107 .47876 L
.8323 .46687 L
.83446 .45097 L
.83975 .42294 L
.84536 .39894 L
.84792 .38887 L
.85062 .37709 L
.85292 .36988 L
.85424 .36495 L
.85544 .36337 L
.85665 .36234 L
.85779 .36252 L
.859 .36353 L
.86031 .3667 L
.86145 .37024 L
.86266 .37357 L
.86369 .37852 L
.86483 .38726 L
.86971 .43118 L
.87099 .45307 L
.87172 .45736 L
.87239 .46205 L
.87363 .46946 L
.87494 .47103 L
.87615 .46995 L
.87729 .46615 L
.87854 .46234 L
.87924 .45737 L
.87988 .45149 L
.88092 .44381 L
.88204 .43426 L
.88326 .4148 L
.88439 .39548 L
.88555 .38579 L
.88665 .37747 L
.88764 .36902 L
.8887 .36115 L
.88983 .35673 L
.89087 .35376 L
.89199 .35151 L
.89323 .35005 L
.89799 .35647 L
.89929 .35934 L
.90002 .35992 L
.90068 .36059 L
Mistroke
.90197 .36117 L
.90318 .36073 L
.90434 .3598 L
.90555 .35682 L
.9066 .35467 L
.90773 .35225 L
.90894 .34778 L
.91007 .34309 L
.91264 .33235 L
.91333 .33092 L
.91405 .32888 L
.91484 .3257 L
.91557 .32291 L
.91689 .32002 L
.91764 .31925 L
.91835 .31868 L
.91966 .31986 L
.92085 .32201 L
.92217 .32606 L
.92355 .33207 L
.92473 .33678 L
.92585 .34397 L
.92714 .34836 L
.92831 .35223 L
.92961 .35624 L
.93034 .35753 L
.93101 .35777 L
.93223 .35813 L
.93353 .35751 L
.93584 .35288 L
.93707 .35087 L
.93837 .3473 L
.93962 .34626 L
.94075 .34644 L
.94189 .34939 L
.94297 .35353 L
.94361 .35979 L
.94429 .36351 L
.94551 .38239 L
.94826 .422 L
.9506 .46014 L
.95189 .47692 L
.95311 .4904 L
.95424 .50122 L
.95547 .50153 L
.95659 .49606 L
.95763 .48116 L
.96184 .42681 L
.96291 .40699 L
.96405 .39268 L
Mistroke
.96531 .38853 L
.96649 .38806 L
.96781 .39104 L
.96906 .39565 L
.9703 .40137 L
.97142 .40425 L
.97262 .40697 L
.97389 .40839 L
.97508 .40827 L
.97619 .40762 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`006oooool00ol0003oooooooooo`3oooooo`?ooooo000Kooooo`03o`000?oooooooooo0?oo
oooo0oooool001_ooooo00?o0000ooooooooool0ooooool3ooooo`006oooool00ol0003ooooooooo
o`3oooooo`?ooooo000Kooooob_o0000f_ooool001_ooooo00?o0000ooooooooool0:?ooool9o`00
0=7ooooo000Kooooo`03o`000?oooooooooo037ooooo1Ol0003<ooooo`006oooool00ol0003ooooo
ooooo`0fooooo`Go0000aoooool001_ooooo0_l0000looooo`Co0000`oooool001_ooooo00?o0000
ooooooooool0?oooool3o`000<3ooooo000Kooooo`03o`000?oooooooooo04;ooooo0_l0002noooo
o`002?ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000oooooooo
ool0A?ooool3o`000;_ooooo0007ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000oooooooo
ooooooooo`000004ooooo`03o`000?oooooooooo04Oooooo0_l0002iooooo`001Ol00002ooooo`04
o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool00_ooool2o`0004[ooooo0ol0002foooo
o`001oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool0C?ooool2o`000;Cooooo0007ooooo`04o`000?ooooooooooo`0000Oooooo1?l00005oooo
o`03o`000?oooooooooo04kooooo0_l0002booooo`001oooool01?l0003oooooooooool00007oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0D?ooool2o`000;3ooooo0008ooooo`;o
00002?ooool5o`0000Cooooo00?o0000ooooooooool0D_ooool2o`000:kooooo000Kooooo`;o0000
EOooool00ol0003oooooooooo`2[ooooo`006oooool00ol0003oooooooooo`1Eooooo`03o`000?oo
oooooooo0:[ooooo000Kooooo`03o`000?oooooooooo05Kooooo00?o0000ooooooooool0ZOooool0
01_ooooo00?o0000ooooooooool0Eoooool2o`000:Wooooo000Kooooo`03o`000?oooooooooo05Wo
oooo00?o0000ooooooooool0Y_ooool001_ooooo0_l0001Kooooo`03o`000?oooooooooo0:Gooooo
000Kooooo`03o`000?oooooooooo05_ooooo00?o0000ooooooooool0Y?ooool001_ooooo00?o0000
ooooooooool0G?ooool00ol0003oooooooooo`2Sooooo`006oooool00ol0003oooooooooo`1Loooo
o`03o`000?oooooooooo0:?ooooo000Kooooo`03o`000?oooooooooo01oooooo0_l00004ooooo`03
o`000?oooooooooo00?ooooo0_l00004ooooo`;o00000_ooool5o`0001Cooooo0_l00004ooooo`03
o`000?oooooooooo00?ooooo0_l000001?oooooo0000ooooooooool2o`0000Cooooo0ol0000Doooo
o`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000?ooooo0ol0000Eoooo
o`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000?ooooo0ol0000Hoooo
o`;o00001?ooool00ol0003oooooooooo`03ooooo`;o00000oooool3o`00013ooooo000Kooooo`;o
00007oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Cooooo`04o`000?ooooooooooo`0000So
oooo00Go0000oooooooooooo0000ooooo`02o`0000;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0Booooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool04Oooool01?l0003o
ooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000oooo
ool00003ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo00002?ooool01?l0003o
ooooooooool00003ooooo`03o`000?oooooooooo00oooooo000Kooooo`03o`000?oooooooooo01ko
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000?ooooo00?o0000ooooooooool04oooool01?l0003oooooooooool00008ooooo`04o`00
0?ooooooooooo`0000;ooooo00Go0000oooooooooooo0000ooooo`05o`0001?ooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo
00000oooool00ol0003oooooooooo`0Aooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooo
oooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool0
5?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooo
ooooool03oooool001_ooooo00?o0000ooooooooool07_ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001?ooool00ol0003ooooooooo
o`0Booooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool2o`000004
ooooool0003oooooo`0000;ooooo00?o0000ooooooooool04_ooool01?l0003oooooooooool00008
ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooooooo0000ooooo`04o`0001Cooooo
00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000;ooooo0ol0000Gooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo0000
0oooool00ol0003oooooooooo`0?ooooo`006oooool00ol0003oooooooooo`0Nooooo`04o`000?oo
ooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003ooooo
o`0000?ooooo00?o0000ooooooooool04Oooool01?l0003oooooooooool00008ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000ooooool0003o00000_ooool00ol0003oooooo`00000Dooooo`04
o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0
003oooooo`0001Oooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002oooo
o`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Dooooo`04o`000?oo
ooooooooo`0000Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0?ooooo`00
6oooool00ol0003oooooooooo`0Nooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooo
oooo00000_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool04Ooo
ool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00000oooool2o`0001Cooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003ooooo
ooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool0
0003ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo00002?ooool01?l0003ooooo
ooooool00002ooooo`;o00004Oooool001_ooooo0_l0000Pooooo`;o00002_ooool2o`0000Cooooo
0_l00003ooooo`?o00005Oooool2o`0000[ooooo0_l00004ooooo`;o000000?oooooo`000?ooool0
0_ooool00ol0003oooooooooo`0Cooooo`;o00002_ooool2o`0000Cooooo0_l00004ooooo`;o0000
5Oooool2o`0000[ooooo0_l00004ooooo`;o00000oooool3o`0001Sooooo0_l0000:ooooo`;o0000
1?ooool00ol0003oooooooooo`0?ooooo`006oooool00ol0003oooooooooo`1Tooooo`03o`000?oo
oooooooo09_ooooo000Kooooo`03o`000?oooooooooo06Gooooo00?o0000ooooooooool0V_ooool0
01_ooooo00?o0000ooooooooool0I_ooool00ol0003oooooooooo`2Iooooo`006oooool00ol0003o
ooooooooo`1Vooooo`03o`000?oooooooooo09Wooooo000Doooooooo00003Ol0000001_ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo0_l0
000:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`09ooooo`7o00000Oooool001_ooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0/
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0/
ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool05oooool001_ooooo00?o0000oooo
ooooool0JOooool00ol0003oooooooooo`2Fooooo`006oooool00ol0003oooooooooo`1Zooooo`03
o`000?oooooooooo09Gooooo000Kooooo`;o0000K?ooool00ol0003oooooooooo`2Dooooo`006ooo
ool00ol0003oooooooooo`1/ooooo`03o`000?oooooooooo09?ooooo000Kooooo`03o`000?oooooo
oooo06gooooo00?o0000ooooooooool0T_ooool001_ooooo00?o0000ooooooooool0KOooool00ol0
003oooooooooo`2Booooo`006oooool00ol0003oooooooooo`1^ooooo`03o`000?oooooooooo097o
oooo000Kooooo`;o0000L?ooool00ol0003oooooooooo`2@ooooo`006oooool00ol0003ooooooooo
o`1`ooooo`03o`000?oooooooooo08oooooo000Kooooo`03o`000?oooooooooo073ooooo00?o0000
ooooooooool0Soooool001_ooooo00?o0000ooooooooool0LOooool00ol0003oooooooooo`2>oooo
o`006oooool00ol0003oooooooooo`1booooo`03o`000?oooooooooo08gooooo000Kooooo`;o0000
Loooool00ol0003oooooooooo`2=ooooo`006oooool00ol0003oooooooooo`1cooooo`03o`000?oo
oooooooo08cooooo000Kooooo`03o`000?oooooooooo07Cooooo00?o0000ooooooooool0Roooool0
01_ooooo00?o0000ooooooooool0M?ooool00ol0003oooooooooo`2;ooooo`006oooool00ol0003o
ooooooooo`1eooooo`03o`000?oooooooooo08[ooooo000Kooooo`;o0000Moooool00ol0003ooooo
ooooo`29ooooo`006oooool00ol0003oooooooooo`1fooooo`03o`000?oooooooooo08Wooooo0008
ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`1g
ooooo`03o`000?oooooooooo08Sooooo0007ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000
ooooooooooooooooo`000004ooooo`03o`000?oooooooooo07Oooooo00?o0000ooooooooool0R?oo
ool000Oooooo00Co0000oooooooooooo00002oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo07Sooooo00?o0000ooooooooool0Qoooool000Oooooo00Co0000oooooooooooo00002ooo
ool00ol0003oooooooooo`02ooooo`;o0000NOooool00ol0003oooooooooo`27ooooo`001oooool0
1?l0003oooooooooool00007ooooo`Co00001Oooool00ol0003oooooooooo`1iooooo`03o`000?oo
oooooooo08Kooooo0007ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo08Kooooo0008ooooo`;o00002?ooool5
o`0000Cooooo00?o0000ooooooooool0N_ooool00ol0003oooooooooo`25ooooo`006oooool2o`00
07_ooooo00?o0000ooooooooool0QOooool001_ooooo00?o0000ooooooooool0Noooool00ol0003o
ooooooooo`24ooooo`006oooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo08Cooooo
000Kooooo`03o`000?oooooooooo07cooooo00?o0000ooooooooool0Poooool001_ooooo00?o0000
ooooooooool0O?ooool00ol0003oooooooooo`23ooooo`006oooool2o`0007kooooo00?o0000oooo
ooooool0P_ooool001_ooooo00?o0000ooooooooool0OOooool00ol0003oooooooooo`22ooooo`00
6oooool00ol0003oooooooooo`1nooooo`03o`000?oooooooooo087ooooo000Kooooo`03o`000?oo
oooooooo07kooooo00?o0000ooooooooool0POooool001_ooooo00?o0000ooooooooool0Ooooool0
0ol0003oooooooooo`20ooooo`006oooool2o`00083ooooo00?o0000ooooooooool0P?ooool001_o
oooo00?o0000ooooooooool0Ooooool00ol0003oooooooooo`20ooooo`006oooool00ol0003ooooo
ooooo`20ooooo`03o`000?oooooooooo07oooooo000Kooooo`03o`000?oooooooooo083ooooo00?o
0000ooooooooool0Ooooool001_ooooo00?o0000ooooooooool0P?ooool00ol0003oooooooooo`1o
ooooo`006oooool2o`0008;ooooo00?o0000ooooooooool0O_ooool001_ooooo00?o0000oooooooo
ool0POooool00ol0003oooooooooo`1nooooo`006oooool00ol0003oooooooooo`21ooooo`03o`00
0?oooooooooo07kooooo000Cooooo`?o00001Oooool00ol0003oooooooooo`22ooooo`03o`000?oo
oooooooo06Gooooo0_l0000Fooooo`005?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo08;ooooo00?o0000ooooooooool0IOooool00ol0003oooooo`00000Eooooo`005?ooool00ol0
003oooooooooo`04ooooo`;o0000Poooool00ol0003oooooooooo`1Uooooo`03o`000?oooooo0000
01Gooooo000Dooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0Poooool00ol0003o
ooooooooo`1Sooooo`04o`000?ooooooooooo`0001Gooooo000Dooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0Poooool00ol0003oooooooooo`1Sooooo`04o`000?ooooooooooo`00
01Gooooo000Cooooo`;o00001_ooool00ol0003oooooooooo`23ooooo`03o`000?oooooooooo06?o
oooo00Co0000oooooooooooo00005Oooool001Cooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`24ooooo`03o`000?oooooooooo06;ooooo00Go0000ooooooooooooooooo`00000Doooo
o`006oooool2o`0008Gooooo00?o0000ooooooooool0HOooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00;o00004?ooool001_ooooo00?o0000ooooooooool0Q?ooool00ol0003ooooo
ooooo`1Mooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`02o`00013o
oooo000Kooooo`03o`000?oooooooooo08Gooooo00?o0000ooooooooool0Foooool2o`0000?ooooo
00?o0000ooooooooool00_ooool01Ol0003oooooo`000?oooooo0000013ooooo000Kooooo`03o`00
0?oooooooooo08Gooooo00?o0000ooooooooool0Foooool00ol0003oooooo`000002o`0000Kooooo
0_l00002ooooo`03o`000?oooooooooo00gooooo000Kooooo`03o`000?oooooooooo08Gooooo00?o
0000ooooooooool0D_ooool2o`0000Oooooo00?o0000ooooooooool00_l0000:ooooo`03o`000?oo
oooooooo00gooooo000Kooooo`;o0000Qoooool00ol0003oooooooooo`1Aooooo`;o00001oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo000Kooooo`03o`000?oooooooooo
08Kooooo00?o0000ooooooooool0D?ooool01?l0003oooooooooool00006ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool001_ooooo00?o0000ooooooooool0Qoooool00ol0
003oooooooooo`1?ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0=ooooo`006oooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo
04oooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo000Kooooo`03o`000?oooooooooo08Oooooo00?o0000ooooooooool0Coooool01?l0
003oooooooooool00005ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
01_ooooo0_l00029ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool001_o
oooo00?o0000ooooooooool0R?ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;o
oooo0_l00009ooooo`006oooool00ol0003oooooooooo`29ooooo`03o`000?oooooooooo04cooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool00_ooool2o`0000Wooooo000Kooooo`03o`000?oooooooooo08Wooooo00?o
0000ooooooooool0Boooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`;o00002Oooool001_ooooo00?o0000
ooooooooool0R_ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo0_l00009
ooooo`006oooool2o`0008_ooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03_ooool01ol0003ooooooooooooooooo
0000ooooool000002?ooool001_ooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`19
ooooo`03o`000?oooooooooo00?ooooo00Go0000ooooooooooooooooo`00000Aooooo`06o`000?oo
ooooooooooooool0003ooooo0_l00007ooooo`001oooool3o`0000Cooooo00?o0000ooooooooool0
0_ooool3o`0000Gooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`19ooooo`03o`00
0?oooooooooo00Cooooo00Co0000oooooooooooo00004Oooool01Ol0003ooooooooooooooooo0000
00[ooooo0008ooooo`03o`000?oooooooooo00Oooooo00Go0000ooooooooooooooooo`000004oooo
o`03o`000?oooooooooo08cooooo00?o0000ooooooooool0Aoooool00ol0003oooooooooo`05oooo
o`04o`000?ooooooooooo`00017ooooo00Go0000ooooooooooooooooo`00000:ooooo`002?ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0S?ooool0
0ol0003oooooooooo`17ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00004Ooo
ool01?l0003oooooooooool0000;ooooo`002?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00;ooooo0_l0002>ooooo`03o`000?oooooooooo04Kooooo00?o0000ooooooooool01Ooo
ool01?l0003oooooooooool0000Aooooo`04o`000?ooooooooooo`0000_ooooo0008ooooo`03o`00
0?oooooooooo00Oooooo1?l00005ooooo`03o`000?oooooooooo08gooooo00?o0000ooooooooool0
A_ooool00ol0003oooooooooo`05ooooo`04o`000?ooooooooooo`00017ooooo00Co0000oooooooo
oooo00002oooool000Oooooo0_l00009ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool0S_ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooo
oooo00004Oooool01?l0003oooooooooool0000;ooooo`002?ooool00ol0003oooooooooo`07oooo
o`Go00001?ooool00ol0003oooooooooo`2>ooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`00017ooooo00Co0000
oooooooooooo00002oooool001_ooooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0E
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool0
000Aooooo`04o`000?ooooooooooo`0000_ooooo000Kooooo`;o0000T?ooool00ol0003ooooooooo
o`0Eooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool01_ooool01?l0003ooooooooo
ool0000Aooooo`04o`000?ooooooooooo`0000_ooooo000Kooooo`03o`000?oooooooooo093ooooo
00?o0000ooooooooool04oooool2o`0002gooooo00?o0000ooooooooool01_ooool01?l0003ooooo
ooooool0000Aooooo`04o`000?ooooooooooo`0000_ooooo000Kooooo`03o`000?oooooooooo093o
oooo00?o0000ooooooooool04oooool2o`0002cooooo00?o0000ooooooooool01oooool01?l0003o
ooooooooool0000Aooooo`04o`000?ooooooooooo`0000_ooooo000Kooooo`03o`000?oooooooooo
097ooooo00?o0000ooooooooool04_ooool2o`0002cooooo00?o0000ooooooooool01oooool01?l0
003oooooooooool0000Aooooo`04o`000?ooooooooooo`0000_ooooo000Kooooo`;o0000Toooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooo000002cooooo00?o0000ooooooooool01oooool0
0ol0003oooooo`00000Booooo`03o`000?oooooo000000cooooo000Kooooo`03o`000?oooooooooo
09?ooooo00?o0000ooooooooool03oooool00ol0003oooooo`00000/ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooool000004_ooool00ol0003oooooo`00000<ooooo`006oooool00ol0003o
ooooooooo`2Dooooo`03o`000?oooooooooo00gooooo00Co0000oooooooooooo0000;?ooool00ol0
003oooooooooo`08ooooo`;o00004_ooool00ol0003oooooo`00000<ooooo`006oooool00ol0003o
ooooooooo`2Eooooo`03o`000?oooooooooo00cooooo00Co0000oooooooooooo0000;?ooool00ol0
003oooooooooo`08ooooo`;o00004_ooool00ol0003oooooo`00000<ooooo`006oooool00ol0003o
ooooooooo`2Fooooo`03o`000?oooooooooo00[ooooo00Go0000ooooooooooooooooo`00000/oooo
o`03o`000?oooooooooo00Sooooo0_l0000Cooooo`;o00003?ooool001_ooooo0_l0002Gooooo`03
o`000?oooooooooo00[ooooo00Go0000ooooooooooooooooo`00000/ooooo`03o`000?oooooooooo
01gooooo0_l0000<ooooo`006oooool00ol0003oooooooooo`2Gooooo`;o00002Oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Oooooo0_l0000Qooooo`03o`000?oooooooooo01go
oooo0_l0000<ooooo`006oooool00ol0003oooooooooo`2Iooooo`03o`000?oooooooooo00Cooooo
0_l00005ooooo`03o`000?oooooooooo00Oooooo0_l0000Qooooo`03o`000?oooooooooo01gooooo
0_l0000<ooooo`006oooool00ol0003oooooooooo`2Jooooo`;o00000oooool2o`0000Kooooo00?o
0000ooooooooool01oooool2o`00023ooooo00?o0000ooooooooool07_ooool2o`0000cooooo000K
ooooo`03o`000?oooooooooo09_ooooo1?l00008ooooo`03o`000?oooooooooo00Oooooo0_l0000P
ooooo`03o`000?oooooooooo01kooooo0_l0000<ooooo`006oooool2o`000:Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooo`00000Oooooo`03o`000?oooooooooo01kooooo0_l0000<oooo
o`006oooool00ol0003oooooooooo`2Wooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooo
oooo00007_ooool00ol0003oooooooooo`0Nooooo`;o00003?ooool001_ooooo00?o0000oooooooo
ool0Z?ooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0001kooooo00?o0000oooo
ooooool07_ooool2o`0000cooooo000Booooo`Go00001?ooool00ol0003oooooooooo`2Xooooo`03
o`000?oooooooooo00Kooooo00Go0000ooooooooooooooooo`00000Mooooo`03o`000?oooooooooo
02cooooo000Cooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0Z?ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0/ooooo`005?ooool00ol0003oooooooooo`04ooooo`;o0000ZOooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool06_ooool00ol0003o
ooooooooo`0]ooooo`005Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0:Sooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Wooooo
00?o0000ooooooooool0;Oooool001;ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo0:Sooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool0;Oooool001;ooooo00Go0000oooooooooooooooo
o`000004ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0;Oooool001?ooooo0ol0
0005ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0;Oooool001_ooooo0_l0002Z
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo02kooooo000Kooooo`03o`000?oooooooooo0:[ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01Gooooo00?o0000oooo
ooooool0;_ooool001_ooooo00?o0000ooooooooool0Z_ooool01Ol0003ooooooooooooooooo0000
00_ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0^ooooo`006oooool00ol0003o
ooooooooo`2[ooooo`04o`000?oooooo0000o`0000_ooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`0^ooooo`006oooool00ol0003oooooooooo`2/ooooo`;o00003Oooool00ol0003o
ooooooooo`0Cooooo`03o`000?oooooooooo02kooooo000Kooooo`;o0000_?ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo02oooooo000Kooooo`03o`000?oooooooooo0;cooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0_ooooo`006oooool00ol0003oooooooooo`2l
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0<?ooool001_ooooo00?o0000oooo
ooooool0_Oooool00ol0003oooooooooo`08ooooo`Co00000oooool00ol0003oooooooooo`0`oooo
o`006oooool00ol0003oooooooooo`2mooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool00_l00002ooooo`03o`000?oooooooooo033ooooo000Kooooo`;o0000_oooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00;ooooo0ol0000cooooo`006oooool00ol0003ooooooooo
o`2nooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0>?ooool001_ooooo00?o0000
ooooooooool0_oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03Wooooo000Koooo
o`03o`000?oooooooooo0;oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0ioooo
o`006oooool00ol0003oooooooooo`30ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0>Oooool001_ooooo0_l00031ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
>_ooool001_ooooo00?o0000ooooooooool0`Oooool01Ol0003ooooooooooooooooo000003cooooo
0006ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003ooooooooo
o`31ooooo`05o`000?ooooooooooooooool00000??ooool000Oooooo00Co0000oooooooooooo0000
1oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0`Oooool2o`000003
ooooool0003ooooo03cooooo0008ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`32ooooo`?o0000?Oooool000Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`02ooooo`;o0000ooooool4ooooo`001_ooool01Ol0003ooooooooooooo
oooo000000Oooooo1?l00005ooooo`03o`000?oooooooooo0?oooooo0oooool000Kooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0oooo
ool3ooooo`001oooool3o`0000Sooooo1Ol00004ooooo`03o`000?oooooooooo0?oooooo0oooool0
0?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool0
0?oooooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176, 0}} -> {-0.00116071, -0.884886, \
4.24759*^-5, 0.0203611}}],

Cell[TextData["-Graphics-"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q2final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 88.5047 0.0922964 0.0273528 [
[.20082 .0798 -15 -9 ]
[.20082 .0798 15 0 ]
[.37783 .0798 -15 -9 ]
[.37783 .0798 15 0 ]
[.55484 .0798 -15 -9 ]
[.55484 .0798 15 0 ]
[.73185 .0798 -15 -9 ]
[.73185 .0798 15 0 ]
[.90886 .0798 -12 -9 ]
[.90886 .0798 12 0 ]
[.01131 .22906 -6 -4.5 ]
[.01131 .22906 0 4.5 ]
[.01131 .36582 -12 -4.5 ]
[.01131 .36582 0 4.5 ]
[.01131 .50259 -12 -4.5 ]
[.01131 .50259 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20082 .0923 m
.20082 .09855 L
s
[(0.002)] .20082 .0798 0 1 Mshowa
.37783 .0923 m
.37783 .09855 L
s
[(0.004)] .37783 .0798 0 1 Mshowa
.55484 .0923 m
.55484 .09855 L
s
[(0.006)] .55484 .0798 0 1 Mshowa
.73185 .0923 m
.73185 .09855 L
s
[(0.008)] .73185 .0798 0 1 Mshowa
.90886 .0923 m
.90886 .09855 L
s
[(0.01)] .90886 .0798 0 1 Mshowa
.125 Mabswid
.06806 .0923 m
.06806 .09605 L
s
.11231 .0923 m
.11231 .09605 L
s
.15657 .0923 m
.15657 .09605 L
s
.24507 .0923 m
.24507 .09605 L
s
.28932 .0923 m
.28932 .09605 L
s
.33358 .0923 m
.33358 .09605 L
s
.42208 .0923 m
.42208 .09605 L
s
.46633 .0923 m
.46633 .09605 L
s
.51059 .0923 m
.51059 .09605 L
s
.59909 .0923 m
.59909 .09605 L
s
.64334 .0923 m
.64334 .09605 L
s
.68759 .0923 m
.68759 .09605 L
s
.7761 .0923 m
.7761 .09605 L
s
.82035 .0923 m
.82035 .09605 L
s
.8646 .0923 m
.8646 .09605 L
s
.95311 .0923 m
.95311 .09605 L
s
.99736 .0923 m
.99736 .09605 L
s
.25 Mabswid
0 .0923 m
1 .0923 L
s
.02381 .22906 m
.03006 .22906 L
s
[(5)] .01131 .22906 1 0 Mshowa
.02381 .36582 m
.03006 .36582 L
s
[(10)] .01131 .36582 1 0 Mshowa
.02381 .50259 m
.03006 .50259 L
s
[(15)] .01131 .50259 1 0 Mshowa
.125 Mabswid
.02381 .11965 m
.02756 .11965 L
s
.02381 .147 m
.02756 .147 L
s
.02381 .17435 m
.02756 .17435 L
s
.02381 .20171 m
.02756 .20171 L
s
.02381 .25641 m
.02756 .25641 L
s
.02381 .28377 m
.02756 .28377 L
s
.02381 .31112 m
.02756 .31112 L
s
.02381 .33847 m
.02756 .33847 L
s
.02381 .39318 m
.02756 .39318 L
s
.02381 .42053 m
.02756 .42053 L
s
.02381 .44788 m
.02756 .44788 L
s
.02381 .47524 m
.02756 .47524 L
s
.02381 .06494 m
.02756 .06494 L
s
.02381 .03759 m
.02756 .03759 L
s
.02381 .01024 m
.02756 .01024 L
s
.02381 .52994 m
.02756 .52994 L
s
.02381 .55729 m
.02756 .55729 L
s
.02381 .58465 m
.02756 .58465 L
s
.02381 .612 m
.02756 .612 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .10662 m
.02499 .10662 L
.02605 .10662 L
.02729 .10662 L
.02846 .10662 L
.02954 .10662 L
.03053 .10662 L
.03163 .10662 L
.03279 .10662 L
.03395 .10662 L
.0352 .10662 L
.03638 .10662 L
.03746 .10662 L
.03873 .10662 L
.03944 .10662 L
.04011 .10662 L
.04262 .10662 L
.04521 .10662 L
.04648 .10662 L
.04765 .10662 L
.04872 .10662 L
.04984 .10662 L
.05221 .10662 L
.05343 .10662 L
.05474 .10662 L
.05597 .10662 L
.05709 .10662 L
.05841 .10662 L
.05984 .10662 L
.06244 .10662 L
.06749 .10662 L
.07306 .10662 L
.07586 .10662 L
.07743 .10662 L
.07887 .10662 L
.08433 .10662 L
.08904 .10662 L
.09419 .10663 L
.10458 .10663 L
.10986 .10664 L
.11485 .10664 L
.11933 .10665 L
.12419 .10665 L
.13417 .10667 L
.14514 .10669 L
.15541 .10672 L
.16502 .10675 L
.18606 .10684 L
.20635 .10696 L
.22488 .10711 L
Mistroke
.26464 .1075 L
.28472 .1077 L
.29345 .10778 L
.30289 .10786 L
.30547 .10787 L
.30818 .10789 L
.3107 .1079 L
.31305 .1079 L
.31427 .10791 L
.31543 .10791 L
.3176 .10792 L
.31886 .10792 L
.32002 .10792 L
.32126 .10792 L
.32191 .10792 L
.3226 .10792 L
.3239 .10792 L
.32508 .10792 L
.32775 .10791 L
.33011 .1079 L
.33258 .10789 L
.33531 .10787 L
.33784 .10785 L
.33853 .10784 L
.33927 .10783 L
.33998 .10782 L
.34062 .10782 L
.34138 .10781 L
.34218 .1078 L
.34359 .10777 L
.34844 .1077 L
.35305 .10761 L
.35836 .10747 L
.3632 .1073 L
.37191 .10693 L
.38153 .10638 L
.39116 .10567 L
.40141 .10471 L
.4109 .10351 L
.41982 .10218 L
.43998 .09805 L
.45848 .09268 L
.47738 .08509 L
.48809 .07944 L
.49807 .07291 L
.50858 .06381 L
.5185 .05164 L
.52735 .04013 L
.53238 .03519 L
.53708 .03154 L
Mistroke
.54679 .02605 L
.55174 .02389 L
.55707 .02206 L
.56201 .02061 L
.56671 .01955 L
.57552 .01803 L
.58055 .0174 L
.58511 .01692 L
.59534 .01609 L
.60428 .01539 L
.60664 .0152 L
.60917 .01503 L
.61151 .0149 L
.61267 .01484 L
.61373 .0148 L
.61493 .01477 L
.61623 .01473 L
.61734 .01472 L
.61852 .01472 L
.6198 .01473 L
.62101 .01475 L
.6217 .01478 L
.62234 .01482 L
.62303 .01486 L
.62376 .01489 L
.62487 .015 L
.62605 .0151 L
.62707 .0152 L
.62817 .01533 L
.62947 .01559 L
.6307 .01574 L
.63189 .01604 L
.63299 .01631 L
.63532 .01686 L
.63781 .01762 L
.64055 .01868 L
.64311 .01988 L
.64871 .02354 L
.65139 .02573 L
.65265 .02672 L
.65382 .02762 L
.655 .02937 L
.65628 .03041 L
.65741 .03173 L
.6586 .03384 L
.66124 .03805 L
.66253 .03966 L
.6637 .04244 L
.66478 .09127 L
.66581 .1452 L
Mistroke
.66689 .14899 L
.66807 .15167 L
.67286 .16293 L
.6936 .20238 L
.69471 .20384 L
.69589 .20577 L
.69719 .2093 L
.6984 .21162 L
.69963 .21694 L
.70079 .22104 L
.70183 .29458 L
.70296 .30695 L
.7036 .30723 L
.70429 .3075 L
.70502 .30796 L
.7057 .30831 L
.70692 .30856 L
.70822 .30877 L
.70951 .30873 L
.71074 .30848 L
.71183 .30817 L
.71304 .30786 L
.71372 .3075 L
.71437 .30713 L
.71505 .30697 L
.71579 .3067 L
.71833 .30543 L
.71979 .30465 L
.72053 .30436 L
.72134 .30414 L
.72278 .30381 L
.72409 .30358 L
.72473 .30358 L
.72543 .30358 L
.72669 .30381 L
.72739 .3039 L
.72813 .30412 L
.72876 .30448 L
.72946 .30493 L
.73445 .30838 L
.77379 .33246 L
.77508 .33241 L
.77629 .33258 L
.77697 .33265 L
.77769 .33285 L
.77896 .33366 L
.7797 .33398 L
.78048 .3344 L
.78115 .33499 L
.78189 .3358 L
Mistroke
.7846 .33872 L
.78955 .3457 L
.79228 .34956 L
.79486 .35266 L
.79736 .35491 L
.79868 .35608 L
.79934 .3566 L
.80008 .35685 L
.80135 .35736 L
.80254 .35756 L
.80364 .35764 L
.80482 .35754 L
.80595 .35737 L
.80719 .35698 L
.80968 .35632 L
.81079 .35592 L
.81198 .35573 L
.8131 .35566 L
.81412 .35568 L
.81527 .356 L
.81654 .35637 L
.81718 .35686 L
.81787 .3574 L
.81911 .35831 L
.82034 .35955 L
.82151 .36169 L
.82256 .36315 L
.82371 .36476 L
.82496 .36829 L
.82564 .36908 L
.82629 .37078 L
.82868 .3788 L
.83409 .4041 L
.84315 .43734 L
.84563 .44487 L
.84699 .44805 L
.84825 .45058 L
.84933 .452 L
.85048 .45357 L
.85176 .45485 L
.85293 .45537 L
.85776 .45673 L
.85894 .45704 L
.8602 .45766 L
.86093 .45802 L
.86159 .45877 L
.86289 .46022 L
.86406 .46225 L
.86514 .46391 L
.86633 .46621 L
Mistroke
.8676 .47084 L
.87208 .49191 L
.87735 .5269 L
.88291 .56218 L
.88409 .57025 L
.8852 .57772 L
.88649 .58068 L
.88766 .58352 L
.88895 .58555 L
.88968 .5862 L
.89035 .58634 L
.89157 .58641 L
.89287 .58602 L
.89408 .58488 L
.89539 .58415 L
.89652 .58316 L
.89776 .58243 L
.89847 .5823 L
.89913 .58234 L
.89983 .58245 L
.90057 .58295 L
.90127 .58375 L
.90193 .58458 L
.90316 .58617 L
.90597 .59111 L
.90751 .59475 L
.90895 .59743 L
.91149 .60115 L
.91218 .60197 L
.91284 .60276 L
.91359 .60322 L
.91428 .60332 L
.91545 .60319 L
.91669 .60271 L
.91786 .60115 L
.91892 .59965 L
.92397 .5911 L
.92523 .58903 L
.92587 .5881 L
.92656 .58774 L
.92732 .5872 L
.92803 .58672 L
.92868 .58654 L
.92937 .58662 L
.93003 .58666 L
.93074 .58698 L
.93203 .58808 L
.93446 .5898 L
.93566 .59096 L
.9368 .59126 L
Mistroke
.93812 .59106 L
.93932 .58998 L
.94045 .58865 L
.9415 .58674 L
.94266 .58179 L
.94389 .5772 L
.94459 .57204 L
.94523 .56835 L
.94669 .55888 L
.94933 .5438 L
.95189 .52788 L
.95314 .52035 L
.95428 .51156 L
.95548 .5065 L
.95663 .5009 L
.95915 .49081 L
.9645 .46812 L
.967 .45793 L
.96827 .4536 L
.96899 .45245 L
.96967 .4506 L
.97035 .44872 L
.97108 .44706 L
.97187 .44584 L
.97259 .44513 L
.97388 .44278 L
.97457 .44141 L
.9753 .44053 L
.97619 .43968 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo
000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo0_l0003ooooooa3ooooo000?oooo
o`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0UooooolBo`0006Go
oooo000?ooooo`03o`000?oooooooooo09;ooooo1Ol0000Booooo`;o0000Hoooool000oooooo00?o
0000ooooooooool0Soooool3o`0001Wooooo00?o0000ooooooooool0H?ooool000oooooo00?o0000
ooooooooool0SOooool2o`0001gooooo00?o0000ooooooooool0Goooool000oooooo00?o0000oooo
ooooool0Roooool2o`00023ooooo00?o0000ooooooooool0G_ooool000oooooo00?o0000oooooooo
ool0R_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo05gooooo000?ooooo`;o0000
Roooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo05gooooo000?ooooo`03o`000?oo
oooooooo08Wooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`1Looooo`003oooool0
0ol0003oooooooooo`29ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0G?ooool0
00oooooo00?o0000ooooooooool0R?ooool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo
05cooooo000?ooooo`03o`000?oooooooooo027ooooo0_l00004ooooo`03o`000?oooooooooo00?o
oooo0_l00004ooooo`;o00000_ooool5o`0001Kooooo0_l00004ooooo`03o`000?oooooooooo00?o
oooo0_l00004ooooo`;o00001?ooool3o`0001Oooooo0_l000001Ooooooo0000oooooooooooo0000
00Gooooo0_l00004ooooo`;o00000oooool3o`00017ooooo00?o0000ooooooooool00oooool2o`00
00Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003ooooo`?o00006_ooool2o`00
00Cooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol0000Aooooo`003oooool00ol0003o
ooooooooo`0Pooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Gooooo00Co0000oooooooooooo
00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool05Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo
00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko
0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01Kooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo013ooooo000?oooo
o`03o`000?oooooooooo023ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool0
0002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool05Oooool01?l0003ooooo
ooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooooooo0000ooooo`05
o`0001Kooooo00Co0000ooooool0003o00002?ooool01?l0003oooooooooool00002ooooo`06o`00
0?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00;ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?oo
ooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Fooooo`04o`000?ooooooooooo`00
00Sooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0@ooooo`003oooool00ol0
003oooooooooo`0Pooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo
00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000_oo
ool00ol0003oooooooooo`0Eooooo`;o000000?oooooo`000?ooool01oooool01?l0003ooooooooo
ool00002ooooo`05o`000?ooooooooooo`000?ooool01?l0000Aooooo`03o`000?oooooooooo00;o
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?oooooo
ooooo`0000;ooooo0ol0000Iooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo
00000oooool00ol0003oooooooooo`0@ooooo`003oooool2o`00027ooooo00Co0000oooooooooooo
00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000ooo
ool00ol0003oooooooooo`0Cooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000001Oooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo
00005?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooo
oooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool0
5_ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000oooo
ooooool04?ooool000oooooo00?o0000ooooooooool08?ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`00
0?oooooooooo01?ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000?ooooo0_l0000Fooooo`;o00000_ooool00ol0003oooooooooo`06
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00002?ooool01?l0003o
ooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003ooooooooo
o`0Fooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool2o`0001;o
oooo000?ooooo`03o`000?oooooooooo027ooooo0_l0000:ooooo`;o00001?ooool2o`0000?ooooo
0ol0000Gooooo`;o00002_ooool2o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo01;ooooo
0_l00002ooooo`;o00002_ooool2o`0000Cooooo0_l00004ooooo`;o00004Oooool00ol0003ooooo
ooooo`03ooooo`;o00002_ooool2o`0000Cooooo0_l00003ooooo`?o00006_ooool2o`0000[ooooo
0_l00004ooooo`03o`000?oooooooooo013ooooo000?ooooo`03o`000?oooooooooo07oooooo00?o
0000ooooooooool0;Oooool00ol0003oooooooooo`1Looooo`003oooool00ol0003oooooooooo`1m
ooooo`;o0000<?ooool00ol0003oooooooooo`1Looooo`003oooool00ol0003oooooooooo`1joooo
o`?o0000<_ooool00ol0003oooooooooo`1Looooo`003oooool00ol0003oooooooooo`1gooooo`?o
0000=Oooool00ol0003oooooooooo`1Looooo`002?ooooooo`0001Wo0000000?ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00?ooooo0ol00003ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo0Ol00001ooooo`003oooool0
0ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool03?ooool4
o`0001oooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo02kooooo00?o0000ooooooooool06?ooool000oooooo00?o0000ooooooooool0J?ooool6o`00
047ooooo00?o0000ooooooooool0G?ooool000ooooooAol0000Doooooa3o0000Aoooool00ol0003o
ooooooooo`1Looooo`003oooool00ol0003oooooooooo`14oooooaCo0000Eoooool00ol0003ooooo
ooooo`1Looooo`003oooool00ol0003oooooooooo`2_ooooo`03o`000?oooooooooo05cooooo000?
ooooo`03o`000?oooooooooo0:oooooo00?o0000ooooooooool0G?ooool000oooooo0_l0002aoooo
o`03o`000?oooooooooo05_ooooo000?ooooo`03o`000?oooooooooo0;3ooooo00?o0000oooooooo
ool0Foooool000oooooo00?o0000ooooooooool0/?ooool00ol0003oooooooooo`1Kooooo`003ooo
ool00ol0003oooooooooo`2`ooooo`03o`000?oooooooooo05_ooooo000?ooooo`03o`000?oooooo
oooo0;3ooooo00?o0000ooooooooool0Foooool000oooooo00?o0000ooooooooool0/?ooool00ol0
003oooooooooo`1Kooooo`003oooool00ol0003oooooooooo`2`ooooo`03o`000?oooooooooo05_o
oooo000?ooooo`;o0000/Oooool00ol0003oooooooooo`1Kooooo`003oooool00ol0003ooooooooo
o`2`ooooo`03o`000?oooooooooo05_ooooo000?ooooo`03o`000?oooooooooo0;3ooooo00?o0000
ooooooooool0Foooool000oooooo00?o0000ooooooooool0/?ooool00ol0003oooooooooo`1Koooo
o`003oooool00ol0003oooooooooo`2aooooo`03o`000?oooooooooo05[ooooo000?ooooo`03o`00
0?oooooooooo0;;ooooo00?o0000ooooooooool0FOooool000oooooo00?o0000ooooooooool0/_oo
ool00ol0003oooooooooo`1Iooooo`003oooool00ol0003oooooooooo`2cooooo`03o`000?oooooo
oooo05Sooooo000?ooooo`;o0000]?ooool00ol0003oooooooooo`1Hooooo`003oooool00ol0003o
ooooooooo`2dooooo`03o`000?oooooooooo05Oooooo000?ooooo`03o`000?oooooooooo0;Cooooo
00?o0000ooooooooool0Eoooool000oooooo00?o0000ooooooooool0]Oooool00ol0003ooooooooo
o`1Fooooo`003oooool00ol0003oooooooooo`2eooooo`03o`000?oooooooooo05Kooooo000?oooo
o`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool0E_ooool000oooooo00?o0000oooooooo
ool0]_ooool00ol0003oooooooooo`1Eooooo`003oooool00ol0003oooooooooo`2fooooo`03o`00
0?oooooooooo05Gooooo000?ooooo`;o0000^?ooool2o`0005Gooooo000?ooooo`03o`000?oooooo
oooo0;Sooooo00?o0000ooooooooool0Doooool000oooooo00?o0000ooooooooool0^?ooool2o`00
05Cooooo000?ooooo`03o`000?oooooooooo0;Wooooo00?o0000ooooooooool0D_ooool000oooooo
00?o0000ooooooooool0^Oooool00ol0003oooooooooo`1Booooo`001oooool3o`0000Gooooo00?o
0000ooooooooool0^Oooool00ol0003oooooooooo`1Booooo`001_ooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool0^Oooool00ol0003oooooooooo`1Booooo`002_ooool0
0ol0003oooooooooo`02ooooo`?o0000^Oooool00ol0003oooooooooo`1Booooo`002_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo0;Wooooo00?o0000ooooooooool0D_ooool000Ko
oooo1?l00005ooooo`03o`000?oooooooooo0;Wooooo00?o0000ooooooooool0D_ooool000Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`2iooooo`03o`000?oooooooooo05;ooooo
0006ooooo`Go00001?ooool00ol0003oooooooooo`2iooooo`03o`000?oooooooooo05;ooooo000?
ooooo`03o`000?oooooooooo0;Wooooo00?o0000ooooooooool0D_ooool000oooooo00?o0000oooo
ooooool0^Oooool00ol0003oooooooooo`1Booooo`003oooool00ol0003oooooooooo`2iooooo`03
o`000?oooooooooo05;ooooo000?ooooo`;o0000^_ooool00ol0003oooooooooo`1Booooo`003ooo
ool00ol0003oooooooooo`2jooooo`03o`000?oooooooooo057ooooo000?ooooo`03o`000?oooooo
oooo0;[ooooo00?o0000ooooooooool0DOooool000oooooo00?o0000ooooooooool0^_ooool00ol0
003oooooooooo`1Aooooo`003oooool00ol0003oooooooooo`2jooooo`03o`000?oooooooooo057o
oooo000?ooooo`03o`000?oooooooooo0;[ooooo00?o0000ooooooooool0DOooool000oooooo00?o
0000ooooooooool0^_ooool00ol0003oooooooooo`1Aooooo`003oooool2o`000;_ooooo00?o0000
ooooooooool0DOooool000oooooo00?o0000ooooooooool0^_ooool00ol0003oooooooooo`1Aoooo
o`003oooool00ol0003oooooooooo`2jooooo`03o`000?oooooooooo057ooooo000?ooooo`03o`00
0?oooooooooo0;[ooooo00?o0000ooooooooool0DOooool000oooooo00?o0000ooooooooool0^_oo
ool00ol0003oooooooooo`1Aooooo`003oooool00ol0003oooooooooo`2jooooo`03o`000?oooooo
oooo057ooooo000?ooooo`03o`000?oooooooooo0;[ooooo00?o0000ooooooooool00_ooool4o`00
04_ooooo000?ooooo`03o`000?oooooooooo0;[ooooo1Ol00004ooooo`;o0000BOooool000oooooo
0_l00036ooooo`03o`000?oooooooooo04Kooooo000?ooooo`03o`000?oooooooooo0<Kooooo0_l0
0016ooooo`003oooool00ol0003oooooooooo`38ooooo`;o0000A?ooool000oooooo00?o0000oooo
ooooool0b_ooool00ol0003oooooooooo`11ooooo`003oooool00ol0003oooooooooo`3;ooooo`;o
0000@Oooool000oooooo00?o0000ooooooooool0cOooool00ol0003oooooooooo`0nooooo`003ooo
ool00ol0003oooooooooo`3>ooooo`;o0000?_ooool000oooooo00?o0000ooooooooool0coooool2
o`0003gooooo000?ooooo`;o0000d_ooool00ol0003oooooooooo`0jooooo`003oooool00ol0003o
ooooooooo`3Aooooo`03o`000?oooooooooo03[ooooo000?ooooo`03o`000?oooooooooo0=;ooooo
00?o0000ooooooooool0>Oooool000oooooo00?o0000ooooooooool0doooool00ol0003ooooooooo
o`0hooooo`003oooool00ol0003oooooooooo`3Cooooo`;o00000oooool2o`0003Cooooo00001?oo
oooo0000o`000?l00004ooooo`;o00001Oooool00ol0003oooooooooo`3Eooooo`Ko0000<oooool0
00;ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo
oooo0=_ooooo00?o0000ooooooooool0<?ooool000;ooooo00?o0000ooooooooool00_ooool01?l0
003oooooooooool00004ooooo`?o0000foooool00ol0003oooooooooo`0`ooooo`000_ooool00ol0
003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0g?ooool0
0ol0003oooooooooo`0_ooooo`000_ooool00ol0003oooooooooo`02ooooo`04o`000?oooooooooo
o`0000Cooooo00?o0000ooooooooool0g?ooool00ol0003oooooooooo`0_ooooo`0000?oooooo`00
0?l000001?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0=cooooo00?o0000
ooooooooool0;oooool000;ooooo00?o0000ooooooooool00oooool2o`0000Gooooo00?o0000oooo
ooooool0gOooool00ol0003oooooooooo`0^ooooo`003oooool00ol0003oooooooooo`3Mooooo`03
o`000?oooooooooo02kooooo000?ooooo`03o`000?oooooooooo0=gooooo00?o0000ooooooooool0
;_ooool000oooooo00?o0000ooooooooool0gOooool00ol0003oooooooooo`0^ooooo`003oooool2
o`000=oooooo00?o0000ooooooooool0;Oooool000oooooo00?o0000ooooooooool0g_ooool00ol0
003oooooooooo`0]ooooo`003oooool00ol0003oooooooooo`3Nooooo`03o`000?oooooooooo02go
oooo000?ooooo`03o`000?oooooooooo0=kooooo00?o0000ooooooooool0;Oooool000oooooo00?o
0000ooooooooool0g_ooool00ol0003oooooooooo`0]ooooo`003oooool00ol0003oooooooooo`3O
ooooo`03o`000?oooooooooo02cooooo000?ooooo`03o`000?oooooooooo0=oooooo00?o0000oooo
ooooool0;?ooool000oooooo00?o0000ooooooooool0goooool00ol0003oooooooooo`0/ooooo`00
3oooool2o`000>7ooooo00?o0000ooooooooool0:oooool000oooooo00?o0000ooooooooool0h?oo
ool00ol0003oooooooooo`0[ooooo`003oooool00ol0003oooooooooo`3Pooooo`03o`000?oooooo
oooo02_ooooo000?ooooo`03o`000?oooooooooo0>7ooooo00?o0000ooooooooool0:_ooool000oo
oooo00?o0000ooooooooool0hOooool00ol0003oooooooooo`0Zooooo`003oooool00ol0003ooooo
ooooo`3Qooooo`03o`000?oooooooooo027ooooo0_l00007ooooo`003oooool00ol0003ooooooooo
o`3Rooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool01_ooool000oooooo0_l0003S
ooooo`03o`000?oooooooooo01oooooo0_l00008ooooo`003oooool00ol0003oooooooooo`3Roooo
o`;o00008?ooool00ol0003oooooooooo`07ooooo`003oooool00ol0003oooooooooo`3Sooooo`;o
00007oooool00ol0003oooooooooo`07ooooo`003oooool00ol0003oooooooooo`3Uooooo`;o0000
7?ooool00ol0003oooooooooo`08ooooo`003oooool00ol0003oooooooooo`3Vooooo`;o00006ooo
ool00ol0003oooooooooo`08ooooo`003oooool00ol0003oooooooooo`3Wooooo`03o`000?oooooo
oooo01Wooooo00?o0000ooooooooool02?ooool000oooooo00?o0000ooooooooool0ioooool00ol0
003oooooooooo`0Iooooo`03o`000?oooooooooo00Sooooo000?ooooo`03o`000?oooooooooo0>So
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`003oooool2o`000>Wooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`09ooooo`003oooool00ol0003ooooooooo
o`3Xooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02Oooool000oooooo00?o0000
ooooooooool0jOooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00Wooooo000?oooo
o`03o`000?oooooooooo0>Wooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0:oooo
o`003oooool00ol0003oooooooooo`3Yooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool02_ooool00004ooooool0003o0000o`0000?ooooo0ol00005ooooo`03o`000?oooooooooo0>Wo
oooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0:ooooo`000_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3Yooooo`03
o`000?oooooooooo01Cooooo00?o0000ooooooooool02oooool000;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`02ooooo`?o0000jOooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo00_ooooo0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`3Yooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool02ooo
ool000;ooooo00Co0000oooooooooooooooo1?l00005ooooo`03o`000?oooooooooo0>Wooooo00?o
0000ooooooooool05?ooool00ol0003oooooooooo`0;ooooo`0000?oooooo`000?l000000oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo0>[ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0;ooooo`000_ooool01?l0003oooooooooooooool5o`0000Cooooo00?o0000
ooooooooool0j_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00_ooooo000?oooo
o`03o`000?oooooooooo0>[ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0<oooo
o`003oooool00ol0003oooooooooo`3Zooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool03?ooool000oooooo00?o0000ooooooooool0j_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00cooooo000?ooooo`;o0000joooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo00cooooo000?ooooo`03o`000?oooooooooo0>[ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0<ooooo`003oooool00ol0003oooooooooo`3[ooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool03Oooool000oooooo00?o0000ooooooooool0joooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo00gooooo000?ooooo`03o`000?oooooooooo0>_ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0=ooooo`003oooool00ol0003ooooooooo
o`3[ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool03Oooool000oooooo00?o0000
ooooooooool0joooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00gooooo000?oooo
o`03o`000?oooooooooo0>cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0=oooo
o`003oooool2o`000>gooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`0=ooooo`00
3oooool00ol0003oooooooooo`3/ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool0
3Oooool000oooooo00?o0000ooooooooool0k?ooool00ol0003oooooooooo`0>ooooo`03o`000?oo
oooooooo00kooooo000?ooooo`03o`000?oooooooooo0>cooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0>ooooo`003oooool00ol0003oooooooooo`3/ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool03_ooool000oooooo00?o0000ooooooooool0kOooool00ol0003o
ooooooooo`0=ooooo`03o`000?oooooooooo00kooooo000?ooooo`03o`000?oooooooooo0>gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`003oooool2o`000>kooooo1Ol0
000;ooooo`03o`000?oooooooooo00kooooo000?ooooo`03o`000?oooooooooo0>kooooo0_l00002
ooooo`03o`000?oooooooooo00?ooooo0ol000000ooooooo0000ooooo`0@ooooo`003oooool00ol0
003oooooooooo`3booooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00ol0000Aoooo
o`003oooool00ol0003oooooooooo`3cooooo`05o`000?ooooooooooooooool000005_ooool000oo
oooo00?o0000ooooooooool0loooool01?l0003oooooooooool0000Gooooo`003oooool00ol0003o
ooooooooo`3dooooo`?o00005oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003ooo
ool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`;o0000ooooool@ooooo`003oooool00ol0
003oooooooooo`3oooooo`oooooo003oooooob7ooooo003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176, 0}} -> {-0.000628754, -3.6437, \
4.06224*^-5, 0.131441}}],

Cell[TextData["-Graphics-"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q3final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 88.5047 0.0158609 0.00802324 [
[.20082 .00336 -15 -9 ]
[.20082 .00336 15 0 ]
[.37783 .00336 -15 -9 ]
[.37783 .00336 15 0 ]
[.55484 .00336 -15 -9 ]
[.55484 .00336 15 0 ]
[.73185 .00336 -15 -9 ]
[.73185 .00336 15 0 ]
[.90886 .00336 -12 -9 ]
[.90886 .00336 12 0 ]
[.01131 .09609 -12 -4.5 ]
[.01131 .09609 0 4.5 ]
[.01131 .17633 -12 -4.5 ]
[.01131 .17633 0 4.5 ]
[.01131 .25656 -12 -4.5 ]
[.01131 .25656 0 4.5 ]
[.01131 .33679 -12 -4.5 ]
[.01131 .33679 0 4.5 ]
[.01131 .41702 -12 -4.5 ]
[.01131 .41702 0 4.5 ]
[.01131 .49726 -12 -4.5 ]
[.01131 .49726 0 4.5 ]
[.01131 .57749 -12 -4.5 ]
[.01131 .57749 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20082 .01586 m
.20082 .02211 L
s
[(0.002)] .20082 .00336 0 1 Mshowa
.37783 .01586 m
.37783 .02211 L
s
[(0.004)] .37783 .00336 0 1 Mshowa
.55484 .01586 m
.55484 .02211 L
s
[(0.006)] .55484 .00336 0 1 Mshowa
.73185 .01586 m
.73185 .02211 L
s
[(0.008)] .73185 .00336 0 1 Mshowa
.90886 .01586 m
.90886 .02211 L
s
[(0.01)] .90886 .00336 0 1 Mshowa
.125 Mabswid
.06806 .01586 m
.06806 .01961 L
s
.11231 .01586 m
.11231 .01961 L
s
.15657 .01586 m
.15657 .01961 L
s
.24507 .01586 m
.24507 .01961 L
s
.28932 .01586 m
.28932 .01961 L
s
.33358 .01586 m
.33358 .01961 L
s
.42208 .01586 m
.42208 .01961 L
s
.46633 .01586 m
.46633 .01961 L
s
.51059 .01586 m
.51059 .01961 L
s
.59909 .01586 m
.59909 .01961 L
s
.64334 .01586 m
.64334 .01961 L
s
.68759 .01586 m
.68759 .01961 L
s
.7761 .01586 m
.7761 .01961 L
s
.82035 .01586 m
.82035 .01961 L
s
.8646 .01586 m
.8646 .01961 L
s
.95311 .01586 m
.95311 .01961 L
s
.99736 .01586 m
.99736 .01961 L
s
.25 Mabswid
0 .01586 m
1 .01586 L
s
.02381 .09609 m
.03006 .09609 L
s
[(10)] .01131 .09609 1 0 Mshowa
.02381 .17633 m
.03006 .17633 L
s
[(20)] .01131 .17633 1 0 Mshowa
.02381 .25656 m
.03006 .25656 L
s
[(30)] .01131 .25656 1 0 Mshowa
.02381 .33679 m
.03006 .33679 L
s
[(40)] .01131 .33679 1 0 Mshowa
.02381 .41702 m
.03006 .41702 L
s
[(50)] .01131 .41702 1 0 Mshowa
.02381 .49726 m
.03006 .49726 L
s
[(60)] .01131 .49726 1 0 Mshowa
.02381 .57749 m
.03006 .57749 L
s
[(70)] .01131 .57749 1 0 Mshowa
.125 Mabswid
.02381 .03191 m
.02756 .03191 L
s
.02381 .04795 m
.02756 .04795 L
s
.02381 .064 m
.02756 .064 L
s
.02381 .08005 m
.02756 .08005 L
s
.02381 .11214 m
.02756 .11214 L
s
.02381 .12819 m
.02756 .12819 L
s
.02381 .14423 m
.02756 .14423 L
s
.02381 .16028 m
.02756 .16028 L
s
.02381 .19237 m
.02756 .19237 L
s
.02381 .20842 m
.02756 .20842 L
s
.02381 .22447 m
.02756 .22447 L
s
.02381 .24051 m
.02756 .24051 L
s
.02381 .2726 m
.02756 .2726 L
s
.02381 .28865 m
.02756 .28865 L
s
.02381 .3047 m
.02756 .3047 L
s
.02381 .32074 m
.02756 .32074 L
s
.02381 .35284 m
.02756 .35284 L
s
.02381 .36888 m
.02756 .36888 L
s
.02381 .38493 m
.02756 .38493 L
s
.02381 .40098 m
.02756 .40098 L
s
.02381 .43307 m
.02756 .43307 L
s
.02381 .44912 m
.02756 .44912 L
s
.02381 .46516 m
.02756 .46516 L
s
.02381 .48121 m
.02756 .48121 L
s
.02381 .5133 m
.02756 .5133 L
s
.02381 .52935 m
.02756 .52935 L
s
.02381 .54539 m
.02756 .54539 L
s
.02381 .56144 m
.02756 .56144 L
s
.02381 .59353 m
.02756 .59353 L
s
.02381 .60958 m
.02756 .60958 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .01726 m
.02499 .01726 L
.02605 .01726 L
.02729 .01726 L
.02846 .01726 L
.02954 .01726 L
.03053 .01726 L
.03163 .01726 L
.03279 .01726 L
.03395 .01726 L
.0352 .01726 L
.03638 .01726 L
.03746 .01726 L
.03873 .01726 L
.03944 .01726 L
.04011 .01726 L
.04262 .01726 L
.04521 .01726 L
.04648 .01726 L
.04765 .01726 L
.04872 .01726 L
.04984 .01726 L
.05221 .01726 L
.05343 .01726 L
.05474 .01726 L
.05597 .01726 L
.05709 .01726 L
.05841 .01726 L
.05984 .01726 L
.06244 .01726 L
.06749 .01726 L
.07306 .01726 L
.07586 .01726 L
.07743 .01726 L
.07887 .01726 L
.08433 .01726 L
.08904 .01726 L
.09419 .01725 L
.10458 .01725 L
.10986 .01725 L
.11485 .01724 L
.11933 .01724 L
.12419 .01724 L
.13417 .01722 L
.14514 .01721 L
.15541 .01719 L
.16502 .01717 L
.17581 .01713 L
.18606 .0171 L
.20635 .017 L
Mistroke
.22488 .01688 L
.24473 .01672 L
.26313 .01654 L
.30231 .01603 L
.34394 .01537 L
.36485 .01505 L
.37402 .01493 L
.37887 .01487 L
.38406 .01482 L
.38915 .01478 L
.39156 .01476 L
.39378 .01475 L
.39602 .01474 L
.39717 .01473 L
.39844 .01473 L
.39955 .01472 L
.40058 .01472 L
.40176 .01472 L
.40285 .01472 L
.40401 .01472 L
.40528 .01472 L
.40651 .01472 L
.40783 .01472 L
.40906 .01472 L
.41022 .01472 L
.41126 .01472 L
.41239 .01473 L
.41499 .01474 L
.4163 .01475 L
.41774 .01476 L
.4203 .01478 L
.42267 .01481 L
.42517 .01484 L
.4279 .01488 L
.43286 .01497 L
.43765 .01507 L
.44215 .01518 L
.44697 .01534 L
.45229 .01554 L
.46306 .01604 L
.47287 .01663 L
.48322 .01744 L
.49205 .01834 L
.50171 .01965 L
.50699 .02059 L
.51197 .02175 L
.51645 .0231 L
.5213 .02516 L
.54224 .03453 L
.58313 .04857 L
Mistroke
.6225 .06362 L
.63264 .06738 L
.64227 .07058 L
.64681 .07195 L
.65165 .07323 L
.65622 .07414 L
.65837 .0745 L
.65932 .07466 L
.66035 .07481 L
.66147 .07491 L
.66265 .075 L
.66394 .07514 L
.66514 .0901 L
.66628 .09089 L
.66731 .09113 L
.66851 .09154 L
.66964 .09214 L
.67491 .09489 L
.67602 .09544 L
.67722 .096 L
.67854 .09718 L
.67978 .09779 L
.68101 .09891 L
.68231 .0998 L
.68463 .10197 L
.68978 .10662 L
.69272 .10976 L
.69548 .11227 L
.69679 .11319 L
.69751 .11372 L
.69818 .11436 L
.69936 .1149 L
.70066 .11568 L
.70182 .14663 L
.70287 .15301 L
.70409 .15382 L
.70525 .15477 L
.71022 .16019 L
.72042 .17196 L
.73879 .18965 L
.77706 .22923 L
.81777 .27582 L
.85698 .31967 L
.89863 .38525 L
.91955 .42197 L
.92872 .44218 L
.93357 .45016 L
.93877 .46072 L
.9437 .47495 L
.9482 .49319 L
Mistroke
.95698 .53442 L
.97619 .60332 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[TextData["-Graphics-"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[q4final[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 88.5047 0.80802 0.320115 [
[.20082 .15529 -15 -9 ]
[.20082 .15529 15 0 ]
[.37783 .15529 -15 -9 ]
[.37783 .15529 15 0 ]
[.55484 .15529 -15 -9 ]
[.55484 .15529 15 0 ]
[.73185 .15529 -15 -9 ]
[.73185 .15529 15 0 ]
[.90886 .15529 -12 -9 ]
[.90886 .15529 12 0 ]
[.01131 .00773 -24 -4.5 ]
[.01131 .00773 0 4.5 ]
[.01131 .08776 -30 -4.5 ]
[.01131 .08776 0 4.5 ]
[.01131 .24782 -30 -4.5 ]
[.01131 .24782 0 4.5 ]
[.01131 .32785 -24 -4.5 ]
[.01131 .32785 0 4.5 ]
[.01131 .40788 -30 -4.5 ]
[.01131 .40788 0 4.5 ]
[.01131 .48791 -12 -4.5 ]
[.01131 .48791 0 4.5 ]
[.01131 .56793 -30 -4.5 ]
[.01131 .56793 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20082 .16779 m
.20082 .17404 L
s
[(0.002)] .20082 .15529 0 1 Mshowa
.37783 .16779 m
.37783 .17404 L
s
[(0.004)] .37783 .15529 0 1 Mshowa
.55484 .16779 m
.55484 .17404 L
s
[(0.006)] .55484 .15529 0 1 Mshowa
.73185 .16779 m
.73185 .17404 L
s
[(0.008)] .73185 .15529 0 1 Mshowa
.90886 .16779 m
.90886 .17404 L
s
[(0.01)] .90886 .15529 0 1 Mshowa
.125 Mabswid
.06806 .16779 m
.06806 .17154 L
s
.11231 .16779 m
.11231 .17154 L
s
.15657 .16779 m
.15657 .17154 L
s
.24507 .16779 m
.24507 .17154 L
s
.28932 .16779 m
.28932 .17154 L
s
.33358 .16779 m
.33358 .17154 L
s
.42208 .16779 m
.42208 .17154 L
s
.46633 .16779 m
.46633 .17154 L
s
.51059 .16779 m
.51059 .17154 L
s
.59909 .16779 m
.59909 .17154 L
s
.64334 .16779 m
.64334 .17154 L
s
.68759 .16779 m
.68759 .17154 L
s
.7761 .16779 m
.7761 .17154 L
s
.82035 .16779 m
.82035 .17154 L
s
.8646 .16779 m
.8646 .17154 L
s
.95311 .16779 m
.95311 .17154 L
s
.99736 .16779 m
.99736 .17154 L
s
.25 Mabswid
0 .16779 m
1 .16779 L
s
.02381 .00773 m
.03006 .00773 L
s
[(-2.5)] .01131 .00773 1 0 Mshowa
.02381 .08776 m
.03006 .08776 L
s
[(-2.25)] .01131 .08776 1 0 Mshowa
.02381 .24782 m
.03006 .24782 L
s
[(-1.75)] .01131 .24782 1 0 Mshowa
.02381 .32785 m
.03006 .32785 L
s
[(-1.5)] .01131 .32785 1 0 Mshowa
.02381 .40788 m
.03006 .40788 L
s
[(-1.25)] .01131 .40788 1 0 Mshowa
.02381 .48791 m
.03006 .48791 L
s
[(-1)] .01131 .48791 1 0 Mshowa
.02381 .56793 m
.03006 .56793 L
s
[(-0.75)] .01131 .56793 1 0 Mshowa
.125 Mabswid
.02381 .02374 m
.02756 .02374 L
s
.02381 .03974 m
.02756 .03974 L
s
.02381 .05575 m
.02756 .05575 L
s
.02381 .07176 m
.02756 .07176 L
s
.02381 .10377 m
.02756 .10377 L
s
.02381 .11977 m
.02756 .11977 L
s
.02381 .13578 m
.02756 .13578 L
s
.02381 .15178 m
.02756 .15178 L
s
.02381 .1838 m
.02756 .1838 L
s
.02381 .1998 m
.02756 .1998 L
s
.02381 .21581 m
.02756 .21581 L
s
.02381 .23181 m
.02756 .23181 L
s
.02381 .26382 m
.02756 .26382 L
s
.02381 .27983 m
.02756 .27983 L
s
.02381 .29584 m
.02756 .29584 L
s
.02381 .31184 m
.02756 .31184 L
s
.02381 .34385 m
.02756 .34385 L
s
.02381 .35986 m
.02756 .35986 L
s
.02381 .37586 m
.02756 .37586 L
s
.02381 .39187 m
.02756 .39187 L
s
.02381 .42388 m
.02756 .42388 L
s
.02381 .43989 m
.02756 .43989 L
s
.02381 .45589 m
.02756 .45589 L
s
.02381 .4719 m
.02756 .4719 L
s
.02381 .50391 m
.02756 .50391 L
s
.02381 .51992 m
.02756 .51992 L
s
.02381 .53592 m
.02756 .53592 L
s
.02381 .55193 m
.02756 .55193 L
s
.02381 .58394 m
.02756 .58394 L
s
.02381 .59995 m
.02756 .59995 L
s
.02381 .61595 m
.02756 .61595 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .09295 m
.02499 .09295 L
.02605 .09295 L
.02729 .09295 L
.02846 .09295 L
.02954 .09295 L
.03053 .09295 L
.03163 .09295 L
.03279 .09295 L
.03395 .09295 L
.0352 .09295 L
.03638 .09295 L
.03746 .09295 L
.03873 .09295 L
.03944 .09295 L
.04011 .09295 L
.04262 .09295 L
.04521 .09295 L
.04648 .09295 L
.04765 .09295 L
.04872 .09295 L
.04984 .09295 L
.05221 .09295 L
.05343 .09295 L
.05474 .09295 L
.05597 .09295 L
.05709 .09295 L
.05841 .09295 L
.05984 .09294 L
.06244 .09294 L
.06749 .09294 L
.07306 .09293 L
.07586 .09292 L
.07743 .09292 L
.07887 .09291 L
.08433 .0929 L
.08904 .09288 L
.09419 .09285 L
.10458 .09278 L
.10986 .09273 L
.11485 .09268 L
.11933 .09262 L
.12419 .09254 L
.13417 .09236 L
.14514 .09209 L
.15541 .09176 L
.16502 .09137 L
.17581 .09084 L
.18606 .09019 L
.20635 .08855 L
Mistroke
.22488 .08651 L
.24473 .0837 L
.26313 .08029 L
.30231 .07051 L
.34394 .056 L
.38406 .03926 L
.40248 .03185 L
.42267 .02464 L
.43231 .02189 L
.43762 .02064 L
.44264 .01957 L
.44835 .01869 L
.45355 .01799 L
.45843 .0175 L
.45976 .01741 L
.46049 .01735 L
.46118 .01729 L
.46239 .01724 L
.46372 .01716 L
.4649 .01711 L
.46616 .01707 L
.46725 .01703 L
.46843 .017 L
.46916 .01698 L
.46982 .01698 L
.47113 .01696 L
.47232 .01696 L
.47358 .01696 L
.47481 .01697 L
.47613 .01699 L
.47728 .01701 L
.47852 .01703 L
.47927 .01705 L
.47998 .01708 L
.48136 .01712 L
.48394 .01722 L
.49285 .01764 L
.49529 .01774 L
.49594 .01777 L
.49662 .0178 L
.49786 .01782 L
.49899 .01784 L
.50006 .01786 L
.50132 .01786 L
.50246 .01785 L
.50363 .01781 L
.50486 .01777 L
.50591 .01772 L
.50707 .01761 L
.50831 .01748 L
Mistroke
.50948 .01737 L
.51013 .01724 L
.51083 .01709 L
.51207 .01693 L
.51324 .01664 L
.51449 .01632 L
.51674 .01575 L
.51784 .01536 L
.51901 .01514 L
.52009 .01495 L
.5211 .01479 L
.52238 .01472 L
.52305 .01477 L
.52378 .01483 L
.52455 .01495 L
.52529 .01521 L
.52595 .01557 L
.52667 .016 L
.53191 .02035 L
.53437 .02286 L
.53699 .02633 L
.5417 .03441 L
.57947 .11741 L
.59883 .17566 L
.61969 .26017 L
.63974 .37134 L
.64983 .44791 L
.6555 .49551 L
.65828 .52478 L
.66085 .55414 L
.66209 .57752 L
.66325 .59098 L
.66446 .60332 L
.6651 .55986 L
.66579 .55375 L
.66647 .53951 L
.66722 .52495 L
.66858 .50625 L
.66991 .49242 L
.67113 .48268 L
.67226 .47181 L
.67347 .46652 L
.67453 .46228 L
.67566 .45694 L
.67698 .45325 L
.67819 .45111 L
.67928 .44909 L
.68047 .4483 L
.68115 .44806 L
.68188 .44813 L
Mistroke
.68258 .44821 L
.68322 .44862 L
.68443 .44975 L
.68571 .45198 L
.68638 .45357 L
.68709 .45455 L
.68838 .45871 L
.68979 .46363 L
.69053 .46585 L
.69132 .46995 L
.69206 .47518 L
.69272 .48116 L
.69403 .48805 L
.69466 .49616 L
.69535 .50547 L
.6966 .51606 L
.69782 .53876 L
.69912 .56016 L
.70032 .58353 L
.70143 .59466 L
.70265 .5777 L
.70329 .57268 L
.70397 .5655 L
.70638 .54577 L
.7109 .51523 L
.72106 .46329 L
.73939 .36368 L
.74875 .31064 L
.75367 .28171 L
.75885 .25043 L
.7634 .22836 L
.76465 .22335 L
.76598 .21881 L
.76714 .21643 L
.76838 .21299 L
.76961 .21195 L
.77074 .21137 L
.77182 .21152 L
.77296 .21235 L
.77399 .21346 L
.77495 .2149 L
.776 .21664 L
.77713 .22001 L
.77967 .22541 L
.78107 .22849 L
.78238 .23097 L
.78361 .23289 L
.7843 .23391 L
.78494 .23412 L
.78606 .23528 L
Mistroke
.78725 .23565 L
.78857 .2357 L
.78931 .23562 L
.78998 .23532 L
.79128 .23422 L
.79252 .23303 L
.79322 .23184 L
.79396 .23076 L
.7946 .23038 L
.79529 .22883 L
.79602 .22701 L
.79672 .22499 L
.79829 .22162 L
.80341 .20691 L
.80475 .20157 L
.80551 .19939 L
.80619 .19854 L
.80683 .19698 L
.80753 .19507 L
.80878 .19339 L
.80994 .19155 L
.81117 .19109 L
.81222 .19111 L
.81337 .19212 L
.81463 .19379 L
.81533 .19553 L
.81597 .19639 L
.81721 .20017 L
.81839 .20298 L
.81953 .20786 L
.82075 .21353 L
.82297 .22269 L
.8256 .23742 L
.82686 .24868 L
.82802 .25551 L
.82917 .26488 L
.8304 .28259 L
.83301 .32292 L
.83576 .35518 L
.83827 .37857 L
.8472 .44661 L
.84956 .4642 L
.8521 .48472 L
.85332 .49648 L
.85449 .50099 L
.85553 .50378 L
.85668 .50494 L
.85787 .50282 L
.85914 .49941 L
.86033 .48947 L
Mistroke
.86142 .4802 L
.86271 .47122 L
.86344 .46079 L
.8641 .44913 L
.86664 .40457 L
.86782 .38539 L
.86893 .3629 L
.87022 .31388 L
.87139 .29302 L
.87242 .27776 L
.87352 .26357 L
.87472 .25554 L
.87583 .25354 L
.87701 .25407 L
.87812 .2587 L
.87934 .264 L
.88065 .27757 L
.88135 .28203 L
.88199 .29486 L
.88267 .31436 L
.88341 .33629 L
.88463 .35848 L
.88594 .38323 L
.88666 .38999 L
.88732 .40086 L
.88803 .41061 L
.88882 .41853 L
.89014 .42459 L
.89087 .42888 L
.89153 .43125 L
.8928 .43177 L
.8935 .43047 L
.89416 .42754 L
.89661 .41338 L
.89786 .40578 L
.89922 .39696 L
.90049 .39042 L
.90166 .38703 L
.90272 .38395 L
.90388 .38267 L
.9051 .38302 L
.90623 .38493 L
.90687 .38614 L
.90756 .38886 L
.90882 .39289 L
.91004 .40087 L
.91117 .40595 L
.91391 .42203 L
.91459 .42677 L
.91524 .43007 L
Mistroke
.91647 .43312 L
.91744 .43411 L
.91851 .43317 L
.91965 .42681 L
.92071 .41959 L
.92188 .41158 L
.92298 .40046 L
.92425 .38093 L
.9254 .37009 L
.92654 .35757 L
.92761 .34314 L
.92872 .33393 L
.92994 .3278 L
.93118 .3195 L
.93187 .31834 L
.93251 .31655 L
.93372 .31476 L
.93487 .31473 L
.936 .31552 L
.93723 .317 L
.93839 .31796 L
.93945 .31738 L
.94063 .31515 L
.94191 .30453 L
.94256 .29962 L
.94326 .295 L
.94451 .26419 L
.94727 .19972 L
.94793 .18715 L
.94863 .17957 L
.94988 .14602 L
.95099 .12966 L
.95222 .11254 L
.95353 .09649 L
.95476 .09287 L
.9559 .09775 L
.95714 .11014 L
.95831 .12448 L
.95939 .14947 L
.96158 .18983 L
.96363 .2289 L
.9648 .24787 L
.96606 .25173 L
.9672 .2508 L
.96825 .24564 L
.97065 .23544 L
.97185 .23033 L
.97317 .2287 L
.97393 .22875 L
.97463 .22981 L
Mistroke
.97619 .2316 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[TextData["-Graphics-"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[xfinal[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 88.5047 0.127316 0.00886175 [
[.20082 .11482 -15 -9 ]
[.20082 .11482 15 0 ]
[.37783 .11482 -15 -9 ]
[.37783 .11482 15 0 ]
[.55484 .11482 -15 -9 ]
[.55484 .11482 15 0 ]
[.73185 .11482 -15 -9 ]
[.73185 .11482 15 0 ]
[.90886 .11482 -12 -9 ]
[.90886 .11482 12 0 ]
[.01131 .0387 -18 -4.5 ]
[.01131 .0387 0 4.5 ]
[.01131 .21593 -12 -4.5 ]
[.01131 .21593 0 4.5 ]
[.01131 .30455 -12 -4.5 ]
[.01131 .30455 0 4.5 ]
[.01131 .39317 -12 -4.5 ]
[.01131 .39317 0 4.5 ]
[.01131 .48179 -12 -4.5 ]
[.01131 .48179 0 4.5 ]
[.01131 .5704 -12 -4.5 ]
[.01131 .5704 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20082 .12732 m
.20082 .13357 L
s
[(0.002)] .20082 .11482 0 1 Mshowa
.37783 .12732 m
.37783 .13357 L
s
[(0.004)] .37783 .11482 0 1 Mshowa
.55484 .12732 m
.55484 .13357 L
s
[(0.006)] .55484 .11482 0 1 Mshowa
.73185 .12732 m
.73185 .13357 L
s
[(0.008)] .73185 .11482 0 1 Mshowa
.90886 .12732 m
.90886 .13357 L
s
[(0.01)] .90886 .11482 0 1 Mshowa
.125 Mabswid
.06806 .12732 m
.06806 .13107 L
s
.11231 .12732 m
.11231 .13107 L
s
.15657 .12732 m
.15657 .13107 L
s
.24507 .12732 m
.24507 .13107 L
s
.28932 .12732 m
.28932 .13107 L
s
.33358 .12732 m
.33358 .13107 L
s
.42208 .12732 m
.42208 .13107 L
s
.46633 .12732 m
.46633 .13107 L
s
.51059 .12732 m
.51059 .13107 L
s
.59909 .12732 m
.59909 .13107 L
s
.64334 .12732 m
.64334 .13107 L
s
.68759 .12732 m
.68759 .13107 L
s
.7761 .12732 m
.7761 .13107 L
s
.82035 .12732 m
.82035 .13107 L
s
.8646 .12732 m
.8646 .13107 L
s
.95311 .12732 m
.95311 .13107 L
s
.99736 .12732 m
.99736 .13107 L
s
.25 Mabswid
0 .12732 m
1 .12732 L
s
.02381 .0387 m
.03006 .0387 L
s
[(-10)] .01131 .0387 1 0 Mshowa
.02381 .21593 m
.03006 .21593 L
s
[(10)] .01131 .21593 1 0 Mshowa
.02381 .30455 m
.03006 .30455 L
s
[(20)] .01131 .30455 1 0 Mshowa
.02381 .39317 m
.03006 .39317 L
s
[(30)] .01131 .39317 1 0 Mshowa
.02381 .48179 m
.03006 .48179 L
s
[(40)] .01131 .48179 1 0 Mshowa
.02381 .5704 m
.03006 .5704 L
s
[(50)] .01131 .5704 1 0 Mshowa
.125 Mabswid
.02381 .05642 m
.02756 .05642 L
s
.02381 .07415 m
.02756 .07415 L
s
.02381 .09187 m
.02756 .09187 L
s
.02381 .10959 m
.02756 .10959 L
s
.02381 .14504 m
.02756 .14504 L
s
.02381 .16276 m
.02756 .16276 L
s
.02381 .18049 m
.02756 .18049 L
s
.02381 .19821 m
.02756 .19821 L
s
.02381 .23366 m
.02756 .23366 L
s
.02381 .25138 m
.02756 .25138 L
s
.02381 .2691 m
.02756 .2691 L
s
.02381 .28683 m
.02756 .28683 L
s
.02381 .32227 m
.02756 .32227 L
s
.02381 .34 m
.02756 .34 L
s
.02381 .35772 m
.02756 .35772 L
s
.02381 .37545 m
.02756 .37545 L
s
.02381 .41089 m
.02756 .41089 L
s
.02381 .42862 m
.02756 .42862 L
s
.02381 .44634 m
.02756 .44634 L
s
.02381 .46406 m
.02756 .46406 L
s
.02381 .49951 m
.02756 .49951 L
s
.02381 .51723 m
.02756 .51723 L
s
.02381 .53496 m
.02756 .53496 L
s
.02381 .55268 m
.02756 .55268 L
s
.02381 .02098 m
.02756 .02098 L
s
.02381 .00325 m
.02756 .00325 L
s
.02381 .58813 m
.02756 .58813 L
s
.02381 .60585 m
.02756 .60585 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .18945 m
.02499 .18945 L
.02605 .18945 L
.02729 .18945 L
.02846 .18945 L
.02954 .18945 L
.03053 .18945 L
.03163 .18945 L
.03279 .18945 L
.03395 .18945 L
.0352 .18945 L
.03638 .18945 L
.03746 .18945 L
.03873 .18945 L
.03944 .18945 L
.04011 .18945 L
.04262 .18945 L
.04521 .18945 L
.04648 .18945 L
.04765 .18945 L
.04872 .18945 L
.04984 .18945 L
.05221 .18945 L
.05343 .18944 L
.05474 .18944 L
.05597 .18944 L
.05709 .18944 L
.05841 .18944 L
.05984 .18944 L
.06244 .18944 L
.06749 .18944 L
.07306 .18943 L
.07586 .18943 L
.07743 .18943 L
.07887 .18943 L
.08433 .18942 L
.08904 .18941 L
.09419 .1894 L
.10458 .18936 L
.10986 .18934 L
.11485 .18932 L
.11933 .18929 L
.12419 .18925 L
.13417 .18917 L
.14514 .18904 L
.15541 .18889 L
.16502 .1887 L
.17581 .18846 L
.18606 .18815 L
.20635 .18737 L
Mistroke
.22488 .18639 L
.24473 .18502 L
.26313 .18333 L
.30231 .17826 L
.32376 .17445 L
.34394 .16996 L
.38255 .15884 L
.40213 .15186 L
.4236 .14293 L
.46314 .12081 L
.48269 .1065 L
.50362 .08763 L
.52347 .06715 L
.54503 .04386 L
.55509 .03365 L
.56577 .02495 L
.57488 .01953 L
.57738 .01828 L
.58007 .01721 L
.58262 .01633 L
.58493 .01574 L
.58734 .01528 L
.58857 .01504 L
.58926 .01499 L
.5899 .01491 L
.59106 .01481 L
.59228 .01473 L
.59335 .01472 L
.59453 .01472 L
.59523 .01474 L
.59589 .01478 L
.59714 .01484 L
.59784 .01492 L
.59848 .01502 L
.59995 .0152 L
.60121 .01543 L
.6024 .0156 L
.60364 .01596 L
.6043 .01603 L
.60501 .0162 L
.61037 .0178 L
.61602 .02014 L
.62612 .02473 L
.64606 .03591 L
.65476 .04099 L
.65934 .04385 L
.66185 .04508 L
.66308 .0459 L
.6642 .04636 L
.6654 .09526 L
Mistroke
.66669 .09652 L
.66944 .09996 L
.67427 .10579 L
.68379 .11752 L
.68892 .12348 L
.69452 .1305 L
.69709 .13378 L
.69776 .13432 L
.69849 .13492 L
.69918 .13597 L
.69982 .13707 L
.70107 .13817 L
.7017 .18394 L
.70239 .20391 L
.7036 .20558 L
.70473 .20721 L
.74366 .25685 L
.78504 .31211 L
.8249 .36832 L
.86325 .42471 L
.90405 .48714 L
.94334 .54952 L
.97619 .60332 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003oooooooooo`3ooooo
o`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0
Uoooool3o`0006kooooo000Eooooo`03o`000?oooooooooo09Cooooo1?l000000ooooooo0000o`00
0003o`0006[ooooo000Eooooo`;o0000Toooool2o`0000[ooooo0ol0001Wooooo`005Oooool00ol0
003oooooooooo`2@ooooo`;o00003oooool2o`0006Gooooo0007ooooo`?o00001?ooool2o`0000Go
oooo00?o0000ooooooooool0Soooool00ol0003oooooooooo`0Aooooo`;o0000Hoooool000Sooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo08ko
oooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`1Pooooo`001Ol00003ooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`2=ooooo`03
o`000?oooooooooo01Kooooo0_l0001Pooooo`002?ooool00ol0003oooooooooo`02ooooo`04o`00
0?ooooooooooo`0000Cooooo0ol0002<ooooo`03o`000?oooooooooo01Wooooo00?o0000oooooooo
ool0GOooool000Sooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00004ooooo`03
o`000?oooooooooo08_ooooo00?o0000ooooooooool06oooool2o`0005gooooo0007ooooo`;o0000
1?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo08_ooooo00?o0000oooooooo
ool07?ooool2o`0005cooooo0008ooooo`03o`000?oooooooooo00?ooooo0_l00005ooooo`03o`00
0?oooooooooo08[ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Jooooo`005Ooo
ool00ol0003oooooooooo`29ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0F_oo
ool001Gooooo0_l00029ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0F_ooool0
01Gooooo00?o0000ooooooooool0Qoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
05[ooooo000Eooooo`03o`000?oooooooooo08Kooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`1Jooooo`005Oooool00ol0003oooooooooo`24ooooo`;o00009Oooool00ol0003ooooo
ooooo`1Jooooo`005Oooool00ol0003oooooooooo`23ooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0F_ooool001Gooooo0_l00023ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool0F_ooool001Gooooo00?o0000ooooooooool0POooool00ol0003oooooooooo`0Woooo
o`03o`000?oooooooooo05[ooooo000Eooooo`03o`000?oooooooooo083ooooo00?o0000oooooooo
ool0:?ooool00ol0003oooooooooo`1Jooooo`005Oooool00ol0003oooooooooo`0Pooooo`;o0000
1?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000;ooooo1Ol0000Eooooo`;o0000
1?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000Cooooo0ol0000Dooooo`?o0000
1?ooool00ol0003oooooooooo`03ooooo`;o00001?ooool2o`0000?ooooo0ol0000Aooooo`03o`00
0?oooooooooo00?ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`;o0000
0oooool3o`0001Wooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0_l00003ooooo`?o0000
4?ooool001Gooooo0_l0000Pooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Co
oooo00?o0000ooooooooool04_ooool2o`0000;ooooo00?o0000ooooooooool01_ooool01?l0003o
ooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00002?ooool01?l0003ooooo
ooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0E
ooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000oooool00ol0003ooooo
ooooo`0?ooooo`005Oooool00ol0003oooooooooo`0Oooooo`04o`000?ooooooooooo`0000Sooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo
01Cooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`05o`000?oo
ooooooooo`000?ooool01Ol0000Booooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool0
1_ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00002?oo
ool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0
003oooooooooo`0Eooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`0?ooooo`005Oooool00ol0003oooooooooo`0Oooooo`04o`000?oooooo
ooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00004ooooo`03
o`000?oooooooooo01?ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002
ooooo`06o`000?ooooooooooo`000?oooooo00000_ooool00ol0003oooooooooo`0@ooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool01_ooool01?l0003oooooooooool00002oooo
o`05o`000?ooooooooooo`000?ooool01?l0000Booooo`05o`000?ooooooooooooooool000000_oo
ool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo
00000_ooool3o`0001Sooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00003
ooooo`03o`000?oooooooooo00oooooo000Eooooo`03o`000?oooooooooo01oooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo
00000oooool00ol0003oooooooooo`0Booooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo0000017ooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo
00000_ooool01_l0003oooooooooool0003oooooo`0001Kooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000oooooooooooo
0000ooooool00003ooooo`03o`000?oooooooooo01Gooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo00oooooo000Eooooo`03o`000?oooooo
oooo01oooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`00
0?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Booooo`04o`000?oooooooooo
o`0000Sooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00003ooooo`;o0000
3oooool2o`0000Cooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool00ol0003oooooo`000002
ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooooooool05Oooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo0_l0000Aooooo`005Oooool2o`00027ooooo0_l0000:oooo
o`;o00001?ooool2o`0000?ooooo0ol0000Fooooo`;o00002_ooool2o`0000Cooooo0_l00005oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool01Oooool2o`0000[ooooo0_l00004oooo
o`;o00001?ooool2o`0001Cooooo00?o0000ooooooooool00_l0000:ooooo`;o00001?ooool2o`00
00?ooooo0ol0000Iooooo`;o00002_ooool2o`0000Cooooo00?o0000ooooooooool03oooool001Go
oooo00?o0000ooooooooool0M_ooool2o`0003Oooooo00?o0000ooooooooool0E_ooool001Gooooo
00?o0000ooooooooool0MOooool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo05Gooooo
000Eooooo`03o`000?oooooooooo07?ooooo0_l0000looooo`03o`000?oooooooooo05Cooooo000E
ooooo`03o`000?oooooooooo077ooooo0_l0000oooooo`03o`000?oooooooooo05?ooooo000>oooo
oooo00004ol0000001Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`0:ooooo`;o00002_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool1o`00007ooooo000Eooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0<ooooo`;o0000
7oooool00ol0003oooooooooo`0Tooooo`;o00002?ooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo01Oooooo000Eooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool0Aooo
ool00ol0003oooooooooo`1@ooooo`005Oooool00ol0003oooooooooo`1Yooooo`;o0000B_ooool0
0ol0003oooooooooo`1@ooooo`005Oooool2o`0006Sooooo0_l0001<ooooo`03o`000?oooooooooo
053ooooo000Eooooo`03o`000?oooooooooo06Gooooo0_l0001>ooooo`03o`000?oooooooooo053o
oooo000Eooooo`03o`000?oooooooooo06?ooooo0_l0001@ooooo`03o`000?oooooooooo053ooooo
000Eooooo`03o`000?oooooooooo063ooooo0ol0001Booooo`03o`000?oooooooooo053ooooo000E
ooooo`03o`000?oooooooooo05gooooo0ol0001Eooooo`03o`000?oooooooooo053ooooo000Eoooo
o`;o0000F_ooool4o`0005Sooooo00?o0000ooooooooool0D?ooool001Gooooo00?o0000oooooooo
ool0E_ooool3o`0005cooooo00?o0000ooooooooool0D?ooool001Gooooo00?o0000ooooooooool0
D_ooool4o`0005oooooo00?o0000ooooooooool0D?ooool001Gooooo00?o0000ooooooooool0C?oo
ool6o`0006?ooooo00?o0000ooooooooool0D?ooool001Gooooo00?o0000ooooooooool0A?ooool8
o`0006Wooooo00?o0000ooooooooool0D?ooool001Gooooo0_l0000mooooo`So0000LOooool00ol0
003oooooooooo`1@ooooo`005Oooool00ol0003oooooooooo`0/oooooa3o0000NOooool00ol0003o
ooooooooo`1@ooooo`005Oooool_o`0008Wooooo00?o0000ooooooooool0D?ooool001Gooooo00?o
0000ooooooooool0]Oooool00ol0003oooooooooo`1@ooooo`005Oooool2o`000;Oooooo00?o0000
ooooooooool0Coooool001Gooooo00?o0000ooooooooool0]_ooool00ol0003oooooooooo`1?oooo
o`005Oooool00ol0003oooooooooo`2fooooo`03o`000?oooooooooo04oooooo0007ooooo`?o0000
1?ooool2o`0000Gooooo00?o0000ooooooooool0]_ooool00ol0003oooooooooo`1?ooooo`002?oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0
]_ooool00ol0003oooooooooo`1?ooooo`002?ooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0000Cooooo0ol0002gooooo`03o`000?oooooooooo04kooooo0008ooooo`03o`000?oo
oooooooo00;ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`2hooooo`03o`00
0?oooooooooo04gooooo0008ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000
1?ooool00ol0003oooooooooo`2iooooo`03o`000?oooooooooo04cooooo0007ooooo`;o00001?oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;[ooooo00?o0000ooooooooool0
Boooool000Sooooo00?o0000ooooooooool00oooool2o`0000Gooooo00?o0000ooooooooool0^ooo
ool00ol0003oooooooooo`1:ooooo`005Oooool2o`000;gooooo00?o0000ooooooooool0BOooool0
01Gooooo00?o0000ooooooooool0_?ooool00ol0003oooooooooo`19ooooo`005Oooool00ol0003o
ooooooooo`2mooooo`03o`000?oooooooooo04Sooooo000Eooooo`03o`000?oooooooooo0;kooooo
00?o0000ooooooooool0Aoooool001Gooooo00?o0000ooooooooool0_oooool00ol0003ooooooooo
o`16ooooo`005Oooool2o`000<7ooooo00?o0000ooooooooool0AOooool001Gooooo00?o0000oooo
ooooool0`Oooool00ol0003oooooooooo`14ooooo`005Oooool00ol0003oooooooooo`31ooooo`03
o`000?oooooooooo04Cooooo000Eooooo`03o`000?oooooooooo0<;ooooo00?o0000ooooooooool0
@oooool001Gooooo00?o0000ooooooooool0`oooool00ol0003oooooooooo`12ooooo`005Oooool2
o`000<Gooooo00?o0000ooooooooool0@Oooool001Gooooo00?o0000ooooooooool0a?ooool00ol0
003oooooooooo`11ooooo`005Oooool00ol0003oooooooooo`35ooooo`03o`000?oooooooooo043o
oooo000Eooooo`03o`000?oooooooooo0<Kooooo00?o0000ooooooooool0?oooool001Gooooo0_l0
0038ooooo`03o`000?oooooooooo03kooooo000Eooooo`03o`000?oooooooooo0<Oooooo00?o0000
ooooooooool0?_ooool001Gooooo00?o0000ooooooooool0b?ooool00ol0003oooooooooo`0moooo
o`001_ooool5o`0000?ooooo0_l00005ooooo`03o`000?oooooooooo0<Wooooo00?o0000oooooooo
ool0??ooool000Oooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00004oooo
o`03o`000?oooooooooo0<Wooooo00?o0000ooooooooool0??ooool000Sooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00004ooooo`?o0000b_ooool00ol0003oooooooooo`0koooo
o`002Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`3;ooooo`03o`000?oooooooooo03[ooooo0006ooooo`05o`000?oooooooooooooo
ool000000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0<cooooo00?o0000
ooooooooool0>Oooool000Kooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`0iooooo`001oooool3
o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0>?ooool0
01Gooooo0_l0003?ooooo`03o`000?oooooooooo03Oooooo000Eooooo`03o`000?oooooooooo0<ko
oooo00?o0000ooooooooool0=oooool001Gooooo00?o0000ooooooooool0coooool00ol0003ooooo
ooooo`0fooooo`005Oooool00ol0003oooooooooo`3@ooooo`03o`000?oooooooooo03Gooooo000E
ooooo`03o`000?oooooooooo0=3ooooo00?o0000ooooooooool0=Oooool001Gooooo0_l0003Boooo
o`03o`000?oooooooooo03Cooooo000Eooooo`03o`000?oooooooooo0=;ooooo00?o0000oooooooo
ool0<oooool001Gooooo00?o0000ooooooooool0doooool00ol0003oooooooooo`0booooo`005Ooo
ool00ol0003oooooooooo`3Cooooo`03o`000?oooooooooo03;ooooo000Eooooo`03o`000?oooooo
oooo0=Cooooo00?o0000ooooooooool0<Oooool001Gooooo0_l0003Fooooo`03o`000?oooooooooo
033ooooo000Eooooo`03o`000?oooooooooo0=Gooooo00?o0000ooooooooool0<?ooool001Gooooo
00?o0000ooooooooool0e_ooool00ol0003oooooooooo`0_ooooo`005Oooool00ol0003ooooooooo
o`3Gooooo`03o`000?oooooooooo02kooooo000Eooooo`03o`000?oooooooooo0=Oooooo00?o0000
ooooooooool0;_ooool001Gooooo0_l0003Iooooo`03o`000?oooooooooo02gooooo000Eooooo`03
o`000?oooooooooo0=Wooooo00?o0000ooooooooool0;?ooool000Oooooo0ol00004ooooo`;o0000
1Oooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo02cooooo0006ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0=[o
oooo00?o0000ooooooooool0:oooool000[ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`02ooooo`?o0000foooool00ol0003oooooooooo`0Zooooo`002?ooool2o`0000?ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo02[o
oooo000:ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`3Looooo`03o`000?oooooooooo02Wooooo0006ooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0=gooooo00?o0000oooo
ooooool0:?ooool000Oooooo0ol00004ooooo`;o00001Oooool00ol0003oooooooooo`3Mooooo`03
o`000?oooooooooo02Sooooo000Eooooo`;o0000goooool00ol0003oooooooooo`0Wooooo`005Ooo
ool00ol0003oooooooooo`3Oooooo`03o`000?oooooooooo02Kooooo000Eooooo`03o`000?oooooo
oooo0=oooooo00?o0000ooooooooool09_ooool001Gooooo00?o0000ooooooooool0h?ooool00ol0
003oooooooooo`0Uooooo`005Oooool00ol0003oooooooooo`3Qooooo`03o`000?oooooooooo02Co
oooo000Eooooo`;o0000h_ooool00ol0003oooooooooo`0Tooooo`005Oooool00ol0003ooooooooo
o`3Rooooo`03o`000?oooooooooo02?ooooo000Eooooo`03o`000?oooooooooo0>?ooooo00?o0000
ooooooooool08_ooool001Gooooo00?o0000ooooooooool0hoooool00ol0003oooooooooo`0Roooo
o`005Oooool00ol0003oooooooooo`3Tooooo`03o`000?oooooooooo027ooooo000Eooooo`;o0000
i_ooool00ol0003oooooooooo`0Pooooo`005Oooool00ol0003oooooooooo`3Uooooo`03o`000?oo
oooooooo023ooooo000Eooooo`03o`000?oooooooooo0>Kooooo00?o0000ooooooooool07oooool0
01Gooooo00?o0000ooooooooool0ioooool00ol0003oooooooooo`0Nooooo`005Oooool00ol0003o
ooooooooo`3Wooooo`03o`000?oooooooooo01kooooo000Eooooo`;o0000jOooool00ol0003ooooo
ooooo`0Mooooo`005Oooool00ol0003oooooooooo`3Xooooo`03o`000?oooooooooo01gooooo0008
ooooo`?o00000oooool2o`0000Gooooo00?o0000ooooooooool0jOooool00ol0003oooooooooo`0L
ooooo`002Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`3Zooooo`03o`000?oooooooooo01_ooooo0006ooooo`Go00000_ooool01?l0
003oooooooooool00004ooooo`03o`000?oooooooooo0>[ooooo00?o0000ooooooooool06oooool0
00Kooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool00004ooooo`?o0000jooo
ool00ol0003oooooooooo`0Jooooo`001oooool00ol0003oooooo`000003ooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool0k?ooool00ol0003oooooooooo`0Iooooo`002?ooool2
o`0000?ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3/ooooo`03o`000?oo
oooooooo01Wooooo0009ooooo`03o`000?oooooooooo00;ooooo0_l00005ooooo`03o`000?oooooo
oooo0>gooooo00?o0000ooooooooool06?ooool001Gooooo0_l0003_ooooo`03o`000?oooooooooo
01Oooooo000Eooooo`03o`000?oooooooooo0>kooooo00?o0000ooooooooool05oooool001Gooooo
00?o0000ooooooooool0koooool00ol0003oooooooooo`0Fooooo`005Oooool00ol0003ooooooooo
o`3`ooooo`03o`000?oooooooooo01Gooooo000Eooooo`03o`000?oooooooooo0?3ooooo00?o0000
ooooooooool05Oooool001Gooooo0_l0003booooo`03o`000?oooooooooo01Cooooo000Eooooo`03
o`000?oooooooooo0?;ooooo00?o0000ooooooooool04oooool001Gooooo00?o0000ooooooooool0
l_ooool00ol0003oooooooooo`0Cooooo`005Oooool00ol0003oooooooooo`3cooooo`03o`000?oo
oooooooo01;ooooo000Eooooo`03o`000?oooooooooo0??ooooo00?o0000ooooooooool04_ooool0
01Gooooo0_l0003eooooo`03o`000?oooooooooo017ooooo000Eooooo`03o`000?oooooooooo0?Go
oooo00?o0000ooooooooool04?ooool001Gooooo00?o0000ooooooooool0mOooool00ol0003ooooo
ooooo`0@ooooo`005Oooool00ol0003oooooooooo`3fooooo`03o`000?oooooooooo00oooooo000E
ooooo`03o`000?oooooooooo0?Oooooo00?o0000ooooooooool03_ooool001Gooooo0_l0003hoooo
o`03o`000?oooooooooo00kooooo000Eooooo`03o`000?oooooooooo0?Sooooo00?o0000oooooooo
ool03Oooool000Oooooo0ol00004ooooo`;o00001Oooool00ol0003oooooooooo`3iooooo`03o`00
0?oooooooooo00cooooo0006ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00004ooooo`03o`000?oooooooooo0?Wooooo00?o0000ooooooooool03?ooool000[ooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo0?[o
oooo00?o0000ooooooooool02oooool000[ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`02ooooo`?o0000n_ooool00ol0003oooooooooo`0;ooooo`001_ooool4o`0000?ooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3kooooo`03o`000?oooooooooo00[o
oooo0006ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00001?ooool00ol0003o
ooooooooo`3looooo`03o`000?oooooooooo00Wooooo0006ooooo`Go00000oooool2o`0000Gooooo
00?o0000ooooooooool0o?ooool00ol0003oooooooooo`09ooooo`005Oooool2o`000?kooooo00?o
0000ooooooooool02?ooool001Gooooo00?o0000ooooooooool0oOooool00ol0003oooooooooo`08
ooooo`005Oooool00ol0003oooooooooo`3nooooo`03o`000?oooooooooo00Oooooo000Eooooo`03
o`000?oooooooooo0?oooooo00?o0000ooooooooool01_ooool001Gooooo00?o0000ooooooooool0
ooooool00ol0003oooooooooo`06ooooo`005Oooool2o`000?oooooo0_ooool00ol0003ooooooooo
o`05ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo
0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003ooooo
ooooo`3oooooo`Wooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176, 0}} -> {-0.000888798, -15.9948, \
4.15285*^-5, 0.414756}}],

Cell[TextData["-Graphics-"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[yfinal[t], {t, 0, tf}, PlotRange \[Rule] All]\)], "Input"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 88.5047 0.0178055 0.0150072 [
[.20082 .00531 -15 -9 ]
[.20082 .00531 15 0 ]
[.37783 .00531 -15 -9 ]
[.37783 .00531 15 0 ]
[.55484 .00531 -15 -9 ]
[.55484 .00531 15 0 ]
[.73185 .00531 -15 -9 ]
[.73185 .00531 15 0 ]
[.90886 .00531 -12 -9 ]
[.90886 .00531 12 0 ]
[.01131 .16788 -12 -4.5 ]
[.01131 .16788 0 4.5 ]
[.01131 .31795 -12 -4.5 ]
[.01131 .31795 0 4.5 ]
[.01131 .46802 -12 -4.5 ]
[.01131 .46802 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20082 .01781 m
.20082 .02406 L
s
[(0.002)] .20082 .00531 0 1 Mshowa
.37783 .01781 m
.37783 .02406 L
s
[(0.004)] .37783 .00531 0 1 Mshowa
.55484 .01781 m
.55484 .02406 L
s
[(0.006)] .55484 .00531 0 1 Mshowa
.73185 .01781 m
.73185 .02406 L
s
[(0.008)] .73185 .00531 0 1 Mshowa
.90886 .01781 m
.90886 .02406 L
s
[(0.01)] .90886 .00531 0 1 Mshowa
.125 Mabswid
.06806 .01781 m
.06806 .02156 L
s
.11231 .01781 m
.11231 .02156 L
s
.15657 .01781 m
.15657 .02156 L
s
.24507 .01781 m
.24507 .02156 L
s
.28932 .01781 m
.28932 .02156 L
s
.33358 .01781 m
.33358 .02156 L
s
.42208 .01781 m
.42208 .02156 L
s
.46633 .01781 m
.46633 .02156 L
s
.51059 .01781 m
.51059 .02156 L
s
.59909 .01781 m
.59909 .02156 L
s
.64334 .01781 m
.64334 .02156 L
s
.68759 .01781 m
.68759 .02156 L
s
.7761 .01781 m
.7761 .02156 L
s
.82035 .01781 m
.82035 .02156 L
s
.8646 .01781 m
.8646 .02156 L
s
.95311 .01781 m
.95311 .02156 L
s
.99736 .01781 m
.99736 .02156 L
s
.25 Mabswid
0 .01781 m
1 .01781 L
s
.02381 .16788 m
.03006 .16788 L
s
[(10)] .01131 .16788 1 0 Mshowa
.02381 .31795 m
.03006 .31795 L
s
[(20)] .01131 .31795 1 0 Mshowa
.02381 .46802 m
.03006 .46802 L
s
[(30)] .01131 .46802 1 0 Mshowa
.125 Mabswid
.02381 .04782 m
.02756 .04782 L
s
.02381 .07783 m
.02756 .07783 L
s
.02381 .10785 m
.02756 .10785 L
s
.02381 .13786 m
.02756 .13786 L
s
.02381 .19789 m
.02756 .19789 L
s
.02381 .22791 m
.02756 .22791 L
s
.02381 .25792 m
.02756 .25792 L
s
.02381 .28794 m
.02756 .28794 L
s
.02381 .34796 m
.02756 .34796 L
s
.02381 .37798 m
.02756 .37798 L
s
.02381 .40799 m
.02756 .40799 L
s
.02381 .43801 m
.02756 .43801 L
s
.02381 .49804 m
.02756 .49804 L
s
.02381 .52805 m
.02756 .52805 L
s
.02381 .55806 m
.02756 .55806 L
s
.02381 .58808 m
.02756 .58808 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
.5 Mabswid
.02381 .02531 m
.06244 .02531 L
.10458 .02531 L
.14415 .02531 L
.18221 .02531 L
.22272 .02531 L
.26171 .02531 L
.30316 .02531 L
.34309 .02531 L
.3815 .02531 L
.40095 .02531 L
.41127 .02531 L
.41696 .02531 L
.41976 .02531 L
.42113 .02531 L
.42237 .02531 L
.42363 .02531 L
.42482 .02531 L
.42608 .02531 L
.42679 .02531 L
.42744 .02531 L
.42872 .02531 L
.42945 .02531 L
.43013 .02532 L
.43084 .02532 L
.4315 .02532 L
.43227 .02532 L
.43298 .02533 L
.43414 .02533 L
.43523 .02534 L
.43637 .02535 L
.43763 .02536 L
.43889 .02538 L
.44025 .0254 L
.44152 .02542 L
.44268 .02544 L
.44388 .02546 L
.44501 .02549 L
.44631 .02554 L
.44749 .02556 L
.4486 .02561 L
.44963 .02566 L
.45074 .0257 L
.45195 .02574 L
.45312 .02582 L
.45422 .02589 L
.45662 .02604 L
.45926 .02624 L
.46055 .02636 L
.46172 .02645 L
Mistroke
.46296 .02663 L
.46413 .02673 L
.46536 .02687 L
.46606 .02695 L
.4667 .02707 L
.47212 .02794 L
.47693 .02898 L
.482 .03035 L
.48658 .03198 L
.49085 .03385 L
.49589 .0368 L
.50054 .03987 L
.50556 .04454 L
.51102 .05055 L
.52093 .06586 L
.5395 .09939 L
.5582 .14091 L
.57882 .20285 L
.61908 .34371 L
.65781 .47735 L
.66017 .48493 L
.66141 .48935 L
.66272 .49299 L
.66386 .49844 L
.66512 .55704 L
.66627 .56105 L
.66734 .56185 L
.67267 .56656 L
.6775 .57088 L
.68865 .57916 L
.69901 .58624 L
.70018 .58677 L
.70129 .58933 L
.70244 .60332 L
.70371 .60332 L
.70499 .6033 L
.70571 .60328 L
.70637 .60325 L
.70765 .60321 L
.70883 .60314 L
.70988 .60305 L
.711 .60296 L
.71337 .60272 L
.71815 .60202 L
.72104 .60152 L
.72377 .60093 L
.72889 .5995 L
.73868 .59597 L
.74839 .59121 L
.75867 .58457 L
Mistroke
.77712 .56939 L
.79667 .54754 L
.81497 .52239 L
.85376 .44861 L
.89501 .3377 L
.93474 .19729 L
.97295 .02787 L
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00=Oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00002oooo
o`Go00005Oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00004oooo
o`?o00005Oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003oooo
o`?o00005oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000Cooooo0_l00003oooo
o`?o00006Oooool2o`0000Cooooo00?o0000ooooooooool00oooool2o`0000?ooooo0ol0000Coooo
o`00=?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool0000Dooooo`04o`000?ooooooooooo`0000So
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooo
oooo01?ooooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`00
0?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Cooooo`04o`000?oooooooooo
o`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003oooooooooool0003oooooo`0000?o
oooo00?o0000ooooooooool05Oooool01?l0003oooooooooool00008ooooo`04o`000?oooooooooo
o`0000?ooooo00?o0000ooooooooool04_ooool003Cooooo00Co0000oooooooooooo00002?ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool0
5?ooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooo
oooooooo0000ooooo`05o`0001Cooooo00Co0000oooooooooooo00002?ooool01?l0003ooooooooo
ool00002ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooooooo`0Coooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooooooool05Oooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool04_ooool003Cooooo00Co0000oooo
oooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool04oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`00
00;ooooo00Ko0000oooooooooooo0000ooooool00002ooooo`03o`000?oooooooooo01?ooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`05o`000?ooooooooooo`00
0?ooool01?l0000Fooooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool00002ooooo`?o00006?ooool01?l0003oooooooooool00008ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool04_ooool003Cooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oooooo0000
0oooool00ol0003oooooooooo`0Booooo`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000001Gooooo00Co0000
oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`06o`000?ooooooooooo`000?oo
oooo00006Oooool01?l0003oooooooooool00008ooooo`04o`000?ooooooooooo`0000;ooooo00Ko
0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01Gooooo00Co0000oooooooo
oooo00002?ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo01;ooooo000doooo
o`04o`000?ooooooooooo`0000Sooooo00Co0000oooooooooooo00000_ooool01_l0003ooooooooo
ool0003oooooo`0000?ooooo00?o0000ooooooooool04_ooool01?l0003oooooooooool00008oooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000oooool2o`0001Gooooo00Co
0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool05_ooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000;ooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oooooooooo01Go
oooo00Co0000oooooooooooo00002?ooool01?l0003oooooooooool00002ooooo`;o00005?ooool0
03Gooooo0_l0000:ooooo`;o00001?ooool2o`0000?ooooo0ol0000Fooooo`;o00002_ooool2o`00
00Cooooo0_l00005ooooo`03o`000?oooooooooo01Cooooo0_l0000:ooooo`;o00001?ooool2o`00
00Cooooo0_l0000Gooooo`;o00002_ooool2o`0000Cooooo0_l00003ooooo`?o00006Oooool2o`00
00[ooooo0_l00004ooooo`03o`000?oooooooooo01;ooooo000Booooo`03o`000?oooooooooo0?oo
oooo3?ooool001;ooooo00?o0000ooooooooool0ooooool<ooooo`004_ooool00ol0003ooooooooo
o`3oooooo`cooooo000Booooo`03o`000?oooooooooo0?oooooo3?ooool001;ooooo00?o0000oooo
ooooool0ooooool1ooooo`03o`000?oooooooooo00Sooooo000;oooooooo00004ol00003ooooo`00
4_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0_ooool001;oooooN_l0000Fooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Wooooo000Booooo`03o`000?oooooo
oooo07Oooooo1?l00024ooooo`03o`000?oooooooooo00Wooooo000Booooo`03o`000?oooooooooo
07_ooooo0_l00022ooooo`03o`000?oooooooooo00Wooooo000Booooo`03o`000?oooooooooo07go
oooo0_l00020ooooo`03o`000?oooooooooo00Wooooo000Booooo`03o`000?oooooooooo07oooooo
00?o0000ooooooooool0O?ooool00ol0003oooooooooo`0:ooooo`004_ooool00ol0003ooooooooo
o`20ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool02_ooool001;ooooo0_l00021
ooooo`03o`000?oooooooooo07_ooooo00?o0000ooooooooool02_ooool001;ooooo00?o0000oooo
ooooool0POooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo00[ooooo000Booooo`03
o`000?oooooooooo087ooooo00?o0000ooooooooool0N_ooool00ol0003oooooooooo`0:ooooo`00
4_ooool00ol0003oooooooooo`22ooooo`03o`000?oooooooooo07Sooooo00?o0000ooooooooool0
2oooool001;ooooo00?o0000ooooooooool0Poooool00ol0003oooooooooo`1gooooo`03o`000?oo
oooooooo00_ooooo000Booooo`03o`000?oooooooooo08Cooooo00?o0000ooooooooool0M_ooool0
0ol0003oooooooooo`0;ooooo`004_ooool00ol0003oooooooooo`24ooooo`03o`000?oooooooooo
07Kooooo00?o0000ooooooooool02oooool001;ooooo00?o0000ooooooooool0QOooool00ol0003o
ooooooooo`1dooooo`03o`000?oooooooooo00cooooo000Booooo`;o0000Q_ooool00ol0003ooooo
ooooo`1dooooo`03o`000?oooooooooo00cooooo000Booooo`03o`000?oooooooooo08Kooooo00?o
0000ooooooooool0Loooool00ol0003oooooooooo`0<ooooo`004_ooool00ol0003oooooooooo`27
ooooo`03o`000?oooooooooo07;ooooo00?o0000ooooooooool03?ooool001;ooooo00?o0000oooo
ooooool0Qoooool00ol0003oooooooooo`1booooo`03o`000?oooooooooo00cooooo000Booooo`03
o`000?oooooooooo08Sooooo00?o0000ooooooooool0L?ooool00ol0003oooooooooo`0=ooooo`00
4_ooool00ol0003oooooooooo`28ooooo`03o`000?oooooooooo073ooooo00?o0000ooooooooool0
3Oooool001;ooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`1_ooooo`03o`000?oo
oooooooo00gooooo000Booooo`03o`000?oooooooooo08Wooooo00?o0000ooooooooool0Koooool0
0ol0003oooooooooo`0=ooooo`004_ooool2o`0008_ooooo00?o0000ooooooooool0K_ooool00ol0
003oooooooooo`0=ooooo`004_ooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo06go
oooo00?o0000ooooooooool03_ooool001;ooooo00?o0000ooooooooool0Roooool00ol0003ooooo
ooooo`1/ooooo`03o`000?oooooooooo00kooooo000Booooo`03o`000?oooooooooo08_ooooo00?o
0000ooooooooool0K?ooool00ol0003oooooooooo`0>ooooo`004_ooool00ol0003oooooooooo`2<
ooooo`03o`000?oooooooooo06_ooooo00?o0000ooooooooool03_ooool001;ooooo00?o0000oooo
ooooool0S?ooool00ol0003oooooooooo`1Zooooo`03o`000?oooooooooo00oooooo000Booooo`03
o`000?oooooooooo08cooooo00?o0000ooooooooool0J_ooool00ol0003oooooooooo`0?ooooo`00
4_ooool00ol0003oooooooooo`2=ooooo`03o`000?oooooooooo06Wooooo00?o0000ooooooooool0
3oooool001;ooooo00?o0000ooooooooool0SOooool00ol0003oooooooooo`1Yooooo`03o`000?oo
oooooooo00oooooo000Booooo`;o0000Soooool00ol0003oooooooooo`1Xooooo`03o`000?oooooo
oooo00oooooo000Booooo`03o`000?oooooooooo08kooooo00?o0000ooooooooool0Ioooool00ol0
003oooooooooo`0@ooooo`004_ooool00ol0003oooooooooo`2?ooooo`03o`000?oooooooooo06Ko
oooo00?o0000ooooooooool04?ooool001;ooooo00?o0000ooooooooool0Soooool00ol0003ooooo
ooooo`1Vooooo`03o`000?oooooooooo013ooooo000Booooo`03o`000?oooooooooo08oooooo00?o
0000ooooooooool0I_ooool00ol0003oooooooooo`0@ooooo`000oooool3o`0000Cooooo0_l00006
ooooo`03o`000?oooooooooo093ooooo00?o0000ooooooooool0I?ooool00ol0003oooooooooo`0A
ooooo`001?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000
ooooooooool0T?ooool00ol0003oooooooooo`1Tooooo`03o`000?oooooooooo017ooooo0004oooo
o`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`2@
ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool04Oooool000Cooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00005ooooo`;o0000T_ooool00ol0003oooooooooo`1S
ooooo`03o`000?oooooooooo017ooooo0004ooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00001Oooool00ol0003oooooooooo`2Aooooo`03o`000?oooooooooo06?ooooo00?o0000
ooooooooool04Oooool000?ooooo0_l00004ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000
ooooooooool0TOooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo01;ooooo0004oooo
o`03o`000?oooooooooo00?ooooo0_l00006ooooo`03o`000?oooooooooo09;ooooo00?o0000oooo
ooooool0HOooool00ol0003oooooooooo`0Booooo`004_ooool00ol0003oooooooooo`2Booooo`03
o`000?oooooooooo067ooooo00?o0000ooooooooool04_ooool001;ooooo00?o0000ooooooooool0
T_ooool00ol0003oooooooooo`1Qooooo`03o`000?oooooooooo01;ooooo000Booooo`03o`000?oo
oooooooo09?ooooo00?o0000ooooooooool0H?ooool00ol0003oooooooooo`0Booooo`004_ooool0
0ol0003oooooooooo`2Cooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool04oooool0
01;ooooo0_l0002Dooooo`03o`000?oooooooooo05oooooo00?o0000ooooooooool04oooool001;o
oooo00?o0000ooooooooool0U?ooool00ol0003oooooooooo`1Nooooo`03o`000?oooooooooo01?o
oooo000Booooo`03o`000?oooooooooo09Cooooo00?o0000ooooooooool0G_ooool00ol0003ooooo
ooooo`0Cooooo`004_ooool00ol0003oooooooooo`2Dooooo`03o`000?oooooooooo05gooooo00?o
0000ooooooooool05?ooool001;ooooo00?o0000ooooooooool0UOooool00ol0003oooooooooo`1L
ooooo`03o`000?oooooooooo01Cooooo000Booooo`03o`000?oooooooooo09Gooooo00?o0000oooo
ooooool0G?ooool00ol0003oooooooooo`0Dooooo`004_ooool00ol0003oooooooooo`2Eooooo`03
o`000?oooooooooo05_ooooo00?o0000ooooooooool05Oooool001;ooooo00?o0000ooooooooool0
U_ooool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo01Gooooo000Booooo`;o0000Uooo
ool00ol0003oooooooooo`1Jooooo`03o`000?oooooooooo01Gooooo000Booooo`03o`000?oooooo
oooo09Kooooo00?o0000ooooooooool0F_ooool00ol0003oooooooooo`0Eooooo`004_ooool00ol0
003oooooooooo`2Fooooo`03o`000?oooooooooo05Wooooo00?o0000ooooooooool05_ooool001;o
oooo00?o0000ooooooooool0Uoooool00ol0003oooooooooo`1Hooooo`03o`000?oooooooooo01Ko
oooo000Booooo`03o`000?oooooooooo09Oooooo00?o0000ooooooooool0F?ooool00ol0003ooooo
ooooo`0Fooooo`004_ooool00ol0003oooooooooo`2Gooooo`03o`000?oooooooooo05Oooooo00?o
0000ooooooooool05oooool001;ooooo00?o0000ooooooooool0V?ooool00ol0003oooooooooo`1F
ooooo`03o`000?oooooooooo01Oooooo000Booooo`03o`000?oooooooooo09Sooooo00?o0000oooo
ooooool0E_ooool00ol0003oooooooooo`0Gooooo`004_ooool2o`0009Wooooo00?o0000oooooooo
ool0E_ooool00ol0003oooooooooo`0Gooooo`004_ooool00ol0003oooooooooo`2Hooooo`03o`00
0?oooooooooo05Gooooo00?o0000ooooooooool06?ooool001;ooooo00?o0000ooooooooool0VOoo
ool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo01Sooooo000Booooo`03o`000?oooooo
oooo09Wooooo00?o0000ooooooooool0E?ooool00ol0003oooooooooo`0Hooooo`004_ooool00ol0
003oooooooooo`2Iooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool06Oooool001;o
oooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo01Wo
oooo000Booooo`03o`000?oooooooooo09[ooooo00?o0000ooooooooool0D_ooool00ol0003ooooo
ooooo`0Iooooo`004_ooool00ol0003oooooooooo`2Jooooo`03o`000?oooooooooo057ooooo00?o
0000ooooooooool06_ooool001;ooooo00?o0000ooooooooool0V_ooool00ol0003oooooooooo`1A
ooooo`03o`000?oooooooooo01[ooooo000Booooo`;o0000W?ooool00ol0003oooooooooo`1@oooo
o`03o`000?oooooooooo01[ooooo000Booooo`03o`000?oooooooooo09_ooooo00?o0000oooooooo
ool0D?ooool00ol0003oooooooooo`0Jooooo`004_ooool00ol0003oooooooooo`2Kooooo`03o`00
0?oooooooooo04oooooo00?o0000ooooooooool06oooool001;ooooo00?o0000ooooooooool0Vooo
ool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo01_ooooo000Booooo`03o`000?oooooo
oooo09cooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`0Kooooo`000_ooool5o`00
00?ooooo0_l00006ooooo`03o`000?oooooooooo09cooooo00?o0000ooooooooool0COooool00ol0
003oooooooooo`0Looooo`000oooool01?l0003oooooooooool00002ooooo`04o`000?oooooooooo
o`0000Gooooo00?o0000ooooooooool0W?ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooo
oooo01cooooo0004ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool0
0ol0003oooooooooo`2Mooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool07?ooool0
00Gooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00?ooooo0_l0002N
ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool07?ooool000;ooooo00Go0000oooo
ooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool0WOoo
ool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo01gooooo0002ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo09gooooo
00?o0000ooooooooool0Boooool00ol0003oooooooooo`0Mooooo`000oooool3o`0000Cooooo0_l0
0006ooooo`03o`000?oooooooooo09kooooo00?o0000ooooooooool0B_ooool00ol0003ooooooooo
o`0Mooooo`004_ooool00ol0003oooooooooo`2Nooooo`03o`000?oooooooooo04Wooooo00?o0000
ooooooooool07_ooool001;ooooo00?o0000ooooooooool0W_ooool00ol0003oooooooooo`19oooo
o`03o`000?oooooooooo01kooooo000Booooo`03o`000?oooooooooo09oooooo00?o0000oooooooo
ool0B?ooool00ol0003oooooooooo`0Nooooo`004_ooool00ol0003oooooooooo`2Oooooo`03o`00
0?oooooooooo04Oooooo00?o0000ooooooooool07oooool001;ooooo0_l0002Pooooo`03o`000?oo
oooooooo04Oooooo00?o0000ooooooooool07oooool001;ooooo00?o0000ooooooooool0Woooool0
0ol0003oooooooooo`17ooooo`03o`000?oooooooooo01oooooo000Booooo`03o`000?oooooooooo
0:3ooooo00?o0000ooooooooool0AOooool00ol0003oooooooooo`0Pooooo`004_ooool00ol0003o
ooooooooo`2Pooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool08?ooool001;ooooo
00?o0000ooooooooool0X?ooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo023ooooo
000Booooo`03o`000?oooooooooo0:7ooooo00?o0000ooooooooool0@oooool00ol0003ooooooooo
o`0Qooooo`004_ooool00ol0003oooooooooo`2Qooooo`03o`000?oooooooooo04?ooooo00?o0000
ooooooooool08Oooool001;ooooo00?o0000ooooooooool0XOooool00ol0003oooooooooo`13oooo
o`03o`000?oooooooooo027ooooo000Booooo`;o0000X_ooool00ol0003oooooooooo`12ooooo`03
o`000?oooooooooo02;ooooo000Booooo`03o`000?oooooooooo0:;ooooo00?o0000ooooooooool0
@Oooool00ol0003oooooooooo`0Rooooo`004_ooool00ol0003oooooooooo`2Rooooo`03o`000?oo
oooooooo043ooooo00?o0000ooooooooool08oooool001;ooooo00?o0000ooooooooool0X_ooool0
0ol0003oooooooooo`10ooooo`03o`000?oooooooooo02?ooooo000Booooo`03o`000?oooooooooo
0:;ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`0Sooooo`004_ooool00ol0003o
ooooooooo`2Sooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool09?ooool001;ooooo
00?o0000ooooooooool0Xoooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo02Cooooo
000Booooo`03o`000?oooooooooo0:?ooooo00?o0000ooooooooool0?_ooool00ol0003ooooooooo
o`0Tooooo`004_ooool2o`000:Gooooo00?o0000ooooooooool0??ooool00ol0003oooooooooo`0U
ooooo`004_ooool00ol0003oooooooooo`2Tooooo`03o`000?oooooooooo03cooooo00?o0000oooo
ooooool09Oooool001;ooooo00?o0000ooooooooool0Y?ooool00ol0003oooooooooo`0kooooo`03
o`000?oooooooooo02Kooooo000Booooo`03o`000?oooooooooo0:Cooooo00?o0000ooooooooool0
>oooool00ol0003oooooooooo`0Vooooo`004_ooool00ol0003oooooooooo`2Uooooo`03o`000?oo
oooooooo03[ooooo00?o0000ooooooooool09_ooool001;ooooo00?o0000ooooooooool0YOooool0
0ol0003oooooooooo`0iooooo`03o`000?oooooooooo02Oooooo000Booooo`03o`000?oooooooooo
0:Gooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`0Wooooo`004_ooool00ol0003o
ooooooooo`2Vooooo`03o`000?oooooooooo03Sooooo00?o0000ooooooooool09oooool001;ooooo
0_l0002Wooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0:?ooool001;ooooo00?o
0000ooooooooool0Y_ooool00ol0003oooooooooo`0gooooo`03o`000?oooooooooo02Sooooo000B
ooooo`03o`000?oooooooooo0:Kooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0X
ooooo`004_ooool00ol0003oooooooooo`2Wooooo`03o`000?oooooooooo03Gooooo00?o0000oooo
ooooool0:Oooool001;ooooo00?o0000ooooooooool0Yoooool00ol0003oooooooooo`0eooooo`03
o`000?oooooooooo02Wooooo000Booooo`03o`000?oooooooooo0:Oooooo00?o0000ooooooooool0
=?ooool00ol0003oooooooooo`0Zooooo`000oooool3o`0000Cooooo0_l00006ooooo`03o`000?oo
oooooooo0:Oooooo00?o0000ooooooooool0=?ooool00ol0003oooooooooo`0Zooooo`000_ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001Oooool00ol0003ooooo
ooooo`2Xooooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0:oooool000Kooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0:Sooooo
00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0[ooooo`001?ooool2o`0000?ooooo00Co
0000oooooooooooo00001Oooool2o`000:Wooooo00?o0000ooooooooool0<Oooool00ol0003ooooo
ooooo`0/ooooo`001_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0ZOooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02gooooo
0002ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00005ooooo`03
o`000?oooooooooo0:Wooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0]ooooo`00
0oooool3o`0000Cooooo0_l00006ooooo`03o`000?oooooooooo0:Wooooo00?o0000ooooooooool0
;_ooool00ol0003oooooooooo`0^ooooo`004_ooool00ol0003oooooooooo`2Zooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;_ooool001;ooooo00?o0000ooooooooool0Z_ooool0
0ol0003oooooooooo`0/ooooo`03o`000?oooooooooo02oooooo000Booooo`03o`000?oooooooooo
0:_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0_ooooo`004_ooool00ol0003o
ooooooooo`2[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0<?ooool001;ooooo
0_l0002/ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0<?ooool001;ooooo00?o
0000ooooooooool0Zoooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo037ooooo000B
ooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool0:?ooool00ol0003oooooooooo`0b
ooooo`004_ooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo02Sooooo00?o0000oooo
ooooool0<_ooool001;ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0Wooooo`03
o`000?oooooooooo03?ooooo000Booooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool0
9oooool00ol0003oooooooooo`0cooooo`004_ooool00ol0003oooooooooo`2[ooooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool0=?ooool001;ooooo00?o0000ooooooooool0Zoooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo03Cooooo000Booooo`;o0000[?ooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo03Gooooo000Booooo`03o`000?oooooooooo0:_o
oooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0fooooo`004_ooool00ol0003ooooo
ooooo`2[ooooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool0=oooool001;ooooo00?o
0000ooooooooool0Zoooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo03Oooooo000B
ooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0h
ooooo`004_ooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0>Oooool001;ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo03Wooooo000Booooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`0jooooo`004_ooool2o`000:cooooo00?o0000ooooooooool07ooo
ool00ol0003oooooooooo`0kooooo`004_ooool00ol0003oooooooooo`2/ooooo`;o00007_ooool0
0ol0003oooooooooo`0looooo`004_ooool00ol0003oooooooooo`2^ooooo`03o`000?oooooooooo
01[ooooo00?o0000ooooooooool0?Oooool001;ooooo00?o0000ooooooooool0[_ooool00ol0003o
ooooooooo`0Hooooo`;o0000@?ooool001;ooooo00?o0000ooooooooool0[oooool2o`0001Oooooo
00?o0000ooooooooool0@?ooool001;ooooo00?o0000ooooooooool0/Oooool00ol0003ooooooooo
o`0Cooooo`03o`000?oooooooooo047ooooo000Booooo`03o`000?oooooooooo0;;ooooo0_l0000B
ooooo`03o`000?oooooooooo04;ooooo000Booooo`03o`000?oooooooooo0;Cooooo00?o0000oooo
ooooool03Oooool2o`0004Gooooo000Booooo`;o0000]_ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo04Gooooo000Booooo`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool0
2Oooool2o`0004Sooooo000Booooo`03o`000?oooooooooo0;Gooooo00?o0000ooooooooool01ooo
ool2o`0004[ooooo000Booooo`03o`000?oooooooooo0;Kooooo00?o0000ooooooooool00oooool3
o`0004cooooo000Booooo`03o`000?oooooooooo0;Kooooo1_l0001?ooooo`004_ooool00ol0003o
ooooooooo`3oooooo`cooooo000Booooo`03o`000?oooooooooo0?oooooo3?ooool001;ooooo00?o
0000ooooooooool0ooooool<ooooo`004_ooool00ol0003oooooooooo`3oooooo`cooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176, 0}} -> {-0.000753325, -3.03319, \
4.14556*^-5, 0.244484}}],

Cell[TextData["-Graphics-"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ParametricPlot[{xfinal[t], yfinal[t]}, {t, 0, tf}, 
      PlotRange \[Rule] All]\)], "Input"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[TextData[
"InterpolatingFunction::dmval: Input value {0.0107608} lies outside the range \
\\\nof data in the interpolating function. Extrapolation will be used."], 
  "Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.206002 0.0143386 0.0178055 0.0150071 [
[.06262 .00531 -9 -9 ]
[.06262 .00531 9 0 ]
[.34939 .00531 -6 -9 ]
[.34939 .00531 6 0 ]
[.49277 .00531 -6 -9 ]
[.49277 .00531 6 0 ]
[.63616 .00531 -6 -9 ]
[.63616 .00531 6 0 ]
[.77955 .00531 -6 -9 ]
[.77955 .00531 6 0 ]
[.92293 .00531 -6 -9 ]
[.92293 .00531 6 0 ]
[.1935 .16788 -12 -4.5 ]
[.1935 .16788 0 4.5 ]
[.1935 .31795 -12 -4.5 ]
[.1935 .31795 0 4.5 ]
[.1935 .46802 -12 -4.5 ]
[.1935 .46802 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.06262 .01781 m
.06262 .02406 L
s
[(-10)] .06262 .00531 0 1 Mshowa
.34939 .01781 m
.34939 .02406 L
s
[(10)] .34939 .00531 0 1 Mshowa
.49277 .01781 m
.49277 .02406 L
s
[(20)] .49277 .00531 0 1 Mshowa
.63616 .01781 m
.63616 .02406 L
s
[(30)] .63616 .00531 0 1 Mshowa
.77955 .01781 m
.77955 .02406 L
s
[(40)] .77955 .00531 0 1 Mshowa
.92293 .01781 m
.92293 .02406 L
s
[(50)] .92293 .00531 0 1 Mshowa
.125 Mabswid
.09129 .01781 m
.09129 .02156 L
s
.11997 .01781 m
.11997 .02156 L
s
.14865 .01781 m
.14865 .02156 L
s
.17732 .01781 m
.17732 .02156 L
s
.23468 .01781 m
.23468 .02156 L
s
.26336 .01781 m
.26336 .02156 L
s
.29203 .01781 m
.29203 .02156 L
s
.32071 .01781 m
.32071 .02156 L
s
.37807 .01781 m
.37807 .02156 L
s
.40674 .01781 m
.40674 .02156 L
s
.43542 .01781 m
.43542 .02156 L
s
.4641 .01781 m
.4641 .02156 L
s
.52145 .01781 m
.52145 .02156 L
s
.55013 .01781 m
.55013 .02156 L
s
.57881 .01781 m
.57881 .02156 L
s
.60748 .01781 m
.60748 .02156 L
s
.66484 .01781 m
.66484 .02156 L
s
.69352 .01781 m
.69352 .02156 L
s
.72219 .01781 m
.72219 .02156 L
s
.75087 .01781 m
.75087 .02156 L
s
.80822 .01781 m
.80822 .02156 L
s
.8369 .01781 m
.8369 .02156 L
s
.86558 .01781 m
.86558 .02156 L
s
.89426 .01781 m
.89426 .02156 L
s
.03394 .01781 m
.03394 .02156 L
s
.00526 .01781 m
.00526 .02156 L
s
.95161 .01781 m
.95161 .02156 L
s
.98029 .01781 m
.98029 .02156 L
s
.25 Mabswid
0 .01781 m
1 .01781 L
s
.206 .16788 m
.21225 .16788 L
s
[(10)] .1935 .16788 1 0 Mshowa
.206 .31795 m
.21225 .31795 L
s
[(20)] .1935 .31795 1 0 Mshowa
.206 .46802 m
.21225 .46802 L
s
[(30)] .1935 .46802 1 0 Mshowa
.125 Mabswid
.206 .04782 m
.20975 .04782 L
s
.206 .07783 m
.20975 .07783 L
s
.206 .10785 m
.20975 .10785 L
s
.206 .13786 m
.20975 .13786 L
s
.206 .19789 m
.20975 .19789 L
s
.206 .22791 m
.20975 .22791 L
s
.206 .25792 m
.20975 .25792 L
s
.206 .28793 m
.20975 .28793 L
s
.206 .34796 m
.20975 .34796 L
s
.206 .37798 m
.20975 .37798 L
s
.206 .40799 m
.20975 .40799 L
s
.206 .438 m
.20975 .438 L
s
.206 .49803 m
.20975 .49803 L
s
.206 .52805 m
.20975 .52805 L
s
.206 .55806 m
.20975 .55806 L
s
.206 .58808 m
.20975 .58808 L
s
.25 Mabswid
.206 0 m
.206 .61803 L
s
.5 Mabswid
.30653 .02531 m
.30652 .02531 L
.3064 .02531 L
.3059 .02531 L
.30465 .02531 L
.30184 .02531 L
.29692 .02531 L
.2882 .02531 L
.27534 .02531 L
.25753 .02531 L
.24636 .02531 L
.24 .02531 L
.23574 .02531 L
.23384 .02531 L
.23302 .02531 L
.2319 .02531 L
.23126 .02531 L
.23007 .02531 L
.22925 .02531 L
.22857 .02531 L
.22813 .02531 L
.2272 .02531 L
.22651 .02531 L
.22597 .02532 L
.22511 .02532 L
.22368 .02533 L
.22297 .02533 L
.2215 .02534 L
.21954 .02537 L
.21775 .0254 L
.21542 .02544 L
.21378 .02549 L
.2114 .02556 L
.20723 .02574 L
.20231 .02604 L
.19737 .02644 L
.19159 .02707 L
.18654 .02778 L
.18018 .02889 L
.17348 .03036 L
.1598 .03447 L
.15119 .03795 L
.14299 .04206 L
.12701 .05291 L
.10994 .06936 L
.07746 .10282 L
.06122 .12359 L
.05315 .13639 L
.04688 .14808 L
.04083 .16148 L
Mistroke
.03562 .17559 L
.0316 .18926 L
.02838 .2035 L
.02686 .21228 L
.02564 .22121 L
.02473 .23029 L
.02448 .23358 L
.0243 .23637 L
.02413 .2395 L
.02396 .24398 L
.02384 .2488 L
.02381 .2519 L
.02381 .25506 L
.02385 .25819 L
.02392 .26134 L
.02407 .26583 L
.02431 .27081 L
.0245 .27395 L
.02524 .2835 L
.02611 .292 L
.02797 .30647 L
.03392 .34062 L
.05074 .41146 L
.05909 .44134 L
.06808 .47227 L
.07062 .48133 L
.07197 .48633 L
.07341 .49196 L
.07427 .49544 L
.07765 .50057 L
.15273 .55914 L
.15464 .56047 L
.15752 .56185 L
.17632 .5703 L
.19363 .57723 L
.20412 .58104 L
.21292 .584 L
.21811 .58565 L
.22001 .58623 L
.22196 .58682 L
.27143 .59451 L
.32995 .60332 L
.33173 .60332 L
.3335 .60331 L
.33572 .60329 L
.33884 .60325 L
.34061 .60321 L
.3442 .6031 L
.34622 .60302 L
.35137 .60278 L
Mistroke
.35677 .60244 L
.3658 .6017 L
.37675 .60049 L
.39513 .59772 L
.41556 .59353 L
.44007 .58696 L
.48279 .57148 L
.52744 .5498 L
.57422 .52101 L
.6724 .44029 L
.7723 .32974 L
.87014 .19356 L
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[TextData["-Graphics-"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Animation"], "Subsubsection"],

Cell[TextData[
"For this animation we will draw: two circles center at each end of the bar \
and \ntwo lines tangent to the circles to repesent the bar, lines to \
represent the box of rocks, and lines and a circle to represent the sling and \
payload.  We then animate according to the time solution above."], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!PS-Adobe-2.0 EPSF-1.2
%%BoundingBox: 4 4 377 279
%%HiResBoundingBox: 4 4 377 279
%%Creator: (Mathematica 4.2 for Macintosh)
%%CreationDate: (Friday, April 29, 2005) (19:01:02)
%%Title: Clipboard
%%DocumentNeededResources: (atend)
%%DocumentFonts: (atend)
%%DocumentNeededFonts: (atend)
%%EndComments
0 283 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def

%%MathematicaCell
%Cell[GraphicsData[\"PICT\", \\
%\"\\<\\
%000000000A<1M@0A0_l<0?on0000B00004P0000000014`\\
%5e0000000N00402P00
%00014`5e038000000A<1M@0OP0200800PP000==H00000@000000000000000000
%00400000000000000000040000000000000000000000@00000014`5e00030000
%00X02P0000014`5e0000OWAYIVH0000000000000001QL71/000000001001M@4C
%04P0001800000=:<004:E4U6AR0XC5YG:@00000000000000000000000000000H
%ool0000<LgAbL00001d0000<JFiTN0000040000<M6UVH`0000D00000CDd0:P00
%dHB0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@B6AB>BBFCBND
%BVEB^FBfGBnHC6IC>JCFKCNLCVMC^NCfOCnPD6QD>RDFSDNTDVUD^VDfWDnXE6YE
%>ZEF[EN/EV]E^^Ef_En`F6aF>bFFcFNdFVeF^fFfgFnhG6iG>jGFkGNlGVmG^nGf
%oGo0H71H?2HG3HO4HV=_g6@=oHmli63?c:H[;IO<IW=I^i?K?@Ikj61iikIcCJOD
%JWEJ^P__G@W:?cFK?JKGKKOLAK7_kB@?6?gG?_OkWRLGSLOTGimL^4l7TloXM7YM
%>djC8_UXMT0M_ZMg_Mo`N6NL]m@UCNO]P37HoaNggNohO5o_j9k7Mk56oT1O]]Og
%i?o040`4_[j?VPD2X90/48;1D3@M1<3WjnKO`TP[b33300`dG/>=fgd:@[1;M_I0
%LBa=4lD:G0[I7o5R2@[4<7`ZnTFAM0/IWfPAm/O5alAlPHIB2m9?B8RD@AS5<TbD
%P3oPD3PT5Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMP[nPClT<6TCoTDPO/UT
%d2O[oOL2O<3T3oU[oOd_Ud/OLkPKgW`:X00XAHXSmXcnY59Q=9XdeSe?Z5AZECZU
%EZeG[5I[EK[UM[eO/5Q/ES/UUSTcVLRV/]T/WUeZUL[W4aPDcYdhW5>PKE_U01@3
%`0I`D3Y]=YEVa69aF;aV=af?b6AbFCbVEbeU]5eVT/^=>ODPUlU]T2W4fcFTdSjO
%ChPKeebPf0>f@1fP8fccg4bY65XfGgfoh71hG3hW5hg7i79[nIPMhcNVVcjdU8Td
%Pc;mVO@Ode_;lkd38OQXGS009lbSm5;jT8`o:mg_n7anGcnWengg/EYdldUlgk:d
%^TOYm[XeR?YBe2jYJVjK7jO<77O23006lRQ0=2`M@`eC?_FPSf_a3l@A34DAa94/
%CA>[;m>PoSn9:k9m^TOQm`:NjI<h^JI@DWIl`:Oi=anf`40U8Ka`U2AhBA1bj88g
%RmAA9lXBS:DYbY:/[?c1227^N/F_fNajWTM1cW6MQhaZdjGY`NZFafVcnYBkdQPT
%lHJC[2`30K?<kSQ?RV^JWRF:?3T[d9@]3D?A54dDn[//8OIn7/NQk9m?dI1L4XC1
%l8XTW]6d5Wbd22`77Y:e:0UCRYE:T_6JmFPYEkaWCFD=Cnd[2=kAMLeeGMNEkGeO
%ZPOd79XU[NZ<EQCUBBi:T`BI:4`DQCUHTYmY0]]0ZM9CaRAKRTZB0]`8791h0QLX
%dg>kbE:KFUPGKMeggQN=iBSMT4WneIh7DM0J1V6c/YJ50CQHMai7bNdf94O65E^Y
%aTHLPLU:JlJ1gC9A^H_FZ4bENN>HkSf?i1T;laTUSo[HNi@4`BYRV:IIlY>O9mVN
%IYW4@Ai;`:k5k92_F=]9@1oP5XEdZJNfS87Xe>Y3M>V9ETFWjQ:Z0X0oh50h91H=
%1hA2HE2hI3HM3hQ4HU4hY5H]5ha6He6hi7Hm3Wk0Wg0Wjmg`nWjnghogjmYHn7k8
%GhoX4oWfoWhngc0W[8IXog`mgW0io<I3=Gm?gnljH0:M2GYDHOAXoEJ]EjaFJeFj
%iGJmGk1HK5Hk9IK=IkAJKEJi8nge;WloKS=H4o7Ro7^kiHogZmH6nY5=gnlG^ojD
%ogg9WaQh8m/M1ZL086nLXml]1/XnGgVh=E;IWm1XM5Xm9YM=YmAZMEZmI[HYLgkP
%<i=7k:l<lVVcV8GRdJ4ZSTjaEj^080@0`fBeGa?9dngkbiYKYI]X;Vi70/Ro>e1^
%e<jCgh7A/mIioS89AoA98Ki_30/1R<=M8;Ah9iH9el5LZ9l_I[_lol0@30D1`90/
%3@>ZZH/@TIm<hOjMWnOAm7J`ak3^=i12D7PXU4AY51J3`<UZGYT7RPCU`NOJG=/f
%bJ?0P[_P36D1::mCh/<Xkl>S7JF?]6lOA^n31/fMbT/<j9l_NjkH^/^ZmWnUaoWY
%1T8BNUJLb>YC^^jPLV`A;l`C3<Dac9</c@?7:DWXNkl894al7R3H;1D3H8QBOii7
%X5X=PbIiZW0NRAB4U2AY`^TG_ZY<I036TK:>l/L_LVQm>R^BhaLoSmb2`1o;e:Al
%96Tjj7bO1j:BkL7bLXlXbW2<ZZ?5/8`TXTS8:c<ceaG=MEgGUNemGkhW^Ne2[XT]
%0WfMYeVhJZW0TJQ/7NLa^W02h6PHOS0<XTQjW`NIfWTWLDAKF]4WmAM6bOAkfb4`
%Cld/YDOGSB9oDXOYlW]1Yl_e@JE^UE33_a5R4@Tmk1WS4c0^^PV2F1Q^7HOR68hU
%RJ<da8:R^FNidUVDQ>R>9@//FOiDU4E8V228IO5jHBg7jIAPUd6`HQF0030LLQfW
%aLKcAS6L2B1MLL]YN==Alf[3BD_JM9VnAi7QQ1ogkBS1Ao7^[J[MJ5H8Xe4HY[f_
%k1/>aK7M2@jFOT5?POAgRT98R5nGiTWd`YATVCH8080ac7BMYk:BKi`6dT@m3j@A
%K5bH3bg9FUcIm<KdbO65<a^kJKA?Y6ZWmOBm[VOCZAcPCh/5BV[j0URHWae;_^][
%W5k9eoHMSfGImXSBO_c2:hYVWIo>Ff:ijR`agf?NbiBRfWDW/=`gSWYjoAMed/g?
%<?8LQC?P?A5e2dh^5>7nF9G5X=0_S0=8a3B6hN2PM4:?Pim@8522JAA55mamFoJo
%coGmoio_o4YDhOXWa8EB50KlGE1CJ48U^<fKHNhmAk2?4J8hL8iAc;hJXedY3SE6
%85NZSIbB=eH:2JRKA@[_RQV95X;@G`5P90LBT>`F`[QF0Q1F48NY?c2W`A@HDmjP
%BP96EReUA3n7CSm;jGiodBhVA=RM4m01?g?3i;RC/f:3c04iGd?a:Z=DL:T7X:hD
%XYUUSH7:>/MKlX=T6Ik1e0T7g8We?Ti19I97^8?7LZDN04@80N6/=8L1R1j2B4B8
%@?HRQ?S^=/RPWL>e0U7MlY@VSC604a;LQ8;LVBXZVE>ZR8lD9@BQU5:>DQEROX@H
%DkeZ:PEkV87dQ29@mBEU57d?<B0Q`o0L0L0/6X;@ERS5F:f7K>hf::LLP>>1m8i@
%R<<MLfaj30A8<<?<IXbARP@0N1lOAOQm3Z7F0LY`aa[STB:@8Ni>bg3]7^?hNA8V
%A4[9<?aWAnS18@GN5JO0W9m466I?dD/oiBd1X5@>PU0YCY>86BhO/:DEX=W<o54k
%8RP4/7T?hNHjbF8>G56]64aXgC8DM22ILGSKBB<eAT`abal3^5f;LFP2@40H?PW@
%3`6080>757V9A;1m1X2l5`000@4R94T9m:bAgLWa?NoDj`]JW0iZPDIe8n0MeE5S
%ENP]FJ]EKZhk5XSUdXEPPc5hYD?b19A7f?QOB]GX<lXlV:I<LWP7f9BB^:jm2F3e
%6d=EIP0070V1234AXQA11V325^FBZAoS[7<>Q5@mQcS/7P3/8@B9h[2>LXDfR:Ao
%A:GNMH2]XAcFS61JD4mYj^fY]EJ^eR_ee7A9Fiha5VdJSl7/Ch_HnRH@7M9IUReK
%IR`LC;724=Gc^ShRDkhU9QJl1`3H6TD0Wa=`9Dd@8HPaaV2E4`9eMiPJT=3<@GdX
%I1AgGU<L?H:=jA;G[]KNfmekkhAAVFj5N2=RiZG?TcZ:SW3iDLG:m=0KYUdTR_0e
%QU[F6SehOL?dLHhAa0@0R1F_Pfbm]7CH?PK@gQ^R>4L9IKC]cHTVM8D1cMM6dSo7
%5RTB>:`:H]_:>jn><LIHcaXFHna?cK4SJ?KQ9lEAlVFMB`:0B=cW7aPdm:HioX_;
%ZA/SZfKYdG]7?SU9B1>AkSa7J>TCPVQ<RK4m?lE0[e=SO78=dChYA@SX7D?@kI>B
%RaK>XKBf8nAn2Mc/4c?03lm0hch77?a0d^Hed5X?@VQB8i;b8HQL98bAhiX@/EOY
%8akSd7/?1h:@[PDM^4P7A2?e8e9]kEn7C>V/55G/BH`A]S:;97H=X1H301112:48
%58<0L3a:7:Yh9ed83=el60;`GLm0?2E/DDVaagk90Q//IncC`hWd=]4P3oPD3PT5
%Pd7Q49QD;QT=Qd?R4ARDCRTERdGS4ISDKSTMSdOQ[nPCmTKoTCoOSoOKkOkhU</U
%<ZU3iPShOCgO;nUd]TCjU42UTVTcnTl4XSn0=9T5;QdTOm>Tm5YckTEDYlWO;jOS
%kOU4X4YTmKXm4OTTZ//Z;nN;mOc/PCfTCmO<T[/2V<dK3ML9A;9I3@J32=AR8L[U
%LL6Bf97^;46=O>?YVAbFCbVEbfGc6IcFKcVMcfOd6QdFHZ=6ZnW/dUXD6^=aT^UP
%M7eU4Y81Sn`QN]e6j]Vkgd2f6hQCm/5@U3l//aPCjiT3i7:O;hX?7O5/O50aki/^
%[M3VM9a=ib2@C2Z0@:1N_Y/W<We0UHYn31n@bnRoneSo43UOCPKmocA`10<1@70T
%2`=0l4@C1D5`HdCI8:XkJ]^h2@]lg/;]i3;F@XeKP`hd[WXFYbW7nmR1_I4:A_nh
%2R3Y5`9aP=TI7E6SoA95;SWhGdMQG7/K4C80cB4Pcma/oBEaa8d6bG9TVbM9lXBS
%:DYbY:[LZm23J:Dc/=@`gl?8M<3BW^NbJ84k<7XDk<C;/i4K:>K4hQS>H^CZKTkX
%BNlmA]9AoU5?iWD2PIgd8==37aA23D@jlfZk;2WaG:e9DWBU:d]Bm<DcCC=cBf<]
%=];T;@e3/?XU3ao><Pdm7_8TT>A=<L86DMIPaFY:E_AKW>Ni3mX<ilnDRPM5cC=T
%LckCbRdgIEUfII]WFOJ5XdiAmT@U1<a8C4KEA8PdK?fXlLDGH[n_mHYeg><UdPoM
%IXGKGB]YFQ=LXFimNX;AKWcC?[meSJEoGoP60h5PN2BIC/F:A;L2f`eJ3fdYm]XI
%>i^2IR[/eli4oU4F6>>NL6?Q9T8ci6NfBgO?]Eg`i6<>EEKIWmRj4COAlnf?P^Ki
%aW>MIgWVNhAUm[8hgV8`gDVSHIQfRHOYK7W^Xh`JP7PMQlMig7SE4:1;[ASjh`Yb
%Pk/1;k5NaoiRPTKAaF6EXA9;o>NC6h5k^B1c@o:2gkWflke_NnKk_d2H>XN4e1XC
%DJ925Bj?a=TX;YNU96/SE7nm9jST>8j2V:@ZZ4Ki_722o@6]dG@0^C?CFAH]Rf8i
%[UmHPUaX5bR35KfPPm]LU^G_A>omig_OMoh7PXQ`<8hDSL^]MX]CYRdYnZhdjAKK
%4Rb>@[An?KYM>Y4CY>4o[1<4^CF:RIFX<5?lmF^W/R:Z??ZSb;H3/POnIco[I6G`
%1/gLIIhGnolon040GS[DH@d5hjXV8?::Nl`U0nSDU27lE^1KcSU527dMYVA8bETi
%PRi8ijI2J6ULb5D3<9F==TCBh4S1ngeT;B46HA4<HE42ILJ1H[nSg7lP53/QQ0B0
%?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN<AV=A^>Af?An@@=oB>3B=o06DAio?
%mnb^FbbG@BE_nIbimb^J`:I_en_mm_RJ?^J?ek_IlcAo_bQDRABIo?b1CfF?Ej_>
%X`>UCRM?l5PX6XF`;Za@UmFFC?^dB6NBfAfQmfEmBIRg<UGEbgLhgUjG^3?boB67
%bJ1g21fj3?W4H35H_6Hg7Ho8I79I?:IG;IO<IW=IC1@FCBP0bZHJ>Ge^VCWCe6LC
%en_ZTd1oFEl_FFBbXJVTF_>e;NEOJ`:g_eQ/9RS@ISIflT>L]<lfcfV@HB2gkK`[
%Z1?/9G]5;^HGXI^Vc>6ig`NGcNOdNWeN_fNggNohI3bN7@J:GjGaJSmCAnCal=PX
%CHX4O3FWRLYb6nDA?U<HAP6FOSG7jfkEYXTJe[:O4<:S33Y7n?PmSl?8l3fPI/A<
%54D4m5C`Z`_j;[Fl;iX:^2g316`Za`=<M86a1l/<c<H>W5ao[Q7[hb?94TbE9LVB
%K9dWbPT4I@ZTjDXjUd/=<g3D9NObNWm0;G7hfQoW/PAj7VMiePn3PATnCYE:NZl9
%:7;B1`U23O:TWbd1L5XH60GiQB:a1gd<;m48<Nm5XljSb;M8b45;BH@dZAE;^XPK
%oWa:K8bVTe<b4j/Xe9D]CE?E5DeEEMBDnTKjb^dSDBfdbJbo<9n7bN2F7TVQj7dN
%ai143hC6jKId=neT9ZfgJXdFNZo=LPAfFX2P9P/O9l:FPRgDFNm@X98:<`j`JbX<
%]befld1@gI>jNAKDK9Y=LC`[LJ]keIO=mGgOUngmOn0AHceGb/SckeVoKLCXWl1Z
%WGaoWbMa^VbJX7PN2l<YlebBGNVK2BlfdjfBPIYI:DiDCRQ5`>lOIWiLMfH8gUKP
%>nN>K5cW0bId7NN0KWa5j0gBB?K7ioUmXhRJCVJ:cfg26?gQ>0jUZNZJ[Zc;hBlF
%AjgE3b?8jP2k3YLG]lVEJeZTV@C0OalZ/OdcEdUQiTXB163X?Y1:]R217bWZSYlT
%EKYI0:K]RWZX9bfnnj6ZTbFh]2eW5b@ClX^ibj;L]YBX_/QWWcaEM0;gAIl1XNM<
%A_D79e@7MH:?G:MXJTb6bZEW^N/cAVO9n4bC1=Rh;X_UVFQK3R>@i?kYZXWjYL_]
%jWbHjc>jV=_JBElFZ4j=J]6]J_k__Nol7`k=FWYJgi=BmPOe=X<07fgPS>eO?j=`
%[NWbP=JUTc7fZam7T5P9PARm6><`NRIcG5;7T?/O[Odj_;L6C@^;ccJ`:7d?Q7a`
%21?88<XHMihCZ2>Q01V4@jhB437]2LPbhQd`[512d:T;`2@a2I3<B<=A``g?2cHN
%81hN0AQldEc3F4k3`R8DP@PPa31H2b5/2h60=3XQFFb4k^7b_;FbGhX2A3E4RK>n
%>1C44952:F[n2Y/F?;VO56V=DJhf<1NLliP1L8N07GXAQn99H^TeKBh9G8oAjZk7
%j?HNhk1b0A0F0PMXm1l>h:FCLOhmh3:LCTV21i[An=[=ZE8UKe9=[_84hdQQJaCb
%S2W:F81J1abYAD9h7d[F;0?2a;4Cl/aeBe8B^0IL^@GbkUh<6Gb?Beae<TSeAc/3
%Z1?V@0JI@bYV;T9dk5D9DRU[BL:DU;AZ3KSkOdG4ULFH4]/PbWU`3g8fcUW=>NM1
%khg]UE>n^IihU=_]00YdR/Mc?AiWNH<O4T5LT/C4?LFX[1BQ92:44F8]QLb@TNJi
%TXf0;PO12<HIPc33;_HjmTO1BQn/IT^ajC[bc_W?9nOmP@oaVdW6eBTAU:`Kd]0G
%Bl<=<AHdcIP>iURkTl7E9=5<FU?IBQC;08D=m@cg;PQeBl1HIZUC2DfMBHY>co`5
%RdlnCLGJM3o7F=LI`]aARN5F:dFhlBNeBRbL0XT1F@CY[EF^]UKJg4DFlnam/m2:
%Ag[Bn@VIoI7Z<L2?`O1]3FRJ4X942P406S<6P=5cDVbQ1D2d5XNKfdkU?7dhE>De
%Tm?S8C5=3Z?AXfO3aJ45EX`=fU3KJN5XX7<T<DfFiXZhQ7faZD6HJU]CUPLJ4V0k
%iU4;UUJ:dT8P2;QBa2`:fha9T>YC>TE:;<eFQUJ7oE8jXlAcPc0X0lChXAEdf7n[
%^j<6JoT/O^nN]miKcGW_@eMM=O23[PDRAN^ccH^Eh8:]i21Ai:4o7Z?@N3b8;577
%d?`K`g1_Q[;b?DWS7WM6iVjB<j/2Y0V87_AU8IKU`36``lH>@8<>0O`l7G44c1UC
%^7n;g4`O<DF[855>8:hI?4/aN@H36<jDSJV4NEW@I0Phk0CSdKV?kKfa4NS`a:0j
%B459i=<h3JBLTcC8MDMHh@M0M0^=hL0jQdU@^lgYnaBBSha_CV7<FHfY_cc<WIEE
%CdNg_a_?FnDmWaTc7g9MPi27hgg:^b0WPVa;2H5^;/GQBl5Tc<BhZ31_T9Vl;f?C
%4`_DM1Y0UY46>T`mjEI:=8QSSBg0edh6SCa36RXMJ;JdkiN@he1?:?T/YK1=j]1C
%ZlK>/HA0I:6>0K`g@E0X1B70=`KjWU8I11I`[e3PCIPbUXgPoAbEJ0b0h13=U/bO
%aFlU]FI=[KGf`Zc<mm6W:UVL@Ym;l<ggbW^`XUMUCBU^^A6PXMn2QB2365d;Xl4d
%B=9a_Nc0mRESf;nCdNhl1iR^5B:T;XF`]7H0V3SQ@RN6HeG>MmLFgh>15hY20Abh
%<BDUDeTMcI0QQlO1Mb7SBlR132hn1GU0fnE2liIL3?2GWK3f26448D<`V:K7S`3H
%2MWV6gFFm:R`nfj2=3/7@>YB3ofG:FKLo6fNWM?jQ>Zj1>l7@;`VKE22GfcSjd6E
%^H<WXhKPc@_nn9@jW5nHCGZ_C2D^]YS4?PF`[1Ek>0@=lLHh^U/d@[18LXkAgRX5
%L:h9HAPU0D0J108X@0P2I4^9Hi8kN<ciH7KYKJh[gj;4]iVW73li^c8;Rd]H4?A3
%Xm8f<Rj=;M]lb:?lKN?`=FUI`;TjPXQA2P/N5Q>[lBZSb3?kgCP=A_SN73c/dKOL
%0Ved9>626LeNY41>2<5XbQS3DjbUiaJW2FB:L0DcZ?gO_OO</F`oZ440]W7@><LX
%jAcSZTYeaTES6f;J8Af4Q:/f0?;;RD[g;l]R]/`2=@eD;l=H9FcV?b7dTPO`od9h
%=^gh7h7N7T7/Q87R4^4^4j242:2B0J0Z0^242@2@5F5<5@7J7<7BMT:6fni68Da8
%Y4hf[:DfRVoZ96m@Fffn/N2dQZ4R8fV4G01Q1jLl7VdF1LUf4DJ08<a<5f60605l
%M/[@:8_fPJ7l3o2T18161<6T6V6ZkDd>7^;Njb/a0F7^7R847R7B7D740@0J0l7O
%34FBP:7j7TFb7X7Z:4RbGRo13_3a3b8/JP_l@RTN7U3L7n1J1@1D290^TX_X[^MT
%jH/b=ng:W8J/Y4m=4F=A0:BhX^:2B8S47f6/6d6b4H4T4T24262>0R0P0Z2Z2X2b
%5B5D5L7P7ZXb<6:PdB;@PHLhN@OU1TgHBVgDMS1P84M05D6_66b87bJlMR]L>n5W
%6F2=6J[X8NDPmF9<7=6X0e6/9<Yn343636=^@bFn@P@dKD:4Wk4`Jd5B5@kV0N0V
%I`5nilf>I2:@:DTPKN9l7J5d5R5H1h2R384j5V6@:B9j7R7<TN7Fbl363H3b7JP?
%3e8I8K8L8F?fPZbn/b5>54584d4[0X4T4/5H5B5PPV=LC@@8FFSZWG4LcRJW4V9;
%5lQ@lnXj==02Jd7j6J6F6D4@44441X1N1R0^0f0d2lId5Z5/5`_g7V=73VcVj0:<
%7ffRaP`BMP]blhV4FlJn;l]N9i6X7<UN6A:hlhY^W2>[1nZ2cJ8/@j;V6;1j1PdZ
%3f1/YJN@ilT`bBPZ7/=X_bFdQ@;@726n704k;j5i2@6D6F6N0H0N0X4j505:kb7n
%WfHf@ZHfP:7/7>524`4V000D0j666h7P7`7NEf7bPjT6140h0b2j3<3ZnJFg8O=D
%80oh50h91H=1hA2HE2hI3HM3hQ4HU4hY5H]5h<oX56XM78dnW`nGo7gZmgjn7dlW
%FkQf=1^og`ni>o1F9aRig:kY76gnmWZnYfoJ4o7i@7noH5B:?BH?7XaCjQCgmDgg
%EJ8o:KB7kF7mB:joWhnj_1VCICXMCZ8a890oKCTKCN`Uj_gcFgg6GnnG^nZVo[^o
%jaC<117kDj5QJW3kk0j[Ol9@[kRjC@/IEEgU`[VFKVh7EgeWh=Qh<nM9HjQY951E
%CZai[KJ7g@jGC8GbmGbn8doGTm7S0[o<WbmY7MkmAgjlgRlQ1be/]EdmW^ng0hg@
%7Q29S/O3hmWe8XiBWg^7c_GnkI6mgS6WUPJ4nWFhd6NCJRT<Peja6Tmh5PJSoOlo
%l0@30D1`90/3@?144`E1L2ZLSZN9fOIlZ0YBT4`B9:6bJAZWnOJ=:`IYTVVBA84f
%YJ^Y6[C:?fX[1@Z`B2`M1TIX@bB7:fXin7jOJP:jNijWXI1S6:=<R/b2XDBB?LUV
%BIYV8i2DNWnNIkW/_j[bRX;fZj_RT7hg:28hQRn]4Q3D8bZL/:Ze36/ZaaWCP>Ti
%876c3]<`2[Z8olbAFTJYSK@05D4Hm2@L`;Lbngj]W`hK094OYm7hO3K7^O00P00I
%dW@M[4/2LadWL6cFRd;`^WXNAjWfNe6>:W[09dV1j:0V:V2N90P6fJQV3<<PaV^K
%[I_g6UQf9H]SF?I5TfEIMV@C6Da`PY1l7VNZUWdT/>WlKY[6bDa?U4HQOV6`LM`j
%e:==^a4aAMMRU[`WMVfM238/C6:``TO1I5PEh^2d;8<P^2`G1H5I2T6@A_VjKTD[
%j^Z`86YD?X4NJm:HZ[S:B[4L:e65h8C?S3gESjZ:[<Z6/nXb27;UND8=U/HgZOij
%iVZ<K;jLNL0OW@VIhM^O<@fS^7bg;LahNb^^m7Ym4NAI43T=`eP^2X;2T:8ZAi?5
%//7:LZRT:PXQn7`QWHMCc@kBJM7lNSc`l`2=7ACi@4fCI4T:@@Fk`Ja]7;FF?GS_
%o0L3`G1l9`_3@?XTjGW6:_HiMbUCdXAh7DM@@0b3QP5dH<F/Xa>;/:WS9AOan>l?
%12=A@PYnWDMIeUGehY2P:880L1XPR07Q:4VAibW6LDDn177D[b`[n8e7TLJfdSmA
%A?B_ha;lM9gIlo<RQnGnZd>@gE>n8Nfc/m84KGaX7<lF?i=b<;jaYkOJ7ggPin9;
%oV3gjVWnjWDPZ/dZCXb^Sf305d:PUA927:>?T:@CP/2K4^:E523UJ3h;2H4>8LPk
%0V1>2/Kk2B]_<=`?XhA7bkXkM@?lE`[QF2c5X;@`:QgC@_QQ366D<hJ9QLFgi6<=
%d7@kQ_3YV/?G@5R>:QlXa6QOa7D^00O0mai]K?HA/^ho1k3c7J>X4H70@Sb7M18S
%@mB/6oF53PdD3g6_0M8^i0HY8e9`6L@=k3gRU?I8:mR=iThh_Y:L>DLPigiRE2P5
%89X0P3032F4l9`XQ@2Q7L>`MI0UZZ^S@KhTJ?B_@f:JQ2Bj=Ta/aAXmdSLW242bU
%452DPm9C<^=19mjdMTj;d;k9hOhNII2HUX26FcmaYRVUd1>GP^3V/<AdSHXPn1NR
%n5X3d7`;213UDP>l2H2PCSM6ZXaSB>bQ=]7nDHNQA2oRJ4j:4204@9S8W8l21lfA
%lUL96F6D`lRTWOU13FNDlijCeW/P27T>9;CiWi3eN3e2;CiGLGa3Zl68XM:[4T=h
%KPe;T?dfiAXnaiSA6F<P0P0021P2h6H000P5Ro6><lN1nRja>LDV6</I5f^S:N?R
%UaZ1EDa27C>UbS21<XCJKhZchI/bY7n?NX1QjLT4O<?n3Hga9E91n3`8@2`4P<2n
%5d;PYaDRT7F?4MhkCT2c5R;0DHWa>7W851:<==bAZ?Ta@5=:NCnE/?hbI6TVYF<`
%7lc>;aA0]ei23G]WcIZR6TC@F0XUAG`7lZ:bH1eRAiF;:^X@HiV@9e94Q?nK:f2o
%1T385PAhT0n42789XC@S@5P51>?ho@nj7cI>6ImFQ<21CK7lUHO`]aMRl0X1D2h[
%AER/NVm8SdID>_]7TDPOEa9kg7^ALViEbinXeQmIBj2cj1?ZR0^QB99XWYE<L0l1
%`2P20300?`e9h2_8B7X>h>SD0?PH0n?@N0nQ3R94V54;0H8`=J>hLBWYAWAd/Y>^
%]01Z;4P>LX>Y8hi/443OJL:^UL24F;7T=C2@Sl:0Y`/1S30HL=EL5TRLdQSCDZ?E
%j5`:PCPU]JFUF=Md8E68_N6@ZEeLR2BV7YCEl]P5U<X`MO/Q>2`kho4?T4Q;f1Ri
%54ITL>6BDi1d3ETd@6CfCDe;j>c:P4<[46=X>8L`i@A0V1:74=hL1n3eDHZ/`0nP
%[Q@2@<0G`[A^SQ68YP00E@[1db:>VX8aAR2m1X2`5@3P3P:7F>lN0l1lXBTUCl/@
%d1XSC0d1P38SQ62=@RQ>LeoGS_7^GY_CVWM?>1^K9Nj=ckYgC8_?`YE12a5o:dER
%VXE0YQ?RB9bKbThAa@:>?L3k01a3KMnEPD`ZAH152B52TYPIdcoU1Oe66YR:V=;j
%bPZhHmZHD4N03K6>hh3cfh@?:ADaUKQ3W^<5Ni@CKW`d678XaDg5P7jG[5[6BOSc
%:0?T:XE`Z@X5OJX`N;E6DfaKOZgn<5j46:_P/QUQ70B`SZ@@H?3jJV7MN:/k@O0g
%lG5iaW@Xl2nQ[hlFP>XGnA0ci8WLaXf>D1BiESI25/]1S`YV4<9hB@T/bKFMdB@R
%A203D^7`@0IaBR]51]P38gQ_^P7n=PJXc<cR53l84F@]QKVYET?X_j3Q`MI1R2l6
%0K0e1[90Mia[bjG=7G<N7CoJNeM[kHPCD=e;X@ikSg27IR2SGj;2j4ZHU192A05]
%P283`98Ac<N4KXfAZPB0L0^:SJbTBb3n8TAPTC0URBWSDNBe5XJSkVDnXYOAFnQ1
%Yj<4oYK2a^<o`PPG3aPi=3D1Wf0:_ILE6QkGQ[=YE4W7d;`FP/@c1P2MQX:Vf05S
%WK=2h^hlb/A=;nD3I5JBVcaNe77QA19H8;aU:g07eRR67[j:Sl0LOaI93P;7lbMj
%PFYiX4TLokM_D^6[o4:oladOeafWKkYG8BTK7j6P<P<05X4h4PL`L0K[MiEHNhN0
%P@Mj/IL[A2Jjei/h=`=P=j[ARSA8MiVI@`XSKPNH908`8h:H:8:@MIC@/3EPbJR2
%>k]/5T5/5d5iMkI`R/6D6@RSE2HHXQ:A[2bPE8DhD`0bkl800h?H?:cYRh_`AH@h
%@PAH@`@`YHKcG`181@1cbcZ`OhGhH0HC[P6@2`2h3;0[7JiZ5[]aV;0H74<jXHe2
%5HFP<l=X14=h5l>;88@hKT>Z>3JBWPcbE8OXTZM`XhFhFHGX6H5@5XXhM0BhA`?X
%6`7`:3?1[@X8Ol?a]K4:PZecbd5HRImh7bDC3Z>bXKk91DCiTPa`PKm8MdDhD/E8
%</EH?dEXK<EjXHBTF@ETFRXX;4FlDhMbXARhP[6P=dGj=SkB`Ye;Eb;a7HX`O0C0
%BhB02P2H1`I`IPIJBJei:XgXhQLhj8OHMc2PAXK8K@KP_jQi:jVhVC02VXNXNHNQ
%GP<X6P6@6<4XM15`VAB9E/64NdNlO3CS]kDjObokj2P:7BlQLZ7Q70H4PaW@1j9:
%Y`1A^0LXg`C8C0BP;@;0:i^@Ch;H;0;b?@Li70fhOJXh`h?/T@FdTTObj4<JT`oX
%ZiV`ZHeX7SdH6PeHE;nH:h1TV`7/W0B4WCmXLik3J0`a?Z>0_0e8N8N0N8M;:`4`
%L@K@l`NhLh?H=@;0@HAhCYF0e8`Si`[0Xb;hP@TBPR><D0ha7HaXZ[2`5<>YQJW@
%acjYHY=@aaUHLXBL^Ce`@D^YW0LIU3QXa[:PMSf03<W@B2F@?8LT`SP`XS6@e0B<
%a@DlaSK@l2<8[Y7AE:^XFhG8FL;X2lE8D[5@hXhRV`OhNPD8DHBXKT:0M3@KiXP@
%j9l8SQ2Im4O`A8A8@kf02hJ8J8IhY8Nhh9<4O<NhP820?n1@>2@F3@N4@V5@^6@f
%7@n8A69A>:AF;AN6?j1AYoab>AR>a^A@J?B>@BF@bUo_f1?enBmoBb@_Yl_i`=ma
%0ZM0D1P@2080SlO3ZG?R>_ei_5i?Ag_=o?bCAeoAmneDeEMjEV1bRDE1oej`B2Ee
%F3>Bc:>d1^e06f4^g9bh>Zi@ImgF7eFlC:2GR1DIo^UT/IMPT7RMlDIk=m/Q8001
%X=ad?21Ej>_]oiIo_ZSen=E1me1lAYne?BAnjGEkJT6J/2jekjmlk64jBaAKH_U^
%kU6k/_Ke;KmcL6]e>jiRmeGJA^Y]oV1[W9CX?[Y97Z1W[4o/>?]BBY`=JMm1N61k
%NDiRX?bJGf=?GA_QY=5Z1l?2=07hndMoIR=8E2WP50H00H@4EAE5Plb17dc/47fd
%K9YN_SA<nUim5JEYEPT2@85dGAL=4OAn7bf/AA74TBa=4lDAC5DEaI5/G;4[RXXP
%Z[<9HV:SWjOK=9FdQn>@TJl[8RDHY2^/@ahYkGW^OQmXdSA]6bK`80N2Bf01:`3P
%<0@XRN9b@ac9bFY76jHabOCZ4RL4e?8TIjW/d:A`>Oil]6[cTX8dRn8@MLn4_?`Q
%d01]12S@PMD<2U46SAB1[`d[^`@jCQ]=8Ik<bLA?TbA8T2X=1gZ<4`;103@50FEQ
%IUfN4684N9MUTEH5PB3if7NOik[jbImWXPE:/_Ae9/^^b2RKHH7F:PJGWi>llb4P
%mTF@dkSCeH5XZZIe[3mK0bFdCm^7IKe6B3Ij4>TOEYF>UiPgBgI6TcMX?gN0eh[I
%NH0/J01dg`QQZgf<]nbE1]TWnO3S</O]M7mBYkedZ1dW6MHHQT6@]2l;Yi<>d<4W
%nNJ1Hg9XS1l8iMUdGYl^TSTO;cLBYC:_B369Um40XC^I]VZMT7;W0PieL6FX4hZ3
%FLUlGj7XVRj=XnTJCYFSB9Gj4>;WjEYK<c=YRe=MC6bMV8=LcIjbUBI7j`mN:ZZ1
%lW`OY^6fL4/PCN`104005PD0ejP0DaB5>U:I8h/RlAdDI@U0K72I`L]ca13nCYHN
%akWb/;<c3UM98<h9c4Qc531eN832ocaDm0dSRQcdP^M<>_DJjPmOC^RIo:<OAd70
%K1UP00H71D78V5lFaQP>0025NFAL/XOYf7RLa`3F=Y27IBYjX58j_nPOV3afPSKc
%_=QoTGkX8NoLR1o2Q7]mDh/kbDPedV2>?fSGmiHORN_ilA[V]XAm:2^;LQhOj>3o
%b1[N7HCh0RmSFP5KNg0=42ga:A84o=j2ZahSa2[1DLPiAdScE/NHOQAV46GDZT`b
%iTb_T/2B4l9X=@OPj7F?@MPm1mS[:Z?4[ho`CPM1<=8J0db>3h=R;`GX_A^A38Bb
%XPK5b1SGRD2J9PLXW<ZC^;n:@?hZ:B3_5L5dFH8;:DNEmXCBh`AQS56><TIHc93J
%ndhQ;HFK6_PRIQ9XoDS]R<>BPOB`DlAM8Jdf;aGRI8e9XE0S@gQ^SS0N0h2H2@4P
%502g4eH22M08KJ:lE`/db8n;6ITO@SQ62;0BUT6/XAGBSQlTdU[TTR8B8hQ9BAc1
%_YX1Y;42l/`^be5a;LQ;DAoWF0b;jG`79PA88Ln<RinAoSf<T`PN1QeK4R7dYDe9
%VAkT/7f?HE`YA@2U5J;PNA0Qi@K?dIR3aNSK^ZR6=`ATj@LC[P>VXL2dUTBjDU<8
%hiNUTBn5lnd>;WP__[>;?@kQ7eO>DNRK8Q2M``D9PP@<Je3@4D?G/_IcRl`UDEJ1
%5lQ@JWUS:6J=B?b>GYT[<dSTOPmCcTR7ZfL?`Q@o0E0h18KHgaX:kQZ0/0X33d5i
%1iC/<E?G]a684TZGBdQie51gDL;=BFXAh4[DfWXHSRWl4:2nZSoAh5h:beR?]@8c
%eMZmEn/5HJaAX9BBPS9CiCU?AXchSXnQU396:WhBKQYE<nX`oDQlO8SSh7/E>>hn
%eK4U60;hHiSH200366@;PT18R;Fh9d305`>F67P>nKZh1o6b9LI^PY=F_bULKIj/
%Z2amc^?2886mZ@<F[=j5imMAAi]1A0K5UA]eb@7>:a46@b[NC4WTY1ji5VnT/=RM
%8O1D6aFdA/bLP@m1m1V2n68J`hQ`@d:U2@T;=Z1T26QMd>eg`AgQ>L1X<eiH5QXZ
%X2l?]jb6Fb8<KN2HlD:R]ON6/=mmaRgiDTjfc]12275ZiAMhYb2YS=`<:S13R5b1
%<`H0O1e4L85X57P51aj3Y7T8d8/APT1?RN576i13?Qm3hE/SHoA:Al3j7X:`EhY0
%;PH0L:lF0Z1e3X7B141`5<B3j1kSeOXIKgd6_o7QlaMET6Y7/5O9@=/V@2868C:5
%j`ncY4H2G:bn1dglSc@:?EHl_IOc1V7<B;:m4>SX[b>2C9VSk6H</Hm3`2Ed9QGH
%bUN27EjEnS]7CSb@RG4Z9h0P0`42N4l9XEX[QC0i1d3A<A6QKRf5h=?BA;Am?d;8
%BDNPle:^B<nOUI9GBZ^46`8PA0QV8P`D@18=VZaMj]][T;>d3D4UC7A[DZhJR1eB
%33[]J50CJjM9CAlUPlR=3f:mR@OhlQfSo3:6<>28HkSoHFR4bdMAjU65X;DFhIm^
%Bl1E]l>NhATKS?6K7GHHA0kY19^_FA0l0DH75_4ENl`dke41_N9@eiRK^;ZWNGE_
%dI_gSk[8dTXaGKS6@jXg8g@9l=0O`nGP5^903hX9_Rbb7E4:8d;TFh^0oQo3jBc4
%J8;T4N9H?e7JCVa4^7Z;dGP]@@0P0h7<>PM0MPl1l5SW@D0W1?7fbE;o0W]YgX0@
%QI0N^TA<1=`/;GCGC1L_22=`b_[OAhbeV?[7FN]MKjhE^=:<kS5EB>In`3?Q]SJ6
%]N43kHhkAh_m7_[i:XBi[]63`7@A@:PD0bchMXkQb0A0T0a?PjHA3gf<^0bb=cYD
%TAiJ=8PcaX3B3j]P4/C5gPMON6TGo;RW[DIj@A9Da2lELDK5dKOYn6PCb:LIWQ5I
%Ee1VW2<bj>AmS^:P?A>PoQjZf3h7XAXB@T1E7V?TMY;1gSj7R>XE@Wa@^N3>0L1H
%50O0o268Wjg2g]T3Ob?m@0@aKoOb/2DHGhb3B^53nOFnma0;k6[^EjG[B2kk>D[n
%GGlXnbjWYUXk@h`gOmoP8>7302[f7`F:0LP>jJ2d]Q06m4AXK>9F7h6l6l6h3438
%327J7N7HlB7XmfX4<^j0<bBHJ`7fR66d0LhN101212291FinY6LT8:b@oLgJoVj:
%8>Cl4^0[1bjRUV0^;<78kNIlkL8:nbjk2;2=2?2@JBc:8JK29N;lSPAd7/46443j
%Nj4>U>96I@SFh4MFkR8dCHAfS^G:7Z^L3`3/426`6^6i2LEf2b2d2Xo>4n;/>jQl
%k6JXC8CV7^Pl946:6<6@3b3d3h0j0l101<1>1BOn3P`<6Ja6/2a</hbfhc22><=8
%o]1ZM81b5U4dO/;bon[8:lPL;0Af7`7Z7d:L>D9B71024V4Z4N2@2>240@KR2P2B
%2H4X4V4bOj7/Ad;bbdFT=^1?62XJ6/bTZN4U6>376BL`4Pofo/IZ8nG94T;6;dh1
%1VLV8@XF8:m69O4G6FO@=NULb@Ue1lhX06G/mBeJ5f8BaBBF<^<lB<7Z7V7X342j
%2n766l7092BHDO50CV=0@l>T1f1/1`100f0j7^CM0N]6G8C_0Hlo2jT31T843g8X
%G/Wa7F<>nd=N8<7U8k2C8o919394A92FK2C52`T`[HPn7`fFH@0l121:6H6P6^@J
%FT^69LAn9DSDjl]6BncZIlk57f92K?1N<`7d50524f2L2L2H@J[<JTJTC:<n6J6F
%6H3V3T3Z16141:0n10143`3b3f6P6R6W3dN^=X/f/f9Rljem6d`8oXSa6Rh4;`>P
%4Y0@_l`X8X8e3V8e8@df9L/b=46N6L6V42404:1P1T1N0Z0^0TZB2^5V5R5P7]0g
%8F/l=<M4gjbj882A<joDan_Z7O=56/UF9P>j?b7f7V7L<Z6j747:2Pid9j@21N1@
%6U=/:lYR7@UZ360@<J4N4D483j40486D6R6ba>94[G;F[DY0[BLFln5`5/5Z4H4@
%4::n7bP4/<5T5R5/JTin<Y:Z6H0B9dG/`L0>2NXZ6jk>Aj[H<nmTA/Q83d3V3`5f
%5/5`^b[HQ6VN7j?H:V3d3b3h0f0/0`4F4<4@A`Ae9jJV;dj^^08<l<A32nb459@X
%0S@/TD0BV8^fFVb2NU6M97A1A3A5949;9<Ej<bE_A@Z2VX8lH:fF7/6h7H6l6N0<
%0R167DA2C/=TA^96HbLPKjiD8:<jT2?A9>TdAg2JJ4<jU<:XI/:b7U0;38/2h684
%IN68g23VjRo23cBi67<bmHc0b`@`0T]P@85D6YCA8U6_BXFVIDFAAh8dH^OFlbiR
%101:181>3J3H3N61CjOVHf8b<gCL[^84o6643aD@fh3>5SDI0E@Fh0=6V<EZY0A^
%7fNP7b7F7>6d6R000:0F33Bh6T6X5h2B281H2/bD6/6l7PB^0h3P3V486N5h5B1F
%0d0=Dj0P6d7HfTEfT4_n[J9S2N@n7bSP@@<jd^NR7/6R6>5j3P3>2l2G5ZdT6j1H
%1@1/7H7:Vj^@[F7n3B3R3N0<0@0:9n02KL000J9h2D;L6B6N6Jf>7dVJ88?@BJAl
%K`5:=n4/ndSZlJ7j4MGlgF18242023>R5^DTm:MH8IHA20FV5IHM1h@f5d_6gm25
%6Vm8Jg;fG;4l@@A09HT`BHi@@SI3Gh@H7d6N6R6L]hhC>J9MB;6VAZI]9?A=IWIU
%A7I]I^jf=4=5?bU<;mIl92;l]4Y07`7B<b6d5^5<4X2/383l78<dH30l7h=NB=Ho
%?b7VH79[BF:OBD8fSnk58`;mCHc/>:2?K:h<RT5n3KKE@/0R_CD@3`6OKSHX@I2h
%c7:F2Ld84l]B1^6GKjFG8N^0h0=8=^gV5FZOKH@41PNj4F^j6QHFO8ePEf=BNd=S
%Cj61KD3JanR25jgh@T<YL6b4e4F?JnmU?JHf7`7<3b3B2d1n2/2h7D887>6L6>5F
%3ng^2h383^2L2l3o5:;j745X4l4>0D0V1472:<^/7T<]3dT4lCIlk4@BF2CTX4i>
%:<7j7N584^4H1/1R1Z7T7N7l6N6D6h302h3DMNIF<`B>12141406G[E^N0<J9j08
%0@F:aN0`M@3Z`U6Z84_b6:^n3/Kn;Z4eP;H07?P@GN0nhF[bDM4iHH86PQ7BhT0/
%oILf1mP`86ZcLjUc<dEoCQGTJ2=:9G7IIeQ9GP=4LL7/4l504j1^1b1]8<0e0R6i
%DOFiIKBAI[:QIYQgB=IaQoR0[3Q=A<U=32a3ABmS0lV>7>CV6n3@2/2@3J3h4R6O
%1naB7n6B66621L1B1C@/0N7I0^^>iFmT[<9@?J7]5:VNIlNfnf`5KWL/RX1nG]Rj
%1B4ES_PH8G@g2:Fh4n>`2OKHeZ7@8=1R;k8b8;P@7>GJ4b2=TJ9d0ETJ2<bX;UMQ
%@L`[PhmQGS@N=N>n5Xoj3MOd5iU48=8L8<WMK:2>GWTO7:dD1d7D7L7N7/?BA^7^
%EX7X72180X0:5B5d62<T86Hf7j7J7^7V7P0/0d1:5`686`U<<b7H5B4Z4@2J2/3:
%fF7n7L9IK3AJ7jHD?D7l@o?c7Jmb@U4J/b7R7h7V742^2J223/3J3T1l1^2<6`6Z
%78Nj4Z6V6ToK4V;`6IWlKPN0P:`LP@00040D0B@0`PG/c/nfL/]J7MXPonUZ2jRg
%<fX3@J8?DL89L/hN0N67Xn;aDH5Rj@3dRh8n=_;cCD_R86hn3n_VO?I9I67k7`6k
%423b0b>L2;TJ5V>oDRa0Y4a7ITB=QeQiZ;QmR3ZAZBS5R7IU;gIhndNRF><d7gU/
%721P0n0Z1T1n2P6jQX>j746h6d;6j@3`5R5T5X:l<`7X7^AdlBjmGV[E9?KXNTWY
%8HRjG85c[c6B37KIKfF`3mKICDWR;ZG9[/Eo6TbmXP7M1b0ZP?@j8==/6T47/Vaj
%1jKP04ZB2b5O/g=4EX8;CNRkX`8=/j`@5@g?Y9/R>:MD_LoR>U0272GV/><JLiTN
%KN060;1RKj7/7L6b6<0VP@7>7R7`Zd9N4^4B486F645j=F0HNLHd^>H47T1V120j
%4V4d5EUn7L</B?:4V<A0[J9KW9ZLQZfBZ:@h5^3l3b3R4B3j3J6n6T6>766h7238
%343N:42H2D2H2/KgEm9l7oGD2FB^<JGZ0T0R0X504l53BT8a8j7Te_Kj6G6/IiY<
%bdEm6fI@;dG9LfNn0P6C`nonO?X/oW9]PLX>RjLdnoH=>CF87`5f5j5d2:2>280P
%0T0N3Joj6^L9B1>I6eZ7Qf@WZ9b5Qkb9ZEb=b>J?ZIb:C`@JCW?b<ZfUEf7YT67b
%7T7R8d7G1NAbSXoj3H]2CU[B?>KhAU6WF8K4RP:V;aHRPZ2[C7P`1m6>4TL]T:7o
%cOC=PQSd>9HZj`21cj]F0`FU`n6C4Bo20kd=L`5[dBon;`O:h4ZGKYN_=56F2gdX
%bXW>ejJOHZZh0Gdi7:G/GWXDP>9h080gYaGWJTQX7Z780b0N024d4n567PDZ4>3n
%4D0d0F0P7X7:6m0<005@5L5D^>7f3n3N3P0LN0666D6`^/kX95JTa:lB@Hf07n7F
%7L7T5<5F5L3J3R3T4J4N4HRDQiUZ:n7KAT6V06040:6/6j7:6^6f7<9d0T4@4248
%CVY6H47^I<7n6`6h6jTPnQdh58565=`<0Yh45=6/G8YoD8fT:b]>W`]/lFh5Ko5l
%AYHZUd6=hc1B137BW:j4b4WQhHo/>;SL8;hfULbacRjD1KiH`U6RC/95D[H[Y<`5
%bAi]i_R5GiQlAR8hk6:f</VZ7n7ZEXAeb^fB@FVX7b4X4N4Ngb^Ij4^?iPJb[Dh`
%C1Ghb@M05Bid2a0:U21[TFL/H^MD;`bX_?;Jbg]I2<>:4=kHLhFd391h1IkUYKKR
%6OPf8GYF8;i;6VWLZJ4ZeF3ILG/kLjAkhHF@H_;bC^WaKHG/P8LilJ9lKR02P:00
%0X0N0R@h5ba27f7H4`4R4</<<J0K0<0`6Z6>6T<b7R5F4l4JM]`800100X0jMn0@
%787ESCR@iBJV;67DI`4d4`4f3Z3/3`4T4Z4b6hgRHcaK9DDZ7d7J302T2>4/4d4g
%D07RA2Ch7V6b6L6T3J3236K4HcbLHd=S4`0D0@0B6FXh?N6X0f0d0kKcPNPNOXoV
%nf>:`UcS`WB5a<WZ80oh4nh90X<ofE2@C2e]3H?0Wa4H<oXY3go17g4h[0Wk7Hm5
%XXoX=7h4nI<09@HID4iHEILaYQ1WY<go8Y[=Gjog/mGa=i_7Y35Y91giAH]AjABJ
%EBjICJMCjQDJUDjYEJ]EjaFJeFjU=X?=Yc=i4oIjo9k?GgJ7e>W_5gkKGnkYcAGh
%Ze:YG4gFnj[hnGdnWi0/2og^ngiQY5RL2oWiHGnlWTl58YU6DRXD@QVB;VdiWKhj
%[YC7[Xh/i]<3=AM=EAJ7C:3G=QC]Fo4Q]@9]cg^G3^h=Oge68doY<nMK3mm1VUbD
%=bc5cDociVm7WdmkOh=/h=6>;Aha[h?bd<3_41O9:?<0=^1?<0I@2@60`E]d5li5
%QWhlXPn7ZngHj7/Rj1;JHIGU4Li[64Taf/2OY;4PC@R209alXPPBeYlLY`74BI6T
%J?HjSZCY<4db9iWZNc0<4PBK;6PJ;WVOQc6b5P=PRJi_VjN<0aDVaj7^NicW@;X[
%2fLAbWBWZM94DYB5>mP06lKY`7j`<X702T[/jCR?8lhlMZlY:<6O<@gc8Sb8W`kc
%PY0SIo]6N[T>B1li5g>TdX6PS@X5=b;>1>j<XO<lnWnSajW^NS9U660H1L288PN@
%=8<nWba/75Io/>RR`d/OImBg>bSdnf=AE7DUBe=DmDECEEBD/SUG;5@J<X:]IoET
%W9lY4`<T;PAeN_D00IQR6AGF8Vam7m:LE8WIAg7HMYDU>E0QfWAX8R@9@STlD1>W
%KK[Pe2TZC:BNeb8<7McUiM;GDc;Ing1EMB3YN@LGXAUk96S/n8:Qm18lI5oSkP8c
%H6EN2bjRmmZE?:3h>T;_GJac/hBD>:CT1keP20;gP6l`3Hl0@003Gh6P>0i<TfC2
%<fB]j9;32JdaJB8nSP2:D4dBi73>=Hf0@1096TJQ`A>Oi/VlL924@A8eJFF1EUJN
%YgWNOak[F^L9ePOij7aG5U8m2Io?nNAcPb1H06RK9[_`OiQ6NJIVKJ`QkU4BA9P/
%1X91448C68IIWb@Lae7GSIZ6RJjO/2L_4PcaI7lKO37;XXJ?D4Pg4W:;W<7McCQZ
%5O:T:6JW@fZFGBFoMS7:1=TO;PXn3lNPa]mR?7IPZ2h:2:8hR?V@56PNJ_O^?BUU
%L?IETFEC2O:ACo:GQi_WNOj7XnUjJZXla_T[3BZO8bjbNWj]O[[P`<o`VOYmWckb
%LboMeJYZVaeWHMa>ThChT2>9@:0T2HS288YE?oLd>iBSkCH<;8<O<@@KH54F=lD<
%kc[WW/;;X`mcaGdf4H2Y1T?d6`I@MPXjPSY8CO34Q8724d2PfRdQD^mjQBaU`_?B
%ah0aihJ02Q/0<080P3/I0T0h1H^1NRg7/Ha925QlScO0nhOhn1k8C7Z>LGHZA=1f
%3Z74B8UQ=2g5l<@?0Oa2Qf3h7`FP^1KSa<P@Mk:^BJW4D6lEhJUUg80RF?lO8kQ6
%R03^0<0h1P[1P3:7/@`R1i4A;N?@MHga_A;7j3050<A0244F:<EP[aj;8CnYM59H
%R:3RTh2NC`Fi@7G:<ELT8JIC496D^mb<5CTSB0g:mPXZgGU8PP@MiT]V4TN5c;/:
%4_Ca0>3U<4K@g1/SkNn9`C`V`OQ11l_@73`Hg[:7d?PS9Hc3:CD^KlT;TX:WE@]2
%fL4hIaCSW9>DQi@He?HELH`RiAD9Si<2[BHdCD0?]@FAU[i>B2TR=lT0M0Ua=RJ2
%44<8X306P?2T54:RBaCScS<Cme9Hal3lJ^EV0b0DO3FXd2BSS44eCWM>K6EAAHF5
%>>f3bU0`ZE0LYH=NUa@cXRjYU2H>0KZK;Y5i0iQbGic>O8j62X1i02WVHfaQS9:5
%OPT161mlKEbhDEO6?HR<Ub<Sl7N<dGP/0kQe3`6/>@NQMS46>?DW8lAjSd8jWmbK
%ieJ:_;1=5EYHdF3oO0OPOXm1fS^7P>nJQohj4C;FnLN`jAg1b3D7=ZPoaKS06:70
%?@NGba]7j?Ilhmj9bS7n82c@2k>46C>EPT:i1k6e4PolEA`IJ^[5kJ/KU[GE/;D4
%W/`A[2>fRLNG@hHlKM:m4L22g`<kP2E^5KI[YH`m1l3cLL?8:KV2n^LY`SYRbL[9
%WHCimQQakeW9a;M@QXf5WKYkN6lEhkbGUE0/ZN4kB1gCODm]@MCAjef[LVdNkJRo
%Sh7^>XLXia>2J4f3O003c<QJU0:YP]UTT=M<=Fab9[c1ZTX^?l4F4da3?UZD>FiF
%b@hALNL<gbWl=dTCHL<^ReC?QgaACH=`[lF1UaL7[62oaT9P88`e=UiR>4M=lNVX
%Y:6<Y>00182@40JPc1TA6B]M6[elSV[4a8oAI2h5X7<>XK`o1d3@<lHP_Xf]G[ln
%F^MJUGT?^VmZK1BD__L[]IA7@oaiclD^L8NHnAh3[3h7<>eOc1dC7n5T;hG`6PA0
%P?0M`ki/7C7V5WABRPHBXXnEK4>3iH`8U5PlhI6<>7i`CSJWS23kH?6WZ4<nXcD0
%<2mZLHnZEmBG7bFT/HHPb1Q4V9DBEYPRQ42>/VjddGc?SV[EDT`n1jIS>6M^Sf>=
%TK9fE/]EF_GSIV9ZbZBi=S1Un@/maHiRB13S76>4AhSQ510G?T<28E@YQDUf;Ta/
%8B=Wf<H^ijj[GQ_/V[QY=V4LD1gMV7S=2K:MJM:U/HSY`jBZGWL^8Z8aN52IhI;d
%:06>8>o6ZDTgd]C^dkfHUhS0W^>1:hl1GT0A>A8L4J?TNmOQmVS7RH<MaKA@RY5X
%7C?0Q11Qn6N=HIb^RJWoi<AEZhlRoZb9<O/O@mZdiS?][[NACB_?6iBYNk9>Dgi=
%AH?TNPW19R>7Ro4M0id542WXBP0@BnbIo2n>Aa=6Q[0^kH6?]eWn`;UddEEMk/A]
%m^36@IcQaS[Hi;8A:S3[23>[l6ShPd/@Hn9UN1^c@P;M8iCmg[Q71QnEbD6408@?
%aO2o5n?<N@m@>0K0l<LH`bLcV:OD^hO@maoM59ZQIFPoCQkL76:KfcY1IJ?hck_g
%W_OO5:O==m?jOao7jcT@CE[hm]I^7R?0L@h1_R;4N905P;`IPG0Z1@<e@1MRf5a=
%?<18M[4fJfe`SWbi[6788ZdhV3b/Bekf@PQ8:ojBcEGN3_ceRRlEkk6RKXP@b0NC
%fPAL0S_1aXAhM<18Pc2H4CE8HiRBBkOXaRc3PZL`^S^3CcC8PhM0L`LXDHD@Cb50
%APBHCHKHL@d20RJP`POHOa=hOH]XW8RCbZC2>POHoihaI3o@eT6SYHTHW47jLiII
%Bik`O@NBHcHJ_h^9IX9H8@7X6h5`582l:@K0KXL950D`DPEX1X0P18?`>h?AHhOH
%:@;0:P2I:jh@B[`PY433^Q=QPhS0ML>;A@;9Z8Mj1Z2[B:cbZIQ8kcfP?l?iR`8<
%@@Fl@RFl=CbQ<1kh/H8X8`8`L:CQI8BXBPBh:`:X;1C3GZjamBJY2a90NcThMilh
%WXT@MPMHMa_84PFhF`G9hSYBJ;dlEkglFDFLFQN3GB^Q5Y5D6l92>8OhJXJhL8nH
%A@6P6@6;R02P;h<h<XH0V8/<5@`J>9;hVclKb8nX_b9P]/JBC;J0[ACi;P_h3lL:
%U`JhkK38f0S2FXYRFYd8JR11<P=hCLN;A0Rd33aYYH=@Y8^TM;_d2ZlPgcn8P`gH
%L<0PAH=LPboXCHN<>;>8`KhH/PTA=2^ROSoJR29B]T7h_haSJLKJC;mZ^Ke<82=a
%hIV4D@PD92RZNXokU8giOILX3H2h481P080hA8@LV`A8@X1X2`28>X>`>`DLX3B/
%O:c0[Y=T=S_PO@=4Y@I<YTXBT478aa@APH<aRdMjeXKPYSPAlaQ8kY@IBQe8Vjo0
%O@1h1`28K@K<[15LCHO8N[b4C`O8N`MHR4S@VhM@M8MR?H1<DXM`OBm;9lEj^<`4
%F/`L`T`[3A;HNh`;1hOXNHJHIhHIfH>SjX6P3@384`=@=0>HHhHXHPaXNhN<6b8L
%aDG9kDRi?ALQmJ]<^QhaCCbPnchIhIjZ2XkB2/34Y@=2132<3Bd36k_bEI;I@C6@
%g8?H=ThXEThj0;B/3@g`j<@PFhfK40RSRkY/gZldXhOhKdk8l4P`=HE<kd>[GJ>B
%]CIjOTR0RTUSl`V`a0XPTY1J^0PHTAZiFQk@/<f471hZ^<6d]XWQl`P@NJb`_j_e
%0ClQ=2:X?X1H0//P181X5`5P5H6H786XMXNHMkJ`H=2kO9PieKo0Z0T<322LjXT8
%AE4Ji`GaeJ3l?A=1=R5@FPj;ne3HS/@hPbhTA3<T8KeKJR4<69ZPA`AXB4BX;4[c
%h;J;ek/0]8MY@HNI@HNP@cVP=h=`>82`2X3098909Ih`Vii4`<F5;T`e;e;m<1iA
%C0RPJ@JXK@>`>h?84`4H3@4X4@39N@>@HPHXI9c`/9:LlilZBh`LJ0V[mb2IhJnj
%MJ]8`0gii<[b0TKSB3S3^I?e2hH;006lOID4j[P;om6[Ce4[60?DfjW1<kHhYD?8
%QlgI;d[;MSP2lTMR3H?`>MEYHPEd@jfAIAlilI2ZmSXJOQFk<IjkN97H`:m=?[GZ
%j3JRC:J/nQ5/72m/F0T`^2mZOH`AFXTB8I98W8J`JPKX1@0`20mP0X0P0BXHU04X
%4h4@;P<8;HBhC8B`F=MHKEM/fiK]95DLXPZ8k`T:V@GCAaL<U0P@BMOXJ=OhRe6C
%<TfXR9Ckn3bHh=D0/H^KNABd_I:h2SihL<7keYI0/]9A[9FXN0<0;X:PB`BXB0S`
%:P:@;XC@C0D<RQQ1C];T7/8EE4`Z2ENMC1ChG5VY3h>/[DXK1iPm3QQMWUBlYb^S
%o]WZc5WiR=NEWMXJ2[29@C4UVCAjWKCYQLO[Cd2C6EVh4=[84ULECHI0HhHLG<85
%U/G[Y/F9E5UYDbKJ2XUP2LP@R`^QOZ2/P3_e]jfPaaeMNlhX=RH8>EAlL`ZJR8P`
%F]`H7m`X5U`lhhEU]EXimaQaPjF[2;n<j8[eDUXDURBhH5c;O8?=cPHMcd32Fm43
%P4eZMB=]deNU/`T4`@XCYUFMUI7KK8aIIDCmN8O0M0M0N1>@39T9SPliGmKh0H0@
%1P1H0j6P00P`N5i8U@<8LUiYdaF/?Tj/7DMQJX1EjcDX7]k:R<7DNhL5ka=MbRc4
%LY?5YhZmlKCialW`>e_@SPXZRH]i2XVXNhH0GhG1Lh5hP@N9c@M@2@1h50JPJ@M0
%T@^0NIl`n]RT_ii9FQG5IE@l`e`:Tb2[Q@HX1^2XLn2j4Co[EMNZ2iQ<263P[bFl
%jKAn4CmI=Pkf4/5V4n3ZHbj:c1@DjialOhTebN21@LfKi3bL3BeHG[5@3^7jC`4j
%<8?PK68]P@WC^EC5<8fE^e^XOUiJdR]L29;aChk0QhhI=`E^;C5EmBE5aMb/X/Z0
%DV<Mj`1BX@laWX10Dn=KnelmimW@Y=^J2aQei5i=NmmAP8?XI^?Hkd@l2k`2G6:N
%9L89kHOSU3eN1/K0N85h5h6j6dVEKYT8002h2`3MoX2X>Q<PEhEHE0M8LhLe6N98
%PdhMVXG5WF3:KhRcaJ6`0@m=h`>>F0kMOhJ;5PEk`YeU3Q[eQ4Y0[KPUBXQjCPL@
%e01AK/^DlEn:^P;8;@:AGX@CT`L`D`DXD3@@5Zb`Vl90MXOHNPS8W[EZ>@SI5Ikc
%X`RUAD`N:ea^>;bN2hLn7h3Y>PGHfJKQkkX9Q;H]BlKmbkb@hVNk7FNSEPTd[@ge
%Y^P6OVNNO=OE3QCl09cXadKeBm52fKm`YKcPGlfkDYLh7Ka/MU5>QV<6@MPMaUWE
%MHF;T@8Pd@dQ2^3@Qhd`L`C6Ue_Ca/Zll4YmP;``Zn8h7FW;7k7mhf</fR40acA0
%T>4NR<jmV<aNOYCXS/0<k`E:50@nZ3D8JIai<iMnWn9fSii@PJDLnbK<D@NH:h:h
%:HU00Xmh1H0@0`0h:`;@;8GXGPH:JIUDCJmml1QKSPC`BF_>QSCPSc^cDZXPmhlb
%cP1N=<>^Wn=HDj5hIMdAai<eP^GkbV>@[1@CB>Lj1@=LW`>Q?`^3l0NH;h<0;5c8
%F`LPK`J5gX9`:P=PG@H@JhT@NPK0JPHP?h>H?X1`0X30MPN0OL8b>@W`jeFPT/f>
%9Hj=4X4fhf8=`h5Um@Pb3X6AN@>U`HFX4^jNi>i:VQChQXFbh06LL83knP5K5Fk0
%Q^kNk^knl<j^k>lTL>lbVflFkBh6l[nVlkC^m>n6mNnBVbFkM>AP5jg`405702Gk
%2[S`9Cg6;@E^m@3nh`4finNE4X4O25[84;aN8:Gh6_2l0hD73D1RiP5>klNnSPPD
%ic]P5bSP4VmP=f[=BTZ3B^N`a`g`lfVHPkn9QKfRgP;_70BW7CfSgFT66`f=^0PW
%0050lbXF=;7X067Pgc2>QfT>GVR>FmN73@D6F0>:dUiXLVa^Y8kLODS<j/go5C=6
%[LODn0`hW2Q89YSX0X1@9fe0J8JXJdSHVjJL631m5eY1QN?HI]_EaK30S1Q>oQT]
%h]h`U3DX3G@iB0@?;3_4277_5J3mZQMKC/7BK`T=iXLBcP18jKb4f2^PAHAP@bXh
%A8@@>hDhDHD00H183XKPLZ]3=cHFD1=h78608HM8MXNPN8`7>FKbHcJ^hBWXP820
%?n1@>2@F3@=k`V3>n6=N7=68=J9=n:7j;0J<<^=?:>@i[]F@=2A>NB@=kBMnbUjB
%]UBe`bnA=1bC>CBREBbGC2AC=bCEkBUnb]jBeUBm`c6NCjPD:RDJTCB1BNOcNQcV
%Sc^X?mje^1_2_=V`=Ra=:b6Vc86d2Be=ZfAai=>h=fiFa]DJP@=mgUDG/[Gd;GlF
%h4nh=aHF1_W4??5F9/A1Xb1Z^[9@J4_O5?>H]k==C>>_?@O@J7AJ?BJGCJBPGOC`
%D]Je?jnPGUm`>:=m2kL/kUAk]dkg@d1nL63?[RK:3L7T?cEj?R?[T9_X0OY03ZMG
%ZP7/0c]>c^@=oMn4@Z1MmoMk_hQl`Kd@>N93g77h:3i>gjIF1lSS@GbL?RJRD^Jh
%kQ>G0L2@;0cbWo12D]VOimWdO9jQl7@KP2jP=Pf39/6^KD47dOYo^DOil7^OD4_6
%OYn@NPcE88i21ZfN[=6l</J<lMJl;boQm3=7SZPO7h8B2k00Ta8Z`6c7Pc099H[b
%JIlW]TlTF7a:S:`0P[eb`a438<lTG85;j3_@<@a30A144<klB`JOAmWZl/87XMZX
%WfO9l7XNYoa94aj8XJHM1T7iEU6Fak7bOd6@A4d6X53l47c555BiBM:>FXCo7jG=
%=0[CPNDlH]@=9:l4_0oCbE:OlF?gDeCX7EED?=E]6YCF<^e?AEGdTlMKeMFS@E6f
%CT65HHJf:jZ3BXO5Ea5:QKfL:5X0UJ@RfXAE[77K5T_^h=A]S7=MdDo;A<ZZE:g=
%Ll3G5KL@X>lUTUIN5Z2:Iej47NdJ3:D]m7SOS@_8i]Ue]GB2F30E:^1P`UhDjX1h
%Jj[Y0>0F90;RPQh]746E9PN4GHPJ96/An@[<=9Di:]bP>K5T`haF=AiIL3Ch3M6I
%iXlNK7oB4@WjaAgU>DAA0J10444@8n84OI[V/KJ_7]4<@dDlYl7/Nl4Wjm5;X;LF
%EX5OQhSI[jh6WGYng43fcE0HZd438Y<8HMk;Z1]QEKW<i413^hNkb_ID?3ZSUfG5
%Uce6i]PFnOmj6L38<P^Q<l`K=B1CFianlM3m7?:OIn7TZ9IUNGXSR8:YoDME:2@E
%VmD`GV_EiYMFS[c6G50bHOJ1mfaLM`lT/WoL[@>A5VGMlh?P?jdOOelOoPX?hl?l
%Sh[ANHPOUFdPGMh4iX8ncJ@9G4b^mRUl06o5R`QT]lacO@PN/89SVaiUPW3C3P^>
%c1PgFO_LdF=UefLBfPCJ0e@10G0=N0[2Y?_H`o`i9`D_?fOZ?amke5:W84c1Djd5
%aF`I5g1]R@0X;P0G/8<`koT@@;:0f4@4:@g@[Dd;Tnbh84?EQ8@I63PEI_=OPiV1
%ck3D`hOa3m;R2Sb/MLTlTOhha_3R7j?XMhj1d3N>X0LEh[QMZ@>LPeobSQn:>Qlj
%lOI@70?8?DHPAdIAJAWE6;2=@>8f:gH6NQ/8WHi2=SXHiI<6AF]i1jk:<XSQgAoC
%2LQjd3ecaQRj@MLAi0W1>2HTDBa`Al4Y?BXaaj3FYSg7lV]3jKAhW>7/>0Khk@k1
%e4:ZTlXoSdZAL^ZA4kAe6a0UPP=kY2ERPeSjD09T^AJbk8<n/m4=WC:XMg<1F/<Y
%9^YT?<Eo/aiR<`V<f=Od`XIb48:`1F10PScI0k=]TXZ@WcOP60/9Dhff7d7Je^I2
%jiP>mQb^]jkciPC=US?<djDdZAW5X7FOD:`g;364D2LHBQCd3SLR^<D=j3B7V10e
%nT4cPV@HPMLk0KJ::aKDMDS01SZRoXhChHm7`kdQY4;ZTRhY[<3WM<jH;Xj3c8V1
%>QKc6IjDc@8PR8Bod4XUNK3PN`B`U136P<lJX<`IPk7<>XM9bQnWPElNDhPn4`c0
%PTLe[D33_]kSX8dPHAZ^6_4oBU1YNHW3X3WFDf@bJd0H[E6XF531Ve_BJ5MkHLZj
%<OH`/^@L@I[`UGHD25i1j?S50n1l3[ZW7bITTNF7dVal3i4084?8F`^QHJ88lM8j
%1k=E84?RcDYk5>GA39ZVTm5Ac/866Re4R`W462aJeO@YCB@a]7K>fPo`RFg>Z56g
%@XKNCVWUKFh4b7g`;PPMn<5aRD__X:@EG=NB1ao7L:nj@JkZDR8d</d9ccX1E^i<
%ZgjTkUX]H=BLPco2Y0/_@`aQX:kfB1FhL@7mlDQWE0_OD<MmhDR0K@niFlj;IG1`
%1P5;[Ah6:=JNN=?8naiR`5F:dAPRQ6Y`6Z=LJ@F0]QRPPcRYHnCRDfVBP>QJJSR=
%Q]J5RnX5gm^687>Je0J7iW8BN<m/`7QIheVP@9K0h`lhk0WSfKhCj>2oV0Z>fC^e
%EXXAC6>HjRg<>6=UE`8Qd1<Z=>9IVDdFdCDfEC5/NjMD?FLDHiPlXmW<:;JLZjYd
%[l1<eI@lnfBb`^ia?T:2onJlkBaI6n81Y_AdZHc_?AoSQ7WX6d4V]SDj4`WL7H9c
%AT0@e2;dPf5F=9SR8/dESd2Lk<jde[gF0dTj4H43C86:3k3@1Y7H4D:2XVFQ08X`
%AR[PAT0[/E6V6l>OmLG1bdX]4`n[6X97XZTNHJ@aQZ7hClZ8m1kS^4B8TBHdQZ3P
%c>?eZHnfX;XPT@H<nf`DkM<L@=I>>@nKS^PJ5I9QAa7@4foY`c71:k_1E_45nlm6
%2Le3I]:V/f1?7f/?hi9_cU>SQi3R3H^kf0Y;c9=/RMGBiIU<PfBCI4h9PA<iUgVI
%D4IWDKVWQ^^GFB9E_GoKHIgc2F^?BSSg:EcjS_@2`EO;cT;MYKbYeKkEOe?BXU6i
%4Qggei>K^Q]VXa:M398>LZDj5eb6KkKL8P/NWGUaDY?Va1lfXN9C>SK90VmdIB6a
%@0XY^`7X^Q_FOTOCJRbk@a18L7Kl`SV?K9iG=>iA0@jGU3[aCISjf2?eZT37oKFU
%<NDN/TO08<`>jQ;Tk7MUB0Ehem0i^BQNlTO0>=M0iAj0iiUjF7C_g^XJLf_klcd2
%nm84;ddf`>QkmE>JhWFJn7VIe<0mN^hQn08:2kg46AE[LM<jQ1TV^1L=Q`Pc<1/k
%?B/cDPc3oLkHhRd=TXd=I@i[F4E[OiWed1[baKZ?k6Jm=d9eWGl^QkQ8;hZmWa:E
%bJmW=mMjiDHTOhHUkL^OA4T4ZGOd>`Hi2<U>0EPnX2oP4RWd3Z4W0:mHQf863Q0D
%>ZjleJXn6>[^EhYDnk0XIZefT^UND@EBYdA:7f7`7D7<763632303Y1<3L3N3Vl:
%JR=V]2NJi@=<FFC2FBgD[RID>2aB7fK@>Z]h52VRE`9B<ZFL5^5i2:QjXDN@<h6X
%aJNf=J2dL@kLG4^>IdER?8><mXI/AH^T5N1c2jBXc8hXei0dRFJZ@@l<>l=W38TZ
%TXGHh50dn30ZIRE@?8[n9l?8_b8/3lnK1Q3RkV<21J5k42HPoV84OG3jG?1b^bQ<
%N@FBPTaR494PdL594VKLKjF@gbPNND=TEbNDg@[D0a1^XJ@6j@Q^YRUnYJV01_5D
%>ZPk4ni:7;5PQX:hV<ON1g5/Pn/60nlNa^[h[o594?60=52`[2;b7^f27l/h7j7`
%7H7<780:@Z6h6f@f6d6`0P0R0Z7b>D@H7/f/l13J[e1P?8_H1FaZ5VdlYDe<BF08
%:TYS4888[74n457TkLE6[b;LfJ4B177e2j1bW`=6RFel/<VBmZU>bfCHM8?8gR1D
%WlQdTVGH@L[2hZ/fULEVA13BZF84Klc0hJba3i62ZRQk4_8f:04I9:l/cm62njFP
%2P86SH1`Y85e7LkS9B=:a2U@<@OhoB7j6I9h3e9lI65]:2Y>n/mNBdbF=0YNQfNH
%iK9PVDDX?`jR=:PT=T;X1e:/PnXbm85m957L[0=T[6Ng5HHU2M9VHe:M9Y;@`6Mh
%7^D>C0l0EX`D@B7/2d2X2T4`4T4TYbJ>8X7:7`=V@Hn8=W;lehG<IB9B61<A3ng<
%BY<<Q`Ub2HjllX=2UVKl7n<T7D1Y<b3a<g5h86<^iRNN<ZX65>M/1lMT]DI6hBbX
%elcDH8@lbbL/l>DTST4j_R1nDO32CI8Rc:A58XMBhPMB@A8dELC0M9;B=0XHIN_4
%^:7li:aJH5;?>>iX:0KE0D3P[`VW>T@8=T[bA/63>nl/l]:J8:WI52g^Qc5n?@oZ
%eX>8:<i:2K?PB20P9S3Z_0[fXI:Q0m<H>86A?jmD3g06<63jXR>XXb=^U:Jb;biT
%Q`AI?DZ/7l5M@S@8>/j64XAPd2d7>e>e66@N>28D7l7X7d7V7B0n0/0b706b6h@B
%T`I`?0`bTRTX7N7XZPl@IZa:I24N=>NHjL5R>d0H>Z69B3??>R:0?@g6J<V[@bT@
%L<<P3OBLNb0Rlb0iAlk@5PDJhBljK67hl0U?1O2b>DNHK^1268E0l?=nEY8:DHAA
%CD@n`?3==bM?<8ea6d/DbI32R78=<0MB>@Ea2bhTTX7ngZnhQPdk@diC2/;b<P11
%DFo`]6DLA:M6hb>lI_CACFA1DWC]:@lfd<:TS`BC@5?j6@YPiWBBnNXA7noDH6C2
%<Q4P48UZNfcR2jiN5F:l7PES5n=>i0D@L<FBh;@2<7B268:0ci7d16_D0621FBge
%@B7fKV5E:hEH86l];404Xb[N6K>RnoD=3RDN?j`lA07V7/7R7B0b0T0Z`X6//f6J
%6L6@[@6NCfA2444<4:2@2F2Q6cCT@<PU5P7:lJ0Ddd[fmLj:eN0<0MH<;M5hXGBl
%c4CHRn@LQ`ljAB7j5>5:5@1j1l200`0h0j3d3b3h71I087A`TF2HlkBbhjmjn2/D
%`?BfH79:4H2YIRH73M8@M98`n=><?eA[GbebJXfEA0hJc0f2M:CbA67n7V@KJ@A7
%3<@jhXPQ<7307k4V59ES;;FfnHC3BTdT8:BnYf@6IT=RcD=RM6/b7l7R@J7Z6Z6a
%;k8bKlNJ7hFD7b7VLLLLglLS0bBm<08H7Jk05<XX3J3oL2eAFI<j>FW@L6lhH6AQ
%0NY55cDF10Jn3Hh:V6NACh[g@aE<^4if:U@R5MLS3cJfYF:0O02TPj_X_[Gi3f?8
%B6jBE@Oh:41SMRPn1AMX;M4gL[@O1oL]8mJ^`11U@l?4@L@PC@4>0804062h2h2d
%;@3oHNY^61>n4l4n53Mh>FMgEJaK9djPHbidDE?THN>TGTFFOiCFJ/I/A:7X?B7X
%7F7L7TSX4V6h6l6f3f3d3/0n0`0n241h2<5B5J5X7TgjJ?=Nc67X7WBPj;4BEHi>
%VDC2:4a><P[nNDQO@HN@?@OhOhe`Cb9F7mJ@NJCFhD7oE/7Rf27LEB/hRn7V7_;l
%@@n:DHBff@7hWlDl1hOODKMj]ZXH?8WiEKDf^I=KAdPMK2n58X/h7h7R5J584j>X
%0J6f76l6hfJ>UB7d7[23B_0fI/F`724l4h4f3@3<3:nX:<ERAQ?C>c90QaL@7d[n
%N87eAh2oSNMT1?SU@48mEbk/EA5o2>K6<Z<[JV^X3FK[L688[b?A;`4TPnW37;:k
%E:86>[M^T>Y>PT6gTVd`_V>X2WTaNg2ZigMgQ^nIQ]5kSi<ZGF=Ti6j:^ML<H<<^
%0eUITV6fAHHh]T>@jI7D>[Gla;SBmkD_8P>EAX7/5PjM6/0V000800/T2d6d6T6j
%I`TXf@f^GFl]1<3Y>QE>HeU17`39Vb9l^Pi75o<JbEP`hl?BR^n=32`>/h7V>D/b
%A:7h7Z@4ZQ1JhY1J/hLV7j[6ojgg0ATliCF2U[VYJlH?HRABFhTU0f7H6h6d2l2P
%2N6L6J6P2N2b2l7DJh?6n9C`A07l6l6j764L4R4Z303:2n4d4h4/[7HUQk0VRl=>
%NEMnXJ^PZl^h2ZXb23YXZc5fQ^L:Of?AQcD:HdOV86[6i;>]AaI071FQ68[08mM=
%@:8`l/imLBeWMH=1Yo:<86Vk0HHX>ZeGZX=4WUU1WfYWTkJhPG>Dd:=T]EU@dhDE
%FM=]D@YUYE[73J>oLRPoGl0C[^]E<J?gCB6n70784@4>4DLF0/F:1B4f4j4P1d20
%1h00060>7<7:Lf>DBf?fRFJ]31D^7n@d6d@^0fFCNeVZ[0WTdDjlAT87425k7i>`
%DPNA[LkLVjn^RnFDhjC[1`FA;dh36e8bf>A0@nQdNZhfYH7jXbPU:9[0cF=TFB<Z
%oj;UVFjYQoUBRfK9K4nCKP7Z2j]d6b[NMB3i4PD85dLf/d6d6P6b4>3j3h3N3B3>
%4j50587@:mUj@nJXM?HNK77J84APXbO8IJNOPB[h9iIO5/1gAl]d2ReGT8<@mLo0
%>HWPN@6i`NZbI6In54ch=oE8NCBDJkST1>e<>[5D1_4<=6:UNj2ga;/o0U>FkLT4
%<A07FYF]^g5;`_TgN[^>^1]MZVORN6N@6=ai03J/>FAI:/1e=7FcH34`89EJHPeK
%FXjmQW@L7h5jm82R2Z2/0J0L0T3>383F6b<h847N7:7<6/262>2@3D3P3f2T2/32
%7ZKl]2ZDn<7f7R7T7Xl?=;FLEbdgNjg1b>KDI686ZmNB2icg8fXCGi7T45LO7ian
%cGDZ>1CJ>>A:7^/cdN7n7L9>ZE=o6bA330Ee4nacL;aZ`4PD>2:8gAYfE;X1[E^X
%n4IiI06iRh4/Tb/bf]6H7J2d2h3<3b3f4@322l3N5T5L5`7/7Z7PJRc1d89n7dTj
%7ZUB/eTN8<<^iJ>ZW<VD[n;86U3c3o4nGa2fj`o_aTRlZVNO7HYK2E<f3aSnSa<^
%eVb6>9Mf<_5he6B6e<W2aS4E?Hd<FFNEYIa@8<W=3nHPPj;D18]<PNWSECe3^A:R
%eWTNND[6Sd4_hRMI2ELN>K[5``d=;;T;;aAlPjojKEF:>[7D15i81H1F1L4T4V4_
%CF7i;IR^7l7J]d28;475G`3b40485V5^5]8i^1<8Rnd<VjSe`FHeFeZ@84g@oj9h
%nY06]U9P;j2]?Ti72Q0Xb`F30dTXCK;nTgdNl1f?ALUNA2DBQ^SdWm]1;=hB`2?9
%gP^IMa2YIA1S0Tb@@N7cKL`87g6h7`7J4H4B442@2>2J3P3L3f5n5d6DR=/bL/7l
%JJMiJ@7f7QSD:S;UDbY@?@8lW2>ZBB:0j>>3>n62e78EBTY5ah6=S8odPF^DoGBD
%Ad879h6IBMmP3O:e`EFS:<_mYj=f57ZF>/ZlGFZYhF85kH89H@N5KQb?Sf?489^K
%bFP_ES:C>IkBn^^8o`FCfNNMDh9>iFC8kJ=1B7mZWB85JV>[<NlT2mSN2oESGlAn
%0N_gDWY>Fn7`8T6B4X4V4I^V`b7RD<3B3J3D80ogfoDFQ4Bng`oWRl7ZogloGjo7
%`o7hnW_5`a6Fe6gm7Hloi18I348S5937Wg:I5:c7;Cg;c1<Da<i2ki/T9`9id<Ih
%U9ll:1:gnmZ8nZ=@ZABJEBjICGno7gCgi3X587]57e0gnnWnoGLljkAWdmWXoGnn
%978;<mgaFHLoYFGkTX;Y98o8;_C[eNkiOKmOl1Bh^mjK9:CIZkPHYDlCSGk=WJ/e
%V[cNJS4OcNGe>WDV0004W<m85DgmG:ON93KGflGc8:S3WjmZk/[PoM[S=M:EY^`3
%_@?_`O`FY`e[aIRH0QbAabd?cFOci3A=U:iC[jgAiFn>e7^e4i=QhPnO4^O8L_<M
%o@aoEQ]ce/GH^[NJKeI?7Xk8FSn@Wnmj0Ll00^`2T;Z_4eZE[4T<490/Bl[51BA@
%:nBT^Z/AE`/oh5@boi>@i0ZU@T]jh<34LBA;4dC_JYBk8jTT7ZDN<HA@XAgAXoH9
%WA73^_[4Bc^dnRE_HTA3B6oheb<6DT?nA<Uad_3ka4Tb8:jORh7g:Ze:XO1k7bfb
%Z@FO`h3L>8FQR61cWFM2^[<UDN7nl`i3W>:BB2_;5cXS/VcDa1oXfKDK2;@2O4X=
%520c@`VD@GU5@6UB[:96E8;hUAn8PZK6:hnj7=THaL66;`Z2D=`dRn7HRRHLIgXS
%:4_=[88heNAMH_]C=8e[FeKa<_:?B37jd/KBE6Wo6Qf5>DiBSD=@d48@Q1?bIZ7=
%4OAc64FQDRn=a0WJT1leFOcGa4f:@8V[ZXa5C1m=]KbEW1MPRGL15h05NCnPMNX6
%g^8=lYVC1aGkG/?Xk3bVH4Y2lZ0N1DHB>V5SmQYVhO7N2>ZaK2bTUN:ACKKa:4NV
%>QiSko_n5NAWKT]MEYFLNCWRd@U=UbQ>TXENF3VIm/G8`ei2cejPLK^OIRjUPeaX
%NRJ:YSg^`TFDafT>2AgULm/2AfYRiZZU>[G/@Ejo9XYd4knR[/9MK67fbiLDf9^n
%]DeZhO/[7m::f7`X1g5^FYJ58DAAbbNjcJR@I64:2H=0VN1e7DPCJWo0YclKNh6Y
%AH><CeYT9YBaJ?9J<KnP[cY0LnKo@Z51lkII8>SA>OE;=A2:]gBFAG683P9Q8XIe
%5`Ei?1B6HM7QLCGklg4m/GOHbN<XD@MAiGUa;bJ@lWX2AZaVGC8PMO[Tek8cnfA1
%44=d9^XkBVg=MJ2QW8>HbRd005Pl6`US<78O2NM1b7LZVg:hRD5WdQk64?=J@Q4@
%k1h3a3Q0L1L2CoWmGT08oh1X81JPT?:2SdGA]996baibCTfT[N^>]HXY`f@SFF8@
%Jl9e67FNHD9Ya:cd1gId000L<aX@e;bcD_K:CnXXLVH/aIg@Fa1QV0<ol@@F/M=4
%B]>[JXEa=RM4l_D;BY6hQBB44LEaUAI>RXlUIPd4]97[65/k7`N0GS<G8;h`8e91
%=f;@WP<H=Vi84E4OKoB^`18XFPdXK`fQ`2F4X:2SCJ/fBX?T]0nQDRb5D<DG``CC
%V9RlB1A0C1?BE:4[e?;cb:4T<G1l?TWhc0G21:<olB3DWJRQ4daQY1l[U=<?<X0k
%0=0K1Z<hI0h2]S_4d8X?@NQ12:7RnDOhmb[UDV8PI48/YUBCM?1bE<ciXAOGA1Y]
%AMc4=^F2^`L3Da7@S3H9JL2<1hY=V^BU0aR8jSeFd?<LP6`808428XBhlR@0O103
%0GX^AQV=8O<8OXm2:`Z7f><Khg0]d7<m0f1c>X6Wm?o0doh1J92KXY64Q[JfXTPL
%V`@TS11ddO4IB5h`I5mSIY<lQ5S;9XbW7`B@G5;h806XLIhBE=Ch/XEXT6:DdR@W
%oGnY15HoQYE309DEN023oQQZDAj2c6JEe?ZPdFRcCCaDgAh;J[0=j]DF@Ni4ma51
%cEQVlAT30Ajc2a[@?>]Ce5dWfR<XXGQB2EAe7lF@RK=S4Sn;0?/NXF0/1R5D:dGR
%E4_6i7hF@OXmHj3i7XFRU]0H<Sm<T;<7EUIC=1QEAPS``K>1D/lQT1@K[AE36T>>
%d`7;DDoZRd@d]6Re;URB>`IPcARP90L2]M@oQdST0LIhIHdQ[3ZSXR9:/icH4R6]
%LT55bfXFA]GLmF[TiVTRJPN8Nk?Q]R:^d6FkPZK_<U7JF9>iYAmD]O8HhSYYQm3F
%6V<`5h:`C_B7n4T8XDAJ2`5hA6jQ4:kV4;>B04X90@04<lOh0@0`105]@1a/X?V`
%QE9N7]chP0fhEF@6ZBI`@7da`SB`aJ_KY4@]<><iXQ`ghWQ31n]UK;YbYB2>c62=
%Z7[b[<4NB<Lk<U8B2PaFTVQn@kDQN:UAkA@i5?nKl0ioaEI;AET>j6ClX5>Tc4YF
%QR`XiGGgTdTXo;_2Y2EUmahM/a<n6jiDTB;X>;k2QV]YdoAmV]DZB0FH]AH1^364
%l<PG0XVN0Z>0M;Rb@3d7]<4OQH2QVe7_7EER8A1j=PnF83FTA/JCYfB1`hjZJRB1
%EY/5>WI`2FCbH^^0>MB4Q<6[_9fDC0=`8Ll0Z8o1hSm7`>8b@Z@3P=1:?Dd@=@@0
%S0n0d0i31ldG;D>9W`4P80K6<<DJDoB@eZ7WJ3<cbMEKE;lGT`I963RAfhTH=8[Q
%G2/9/>o5ICRB?0]N?^o`na6R;4H8H@8PB77J7X?42`6@@3K6j>LZPm1i5P;<M/]0
%ob6SnK:3`BKDa`SL6l[m4>8DiiVfP<kRUCLL4Q>6=AQXOVL2]hlPDjANLYXQ^W]B
%9iR`TlYYV01@`6J`SV^LT39f;E73fZ]@L;O8m[iERHB36kVSoa30Cd<KgAHOM7f]
%dWYA@ZYT[>T>GZ3?:[4Qa67gZ`6n/12jd9o[Q@/?^GijB:SIhSYBQ79fM3en]I;T
%5F:lG2I@JSo7P=`C8S@oPb1h5DMaL2bYI:jJ8Oeo[2g4Cdf<GDXATn9dJ8>Y@HBl
%jC6`6KbFT@=1Bl/<;c3V60X5HfB248G_@:miYd^7?Q4e42d<>`KPg1X6N0R243h=
%A5Qk4:5h:@E36L3gV?^F0G@]QXMDFm498K@K@c=jCi1BnVU8Z`;Jd@KYa5Z:<@UF
%TDZ;@]GBE3=khWbU61>1X48ha[SId294CHSPY1V3;^@ZPnQa3J6^1T1X6AZS<6hU
%_@3RedTWKM8JWPYSE2][ZIL@kB;8I@?<134h=jbHX@`IGZeBb942CS/9iQZ1F8AJ
%1j20ohGL3RU1U@R2Zb9Hg2[YFS=14a[;7XUKBh4/5S92V:iH53J11Z33i<6ZJ2>9
%?8?47AQH>PT8Fl7kb`:@1T8IW2i8Jb5PlCTaP23XTB5ikH<jjS>0M`N0MHLH2`3H
%5hL8Khd@O8M`@@>8<X?XAXCQa3o9SYg`ZY:JCHZH[9;[hHT3i[[03L3PGHi821/h
%6/?:D;2K4I7I426hR1j:><6`_I;PRASJJhdbH8OhNKcXZH>X=X?0EXDXEa9hnj`h
%L0J`JP>X>P@8NZ?AEY?H5lDHITD[7d@TE2e@`JUhG3[PClDj>hO8Nj>9YI0i1cPJ
%Jh]Bm9aHO8<09h:XAh@3AX@P?P@8A`@T<ZNPOhNPNXL[_h<8;0=0NHMI;3o1:b`/
%=9e@R/3``K6hX@k[iZG/L@?B^1U95/6S<iY8k[dHSccD9RE9QhIZXj6;SJUPYB><
%4`XCh`UJ2TIA6@k/0:58_8ihIj8KX:6K2X=[dLE4QSTh[2<2<:181JCh?P44R`64
%S0^PD3LJBhU8_8j[TJ[cLXTCUiajl1L@T0M0IHHPG80cG0N8dCFHLX1Xc`IXK`La
%K@dio8NXN8N@NPehO8dRjTGH[XSbR`HLY094Y@oj:h4KS`EYPP/DK`T3iKD`RkT[
%WR:TQZ^@/i:jEH]@fBOhO[HHLPL@LH2X2H3`I0HhJRliBhN`E0C@Bj[0H10dMhOk
%2kC<F4[L6Z:C29[1X@abZTX<2RYdGA^3jI;0Z//IaHN`O0M`MPMbbkPH^0d`L`K@
%JPH@<X=H?8Nh^0OS>10`ZIlPR:obaCMD`HYCBki[b@<b4/PP/CW@Y;/IKT59PXSX
%jZjL@IiJR`3dg`oZXX0RbX7DSPY8n4`;/A]A1liHXd6Hda4KdCE<ZR<8XC8XD:68
%ohETkDfD_TkYiP/A8H@bY:Y@H/lZ:/FbJJS8YId/m@TS6hjXjD9jk@A@[XQXO0Kh
%CPBX@H9X;@=HNHZH4H1P4P3P0h2`D0F8Fa=8OHL`LhJjnP780DU`GXHXJhQ8[Hg3
%PKF8OPNlY0HI08;Yai@P=1k8CB=kD;/90/54^jHHRlMdk`Y`Z<cdaI1H_0f`f8O0
%NXMPC`CXC8CXCXDXEHEXG9;aM0OhMhMX=H;h;a6SV`e1Y@S[CjkP<[hm5kED2@R0
%BM;9?:Vld4FD[43kR:oJljJl41l]3H/8ejoa7Te0OHLPD`D@B@FPG`HhNIL56TaH
%j`dbRk7:ShM:BXC`==@:T8APJM@/KjE4fHRT@4mCol=j:LgBCLjB5KW390oiWQd8
%KlTJjLkUAJlI/iB92:W0OaPQbHjZ_`;2R@0Xok3CX[Q]:]Eii29DK5FJ2lik7dYk
%3DO[TeAL?aFIR/mD4`I5H@3mHPQ2H8OHLhL0K@IP000@1`586090HHFHIJY01HEH
%G8GBH8O0M0L`JXYhN0GXH8I0=H>H@YLJ`QLDb0KX5@584SCX5;KPB:91bH4ENc2K
%RPIdfUF/_JeD9EEiaB_=9bjROa;9;Ro@ZPF39H1PghMHM@MZhP/`_8IMRP5URc[d
%`]F2Z9?8TT>R6XJ17JbH8eTH4eT/Yl9KWLM[dhQiEH[LX8f5H`;P;H:`N0NHNm8[
%]DJk`SkPPC/hLDEc2hAmXEC3V=S@_L2L[@T@kY/lPc0Xg[L0EaPUOi6B7@gZJ91k
%LLg`3eE8oj=mZL2=GeXaG2O[IeAP^3daL5/jea;aom9alK`Q:B`Q]`OXOCfh:8C4
%^@]Bjb6l=UUm/mAUU<_LZ`NiO888E8DhD`QaeCMEQhNEM8eXO5Vcg:e[`91HB0B8
%BHIHI`JLB`THLHL@K`GXGXGM:S70W0B3:h:82UeLSDSXjdZM<De:c5/@P820?n1@
%>2@F3@=n`V3?b6@R5@9ma63A5m_F;0j<?Z=?V>@N?An@B6AB>BBFCBNBaB3@Un`a
%n8NH?>I;2J0VK02L0:MCP0::OAal`>PBbD@=oDNFD2G@>;?FJ;08E5aE>5`f1=Z/
%9:]6N^:2_=b`B:S_jRfFcFNd@>U`F/=X6fnM0:N66jFZ[@AkGVdd2?aYm@>NBZdh
%=ogj1]340?5C`4Hf^6Ne`C8f?3HC;IO<B=o?f8@;>?o?`:bFAojCCJ:1?ZbJYo__
%>hFb?fajS2_al_[KK5I;AHS8J366Go@H;Binb?amdS1f?8gIn@=Fm4Lm?TJ?DIEo
%l7?IkP[QL;IF:aE@Im?UnNGWjC?Bb7mV6F=iO6K0URoDCOM<OV?dCADNB_hc<0`4
%XZlW/PKR:Zij?@05<6VA1l1`S2D9[4ocDXdUR:3I3J1Q_3`3A0WP0a6WP<a<O4D@
%BXbSYLRSIX;04G/T^joATJ<KT778gAfELNWI7j?YLiZ88U2TS@TNTTYLjHLYhWPF
%BQ0/G@/Oikb/c<JbXidAP38jB^`PI:C59bLBhElcX=99jAFmDQbm=l9/o>C]X<dk
%=]:fSI=0jdlCg2amWhOan<hfD;=8g1lPn48?6FIITXBecn_E0im<iBK<b/Nj9XR4
%U>V6HARc`Y/489>AR68HC_5/N=F;6URU^>i<I@?8Z3RoFi2ecEQhS]GZ:CLmR4c0
%PBU;_>5S`4_TH8CIC@?K6BF39JA;FYI5[F^_J>;6C=^7AK`EG1<P009LT^0GLigG
%BUUQ[?H/5B[:mR8ha1X3_N`jg`j9FZKFQm`1>ZT?K3=JfaP[BbXX3R3KQJN0EQec
%PGAYU^9:M;`S:B8[6;N=a@O62[7RR8[l:fB<D0JN0SU9`iFoKfh=Uk2CVd4j8:dk
%Zc_?5;idPE1cjOEo=??[B4FAY52h;P]AHUTIDcXC1Z1FJ2hjPI6JZ:PYR]?Z?FDO
%YO5lGRN2V:HXg`>Z7=2OM:jdOnYi[:QhKPIfi1?^VXWnX2VeMUd;WeYZ2`;V70Y2
%RUVgnPFfX9MQ6lF>76gi`G8B>iR6L0PYgl^[A95;cMb08]h6[RWSkQ<_Zo@a_J2K
%dd:EXC[aOEj>`imTGWJBcRdfDgB<IgO5G8bl/LI;6FWQlj0oS9hBOTX=`[fcLU38
%^a6EfHo:SRAnMP?NcLD?1_/jGAUDWOO5D^J91X;AbdXc2WdO1nkBccKd<R50ijdQ
%l8hM]dPWoMMen^j0735WGHgI0X4`90E6f=XKY0e<_BOHIi5QNDeZB<RBd`YiVc[m
%>LD`RbD0F2kQ11TP@gHB2XQ<@=jJlQlXbL@n=gcNDZ@]8:n4Hl=@F`gMa2j7B0f>
%SVQlF<=D@B1PaR8bQU89HTA96a4^1[jGDU7;lVhn8lQIAE3G5L?lFECS4QBDE_c1
%gK]lGM3]8af1eAWOf1<WSaP3Q<SLS8UbcFk839T?<PdDgaAO<S5]TbG02ao3;85g
%/H8b@jITB6<923AZF=TLPcZMbb8X=VJA@3CTn/T2/8VCBoD0?ORLFIh30Fd4ALN?
%l>HLPjQf3Z7Qj;jD<Yd?HkUYbk3/;/4_;L:<^F>X0:01nG`M9P46LZJdR<Gi2/`H
%B[FC`oUV_Q>LGiQ`2RTTMV?=DTQOQMCIHf5/34gAWcO;6lTBJjAg46KP?0PI?QA<
%Y0REhD48UW4];^iLMjnPdCg4=?TK<niT^jMHJ4YYTD2[=Pf//O/GI[6IF2?dX0A:
%7A[N<1ZRCehLTP8Y04U4]B=@X8e0hhBeef:INH?dB59FC6<<J;FUAHj2D9LRd4cA
%]3C:4<hA8Q@oSGDh7b?M0aI4[54J2oDe:oQUE5@J2VGKZ:<5UQU<BOa7QYeALk7D
%lU7IABU>8/fUXoiB`<GS60RQ568Cd;7:DM]Ij7142CF^;mFbQ^XYL/NY[07PC`87
%1j6Xajhek8m5T?h>[0>;4JE<LCZQdf7/4l69aKE`0Z2cHm=A0hO3V?b9QQHKG<a;
%6aAEg;R4Q;6DTkUJ5L;@W[MGG`b`R;E4lA00HWP`;HBQ?Dn1S<WbdFSURY8De^ga
%EK>LF<8m`IXTl0[LDLUai1fXF]C0/AZ7g5oC^@ZSM>3BSk7`?@N8hA_SN7Z?@eCj
%1oUiD6WbXECZSRo_AEFSmBbcW4]Tji/@Dif;D4]KnDA7kIDE]aNZcS?268k3L7_0
%Eo;C;f3_AEYM][UCFSTDMFhGa?HARjoiMlcRdHF89QQ01f80[/F0/lXiCADhSC49
%@PKR8YT^ARU@/HCLG<M/ECQFZV@/He^:1D:V>L8RNS>>Z;ZKW`hH`FUiibA5IFb7
%lGjKhcjCTi9d83:52hMFbBiT<LnE`>IIA4R<8FGC/AaVY8A`lT/5I39ALbA4S3Rg
%?=1M1]8mXkDh7H>PLX0BL2Z5B:loe=dn?a=8oDXhUM1He2aSl^n@KJee8lF=K`j;
%10QdP2kBF9Hj]fb4P/Q>AIhiWU3E4JJ9P<d5`bA4b>@624NPZlfd6IT1aM;m>9J@
%I7UiQM;MnA;cmEjUeGRM51TCR9^;m5nY9XIjCK0I/O;X@WGH4dgOhlkYc@S[fU[7
%GSkB4i;3c]T<ffaEKM/[A83@W=a9^V==NSNA]F;GEN@b[ITHYPMgPG6?h1DVEcFa
%Ki_QP2LJGV><?ObG5a1bh5Z:9ZP]EklgCOPfQV/e4]7f?USe><TZJ^XKH9`BPSSA
%6N=060;`J3U7:>^WkmQlYj>bYIBB1MSP<[>>gMIb5JR>iTa9S/GF@4Agl<>C6h0^
%lmHU@/bMmb2kUOFNGFSKV;<3b>I@SChE<PhjP:CZA1Z^fUS087[1cV:TD65edFoG
%mJl9@5R[41jQ[MW15fWE=Yb3gi@UQ`m[Q>SW^7i]8MHJNl3OkeAbSi0nkH=7mb0L
%]m:ZISHmdSDChIB/[72fG0gF10S1lU/0SFB`EnG;X66b?B>bCb=]g?XWHT_@`H/M
%QS/fkFa60R>3eT6W1>f@CUG1J;B8T`4>G4^9lhZRbf[?3X>]oAL:KFB5>A6_3d<Y
%hLDhX/1G2]4:8<@BN1W3=6T60<0ISoGUCdXLR:00aoO3in5=Q;;hTl`CjDSB^a8o
%[Q^2fXlVQ4Zk;m<<oU1gfA`/ncU@R2U9T/iZg>T>9:;6DbWD1o0<0g0@l4S`l@84
%@:>`2G0P2=0TV6K>bP40Wb4<GFg>n2CRdbeF;lbb0h;06hK/YHkVSV]^NZEZbT8:
%>`SZDj18Fh4b9Lf2B/W4^22>HPj8edfNXnO2kFB28HP0XFH4kRe>7nN^/N2bR81R
%6_2Lg/ZL[/gA0h@VbneFMDg44hbf02]J5?2m1@O6H`b>Vg2P[R8XfBG4113D/8CH
%VJe8;_312XMBhF94IT@bAH>27^^jR^3FD47j^j7^Ij4F4H4P6R6T6/7^7`=HClD6
%i<ATk>6]0@0f>`V03X;R354`CH;libT23:0U4nT`]P60>8UY0f>h?>ZlDd8:hPYb
%^L>N_HUPZJ;l8Y16o23he10T2<?25HSZkPkH[Y0d7e3hKX1>W><R3S6@]D4@^C3T
%@2kFHdHfafVF[XWn<bmnCH8X>`X^8B`N2m6lWP[Bd8]f5<ljS6QDddlf8>Rn[32>
%94>8l:K^c2>`/ZLn:NH[7BP2lk6J@Xo>]`6[7n8`0L<J0@9hW^3@:4c33RCNNQ0f
%XlgBN/Ao12bJ00[F2B8734eV:2]=7fO=3Xn8UP8S8dClOD7n68666<5052567:7<
%7D7X7Z7^O>PPY`8HGl>47jL^7J861i9h:N2M9n0402080:080>@N6@W>4k:D1O:H
%M76Dk/mLZLGHL@8i5D7k:D4j<NkJYU3X`XAPn<Mb5c;42E;8a_4jkd6o30UJaTD0
%d>njM@4o;RKT6LAT3a;/49;`GHhA8hO<BXo>8<Q<5@27<6_DaS8D;>P330AU0a4T
%Lf5:L@Dc6NaHRLaFh<MhL6dC8b>8@:mXb?6dE[590fA^6RkB14k`3Bem1F?K3;;h
%</_f8:/J9hI=:H1NHjen?Nj4LS7P870F^DkF:0MLh0C83m>98b_`c;7fc@90CT>2
%=S4J=^>@D2=86/6^6f00020:7@7B7F=87/7^?<8Bcn:8D2=0B/7ZIX/ZUl0n]J0>
%0<0B0/0Z0`nn36SBUb2R>l5`>8W9:S6Y0H@bEfa^l4KbYZDZ>ZKBlm1@CT^>78`4
%3g?D1Y@Q;R4n>a7G<bfLIJD:o@=`;_7P9Hh43Ta;8M=J<`kL89@FVj0`W>CI1i5P
%@5=f8:dll^1FI<g0mH70iO22GNXdXo30jg92kV/nGNATjZ8?5l@0CDHZ86N^2eBI
%=Y;@o?27@cA6<`lXXn<Nm`9e87;V[XX@FAAfkiA4[fJHZn9LlPLk2fMX5h>Ll1BV
%dG8lO8CgCROL?NF9@fIhL>=L5R5X5b2H2N2XnhhNXkCTD2>BcJ=/<m926YDDM69b
%06040:bM:4<Nl4WP_HLW<_:U5<IWDf7j@f3I;/3`JLP/I`=>aF7h5R5R5NaZ2]4n
%0UDm=6_EAK2S@_EXE;0lGNjDWP2UEflPCBBCCJ;BO2[N=32I555m>>n09<@16f7j
%/W5l_@5o<JLfSL2HWDX[;f8>CLFJCM1YDdkYC1;lDQ@/c4fKG:mj]<oF4Ra^5MGH
%UUA9CNYW98]V9F<j8DFNL4Tj8Hjn5^M2bL04W4CHd]7JF@]a<[76gBV73L7g0<1n
%;RBi4U:Pj@ga;h=8T><nYbCT;9D:TZX>HbD67<IF3>36303N3L3R9`0H545@5XIn
%TD>6X?HZ:?;JTXhO;`44^69`mB01DO::9bHP1[J0Z:6EFi25?2RM7e?m;0=1@GFX
%?@P/JL7`7^^P7nW>4EJ/kB101/1/1X:d4PSZmnP328eEB4U3H2RQ0fj8>`:14T0_
%KK176_F09<L@K/>a;`48MT3W3[2<hNkWB9BR86dm@JZ>2;L8>L9M8ZMP;6GdBH95
%=BGlk;KR886=LW1PLJ3Q@ZZN;`;dDTFP;98dMeHZD/DSJOB4=@D2l>@=5@^jD?CN
%<90Xj/CMA/0]MW8WEf2U2XbXA6b7Gc>T?D9H77N1MV0]=T<E8Z[Xde8iHZhF>4Hm
%G/C`=`KH=L7g>n^lGB0h0D0<7<6/6>7b7R7H000<0f6P6m4DD/I_J:cn847R7Z7/
%5b5d5hSBA49`0C?J0?:8I@0P0V0204089iC>9`/K:SKYFm2TKHABQW=Dll866CPH
%`O83BH2djj64LPP9Lf8>9H@;4_4`2_PiKJ0^lHHZ@0ZK=OF0O2@:[bZ?Q4AAETe<
%7g7Bi^MddP12`=PH6BM=0foPNi<n7g?E4P:0M]F57UP9KRlI?//01d;JK>f694RR
%L>F998Y_M6@DGO5NET<:B]9d7hHlV:A@DSFB<8;l_HDc<627HLA712XX[iHV>`<3
%H6V?A;?j7n:NBi>400Ab47GL:;SPV]NEDfKI0J>bIX7`=L;e5D7f3?Ph5@4N4D<:
%7@6J645d0>0T1J7H=M?8>@hX_3?<7/7d6j70780V0/0e>^05DL0:?V2P2L2J3^3Z
%3XnH5JR81N4^4/4b7P7R7V;m;AFQ2c=kAb8<HjaP`EFGAnhPA@WLdT1LZ>Eb4;=j
%`gR6F?A`l<8<Db2AVZd8ff3<WLib4eVi05K>e]CJjD_MIU2?A@6gW>8=5/WMA:8X
%Hj9L6IWPK:GXBoFlicPlajDbRoE1:e0IE/=3NA;iMNS0oP0YX::O6IFnb<=9Ln8@
%?F>:=SGVUWD>=J=1Rf7aXGMJ9<oaD`g8Znm/G4Lj[bgBmP8:9LmTc=<[PaP/863e
%YJHJHLLkLV6<K?EUFAC4CX?EMAT3SmIJAB7d?R7L1JgP7J6/6P<:7>1P1:0j3l4@
%527R847Y9R8PYgX^=X20262>0h0n164<4D4F76747:E:?BTHfj5@201n24D1YcP?
%7S94khRRefn9G5Lb9M=7@nHQ5c;45cVVB/LA=HF>80nh4oh91H=1bk2BG2h:GhLW
%HQ1GM4h4nh;5Gi6H:oHi1h<mY17Y58i99I=9iA9We:h:oYM77k5Hm87]2BjV9a;W
%lLIhBIm<X?>X:[j86:<::@O:DlJI<8[>WaDJ51ha6J18Xbo7;F`IGGOGiY98ZnK9
%5h7:KAJKEJkI1:Rn8lb;T5[XN[]Kk<niFnXmFGhoGno88oXg18jogkQ<7Rl@nGjo
%7`/e/^TXUD^ngZlWoV<Dmge;[K;M118[<99FH:aMD0=H0mM[00Q]UHM3]M]JYYCi
%LFmiN=__mo<9QDh=Z8>=^@1^E/0icG?ch;aWo>^9`>]enWQ/Hog]1>kP/AfGgPWe
%5WjlWTl124@TlVjf4ZPSR1mHX5@_FHfWYh7LkGB9hVRLAa7TNlK^<Lcao?0_C09J
%a9n;dO1k/<2@8PXK9]6hScR9P_J[Y8Nl@X:/Ql^Tdb24g58NaF4TFR[5i8aRj:<^
%ZPRm^a71oa2NlC/2SB23Q88OB6VR/S38i?BBTiABHKlW>6dLMA36/LbZf/X<DOlK
%X>gaoTe;h[c2FLaPk<YhC>PYTcDSdMUk=a]CQ6In>97J?B`jBB;g4SY2]?Y7CnSK
%3^hT:2:bfT[DAA:39dNU6X:YQhR7B@MDXiiccU7[YBc@;Y/O@ZF/<V9k7H]a:4`D
%8G1T7LK;MB4/df]LNd31[RanOlcWP3EM03GSG068=PCZ`LXdE:cYBfjLXfAH]4fF
%]BM75J86fVf3H2SJjmeTX=RFIK[/]7;;^^h`=?/9CbHX8NMe1N40@PTeQN5DCHC0
%j2P_S>?9e`W@AmT<@Q2VZJa[<E1K2?0k9jhCC[4<4Od6Wj?0kSd=`gSR_/JBSC=K
%A93M^7o>1]3cT@7I89VC:8Ej:gDNH:iJK>G[cI5]Fld:H:b@nL1OWAeIhdAoC2:i
%?j57/NVQXeM0e=aNa6/[B85VNJJROl^jHO:[ZcB`7jeTP74G[`^K1JH6TK/VKE/P
%/?;?:D9X?UJ?F@d]19?4Q^KZ^P;6K_<@A5ZFnfNUeQ<A@CY8[W13PYa1LLDP^Z@f
%`K0HLj=?/IM1o7NOIl7N?A04LAQ9U6PFf7ZlB;>bflZEW]2EROeP2mLf6]0OWQe>
%9e6o>a]b3_@cGKd@hTmJK7dibRFWRP9hh4NBf3I4<]3ZNOg[P<9F3_N[1^6lVNYl
%[haAj>jm9oWcDQl7PNk2KHaD97V9XURHlJo/8OC0A:cM2Wg;:H[iCf79LOQc3U7@
%N`2RSAj8mM/h8OZcR34`5E0eB@@fkQcPT>62Q>V>473M1T?46ba42NNoQ^COH;][
%8:8b4ac@>3SQDch_HUXG5b6@@E@j?AO@e0W3Ma@^8I:4NRe9Z18gOT[0o4>2@LdE
%Pm4[4TM4Bg6YJ9FWPPT8eI[79HMj7S?R/UGRTRQ58<8_5I9dG^3l?Hb5XA8kDUi7
%1RA[C:1dY@O3DVZKZ=a1AP2>V7<Bi=EiPbh3m7H?XNHj0=0R1X</Jhjec7N@PE=j
%QK4/<M>Y2hBa/04bE=PbQaQDHbWFFA9dUL@BnBK=ZCZ7i8TZ1]U@K1hh105b]QQ6
%1SdY2>@7U4BQCJ3Aj?F>d`AbHo7i9J<8GXa0lAl3c7F?T]cmQo3A6P<`?HN@m6:N
%fPZG[SbP^@V``TNKT@V1=2NT`DBE6c5n98>2L`OYd=81a>/E<kDR]WD:[H]liQ`0
%GW/`TNZVV?BeIl@ET`C01D17I@>OZXAnaWOj[HWAEF3SNXL7NR3<ilClDC5U]A=9
%`1JXdR@<]7DGQEKRC5]CL6e4NRfl:Tc`BB8LD4L@[:?B5Q;3kC=3m1ZJdDIY:1e:
%`d/UI7CCl8E@@Oe3W/1N2PhF5TM7loMQQfgYT6;P?/L`jA_SC020h3hj2h9c8/?i
%dKdc5B==3CL_Hf:c07[@]DeR@@hDkDG?^W4@6<W2EXCXDeMjhU]YM@XUe9gEBQ7n
%LP6eJP00S/=?R1E1Jl[?PFmELK3eT[T<@^JYSYBbSl7VFhNaO9T464Z9@B0cQV3=
%?;DbbB2e@6XOfAbHAhC22a5T;@6E/blf:[X?dFe^@YFkK^6Ng`e;PEo[LAjVlBad
%=YM:[D_m;Jh;NF@d2MH>5L9f[YM@a:DF[c`O3BXPT1;5[6E/7FlAG@617_<:Bm2B
%A?0Y_IM<PkA;ZgO9:YI^hakk=EAkCL_ef[4gbYFU64M2jBU^;O9XPPJ<46`_/<MQ
%Hn9TE;?<mbJQfAiSiKHMdOHj1D2K4P58<8LQgAA9H?h^2iY/6e[95DOk:`Fh]/82
%_62T6;/7RQOh]<7eN01a/XU:QFEXSR0QT4f6>@Yi5AkA<PkPLMbV<FPeLDOC5WP?
%17^dkT2h9JbT@Bd@b`:PD0P<@H@`kBUo/T?PRc1eH>AcEI2YhohD3CcQ;1;8kLj2
%3c/Rd4P<Lm4h4`kVkMWKU6gL30M`SJVIb?_OKM@BMb<S[dL3cB56P]5O7O6Q1Ef/
%Ugn:^FlFFWB/Uk6OZ66h4aYJUCUGnVnVBAjM5TlT16U;5B@KNB];/];iGmPAS>Ti
%Ka@jm9l4T2F`A1R145M]`Ai[TVO7j?POUWC2HH7D3H4h7aLS96`>]>`nQf3[7RN2
%?;YbG<b8iKh<j_YE?7[<=RC>IVeJYeEGi6f:SHK^eDL14Rb1FkiEm@40A/1;koIW
%4gN]HLVc9a8jIPcTn4>C<>jFdbRd6T2VVXD`4_c`K<LQ=MQKTKG>Vc/8>SXIB2Ro
%i8d3H84PaLYe2<lTm]d[5kWdMBhM1/i6W^e1JkPoj73Nca4GVM:=jm1RMH2<A;Rg
%PKj@:kYEOlJgFj4B8<gD@JMCIGYo5A^ZaE_jc_E7^0BG:7[MLJX8@TDRK6gfL8P@
%PQQ;2<4PM3ol8e;?2N4N@nak64`L>LK88P9P<50:hFheQdBi8h<LGX^d`QM2J54;
%6gbfUkk0@@EOTjd7d=I_c/]Om;Jaj5dEjQFLLm?AaSF3lAMcb[09b_Vc`n]eih8j
%HjKg<B^Vbbi@kG/?LHWfJGXk^KL7:N]>Z3R76lf>VMVjh0]k0DP^nHf@A^S]/KaO
%UJ`PGCJN7F7=mUUhfJm/7RK`:N<_RmhZ9ei7XHa_d0AoDd8Ci1LTIoL3n3dE>>GH
%4b^@HR_nMfh3eco<Z30`Oh=l0CZH6RO3j`Pc9@PSmkYkFcoXcJ3b=8OZ>H3d2SY0
%3JXkmaQ8?@?8?P4D3`H0HPH8OCIY7`OHO;<bbI;@LPJXIX10eP@XAhBadJ:<4hoX
%Z@3H3h4ca`jj>If;diX0W@jCnD1[NXg<20O`gP;KnCnH]8]j3hhQgH6l:@f3OP44
%:`]kN3X:GSf0OaoAkSKkfYdbYC:;QC=B[XOHakfHNhZ@dSQ9ZK<S=;4kSSS8a@V1
%=@I8GL?9@l8RPaVL0h]0]hX`337kG3FJ`4@400PY`8DlAQf8H<AkG2k9Pl9T9Q3[
%5BjcV<;;9IVH_J]Rj9gKmjO0hS[4BQKIjPZl18Oi9`Kl2P3cSl@BRbd`N[IPE`F@
%FJN`2XAHAAiXcIQ8N:cIlanXOQ48N8McQ`j8OXHhG`Gh^P3`JHJhKd7IVXSP_IH0
%88f1Gd:`42PHMT0klbDZob:R`2WDDXd<9Kj@PZh0JQf;7:EX1JgH:C6/?keb?@U[
%29C/;LBL<h``aAd[=2>`lXNjG8cJ>ZdZ?;Rd<[SC=JGKg3XJn1FQgL@cG2Uj48fZ
%]RR0>l@aFKP<A;l;V8PYfH9DTCiP5c>0JJVklZ7Q@lCDLZ<P[94PR/E;0Anj_Yh;
%@lR[Yj9[10=40TDRP`Sa;/Lk6bTRi9S@OPJ<Y1UX2[mSmP;<Y`_YnHdPPPLZL`70
%6@60989@8PNXNhN9L`e3SRYPOY49dHO0O@O8N0NH>@>@?@BhCHDDJ@]XRX@4^Sdh
%f0ID_2U94YF`ZlL3nK?`P/R<UY:hSSnA;ZL2`Pf3GXD8V4XBaL;J40a2[/<2YakR
%D;h2cZi;^CIHa0O@N`NXN9KkRS<XR`ac=Y1chTQSeX_<NH[0S8]l_`]94S>PMX1D
%fd1Kjkl;Wi?IFaI0C<gkm@2:=lU1IDBhZSoT`HP`P820?n1@>2@F3@N4@V3?f6@U
%l@mka65@ElaF9aN<AV=A^6?enAn3@ml@<hbD>BMOBUiB^>af1_^HA^IC>J@R:_V4
%c2M?^1YVO1NP:^QAmn62S9bT?jUBn1?N1>mjB=n@9l_LdV`aQ/@1UW/eV?mo?nN?
%ml_em?Uk>mo_fYCbY[EJ[eAZIF_f`cF2<>m02n0RoG`08?1@=kHF4hEk@Ijh^lHg
%7@UmI61i5mI?8dZk_o:Ho>Ig7c[5H_4BnHIPgJL2JW00WF=CG@>RIkIAVke>`KF1
%?fN?jk@;KIUoIEob>ef?RCSLcbfF;R?]o?an_9i_>k_Yn_oKFF`iV1Kb`MO_F^`N
%>bAJ4J3L`bMDBF`c<@j7ik<;7j=3k@=LoUcO^4a6W>jYCd;4V1b@:9D3QO19Y`FP
%bM<fgb@@0OcAX:f;I`_34<YW1kb^@PSo=Q2<1[6PSYWW3DD8c0B1_NPClUbX0;SZ
%>Hj7PMah_6Qk4[F^cN:FPkN_8kS^aBVC<:92c/8n8lV1Y9a/BQ5RU0m:Q/b/Pc/X
%4O3[^`PAm7`/9m5>EQBPX2@8TTB18[74SQW^Mie1B40@Sd>XlTLAa:=]8:JWE?dZ
%0l0=1<09e2YfV<9=94RRAJcC9B;5=6_K;SKWlDe;b58TQ?0gKQ>8b[]]l/B`^_;S
%`DdlT^;_D;b898K>Z93T/A4M]J`B5k0<05EM/FN]8DSDEFe=DcLEJOe>]c;:a86Q
%Zc;0gJcDNlQkWfSmCX@ke/dY5Scd@PRGDBRK<G1556/`4md6kMDSa59<1<XCmhPc
%NHlG[AE6`i1mXc0lBZ<RglFE;CE@^L]MEeoQ64hEQN68bN9gWL<P_S24P=16GQJU
%hPF2WfiZ5^PcBY]eSK]i0Q]B?M7mG:ELU6X_MSK@k0EhTn4VK3OW2A;aPkb7`NbW
%=hSimE8KFRQ]XhXRT:Aj<FimX7fO9mHNN3ai0RmbBC9PS]H1;00e[kmW=LJ6hK/Z
%4e9]63Ahk4NP0081dcO/^:Z]K4W`MSQW6K9YV:KQ^W2Ii[6dN1n7LM1gW>KAY7:K
%YZWHJa^W:hVecHg=Ul_E=DK<XT[6b1_?/00_A3?dSea5AFFiE/eDIiEmFh2km^KS
%COHg5fGEmaIVb88bS<15gi`N2c7QiELSG6Y@XW1WiI]nJNWW`KKb5WfhF2WdZN2l
%^NUS^D]K:n_bin>NOik97JVBMOg?eOGmWLj2NilV>GYS1:3`BSD=8bV/K1Y7Tb9b
%4;?F;:Uljk<CN?D<BAihS`bR4jG8@UBL47MRhPX3:2bCPJ2kPdkYKI=FM7YDXXM4
%PkhB1YQ<1n50eXE=SDXI@SZBEg?B84WPA`1XK60Q/0HnP/H9@MOJ[lO0nQk]Y=j?
%]JPn6A5l04?X/IHAl3e:VW/WRKbe]h7X=X>8JP/5l08:TF@]bW3b72>PK`9P?0e0
%T0/5@^aPS<@lb0OIebaabHfN8^jZWLTR8j:V?RPP0Zi;h::@A1VH469_3nA4RHO[
%TET@844SfRSJIL@DILU@ZBGD0H8@I7I3[HMDNU=Se1jYQSR?XN[DBaTh8l//OY>8
%h737V?LZHmRLBd;2`2AD^IMBk9X?b9PoQlU^7n>lMXl0kQf3TBL30A0SQ;5<:TEb
%eGa:S>6mQ7jU4^72QlAM0DTb2@=D>:NLDU`Z0SW<:FM10i>Y:IRQN1jGUY43Sh:T
%1DmA=cgDDP:Mj?8O3:Wm3T`01j1@V3Bm54TgYN6c;_<5;If5B?HP6fh0JZeC5D;2
%?MG`o1j737DF0M0Wa<R92X5T;Z7QoSd7h?/NP:@CPlW4<69[^Vf9M?6`MJk[V5c[
%?lCX<U?@1doZ13TJ]@e546<A?^Q=BJU6NBBRH65CeiPI@:>A:@oZQSE2aEV507a5
%EM7CElba`Y_TOVlRd/Hm1kSh7Lg:VPn2N5WU7BXZLYQlTSS^N=Z0nak=3F=D^_eO
%i4/77X?>^aTc5Sa5H:/F8?0MQ1CV24?hP@n3R7;9:EQVRY;7C2d:PaR96ZE8^id>
%MX`7fU29JLCEZD>@O]0Idc288@8[Hf]hbRjQ^PX]`5VgA:ai43Ek1b5c^ahG31;L
%Ed@1C00a^E2m4Bn9hf0<Njd]HmAkUA7jnLOPFP]QK[BZ1CEO6AW;7mH@MhgP?PK0
%N:`FH]akBY7N=LIhbVg0D7?F]n2VUVY4MMCMmR9R3G37QLD4YP01H5^D35dc<ImY
%9^QPg1c;bU1k`T1;2SWG>QO``173@S<>H0WG?XmA<<6@P8;BXN`jB1DK8jIE2:G:
%D_N>@Onm/ecM5::VM^?63lMHk@dC2Te5iJ9NHf/i;XcQVS@3H6`=05P;P=0X1D1h
%A`RQ@4684A`_QP2m7H>m/ChbI4g?/=2NMX`iPic<il1X7Le1ncH>?=e[59HQDFjL
%adnco8DMiLnMV60_fh1@<c@4724U43;XFX1P<dBA]U?bY6?2IDY<c@aU1VR`eiGh
%NB^Y^cdSe7NgQ2Hm1f3Q097l<XK0h1N326D?XJ`cPN0P0l60?0UE[KGCAKKUKlGl
%QnB9A^H@7Jo`:08`0H]RH;8oX_AfbIMVDdFldKIP11KA0[]<@^eAhkGZ:@E3V8b5
%8]?0Z2F@oDCVJ7n?DOXSQ0R:3HDH;PE`/Qc3h8LMQUIE5CXKF;LU=:LK:gi_dQ1d
%6DWQFniH]`mYFSfa^I<LXi1`2c5T;P>`MPo0h1d3L1`405PQ121m@6JP>lJ122WT
%B^`ELPfV1G?`CNE27iH<7U`jnH:cWKRC4^8/j6=PL@aG]2>J8SM@@`D7@NCRFj8X
%ff0oaBM9X3@8`4PQAE6<<Q20dWmo>fYZ@8N@m1h]Y7f?4NHl6dUR[8bajRcg_2TY
%04<8@?Aha8UFn@NPH@W1?4@9DDKE3K]eUDcdZU<VC^JK;XeKi39kRKT000_`21DN
%;j>@>eWEO8@o/nCL27U@eNG]ic`Oj9UbK8G2@LWMMD]7HaAi/<@FPcR43`8Xc@n`
%]=94V9lEZ>?=UVg]@`lTZO0NAmiXiH[@d^<M7]:<k/1B9;7LbUfH6UVQ_I>l=kj0
%hOY3RnY/hJGeo/O@6l>ckQSlE[B<XTWcAWYeXQB@^@S/gQ^O[1Gnd;_kkFBA0]o?
%`hG_k4jj<A8P_P_N^l7bhBGdXHP:dZXHN^JR7h>@?10DDL2HBHj84/7bIh7F7H0^
%040:6@6X707BRRklFVm6?BYVEHM`8jdFo:842e1@^><0]:0NTRZZfbok1RH@THcd
%lB]ngni^8dQH[:DJXd;86j6F5f5B0F0N1@7TEl;87f1<0^0P6B6/6h7J84n8;^In
%9P>8=/Ua1U2d^P;^;LI49P?nUJ9`>0R@7^A`U^DlL//f<d=j>0dHMfT8IDPG1hgf
%8^?I3P<jlll6QJcd<`@49^A<o/2lclZ^c<1bM2M4I/18f^mX8`^2Vg2fMZXNWh[^
%7h5:5>54dZdZP:?D<RC0:D7/JHf406706n752`OP6X5f5l0l0D0NY@7n]j7n7^I>
%H4?72@:LDi12[jl2Mg1<[67hA=4Df2<01e6<ca3e4S6D=T/n<`lZ0PE[2R@TVjID
%oa3W3ZQ0?O151l7d6j423L2f3X3f4ZNf7n645Z5d0d0H0>7N[LXfL^7a5XFdSZBD
%OC6G7^UbPDGh<RSR;^7^g`>`aDRA4dkj>:BlSRR@BlF_7`;`BC4NlL?Rof8H:@4h
%lB<0Sl^>6K8e1XRHFlo77`^TZZa/00f54fdXVX8J7i0V7H2d2b2hRh4P4NCd>^6Z
%6P6T0l0F0H0R040>5h5l6D?n7U0@I4e]5V:JGj>Dee6`Udd06HWZ0Dl>=>3LW0CJ
%]VA8f<h14Q8I7`G8Qc1_3NQlJ`F]3`9[2j<B7f781^1:0/585D5`732R;h0D3230
%3:Gj;26h6f6/3J3H3N0@0B167I2R?27hElh5:g<@OF;6AfR4nK7XSZRX7h7`>@7X
%ab7l[L7[5TF[7Y:G<B8>o4jX86lJ84Pd5fX0T04==BlO:/9b=:N97`dbKRC2FTKL
%00N^UU<^O4GhR<;@Ak7lh@JZ908J<TNZV[:<^^7l:LLZ>@96LZknMV[n<`4Y>V<0
%d>;h5W>`o=1:?<@k<m<B<@]H8k:NEj`h4H`0[3:n9^fh9X=[3@Y>7>5:4^4D060>
%0<2b3<3L1l2<2`5P5Z6<blKX7R7<>:121D2>712Rn6[]7O:[>m@LHD=fO:7V7J=/
%Hl7n3X3V3N3^382f382/2V3D3/48mXR@=f96I6O47VTk<k@N8:NO7O;11N84`0oV
%0]8^D4Jn0dclK2PFT<8ZdG8o1RMk</WHD77X[h;;9>=dF/>g4VL]0@YW0RFF:F<B
%;>FFLZmdHhMS92`L9d^f2fl>`d0RoF6hjP7]1j^Ja]1cAJgk:no<86i88j3[CVI`
%3NdFWg5n8f;^[L;4>_7R;F7X7P7X72El7^0/0j1b747@L`7jn66Z6<2L1b1X4N58
%5j718FYDk=CIDfB;>7A>R27i7n;02N2/2h4<464B<d7V2j2T2H4R545Dm:>b7VA`
%_2kNYSDh8fWFVl9d2;El=B08f3AZK2]B4d^>5OFA8KCG7^;3@DNX;/>_BnAd8nDn
%8O<[9>;8N^<TEF>2U4YX=]5b<Z7S629`[Nb4E8[Nd[3DH6`J@47AGNG@1>l?6<1d
%<Xj>oBIHh2d5Ebmh<`WFPR84Zn7C6N7MH;AU>j@^>gE5@Rjf7n7H5N5/5H0<0J1>
%7U>JVV7c2R7J765d5<5:262f3TZXEJ[de[GiI><ln2;07Y5T7F5h5h5N0T0Z18Bn
%Bd7T140f0P6>6b6`7IBL[V7f7ZUXk0j`US7]I@WE>iJBSN8n4OJM68T0ANDJn`Zf
%bB3HEj8k?2?K<@/hNmFg4T;4onYZUKB><Rh<I6FhI1=WJ2;90hL^U_9?G<;8n:[V
%V/S]GH`NG861KfZ1F0Qc:UCNij9_B3J@`KG`>0N8QP8n2_LH4KLL8G;9L8F`:JUJ
%R3>DP:7f:l6@4ZW^4X4j5D6R6`71IF>`;DBn7D747F363T46k`[hk=<?L;MTB=7X
%9R7j783/3J2f3j404RXJ5f5^5X0V0V0>7JJQ5`g6:V>@ElLW;_MV@UJc8RIF7l6;
%NZ0GN_4@0:9:3Ro<^H7hQ87OLH2^ZN1PZW1P[37_IDL`7W2>Dbjn<BXXYB?n>4NZ
%:8n7MN<[7f>6>_33Fc<T7b7R8l:MOY11><O1:D`JBBG90Nl>Z05YPO=GHAASNNfC
%PDMfa07j`07;Pg1Q6]AH8EG0kj>^RHO9A>YX>@E8>`7V3l3N3>2X2P2J4>4H4P6n
%7@dh:U=IPYQe1d<e5X>`9h7R721j1>0b5D5H5/70gV000>0B2n3:33@]3N545[24
%5h64V09`m5;9QfWF]hi41Bl>1gS5AO=JA89^QXZR5ESEL7=36F;=KHDMIZd[2^h9
%K4?2NX7b:R7_<d>nUG2Xg;0S>Db490dd>6NlgbSV>=KZKEK``MH1SR@>2EN^0F<0
%i>nX74^0ce6CQf`L/oCMNP?J/n/n8d;75T]jU^STH4^j;0NnR67S;?Pb7`7BEljR
%RJa`mgTiUcKa<V>67J5F4X4D04020<2l3@3R262D2U?j5b>/8;<^5X;P00080V70
%mXS^PC:eDhQIAl7b:<30l>`X0TLkNk;8fiKf60W<163_WGO?SL:DNZ?DkNaL7n5?
%;JDf=h>AOYOT;FhBJSQ8O0aHm7K4IS<T/`O3P:[i<fCiPo7c;8`B`0AS>/0027XX
%c`Z[TgUdUhWg8iH??F:YJD<L;6g6?oRaCjJPWJ>2>IT@g:7n7P967X;690:FAoXI
%XcI?BLBhRXg47T7L7Fk:160l1L7@79U>>j7b605n5d4b4d4l3D3R4B7QT4?6Ve6E
%6^=hMf<aPSNl86jL<1F0<0W45>GbFUX`86iP7FJeGXK33R>Nf>FmP]VbZDX[VM0F
%SnKPB0L/[ILV=j_hIiBgPA[bChgk6XN695:Jf3XT3c/EGfimY]/LIO7XP=[bT90F
%S`d[K]KaY[/OGh[_Y?UH85;>7Z5V5H5N0R0@0f7k847d5j5h5^3>3@346:6@6H3Z
%3/4QBBR6O8>7QC:g189PWgVf8:N?6O=>00Yj39X/lnljD>ldcH3l9>0h5_^U]lNY
%[9=MZ_[RZECbWP[4<1[;/fiUL>ZZ9_JL4Nl>Qb5e_CGm>iXm_1_M_O_PEn>h[PBd
%6^6V6N4b4X4/5@525P6b6T72?5Z@5d5:5<500T0V0^4`4`5L7PEl7RV29hH;^bgm
%Pl<PFU^Blf>W4<Sl<0i1S8jTj?3lQTm1a8865ka@ZR41aFDK5o^2adMjjX:8Sm_R
%=VG8<@2=abl?N60VnhK`@ULUa[b5b7b88VlNJ2R<>aA>>^>AYR>obJ2X2Z2^7R]k
%Be5VUK/dfC_5VMGc:d:9CV3Zl?F0Z^B@8o5o3^DYC@iW6087O025cOGYH4[3`/lP
%<APmFUNUb;L28ETN7?cl0ad0l?XX27PSced=d?dAVLDea09N=eX27iC>Db8RA<>X
%;2V2[JdQFHjXehID@h8kIN5i8`M4<04Se:8ebg4YbjinDXWG:n3ieNAR65eU;4B@
%`O8LFT^M81dB8AZfika?a@jF0>fPfS_Kegf=f?/LXNknUFIm<<<ZXZaZbl[HEI3K
%<ll5NRLVnT73AZl>2[fme@QH<X/oP`X=94N:Mg=;A[=B4=dibbZF_l8:]ifAWJWi
%H>j?gFl>Sl6AggU7gWgmgoJ@E8[g0SBJFH]V7eC>aN[^:Z>934n8B3/590:E=7g[
%]0<:2IhaXT0Yhf`0j?^nWI:ag:8X8ZVlcL77GYTS[?f:XC[6[5aR<cgkcdl5a6SS
%;9AOcN258/;hAScl7?h1ioj1Gi>7@ZC0M>8IWbSZa^YR[[7NDnDI:fWF@h@4?mLL
%4Jl>Jh9B5lG9PSiYaO8QNJFjA9Tl<HiZ7fhR3/D069kD`NcR9JZZD^5=fACaY08?
%Aj85Pf7;hf0YA^022Ckmj3l1l3f]88AjkcI90ofO[bXY]1lHM_6GkKeb6OlTf3`j
%;i/D3bWgd:XBQgd00`ZjmIbh<cPaeXPhT;_TN9aYl49Y^XiL63JPEb49mSJGS;mE
%m[m//0R:KAh:F50n/;[d?37OAQ>Q2eiF7nCl7Di1Zn;iGXiUi4K=4OiR86N270J>
%1]TSH:eX8`dGg8jT<O^gSR87^ma=m_:Yjn87k?F0SmF1W>PhG9nom_oQoROFk3=T
%92m7Bh87n2nCgLfB80oX4oh8nX=17nIXD08I3@Q3fo4Gk4hY27c5hA6He6hi7Hm7
%hk5Hdo997SK9`i:FG:h<nX4oXA;H@miY97i<iY89e>iK;hg=P3@Ig@j9AJ=AjABJ
%EBY]6i4oa_DHJ1:X7j/jJa>7_CiUBjmGk1HK5Hk9IK=IkABH280oh50h91H=1hA2
%HE2hI3HM3hQ4HU4h8oH8oX567o6X8nX4n8g6I58H4mY;98]98Y:iI;HHnIQ0dU<`
%1=@7=`9>EM>gi?H<mJ11Wk@iM;WWAh7?GhnjI4U[C`QDDKDh6oZ]0geFH7@iC6j_
%1JHnj;27]IK3EWlFkDn;IHkMKkQLKU0kI88;<7bhkd6;i=Kl02EPJ5A;WQL=QlAR
%LERlISLMSlQTHSGI97;4ohmEH5:HiMY16]1T]5GXi0fUY`WZKo=C7[H=BX=HJ[Gm
%72[AFLc1:EB[@i]l=^0C^4kN9J87@7[2Ji/m;5=Q0]ac:aF][eN]5=U1JiaXcEUU
%gkl0_40O8R_=1^ieoEjoIkOMkoQlLKXH5Uh]m7oUmc:97V>Pb[n_T^:l86Nl31Q1
%2KP6W821=1d37^ik<>XOkU^ji[J]a2B4`8/Rb]`=4@Q34IZA;2D9@k2[2<<XiiX<
%NDH@56C9:i3J2`T]0jAdl@1;l1<OV98;GYm6LRb=8lTBC9DU/dUC<[4o2DWfS1n]
%0S2[Xa:Kl`0UDV9H_0eC20daam7iXC>[LE`;0b1^c5C:<Q2b:Z6^Z4_C=<h7nDTm
%PS?Y<CnPJl>RQ4g9G@L9]bg3dd?;e6XU2CLD?@jd:D6m;;m1PBddLm>D;Ae?e1D=
%AE7D;l<_:40/g:T[:lT<ZbfnT<E8QAKeZ_cb02_a:efjKL[:TdKYk>lVX9Dj;Y7F
%:]eEE<k;@fTfZJn]XX>/<96eJl41P9U]dlo:VA/USdZi>Bd5=LeIg@Q=6>Q2S1Wj
%L5h:R23EP0;=k>gImdgeOMnGkObgYBnmV8@o5UH;9UbFLSTi75QX;hONPXHU?2RX
%dnin8bTam7TT:UeK8V<@[=//i3T:;cc@efXA2AjIJ=VGQ1V9[IWG]VeTkBQg0m65
%EaOnO8RYAGj5NRo9VBE0YRQ4iIeWnVjMYnXJS94iGFdRTYj8>/PG[Jo0i[e>7>m>
%V8M:jkEm2^>7lRbDh`OIl/g;/YBhRZGCUV/?F0OjUCfDSDPVC_0Ca^b1AB[Tj[_Y
%:3d>_e^jUO_3]8=_9GX0o:VGbkSZ3YDEk7ag?Lod7@m4UcN=Y5Z343e=j0;eQUMM
%ZinF6RRDkO_B@WfSak6nKa/WXMYh7o5co<^^fC:BRanEO;L^Z;J/R895>kWndiY1
%Gj`_naZ]X7g`IolQG_I:EW_AjN]6FWX6Odc60bo19mafOPPg8;ak_bO]nolOcZ2d
%CM=bU38P0GieP1DN1oP<m8PJ_e`We@Z?HO8malSdH`?P58:@?Q7Jb?mf[Kf@^eI<
%aI]KbV@/g8NoEJ@ne85IDG2XZci`]@_Dd2DK4<gW<VG6R]aY1EOUW:/FX;Kggm:P
%R0@@KTAH1Zg?92l;C/8Pa=RM4n:2o6Z5I:hRd3/EdOP9;l3b;QN5^`:9LAPOS]BD
%/K5D:HC@YQARJ:V8dEPZQNSm<^A`ScJR=<UBJfX]c2R>;PMU3TOhVi1=n5?8EMbg
%D=??DVKAkDDEA`l7l:fBDAcEYo4`@I22kY7BKTi9fCaTDg5L2]:=NRlQdbWHY2L]
%im2;3c7D>48X?@I3f7V>`NQ@0D0[1d>`M[Jc=UR:6AZ3JCBR@T8Jd]iijAHC;APa
%`cJJRBXO@X<bJSkPB9Q3D?2KA2G>T2M>@FI/We7B=CN6VLaOP4CYWD=6MR;dHT2V
%k>:NDlijCc;2m4PB^a:a802n/FTodD^bJ@kDUZFBbRJ4T8dJXcQS=jX8<HI8cA9R
%F4jkJRdMSl/H7k1mPI;W2U35]B49m8g[0[6CBLPb:E^S^YI3h5U;e[SJQ<XQjBRY
%6<ZWZO1L2n2>:o1UCmNP;JQ5hS0VnW=AjTE9W/Da4Xe7:P7@DGi48J9<^4LC:6J1
%;F0Wg9<?a];g6<AhWQF<SJ[amDJXhlb[CW2NS0[L1V^0gZi2S[X`l2hUZl>bCT`T
%OdnP:Eo9f:i@kYF5`g>H^HDeBTRe5CLNVYX2[88lE`5bbR@gSF:/aIVcBC3dUXR7
%@=?1BPGfS;lPZ2X:JRV?=2?XX8naf427J8L@HP791c1L387HQQ42B7f?N/QV1lSk
%7ZGHnd:5_8E</Db_MFG<W984KhL`5[Y2h^X@J^@gU/QD^e:LM:9gWc87h<jlDE`>
%Q__<K]iln4gUhZO?6cJAQ?gaZN_A`0WK_FGYY?1imk[ggm_mOlURgJN?cLB6C0aO
%Wee?ZJKEF9magQT2j4/A8QA0_97n4@90Da?RQ5Jb8Oe`CX>aJBOXO3KbR?:8jEUb
%1BY00^aL8_63fhKab:H6O6d<AQHiCMEE_DbB[C=HT52dH;eh3P>EEUG50/0992_T
%eG23;80:QV=Q>Ej[;9[]mT_;FFl^4;K5Mm5J:IUR`D`CT_`W<dDc<L?ii8o1l3e6
%H<DGX507P59:D<O<E`B^k7Fg>3AFBa3l7d?iE6Q2ACgLCBUa9b21QNdL5SB42Bb[
%^CTMlFCOX31ob>bPPXT=?0Ee0;7DAHB`ZA@XGk;ZBi4Sl]?>RM89mHJ<QdFELEK;
%lJYea[VcJL]B;C;`NTKN`EiBD01MX:VEcJWg7f8D?PMa=RB4F?dO@kaPS35j0/1h
%61j<J7_78NU_Xa4FKNfiK`n8a<3;[N1>ElA?j`1>nNWMQYWkB:b>SN`Aml701/=o
%OQ1ZR^G6F=GPA0h0380o`L?72B4UQ2U`gGBAhJSGhT0cRRm6GQ/Nf^2;bdleL?hm
%anCJKXQUQZ;_P8jm=g3ZiDFSSYRB=3eSUWP:P@@M3B5l;DMXjA^P0080098E``39
%6T=m;Hd1P311S;T183@73I7H>PNRbUHHP_eEi60R>/8Y:ESTH@4^_K16fc]IclRf
%bZQ>NHA@6neISG07W]b35N_`7H4G^RUPKSTkaOcT1lRl2JkmU5NPX_149Z;S?_OQ
%b0?n1@>2@F3@N4@V5@^6@f7@n8A69A>:AF;AN1_f=?j>@Ilan37jA02BBD2bMSbV
%<aZ1_ZGAR:_j1?V1?an?QA8i2Q6B7Tj6Y7YQ9P04Q5V=E`?mk_ef=U]_mm_a18I2
%Z]O[ed_]mE21E]o_f3ZJa0:bB]n^Nd1Ve;ZfCInFJ4aZ`@^>?ji<:l22m7:n?2oF
%iHH6BZ?2GFj`=2HT>h]Nhf?cBIb2HI?:IG;IO<A>GEj2?_?5o@BFBQ;B=OC@>g@=
%kj^3G;<joHK7IK?JKGKKOLKWMK_N@W3i5ljV1;cR07SF@10?U8;VJkN`bI?nk?Qo
%_ah_mi^En?UiFmo_B`?Vi_^1?OZ_QjW4iVic?9hMB1C9n_JX_ZXcJ1X?mBE/Og=Q
%k012`4hB_YH[ZGX4ib26Y1Rg;Zcck^lOif`X:4;1c33C6^hQN0=3`@a0^3hXhaYN
%]82A0aC23WaI5/G<XN/HX6N<J1E6bB^D0HHag1k?=K0cY8k5lQb98/SB?94TbE9K
%:/NQ<:7J3TY>@TXOB/^:=@8ikW?8OAh>TNR17fNil7`kamYTOch?8BQ9TNJa/6Vl
%SZZjO3b;Vj:JY/8/n0G?aGd0=E12I@TEY[=3D?a<DOCdOQEdN0@006M9cW@UZG>R
%nj1c:O1<Dl2]@4>A140EDX80L1he3@=:j`DPIeeP8MI1IFQae]9UL8bR3XccG:i@
%EEZ=6UHH4f:dBBD4=B3<=8DPekG=XFSJEYfYJ][=kIUW`:OXYFj0U_Y:2ma79LT5
%;M@dS_7<D4X7GT4c@D9?U4KI]Vc6Qg_^j:i7lOR`GLOIlWd0`20:T/;2L4PBQ:Mj
%oH2OSXWXNYlW/Nilge8AnY/OAc7>M8T2>9AXVFJ@/RX;3YI@kn7/Pj;7/NHIR6<2
%`=0b0`3P>0JB0OHYT6<Hl2@8^ZBPgXQPJ<^Ed@QEe5cVPT]8;YMY[]P1l8h[anW`
%NbJCB[kiIBVF7dAOb_[NhBiaIM3=X<B6fBXTTLUI^;O^[AAobMJnlKc_Fmki_^n4
%G`5_P8T[S02E?3d^OFigKI][TSakT1QbAGLYYmWH0]jI58DAAPJ1H6><05_P44HB
%19dXB0X2X;Y80PPR48f;gdSC87j:XY2`K1ZVfOAjW^A134>EaFUU>fk9VP@kSb>`
%L1`6`;0Z32B0415RP2/VLdTTP:0T2MH7FQ=>@l0aKo;L@;T1m=4hOa^VFGI^T<ma
%MZDc>kaYLjSiC@NAk7VlQMVbYMP0ElPR_FXVh@8?:1AZSF452[0m]`006`C6k1Ea
%PoUd=nPe1^3T7H?@O8RPXcJ6P7@U9:0R50JhE46KD@R3;NHF`5FI0`lbJBgQ9Q`B
%H0[fCA03Fnil1`P10R3I@aU^QfakSfC4=HJ8da;2>4fE`P@n1f3b7@74?0P1jUP>
%lOIf`FPZ0T1B2<1h3P8P9060X2`3`9@l02BB=h1D?0RSX>Z>aSfiXi86>R?P@8o1
%1T0>V@BVdb_c7nI]bb_dP;EMVeQ>bS44UPD<deODDTiVY;/AUmY^HGT:DhU1Q@9B
%B^21o:D_`l6PbKQ1:^ET[IGB_BD?>F@:IJ;7003BG0mYM>9KVFi1dZUYX:Dh^PeK
%5C97B;N=DJHeUBP:U]2P0`5@;0F4l9lCk5cZZ8GJN<[@mDj?77o=hc`kSb3d7V@:
%KcM2<UK7bUdOYFao7P5`:/F0D`VQ=0L1@200P5P6U/BELiWRg1AX8R8OhNJ40JXD
%<FQQ0i>T9;M0MnQ6TbX5FFeU0[5QoWd?U99ARLf0>:V>]Xg/<J38:6GBU71bRBd8
%3c@JF5<JIDcYYCDS210bDiYF0=Vh1aYdoYQ94O/QW;;GT<@JH[:0U192I<dTZOP4
%/77L>hMQ6C_;^7bV@OQZao3j?<?ljQgYcS65b<X<XHPWQU3H5P6@A@Z3P>^Xb31i
%1l4d9Y5dPAm2_Sk?0?PCXYaA0R1<2E`A9Hj0RJR/1IYK1M0D/LOZ8Q`5>6KKV]U_
%LVBi9UK^EmRJo2XTe?R?`c`nAl3jRhJemSG4G5bQS9e6Qeb1>?4RSVF`][KFKY]K
%VgE^kNDb53Kn7D>cU2R^8@aOJcIN]eFY@6BQ79OV686=dKPh@6P<0Nm<Th1FhRZG
%N`11=9RI=D>TonN4BRgS85l=H281@;eP7<8dA`O0D0m2P>e4LhAgS/:fVJ0RLicb
%79V?M>lgQm7NO:;Mlh3<5;50C;:ojfhA887n>72R00NZb26>o3BF6c_[Z:]6C=V:
%mWNJAR5/K:HSA6JQA8g>7b2:L7YS5mhoPSHeL:SVJH5Ub3T]kSg7f?lP;D6eT?1@
%34o0;9:5S9D5kV5bTC8Z3LQVU4K8h3<6@=gYPH0^1XJ6GKAg>^L^a/1mX2DFWN?T
%NPkSY3f7TQ@3`6`G3F6N=m^`kA=RC4@8DC8[abhW:n?M/=@k@5LTLaVoPoDiYT?P
%@@BnSG2`C0K@K9hoC7Qgd/GX40bM=HaC2da0V;<@;l>TF0OEHBK[m@TB`/0kiS:j
%7i;Xj9gY<95/ZAaM2iRKH>17[^FdY@Od?b3/7HF`mR6``]144fbJYiZDJ@JC^]i5
%[FTDfNeV4R1]a5H0@0H2090A0YM8Ki_m4GNJj_`OVI4dTPP`EnlYGajSK6^=@1H3
%P>jU84>lM@6`5P96:=DMEmRU3gVl?hNdVAiSfa>WTZ8oS85@TQ;hVcL`[lC<8:<Q
%RW235^5Sa/2?7E?2H/fg?D2d;A[[:d:@C`W09PK0j<@I@bSZSm345`;PaQWSB7P?
%//1;:/YW@??3?a_;LK=A7B@PX_nTH<PR7KYVaNW=k820P3oPD3PT5Pd7Q49QD;QT
%=Qd?R4ARDCRTERd>O/IOTKQQhS`0T4Q0TSIlUPKjU4GUD[UT7SKlQ<_O4cT860X:
%M[/MkoOd4OKkO;nOd`OkmPCmXM6W[lNkgWSkX[jWSfOkhN2`EjZ99A;;lWXf40S3
%851bhHCGLKdXkjL3GJ0B2@LJ3FLE1OkgO[iV3kW]lO=@XdlQE2`Sn0>7U[Na@faQ
%?aceb4_S>1WU2bLWU=7bLIPN4c]2U5BPF4WkkUl3O>YPNWQ6QP[mOSkYfaOklOAO
%<iYF:gFneOZJBRDFboHCa[e5XffXShXD4Oe:U_AR^/Oj5jdQ0OIT:ekT3bN4boBl
%GSlWUlgWm7YmG[mW]mg_QfUPfYO<3GOgT85oF70:4ob1_TPBVW^cch@<QSB/VVIl
%86=L7960Qc7:MAmWdOYjWXYb2<33RS]/Z2NWnOBH<hOL67jYao7/K9]6X0020:4h
%EQTEA:U21H00>D1CUbN[EZXNQgRb;Hd7DZT=7U2jH=4Z2X=[4AlBLPkG84T<0X/U
%k@SO;HCBjH/_/nXJ>85:SJYO<JO9nQ;j8Nd/bYS<JU:<X2V7^Ba=4f;@_2ni0nS`
%?A_7<M3jZ>PBOa2OD@Z>dd3YH`T5c2`PVDVVX30<3]<71CB7^YA]?DoD5@e5DMBE
%;DbEW]E;_8c<YbeL3MH?d0Z@R3F/0CDPCZB_Dkd<9=SG/hPYgf6`CW]6i1nYo@RT
%:6cEPZ>W]S7hn[I:VY1k7HO1iD8Om27VOig7PY2CWXLi[VZ>8kT:LTO7TPD6@I4D
%A:U9bR9jd<2X8Ukn?50K9UAP0;H4Cf2EBZSA^Jn=LGVdB5EnPl1X=;;<f@WT;WWM
%c0YjDYBU6@a348I9T6FE1CUDOR<d@_CH>MI]LcAGR7HSH1nWCV`?i`T;n1mWSj?3
%=<YISXFQj9X^SJ?Y5?hNPHUJJT:@d`3YcjW<ZG_1InT_8Un7/9</5WTN:eDDZZI`
%m3jP>MReX<4i2WZ;Pil7ZObVX71QoAlX]2a4NQB4/BYIUdI2MWnN2RZM3BX:8V1o
%BM/J1h<d[22gbM88_Pf98fKO=1OcP/LmVJ2<PNZGW=dYGM>IgDWYeMlio=KE8:dV
%5]FSUYA8bS@VPIQTRF98T3F=`i7/O:T=Xf4XbO3L:kC[:2M1fDY<8H7YY20G[?h?
%o/mY<kDMQi__o1l?aO7lSf@CIi6oBoSn92Fgg8C<[=jalZ8CNP[ZL[Hk1O/bJnC8
%XM]IPS;[67nQDO8m2NUoA4heaJQ4@[C7n?DN@I`^QL7<]T]D4D15E:6E12cNEY?n
%C8aAO;mRE_b=PVQ0HHhF0UQL=661Q1C`cH41H3<=e9Q<Lh2l0l?HMSJR0a=QYYE>
%T;JF@8O8mbZ4Y8bULL@g1]06<>>m3;3B>A=D<Mh_ZDVD?R>n`UUYcfDU24?6Do9n
%R@S7SDm/NLKGjA_SQ76>DLgVa57n<J?02hm<j<>7F?bnHS[MNljj>Q3hD?MFhP]>
%S;R2TcH?6=U2bB_::9jb`cdHQn;a7d?@O8lRR>`<XF/G@/QH0:0:0M@@lWA[MEbg
%UAJdGm>>856eKi1AiBg9J_TQhXiN@e2A;l5L`A/c3M0Bm0H[IT0:VE30J:]fPT2M
%4cmAkIF4=SA2AY^Q1A0Qk3f=dK0f3V><<jXE9aXX1VD=<DAlC3d[^PH<4>N2/R@P
%?WX>bNdQIlCiWe?^OQj39S`X02NPBUP34Q1_@LjSX9WCBS1?eEIU7X46Oc08_TTY
%9=j7j?=eRQY9baEc92;<1BmSgA<faAATalSjP0gX_J5ZE:<NC08Z@nRm6HHJ_R<4
%9R9DXT6AV@9X@@e1WP4<PdQ23SQZ@B4G5Bi0V5S0iMnjJ4?W8CZ7`?PN0X1@2L<P
%H`bFlZ9@Z/HYID7R;C7j`e]Sm39af8HZhLX5jh7I06O`85MH_bbXMGV_ENjn?TIn
%6:`3Cb@0=/9DPL9m4[V4S]Fb_T^R2YGLR_IoBhiGASA3INSm9UXCGYm9D[b83J`O
%KJKA4D3iFb^G_0UIR7Ja6JXZ//`PYAC2V/aAjTb7Gm46Efc@FM_HKPICLBPjSEid
%<;63LL35bGESdZP@M:i8JgF40J:njTiam3h7^a`D8eec[9UQ9FB/0W5U5_3IQ0<X
%F/[i/DVR8S<212m_PB8TI8F?R6XOGfo5nKmGk>UDIn;lR3Fc5=H9YhY<3GlSSGPQ
%5U<54=>>Ibg1BjE=iCXLMa@nf3Sf>NGHOh00304W:aZ958Jc5<DA;0OmbkM<;=;@
%L6h_<H<o=2eJQ[=46X>45SU<9lg_4Q1ESl5^@D[/o8fXVYae3=fBaXHG9606GbCb
%HVR@nCjW9RWEU=<fD;eiGFOK]3Jck73o47V<k1fG[02^><77J0Y/`5HGV7112KJi
%c]]W@j;EDdIEcSW_13?WiaQ87<<K<NTL4PET5kA3MBIi`ciPVg93;JdnMFWE]YZX
%[U6]I;2LYJbOP00608_2bF4FW:9FMMkRZ>BbQ<JFjD]egA8=COlbTk3BTo4e[N5P
%HfOd:VZQ0T:VQ`>?EEXdRMS256U@F3gIElP2:`0g?HMUmiZT9bm/BcFelkIfUcSG
%;<9F:KFg1?Uo:IF7j^1U^NPULPAK[UY^6Qe]B6fHFBE9Hc:CE6Z8b;/kP62h0490
%5/;8FQaTj@eILV2UP21m3l7h?HP11Qj3j86Ea]RRZ47d7cR?2a2203n8:Z`O<N7d
%7b7CTP4NC1miAamehnI^1k43bmk8OnGlB84=;V`:NL6C3ec/A7?NMQj41d4Mg@`4
%M53CdLPO7nPlLNcbP?ZTH`M>iSc7YgD55MBjV7oZ/eElmHjWe/bYQB1mNjYbSZgH
%nDLa3cf/o`Q<_E6Nf@?J03>jK<2KgMGC2mSK^W7]S>_ObEiKGbI;?oO?3A_Ye]?9
%o;GZ_F[T<cb2IGAN7SU_3B4/GRY=LBkLE<_=o005R:TD`f1US31<283`H`j1k7J[
%VJho`GLhiP7KQHOc[3n7dDkDblbV22468L?W;_PQnc68>@90`kO90Cl/S`N>fYW8
%fUN<XQnFm>iD@8D7f@ZoKk@7gWo<nFeI2PB5O??nUlOn;Uhd_aN?oXc7nXWok?fQ
%loBk=@glLaocoYnonfKQm_i?f_jYW_o@0;j^HR639TbT[T5QL`6R@YU052@WdQ6^
%hUW7<9e=g=/_0=]2::8_525?9_:@A7`;853X`2G`6QL/22@Q9@FSZ>m`AYn[<1kT
%<6e<84;Z00:9j1L;NRRT61lQe1C1@Q;P:PEPK1c_G:@UTRlQjU25^?L3JQk2T1l4
%B6f<A=_:d5W>L0DRBQW]82Q<QUWV3>W?RZ9R2SkQM_6P12://93<W28@fR<@g`g3
%=R4Y5@C32/I8B8`@@R28o0jR@_UP4Zi1Ta2Z9=5`C[g@H]]/6[R>@/R?XA5a97_W
%@:eR=VYQcP?A=<bP1ZQZN5^@:a9]g_<@K3H2VQRWYP7YU1kYL1nT61mQf0o0kPfP
%[Pg0mQdU39:QiRX;/2N1m1jUT_M5gRYUkWKRH9<US]N22;V^?P^aW4baU<_2GQha
%ZA=0?<dR36^RD>C08PYa_487l2IWnRO^h6J=Jab?2acAcab/_UTaeadafacQmaf:
%7/_?1R=`?Af^@S@]U0N/2:10CUQQg`c88S8AA3a]6>`RGWA7laa]Jb3b86RAi943
%j0WB;8cP2]W1eB=R31fb?@B`1b8YlSH=iVe3WQA1@1?PJPIPI1o=kRe5bPB0?P;Q
%@1IQO_FSJT@TW=A4C5276Qm2Z1o9=4ASj`>9W<_9J4^PC9N1A`Gal=^:7R@_[RkR
%VSZ>F`841R@/e]S_n]Z[7b^_n/E`1b_6PBa44B`B@YIXg@?a3Ql:S<`Q^BhP:BiZ
%22@a_0Y/`b2:m?;43b4WX;00a>W:gA/X`BmBAC3T3a;9e>NQ4@ER@;h1N]5@ZA5@
%HC4?:Ti6;1l1k1jQGQFQF04P3P31a1^Q^U^QkPnPj0fP60402QfRX71SSX2QoR/Q
%E2Q>:9F3=2XTb:>=<C<@m66al[^1[R@_TPk3j5lT[b=Qe0RcV@8:L9I321YcY;WR
%@7A6L0?QMC/W8S;Ah:7/Zaj5WC_c^c`ZWC`5TCa;d23Zka`Uh^`bb7FUW/UQICiX
%n00/cQ8Cl=[Bn43B4b71Ocoa0_UQ5d1]GCSbXC;AAA898cd_SR;V7QVd85:P3<c_
%Vd4@>/Sc:<lc^3:3Z8C8kC5=Y66@;R5TD@JC<c=QfQeQe0S0R0QP0R@DGP00H0G0
%HQ`1_Qa9`X721C=Ql038NU4]A:HS0X^bQ4b=D:dR;^QQg370WXMPdDWV21??RP[d
%Z0:d[17D/:072R;R@Phd_0]D`D;3gPhDb3n5I3n?81V:K@4<^b`W`@=284f;<:Y[
%<2TRFYT1FSn>j06:20NDo7CQG:gA7<Wb]c3Da:mZVcKA5<Ze6E6alR1PbE8cj]cP
%I:ke7E;e<E<e=E=e>E>e?E?/ZS@T[XCEB6:39QdED263@TbQ_eFdA]HA@8S3DX/>
%:XUBC2lXU1aDK1e1dQf5E8`2OQn8<[:000100==VfcI82Y:TDZBCM[b>`e?b732@
%DQ<E[E8Pb>B0j<31BCQ?4b5D=<[3@T86XQeec:KE@EdeeEeefEfegE=T1PHEiCjP
%eEjR363:S<E<K>^Egene>;ES;F0e>S_3C2T`JBPZ?@h]096YZ1oQ=f7bj[1>RP4:
%i09f;:jPP?RQAF=QUF>QaF?e3/mWWRQ<28NP3cjc7FD`EZiFD[Y=VFEFHFHfIFIf
%JFJfKFKfL=38d;1FCA>FJ7fDH7eck<cW[B<Cj/c`e2@f9fJF9S3P0FWFDRAfT2@=
%o00P79CP8P3]o??dHVWfRP1UIP0F`P2]oC@eRZ2]?7ZR@01??eSFLa>@8FDfQF^f
%P6WT8=OFMF`TG[ifefRc7FNfgg0g1G1g2G2g2SnG000FU[15I9iC7EkUDfYg3G9g
%:FIDHg;R@:iP104P20301g<dHC7FifHflFEF9f8VWYj07fD;11DgGF@/hRG/_AU2
%E6^@n38AZ1hd@gH:RXVadDBT==hRQ>5PoA[;VT5a]66cRbUD@242Gd]0JgXW9P]R
%34Z:c[[Z<2SWE]G[:851kSABGDMQlQl84210Y7?529eBM;CdRRZTW76SY;VT`VOa
%f<][4@l45e[1<2@b2GJGN2ET[gLYRTdGkTY39V3B6caVSDh=hZ?8TTCZF<D<6S1Z
%WUDf7Q=P8H</25IDmgE0Mh?cl18BV1THBB?1fccGoYl5o5WgTD3eXedY4946OgKE
%oHJhKHKefVO`nde_k/<5D]40_0MHQEc1ehHZXQnE/Do0NHC2IF6W]S51_:h0;^I/
%iC^BMgO6d;:cK6dT@`Z563:GT<AUiETggUXT25^eT5aee<Ua7hFAa<ohf25a<2h0
%9=P=Q63X`hLHmHmhnHKYWBcHNi0682V[4hnhnF03Wf1E<[=<<H8BLTA@ZT?RTc5H
%hf5QoQJI<3nG5P00QI>QHi?hk@;HNhJC:hDY2aU;e:W2FT5Xk4[d6iC?2H`HgXDY
%<RIi>PQ0XiLaU3ZHRCV0RUJPPgi<Z8`8e1S[OQ?iT>[Em<g5UUU<RZ<2D6k2Y1lb
%PZ<RS1gW5/i`U/9dQ55eWZH;93aeA65iMa8/5Wi3j0RIe>fY0iBiC29UlelChic5
%mBWh9eH7`h6?;`[DS>9Qo1_Q]1^I8DTB]`;QRJ3d91:j5IU[V`/GMig[m41ch@ji
%Qeeba7cWL@mi3J=j>EoC]U5IHR1eD1dBU0ijC7A?h1mVK1dei0H470eba<`i?QHd
%[0:jIR1fAj@4hZ<5UEVIZAi]j2Y1nQhTC1hd]Qg41@W5LTV3A66]C4D;E3OCNbCE
%daX<fZ7_X@<IciJ237DQW>Ud>eC<`J>jbJbjc55IGd5IDU5AUE;JchLf1I4E<h7W
%mQjaQ6lQd1aQb_?QIQG1H2P@/^`ceR=T1c0=LW8EPR=V7f5:KJ?j8:m8k@5Dg2;C
%Wa@Z6IkiC8C1[K=P>K>Q6K?XC<]bhQ^8JQ5KC9fj[UW1>KE[TP<1UkGhSBbceG/e
%X5akK3HRZJQRN1kQeRSD]X54WQKQG1GY<YEZHYa@XEU[Lcmj2H6Z:9e2GZi8D<`Z
%S8Q4`]SB4k7R8/V]IW_4h<^5V55IQ7_im7H[K@KST83Ql0Z0WPXQ[8H0GPFPG:01
%k=5][]7S:Y<c=V;9;4?2290T[]SBbK]L2L2`kHW211OL5C[dXbfR3L51OL66224a
%U>IP=L;eFQ_U6RU4@DPQi]j3AVDDHV;9[SV]j/7[`:><]Dk3J8^lGK`lCIn[L;:1
%oSn777XKZH5L3LMS1kJg/[FWT]BSATVTDQmQIQH1K121112SWQk1Y1Z1XPZP^0eB
%g:<8aT@;bSj]C76;CKk[:lNL`L`RFVOQElb]WJKj]R1lbQElci?gZ]_dMUDPblie
%:DUE_Sf;c8?Zl3nK9@1[?L^LOH]2RTBM2EXKcAG2YLQK03j481j38a5>[HDLaLaL
%DlIbC;CUjVGRWQkQiQh0j0gPh[[T=2ISHQ0Q61?1X1/1fYa4c<CRl/<CMaG2RZHM
%<dT30bMm9mLmMHZ/[17mOL;P=J_C2<XQnMO17mPMQ7HgKX99KbkPSmWdU5BUX/A8
%1;;:i21[3C/QMHkloWoKK8D98Y8dPDPD5S>?GRV7R1lL@21R@QW2BkA]GJ2b_bdm
%Ml`M:lD/jjYTiQkJQ3=89AL<DVgT@Vl1hUUS=2RGh2TMIN5mJGf2O@UMjn8mMS9^
%F/OPEHX<m<f=@Qnn:/On<IEN=21hCH?PMP`NCIUgo3gSHh9KlGc0Y0Y63=WCoQO_
%1W63Tm:a/WmDSW7:;TAl_QkM739R@PAPB0BB1@/Lkn9MLmkkU[L]=l^SA2=QEQCQ
%<PNPKPCQU1Q1NQ3Q3160@PEPP1abL5kS8:B8881MHTCn6WTVaggVmNUNhLMjIPLn
%jD]C_2Q7lninjZ0NkbQL41okF`1B]ig3c822N[/:E;A23e/EjPe:5R<RVVl4>97;
%b=jlDngO:S?He?k/g6;8fQhXNP2QKQLQK24kYn@NhmM4>Dh2nTbJjDQVGQkQgQa0
%9@8Pc0]P[QC1@1DG50>QfRW:J5X4WAP:HcIL]nei`Z@mL6HR0X0oh50h91H=1hA2
%HE2hI3HM3hQ4HU4hY5H]5ha6He6hi0TO7gY8H6oI92Gg9hnSi2m979HA9gg0e;<i
%JoGm=h==gm7HVnWbo7o>j30Z51F5A`oBGEBgaCH@oI>nI9<H7@Z]@go@:cA:i1J4
%o:1H:2oCRLCN0;@o7lngeKKM<8CH7i97k?;]MkaNKeNkiOHIEjaEi/ojXog`mW^o
%k[RWdefHa0EJ5<V4Vhfhh@H51>hWOGI]E7[HH5DlI@GgFZYFX;E:YRkm[mQ/MU/m
%Y]M]]khm]e0jJn7__hI^W]_:K_lC1Mk>X7L=7;]a1:^o/G>iQKQEeeCfNHoiGd;[
%d/E@:5RnWF:eijkd>JnI2e6Td@T4PP1@:0Ig[Y[M:[>Yacolol0@30B_:jX1n`<[
%BQ:RPAm:bNJ/WXDa=4d4ChWnOAj4^Ai6Sh@Y:9Hl:^7TZAl84NamY`kl6/8e3dX8
%eSA`76DIaY6/KA_0Bi8<kJ1adPDOANTj3B0V/R8:O<T?lOTD:6l4VY^@dXP9:Jd0
%00D[bZ0<]BZ0Bd02]4^P00JdC60DaP9;h2;A=@0CI=@0c3<80Bn002[A>di[@DAA
%51:[kahQ2M?e752D;@dI>R[T3aI4:]Z6aLBWo1io7/60@Q<GQEUN`ah2D88N4>B1
%=VTKaf?0Maf7J90WRVAi<4jO3_Z[5KCX4ZRR/DaC5YSG53emGmPF3HEQf8RcZ9n`
%9oVcIH9fJ0Sj9/jCWFB[:eBBTZ]AFm45=5Ab[?jXQnTJAI51l7PM]7:H1?_H]fgM
%MjkDCAjPEZZ4OdDPE8WXNih7@4h=0nOIe7POihWF4@<PX<0d3TN:jWbO5N7j?i34
%HJ9/W3FmIe/ZQlaL^ZGEiN6Ai9T^CI?U27/?ScZ7eF@QIPB>IClQ1m7`O9o;WGC2
%9RTQ>4ZC080B21[6PK1EU@E`70J2Ag7NNJ]7YVl4X591lW2Ki`0`2`:VjKI]=nN/
%lgIU>bk=H[0:jnl4G_NInW^]IjDY1im[[Ud;a:O9kdRhM`WXMigRB9XZ7U1[D^W5
%ImHk5cV[6[6clQb?9LWbRo9fOVG9lOQcW<M9LUdGEXP7:KafVWNmERYbBi_2inTH
%@I40>003T^B9<6XJI/:o]Yl;WWB1VBHiT6TJ1XX=:Zi_ab_UnI030:_9TV:Q8CbK
%/N[37SWQoiaSaoWPNjf7/NI/VVJ90MQB;F;DX?4lGajFlMG_VoWnWjo]U3bgV`dT
%=>OP^1M2jg]B9@BK/fIHSm0aMFM506D<4H`5`80G7^?54Y>bQ=g7dM@dL5VZY9E`
%?6401`408OjoN4d9bl`LFC1T`a8d38[>VB`Oa;5j_K84?LTXoQl2B4D8LI0b1W5D
%7]0LXSkFZ^<OR[:54BhVA=RLKPWK=Vj]D<0?T]YP2h;7@JBB7B9G58G7l:DCPX@<
%PB0^?4MPl689<DM3QAKfam?[LL?N8JbD`?bRO7V9ii3e;D@^_TiAEhY42N^?lhKY
%al3nNk1TOXga/3@0b101HaQSS;:Tje]DAXK:>SjfV?DWi@BQU4@/Z478eZ?9^lUV
%k>42aLIdH/]ZS8hS/72><?HLPkPJ0V1PHh`QS2l5f;j:aHS2B0?jJN5D5SbSe7]8
%VDLci?_bAP^52l[8>=e@^hZ=kQHF4a7/>d`T<U_C:R:_UmaZRZ]ZVQ>^MTkHCAl:
%6F``IF7nU2R]2aA@n8]UeKf5l:PEP9P80D?`N8ma<2?4X0`0X2Qd>MMg<F?lm2e4
%nDX?E1[;J9AhWMA]bIh:?CZ=8[ZE<=g3:fY<H=S`oD7SjL:a5I1>3V:AHS4NCTjH
%oDLYaCVWBkW;]gT4BL`2dIk99Y/T8/DEY<@H<8?JRhofmaaY<XiVlK5Z4k=lbj5E
%>j];]TlS6HYh9hCc9Pg17kUbMSf;0cdV;jjDT/7j?HZ1JRM]kW@?ia:1V=84OOE^
%_UOJo>ANO>ZVm=Z^T:EkAZ_mREQWh/;?2Z]PTHU[==9d[ai;2f:/aIVcEVk>FM/m
%Ind5XKAFS]9JF_Y0@0003@4000<000010GD0004100<000010A<0004200<00003
%003B9P4300<0000100D0004600<000010080004A00@0000:003B;04E00<00001
%00<0004F00@0000100007@4G00@0000:003BE04J00D00001003BO04K00D00001
%003BQ04L00<000010040004X00<00001008000000000200800P000080004CP00
%3lD002LV001?Q@00Le800926002V6`00]/L00<^K0004AP002gL001MQ000XG`00
%8ld001dd000EU@004:`001CD0005j00:o80002L@00[lP0009a001`2^07X01`01
%00400`0300@0000=00`0405e0GD1M@5e02P0O@25455eJF=[E6U]IJXPHFiT8640
%02P0R@1]5eA9ATHP:4aJEbTPI6ESKfe`LVEcLfmb02P0U@1M7f5bIB1^IFETIF@P
%M6lPLfEU87AXJG<PL6USM7EbIBh0003o\\>\"], \"Graphics\",
%  ImageSize->{373, 275},
%  ImageMargins->{{0, 0}, {0, 0}},
%  ImageRegion->{{0, 1}, {0, 1}}]
%%EndMathematicaCell
1 setgray
4 279 moveto
377 279 lineto
377 4 lineto
4 4 lineto
closepath
fill
gsave
4 279 translate
373 -275 scale
1 string
373 275 8 [373 0 0 275 0 0] {
 currentfile
  1 index
   readhexstring
    pop
    } false 3 colorimage
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFEFFFFFEFFFFFFFFFFFFFD
FFFFFDFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFEFBFFFEFB
FFFFFFFFFEFFFFFEFFFFFFFFFFFEFDFFFFFDFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFAFDFFFEFFFFFEFF
FAFBFBFEFFFFFEFFFFFDFEFEFEFFFFF9F9F9FFFFFFFFFEFFFFFBFBFFFCFC
FFF9FAFFFAFDFFFAFDFFFAFFFBF6FAFFFEFFF7F8FAFCFFFFFBFFFFFCFFFF
F8F9FBFEFFFFFFFEFFFFFEFFFFFEFFF8F7FAFDFEFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFDFFFFFBFFFEFDFFFDFFFFFDFFFFFDFEFFFFFB
FBFBF7FEFFFFFCFEFFFCFEFFF6FCFCFBFFFDFBFFFCFEFFF9FFFDF4FFFDF6
FDFBFCFEFEFFF7F8FCFFFFFFFFFEFAFFFFFAFCFFFDFBFFFFFEFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFEFFFBFAFD
FEFFFFFEFFFFFBFCFCFEFFFFF9FAFAFEFFFFFFFEFFFDF8FAFFFDFDFFF7F8
5F545613080AFCF1F7988F940C050AE8E6E9FEFFFFFCFFFFFBFFFFFAFFFF
FEFFFFFBFCFEFAF9FEF6F5FAFFFEFFFBFAFFFEFFFFFBFCFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFEFDFFFEFFFFFEFFFFFEFFFDFDFB
FFFFFDFDFEFEFCFFFFF7FAFFFBFFFFFBFFFFFBFFFDFEFFF9FFFDF3FFFAF2
FAF8FBF9FCFFFEFEFFFBFBFBFFFFF8FFFFF8FBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFEFFFEFFF9F8FBFFFEFF
FDFEFEFCFDFDF8F9F9FEFFFFFEFFFFFCFDFDFEFCFDFFFDFFFFFAFAFFFBFC
FFFAFCECE1E37B72771A1318C7C2C6BCBBBEF9FAFCFCFFFFFBFFFFF8FEFE
FEFFFFFBFCFEFFFEFFFFFEFFFEFDFFFFFEFFF5F6F8FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFBFFFFFBFFFFFFFEFDFF
FAF9FEFFFEFFFEFFFBFDFFFAFAFBFDFCFFFFF2FAFAFEFFFBFFF6EDFFFBF4
FFFEFFFCFFFFFEFEFFFEFDFFFFFEFAFFFFF8FBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFAF8FBFDFCFFFFFEFF
FEFFFFFEFFFFF9FAFAFEFFFFFEFFFFFBFBFBFFFEFFFBF9FAFFFDFDFEF8F8
FFFAFBFFFAFEA59CA1191217F1ECF0F9F8FBFEFFFFFCFFFFF7FDFDFCFFFF
F9FAFCFEFFFFFEFDFFF7F6F9FFFEFFFFFEFF000002FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFFFFFEFFFFFEFFFFFEFFFFFFFAFFFFF8FEFEFEFFFEFF
FFFEFFFAF8FBFFFFF5FFFFF6FFFEFFF9F8FEF9FFFFFAFEFDDFD8D019100B
C6C7CBF9FDFFFAFDFFFFFEFFFFFEFAFFFFFAFBFFFFF9FFFFFCFFFFFFFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFEFFFFFEFFFDFCFF
F8F9F9FBFCFC5C5D5DF7F8F8FFFFFFFEFEFEFAF8F9FFFEFFFFFCFCFFFDFD
FFFCFDFFFCFFCAC1C6171017F7F1F8FFFEFFFEFFFFFAFDFFFAFEFFFBFFFF
FDFEFFFEFFFFF9F9F9FFFEFFFFFFFFF1F1F1070808FBFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFEFFFFFEFFFFFEFFFAFEFFF8FFFFFFFDFCFF
FDFAFFFFFDFFFFFEF4FFFEF4FFFBFCFFFDFFF9FFFFF7FDFDFFFEF8928A87
C8C8CEFBFFFFF6F9FFFEFFFFFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFEFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFAFDFAF9FCE7E6E9
B9BABAFDFEFE030404FEFFFFFDFDFDFFFFFFFFFEFFF9F7F8FDF8F8FFFDFD
FFF8F9FFFAFD8C8388070007979198D4D3D8FEFFFFFCFFFFFCFFFFF8FCFD
FCFDFFFFFFFFC9C7C8D2D0D1FFFFFFFFFFFF000000FCFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFBFEFFFBFEFFFDFBFBFB
FFFDFFFFFDFDFFFAF5FFF8F1FFFBFBFFF9FEF9FFFFF0F7FBFAF6F3D9D3D1
808388F8FFFFFBFFFFFBFCFEFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFDFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F6F9FFFEFFFBFAFDFFFEFF
424242919191000000FEFFFFFFFFFFFFFFFFFAF8F9FEFCFDFFFDFDFFFBFB
FFFDFD9C9598100910D6D0D8ABA8AE0E0D12EEEFF3FCFFFFF4F8F9FCFFFF
FEFFFFF9F9F9E1DFE0181615DDDBDAF7F7F5000100FEFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFDFCFFFDFCFFFFFCFFFFFEFFFDFCFDF7
FEFBF4FEF6F3FFFBFDFFFAFDFFFAF8FFF9F7F8FFFFF6FFFFFFFEFDF4EFEF
494D54F2FAFFFBFFFFFCFDFFFFFEFAFFFFFAFBFFFFF9FFFFFEFFFFFFFFFF
FFFDFDFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFBF9FCFFFEFFFFFEFF
D9D9D9131313040505FDFEFEFDFDFDFFFFFFFFFEFFFFFEFFFFFCFCFEF9F9
FFFDFDFFFCFFFFFAFFFFFCFFFFFCFFFEFFFFFBFCFFFCFFFFFCFFFFFEFFFF
FEFEFEFFFFFFFFFEFD8D8B8A3E3C3BFFFFFD040402FEFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFEFFFDFCFFFBFCFFFDFBFFFFFCFFFFFEFFFDFFFFF8
FFFFF4F7F0E8271A1FFBEAF0FFF1EB221914606872F1FDFFF9F8FBFFFEFD
7F868CD1D9E1FBFFFFFEFFFFFFFEFAFFFFFBFBFFFFF9FFFFFEFFFFFFFFFD
FFFDFDFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FCFCFCFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFEFFFEFDFFFFFEFF
FEFEFE868686040404000000020202000000010101000000020000010000
020000030000030002030004010004000004000004000004000102000002
000000010000050000050000010000A2A2A0000000FEFFFDFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFEFFFDFCFFFBFCFFFDFCFFFFFCFFFFFEFFFDFFFFF8
FFFFF3FFFEF6302126BCABAFFFF8F04A413C87909BD2DEECFEFDFFEEECED
484F538F989DF8FDFFFEFFFFFFFEFAFFFFFBFCFFFFFBFFFFFEFFFFFFFFFD
FFFDFDFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFF
F8F8F8F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFF8F8F8F7F7F7
FFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFBFBFBFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFEFDFFFFFEFF
FBFBFBFAFAFA2A2A2AA9A9A9FBFBFBFFFFFFF4F4F4FFFFFFFFFEFDFFFEFD
FFFDFCFFFEFFFFFDFFFFFDFFFFFEFFFEFFFFFCFFFFFCFFFFFCFFFFFEFFFF
FFFFFFFFFEFFFFFDFDF9F4F4D4D2D1121210050501FEFFFDFFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFCFFFDFCFFFDFCFFFFFEFFFFFBFBF9FFFFFA
FFFCF3FFFCF4A69A9A221212FFFAF4978F8D7C8594F4FFFFFDFCFFFFFEFF
F2F9FDF8FFFFF6FBFEFEFFFDFFFEFAFFFFFBFCFFFFFBFFFFFEFFFFFFFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FF4F4F4FFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFBFBFB8F8F8FF4F4F4FFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFA5A5A5FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF9FCFFFEFFFFFEFFFFFEFF
FFFFFFFFFFFFC2C2C21F1F1FEAEAEAF8F8F8FFFFFFFFFFFFFFFFFDFBFBF9
FDFDFBFFFFFFFFFEFFFFFEFFFFFEFFFEFFFFFCFFFFFCFFFFFEFFFFFEFFFF
FFFFFFFFFEFFFFFCFCFFFCFCFFFEFD71716F000000FCFEFBFAFAFAFAFAFA
FBFBFBFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFDFEFFFBFFFFFFF8F6F7
FFFDFFFFFDFAD7CCC40A0000A69893E3DCE10C1427E2EFFFFFFEFFFFFDFE
FBFFFFF5FCFFFCFFFFFDFDFBFFFDFAFFFEFBFCFFFFFBFFFFFCFFFFFFFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB1B1B1393939F0F0F0FFFFFF
FDFDFDFEFEFEF8F8F8FFFFFFB1B1B1393939F0F0F0FFFFFFFDFDFDFEFEFE
F8F8F8FFFFFFFFFFFF181818838383FBFBFBFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFFFEFFF8F7FAFBFAFD
FFFFFFFFFFFFFFFFFF6464646A6A6AFFFFFFFBFBFBFDFDFDF7F7F5FFFFFD
FFFFFDF8F8F6FFFDFEFEFDFFFDFEFFFDFEFFFBFFFFFBFFFFFDFEFEFEFEFE
FFFDFEFFFEFFFFFBFBFFFBFBFFFEFDF3F3F1070705B7B9B6FFFFFFFFFFFF
FFFFFFFDFDFDFDFDFDFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFEFFFFFEFFFFFEFFFFFEFFFFFEFFFBFFFFFAF9F7F8FFFDFF
FFFCFFFFFCFCF7EFE2120A00665B57A6A0A800081DEDF7FFFAF9FFFFFDFE
FBFFFFF5FDFFFCFFFFFFFFFBFFFDFAFFFEFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD7B7B7B2A2A2ADEDEDE
FEFEFEFEFEFEFFFFFFF7F7F7FDFDFD7B7B7B2A2A2ADEDEDEFEFEFEFEFEFE
FFFFFFF7F7F7FFFFFFEDEDED3B3B3B606060F4F4F4FFFFFFF7F7F7FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFEFFFFFEFFFFFEFF
FFFFFFFFFFFF525252F6F6F61B1B1BBFBFBFFEFEFEFFFFFFFCFEFBFDFFFC
FEFFFDFEFFFDFFFFFFFFFFFFFEFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFFFF
FDFBFCFFFAFCFFFDFFFFFDFFF6F4F5FDFDFD000000232424EFEFEFFEFEFE
FFFFFFFAFAFAFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFFFBFFFFFAFFFEFFFFFCFF
FFFAFFFFFCFCABA7993D3727CAC2BD87868C212B40E3EDFFFFFEFFFAF5F5
F7FBFCF9FFFFFEFFFDFFFFFAFFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFC8F8F8F1A1A1A
CECECEFFFFFFFFFFFFFEFEFEFEFEFEFCFCFC8F8F8F1A1A1ACECECEFFFFFF
FFFFFFFEFEFEFFFFFFF5F5F5F2F2F2535353474747EEEEEEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFDFFFFFEFFFFFEFF
FDFDFDFEFEFE030303FFFFFFE1E1E1BABABAFFFFFFF6F6F6FEFFFDFCFEFB
FEFFFDFEFFFDFDFDFDFDFDFDFCFDFDFCFDFDFAFEFDFAFEFDFCFDFDFDFDFD
FFFEFFFFFDFFFCF7F9FDF8FAFFFEFFFFFFFF000000CECFCFDCDCDCF2F2F2
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFFFFFEFDFFFDFDFFFDFFFBF6FA
FFFDFFFFFDFDF5F2E9FFFFF4FFFDF6FEFFFFF5FFFFF1F9FFFFFDFFFFFDFD
FCFFFFFBFFFFFEFFFDFEFDF8FFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFBFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFABABAB
1B1B1BB1B1B1FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFABABAB1B1B1BB1B1B1
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFF6F6F6656565323232EEEEEEFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFBFAFDFFFEFF
FFFFFFFFFFFF010101FAFAFAFFFFFFFBFBFBFFFFFFFFFFFFFEFFFDFCFEFB
FEFFFDFEFFFDFFFFFDFFFFFDFEFFFDFCFFFDFCFFFDFCFFFDFEFFFFFFFFFF
FFFEFFFDF8FAFFFCFFFFFDFFFBF9FAF9F9F9040404F4F5F5FCFCFCFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFFFFFDFFFFFDFFFEFDFFFEFFFFFCFFFFFBFFFFFCFFFFFCFC
FFFEFBF7F3F0746F71FAF8F7FFFFF8F8FCFB818C9ED0D8EDFEFBFFFFFCFC
FEFFFFFAFEFDF9FBF6FFFFFAFFFDF8FFFDFBFCFFFFFBFFFFFCFFFFFEFFFF
FFFFFDFFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
BEBEBE1F1F1F9E9E9EFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFBEBEBE1F1F1F
9E9E9EFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFF8181811A1A1ADFDFDF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFBFFFEFDFBFFFFF3FAFF
FEFFFFFEFCFD010000FFFEFDFEFFFFFDFEFEFFFEFDFFFDFCFEFFFDFEFFFD
FEFFFFFBFCFCFEFEFEFEFEFCFDFFFCFBFFFCFDFFFCFDFFFCFDFEFEFEFEFE
FFFEFFFFFAFCFFFDFFFFFDFFFFFDFEFFFFFF010101FEFFFFFFFFFFFEFEFE
FBFBFBFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFEFFFDFFFFFDFFFFFDFFFEFDFFFEFFFFFCFFFFFCFFFFFDFFFFFEFB
FFFBF7FFFEFBB3B0B6848285FEFDF6D2D4D1555C6AF8FDFFFFFDFFFFFDFD
FDFEFEFBFFFEFEFFFDFFFEF9FFFDFAFFFEFBFEFFFFFCFFFFFEFFFFFEFFFF
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FDFDFDFFFFFFF8F8F8FEFEFEFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFF9F9F9FFFFFFF9F9F9FDFDFDFFFFFFF9F9F9FFFFFFFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFDFDFDFFFFFFF5F5F5FFFFFF
FFFFFFFAFAFAFFFFFFFBFBFBF6F6F65E5E5E3A3A3AEBEBEBFFFFFFF9F9F9
FFFFFFFFFFFFFCFCFC6464643C3C3CEDEDEDFCFCFCF8F8F8FFFFFFFFFFFF
FCFCFCDEDEDE171717818181FFFFFFFFFFFFFFFFFFFEFEFEFDFDFBFFFFFD
FDFDFBFBFBF9FFFFFDFFFFFDFEFEFCFFFFFFFFFEFFFEFFFFF8FCFBFCFFFD
FFFFFFF8F8F8FEFFFFF9FFFFFAFFFFFDFDFFFFFBFFFFFBFEFFFEF7FEFFF9
FBFFFFFAFFFFFDFEFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FCFCFCFEFEFEFFFFFFFFFFFFF9F9F9FDFDFDFFFFFFF8F8F8FDFDFDFFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFE7E7E7121212E0E0E0
FFFFFFF6F6F6FFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFFFBFBFBFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFF7F7F7FBFBFBFFFFFFFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFE
FDFEFEFDFEFEFDFEFEFDFEFEFEFEFEFEFEFEFEFEFEFEFEFEFFFEFFFFFEFF
FBF6F8FFFDFFFFFCFEFFFAFCFFFDFFFCFAFBFEFCFDFDFDFDFCFCFCFCFCFC
FEFEFEFFFFFFFFFFFFFEFEFEFFFFFFB4B4B4010101080808000000424242
B1B1B1E0E0E0FFFFFFFDFDFDFFFFFFFBFBFBF9F9F9FFFFFFFEFEFEFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFFAFAFAFFFFFFF9F9F9FFFFFFF2F2F2323232060606
030303222222F3F3F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFDFBFAFFFEFD
FFFDFDFEF9F9FFF9F9FFFDFDBBB5B51812120400005B595AE3ECEFF7FFFF
FEFFFFFEFCFF0606047D7E7E7B80837A7D81FFFDFFFFFCFAFFFDF9FFFFFA
7C7D817E7E84807F827C7C7CFFFFFFFFFFFFF9F9F9F9F9F9747474111111
7D7D7D7C7C7CFFFFFFFFFFFFFFFFFFF9F9F97B7B7B8181817F7F7F818181
FFFFFFD2D2D2292929FDFDFD7A7A7A8888887A7A7A808080EEEEEE080808
696969FFFFFF7C7C7C8080807F7F7F7D7D7DFFFFFFFEFEFEFEFEFEFFFFFF
7D7D7D7F7F7F7F7F7F7D7D7DFFFFFFFEFEFEFEFEFEFFFFFF7D7D7D7F7F7F
7F7F7F7D7D7DFFFFFFFEFEFEFEFEFEFFFFFF7D7D7D7F7F7F7F7F7F7D7D7D
FFFFFFFEFEFEFEFEFEFFFFFF7D7D7D7F7F7F7F7F7F7D7D7DFFFFFFFEFEFE
FEFEFEFFFFFF7D7D7D7F7F7F797979848484FBFBFBFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFECECEC0C0C0C0000000404044D4D4D
FCFCFCFFFFFFFBFBFBFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFEFEFEFFFFFFFCFCFCFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFA6A6A6
000000000000000000A4A4A4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFEFFFDFD
FFFDFFFFFDFFFFFEFFFCFAFBFFFDFFFBF9FCFCFEFFFCFFFFFCFBF6FFFFF6
FEFDF9FEFFFF000604FBFFFFFAFDFFFFFEFFFFF9FFFFFBFFFFFCF9FDFCF7
FEFFFFFAFEFFFEFFFFF4F4F4FFFFFFFFFFFFFBFBFBFFFFFFFBFBFB373737
BCBCBCFDFDFDFFFFFFFAFAFAFCFCFCFEFEFEFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFF6B6B6B828282FFFFFFFEFEFEFFFFFFFFFFFFF9F9F9FFFFFF000000
2A2A2A2D2D2DFBFBFBFFFFFFFDFDFDFFFFFFFCFCFAFEFEFEFEFEFEFCFCFC
FFFFFFFDFDFDFDFCFFFFFEFFFCFCFCFEFEFEFEFEFEFCFCFCFFFFFFFDFDFD
FDFDFDFFFFFFFCFCFCFEFEFEFEFEFEFCFCFCFFFFFFFDFDFDFDFDFDFFFFFF
FCFCFCFEFEFEFEFEFEFCFCFCFFFFFFFDFDFDFDFDFDFFFFFFFCFCFCFEFEFE
FEFEFEFCFCFCFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFEFEFEFFFFFFFFFFFF838383000000030303020202C1C1C1FFFFFF
FEFEFEFFFFFFF7F7F7FFFFFFFBFBFBFFFFFFFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFFFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFC6C6C60B0B0B000000010101757575FEFEFEFFFFFFF9F9F9FFFFFF
FFFFFFF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFD
FFFFFFF9F9F9FFFFFFF8F8F8FBF9FCFEFCFFFFFFFFFFFFFFF8F8F6FFFFFD
FDFEFEFCFDFDFBFCFEFEFFFFFFFEFFFDFCFFFEFEFEFFFEFDFDFCF8FFFFFA
F4F9F2FCFFFFF9F9FFFFFDFFFFFFFFFFFDFABAB2B00A0507E6E8F2F5FCFF
F9FFFFFCFFFDFFFFFFFDFBFEFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA3A3A3
1616164848482B2B2BD9D9D9F7F7F7FFFFFFFCFCFCF7F7F7ADADAD0A0A0A
D1D1D1FFFFFFFBFBFBFFFFFFFFFFFFF5F5F5FDFDFDFFFFFFFEFEFEF8F8F8
FFFFFFFEFEFEFFFFFFFFFEFFFFFDFDFCF7F7FFFFFFFFFFFF817B7BDDD8D8
F8FEFEFBFFFFFFFEFFFFFDFFFBFFFFFAFFFFFDFDFDFFFEFDFFFFFFFBFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFBFBFBFFFFFFF7F7F7
FFFFFFF6F6F64343430505050000000F0F0FECECECFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F9F9FFFFFFFFFFFF4A4A4A0000000000001D1D1DE7E7E7FAFAFAFFFFFF
FCFCFCFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF9F9F9FFFFFF
FEFEFEFAFAFAFFFFFFF8F8F8F2F1F4FFFEFFFFFFFFF8F8F8FFFFFDFCFCFA
FBFBF9FFFFFFFFFEFFFEFDFFFFFDFEFFFEFFFFFDFDFFFEFBFFFDF6FFFFF8
F5FEF7F7FFFFFFF8FFFEF5FFFFFDFFFFFDFFFFFAF4A49695B3BAC8EFFFFF
F0FFFDF7FFF7FFFFFBFFFCFFFFFCFFFEFBFFFFFEFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF6F6F6FFFFFFFFFFFFFCFCFCDBDBDB2F2F2F585858F7F7F7
FFFFFFFFFFFFF5F5F5FCFCFCE6E6E6AEAEAECECECEF4F4F4FEFEFEFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFBFBFB
FFFFFFFFFFFFFCFCFCFFFEFDFFFCFCFFFDFDFFFFFFFAFAFAD0CCC94B4948
6B6E72F6F9FDFEFCFBFFFDFCF8FBFFFCFFFFFFFFFFFDFBFAFFFFFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFEFEFEFBFBFBFFFFFFFEFEFE
C0C0C00000000202020101017F7F7FFFFFFFFCFCFCFCFCFCFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFF9F9F9FFFFFFBBBBBB000000050505010101848484FFFFFF
FBFBFBFFFFFFF7F7F7FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFDFDFD
F8F8F8FFFFFF6B6B6B040404E6E5EAFBFAFDF5F4F7FFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFCFAFBFFFEFFFFFAFCFFFDFDFFFBF8FFFDF7FFFEF6D9DAD4
000405272B32AA95A10B0007A0A7B9F5FFFFFFFCF6FFF4EF595B68EAF6FF
F7FFFFF2FDF5FCFFFAFFFFFBFFFBFFFFFCFFFAF8FBFFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFAFAFA6F6F6F262626C5C5C5FFFFFFFEFEFEFCFCFC
FFFFFFFAFAFAFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFDFFFEFDFFFBF9FCF7F7969A9B5A5E5F
FFFDFD7D787ADEE6E8F9FFFFFFFDFFFFFBFBFEFFFFFAFEFFFFFFFFFDFBFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF8F8F8FFFFFFFEFEFEFEFEFE4C4C4C
0000000606061D1D1DE0E0E0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3D3D3D020202000000262626
EEEEEEFFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFDFDFD
FAFAFAFFFFFFFFFFFFACACAC040308121114DDDCDFFEFEFEFFFFFDFBFBF9
FFFFFDFEFEFCFCFAFBFFFEFFFEF9F9FFFEFBFFFDFAFFFEF6FFFDF5DBD7D4
0B0E1DFAF8FFFFEFEA1B0B09C5D5EAEDFFFFF7F7F5FFFEF6FEFDFFF3F6FD
FFFEFFFFFEFFFFFFFBFCFEF9FFFFFFFBFBFBFFFFFFFCFCFCFCFCFCFEFEFE
FFFFFF575757A3A3A3FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF
FCFCFCB1B1B1111111989898F9F9F9FFFFFFFEFEFEFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBF9FFFFFBFFFBFAA49E9C131B1DC4CACA
FFFCFD625C5CC6CFD2F0FBFDFFFDFDFFF9F7FCFFFFFBFFFFFAFAFAFFFEFD
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFF
FCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF090909020202
000000767676FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDADADA0C0C0C0B0B0B000000
585858FFFFFFFEFEFEFCFCFCFBFBFBFDFDFDFCFCFCFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFBFBFBFDFDFDFEFEFE33323700000218171AD0D0D0FBFBF9FEFEFC
FEFEFCFFFFFDFFFEFFFCFAFBFFFDFFFFFDFDFFFDFAF9F4EEFFFEF6F2EDED
1E1B2ED6CFDFFFF9ED9B93888599AFE5FDFFFEFFFFFFFDF7FCFEFBFDFEFF
FFFCFFFFFBFFFDF8F8FDFCF8FCFFFDFBFFFFF7F8F8FFFFFFFFFFFF979797
0101010D0D0DFFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFDFDFDF9F9F9
777777202020C9C9C9F4F4F4FFFFFFFBFBFBFCFCFCFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFCFFFEFDFFFAF8FFFCFCF8FCFDFCFFFF
FFFDFDFFFDFFEFF7F9F9FFFFFFFDFFFCF6F6FEFFFFFCFFFFFCFCFCFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FEFEFEFBFBFBFFFFFFFDFDFDFFFFFFFCFCFCF3F3F3232323000000000000
3F3F3FFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA1A1A1000000050505
030303A2A2A2FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFFEFEFE
FCFCFCFEFEFEFEFEFEFFFFFFDDDCE10D0C0F000002050505ACACAAFFFFFD
FBFBF9FFFFFDFAFAFAFFFFFFFFFEFFFBF9F8FFFEFBFFFEFAFFFEF6FFFCFF
C8BED6110517FFF8E68D8E7C283D50EDFFFFFEFEFFF5EFECFAFFF8FCFFFD
FFFBFFFFF3FFFFFAFFFFF9F7FBFFFDF5FFFAFCFFFFB7B7B71717170C0C0C
090909F3F3F3FFFFFFFDFDFDFDFDFDFFFFFFFAFAFAFFFFFFE1E1E13D3D3D
434343EFEFEFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFEFDFFFDFFFDFBFCFFFFFDFDFDFB
FEFDFFFEFDFFFEFFFFFEFFFFFDFCFFFDFCFFFFFFFFFFFFFDFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFFF8F8F8F4F4F4FFFFFFFFFFFFFEFEFE464646010101030303161616
E4E4E4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF646464000000
030303070707D3D3D3FFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFEFEFEFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFF7F7F7FFFEFF4A494C0A0A0A0000000B0B0950504E
EEEEECFFFFFFFDFCFFFFFEFFFFFEFFF9F7F8FCF7F7FEFAF7FFFFF8FFFCFF
FFF3FFC6B9CA65624F656C58324554E0F1FFFBFBFFFFFEFBFBFFF8F9FFF9
FFFCFFFFFAFFFFF6FBFFFDFBF4FDF89DA7A2222625040404000000222222
FDFDFDFFFFFFFFFFFFFDFDFDFFFFFFFEFEFEFFFFFFBABABA141414838383
FFFFFFF9F9F9F8F8F8FAFAFAFEFEFEFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFDFFFDFDFDF8F8F9F9F9FFFFFFFDF9F6FEFCFB
FCFFFFFCFFFFFEFCFBFBF9F8FAFDFFFCFFFFFFFFFFFFFDFCFEFEFEFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFAFFFFFF
FBFBFBFFFFFFFFFFFFF1F1F1FFFFFF919191030303000000000000B6B6B6
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3292929
000000000000343434F6F6F6FFFFFFFAFAFAFEFEFEFFFFFFFCFCFCFCFCFC
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF8F8F8FBFBFB
FFFFFFF7F7F7F9F9F9FFFFFFFEFCFFD5D3D60A0A0A000000000000080806
1516169E9F9FFEFFFFFDFEFFFCFBFEFFFFFFFFFEFDFFFFFBFBFAF5FFFCFF
FFF9FFFFF5FFFBFBEEFBFFF4F3FFFFF5FFFFFCFCFFFFFFFDFAFFF9FBFFFA
FDFAFFFEF4FDB8ABB0534D4D0E1410020B06000000000000000000FCFCFC
FBFBFBFCFCFC515151FFFFFFFDFDFDFFFFFF7979791A1A1AC5C5C5FFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFDFDF8F8FFFDFDFFFFFFFFFFFFFEF8F6FFFDFD
F9FEFFF6FBFEFFFDFDFFFBFBFBFFFFFBFFFFFBF9FAFEF9F9FFFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FDFDFDFFFFFFFDFDFDFFFFFFCBCBCB000000030303000000797979FFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAD7D7D7
0E0E0E0000000808086B6B6BFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FEFEFEFEFEFEFFFFFFF7F7F7FFFEFFFEFCFF494949000000050503000000
0000000304040B0C0E808183FFFEFFFDFCFFFCFCFCF9F7F6FFFFFBD6D1D3
968E9BFFFBFFFFFFF8ECF2E8717880F5FDFFFCFFFFFAFBFD555A54242923
0F0E1109030A160F12030000000100000100050606222222EAEAEAF9F9F9
FEFEFEFFFFFF030303FFFFFFE8E8E8404040414141E9E9E9FFFFFFF8F8F8
FEFEFEFFFFFFFFFFFFFAFAFAFCFCFCFFFFFFFFFFFFFDFDFDFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFDFDFDF8F8FBFBFBFFFFFFFFFDFDFFFBFB
FBFFFFFBFFFFFFFEFFFFFDFFFBFFFFFBFFFFFCFCFCFFFEFDFFFFFFFDFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF8F8F8EDEDED2525250000000404043F3F3FF0F0F0FCFCFC
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
8B8B8B040404000000010101A9A9A9FFFFFFFAFAFAFEFEFEFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF919191020202303030AEAEAE
FCFCFCFFFFFFFFFFFFFEFEFEFBF9FCFFFEFFA4A2A30D0B0C010100040402
232424232424141517000004414246FEFFFFFDFEFEFFFFFDFDFDF9FFFFFD
555258D8D5DBFAF5F7888687AEADB2F8FBFFF9FFFFF9FFFF777976383836
161518000002080909010202030000030000141213EBEBEBFFFFFFFFFFFF
FFFFFFF8F8F8060606B7B7B7171717808080FFFFFFFCFCFCFEFEFEFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFEFEFEFFFFFFFDFDFDFBFBFBFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFBFBFFFDFDFFFFFBFAFAF8FFFEFFFDFBFE
F2F6F3FBFFFEFDFCFFFCFBFFFAFEFDFCFFFDFFFFFFFFFEFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF2F2F2FFFFFF
F7F7F7FFFFFFFFFFFF5555550202020000000D0D0DDDDDDDFFFFFFFEFEFE
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FDFDFD525252040404000000171717E4E4E4FDFDFDFFFFFFFCFCFCFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FFFFFBFFFFFBFFFFFDFFFFFFFEFFFFFEFFFFFDFBFEA19FA2DBDBD9F1F1EF
FBFCFCFEFFFFFDFDFDFEFCFDFFFEFFFFFEFFFBF9FA06040500000050504E
242525EFF0F0F9FAFCFEFFFFF4F5F9F6F7F9FEFFFFFDFEFEFFFFFDFCFCFA
E6E7E948474AD1CBD2595458FFFEFFFEFFFFF4FCFEF9FFFFFEFFFFF9F9F9
F9F9F9C3C4C6161A190607070300000F0909C8C6C7FCFCFCFFFFFFFCFCFC
FFFFFFFEFEFE0000001B1B1BC0C0C0FDFDFDFBFBFBFFFFFFFBFBFBFDFDFD
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFBF9F8FEFEFAFFFFFDF8F6F9FFFEFF
FEFFFDFEFFFDFFFEFFFFFEFFFCFEFBFEFFFDFFFEFFFDFCFFFCFCFCFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFAFAFA
FFFFFFFFFFFF909090020202000000030303ACACACFEFEFEFFFFFFFCFCFC
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFF
FFFFFFEDEDED1C1C1C0202020000003E3E3EFFFFFFFFFFFFFFFFFFFDFDFD
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFB
FFFAF0FFFEF4FFFFFBF7F8F8FCFFFFFBFEFFFEF8FFFFFBFF94938FD6D8D3
FBFFFFFCFFFFFAF8FBFFFDFFFFFEFFFFFFFFFCFCFC4545450B0B0BAFAFAF
6A6A6A4C4C4CFBFBFBFFFFFFFCFBFEFFFFFFFCFCFCFFFFFFFBFBFBFFFFFF
FCFCFCABABAB020003E9E7E8FFFFFFFAFAFAFEFFFFFBFCFCFFFFFFF8F8F8
9898981515158788880A0A0A100E0F6A6869FEFEFEFDFDFDFFFFFFFFFFFF
EBEBEB4343432C2C2CE3E3E3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFEFEFE
FDFDFDD2D2D20909090000000000006A6A6AFFFFFFFFFFFFFEFEFEFEFEFE
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF9F9F9
FCFCFCFFFFFFBCBCBC010101020202030303828282FDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFDF8
FFFCF1FFF3E5FCF9F2FCFFFFF4FDFFF9FDFFFFFBFFFFF7FFFCF8F571736E
E6F2F0F8FFFFFFFEFFFDF6FBFCFAFBFCFCFCFFFFFF838383000000D8D8D8
FAFAFA3D3D3D858585FCFCFCFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFDFDFD
FFFFFFFFFFFFD4D4D4FCFCFCFEFEFEFBFBFBFCFCFCFFFFFFEDEDED505050
393939D7D7D7BCBCBC060606212121FFFFFFFDFDFDFFFFFFFEFEFEBDBDBD
121212818181FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFF
F1F1F12A2A2A000000030303313131FEFEFEFBFBFBFFFFFFFFFFFFFDFDFD
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFF
F9F9F9FFFFFFFFFFFF7E7E7E000000000000050505C7C7C7FFFFFFFDFDFD
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF9FFFFFCFCF8
A28E8511000079746A8F9893000911CCD5E0FFF7FDECD9DBFFFBFC828685
ABBFBDE9FBFAFFFBFFFFFAFFFFFDFFFFFFFFFFFFFFA6A6A6020202FFFFFF
FDFDFDE7E7E7191919BABABAFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDC2C2C2202020727272
F0F0F0FCFCFCB0B0B0000000A3A3A3FEFEFEFEFEFEFFFFFF8484841D1D1D
BDBDBDF9F9F9FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFB
5F5F5F000000000000121212D7D7D7FFFFFFFCFCFCFFFFFFF7F7F7FFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFF8F8F8FFFFFF
FFFFFFFBFBFBF6F6F6FFFFFF474747000000000000272727EAEAEAFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF5FDFBFDFDF9
54413AD2BEB5EDE9DD000400495760C9D2DFFFFBFFD0C0C131282B090D0E
D9ECE8F4FFFFFFFDFFFFFBFFFEF9FBFFFFFFFCFCFCF2F2F2888888F9F9F9
FFFFFFFCFCFCC2C2C2121212DBDBDBFFFFFFFFFFFFFEFEFEFEFEFEFFFFFF
FFFFFFF8F8F8FFFFFFFBFBFBFFFFFFFBFBFB8A8A8A1B1B1BB0B0B0FCFCFC
FFFFFFFFFFFF797979040404FFFFFFFAFAFAECECEC454545373737E4E4E4
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F99A9A9A
0A0A0A000000000000A2A2A2FFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFBFBFB
FFFFFFF9F9F9FEFEFEFFFFFFDBDBDB101010050505000000545454FFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFB
857C779B928BFDFAEFC1C3BD0B0F18F4F6FFFAF7FDFBF4F7FFFEFFFCFDFF
F9FFFBF9FFFBFBF8FEFFFCFFFFFEFFFFFFFFFFFFFFF8F8F8FDFDFDFFFFFF
FCFCFCFDFDFDFFFFFF9F9F9F272727F4F4F4FCFCFCFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFDFDFDFAFAFAE8E8E8474747363636DFDFDFFFFFFFFFFFFF
F6F6F6FFFFFFCBCBCBD5D5D5FFFFFFC8C8C81F1F1F787878FFFFFFFFFFFF
FFFFFFFBFBFB525252FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCD7D7D70C0C0C
0000000000006C6C6CFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFF9F9F9FBFBFB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFDFDFDFFFFFFF9F9F9FFFFFFB0B0B00000000404040000009C9C9C
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFDFCF8F5
CCC5BD140F05FFFFF6FDFDF91D1D25DFDEEBFFFEFFFFFEFFFFFFFFF9FAFA
FBFFFCFAFEFBFFFEFFFEFBFFFFFEFFFBFBFBF9F9F9FFFFFFFFFFFFFFFFFF
F9F9F9FFFFFFF5F5F5FFFFFF5E5E5E585858FFFFFFF6F6F6FFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFB2B2B21313137F7F7FFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFF909090151515B1B1B1FBFBFBFBFBFBFAFAFA
FAFAFAFFFFFF000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFCFCFC292929000000
080808272727F5F5F5FFFFFFFFFFFFF6F6F6FEFEFEFFFFFFFDFDFDFFFFFF
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FDFDFDFEFEFEF8F8F8FFFFFFF9F9F9FFFFFF646464000000060606070707
D4D4D4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFD
FFFEEF645D4B898581FCFDFF4448539FA1ADFFFDFFFEF9FBFFFFFAFCFEF9
F9FFFFFBFFFFFAF8F9FFFDFDFFFDFEFFFFFFFFFFFFFAFAFAF8F8F8FFFFFF
FCFCFCFBFBFBFFFFFFFFFFFFFFFFFF2E2E2E8B8B8BFFFFFFFBFBFBFDFDFD
FDFDFDFBFBFB676767252525C2C2C2FBFBFBFFFFFFF7F7F7FFFFFFFCFCFC
FFFFFFFEFEFEF2F2F25050502F2F2FE0E0E0FFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFF010101FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF575757010101040404
0A0A0AD8D8D8FDFDFDFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEF8F8F8
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDFCFCFC2F2F2F000000030303
292929F6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFAF5F5
FFFBECFFFFED8783806D6D732E323B868892FBF7FFFFFCFFFFFFFAF9FBF5
F8FFFFFBFFFFFDFBFCFFFBFBFFFDFEFFFFFFFBFBFBFDFDFDFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFF5F5F5FFFFFFE6E6E6161616B8B8B8FFFFFFFFFFFF
DEDEDE303030545454E9E9E9FCFCFCFFFFFFFCFCFCFFFFFFFDFDFDFFFFFF
FCFCFCCECECE1D1D1D6F6F6FFCFCFCFCFCFCFFFFFFF9F9F9FFFFFFFFFFFF
FDFDFDF9F9F9070707FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9F070707000000000000
9D9D9DFCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFF
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBD4D4D4070707030303
000000686868F7F7F7FFFFFFF9F9F9FFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFD
FFFEF6FFFCF2FFFEFBFDFCFFFCFFFFFCFFFFFFFCFFFFFCFFFFFEFDFEFFFA
FCFFFDFCFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFCFCFCC0C0C0191919DEDEDEA3A3A3
171717969696FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFDFDFDFFFFFFFEFEFE
959595141414AEAEAEFAFAFAFFFFFFFCFCFCFEFEFEFFFFFFFDFDFDFDFDFD
FFFFFFFEFEFEA6A6A6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FFFFFFFBFBFBFFFFFFFEFEFEFFFFFFD4D4D40A0A0A0202020101015C5C5C
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9FFFFFFFFFFFF959595000000
010101060606B4B4B4F9F9F9FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFBF6F6
9A928DD5CEC6FFFCF9FFFFFFC6C9CD93969DFFFCFFFFFCFFFFFEFDFEFFFB
FCFFFDFCFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDB6B6B64F4F4F2B2B2B
C9C9C9FFFFFFFFFFFFF9F9F9FFFFFFFBFBFBFFFFFFFFFFFFEEEEEE5B5B5B
2C2C2CDADADAFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFAFAFAFFFFFF
FAFAFAFEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFF6F6F63232320000000000002D2D2DF9F9F9
F6F6F6FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFDFDFD565656
000000000000101010E9E9E9FFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFF
F3EAE1453D32F6F3ECF4F5F5282B3AECEDFDFFFDFFFFFDFBFFFDFDFEFFFF
F9FFFFF9FFFFFFFEFFFFFDFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFB0B0B0F2F2F2
FFFFFFFDFDFDFFFFFFFFFFFFF6F6F6FAFAFAFFFFFFCCCCCC2424246A6A6A
F0F0F0FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFFFFFFFFDFDFD696969000000080808080808D1D1D1FFFFFF
FFFFFFF2F2F2FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFDFDFDF3F3F3
1D1D1D0909090000003C3C3CF9F9F9FBFBFBFFFFFFFFFFFFF6F6F6FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCF9FFFFFDFF
FFFAF2AAA69AA6A39A8D8D8DACAABDFDFBFFFFFEFFFFFFFAFFFEFDFEFFFF
FCFFFFFCFFFFFFFEFFFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF9B9B9B131313A7A7A7FFFFFF
FFFFFFFDFDFDFBFBFBFFFFFFFFFFFFFAFAFAFCFCFCFFFFFFFAFAFAFFFFFF
FEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFEFEFEADADAD050505000000000000989898FFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFFFFFFFBFBFBFFFFFFFCFCFC
C8C8C80000000505050202027F7F7FFFFFFFFAFAFAFFFFFFFFFFFFF6F6F6
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFFFDF6F9
F7F9F4FCFFF829291F474141FFF9FFFFF9FFFCFFFFF9FFFFFCFFFFFFFEFF
FFFDFDFFFDFDFEFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFAFAFA
FEFEFEFFFFFFFAFAFAFEFEFEF4F4F45A5A5A252525D8D8D8FBFBFBFCFCFC
FFFFFFFDFDFDFDFDFDFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6
FBFBFBFEFEFE5B5B5BF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFDCDCDC0505050000000101015A5A5AFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFF3F3F3FFFFFF
FFFFFF818181000000000000050505CACACAFFFFFFFCFCFCFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF9FFFFFCFF
FEFFFBFAFFF6DFDED9F4EDF0FFF3FFFFFAFFFBFFFFF8FFFFFCFFFFFFFFFF
FFFCFDFFFCFDFEFFFFFBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFAFAFAFFFFFFD2D2D22B2B2B5F5F5FFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFDFDFDFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFAFAFAFEFEFEFFFFFF
FFFFFFFCFCFC010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEF4F4F4333333060606000000242424ECECECFFFFFFFFFFFFF8F8F8
FFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFFFEFEFE
FFFFFFFCFCFC4141410B0B0B0000001C1C1CE7E7E7FEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEF8FFFFFAFF
FFFFF6FFFDF2FFFEFDFFFDFFFFFCFFFBF9FFFFFDFFFEFFFFFFFFFDFFFFFB
FFFEFFFFFEFFFFFFFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF6F6F6
FFFFFFFCFCFCA4A4A41313139D9D9DFFFFFFFDFDFDFDFDFDFFFFFFFFFFFF
F9F9F9FFFFFFFDFDFDF8F8F8FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FEFEFE6D6D6D000000000000070707CBCBCBFFFFFFF5F5F5FFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFDFCFFFFFDFFFFF7EFFFFDF3F2EEEBFBFAFF
231E2EE8E4F2FFFEFFFFFEF9C0BFBA999A9E6A7189F0F7FFFBFFFFFEFFFA
FFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFDFDFDFFFFFFFEFEFEF8F8F8FFFFFF
FFFFFFFDFDFDFCFCFCFFFFFFA2A2A2000000040404000000A7A7A7FAFAFA
FFFFFFFAFAFAFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEBEBEB
4747473A3A3AE6E6E6FFFFFFFFFFFFFEFEFEFCFCFCFBFBFBFFFFFFFCFCFC
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFFFFFF
FEFDFFFEFDFF010003FFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFFFEFFFFFEFFFEFFFFFEFFFFFFFEFDFFFEFD
FFFEFFFFFEFFFFFEFFFFFFFDFFFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFEFEFEFEFEFEF8F8F8CCCCCC020202
030303000000797979FFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFFFFFCFFFFFFFEFFFFFDFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFDFFFFFEFFFEFFFBFCFFFBFEFFFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFF8F9FFF8EDAB948A0201065E6871
434A52B0B5B9FAFDFFFFFFFFFFFEF8B4B5B5000413E0F1FFFFFEFFFFFDF6
FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFFFFFFF9F9F9606060000000000000121212D9D9D9
FFFFFFFCFCFCFDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFC0C0C0232323
777777FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFEFAFFFFFBFDFDFBFDFCFF
FFFDFFFFFCFFA7A4AAFFFEFFFFFEFDFEFDF9FFFFFAFFFFFAFCFBF7FFFDFC
FFFEFFF9FAFAFBFFFAFCFFFAFFFCFFFFF8FFF9FCFFFCFFFFFFFCF8FFFAF8
FFFBFFFFFCFFFFFDFDFFFFFAFEFFFBFCFFFDFEFFFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFCFCFCF0F0F0171717030303
000000434343F6F6F6FFFFFFFFFFFFFEFEFEFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFF3FFFFF7FFFFFEF9F9FFFBFD
FBF9FCFFFFFFFFFEFAFFFBF8FFFAFFFFFBFFF5FFF0F8FFF4FBFFFFFCFCFF
FEFEFFFEFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFDFFFFFBFFFEF4F2FFFFEBBCBCAF121524FAF8FF
FFF8F2221B10C7D9D8ECFEFFFDFCFFFFFCFFFAFBF5F6F9F0FEFFFFF2F3F7
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFF9F9F9FFFFFFFCFCFC8F8F8F020202000000
000000B9B9B9FEFEFEFFFFFFD2D2D21F1F1F6C6C6CF5F5F5FDFDFDF8F8F8
FFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFAFFFFFDFAFAFAFFFEFF
FEFDFFFFFEFFFBF9FCFFFEFFFEFDF9FFFFFBFFFFFAFAFAF6FDFDFBFFFFFF
FFFEFFFCFDFFFEFFFAFAFBF5FFF9FCFFFCFFFFFBFFFFFEFFFCFFFAFEFFFB
FFFAFFFFF9FFFFFEFDFCFFFAFCFFFBFEFFFDFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFC0C0C00303030404040606066E6E6E
FFFFFFFCFCFCFFFFFFFDFDFDFFFFFFF9F9F9FEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFEFEFEFEFEFEFCFCFCFFFFFFFCFCFC
5757578D8D8DFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF7FDF9F8FAF7FFFBFDFFFCFB
CDCCC8959B9B949DAAD1D8E0FFFEF4FFFCEFFFFAF8EAE2EB637283F0FFFF
FAFEFFFFFEFBFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF1EFEE645F61241A23BCB5BCFFFFFBFEFFFB
F8FFFFFBFFFFFFFFFFFFFDFCFDFFFAFCFFFDFBFFFFFBFEFFFEFCFDFFFDFD
FFFEFFFDFDFDFEFEFEFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFF9F9F9FBFBFBFFFFFF
9F9F9F2424246F6F6FF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFEFFFFFEFFFFF8F6F7FFFEFDFCFCFAFEFFFDDADADA363636
515252F4F5F5FEFCFBFFFEFDFBF9FAF1EFF0FFFEFFFCFDFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFCFCFCFFFFFF4747470909090000001A1A1A
E6E6E6FEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFD
FDFFFCFDFEFE000103FFFEFFFFFEFFFFFDFFFFFDFFFFF9F7FFFDF6FFF8EC
FFF8E3D9D3C5DCDDE1CFD6DAF0FCEEE8EFE7DAD2E5DDD5ECD6DDE5F8FFFF
FFFDFDFFFBFFFFFBFFFFFDFFFBFFFFFBFFFFFFFEFFFFFDFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCD9D9D90D0D0D000000050505
676767FBFBFBFCFCFCFFFFFFFFFFFFFBFBFBFDFDFDFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFEFFFFFEFFFFFEFF
FFFFFFFFFFFFFEFFFFFFFFFFFFFEFDFFFEFDFFFFFFFEFFFFFEFFFFFEFFFF
FFFEFFFFFEFDFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFEFEFE222222E0E0E0FEFEFE
FEFEFEFEFEFEFFFFFFFDFDFDFFFFFFD4D4D44E4E4E333333DBDBDBF4F4F4
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFDFBFAFFFFFBFEFFFAFCFFFB
FEFFFFFBFFFFF4FEFBFBFFFDFFFDFAFFFAFCFFFBFFFFFCFEFCFFF6F8FFF7
FBFFFFFBFEFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFF8F8F8F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFF
F8F8F8FFFFFF7171711C1C1CBEBEBEF2F2F2FDFDFDFDFDFDFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FBFBFBFBFBFBFFFFFF999999171717ABABABFCFCFC6060609C9C9CFEFEFE
FFFFFFFBFFFFF7FFFFEFF4F8FFFCFFFFF9F7696C631B2019CFCDCCFFFEFF
FBFFFFF9FDFAF9F6EFFFFDF8FFFCFBFFFCFFB5B5BDA3A6ADFDFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3C3C3000000080808
000000838383FFFFFFF6F6F6FFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFF
F5F5F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFAFAFAFFFFFF
FAFAFAFEFEFEFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
F5F5F5F6F6F6FFFFFFFBFBFBFEFEFE6E6E6E040404000000090909D4D4D4
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFCFFFFFEFEFFFFFCFFFFFDFB
FFFEFDFEFFFFFCFFFFFEFFFFFFFEFAFFFFF8FFFFFDFBFFFFF8FFFFF9FFFF
FFFDFBFFFDF8FFFBF8FFFFFBFEFCFDF2F3F3FEFFFFFAFDFFFCFFFFF9FDFE
FFFEFFFFFFFFFFFEFDFFFEFDFFFEFDFFFFFDFFFEFFFEFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFBFBFBFCFCFCFDFDFDFDFDFDFEFEFE
FFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEB1B1B1D0D0D0FFFFFFB9B9B9E6E6E6FFFFFF
FFFFFFFFFFFFF7F7F7FFFFFFFEFEFEFBFBFBFFFFFFFBFBFBE4E4E44A4A4A
2F2F2FD3D3D3FFFFFFFFFFFFFBFBFBFAFAFAFFFFFFFCFCFCFFFFFFFEFEFE
F6F6F6FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FAFAFA939393646464FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFF
FAFAFAFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFCFCFCFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
F8F8F8FCFCFCFFFFFFFBFBFBFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAF7F7F7
FFFFFFF8F8F8FDFDFDFFFFFFEFEFEF5B5B5B0C0C0C424242BEBEBEFFFFFF
FFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFCFCFCFAFAFAFDFDFDFFFFFFEBEBEB
646464FFFFFFF8F8F8FDFDFDCFCFCF797979666666AAAAAA9898981A1A1A
9C9C9CFCFCFCFFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFCFCFCF9F9F9FFFFFFFFFFFF
FCFCFCFFFFFFF2F2F21D1D1D020202050505393939F8F8F8FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3C3C3
010101000000000000727272FFFFFFFCFCFCFFFFFFF7F7F7FEFEFEFCFCFC
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFDFCFBF9F8FFFEFBFEFAF7FFFEFBFFFCF9
4E4A47D1CFD0302F34E5E5EBF7F7FDFEFFFFF8F9FDFEFFFFFCFDFFFEFFFF
FEFEFEF6F6F60C0C0CEDEDEDFDFDFDFCFCFCFBFBFBFFFFFF8E8E8ECBCBCB
F8F8F8FAFAFAFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBC3C3C35656561A1A1A
5D5D5DCBCBCBFDFDFDFDFDFDFCFCFCFFFFFFFEFEFEFDFDFDFFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFAFAFAF9F9F9FFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFDFDFDFBFBFBFEFEFEFEFEFEFAFAFAFBFBFBFFFFFFFFFFFFF7F7F7
383838A4A4A4FFFFFFFFFFFFF5F5F5FFFFFFFFFFFFFEFEFEFFFFFFFEFEFE
818181FFFFFFFCFCFCFBFBFBFEFEFEFBFBFBC2C2C2B7B7B7FFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FBFBFB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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFFCFCFCFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBF5F5F5
0E0E0EFAFAFAF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFCFCFC878787F3F3F3B0B0B0
090909000000020202000000A2A2A2F9F9F9FFFFFFF9F9F9FDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDF9F9F9FCFCFC
FFFFFFF5F5F5B0B0B0101010E2E2E2FFFFFFFFFFFFFCFCFCFFFFFFDADADA
929292676767A0A0A0DCDCDCFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFDADADA0D0D0D
020202000000616161FFFFFFFCFCFCFFFFFFFFFFFFF6F6F6FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FAFAFAFFFFFF000000FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFD0D0D0030303000000080808676767FCFCFCFFFFFF
FFFFFFFCFCFCFFFFFFFEFEFEFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFFFBFFFFFDFFFFFD
FFFFFFFFFEFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFAFEFFFAFEFFFBFFFF
FBFFFFFAFEFFFDFEFEFEFFFFFEFFFFFAFCF9FAFCF9FEFFFDB2B4B1323431
FCFCFAFFFFFDFBFBFBFFFFFFFEFDFFFFFEFFFCFBFEFEFDFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFFFFFF
FCFCFCFFFFFFADADAD393939FCFBFEFFFEFFFFFEFFFAFAFAFFFFFFFCFCFA
FFFFFDFFFFFDFCFCFAB8B8B6ACACAAFFFFFFFFFFFFFAF9FCFAF9FCFFFEFF
FFFFFFFDFDFDFDFDFDFFFFFFFCFCFCFEFEFEF2F2F2090909C5C5C5262626
989898FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FEFFFDFFFFFDFFFEFFFFFEFFFFFFFFFFFFFDFFFFFBFFFFFDFFFEFFF8F9FD
FDFCFFFFFEFFB0AAAA0C0707EBEAEDFEFFFFFEFDFFFEFEFEFFFFFFCBCBCB
2C2C2CFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFDFDFDBBBBBBD0D0D0FFFFFFFEFEFE
B3B3B3464646262626ADADADFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFCFFFDFDFFFEFDFEFFFFFCFFFF
FAF9FCFFFEFDFBF8F15C5B56F0F3F7FAFDFFFDFCFFFDFBFEFFFEFFFFFEFF
FEFEFCFFFFFBE4E4E29F9F9F6A6A6A8F8F8FDFDFDFFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFFFFFFF8F8F8A6A6A6
030303000000010101AEAEAEF9F9F9FFFFFFFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFAFFFFFFEFEFEF1E1E1E050505000000313131FEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFEFDFFFFFDFFFFFF
FFFFFFFFFEFFFEFFFFFEFFFFFEFFFFFDFEFFFEFFFFFCFFFFFEFFFFFCFFFF
FEFFFFFEFFFFFCFDFDFEFFFFFEFFFDFDFFFCFEFFFDFBFDFA525451989A97
FFFFFDF9F9F7FEFEFEFFFFFFFDFCFFFAF9FCFFFEFFFEFDFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFCFCFCFFFFFF
FFFFFFF7F7F7414141A9A7A6FFFEFAFCFBF7EAEDF2FCFEFFFFF9FFF8F3F7
FCFFFFF8FEFAFFFEF7FFFFFA909193CBCED3FEFEFFFEFEFFFFFFFDE3E2DE
BDBDBBFFFFFFFEFEFEFFFFFFFFFFFFFBFBFB909090515151141414A0A0A0
FFFFFFFFFFFFFBFBFBFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFDFDFDFFFFFF
F9F9F9FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FBFFF7FEFFFBFFFDFFFFFAFFFFFEFDFEFDF6F8F5EC9E9D999D9DA5ABADB9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FBFFF8FEFFFBFFFCFFFFFCFFFFFDF6FFFDF4FDF9F5E4E2E315131EC8C7D4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F9FDFCF8F9F9FFFDFFFFFDFAFFFFF1FFFFF3F9F9FFFFFCFF756D78ADA5AE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FEFEFFFFFEFFFFFDFDFFFBF3FFFFECDCDCD0000011211F358B7B855E5254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FEFCFFFEFBFFFFFDFBFFFCF1FDF8E2B3B3A9070D25F5F4FF3520231F0D07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FEFAFFFFFCFFFFFDFBFFFEF4FFFFECCCCDC5090E2BFEFBFFFEE9E40E0000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FFFCFFFFFCFFFEF9FBFFFEFAFFFFF3F0F0EC1A1B35CEC8E0FFFAEF9A8A7A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FFFAFCFFFCFFFFFEFFF9F9F9FEFFFAFDFEFEB2AEC41C1324FFF6EAB8AF9E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FFFBFBFFFCFDFDFCFFFCFFFFFAFFFEFEFFFFFEF6FFC6B8C35E544A6E695F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FFFCFBFFFCFCFFFEFFFBFFFFF6FCFCFAFBFDFFFAFFFDEEF3FFFDFAFAFAF6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FFFCFDFFFBFBFBFCFEFBFFFFFBFFFFFAFBFBFFFBFDFFFAFDFFFCFFFBFEFF
F8FFFFF8FEFEFFFCFFFFFDFFFCFFFFFBFFFFFEFFFFFDFDFD3D3D3DC2C2C2
FEFEFEFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEF3F3F3FFFFFFFFFFFFFDFDFDFFFFFFFCFCFC
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFE
FFFFFDFCFCFAF9F9F7FFFFFDFFFFFBFCFBF6FBF8ED8C898248474D706E7B
BFBACAFFFAFFFFFCFFFFFDFFFDFEF6FCFFF6F3FFFBF0FAF7FFFFF6FFFEF6
FFFEFFFFFEFFFFFEFFFFFFFFFFFFFFF9F9F9D7D7D70B0B0B000000666666
FDFDFDF6F6F6FCFCFCC1C1C16262622A2A2A1C1C1C777777C6C6C6F5F5F5
FCFCFCFFFFFFFCFCFCFCFCFCFEFEFEFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFCCCCCC6F6F6F6F6F6F
BEBEBEF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF9F9F9
FCFCFCFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFA3A3A3020202000000
0000009F9F9FFFFFFFFCFCFCFAFAFAFBFBFBFFFFFFFFFFFFFFFFFFF3F3F3
FFFFFFFFFFFFF2F2F2FFFFFFFFFFFFFFFFFFFCFCFCF8F8F8FFFFFFFFFFFF
FDFDFDF7F7F7FFFFFFFFFFFFDDDDDD0808080000000000005D5D5DFDFDFD
FFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FBFBFBFDFDFDFFFFFFFAFAFA
FFFFFFF6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF626262808080FFFFFFFFFFFFFFFFFFF5F5F5FFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFDFDFDFFFFFFA4A4A40000004C4C4C5E5E5E5F5F5F5D5D5D
0A0A0A0F0F0FC5C5C5FFFFFFFFFEFFFCFAFDFFFBFBFFFFF8D6D6C994938C
FDFBFFFCFEFFF1F6F9696D6AFFFBFD8B8489FBF8FEF1F0F5FFFEFDFDFCF8
FCFCFAF7F7F7181818DADADAFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFDFDFD
FCFCFCFFFFFFFEFEFEFBFBFBFFFFFFFFFFFFFFFFFF6363637B7B7B606060
989898FFFFFFEFEFEF909090272727313131949494F0F0F0FFFFFFFFFFFF
F6F6F6FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFDFDFFFEFDFDFDFDFCFDFFFCFFFFFFFFFFFFFCFAFFF7F6FFFDFFFCFFFF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FBFDF8FEFFFDFFFFFFFBF9FCFCFBFFFFFFFFFFFFF8FFFEFAFFFCFFFEFCFF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F9FFFAFCFFFBFFFEFFFFFCFFFFFCFFFFFEFFF8FFF3FCFFF6FFFAFFFCF5FC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F5FFF4F4FEF3FFFDFFFFFAFFFFF9FFFFFDFFF0FFF1F4FFEEFFFDF8FFFBFD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F7FFF4F7FEF4FFFDFFFFF8FFFFF4FFFFFDFFF5FFF8F7FFF3FFFBF3FFF8F7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FCFFFBFEFFFDFFFEFFFFFEFFFFFCFFFFFEFFFCFFFDFCFFFBFFFFFBFFFDFD
FCFCFCFEFFFFFFFDFFFFFEFFFDFDFBFEFFFBFFFFFF9C9C9C626262FFFFFF
FEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFBFBFBD5D5D5202020FDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFAFFFEFDFEFFFFFCFFFF
FFFEFFFFFEFFFFFDFDFFFEFDFCFFFFFCFFFFFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFDFFFFFFFAFAFAFFFFFFF6F6F6ADADAD6666667D7D7DC8C8C8
FCFCFCFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFF
FCFCFCFFFFFFD5D5D58484843535351212125D5D5DABABABF0F0F0FFFFFF
FEFEFEFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFEFEFEFBFBFBFFFFFFF8F8F8BBBBBB7575757D7D7DC4C4C4
FDFDFDE9E9E9232323000000030303404040FFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFBFBFBAAAAAAFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFEFEFEFFFFFF
727272000000020202060606CDCDCDFFFFFFFEFEFEFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF9FAFAFFFEFFFFFEFD
FFFCF3F6F1E9191215D7D2D6FFFFF8CDCEC8C9C9CFF7FAFFFCFFFF828685
484B50F9FCFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFE5E5E50A0A0AF6F6F6FFFFFFFEFEFEFFFFFFFFFFFF
F8F8F8FFFFFFFFFFFFE7E7E70000000606060E0E0EF2F2F2FFFFFFFDFDFD
FFFFFFFDFDFDFFFFFFFFFFFFFEFDFFFFFEFFFEFFFBFEFFFBFAFBFDFBFAFD
FFFFFFFEFEFCFCFAFDA7A5A83D3E40181C1D7A797CE0E0E0FFFFFF8F8F8F
4E4E4CFEFEFCFEFEFCFFFFFDFFFFFFFFFFFFFFFEFFFEFDFFFFFEFFFDFCFF
FFFEFFFCFBFEFFFFFFFFFFFF8C8C8C545454FEFFFFFFFFFFFFFEFDFFFEFD
FFFEFFFEFDFFFEFFFDFEFFFBFFFEFDFFFEFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFAFAFA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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFA
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF5D5D5DA0A0A0FEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF6969690D0D0DE9E9E9FFFFFFFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFAFAFAFAFAFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFAFAFAFFFFFFFEFEFEFCFCFC
FFFFFFFFFFFFFCFCFCFFFFFFECECEC9C9C9C6A6A6A8B8B8BD3D3D3FFFFFF
FEFEFEFBFBFBFFFFFFFAFAFAFDFDFDFFFFFFECECEC131313F6F6F6FFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFF5F5F5FFFFFF626262000000000000030303
D9D9D9FFFFFFFFFFFFFEFEFEF4F4F4999999080808000000060606464646
FFFFFFFFFFFFFCFCFCFFFFFFFAFAFAFFFFFFFCFCFCFFFFFFFEFEFEFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFEFFFAF8F9
FFFEF4FFFDF369636AFCF6FDFFFFF6F4F7EE898993D2D4E0FCFFFFFCFFFD
F6F7FBFEFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFF676767292929D1D1D1FFFFFF
F8F8F8E3E3E37C7C7CEEEEEEFFFFFFFFFFFFFFFFFFF8F8F8E2E2E29B9B9B
FDFDFDFFFFFFFBFBFBFFFFFFFDFDFDFCFCFC9595952A2A2A2F2F2F9C9C9C
F5F5F5FFFFFFF8F8F8FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFEFEFEFCFCFC
FDFDFBFEFEFCFCFCFCFFFFFFFFFFFFFFFFFFFDFCFFFEFDFFFFFFFFFDFDFD
FFFFFFBBBBBB2B2B29FBFBF9FFFFFDFBFBF9FFFDFFFFFEFFFEFFFDFEFFFB
FDFDF9FDFBFEFFF9FFFFFCFFFEFFFBFCFFF6FEFFFBFFFEFFFFFCFFFFFCFF
FFFFFDFEFFFAFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFF7F7F73535358E8E8EFDFDFD4C4C4CB5B5B5FFFFFF
FFFFFFF4F4F4FFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
F9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF9F9F9FFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF9F9F9FFFFFFFDFDFDFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFF9F9F9FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFEFEFE
FFFFFFFFFFFF4747471D1D1DA9A9A94F4F4F0B0B0B4A4A4A989898EDEDED
FCFCFCFFFFFFFFFFFFFDFDFDFFFFFFFCFCFCFDFDFDFFFFFFFFFFFFF6F6F6
FFFFFFFFFFFFFBFBFBFFFFFFFCFCFCFFFFFFFFFFFFFEFEFEFAFAFAFFFFFF
FDFDFDFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFF
F8F8F8B4B4B47575756E6E6EC2C2C2FDFDFD4A4A4AA7A7A7FEFEFEFEFEFE
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCD5D5D5070707000000
0101016D6D6DFFFFFFFEFEFE818181000000060606000000BFBFBFFFFFFF
F6F6F6C7C7C7777777777777BABABAFBFBFBFFFFFFFAFAFAFEFEFEFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFDFDFDFFFFFF
FFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFDFDFDFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFEFEFEFEFAFFFEFA
FFFDFFFFFDFFFFFFF64B4A43D0CFD533333BE6EAE9FCFFFDFEFEFFFDFDFF
FFFEFFFAFAF8FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFF8F8F8FFFFFFFAFAFA
FBFBFBFFFFFFFCFCFCFEFEFEA8A8A88D8D8DFFFFFF4646469F9F9FFFFFFF
FCFCFCFFFFFFFBFBFBE8E8E8737373FBFBFBC9C9C9181818B0B0B0FEFEFE
FCFCFCCDCDCD575757121212727272D6D6D6FFFFFFFBFBFBFEFEFEFFFFFF
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFDFDFDF7F7F7FFFFFFFFFFFFFFFFFF
C7C7C51F1F1DFDFDFBFFFFFBFEFEFAFDFDF9FEFFFDFFFFFFFFFDFFFAF8F9
8081795B5D5882818FE9E8F6FFFEFDFFFFF8FFFEFDFFFEFFFEFEFFFDFDFF
FEFEFCFFFFFAFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4F4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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFE7E7E71D1D1DBBBBBB
FCFCFCFCFCFCFDFDFDFFFFFFFDFDFDFAFAFAFBFBFBFFFFFFF9F9F9FDFDFD
FFFFFFFFFFFFFDFDFDFAFAFAFBFBFBFFFFFFF9F9F9FDFDFDFFFFFFFFFFFF
FDFDFDFAFAFAFBFBFBFFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFDFDFDFAFAFA
FBFBFBFFFFFFF9F9F9FDFDFDFFFFFFFFFFFFFDFDFDFAFAFAFBFBFBFFFFFF
F9F9F9FDFDFDFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF2F2F2FFFFFF
FFFFFFFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFE
FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF
6868680C0C0C3B3B3B808080D4D4D4FFFFFFF8F8F8FFFFFFFFFFFFFDFDFD
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCB1B1B1444444FFFFFFFFFFFFFFFFFFFFFFFF
F5F5F5FFFFFFFAFAFAFFFFFFFFFFFFFFFFFFE6E6E69898986C6C6C808080
DCDCDCEFEFEFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF7F7F7FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFF3A3A3A
0101010101010000000000000A0A0AFBFBFBFDFDFDFFFFFFFDFDFDFFFFFF
F3F3F3FEFEFEFBFBFBFEFEFEFFFFFFFCFCFCF8F8F8FFFFFFFFFFFFFCFCFC
FFFFFFFCFCFCFFFFFFFDFDFDFAFAFAFDFDFDF2F2F2A9A9A96D6D6D878787
D3D3D3FFFFFFFDFDFDF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFBFBFBFDFDFD
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFCFCFFFFFBFFFFFB
FFFEFFFCFAFBF9F8F357575300000503030B020607565A59BDBCC1FAF8FB
FFFDFDFFFEFBFFFDFCFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF9E9E9E929292
FFFFFFFFFFFFFDFDFDFAFAFAFFFFFFFEFEFEFDFDFDDBDBDB0C0C0C000000
0303030000000B0B0B080808EFEFEFFBFBFBFDFDFDA7A7A7CBCBCBFCFCFC
FEFEFEFFFFFFFDFDFDFDFDFDF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFCFCFC
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFFEFEFEFCFCFCFCFCFCFCFCFCFFFFFF6D6D6B767674
FFFFFBFBFBF7FFFFFAF8F9F35F6058C0C0B6E4DED00300004E546CBAC2D7
FEFFF4D8D4C47F737D0E0518ECF0FBF2FBFFFBFFFFFFFEFFFFFAFAFFFBF9
FCFFFFF9FFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC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FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFBFEFEFED2D5DA767779
26231A252219747472C4C5C9FDFDFFFFFDFFFFFDFCFEFEFAF9FFFDFBFFFF
FFFCFFFFFCFFFFFDFFFEFCFFFFFFFFFCFCFCFEFFFFFEFFFFFAFAF8FFFFFD
FFFEFDFDFBFAFCFAFBFFFEFFFFFFFFFDFEFEFBFFFFFCFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFF
F8F8F8FFFFFFFBFBFBC1C1C1373737FAFAFAFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFBFBFBBEBEBE7A7A7A686868BCBCBC
F8F8F8FDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD4D4D47E7E7E737373AEAEAE
F7F7F7FFFFFFF5F5F5FFFFFFFFFEFFFBF9FCFFFBFFFFFAFDFFFDFDF9F9F5
FEFFFAFDFFF9FFFFFDFFFFFFFCFDFFFCFDFFFEFFFFFEFEFCFFF9FCFFFCFF
FFFDFFFDFBFCFBFAFDFEFFFFFCFFFFFCFFFFFBFFFEFCFFFFFEFFFDFFFFFB
FFFEFDFFFEFDFFFEFFFFFEFFFFFEFFFFFEFFF9F9F7FFFFFDFFFEFFFBFBFF
FEFFFFFCFEFBFEFFF6FEFFF6FEFDFFD6D4DD0A0610010005040205000000
2527225C615B979996B1B1B1DADADA686868EDEDEDFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFE
BABABACACACAFFFFFFF9F9F9FFFFFFFFFFFF939393D1D1D1FFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF8F8F8FEFEFEFFFFFFFFFFFF
FAFAFAFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFDFDFDFDFDFDFFFFFF
FEFFFDFDFFFCFEFFFFFEFFFFFFFEFFFFFEFFECEBEE141414E2E0E1FFFEFD
FFFEFAFEFDF8FFFCF3FFFFF4FEFBF0605D54969590FDFDFD54525D9A98A1
FCFCFAFFFFFBFBFAFDFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFDFDFDF7FCFFFCFFFF
FFFDF3D3CFC37878742C2F341A19266A6873C7C5C4FCFDF7F1FBF6F6FEFC
FFFCFFFFFBFFFFFCFFFFFEFFFBF9FAFFFFFFF5F6F6FEFFFFFFFFFDFDFDFB
FEFCFBFFFEFDFFFDFFFFFEFFFCFCFCFBFCFCFBFFFFFBFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFDFDFD
FFFFFFF8F8F8FFFFFF686868828282FCFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFDFDFDFCFCFCFDFDFDFDFDFDFBFBFBFFFFFFC8C8C8
7B7B7B6C6C6CACACACEEEEEEFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFFFFFF
FAFAFAF4F4F4B7B7B7FCFCFCFCFCFCFEFEFEFFFFFFFFFFFFFEFEFEFBFBFB
FEFEFEFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFDEDEDE
8686866B6B6BA9A9A9EFEFEFFFFEFFFFFDFFFFFBFFFFFBFFFFFDFEFDFFFC
FEFFFAFEFFF8FEFEFAFBFBF9FEFFFFFEFFFFFBFCFEFFFFFFFFFCFFFFF9FC
FFFDFFFFFEFFFFFEFFFEFFFFFBFEFFF9FFFFFAFFFEFCFFFFFEFFFDFFFFFB
FFFFFBFFFEFDFFFEFFFFFEFFFEFEFFFFFEFFFFFEFBF6F5F1F5F8FDFBFFFF
F3F7F8FAFAF6FFFFF6FFFFF6FEFFFFF8F8FE75717D0B050F0E090D2E2C2B
333935EDF3EFF9FAFAC1C1C1777777FAFAFAFFFFFFF7F7F7FDFDFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF8F8F8FFFFFF
FCFCFCFEFEFEFFFFFFFFFFFFFEFEFE8A8A8ABEBEBEF7F7F7FEFEFEFFFFFF
FDFDFDFFFFFFF8F8F8FEFEFEFFFFFFB4B4B4F4F4F4FFFFFFFDFDFDFFFFFF
F7F7F7FDFDFDF7F7F7FFFFFFFFFFFFF6F6F6FFFFFFFCFCFCFFFFFFFFFFFF
FDFFFCF8FAF7FEFFFFFCFDFDFEFDFFF8F7FA8E8D90565558FFFDFEFDFBFA
FFFEFBFFFEFAFFFFF6FBF8EDFFFDF3FFFDF48684836F6E7116151849484B
FEFDFFFFFEFFFCFBFEFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFFFFAFFFFFBFFFF
FFFEF6FFFEF4FFFFFDFEFFFFD5D7E182828A3432311818145F6765C0C6C6
FFFDFFFFF8FBFFFCFFFFFDFEFFFEFFFFFFFFFEFFFFF9FAFAFEFFFFFBFBFB
FFFEFFFBF9FAF8F6F7FFFEFFFFFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFDFDFDFAFAFA1F1F1FD7D7D7FDFDFDFFFFFFFFFFFFFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFD4D4D48282826F6F6F9B9B9BF3F3F3FFFFFFFFFFFFF8F8F8
FFFFFF8080806A6A6AFFFFFFFFFFFFFFFFFFFCFCFCFAFAFAFFFFFFFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAF9F9F9
FFFFFFFFFFFFE1E1E18B8B8B6B6B6B9C9A9BF1EBEBFFFCFEFCFFFFFBFFFF
FBFDF8FEFFF8FEFFFAFEFFFAFCFCFAFFFEFFFDFDFFFEFEFFFBF9FAFFFEFD
FFFAFAFEFCFBFFFFFFFEFFFFFCFFFFFCFFFFFCFFFFF9FDFCFEFFFDFFFFFD
FFFEFDFFFEFDFFFFFFFFFEFFFEFFFFFFFEFFFFFBF8FFFBF9F8FFFFF4FFFF
F9FFFFFFFFFBFFFEF6FFFBF5FAFBFBFBFFFFF6F6FF1B17210C0107898383
8389850D1611757676A3A3A3FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFAFAFA686868C9C9C9FFFFFFFCFCFCFFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFBFBFBFFFFFF6666660F0F0F6F6F6FDCDCDCFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFDFDFDFBFBFBFFFFFFFBFBFB
FEFFFDFEFFFDFCFDFDFDFEFEFFFEFFF8F7FA0F0E11DAD9DCFFFEFFFFFEFD
FFFEFBF9F5F1FFFFF8FFFFF6F9F6EBFFFFF8FEFCFBFFFEFFEAE9EC070609
ECEBEEFAF9FCFFFEFFFEFDFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFAFFFFFFFBFFFFFBFFFF
FEF8F5FEF9F3FBFBF9FBFCFFFBFEFFFEFFFFF3F1F0E2E0DF8B8F902C2F33
171514666060BBB6B8FAF8F9FFFDFEFEFEFEF9FAFAFEFFFFF8F9F9FEFFFF
FFFDFEFFFEFFFFFEFFFDFBFCFBFBFBFEFFFFFEFFFFF9FDFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
F9F9F9FFFFFFCACACA2B2B2BFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFCFCFCFAFAFAFAFAFAFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFF2F2F2E3E3E38B8B8B6363638F8F8FE9E9E9
FFFFFF222222C7C7C7FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FCFCFCFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCF8F8F8FFFFFFFBFBFB
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFE8E6E5A3A29E6D6D6D8C939BDBE2EA
FCFEFBFFFFF8FBFFF7FBFEF5FFFBF7FFFDFFF8F8FFFCFEFFFCFFFFF9FBF6
FFFEFDFFFEFDFDFDFDFCFCFCFCFDFFFCFFFFFEFFFFFEFFFFFFFFFFFFFFFD
FFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFFFEFFFFFCF8FFFDFAF2FBFDF4FFFF
F9FFFFEEEEEC4B423D372E29171717D8DDE1FAFCFFA6A4AD0D04097E777A
FAFEFB525854131414959595F7F7F7FFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFAFAFA
FFFFFFFBFBFBEBEBEB595959EFEFEFFAFAFAFDFDFDFFFFFFFEFEFEFCFCFC
FFFFFFF8F8F8FBFBFBFFFFFFFEFEFEFFFFFFE3E3E37F7F7F0F0F0F414141
B7B7B7FBFBFBFFFFFFFFFFFFF7F7F7FFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FBFDFAFEFFFD454646E1E2E2FDFCFF959497565558FCFBFEFDFBFCFFFEFF
FFFDFDFFFEFBFFFEFAFFFFF8FFFFF6F7F6EFFBF9F8FFFEFFECEBEE222124
B7B6B9FFFEFFFDFCFFFDFCFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFCFEFDFFFCFFFFFEFFFF
FFFEFBFFFDFBFFFFFFFEFFFFFCFFFFF9FAFAFFFFFBFFFAFAFEFEFFFEFFFF
E3E3E18F8E8A403B3B121011555354B9B9B9FCFDFDFDFEFEFEFFFFFBFCFC
FEFCFDFEFCFDFFFEFFFFFEFFFFFFFFFEFFFFFDFEFEFBFFFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFF777777787878FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFDFDFD
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFDFDFDF9F9F9FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC5C5C5999999
505050181818D5D5D5FFFFFFFFFFFFFFFFFFFAFAFAFAFAFAFFFFFFFFFFFF
FBFBFBFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFB9E9E9E
4A4A4A1515154444448D8D8DF9F7F6FFFFFBF5F5F1FCFFFFEEF7FFA1A9B4
74737684837ECFD6CEFCFFF8FFFEF6FFF9F7FEFEFFF9FFFFF2FAFAFBFFFB
F9F9F5FBFAF6FDFDFBFFFFFDFFFFFFFBFCFCFDFCFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFEFDFFFBF5FFFCF7F5FDFFF5FFFF
F8FFFFFEFFFDFFF9F49C938EF1ECEEE8E7EDFCFFFFF6F9FF0000024B4B4B
5F5F5FE4E5E5D6D6D62E2E2E636363F8F8F8FFFFFFF6F6F6FFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFDBDBDB636363FFFFFFF9F9F9FFFFFFFFFFFFFAFAFAFFFFFFFDFDFD
F8F8F8FFFFFFF7F7F7FFFFFFFFFFFFF7F7F7FFFFFFF7F7F7FFFFFFABABAB
3131311B1B1B808080F1F1F1FFFFFFFBFBFBFFFFFFF9F9F9FFFFFFFCFCFC
FEFFFDFEFFFD40423FBEBFBFF3F2F51C1B1EC7C6C9FFFEFFFFFEFFFFFEFF
FEFCFDFFFEFDFEFAF7FEFAF6FFFEFAFFFFFAFFFEFDF9F9F9E3E3E3A6A6A6
B2B2B2FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFF9FCFFFBFCFF
FFFBFDFFFDFDFFFEFFFEFFFFFBFFFDFCFFFBF9F5F2FFFDFFFFFDFFFFFEFF
F5F7F2FFFFFAFAF8F7EAE5E79C9A9B3737370F10105A5B5BAAABABF7F8F8
FFFFFFFFFEFFFDFBFCFBF9FAFCFCFCFDFEFEFEFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFF222222CFCFCFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFCFCFCFFFFFFFFFFFFFFFFFFFDFDFDF9F9F9FAFAFAFEFEFE
FFFFFFFFFFFFFEFEFEFCFCFCFEFEFEFFFFFFF9F9F9FCFCFC111111EAEAEA
7777776E6E6EAFAFAF6565657A7A7AC8C8C8FFFFFFFFFFFFFFFFFFFBFBFB
FAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFAFAFA040404030303
000000010101000000121210353332F8F8F4FEFFFAF9FFFFEFF8FFF8FFFF
FDFBFEFFFEFDB2B8B473756F7E7468CFC4BEFFFDFFF9FFFFF6FFFFF9FFFD
FEFFFDFFFFFBFFFFFDFFFFFDFFFFFFFFFFFFFFFDFFFDFCFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFBFFFAF2FFFDF6FBFFFFF7FFFF
F3FEFFFAFFFCFEF9F3F9F0EB7C7376FFF9FFFCFFFFF8FCFF595F5F0D1110
F0EEEFFFFEFFFFFEFFF3F3F3595959303030CACACAFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFFFFFF
ABABAB828282FFFFFFFCFCFCFFFFFFF9F9F9FBFBFBFCFCFCFFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFCFCFC
FFFFFFD3D3D36767670C0C0C5E5E5EC7C7C7FFFFFFFFFFFFFBFBFBFFFFFF
F9FBF8FEFFFD626461939592AAAAAA454447FDFCFFFFFEFFFFFDFFFFFEFF
FFFEFFFDFBFCFFFBFBFFFEFBFFFCF9F9F8F4FFFFFDFFFFFFF9F9F9FDFDFD
FFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFEFFFCFFFFFEFFFF
FFFDFFFFFDFFFEFCFFFBFCFCF9FFF9FCFFFAFFFEFBFDF6F9FFFBFFFEFBFF
FCFFFDFBFFF9FFFEFDFFFBFBFFFEFFFAFAFAE7E8E8979B9A4243450C0D0F
525154A5A4A7F3F1F2FFFEFFFDFDFDFDFEFEFEFFFDF8FCF9FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
F7F7F7D6D6D6242424FDFDFDFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF3C3C3CC2C2C2
1C1C1CD7D7D7FDFDFDFFFFFFF4F4F4BABABA7070706E6E6EBCBCBCFDFDFD
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD606060050505000000
03030300000001010101000004000024231FFCFFFBF9FFFFF7FFFFF9FFFF
FFFCFFFBF6F8F8FBFFFFFFFBFFFCEFCDBCB07775786B727ABBC4C7F5FDFF
F1F5F4FDFDFBFFFFFDFDFDFBFBF9FAFFFEFFFFFDFFFFFEFFFFFDFFFFFEFF
FFFEFFFEFFFFFEFFFFFEFFFDFEFFFDFFFFFAFFFCF2FFFDF4EDEEF0EFF8FB
F6FFFFF9FFFFFFFEFAFFFBF9F6E9EE726A73F7FAFFB7C0C5707A79F9FFFD
FFFDFFFDF6FBF9F7F8FCFCFCFFFFFF8080800B0B0BFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF6F6F6909090
AAAAAAFFFFFFFEFEFEFAFAFAFFFFFFFFFFFFF7F7F7BDBDBDDCDCDCF7F7F7
FCFCFCFFFFFFFBFBFBFFFFFFF5F5F5FFFFFFFCFCFCFDFDFDF6F6F6FFFFFF
FDFDFDFCFCFCF9F9F9F1F1F18E8E8E202020333333959595F6F6F6FFFFFF
FEFFFDFEFFFD7A7C797A7C79292929BEBEBEFBFAFDFDFCFFFEFDFFFDFCFF
FEFCFFFFFEFFFFFDFEFEFCFBF7F5F4FFFEFDFBFBFBFFFFFFFFFFFFFDFDFD
F5F5F5FCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFCFDFFFEFFFF
FFFDFFFFFCFFFFFEFFFEFFFFFBFFFAFAFFF8FFFDFAFFFCFDFFF7FFFFFCFF
FBFFFFF9FFFDFBF9F8FFFDFDFFFEFFFFFFFFFDFEFEFBFFFEFEFFFFEBECEE
9D9C9F48474A141213464445AAAAAAEEEEEEFEFFFDFCFEFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFF8282826D6D6DFFFFFFFFFFFFFAFAFAFDFDFDFFFFFFFEFEFEFFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFCFCFC
FEFEFEFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFBFBFB5454547E7E7E
323232FEFEFEFFFFFFFDFDFDFFFFFFFDFDFDFEFEFEFAFAFAC4C4C4707070
6D6D6DB4B4B4FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCBCBCB040404060606000000
000000000000020202030102070101120E0BB8BDB7F6FEFCF8FFFFFAFFFF
F9F3FAFFFCFFFEFEFFF8F6F9FFF5E7BBA99A76757191969AB7BEC4787F85
767C7CB4B8B7F1F2F2FFFFFFFFFDFFFFFCFEFFFCFFFEF9FDFFFDFFFFFEFF
FEFFFFFEFFFFFEFFFFFEFFFDFEFFFBFFFFF8FFF9EE8D8077030706566065
7B8688F2F8F8FDF7F4EBDFDEFFF8FD30283180848BA3ACAFF4FEFDFBFFFF
FFFCFFFFFCFFFFFEFFFEFEFEE2E2E22727275B5B5BFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE696969CACACA
FEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFFD2D2D21B1B1BABABAB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFDFDFDB9B9B95050500E0E0E727272
DADCD9FBFDFA9C9E9B3F413E383838FAFAFAFFFEFFFFFEFFFFFEFFFFFEFF
FAF8FBFFFEFFFDFBFCFFFEFFFFFEFFFCFAFBFEFEFEFDFDFDFFFFFFFDFDFD
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFDFFFFFDFFFFFEFFFEFFFDFBFFFBFBFFFAFFFEFBFFFBFDFFF9FEFFFCFF
F8FFFFF7FFFF8E8E8E040000333132AEAEAEFEFFFFFAFEFDFCFFFFFEFFFF
FFFEFFFFFEFFEEECEDA9A7A8434343111111484A479EA09DEDEDEDFFFFFF
FEFEFEFEFEFEFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFF6F6F6
FFFFFF3B3B3BBCBCBCFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF747474383838
8C8C8CFFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFBFBFBFFFFFF
FDFDFDC8C8C87D7D7D666666ABABABFAFAFAFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFEFEFEFFFFFF
FDFDFDFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFA1A1A10F0F0F000000010101
0303030000000606060200010400000D0707999B98FBFFFDFCFFFDF7F8F8
FFFDFFFFF9FFFBF8FFFFFBFF917D701100009A978E676B6C080812D2D4E0
F6FAFFD9DEE18488896A6A6AB0ABADF5EFEFFEF7FAFFFDFFFCF9FFFFFEFF
FEFFFFF4F8F9FEFFFFFEFFFDFDFDF9FFFEF6FFF2E7190B00D1D9D7F2FFFF
C2CFD3CCCFD3FFF7F7A29293160D12222126C4CBCFF8FFFFE6EAEB030303
D4D1D7FFFEFFFDFCFFE5E5E51919198F8F8FFFFFFFFDFDFDFFFFFFFCFCFC
FDFDFDFFFFFFFDFDFDFBFBFBFFFFFFFFFFFFE5E5E55C5C5CEEEEEEF9F9F9
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFD4D4D4111111
B2B2B2FFFFFFFEFEFEFEFEFEFDFDFDFFFFFFFDFDFDFEFEFEFFFFFFF7F7F7
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFDBDBDB787878
15171445474482828011110FD5D5D5FAFAFAFFFEFFFDFCFFFFFEFFFFFEFF
FDFCFFFFFEFFFEFDFFFFFEFFFCFBFEFFFEFFFFFFFFFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFF
FFFEFFFFFDFFFFFEFFFEFFFDF8FFFCF8FFF8FFFBF8FFFBFAFFF6F7FFFBFD
F7FFFFEEFDFFFCFCFCABA5A5E2DDDFEAEAEAF9FAFAFCFFFFFCFFFFF7FBFC
FBFCFEFFFEFFFEFCFFFEFCFDFFFFFFF2F2F0A4A6A3525451101010454545
9C9C9CEAEAEAFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FFFFFFFFFFFF
E6E6E60C0C0CFCFCFCFCFCFCFCFCFCFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFCFCFC909090040404
7B7B7BE1E1E1FFFFFFFAFAFAFBFBFBFFFFFFFEFEFEF9F9F9FDFDFDFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFD2D2D28686866262629F9F9FF4F4F4F3F3F3
FFFFFFFAFAFAFFFFFFFCFCFCFCFCFCFFFFFFFBFBFBFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFFFFFF8686860E0E0E050505000000
0000000404040000000100000903030A0404828282FEFFFBFCFCF2FFFFF8
F8F5FBECE8F6FFFBFFFFF7FFC3AFA2E7D6C2F9F9EDFCFFFD96909A44404E
F9FFFFF8FFFFFAFFFFFEFFFFE5E0E2938D8D7B75759D989AF2F0F3F5F6FA
FCFFFFFCFFFFFEFFFFFEFFFDFFFFFBFFFBF3FCE6D92C1B11D7DFDDF1FFFF
F7FFFFFEFEFFFFF4F7F7E7E85D565BE2E5E9F8FFFFF6FEFFA5A4A7010000
DEDDE0FDFCFFDEDDE01414149C9C9CFDFDFDFDFDFDFAFAFAFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBCFCFCF6F6F6FFDFDFDF8F8F8FEFEFE
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFFFFFFF5F5F5FFFFFFD2D2D2
0F0F0FBBBBBBFEFEFEFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFF5F5F5FFFFFF
FFFFFFFBFBFBFFFFFFFBFBFBFFFFFFFFFFFFF8F8F8FBFBFBFFFFFFFDFDFD
F5F7F4A4A6A330302E11110F818181EAEAEAFFFEFFFFFEFFFDFCFFFFFEFF
FFFEFFFCFBFEFEFDFFFFFEFFFFFEFFFBFAFDFDFDFDFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFF
FFFEFFFFFEFFFFFEFFFEFFFFF9FFFFFBFFFFFFFEFBFFFBF6FFF5EFFFFBFA
F1FEFFF2FFFFFAFBFDFFFBF9948F8FD7D7D7FEFFFFFCFFFFF5F8FCFCFFFF
FEFFFFFFFEFFFFFEFFFEFCFDFCFCFCFDFDFBFEFFFDFEFFFDF6F6F6A9A9A9
5858580E0E0E353535999999E6E6E6F8F8F8FDFDFDFFFFFFFFFFFFFDFDFD
8C8C8C686868FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFCFCFCFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFB868686060606
6464641717172C2C2C7F7F7FCFCFCFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFF
F1F1F1FFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFDFDFDE0E0E09595956C6C6C
8B8B8BEFEFEFFFFFFFFBFBFBFEFEFEFCFCFCFFFFFFFFFFFFFCFCFCF8F8F8
FCFCFCFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFBEBEBE111111000000040404
060606000000040404020001040000140F11BAB8B9FFFFFAFFFBEC989186
00000400000D0E0518D5C7D2FFFAF1AB9E8D00030000010020141D070008
E4EAF6F5FFFFF8FFFFF7FAFFFFFEFFFFFDFDFFFDFDEAE5E59A989B757678
929599DCE2E2FAFEFFF9FBF8FFFFFBFFFEF6FFFAED605247969A9BF3FFFF
F1F9FFEBEBF3D9CED26D6163FDF8FAFEFFFFF9FFFFF3F9F93939390A0809
CBCACDD2D1D41B1A1D9E9E9EFFFFFFFFFFFFFDFDFDFFFFFFF5F5F5FFFFFF
FEFEFEF7F7F7FFFFFFFBFBFBA3A3A3929292FFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFFFFFF
CACACA090909B6B6B6FFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFFFFFFFFFFFF
FBFBFBFFFFFFFEFEFEFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFEFEFEFFFFFF
FDFDFDFFFFFFF9F9F9000000616161131313555555C6C6C6FFFFFFF4F4F4
FFFEFFFFFEFFFEFDFFF6F5F8FFFEFFFFFEFFFDFDFDFEFEFEFFFFFFFFFFFF
FDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFD
FFFFFFFFFFFFFFFEFDFEFFFFF9FFFFFBFFFFFFFEFBFFF4ECFFF4E8FFF9F2
F1FEFFEBFEFFFEFFFFFFFDFBFDF8F86E6E6CF6F7F9FBFFFFFCFFFFFCFFFF
FBFCFFFCFDFFFFFEFFFFFEFFFFFFFFFFFFFDFDFDF9FBFDF8FCFCFCFFFFFF
FEFEFEFDFDFDBABABA5555551212123E3E3E929292E6E6E6F6F6F6FFFFFF
3E3E3EAAAAAAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF404040181818
FDFDFDFFFFFFC9C9C97070702525251D1D1D6D6D6DB5B5B5FFFFFFFDFDFD
FFFFFFFDFDFDF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFBFBFBFDFDFD
EFEFEF9090905B5B5B8C8C8CDCDCDCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFFFFFFFFFFFF0B0B0B030303000000
0101010000000000000505050503041B191AFCFAFBFCF7F1FFF5E4190F01
9A9FA3F0F6FF877F8A1A0B10F4E5DE0E0500A8AEAAF8FCFB7F6F700E0004
C3CAD8F1FFFFF7FFFFFBFFFFFFFEFFFCF7F7FFFDFBFFFEFBFDFBFCFEFFFF
EBEEF2A6ABAE6D71728D8F8CD7D7D3FEF7EFFFFCEDECDED3030205D6DDE5
D7DBE60A0A12888184FFF9FAFFFDFFF8F7FAFAFEFFD8DCDD080A070B0B0B
A4A3A6121114A4A3A6FFFFFFFAFAFAFFFFFFFAFAFAF9F9F9FFFFFFFCFCFC
FFFFFFFFFFFFF4F4F4828282BEBEBEF9F9F9FAFAFAFDFDFDFFFFFFFFFFFF
FEFEFEFDFDFDFEFEFEFFFFFFFFFFFFFDFDFDFBFBFBFFFFFFFFFFFFFBFBFB
FFFFFFC6C6C6212121BBBBBBF9F9F9FDFDFDFFFFFFFFFFFFF9F9F9FFFFFF
FDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFBF7F7F7
FFFFFFFFFFFFFFFFFF212121DFDFDFE9E9E99292922626262D2D2DA3A3A3
FAFAFAFDFCFFFFFEFFFFFEFFFEFDFFFBFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFD
FEFFFBFFFFFBFFFFFBFFFFFFF7FFFFF9FFFFFFFCFAFFFBEFFFF4E1301F15
323F50DDF1FFFEFEFFE2DCDAFFFDFD7A7A78B1B2B4FCFFFFFBFFFFF4F7FB
FAFBFFFEFFFFFFFEFFFCFAFBFEFCFDFFFFFDFFFFFBFDFDF9FFFFFFF8F8F8
FFFFFFFAFAFAFEFEFEFFFFFFFAFAFAB9B9B96363631111113737377E7E7E
111111FFFFFFF9F9F9FFFFFFFCFCFCFBFBFBFAFAFAFAFAFAFEFEFEFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEEEEE151515050505
FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFD2D2D28383833D3D3D020202595959
AFAFAFEFEFEFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFEFA8A8A86161617A7A7AD2D2D2FBFBFBFDFDFD
FFFFFFFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFAFAFAE1E1E1010101040404
0000000606060A0A0A000000020305F6F6F6FFFEFFFFFDF6EED9C6130500
E7F1F8F4FFFFFFFCFC978984CBC2BD0C0C0CECF6FFF3F8FCFFF8F233211D
939AAAF0FFFFEEFBFFF9FFFFFCFBFEFFFEFBFFFCF9FFFEFAFFFFFDFBFCFC
FAFEFFFBFFFFFCFFFFF2F3F3BAB8B77E7971897D6DDFD2C7E3DCE164626F
3F3E4C4A4C56FFFEFFFFFDFCFFFEFFFFFEFFFDFCFF4A4B4B000100000100
121114A09EA1F5F4F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF2F2F26A6A6ACBCBCBFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFEFEFE
FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFEFEFEFEFEFEFDFDFDFCFCFCFDFDFD
FFFFFFFAFAFABDBDBD101010C9C9C9FFFFFFFDFDFDFFFFFFFBFBFBFEFEFE
FFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFF3A3A3AB7B7B7FFFFFFFEFFFDF9FBF8BBBDBA454744
10120F6D6E6ED7D8D8FEFFFFFDFEFEFCFDFDFFFFFFFFFFFDFBFBF9FFFFFD
FFFFFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFB
FEFFFAFFFFFAFFFFFAFFFFFFF8FFFFF7FDFFFFFBF9FFF6E7FFF9DF685648
6D7C91CFE4FFF8FAFFC9C3C12E292911110FECEDEFF8FCFDF8FDFFFBFFFF
FEFFFFFEFFFFFFFEFFFFFEFFFFFDFEF8F6F5FAFAF6FFFFFBF9F9F9FFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFFFFFFFBFBFBC0C0C03F3F3F
0000002929298A8A8ADDDDDDFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9F4F4F4F111111
E8E8E8FFFFFFFFFFFFF6F6F6FFFFFFF8F8F8FFFFFFFFFFFFE7E7E7999999
4646460A0A0A4646468C8C8CEAEAEAFFFFFFFAFAFAFFFFFFFCFCFCFFFFFF
FBFBFBFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFF7F7F7B4B4B46E6E6E757575
BCBCBCFFFFFFFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFFE0E0E0474747
0101010A0A0A030303393A3AEAEEEFF6FAF9FFFEFDFFF7EFFFF4E1241405
A9BAC1F0FFFFFFFFF3FFFDEDF7F3F0161A25B8C4D8FBFEFFFFFAECA99588
4D5665EDFFFFEEFDFFF8FFFFFFFEFFFFFEFBFDF7F4FFFFF8FEFEFAFCFFFF
FBFFFFF7FCFFF9FDFEFBFCFCFAF8F7FEF9F1FCF3E2574D41766D723E3746
D8D5E48B8B95D3D2D5FFFFFFFBFBFBFDFDFDCCCCCC020200040400070705
0000020A090C000000000000000000FFFFFFFCFCFCFFFFFFF7F7F7FFFFFF
E6E6E65E5E5EEEEEEEFFFFFFFDFDFDFFFFFF5D5D5DF5F5F5FEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F3F3F3FFFFFFFFFFFFC0C0C00F0F0FC3C3C3FDFDFDB1B1B17A7A7AFEFEFE
FFFFFFFEFEFEFFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFF1F1F1FFFFFF7F7F7FADADADFBFBFBFEFFFDFEFFFDFBFDFAFEFFFD
DEE0DD7A7C79191A1A454646B3B4B4FDFEFEF7F7F5FFFFFDFAFAF8FFFFFD
FFFFFDFBFBF9FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFDFFFFFBFFFFFB
FEFFF8FFFFF8FFFFF8FFFEFFF8FFFFF9FEFFFFFDFBFFF8E9FFFADAB7A694
56647EE4FAFFFCFEFFFFFBF9FCF7F7FBFBF9FCFDFFFCFFFFFBFFFFF3F8FB
FDFEFFFDFEFFFCFBFEFCFCFCFFFEFFFFFEFDFFFFFBFDFDF9FFFFFFFFFFFF
FFFFFFF8F8F8FFFFFFFCFCFCFFFFFFFFFFFFFCFCFCFFFFFFFBFBFB474747
AEAEAEBFBFBF6D6D6D1111112F2F2F787878CFCFCFFEFEFEFFFFFFFBFBFB
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4E4E4E9E9E9E373737
CBCBCBFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFFFFFFFF
FEFEFEF9F9F9ABABAB6262621111113030308B8B8BD0D0D0FDFDFDFEFEFE
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFF6F6F6FEFEFEFFFFFFF9F9F9
C0C0C06D6D6D656565BDBDBDFFFFFFFBFBFBFCFCFCFFFFFFFEFEFEF9F9F9
FFFFFFD8D8D8FFFFFFFCFDFDF9FFFFFBFFFFFFFFFBFFFBF3FFF8E679695A
3F565CEAFFFFFFFFE7CEC7AB7F80805C64774E5E7FF5FAFFFFF8E2B49E87
0A1322E1F8FFF1FFFFF2FBFFF7F8FCFFFEFBFFFEF8FFFFF8FDFDF9FAFEFB
FBFFFFFBFFFFFCFFFFFEFFFFFFFEFDFFFDF8FFFDEFA4978C363135F2EFFE
CFCADC605C6AFEF8FFFEFEFEFBFFFFF9FFFF212222030100060000040000
030404080E0E171818757575A3A3A3FBFBFBFFFFFFFFFFFFFFFFFFC5C5C5
767676FDFDFDFBFBFB9A9A9A242424E7E7E71F1F1FDDDDDDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFF5F5F5BBBBBB161616D5D5D5BDBDBD3E3E3EFFFFFF
F4F4F4FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFFFFFF
FEFDFFFFFEFFFFFFFFFCFCFCFCFCFCFEFEFEFEFFFDF8FAF7FEFFFDFEFFFD
F8FAF7FEFFFDF7F9F69EA09D3739361B1D1ADEDEDCFFFFFDFDFDFBFDFDFB
FFFFFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFDFFFFFDFFFFFB
FEFFFAFFFFF8FFFFFAFFFFFFF7FDFFFBFEFFFFFEFBFFFDEDFFF6DCECDECF
061123EAF9FFFCFFFFFEF9F9FFFEFDFFFFFFFEFFFFFAFEFFFCFFFFFCFFFF
FEFFFFFDFEFFFEFDFFFFFFFFFFFEFFFCFAF9FCFCFAFFFFFDFFFFFFFAFAFA
FFFFFDFFFFFDFCFCFCFFFEFFFCFBFEFFFEFFFFFFFDFEFEFCF4F4F20E0E0E
F5F4F7FFFEFFFCFCFCFFFFFFC4C4C4737373232323252525797979D6D6D6
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE9E9E9121212F3F3F3AAAAAA
D4D4D4FFFFFFF9F9F9FFFFFFFEFEFEFFFFFFFCFCFCFFFFFFFBFBFBFCFCFC
FFFFFFFCFCFCFEFDFFFFFEFFF8F8F8C1C1C16B6B692020202524276D6C6F
C0C0C0F5F5F3FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFDFFFCFCFCFFFFFF
FCFCFCFFFFFFFFFFFFC2C2C2787878676767B1B1B1F3F3F3FFFFFFFDFDFD
FBFBFBFFFFFFFFFFFFFDFEFEFBFFFFF7FDFBFFFEFDFFFBF5FFF9EBE7DAD1
00050B617979D2D4BC49442C565757D6DEF000011C707384CFBCA92B1A06
000510DAECFFF4FFFFF6FCFFFEFFFFFFFFFBFFFEFAFEFDF8FFFFFBFAFCF9
FBFFFFFBFFFFFAFEFFFCFDFDFFFEFFFFF9F6D1C7BD70675E4B494CD3D3DD
2C2836ECE5F2FFFCFFFDFDFDFBFFFF69716F0608050402010900000D0503
4A4B4BC9CFCDFCFFFFF8FAF7FFFFFFFFFFFFFCFAFBFEFCFDA6A4A5969696
FFFFFFF7F8F8FEFFFDFEFFFD8E8E8E242424424041B8B6B7FFFFFFFEFEFE
FDFDFDFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFEFEFE
FFFFFFFEFEFEFFFFFFFFFFFFFBFBFBACACAC171717BABABA1A1A1AFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFFFFFFFDFDFDFFFFFF
FFFEFFFBFAFDFFFFFFFDFDFDFFFFFFFFFFFFFAFCF9FDFFFCFDFFFCFBFDFA
FEFFFDFBFDFAFEFFFDFEFFFDFBFDFACFD1CECACAC8FDFDFBFFFFFDFCFCFA
FFFFFDFDFDFBFFFFFDFEFEFCFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFDFFFFFDFFFFFDFFFFFFFDFEFFFCFDFFFFFFFBFFFEF6FFF8EDFFFEF6
1E2125CCD0D7FDFEFFFDFDFDFFFFFFFEFFFFFDFDFDFCFDFDFEFFFFFEFFFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFDFCFFFFFFFF
FFFFFBFDFDF9FCFBFEFFFEFFF9F8FEFFFEFFFFFFFBFFFFFAA0A19B4E4E4C
FDFEFFFEFFFFFEFFFFFFFFFDFFFFFDFFFEFDFDFBFCCDCBCC737275232225
1F202278797BD0D1D3F7F8FAFFFFFFFEFEFEFFFDFCFFFDFCFFFEFDFEFCFB
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFEFEFEFFFFFFFFFFFFFBFBFB
FFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFDFDFD9494945A5A5AFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFFFBFBFFFEFEFFF7F5F6FFFEFDFCFEF9FEFFFDCFCED3818085
30322F151712595957B3B1B0F6F4F5FFFEFFFFFEFFFAF9FEFFFEFFFFFFFF
FEFEFEFBFBFBFEFEFEFFFFFFFFFFFFFFFFFF4848488080806565656B6B6B
EFEFEFFFFFFFFAFAFAFFFFFFFEFFFFFBFCFCFEFEFEFFFEFBFBF3EEFFFEFB
DDE2E5505858030400302F28D2D2D2FCFFFFDBDFE85D5D630800008F8A84
7D8084CAD1D9FBFFFFFEFFFFFFFEFFFDFDFBFFFEFDFEFEFCFDFDFBFFFFFF
FDFEFEFEFFFFFCFDFDFFFFFFFFFFFFB8B6B58C8885FFFCF9ECECEC000004
B2B1B6FFFDFFFBF9FCFFFFFFCBCCCC090A0A0000000707074F4A4ADDDBDA
FEFEFEFCFFFFFBFFFBFCFFFBFFFFFDFFFEFFFFFCFF7A7378BBB6B8FFFEFF
FEFFFFFBFFFFFBFFFAF6FDF5FDFEFE7A797C1B16188B8688FFFEFDFDFBFA
FFFEFFFFFEFFFFFFFFFDFDFDFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFF7F6F9FFFEFFF9F9F9FFFFFFA4A4A4111111090909FAFAFA
FFFFFFFEFEFEFEFEFEFFFFFFFBFBFBFFFFFFFFFFFFF9F9F9FFFFFFFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFCFCF8FFFFFBFFFFFBFBFAF6
83827D8B8B87FFFFFDFEFFFFFEFFFFFCFDFDFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFF9F9F9
FFFFFAFFFFFAFBFAFDF5F4FA787681D8D7DCFCFCF8FFFFF6595A54A1A19F
FBFBFFFEFEFFF8F9F9FFFFFBFDFBFAFFFEFDFFFEFFF9F7F8FFFEFFFFFEFF
C5C6C8797A7C1D1E20262729707070CDCDCDFAF8F7FFFEFDFFFEFBFFFEFD
FFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFEFEFE
FAFAFAFFFFFFFFFFFFF8F8F8FFFFFFFFFFFF393939B2B2B2FFFFFFFFFFFF
FDFDFDFDFDFDFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFCFFFFFAFAFFFFFCFFFFFCFAFFFFF8F5FAF3FEFFFFFEFEFF
FEFFFFE0E1E193958F48474208020050494C949399F0F0F6FBFAFDFDFDFD
FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9272727D6D6D67D7D7D626262
929292636363909090E3E3E3FAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFBFBFB
FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFF5F5F5
FFFFFFFFFFFFFDFDFDFCFCFCCDCDCD909090FEFEFEFFFFFFF7F7F7DFDFDF
F6F6F6FBFBFBFFFFFFE4E4E4030303000000131313BBBBBBFFFFFFFFFFFF
FFFFFFF8FAF7FCFFFBFCFFFBFBFBF9F5F3F4625D5FE3DEE0FFFEFFFCFBFE
FEFFFFFCFFFFFAFFF9FCFFF8FEFFFDFAFAFA3B3638201B1DF7F5F6FFFDFC
FFFEFFFFFEFFFAFAFAFEFEFEFFFFFFFAFAFAFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFAF9FCFFFFFFF9F9F9FFFFFF7B7B7B000000BEBEBE
FFFFFFFFFFFFFFFFFFF8F8F8FFFFFFF7F7F7FFFFFFFFFFFFF2F2F2FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFAFAF8FDFDF9FFFFFBFCFBF7FFFFFB
DBDAD623231FF8F8F6FEFFFFFEFFFFFAFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FCFDF7FFFFFBFFFEFFFFFEFF3C3A45151419FFFFFBEDEEE411120CEBEBE9
FCFBFFF7F6FCFFFFFFFDFDFBFFFEFDFFFAFAFDFBFCFFFDFEFFFEFFFFFEFF
FEFFFFFEFFFFFEFFFFCFD0D27D7E7E2526261F1F1D6B6B69BFBDBCFEFCFB
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFF7F7F7FAFAFAFFFFFFFDFDFDFCFCFC
FFFFFFFFFFFFFDFDFDFEFEFEFFFFFFDBDBDB131313FDFDFDFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFBFFFFF7F7FDFFFBFFFFFBFDFBFBEEFCFFF4F9FDFEF5F7FF
7C7A8D494855F3F9EDFDFFEFFAF1EAAA9FA15F5F67070B143E3F43898989
DDDDDDF9F9F9FFFFFFFFFFFFF7F7F7FFFFFF434343B7B7B7252525C2C2C2
FFFFFFFFFFFFDFDFDFA1A1A16A6A6A808080D5D5D5FFFFFFF9F9F9FFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FBFBFBFFFFFFFAFAFAFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFF8F8F8FFFFFF
FEFEFEFFFFFFFFFFFFE3E3E36E6E6EFFFFFFFDFDFDFFFFFFFFFFFFFFFFFF
E1E1E1FFFFFFF8F8F80E0E0E0505055A5A5AF3F3F3FFFFFFF8F8F8FAFAFA
FFFFFFFDFDFDFBF9F8FFFDFCDEDEDC626461EDEFECFBFFFEF4F5F7FEFFFF
FFFEFFFBF9FAFFFFFAFCFBF4FFFFFBDCDCDA0E0F0F202121444444FBF9FA
FFFDFEFFFEFFFFFFFFFFFFFFF6F6F6FFFFFFF9F9F9FFFFFFFAFAFAFFFFFF
FEFEFEF8F8F8FFFFFFFFFFFFFFFFFFFFFFFF979797151515232323171717
E4E4E4FFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF8F8F6FFFFFBFFFFFBFCFBF7FFFFFB
CCCBC7080804E5E5E5FBFCFCFEFFFFFBFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFAFFFFFBFAF9FCFFFEFF97959E0403089E9E9AADAEA6393A34FFFFFD
FFFEFFB7B6BCD3D3D3FFFFFDFAF5F5FFFDFDFFFEFFFFFEFFF4F3F6FFFEFF
FEFFFFFBFCFEFBFCFEFEFFFFFEFFFFFCFDFDD8D8D8888886323230141412
6C6C6CBBBBBBFCFCFCFFFFFFF9F9F9FFFFFFFFFFFFFCFCFCFFFFFFFFFFFF
FAFAFAFEFEFEE8E8E86A6A6AFFFFFF858585616161FFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFCFEFFFEFFFFFCFFFFFDFDFDFFF2FEFFF6FCFFFFF8F7FF
F2EDFF656370F9FFFAFBFFF4FFFCF9FFFBFFF8F8FEF5F8FFB4B5B7676767
1919192A2A2A737373C8C8C8FFFFFFF9F9F9616161818181242424FFFFFF
FAFAFAFFFFFFFBFBFBFCFCFCFFFFFFE2E2E2ABABAB696969808080D7D7D7
FAFAFAFFFFFFFFFFFFFBFBFBFEFEFEFFFFFFFBFBFBFFFFFFFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
FFFFFFFAFAFAFEFEFEAEAEAEC8C8C8FDFDFDFFFFFFFFFFFFDDDDDD131313
0F0F0F1919191616160303039B9B9BFCFCFCFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFB9B7B87F7F7DFDFFFAF8FCF9FCFFFDFEFFFFFEFDFF
FDFAFFFFFEFFFEFDF8FDFCF5BDBCB520201C7374743B3C3E585858504E4F
FBF9FAFFFEFFFDFDFDFFFFFFFFFFFFF9F9F9FFFFFFFEFEFEFFFFFFF8F8F8
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFC7A7A7A262626DDDDDD5A5A5A5C5C5C
232323E5E5E5FEFEFEFEFEFEFAFAFAFFFFFFFBFBFBFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFCFFFFFDFEFEFCFDFDFBFFFFFBFFFEFA
CAC9C5979793E5E5E5FBFCFCFEFFFFFBFCFCFFFFFFFFFFFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFF8F8F6
FEFEFAFBFBF7FFFEFFFFFEFFC0BEC700000404040063645C90918B9F9F9D
18171C000004F0EFF2FFFFFFFFFDFDFEF9F9FFFDFCFFFEFDFFFFFFF9F9F9
FEFFFFFEFFFFFEFFFFF8F9FBF6F7F9FEFFFFFEFFFFFEFFFFFAFBFBE0E0E0
8282823737371818185E5E5EC1C1C1F3F3F3FCFCFCFCFCFCF9F9F9FCFCFC
FFFFFFF9F9F9FAFAFA050505FBFBFB323232CACACAFAFAFAFFFFFFFBFBFB
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFFFFFDFDFFF9F9FAFAF8FCFFFDF8F9F9FCFDFFFEFEFFFFFCFF
FFF4FA665F62D6E2E0F1FFFFFEFEFFFFFCFFFFFEFFFEFEFCFEFEFEFEFEFE
FFFFFFD0D0D07676762323231A1A1A6666666868682F2F2F7D7D7DFFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFF9F9F9F1F1F1ADADAD
6B6B6B6F6F6FC5C5C5FFFFFFFEFEFEFEFEFEFFFFFFFFFFFFF9F9F9FFFFFF
FEFEFEFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FFFFFFFDFDFDFEFEFECDCDCDA8A8A8FFFFFFFCFCFCFAFAFA4C4C4C070707
000000000000000000A3A3A3FCFCFCFFFFFFFFFFFFFFFFFFFCFCFCFAFAFA
F9F9F9FFFEFF8B8C909F9EA3F7F7F5FFFFFAFFFFFBFAF8F7FFFDFFFEFBFF
FFFEFFFEFFFFF8FAF4ACAFA417180EAFB0A8EAE8E9110E14F8F7FA3D3D3D
656565FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFBFBFBFFFFFFFDFDFDFFFFFF
FFFFFFFBFBFBFCFCFCF6F6F6575757363636ECECECFFFFFF8484847D7D7D
8C8C8C252525E9E9E9FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFEFEFCF7F7F5FFFFFBFFFFFB
FEFDF9FFFFFDF8F8F8FEFFFFFEFFFFFAFBFBFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFCFCFCFFFFFD
FFFFFBFFFFFDFAF9FCFFFEFFDEDDE30F0E130909050102000C0C080A0A08
070609AFAEB3FEFDFFFEFCFDFFFDFDFFFAFA8E8C8B090706353535AEAEAE
F8F9FBFEFFFFFDFEFFFEFFFFFEFFFFFEFFFFFEFFFFFBFCFCFEFFFFFBFCFC
FFFFFFFEFEFEDFDFDF9191913434341717175D5D5DB8B8B8FFFFFFFFFFFF
FFFFFFFBFBFBFFFFFF191919BEBEBE1C1C1CF8F8F8FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFBFFF6F0FFFEF6F0F8F8F7FFFFFFFEFFFAF6FFF6F6FFFAF7FD
FFFBF6AEA5A0A5ADB8F2FFFFF2F7FFFBFBFFFFFEFBFFFFF8FFFEFDFFFFFF
F9F9F9FDFDFDFFFFFFFFFFFFDCDCDC8C8C8C383838050505E0E0E0FDFDFD
FFFFFFFCFCFCFBFBFBFFFFFFFFFFFFFEFEFEF8F8F8FFFFFFFFFFFFFDFDFD
FFFFFFFCFCFCBEBEBE7171715F5F5FC1C1C1FBFBFBF8F8F8FFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFEFEFEFEFEFEFFFFFFFEFEFEFFFFFFF9F9F9FFFFFF
FFFFFFFFFFFFFEFEFEFFFFFF606060F5F5F5FFFFFFD6D6D6080808000000
0000000606060101014A4A4AFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFF
FFFFFF6A6B6DCACDD4FCFFFFFDFDFBFFFCF5FFFDFAFFFDFBFCF5FCFFFCFF
FFFEFFF5F9F87E857E151C12DBDFD0FFFFF6FFFCFF0B050CFCFAFDFDFDFD
3C3C3C626262F9F9F9FFFFFFFCFCFCFFFFFFFFFFFFF7F7F7FBFBFBFFFFFF
FDFDFDFFFFFFF3F3F33B3B3B595959FBFBFBFBFBFBFFFFFF959595626262
FBFBFB8585852F2F2FF0F0F0FDFDFDF4F4F4FFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFBFBFBFFFFFDFFFFFDFDFBFAFFFEFD
FFFEFDF6F6F4FFFFFFFEFFFFFEFFFFFCFDFDFFFFFFFFFFFFFFFFFFFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFD
F8F8F6FFFFFDFDFCFFF9F8FDDCDBE00706090000000202000B0A06010000
A6A4A7FFFEFFFFFDFFFFFEFFFFFDFDFFFDFDFDFBFAA3A1A0D8D8D8E5E5E5
FFFFFFFCFCFCF9FAFCFEFFFFFCFDFFF6F7F9FCFFFFFCFFFFFAFEFFFEFFFF
FEFEFEFFFFFFFEFEFEFFFFFFFFFFFFE6E6E69090903A3A3A0606065F5F5F
A9A9A9FEFEFEFBFBFB3939395C5C5C757575FDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF8FFFAE8E0D8CB00030E2A394CBEB6C3070004AFB2B9FCFFFF
FFFDECF1E6E06B6D84ECF6FFF5FFFFF9FFFFFFFCF5FFFCF4FFFEFAFFFFFF
FFFFFFF9F9F9FEFEFEFFFFFFF9F9F9FFFFFF8B8B8B101010FAFAFAFFFFFF
FAFAFAFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFBFBFB
FEFEFEFFFFFFF7F7F7FFFFFFFFFFFFC1C1C17171716B6B6BB0B0B0F5F5F5
FFFFFFFCFCFCFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7
FFFFFFFFFFFFFBFBFBFAFAFAF0F0F0707070FFFFFFECECEC040404000000
050505000000020202686868FFFFFFFAFAFAFFFFFFF5F5F5FFFFFFF1F1F1
555555E4E5E9F3F7FFFBFFFFFCFCF8FFFEF6FFFBF6FFFCFBFFFBFFFFFCFF
FCFDFF494F4D353F3AEBF4ECF4FBEBFDFDF1FFFCFF271D26D2D0D3FEFFFF
F8F9F9BCBDBDDCDCDCFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFF8F8F8
FFFFFFD7D7D7262626727272FCFCFCFFFFFFFEFEFEFFFFFFBFBFBF3F3F3F
FFFFFFFEFEFE7777772E2E2EF5F5F5FEFEFEFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFBFFFFFDFFFEFDFFFEFD
FDFBFAFFFFFDFEFEFEFCFDFDFEFFFFFEFFFFFDFDFDFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFBFBF9FFFFFD
FEFEFCF7F7F7FCFBFEFFFEFFDAD9DE100F12010100010100070602514F4E
FFFEFFFDFBFEFFFEFFFFFDFFFFFEFFFFFEFDFFFEFDFDFBFA919191E0E0E0
F9F9F9FFFFFFFEFFFFF5F6F8FEFFFFFEFFFFFBFFFFFCFFFFF9FDFEFCFFFF
FEFEFEFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFEBEBEB979797
4343430D0D0D5151513A3A3A141414D1D1D1FFFFFFFDFDFDFEFEFEFEFEFE
FFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF6FFFAE29F9989485468EFF8FF2616201A0A0BACB3BBF0FBFD
FFFFF1BBB2AB0B091FECEFFFF7FFFFF8FFFFFCFBF4FFFFF6FFFFFBFEFEFE
FEFEFEFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF4D4D4D0E0E0EFFFFFFFCFCFC
FEFEFEFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFBFBFBFFFFFFFDFDFDFFFFFFFBFBFBFFFFFFFDFDFDCECECE7E7E7E
6464649F9F9FECECECFFFFFFFDFDFDFDFDFDFCFCFCFFFFFFFFFFFFFFFFFF
FAFAFAFDFDFDFFFFFFFFFFFFFCFCFCC1C1C18D8D8D9999991F1F1F060606
010101010101000000E9E9E9FFFFFFFFFFFFFFFFFFFFFFFFD5D5D5656565
F7F7F7FDFEFFFCFEFFF8FBFFFFFFFBFFFDF4FFFEF6FFF7F4FFFCFFE9E3EB
3132325A5E5DF2F8F8F8FEFAFEFFF3FFFFF3FFFBFE463E47BBBABDF9FAFA
FEFFFFFCFDFDFDFDFDFCFCFCFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFFFFFF
C4C4C41414149D9D9DFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCE5E5E5414141
FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFCFCFCFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFD
FCFCFCFEFDFFFFFEFFFAF9FEE0DFE20A0A0A0503040402013F3E3AFDFCF8
FFFEFDF3F1F2F4EFF3FEFCFFFFFEFFFFFFFFFEFEFEFFFFFFFDFDFD6A6A6A
F4F4F4FFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFE4E4E4A3A3A31B1B1B0101014B4B4B9C9C9CEAEAEAFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFFFFFF
FDFDFDFFFFF8FFFFE9C9C6BB090F27F8F8FFF6DFD9120000D0DCE8F0FFFF
FCFFFFFFFEFBFFFBFFFFFAFFFEFDFFFCFEFFFCFFFBFCFFF8FEFFFDFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFBFBFBF6F6F60C0C0C050505F7F7F7F9F9F9
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F9F9DDDDDD8D8D8D5E5E5E969696E6E6E6FFFFFFFEFEFEFBFBFBFFFFFF
FFFFFFFDFDFDFEFEFEFFFFFFFEFEFEDFDFDF1A1A1A949494FAFAFA919191
1919194F4F4FE3E3E3FFFFFFFFFFFFFEFEFEFFFFFFB4B4B4828282FFFFFF
F9F9F9FFFEFFFFFBFFFFFCFFFCFAF9FFFFF8FEFFF5FDFEF8D2D1D41F1E23
807E7DFFFEFDFEFBFFFFFEFF8585780A0C00303030AAAAB0FBFFFFFCFFFF
FAFEFFFCFFFFFAFBFDFEFFFFFCFCFCFDFDFDFFFEFFFDFBFCFCFCFAADADAB
121210BABAB8FEFFFDFAFCF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFFFFFBFDFDFB
FFFEFFFFFEFFFFFEFFFDFCFFC0C0C00F0F0F0100000B090AE8E6E5FFFFFB
9998945A5857A09B9F5B585EE5E4E7FDFCFFF9F8FBDFDFDFFDFDFD7D7D7D
B6B6B6FFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC
FEFEFEFFFFFFFEFEFE3C3C3C343434A9A9A95757570C0C0C3D3D3D909090
E7E7E7FAFAFAFFFFFFFBFBFBFEFEFEFDFDFDFFFFFFFFFFFFFDFDFDFFFFFF
FFFFFFFEFFF9FFFFF1F0F1E9101026E2DAEDFFF7E77B6A58838F9DEEFFFF
F9FFFFFFFFFFFFFDFAFFFCFCFFFAFFFFFCFFFBFFFFF9FFFAFEFFFDFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFDFDFDFBFBFBFBFBFB292929DCDCDCFFFFFF
FBFBFBFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFBFBFBFFFFFFE5E5E59393936A6A6A828282E3E3E3FAFAFA
FAFAFAFFFFFFFFFFFFFBFBFBECECEC191919909090797979E4E4E4FFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFFFFFFF9F9F9919191A7A7A7FDFDFDFFFFFF
FFFFFFFFFDFFFFFBFFFFFCFFFFFEFDFCFDF5FBFEF5B7B9B3161717A5A5A5
FFFFF8FFFEFBFFFBFFFEF8FFFFFFF4A1A395DCDEDBE8EBEFFBFFFFFAFFFF
F7FBFCFCFFFFFEFFFFF9FAFCFFFFFFFFFFFFFFFEFFFFFEFF898987191917
D1D1CFFFFFFDF7F9F6FEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFCFCF8FCFCFA
FFFEFFFBFAFFFFFEFFFFFEFFA9A7A60604030604077B797CFFFBFBFFFEFB
8B87848B8686FFFDFFDEDBE2090A0EFBFCFFFAFBFFBFC0C22F3032161719
EAEAEAFDFDFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFCFFFFFCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFF0E0E0E383838FBFBFBFFFFFFF9F9F9B4B4B4676767
0808082F2F2F878787DCDCDCFFFFFFFDFDFDFAFAFAFCFCFCFFFFFFFCFCFC
FAFAFAFFFFFDF5F7F2FFFFFDB7B3BD332A2DFFFDE8978E7D363E50E9F7FF
FBFEFFFFFEFFFDFFF2FFFFF4FFF9FFFFF9FFFBFFFFF8FFFBFCFFFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3E3E3EB2B2B2FFFFFF
FDFDFDFBFBFBFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFEFEFEFBFBFBFFFFFFFFFFFFF7F7F7EEEEEEA5A5A5656565
7E7E7ED9D9D9FBFBFBFFFFFF949494ACACACF9F9F9FFFFFF585858EEEEEE
FDFDFDFBFBFBFFFFFFFFFFFFF4F4F46E6E6ECECECEFFFFFFFEFEFEFFFFFF
FCFCFCFEFDFFFFFCFFF8F5FCFDFBFAFFFFF898979014130ECECCCBFFFEFA
FFFFF4F7F6F1FFFBFFFEF9FFFFFEF7FBFBEE8F8F8DD9DADCFBFFFFF7FFFF
FBFFFFFCFFFFFAFBFDFEFFFFFFFFFFF8F8F8F5F3F4666465343231EBE9E8
FFFFFDFFFFFDFBFDFAFCFEFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFEFEFAFFFFFB
FFFEFFFCFBFFFFFEFFFEFEFE949291020000110F12FFFEFFFBF6F8FFFBF8
DDD9D5120E0BF3EDF4FFFDFF79797F898C91FCFFFFFBFCFFF3F4F8F2F3F5
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9
FFFFFFFEFEFEADADAD343434272727FFFFFFFCFCFCFFFFFFFAFAFAF6F6F6
FFFFFFC1C1C16A6A6A1919192A2A2A7C7C7CD0D0D0FAFAFAFFFFFFFFFFFF
FEFEFEFFFFFFFEFFFFFEFEFEFDF8FABCB4B166604E61615400000BE7EDFF
FFFCFFFFFEFFFBFFF3FCFFF3FFFBFFFFFAFFFCFFFFF9FFFFFEFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFCFCFDFDFD
EDEDEDA8A8A8717171707070B1B1B1FCFCFCFFFFFFF7F7F7FFFFFF494949
E7E7E7FFFFFFF8F8F8D5D5D5575757E8E8E8FDFDFDFFFFFFFFFFFFFDFDFD
FCFCFCFDFCFFFEFEFFFEFFFFFFFEFD6864602D2724E6E0DDFDF9F6F8F7F0
FFFFEFFFFFF8FDFBFFFBF9FFFDFDFBFFFFF4FFFBF86E6C6FEDF3F3F9FFFF
FBFFFFEFF5F5FEFFFFFEFFFFFCFCFCF3F3F3484647535152EBE9E8FEFCFB
FFFFFDFFFFFDFDFFFCFEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFDFFFFFAFEFFFB
FCFBFFFFFDFFFDFCFFF8F8F854534F0100009C9A9DF8F5FBFFFDFFFFFEFB
FFFDF71F1917E2DBE2FFFCFFA6A9B0454950F9FDFFFCFFFFF9FCFFFEFFFF
FEFEFEFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFEFEFE
FAFAFAFCFCFC6363638F8F8F000000FDFDFDFFFFFFFFFFFFFFFFFFFDFDFD
F3F3F3FFFFFFF8F8F8FEFEFECACACA7373732B2B2B262626616161C5C5C5
FFFFFFFBFBFBFEFCFDF9F7F8FFFDFFFFFDFCF5FAF3FAFFF9555754AEACAF
FFFAFFFFFCFFF8FFFDF8FFF8FFFFF8FFFDFBFFFEFFFEFFFFFEFDFFFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFCFCFCF6F6F6FFFFFFFFFFFF
FFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFC1C1C1F8F8F8FDFDFDABABAB7C7C7C6F6F6FBCBCBCF0F0F0FEFEFE
6B6B6B7575755F5F5F333333FCFCFCFFFFFFFBFBFBD8D8D8525252F8F8F8
FFFFFFFEFFFFF6FBFEEBEFF04343434F4949FFF5F4FFFAF9928984030100
7C8067A5ADA0000019DEDFFDFEFFFFD8D5CCFFFCFA857E81B2B6B7F9FFFF
F4FAFAFBFFFFFEFFFFFEFFFFE0E0E0312F306C6A6BFAF8F9FFFEFDFFFEFD
F9F9F7F8F8F6FEFFFBF9FBF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFEFFF9FAFCF7
FDFCFFFFFDFFF7F6FBFFFFFF0F0E0A040300FCF9FFFFFDFFFFFBFDFFFEFB
F9F4EE746E6B1F181FF4F0FA878993515860FBFFFFFBFFFFFBFEFFF6FAFB
FFFEFFFAFAFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF9F9F90E0E0EEAEAEA151515E6E6E6FFFFFFF6F6F6FFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFF2F2F2D4D4D48F8F8F292929
181818616161B3B1B2FFFDFFFEF9F9FBFBFBF9FFFFF9FFFD64635C544E4B
FFFBFEFFFDFFF8FFFFF8FFFDFFFFF6FFFEF8FFFDFFFFFDFFFEFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFF4F4F4
F8F8F8FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFDFDFDFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFFF6F6F6
777777878787FFFFFFFFFFFFFFFFFFFAFAFAFFFFFFC5C5C58C8C8C707070
7474746A6A6A808080FDFDFDFFFFFFF8F8F8FEFEFEECECEC101010FFFFFF
FFFFFFF8F9F9E2E6E5222625716F70FCF5F8FFF6F8FFFCFA575048C0BEAD
DDE1C4000300555674C5C5E9F7F7FDC5C4BD342C2A0E070AEBEFF0F0F9FB
F9FFFFFBFFFFF7FBFCD0D1D31A18198E8C8DFFFEFFFBF9FAFFFEFDFFFEFD
FFFFFDFFFFFDFEFFFBFEFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFFFFFAFEFFFB
FFFEFFFFFDFFFFFEFFFBFBFB0100006F6E6AFFFCFFFDF7FFFFFCFEFFFEFB
FFFBF3D1CBC8040004605C6600020BBFC7CFF0F7FFF9FDFFFCFFFFFCFFFF
FFFEFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8
F9F9F9AAAAAA434343F8F8F8FFFFFFFAFAFAFBFBFBFFFFFFFBFBFBFCFCFC
FFFFFFFAFAFAFFFFFFF7F7F7FDFDFDFBFBFBFFFFFFFFFFFFF9F9F9FFFFFF
DFDFDF9292923F3C420B090C5F5D5CA7A9A4EBF1EFEDF3F1B3B1B0A39F9C
FFFEF7FFFFF8FCFFFFFCFFFFFFFFFAFFFEF9FFFDFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFCFCFCFCFCFCFFFFFF
FCFCFCFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFEFEFEF5F5F5FCFCFC5B5B5B
414141EDEDEDFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFCFCFCF9F9F9
FFFFFFFFFFFFFCFCFCFFFFFFF9F9F9FFFFFFFDFDFDFFFFFF0E0E0EF2F2F2
FCFCFCC7C7C7151513929290FFFEFFFFFEFFFAF5F7FFFEFB6464588F907C
FFFFE49A9A8D0B0527FEF7FFFBF7FFFFFFFAFFFEFBFAFAF8FBFFFFF8FFFF
F4FCFEF6FBFEB7BBBC141517ADABACFFFEFFFEFCFDFFFEFFFFFEFDFFFEFD
FFFFFBF6F6F2FDFFFAFDFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFFFDFEFFFBFCFEFB
FFFEFFFCFAFFFFFEFFBFBFBF010000F8F7F3FFFCFFFFFCFFFFFDFFFFFEFB
FFFCF6F3EDEA231C21F2EEF8FCFEFFF5FCFFFBFFFFFBFFFFFCFFFFFEFFFF
FFFFFFFDFDFDFFFEFDFFFEFDFFFEFDFFFEFDFFFFFDFFFFFDFFFFFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFA4A4A4CECECEFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFEFEFE
FFFFFFFFFFFFFAFAFAFFFFFFFAFAFAFFFFFFFFFFFFFDFDFDFFFFFFFFFFFF
FBFBFBFFFEFFFFFEFFE5E4E797979550524D0206034B4F4EA2A0A1EEECEB
FFFFF5FFFFF6FFFFFDFFFFFFFFFFFBFFFEFAFFFEFDFFFEFFFFFFFFFEFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFEFFFEFEFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFCFCFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFB2B2B2505050
F4F4F4FFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFEFEFEFFFFFFFDFDFDFFFFFF
FEFEFEFEFEFEFEFEFEFCFCFCFFFFFFFFFFFF797979989898212121D3D3D3
A6A6A6131313B8B6B5FFFEFDFEFCFDFEFEFEFFFFFFFCFCF8BDBEB43D3E2C
FFFFE5FDFAEF130A27DDD5F8FFFCFFFDFDFBFDFDFBFEFFFFFAFFFFF4FCFC
FBFFFF9A9DA1101113C8C8C8FFFEFDFFFEFDFFFEFFFAF9FCFFFEFFFEFCFB
F4F4F2FFFFFDFEFFFFFDFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFF
FFFEFFFFFEFFFFFEFFFFFFFFFFFEFDFFFEFDFFFDFFFFFDFFFFFDFFFFFCFC
FFFDFDF0EAEA20191CC0BAC1FCFAFFFDFDFFFEFEFFFBFBFFFDFEFFFFFEFF
FEFEFEFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFEFDFFFFFFFFFFFFFDEAEBEBABABAB525051100E0D
41403C94938FE5E3E2FFFEFDFFFEFDFFFDFCFFFEFDFFFFFFF9FDFEFCFFFF
FFFEFFFBFAFDFCFFFFFCFFFFF9F9F7FFFEFDFFFCFCFFFEFDFEFFFDFDFFFC
FEFCFDFFFEFFFEFFFFFEFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFDFDFDFDFDFDFEFEFE
FCFCFCFFFFFFFFFFFFFDFDFDFDFDFDFFFFFFFCFCFCFFFFFFDADADAFFFFFF
F9F9F9FFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBF6F6F63E3E3E1C1C1C979797
1E1E1ED3D3D3FEFFFFFEFFFDFAFBFBFEFEFCFFFFFDFBFAF6FEFDF6605D54
959287FFFDF9524E589B97A5FEFDFFFEFFFFFEFFFFF8FBFFF8FCFBFCFFFF
71727626272BDFDFDDFDFCF7FFFEF8FEFAF6FFFEFFFAFBFFFDFBFEFFFEFF
AEAEACB3B4B4FCFFFFFCFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFF8F3F5FFFDFFFAF5F7
FFFBFEDDD6D9A69FA2C4BFC3FFFCFFFDFBFFFBF9FFFFFEFFF9F8FDFEFEFE
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFFEFFFFFEFEFEFEFEFEFFFFFFFFFFFFFEFCFBFBF9F8
B2B0AF5C5A591917162E2C2B858382DFDDDCFFFEFDFEFEFEF9FDFEFCFFFF
FFFDFFFFFEFFFCFFFFF3F9F7FFFFFDFFFBFBFFFDFDFFFFFDFCFFFDFCFFFD
FFFDFFFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFDFDFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFFFFFFFE5E5E5FAFAFAFFFFFFFFFFFFFAFAFA
FFFFFFFFFFFFFEFEFEFFFFFFF5F5F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEE3E3E30F0F0F4C4C4C
EDEDEDFDFEFEF8F9F9F6FAF9FEFFFDFEFFFDFBFAF6FEFDF9FFFEFAFFFEFA
8F8B88726E6B171516525154FBFAFFFCFCFFFBFEFFFCFFFFF3F7F6525451
3F3E43ECEAEDFFFFFBF8F5EEFFFEF4FFFEF7FBFEFFFCFEFFE8E6E9A09B9B
8985822D2D2DD6DAE5F4FAFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFBF9FAFFFDFFFFFDFF
989194D9D2D5FFFBFEFFFCFFCDC9D392909BFFFDFFFEFDFFFEFDFFFDFDFD
FFFFFFFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFDFC
FDFBFAFFFEFDF7F5F4C8C6C56969691515152828287B7B7BC9CDCCFEFFFF
FBF9FAFFFEFFF3F7F6FBFFFFFCFCFCFBF9FAFFFEFFFDFDFDFAFEFDFAFEFD
FFFCFEFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFD
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFEFEFEFCFCFCFBFBFBF9F9F9
FBFBFBFFFFFFFBFBFBFFFFFFCECECE747474FFFFFFFEFEFEFFFFFFFDFDFD
FCFCFCFFFFFFFCFCFCFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFEFEFE6D6D6D0A0A0A
C7C7C7FEFFFFFEFFFFFCFFFFFEFFFDFCFEFBFFFFFBFDFCF8FFFEFBFFFCF9
FFFDFAFCF8F5F9F7F8010003E9E8EDFEFEFFFCFFFFE6E9EE363C3C5A5E5D
F4F2F5FBF6F8FFFEFBFFFFF6FFFCEEFFFFF8F4FAFFF8FBFFFFFDFF4F4840
DBD4CC666463D7DDE9F8FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFAF8F9FFFEFFFAF5F7FDF8FA
F2EBEE3B3437FFF8FBFDF8FC2B2731E7E5EEFFFEFFFFFEFFF6F5FAFFFEFF
FDFDFDFCFCFAFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFCFCFCFFFFFFFFFFFFFFFEFDFFFDFC
FFFEFDFFFEFDFEFCFBFCFCFCFFFFFFFFFFFFC9C9C97475752324241F1F1F
726D6FC2BDBFF9FDFCFBFFFFFFFFFFFFFEFFF9F7FAFEFEFEFBFFFFFCFFFF
FFFDFFFFFCFFFFFFFFFDFEFEFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFEFEFEFEFEFEFFFFFF
FDFDFDFFFFFFFBFBFBBBBBBB151515CDCDCDFFFFFFFCFCFCFAFAFAFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFF9F9F9FCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFA9A9A93C3C3C
1F1F1FE8E9E9F8F9F9F5F9F8FEFFFDF2F4F1FFFFFBFFFFFBFDF9F6FFFEFB
FFFEFBFFFDFDF3F1F2202020B6B5BAF6F7FBE0E3E81E2126767C7CF6FAF9
FFFEFFFFFDFFFFFBF8FEF9F1FFFFEDFFFEF7F1FEFFF2FCFFFFFDFDFAEBE3
83796D8A8683BDC4D2F7FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFAF8F9FFFDFFFFFDFF
FFFDFFA7A2A49A9597979296ACA9B0FFFDFFFBFAFFF4F3F8FDFCFFFFFEFF
FDFDFDFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
F6F6F6FFFFFFFFFFFFFBFCFEFEFFFFFEFFFFF9FAFCFEFFFFFFFFFDCDCBCA
888282342F31171B1A5E6464B5B6B8F5F4F7FFFEFFFDFEFFF5FBFBFCFFFF
FFFDFFFDF6F9FBF9F8FFFFFDFDFDFDFEFEFEFEFEFEFDFDFDFEFEFEFFFFFF
FFFFFFFBFBFBFDFDFDFFFFFFFFFFFFF7F7F7FEFEFEFFFFFFFCFCFCFBFBFB
FFFFFFFDFDFDE6E6E60F0F0FC8C8C8FFFFFFFFFFFFFBFBFBFFFFFFFBFBFB
FFFFFFFCFCFCFFFFFFF3F3F3858585FDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFC5C5C5303030
7B7B7B363737FCFDFDFCFFFFFCFEFBFEFFFDFDFBFAF8F6F5FFFEFBFFFBF8
FBF6F6FFFBFBE1DFE09D9D9DBCBBC0CACBCF0C0F149DA0A5FBFFFFFCFFFF
F8F7FAFFFEFFFEFEFAFFFEF4FFF6E7A19893000A1DC3DCF0F8EFF0FFF9EF
FFF7EC221C195D6675F2FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFCFDFDF8FAFFFDFF
F7F2F4FFFDFF2D282A444245FEFBFFFFFEFFFFFEFFFFFEFFFFFEFFFEFDFF
FFFFFFFCFCFCFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFBFBFBFCFCFCFFFFFFFFFFFF
FFFFFFFCFCFCFEFFFFFEFFFFFBFCFEFEFFFFFEFFFFFDFDFDFFFEFDFFFEFB
FFFAFBFFFBFBD6DAD98C9292424347111015555459A9AAAEF0F5F8FCFFFF
FFFAFCFFFCFFFFFEFDFBFBF9FFFFFFFFFFFFFFFFFFFCFCFCFDFDFDFFFFFF
FFFFFFFEFEFEFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFBFBFBFEFEFEFFFFFF
F6F6F6FFFFFFAAAAAAD7D7D7FFFFFFF9F9F9FEFEFEFFFFFFFEFEFEFFFFFF
FBFBFBFBFBFBFFFFFFB3B3B3464646FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFBFBF9F9F9FFFFFFFEFEFEE6E6E61A1A1A
FEFEFE535353626363FCFFFFF8FAF7FCFCFAFAFAF8FFFEFDFFFEFBFFFCF9
FFFDFDFFFEFDFFFEFFFFFFFFA9A8AB0E0F13B9B9BFFCFFFFFCFFFFFCFFFF
FDFCFFFFFEFFFCFBF7FFFEF6FFFBEDBAB1AC3C51649DB3C8FFFCFDFFF1E6
FFF7EBFFFCF9636C79EDFAFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFEFCFDFCFAFBFFFEFF
FFFEFFFFFEFFE8E3E5E9E7EAFEFBFFFAF9FFFEFDFFFFFEFFFCFBFEF9F8FB
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFBFAFEFCFBFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFBFCFE
F9FAFCFEFFFFFEFFFFF9FAFCFCFDFFFDFEFFFBFCFEFFFFFFFEFAF7FFFDFA
FFFCFBFFFDFDFCFFFFF6FCFCEFF2F6EBEBF197979D4245490D1517424848
ABA6A8EDE6E9FFFCFCFFFEFDFAFAFAFFFFFFFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFBFBFBFFFFFFF8F8F8
FFFFFFF8F8F8F6F6F6FFFFFFFFFFFFFFFFFFFEFEFEFAFAFAFBFBFBFFFFFF
FAFAFAFFFFFFFFFFFF5A5A5A919191FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFFFFFF303030
F3F3F3F4F4F42E2F2F8A8B8BFFFFFFFFFFFFBDBDBBC0C0BEF7F5F4FFFEFD
F7F5F4FFFEFDFFFDFE7F7F7F242326D2D3D5FCFDFFFCFFFFFBFFFFF7FBFA
FCFAFDFFFCFFFFFDFDFCF7F1FFFFF1E9EAE2080D1EEFF1FFFFFDFFFFFDF4
FFFDF2F9F8F4F5FBFFF8FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFFFEFFFFFEFFFFFDFE
FEFCFDF9F7F8FFFDFFFCFAFDFFFEFFFFFEFFFFFEFFFAF9FCFFFEFFFFFEFF
FDFDFDFDFDFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFCFCFCFCFCFCFEFFFFFEFFFF
FEFFFFFCFDFFFCFDFFFEFFFFFEFFFFFEFFFFFDFEFFFEFEFEFFFEFBFFFBF8
B6ACAB0E0808DFE3E2FBFFFFFCFFFFFBFBFFFEFEFFFBFEFFE5EDEFA8AEAE
4B464A140D10454040999796EDEDEDF8F8F8FFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFEFEFEFBFBFBFFFFFFFDFDFDFFFFFFF9F9F9FFFFFFF4F4F4969696
FFFFFFFDFDFDFFFFFFFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFBFBFB
FFFFFFFFFFFFFDFDFD101010E8E8E8FCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFBFBFBFFFFFFFFFFFF
F9F9F9FFFFFFDBDCDC1A1B1BB9B9B9FCFCFCA2A2A05A5A58FFFEFDFFFEFD
FFFEFDF5F3F2676767353535DFDEE1FFFEFFFEFFFFFDFEFFF9FDFAFCFFFD
FFFEFFFFF9FFFFFCFCFFFEFAFBFCF2FFFFFA27232DCAC6D4FCFAFDFEFDF9
FDFEF8FEFFFDF4F8FFFBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFF
FEFFFFFDFEFFFAFBFDFEFFFFFBFBFBFEFEFEFAFAFAFFFFFFFEFDF9FFFEFB
FFF6F7635D5DF0F4F3FBFFFFFBFEFFFEFEFFFEFEFFFCFFFFF6FEFFF6FCFC
FFFDFFF7F0F3AEA9A95D5B5A131313383838898989DADADAFFFFFFFFFFFF
FBFBFBFFFFFFFDFDFDFFFFFFFAFAFAFFFFFFFFFFFFEFEFEF4545458E8E8E
FCFCFCFFFFFFF8F8F8FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFF8F8F8FFFFFF
FEFEFEFFFFFFC3C3C32E2E2EFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFFC2C3C3151515DBDBDBBCBCBC444444FCFAF9FFFEFD
F7F5F64341424C4C4CF8F8F8F1F0F3FFFEFFFEFFFFFEFFFFFFFFFBFFFFFD
FCFFFFFCFFFFFEFFFFFFFFFDFFFDFDFFFDFB94908D767475FFFEFFF8F8FE
FCFFFFFBFFFFFCFFFFFDFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEF9F9F9
F9F9F9FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFF
FBFCFEFDFEFFFDFEFFFFFFFFFFFFFFFFFEFDFFFEFDFCFAF9FFFFFDFFFEFD
FFFDFD9B9698B7BBBCFBFFFFF9FCFFFEFFFFF9F9FFFCFFFFF9FFFFFBFFFF
FFFDFFFFFCFFFFFEFDFFFFFDF4F4F4BDBDBD6969691212123131317B7B7B
D2D2D2FFFFFFFFFFFFFFFFFFFFFFFFF5F5F5FBFBFB353535686868FFFFFF
FFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFAFAFAFFFFFFFBFBFBFFFFFFF8F8F8
FBFBFBFFFFFF717171858585FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9FAFAFDFEFE9B9B9B292929D9D9D9191919FFFEFDE0DEDD
2A2829706E6FFCFCFCFEFEFEFFFEFFFEFDFFF8F9FBFEFEFCFFFFFAFFFFFB
FCFFFFFBFFFFFCFFFFFEFFFFFFFDFFFFFDFDE4D7CE190E08F1F1F9F8FFFF
F5FFFFF6FDFFFFFFFFFFFEFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDF7F7F7FFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFEFDFFFFFFFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFFFFFFF7F7F7FCFAF9FFFEFBFFFBF8F5F4F0FCFDFDF8F9F9
FFFAFCDEDCDF6B7171F5FDFDFEFFFFFAF9FCFFFEFFFDFEFFF8FEFEFCFFFF
FFFBFDFDF6F9F9F7F8FCFCFCFFFFFFFBFBFBFCFCFCFFFFFFC6C6C6727272
2020201F1F1F757575CACACAF8F8F8FFFFFFBDBDBD7C7C7CFFFFFFFAFAFA
FFFFFFF6F6F6FBFBFBFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFDFDFDFFFFFF
FFFFFFFFFFFF181818DADADAFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF646464414141090909DCDCDC1C1C1C
8F8F8FFFFFFFF9F9F9FFFFFFF8F8F8FFFFFFFFFFFFFDFDFBFFFFFAFFFFFB
FEFEFFFEFEFFFFFEFFFEFFFFF5FFFFFCFFFFFFEBE13A1D17DEE0EAE9FCFF
F0FFFFF3FFFFFFFBF8FFFCF9FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7F7FFFFFF
FFFFFF000000FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFEFDFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FCFDFFF7F7F7FFFFFFFFFEFDFCF8F5FFFDFA9A949114100DCCD0D1FAFFFF
FFFEFFFCFBFF545A5AF3FBFBFEFFFFFFFDFEFCFAFBFEFEFEFCFFFFFCFFFF
FFFDFFFFFDFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFF6F6F6FAFAFAFFFFFF
F9F9F9D1D1D17878782A2A2A1B1B1B6D6D6DA0A0A0FFFFFFFAFAFAFFFFFF
FFFFFFFFFFFFFFFFFFF8F8F8FBFBFBFBFBFBFFFFFFFDFDFDFFFFFF8F8F8F
666666D4D4D41C1C1CFDFDFDFEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFAFAFAFBFBFBFFFFFF444444080808585858ADADAD
FEFEFEFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFFAFAFAFFFFFDFFFFF8FFFFFB
FEFEFFFEFEFFFFFEFFFEFFFFF4FFFFFCFFFFFFF1E733140F9FA1ABEEFFFF
F0FFFFF4FFFFFCF8F5FFFDF8FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFEFEFEFFFFFF
F8F8F8000000FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFFFFFAF8F7FFFCF9FFFDFAFFFCF7B5ACA5494541B1B6B9F7FFFF
F7FAFFD2D2D8171F21C6CCCCFBFBFBFFFDFDFFFDFDFFFEFDFCFFFDF8FCFB
FDF8FAFFFCFEFEFFFFFAFEFFFCFDFDFBFBFBFFFFFFFEFEFEFBFBFBF8F8F8
FFFFFFFEFEFEFFFFFFCDCDCDDADADA8C8C8C3737370B0B0B616161B1B1B1
EEEEEEFFFFFFFBFBFBFFFFFFFDFDFDFCFCFCFFFFFFFEFEFEF6F6F6B4B4B4
5353538585856F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFF1F1F10B0B0B666666FDFDFD
FFFFFFFFFFFFF8F8F8FCFCFCFCFCFCFEFEFEFFFFFDF8F8F4FFFFFAFFFFFB
FEFEFFFCFFFFFEFFFFFEFFFFFCFFFFFFFEFFEBD7CEB7A39EABADB7F1FDFF
F4FFFFF8FFFFFFFFFBFDF7F4FFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFA070707FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFEFDFFFEFBFFFCF9FDF5F0FFFDF6F7ECE4110B08EDF4F8F6FFFF
FBFFFFFBFEFFF7FFFFF4FAF8FEFEFCFFFEFBFFFDFBFFFDFAFCFEFBFEFFFD
FFFDFFFFFEFFFCFFFFFAFEFFFCFDFDFFFFFFF5F5F5FFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDA7A7A7535353FBFBFBFFFFFFFBFBFBE3E3E39E9E9E3E3E3E
0F0F0F5858589F9F9FEAEAEAFFFFFFFFFFFFFFFFFFFCFCFCFFFFFFCBCBCB
2F2F2F2F2F2FC1C1C1F9F9F9FDFDFDFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9F9F9FCFCFCFEFEFEFEFEFEFCFCFC4F4F4F060606CACACA
FAFAFAFFFFFFFFFFFFFEFEFEFFFFFFFCFCFCFFFFFDFFFFFBFFFFFAFFFFFB
FEFEFFFCFFFFFEFFFFFFFEFFFFFEFFFFFCFFFFFBF6FFFBFAFEFEFFF8FFFF
F2FBFEF9FFFFFCFCFAFFFFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFEFEFEF8F8F8FFFFFF
FFFFFF000000FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFDFFFEFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FFFFFFFDFBFAFFFBF8FFFDFAFFFDF6FFFBF3FFFAF22C2623BDC7CCF4FFFF
F4FAFFFBFFFFF2FBFDF9FFFFFFFEFDFFFDFBFFFDFBFFFEFAFEFFFBFEFFFD
FFFBFDFAF8F9FBFFFFFBFFFFFCFDFDFFFFFFFFFFFFEFEFEFFFFFFFFEFEFE
FCFCFC8E8E8E191919EBEBEBFFFFFFF6F6F6FFFFFFFFFFFFFDFDFDFFFFFF
E9E9E9A0A0A05454540404044C4C4C919191E1E1E1FFFFFFFEFEFEF1F1F1
070707111111FBFBFBFFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFF0F0F0FFFEFF84838658595B17181A
E8E9E9FDFEFEF6F6F6FFFFFFFFFFFDFFFFFDFBF9F8FCFCF8FFFFFAFFFFFD
FEFFFFFFFEFFFFFEFFFFFEFFFFFFFFFFFEFFFFFBFDFFF9FDFCFBFFFBFFFF
F4FAFAF8FEFAFEFFFFFAFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFEFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFEFEFEFFFFFF
FCFCFC050505FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFF
FEFEFEFFFEFDFFFEFBFEF9F3FFFEF6FFF9F0FFFDF394908C747D82F3FFFF
F9FFFFF9FDFFF9FFFFFBFFFFFFFEFDFFFEFBFFFDFBFFFEFBFEFEFAFDFFFC
FFFEFFFFFEFFFCFFFFF9FDFEFEFFFFF5F5F5FFFFFFFFFFFFFBFBFBFDFDFD
E2E2E2272727E5E5E5FBFBFBFFFFFFFFFFFFFAFAFAFFFFFFFEFEFEFFFFFF
FFFFFFFCFCFCFFFFFFF3F3F3AAAAAA5E5E5E0D0D0D3C3C3C8D8D8DE4E4E4
0E0E0E515151FEFEFEFEFEFEFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFF7F5F6FFFFFFFFFFFFFAF9FC99989B5C5D5FB3B4B6
717272FCFDFDFFFFFFFFFFFFFDFDFBFFFFFDFFFEFDFFFFFDFFFFFBFEFFFD
FFFEFFFFFEFFFFFEFFFFFEFFFFFFFDFFFEFFFFFCFFFFFAFFFFFEFFF9FDFE
FCFFFDFCFFFDFAFBFBFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFDFCFFFBF8FFFFF8FFFDF5FFFEF4FFF9EEDDD9D50F0F17F8FAFF
FBFAFFFEFEFFFDFDFFFEFFFFFAFAFAFFFEFDFFFDFCFFFEFDFFFFFDFFFFFD
FFFFFFD2D2D2A7A8AAFEFFFFFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFBFBFB
CFCFCFEEEEEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFBFBFBFFFFFFF1F1F1B9B9B96464643B3B3B
0D0D0D8B8B8BFDFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFBEBEBE444444FCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFFFF
FEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFDFFFEFBFFFEFAFCF9F0FFFDF2FFFEF4FAF6F2221F26DDDBE8
FFFDFFFFFDFFFDFCFFFFFEFFFFFEFFFEFEFEFFFFFDFFFFFDF7F7F5FCFCFA
FFFFFFECECEC141316F9F8FBFFFFFFFFFFFFFBFBFBF7F7F7FCFCFCFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFBFBFBFDFDFDF7F7F7
010101A1A1A1FFFFFFFDFDFDFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFDFDFDFFFFFFFFFFFFFEFEFEFBFBFBD5D5D5FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFDFEFFFEFDFFFEFBFFFEFAFFFCF5FFFFF6FFFFF4F3EFEB1F1C239F9DAA
FEFCFFFFFDFFFDFCFFFEFDFFFFFEFFFFFFFFFFFFFDFCFCFAFFFFFDFFFFFD
FFFFFFFBFBFB2E2D30C0BFC2FAFAFAF9F9F9EFEFEF5F5F5FFFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFCFCFCFEFEFEFFFFFFFBFBFBF9F9F9FFFFFFFFFFFFFFFFFFA5A5A5
2121218A8A8AFCFCFCFFFFFFF8F8F8FEFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFCFCFCFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFFFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFEFCFDFDF8F8FFFEFBFFFEFAFFFFF8FDFAF1E5E4DFA29FA6C2C0CB
FCFAFFFDFCFFFFFEFFFEFDFFFEFEFEFDFDFDFAFAF8FAFAF8FFFFFDFAFAF8
FAFAFAFFFFFF7C7B7E79787BFFFFFFD8D8D82828289E9E9EFFFFFFFEFEFE
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFDFFFFFFFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFAFAFAFBFBFB606060
555555696969FFFFFFF9F9F9FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFCFFFFFFFAFAFAF9F9F9FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFDFEFFFEFDFFFDFAFFFCF8FFFEFAFAF9F5FFFDFFFDFCFF
FFFEFFFFFEFFFFFEFFFDFDFDFEFEFEFFFFFDFFFFFDFFFFFDFFFFFDFFFFFD
FFFFFFFBFAFDC3C2C5343336EDEDED1C1C1C999999FEFEFEFBFBFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFAFAFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFCFCFC131313
959595525252FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFEFFFFFEFFFFFEFF
FDFBFEFFFEFFFFFEFFFFFEFFFFFDFDFFFBF8FFFEFBFFFEFDF7F6F9FFFEFF
FCFBFFFFFEFFFFFFFFFEFEFEFEFEFCFFFFFDFFFFFDF5F5F3FFFFFDFFFFFF
FCFBFEFFFEFFFFFEFF0B0A0D858585BABABAFFFFFFFFFFFFFFFFFFFAFAFA
FEFEFEFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFDFEFEFEFBFBFBFAFAFAFEFEFEC5C5C54A4A4A
E5E5E5717171F4F4F4FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFEFEFFFFFFFAFAFAFFFFFFFBFBFBFFFFFFFFFFFFF9F9F9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FDFCFFFFFEFFFCFAFDFFFEFFFFFEFFFEFCFBFFFDFCFDFBFCFFFFFFFFFEFF
FAF9FCFFFFFFFFFFFFFFFFFDFFFFFDFBFBF9FEFEFCFFFFFDFFFFFFFCFCFC
F7F6F9FFFEFFFFFEFF535255191919A2A2A2FBFBFBFFFFFFFEFEFEFFFFFF
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFBFBFBFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF666666888888
FEFEFEFFFFFFFFFFFFFFFFFFF7F7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFAFAFAFFFFFFF9F9F9FFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFEFFFDFEFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFEFCFFFFFEFFFFFEFFFDFBFCFFFDFEFFFEFFFCFCFCFFFFFF
FDFDFDFFFFFFFEFEFCFCFCFAFCFCFAFFFFFDFFFFFDFFFFFDFEFEFEFFFFFF
FFFEFF9D9C9FFEFDFF98979A4C4C4C181818A7A7A7FFFFFFFFFFFFFBFBFB
FFFFFFFBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFEFDFDFDFFFFFFFEFEFEFBFBFBFDFDFDFDFDFDF9F9F90F0F0FE7E7E7
FFFFFFFEFEFEFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFEFEFCFFFFFDFFFFFFF5F5F5
727174535255FFFEFFDFDEE1171717D6D6D6171717999999FFFFFFFEFEFE
FAFAFAFFFFFFFAFAFAFFFFFFFEFEFEFFFFFFFAFAFAFFFFFFFAFAFAFFFFFF
FFFFFFFAFAFAFFFFFFFFFFFFF5F5F5FFFFFFFFFFFFADADAD414141FFFFFF
FDFDFDFFFFFFFFFFFFFFFFFFF8F8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFFFDFEFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDFFFFFDF9F9F7FEFEFE606060
3C3B3EEFEEF1FEFDFFFFFEFF252525C7C7C7E5E5E51D1D1D979797FBFBFB
FFFFFFF9F9F9FFFFFFFFFFFFFDFDFDFCFCFCFFFFFFFEFEFEFFFFFFFCFCFC
FFFFFFFFFFFFFFFFFFFCFCFCFFFFFFFDFDFDFCFCFC989898BDBDBDFFFFFF
F9F9F9FEFEFEFEFEFEFFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFDCDCDC4C4C4C
F9F9F9FFFFFFFFFFFFFCFCFCA2A2A2B0B0B0FCFCFCE0E0E0242424676767
F6F6F6FFFFFFFCFCFCFDFDFDFFFFFFF7F7F7F8F8F8FCFCFCFFFFFFFFFFFF
FCFCFCFFFFFFF7F7F7FFFFFFFFFFFFFEFEFEF9F9F9FFFFFFFFFFFFFFFFFF
FDFDFDFEFEFEFFFFFFFDFDFDFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFD
FFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFDFDFDFBFBFBFEFEFEFCFCFC
FFFFFFF8F8F8FAFAFAFFFFFFFFFFFFFDFDFDFAFAFAFFFFFFEBEBEB646464
1F1F1FD0D0D0FFFFFFFCFCFCFBFBFBFFFFFFFFFFFFFFFFFFF8F8F8FFFFFF
FFFFFFFFFFFFFFFFFFFCFCFCFBFBFBFFFFFFFFFFFFF8F8F8FCFCFCFEFEFE
FFFFFFFDFDFDFFFFFFFBFBFBFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFEFDFFFFFEFFFFFFFFFFFFFF
F7F7F7FFFFFFFFFFFFFBFBFBFCFCFCFEFEFEFFFFFFFCFCFCFFFFFFFFFFFF
A3A3A3181818949494F8F8F8FFFFFFFCFCFCFCFCFCFBFBFBFFFFFFFFFFFF
FCFCFCFDFDFDFDFDFDFFFFFFFFFFFFF8F8F8FEFEFEFFFFFFFAFAFAFFFFFF
FCFCFCFDFDFDFFFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFF7F6F9FFFFFFF9F9F9
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFF9F9F9FAFAFAFFFFFFFCFCFCFDFDFD
FEFEFED8D8D83131315C5C5CDCDCDCFFFFFFFFFFFFFFFFFFF7F7F7FDFDFD
FDFDFDFFFFFFA2A2A2CECECEFFFFFFEFEFEF696969F8F8F8FFFFFFFFFFFF
F8F8F8FFFFFFFCFCFCFEFEFEFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFFFFFFFFFEFF
FFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFFFEFFFCFCFCFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFFFAFAFAFFFFFFFAFAFAFCFCFCFFFFFF
FDFDFDFFFFFFFEFEFE7474741313136C6C6CEAEAEAFDFDFDFFFFFFFCFCFC
FFFFFFFCFCFCBEBEBE2B2B2BFDFDFD898989666666FFFFFFFFFFFFFBFBFB
FDFDFDFFFFFFFBFBFBFCFCFCFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFFFFFFFEFFFDFEFFFDFEFFFDFFFEFFFFFDFFFFFEFFFFFFFF
FFFFFFFEFFFDFEFFFDFFFFFDFFFEFFFFFEFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFEFFFD
FEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFDFEFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFEFDFFFFFEFFFCFCFC
FDFCFFFFFFFFFAFAFAFFFFFFFCFCFCFFFFFFF9F8FBFFFFFFFCFCF8FDFEF8
FFFFFBF9F9F9FCFDFFFEFFFFE8E6E9716F72121315808181F5F5F5FEFEFC
FAFAFAFFFFFFFBFBFB292929C1C1C1323232BFBFBFFEFEFEFEFEFEFEFEFE
FFFFFFFBFBFBFFFFFFFFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFFFDFFFEFFFFFCFFFBFBFFF8FCFFFBFFFCFFFFFBFFFCF9FFFFFFFF
F8FAF7F9FEF8FCFFF8FEFFFAFFFCFFFFFBFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFF
FFFEFFFFFEFFFFFFFDFFFFFBFEFFFBFEFFFDFEFFFFF9FAFCFBFCFEFEFFFF
FBFCFFFEFFFFFCFBFEFEFEFEFEFCFDFFFEFFFBFBFFFEFFFFFEFEF1FDFEEC
FFFFF6FEFFFDF9FDFFFCFEFFFFFCFFFFF9FFD8DDE15159591A1A188D8C88
E5E5E3FFFFFFFFFFFF9696963D3D3D202020F9F9F9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFFFDFFFEFFFFFBFFFBF9FFF8FBFFFBFFFCFFFFFBFFFFFCFFFFFFFF
FEFFFDFCFFFBFBFFF7F4F6F0FFFCFFFFFBFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFAFEFFFAFEFFFBFEFFFFFEFFFFFEFFFFFEFFFF
F7F8FCFFFEFFFFFEFFFFFEFFFFFDFDF9F7F8FBFEFFFCFFFFF9F9EDEBECDA
0B0C02414542293038F1F3FFFEF8FFFFFCFFFBFFFFF9FFFFCDCDCD605E5D
0F0F0F4A4A4AA4A4A4EFEFEF101010CFCFCFFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFEFFFEFFFFFCFFFFFBFFFDFCFFFDFFFEFFFFFDFFFFFEFDF9F9F7
F7F8F8FCFFFFFCFFFDFEFFFDFFFEFFFFFBFDFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFFFDFFFFFBFFFFFBFEFFFBFEFFFDFDFEFEFEFFFFFDFCFFFFFEFF
FDFCFFFFFEFFFFFEFDFCFBF7F1EDE99C9A999B9EA5A5A8AFFFFEFFFFFFFA
DFE4DD9FA5A1E8EAF4FCFCFFFCFBFEFFFFFDF9FDFCFCFFFFFFFEFFFDFCFF
FAF9FC9D9D9D4C4C4C0F0F0F383838717171FFFFFFFCFCFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFEFFFFFCFFFFFCFFFFFEFFFFFFFEFFFFFDFFFFFEFDFFFEFD
FEFFFFFEFFFFF8FCF9FEFFFDFFFEFFFFFEFFFFFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFDFFFFFDFFFFFBFEFFFDFEFFFFFEFFFFFEFFFFFBFAFDFFFEFF
FFFEFFFFFDFCFFFEFAFFFFFBFFFDFDE3E1E2101115D5D5DBFFFDFFFDFCFF
F7FBF8DADEDD8E8E96F9F9FFFEFFFFFBFDFAF7F8FAFEFFFFF8F9FDFFFEFF
FFFEFFFDFDFDFFFFFFE2E2E2919191141414EEEEEEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFFFFFEFFFEFFFBFCFFFAFCFFFBFEFFFDFFFEFFFFFDFFFCF6FDFFFEFF
FDFFFAF8FDF6FEFFFAFEFFFBFDFBFEFFFEFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFCFCFCF8F5FFFFF8FFFDFDFBF7FFFEFAFF706C69A09F9BFDFDFFFCFFFF
FFFEFFFFFFFFC4C7CC95989DFDFEFEFEFFFFFBFBFFFEFEFFFEFFFDFEFFFB
F5F5F3FFFFFFFFFFFFEEEEEEF6F6F6515151969696FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFEFFFFFEFFFFFFF8FFFFF6FFFFF8FFFFFBFEFFFFFEFEFFFFFDFFFFFEFF
FFFFFAFFFFF4FFFFF6FFFFFBF8F9FDFEFEFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFEFFFEFDFFFFFEFFFFFEFFFDFBFC
FFFDFAFFFEFAFFFDF5DAD5D500000E2621318D858266615BF5FCFFF9FFFF
EBE6E8FBF6F6E7ECF03B4248F7F8FCF7F6FBFDFBFFFEFEFFFDFFF9FBFEF5
FFFFFDFEFEFEFBFBFB151515E6E6E6C0C0C0272727FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
F9FFFFFCFFFFFFFFF6FFFDF3FFFBF6FFFCFAFBFFFFF7FFFFF9FFFFF8F8FE
FFFFF8FFFDF2FEF3EBFFFDFBFBFFFFF8FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFCFFFFFAFEFEF9FB
FFFDFBFFFEF8FFF8EEBBB7B4090818FFFBFF2A1B1E18100EE2EEF8F5FFFF
FFFDFA685E5C00010989929FFFFDFFFFFCFFFEFEFFFAFEFFFEFFFAFFFFF8
FFFFFDFBFBFBB5B5B5393939FDFDFDF8F8F83B3B3BB1B1B1FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
F9FFFFFBFFFFFFFEF8FFFCF4FFF9F6FFFBFAF9FFFFF5FFFFF5FCFFFEFFFF
FDFAF390877E1C0E0B352D2BA3ABADF7FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFEFBFFFFFCFFFFFDFF
FFFDFAFFFDF5FFFEF3CDC9C5100F1FFAF5FFFAEAEB070000C7D7E4EEFEFF
FFF7F9FFFBFAEDF7FEF2FFFFFBF8FEFFFCFFF7F8FCF8FCFDFEFFFBFEFFF9
FFFFFDFEFEFE5656569C9C9CFFFFFFFFFFFFCCCCCCA5A5A5FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFAFCF9FEFDF9FFFDFAFFF9FAFFFCFBF9FDFCF9FFFFFFFEFFFFFDFF
FFFEFDF9F8F4AEA5A6DCD5D8E5EBEBF9FFFFFEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFDFFFFFBFFFFFDFF
FFFDFAFFFEF6FFF9EEF8F4F011101ED6D2E0FFFBF49289847B8A9FEEFCFF
FFF8FFFFF9FFF7FFFFF4FFFDFFFFF8FFFDFAFEFEFFFCFEFFFEFFFFFFFFFB
FDFDFBFAFAFA5B5B5BF4F4F4FEFEFEFCFCFCFFFFFFFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFBFAFFFEFDFEFFFDFFFEFDFFF9F8FFF8F6FEFFFFFCFDFDFFFCFDFFFAFB
FAFBFBFCFFFFF7F5F68F8D8EE1E5E6F6FAFBFEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFD
FFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFDFFFFFCFFFFFBFFFFFCFE
FFFDFBFFFEF8FFFDF3FFFBF7B4B4BE16121CFFF4ECB6AEAC212B42F5FEFF
FFF7FFFFFBFFF8FFFFF7FFFAFFFFF4FFFFF8FEFEFFFCFFFFFEFFFFFFFFFD
FFFFFFFEFEFEFFFFFFF9F9F9FFFFFFFDFDFDF5F5F5FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFBFEFFFDFFFAFEFDFCFEF9FFFEF8FFFDFAFEFDFFFFFCFFFEEFF4FFFBFD
F9FDFEF6FFFFFEFFFDF8F8F66E6F73F0F1F5FFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFEFFFFFEFFFEFDFFFFFDFFFFFDFE
FFFEFBFFFEFAFFFEF6FFFEFAFFFEFFB1AEB4685F60696269373C50E8EDFF
FFFBFFFDF8F8FBFFFFF9FFFFFEFFF8FFFFF8FFFFFDFEFFFFFEFFFFFEFFFF
F9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FFFDFFFBF9FCFCFDFDFFFFFBFFFAEF524944BFBFC9FAF7FFA3939B100406
E6E9EDF6FEFEDFE0DAFFFFFB7A7D82B6B9C0FEFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFEFFFFFEFFFFFEFFFFFEFF
FFFCFCFFFEFBFFFFF8FFFEFAFFFEFFFFFEFFFEF9FDFFFDFFFEFDFFFAFCFF
FFFFFDFFFFFBFCFFFFFCFFFFFEFFFBFEFFFAFEFFFDFEFFFFFEFFFFFEFFFF
FFFFFFFDFDFDF8F8F8FEFEFEFBFBFBFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FEFFFFFEFFFFFFFEFFFFFDF8FFF7E9B3A49D474A59F8FEFFA9A2A94C4143
BEBDC2FBFAFDCAC1BA36312B00060EE4EDF8FCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFDFFFFFDFFFFFBFEFFFDFEFFFFFEFFFFFEFFFFFFFEFFFFFEFF
FFFEFFFFFDFCFFFEFAFFFFFBFFFDFFFBF9FCFEFFFFFEFFFFF2F0F1FFFFFF
FCFFFBFAFEFBFEFFFFFEFFFFFEFFFDFEFFFDFEFFFFFEFFFFFEFFFFFFFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
F7F6FBFFFEFFFFFEFFFDF7F4FFFBEDEBDCD5000012D4D8EFE6DDE0170D0C
FCFAFFF9F9FFFFFDF5F8F3EDF2F9FFF8FFFFFCFFFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFFFDFFFFFBFFFFFBFEFFFBFEFFFDFDFEFEFEFFFFFFFEFFFFFEFF
FFFEFFFFFEFFFFFEFDFFFFFBFFFEFAFEFDF9F6FAFBF9FDFEFFFFFBFFFFFA
FCFFFBFAFFFCFCFFFFFEFFFFFFFFFBFFFFFBFCFFFFFCFFFFFFFFFFFFFFFF
FAFAFAFFFFFFF1F1F1FFFFFFFBFBFBFFFFFFFFFFFFFAFAFAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFF
FFFBFDFBF4F7FBFFFFFBFFFFFFFFF1FFF8F11B162A1B1129FFF2F42D1B19
CFD5E0F4FFFFFBFFFBFFFFFAFDFBFFFEFCFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFAFEFFFAFEFFFBFDFEFEFDFEFFFEFFFFFEFFFF
FEFFFFFFFEFFFFFEFFFFFFFAFFFEEFFFFFF4F8FBFFF8FAFFFFFEFFF9F8F4
FEFEFCFCFFFFF9FFFFFCFFFDFFFFF6FFFFF4FBFFFAF9FFFFFFFDFFFFFCFF
FFFEFFFAFAFAFFFFFFFEFEFEFFFFFFFFFFFFF9F9F9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFD
FFFBFBFFFAFBFBFFFFF9FFFFFAFAEDFFFEF6776F824A3C51A28D8A2D1E19
B5BDC8F1FFFFF8FFFFF9FBF6FFFCFFFFFCFFFFFEFFFEFEFEFFFFFFFFFFFF
FEFEFE010101FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFFFDFF
FFFEFFFFFEFDFFFFFBFFFFFBFEFFFBFEFFFBFEFFFDFEFFFFFEFFFFFEFFFF
FEFFFFFEFFFFFFFEFFFFFFFBFFFFF1FBFBEEFEFEFFFEFEFFFBF9FAFFFFFB
FFFFFDFAFBFBFBFFFFFCFFFDFFFFF6FFFFF4FBFFFAF9FFFFFFFDFFFFFCFF
FCFBFFFEFEFEFFFFFFFCFCFCFCFCFCFFFFFFFBFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFD
FFFDFAFFFBFBFFFEFFFDFCFFFFFEF2D3CEC45E5A68958E9DC5BDB8040100
C3C9D5F8FFFFF5FBF9FBFDF8FFFEFFFBFAFFFDFCFFFFFFFFFFFFFFFBFBFB
FFFFFF000000FCFCFCFFFFFFFFFFFFFCFCFCFEFEFEFEFEFEFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFF
FFFFFFFFFFFFFFFFFDFFFFFDFFFFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFFFFFFFFFFFDFFFFFAFFFFFBFFFEFFFFFEFFFFFFFFFFFFFD
FFFFFFFFFFFFFEFFFFFEFFFFFFFFFBFFFFFBFEFFFDFEFFFFFFFEFFFFFEFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FBFAF6FFFEFDFEFDFFFFFEFFFFFCF1FCF7EFFFFDFFF5F5FFFFFFFAFFFFFB
FBFEFFF1F7FFFEFFFFFFFFFBF7F8F8FEFFFFFFFFFFFFFFFFF6F6F6FFFFFF
FFFFFF000000FFFFFFF9F9F9F7F7F7FFFFFFFFFFFFF9F9F9FBFBFBFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD
FFFFFBFFFFFDF7F8FAFDFBFCFFFDF6FFFDF8FDFDFFFCFEFFFFFEFBFEFCFB
F9FFFFF5FDFFFEFFFFF8F7F3FFFFFFFEFFFFFDFDFDFFFFFFFEFEFEFFFFFF
F3F3F3000000FFFFFFFFFFFFFFFFFFF4F4F4FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFCFBFFFFFDFEFFFFFFFEFDFFFCF7A09895C5C5CBF9FCFFFEF9FBCFCDCE
888F97F8FFFFFDFEFFFFFEFDFFFFFFFCFDFFFFFFFFF9F9F9FFFFFFFBFBFB
FFFFFF020202FCFCFCFDFDFDF6F6F6FFFFFFF6F6F6FFFFFFFCFCFCFCFCFC
FCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFAFAFAFFFFFFFFFEFDFFFAF8F0EAE8343336FEFFFFFFFDFF28272C
EEF2F9F6FDFFFBFCFFF8F8F8FFFFFFFDFDFDFFFFFFC8C8C8FFFFFFF9F9F9
FDFDFD000000FFFFFFFCFCFCF9F9F9DCDCDCFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFF9F9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEF9F9FFFDFDFFFDFDFFFDFDACA7A9979598939498A4A7AC
FCFFFFFBFEFFFCFFFFFCFFFFFDFDFDFFFFFFF9F9F9000000484848FEFEFE
FEFEFE050505FFFFFFF0F0F0101010696969FCFCFCFFFFFFFDFDFDFAFAFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFFFFFFFFFDFBFCF6F4F6F7F7FDFDFDFFFCFB2E25263E4549F6FFFF
FFFEFFFEFBFFF9FEFFFBFFFFFFFFFFFBF9F8FFFFFF959595040404545454
FEFEFE000000D7D7D7141414000000E9E9E9FAFAFAFFFFFFFBFBFBFFFFFF
FFFFFFFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FBFFFFFFFFFFFFF7F5FFFDFBFCFFFFFEFFFFFFF6F5F2E8E7E3ECF1F7FFFF
FFFEFFFFFBFFFBFFFFF5FDFFFBFBF9FFFEFBFFFEFDFCFCFC121212000000
3434340606060D0D0D060606707070FDFDFDFFFFFFFBFBFBFFFFFFFDFDFD
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FCFFFFFEFFFFFFFDFBFFFDFBFCFFFFFEFFFFFFFBFAFFFCFBF8FFFFF7FFFF
FFFEFFFFFDFFFBFFFFF9FFFFFFFEFDFFFEFBFBF9F8FFFFFF9B9B9B080808
121212000000030303030303F0F0F0F9F9F9FFFFFFFFFFFFFDFDFDFDFDFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF
FCFFFFFEFFFFFFFDFBFFFEFBFEFFFFFFFEFFFFFCFAFFFDFBF9FFFFF8FFFF
FFFFFFFFFEFDFCFFFFFBFFFFFFFEFDFFFEFBFFFEFDF9F9F9EFEFEF030303
0000000000000606063A3A3AFAFAFAFEFEFEFFFFFFFFFFFFFEFEFEFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFFFFFBFFFFFBFFFDFFFFFEFFFFFEFAFFFFFBFEFEFFFCFEFF
FEFFFFFEFFFDFEFFFFFFFEFFFFFEFDFFFFFBFFFFFDFCFCFCFFFFFF434343
000000000000090909A3A3A3FFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFF
FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFDFFFFFDFFFCFFFFFDFFFFFFFAFEFFFBFFFCFFFFFDFF
FCFFFFFBFFFFFFFEFFFFFEFFFFFFFBFFFFFBFAFAF8FFFFFFF5F5F5A0A0A0
0E0E0E010101080808F3F3F3FFFFFFFEFEFEFDFDFDFDFDFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFCFFFDFFFFFDFFFCFFFFFCFFFEFFFBFCFFFDFFFCFFFFFCFF
FBFFFFF9FFFFFFFEFFFFFDFFFFFFFBFFFFFBFFFFFDFFFFFFFFFFFFD5D5D5
0A0A0A030303191919FFFFFFFDFDFDFDFDFDFEFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFCFFFFFCFFFFFFFFFFFFFCFFFFFCFFFEFFFDFCFFFFFFFCFFFFFDFF
FBFFFFF9FFFFFFFEFFFFFDFFFFFEFBFFFFFBFFFFFDFBFBFBFFFFFFF7F7F7
0A0A0A000000585858FDFDFDFEFEFEFEFEFEFFFFFFFFFFFFFFFFFFFEFEFE
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFCFFFFFCFFFFFFFFFFFFFDFFFFFDFFFFFFFFFEFFFFFFFDFFFFFEFF
FCFFFFFCFFFFFFFEFFFFFDFFFFFEFBFFFFFBFEFEFCFFFFFFF8F8F8FFFFFF
3232320000009E9E9EFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFD
FDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFEFFFFFFFFFFFFFEFFFFFEFFFFFFFFFFFFFFFFFEFFFFFEFF
FEFFFFFEFFFFFFFFFFFFFEFFFFFEFDFFFEFDFDFDFDFFFFFFFFFFFFFAFAFA
616161010101BDBDBDFEFEFEFFFFFFFDFDFDFDFDFDFFFFFFFFFFFFFEFEFE
FEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFCFEFEFEFCFCFC
8D8D8D020202DADADAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
A6A6A6000000FFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6F9F9F9
D0D0D0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFAFFFFFFFFFFFFFFFFFF
FBFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF6F6F6
FFFFFFFDFDFDFBFBFBFDFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFBFFFFFFFFFFFF
FFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6F6FFFFFFFFFFFF
F7F7F7FFFFFFF6F6F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFDFFFFFFFEFEFEF9F9F9
FFFFFFFFFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF
pop
grestore
%%Trailer
%%EOF
\
\>"], "Graphics",
  ImageSize->{373, 274},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005e00014R000`400?l00000o`00003oo`3ooomf
0?ooo`00o`3ooomf0?ooo`00_03oool70?ono`80oooo0`3nool40?ooo`030?ono`3oool0ooko07D0
oooo00D0ooom0?ooo`3oo_l0ooko0?ooo`020?ooo@030?ooo`3nool0o_oo00<0o_oo00@0ooom0?on
n`3oo_/0oooo0P3oo_l00`3oool0ookm0?ooo@020?kooaT0oooo002`0?ooo`050?ono`3ln_d0ooko
0?ono`3jno/00P3nool0203mo_h0o_oo0?Win@3oool0ooko0?okn`3oo?`0ooWj0P3on_d02@3on_l0
noKj0?ono`3gn?X0o?oo0?_oo`3lool0n?Wk0?koo`030?ono`030?SgnP3mo_l0o_oo0700oooo0P3o
o_l0103oool0ooom0?oon`3oo_d20?omo`040?omoP3ooo/0no_g0?koo`80o?ko0100m_cl0?_oo@3k
oo`0o_oi0?omm03ooOH0oO_l0?kno`3gn?`0oooo0?onnP3oooX0o?om0?_oo`3nool0oooo0P3oo_lE
0?ooo`00/03oool20?omo`0N0?ono`3kn_d0o_oo0?koo`3ko?`0o_oo0?WjnP3nool0ooko0?ghnP3o
oOd0ooOh05mDEP0C20X0o?7g09R?U00<1@X0j>KY0?koo`3lool0nooo0?[oo`3nool0nocn0?[ioP3f
mOX0ooko0?_jo`3nool0nocnM03oool20?ono@<0ooko00D0oOgk0?ooo@3mo_h0o?oo0?Ojo`020?_o
o`080?_oo@3nooT0oogc0?ojlP3jn?/0nOco0?kno`3kno/20?oon0040?_oo`3iool0o?oo0?ooo`<0
ooko503oool00;00oooo00L0oO_n0?ono`3in?/0ooko0?gnoP3loOd0n?Wi0080o_oo0140o?gm0?kl
o@3ooOl0oo[j0?oko03on_`0k>7S07]bM`0J4aP0al;60;bk_P3in_`0o?oo0?_oo`3ho_h0o_oo0?_l
oP020?ono`040?kmo`3oo_l0mOKh0?koog@0oooo01X0ooko0?ooo`3ooo/0oook0?ooo`3noOl0n_Wn
0?ono`3noo/0oOoj0?[ko@3lool0l_[j0?kon`3om^d0oo_d0?ono`3lool0o_ko0?kmo`3oo_X0oooh
0?_oo`3iool0o?oo0?ooo`<0ooko503oool00;00oooo00@0ooko0?[hn`3mo?l0ooko0P3nool05P3i
n_X0o_oo0?koo`3kno/0ooko0?_inP3ooOd0o_Sh0?ojn`3on_h0YIbQ01TB5`3ak?00nOSk0?koo`3l
ool0mogm0?coo`3in_`0o_oo0?kmo`3gm_T20?ono`0300000P3nool0oooo06l0oooo0P3oood01`3o
ool0ooko0?ono`3oo_l0oooj0?oon03no_h00P3oo_l04`3jn?/0oooe0?oomP3oo_l0nOSn0?Woo`3j
o_d0gmS@01T@2`36al/0nOgo0?[mo`3oo_l0ookj0?oonP3kool0nOoo0?coo`3oool00`3oo_lD0?oo
o`00/03oool0803ooOl0ooko0?ono`3mo?l0n?Wi0?_lo01LGEd0moSh0?ooo`3no_h0n_Si0?ono`3o
o?`0oogm0?olo@3oo?l0b/7601L@5`3glOP0ooko0?koo`3joOl0n_ko0?_oo`3mo_l0o_oo0?Win@3o
o_l0oooo0?7al@0720P0noclL`3oool02@3oo_l0o_oo0?koo`3nooX0o_oh0?ooo`3mo?l0oO[o0?om
o`020?onm00@0?oko03ooOl0nOoo0?Omo@3oo_P0TXZ70<S8cP3kool0m_Wo0?koo`3oo_X0oooj0?_o
o`3iool0o_oo0?ooo`80ookm00<0ooko0?ooo`3oool04P3oool00;00oooo01D0ooko0?cjo@3jnO`0
inKY0;Vj^P3mo_h00`@40?koo`3moOd0oooo0?ono`3imoP0oOSh0?omo@3on?T0oo[m08b3R00700L0
Ui6H0=CCf03nool00P3lool01@3ho?d0o?go0?ooo`39alP0d]3A0080oooo00<000000?cmo@3oool0
LP3oool30?koo`80o_ok01T0o_om0?_kn`3ooOl0oogm0?ojm@3on?40oo_k0?oioP3iool0l?Ok0?[f
l`3Idm40P8>80?Soo`3kool0nocn0?onnP3oooX0nooo0?Woo`3nool0oooo0?omo@3oo_d0ooko01@0
oooo002`0?ooo`080?Sfn@3oo_l0no[m0?ono`12@T80TI6A0000003nool20?ooo`0F0?[hn@3no?d0
oogm0?okn`3ooOd0W9FH0109403Fd=P0ZjR^00h=4P3^ko<0o?oo0?Chn@3lool0o_oo0?Win@3Qgn00
61HE0=gKfP3gmoD000400?kooG00oooo0P3oo_l0103oool0o_oo0?koo@3lood20?coo`0I0?koo@3l
oOL0o__d0?kfl`3onod0oo[m0?ojn03onOL0n?oo0?Koo`3oo_d0m>o_04U=E03bn_l0nooo0?cmo`3o
o_X0oooj0?_oo`3iool0o_oo0?ooo`3ooOd0ookm0?ono`0D0?ooo`00/03oool02P3oo_l0noWl0?on
o`3oo_l0fMWI01<C4`041@D0oOkn0?gmo@3oool20?ono`050?olo03nnOT0oogm0?olo`3on_l00P3o
o?l03@3nool0noco0?coo`3lool0o_oo0?knoP3oool0ookm08f;RP0n?3/0ooom00@40P3nood0L03o
ool20?ono`0O0?koo`3nood0o?ok0?coo@3kool0o?oo0?koo@3oooP0oood0?O`j00W6Ql0nn[`0?oa
j`0R6A@0H6Qb0?7mo`3in?/0ookm07n6S03AfN40nooo0?koo`3oo_X0oook0?_oo`3iool0o_oo0?oo
o@3ooOd0oook0?ono`0D0?ooo`00R03oool0103lo?`0oooo0?ooo`3kno/20?ooo`030?clo03oool0
o?cl0080oooo00@0no_k0?ooo`3oool0o?cl0P3oool00`3moOd0o?cl0?ooo`020?ooo`030?Win@3o
ool0oooo00l0oooo01<0o?_n0?ono`3noOl0ooko0?knoP26QXH010@4000000020P80000000410@00
00000P000040000200000`0000<00P0300@00@0400<0000400@0004200000P0000000@000P050000
1@010000XZ:P0000003nood0no_k00@0oooo00<0o_kn0?gmo@3oool0J03oool20?ono`040?koo`3n
ood0o?ok0?coo@80o?oo01T0o_om0?oon03ooo<0ookf030Q9P2lZjl0ooS`04Y1?027T9/0d]k/0?km
o`3^k>d0B4mC08nHW@3hoOl0o_oo0?onnP3ooo/0o?oo0?_oo`3nool0ooom0?omo@3ooo/0ooko01@0
oooo002:0?ooo`040?KfmP3oool0n?Sh0?Ogm`@0oooo00@0m_Kf0?ooo`3hn?P0moOg0P3oool01P3h
n?P0o_kn0?ooo`3kno/0oooo0?gmoA80oooo0P3oo_l02P3noOl0ooko0?_kn`3jn_X0:RXZ0:VYZ@3k
no/0oooo0?Cdm03oool20?ono@060?omo03oo_l0oogo0?omo`3oo_l0o_oo0`3lool02@3nool0oooo
0?ono`3ooOd0nOCd0=CBd@0B4Q001@D10?koo@020?ooo`80oOgm00<0oooo0?knoP3no_h0J`3oool2
0?koo`80o?om01P0o?oo0?koo`3knoT0oooj0?oll`3oo?@0YYZJ028B4P3on_@0Uhn=07b5U03dool0
oOco0?ono`3bnOd0n?oo0?KkoP3nood0ookj0?oon`3lool0nooo0?koo`3oool20?oon`030?ooo@3o
ool0oooo0180oooo00280?ooo`0408n?S`3dm?@0oooo0?gmo@<0oooo00D0no_k08n?S`3dm?@0oooo
0?gmo@030?ooo`060?_kn`3oool0YJFU0?ooo`3moOd0o_kn0P3oool00`3no_h0oooo0?ooo`0>0?oo
o`040?[io03oo_l0ooko0?ono`80oooo00@0`/;201lO7`3Zj^X0n?Sh0P3oool0103oood0no_i0?gm
n`3oool30?ono`030?koo`3lool0o?oo0080o_oo00P0oooo0?ono`3oo?`0oocl0?ono@1aLFl00000
0?cnn`80n_[j00H0no_k0?ooo`3oool0oooo0?clo03moOeZ0?ooo`@0o_oo01P0o_om0?kon`3oool0
n?Kg0?omo`3ooOX0elc400X0002VV9<0hmcQ00`D9`3Rkol0ooko0?omoP3kool0mOco0?coo`3moO/0
oogj0?onn`3lool0nooo0?coo`3oool20?oon`030?ooo@3oool0oooo0180oooo00280?ooo`0?0;6a
/@0i>CT0l?3`0?ooo`3moOd0o_kn0?Shn03oool0/K6a03Ti>@3`l?00oooo0?gmo@3no_h0n?Sh0080
oooo00L061PH08>3P`3kno/0oooo0?knoP3oool0o?cl0100oooo00@0o_go0?ono`3hmoX0no[m0`3o
ool01P1TI6@0JVYZ0?ooo`3kno/0oOgm0?Ogm@80ooom00<0n?Sf0?omoP3noOl00P3mo_l20?_oo`04
0?gnoP3no_h0oogn0?ono`80oo_k00@0ookm0??cl@071`D0]kVf0`3oool20?gmo@80o_knJ@3oool2
0?ooo@@0o_oo01P0o_ok0?oonP3imoP0oogo0?olo`3oo?`0mnoR018:001VFeL0YZ2X00087@3]mol0
n_Wo0?omoP3kool0mOgo0?coo`3ooo/0oogj0?onn`3lool0nooo0?coo`3nool20?oon`030?ooo@3o
ool0oooo0180oooo00280?ooo`040?gmo@1kNg/0:RXZ0=kNgP80o_kn00H0oooo0?Ogm`3moOd0Ng]k
02XZ:P3Ng]h20?knoP090?ooo`3gmoL0oooo0>g]k@0k>c/0H61P0?Cdm03oool0moOg0140oooo00@0
o?_n0?ono`3oo_l0ooko0P3oool0201BDU80m_Kf01/K6`2o_kl0o_kn0?ooo`3lo_/0oOol0P3nood2
0?ooo`80o_oo0P3lool0103nool0oooo0?gko03on_`20?omo`070?Kdm@3moOd0000002<T903_knl0
o_kn0?ooo`020?[jnV/0oooo0P3nood20?koo`80ooko01P0oook0?oonP3oo_l0ooco0?ojo`3oo?`0
ZjNI03dg9`3:`[d0QhJ<024[@03SkOl0ooko0?[em@3gno`0nOoo0?koo@3oooX0oogh0?omn`3lool0
nooo0?coo`3nool20?oon`030?ooo@3oool0oooo0180oooo00280?ooo`050?knoP3lo?`0Shn?01XJ
6P3>c/h00P3oool20?knoP040?clo02?Shl06QXJ0<k>cP80oooo00L0o_kn0?ooo`3emOD0l_;b05=C
D`17AdL0k^k^0180oooo00h0ooko0?kmo`3oo_l0ooko0?gmo@3no_h00`<30?ooo`3QhN40^[Zj0?oo
o`3fm_H0o_om0?cnn`80o_om0P3moOd20?cmo@80n_km00h0o?gm0?gmo@3oo_l0oogo0?cgn@3mn?X0
ooko0?ooo`000000c/o?0=cLg03bl_80oooo0?knoP<0oooo00<0no_k0?ooo`3oool0IP3oool30?ko
o@0K0?koo`3oo_l0ooko0?ono@3ooOd0oogo0?_fnP3ooOl0oogm0?Gbj@3ooo@0oogf0?koo`3eool0
lOWo0?omo`3ooOd0o?oo0?_oo`3nood0o_gh0?omn03ooO/0o?oo0?_oo`3lool0o_oo0080oook00<0
ooom0?ooo`3oool04P3oool008T0oooo00D0oOgm0?ooo`2[Zj/06a/K0;6a/@030?ooo`050?gmo@3o
ool0Zj^[01/K6`2a/K400P3oool0203jn_X0oooo0?ooo`3fm_H0IFEU038b<P3^k^h0n_[j403oool2
0?ono`080?_jo@3oo_l0oooo0?ooo`010@40n_[j0?ooo`3kno/20?ooo`040?koo@3lo_/0o_om0?ko
o@80ooom00l0o_om0?coo@3lood0o?om0?koo`3oool0ooko0?ghnP3oo?l0oogo0?_inP3inOT010@4
0?Cem@3lo?`00`3oool20?knoP030?gmo@3oool0oooo06L0oooo0P3nood20?ooo@0M0?ono@3oo_l0
ooco0?oko`3oo?l0oocl0?onn`3glo00M6ma0?[hm`3oooP0n?ck086<WP3@f>d0o__o0?olo03nool0
n_km0?WkmP3oooX0oogh0?omn`3lool0nooo0?coo`3nool0ooom0?oon`3oood0503oool008T0oooo
00H0n?Sh0?ooo`3oool0_[jn01lO7`2NWYh20?ooo`060?Shn03oool0oooo0;jn_P0O7al0WYjN0`3o
ool01P3gmoL0oooo0?ooo`21PH406QXJ0=oOg`l0oooo00d0ooom0?onn`3oo_d0nooo0??jo`3nool0
o_cm0040003oo_d0o_oo0?gnoP3oo_d0oogl0080o_om00H0o_oo0?_lo03no_h0o_kl0?goo03koo`2
0?goo0040?gnoP3no_h0ooko0?ojo080oogo00P0oogn0?ooo`010@40o_oo0?ooo`3no_h0no_k0?kn
oP80oooo00<0oOgm0?ooo`3oool0I`3oool20?koo@80ooom01P0ookm0?ono`3oo?l0ooco0?omo`3o
o_/0oo_g0?onn`2c/;H0Q8:50?kmmP3Be=40EEaZ0?Smo`3ooOl0oogm0?gnoP3kooh0o_om0?onn@3o
oOX0ookk0?koo`3lool20?koo`80ooom5@3oool00400oooo00H0o?cl0?ooo`3oool0n_[j0?ooo`3k
no/:0?ooo`080?[jnP3no_h0oooo0?clo03oool0oOgm0?ooo`3no_hb0?ooo`070?[jnP3oool0oooo
0=KFeP0L71`0S8b<0?[jnP020?ooo`080?knoP3lo?`0g=cL01HF5P2:RXX0no_k0?ooo`3gmoL20?oo
o`060?gmo@2LW9`061PH0<_;b`3oool0nOWi0P3oool00`3kno/0oooo0?ooo`040?ooo@<0o_om00T0
o?_f0?oml@3oo_L0jogo0?3oo`3inol0ooco0;N^[`3ln?D00P3lool00`3oo_/0ookj0?oon`020?ko
o`80ooko0P3oool00`3nool0oooo0?ooo`030?ooo`80ooko00@0oO_l0?ooo`3lo?`00`<30P3moOd0
103no_h0oooo0?ooo`3moOd20?ooo`050?clo03jn_X0oooo0?knoP3lo?`00`3oool00`3no_h0oooo
0?ooo`0f0?ooo`050?clo03oool0oOgm0?ooo`3inOT0103oool01P3lo?`0oooo0?gmo@3no_h0oooo
0?KfmQT0oooo103nool20?ooo`<0ooko0`3ooOd01P3im?P0E4mA0=KAd@0_;Bh0l?3f0?ShoP80ooko
00/0oooo0?koo`3oool0o_kl0?Sfm@3oo_d0oOco0?koo`3mo?l0oooo0?Win@020?ooo`030?_kn`3o
ool0o?cl00<0oooo00<0no_k0?ooo`3oool02`3oool00440oooo00<0moOg0?knoP3oool00P3moOd0
0`3oool0o?cl0?knoP070?knoP80oooo0P3kno/0103moOd0oooo0?[jnP3oool`0?knoP0;0?_kn`3n
o_h0oooo0?clo03moOd0oooo0>SXj00V9RH0Lg=c0?Gem@3kno/00P3oool0103kno/0jNWY030`<01[
Jf/20?ooo`0=0?_kn`3no_h0oooo0?ooo`2a/K405ADE0;6a/@3oool0moOg0?ooo`3no_h0oooo0?cl
o0030?ooo@0=0?_kn@3nood0moWf0?_mnP3oo_X0ooga0?_hl@3`ool0k_oo0?Oio`3onOl0oocj0?oo
n`020?[oo`040?omnP3ooOL0o_oi0?goo080oOgo00<0o_go0?knoP3no_h01@3no_h00`3jn_X0oooo
0?Ogm`020?ooo`030?gmo@3lo?`0o?cl00@0oooo00`0oOgm0?clo03oool0oooo0<k>cP20P800o?cl
0?ooo`3jn_X0oooo0?gmo@3ooolh0?knoP030?ooo`3inOT0oooo0080oooo00P0oOgm0?ooo`3lo?`0
o_kn0?ooo`3no_h0oooo0?Ogm`80oooo00<0oOgm0?knoP3no_h05P3no_h40?gnoP@0o_kn00<0nOOh
0?ono`3jmOL00P3ooOl0103XhnD010000;>^/03knOX20?ooo`0<0?knoP3moOd0o_kn0?clo03gmoL0
HV9R06=SH`3fm_H0no_k0?clo03inOT0oooo0P3moOd30?ooo`030?[jnP3kno/0o_kn00h0oooo0011
0?ooo`050?Ogm`3oool0oooo0?knoP3oool00P3no_h90?ooo`070?Shn03lo?`0oooo0?ooo`3kno/0
oooo0?Win@0a0?ooo`0:0?clo03moOd0oooo0?Shn03moOd0o?cl0?Shn012@T80DE5A0?Ogm`80oooo
00H0o?cl0?ooo`3[jn/0ADE50451@@3fm_H20?ooo`070?clo03no_h0oooo0<O7a`0I6AT0WinO0?oo
o`020?knoP060?Cdm03oool0no_i0?ooo@3knoT0o?cj0P3oood0403jn_P0ookj0?oimP3oo_d0logo
0>olo`3no_l0ooko0?ono@3koOX0nooo0?coo`3ooOl0oogk0?oonP3ooo/20?coo`030?koo`3oool0
oooo00P0oooo00@0n_[j0?_kn`3oool0moOg0P3oool20?clo0<0oooo0P3moOd0103inOT0A4A408B4
Q03inOT20?ooo`030?clo03oool0oooo03L0oooo00D0o_kn0?ooo`3fm_H0oOgm0?ooo`020?clo080
oooo00<0o?cl0?knoP3oool00`3oool00`3inOT0oooo0?ooo`0F0?ooo`@0o_oo103oool20?ono`07
0?omo`3on_`0oogo0?oloP3Of]`0oo[l0?ono`020?ooo`0B0?knoP3oool0oooo0?ooo`3lo?`0a<C4
000000061PH0UIFE0?Cdm03oool0m_Kf0?ooo`3no_h0oooo0?[jnP3oool0oOgm403oool00400oooo
00D0moOg0?gmo@3oool0n?Sh0?knoP030?ooo`P0o_kn00P0oooo0?Win@3oool0nOWi0?gmo@3oool0
nOWi0?oooc00o_kn00<0oOgm0?ooo`3emOD00P3oool02@3jn_X0oooo0?_kn`3fm_H0GUiN03Xj>P3[
jn/0oooo0?Win@020?ooo`060?clo01TI6@0?3`l0>g]k@3lo?`0n?Sh0P3oool0103lo?`0g]kN01LG
5`21PH430?ooo`050?knoP3moO/0ooom0?gmn`3knoT00P3oood04`3no_`0oooo0?ono`3nool0n?ck
0?coo@3oool0n?Sh0?koo`3iool0n_oo0?gmo`3onol0oo_n0?onm`3nooT0nooo0?[oo`3mo_l01`3n
o_h02@3lo?`0o_kn0?ooo`3oool0nOWi0?gmo@3oool0n?Sh0?gmo@020?ooo`030?clo03no_h0oooo
00<0oooo00D0inOW018B4P3Ph>00oooo0?KfmP020?ooocP0o_kn00L0oooo0?_kn`3oool0oooo0?_k
n`3oool0no_k0080oooo00L0no_k0?ooo`3oool0oooo0?Ogm`3kno/0oooo01P0o_kn103mo_h40?kn
oP80ooko00P0noKh0?omo`3oo?h0oo[l0?omo`3ln_/0o_cm0?gmo@80o?cl01@0o_kn0?ooo`3oool0
o_kn0?ooo`2d];@00@4100P820000000@T920;6a/@3Ph>00oooo0?gmo@3oool0no_k0?Win@3oool0
o_kn0?clo0d0oooo00110?ooo`050?clo03kno/0oooo0?ooo`3gmoL02P3oool0203inOT0oooo0?kn
oP3oool0mOGe0?7al@3oool0oOgm<03oool0103moOd0no_k0?gmo@3gmoL50?ooo`0=0?knoP1nOWh0
7QhN0?KfmP3oool0n?Sh0?knoP3jn_X0oooo07IfMP0V9RH0oOgm0?clo0030?ooo`040?clo03`l?00
=CDe05]KF`80oooo00<0n_[j0?ooo@3jn_P00`3oood04@3dm?80ooom0?koo`3inol0mo[o0?onn@3o
ooH0nOSd0?koo`1BF5P0nOoo0?coo`3oo_l0oo_o0?olo`3oo_P0oooh0080nooo00<0o_oo0?ooo`3o
ool01`3oool01`3fm_H0oooo0?ooo`3no_h0oOgm0?ooo`3moOd00`3oool02@3no_h0o?cl0?Win@3k
no/0o_kn0?Shn02HV9P000000?Shn0020?ooo`030?Ogm`3oool0oooo03H0oooo00l0no_k0?ooo`3a
lO40moOg0?ooo`3lo?`0oooo0?Win@3kno/0oooo0?gmo@3fm_H0n?Sh0?ooo`3moOd06@3oool40?ko
o`@0oooo0`3oo_l0103imoP0oogo0?omo`3oo?h20?ono`H0oooo00D0o_kn0?ooo`3fm_H0Vi^K010@
40020000000900D51@0<30`03`l?03/k>`2@T900Xj>S0<S8b03]kNd0oOgm00h0oooo00100?ooo`03
0?Ogm`3oool0o_kn0080000000<01`L7000000010@40200000001`030`<000000000000000003@d=
0000000410@0<@0000001P051@D00000000000071`L0000000<30`D0000000@00@41000000010@40
0@410P020P802@0000001@D5000000010@400P82000000020P80000000P820050000000300P82001
0@000@4000<0000000/010@20082000000@0004>00D74@0710001000004000000000008200031@02
00001@0700@01`0600801P0000<000000P00008400000P080000000300<30`0:2PX0000000800000
0P010@40100000000@4100000000000200@41006000000051@D0000000@4100000000P820`000000
0`071`L000000000000f0000000400410@071`L0000000P8208000000P051@D300000080oooo00<0
m_Kf00820P000000800000030040000500<10P0910H00`0000<0000100000P00000200410@@00000
00<010@40000000000000P0000001`0820P01PH60000000000003`l?000000010@400P0000000`2Y
ZJT0oooo0?ooo`0<0?ooo`00@@3oool01@3inOT0oooo0?ooo`3no_h0o?cl0080oooo203no_h0203k
no/0oooo0?ooo`1TI6@0000000410@0b<S80oOgm<03no_h0103jn_X0no_k0?ooo`3jn_X20?ooo`07
0?[jnP3oool0oooo0?[jnP3oool0oOgm0>SXj0040?ooo`80n_[j00L0oooo0=oOg`3oool0oooo0?cl
o03oool0nOWi00D0oooo00@0nOWi0?gmn`3oood0nOOf0P3oo_d0503imoH0h^3O0>[Yk03fm_l0o_ko
0?oon`3ko?@0ooom0?koo`000P00nooo0?[oo`3moOl0oo_o0?okoP3ooOL0ookg0?_oo`3jool0oOko
1`3no_h02P3moOd0no_k0?knoP2i^KT0V9RH06ATI01dM7@0Y:BT0=OGe`3jn_X30?ooo`0;0?knoP3l
o?`0oooo0?knoP3lo?`0n_[j00@4100M7Ad0jn_[0?ooo`3jn_X0>03no_h01@3gmoL0<30`00000001
0@40JVYZ0080oooo00D0m_Kf0?gmo@3oool0oooo0?Cdm0020?ooo`030?gmo@3oool0o_kn01L0o_kn
103mo_h50?knoP040?ooo`3mno`0o_cm0?OemP<0ooko0P3moOd30?ooo`070?knoP3oool0oooo0?Sh
n03oool0Vi^K00H61P020000000800P820030`<04a<C0410@023Ph<0XZ:R0<[:bP3Rh^8?0?ooo`00
@03oool0103moOd0oooo0?clo03moOd20?ooo`030?Win@3oool0oooo00P0oooo00L0nOWi0?ooo`3=
cLd0000000H61P020P80N7Qh0380oooo0P3no_h02`3lo?`0oooo0?ooo`3lo?`0oooo0?knoP3moOd0
oooo0?clo03oool0n_[j0080oooo00T0o?cl0?ooo`3oool0oOgm0?clo03oool0oOgm0?ooo`3jn_X0
0P3oool02P3lo?`0oooo0?ooo`3oool0ooom0?Ogm@3oo_d0n?Ke0>g[jP16A4<20040000>030^<@3P
gn80n?kn0?Woo`3nool0m_Gh00H71`3jo_d0nooo0?coo`3ooOl0oocm0?onn03oooX20?coo`030?ko
o`3oool0oooo00H0oooo00X0k^k^04m?C`0_;bl0J6QX09jNWP23Ph<0EeMG01DE5@2>SXh0l?3`203o
ool00`000000LG5a05YJFP0j0?ooo`07071`L0010@401@D500410@3<c<`0oooo0?[jnP040?ooo`03
0?gmo@3oool0no_k01X0oooo103nool50?ooo`040?Win@3oo_l0ooko0?cjn`80ooko00<0o_cm0?oo
o`3oool01`3oool03`2][Jd00@4100`<30061PH0?3`l0:j^[P3UiND0o_kn0?gmo@3oool0o?cl0?oo
o`3no_h0oooo0?Shn00=0?ooo`00D@3oool0103moOd0o?cl0?ooo`28R8P3000000040;fm_@3oool0
n?Sh0?clo080oooo00<0o?cl0?ooo`3oool0A`3oool30?ono@0Z0?Sfm@2_[J`02@L60>;Mg@3onOL0
OGA]00`81@3]nol0kooo0?cno`3onol0[jZZ0?kno03jool0nOoo0?omo@3ooOX0oooj0?oon`3loOl0
oOgo0?kmo`3moOd0oooo0?[jnP3oool0o_kn0?_kn`3oool0emOG0000001fMWH0nOWi0?knoP3oool0
no_k0?ooo`3Zj^X0ADE500X:2P3jn_X0o_kn0P3oool02`3no_h0dm?C0?_kn`3oool000000?Gem@0O
7al0^[Zj0?_kn`3no_h0oOgm00@0oooo00@0oOgm0?knoP3no_h0oOgm103oool0103moOd0o_kn0?kn
oP3moOd40?ooo`040?gmo@3no_h0o_kn0?gmo@@0oooo00@0oOgm0?knoP3no_h0oOgm103oool0203m
oOd0o_kn0?clo03oool0n?Sh0?ooo`3no_h0no_k0`3oool02`3no_h0oooo0?gmo@3oool0o?cl0?kn
oP2b/[80000000410@020P80T92@02@0oooo0P3nool@0?ooo`0=0?knoP3oool0oooo0?ooo`3moOd0
no_k0;no_`0000002@T908^;R`3bl_80nOWi0?knoP0F0?ooo`00D03oool20?_kn`080?ooo`3inOT0
nOWi04i>CP0000001@D501/K6`3Zj^X20?ooo`040>g]k@3kno/0oooo0?_kndP0oooo01H0oogl0?gk
nP3oo_d0ookm0::PW`0e<c80o_Wi0?oim03om>L091lG0:2c_`3]ool0o?ko0?oko`3ooO/0oo_h0?Wo
o`3kool0o_[f0?onn03oooX0n_ci0`3oo_l20?ooo`80no_k0P3oool01`3clo<09RHV0:>SX`3lo?`0
oooo0?clo03no_h00`3oool03@3moOd0000007alO03oool0moOg0?clo03oool0Ng]k00X:2P3gmoL0
00000?ooo`3no_h0103oool0103kno/0oooo0?ooo`3kno/40?ooo`040?_kn`3oool0oooo0?_kn`@0
oooo00@0no_k0?ooo`3oool0no_k103oool0103kno/0oooo0?ooo`3kno/40?ooo`040?_kn`3oool0
oooo0?_kn`<0oooo00<0lo?c0?ooo`3no_h00`3oool01@3hn?P0oOgm0?ooo`3oool0o_kn0080oooo
00H0g=cL01@D50061PH0000005=CD`3no_h20?ooo`030?Shn03oool0oooo01l0oooo0P3nool@0?oo
o`090?knoP3oool0oooo0?ooo`3no_h0no_k069RHP1mOGd0iNGU0080oooo00<0o_kn0?ooo`3hn?P0
5@3oool00540oooo00/0moOg0?ooo`3moOd0o?cl0>OWi`0N7Qh0000000<30`13@d<0oOgm0?Win@02
0?ooo`030?clo03oool0oooo04D0oooo0P3oo_l20?ono@0H0?omo@3lmoL0aL3000l:2P3gl_80oogh
0?okk01nMfd0Efik0>Woo`3ko_l0oO?k0?ohm`3oo_X0mOgk0?Ooo@3oooP0ookf0?konP3lood0oOco
0?cho`3oo_l0moOg0`3oool01`3fm_H0oooo07alO01MGEd0n_[j0?ooo`3gmoL00P3oool01`3kno/0
oooo0?ooo`3lo?`0lO7a01hN7P31`L400P3oool02`3no_h0n_[j014A4@1CDe<010@40?clo03oool0
n?Sh0?gmo@3kno/0oOgm00@0oooo00@0oOgm0?_kn`3kno/0oOgm103oool0103moOd0no_k0?_kn`3m
oOd40?ooo`040?gmo@3kno/0no_k0?gmo@@0oooo00@0oOgm0?_kn`3kno/0oOgm103oool02@3moOd0
no_k0?ooo`3oool0o_kn0?ooo`3lo?`0o_kn0?_kn`020?ooo`060?gmo@3oool0oooo0?Win@3jn_X0
?Cdm0P0000000`0W9bL0kno_0?Shn0020?ooo`030?Gem@3oool0oooo0340oooo00X0o_kn0?ooo`3o
ool0oooo0?knoP3lo?`0mOGe0?Shn03oool0oOgm0P3kno/G0?ooo`00D03oool01`3kno/0oooo0?_k
n`3no_h0oooo0?clo02i^KT00`000000102BTY80o?cl0?ooo`3lo?a80?ooo`80ooko0100moGd0?on
o@3ooOd0oogm0?G`l00D3`l0^;>c0?omn03onNX0YZ6G01D[=P3Wool0o?ko0?oko`3ooO/0oOWe0P3i
ool02P3oo_X0oocf0?gnn03lood0ooko0?omo`3oo_l0o_kn0?ooo`3jn_X20?ooo`030?gmo@0Y:BT0
clo?00@0oooo00T0o_kn0?_kn`3oool0oOgm0?ooo`3fm_H0OGem08>3P`3hn?P00`3oool00`2k^k/0
000000820P070?ooo`80oOgm1P3oool20?gmo@H0oooo0P3moOd60?ooo`80oOgm1P3oool20?gmo@<0
oooo00/0n?Sh0?_kn`3no_h0o_kn0?gmo@3oool0n_[j0?ooo`3no_h0oooo0?Gem@020?ooo`0507Ee
M@0000002@T900<30`39bLT00P3oool0103hn?P0o_kn0?ooo`3lo?`b0?ooo`060?knoP3oool0oooo
0?ooo`3no_h0oOgm0P3oool00`3inOT0oOgm0?ooo`020?clo1H0oooo001@0?ooo`0?0?[jnP3oool0
oooo0?ooo`3no_h0oooo0?clo01kNg/0000000820P030`<0c<c<0?[jnP3oool0mOGe0440oooo0P3n
ool40?ooo`80ooko01/0ookm0?kln`3ono/0oocl0?omo@2YXj<010000;6YYP3Hbl<09R8N06=dN`3]
ool0o?ko0?omo`0^:BT0PH5o07InOP1oQHD0o_[g0?omnP3oooX0n_cg08:3Q`1lNh40O7]n08>3P`3i
nOT00`3oool0101fMWH02@T907QhN024Q8@20?clo00G0?_kn`3oool0QhN707]kN`1mOGd0O7al0?oo
o`2PX:00EEEE0?ooo`1mOGd0NWYj0861P@1kNg/0D51@0000003no_h0oooo07YjNP20P800O7al08>3
P`3kno/00P3oool01P3kno/0Ph>307alO01lO7`0Ph>30?_kn`80oooo00H0no_k08>3P`1lO7`0O7al
08>3P`3kno/20?ooo`060?_kn`23Ph<0O7al07alO023Ph<0no_k0P3oool01P3kno/0Ph>307alO01l
O7`0Ph>30?_kn`80oooo00D0no_k08>3P`1lO7`0QXJ607moO`040?ooo`0?0?gmo@3jn_X0oooo0?_k
n`3oool0n?Sh0;Vi^@0000002PX:0000002=SHd0oooo0?clo03oool0oOgm0080oooo00<0o?cl0?oo
o`3oool0903oool:0?koo`L0oooo00@0o_kn0?_kn`3oool0o_kn103oool00`3emOD0oooo0?ooo`0C
0?ooo`00D@3oool0303hn?P0oooo0?[jnP3oool0nOWi0?ooo`3bl_80<S8b00H61P030`<08R8R0??c
ld<0oooo0P3nool40?ooo`80ooko01X0oO_j0?ono@3ooOd0o_Wi0?oin@3ooOd0^kFe01PB4P040000
FeUJ0>?/k`3gool0o_oo0?klo`061P@0OGin07^0P`1jOH40oogo0?olnP3ooOT0oooj07amP@1nOX@0
P7n207alO080oooo0P3inOT0101dM7@04A4A07emO@1lO7`30?ooo`0F0?Win@1kNg/0PH6107moO`21
PH40oooo0=;BdP0Y:BT0oOgm07YjNP28R8P0NWYj0820P03^k^h020P806UYJ@3oool0O7al0820P01o
Ogl0OGem0?ooo`80o_kn00H0oooo07emO@1oOgl0Ogmo07emO@3oool20?knoP060?ooo`1mOGd0Ogmo
07moO`1mOGd0oooo0P3no_h01P3oool0OGem07moO`1oOgl0OGem0?ooo`80o_kn00H0oooo07emO@1o
Ogl0Ogmo07emO@3oool20?knoP060?ooo`1mOGd0Ogmo07UiN@24Q8@0no_k0P3oool0403moOd0oooo
0?ooo`3oool0o?cl0?ooo`3/k>`030`<0000000410@0CDe=0?clo03oool0no_k0?ooo`3lo?`Y0?oo
o`X0o_oo203oool01P3no_h0o?cl0?knoP3oool0o?cl0?gmoAL0oooo001A0?ooo`030?Win@3moOd0
oooo0080oooo00X0o_kn0?ooo`3IfMT02`/;000000051@D0GUiN0?ooo`3hn?P0o_kn@03oool20?ko
o`@0oooo0P3oo_l01`3ooOd0nOCd0?cgm`3ooOd0ooWi0?olo03ooOd00P3ooOl02@3no_l0o_ok0?oo
nP3oood0n__k00030P3goOd0nooo0?kno`020?olo`050?omnP3oooP0o?oo0?coo`3ko?h00P3oool0
3P3jn_X0oooo0?ooo`3kno/03@d=0?;blP3oool0nOWi0?[jnP3oool0oOgm0?ooo`3inOT0oooo0P3k
no/01@2JVYX0Hf=S0?gmo@3oool0moOg0080oooo00H0o_kn00@410000000h>3P0?ooo`3fm_HZ0?oo
o`030?clo03oool0oooo00@0oooo00/0no_k0?Shn00m?Cd0000000@4100K6a/0k>c/0?ooo`3moOd0
oooo0?knoP030?ooo`030?_kn`3oool0oooo02@0oooo2P3nool90?ooo`070?knoP3oool0oooo0?cl
o03no_h0oooo0?[jnP0E0?ooo`00D03oool01@3moOd0oooo0?ooo`3jn_X0oooo0080oOgm0P3oool0
1@2VYZH00000000000000000Y:BT03`0oooo00<0ooko0?ooo`3oool00P3oool00`3oood0o_oo0?ko
o`060?ooo`0J0?oloP3ooOd0oogo0?omo`3oo_l0o?[k0?omo`3knO`0o?ko0?coo`3lnoH0ooof0?km
n@3nool000H40?_oo`3joOl0ooko0?oio`3onol0ooci0?glm`3nool0n_ko0?koo`3dm?@20?ooo`0:
0?_kn`3oool0no_k03Lg=`2l_;`0oOgm0?ooo`3jn_X0o?cl0?knoP<0oooo00H0oOgm0?ooo`1[Jf/0
PX:20?ooo`3no_h20?ooo`0:0?Win@3oool0000002XZ:P0];Bd0no_k0?ooo`3moOd0oooo0?clnP80
o_kn00H0o?cl0?ooo`3moOd0oOco0?ono`3lo?`20?knoP060?clo03oool0oOgm0?gmo@3oool0o?cl
0P3no_h01P3lo?`0oooo0?gmo@3moOd0oooo0?clo080o_kn00H0o?cl0?ooo`3moOd0oOgm0?ooo`3l
o?`20?knoP050?clo03oool0oOgm0?ooo`3kno/00`3oool00`3moOd0oooo0?knoP020?ooo`0=08>3
P`0000000`<300820P31`L40oooo0?knoP3oool0moOg0?ooo`3kno/0oooo0?knoP0W0?ooo`X0o_oo
2@3oool0103jn_X0oooo0?clo03oool20?knoQH0oooo001H0?ooo`030?gmo@3oool0HV9R00800000
00L03@d=0>7Qh@3inOT0no_k0?ooo`3no_h0o?cl0080oooo00<0o?cl0?ooo`3oool0803oool0203n
o_h0oooo0?ooo`3oool0no_k0?ooo`3kno/0o_co0P3oo_l0103ooOh0ooom0?ooo@3mo_h30?koo`0>
0?cmo`3nool0o_oo0?gnoP3oood0oOgi0?koo@3lo_/0ooko0?cjo@3oood0oOol0?_oo`3jo_l20?ol
o`0=0?omo`3oo_l0n_ko0?WmoP3noOl0oogo0?kmo`3nool0oOgk0?kmn@3oood0o_kn0:FVYP020?ko
o`<0ooko00@0ookm0?ooo@3oool0o_oo0P3oool0503kno/0oooo0?ooo`3oool0oOgm0;>c/`0I6AT0
no_k0?[jnP3lo?`0oooo0?knoP3moOd0oooo0?_kn`3oool0`L7101PH603dm?@0m_Kf0`3oool03@3k
no/0oooo0000003UiND03@d=0:n_[`3moOd0ookm0?[hm`2UYJ40emOE0?gkoP3oo_l00P3nood0103o
o_l0oOco0?koo@3nood20?ono`030?_kn`3oood0oooo01L0oooo00L0o_kn0?ooo`3no_h0o?cl0?oo
o`3kno/0o?cl0080oooo00L0_Kfm0000000410@0000008J6QP3oool0oOgm05d0oooo001I0?ooo`09
0?gmo@3`l?009bLW00H61P000000=cLg0?clo03oool0moOg0080oooo00@0no_k0?gmo@3oool0o_kn
803oool0103moOd0oooo0?knoP3kno/20?ooo`040?Shn03oool0ooko0?gkoP80oO_l0P3oood00`3c
m?@0o_oo0?_loP030?koo`060?cmo@3no_`0oook0?oon`3loo/0mo_h0P3oo_l0203oood0oOgi0?[k
n`3nool0oogo0?olo`3kn_d0n__k0P3lool02P3oo_l0oO[o0?[io03oool0n_[j0?ooo`3jn_X0o_kn
0?ooo`3jn_X80?ooo`050?gmo@3inOT0oooo0?gmo@3inOT00P3oool00`3jn_X08B4Q04=3@`020?oo
o`030?gmo@3oool0oooo0080oooo00@0hN7Q0000002h^;P0nOWi0P3oool20?knoP0E0?ooo`3fm_H0
oooo0?ooo`3lo?`0oooo0?cjn`3ooOd0o?Og07alN01@D4h0b<K90?omo`3jo_/0n_km0?ono`3lnol0
nOgl0?WmnP3oool0ooko01X0oooo00<0oOgm0?clo03oool01@3oool01`3UiND05aLG00<30`010@40
@4100?gmo@3no_h0GP3oool005P0oooo00/0o?cl0?ooo`3oool0a/K600/;2`0000000@4107EeM@3n
o_h0oooo0?Win@020?ooo`030?Win@3oool0oOgm0280oooo0P3moOd01P3oool0nOWi0?ooo`3hn?P0
noWl0?klo`80oooo01X0n?Sf0?ooo@3mo_h0o?gm0?_loP3nool0ooko0?glo`3no_h0ookm0?gln03o
ooX0m?Wb0?coo`3inOl0oogo0?ooo`3ooOX0^[:`00X51`3Vj?80mOco0?Woo`3lood0oooo0?gkoP<0
ooko0P3oool0103clo<0oooo0?ooo`3bl_890?ooo`030?knoP3oool0oooo00@0oooo00h0Xj>S01HF
5P18B4P0:b/[0=WIf@3gmoL0oooo0?clo03gmoL0[Jf]00X:2P3AdM40oooo0?_kn`80oooo00/0mOGe
0?gmo@3oool0o_kn0?Shn03oool0o_kn0?ooo`3oo_l0oogm0?cgm`020?ooo`0<085kN`3Mf=P0n?kn
0?_oo`3oo_l0oogo0?_oo`3jool0oOgm0?ono@3oool0nocl6@3oool0303inOT0oooo0?_kn`3oool0
moOg0?ooo`3fm_H0@d=300D51@0000003`l?0>c/k600oooo001I0?ooo`040?_kn`3moOd0oooo08f=
S@800@4100<000000;Jf]P3oool00P3oool0103jn_X0oooo0?gmo@3moOdP0?ooo`080?[jnP3oool0
oooo0?ooo`3lo?`0oooo0?Shn03oool20?ono`0U0?[jnP3oool0ooom0?gmn`3nool0n__k0?koo`3m
o_l0ooko0?gmo@3oo_d0oook0?[im03nooT0nooj0?_oo`3no?l0o_Wo0?ono`3oo?T0ooGb06MMG03V
k?P0m?oo0?Goo`3gooP0o_ck0?ojo@3ooOl0o_go0?ckoP3oool0n_[j0?ooo`3no_h0oooo0?[jnP0:
0?ooo`80oOgm01@0o?cl0?ooo`3gmoL0Hf=S02DU9@3AdM40o_kn0:NWY`0F5QH06ATI04a<C00_;bl0
1`L702l_;`3Jf]X0o?cl0?[jnP3oool0no_k0?clo0D0oooo00h0nOWi0?ooo`3oool0nOOf0?ojnP3o
oOd0no_k0?ooo`3Rg=X01P410>odm`3jool0oocl0?omo@80nooo00@0oogn0?okn`3oool0o?go603o
ool03`3moOd0o_kn0?ooo`3oool0o_kn0?gmo@3no_h0QhN7000000051@D000000<O7a`3oool0o?cl
0??cl`1N0?ooo`00FP3oool0103inOT0oooo0?ooo`1:BTX20000000701dM7@3WinL0n_[j0?ooo`3l
o?`0o_kn0?gmo@0R0?ooo`0K0?clo03inOT0oooo0?knoP3jn_X0oooo0?Shn03blO@0ooko0?ooo`3h
n?P0ooom0?clnP3knoT0oooo0?ono`3noOl0oogn0?ono`3ooOd0ookk0?ommP3oooP0mOkg0?Ooo`3o
n?l0o_Go0080oogo00L0oo[d0:BFU@2c^/P0kooo0?3oo@3gooL0oook0080ooco00T0o__o0?ono`3o
ool0oooo0?KfmP3kno/0o_kn05]KF`3hn?P0203oool0203fm_H0oooo0?ooo`3lo?`0fm_K02l_;`1H
F5P0moOg0P3oool02@3emOD0o?cl0>KViP2^[Zh0c/k>0?Cdm03no_h0oooo0?gmo@040?ooo`050?Wi
n@3oool0oooo0?knoP3kno/00P3oool04P3lo?`0ookm0?olo03ooOd0oooo0?[jnP3@c<T0BdU806]^
LP3fnOd0o_ck0?omo03hnol0o?oo0?ooo`3mnoX0oooo0?onoaP0oooo00`0moOg0?ooo`3no_h0no_k
0?ooo`3no_h0`<30000000020P800@4107moO`3oool20?clo0030?ooo`3inOT0oooo05`0oooo001H
0?ooo`0@0?KfmP3oool0oOgm0?[jnP3oool0iNGU01/K6`051@D000000451@@3oool0no_k0?ooo`3l
o?`0oooo0?_knb00oooo00D0o_kn0?Win@3oool0oooo0?gmo@020?ooo`0T0>o_k`3oo_l0o_go0?on
o`3moOd0no_i0?ooo@3no_`0ooom0?gmo@3oool0oogn0?ono@3oo?T0oo_g0?onmP3mo_H0k?Sb0?Wo
o`3onOl0oo?o0>k`o@3nool0oo[d0>OGe@1aMhD0i?Go0?;oo`3hooP0oooj0?ojnP3onol0ooco0?on
o`3jn_X0o_kn0P3oool00`3lo?`00@410?ooo`090?ooo`080?Ogm`3moOd0Z:RX01HF5P2NWYh0m_Kf
0?ooo`3no_h50?ooo`030?_kn`3oool0n_[j00@0oooo00D0nOWi0?ooo`3oool0oooo0?Ogm`020?oo
o`0D0?clo03jn_X0oooo0?gmo@3oo_d0mO?b0?omo`3oo_l0YJFS08J6Q039b</0Z:NZ0?cmo@3nool0
n_Wl0?glo`3oool0o_kl0?ooo`3lo?`I0?ooo`0;0?Ogm`3oool0oooo0?gmo@3YjNT07alO00000001
0@40?Shn0?Win@3moOd00P3oool00`3kno/0oooo0?ooo`1L0?ooo`00F@3oool03`3kno/0oooo0?oo
o`3inOT0oooo0;^k^`0000001@D500410@24Q8@0oooo0?_kn`3oool0moOg0?knoP0R0?ooo`0:0?_k
n`3moOd0n?Sh0?ooo`1[Jf/010@40>KUjP3kn_d0mOCg0?ooo`@0ooom01T0o?[k0?ono`3on_`0oogm
0?okn03ooOL0ookf0=WJe00010D09b/b0:ZEX@0;00L0X:Ni0?Goo`3oo?H0ooC_05UKJ03Zm_l0mooo
0?;mm@3looX0oook0?oko`3oo?l0n_Sk00<0oooo00@0n_[j0?ooo`000000no_k203oool02`3lo?`0
n_[j06m_K`0V9RH0aLG50?ooo`3no_h0o?cl0?ooo`3jn_X0oooo0080o?cl0P3oool01@3kno/0oooo
0?ooo`3oool0nOWi00D0oooo00<0no_k0?[jnP3oool00`3oool04@3lo?`0ooom0?ono@3onoT0o?Og
09JJV`1JGUl0oogm07ehNP3Ni^P0nOoo0?omo`3ono/0o_oo0?[no`3oool0oO_l01P0oooo00<0o_kn
0?Shn03oool00P3no_h01@1<C4`0000000H61P0M7Ad0h>3P00D0oooo00<0o?cl0?ooo`3oool0F`3o
ool005T0oooo00<0oOgm0?clo03oool00`3oool01`1hN7P000000000000410@0clo?0?ooo`3jn_X0
8`3oool03@3lo?`0oooo0?ooo`3oool0o?cl0?Shn00000001PD:0>g/k`3oo_l0oooo0?_kn@3no_`0
0P3oood06@3no?d0ooko0?cgm`3oo_/0oogj0?onmP3on?00/:nZ04UAF@3lo_l0=R0S01T53P2h`]L0
hoCo0?omnP3Pem004Q8L0=3FhP3io_l0mogi0?con`3noo/0o_Wk0?omo`3oo_l00`3oool20?knoP03
00410@3oool0oooo00L0oooo00`0g]kN03Hf=P1?Cdl0mOGe0?clo03moOd0oooo0?knoP3moOd0oooo
0?[jnP3oool20?gmo@0=0?ooo`3no_h0oooo0?knoP3jn_X0oooo0?knoP3kno/0o?cl0?ooo`3inOT0
oooo0?clo0030?ooo`0C0?[jnP3oool0ooom0?ckm`3oo?/0oocj05mWJ@2a]kL0oocm09ZDU02f_l80
lOcn0?omo@3oo?X0o?oo0?SnoP3oool0ookm0?ono`0I0?ooo`0;0?clo03oool0QHF5000000030`<0
00000;Fe]@3oool0oOgm0?knoP3moOd0H03oool00600oooo00L0?Cdm00820P0000009RHV0>k^kP3o
ool0o?cl0080oooo00H0no_k0?ooo`3oool0no_k0?ooo`3moOdI0?ooo`80oOgm00<0oooo0?gmo@3j
n_X00P3oool06`2/[:`010<8018A503Mg=l0o_kn0?ooo@3knoT0ooom0?kno03ln_/0ooko0?kin@3o
o_/0oogj0?onmP3ooOD0fmOD00/>7@3jn?l0onoZ01/;2@35eNX0kOoo0?Ogm@3oo_H0o_go0??fo@02
0?ono`050?oon`3lo_T0oooo0?_kn`3oool00P3lo?`0103no_h0oooo05MGE`2SXj<40?ooo`0<0?Sh
n03oool0oooo0?clo02a/K404A4A09RHV03inOT0oooo0?knoP3oool0oOgm6@3oool04@3knoT0oook
0?oknP2TWY`04a/M0<C:bP3oo?d0HUaL0<K?dP3`nod0oogm0?oim`3lool0nooo0?[jnP3oo_d0ooko
0100oooo00H0nOWi0?ooo`3oool0o?cl0?ooo`3no_h40?ooo`050;no_`092@T00P820000001fMWH0
I@3oool00600oooo00/0f][J00`<300;2`/0000005QHF03oool0o_kn0?clo03kno/0oOgm0?clo002
0?ooo`80oOgm6`3oool02`3no_h0oooo0?ooo`3kno/0oOgm0?knoP0c<SL0000201PG6P3@d=00no_i
0080o_kl01X0ooom0?ono`3ln_/0oogo0?omo@3ooOX0nOC^0?onmP3bkNd07Q/^0=K?g`3onNd0Vi>8
08FI[`3UoOl0o_oo0?omm`3lo_/0oOko0?olo`3onol0oOSh0?gln03lood0nooo0?Ohn080oooo00L0
UiNG00410@0=3@d0oooo0?gmo@3oool0o?cl0080oooo00/0oOgm0?Win@1gMgL0820P0<W9b@3dm?@0
oooo0?_kn`3lo?`0oooo0?gmo@0I0?ooo`0@0?kno03oo_d0oo[h0?olo03ho?d0o?oo0?omo@3ooOl0
koOi0?Woo`3ooOl0o?Kf0?koo`3lool0o?cl0?onoa80oooo00X0o_kn0?ooo`3no_h0no_k0?ooo`3m
oOd0oooo0?clo03clo<08b<S0P0000000`0o?cl0no_k0?ooo`1T0?ooo`00H@3oool01@2QXJ400000
00D51@030`<0XZ:R00@0oooo00H0oOgm0?knoP3oool0o_kn0?ooo`3lo?`H0?ooo`050?clo03kno/0
oooo0?knoP3lo?`00P3no_h0:03oool0gMcQ00d<3`0000801@D50:b/ZP3oood0no_i0?ooo@3jn_X0
oooo0?ono`3knOP0ookk0?onnP3oo_H0ooco0<RneP0A1AL0ooSV08f>O00X?E00kOoo0?kno`3ekn`0
n_oh0?coo@3onol0oo?o0?ojo`3onOL0noom0?GonP3lool0]kNg01LG5`0<30`02@T90??cl`3oool2
0?gmo@070?ooo`3jn_X0oooo0>7Qh@0m?Cd0@d=30>o_k`030?ooo`030?gmo@3oool0oooo0080o?cl
603oool20?ono@040?omo`3mno`0ooom0?gmn`80o_go0P3nool20?glo`030?ooo`3oood0oOgm0140
oooo00<0o?cl0?ooo`3oool00P3oool02P3hn?P0m?Cd0?ooo`3oool0o_kn04I6AP010@400`<301HF
5P3Ti>AV0?ooo`00H03oool02@3lo?`0oooo06ATI00000000`<300L71`3Cdm<0oooo0?gmo@020?oo
o`050?gmo@3no_h0oooo0?ooo`3lo?`06P3oool00`3no_h0oooo0?ooo`020?ooo`0:0?Ogm`3oo_l0
BTU<00X:2P0000002`/9051@CP3^k^`0oooo0?glo`80ooko01X0nOOh0?cgm`3nn_L0oooh0?olo`3o
lol0a[W:06ERC`1UK5P0<TED0>3ao`3knol0ookk0?_on03iooT0ooco0?ojo`3om_/0oogk0?Cmn02M
Yj808RHU00@4100000008R8R0?gmo@80oooo00d0oOgm0?ooo`3no_h0oooo0;Zj^P0D51@0Ph>30?oo
o`3inOT0n?Sh0?[jnP3no_h0oooo0080o_kn6@3oool01`3oo_d0oogm0?ghn03inOT0oooo0?gimP3n
o?/00P3lool0203no?/0noWh0?[mo`3lool0oooo0?omo03no_h0ooko4@3oool0103moOd0n_[j0?oo
o`3kno/20?ooo`040?7al@3oool0TI6A00<30`80000000<0][Jf0?Win@3oool0I@3oool00680oooo
00X0lo?c02TY:@000000000003@d=03fm_H0oooo0?[jnP3no_h0oooo0P3lo?`00`3no_h0oooo0?oo
o`0G0?ooo`0;0?gmo@3oool0n?Sh0?_kn`3oool0moOg0?Win@3oool0o_co0=GCeP0:2PX00P000000
6`0820H05AHF09jOW`3nool0oOko0?ckoP3oool0ookm0?oon`3kn_D0ooco0?oio`3omOl0no_^0?_o
m03cool0mOoo0?clo`3oood0n_oi0?_onP3mn_l0o_Cm0;R[/01CCDd03Q@@008;1P030000000<0?cl
o03kno/0o?cl055AD@3oool0oOgm0?ooo`1iNGT06QXJ0<G5a@3oool0no_k1@3oool00`3lo?`0oOgm
0?ooo`0H0?ooo`030?ono@3mn?P0oogm0080oooo00H0o_Sf0?omo@3io_l0m__n0?omo@3ono/20?_o
o`040?_inP3nnOT0oooo0?kooa40oooo00h0n_[j0?ooo`3oool0oOgm0?ooo`3moOd0oooo0<_;b`00
00000`<30000001iNGT0oooo0?gmoFH0oooo001P0?ooo`080?gmo@3oool0n_[j0=OGe`0>3Ph00000
00P8201[Jf/20?ooo`050?[jnP3oool0oooo0?ooo`3kno/06P3oool00`3jn_X0oooo0?ooo`020?kn
oP070?ooo`3gmoL0ooko0?klo`19BDT0000000D50`020000000G00<4100;30h0P8630?ono`3mo?l0
o?cl0?WgmP3ooo/0e]7C09J>V`3onol0oooh0>cbj01aN800mOgo0?coo`3jnod0EEYD02@Y8`0?3Q40
2@<:01H?4P0300000P000@003`051PH08R8R0>[ZjP3inOT0o_kn0?ooo`030`<0oooo0>SXj010@400
@D510>WYj@3oool0n?Sh0?knoP020?ooo`040?[jnP3lo?`0oooo0?ooo`80oOgm603oool01`3oo_l0
oogm0?ghn03kno/0oooo0?omo@3ono/00P3kool0203oo_l0oogo0?_oo`3kool0o?cl0?ono@3oool0
oOkn403oool00`3kno/0oooo0?ooo`030?ooo`0:0?Shn03]kNd09BDU0000000410@0?clo0?3`l03l
o?`0oooo0?knoVD0oooo001T0?ooo`0808^;R`0410@0000000410@2YZJT0oooo0?[jnP3no_h20?oo
o`030?knoP3oool0oooo01L0oooo00D0TI6A00820P0`<300[Zj^0?clo0020?ooo`070?knoP3knO`0
ooko0:BRX`0=2``00@4000@40P0202<T900>01@E5`0000@0@D960?koo`3mo_h0ooom0?gmn@3oood0
EE9H0=SEf`3jmOL0R8J70:j]/P3hnol20?Woo`0607MiMP0h>3H05QDH00000P082@T00@820P030000
0`0D4Q<0jn_[0?ooo`020?ooo`080?Shn0061PH0]kNg01LG5`20P800oooo0?clo03no_h20?ooo`08
0?_kn`3oool0oooo0?knoP3oool0oOgm0?_kn`3no_hH0?ooo`0A0?ono`3ono/0oogm0?oon`3jn_P0
ooko0?gkoP3bm_<0noon0?glo`3lnol0n_km0?coo@3oool0ooko0?ooo`3moOd0403oool01@3lo?`0
oooo0?;blP3oool0moOg0080oooo00P0EEEE00820P0000003@d=0=gMg@3oool0o_kn0?_knfH0oooo
001P0?ooo`80o_kn0P3oool02P3moOd0DU9B00@4100000005aLG0>CTi03moOd0oooo0?clo03kno/C
0?ooo`050?ooo@3ooo/0oook0?ooo@3oool00P3nool0203mnoh0XInR0=_Kf@3alNl0nocl0?koo`3m
oOd0o_cm0P3oo_l05`3knOX01P@50000001@D4h092DU0>o`l03in_`0o_oo0?Cen@3fmoT0o_oo0?gn
oP3oood0o?cj0>KWj@18AdX0dL_B05UDF03oo_l0o_oo0?CloP3iool0o_oo0080nOWi01<0`lC601HJ
6@061`L00`0000l92@38a/L0o?cl0?ooo`3lo?`0oooo0?knoP0000006a/K0<30`03moOd0no_k0?oo
o`3kno/0oOgm0080oooo00@0no_k0?ooo`3oool0o?cl0`3oool00`3moOd0oooo0?ooo`0F0?ooo`06
0?ono@3knOP0o_kj0?ooo@3hm_T0ooko0P3nood20?ono`060?cnn`3nood0ooko0?glo`3lo?`0ooom
4@3oool00`3kno/0oooo0?[jnP020?ooo`0:092@T0020P80000000<30`2/[:`0o_kn0?ooo`3lo?`0
oooo0?WinFD0oooo001Q0?ooo`090?Win@3oool0oooo0?ooo`3]kNd071`L00820P000000?Shn00<0
oooo00<0oOgm0?clo03oool0403oool0<P3moOd0oook0?ojl03oo_@0oook0?Ohn03lool0noko0?kh
o`3onol0U9>?0=KHd`3kool0o?oo0?[hn`3ooOl0ooko0?ooo`3lo?`0ADE500/;2`2_[jl0JVYZ04a<
C03kno/0oooo0?ckoP3oool0o?cl0?ooo`3kno/0oooo0?clo02[Zj/00P030>WWj03oool0n_[j0?ko
o`3ko?`0oooo0?Shn02HV9P05ADE08N8R00:2PX040h?06YXJ@3no_h0oOgm0P3oool0103[jn/0@d=3
02`/;03Shn<Z0?ooo`030?ooo@3oool0oooo00<0oooo0P3oo_lF0?ooo`80oOgm00D0oooo0?knoP3m
oOd0d];B00T92@020000000306YZJP3oool0oooo0080o_kn00<0oooo0?knoP3oool0I03oool00640
oooo00/0o_kn0?ooo`3inOT0o?cl0?ooo`2l_;`00@4100820P030`<0PX:20?gmo@0D0?ooo`0P0?ko
o`3noOP0ooca0?oci@3lnO80o?oo0?Cmo`3ioOl0oo_o0?ogo`3ln?D0LG=^0>Kbl03hool0ooko0?gf
n`3ln_/0o?cl0?ooo`23Ph<000000=SHf03jn_X0?Cdm08F5Q@3lo?`0oooo0?gmo@3oool0n_[j0?oo
o`3moOd20?ooo`0E0=CDe03lo?`0o_kn0?_kn`3lo?`0oooo0>g]k@1@D500>CTi0=OGe`2l_;`01PH6
024Q8@3oool0oOgm0?ooo`3no_h0_Kfm018B4P21PH40no_k04/0oooo00T0mOGe0?ooo`3alO40:RXZ
000000030`<0<C4a0?knoP3kno/00P3oool00`3moOd0oooo0?knoP1U0?ooo`00H03oool01@3moOd0
o_kn0?ooo`3oool0nOWi0080oooo00T0OWin0000000000001@D50<O7a`3oool0oOgm0?ooo`3jn_X0
3`3oool04P3nool0nOoo0?cln02RSXD04@0007UdJP2?V9<000TA0<cEh03omod0k=WK0?oko022QXD0
Zknm0>WknP3onol0oo[o0?omo`80oooo00X0YZJV00820P3oool0oOgm0>OWi`0I6AT0^[Zj0?clo03o
ool0oOgm0`3oool00`3moOd0oooo0?ooo`020?ooo`0:0?knoP3moOd0`/;2020P801bLW80l?3`0?cl
o02`/;0000000:>SX`80o_kn00L0oooo08B4Q00M7Ad0_Kfm0?Win@3oool0nOWi04P0oooo00D0n_[j
0?ooo`3oool0no_k05mOG`0200000006018B4P3GemL0oooo0?clo03oool0moOg0P3oool00`3moOd0
oooo0?ooo`1S0?ooo`00H03oool00`3kno/0oooo0?Shn0020?ooo`040?_kn`3fm_H0oooo04M7A`80
000000@09bLW0>[ZjP3no_h0oOgm403oool0703nool0mOgk0?gmn@1D@CX0d[je0>gYg@001000BEMP
0<WBg`3onol0d<31034X:`093@h0fNcX0?Coo`3ooOl0oo_o0?kin`3oool0o?cl0?;blP28R8P0nOWi
0?ooo`3lo?`0`/;2018B4P3Kfm/20?ooo`80o_kn0P3oool02@3hn?P0oooo0?_kn`3oool0no_k08Z:
RP0K6a/0/;2`0?clo0020?ooo`0907UiN@0410@0oooo0?[jnP3/k>`0ADE503Lg=`3Ti>@0o?cl04d0
oooo00<0nOWi09ZJVP0:2PX00P0000001P2RXZ80oooo0?ooo`3oool0m_Kf0?ooo`80oOgmIP3oool0
0600oooo00d0oOgm0?ooo`3kno/0no_k0?ooo`3inOT0o_kn0?ooo`3Kfm/0410@00D51@000000E5AD
0080oooo00<0o?cl0?ooo`3oool03P3oool0303oood0ookk08ElM`2KTX/0oO[_0<73_@0;3aP0m?Ko
0?[go@3km?L0ooko0?cmo`80nOok00<0noSn0?olo`3oo_l00P3oool02P3hn?P0oOgm0?ooo`3lo?`0
oOgm0?ooo`2OWil09bLW0?Cdm03lo?`20?ooo`80oOgm00L0oooo0?gmo@3jn_X0j>SX04M7A`0f=SH0
gmoO0080oooo00P0m_Kf0?ooo`3;bl/0eMGE0?ooo`38b<P07alO07QhN0<0oooo00<0no_k059BDP3o
ool0B03oool0103kno/0o?cl0=OGe`0<30`20000000406a/K03oool0no_k0?clo080oooo00@0nOWi
0?_kn`3oool0oOgmI@3oool00640oooo00h0o_kn0?ooo`3lo?`0oooo0?gmo@3oool0nOWi0?ooo`2`
/;00000000@410000000W9bL0?gmoA40oooo00P0o_cm0?chm@3<aKd050l50?oomP3moOT07AdU0=oN
j`80ooko00T0oooo0?WjnP3koo`0n_kk0?ono`3nnol0ooko0?_kn`3inOT00`3oool0203inOT0oooo
0?Gem@3oool0GUiN05QHF03oool0m_Kf0P3oool20?gmo@040?ooo`2b/[804a<C07moO`<0oooo00<0
oOgm0?ooo`3oool00P3oool00`2@T9005ADE0;6a/@020?_kn`80n_[j00<0oooo0000003oool0B03o
ool01`3jn_X0o?cl02TY:@00000020P802LW9`3emOD00P3oool01P3fm_H0o_kn0?ooo`3moOd0oooo
0?clo6H0oooo001Q0?ooo`0>0?_kn`3oool0oooo0?gmo@3no_h0n?Sh0?ooo`3inOT0oooo06ATI000
00001PH600L71`3De=@@0?ooo`80ooko0100ookm0?onk`1TGD/0RHF10?cmo`14B5<0Wj6]0?omo`3n
nO/0oooj0?cnn@3iool0nooo0?[hn@3ooOd0oogn0P3oool01@3jn_X0n?Sh0?ooo`3lo?`0no_k00<0
oooo00@0;Rh^08^;R`3oool0no_k0P3moOd03`3kno/0IfMW02DU9@32`/80no_k0?ooo`3gmoL0oooo
0?clo03oool0o_kn0?;blP1@D500;bl_0>3Ph0030?ooo`050?gmo@3oool0oooo00410@3no_h0B@3o
ool0201GEeL00@4100@4100:2PX0f=SH0?gmo@3oool0nOWi103oool00`3lo?`0oooo0?Ogm`1U0?oo
o`00H03oool0103no_h0oooo0?knoP3hn?P30?ooo`090?Win@3oool0oOgm0?clo00_;bl0000000<3
0`0Y:BT0m_Kf00l0oooo0P3oo_l05@3jmOD0oo_/0?ook@27Ph00KFec02hb>`26R980noOo0?olo`3o
ooX0nO_e0?Soo`3kool0oO_l0?okn`3ooOh0oooo0?_kn`3moOd0oooo0?gmo@030?ooo`050?Gem@3o
ool0i^KV01HF5P2h^;P00P3oool03P3Ng]h0<30`05ADE03YjNT0o?cl0?ooo`3lo?`0oooo0?gmo@3o
ool0o?cl0<k>cP0M7Ad0Kfm_0P3lo?`0203oool0nOWi0?ooo`3oool0oOgm0?Win@071`L0o?clB03o
ool0202OWil01`L7000000000000WIfM0?clo03oool0o?cl0P3oool01@3jn_X0oooo0?clo03oool0
o?cl06H0oooo001Z0?ooo`0=0?_kn`3De=@01`L700<30`000000J6QX0?Ogm`3oool0nOWi0?ooo`3k
no/0oooo0?gmo@090?ooo`060?omo`3ooOd0ookf0?ollP3oo_/0oOco0P3lool20?olo`040?ono@3n
ooX0o?om0?coo`80ooko2@3oool02P3moOd0oooo0?clo030`<006ATI0=kNgP2SXj<05aLG09JFUP3n
o_h20?ooo`0=0?gmo@3oool0oOgm0?ooo`3no_h0UIFE01@D502^[Zh0n_[j0?ooo`3lo?`0o_kn0?oo
o`020?gmo@030?ooo`3no_h0YZJV0480oooo00/0m_Kf0?ooo`3kno/0oooo0?knoP3oool0e=CD00X:
2P020P800@4105aLG0020?ooo`030?clo03oool0oooo06`0oooo001X0?ooo`0<0?_kn`3inOT0oooo
0?ooo`2EUID0000000410@061PH0];Bd0?Win@3oool0o_kn0`3oool00`3inOT0oooo0?ooo`060?oo
o`080?ono`3km_H0VY:=0=G>aP3oo?T0oooo0<K9c@2CUYd20?olo`040?ono@3noo/0o?om0?coo`80
ooko2P3oool01`3inOT0oooo0?gmo@2f][H0Cdm?02/[:`39bLT00P3oool00`3inOT0oooo0?_kn`02
0?ooo`050>k^kP1KFe/0;2`/0=[JfP3moOd00`3oool0203jn_X0oooo0?[jnP3oool0n_[j0?knoP3o
ool0n_[j@03oool0203lo?`0oooo0?ooo`3moOd0o_kn0?ooo`3fm_H0<S8b0P0000001@0];Bd0nOWi
0?KfmP3oool0oOgm06h0oooo001Z0?ooo`040?_kn`3oool0oOgm05IFEP80000000H0410@0>WYj@3o
ool0oOgm0?ooo`3kno/90?ooo`80ooko00/0oogo0??Zh@15?C80m_?/0?Cem@0X:cX0k>gm0?omo`3o
oO/0oogm0?koo`020?Woo`030?ono`3ooOd0ooko00L0oooo00X0oOgm0?ooo`3lo?`0oooo0?knoP3o
ool0/;2`0?;blP3oool0oOgm0P3oool01`3fm_H0n_[j0?ooo`3<c<`092@T06YZJP3`l?000`3oool0
0`3lo?`0oooo0?ooo`020?ooo`040??cl`3oool0oooo0?;blT80oooo00L0n_[j0?ooo`3oool0oooo
0?gmo@1YJFT00000008020P800H0dM7A0?ooo`3oool0l_;b0?ooo`3lo?a]0?ooo`00J@3oool02`3m
oOd0oooo0?[jnP3moOd0lo?c01dM7@092@T0000003`l?03inOT0no_k0080oooo00<0m_Kf0?ooo`3o
ool01P3oool03@3oo_l0o?Wo0?omo`3on_80ZZJJ0:JSVP2=SHd0[:Zm0?gko`3oo_l0oooj0?ono@3n
ool00P3lool00`3oo_l0ookm0?ooo`080?ooo`80o_kn00D0oooo0?clo03oool0oooo0?knoP020?oo
o`070?_kn`3oool0oooo0?ooo`2KVi/04a<C0:NWY`020?ooo`0<0?gmo@3kno/0oooo0?ooo`3jn_X0
o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[jA03oool0103kno/0o_kn0:f][@051@D20000000409RH
V03oool0oooo0?Ogm`80oooo00<0oOgm0?ooo`3oool0J`3oool006P0oooo00d0o_kn0?_kn`3oool0
no_k0?ooo`3lo?`0b<S8000000051@D00P8207moO`3oool0n_[j0080oooo00<0m_Kf0?ooo`3oool0
1@3oool01`3oo_l0oo_o0?gfn@3gnO@0o?oh02TY7`17@D400P3onOl0103lool0nOoo0?coo`3oo_l2
0?omo@030?koo`3lool0o_oo00L0oooo01<0oOgm0?ooo`3oool0oooo0?_kn`3lo?`0oooo0?[jnP3n
o_h0oooo0?[jnP3no_h0m?Cd05YJFP0U9BD0f=SH0?_kn`3lo?`0oooo0080oOgm00<0oooo0?_kn`3o
ool00`3oool01@3fm_H0no_k0?knoP1KFe/0n?Sh0400oooo00/0n?Sh0?ooo`3oool0oooo0=cLg005
1@D0000000410@1JFUX0oooo0?clo01b0?ooo`00J@3oool0103lo?`0o_kn0?ooo`3clo<20?ooo`08
0861P@000000000000D51@3:b/X0oooo0?clo03no_h80?ooo`0=0?omo`3onOl0ooco0?kon`3jooH0
gmkI0?C]l03olol0oo[o0?_oo`3hool0o?oo0?ooo`020?olo@030?koo`3kool0o_oo00T0oooo00D0
no_k0?clo03oool0oooo0?Win@020?ooo`060?[jnP3oool0d];B02/[:`1OGel0n_[j0`3oool01@3k
no/0oOgm0?ooo`3oool0n?Sh0080oooo00H0n_[j0?knoP3oool0oooo0?clo0010@530?ooo`070?kn
oP3dm?@0<c<c00H61P00000092@T0>c/k0020?ooo`040?Shn03oool0nOWi0?gmoFh0oooo001X0?oo
o`030?gmo@3oool0n_[j0080oooo00/0o_kn0?ooo`3lo?`0@D5100/;2`00000071`L0>OWi`3no_h0
oooo0?clo0070?ooo`0=0?ono`3nn?l0oo[o0?oomP3ooO80ookm0?omo`3oo?l0noWo0?omo`3nool0
ooom0?oon`020?ono`030?ooo`3oood0oooo00L0oooo00@0oOgm0?ooo`3oool0n_[j0`3oool01`3f
m_H0oooo0?clo02TY:@04a<C09fMW@3oool00P3moOd20?ooo`040?Win@3oool0oOgm0?Shn080oooo
00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_knd00oooo00@0n?Sh0?ooo`3no_h0KFe]0P00
000010071`L0bl_;0?ooo`3emOD30?ooo`030?gmo@3oool0o?cl06d0oooo00120?ooo`80ooom0P3o
o_l40?ooo`80ooko00@0oooo0?ooo@3oo_l0ooko6@3oool02@3moOd0oooo0?knoP3no_h0oooo0?gm
o@3oool0h^;R01LG5`0200000003051@D03oool0oOgm00P0oooo00d0ooko0?omo`3no?l0ookf0?oj
lP3oo_l0o?_o0?kno`3lo?l0ooco0?omo`3ooo/0o_ok0080o?oo00<0oooo0?ono@3oool0203oool0
0`3jn_X0oooo0?ooo`020?ooo`080?clo03oool0m?Cd06a/K00P8200e]KF0?ooo`3jn_X30?ooo`03
0?knoP3oool0oooo0080oooo00<0oOgm0?clo03oool00`3oool20?knoP0300410@3oool0oooo0400
oooo00<0o?cl0:n_[`0000000P0000000`2BTY80oooo0?Win@030?ooo`030?gmo@3oool0o?cl06h0
oooo00100?ooo`80ooko0P3ooo/20?ono`040?ooo`3oood0o_om0?koo`80o_ko00<0o_om0?kon`3o
o_l00P3oo_lP0?ooo`090;Ng]`0000000@410000002EUID0oooo0?[jnP3oool0m_Kf0080oooo00H0
o?cl0?knoP3oool0oooo0?ono`3oool20?oon`030?ooo`3oo_l0ooko00<0ooko0P3oood20?koo`@0
oooo0P3no_h20?ooo`030?_kn`3oool0no_k00<0oooo00L0no_k0?clo03oool0f][J030`<01<C4`0
no_k0080oooo00<0no_k0?clo03oool0203oool01`3no_h0oooo0?gmo@3moOd0oooo0?knoP2VYZH0
>P3oool0103jn_X0oooo0?ooo`3jn_X30?ooo`030?gmo@3Ph>00410@0080000000<0FEUI0?gmo@3n
o_h0M@3oool00400oooo0P3oo_l0203oooX0oook0?ono`3oo_l0ooom0?oon`3nood0o_oo0P3no_l2
0?kon`<0ooko803oool0203inOT0JVYZ00H61P0000002@T90=3@d03oool0oOgm0P3oool01@3gmoL0
oooo0?_kn`3oool0oOgm0100oooo00D0oOgm0?ooo`3oool0oOgm0?Shn0030?ooo`040?knoP3oool0
oooo0?gmo@80oooo00H0Y:BT014A4@2HV9P0oooo0?Win@3jn_X30?ooo`030?_kn`3oool0oooo00H0
oooo00P0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnSP0oooo00l0o?cl0?ooo`3jn_X0n_[j
0?ooo`3jn_X0oooo0?knoP3lo?`0=cLg0000000410@09BDU0>OWi`3kno/0MP3oool00400oooo0P3o
o_l02P3ooo/0ooom0?ono`3oo_l0oook0?oonP3oool0ooko0?omo`3oo_l20?oonP<0ooko7`3oool0
3`3inOT0oooo0?Ogm`0`<3000`<300@4100V9RH0moOg0?clo03oool0n_[j0?ooo`3moOd0oooo0?kn
oP0B0?ooo`030?[jnP3lo?`0oooo00<0oooo0100nOWi0?ooo`3oool0oooo0?KfmP3jn_X0J6QX024Q
8@3De=@0o?cl0?ooo`3lo?`0oooo0?Win@3oool0oOgm303oool0103clo<0oooo0?ooo`3bl_8i0?oo
o`030?gmo@3lo?`0oooo0080oooo00P0o?cl0?ooo`3no_h0M7Ad00820P0000002@T90<C4a080oooo
00<0o?cl0?ooo`3oool0L`3oool00480oooo00X0ooom0?ooo`3oo_l0ooko0?oon`3oooX0oooo0?on
o`3ooOl0ooko0P3oooP30?onoal0oooo00D0o_kn0?ooo`3oool0d];B01<C4`020000000406=SH`3o
ool0oooo0?clo080oooo00<0no_k0?ooo`3no_h0503oool0103no_h0n_[j0?ooo`3oool20?clo008
0?knoP3Vi^H0=SHf04i>CP3]kNd0o_kn0?ooo`3emOD30?ooo`030?gmo@3oool0o_kn00P0oooo00L0
o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[j03T0oooo00`0no_k0?ooo`3oool0oOgm0?knoP3oool0
o_kn0;:b/P0000000P8200410@2:RXX20?ooo`030?knoP3oool0oooo07@0oooo00100?ooo`030?oo
o@3oool0ooko0080ooko00<0oooo0?oonP3oooP0103oo_l20?oomP030?ono`3ooOl0ooko0240oooo
00P0nOWi0?ooo`2BTY80000000<30`0410@0[Zj^0?clo080oooo00@0mOGe0?ooo`3oool0oOgm403o
ool0103clo<0oooo0?clo03kno/60?ooo`0;0;Fe]@0@4100SHf=0?ooo`3no_h0oooo0?[jnP3oool0
oOgm0?ooo`3no_h00P3oool00`3kno/0oooo0?ooo`090?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P0
>P3oool01P3hn?P0oooo0?ooo`3inOT0hn?S01PH6080000000@0BTY:0?ooo`3oool0oOgmM`3oool0
0400oooo00<0o_om0?koo`3oo_l00P3oo_l00`3oool0oooh0?oon0030?ono`060?ooo`3ooo@0oood
0?ono`3ooOl0ooko803oool01@3no_h0oooo0?[jnP3oool0IVIV0080000000H0410@0=oOg`3moOd0
oOgm0?ooo`3inOTD0?ooo`040?gmo@3oool0oooo0?clo0<0oooo00`0KFe]01`L703;bl/0n_[j0?kn
oP3oool0n_[j0?ooo`3gmoL0o?cl0?ooo`3gmoL<0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@41
>P3oool03`3lo?`0oooo0?ooo`3moOd0oooo03Lg=`00000010@401lO7`3YjNT0oooo0?Ogm`3moOd0
oooo0?[jnP1e0?ooo`00?`3oool00`3oood0o_ok0?koo@020?kno`050?ono`3oood0oooh0?oon03o
o_l00P3ooOl0103oo_d0oood0?oom03oool20?onoal0oooo00<0o?cl0?ooo`3oool00P3oool01@3Z
j^X08B4Q00@410000000>SXj0080oooo00@0o?cl0?ooo`3oool0no_k403oool00`3jn_X0oOgm0?[j
nP040?ooo`040>3Ph00f=SH0BTY:0>k^kPD0oooo00P0no_k0?ooo`3oool0no_k0?ooo`3moOd0oooo
0?clo0P0oooo00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_kncP0oooo00/0o?cl0?_kn`3o
ool0n?Sh0?ooo`1fMWH010@400410@0410@0`<300?ooo`020?gmo@030?ooo`3inOT0oooo07D0oooo
000o0?ooo`030?ooo@3noo/0o_om0080o_ko00@0ooko0?oon`3oooP0oooj0P3ooOl01P3oo_l0ookm
0?oomP3oooH0oooo0?onob00oooo00`0o_kn0?ooo`3moOd0o_kn0?ooo`3jn_X0clo?00820P010@40
000007UiN@3moOd20?ooo`030?Shn03oool0oooo01D0oooo00<0/K6a01PH602:RXX00P3oool0103n
o_h0oooo0?_kn`3oool20?gmo@060?ooo`3lo?`0oooo0?gmo@3no_h0o?cl3@3oool20?knoP030041
0@3oool0oooo03T0oooo00@0oOgm0?_kn`31`L400P820P0000000`24Q8@0oooo0?Win@030?ooo`03
0?_kn`3oool0oooo07@0oooo000o0?ooo`0A0?ooo@3mooX0o?oo0?ShoP3lo?l0oooo0?gmn@3oooX0
oook0?olo`3nnol0ooko0?Whm03oooP0oooj0?clo03nool0803oool0203inOT0oooo0?[jnP3oool0
no_k0?ooo`3gmoL0SHf=0P0000001@092@T0_[jn0?gmo@3oool0n?Sh0080oooo00@0o_kn0?_kn`3n
o_h0oOgm0P3oool00`3hn?P0oooo0?ooo`020?ooo`030?_kn`3oool0n_[j0080oooo00L0mOGe0?oo
o`3oool0no_k07IfMP0N7Qh0a<C401P0oooo00L0o_kn0?ooo`3moOd0oOgm0?ooo`3no_h0YZJV0340
oooo00@0oOgm0?ooo`3oool0nOWi103oool20?knoP060?ooo`3UiND051@D000000010@40BDU9O@3o
ool00400oooo0100o_om0?Kjn@3no_l0o_ko0?ooo@3ooo/0no[f0?kln`3oo_l0oogo0?Wgn03oood0
nOWe0?koo@3nool0oOko8@3oool03`3no_h0moOg0?ooo`3oool0oOgm0?ooo`3fm_H0C4a<00<30`00
000051@D0?3`l03gmoL0oooo0?_kn`050?ooo`050?clo03moOd0oooo0?ooo`3lo?`00P3oool01@3k
no/0oooo0?ooo`3inOT0o_kn0080oooo00D0hn?S03Xj>P1:BTX0jn_[0?clo00H0?ooo`080?[jnP3o
ool0n_[j0?ooo`3jn_X0o_kn0?ooo`3jn_Xa0?ooo`070?gmo@3oool0oooo0?ooo`3no_h0no_k0?gm
o@020?ooo`060?Cdm012@T8020P80000000G5aL0inOWO@3oool00400oooo00H0o_om0?cmo@3oo_l0
oOco0?Sfm@3oo_X20?omo`080?gkoP3no?l0ooom0?ooo@3oo_l0o_oo0?gno`3noolQ0?ooo`090?gm
o@3oool0oooo0?ooo`3moOd0n?Sh0?ooo`3QhN405QHF0080000000H0EEEE0?gmo@3no_h0oooo0?kn
oP3moOd20?[jnP80oooo00<0no_k0?ooo`3moOd00P3oool0303kno/0oooo0?knoP3no_h0oooo0?gm
o@3oool0^k^k01HF5P26QXH0n?Sh0?knoQ`0oooo00@0lo?c0?ooo`3oool0l_;b<P3oool02P3kno/0
oooo0?ooo`3moOd0oooo0?knoP3oool0moOg0?ooo`26QXH20000000300410@38b<P0n_[j07d0oooo
00100?ooo`80o_oo00H0m?Cd0?ooo`3ooo/0oO_j0?olo`3lm_h20?ono`070?Ogl`3clo<0o_ko0?Wk
o`3lool0n?ck0?koo`0O0?ooo`0>0?knoP3oool0oooo0?Shn03no_h0oooo0?[jnP3oool0oOgm0;bl
_0010@401@D50000002ATI450?ooo`0C0?gmo@3no_h0oooo0?gmo@3no_h0oOgm0?ooo`3kno/0oOgm
0?ooo`3inOT0oooo0?Gem@3oool0O7al01LG5`32`/80oOgm0?ooo`020?clo1P0oooo00L0o?cl0?oo
o`3jn_X0oooo0?knoP3oool0n_[j03@0oooo00@0oOgm0?clo03oool0oOgm0P3oool01P2m_Kd00000
00L71`000000PX:20?clo7h0oooo00100?ooo`0A0?Shn03oool0ookm0?ckm`3oo?P0oogm0?oio`3o
nol0ooco0?kmn@3ooo/0E5EG0?7bo`3ko_l0nooo0?Omn@3nool07`3oool01P3moOd0o_kn0?ooo`3o
ool0o_kn0?gmo@<0oooo00H0o?cl07EeM@000000000000@4103EeMD20?clo0090?Win@3oool0oooo
0?clo03moOd0oooo0?knoP3oool0o?cl00<0oooo00X0o?cl0?ooo`3_knl0@T9203Xj>P3YjNT0oooo
0?[jnP3kno/0o_kn703oool01@3fm_H0no_k0?knoP1KFe/0n?Sh0300oooo00<0o?cl0?ooo`3oool0
0P3oool20?gmo@030?ooo`3WinL061PH0080000000<0@d=30?Shn03oool0OP3oool00400oooo0140
ooko0?ooo`3jnOD0oooh0=OCc`2IU9H0Z:6`0=WBh@3ooOl0`;nj0:FVX00B4aL0V9R^0?3eo`3anO/0
nook0?koo@0O0?ooo`030?_kn`3no_h0oooo0080oooo00<0n_[j0?ooo`3fm_H00P3oool0303clo<0
>CTi00410@0000008B4Q0?Cdm03oool0o?cl0?Ogm`3oool0o_kn0?_kn`@0oooo00X0no_k0?ooo`3o
ool0oooo0;fm_@0I6AT0P8200?knoP3oool0nOWi0P3oool00`3no_h0oOgm0?ooo`0H0?ooo`060?[j
nP3no_h0oooo0?ooo`3lo?`00@41=P3oool0103moOd0oooo0?KfmP16ATH20000000301<C4`3/k>`0
oooo0080o_knO@3oool003l0oooo0180ooko0?omo`3knO`0ookj0?oomP3onoD0/jb_01486`3mm?l0
oOSj0;fl]`1WJ680aLS<07EfT03ioOl0moko0?Kon03noodQ0?ooo`030?gmo@3kno/0oOgm0080oooo
00X0o_kn0?gmo@3oool0oooo0=CDe00@41001PH60000001TI6@0m_Kf0P3oool0103no_h0oooo0?gm
o@3oool20?_kn`0>0?knoP3oool0oooo0?ooo`1nOWh071`L0;Ng]`3moOd0no_k0?[jnP3oool0no_k
0?knoP3moOdI0?ooo`080?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/a0?ooo`070?clo03m
oOd0o_kn0?ooo`3no_h0nOWi08n?S`020000000600H61P2j^[X0o_kn0?Win@3oool0o?clO@3oool0
03l0oooo0180ooko0?glo`3ooOl0ooO_0?oml`3bk^/0no[o02<N;P3Xi?80ooko0?onn@30_kX0VIZN
06YaR@3`mol0nooo0?konP3ooodO0?ooo`<0o_kn00@0oOgm0?ooo`3no_h0n?Sh0P3oool03@3moOd0
o?cl0?ooo`2RXZ80000000@410000000YjNW0?[jnP3oool0n_[j0?ooo`3kno/01@3oool0103[jn/0
AdM703Xj>P3Vi^H20?ooo`070?knoP3lo?`0no_k0?ooo`3lo?`0oooo0?gmo@0H0?ooo`80ooom0P3o
ool20?kmo`0300400`3oool0oooo00@0ooom0`3oool20?koo@80ooko0P3nool20?ono@<0ooko0P3o
ood00`3nool0oooo0?ooo`0I0?ooo`0>0?_kn`3oool0o_kn0?knoP3hn?P0c<c<00820P030`<00000
07UiN@3oool0oOgm0?ooo`3kno]H0?ooo`050?koo`3kool0o?oo0?ono`3ooOl00P3oool20?ono@05
0?omo`3oo_l0o_ok0?con`3nool00`3oo_lE0?ooo`00?`3oool20?ono`0@0?ohn@3on>d0ZiB:0081
1P1NJ740@dYB0;2e^@3joOl0oooo0?onn02d]KD000@C0>3ao`3oo_l0oogf0?omoBL0oooo00H0o_kn
0?gmo@3oool0oooo0?Win@1PH60200000005018B4P3IfMT0oooo0?clo03moOd00P3oool0203lo?`0
oooo0?ooo`30`<008b<S07MgM`3oool0no_k803oool02`3oood0o_kj0?oon`3moO/0oOco0?omo`3o
o?l0YjBZ0?ono`3oo_d0o_gi0080oooj01@0o?_g0?omo03oo_l0nO[j0?_onP3looX0ooco0?oho`3i
o?l0o?oo0?oln03on_P0oo_o0?olo`3ooOd0oooj0?kon`3lood0o_oo0?onoaP0oooo00/0oOgm0?oo
o`3oool0no_k0?clo03`l?005aLG00<30`000000@d=30?KfmP020?ooo`030?knoP3kno/0oooo0400
oooo00X0oOgm0?ooo`3oool0oOgm0?ooo`3jn_X0oooo0?knoP3oool0o?cl0`3oool00`3inOT0oooo
0?ooo`070?ooo`0?0?_oo`3cool0mooo0?kin@3onod0noWl0?ooo`3oo_X0oo_h0?ojo`3onol0mOo`
0?Som03kool0o?co0080o_ko00<0ooko0?ooo`3oool04P3oool003l0oooo0180ooko0?[go@3oo?/0
oo7Q03dW6@2Z[;H0h>cj00072@1OIF40n?oo0?_oo`3ooOd0oOgm0::e^`2Y_<80o_Wi0?oin03ooOdZ
0?ooo`040?Win@3oool0l_;b02TY:@80000000<0>c/k0?Cdm03oool00P3oool0203kno/0oooo0?Wi
n@2>SXh06ATI0:ZZZP3inOT0o_kn8@3oool0803oood0n__e0?oonP3jn_P0ooko0?_ho`3oo?l0oogo
0?_io03oo_d0oook0?[im03hmo80oook0?ono@3mo?l0o_oo0?Kom@3io_L0oo_o0?ojo`3lo?l0noon
0?oon03ooOX0oo[o0?oko`3ooO/0oooh0?conP3lood0o_oo0P3oo_lH0?ooo`80oOgm00X0oooo0?[j
nP1:BTX02`/;0000000E5AD0h^;R0?ooo`3moOd0n_[j0P3oool00`3kno/0oooo0?ooo`110?ooo`04
0?[jnP3oool0oooo0?Gem@80oooo00@0o_kn0?gmo@3moOd0n_[j0P3oool00`3jn_X0oooo0?ooo`05
0?ooo`0B0?_oo`3bool0l_on0?olo@3onod0oogo0?OhnP3oo_X0oo[g0?kamP3onod0l?SY0?GomP3f
ool0nooo0?kno`3noOl0ooko503oool003l0oooo0180ooko0?oko`3ono/0oogT07I]F`1mP940n?go
0;^g]00C4`L0kO_i0?Goo`3glol0ooco0?Woo`3eooP0oooo0?omo`3oo_lW0?ooo`030?knoP3moOd0
n?Sh0080oooo0100o_kn0<G5a@0;2`/0000000D51@1aLG40oooo0?clo03moOd0o?cl0>o_k`1GEeL0
<30`0>CTi03oool0no_k0P3oool00`3jn_X0oooo0?ooo`0M0?ooo`050?ooo@3ooo/0oook0?ooo`3c
l_D00P3oo_l0103cl?H0ooko0?ono@3lnoL20?oonP0<0?oon`3lo?`0m_Gj0?koo`3jooP0o_oj0?oh
o@3omol0oogo0?Wjo03hnO40oOcg0P3on_l0103ooOd0oooh0?conP3lood30?onoaL0oooo00D0o?cl
0?ooo`3moOd0oooo09JFUP020000000300<30`2d];@0n?Sh0080oooo00@0nOWi0?ooo`3moOd0oOgm
@@3oool03P3lo?`0oooo0?gmo@3oool0no_k0?ooo`3moOd0l?3`0>GUi@3oool0no_k0?ooo`3kno/0
o_kn203oool04@3lool0mooo0?Woo@3on_/0ooKh0?omo`3lool0nOoo0?koo@3oo?<0OVmW05A@C@27
S900gnSe0>oho`3lool0no_k01D0oooo000o0?ooo`0B0?omo`3onol0o_Cb0?ooj`2l_:l04QDT0?[h
o`3on?808Q/@0<OIf03/o_l0oOco0?olo`3jnoD0m_W`0?koo`3bloL0ooko:03oool0203inOT0oooo
0?ooo`3inOT0oooo0?clo02?Shl00P820P0000002P2i^KT0o_kn0?ooo`3Bd]807alO06a/K03emOD0
oOgm0?Shn03oool20?gmoB40oooo01h0o?cj0?ooo@3jn_X0ooko0?kmo`3oo_l0noWl0?ono`3noOT0
oook0?oonP3jn_H0oOgk0?ooo`3oo_l0o?go0?konP3jnoD0ooWl0?olo`3onol0ooko0?conP3noo/0
oo[o0?oio`3oo_d0o?oj0?con`3nood30?onoaP0oooo00h0oOgm0?ooo`30`<000`<300@410061PH0
KVi^0?ooo`3lo?`0oooo0?gmo@3oool0nOWi0?knoT40oooo00<0oOgm0?knoP3oool00P3no_h01@3l
o?`0oooo0?clo01GEeL0SHf=0080oooo00@0oOgm0?ooo`3oool0o_kn1`3oool04P3nool0mogi0?Sj
m`3onod0oock0<g<b02EVi/0U9fZ0=7Hh03oo_@0ooc_0?ojn03Zh^/0Hg:30?3oo`3jo_l0ookk0?on
oA@0oooo000o0?ooo`0B0?omo@3on_P0oogh0?[lm`3jooh0CeIL08J3R@3on_<0GE9<096RZP3Yool0
o?oo0?Wcl@3ooO/0oogm0?coo`3kool0o_oo:@3oool00`3inOT0oooo0?knoP020?ooo`090?_kn`15
ADD010@400820P0F5QH0i^KV09ZJVP051@D0[jn_00L0oooo00<0o?cl0?ooo`3oool0803oool0403o
o_l0m_Gh0?_jo@3noOl0Fe]K0?ShmP3lo?P0oooj0?Shm03mooX0o_oo0?Wjo03jn_l0o_oo0?knnP3k
n_D20?olo`040?ogo`3mn_l0lOcc0?Won`80oo[o00@0o_om0?_onP3noo/0ooom0`3oo_lG0?ooo`04
0?_kn`3oool0j>SX02LW9`80000000X0>SXj0?[jnP3gmoL0oooo0?gmo@3no_h0oOgm0?knoP3oool0
oOgm@@3oool00`3no_h0nOWi0?ooo`020?gmo@080?ooo`3YjNT0410@0>k^kP3oool0o_kn0?ooo`3i
nOT:0?ooo`0A0?ono`3nmoX0oo_o0?kfl@3non`0[kJ/00H=9`3bn?l0nocn0?oik@3okN<0^ZJU04=K
LP3Tool0o_oo0?okmP3ooOd0503oool003l0oooo0180oook0?onmP3hlnd0o?oo0?Soo`3kool0M7=_
07MTF`1TEU<0JWJ40?7oo`3ho?/0ookh0?omn`3oo?h0loWi0?Woo`3noolX0?ooo`0>0?Cdm03oool0
oOgm0?gmo@3oool0o_kn0?ooo`3`l?005QHF000000010@406QXJ02PX:03Vi^H20?knoP80oooo00D0
nOWi0?_kn`3oool0oooo0?knoP0Q0?ooo`0G0?[jnP3noOl0ooko0?ono`3lo?`00@400?oon`3oooX0
o_oi0?gonP3nood0nocl0?gno`3no_l0oOco0?ooo@3oo?T0oocm0?oioP3onol0o_ko0?KonP3ioo/0
0P3onol0103kool0nOok0?kon`3oo_d30?onoaP0oooo00H0no_k05]KF`0000000000014A4@3Lg=`2
0?ooo`070?KfmP3no_h0oooo0?clo03oool0o_kn0?clo0100?ooo`0:0?Gem@3oool0oooo0?clo03o
ool0:RXZ0?gmo@1eMGD0Kfm_0?_kn`80oooo00@0oOgm0?ooo`3oool0nOWi1`3oool04P3oo_l0ooSk
0?oko@3on?L0oogd0?3dh@3eooL05Qdi0>;Xo`3kool0oogf0?GEaP1>>C@0SjBm0>3mo`3nool0oo_d
0?onna@0oooo000o0?ooo`040?oon`3oooH0oooj0?OjoP80nooo00`0oook0?ogk`3oo?P0nOoo0?Cm
o`3oo_l0ookh0?_elP3ooo/0o?oo0?_oo`3noolW0?ooo`030?clo03oool0o_kn00<0oooo00D0moOg
0?ooo`3oool0^k^k00H61P020000000508J6QP3hn?P0oooo0?ooo`3kno/00`3oool00`3kno/0o_kn
0?knoP0P0?ooo`080?Whn`3oo_l0ooko0?ono`3jn_X0oooo0001003jo?L20?cnn00>0?kon`3gnOH0
oOkn0?koo`3gm_`0ooko0?clo03ooOd0oo[j0?ojo`3onol0n?co0?Ooo@3go_L20?oko`040?Woo`3h
oo/0oook0?omo@<0ooko5`3oool02@3no_h0U9BD000000030`<000000;>c/`3oool0o?cl0?_kn`02
0?ooo`030?Win@3oool0nOWi04<0oooo00h0m_Kf0?Shn03oool0oOgm00X:2P3emOD0S8b<0?3`l03o
ool0n_[j0?Gem@3oool0nOWi0?clo0P0oooo0180ooko0?oloP3oo?X0ooCW0:FGRP031`H0FFI^03i6
F02`]LH0o_co0?oim`3olNH0oogk024ZA`3PkOl0m_Gh0?onm03ooo/D0?ooo`00?`3oool04P3oood0
o?kh0?konP3jnod0o_oo0?Ojo`3oool0oocd0?omn03lo_l0noko0?oio`3ooO/0oooj0?_mn03lool0
n_go0?koobL0oooo00H0o?cl0?ooo`3jn_X0oOgm0?ooo`3hn?P20?ooo`0=0?gmo@2LW9`020P80000
00010@401@D50<g=c@3moOd0oooo0?[jnP3kno/0oooo0?knoP0S0?ooo`<0ooko01/0oooo0?knoP3n
o_`000800?kon`3mooX0o_ok0?koo@3moo`0jnc/05YIG00000@0T8nD0?cmo`3Ed=807P/<01421`2l
_/X0mooo0?;ln@3lood0ooco0?omo`3gool0moom0?oon`3ooOd00`3oo_lG0?ooo`070<c<c00:2PX0
00000000001^KVh0o?cl0?_kn`020?ooo`030?_kn`3oool0oOgm0080oooo00<0o?cl0?gmo@3oool0
@P3oool01@3moOd0oooo00H61P3emOD0oooo0080oOgm0P3oool0103moOd0oooo0?clo03moOd80?oo
o`0A0?ono`3onoH0oo_T03LU5P2TZ[P0hNgo00002P1QH6D0oogo0?ono`3LfmH0KFa_00P98`3/kOl0
o_go0?olm@3oo_d0503oool003l0oooo0180o_oo0?_oo03lood0no_g0?ooo@3inOl0o_oo0?onn03l
mo40ooko0?cjo`3on?l0oogo0?konP3looX0oOko0?koo`3oo_l20?gmo@<0oooo00<0o_kn0?ooo`3n
o_h00P3no_h20?ooo`030?knoP3oool0oooo00D0oooo00<0o?cl0?gmo@3oool02@3oool00`3kno/0
oooo0?ooo`020?ooo`030?gmo@3oool0n_[j0080oooo00d0o_kn0?_kn`3oool0nOWi0??cl`1NGUh0
:2PX0=GEe@0i>CT0000000D51@0T92@0lO7a00D0oooo00<0n_[j0?gmo@3oool0803oool01`3noOl0
ooko0?glo`3moOd0o_oo0?goo02UYj800P3noo/0603moo`0oOgk0?[jn03no_h0m_Ce00800`3Pgn80
o?oo0?cgn@3D^kh07PX?0?Clo`3bool0mogm0?ono@3ooOl0ooko0?Goo`3good0ookk0?olo@3oo_l0
o_oo0?ono`l0oooo00<0oOgm0?ooo`3inOT00`3oool02@3lo?`0lo?c02@T90020P80000003Xj>P3f
m_H0oooo0?_kn`1:0?ooo`0=0?[jnP3oool0oooo0?knoP0@4100kNg]0?ooo`3no_h0no_k0?ooo`3n
o_h0oooo0?_kn`030?knoP@0oooo00l0oOgm0?knoP3oo_l0o_oo0?olm03on]d0PFiK07AkU@3do_l0
`[Fj01X<1`3_n?/0m?oo0?_oo`3hmod00P3noOl00`3onol0oocl0?ono`0D0?ooo`00?`3oool05@3n
ool0o?oo0?[no@3ooo/0n?Ke0?koo`3noOl0o?Og0?onn`3oo_l0oogo0?olo`3nnO/0nO_h0?[nn`3n
ool0o_go0=kNgP3QhN40h^;R0=_Kf`020=;BdP030=kNgP3/k>`0oooo00L0oooo00L0oOgm0?[jnP3o
ool0n_[j0?clo03oool0o_kn00`0oooo00<0nOWi0?ooo`3oool00P3lo?`0103moOd0oooo0?gmo@3n
o_h20?ooo`070=cLg00[:b/0GEeM0?Shn03oool0f][J01HF5P020000000505iNGP3kno/0o_kn0?oo
o`3gmoL00P3oool00`3moOd0oooo0?ooo`0O0?ooo`080?[io03oo_l0n_[j0?ooo@3inoP0oOol0?ko
n`3inoP20?[ln@0F0?ooo@3oo_d0ookm0?ojnP1<AdL0UYJF0?Wno`3oo_l0on_/01L21@38e>00jOco
0?coo`3ooOd0oogo0?koo`3gool0n?oo0?omo@3oo?d0ooko0?kooa00oooo00D0oOgm0?_kn`3oool0
oooo0?Win@020?ooo`0905YJFP051@D0000000l?3`3Jf]X0oooo0?knoP3oool0no_k04P0oooo00<0
oOgm0?ooo`3jn_X00P3oool00`0820P0mOGe0?ooo`020?ooo`030?clo03oool0oooo00D0oooo00<0
o_kn0?gmo@3no_h00P3oool03`3no_h0o_oo0?olm03onMd0bk^Y00/?:03bmOl0ooWk02HG4039e]`0
kOoo0?Gno`3nool0m_Ok0?_ho`020?olo`030?ono`3oool0oooo0180oooo00100?ooo`040?cmo@3m
o_h0o_go0?ooo`80ooom01L0oo_o0?cfo@3im_`0ooko0?oonP3Ui>00/k:h07IfOP0h>SL03Q0;024Q
7`0N7Qh07AdM024Q8@0Y:BT0:RXZ024Q8@0E5AD0:2PX04e=C@27QhL0`L710>_[j`020?ooo`040?cl
o03oool0oooo0?gmo@80oooo00<0no_k0?clo03oool0203oool0103kno/0oOgm0?Gem@3no_h30?oo
o`0B0?gmo@3oool0no_k0?ooo`3kno/0oOgm0:2PX00E5AD0UYJF0?knoP3oool0moOg0?ooo`2TY:@0
000000L71`000000XZ:R0P3oool01@3fm_H0oooo0?clo03oool0o_kn0200oooo0P3oo_l06P3nool0
l_Ca0?koo@3noo/0lO?`0?koo@3nool0nocl0?knoP3mnoX0ookk0?omnP2TWiT0@d8m0?7ho03mo?l0
ooKd065>C`28UJ<0l?oo0?kno`3mm_T0oogo0?koo`3hool0nOoo0P3ooOd20?onoa00oooo00<0oOgm
0?ooo`3oool00P3oool01`3moOd0Vi^K00000000000020P80:RXZ03gmoL00P3oool00`3hn?P0oooo
0?ooo`180?ooo`080?[jnP3oool0oooo0?Win@0@4100JVYZ0?;blP3no_h30?ooo`040??cl`3moOd0
oooo0?_kn`<0oooo01H0o_kn0?ooo`3oool0oooo0?_kn`3knOP0oooh0?olj@3ooo<0HUYW08AhRP3o
n_/0FU5B09>O[@3aool0logj0?con03inoP0ooko0?oko`3onOl0ooko503oool00400oooo0140no_i
0?ooo`3oo_l0moKi0?oonP3ooo/0oO[o0?olo`3>cM00K6aX01HG3@0D5@l0AdE@08>1SP2n`;d0k>oV
0?kno0060?ooo`0A0?Win@3@d=00ZJVY07=cL`0i>CT03@d=01dM7@1nOWh0hn?S0?Shn03oool0o_kn
0?ooo`3moOd0no_k0?ooo`3lo?`02@3oool01@3moOd0oooo0?ooo`3gmoL0m_Kf0080oooo00T0n_[j
0?ooo`3oool0o?cl05mOG`0X:2P0c<c<0?ooo`3moOd00`3oool01`3lo?`0IFEU00<30`0000003@d=
0=[JfP3kno/00P3oool20?gmoB40oooo00L0o?_n0?ooo`3inoP0o_om0?gonP3noo/0nO_h0080o_oo
0140nOSk0?ono`3ooOd0mNo/0?onmP3dk>40104006E/L01NHFD0OF]W01h@3`0`?4X0k_oo0?gmo`3o
o?l0oogo0?ooo`020?_oo`040?ono`3ooOd0ooko0?onoa80oooo00T0n?Sh0?knoP3oool0d=3@00h>
3P020P800000069RHP3moOd00P3oool00`3lo?`0no_k0?ooo`180?ooo`0<0?[jnP3kno/0oooo0?oo
o`3Kfm/0000008:2PP0E5AD0QHF50?7al@3oool0no_k0P3oool00`3jn_X0oooo0?clo0050?ooo`0C
0?knoP3oood0ookj0?onm`3loO<0oooj0?oeo@2>PHX0K61P05aGF@1cO8L0k?[o0?Woo@3looP0oOoj
0?ooo`3on_l0ooco0?ono`0D0?ooo`00@03oool20?ono`0?0?Ccn03oo_l0oooj0?Gel@2/Zk40?3]1
020Q8@1oPG`0h^GJ0?kon`3ooOl0n_So0?cnn`3nooX0o?cj0080oooo00<0no_k0?KfmP3jn_X00P3o
ool00`3no_h0oooo0?ooo`020?ooo`0:0=WIf@1cLg<03`l?04A4A02JVYX0n_[j0?ooo`3hn?P0oooo
0?knoPT0oooo00D0o_kn0?Ogm`3oool0oOgm0?_kn`020?ooo`0I0?_kn`3oool0n_[j0=gMg@0X:2P0
FEUI0?;blP3oool0mOGe0?ooo`3moOd0n_[j0?gmo@3oool0l?3`02DU9@051@D00000034a<@3moOd0
o?cl0?ooo`3no_h0oooo0?[jnP0P0?ooo`80o_oo00H0o_om0?Ggm03hoOL0nool05YKF`3gn?X20?on
o`0D0?ojoP3ooO/0oogh0?onl`3hkmh07a/?0:bc]`3fnol0ooW_0=O?bP000A@0inko0?Oio`3oo_l0
oogm0?omo`3oo_l0o_oo0?ooo`3oood20?onoa40oooo00`0lo?c0?ooo`3oool0l?3`02DU9@000000
0P82034a<@3kno/0o?cl0?ooo`3moOd20?ooo`030?clo03oool0oooo04T0oooo00<0o_kn07]kN`0B
4Q800P3IfMT02`1OGel04A4A08b<S03`l?00nOWi0?ooo`3kno/0oooo0?gmo@3kno/0o?cl0080oooo
01@0oOgm0?ooo`3ooo/0m?KY0?oom03ooOd0oO[o0?clo`3ooOl0oock0?omnP3iool0mooo0?KkoP3n
ool0oOgk0?kno03oo_l0o_go0?onoa@0oooo00100?ooo`0A0?cjn`3nnO/0ooco0>o]l01gMW8071`H
04A7B`2VZJh0nocl0?kon`3nooP0o?ok0?kno`3ooOl0ooom0?oonP3oood01P3oool00`3kno/0oooo
0?knoP030?ooo`0;0?clo03kno/0no_k0:NWY`1DE5@08b<S0:FUY@3oool0nOWi0?ooo`3lo?`02`3o
ool0103moOd0oooo0?ooo`3jn_X20?ooo`040:VYZ@0:2PX0Vi^K0?ooo`80no_k00D0oooo0?gmo@3o
ool0oooo0?gmo@020?ooo`050<[:bP061PH0000000L71`1YJFT00P3oool00`3kno/0oooo0?knoP0P
0?ooo`0N0?koo`3inoP0oOol0?koo@3loo/0nOgj00010`3nool0o_go0?omo`3onOh0ooOe0?olm03o
n>X0ookX09nIR@1DFEd0nOoo0?oom03lno@0:BLl0:NW`@3kool0o_oo0?omo@3oo?d0ooco0?ono`3n
ool0o_om0P3oo_l@0?ooo`050?Win@3oool0moOg0?_kn`1TI6@00P030`<010061PH0eMGE0?ooo`3k
no/20?ooo`030?KfmP3moOd0oooo04T0oooo00l0o?cl0?ooo`3clo<0<30`01TI6@3Ti>@0oooo0?kn
oP3EeMD0F5QH01lO7`2:RXX0jNWY0?ooo`3jn_X00P3oool0203lo?`0o_kn0?ooo`3oool0o_kn0?oo
n`3ooo@0moS^0P3ooOl03@3lool0n?_o0?[im@3nno@0o?oj0?Gin03oo_l0oogo0?kon`3inoH0n_ko
0?koo`3oo_l0503oool00400oooo0140ookm0?cgn@37_LH09AhU06YYI@3Ff=80l_[j0?Woo`3lo?`0
oook0?konP3ioOX0n?go0?coo`3oo_d0no[f0?omo0030?knoP030?clo03kno/0oOgm00@0oooo0P3m
oOd30?ooo`080?gmo@3oool0^;Rh038b<P0d=3@0^k^k0?ooo`3moOd80?ooo`040?Shn03oool0oOgm
0?ooo`80no_k00l0oooo0>o_k`1YJFT07alO0=KFeP3no_h0oOgm0?ooo`3jn_X0oOgm0?clo03oool0
o?cl0?ooo`3kno/00P3oool01@2>SXh01PH6000000061PH0/K6a00<0oooo00<0oOgm0?ooo`3oool0
7P3oool08@3hn_L0o_om0?koo@3noo/0mo_h0?coo@000080n__o0?ono`3hmO`0ooco0?omn`3omnl0
oog/0?odfP1aJUP000040:Vb]`3goo80hNSN02HN=@0B2bX0^l7<0?Woo`3oo?d0oo_m0?oko`3ooOl0
nooo0?_oo@3oo_l0oogo0?ono`0@0?ooo`040?Shn03moOd0ZJVY00410@80000000D0XZ:R0?ooo`3o
ool0o_kn0?clo0020?ooo`030?Win@3oool0oooo04L0oooo00<0oOgm0?ooo`3jn_X00P3oool00`0P
8200f][J0?knoP030?ooo`060<_;b`1DE5@07QhN08>3P`3moOd0nOWi0`3oool05@3no_h0oooo0?oo
o`3moO/0oook0?_jm@3nooX0nogj0?GinP3kool0nOom0?con`3ooOT0oocm0?oko`3hloL0o?of0?Wo
mP3io_l0o?oo0?koo`0D0?ooo`00@03oool04`3aknh0I5mQ02@J8`2l]K`0oook0?kon`3hool0nooo
0?ooo`3ooO`0oOoj0?coo@3kool0noko0?klo@3ooOd0ooko0?gmo@3no_h00P3oool0103no_h0oOgm
0?ooo`3no_h50?ooo`0:0?knoP3lo?`0oooo0?Win@3kno/0oooo09nOW`0T92@0Kfm_0?Shn0L0oooo
0`3nool03P3hm_L0ookm0?clnP3nood0f][J03Hf=P1ADU80m?Ge0?kln`3oo_d0noWj0?7_l03oo_l0
o?go103oool02`3moOd0oooo0?clo03oool0AdM700T92@0000006QXJ0>KViP3no_h0oOgm0240oooo
103nood00`3moo`0oOkn00010`020?ono`80oogo00h0ooWg0?ommP3on>`0ooSS0=WCa@3LgN40cmKJ
0?3lkP3XknL0f];U0=gEk03FgND0n?oo0?omo@80oo_o00H0oogo0?_oo`3kool0ooko0?omo`3oo_l@
0?ooo`080?clo03IfMT03@d=000000051@D0IfMW0?_kn`3lo?`20?ooo`040?_kn`3moOd0oooo0?kn
oQ40oooo00@0o_oo0?ono`3oo_l0ooko0P3oool01@3nool0oooo0?ono@3oo_d0oooo00<0o_oo00<0
ooko0?ono@3oo_d0103oool00`3nool0ooko0?ooo`0P0?ooo`070?gmo@3oool0oooo0?[jnP3no_h0
8R8R0>3Ph0030?knoP080?ooo`3moOd0oooo0=CDe01>CTh0<c<c0=_Kf`3dm?@20?ooo`0E0?_kn`3o
ool0oooo0?ooo`3mnoX0oook0?konP3loo/0o_oo0?_oo`3do_/0noom0?omnP3on_`0oo_o0?oloP3l
ooH0n?og0?_oo`3ko_l0o_oo01@0oooo000B0?ooo`030?[jnP3oool0nOWi0080oooo00D0moOg0?oo
o`3lo?`0oooo0?_kn`020?ooo`030??cl`3oool0oooo01T0oooo00`0no_k0?ooo`3oool0o_kn0?oo
o`2i^KT05aLG07EcM03`k_40ooko0?ShmP3oood20?gnoP80oooo00H0ooom0?koo`3nool0o_oo0?oo
o`3oo_lA0?ooo`0<0?knoP3lo?`0o?cl0?ooo`3lo?`0AdM703@d=03Hf=P0oooo0?knoP0N7Qh0fMWI
0P3oool02@3lool0nOoo0?Smo`3oo?l0oo[h0?konP2W[:D0518A09:@T@020?_oo`070?oon03gknX0
:B0Q07YeN@2>SY@0o?oo0?gno`070?ooo`050>[ZjP0N7Qh00@410000001>CTh00P3kno/02@3oool0
o_kn0?ooo`3kno/0oooo0?clo03no_h0oooo0?[jnP0H0?ooo`070?knoP3oool0oOgm0?gmo@3oool0
o_kn0:JVYP040?ono`090?ono@3oo_/0ookj0?oon03oooX0ooko0?koo`3loo/0o_om0080oogo0P3n
ool0103oo_l0oogo0?ono`3oo_l20?koo`030?ooo`3oo_l0oooo00T0oooo00<0o?cl0?[jnP3oool0
0P3oool0103lo?`0oooo0>g]k@0_;bl20000000302XZ:P3emOD0oooo01L0oooo01T0o_oo0?coo`3n
ool0oogo0?omo@3oood0o_oo0?coo`3nool0ookk0?onnP3oood0o?oo0?Woo`3kool0oogm0?omnP3o
o_/0ookm0?[jnP3oool0o_oo0?Oko03loOl0o_oo0080oooo0`3oo_d20?ooo`040?koo`3oool0oooo
0?_kn`80oooo00<0oOgm0?ooo`3no_h0103oool00`3no_h0oOgm0?ooo`0;0?ooo`0P0?knoP3oool0
o_kn02LW9`3MgMd0o_kn0?clo03oool0o?cl0?ooo`3kno/0oooo0?[jnP2OWil06ATI07QhN03oool0
no_k0?knoP3oool0n_[j0?ooo`3jn_X0ooom0?[jn03nood0oooo0?WjnP3lool0o_oo0?ono@3ooOl2
0?ono`040?kon`3nood0o_oo0?kooaD0oooo000A0?ooo`060?gmo@3oool0oooo0?ooo`3hn?P0moOg
1@3oool00`3inOT0oooo0?ooo`0I0?ooo`0:0?gmo@3lo?`0oooo0?ooo`3hn?P0oooo075aL@0L71`0
_[jn0?;blP80oOgm00<0oooo0?_kn`3oool06@3oool0103inOT0oooo0?ooo`3oool20?_kn`0K0?oo
o`2IVIT05aLG0:^[Z`3lo?`0H61P09bLW03no_h0oooo0?_oo`3gool0koCh0?olo`3onOL0JFaS01/P
6@3?cL`0ooko0?_oo`3ioOX0nOK_0?omn03oo?/0ooco0;Fe_@2SYZd0oOko00P0oooo00L0`l?30000
000820P0000008>3P`3oool0m_Kf00<0oooo00@0m_Kf0?ooo`3oool0mOGe6@3oool0203jn_X0oooo
0?[jnP3oool0n_[j0?knoP3oool0n_[j8@3oool03`3kno/0oooo0?ooo`3emOD0m_Kf0?ooo`3kno/0
o_kn06i^KP0410@0000000T92@3De=@0oooo0?clo00G0?ooo`0K0?koo`3lool0o_ko0?olo`3ooO/0
ookm0?koo`3lool0o_oo0?onnP3oooP0ooom0?_oo`3hool0nOoo0?omn`3ooOP0oo_h0?oon`3no?d0
l_?c0?koo`3joOl0o?oo0?WmoP3oo_l0oooo00<0ookm00@0ooom0?ono`3nool0nOWi0`3oool01@3k
no/0oooo0?gmo@3kno/0o?cl0080oOgm00D0o_kn0?ooo`3oool0oooo0?Shn0090?ooo`060?knoP2a
/K40d=3@0?ooo`2i^KT0i^KV0`3oool02P3gmoL0oooo0?knoP3kno/0oooo0?_kn`3Ti>@0BTY:02l_
;`3Cdm<20?ooo`070?_kn`3jn_X0oooo0?clo03oool0o_kn0?KfmP020?ooo`030?clo03oool0oooo
01/0oooo000A0?ooo`040?clo03inOT0no_k0?Ogm`80oooo00H0o_kn0?_kn`3no_h0nOWi0?ooo`3m
oOd20?ooo`030?gmo@3oool0oooo01P0oooo00T0n?Sh0?ooo`3oool0J6QX03@d=03kno/0o_kn0?oo
o`3moOd00P3oool00`3hn?P0oooo0?Shn00I0?ooo`090?[jnP3oool0no_k0?ooo`3moOd0oooo0?cl
o03AdM405ADE0080WinO01D0FEUI0?ooo`3oool0o?go0?Woo`3kool0iN3P03Pb<019BT@0mOOa0?ko
o@3lo?`0ookm0?oon`3nood0moOe0?ohnP3il?<0LW9j09NKXP3mo_l0203oool01P3kno/0P8200000
000410@000000<[:bP80oooo00H0nOWi0?clo03oool0no_k0?ooo`3moOdL0?ooo`040??cl`3oool0
oooo0?;blR80oooo00<0oOgm0?Shn03oool00P3oool00`3hn?P0oooo0::RXP03000000030:6QX@3m
oOd0n?Sh01P0oooo00T0o_oo0?coo`3nool0oogm0?omn`3oo_d0o_oo0?coo`3nool00P3oo_X0403o
ood0o?oo0?Woo`3kool0ookk0?omn03ooOX0m_Ga0?ono`3nool0o?go0?coo`3hnol0nOgn0?ono`3o
ool30?ono@030?ooo@3oo_l0o_oo00@0oooo00<0no_k0?clo03oool01@3oool00`3lo?`0n?Sh0?gm
o@090?ooo`040?Win@3]kNd02PX:0?Gem@80oooo00D0o_kn0?ooo`3lo?`0oooo0?gmo@020?ooo`09
0?Win@3lo?`0oooo0?[jnP3oool0VIVI014A4@1lO7`0no_k0080oooo00<0o_kn0?ooo`3jn_X00`3o
ool00`3kno/0oooo0?ooo`0L0?ooo`005@3oool00`3moOd0n_[j0?ooo`020?ooo`050?gmo@3lo?`0
oooo0?knoP3inOT06@3oool03P3moOd0oooo0?ooo`3jn_X0L71`03Ph>03bl_80mOGe0?ooo`3emOD0
o_kn0?ooo`3kno/0o_kn6`3oool01P3no_h0oooo0?ooo`3kno/0oooo0?Ogm`80oooo0140gmoO01hN
7P23Ph<061PH0?clo03kno/0o_oo0?Gho02^/[<05aLE08^:QP3ooo/0mOGa0?Kjm`3noo/0oocg0?Oa
kP020?_oo`050?olo@37_[l05QHN0=?GgP3mo_l0203oool0203moOd0n_[j0451@@0000000`<3020P
803/k>`0o?cl0`3oool0103fm_H0oooo0?ooo`3moOdH0?ooo`070?clo03oool0n_[j0?ooo`3no_h0
oooo0?[jnP0Q0?ooo`030?Shn03oool0oooo0080oooo00P0n_[j0?ooo`3De=@03`l?00410@0;2`/0
DU9B0?clo080oooo00<0o?cl0?ooo`3oool05@3oool01`3nool0o?oo0?koo`3oo_/0oogj0?ono@3n
ool00P3lool03P3ooo/0ookk0?ooo@3nool0nooo0?coo`3oo_d0oogj0?_gm03ooo/0o_cm0?[kn`3m
o_l0n_go0P3lool00`3oo_l0oooo0?ono@020?ono@0:0?ooo@3oo_l0o_oo0?ooo`3jn_X0oOgm0?oo
o`3moOd0oooo0?;blP80oooo0P3jn_X30?ooo`030?clo03moOd0oooo00P0oooo00H0L71`07MgM`3o
ool0oooo0?[jnP3oool20?gmo@80oooo00<0n?Sh0?ooo`3oool00P3lo?`0203oool0o_kn0?ooo`3Z
j^X0BTY:02h^;P3Cdm<0no_k0P3oool01P3no_h0m_Kf0?ooo`3fm_H0oooo0?WinAd0oooo000A0?oo
o`80oOgm00@0oooo0?Shn03oool0oooo0`3kno/01@3oool0no_k0?ooo`3oool0oOgm01T0oooo00L0
o_kn0?Shn03oool0Kfm_03@d=03emOD0o?cl00@0oooo00@0moOg0?ooo`3oool0mOGe6@3oool00`3n
o_h0oooo0?ooo`020?ooo`0L0?gmo@3oool0no_k0?knoP3moOd0g=cL01hN7P0K6a/0hN7Q0?ooo`3e
mOD0NWUl028R8P30a<40n_ci0?olo03knOP0noom0?konP3TeLd0200008F?UP3eool0ooWi0?S^k@3h
n?h06alV0?gno`X0oooo00T0g=cL00l?3`00000010@405MGE`3no_h0o?cl0?ooo`3hn?P00`3oool0
0`3no_h0oooo0?ooo`0I0?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P08@3oool0303hn?P0o_kn0?kn
oP3no_h0oooo0?;blP0g=cL0000000820P0P8200n?Sh0?WinAX0oooo00L0o_oo0?coo`3nool0ookj
0?omnP3oo_d0o_oo0080o?oo00@0ooko0?omo@3oo_l0ooko0P3lool0303oo_d0ookk0?onn`3mo?P0
ooko0?Ohn03nool0noko0?coo`3ho?d0ooko0?ooo`<0ookm00T0ooom0?ono`3nool0oOgm0<W9b@2k
^k/0m_Kf0?ooo`3no_h01@3oool20?gmo@80oooo00<0o?cl0?ooo`3oool01P3oool0103hn?P061PH
0>;RhP3jn_X50?ooo`030?[jnP3oool0oooo00@0oooo00T0n?Sh0?ooo`3oool0moOg0?ooo`2WYjL0
3`l?0<71`@3jn_X00`3oool00`3kno/0oooo0?clo00N0?ooo`004@3oool02P3jn_X0oooo0?[jnP3n
o_h0n?Sh01/K6`2^[Zh0oooo0?[jnP3lo?`40?ooo`030?gmo@3oool0oooo01P0oooo00P0IVIV03@d
=03clo<0o?cl0?[jnP3oool0no_k0?knoP@0oooo00<0o_kn0?ooo`3oool0603oool01P3moOd0oooo
0?Win@3oool0o_kn0?KfmP80oooo00/0oOgm0?ooo`3Xj>P0@T9209^KV`3Kfm/0A49304]6B03Xi^D0
noom0?[nn`020?omo`0;0?;kmP3nooP0nNOI028C302P[[L0e^Sd0?omo@37_K/0EeMM04eAF03mo_l0
1`3oool0403jn_X0m_Kf0?ooo`3oool0Zj^[00L71`0000000P8209^KV`3oool0n_[j0?knoP3oool0
o_kn0?ooo`3no_hI0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@418P3oool00`3lo?`0oooo0?oo
o`020?knoP0507=cL`00000010@400@4103?cll00`3oool00`3lo?`0o_kn0?ooo`0F0?ooo`<0o_oo
00@0ookj0?onn03oo_l0o_oo0P3lool03@3oo_l0oogo0?omo`3oo_l0oooo0?koo`3oood0ookm0?ol
n@3kn_H0ooko0?koo`3hnOd00`3lool00`3oo_l0oooo0?ono@020?ono@0>0?ooo@3oo_l0o_oo0>[Z
jP051@D0:BTY02h^;P2=SHd0jn_[0?ooo`3jn_X0oOgm0?_kn`3lo?`30?ooo`030?knoP3oool0oooo
00L0oooo00L0i^KV0=WIf@3no_h0oooo0?clo03oool0n?Sh0080oooo00D0n?Sh0?ooo`3oool0oooo
0?clo0020?[jnP030?ooo`3no_h0m_Kf0080oooo00/0n_[j0<K6aP0A4A40WinO0?ooo`3emOD0oooo
0?Win@3gmoL0oooo0?Shn00M0?ooo`00403oool03P3kno/0oooo0?Shn02b/[80o?cl0?[jnP3?cll0
4a<C0=;BdP3oool0o?cl0?ooo`3jn_X0no_k6`3oool01@2b/[8020P80>o_k`3oool0o_kn00<0oooo
00L0o_kn0?ooo`3oool0n_[j0?Shn03oool0o_kn01P0oooo00D0n_[j0?ooo`3oool0oooo0?gmo@02
0?ooo`0J0?clo03inOT0oooo0?ooo`3hn?P0XJ6Q04U9B@0B4Q80Ph620?oin@3ooOd0noom0?_oo`3o
n_h0oOSl0?Woo`3nooH0oo_Z03HW7`2ibMP0jooo0?ooo`3ooOX0k>_a0?coo`3mo_l80?ooo`0>0?kn
oP3jn_X0oooo0?gmo@1WIfL00`<30000000410@0f=SH0?ooo`3hn?P0no_k0?ooo`3kno/I0?ooo`08
0?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/R0?ooo`090?Win@3jn_X0oooo0:f][@030`<0
0P820000002GUiL0oOgm0080oooo00<0n?Sh0?ooo`3oool05`3oool20?koo`030?koo@3oooP0ookh
0080ooko0P3lool20?ono`0@0?olo`3ooOd0oook0?oon`3nool0oooo0?ono@3ooo/0noWj0?koo`3l
oOl0n_go0?coo`3ho?d0ooko0?ooo`<0ookm00/0ooom0?ono`3nool0Ph>306EUI@3oool0_kno05MG
E`0B4Q80HV9R0<o?c`040?ooo`80oOgm2`3oool00`3jn_X0o?cl0?ooo`020?knoP070?ooo`3moOd0
oooo0?ooo`3moOd0o?cl0?knoP030?ooo`050?clo03oool0oooo0?knoP3inOT00P3oool01@3Ng]h0
92@T07=cL`3oool0oOgm0080oooo00<0o?cl0?ooo`3oool0703oool00140oooo00T0o?cl0?ooo`1e
MGD030`<04M7A`2TY:@0WYjN02TY:@3`l?000P3oool0103moOd0oooo0?gmo@3moOdH0?ooo`080>OW
i`0F5QH0alO70?ooo`3inOT0oOgm0?ooo`3kno/20?ooo`80o?cl0P3oool00`3jn_X0oooo0?ooo`0H
0?ooo`060?knoP3oool0nOWi0?ooo`3no_h0no_k0P3oool20?Shn00F0?ooo`1XJ6P000000<O7a`3o
o_d0ooSi0?onn`3kood0n_on0?klo`3oo_l0loWg0?oomP3onnP0Z9^@059QLP3^ool0nO[j0?onn03o
o_l0oOgo0?kmo`L0oooo00L0no_k0?ooo`3oool0n_[j0?ooo`3clo<0;Bd]0080000000L0:b/[0?7a
l@3oool0oooo0?clo03oool0o?cl01`0oooo0P3no_h00`010@40oooo0?ooo`0O0?ooo`0<0?knoP3o
ool0oooo0?clo03Rh^80410@000000010@40De=C0?gmo@3oool0mOGe0P3oool00`3gmoL0oooo0?oo
o`0G0?ooo`060?koo`3nood0ooof0?oon03ooOl0ooko0P3lool01P3nool0ooko0?olo`3oo?d0ookh
0?oonP80o?oo00X0c/c;01DD4034`/<0n__k0?cmo`3lool0n?_o0?coo`3oo_l0oooo0`3oo_d0403o
ood0ooko0?koo`0L71`0dm?C0?clo03no_h0oooo0>g]k@23Ph<092@T034a<@2HV9P0lo?c0?ooo`3i
nOT20?ooo`030?clo03oool0oooo00H0oooo00<0moOg0?ooo`3no_h00`3oool01@3lo?`0oooo0?_k
n`3oool0oOgm0080oooo00@0oOgm0?knoP3oool0oooo0`3moOd0303oool0oOgm0?knoP3lo?`0jn_[
03`l?01JFUX0kno_0?knoP3oool0o_kn0?clo1d0oooo000A0?ooo`0@0?clo03kno/0oooo0?KfmP2R
XZ80FUYJ0?Win@1UIFD0EEEE0?_kn`3moOd0no_k0?ooo`3jn_X0oooo0?_kn`<0oooo00@0nOWi0?oo
o`3oool0o?cl0P3oool00`3inOT0oooo0?ooo`020?ooo`0<0?knoP3oool0oOgm0?ooo`3no_h0oooo
0?clo03moOd0oooo04];B`1mOGd0no_k0P3oool00`3moOd0no_k0?ooo`0Q0?ooo`0P0?knoP3oool0
n_[j0?ooo`3moOd0oooo0?knoP3oool0o?cl0>WYj@12@T80?clo01LG5`3QhN40ookm0?omo@3oo_/0
o_om0?coo`3nool0ooko0?koo`3oooP0oo_V0>WOd`013Ql0j?So0?cnn`3oo_D0ooko0?kno`3oo_l9
0?ooo`060?_kn`3oool0oooo0?[jnP3Hf=P01`L70P0000000`1`L700oooo0?gmo@020?ooo`030?kn
oP3oool0oooo01H0oooo00L0o_kn0?ooo`3moOd0oOgm0?ooo`3no_h0YZJV01X0oooo00H0o_kn0?oo
o`3lo?`0oooo0?knoP3inOT30?ooo`030?[jnP3oool0=SHf0080000000<08b<S0?Gem@3jn_X00`3o
ool00`3no_h0oooo0?ooo`0H0?ooo`040?koo`3oood0ooof0?oomP80oogo00l0o_ko0?coo`3mo_l0
oO_n0?oko`3onOT0oocc0?oon03fn_l0nOoo0?ooo`2EU900c/c=0?[kn`3nool00P3lool03`3kool0
ooko0?clo03ooO`0ookm0?gknP3oood0ooko0;6b]00b<S80oooo0?_kn`3oool0o_kn0?ooo`020?gm
o@090;Jf]P1BDU805QHF06MWI`3De=@0oooo0?[jnP3oool0oOgm00<0oooo00H0no_k0?ooo`3oool0
j>SX0?[jnP3kno/20?ooo`040?clo03moOd0oooo0?knoQ00oooo00D0n_[j0?ooo`1GEeL0>3Ph0?3`
l0020?ooo`80oOgm0P3oool01P3moOd0o_kn0?ooo`3kno/0oooo0?clo080oooo00@0nOWi0?ooo`3o
ool0m?Cd3P3oool00100oooo00<0oOgm0?ooo`3oool00`3oool02@3no_h0oooo0?[jnP0O7al0Lg=c
03dm?@2EUID0j>SX0?Shn0020?ooo`050?[jnP3lo?`0oooo0?ooo`3inOT00P3oool01P3moOd0o?cl
0?ooo`3jn_X0oooo0?KfmP80oooo00D0o_kn0?clo03kno/0oooo0?Win@020?ooo`0509^KV`0`<300
o?cl0?knoP3jn_X00P3no_hV0?ooo`0<0?Win@3no_h0oooo0?knoP3moOd0a<C401dM7@1lO7`0oooo
0<G5a@3Lg=`0o_cm0P3ooOd03`3oood0o_oo0?coo`3nool0ooko0?onn03ooN`0n_?X01XR=03;en/0
o_om0?oomP3lnoh0o_ko0?ono`080?ooo`040?gmo@3no_h0oooo0?ooo`80o_kn00L0UYJF00000009
2@T000000:n_[`3oool0n?Sh01X0oooo00P0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnQT0
oooo00<0o_kn0?gmo@3oool0103oool02P3no_h0oooo0?ooo`1]KFd0000000@4100;2`/0b<S80?cl
o03no_h20?ooo`030?knoP3moOd0o_kn01T0oooo00@0o_oo0?ooo@3ooo@0ooof0P3ooOl03`3nool0
o?oo0?coo`3ln_d0oo[n0?oknP3ooO40n??[0?Woo`3hool0o?_n0=7@c01kNGX0o_oo0?WjoP030?co
o`030?kmo`3oool0ookm0080ookm00D0mOGc0?kmo`1<CDl0XZ:R0?knoP020?ooo`030?gmo@3lo?`0
o?cl00<0oooo00L0h>3P07inOP0J6QX0>3Ph0:VYZ@3fm_H0o?cl0080oooo00T0o?cl0?ooo`3hn?P0
h>3P01LG5`3emOD0o?cl0?ooo`3no_h05@3oool0503no_h0oooo04a<C0020P80k>c/0?ooo`3no_h0
oooo0?gmo@3inOT0o_kn0?clo03oool0o_kn0?_kn`3lo?`0oooo0=kNgP1gMgL0oOgm0P3oool00`3e
mOD0oooo0?ooo`0;0?ooo`004@3oool0403hn?P0oooo0?ooo`3inOT0no_k0?ooo`3lo?`0inOW00l?
3`0>3Ph0Rh^;05aLG00=3@d0SHf=0?gmo@3lo?`20?ooo`040?[jnP3kno/0oooo0?Ogm`80oooo00L0
lo?c0?ooo`3oool0n_[j0?ooo`3kno/0oOgm00D0oooo00@0nOWi0=cLg00F5QH0cLg=0`3oool00`3g
moL0oooo0?ooo`0Q0?ooo`0=0?knoP3gmoL0oooo0?gmo@3oool0o?cl0?ooo`3kno/0QhN701@D502h
^;P0oooo0?Shn0030?ooo`040?ono`3oo_d0ookm0?ooo`80o?oo00/0ooko0?omn`3oo^l0noS_07Z0
SP2<Tj<0no_g0?oom@3oo_l0no_o0?ono`080?ooo`0?0?knoP3oool0oooo0?ooo`3moOd0oooo0?[j
nP1?Cdl01@D50000000?3`l0j^[Z0?knoP3oool0o_kn01/0oooo00@0lo?c0?ooo`3oool0l_;b6`3o
ool03@3no_h0oooo0?[jnP3inOT0oooo0?clo03no_h0oooo0;Bd]00410@020P800000026QXH01@3o
ool30?knoQP0oooo00<0ooko0?koo`3oool00P3oooH0803ooOl0ooco0?koo`3lool0mOWj0?ono`3o
m?H0oo;`0?oik03on?00moko0?Ooo`3nool0n?Oc04e;C03ko?`0oOko0?[mo`3io?l0nooo0?ckoP3o
ool0oO_j0?omo03oo_d0o_kl0>KUj00A4Q@0m?Cd0?gmo@3oool0o_kn0`3oool00`3moOd0n_[j0?oo
o`020?ooo`080?gmo@2ZZZX0@d=301HF5P1cLg<0hN7Q0?knoP3inOT20?ooo`0306i^KP1hN7P0oooo
0080oooo00D0no_k0?knoP3no_h0oooo0?gmo@0@0?ooo`0F0?Win@3oool0moOg0?ooo`2<S8`071`L
0>?Sh`3oool0o_kn0?[jnP2FUYH0b<S80?ooo`3fm_H0oooo0?gmo@3oool0_[jn01<C4`2h^;P0oooo
0?KfmPl0oooo000@0?ooo`040?gmo@3no_h0oooo0?[jnP80oooo00T0n?Sh0?ooo`2JVYX0EeMG0;>c
/`0M7Ad0l?3`0?ooo`39bLT00P3oool0203gmoL0_Kfm0=[JfP3oool0o?cl0?knoP3oool0moOg0P3o
ool00`3moOd0o_kn0?clo0040?ooo`0=0?[jnP3inOT0o?cl0?ooo`1FEUH0SXj>0?ooo`3moOd0oooo
0?KfmP3oool0o?cl0?KfmP0T0?ooo`0A0?knoP3dm?@0oooo0?7al@13@d<0>SXj0>OWi`3oool0o?cl
0?gmo@3oool0o?cl0?ooo`3nool0oooo0?omo@3oo_d00P3lool02`3oo_l0oogm0?_fk03oooP0U9RQ
02hb>`3oooX0oooh0?7al@3nool0ooko00L0oooo00@0oOgm0?ooo`3oool0oOgm0P3oool02P3lo?`0
oooo0?3`l00J6QX00@4100<30`11@D40moOg0?ooo`3no_hH0?ooo`070?clo03oool0n_[j0?ooo`3n
o_h0oooo0?[jnP0I0?ooo`030?[jnP3oool0oooo00D0oooo00<0o_kn0>;RhP0=3@d00P0000000`1A
DE40n_[j0?gmo@030?ooo`030?knoP3oool0oooo01T0oooo00<0ooko0?kno`3oo_l00P3oooH20?ol
o`0J0?koo@3lood0nooo0??cl`0_82404P000;bZV`0V7A@0GfMi0>_go`3moOl0oook08J4Q@3Ee]H0
o_oo0?coo`3ko_l0o?oo0?ono`3emOD0ookm0?omo03oo_d0ooom07QgNP1^Kg420?ooo`080?clo03n
o_h0oooo0?gmo@3oool0o?cl0?ooo`3inOT20?ooo`0A0?knoP3oool0oooo0=[JfP1iNGT03Ph>04a<
C02_[jl0no_k0??cl`0E5AD0fMWI0?ooo`3kno/0n_[j0?ooo`3moOd05P3oool05@3moOd0o?cl08N7
Q`0_;bl0j^[Z0?ooo`3no_h0EeMG09nOW`3moOd0oooo0?gmo@3oool0d=3@01XJ6P2m_Kd0oooo0?Wi
n@3oool0no_k0?gmo@0=0?ooo`00403oool01@3jn_X0oooo0?knoP3moOd0no_k0080oooo00L0m_Kf
05eMG@2HV9P0o_kn075aL@19BDT0no_k0080oooo00`0o_kn0?ooo`2_[jl061PH02PX:01lO7`0lO7a
0?gmo@3kno/0o_kn0?Shn03no_h20?ooo`030?_kn`3lo?`0no_k00<0oooo00D0o?cl0>GUi@0<30`0
kno_0?KfmP030?ooo`040?_kn`3inOT0oooo0?_knb80oooo00X0n?Sh0?ooo`3oool0b<S801HF5P1j
NWX0n?Sh0?ooo`3kno/0n_[j0P3oool0203lo?`0o?go0?coo`3nool0oogo0?omo@3oood0o_oo0P3o
o_l02@3ooOT0oOch0;>f^P2DUIL0noGb0?okm@3nool0mo[n0?koo`070?ooo`040?knoP3oool0no_k
0?gmo@<0oooo00P0o?cl0?ooo`35aLD0000000<30`000000QXJ60?KfmQ`0oooo00D0m_Kf0?_kn`3n
o_h0Fe]K0?Shn00I0?ooo`80oOgm00@0o_kn0?ooo`3oool0o?cl0P3oool0200f=SH01PH60000000L
71`0inOW0?ooo`3lo?`0oooo0P3no_hL0?ooo`030?ono`3ooOl0ooko0080ooof01`0ooco0?omo`3n
oo/0o?oj0?_oo@3bl_008A4B0?;Mf02EPW401`000:2X_@3<f_@0o?oo0>k]j@1?CDh0SXn?0?_lo`3f
nOd0mo[n0?coo`3kn_d0oooo0?ono@3no?/0n_Sg0?ooo@0B4A@0fM[L0P3oool01@3no_h0oooo0?gm
o@3jn_X0no_k00@0oooo00l0moOg0?ooo`3inOT0o?cl0?ooo`3moOd0oooo09^KV`0m?Cd092@T05EE
E@2ATI40oooo0?clo03no_h00P3oool00`3jn_X0oooo0?ooo`0B0?ooo`0;0?Ogm`3moOd0oooo0?cl
o03oool0L71`03hn?P3fm_H0o?cl065QH@2NWYh0103oool01`2RXZ80gmoO0?gmo@3no_h0oooo0?Og
m`3no_h03P3oool00100oooo00H0oOgm0?_kn`3kno/0oooo0?knoP3kno/20?ooo`0601PH603Kfm/0
oooo0?ooo`1lO7`0X:2P0P3no_h01`3oool0no_k0?Shn03lo?`0c<c<07EeM@3@d=001@3oool01P3j
n_X0oooo0?ooo`33`l<05aLG0>[ZjP80moOg00<0oooo07QhN01WIfL00P3oool01P3no_h0oooo0?oo
o`3moOd0oooo0?clo240oooo00L0m_Kf0?ooo`3oool0o_kn08V9R@0D51@0/;2`0080oooo00h0o?cl
0?ooo`3oool0o?cl0?ooo`3kno/0o_oo0?Woo`3kool0oogo0?omo@3oo_d0o_om0?koo`<0ooko00L0
n_ci0?oon`3ooOP0oo_h0?koo`3iool0o_oo00L0oooo00<0o_kn0?ooo`3lo?`00P3oool01P3lo?`0
oooo0?ooo`3gmoL0oooo08N7Q`80000000<010@40<O7a`3oool06@3oool01P3jn_X0o_kn0?ooo`3o
ool0o?cl00410AX0oooo00D0oOgm0?ooo`3no_h0oOgm0?KfmP020?ooo`0607YjNP0000002PX:00@4
1036a/H0oooo0P3moOd70?ooo`030?knoP3oool0oooo01D0oooo01@0ooko0?omo`3oo_l0oooh0?oo
mP3oo?l0oogo0?oonP3kooP0n?oj0?;bkP0]7Ad0kMK@0?oji`0`9Ad0OXRQ0?7oo`3dmoh0oook0?Wg
n080o_oo00H0@4=701`O8`26RX/0hn;U0?ooo`3ooO`20?ono@070:ZZZ010?d80nocn0?ooo`3hn?P0
oooo0?Win@020?ooo`80n_[j00<0o?cl0?ooo`3oool0103oool02P3moOd0no_k0?ooo`3oool0o?cl
0=7Ad@1bLW802`/;04I6AP2i^KT20?ooo`040?Ogm`3hn?P0oooo0?Shn180oooo00<0no_k0?ooo`3o
ool00`3oool03@1MGEd0Bd];0?ooo`1OGel0WIfM0?ooo`3^k^h0no_k0?ooo`3kno/0o?cl0?ooo`3m
oOd00`3oool00`3fm_H0oooo0?ooo`0;0?ooo`004`3oool02P3kno/0oooo0?ooo`3fm_H0alO702TY
:@3moOd0oooo0?Shn03moOd40?ooo`0<0?clo03oool0oooo0?_kn`3dm?@0oooo0?knoP3kno/0oooo
024Q8@1gMgL0bLW90P3jn_X0303oool0RHV903Lg=`3jn_X0oooo0?_kn`0O7al0e]KF0?Win@3jn_X0
o_kn0?_kn`80oooo00<0nOWi0?ooo`3jn_X08P3oool0203QhN40DE5A03Xj>P3Jf]X0oooo0?gmo@3h
n?P0oOgm103oool0203jn_X0o?oo0?Soo`3iool0ooko0?omo@3oo_/0ooom0P3lool02@3oo?l0oO_n
0?konP3gmnd0ooch0?okn`3gn?P0nooo0?koo`0<0?ooo`030?[jnP3moOd0oooo0080oooo00H0moOg
04=3@`020P800@4101`L703/k>`H0?ooo`080?Win@3oool0oooo0?ooo`3jn_X0oooo0000003kno/H
0?ooo`80o_kn0`3oool00`3no_h0oooo0;2`/00200410@0500000023Ph<0oooo0?ooo`3kno/01`3o
ool20?knoQL0oooo02H0ooko0?omo`3ooOl0oooh0?oomP3oo?l0oogo0?oon03kooH0m_og0?oon`1W
EeL0Z8n:0?ojj03=`[X01a8]0>cko`3lo_l0o?_g0?ono`3fmoL0mOKj0=gPi00C5QX0004200<21@09
2@T0D4i=07MeM02`[Zd0<C4_09NFV@3`lO<0n_[j0=oOg`2o_kl0W9bL0?;blP@0oooo00<0o?cl0?oo
o`3oool00P3hn?P04P3no_h0oooo0?ooo`3oool0oOgm0?ooo`3kno/0nOWi0?Shn02PX:00;Rh^02TY
:@25QHD0l_;b0?ooo`3moOd0oooo0?[jnQ40oooo00@0oOgm0?clo03oool0n?Sh0P3oool01`3gmoL0
B4Q805QHF01VIVH0X:2P0<?3``2JVYX01@3oool00`3no_h0n_[j0?knoP0?0?ooo`00403oool00`3h
n?P0oooo0?knoP020?ooo`040?[jnP3oool0Q8B407=cL`@0oooo00@0oOgm0?ooo`3kno/0nOWi0P3o
ool0303emOD0oooo0?ooo`3moOd0oooo0?gmo@3oool0dm?C07]kN`0Y:BT0ADE50?ooo`80o?cl00D0
BDU907IfMP3no_h0[Jf]03Ti>@040?ooo`060?clo03oool0no_k0?gmo@3oool0o_kn8@3oool01P36
a/H092@T071`L03gmoL0oooo0?_kn`<0oooo00`0m_Kf0?ooo`3no_h0o_kn0?ooo`3mo_l0nOoo0?_o
o`3oo_l0oogm0?onn`3oood20?coo`80ooko00L0o?kh0?oomP3oo?X0ooGd0?koo`3jool0o_oo00X0
oooo00H0m_Kf0?ooo`3oool0o_kn0?ooo`3lo?`20?ooo`050>3Ph00F5QH00`<30000001BDU80703o
ool20?knoP0300410@3oool0oooo01L0oooo00/0oOgm0?ooo`3lo?`0o_kn0?ooo`3moOd0hn?S01HF
5P0000000`<304U9B@020?ooo`030?knoP3lo?`0oooo01l0oooo02T0ooko0?omo`3oo_l0oooj0?oo
n03ooOd0oogo0?konP3looP0nook0?Oim03jk^h070X60>KFa`3ilN`000HK0=3Nn03joOl0o_ck0?kn
o03loOd0o_oo0?coo`3amOH0^KZl01<C4`0000000@0000T71P071@@00000014@4`010P@0000000@4
10000000:RXZ0?ooo`3kno/0oooo0?knoP020?ooo`050?[jnP3oool0oooo0?ooo`3moOd00P3oool0
3@3hn?P0oooo0?ooo`3kno/0oooo0?gmo@3lo?`0oooo0<W9b@1OGel03Ph>05YJFP32`/804P3oool0
103no_h0oooo0?ooo`3fm_H30?ooo`0<0?gmo@3fm_H00P82069RHP1GEeL05aLG0>7Qh@3kno/0o_kn
0?gmo@3oool0n?Sh0P3oool00`3no_h0oooo0?gmo@0=0?ooo`004@3oool02`3kno/0oooo0?ooo`3i
nOT0oOgm0?ooo`0a<C40`<300?[jnP3oool0oOgm00<0oooo00<0o_kn0?ooo`3oool01`3oool04@3m
oOd0oooo0?_kn`3moOd0i^KV0?[jnP3oool0oOgm0;no_`0K6a/0YJFU04a<C02RXZ80oooo0?knoP3o
ool0no_k00L0oooo00H0o?cl0?ooo`3oool0nOWi0?ooo`3lo?`20?ooo`0B0?clo03jn_X0oooo0?oo
o`3lo?`0oooo0?[jnP3no_h0oooo0?gmo@3kno/0o_kn0?ooo`3no_h0oooo0?gmo@3oool0oOgm0P3o
ool01P3hn?P0oooo0?gmo@2ATI405ADE0:j^[P80oooo00<0no_k0?ooo`3oool0203oool20?koo`04
0?ooo`3oo_l0ookm0?ooo`80o_oo00@0ooko0?ooo`3oood0oook0P3ooOd00`3oool0o_oo0?ooo`0@
0?ooo`090?gmo@3oool0o?cl0;Ng]`020P80000000820P2CTi<0oooo0080o_kn0P3oool00`3kno/0
oooo0?ooo`0?0?ooo`070?knoP3oool0oOgm0?gmo@3oool0o_kn0:JVYP0J0?ooo`0:0?KfmP3oool0
nOWi0?ooo`3kno/0?clo00820P010@406a/K0>_[j`80oooo00<0o_kn0?Win@3oool07`3oool01`3o
o_l0oogo0?omo`3oood0oook0?ono@3oood00P3noo/0703lood0n__k0?klo@3VhN40If=P06m^L@00
00`0XZRd0?[ko`3oood0o_om0?_mnP3nool0oOkn0?_lo03nool0no_i08B4PP0:2PX0000000H61P00
00801@@700000P0;2`/0=CDe0<[:bP3lo?`20?ooo`030?clo03moOd0o_kn0080oooo00`0o?cl0?gm
o@3oool0oooo0?knoP3oood0n_[h0?ooo@3Ti>@0C4a<0?[io03mo?l20?ono`0<0?SgnP3oo_l0l?3`
08Z:RP0R8R00=SHd09:BT03clo<0o?cl0?ooo`3no_h0oOgm0P3oool30?gmo@030?ooo`3lo?`0oooo
0080o_kn00H0oooo0?knoP3no_h0n_[j0?ooo`3gmoL20?ooo`090?[jnP3oool0nOWi01/K6`0G5aL0
g=cL0?clo03oool0o_kn01D0oooo000B0?ooo`80o_kn0P3oool02@3Ti>@061PH0?3`l03oool0o_kn
0?clo03oool0o?cl0?gmo@0>0?ooo`0;0??cl`3oool0oooo0?ooo`3Cdm<0:b/[00<30`0J6QX0h>3P
0?gmo@3lo?`00`3oool01`3lo?`0oooo0?[jnP3oool0n_[j0?ooo`3no_h00`3oool0103kno/0o_kn
0?_kn`3inOT20?ooo`80o?cl00@0oooo0?knoP3oool0mOGe103oool04`3jn_X0oooo0?gmo@3moOd0
oooo0?Cdm03kno/0o_kn0?ooo`3/k>`0FUYJ02l_;`3Ogml0oOgm0?knoP3moOd0oooo0?gmo@3no_h0
:03oool01P3lo?`0oooo0?ooo`3jn_X0oooo06MWI`800P8200H020P80<k>cP3oool0oooo0?knoP3j
n_XB0?ooo`080?[jnP3oool0n_[j0?ooo`3jn_X0o_kn0?ooo`3jn_XH0?ooo`0?0?knoP3oool0moOg
0?ooo`3lo?`0PH6100@4100000000@410;bl_03oool0o?cl0?Win@3oool0o_kn0240oooo0P3oo_l2
0?ooo`80ooom0P3nood00`3ko?`0o_oo0?Wjo0020?coo`060?Sko`2a];T0C4mD0?koo`3jno/0nO[j
0P3nood04@3lo_/0o_om0?[ln@3oood0no_i0=CDe00V9RH0000200<21@0000800P4406MWI`3UiND0
oooo0?gmo@3oool0oOgm00<0oooo00L0o_kn0?clo03oool0oooo0?_kn`3jn_X0oooo00<0ooom00H0
K6a/07QhN03oo_l0ooko0?glo`3noOl20?ono`080?gmo@3oool0o_kl0;6a[`1HF5H04Q8B06a/K03A
dM420?ooo`030?[jnP3moOd0oooo00<0oooo00D0no_k0?ooo`3lo?`0oooo0?clo0020?ooo`0:0?gm
o@3lo?`0oooo0?gmo@3kno/0oooo0?gmo@3oool0DU9B0861P@80oooo00<0m?Cd0?ooo`3oool0503o
ool00100oooo00@0o_kn0?ooo`3moOd0o_kn0P3oool01`2XZ:P0@d=30?ooo`3oool0n_[j0?knoP3o
ool00P3no_h;0?ooo`040?gmo@3oool0oooo0?knoP<0oooo00h0o_kn0?ooo`26QXH06a/K0:FUY@3h
n?P0oooo0?Ogm`3lo?`0oooo0?gmo@3no_h0oooo0?knoP80oooo00@0oOgm0?ooo`3no_h0o?cl1@3o
ool07@3kno/0o_kn0?ooo`3oool0nOWi0?_kn`3oool0m_Kf0?clo03kno/0o_kn0?[jnP3oool0no_k
0?ooo`3kno/0oooo0?[jnP3oool0dM7A028R8P1YJFT0o?cl0?ooo`3kno/0oooo0?gmo@3oool0n?Sh
02X0oooo00<0o_kn0?ooo`3moOd00P3oool02P0Z:RX0000000<30`0_;bl0n?Sh0?_kn`3oool0o?cl
0?knoP3moOdC0?ooo`040??cl`3oool0oooo0?;blQT0oooo00H0o?cl0?ooo`3moOd0nOWi0;jn_P01
0@420000000407inOP3oool0oooo0?Win@<0oooo00<0o_kn0?ooo`3oool07P3oool20?ono`@0oooo
0P3oood08@3lo?X0o_om0?cmo@3in_`0nocn0?koo`3Fem/000450>SYj`3nool0m_Oi0?cmo@3nool0
o?gm0?goo03nood0moOe0?ooo@3oool0V9RH01lO7`061PH01`H901HE601SHf<04a<C055AD@2h^;P0
no_k0?ooo`3^k^h0oooo0?_kn`030?ooo`0@0?knoP3oool0oooo0?knoP3oood0oOgk0?7al@0E5AD0
iNGU0?Gem@3noOl0no[m0?ckoP3kn_d0o?cl0?knoP80oooo0P3oood03@3Ti>@0Ng]k01lO7`0d=3@0
WinO0?[jnP3oool0moOg0?ooo`3kno/0o_kn0?ooo`3lo?`00`3oool03`3moOd0o_kn0?ooo`3oool0
n_[j0?clo03oool0lo?c0?ooo`3moOd0LW9b09BDU03no_h0oooo0?[jnP0F0?ooo`004P3oool0203l
o?`0oooo0?gmo@3no_h0Fe]K09jNWP3lo?`0o_kn0P3oool0103no_h0oooo0?ooo`3moOd:0?ooo`0I
0?clo03oool0o_kn0?ooo`3no_h0no_k0?[jnP3oool0no_k0?gmo@1OGel0GUiN0?ooo`3moOd0oooo
04A4A01HF5P0YZJV0?clo03moOd0nOWi0?clo03oool0nOWi0?clo0030?ooo`060?Cdm03oool0oooo
0?ooo`3gmoL0oooo0P3kno/60?ooo`0@0?_kn`3oool0lo?c0?ooo`3inOT0oooo0?[jnP3oool0V9RH
00d=3@2`/;00no_k0?knoP3dm?@0oooo0?gmo@80oooo00<0o?cl0?gmo@3oool0:03oool03P3moOd0
o_kn0?knoP3oool0oOgm0=GEe@0>3Ph020P80000001XJ6P0oooo0?Win@3oool0o_kn4@3oool01`3l
o?`0oooo0?[jnP3oool0o_kn0?ooo`3jn_X06P3oool02P3kno/0oooo0>c/k00L71`00`<300000019
BDT0oooo0?KfmP3kno/20?ooo`030?Win@3oool0oOgm0200oooo0P3oo_l40?ooo`<0ooom00T0no_i
0?ooo`3mo_h0oooo0?koo`34`lH0X:6S0>GVjP3dmOL00`3nool05`3mo_h0nocl0?_mnP3oood0kno]
0?ooo`0l?3`0/;2`04i>CP020@@01@@70<S8b03`l?00WIfM02l_;`0V9RH0R8R80>_[j`3oool0no_k
0?ooo`3kno/0n_[j0080oooo00H0n?Sh0?ooo`3inOL0ooom09fMW@1WIfL20?ooo`@0ooko00H0oooo
0?_kn`3lo?`0oooo0?ooo@3jn_P20?ooo`070?_kn`2i^KT0BTY:01DE5@1UIFD0gmoO0?knoP030?oo
o`080?[jnP3oool0o_kn0?_kn`3lo?`0oooo0?_kn`3moOd20?ooo`0709nOW`3>c/h0o_kn0?ooo`1h
N7P0Q8B40?[jnP020?ooo`030?_kn`3oool0oooo01<0oooo000A0?ooo`080?gmo@3lo?`0oooo0?oo
o`3jn_X071`L0=cLg03no_h20?ooo`050?knoP3inOT0oooo0?ooo`3no_h02P3oool0103no_h0oooo
0?_kn`3oool20?gmo@80oooo00`0n_[j0?ooo`3clo<092@T09VIV@3lo?`0n_[j0?Ogm`2CTi<0AdM7
00/;2`3gmoL20?ooo`060?clo03oool0o?cl0?[jnP3oool0no_k0P3oool00`3lo?`0oooo0?gmo@03
0?ooo`030?clo03moOd0oooo00<0oOgm00@0oooo0?gmo@3oool0no_k0P3oool01@3/k>`0FEUI034a
<@3GemL0n?Sh00<0oooo00<0no_k0?ooo`3moOd00P3oool00`3kno/0oooo0?ooo`0V0?ooo`030?[j
nP3oool0o?cl0080oooo00P0o_kn0?gmo@2LW9`0000000410@061PH0YjNW0?knoQH0oooo00D0m_Kf
0?_kn`3no_h0Fe]K0?Shn00J0?ooo`0>0?_kn`12@T8000000000000P8200h^;R0?ooo`3no_h0nOWi
0?ooo`3kno/0o?cl0?ooo`3no_hP0?ooo`80ooko103oool30?ooo@0S0?gmn`3no_`0o?cj0?Oem01[
Jf/0o_cm0?Gdm`3loOl0Rhb@0=7BeP3gn?X0o_oo0?gnoP3loOd0o_oo0?knoP3oool0e]KF01/K6`3j
n_X0oooo07AdM0020P80HV9R0?ooo`3no_h0n_[j0<?3``1UIFD04Q8B05IFEP30`<00no_k0?ooo`3j
n_X00P3oool01P3jn_X0oooo0?ooo@3lo?X0oooo0?Ogm`80oooo00D0nOSk0?ono`3oo_l0oOco0?gm
o@030?ooo`80ooom00h0n?Sh0?ooo`3oool0n_[j0?_kn`3Lg=`0O7al01TI6@16ATH0[:b/0??cl`3j
n_X0oooo0?gmo@@0oooo00X0o_kn0?gmo@3jn_X0Jf][02LW9`3`l?00o?cl0?ooo`1aLG40R8R80P3o
ool00`3lo?`0oooo0?ooo`0D0?ooo`00403oool02P3lo?`0oOgm0?ooo`3no_h0oooo0=KFeP0R8R80
o?cl0?ooo`3moOd40?ooo`80o_kn303oool01P3jn_X0oooo0?gmo@3oool0no_k0?Win@80oooo00H0
o?cl0>_[j`1YJFT0gmoO0?ooo`3jn_X20?ooo`090>_[j`3inOT0oooo0?knoP3UiND0UYJF0??cl`3o
ool0n?Sh0080oooo00D0o_kn0?ooo`3lo?`0oooo0?_kn`020?ooo`080?Gem@3oool0hN7Q07EeM@1g
MgL0PH610<71`@3lo?`20?ooo`050?[jnP3?cll0:b/[065QH@3dm?@00P3oool01@3no_h0o?cl0?gm
o@3lo?`0nOWi0080oooo00<0moOg0?ooo`3oool0:03oool03P3emOD0o_kn0?ooo`3oool0n_[j0?oo
o`3hn?P0Fe]K00H61P0000004A4A0>3Ph03oool0no_k4P3oool01P3jn_X0o_kn0?ooo`3oool0o?cl
00410AT0oooo00<0o?cl0?_kn`27QhL00P020P802P092@T0/[:b0?ooo`3hn?P0oooo0?gmo@3oool0
o?cl0?ooo`3no_hQ0?ooo`80ooko103oool20?ooo@030?[jn03oood0nOOf0080ookm01H0/:j]08F3
PP3oo_l0c/gB061PIP3no_l0o?go0?koo`3mo_l0o_oo0?[kn`3moOd0oooo06=SH`1lO7`0oooo0?kn
oP3moOd0De=C0000003moOd0o_kn0P3oool03`3jn_X0lO7a096AT@0];Bd0:BTY08V9R@3alO40n_[j
0?KfmP3oool0oOgm0?ooo@3jn_P0o_kn0?ooo`020?clo0080?ono`3noOl0oOco0?ono`3oool0oOgm
0?Shn03jn_X20?ooo@H0oooo00L0o_kn0?Ogm`2RXZ80?clo01/K6`3UiND0l_;b0080oooo00P0o_kn
0?ooo`3fm_H0n_[j0?ooo`1;Bd/0ATI60?KfmP80oooo00D0oOgm0820P026QXH0oOgm0?[jnP0G0?oo
o`00403oool01`3jn_X0oooo0?ooo`3oool0n_[j09>CT`1TI6@00P3oool00`3inOT0oooo0?ooo`02
0?ooo`030?[jnP3no_h0oooo00P0oooo00H0o?cl0?ooo`3oool0o?cl0?ooo`3lo?`30?ooo`060?Sh
n03lo?`0oooo0?_kn`3oool0o?cl0P3oool02`3jn_X0moOg0?ooo`3hn?P0oOgm0?ooo`3_knl0Fe]K
00`<3012@T80_[jn0080oooo01D0n_[j0?ooo`3moOd0oooo0?clo03jn_X0oOgm0?ooo`3[jn/0I6AT
0?ooo`3hn?P0oOgm0<o?c`1iNGT0IVIV0:ZZZP2HV9P06QXJ09bLW03lo?`00P3oool00`3gmoL0oooo
0?ooo`040?ooo`030?[jnP3oool0no_k02T0oooo00<0oOgm0?clo03inOT00P3oool0203lo?`0oooo
0?;blP0M7Ad00P8200D51@0i>CT0n?Sh4P3oool0203inOT0oooo0?ooo`3oool0n_[j0?ooo`000000
no_k6@3oool02`33`l<00@41000000000000LW9b0?ooo`3lo?`0oooo0?Ogm`3no_h0o?cl0080oooo
00<0no_k0?ooo`3oool07`3oool20?koo`@0oooo0P3oo_d0703ooO`0noWh0?onn`3nn_L0ookk0?ol
n@1>BTL0dLo@030_=03UiN/0moOm0?koo`3hnOd0o_oo0?cmo`3nool0o_kn0?KfmP0<30`0kNg]0?gm
o@3lo?`0no_k0?ooo`2>SXh0bl_;0?Shn03jn_X30?ooo`070?knoP3kno/0`l?305IFEP0J6QX0GEeM
0<_;b`020?gmo@040?clo03oool0o_kn0?gmo@80oooo00D0moOg0?ooo`3oool0n_[j0?Win@030?oo
o`050?knoP3oool0oooo0?gmo@3kno/00P3no_h01`3jn_X0no_k0?ooo`3oool0moOg03Ph>02TY:@0
0P3oool03P3emOD0oooo0?ooo`3no_h0oooo0?knoP21PH40oooo0?clo03kno/0o_kn0?_kn`32`/80
]kNg0`3oool00`3jn_X0oooo0?ooo`0C0?ooo`004P3oool01P3inOT0oooo0?knoP1OGel0WYjN0?[j
nP<0oooo00@0no_k0?clo03oool0no_k2P3oool00`3kno/0oooo0?ooo`020?ooo`090?_kn`3oool0
oooo0?ooo`3moOd0oooo0?[jnP3oool0oOgm0080oooo00@0n_[j0?ooo`3oool0o?cl0P3oool07P3m
oOd0oooo0?knoP3emOD0ZJVY09BDU03oool0n?Sh0?ooo`3bl_80o?cl0?gmo@3oool0o_kn0?ooo`3n
o_h0CDe=0?Shn03no_h0oooo0?knoP3kno/0oooo0?Ogm`1HF5P05ADE05ADE02NWYh0j^[Z0?[jnP<0
oooo00@0o?cl0?ooo`3oool0no_k0P3oool00`3kno/0oooo0?ooo`0W0?ooo`050?clo03oool0oooo
0?ooo`3kno/00`3no_h01P3jn_X0clo?00<30`0000000P820820P080oOgm503oool20?knoP030041
0@3oool0oooo01L0oooo00h0inOW01`L700000000@410492@P3jn_X0oooo0?clo03inOT0oooo0?kn
oP3oool0n?Sh0?knoR80oooo0P3nool40?ooo`<0ookm01<0oO_j0?omnP3oo_/0n_Kc0?onn`3/j>D0
0@000:ZY[`3no_l0oOgo0?kno`3nool0nO[n0?koo`3loOl0o_kn09FEU@1HF5P0n_[j00<0oooo00<0
o?cl0?ooo`3kno/00P3oool00`3kno/0o_kn0?knoP030?ooo`080?knoP3Xj>P0SHf=024Q8@0^;Rh0
U9BD0??cl`3no_h20?ooo`030?_kn`3oool0oooo00@0oooo00<0oOgm0?clo03oool00P3oool00`3m
oOd0oooo0?ooo`040?ooo`80o_kn00@0dm?C01TI6@3oool0o?cl0P3oool0103kno/0o?cl0?ooo`3l
o?`20?ooo`030?_kn`3oool0oooo0080oooo00D0o?cl0?ooo`3moOd0oooo0?clo00F0?ooo`002P3o
ool00`3hn?P0oooo0?ooo`020?ooo`80o_kn00H0oooo0?gmo@3oool0oooo02`/;037alLa0?ooo`0;
07moO`0j>SX0SHf=0>;RhP3no_h0oOgm0>WYj@2=SHd0o_kn0?ooo`3no_h00P3oool0303Jf]X0:RXZ
05UIF@3dm?@0oooo0>KViP2HV9P0KFe]09:BTP3Hf=P0oooo0?knoP<0oooo00<0no_k0?Shn03oool0
0P3lo?`20?ooo`070?knoP3oool0oooo0?_kn`3no_h0oooo0?gmo@030?ooo`030?knoP3oool0oOgm
0280oooo00D0R8R8000000061PH000000<30`0020?knoP050?ooo`3no_h0oooo0?_kn`3no_h02P3o
ool01`3no_h0oooo0?gmo@3moOd0oooo0?knoP2VYZH04`3oool02`3inOT0oooo0?ooo`3oool0o?cl
0?knoP17AdL02PX:0000000E5AD0i>CT0080oooo00<0o?cl0?ooo`3oool09P3oool20?koo`@0oooo
0P3oo_l0103mnoX0ookm0?omo@3on_X20?onn`030?Sdl@3Qgmh0mOCj0080o_ko00P0m_Kl0?gno`3n
ool0o?go0?koo`3kno/0:BTY0;no_`80oooo00<0n_[j0?ooo`3moOd02P3oool0303kno/0oooo0?kn
oP3no_h0_[jn05=CD`0A4A40UYJF0?ooo`3lo?`0o_kn0?gmo@<0oooo0P3no_h01P3oool0o_kn0?oo
o`3no_h0oooo0?gmo@80oooo00<0n_[j0?ooo`3no_h00P3oool00`3lo?`0KVi^07]kN`020?ooo`09
0?[jnP3oool0oOgm07MgM`3oool0o_kn0?ooo`3moOd0o_kn01l0oooo00080?ooo`080?Win@3kno/0
oooo0?clo03no_h0nOWi0?ooo`3kno/30?ooo`050?clo03jn_X02PX:0?gmo@3inOT0<03oool0203j
n_X0^[Zj05]KF`0H61P0clo?0?knoP2CTi<0k^k^0P3oool04P3`l?00oooo0::RXP0A4A40X:2P0?oo
o`3moOd0oooo0?gmo@3lo?`0oooo0>o_k`2][Jd0J6QX08J6QP3IfMT0nOWi0?_kn`<0oooo00L0oOgm
0?ooo`3emOD0o?cl0?ooo`3fm_H0nOWi0080oooo00D0o?cl0?ooo`3oool0oOgm0?[jnP0S0?ooo`80
oOgm00P0nOWi04A4A00000001`L701XJ6P3/k>`0oooo0?knoP@0oooo00<0no_k0?gmo@3oool01`3o
ool0203jn_X0oooo0?[jnP3oool0n_[j0?knoP3oool0n_[j403oool03P3jn_X0oooo0?ooo`3gmoL0
nOWi0?ooo`3moOd0T92@00<30`00000020P80;Fe]@3no_h0nOWi:P3oool20?koo`@0oooo0`3oo_l0
103oo_d0oogm0?okn`3ooOd20?onn`040?WgmP3oo_l0moOm0?gmo`80o_oo00L0o?go0?koo`3jnod0
b/[:02TY:@3hn?P0oOgm0080oooo00<0oOgm0?ooo`3oool01`3oool0103hn?P0oooo0?ooo`3kno/4
0?ooo`030=?Cd`0410@0lo?c0080oooo00X0n_[j0?knoP3moOd0mOGe0?ooo`3kno/0oooo0?Win@3o
ool0nOWi0P3oool01P3emOD0oooo0?ooo`3gmoL0oooo0?knoP80no_k00/02`/;0>o_k`3no_h0mOGe
0?ooo`3]kNd0A4A404U9B@3gmoL0oooo0?Win@020?ooo`030?Win@3moOd0oooo01`0oooo000:0?oo
o`040?Gem@3no_h0oooo0?Shn0<0oooo00L0no_k0?ooo`3oool0alO702d];@3oool0o_kn03<0oooo
00P0n?Sh0>KViP3no_h0JVYZ0?ooo`0a<C400000014A4@809BDU00<0f=SH0?Ogm`3no_h00`3oool0
0`3no_h0n_[j0?clo0020?ooo`060?;blP2b/[80Jf][07moO`34a<@0n_[j2@3oool00`3gmoL0oooo
0?knoP030?ooo`030?[jnP3inOT0o?cl0240oooo00d0n_[j0?ooo`3Zj^X04a<C000000071`L0C4a<
0?knoP3oool0o?cl0?Win@3oool0o_kn00d0oooo00@0lo?c0?ooo`3oool0l_;b4`3oool02@3gmoL0
oooo0?clo03oool0a<C400<30`010@401@D506EUI@020?ooo`030?clo03oool0o_kn02P0oooo0P3o
ood40?ooo`050?ono`3oool0oooo0?ooo`3ooOh00P3oo_d0203no?/0oook0?ono@3oo_l0n?Sn0?kn
o`3nool0noco0`3nool0201FEUH0RHV90?ooo`3kno/0oOgm0?ooo`3lo?`0o_kn2@3oool20?knoP0=
0?gmo@3oool0no_k0?Gem@3oool0Lg9e07IeN03jn_X0oooo0?knoP3oool0ooom0?gmn`020?ooo@04
0?gmo@3oool0oooo0?_kn`80ooko00H0n_[j0?ooo`3oool0n_[j0?ooo`3jn_X20?ooo`0809NGU`1A
DE40n?Sh0?gmo@3oool0nOWi01lO7`1dM7@20?ooo`040?KfmP3oool0no_k0?Ogmal0oooo00080?oo
o`040?_kn`3inOT0oooo0?gmo@80oooo00@0n?Sh0?ooo`3oool0n_[j0P3oool00`2=SHd0L71`0?Ge
m@0a0?ooo`030?knoP3lo?`0m_Kf0080oooo00P0kno_09:BTP2UYJD010@400d=3@020P80000002HV
9P<0oooo0P3jn_X01P3moOd0oooo0?ooo`3oool0o_kn0?gmo@<0oooo00L0oOgm0;jn_P1fMWH0Lg=c
0;bl_03jn_X0o_kn00<0oooo00@0o_kn0?ooo`3oool0no_k0P3oool01@3lo?`0oooo0?ooo`3oool0
o?cl0200oooo0P3no_h01`3oool0o_kn0;Bd]00410@01`L70000002CTi<00P3oool01@3inOT0oooo
0?gmo@3oool0o?cl00P0oooo00L0o?cl0?ooo`3jn_X0oooo0?knoP3oool0n_[j0180oooo00H0o_kn
0?ooo`3kno/0oooo0>c/k00N7Qh20000000703Lg=`3oool0oOgm0?clo03no_h0oooo0?_kn`0X0?oo
o`80ooom103oool30?ono`080?knoP3oool0oooo0?ono`3jn_P0oO_j0?ooo@3in_h20?koo`0=0?_l
oP3loOl0o_oo0?Sin@3]k^h04a<C0?7al@3kno/0o?cl0?ooo`3moOd0oooo0?gmo@090?ooo`040?[j
nP3oool0oooo0?knoP80oooo0280m_Kf01<B5@3Kf]d0oooo0?Ogm`3no_h0oooo0?[jn03oood0o_kl
0?Kfm03oool0o_kn0?clo03oool0oOco0?[io03oool0oOgm0?ooo`3kno/0oooo0?clo03oool0mOGe
02`/;02k^k/0oooo0?gmo@3oool0gMgM0:RXZ03oool0n_[j0`3oool0103inOT0o_kn0?ooo`3hn?PM
0?ooo`002@3oool03@3inOT0oooo0?ooo`3moOd0nOWi0?ooo`3moOd0oooo0?knoP3oool0oOgm06AT
I02FUYH0=@3oool01@3inOT0o_kn09VIV@3Xj>P0:RXZ0080000000H010@400410@0;2`/0k^k^0?gm
o@3jn_X90?ooo`0>0?Win@3lo?`0oooo0?Ogm`3oool0nOWi0=3@d01gMgL0MGEe0:f][@3emOD0oooo
0?_kn`3moOd30?ooo`050?knoP3moOd0oooo0?gmo@3kno/08@3oool03P3no_h0oooo0?Win@3kno/0
oooo06e]K@0000002PX:00/;2`3;bl/0no_k0?ooo`3kno/0o_kn3@3oool01@3fm_H0no_k0?knoP1K
Fe/0n?Sh0100oooo00X0o_kn0?_kn`3oool0no_k0?[jnP1FEUH00`<30000000A4A40hN7Q0`3oool0
0`3moOd0oooo0?ooo`0X0?ooo`@0ooom0P3oool20?ono`0;0?ckoP3noOl0ooko0?koo`3oool0o_oo
0?ooo`3nool0o?go0?koo`3jnod0103nool01`2;SHX0G5aJ0?kno03moOd0o_kn0?ooo`3gmoL00P3o
o_l80?ooo`030?Win@3no_h0oooo0080oooo00D0n?Sh0?ooo`2<S8`0E5=F0?ono`030?ooo`0=0?Wi
n@3oood0_[jl0000001CDe40MGEe0?ooo`3moOd0oooo0?_jo@3oo_l0oooo0?Shn0020?ooo`060?kn
oP3oool0l?3`0<k>cP0W9bL0o_kn0P3oool0103inOT0mOGe0?knoP3moOd20?ooo`050?[jnP3gmoL0
oooo0?ooo`3fm_H07P3oool000P0oooo00<0m_Kf0?ooo`3kno/00`3oool0203lo?`0oooo0?ooo`3o
ool0oOgm0?ooo`0Y:BT0b<S8<P3oool03P3no_h0oooo0?[jnP3moOd0no_k06a/K03oool0=cLg00H6
1P0000000@410000000I6AT0n?Sh0P3oool01P3lo?`0oooo0?knoP3lo?`0no_k0?knoP80oooo00<0
oOgm0?ooo`3no_h00P3oool02P3lo?`0oooo0?[jnP3no_h0oooo0=7Ad@23Ph<0KVi^0:^[Z`3/k>`3
0?ooo`80o?cl0P3oool00`3kno/0oooo0?ooo`0S0?ooo`030?Cdm03lo?`0>CTi0080000000H0;2`/
0?KfmP3kno/0o_kn0?ooo`3gmoL:0?ooo`060?[jnP3no_h0oooo0?ooo`3lo?`00@414P3oool0103j
n_X0oooo0?ooo`2DU9@20000000900410@2_[jl0oooo0?ooo`3dm?@0oooo0?knoP3oool0o?cl02P0
oooo103oood20?ooo`80ooko00<0o_go0?koo`3nool00P3mo_l20?koo`050?gnoP3nool0nocn0?cm
o`3mo_h00P3nool01P3jo?T07b4N0<_;b@3moO/0oooo0?knoP80oooo00<0no[m0?ono`3oool02P3o
ool02@3gmoL0oooo0?ooo`3kno/092@T0<?2a@3oo_l0mOGe0?_kn`020?ooo`80ooom00T0a<C20;Rh
]P3alO40o_kn0?gmo@3lo?`0ooko0?ckoP3no_h00P3oool02P3kno/0oooo0?ooo`3oool0GemO08F5
Q@3alO40MWIf0?_kn`3lo?`20?ooo`80oOgm00D0n_[j0?ooo`3oool0nOWi0?clo00O0?ooo`00203o
ool0203moOd0oooo0?ooo`3lo?`0oooo0?gmo@3oool0no_k0P3oool01@3kno/0mOGe00h>3P3jn_X0
nOWi0340oooo0140no_k0?ooo`3oool0oOgm0?clo027QhL0lo?c0;2`/0092@T0000000820P000000
XZ:R0?Win@3oool0nOWi0?gmo@070?ooo`090?knoP3moOd0nOWi0?clo03oool0mOGe0;2`/00@4100
h^;R0080oooo00L0o?cl0?ooo`3Jf]X0TY:B06MWI`2PX:00g=cL00@0oooo00<0o_kn0?ooo`3oool0
8P3oool02P3lo?`0oooo0?ooo`3Jf]X03@d=00820P000000HF5Q0?ooo`3lo?`20?ooo`030?KfmP3o
ool0oooo00H0oooo00P0nOWi0?ooo`3oool0oooo0?[jnP3oool000000?_kna40oooo00P0n_[j0?oo
o`3@d=000`<30000000820P0IfMW0?clo080oooo00@0o?cl0?ooo`3no_h0n_[j:@3oool01P3oo_d0
oook0?ooo@3oood0oooo0?ono`D0o_oo0P3jo_l20?_oo`040?[no`3mo_h0o_oo0?koo`80n_ci00/0
o_om0;:d/@0b=340o?cj0?ooo@3kno/0oooo0?kmo`3oo_l0o?_n0?kmo`080?ooo`090?knoP3lo?`0
oooo0?ooo`3lo?`0oooo0:f][@0i>CT0o?_n0080ooko00<0n_[j0?ooo`3lo?X00P3oood00`3lo?X0
^;Rf0:b/ZP020?ooo`80n_Wl00`0ooko0?ooo`3moOd0oOgm0?ooo`3lo?`0o_kn0?;blP092@T0aLG5
02HV9P2HV9P30?ooo`030?gmo@3oool0o_kn00D0oooo00<0oOgm0?ooo`3oool0703oool0000E0?ko
o@3oood0ooko0?ono`3oool0ooom0?oon`3oood0ooko0?Sio@3mo?l0ooko0;2ZZP0<1`L0jn[]0?ko
o`3noOl0o_kn0?ooo`3;bl/0;2`/0080oooo00<0o?cl0?ooo`3oool0;`3oool02`3hn?P0oooo0?gm
o@2k^k/0d=3@0?ooo`3no_h0/k>c04I6AP0V9RH0[Jf]00<0oooo00<0o_kn0?ooo`3oool0103oool0
3P3no_h0o_kl0?omo@3oo_d0o_oo0?coo`3jnO`0ookm0?_hl@1LFeH0l??g0?[mo`3mo?l0oO_n0P3o
o_l02@3no_`0oook0>CThP2OWil0JVYZ08n?S`3Ogml0oooo0?gmo@0R0?ooo`030?gmo@3lo?`0oooo
0080oooo00T0n?Sh0:JVYP030`<0000000410@2^[Zh0nOWi0?ooo`3no_h03@3oool20?knoP030041
0@3oool0oooo00l0oooo00P0n_[j0?ooo`3_knl07QhN00D51@000000<C4a0?knoPD0oooo00<0oOgm
0?knoP3no_h0:03oool20?ono@040?ooo@3oool0oooo0?ono`<0o_oo00D0oOko0?koo`3lool0o_oo
0?coo`020?koo`0@0?cmo@3nool0o_om0?goo03nood0nogj059DD@2HVYL0ooom0?Wim`3no_h0oooo
0?glo`3jnO`0ooko0?kmo`P0oooo00<0o_kn0?ooo`3lo?`00P3oool03`3gmoL0@D510:VWYP3oo_X0
o?_g0>[]lP3lo_l0ooWo0?Scm`3lool0n?kj0?onm`3oooX0T96C0<_>d`020?kno`050?ooo@3Sh]h0
_Kfk0?ooo`3no_h00P3oool01@3kno/0T92@055AD@0D51@0X:2P0080oooo00<0no_k0?ooo`3gmoL0
0`3oool00`3moOd0oooo0?Win@020?ooo`030?_kn`3oool0oooo01/0oooo00005`3kooL0o_ok0?om
o`3on_l0ookm0?kmmP3hmN`0WYfI09fMY@2[[KT0ooko0?ojo@3oknd0JemN0>k^mP3kool0o_oo0?oo
o`3no_h0UYJF06EUI@3oool0o_kn0340oooo00/0o_kn0?ooo`3oool0oOgm09>CT`3hn?P0oooo0?_k
n`3no_`0nOWg0?gmo@020?ooo`070?knoP3oool0oOgm0?gmo@3oool0ooom0?gmn`020?ooo@0C0?gm
n`3ooo/0oocg0?omnP3kool0mooo0?koo`3onoL0oo_T0:JRTP2d_/L0loko0?omo`3on_l0oo_o0?gk
o`3oooX0oooe0?oon`020?ooo`050>WYj@2NWYh0JFUY08b<S03Cdm<00P3oool0203hn?P0oooo0?oo
o`3oool0o?cl0?knoP3oool0oOgm0`3oool01P3jn_X0oooo0?knoP3oool0o?cl0?gmo@80oooo00<0
o?cl0?gmo@3oool0403oool01@1KFe/01`L70000000>3Ph0gmoO0080oooo00<0oOgm0?ooo`3moOd0
0P3oool01P3hn?P0oooo0?ooo`3oool0o_kn0?ooo`80oOgm00<0oooo0?knoP2VYZH02P3oool03P3i
nOT0o_kn0?ooo`3no_h0nOWi0?ooo`3lo?`0oooo0?_kn`1HF5P01@D50000000?3`l0g]kN>@3oool0
1P3oo_l0oooo0?ono`3nool0oooo0?koo`<0oooo00P0n_[j0?ooo`3oool0o?cl0:f][@0?3`l0l_;b
0?knoP<0oooo00@0o_kn0?ooo`3moOd0oooo0`3no_h40?ooo`040?gmo@3oool0oooo0?[jnP80oooo
01l0b<S801lO7`3kn?40oo_W0>3Jc0000Ph0:C180<>cb`0800/0ZkVj0?7on03Xi]D0ooc`0;g1b01[
LhD0n?co0?cno`3oooP0k^cM02XY900Y:BT0TI6A0?Cdm03lo?`0oooo028R8P20P800c/k>0?clo03o
ool0nOWi0080oooo00D0n_[j0?ooo`3lo?`0oooo0?_kn`020?ooo`030?knoP3oool0oooo01d0oooo
00004@3kooP0o_ok0?olo`3oo?l0oogf0?omm03mnOD0i>;S01DC7P38am@0oO_o0?olo`3on_H0Z9ZG
0;Jf`03iool0o_oo0080oooo00@0JVYZ09:BTP3oool0o?cl<P3oool0103inOT0oooo0?ooo`1kNg/2
0?_kn`060?ooo`3oood0ooom0?ooo`3inOT0o?cl0`3oool06`3kno/0oooo0?ooo@3no_`0n_[h0?oo
o@3ooo/0oogi0?oimP3hk^`0k_Cd0?Coo`3hool0o_oj0?ooiP3Je<80IF]i0?Ono`3lnOl0oOWo0?ol
o`3mnol0oOcg0?oom@3knoL0oooo0?Win@030?ooo`070>[ZjP2f][H0IVIV08B4Q03?cll0n_[j0?Sh
n0050?ooo`040?clo03oool0nOWi0?knoP@0oooo00<0o_kn0?_kn`3moOd00P3oool00`3lo?`0oooo
0?ooo`0>0?ooo`060?Gem@0N7Qh00@4100@4100j>SX0kno_0`3oool00`3jn_X0no_k0?ooo`020?oo
o`0:0?clo03oool0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0?[jnPP0oooo00<0no_k0?ooo`3m
oOd00`3oool0103emOD0oooo0?ooo`2QXJ43000000030:b/[03hn?P0oooo04@0oooo00L0n_[j08J6
QP000000HF5Q0<G5a@3oool0no_k0080oooo00<0n_[j0?gmo@3oool0103oool09P3lo?`0oOgm0?oo
o`3oool0oOgm0?Ogm`3oool0no_k0?KfmP1WIfL0RXZ:0?omm@3on=l0W9F304eJJ`3co?l08``T01`7
5P2P/KH0j?ok0>KWe`19ACT00PH=0;g5e`3ho_l0n_co0?oon03ooo40oOcg0<?3``1MGEd03@d=06QX
J02JVYX0<C4a0?Shn03oool0o?cl0P3oool0103inOT0no_k0?ooo`3no_h30?ooo`030?Ogm`3lo?`0
o_kn01l0oooo00005`3ioO`0n?Wi0?omo`3ooOX0oooa0?ool`3inOl0ooco07E]N02]YJh0o_ko0?kn
oP3oo?H0h=KD07EdP@3en?l0o_ko0?gmo@3oool0;bl_0<c<c03oool0o?cl0340oooo00/0no_k0?oo
o`3oool0moOg0;Rh^02OWil0oooo0?clo03oood0nOWg0?clo0020?ooo`80o_kn0P3oool00`3jn_X0
n_[h0?ooo@020?ooo@0C0?knnP3onOT0H4mE08n0P`23Q7`0PHj40>[oo`3bool0m?GU0?omm01QF6P0
ln_o0?omo`3fnOl0noko0?koo`3ooo/0oooj0?clnP020?ooo`030?knoP3gmoL0moOg00<0oooo00D0
n?Sh0;Jf]P1jNWX0NWYj0;bl_0020?knoP030?gmo@3jn_X0oooo0080oooo00@0n_[j0?ooo`3hn?P0
oOgm0`3oool00`3no_h0o?cl0?knoP0B0?ooo`070<g=c@0820P000000000001nOWh0oooo0?Shn003
0?ooo`040?clo03oool0oooo0?[jnP@0oooo00@0lo?c0?ooo`3oool0l_;b2P3oool03@3hn?P0o_kn
0?gmo@3oool0no_k0?knoP3oool0clo?00<30`0000000`<306e]K@3moOd0A03oool02P3lo?`0n_[j
0?ooo`3emOD02`/;07alO00P8200<30`0:2PX03_knl20?ooo`050?_kn`3no_h0oooo0?_kn`3hn?P0
0P3oool01@3no_h0no_k0?ooo`3oool0oOgm0080oooo0200i^KV00d=3@3]kNd0oooh0?ooj03;a;T0
1PdU0?7do`3hh^D03@000<gNiP3]ool0o?om0?_jm@3al_@0nooo0?Wlo`3nool0ooom0?knnP3oood0
o_kn0?Gem@33`l<0B4Q80000000S8b<0[Jf]0?Win@3oool0n_[j0?Ogm`80oooo00D0mOGe0?ooo`3o
ool0moOg0?gmo@020?ooo`030?knoP3oool0o?cl01d0oooo00005`3no_l0ooko0?omo@3ono<0ooo/
0=cLd00001408Ale08]kQ@1NDU@0o?oo0?Soo`3oo_P0no?`05eKJ03jo?l0o_ko0?knoP3oool02PX:
0??cl`3oool0o_kn0380oooo00`0mOGe0?ooo`3oool0oooo0;Jf]P1^KVh0lO7a0?ooo@3jn_P0o_kn
0?ooo`3inOT20?ooo`0K0?Gem@3inOT0oooo0?ooo@3no_`0no_i0?kno03ooo/0oo[j02LJ8@3SemT0
oood096KSP1BIVD0kooo0?konP3Rf]L06@dI0=G<g03fnOl0nOoo0?WmoP3nool0ookm0?_in03oool0
n_[j00@0oooo00/0o_kn0?gmo@3no_h0no_k0?knoP3oool0n?Sh0<[:bP1iNGT0Kfm_0;>c/`020?oo
o`040?Ogm`3kno/0oooo0?_kn`<0oooo00H0oOgm0?knoP3oool0oooo0?gmo@3lo?`@0?ooo`80oOgm
00D0Rh^;000000061PH000000;^k^`020?ooo`040?knoP3oool0oOgm0?_kn`80o_kn00P0oooo0?cl
o03oool0n_[j0?ooo`3no_h0oooo0?[jnPX0oooo00<0no_k0?ooo`3no_h00`3oool02@3Zj^X09BDU
00L71`061PH0:2PX0??cl`3no_h0oooo0?[jnP110?ooo`0=0?clo03oool0oooo0?Shn03oool0N7Qh
07AdM03oool0]kNg059BDP0<30`0Jf][0=KFeP020?ooo`030?Win@3no_h0oooo00D0oooo02@0o_kn
0?ooo`3oool0oooo07MgM`1WIfL0oooo0?omn@3ooNh0l>_S01HK;`3Qgo@0ooW^089aI@1mSI`0j_oo
0?Woo`3dm?00oook0?ooo@3lo?`0oOco0?[ko@3nool0o_kn0?ooo`2f][H06a/K0;^k^`0@4100YZJV
03De=@0G5aL0P8200>?Sh`3oool20?knoP80oooo00H0o_kn0?ooo`3moOd0m_Kf0?ooo`3lo?`O0?oo
o`0001P0o_co0?kko`3ooO/0ooca0?ghhP2c/jT01`dU0?Gdo`0e82<07`d70?3en@3eool0ooom0>;M
g@0B41/0a/GB0?kmo`3oool0lo?c00X:2P3oool0o_kn0?ooo`3no_hb0?ooo`090?knoP3oool0moOg
0?gmo@3`l?00TI6A06][J@2^[Z`0kno_0080oooo00<0oOgm0?ooo`3oool00P3oool06P3oood0oOgk
0?ooo@3oood0no_g0?oon`2=Rh`0QX610?onn03hm?405QTP0=_Mi`3oo_l0m?;c0?omo`3hn?h0n?oo
0?GooP0n?S`0Thj>0>7LgP3ooOl0oooo0?knoP3lo?`0oooo0P3moOd01P3oool0o_kn0?ooo`3clo<0
c/k>0?KfmP80oooo00/0no_k0?ooo`3De=@0OWin06][J`2][Jd0nOWi0?KfmP3no_h0oooo0?Shn002
0?ooo`050?knoP3moOd0oooo0?ooo`3no_h04P3oool0203lo?`0BDU900410@0000006ATI0>KViP3o
ool0oOgm0P3oool0103moOd0oooo0?ooo`3moOd30?ooo`050?KfmP3kno/0o_kn05]KF`3hn?P0203o
ool00`3no_h0oooo0?clo0020?ooo`070?Ogm`3oool0Hf=S000000030`<02@T90=kNgP030?clo4<0
oooo00h0mOGe0?ooo`3oool0m_Kf0>GUi@0>3Ph0no_k0?knoP3oool0hn?S07emO@0K6a/0@T9209nO
W`80oooo00<0o?cl0?_kn`3lo?`00`3oool05P3lo?`0oooo0?Win@3fm_H05aLG0>CTi03inOT0oogl
0?omn03ooO/0Zjnh034`=@3ol=`0VHeo038lE@3^o_l0m?go0?kon03ooO@0ookg0?ooo`3nool20?on
o`0?0?gmo@2j^[X05aLG0<W9b@23Ph<0HF5Q0?knoP3oool0f=SH06IVIP0J6QX0DU9B0<;2`P3lo?`0
o_kn0080nOWi00H0oooo0:NWY`1NGUh0no_k0?ooo`3moOdN0?ooo`0001@0o_[o0?olo`3ooO/0ookd
0?ook03<cLD02@h[0?kko`3njN@03P000<_BeP3Znol0noko0?ono`3knOl0oogo0?kmo`3oool0e]KF
02PX:080oOgm00<0oooo0?gmo@3oool0;`3oool00`3lo?`0oooo0?gmo@030?ooo`80oOgm00`0nOWg
0=gMf`2:RXX0IFEU0:VYZ@3]kNd0n_[j0?gmo@3oool0o_kn0?[jn03moO/20?ooo@0Z0?knnP3oooX0
e]?<02l[9`3oool0oOco04U5D@2d/;`0oOco0?ooo`3moOd0n?ck0?Ooo`3hool09B@P00@000010080
0`8501`L700n?Sh0EEEE07]kN`20P800KFe]06YZJP1<C4`03`l?00H61P1kNg/0oooo0?Shn03lo?`0
no_k0?ooo`3lo?`0oooo0?gmo@3Shn<0QhN706m_K`2WYjL0jn_[0P3oool00`3moOd0oooo0?ooo`02
0?gmoA80oooo00X0oOgm0?ooo`3/k>`04a<C000000020P80AdM70?Ogm`3oool0no_k103oool0103m
oOd0oooo0?[jnP3no_h20?ooo`030?clo0010@40oooo00T0oooo00X0n_[j0?gmo@3oool0oooo0?_k
n`2QXJ40000000L71`000000ZZZZ0`3oool00`3moOd0oooo0?ooo`0o0?ooo`090?Shn03oool0oooo
0?ooo`3no_h0oooo0?clo01ADE40V9RH00<0oooo00T0oOgm0?clo02YZJT0BTY:00d=3@1fMWH0gMgM
0?ooo`3no_h00P3oool05`3jn_X0oooo0?ooo`3no_h0V9RH051@D03inOT0oooo0?ono@3onoT0oogm
0?coo`2c]K00KV=?06ALD@0001D0h>Wo0?Woo`3dm_40oocc0?oomP3nood0mo_j0080ooko00L0o_kn
08>3P`3[jn/0n_[j01XJ6P3Hf=P0nOWi00<0oooo00h0j^[Z09:BTP0Z:RX0:BTY09JFUP3hn?P0oooo
0?clo02l_;`0>CTi0?ooo`3gmoL0o_kn0?gmoAd0oooo00005@3onoh0ooco0?olo@3lo?X0ooog0?Og
m@1VIGd0MFj20?ohk@2YWH`0DU]R0?7oo`3joOl0no[n0?kmo`3kno/0oooo0?gmo@2UYJD0F5QH0?kn
oP0d0?ooo`030?knoP3moOd0o_kn0080o_kn02D0no_k0?ooo`3oood0o_kl0?gmo@3oool0kno_0<O7
a`2e]KD0`L710<K6aP2`/;00a<C20>o_k@3moO/0o_kl0?oon`3mn_40ooGT04Lk<@11Be/0U:Fc02`_
@03CcmT0ooko0?kmo03oo_X0oool0?Omo03lool0ookj0?7]jP2][Jd0MWQj03Ti>@061PH000000080
0P8200X0000000@4100];Bd0O7al0<W9b@3jn_X0oooo0?knoP3moOd0oooo0P3no_h03`3lo?`0o_kn
0?knoP3lo?`0oooo0?Cdm036a/H0/[:b0<;2`P30`<00][Jf0<;2`P3[jn/0o_kn0?gmo@0A0?ooo`80
o?cl00h0o_kn0=cLg00o?cl00@410000001;Bd/0i^KV0?knoP3oool0o_kn0?ooo`3lo?`0oooo0?cl
o0<0oooo00@0o?cl0?ooo`010@40oOgm203oool01P3no_h0oooo0?knoP3moOd0no_k0820P08010@4
00@05aLG0:^[Z`3oool0no_k0P3oool00`3lo?`0oooo0?ooo`0o0?ooo`0C0?clo03jn_X0oooo0?_k
n`3moOd0oooo0?gmo@3Kfm/0;Bd]0>3Ph03moOd0no_k0?ooo`3moOd0no_k0?knoP3`l?00][Jf08N7
Q`0207MgM`0808F5Q@2_[jl0h>3P0?gmo@3oool0fMWI02l_;`3Lg=`20?ooo`80oo_k01H0ooWg0?_n
o03koo`0o_gf0?omn01THfT0Ngb60?cmo`3oool0o_gl0?cmn03fo_P0d]WC0=oIg@3on_h0o_cm0?_k
n`3no_h0P82006a/K03jn_X0oooo0P3moOd01`3lo?`0oooo0?knoP3moOd0gmoO0:RXZ01kNg/00P1e
MGD01@2BTY803Ph>0?Shn03oool0o?cl01h0oooo0000503ono/0oocm0?glo`3lool0n_on0?koo`3n
m_l0a[S305iDBP1^JEl0>dE<0>?_o@3lo_l0ooco0?koo`3nood0oOgm0?ooo`1aLG40Rh^;0P3no_hc
0?ooo`070?knoP3oool0o_kn0?gmo@3oool0no_k0?ooo`020?ooo@H0oooo02@0no_k0?ooo`3^k^`0
YjNU06YZJ024Q880dM7=0?onm03on^H0`[BY05m^P@3]ool0nOko0?olo`3nnol0ooko0?ommP3oooP0
o?om0?_ooP3oooX0ookj0?gnoP3kool0oooo0>3Ph014A4@020P800820P010@403Ph>00d=3@11@D40
V9RH0>;RhP3kno/40?ooo`030?knoP3inOT0oooo00<0oooo0140nOWi0?ooo`3oool0oooo0?knoP3o
ool0l?3`0:RXZ01dM7@0OWin0<g=c@3oool0o_kn0?Win@3oool0no_k0?clo0040?ooo`080?gmo@3o
ool0oooo0?clo03oool0no_k0?ooo`3inOT20?ooo`0:0?Cdm00l?3`000000000000[:b/0kNg]0?kn
oP3oool0o_kn0?ooo`80o_kn00H0oooo0?gmo@3moOd0oooo0?knoP2VYZH20?ooo`0<0?KfmP3oool0
oooo0?gmo@3oool0no_k0?ooo`3moOd0oooo0?_kn`3lo?`0Jf][0P0000000`0>3Ph0gMgM0?KfmP02
0?ooo`030?_kn`3oool0oooo0380oooo00@0o?cl0?[jnP3oool0oooo0P3no_h0103oool0o_kn0?oo
o`3inOT20?ooo`030?knoP3moOd0oOgm00P0oooo00<0SXj>05aLG03oool00P3oool20?_kn`0]0?oo
o`3no_h0oooo0?ooo`3kno/0oooo0=7Ad@0W9bL00@4105EEE@2j^[X0?Shn0:JVYP3kno/0o?cl0?oo
o`3ooOd0oo_j0?omn`3no_`0o?om0?Ohn03`l>h0]kFd0:BRX`3oo_l0n?Om0?omo`3oool0Phb501<J
4`3`j^X0oo_n0?omo`3inOT0inOW00d=3@3no_h0no_k0?ooo`3lo?`0oooo0?gmo@3oool0o_kn00<0
oooo00P0no_k0?clo03no_h0Hf=S00410@0E5AD0P8200=oOg`80oooo00H0n_[j0?ooo`3lo?`0oOgm
0?ooo`3moOdF0?ooo`0000`0oock0?olo03oo_l0nooo0?Klo03jnod0oo[o0?g^l`3ooOX0n_[f0?Cm
o`3hool20?omo`0:0?OhnP3kooh0o_oo0?ooo`1OGel0X:2P0?gmo@3no_h0oooo0?knoS00oooo00<0
moOg0?ooo`3oool00P3oool00`3moOd0oooo0?ooo`020?ooo@L0oooo02L0o?cl0?ooo@3oood0ooom
0>o_k@2c/jl0KfYR07m_G`2WWI<0000B0>Kdo`3ko?l0o_[o0?olo`3oo_l0oooh0?[kl@3iool0nooo
0?kmmP3ooOH0ooko0?gno`3mo?l0oooo0?_kn`2d];@00@4100L71`0?3`l0e=CD0;Fe]@1PH600410@
03Ph>027QhL0clo?0?ooo`3fm_H00P3oool00`3kno/0oooo0?[jnP020?ooo`040?Shn03no_h0n?Sh
0?clo0<0oooo00h0oOgm0?Win@2i^KT0LW9b07MgM`37alL0oOgm0?ooo`3kno/0oooo0?clo03jn_X0
no_k0?knoPD0oooo00d0no_k0?ooo`3no_h0o_kn0?ooo`3AdM404a<C00410@000000GEeM0?ooo`3k
no/0nOWi0080oooo00L0n_[j0?ooo`3jn_X0oooo0?[jnP3no_h0oooo0080n_[j0P3oool00`3inOT0
o_kn0?ooo`030?ooo`080?_kn`3jn_X0Zj^[0000000:2PX0000009bLW03inOT30?ooo`040?knoP3o
ool0oooo0?knoS00oooo00P0no_k0?ooo`3oool0oooo0?gmo@3no_h0oOgm0?[jnP@0oooo00<0lO7a
0?ooo`3oool02@3oool02@3^k^h04a<C0>SXj03hn?P0oooo0?knoP3oool0n?Sh0?_kn`020?ooo`0@
0?gmo@3oool0oooo08J6QP000000Jf][038b<P000000RHV90?Shn03oool0o_kn0?ono`3oo?`0oogm
0?omo080o_ok00l0ooom0?ono`3hm_T0oOko0?koo`3on_h0L6ia02da<03WjnP0oogm0?okn`3oo_l0
oooo079bLP1cLg<00P3moOd05`3oool0o_kn0?ooo`3lo?`0oOgm0?ooo`3no_h0n?Sh0?ooo`3moOd0
oooo0=[JfP0C4a<0ADE509BDU01XJ6P06ATI04a<C02l_;`0oooo0?_kn`3oool0m_Kf01P0oooo0000
0`3oo?d0oo_k0?_loP020?_oo`0C0?[kn`3onod0oo[m0?olo`3ko_l0n?oo0?SnoP3oo?l0oogo0?co
o`3kool0o_oo0?gmo@0m?Cd0`/;20?knoP3moOd0oooo0?knoP0a0?ooo`070?knoP3clo<0oooo0?oo
o`3moOd0oooo0?clo0020?ooo@H0oooo0P3no_h0503oood0o?cj0?Wim`3oood0oook0?ckmP3kn>d0
S8V204Q7C@1`KW/0_k[:0?ojo`3oo?l0oogo0?gnmP3looH0look0?3jm`3oooH0ookf0`3oo_l20?oo
o`0A0?Win@3GemL02`/;0000001VIVH0oOgm0?KfmP3lo?`0`L71069RHP0Z:RX071`L07MgM`36a/H0
mOGe0?clo03oool00P3lo?`0103no_h0oooo0?ooo`3no_h20?ooo`030?[jnP3oool0oooo0080oooo
00<0n_[j0?ooo`3<c<`00P1_Kfl00`2n_[h0n?Sh0?ooo`030?ooo`050?knoP3oool0oooo0?Win@3l
o?`00P3oool01P3no_h0oooo0?ooo`3oool0Xj>S00820P80000000D0WinO0?ooo`3lo?`0n_[j0?_k
n`030?ooo`040??cl`3oool0oooo0?;blP<0oooo00H0o?cl0?Shn03oool0oooo0?gmo@3gmoL20?oo
o`060=gMg@0820P000000000001MGEd0oOgm0P3oool00`3lo?`0o_kn0?ooo`0e0?ooo`80o?cl00<0
oOgm0?ooo`3oool00P3oool01`3hn?P0no_k0?gmo@3oool0n_[j0?ooo`3fm_H02@3oool00`1RHV80
P8200?ooo`020?ooo`0V0?Gem@3oool0oooo0?ooo`3no_h0oooo0?gmo@3oool0Y:BT0000001<C4`0
GUiN05mOG`1MGEd02PX:00l?3`35aLD0oooo0?ono`3ln_d0oo_k0?oon03Fe/T0U9><0?gko`3lo_l0
lOKi06U]JP3onod0RhB90?_hoP3al?D0ookm0?gln03lo?X0moOg01PH603Jf]X20?knoP<0oooo00D0
oOgm0?clo03oool0o_kn0?_kn`030?ooo`0;06=SH`1kNg/0H61P09RHV03oool0kno_092@T00W9bL0
<C4a09BDU03`l?000P3oool00`3fm_H0n_[j0?ooo`0D0?ooo`0001H0oogm0?ono@3moOd0o?go0?co
o`3oool0oocj0?ogmP3ooOl0o?oo0>kfmP3lood0oogm0?oio03lool0m_ko0?koo`3oool061PH0>?S
h`3oool0oOgm<P3oool0203kno/0oooo0?ooo`3lo?`0b/[:0>;RhP3inOT0o_kn0P3oood70?ooo`03
0?knoP3oood0ooom0080ooom00`0lo?_0>3Pg02LViH0o_[f0?okoP3/i^d0FUaV07UkR01QGVl0/Zjh
0?Kel03nooP20?Soo`070?oomP3mn_40n_Gi0?omo`3noOl0no_k0?gmo@020?ooo`0@0??cl`0/;2`0
00000>g]k@3oool0o_kn0?ooo`3gmoL0oooo0=;BdP1nOWh0;Bd]01PH601UIFD0[jn_0?clo080oooo
00<0n?Sh0?gmo@3oool00`3oool01`3kno/0n?Sh0?ooo`3jn_X0oooo0?KfmP3moOd00P3oool01@3D
e=@0N7Qh06][J`2][Jd0j^[Z0080oooo0100o?cl0?gmo@3oool0oooo0?[jnP3lo?`0o_kn0??cl`3o
ool0oOgm0?ooo`1RHV800@4100<30`0;2`/0clo?0`3oool01`3lo?`0oooo0?[jnP3oool0o_kn0?oo
o`3jn_X00P3oool00`3jn_X0oooo0?ooo`020?knoP<0oooo00H0kNg]02d];@071`L00P8202@T903f
m_H20?ooo`060?clo03moOd0oooo0?ooo`3moOd0o_kn<@3oool00`3kno/0oooo0?ooo`020?ooo`04
0?clo03kno/0oOgm0?[jnP80oooo00<0j>SX03dm?@2GUiL02`3oool02@3De=@0820P0?[jnP3lo?`0
o_kn0?ooo`3jn_X0oooo0?[jnP030?ooo`0N0?Win@2BTY8030`<00820P0E5AD0PH6102<S8`000000
10@4028R8P0/:bh0TY>G0?glo`3lmoT0oogj0?onk@1ADD@0f=SR0?Wlo`1iP8@0/kNf0?omo`3oo?l0
ooWo0?ono`3oool0nogj0?ooo`2YZJT0?Cdm0P3oool0103moOd0oooo0?knoP3no_h50?ooo`080?_k
n`3oool0h^;R01DE5@3Ti>@0RXZ:07EeM@3no_h30?ooo`050;Zj^P1FEUH0410@06MWI`3>c/h05`3o
ool0000E0?_mn03nood0oooo0?_io03lnol0oooo0?oon03oo_X0ooco0?klo`3kool0mocf0?olo@3o
no`0o?oo0?Woo`3mo_h0oOgm00H61P3hn?P0oooo0080o_kn<P3oool01@3kno/0n?Sh0?Ogm`0E5AD0
gMgM0080oooo0P3oood70?ooo`030?clo03moO/0ooom0080ooom01@0oook0?chm@1MDE40fLg=0?om
o@1lQ8@0XkJj0?;oo`3noOl0f]3I08MmO01_JFL0WJ2T0>S`l03looP0oOog0?ono`3ooOl0no[m0?oo
o`80oOgm00T0no_k0?ooo`3emOD01PH604=3@`3oool0o_kn0?[jnP3oool00P3kno/02@3oool0o?cl
0>CTi02<S8`0>c/k00`<301ADE40VIVI0?Win@020?ooo`030?Win@3hn?P0oooo00<0oooo00<0oOgm
0?ooo`3oool00P3oool02@3jn_X0oooo0?gmo@3oool0g=cL08f=S@1YJFT0XZ:R0>WYj@030?ooo`05
0?gmo@3oool0oooo0?ooo`3jn_X00P3oool01P3alO409bLW00<30`000000=cLg0?Cdm0D0oooo00D0
m_Kf0?_kn`3no_h0Fe]K0?Shn0020?knoP80oooo00/0o?cl0?ooo`3inOT0o?cl0?Win@1eMGD00000
00820P061PH0cLg=0?ooo`020?gmo@@0oooo0P3no_hc0?ooo`030?knoP3kno/0oooo0080oooo00P0
no_k0?ooo`3lo?`0oOgm0?ooo`36a/H0TI6A0?[jnPT0oooo00H0oOgm0?ooo`0j>SX0YjNW0?ooo`3n
o_h20?ooo`040?knoP3oool0oooo0?Shn080oooo01l0Q8B400L71`0820P0000000820P051@D0?3`l
0?Win@3lo?`0_Kjn055EEP0=3Q80IfA[0=WDe03oonl0iNKF04=7B01ZL7/0DUIQ0?Ggo`3oo?l0oo[l
0?omn`3oo_/0lO;d0?coo`3nool0?Shn0:ZZZP3moOd0oooo0080o_kn103oool0303kno/0o_kn0?oo
o`3hn?P0oooo0861P@1YJFT0oooo09nOW`1LG5`0oooo0?Shn0<0oooo00H0oOgm0>GUi@22PX80820P
03Ti>@3jn_XE0?ooo`0000<0nOoj0?con`3oo_l00P3oo?l01`3oo_l0n?oc0?comP3on_l0o?Gl0?co
o`3ho?/00P3oo?l01@3koo`0n?oj0?cmo@3Xj>P05ADE0080oooo00<0o_kn0?clo03oool0<`3oool0
1@34a<@0=CDe0?ooo`3oool0o_kn0080ooom203oool06P3oood0o_kl0?clnP3lo?X0oOgi0?omnP3/
g=X0GU1?0<k=d01?FEh0j_oo0?7oo`3nnol0ooSn0?olo`3oo?h0g]gS08jAU@1PIEl0VYbF0>SXj03l
n_d0oooo0?[jnP3oool0o_kn0P3oool00`3kno/0oooo0?ooo`030?ooo`060?[jnP3oool0oooo0?kn
oP3oool0o?cl0P3oool02`3^k^h0WinO05EEE@061PH0@D5108f=S@3Vi^H0oooo0?gmo@3jn_X0oooo
0080no_k00@0nOWi0?knoP3lo?`0o_kn0`3oool02@3no_h0no_k0?clo03oool0j>SX09JFUP1`L700
Shn?0>3Ph0020?ooo`0<0?Shn03oool0no_k0?ooo`3lo?`0oooo0=OGe`020P80000000H61P1bLW80
nOWi0P3oool01P3jn_X0o_kn0?ooo`3oool0o?cl00410@<0oooo00d0no_k0?clo03oool0oooo0?Wi
n@3oool0ZJVY000000051@D0000009VIV@3kno/0o?cl00@0oooo00D0oOgm0?ooo`3oool0oooo0?gm
o@0a0?ooo`040?clo03no_h0oooo0?ooo`80o?cl00<0oooo0?_kn`3oool00P3jn_X00`3kno/0CTi>
0?Win@090?ooo`060?knoP3oool0ZZZZ03lo?`3no_h0no_k0P3oool01`3kno/0oooo0?ooo`3lo?`0
oooo0?knoP1/K6`00P0000007P0:2PX02@T904i>CP3jn_X0oOgm0?knoP3oo_l0o_oo0=oPi028QhX0
6ALF03De:@2KWI00>T0l00031`3ViO80ooco0?Wio`3no_h0oogj0?gimP3nool0o?oo0=SGfP0K6a/0
n?Sh0?knoP3moOd0oooo0?gmo@80oooo00<0o?cl0?ooo`3moOd00`3oool0403/k>`01@D50=kNgP3o
ool0_Kfm03Ti>@3no_h0oooo0?Win@3moOd0oooo0?knoP3kno/0oooo0?Win@2YZJTF0?ooo`0001@0
mOod0?Cnl`3ooOl0oo[o0?oio`3ooOl0l?oa0?CokP3ooOP0oo_m0??gn03ko_l0ooSo0?oko`3kooT0
nOof0?goo032`/80?3`l0?knoP80oooo00<0oOgm0?ooo`3oool0;`3oool0203no_h0o?cl0?knoP1^
KVh0Q8B40?ooo`3jn_X0oooo0P3oood60?ooo`040?clo03oool0ooom0?gmn`80ooom01P0oook0?oo
n03oo?40[JBM00003@3KhoD0n?oo0?gno`3onoT0oogj0?Gmo@3gool0oO_o0?gjo`3oo_l0hn?Q09jL
V`1XIVD0RXZ:0>7Qh@3oool0o_kn0?Gem@3lo?`30?ooo`0E0?Win@3oool0oooo0?clo03oool0oOgm
0?ooo`3jn_X0oooo0?[jnP3gmoL0oooo0?gmo@3oool0n_[j0;6a/@1OGel06ATI02LW9`1mOGd0emOG
00D0oooo00@0no_k0?knoP3oool0o?cl0`3oool20?gmo@080?ooo`3moOd0moOg0?Ogm`2TY:@0Jf][
08R8R03IfMT20?ooo`050?Win@3oool0oooo0?Win@2BTY800P000000100;2`/0/k>c0?ooo`3inOT3
0?ooo`050?[jnP3oool000000?_kn`3moOd00P3oool02@3jn_X0o_kn0?Shn03oool0fm_K01<C4`01
0@40000005=CD`020?ooo`070?_kn`3oool0o_kn0?knoP3moOd0o?cl0?knoP0c0?ooo`030?gmo@3o
ool0oooo00<0oooo00<0o?cl0?Ogm`3gmoL00P3oool01@3lo?`0no_k06MWI`3WinL0nOWi00P0oooo
00X0o?cl0?ooo`3clo<06QXJ0=_Kf`3moOd0oooo0?gmo@3lo?`0o_kn0`3oool07@3lo?`0A4A400@4
100000002PX:05QHF03jn_X0oooo0?[jnP3oool0ooko0?olo`3kn_l0o?oh0?comP2`/K40414C0004
001KGEX0f];M0?oio`3kool0m_go0?koo`3oo_l0oooo0?clo01bLW80M7Ad0080oooo00H0o_kn0?oo
o`3moOd0oooo0?knoP3moOd50?ooo`0708V9R@1TI6@0oooo0?KfmP3^k^h0IfMW0?clo0030?ooo`06
0?[jnP3moOd0oooo0?ooo`3inOT0no_k5P3oool0000D0?Oom03go_@0oogo0?oho`3om?l0oogo0?Go
n03goo<0oo_c0?ohm`3nool0noko0?ojo`3oo?l0o?kh0?_omP3nood0Y:BT05eMG@3jn_Xe0?ooo`04
0?clo03oool071`L0=?Cd`80oooo00<0o?cl0?ooo@3oood01P3oool0103no_h0oooo0?ooo@3moO/2
0?ooo@0:0?gmn`3noOH0ooka0?okm@3Ef>D0n?oo0?Ogo`3ooOl0ooch0?kil`80mOoo00/0o_co0?oj
o`3ooOl0o_kn0?kln`3ooo/0kno]0:JVYP1]KFd0Ogmo0=WIf@020?ooo`030?_kn`3oool0oOgm00L0
oooo00L0o?cl0?ooo`3oool0n_[j0?ooo`3jn_X0o_kn0080oooo00d0mOGe0<O7a`1gMgL07alO020P
801/K6`0^k^k0?Win@3oool0oOgm0?ooo`3lo?`0o_kn0080oooo00@0no_k0?ooo`3oool0n_[j0P3o
ool0203moOd0o_kn0?gmo@3fm_H0[Zj^06a/K01nOWh0dm?C0P3oool01`3no_h0oOgm059BDP020P80
000001LG5`3UiND0103oool20?knoP0600410@3oool0o?cl0?knoP3oool0no_k0P3oool02`3dm?@0
<C4a000000000000:2PX0?;blP3kno/0oOgm0?ooo`3lo?`0o_kn00<0oooo00<0o_kn0?clo03no_h0
<@3oool0403no_h0oooo0?clo03gmoL0oook0?[im@28QXL0108305aLFP21PGl0no[m0?koo`3mo_h0
`<7109jOX@3nool90?ooo`060?Win@3oool0Q8B406QXJ03no_h0oOgm0P3oool0303kno/0oooo0?_k
n`3no_h0oooo010@400000001`L704E5A@3no_h0oooo0?_kn`80oooo01<0oOco0?gio`3oo_l0n_od
0?Wom03[k_80SHfC0=cNf`1kNWH07aPO048lAP2Y[K@0l__n0?koo`3kn_d0ooko0?Kdl`0A4A40inOW
0080no_k0P3oool03P3no_h0oOgm0?knoP3oool0o_kn0?ooo`3lo?`0oooo0?Cdm00G5aL0eMGE0?Og
m`3oool0n_[j0P3oool01`3gmoL0ooom0?ooo`3moOd0oooo0?Win@3kno/00P3oool00`3kno/0oooo
0?ooo`0C0?ooo`0001@0o?ok0?koo@3oo_l0ooko0?olo`3oo_l0o?om0?con`3ooo/0oogm0?clo03n
ool0oogo0?ono`3moO/0o_ok0?ooo`2LW9`0HV9R0?ooo`80o_kn<P3oool01@3no_h0no_k0=GEe@0P
8200oOgm0180oooo00D0ooom0?onnP3oo_d0o_oo0?coo`020?ono`040?omo@3oo_d0o?oo0?coo`<0
ooko0P3oool02P3oood0oooo0?[jnP3oool0m_Kf0:f][@1VIVH0OGem0<S8b03lo?`20?ooo`030?gm
o@3oool0oooo0080oooo00@0n_[j0?ooo`3oool0oOgm103oool0403moOd0o_kn0?ooo`3oool0o?cl
0?ooo`3EeMD0Q8B403De=@0B4Q80GEeM0:^[Z`3`l?00oooo0?knoP3lo?`80?ooo`0@0?_kn`3oool0
o_kn0?_kn`3oool0n?Sh0;^k^`1eMGD0OGem0<C4a03moOd0jNWY02<S8`0000000`<30410@080oooo
00D0o?cl0?ooo`3oool0no_k0:ZZZP020?ooo`0<0?Shn03oool0oooo0?knoP3oool0LW9b00000002
0P801PH60<g=c@3oool0o_kn0P3oool00`3no_h0oooo0?ooo`0f0?ooo`0A0?koo`3in_X0ooko0?on
o@3oo?<0m_7Y01TB5@3Gd]H0oooh0<g>b039bLl0mo[o0?coo`22QXD0B4]@0?Wlo`3nool0203oool0
1`3hn?P0oooo0>GUi@0:2PX0m_Kf0?ooo`3no_h00P3oool0303hn?P0oooo0?ooo`3WinL0000000H6
1P0>3Ph0l_;b0?ooo`3moOd0oooo0?gmo@80oooo0140o_go0?ono`3noo/0o_ok0?[ko@3kn_d0oooo
0?kno03ln_d0YjFX03dn@00H71d0NWUl0>3Ph03oool0Shn?04i>C0020?kno0090?ooo@3oool0oooo
0?ono`3noOl0ooko0?glo`3oo_l0o?_n0080oooo00@0S8b<05ADE03nool0oooo0P3oo_d01P3oo_l0
o_go0?koo@3noo/0ookm0?ono`80oooo0P3nool00`3oool0ooko0?ooo`0D0?ooo`002@3oool0103n
o_h0o?cl0?ooo`3kno/20?ooo`040?clo03no_h0UYJF06QXJ080oooo00<0o_kn0?ooo`3no_h0<@3o
ool01P3moOd0PH61071`L03no_h0oooo0?WinB<0oooo00H0no_k0?Win@3oool0oooo0>_[j`31`L42
079bLP090;Zj^P3oool0oooo0?KfmP3oool0oOgm0?ooo`3lo?`0mOGe0080oooo00<0no_k0?clo03o
ool00P3oool03@3inOT0o?cl0?ooo`3oool0o?cl0?ooo`3jn_X0hN7Q09JFUP1=CDd0410@0=3@d03g
moL02@3oool0103no_h0oooo0?ooo`3no_h20?clo00;0?_kn`3hn?P0n_[j0<S8b01kNg/0MGEe07em
O@071`L0000000H61P25QHD00P3oool0303kno/0n_[j0?ooo`3moOd0oooo0?gmo@3oool0nOWi0?cl
o03no_h0[Zj^00L71`80000000<0U9BD0?Gem@3kno/00P3oool00`3jn_X0oooo0?ooo`0f0?ooo`<0
o_oo00l0n_Wl0?cgm`3oo_@0n_?Y01lF6@3PfM`0ookg0?kon@3no_l0o?ko0?Smo`3kool0koCh0?co
o`3nool02`3oool00`1HF5P0Shn?0?ooo`040?ooo`070?clo03moOd0/K6a00`<30000000a<C40?Ge
m@020?ooo`060?knoP3oool0oooo0?gmo@3inOT0O7al0P3oool00`3jn_X0oooo0?ooo`020?ooo`0@
0?_kn`3oool0eMGE06m_K`0A4A4071`L00`<302b/[00ooom0?_kn@3no_`0oooo0?gmo@3lnoh0ooko
0?kmo`80ooko00L0oOco0?clo03moOd08B4Q0<C5a@3lool0o_oo0080oogm00d0ooko0?koo`3kood0
o?ok0?omo@3oo?l0ooko0?koo`3kool0o?oo0?ono`3ooOl0ooko01@0oooo00080?ooo`040?clo03o
ool0oOgm0?gmo@80oooo00D0n?Sh0?ooo`3moOd0S8b<079bLP040?ooo`030?gmo@3oool0oooo02h0
oooo00P0D51@0?ooo`0h>3P0^[Zj0?ooo`3inOT0oooo0?[jnR00oooo00H0oOgm0?ooo`3oool0o_kn
0?Win@3kno/20?ooo`070?knoP3moOd0c<c<07YjNP1YJFT0][Jf0?[jnP030?knoP80oooo00@0o?cl
0?ooo`3oool0nOWi103oool0103moOd0oooo0?ooo`3lo?`20?ooo`060?clo03moOd0;2`/0;Zj^P3o
ool0o_kn2@3oool00`3lo?`0no_k0?ooo`050?ooo`050?Shn03oool0no_k0=[JfP0j>SX00P000000
1`061PH0_[jn0?ooo`3oool0n?Sh0?ooo`3inOT00P3oool02@3lo?`0oooo0?_kn`3Xj>P04Q8B0000
00020P80FUYJ0?[jnP030?ooo`030?knoP3oool0o_kn03L0oooo00d0o_oo0?Kgn@3nool0o?_n0?om
o@3ono<0ookf05YDDP2HTY80ookj0?oon`3OgnD0n?_o0080nooo0P3hnol00`3nool0oooo0?ooo`07
0?ooo`040?[jnP3moOd0`<3002d];@<0oooo00L0n?Sh0?[jnP3moOd0oooo04a<C0051@D0LG5a00<0
oooo00T0no_k0?ooo`3gmoL0oooo0>[ZjP0d=3@0N7Qh0?ooo`3moOd00P3oool03P3clo<0o?cl0?[j
nP3oool0moOg0:NWY`0n?Sh06ATI04i>CP1YJFT0no_i0?ooo@3jn_P0ooom0P3oool0103kn_d0ooko
0?kmo`3mo?l20?ono`0E0?ooo`2MWId0?clo0?koo`3iool0o?oo0?oknP3ono/0ooko0?_oo`3hool0
nooo0?omo@3onod0oogm0?koo`3gool0n?oo0?omo`3oo?d0ooko01@0oooo00090?ooo`040?knoP3o
ool0o_kn0?Ogm`80oooo00@0m_Kf0?knoP20P800OWin103oool00`3no_h0oooo0?ooo`0^0?ooo`07
02d];@2m_Kd01`L70?ooo`3inOT0oooo0?Cdm00R0?ooo`80no_k0`3oool20?clo00<0?gmo@3oool0
n?Sh0?Shn03oool0clo?08B4Q01ZJVX0Y:BT0>o_k`3oool0moOg0P3oool0103hn?P0oooo0?clo03j
n_X20?ooo`050?_kn`3moOd0oooo0?knoP3jn_X00P3oool01@3Rh^8061PH0?gmo@3oool0o?cl00P0
oooo00@0o?cl0?ooo`3oool0oooo0P3moOd00`3kno/0nOWi0?gmo@020?ooo`090?gmo@3oool0oooo
03Lg=`0000000P8201PH602FUYH0iNGU0080oooo00@0mOGe0?ooo`3inOT0o_kn0P3oool0300k>c/0
00000000000O7al0i^KV0?ooo`3moOd0oooo0?clo03gmoL0oooo0?clo3L0oooo0`3nool03`3kno/0
noOd0?onn03ooOP0k>KT00D1003LfmL0f][H010A5@3io?l0nooo0?KkoP3ko_l0o?oo0?ono`070?oo
o`090?knoP3oool0oooo0?ooo`3no_h0:b/[0;>c/`3oool0o?cl0080oooo00T0o_kn0?ooo`030`<0
10@40?KfmP3moOd0no_k0?ooo`3inOT00P3oool0203Xj>P061PH08:2PP3oool0nOWi0?[jnP3oool0
nOWi0P3oool01@3bl_80RHV902<S8`0i>CT0];Bd00<0oooo00@0ooom0?[jn03moO/0ooom0P3oool0
6`3oo_l0o?_n0?ono`3mo?l0no[m0?ono`3no_h0:RXZ0<;2`P3ko?`0nOoo0?coo`3onoX0oo_k0?on
o`3kool0n?oo0?_oo`3ooOd0oock0?omo@3nool0mooo0?Soo`3ooOl0oocm0?ono`0D0?ooo`00203o
ool00`3no_h0n_[j0?ooo`020?ooo`060?Win@3oool0oooo0?ooo`1cLg<0RXZ:0P3no_hc0?ooo`03
04E5A@1XJ6P0HV9R02P0oooo00<0o_kn0?ooo`3oool0103oool03P3moOd0oooo0?ooo`3lo?`0moOg
0?ooo`3Jf]X0T92@06EUI@2OWil0jNWY0?knoP3moOd0o_kn0P3oool01@3jn_X0n?Sh0?ooo`3oool0
n?Sh0080oooo00H0n_[j0?ooo`2ATI40F5QH0?ooo`3inOT90?ooo`060?clo03oool0oooo0?clo03h
n?P0oOgm103oool01P3no_h0o?cl0?ooo`3lo?`0g]kN01DE5@80000000H0BTY:096AT@1eMGD0Ti>C
0>g]k@3lo?`30?ooo`07071`L00000001@D500P82037alL0oooo0?_kn`020?knoP030?ooo`3no_h0
oooo03P0oooo0P3nool00`3fmoL0ooom0?onn`020?omnP050?okn03Zi^<0Hf5P07AdM01^Kg<00P3k
o_l0103hnol0o?oo0?[mo`3oo_l70?ooo`0:0?knoP3oool0o?cl0?ooo`3hn?P0Vi^K05MGE`3moOd0
oooo0?clo080no_k00<0aLG50000002QXJ400`3oool01P3no_h0oooo0?gmo@3gmoL0]kNg0;bl_080
oOgm0P3oool03`3moOd0oooo0=CDe01XJ6P04Q8B05YJFP3>c/h0oooo0?Win@3kno/0oooo0?gmo@3n
o_`0ooom0?ooo`020?knoP030?_kn`3oo_l0ooko0080ooko01L0oOgm0?ooo`2_[jl0>CTi0?ShmP3n
ool0o?oo0?koo`3oo_/0oogj0?ono@3nool0nooo0?coo`3oo_/0oogj0?oon`3nool0nooo0?coo`3o
o_d0ookk0?ono@0D0?ooo`002`3oool02P3kno/0oooo0?knoP3no_h0moOg0?ooo`1WIfL0UYJF0?gm
o@3no_hc0?ooo`07069RHP0/;2`0Zj^[0?clo03jn_X0oooo0?gmo@0Q0?ooo`030?gmo@3lo?`0oooo
0080oooo00D0n_[j0?Shn03kno/0o_kn0?gmo@020?ooo`040?knoP3oool0oooo0?Win@80oooo00P0
n_[j0>;RhP2HV9P0HV9R09BDU03WinL0m_Kf0?clo0<0oooo00P0o?cl0?knoP3oool0oOgm0?ooo`3g
moL0A4A40;6a/@80oooo00<0no_k0?ooo`3oool01`3oool00`3moOd0o?cl0?ooo`020?ooo`040?gm
o@3jn_X0oOgm0?clo080oooo01L0n?Sh0?ooo`3oool0Z:RX00H61P010@401@D50:JVYP3inOT0k^k^
09bLW01^KVh0SXj>0=oOg`2b/[801`L700410@020P80P8200?ooo`3inOT0oooo0?knoP030?ooo`03
0?[jnP3oool0oooo03H0oooo0180o_oo0?[kn`3nool0n_[j0?oon`3on_@0oogg0?olo03nnOT0oook
0?koo@3no_l0mOSm0?_no`3kool0o?oo0?koo`3oo_l80?ooo`0C0?KfmP3oool0nOWi0?ooo`3fm_H0
2PX:0>KViP2FUYH0GUiN075aL@1bLW80?Cdm01`L703oool0n_[j0?knoP3lo?`0oooo0?clo0020?oo
o`0;0?[jnP3gmoL0oooo0?_kn`3lo?`0nOWi0;jn_P12@T807AdM07]kN`3]kNd00P3lo?`0203hn?P0
oooo0?ooo`3lo?`0oooo0?kno03oood0oOgm0P3oool01@3inOT0ooko0?ono`3oo_l0o?_n0080oooo
00@0;Rh^0:f]Z`3lo?X0oooo0P3oo_l0103ooo/0oooj0?ooo@3noOl20?omo`040?oon`3oooP0oook
0?ono`80o_ko00<0ooom0?oon`3oood0503oool000P0oooo00@0oOgm0?[jnP3oool0o_kn0`3oool0
1@3no_h0oooo05eMG@2PX:00o_kn03@0oooo00<0JFUY00d=3@3YjNT0103oool00`3moOd0oooo0?oo
o`0N0?ooo`030?_kn`3oool0oooo0080n_[j203oool20?[jnP030?ooo`3no_h0o?cl0080oooo01<0
o?cl0?ooo`3/k>`0W9bL06YZJP2;Rh/0dm?C0?ooo`3no_h0no_k0?ooo`3jn_X0oOgm0?ooo`3/k>`0
4a<C0?KfmP3oool0o_kn00X0oooo00D0o_kn0?ooo`3oool0oooo0?clo0050?ooo`060?clo03oool0
oooo0?Gem@3oool0HV9R0P0000002`030`<0fMWI0?ooo`3oool0o_kn0?Cdm02IVIT020P800000006
1PH0ATI60080oooo00H0o?cl0?ooo`3jn_X0oooo0?clo03oool20?knoSL0oooo0`3nool03`3oo_l0
n_Si0?onm03ooO<0JF=Z0?cfo@3oooH0m?O^08V9T`3Be>00o?oo0?coo@3fmo/0o_oo0?ono`090?oo
o`0<0?Shn03oool0oooo0?ooo`1WIfL0:BTY0=7Ad@3oool0n?Sh0>?Sh`1lO7`0k^k^0`3oool0403h
n?P0h^;R09^KV`3moOd0oooo0?_kn`3oool0oOgm0?clo02EUID0:RXZ02l_;`2LW9`0mOGe0?ooo`3h
n?P20?ooo`080?clo03oool0oooo0?knoP3lo?`0oOgk0?kno03lo?`30?ooo`0F0?glo`3noOl0oooo
0?gmo@3oool0^k^k02/[:@3knoT0ooom0?_kn@3ooOl0ooko0?koo@3noo/0oOgi0?gkoP3onOl0ooco
0?kon`3looH0o_ok0?ono`80ooco00<0ooom0?konP3oood0503oool000P0oooo00<0n_[j0?ooo`3f
m_H00P3oool01P1XJ6P0CTi>0?ooo`3oool0F5QH0:FUY@@0oooo00<0o_kn0?ooo`3oool0;P3oool0
1P14A4@00000055AD@2QXJ40kNg]0?gmoB<0oooo00@0oOgm0?knoP3oool0oooo0P3lo?`01@3no_h0
oOgm0?knoP3moOd0o_kn0080oooo0P3no_h20?ooo`040?gmo@3oool0o_kn0?Win@<0oooo00D0k^k^
0:n_[`1[Jf/0MgMg0<_;b`030?ooo`070?clo02KVi/0EEEE0?ooo`3no_h0oooo0?gmo@0;0?ooo`80
o_kn0P3oool0103lo?`0oooo0?[jnP3no_h20?ooo`0E0?_kn`3oool0oooo0?KfmP0/;2`0000000<3
0`0[:b/0o?cl0?ooo`3lo?`0n_[j03lo?`010@40000001LG5`1SHf<0P8200<G5a@3oool0oOgm0080
o_kn00@0o?cl0?ooo`3oool0o_kn=`3oool04@3nool0nocl0?koo`3mo?l0ooko0?onm@3ono<0/:^]
08b:S@3nooT0eMOB05QKHP3lo_l0nOgn0?WjnP3nool0o_go00P0oooo00P0oOgm0?ooo`3oool0o_kn
0?[jnP3Cdm<0F5QH01LG5`80no_k0P3oool00`3]kNd0J6QX0?_kn`020?clo00<0<o?c`0N7Qh0/k>c
0?ooo`3moOd0oooo0>?Sh`1iNGT04a<C04m?C`2o_kl0oOgm0P3oool00`3jn_X0oooo0?knoP030?oo
o`050?Win@3oool0o_kn0?ooo@3lo?X00P3oool0603inOT0oooo0?ono`3oo_l0no_k0?ooo`3kno/0
ATI409^KV@3oood0n_[f0?ooo@3no?d0ooko0?koo`3nood0o?gg0?_inP3mn?l0oo_o0?kon`3nooH0
o_ok0?ono`80ooco00<0ooom0?konP3oood0503oool000/0oooo00P0no_k0?ooo`3gmoL0=CDe08j>
SP3moOd0C4a<0;Fe]@80oooo00@0m?Cd0?ooo`3inOT0oOgm0`3oool01@3no_h0oooo0?Win@3oool0
oOgm00<0oooo00D0o_kn0?ooo`3inOT0oooo0?gmo@030?ooo`050?knoP3oool0nOWi0?ooo`3moOd0
0`3oool01@3no_h0oooo0?Win@3oool0oOgm00<0oooo00<0o_kn0?ooo`3inOT00P3oool01@3lo?`0
oooo0?ooo`3jn_X0o_kn0080oooo00T0AdM701dM7@2YZJT0Cdm?00/;2`1:BTX0V9RH0>g]k@3lo?`0
0P3oool0103moOd0oooo0?clo03moOd20?ooo`060?KfmP3oool0oooo0?_kn`3oool0o?cl0P3oool0
103no_h0n_[j0?ooo`3moOd20?ooo`030?gmo@3oool0oooo0200oooo00X0oOgm0?ooo`3hn?P0];Bd
07EeM@1^KVh0`/;20?gmo@1:BTX0YjNW0P3no_h20?ooo`040?gmo@3oool0oooo0?gmo@80oooo00@0
oOgm0?ooo`3oool0oOgm0P3oool00`3no_h0o?cl0?ooo`090?ooo`0@0?clo03EeMD01`L700000001
0@40KFe]0?ooo`3no_h0PH61000000061PH000000;no_`3oool0m_Kf0<O7a`80MgMg00D0^[Zj0?_k
n`3oool0n_[j0?knoP030?ooo`030?clo03oool0o_kn0080oooo00@0o_kn0?gmo@3oool0oooo0P3m
oOd20?ooo`050?clo03oool0oooo0?gmo@3kno/08`3oool20?koo`030?gnoP3no_X0ookj0080oogo
00d0ooof04]:@`3@cmD0<c<k0>KZj@3lood0o_ko0?gmo`3oo_l0n_[h0?clo03oool0oOgm0080oooo
0280n?Sh0?ooo`3jn_X0no_k0?ooo`3lo?`0o_kn0:RXZ02=SHd0oooo04I6AP2OWil0oooo0?clo03o
ool0no_k0>SXj01cLg<0no_k0<W9b@0H61P0/;2`0?knoP3lo?`0cLg=05MGE`0B4Q80LW9b0=KFeP3o
ool0no_k0?knoP3oool0nOWi2@3oool01`3no_h0oooo0?ooo`3lo?`0oooo0?gmo@3gmoL00`3oool0
5`37alD07alM0?gmn`3ooo/0o_kj0?gmn@3nood0oooo0?omo`3jn?T0P85i05]MF022PHl0jNSf0?on
o@3oooP0ookm0?ono`3no_l0oOgo0?kno03oooX0ooom01@0oooo000:0?ooo`0=0?_kn`3oool0oooo
0?_kn`3Ng]h06ATI0<?3``0n?Sh0^;Rh0?knoP3inOT0oooo0?KfmP030?ooo`040?clo03moOd0oooo
0?[jnP@0oooo00@0o?cl0?gmo@3oool0n_[j103oool0103lo?`0oOgm0?ooo`3jn_X40?ooo`040?cl
o03moOd0oooo0?[jnP@0oooo00@0o?cl0?gmo@3oool0n_[j0P3oool00`3hn?P0oooo0?Win@030?oo
o`0?0?knoP3jn_X04A4A018B4P3kno/0oooo0?Ogm`2XZ:P0DU9B00d=3@13@d<0UYJF0>KViP3oool0
m?Cd0080oooo00D0oOgm0?clo03oool0oOgm0?knoP030?ooo`060?_kn`3oool0o?cl0?ooo`3kno/0
o?cl0P3oool00`3lo?`0oooo0?ooo`0N0?ooo`040?gmo@3oool0no_k0?_kn`80oooo00P0nOWi0?oo
o`35aLD0JVYZ00/;2`2/[:`0m_Kf0?knoP<0oooo0P3kno/20?ooo`80o?cl00H0o_kn0?clo03oool0
oooo0?clo03no_h20?ooo`030?Shn03oool0oooo00L0oooo00<0o?cl09VIV@0000000P0000000`2]
[Jd0^k^k00820P020000000408>3P`3oool0nOWi0?ooo`80o?cl00L0oOgm0=?Cd`20P800KVi^0;Vi
^@3gmoL0oooo0080o_kn0`3oool01P3inOT0oooo0?ooo`3oool0mOGe0?gmo@80oooo00D0oOgm0?oo
o`3oool0no_k0?clo0030?ooo`80oOgm803oool00`3nool0oOko0?coo`020?oonP0<0?ojo`3Sg^80
oO[_0>SXgP0000L0[jjk0?WmnP3loo/0nOWo0?omo`3no?d0ookm0P3oool01@3kno/0oOgm0?knoP3o
ool0oOgm00<0oooo00L0nOWi08j>SP2d];@0n_[j0?ooo`2`/;00>3Ph0080o_kn0P3oool03`3inOT0
dm?C09fMW@2=SHd0dM7A0?Shn02][Jd0?Cdm01TI6@2>SXh0k^k^0?clo03oool0o?cl0?Win@020?oo
o`030?clo03oool0oooo00L0oooo00<0o_kn0?ooo`3moOd0103oool01`3kno/0oooo0?knoP1>CT`0
V9RF0?cln03moOT00P3ooo/0303noo/0m_Og0?kjo`3ooOl0n__a0?[lmP3Pgnd0MWF50?omoP3oo_T0
oogl0?kmo`80o_ko00<0ookm0?oon`3oood0503oool000T0oooo00<0m?Cd0?ooo`3oool00P3oool0
1@3moOd0^KVi01DE5@0l?3`0aLG500@0oooo00<0n_[j0?ooo`3no_h00P3oool20?knoP040?ooo`3m
oOd0oooo0?knoP80oooo0P3no_h0103oool0oOgm0?ooo`3no_h20?ooo`80o_kn00@0oooo0?gmo@3o
ool0o_kn0P3oool20?knoP040?ooo`3moOd0oooo0?knoP80oooo0P3no_h00`3oool0oOgm0?ooo`02
0?ooo`070?[jnP3oool0no_k0?clo032`/80=CDe000000020?ooo`0E0?Shn03no_h0oooo0?Shn02g
]kL0D51@018B4P15ADD0RXZ:0>?Sh`3hn?P0oooo0?clo03jn_X0oooo0?gmo@3kno/0oooo0?knoP3o
ool0no_k00@0oooo00<0moOg0?KfmP3oool0803oool0103kno/0oooo0?ooo`3lo?`30?ooo`090?kn
oP3hn?P0[:b/04E5A@3>c/h0Ph>306EUI@2UYJD0lO7a00<0oooo00<0o_kn0?[jnP3no_h00`3oool0
1P3no_h0oooo0?ooo`3oool0no_k0?clo0T0oooo00l0oOgm0?clo03oool0Bd];000000030`<00000
00L71`020P801@D504=3@`3oool0no_k0?ooo`3no_h00P3oool03P3moOd0o?cl0?ooo`3oool0e]KF
08n?S`1YJFT0ZJVY0?;blP3moOd0n_[j0?gmo@3oool0o?cl0P3oool0103kno/0oooo0?knoP3jn_X2
0?ooo`030?_kn`3oool0o_kn00D0oooo00<0o_kn0?ooo`3oool07@3oool20?koo`090?Wmo03oood0
lo?_0:NRXP0=20P0PX5l0?oon`3Ge]/0l?3f0080o?oo00H0o_oo0?ono`3hm_L0ookm0?Win@3dm?@2
0?ooo`030?_kn`3oool0o?cl0080oooo01H0lO7a06a/K03Cdm<0oooo0?gmo@3kno/0oooo01hN7P35
aLD0PH6109RHV03_knl0lo?c0?gmo@2HV9P0ZZZZ08R8R00Q8B40?Cdm0:RXZ03oool0moOg1P3oool0
0`3no_h0oooo0?gmo@0:0?ooo`0<0?[jnP3oool0n_[j0?[jnP3oool0no_k0?ooo`3>c/h06ATG0?Og
m@3ooo/0o_kj0P3oooX0403loOD0ooom0?omo`3no_l0nocb0?oomP2c[kd0AdAE0?kmo`3nood0oooo
0?ono`3ooOl0ooko0?ooo@3moO/E0?ooo`00203oool0F03gmoL0oooo0?ooo`3_knl0emOG0=7Ad@3F
e]H0gmoO07inOP061PH0bl_;0?;blP3GemL0eMGE0=3@d03WinL0oooo0?KfmP3moOd0m?Cd0<[:bP3Q
hN40d=3@0>CTi03oool0m_Kf0?gmo@3dm?@0b/[:0>7Qh@3@d=00i>CT0?ooo`3fm_H0oOgm0?Cdm03:
b/X0hN7Q0=3@d03Ti>@0oooo0?KfmP3moOd0m?Cd0<[:bP3QhN40d=3@0>CTi03oool0m_Kf0?gmo@3d
m?@0b/[:0>7Qh@3@d=00i>CT0?ooo`3emOD0oooo0?3`l03IfMT0f=SH0=;BdP1YJFT0PH6102@T903J
f]X0l_;b0=?Cd`3MgMd0f][J0>7Qh@3moOd0oooo0?_kn`2XZ:P0EUIF01HF5P0];Bd0OGem0>;RhP3o
ool0nOWi0??cl`3Hf=P0dM7A0=GEe@3Zj^X20?ooo`060?Ogm`3clo<0d=3@0=kNgP3De=@0jn_[803o
ool20?gmo@L0oooo00X0FUYJ09nOW`3moOd0no_k0?ooo`3Ogml0QHF505UIF@2SXj<0jNWY0`3oool0
1P3moOd0o?cl0?ooo`3oool0n_[j0?_kn`80oooo0P3lo?`90?ooo`040?[jnP3lo?`0Vi^K00L71`<0
000000`00@4100`<303/k>`0oooo0?knoP3oool0moOg0?ooo`3no_h0oooo0?knoP3inOT20?ooo`0;
0?Win@3oool0i>CT092@T01aLG40X:2P0>g]k@3gmoL0oooo0?clo03kno/00P3oool0103no_h0oooo
0?ooo`3jn_X40?ooo`050?gmo@3jn_X0oooo0?ooo`3lo?`0803oool20?koo`0>0?gmn`3ooo/0n_We
03hj=`0100006a/I0=SGfP3nool0n_go0?coo`3hmoX0ooko0?ono@3ln_T20?ooo`0;0?gmo@3oool0
oooo0?clo03oool0mOGe0=kNgP1UIFD0jn_[0?ooo`3kno/00P3oool04`3jn_X0IVIV0000000?3`l0
410@00410@2HV9P0fMWI06IVIP0410@0EeMG0<o?c`3kno/0o_kn0?gmo@3oool0n?Sh0?Ogm`3jn_X0
0P3oool0103inOT0oooo0?ooo`3inOT90?ooo`040?knoP3lo?`0oooo0?clo0<0oooo01T0nOWi069R
H028R8H0o_kj0?oon`3jnoD0o_oi0?Gdk@3oooH0noWh0?Ceo`3gn_l0o_od0=oOd`0j<Sl0Zj>f0?Ki
oP3kool0o_oo0?ono`3onol0oogo0?koo`3ioO`0o_oo01@0oooo000:0?ooo`0;0?Cdm02n_[h09RHV
02LW9`0/;2`0MWIf0?ooo`0b<S80M7Ad0;Fe]@0U9BD00P0/;2`02P1`L700o_kn0?ooo`3oool0][Jf
03<c<`0O7al0:b/[06i^KP3no_h20?ooo`060;Jf]P0c<c<07alO02/[:`1^KVh0o_kn0P3oool01P2f
][H0<c<c01lO7`0[:b/0KVi^0?knoP80oooo00H0][Jf03<c<`0O7al0:b/[06i^KP3no_h20?ooo`06
0;Jf]P0c<c<07alO02/[:`1^KVh0no_k0P3oool09@2i^KT0;bl_020P800X:2P03Ph>0<o?c`1:BTX0
/[:b0:f][@0c<c<07alO02HV9P1dM7@0oOgm0?ooo`3moOd0_[jn02<S8`0Q8B406a/K02LW9`0>3Ph0
=CDe08n?S`2PX:008R8R02TY:@0[:b/0JVYZ0?ooo`3hn?P0oooo0;Ng]`0^;Rh092@T02/[:`1^KVh0
8@3oool02P3no_h0oOgm0?ooo`3lo?`0nOWi0?gmo@3oool0n_[j0000003_knl20?ooo`0;0?Win@3o
ool0o?cl0?ooo`3Shn<0SXj>05eMG@2DU9@0hn?S0?ooo`3no_h00`3oool20?gmo@030?knoP3oool0
oooo00T0oooo00/0o?cl0?_kn`0X:2P0000000D51@0820P00`<30000002m_Kd0n_[j0?clo0020?oo
o`040?knoP3oool0oooo0?gmo@@0oooo00/0n_[j0?ooo`3lo?`0oooo0?Ogm`3]kNd0X:2P075aL@2@
T900i>CT0?ooo`020?gmo@070?[jnP3moOd0oooo0?ooo`3lo?`0n_[j0?knoP020?ooo`030?clo03m
oOd0oooo0240oooo00`0o_oo0?_lo03lo?X0oook0?kln`3oo_d0DU5=000000061@X0CTiD0=7EeP3k
ool20?ono`040?[hm`3ooO`0oooo0?Cdm080oooo0P3lo?`0103oool0cLg=06a/K03no_h20?gmo@06
0?ooo`3kno/0no_k0?ooo`0_;bl01`L70`0000002@0<30`06QXJ0861P@3Ti>@0Hf=S0?ooo`3kno/0
oooo0?knoP040?ooo`80o_kn00<0oooo0?gmo@3no_h02@3oool02`3no_h0oooo0?ooo`3moOd0o?cl
0?ooo`3jn_X0o_kn0>CThP0;2`T0lo?a0080oook01@0oooj08^<QP010@00RH9g0:NSX0032Ad0g>Gd
0?gol`3hm>H0ooGo03T`@`3YkO@0lO[l0?_oo`3oo_l0ooWk0?oko@3lool0nOoo0?kooa@0oooo0008
0?ooo`80o?cl00<0oooo0?knoP3oool00P3oool01@3inOT0oooo0>OWi`0M7Ad0^k^k0080o?cl00P0
oOgm0?ooo`3moOd0n_[j0?_kn`3oool0nOWi0?gmo@80oooo00H0oOgm0?[jnP3kno/0oooo0?Win@3m
oOd20?ooo`060?gmo@3jn_X0no_k0?ooo`3inOT0oOgm0P3oool01P3moOd0n_[j0?_kn`3oool0nOWi
0?gmo@80oooo00H0oOgm0?[jnP3kno/0oooo0?Win@3moOd30?ooo`040?knoP3oool0oooo0?;blP80
oooo00<0oOgm0?ooo`3no_h00P3oool0203moOd0oooo0?ooo`3no_h0oooo0?gmo@3oool0o?cl1@3o
ool0202o_kl0J6QX00`<300k>c/0P8200=CDe03oool0n?Sh0P3oool00`3moOd0o?cl0?ooo`0S0?oo
o`030?gmo@3oool0oooo00<0oooo00<0o?cl0;6a/@14A4@0103oool00`3emOD0oooo0?[jnP030?oo
o`060>KViP2HV9P0K6a/0820P03Lg=`0kno_0P3oool0103no_h0oooo0?ooo`3gmoL80?ooo`040?Og
m`3oool0oooo03Xj>P800@410P0000003@0:2PX0no_k0?gmo@3oool0oOgm0?ooo`3clo<0o_kn0?_k
n`3no_h0oooo0?clo03hn?P00P3oool0403lo?`0oooo0?clo03oool0oOgm0?[jnP3moOd0l_;b0:VY
Z@1]KFd0QhN70=?Cd`3oool0oOgm0?Shn03no_h30?ooo`050?_kn`3moOd0oooo0?ooo`3lo?`08@3o
ool04@3nool0nocl0?oon`3ooo/0ooko0?cjn`3in?<0EeMC00001@030`/00PH705IJF@2m_<40n_Sk
0?omo@3oo_/0oogl0080oooo00D0o_kn0?clo03oool0WYjN09:BTP020?ooo`0D0?gmo@3jn_X0oooo
0?knoP3moOd0fm_K00`<300000000`<30000000;2`/020P80>o_k`3kno/0oOgm0:NWY`3;bl/0o?cl
0?knoP3oool20?gmo@030?Shn03no_h0oooo0080oooo00<0o?cl0?Win@3oool02@3oool00`3kno/0
oooo0?knoP030?clo00J0?ooo`1]KF/0MWId0?oon`3knoL0oooj0?Sil`1OH5P0`<2f0>CNd0030000
CUA/0;[2e`3noo@0f=C407mcO@0>1AP0k?3k0?;ko`3kool0ooko0?ojnP3onoT0o?oo0?Woo`3noolD
0?ooo`002@3oool00`3moOd0o_kn0?ooo`040?ooo`070?gmo@3oool0aLG500d=3@3WinL0o_kn0?[j
nP030?ooo`060?_kn`3no_h0oooo0?knoP3oool0no_k0P3oool01P3kno/0o_kn0?ooo`3no_h0oooo
0?_kn`80oooo00H0no_k0?knoP3oool0o_kn0?ooo`3kno/20?ooo`060?_kn`3no_h0oooo0?knoP3o
ool0no_k0P3oool0303kno/0o_kn0?ooo`3no_h0oooo0?_kn`3moOd0o?cl0?ooo`3kno/0oooo0?Sh
n0<0oooo00@0oOgm0?[jnP3inOT0o_kn0P3oool02P3no_h0oOgm0?knoP3oool0oOgm0?ooo`3kno/0
nOWi0?ooo`3lo?`30?ooo`070;fm_@1^KVh07AdM02LW9`1lO7`0f=SH0?Ogm`020?ooo`030?KfmP3o
ool0o?cl02<0oooo00T0o?cl0?gmo@3oool0oooo0?clo01QHF40T92@0?gmo@3kno/00P3oool20?kn
oP80oooo0P3lo?`20?ooo`090?Win@3emOD0[Jf]06i^KP1fMWH0b/[:0?knoP3moOd0o?cl00X0oooo
00`0o_kn0?gmo@2TY:@02PX:00D51@00000020P80:NWY`3oool0oOgm0?ooo`3moOd20?ooo`040?_k
n`3oool0o_kn0?knoP<0oooo00D0o?cl0?ooo`3oool0oooo0?Win@030?ooo`80o_kn00`0oooo0?3`
l02j^[X0MWIf07emO@3=cLd0o_kn0?ooo`3gmoL0oooo0?clo03hn?P20?ooo`030?_kn`3oool0oooo
01l0oooo0P3nool04@3ko?H0oook0?[go@3oo_l0oooh0?Kgl@0_;cL00P8<004510000@005aHK018?
5@1dKfl0[j^X0>WWiP3oool0m_Kf0080oooo00<0Ng]k0;Rh^03oool00P3oool00`3lo?`0o_kn0?[j
nP030?ooo`0301/K6`020P8010@40080000000X0LG5a0?gmo@3oool0oooo0=7Ad@2_[jl0oooo0?Og
m`3oool0oOgm0`3oool00`3moOd0nOWi0?ooo`020?ooo`030?[jnP3oool0oooo00L0oooo00<0nOWi
0?knoP3oool00`3oool00`3Rh^8030`:0>g]j`020?oon`80oooj01<0FEYB08j>PP3imnH0YZFP014@
;@3gn?l0o_od0?ook@3km?/0ooSo0?Wko`3kool0o_ko0?ono`3oo_P0oogf0?gnoP3lool0o_oo01@0
oooo00090?ooo`030?clo03oool0o?cl0080oooo00<0o?cl0?ooo`3no_h00P3oool00`2h^;P0MGEe
0?gmo@020?ooo`090?gmo@3oool0oooo0?ooo`3lo?`0oooo0?[jnP3oool0oOgm00<0oooo00D0o?cl
0?ooo`3jn_X0oooo0?gmo@030?ooo`050?clo03oool0n_[j0?ooo`3moOd00`3oool01@3lo?`0oooo
0?[jnP3oool0oOgm00<0oooo00L0o?cl0?ooo`3jn_X0oooo0?gmo@3oool0o?cl0080oooo00@0no_k
0?ooo`3inOT0o?cl0`3oool0103no_h0oooo0?knoP3no_h20?ooo`030?clo03oool0o_kn00D0oooo
00h0no_k0?ooo`3oool0oooo0?knoP38b<P0MGEe024Q8@0T9BL0NWYj0<S7``3ooo/0oooo0?kmo`80
ooko00@0oooo0?ooo@3nool0o_oo0`3oo_l=0?ooo`80o_oo3@3oool01@3no_h0oOgm0?ooo`0C4a<0
hN7Q0080oooo00H0o?cl0?_kn`3oool0oOgm0?ooo`3inOT20?ooo`0<0?gmo@3oool0oooo0?clo03m
oOd0oooo0?Ogm`2j^[X0K6a/079bLP31`L40no_k2@3oool02@3moOd0o_kn0?ooo`2e]KD0?clo02`/
;02/[:`0o_kn0?gmo@020?ooo`80o_kn00<0n_[j0?ooo`3jn_X00P3oool01P3lo?`0oooo0?ooo`3i
nOT0oooo0?knoP80oooo00<0o_kn0?ooo`3lo?`0103oool02P3jn_X0no_k0?ooo`30`<00MgMg07Ui
N@33`l<0n?Sh0?ooo`3kno/20?ooo`050?clo03no_h0oooo0?ooo`3ooOl00P3oo_l30?ooo@H0oooo
0`3oo_l30?ooo`@0o_oo00<0oooo0?ooo@3oool00`3oool20?ono`040?_jo@3oool0o_kj0?kno080
ooko00X0m_O]0?oon03Xj?003`lI00010`000000000400000P050`8030/70P0000001@3oool0l?3`
065QH@3Ti>@0oooo0080o_kn00<0no_k0?ooo`3no_h00P3oool03@3moOd0o?cl0=CDe00A4A402PX:
00`<300m?Cd0oOgm0?knoP3moOd0o?cl06YZJP3Ph>000P3oool01@3no_h0oooo0?clo03oool0oOgm
0080oooo00<0no_k0?clo03oool02@3oool08@3moOd0oooo0?ooo`3kno/0o?cl0?ooo`3moOd0MWIf
06a/K03oood0o?ch0?cmm`3oooX0ookg0<2o^00k>bl0oooa0>k^jP0B3bP0e=;X0?kom`3ooo<0oO_n
0?oko`3noOl0o_ko0?kmo`3oo_l0oooj0?onn@3noOl0o_oo0?ono`0D0?ooo`00H03oool03P3no?/0
o_kn0=;EfP1fMgT09R<J02DR6@1dM780a<G90?gmo`3ooOl0oogl0?knnP3iood0nooo0P3oo?l0103o
oOl0o_co0?ooo`3lo?`20?koo`0;0?[jn03oood0ookm0?gknP3ln_/0ooko0?ooo`3mo_h0nooo0?co
o`3nool0203oool20?knoP070?ooo`3hn?P0oooo0?_kn`31`L40=cLg0?[jnP050?ooo`030?knoP3o
ool0oooo00H0oooo00/0oOgm0?ooo`3oool0o?cl0?ooo`3kno/0_[jn07YjNP1XJ6P0_;bl0?Shn002
0?gmo@@0oooo00D0o_kn0?clo03oool0oooo0?clo0040?ooo`030?knoP3oool0oooo0080oooo00<0
oOgm0?knoP3oool05P3oool04P3De=@0OWin07=cL`2^[Zh0moOg0?ooo`3emOD0oooo0?ono`3knO`0
oo_o0?ojo@3ooOd0nOWe0?konP3mooT0ooom0?ooo`80o?go00P0o_oo0?kno03onO`0ooco0?omo`3m
no`0no[m0?koo`80o?oo00@0noon0?coo`3nood0oook0P3oo_d40?ono`060?Wim`3oood0ooko0?_k
o`3nool0o?kk0P3nooH03@3noOl0e]CM00X6400100D010850000000U9b80G65K09NIUP2a/K40f][J
06QXJ03]kNd00P3oool00`3lo?`0oooo0?ooo`050?ooo`070?knoP3oool0o_kn0;Zj^P3:b/X0oooo
0?Win@020?ooo`0509>CT`3AdM40oooo0?ooo`3gmoL00`3oool0103moOd0oooo0?Shn03no_h20?oo
o`040?[jnP3oool0oooo0?Win@80oooo00H0o_kn0?gmo@3moOd0oooo0?koo@3moo`20?koo`80ooko
0140k>_^01@D503Rh>40ookm0?onnP3noOP0oocc0?oom03nno00H5eD09JET03moOd0E59M09ZHX@3l
o?X0oook0?_jo@050?ono`80oooo0P3oo_lE0?ooo`00H03oool07P3oo_d0oOgm0?Olo`3lool0oogc
0=??``1hN7@0;2ld01XI9P1ZJ7<0alG40?cmm`3anoH0m_kl0?olo`3onol0ooco0?ono`3knOX0oooo
0?GfmP3nool0ooom0?gmn`3no?/0ookm0?omo`3oo_l0o?cl0?_lo080nooo00<0o_oo0?ooo`3oool0
1@3oool02P3moOd0oooo0?_kn`3moOd0oooo0?Shn03oool0J6QX08:2PP3lo?`20?ooo`030?clo03o
ool0oooo00T0oooo00D0o_kn0?ooo`3oool0oOgm0?clo0020?gmo@080?_kn`3oool0b<S807]kN`1/
K6`0[:b/0>k^kP3oool20?clo0<0oooo00<0n_[j0?Cdm02g]kL00P3lo?`0203no_h0oooo0?ooo`3n
o_h0no_k0?knoP3oool0o_kn5`3oool02P3hn?P0oooo0?ooo`3Ng]h0QXJ606][J`2YZJT0kno_0?on
o`3ooOl20?oko`060?omoP3moo`0o_oj0?kon03no_X0no_i0P3nool01@3ko?h0oooo0?olo`3onO`0
oogo0080ooko00H0o_oo0?_no`3iool0n_on0?coo`3nood20?oon`0;0?ono@3oo_l0ooko0?kno`3o
o_l0ookk0?Kel@3en?d0nooo0??gn03jn_H00P3oooH03`3nool0n?Sn07EaO@0;1@l03PT=02h/:`0c
>CD0kO?_0?WjnP31`L40MgMg0?[jnP3oool0moOg0?gmo@080?ooo`050?knoP3hn?P0oooo0?clo03n
o_h00P3oool04`3no_h0RXZ:0;jn_P3gmoL0o_kn0?ooo`3moOd0oooo0?Shn03no_h0oooo0;Bd]03d
m?@0oooo0?gmo@3oool0moOg0?gmo@3gmoL00P3oool00`3fm_H0oooo0?clo0020?ooo`0G0?goo03h
n_L0o_oo0?cmo@3noOl0n?Oj08j=T01FEEP0oogn0?gknP3oo_/0ookj0?oomP3kn>d0oogc0?omm026
Q8<0Kfia01HE6019B4/0o_go0?ono`3lnoh02@3oo_lE0?ooo`00H03oool07P3ooO`0oooo0?[oo`3k
ool0ookf0?onm03oood0o_oo0=GGh@22PXX0=38a01PH501OIfD0`<K60?omo`3on?/0ooco0?omoP3o
o_l0oooo0?koo`3in_X0o_oo0?_kn`3oo_l0noWj0?Sfm`3oo_l0oooo0?koo`80o?oo00<0o_oo0?oo
o`3oool01`3oool0203no_h0oooo0?ooo`3moOd0n_[j01lO7`3GemL0oOgm0P3oool00`3kno/0oooo
0?ooo`0:0?ooo`030?_kn`3jn_X0oooo00D0oooo00P0n_[j0?ooo`3oool0e=CD08:2PP1_Kfl0Vi^K
0??cl`80oooo00@0n?Sh0?ooo`20P800JVYZ0`3oool00`3lo?`0n_[j0?ooo`020?ooo`030?gmo@3n
o_h0oooo01P0oooo00h0n_[j0?Win@3oool0oooo0>7Qh@2;Rh/0Jf][09bJV`3ajn/0oocn0?coo`3k
ool0nogh0?kon080o_oj00X0o?cj0?ono`3moOl0o_ko0?_inP3oo_d0oo[j0?kln`3oool0o_oo0`3l
ool00`3ioO`0o_om0?ooo@020?ono@0H0?ooo`3oo_l0o_oo0?ono`3onoP0oo_i0?Soo`3dool0nOoo
0?oon`3oo_H0oo_e0?[kn`3kool0m_Ko01/G8@0<0@L0RH>308>9Q@0=5Q40MGIf0:>SX`3oool0o?cl
0`3oool00`3lo?`0oooo0?ooo`050?ooo`030?knoP3oool0n?Sh00<0oooo00D0n_[j06QXJ039bLT0
oooo0?clo0020?ooo`090?knoP3moOd0oooo0?_kn`3oool0IVIV00l?3`1_Kfl0g=cL00@0oooo00L0
oOgm0?ooo`3oool0oOgm0?_kn`3oool0no_k0080o_om01H0o?gm0?gnoP3oo_l0n?Oj00l>4@3JfM`0
ooko0?ono@3oo_/0nOGa0?oon03oooH0nOK[0?oon03no?/0ooko0>[Yk0071PT0k>_^0?[io03oo_l0
o_go203oo_lE0?ooo`00H03oool06@3mnoX0oooo0?_oo`3kool0o_Se0?kil`3knoT0noco0?_no`3n
ool0lo7`0>;Pg`2;Si00;2lc01LE501VH600^kJh0?[hn@3ooOh0o_kn0?WjnP3nool0n?Wi0?koo`3o
oOh00P3oo_l01@3mno`0no_k0?koo`3nool0nOgl00T0oooo00T0n_[j0?ooo`3oool0nOWi0?ooo`3:
b/X0:b/[0?ooo`3moOd03P3oool0103moOd0oooo0?ooo`3oool20?gmo@030?clo03jn_X0n_[j0080
oooo00h0oOgm0?ooo`3oool0l_;b0>?Sh`2;Rh/0Hf=S08n?S`3YjNT0oooo028R8P37alL0oooo0?_k
n`@0oooo00@0o_kn0?clo03oool0o_kn5`3oool01@3lo?`0n?Sh0?ooo`3kno/0o?cl00@0oooo00l0
j>KU0:>RWP1]KFd0S9>K0=_RjP3lo_/0oooh0?_om`3ko_D0oo_g0?omo`3hn?l0o?ko0?coo`3inoH0
0P3oo_d0103moOd0o?cl0?cmo`3lool20?koo`040?ooo`3oood0ookm0?ono@80oooo01D0o_oo0?on
o`3oo?P0oogj0?;ko@3dool0nOoo0>k^k01;@Sd0=bhY01LG5`3HgN40n_co0:JT[@0=10T0OWMj0?[n
n`1BF5@04a@D09FEU@3gmoL00`3oool00`3hn?P0oooo0?ooo`060?ooo`0I0?knoP3oool0n_[j0?oo
o`3kno/0jn_[05UIF@3_knl0n_[j0?gmo@3oool0o_kn0?clo03oool0n?Sh0?_kn`3oool0o_kn0?oo
o`3Shn<0Ogmo00l?3`11@D40]kNg0?_kn`020?ooo`030?Ogm`3oool0o?cl00<0oooo01H0nogj0?ko
o@15ATH0hN;R0?glo`2EU9L0EUEH0?ckoP3mno`0ooko0?omo@3oo_/0ookj0?oon03oooH0moK_0?_i
n03oo_l0k>_^028Q902g][T0ooko0P3mo?l80?onoaD0oooo001P0?ooo`0H0?gko03noOl0o?oo0?ko
o`3oo_/0oogk0?ooo`3nool0o?oo0?WjnP3ooo/0oo[j0?kno`3nool0hn?Q08n>RP10>c/04Q0A05EC
E02i^KT0o?gm0?gnoP3nool0nocl0P3no?d20?ono`040?ooo`3nool0oOkn0?_ooPT0oooo00<0o_kn
0?ooo`3lo?`00P3oool00`1gMgL0N7Qh0?ooo`020?ooo`050?knoP3oool0oOgm0?ooo`3no_h0203o
ool01P3moOd0oooo0?ooo`3moOd0nOWi0?knoP@0oooo00<0o?cl0?Win@3oool01@3oool01@35aLD0
VIVI051@D00H61P0eMGE00<0oooo0P3jn_X20?ooo`030?_kn`3no_h0o_kn01P0oooo01h0o_kn0?_k
n`2NWYh0BTY:01DE5@14A4@0SHf=0?WgmP3ooo/0mOGa0?coo`3^mol0XJVd07AcMP24Pgh0cmK>0?co
n03oo_H0ooWg0?kno`3iool0l_[j0?_on`3inOD0no[f0?gmn`3oood0oooo0?_lo03mo?l20?ono`D0
oooo01X0o_oo0?ono@3onoD0oocg0?Gmo`3eool0n?oo0?koo@3onO@0W9>>0?7/kP3Xind0o?oo0?Ki
o`000080Bd];05mOG`3TiND0e]KF02h^;P1SHf<0n?Sh0?ooo`3fm_H0oooo0?Shn0L0oooo00P0o_kn
0?ooo`3oool0oooo0=_Kf`1SHf<0oooo0?Win@80oooo00H0n_[j0?ooo`3moOd0n?Sh0?ooo`3gmoL2
0?ooo`0?0?Ogm`3oool0moOg0?ooo`2[Zj/0<C4a01/K6`20P800lO7a0?ooo`3kno/0oooo0?Win@3o
ool0o?cl0080o_om00D0@48o0;jo_`3cl_D071/N0<O6b@030?ono`0=0?klo@3oo_d0o_[g0?kjmP3o
o_X0oooj0?ono@3inOT0hn?S0:JVYP2b/[80oooo0?knoP0N0?ooo`00H03oool20?ono`090?Wlo`3k
o?l0oo_m0?omo@3oo_l0o_oo0?_oo@3loo/0nOGb0080oogo01<0ooko0?GglP3oooX0n_Sg0>[Ui`2L
VY/0=cLg00l@401JFe/0ZZ^[0?Ohn03oool0ooko0?gko03knOX0o?cl0?gnoP3nool0o?oo00/0oooo
00H0o?cl0?ooo`3oool08R8R0<o?c`3jn_X20?ooo`030?gmo@3oool0no_k00/0oooo00<0o_kn0?cl
o03oool00P3oool0103moOd0nOWi0?[jnP3no_h20?ooo`0>0?knoP3lo?`0o_kn0?ooo`3inOT0o?cl
014A4@3Zj^X0MgMg06i^KP2_[jl0IFEU07YjNP38b<P30?ooo`040?_kn`3jn_X0oooo0?knoQL0oooo
01X0oOgm0?[jnP0410@00`<3000000010@400000018B400e<c80n?Sd0?konP3iool0koSo0?Soo`3m
noh0ookm0;:h]01cMFl0OWAX0<o4_P3ooOl0nOoo0?Koo`3iood0o_om0?oon`80ooom0P3oool00`3o
oOl0oOco0?ono`020?ono`<0oooo0140o_oo0?oon`3on_80oogf0?_oo`3gool0loko0?[oo03nnO<0
nO3[07acMP3onOl0o?oo0?Slo`1IGel03A4@0?3^k`020?ono`060??cl`1IFET0<30`0<[:bP3oool0
o_kn203oool02`3no_h0o?cl0?ooo`2[Zj/0PX:20?ooo`3lo?`0oooo0?Win@3kno/0o?cl00<0oooo
00D0n?Sh0?ooo`3jn_X0oooo0?knoP020?ooo`080?_kn`3lo?`0oooo0=?Cd`1WIfL030`<05iNGP37
alL20?ooo`0;0?_kn`3oool0nO_h0?koo@1RI640TiFB0:ZZZP15A4L0oOco0?ono`3ooOl00P3oo_l0
2@3mno`0oo_k0?onn`3oo?T0nOSd0?ooo@3oool0nOWi0?gmo@020?ooo`80oOgm7@3oool00600oooo
00@0o_kn0?ono`3lool0o_oo0P3ooOl06P3no?l0nocl0?Won@3looX0ookk0?gfn@3onol0o__o0?co
o@3kooT0ookm0?okn`3oo_l0n_[j0>OXj02GViX0@T=500`=3`1BDE@0YJBW0??alP3oo_l0oOgm0?gn
oP3nood0n?ci2@3oool01P3lo?`0oooo0?ooo`3gmoL0e]KF02@T9080oOgm00H0oooo0?knoP3oool0
oooo0?knoP3moOd:0?ooo`060?knoP3oool0oooo0?ooo`3lo?`0o_kn203oool0403moOd0oooo0?oo
o`0l?3`0`/;201`L703GemL0oOgm0?ooo`3dm?@0^[Zj071`L01^KVh0_;bl0?gmo@3oool20?knoQL0
oooo0240oOgm061PH0051@D0000000<30`0000000@4100400004000092<O0?con`3iool0mooo0?Wo
o`3oo?l0noKh0?Sko`3ooo/0ooc_0<fl/01gMGP0Jg9j0;_4a`3eoOl0lOGd0?gmn`3oood0oOgk0?_i
nP3oo_l0oogo0?ono`3ooOl00P3oo_l20?koo`80o_om01P0oooj0?ollP3ooO@0kNk`0>ohn`3fool0
nOoo0?onnP3onoT0m^W^079ZL`3gn_l0]l35071jN@3iood0oogo0?gfn`3imoP0o?cl0?ooo`20P800
2`/;0?ooo`3hn?P80?ooo`070?knoP3fm_H0T92@0:ZZZP3oool0o_kn0?[jnP020?ooo`0H0?Ogm`2m
_Kd0g=cL0?Ogm`3lo?`0oooo0?_kn`3oool0mOGe0?ooo`3lo?`0oOgm0?KfmP3oool0oOgm0?clo03i
nOT0lO7a08j>SP0P8200<c<c09FEU@3fm_H0oooo0P3nood207YlN@0=02TY:@2n_[h0no[m0?glo`3n
oOl0oOco0?klo`3oo_l0oogn0?kln`3gmO@0ookm0?_kn`020?ooo`050?gmo@3emOD0o?cl0?ooo`3m
oOd07@3oool00640oooo01l0oOgm0?cmo`3nool0oogo0?olo`3oo_l0o_oo0?_onP3jooP0oogj0?ol
o@3omol0ooco0?_oo`3iood0noWh0?omo@3oo_l0oooo0?gnoP3kooh0o_oo0>_/kP2MW9l0B4M:01@B
4`16A4D0ZZZZ0>k^kP3nood0o?kk00X0oooo00D0o?cl0?ooo`3oool0PX:206e]K@020?ooo`060?[j
nP3moOd0oooo0?knoP3oool0n_[j403oool01P3lo?`0oooo0?clo03no_h0oooo0?gmo@80oooo0180
o_kn0?ooo`3kno/0E5AD07inOP0b<S80o_kn0?ooo`3moOd0oooo0?gmo@3no_h0n_[j0<C4a01`L700
KFe]0;Bd]03no_hG0?ooo`030<_;b`0410@01PH600<0000001`00P8200<10P070@404Ph;0;Rm]`3f
o_`0n?oo0?[oo`3iloX0ooco0?kno`3hm_T0ooGW0;^YVP1fMG40TIJJ0;Nna01hOhD0MWal0;Bh]`3a
l_80oooo0?omo`3oo?h0ooco0?kio@3ooOl0ooko0`3nool04@3nood0o_ok0?oon03onNh0SH1g00<7
1P1FH6D0NhJ80?;hn03mmo@0jmoN0?oho@0`:340P8B;0:>/[`3do_d0nooo0080ooco00L0ooko0?kn
oP3Rh^809bLW05]KF`3oool0o?cl00P0oooo00@0o_kn06UYJ@3:b/X0o_kn0`3oool0203lo?`0oOgm
0?ooo`3Bd]806a/K0:^[Z`3oool0oOgm0`3oool01@3jn_X0oooo0?ooo`3oool0no_k00<0oooo00d0
no_k0?ooo`3moOd0^KVi051@D00>3Ph0LW9b0=[Lf@3koOX0W9jK03m1?P0h>3P0n_[j00@0ooko00<0
n_Sk0?ono`3mno`00P3oo_l01@3ln_/0o_kn0?gmo@3oool0oOgm0080oooo00<0n_[j0?ooo`3oool0
703oool00680oooo0P3nool20?omo`0B0?ono`3nood0nook0?_onP3oo_/0oo_m0?oioP3oo?l0n?oo
0?Ooo`2>SXh0100003<a<P2^[Zh0o_oo0?[no@3lool0o_oo0P3oo_l0203^k>d0ZJNX04=3@`0A4A40
B4Y709jPW@3]kNd0oooo0P3no_h30?ooo`080?Win@3oool0oooo0?ooo`3fm_H0oooo03/k>`2l_;`4
0?ooo`040?knoP3moOd0oOgm0?knoQ/0oooo00D0M7Ad03Ph>02<S8`0oooo0?gmo@020?ooo`0=0?_k
n`3oool0oooo0?_kn`3oool0oOgm0<S8b01mOGd0IVIV0:^[Z`3jn_X0oooo0?_kn`040?ooo`050?cl
o03oool0oooo0?[jnP3oool00P3no_h00`3oool0oOgm0?gmo@020?ooo`160?_kn`3oool0XJ6Q00l?
3`0000000@4100<30`0000001PH600800@0400003@L709VKV03kood0o?om0?Ohn03ooOl0ooWo0?_h
o`3onol0TGe`0140002JUhh0If]/00P84P3Be>00m_[o0=WNh@24R8T0JVYZ0;2[[@3eknl0o_Oj0?om
o`3lnOl0ooko0?koo`3dn?T0o_oo0?koo@3moOT0ookf0?obi`0I2`00dMWG0?;oo`32cm<0c<oC0?og
m`2RTY<05PdB028Q9P34bll0n?oo0>KZj`030`<0e=7G0?ono`3mo?l0iNGU01TI6@2?Shl0oooo0?gm
o@3oool0o?cl0?gmo@3oool0oOgm0?_kn`80oooo00@0iNGU05aLG03^k^h0nOWi0P3oool02P3moOd0
oooo0?ooo`3oool0oOgm0?ooo`3De=@04A4A0;:b/P3oool20?knoP060?gmo@3oool0oOgm0?knoP3o
ool0moOg0`3oool03`3jn_X0oooo0?ooo`3moOd0oooo0=_Kf`1hN7P05ALD04E7A022PX004A4?0=GE
e@3jn_X0ooko0?glo`020?ono`060?glo`3oo_l0o_go0?ono`3lnoh0ooko0`3oool0103no_h0oooo
0?ooo`3kno/N0?ooo`00HP3oool04`3nool0oooo0?ono`3ooOl0ooko0?koo@3hoo`0n?oh0?okn03o
noX0ooKg0?oko@3gool0k_go0?clo02[YJD0h]gO0>[ZjP3in_X00P3lool03P3gno`0nocn0?ono`3n
o?l0o_cm0?ooo`3bl_00Y:JS059DD@0@4100ADE509bLW03Zj^X0o?cl103oool01@3emOD0oooo0?oo
o`3Vi^H030`<00<0o?cl00<0oOgm0?ooo`3oool00`3oool00`3no_h0oooo0?ooo`0F0?ooo`80o?cl
00/0T92@00@4101kNg/0hN7Q0?ooo`3jn_X0no_k0?ooo`3no_h0nOWi0?gmo@030?ooo`0;0?[jnP3o
ool0d];B08J6QP1RHV80WinO0?Cdm03clo<0oooo0?[jnP3oool00P3lo?`00`3oool0no_k0?gmo@04
0?ooo`070?_kn`3no_h0oooo0?ooo`26QXH03Ph>00D51@020000000M00@4100000000@0000T30`0:
10@0PX:20?kon`3lo?80oooh0?Sen`3/j?H0oo_o0?ogo`33[j80imK20?Wik@3lood0UY2J04A0CP3i
ool0n?oo0?[oo`3nool0iN3R09>=S@1kMGD0WIRJ0?;`l`3em_X00P3lool05`3nool0o_om0?oon`3o
no<0o>KI02`K4@3Ggmd0lOoo0?Ooo`3no_l0ooCg0?OWj01MEU/0h^GY0?Soo`3fo_l0YJBW0040003N
gN00oOco0=kMh00D51@0W9bL0080oOgm00<0n_[j0?ooo`3no_h0103oool01P3kno/0clo?06m_K`3m
oOd0n?Sh0?knoP80oooo00/0o_kn0?ooo`3oool0o_kn0?ooo`3emOD0oooo0=;BdP0?3`l0^k^k0?kn
oP020?ooo`040?_kn`3lo?`0oooo0?Gem@80oooo00<0no_k0?ooo`3kno/00P3oool02P3hn?P0no_k
0?ooo`3moOd0mOOd0:BVX`0`<2h04A4?0861P@3Zj^X20?ono`050?glo`3oo_l0ooko0?ckoP3noOl0
0P3oo_l00`3kn_d0oOgm0?knoP040?ooo`030?knoP3oool0oooo01`0oooo001P0?ooo`80o_om00<0
ooom0?ooo`3oo_l00P3oo_l04P3nool0nOoo0?_oo`3oo_/0oo_f0?oek`3onoX0lOko0?;oo`3jnod0
oo_i09B?S`3GemL0o_oo0?coo`3en?`0o?oo0?koo`80ooko00<0o_cm0?clo03moO/00P3nood02@3f
m_H0ZJVY05QHF00>3Ph0=CDe09VIV@3Vi^H0n?Sh0?gmo@020?ooo`030?gmo@2<S8`0J6QX0080oooo
00@0o_kn0?ooo`3oool0o_kn0P3lo?`K0?ooo`090?_kn`26QXH01PH606ATI00G5aL0;2`/07moO`3?
cll0m?Cd00@0oooo00@0lO7a0?ooo`3oool0moOg0P3oool02P3moOd0h>3P09FEU@1/K6`0Rh^;0>o_
k`3oool0no_k0?knoP3lo?`20?ooo`030?clo03hn?P0o?cl00<0oooo01l0o_kn0?ooo`2n_[h04A4A
0000000410@01PH60000000410@00P0100@0000D3a40^[Ri0?oonP3onn`0V9660000100000d03PDH
0=G7dP3on_40Zij=000300000@0081@M00L0203Tj_H0mOoo0?Soo`3gn_l0ooko0080oogm01/0j^GU
09ZHV`1eMWP0TYFI0=cRhP3jo_l0nO_h0?oon`3oo_H0oo[]061BA`2FVY/0looo0?7io`3[jo<0fLkB
06eQH`3mn?X0o_oo0?Woo`3cnOT0>CTi00X82@3;b/d0d]7D01/J7@2NWYh00P3oool0303moOd0oooo
0?Gem@3oool0o_kn0?Ogm`3oool0no_k0:>SX`2BTY80oooo0?[jnP<0oooo0P3no_h20?ooo`030?gm
o@3oool0no_k0080oooo00<0b/[:00T92@2f][H00P3oool00`3hn?P0oooo0?knoP020?ooo`040?_k
n`3oool0o_kn0?ooo`80oOgm0P3oool0303no_h0oooo0?gmo@3oool0nOWi0000001QHF404a<C05EE
E@36a/H0oooo0?Cdm080ooko00H0o_go0?Ken03oo_l0ooko0?gmo@3no_h20?ooo`040?gmo@3oool0
oooo0?clo1d0oooo001P0?ooo`80o_om0P3oood20?ooo`0@0?ono@3nool0nOoo0?_oo`3oo_/0ooC/
0?odj03onO80lOko0>_no`3nool0oogk0?ghn01^KV`0m_Oi0?_oo`80o?oo01P0noco0?cmo`3oo_l0
ooko0?ooo`3oood0oOgi0?_mn03lo?`0oooo0?knoP3moOd0^[Zj05EEE@0B4Q80?Shn09:BTP3Vi^H0
m_Kf0?ooo`0n?Sh0ZZZZ0?ooo`3no_h60?ooo`030?knoP3kno/0oooo01T0oooo0140@41001PH603m
oOd0oooo0<W9b@1`L7009BDU01dM7@1]KFd0]KFe0?ooo`3moOd0oooo0?gmo@3inOT0oooo0?gmo@02
0?ooo`80no_k00H0oOgm0>o_k`2@T900Fe]K08b<S03Lg=`20?ooo`050?_kn`3oool0oooo0?ooo`3k
no/00P3oool01`3lo?`0oooo0?ooo`0;2`/00`<3000000010@400P000000>@051@D01@<401/I6P3l
n_/0o?Oa0?oei00I3`40VYnS0?3fo`27OhX06P/@0?CUgP0>1@00Z:jZ0?Sln`1oKg003P040<?:f03a
ool0mooo0?_oo`3oo_l0o?Og0?omn`3oo_/0oO_l0?koo`3[k_80YZ^^06eaLP2=Sh`0emOC0?kgk`3o
o>d0k=kC00<21@3FgND0em_V00X:4P28PH@0ooWj0?omo`3hmoX0n_ko0=SLg@082PL02`/;0:BSYP0B
4A@0Y:>V0?ooo`3jn_X0oooo0?[jnP3inOT0oooo0?clo0020?ooo`060?Cdm022PX80_[jn0?Win@3j
n_X0oOgm0P3oool00`3no_h0oOgm0?knoP020?ooo`0;0?gmo@3kno/0oooo0?ooo`3kno/0oooo0<K6
aP0Q8B40^k^k0?Win@3moOd00P3oool01@3inOT0oooo0?gmo@3oool0o?cl0080oooo00D0n_[j0?oo
o`3oool0no_k0?Ogm`030?ooo`09024Q8@3Ogml0jNWY09:BTP0V9RH0;Bd]0:>SX`3jn_X0oOco0080
ooko00L0o_go0?_kn`3oool0oooo0?knoP3oool0o_kn0080oooo00<0o?cl0?ooo`3oool06`3oool0
0600oooo0P3nood20?ooo@0^0?kon`3ooo/0oook0?ooo`3gool0nOoo0?olnP3onnl0ooCQ030O5@0b
?e00gO7o0?kno`3Rg=X0oogm07YjN02a/[@0o?oo0?_oo`3dmo/0n__o0?koo`3oo_l0o?[k0?klo@3o
ood0oook0?gmn@3oool0n?Sh0?ooo`3jn_X0o_kn0?ooo`3jn_X0^KVi06=SH`0A4A40=cLg07inOP0A
4A40oooo0?Win@3oool0o?cl0?_kn`80n_[j00@0o_kn0?ooo`3oool0oOgm6@3oool00`3^k^h05ADE
00D51@020?ooo`0:0?Win@3oool0oooo0=;BdP23Ph<0?Cdm00820P1IFET0[jn_0>o_k`80oooo00@0
o?cl0?knoP3oool0o_kn1@3oool01`3_knl0Z:RX065QH@1jNWX0d];B0?_kn`3moOd00P3oool20?cl
o080oooo0300n_[j0>7Qh@010@4010@4000000061PH02PX:000000020`D0m_Kf0?ono`3ooOH0k]W6
01<5003WlOP0m?oo0?olo02GRH@0bl:m00`<303/m_l0loSl0?ohlP0c8Ad0TiZZ0?3oo`3^nol0nOoo
0?ckoP3oo_/0ooci0?onnP3oood0nocl0?[no`3kool0o?oo0?;cl`2j^;L0OWUa08UmK@3Od/L0hmcQ
06ARK`0o?T`0BTaF0?ono`3ooO`20?ono`070?glo`1:Bd/000400001000B4A@0X9jQ0?Gdm`080?oo
o`050?;blP1ZJVX0bl_;0?ooo`3jn_X00P3oool00`3moOd0o_kn0?ooo`020?knoP80oooo0P3no_h0
3@3moOd0o?cl0?gmo@3oool0n_[j0;fm_@0@4100bLW90?ooo`3moOd0oooo0?_kn`3no_h00`3oool0
0`3no_h0oOgm0?ooo`020?knoP<0oooo0180o_kn0?ooo`0j>SX0]kNg0?ooo`3nood0nO_h0;^m^P15
Ad@0418?06e^KP3Gf=P0o_oo0?gnoP3loOd0oooo0?ooo@3knoT20?ooo@030?clnP3oood0ooom00P0
ooom5@3oool00600oooo0P3nood00`3oood0oook0?konP020?oonP0A0?ooo`3hool0mogo0?okn@3o
m^L0ooWO06QFB01]O940cnCo0?Sjo`39`l40;RTY014A3`3/kNl0n?cm0?Smo`3kool00P3nool20?on
o`070?omoP3hm_D0n_[f0?oon`3inOT0oooo0?Ogm`030?ooo`0:0?clo03no_h0oooo0?_kn`30`<00
?clo0000000Y:BT0RXZ:0=gMg@@0oooo0P3no_hK0?ooo`0409nOW`1?Cdl04A4A0>SXj080oooo00<0
m_Kf0?ooo`3hn?P00P3oool03`3WinL0VIVI04I6AP0:2PX0ATI608b<S03Zj^X0oooo0?[jnP3oool0
o?cl0?ooo`3kno/0oooo0?Ogm`030?ooo`050?Ogm`2d];@0KVi^07EeM@2l_;`00P3oool00`3jn_X0
oooo0?gmo@020?ooo`0f0>3Ph017AdL00@4100X:2P030`<0>CXj0>[^k`3fn_T0ookm0?ogk`3om>40
91@50:Vj`@3`ool0oooc0?omk@3glo005QXU0;S4f03ko_l0oo[/0:VER01=EVD0kOoo0>kmo`3hool0
ooko0?onn`3mmo@0oooh0?knnP3lool0nooo0?Olo`3ioOh0nocl0?[hm`3nnO40o??R05M=@@1fKG80
?SM60=SEi02;RiD0dm;E0?ooo`3kno/0oOgm0<c<c0020P0010@000L71@0000802PT<0`0000003P3o
ool0o?cl0?ooo`3gmoL0oooo0>KViP1NGUh0k^k^0?ooo`3moOd0oooo05eMG@3emOD0o_kn103oool2
0?knoPD0oooo00l0lo?c0?ooo`3oool0`<3000l?3`33`l<0oOgm0;6a/@1jNWX0o_kn0?ooo`3no_h0
oooo0?Win@3lo?`0103oool01`3inOT0oooo0?7al@3oool0Ogmo0:f][@3kno/00P3nood02`3koOX0
o_om0=kPg@1jO7T06AXJ04E6AP2c];@0oOkn0?Ogm@3oood0n_[h0080ooom00<0no_i0?ooo@3oood0
203ooodE0?ooo`00H03oool20?koo@80oook01@0o_oh0?oon03oooP0ooko0?Soo`3io_l0oogk0?oh
j@3on]X0]jJD05ITOP3Tn_l0o?ko0?okn@3lmoL0no_i0?cmo`3lool0nooo0??hn`80oOko00H0o?_n
0?clo03oo_l0ookm0?oon`3moOT30?ooo`030?Shn03oool0o?cl0080oooo00l0o?cl0?ooo`3kno/0
AdM70:j^[P2o_kl0KFe]014A4@0_;bl0N7Qh0<o?c`3no_h0oooo0?_kn`3moOd06P3oool01P1>CTh0
WYjN03Lg=`3;bl/0o_kn0?gmo@<0oooo00h0n_[j0?_kn`3oool0oooo0?knoP3inOT0Zj^[069RHP0A
4A40<30`08^;R`3@d=00oOgm0?knoP<0oooo02l0nOWi0?ooo`3oool0m_Kf0?knoP3oool0nOWi0<30
`01]KFd0IFEU0;fm_@3oool0no_k0?clo03oool0o_kn0?Win@3oool0f=SH0?ooo`3loOd0nOoo0?_o
o`3ooo/0oo_c0?ohiP1iJEX0?eIL0>[oo`3oonL0c/N[07n0P01LI7L0CUio0?Gjo`3on>80]9j700XC
8P3Qn?l0lOoo0?;ko`3gn?`0ookk0?onn03oooP0oOgi0?[nn`020?_oo`0H0?coo`3nool0ookm0?om
n03ooNl0Y9N<03Ha=@3bkoh0cl[L061LJP3nn?l0o_kn0?_oo`3iool08B8R00<100060000100000<4
10083Ph05aPH07EeM@2SXj<0no_k0`3oool02@35aLD0MWIf0?gmo@3kno/0VYZJ02@T903WinL07alO
0=gMg@050?ooo`80o_kn0P3oool00`3moOd0oooo0?knoP030?ooo`0:0?Gem@2k^k/05QHF0=GEe@2m
_Kd0?Shn0?ooo`3dm?@0oooo0?_kn`<0oooo00L0no_k0?knoP3oool0oooo0?kmo`3oo_l0oooo0080
o?cl00<0o_kn0?koo@3hn_L00P3nood0203hn_L0o_om0?OimP2NX9d0=cTf01/M6P3Ng]`0ooom0P3m
oO/00`3oood0o?cj0?ooo@090?oooAD0oooo001P0?ooo`0F0?koo`3nood0ooom0?oon`3nooX0oooh
0?oonP3oool0mogo0?_no`3oo_/0oog]0?ofg03/g/l01Q4S0>[io`3lool0o_Wi0?ono@3oool0o_oo
0?[no`80o?oo00X0o_oo0?gno`3noOl0oooo0?ono`3ln_T0o?cj0?ooo@3oool0n_[j0P3oood0503l
o?`0ooko0?ckoP3oo_l0ooom0?kno03dm?803Ph>0?Gdm`3oo_l0o?cl0?ooo`34a<@0Lg=c02<S8`0U
9BD0NGUi0=KFeP3no_h0no_k603oool06P3YjNT04Q8B0??cl`2ZZZX0e=CD0?ooo`3inOT0oooo0?kn
oP3oool0o?cl0?ooo`3kno/0o?cl0?ooo`3lo?`0o_go0?ono`3hn?P0`L7106][J@0P82009B@W06e/
K`30`<00mOGc103oool01@3oo_l0o_go0?clo03oool0o?cl0080oooo00P0`/;207QhN01WIfL0/K6a
0??cl`3oool0oOgm0?_kn`80oooo01/0oOkn0?_oo`3goO/0ookm0?okm@3onN/0im[A00052`1QNGT0
d]Bl04U4;01FEeL0e]k`0001701`Lh@0ckbY02/J1P001A00f^co0?Coo`3fo?l0o_oo0?oon`3oo_X0
o_gh0?oon`3jo?T00P3kool05P3jo_l0o?gm0?ono`3onOH0dLNm071WGP1;BD`0dm?M02`X=P3/iO80
ooco0?gmo@3kool0JG5_00H81@040P402@0000d50`1:Bd/0bLo=0?coo`3hn_L20?ooo`060?cjn`3n
o?d0YZBU09JFUP3oool0moSh0P3nood01`2>SXh092@T0490@@2h][L0oooo0?knoP3moOd00`3no_h4
0?ooo`040?gmo@3no_h0oooo0?knoP80oooo00P0no_k0:b/[00G5aL0^[Zj01XJ6P3no_h0oooo0?_k
n`80oooo00X0oOgm0?clo03oool0oooo0?gmo@3oool0ooko0?_jo@3oool0oOgm0P3oool01P3jo?T0
oOol0?goo03koOX0o_om0?_mnP80o_om00X0nogj0<oAcP3:b/P0oOgk0?ooo@3lo?X0ooom0?gmn`3o
ood0o_kl203ooodE0?ooo`00H03oool40?koo`<0ooom00l0oooo0?gno`3loOl0oook0?onmP3on>d0
ookf01hQ9@3<d=L0oOko0?gmo@3oool0o_oo0?gmo@3loOd00P3nool0103oo_l0oooo0?ooo`3oool4
0?ono`0=0?glo`3oool0oook0?gmn@3lnoh0ooko0?WhoP3oo_l0oook0?oonP2PXI/0CTi<0?gno`02
0?koo`80ooom00/0ookm0?gko03=bl`0Lg9e02<R9@0O8280N7Uk0=3Ad`3gn?X0oooo0?knoP020?om
o0050?ono@3no?/0oooo0?ooo`3no_h00P3oool0203moOd0o_kn0?ooo`3oool0no_k0?ooo`3jn_X0
oOgm0P3oool01`3moOd0U9BD05YJFP3oool0o_kn0?ooo`3lo?`02@3oool03P3oo_l0no_o0?kno`3g
mOH0ookm0?cnn@3nood0clkC0860Q@0`<Rl05ALB05UIE`2c/K00m_Ce0P3oo_l01P3jnOh0ooko0?oo
o`3no_h0no_k0?knoP<0oooo02D0B4Q80820P01UIFD0Jf][0>o_k`3oool0n_[j0?ooo`3nool0nocl
0?knoP3oo_/0no?^0?onn`3Mh^D0D5QH00<4000`;bP0d];B0?coo`3KgnP0GEeS00P0002?RX@0OH24
0<[Af@3kool0o_oo0?ono`3moO/0ookm0?kno03moO/0oooo0?gnoP3nool0o?gm0080oooo02<0^;Je
08b8Q@3oo?T0k>c/0000102b/KH0oogo0?_io03oool0blc<00T:2P0000001`L704m:BP3MfmX0o_kn
0?coo`3koo/0o?ok0?ooo@3oo_l0ooco07YcN02k][P0ooko0?koo`3kool0nooj0?Kmm@3mo_h0NWUl
01/F602;QXP0ookm0?gknP020?ono`040?ooo`3moOd0oooo0?knoP<0oooo00`0n_[j0?ooo`3oool0
moKi0?ono`3inOT0oooo0:BTY00A4A402@T90?[jnP3oool20?knoP070?ooo`3kno/0oooo0?ooo`3i
nOT0oooo0?[jnP0e0?ooo`00H03oool40?koo`@0oooo0P3oood01`3lo?P0oook0?oon`3kn_H0Ph9m
08^;Q`3oood00P3nool01@3loOd0oooo0?ooo`3oool0oOgm00@0oooo1@3oo_l04`3inOT0oooj0?oo
nP3kn_d0mOCj07QfP@3Hem`0o?ch0?oomP1IFU@0XJ6O0?_ko`3no_l0n?Wi0?oon`3mnoX0ookm0?on
o`3imoP00P3oo_l02P35a/P0NGYl01dN800V9bT0L71`0<g=c@3jn?L0ookm0?onn`3oo_d20?ooo`03
0?knoP3moOd0oooo0080oooo00@0no_k0?ooo`3no_h0n_[j0P3oool01@3hn?P0oooo0?ooo`0i>CT0
/[:b0080oooo0P3moOd00`3oool0oOgm0?ooo`060?ooo`0D0?koo`3lool0n_[o0?olo`3oo?X0oooh
0?Gjl`3nool0o_ko0?koo`3PhN40TiF?04Q7@P080P00D4U<09BCV@3`l?H0no[m0?gmo@3no_h20?oo
o`0<0?gmo@3oool0nOWi02LW9`3Fe]H0OGem069RHP2BTY80Hf=S092@T03Shn<0n_[j1@3oool0103n
o_h0oooo0?[jnP3moOd30?ooo`030?gmo@3oool0no_k00<0oooo00<0n_[j0?ooo`3no_h00`3oool0
4`3emOD0oooo0?ooo`3moOd0o?cl0<g=c@2@T900o_kn0?ooo`3gmoL0gmoO0?KfmP3kno/0oooo0>CT
i0030`<0000001<C4`2k^k/00`3oool04`3hn_L0o?ok0?con`3knoT0mO?d069MG`3Sg^00ooko0?ck
oP3nool0o?oo0?[on@3looP0o_om0?[jnP0k=SP081/M0?OemP3ooO`00P3oo_l01P3jn_X0o_kn0?oo
o`3jn_X0oooo0?gmo@@0oooo00P0ooko0?[io03oool0nOWi0?ooo`1kNg/000000;jn_P<0oooo00<0
n?Sh0?ooo`3gmoL00P3oool00`3bl_80oooo0?ooo`0d0?ooo`00H03oool40?koo`@0oooo00T0ooom
0?[jn03moOT0oook0?ckm`3ooo/0fm[F02<S7`3hn?H00P3nool0103jno/0oooo0?ooo`3no_h50?oo
o`D0ooko00<0oooo0?cmm`3ooo/00P3oo_l03P0l>TD05A@I0?oon`3]k^@04A8<0>_[j@3lnol0moKl
0?ooo`3moO/0ookm0?ojnP3mno`0oogn0P3oo_l30?koo`090<o@dP1mOWh09BHV01lO7@1[JfT0_kfl
0?kln`3oool0oOgm00<0oooo00D0moOg0?[jnP3oool0oOgm0?clo0020?ooo`060?gmo@3no_h0oooo
0=_Kf`0C4a<0oOgm0P3oool0103kno/0oooo0?ooo`3moOd70?ooo`0E0?koo`3kool0moOm0?oko`3o
nod0no_^0?com03ioOh0mOOo07ajS@19B5D0loW]0?gok`3jlNX0ZYnQ05mOI`072a@0?Sm308V9R@3M
gMd0nOWi0080oooo00H0moOg0?ooo`13@d<0]kNg02DU9@32`/820?ooo`070=oOg`2QXJ40JVYZ0820
P03EeMD0oooo0?Win@020?ooo`040?gmo@3oool0oooo0?[jnP80oooo00H0o_kn0?ooo`3oool0no_k
0?ooo`3jn_X20?ooo`060?clo03kno/0oooo0?Shn03oool0o_kn0P3oool0103Shn<0KVi^0?ooo`3m
oOd30?ooo`0P0>7Qh@3oool0n?Sh00h>3P051@D0FUYJ0??cl`3oool0n?Sh0?[jnP3oool0oOgm0?_i
n03ooO`0g]kL069TH@3]kn`0noon0?Cem`3nool0ooko0?_inP3oooX0o?_d0?oon`3Lg=X03Pl?020Q
8@14A4@0noWj0?omoP3oo_l20?ooo`080?KfmP3oool0nOWi0?ooo`3jn_X0oooo0?knoP3hn?P40?oo
o`0709NGU`0E5AD08b<S01LG5`3Ti>@0oooo0?knoP020?ooo`050?_kn`3oool0oooo0?ooo`3inOT0
=@3oool00600oooo103nool40?ooo`0<0?ooo@3hn?H0oook0?oon`3lnoL0oook0<c;a`0820@0iNGU
0?_lo03nool0nocl0P3oool00`3lo?`0oooo0?ooo`030?ooo`D0ooko0140oooo0?oonP3ooo/0n_Wl
0?ono`2GUIh010<809jNVP2][ZH0>CXd0?ooo@3oo_l0]kJl0=?Cd`3oood0n_Ge0?omo@020?ono`03
0?CcmP3oo_l0o_oo0080nocn0P3nool02P3loOd0f=SH08R8QP0b<S0051@B06a/K02k^k/0o?cl0?oo
o`3inOT20?ooo`0:0?clo03oool0oooo0?[jnP3no_h0j>SX06YZJP3oool0QHF5065QH@80oooo00@0
no_k0?ooo`3oool0o_kn2@3oool09`3ko?h0ooko0?olo`3ooOd0oOob0?komP3lool0n?Oo0?;]o`1U
Hg00nOoj0?_om03oo?T0oo_o0?ShoP3en?l0];Fg06MWI`0I6AT0:RXZ07=cL`38b<P0oooo0?Win@1Q
HF40PH6102@T903oool0n_[j0?ooo`3kno/0o?cl0?ooo`3Rh^80Zj^[06UYJ@20P800emOG0?[jnP02
0?ooo`060?_kn`3no_h0oooo0?_kn`3oool0no_k1`3oool02P3moOd0oooo0?ooo`3lo?`0oooo0?[j
nP3no_h0[Zj^0<S8b03moOd20?ooo`090=gMg@0C4a<03`l?01TI6@0F5QH00`<309^KV`3lo?`0oOgm
00D0oooo01D0ooko0;Vg^01oOgd0oOoj0?Sln@3lood0o_oo0?kmo`3mn_l0ooko0?kmn03mo?D0_Kbe
020P701cM7@0>c`n05QHF01@CTl0noWj0?ono`3moOd00P3oool01@3inOT0oooo0?knoP3oool0n?Sh
00@0oooo00P0o?cl07YjNP0V9RH0gMgM05YJFP1LG5`08b<S0>GUi@80o_kn00D0n_[j0?ooo`3kno/0
oooo0?knoP0f0?ooo`00H03oool40?koo`@0oooo00`0o_kl0?ooo@3no_`0oOgk0?oon`3oo_X0b/W5
09NGT`3UiND0nocl0?koo`3ko?`20?ooo`030?clo03oool0oooo00<0oooo103oo_l0103oool0n?Sf
0?knnP3knoL20?ono`0@0<2na`0000@010@006=TG02@TH/0WinM01PG700000@0l>ob0?ooo`3ooOd0
o_Wi0?omo03oo_d0oooo0?Win@<0o_oo00<0n?Wk0?Kgn@3nool00P3nool0203jno/0h>3P08:2PP0g
=cL061PH05iNGP31`L40lo?c0P3lo?`0303inOT0o?cl0?ooo`3inOT0n_[j00D51@3kno/0<S8b0<[:
bP3jn_X0oooo0?_kn`80oooo00<0n_[j0?ooo`3oool01P3oool04@3oo_l0oogm0?oin@3jn_P0o?om
0?Sin@3loOl0o_ko0?olo`3om?X0IUmR0=KRh03aool0o_ko0?olo`3oo_l0o_kl0080o_kn00T0oooo
0=3@d01fMWH08b<S01XJ6P1VIVH0J6QX02l_;`1mOGd0103oool20?clo080oooo00L0nOWi0?7al@2]
[Jd0Jf][06m_K`35aLD0oooo0080o_kn0P3oool00`3inOT0oooo0?knoP020?ooo`030?_kn`3lo?`0
oooo00<0oooo00/0o?cl0?ooo`3moOd0o_kn0<g=c@2XZ:P0oooo0?clo03jn_X0C4a<00L71`030000
00030:>SX`3lo?`0oooo0080oooo01L0o?cl0?[jnP3inOT0ooko08^<T02OWZ<0moOe0?oonP3ooo/0
n_Sg0?omo`3nnol0ooko0?koo`3hn_@0[:nT01LH3P2_/:P0j^SY014>503hmoX0?Cdm06EUI@020?oo
o`060?Win@3oool0oooo0?_kn`3oool0oOgm0P3oool03@3kno/0o?cl0?KfmP1GEeL0=SHf0>c/k03o
ool0Q8B407emO@2<S8`09BDU0>WYj@3no_h00`3oool00`3no_h0oooo0?knoP0e0?ooo`00H03oool4
0?koo`@0oooo0P3oood01`3no_`0moOe0?oon`3ooo/0o_gi0?ooo@3hn?P00P3nool0103jno/0oooo
0?ooo`3no_h50?ooo`@0ooko01T0o?cl0?ooo@3ooo/0ooom0?[io03oo_l0g]gS00l>4`092@D00@80
00`<200:2PP01`H90:n^/`3noOl0o_cm0?omo@3on_X0SXb;00T71P0e=CD0[Zj^0?Sin`3nool0oOko
00@0o_oo00/0nocl0?koo`3ko?`0oooo0?knoP3Ogml0TI6A03@d=00G5aL0GEeM0;Rh^0030?ooo`06
0?_kn`3oool06ATI0;jn_P0L71`0n?Sh1@3oool00`3jn_X0oooo0?ooo`060?ooo`0E0?onn`3om_00
ookf0?3hn03gool0ooko0?[fo`3fm_l0n_Om0?okmP2^YJ00YJfh0?;oo`3bmol0no_o0?onn`3oooP0
ookm0?ooo`3inOT0oOgm0080oooo00T0g=cL08b<S00h>3P01@D50>3Ph03moOd0oooo0?clo03kno/0
0P3oool03@3no_h0n?Sh0?ooo`3oool0oOgm0?ooo`3lo?`0_[jn075aL@1OGel0`L710?_kn`3hn?P0
0`3oool0203no_h0oooo0?knoP3no_h0oooo0?knoP3oool0nOWi0`3oool01`3no_h0oooo061PH03e
mOD0oooo0=KFeP0820P00P0000000`061PH00@4104Y:BP020?ooo`030?clo03oool0oooo0080oooo
01P0JV]]0<[=e03lool0oOgk0?olm@3ooOX0oogk0?ceo03oo?l0ooko0?Gin01nQGh05A`B0=_Od03o
ooH0ooco00/5303ln_d0oOgm03`l?01RHV80nOWi0?ooo`3lo?`20?ooo`080?Ogm`3kno/0oooo0?gm
o@3oool0lo?c03/k>`1IFET20?_kn`0:0?ooo`2EUID0HV9R0?_kn`25QHD0;bl_0?3`l03moOd0m?Cd
0?ooo`80o?cl=P3oool00600oooo103nool40?ooo`80no_k0P3oood01@3mnoX0ookm0?ono@3fm_@0
oooo0080o_oo00D0o?gm0?ooo`3oool0oooo0?gmo@040?ooo`@0ooko0P3oood03P3hn?H0ooom0?gl
o`3in?d0g=_P00L62@0000000P8000/:1P010000YZBW0?ono`3ooOl0ooko0P3ooOd02P3mnoX0Xj6P
0=SHf03UiND0oooo0?clo03in_`0o_oo0?cmo`3fmoT20?coo`050?[no`3nool0o_kn0?ooo`3no_h0
0P3oool0303Vi^H0T92@03Xj>P061PH0GemO0:VYZ@3no_h0no_k03Ti>@1LG5`0MGEe0?gmo@@0oooo
0`3no_h70?ooo`0B0?onn03on^P0h=S;00033P0Z>D`0_[K300L0102_/[T0o?oo0?omk03ai^00Jff4
0>cfo`3eool0nOoo0?olm@3oo?@0ookj0P3oool02P3inOT0o_kn0?ooo`3inOT0oooo08^;R`0@4100
n_[j0?ooo`3jn_X30?ooo`030?Win@3oool0oOgm0080oooo00@0no_k0?knoP3oool0moOg0P3oool0
1`31`L40LG5a06][J`2`/;00mOGe0?ooo`3lo?`00P3oool00`3moOd0oooo0?ooo`020?ooo`0/0?Og
m`3oool0oooo0?_kn`3jn_X0l?3`071`L03oool0k>c/00@4100000001@D5000000020P80J6QX0?oo
o`3jn_X0oooo0?Gem@3oool0lO7a05EEE@3TiNT0loOo0?_oo`3lo?P0ookf0?okmP3oo?/0oo_o0?ol
o`3loOl0BDm=03Do>P3[m>`0m?_[0?gml@3oo?l09adV0=;@d`3nool0n?Wi0;bm_@3Lg=`30?ooo`0H
0?clo03oool0oooo0?Shn03oool0emOG02HV9P1bLW80o?cl0?ooo`3no_h0oooo0;no_`0o?cl0oooo
0?knoP1gMgL0;Rh^0?Gem@3no_h0oooo0?knoP3oool0o?cl=@3oool00600oooo103nool60?ooo`08
0?gmn`3oood0ookm0?ono@3mnoX0ooom0?knoP3loOd20?koo`80oOgm1P3oool40?ono`080?_kn@3o
ood0o_kl0?Ogm`3lnoh0ooko0=[IgP0@3a820041000700L60P1ACdh0ooko0?gkoP3oo_l0oogo0?on
o`020?ono@070?gknP2ATI40h>3P0?Win@3oool0o_oo0?Gfn0020?koo`050?_oo`3lool0nOgn0?co
o`3no_h00P3oool00`3no_h0oOgm0?ooo`020?ooo`0:0>_[j`2GUiL0@d=300d=3@1ADE40>SXj01@D
503AdM40oooo0?gmo@80o_kn00@0oooo0?[jnP3oool0o_kn1`3oool04P3oo_H0oo[R09nIR@18E6P0
koSo02HF800J2P/0[;>k0?3ko@3ooo40^k:[00/97`3/kol0mooo0?Soo`3lno@0ooof0?oon`80o_kn
0P3oool02`3kno/0oooo0?ooo`1=CDd03Ph>0?ooo`3lo?`0o_kn0?ooo`3no_h0oOgm00<0oooo0P3l
o?`20?ooo`0=0?_kn`3oool0oOgm0?ooo`3kno/0oooo0?gmo@3>c/h0OWin06ATI02OWil0k>c/0?oo
o`020?gmo@060?clo03oool0oooo0?ooo`3jn_X0oOgm0P3oool01P3lo?`0`L7108f=S@2IVIT07alO
00H61P800@4100<000000>WYj@3oool00`3oool07@3EeMD0IFEU0?Ogm`3mo_l0o?ko0?Sko`3ooo/0
oogd0?onmP3omo@0ooco0>WSj`0a<S80FUiM0?;hn03ho_X0o_oc0?ool`3onoh0ASi70;^j_@3in_X0
o_oo0?cmo@3moOd0o?cl0?ooo`3no_h0oOgm00<0oooo00<0a<C401@D502MWId00`3oool01P3no_h0
o?cl0>GUi@11@D40oooo0?gmo@80oooo00<0no_k0?ooo`3oool00P3lo?`f0?ooo`00H03oool40?ko
o`P0oooo0`3oo_l20?ooo`<0o_oo203oool40?ono`80ooom01H0o?cl0?kmo`3oo_l0n_Wn0>3OhP0:
2PX01@<400@20@0o?SX0oOch0?ono@3clO80m>oc0?klo`3oo_l0oooo0?knoP3oool0oOgm06YZJP3d
m?@0oooo103nool40?coo`P0oooo00X0oOgm0?ooo`3oool0i>CT0:>SX`0K6a/00@4104];B`2LW9`0
j^[Z0P3oool00`3kno/0oooo0?ooo`030?ooo`80oOgm0P3oool04`3moOd0oooh0?ooj@39a[/02@lW
0?Sho`3fgmT04P000=3Lj03`ool0o?oo0?onn`3onol0oo[o0?kmo`3lo_l0o?ok0?con03nood00P3n
o_h30?ooo`060?_kn`3fm_H030`<00D51@3gmoL0nOWi0`3oool00`3no_h0oooo0?ooo`0>0?ooo`09
0?Win@3MgMd0SHf=05iNGP2FUYH0i^KV0?ooo`3no_h0no_k0080oooo00`0oOgm0?knoP3oool0o_kn
0=oOg`0J6QX0U9BD0?[jnP2ATI406ATI04m?C`3Shn<20?ooo`0W0?knoP3oool0];Bd08:2PP3oool0
nOWi0?ono`3onol0ooco0?cjn@3oooP0o_oe0?gnn03BdM@07ahS081nO@3oo_d0o__o0?ono`25QGP0
2P`0030`<02ZZ[00nooo0?coo`3jo_l0o?oo0?[ko@3nool0o?cl0?gmo@3oo_l0oO_l0?clnP2][J/0
4Q8@0;Zj^03nood0n_ci04D0oooo001P0?ooo`@0o_oo203oool30?ono`80oooo0`3nool80?ooo`<0
ooko00<0ookm0?oon`3moO/00`3oo_l04`3mo?l0`<3000l?3`0100002`T:0>SVi@3ooo/0VIRD05YH
E`2PVil0FeQN0>GTi`3mo?l0nOSk0=oOg`3moOd0OGem0;Jf]P3oool0103nool40?coo`T0oooo0140
o?cl0?knoP3oool0o_kn03`l?00d=3@0ZJVY05MGE`0<30`0?Cdm092@T03WinL0n_[j0?ooo`3kno/0
o_kn0?gmo@020?ooo`0G0?gmo@3oool0oooo0?kon@3ooo40l?7Y010@9P3Rf^d0ooOW07]ZF023Sid0
k_oo0?Woo`3oool0oogj0?olo03on_l0ooco0?_oo`3iooX0o_om0?ooo`3no_h00`3oool02@3moOd0
no_k0?_kn`0Y:BT0g=cL0?ooo`3kno/0oooo0?Win@0B0?ooo`080?clo03kno/0oooo0>GUi@2CTi<0
JVYZ08:2PP3Shn<20?[jnP80oooo00H0no_k0>c/k00I6AT0T92@07UiN@3Ti>@20?ooo`080?clo03n
o_h0oooo0?ooo`3inOT0TI6A0:NWY`3moOd20?ooo`0G0?omo`3onol0ooco0?ono@3loOD0noke0;Ni
/`0F5aL0YJFU0?oon03oo_/0oo_o0?kho`3ooo@0XJ>E0=cNf`3Xjnl0nooo0?[oo`3gno`0o?oo0?ko
o`3in_`00P3oool20?ono`0608V9Q`0I6AL0dM7?0?ooo@3gnOH0o_omA@3oool00600oooo103nool8
0?ooo`<0ooko0P3oool30?koo`P0oooo0`3oo_l01@3oo_d0o?ch0?clnP3oo_l0no[o0080ooko0180
ZJNV00H40`0610L0NgUl0?okn`3oo_/0RhN408^6QP3ooOl0g]_R00T:3P3ko?l0n__o0;o0`P0_<380
5QLI0>[ZjP3moOd20?ooo`@0o_oo0P3lool;0?ooo`0Q0?knoP3oool03Ph>03Ph>03kno/0oooo0?Wi
n@2d];@0IfMW00P8200_;bl0QhN70=cLg03oool0oOgm0?[jnP3lo?`0oooo0?clo03jn_X0ooom0?Gg
lP3oood0]k>m03<Z;@3ooNP0Uhim03HnD03Ymol0noko0?ono`3moo80oood0080ooWo00<0nooo0?So
n`3lood0203oool01`0n?Sh0/[:b0?ooo`3moOd0no_k0?ooo`3no_h0403oool0103kno/0oooo0?kn
oP3kno/20?ooo`0@0?Ogm`3^k^h0YJFU06EUI@1nOWh0fMWI0?_kn`3oool0U9BD0:b/[03inOT0oooo
05QHF03^k^h0oOgm0?_kn`80oooo02@0m?Cd06i^KP3>c/h0oooo0?knoP3oool0o?cl0?kmo`3oo?l0
n?Gl0?gknP3oooP0V9N@01@C3P3>c</0ookj0?oom03gm_40oo_o0?kio`3oo_L0no_^08n?S@3If]`0
nooo0?Ooo`3kool0o?oo0?[ko@3nool0oooo0?Shn03elo@0IVAU03@b<@3[jNP20?ooo@030?_mnP3l
o_/0oooo04@0oooo001P0?ooo`@0o_oo203oool30?ono`80oooo0`3nool80?ooo`<0ooko01L0ookm
0?knnP3ooo/0ooko0?cko`3oo_l0o_kn09BBT@0200004@lB0?ono`3km_P0oo_h0=gIe@0B3P/0lngd
0?omo`1iNGl0RHbA0?coo`3ko?l0loCh0?;cm@040?ooo`H0o_oo2@3oool04`3inOT0oooo0?knoP2]
[Jd0=3@d02LW9`3oool0o?cl0?ooo`3jn_X0m_Kf0?ooo`31`L40JVYZ01TI6@0Z:RX0O7al0=3@d03j
n_X00P3oool04`3no_h0oooo0?koo`3no_h0oOSj0;bd/@1VH4h0HF5D00002`3WkOl0ooco0?ono`3k
oo<0o?oc0?oko`3on_l0o?oo0?Woo`3nool00`3oool00`3no_h0oooo0?ooo`020?ooo`030?gmo@3o
ool0nOWi00<0oooo00<0o?cl0?ooo`3oool03P3oool01@3no_h0oooo0?ooo`3oool0o_kn00<0oooo
01<0o?cl0?gmo@3]kNd0Z:RX075aL@1`L700/K6a0?clo03oool0moOg0?ooo`19BDT0inOW0?ooo`3h
n?P0eMGE05MGE`3Xj>P0oOgm0080oooo01L0oOgm0?clo03mo?l0o_ko0?koo`3oo_d0J6AP02dW903V
h=d0oOWf0?Sgl03oonl0oooh0?gko`3knOl0oOgk0?oom03onoP0KVa_0>gcl`3iool0nooo0>oem@02
0?koo`060?clo03clo<0B4I705=ADP3[jNP0o_ck0P3oood00`3moo`0o_om0?ooo`140?ooo`00H03o
ool40?koo`80oooo2P3oo_l0103oool0o_oo0?koo`3nool80?ooo`<0ooko01T0ookm0?oonP3noo/0
o?_o0?omo`3mo?l0n?Sh05ACC`010000W9ZM0?Sen`3ooOl0ookk0?omm`0O6AL0h]_R0?olo`2VZK00
ADU@0?Wmo`3lool0nOco0?koo`3no_h0oooo00@0ooom00@0oooo0?koo`3nool0o_oo203oool0203k
no/0o_kn0?[jnP3lo?`0Hf=S08n?S`000000oOgm0`3oool07P3moOd0lo?c0?ooo`3hn?P0o_kn0<[:
bP1cLg<0:b/[02HV9P1QHF40aLG50?ooo`3kno/0o_cm0?Wgn03ooOl0oogl0?Gjl`3jooT0EEMD0:j/
[`3on_l0ooco0?Soo@3hooP0oooh0?omn`3oo_l0o_oo0?kmo`<0oooo0P3no_h20?ooo`030?clo03f
m_H0oooo00<0oooo00<0nOWi0?ooo`3oool04`3oool0103lo?`0oooo0?ooo`3jn_X30?ooo`0Y0<71
`@3hn?P0oOgm0:^[Z`1lO7`0Kfm_0;bl_03`l?00o_kn06][J`1eMGD0GemO03<c<`3lo?`0oooo0?_k
n`3Hf=P0DU9B0?Shn03oool0o_oo0?KkoP3[ko00@d=304m9B@3omO@0oo[i09:9Q0030@00O81W0:F]
X00001T0g]om0?koo`3HeL`0oocj08EnP@2b][L0nOoo0?CjnP3kool00P3nool0103Ph>00<Bl`06aZ
J`3jn?T20?ono@040?Wim`3hn?H0o_ok0?Wkn4D0oooo001P0?ooo`@0o_oo0P3oool:0?ono`040?oo
o`3nool0o_oo0?koo`P0oooo0`3oo_l04`3oood0o_oi0?[lm`3mo?l0oogo0?Ofn`3oool03`h:00@3
003lnOl0oogo0?oko@3oo_/0nOC^07A^J`0O61l0m?3j08N9T`1AF6000P3kool0103ko_l0m_[k0?on
o`3jn_X40?ooo@80oooo0P3nool;0?ooo`070?Win@0>3Ph0j^[Z01DE5@3Vi^H0oooo0?KfmP020?oo
o`030?knoP3moOd0oooo00<0oooo01@0l_;b0=CDe02?Shl0:BTY01PH601QHF40/k6b0?omo`3nnOT0
no_k0?Woo`3iood0I6=L05A>B`3onoh0oogo0?Soo`3hood0ooof0?onn080oogo00<0o_go0?ooo`3o
ool00P3oool30?knoP<0oooo00@0m?Cd0?Shn03oool0nOWi4P3oool01@3jn_X0oOgm0?ooo`3oool0
n_[j00<0oooo00<0m_Kf07MgM`27QhL00`3oool03P3jn_X0oooo0<G5a@2<S8`0L71`07AdM01ZJVX0
P8200?gmo@3oool0n?Sh0?knoP3/k>`0410@0P3oool06`3hnOT0h^KU028V9@1aKg00o?Gh0?ofn03o
o?X0Ee180<2n[@3MhL@000<005EFM035aNT0moOm0<G4_@0d;2X03PL:0>__l03`nO/0nOoo0?_oo`3g
no`0d=7C01XH6@2>S8d0ooko0?_inP020?ono@80ooom0P3noo]50?ooo`00H03oool40?koo`80oooo
2P3oo_l0103oool0o_oo0?koo`3nool80?ooo`<0ooko01D0ooom0?oonP3noo/0ooko0?omo`3oo_l0
no_k0040001_KVX0ooco0?ggo`3oo?h0ookk0?okl`3AblP01004061LIP000P/0_lO?0?3go`3ioOl0
0P3lool00`3oo_l0oooo0?ono@030?ono@@0ooom2@3oool04@3hn?P0nOWi0:ZZZP13@d<0n?Sh0?oo
o`3jn_X0no_k0?ooo`3kno/0o?cl0?ooo`3jn_X0oooo0?Ogm`3moOd0no_k0080oooo00h0nOWi0?oo
o`3Ogml0TY:B03ll@P0;2@`0GeeL0:NYY03[lNl0kO?a0;>a/02SWi`0ookg0?oon080o?oo00@0oooj
0?onn@3ooOl0ooko203oool0103no_h0o?cl0?clo03oool20?clo0030?ooo`3moOd0oooo00l0oooo
00@0o_kn0?ooo`3oool0oOgm0P3oool01P3no_h0mOGe0?clo01KFe/0@D510>g]k@80oooo00H0nOWi
0?ooo`3oool0o_kn0?clo03inOT20?ooo`0<0?clo03oool0nOWi0?ooo`3moOd0oooo00h>3P3bl_80
o?cl0<O7a`0E5A<0TY:@0P3oo_l05P3jmOL0ookk06ATF02?T7`0oooT09ZJS@0;1BL0o_Oo0?_go`3o
ooX0ookk0?[jn03kool0n?oo0?CloP3fnoh0]k^l01@E5`2]Zj`0ooko0?klo@3oo_l20?ono@040?oo
n`3fm_80oOoj0?gonTD0oooo001P0?ooo`@0o_oo0P3oool:0?ono`040?ooo`3nool0o_oo0?koo`P0
oooo0`3oo_l02@3oood0o_ok0?cnn`3oo_l0o?[o0?ono`2o_kl00@000?Sgl`020?olo`080?omo`3o
o_/0oocf0??]jP0S7240l^kh0?cno`3eo?l20?_oo`040?coo`3nool0oooo0?gmo@@0ookm0`3oood<
0?ooo`040:BTY03>c/h0oooo0?[jnP80oooo00<0oOgm0?ooo`3no_h00P3oool00`3jn_X0oooo0?[j
nP020?ooo`040?gmo@3oool0oooo0?_kn`80ooko0140iNCW09NGU@1@DTd00PH304]?CP2RX:40k^c[
0?oom@3oooH0ooom0?ooo`3ooo/0ookj0?ono@3oo_l0oooo0?koo`020?ooo`80o_oo0P3oool00`3o
o_l0o_kn0?ooo`040?ooo`030?knoP3oool0oooo00h0oooo00@0o?cl0?ooo`3oool0o_kn103oool0
0`2b/[80D51@0?Cdm0020?ooo`070?[jnP3oool0o_kn0?knoP3oool0oOgm0?ooo`030?knoP0F0?cl
o03oool0oooo07UiN@2HV9P08B4Q0=?Cd`2VYZH04a<C0;Rf]@3oo_d0o_cm0?knoP3oool0o?ch0;fn
]00m?R`0oooU0?gjk`0C2RL0gMGh0?olo`80oOgk00L0o_oo0?[oo`3do?`0nooo09ZMX@0@4A<0b<S8
0080ookm00P0ooko0?[io03oo_l0o_ck0?CdlP3oood0o_oo0?gnoTD0oooo00200?ooo`030?koo@3n
ool0ooko0080ooko00<0oooo0?ono@3oo_d00`3ooOl0303oo?`0oogm0?3ZjP0P6A`0`;[10?cjo`3m
oOl0o_ko0?_ko`3mo_l0ooko0?knoPD0ooom903oool02`3oo_l0o_go0?ooo`3oood0j^_[0:^[Z`1B
D54040h=0450?02DThl0iN?R0080ookm00L0oogl0?ono@3oool0nOgn0?coo`3oo_l0no[m0080o?oo
00P0nOWg0?ono@3oo?`0ookm0?koo@3moo`0o_cm0?ono`80o_oo00<0oooo0?knoP3no_h01@3oool0
0`3jn_X0oooo0?knoP020?ooo`80oOgm00@0o_kn0?clo03oool0oooo0P3moOd0203oool0o?cl0?oo
o`3Jf]X0oooo0?Win@3oool0o?cl0P3oool00`3kno/0oooo0?ooo`060?ooo`0E0?knoP3kno/0m_Kf
03hn?P0L71`0UiNG01hN7P3Cdm<0o_oo0?koo@3jno/0o_kl0?ooo@3kn_H0o_gf061ME02ETXL0oogi
059>F02KUjD0o_go0080o_oo00l0n?_o0?Sln`3lool0LG9f02HW:`3Ogmd0oOcg0?onn03nn_H0ooko
0?[ko`3mnoh0ooko0:j^[02c];@00P3lool00`3nool0oooo0?ooo`120?ooo`00P03oool20?koo`@0
oooo0P3oo_l03`3ooOl0n??e0?omo`3jmOL0oo_n0=gFf@2VWj80a;o30?olo`3mnol0noWo0?ono`3i
n?d0o_kn0?ooo`050?ooo@80oooo0P3oo_lP0?ooo`80o_oo0P3no_h20?ooo`0D0?kln`3knOP0/[2_
05aJF@0I5aH0;R`[08F3PP3OgM`0ookm0?knoP3ioOh0o?oo0?omo`3oo_l0o?oo0??im`3oood0oo_k
0?omo@3oood20?coo@80oogo00<0oooo0?koo`3oool00P3oool0103no_h0oOgm0?gmo@3no_h30?oo
o`030?knoP3kno/0oOgm00D0oooo00D0n_[j0?ooo`3oool0iNGU0?[jnP020?ooo`060?[jnP3oool0
oooo0?knoP3oool0mOGe2@3oool02P3no_h0oooo0?knoP3Shn<03`l?04a<C03]kNd0oOkn0?Sin@3f
n_T20?koo@0M0?_jmP3noOT0ookj0?onnP2?RhP0LVi[01LE5P1BDE@0no[o0?clo`3ko_l0o?oo0??g
mP1BE540?ci30>cZk@3ooo/0n?G^0?onm03oo_L0noko0?cno`3Xi^T0X9^K08V5PP0];Bd0e][U0?Cj
o`3nool0A03oool00800oooo0P3nool40?ooo`<0ooko00X0noWj0?omo`3ooOl0V96D0=WBe@3onoh0
ooco0<g9d`2BT9/0oogo0P3noOl00`3moOd0oooo0?clnP040?ooo@80oooo0P3oo_lP0?ooo`030?kn
oP3oool0oooo00<0oooo0P3ooO`04P3mnoX0ookm0?Oem038a/D0JFUY01DE5@0X:2P0Ng]k0<W=c03n
ool0noWj0?ono`3cmoH0nooo0?clo03knOX0ooko0?gmo@80n_km00@0oocn0?omo`3oool0o_oo103o
ool00`3no_h0oOgm0?ooo`020?ooo`0C0?Win@3oool0oooo0?knoP3lo?`0no_k0?Win@3kno/0oooo
0?_kn`3oool0c/k>07AdM03oool0o_kn0?ooo`3moOd0o?cl0?ooo`020?clo0X0oooo00L0o_kn0?gm
o@3oool0o_kn06e]K@0:2PX0alO70080o_oo0200o?oo0?koo@3lo_/0oook0?gln03oo_/0ooci0?om
nP3ln?D0nOOh00400`3Yj>d0o_ko0?coo`3VjNh0=S`l05YNG@3dl_D0noKh0?onn`3oooH0ooc^0?oo
n03dn_l0n?_o0?omo`1?B400fmC<06ITH`3GgNT0n?oo0?cood@0oooo00200?ooo`80o_oo103oool2
0?ono`0:0?[hn@3oo_l0n_Gg0?ghnP3bjnh0>c@g0?ohn`3mn?`0:bLa0>OUkP80ooko00@0m_Gj0?on
o`3moOd0o?cj103oood20?ooo`80ooko8@3oool00`3no_h0no_k0?clo0020?ooo`060?ono@3ooO`0
ookm0?ono@3no?/0o?cl0P3oool05039bLT0M7Ee02<T900O7al0LVe_0<:m_`3ioO`0nooo0?ooo`3o
o_l0nOOj0?knoP3kool0o?oo0?omo`3oo?l0oooo0?gnoP3moOd0o_kn1@3oool00`3no_h0oooo0?_k
n`020?ooo`0=0?gmo@3no_h0o_kn0?ooo`3moOd0oooo0?_kn`2k^k/05ADE0<g=c@3oool0o?cl0?[j
nP020?ooo`050?gmo@3oool0oooo0?Win@3lo?`02@3oool02`3inOT0oooo0?ooo`2YZJT0?3`l01lO
7`3XjNT0n?Wi0?Gin03nood0l_Ca0080oook01/0oOWf0?onn`3oo_/0oogm0??alP0P8200][Fj0?Kg
n`3PhnP07R4V07IlO03fn_T0ooko0?omo`3onoP0o_Wa0?ook@3oo_L0lOko0?;lo`3ooOd0n^_S08=i
K@2:QX<0_LCB0?Ooo`3lool0A03oool008H0oooo0`3oo_l03`3jn?T0oogo0?omo`3ooOl0Yj:T09ZE
U`2GTYH0[:V`0?omo`3kn_l0m??h0?glo`3oo_l0oOgm0?ooo`040?ooo@80oooo0P3oo_lP0?ooo`03
0?clo03oool0oooo00<0oooo00<0o_kn0?ooo`3fm_H00P3oool05P3ko?h0o_oo0?koo`3in_`0o_oo
0?ooo@3=blX0R8:203@_<@0G6aX0GVAT0;Ff^03em?L0ooko0?gno`3eno/0o?oo0?omo`3mm_T0noWh
0?ooo@3moOd20?knoP060?gmo@3no_h0oooo0?ooo`3kno/0oOgm0P3oool02P3gmoL0o_kn0?ooo`3l
o?`0no_k0?ooo`3moOd0i^KV00l?3`38b<P20?ooo`090?_kn`3oool0no_k0?ooo`3lo?`0oooo0??c
l`25QHD0oOgm00X0oooo02L0n_[j0?ooo`35aLD0<30`07]kN`0f=cL0o?gm0?coo`3lo_/0o_om0?gk
nP3hm_D0ookk0?okn03km_H0oo_k0>7Oh02MWId0_;_00<[;c`0<3a@0WJ2U0?_oo`3lool0n?Oj0?on
o`3no_X0ookd0?ofi`2QV9<000XM0<?Ll03hko00ooW_0?ogk00R71T0GFIe0?;oo`3kool0A03oool0
08H0oooo0`3oo_l0203no?d0oOSj0?omo`3gl_@0oogo02dX:P14@TD0o__o103oo_l00`3noOl0oooo
0?clo0040?ooo@80oooo0P3oo_lS0?ooo`030?knoP3kno/0o?cl00<0oooo00@0o?cl0?koo`3nool0
nocn0P3nool04@3moOd0ookm0?onn`3on_/0oo_k0=KJf@2<TY80@T=7014@5@1EE5T0ZJZ^0?3en03l
ool0oo[l0?olo`3oo_d0no_i00<0oooo00P0o?cl0?gmo@3oool0oooo0?knoP3jn_X0oooo0?knoP80
oooo00d0no_k0?knoP3oool0m_Kf0?ooo`2ZZZX0emOG0?ooo`3inOT0o_kn0?ooo`3no_h0oooo0080
no_k00@0oooo0;>c/`16ATH0o_kn203oool05`3kno/0nOWi0?ooo`3no_h0i^KV01XJ6P3no_h0De=C
069SH`3lool0n?[g0?clnP3jn_P0ookm0?onn`3oo?T0oogm0?ono@3oo_l0oooo0:VXZ`0>3a<0^KVo
00<0o?oo00l0oOco0?ono`3lnoL0ookf0?okk@2j/J`0?55T09fcb03oo?d0oo7V0?ogj`3oo?T0Hfai
0>gjo`3kool0A03oool008P0oooo00<0oogn0?klo@3ln_/00`3oo_l0203XhnD0jNOZ0?kko`3jnOl0
o_go0?ono`3lnoh0nOSk0P3oool20?ooo@@0oooo0P3oo_lP0?ooo`040?gknP3no?/0ookm0?ono@80
oooo00<0o_oo0?_loP3in_`00P3nool05P3in_`0o?go0?gno`3ko?h0oooo0?kjm`3ooOX0oock0?om
o@3lool0m_cl0>obmP3[jo40UiNM0495B@0=5AL0@TQ80:^VZ03]i^T0oocl0?ono@3jn_X30?ooo`03
0?knoP3oool0oooo00<0oooo00T0n?Sh0?ooo`3no_h0no_k0?ooo`3hn?P0oooo0?Shn03fm_H00`3o
ool01@3no_h0n_[j0?_kn`3oool0n_[j0080oooo00<0FUYJ096AT@3oool0203oool02P3moOd0oooo
0?ooo`3lo?`0oooo030`<03clo<0m?Cd02h_;`2:Rh/20?ooo`0M0;fm^`30`;h0moGd0?ono@3gmO@0
ookm0?omoP1oOgl092<V0=;Ce@3loOl0o?oo0?_oo`3gnoX0o?[m0?olo`3ooOd0o?Oa0?ool@3Yj^80
20dN0>oao`3ooOl0oogd0?omlP3in?@0mO_o0?Soo`3lool0A03oool008P0oooo00P0oogn0?ono`3o
o_l0oogn0?klo@3imoP0oogo0?cjo@<0ooko00<0n_Wl0?ono`3oo_l00P3moOd20?ooo@@0oooo0P3o
o_lP0?ooo`@0ookm0P3lo?`30?koo`80o?go0`3nool0503mo_l0o_kn0?onn`3onoP0]Zb[00h8203O
hn80nooo0?coo`3knol0o_ko0?_no`3UkNl0Z:j^04]6BP0D3A00AD1009VGUP3]kNd0n?Sh0P3oool0
3P3no_h0oooo0?ooo`3no_h0no_k0?ooo`3moOd0oooo0?Win@3oool0m?Cd09JFUP3oool0oOgm0P3o
ool00`3kno/0o?cl0?ooo`020?ooo`070?_kn`3oool0oooo0?gmo@0@4100j>SX0?clo00:0?ooo`0<
0?[jnP3kno/0oooo0?ooo`3inOT0oooo0=_Lg00J6a/0^KVi0?clo02RXZ00FUYH0`3oo_d0603elo80
IfMW03De=@3Og^40ooko0?koo`3mo_l0nOgj0?coo@3oo_l0ooWo0?olo03oo_X0nocb0?oonP0W8bd0
b/KD0?cjo@3noOT0oOkh0?koo@3dn?l0nooo0?kood@0oooo002:0?ooo`/0ooko6`3oool00`3jn_X0
oooo0?ooo`030?ooo`80o_kn203oool40?ono@80oooo0`3nool03P3mo_l0n__m0?koo`3kno/0o_kn
0?[jnP3oool0o_gi0?onn`3om_L0HeeM0?3dl`3kool0noko0P3no_l02`3lool0m_ko0?Klo03ooOl0
mo3c0:jYZ@1MFeX04a<C03Ph>029RHT0f][J0080oooo00D0no_k0?ooo`3moOd0oooo0?[jnP020?oo
o`060>o_k`15ADD0SXj>0?clo03oool0n?Sh0P3oool02`3no_h0oooo0?ooo`3hn?P0oooo0?knoP3o
ool0`l?302h^;P3oool0o_kn0100oooo00h0o_oo0<;3``0E5AD0fm_K0;bl_014A4@0o?[i0?ono@3g
mOH0@d5204a<C03hn?P0lO3c0?ono`80o_oo0140oook0?ooo@3lool0o?oo0?koo`3oood0oogm0?om
n`2DT8d0MWAe0?ono`3hn?h0o?oo0?_oo`3lool0oOko0?ono`140?ooo`00RP3oool:0?onoad0oooo
00H0o?cl0?knoP3inOT0nOWi0?ooo`3moOd90?ooo`@0ookm0P3oool20?koo`030?_loP3mo_l0oOko
0080oooo0P3oo_d0603ln_T0ooom0?ono@3ooOd0ViJH0;Nk_03kool0nOco0?koo`3inOl0o?oo0?Wo
o`3kool0oogo0?olo`3oo_d0ooom0?Cdm02m_Kd0JFUY018B4P0a<C40Ng]k0=;BdP@0oooo00@0mOGe
0?_kn`0e=CD0J6QX103oool02`3kno/0oooo0?[jnP3oool0no_k0?ooo`3hn?P0no_k0?ooo`1aLG40
QHF50180oooo0240nO[j0?gnoP2KVi/0:BTY0=WIf@0I6AT0ookm0>3Ng@0Z:2T0L6i_0?clo03no_h0
ooko0?kmo`3hnO/0o_kl0?oonP3ooo/0o?oo0?_oo`3lool0o_oo0?omo`3ooOd0i=O>01T>203alOT0
n?oo0?Goo`3foOl0oooo0?ono@3oo_l0A03oool00;00oooo00<0oOgm0?Ogm`3oool00P3oool00`3l
o?`0oooo0?Win@080?ooo`@0ookm00<0oooo0?koo`3nool00`3nool0:@3oool0moOg0?cjn@3oo_/0
oo_h0?Gdl03loOd0n?Wi0?ojo03Ng=l0Jg5a0?Gmo@3nool0n_Wl0?ono`3mo_l0n?kn0?coo`3onod0
oOKi0?Wgn03lo?`0oooo0?_kn`3lo?`0oooo0<K6aP1bLW80820P01lO7`1eMGD0b/[:0?Shn03oool0
_Kfm07alO03oool0n_[j0?ooo`3fm_H0no_k00<0oooo00<0oOgm0?ooo`3moOd00`3oool00`0H61P0
f][J0?gmo@0D0?ooo`0:06ATI011@D402@T90=cLg00L71`0Shn?0?ooo`3inOT0oooo0?Shn080oooo
00<0oOgk0?oonP3ooo/00P3no_l03@3oo_l0o_oo0?Goo`3lool0on_Q03XM5`3Nh>X0jOco0?3oo`3c
ool0oo_h0?oln@3ooOd0A03oool00;80oooo00D0moOg0?ooo`3oool000000?knoP090?ooo`<0ookm
00<0oooo0?koo`3nool00P3nool04P3loOl0moOg0?ooo`3oo_d0o?Se0?omnP2JU940510=0<c@d@3j
ool0ooko0?cko`1DFUX0lo_k0?koo`3ooOh0o?[k0?knoP80o?oo0P3ooOl00`3oool0o_oo0?ooo`02
0?ooo`0<0?KfmP3jn_X0oooo0?Win@3AdM40N7Qh02XZ:P0K6a/0KFe]0:2PX03oool0n_[j103oool0
3@3hn?P0no_k0?_kn`3oool0oOgm0?ooo`2?Shl0IVIV0=CDe00L71`0oOgm0?knoP3kno/0403oool0
303moOd0n_[j0?_kn`3oool0A4A400P8201HF5P0[Jf]0?knoP3jn_X0oooo0?knoP80oooo00@0n_[j
0?ooo@3oooP0oook0P3no_l03@3oo_l0o_oo0?Coo`3lool0oo7W03<D3`2OXJ/0k_oo0?3oo`3dool0
o?Se0?omn03ooOd0A03oool00900oooo103ooodL0?ooo`070?Shn03oool0o_kn0?ooo`3hn?P00000
0?knoP090?ooo`80ookm0P3oool40?koo`0?0?knoP3oool0n_Sg0?oln@3ooOX0oocg0;F/Y@19AD40
/KJi0?Ooo`3gn_l0d];H01LO8@36c<`0no_k0080oogm02@0ookm0?coo@3ho?/0oOSj0?oloP3nool0
n_ko0?cmo@3kno/0oooo0?knoP3kno/0n?Sh0?ooo`3no_h0oooo0<g=c@3Jf]X0S8b<03Lg=`0;2`/0
HF5Q0;6a/@3^k^h0oooo0?_kn`3oool0oOgm0?clo03oool0o_kn0?KfmP2d];@0De=C08F5Q@1_KflE
0?ooo`060?clo03oool0lO7a00/;2`1VIVH0oOgm0P3oool02P3hn?P0o?cl0?clo03no_h0ooom0?Sh
m03oooX0oook0?kno`3lool20?koo`0;0?coo`3oo_l0jmO>0;NSWP2[[KL0lOgo0?Coo`3hool0oook
0?ggm03oo_d0A03oool00900oooo103ooodP0?ooo`030?[jnP071`L0oOgm00T0oooo0P3oo_d20?oo
o`@0o_oo01/0o_kn0?ono@3oo_/0ooci0?gel03ooOH0mncT014;203]m?P0m_oo0?_oo`3ko_l0mooo
0?Cjn03no_`0ookk0?omn`3ooOX0o?kk0?koo@3ooOl0ooko0?coo`3jo_l0o?gm0?ooo`3emOD0103o
ool03@3moOd0YjNW05=CD`3kno/0oooo0?_kn`3Shn<0WYjN03hn?P0?3`l0F5QH09nOW`3Zj^X00`3o
ool00`3lo?`0oooo0<_;b`0202l_;`040<71`@3inOT0oOgm0?gmoA00oooo00T0nOWi0?clo03no_h0
o_kn0?clo01?Cdl01PH60<[:bP3jn_X00P3oool02P3no_h0oooo0?clo03oood0oook0?oonP3ooo/0
o_ko0?coo`3nool20?ono`0:0?olo`3onoH0oo_j0?kno`3hool0l__n0?Woo`3lo?X0oook0?onod@0
oooo002<0?ooo`@0o_oo103ooodL0?ooo`80o_kn00H0n?Sh0?ooo`3oool000000?ooo`3lo?`80?oo
o`80ookm0P3oool40?koo`0?0?ooo`3mnoX0oo_h0?omnP3ooOH0oo_c0?ojlP0/9R<0_LO<0?Coo`3d
n_l0nooo0?;ko@3iool0ookm0080oogk00D0ookj0?kon`3nood0oo_m0?[hn@020?_oo`0<0?cmo@3o
ool0oooo0>o_k`3oool0o_kn0?clo02>SXh06ATI0>_[j`3oool0m_Kf0P3oool04@3moOd0oooo0>WY
j@2PX:00E5AD00@4101<C4`0TI6A0>7Qh@3oool0o_kn0?7al@071`L04A4A0?_kn`3oool0no_k0140
oooo0P3oo_l02P3oool0l?3`0?ono`24PhH0F5UK01LH6P3XjNT0oOkn0?KfmP3oool20?ooo@050?_i
n03lo?P0oooj0?ooo@3nool00`3oo_l02P3oool0ooko0?oko@3onOd0o?_o0?_oo`3dn_X0n?kj0?ko
o`3jn_Y50?ooo`00S03oool40?koo`@0ooom703oool01`3no_h0oooo0?knoP3oool0o?cl00D51@3l
o?`02@3oool20?ooo@80oooo103nool0503no_h0ookm0?onn`3nnO<0ookf0?oil03ooO<0U92<07Am
PP3cool0nOoo0?Wmo`3iool0nooo0?ono@3oo_/0oogk0?onn`3no_X0oOol0P3oo_l0103lool0nOgn
0?koo`3emOD20?ooo`060?_kn`3moOd0h^;R02LW9`3UiND0no_k0P3oool00`3jn_X0oooo0?knoP02
0?ooo`0;0?clo03oool0lo?c0:ZZZP1NGUh03@d=03`l?02=SHd0i>CT00h>3P1ADE400P3no_h00`3o
ool0o?cl0?ooo`0?0?ooo`0:0?ono`3gmOH0oooo0?ooo`3jnO`0VIRK05aMG`2c];H0LG9b0?cmo@80
oooo00H0oOgk0?ooo@3oo_d0ooom0?oon`3nood40?ono`060?ooo@3oo_l0ooco0?ojo`3oo_l0nOgn
0P3lood00`3jno/0o_oo0?ooo`140?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@4100X0oooo
00@0ooom0?koo@3nool0o_oo1@3oo_l04@3ooO`0oo_h0?oon03ooOD0ookd0?oikP3MfMD03`lG0?Sj
o`3kn_l0o_ko0?gmo`3nool0n_[j0?ono@3ooO`0ookm0080ooom00@0oooo0=;BdP2WZ:X0o_oo0P3o
ool01P3lo?`0oooo0?ooo`3kno/0clo?0>k^kPT0oooo00d0o?cl0?ooo`3oool0no_k0?ooo`3alO40
^KVi06ATI00k>c/03@d=08^;R`3moOd0o_kn01D0oooo00D0no_k0?ooo`2n_[h0A4A40?clo0080?oo
o`040?ooo@3oool0ooko0?ono`@0oooo0`3oo_l30?koodL0oooo002a0?ooo`050?knoP3oool0oooo
0?knoP010@402P3oool20?koo@80o_oo1@3oo_l02@3oo_d0ookk0?onnP3lnO00oogb0?onm03jm_80
8QlV0=gKj0020?omo`040?glo`3oo_l0ooko0?knoP80ooom00H0moOe0?clnP3oool0k>c/01@C5P3i
n?/20?ooo`030?_kn`3gmoL0o?cl0080oooo00<0oOgm0?ooo`3oool01`3oool0103jn_X0oooo0?oo
o`3jn_X20?ooo`090?_kn`3moOd0moOg00410@2QXJ40oooo0?gmo@3oool0o?cl0100oooo00L0o_kn
0?gmo@3oool0oooo0?knoP3kno/0eMGE05h0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40
2P3oool20?koo@80o_oo103oo_l04P3ooOh0ookm0?onn`3oo_X0ooce0?oomP3ooo@0lno[01lL8`2O
WJX0o_co0?omo`3mo?l0o_go0?ono`3oool0ooom0?clnP80ooom00P0oooo0?_kn`0^;C00`;o20?[j
nP3inOT0kno_05mOG`80oooo00<0moOg0?ooo`3oool0203oool01@3lo?`0o_kn0?ooo`3kno/0nOWi
00<0oooo00L0YJFU024Q8@2:RXX0o?cl0?ooo`3hn?P0o_kn0100oooo00D0o_kn0?ooo`3oool0o_kn
0?clo0020?ooo`030?clo03oool0oooo05/0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40
2P3oool20?koo@80o_oo1@3oo_l03`3no?d0oOSh0?onn`3oo_X0oooh0?gjl@3Ui=l0XYnV0<;0b`3l
n_l0oOco0?ono`3noOl0o_kn0?gmo@020?[jn00>0?ooo@3jn_P0n_[j0?ooo`1lNgh0NGQk0?ooo`3H
f=P0:2PX09jNWP3oool0o_kn0?ooo`3lo?`80?ooo`040?gmo@3oool0o_kn0?knoP<0oooo00P0n_[j
0?_kn`1PH600EEEE06UYJ@3oool0nOWi0?_kna40oooo00L0oOgm0?ooo`3oool0o?cl0?ooo`3jn_X0
nOWi05h0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@402P3oool30?koo@030?koo`3oo_l0
ooko00@0ooko00P0oogn0?ono@3ooOX0ooch0?onnP3jnOD0oogo0?glo`<0ooko00<0oOgm0?knoP3o
ood0103oood02@3oool0no[m0<?2a@0d<cH0kNg]01`L702IVIT0o_kn0?_kn`0;0?ooo`040?[jnP3o
ool0oooo0?clo0@0oooo00H0o?cl01<C4`2EUID0DU9B0?ooo`3kno/C0?ooo`030?knoP3oool0oooo
00<0oooo00<0o_kn0?ooo`3oool0F`3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn00410@0:0?oo
o`@0o_om00D0oooo0?ono`3oo_l0ooko0?gkoP030?ono`0;0?omo@3onoP0ookk0?ono@3gm_T0ooko
0?cko`3oo_l0oooo0?knoP3no_`00P3oood0103emO<0ooom0?ooo`3lnoh20?ono`0300/:3@25QHD0
^[Zj00<0oooo00<0n_[j0?knoP3kno/02`3oool02P3moOd0o_kn0?_kn`3jn_X0o_kn0<G5a@1:BTX0
iNGU075aL@3dm?@20?ooo`030?clo03oool0oooo00h0oooo00D0o_kn0?ooo`3jn_X0oooo0?_kn`02
0?ooo`030?Win@3oool0oooo05/0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@402P3oool4
0?koo@80oooo0P3oo_l00`3mo?l0ooko0?cjo@020?ono`060?kln`3ooO`0oO_l0?ooo`3oo_l0n_Wl
0P3oool20?ooo@060?_kn@3no_`0ooom0?ooo`3lo?`0moKi0P3oo_l0201CDUD06ATI0::RXP3kno/0
oooo0?knoP3oool0o_kn2P3oool20?_kn`D0oooo00<0IVIV08R8R03no_h00`3oool00`3gmoL0oooo
0?ooo`0?0?ooo`030?[jnP3oool0nOWi0080oooo00<0no_k0?ooo`3oool0G@3oool00;40oooo00D0
o_kn0?ooo`3oool0o_kn00410@0:0?ooo`@0o_om0P3oool40?ono`0;0?klo`3oo_l0ooko0?gko03o
oOh0ooko0?clo03oool0oOgm0?ooo`3no_`00P3lo?X30?ooo@090?knoP3oool0ooko09fLW`3noOl0
V9NJ04a<C00H61P0YjNW0080oooo00<0no_k0?ooo`3kno/0203oool01@3no_h0oOgm0?ooo`3no_h0
no_k0080oOgm00D0nOWi00l?3`3WinL0oooo0?knoP020?ooo`030?knoP3oool0oooo0100oooo00@0
nOWi0?ooo`3oool0oOgm0P3oool00`3lo?`0oooo0?ooo`1K0?ooo`00/@3oool01@3no_h0oooo0?oo
o`3no_h00@4100X0oooo0P3nood20?ooo@80oooo2@3oo_l20?ooo`L0ooom01L0o_kl0?ooo@3oool0
mOGe079aM01CDUD0ooko0=oNh@0G5aL0e]KF01LG5`2IVIT0oooo0?knoP3jn_X0oooo0?[jnP3oool0
o_kn0?ooo`3jn_X0oooo0?[jnP020?ooo`040?[jnP3oool0oooo0?Gem@80oooo00@0[Jf]0451@@3o
ool0oOgm0`3oool00`3hn?P0oooo0?ooo`1d0?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@41
00X0oooo0P3nood20?ooo@80oooo2@3oo_l20?ooo`P0ooom00l0nOWg0?knoP1PH600?3/n0>o^l@3n
oOl0ooko02DU9@37alL0iNGU01dM7@2GUiL0no_k0?ooo`3inOT00P3oool01P3moOd0o?cl0?ooo`3n
o_h0oooo0?clo0<0oooo00P0o?cl0?ooo`3moOd0o?cl09RHV02m_Kd0oooo0?Win@80o_kn0P3oool0
0`3lo?`0oooo0?ooo`1c0?ooo`00/@3oool01@3no_h0oooo0?ooo`3no_h00@4101@0oooo1@3oo_l2
0?ooo`D0ooom103oool00`3Lg=`0C4a<0?Win@020?ooo`0?0?clo02RXZ80/;2`0?clo03Ph>0092@T
06MWI`3fm_H0oooo0?clo03moOd0oooo0?Ogm`3hn?P0o?cl0080oooo00<0o?cl0?ooo`3gmoL00P3o
ool00`3no_h0nOWi0?ooo`020?ooo`060?gmo@3no_h0oooo0?gmo@3oool0oOgmM@3oool00;40oooo
00D0o_kn0?ooo`3oool0o_kn00410@0E0?ooo`@0ooko0P3oool40?ooo@<0oooo00L0oOgm0?_kn`3n
o_h0o?cl0?ooo`3hn?P0n_[j0080oooo00X0oOgm0?[jnP3oool0jn_[06ATI00O7al0d=3@0?ooo`3l
o?`0no_k0`3oool00`3hn?P0oooo0?ooo`020?ooo`0<0?clo03kno/0oooo0?ooo`3hn?P0o?cl0?kn
oP3oool0oOgm0?ooo`3kno/0o?clMP3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn00410@0@0?oo
o`D0o_om1@3nool50?ooo`<0ooko00D0o_go0?ono`3oool0oooo0?Ogm`020?ooo`050?_kn`3lo?`0
o_kn0?ooo`3lo?`00P3oool01@2SXj<061PH09BDU03hn?P0oooo0080o?cl00@0no_k0?ooo`3oool0
o?cl0P3moOd20?ooo`070?Shn03no_h0oooo0?[jnP3oool0o?cl0?gmo@020?ooo`030?knoP3oool0
oooo07@0oooo002a0?ooo`050?knoP3oool0oooo0?knoP010@40403oool60?koo@@0o_oo103oool5
0?ono`040?Ofn@3oool0nOWi0?knoP@0oooo00X0nOWi0?[jnP3oool0o?cl0?gmo@3no_h0f=SH034a
<@1LG5`0g=cL0`3oool02P3gmoL0oOgm0?gmo@3oool0XZ:R0<k>cP3oool0kno_06UYJ@3hn?P20?oo
o`060?Shn03oool0o?cl0?knoP3oool0oOgmM@3oool00;40oooo00D0o_kn0?ooo`3oool0o_kn0041
0@0:0?ooo`80ooko103oool90?koo@030?koo`3oool0ooko00P0ooko00@0o?cl0?ooo`3oool0oooo
0P3oood05`3oool0n_[j0?ooo`3jn_X0o?cl0?ooo`3moOd0oooo0?knoP1dM7@04a<C06a/K03Zj^X0
oOgm0?ooo`3lo?`0oooo0?clo02n_[h0:b/[0?gmo@29RHT0IVIV0080oooo00L0no_k0?gmo@3oool0
no_k0?clo03oool0oOgm07D0oooo002P0?ooo`80ooko00L0oooo0?koo@3nood0o_om0?ono`3ooOl0
ooko0080oooo0P3nood01@3oood0ooko0?ono`3oool0o_kn0080oooo00<0o_kn00410@3oool02@3o
ool20?ono`@0oooo2@3nood00`3nool0ooko0?ono`020?ono`@0oooo01l0oOco0?kmo`3oo_l0o?cl
0?glo`3oool0n_[j0?ooo`3lo?`0oooo0?Whn`3oool0o?ch0?gnn03ooo/0nOWi0?cmo`3nool0j>KY
075_LP0B4aD0P8610?Gem@3no_`0n_[j0?ooo`3kno/0:BTY0<71`@0b<S80_kno00<0o_kn00D0oooo
0?_kn`3oool0oooo0?gmo@1f0?ooo`00W`3oool04`3oo_l0oogo0?omo`3nool0o?ok0?_on03loo/0
ooco0?oko`3lnOl0oooo0?Sjm`3io_P0o?oh0?konP3oo?l0oo_o0?ono`3no_h00P3oool00`3no_h0
0@410?ooo`0I0?ooo`80oogo0P3oo_l07@3oood0oook0?kon`3nood0o_oo0?Wjo03ko?h0o_oo0?_l
o`3nool0o?_n0?knoP3no?d0ooko0?_ko`3nool0o_ka0?gnk03oooH0o_om0?Wmo`3lo_l0ooco0?oi
o`3HgN40DEUI01XJ602=S8P0iNGS0080oooo00@0UYJF03dm?@0P8200nOWiOP3oool009l0oooo01<0
ooko0?omo`3ooOl0o_oo0?_on`3iooP0nook0?olo`3onol0ooco0?ooo`3nood0o?ok0?_om`3dm_00
ooco0?oko`3oo_l0o_kn0080oooo00<0o_kn00410@3oool0603oool02@3oo_l0oogo0?omo`3oo_l0
ookm0?oon`3oooX0o_oj0?kon`040?koo`0L0?Oho03oo_l0ooko0?ono`3ooOd0nOOh0?_no`3lool0
nOW]0>_/fP0;3080@DE202T`>03alol0o_So0?olo`3kool0nOoo0<g=c@1PGUd03`l?04Y:BP2TY:@0
kno_010@403?cll0oooo0?gmoGd0oooo002P0?ooo`80ooko0100o_oo0?coo`3kood0o?om0?ono`3o
oOl0ookm0?Wim`3gn?P0o?oo0?coo@3nood0ooko0?oko@3oo_l0o_kn0P3oool00`3no_h00@410?oo
o`0H0?ooo`050?ono`3ooOl0oogo0?ono`3oood00P3ooo/08P3noo/0o_om0?gnoP3nool0oOco0?on
o`3mo?l0ooko0?ono@3lnoL0lNgY09bJV@2KWZD0YJR_0?ono`3oooX0gnCM09nUX@3Xj_@0o?co0?ck
oP3oood0nOgl0?coo`3oo_l0oOco0?[io02MWId0C4a<00l?3`0h>3P0LG5a0?ooo`3lo?am0?ooo`00
X03oool00`3oo_l0oooo0?koo`020?coo`030?koo`3oo_l0oogo0080ookm0P3nool01P3ho?T0o_om
0?ono`3oo_l0oooo0?knoP80oooo00<0o_kn00410@3oool06@3oool20?ono`050?ooo`3oood0ooom
0?oon`3nood00`3nool05@3kn_d0ooko0?ono`3ooO`0ookj0?oon`3ooOd0hn7R010A5@3EeM/0oogo
0?glo`3gnoP0f]kM08j>UP3inOl0o_oo0?_mnP3gn?X0o_oo0?Sio@020?ono`060?gmo@3oool0h^;R
096AT@0D51@0k^k^OP3oool00:00oooo00l0oogo0?ono`3noo/0o?oj0?con`3nood0ooko0?omo`3l
m_d0ooko0?gonP3hoOH0o_oj0?kon`3mnoh00P3oo_l01@3no_h0oooo0?ooo`3no_h00@4101d0oooo
0`3oood20?ooo`@0ooko01D0oocl0?chm@3oooP0oogm0?_go`3nn_l0L6aY0:2OV`3moOl0o?oo0?on
o`3oool0a<O<09FHW@3mo_h0o_oo0?_ko`3no_l0o_om0?kon`3emO<00P3oool0103^k^h0m_Kf055A
D@2FUYIn0?ooo`00W`3oool30?ono`0@0?oon03oooH0oooh0?oon`3nool0o_ko0?omo`3oo_l0oooj
0?oom03oooH0oook0?Sio@3no_l0ooko0?knoP80oooo00<0o_kn00410@3oool06`3oool40?ooo@03
0?ooo`3oo_l0o_go0080ooko01`0oO_l0?omnP3oo_X0ooge0=[Ee@0000h09R4a08f5PP1VHE/0mOco
0?Woo`3[i^P0noKf0>O/l00k@TP0moSl0?Ofn`3mnol0o_ko0?gon@3ko_D0ooom0?knoP3kno/05ADE
0>KViP30`<009bLWOP3oool009l0oooo01<0o_oo0?Woo`3lool0ooof0?oml`3onoH0oocj0?_oo`3g
ool0nOoo0?ShoP3oooP0oogb0?kcj`3ooO/0nooo0?Soo`3lool0o_kn0080oooo00<0o_kn00410@3o
ool06@3oool40?ooo@80oooo0P3oo_l0803ooOl0ooco0?ojoP3nnO/0oogk0?onn03on>h0^kNd00T8
603onol0:Q/N01P@3P3Rk_P0mOoo0?omnP1XGU`0004908VBW`3ooOl0ooco0?kno`3jo_l0o_oj0?oo
n03oood0no_k0;Fe]@0i>CT0oOgm0?Shn00k>c/0/K6aO@3oool009l0oooo01<0o_oo0?Woo`3kool0
ookh0?olm03onOH0oo_j0?Woo`3eool0mOco0?koo`3mn_<0T8Mn01`>2`0e;B/0Xj^]0?Ooo`3lool0
o_kn0080oooo00<0o_kn00410@3oool06@3oool40?ooo@80oooo0P3oo_l0703ooOl0o__o0?olo`3o
oOl0oogj0?omm@3oo_<0cLW5010?7`3jmOl0n^[[00L00037en@0k_ko0?ogn@3onoX0kOOn0?;oo`3k
n?h0ooco0?Oho03ho?d0o_ok0?kon@3oood0o_kn05IFEP2LW9`20?ooo`030<c<c02UYJD0oooo07`0
oooo002P0?ooo`0B0?koo`3jo?T0o_gi0?omnP3onOX0oock0?Wmo03iool0ooko0?omo`3oo_d0nOSd
0:jUYP3LeMP0iN_[0?Woo`3nool0o_kn0P3oool00`3no_h00@410?ooo`0I0?ooo`@0ooom0P3oool2
0?ono`80oogo01h0oo_o0?omo`3ooOX0ookf0?oikP3hm?004A0N0=KBh03ono@0TXV407^:W`3^o?l0
ooSo0?oio`3gool0m?om0?oon03ooOX0o_ko0?cno`3nool0oook0?gmn`3jn_X0Fe]K0?Cdm03no_h0
o?cl0?ooo`3moOem0?ooo`00X03oool04P3mnoX0ookm0?koo@3oo_d0ooWh0?ohmP3nool0o?gm0?ol
o@3on_/0n__k0?coo`3gmOH0Shf>0>7UiP3fn_/0o_oo0?knoP80oooo00<0o_kn00410@3oool06@3o
ool40?ooo@80oooo0P3oo_l07`3ooOl0ooco0?oko`3oo?h0oogk0?onn03ooO<0oo_g0;Bd_P0F4Q`0
ooC/0;J^[00Q:d80mOko0?ogo`3onol0n?oo0?OonP3ooo@0oooh0?kno`3lool0o_oo0?ooo@3oool0
o_kn0?ooo`3inOT0oooo0?gmo@3emOD0OP3oool009l0oooo01<0ooko0?okoP3ooOl0n_km0?cnn@3o
o_P0oogj0?kmo`3oo?l0o^od0?oko@3ioOh0m_oo0?koo@3hn?H0KVmc0?3am@3oo_l0o_kn0080oooo
00<0o_kn00410@3oool06`3oool40?ooo@0G0?ooo`3oo_l0ooko0?kmo`3ooOl0oogn0?onn`3oo_X0
ookf0?onnP3oo_l0/Jjd06QOH01YHVT0=ca@0>S]o`3onol0oOSh0?_oo`3iool0o_oh0?oon03oood0
0`3nool00`3inOT0oooo0?ooo`220?ooo`00W`3oool04`3oo_l0oogo0?_io03loOd0oook0?ojk`1B
BD@0_ko90?[go`2STi/040@60>KYk@3fo_h0gn3J0?oon`1jOH80][W00?koo`3no_h00P3oool00`3n
o_h00@410?ooo`0L0?ooo`<0ooom0P3oool40?ono`040?olo03oo_/0oooh0?onnP80ooko00H0o_Wm
0?omo`3noOl0n_co0?ooo@3ooo/20?coo`030?kon`3nooX0o_om00<0o_oo00L0oooo0?gmo@3hn?P0
o_kn0?_kn`3moOd0o_kn07h0oooo002O0?ooo`0C0?ono`3nool0o_oo0?ono`3ooOP0ooOY0;>TW@17
BUT0n?ko0:VRZ@1<@D<0_[g20?_jo@3:`KX0=S4[00063P3TkOP0o?oo0?knoP020?ooo`030?knoP01
0@40oooo01T0oooo0P3oo_l01@3oool0ooom0?ooo@3ooo/0o_om00<0o_oo0`3oo_l01@3ooO`0ookj
0?oon`3ooOl0noWl0080o_oo00@0l_3a0?ooo`3loo/0n_kk0P3nool20?koo@<0o_oo00<0ooom0?oo
o`3oool00P3oool00`3jn_X0oOgm0?knoP1n0?ooo`00W`3oool04`3oo_l0moKk0?ono`3oo_l0oOOd
0?okk@3[g=D0000B0=CHk`3VgN005`d<0?cjo`3inOl0ooge0?Sck@3bnOl0n?oo0?coo`3no_h00P3o
ool00`3no_h00@410?ooo`0H0?ooo`050?ono`3ooOl0oogo0?ono`3oood00P3ooo/0103noo/0o_om
0?gnoP3nool40?ono`0<0?ono@3ooo/0ookj0?kmn@3fn_/0nOgn0?oon`3oooX0o?ok0?[oo03lool0
o_oo0P3ooo/20?coo`80oooo00D0n_[j0?ooo`3alO40oooo0?_kn`020?ooo`030?[jnP3oool0oooo
07/0oooo002O0?ooo`030?omo`3onod0noCg0080nooo00h0oooa0?ohl@0K5RX06a4Y0?obm00]6aT0
cmGP0?Coo`3koo/0oooj0?gko`3no?l0ooko0?knoP80oooo00<0o_kn00410@3oool0603oool02`3o
o_l0oogo0?omo`3oo_l0ookm0?oon`3oooX0o_oj0?kon`3mo_h0oOko00<0o_oo0P3oo_l05@3oooX0
ook_0?oom03hnol0n?[o0?ono`3in?@0o_kl0?coo`3iool0o?om0?oomP3ooo@0nooj0?Woo`3ooOl0
ooco0?ono`3jn_X0oooo0?knoP020?ooo`030?Win@3oool0oooo07`0oooo002O0?ooo`0?0?omo@3o
no/0oo[k0?_oo`3iool0n_[]0?onmP1gKh80BSaA0::=RP0]7QT0]Kg80?7oo`3hool0nO_f0080ooco
00H0ooko0?knoP3oool0oooo0?knoP010@4I0?ooo`050?ono`3ooOl0oogo0?ono`3oo_d00P3ooo/2
0?kon`030?koo@3nool0o_oo00<0o_oo00@0ooko0?oon`3ooo40no_^0P3no_l03`3knOX0oook0?oo
o@3jno/0nooo0?coo@3oooH0oood0?_onP3iool0oogo0?olo`3lnol0o_kn0?ooo`020?clo0030?oo
o`3kno/0oooo07d0oooo002O0?ooo`0B0?ono@3ooOX0oo_k0?ono`3mo?l0ookb0=?>a01NFVP0UHjM
0<Fm^0040@00`lWE0?Soo`3enoT0nogh0?ono`3kn_l0oOco0P3oool0103kno/0oooo0000003lo?`2
0?ooo`040?clo03no_h0o_kn0?ooo`80oOgm4@3oool20?ono`80oooo103oood40?ooo`060?ono`3o
ool0oooo0?ooo@3oooX0oook0P3oo_l0103oool0ooom0?ooo`3oool20?koo`80oook00<0o_om0?ko
o`3oo_l00P3oo_n40?ooo`00W`3oool04@3oood0no[f0?ono@3noOl0ooko0?oll@3lmnl0oogo0?Ge
o`3oooX0oook0?_no`3amol0o_oo0?oon`3gn?P0o_oo0080oooo00L0m_Kf0?ooo`3oool000000?oo
o`3inOT0moOg0080oooo00D0nOWi0?_kn`3oool0oooo0?gmo@2e0?ooo`00W`3oool05`3oood0oook
0?ooo@3gn?X0oO_l0?ommP3ooOP0oOgo0?cno`3oo_/0o_ck0?Woo`3eoOl0o_oo0?Sgl`3oool0o_oo
0?gmo@3oool0o_kn0?ooo`3clo<0000000<0oooo00<0m?Cd0?ooo`3oool00`3oool00`3moOd0oooo
0?ooo`2c0?ooo`00X03oool0703no?/0ooom0?koo`3oo_d0oocg0:2HU@35aL/0nOco0?kin`3?cLh0
R8nG0?Soo`3mo_l0ookm0?ooo`3loOl0oooo0?Win@3oool0no_k0?ooo`020P80o?cl0?gmo@3fm_H0
oooo0?KfmP3oool30?clo;H0oooo002Q0?ooo`0K0?[jnP3oool0ookm0?ojn03`j^P0=3<f0?koo`3o
oOl0:2L/0>kbn@3foOl0noco0?Shn03oool0oOgm0?ooo`38b<P0oooo0?Win@3moOd000000?ooo`3l
o?`0nOWi0=cLg03oool0no_k00<0oooo00<0nOWi0?ooo`3oool0/`3oool00:80oooo00X0o_Wi0?om
o@3ooOd0oogm0:bWZ@2GUIP0TiBH0:BW[03lool0noko0P3lool01@3moOd0oooo0?Win@000000B4Q8
0080o_kn00T01@D50?ooo`3`l?00410@06UYJ@3lo?`0oooo0?gmo@3jn_X0]`3oool00:00oooo01d0
o_oo0?ooo`3ooO/0o?Kd0?Kgm`3moOd0oock02hU9P0nADT0m_oo0?ono`3nnol0nOko0?_oo`3oool0
noWh0?ooo`2EUID010@405ADE03no_h000000=OGe`0D51@000000>WYj@3jn_X0oooo0?_kn`020?oo
o`030?gmo@3oool0oooo0;<0oooo002O0?ooo`0P0?koo`3kool0oooo0?ogm@3ooO/0o?oo0?koo`3o
m_D0l^SW0>?/l@3gool0ooko0?oko`3kool0mOgo0?_kn@3oo_/0ookm0?clo00B4Q80000003@d=006
1PH03@d=00H61P1`L700oOgm0?ooo`3kno/0oooo0?gmo@3no_jf0?ooo`00W`3oool00`3nool0o?oo
0?koo`020?omn`0B0?coo`3nool0oo_j0?oln`3hool0mooo0?ono`3ooOl0nooo0?Woo`3oo_d0ookk
0?_in03oool0Vi^K00P8200B4Q8000000P030`<0103`l?00nOWi0?ooo`3oool20?gmoKL0oooo002O
0?ooo`0E0?koo`3lool0o_oo0?omn`3oo_/0o_oo0?ono`3oo?X0oogk0?Woo`3hool0oooo0?ono@3l
ool0nooo0?ono@3oo_/0ookm0?Win@3_knl00`<30080000000@01PH603Xj>P3jn_X0o_kn0P3oool0
0`3no_h0oooo0?ooo`2f0?ooo`00X03oool20?koo`80oook0100oogo0?ono`3oo_X0oook0?kno`3l
o_l0o_oo0?koo@3nool0ooko0?ono@3ooo/0ooom0?clo03oool0@d=30P0000000`092@T0Xj>S0?oo
o`020?ooo`050?knoP3oool0oooo0?ooo`3no_h0]@3oool00:00oooo0P3nool02P3nood0ooom0?ol
o`3ooOl0oooj0?kon`3oo?l0oogo0?coo`3kool20?ono`80oook00X0n_[h0?ooo`3emOD0X:2P00h>
3P010@4020P80??cl`3oool0o_kn0P3moOfi0?ooo`00X03oool20?koo`060?coo@3oood0ooco0?ol
o`3noo/0o?om0P3oo?l0103kool0nOoo0?ono`3ooOl20?oon`080?ooo@3oool0oooo0=GEe@0:2PX0
0`<301TI6@3oool20?gmo@030?knoP3oool0oooo0;P0oooo002P0?ooo`040?koo`3lool0o?oo0?oo
o`80ooco0180o_om0?coo`3oo?l0oogo0?_oo`3iool0ooko0?omo`3oo_/0oook0?ooo@3kno/0oooo
0?Ogm`0:2PX0000005QHF03moOd20?knoP<0oooo00<0o_kn0?gmo@3oool0]@3oool00:00oooo00@0
o_oo0?coo`3lool0oooo0P3ooOl0103oool0o_oo0?omo`3oo_l20?coo`0;0?ono`3ooOl0ookk0?oo
n`3no_`0oooo0?Shn03oool0<S8b0000002NWYh01P3oool20?gmoKH0oooo002P0?ooo`<0o_oo00<0
oooo0?ono`3oo_l00P3oool20?ono`80o_oo00D0oooo0?ono`3oo_d0ookm0?gmo@020?ooo`060?[j
nP1QHF400@410;fm_@3no_h0oooo0P3moOd20?ooo`80o_kn]P3oool00:X0oooo00<0ooko0?ooo`3o
ool0103oool01P3lo?`0o_kn0?clo02=SHd00P820=[Jf[h0oooo002`0?ooo`080?[jnP3oool0oooo
0?ooo`2VYZH000000?ooo`3no_jm0?ooo`00/P3oool0103fm_H0nOWi0=3@d000002o0?ooo`00/03o
ool01@3jn_X0oooo0?ooo`3oool0no_k0<00oooo002b0?ooo`060?knoP3fm_H0oooo0?gmo@3kno/0
oOgm_@3oool00;40oooo00D0no_k0?ooo`3oool0oooo0?clo02o0?ooo`00/@3oool01P3fm_H0oooo
0?ooo`3gmoL0oooo0?Kfm[h0oooo002`0?ooo`040?gmo@3oool0o_kn0?Win@80oooo00<0o?cl0?oo
o`3oool0_03oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool0
0?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00?l0ooooMP3oool00001\
\>"]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(q1[t_] = q1final[t]; \)\), 
    \(\(q2[t_] = q2final[t]; \)\), 
    \(\(q3[t_] = q3final[t]; \)\), 
    \(\(q4[t_] = q4final[t]; \)\), 
    \(\(x[t_] = xfinal[t]; \)\), 
    \(\(y[t_] = yfinal[t]; \)\), 
    \(tg =. \), 
    \(\(thick = \(l1 + l2\)\/10; \)\), 
    \(\(xa0 = transform[\((H\ n[2] + l2\ b[1] + l3\ a[1])\).n[1]]; \)\), 
    \(\(ya0 = transform[\((H\ n[2] + l2\ b[1] + l3\ a[1])\).n[2]]; \)\), 
    \(\(xb0 = transform[\((H\ n[2] + l2\ b[1])\).n[1]]; \)\), 
    \(\(yb0 = transform[\((H\ n[2] + l2\ b[1])\).n[2]]; \)\), 
    \(\(xc0 = transform[\((H\ n[2] - l1\ b[1])\).n[1]]; \)\), 
    \(\(yc0 = transform[\((H\ n[2] - l1\ b[1])\).n[2]]; \)\), 
    \(\(xd0 = transform[\((H\ n[2] - l1\ b[1] - l4\ c[2])\).n[1]]; \)\), 
    \(\(yd0 = transform[\((H\ n[2] - l1\ b[1] - l4\ c[2])\).n[2]]; \)\), 
    \(\(xbl0 = transform[\((H\ n[2] + l2\ b[1] - 1\/2\ thick\ b[2])\).n[1]]; 
    \)\), 
    \(\(ybl0 = transform[\((H\ n[2] + l2\ b[1] - 1\/2\ thick\ b[2])\).n[2]]; 
    \)\), 
    \(\(xbl1 = transform[\((H\ n[2] - l1\ b[1] - 1\/2\ thick\ b[2])\).n[1]]; 
    \)\), 
    \(\(ybl1 = transform[\((H\ n[2] - l1\ b[1] - 1\/2\ thick\ b[2])\).n[2]]; 
    \)\), 
    \(\(xbu0 = transform[\((H\ n[2] + l2\ b[1] + 1\/2\ thick\ b[2])\).n[1]]; 
    \)\), 
    \(\(ybu0 = transform[\((H\ n[2] + l2\ b[1] + 1\/2\ thick\ b[2])\).n[2]]; 
    \)\), 
    \(\(xbu1 = transform[\((H\ n[2] - l1\ b[1] + 1\/2\ thick\ b[2])\).n[1]]; 
    \)\), 
    \(\(ybu1 = transform[\((H\ n[2] - l1\ b[1] + 1\/2\ thick\ b[2])\).n[2]]; 
    \)\), 
    \(\(xcl0 = transform[\((H\ n[2] - l1\ b[1] - 1\/2\ thick\ c[1])\).n[1]]; 
    \)\), 
    \(\(ycl0 = transform[\((H\ n[2] - l1\ b[1] - 1\/2\ thick\ c[1])\).n[2]]; 
    \)\), 
    \(\(xcl1 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - 1\/2\ thick\ c[1])\).n[1]]; \)\), 
    \(\(ycl1 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - 1\/2\ thick\ c[1])\).n[2]]; \)\), 
    \(\(xcu0 = transform[\((H\ n[2] - l1\ b[1] + 1\/2\ thick\ c[1])\).n[1]]; 
    \)\), 
    \(\(ycu0 = transform[\((H\ n[2] - l1\ b[1] + 1\/2\ thick\ c[1])\).n[2]]; 
    \)\), 
    \(\(xcu1 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] + 1\/2\ thick\ c[1])\).n[1]]; \)\), 
    \(\(ycu1 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] + 1\/2\ thick\ c[1])\).n[2]]; \)\), 
    \(\(xd1 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] - 1\/2\ boxL\ d[1] + 
              1\/2\ boxH\ d[2])\).n[1]]; \)\), 
    \(\(yd1 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] - 1\/2\ boxL\ d[1] + 
              1\/2\ boxH\ d[2])\).n[2]]; \)\), 
    \(\(xd2 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] - 1\/2\ boxL\ d[1] - 
              1\/2\ boxH\ d[2])\).n[1]]; \)\), 
    \(\(yd2 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] - 1\/2\ boxL\ d[1] - 
              1\/2\ boxH\ d[2])\).n[2]]; \)\), 
    \(\(xd3 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] + 1\/2\ boxL\ d[1] - 
              1\/2\ boxH\ d[2])\).n[1]]; \)\), 
    \(\(yd3 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] + 1\/2\ boxL\ d[1] - 
              1\/2\ boxH\ d[2])\).n[2]]; \)\), 
    \(\(xd4 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] + 1\/2\ boxL\ d[1] + 
              1\/2\ boxH\ d[2])\).n[1]]; \)\), 
    \(\(yd4 = 
      transform[
        \((H\ n[2] - l1\ b[1] - l4\ c[2] - d3\ d[2] + 1\/2\ boxL\ d[1] + 
              1\/2\ boxH\ d[2])\).n[2]]; \)\), 
    \(\(xH = x[t]; \)\), 
    \(\(yH = y[t]; \)\), 
    \(For[tg = 0, tg \[LessEqual] tf, tg += tf\/100, 
      Show[Graphics[{
            Circle[{xb0 /. t \[Rule] tg, yb0 /. t \[Rule] tg}, thick\/2], 
            Circle[{xc0 /. t \[Rule] tg, yc0 /. t \[Rule] tg}, thick\/2], 
            Circle[{xd0 /. t \[Rule] tg, yd0 /. t \[Rule] tg}, thick\/2], 
            Line[{{xbl0 /. t \[Rule] tg, ybl0 /. t \[Rule] tg}, {
                  xbl1 /. t \[Rule] tg, ybl1 /. t \[Rule] tg}}], 
            Line[{{xbu0 /. t \[Rule] tg, ybu0 /. t \[Rule] tg}, {
                  xbu1 /. t \[Rule] tg, ybu1 /. t \[Rule] tg}}], 
            Line[{{xcl0 /. t \[Rule] tg, ycl0 /. t \[Rule] tg}, {
                  xcl1 /. t \[Rule] tg, ycl1 /. t \[Rule] tg}}], 
            Line[{{xcu0 /. t \[Rule] tg, ycu0 /. t \[Rule] tg}, {
                  xcu1 /. t \[Rule] tg, ycu1 /. t \[Rule] tg}}], 
            Line[{{xd1 /. t \[Rule] tg, yd1 /. t \[Rule] tg}, {
                  xd2 /. t \[Rule] tg, yd2 /. t \[Rule] tg}}], 
            Line[{{xd3 /. t \[Rule] tg, yd3 /. t \[Rule] tg}, {
                  xd4 /. t \[Rule] tg, yd4 /. t \[Rule] tg}}], 
            Line[{{xb0 /. t \[Rule] tg, yb0 /. t \[Rule] tg}, {
                  xa0 /. t \[Rule] tg, ya0 /. t \[Rule] tg}}], 
            Line[{{xd1 /. t \[Rule] tg, yd1 /. t \[Rule] tg}, {
                  xd4 /. t \[Rule] tg, yd4 /. t \[Rule] tg}}], 
            Line[{{xd2 /. t \[Rule] tg, yd2 /. t \[Rule] tg}, {
                  xd3 /. t \[Rule] tg, yd3 /. t \[Rule] tg}}], 
            Line[{{xd1 /. t \[Rule] tg, yd1 /. t \[Rule] tg}, {
                  xd0 /. t \[Rule] tg, yd0 /. t \[Rule] tg}}], 
            Line[{{xd4 /. t \[Rule] tg, yd4 /. t \[Rule] tg}, {
                  xd0 /. t \[Rule] tg, yd0 /. t \[Rule] tg}}], 
            Circle[{xa0 /. t \[Rule] tg, ya0 /. t \[Rule] tg}, 1.125\ rH], 
            Circle[{xH /. t \[Rule] tg, yH /. t \[Rule] tg}, rH], 
            Line[{{0, H}, {H, 0}}], Line[{{0, H}, {\(-H\), 0}}]}], 
        Axes \[Rule] True, 
        PlotRange 
          \[Rule] {{\(-\((H + l1 + l2 + l3 + 2\ rH)\)\), 
              2\ \((H + l1 + l2 + l3 + 2\ rH)\)}, {0, 
              1.5\ \((H + l1 + l2 + l3 + 2\ rH)\)}}, 
        AspectRatio \[Rule] Automatic]]\)}], "Input"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .10771 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{550, 275},
  ImageMargins->{{34, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008V00014b000`400?l00000o`00003ooooooooo
ooooobSooooo000Eooooo`?o00000oooool2o`0004[ooooo1Ol00003ooooo`;o0000Voooool5o`00
00?ooooo0_l0001<ooooo`?o00000oooool2o`0004_ooooo0ol00004ooooo`;o0000Boooool3o`00
00Cooooo0_l0000Dooooo`005_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0B?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0009_ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0001<ooooo`05o`000?oooooooooooooo
ool000000_ooool00ol0003oooooooooo`17ooooo`05o`000?ooooooooooooooool000000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool0000Cooooo`003Oooool5o`000003ooooool0003o000000?o00000_ooool01?l0003ooooo
ooooool00013ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
09cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00019ooooo`Go00000_ooool0
1?l0003oooooooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00019ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000C
ooooo`004oooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0004cooooo00Go
0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo09_ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo04Oooooo00Co0000oooooooooooo00000oooool01?l0
003oooooooooool00019ooooo`Co00000oooool01?l0003oooooooooool0001:ooooo`?o00000ooo
ool01?l0003oooooooooool0000Cooooo`005?ooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0004Wooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`00
09[ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0004[ooooo00?o
0000ooooool000000oooool01?l0003oooooooooool00019ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo0000BOooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooo
oooooooo00004oooool001Gooooo0_l00003ooooo`04o`000?ooooooooooo`0004Wooooo00Go0000
ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0009[ooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0004_ooooo0_l00003ooooo`04o`000?oooooooooo
o`0004[ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool00019ooooo`05o`000?oo
ooooooooooooool000000_ooool01?l0003oooooooooool0000Cooooo`005_ooool00ol0003ooooo
ooooo`02ooooo`;o0000Boooool3o`0000Cooooo0_l0002Looooo`?o00001?ooool2o`0004gooooo
00?o0000ooooooooool00_ooool2o`0004cooooo0_l00004ooooo`;o0000Boooool3o`0000Cooooo
0_l0000Dooooo`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXoooo
o`00ooooooooooooobSooooo003ooooooooooooo:?ooool00?oooooooooooolXooooo`00oooooooo
ooooobSooooo003ooooooooooooo:?ooool001;oooooool0003oo`0000So00003_ooool001Kooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
0_l0000Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Wooooo0_l0000Dooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool05Oooool001Kooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooool000004_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool00oooool4o`000003oooo
ool0003ooooo00Kooooo00?o0000ooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01Gooooo000Fooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo01Cooooo1ol00002ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Aooooo`03o`000?oo
oooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`0Eooooo`00V?ooool0
0ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00oooooo1Ol00005ooooo`Co00001_ooool0
0ol0003oooooooooo`3ooooood3ooooo002Iooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool02_ooool5o`0001?ooooo00?o0000ooooooooool0oooooom1ooooo`00V_ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0000Gooooo`03o`000?oooooooooo0?oo
oooo@_ooool009_ooooo00?o0000ooooooooool08?ooool01?l0003oooooooooooooool5o`0001[o
oooo00?o0000ooooooooool0oooooom3ooooo`00W?ooool00ol0003oooooooooo`0Nooooo`Go0000
7_ooool00ol0003oooooooooo`3oooooodCooooo002Mooooo`03o`000?oooooooooo01Sooooo1Ol0
00000ooooooo0000ooooo`0Oooooo`03o`000?oooooooooo0?ooooooAOooool009kooooo00?o0000
ooooooooool04_ooool5o`0000Kooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3o
ooooodKooooo002Oooooo`03o`000?oooooooooo00gooooo1?l0000;ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool0oooooom7ooooo`00WOooool4o`0000Wooooo1Ol0000?ooooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooom8ooooo`00W?ooool01?l0003ooooo
ooooooooool2o`0000?ooooo1Ol0000Dooooo`03o`000?oooooooooo01[ooooo00?o0000oooooooo
ool0oooooom9ooooo`00W?ooool01?l0003oooooooooooooool5o`0001Wooooo00?o0000oooooooo
ool06Oooool00ol0003oooooooooo`3ooooood[ooooo002Kooooo`03o`000?oooooooooo00;o0000
00Coooooo`000?oooooo00006_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?oo
ooooBoooool009_ooooo00?o0000ooooooooool00oooool01?l0003oooooooooool0000Iooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool0oooooom<ooooo`00W?ooool2o`000003oooo
ool0003o000000Cooooo00?o0000ooooooooool05_ooool3o`0001Kooooo00?o0000ooooooooool0
oooooom=ooooo`00W?ooool3o`0000Oooooo0_l0000Fooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool0oooooom>ooooo`00W_ooool00ol0003oooooooooo`06ooooo`;o00005Oooool0
0ol0003oooooooooo`0Dooooo`03o`000?oooooooooo0?ooooooCoooool009oooooo00?o0000oooo
ooooool01_ooool2o`0001Cooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`3ooooo
oe3ooooo002Pooooo`03o`000?oooooooooo00Kooooo0_l0000Cooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool0oooooomAooooo`00XOooool00ol0003oooooooooo`06ooooo`;o0000
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo0?ooooooD_ooool00:;ooooo0_l0
0007ooooo`?o00004?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo0?ooooooDooo
ool00:Cooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000?ooooo`03o`000?oooooo
oooo00oooooo00?o0000ooooooooool0oooooomDooooo`00YOooool00ol0003oooooooooo`05oooo
o`03o`000?oooooo000000kooooo0ol0000>ooooo`03o`000?oooooooooo0?ooooooEOooool00:Ko
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool0oooooomFooooo`00Yoooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooo000000cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`3ooooooeOooooo
002Xooooo`;o00001_ooool01?l0003oooooo`000?l0000:ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool0oooooomHooooo`00Z_ooool00ol0003oooooooooo`04ooooo`04o`000?oo
ooooooooo`0000Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3ooooooeWooooo
002[ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo0?ooooooF_ooool00:cooooo00?o0000ooooooooool01?oo
ool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
oooooomKooooo`00[Oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Kooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooecooooo002^ooooo`;o00001Ooo
ool00ol0003oooooooooo`02o`0000Cooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`3ooooooegooooo002`ooooo`03o`000?oooooooooo00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`?o00001Oooool00ol0003oooooooooo`3ooooooekooooo002aooooo`03o`000?oooooo
oooo00?ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0oooooomOooooo`00/_ooool00ol0003oooooooooo`03ooooo`07o`000?oooooo
ooooooooool0003oooooo`000005ooooo`03o`000?oooooooooo0?ooooooH?ooool00;?ooooo00?o
0000ooooooooool00oooool01?l0003oooooooooooooool2o`0000Cooooo00?o0000ooooooooool0
oooooomQooooo`00]?ooool2o`0000Cooooo00Co0000oooooooooooooooo0_l00002ooooo`03o`00
0?oooooooooo0?ooooooH_ooool00:gooooo0ol00004ooooo`?o00001?ooool01Ol0003ooooooooo
ool0003ooooo00;o00002?ooool=o`000?ooooooD?ooool00:kooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02o`0000Cooooo00Co0000ooooool0003ooooo0_l00008ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0oooooom>ooooo`00[_ooool00ol0003ooooooooo
o`02ooooo`06o`000?ooooooooooo`000?oooooo00001?ooool3o`0000;ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooC_ooool00:kooooo
00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00;o
oooo1?l000000ooooooo0000ooooo`05ooooo`03o`000?oooooooooo00;ooooo0ol00004ooooo`03
o`000?oooooooooo0?ooooooC_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool00003ooooo`;o00000_ooool00ol0003oooooooooo`03ooooo`;o00001?ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00003ooooooe3ooooo002]oooo
o`;o00001?ooool01?l0003oooooooooool00005ooooo`03o`000?oooooo000000Oooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooo
ooooo`3oooooodkooooo002^ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`;o00002?oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooo000000Co00000_ooool00ol0003ooooo
ooooo`3oooooodkooooo002nooooo`03o`000?oooooooooo00Oooooo00Co0000ooooool0003ooooo
0ol00004ooooo`Co0000oooooom@ooooo`00__ooool2o`0000Wooooo3_l0003ooooooe3ooooo002n
ooooo`04o`000?oooooo0000o`0000Sooooo0ol00003ooooo`04o`000?ooooooooooo`000?oooooo
Doooool00;kooooo00Go0000ooooooooooooooooo`000009ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool0oooooomBooooo`00__ooool3o`0000;ooooo00?o0000ooooooooool01_oo
ool2o`0000Cooooo00?o0000ooooooooool0oooooomBooooo`00__ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000000oooool00ol0003oooooooooo`3o
oooooe;ooooo002nooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo0?ooooooD_ooool00;kooooo00?o0000oooo
ooooool01Oooool2o`0000?ooooo1_l000000ooooooo0000ooooo`3ooooooe?ooooo002nooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool00_l00004ooooo`03o`000?oooooooooo0?oo
ooooDoooool00;kooooo00?o0000ooooooooool02?ooool00ol0003oooooo`000005ooooo`03o`00
0?oooooooooo0?ooooooDoooool00;kooooo00?o0000ooooooooool02Oooool2o`0000Gooooo00?o
0000ooooooooool0oooooomCooooo`00__ooool00ol0003oooooooooo`0:ooooo`;o00001?ooool0
0ol0003oooooooooo`3ooooooe?ooooo002nooooo`03o`000?oooooooooo00_ooooo0_l000000ooo
oooo0000o`00003ooooooeKooooo002nooooo`?o00003Oooool00ol0003oooooooooo`3ooooooeKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[?oo
ool5o`0000?ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00:kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:oooooo00Go0000ooooooooooooooooo`000002ooooo`03o`00
0?oooooooooo00Gooooo1?l0003oooooofGooooo002/ooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo
00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000oooo
ooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008ooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`?o0000oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo
002/ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooI_ooool00:kooooo0_l00003ooooo`04o`00
0?ooooooooooo`0000Oooooo1?l0003oooooofGooooo002`ooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`00
0?ooooooooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
0?ooooooI_ooool00:gooooo0ol00004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool3o`00
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002^ooooo`?o00000oooool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00[ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Go00000_ooool01?l0003oooooooooool00007ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00:cooooo00Co0000oooooooooooo00000oooool01?l0003ooooo
ooooool00007ooooo`Co0000oooooomUooooo`00[Oooool00ol0003oooooo`000003ooooo`04o`00
0?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000?ooooo
00Co0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002_ooooo`03o`00
0?oooooooooo00;ooooo0_l00008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o
0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002noooo
o`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00
__ooool3o`000?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool0
0ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;ko
oooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo
002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomVooooo`00
__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_oo
ool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3ooooo
ofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0
oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooooooo
o`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooo
ooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oooooo
oooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003o
ooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00:gooooo0ol0
0004ooooo`;o00002?ooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo0?oooooo
I_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?ooooooI_ooool00;3ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`05ooooo`Co0000oooooomUooooo`00[?ooool4o`0000?ooooo00Co0000oooooooooooo0000
1oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`03o`000?oooooooooo00Cooooo00Co
0000oooooooooooo00001oooool00ol0003oooooooooo`3oooooofKooooo002/ooooo`Go00000ooo
ool2o`0000Sooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3o
ooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000oooooooo
ool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`?o0000oooo
oomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo
0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003ooooo
ooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000
ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03o`000?oo
oooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0
003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo
00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002nooooo`03
o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00__oo
ool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool0
0;kooooo00?o0000ooooooooool0oooooomVooooo`00__ooool00ol0003oooooooooo`3oooooofKo
oooo002nooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo0ol0003oooooofKooooo002n
ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomVoooo
o`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oooooo
I_ooool00;kooooo00?o0000ooooooooool0oooooomVooooo`00[Oooool3o`0000Cooooo0_l00008
ooooo`03o`000?oooooooooo0?ooooooI_ooool00:cooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[?ooool0
1Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001oooool00ol0003ooooo
ooooo`3oooooofKooooo002/ooooo`Co00000oooool01?l0003oooooooooool00007ooooo`Co0000
oooooomUooooo`00[?ooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool0oooooomVooooo`00[Oooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0000Oooooo00?o0000ooooooooool0oooooomVooooo`00[_ooool2o`0000Cooooo0_l0
0008ooooo`03o`000?oooooooooo0?ooooooI_ooool00;kooooo00?o0000ooooooooool0oooooomV
ooooo`00__ooool00ol0003oooooooooo`3oooooofKooooo002nooooo`03o`000?oooooooooo0?oo
ooooI_ooool00001\
\>"],
  ImageRangeCache->{{{0, 549}, {274, 0}} -> {-45.3991, -3.68322, 0.23817, \
0.23817}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .10771 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`002?ooool3o`0000?ooooo0_l0
000Sooooo`Go00000oooool2o`0004kooooo1Ol00003ooooo`;o00009Oooool3o`0000?ooooo0_l0
000Tooooo`?o00001?ooool2o`0002Gooooo0ol00004ooooo`;o00000oooool000Wooooo00Go0000
ooooooooooooooooo`000002ooooo`03o`000?oooooooooo027ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0001>ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00009Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool08?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00008oooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool000Go000000?oooooo`00
0?l000000ol00002ooooo`04o`000?ooooooooooo`0001cooooo1Ol00003ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo0000Coooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0002;ooooo1Ol00002ooooo`04o`000?ooooooooooo`0002;ooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0002?ooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo0006ooooo`04o`000?ooooooooooo`0000?ooooo
00Co0000oooooooooooo00009Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0C_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool08?ooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0002;ooooo1?l00003ooooo`04o`00
0?ooooooooooo`0002Cooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo0007ooooo`03
o`000?oooooo000000?ooooo00Co0000oooooooooooo00008_ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo0000COooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00008oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`00
02;ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000Sooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00002ooooo`002?ooool2o`0000?ooooo00Co
0000oooooooooooo00008_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo0000COooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00009?oo
ool2o`0000?ooooo00Co0000oooooooooooo00008oooool00ol0003oooooooooo`03ooooo`04o`00
0?ooooooooooo`0002?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo0009ooooo`03o`000?oooooooooo00;ooooo0_l0000Tooooo`?o00001?ooool2o`00
04oooooo0ol00004ooooo`;o00009_ooool00ol0003oooooooooo`02ooooo`;o00009Oooool2o`00
00Cooooo0_l0000Uooooo`?o00001?ooool2o`0000?ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo0006oooooooo00006Ol00002ooooo`002Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooo`000003o`0000Cooooo0_l0000:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool01?ooool000Wooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Eooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool01_ooool5o`000004ooooool0003o0000o`0000?o
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`04ooooo`00Coooool00ol0003ooooo
ooooo`0Aooooo`04o`000?ooooooooooooooo`Go00002oooool00ol0003oooooooooo`2Vooooo`00
D?ooool00ol0003oooooooooo`0?ooooo`Go00003oooool00ol0003oooooooooo`2Wooooo`00DOoo
ool00ol0003oooooooooo`0:ooooo`Co000000?oooooo`000?l000004?ooool00ol0003ooooooooo
o`2Xooooo`00D_ooool00ol0003oooooooooo`04ooooo`Go00001Oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo0:Wooooo001Aooooo`So00002_ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo0:[ooooo001@ooooo`03o`000?oooooo000000?o00003Oooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo0:_ooooo001Aooooo`04o`000?oooooo0000ooooo`;o
00003?ooool2o`0000cooooo00?o0000ooooooooool0[?ooool0057ooooo0_l00003ooooo`;o0000
2oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0:gooooo001Cooooo`04o`000?oo
ooooooooooooo`;o00002_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0:kooooo
001Dooooo`04o`000?ooooooooooooooo`?o00002?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0:oooooo001Eooooo`07o`000?ooooooooooooooool0003oooooo`000007ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0/?ooool005Kooooo0_l00002ooooo`03o`00
0?oooooo000000Kooooo0_l00007ooooo`03o`000?oooooooooo0;7ooooo001Hooooo`06o`000?oo
ooooooooo`000?oooooo00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0;;o
oooo001Iooooo`06o`000?ooooooooooo`000?oooooo00001?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo0;?ooooo001Jooooo`06o`000?ooooooooooo`000?oooooo00000oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0;Cooooo001Kooooo`;o000000?oooooo`00
0?ooool00_l000000ooooooo0000o`000003ooooo`03o`000?oooooooooo0;Gooooo001Mooooo`03
o`000?oooooo000000;ooooo0_l00003ooooo`03o`000?oooooooooo0;Kooooo001Eooooo`?o0000
1?ooool3o`000005ooooool0003oooooooooool000000_ooool00ol0003oooooooooo`2gooooo`00
E_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o000000?oooooo`000?ooool0
0ol00003ooooo`So0000[oooool005Kooooo00?o0000ooooooooool00_ooool01ol0003ooooooooo
ool0003oooooo`000?ooool01?l00003ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0[Oooool005Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`Oo
000000Coooooo`000?oooooooooo0ol000000ooooooo0000ooooo`2^ooooo`00E_ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool2o`00
0003ooooool0003o000000Co0000[oooool005Gooooo0_l00004ooooo`04o`000?ooooooooooo`00
00Cooooo0_l00004ooooo`So0000[oooool005Kooooo00?o0000ooooooooool00oooool2o`0000Go
oooo00?o0000ooooool000001?ooool6o`000;3ooooo001Sooooo`;o000000?oooooo`000?l00000
0oooool01Ol0003ooooooooooooooooo00000;3ooooo001Sooooo`03o`000?oooooooooo00;ooooo
00Oo0000ooooool0003oooooo`000?oooooo00000;7ooooo001Sooooo`03o`000?oooooooooo00?o
oooo0ol000000ooooooo0000o`00002aooooo`00Hoooool00ol0003oooooooooo`04ooooo`05o`00
0?ooooooooooooooool00000/Oooool006?ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
o`00002booooo`00Hoooool2o`0000Oooooo00?o0000ooooooooool0/Oooool006?ooooo00?o0000
ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000oooooooo
ool0^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool0
0ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003o
ooooooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001D
ooooo`Go00000oooool2o`0000Gooooo00?o0000ooooooooool0^_ooool005Gooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;[ooooo001F
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool3o`000;[ooooo001G
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0;[ooooo001Dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooooooo0;[ooooo001Dooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;[ooooo001Eooooo`?o0000
1?ooool2o`0000Gooooo00?o0000ooooooooool0^_ooool006?ooooo0_l0002kooooo`00Hoooool0
0ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003o
ooooooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001S
ooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03
o`000?oooooooooo0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000ooooooooool0^_oo
ool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?o
oooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00EOooool3o`0000Cooooo0_l0
0005ooooo`03o`000?oooooooooo0;[ooooo001Dooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;[ooooo001Hooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2jooooo`00E_oo
ool2o`0000?ooooo00Co0000oooooooooooo00001?ooool3o`000;[ooooo001Hooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2jooooo`00E?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool00ol0003o
ooooooooo`2jooooo`00EOooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0;[ooooo
001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000oooo
ooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0
^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0
003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003ooooo
ooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Soooo
o`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`;o0000
^oooool006?ooooo00?o0000ooooooooool0^_ooool005Kooooo0ol00003ooooo`;o00001Oooool0
0ol0003oooooooooo`2jooooo`00Eoooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`2jooooo`00E?ooool5o`0000;ooooo00Co0000oooo
oooooooo00001?ooool00ol0003oooooooooo`2jooooo`00E?ooool01?l0003oooooooooool00003
ooooo`04o`000?ooooooooooo`0000Cooooo0ol0002jooooo`00EOooool00ol0003oooooo`000003
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Kooooo0_l00003
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Oooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0^_ooool006?ooooo0_l0002koooo
o`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hooo
ool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool2o`00
0;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo
001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000oooo
ooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0
^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0
003oooooooooo`2jooooo`00EOooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0;[o
oooo001Dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00004oooo
o`03o`000?oooooooooo0;[ooooo001Hooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool00_ooool3o`000;[ooooo001Hooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`2jooooo`00E?ooool4o`0000?ooooo00Co0000oooooooo
oooo00001?ooool00ol0003oooooooooo`2jooooo`00E?ooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Cooooo1Ol00003ooooo`;o
00001Oooool00ol0003oooooooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oo
oooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo
0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o
0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000oooo
ooooool0^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hooo
ool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool2o`00
0;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Eooooo`?o00001?ooool2o`0000Gooooo
00?o0000ooooooooool0^_ooool005Cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Co
oooo1?l00003ooooo`04o`000?ooooooooooo`0000Cooooo0ol0002jooooo`00E?ooool00ol0003o
ooooooooo`04ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Go
oooo00?o0000ooooooooool00oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo
0;[ooooo001Fooooo`;o00001?ooool2o`0000Gooooo00?o0000ooooooooool0^_ooool006?ooooo
00?o0000ooooooooool0^_ooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-43.9707, -35.0717, 0.44118, \
0.44118}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .10771 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`002?ooool3o`0000?ooooo0_l0
000Sooooo`Go00000oooool2o`0004kooooo1Ol00003ooooo`;o00009Oooool3o`0000?ooooo0_l0
000Tooooo`?o00001?ooool2o`0002Gooooo0ol00004ooooo`;o00000oooool000Wooooo00Go0000
ooooooooooooooooo`000002ooooo`03o`000?oooooooooo027ooooo00Co0000oooooooooooo0000
0_ooool01?l0003oooooooooool0001>ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooo
oooooooo00009Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool08?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00008oooool01Ol0003o
oooooooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool000Go000000?oooooo`00
0?l000000ol00002ooooo`04o`000?ooooooooooo`0001cooooo1Ol00003ooooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo0000Coooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0002;ooooo1Ol00002ooooo`04o`000?ooooooooooo`0002;ooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0002?ooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo0006ooooo`04o`000?ooooooooooo`0000?ooooo
00Co0000oooooooooooo00009Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool0C_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool08?ooool0
1?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0002;ooooo1?l00003ooooo`04o`00
0?ooooooooooo`0002Cooooo0ol00003ooooo`04o`000?ooooooooooo`0000;ooooo0007ooooo`03
o`000?oooooo000000?ooooo00Co0000oooooooooooo00008_ooool01Ol0003ooooooooooooooooo
000000;ooooo00Co0000oooooooooooo0000COooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00008oooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`00
02;ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0000Sooooo`05o`000?oooooo
ooooooooool000000_ooool01?l0003oooooooooool00002ooooo`002?ooool2o`0000?ooooo00Co
0000oooooooooooo00008_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooo
oooo0000COooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00009?oo
ool2o`0000?ooooo00Co0000oooooooooooo00008oooool00ol0003oooooooooo`03ooooo`04o`00
0?ooooooooooo`0002?ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?oooooooooo
o`0000;ooooo0009ooooo`03o`000?oooooooooo00;ooooo0_l0000Tooooo`?o00001?ooool2o`00
04oooooo0ol00004ooooo`;o00009_ooool00ol0003oooooooooo`02ooooo`;o00009Oooool2o`00
00Cooooo0_l0000Uooooo`?o00001?ooool2o`0000?ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo0006oooooooo00006Ol00002ooooo`002Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooo`000003o`0000Cooooo0_l0000:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool01?ooool000Wooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Eooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool01_ooool5o`000004ooooool0003o0000o`0000?o
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`04ooooo`00Coooool00ol0003ooooo
ooooo`0Aooooo`04o`000?ooooooooooooooo`Go00002oooool00ol0003oooooooooo`2Vooooo`00
D?ooool00ol0003oooooooooo`0?ooooo`Go00003oooool00ol0003oooooooooo`2Wooooo`00DOoo
ool00ol0003oooooooooo`0:ooooo`Co000000?oooooo`000?l000004?ooool00ol0003ooooooooo
o`2Xooooo`00D_ooool00ol0003oooooooooo`04ooooo`Go00001Oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo0:Wooooo001Aooooo`So00002_ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo0:[ooooo001@ooooo`03o`000?oooooo000000?o00003Oooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo0:_ooooo001Aooooo`04o`000?oooooo0000ooooo`;o
00003?ooool2o`0000cooooo00?o0000ooooooooool0[?ooool0057ooooo0_l00003ooooo`;o0000
2oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0:gooooo001Cooooo`04o`000?oo
ooooooooooooo`;o00002_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0:kooooo
001Dooooo`04o`000?ooooooooooooooo`?o00002?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0:oooooo001Eooooo`07o`000?ooooooooooooooool0003oooooo`000007ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0/?ooool005Kooooo0_l00002ooooo`03o`00
0?oooooo000000Kooooo0_l00007ooooo`03o`000?oooooooooo0;7ooooo001Hooooo`06o`000?oo
ooooooooo`000?oooooo00001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0;;o
oooo001Iooooo`06o`000?ooooooooooo`000?oooooo00001?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo0;?ooooo001Jooooo`06o`000?ooooooooooo`000?oooooo00000oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0;Cooooo001Kooooo`;o000000?oooooo`00
0?ooool00_l000000ooooooo0000o`000003ooooo`03o`000?oooooooooo0;Gooooo001Mooooo`03
o`000?oooooo000000;ooooo0_l00003ooooo`03o`000?oooooooooo0;Kooooo001Eooooo`?o0000
1?ooool3o`000005ooooool0003oooooooooool000000_ooool00ol0003oooooooooo`2gooooo`00
E_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o000000?oooooo`000?ooool0
0ol00003ooooo`So0000[oooool005Kooooo00?o0000ooooooooool00_ooool01ol0003ooooooooo
ool0003oooooo`000?ooool01?l00003ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool0[Oooool005Kooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`Oo
000000Coooooo`000?oooooooooo0ol000000ooooooo0000ooooo`2^ooooo`00E_ooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool2o`00
0003ooooool0003o000000Co0000[oooool005Gooooo0_l00004ooooo`04o`000?ooooooooooo`00
00Cooooo0_l00004ooooo`So0000[oooool005Kooooo00?o0000ooooooooool00oooool2o`0000Go
oooo00?o0000ooooool000001?ooool6o`000;3ooooo001Sooooo`;o000000?oooooo`000?l00000
0oooool01Ol0003ooooooooooooooooo00000;3ooooo001Sooooo`03o`000?oooooooooo00;ooooo
00Oo0000ooooool0003oooooo`000?oooooo00000;7ooooo001Sooooo`03o`000?oooooooooo00?o
oooo0ol000000ooooooo0000o`00002aooooo`00Hoooool00ol0003oooooooooo`04ooooo`05o`00
0?ooooooooooooooool00000/Oooool006?ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
o`00002booooo`00Hoooool2o`0000Oooooo00?o0000ooooooooool0/Oooool006?ooooo00?o0000
ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000oooooooo
ool0^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool0
0ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003o
ooooooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001D
ooooo`Go00000oooool2o`0000Gooooo00?o0000ooooooooool0^_ooool005Gooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;[ooooo001F
ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001?ooool3o`000;[ooooo001G
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo0;[ooooo001Dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooooooo0;[ooooo001Dooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;[ooooo001Eooooo`?o0000
1?ooool2o`0000Gooooo00?o0000ooooooooool0^_ooool006?ooooo0_l0002kooooo`00Hoooool0
0ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003o
ooooooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001S
ooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03
o`000?oooooooooo0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000ooooooooool0^_oo
ool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?o
oooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00EOooool3o`0000Cooooo0_l0
0005ooooo`03o`000?oooooooooo0;[ooooo001Dooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0;[ooooo001Hooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2jooooo`00E_oo
ool2o`0000?ooooo00Co0000oooooooooooo00001?ooool3o`000;[ooooo001Hooooo`04o`000?oo
ooooooooo`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`2jooooo`00E?oo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00001?ooool00ol0003o
ooooooooo`2jooooo`00EOooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0;[ooooo
001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000oooo
ooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0
^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0
003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003ooooo
ooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Soooo
o`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`;o0000
^oooool006?ooooo00?o0000ooooooooool0^_ooool005Kooooo0ol00003ooooo`;o00001Oooool0
0ol0003oooooooooo`2jooooo`00Eoooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`2jooooo`00E?ooool5o`0000;ooooo00Co0000oooo
oooooooo00001?ooool00ol0003oooooooooo`2jooooo`00E?ooool01?l0003oooooooooool00003
ooooo`04o`000?ooooooooooo`0000Cooooo0ol0002jooooo`00EOooool00ol0003oooooo`000003
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Kooooo0_l00003
ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Oooooo00?o0000
ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool0^_ooool006?ooooo0_l0002koooo
o`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hooo
ool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool2o`00
0;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo
001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000oooo
ooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0
^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0
003oooooooooo`2jooooo`00EOooool3o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo0;[o
oooo001Dooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool00004oooo
o`03o`000?oooooooooo0;[ooooo001Hooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool00_ooool3o`000;[ooooo001Hooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`2jooooo`00E?ooool4o`0000?ooooo00Co0000oooooooo
oooo00001?ooool00ol0003oooooooooo`2jooooo`00E?ooool00ol0003oooooooooo`04ooooo`04
o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Cooooo1Ol00003ooooo`;o
00001Oooool00ol0003oooooooooo`2jooooo`00Hoooool2o`000;_ooooo001Sooooo`03o`000?oo
oooooooo0;[ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Sooooo`03o`000?oooooooooo
0;[ooooo001Sooooo`;o0000^oooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o
0000ooooooooool0^_ooool006?ooooo00?o0000ooooooooool0^_ooool006?ooooo00?o0000oooo
ooooool0^_ooool006?ooooo0_l0002kooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hooo
ool00ol0003oooooooooo`2jooooo`00Hoooool00ol0003oooooooooo`2jooooo`00Hoooool2o`00
0;_ooooo001Sooooo`03o`000?oooooooooo0;[ooooo001Eooooo`?o00001?ooool2o`0000Gooooo
00?o0000ooooooooool0^_ooool005Cooooo00Go0000ooooooooooooooooo`000002ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Cooooo00Go0000oooooooooooo
ooooo`000002ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Co
oooo1?l00003ooooo`04o`000?ooooooooooo`0000Cooooo0ol0002jooooo`00E?ooool00ol0003o
ooooooooo`04ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0^_ooool005Go
oooo00?o0000ooooooooool00oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo
0;[ooooo001Fooooo`;o00001?ooool2o`0000Gooooo00?o0000ooooooooool0^_ooool006?ooooo
00?o0000ooooooooool0^_ooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-43.9707, -35.0717, 0.44118, \
0.44118}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02941 .00609 0 365.73 arc
s
newpath
.36444 .1077 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08626 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02941 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27113 .02942 .00609 0 365.73 arc
s
newpath
.36444 .1077 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02475 m
.36835 .10304 L
s
.26721 .03408 m
.36052 .11237 L
s
.37043 .10876 m
.37403 .08837 L
s
.35844 .10665 m
.36203 .08625 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27113 .02942 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27112 .02942 .00609 0 365.73 arc
s
newpath
.36444 .1077 .00609 0 365.73 arc
s
newpath
.36803 .08731 .00609 0 365.73 arc
s
.27504 .02476 m
.36835 .10304 L
s
.26721 .03409 m
.36052 .11237 L
s
.37044 .10876 m
.37403 .08836 L
s
.35844 .10664 m
.36203 .08625 L
s
.38021 .09137 m
.38021 .07513 L
s
.35585 .07513 m
.35585 .09137 L
s
.27112 .02942 m
.39026 .00406 L
s
.38021 .09137 m
.35585 .09137 L
s
.38021 .07513 m
.35585 .07513 L
s
.38021 .09137 m
.36803 .08731 L
s
.35585 .09137 m
.36803 .08731 L
s
newpath
.39026 .00406 .00457 0 365.73 arc
s
newpath
.39026 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27111 .02943 .00609 0 365.73 arc
s
newpath
.36444 .1077 .00609 0 365.73 arc
s
newpath
.36803 .0873 .00609 0 365.73 arc
s
.27503 .02476 m
.36836 .10303 L
s
.2672 .0341 m
.36053 .11236 L
s
.37044 .10875 m
.37403 .08836 L
s
.35844 .10664 m
.36203 .08625 L
s
.38021 .09136 m
.38021 .07512 L
s
.35585 .07512 m
.35585 .09136 L
s
.27111 .02943 m
.39025 .00406 L
s
.38021 .09136 m
.35585 .09136 L
s
.38021 .07512 m
.35585 .07512 L
s
.38021 .09136 m
.36803 .0873 L
s
.35585 .09136 m
.36803 .0873 L
s
newpath
.39025 .00406 .00457 0 365.73 arc
s
newpath
.39025 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2711 .02945 .00609 0 365.73 arc
s
newpath
.36445 .10769 .00609 0 365.73 arc
s
newpath
.36803 .08729 .00609 0 365.73 arc
s
.27501 .02478 m
.36836 .10302 L
s
.26719 .03411 m
.36054 .11236 L
s
.37045 .10874 m
.37403 .08835 L
s
.35845 .10664 m
.36203 .08624 L
s
.38021 .09135 m
.38021 .07511 L
s
.35585 .07512 m
.35585 .09136 L
s
.2711 .02945 m
.39023 .00406 L
s
.38021 .09135 m
.35585 .09136 L
s
.38021 .07511 m
.35585 .07512 L
s
.38021 .09135 m
.36803 .08729 L
s
.35585 .09136 m
.36803 .08729 L
s
newpath
.39023 .00406 .00457 0 365.73 arc
s
newpath
.39023 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27108 .02947 .00609 0 365.73 arc
s
newpath
.36446 .10768 .00609 0 365.73 arc
s
newpath
.36803 .08728 .00609 0 365.73 arc
s
.27499 .0248 m
.36837 .10301 L
s
.26717 .03414 m
.36055 .11235 L
s
.37046 .10873 m
.37403 .08833 L
s
.35846 .10663 m
.36203 .08623 L
s
.38021 .09134 m
.3802 .0751 L
s
.35584 .0751 m
.35585 .09134 L
s
.27108 .02947 m
.39021 .00406 L
s
.38021 .09134 m
.35585 .09134 L
s
.3802 .0751 m
.35584 .0751 L
s
.38021 .09134 m
.36803 .08728 L
s
.35585 .09134 m
.36803 .08728 L
s
newpath
.39021 .00406 .00457 0 365.73 arc
s
newpath
.39021 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27106 .0295 .00609 0 365.73 arc
s
newpath
.36447 .10766 .00609 0 365.73 arc
s
newpath
.36803 .08726 .00609 0 365.73 arc
s
.27496 .02483 m
.36838 .10299 L
s
.26715 .03417 m
.36056 .11233 L
s
.37047 .10871 m
.37403 .08831 L
s
.35847 .10662 m
.36203 .08622 L
s
.38021 .09132 m
.3802 .07508 L
s
.35584 .07509 m
.35585 .09133 L
s
.27106 .0295 m
.39017 .00406 L
s
.38021 .09132 m
.35585 .09133 L
s
.3802 .07508 m
.35584 .07509 L
s
.38021 .09132 m
.36803 .08726 L
s
.35585 .09133 m
.36803 .08726 L
s
newpath
.39017 .00406 .00457 0 365.73 arc
s
newpath
.39017 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27102 .02955 .00609 0 365.73 arc
s
newpath
.36449 .10764 .00609 0 365.73 arc
s
newpath
.36802 .08723 .00609 0 365.73 arc
s
.27492 .02487 m
.3684 .10296 L
s
.26711 .03422 m
.36059 .11231 L
s
.37049 .10868 m
.37402 .08827 L
s
.35849 .1066 m
.36202 .0862 L
s
.38021 .09129 m
.3802 .07505 L
s
.35583 .07506 m
.35585 .0913 L
s
.27102 .02955 m
.39012 .00406 L
s
.38021 .09129 m
.35585 .0913 L
s
.3802 .07505 m
.35583 .07506 L
s
.38021 .09129 m
.36802 .08723 L
s
.35585 .0913 m
.36802 .08723 L
s
newpath
.39012 .00406 .00457 0 365.73 arc
s
newpath
.39012 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27096 .02961 .00609 0 365.73 arc
s
newpath
.36452 .10761 .00609 0 365.73 arc
s
newpath
.36802 .0872 .00609 0 365.73 arc
s
.27486 .02493 m
.36842 .10293 L
s
.26706 .03429 m
.36062 .11228 L
s
.37052 .10864 m
.37402 .08823 L
s
.35852 .10658 m
.36202 .08617 L
s
.3802 .09125 m
.38019 .07501 L
s
.35583 .07503 m
.35584 .09127 L
s
.27096 .02961 m
.39006 .00406 L
s
.3802 .09125 m
.35584 .09127 L
s
.38019 .07501 m
.35583 .07503 L
s
.3802 .09125 m
.36802 .0872 L
s
.35584 .09127 m
.36802 .0872 L
s
newpath
.39006 .00406 .00457 0 365.73 arc
s
newpath
.39006 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2709 .02969 .00609 0 365.73 arc
s
newpath
.36455 .10757 .00609 0 365.73 arc
s
newpath
.36801 .08715 .00609 0 365.73 arc
s
.27479 .02501 m
.36845 .10288 L
s
.267 .03438 m
.36066 .11225 L
s
.37056 .10858 m
.37402 .08817 L
s
.35855 .10655 m
.36201 .08613 L
s
.3802 .09119 m
.38018 .07495 L
s
.35582 .07499 m
.35584 .09123 L
s
.2709 .02969 m
.38997 .00406 L
s
.3802 .09119 m
.35584 .09123 L
s
.38018 .07495 m
.35582 .07499 L
s
.3802 .09119 m
.36801 .08715 L
s
.35584 .09123 m
.36801 .08715 L
s
newpath
.38997 .00406 .00457 0 365.73 arc
s
newpath
.38997 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27081 .02979 .00609 0 365.73 arc
s
newpath
.36459 .10752 .00609 0 365.73 arc
s
newpath
.36801 .08709 .00609 0 365.73 arc
s
.2747 .0251 m
.36848 .10283 L
s
.26693 .03448 m
.36071 .1122 L
s
.3706 .10852 m
.37401 .0881 L
s
.35859 .10651 m
.362 .08609 L
s
.3802 .09113 m
.38017 .07489 L
s
.35581 .07493 m
.35583 .09117 L
s
.27081 .02979 m
.38987 .00406 L
s
.3802 .09113 m
.35583 .09117 L
s
.38017 .07489 m
.35581 .07493 L
s
.3802 .09113 m
.36801 .08709 L
s
.35583 .09117 m
.36801 .08709 L
s
newpath
.38987 .00406 .00457 0 365.73 arc
s
newpath
.38987 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2707 .02993 .00609 0 365.73 arc
s
newpath
.36465 .10745 .00609 0 365.73 arc
s
newpath
.368 .08701 .00609 0 365.73 arc
s
.27458 .02523 m
.36853 .10275 L
s
.26682 .03463 m
.36077 .11215 L
s
.37066 .10843 m
.37401 .088 L
s
.35864 .10646 m
.36199 .08603 L
s
.38019 .09104 m
.38015 .0748 L
s
.35579 .07486 m
.35583 .0911 L
s
.2707 .02993 m
.38972 .00406 L
s
.38019 .09104 m
.35583 .0911 L
s
.38015 .0748 m
.35579 .07486 L
s
.38019 .09104 m
.368 .08701 L
s
.35583 .0911 m
.368 .08701 L
s
newpath
.38972 .00406 .00457 0 365.73 arc
s
newpath
.38972 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27056 .0301 .00609 0 365.73 arc
s
newpath
.36472 .10736 .00609 0 365.73 arc
s
newpath
.36799 .08692 .00609 0 365.73 arc
s
.27443 .02539 m
.36858 .10266 L
s
.2667 .0348 m
.36086 .11207 L
s
.37073 .10833 m
.374 .08788 L
s
.35871 .1064 m
.36198 .08596 L
s
.38018 .09094 m
.38013 .0747 L
s
.35577 .07478 m
.35582 .09102 L
s
.27056 .0301 m
.38955 .00406 L
s
.38018 .09094 m
.35582 .09102 L
s
.38013 .0747 m
.35577 .07478 L
s
.38018 .09094 m
.36799 .08692 L
s
.35582 .09102 m
.36799 .08692 L
s
newpath
.38955 .00406 .00457 0 365.73 arc
s
newpath
.38955 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27039 .0303 .00609 0 365.73 arc
s
newpath
.3648 .10726 .00609 0 365.73 arc
s
newpath
.36798 .0868 .00609 0 365.73 arc
s
.27424 .02558 m
.36865 .10254 L
s
.26655 .03502 m
.36095 .11198 L
s
.37082 .1082 m
.374 .08773 L
s
.35878 .10633 m
.36196 .08587 L
s
.38018 .09081 m
.3801 .07457 L
s
.35574 .07467 m
.35582 .09091 L
s
.27039 .0303 m
.38934 .00406 L
s
.38018 .09081 m
.35582 .09091 L
s
.3801 .07457 m
.35574 .07467 L
s
.38018 .09081 m
.36798 .0868 L
s
.35582 .09091 m
.36798 .0868 L
s
newpath
.38934 .00406 .00457 0 365.73 arc
s
newpath
.38934 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27021 .03053 .00609 0 365.73 arc
s
newpath
.36489 .10715 .00609 0 365.73 arc
s
newpath
.36796 .08667 .00609 0 365.73 arc
s
.27404 .02579 m
.36873 .10241 L
s
.26638 .03526 m
.36106 .11188 L
s
.37092 .10805 m
.37399 .08757 L
s
.35887 .10625 m
.36194 .08577 L
s
.38017 .09066 m
.38008 .07442 L
s
.35572 .07456 m
.35581 .0908 L
s
.27021 .03053 m
.3891 .00406 L
s
.38017 .09066 m
.35581 .0908 L
s
.38008 .07442 m
.35572 .07456 L
s
.38017 .09066 m
.36796 .08667 L
s
.35581 .0908 m
.36796 .08667 L
s
newpath
.3891 .00406 .00457 0 365.73 arc
s
newpath
.3891 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26997 .03083 .00609 0 365.73 arc
s
newpath
.36502 .107 .00609 0 365.73 arc
s
newpath
.36795 .0865 .00609 0 365.73 arc
s
.27378 .02607 m
.36882 .10225 L
s
.26616 .03558 m
.36121 .11175 L
s
.37104 .10786 m
.37398 .08736 L
s
.35899 .10614 m
.36192 .08564 L
s
.38016 .09047 m
.38004 .07423 L
s
.35568 .07441 m
.3558 .09065 L
s
.26997 .03083 m
.3888 .00406 L
s
.38016 .09047 m
.3558 .09065 L
s
.38004 .07423 m
.35568 .07441 L
s
.38016 .09047 m
.36795 .0865 L
s
.3558 .09065 m
.36795 .0865 L
s
newpath
.3888 .00406 .00457 0 365.73 arc
s
newpath
.3888 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26969 .03118 .00609 0 365.73 arc
s
newpath
.36516 .10682 .00609 0 365.73 arc
s
newpath
.36793 .0863 .00609 0 365.73 arc
s
.27347 .02641 m
.36894 .10205 L
s
.26591 .03595 m
.36137 .1116 L
s
.37119 .10764 m
.37396 .08712 L
s
.35912 .10601 m
.36189 .08549 L
s
.38014 .09025 m
.38 .07401 L
s
.35564 .07423 m
.35578 .09047 L
s
.26969 .03118 m
.38843 .00406 L
s
.38014 .09025 m
.35578 .09047 L
s
.38 .07401 m
.35564 .07423 L
s
.38014 .09025 m
.36793 .0863 L
s
.35578 .09047 m
.36793 .0863 L
s
newpath
.38843 .00406 .00457 0 365.73 arc
s
newpath
.38843 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26936 .0316 .00609 0 365.73 arc
s
newpath
.36532 .10661 .00609 0 365.73 arc
s
newpath
.3679 .08607 .00609 0 365.73 arc
s
.27311 .0268 m
.36907 .10181 L
s
.26561 .0364 m
.36157 .11141 L
s
.37136 .10737 m
.37395 .08683 L
s
.35928 .10585 m
.36186 .08531 L
s
.38013 .08999 m
.37995 .07375 L
s
.35559 .07402 m
.35577 .09026 L
s
.26936 .0316 m
.38801 .00406 L
s
.38013 .08999 m
.35577 .09026 L
s
.37995 .07375 m
.35559 .07402 L
s
.38013 .08999 m
.3679 .08607 L
s
.35577 .09026 m
.3679 .08607 L
s
newpath
.38801 .00406 .00457 0 365.73 arc
s
newpath
.38801 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26901 .03204 .00609 0 365.73 arc
s
newpath
.36549 .10639 .00609 0 365.73 arc
s
newpath
.36788 .08582 .00609 0 365.73 arc
s
.27273 .02722 m
.36921 .10157 L
s
.2653 .03687 m
.36178 .11121 L
s
.37154 .10709 m
.37393 .08652 L
s
.35944 .10569 m
.36183 .08512 L
s
.38011 .08972 m
.3799 .07348 L
s
.35554 .0738 m
.35576 .09004 L
s
.26901 .03204 m
.38756 .00406 L
s
.38011 .08972 m
.35576 .09004 L
s
.3799 .07348 m
.35554 .0738 L
s
.38011 .08972 m
.36788 .08582 L
s
.35576 .09004 m
.36788 .08582 L
s
newpath
.38756 .00406 .00457 0 365.73 arc
s
newpath
.38756 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26858 .03261 .00609 0 365.73 arc
s
newpath
.36571 .10611 .00609 0 365.73 arc
s
newpath
.36785 .08551 .00609 0 365.73 arc
s
.27226 .02775 m
.36938 .10125 L
s
.26491 .03747 m
.36203 .11096 L
s
.37177 .10674 m
.37391 .08614 L
s
.35965 .10548 m
.36179 .08488 L
s
.3801 .08937 m
.37983 .07314 L
s
.35548 .07353 m
.35574 .08977 L
s
.26858 .03261 m
.38699 .00406 L
s
.3801 .08937 m
.35574 .08977 L
s
.37983 .07314 m
.35548 .07353 L
s
.3801 .08937 m
.36785 .08551 L
s
.35574 .08977 m
.36785 .08551 L
s
newpath
.38699 .00406 .00457 0 365.73 arc
s
newpath
.38699 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26809 .03327 .00609 0 365.73 arc
s
newpath
.36596 .10578 .00609 0 365.73 arc
s
newpath
.36782 .08516 .00609 0 365.73 arc
s
.27171 .02837 m
.36958 .10088 L
s
.26446 .03816 m
.36233 .11067 L
s
.37202 .10633 m
.37389 .0857 L
s
.35989 .10523 m
.36175 .08461 L
s
.38008 .08898 m
.37976 .07274 L
s
.3554 .07321 m
.35572 .08945 L
s
.26809 .03327 m
.38634 .00406 L
s
.38008 .08898 m
.35572 .08945 L
s
.37976 .07274 m
.3554 .07321 L
s
.38008 .08898 m
.36782 .08516 L
s
.35572 .08945 m
.36782 .08516 L
s
newpath
.38634 .00406 .00457 0 365.73 arc
s
newpath
.38634 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26753 .03403 .00609 0 365.73 arc
s
newpath
.36624 .1054 .00609 0 365.73 arc
s
newpath
.36778 .08475 .00609 0 365.73 arc
s
.2711 .0291 m
.3698 .10046 L
s
.26396 .03897 m
.36267 .11033 L
s
.37231 .10585 m
.37386 .0852 L
s
.36016 .10494 m
.36171 .08429 L
s
.38006 .08852 m
.37968 .07229 L
s
.35532 .07285 m
.3557 .08909 L
s
.26753 .03403 m
.38559 .00406 L
s
.38006 .08852 m
.3557 .08909 L
s
.37968 .07229 m
.35532 .07285 L
s
.38006 .08852 m
.36778 .08475 L
s
.3557 .08909 m
.36778 .08475 L
s
newpath
.38559 .00406 .00457 0 365.73 arc
s
newpath
.38559 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26696 .03483 .00609 0 365.73 arc
s
newpath
.36652 .105 .00609 0 365.73 arc
s
newpath
.36775 .08433 .00609 0 365.73 arc
s
.27047 .02985 m
.37003 .10002 L
s
.26345 .0398 m
.36301 .10998 L
s
.3726 .10536 m
.37383 .08469 L
s
.36044 .10464 m
.36167 .08397 L
s
.38004 .08806 m
.37959 .07182 L
s
.35524 .07248 m
.35568 .08872 L
s
.26696 .03483 m
.38482 .00406 L
s
.38004 .08806 m
.35568 .08872 L
s
.37959 .07182 m
.35524 .07248 L
s
.38004 .08806 m
.36775 .08433 L
s
.35568 .08872 m
.36775 .08433 L
s
newpath
.38482 .00406 .00457 0 365.73 arc
s
newpath
.38482 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26628 .03581 .00609 0 365.73 arc
s
newpath
.36686 .10451 .00609 0 365.73 arc
s
newpath
.36771 .08382 .00609 0 365.73 arc
s
.26972 .03078 m
.37029 .09948 L
s
.26285 .04084 m
.36342 .10954 L
s
.37294 .10476 m
.37379 .08407 L
s
.36077 .10426 m
.36162 .08357 L
s
.38001 .08749 m
.37949 .07125 L
s
.35514 .07203 m
.35566 .08827 L
s
.26628 .03581 m
.38387 .00406 L
s
.38001 .08749 m
.35566 .08827 L
s
.37949 .07125 m
.35514 .07203 L
s
.38001 .08749 m
.36771 .08382 L
s
.35566 .08827 m
.36771 .08382 L
s
newpath
.38387 .00406 .00457 0 365.73 arc
s
newpath
.38387 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26552 .03694 .00609 0 365.73 arc
s
newpath
.36724 .10394 .00609 0 365.73 arc
s
newpath
.36766 .08324 .00609 0 365.73 arc
s
.26887 .03185 m
.37059 .09886 L
s
.26217 .04202 m
.36389 .10903 L
s
.37333 .10407 m
.37375 .08337 L
s
.36115 .10382 m
.36158 .08312 L
s
.37999 .08684 m
.37938 .07061 L
s
.35504 .07152 m
.35565 .08775 L
s
.26552 .03694 m
.3828 .00406 L
s
.37999 .08684 m
.35565 .08775 L
s
.37938 .07061 m
.35504 .07152 L
s
.37999 .08684 m
.36766 .08324 L
s
.35565 .08775 m
.36766 .08324 L
s
newpath
.3828 .00406 .00457 0 365.73 arc
s
newpath
.3828 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26469 .03823 .00609 0 365.73 arc
s
newpath
.36766 .1033 .00609 0 365.73 arc
s
newpath
.36762 .08259 .00609 0 365.73 arc
s
.26794 .03308 m
.37091 .09815 L
s
.26143 .04338 m
.3644 .10844 L
s
.37375 .10329 m
.37371 .08258 L
s
.36157 .10331 m
.36153 .0826 L
s
.37996 .08612 m
.37926 .06989 L
s
.35492 .07095 m
.35563 .08718 L
s
.26469 .03823 m
.3816 .00406 L
s
.37996 .08612 m
.35563 .08718 L
s
.37926 .06989 m
.35492 .07095 L
s
.37996 .08612 m
.36762 .08259 L
s
.35563 .08718 m
.36762 .08259 L
s
newpath
.3816 .00406 .00457 0 365.73 arc
s
newpath
.3816 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26385 .03958 .00609 0 365.73 arc
s
newpath
.36807 .10262 .00609 0 365.73 arc
s
newpath
.36758 .08192 .00609 0 365.73 arc
s
.267 .03437 m
.37123 .09741 L
s
.2607 .04479 m
.36492 .10783 L
s
.37416 .10247 m
.37366 .08177 L
s
.36199 .10277 m
.36149 .08207 L
s
.37994 .08537 m
.37914 .06915 L
s
.35481 .07036 m
.35561 .08658 L
s
.26385 .03958 m
.38036 .00406 L
s
.37994 .08537 m
.35561 .08658 L
s
.37914 .06915 m
.35481 .07036 L
s
.37994 .08537 m
.36758 .08192 L
s
.35561 .08658 m
.36758 .08192 L
s
newpath
.38036 .00406 .00457 0 365.73 arc
s
newpath
.38036 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26292 .04117 .00609 0 365.73 arc
s
newpath
.36854 .10183 .00609 0 365.73 arc
s
newpath
.36753 .08115 .00609 0 365.73 arc
s
.26595 .03589 m
.37157 .09655 L
s
.25989 .04645 m
.36551 .10711 L
s
.37462 .10153 m
.37361 .08085 L
s
.36246 .10213 m
.36145 .08144 L
s
.37992 .08451 m
.379 .0683 L
s
.35468 .06968 m
.3556 .08589 L
s
.26292 .04117 m
.37893 .00406 L
s
.37992 .08451 m
.3556 .08589 L
s
.379 .0683 m
.35468 .06968 L
s
.37992 .08451 m
.36753 .08115 L
s
.3556 .08589 m
.36753 .08115 L
s
newpath
.37893 .00406 .00457 0 365.73 arc
s
newpath
.37893 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26189 .043 .00609 0 365.73 arc
s
newpath
.36905 .10091 .00609 0 365.73 arc
s
newpath
.36749 .08026 .00609 0 365.73 arc
s
.26479 .03765 m
.37195 .09555 L
s
.259 .04836 m
.36616 .10627 L
s
.37513 .10045 m
.37356 .0798 L
s
.36298 .10137 m
.36141 .08072 L
s
.3799 .08353 m
.37885 .06732 L
s
.35454 .06889 m
.35559 .0851 L
s
.26189 .043 m
.3773 .00406 L
s
.3799 .08353 m
.35559 .0851 L
s
.37885 .06732 m
.35454 .06889 L
s
.3799 .08353 m
.36749 .08026 L
s
.35559 .0851 m
.36749 .08026 L
s
newpath
.3773 .00406 .00457 0 365.73 arc
s
newpath
.3773 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26082 .04507 .00609 0 365.73 arc
s
newpath
.36959 .09988 .00609 0 365.73 arc
s
newpath
.36744 .07928 .00609 0 365.73 arc
s
.26356 .03963 m
.37233 .09444 L
s
.25808 .05051 m
.36685 .10532 L
s
.37565 .09924 m
.3735 .07865 L
s
.36353 .10051 m
.36139 .07991 L
s
.37989 .08244 m
.3787 .06624 L
s
.3544 .06803 m
.35559 .08422 L
s
.26082 .04507 m
.37551 .00406 L
s
.37989 .08244 m
.35559 .08422 L
s
.3787 .06624 m
.3544 .06803 L
s
.37989 .08244 m
.36744 .07928 L
s
.35559 .08422 m
.36744 .07928 L
s
newpath
.37551 .00406 .00457 0 365.73 arc
s
newpath
.37551 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25975 .04726 .00609 0 365.73 arc
s
newpath
.37012 .09878 .00609 0 365.73 arc
s
newpath
.36741 .07825 .00609 0 365.73 arc
s
.26233 .04174 m
.3727 .09326 L
s
.25718 .05278 m
.36755 .1043 L
s
.37616 .09798 m
.37344 .07746 L
s
.36409 .09958 m
.36137 .07905 L
s
.37988 .0813 m
.37855 .06512 L
s
.35427 .06711 m
.3556 .0833 L
s
.25975 .04726 m
.37364 .00406 L
s
.37988 .0813 m
.3556 .0833 L
s
.37855 .06512 m
.35427 .06711 L
s
.37988 .0813 m
.36741 .07825 L
s
.3556 .0833 m
.36741 .07825 L
s
newpath
.37364 .00406 .00457 0 365.73 arc
s
newpath
.37364 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25868 .04967 .00609 0 365.73 arc
s
newpath
.37066 .09758 .00609 0 365.73 arc
s
newpath
.36737 .07713 .00609 0 365.73 arc
s
.26107 .04407 m
.37306 .09198 L
s
.25628 .05527 m
.36827 .10318 L
s
.37667 .09661 m
.37339 .07617 L
s
.36465 .09855 m
.36136 .0781 L
s
.37987 .08007 m
.37839 .06389 L
s
.35413 .06612 m
.35561 .08229 L
s
.25868 .04967 m
.37162 .00406 L
s
.37987 .08007 m
.35561 .08229 L
s
.37839 .06389 m
.35413 .06612 L
s
.37987 .08007 m
.36737 .07713 L
s
.35561 .08229 m
.36737 .07713 L
s
newpath
.37162 .00406 .00457 0 365.73 arc
s
newpath
.37162 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25753 .05249 .00609 0 365.73 arc
s
newpath
.37123 .09617 .00609 0 365.73 arc
s
newpath
.36735 .07583 .00609 0 365.73 arc
s
.25972 .0468 m
.37342 .09048 L
s
.25535 .05817 m
.36905 .10185 L
s
.37722 .09502 m
.37333 .07469 L
s
.36525 .09731 m
.36136 .07697 L
s
.37988 .07863 m
.37823 .06247 L
s
.35399 .06495 m
.35564 .08111 L
s
.25753 .05249 m
.36929 .00406 L
s
.37988 .07863 m
.35564 .08111 L
s
.37823 .06247 m
.35399 .06495 L
s
.37988 .07863 m
.36735 .07583 L
s
.35564 .08111 m
.36735 .07583 L
s
newpath
.36929 .00406 .00457 0 365.73 arc
s
newpath
.36929 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25641 .05559 .00609 0 365.73 arc
s
newpath
.37179 .09462 .00609 0 365.73 arc
s
newpath
.36733 .0744 .00609 0 365.73 arc
s
.25836 .04982 m
.37374 .08885 L
s
.25446 .06136 m
.36984 .10039 L
s
.37774 .0933 m
.37328 .07308 L
s
.36585 .09593 m
.36138 .07571 L
s
.37989 .07706 m
.37806 .06092 L
s
.35385 .06367 m
.35568 .0798 L
s
.25641 .05559 m
.36678 .00406 L
s
.37989 .07706 m
.35568 .0798 L
s
.37806 .06092 m
.35385 .06367 L
s
.37989 .07706 m
.36733 .0744 L
s
.35568 .0798 m
.36733 .0744 L
s
newpath
.36678 .00406 .00457 0 365.73 arc
s
newpath
.36678 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25536 .05895 .00609 0 365.73 arc
s
newpath
.37232 .09293 .00609 0 365.73 arc
s
newpath
.36732 .07284 .00609 0 365.73 arc
s
.25705 .05311 m
.37402 .08709 L
s
.25366 .0648 m
.37062 .09878 L
s
.37823 .09146 m
.37323 .07137 L
s
.36641 .09441 m
.36141 .07431 L
s
.37991 .07536 m
.3779 .05925 L
s
.35373 .06226 m
.35574 .07838 L
s
.25536 .05895 m
.36409 .00406 L
s
.37991 .07536 m
.35574 .07838 L
s
.3779 .05925 m
.35373 .06226 L
s
.37991 .07536 m
.36732 .07284 L
s
.35574 .07838 m
.36732 .07284 L
s
newpath
.36409 .00406 .00457 0 365.73 arc
s
newpath
.36409 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25443 .06243 .00609 0 365.73 arc
s
newpath
.37279 .0912 .00609 0 365.73 arc
s
newpath
.36733 .07122 .00609 0 365.73 arc
s
.25587 .05651 m
.37422 .08528 L
s
.25299 .06835 m
.37135 .09712 L
s
.37866 .08959 m
.3732 .06962 L
s
.36691 .0928 m
.36145 .07283 L
s
.37994 .0736 m
.37775 .05751 L
s
.35361 .0608 m
.3558 .07689 L
s
.25443 .06243 m
.36134 .00406 L
s
.37994 .0736 m
.3558 .07689 L
s
.37775 .05751 m
.35361 .0608 L
s
.37994 .0736 m
.36733 .07122 L
s
.3558 .07689 m
.36733 .07122 L
s
newpath
.36134 .00406 .00457 0 365.73 arc
s
newpath
.36134 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25358 .06633 .00609 0 365.73 arc
s
newpath
.37321 .08925 .00609 0 365.73 arc
s
newpath
.36734 .06939 .00609 0 365.73 arc
s
.25473 .06035 m
.37435 .08327 L
s
.25244 .07231 m
.37206 .09523 L
s
.37905 .08752 m
.37318 .06766 L
s
.36737 .09097 m
.3615 .07112 L
s
.37999 .07161 m
.3776 .05555 L
s
.3535 .05913 m
.35589 .0752 L
s
.25358 .06633 m
.35827 .00406 L
s
.37999 .07161 m
.35589 .0752 L
s
.3776 .05555 m
.3535 .05913 L
s
.37999 .07161 m
.36734 .06939 L
s
.35589 .0752 m
.36734 .06939 L
s
newpath
.35827 .00406 .00457 0 365.73 arc
s
newpath
.35827 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25288 .07063 .00609 0 365.73 arc
s
newpath
.37356 .08709 .00609 0 365.73 arc
s
newpath
.36738 .06733 .00609 0 365.73 arc
s
.2537 .0646 m
.37438 .08106 L
s
.25205 .07667 m
.37274 .09313 L
s
.37937 .08528 m
.37319 .06551 L
s
.36775 .08891 m
.36156 .06915 L
s
.38005 .06939 m
.37745 .05336 L
s
.35341 .05726 m
.356 .07329 L
s
.25288 .07063 m
.35488 .00406 L
s
.38005 .06939 m
.356 .07329 L
s
.37745 .05336 m
.35341 .05726 L
s
.38005 .06939 m
.36738 .06733 L
s
.356 .07329 m
.36738 .06733 L
s
newpath
.35488 .00406 .00457 0 365.73 arc
s
newpath
.35488 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25238 .07524 .00609 0 365.73 arc
s
newpath
.37381 .08479 .00609 0 365.73 arc
s
newpath
.36743 .06509 .00609 0 365.73 arc
s
.25286 .06916 m
.37429 .07872 L
s
.2519 .08131 m
.37333 .09086 L
s
.3796 .08292 m
.37322 .06322 L
s
.36802 .08667 m
.36163 .06697 L
s
.38013 .06699 m
.37732 .05099 L
s
.35333 .0552 m
.35613 .0712 L
s
.25238 .07524 m
.35122 .00406 L
s
.38013 .06699 m
.35613 .0712 L
s
.37732 .05099 m
.35333 .0552 L
s
.38013 .06699 m
.36743 .06509 L
s
.35613 .0712 m
.36743 .06509 L
s
newpath
.35122 .00406 .00457 0 365.73 arc
s
newpath
.35122 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25215 .07986 .00609 0 365.73 arc
s
newpath
.37392 .08248 .00609 0 365.73 arc
s
newpath
.3675 .0628 .00609 0 365.73 arc
s
.25228 .07377 m
.37406 .07639 L
s
.25202 .08595 m
.37379 .08857 L
s
.37971 .08059 m
.37329 .06091 L
s
.36814 .08437 m
.36171 .06469 L
s
.38022 .06453 m
.37721 .04857 L
s
.35327 .05308 m
.35628 .06904 L
s
.25215 .07986 m
.34749 .00406 L
s
.38022 .06453 m
.35628 .06904 L
s
.37721 .04857 m
.35327 .05308 L
s
.38022 .06453 m
.3675 .0628 L
s
.35628 .06904 m
.3675 .0628 L
s
newpath
.34749 .00406 .00457 0 365.73 arc
s
newpath
.34749 .00406 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2522 .08486 .00609 0 365.73 arc
s
newpath
.3739 .07998 .00609 0 365.73 arc
s
newpath
.36759 .06026 .00609 0 365.73 arc
s
.25195 .07877 m
.37366 .0739 L
s
.25244 .09094 m
.37415 .08607 L
s
.3797 .07813 m
.37339 .05841 L
s
.3681 .08184 m
.36179 .06212 L
s
.38033 .06183 m
.37712 .04591 L
s
.35324 .05073 m
.35645 .06665 L
s
.2522 .08486 m
.34335 .00407 L
s
.38033 .06183 m
.35645 .06665 L
s
.37712 .04591 m
.35324 .05073 L
s
.38033 .06183 m
.36759 .06026 L
s
.35645 .06665 m
.36759 .06026 L
s
newpath
.34335 .00407 .00457 0 365.73 arc
s
newpath
.34335 .00407 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2526 .09033 .00609 0 365.73 arc
s
newpath
.3737 .07725 .00609 0 365.73 arc
s
newpath
.36771 .05743 .00609 0 365.73 arc
s
.25195 .08427 m
.37305 .07119 L
s
.25325 .09638 m
.37435 .0833 L
s
.37953 .07549 m
.37354 .05567 L
s
.36787 .07901 m
.36188 .05919 L
s
.38047 .05883 m
.37705 .04295 L
s
.35324 .04809 m
.35666 .06396 L
s
.2526 .09033 m
.33866 .00413 L
s
.38047 .05883 m
.35666 .06396 L
s
.37705 .04295 m
.35324 .04809 L
s
.38047 .05883 m
.36771 .05743 L
s
.35666 .06396 m
.36771 .05743 L
s
newpath
.33866 .00413 .00457 0 365.73 arc
s
newpath
.33866 .00413 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25343 .09607 .00609 0 365.73 arc
s
newpath
.37328 .07438 .00609 0 365.73 arc
s
newpath
.36787 .05439 .00609 0 365.73 arc
s
.25235 .09008 m
.3722 .06838 L
s
.25452 .10207 m
.37437 .08037 L
s
.37916 .07278 m
.37374 .0528 L
s
.36741 .07597 m
.36199 .05598 L
s
.38065 .05563 m
.37702 .0398 L
s
.35327 .04524 m
.3569 .06107 L
s
.25343 .09607 m
.33354 .00432 L
s
.38065 .05563 m
.3569 .06107 L
s
.37702 .0398 m
.35327 .04524 L
s
.38065 .05563 m
.36787 .05439 L
s
.3569 .06107 m
.36787 .05439 L
s
newpath
.33354 .00432 .00457 0 365.73 arc
s
newpath
.33354 .00432 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25469 .10183 .00609 0 365.73 arc
s
newpath
.37265 .0715 .00609 0 365.73 arc
s
newpath
.36805 .05131 .00609 0 365.73 arc
s
.25317 .09593 m
.37114 .0656 L
s
.25621 .10773 m
.37417 .07739 L
s
.37859 .07014 m
.37399 .04995 L
s
.36672 .07285 m
.36211 .05266 L
s
.38085 .05239 m
.37703 .0366 L
s
.35335 .04233 m
.35717 .05812 L
s
.25469 .10183 m
.32818 .0047 L
s
.38085 .05239 m
.35717 .05812 L
s
.37703 .0366 m
.35335 .04233 L
s
.38085 .05239 m
.36805 .05131 L
s
.35717 .05812 m
.36805 .05131 L
s
newpath
.32818 .0047 .00457 0 365.73 arc
s
newpath
.32818 .0047 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2565 .10788 .00609 0 365.73 arc
s
newpath
.37175 .06847 .00609 0 365.73 arc
s
newpath
.36828 .04806 .00609 0 365.73 arc
s
.25453 .10212 m
.36978 .06271 L
s
.25847 .11365 m
.37372 .07423 L
s
.37775 .06745 m
.37428 .04703 L
s
.36575 .06949 m
.36227 .04908 L
s
.38108 .04899 m
.37708 .03325 L
s
.35347 .03925 m
.35747 .05499 L
s
.2565 .10788 m
.32232 .00539 L
s
.38108 .04899 m
.35747 .05499 L
s
.37708 .03325 m
.35347 .03925 L
s
.38108 .04899 m
.36828 .04806 L
s
.35747 .05499 m
.36828 .04806 L
s
newpath
.32232 .00539 .00457 0 365.73 arc
s
newpath
.32232 .00539 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.25913 .11459 .00609 0 365.73 arc
s
newpath
.37044 .06512 .00609 0 365.73 arc
s
newpath
.36856 .0445 .00609 0 365.73 arc
s
.25666 .10902 m
.36796 .05955 L
s
.2616 .12015 m
.37291 .07068 L
s
.3765 .06457 m
.37463 .04395 L
s
.36437 .06567 m
.3625 .04505 L
s
.38138 .04527 m
.37718 .02958 L
s
.35365 .03588 m
.35785 .05157 L
s
.25913 .11459 m
.31556 .00664 L
s
.38138 .04527 m
.35785 .05157 L
s
.37718 .02958 m
.35365 .03588 L
s
.38138 .04527 m
.36856 .0445 L
s
.35785 .05157 m
.36856 .0445 L
s
newpath
.31556 .00664 .00457 0 365.73 arc
s
newpath
.31556 .00664 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26272 .12171 .00609 0 365.73 arc
s
newpath
.36864 .06156 .00609 0 365.73 arc
s
newpath
.3689 .04085 .00609 0 365.73 arc
s
.25972 .11641 m
.36563 .05626 L
s
.26573 .127 m
.37165 .06685 L
s
.37473 .06164 m
.37499 .04093 L
s
.36255 .06148 m
.36281 .04078 L
s
.38173 .04144 m
.37731 .02582 L
s
.35387 .03245 m
.35829 .04808 L
s
.26272 .12171 m
.30814 .00869 L
s
.38173 .04144 m
.35829 .04808 L
s
.37731 .02582 m
.35387 .03245 L
s
.38173 .04144 m
.3689 .04085 L
s
.35829 .04808 m
.3689 .04085 L
s
newpath
.30814 .00869 .00457 0 365.73 arc
s
newpath
.30814 .00869 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.26747 .1291 .00609 0 365.73 arc
s
newpath
.36627 .05786 .00609 0 365.73 arc
s
newpath
.36927 .03738 .00609 0 365.73 arc
s
.26391 .12416 m
.3627 .05292 L
s
.27103 .13404 m
.36983 .0628 L
s
.37229 .05875 m
.3753 .03826 L
s
.36024 .05698 m
.36325 .03649 L
s
.38211 .03772 m
.37739 .02218 L
s
.35408 .02926 m
.3588 .0448 L
s
.26747 .1291 m
.30029 .0118 L
s
.38211 .03772 m
.3588 .0448 L
s
.37739 .02218 m
.35408 .02926 L
s
.38211 .03772 m
.36927 .03738 L
s
.3588 .0448 m
.36927 .03738 L
s
newpath
.30029 .0118 .00457 0 365.73 arc
s
newpath
.30029 .0118 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.27396 .137 .00609 0 365.73 arc
s
newpath
.36302 .05391 .00609 0 365.73 arc
s
newpath
.36963 .03429 .00609 0 365.73 arc
s
.26981 .13255 m
.35886 .04946 L
s
.27812 .14146 m
.36717 .05836 L
s
.36879 .05585 m
.3754 .03623 L
s
.35725 .05197 m
.36386 .03234 L
s
.38247 .0342 m
.37723 .01883 L
s
.35417 .02668 m
.35941 .04205 L
s
.27396 .137 m
.29196 .01654 L
s
.38247 .0342 m
.35941 .04205 L
s
.37723 .01883 m
.35417 .02668 L
s
.38247 .0342 m
.36963 .03429 L
s
.35941 .04205 m
.36963 .03429 L
s
newpath
.29196 .01654 .00457 0 365.73 arc
s
newpath
.29196 .01654 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.284 .14611 .00609 0 365.73 arc
s
newpath
.358 .04936 .00609 0 365.73 arc
s
newpath
.36965 .03224 .00609 0 365.73 arc
s
.27916 .14241 m
.35316 .04566 L
s
.28884 .14981 m
.36284 .05306 L
s
.36303 .05279 m
.37469 .03567 L
s
.35297 .04593 m
.36462 .02881 L
s
.38242 .03087 m
.37567 .0161 L
s
.35351 .02623 m
.36026 .041 L
s
.284 .14611 m
.28257 .02431 L
s
.38242 .03087 m
.36026 .041 L
s
.37567 .0161 m
.35351 .02623 L
s
.38242 .03087 m
.36965 .03224 L
s
.36026 .041 m
.36965 .03224 L
s
newpath
.28257 .02431 .00457 0 365.73 arc
s
newpath
.28257 .02431 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29549 .15345 .00609 0 365.73 arc
s
newpath
.35226 .04569 .00609 0 365.73 arc
s
newpath
.36821 .03249 .00609 0 365.73 arc
s
.2901 .15061 m
.34687 .04285 L
s
.30087 .15629 m
.35765 .04853 L
s
.35614 .05038 m
.37209 .03718 L
s
.34837 .04099 m
.36433 .02779 L
s
.38009 .02763 m
.36951 .01531 L
s
.35103 .03119 m
.36162 .04351 L
s
.29549 .15345 m
.27292 .03376 L
s
.38009 .02763 m
.36162 .04351 L
s
.36951 .01531 m
.35103 .03119 L
s
.38009 .02763 m
.36821 .03249 L
s
.36162 .04351 m
.36821 .03249 L
s
newpath
.27292 .03376 .00457 0 365.73 arc
s
newpath
.27292 .03376 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.30469 .15759 .00609 0 365.73 arc
s
newpath
.34765 .04362 .00609 0 365.73 arc
s
newpath
.36553 .03316 .00609 0 365.73 arc
s
.29899 .15544 m
.34195 .04147 L
s
.31039 .15974 m
.35335 .04576 L
s
.35073 .04887 m
.3686 .03842 L
s
.34458 .03836 m
.36245 .02791 L
s
.37477 .02425 m
.36037 .01673 L
s
.34909 .03832 m
.36349 .04584 L
s
.30469 .15759 m
.26338 .04301 L
s
.37477 .02425 m
.36349 .04584 L
s
.36037 .01673 m
.34909 .03832 L
s
.37477 .02425 m
.36553 .03316 L
s
.36349 .04584 m
.36553 .03316 L
s
newpath
.26338 .04301 .00457 0 365.73 arc
s
newpath
.26338 .04301 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31257 .16011 .00609 0 365.73 arc
s
newpath
.34372 .04236 .00609 0 365.73 arc
s
newpath
.36237 .03338 .00609 0 365.73 arc
s
.30668 .15855 m
.33783 .0408 L
s
.31846 .16167 m
.3496 .04391 L
s
.34636 .04784 m
.36501 .03887 L
s
.34107 .03687 m
.35973 .02789 L
s
.36767 .02168 m
.35151 .02001 L
s
.349 .04424 m
.36516 .04591 L
s
.31257 .16011 m
.25451 .05304 L
s
.36767 .02168 m
.36516 .04591 L
s
.35151 .02001 m
.349 .04424 L
s
.36767 .02168 m
.36237 .03338 L
s
.36516 .04591 m
.36237 .03338 L
s
newpath
.25451 .05304 .00457 0 365.73 arc
s
newpath
.25451 .05304 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32048 .16179 .00609 0 365.73 arc
s
newpath
.33976 .04152 .00609 0 365.73 arc
s
newpath
.35871 .03318 .00609 0 365.73 arc
s
.31447 .16082 m
.33375 .04055 L
s
.3265 .16275 m
.34577 .04248 L
s
.34221 .04709 m
.36116 .03875 L
s
.33731 .03594 m
.35626 .0276 L
s
.35907 .02034 m
.34352 .02505 L
s
.35058 .04836 m
.36612 .04366 L
s
.32048 .16179 m
.24605 .06537 L
s
.35907 .02034 m
.36612 .04366 L
s
.34352 .02505 m
.35058 .04836 L
s
.35907 .02034 m
.35871 .03318 L
s
.36612 .04366 m
.35871 .03318 L
s
newpath
.24605 .06537 .00457 0 365.73 arc
s
newpath
.24605 .06537 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32818 .16265 .00609 0 365.73 arc
s
newpath
.33591 .04109 .00609 0 365.73 arc
s
newpath
.35483 .03267 .00609 0 365.73 arc
s
.32211 .16226 m
.32983 .0407 L
s
.33426 .16303 m
.34199 .04147 L
s
.33838 .04665 m
.3573 .03824 L
s
.33343 .03552 m
.35235 .02711 L
s
.35011 .02073 m
.33767 .03117 L
s
.35332 .04983 m
.36577 .0394 L
s
.32818 .16265 m
.23896 .07973 L
s
.35011 .02073 m
.36577 .0394 L
s
.33767 .03117 m
.35332 .04983 L
s
.35011 .02073 m
.35483 .03267 L
s
.36577 .0394 m
.35483 .03267 L
s
newpath
.23896 .07973 .00457 0 365.73 arc
s
newpath
.23896 .07973 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.33543 .16278 .00609 0 365.73 arc
s
newpath
.33228 .04102 .00609 0 365.73 arc
s
newpath
.35094 .03204 .00609 0 365.73 arc
s
.32935 .16294 m
.3262 .04118 L
s
.34152 .16262 m
.33837 .04086 L
s
.33492 .04651 m
.35358 .03753 L
s
.32964 .03553 m
.3483 .02655 L
s
.34182 .023 m
.33462 .03756 L
s
.35646 .04836 m
.36366 .0338 L
s
.33543 .16278 m
.23384 .09559 L
s
.34182 .023 m
.36366 .0338 L
s
.33462 .03756 m
.35646 .04836 L
s
.34182 .023 m
.35094 .03204 L
s
.36366 .0338 m
.35094 .03204 L
s
newpath
.23384 .09559 .00457 0 365.73 arc
s
newpath
.23384 .09559 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34187 .16236 .00609 0 365.73 arc
s
newpath
.32907 .04123 .00609 0 365.73 arc
s
newpath
.34733 .03148 .00609 0 365.73 arc
s
.33581 .163 m
.32301 .04187 L
s
.34792 .16172 m
.33512 .04059 L
s
.33194 .0466 m
.3502 .03685 L
s
.3262 .03586 m
.34446 .0261 L
s
.33533 .02691 m
.33465 .04313 L
s
.35899 .04416 m
.35967 .02793 L
s
.34187 .16236 m
.23096 .112 L
s
.33533 .02691 m
.35967 .02793 L
s
.33465 .04313 m
.35899 .04416 L
s
.33533 .02691 m
.34733 .03148 L
s
.35967 .02793 m
.34733 .03148 L
s
newpath
.23096 .112 .00457 0 365.73 arc
s
newpath
.23097 .112 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34785 .1615 .00609 0 365.73 arc
s
newpath
.32607 .04166 .00609 0 365.73 arc
s
newpath
.34388 .0311 .00609 0 365.73 arc
s
.34186 .16259 m
.32008 .04275 L
s
.35384 .16041 m
.33207 .04057 L
s
.32918 .0469 m
.34699 .03634 L
s
.32297 .03642 m
.34078 .02586 L
s
.33111 .0324 m
.33778 .04721 L
s
.35999 .03721 m
.35332 .0224 L
s
.34785 .1615 m
.23018 .13006 L
s
.33111 .0324 m
.35332 .0224 L
s
.33778 .04721 m
.35999 .03721 L
s
.33111 .0324 m
.34388 .0311 L
s
.35332 .0224 m
.34388 .0311 L
s
newpath
.23018 .13006 .00457 0 365.73 arc
s
newpath
.23018 .13006 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35278 .16045 .00609 0 365.73 arc
s
newpath
.32361 .04219 .00609 0 365.73 arc
s
newpath
.34105 .03102 .00609 0 365.73 arc
s
.34686 .16191 m
.3177 .04365 L
s
.35869 .15899 m
.32952 .04073 L
s
.3269 .04732 m
.34433 .03615 L
s
.32033 .03706 m
.33777 .02589 L
s
.33046 .03828 m
.34341 .04809 L
s
.35811 .02866 m
.34516 .01886 L
s
.35278 .16045 m
.23152 .14893 L
s
.33046 .03828 m
.34516 .01886 L
s
.34341 .04809 m
.35811 .02866 L
s
.33046 .03828 m
.34105 .03102 L
s
.34516 .01886 m
.34105 .03102 L
s
newpath
.23152 .14893 .00457 0 365.73 arc
s
newpath
.23152 .14893 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35602 .15958 .00609 0 365.73 arc
s
newpath
.32199 .04262 .00609 0 365.73 arc
s
newpath
.33919 .03109 .00609 0 365.73 arc
s
.35017 .16128 m
.31614 .04432 L
s
.36186 .15788 m
.32784 .04092 L
s
.32538 .04768 m
.34258 .03615 L
s
.3186 .03756 m
.3358 .02604 L
s
.33346 .04258 m
.34954 .04486 L
s
.35296 .02074 m
.33688 .01846 L
s
.35602 .15958 m
.23449 .16772 L
s
.33346 .04258 m
.33688 .01846 L
s
.34954 .04486 m
.35296 .02074 L
s
.33346 .04258 m
.33919 .03109 L
s
.33688 .01846 m
.33919 .03109 L
s
newpath
.23449 .16772 .00457 0 365.73 arc
s
newpath
.23449 .16772 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35722 .15922 .00609 0 365.73 arc
s
newpath
.32139 .0428 .00609 0 365.73 arc
s
newpath
.33836 .03093 .00609 0 365.73 arc
s
.35139 .16101 m
.31557 .04459 L
s
.36304 .15743 m
.32721 .04101 L
s
.32488 .04779 m
.34185 .03592 L
s
.3179 .03781 m
.33487 .02594 L
s
.33854 .04377 m
.35387 .03842 L
s
.34585 .01542 m
.33051 .02077 L
s
.35722 .15922 m
.23824 .18532 L
s
.33854 .04377 m
.33051 .02077 L
s
.35387 .03842 m
.34585 .01542 L
s
.33854 .04377 m
.33836 .03093 L
s
.33051 .02077 m
.33836 .03093 L
s
newpath
.23824 .18532 .00457 0 365.73 arc
s
newpath
.23825 .18532 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3564 .15946 .00609 0 365.73 arc
s
newpath
.3218 .04268 .00609 0 365.73 arc
s
newpath
.33826 .03012 .00609 0 365.73 arc
s
.35056 .16119 m
.31596 .04441 L
s
.36224 .15773 m
.32764 .04095 L
s
.32549 .04752 m
.34196 .03497 L
s
.31811 .03784 m
.33457 .02528 L
s
.3444 .0414 m
.35548 .02953 L
s
.33767 .01291 m
.32659 .02478 L
s
.3564 .15946 m
.24272 .2032 L
s
.3444 .0414 m
.32659 .02478 L
s
.35548 .02953 m
.33767 .01291 L
s
.3444 .0414 m
.33826 .03012 L
s
.32659 .02478 m
.33826 .03012 L
s
newpath
.24272 .2032 .00457 0 365.73 arc
s
newpath
.24272 .2032 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35324 .16033 .00609 0 365.73 arc
s
newpath
.32338 .04225 .00609 0 365.73 arc
s
newpath
.33864 .02825 .00609 0 365.73 arc
s
.34733 .16183 m
.31748 .04374 L
s
.35914 .15884 m
.32929 .04075 L
s
.3275 .04673 m
.34276 .03274 L
s
.31927 .03776 m
.33453 .02376 L
s
.34939 .03528 m
.35352 .01958 L
s
.32997 .01337 m
.32583 .02907 L
s
.35324 .16033 m
.24779 .2213 L
s
.34939 .03528 m
.32583 .02907 L
s
.35352 .01958 m
.32997 .01337 L
s
.34939 .03528 m
.33864 .02825 L
s
.32583 .02907 m
.33864 .02825 L
s
newpath
.24779 .2213 .00457 0 365.73 arc
s
newpath
.24779 .2213 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34718 .16162 .00609 0 365.73 arc
s
newpath
.32641 .0416 .00609 0 365.73 arc
s
newpath
.33903 .02519 .00609 0 365.73 arc
s
.34118 .16266 m
.32041 .04264 L
s
.35318 .16058 m
.33241 .04056 L
s
.33124 .04531 m
.34386 .0289 L
s
.32158 .03789 m
.3342 .02147 L
s
.35182 .02628 m
.34802 .01049 L
s
.32433 .0162 m
.32814 .03199 L
s
.34718 .16162 m
.25314 .23903 L
s
.35182 .02628 m
.32814 .03199 L
s
.34802 .01049 m
.32433 .0162 L
s
.35182 .02628 m
.33903 .02519 L
s
.32814 .03199 m
.33903 .02519 L
s
newpath
.25314 .23903 .00457 0 365.73 arc
s
newpath
.25314 .23903 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.33659 .16274 .00609 0 365.73 arc
s
newpath
.33171 .04104 .00609 0 365.73 arc
s
newpath
.33875 .02157 .00609 0 365.73 arc
s
.3305 .16299 m
.32562 .04128 L
s
.34267 .1625 m
.33779 .0408 L
s
.33743 .04311 m
.34448 .02364 L
s
.32598 .03897 m
.33303 .0195 L
s
.35051 .01642 m
.33963 .00437 L
s
.32155 .02069 m
.33243 .03275 L
s
.33659 .16274 m
.25805 .25585 L
s
.35051 .01642 m
.33243 .03275 L
s
.33963 .00437 m
.32155 .02069 L
s
.35051 .01642 m
.33875 .02157 L
s
.33243 .03275 m
.33875 .02157 L
s
newpath
.25805 .25585 .00457 0 365.73 arc
s
newpath
.25806 .25584 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.37338 .15225 .00609 0 365.73 arc
s
newpath
.31331 .04629 .00609 0 365.73 arc
s
newpath
.33384 .04901 .00609 0 365.73 arc
s
.36808 .15525 m
.30801 .04929 L
s
.37868 .14925 m
.31861 .04328 L
s
.31251 .05232 m
.33304 .05504 L
s
.31411 .04025 m
.33464 .04297 L
s
.33724 .03663 m
.32102 .0375 L
s
.32233 .06183 m
.33855 .06095 L
s
.37338 .15225 m
.3132 .25815 L
s
.33724 .03663 m
.33855 .06095 L
s
.32102 .0375 m
.32233 .06183 L
s
.33724 .03663 m
.33384 .04901 L
s
.33855 .06095 m
.33384 .04901 L
s
newpath
.3132 .25815 .00457 0 365.73 arc
s
newpath
.3107 .29651 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3793 .14855 .00609 0 365.73 arc
s
newpath
.31035 .04814 .00609 0 365.73 arc
s
newpath
.32566 .0342 .00609 0 365.73 arc
s
.37428 .15199 m
.30533 .05159 L
s
.38432 .1451 m
.31537 .04469 L
s
.31445 .05264 m
.32976 .0387 L
s
.30625 .04364 m
.32156 .0297 L
s
.3132 .0311 m
.31447 .04729 L
s
.33876 .04539 m
.33749 .0292 L
s
.3793 .14855 m
.31853 .25411 L
s
.3132 .0311 m
.33749 .0292 L
s
.31447 .04729 m
.33876 .04539 L
s
.3132 .0311 m
.32566 .0342 L
s
.33749 .0292 m
.32566 .0342 L
s
newpath
.31853 .25411 .00457 0 365.73 arc
s
newpath
.32093 .30069 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.37746 .14977 .00609 0 365.73 arc
s
newpath
.31127 .04752 .00609 0 365.73 arc
s
newpath
.31735 .02773 .00609 0 365.73 arc
s
.37235 .15308 m
.30616 .05083 L
s
.38257 .14646 m
.31638 .04422 L
s
.31709 .04931 m
.32317 .02952 L
s
.30545 .04574 m
.31152 .02594 L
s
.31424 .04019 m
.33043 .03893 L
s
.32855 .01464 m
.31236 .0159 L
s
.37746 .14977 m
.31958 .25694 L
s
.31424 .04019 m
.31236 .0159 L
s
.33043 .03893 m
.32855 .01464 L
s
.31424 .04019 m
.31735 .02773 L
s
.31236 .0159 m
.31735 .02773 L
s
newpath
.31958 .25694 .00457 0 365.73 arc
s
newpath
.33127 .30442 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35967 .15842 .00609 0 365.73 arc
s
newpath
.32017 .0432 .00609 0 365.73 arc
s
newpath
.3161 .0229 .00609 0 365.73 arc
s
.35391 .1604 m
.3144 .04518 L
s
.36543 .15644 m
.32593 .04123 L
s
.32614 .04201 m
.32207 .0217 L
s
.31419 .0444 m
.31013 .0241 L
s
.32839 .0266 m
.32792 .01037 L
s
.30357 .01108 m
.30404 .02731 L
s
.35967 .15842 m
.31413 .27139 L
s
.32839 .0266 m
.30404 .02731 L
s
.32792 .01037 m
.30357 .01108 L
s
.32839 .0266 m
.3161 .0229 L
s
.30404 .02731 m
.3161 .0229 L
s
newpath
.31413 .27139 .00457 0 365.73 arc
s
newpath
.34227 .30786 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35932 .15854 .00609 0 365.73 arc
s
newpath
.32034 .04314 .00609 0 365.73 arc
s
newpath
.32811 .06234 .00609 0 365.73 arc
s
.35356 .16049 m
.31457 .04509 L
s
.36509 .15659 m
.32611 .04119 L
s
.31469 .04543 m
.32246 .06462 L
s
.32598 .04086 m
.33375 .06005 L
s
.32034 .05211 m
.31118 .06552 L
s
.33129 .07927 m
.34045 .06586 L
s
.35932 .15854 m
.29531 .26216 L
s
.32034 .05211 m
.34045 .06586 L
s
.31118 .06552 m
.33129 .07927 L
s
.32034 .05211 m
.32811 .06234 L
s
.34045 .06586 m
.32811 .06234 L
s
newpath
.29531 .26216 .00457 0 365.73 arc
s
newpath
.41158 .3167 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.36613 .15589 .00609 0 365.73 arc
s
newpath
.31693 .04447 .00609 0 365.73 arc
s
newpath
.32382 .06399 .00609 0 365.73 arc
s
.36056 .15835 m
.31136 .04693 L
s
.37171 .15343 m
.3225 .04201 L
s
.31119 .04649 m
.31808 .06602 L
s
.32268 .04244 m
.32956 .06197 L
s
.31214 .06933 m
.32321 .08121 L
s
.34103 .0646 m
.32997 .05272 L
s
.36613 .15589 m
.29418 .25417 L
s
.31214 .06933 m
.32997 .05272 L
s
.32321 .08121 m
.34103 .0646 L
s
.31214 .06933 m
.32382 .06399 L
s
.32997 .05272 m
.32382 .06399 L
s
newpath
.29418 .25417 .00457 0 365.73 arc
s
newpath
.42281 .31603 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.37317 .15237 .00609 0 365.73 arc
s
newpath
.31342 .04623 .00609 0 365.73 arc
s
newpath
.32179 .06517 .00609 0 365.73 arc
s
.36786 .15536 m
.30811 .04922 L
s
.37847 .14938 m
.31872 .04324 L
s
.30785 .04869 m
.31622 .06763 L
s
.31899 .04377 m
.32736 .0627 L
s
.32548 .07746 m
.33876 .06811 L
s
.32474 .0482 m
.31146 .05754 L
s
.37317 .15237 m
.294 .24494 L
s
.32548 .07746 m
.31146 .05754 L
s
.33876 .06811 m
.32474 .0482 L
s
.32548 .07746 m
.32179 .06517 L
s
.31146 .05754 m
.32179 .06517 L
s
newpath
.294 .24494 .00457 0 365.73 arc
s
newpath
.43418 .31475 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3788 .14889 .00609 0 365.73 arc
s
newpath
.3106 .04797 .00609 0 365.73 arc
s
newpath
.32532 .06253 .00609 0 365.73 arc
s
.37375 .1523 m
.30555 .05138 L
s
.38384 .14548 m
.31565 .04456 L
s
.30632 .0523 m
.32104 .06686 L
s
.31488 .04364 m
.3296 .0582 L
s
.3381 .06133 m
.33155 .04647 L
s
.30926 .0563 m
.31581 .07116 L
s
.3788 .14889 m
.29387 .23619 L
s
.3381 .06133 m
.31581 .07116 L
s
.33155 .04647 m
.30926 .0563 L
s
.3381 .06133 m
.32532 .06253 L
s
.31581 .07116 m
.32532 .06253 L
s
newpath
.29387 .23619 .00457 0 365.73 arc
s
newpath
.4451 .31295 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.38537 .14394 .00609 0 365.73 arc
s
newpath
.30731 .05044 .00609 0 365.73 arc
s
newpath
.32748 .05512 .00609 0 365.73 arc
s
.3807 .14785 m
.30264 .05434 L
s
.39005 .14004 m
.31199 .04654 L
s
.30594 .05637 m
.32611 .06105 L
s
.30869 .04451 m
.32886 .04919 L
s
.32883 .04235 m
.31297 .04584 L
s
.31821 .06963 m
.33407 .06614 L
s
.38537 .14394 m
.2953 .22594 L
s
.32883 .04235 m
.33407 .06614 L
s
.31297 .04584 m
.31821 .06963 L
s
.32883 .04235 m
.32748 .05512 L
s
.33407 .06614 m
.32748 .05512 L
s
newpath
.2953 .22594 .00457 0 365.73 arc
s
newpath
.45626 .31053 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.39302 .13667 .00609 0 365.73 arc
s
newpath
.30349 .05408 .00609 0 365.73 arc
s
newpath
.32352 .04884 .00609 0 365.73 arc
s
.38889 .14114 m
.29936 .05856 L
s
.39715 .13219 m
.30762 .0496 L
s
.30503 .05997 m
.32506 .05473 L
s
.30195 .04819 m
.32198 .04295 L
s
.3109 .0465 m
.31314 .06259 L
s
.33727 .05922 m
.33503 .04314 L
s
.39302 .13667 m
.29879 .21385 L
s
.3109 .0465 m
.33503 .04314 L
s
.31314 .06259 m
.33727 .05922 L
s
.3109 .0465 m
.32352 .04884 L
s
.33503 .04314 m
.32352 .04884 L
s
newpath
.29879 .21385 .00457 0 365.73 arc
s
newpath
.46806 .30732 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.39787 .13089 .00609 0 365.73 arc
s
newpath
.30107 .05697 .00609 0 365.73 arc
s
newpath
.32048 .04976 .00609 0 365.73 arc
s
.39417 .13573 m
.29737 .06181 L
s
.40156 .12605 m
.30476 .05213 L
s
.30319 .06267 m
.3226 .05547 L
s
.29895 .05126 m
.31836 .04405 L
s
.31743 .06223 m
.33362 .0609 L
s
.33162 .03662 m
.31543 .03795 L
s
.39787 .13089 m
.30026 .20376 L
s
.31743 .06223 m
.31543 .03795 L
s
.33362 .0609 m
.33162 .03662 L
s
.31743 .06223 m
.32048 .04976 L
s
.31543 .03795 m
.32048 .04976 L
s
newpath
.30026 .20376 .00457 0 365.73 arc
s
newpath
.47999 .30342 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.39407 .13551 .00609 0 365.73 arc
s
newpath
.30297 .05466 .00609 0 365.73 arc
s
newpath
.32325 .05048 .00609 0 365.73 arc
s
.39002 .14006 m
.29892 .05921 L
s
.39811 .13095 m
.30701 .0501 L
s
.3042 .06062 m
.32448 .05645 L
s
.30174 .04869 m
.32202 .04452 L
s
.33524 .05506 m
.33594 .03883 L
s
.3116 .03779 m
.31091 .05402 L
s
.39407 .13551 m
.29163 .2014 L
s
.33524 .05506 m
.31091 .05402 L
s
.33594 .03883 m
.3116 .03779 L
s
.33524 .05506 m
.32325 .05048 L
s
.31091 .05402 m
.32325 .05048 L
s
newpath
.29163 .2014 .00457 0 365.73 arc
s
newpath
.49159 .29897 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.38707 .14249 .00609 0 365.73 arc
s
newpath
.30647 .05117 .00609 0 365.73 arc
s
newpath
.32594 .04411 .00609 0 365.73 arc
s
.3825 .14652 m
.3019 .0552 L
s
.39163 .13846 m
.31103 .04714 L
s
.30854 .05689 m
.32801 .04984 L
s
.30439 .04544 m
.32386 .03839 L
s
.33196 .03278 m
.31595 .03008 L
s
.3119 .0541 m
.32791 .0568 L
s
.38707 .14249 m
.28035 .20121 L
s
.33196 .03278 m
.32791 .0568 L
s
.31595 .03008 m
.3119 .0541 L
s
.33196 .03278 m
.32594 .04411 L
s
.32791 .0568 m
.32594 .04411 L
s
newpath
.28035 .20121 .00457 0 365.73 arc
s
newpath
.50315 .2939 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.38478 .14443 .00609 0 365.73 arc
s
newpath
.30761 .05019 .00609 0 365.73 arc
s
newpath
.32224 .03554 .00609 0 365.73 arc
s
.38007 .14829 m
.3029 .05405 L
s
.38949 .14058 m
.31232 .04634 L
s
.31192 .0545 m
.32655 .03984 L
s
.3033 .04589 m
.31792 .03123 L
s
.31113 .0291 m
.30784 .045 L
s
.3317 .04993 m
.33498 .03402 L
s
.38478 .14443 m
.27497 .19715 L
s
.31113 .0291 m
.33498 .03402 L
s
.30784 .045 m
.3317 .04993 L
s
.31113 .0291 m
.32224 .03554 L
s
.33498 .03402 m
.32224 .03554 L
s
newpath
.27497 .19715 .00457 0 365.73 arc
s
newpath
.5155 .28778 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3872 .14237 .00609 0 365.73 arc
s
newpath
.3064 .05123 .00609 0 365.73 arc
s
newpath
.31763 .03383 .00609 0 365.73 arc
s
.38265 .14641 m
.30184 .05527 L
s
.39176 .13833 m
.31096 .04719 L
s
.31152 .05453 m
.32274 .03713 L
s
.30128 .04793 m
.31251 .03053 L
s
.31133 .04502 m
.32728 .0481 L
s
.33189 .02418 m
.31595 .0211 L
s
.3872 .14237 m
.27509 .18999 L
s
.31133 .04502 m
.31595 .0211 L
s
.32728 .0481 m
.33189 .02418 L
s
.31133 .04502 m
.31763 .03383 L
s
.31595 .0211 m
.31763 .03383 L
s
newpath
.27509 .18999 .00457 0 365.73 arc
s
newpath
.52799 .28085 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.38485 .14437 .00609 0 365.73 arc
s
newpath
.30757 .05022 .00609 0 365.73 arc
s
newpath
.32054 .03408 .00609 0 365.73 arc
s
.38014 .14824 m
.30287 .05409 L
s
.38956 .14051 m
.31228 .04636 L
s
.31232 .05404 m
.32529 .0379 L
s
.30283 .04641 m
.31579 .03027 L
s
.3314 .04093 m
.33528 .02516 L
s
.31162 .01935 m
.30775 .03512 L
s
.38485 .14437 m
.26994 .18477 L
s
.3314 .04093 m
.30775 .03512 L
s
.33528 .02516 m
.31162 .01935 L
s
.3314 .04093 m
.32054 .03408 L
s
.30775 .03512 m
.32054 .03408 L
s
newpath
.26994 .18477 .00457 0 365.73 arc
s
newpath
.54026 .27332 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.37203 .153 .00609 0 365.73 arc
s
newpath
.31399 .04591 .00609 0 365.73 arc
s
newpath
.32451 .02808 .00609 0 365.73 arc
s
.36667 .1559 m
.30863 .04882 L
s
.37738 .15009 m
.31934 .04301 L
s
.31923 .04901 m
.32976 .03118 L
s
.30874 .04282 m
.31927 .02499 L
s
.33218 .01778 m
.31676 .0127 L
s
.30913 .03584 m
.32456 .04092 L
s
.37203 .153 m
.25407 .18336 L
s
.33218 .01778 m
.32456 .04092 L
s
.31676 .0127 m
.30913 .03584 L
s
.33218 .01778 m
.32451 .02808 L
s
.32456 .04092 m
.32451 .02808 L
s
newpath
.25407 .18336 .00457 0 365.73 arc
s
newpath
.55227 .26523 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34434 .16206 .00609 0 365.73 arc
s
newpath
.32783 .04138 .00609 0 365.73 arc
s
newpath
.32013 .02216 .00609 0 365.73 arc
s
.3383 .16289 m
.3218 .04221 L
s
.35037 .16124 m
.33387 .04056 L
s
.33349 .03912 m
.32578 .0199 L
s
.32218 .04365 m
.31447 .02443 L
s
.30871 .01629 m
.30623 .03234 L
s
.3303 .03606 m
.33279 .02001 L
s
.34434 .16206 m
.22476 .18522 L
s
.30871 .01629 m
.33279 .02001 L
s
.30623 .03234 m
.3303 .03606 L
s
.30871 .01629 m
.32013 .02216 L
s
.33279 .02001 m
.32013 .02216 L
s
newpath
.22476 .18522 .00457 0 365.73 arc
s
newpath
.56511 .25583 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32259 .1621 .00609 0 365.73 arc
s
newpath
.33871 .04136 .00609 0 365.73 arc
s
newpath
.31807 .03964 .00609 0 365.73 arc
s
.31655 .16129 m
.33267 .04056 L
s
.32862 .1629 m
.34474 .04217 L
s
.33921 .0353 m
.31858 .03357 L
s
.3382 .04743 m
.31757 .04571 L
s
.3199 .05235 m
.33442 .04508 L
s
.32351 .0233 m
.30899 .03057 L
s
.32259 .1621 m
.20326 .18653 L
s
.3199 .05235 m
.30899 .03057 L
s
.33442 .04508 m
.32351 .0233 L
s
.3199 .05235 m
.31807 .03964 L
s
.30899 .03057 m
.31807 .03964 L
s
newpath
.20326 .18653 .00457 0 365.73 arc
s
newpath
.57814 .24547 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.30609 .1581 .00609 0 365.73 arc
s
newpath
.34696 .04336 .00609 0 365.73 arc
s
newpath
.32759 .05069 .00609 0 365.73 arc
s
.30035 .15606 m
.34122 .04132 L
s
.31182 .16015 m
.35269 .0454 L
s
.3448 .03766 m
.32543 .04499 L
s
.34911 .04906 m
.32974 .05638 L
s
.33695 .0419 m
.32266 .03418 L
s
.31108 .05561 m
.32537 .06333 L
s
.30609 .1581 m
.18764 .18648 L
s
.33695 .0419 m
.32537 .06333 L
s
.32266 .03418 m
.31108 .05561 L
s
.33695 .0419 m
.32759 .05069 L
s
.32537 .06333 m
.32759 .05069 L
s
newpath
.18764 .18648 .00457 0 365.73 arc
s
newpath
.59108 .23437 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.3062 .15814 .00609 0 365.73 arc
s
newpath
.3469 .04334 .00609 0 365.73 arc
s
newpath
.32869 .05319 .00609 0 365.73 arc
s
.30046 .15611 m
.34116 .04131 L
s
.31194 .16018 m
.35264 .04538 L
s
.344 .03798 m
.32579 .04784 L
s
.3498 .0487 m
.33158 .05855 L
s
.31658 .04891 m
.31629 .06515 L
s
.34064 .06559 m
.34094 .04936 L
s
.3062 .15814 m
.18687 .18257 L
s
.31658 .04891 m
.34094 .04936 L
s
.31629 .06515 m
.34064 .06559 L
s
.31658 .04891 m
.32869 .05319 L
s
.34094 .04936 m
.32869 .05319 L
s
newpath
.18687 .18257 .00457 0 365.73 arc
s
newpath
.60359 .22287 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.34243 .1623 .00609 0 365.73 arc
s
newpath
.32879 .04126 .00609 0 365.73 arc
s
newpath
.33686 .06033 .00609 0 365.73 arc
s
.33638 .16298 m
.32273 .04194 L
s
.34848 .16162 m
.33484 .04058 L
s
.32318 .04364 m
.33125 .0627 L
s
.33439 .03889 m
.34247 .05795 L
s
.34589 .06945 m
.35323 .05496 L
s
.3315 .04396 m
.32416 .05845 L
s
.34243 .1623 m
.22097 .17137 L
s
.34589 .06945 m
.32416 .05845 L
s
.35323 .05496 m
.3315 .04396 L
s
.34589 .06945 m
.33686 .06033 L
s
.32416 .05845 m
.33686 .06033 L
s
newpath
.22097 .17137 .00457 0 365.73 arc
s
newpath
.61684 .20986 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.33781 .16269 .00609 0 365.73 arc
s
newpath
.3311 .04107 .00609 0 365.73 arc
s
newpath
.34073 .02274 .00609 0 365.73 arc
s
.33173 .16302 m
.32502 .0414 L
s
.34389 .16235 m
.33718 .04073 L
s
.33649 .0439 m
.34612 .02557 L
s
.32571 .03824 m
.33534 .01991 L
s
.32904 .02804 m
.34008 .03995 L
s
.35794 .02339 m
.3469 .01148 L
s
.33781 .16269 m
.21603 .16024 L
s
.32904 .02804 m
.3469 .01148 L
s
.34008 .03995 m
.35794 .02339 L
s
.32904 .02804 m
.34073 .02274 L
s
.3469 .01148 m
.34073 .02274 L
s
newpath
.21603 .16024 .00457 0 365.73 arc
s
newpath
.63042 .19564 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.2994 .15538 .00609 0 365.73 arc
s
newpath
.3503 .04472 .00609 0 365.73 arc
s
newpath
.34309 .02531 .00609 0 365.73 arc
s
.29387 .15283 m
.34477 .04218 L
s
.30493 .15792 m
.35583 .04727 L
s
.35601 .0426 m
.3488 .02319 L
s
.34459 .04684 m
.33738 .02743 L
s
.35592 .02475 m
.35011 .00958 L
s
.32736 .01829 m
.33317 .03346 L
s
.2994 .15538 m
.17773 .14979 L
s
.35592 .02475 m
.33317 .03346 L
s
.35011 .00958 m
.32736 .01829 L
s
.35592 .02475 m
.34309 .02531 L
s
.33317 .03346 m
.34309 .02531 L
s
newpath
.17773 .14979 .00457 0 365.73 arc
s
newpath
.64402 .18051 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.30174 .15641 .00609 0 365.73 arc
s
newpath
.34913 .04421 .00609 0 365.73 arc
s
newpath
.34408 .02412 .00609 0 365.73 arc
s
.29613 .15404 m
.34352 .04184 L
s
.30735 .15878 m
.35474 .04657 L
s
.35504 .04272 m
.34999 .02264 L
s
.34322 .04569 m
.33817 .02561 L
s
.33625 .01395 m
.32717 .02742 L
s
.34738 .04103 m
.35645 .02756 L
s
.30174 .15641 m
.18086 .14144 L
s
.33625 .01395 m
.35645 .02756 L
s
.32717 .02742 m
.34738 .04103 L
s
.33625 .01395 m
.34408 .02412 L
s
.35645 .02756 m
.34408 .02412 L
s
newpath
.18086 .14144 .00457 0 365.73 arc
s
newpath
.65703 .16518 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29639 .15392 .00609 0 365.73 arc
s
newpath
.3518 .04545 .00609 0 365.73 arc
s
newpath
.33781 .03018 .00609 0 365.73 arc
s
.29097 .15115 m
.34638 .04268 L
s
.30182 .15669 m
.35723 .04822 L
s
.35629 .04134 m
.3423 .02607 L
s
.34731 .04957 m
.33332 .0343 L
s
.33476 .04265 m
.35095 .04133 L
s
.34896 .01705 m
.33278 .01837 L
s
.29639 .15392 m
.17674 .13117 L
s
.33476 .04265 m
.33278 .01837 L
s
.35095 .04133 m
.34896 .01705 L
s
.33476 .04265 m
.33781 .03018 L
s
.33278 .01837 m
.33781 .03018 L
s
newpath
.17674 .13117 .00457 0 365.73 arc
s
newpath
.67067 .14824 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.28607 .14764 .00609 0 365.73 arc
s
newpath
.35697 .04859 .00609 0 365.73 arc
s
newpath
.34446 .03209 .00609 0 365.73 arc
s
.28112 .14409 m
.35201 .04505 L
s
.29102 .15118 m
.36192 .05214 L
s
.36182 .04492 m
.34931 .02841 L
s
.35211 .05227 m
.33961 .03577 L
s
.35544 .02544 m
.34306 .01492 L
s
.32729 .03349 m
.33967 .044 L
s
.28607 .14764 m
.16746 .11994 L
s
.35544 .02544 m
.33967 .044 L
s
.34306 .01492 m
.32729 .03349 L
s
.35544 .02544 m
.34446 .03209 L
s
.33967 .044 m
.34446 .03209 L
s
newpath
.16746 .11994 .00457 0 365.73 arc
s
newpath
.68479 .12974 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29948 .15542 .00609 0 365.73 arc
s
newpath
.35026 .0447 .00609 0 365.73 arc
s
newpath
.34296 .02533 .00609 0 365.73 arc
s
.29395 .15288 m
.34472 .04216 L
s
.30502 .15796 m
.35579 .04724 L
s
.35596 .04256 m
.34865 .02318 L
s
.34456 .04685 m
.33726 .02748 L
s
.33047 .02235 m
.33189 .03853 L
s
.35616 .03639 m
.35473 .02022 L
s
.29948 .15542 m
.18465 .11479 L
s
.33047 .02235 m
.35473 .02022 L
s
.33189 .03853 m
.35616 .03639 L
s
.33047 .02235 m
.34296 .02533 L
s
.35473 .02022 m
.34296 .02533 L
s
newpath
.18465 .11479 .00457 0 365.73 arc
s
newpath
.69902 .11011 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.29713 .15429 .00609 0 365.73 arc
s
newpath
.35143 .04526 .00609 0 365.73 arc
s
newpath
.34161 .02704 .00609 0 365.73 arc
s
.29168 .15158 m
.34598 .04255 L
s
.30258 .15701 m
.35689 .04798 L
s
.35679 .04237 m
.34697 .02415 L
s
.34607 .04816 m
.33625 .02993 L
s
.34764 .03837 m
.35883 .0266 L
s
.34116 .00982 m
.32998 .02159 L
s
.29713 .15429 m
.18607 .10429 L
s
.34764 .03837 m
.32998 .02159 L
s
.35883 .0266 m
.34116 .00982 L
s
.34764 .03837 m
.34161 .02704 L
s
.32998 .02159 m
.34161 .02704 L
s
newpath
.18607 .10429 .00457 0 365.73 arc
s
newpath
.71258 .09049 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32256 .16209 .00609 0 365.73 arc
s
newpath
.33872 .04137 .00609 0 365.73 arc
s
newpath
.34955 .02372 .00609 0 365.73 arc
s
.31652 .16128 m
.33268 .04056 L
s
.3286 .1629 m
.34476 .04217 L
s
.34391 .04455 m
.35474 .0269 L
s
.33353 .03818 m
.34436 .02053 L
s
.34928 .01088 m
.33399 .01634 L
s
.34217 .03928 m
.35747 .03383 L
s
.32256 .16209 m
.21351 .10784 L
s
.34928 .01088 m
.35747 .03383 L
s
.33399 .01634 m
.34217 .03928 L
s
.34928 .01088 m
.34955 .02372 L
s
.35747 .03383 m
.34955 .02372 L
s
newpath
.21351 .10784 .00457 0 365.73 arc
s
newpath
.72656 .06931 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.35694 .1593 .00609 0 365.73 arc
s
newpath
.32153 .04276 .00609 0 365.73 arc
s
newpath
.33864 .05443 .00609 0 365.73 arc
s
.35111 .16107 m
.3157 .04453 L
s
.36276 .15753 m
.32736 .04099 L
s
.3181 .04779 m
.3352 .05946 L
s
.32496 .03773 m
.34207 .0494 L
s
.34853 .06261 m
.35439 .04746 L
s
.33167 .03868 m
.32581 .05383 L
s
.35694 .1593 m
.2411 .12164 L
s
.34853 .06261 m
.32581 .05383 L
s
.35439 .04746 m
.33167 .03868 L
s
.34853 .06261 m
.33864 .05443 L
s
.32581 .05383 m
.33864 .05443 L
s
newpath
.2411 .12164 .00457 0 365.73 arc
s
newpath
.74121 .04611 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.31367 .16039 .00609 0 365.73 arc
s
newpath
.34316 .04221 .00609 0 365.73 arc
s
newpath
.32557 .05314 .00609 0 365.73 arc
s
.30776 .15892 m
.33725 .04074 L
s
.31958 .16187 m
.34907 .04369 L
s
.33995 .03704 m
.32236 .04797 L
s
.34638 .04739 m
.32879 .05831 L
s
.31341 .04904 m
.31335 .06528 L
s
.33771 .06536 m
.33777 .04912 L
s
.31367 .16039 m
.20215 .11143 L
s
.31341 .04904 m
.33777 .04912 L
s
.31335 .06528 m
.33771 .06536 L
s
.31341 .04904 m
.32557 .05314 L
s
.33777 .04912 m
.32557 .05314 L
s
newpath
.20215 .11143 .00457 0 365.73 arc
s
newpath
.75597 .02167 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.333333 0.00812018 0 0.00812018 [
[.00853 -0.0125 -9 -9 ]
[.00853 -0.0125 9 0 ]
[.17093 -0.0125 -9 -9 ]
[.17093 -0.0125 9 0 ]
[.49574 -0.0125 -6 -9 ]
[.49574 -0.0125 6 0 ]
[.65814 -0.0125 -6 -9 ]
[.65814 -0.0125 6 0 ]
[.82054 -0.0125 -6 -9 ]
[.82054 -0.0125 6 0 ]
[.98295 -0.0125 -6 -9 ]
[.98295 -0.0125 6 0 ]
[.32083 .0812 -12 -4.5 ]
[.32083 .0812 0 4.5 ]
[.32083 .1624 -12 -4.5 ]
[.32083 .1624 0 4.5 ]
[.32083 .24361 -12 -4.5 ]
[.32083 .24361 0 4.5 ]
[.32083 .32481 -12 -4.5 ]
[.32083 .32481 0 4.5 ]
[.32083 .40601 -12 -4.5 ]
[.32083 .40601 0 4.5 ]
[.32083 .48721 -12 -4.5 ]
[.32083 .48721 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.00853 0 m
.00853 .00625 L
s
[(-40)] .00853 -0.0125 0 1 Mshowa
.17093 0 m
.17093 .00625 L
s
[(-20)] .17093 -0.0125 0 1 Mshowa
.49574 0 m
.49574 .00625 L
s
[(20)] .49574 -0.0125 0 1 Mshowa
.65814 0 m
.65814 .00625 L
s
[(40)] .65814 -0.0125 0 1 Mshowa
.82054 0 m
.82054 .00625 L
s
[(60)] .82054 -0.0125 0 1 Mshowa
.98295 0 m
.98295 .00625 L
s
[(80)] .98295 -0.0125 0 1 Mshowa
.125 Mabswid
.04913 0 m
.04913 .00375 L
s
.08973 0 m
.08973 .00375 L
s
.13033 0 m
.13033 .00375 L
s
.21153 0 m
.21153 .00375 L
s
.25213 0 m
.25213 .00375 L
s
.29273 0 m
.29273 .00375 L
s
.37393 0 m
.37393 .00375 L
s
.41454 0 m
.41454 .00375 L
s
.45514 0 m
.45514 .00375 L
s
.53634 0 m
.53634 .00375 L
s
.57694 0 m
.57694 .00375 L
s
.61754 0 m
.61754 .00375 L
s
.69874 0 m
.69874 .00375 L
s
.73934 0 m
.73934 .00375 L
s
.77994 0 m
.77994 .00375 L
s
.86114 0 m
.86114 .00375 L
s
.90175 0 m
.90175 .00375 L
s
.94235 0 m
.94235 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.33333 .0812 m
.33958 .0812 L
s
[(10)] .32083 .0812 1 0 Mshowa
.33333 .1624 m
.33958 .1624 L
s
[(20)] .32083 .1624 1 0 Mshowa
.33333 .24361 m
.33958 .24361 L
s
[(30)] .32083 .24361 1 0 Mshowa
.33333 .32481 m
.33958 .32481 L
s
[(40)] .32083 .32481 1 0 Mshowa
.33333 .40601 m
.33958 .40601 L
s
[(50)] .32083 .40601 1 0 Mshowa
.33333 .48721 m
.33958 .48721 L
s
[(60)] .32083 .48721 1 0 Mshowa
.125 Mabswid
.33333 .01624 m
.33708 .01624 L
s
.33333 .03248 m
.33708 .03248 L
s
.33333 .04872 m
.33708 .04872 L
s
.33333 .06496 m
.33708 .06496 L
s
.33333 .09744 m
.33708 .09744 L
s
.33333 .11368 m
.33708 .11368 L
s
.33333 .12992 m
.33708 .12992 L
s
.33333 .14616 m
.33708 .14616 L
s
.33333 .17864 m
.33708 .17864 L
s
.33333 .19488 m
.33708 .19488 L
s
.33333 .21112 m
.33708 .21112 L
s
.33333 .22737 m
.33708 .22737 L
s
.33333 .25985 m
.33708 .25985 L
s
.33333 .27609 m
.33708 .27609 L
s
.33333 .29233 m
.33708 .29233 L
s
.33333 .30857 m
.33708 .30857 L
s
.33333 .34105 m
.33708 .34105 L
s
.33333 .35729 m
.33708 .35729 L
s
.33333 .37353 m
.33708 .37353 L
s
.33333 .38977 m
.33708 .38977 L
s
.33333 .42225 m
.33708 .42225 L
s
.33333 .43849 m
.33708 .43849 L
s
.33333 .45473 m
.33708 .45473 L
s
.33333 .47097 m
.33708 .47097 L
s
.25 Mabswid
.33333 0 m
.33333 .5 L
s
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
.5 Mabswid
newpath
.32193 .162 .00609 0 365.73 arc
s
newpath
.33904 .04141 .00609 0 365.73 arc
s
newpath
.31833 .04126 .00609 0 365.73 arc
s
.3159 .16115 m
.33301 .04055 L
s
.32796 .16286 m
.34507 .04226 L
s
.33908 .03532 m
.31837 .03517 L
s
.33899 .0475 m
.31828 .04735 L
s
.32593 .0516 m
.33531 .03834 L
s
.31541 .02428 m
.30604 .03754 L
s
.32193 .162 m
.2084 .11787 L
s
.32593 .0516 m
.30604 .03754 L
s
.33531 .03834 m
.31541 .02428 L
s
.32593 .0516 m
.31833 .04126 L
s
.30604 .03754 m
.31833 .04126 L
s
newpath
.2084 .11787 .00457 0 365.73 arc
s
newpath
.7695 -0.00167 .00406 0 365.73 arc
s
.33333 .08161 m
.41494 0 L
s
.33333 .08161 m
.25173 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  ImageCacheValid->False]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1546}, {0, 1002}},
WindowToolbars->{},
WindowSize->{520, 600},
WindowMargins->{{259, Automatic}, {Automatic, 64}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 43, 0, 56, "Section"],
Cell[1822, 55, 216, 3, 50, "Text"],
Cell[2041, 60, 97, 2, 43, "Input"],

Cell[CellGroupData[{
Cell[2163, 66, 83, 1, 42, "Subsubsection"],
Cell[2249, 69, 163, 2, 50, "Text"],

Cell[CellGroupData[{
Cell[2437, 75, 100, 2, 43, "Input"],
Cell[2540, 79, 94, 1, 38, "Print"]
}, Open  ]],
Cell[2649, 83, 180, 3, 50, "Text"],
Cell[2832, 88, 219, 5, 91, "Input"],
Cell[3054, 95, 164, 2, 50, "Text"],
Cell[3221, 99, 2896, 92, 1483, "Input"],
Cell[6120, 193, 560, 9, 155, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[6717, 207, 46, 0, 28, "Subsubsection"],
Cell[6766, 209, 3313, 70, 1318, "Input"],
Cell[10082, 281, 1822, 41, 165, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[11941, 327, 71, 0, 28, "Subsubsection"],
Cell[12015, 329, 26079, 528, 1525, "Input"],
Cell[38097, 859, 4428, 97, 213, "Input"],
Cell[42528, 958, 2943, 65, 149, "Input"],
Cell[45474, 1025, 2157, 45, 170, "Input"],
Cell[47634, 1072, 1677, 38, 100, "Input"],
Cell[49314, 1112, 194, 5, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[49545, 1122, 71, 0, 28, "Subsubsection"],
Cell[49619, 1124, 13740, 285, 763, "Input"],
Cell[63362, 1411, 4428, 97, 213, "Input"],
Cell[67793, 1510, 2943, 65, 149, "Input"],
Cell[70739, 1577, 1585, 36, 95, "Input"],
Cell[72327, 1615, 1628, 35, 95, "Input"],
Cell[73958, 1652, 1633, 35, 95, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[75628, 1692, 74, 0, 28, "Subsubsection"],
Cell[75705, 1694, 27599, 566, 1820, "Input"],
Cell[103307, 2262, 4428, 97, 213, "Input"],
Cell[107738, 2361, 2943, 65, 149, "Input"],
Cell[110684, 2428, 6010, 123, 384, "Input"],
Cell[116697, 2553, 657, 17, 29, "Input"],
Cell[117357, 2572, 741, 19, 29, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[118135, 2596, 49, 0, 28, "Subsubsection"],
Cell[118187, 2598, 4279, 89, 344, "Input"],
Cell[122469, 2689, 429760, 7007, 22878, "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[552278, 9702, 48, 0, 56, "Section"],
Cell[552329, 9704, 264, 4, 86, "Text"],
Cell[552596, 9710, 70, 0, 32, "Text"],
Cell[552669, 9712, 890289, 13972, 282, 702013, 11645, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1442961, 23686, 770, 26, 508, "Input"],
Cell[1443734, 23714, 144, 2, 50, "Text"],

Cell[CellGroupData[{
Cell[1443903, 23720, 242, 7, 123, "Input"],
Cell[1444148, 23729, 82, 1, 21, "Message"],
Cell[1444233, 23732, 82, 1, 21, "Message"],
Cell[1444318, 23735, 82, 1, 21, "Message"],
Cell[1444403, 23738, 82, 1, 21, "Message"],
Cell[1444488, 23741, 79, 0, 21, "Message"],
Cell[1444570, 23743, 79, 0, 21, "Message"]
}, Open  ]],
Cell[1444664, 23746, 114, 2, 32, "Text"],
Cell[1444781, 23750, 2344, 51, 325, "Input"],

Cell[CellGroupData[{
Cell[1447150, 23805, 178, 4, 75, "Input"],
Cell[1447331, 23811, 50, 0, 23, "Print"],
Cell[1447384, 23813, 52, 0, 23, "Print"],
Cell[1447439, 23815, 50, 0, 23, "Print"],
Cell[1447492, 23817, 55, 0, 23, "Print"]
}, Open  ]],
Cell[1447562, 23820, 182, 3, 50, "Text"],
Cell[1447747, 23825, 13229, 241, 1895, "Input"],
Cell[1460979, 24068, 74, 0, 32, "Text"],
Cell[1461056, 24070, 890289, 13972, 282, 702013, 11645, "GraphicsData", \
"PostScript", "Graphics"],

Cell[CellGroupData[{
Cell[2351370, 38046, 84, 1, 27, "Input"],
Cell[2351457, 38049, 182, 3, 60, "Message"],
Cell[2351642, 38054, 29819, 830, 185, 8435, 562, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2381464, 38886, 38, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2381539, 38891, 84, 1, 27, "Input"],
Cell[2381626, 38894, 182, 3, 60, "Message"],
Cell[2381811, 38899, 25296, 758, 185, 8082, 542, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2407110, 39659, 38, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2407185, 39664, 84, 1, 27, "Input"],
Cell[2407272, 39667, 182, 3, 60, "Message"],
Cell[2407457, 39672, 6256, 422, 185, 6154, 419, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[2413716, 40096, 38, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2413791, 40101, 84, 1, 27, "Input"],
Cell[2413878, 40104, 182, 3, 60, "Message"],
Cell[2414063, 40109, 9488, 628, 185, 9386, 625, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[2423554, 40739, 38, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2423629, 40744, 83, 1, 27, "Input"],
Cell[2423715, 40747, 182, 3, 60, "Message"],
Cell[2423900, 40752, 23119, 598, 185, 5491, 377, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2447022, 41352, 38, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2447097, 41357, 83, 1, 27, "Input"],
Cell[2447183, 41360, 182, 3, 60, "Message"],
Cell[2447368, 41365, 24498, 558, 185, 4517, 308, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2471869, 41925, 38, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2471944, 41930, 113, 2, 43, "Input"],
Cell[2472060, 41934, 182, 3, 60, "Message"],
Cell[2472245, 41939, 182, 3, 60, "Message"],
Cell[2472430, 41944, 5090, 355, 185, 4988, 352, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[2477523, 42301, 38, 0, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2477598, 42306, 44, 0, 42, "Subsubsection"],
Cell[2477645, 42308, 318, 4, 86, "Text"],
Cell[2477966, 42314, 890289, 13972, 282, 702013, 11645, "GraphicsData", \
"PostScript", "Graphics"],

Cell[CellGroupData[{
Cell[3368280, 56290, 5831, 122, 2433, "Input"],

Cell[CellGroupData[{
Cell[3374136, 56416, 25073, 566, 283, 4027, 302, "GraphicsData", \
"PostScript", "Graphics"],
Cell[3399212, 56984, 18074, 479, 296, 4027, 302, "GraphicsData", \
"PostScript", "Graphics"],
Cell[3417289, 57465, 18074, 479, 296, 4027, 302, "GraphicsData", \
"PostScript", "Graphics"],
Cell[3435366, 57946, 4128, 305, 296, 4026, 302, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[3439497, 58253, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3443628, 58560, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3447759, 58867, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3451885, 59174, 4127, 305, 70, 4025, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3456015, 59481, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3460140, 59788, 4125, 305, 70, 4023, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3464268, 60095, 4121, 305, 70, 4019, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3468392, 60402, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3472518, 60709, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3476643, 61016, 4119, 305, 70, 4017, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3480765, 61323, 4114, 305, 70, 4012, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3484882, 61630, 4120, 305, 70, 4018, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3489005, 61937, 4118, 305, 70, 4016, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3493126, 62244, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3497252, 62551, 4118, 305, 70, 4016, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3501373, 62858, 4119, 305, 70, 4017, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3505495, 63165, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3509620, 63472, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3513747, 63779, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3517876, 64086, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3522005, 64393, 4121, 305, 70, 4019, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3526129, 64700, 4125, 305, 70, 4023, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3530257, 65007, 4129, 305, 70, 4027, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3534389, 65314, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3538518, 65621, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3542644, 65928, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3546773, 66235, 4120, 305, 70, 4018, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3550896, 66542, 4113, 305, 70, 4011, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3555012, 66849, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3559139, 67156, 4118, 305, 70, 4016, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3563260, 67463, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3567391, 67770, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3571522, 68077, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3575647, 68384, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3579776, 68691, 4118, 305, 70, 4016, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3583897, 68998, 4121, 305, 70, 4019, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3588021, 69305, 4121, 305, 70, 4019, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3592145, 69612, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3596270, 69919, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3600396, 70226, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3604522, 70533, 4125, 305, 70, 4023, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3608650, 70840, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3612775, 71147, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3616900, 71454, 4127, 305, 70, 4025, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3621030, 71761, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3625156, 72068, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3629283, 72375, 4115, 305, 70, 4013, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3633401, 72682, 4121, 305, 70, 4019, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3637525, 72989, 4115, 305, 70, 4013, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3641643, 73296, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3645774, 73603, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3649905, 73910, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3654031, 74217, 4127, 305, 70, 4025, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3658161, 74524, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3662288, 74831, 4118, 305, 70, 4016, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3666409, 75138, 4117, 305, 70, 4015, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3670529, 75445, 4117, 305, 70, 4015, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3674649, 75752, 4127, 305, 70, 4025, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3678779, 76059, 4127, 305, 70, 4025, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3682909, 76366, 4127, 305, 70, 4025, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3687039, 76673, 4117, 305, 70, 4015, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3691159, 76980, 4125, 305, 70, 4023, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3695287, 77287, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3699414, 77594, 4125, 305, 70, 4023, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3703542, 77901, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3707669, 78208, 4112, 305, 70, 4010, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3711784, 78515, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3715913, 78822, 4114, 305, 70, 4012, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3720030, 79129, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3724161, 79436, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3728290, 79743, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3732415, 80050, 4116, 305, 70, 4014, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3736534, 80357, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3740663, 80664, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3744788, 80971, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3748917, 81278, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3753043, 81585, 4118, 305, 70, 4016, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3757164, 81892, 4116, 305, 70, 4014, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3761283, 82199, 4121, 305, 70, 4019, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3765407, 82506, 4125, 305, 70, 4023, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3769535, 82813, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3773660, 83120, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3777787, 83427, 4119, 305, 70, 4017, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3781909, 83734, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3786034, 84041, 4122, 305, 70, 4020, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3790159, 84348, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3794286, 84655, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3798412, 84962, 4124, 305, 70, 4022, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3802539, 85269, 4129, 305, 70, 4027, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3806671, 85576, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3810800, 85883, 4123, 305, 70, 4021, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3814926, 86190, 4128, 305, 70, 4026, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3819057, 86497, 4127, 305, 296, 4025, 302, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[3823187, 86804, 4126, 305, 70, 4024, 302, "GraphicsData", "PostScript", \
"Graphics"],
Cell[3827316, 87111, 4121, 305, 296, 4019, 302, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[3831440, 87418, 4129, 305, 296, 4027, 302, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[3835572, 87725, 4119, 305, 296, 4017, 302, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

