(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    260278,       7741]
NotebookOptionsPosition[    257980,       7658]
NotebookOutlinePosition[    258336,       7674]
CellTagsIndexPosition[    258293,       7671]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "Utilizing Vector Notation in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ": Example 2\[Dash]Vector Loops"
}], "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Input the definitions for the vector operations", "Subsection"],

Cell["\<\
Input the vector definition with the command that follows.  The path will \
depend on where  the definitions reside on the local system.\
\>", "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Get[StringJoin[NotebookDirectory[],\"vectors3.m\"]]\
\>", "Input",
 CellChangeTimes->{{3.5184566429384003`*^9, 3.5184566493188*^9}, 
   3.536265292792694*^9},
 AspectRatioFixed->True],

Cell[BoxData["\<\"These Engineering Vector algorithms are copyright Alan A. \
Barhorst\"\>"], "Print",
 CellChangeTimes->{3.5184566517056*^9, 3.536265301649008*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Define the symbols used for Unit Vectors", "Subsection"],

Cell[TextData[{
 "Define Unit Vectors for however many frames we need for the system. For \
this example we will use three frames of reference, with the frame ",
 StyleBox["N",
  FontWeight->"Bold"],
 " being the Newtonian frame denoted by the usual ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["i", "^"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["j", "^"], TraditionalForm]]],
 " vectors.   "
}], "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"B", ",", "b", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"c", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"C", ",", "c", ",", "a"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"d", "[", "a_", "]"}], ":=", 
  RowBox[{"unitVector", "[", 
   RowBox[{"D", ",", "d", ",", "a"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.518456656994*^9, 3.518456656994*^9}},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example from Textbook", "Subsection"],

Cell["\<\
In this example we will use the tools plot the variables for the slider crank \
shown below.  See lesson 8.2.\
\>", "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 0.521739
200 dict begin
MathPictureStart
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1196 624 0 0 ]
] MathScale
% Start of Graphics
%!PS-Adobe-2.1 EPSF-1.2

%%Creator: Logitech FotoTouch Color Version 1.1

%%Title: C:\\USERS\\BOOK\\ASLIDER.EPS

%%CreationDate: Mon Aug 29 17:23:40 1994

%%BoundingBox: 0 0 1196 624

%%EndComments

gsave

/picstr 150 string def

1196 624 scale

1196 624 1 [1196 0 0 -624 0 624] {currentfile picstr readhexstring pop}

image

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000007FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007F800FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFE007FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFF803FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFC07FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFE03FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFF01FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF807FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFC07FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFE03FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFF03FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFC01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFF001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFF0001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000000FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00BC0007FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFF003FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFF801FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFE00FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFF007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFF807FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFC03FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFC01FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFE01FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFF80FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFFFFFFFFFFFFC01FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000FFFFFFFFFFFFFFFFFFFFFFE0401FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000003FFFFFFFFFFFFFFFFFFFFFC0001FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0001FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000003FFFFFFFFFFFFFFFFFFFFF80001FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000001FFFFFFFFFFFFFFFFFFFFF00003FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000FFFFFFFFFFFFFFFFFFFFF00003FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000000FFFFFFFFFFFFFFFFFFFFE00403FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000007FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007C0007FFFFFFFFFFFFFFFFFFFC00C07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000001FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FE0007FFFFFFFFFFFFFFFFFFFC00C07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FC03FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFC007FFFFFFFFFFFFFFFFFFF801E07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000403FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFE003FFFFFFFFFFFFFFFFFFF003E07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFF003FFFFFFFFFFFFFFFFFFF007E07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000003FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFC07FFFFFFFFFFFFFFFFFFE00FE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000000000003FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000001FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFE07FFFFFFFFFFFFFFFFFFC01FE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000000000007FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000000000FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFF07FFFFFFFFFFFFFFFFFF801FE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000FC000000FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000003000007FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFF8FFFFFFFFFFFFFFFFFFF003FC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000FF0000000FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0001FFF00003FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFE007FC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000001FFF0000001FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFF80000FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFFE00FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000001FFFE0000001FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFF000007FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFC00FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00100003FFFFE0000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFE00F003FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF801FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00380007FFFFFC0000003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFE01F803FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFF801FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FC000FFFFFFFC0000003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF803FE01FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFF003FFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FF001FFFFFFFFE000000

7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF007FF00FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFE007FFC03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFF3FFFFFFFFFFC00000

0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFC00FFF807FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFC00FFFC03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFF00000

00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFF801FFF803FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFF0000

001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFE007FFFC01FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFFF801FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFF000

0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFF800FFFFE01FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF003FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFC00

00007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFF001FFFFE00FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFF003FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFC0

00001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FF8007FFFFF00FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFE007FFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFF8

000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003C000FFFFFF007FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFE03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFE

0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000003FFFFFF807FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFF

E0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000007FFFFFFC07FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFF

FE0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00001FFFFFFFC03FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF803FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFF

FF80000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFFFFFC03FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF003FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFF

FFF8000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FFFFFFFFE01FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFF007FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFF

FFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFE01FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFE007FFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFF

FFFFC0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFF00FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFF

FFFFF80000003FFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFF801FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFF801FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFF003FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFE003FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFC007FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF80000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFC007FFFFFC07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFE0000000FFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFFFFFFFFF800FFFFFFE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFF800FFFFFFE07FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC0000001FFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFF8FFFFFFFFFFFFFF0007FFFFFF0FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFC0000003FFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFE01FFFFFFFFFFFFE0007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFF00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80001FF8007FFFFFFFFFFFE0003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFE0000000FFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000007FFFFFFFFFFFC0003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFC0000001FFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000000007FFFFFFFFFFF80003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF80000003FFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000007FFFFFFFFFFF80007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF00000007FFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000007FFFFFFFFFFF00007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC0000001FFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000007FFFFFFFFFFF00007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF80000007FFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFFFFFFFFFFC00007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF80000007FF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000007FFFFFFFFFFFC00603FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF00000007F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFFFFFFFFFFFFF800E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF0000000F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC00000033FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFF0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007E03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FC03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF80000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE00000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF30000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7C0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FC000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FF8000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFE0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFC0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFF80000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFE00000017FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFC0000003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF0000000FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFF0000000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFE0000001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFE00000007FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFC0000000FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFF00000000FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFFFFFFF801FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF80000003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFF001FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFE00000007FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFE003FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFF000000007FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFFFFFFE007FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFF000000000FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFC00FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFF0000000001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE00007FFFFFFFFFFFFFFFFFFF801FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFF00200000001FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC00003FFFFFFFFFFFFFFFFFFF801FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFF007C00000003FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFF003FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFF007E00000000FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF8000007FFFFFFFFFFFFFFFFFF003FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFF007FF00000000FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF8000001FFFFFFFFFFFFFFFFFE007FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFF007FFE00000003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF00000003FFFFFFFFFFFFFFFFC007FFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFF00FFFFC00000007FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC000000007FFFFFFFFFFFFFFF800FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFFFFFFE00FFFFFC00000003FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC001C00001FFFFFFFFFFFFFFF001FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFE00FFFFFF800000007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF8003F000007FFFFFFFFFFFFFE003FFFFFFFF07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFE00FFFFFFE00000001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF8007F800003FFFFFFFFFFFFFE003FFFFFFFF07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFC01FFFFFFFE00000007FFFFFFFFF

FFFFFFFFFFFFFFFFFFF800FFC00000FFFFFFFFFFFFFC007FFFFFFFFDFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFFFFFC01FFFFFFFFE00000003FFFFFFFF

FFFFFFFFFFFFFFFFFFF001FFF000001FFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFC03FFFFFFFFFE00000007FFFFFFF

FFFFFFFFFFFFFFFFFFE003FFFF800007FFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFF803FFFFFFFFFF00000001FFFFFFF

FFFFFFFFFFFFFFFFFFE003FFFFE00007FFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFC000003FC03FFFFFFFFFFFFF807FFFFFFFFFFE00000001FFFFFF

FFFFFFFFFFFFFFFFFFC007FFFFFC0001FFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC00000007803FFFFFFFFFFFFF807FFFFFFFFFFFE00000001FFFFF

FFFFFFFFFFFFFFFFFF800FFFFFFF0000FFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC000000000003FFFFFFFFFFFFF807FFFFFFFFFFFFC00000003FFFF

FFFFFFFFFFFFFFFFFF800FFFFFFFC0007FFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF8000000000003FFFFFFFFFFFFF807FFFFFFFFFFFFF00000000FFFF

FFFFFFFFFFFFFFFFFF000FFFFFFFE0003FFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE0000000000017FFFFFFFFFFFFF00FFFFFFFFFFFFFFE00000001FFF

FFFFFFFFFFFFFFFFFF001FFFFFFFF8001FFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFC0000000000037FFFFFFFFFFFFF00FFFFFFFFFFFFFFFF00000003FF

FFFFFFFFFFFFFFFFFE003FFFFFFFFC000FFFFFFFFF001CFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF800003C3000037FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFE00000007F

FFFFFFFFFFFFFFFFFE007FFFFFFFFF0003FFFFFFFF00383FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF800FFFFFF00037FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFE00000007

FFFFFFFFFFFFFFFFFC007FFFFFFFFF8001FFFFFFFE00701FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF003FFFFFF00017FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFF80000001

FFFFFFFFFFFFFFFFFC007FFFFFFFFFC001FFFFFFFC00701FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF00FFFFFFE00003FFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFF0000000

3FFFFFFFFFFFFFFFF800FFFFFFFFFFF0007FFFFFFC00F01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF01FFFFFF800003FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFE000000

07FFFFFFFFFFFFFFF800FFFFFFFFFFF8001FFFFFF800E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE03FFFFFF000003FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF800000

01FFFFFFFFFFFFFFF800FFFFFFFFFFF8000FFFFFF000E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE03FFFFFC003001FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFF00000

001FFFFFFFFFFFFFF001FFFFFFFFFFFC0007FFFFE001E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFFF

FFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE01FFFFF000FC00FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFF0000

0003FFFFFFFFFFFFE001FFFFFFFFFFFF0001FFFFC007E01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000001FFFFF

FFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE00FFFFC003FE003FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFC000

00007FFFFFFFFFFFE001FFFFFFFFFFFF8000FFFFC00FC01FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000FFFFF

FFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE00FFFF8007FF003FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFF000

00001FFFFFFFFFFFC001FFFFFFFFFFFF80007FFF800FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000007FFFF

FFFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE001FFC001FFF800FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF00

000003FFFFFFFFFFC003FFFFFFFFFFFFE0003FFF801FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000003FFFF

FFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF000020003FFFC007FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFE0

0000003FFFFFFFFF8007FFFFFFFFFFFFF0001FFF001FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000FFE01FFFF

FFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF80000000FFFFE003FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

00000007FFFFFFFF800FFFFFFFFFFFFFFC000FFE003FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00003FFF00FFFF

FFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFC0000001FFFFF001FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

C0000001FFFFFFFF801FFFFFFFFFFFFFFE000FFE003FC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00001FFFF807FFF

FFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE0000007FFFFF000FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

F80000003FFFFFFF001FFFFFFFFFFFFFFF0003FC007FE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFF807FFF

FFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF000000FFFFFF000FFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

FC0000000FFFFFFF001FFFFFFFFFFFFFFF8003F8007FE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFE03FFF

FFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE00007FFFFFF6003FFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFC0000001FFFFFE003FFFFFFFFFFFFFFFC001F800FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFE03FFF

FFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFE003FFFFFFF7803FFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFC0000003FFFFE007FFFFFFFFFFFFFFFF0007001FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFF01FFF

FFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7C03FFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFC0000001FFFC00FFFFFFFFFFFFFFFFF8000003FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFF81FFF

FFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7C03FFFFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE0000000FFFC00FFFFFFFFFFFFFFFFF8000003FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7F03FFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC00000007F800FFFFFFFFFFFFFFFFF8000007FFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7F87FFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00000003F801FFFFFFFFFFFFFFFFF800000FFFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE0000000F001FFFFFFFFFFFFFFFFF000000FFFE03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC0000000003FFFFFFFFFFFFFFFFF000001FFFC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF0000000003FFFFFFFFFFFFFFFFE000001FFFC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF800000007FFFFFFFFFFFFFFFFC000007FFFC03FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF00000007FFFFE00FFFFFFFFF8000007FFFC07FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFF

FFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF80000003FFFF8003FFFFFFFF801800FFFFC07FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFF

FFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF00000007FFC0000FFFFFFFF003001FFFFC07FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFF

FFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFF

007FFFFFFFFE00000001E000007FFFFFFF003001FFFF807FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFF

FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFC03FFFFFFFFFFFFFFFFFFFFF0000

000000FFFFFFC00000000000003FFFFFFE004003FFFF807FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFF

FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFF00000

00000007FFFFC00000000000001FFFFFFC004007FFFF807FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFF

FFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFE700000000

00000003FFFFF00000000000001FFFFFFC008007FFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFF

FFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFC000803F00000000000000000000

00000003FFFFF00000000000000FFFFFF801800FFFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFF

FFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE00000000000FFFFFE00000000000000000000000000000

00000001FFFFF00000000000000FFFFFF803001FFFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFF

FFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC0000000000000030000000000000000000000000000000

00000001FFFFE000000000000007FFFFF002001FFFFF80FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFF800FFFF

FFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF80000000000000000000000000000000000000000000000

00000003FFFFC001E00000000007FFFFE006003FFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFF

FFFFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF80000000000000000000000000000000000000000000000

00000003FFFFC003FC0000000007FFFFE00C007FFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFF

FFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF800000000000000000000000000000000000000000007FF

FFFFF03FFFFF8003FF8000000007FFFFC008007FFFFF007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFF

FFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF800000000000000000000000000000000000000000FFFFF

FFFFFFFFFFFF0007FFF000000007FFFF800000FFFFFF007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFF

FFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC01FF3FFCC0000000000000000009FFFF3FFFF7FFFFFFFF

FFFFFFFFFFFE000FFFF800000007FFFF800001FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800001FFFFF

FFFFFFFFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF80000000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC001FFFFC0000000FFFFF000003FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000003FFFFF

FFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFF003FFFFFEFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC001FFFFE0000000FFFFE000003FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000003FFFFF

FFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF8003FFFFF0000000FFFFE000007FFFFFF00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000001FFFFF

FFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF0003FFFFF8000001FFFFC00000FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFF

FFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFF0007FFFFF8000001FFFF800000FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000003FFFF

FFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFE000FFFFFF8000003FFFF800001FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000007FFF

FFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFC001FFFFFFC000007FFFF000001FFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000003FFF

FFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF8001FFFFFFC000007FFFE000003FFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0F80000FFF

FFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF8003FFFFFFE00000FFFFE000007FFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FF

FFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF0007FFFFFFF80001FFFFC000007FFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FF

FFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFE000FFFFFFFFC0003FFFF800000FFFFFFFF01FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FF

FFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFC001FFFFFFFFF000FFFFF800001FFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007F

FFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF8001FFFFFFFFF801FFFFF000001FFFFFFFF81FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803F

FFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF8003FFFFFFFFFF1FFFFFE000003FFFFFFFFC3FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01F

FFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF0007FFFFFFFFFFFFFFFFC000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F

FFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFE000FFFFFFFFFFFFFFFFF800000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFC001FFFFFFFFFFFFFFFFF800001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFC003FFFFFFFFFFFFFFFFF000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF8007FFFFFFFFFFFFFFFFE000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07

FFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF000FFFFFFFFFFFFFFFFFE000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807

FFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC001FFFFFFFFFFFFFFFFFC000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807

FFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFC003FFFFFFFFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80F

FFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFF0007FFFFFFFFFFFFFFFFF8000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00F

FFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE000FFFFFFFFFFFFFFFFFF0020001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00F

FFFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFC000FFFFFFFFFFFFFFFFFE0060001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800F

FFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF8001FFFFFFFFFFFFFFFFFC00C0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001F

FFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF8003FFFFFFFFFFFFFFFFF80180001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003F

FFFFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFE0007FFFFFFFFFFFFFFFFF80180001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007F

FFFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC000FFFFFFFFFFFFFFFFFF00300001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFE0000FF

FFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF0001FFFFFFFFFFFFFFFFFF00600001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000001FF

FFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE0003FFFFFFFFFFFFFFFFFC00400201FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000003FF

FFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE0007FFFFFFFFFFFFFFFFFC00400601FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000FFF

FFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE000FFFFFFFFFFFFFFFFFF800800E01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000FFFF

FFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE000FFFFFFFFFFFFFFFFFF801001E01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000003FFFF

FFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE000FFFFFFFFFFFFFFFFFF003003E03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000FFFFF

FFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF0003FFFFFFFFFFFFFFFFE006003E03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFF

FFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF0001FFFFFFFFFFFFFFFFE00E007E03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFF

FFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF80003FFFFFFFFFFFFFFFC01C00FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC00007FFFFFFFFFFFFFFC01800FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00003FFFFFFFFFFFFFF803801FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFF00000FFFFFFFFFFFFFF803003FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFC00003FFFFFFFFFFFFF006007FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFE00000FFFFFFFFFFFFE004007FE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFF000007FFFFFFFFFFFE00000FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFE00000FFFFFFFFFFFC00801FFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFF800007FFFFFFFFFF801001FFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFE00000FFFFFFFFFF803003FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFF000003FFFFFFFFF000007FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFF80000FFFFFFFFF000007FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFC00001FFFFFFFE00000FFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFE000007FFFFFFE00000FFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFC00000FFFFFFC00001FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFF000003FFFFF800003FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFC00000FFFFF800003FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFF000003FFFF000007FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFF8000007FFF00000FFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFE000001FFE00000FFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFF800000FFE00001FFFFC01FFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF800007FC00003FFFFC03FFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF00000FC00003FFFFC03FFFFFFFFFFFFFF803FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE00007800007FFFFC03FFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC000000000FFFFFC03FFFFFFFFFFFFFFC003FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF000000000FFFFFE03FFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC

007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF800000001FFFFFE07FFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFE00000003FFFFFE07FFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0

00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF00000003FFFFFF07FFFFFFFFFFFFFFFF8007FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0

01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF80000007FFFFFF0FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0

03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFD000000FFFFFFFFFFFFFFFFFFFFFFFFFF800FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80

07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF800001FFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00

0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE00001FFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00

1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00

3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF00003FFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800

7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF80003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF00003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF00203FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC00603FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC00607FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF800C07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF801C07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF003C07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007F

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF007807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001F

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFE007807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000F

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFC00F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF800F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000

7FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF001F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000

3FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFE003F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800

0FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC007F80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00

03FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFC007F81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF800FF81FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0

003FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF000FF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

0007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF001FF01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

0000FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE001FF03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C0007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFE007FF03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E0001FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC00FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F80007FBFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF801FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FE0001FBFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF001FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF80007BFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF003FFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFC00039FFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE007FFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF800001FFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFFF

FFFFFFFFFFFFFFFC00FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF000001FFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF87FFFFFFFFF

FFFFFFFFFFFFFFF800FFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FC0000003FFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF

FFFFFFFFFFFFFFF801FFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F80000000FFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFF

FFFFFFFFFFFFFFF003FFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E000000007FFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFF

FFFFFFFFFFFFFFE007FFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

8000040001FFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFF

FFFFFFFFFFFFFFC007FFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

00000F00007FFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFF800FFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC

00000FE0000FFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFF801FFFE00FFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

00000FE80001FFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFF003FFFE01FFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0

00000FF800007FFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFE007FFFE01FFFFFFFFFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0

00001FF900001FFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFF

FFFFFFFFFFFFFE007FFFE01FFFFFFFFFFFF00007FFFFFFFFFFFFFFFFFFFFFFFFFFFFC0

00001FF9E0000FFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8007FFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFF

FFFFFFFFFFFFFC00FFFFE03FFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFFFFE00

00001FFBF80007FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFF

FFFFFFFFFFFFFC01FFFFE03FFFFFFFFFFFC00000FFFFFFFFFFFFFFFFFFFFFFFFFFF800

00001FFBFF0001FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFF

FFFFFFFFFFFFF801FFFFE03FFFFFFFFFFF000000FFFFFFFFFFFFFFFFFFFFFFFFFFF000

00003FFFFFE000FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFF

FFFFFFFFFFFFF003FFFFF07FFFFFFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFFFC000

00003FFFFFF8007FFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFF007FFFFF87FFFFFFFFFFC001C003FFFFFFFFFFFFFFFFFFFFFFFFF0000

00003FFFFFFE007FFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFE007FFFFFFFFFFFFFFFFF8007F001FFFFFFFFFFFFFFFFFFFFFFFFC0000

06007FFFFFFF807FFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFF000FFC01FFFFFFFFFFFFFFFFFFFFFFFF80000

06007FFFFFFFE0FFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFC01FFFFFFFFFFFFFFFFFF001FFE00FFFFFFFFFFFFFFFFFFFFFFFF00000

0E00FFFFFFFFFDFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFF803FFFFFFFFFFFFFFFFFE003FFF00FFFFFFFFFFFFFFFFFFFFFFFC00000

1C00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFF007FFFFFFFFFFFFFFFFFC007FFF007FFFFFFFFFFFFFFFFFFFFFF000000

3C00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFF

FFFFFFFFFFFE00FFFFFFFFFFFFFFFFFF800FFFF807FFFFFFFFFFFFFFFFFFFFFE000000

3C00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFF

FFFFFFFFFFFE01FFFFFFFFFFFFFFFFFF801FFFF807FFFFFFFFFFFFFFFFFFFFFC000700

7801FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFF

FFFFFFFFFFFC01FFFFFFFFFFFFFFFFFF003FFFF803FFFFFFFFFFFFFFFFFFFFF8000F00

F803FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFF

FFFFFFFFFFF803FFFFFFFFFFFFFFFFFE007FFFF803FFFFFFFFFFFFFFFFFFFFF0003E01

F803FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFF

FFFFFFFFFFF803FFFFFFFFFFFFFFFFFE007FFFF803FFFFFFFFFFFFFFFFFFFFE0007E01

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFF

FFFFFFFFFFF007FFFFFFFFFFFFFFFFFC00FFFFF803FFFFFFFFFFFFFFFFFFFFE001FC03

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFF83FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000007FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFF

FFFFFFFFFFE007FFFFFFFFFFFFFFFFF801FFFFF803FFFFFFFFFFFFFFFFFFFFE003F807

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFE000003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFFC01FFFFFFFFFFFFFFFFFF003FFFFF003FFFFFFFFFFFFFFFFFFFFE00FF00F

F007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFC000000

7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFF801FFFFFFFFFFFFFFFFFE007FFFFF003FFFFFFFFFFFFFFFFFFFFF03FF01F

E00FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFF8000000

0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFF003FFFFFFFFFFFFFFFFFC00FFFFFE007FFFFFFFFFFFFFFFFFFFFF07FE01F

E00FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFF0000000

07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFF007FFFFFFFFFFFFFFFFFC01FFFFFE007FFFFFFFFFFFFFFFFFFFFF87FE03F

E00FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFF0000000

00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00001BFFC003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFE007FFFFFFFFFFFFFFFFF803FFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFC07F

C01FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFE0000000

003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFF801F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFC00FFFFFFFFFFFFFFFFFF803FFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFC07F

C01FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFC0003F00

000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFF01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFF801FFFFFFFFFFFFFFFFFF007FFFFE000FFFFFFFFFFFFFFFFFFFFFFFFF80FF

C01FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFF8001FFF8

0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFFC0F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFF801FFFFFFFFFFFFFFFFFE007FFFF8001FFFFFFFFFFFFFFFFFFFFFFFFF01FF

803FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFF0007FFFF

0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFFFFFFFC0F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFF003FFFFFFFFFFFFFFFFFE007FFFE0003FFFFFFFFFFFFFFFFFFFFFFFFE01FF

803FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFFFFFFF001FFFFF

C000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFE007FFFFFFFFFFFFFFFFFC0000000000FFFFFFFFFFFFFFFFFFFFFFFFFE03FF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFE001FFFFF

F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFC007FFFFFFFFFFFFFFFFFC0000000001FFFFFFFFFFFFFFFFFFFFFFFFFC07FF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFE003FFFFF

FC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF8007FFFFFFFFFFFFFFFFF80000000007FFFFFFFFFFFFFFFFFFFFFFFFF807FF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFC00FFFFFF

FF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF8007FFFFFFFFFFFFFFFFF8000000000FFFFFFFFFFFFFFFFFFFFFFFFFF00FFF

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFC01FFFFFF

FF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF0003FFFFFFFFFFFFFFFFF0000000003FFFFFFFFFFFFFFFFFFFFFFFFFE01FFF

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFF801FFFFFF

FFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFF0003FFFFFFFFFFFFFFFFF0000000007FFFFFFFFFFFFFFFFFFFFFFFFFE01FFF

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFF003FFFFFF

FFE0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFF007FFFFFFF

FFFFFFFE0001FFFFFFFFFFFFFFFFE0000000007FFFFFFFFFFFFFFFFFFFFFFFFFC03FFF

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00007FFFFFFFFFFF003FFFFFF

FFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00003F007FFFFFFF

FFFFFFFC0000FFFFFFFFFFFFFFFFC0000000007FFFFFFFFFFFFFFFFFFFFFFFFF807FFF

81FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007FFFFFFFFFFE007FFFFFF

FFE0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000007007FFFFFFF

FFFFFFF800007FFFFFFFFFFFFFFFC01C0000003FFFFFFFFFFFFFFFFFFFFFFFFF80FFFF

C3FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800003FFFFFFFFFFE00FFFFFFF

FF00001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000000FFFFFFFF

FFFFFFF000003FFFFFFFFFFFFFFF801F800A001FFFFFFFFFFFFFFFFFFFFFFFFF00FFFF

EFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800001FFFFFFFFFFC01FFFFFFE

0000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000001FFFFFFFF

FFFFFFF001001FFFFFFFFFFFFFFF803FFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFE01FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000FFFFFFFFFFC01FFFFF40

0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000001FFFFFFFF

FFFFFFE003000FFFFFFFFFFFFFFF003FFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFE03FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000007FFFFFFFFFC01FFFE000

0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE001F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000001FFFFFFFF

FFFFFFC0078007FFFFFFFFFFFFFF007FFFFFE007FFFFFFFFFFFFFFFFFFFFFFFC03FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0003003FFFFFFFF8001F800000

0000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000003FFFFFFFF

FFFFFFC00F8003FFFFFFFFFFFFFE007FFFFFF007FFFFFFFFFFFFFFFFFFFFFFF807FFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FC00FFFFFFFF00000000000

0000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007200001FFFFFFFF

FFFFFF801FE000FFFFFFFFFFFFFE007FFFFFF007FFFFFFFFFFFFFFFFFFFFFFF00FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FC007FFFFFFE00000000000

0000403FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFC001FFFFFFFF

FFFFFF001FE0007FFFFFFFFFFFFE00FFFFFFF003FFFFFFFFFFFFFFFFFFFFFFF00FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FF003FFFFFFF00000000000

00FFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFF001FFFFFFFF

FFFFFE003FFE003FFFFFFFFFFFFC00FFFFFFF003FFFFFFFFFFFFFFFFFFFFFFE01FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FF801FFFFFFF00000000000

3FFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000007FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFF801FFFFFFFF

FFFFFC007FFF801FFFFFFFFFFFF8007FFFFFC003FFFFFFFFFFFFFFFFFFFFFFC03FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFC00FFFFFFF800000000FF

FFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFC01FFFFFFFF

FFFFFC00FFFFE00FFFFFFFFFFFF8001FFFFF0003FFFFFFFFFFFFFFFFFFFFFF807FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFE00FFFFFFFC0000003FFF

FFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFC00FFFFFFFF

FFFFF801FFFFF00FFFFFFFFFFFF0000FFFF80007FFFFFFFFFFFFFFFFFFFFFF807FFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0003FFFF007FFFFFFE000003FFFF

FFFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000007FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFF800FFFFFFFF

FFFFF001FFFFF807FFFFFFFFFFF00003FFE00007FFFFFFFFFFFFFFFFFFFFFF00FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFF803FFFFFFF003FFFFFFF

FFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFC0007FFFFFFF

FFFFE003FFFFFC03FFFFFFFFFFE000000000000FFFFFFFFFFFFFFFFFFFFFFE01FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFC03FFFFFFF807FFFFFFF

FFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801F7001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFC00007FFFFFFF

FFFFE007FFFFFC01FFFFFFFFFFC000000000001FFFFFFFFFFFFFFFFFFFFFFC01FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFE01FFFFFFF80FFFFFFFF

FFE003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000FFFFFFFF

FFFFC007FFFFFE01FFFFFFFFFFC000000000007FFFFFFFFFFFFFFFFFFFFFF803FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFF00FFFFFFF807FFFFFFF

FF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000000000FFFFFFFF

FFFF800FFFFFFF00FFFFFFFFFFC00000000003FFFFFFFFFFFFFFFFFFFFFFF807FFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFF80FFFFFFFC07FFFFFFF

FE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000001FFFFFFFF

FFFF001FFFFFFF007FFFFFFFFF80180000001FFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFC1FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0001FFFFFFF807FFFFFFC07FFFFFFF

F0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000003FFFFFFFF

FFFF003FFFFFFF807FFFFFFFFF803F000000FFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFF800003FFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFE03FFFFFFE03FFFFFFF

8001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000003FFFFFFFFF

FFFC007FFFFFFFC03FFFFFFFFF003FE0001FFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFF0000007FFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFE01FFFFFFE03FFFFFFE

0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000FFFFFFFFFF

FFFC00FFFFFFFFC03FFFFFFFFF007FF80DFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFF80000003FFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFF00FFFFFFE01FFFFFE0

001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800007FFFFFFFFFF

FFF801FFFFFFFFC03FFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFC00000001FFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFF80FFFFFFF00FFFFF00

007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFF

FFF001FFFFFFFFC01FFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFF800000000FFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFC07FFFFFF803BFE000

03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFE00FFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFF000000000FFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFC07FFFFFF800000000

07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFE007FFFFFFFFE00FFFFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFC000000000FFFFFFFFFFFFFFFFFFFFFFFFBE0003FFFFFFFFFFE03FFFFFFE00000000

3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFC00FFFFFFFFFF007FFFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FF80000000007FFFFFFFFFFFFFFFFFFFFFFFB80007FFFFFFFFFFF01FFFFFFF00000001

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFE007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF800FFFFFFFFFF007FFFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FB80000008007FFFFFFFFFFFFFFFFFFFFFFFB0000FFFFFFFFFFFF00FFFFFFF8000000F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF000FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF801FFFFFFFFFF807FFFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FB8000039C007FFFFFFFFFFFFFFFFFFFFFFFA0001FFFFFFFFFFFF80FFFFFFFE000007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFF0000FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF001FFFFFFFFFF803FFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FB00001F9C007FFFFFFFFFFFFFFFFFFFFFFF80003FFFFFFFFFFFFC07FFFFFFFC001FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000FFFFFF80001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FF003FFFFFFFFFF803FFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FA0000FFFE007FFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFE03FFFFFFFF8FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFF800001FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FE007FFFFFFFFFF803FFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

F80003FFFE003FFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFE01FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80001FFC000003FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FC007FFFFFFFFFFC03FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

F0000FFFFE003FFFFFFFFFFFFFFFFFFFFFFE0000FFFFFFFFFFFFFF01FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC000000000000FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F800FFFFFFFFFFFC01FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

F0001FFFFC003FFFFFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFFFFF00FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000007FFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F001FFFFFFFFFFFC01FFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFF1FFFFF

FFFFFFFFFFFFFFFFFFF0

F0003FFFFC001FFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFF80FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80000000003FFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

F003FFFFFFFFFFFC01FFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFF0FFFFF

FFFFFFFFFFFFFFFFFFF0

F0007FFFF8001FFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFFF807FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000001FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

E003FFFFFFFFFFFC01FFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFE07FFFF

FFFFFFFFFFFFFFFFFFF0

F000FFFFF8001FFFFFFFFFFFFFFFFFFFFFC0001FFFFFFFFFFFFFFFC07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C007FFFFFFFFFFFC01FFFFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFE03FFFF

FFFFFFFFFFFFFFFFFFF0

F001FFFFF8000FFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFFFC07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00003FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

C00FFFFFFFFFFFFC01FFFFFFC03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFE03FFFF

FFFFFFFFFFFFFFFFFFF0

F003FFFFD0000FFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

800FFFFFFFFFFFFE01FFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFE01FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF800007FFFFFFFFFFFFFFFFFFFE0001FFFFFFFFFFFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

001FFFFFFFFFFFFE01FFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFE00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF800007FFFFFFFFFFFFFFFFFFFC0003FFFFFFFFFFF0FFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

003FFFFFFFFFFFFE01FFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFE00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF800003FFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFC01FFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE

007FFFFFFFFFFFFE01FFFFFF807FFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFF000003FFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFE001FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC

007FFFFFFFFFFFFE01FFFFFFC07FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F007FFFC000401FFFFFFFFFFFFFFFFFFE0003FFFFFFFFFF8000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8

00FFFFFFFFFFFFFE01FFFFFFE0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC03FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F807FFF0000E01FFFFFFFFFFFFFFFFFFC0003FFFFFFFFFE0000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFF8

00FFFFFFFFFFFFFE01FFFFFFE0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F803FF80001E00FFFFFFFFFFFFF07FFF8000BFFFFFFFFF80000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFF0

03FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

F8000000003F007FFFFFFFFFFF8007FF0001FFFFFFFFFE00000FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFE0

03FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FA000000007F003FFFFFFFFFFE00007E0003FFFFFFFFF800001FFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFFFFFFFE0

07FFFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FA00000000FF801FFFFFFFFFFC000008000FFFFFFFFFC00000FFFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFC0

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FF00000001FFC01FFFFFFFFFF8000000000FFFFFFFFF800001FFFFF01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFF80

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFF00FFFF

FFFFFFFFFFFFFFFFFFF0

FF80000003FFE007FFFFFFFFE0000000001FFFFFFFF800000FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800007FFFFFFFF80

1FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FF80000007FFE003FFFFFFFF80000000003FFFFFFFF000001FFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800003FFFFFFFF00

3FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFC000001FFFF003FFFFFFFF00000000007FFFFFFFC00000FFFFFFE01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000007FFFFFFE00

3FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFF00003BFFFF801FFFFFFFE0000000000FFFFFFFF000003FFFFFFC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF80000007FFFFF800

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFC0007FFFFF801FFFFFFF80003800001FFFFFFFE000007FFFFFFC01FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFC0000003FFFFE000

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFF00FFFFFFFC00FFFFFFF0000FE00001FFFFFFFC00001FFFFFFFC03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000003FFF8000

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFE00FFFFFFE0003FF80000FFFFFFF800003FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000000FFE0000

7FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFF00FFFFFFC0007FF00000FFFFFFF800007FFFFFFFE03FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000003FC0000

3FFFFFFFFFFFFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFF80FFFFFF8000FFF000007FFFFFF00001FFFFFFFFE07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00830780EEC1EFFFFFFFFFF

FFFFE0000000000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000780000

1FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFC0FFFFFE0001FFE000001FFFFFF00003FFFFFFFFF07FFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000000005FFFFFFFF

FFFFC00000000000003FFFFFFFFFFFFFF8FFFFFFFFFFFFFFFFFFFFFFE0000000000000

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFF1FFFFFC0007FFC000001FFFFFF00003FFFFFFFFF8FFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFC3FFFFFFBE00003FFFFFFFFFFC000000000000000FFFFFFFF

FFFFC000000000000007FFFFFFFFFFFFE000043FFFFFFFFFFFFFFFFFFC000000000000

0FFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFF807FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFF8001FFF8000000FFFFFF0000000FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8000800000000000FFFFFFFFFE000000000000001FFFFFFFF

FFFFC000000000000003FFFFFFFFFFFFE000000006FFFFFFFFFFFFFFFFC00000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFF0003FFF00000007FFFFF00000000000007FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF00000000000000007FFFFFFFFE000000000000003FFFFFFFF

FFFFC00000000000000FFFFFFFFFFFFFE00000000000007FFFFFFFFFFFF80000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFE000FEFC00038003FFFFF00000000000000003FFFCFFFFFE00

00C080E3BFFFFFFFFFFFF0000000000000000FFFFFFFFFF00000000000001FFFFFFFFF

FFFFE00000000000007FFFFFFFFF7FFFE000000000000000007FFFFFFFF80000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFC001F8000007E001FFFFF8000000000000000000007FFFF800

00000000003FFFFFFFFFF000000000000007FFFFFFFFFFFFFFFFF20006E07FFFFFFFFF

FFFFF807F800000007FFFFFFFFFF7FFFE0000000000000000003FFFFFFF80000000000

07FFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFF80010000000FF001FFFFF8000000000000000000007FFFF800

00000000000FFFFFFFFFF00000000000001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFF00000000000000000001FFFFFF80000000000

03FFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFF80000000001FF000FFFFFE000000000000000000007FFFF800

00000000000FFFFFFFFFF8000000000003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000000000000000003FFFFF80000000000

007FFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFF803FFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFF00000000003FF800FFFFFF800000000000000000007FFFFC00

0000000000FFFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00000000000000003FFFFF80000000000

0001FFFFFFFE000000F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFF803C01

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFE00100000003FFC00BFFFFFF80000000000000000007FFFFE00

000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFE000000000000007FFFFF80000000000

00000FFFFFFC00000000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFC00000

7FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFC00300000007FFC003FFFFFFE000007FFFF80000000FFFFFF00

0FEE062A3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBC00000001FFFFFFF80000000000

000001FFFFF800000000000000001FFFFFFFFFFFFFFFFFFFFFFF803FFFFFBFFFC00000

1FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFC00700000007FFE003FFFFFFF80001FFFFFFFF80001FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFE78007FFFFFFF80000000000

000001FFFFF80000000000000000007FFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFC00000

0FFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFC00600000007FFE003FFFFFFFE00007FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00000000000

000003FFFFF80000000000000000001FFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFC00000

01FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF800E00000003FFF003FFFFFFFF80003FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFF800000000000

00001FFFFFFC0000000000000000000FFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFC00000

00FFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF800C00000003FFF003FFFFFFFFC0001FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFE000000000000

0007FFFFFFFC0000000000000000001FFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFC00000

007FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF801C00000003FFF801FFFFFFFFF80007FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFF0000000000000

003FFFFFFFFE00000000000000000FFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFF800000

003FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF003C00000003FFF801FFFFFFFFFE0001FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFF80000000000000

1FFFFFFFFFFFDFC0000000000005FFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFF800000

000FFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFF003E00000003FFF800FFFFFFFFFF80007FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFE00000000000000

7FFFFFFFFFFFFFFC0FF8CFFE001FFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFF8000FE

0007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFE007E00000003FFFC00FFFFFFFFFFE0003FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFF0000000F8000000

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFF8003FF

8007FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFE007E00000003FFFC00FFFFFFFFFFFC000FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0000003F8000001

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFF000FFF

E003FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFC00FF00000003FFFC007FFFFFFFFFFF0003FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFF00000007F0000003

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFF001FFF

F800FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFC00FF00000003FFFE007FFFFFFFFFFFC001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00000017E0000007

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFF003FFF

FC00FFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF800FF80000007FFFE007FFFFFFFFFFFF001FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF8000000FFC000003F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFF003FFF

FE007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF800FF8000000FFFFE007FFFFFFFFFFFF800FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF8000003FFC007007F

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFF007FFF

FE007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF801FFC000001FFFFF003FFFFFFFFFFFFE00FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF8000007FF800FC1FF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFF007FFF

FF007FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF801FFE00000FFFFFF003FFFFFFFFFFFFFC0FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF000001FFF800FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFF007FFF

FF003FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF001FFF0000FFFFFFF003FFFFFFFFFFFFFE1FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000007FFF001FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFF007FFF

FF803FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF001FFF800FFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFF80001FFFF003FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFFFFFFF007FFF

FF803FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF001FFFC03FFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8001FFFFE007FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFF007FFF

FFC03FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFCFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC007FFFFC007FFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFF007FFF

FFC01FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFF800FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFF007FFF

FFE01FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF801FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFF007FFF

FFE00FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFF807FFF

FFE00FFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE003FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFF807FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE003FFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFF807FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFF803FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFF803FFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF801FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC00FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FF807FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE007FC003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFF803FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFE007FFFFFFFFFFFFFFE003C0003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFE00000001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE01FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFF9800000001FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC01FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF003FFFFFFFF800000000000003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFFFC03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFF801FFA08000000000000000003FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF83FFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFE03FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFFF07FFFF8000000000000000000000001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFF

FFFFFFFFFFFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFF07FFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFE000F8000000000000000000000000003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFF

FFFFFFFFFFFFE01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE00FFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFFFFFFF

FFFFFFFFFFFFE007FFFFFFFFFFFFFFFFFFFFFFFFFC3FFE00FFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000000000000007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80FFFFFFFFFF

FFFFFFFFFFFFE003FFFFFFFFFFFFFFFFFFFFFFFFF81FFC01FFFFFFFFFFFFFFFFFFFFFF

FFF003FFFFFFFFFFFFF0

FFFFFFFFFFC00000000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFF

FFFFFFFFFFFFE0007FFFFFFFFFFFFFFFFFFFFFFFF807FC03FFFFFFFFFFFFFFFFFFFFFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000000008E0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFF

FFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFF007F803FFFFFFFFFFFFFFFFFFFFFF

FFF007FFFFFFFFFFFFF0

FFFFFFFFFFC000000000000000000007FFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFF

FFFFFFFFFFFFFC000FFFFFFFFFFFFFFFFFFFFFFFF007F007FFFFFFFFFFFFFFFFFFFFFF

FFF00FFFFFFFFFFFFFF0

FFFFFFFFFFE00000000000000000000FFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFFFFF

FFFFFFFFFFFFFE0007FFFFFFFFFFFFFFFFFFFFFFE007E007FFFFFFFFFFFFFFFFFFFFFF

FFF80FFFFFFFFFFFFFF0

FFFFFFFFFFF00000000007FFFFF0000FFFFFA000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFFFFFFFE007C00FFFFFFFFFFFFFFFFFFFFFFF

FFFC1FFFFFFFFFFFFFF0

FFFFFFFFFFF80000001FFFFFFFE0001FFFFFA000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFFFFFFFFC007801FFFFFFFFFFFFFFFFFFFFFFF

FFFEFFFFFFFFFFFFFFF0

FFFFFFFFFFFE0000007FFFFFFFC0003FFFFF8001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFC00F001FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFBE0007FFFFFFF80007FFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFC00E003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFE0007FFFFFFE0000FFFFFF0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFFFFFC01C007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFE0007FFFFFFC0001FFFFFF0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFC000FFFFFFFFFFFFFFFFFFFFC01C007FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFC000FFFFFFF80007FFFFFE000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFFFFFFF801C00FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFF8000FFFFFFF00007FFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFFFF801800FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFE0001FFFFFFE0001FFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFFFFF003001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFC0003FFFFFFC0003FFFFFFC007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFFFFF003003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFF80007FFFFFF8000FFFFFFF800FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFFFFF002003FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFF0000FFFFFFF0001FFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFFFFF000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFE0001FFFFFFE0003FFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFFF000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFC0003FFFFFFC0003FFFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFF00000FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFF00007FFFFFFC0007FFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFFFFFFE00001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFE0000FFFFFFF80007FFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFE000FFFFFFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFC0001FFFFFFF00003FFFFFF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFF8003FFFFFFFFFFFFFFE00003FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFF80001FFFFFFE00003FFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFFFE00007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFF00003FFFFFFE00003FFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFFFE00007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFC00003FFFFFFE00007FFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFC0000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF800003FFFFFFE0000FFFFFFC003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFF000FFFFFFFFFFFFFC0000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF800003FFFFFFF0003FFFFFF8003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFC003FFFFFFFFFFFFC0000FF07FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF000003FFFFFFF0003FFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFE001FFFFFFFFFFFFC0001FE03FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF000003FFFFFFF0007FFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF0007FFFFFFFFFFFC0007F8007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF00001FFFFFFFF801FFFFFFF000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFF8001FFFFFFFFFFF80006C0007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF00003FFFFFFFFC07FFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFFFF8000C00007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF00007FFFFFFFFE0FFFFFFFE001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFFF8000C00007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF8003FFFFFFFFFFFFFFFFFFF003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFF8000000007FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFF800FFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFFFFF800000000FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFC00FFFFFFFFFFFFFFFFFFFF007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFF800000001FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFE03FFFFFFFFFFFFFFFFFFFF80FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE03FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFC000FFFFFFFFF000000007FFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC07FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFF00000001FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF807FFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFF00000003FFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF81FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFE000FFFFFFFF0000001FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFE0000007FFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFFFFE000001FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFC000007FFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE07FFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFC00000FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFF800007FFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFF80001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FFF80007FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFF8001FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0007FF8007FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FF03FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE3FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0007FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC1FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8000FFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC3FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7FFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0003FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF001FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF803FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

FFFFFFFFFFFFFFFFFFF0

grestore

showpage

%%EOF


%End of Graphics
MathPictureEnd
end
\
\>"], "Graphics",
 ImageSize->{351, 183.0625},
 ImageMargins->{{16, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[TextData[{
 "First we write the vector loop for the complete mechanism.  ",
 "In each planar vector loop we can introduce only two unknowns. In this case \
we have \[Alpha] and ",
 StyleBox["h",
  FontSlant->"Italic"],
 " as unknowns. "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vLoop", "=", 
  RowBox[{
   RowBox[{"3", " ", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", "i"}], " ", "+", " ", 
   RowBox[{"3", " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", "j"}], " ", "-", " ", 
   RowBox[{"2", " ", 
    RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", "i"}], " ", "-", " ", 
   RowBox[{"2", " ", 
    RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", "j"}], " ", "-", " ", 
   RowBox[{"h", " ", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", "i"}], " ", "-", " ", 
   RowBox[{"h", " ", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", "j"}], " ", "-", " ", 
   RowBox[{"3", " ", "i"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "3"}], " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "-", 
  RowBox[{"h", " ", 
   RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
   OverscriptBox["\<\"i\"\>", "^"]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
   OverscriptBox["\<\"j\"\>", "^"]}], "-", 
  RowBox[{"h", " ", 
   RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
   OverscriptBox["\<\"j\"\>", "^"]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
   OverscriptBox["\<\"j\"\>", "^"]}]}]], "Output",
 CellChangeTimes->{3.5184566596772003`*^9, 3.536265301780105*^9}]
}, Open  ]],

Cell["\<\
Remember the vector loop actually is equal to zero.  We will just carry that \
fact in our heads for now.\
\>", "Text"],

Cell[TextData[{
 "We need to find the functions for ",
 StyleBox["h",
  FontSlant->"Italic"],
 " and \[Alpha].  Using the x and y components of the above equation we can \
write:"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Xcomp", "=", 
  RowBox[{"vLoop", " ", ".", "i"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "3"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "\[Alpha]", "]"}]}], "-", 
  RowBox[{"h", " ", 
   RowBox[{"Cos", "[", "\[Beta]", "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184566606288*^9, 3.536265301846901*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ycomp", "=", 
  RowBox[{"vLoop", ".", "j"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "-", 
  RowBox[{"h", " ", 
   RowBox[{"Sin", "[", "\[Beta]", "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184566614088*^9, 3.536265301882296*^9}]
}, Open  ]],

Cell["We can solve for the unknowns as follows.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"elim1", "=", 
  RowBox[{"Eliminate", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Xcomp", "==", "0"}], ",", 
      RowBox[{"Ycomp", "==", "0"}]}], "}"}], ",", "h"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"2", " ", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
    RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "-", 
   RowBox[{"3", " ", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}]}], "+", 
   RowBox[{"3", " ", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}]}], "-", 
   RowBox[{"3", " ", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], "\[Equal]", 
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
   RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}]], "Output",
 CellChangeTimes->{3.5184566631872*^9, 3.536265301915167*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol1", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{"elim1", ",", "\[Alpha]"}], "]"}], "//", "Simplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Alpha]", "\[Rule]", 
     RowBox[{"-", 
      RowBox[{"ArcCos", "[", 
       RowBox[{
        FractionBox["1", "8"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "6"}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
          RowBox[{"6", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "-", 
          RowBox[{"2", " ", 
           SqrtBox["2"], " ", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "10"}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", 
                  RowBox[{"(", 
                   RowBox[{"\[Beta]", "-", "\[Theta]"}], ")"}]}], "]"}]}], 
               "-", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], 
               "+", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ")"}]}]]}]}], 
         ")"}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", "\[Rule]", 
     RowBox[{"ArcCos", "[", 
      RowBox[{
       FractionBox["1", "8"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "6"}], "+", 
         RowBox[{"6", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
         RowBox[{"6", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], "+", 
         RowBox[{"6", " ", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "-", 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "10"}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Beta]", "-", "\[Theta]"}], ")"}]}], "]"}]}], "-", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], 
              "+", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ")"}]}]]}]}], 
        ")"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", "\[Rule]", 
     RowBox[{"-", 
      RowBox[{"ArcCos", "[", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{"3", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
          RowBox[{"3", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], "+", 
          RowBox[{"3", " ", 
           RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
          RowBox[{
           SqrtBox["2"], " ", 
           SqrtBox[
            RowBox[{
             SuperscriptBox[
              RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "10"}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
               RowBox[{"9", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", 
                  RowBox[{"(", 
                   RowBox[{"\[Beta]", "-", "\[Theta]"}], ")"}]}], "]"}]}], 
               "-", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], 
               "+", 
               RowBox[{"18", " ", 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ")"}]}]]}]}], 
         ")"}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", "\[Rule]", 
     RowBox[{"ArcCos", "[", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "-", 
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], "+", 
         RowBox[{"3", " ", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
         RowBox[{
          SqrtBox["2"], " ", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "10"}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
              RowBox[{"9", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Beta]", "-", "\[Theta]"}], ")"}]}], "]"}]}], "-", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{
                 RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], 
              "+", 
              RowBox[{"18", " ", 
               RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ")"}]}]]}]}], 
        ")"}]}], "]"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5184566647628*^9, 3.536265302672648*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"elim2", "=", 
  RowBox[{"Eliminate", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Xcomp", "==", "0"}], ",", 
      RowBox[{"Ycomp", "==", "0"}]}], "}"}], ",", "\[Alpha]"}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "5"}], "-", 
   RowBox[{"6", " ", "h", " ", 
    RowBox[{"Cos", "[", "\[Beta]", "]"}]}], "-", 
   RowBox[{
    SuperscriptBox["h", "2"], " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"]}], "-", 
   RowBox[{
    SuperscriptBox["h", "2"], " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "\[Beta]", "]"}], "2"]}], "+", 
   RowBox[{"6", " ", "h", " ", 
    RowBox[{"Sin", "[", "\[Beta]", "]"}], " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "-", 
   RowBox[{"9", " ", 
    SuperscriptBox[
     RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "18"}], "-", 
      RowBox[{"6", " ", "h", " ", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}]}]}], ")"}], " ", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
   RowBox[{"9", " ", 
    SuperscriptBox[
     RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}]], "Output",
 CellChangeTimes->{3.5184566675552*^9, 3.536265302718573*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol2", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{"elim2", ",", "h"}], "]"}], "//", "Simplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"h", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Beta]", "-", "\[Theta]"}], "]"}]}], "-", 
      SqrtBox[
       RowBox[{
        RowBox[{"-", "5"}], "+", 
        RowBox[{
         FractionBox["9", "2"], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
        RowBox[{
         FractionBox["9", "2"], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{"\[Beta]", "-", "\[Theta]"}], ")"}]}], "]"}]}], "-", 
        RowBox[{"9", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], "+", 
        RowBox[{"9", " ", 
         RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"h", "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Beta]", "-", "\[Theta]"}], "]"}]}], "+", 
      SqrtBox[
       RowBox[{
        RowBox[{"-", "5"}], "+", 
        RowBox[{
         FractionBox["9", "2"], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", "\[Beta]"}], "]"}]}], "+", 
        RowBox[{
         FractionBox["9", "2"], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{"\[Beta]", "-", "\[Theta]"}], ")"}]}], "]"}]}], "-", 
        RowBox[{"9", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"2", " ", "\[Beta]"}], "-", "\[Theta]"}], "]"}]}], "+", 
        RowBox[{"9", " ", 
         RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}]]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5184566692712*^9, 3.536265303292482*^9}]
}, Open  ]],

Cell[TextData[{
 "Now we can plot the results.  Which will show the different solution \
branches.  The solutions are undefined a certain points that ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " leaves out."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Beta]", "=", 
  RowBox[{"Pi", "/", "6"}]}]], "Input"],

Cell[BoxData[
 FractionBox["\[Pi]", "6"]], "Output",
 CellChangeTimes->{3.5184566703788*^9, 3.5362653033203907`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"\[Alpha]", "/.", "sol1"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", 
     RowBox[{
      RowBox[{"-", "3"}], 
      RowBox[{"Pi", "/", "2"}]}], ",", 
     RowBox[{"Pi", "/", "3"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl2lcTW0Xxk9nPqYGmjMkJQ8lFEnshIRmJSmSFAolKfUUSaTZEEJISgMp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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3k4VV0bxo8znyZDmaUk0lukooRaK5VU5gzJlESFIol4KaFkblCphESm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     "]]}, 
   {Hue[0.1421359549995791, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlnc8Vf8fx68yWioVCtHWQISofDsaVEQIySizhMgsSlQqKaQklVTITPYe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     "]]}, 
   {Hue[0.37820393249936934`, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlHc41e8bx48yWioJhahUGogQlW+3BonITkaZJURmUaJSSSElIZSRmew9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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{Rational[-3, 2] Pi, Rational[1, 3] Pi}, {-3.1408916885595044`, 
     3.1408916885595044`}}, {{-4.71238898038469, 
    1.0471975511965976`}, {-3.1408916885595044`, 3.1408916885595044`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184566720480003`*^9, 3.536265303475163*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"h", "/.", "sol2"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", 
     RowBox[{
      RowBox[{"-", "3"}], " ", 
      RowBox[{"Pi", "/", "2"}]}], ",", 
     RowBox[{"Pi", "/", "3"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlnk4Vd8Xxu89dyihkOG67hFpoEEqZKgOyZASITJkyJAxhYhUaBAyplIk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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1Xk4VdsbB/C9HeegzI4hSmRIpgiF5N0it2iQSDdj0XCplNAgJV2EDF1K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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->
   NCache[{{Rational[-3, 2] Pi, Rational[1, 3] Pi}, {-7.367772191879083, 
     2.171619774971294}}, {{-4.71238898038469, 
    1.0471975511965976`}, {-7.367772191879083, 2.171619774971294}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5184566737483997`*^9, 3.5362653035136223`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 193, 7, 67, "Section",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[797, 33, 69, 0, 34, "Subsection"],
Cell[869, 35, 206, 5, 26, "Text",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1100, 44, 193, 5, 27, "Input"],
Cell[1296, 51, 164, 2, 20, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1509, 59, 62, 0, 34, "Subsection"],
Cell[1574, 61, 484, 16, 30, "Text",
 Evaluatable->False],
Cell[2061, 79, 505, 14, 58, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2603, 98, 43, 0, 34, "Subsection"],
Cell[2649, 100, 133, 3, 26, "Text"],
Cell[2785, 105, 197392, 6343, 192, 194103, 6286, "GraphicsData", \
"PostScript", "Graphics"],
Cell[200180, 6450, 253, 7, 26, "Text"],
Cell[CellGroupData[{
Cell[200458, 6461, 646, 15, 27, "Input"],
Cell[201107, 6478, 856, 23, 31, "Output"]
}, Open  ]],
Cell[201978, 6504, 129, 3, 26, "Text"],
Cell[202110, 6509, 191, 6, 26, "Text"],
Cell[CellGroupData[{
Cell[202326, 6519, 85, 2, 27, "Input"],
Cell[202414, 6523, 332, 9, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[202783, 6537, 80, 2, 27, "Input"],
Cell[202866, 6541, 323, 9, 27, "Output"]
}, Open  ]],
Cell[203204, 6553, 57, 0, 26, "Text"],
Cell[CellGroupData[{
Cell[203286, 6557, 228, 7, 27, "Input"],
Cell[203517, 6566, 665, 17, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[204219, 6588, 152, 4, 27, "Input"],
Cell[204374, 6594, 6345, 175, 154, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[210756, 6774, 239, 8, 27, "Input"],
Cell[210998, 6784, 1042, 31, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[212077, 6820, 145, 4, 27, "Input"],
Cell[212225, 6826, 2004, 60, 54, "Output"]
}, Open  ]],
Cell[214244, 6889, 229, 6, 26, "Text"],
Cell[CellGroupData[{
Cell[214498, 6899, 79, 2, 27, "Input"],
Cell[214580, 6903, 116, 2, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[214733, 6910, 316, 10, 27, "Input"],
Cell[215052, 6922, 30605, 511, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[245694, 7438, 314, 10, 27, "Input"],
Cell[246011, 7450, 11929, 203, 238, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
